<?xml version="1.0" encoding="windows-1251"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<xsl:output method="xml" encoding="windows-1251"/>
<xsl:template match="/">
<DECLAR xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="J0500103.xsd">
    <xsl:apply-templates select="//DECLARHEAD"/>
    <xsl:apply-templates select="//DECLARBODY"/>
</DECLAR>
</xsl:template>

<xsl:template match="DECLARHEAD">
     <xsl:copy-of select="//DECLARHEAD" />
</xsl:template>

<xsl:template match="DECLARBODY">
          <xsl:copy>
               <xsl:copy-of select="//DECLARBODY/HTIN" />
               <xsl:copy-of select="//DECLARBODY/HPAGES" />
               <xsl:copy-of select="//DECLARBODY/HZ" />
               <xsl:copy-of select="//DECLARBODY/HZN" />
               <xsl:copy-of select="//DECLARBODY/HNAME" />
               <xsl:copy-of select="//DECLARBODY/HLOC" />
               <xsl:copy-of select="//DECLARBODY/HTINSTI" />
               <xsl:copy-of select="//DECLARBODY/HSTI" />
               <xsl:copy-of select="//DECLARBODY/HZKV" />
               <xsl:copy-of select="//DECLARBODY/HZY" />
               <xsl:copy-of select="//DECLARBODY/*[starts-with(name(),'R00')]" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG02" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG03A" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG03" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG04A" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG04" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG05" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG06D" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG07D" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG08" />
               <xsl:copy-of select="//DECLARBODY/T1RXXXXG09" />

               <xsl:copy-of select="//DECLARBODY/*[starts-with(name(),'R01')]" />

               <xsl:copy-of select="//DECLARBODY/*[starts-with(name(),'R02')]" />

               <xsl:copy-of select="//DECLARBODY/HFILL" />
               <xsl:copy-of select="//DECLARBODY/HKBOS" />
               <xsl:copy-of select="//DECLARBODY/HBOS" />
               <xsl:copy-of select="//DECLARBODY/HTELBOS" />
               <xsl:copy-of select="//DECLARBODY/HKBUH" />
               <xsl:copy-of select="//DECLARBODY/HBUH" />
               <xsl:copy-of select="//DECLARBODY/HTELBUH" />
         </xsl:copy>
</xsl:template>
</xsl:stylesheet>