var objCl = extPar.dpObj;
var ctrlLinker;

include("sys/mask.js");
include("Objects/DpCl.js");
include("Objects/DpSbcs.js");
include("Objects/DpSc.js");

var Validation = true;
var strFwid;
var strMode;
var bReady=false;

var oTabn ;
var oSbcs;
var oTrType;
var oSc;
var oldTabn = 0;
//метки констант справочников
var sTabn = "CODPERS";
var sTrtype = "CAS_TRTYPE";
var isFirstValid = true;

function Load()
{
	Caption(ru("Місця перерахувань", "Места перечислений")
			+ ": " + modeName(this.sMode));
			
	var tbl = extPar.m_pTable;
	FCOD.mask="###############";
	FINDNUM.mask = replicate("$", 10);
	FCOD.setFocus();

	// табельный №
	oTabn = new DpCl("N",getPar(sTabn),0);
	oTabn.linkSmartCtrl(FTABN);
	// виды перечислений
	oTrType = new DpCl("",getPar(sTrtype),0);
	oTrType.linkSmartCtrl(FTRTYPE);

	oSc = new DpSc("c0utxyz");
	oSc.linkCtrl(FSC, FSU, FST, FCL1, FCL2, FCL3);
	
	Disable(FBNK);
	Disable(FSCH);
	Disable(FMFO);

   	oSbcs = new DpSbcs();
	oSbcs.linkCtrl(FNUMSB,FBNK,FSCH,FMFO);	

	ctrlLinker = new DpCtrlLinker(objCl);
	ctrlLinker.addLink("HCOD",  FCOD);
	ctrlLinker.addLink("HTXT",  FTXT);
	ctrlLinker.addLink("HINDNUM",  FINDNUM);
	
	ctrlLinker.addClLink("HTABN", oTabn);
	ctrlLinker.addClLink("HIDPAR", oTabn);
	ctrlLinker.addClLink("HTRTYPE", oTrType);
	ctrlLinker.addLink("HADDR", FADDR);
	ctrlLinker.addLink("HZIP", FZIP);
	ctrlLinker.addLink("HLICSCH", FLICSCH);
	ctrlLinker.addLink("HNUMSB", FNUMSB);

	ctrlLinker.addScLink("HSC","HSU","HST","HCL1","HCL2","HCL3",oSc)

	ctrlLinker.toControls();
	if (extPar.mode == "EDIT")
		setFocus(FTXT);
	
	FTABN_valid();
	if (extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		oSbcs.setCod(FNUMSB.value);
		oSbcs.updateCtrl();		
	}
	
	if (extPar.mode == "ADD")
	{
		oSc.set( 0, 0, 0, 0, 0, 0 );
	}

	setValid(FTABN,FTABN_valid)
	oldTabn =  oTabn.getCod();

	setFocus(FCOD);
}

function FTABN_valid()
{
	if (extPar.mode == "ADD" && isFirstValid)//Tori 02.06.2010: добавил флаг, чтоб при сохранении не перебивало ФИО получателя, если они отличаются от сотрудника
	{
		FTXT.value =  oTabn.getTxt();
		isFirstValid = false;
	}
	oldTabn =  oTabn.getCod();
	return true;
}

function onSave()
{
	if("EDIT"!=extPar.mode)
	{
		var oSnap = getSnap("SELECT b.* FROM ^clrelclcl b"
							+ " WHERE b.Fcod=" + FCOD.getValue()
							+ " AND b.Fcl=" + objCl.getVar("HCL"));
		if(null!= oSnap)
		{			
			setFocus(FCOD);
			WAIT(ru("Запись с таким кодом уже существует.", "Запис з таким кодом вже існує."));
			return false;
		}
	}	
	ctrlLinker.toVars();
	objCl.setVar("HFIO", FTXT.getValue());
}

include("sys\\DpBaseDlg.js");