include("sys\\main.js");
include("objects\\DpGrid.js");
include("sys\\servis.js");
include("servis\\format.js");

var oGrid = new DpGrid("NOCREATE");
var ds;
var tblUpd;
var tblFiles;

var path = getPar("UPDDIR", "UPD");

if (isEmpty(toScrObj(path)))
{
	//Если путь не задан, то по умолчанию он у нас будет вида
	// D:\Debet\DebetPlusV12\updates/"
	//path = "D:\\Debet\\DebetPlusV12\\updates";
	
	//вернет что то похожее на C:\DebetPlusV12\JDebet/
	path = String(lpProxy.getWrkDir()).trim();	
	//заменим JDebet\ в конце на updates/
	path = path.replace(/JDebet[\\\/]*$/i, "updates/");
}
else
{
	//проверим наличие слеша в конце.
	//Если его нет, то добавим
	//Будем добавлять прямой а не обратный слеш
	//с прицелом на работу под *nix
	//Сначала удалим слеш в конце (если он есть)
	path = path.replace(/[\\\/]$/i, "");
	//а теперь добавим
	path +="/";
}

var tblUpdName = "UPDATES";
var tblFiles = snapDirectory(path);

function listLoad()
{
	ds = DataSource();

	with (list)
	{
		accDel = new Function("return false");
	}
}

function listTitle()
{
	var str4capt = UR("Перегляд оновлень|Просмотр обновлений");
	return str4capt;
}

function loadFileAsArrayString(file)
{
	f = new java.io.BufferedReader(new java.io.InputStreamReader(new DpFileInputStream(file), "utf8"));
	
	var ArString = new Array();
	var s = null;
	var i = 0;
	while ((s = f.readLine()) != null)
	{
		ArString[i] = toScrObj(s);
		i++;
	}
	return ArString;
	f.close();
}

function listMake()
{
	// открываем нашу таблицу обновлений
	strSQL = " SELECT * "
			+" FROM ^" + tblUpdName
			+" ORDER BY "+Convert("FDATA","INT")+" DESC";
	tblUpd = OpenTable("s", strSQL);

	//++ Проверяем, есть ли файл к каждой записи, и заполняем поле "FIS_EXIST"
	for (; !tblUpd.isEOF(); tblUpd.MoveNext())
	{
		var mFrem			= "";
		var isFileExist		= false;
		var fileName		= "up" + tblUpd.getValue("FDATA") + ".js";
		for (i in tblFiles)
		{
			if (tblFiles[i] == fileName)
			{
				isFileExist		= true;
				// проставляем комментарии из файла
				mFrem			= UR(get_rem_from_file("", path, tblFiles[i]));
				break;
			}
		}
		m = new Object();
		m.fis_exist = isFileExist;
		m.frem = mFrem;
		UpdateTable("^"+tblUpdName, m, false, "fwid = " + sqlTo(tblUpd.getValue("FWID")));
	}
	tblUpd.requery();
	//-- Проверяем, есть ли файл к каждой записи, и заполняем поле "FIS_EXIST"

	//++ Добавляем записи, для которых есть файлы
	if (tblFiles != null && tblFiles[0] != null)
	{
		for (i in tblFiles)
		{
			aName = String(tblFiles[i]).split(".");
			check = left(tblFiles[i],2);
			if (aName.length==2 && aName[0].length==12 && aName[1].toLowerCase()=="js" && check.toLowerCase()=="up")
			{
				var strDate = aName[0].substr(2, 10);
				if (!tblUpd.FindFirst("FDATA = " + sqlTo(strDate)))
				{
					mFrem = get_rem_from_file("", path, tblFiles[i]);
					m = new Object();
					m.fdata = strDate;
					m.fis_exist = true;
					
					m.frem = mFrem;
					m.fwid = GetUID();
					UpdateTable("^"+tblUpdName, m, true);
				}
			}
		}
	}
	tblUpd.requery();	
}

function listDpGrid()
{
	with (oGrid)
	{
		var widthDateTime = 13;

		defCond("=^FKOL_UPD==0", "FKOL_UPD_NO");
		defCond("=^FKOL_UPD==1", "FKOL_UPD_ONE");
		defCond("=^FKOL_UPD>1", "FKOL_UPD_MORE");

		color(1, "FKOL_UPD_NO");
		color(4, "FKOL_UPD_ONE");
		color(7, "FKOL_UPD_MORE");

		with (page("Оновлення|Обновления"))
		{
			cell("FIS_EXIST", "Є в\nнаявності|Имеется в\nналичии", 5);
			cell("=str2date(toScrObj(^FDATA))", "Дата/час\nфайлу|Дата/время\nфайла", widthDateTime, "a");
			cell("FKOL_UPD", "Кількість\nзапусків|Количество\nзапусков", 7, "u");
			cell("FREM", "Коментар|Комментарий", 35);
			cell("FRESULT", "Результат\nвиконання|Результат\nвыполнения", 23);
		}
		with (page("Додатково|Дополнительно"))
		{
			with (group("Перше оновлення|Первое обновление"))
			{
				cell("FM1DATE", "Дата/час|Дата/время", widthDateTime, "a");
				cell("FM1USER", "Користувач|Пользователь", 10, "u");
			}
			with (group("Останнє оновлення|Последнее обновление"))
			{
				cell("FMDATE", "Дата/час|Дата/время", widthDateTime, "a");
				cell("FMUSER", "Користувач|Пользователь", 10, "u");
			}
		}
		build();
	}
}

function listSrc()
{
	this.qrySet("From", "^"+tblUpdName, "order", Convert("FDATA","INT")+" DESC");
}

// функция возвращает строку вида ггммддччмм из формата даты
// 24 августа 2004 15:00 -> "0408241500"
function date2str(dat)
{
	var datFull = new Date(dat);

	var year	= String(datFull.getYear()).substr(2);
	var month	= datFull.getMonth()	<= 8 ? "0" + String(datFull.getMonth() + 1)	: String(datFull.getMonth() + 1);

	var date	= datFull.getDate()		<= 9 ? "0" + String(datFull.getDate())		: String(datFull.getDate());
	var hours	= datFull.getHours()	<= 9 ? "0" + String(datFull.getHours())		: String(datFull.getHours());
	var minutes	= datFull.getMinutes()	<= 9 ? "0" + String(datFull.getMinutes())	: String(datFull.getMinutes());

	return year + month + date + hours + minutes;
}

// функция возвращает дату из строки вида ггммддччмм
// "0408241500" -> 24 августа 2004 15:00
function str2date(str)
{
	var ret = "";
	if (!isEmpty(str))
	{
		var year	= str.substr(0, 2);
		var month	= str.substr(2, 2);
		var date	= str.substr(4, 2);
		var hours	= str.substr(6, 2);
		var minutes	= str.substr(8, 2);

		ret = date+" "+tmonth(Number(month), 2)+" "+"20"+year+"  "+hours+":"+minutes;
	}

	return ret;
}

function make_date()
{
	var retVal	= str2date(list.tbl.getValue("FDATA")).getVarDate();

	return retVal;
}

// функция возвращает комментарии из файла fileNameIn в папке pathName,
// которые находятся в начале файла (до определения любой функции)
// и оформлены должным образом (конструкция //комментарий или /*комментарий*/)
function get_rem_from_file(mode, pathName, fileNameIn)
{
	var fileName	= pathName + fileNameIn;
	var aLines1 = loadFileAsArrayString(fileName);
	var nLines1 = aLines1.length;
	var nLine1;
	var strRem = "";
	for (nLine1=0; nLine1<nLines1;nLine1++)
	{
		if (aLines1[nLine1].indexOf("function") == -1)
		{
			strRem += aLines1[nLine1];
		}
		else
		{
			strRem += aLines1[nLine1].substr(0, aLines1[nLine1].indexOf("function"));
			break;
		}
	}	
	strRem			= strRem.replace(/\s\s+/g, " ");
	strRem			= strRem.replace(/(\/\/)|(\/\*)|(\*\/)/g, " ");
	strRem			= strRem.replace(/  +/g, " ");
	return strRem;
}

function listMenuInit()
{
	if (list.tbl.getValue("FIS_EXIST"))
	{
		ds.AddMenuItem("DO_UPDATE", "Виконати оновлення|Выполнить обновление");
	}
	
	if (isAdministrator())
	{
		editAcc = "";
		stdMenuInit();
	}
}

function listMenuRun(ID, toObject)
{
	switch (ID)
	{
		case "DO_UPDATE":
			var kol = list.tbl.getValue("FKOL_UPD");
			var strFileName = "up" + list.tbl.getValue("FDATA") + ".js";
			var strMsg = UR("Увага!!! Буде внесено незворотні зміни|Внимание!!! Будут внесены необратимые изменения");

			if (kol > 0)
			{
				var strRaz = kol >= 2 && kol <= 4 ? " рази" : " раз";
				strMsg = UR("Увага!!! Це оновлення вже виконувалося |Внимание!!! Это обновление уже выполнялось ") + kol + strRaz + "!";
			}

			if ("c" != msgBox("co", strMsg, UR("Оновлення|Обновление")))
			{
				var mFwid				= list.tbl.getValue("FWID");
				var dateTime			= new Date();

				var m = new Object();
				m.FKOL_UPD		= Number(list.tbl.getValue("FKOL_UPD")) + 1;

				// upd_do_update.htm правильно includ'ит нужный файл
				// и вызывает функцию do_update() (если она там есть)
				var par					= new Object();
				par.includePath			= path;
				par.includeFile			= strFileName;
				include("upd:upd_do_update.js");
				upd_do_update(par);

				//tblUpd("FRESULT")		= par.result;
				//tblUpd.Update();
				m.FRESULT 				= par.result;
				UpdateTable("^"+tblUpdName, m, false, "fwid = "+sqlTo(mFwid));
				list.tbl.requery();
				list.tbl.FindFirst("FWID = " + sqlToFind(mFwid));
				grid.RefreshGrid(RG_SAVEROW);
			}
		break;
	}

	stdMenuHandler(ID);
}

include ("sys\\DpList.js");