include("Objects\\DpCl.js");
include("avto:AVTO_const.js");

var sDir;
var objCl = extPar.dpObj;
var sTmpTbl = "TMP_CL_RASC10TKM_ROWS";
var sRowTbl = "CL_RASC10TKM_ROWS";
var sRowClass = "RASC";
var ctrlLinker;
var gridTbl;
var sprGrTS;
function onLoad()
{
	this.onEscape = exit;
	
	Caption(ru("Авто:Расценки за т/км", "Авто:Розцінки за т/км") +": "+ modeName(this.sMode));
	sprGrTS = getPar(const_GETPAR_GROUPTS)
	oGrTs = new DpCl("", sprGrTS, 0);
	oGrTs.linkSmartCtrl(FAVTOGR);
	FCOD.setMask("######");
	FCLASS.setMask("######");
	FROADGR.setMask("######");
	FVANT.setMask(MASK_KOL);
	FCOD.setFocus();
	
	ctrlLinker = new DpCtrlLinker(objCl);
	ctrlLinker.addLink("HCOD", FCOD);
	ctrlLinker.addLink("HTXT", FTXT);
	ctrlLinker.addClLink("HAVTOGR", oGrTs);
	ctrlLinker.addLink("HCLASS", FCLASS);
	ctrlLinker.addLink("HVANT", FVANT);
	ctrlLinker.addLink("HROADGR", FROADGR);
	
	ctrlLinker.toControls();
	
	loadGrid(this.sMode);
	setValid(FROADGR, FROADGR_Valid);
	setValid(FCLASS, FCLASS_Valid);
}

function loadGrid(sMode)
{
	var n = objCl.sClassId.indexOf(":");
	if (n != -1)
	{
		var moduleID = objCl.sClassId.substr(0, n);
		sDir = lpProxy.getModulePath(moduleID) + "/scripts/cls/" + objCl.sClassId.substr(n + 1)+ "/";
	}
	else
	{
		sDir = rootDirectory() + "cls/" + objCl.sClassId+ "/";
	}
	DropTable(sTmpTbl);
	var sSQL = "SELECT *"
			+ " INTO " + sTmpTbl
			+ " FROM ^"+ sRowTbl;
	var sWhere = " WHERE 1<>1 ";
	if (sMode != "ADD")
		sWhere = " WHERE FWID_CL="+ sqlTo(objCl.getID());
	sSQL += sWhere;
	ExecuteSQL(sSQL);
	
	strSQL = " SELECT * "
			+" FROM " + sTmpTbl
			+" ORDER BY FBDAT"
	gridTbl = OpenTable("m", strSQL);
	GRIDRASC.setXMLDir(sDir);
	GRIDRASC.setXMLFile("GRIDRASC.xml");
	GRIDRASC.setTable(gridTbl);
	GRIDRASC.build();
	GRIDRASC.setData(sRowClass);
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	GRIDRASC.loadMenuHandler(this,"gridMenuInit");
	GRIDRASC.selectMenuHandler(this,"gridMenuRun");
}

function FROADGR_Valid()
{
	var retval = true;

	if (Number(FROADGR.value) < 1 || Number(FROADGR.value) > 3)
	{
		WAIT(ru("Введите значение от 1 до 3", "Введiть значення вiд 1 до 3"));
		retval = false;
	}

	return retval;
}

function FCLASS_Valid()
{
	var retval = true;

	if (Number(FCLASS.value) < 1 || Number(FCLASS.value) > 4)
	{
		WAIT(ru("Введите значение от 1 до 4", "Введiть значення вiд 1 до 4"));
		retval = false;
	}

	return retval;
}

function gridMenuInit(GRIDRASC)
{
	GRIDRASC.AddMenuItem("ADD","Додати|Добавить");
	if (!GRIDRASC.getTable().isEmpty())
	{
		GRIDRASC.AddMenuItem("EDIT","Редагувати|Редактировать");
		GRIDRASC.AddMenuItem("COPY","Копіювати|Копировать");
		GRIDRASC.AddMenuItem("DEL","Видалити|Удалить");
	}
}

function gridMenuRun(sID, GRIDRASC)
{
	var tbl = GRIDRASC.getTable();
	var tName = tbl.getTableName();
	var rowID = tbl.getValue("FWID");
	
	switch(sID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					var rowID = Number(GRIDRASC.getTable().getRowID());
					objCl.deleteRow(sRowClass, rowID);
					GRIDRASC.getTable().Delete();
					GRIDRASC.getTable().requery();
					GRIDRASC.refresh();
				break;
			}
			break;

		case "__XDEL":
			var delRowCount = DataSource().getSelectedCount();
			
			if (delRowCount <= 0)
			{
				return;
			}
			var selIds = DataSource().getSelectedIDs();
			
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}

			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				objCl.deleteRow(sRowClass, Number(selIds[nRow]));
			}
			strSQL = " DELETE FROM " + GRIDRASC.getTable().getTableName()
					+" WHERE " + GRIDRASC.sqlSelected()
			ExecuteSQL(strSQL);

			GRIDRASC.getTable().requery();
			GRIDRASC.clearSelected();
			GRIDRASC.refresh();
			setProgressPos(0);
			break;

		case "ADD":
		case "EDIT":
		case "COPY":
			var oRow;
			if(sID == "ADD")
				oRow = objCl.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = objCl.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = objCl.copyRow(sRowClass, rowID);
			if(!oRow)
				break;
			if (!rowEdit(sID, oRow))
				break;
			
			tbl.requery();
			GRIDRASC.refresh();
			break;
	}
	return true;
}

function onSave()
{
	ctrlLinker.toVars();
	storeToDb(sRowTbl, sTmpTbl);
	exit();
}

function storeToDb(sTbl, tmpTbl)
{
	var sFld = GetPatternIntersection (sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FWID_CL="+ sqlTo(objCl.getID()));
	ExecuteSQL("UPDATE "+ tmpTbl +" SET Fwid_cl="+ sqlTo(objCl.getID()));
	ExecuteSQL("INSERT INTO ^"+ sTbl +" ("+ sFld +")"
			+" SELECT "+ sFld +" FROM "+ tmpTbl);
}

function exit()
{
	gridTbl.close();
	DropTable(sTmpTbl);
}

function rowEdit(sMode, oRow)
{
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = sTmpTbl;
	par.formFile = "avto:"+"\\cls\\com.debet.clcl.rasc10t\\" +sRowClass+"/form.xml";
	par.dpObj.hasExt = hasExt;
	par.nCl = objCl.getVar("HCL");
	par.Fcod1 = objCl.getVar("HIDPAR");
	par.objCl = objCl;
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	
	var id = oRow.getID();
	if(inList(sMode, "ADD", "COPY"))
		objCl.appendRow(sRowClass, oRow);
	
	obj2DB(id, oRow.jObj, null, sTmpTbl);
	
	return true;
}

function hasExt()
{
	return false;
}

include("sys/DpBaseDlg.js");