include("objects/DpCl.js");
include("avto:AVTO_const.js");
include("servis/date.js");
include("objects\\DpLicf.js");

var obj = extPar.dpObj;
var oLs;
var isKlassn = extPar.isKlassn;

function onLoad()
{
	Caption(ru("Доплаты", "Доплати")	+": "+ modeName(extPar.mode));
	
	//маски
	FPROC.mask = "###.##";
	FBSUM.mask = MASK_SUM;
	FSUM.mask = MASK_SUM;
	FTIME.mask = "###.##";
		
	ctrlLinker = new DpCtrlLinker(obj);	
		
	ctrlLinker.addLink("RVOPL", FVOPL);
	ctrlLinker.addLink("RTIME", FTIME);
	ctrlLinker.addLink("RBSUM", FBSUM);
	ctrlLinker.addLink("RLSFID", FLSFID);
	ctrlLinker.addLink("RPROC", FPROC);
	ctrlLinker.addLink("RSUM", FSUM);
	ctrlLinker.addLink("RISKLASSN", FISKLASSN);
	
	Disable(FBSUM);
	Disable(FSUM);
	//ctrlLinker.updateData(false);
	ctrlLinker.toControls();
	
	oLs = new DpLicf("Z");
	
	if(inList(this.sMode, "EDIT", "COPY"))
	{
		oLs.setFid(Number(FLSFID.getValue()));
		FLSFID.setValue(oLs.getFnum())
	}
	oLs.linkCtrl(FLSFID, FTLSFID);
	
	if(this.sMode == "ADD")
	{
		FTIME.setValue(extPar.cdv)
	}
	
	if(!isKlassn)
	{
		ISKLASSN.setVisible(false);
	}
	
	setValid(FVOPL, calcSum);
	setValid(FPROC, calcSum);
	setValid(FTIME, calcSum);
	setValid(FLSFID, FLSFID_Valid)
	//setValid(FPROC, FPROC_Valid)
	
	calcSum();
}

function FLSFID_Valid()
{
	var ret = true;
	if(isEmpty(oLs.getFid()))
	{
		ret = false;
	}
	
	return ret;
}

function calcSum()
{
	Disable(FSUM);
	var mFopl = String(FVOPL.getValue());
	var mFproc = Number(FPROC.getValue());
	var mFtime = Number(FTIME.getValue());
	var mFbsum = 0;
	var mFsum = Number(FSUM.getValue());
	//var mFrasc = extPar.rasc;
	var mFcts = extPar.cts;
	var ret = true;
	
	switch (mFopl)
	{
		case "GTS":
			Enable(FTIME);
			Enable(FPROC);
			mFbsum = mFtime * mFcts;
			mFsum = round(mFbsum * mFproc / 100, 2);
			if(isEmpty(mFproc))
			{
				ret = false;
			}
			break;
		case "PROC":
			Disable(FTIME);
			Enable(FPROC);
			mFbsum = isEmpty(extPar.mFzp) ? 0 : extPar.mFzp;
			mFsum = round(mFbsum * mFproc / 100, 2);
			if(isEmpty(mFproc))
			{
				ret = false;
			}
			break;
		case "VDR":
			Disable(FTIME);
			Disable(FPROC);
			FPROC.setValue(0);
			FTIME.setValue(0);
			Enable(FSUM);
			/*
			mFbsum = extPar.bsum;
			if(Number(FPROC.getValue()) == 0)
			{
				Enable(FSUM);
			}
			else
			{
				mFsum = round(mFbsum * mFproc / 100, 2);
				Disable(FSUM);
				
				if(isEmpty(mFproc))
				{
					ret = false;
				}
			}
			*/
			break;
		default:
			mFbsum = 0;
			break;
	}
	
		
	FBSUM.setValue(mFbsum);
	FSUM.setValue(mFsum);
	
	if(isSaving() && isEmpty(Number(FSUM.getValue())))
	{
		FSUM.showErr(ru("Сумма равна нулю...", "Сума рівна нулю..."));
		ret = false;
	}
	return ret;
}

function onSave()
{
	ctrlLinker.toVars();
	obj.setVar("RLSFID",oLs.getFid());
}

include("sys/DpBaseDlg.js");