﻿include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("objects\\DpShifPZ.js");
include("sys\\mask.js");
include("sys\\udfs.js");
include("avto:AVTO_const.js");	// Константы справочников
include("avto:servis\\avto_tools.js");	// сервисные функции
include("getParam.js");
include("objects\\DpEdi.js");
include("objects\\DpLicf.js");

var ctrlLinker;
var sprWorkType, sprMod, sprZatr, sprMarsh, sprCat, sprDopRab, sprMetLoad, sprPers;
var oWorkType, oMod, oLsKlassn;
var noCalcKl;
var oldValofKl;
var obj = extPar.obj;
var oAvto = extPar.oAvto;
var oFrom, oTo;

var isKlassn = (isEmpty(getPar(const_AVTO_LIC_KLASSN)) ? false :true);
var codLsKlassn = getPar(const_AVTO_LIC_KLASSN);

var clasDopl = "DOPL";
var tblDopl = extPar.tblDopl;
var tmpTblDopl = getTmpTableName();

//параметры папки
var sprPers = obj.parent.getPar("_codpers");
var load2zp = obj.parent.getPar("_is_load2zp");
var useShpz = obj.parent.getPar("_use_spr_shpz");
function Load()
{
	Caption(ru("Строки путевого листа","Рядки шляхового листа"),extPar.mode);
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprMod = getPar(const_GETPAR_MODEL);
	sprZatr = getPar(const_GETPAR_ZATR);
	sprMarsh = getPar(const_GETPAR_PUNKT);
	sprUser = (extPar.mode=="ADD" ? obj.parent.getPar("_codconsumer") : obj.getVar("RUSER_CL"));
	sprCat = getPar(const_GETPAR_CATEGORY);
	sprDopRab = getPar(const_GETPAR_DOPRAB);
	sprMetLoad = getPar(const_GETPAR_METHODLOADING);
	
	oWorkType = new DpCl("", sprWorkType, 0);
	oWorkType.linkSmartCtrl(FWORKTYPE);
	oWorkType.listCond = listCondWorkType;
	
	if(!useShpz)
	{
		//fruckt
		//oZatr = new DpCl("", sprZatr, 0);
		oZatr = new DpCl("0", sprZatr, 0);
		oZatr.linkSmartCtrl(FGALUZ);
	}
	else
	{
		dpShifPZ = new DpShifPZ();
		dpShifPZ.linkCtrl(FGALUZ);
	}

	//проверим есть ли такой код ЛС который указан в настройке класности
	if(isKlassn)
	{
		strSQL = "SELECT FID" 
					+" FROM ^LIC_FLD"
					+" WHERE 1=1"
						+" AND FID = "+sqlTo(codLsKlassn)
		var sn = getSnap(strSQL);
		if(sn)
		{
			codLsKlassn = sn[0];
		}
		else
		{
			alert(ru("Указанный код для классности не найден в справочнике ЛС, "+codLsKlassn
					, "Вказаний код для класності не знайдений в довіднику ОР, "+codLsKlassn));
			isKlassn = false;
		}
	}

	//поле ЛС для класности
	oLsKlassn = new DpLicf("Z");
	oLsKlassn.linkCtrl(FLSFIDKLASSN, FTLSFIDKLASSN);
	oLsKlassn.setFid(codLsKlassn);
	//----
	
	oMetLoad = new DpCl("0", sprMetLoad, 0);
	oMetLoad.linkSmartCtrl(FSPPOGR);
	oUser = new DpCl("", sprUser, 0);
	if (sprUser == 0)
	{
		oUser.setMode("0");
	}
	oUser.linkSmartCtrl(FUSER);
	oDopRab = new DpCl("0", sprDopRab, 0);
	oDopRab.linkSmartCtrl(FRAB);
	
	oMod = new DpCl("", sprMod, 0);
	oCat = new DpCl("", sprCat, 0);

	oEdi = new DpEdi();
	oEdiSD = new DpEdi();
	oEdiSD.linkCtrl(FEDSD);
	
	if(!load2zp)//если данные для з/п не используются, то и вводить ничего не даем по з/п
		Disable(ZP);
	Enable(FPROB, false);
	Enable(FEDOBL, false);
	Enable(FNOBL, false);
	Enable(FKOLF, false);
	Enable(FCTOT, false);
	Enable(FMTOT, false);
	Enable(FDTOT, false);
	Enable(FKOLVYD, false);
	Enable(FGRDOR1, false);
	Enable(FRTKM, false);
	Enable(FSTKM	, false);
	Enable(FRT, false);
	Enable(FST	, false);
	Enable(FRDOP, false);
	Enable(FSDOP, false);
	Enable(FSSD, false);
	Enable(FSDOPL, false);
	Enable(FSUM, false);
	Enable(FLSFIDKLASSN, false);
	Enable(FKLSUM, false);
	
	Enable(FCTS, false);
	Enable(FCTSSUM, false);
	
	if(!isKlassn)
	{
		//скрываемконтролы класности если нету в настройках поля ЛС для классности
		ZAKLASSN.setVisible(false);
	}

	ctrlLinker = new DpCtrlLinker(obj);
	if (obj.parent.getPar("_beg_tour")==1)
	{
		oFrom = new DpCl("", sprMarsh, 0);
		oFrom.linkSmartCtrl(FFROM);		
		ctrlLinker.addClLink("RFROMCOD", oFrom);
	}
	else
	{
		ctrlLinker.addLink("RFROM", FFROM);
	}
	if (obj.parent.getPar("_end_tour")==1)
	{
		oTo = new DpCl("", sprMarsh, 0);
		oTo.linkSmartCtrl(FTO);		
		ctrlLinker.addClLink("RTOCOD", oTo);
	}
	else
	{
		ctrlLinker.addLink("RTO", FTO);
	}
	
	if (extPar.mode == "ADD")
	{
		obj.setVar("RBDATE", new Date());
		obj.setVar("REDATE", new Date());
		FBDATE.value = new Date();
		FEDATE.value = new Date();
		if(useShpz)
		{
			dpShifPZ.setFshpz("");
		}
	}
	else 	if ((extPar.mode == "EDIT" || extPar.mode == "COPY") && useShpz)
	{
		dpShifPZ.setFshpz(obj.getVar("RSHPZ"));		
	}
	
	ctrlLinker.addClLink("RUSER", oUser);
	if(!useShpz)
	{
		ctrlLinker.addClLink("RGALUZ", oZatr);
	}
	else
	{
		
	}
	ctrlLinker.addLink("RNOM",FNOM_STR);
	ctrlLinker.addLink("RGRDOR", FGRDOR);
	ctrlLinker.addLink("RHOD", FHOD);
	ctrlLinker.addLink("RGRUZ", FGRUZ);
	ctrlLinker.addLink("RGRKL", FGRKL);
	ctrlLinker.addLink("RPROBG", FPROBG);
	ctrlLinker.addLink("RPROB0", FPROB0);
	ctrlLinker.addLink("RPROB", FPROB);
	ctrlLinker.addLink("RDDV", FDDV);
	ctrlLinker.addLink("RMDV", FMDV);
	ctrlLinker.addLink("RCDV", FCDV);
	ctrlLinker.addLink("RDTOT", FDTOT);
	ctrlLinker.addLink("RMTOT", FMTOT);
	ctrlLinker.addLink("RCTOT", FCTOT);
	ctrlLinker.addLink("RDREM", FDREM);
	ctrlLinker.addLink("RMREM", FMREM);
	ctrlLinker.addLink("RCREM", FCREM);
	ctrlLinker.addLink("RDBOPL", FDBOPL);
	ctrlLinker.addLink("RMBOPL", FMBOPL);
	ctrlLinker.addLink("RCBOPL", FCBOPL);
	ctrlLinker.addLink("RDLIN", FDLIN);
	ctrlLinker.addLink("RMLIN", FMLIN);
	ctrlLinker.addLink("RCLIN", FCLIN);
	ctrlLinker.addLink("RKOLF", FKOLF);
	ctrlLinker.addLink("RKOLVYD", FKOLVYD);
	ctrlLinker.addLink("RPROCDOP", FPROCDOP);
	ctrlLinker.addLink("RKOLVYDDOP", FKOLVYDDOP);
	ctrlLinker.addLink("RKOLOBL", FKOLOBL);
	ctrlLinker.addLink("RPROCTIMELIN", FPROCTIMELIN);
	ctrlLinker.addLink("RPROCTIMEREM", FPROCTIMEREM);
	ctrlLinker.addClLink("RWORKTYPE", oWorkType);
	ctrlLinker.addDateTimeLink("RBDATE",FBDATE,FBTIME);
	ctrlLinker.addDateTimeLink("REDATE",FEDATE,FETIME);
	ctrlLinker.addClLink("RRAB", oDopRab);
	ctrlLinker.addLink("RRDOP", FRDOP);
	ctrlLinker.addLink("RRSD", FRSD);
	ctrlLinker.addLink("RRT", FRT);
	ctrlLinker.addLink("RRTKM", FRTKM);
	ctrlLinker.addLink("RSDOP", FSDOP);
	ctrlLinker.addLink("RSDOPL", FSDOPL);
	ctrlLinker.addClLink("RSPPOGR", oMetLoad);
	ctrlLinker.addLink("RSSD", FSSD);
	ctrlLinker.addLink("RST", FST);
	ctrlLinker.addLink("RSTKM", FSTKM);
	ctrlLinker.addLink("RSUM", FSUM);
	ctrlLinker.addLink("RVOPL", FVOPL);
	ctrlLinker.addLink("RKOLDOP", FKOLDOP);
	ctrlLinker.addLink("RKOLVYDDOP", FKOLVYDDOP);
	ctrlLinker.addLink("RKOLSD", FKOLSD);
	ctrlLinker.addLink("RKLPROC", FKLPROC);
	ctrlLinker.addLink("RKLCTS", FKLCTS);
	ctrlLinker.addLink("RKLSUM", FKLSUM);
	ctrlLinker.addLink("RCTS", FCTS);
	ctrlLinker.addLink("RCTSSUM", FCTSSUM);
	ctrlLinker.updateData(false);
	setMasks();
	
	loadGrid(clasDopl);
	
	//при содзании строки возьмем классность у водителя 
	if(isKlassn && extPar.mode == "ADD")
	{
		FKLPROC.setValue(xcl(sprPers, extPar.oPers.getCod(), "PRKL"));
	}
	
	if(extPar.mode == "ADD")
	{
		FBDATE.setValue(new Date().getVarDate())
		FEDATE.setValue(new Date().getVarDate())
		FBTIME.setTime(8.00);
		FETIME.setTime(17.00);
		
		//fruckt
		FGRDOR.setValue(1);
		FHOD.setValue(1);
		FGRKL.setValue(1);
		
		oUser.setCod(1);
	}
	
	//если подняли на редактирование то клас груза не пересчитываем
	noCalcKl = extPar.mode == "EDIT" ? true : false;
	FWORKTYPE_Valid();
	FVOPL_Valid();
	Fwork_Valid();
	FGRDOR_Valid();
	//проконтролируем введение класса груза руками
	setValid(FGRKL		, FGRKL_Valid);
	setValid(FWORKTYPE	, FWORKTYPE_Valid);
	setValid(FGRDOR	, FGRDOR_Valid);
	setValid(FHOD		, FHOD_Valid);
	setValid(FGRUZ		, calcAll);
	setValid(FPROBG	, calcAll);
	setValid(FPROB0		, calcAll);
	setValid(FKOLOBL	, calcAll);
	setValid(FDDV		, calcAll);
	setValid(FCDV		, calcAll);
	setValid(FMDV		, calcAll);
	setValid(FDLIN		, calcAll);
	setValid(FCLIN		, calcAll);
	setValid(FMLIN		, calcAll);
	setValid(FDBOPL		, calcAll);
	setValid(FCBOPL		, calcAll);
	setValid(FMBOPL		, calcAll);
	setValid(FDREM		, calcAll);
	setValid(FCREM		, calcAll);
	setValid(FMREM		, calcAll);
	setValid(FVOPL		, FVOPL_Valid);
	setValid(FKOLDOP	, calcAll);
	
	setValid(FPROCTIMELIN	, calcAll);
	setValid(FPROCTIMEREM	, calcAll);
	
	setValid(FPROCDOP		, FPROCDOP_Valid);
	setValid(FKOLVYDDOP	, FKOLVYDDOP_Valid);
	setValid(FSPPOGR	, FSPPOGR_Valid);
	setValid(FRAB		, FDOPRAB_Valid);
	setValid(FKOLSD		, calcAll);
	setValid(FRSD		, calcAll);
	setValid(FKLPROC	, calcAll);
	setValid(FKLSUM		, calcAll);

	setValid(FEDATE, Fwork_Valid);
	setValid(FETIME, Fwork_Valid);	
	oEdiSD.setCod(obj.getVar("REDSD"));
	
	if(useShpz)
	{
		setValid(FGALUZ, FGALUZ_Valid);
	}
}

function listCondWorkType()
{
	var strSQL = " FCOD IN ("
						+" SELECT"
							+" W.FCOD"
						+" FROM (^CL_AVTO_WORK W LEFT JOIN ^CL_AVTO A ON W.FWID_CL = A.FWID_CL)"
							+" LEFT JOIN ^CLRELCLCL REL ON A.FWID_CL = REL.FWID_CL"
						+" WHERE 1 = 1"
							+" AND REL.FCL = "+sqlTo(getPar("AVTOTRANSPORT"))
							+" AND REL.FCOD = "+sqlTo(oAvto.getVar("FAVTO"))
						+")";
	return strSQL;
}

function loadGrid(clas)
{
	
	var tmpTbl;
	var workTbl;
	var gridName;
	var sMode = extPar.mode;
	
	var n = String(obj.parent.sDocLbl).indexOf(":");
	if (n != -1)
	{
		var moduleID = obj.parent.sDocLbl.substr(0, n);
//		this.sDocSourceDir = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + obj.parent.sDocLbl.substr(n + 1)+ "/ROW/";
		this.sDocSourceDir = rootDirectoryEx() + "modules/avto/scripts/docs/" + obj.parent.sDocLbl.substr(n + 1)+ "/ROW/";
	}
	else
	{
		this.sDocSourceDir = rootDirectory() + "docs/" + obj.parent.sDocLbl+ "/ROW/";
	}
	
	switch(clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			workTbl = tblDopl;
			gridName = "GRIDDOPL";
			/*
			if(!IsTable(workTbl))
			{
				CreateTable(workTbl, "ROWS_DOPL", "*");
			}
			*/
			break;
	}
	var xmlFile = gridName+".xml";
	
	var sSQL = "SELECT *"
				+" INTO " + tmpTbl
				+" FROM ^"+ workTbl;
	switch (sMode)
	{
		case "ADD":
			sWhere = " WHERE 1<>1 ";
			break;
		case "COPY":
			sWhere = " WHERE FID_DOC="+ sqlTo(obj.nOldID);
			break;
		case "EDIT":
		default:
			sWhere = " WHERE FID_DOC="+ sqlTo(obj.getID());
			break;
	}
	sSQL +=sWhere;
	ExecuteSQL(sSQL);
	
	var gridTbl = OpenTable("m", tmpTbl);
	switch(clas)
	{
		case clasDopl:
			gridTbl.tie("LIC_FLD","LS","FID", "FLSFID");
			break;
	}

	//парметры загрузки грида
	eval(gridName+".setXMLDir(this.sDocSourceDir)");
	eval(gridName+".setXMLFile(xmlFile)");
	eval(gridName+".setTable(gridTbl)");
	eval(gridName+".build()");
	eval(gridName+".setData(clas)");
	
	//меню грида
	eval(gridName+".loadMenuHandler(this,'gridMenuInit')");
	eval(gridName+".selectMenuHandler(this,'gridMenuRun')");
	
	return true;
}

function gridMenuInit(grid)
{
	if(!load2zp)
		return false;
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");
	}
}

function gridMenuRun(sID, grid)
{
	if(!load2zp)
		return false;
	var tbl = grid.getTable();
	var tName = tbl.getTableName();
	var rowID = tbl.getValue("FWID");
	var clas = String(grid.getData());
		
	switch(sID)
	{
		case "DEL":
			var msg = ru("Подтвердите удаление записи.", "Підтвердіть вилучення запису.");
			var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
			switch(ret)
			{
				case 'c':
					break;
				case '-':
					var rowID = Number(grid.getTable().getRowID());
					obj.deleteRow(clas, rowID);
					grid.getTable().Delete();
					grid.getTable().requery();
					grid.refresh();
					if(clas == clasDopl)
					{
						//calcZP();
					}
				break;
			}
			break;

		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
	
			if (delRowCount <= 0)
			{
				return;
			}
			
			var selIds = grid.getSelectedIDs();
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + delRowCount + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}
			
			setProgressRange(0, delRowCount);
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
				obj.deleteRow(clas, Number(selIds[nRow]));
			}
			
			strSQL = " DELETE FROM " + grid.getTable().getTableName()
					+" WHERE " + grid.sqlSelected()
			ExecuteSQL(strSQL);

			grid.getTable().requery();
			grid.clearSelected();
			grid.refresh();
			setProgressPos(0);
			if(clas == clasDopl)
			{
				//calcZP();
			}
			break;

		case "ADD":
		case "EDIT":
		case "COPY":
			var oRow;
			if(sID == "ADD")
			{
				oRow = obj.createRow(clas);
				var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tName);
				var nNom = 1;
				if (oSnap && oSnap[0])
					nNom = Number(oSnap[0]) + 1;
				oRow.setVar("RNOM",nNom)
			}
			else if(sID == "EDIT")
					oRow = obj.getRow(clas, rowID);
			else if(sID == "COPY")
				oRow = obj.copyRow(clas, rowID);
				var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tName);
				var nNom = 1;
				if (oSnap && oSnap[0])
					nNom = Number(oSnap[0]) + 1;
				oRow.setVar("RNOM",nNom)
			if(!oRow)
				break;
			if (!rowEdit(sID, clas, oRow))
				break;
			tbl.requery();
			grid.refresh();
			break;
	}
	return true;
}

function rowEdit(sMode, clas, oRow)
{
	var par = new Object();
	var tmpTbl;
	switch (clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			break;
		/*case clasHelp:
			tmpTbl = tmpTblHelp;
			break;*/
		default:
	}

	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = tmpTbl;
	par.formFile = this.sDocSourceDir + clas + "/form.xml";
	par.dpObj.hasExt = new function(){return false};
	par.obj = obj;
	par.isKlassn = isKlassn;
	par.cts =Number(FCTS.getValue());
	par.mFzp = Number(FSUM.getValue())-Number(FSDOPL.getValue());
	/*
	par.rasc = Number(FRASC.getValue());
	par.kolGa = Number(FKOL_GA.getValue());
	par.ddv = Number(FDDV.getValue());
	par.cdv = Number(FCDV.getValue());
	*/
	
	par.bsum = Number(FSSD.getValue())	+Number(FSDOP.getValue())+Number(FST.getValue())+Number(FSTKM.getValue());
	//что брать для расчета при ЧТС (дни, часы)
	//параметр из настройки папки 
	//par.time = obj.parent.getPar("_gts_pom");

	//SAM 19.04.2012 - при сетевом подключении не работает - временно, но работоспособно
	//showWindow(par.formFile, "XMLDLG", par);
	showWindow("../modules/avto/scripts/docs/" + obj.parent.sDocLbl.substr(5)+ "/ROW/" + clas + "/form.xml", "XMLDLG", par);

	if(par.escape)
		return false;
	
	var id = oRow.getID();
	
	if(inList(sMode, "ADD", "COPY"))
		obj.appendRow(clas, oRow);
		
	obj2DB(id, oRow.jDocRow, null, tmpTbl);
	
	calcAll();
	return true;
}


function FGRDOR_Valid()
{
	var retval = true;

	if ((Number(FGRDOR.value) < 1 || Number(FGRDOR.value) > 3) && Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_RUN )
	{
		WAIT(ru("Введите значение от 1 до 3", "Введiть значення вiд 1 до 3"));
		retval = false;
	}
	else
	{
		FGRDOR1.value = FGRDOR.value;
		calcAll();
	}

	return retval;
}

function FHOD_Valid()
{
	var retval = true;

	if (Number(FHOD.value) < 1 && Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_RUN)
	{
		WAIT(ru("Введите значение > 0", "Введiть значення > 0"));
		retval = false;
	}
	else
	{
		calcAll();
	}

	return retval;
}

function Fwork_Valid()
{
	var date = new Date();
	date.setDate(toScriptDate(FBDATE.value).getDate());
	date.setMonth(toScriptDate(FBDATE.value).getMonth());
	date.setFullYear(toScriptDate(FBDATE.value).getFullYear());
	date.setHours(FBTIME.getHours());
	date.setMinutes(FBTIME.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(FEDATE.value).getDate());
	date2.setMonth(toScriptDate(FEDATE.value).getMonth());
	date2.setFullYear(toScriptDate(FEDATE.value).getFullYear());
	date2.setHours(FETIME.getHours());
	date2.setMinutes(FETIME.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	FDATDIFF.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";

	return true;
}

function FPROCDOP_Valid()
{	
	if(!isSaving())
	{
		var proc = Number(FPROCDOP.getValue());
		if(!isEmpty(proc))
		{
			kolDop = Number(FKOLF.getValue())*proc/100;
			FKOLVYDDOP.setValue(kolDop);
			Disable(FKOLVYDDOP);
		}
		else
		{
			kolDop = 0;
			FKOLVYDDOP.setValue(kolDop);
			Enable(FKOLVYDDOP)
		}
		FKOLVYD.setValue(kolDop+Number(FKOLF.getValue()));
	}
	return true;
}

function FKOLVYDDOP_Valid()
{
	FKOLVYD.setValue(Number(FKOLF.getValue()) + Number(FKOLVYDDOP.getValue()));
	return true;
}

function FSPPOGR_Valid()
{
	oAvto.setVar("FSPPOGR", oMetLoad.getCod());
	var mFrt = (oAvto.getRascT() == null ? 0 : oAvto.getRascT());
	FRT.setValue(mFrt);
	calcAll();
	return true;
}

function FDOPRAB_Valid()
{
	oAvto.setVar("FDOPRAB", oDopRab.getCod());
	var mFrdop = (oAvto.getRascDopr() == null ? 0 : oAvto.getRascDopr());
	FRDOP.setValue(mFrdop);
	calcAll();
	return true;
}

function FWORKTYPE_Valid()
{
	if (Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_TRACTOR)
	{
		FWORKTYPE.showErr(ru("Укажите вид работы для пробега или спецоборудования", "Вкажіть вид роботи для пробігу чи спецобладнання"));
		return false;
	}
	switch(Number(oWorkType.get("FWORK")))
	{
		case AVTO_WORKTYPE_RUN:
			SPEC.setVisible(false);
			PROB.setVisible(true);
			break;
		case AVTO_WORKTYPE_SPEC:
			SPEC.setVisible(true);
			PROB.setVisible(false);
			break;
	}
	var shell = FORM.ctrlComp.getShell();
	shell.pack();
	//Перерисуем окно
	var pnt = WT;
	pnt.redraw();
	pnt.layout(true);
	calcAll();
	return true;
}

function FVOPL_Valid()
{
	switch(String(FVOPL.value))
	{
		case "TKM":
			ZAVIDR.setVisible(false);
			ZATKM.setVisible(true);
			ZAGRUZ.setVisible(true);
			ZADOPRAB.setVisible(true);
			ZACTS.setVisible(false);
			if(isKlassn)
			{
				ZAKLASSN.setVisible(true);
			}
			break;
		case "GTS":
			ZAVIDR.setVisible(false);
			ZATKM.setVisible(false);
			ZAGRUZ.setVisible(true);
			ZADOPRAB.setVisible(true);
			ZACTS.setVisible(true);
			if(isKlassn)
			{
				ZAKLASSN.setVisible(true);
			}
			break;
		case "VIDR":
			ZAVIDR.setVisible(true);
			ZATKM.setVisible(false);
			ZAGRUZ.setVisible(true);
			ZADOPRAB.setVisible(true);
			ZACTS.setVisible(false);
			ZAKLASSN.setVisible(false);
			break;
	}
	var shell = FORM.ctrlComp.getShell();
	shell.pack();
	//Перерисуем окно
	var pnt = ZP;
	pnt.redraw();
	pnt.layout(true);
	calcAll();
	return true;
}

function FGRKL_Valid()
{
	//если изменили значение руками - дальше это поле не меняем
	if (FGRKL.value != oldValofKl)
	{
		noCalcKl = true;
	}
	return true;
}
function FGALUZ_Valid()
{
	if (isEmpty(dpShifPZ.getFshpz()))
	{
		FWORKTYPE.showErr(ru("Укажите ШПЗ", "Вкажіть ШВВ"));
		return false;
	}
	else
	{
		return true;
	}
	
}
function setMasks()
{
	FNOM_STR.mask = "#####";
	FGRDOR.mask = "######";
	FHOD.mask = MASK_KOL;
	FGRUZ.mask = MASK_KOL;
	FGRKL.mask = "######";
	FPROBG.mask = MASK_KOL;
	FPROB0.mask = MASK_KOL;
	FPROB.mask = MASK_KOL;
	FDDV.mask = "#####";
	FMDV.mask = "#####";
	FCDV.mask = "#####";
	FDLIN.mask = "#####";
	FMLIN.mask = "#####";
	FCLIN.mask = "#####";
	FDBOPL.mask = "#####";
	FMBOPL.mask = "#####";
	FCBOPL.mask = "#####";
	FDREM.mask = "#####";
	FMREM.mask = "#####";
	FCREM.mask = "#####";
	FDTOT.mask = "#####";
	FMTOT.mask = "#####";
	FCTOT.mask = "#####";
	FKOLF.mask = MASK_KOL;
	FNOBL.mask = MASK_KOL;
	FKOLOBL.mask = MASK_KOL;
	FPROCDOP.mask = "#####.##";
	FPROCTIMELIN.mask = "#####.##";
	FPROCTIMEREM.mask = "#####.##";
	FKOLVYDDOP.mask = MASK_KOL;
	FKOLVYD.mask = MASK_KOL;
	FKOLDOP.mask = MASK_KOL;
	FKOLSD.mask = MASK_KOL;
	FSDOP.mask = MASK_SUM;
	FSDOPL.mask = MASK_SUM;
	FST.mask = MASK_SUM;
	FSTKM.mask = MASK_SUM;
	//FSKL.mask = MASK_SUM;
	FSUM.mask = MASK_SUM;
	FSSD.mask = MASK_SUM;
	FRDOP.mask = MASK_SUM;
	FRT.mask = MASK_SUM;
	FRTKM.mask = MASK_SUM;
	FRSD.mask = MASK_SUM;
	//FCTS.mask = MASK_SUM;
	FKLPROC.mask = "###.##";
	FKLCTS.mask = "#####.##";
	FKLSUM.mask = MASK_SUM;
	
	FCTS.mask = "#####.##";
	FCTSSUM.mask = MASK_SUM;
	
	//FPROCDOPL.mask = "#####.##";
}

function calcAll()
{
	Enable(FKLCTS);

	var mFsppogr	= oMetLoad.getCod();
	var mFrab = oDopRab.getCod();
	var mFcargo = 0;
	var mFgrkl	= 0;
	var mFgrdor = 0;
	var mFgruz = 0;
	var mFhod	= 0;
	var tkm = 0;
	var mFcts = 0;
	var mFsumAll = 0;
	var mFdopl = 0;
	var mFskl = 0;
	var mFprkl = 0;
	
	switch (oWorkType.get("FWORK"))
	{
		case AVTO_WORKTYPE_RUN:
			oMod.setCod(oWorkType.get("FMODEL"));
			// кол-во ходок
			mFhod		= Number(FHOD.getValue());
			mFgruz	= Number(FGRUZ.getValue());
			mFgrdor	= Number(FGRDOR.getValue());
			mFcargo	= oMod.get("FGRUZPOD");
			//1) Класс груза
			//если ввели значение вручную то не пересчитываем
			if (!noCalcKl)
			{
				if (mFgruz != 0)
				{
					// Грузоподъемность
					if (mFcargo != 0)
					{
						var koef = mFcargo / (mFgruz / mFhod);
						if (koef < AVTO_KLASKOEF_GRUZ2)
						{
							mFgrkl = 1;
						}
						else
						{
							if (koef < AVTO_KLASKOEF_GRUZ3)
							{
								mFgrkl = 2;
							}
							else
							{
								if (koef < AVTO_KLASKOEF_GRUZ4)
								{
									mFgrkl = 3;
								}
								else
								{
									mFgrkl = 4;
								}
							}
						}
					}
				} //if(mFgruz!=0)
				FGRKL.value		= mFgrkl;

				//запомним последнее расчитаное значение
				oldValofKl = FGRKL.value;
			}
			else
			{
				mFgrkl = FGRKL.value;
			}

			//2) Пробег всего
			mFprobg	= Number(FPROBG.value);
			mFprob0	= Number(FPROB0.value);
			mFprob		= mFprobg + mFprob0;
			FPROB.value	= mFprob;
			// Перевезено тонно-километров
			tkm	= mFprobg / mFhod * mFgruz;
			npr	= oWorkType.get("FNORM_100KM");	//Норма на 100 км пробiгу, л
			ntkm	= oWorkType.get("FNORM_100TKM");	//Норма на 100 т/км, л
			//3) Топливо по норме
			//3.1) на линейные нормы
			mFkolf_km		= mFprob / 100 * npr;
			//3.2) на тонно-километры
			mFkolf_tkm		= tkm / 100 * ntkm;
			mFkolf			= mFkolf_km + mFkolf_tkm;
			FKOLF.value		= mFkolf;
			break;
		case AVTO_WORKTYPE_SPEC:
			//3) Спецоборуд
			oEdi.setCod(oWorkType.get("FEDI"));
			oEdi.assocDpText(FEDOBL);
			mFkolobl	= FKOLOBL.value;
			// Нормы
			mFnobl	= oWorkType.get("FNORM_FUEL");	//Норма на роботу спецобл., л
			FNOBL.value	= mFnobl;
			//3) Топливо по норме
			//3.1) на работу спецоборудования
			mFkolf_ob		= mFnobl * mFkolobl;
			mFkolf			= mFkolf_ob;
			FKOLF.value		= mFkolf;
			break;
	}

	//4) Время
	//4.1) в движении
	mTdv				= Number(FCDV.value) * 60 + Number(FMDV.value);
	//4.2) простой на линии
	mTlin				= Number(FCLIN.value) * 60 + Number(FMLIN.value);
	mTlinWithProc		= mTlin*Number(FPROCTIMELIN.value)/100;
	//4.3) простой без оплаты
	mTbopl			= Number(FCBOPL.value) * 60 + Number(FMBOPL.value);
	//4.4) простой на ремонте
	mTrem				= Number(FCREM.value) * 60 + Number(FMREM.value);
	mTremWithProc		= mTrem*Number(FPROCTIMEREM.value)/100;
	//4.5) Время всего
	mTtot				= mTdv + mTlin + mTbopl + mTrem;
	mFctot			= Math.floor(mTtot / 60);
	mFmtot			= mTtot - mFctot * 60;

	FDTOT.value		= Number(FDDV.value) + Number(FDLIN.value) + Number(FDBOPL.value) + Number(FDREM.value);
	FCTOT.value		= mFctot;
	FMTOT.value		= mFmtot;

	mFvopl			= FVOPL.value;
	mGtz = extPar.objAvto.get("FGROUP");

	oAvto.setVar("FCLASS", mFgrkl);
	oAvto.setVar("FVANT", mFcargo);
	oAvto.setVar("FGRDOR", mFgrdor);
	oAvto.setVar("FGROUPTS", mGtz);
	oAvto.setVar("FSPPOGR", mFsppogr);
	oAvto.setVar("FDOPRAB", mFrab);
	switch (oWorkType.get("FQUOTTYPE"))
	{
		case AVTO_QUOTTYPE_QUOT:
			mFcts = oWorkType.get("FQUOT");
			break;
		case AVTO_QUOTTYPE_CAT:
			oCat.setCod(oWorkType.get("FCATEGORY"));
			mFcts = getRascRazr(oCat.getCod(), extPar.doc_dat);
			break;
	}
	
	//проц. классности
	mFprkl= Number(FKLPROC.getValue());
	
	//если в настройке указано поле ЛС для классности 
	//то выберем суму в доплатах которую нужно включить 
	//в базовую суму для расчета класности 
	var addSum4kl = 0;
	if(isKlassn)
	{
		strSQL = "SELECT SUM(FSUM)" 
				+" FROM "+tmpTblDopl
				+" WHERE 1=1"
					+" AND FID_DOC = "+sqlTo(obj.getID())
					+" AND FISKLASSN = "+sqlTrue;
		var sn = getSnap(strSQL);
		if(sn)
		{
			addSum4kl = isEmpty(sn[0]) ? 0 : sn[0];
		}
	}
	
	//Установим ЧТС и ЧТС для классности
	FKLCTS.setValue(mFcts);
	FCTS.setValue(mFcts);
		
	//-------ДОП. РАБОТА------------------
	//Вытянем расценку за дополнительную работу
	var mFrdop	= Number(FRDOP.getValue());
		
	//и посчитаем сумму за дополнительную работы
	var mFsdop	= round(mFrdop * Number(FKOLDOP.getValue()), 2);
	FSDOP.setValue(mFsdop);
	//----------------------------------------
	
	//--------ЗА ГРУЗ------------------------
	//Вытянем расценку за груз
	var mFrt		= Number(FRT.getValue());
	
	//и посчитаем сумму за груз
	var mFst	= round(mFgruz / 10 * mFrt, 2);
	FST.setValue(mFst);
	//----------------------------------------
	
	switch (String(mFvopl))
	{
		case "TKM":
			//Расценки
			//За 10 тонно-километров
			mFrtkm		= oAvto.getRascTkm();
			FRTKM.value	= mFrtkm == null ? 0 : mFrtkm;
				
			//Суммы ЗП
			//За 10 тонно-километров
			mFstkm	= round(tkm / 10 * mFrtkm, 2);
			FSTKM.value	= mFstkm == null ? 0 : mFstkm;
						
			//доплата
			var mFdopl = 0;
									
			//За классность
			mFskl	= round((mFcts * (mTdv + mTlinWithProc + mTremWithProc) / 60 + addSum4kl) * mFprkl / 100, 2);
			FKLSUM.setValue(mFskl);
			
			//Всего
			mFsum		= round(Number(FSTKM.value) + Number(FST.value) + Number(FSDOP.value) + Number(FKLSUM.value), 2);
			mFsumAll	= mFsum;
		break;
		case "GTS":

			FRSD.value = 0;
			FKOLSD.value = 0;
			FSSD.value = 0;

			Enable(FEDSD, false);
			Enable(FRSD, false);
			Enable(FKOLSD, false);
			
			//сумма по чтс
			mFscts	= round((mTdv + mTlinWithProc + mTremWithProc) / 60 * mFcts, 2);
			FCTSSUM.setValue(mFscts);
			
			//За классность
			mFskl			= round((mFscts + addSum4kl) * mFprkl / 100, 2);
			FKLSUM.setValue(mFskl);
			
			//Всего
			mFsum		= mFscts + mFdopl + mFskl + mFst + mFsdop;
			mFsumAll	= mFsum;
		break;
		case "VIDR":
			//при сдельной оплате классность не считаем
			FKLCTS.setValue(0);
			FKLSUM.setValue(0);
			Disable(FKLCTS);

			Enable(FEDSD);
			Enable(FRSD);
			Enable(FKOLSD);
						
			//За дополнительные работы
			mFrdop = oAvto.getRascDopr();
			FRDOP.value	= mFrdop == null ? 0: mFrdop;

			if (isEmpty(FKOLSD.value))
			{
				FKOLSD.value = (mTdv + mTlin * (FPROCTIMELIN.value/100)) / 60;
			}

			mFsum = FRSD.value * FKOLSD.value;
			FSSD.value	= mFsum;
			
			mFsumAll = mFsum + mFdopl + mFst + mFsdop;
		break;
	}
		
	//сумы доплат 
	strSQL = "SELECT SUM(FSUM)" 
				+" FROM "+tmpTblDopl
				+" WHERE 1=1"
					+" AND FID_DOC = "+sqlTo(obj.getID())
	var sn = getSnap(strSQL);
	
	if(sn != null && !isEmpty(sn[0]))
	{
		mFdopl = sn[0];
	}
	FSDOPL.setValue(mFdopl);
	FSUM.setValue(mFsumAll+mFdopl);

	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RTYPE", AVTO_WAYBILL_TYPE_FACT);
	obj.setVar("RUSER_CL", sprUser);
	obj.setVar("REDSD", oEdiSD.getCod());
	obj.setVar("RLSFIDKLASSN", oLsKlassn.getFid());
	if(oFrom)
		obj.setVar("RFROM", oFrom.getTxt());
	if(oTo)
		obj.setVar("RTO", oTo.getTxt());
	//при сохранении нужно узнать код ШПЗ и записать в таблицу 
	//для этого используем объект DpShifPZ
	var par = {};
		par.clPodr = sprUser;
		par.clGaluz = sprZatr;
		par.clZatr = 3; 		//статьи затрат
		par.clAvto = getPar(const_AVTOTRANSPORT);
		par.codAvto = oAvto.getVar("FAVTO");
	if(!useShpz)
	{	
		var oShpz = new DpShifPZ("",par);
		oShpz.setObj(oZatr);
		oShpz.setObj(oUser);
		obj.setVar("RSHPZ", oShpz.save());
	}
	else
	{
		obj.setVar("RSHPZ", dpShifPZ.getFshpz());
	}
			
	saveRows(clasDopl);
}

//сохрарение строк для доплат и помощников
function saveRows(clas)
{
	var tmpTbl;
	var workTbl;
	var ID = obj.getID();
	
	switch (clas)
	{
		case clasDopl:
			tmpTbl = tmpTblDopl;
			workTbl = tblDopl;
			break;
		/*
		case clasHelp:
			tmpTbl = tmpTblHelp;
			workTbl = tblHelp;
			break;
		*/
	}
	
	ExecuteSQL("DELETE FROM "+ workTbl +" WHERE FID_DOC = " + sqlTo(ID));
	ExecuteSQL("UPDATE " + tmpTbl + " SET FID_DOC=" + sqlTo(ID));
	ExecuteSQL("INSERT INTO "+ workTbl + " SELECT * FROM " + tmpTbl);
	return true;
}
include("sys\\DpBaseDlg.js");