include("objects/DpCl.js");
include("avto:AVTO_const.js");
include("objects/DpShtat.js");
include("servis/date.js");

var obj = extPar.dpObj;
var oTabn;
var baseSum = extPar.bsum;
var doc_dat = extPar.doc_dat;

//параметры папки
var _pers_zaval = obj.parent.parent.getPar("_pers_zaval");
var sprPers = obj.parent.parent.getPar("_codpers");

function onLoad()
{
	Caption(ru("Помощники", "Помічники")	+": "+ modeName(extPar.mode));
	
	//маски
	FWORK.mask = replicate("&", 300);
	FDAY.mask = "##";
	FHOUR.mask = "##.#";
	FPROC.mask = "###.##";
	FGTS.mask = "###.##";
	FSUM.mask = MASK_SUM;
		
	ctrlLinker = new DpCtrlLinker(obj);	
	
	// помошник (какой объект смотрим в настр. папки)
	switch (_pers_zaval)
	{	
		case 0:
			oTabn = new DpShtat("", new Date(doc_dat), new Date(doc_dat));
			oTabn.zavalInAllShtat = true;
			oTabn.linkCtrl("fcod", FTABN);
			setValid(FTABN, FTABN_valid);
			break;
		
		case 1:
			oTabn = new DpCl();
			oTabn.setClcl(sprPers)
			oTabn.linkCtrl(FTABN, FTABN_TXT);
			break;
		default: 
			alert(ru("Этот режим справочника персонала не предусмотрен!"
					, "Цей режим довідника персоналу не передбачено!"));
	}
	ctrlLinker.addClLink("RTABN", 	oTabn);
	
	/*
	oZatr = new DpCl("", getPar(const_GETPAR_ZATR), 0);
	oZatr.linkSmartCtrl(FGALUZ);
	ctrlLinker.addClLink("RGALUZ", oZatr);
	*/	
	ctrlLinker.addLink("RWORK", FWORK);
	ctrlLinker.addLink("RVOPL", FVOPL);
	ctrlLinker.addLink("RDAY", FDAY);
	ctrlLinker.addLink("RHOUR", FHOUR);
	ctrlLinker.addLink("RPROC", FPROC);
	ctrlLinker.addLink("RGTS", FGTS);
	ctrlLinker.addLink("RSUM", FSUM);
	
	//ctrlLinker.updateData(false);
	ctrlLinker.toControls();
	
	//при создании новой строки отрасль затр. берем такую как у основного тракториста
	/*
	if(extPar.mode == "ADD")
	{
		oZatr.setCod(Number(extPar.galuz));
	}
	*/
	FTABN_valid()
	calcSum();
	
	setValid(FVOPL, calcSum)
	setValid(FGTS, calcSum)
	setValid(FPROC, calcSum)
}

function onSave()
{
	ctrlLinker.toVars();
	//obj.setVar("RLSFID",oLs.getFid());
}

function calcSum()
{
	var mFsum = 0;
	var mFvopl = String(FVOPL.getValue());
	var ret = true;
	
	switch (mFvopl)
	{
		case "PRC":
			ISPROC.setVisible(true);
			ISGTS.setVisible(false);
			Disable(FSUM);
			
			mFsum = round(baseSum * Number(FPROC.getValue()), 2);
			FSUM.setValue(mFsum);
			break;
		case "FIX":
			ISPROC.setVisible(false);
			ISGTS.setVisible(false);
			Enable(FSUM);
			break;
		case "GTS":
			ISPROC.setVisible(false);
			ISGTS.setVisible(true);
			Disable(FSUM);
			
			//какое время учитывать берем из настройки папки. 
			//0 - часы
			//1 - дни
			if(extPar.time == 1)
			{
				mFtime = Number(FDAY.getValue());
			}
			else
			{
				mFtime = Number(FHOUR.getValue())
			}
			
			mFsum = round(mFtime * Number(FGTS.getValue()), 2);
			FSUM.setValue(mFsum);
			break;
	}
	
	if(isSaving() && isEmpty(Number(FSUM.getValue())))
	{
		FSUM.showErr(ru("Сумма равна нулю...", "Сума рівна нулю..."));
		ret = false;
	}
	
	return ret;
}

function FTABN_valid()
{
	//если oTabn это штатное расписание то сами опдейтим текстовое поле
	if(oTabn instanceof DpShtat == true)
	{
		FTABN_TXT.setValue(oTabn.getEmployeSurname());
	}
	return true;
}

include("sys/DpBaseDlg.js");