include("objects\\DpGetDat.js");
include("objects\\DpTVars.js");
include("objects\\DpCl.js");
include("sys/udfs.js");
include("avto:servis/avto_tools.js");
include("avto:calcOverRun.js");

var gd, d1, d2, d, de, vCl;
var h, tbl, tv;
var scl;
var vSetStr;
var tblAvto = getTmpTableName();
function onLoad()
{
//	Caption('Облік витрат пального');
	gd = new DpGetDat("dDl");
	if(!gd.escape)
		calcLKV();
}

function init()
{
	d1 = gd.dat1;
	d2 = gd.dat2;
	vCl = gd.fcod;//temp
	ExecuteSQL("CREATE TABLE " + tblAvto + "(FDATE "+SqlType("DateTime")
					+", FNOMPUTL "+SqlType("TEXT")
					+", FNOMAVTO "+SqlType("DOUBLE")
					+", FDRIVER "+SqlType("DOUBLE")
					+", FTABDRIVER "+SqlType("DOUBLE")
					+", FPROBIG "+SqlType("DOUBLE")
					+", FVYKON "+SqlType("DOUBLE") //Виконано
					+", FZALPV "+SqlType("DOUBLE")//ЗАлишок при виїзді
					+", FOTR "+SqlType("DOUBLE")  //Отримано при виїзді
					+", FPOV "+SqlType("DOUBLE")  //Повернено
					+", FZALPP "+SqlType("DOUBLE")  //ЗАлишок після повернення
					+", FNORMA "+SqlType("DOUBLE")
					+", FFAKT "+SqlType("DOUBLE")
					+", FEKONOM "+SqlType("DOUBLE")
					+", FVYTR "+SqlType("DOUBLE")
					+", FTT "+SqlType("INTEGER")
					+", FWID "+SqlType("COUNTER")+")"); 
	return true;
}

function showXlsDoc(prnPat)//вывод документа
{
	tv = new DpTVars(prnPat);
	tbl = OpenTable("Select * From " + tblAvto);
	var strFuel = "";
	strSQL = "select DISTINCT T.FFUEL from (^WAYBILL H INNER JOIN ^RFUEL T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
				+ " Where H.FDOC_DAT BETWEEN "+sqlTo(d1)+" and " +sqlTo(d2)
				+ " AND H.FAVTO = " + sqlTo(vCl)
				+ " AND T.FTYPE = " + sqlTo(AVTO_NMK_FUEL);
	var tFuel = OpenTable("s", strSQL);
	for (; !tFuel.IsEOF(); tFuel.MoveNext())
	{
		strFuel = strFuel+tcl('NMK','TXT',tFuel.getValue("FFUEL"))+", "
	}
	if (strFuel != "")
	{
		strFuel = strFuel.substr(0, strFuel.length-2);
	}
	tFuel.close(5652);
	tFuel = null;
	var hSnap = getSnap("select FMODEL, FNUM, FGARAGE_NUM from ^CL_AVTO where FCOD = " + vCl);
	h = new Object();
	h.FBDATE = d1;
	h.FEDATE = d2;
	h.FMODEL = hSnap[0];
	h.FNUM = hSnap[1];
	h.FGARAGE_NUM = hSnap[2];
	h.FCHEL = vCl;
	h.FFUEL = strFuel;
	tv.setHTbl(h);
	tv.setRTbl(tbl);
	tv.print();
}

function listInitGetDatParam(par)
{
	par.Fcl = getPar("AVTOTRANSPORT");
}

function calcLKV()
{
	if(!init())
		return false;
	var vStr = "Insert Into " + tblAvto + " (FDATE, FNOMPUTL, FNOMAVTO, FDRIVER, FPROBIG, FOTR, FPOV, FZALPP, FZALPV, FTT) Select "
				+ " FDOC_DAT, FDOC_NUM, FAVTO, FDRIVER, FEDISTANCE-FBDISTANCE  as FPROBIG, "
				+ " 0 AS FOTR, 0, 0 AS FZALPP, 0 AS FZALPV, 0 as FTT From ^WAYBILL " 
				+ " Where FDOC_DAT BETWEEN "+sqlTo(d1)+" and " +sqlTo(d2)
				+ " and FAVTO = " + sqlTo(vCl);
	ExecuteSQL(vStr);
	
	tr = OpenTable("m","SELECT * From " + tblAvto);
	for(tr.MoveFirst();!tr.IsEOF();tr.MoveNext())
	{
		strSQL = "SELECT SUM(T.FBFUEL), SUM(T.FEFUEL), SUM(T.FFUEL_DESK) "
				+" FROM (^WAYBILL H INNER JOIN ^RFUEL T ON (H.FWID = T.FID_DOC AND H.FDOC = 'avto:com.debet.avto')) "
				+" WHERE T.FTYPE = " + sqlTo(AVTO_NMK_FUEL)
				+" AND H.FDOC_NUM = " + sqlTo(tr.getValue("FNOMPUTL"))
				+" AND H.FDOC_DAT = " + sqlTo(tr.getValue("FDATE"))
				+" AND H.FAVTO = " + sqlTo(tr.getValue("FNOMAVTO"))
				+" AND H.FDRIVER = " + sqlTo(tr.getValue("FDRIVER"))
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			tr.Edit();
			tr.setValue("FZALPV", sn[0]);
			tr.setValue("FZALPP", sn[1]);
			tr.setValue("FOTR", sn[2]);
			tr.Update();
		}
		sn = null;
		var result = 0;
		var overrun_value = 0;
		var m = calcOverRun(tr, "^RWAYBILL", "^RFUEL");
		strSQL = "select a.FCALC_KSUM, a.FCALC_KOB"
			+ " from ^WAYBILL a "
			+" WHERE 1=1"
			+" AND a.FDOC_NUM = " + sqlTo(tr.getValue("FNOMPUTL"))
			+" AND a.FDOC_DAT = " + sqlTo(tr.getValue("FDATE"))
			+" AND a.FAVTO = " + sqlTo(tr.getValue("FNOMAVTO"))
			+" AND a.FDRIVER = " + sqlTo(tr.getValue("FDRIVER"))
		var oSnap = getSnap(strSQL);
		if (oSnap != null && oSnap[0] != null && oSnap[1] != null)
		{
			result = Math.round((m.Hs * (1 + 0.01 * Number(oSnap[0])) + m.Hob * (1 + 0.01 * Number(oSnap[0])))*1000)/1000;
			overrun_value = Math.round((m.fuelQty) * 1000) / 1000;
		}
		if(result>overrun_value){
			vSetStr =",FEKONOM = " + (result-overrun_value);
		}else if(result<overrun_value){
			vSetStr =",FVYTR = " + (-result+overrun_value);
		}else {
			vSetStr ="";
		}
		ExecuteSQL("UPDATE " + tblAvto + " set FNORMA = " + result +", FFAKT = " + overrun_value
					+ vSetStr +" where FWID = " + tr.getValue("FWID"));	
	}
	var addSumStr = "Insert Into " + tblAvto + " (FNORMA, FFAKT, FEKONOM, FVYTR, FTT) Select "
				+ " SUM(a.FNORMA) as FNORMA, SUM(a.FFAKT) as FFAKT, SUM(a.FEKONOM)as FEKONOM,"
				+ " SUM(a.FVYTR) as FVYTR,1 as FTT  From "
				+ tblAvto + " a Group By a.FNOMAVTO";
	ExecuteSQL(addSumStr);
	//browse("Select * From " + tblAvto);
	showXlsDoc("avto:AVTO_KUG");
}

if (GetMenuMode() == "RUN")
	onLoad();

include("sys\\DpBaseDlg.js");