include("installApi.js");
include("Objects\\DpAskEx.js");
include("Objects\\DpClEx.js");
var arrUpd = new Array();
var sCod, sParName, sVid, sText;
var arrCod, arrCodDef, arrParName, arrVid, arrText;
var tblSprav = "AVTO_SPRAV_TBL";

function installAvto()
{
	//справочники аналитики
	sCod = "301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319"
	arrCodDef = sCod.split(", ");
	sParName = "AVTO_MODEL, AVTO_FUELTYPE, AVTO_WORKTYPE"
			+", AVTO_WORKTIME, AVTO_CATEGORY, AVTO_SGMASH"
			+", AVTO_TIRETYPE, AVTO_TIRESIZE, AVTO_AKKUMUL, AVTO_GROUPTS"
			+", AVTO_TYPE, AVTO_MARSHRUT, AVTOTRANSPORT, AVTO_TIREPRODUCER"
			+", AVTO_AKKUMULPRODUCER, AVTO_TRAILER, AVTO_DOPRAB, AVTO_METHODLOADING, AVTO_RASCTKM"
	arrParName = sParName.split(", ");
	if (!IsTable(tblSprav))
	{
		// Значит запускаем первый раз и не смотрим в параметры
		ExecuteSQL(" CREATE TABLE "+tblSprav
		+" (FWID "+SqlType("COUNTER")
		+", FCOD_OUT "+SqlType("LONG")
		+", FCOD_IN "+SqlType("LONG")
		+", FVID "+SqlType("TEXT", 254)+")");
		arrCod = arrCodDef;
	}
	else
	{
		arrCod = new Array();
		for (var i in arrParName)
		{
			arrCod[i] = (!isEmpty(getPar(arrParName[i])) ? getPar(arrParName[i]) : Number(arrCodDef[i]));
		}
	}
	sVid = "avto:com.debet.clcl.markcar, avto:com.debet.clcl.fueltype, avto:com.debet.clcl.worktype"
			+", 1, avto:com.debet.clcl.rascrazr, 1, 1, avto:com.debet.clcl.tiresize"
			+", avto:com.debet.clcl.akkum, 1, 1, avto:com.debet.clcl.marshrut, avto:com.debet.clcl.avto"
			+", 1, 1, avto:com.debet.clcl.trailer, avto:com.debet.clcl.rascdopr, avto:com.debet.clcl.rasc10t, avto:com.debet.clcl.rasc10tkm";
	arrVid = sVid.split(", ");
	sText = "Авто:Марки авто|Авто:Марки авто"
			+", Авто:Види пального|Авто:Виды топлива"
			+", Авто:Види робіт|Авто:Виды работ"
			+", Авто:Час виконання робіт|Авто:Время выполнения работ"
			+", Авто:Розцінки за розрядами|Авто:Расценки по разрядам"
			+", Авто:С/г машини|Авто:С/х машины"
			+", Авто:Типи шин|Авто:Типы шин"
			+", Авто:Розміри шин|Авто:Размеры шин"
			+", Авто:Акумулятори|Авто:Аккумуляторы"
			+", Авто:Групи транспортних засобів|Авто:Группы транспортных средств"
			+", Авто:Види транспортних засобів|Авто:Виды транспортных средств"
			+", Авто:Маршрути|Авто:Маршруты"
			+", Авто:Транспортні засоби|Авто:Транспортные средства"
			+", Авто:Виробники шин|Авто:Производители шин"
			+", Авто:Виробники акумуляторів|Авто:Производители аккумуляторов"
			+", Авто:Причепи|Авто:Прицепы"
			+", Авто:Розцінки за додаткові роботи|Авто:Расценки за дополнительные работы"
			+", Авто:Розцінки за тонни|Авто:Расценки за тонны"
			+", Авто:Розцінки за т/км|Авто:Расценки за т/км"
	arrText = sText.split(", ");
	var oA = new DpAskEx();
	oA.useDefsOnly = true;
	strCombo = ru("Переименовать", "Переіменувати")+"|"+ru("Пропустить", "Пропустити")+"|"
			+ru("Заменить", "Замінити")+"|"+ru("Создать новый", "Створити новий");
	for (i in arrParName)
	{
		strSQL = "SELECT FTXT, FVID FROM ^CLCL WHERE FCOD = " + sqlTo(Number(arrCod[i]));
		var sn = getSnap(strSQL);
		var strText = "";
		var strTyp = "";
		if (sn != null && sn[0] != null)
		{
			strText = sn[0];
			strTyp = sn[1];
			var strRem = UR("Існує: |Существует: ")+arrCod[i]+" "+UR(strText)+(strTyp != "" ? " Тип: "+strTyp : "");
			strName = UR("Потрібно: |Нужно: ")+UR(arrText[i])+" Тип: "+arrVid[i];
			oA.add("REM", strRem, "MREM"+i);
			var ind = 3;
			if (UR(arrText[i])==UR(strText) && arrVid[i]==strTyp)
			{
				ind = 1;
			}
			else if (UR(arrText[i])!=UR(strText) && arrVid[i]==strTyp)
			{
				ind = 0;
			}
			else if (UR(arrText[i])==UR(strText) && arrVid[i]!=strTyp)
			{
				ind = 2;
			}
			oA.add("COMBO", strName, "SPR"+i, ind, strCombo);
		}
		sn = null;
	}
	if(!oA.doAsk() && oA.hasVisibleControls)
	{
		return false;
	}
	for (i in arrParName)
	{
		var action = oA.get("SPR"+i);
		if (action == null)
		{
			installCLAvto(arrCod[i], arrParName[i], arrVid[i], arrText[i]);
			setPar(arrParName[i], arrCod[i]);
		}
		else
		{
			switch (action)
			{
				case 0:
					strSQL = "UPDATE ^CLCL SET FTXT = " + sqlTo(UR(arrText[i]))
							+" WHERE FCOD = " + sqlTo(Number(arrCod[i]));
					ExecuteSQL(strSQL);
					setPar(arrParName[i], arrCod[i]);
					break;
				case 1:
					break;
				case 2:
					installCLAvto(arrCod[i], arrParName[i], arrVid[i], arrText[i]);
					setPar(arrParName[i], arrCod[i]);
					break;
				case 3:
					installCLAvto(0, arrParName[i], arrVid[i], arrText[i]);
					break;
			}
		}
		strSQL = "SELECT FWID FROM "+tblSprav
			+" WHERE FCOD_OUT = "+sqlTo(Number(arrCodDef[i]))
		var sn = getSnap(strSQL);
		var m = new Object();
		if (sn != null && sn[0] != null)
		{
			m.FWID = sn[0];
		}
		m.FCOD_OUT = Number(arrCodDef[i]);
		m.FCOD_IN = getPar(arrParName[i]);
		m.FVID = arrVid[i];
		updateTable(tblSprav, m, !(sn != null && sn[0] != null));
		sn = null;
	}
	
	//обновление всех таблиц в dbstru.xml
	include("upd:objects\\DpUpdate.js");
	var oUpd = new DpUpdate();
	oUpd.UDD_modiStru4module("avto");
	oUpd = null;
	
	//добавление росширения в справочник персонала 
	//% - классности для водителя
	//+++++++++++++++++++++++++++++++++++++++++
	var sprPers = getPar("CODPERS");
	
	include("objects\\DpExtentionBuilder.js");
	var extBuilder = new DpExtentionBuilder("CL", String(sprPers), null);
	extBuilder.load();
	
	var ID = GetUID();
	var m = new Object();
	m.Fwid = ID;
	m.Fwidth = 7;
	m.Fclass = extBuilder.FCLASS;
	m.Ftxt = "% "+ru("Классности для водителей", "Класності для водіїв");
	var sn = getSnap("SELECT MAX(FPOS) FROM ^CL_EXT WHERE FCLASS = "+sqlTo(m.Fclass));
	m.Fpos = (sn !=null && !isEmpty(sn[0]) ? sn[0]+1 : 1);
	m.FISCHECK = false;
	m.Fisculc = false;
	m.Fformat = "%3.2f";
	m.Flabel = "PRKL";
	m.Fused = true;
	m.Ftype = "FLOAT";
	m.Fcomment = "";
	m.Fsubclass = null;
		
	UpdateTable(extBuilder.getInfoTableName(), m, true);
	
	m.Fdefault = 0;
	extBuilder.commitStructure()
	extBuilder.save(m);
	//+++++++++++++++++++++++++++++++++++++++++
	
	//теперь все справочники начинатся с №301
	//поэтому удалим старые справочники модуля avto
	//ExecuteSQL("DELETE FROM ^CLCL WHERE FCOD IN(241,242,243)");
	
	//формирование итогов для сводов
	lpProxy.doItogsIn(rootDirectoryEx() + "Source/itog.xml");
	
	//impClAvto();
	return true;
}

function installCLAvto(cod, parName, vid, txt)
{
	cod = Number(cod);
	if (cod==0)
	{
		installCL(parName, vid, txt);
	}
	else
	{
		// сначала почистим
		// удалить надо из CL, CLRELCLCL и если есть из других таблиц
		strSQL = "SELECT FVID FROM ^CLCL WHERE FCOD = " + sqlTo(cod);
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			var oldVid = sn[0];
			// так как заменяем, нам без разницы было там что-то или нет
			var oCL = new DpClEx(oldVid, cod);
		    var arrTbl = new Array();
		    var mapper = oCL.jObj.getDefaultMapper();
		    if (!mapper) 
			{
		        return;
		    }
		    var aTables = mapper.getTables();
		    for (var i = 0; i < Number(aTables.size()); i++) 
			{
		        if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
				{
					arrTbl[arrTbl.length] = String(aTables.get(i).name);
				}
		    }
		    var aTables = mapper.getRowsTables();
		    for (var i = 0; i < Number(aTables.size()); i++) 
			{
		        if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
				{
					arrTbl[arrTbl.length] = String(aTables.get(i).name);
				}
		    }
			if (oldVid == "avto:com.debet.clcl.avto")
			{
				arrTbl[arrTbl.length] = "CL_AVTO_TIRES_RUNS";
			}
			// почистим таблицы
			for (var i in arrTbl)
			{
				strSQL = "DELETE FROM ^"+arrTbl[i]
						+" WHERE FWID_CL IN (SELECT FWID_CL FROM ^CLRELCLCL "
								+" WHERE FCL = "+sqlTo(cod)+")"
				ExecuteSQL(strSQL);
			}
			// удалим с CL
			strSQL = "DELETE FROM ^CL"
					+" WHERE FWID IN (SELECT FWID_CL FROM ^CLRELCLCL "
							+" WHERE FCL = "+sqlTo(cod)+")"
			ExecuteSQL(strSQL);			
			// удалим с CLRELCLCL
			strSQL = "DELETE FROM ^CLRELCLCL"
					+" WHERE FCL = "+sqlTo(cod)
			ExecuteSQL(strSQL);	
			// теперь удалим из класификатора
			strSQL = "DELETE FROM ^CLCL"
					+" WHERE FCOD = "+sqlTo(cod)
			ExecuteSQL(strSQL);				
		}
		else
		{
			// не было у нас такого справочника 
		}
		sn = null;
		// теперь добавим
		var oCL = new DpClEx(vid, cod);
/*		var arrTbl = new Array();
		var mapper = oCL.jObj.getDefaultMapper();
		if (!mapper) 
		{
			return;
		}
		var aTables = mapper.getTables();
		for (var i = 0; i < Number(aTables.size()); i++) 
		{
			if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
			{
				arrTbl[arrTbl.length] = String(aTables.get(i).name);
			}
		}
		var aTables = mapper.getRowsTables();
		for (var i = 0; i < Number(aTables.size()); i++) 
		{
			if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
			{
				arrTbl[arrTbl.length] = String(aTables.get(i).name);
			}
		}
		if (vid == "avto:com.debet.clcl.avto")
		{
			arrTbl[arrTbl.length] = "CL_AVTO_TIRES_RUNS";
		}
		//сначала промодифицируем таблицы плагинов
		for (var ind in arrTbl)
		{
			arrUpd[arrUpd.length] = arrTbl[ind];
		}
		*/
		// теперь добавим в класификатор
		var m	= new Object();
		m.Ftxt	= txt;
		m.Fcod	= cod;
		m.Fvid	= vid;
		m.FWID	= GetUID();		
		m.Frel	= 0;	
		updateTable("^CLCL", m, true);		
	}
}

function impClAvto()
{
	//Импорт строк справочника из XML-файлов
	//Имя файла имеет формат:
	//CL<вид справочника>_<номер справочника>_<FWID строки>.xml
	
	include("objects\\DpAskEx.js");
	oA = new DpAskEx();

	oA.setCaption("Встановіть директорію імпорту|Установите директорию импорта"); 
	oA.add("DIR", "Директорія імпорту|Директория импорта", "PATH", getPar("IMPDIR"));
	if(oA.doAsk())
	{
		var sDir = oA.get("PATH");
		//надо, чтоб директория не оканчивалась слешем
		sDir = sDir.replace(/[\\\/]$/, "");
		var oDir = new DpFile(sDir);
		
		if(oDir.exists() && oDir.isDirectory())	//проверка на существование директории
		{
			//объект-фильтр
			//массив файлов для импорта
			fa = 	oDir.listFiles();
			var recCnt = fa.length;
			var c = 0;
			if(recCnt > 0)
			{
				var progress = createProgressDialog(recCnt);
				progress.getShell().setText(ru("Импорт данных...", "Імпорт даних..."));
				var oTbl = OpenTable("s", tblSprav);
				for (; !oTbl.IsEOF(); oTbl.MoveNext())
				{
					var sClass = oTbl.getValue("FVID");
					var Fcl = oTbl.getValue("FCOD_OUT");
					var Fcl_in = oTbl.getValue("FCOD_IN");
					//alert(sClass+" "+Fcl_in)
					//префикс имен создаваемых файлов
					var sFileNamePrefix = sClass+"_"+Fcl.toString()+"_";
					sFileNamePrefix = sFileNamePrefix.replace(/:/gi, "_"); 
					oObj = new DpClEx(sClass, Fcl_in);
					oObj.getJObject().setVar("HCL", Fcl_in);
					oObj.getJObject().setNomCl(Fcl_in);
					oObj.nCl = Fcl_in;

					var sFileName, sFilePath, oFile;
					var arrTbl = new Array();
					var mapper = oObj.jObj.getDefaultMapper();
					if (!mapper) 
					{
						return;
					}
					var aTables = mapper.getTables();
					for (var i = 0; i < Number(aTables.size()); i++) 
					{
						if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
						{
							arrTbl[arrTbl.length] = String(aTables.get(i).name);
						}
					}
				    var aTables = mapper.getRowsTables();
				    for (var i = 0; i < Number(aTables.size()); i++) 
					{
				        if (!inList(String(aTables.get(i).name), "CL", "CLRELCLCL"))
						{
							arrTbl[arrTbl.length] = String(aTables.get(i).name);
						}
				    }
					if (sClass == "avto:com.debet.clcl.avto")
					{
						arrTbl[arrTbl.length] = "CL_AVTO_TIRES_RUNS";
					}
					
					for(var nIndex in fa)
					{
						var re = new RegExp(sFileNamePrefix+"[0-9]+\.xml", "ig")
						oFile = fa[nIndex];
						sFileName = oFile.getName();
						if(!re.test(sFileName))
						{
							continue;
						}
						sFilePath = oFile.getAbsolutePath();

						oObj.clear();
						oObj.jObj.loadFromXML(sFilePath);
						oObj.nCl = Fcl_in;
						oObj.getJObject().setVar("HCL", Fcl_in);
						oObj.getJObject().setNomCl(Fcl_in);
						oObj.saveExtToDB();
						var objID = oObj.jObj.getObjectID();
						// почистим таблицы, где этот objID = FOUTID в таблицах - данные обновятся,
						// а незатрагиваемое останется
						strSQL = " SELECT FWID "
								+" FROM ^CL "
								+" WHERE FOUTID = " + sqlTo(String(objID))
						var sn = getSnap(strSQL);
						if (sn != null && sn[0] != null)
						{
							strSQL = " DELETE FROM ^CLRELCLCL WHERE FWID_CL = " + sqlTo(sn[0])
							ExecuteSQL(strSQL);

							strSQL = " DELETE FROM ^CL WHERE FWID = " + sqlTo(sn[0])
							ExecuteSQL(strSQL);
							
							for (var i in arrTbl)
							{
								strSQL = " DELETE FROM ^"+arrTbl[i]+" WHERE FWID_CL = " + sqlTo(sn[0])
								ExecuteSQL(strSQL);
							}
						}
						obj2DB(objID, oObj.jObj);
						oObj.saveRows();
						var mFwid = GetUID();

						// перебьем идентификаторы
						strSQL = " UPDATE ^CLRELCLCL "
								+" SET FWID_CL = " + sqlTo(mFwid)
								+" WHERE FWID_CL = " + sqlTo(objID)
						ExecuteSQL(strSQL);

						strSQL = " UPDATE ^CL "
								+" SET  FWID = " + sqlTo(mFwid)
									+", FOUTID = " + sqlTo(String(objID))
								+" WHERE FWID = " + sqlTo(objID)
						ExecuteSQL(strSQL);
						for (var i in arrTbl)
						{
							strSQL = " UPDATE ^"+arrTbl[i]
									+" SET FWID_CL = " + sqlTo(mFwid)
									+" WHERE FWID_CL = " + sqlTo(objID)
							ExecuteSQL(strSQL);
						}

						if (progress)
						{
							progress.getProgressMonitor().worked(1);
							progress.getProgressMonitor().setTaskName("Записано "+ ++c + " из " + recCnt + " записей");
						}
					}
				}

				if (progress)
				{
					progress.getProgressMonitor().done();
					progress.close();
				}
				
			}
		}
		else
		{
			var strMsg = ru("Директория "+sDir+" не существует"
			, "Директорія "+sDir+" не існує");
			alert(strMsg);
		}
	}
}

function createProgressDialog(recCnt)
{
	var progress = new Packages.org.eclipse.jface.dialogs.ProgressMonitorDialog(Packages.org.eclipse.swt.widgets.Display.getCurrent().getActiveShell());
	progress.open();
	progress.getProgressMonitor().beginTask("", recCnt);
	progress.getShell().setText(UR(""));
	return progress;
}