include("avto:AVTO_const.js");
include("Objects\\DpUpdate.js");
include("installApi.js");
include("installAvto.js");
var avto_const_spr_avtotransport;
var avto_const_spr_model;
var avto_const_spr_fueltype;
var avto_const_spr_worktime;
/*function Load()
{
	beforeUpdate();
	afterUpdate();
}*/

function beforeUpdate()
{
	avto_const_spr_avtotransport = getPar(const_AVTOTRANSPORT);
	avto_const_spr_model = getPar(const_GETPAR_MODEL);
	avto_const_spr_fueltype = getPar(const_GETPAR_FUELTYPE);
	avto_const_spr_worktime = getPar(const_GETPAR_WORKTIME);
	if (IsTable("TMP_CL_AVTO"))
	{
		DropTable("TMP_CL_AVTO");
	}
	if (IsTable("TMP_WAYBILL"))
	{
		DropTable("TMP_WAYBILL");
	}
	if (IsTable("TMP_CL_AVTO2FUEL_RATE"))
	{
		DropTable("TMP_CL_AVTO2FUEL_RATE");
	}
	strSQL = "SELECT * INTO TMP_CL_AVTO "
			+" FROM ^CL_AVTO "
	ExecuteSQL(strSQL);		
	strSQL = "SELECT * INTO TMP_WAYBILL "
			+" FROM ^WAYBILL "
	ExecuteSQL(strSQL);		
	strSQL = "SELECT * INTO TMP_CL_AVTO2FUEL_RATE "
			+" FROM ^CL_AVTO2FUEL_RATE "
	ExecuteSQL(strSQL);		
}
var sprAvto, sprModel, sprFuelType, sprWorkTime, sprWorkType, sprTrailer;
var tmpFuel = "TMP_FYELTYPE_TBL";
function afterUpdate()
{
	var sFLD = getColumn("TMP_CL_AVTO", false);
	if (sFLD.indexOf("FGROUP") != -1)
	{
		// уже перенесли, больше не будем
		return true;
	}
	installAvto();
	// перенесем данные в справочники, если поменялись номера
	var arrBef = new Array(avto_const_spr_avtotransport, avto_const_spr_model, avto_const_spr_fueltype, avto_const_spr_worktime);
	sprAvto = getPar(const_AVTOTRANSPORT);
	sprModel = getPar(const_GETPAR_MODEL);
	sprFuelType = getPar(const_GETPAR_FUELTYPE);
	sprWorkTime = getPar(const_GETPAR_WORKTIME);
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprTrailer = getPar(const_GETPAR_TRAILER);
	var arrAft = new Array(sprAvto, sprModel, sprFuelType, sprWorkTime);
	for (var i in arrBef)
	{
		if (arrAft[i] != arrBef[i])
		{
			strSQL = "UPDATE ^CLRELCLCL SET FCL = "+sqlTo(arrAft[i])
				+" WHERE FCL = " + sqlTo(arrBef[i])
			ExecuteSQL(strSQL);
		}
	}
	// занесем виды топлива
	makeFuelType(tmpFuel);
	// занесем виды работ
	makeWorkType();
	makeWayBill();
	//CloseWindow();
	return

}

function makeFuelType(tmpFuel)
{
	DropTable(tmpFuel);
	if (IsTable(tmpFuel))
	{
		ExecuteSQL("DELETE FROM "+tmpFuel);
	}
	else
	{
		strSQL = "CREATE TABLE "+tmpFuel+"("
					+" FFUEL_TYPE "+SqlType("LONG")
					+", FFUEL "+SqlType("LONG")
					+", FMOTOR_OIL "+SqlType("LONG")
					+", FTRANSMISSION_OIL "+SqlType("LONG")
					+", FSPECIAL_OIL "+SqlType("LONG")
					+", FPLASTIC_LUBRICATION "+SqlType("LONG")
					+", FCOD "+SqlType("LONG")
					+", FWID "+SqlType("COUNTER")+")"
		ExecuteSQL(strSQL);
	}
	strSQL ="INSERT INTO " + tmpFuel +"(FFUEL_TYPE, FFUEL, FMOTOR_OIL, FTRANSMISSION_OIL, FSPECIAL_OIL, FPLASTIC_LUBRICATION, FCOD)" 
			+" SELECT DISTINCT B.FFUEL_TYPE "
			+", A.FFUEL, A.FMOTOR_OIL, A.FTRANSMISSION_OIL, A.FSPECIAL_OIL, A.FPLASTIC_LUBRICATION, 0 AS FCOD "
			+ " from TMP_CL_AVTO a LEFT JOIN TMP_CL_AVTO2FUEL_RATE b on a.fmodel = b.fcod"
	ExecuteSQL(strSQL);
	strSQL ="INSERT INTO " + tmpFuel +"(FFUEL_TYPE, FFUEL, FMOTOR_OIL, FTRANSMISSION_OIL, FSPECIAL_OIL, FPLASTIC_LUBRICATION, FCOD)"
			+" SELECT DISTINCT B.FFUEL_TYPE2 AS FFUEL_TYPE"
			+", A.FFUEL2 AS FFUEL, A.FMOTOR_OIL2 AS FMOTOR_OIL"
			+", A.FTRANSMISSION_OIL2 AS FTRANSMISSION_OIL, A.FSPECIAL_OIL2 AS FSPECIAL_OIL"
			+", A.FPLASTIC_LUBRICATION2 AS FPLASTIC_LUBRICATION, 0 AS FCOD"
			+ " from TMP_CL_AVTO a LEFT JOIN TMP_CL_AVTO2FUEL_RATE b on a.fmodel = b.fcod"
			+" WHERE NOT FWID IN "
				+"(SELECT FWID FROM "+tmpFuel+" F "
					+" WHERE B.FFUEL_TYPE2 = F.FFUEL_TYPE"
					+" AND A.FMOTOR_OIL2 = F.FMOTOR_OIL"
					+" AND A.FTRANSMISSION_OIL2 = F.FTRANSMISSION_OIL"
					+" AND A.FSPECIAL_OIL2 = F.FSPECIAL_OIL"
					+" AND A.FPLASTIC_LUBRICATION2 = F.FPLASTIC_LUBRICATION"
					+" AND A.FFUEL2 = F.FFUEL"
				+")"
	ExecuteSQL(strSQL);
	var tFuel = OpenTable("s", tmpFuel);
	for (; !tFuel.IsEOF(); tFuel.MoveNext())
	{
		strSQL = "SELECT REL.FCOD"
			+" FROM ^CLRELCLCL REL LEFT JOIN ^CL_FUELTYPE F ON (REL.FWID_CL = F.FWID_CL AND REL.FCL = "+sqlTo(sprFuelType)+")"
			+" WHERE REL.FCOD = "+sqlTo(tFuel.getValue("FFUEL_TYPE"))
			+" AND (F.FMOTOR_OIL <> "+sqlTo(tFuel.getValue("FMOTOR_OIL"))
			+" OR F.FTRANSMISSION_OIL <> "+sqlTo(tFuel.getValue("FTRANSMISSION_OIL"))
			+" OR F.FSPECIAL_OIL <> "+sqlTo(tFuel.getValue("FSPECIAL_OIL"))
			+" OR F.FPLASTIC_LUBRICATION <> "+sqlTo(tFuel.getValue("FPLASTIC_LUBRICATION"))
			+" OR F.FFUEL <> "+sqlTo(tFuel.getValue("FFUEL"))
			+")"
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			// уже есть с таким номером будем добавлять новый
			var mFcod = getNextClCod(sprFuelType);
			strSQL = "SELECT CL.FTXT FROM ^CLRELCLCL REL INNER JOIN ^CL CL ON (REL.FWID_CL = CL.FWID AND REL.FCL = "+sqlTo(sprFuelType)+")"
				+" WHERE REL.FCOD = "+sqlTo(tFuel.getValue("FFUEL_TYPE"))
			var sn1 = getSnap(strSQL);
			var mFtxt = sn1[0];
			sn1 = null;
			strSQL = "SELECT FVID FROM ^CLCL"
				+" WHERE FCOD = "+sqlTo(sprFuelType)
			var sn1 = getSnap(strSQL);
			var mFvid = sn1[0];
			sn1 = null;			
			var mFwid = GetUID();
			var mObj = new Object();
			mObj.HTXT = mFtxt;
			mObj.HFUEL = tFuel.getValue("FFUEL")
			mObj.HMOTOR_OIL = tFuel.getValue("FMOTOR_OIL")
			mObj.HTRANSMISSION_OIL = tFuel.getValue("FTRANSMISSION_OIL")
			mObj.HSPECIAL_OIL = tFuel.getValue("FSPECIAL_OIL")
			mObj.HPLASTIC_LUBRICATION = tFuel.getValue("FPLASTIC_LUBRICATION")
			addCL(mFvid, sprFuelType, mFcod, mObj);
		}
		else
		{
			strSQL = "SELECT FWID_CL FROM ^CLRELCLCL "
					+" WHERE FCL = "+sqlTo(sprFuelType)
					+" AND FCOD = "+sqlTo(tFuel.getValue("FFUEL_TYPE"))
			var sn1 = getSnap(strSQL);
			if (sn1 != null && sn1[0] != null)
			{
				//
				strSQL = "INSERT INTO ^CL_FUELTYPE (FFUEL, FMOTOR_OIL, FTRANSMISSION_OIL, FSPECIAL_OIL, FPLASTIC_LUBRICATION, FWID_CL)"
					+" VALUES(" + sqlTo(tFuel.getValue("FFUEL"))
					+" , " + sqlTo(tFuel.getValue("FMOTOR_OIL"))
					+" , " + sqlTo(tFuel.getValue("FTRANSMISSION_OIL"))
					+" , " + sqlTo(tFuel.getValue("FSPECIAL_OIL"))
					+" , " + sqlTo(tFuel.getValue("FPLASTIC_LUBRICATION"))
					+" , " + sqlTo(sn1[0])
					+")"
				ExecuteSQL(strSQL);
			}
			var mFcod = tFuel.getValue("FFUEL_TYPE");	
		}
		sn = null;
		tFuel.Edit();
		tFuel.setValue("FCOD", mFcod);
		tFuel.Update();
	}
	tFuel.close(5652);
	tFuel = null;
	return tmpFuel;
}

function makeWorkType()
{
	strSQL = "SELECT * FROM TMP_CL_AVTO2FUEL_RATE ORDER BY FCOD"
	tModel = OpenTable("s", strSQL);
	for (; !tModel.IsEOF(); tModel.MoveNext())
	{
		// соберем автомобили, в которых стоит эта модель
		strSQL = "SELECT FCOD, FFUEL, FMOTOR_OIL, FTRANSMISSION_OIL, FSPECIAL_OIL, FPLASTIC_LUBRICATION"
				+", FFUEL2, FMOTOR_OIL2, FTRANSMISSION_OIL2, FSPECIAL_OIL2, FPLASTIC_LUBRICATION2, FSUM_HOUR, FSUM_ED, FWID_CL"
				+" FROM TMP_CL_AVTO WHERE FMODEL = " + sqlTo(tModel.getValue("FCOD"))
				+" ORDER BY FCOD"
		var tCar = OpenTable("s", strSQL);
		for (; !tCar.IsEOF(); tCar.MoveNext())
		{
			var mFcodMar = tModel.getValue("FAVTO");
			strSQL = "SELECT A.FCOD"
				+" FROM TMP_CL_AVTO A LEFT JOIN TMP_CL_AVTO2FUEL_RATE B ON A.FMODEL = B.FCOD "
				+" WHERE B.FCOD = "+sqlTo(tModel.getValue("FCOD"))
				+" AND A.FCOD < "+sqlTo(tCar.getValue("FCOD"))
				+" AND (( B.FFUEL_TYPE = " + sqlTo(tModel.getValue("FFUEL_TYPE"))
				+" AND (A.FMOTOR_OIL <> "+sqlTo(tCar.getValue("FMOTOR_OIL"))
				+" OR A.FTRANSMISSION_OIL <> "+sqlTo(tCar.getValue("FTRANSMISSION_OIL"))
				+" OR A.FSPECIAL_OIL <> "+sqlTo(tCar.getValue("FSPECIAL_OIL"))
				+" OR A.FPLASTIC_LUBRICATION <> "+sqlTo(tCar.getValue("FPLASTIC_LUBRICATION"))
				+" OR A.FFUEL <> "+sqlTo(tCar.getValue("FFUEL"))
				+"))"
				+" OR ( B.FFUEL_TYPE2 = " + sqlTo(tModel.getValue("FFUEL_TYPE2"))
				+" AND (A.FMOTOR_OIL2 <> "+sqlTo(tCar.getValue("FMOTOR_OIL2"))
				+" OR A.FTRANSMISSION_OIL2 <> "+sqlTo(tCar.getValue("FTRANSMISSION_OIL2"))
				+" OR A.FSPECIAL_OIL2 <> "+sqlTo(tCar.getValue("FSPECIAL_OIL2"))
				+" OR A.FPLASTIC_LUBRICATION2 <> "+sqlTo(tCar.getValue("FPLASTIC_LUBRICATION2"))
				+" OR A.FFUEL2 <> "+sqlTo(tCar.getValue("FFUEL2"))
				+"))"
				+")"
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				mFcodMar = getNextClCod(sprModel);
				strSQL = "SELECT FVID FROM ^CLCL"
					+" WHERE FCOD = "+sqlTo(sprModel)
				var sn1 = getSnap(strSQL);
				var mFvid = sn1[0];
				sn1 = null;			
				strSQL = " SELECT CL.FTXT "
					+" FROM ^CLRELCLCL REL INNER JOIN ^CL CL ON (REL.FWID_CL = CL.FWID AND REL.FCL = "+sqlTo(sprModel)+")"
					+" WHERE REL.FCOD = " +sqlTo(tModel.getValue("FAVTO"))
				var sn1 = getSnap(strSQL);
				var mFtxt = sn1[0];
				sn1 = null;			
				// МАРКИ авто
				var mObj = new Object();
				mObj.HTXT = mFtxt;
				addCL(mFvid, sprModel, mFcodMar, mObj);
			}
			// ВИДЫ РАБОТ
			strSQL = "SELECT FVID FROM ^CLCL"
				+" WHERE FCOD = "+sqlTo(sprWorkType)
			var sn1 = getSnap(strSQL);
			var mFvid = sn1[0];
			sn1 = null;			
			strSQL = " SELECT CL.FTXT "
				+" FROM ^CLRELCLCL REL INNER JOIN ^CL CL ON (REL.FWID_CL = CL.FWID AND REL.FCL = "+sqlTo(sprModel)+")"
				+" WHERE REL.FCOD = " +sqlTo(mFcodMar)
			var sn1 = getSnap(strSQL);
			var mFtxt = sn1[0];
			sn1 = null;			
			var mObj = new Object();
			mObj.HTXT = mFtxt;
			mObj.HWORK = AVTO_WORKTYPE_RUN;
			mObj.HMODEL = mFcodMar;
			mObj.HQUOTTYPE = AVTO_QUOTTYPE_QUOT;
			mObj.HQUOT = tCar.getValue("FSUM_HOUR");

			// 1) по первому топливу
			var mFcodFuel = 0;
			strSQL = "SELECT FCOD FROM "+tmpFuel
				+" WHERE FFUEL_TYPE = " + sqlTo(tModel.getValue("FFUEL_TYPE"))
				+" AND FFUEL = " + sqlTo(tCar.getValue("FFUEL"))
				+" AND FMOTOR_OIL = " + sqlTo(tCar.getValue("FMOTOR_OIL"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tCar.getValue("FTRANSMISSION_OIL"))
				+" AND FSPECIAL_OIL = " + sqlTo(tCar.getValue("FSPECIAL_OIL"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tCar.getValue("FPLASTIC_LUBRICATION"))
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				mFcodFuel = sn[0];
			}
			sn = null;
			strSQL = "SELECT REL.FCOD FROM ^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT "
				+" ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+")"
				+" WHERE WT.FFUEL = " + sqlTo(mFcodFuel)
				+" AND FWORK = " + sqlTo(AVTO_WORKTYPE_RUN)
				+" AND FMODEL = " + sqlTo(mFcodMar)
				+" AND FMOTOR_OIL = " + sqlTo(tModel.getValue("FMOTOR_OIL"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tModel.getValue("FTRANSMISSION_OIL"))
				+" AND FSPECIAL_OIL = " + sqlTo(tModel.getValue("FSPECIAL_OIL"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tModel.getValue("FPLASTIC_LUBRICATION"))
				+" AND FNORM_100KM = " + sqlTo(tModel.getValue("FPETROL"))
				+" AND FQUOTTYPE = " + sqlTo(AVTO_QUOTTYPE_QUOT)
				+" AND FQUOT = " + sqlTo(tCar.getValue("FSUM_HOUR"))
			var oSnap = getSnap(strSQL)
			if (oSnap != null && oSnap[0] != null)
			{
				var mFcod = oSnap[0];
			}
			else
			{
				var mFcod = getNextClCod(sprWorkType);
				mObj.HFUEL = mFcodFuel;
				mObj.HMOTOR_OIL = tModel.getValue("FMOTOR_OIL");
				mObj.HTRANSMISSION_OIL = tModel.getValue("FTRANSMISSION_OIL");
				mObj.HSPECIAL_OIL = tModel.getValue("FSPECIAL_OIL");
				mObj.HPLASTIC_LUBRICATION = tModel.getValue("FPLASTIC_LUBRICATION");
				mObj.HNORM_100KM = tModel.getValue("FPETROL");
				addCL(mFvid, sprWorkType, mFcod, mObj);			
			}
			oSnap = null;
			// запишем в CL_AVTO_WORK
			strSQL = "INSERT INTO ^CL_AVTO_WORK (FWID, FWID_CL, FCOD) "
				+" VALUES ("
				+sqlTo(GetUID())
				+", "+sqlTo(tCar.getValue("FWID_CL"))
				+", "+sqlTo(mFcod)
				+")"
			ExecuteSQL(strSQL)
			// запишем в CL_AVTO
			strSQL = "UPDATE ^CL_AVTO "
				+" SET FMODEL = " + sqlTo(mFcodMar)
				+" WHERE FCOD = " + sqlTo(tCar.getValue("FCOD"))
			ExecuteSQL(strSQL)
			// 2) по спецоборудованию
			strSQL = "SELECT REL.FCOD FROM ^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT "
				+" ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+")"
				+" WHERE WT.FFUEL = " + sqlTo(mFcodFuel)
				+" AND FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
				+" AND FMODEL = " + sqlTo(mFcodMar)
				+" AND FMOTOR_OIL = " + sqlTo(tModel.getValue("FMOTOR_OIL"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tModel.getValue("FTRANSMISSION_OIL"))
				+" AND FSPECIAL_OIL = " + sqlTo(tModel.getValue("FSPECIAL_OIL"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tModel.getValue("FPLASTIC_LUBRICATION"))
				+" AND FNORM_FUEL = " + sqlTo(tModel.getValue("FWORKING_PETROL"))
				+" AND FQUOTTYPE = " + sqlTo(AVTO_QUOTTYPE_QUOT)
				+" AND FQUOT = " + sqlTo(tCar.getValue("FSUM_ED"))
			var oSnap = getSnap(strSQL)
			if (oSnap != null && oSnap[0] != null)
			{
				var mFcod = oSnap[0];
			}
			else
			{
				var mFcod = getNextClCod(sprWorkType);
				mObj.HFUEL = mFcodFuel;
				mObj.HMOTOR_OIL = tModel.getValue("FMOTOR_OIL2");
				mObj.HTRANSMISSION_OIL = tModel.getValue("FTRANSMISSION_OIL2");
				mObj.HSPECIAL_OIL = tModel.getValue("FSPECIAL_OIL2");
				mObj.HPLASTIC_LUBRICATION = tModel.getValue("FPLASTIC_LUBRICATION2");
				mObj.HNORM_FUEL = tModel.getValue("FWORKING_PETROL");
				mObj.HWORK = AVTO_WORKTYPE_SPEC;
				mObj.HNORM_100KM = 0;
				mObj.HEDI = 1;
				mObj.HQUOT = tCar.getValue("FSUM_ED");
				addCL(mFvid, sprWorkType, mFcod, mObj);			
			}
			oSnap = null;
			// запишем в CL_AVTO
			strSQL = "INSERT INTO ^CL_AVTO_WORK (FWID, FWID_CL, FCOD) "
				+" VALUES ("
				+sqlTo(GetUID())
				+", "+sqlTo(tCar.getValue("FWID_CL"))
				+", "+sqlTo(mFcod)
				+")"
			ExecuteSQL(strSQL)
			// 3) по второму топливу
			strSQL = "SELECT FCOD FROM "+tmpFuel
				+" WHERE FFUEL_TYPE = " + sqlTo(tModel.getValue("FFUEL_TYPE2"))
				+" AND FFUEL = " + sqlTo(tCar.getValue("FFUEL2"))
				+" AND FMOTOR_OIL = " + sqlTo(tCar.getValue("FMOTOR_OIL2"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tCar.getValue("FTRANSMISSION_OIL2"))
				+" AND FSPECIAL_OIL = " + sqlTo(tCar.getValue("FSPECIAL_OIL2"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tCar.getValue("FPLASTIC_LUBRICATION2"))
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				mFcodFuel = sn[0];
			}
			sn = null;
			strSQL = "SELECT REL.FCOD FROM ^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT "
				+" ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+")"
				+" WHERE WT.FFUEL = " + sqlTo(mFcodFuel)
				+" AND FWORK = " + sqlTo(AVTO_WORKTYPE_RUN)
				+" AND FMODEL = " + sqlTo(mFcodMar)
				+" AND FMOTOR_OIL = " + sqlTo(tModel.getValue("FMOTOR_OIL2"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tModel.getValue("FTRANSMISSION_OIL2"))
				+" AND FSPECIAL_OIL = " + sqlTo(tModel.getValue("FSPECIAL_OIL2"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tModel.getValue("FPLASTIC_LUBRICATION2"))
				+" AND FNORM_100KM = " + sqlTo(tModel.getValue("FPETROL2"))
				+" AND FQUOTTYPE = " + sqlTo(AVTO_QUOTTYPE_QUOT)
				+" AND FQUOT = " + sqlTo(tCar.getValue("FSUM_HOUR"))
			var oSnap = getSnap(strSQL)
			if (oSnap != null && oSnap[0] != null)
			{
				var mFcod = oSnap[0];
			}
			else
			{
				var mFcod = getNextClCod(sprWorkType);
				mObj.HFUEL = mFcodFuel;
				mObj.HMOTOR_OIL = tModel.getValue("FMOTOR_OIL2");
				mObj.HTRANSMISSION_OIL = tModel.getValue("FTRANSMISSION_OIL2");
				mObj.HSPECIAL_OIL = tModel.getValue("FSPECIAL_OIL2");
				mObj.HPLASTIC_LUBRICATION = tModel.getValue("FPLASTIC_LUBRICATION2");
				mObj.HNORM_100KM = tModel.getValue("FPETROL2");
				mObj.HNORM_FUEL = 0;
				mObj.HEDI = 0;
				mObj.HWORK = AVTO_WORKTYPE_RUN;
				mObj.HQUOT = tCar.getValue("FSUM_HOUR");
				addCL(mFvid, sprWorkType, mFcod, mObj);			
			}
			oSnap = null;
			// запишем в CL_AVTO
			strSQL = "INSERT INTO ^CL_AVTO_WORK (FWID, FWID_CL, FCOD) "
				+" VALUES ("
				+sqlTo(GetUID())
				+", "+sqlTo(tCar.getValue("FWID_CL"))
				+", "+sqlTo(mFcod)
				+")"
			ExecuteSQL(strSQL)
			// 4) по спецоборудованию
			strSQL = "SELECT REL.FCOD FROM ^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT "
				+" ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+")"
				+" WHERE WT.FFUEL = " + sqlTo(mFcodFuel)
				+" AND FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
				+" AND FMODEL = " + sqlTo(mFcodMar)
				+" AND FMOTOR_OIL = " + sqlTo(tModel.getValue("FMOTOR_OIL2"))
				+" AND FTRANSMISSION_OIL = " + sqlTo(tModel.getValue("FTRANSMISSION_OIL2"))
				+" AND FSPECIAL_OIL = " + sqlTo(tModel.getValue("FSPECIAL_OIL2"))
				+" AND FPLASTIC_LUBRICATION = " + sqlTo(tModel.getValue("FPLASTIC_LUBRICATION2"))
				+" AND FNORM_FUEL = " + sqlTo(tModel.getValue("FWORKING_PETROL"))
				+" AND FQUOTTYPE = " + sqlTo(AVTO_QUOTTYPE_QUOT)
				+" AND FQUOT = " + sqlTo(tCar.getValue("FSUM_ED"))
			var oSnap = getSnap(strSQL)
			if (oSnap != null && oSnap[0] != null)
			{
				var mFcod = oSnap[0];
			}
			else
			{
				var mFcod = getNextClCod(sprWorkType);
				mObj.HFUEL = mFcodFuel;
				mObj.HMOTOR_OIL = tModel.getValue("FMOTOR_OIL2");
				mObj.HTRANSMISSION_OIL = tModel.getValue("FTRANSMISSION_OIL2");
				mObj.HSPECIAL_OIL = tModel.getValue("FSPECIAL_OIL2");
				mObj.HPLASTIC_LUBRICATION = tModel.getValue("FPLASTIC_LUBRICATION2");
				mObj.HNORM_FUEL = tModel.getValue("FWORKING_PETROL");
				mObj.HWORK = AVTO_WORKTYPE_SPEC;
				mObj.HNORM_100KM = 0;
				mObj.HEDI = 1;
				mObj.HQUOT = tCar.getValue("FSUM_ED");
				addCL(mFvid, sprWorkType, mFcod, mObj);			
			}
			oSnap = null;
			// запишем в CL_AVTO
			strSQL = "INSERT INTO ^CL_AVTO_WORK (FWID, FWID_CL, FCOD) "
				+" VALUES ("
				+sqlTo(GetUID())
				+", "+sqlTo(tCar.getValue("FWID_CL"))
				+", "+sqlTo(mFcod)
				+")"
			ExecuteSQL(strSQL)
		}
		tCar.close(5652);
		tCar = null;
	}
	tModel.close(5652);
	tModel = null;
}

function makeWayBill()
{
	var tmpTrailer = getTmpTableName();
	// сначала перенесем прицепы ( если они есть ) в справочник прицепов
	strSQL = "SELECT DISTINCT FTRAILER1 AS FTRAILER INTO "+tmpTrailer
		+" FROM TMP_WAYBILL "
		+" WHERE FTRAILER1 <> 0 "
		+" AND NOT FTRAILER1 IS NULL "
	ExecuteSQL(strSQL);
	strSQL = "INSERT INTO "+tmpTrailer+" (FTRAILER) "
		+" SELECT DISTINCT FTRAILER2 AS FTRAILER "
		+" FROM TMP_WAYBILL "
		+" WHERE FTRAILER2 <> 0 "
		+" AND NOT FTRAILER2 IS NULL "
		+" AND NOT FTRAILER2 IN (SELECT FTRAILER FROM "+tmpTrailer+")"
	ExecuteSQL(strSQL);
	include("Objects/DpClEx.js");
	var tTrailer = OpenTable("s", tmpTrailer);
	var vidAvto = "";
	var vidTrailer = "";
	var strSQL = "SELECT T1.FVID AS FVID1, T2.FVID AS FVID2 FROM ^CLCL T1, ^CLCL T2 "
		+" WHERE T1.FCOD = " + sqlTo(sprAvto) 
		+" AND T2.FCOD = " + sqlTo(sprTrailer) 
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		vidAvto = sn[0];
		vidTrailer = sn[1];
	}
	sn = null;
	for (; !tTrailer.IsEOF(); tTrailer.MoveNext())
	{
		var oCLAvto = new DpClEx(vidAvto, sprAvto);
		strSQL = "SELECT FWID_CL FROM ^CLRELCLCL "
			+" WHERE FCL = "+sqlTo(sprAvto)
			+" AND FCOD = "+sqlTo(tTrailer.getValue("FTRAILER"))
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			oCLAvto.loadByID(sn[0]);
		}
		sn = null;
		var oCLTrailer = new DpClEx(vidTrailer, sprTrailer);
		oCLTrailer.setVar("HCOD", tTrailer.getValue("FTRAILER"));
		oCLTrailer.setVar("HTXT", oCLAvto.getVar("HTXT"));
		oCLTrailer.setVar("HMARKA", oCLAvto.getVar("HMODEL"));
		oCLTrailer.setVar("HGARNOM", oCLAvto.getVar("HGARAGE_NUM"));
		oCLTrailer.setVar("HGOSNOM", oCLAvto.getVar("HNUM"));
		oCLTrailer.save("ADD");
	}
	tTrailer.close(5652);
	tTrailer = null;
	// теперь добавим строки к документам
	// соберем виды топлива
	var strFrom = " FROM TMP_WAYBILL W LEFT JOIN "
			+"(((^CL_AVTO_WORK AW INNER JOIN ^CLRELCLCL REL "
			+" ON (REL.FWID_CL=AW.FWID_CL AND REL.FCL = "+sqlTo(sprAvto)+"))"
				+" LEFT JOIN (^CLRELCLCL REL1 INNER JOIN ^CL_WORKTYPE WT "
					+" ON (REL1.FWID_CL=WT.FWID_CL AND REL1.FCL = "+sqlTo(sprWorkType)+"))"
						+" ON AW.FCOD = REL1.FCOD )"
				+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
					+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
				+" ON REL.FCOD = W.FAVTO"
							
	var tmpNmk = getTmpTableName();
	// топливо
	strSQL = " SELECT Distinct FT.FFUEL AS FNMKL, "+sqlTo(AVTO_NMK_FUEL)+" AS FTYPE, W.FAVTO, W.FWID, W.FDOC  "
				+" INTO "+tmpNmk
				+strFrom
	ExecuteSQL(strSQL);
	// масло моторное
	strSQL = "INSERT INTO "+tmpNmk+"(FNMKL, FTYPE, FAVTO, FWID, FDOC)"
				+" SELECT Distinct FT.FMOTOR_OIL AS FNMKL, "+sqlTo(AVTO_NMK_MOTOR)+" AS FTYPE , W.FAVTO, W.FWID, W.FDOC  "
				+strFrom
	ExecuteSQL(strSQL);
	// масло трансмиссионное
	strSQL = "INSERT INTO "+tmpNmk+"(FNMKL, FTYPE, FAVTO, FWID, FDOC)"
				+" SELECT Distinct FT.FTRANSMISSION_OIL AS FNMKL, "+sqlTo(AVTO_NMK_TRMIS)+" AS FTYPE , W.FAVTO, W.FWID, W.FDOC  "
				+strFrom
	ExecuteSQL(strSQL);
	// масло специальное
	strSQL = "INSERT INTO "+tmpNmk+"(FNMKL, FTYPE, FAVTO, FWID, FDOC)"
				+" SELECT Distinct FT.FSPECIAL_OIL AS FNMKL, "+sqlTo(AVTO_NMK_SPEC)+" AS FTYPE , W.FAVTO, W.FWID, W.FDOC  "
				+strFrom
	ExecuteSQL(strSQL);
	// смазка пластичная
	strSQL = "INSERT INTO "+tmpNmk+"(FNMKL, FTYPE, FAVTO, FWID, FDOC)"
				+" SELECT Distinct FT.FPLASTIC_LUBRICATION AS FNMKL, "+sqlTo(AVTO_NMK_PLLUB)+" AS FTYPE ,W.FAVTO, W.FWID, W.FDOC  "
				+strFrom
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO ^RFUEL(FFUEL, FID_DOC, FDOC, FTYPE)"
				+" SELECT DISTINCT FNMKL AS FFUEL, FWID AS FID_DOC, FDOC, FTYPE "
				+" FROM "+tmpNmk
	ExecuteSQL(strSQL);			

	var tFuel = OpenTable("s","^RFUEL");
	for(; !tFuel.IsEOF(); tFuel.MoveNext())
	{
		var m = new Object();
		m.FWID = GetUID();
		updateTable("^RFUEL", m, false, "FFUEL = " + sqlTo(tFuel.getValue("FFUEL"))
			+" AND FTYPE = " + sqlTo(tFuel.getValue("FTYPE"))
			+" AND FID_DOC = " + sqlTo(tFuel.getValue("FID_DOC"))
			+" AND FDOC = " + sqlTo(tFuel.getValue("FDOC")))
	}
	tFuel.close(5652);
	tFuel = null;
	// по времени тоже строки
	// будет по одной строке по каждому документу для задания и для того, что сделано
	strSQL = "INSERT INTO ^RWAYBILL (FID_DOC, FDOC, FCDV, FDLIN, FCREM, FCTOT, FBDATE, FEDATE, FTYPE) "
		+" SELECT FWID AS FID_DOC, FDOC, FWORK_H AS FCDV, FWORKOUTAGE_H AS FDLIN, FREPAINT_H AS FCREM"
		+", (FWORK_H+FWORKOUTAGE_H+FREPAINT_H) AS FCTOT, FBDATE, FEDATE, "+sqlTo(AVTO_WAYBILL_TYPE_TASK)+" AS FTYPE"
		+" FROM TMP_WAYBILL"
	ExecuteSQL(strSQL);
	strSQL = "INSERT INTO ^RWAYBILL (FID_DOC, FDOC, FCDV, FDLIN, FCREM, FCTOT, FBDATE, FEDATE, FTYPE) "
		+" SELECT FWID AS FID_DOC, FDOC, FWORK_H AS FCDV, FWORKOUTAGE_H AS FDLIN, FREPAINT_H AS FCREM"
		+", (FWORK_H+FWORKOUTAGE_H+FREPAINT_H) AS FCTOT, FBDATE, FEDATE, "+sqlTo(AVTO_WAYBILL_TYPE_FACT)+" AS FTYPE"
		+" FROM TMP_WAYBILL"
	ExecuteSQL(strSQL);
	var tr = OpenTable("s", "^RWAYBILL");
	for(; !tr.IsEOF(); tr.MoveNext())
	{
		var m = new Object();
		m.FWID = GetUID();
		updateTable("^RWAYBILL", m, false, " FTYPE = " + sqlTo(tr.getValue("FTYPE"))
			+" AND FID_DOC = " + sqlTo(tr.getValue("FID_DOC"))
			+" AND FDOC = " + sqlTo(tr.getValue("FDOC")))	
	}
	tr.close(5652);
	tr = null;	
}

function getNextClCod(nCl)
{
	strSQL = "SELECT MAX(FCOD) FROM ^CLRELCLCL "
		+" WHERE FCL = " + sqlTo(nCl)
	var sn = getSnap(strSQL);
	var mFcod = (sn != null && sn[0] != null ? sn[0] : 0)+1;
	sn = null;
	return mFcod;
}
//include("sys\\DpBaseDlg.js");