include("help:DpHelper.js");
include("help:sys/udfs.js");

var helper = new DpHelper();

function main()
{
	Caption("Замітка|Заметка");
	FORM.setImage(rootDirectoryEx() +"/icons/remark.gif");
	
	this.changing = htmlpage_changing;
	this.completed = htmlpage_completed;
	if(extPar && typeOf(extPar[0])!="DpTask")
	{
		if(extPar.caption)
			Caption(extPar.caption);
		if(extPar.url)
		{
			browser.setURL(extPar.url);
			GRBUTTONS.setVisible(false);
			browser.setLocationHandler(this);
			return;
		}
	}
	FORM.setMessageHandler(helper_refresh, null);
	FORM.setDisposeHandler(onClose);
	
	this.helper_edit = helper_edit;
	this.helper_delete = helper_delete;
	this.helper_info = helper_info;
	this.helper_back = helper_back;
	this.helper_forward = helper_forward;
	this.helper_settings = helper_settings;
	FORM.getDialogBuilder().setToolItemSelection(BBACK, this, "helper_back");
	FORM.getDialogBuilder().setToolItemSelection(BFORW, this, "helper_forward");
	FORM.getDialogBuilder().setToolItemSelection(BEDIT, this, "helper_edit");
	FORM.getDialogBuilder().setToolItemSelection(BDEL, this, "helper_delete");
	FORM.getDialogBuilder().setToolItemSelection(BINFO, this, "helper_info");
	FORM.getDialogBuilder().setToolItemSelection(BSETTINGS, this, "helper_settings");
	
	browser.setLocationHandler(this);
	loadTask();
}

function loadTask()
{
	try
	{
		var task = Task;
		if(extPar)
		{
			if(typeOf(extPar[0])=="DpTask")
			{
				task = extPar[0];
			}
			else if(extPar.task)
			{
				task = extPar.task;
				var sTask = task.getTaskName();
				var sType = task.getTaskType();
				if(extPar.type)
					sType = extPar.type;
				helper_refresh(sType, task);
				return;
			}
		}
		if(task)
		{
			var sTask = task.getTaskName();
			var sType = task.getTaskType();
			if(!sType)
				sType = "info";
			if(helper_enable(sType, sTask))
				helper_refresh(sType, task);
			if(!helper.isblank)
				return;
		}
		setHelperEditable(helper.isedit);
		helper_info();
	}
	catch(ex)
	{
		
	}
}

function helper_refresh(sType, oPar)
{
	try
	{
		if(!oPar)
			return;
		if(sType && sType.startsWith("control:"))
		{
			sType = sType.substring(8);
			helper.setCtrl(sType, oPar);
			setHelperUrl(helper.getURL());
			return;
		}
		if(!oPar.getTaskName)
			return;
		var sTask = oPar.getTaskName();
		if(helper_enable(sType, sTask))
			loadHelper(sType, oPar);
		helper_init_ctrl(sTask);
	}
	catch(ex)
	{
		
	}
}

function loadHelper(sType, task)
{
	helper.setTask(task, sType);
	setHelperUrl(helper.getURL());
}

function setHelperUrl(sURL)
{
	try
	{
		if(browser.getURL()==sURL)
			return;
		if(sURL && helper.refresh)
			browser.setURL(sURL);
	}
	catch(ex){}
}

function helper_enable(sType, sTask)
{
	return helper.isEnable(sType, sTask);
}

function helper_init_ctrl(sTask)
{
	if((helper.ID || sTask=="showHelper") && helper.isedit)
	{
		//BEDIT.setText(UR("Нова замітка|Новая заметка"));
		BEDIT.setText(UR("Додати замітку|Добавить заметку"));
		BDEL.setEnabled(false);
		if(helper.exist)
		{
			BEDIT.setText(UR("Редагувати|Редактировать"));
			if(helper.isuser || helper.dir=="main")
				BDEL.setEnabled(true);
		}
		setHelperEditable(true);
	}
	else
	{
		setHelperEditable(false);
	}
}

function setHelperEditable(bEnable)
{
	GREDIT.setVisible(bEnable);
}

function onClose()
{
	if(lpProxy.isConnected())
		setPar("SHOW_HELPER", false);
}

function helper_back()
{
	browser.getCtrl().back();
	setHelperEditable(false);
}

function helper_forward()
{
	browser.getCtrl().forward();
	setHelperEditable(false);
}

function helper_edit()
{
	helper.edit();
}

function helper_delete()
{
	if(confirm(UR("Видалити замітку |Удалить заметку ") + helper.getID() +" ?"))
		helper.del();
	BDEL.setEnabled(false);
}

function helper_settings()
{
	var task = helper.task;
	var type = helper.type;
	var sURL = browser.getURL();
	//helper.refresh = false;
	helperSettings();
	//helper.refresh = true;
	//if(task)
	//	helper_refresh(type, task);
	browser.setURL(sURL);
}

function helper_close(bAsk)
{
	helper.enable(false);
	FORM.close();
	include("Objects/DpMsgBox.js");
	if(bAsk && confirm(UR("Відкрити вікно для заміток?|Открыть окно для заметок?")))
	{
		showHelper("", Task);
		helper.enable(true);
	}
}

function helper_hide()
{
	helper.enable(false);
	//var wp = lpProxy.getWorkbenchPage();
	//var vr = wp.findViewReference("org.debet.DebetApp.DebetView", "helper");
	//wp.setPartState(vr, 0);
	helper.jHelper.hide();
	if(confirm(UR("Розгорнути вікно для заміток?|Развернуть окно для заметок?")))
		helper.jHelper.restore();
	helper.enable(true);
}

function helper_info()
{
	browser.setURL("file://"+ helper.infoHtml() + helper.getHtmlParams(helper.infoTask));
	//setHelperEditable(false);
}

function showDocList(sDoc)
{
	helper.refresh = false;
	var par = new Object();
	par.doc = sDoc;
	showWindow("l_docekz.xml", SW_NOMODAL, par);
	helper.setTask(lpProxy.getActiveTask(), "l");
	helper_info();
	helper.refresh = true;
}

function showParamList()
{
	helper.refresh = false;
	var par = new Object();
	par.sys = getSystem();
	//par.ret = new Object();
	//par.ret.FGROUP = "";
	showWindow("l_params.xml", SW_NOMODAL, par);
	helper.refresh = true;
}

function helper_keyboad(sKey)
{
	var html = helper.path +"keyboard.html"
	if(sKey)
		html += "?"+ sKey;
	var par = new Object();
	par.url = "file://"+ html;
	par.caption = UR("Клавіатура|Клавиатура");
	helper.enable(false);
	showWindow("help:helper.xml", SW_MODAL, par);
	helper.enable(true);
}

function helper_speedtest()
{
	showWindow("service:speedtest.xml", SW_MODAL, new Object());
}

function helper_opendir(sDir)
{
	helper.enable(false);
	if(!isDir(sDir))
		createDirectory(sDir);
	BrowseForDir(sDir);
	helper.enable(true);
}

function htmlpage_completed()
{
	if(helper.font)
		set_helper_font(helper.font);
}

function set_helper_font(fontSize)
{
	browser.getCtrl().execute("document.getElementById('TEXT')? document.getElementById('TEXT').style.fontSize='"+ fontSize +"' : ''");
}

function htmlpage_changing(ev)
{
	helper.enable(false);
	var loc = String(ev.location);	
	if (loc.startsWith("help:"))
	{	
		ev.doit = false;
		var str = "/org.debet.DebetApp.rcp/html"+ loc.substr(5);
		lpProxy.getWorkbenchWindow().getWorkbench().getHelpSystem().displayHelpResource(str);
	}
	else if (loc.startsWith("docs:"))
	{	
		ev.doit = false;
		var sDocs = loc.substr(6);
		var sPath = rootDirectoryEx() +"Source/docs/";
		if(sDocs.indexOf(":")!=-1)
		{
			var sModule = sDocs.substring(0, sDocs.indexOf(":"));
			sDocs = sDocs.substring(sDocs.indexOf(":")+1);
			sPath = lpProxy.getModulePath(sModule) +"/Source/docs/";
		}
		var sSource = sDocs;
		if(getOS()=="win32" || sDocs.indexOf(".htm")!=-1)
			sSource = sPath + sDocs;
		openSource(sSource);
	}
	else if (loc.startsWith("video:"))
	{	
		ev.doit = false;
		openVideo(loc.substr(6));		
	}
	else if (loc.startsWith("source:"))
	{	
		ev.doit = false;
		openSource(rootDirectoryEx() +"Source"+ loc.substr(7));
	}
	else if (loc.startsWith("task:"))
	{	
		ev.doit = false;
		openTask(loc.substr(5));		
	}
	else if (loc.startsWith("close:"))
	{	
		ev.doit = false;
		FORM.close();
	}
	else if (loc.startsWith("script:"))
	{	
		ev.doit = false;
		var e;
		try
		{
			eval(loc.substr(7));
		}
		catch(e)
		{
			trace("helper.htmlpage_changing: "+ e);
		}
	}
	else if (loc.startsWith("menu:"))
	{	
		ev.doit = false;
		var sMenuID = loc.substr(5);
		if(helper.list)
		{
			var tbl = helper.list.tbl;
			var grid = helper.list.grid;
			helper.enable(false);
			if(grid && !grid.getTableControl().isDisposed() && tbl && !tbl.isEmpty())
				grid.runGridMenu(sMenuID);
			helper.enable(true);
		}
	}
	helper.enable(true);
}

function openSource(sFile)
{
	var file = "";
	var url = sFile;
	var n = url.lastIndexOf("#");
	var anchor = "";
	if (n != -1)
	{
		file = url.substr(0,n);
		anchor = url.substr(n);
	}
	else
	{
		file = url;
	}		
	if (isFile(file))
	{
		file = new DpFile(file);
		url = file.toURI().toString();		
		url +=anchor;
	}
	else
	{
		var urlStr = sFile;
		if(sFile != "")
		{			 
			var n = sFile.lastIndexOf("/");
			if(n!=-1)
				urlStr = sFile.substr(n+1);
			if(urlStr.indexOf(".")!=-1)
				urlStr = urlStr.substr(0, urlStr.indexOf("."));
			//urlStr = java.lang.String(urlStr);
			//urlStr = urlStr.replaceAll(".html", "");
			//urlStr = urlStr.replaceAll(".htm", "");
		}
		if (urlStr)
			url = "http://www.debet.kiev.ua/" + urlStr;
		else
			url = "http://www.debet.kiev.ua/training-materials";
	}
	lpProxy.displayURL(url);
}

function openVideo(sFile)
{
	if(isFile(sFile))
	{
		url = new DpFile(url).toURI().toString();
	}
	else
	{
		if(sFile.endsWith("/"))
			sFile = sFile.substr(0, sFile.length-1);
		if(sFile.indexOf("/")!=-1)
			sFile = sFile.substring(sFile.lastIndexOf("/")+1, sFile.length);
		if(sFile.indexOf(".swf")!=-1)
			sFile = sFile.substring(0, sFile.indexOf(".swf"));
		var url = rootDirectoryEx() +"Source/demoroliki/"+ sFile;
		if (isFile(url + "/"+ sFile + ".swf"))
		{
			url = url + "/"+ sFile + ".swf";
			url = new DpFile(url).toURI().toString();	
		}
		else
		{
			url = "http://www.debet.kiev.ua/"+ sFile;
		}
	}
	lpProxy.displayURL(url);
}

function openTask(sTask)
{
	lpProxy.getMenuManager().execute("l", sTask, "");
}
