include("reports:DpReport.js");

var sTmpTbl = getTmpTableName();
var menuMode = GetMenuMode();

function listLoad()
{
	this.title = UR("Звіти|Отчеты");
	this.editTask = "reports:e_report.xml";
	this.accEdit = accEdit;
	
	FORM.setImage(rootDirectoryEx() +"/icons/Summary-2.gif");
	
	fillSys(FSYS);
	loadReports();
	
	setValid(FSYS, sys_valid);
	setValid(FUSE, sys_valid);
	
	this.gridButtonClick = gridButtonClick;
	grid.setButtonColHandler(this, "gridButtonClick");
	
	if(menuMode=="CALC")
		list.zaval = true;
	if(list.zaval)
		FUSE.checked = true;
	if(extPar && extPar.use!=null)
		FUSE.checked = extPar.use;
}

function accEdit()
{
	var main = list.tbl.getValue("FMAIN");
	if(main==true)
		return "AV";
	return "AEVF";
}

function gridButtonClick(obj, sField, nCol)
{
	var sID = sField.substring(2, sField.length-1);
	var main = list.tbl.getValue("FMAIN");
	if(sID=="EDIT" && main==true)
		sID = "VIEW";
	list.mnuHandler(sID);
	if(sID=="RUN" && list.zaval)
		CloseWindow();	
}

function sys_valid()
{
	list.qryWhere = "1=1";
	if(FUSE.checked)
		list.qryWhere = " FUSE="+ sqlTrue;
	var sys = String(FSYS.value).trim().toUpperCase();
	if(FSYS.value && sys!="")
		list.qryWhere += " and (UPPER(FSYS)="+ sqlTo(sys) +" OR UPPER(FSYS)='COM')";
	list.tblInit();
	if(sys=="")
		Caption(list.title);
	else
		Caption(list.title +": "+ FSYS.getStringValue());
}

function fillSys(oCtrl)
{
	oCtrl.addItem("", UR("Усі|Все"));
	var orgMngr = lpProxy.getOrgManager();
	var sysList = orgMngr.getSysList();
	for(var i=0; i<sysList.size(); i++)
	{
		var sys = sysList.get(i);			
		if(sys)
		{
			var sLabel = sys.label;
			var sName = sys.name;
			var img = sys.iconFile;
			oCtrl.addItem(sLabel, sName);
		}
	}
	if(menuMode!="SETTINGS")
	{
		oCtrl.value = orgMngr.getSys();
		Caption(list.title +": "+ oCtrl.getStringValue());
	}
}

function loadReports()
{
	var sSQL = "create table "+ sTmpTbl 
				+" (FID "+ sqlType("TEXT")
				+", FTXT "+ sqlType("LONGTEXT")
				+", FSYS "+ sqlType("TEXT")
				+", FUSE "+ sqlType("BIT")
				+", FMAIN "+ sqlType("BIT")
				+", FWID "+ sqlType("COUNTER")
				+")";
	ExecuteSQL(sSQL, false);
	
	fillReports(rootDirectoryEx() +"userData/reports/");
	fillReports(rootDirectoryEx() +"modules/reports/scripts/", true);	
}

function fillReports(sPath, bMain)
{
	var mainDir = new java.io.File(sPath);
	if(!mainDir.exists())
		return;
	var listDir = mainDir.listFiles();
	for(var nDir=0; nDir<listDir.length; nDir++)
	{
		var dir = listDir[nDir];
		if(!dir.isDirectory())
			continue;
		var sReport = dir.getName();
		var oSnap = getSnap("select FTXT from "+ sTmpTbl +" where FID="+ sqlTo(sReport));
		if(oSnap)
			continue;
		var oReport = new DpReport(sReport);
		if(!oReport.loadXml())
			continue;
		sSQL = "insert into "+ sTmpTbl +" (FID, FTXT, FSYS, FUSE, FMAIN)"
				+" values ("+ sqlTo(sReport) +", "+ sqlTo(UR(oReport.title)) 
				+", "+ sqlTo(oReport.sys) +", "+ sqlTo(oReport.use)
				+", "+ sqlTo(bMain? bMain : false) 
				+")";
		ExecuteSQL(sSQL);
	}
}

function listSrc()
{
	var	sWhere = "1=1";
	if(FUSE.checked)
		sWhere = " FUSE="+ sqlTrue;
	var sys = String(FSYS.value).trim().toUpperCase();
	if(FSYS.value && sys!="")
		sWhere += " and (UPPER(FSYS)="+ sqlTo(sys) +" OR UPPER(FSYS)='COM')";
	this.qrySet("From", "^" + sTmpTbl
				,"Where", sWhere
				,"Order", new Array("FMAIN", "FTXT")
				);
}

function listGrid()
{
	grid.build();
}

function listMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		/*if(IsDblClick())
		{
			listMenuRun("RUN");
			return false;
		}*/
		grid.AddMenuItem("RUN", "Запустити|Запустить");		
	}
}

function listMenuRun(sID)
{
	var tbl = grid.getTable();
	if(!tbl)
		return;	
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="RUN")
	{
		var par = new Object();
		par.name = tbl.getValue("FID");
		showWindow("reports:report.xml", SW_NOMODAL, par);
	}	
}

function listDelAcc()
{
	return false;
}

include("sys/DpList.js");