//Описание объекта упрощенные больничные
 
//коструктор
function DpBlnObsh(fd, mode)
{
	RO("DpBlnObsh", this);
    this.empty = DpBlnObsh_empty;
    this.setCod = DpBlnObsh_setCod;
    this.getCod = DpBlnObsh_getCod;
    this.getFidP = DpBlnObsh_getFidP;	//возращает код приказа больничного за счет предприятия
    this.getFidS = DpBlnObsh_getFidS;	//возращает код приказа больничного за счет соцстраха
    this.getNazv = DpBlnObsh_getNazv;
    this.getLblP = DpBlnObsh_getLblP;	//возращает метку приказа больничного за счет предприятия
    this.getLblS = DpBlnObsh_getLblS;	//возращает метку приказа больничного за счет соцстраха
    this.zSetCod = DpBlnObsh_zSetCod;
    this.isBerem = DpBlnObsh_isBerem;	//является ли больничный по беременности и родам
    this.is_berem = false;
	this.zValid = DpBlnObsh_zValid;
    this.linkCtrl = DpBlnObsh_linkCtrl;
    this.validCtrl = DpBlnObsh_validCtrl;
    this.updateCtrl = DpBlnObsh_updateCtrl;
    this.zaval = DpBlnObsh_zaval;
    this.fillUp = DpBlnObsh_fillUp;
    this.zavalOk = DpBlnObsh_zavalOk;
    this.empty();
    this.zOk = true;
    this.htm = "l_bln_nas.js";
    this.nazv = "???";
    this.fidP = 0;
    this.fidS = 0;
    this.lblP = "";
    this.lblS = "";
    if (fd=="0")
    	this.allow0 = true;
    if(Number(ReadParEx("TYPE_BOLN"))!=0 && mode=="ADD") //будем запоминать последний выбор и при последующих вызовах устанавливать его
    {
		this.zSetCod(Number(ReadParEx("TYPE_BOLN")));
    }
}

function DpBlnObsh_empty()
{
	this.cod = 0;
	this.nazv = "???";
}

function DpBlnObsh_setCod(newcod)
{
	this.empty();
    this.cod = newcod;
    this.fillUp();
    this.updateCtrl();
}

function DpBlnObsh_getCod()
{
	return this.cod;
}

function DpBlnObsh_getNazv()
{
	return this.nazv;
}

function DpBlnObsh_getFidP()
{
	return this.fidP;
}

function DpBlnObsh_getFidS()
{
	return this.fidS;
}

function DpBlnObsh_getLblP()
{
	return this.lblP;
}

function DpBlnObsh_getLblS()
{
	return this.lblS;
}

function DpBlnObsh_zSetCod(newcod)
{
    this.zOk = true;
    this.cod = newcod;
    if(!this.fillUp())
		this.zaval(this.cod);
	if(this.zOk)
    	this.updateCtrl();
	return this.zOk;
}

function DpBlnObsh_isBerem()
{
	return this.is_berem;
}

function DpBlnObsh_fillUp()
{
    if (!this.cod && this.allow0) 
    	return true;
	var strSQL = "select Fnazv, Fvid_p, Fvid_s, Fis_berem from ^nast_bln where fnom="+ sqlTo(this.cod);
    var snap = getSnap(strSQL);
    if (snap == null)
    {
    	this.empty();
        return false;
	}
	else
	{
		this.nazv = snap[0];
		this.fidP = snap[1];
		this.fidS = snap[2];
		this.is_berem = toScrObj(snap[3]);
		WriteParEx("TYPE_BOLN",this.cod);
	}
	snap = getSnap("select Fedit from ^cl_prik where Fvid="+this.fidP);
	if(snap)
		this.lblP = snap[0].toUpperCase();
	snap = getSnap("select Fedit from ^cl_prik where Fvid="+this.fidS);
	if(snap)
		this.lblS = snap[0].toUpperCase();
	return true;
}

function DpBlnObsh_updateCtrl()
{
	if (this.ctrlCod)
    	this.ctrlCod.value = this.cod;
    if(this.ctrlTxt)
		this.ctrlTxt.value = this.getNazv();
}

function DpBlnObsh_zaval(ncod)
{
	if (!ncod)
    	ncod = this.ctrlCod.value;
	par = new Object();
   	par.isZaval = true;
    par.fcod = ncod;
    par.ret = new Object();
    par.ret.fnom = ncod;
    
    showWindow(this.htm, SW_MODAL, par, "");
    if(!par.escape)
    {
    	this.cod = par.ret.fnom;
		this.zOk = true;
	}
    else
    {
        this.zOk = false;
	}

	if (this.zOk)
	{
    	
    	this.fillUp();
    	this.updateCtrl();
	}
	return this.zOk;
}

function DpBlnObsh_linkCtrl(nomCtrl,nazvCtrl)
{
	this.ctrlCod = nomCtrl;
    nomCtrl.mask = "##";
	if(typeOf(this.ctrlCod)=="DpTextEx")
	{
		this.ctrlCod.setButton(true);
		this.ctrlCod.buttonHandler(this, "zaval");
	}	
	setValid(this.ctrlCod, this, "validCtrl");
	if(typeOf(nazvCtrl)=="DpTextEx")
	{
		this.ctrlTxt = nazvCtrl;
		var str = "";
		for(var i=0; i<100; i++)
			str += "&";
		this.ctrlTxt.setMask(str); // 100
		Disable(this.ctrlTxt);
	}
	this.updateCtrl();
}

function DpBlnObsh_validCtrl()
{
	return this.zSetCod(this.ctrlCod.value);
}

function DpBlnObsh_zavalOk()
{
	return this.zOk;
}

function DpBlnObsh_zValid()
{
	return this.zSetCod(this.ctrlCod.value);
}