/*Описание объекта для выбора N калькуляции
 */
 
include("objects\\DpCalculations.js");

function DpCalc (mdoc, mnop, mcalc)
{
	RO("DpCalc", this);
   this.setCod  = DpCalc_setCod;
   this.zSetCod = DpCalc_zSetCod;
   this.getCod  = DpCalc_getCod;
   this.setDoc = DpCalc_setDoc;
   
   this.linkCtrl = DpCalc_linkCtrl;
   this.updateCtrl = DpCalc_updateCtrl;
   this.valid = DpCalc_valid;          //Проверка, существует ли запись по заданному коду вида оплаты 
   this.validCtrl = DpCalc_validCtrl;  //Реакция на выход из связанного поля ввода
   this.zaval = DpCalc_zaval;          //Осуществляется завал при нажатии кнопки
//   this.pFcalc   = null;
//   this.ctrlCod = null;
   this.setCod(mcalc);
   this.setDoc(mdoc);
}

function DpCalc_setDoc(cDoc)
{
	this.pFdoc = cDoc;
	this.calcs = new DpCalculations(cDoc);
}

function DpCalc_linkCtrl(newctrl)
{
   this.ctrlCod=newctrl;
   this.ctrlCod.mask="#####";
   setButton(this.ctrlCod, this, "zaval");
   setValid(this.ctrlCod, this, "validCtrl");
}

function DpCalc_updateCtrl()
{
  if(this.ctrlCod) this.ctrlCod.setValue(this.getCod());
}

function DpCalc_setCod(mcalc)
{
	if(mcalc==0)
	{
		this.isValid = true;
	}
	else
	{
/*
		var tmpTbl=OpenTable("s",
			"SELECT * "
			+ "FROM ^CL_CALC "
			+ "WHERE Fcalc="+sqlTo(mcalc)
			);

		this.isValid = !tmpTbl.IsEmpty();
*/
		mcalc = parseInt(mcalc);
		this.isValid = !isNaN(mcalc) && this.calcs.listGroups(true)[mcalc];
	}
	
   this.pFcalc = mcalc;
   this.updateCtrl();
}

function DpCalc_zSetCod(mdoc, mnop, mcalc){
   var strSQL, tcalc;
   this.pFcalc = mcalc;
   this.pFnop = mnop;
   this.pFdoc = allt(mdoc);
   this.ok = true;
   if (this.pFcalc==0) return this.ok;
//-   strSQL = "select * from ^CL_CALC where Fdoc="+"'"+this.pFdoc+"'"+" and (Fnop=0 or Fnop="+String(this.pFnop)+") and Fcalc="+String(this.pFcalc) ;
//-   tcalc = OpenTable("s", strSQL);
   if (!this.calcs.listGroups(true)[this.pFcalc])
   {
    //завал
      var pr = new Object();
      pr.isZaval=true;
      pr.doc    = this.pFdoc;
      showWindow("l_calc.xml",SW_MODAL,pr,"");
      if (!pr.escape)
      {
          this.pFcalc = pr.calc;
          this.ok = true;
      }
      else
      {
         this.ok = false;
      }
   }else{
      this.ok = true;
   }
//-   tcalc.Close();
   this.updateCtrl();
   return this.ok;
}

function DpCalc_getCod()
{
   return this.pFcalc;
}

function DpCalc_validCtrl()
{
    this.setCod(this.ctrlCod.value);
    if(!this.valid())
     { // делаем завал
      var pr = new Object();
      pr.isZaval=true;
      pr.doc    = this.pFdoc;
      showWindow("l_calc.xml",SW_MODAL,pr,"");
      if (!pr.escape)
      {
	       this.pFcalc = pr.calc;
           this.ok = true;
           this.updateCtrl();
      }
      else
      {
           this.ok = false;
      }
     }
}

function DpCalc_zaval()
{
      var pr = new Object();
      pr.isZaval=true;
      pr.doc    = this.pFdoc;
      showWindow("l_calc.xml",SW_MODAL,pr,"");
      if (!pr.escape)
      {
            this.pFcalc = pr.calc;
            this.ok = true;
            this.updateCtrl();
       }
       else
       {
           this.ok = false;
       }
}

function DpCalc_valid()
{  
   return this.isValid;
}