function DpCtrlLinker(obj, isTbl)
{
	this.obj = obj;
	this.isTable = Boolean(isTbl);
	this.arrCtrl = new Array();
	this.arrCL = new Array();
	this.arrSc = new Array();	
	this.arrDateTimeD = new Array();
	this.arrDateTimeT = new Array();	
	this.arrVar = new Array();
	this.arrCtrlSetGet = new Array();
	this.arrValids = new Array();
	this.addLink = DpCtrlLinker_addLink;
	this.addClLink = DpCtrlLinker_addClLink;
	this.addScLink = DpCtrlLinker_addScLink;
	this.addSetGetLink = DpCtrlLinker_addSetGetLink;
	this.addDateTimeLink = DpCtrlLinker_addDateTimeLink;
	this.updateData = DpCtrlLinker_updateData;
	this.toControls = DpCtrlLinker_toControls;
	this.toVars = DpCtrlLinker_toVars;
	this.toObject = DpCtrlLinker_toObject;
	this.getObjectValue = DpCtrlLinker_getObjectValue;
	this.getContext = DpCtrlLinker_getContext;
	this.setValidVar = DpCtrlLinker_setValidVar;	
	
	if (obj.setCtrlLinker)
		obj.setCtrlLinker(this);
}

function DpCtrlLinker_addLink(sVar, oCtrl)
{
	this.arrCtrl[sVar] = oCtrl;
	this.arrVar[oCtrl.getData("ID")] = sVar;
	if (this.arrValids[sVar])
		setValid(oCtrl, this.arrValids[sVar].obj, this.arrValids[sVar].method)
	
	if (typeof(this.obj.isFixedVar) != "undefined"
		&& this.obj.isFixedVar(sVar))
		Disable(oCtrl);
}

function DpCtrlLinker_getObjectValue(sVar)
{
	if (this.isTable)
	{
		return toScrObj(this.obj.getValue(sVar));
	}
	return this.obj.getVar(sVar);
}

function DpCtrlLinker_addScLink(sScVar,sSuVar,sStVar,sClVar1,sClVar2,sClVar3,oSc)
{
	var oScObj = new Object();
	oScObj.sScVar = sScVar;
	oScObj.sSuVar = sSuVar;
	oScObj.sStVar = sStVar;
	oScObj.sClVar1 = (sClVar1?sClVar1:null);
	oScObj.sClVar2 = (sClVar2?sClVar2:null);
	oScObj.sClVar3 = (sClVar3?sClVar3:null);
	oScObj.oSc = oSc;
	this.arrVar[oSc.ctrlSc.getData("ID")] = sScVar;
	this.arrVar[oSc.ctrlSu.getData("ID")] = sSuVar;
	this.arrVar[oSc.ctrlSt.getData("ID")] = sStVar;
	
	if (oSc.ctrlCl1 && sClVar1)
		this.arrVar[oSc.ctrlCl1.getData("ID")] = sClVar1;
	if (oSc.ctrlCl2 && sClVar2)
		this.arrVar[oSc.ctrlCl2.getData("ID")] = sClVar2;
	if (oSc.ctrlCl3 && sClVar3)
		this.arrVar[oSc.ctrlCl3.getData("ID")] = sClVar3;
	this.arrSc[this.arrSc.length] = oScObj;
	if (typeof(this.obj.isFixedVar) != "undefined")
	{
		if (this.obj.isFixedVar(sScVar))
			Disable(oSc.ctrlSc);
		if (this.obj.isFixedVar(sSuVar))
			Disable(oSc.ctrlSu);
		if (this.obj.isFixedVar(sStVar))
			Disable(oSc.ctrlSt);
		if (sClVar1 && this.obj.isFixedVar(sClVar1))
			Disable(oSc.ctrlCl1);
		if (sClVar2 && this.obj.isFixedVar(sClVar2))
			Disable(oSc.ctrlCl2);
		if (sClVar3 && this.obj.isFixedVar(sClVar3))
			Disable(oSc.ctrlCl3);
	}
}

function DpCtrlLinker_addDateTimeLink(sVar, oCtrlDate, oCtrlTime)
{
	this.arrDateTimeD[sVar] = oCtrlDate;
	this.arrDateTimeT[sVar] = oCtrlTime;
	this.arrVar[oCtrlDate.getData("ID")] = sVar;
	this.arrVar[oCtrlTime.getData("ID")] = sVar;
	if (this.arrValids[sVar])
	{
		setValid(oCtrlDate, this.arrValids[sVar].obj, this.arrValids[sVar].method)
		setValid(oCtrlTime, this.arrValids[sVar].obj, this.arrValids[sVar].method)
	}
	
	if (typeof(this.obj.isFixedVar) != "undefined"
		&& this.obj.isFixedVar(sVar))
	{
		Disable(oCtrlDate);
		Disable(oCtrlTime);
	}
}

function DpCtrlLinker_addClLink(sVar, oCl)
{
	this.arrCL[sVar] = oCl;
	if(oCl.ctrlCod)
		this.arrVar[oCl.ctrlCod.getData("ID")] = sVar;
	else if(oCl.ctrlSmart)
		this.arrVar[oCl.ctrlSmart.getData("ID")] = sVar;
	else if(oCl.dpTextCtrl)
		this.arrVar[oCl.dpTextCtrl.getData("ID")] = sVar;
	if (typeof(this.obj.isFixedVar) != "undefined"
		&& this.obj.isFixedVar(sVar))
	{
		Disable(oCl.ctrlCod);
		if(oCl.ctrlSmart)
			Disable(oCl.ctrlSmart);
		Disable(oCl.ctrl["ftxt"]);		
	}
}

function DpCtrlLinker_addSetGetLink(sVar, oCtrl)
{
	this.arrCtrlSetGet[sVar] = oCtrl;
}

function DpCtrlLinker_updateData(bSave, objTo)
{
	for(var sVar in this.arrCtrl)
	{
		if (bSave)
		{
			if (objTo)
				objTo[String(sVar).toUpperCase()] = this.arrCtrl[sVar].value;
			else
				this.obj.setVar(sVar,this.arrCtrl[sVar].value)
		}
		else
		{
			try
			{
				this.arrCtrl[sVar].value = this.getObjectValue(sVar);
			} catch(err)
			{
				alert("Ошибка при присвоении значения '" + this.getObjectValue(sVar) + "' в поле " + sVar
						+ "\n" + err.name
						+ "\n" + err.message
						)
			}
		}
	}
	
	for(var sVar in this.arrCL)
	{
		if (bSave)
		{
			if (objTo)
				objTo[String(sVar).toUpperCase()] = this.arrCL[sVar].getCod();
			else
				this.obj.setVar(sVar,this.arrCL[sVar].getCod())
		}
		else
		{
			this.arrCL[sVar].setCod(this.getObjectValue(sVar));
		}
	}
	
	for(var sVar in this.arrDateTimeD)
	{
		if (bSave)
		{
//			if (objTo)
	//			objTo[String(sVar).toUpperCase()] = this.arrDateTimeD[sVar].value;
		//	else
			//	this.obj.setVar(sVar,this.arrDateTimeD[sVar].value)
		}
		else
		{
			this.arrDateTimeD[sVar].value = this.getObjectValue(sVar);
		}
	}
	
	for(var sVar in this.arrDateTimeT)
	{
		if (bSave)
		{
			var date = new Date();
			date.setDate(toScriptDate(this.arrDateTimeD[sVar].value).getDate());
			date.setMonth(toScriptDate(this.arrDateTimeD[sVar].value).getMonth());
			date.setFullYear(toScriptDate(this.arrDateTimeD[sVar].value).getFullYear());
			date.setHours(this.arrDateTimeT[sVar].getHours());
			date.setMinutes(this.arrDateTimeT[sVar].getMinutes());
			
			if (objTo)
				objTo[String(sVar).toUpperCase()] = date.getVarDate();
			else
				this.obj.setVar(sVar,date.getVarDate());
		}
		else
		{
			this.arrDateTimeT[sVar].setTime(this.getObjectValue(sVar).getHours(), 
				this.getObjectValue(sVar).getMinutes());	
		}
	}
	
	for(var sVar in this.arrCtrlSetGet)
	{
		if (bSave)
		{
			
			if (objTo)
				objTo[String(sVar).toUpperCase()] = this.arrCtrlSetGet[sVar].getValue();
			else
				this.obj.setVar(sVar,this.arrCtrlSetGet[sVar].getValue())
		}
		else
		{
			this.arrCtrlSetGet[sVar].setValue(this.getObjectValue(sVar));
		}
	}
	
	for (var nVar in this.arrSc)
	{
		var oScObj = this.arrSc[nVar];
		if (bSave)
		{
			var sc = parseInt(oScObj.oSc.getSc());
			var su = parseInt(oScObj.oSc.getSu());
			var st = parseInt(oScObj.oSc.getSt());
			
			if (objTo)
			{
				objTo[String(oScObj.sScVar).toUpperCase()] = (isNaN(sc)?0:sc);
				objTo[String(oScObj.sSuVar).toUpperCase()] = (isNaN(su)?0:su);
				objTo[String(oScObj.sStVar).toUpperCase()] = (isNaN(st)?0:st);
			}
			else
			{
				this.obj.setVar(oScObj.sScVar,(isNaN(sc)?0:sc));
				this.obj.setVar(oScObj.sSuVar,(isNaN(su)?0:su));
				this.obj.setVar(oScObj.sStVar,(isNaN(st)?0:st));
			}
			
			if (oScObj.sClVar1)
			{
				var cl1 = parseInt(oScObj.oSc.getCl1());
				if (objTo)
					objTo[String(oScObj.sClVar1).toUpperCase()] = (isNaN(cl1)?0:cl1);
				else	
					this.obj.setVar(oScObj.sClVar1,(isNaN(cl1)?0:cl1));
			}
			if (oScObj.sClVar2)
			{
				var cl2 = parseInt(oScObj.oSc.getCl2());
				if (objTo)
					objTo[String(oScObj.sClVar2).toUpperCase()] = (isNaN(cl2)?0:cl2);
				else
					this.obj.setVar(oScObj.sClVar2,(isNaN(cl2)?0:cl2));
			}
			if (oScObj.sClVar3)
			{
				var cl3 = parseInt(oScObj.oSc.getCl3());
				if (objTo)
					objTo[String(oScObj.sClVar3).toUpperCase()] = (isNaN(cl3)?0:cl3);
				else
					this.obj.setVar(oScObj.sClVar3,(isNaN(cl3)?0:cl3));
			}
		}
		else
		{
			var sc = this.getObjectValue(oScObj.sScVar);
			var su = this.getObjectValue(oScObj.sSuVar);
			var st = this.getObjectValue(oScObj.sStVar);
			var cl1 = (oScObj.sClVar1?this.obj.getVar(oScObj.sClVar1):0);
			var cl2 = (oScObj.sClVar2?this.obj.getVar(oScObj.sClVar2):0);
			var cl3 = (oScObj.sClVar3?this.obj.getVar(oScObj.sClVar3):0);
			oScObj.oSc.set(sc,su,st,cl1,cl2,cl3);
		}
	}
}

function DpCtrlLinker_toControls()
{
	this.updateData(false);
}

function DpCtrlLinker_toVars()
{
	this.updateData(true);
}

function DpCtrlLinker_toObject(m)
{
	this.updateData(true, m);
}

function DpCtrlLinker_getContext()
{
	return document;
}

function DpCtrlLinker_setValidVar(strVar, obj, method)
{
	this.arrValids[strVar] = {obj: obj, method:method};		
}