// JScript source code

function DpDBTable(sSQL)
{
	this.MoveNext = this.moveNext = DpDBTable_moveNext;
	this.MoveFirst = this.moveFirst = DpDBTable_moveFirst;
	this.MoveLast = this.moveLast = DpDBTable_moveLast;
	this.MovePrev = this.movePrev = DpDBTable_movePrev;
	this.IsEOF = this.isEOF = DpDBTable_isEOF;
	this.IsBOF = this.isBOF = DpDBTable_isEOF;
	this.IsEmpty = this.isEmpty = DpDBTable_isEmpty;
	this.Close = this.close = DpDBTable_close;
	this.Requery = this.requery= DpDBTable_requery;
	this.setAbsolute = DpDBTable_setAbsolute;
	this.getAbsolute = DpDBTable_getAbsolute;
	this.getValue = DpDBTable_getValue;
	
	this.getFieldInfo = DpDBTable_getFieldInfo;
	this.getFieldCount = DpDBTable_fieldCount;
	
	this.jTbl = OpenTable(sSQL);	
	var nFld = this.jTbl.fieldCount();
	
	for (var i = 1;i < nFld + 1;i++)
	{
		var fld = this.jTbl.getFieldInfo(i);
		if (fld == null)
			continue;
			
		var sFLD = String(fld.getName()).toUpperCase();		
		//var func = eval("function() {return this.getValue('" + sFLD + "'); }");
		var func =  new Function("return this.getValue('" + sFLD + "')");
		this.__defineGetter__(sFLD, func);
		var sFLD = String(fld.getName()).toLowerCase();				
		this.__defineGetter__(sFLD, func);
		if (sFLD.substr(0,1) == "f" )
			sFLD = "F" + sFLD.substring(1);
		this.__defineGetter__(sFLD, func);
			
	}
	
	this.__defineGetter__("bookmark", this.getAbsolute);
	this.__defineSetter__("bookmark", this.setAbsolute);
	this.__defineGetter__("absolute", this.getAbsolute);
	this.__defineSetter__("absolute", this.setAbsolute);
	
	this.__defineGetter__("empty", this.isEmpty);
	this.__defineGetter__("fieldCount", this.getFieldCount);
}


function DpDBTable_moveNext()
{
	return this.jTbl.moveNext();
}

function DpDBTable_movePrev()
{
	return this.jTbl.movePrev();
}

function DpDBTable_moveFirst()
{
	return this.jTbl.moveFirst();
}

function DpDBTable_moveLast()
{
	return this.jTbl.moveLast();
}

function DpDBTable_isEOF()
{
	return toScrObj(this.jTbl.isEOF());
}

function DpDBTable_isBOF()
{
	return toScrObj(this.jTbl.isBOF());
}

function DpDBTable_isEmpty()
{
	return toScrObj(this.jTbl.isEmpty());
}

function DpDBTable_close()
{
	return toScrObj(this.jTbl.close());
}

function DpDBTable_requery()
{
	return toScrObj(this.jTbl.requery());
}

function DpDBTable_setAbsolute(n)
{
	return this.jTbl.setAbsolute(n);
}

function DpDBTable_getAbsolute()
{
	return Number(this.jTbl.getAbsolute());
}

function DpDBTable_getValue(sFLD)
{
	return toScrObj(this.jTbl.getValue(sFLD));
}

function DpDBTable_getFieldInfo(sFLD)
{
	return this.jTbl.getFieldInfo(sFLD);
}

function DpDBTable_fieldCount()
{
	return this.jTbl.fieldCount();
}