/*
	Описание объекта единицы измерений
*/

include("sys\\servis.js");

DpEdi.prototype.setCod = EdiSetCod;
DpEdi.prototype.setTxts = EdiSetTxts;
DpEdi.prototype.zSetTxts = EdiZSetTxts;
DpEdi.prototype.getTxts = EdiGetTxts;
DpEdi.prototype.empty = EdiEmpty;
//DpEdi.prototype.fillUpFromTbl = EdiFillUpFromTbl;
DpEdi.prototype.getCod = EdiGetCod;
DpEdi.prototype.zaval = EdiZaval;
DpEdi.prototype.assocTextCtrl = EdiAssocTextCtrl;
DpEdi.prototype.assocDpText = EdiAssocDpText;
DpEdi.prototype.linkCtrl = EdiLinkCtrl;
DpEdi.prototype.blurCtrl = EdiBlurCtrl;
DpEdi.prototype.valid = EdiValid;
DpEdi.prototype.zValid = EdiZValid;
DpEdi.prototype.updateCtrl = EdiUpdateCtrl;
DpEdi.prototype.setMode = EdiSetMode;

var tblWrkCl_edi;

// Конструктор объекта валюты
function DpEdi(val)
{
	this.__defineGetter__("value", this.getCod);
	this.__defineSetter__("value", this.setCod);
	RO("DpEdi", this);
	this.setMode("0");
	switch(typeof(val))
	{
	case "number":
		this.setCod(val);
		break;
	case "string":
		this.setMode(val);
		//this.setTxts(val);
		break;
	case "undefined":
		this.setCod(0);
		break;
	}

	/*
	if(tblWrkCl_edi == null)
		tblWrkCl_edi = OpenTable("s", "cl_edi");
		*/ 
}

function EdiSetCod( newCod )
{
	this.empty();
	this.cod = newCod;
	if( this.cod == 0 )
	{
		this.txts = "   ";
		this.txtfz = "";
		this.txtf = "";
		this.txtf2 = "";
	}
	this.updateCtrl();
}


function EdiSetTxts( newTxts )
{
	newTxts = allt(newTxts);
	
	this.empty();
	if(newTxts=="")
	{
		this.cod = 0;
		this.txts = "";
		this.txtf = ""
	}
	this.updateCtrl();
}

function EdiZSetTxts( newTxts )
{
	newTxts = allt(newTxts);

	var retValue = true;

	this.empty();

	if(newTxts=="")
	{
		if(this.mode=="0")
		{
			this.cod = 0;
			this.txts = "";
			this.txtf = ""
			this.txtf2 = ""
		}
		else
			retValue = this.zaval();
	}
	else
	{
//-		tblWrkCl_edi.setIndex("txts");
//-		if( tblWrkCl_edi.Seek("=", newTxts) )
		var oSnap = getSnap("Select Fcod, Ftxts, Ftxtf, ftxtf2 From ^cl_edi Where Ftxts=" + sqlTo(newTxts));
		if (oSnap != null)
		{
//-			this.cod = tblWrkCl_edi.getValue("fcod");
//-			this.txtf = tblWrkCl_edi.getValue("ftxtf");
//-			this.txts = tblWrkCl_edi.getValue("ftxts");
			this.cod = oSnap[0];
			this.txts = oSnap[1];
			this.txtf = oSnap[2];
			this.txtf2 = oSnap[3];
		}
		else
			retValue = this.zaval();
	}
	
	if(retValue)
		this.updateCtrl();

	return retValue;
}

function EdiZaval()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.fcod = this.getCod();
	par.ret.ftxts = null;
	par.ret.ftxtf = null;
	par.ret.ftxtf2 = null;
//-	showWindow("l_cledi.js",SW_MODAL,par);
	showWindow("l_cledi_tree.xml",SW_MODAL,par);
	if( !par.escape)
	{
		this.cod = par.ret.fcod;
		this.txts = par.ret.ftxts;
		this.txtf = par.ret.ftxtf;
		this.txtf2 = par.ret.ftxtf;
		this.updateCtrl();
		return true;
	}
	else
	{
		return false;
	}
}

function EdiGetTxts()
{
	if( this.txts != null )
		return this.txts;
	else if( this.cod == null )
		return "???";
	else
	{
//-		tblWrkCl_edi.Index = "cod";
//-		if (SQL)
//-			tblWrkCl_edi.Index = "FCOD";
//-		if( tblWrkCl_edi.Seek("=", this.cod) )
		var oSnap = getSnap("Select fcod, ftxts, ftxtf, ftxtf2 From ^cl_edi Where fcod=" + sqlTo(this.cod));
		if (oSnap != null)
		{
//			this.fillUpFromTbl();
			this.cod = oSnap[0];
			this.txts = oSnap[1];
			this.txtf = oSnap[2];
			this.txtf2 = oSnap[3];
			return this.txts;
		}
		else
			return "???";
	}
}

function EdiGetCod()
{
	if( this.cod != null )
		return this.cod;
	else if( this.txts == null )
		return null;
	else if( this.txts.trim == "" )
		return 0;
	else
	{
//-		tlbWrkCl_valut.Index = "txts";
//-		if (SQL)
//-			tlbWrkCl_valut.Index = "FTXTS";
//-		if( !tblWrkCl_edi.Seek("=", this.txts) )
		var oSnap = getSnap("Select Fcod, Ftxts, Ftxtf, ftxtf2 From ^cl_edi Where Ftxts=" + sqlTo(this.txts));
		if (oSnap != null)
		{
//-			this.fillUpFromTbl();
			this.cod = oSnap[0];
			this.txts = oSnap[1];
			this.txtf = oSnap[2];
			this.txtf2 = oSnap[3];
			return this.cod;
		}
		else
		{
			return null;
		}
	}
}

function EdiEmpty()
{
	this.cod = null;
	this.txts = null;
	this.txtf = null;
	this.txtf2 = null;
}

function EdiAssocTextCtrl(ctrl)
{
	if( ctrl.type == "text" )
	{
		this.textCtrl = ctrl;
		ctrl.value = this.getTxts();
	}
}

function EdiAssocDpText(ctrl)
{
	ctrl.mask = "&&&&&&&";
	ctrl.value = this.getTxts();
	this.dpTextCtrl = ctrl;
	setValid(ctrl, this, "blurCtrl");
	
	if(typeof(ctrl.BlurCtrl)!="undefined")
	{
		//ctrl.BlurCtrl(this, "blurCtrl");
	}
	setButton(ctrl, this, "zaval");
	
	if(ctrl.setData)
		ctrl.setData("DPOBJ", this);
/*
	if(ctrl.DpType=="DpGet")
	{
		ctrl.isButton = true;
		ctrl.ButtonHandler(this, "zaval");
	}
*/
}

function EdiLinkCtrl(ctrl)
{
	this.assocDpText(ctrl)
}

function EdiBlurCtrl()
{
	if( this.textCtrl != null )
	{
		if( !this.zSetTxts(this.textCtrl.value) )
		{
			//this.textCtrl.focus();
		}
		else
			this.textCtrl.value = this.getTxts();
	}
	if(typeof(this.dpTextCtrl)=="object")
	{
		return this.zSetTxts(this.dpTextCtrl.value);
	}
}

function EdiValid()
{
//-	tblWrkCl_edi.Index = "cod";
//-	if (SQL)
//-		tblWrkCl_edi.Index = "Fcod";
//-	return tblWrkCl_edi.Seek("=", this.getCod());
	var oSnap = getSnap("Select Fcod From ^cl_edi Where Fcod=" + sqlTo(this.getCod()));
	return oSnap != null;
}

function EdiZValid()
{
	return this.zSetTxts(this.getTxts());
}

function EdiUpdateCtrl()
{
	if(this.dpTextCtrl != null)
	{
		this.dpTextCtrl.value = this.getTxts();
	}
}

function EdiSetMode(mode)
{
	this.mode = mode;
}