function DpFile(sFile)
{
	sFile = String(sFile);
	if (sFile.startsWith("dborg:"))
	{
		return new DpDBFile(sFile);
	}
	return new java.io.File(sFile);
	
	if (!isClientMode)
	{
		var sFullName = sFile; 
		return new java.io.File(sFile);
	}	
}

function DpFileOutputStream(file)
{
	return new java.io.FileOutputStream(file);
}

function DpFileInputStream(file)
{
	return new java.io.FileInputStream(file);
}

function DpDBFile(sFile)
{
	this.separatorChar = "/";
	this.prefixLength = 0;
	sFile = String(sFile);
	
	while(sFile.endsWith("/"))
		sFile = sFile.substring(sFile, sFile.length - 1);
	this.path = this.file = sFile;
	this.keyPath = String(lpProxy.getDBFileName(this.path)); 
	this.fileSystemTable = "^orgfilesys";
	
	this.getName = DpDBFile_getName;
	this.DpDBFile_getParent = DpDBFile_getParent;
	this.DpDBFile_getParentFile = DpDBFile_getParentFile;
	this.getFileInfo = DpDBFile_getFileInfo;
	this.getPath = DpDBFile_getPath;
	this.isAbsolute = DpDBFile_isAbsolute;
	this.getAbsolutePath = DpDBFile_getAbsolutePath;
	this.getAbsoluteFile = DpDBFile_getAbsoluteFile;
	this.getCanonicalPath = DpDBFile_getCanonicalPath;
	this.getCanonicalFile = DpDBFile_getCanonicalFile;
	this.toURL = DpDBFile_toURL;
	this.toURI = DpDBFile_toURI;
	
	this.canRead = DpDBFile_canRead;
	this.canWrite = DpDBFile_canWrite;
	this.exists = DpDBFile_exists;
	this.isDirectory = DpDBFile_isDirectory;
	this.isFile = DpDBFile_isFile;
	this.isHidden = DpDBFile_isHidden;	
	this.lastModified = DpDBFile_lastModified;
	this.length = DpDBFile_length;
	this.createNewFile = DpDBFile_createNewFile;
	this.Delete = this.del = DpDBFile_delete;
	this.DpDBFile_deleteOnExit = DpDBFile_deleteOnExit;
	this.list = DpDBFile_list;
	this.listFiles = DpDBFile_listFiles;
	this.mkdir = DpDBFile_mkdir;
	this.mkdirs = DpDBFile_mkdirs;
	this.renameTo = DpDBFile_renameTo;
	this.setLastModified = DpDBFile_setLastModified;
	this.setReadOnly = DpDBFile_setReadOnly;
	this.setWritable = DpDBFile_setWritable;
	this.setReadable = DpDBFile_setReadable;
	this.setExecutable = DpDBFile_setExecutable;
	this.canExecute = DpDBFile_canExecute;
	this.compareTo = DpDBFile_compareTo;
	this.equals = DpDBFile_equals;
	this.toString = DpDBFile_toString;
}

function DpDBFile_getName() {
    var index = this.path.lastIndexOf(this.separatorChar);
    if (index < this.prefixLength) return this.path.substring(this.prefixLength);
    return this.path.substring(index + 1);
}

function DpDBFile_getParent() {
    var index = this.path.lastIndexOf(this.separatorChar);
    if (index < this.prefixLength) {
        if ((this.prefixLength > 0) && (path.length() > this.prefixLength))
            return this.path.substring(0, this.prefixLength);
        return null;
    }
    return this.path.substring(0, index);
}

function DpDBFile_getParentFile() {
    var p = this.getParent();
    if (p == null) return null;
    return new DpDBFile(p, this.prefixLength);
}

function DpDBFile_getFileInfo()
{
	if(this._fi == null)
	{
		this._fi = new Object();
		this._fi.isExists = false;
		this._fi.isDirectory = false;
		this._fi.isFile = false;
		this._fi.canRead = false;
		this._fi.canWrite = false;
		this._fi.isHidden = false;
		this._fi.fileLength = 0;
		var tbl = OpenTable("select FISDIR from " + this.fileSystemTable + " where fpath = " + sqlTo(this.keyPath));
		if (!tbl.isEmpty())
		{
			this._fi.isExists = true;
			this._fi.isDirectory = toScrObj(tbl.getValue("FISDIR"));
			this._fi.isFile = !this._fi.isDirectory;
			this._fi.canRead = true;
			this._fi.canWrite = true;				
		}
		tbl.close();
	}
	
	return this._fi;
}

function DpDBFile_getPath() {
    return this.path;
}

function DpDBFile_isAbsolute() {
    return true;
}

function DpDBFile_getAbsolutePath() {
    return this.getPath();
}

function DpDBFile_getAbsoluteFile() {
    return this;
}

function DpDBFile_getCanonicalPath()  {
    return this.getPath();
}

function DpDBFile_getCanonicalFile() 
{
    
    return this;
}

//@Deprecated
function DpDBFile_toURL()  {
    return this.getPath();
}


function DpDBFile_toURI() 
{
    return this.getPath();
}

function DpDBFile_canRead() 
{
    return this.getFileInfo().canRead;
}

function DpDBFile_canWrite() 
{
    return this.getFileInfo().canWrite;
}

function DpDBFile_exists() {
    return this.getFileInfo().isExists;
}

function DpDBFile_isDirectory() {
	return this.getFileInfo().isDirectory;
}

function DpDBFile_isFile() 
{
    return !this.getFileInfo().isDirectory;
}

function DpDBFile_isHidden() 
{
    return this.getFileInfo().isHidden;
}

function DpDBFile_lastModified() {
    return 0;
}

function DpDBFile_length() {
   return 0;
}

/* -- File operations -- */
function DpDBFile_createNewFile() {
    
}

function DpDBFile_delete() {
	return lpProxy.deleteFile(this.getPath())
}

function DpDBFile_deleteOnExit() {
    
}

function DpDBFile_list(filter) {
	var arr = snapDirectory(this.getPath());
	var ret = new Array();
	for (var i = 0; i < arr.length; i++)
	{
		ret[i] = this.getPath() + this.separatorChar + arr[i];
	}
    
}


function DpDBFile_listFiles(filter) {
    
	var arr = snapDirectory(this.getPath());
	var ret = new Array();
	for (var i = 0; i < arr.length; i++)
	{
		ret[i] = new DpFile(this.getPath() + this.separatorChar + arr[i]);
	}
	
	return ret;
}

function DpDBFile_mkdir() 
{
    return lpProxy.mkDir(this.getPath());
}

function DpDBFile_mkdirs() 
{
	return lpProxy.mkDirs(this.getPath());
}


function DpDBFile_renameTo(dest) 
{
	var dest = toScrObj(dest);
	var fi = this.getFileInfo();
	if (!fi.isExists)
		return false;
	if (!fi.canWrite)
		return false;
	var newName = null;
	if(typeof(dest) == "string")
		newName = dest;
	if(typeof(dest) == "object" && dest.getPath)
		newName = dest.getPath();
	if (newName == null)
		return false;
	return ExecuteSQL("update " + this.fileSystemTable + " set fpath = " + sqlTo(String(lpProxy.getDBFileName(newName))) 
			+ " where fpath = " + sqlTo(String(lpProxy.getDBFileName(this.getPath()))));
}


function DpDBFile_setLastModified(lTime) {
    
	
}

function DpDBFile_setReadOnly() {
    
}

function DpDBFile_setWritable(writable, ownerOnly) {
   
}

function DpDBFile_setReadable(writable, ownerOnly) {
	   
}

function DpDBFile_setExecutable(executable, ownerOnly) {
    
}

function DpDBFile_canExecute() {
    return false;
}

/* -- Basic infrastructure -- */

function DpDBFile_compareTo(pathname) 
{
	if (this.getPath() == String(pathname))
		return 0;
	else if (this.getPath() < String(pathname))
		return -1;
	else 
		return 1;
	 
}

function DpDBFile_equals() {
    return this.compareTo(obj);
}



function DpDBFile_toString() {
    return this.getPath();
}