include("doc\\nakl\\DpNkRow.js");
include("mtr_ost.js");

/*
	массовый выбор в двухстрочных накладных -
	выписывается одна строка - расход, а приходные
	части ко всем строкам дописываются при записи в буфер
	накладной (причем дописывать будет сама накладная), на
	это пошли потому, что в буфере накладной теперь находятся
	обе строки и приход и расход

	динамическое обновление остатков в прайсе
	обязательно нужно оптимизировать

	!!!!!!!!!!!!! не учитывается тип прайса и не берем цену

	если mol==0 - значит разрешено выписывать с разных МОЛ
	и тоже для подразделений

	Fcena - учетная цена
	F1cena - PN ? цена прихода : цена продажи до кальк. (отпускная)
	Fcenapr - цена продажи после кальк.
*/
//---------------------------------------------------------------------------
//типы массового ввода
if(typeof(MASS_NMK)=="undefined")
	var MASS_NMK=0;
if(typeof(MASS_PRICE)=="undefined")
	var MASS_PRICE=1;
if(typeof(MASS_VDOST)=="undefined")
	var MASS_VDOST=2;

//============================================
//SAM 24.12.2009 для облэнерго при массовом вводе по-любому показывать l_ucena.htm
var isOBL = false;
//============================================

if(typeof(MASS_BUF)!="string")
	var MASS_BUF = getTmpTableName("", true);//"tmp_mass_input_buffer";	//буфер для массового ввода
if(typeof(MASS_BUF_S)!="string")
	var MASS_BUF_S = getTmpTableName("", true);//"tmp_mass_input_show";	//буфер для просмотра отобранных записей
if(typeof(MASS_PATT)!="string")
	var MASS_PATT = "ANLTK";					//шаблон для создания буферов
var PRICE_OST = getTmpTableName("", true);//"tmp_price_ost";			//буфер для остатков из прайса
//ОБЪЕКТ МАССОВОГО ВВОДА
//	сейчас ориентирован на ввод из справочника номенклатуры
var nOldFnmkl=null;		//будем запоминать старую номенклатуру для кешировани
var noOst=false;
function DpMass()
{
	RO("DpMass", this);
	//свойства
	this.nType			=	MASS_NMK;				//заглушка!!! (для VR так и должно быть)
	this.parentNk		=	null;
	this.tbl				=	null;
	//методы
	this.Run				=	DpMass_Run;
	this.Release		=	DpMass_Release;
	this.Save			=	DpMass_Save;
	this.setParentNk	=	DpMass_setParentNk;
	this.makeInput		=	DpMass_makeInput;
	this.loadRow		=	DpMass_loadRow;
	this.getListHtml	=	DpMass_getListHtml;
	this.getEditMode	=	DpMass_getEditMode;
	this.getViewBuffer	=	DpMass_getViewBuffer;
	this.getBuffer		=	DpMass_getBuffer;
	this.getTBuffer	=	DpMass_getTBuffer;
	this.makeRow		=	DpMass_makeRow;
	this.saveRows		=	DpMass_saveRows;
	this.makeChoice	=	DpMass_makeChoice;
	this.refreshBuffer	=	DpMass_refreshBuffer;
	this.openBuffer	=	DpMass_openBuffer;
	/*
		fwid для возврата на выбранную запись
	*/
	this.FWID			=	null;
	/*
		метод для вызова из прайса, для
		возможного расчета остатков
	*/
	this.recallFromPrice =	DpMass_recallFromPrice;
	/*
		таблица и поле, где будут остатки для прайса
	*/
	this.RestTable		= PRICE_OST;
	if(false && getPar("isclost"))
		this.RestField		= "Fost";
	else
		this.RestField		= "Fost1";
	//внутренние данные
	this.tblBuffer		=	null;
	//	процент для расчета отпускной цены
	this.m_fOldOtpProc	= 0.0;
	this.fkol_vip= 0;
	this.massMode = "CALC"; //режим расчета остатков. По умалчанию режим "CALC"
	/*
		флаг перемещения
	*/
	this.isMoving	= false;
	
}
//---------------------------------------------------------------------------
//запуск ввода
function DpMass_Run()
{
	var nk = this.parentNk;
	/*
		определимся с типом массового ввода
	*/
	//объект используем только для ввода из справочника
	//this.nType = nk.oDoc.getPar("_nmklsel");
	var par = new Object();
	par.mode = "MASS";
	par.isMass = true;
	par.mass = this;
	par.nk = nk;
	par.MASS_BUF = MASS_BUF;
	if (nk == null)
	{
		return;
	}
	var doc = nk.oDoc.sDocLbl;
	/*
		здесь стоит проверка, для каких накладных
		массовый выбор не реализован, потом возможно ее
		уберем
	*/
	if(doc != "PN"	&&		doc != "NK"	&&		doc != "SF"	&&		doc != "OT"	&&
		doc != "PM"	&&		doc != "PU"	&&		doc != "SM"	&&		doc != "OC"	&&
		doc != "PZ"	&&		doc != "TC"	&&		doc != "VR"	&&		doc != "IS"	&&
		doc != "GP"	&&		doc != "VP"	&&		doc != "SA")
	{
		_alert("Массовый ввод не реализован");
		return;
	}

	if(this.nType == MASS_PRICE)
	{
		/*
			нужно найти подходящий прайс на нашу дату
		*/
		par.fwid = _pName(nk.oDoc.getVar("HP"), nk.oDoc.getVar("HDAT"));
		if(par.fwid == null)
		{
			_alert("Отсутствует прайс-лист");
			return;
		}
	}
	else if (this.nType == MASS_VDOST)
	{
		par.mol	= this.isMoving ? nk.oDoc.getVar("HMOLOT") : nk.oDoc.getVar("HMOL");
		par.podr = this.isMoving ? nk.oDoc.getVar("HPODROT") : nk.oDoc.getVar("HPODR");
		par.all  = nk.oDoc.getPar("__allnkrec");

		//============================================
		//SAM 24.12.2009 для облэнерго при массовом вводе по-любому показывать l_ucena.htm
		//include("getPlugPar.js");
		isOBL = true;//!isEmpty(getPlugPar(null,"OBL",null,null,"")); - как?
		//============================================
	}
	if(inList(doc, "VR", "VZ", "VM"/*, "VP", "IS"*/))
	{
		if(doc == "VM" )
			par.ret.FKOL = null;
		switch(doc)
		{
			case "VR":
				par.Fdoc = "NK";
				par.Fpost = nk.oDoc.getVar("HPOST");
				break;
			case "VZ":
				par.Fdoc = "OT";
				par.Fpost = nk.oDoc.getVar("HPOST");
				break;
			case "VM":
				par.Fdoc = "SM";
				par.Frtype = RTYPE_PMR;
				break;
			case "IS":
				break;
		}
		par.Fsc = doc != "GP" ? nk.oDoc.getVar("HSC") : nk.oDoc.getVar("HSCRS");
		par.Fsu = doc != "GP" ? nk.oDoc.getVar("HSU") : nk.oDoc.getVar("HSURS");
		par.Fdoc_num = nk.oDoc.getVar("HDVNOM");
		par.Fmol = this.isMoving ? nk.oDoc.getVar("HMOLOT") : nk.oDoc.getVar("HMOL");
		par.Fpodr = this.isMoving ? nk.oDoc.getVar("HPODROT") : nk.oDoc.getVar("HPODR");
		par.bDate = nk.oDoc.getVar("HDVDAT");
		par.eDate = nk.oDoc.getVar("HDAT");
		showWindow("l_pn_strs_mass.xml",SW_MODAL,par);//random size
	}
	else
	{
		switch(doc)
		{
			case "VP":
				//Олег 22.09.2009
				//в настройках параметров смотрим на галочку
				//"Ведется по поставщикам"
				if(getPar("DEF_POST") == true)
				{
					par.Fpost =  nk.oDoc.getVar("HPOST");
					par.Fdoc = "PN";
				}
				else
				{
					nk.oDoc.setPar("__getkol",100);
				}
				break;

			default:
				break;
		}
		showWindow(this.getListHtml(),SW_MODAL,par);//random size
	}
	par.mass = null;//release referense
}
//---------------------------------------------------------------------------
//установка связи с накладной
function DpMass_setParentNk(nk)
{
	this.parentNk = nk;
	/*
		создаем буфер для строк со всеми индексами
	*/
	CreateTable(MASS_BUF, MASS_PATT, "*");
	this.openBuffer();
	/*
		буфер для просмотра отобранных данных
		здесь они если нужно будут просуммированы
	*/
	CreateTable(MASS_BUF_S, MASS_PATT, "*");//250102 теперь здесь все индексы
	this.isMoving = inList(nk.oDoc.sDocLbl, "PM", "PU", "SM");
}
//---------------------------------------------------------------------------
//произвести ввод (параметры - таблица из которой делаем ввод)
function DpMass_makeInput(tbl, cMode, cTblName)
{
	var nk = this.parentNk;
	var strMode = this.getEditMode(tbl);
	var bRet = false;
	var doc = nk.oDoc.sDocLbl;
	switch (doc)
	{
		case "PN":
		case "VR":
		case "SA":
		//запустить редактирование накладной
		//режим определяем по записи на которой стоим в листе
			var par		= new Object();
			par.mode	= strMode;
			par.nk		= nk;
			par.objMass = this;
			this.tbl	= tbl;
			//объяснение этого кода смотри ниже
			var oldBuf	= nk.isBuf;
			nk.isBuf	= true;
			this.fkol_vip = 0;
			showWindow(nk.getEditHtml(),SW_MODAL,par);//default size
			nk.isBuf	= oldBuf;
			//уничтожим объект строки накладной
			par.nk = null;
			this.tbl = null;
			bRet = !par.escape;
			break;

		case "NK":
		case "PM":
		case "PU":
		case "SM":
		case "SF":
		case "OT":
		case "PZ":
		case "TC":
		case "IS":
		case "GP":
		case "VP":
		case "OC":
			/*
			смотрим, если стоит параметр только отложенное
			расценивание, то выпивываем без разговоров
			*/
			var iUchsel = nk.param("_uchsel"),
				iOtpSel = nk.param("_otpsel");
			/*
				проверим, если номенклатура старая и остатков нет, то выйдем сразу
			*/
			if(noOst && tbl("Fcod")==nOldFnmkl){
				_alert("Остатков нет.");
				return false;
			}
			/*
				флаг автомата
			*/
			var	bAuto		= iUchsel==1 || iUchsel==2;
			/*
				объект номенклатура
			*/
			var xFnmkl		= new DpNmkl();
			var xF1cena		= 0;		//отпускная цена
			var xFcena		= 0;		//учетная цена
			var 	xFpodr	=	0,
				xFmol	=	0,
				xFpost	=	0,
				xFid_pn,
				xFsc	=	0,
				xFsu	=	0;		//данные строки накладной
			var xFkol		= 0;		//количество для ввода автоматом
										//дата
			var xFdoc_dat	= new Date(nk.getVar("Fdoc_dat"));
			var t			= null;		//таблица
			var strUpdate	= null;		//строка под обновление таблицы
			var kf			= 1;		//коефициент единиц измерени
			var objKol		= new DpKolFas();	//объект для ввода количества
			var bUsl		= false;	//услуга
			/*
				номенклатура считывается из таблицы
				при любом типе массового выбора
			*/
			var szFnmkl		= "fcod";
			if(this.nType==MASS_PRICE || this.nType==MASS_VDOST)
				szFnmkl		= "fnmkl";
			xFnmkl.SetNakl(nk);
			xFnmkl.setCod(tbl(szFnmkl));	//установим код
			var nmkl		= xFnmkl.getCod();	//чтобы не производить частого чтения кода
			/*
				ДАННЫЕ НАКЛАДНОЙ (считываем сразу, чтобы не обращаться туда каждый раз)
			*/
			var podr		= nk.getVar("Fpodr");
			var mol			= nk.getVar("Fmol");
			//
			//	в идущих далее строках я ДОЛЖЕН определиться с отпускной ценой
			//
			if(this.nType==MASS_PRICE){
				//	массовый выбор по прайсу -
				//	чтение отпускной цены из него
				var szFcena = "Fcena";
				if(nk.getVar("Fpcenano")>0)
					szFcena += String(nk.getVar("Fpcenano"));
				xF1cena = tbl(szFcena);
			}
/*		else
			{
				//чтение в зависимости от параметра
				if(1 == iOtpSel)
					//прайс - чтение с номенклатуры
					xF1cena	= xFnmkl.F1cena;
			}
*/
			//если это ведомость остатков, то надо снять всю цепочку
			if(this.nType == MASS_VDOST){
				xFpodr	= tbl("Fpodr");
				xFmol	= tbl("Fmol");
				xF1cena	= tbl("Fcena");
				xFsc	= tbl("Fsc");
				xFsu	= tbl("Fsu");
				xFid_pn = tbl("Fid_pn");
				// ksm 12.11.2003 Опредиляем статью
				xFst	= tbl("Fst");
				var oFuff = getSnap("SELECT DISTINCT FSC,FSU,FST FROM "+MASS_BUF);

				if(!(doc=="SF" && (podr==0 || mol==0))){
					//с чужих подразделений списывать нельзя
					if(tbl("Fpodr")!=podr)
						return false;
					if(tbl("Fmol")!=mol)
						return false;
				}

				// ksm 12.11.2003 Для того чтобы запретить или розрешить выписку  с только из одного
				//счета используем параметр  rsonly1sc
				// его нужно добавить в ALL_MDB таблица COM_PARDOC и в system таблица DOCP_ETA
				//nk.objDoc.getPar("rsonly1sc") После того как будет нормально дабавлен параметр.
				if (this.idContinue && doc=="SF" && oFuff!=null && (oFuff[0]!=xFsc || oFuff[1]!=xFsu || oFuff[2]!=xFst)){
					WAIT("Виписка можлива тільки по "+oFuff[0]+"/"+oFuff[1]+"/"+oFuff[2])
					return false;
				}

			}

			//чтение в зависимости от параметра
			if(1 == iOtpSel)
				xF1cena	= xFnmkl.F1cena; //прайс - чтение с номенклатуры
			//
			objKol.setNmkl(xFnmkl);
			objKol.setParam(nk.param);
			if(strMode=="EDIT"){
				//возьмем старую цену
				xF1cena	= this.tblBuffer("F1cena");
				xFnmkl.Fedi	= this.tblBuffer("Fedi");
				xFnmkl.setEdi();
				if(	bAuto ){
					//проставим количество, которое возьмем из буфера просмотра
					xFkol			= tbl("mass.Fkol");
					objKol.loadFromTable(tbl.GetTie("mass"));
				}
			}
			bUsl=(xFnmkl.Fvid=="S");
			//считаем единицы измерения
			if(xFnmkl.tFedi1!=null	|| bAuto || bUsl || iUchsel==3){
				var p		= new Object();
										//корректируем коеффициент
				if(xFnmkl.Fedikf1!=null && xFnmkl.Fedi==1)kf=xFnmkl.Fedikf1;
				p.nmkl		= xFnmkl;			//!!!в этом блоке идет приведение
				p.escape	= false;			//!!!цены к основным единицам
				p.cenapr	= xF1cena*kf;
				//согласуем возврат цены
				p.bRetCena	= nk.isOtpCena();
				//в некоторых случаях нужно водить не отпускную цену, а процент к ней
				//если есть процент, то цены нет!!!
				//250102 но - нет цены - нет и процентов
				if(p.bRetCena){
					p.bRetProc	= iOtpSel==3 || iOtpSel==4;
					if(p.bRetProc){
						p.bRetCena	= false;
						p.fOtpProc	= this.m_fOldOtpProc;
					}
				}
				//здесь решаем, можно ли вводить цену отпуска, но если нужен ее процент, то конечно - можно
				//цену(не процент) реально можно редактировать только при ручном вводе
				p.bEditCena	= p.bRetProc || (nk.param("__getot") && iOtpSel==0);
				//вводить ли количество
				p.bRetKol	= bAuto|bUsl|(iUchsel==3);
				p.Fkol		= xFkol/kf;
				p.objKol	= objKol;
				p.nType		= this.nType;
				p.mode = cMode;
				showWindow("getMASScena.htm",SW_MODAL,p);
				if(p.escape)return false;
												//корректируем коеффициент
				if(xFnmkl.Fedikf1!=null && xFnmkl.Fedi==1)kf=xFnmkl.Fedikf1;
				else kf		= 1;				//сбросить
												//считываем цену
				if(p.bRetProc)
					this.m_fOldOtpProc	= p.fOtpProc;
				else if(p.bRetCena)
					xF1cena= p.F1cena/kf;
				if(p.bRetKol)
					xFkol	= p.Fkol*kf;
				p.objKol	= null;
			}
			//если это услуга, то в этом случае выписываем сразу
			if(bUsl || iUchsel==3){
				var r=new DpNkRow();
				r.setParentNk(nk);
				r.setTable(this.tblBuffer);
				//обязательно перебить флаг
				r.m_bNew	= true;
				r.Fwid		= nk.getUID();
				r.loadData(strMode=="ADD");	//new record
				r.Fnmkl.setCod(nmkl);
				r.Fnmkl.Fedi	=xFnmkl.Fedi;
				r.Fcena.value	=0;
				r.F1cena.value	=r.Fcenapr.value=xF1cena;
				r.Fkol.value	=xFkol;
				//в зависимости от параметра ставим отложенное
				//расценивание
				if(iUchsel==3)
					r.Fis_otl=true;
				//
				//	здесь имеем хитрый момент -
				//	если накладная не на буфере, то
				//	сохранение строки сохранит ее и в
				//	файл строк, и потом при сохранении
				//	накладной в нем будет создана еще
				//	одна копия, поэтому мы сейчас скажем,
				//	что накладная не на буфере и тихо
				//	сохранимся не создавая лишних копий
				//
				var bOldBuf		= nk.isBuf;
				nk.isBuf		= true;
				bRet			= r.Save();
				nk.isBuf		= bOldBuf;
				r.Release();
				r				=null;
				this.Foldnmkl	=nmkl;
				this.refreshBuffer(xFnmkl.getCod());
				return bRet;
			}
			//перед расчетом остатков проверим allnkrec
			if(!nk.param("__allnkrec")){
				xFpodr=podr;
				xFmol=mol;
			}

			__noWait = true;
			WAITTIMER("Расчитываются остатки ...");

		// Т.к. ведомость остатков не расчитывается каждый раз
		// при вызове массового ввода (по настоятельной просьбе ОблЭнерго),
		// то брать данные с таблицы cTblName, где как бы должны быть актуальные остатки, нет смысла
/*
			if(this.nType==MASS_VDOST)
			{
				//if(strMode!="EDIT")
				{
					DropTable(getOstName());
					CreateTable(getOstName(), PTN_OST_BUF, "*");

					ExecuteSQL(
						" INSERT INTO " + getOstName()
						+ " SELECT " + GetPatternIntersection(PTN_OST_BUF, "vdost")
						+ " FROM " + cTblName + " o"
						+ " WHERE o.fwid=" + tbl("fwid")
						)
					t = OpenTable("m", getOstName());
				}
			}else
			{
*/
				//расчет остатков стараемся не делать дважды
				if(nOldFnmkl!=nmkl){
					//расчет остатков и выбор
					with(new DpMtrOb()){
						if(strMode=="EDIT"){
							tblName = MASS_BUF;
							union = true;
						}else
							tblName = getOstName();
						fdate = xFdoc_dat;
						fnmkl = nmkl;
						fpodr = xFpodr;
						fmol = xFmol;
						fsc  = xFsc;
						fsu  = xFsu;
						isFostsum = false;
						pattern = PTN_OST_BUF;
						// SK 21.03.03 17:22:52 проверим данные на документе

						if( !inList(doc,"PM","SM","PU","PZ") && (0 == fsc || null == fsc) )
						{
							fsc = nk.getVar("FSC");
							fsu = nk.getVar("FSU");
							fst = nk.getVar("FST");
						}
						doCalc();
						t = getTbl();
					}
					checkOstByDoc(nk.Fdoc);
				}
//		}
			if(bAuto)
				//сносим старые записи
				updateOst("Fkol=0");
			//---модифицировать данные в таблице остатков
			if(nk.param("_otlrasc") && nOldFnmkl!=nmkl && !t.FindFirst("Fis_otl = " + sqlTrue)){
				/*
					здесь подразделение и МОЛ не проставляем, они
					будут проставлены при сохранении
				*/
				t.AddNew();
				t("Fnmkl")=nmkl;
				t("Fis_otl")=true;
				t("F1cena")=xF1cena;
				t("Fedi")=xFnmkl.Fedi;
				t.Update();
			}
			//--проставим Fedi и ВСЕМ ПО ФАСОВКЕ !!!
			strUpdate=" Fedi = "+String(xFnmkl.Fedi);
			//if(xF1cena!=0)strUpdate+=", F1cena = "+String(xF1cena);
			strUpdate+=", Fedi_fas = "+String(objKol.getEdiFas());
			t = updateOst(strUpdate);
			t.extTie("R", this.parentNk.Fdoc, this.parentNk.Fnop);
			/*
				цену обновим отдельно, где она уже проставлена, там
				не трогаем, т.к. можно выписать с разными ценами
			*/
			if(xF1cena!=0)
				ExecuteSQL("Update "+OST_BUF+" SET F1cena="+xF1cena+" WHERE F1cena=0");
			//УЧТЕМ БУФЕР НАКЛАДНОЙ
			if(nOldFnmkl!=nmkl && nk.isBuf)
				checkOst(nk.tblRows,t,nmkl);

			//проверим, что хоть одна запись есть
			if(t.IsEmpty()){
				t = null;
				/*
					восстановить wait перед выходом
				*/
				__noWait = false;
				CLEARWAIT();
				_alert("Остатков нет.");
				noOst=true;
				return false;
			}else noOst=false;
			//ДАЛЬШЕ ПРОВЕРЯТЬ ТАБЛИЦУ С ОСТАТКАМИ НА НАЛИЧИЕ ЗАПИСЕЙ НЕ НУЖНО!
			AddFid_pnData(t);
			var strEdi = xFnmkl.tFcedib;
			if(xFnmkl.Fedi==1)strEdi = xFnmkl.tFedi1;
			var bHnd=true;			//делать ли ручной выбор
			var bRefresh=false;		//перестроить буфер просмотра
			//--считаем сумму (обязательно с учетом отрицательных остатков) доступную к выписке
			t.MoveFirst();
			var nSum=0;				//доступно к выписке
			var nKol=0;				//уже выписано
			var nOst=0;				//остаток
			//проход для суммирования
			while(!t.IsEof()){
				nSum+=(
						(podr==0 || t("Fpodr")==podr)
						 &&
						(mol==0  || t("Fmol")==mol)
					  )
						?t("Fost"):0;
				nKol+=t("Fkol");
				t.MoveNext();
			}
			nOst=nSum-nKol;
			nSum=nOst;//copy
			t.MoveFirst();
			/*
				восстановить wait
			*/
			__noWait = false;
			CLEARWAIT();
			if( !noOst && bAuto ){
				//тут выбор идет хитро
				bHnd=false;			//отключим ручной выбор
				var nChoice=2;
				if(nSum<xFkol){		//спросить пользовател
					nChoice=_msgbox(MSG_T_CENTER|MSG_B_PROPORTIONAL
							,"Введенное количество ("+String(xFkol/kf)+strEdi+") превышает остаток ("+String(round(nOst/kf, prmDecKol))+strEdi+")"
							,"Массовый выбор"
							,"Выход без сохранения"
							,"Выбрать вручную"
							,(nSum>0?"Выписать имеющееся": null)
							,(nk.param("_otlrasc")?"Довыписать отлож. расценив.":null)
							);
				}
				if(nOst<=0 && nChoice==2)nChoice++;
				nOst=nOst>0?nOst:0;
				switch(nChoice){
				case 1:		//ручной выбор
					bHnd=true;
					break;
				case 3:		//довыписка отложенным расцениванием
					bRefresh=true;
					t.index="anltk_dn";//наверху окажется запись с отлож. расцениванием
					if (SQL)
						t.index="FNMKL,FCENA,FPODR,FMOL,FSC,FSU,FPOST,FID_PN,FRTYPE,FDATE";
					t.MoveFirst();
					if(!t("Fis_otl")){		//ERROR
						_alert("DpMass::makeInput: Ошибка в таблице.");
						break;
					}
					t.Edit();
					t("Fwid")=nk.getUID();
					t("Fcena")=0;
					t("Fpost")=0;
					t("Fid_pn")=null;
					t("Fsc")=0;
					t("Fsu")=0;
					t("Fkol")=xFkol-nOst;	//разница
					t("Fkol_fas")=xFnmkl.Ffas1!=null?objKol.getFasQnt(xFkol-nOst):0;
					t("Fedi_fas")=objKol.getEdiFas();
					t.Update();		//выписываем дальше
				case 2:		//выписать имеющеес
//				if(_confirmd("Показать отобранное?"))
//					bHnd=true;//если открыть строку, то увидим записи
					if(nOst==0){//нечего выписывать
						if(nChoice==3)this.saveRows(nmkl);
						break;
					}
					if(xFkol>nOst)xFkol = nOst;//столько есть
					if(xFkol>0)
						this.makeChoice(	t,
											nk.param("_uchsel")==1,
											podr,
											mol,
											xF1cena,
											xFnmkl.Fedi,
											xFkol,
											objKol,
											xFnmkl);
					bRefresh=true;
					this.saveRows(nmkl);
					break;
				default :	//отказатся
					bRefresh=false;
				}
				//при ручном выборе проходим дальше
			}
			if(bHnd){		//ручной выбор
				//формируем параметры для выбора цепочек
				var p=new Object();
				p.tbl=t;
				p.kf=kf;
				p.Fnmkl=nmkl;
				p.Txt = xFnmkl.Ftxts;
				p.Ost = round(nSum/kf, prmDecKol);
				p.Edi = strEdi;
				p.Fpodr=podr;
				p.Fmol=mol;
				p.bMulty=true;
				p.objMass=this;
				p.bViewUch=nk.param("__viewuch");
				p.iOtpSel=iOtpSel;
				p.nMaxKol=nSum-nKol;
				//--запускаем окно для выбора
			if(this.nType != MASS_VDOST || isOBL)
				showWindow("l_ucena.htm",SW_MODAL,p);//HMR!!!
			else
			{
				var r = this.makeRow();
				r.setTable(t);//таблица
				r.setExtTable(null);
				var nMaxKol = p.nMaxKol;
				var nOldMaxKol=nMaxKol;
				if(t("Fkol")!=null)nMaxKol+=t("Fkol");
				r.nMaxKol=nMaxKol;
				var oObj = new Object();
				oObj.row=r;
				oObj.cMode = cMode;
				oObj.fost = t("fost");
				showWindow("getMASSkol.htm", SW_MODAL, oObj);
				if(!oObj.escape)
					nMaxKol-=t("Fkol");		//уменьшить максимальный остаток
				else nMaxKol=nOldMaxKol;
				this.saveRows("");
				oObj.row=null;
				r.Release();
			}
				p.objMass=null;
				p.tbl=null;
				bRefresh=!p.escape;
				if(p.escape){	//чистим цены
					var k = updateOst(" F1cena=0, Fkol=0");
					k = null;
				}
			}
			//перестраиваем буфер просмотра
			if(bRefresh)
				this.refreshBuffer(xFnmkl.getCod(), xF1cena, xFpodr, xFmol, xFsc, xFsu, xFid_pn);

			bRet=bRefresh;
			nOldFnmkl=nmkl;		//сохраним старую номенклатуру
			objKol.Release();

			break;
		default:
			alert("Неизвестный тип документа!")
			return;
		break;
	}

	return bRet;
}
//---------------------------------------------------------------------------
//получить файл с листом
function DpMass_getListHtml()
{
	var strRet="sergey.htm";//file not found
	if(this.nType==MASS_NMK)
		strRet = "l_clnmktree_mass.xml";
	else if(this.nType==MASS_PRICE)
		strRet = "l_price_mass.xml";
	else if(this.nType==MASS_VDOST)
		strRet = "|"+this.massMode+"|r_vdost_mass.xml";
//		strRet = "|VIEW|r_vdost.htm";
	return strRet;
}
//---------------------------------------------------------------------------
/*
	согласовать режим редактирования записи (ADD | EDIT)
	по буферу массового ввода
*/
function DpMass_getEditMode(tbl){
	this.openBuffer();
	var t=this.tblBuffer;
	if( t.isEmpty() )
		return "ADD";
	t.MoveFirst();
	if(this.nType == MASS_VDOST){
		//280102
		//по ведомости остатков надо учесть всю цепочку
		var kol	= tbl("mass.Fkol");
		if(typeof(kol)=="number")
			return "EDIT";
		//здесь возвращаем
		return "ADD";
	}else{
		var szFnmkl = this.nType==MASS_NMK?"Fcod":"Fnmkl";
		if (this.parentNk.Fdoc == "VR" || this.parentNk.Fdoc == "VP")
			szFnmkl = "Fnmkl";
		while(!t.IsEof()){
			//if(strcmp(t("Fnmkl"),tbl(szFnmkl))==0)//found!!!
			if(t("Fnmkl") == tbl(szFnmkl)
					&& (this.parentNk.Fdoc!="VR"
						//|| (t("fid_doc")==tbl("fid_doc"))
						|| (t("fid_pn0")==tbl("fwid")) // для VR в поле fid_pn0 прописывается fwid из порождаемой строки
						)
					)//found!!!
			{
				return "EDIT";
			}
			t.MoveNext();
		}
	}
	return "ADD";
}

//---------------------------------------------------------------------------
//сохранитьс
function DpMass_Save()
{
	__noWait = true;
	WAITTIMER("Сохранение данных ...");
	/*
		для возврата укажем
	*/
	nOldFnmkl = null;
	//запись данных в буфер накладной
	var nk = this.parentNk;

	if(nk != null)
	{
		//записать свои данные в буфер накладной
		nk.insertBuffer(MASS_BUF);
	}
	/*
		расчитаем fwid для возврата
	*/
	var t = OpenTable("s",
		"SELECT *"
		+ " FROM " + MASS_BUF
		+ (nk.oDoc.getPar("_nmksort")==1 ? " ORDER BY FNMKL" : " ORDER BY FNOM_STR")
		);

	if(t && !t.isEmpty())
	{
		t.MoveFirst();
		this.FWID = t.getValue("FWID");
	}
	t.Close(5652);
	t = null;

/*	t = OpenTable("s", MASS_BUF);
	for(; !t.IsEOF(); t.MoveNext())
	{
		//checkAnltkFwid(t("FWID"));
		//checkAnltkFwid(t("FID_PN"));
		if (t.getValue("FID_PN0"))
			checkAnltkFwid(t("FID_PN0"));
	}
	t.Close(5652);
	t = null;*/
	__noWait = false;
	CLEARWAIT();
}
//---------------------------------------------------------------------------
//дозагрузка строки (вызывается из редактирования строки)
function DpMass_loadRow(row)
{
	var nk = this.parentNk;
	if(row!=null){
		var szFnmkl = (this.nType==MASS_NMK)?"Fcod":"Fnmkl";
		if (this.parentNk.Fdoc == "VR" || this.parentNk.Fdoc == "VP")
			szFnmkl = "Fnmkl";
		if(nk.getVar("Fdoc")=="VR"){
			//фокус на количество
			if(row.Fkol.proxy==null)row.Fkol.focus();
		}else if(this.tbl!=null){
			row.Fnmkl.setCod(this.tbl(szFnmkl));//устанавливаем код номенклатуры
			if(row.Fkol_spr.proxy!==true)
				Enable(row.Fkol_spr, row.Fnmkl.Fedi_spr!=0);
			//фокус на количество
			if(row.Fkol.proxy==null)row.Fkol.focus();
		}
	}
}
//---------------------------------------------------------------------------
//object factory
//all this properties may be resetted
function DpMass_makeRow(){
	var objRet=	new DpNkRow();
	objRet.setParentNk(this.parentNk);
	objRet.setMassObject(this);
	//установить таблицу для сохранени
	objRet.setTable(this.tblBuffer);
	//в массовом выборе расширений нет
	objRet.setExtTable(t.getTie("#"));
	objRet.Fwid=null;
	return objRet;
}
//---------------------------------------------------------------------------
//сохранение строк (вызывается в расходных накладных)
//берем записи из таблицы с остатками
function DpMass_saveRows(strNmkl)
{
	/*
		возможен нюанс - в записи с отложенным расцениванием
		не будет проставлен МОЛ и подразделение, чтобы запись попала
		наверх при просмотре, поэтому здесь мы это корректируем
	*/
	__noWait = true;
	WAITTIMER("сохранение данных ...");

	var strFields = GetPatternIntersection(MASS_PATT, PTN_OST_BUF);
	var nk = this.parentNk;
	/*
		убрать старые записи
	*/
	ExecuteSQL("DELETE FROM "+MASS_BUF+" WHERE Fnmkl="+sqlTo(strNmkl));
	if(strFields=="")
	{
		return;//fuck
	}
	var max_num = 0;
	var tbl4num = OpenTable("s", "SELECT MAX(FNOM_STR) as MAX from " + MASS_BUF);
	if (!tbl4num.IsEmpty())
		max_num = tbl4num("MAX");
	if (max_num == null)
		max_num = 0;
	var tblOst = OpenTable("s", "SELECT * FROM "+getOstName()+" WHERE Fkol>0");
	for (; !tblOst.IsEOF(); tblOst.MoveNext())
	{
		tblOst.Edit();
		tblOst("FNOM_STR") = ++max_num;
		tblOst.Update();
	}

	ExecuteSQL("INSERT INTO "+MASS_BUF+"(" + strFields + ") SELECT "+strFields+" FROM "+getOstName()+" WHERE Fkol>0");
	if ( nk.Fdoc == "OC" )
		ExecuteSQL(	"UPDATE "+MASS_BUF+
				" SET F1KOL=FKOL "
				);
	else if ( nk.Fdoc == "NK" || nk.Fdoc == "SF" )
		ExecuteSQL(	"UPDATE "+MASS_BUF+
			" SET F1KOL=FKOL "
			+ (nk.getVar("fpodr") == 0 ? "" : ", FPODR="+sqlTo(nk.getVar("fpodr")))
			+ (nk.getVar("FMOL") == 0 ? "" : ", FMOL="+sqlTo(nk.getVar("FMOL")))
			);
	else
		ExecuteSQL(	"UPDATE "+MASS_BUF+
				" SET FPODR="+sqlTo(nk.getVar("fpodr"))+
				", FMOL="+sqlTo(nk.getVar("fmol"))+
				", F1KOL=FKOL "
				);
	/*
		переоткрываем буфер строк
	*/
	this.tblBuffer = OpenTable("m",MASS_BUF,"fwid");
	if (SQL)
		this.tblBuffer.Index = "FWID";
	this.tblBuffer.extTie("R", nk.Fdoc, nk.Fnop);

	CLEARWAIT();
	__noWait = false;
}
//---------------------------------------------------------------------------
//имя буфера просмтра
function DpMass_getViewBuffer()
{
	/*
		если можем выбирать только по одной записи, то просматриваем по основному буферу
	*/
	if(this.parentNk.oDoc.sDocLbl=="PN" || this.parentNk.oDoc.sDocLbl=="SA" || this.parentNk.oDoc.sDocLbl=="VR")
		return MASS_BUF;
	return MASS_BUF_S;
}

function DpMass_getBuffer()
{
	return MASS_BUF;
}

//---------------------------------------------------------------------------
//делаем выписку строк - FIFO,LIFO
function DpMass_makeChoice(
t,			/*таблица*/
bLifo,		/*режим*/
nFpodr,		/*подразделение*/
nFmol,		/*МОЛ*/
nFcena,		/*цена по которой будем выписывать*/
nFedi,		/*единицы измерения*/
nFkol,		/*желаемое количество*/
pKol,		/*объект ввода количества*/
pFnmkl		/*объект-номенклатура, для выписки*/
)
{
	var e = t.getTie("#");

	var oExt = new Object();

	if(e!=null && (e.topField(), e.isField()))
	{
		for(; e.isField(); e.nextField())
		{
			xl = e.getInfo("LABEL")
			oExt[xl] = input(e.getInfo("TXT"), e.getInfo("TXT"), 0, 6);
		}
	}


	var strOldInd	= t.index,	//предыдущий индекс
		bExit		= false,	//флаг конца выписки
		nTmp		= 0,		//переменная под временное количество
		nFasKol		= 0,
		nRet		= 0,		//фактически выписанное число
		iOtpSel = nk.param("_otpsel");	//где взять отпускную цену
	WAITTIMER("выписывается номенклатура ...");
	t.index			= "fpndate";	//в поле fdate будет записана дата поставки
	if(typeof(nFkol)!="number")nFkol=0;
	if( !t.IsEmpty() )	//встанем на первую запись
		if(!bLifo)t.MoveFirst();
		else t.MoveLast();
	//ПРОХОД ПО ТАБЛИЦЕ
	while( t.IsRecord() ){
		nTmp=0;
		if(
			!t("Fis_otl")						&&
			(nFpodr==0 || t("Fpodr")==nFpodr)	&&
			(nFmol==0  || t("Fmol")==nFmol)		&&
			t("Fost")>0							&&
			!bExit
		   ){
			//наша запись - берем
			if(t("Fost")>nFkol){
				nTmp	=	nFkol;
				bExit	=	true;	//выписано все
			}else{
				nTmp	=	t("Fost");
				nFkol	-=	nTmp;
			}
			//выписать
			t.Edit();										//!!!все что не влезло пойдет без фасовок
				t("Fwid")		= this.parentNk.getUID();
				t("Fedi")		= nFedi;
				for(xl in oExt)
				{
					t("#"+xl) = oExt[xl];
				}
				//сейчас можно выписывать автоматом процент от учетной цены
				if(iOtpSel==2)
					//это просто учетная цена
					t("F1cena")	= t("Fcena");
				else if(iOtpSel==3){
					//а здесь уже с процентом
					var fPrice	= t("Fcena");
					t("F1cena")	= fPrice + round(fPrice*this.m_fOldOtpProc/100, prmDecPri);
				}else if(iOtpSel==4){
					//тоже с процентом, но от другой цены
					var fPrice = tAnf(t("Fid_pn"), "1cena");
					if(typeof(fPrice)=="number")
						t("F1cena")	= fPrice + round(fPrice*this.m_fOldOtpProc/100, prmDecPri);
					else
						t("F1cena")	= 0.0;
				}else if(iOtpSel==5){
					//отпускная при приходе
					var fPrice = tAnf(t("Fid_pn"), "cenapr");
					if(typeof(fPrice)=="number")
						t("F1cena")	= fPrice + round(fPrice*this.m_fOldOtpProc/100, prmDecPri);
					else
						t("F1cena")	= 0.0;
				}else
					t("F1cena")	= nFcena;
				t("Fkol")		= nTmp;					//количество
				t("Fedi_fas")	= pKol.getEdiFas();		//какие фасовки
				t("Fkol_fas")	= pKol.getKolFas(nTmp);	//число полных фасовок
			t.Update();
			nRet+=nTmp;
		}else if(!t("Fis_otl")){
			//обнулить количество
			t.Edit();
			t("Fkol")=0;
			t.Update();
		}
		//перемещение
		if(!bLifo)t.MoveNext();
		else t.MovePrev();
	}
	//вернем индекс
	t.index=strOldInd;
	CLEARWAIT();
	return nRet;
}
//---------------------------------------------------------------------------
//destructor
function DpMass_Release()
{
	nOldFnmkl		=	null;
	this.tblBuffer	=	null;
	this.parentNk	=	null;
	DropTable(MASS_BUF);
	DropTable(MASS_BUF_S);
}
//---------------------------------------------------------------------------
//перестроить буферы
function DpMass_refreshBuffer(szFnmkl, xFcena, xFpodr, xFmol, xFsc, xFsu, xFid_pn)
{
	//для просмотра цена суммируется по номенклатуре
	//2801
	//при работе с ведомостью остатков - сумма по всей цепочке
	var strFields = GetPatternIntersection(MASS_PATT, PTN_OST_BUF);
	if(this.nType == MASS_VDOST)
	{
		var sFields	=
			"a.Fnmkl,a.Fcena,a.Fpodr,a.Fmol,a.Fsc,a.Fsu,a.Fpost,a.Fid_pn";

		ExecuteSQL(
			"DELETE FROM "+MASS_BUF_S
			+ " WHERE Fnmkl="+sqlTo(szFnmkl)
				+ sqlw0And("Fcena=", xFcena)
				+ sqlw0And("Fpodr=", xFpodr)
				+ sqlw0And("Fmol=", xFmol)
				+ sqlw0And("Fsc=", xFsc)
				+ sqlw0And("Fsu=", xFsu)
				+ sqlw0And("Fid_pn=", xFid_pn)
			);

		ExecuteSQL(
			"INSERT INTO "+MASS_BUF_S+"(Fkol, " + strFields + ")"
			+ " SELECT SUM(a.Fkol) AS Fkol"
				+ "," + sFields
			+ " FROM "+MASS_BUF+" a"
			+ " WHERE Fnmkl="+sqlTo(szFnmkl)
			+ " GROUP BY "+sFields
			);
	}
	else
	{
		ExecuteSQL(
			"DELETE FROM "+MASS_BUF_S
			+ " WHERE Fnmkl="+sqlTo(szFnmkl)
			);

		ExecuteSQL(
			"INSERT INTO "+MASS_BUF_S+"(Fkol, fnmkl)"
			+ " SELECT SUM(a.Fkol) AS Fkol,a.Fnmkl"
			+ " FROM "+MASS_BUF+" a"
			+ " WHERE Fnmkl="+sqlTo(szFnmkl)
			+ " GROUP BY a.Fnmkl"
		);
	}
}
//---------------------------------------------------------------------------
function DpMass_getTBuffer()
{
	return this.tblBuffer;
}
/*
	открытие буфера по новой
*/
function DpMass_openBuffer()
{
	this.tblBuffer	=	OpenTable("m",MASS_BUF);
	if(this.tblBuffer)
		this.tblBuffer.ExtTie("R", nk.oDoc.sDocLbl+".ROW", String(nk.oDoc.nNop));
}
/*
	расчет остатков для прайса
*/
function DpMass_recallFromPrice(Fnmkl,Fmol,Fpodr,Fsc,Fsu)
{
	/*
		через параметры нам сообщают какой был прайс

		если есть динамический расчет остатков, то
		их нужно расчитать
	*/
	//if(!getPar("DYNAOST"))
	//	return false;
	WAIT("Предварительный расчет остатков...");
	var nk = this.parentNk;
	/*
		корректируем входные параметры
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		13.08.2001 S. Komarov
		счет и субсчет мы не принимаем во внимание
	*/
	//if(isEmpty(Fdat))
	//	Fdat = null;
	if(isEmpty(Fnmkl)) 
		Fnmkl = nk.oDoc.getVar("HNMKL");
	if(isEmpty(Fmol))
		Fmol = nk.oDoc.getVar("HMOL");
	if(isEmpty(Fpodr))
		Fpodr = nk.oDoc.getVar("HPODR");
	/*
		проверим данные на соответствие -
		МОЛ, подр. не должны
		отличаться от тех, что в накладной
	*/
	var bNoData = false;
	if(Fpodr != 0 && nk.oDoc.getVar("HPODR") != Fpodr)
		bNoData = true;
	else if(Fmol != 0 && nk.oDoc.getVar("HMOL") != Fmol)
		bNoData = true;

	CreateTable(PRICE_OST, PTN_OST_BUF, "Fnmkl");

	if(bNoData == false && getPar("isclost") && false)
	{
		include("Objects\\DpKolos.js");
		with(new DpKolos())
		{
			tblName = PRICE_OST;
			calc("INSERT", new Date(nk.getVar("FDOC_DAT")));
		}
	}
	else if(!bNoData)
	{
		/*
			здесь данные накладной мы должны использовать
			вместо данных прайса
		*/
		/*
			таблица под остатки для прайса
		*/
		var sOstTable	= "tmp_"+PRICE_OST;
		with(new DpMtrOb())	
		{
			/*
				сначала делаем расчет во временную таблицу
			*/
			tblName	= sOstTable;
			fdate	= new Date(nk.oDoc.getVar("HDAT"));
			fpodr	= nk.oDoc.getVar("Hpodr");
			fmol	= nk.oDoc.getVar("Hmol");

			fsc = nk.oDoc.getVar("hsc");
			fsu = nk.oDoc.getVar("hsu");
			fst = nk.oDoc.getVar("hst");

			isFostsum = false;
			pattern = PTN_OST_BUF;
			doCalc();
		}
		//checkOstByDoc(nk.Fdoc, sOstTable);
		/*
				теперь суммируем для вывода в прайсе,
				нужно все просуммировать по номенклатуре
		*/
		ExecuteSQL(	" INSERT INTO "+PRICE_OST+ "(Fnmkl, Fost1)"+
					" SELECT Fnmkl AS Fnmkl, SUM(Fost) AS Fost1"+
					" FROM tmp_"+PRICE_OST+" GROUP BY Fnmkl");
		/*
			дальше временная таблица уже не нужна
		*/
		DropTable("tmp_"+PRICE_OST);
		/*
			нужно учесть буфер нашей накладной
		*/
		//checkOst(nk.tblRows, PRICE_OST);
	}
	else
		_alert(	"Используемый прайс-лист не соответствует накладной."+
				"\nПодразделение "+Fpodr+" - "+nk.oDoc.getVar("HPODR")+
				"\nМОЛ "+Fmol+" - "+nk.oDoc.getVar("HMOL")+
				"\nВсе номенклатуры будут без остатков.");

	CLEARWAIT();
	return true;
}
//--------------------------------------EOF----------------------------------
