function DpOrg(fwid, d1, d2)
{
	this.fwid = 0;
	this.fwid_cl = 0;
	this.textObj = null;
	this.useSmallText = false;
	this.isZaval = false;	
	
	this.dpDol = null;
	this.dpPers = null;
	
	this.setFWID = DpOrg_setFwid;
	this.getFWID = DpOrg_getFwid;
	this.setFWID_CL = DpOrg_setFWID_CL;
	this.linkCtrl   = DpOrg_linkCtrl;
	this.updateCtrl = DpOrg_updateCtrl;
	this.validCtrl = DpOrg_validCtrl;
	this.zaval = DpOrg_zaval;
	this.setPeriod = DpOrg_setPeriod;
	this.getDpDol = DpOrg_getDpDol;
	this.setDpDol = DpOrg_setDpDol;
	this.setDpPers = DpOrg_setDpPers;
	
	this.findFirstOrg = DpOrg_findFirstOrg;
	this.findFirstPers = DpOrg_findFirstPers;
	this.getSQL_CL = DpOrg_getSQL_CL;
	
	this.setFWID(fwid);
	this.setPeriod(d1, d2);
}

function DpOrg_setFwid(fwid)
{
	if (typeof fwid != "undefined")
		this.fwid = Number(fwid);
	else
		this.fwid = 0;
	if (this.dpDol != null)
	{		
		if (!this.dpDol.findFirstDol(this.isZaval))
		{
			Disable(this.dpDol.textObj);
		}
		else
		{
			Enable(this.dpDol.textObj, true);
		}
	}
	if (this.dat1 != null && this.dat2 != null)
		return this.updateCtrl();
	return false;
}

function DpOrg_getFwid()
{
	return this.fwid;
}

function DpOrg_setFWID_CL(fwid_cl)
{
	this.fwid_cl = fwid_cl;
}

function DpOrg_setDpDol(dpDol)
{
	this.dpDol = dpDol;
	this.dpDol.setDpOrg(this);
	if (this.dpPers != null)
		this.dpDol.setDpPers(this.dpPers);
}

function DpOrg_setDpPers(dpPers)
{
	this.dpPers = dpPers;
	this.dpPers.dpOrg = this;
	if (this.dpPers.ctrlCod != null)
	{
		this.dpPers.validDpPers = DpOrg_validDpPers;
		setValid(this.dpPers.ctrlCod, this.dpPers, "validDpPers");	
	}
	if (this.dpDol != null)
		this.dpDol.setDpPers(this.dpPers);
}

function DpOrg_getDpDol()
{
	return this.dpDol;
}

function DpOrg_setUseSmallText(bool)
{
	this.useSmallText = Boolean(bool);
}

function DpOrg_setPeriod(d1, d2)
{
	try
	{
		if (typeOf(d1) == "Date")
			this.dat1 = d1;
		else
			this.dat1 = toScriptDate(d1).getVarDate();
		if (typeOf(d2) == "Date")
			this.dat2 = d2;
		else
			this.dat2 =  toScriptDate(d2).getVarDate();
	}
	catch(e)
	{
		this.dat1 = null;
		this.dat2 = null;
	}
	if (this.fwid != 0)
		this.updateCtrl();
	if (this.dpDol != null)
		this.dpDol.setPeriod(this.dat1, this.dat2);
}

function DpOrg_linkCtrl(oCtrlOrg, oCtrlDol)
{
	if (typeof oCtrlOrg == "undefined")
		return;
	this.textObj = oCtrlOrg;
	this.textObj.isButton = true;
	this.fillContAssist = DpOrg_fillContAssist;
	this.textObj.setContentAssistHandler(this, "fillContAssist", "setFWID");
	setValid(this.textObj, this, "validCtrl");	
	setButton(this.textObj, this, "zaval");
	this.updateCtrl();
	/*if (typeof oCtrlDol != "undefined")
	{
		include("objects/DpDol.js");
		this.dpDol = new DpDol(this.getFWID(), this.dat1, this.dat2);
		this.dpDol.linkCtrl(oCtrlDol);
	}*/	
}

function DpOrg_updateCtrl()
{
	if (this.dat1 == null || this.dat2 == null)
	{
		this.fwid = 0;
		if (this.textObj != null)
			this.textObj.value = "";
		return false;
	}
	var snap = getSnap("SELECT ftxt, ftxts FROM ^stru_org WHERE fwid=" + sqlTo(Number(this.fwid))
			+ " AND fbdat<=" + sqlTo(this.dat2) + " AND fedat>=" + sqlTo(this.dat1));
	if (snap == null)
	{
		this.fwid = 0;
		if (this.textObj != null)
			this.textObj.value = "";
		return false;
	}
	else
	{
		if (this.textObj != null)
			this.textObj.value = snap[Number(this.useSmallText)];
		return true;
	}	
}

function DpOrg_validCtrl()
{
	if (!this.updateCtrl())
		return this.zaval();
	return true;
}

function DpOrg_zaval()
{
	if (this.dat1 == null || this.dat2 == null)
	{
		include ("Objects/DpGetDat.js");
		var gd = new DpGetDat("dD");
		if (!gd.dat1 || !gd.dat2)
			return false;
		this.setPeriod(gd.dat1, gd.dat2);
	}			
	var par = new Object();
	par.escape = true;
	par.dat1 = this.dat1;
	par.dat2 = this.dat2;
	par.fwid = this.getFWID();
	showWindow("e_stru_org.xml", SW_MODAL, par);
	if (!par.escape)
	{
		this.isZaval = true;
		var result = this.setFWID(par.fwid);
		this.findFirstPers();
		this.isZaval = false;
		return result;
	}
	return false;
}


function DpOrg_fillContAssist(ca)
{
	if (this.dat1 == null || this.dat2 == null)
		return;
	var str = this.textObj.value;	
	var strSQL = "SELECT o.fwid, o.flv1, o.ftxt AS org_text, p.ftxt AS par_text "
			+ " FROM ^stru_org AS o INNER JOIN ^stru_org AS p ON o.fwid_par=p.fwid "
			+ " WHERE o.fwid_par > 0 "
			+ (this.dpPers != null ? " AND o.fwid IN (" + this.getSQL_CL(this.dpPers.getFWID()) + ") ": "")
			+ " AND o.ftxt LIKE "	+ sqlTo(str + "%") + " ORDER BY o.fleftkey";
	var tblChoose = OpenTable("s", strSQL);
	while (!tblChoose.isEOF())
	{
		var sCod = tblChoose.getValue("fwid");
		var sText = tblChoose.getValue("org_text");
		var sParText = tblChoose.getValue("par_text");
		ca.addRow(sCod, new Array(sText, sParText));
		tblChoose.MoveNext();
	}
}

// если установлен справочник персонала - используются данные функции
function DpOrg_findFirstPers()
{
	if (this.dpPers == null)
		return false;
	if (this.dpDol != null)
		return this.dpDol.findFirstPers();
	var snap = getSnap("SELECT DISTINCT wp.fwid_cl FROM ^work_pers AS wp "
				+ " WHERE wp.fwid_dol IN (SELECT DISTINCT d.fwid FROM ^stru_dol AS d "
					+ " WHERE d.fwid_org=" + sqlTo(this.dpDol.getFWID()) + " ORDER BY d.fwid) "
						+ " ORDER BY wp.fwid");
	if (snap == null)
		return false;
	this.setFWID_CL(snap[0]);
	this.dpPers.setFWID(snap[0]);
	return true;
}

function DpOrg_getSQL_CL(fwid_cl)
{
	return "SELECT DISTINCT o.fwid_org FROM ^stru_dol AS o "
			+ " WHERE o.fwid IN (SELECT DISTINCT wp.fwid_dol FROM ^work_pers AS wp "
				+ " WHERE wp.fwid_cl=" + sqlTo(Number(fwid_cl)) + " AND fedat=" + SqlMaxDate + ")";
}

function DpOrg_findFirstOrg(fwid_cl)
{
	var snap = getSnap(this.getSQL_CL(fwid_cl));
	if (snap == null)
	{
		this.setFWID(0);
		Disable(this.textObj);
		return false;
	}
	else
	{		
		Enable(this.textObj, true);
		this.setFWID(snap[0]);
		return true;
	}	
}

function DpOrg_validDpPers()
{
	if (this.dpOrg.fwid_cl != this.getFWID())
	{
		this.dpOrg.fwid_cl = this.getFWID();
		this.dpOrg.findFirstOrg(this.getFWID());
	}
}