// JScript source code
include("objects\\DpXMLDOmDocument.js");
function DpPluginDoc(sID)
{
	var sSQL = "select flib, fdir from ^plugin_objs o, ^plugins p "
		+"where p.fwid = o.fwid_plugin and o.fid = "+sqlTo(sID);
	var oSnap = getSnap(sSQL);
	if(!oSnap)
	{
		alert("Отсутствует библиотека объекта");
		return;
	}
	
	this.objFile = rootDirectory()+"plugins\\"+oSnap[1]+"\\"+oSnap[0];
	this.xmlDom = new DpXMLDOMDocument();
	this.xmlDom.load(this.objFile);
	this.xmlRoot = this.xmlDom.getDocumentElement();
	this.getHFile = DpPluginDoc_getHFile;
	this.loadDocClass = DpPluginDoc_loadDocClass;
	this.buildGrid = DpPluginDoc_buildGrid;
	this.sHTbl = null;
	this.sRTbl = null;
	this.editDoc = DpPluginDoc_editDoc;
	this.getForm = DpPluginDoc_getForm;
	this.loadDocClass();	
}

function DpPluginDoc_loadDocClass()
{
	this.sLbl = this.xmlRoot.getAttribute("type");
	this.sVer = this.xmlRoot.getAttribute("version");
	var xmlTbl = this.xmlRoot.selectSingleNode("tables");
	if(xmlTbl)
	{
		var xmlHead = xmlTbl.selectSingleNode("header");
		if(xmlHead)
		{
			var tbl = xmlHead.selectSingleNode("table");
			if(tbl)
				this.sHTbl = tbl.getAttribute("name");
		}
		var xmlRows = xmlTbl.selectSingleNode("rows");
		if(xmlRows)
		{
			var tbl = xmlRows.selectSingleNode("table");
			if(tbl)
				this.sRTbl = tbl.getAttribute("name");
		}
	}
	var xmlList = this.xmlRoot.selectSingleNode("list");
	if(xmlList)
	{
		this.xmlGrid = xmlList.selectSingleNode("grid");
	}
	this.xmlForm = this.xmlRoot.selectSingleNode("form");
	
	
}

function DpPluginDoc_editDoc(oPar)
{
	oPar.plugDoc = this;
	showWindow("e_plugdocdlg.htm",SW_MODAL,oPar);
	//alert(oPar.mode);
}

function DpPluginDoc_getHFile()
{
	return "^"+this.sHTbl;
}

function DpPluginDoc_getForm()
{
	return this.xmlForm;
}

function DpPluginDoc_buildGrid()
{
	include("objects\\DpGrid.js")
	var oGrid = new DpGrid("NOCREATE");
	oGrid.buildFromXML(this.xmlGrid.xmlNode);
}