// Объект для работы с прайс-листами

function DpPrList()
{
	this.linkCtrl	= DpPrList_linkCtrl;
	this.zaval		= DpPrList_zaval;
	this.setCod		= DpPrList_setCod;
	this.getCod		= DpPrList_getCod;
	this.validCtrl 	= DpPrList_validCtrl;
	this.updateCtrl = DpPrList_updateCtrl;
	this.setMode 	= DpPrList_setMode;
	this.load		= DpPrList_load;
	//this.loadByDate = DpPrList_loadByDate;
	this.getTCen	= DpPrList_getTCen;
	this.initGrid	= DpPrList_initGrid;
	this.grAddCena	= DpPrList_grAddCena;
	this.menuInit 	= DpPrList_menuInit;
	this.menuRun	= DpPrList_menuRun;
	this.src 		= DpPrList_src;
	
	this.tbl		= null;
	this.Ctrl		= null;	
	this.Fcod		= "";	
	this.zavalInto 	= "l_cl_pri.xml";
	this.mode = "";	
	pr = this;
}

function DpPrList_linkCtrl(ctrl)
{
	if(ctrl!=null)
	{
		ctrl.mask = "&";
		ctrl.value = this.getCod();
		this.Ctrl = ctrl;
		setValid(ctrl, this, "validCtrl");
		setButton(ctrl, this, "zaval");
	}
}

function DpPrList_updateCtrl()
{
	if(this.Ctrl != null)
		this.Ctrl.value = this.getCod();
}

function DpPrList_validCtrl()
{
	var pCod = this.Ctrl.value.toUpperCase();
	this.Ctrl.value = pCod;
	this.setCod(pCod);

	if(!this.isValid)
		this.zaval();
	
	return this.isValid;
}

function DpPrList_zaval()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	if(typeof(this.Ctrl)=="object")
	   par.ret.fcod = this.Ctrl.value;
	par.ret.fwid = null;
	
	showWindow(this.zavalInto, SW_MODAL, par);

	if( !par.escape )
	   this.setCod(par.ret.fcod);
}

function DpPrList_setCod(newCod)
{
	if(String(this.Fcod) == String(newCod))
		return;
				
	this.Fcod = String(newCod).toUpperCase();	
	var oSnap = getSnap("select fwid from ^cl_pri where Fcod = "+ sqlTo(this.Fcod));
	this.isValid = oSnap!=null;
	
	this.updateCtrl();
	return this.isValid;
}

function DpPrList_getCod()
{
	return this.Fcod;
}

function DpPrList_setMode(mode)
{
	this.mode = mode;
	this.setCod(this.getCod());
}

/*
function DpPrList_loadByDate(cod, date)
{
	var tbl = OpenTable("s", 
		"select fwid, fdat"
		+ " from ^cl_pri"
		+ " where fcod=" + sqlTo(cod)
			+ " AND fdat<=" + sqlTo(date)
		+ " order by fdat"
		);
	
	if (tbl.IsEOF())
	{
		alert("Прайс лист типа '" + cod + "' на дату " + format("dd.mm.yy", date) + " не найден")
		
		return null;
	}
	
	return this.load(tbl.getValue("fwid"));
}
*/

function DpPrList_load(pId)
{	
	this.id = pId;
	this.zMode = null;
	this.Ftxts = null;
	bAsk  = false;
	szFost	= "fost";	
	szFost1	= "fost1";
	bMass = list.par.mode=="MASS";
	
	pr.tbl = OpenTable("s","select * from ^cl_pri where fwid="+ Number(this.id));
	fcod = pr.tbl.getValue("fcod");
	fdat = pr.tbl.getValue("fdat");
	this.fpressed = pr.tbl.getValue("fpressed");
	this.name = pName(fcod, fdat, pId);
	
	oRecalc = new Object();
	oRecalc.fcod 	= fcod;
	oRecalc.fdat 	= fdat;
	oRecalc.fnmkl 	= pr.tbl.getValue("fnmkl");	
	oRecalc.fmol 	= pr.tbl.getValue("fmol");	
	oRecalc.fpodr 	= pr.tbl.getValue("fpodr");
	oRecalc.fsc 	= pr.tbl.getValue("fsc");
	oRecalc.fsu 	= pr.tbl.getValue("fsu");
	
	if(bMass)
		bDynaOst = list.par.mass.recallFromPrice(
					pr.tbl.getValue("fnmkl"),
					pr.tbl.getValue("fmol"),
					pr.tbl.getValue("fpodr"),
					pr.tbl.getValue("fsc"),
					pr.tbl.getValue("fsu"));
}

function DpPrList_src(ds)
{
	if(!ds)
		ds = list;	
		
	ds.qrySet("From", pr.name,
			  "Order", new Array("fnmkl,forg,ftt DESC"),
			  "WhereArr", new Array( "Ftt='NM'" 
			  		+ ((pr.zMode != "t")? "" 
			  			: " AND fnmkl in (SELECT fcod as fnmkl FROM ^CL_NMK "
							+"WHERE ftxts LIKE " + sqlTo(pr.Ftxts + SqlStr4Like) + " )")),
			  "Ptn", "PRICE"
			);
		
	if (pr.zMode == "l")
	{
		var tmptbl = OpenTable("s", "CL_NMK", "LINECOD");
		if (SQL)
			tmptbl.index = "FLINECOD";
		//if (tmptbl.Seek(">=", par.Flinecod))
		if (tmptbl.FindFirst("FLINECOD>="+ par.Flinecod))
			par.ret.FNMKL = tmptbl.getValue("Fwid");
	}	
	
	if (SQL)
	{
		ds.subTie("cl_nmk", "nmk", "fwid", "Fnmkl", null, TIE_NOSEARCH);
		ds.subTie("cl_edi", "ed", "fcod", "nmk.Fcedib", "getTie('nmk')",TIE_NOSEARCH);
	}
	else
	{
		ds.subTie("cl_nmk", "nmk", "fwid", "Fnmkl", null, TIE_NOSEARCH);
		ds.subTie("cl_edi", "ed", "cod", "nmk.Fcedib","getTie('nmk')",TIE_NOSEARCH);
	}
	/*
		если идет массовый ввод, то нужно добавить
		связку для просмотра введенных значений
	*/
	if(bMass)
	{
		if (SQL)
			ds.subTie(ds.par.mass.getViewBuffer(),"mass","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
		else
			ds.subTie(ds.par.mass.getViewBuffer(),"mass","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
		if(bDynaOst)
		{
			if (SQL)
				ds.subTie(ds.par.mass.RestTable,"ost","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
			else
				ds.subTie(ds.par.mass.RestTable,"ost","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
			/*
				переопределим поле для остатка
			*/
			szFost = "ost."+ ds.par.mass.RestField;
			szFost1 = "ost."+ ds.par.mass.RestField;
		}
	}
	ds.title = ru("Прайс-лист типа " + fcod + " на дату " + StrDat(fdat,"DMY"),
				  "Прайс-лист типу " + fcod + " на дату " + StrDat(fdat,"DMY"));
}

function DpPrList_getTCen(id, m)
{
	if(!m)
		var m = new Object();
	
	var cena = null;
	if(id)
		cena = getSnap("SELECT ftcena,ftcena1,ftcena2,ftcena3,ftcena4,"
							+ " ftcena5,ftcena6,ftcena7,ftcena8,ftcena9 "
						+ " FROM ^cl_pri" 
						+ " WHERE FWID=" + sqlTo(Number(id)));
	
	for(var n=0; n<10; n++)
		m[n] = cena!=null? cena[n] : (UR("Ціна ","Цена ") + (n!=0? n : ""));
		//m[n] = cena!=null? cena[n] : (n==0? UR("Ціна ","Цена ") : "");
		
	return m;
}

function DpPrList_initGrid(pId, gr)
{	
	//include("Objects\\DpGrid.js");	
	if(!gr)
		gr = new DpGrid("NOCREATE");
	gr.DeletePages();

	//var cCond = "=CBool(^ftt=\"NM\")";   
	//var r = gr.row(cCond);
   	//gr.page().textColor(colorLevel(1));
	gr.defCond("=^Ftt=='NM'", "NM");
	//gr.color(1, "NM");
	
	with(gr.page())
	{		
		//FieldEx(getPar("SHOWNMK")? "=(^nmk.Fcod)+\" : \"+(^nmk.Ftxts)" : "nmk.ftxts"
		//		, "Номенклатура|Номенклатура", 15);
		FieldEx("nmk.FCOD", "Код|Код", 10);
		FieldEx("=nmkTxt(^FNMKL)", "Номенклатура|Номенклатура", 20);
		
		FieldEx("FORG","Організація|Организация", 8, null);
		FieldEx("=^FPODR?^podr.ftxt:''","Пiдроздiл|Подразделение", 8, null);		
		//FieldEx(szFcena,"Ціна|Цена", 8, null, DP_FORMAT_PRI);
		
		if(bMass)
			FieldEx("mass.Fkol","Виписано|Выписано", 15, null, DP_FORMAT_KOL);
		
		this.grAddCena(gr, pId);
		
		FieldEx(szFost,"Залишок|Остаток", bMass?15:13, null, DP_FORMAT_KOL);
		FieldEx(szFost1,"Зал. з рез.|Ост. с рез.", bMass?15:13, null, DP_FORMAT_KOL)
		FieldEx(eval("\"=^"+szFost+"-^"+szFost1+"\""),"Зарезервов.|Зарезервир.", 13,null, DP_FORMAT_KOL);
		FieldEx("ed.ftxts","Од.|Ед.", 3);
		FieldEx("nmk.Flinecod","Штрихкод", 15);
		FieldEx("FPODR", "Код пiдроздiлу|Код подразделения", 8, null);
	}
	gr.build();
	return gr;
}

function DpPrList_grAddCena(gr, pId)
{	
	var m = this.getTCen(pId);
	with(gr.page())
	{		
		FieldEx("Fcena", m[0], 8, null, DP_FORMAT_PRI);	
		for(var n=1; n<10; n++)
		{			
			if(m[n]!="" && m[n]!=null && m[n]!=" ")
				FieldEx("Fcena"+n, m[n], 8, null, DP_FORMAT_PRI);		
		}
	}
}

function DpPrList_menuInit()
{
	var ds = list.dataSrc;
	/*
		если идет массовый выбор,
		то меню нет
	*/
	
	
	
	if (list.par.isMass)
	{
		var sVid = list.tbl.getValue("NMK.FVID")
		if (sVid == null || allt(String(sVid)) != "S")
		{
			if(extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_RS || extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_PMR)
				grid.AddMenuItem("ADDNKROWFIFO", "Добавить в накладную (FIFO)")
		}
			
		grid.AddMenuItem("ADDNKROW", "Добавить в накладную")
		
		if (grid.getSelectedCount())
		{
			grid.AddMenuItem("ADDSELNKROW", "Добавить выбранные в накладную")
		}
		grid.AddMenuItem("", "");
	}

	
	if(!list.tbl.IsEmpty())
	{
		ds.AddMenuItem("CHANGE","Змінити ціну|Изменить цену");
		//ds.AddMenuItem("RECOUNT_REST","Перерахувати залишки|Перерассчитать остатки");
		ds.AddMenuItem("RECOUNT_OST","Проставити залишки|Проставить остатки");
		ds.AddMenuItem("RECOUNT_CENA","Проставити облікову цiну з відомості залишків|Проставить учетную цену из ведомости остатков");
		ds.AddMenuItem("RECOUNT_CENAPR_OST","Проставити цiну реалізації з відомості залишків|Проставить цену реализации из ведомости остатков");
		ds.AddMenuItem("RECOUNT_CENAPR","Проставити цiну реалізації з довідника номенклатури|Проставить цену реализации из справочника номенклатуры");
		if(IsTable("REST_PROTOCOL"))
			ds.AddMenuItem("PROTOCOL","Перегляд протоколу перерахунку залишків|Просмотр протокола пересчета остатков");		    
	}
	ds.AddMenuItem("", "");	
	ds.AddMenuItem("COMPLEMENT","Доповнити із довідника номенклатури|Дополнить из справочника номенклатуры");
	if(!list.tbl.IsEmpty())
		ds.AddMenuItem("COPY_TO", "Копіювати до буферу|Копировать в буфер");
	if(IsTable("TMP_PRI_COPY"))
		ds.AddMenuItem("PASTE", "Вставити з буферу|Вставить из буфера");
	ds.AddMenuItem("", "");	
	//ds.AddMenuItem("MUL","Умножить цену на коеффициент");
	//ds.AddMenuItem("ROUND","Округлить цену");
	//ds.AddMenuItem("MOVE","Цена (грн)-> Цена (грн)");
	//ds.AddMenuItem("VAL","Выражение->цена");
}

function DpPrList_menuRun(ID)
{
	include("mtr_ost.js");
	
	if (ID == "ADDNKROWFIFO")
	{
		var sVid = list.tbl.getValue("NMK.FVID")
		if (sVid != null && allt(String(sVid)) == "S")
		{
			ID = "ADDNKROW";
		}
	}
	
	var ppar;
	var ds = list.dataSrc;
	var tbl = grid.getTable();
		
	with( list )
	{
		switch(ID)
		{
		case "CHANGE":			
			ppar = new Object();
			ppar.escape = true;
			showWindow("e_change.xml", SW_MODAL, ppar, "");
			if(ppar.escape)
				return;
				
			var tmp_tbl = OpenTable("s","SELECT * FROM "+ qryFrom +" WHERE "+ ds.sqlSelected());
			oEval = new DpEval();
			oEval.setForm("LIST", "PRICE");
			oEval.setTable(tmp_tbl);		
			
			var field = "fcena" + (ppar.Cena == "0"? "" : ppar.Cena);
			while(!tmp_tbl.IsEOF())
			{
				var expr  = round(oEval.eval(ppar.Expression), ppar.Symbol);
				var txt   = "tmp_tbl.setValue(\""+ field +"\")" + "=" 
							+ (ppar.Run == "="?  expr : 
							"tmp_tbl.getValue(\""+ field +"\")" + ppar.Run + expr);
				
				var res = eval(ppar.Run == "="?  expr : tmp_tbl.getValue(field) + ppar.Run + expr);
				tmp_tbl.Edit();
				//eval(txt)
				tmp_tbl.setValue(field, res);
				tmp_tbl.Update();				  
				tmp_tbl.MoveNext();				 
			}
			tmp_tbl.close();
			grid.getTable().requery(); 
			break;
			
		case "RECOUNT_CENA":
		case "RECOUNT_CENAPR_OST":
			include("Objects\\DpGetDat.js");				
			var gd = new DpGetDat(new Array("dat2"));
			if (gd.escape)
				return false;
			
			WAIT(UR("Виконується розрахунок залишків...|Выполняется расчет остатков..."));			
			var oMtr = new DpMtrOb();
			oMtr.tblName = "TMP_RST_MTR";
			ExecuteSQL("DROP TABLE "+ oMtr.tblName, false);
			oMtr.fdate = gd.fdat;
			if(grid.getSelectedIDs().length<=1)
				oMtr.fnmkl = tbl.getValue("fnmkl");			
			oMtr.doCalc();
			CLEARWAIT();
			
			var nCena = 0;
			var selCol = grid.getActiveCol();
			var sFldName = String(grid.getFieldsName()[selCol]);
			if(sFldName && sFldName.toUpperCase().indexOf("FCENA")!=-1)
				nCena = Number(sFldName.substring(sFldName.length-1));
			var sCapt = UR("Введіть номер ціни|Введите номер цены");
			var sMsg = UR("Ціна № |Цена № ");
			nCena = input(sMsg, sCapt, nCena, 1);
			if(nCena==null)
				return;
			if(nCena==0)
				nCena = "";
			var id = grid.getTable().getValue("FWID");
			var sWhere = " where FWID="+ sqlTo(id);
			if(grid.getSelectedIDs().length>1)
				sWhere = " where "+ grid.sqlSelected();
			sWhere += " and exists(select v.FCENA from "+ oMtr.tblName +" v where v.FNMKL="+ this.name +".FNMKL)";
			
			var sSql = "update "+ this.name 
					+" set FCENA"+ nCena +"=(select max(v.FCENA) from "+ oMtr.tblName +" v where v.FNMKL="+ this.name + ".FNMKL)"
					+ sWhere;
			if (ID == "RECOUNT_CENAPR_OST")
			{
				sSql = "update "+ this.name
					+" set FCENA"+ nCena +"=(select max(pn1.FCENAPR) from "+ oMtr.tblName +" v left join ^anltk pn1 on v.fid_pn = pn1.fwid where v.FNMKL="+ this.name + ".FNMKL)"
					+ sWhere;
					
			}		
			ExecuteSQL(sSql);
			grid.getTable().requery();			
			break;
		case "RECOUNT_OST":
			include("Objects\\DpGetDat.js");				
			var gd = new DpGetDat(new Array("dat"));
			if (gd.escape)
				return false;
			var id = grid.getTable().getValue("FWID");
			WAIT(UR("Виконується розрахунок залишків...|Выполняется расчет остатков..."));			
			var oMtr = new DpMtrOb();
			oMtr.tblName = "TMP_RST_MTR";
			ExecuteSQL("DROP TABLE "+ oMtr.tblName, false);
			oMtr.fdate = gd.fdat;
			if(grid.getSelectedIDs().length<=1)
				oMtr.fnmkl = tbl.getValue("fnmkl");			
			oMtr.doCalc();
			CLEARWAIT();
			
			var sWhere = " where FWID="+ sqlTo(id);
			if(grid.getSelectedIDs().length>1)
				sWhere = " where "+ grid.sqlSelected();
			sWhere += " and exists(select v.FNMKL from "+ oMtr.tblName +" v where v.FNMKL="+ this.name +".FNMKL)";
			var sSql = "update "+ this.name +" "
					+" set FOST =(select sum(v.FOST) from "+ oMtr.tblName +" v where v.FNMKL= " + this.name+ ".FNMKL)"
					+ sWhere;
			ExecuteSQL(sSql);
			grid.getTable().requery();			
			break;
			
		case "RECOUNT_CENAPR":
			
			var nCena = 1;
			
			var nameCena = pr.getTCen(list.par.fwid)[1];			                               
			if (!nameCena || nameCena == "")
			{
				nCena = 0;
			}
			
			var selCol = grid.getActiveCol();
			var sFldName = String(grid.getFieldsName()[selCol]);
			if(sFldName && sFldName.toUpperCase().indexOf("FCENA")!=-1)
				nCena = Number(sFldName.substring(sFldName.length-1));
			var sCapt = UR("Введіть номер ціни|Введите номер цены");
			var sMsg = UR("Ціна № |Цена № ");
			if (nCena != 0)
				nCena = input(sMsg, sCapt, nCena, 1);
			
			if(nCena==null)
				return;
			
			
			if(nCena==0)
				nCena = "";
			var id = grid.getTable().getValue("FWID");
			var sWhere = " where FWID="+ sqlTo(id);
			if(grid.getSelectedIDs().length>1)
				sWhere = " where "+ grid.sqlSelected();
			//sWhere += " and exists(select nmk.FCENAPR from ^CL_NMK nmk where nmk.FWID=p.FNMKL)";
			var sSql = "update "+ this.name 
					+" set FCENA"+ nCena +"=(select max(nmk.FCENAPR) from ^CL_NMK nmk where nmk.FWID="+ this.name +".FNMKL)"
					+ sWhere;
			
			ExecuteSQL(sSql);
			grid.getTable().requery(); 
			grid.refresh()
			return false;
			break;
			
		case "COPY_TO":	
			var priName = tbl.getTableName();
			var rowID = tbl.getValue("FWID");
			var sWhere = " where FWID="+ rowID;
			if(grid.getSelectedIDs().length>0)
				sWhere = " where "+ grid.getSqlSelected();
			ExecuteSQL("drop table TMP_PRI_COPY", false);
			ExecuteSQL("select * into TMP_PRI_COPY from "+ priName + sWhere);
			break;
		
		case "PASTE":	
			var priName = tbl.getTableName();			
			var fld = GetPatternIntersection("PRICE", "PRICE");
			fld = fld.replace(",FWID_CH", "");
			fld = fld.replace(",FWID", "");
			fld = fld.replace("FWID,", "");			
			ExecuteSQL("insert into "+ priName +"("+ fld +") "
					+" select "+ fld +" from TMP_PRI_COPY", false);
			tbl.requery();			
			break;
		
		case "COMPLEMENT":
			var par = new Object();
			par.fromPrice = true;
			par.ret = new Object();
			par.ret.FWID = 0;
		 	showWindow("l_clnmktree.xml", SW_MODAL, par, "");
	 		if(!par.escape)
	 		{
	 			addFromNmk(par.ret.FWID, par.retArray);
	 			grid.getTable().requery();
	 		}	
			break;
			
		case "PROTOCOL":
			var ppar = new Object();
			showWindow("l_rsprot.js",SW_MODAL,ppar,"");
			break;
		
		case "ROUND":
				ppar=new Object();
				ppar.fcod=fcod;
				ppar.fdat=fdat;
		   		showWindow("rou_pri.htm",SW_MODAL,ppar,"");
				break;
		
		case "MOVE":
				ppar=new Object();
				ppar.fcod=fcod;
				ppar.fdat=fdat;
		 		showWindow("mov_pri.htm",SW_MODAL,ppar,"");
				break;
		
		case "VAL":
				ppar=new Object();
				ppar.fcod=fcod;
				ppar.fdat=fdat;
		 		showWindow("val_pri.htm",SW_MODAL,ppar,"");
				break;
		
		case "RECOUNT_REST":
				include("Objects\\DpTotals.js");
				include("Objects\\DpGetDat.js");				
				//var gd = new DpGetDat("d");
				var gd = new DpGetDat(new Array("dat"));
				if (gd.escape)
					return false;
				
				//var priName = pName(oRecalc.fcod,oRecalc.fdat);	
				var priName = this.name;	
				
				if (ds.sqlSelected(false).toUpperCase().indexOf("FALSE")!=-1)
				//не выделено ни одной записи - пересчет делается по всему списку
				{
					//готовим таблицу прайс-листов
					ExecuteSQL("DELETE FROM "+ priName
							+" WHERE ftt<>'NM'"
							);
					var lst_tbl = OpenTable("s",
							"SELECT * FROM "+ priName								
							+" WHERE ftt='NM'"								
							+ " ORDER BY fnmkl, forg, ftt DESC");
				
				  	//пересчет остатков с помощью объекта DpMtrOB в таблицу TMP_RST	
					DropTable("TMP_RST");
					with(oRecalc)
					{
						var oMtr = new DpMtrOb();
						oMtr.tblName = "TMP_RST";
						if(oRecalc.fdat!=null)
							oMtr.fdate = gd.fdat;
					   	if(oRecalc.fnmkl!=null)
							oMtr.fnmkl = fnmkl;
						if(oRecalc.fpodr!=null)
							oMtr.fpodr = fpodr;
						if(oRecalc.fmol!=null)
							oMtr.fmol = fmol;
						if(oRecalc.fsc!=null)
							oMtr.fsc = fsc;
						if(oRecalc.fsu!=null)
							oMtr.fsu = fsu;
					}	
					oMtr.doCalc();					
				}
				else //(ds.sqlSelected(false).toUpperCase().indexOf("FALSE")==-1)
				//пересчет делается по отмеченным записям					
				{
					//готовим таблицу прайс-листов
					DropTable("TMP_NMK");
					ExecuteSQL("SELECT fnmkl INTO TMP_NMK FROM " + priName
								+ " WHERE "+ds.sqlSelected(false)
								+ " AND ftt='NM'");
					ExecuteSQL("DELETE FROM "+ priName
							+ " WHERE ftt<>'NM' AND fnmkl IN "
								+ "(SELECT fnmkl FROM TMP_NMK)"
							);

              		var lst_tbl = OpenTable("s",
								"SELECT * FROM "+ priName								
								+ " WHERE " + ds.sqlSelected(false)								
								+ " AND ftt='NM'"								
								+ " ORDER BY fnmkl, forg, ftt DESC"
								);

					//пересчет остатков с помощью объекта DpMtrOB в таблицу TMP_RST
				   	DropTable("TMP_RST");
					CreateTable("TMP_RST", "vdost", "*");					
																
					if (!lst_tbl.IsEmpty())	
						lst_tbl.MoveFirst();
					while (!lst_tbl.IsEOF())	
					{
						DropTable("TMP_RST_MTR");
						var oMtr = new DpMtrOb();
						oMtr.tblName = "TMP_RST_MTR";
						if(oRecalc.fdat!=null)
							oMtr.fdate = gd.fdat;
						if(oRecalc.fnmkl!=null && oRecalc.fnmkl!=0 && lst_tbl.getValue("fnmkl")!=0)
							oMtr.fnmkl = lst_tbl.getValue("fnmkl");
						if(oRecalc.fpodr!=null && oRecalc.fpodr!=0 && lst_tbl.getValue("fpodr")!=0)
							oMtr.fpodr = lst_tbl.getValue("fpodr");
						if(oRecalc.fmol!=null && oRecalc.fmol!=0 && lst_tbl.getValue("fmol")!=0)
							oMtr.fmol = lst_tbl.getValue("fmol");
						if(oRecalc.fsc!=null && oRecalc.fsc!=0 && lst_tbl.getValue("fsc")!=0)
							oMtr.fsc = lst_tbl.getValue("fsc");
						if(oRecalc.fsu!=null && oRecalc.fsu!=0 && lst_tbl.getValue("fsu")!=0)
							oMtr.fsu = lst_tbl.getValue("fsu");

						oMtr.doCalc();
						if(SUBD != DERBY)
							ExecuteSQL("ALTER TABLE TMP_RST_MTR DROP COLUMN FWID");						
						ExecuteSQL("INSERT INTO TMP_RST " + getColumn("TMP_RST_MTR",true)
								+ " SELECT " + getColumn("TMP_RST_MTR",false) 
								+ " FROM TMP_RST_MTR");
						lst_tbl.MoveNext();
					}
				}
				
				// Построение итогов по номенклатуре
				var tot = new DpTotals();
				tot.AddGroup("fnmkl", "_", "''", "NM", "");
				tot.AddItog("fost", "SUM");
				tot.AddItog("fost1", "SUM");
				tot.AddItog("fcena", "MAX");
				tot.MkTotals("", "TMP_RST", "PRICE", 1, "FTT", "TMP_RST", null);
				
				// Таблица протокола пересчета остатков
				DropTable("REST_PROTOCOL");
				CreateTable("REST_PROTOCOL", "RST_PROT", "*");											
				var prot_tbl = OpenTable("s","REST_PROTOCOL");
				
				var mNmkl,bm;
				// Открываем расcчитанную таблицу	
				var it_tbl = OpenTable("s",
						"SELECT * FROM TMP_RST"
						+ " where ftt = 'NM'"
						+ " ORDER BY fnmkl");
					
				// Отдельная таблица для добавления появившихся записей			
				DropTable("TMP_ADD_RST");		
				ExecuteSQL("SELECT * INTO TMP_ADD_RST FROM "+ priName
						+ " WHERE NOT " + SqlCmpTrue
						);
				var lstN_tbl = OpenTable("s","TMP_ADD_RST");
				
				//Переносим данные в прайс-лист
				if (!lst_tbl.IsEmpty())
					lst_tbl.MoveFirst();
				if (!it_tbl.IsEmpty())									
					it_tbl.MoveFirst();	

				while (!lst_tbl.IsEOF() && !it_tbl.IsEOF())
				{
					mNmkl = Number(it_tbl.getValue("fnmkl"));
					bm = lst_tbl.bookmark;

					if (Number(lst_tbl.getValue("fnmkl"))==Number(it_tbl.getValue("fnmkl")))
					{
						if (it_tbl.getValue("ftt")=="NM")
						{
							if (Number(lst_tbl.getValue("fost"))!=Number(it_tbl.getValue("fost")) 
							|| Number(lst_tbl.getValue("fost1"))!=Number(it_tbl.getValue("fost1")))
							{
								lst_tbl.Edit();
								lst_tbl.setValue("fost", it_tbl.getValue("fost"));
								lst_tbl.setValue("fost1", it_tbl.getValue("fost1"));
								lst_tbl.Update();
							}
							if (lst_tbl.getValue("fcena")<it_tbl.getValue("fcena"))
							{
								/*
								prot_tbl.AddNew();
								prot_tbl.setValue("Fwid", GetUID());
   								prot_tbl.setValue("fnmkl", Number(it_tbl.getValue("fnmkl")));
								prot_tbl.setValue("fcom", 2);
								prot_tbl.Update();
								*/
								ExecuteSQL("INSERT INTO REST_PROTOCOL (FWID,FNMKL,FCOM) "
											+" VALUES ("+ GetUID() +","+ Number(it_tbl.getValue("fnmkl")) +",2)");
							}
							it_tbl.MoveNext();
						}
						//(it_tbl("ftt")!="NM")
						while (!it_tbl.IsEOF() && Number(it_tbl.getValue("fnmkl"))==mNmkl)		
						{
							if (this.fpressed!=true)
								Add_RecRest(it_tbl.getValue("FWID"));
								//Add_RecRest(lstN_tbl,it_tbl);
							it_tbl.MoveNext();
						}
						lst_tbl.bookmark = bm;
						while(!lst_tbl.IsEOF() && Number(lst_tbl.getValue("fnmkl"))==mNmkl)
							lst_tbl.MoveNext();
					} 
					else if (Number(lst_tbl.getValue("fnmkl"))<Number(it_tbl.getValue("fnmkl")))
					{
						if (lst_tbl.getValue("ftt")=="NM")
						{
							lst_tbl.Edit();
							lst_tbl.setValue("fost", 0);
							lst_tbl.setValue("fost1", 0);
							lst_tbl.Update();
						}
      					lst_tbl.MoveNext();
					}	
					else if (Number(lst_tbl.getValue("fnmkl"))>Number(it_tbl.getValue("fnmkl")))
					{
						while (!it_tbl.IsEOF() && Number(it_tbl.getValue("fnmkl"))==mNmkl)		
						{
							if (this.fpressed!=true || it_tbl.getValue("ftt")=="NM")
								Add_RecRest(it_tbl.getValue("FWID"));
								//Add_RecRest(lstN_tbl,it_tbl);
							if (it_tbl.getValue("ftt")=="NM")
							{
								/*
								prot_tbl.AddNew();
								prot_tbl.setValue("Fwid", GetUID());
								prot_tbl.setValue("fnmkl", Number(it_tbl.getValue("fnmkl")));
								prot_tbl.setValue("fcom", 1);
								prot_tbl.Update();
								*/
								ExecuteSQL("INSERT INTO REST_PROTOCOL (FWID,FNMKL,FCOM) "
											+" VALUES ("+ GetUID() +","+ Number(it_tbl.getValue("fnmkl")) +",1)");
							}
							it_tbl.MoveNext();
						}
						lst_tbl.bookmark = bm;

						while(!lst_tbl.IsEOF() && Number(lst_tbl.getValue("fnmkl"))==mNmkl)
							lst_tbl.MoveNext();
					}
				}	
				
				while (!it_tbl.IsEOF())		
				{
					if (this.fpressed!=true || it_tbl.getValue("ftt")=="NM")
						Add_RecRest(it_tbl.getValue("FWID"));
						//Add_RecRest(lstN_tbl,it_tbl);
					if (it_tbl.getValue("ftt")=="NM")
					{
						/*
						prot_tbl.AddNew();
						prot_tbl.setValue("Fwid", GetUID());
						prot_tbl.setValue("fnmkl", Number(it_tbl.getValue("fnmkl")));
						prot_tbl.setValue("fcom", 1);
						prot_tbl.Update();
						*/
						ExecuteSQL("INSERT INTO REST_PROTOCOL (FWID,FNMKL,FCOM) "
									+" VALUES ("+ GetUID() +","+ Number(it_tbl.getValue("fnmkl")) +",1)");
					}
					it_tbl.MoveNext();
				}
				while (!lst_tbl.IsEOF())
				{
					bm = lst_tbl.bookmark;
					if (lst_tbl.getValue("ftt")=="NM")
					{
						lst_tbl.Edit();
						lst_tbl.setValue("fost", 0);
						lst_tbl.setValue("fost1", 0);
						lst_tbl.Update();
					}
      				lst_tbl.MoveNext();
      			}		
				
      			ExecuteSQL("INSERT INTO "+ priName + getColumn("TMP_ADD_RST",true)
						+ " SELECT " + getColumn("TMP_ADD_RST",false) + " FROM TMP_ADD_RST "
      					);      			
      			      			
				list.tbl.Requery();
				grid.RefreshGrid(RG_SAVEROW);	
				lstN_tbl.close();					
				prot_tbl.close();
				lst_tbl.close();				
				it_tbl.close();				
				break;
						
		case "MAKE_ALL":
			var tSelected = OpenTable("m",
				"SELECT *"
				+ " FROM " + pName(fcod,fdat)
				+ " WHERE " + DataSource().sqlSelected()
				);
				
			if (SQL)
				tSelected.tie(extPar.mass.getViewBuffer(),"mass","ANLTK_DN_UR","FNMKL,FCENA,FPODR,FMOL,FSC,FSU,FPOST,FID_PN",null,TIE_NOSEARCH);
			else
				tSelected.tie(extPar.mass.getViewBuffer(),"mass","ANLTK_DN_UR","FNMKL,FCENA,FPODR,FMOL,FSC,FSU,FPOST,FID_PN",null,TIE_NOSEARCH);
				
			for(; !tSelected .IsEOF(); tSelected .MoveNext())
			{
				var bRet = extPar.mass.makeInput(tSelected , "POLY");
			}
			
			bAsk = true;
			tSelected.close();
			grid.RefreshGrid(RG_SAVEROW);
			break;
		/*
		case "EDIT":
		case "COPY":
				if(list.tbl && list.tbl.getValue("ftt")!="NM")
				{
					WAIT(ru("Нельзя "+((ID=="EDIT")?"редактировать":"копировать")+" неитоговые записи",
							"Неможна "+((ID=="EDIT")?"редагувати":"копіювати")+" непідсумкові записи"));
					return DpList_exit;
				}
		*/
		case "ADDNKROW":
			oDocRow = extPar.nk.oDoc.createRow("ROW");
				
			oDocRow.setVar("RTNMK", toScrObj(list.tbl.getValue("fnmkl")));
			//oDocRow.setVar("RUCENA", toScrObj(list.tbl.getValue("fcena")));
			
			oDocRow.setVar("RFOCENA",toScrObj(list.tbl.getValue("fcena1")));
			oDocRow.setVar("ROCENA",toScrObj(list.tbl.getValue("fcena1")));
			
	        //if (extPar.nk.oDoc.sDocLbl == "PM")			
	        //	oDocRow.setVar("R1OCENA",toScrObj(list.tbl.getValue("fcena")));
			//oDocRow.setVar("RPODR", toScrObj(list.tbl.getValue("fpodr")));
			//oDocRow.setVar("RMOL", toScrObj(list.tbl.getValue("fmol")));
			//oDocRow.setVar("RSC", toScrObj(list.tbl.getValue("fsc")));
			//oDocRow.setVar("RSU", toScrObj(list.tbl.getValue("fsu")));
			//oDocRow.setVar("RST", toScrObj(list.tbl.getValue("fst")));
			//oDocRow.setVar("R1ID", toScrObj(list.tbl.getValue("fid_pn")));
			//oDocRow.setVar("RPOST", toScrObj(list.tbl.getValue("fpost")));
			oDocRow.setVar("R2ID", toScrObj(list.tbl.getValue("fid_pn")));
			
			oDocRow.setVar("RKOL", 1);
				
			if (oDocRow.edit("ADD"))
			{
				extPar.nk.oDoc.appendRow("ROW", oDocRow);		
				obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, extPar.nk.bufName);															
			}
			grid.RefreshGrid();
			list.onChangeRow();
			break;

		case "ADDNKROWFIFO":
			var priceuse  = Number(extPar.nk.oDoc.getPar("_priceuse"))
			var cena = toScrObj(list.tbl.getValue("fcena" + (priceuse? priceuse: "")))
			extPar.nk.addRowsMassFifo(toScrObj(list.tbl.getValue("fnmkl")), cena);
			grid.RefreshGrid();
			break;
			
		default:
				list.objParMenu.fcod = fcod;
				list.objParMenu.fdat = fdat;
				return false;
		}		
	}	
	list.par.grpId = pr.id;
	//list.tbl.requery();
	ExecuteSQL("update "+ pr.name +" SET FGRPID="+ pr.id);
	grid.RefreshGrid(RG_SAVEROW);
}

function getTblH()
{
	var oH = new Object;
	oH.FCOD = fcod;
	//oH.FDAT = new Date(fdat).getVarDate();
	oH.FDAT = fdat;
	
	return oH;
}

function Add_RecRest(itFwid)
{
	var sFld = "fost,fost1,fcena,fmol,fnmkl,fpodr,fsc,fsu,fst,fwid_ch,fid_pn,ftt";
	ExecuteSQL("INSERT INTO "+ pr.name +" (Fwid,"+ sFld +") "
				+" SELECT "+ GetUID() +" as Fwid,"+ sFld +" from TMP_RST where fwid="+ itFwid);
}

// функция для добавления записей из справочника номенклатуры
function addFromNmk(nId, arrID)
{
	if(!nId && !arrID)
		return;	
	var priName = pr.name;
	var fwid = GetUID();
	if(nId && (!arrID || arrID.length==0))
	{
		var oSnap = getSnap("select Fisnoprice, fisgrp from ^cl_nmk where fwid = " + sqlTo(nId));
		if (!oSnap ||  (!oSnap[0] && !oSnap[1]))
			ExecuteSQL("INSERT INTO "+ priName +" (fwid,fgrpid,ftt,fnmkl) "
				+" VALUES ("+ fwid +","+ pr.id +", 'NM',"+ nId +")");		
	}
	else
	{
		for(var i=0; i<arrID.length; i++)	
		{
			nId = arrID[i].FWID;			
			var oSnap = getSnap("select Fisnoprice, fisgrp from ^cl_nmk where fwid = " + sqlTo(nId));
			if (!oSnap || (!oSnap[0] && !oSnap[1]) )
			{
				uid = GetUID();
				ExecuteSQL("INSERT INTO "+ priName +" (fwid,fgrpid,ftt,fnmkl) "
						+" VALUES ("+ uid +","+ pr.id +", 'NM',"+ nId +")");
				fwid += ","+ uid;
			}			
		}
	}
	
	var nameCena = pr.getTCen(pr.id)[1];			                               
	if (!nameCena || nameCena == "")
	{
		var sSql = "update "+ priName
			+" set FCENA=(select max(nmk.FCENAPR) from ^CL_NMK nmk where nmk.FWID="+ priName +".FNMKL)"
			+" where FWID in ("+ fwid +")";
		ExecuteSQL(sSql);
	}
	else
	{
		var sSql = "update "+ priName
					+" set FCENA=(select max(nmk.F1CENA) from ^CL_NMK nmk where nmk.FWID="+ priName +".FNMKL)"
					+" where FWID in ("+ fwid +")";
		ExecuteSQL(sSql);
		
		var sSql = "update "+ priName
					+" set FCENA1=(select max(nmk.FCENAPR) from ^CL_NMK nmk where nmk.FWID="+ priName +".FNMKL)"
					+" where FWID in ("+ fwid +")";
		ExecuteSQL(sSql);
	}
	
}

/*
	функция подтверждения выхода
*/
function _exitConfirm()
{
	if(bMass)
	{
		extPar.escape = true;
		if(bAsk)
		{
			var iret = __confirm(ru("Сохранить введенные даные?","Зберегти введені дані?"));
			if(iret==0)
			{
				/*
					сохраним введенные данные
				*/
				extPar.mass.Save();
				extPar.escape = false;
			}
			else if(iret==2)//2- значит продолжить
				return false;
		}
	}
	return true;
}