/*										
   Описание объекта "рецепт": DpRecept
   (C) ДЕБЕТ Плюс, 2000
*/

// Конструктор объекта  DpRecept
// eugene START добавил в SELECT - fkol
var rowRecSql = "SELECT DISTINCT FHNO, FREC, fkol FROM ^CL_RREC WHERE FREC <> 0";
var rowRec = OpenTable("s", rowRecSql);
// eugene END
function  DpRecept()
{
	RO("DpRecept", this);
	this.setCod		=  DpRecept_setFno;
	this.getCod     =  DpRecept_getFno;
	this.setFwid    =  DpRecept_setFwid;
	this.getFwid    =  DpRecept_getFwid;
	this.setFtxt    =  DpRecept_setFtxt;
	this.getFtxt    =  DpRecept_getFtxt;
	this.getValid   =  DpRecept_getValid;
	this.setKol		=  DpRecept_setKol;
	this.isReplaceMap   =  DpRecept_IsReplaceMap;
	this.valid      =  DpRecept_valid;
	this.linkCtrl   =  DpRecept_linkCtrl;
	this.validCtrl  =  DpRecept_validCtrl;
	this.validRecept  =  DpRecept_validRecept;
	this.updateCtrl =  DpRecept_updateCtrl;
	this.EnableCtrl	=  DpRecept_EnableCtrl;
	this.getRTable  =  DpRecept_getRTable;
	this.zaval      =  DpRecept_zaval;
	this.setMode	=  DpRecept_setMode;   // для совместимости с DpCl
	this.linkCtrl2  =  DpRecept_linkCtrl2; // для совместимости с DpCl
	this.getReceptToRows = DpRecept_getReceptToRows;
	this.setAfterValid =  DpRecept_setAfterValid;// Устанавливает this.objValid и функцию даного объекта this.AfterValidFunc,
												 //  которая выполняется при правильном вводе (нового) номера рецепта 
	this.setBeforeValid =  DpRecept_setBeforeValid;// Устанавливает this.objValid и функцию даного объекта this.BeforeValidFunc,
	this.setDate	=  DpRecept_setDate;	// ES 20050211. Добавлен разрез ведения по датам, потому если установлена дата
											// то выбираем расходные строки с учетом периода действия
	this.objValid = 1;
	this.AfterValidFunc = 1;
	this.BeforeValidFunc = 1;
	this.isValid	=  false;
	this.Fno		=  0;
	this.Ftxt		=  null;
	this.CanZero	=  false;
	this.EditRecept = false;
	this.kol = 1;
	if (!SQL)
		this.htable = OpenTable("s","CL_REC", "FNO");
	// список строк текущего рецепта
	this.rtableName = "";
	this.rtable = null;
	// список вложенных рецептов в текущем рецепте
	this.rrtableName = "";
	this.rrtable = null;
	// Состояние объекта
	this.bValid = false;
	// дата
	this.date = null;
	this.isSubRecept = false;
	// Цена основного блюда (собирается по ценам всех ингридиентов и подрецептов)
	this.main_cena = 0;
	return this;
}

// для совместимости с DpCl
function DpRecept_setMode()
{
}

function DpRecept_setDate(dat)
{
	this.date = dat;
}

// для совместимости с DpCl
function DpRecept_linkCtrl2()
{
}

// Установить номер Fno
function DpRecept_setFno(Fno)
{
	var bRet = (this.CanZero && Fno == 0);
	this.Fno = Fno;
	if (SQL)
	{
		this.htable = OpenTable("s","SELECT * FROM ^CL_REC WHERE FNO=" + sqlTo(Fno) );
		this.isValid = !this.htable.IsEmpty();
	}
	else
		this.isValid = this.htable.Seek("=", Fno);
	if (this.isValid)
	{
		this.setFtxt(this.htable.getValue("Ftext"));
		this.fvalid = this.htable.getValue("Fvalid");
		this.bReplaceMap = this.htable.getValue("FISREPLACEMAP") == true;
			//Строки рецепта заносим в буфер поскольку их могут "изменять"
			//(имеется в виду количество)
			// Причем вложенные рецепты "раскрываем"
			
		if (!this.EditRecept)
		{
			this.rtableName = getTmpTableName();
			this.rrtableName = getTmpTableName();
			var strFwids = "";
			
			if (!isEmpty(this.date))
			{
				var tbl = OpenTable("SELECT *"
							+ " FROM ^CL_RREC"
							+ " WHERE FHNO = " + sqlTo(this.Fno)
							+ " AND NOT" 
								+ "("
								+ " frtype = " + sqlTo(RTYPE_PR)
								+ " OR fbdat is null OR fbdat <= " + sqlTo(d00min) + " OR fbdat >= "  + sqlTo(d00)
								+ " OR fedat is null OR fedat <= " + sqlTo(d00min) + " OR fedat >= "  + sqlTo(d00)
								+ ")");
				for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{
					if (new Date(tbl.getValue("fbdat")).getFullYear() != new Date(tbl.getValue("fedat")).getFullYear())
						continue;
						
					var dat = this.date;
					dat.setYear(new Date(tbl.getValue("fbdat")).getYear());
					var oSnap = getSnap("SELECT FWID FROM ^CL_RREC "
						+ "WHERE fwid = " + sqlTo(tbl.getValue("fwid"))
						+ " AND " + sqlTo(dat) + " BETWEEN fbdat AND fedat "
						);
					if (oSnap == null)
					{
						if (strFwids != "")
							strFwids += ","; 
						strFwids += sqlTo(tbl.getValue("fwid"));	
					}
				}
			}
			
			ExecuteSQL("SELECT *"
					+ " INTO " + this.rtableName
					+ " FROM ^CL_RREC"
					+ " WHERE FREC = 0"
					+ " AND FHNO = " + sqlTo(this.Fno)
					+ (!isEmpty(this.date) && strFwids != "" ? " AND " 
								+ "("
								+ " FWID not in (" + strFwids + ")"
								//+ sqlTo(this.date) + " BETWEEN fbdat AND fedat " 
								+ " OR frtype = " + sqlTo(RTYPE_PR)
								// ES 20050215. Исспользуем дату только когда она установлена в рецепте
								+ " OR fbdat is null OR fbdat <= " + sqlTo(d00min) + " OR fbdat >= "  + sqlTo(d00)
								+ " OR fedat is null OR fedat <= " + sqlTo(d00min) + " OR fedat >= "  + sqlTo(d00)
								+ ")"
							: "")
					);
					
			// ES 20050131. Технология с подрецептами немного (кардинально) поменялась.
			// Как работало раньше: раньше встречая подрецепт система рекурсивно 
			// разбирала его, получала расходные строки и добавляла их к строкам корневого
			// рецепта. В итоге мы получали таблицу, где рецепты были уже преобразованы в
			// строки и записаны в одну большую таблицу, которая потом расценивалась.
			// Как работает сейчас: Сейчас находя подрецепт система создает еще один объект 
			// рецепт и передает ему управление, он уже сам работает по такой же схеме
			// Разница в том, что для подрецептов не нужно создавать приходную строку в 
			// накладной. 
//			this.getReceptToRows(this.rtableName, this.Fno);
			ExecuteSQL("SELECT *"
					+ " INTO " + this.rrtableName
					+ " FROM ^CL_RREC"
					+ " WHERE FREC <> 0"
					+ " AND FHNO = " + sqlTo(this.Fno)
					+ (!isEmpty(this.date) && strFwids != ""  ? " AND " 
								+ "("
								+ " FWID not in (" + strFwids + ")"
								// + sqlTo(this.date) + " BETWEEN fbdat AND fedat " 
								+ " OR frtype = " + sqlTo(RTYPE_PR)
								// ES 20050215. Исспользуем дату только когда она установлена в рецепте
								+ " OR fbdat is null OR fbdat <= " + sqlTo(d00min) + " OR fbdat >= "  + sqlTo(d00)
								+ " OR fedat is null OR fedat <= " + sqlTo(d00min) + " OR fedat >= "  + sqlTo(d00)
								+ ")"
							: "")
					);			
			this.rrtable = OpenTable("s", "select * from ^"+ this.rrtableName);
			this.rtable = OpenTable("s", "select * from ^"+ this.rtableName);
		}
		bRet = true;
	}
	else
	{
		this.isValid = false;
		this.Fno = 0;
		this.Ftxt = null;
		//bRet = false;  // Был закомментирован, я раскомментировал
 		bRet = (this.htable.IsEmpty() && !this.EditRecept) || bRet;
	}
	this.isValid = this.isValid || bRet;
	//this.bValid = this.isValid;
	this.updateCtrl();
	return bRet;            
}

// Получить номер Fno
function DpRecept_getFno()
{
	return this.Fno
}

function DpRecept_setFwid(fwid)
{
	var pSnap = getSnap("SELECT fno FROM ^CL_REC WHERE fwid = " + sqlTo(fwid));
	if (pSnap != null)
	{
		this.setCod(pSnap[0]);
	}
	else
	{
		this.setCod(-1);
	}
}

function DpRecept_getFwid()
{
	// ES: Если есть два одинаковых рецепта но по разным ценам, то мы должны их разлчать
	//return GetUID();
	
	// ES Если это штучный рецепт то сгенерируем для него новый fwid
	var bSimple = OpenTable("s", "SELECT fnmkl from ^CL_RREC"
			+ " WHERE fhno = " + sqlTo(this.Fno)
			+ " group by fnmkl ").recordCount == 1;
	if (bSimple)
	{
		return GetUID();
	}
	else
	{
		return this.htable.getValue("fwid");
	}
}

// Установить название Ftxt
function DpRecept_setFtxt(Ftxt)
{
	this.Ftxt = Ftxt;
}

function DpRecept_getValid()
{
	return this.fvalid;
}

function DpRecept_setKol(kol)
{
	this.kol = kol;
	ExecuteSQL("UPDATE " + this.rtableName
			+ " SET FKOL = " + sqlRound("FKOL * " + sqlTo(this.kol), 3)
			);
	this.rtable.requery();
	ExecuteSQL("UPDATE " + this.rrtableName
			+ " SET FKOL = " + sqlRound("FKOL * " + sqlTo(this.kol), 3)
			);
	this.rrtable.requery();
}

function DpRecept_IsReplaceMap()
{
	return this.bReplaceMap;
}

// Получить название Ftxt
function DpRecept_getFtxt()
{
	return this.Ftxt
}

// Проверка правильности инициализации
function DpRecept_valid()
{
  return this.isValid;
}

//связать с полями ввода
function DpRecept_linkCtrl(ctrlFno,ctrlTxt)
{
	this.ctrlFno = ctrlFno;
	if ( typeof(this.ctrlFno) != "object" )
		return false;
	this.ctrlFno.setMask("######");	//6	
	if ((JAVA && typeOf(this.ctrlFno) == "DpTextEx") 
			|| this.ctrlFno.DpType == "DpGet")
	{
		this.ctrlFno.isButton = true;
		setButton(this.ctrlFno, this, "zaval");
	}
	setValid(this.ctrlFno, this, "validCtrl");
	
	this.ctrlTxt = ctrlTxt;
	if(this.ctrlTxt)
	{
		this.ctrlTxt.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");	//60			
		Disable(this.ctrlTxt);
	}

	this.updateCtrl();
}

// Обновить связанные поля ввода
function DpRecept_updateCtrl()
{
	if (this.ctrlFno)
		this.ctrlFno.value = this.getCod();
	if (this.ctrlTxt)
		this.ctrlTxt.value = this.getFtxt();
}

function DpRecept_EnableCtrl(enable)
{
	if (this.ctrlFno)
		Enable(this.ctrlFno, enable);
}
// Реакция на выход из связанного поля ввода
function DpRecept_validCtrl(amount)
{
	var bRet = true;
	this.bValid = (amount == null) ? this.bValid : false;
	amount = (amount==null) ? 1 : amount;
	var c = this.getCod();
	if (this.bValid && c == this.ctrlFno.value)
		return true;
	// ES 20050211. Добавлен обработчик перед проверкой валидности. Сейчас ииспользуется
	// для установки даты.
	if (typeof(this.objValid) == "object" && typeof(this.BeforeValidFunc) == "string")
		bRet = this.objValid[this.BeforeValidFunc]();
	
	this.setCod(this.ctrlFno.value);
//	if (!this.valid())// || !this.bValid)
	if (!this.valid() || !this.bValid)
	{
		bRet = this.zaval();
		c = this.getCod();
	}

	if (bRet && c != 0)
	{
		// Ищем основную строку по рецепту
		var tMain = OpenTable("s",
			"SELECT *"
			+ " FROM ^CL_RREC"
			+ " WHERE fhno = " + sqlTo(this.Fno)
				+ " AND fmain = " + SqlTrue
			);
		if(tMain.IsEmpty())
			alert(
				ru("Выбранный рецепт не имеет главной строки."
				+ "\nКоличества переносятся из рецепта без изменения."
				+ "\nЧтобы в накладной можно было указать количество"
					+ " для рецепта, установите в рецепте главную строку.",
					"Вибраний рецепт не має головного рядка."
				+ "\nКількості переносяться з рецепту без змін."
				+ "\nЩоб в накладній можна було вказати кількість"
					+ " для рецепту, встановіть в рецепті головний рядок.")
				);
			
		if(!tMain.IsEmpty() && !this.EditRecept)
		{
			this.bValid = true;
			// Введем количество партий продукции данного рецепта
			par = new Object();
			par.fnmkl = tMain.getValue("fnmkl");
			par.fkol = tMain.getValue("fkol");
			par.fedi = tMain.getValue("fedi");
			par.amount = amount;
			showWindow("e_reckol.xml", SW_MODAL, par);
			this.setKol(Number(par.fkol) / tMain.getValue("fkol"));
		}
	}
	this.updateCtrl();
	if ( bRet && c!=0 /* && c != this.getCod()*/)
	{
		this.validRecept(null);
	}
	if (typeof(bRet) != "boolean")
		bRet = true;
	if (bRet && c!=0 && !this.EditRecept)
		// Рецепт можна выбрать только один раз 
		// (если только объект используется не при добавлении вложенных рецептов)
		this.EnableCtrl(false);
	return bRet;
}

// parent исспользуется для того, чтобы указать является ли рецепт корневым или
// вложенным. Если рецепт вложенный, то в накладной для него не нужно создавать 
// приходную строку.
function DpRecept_validRecept(parent)
{
	this.main_cena = 0;
	// Проверяем на наличие подрецептов. Если находим их, то создаем новый объект рецепт
	// и передаем ему управление.
	if (this.rrtable)
	{
		for (; !this.rrtable.IsEOF(); this.rrtable.MoveNext())
		{
			var recept = new DpRecept();
			recept.isSubRecept = true;
			recept.bValid = true;
			recept.setCod(Number(this.rrtable.getValue("FREC")));
			recept.setKol(Number(this.rrtable.getValue("FKOL")));
			recept.setAfterValid(this.objValid, this.AfterValidFunc);
			recept.setBeforeValid(this.objValid, this.BeforeValidFunc);
			recept.validRecept(recept);
		}
	}

	if (typeof(this.objValid) == "function")
		bRet = this.objValid(parent);
	else if (typeof(this.objValid) == "object" && typeof(this.AfterValidFunc) == "string")
		bRet = this.objValid[this.AfterValidFunc](parent);
}

function DpRecept_setAfterValid(objValid, funcValid)
{
	this.objValid = objValid;
	this.AfterValidFunc = funcValid;
}

function DpRecept_setBeforeValid(objValid, funcValid)
{
	this.objValid = objValid;
	this.BeforeValidFunc = funcValid;
}

//Осуществляется завал
function DpRecept_zaval()
{
	this.bValid = false;
	var par = new Object();
	par.Fno = this.ctrlFno.value;
	par.escape = true;
	par.zaval = true;
	par.ret = new Object();
	par.ret.Fno = par.Fno;
	par.ret.Ftext = null;
	var bRet;
//	if (!(this.htable.IsEOF() && this.htable.IsBOF()))
//	{
		showWindow("l_cl_rec.js",SW_MODAL,par);
		if (bRet = !par.escape)
			bRet = this.setCod(par.ret.Fno);
//	}
//	else
//	{
//	   WAIT(ru("Рецепты отсутствуют", "Рецепти відсутні"))
//	   bRet = this.setCod(0);
//	}
	
	this.updateCtrl(); 
	return bRet;
}

function DpRecept_getRTable()
{
	return this.rtable;
}

function DpRecept_getReceptToRows(tmpName, hno)
{
	var szSQL = rowRecSql + " AND FHNO = " + sqlTo(hno);
	var tTmp = OpenTable("s", szSQL);
	
	while(!tTmp.isEOF())
	{
		var frec = Number(tTmp.getValue("FREC"));
		var fkol = Number(tTmp.getValue("FKOL")); // eugene
		ExecuteSQL("INSERT INTO " + tmpName
				+ " SELECT "
				+ " FEDI, FHNO, FMAIN, FNMKL, FREC, "
				+ " FRTYPE, FWID, FKOL "
				+ " FROM ^CL_RREC"
				+ " WHERE FREC = 0 AND FHNO = " + sqlTo(frec)
				+ " AND FMAIN = " + SqlFalse
				);

		ExecuteSQL("UPDATE "+tmpName+" SET FKOL = " + sqlRound("FKOL * " + sqlTo(fkol), 3)
                                + " WHERE FREC = 0 AND FHNO = " + sqlTo(frec)
				+ " AND FMAIN = " + SqlFalse);
// eugene END
		this.getReceptToRows(tmpName, frec)
		tTmp.FindFirst("FREC = " + frec)

		tTmp.MoveNext();
	}
		
	tTmp.Close();
}							  