/*
   Описание объекта "элемент плана счетов": DpSc
   (C) ДЕБЕТ Плюс, 1998-1999
*/

include("objects\\DpCl.js");
include("sys\\mask.js");
include("objects\\DpzSelect.js");

//_storeObj("DpSc");
//_storeObj("getScType");

DpSc.prototype.setMode = DpSc_setMode;
DpSc.prototype.getMode = DpSc_getMode;
DpSc.prototype.set = DpSc_set;
DpSc.prototype._setSc = DpSc__setSc;
DpSc.prototype._zavalSc = DpSc__zavalSc;
DpSc.prototype._modeValid = DpSc__modeValid;
DpSc.prototype.valid = DpSc_valid;
DpSc.prototype.zValid = DpSc_zValid;
DpSc.prototype._setCl = DpSc__setCl;
DpSc.prototype.zValidCl = DpSc_zValidCl;
DpSc.prototype.getSc = DpSc_getSc;
DpSc.prototype.getSu = DpSc_getSu;
DpSc.prototype.getSt = DpSc_getSt;
DpSc.prototype.getCl1 = DpSc_getCl1;
DpSc.prototype.getCl2 = DpSc_getCl2;
DpSc.prototype.getCl3 = DpSc_getCl3;
DpSc.prototype.linkCtrl = DpSc_linkCtrl;
DpSc.prototype.linkCtrlSu = DpSc_linkCtrlSu;
DpSc.prototype.linkCtrlSt = DpSc_linkCtrlSt;
DpSc.prototype.linkCtrlTxt = DpSc_linkCtrlTxt;
DpSc.prototype._updateCtrlTxt = DpSc__updateCtrlTxt;
DpSc.prototype.linkCtrlTxtStCl1 = DpSc_linkCtrlTxtStCl1;
DpSc.prototype.linkCtrlTxtStCl1doc = DpSc_linkCtrlTxtStCl1doc;
DpSc.prototype._updateCtrlTxtStCl1 = DpSc__updateCtrlTxtStCl1;
DpSc.prototype.linkCtrlTxtStCl2 = DpSc_linkCtrlTxtStCl2;
DpSc.prototype.linkCtrlTxtStCl2doc = DpSc_linkCtrlTxtStCl2doc;
DpSc.prototype._updateCtrlTxtStCl2 = DpSc__updateCtrlTxtStCl2;
DpSc.prototype.linkCtrlTxtStCl3 = DpSc_linkCtrlTxtStCl3;
DpSc.prototype.linkCtrlTxtStCl3doc = DpSc_linkCtrlTxtStCl3doc;
DpSc.prototype._updateCtrlTxtStCl3 = DpSc__updateCtrlTxtStCl3;
DpSc.prototype._validSc = DpSc__validSc;
DpSc.prototype._validSu = DpSc__validSu;
DpSc.prototype._validSt = DpSc__validSt;
DpSc.prototype.getClcl1 = DpSc_getClcl1;
DpSc.prototype.getClcl2 = DpSc_getClcl2;
DpSc.prototype.getClcl3 = DpSc_getClcl3;
DpSc.prototype.getVid = DpSc_getVid;
DpSc.prototype.getType = DpSc_getType;
DpSc.prototype.getMetod = DpSc_getMetod;
DpSc.prototype.getTxt = DpSc_getTxt;
DpSc.prototype._ctrlZaval = DpSc__ctrlZaval;
DpSc.prototype.getRelCl = DpSc_getRelCl;
DpSc.prototype.say = DpSc_say;
   
DpSc.prototype.getObjCl1 = DpSc_getObjCl1;
DpSc.prototype.getObjCl2 = DpSc_getObjCl2;
DpSc.prototype.getObjCl3 = DpSc_getObjCl3;

DpSc.prototype.Release = DpSc_Release;
   
function DpSc()
{
   RO("DpSc", this);

	if(!DpSc.prototype.tblCl_schet)
	{	
		DpSc.prototype.tblCl_schet = null;// OpenTable("s", "SELECT * FROM ^CL_SCHET ORDER BY FSCHET,FSUBSCHET,FSTAT");
		
   }

   this.cl = new Array();
   
   // Разбор аргументов
   var args = DpSc.arguments;
   if(args.length==0)
   {
      this.setMode("c0ut");
      this.set(0, 0, 0);
   }
   else if(typeof(args[0])=="string")
   {
      this.setMode(args[0]);
      this.set(args[1], args[2], args[3], args[4], args[5], args[6]);
   }
   else
   {
      this.setMode("c0utxyz".substr(0, args.length+1));
      this.set(args[0], args[1], args[2], args[3], args[4], args[5]);
   }

   if(this.DpSc==DpSc)
   {
      debug("Используйте DpSc с оператором new");
      return this;
   }
}

function DpSc_setMode(mode)
{
   this.mode = mode.toLowerCase();

   if(this.getMode("c0"))
   {
      if(this.mode=="c0")
         this.mode = "c00";
      else
         this.mode = "c" + this.mode.substr(2) + "00";
   }
  
   this.mode = this.mode.replace("00", "0-");
   
   if(this.getMode("ux"))
      debug("Не допустимый режим объекта DpSc\n"
         + "Аналитика не может указываться без статьи");
   else if(this.getMode("x"))
   {
	  //this.cl[0] = new DpCl("N" + this.getMode("0"));
	  this.cl[0] = new DpzSelect("N" + this.getMode("0"));            
      if(this.getMode("y"))
         this.cl[1] = new DpzSelect("N" + this.getMode("0"));
      if(this.getMode("z"))
         this.cl[2] = new DpzSelect("N" + this.getMode("0"));
      if(this.getMode("4"))
         this.cl[3] = new DpzSelect("N" + this.getMode("0"));
      if(this.getMode("5"))
         this.cl[4] = new DpzSelect("N" + this.getMode("0"));
      if(this.getMode("6"))
         this.cl[5] = new DpzSelect("N" + this.getMode("0"));
   }
}

// Получить режим, либо проверить, устновлен ли указанный подрежим
function DpSc_getMode(submode)
{
   if(this.mode==null)
      debug("Объекту DpSc должен быть указан режим!");
   if(submode=="*")
      return this.getMode("0") + this.getMode("-");
   if(submode==null)
      return this.mode;
   else
      return (this.mode.indexOf(submode)!=-1)? submode: "";
}

function DpSc_set(sc, su, st, cl1, cl2, cl3)
{
	//debug();
	if(!this.getMode("&"))
	{
		this._setSc(sc, su, st);				
		this._setCl(1, cl1);
		if(this.cl[1])
		{
			
			if(this.getRelCl(2)==this.cl[0].getClcl() || this.cl[1].getType()=="cntrct")
			{
				this.cl[1].setCl(this.cl[0]);
			}
			else 
			{
				this.cl[1].setCl();
			}
			this._setCl(2, cl2);
			//this.getRelCl(2);			
		}
		
		if(this.cl[2])
		{	
			
			if(this.getRelCl(3)==this.cl[0].getClcl())
				this.cl[2].setCl(this.cl[0]);
			else if(this.getRelCl(3)==this.cl[1].getClcl() || this.cl[2].getType()=="cntrct")
				this.cl[2].setCl(this.cl[1]);
			else
				this.cl[2].setCl();
				
			this._setCl(3, cl3);	
		}	
	}
   else
   {
      this._setSc(sc, su);
      if(this.getClcl1())
         this._setCl(1, st);
      else
         this._setSc(sc, su, st);
   }
 
   this._updateCtrlTxt();
   this._updateCtrlTxtStCl1();  
}

function DpSc__setSc(sc, su, st)
{
   this.sc = (sc!=null? sc: 0);
   if(this.ctrlSc)
      this.ctrlSc.setValue(sc);
   this.su = (su!=null? su: 0);
   if(this.ctrlSu)
      this.ctrlSu.setValue(su);
   this.st = (st!=null? st: 0);
   if(this.ctrlSt)
      this.ctrlSt.setValue(st);
   
   var valid = this._modeValid(this.getMode().replace(/[xyz&]/g, "") );
  
   if(valid && this.sc!=0)
   {
      this.vid = toScrObj(DpSc.prototype.tblCl_schet.getValue("fvid"));
      this.type = toScrObj(DpSc.prototype.tblCl_schet.getValue("fctype"));
      this.metod = toScrObj(DpSc.prototype.tblCl_schet.getValue("fcmetod"));
      this.txt = UR(toScrObj(DpSc.prototype.tblCl_schet.getValue("fnazv")));
      this.clcl1 = toScrObj(DpSc.prototype.tblCl_schet.getValue("fcl1"));
      this.clcl2 = toScrObj(DpSc.prototype.tblCl_schet.getValue("fcl2"));
      this.clcl3 = toScrObj(DpSc.prototype.tblCl_schet.getValue("fcl3"));
      
      var cl1_type = DpSc.prototype.tblCl_schet.getValue("fcl1_type");
      var cl2_type = DpSc.prototype.tblCl_schet.getValue("fcl2_type");
      var cl3_type = DpSc.prototype.tblCl_schet.getValue("fcl3_type");
      if(this.cl[0])
      	this.cl[0].setType(cl1_type);
      if(this.cl[1])
      	this.cl[1].setType(cl2_type);
      if(this.cl[2])
      	this.cl[2].setType(cl3_type);
   }
   else
   {
      this.vid = "";
      this.type = "";
      this.metod = "";
      this.clcl1 = this.clcl2 = this.clcl3 = 0;
      this.txt = "";
   } 
 
   if(this.cl[0] && this.cl[0].getClcl() != this.clcl1)
   {
      this.cl[0].setClcl(this.clcl1 == 0 ? -1 : this.clcl1);      
   }
   if(this.cl[1])
   {
      this.cl[1].setClcl(this.clcl2 == 0 ? -1 :this.clcl2);
   }
   if(this.cl[2])
   {
      this.cl[2].setClcl(this.clcl3 == 0 ? -1 : this.clcl3);
   }
     
   this._setCl(1, 0);
   this._setCl(2, 0);
   this._setCl(3, 0);
   
   this.validCUT = valid;
   
   return valid;
}

function DpSc__setCl(no, cod)
{
   if(cod==null)
      cod = 0;
      
   if(this.cl[no-1]  && this.cl[no-1].getClcl()!=-1)
   {
      this.cl[no-1].setCod(cod);
   }
   
}

function DpSc_zValidCl(no)
{
   return !this.cl[no-1] || this.cl[no-1].zValid();
}

function DpSc_getSc()
{
   return this.sc==null? 0: Number(this.sc);
}

function DpSc_getSu()
{
   return this.su==null? 0: Number(this.su);
}

function DpSc_getSt()
{
   if(this.getMode("&") && !this.st)
      return this.getCl1();
   else
      return this.st==null? 0: Number(this.st);
}

function DpSc_getCl1()
{
   return (this.cl[0]? this.cl[0].getCod(): 0);
}
function DpSc_getCl2()
{
   return (this.cl[1]? this.cl[1].getCod(): 0);
}
function DpSc_getCl3()
{
   return (this.cl[2]? this.cl[2].getCod(): 0);
}

function DpSc__zavalSc()
{
   var par = new Object();
   par.zaval = true;
   par.ret = new Object();
   par.mode = this.getMode("c") + this.getMode("u")
      + this.getMode("t") + this.getMode("0");
   par.ret.Fschet = this.sc;
   par.ret.Fsubschet = this.su;
   par.ret.Fstat = this.st;
   par.isMat = this.getMode("m");
	par.aaa = 2;
   showWindow("l_clsch.js","GRIDDLG" , par);	
   if(par.escape==false)
   {
      this.set(par.ret.Fschet, par.ret.Fsubschet, par.ret.Fstat);
   }

   return this.validCUT;
}

function DpSc__ctrlZaval()
{
   // Неправильно, т.к. не отслеживается то, что
   // в поле ввода может хранится значение, отличное
   // от значения в объекте
   this._zavalSc();
}

function DpSc_getClcl1()
{
   return this.clcl1;
}

function DpSc_getClcl2()
{
   return this.clcl2;
}

function DpSc_getClcl3()
{
   return this.clcl3;
}

function DpSc_getVid()
{
   return this.vid;
}

function DpSc_getType()
{
   return this.type;
}

function DpSc_getMetod()
{
	return this.metod;
}

function DpSc_getTxt()
{
	txt = "";
	
   if(this.getCl3())
      txt = this.getObjCl3().getTxt() + (txt? "; " + txt: "");
      
   if(this.getCl2())
      txt = this.getObjCl2().getTxt() + (txt? "; " + txt: "");
      
   if(this.getCl1())
      txt = this.getObjCl1().getTxt() + (txt? "; " + txt: "");
   else
      txt = this.txt;
  
   return txt;
}

function DpSc_linkCtrlSu(ctrlSu)
{
   if(this.ctrlSu = ctrlSu)
   {
      this.ctrlSu.setMask(MASK_SU);
      setValid(ctrlSu, this, "_validSu");
      if(typeOf(this.ctrlSu)=="DpTextEx")
         this.ctrlSu.buttonHandler(this, "_ctrlZaval");
   }
	
	this.ctrlSu.setButton(true);
	
}

function DpSc_linkCtrlSt(ctrlSt)
{
   if(this.ctrlSt = ctrlSt)
   {
      this.ctrlSt.setMask(MASK_ST);
      setValid(ctrlSt, this, "_validSt");
      if(typeOf(this.ctrlSt)=="DpTextEx")
         this.ctrlSt.buttonHandler(this, "_ctrlZaval");
   }
	this.ctrlSt.setButton(true);
}


function DpSc_linkCtrl(ctrlSc, ctrlSu, ctrlSt, ctrlCl1, ctrlCl2, ctrlCl3)
{
   if(this.ctrlSc = ctrlSc)
   {
      this.ctrlSc.setMask(MASK_SC);
      setValid(ctrlSc, this, "_validSc");
      if(typeOf(this.ctrlSc)=="DpTextEx")
      {
         this.ctrlSc.buttonHandler(this, "_ctrlZaval");
      }
   }
   if(this.ctrlSu = ctrlSu)
   {
      this.ctrlSu.setMask(MASK_SU);
      setValid(ctrlSu, this, "_validSu");
      if(typeOf(this.ctrlSu)=="DpTextEx")
         this.ctrlSu.buttonHandler(this, "_ctrlZaval");
   }
   if(this.ctrlSt = ctrlSt)
   {
      this.ctrlSt.setMask(MASK_ST);
      setValid(ctrlSt, this, "_validSt");
      if(typeOf(this.ctrlSt)=="DpTextEx")
         this.ctrlSt.buttonHandler(this, "_ctrlZaval");
   }
   // Принудительно включаем кнопку для завала в последнем из 
   // полей ввода счета, субсчета или статья
   
   if(this.ctrlSt && typeOf(this.ctrlSt)=="DpTextEx")
       this.ctrlSt.setButton(true);   
   
   else if(this.ctrlSu && typeOf(this.ctrlSu)=="DpTextEx")
      this.ctrlSu.setButton(true);
   else if(this.ctrlSc && typeOf(this.ctrlSc)=="DpTextEx")
      this.ctrlSc.setButton(true);
    
   if(this.ctrlCl1 = ctrlCl1)
   {
      if(this.getMode("x"))
         this.cl[0].linkCtrl(ctrlCl1);
      else
         Disable(this.ctrlCl1);
   }
   if(this.ctrlCl2 = ctrlCl2)
   {
      if(this.getMode("y"))
         this.cl[1].linkCtrl(ctrlCl2);
      else
         Disable(this.ctrlCl2);
   }
   if(this.ctrlCl3 = ctrlCl3)
   {
      if(this.getMode("z"))
         this.cl[2].linkCtrl(ctrlCl3);
      else
         Disable(this.ctrlCl3);
   }   
}

function DpSc__validSc()
{
   // Если ввели новый счет - обнулим субсчет и статью
   if(this.ctrlSc.getValue()!=this.getSc())
   {
      //this._setSc(this.ctrlSc.value, 0, 0);
      this.set(this.ctrlSc.getValue(), 0, 0);
   }
   return this._modeValid("c" + this.getMode("*"), true);
}

function DpSc__validSu()
{
   if(this.ctrlSu && this.ctrlSu.getValue() != this.getSu())
   {
      //this._setSc(this.getSc(), this.ctrlSu.value, 0);
      this.set(this.getSc(), this.ctrlSu.getValue(), 0);
   }
   return this._modeValid("cu" + this.getMode("*"), true);
}

function DpSc__validSt()
{
   if(!this.ctrlSt)
   		return true;
   if(toScrObj(this.ctrlSt.getValue())!= this.st) // this.st нельзя заменить на this.getSt(), т.к. не работает для совмещенной статьи и аналитики
   {
      //this._setSc(this.getSc(), this.getSu(), this.ctrlSt.value);
      this.set(this.getSc(), this.getSu(), this.ctrlSt.getValue());
   }
   return this._modeValid("cut" + this.getMode("*"), true);
}

function DpSc_valid(isSilenceMode)
{
   return this.validCUT &&
      (!this.getMode("x") || this.cl[0].valid(isSilenceMode)) &&
      (!this.getMode("y") || this.cl[1].valid(isSilenceMode)) &&
      (!this.getMode("z") || this.cl[2].valid(isSilenceMode));
}

function DpSc_zValid()
{
   if(Validation)
      debug("Метод zValid объекта DpSc устарел.\n"
         + "Пользуйтесь функцией setValid");
   return (this.validCUT || this._zavalSc()) &&
      this.zValidCl(1) &&
      this.zValidCl(2) &&
      this.zValidCl(3);
}

function DpSc__modeValid(mode, zaval)
{
   if(zaval==null)
      zaval = false;
   var t = DpSc.prototype.tblCl_schet;  // Таблица плана счетов
   var valid;
   if(this.sc==0)
      if(this.getMode("-"))
         valid = true;
      else
         valid = false;
   else
      switch(mode.replace("-", "").toUpperCase())
      {
      case "C":
      case "C0":     
         var sSQL = "SELECT * FROM ^CL_SCHET WHERE (FSCHET="+this.sc+")and (FSUBSCHET=0)and(FSTAT=0)";
         DpSc.prototype.tblCl_schet = OpenTable(sSQL);
         this.validSc = !DpSc.prototype.tblCl_schet.isEmpty();      
         //tblCl_schet.Close()
         
         // Проверка, если есть такой субсчет, какой ввели в счет
         if (!this.validSc)
         {
             var sSQL = "SELECT * FROM ^CL_SCHET WHERE FSUBSCHET="+this.sc;
             tblCl_schet = OpenTable(sSQL);
             this.validSc = !tblCl_schet.isEmpty() && Number(tblCl_schet.recordCount)==1      

             this.set(Number(tblCl_schet.getValue("fschet")), Number(tblCl_schet.getValue("fsubschet")))
             tblCl_schet.Close();
         }
         
         valid = this.validSc;
         break;
      case "CU0":
        var sSQL = "SELECT * FROM ^CL_SCHET WHERE (FSCHET="+this.sc+")and (FSUBSCHET="+this.su+")and(FSTAT=0)";
        DpSc.prototype.tblCl_schet = OpenTable("s",sSQL);
         this.validSu = !DpSc.prototype.tblCl_schet.isEmpty();
         
         if(this.validSu)
            this.validSc = true;
         else
            this._modeValid("C");
         valid = this.validSu;
         break;
      case "CU":
         if(this.su!=0)
            valid = this._modeValid("CU0");
         else
         {
            if(this._modeValid("C"))
            {
               this.validSu = false;
               var sSQL = "select * from ^cl_schet where fschet = "+sqlTo(this.sc)+
					" and fsubschet = 0 and fstat <> 0 ";
               if(getSnap(sSQL)!=null)
				this.validSu = true;
				
				if(this.validSu == false)
				{
					sSQL = "select * from ^cl_schet where fschet = "+this.sc+
					" and fsubschet <> 0 ";
					this.validSu = (getSnap(sSQL)==null);
				}               
            }
            else
               this.validSu = false;
            valid = this.validSu;
         }
         break;
      case "CUT0":      
         var sSQL = "SELECT * FROM ^CL_SCHET WHERE (FSCHET="+this.sc+")and (FSUBSCHET="+this.su+")and(FSTAT="+this.st+")";
         DpSc.prototype.tblCl_schet = OpenTable("s",sSQL);
         this.validSt = !DpSc.prototype.tblCl_schet.isEmpty();

         if(!this.validSt)
            this._modeValid("CU0");
         valid = this.validSt;
         break;
      case "CUT":
         if(this.st!=0)
            valid = this._modeValid("CUT0");
         else if(this.su!=0)
         {
            // (sc, su, 0)
            if(this._modeValid("CU"))
            {
                var sSQL = "select * from ^cl_schet where fschet = "+sqlTo(this.sc)+
					" and fsubschet = "+sqlTo(this.su)+" and fstat <> 0 ";
               valid = this.validSt = (getSnap(sSQL)==null);
            }
            else
               valid = this.validSt = false;
         }
         else
         {
            // Устанавливается только счет без субсчета и аналитики
            if(this._modeValid("C"))
            {
               // Сейчас в таблице плана счетов мы стоим на записи
               // вида (счет, 0, 0)
               var sSQL = "select * from ^cl_schet where fschet =" + sqlTo(this.sc)
				//fruckt
				//в случае ввода в контрол счета значения субсчета
				//this.su может быть не нулевым
				+" "+sqlw0And("FSUBSCHET = ", this.su)
				+" order by fschet, fsubschet, fstat";
                var t = OpenTable("s",sSQL); 
               t.MoveNext();
               // Если у следующей запси счет изменился,
               //  то счет не имеет ни субсчетов, ни статей
               if(t.IsEOF() || Number(t.getValue("fschet"))!=this.sc)
               {
                 
                  valid = this.validSu = this.validSt = true;
               }
               else
               {
                  // Если счет не изменился ...
                  if(Number(t.getValue("fsubschet"))==0)
                  {
                     // и субсчет остался нулевым, значит
                     // у счета нет субсчетов, а есть статья,
                     // т.е. субсчет задан правильно (нулем)
                     this.validSu = true;
                     // а статью надо еще указать
                     this.validSt = false;
                  }
                  else
                  {
                     // а субсчет изменился, значит у счета есть
                     // субсчета, т.е. субсчет должен был быть указан
                     this.validSu = this.validSt = false;
                  }
                  // В любом случае требуется довведение данных
                  valid = false;
               }
               t.MovePrev();
            }
         }
         break;
      }
	if(t!=null)
		t.close();
   if(!valid && zaval)
      valid = this._zavalSc();

   return valid;
}

function DpSc_getObjCl1()
{
   return this.cl[0];
}

function DpSc_getObjCl2()
{
   return this.cl[1];
}

function DpSc_getObjCl3()
{
   return this.cl[2];
}

function DpSc_linkCtrlTxt(ctrlTxt, ctrlTxtCl1, ctrlTxtCl2, ctrlTxtCl3)
{
   this.ctrlTxt = ctrlTxt;
   this.ctrlTxtCl1 = ctrlTxtCl1;
   this.ctrlTxtCl2 = ctrlTxtCl2;
   this.ctrlTxtCl3 = ctrlTxtCl3;
   
   if(this.ctrlTxt)
   {
      Disable(this.ctrlTxt);
      this.ctrlTxt.setValue(this.getTxt());
     var o1 = this.getObjCl1(),
         o2 = this.getObjCl2(),
         o3 = this.getObjCl3();
      
      if(o1) o1.setValid(this, "_updateCtrlTxt");
      if(o2) o2.setValid(this, "_updateCtrlTxt");
      if(o3) o3.setValid(this, "_updateCtrlTxt");
   }
   
   if(this.ctrlTxtCl1)
		Disable(this.ctrlTxtCl1);
   if(this.ctrlTxtCl2)
		Disable(this.ctrlTxtCl2);
   if(this.ctrlTxtCl3)
		Disable(this.ctrlTxtCl3);
}

function DpSc__updateCtrlTxt()
{
	if(this.ctrlTxtCl1)
	{
		if(this.getCl3() && this.ctrlTxtCl3)
			this.ctrlTxtCl3.setValue("1:" + this.getObjCl3().getTxt());
		if(this.getCl2() && this.ctrlTxtCl2)
		   this.ctrlTxtCl2.setValue("2:" + this.getObjCl2().getTxt());
		if(this.getCl1() && this.ctrlTxtCl1)
		   this.ctrlTxtCl1.setValue("3:" + this.getObjCl1().getTxt());
		if(this.ctrlTxt)
			this.ctrlTxt.setValue(":" + this.txt);
	}
	else if(this.ctrlTxt)
		this.ctrlTxt.setValue("::" + this.getTxt());
}

function DpSc_linkCtrlTxtStCl1(ctrlStCl1)
{
   this.ctrlStCl1 = ctrlStCl1;
   if(this.ctrlStCl1)
   {
      Disable(this.ctrlStCl1);
      this.getObjCl1().setValid(this, "_updateCtrlTxtStCl1");
      this._updateCtrlTxtStCl1();
   }
}

function DpSc__updateCtrlTxtStCl1()
{
   if(this.ctrlStCl1)
   {
      if(this.getCl1())
         this.ctrlStCl1.setValue(this.cl[0].getTxt());
      else if(this.getSt())
         this.ctrlStCl1.setValue(this.getTxt());
      else
         this.ctrlStCl1.setValue("");
   }
}

function DpSc_linkCtrlTxtStCl1doc(ctrlStCl1)
{
   //этот метод нужен для кассовых ордеров, где не должно быть
   // жесткого соответствия между статьей, аналитикой и текстовкой.
   this.ctrlStCl1 = ctrlStCl1;
   if(this.ctrlStCl1)
   {
      this._updateCtrlTxtStCl1();
   }
}

function DpSc_linkCtrlTxtStCl2(ctrlStCl2)
{
   this.ctrlStCl2 = ctrlStCl2;
   if(this.ctrlStCl2)
   {
      Disable(this.ctrlStCl2);
      this.getObjCl2().setValid(this, "_updateCtrlTxtStCl2");
      this._updateCtrlTxtStCl2();
   }
}

function DpSc__updateCtrlTxtStCl2()
{
   if(this.ctrlStCl2)
   {
      if(this.getCl2())
         this.ctrlStCl2.setValue(this.cl[1].getTxt());
      else
         this.ctrlStCl2.setValue("");
   }
}

function DpSc_linkCtrlTxtStCl2doc(ctrlStCl2)
{
   //этот метод нужен для кассовых ордеров, где не должно быть
   // жесткого соответствия между статьей, аналитикой и текстовкой.
   this.ctrlStCl2 = ctrlStCl2;
   if(this.ctrlStCl2)
   {
      this._updateCtrlTxtStCl2();
   }
}

function DpSc_linkCtrlTxtStCl3(ctrlStCl3)
{
   this.ctrlStCl3 = ctrlStCl3;
   if(this.ctrlStCl3)
   {
      Disable(this.ctrlStCl3);
      this.getObjCl3().setValid(this, "_updateCtrlTxtStCl3");
      this._updateCtrlTxtStCl3();
   }
}

function DpSc__updateCtrlTxtStCl3()
{
   if(this.ctrlStCl3)
   {
      if(this.getCl3())
         this.ctrlStCl3.setValue(this.cl[2].getTxt());
      else
         this.ctrlStCl3.setValue("");
   }
}

function DpSc_linkCtrlTxtStCl3doc(ctrlStCl3)
{
   //этот метод нужен для кассовых ордеров, где не должно быть
   // жесткого соответствия между статьей, аналитикой и текстовкой.
   this.ctrlStCl3 = ctrlStCl3;
   if(this.ctrlStCl3)
   {
      this._updateCtrlTxtStCl3();
   }
}

function DpSc_getRelCl(no)
{
	if(this.cl[no-1].getClcl()>0)
	{
		var sSQL = "SELECT FREL FROM ^clcl WHERE FCOD=" + sqlTo(this.cl[no-1].getClcl());
        var oSnap =   getSnap(sSQL);         
		if(oSnap==null) return 0;	
		return oSnap[0];
	}
	else
		return 0;
}

function DpSc_say(mode)
{
   mode = mode? mode.toUpperCase(): "";
   
   var sRet = "";
   
   switch(mode)
   {
   case "":
      sRet = this.getSc();
      if(this.getSu() || this.getSt() || this.getCl1())
			sRet += "/" + this.getSu();
		if(this.getSt() || this.getCl1())
         sRet += "/" + this.getSt();
      if(this.getCl1())
			sRet += "/" + this.getCl1();
		if(this.getCl2())
			sRet += "/" + this.getCl2();
		if(this.getCl3())
			sRet += "/" + this.getCl3();
	  break;      
   }   
   return sRet;
}

var arrScTypeCash = new Array();

function getScType(sc, su, st)
{
	if (!su)
		su = 0;
	if (!st)
		st = 0
	
	var sKey = sc + "|" + su + "|" + st;
	
	if (arrScTypeCash[sKey] != null)
	{
		return arrScTypeCash[sKey];
	}  
	
	
	if(!getScType.objSc)
		getScType.objSc = new DpSc("cut0");
	getScType.objSc.set(sc, su, st);
	var ret = String(getScType.objSc.getType());
	arrScTypeCash[sKey] = ret;
	return ret;
}

function DpSc_Release()
{
	this.ctrlSc = null;
	this.ctrlSu = null;
	this.ctrlSt = null;
	this.ctrlCl1 = null;
	this.ctrlCl2 = null;
	this.ctrlCl3 = null;	
}