include("objects\\DpJournal.js");
include("doc\\DpDoc.js");

DpSynchronizer.prototype.putObjectForSynchronize = DpSynchronizer_putObjectForSynchronize;
DpSynchronizer.prototype.delObjectFromSynchro = DpSynchronizer_delObjectFromSynchro;
DpSynchronizer.prototype.getTblName = DpSynchronizer_getTblName;

function DpSynchronizer()
{
}

function DpSynchronizer_getTblName()
{
	return "^OBJSYNC";
}

function DpSynchronizer_putObjectForSynchronize(sClassID,nObjID)
{
	var oSnap = getSnap("SELECT * FROM " + this.getTblName());
	if (oSnap != null)
		this.delObjectFromSynchro(sClassID,nObjID);
	var m = new Object();
	m.FCLASS = String(sClassID);
	m.FOBJID = Number(nObjID);
	m.FDATE = new Date();
	m.FUSER = getUserName();
	m.FHOST = getHostName();
	
	UpdateTable(this.getTblName(),m,true);
}

function DpSynchronizer_delObjectFromSynchro(sClassID,nObjID)
{
	return ExecuteSQL("DELETE FROM " + this.getTblName()
			 + " WHERE FCLASS=" + sqlTo(String(sClassID))
			 + " AND FOBJID=" + sqlTo(Number(nObjID)));
}