include("sys\\udfs.js");
include("sys\\ras_ost.js");

//var tblName = "TMP_RAS_OST";
var tblName = getTmpTableName();
var PTN_OST_BUF = "RAS_OST";

function DpUCena(obj)
{
	if(obj.parent == null)
		obj.parent = obj;
	
	this.oDoc = obj;
	this.cena = null;
	this.nmkl = null;
	//this.cena = obj.getVar("RUCENA");
	//this.nmkl = obj.getVar("RTNMK");
	this.where = '';
	this.isValid = true;
	this.nMaxKol = 0;
	this.Fdoc = obj.parent.sDocLbl;
	this.ctrlSN = null;
	this.sn = "";
	
	this.setCena  = DpUCena_setCena;
	this.linkCtrl = DpUCena_linkCtrl;	
	this.linkCtrlSN = DpUCena_linkCtrlSN;
   	this.zaval = DpUCena_zaval;   	
   	this.check = DpUCena_check; 
   	this.valid = DpUCena_valid;
   	this.validCtrl = DpUCena_validCtrl;
   	this.validSN = DpUCena_validSN;
   	this.isOneCena = DpUCena_isOneCena;
   	this.createFifo = DpUCena_createFifo;
	this.bFifo = false;
}

function DpUCena_linkCtrl(ctrlCena, ctrlSN)
{	
   	this.ctrlCena = ctrlCena;
   	this.ctrlCena.mask = MASK_CENA;
   	setButton(this.ctrlCena, this, "zaval");
   	setValid(this.ctrlCena, this, "validCtrl");
   	if(ctrlSN)
   		this.linkCtrlSN(ctrlSN);
}

function DpUCena_linkCtrlSN(ctrlSN)
{	
   this.ctrlSN = ctrlSN;
   setButton(this.ctrlSN, this, "zaval");   
   setValid(this.ctrlSN, this, "validSN");
}

function DpUCena_valid()
{
	return this.isValid;
}

function DpUCena_zaval()
{	
	this.isValid = false;
	this.check(true);			
}

function DpUCena_validCtrl()
{
    //если значения полей номенклатура и цена не изменились, выходим 
	var isCena = Number(this.cena) == Number(this.ctrlCena.value);
	var isNmkl = Number(this.nmkl) == Number(rnk.oNmkl.getCod());
	if (isCena && isNmkl)
		return;
	//this.isValid = false;
    this.setCena(this.ctrlCena.value);
    if(!this.isValid)
      	this.zaval()    
    else 
   		this.check(false);
}

function DpUCena_validSN()
{
   	var sn = this.ctrlSN.value;
   	if(sn=="" || this.sn==sn)
		return;
	
	var oSnap = getSnap("select FCENA from ^ANLTK "
				+" where fnmkl="+ rnk.oNmkl.getCod() 
					+" and FRTYPE='5' "
					+" and FSN="+ sqlTo(sn), false);
	if(!oSnap)
		return;
	this.ctrlCena.value	= Number(oSnap[0]);
    this.check(false);
}

//если в таблице остатков не одна строка с такой ценой, делаем завал чтобы выбрать строку (isValid=false)
function DpUCena_setCena(newCena)
{	
	this.isValid = false;	
	this.check(false);
	
	if(this.isOtlRasc)
	{
		//отложенное расценивание
		this.isValid = true;
		return;
	}
	
	if(newCena==0 || newCena==null)
		newCena = this.ctrlCena.value;
	
	this.isValid = this.isOneCena(newCena);		
}

function DpUCena_isOneCena(nCena)
{
	var bOne = true;
	var hPodr = this.oDoc.parent.getVar("HPODR");
	var hMol = this.oDoc.parent.getVar("HMOL");
	if(hPodr && hMol && hPodr!="undefined")
		this.where = " AND FPODR="+ hPodr +" AND FMOL="+ hMol;
	if (this.oDoc.getVar("R1ID"))
		this.where += " AND fid_pn="+ this.oDoc.getVar("R1ID");
	var sWhere = " WHERE Fcena="+ nCena + this.where;
	var oSnap = getSnap("SELECT COUNT(*) FROM ^"+ tblName + sWhere, false);
	if(oSnap!=null) 
		bOne = oSnap[0]==1;
	return bOne;	
}

//  doZaval && !isValid: расчет остатков и завал (showWindow("l_ucena.js"))
// !doZaval && 	isValid: получить значения без завала 
// !doZaval && !isValid: только расчет остатков 
function DpUCena_check(doZaval, type, kol)
{		
	if (rnk && rnk.oNmkl && !rnk.oNmkl.getCod())
	{
		this.isValid = true;
		return true;
	}
	
	var uchsel = this.oDoc.parent.getPar("_uchsel");
	var allnkrec = this.oDoc.parent.getPar("__allnkrec");
	var otlrasc = this.oDoc.parent.getPar("_otlrasc");
	var viewuch = this.oDoc.parent.getPar("__viewuch");
	this.isOtlRasc = (Number(uchsel)==3);	//отложенное расценивание
	
	if (this.Fdoc == "TC" && (rnk.oNmkl.getCod() == ""  || rnk.oNmkl.getCod() == null))
	{
		setFocus(Fnmkl);
		return true;
	}
	if (this.Fdoc == "GP" && FRTYPE.value != "7")
	{
		this.isValid = true;
		return true;
	}
	
	if (!doZaval && this.Fdoc == "IS" && FRTYPE.value != "7" )
	{
		this.isValid = true;		
		return true;
	}
	/*if(uchsel==0 && !doZaval)//ручной ввод
	{
		this.isValid = true;
		return true;
	}*/
		
	var nmkSnap = getSnap("SELECT * FROM ^cl_nmk "
						 + " WHERE FWID=" + rnk.oNmkl.getCod()
						 + " AND FVID=" + sqlTo("S")
						 );
	//проверка на вызов для услуги
	if (nmkSnap != null)
	{
		this.isValid = true;
		return true;
	}
	//возможно, что стоит выписка только отложенным расцениванием
	if(this.Fdoc != "GP" && uchsel==3 && !(this.Fdoc == "IS" && FRTYPE.value != "7"))
	{
		try
		{
			if(this.ctrlCena)
				this.ctrlCena.value = 0;
			Fcena.value = 0;
		}
		catch(ex){}
		Fis_otl = true;
		return true;
	}

	var kf; //коеффициент перевода единиц измерени
	if(typeOf(rnk.oNmkl.ctrlEdi) != "undefined")
		if(rnk.oNmkl.Fedi == 1)
			kf = rnk.oNmkl.Fedikf1;	
	kf = (kf==null || kf==0) ? 1 : kf;
	
	var xFpodr, xFmol, xFsc, xFsu, xFst;
	var xFpost, xFcenapr;						//переменные для корректировки
	var xdate;									//дата накладной
	var p = new Object();						//объект параметров для завала
	
	//Определяем параметры нашей цепочки
	p.Fnmkl	= rnk.oNmkl.getCod();
	p.Fpodr	= this.oDoc.parent.getVar("HPODR");
	p.Fmol	= this.oDoc.parent.getVar("HMOL");
	xdate = this.oDoc.parent.getVar("HDAT");

	var changeNmkl = this.nmkl != p.Fnmkl;
	this.nmkl = p.Fnmkl;
	var podr = p.Fpodr;
	var mol	 = p.Fmol;

	if(this.Fdoc != "GP" && allnkrec)
	{
		podr=null;
		mol	=null;
	}
	if(changeNmkl || !this.isValid || !IsTable(tblName))
	{	
		//рассчитываем остатки и заносим их в tblName
		CreateTable(tblName, PTN_OST_BUF, "FWID");	
		var oOb = new DpMtrOb()
		oOb.tblName = tblName;		

		with(oOb)
		{		
			// Если нажат Shift
			/*if(askKey(1))
				fdate = input(ru("Введите дату для расчета остатков",
								"Введіть дату для розрахунку залишків"), 
								"", xdate);
			*/	
		    if(typeof fdate!="date")
				fdate = xdate;
			
			fpost = null;
			fnmkl = p.Fnmkl;
			fpodr = podr;
			fmol = mol;
			if (this.Fdoc!="SM" && this.Fdoc!="VM" 
				&& this.Fdoc!="PM" && this.Fdoc!="PZ"
				&& this.Fdoc!="MT" && this.Fdoc != "VP"
				&& this.Fdoc!="OT" && this.Fdoc!="PU"
				&& this.Fdoc!="NK" && this.Fdoc!="NM"
				)
			{
				fsc = this.oDoc.parent.getVar("HSC");
				fsu = this.oDoc.parent.getVar("HSU");
			}
			isFostsum = false;
			/*
				остатки считаются с исключением
				текущего fwid'а
			*/
			if(extPar && extPar.mode == "EDIT")
				fwid = this.oDoc.getID();
				
			pattern = PTN_OST_BUF;
			indexes = "anltk_dn";
	
			// Может быть пересорт, может не вестить по поставщикам
			//if(this.Fdoc=="VP")
			//	fpost = this.oDoc.parent.getVar("HPOST");

			if(this.Fdoc=="VM")
				extraFlds = ", max(CASE WHEN Fdoc='SM' then a.fcenapr else 0 end) as fcenapr";
			if (this.bFifo)
			{
				isPnDate = true;
				//extraFlds += ", pn1.fdate fpndate";
				//extraGroupBy += ", fdate";
			}

			doCalc();
		}
		p.oOb = oOb;
	}	
	
	if(!doZaval && !this.isValid)
		return;

	var flds = "fnmkl, Fcena, FSC, FSU, FST, Fmol, Fpodr, Fpost, Fcenapr, Fid_pn, FOST, Fis_otl, Fsn"
	var oSnap = getSnap("SELECT "+ flds +" FROM ^"+ tblName);
	if(oSnap == null)
	{
		CLEARWAIT();
		WAIT(ru("Остатков нет.", "Залишків немає"));
		if (this.Fdoc == "IS" && FRTYPE.value != "7" )
		{
			this.isValid = true;		
			return true;
		}
		
		
		var e;
		try
		{
			Fcena.value = 0;
		}
		catch(e) {}
		try
		{
			Fvcena.value = 0;
		}
		catch(e) {}
		try
		{
			Ffactcena.value = 0;
		}
		catch(e) {}		
		this.oDoc.make_Otpcena();
		return;
	}
	
	//Добавляем возможность отложенного расценивания
	if(otlrasc)
		ExecuteSQL("INSERT INTO "+ tblName +" (Fis_otl, Fcena) VALUES (" + SqlTrue + ",0)");	
		
	if (this.Fdoc == "PM" || this.Fdoc == "MT" || this.Fdoc == "PZ")
		viewuch = true;
	
	p.bViewUch = (this.Fdoc == "GP")? true : viewuch;
	p.kf = kf;		
	p.tblName = tblName;

	p.ret = new Object();
	p.ret.Fcena = null;
	p.ret.Fsc = null;
	p.ret.Fsu = null;
	p.ret.Fst = null;
	p.ret.Fpost = null;
	p.ret.Fid_pn = null;
	p.ret.Fmol = null;
	p.ret.Fpodr = null;
	p.ret.Fcenapr = null;
	p.ret.Fost = null;
	p.ret.Fsn = null;
	p.ret.Fis_otl = null;
	
	var cena, Fost, Fis_otl;
	
	//Запуск процедуры выбора
	if(doZaval)
	{		
		showWindow("l_ucena.js",SW_MODAL,p);
				
		if(p.escape)
		{
			if (this.Fdoc == "IS" && FRTYPE.value != "7" )
			{
				this.isValid = true;
				return true;
			}
			return false;
		}
		
		cena 	=p.ret.Fcena;	
		xFsc 	= p.ret.Fsc; 
		xFsu 	= p.ret.Fsu; 
		xFst 	= p.ret.Fst;
		xFmol	= p.ret.Fmol;
		xFpodr 	= p.ret.Fpodr;
		xFpost 	= p.ret.Fpost;		
		xFcenapr= p.ret.Fcenapr;
		Fid_pn 	= p.ret.Fid_pn;
		Fost 	= p.ret.Fost;
		this.sn	= p.ret.Fsn;
		Fis_otl = p.ret.Fis_otl;
					
		this.isValid = true;
	}
	else //без завала
	{			
		if (this.bFifo)
			return;
		
		if(type)
		{		
			flds = "a.fnmkl, a.Fcena, a.FSC, a.FSU, a.FST, a.Fmol, a.Fpodr" +
					", a.Fpost, a.Fcenapr, a.Fid_pn, a.FOST, a.Fis_otl, a.Fsn";
			var where ="";
			if (kol)
				where = " where a.fost >= " + kol;
			else
				where = " where a.fost > 0";
			
			xFmol = rnk.oMol.getCod();
			xFpodr = rnk.oPodr.getCod();
			xFpost = rnk.oPost.getCod();
			if(xFmol)
			{
				if(where == "")
					where = " where a.Fmol = " + xFmol;
				else
					where += " and a.Fmol = " + xFmol;
			}
			if(xFpodr)
			{
				if(where == "")
					where = " where a.Fpodr = " + xFpodr;
				else
					where += " and a.Fpodr = " + xFpodr;
			}
			
			oSnap = getSnap(s = "SELECT "+ flds +" FROM ^"+ tblName 
					+ " a left join ^anltk pn1 on pn1.fwid = a.fid_pn " + where + " and a.Fcena="+ sqlTo(this.ctrlCena.value)+" order by pn1.fdate, a.fcena ");

			
			if(!oSnap)
			{
				oSnap = getSnap("SELECT "+ flds +" FROM ^"+ tblName 
					+ " a left join ^anltk pn1 on pn1.fwid = a.fid_pn " + where + " order by pn1.fdate, a.fcena ");
				if(!oSnap)
					return;
			}
		}
		else
		{
			var sWhere = " WHERE Fcena="+ sqlTo(this.ctrlCena.value) + this.where;
			oSnap = getSnap("SELECT "+ flds +" FROM ^"+ tblName + sWhere);
			if(!oSnap)
				return;
		}
		cena 	= oSnap[1];
		xFsc 	= oSnap[2];
		xFsu 	= oSnap[3];
		xFst 	= oSnap[4];		
		xFmol	= oSnap[5];
		xFpodr 	= oSnap[6];
		xFpost 	= oSnap[7];		
		xFcenapr= oSnap[8];
		Fid_pn 	= oSnap[9];	
		Fost 	= oSnap[10];
		this.sn = oSnap[12];
		Fis_otl = oSnap[11];
	}
	
	var xFcena;
	if (this.Fdoc == "GP")
		xFcena = F1cena.value;
	else
		xFcena = Fcena.value;	

	//Записываем значение в поле ввода
	if(!Fis_otl || Fis_otl==0 || cena!=0) //Fis_otl = 0
	{
		// Если номенклатура ведется по средней, учетную цену округляем по параметру			
		var nmkSnap = getSnap("SELECT * FROM ^cl_nmk "
							  + " WHERE Fwid=" + sqlTo(rnk.oNmkl.getCod())
							  + " AND Fis_sred=" + sqlTrue
							  );

		if (nmkSnap != null)
			cena = round(cena, getPar("DECISRED"));
		cena *= kf;
	
		if (this.Fdoc != "GP")		
			Fcena.value	= cena;		
		else
			F1cena.value = cena;

		rnk.oSc.set(xFsc, xFsu, xFst);			
		if(this.Fdoc=="PM" && rnk.oSc1.getSc()==0)
			rnk.oSc1.set(xFsc, xFsu, xFst);
				
		rnk.oMol.setCod(xFmol);
		rnk.oPodr.setCod(xFpodr);
		rnk.oPost.setCod(xFpost);
		
		if (Fid_pn != 0)
		{			
			if(typeof Fvcena != "undefined")
				Fvcena.value  = tanf(Fid_pn,"vcena")*kf;
			if(typeof Ffactcena != "undefined")
				Ffactcena.value = tanf(Fid_pn,"1cena")*kf;
		}

		if(this.Fdoc == "VM")	
		{
			if (Fid_pn != 0)
				Fcenapr.value = tanf(Fid_pn,"cena")*kf;
			else
			{
				if(!getPar("isclost"))
					Fcenapr.value = xFcenapr;
				else
				{								
					var sSQL = "select fcenapr from ^anltk where "
							+" frtype ='6' and fdoc = 'SM' "
							+ " and fnmkl = " + sqlTo(this.nmkl)
							+ " and fpodr = " + sqlTo(xFpodr)
							+ " and fmol = " + sqlTo(xFmol)
							+ " and fsc = " + sqlTo(xFsc)
							+ " and fsu = " + sqlTo(xFsu)
							+ " and fst = " + sqlTo(xFst)
							+ " and fcena = " + sqlTo(xFcena)
							+ " and fid_pn = " + sqlTo(Fid_pn)
							+ " and fdate <= " + sqlTo(xdate.getVarDate())
					var vmSnap = getSnap(sSQL);
					if(vmSnap && vmSnap[0])
						Fcenapr.value = vmSnap[0];						
				}
			}
			if (Fcenapr.value == 0)
				Fcenapr.value = Ffactcena.value;
		}
		if(this.Fdoc == "VP")
		{
			//if(!askKey(1))
				F1cena = tanf(Fid_pn,"1cena")*kf;
				// ES: for Brokard - AL
				if(doZaval || Fcenapr.value == 0)
					Fcenapr.value = F1cena;
				//	Fcenapr.value = Fcena.value;
					
			//else
				//WAIT.getValue("Фактурная цена не изменилась (нажат Shift)")
		}	
		Fis_otl	= false;
		this.nMaxKol = nMaxKol = Fost;
	}
	else
	{
		//все атрибуты снесем
		if (this.Fdoc != "GP")		
			Fcena.value	= 0;
		else
			F1cena.value = 0;
		rnk.oSc.set(xFsc, xFsu, xFst);
		rnk.oPodr.setCod(podr);
		rnk.oMol.setCod(mol);
		if(typeof Ffactcena != "undefined")
			Ffactcena.value = 0;
		if(typeof Fvcena != "undefined")
			Fvcena.value = 0;
		Fid_pn = 0;
		Fis_otl	= true;
	}
	if(this.ctrlSN)
		this.ctrlSN.value = this.sn;	
	this.cena = this.ctrlCena.value;
	this.oDoc.make_Otpcena();
	
	Foldcena = (this.Fdoc != "GP")? Fcena.value : F1cena.value;

	CLEARWAIT();
	return;
}

function DpUCena_createFifo(nk, oDocRow)
{
	var nAllKol = Number(oDocRow.getVar("RKOL"));
	
	var oSnap = getSnap("SELECT SUM(FOST) FROM ^"+ tblName);
	if(oSnap == null || oSnap[0] < nAllKol)
	{
		var oPar = new Object;
		oPar.nAllKol = nAllKol;
		oPar.maxKol = oSnap[0];
		oPar.oDocRow = oDocRow;
		oPar.nk = nk;
		oPar.parentWnd = display.getActiveShell();
		showWindow("e_kol_not_enough.xml", SW_MODAL, oPar);
		
		if (oPar.Fkol)
		{
			nAllKol = oPar.Fkol;
		}
		else
			return false;
			
		/*
		alert("Не удается выписать необходимое количество " + nAllKol 
				+ "\nТекущий остаток: " + oSnap[0]);
		*/
	} 
	
	var flds = "fnmkl, Fcena, FSC, FSU, FST, Fmol, Fpodr, Fpost, Fcenapr, Fid_pn, FOST, Fis_otl, Fsn";
	var tbl = OpenTable("SELECT "+ flds +" FROM ^"+ tblName + " WHERE FOST > 0 ORDER BY FpnDATE, Fcena");
	var bFirstRow = true;
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{	
		if (!bFirstRow)
		{
			var row_num = Number(oDocRow.getVar("RNOM"));
			oDocRow	= nk.oDoc.copyRow("ROW",Number(oDocRow.getID()));
			oDocRow.setVar("RNOM", row_num + 1);
		}
		
		var nKol = Number(tbl.getValue("FOST"));
		if (nKol >= nAllKol)
			nKol = nAllKol;
		cena 	= tbl.getValue("Fcena");
		xFsc 	= tbl.getValue("FSC");
		xFsu 	= tbl.getValue("FSU");
		xFst 	= tbl.getValue("FST");		
		xFmol	= tbl.getValue("Fmol");
		xFpodr 	= tbl.getValue("Fpodr");
		xFpost 	= tbl.getValue("Fpost");		
		Fid_pn 	= tbl.getValue("Fid_pn");	
		xFcenapr= tbl.getValue("Fcenapr");
		Fis_otl = false;

		oDocRow.setVar("RKOL", nKol);
		oDocRow.setVar("RSC", xFsc);
		oDocRow.setVar("RSU", xFsu);
		oDocRow.setVar("RST", xFst);
		if(this.Fdoc=="PM" && rnk.oSc1.getSc()==0)
		{
			oDocRow.setVar("RSC1", xFsc);
			oDocRow.setVar("RSU1", xFsu);
			oDocRow.setVar("RST1", xFst);
		}
		oDocRow.setVar("RMOL", xFmol);
		oDocRow.setVar("RPODR", xFpodr);
		oDocRow.setVar("RPOST", xFpost);
		oDocRow.setVar("R1ID", Fid_pn);
		oDocRow.setVar("RSOTL", Fis_otl);		
		oDocRow.setVar("RUCENA", cena);

/*
		if (this.Fdoc != "GP")		
			Fcena.value	= cena;		
		else
			F1cena.value = cena;
		if (Fid_pn != 0)
		{			
			if(typeof Fvcena != "undefined")
				Fvcena.value  = tanf(Fid_pn,"vcena")*kf;
			if(typeof Ffactcena != "undefined")
				Ffactcena.value = tanf(Fid_pn,"1cena")*kf;
		}
		if(this.Fdoc == "VM")	
		{
			if (Fid_pn != 0)
				Fcenapr.value = tanf(Fid_pn,"cena")*kf;
			else
			{
				if(!getPar("isclost"))
					Fcenapr.value = xFcenapr;
				else
				{								
					var sSQL = "select fcenapr from ^anltk where "
							+" frtype ='6' and fdoc = 'SM' "
							+ " and fnmkl = " + sqlTo(this.nmkl)
							+ " and fpodr = " + sqlTo(xFpodr)
							+ " and fmol = " + sqlTo(xFmol)
							+ " and fsc = " + sqlTo(xFsc)
							+ " and fsu = " + sqlTo(xFsu)
							+ " and fst = " + sqlTo(xFst)
							+ " and fcena = " + sqlTo(xFcena)
							+ " and fid_pn = " + sqlTo(Fid_pn)
							+ " and fdate <= " + sqlTo(xdate.getVarDate())
					var vmSnap = getSnap(sSQL);
					if(vmSnap && vmSnap[0])
						Fcenapr.value = vmSnap[0];						
				}
			}
			if (Fcenapr.value == 0)
				Fcenapr.value = Ffactcena.value;
		}
*/
		nk.oDoc.appendRow("ROW", oDocRow);		
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);		
		
		nAllKol -= nKol;
		if (nAllKol <= 0)
			break;
		bFirstRow = false;
	} 
	
	return true;
}