/*
   Описание объекта валюты
*/

DpVal.prototype.setCod = ValSetCod;
DpVal.prototype.setNazv = ValSetNazv;
DpVal.prototype.setKurs = ValSetKurs;
DpVal.prototype.setKRaz = ValSetKRaz;
DpVal.prototype.zSetNazv = ValZSetNazv;
DpVal.prototype.getNazv = ValGetNazv;
DpVal.prototype.getTxt = ValGetTxt;
DpVal.prototype.getKurs = ValGetKurs;
DpVal.prototype.getKRaz = ValGetKRaz;
DpVal.prototype.setTxts = ValSetTxts;
DpVal.prototype.zSetTxts = ValZSetTxts;
DpVal.prototype.getTxts = ValGetTxts;
DpVal.prototype.empty = ValEmpty;
DpVal.prototype.fillUpFromTbl = ValFillUpFromTbl;
DpVal.prototype.getCod = ValGetCod;
DpVal.prototype.getComCod = ValGetComCod;
DpVal.prototype.assocDpText = ValAssocDpText;
DpVal.prototype.linkCtrl = ValAssocDpText;
DpVal.prototype.linkCtrlKurs = ValLinkCtrlKurs;
DpVal.prototype.linkCtrlKRaz = ValLinkCtrlKRaz; //курсовые разницы
DpVal.prototype.blurCtrl = ValBlurCtrl;
DpVal.prototype.blurCtrlKurs = ValBlurCtrlKurs;
DpVal.prototype.blurCtrlKRaz = ValBlurCtrlKRaz;
DpVal.prototype.valid = ValValid;
DpVal.prototype.zValid = ValZValid;
DpVal.prototype.updateCtrl = ValUpdateCtrl;
DpVal.prototype.zaval = ValZaval;
DpVal.prototype.getField = ValGetField;

var tblWrkCl_valut;

// Конструктор объекта валюты
function DpVal(val)
{
	RO("DpVal", this);
	val = toScrObj(val);
	this.empty();
	
	this.isSingleCod = false;	 
	
   switch(typeof(val))
   {
   case "number":
      this.setCod(val);
      break;
   case "string":
      this.setNazv(val);
      break;
   case "undefined":
      this.setCod(0);
      break;
   }
}

function ValEmpty()
{
   this.isValid = false;
   this.cod = null;
   this.comcod = null;
   this.nazv = null;
   this.kurs = 0;
   this.kraz = "-";
   this.txt = "???";
}

function ValSetCod(newCod)
{
	if (newCod == null ) newCod = 0;
	newCod = toScrObj(newCod);
	trace(newCod)
	//if(newCod==this.getCod()) return;
	tblWrkCl_valut =
	  OpenTable("s","select * from ^cl_valut where FKOD="+sqlTo(newCod));		
	if(!tblWrkCl_valut.isEmpty())		
		this.fillUpFromTbl();
	else
		this.empty();		
	this.updateCtrl();
	tblWrkCl_valut.close();
}

function ValSetNazv( newNazv )
{
	if(newNazv==this.getNazv()) return;	
	if (!newNazv)
	{
		this.setCod(0)
		return;
	}
	
	tblWrkCl_valut = 
		OpenTable("s","select * from ^cl_valut where FNAZVS="+sqlTo(newNazv));
	if(!tblWrkCl_valut.isEmpty())		
		this.fillUpFromTbl();
	else
		this.empty();
	this.updateCtrl();
	tblWrkCl_valut.close();	
}

function ValSetKurs(newKurs)
{
	this.kurs = newKurs;
	this.updateCtrl();
}
function ValSetKRaz(newKRaz)
{
	this.kraz = newKRaz;
	this.updateCtrl();
}

function ValGetKurs()
{
	return this.kurs;
}
function ValGetKRaz()
{
	return this.kraz;
}

function ValValid()
{
	if(!this.getCod())
		this.setKurs(0);
	if(!this.getCod())
		this.setKRaz("-");
	return this.isValid;
}

function ValSetTxts( txts )
{
	return this.setNazv(txts);
}

function ValZSetTxts( txts )
{
   return this.zSetNazv(txts);
}

function ValZSetNazv( newNazv )
{
   var retValue = true;

	this.setNazv(newNazv);
	if(!this.valid())
		this.zaval();
	
	return this.valid();
}

function ValZaval()
{
   	var par = new Object();
   	par.zaval = true;
   	par.fnazvs = this.getNazv();
   	par.ret = new Object();
   	par.ret.fnazvs = this.nazv;
	par.ret.fkod = this.cod;
   	par.ret.fnazv = this.txt;
   	par.ret.fcomcod = this.comcod;
//-   showWindow("l_cl_val.js","GRIDDLG",par);/////
   showWindow("l_cl_val.xml",SW_MODAL,par);
   
   if( !par.escape )
   {
   	this.isValid = true;
      this.cod = Number(par.ret.fkod);
      this.comcod = Number(par.ret.fcomcod);
      this.nazv = toScrObj(par.ret.fnazvs);
      this.txt = toScrObj(par.ret.fnazv);
      this.updateCtrl();
      
      runValid(this.dpTextCtrl);
   }
}

function ValGetNazv()
{
   return this.nazv;
}

function ValGetTxts()
{
   return this.getNazv();
}

function ValGetTxt()
{
   return this.txt;
}

function ValGetCod(mode)
{
	if(mode)
		return this.nazv;
	return this.cod;
}

function ValGetComCod()
{
	return this.comcod;
}

function ValFillUpFromTbl()
{
	this.isValid = true;///////////////////
   this.cod = Number(tblWrkCl_valut.getValue("fkod"));
   this.comcod = Number(tblWrkCl_valut.getValue("fcomcod"));
   this.nazv = toScrObj(tblWrkCl_valut.getValue("fnazvs"));
   this.txt = toScrObj(tblWrkCl_valut.getValue("fnazv"));   
}

function ValAssocDpText(ctrl,ctrl_text)
{
	if(ctrl!=null)
   {
      ctrl.setMask("&&&");
      this.dpTextCtrl = ctrl;
      this.fillContAssist = DpVal_fillContAssist;
      this.dpTextCtrl.setContentAssistHandler(this, 
				"fillContAssist", "setCod");
      setValid(ctrl, this, "blurCtrl");     
      setButton(ctrl, this, "zaval");
   }
   if(ctrl_text!=null)
	{
		this.dpCtrl_text=ctrl_text;
		Disable(ctrl_text);
	}
	var oSnap = getSnap("select count(*) as cnt, min(fkod) from ^cl_valut");
	if (oSnap && oSnap[0] == 1)
	{
		this.isSingleCod = true;
		this.setCod(oSnap[1]);
	}
	this.updateCtrl();
}


function DpVal_fillContAssist(ca)
{
	var str = this.dpTextCtrl.value;
	var sSQL = "SELECT fkod, fnazv as ftxt  FROM ^cl_valut "
	if (str && str != "0")	
	{
		sSQL += " where "+ Convert("fkod","NVC") 
		+ " like " + sqlTo(str+"%");
	}
	
	sSQL += " union SELECT fkod, fnazvs as ftxt  FROM ^cl_valut "
	if (str && str != "0")	
	{
		sSQL += " where "+ Convert("fnazvs","NVC") 
		+ " like " + sqlTo(str+"%");
	}
	
	sSQL += " union SELECT fkod, fnazv as ftxt  FROM ^cl_valut "
	if (str && str != "0")	
	{
		sSQL += " where "+ Convert("fnazv","NVC") 
		+ " like " + sqlTo(str+"%");
	}
	
	
	sSQL += " order by 2 "
	
	var tblChoose = OpenTable("s",sSQL);
	while (!tblChoose.isEOF())
	{
		var sCod = toScrObj(tblChoose.getValue("FKOD"));
		var sTxt = toScrObj(tblChoose.getValue("FTXT"));
		ca.addItem(sCod, sTxt + " : " + sCod)
		tblChoose.MoveNext();
	}
	tblChoose.close();
}

function ValLinkCtrlKurs(ctrlKurs)
{
	this.ctrlKurs = ctrlKurs;
	this.ctrlKurs.mask = "######.#########";
	setValid(this.ctrlKurs, this, "blurCtrlKurs");	
	this.updateCtrl();
}

function ValLinkCtrlKRaz(ctrlKRaz)
{
	this.ctrlKRaz = ctrlKRaz;
	setValid(this.ctrlKRaz, this, "blurCtrlKRaz");
	this.updateCtrl();
}


function ValBlurCtrl()
{
   
   if(typeOf(this.dpTextCtrl)=="DpTextEx")
   {
      this.zSetNazv(toScrObj(this.dpTextCtrl.getValue()));
   }   
   return this.valid();
}

function ValBlurCtrlKurs()
{
	this.kurs = this.ctrlKurs.getValue();
}

function ValBlurCtrlKRaz()
{
	this.kraz = (toScrObj(this.ctrlKRaz.getValue()) ? "+" : "-");
}

function ValZValid()
{
   return this.zSetNazv(this.getNazv());
}

function ValUpdateCtrl()
{
   if(this.dpTextCtrl!= null)
   {
      this.dpTextCtrl.setValue((this.getNazv() == null)?"":this.getNazv());
      if(this.isSingleCod)
    	  Disable(this.dpTextCtrl);
   }
   if(this.dpCtrl_text!= null)
   {
      this.dpCtrl_text.setValue(this.getTxt());
      if(this.isSingleCod)
    	  Disable(this.dpCtrl_text);
   }
   if(this.ctrlKurs)
   {
		Enable(this.ctrlKurs, this.getCod());
		this.ctrlKurs.setValue(this.getKurs());
		if(this.isSingleCod)
	    	  Disable(this.ctrlKurs);
	}
   if(this.ctrlKRaz)
   {
		Enable(this.ctrlKRaz, this.getCod());
		this.ctrlKRaz.setChecked(this.getKRaz() == "+");
		if(this.isSingleCod)
	    	  Disable(this.ctrlKRaz);
	}	
}

function ValGetField(cField)
{
	var retVal = null;
	if(this.valid())
	{
		if(tblWrkCl_valut == null || tblWrkCl_valut.IsEOF() || tblWrkCl_valut.getValue("fkod")!=this.getCod())
		{
			var newCod = this.getCod();
			tblWrkCl_valut = OpenTable("s","select * from ^cl_valut where FKOD="+sqlTo(newCod));			    
		}
		
		if(!tblWrkCl_valut.IsEOF())
			retVal = toScrObj(tblWrkCl_valut.getValue(cField));
		tblWrkCl_valut.close();
		
		if(!retVal)
			switch(cField.toUpperCase())
			{
			case "FRUB0": case "FRUB1": case "FRUB2":
			case "FKOP0": case "FKOP1": case "FKOP2":
				retVal = this.getTxts();
			}
	}
	return retVal;
}