function DpXMLExport(sFileName)
{
	//Функции начальной загрузки и инициализации
	this.ArrObjData = new Array();
	this.initExport = DpXMLExp_InitExport;
	this.getExpFunc = DpXMLExp_getExpFunc;
	this.runExport = DpXMLExp_export;
	this.exportDocs = DpXMLExp_ExportDocs;
	this.exportRows = DpXMLExp_ExportRows;
	this.exportDoc = DpXMLExp_ExportDoc;
	this.exportDogovor = DpXMLExp_ExportDogovor;
	this.exportCl = DpXMLExp_ExportCl;
	this.ArrDocData = new Array();
	this.objToString = DpXMLExp_objToString;
	this.exportHeader = DpXMLExp_exportHeader;
	
	this.findIDFromCod = DpXMLExp_findIDFromCod;
	this.isSimpleCl = DpXMLExp_isSimpleCl;
	this.getNomCl = DpXMLExp_getNomCl;
	this.isExportLinkObj = true;
		
	this.exportCls = DpXMLExp_ExportCls;
	//this.exportClcl = DpXMLExp_ExportClcl;
	this.createRoot =DpXMLExp_createRoot;
	
	this.bStatus = false;	//Состояние инициализации объекта
	this.bStatus = this.initExport();	
	if(sFileName) this.outFileName = sFileName;	
	this.alreadyExportedMap = new Array();
	//this.exportNmkl = ExportNmkl;
	//this.exportSimpleCl = ExportSimpleCl;	
}

function DpXMLExp_InitExport()
{
	var bRet = true;
	this.dpApi = lpProxy.getDpAPI();	
	this.outXMLDOM = lpProxy.createXmlDoc();	
	return bRet;
}

function DpXMLExp_export(arrID,sType)
{	
	this.createRoot();
	var ExpFunc = this.getExpFunc(sType);
	this[ExpFunc](sSelFwid,sType);
	
	lpProxy.SaveXML(this.outXML,this.outFileName);	
	alert("Експорт закончен");
}

function DpXMLExp_getExpFunc(sType)
{
	sType = String(sType);	
		
	if (sType.startsWith("IDPN"))
		return "getPN1";
	if (sType.startsWith("cls.nmkl"))
		return "exportNmkl";
	if (sType.startsWith("cls."))
		return "exportCL";
	if (sType.startsWith("docs."))
		return "exportDoc";
	if (sType.startsWith("dogovor"))
		return "exportDogovor";
			
	return null; 
}

function DpXMLExp_createRoot()
{	
	this.outXML = this.outXMLDOM.createElement("EXPORT");
	this.outXML.setAttribute("date", format("dd.mm.yyyy", new Date()));
	this.outXML.setAttribute("type", "deb");
	this.outXMLDOM.appendChild(this.outXML);
}

function DpXMLExp_ExportDocs(arrID,sType)
{
	this.createRoot();
	
	if (!this.ArrObjData[sType])
		this.ArrObjData[sType] = new Array();	
	for (var i = 0; i < arrID.length; i++)
	{
		this.exportDoc(sType, arrID[i]);		
	}
	
	lpProxy.saveXml(this.outXMLDOM,this.outFileName);	
	alert("Експорт закончен");
	
}

function DpXMLExp_ExportDoc(sType, ID)
{
	ID = Number(ID);
	include ("doc/DpDoc.js");
	if (!this.alreadyExportedMap["docs." + sType])
		this.alreadyExportedMap["docs." + sType] = new Array();
	else if (this.alreadyExportedMap["docs." + sType][ID])
		return;
	
	var oDoc = new DpDoc(sType, 0);
	if (!oDoc.loadByID(ID))
	{
		return;
	}
	oDoc.setVar("HOUTID", String(ID));
	var el  =  this.outXMLDOM.createElement("object");
	el.setAttribute("ID", String(ID));
	el.setAttribute("type", "docs." + sType);
	var header = this.exportHeader(oDoc);
	if (header)
	{
		el.appendChild(header);
	}
	
	var childClassIds = oDoc.getChildIDs();
	for (var i = 0; i < childClassIds.length; i++)
	{
		var rows = this.exportRows(oDoc, childClassIds[i]);
		if (rows)
			el.appendChild(rows);
	}
		
	this.outXML.appendChild(el);
	this.alreadyExportedMap["docs." + sType][ID] = true;
	
	
}

function DpXMLExp_ExportDogovor(ID)
{
	var oSnap = getSnap("select fdoc from ^contract where fwid = " + ID);
	if (!oSnap || !oSnap[0])
		return;
	
	this.exportDoc(oSnap[0], ID);
}

function DpXMLExp_ExportCl(sType, ID)
{
	ID = Number(ID);
	include ("Objects/DpClEx.js");
	var sKey = "cls." + sType;
	if (!this.alreadyExportedMap[sKey])
		this.alreadyExportedMap[sKey] = new Array();
	else if (this.alreadyExportedMap[sKey][ID])
		return;
	
	var nomCl = 0;
	if (sType != "CL2" && this.isSimpleCl(sType))
	{
		nomCl = this.getNomCl(sType);
		if (!nomCl)
			return;
		sType = sType.substr(0, sType.lastIndexOf("."));
	}
	
	var oDoc = new DpClEx(sType, nomCl);
	
	if (!oDoc.loadByID(ID, false, true))
	{
		return;
	}
	oDoc.setVar("HOUTID", String(ID));
	var el  =  this.outXMLDOM.createElement("object");
	el.setAttribute("ID", String(ID));
	el.setAttribute("type", sKey);
	var header = this.exportHeader(oDoc);
	if (header)
	{
		el.appendChild(header);
	}
	
	var childClassIds = oDoc.getChildIDs();
	for (var i = 0; i < childClassIds.length; i++)
	{
		var rows = this.exportRows(oDoc, childClassIds[i]);
		if (rows)
			el.appendChild(rows);
	}
		
	this.outXML.appendChild(el);	
	this.alreadyExportedMap[sKey][ID] = true;
	
	
}

function DpXMLExp_ExportRows(obj, rowClassID)
{
	var rows = this.outXMLDOM.createElement("rows");
	rows.setAttribute("ID", rowClassID);
	var childs = obj.getJObject().getChilds(rowClassID);
	for (var i = 0; i < childs.length; i++)
	{
		var row = this.outXMLDOM.createElement("object");
		row.setAttribute("ID", String(Number(childs[i].getObjectID())));
		row.setAttribute("type", String(childs[i].getClassID()));
		var oRow = obj.getRow(rowClassID,  Number(childs[i].getObjectID()));
		var header = this.exportHeader(oRow);
		if (header)
		{
			row.appendChild(header);
		}
		rows.appendChild(row);
	}
	return rows;
}

function DpXMLExp_exportHeader(obj)
{
	var header  =  this.outXMLDOM.createElement("Header");
	var varInfos = obj.getVarsInfo();
	for (var i = 0; i < varInfos.length; i++)
	{
		var vi = varInfos[i];
		if (vi.isCalc)
			continue;
		var oValue = obj.getVar(vi.name);
		
		var xmlVar = this.outXMLDOM.createElement(vi.name);
		if (String(vi.objectType))
		{
			var sType = String(vi.objectType);
			if (!oValue)
				continue;			
			var sValue = String(Number(oValue));
			
			var subHeader  =  this.outXMLDOM.createElement("Header");
			xmlVar.appendChild(subHeader);
			
			var xmlOutID = this.outXMLDOM.createElement("HOUTID");
			
			var outidText = sValue;
			
			
			if (String(vi.objectType).startsWith("cls.") && sType != "cls.nmkl")
			{
				var xmlCod = this.outXMLDOM.createElement("HCOD");
				subHeader.appendChild(xmlCod);
				
				var xmlText = this.outXMLDOM.createTextNode(sValue);
				xmlCod.appendChild(xmlText);
			}
			
			var idObj = this.findIDFromCod(sType, Number(oValue));
			if (idObj)
			{
				outidText = idObj
				var xmlText = this.outXMLDOM.createTextNode(outidText);
				xmlOutID.appendChild(xmlText);
				
				subHeader.appendChild(xmlOutID);
			}
			
			if (this.isExportLinkObj && idObj)
			{	
				if (!(this.alreadyExportedMap[sType] && this.alreadyExportedMap[sType][idObj]))
				{
					if (String(vi.objectType) == "dogovor")
						this.exportDogovor(idObj);
					else
						this.exportCl(sType.substr(4), idObj);
					
				}
					
				                                                                     
			}
			
		}
		else
		{	
			var sValue = this.objToString(oValue, vi.dataType);
			var xmlText = this.outXMLDOM.createTextNode(sValue);
			xmlVar.appendChild(xmlText);
		}
		header.appendChild(xmlVar);		
	}
	
	
	return header;
}

function DpXMLExp_objToString(obj, type)
{
	return this.dpApi.obj2XmlStr(obj,type);
}

function DpXMLExp_findIDFromCod(sType, nCod)
{
	if (sType.startsWith("cls."))
	{
		sType = sType.substr(4);
		
		if (sType == "CL2" || this.isSimpleCl(sType))
		{
			var nCl = (sType == "CL2") ? 0 : this.getNomCl(sType);
			if (nCl == null)
				return null;
			var oSnap = getSnap("select fwid_cl from ^clrelclcl where fcl = " + nCl + " and fcod = " + Number(nCod));
			if (oSnap && oSnap[0])
				return oSnap[0];
			else
				return null;
		}
		else if (sType == "edi")
		{
			var oSnap = getSnap("select fwid from ^cl_edi where fcod = " + Number(nCod));
			if (oSnap && oSnap[0])
				return oSnap[0];
			else
				return null;
		}
		else if (sType == "valut")
		{
			var oSnap = getSnap("select fwid from ^cl_valut where fkod = " + Number(nCod));
			if (oSnap && oSnap[0])
				return oSnap[0];
			else
				return null;
		}
		else if (sType == "osnazv")
		{
			var oSnap = getSnap("select fwid from ^osnazv where finv_num = " + Number(nCod));
			if (oSnap && oSnap[0])
				return oSnap[0];
			else
				return null;
		}
		return Number(nCod);
	}
	else if (sType == "dogovor")
	{
		return Number(nCod);
	}
	
	return null;
}

function DpXMLExp_isSimpleCl(sType)
{
	return !inList(sType, "edi", "nmkl", "valut", "metals", "naktos", "os0", "os0b", "osnazv", "vn_perem");
}

function DpXMLExp_getNomCl(sType)
{
	var nLastPos = sType.lastIndexOf(".");
	if (nLastPos == -1)
		return null;
	
	var sCl = sType.substr(nLastPos + 1);	
	var nCl = null;
	if (isNaN(sCl))
	{
		sCl = getPar(sCl);
		if 	(sCl)
		{
			nCl = Number(sCl);
		}		
	}
	else
	{		
		nCl = Number(sCl);		
	}
	
	return nCl;
	
}


function DpXMLExp_importRefObj()
{
	
}

function DpXMLExp_ExportCls()
{
	
}

