/*Описание объекта для выбора N операции
 */
include("objects\\DpOperation.js");

function DpNop (mnop, mdoc)
{
	RO("DpNop", this);
   this.setCod  = DpNop_setCod;
   this.zSetCod = DpNop_zSetCod;
   this.getCod  = DpNop_getCod;
   this.getDoc  = DpNop_getDoc;
   this.linkCtrl = DpNop_linkCtrl;
   this.updateCtrl = DpNop_updateCtrl;
   this.validCtrl = DpNop_validCtrl;
   this.zaval = DpNop_zaval;
   this.setZeroIsValid = DpNop_setZeroIsValid;
//   this.pFnop   = null;
//   this.ctrlCod = null;
   this.zeroIsValid = false;
   this.setCod(mnop);
   this.doc = mdoc;
}

function DpNop_setZeroIsValid()
{
   this.zeroIsValid = true;
}


function DpNop_linkCtrl(newctrl, newDoc)
{
   this.ctrlCod=newctrl;
   this.ctrlCod.mask="########";
// св-во DpType - не поддерживается
//   if(this.ctrlCod.DpType=="DpGet")
//  {
      this.ctrlCod.setButton(true);
      this.ctrlCod.buttonHandler(this, "zaval");
//  }
   //if(Validation)
   {
      if(!newDoc)
      {
         debug("Передайте вторым параметром поле ввода документа");
         return;
      }
      this.doc = toScrObj(newDoc);
      setValid(this.ctrlCod, this, "validCtrl");
   }
   this.updateCtrl();
}

function DpNop_validCtrl()
{
   return this.zSetCod(this.ctrlCod.value, this.getDoc());
}

function DpNop_updateCtrl()
{
  if(this.ctrlCod) 
  {
  	if (!isNaN(this.pFnop))
  		this.pFnop = Number(this.pFnop);
  	this.ctrlCod.value=String(this.pFnop);
  }
}

function DpNop_setCod(mnop)
{
   this.pFnop = mnop;
   this.updateCtrl();
}

function DpNop_zSetCod(mnop,mdoc)
{
   var strSQL, pFnop, tnop;
   this.pFnop = parseInt(mnop);
   this.doc   = String(mdoc).toUpperCase();
   this.ok    = true;
   if (this.zeroIsValid  && this.pFnop ==0) return this.ok;
/*---
   strSQL = "select * from ^CL_OP where Fnop=" 
            + String(this.pFnop) + " and Fdoc=" + "'"
            +this.doc+"'" + " and Fnsect=0 and Fnprov=0";
   tnop = OpenTable("s", strSQL);
   if (tnop.IsEOF() && tnop.IsBOF())
---*/
	var oOperList = new DpOperationList(this.doc);
	
   if (isNaN(this.pFnop) || !oOperList.listOperations(true)[this.pFnop])
   {
      this.zaval();
   }
   else
   {
      this.ok = true;
   }
//-   tnop.Close();
   this.updateCtrl();
   return this.ok;
}

function DpNop_zaval()
{
   var pr = new Object();
   pr.ret = new Object();
   pr.doc = this.getDoc();
   pr.ret.fdoc     = this.getDoc();
   pr.ret.fnop = this.pFnop;
   pr.zaval = true;
   showWindow("l_clop.xml",SW_MODAL,pr,"");
   if (!pr.escape)
   {
      this.pFnop = pr.ret.fnop;
      this.ok = true;
   }else{
      this.ok = false;
   }
   this.updateCtrl();
   return this.ok;
}

function DpNop_getCod()
{
   if (!isNaN(this.pFnop))
   {
   		this.pFnop = Number(this.pFnop);
   }		
   return this.pFnop;
}

function DpNop_getDoc()
{
   return typeof(this.doc)=="object"? String(this.doc.value): String(this.doc);
}
