﻿include("objects\\DpGetDat.js");
include("oblns.js");
include("Objects\\DpGrid.js");
include("servis\\date.js");

var editAcc = "";
var listPrnForm = "gazpokat"

include("sys\\dplist.js");

function listLoad()
{
	this.title = "Довідка про розрахунки за тр-т газу"
}

function listAsk()
{
	return new DpGetDat("dD");
}

function listMake()
{
	oblns("3", list.objAsk.dat1, list.objAsk.dat2, "gazpokat_ob")

//*** 19.03.10 знімається сума 51236.00 (див. 31.10.2009 дт 68/682/11/1057 кт 71/719/6) 
//ExecuteSQL("UPDATE gazpokat_ob SET fsum1=1017170.52"
//                    + " WHERE (fsc=68 AND fsu=682 AND fst=11 AND fcl_cod1=1057 AND fsum1=1068406.52)");
//ExecuteSQL("UPDATE gazpokat_ob SET fsum3=1017170.52"
//                    + " WHERE (fsc=68 AND fsu=682 AND fst=11 AND fcl_cod1=1057 AND fsum3=1068406.52)");
ExecuteSQL("UPDATE gazpokat_ob SET fsum1=1017170.52, Fsum3=Fsum3-51236"
                    + " WHERE (fsc=68 AND fsu=682 AND fst=11 AND fcl_cod1=1057 AND fsum1=1068406.52)");


	DropTable("gazpokat_all")
	
	ExecuteSQL("CREATE TABLE gazpokat_all"
		+ " ("
			+ " fcolid " + SqlType("TEXT",60) 
			+ ", frowid " + SqlType("TEXT",60) 
			+ ", fkat " + SqlType("TEXT", 35)
			+ ", fcol " + SqlType("TEXT", 10)
			+ ", fvalue " + SqlType("DOUBLE")
			+ ", forg " + SqlType("INTEGER")
			+ ", fregion " + SqlType("INTEGER")
		+ " )"
		);

      //2011 Колонка 1 *** початкове с-до ДТ рах-в 361/1/2, 361/1/3, 361/1/4, 361/1/5, 374/1, 374/3, 682/2, 682/11 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum1 as fvalue"
			+ ", 'f1' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=2)"
				+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=3)"
				+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=4)"
                        + " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=5)"
                        + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=1)"
                        + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=2)"
                        + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=3)"
                        + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=4)"
                        + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=2)"
                        + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=4)"
				+ " OR (fsc=68 and fsu=682 and fst=2)"
				+ " OR (fsc=68 and fsu=682 and fst=11)"
			+ ")"
		);                 
	
	//2011 Колонка 2 *** початкове с-до КТ рах-в 361/1/3, 361/1/4, 361/1/5, 682/2
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum2 as fvalue"
			+ ", 'f2' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=3)"
				+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=4)"
                        + " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=5)"
				+ " OR (fsc=68 and fsu=682 and fst=2) "
			+ ")"
		);
	
	// Колонка 3 *** кількість (NK4990, NK1001, NK1200)
	ExecuteSQL(
		" INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT"
			+ " sum(a.fkol) as fvalue"
			+ ", 'f3' as fcol"
			+ ", fdbkr as forg"
		+ " FROM ^anltk a"
			+ " INNER join ^sch_zag s"
				+ " ON s.fwid = a.fid_doc"
		+ " WHERE ((s.fdoc='NK' and s.fnop=5005)"
				+ " OR (s.fdoc='NK' and s.fnop=360)"
				+ " OR (s.fdoc='NK' and s.fnop=380)"
				+ " OR (s.fdoc='NK' and s.fnop=400)"
				+ " OR (s.fdoc='NK' and s.fnop=420)"
				+ " OR (s.fdoc='NK' and s.fnop=440)"
				+ " OR (s.fdoc='NK' and s.fnop=460)"
				+ " OR (s.fdoc='NK' and s.fnop=12360)"
				+ " OR (s.fdoc='NK' and s.fnop=12380)"
				+ " OR (s.fdoc='NK' and s.fnop=12400)"
				+ " OR (s.fdoc='NK' and s.fnop=12420)"
				+ " OR (s.fdoc='NK' and s.fnop=12440)"
				+ " OR (s.fdoc='NK' and s.fnop=12460)"
				+ " OR (s.fdoc='NK' and s.fnop=1001)"
				+ " OR (s.fdoc='NK' and s.fnop=1200)"
				+ " OR (s.fdoc='NK' and s.fnop=4990))"
			+ " AND fdoc_dat between " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fdbkr"
		);

	// Колонка 5 *** вартість (NK4990, NK1001, NK1200) за попередній м-ць
	ExecuteSQL(
		" INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT "
			//+ "1.2*sum(a.fkol * a.fcenapr) as fvalue"
			+ " sum(fsum + fnds) as fvalue"
			+ ", 'f5' as fcol"
			+ ", fdbkr as forg"
		+ " FROM ^sch_zag s"
		/*
		+ " FROM ^anltk a"
			+ " INNER join ^sch_zag s"
				+ " ON s.fwid = a.fid_doc"
		*/
		+ " WHERE ((s.fdoc='NK' and s.fnop=5005)"
				+ " OR (s.fdoc='NK' and s.fnop=360)"
				+ " OR (s.fdoc='NK' and s.fnop=380)"
				+ " OR (s.fdoc='NK' and s.fnop=400)"
				+ " OR (s.fdoc='NK' and s.fnop=420)"
				+ " OR (s.fdoc='NK' and s.fnop=440)"
				+ " OR (s.fdoc='NK' and s.fnop=460)"
				+ " OR (s.fdoc='NK' and s.fnop=12360)"
				+ " OR (s.fdoc='NK' and s.fnop=12380)"
				+ " OR (s.fdoc='NK' and s.fnop=12400)"
				+ " OR (s.fdoc='NK' and s.fnop=12420)"
				+ " OR (s.fdoc='NK' and s.fnop=12440)"
				+ " OR (s.fdoc='NK' and s.fnop=12460)"
				+ " OR (s.fdoc='NK' and s.fnop=1001)"
				+ " OR (s.fdoc='NK' and s.fnop=1200)"
				+ " OR (s.fdoc='NK' and s.fnop=4990))"
			+ " AND fdoc_dat between " + sqlTo(firstDay(list.objAsk.dat2))
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fdbkr"
		);
	/*
	ExecuteSQL(s =
		" INSERT INTO gazpokat_all"
		+ " SELECT"
			+ " sum(a.fkol) as fvalue"
			+ ", 'f5' as fcol"
			+ ", fdbkr as forg"
		+ " FROM ^anltk a"
			+ " INNER join ^sch_zag s"
				+ " ON s.fwid = a.fid_doc"
		+ " WHERE ((s.fdoc='NK' and s.fnop=5005)"
				+ " OR (s.fdoc='NK' and s.fnop=360)"
				+ " OR (s.fdoc='NK' and s.fnop=380)"
				+ " OR (s.fdoc='NK' and s.fnop=400)"
				+ " OR (s.fdoc='NK' and s.fnop=420)"
				+ " OR (s.fdoc='NK' and s.fnop=440)"
				+ " OR (s.fdoc='NK' and s.fnop=460)"
				+ " OR (s.fdoc='NK' and s.fnop=12360)"
				+ " OR (s.fdoc='NK' and s.fnop=12380)"
				+ " OR (s.fdoc='NK' and s.fnop=12400)"
				+ " OR (s.fdoc='NK' and s.fnop=12420)"
				+ " OR (s.fdoc='NK' and s.fnop=12440)"
				+ " OR (s.fdoc='NK' and s.fnop=12460)"
				+ " OR (s.fdoc='NK' and s.fnop=1001)"
				+ " OR (s.fdoc='NK' and s.fnop=1200)"
				+ " OR (s.fdoc='NK' and s.fnop=4990))"
			+ " AND fdoc_dat between " + sqlTo(firstDay(list.objAsk.dat2))
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fdbkr"
		);
	*/

	// Колонка 4 *** вартість (NK4990, NK1001, NK1200) за заданий період
	ExecuteSQL(
		" INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT "
			//+ "1.2*sum(a.fkol * a.fcenapr) as fvalue"
			+ " sum(fsum + fnds) as fvalue"
			+ ", 'f4' as fcol"
			+ ", fdbkr as forg"
		+ " FROM ^sch_zag s"
		/*
		+ " FROM ^anltk a"
			+ " INNER join ^sch_zag s"
				+ " ON s.fwid = a.fid_doc"
		*/
		+ " WHERE ((s.fdoc='NK' and s.fnop=5005)"
				+ " OR (s.fdoc='NK' and s.fnop=360)"
				+ " OR (s.fdoc='NK' and s.fnop=380)"
				+ " OR (s.fdoc='NK' and s.fnop=400)"
				+ " OR (s.fdoc='NK' and s.fnop=420)"
				+ " OR (s.fdoc='NK' and s.fnop=440)"
				+ " OR (s.fdoc='NK' and s.fnop=460)"
				+ " OR (s.fdoc='NK' and s.fnop=12360)"
				+ " OR (s.fdoc='NK' and s.fnop=12380)"
				+ " OR (s.fdoc='NK' and s.fnop=12400)"
				+ " OR (s.fdoc='NK' and s.fnop=12420)"
				+ " OR (s.fdoc='NK' and s.fnop=12440)"
				+ " OR (s.fdoc='NK' and s.fnop=12460)"
				+ " OR (s.fdoc='NK' and s.fnop=1001)"
				+ " OR (s.fdoc='NK' and s.fnop=1200)"
				+ " OR (s.fdoc='NK' and s.fnop=4990))"
			+ " AND fdoc_dat between " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fdbkr"
		);

	// Колонка 7 *** обіги по КТ (361/1/1, 682/1)
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum6 as fvalue"
			+ ", 'f7' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=1)"
			+ " OR (fsc=68 and fsu=682 and fst=1)"
			+ ")"
		);

       //*** 19.04.10 мінус дт 374/1 кт 361/1/1
       ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT -sum(fsum) as fvalue"
			+ ", 'f7' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE ( (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2=1)"
			+ " AND (fdb_sc=37 and fdb_su=374 and fdb_st=1)"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
			+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);

       //*** 03.02.11 мінус дт 374/3 кт 361/1/1
       ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT -sum(fsum) as fvalue"
			+ ", 'f7' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE ( (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2=1)"
			+ " AND (fdb_sc=37 and fdb_su=374 and fdb_st=3)"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
			+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);


	// Колонка 10 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT sum(fsum) as fvalue"
			+ ", 'f10' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE fdoc='BS' and fnop in(233,804)"
			+ "AND ( (fcr_sc=36 and fcr_su=361 and fcr_st=1)"
			+ " OR (fcr_sc=68 and fcr_su=682 and fcr_st=1)"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);
	/*
	ExecuteSQL(
		" INSERT INTO gazpokat_all"
		+ " SELECT "
			+ " sum(fsum) as fvalue"
			+ ", 'f10' as fcol"
			+ ", forg"
		+ " FROM ^hbs s"
		+ " WHERE (s.fdoc='BS' and s.fnop=233)"
			+ "AND ( (fsc=36 and fsu=361 and fst=1)"
			+ " OR (fsc=68 and fsu=682 and fst=1)"
			+ ") AND fdoc_dat between " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY forg"
		);
	*/

	//2011 Колонка 12 *** обіги по КТ 361/1/2, 361/1/3, 361/1/4, 361/1/5, 374/1, 374/3, 682/2, 682/11
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum6 as fvalue"
			+ ", 'f12' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=2)"
			+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=3 )" 
			+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=4 )"
                  + " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=5 )" 
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=1)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=2)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=3)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=4)"
                  + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=2)"
                  + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=4)"
                  + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=8)"
			+ " OR (fsc=68 and fsu=682 and fst=2)"
			+ " OR (fsc=68 and fsu=682 and fst=11)"
			+ ") "
		);

      //*** 19.04.10 мінус дт 374/1/1/1 (і 2,3,4) кт 361/1/1/3 (і 4,5)
      ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT -sum(fsum) as fvalue"
			+ ", 'f12' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE ( (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2 in (3,4,5))"
			+ " AND (fdb_sc=37 and fdb_su=374 and fdb_st=1 and fdb_cod2=1 and fdb_cod3 in (1,2,3,4))"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
			+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);

      //*** 03.02.11 мінус дт 374/3/1/2 (і 4) кт 361/1/1/3 (і 4,5)
      ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT -sum(fsum) as fvalue"
			+ ", 'f12' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE ( (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2 in (3,4,5))"
			+ " AND (fdb_sc=37 and fdb_su=374 and fdb_st=3 and fdb_cod2=1 and fdb_cod3 in (2,4,8))"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
			+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);


	// Колонка 8 = 7 - 10 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT " + IIF("a.fcol='f7'", "1", "-1") + " * a.fvalue as fvalue"
			+ ", 'f8' as fcol"
			+ ", forg"                      	
		+ " FROM gazpokat_all a"
		+ " WHERE fcol='f7'"
			+ " OR fcol='f10'"
		);

	// Колонка 15 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT sum(fsum) as fvalue"
			+ ", 'f15' as fcol"
			+ ", fcr_cod1 as forg"
		+ " FROM ^schet"
		+ " WHERE fdoc='BS' and fnop=233"
			+ "AND ( (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2=2)"
			+ " OR (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2=3)"
			+ " OR (fcr_sc=36 and fcr_su=361 and fcr_st=1 and fcr_cod2=11)"
			+ " OR (fcr_sc=37 and fcr_su=374 and fcr_st=1)"
			+ " OR (fcr_sc=68 and fcr_su=682 and fcr_st=3)"
			+ " OR (fcr_sc=68 and fcr_su=682 and fcr_st=11)"
			+ ") AND fdate between " + sqlTo(list.objAsk.dat1)
				+ " AND " + sqlTo(list.objAsk.dat2)	
		+ " GROUP BY fcr_cod1"
		);

	// Колонка 13 = 12- 15
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT " + IIF("a.fcol='f12'", "1", "-1") + " * a.fvalue as fvalue"
			+ ", 'f13' as fcol"
			+ ", forg"                      	
		+ " FROM gazpokat_all a"
		+ " WHERE fcol='f12'"
			+ " OR fcol='f15'"
			);

	// Колонка 6 = 7 + 12
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT a.fvalue as fvalue"
			+ ", 'f6' as fcol"
			+ ", forg"                      	
		+ " FROM gazpokat_all a"
		+ " WHERE fcol='f7'"
			+ " OR fcol='f12'"
		);

	// Колонка 18 *** кінцеве с-до ДТ рах-в 361/1/1, 682/1 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum3  as fvalue"
			+ ", 'f18' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
		+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=1)"
		+ " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=8)"
		+ " OR (fsc=68 and fsu=682 and fst=1)"
		+ ")"
		);


	//2011 *** мінус кт-ве с-до 361/1/1, 361/1/2, 361/1/3, 361/1/4, 361/1/5, 682/1, 682/2
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT - fsum4 as fvalue"
			+ ", 'f18' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and (fcl_cod2=1 OR fcl_cod2=2 OR fcl_cod2=3 OR fcl_cod2=4 OR fcl_cod2=5)) "
                  + " OR (fsc=68 and fsu=682 and fst=1)"
                  + " OR (fsc=68 and fsu=682 and fst=2)"
                  + ")"  
            );
	
	//2011 Колонка 19 *** кінцеве с-до ДТ рах-в 361/1/2, 361/1/3, 361/1/4, 361/1/5, 682/2, 682/11, 374/1/1/1(і 2,3,4), 374/3/1/2(і 4) 
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT fsum3 as fvalue"
			+ ", 'f19' AS fcol"
			+ ", fcl_cod1 AS forg"
		+ " FROM gazpokat_ob"
		+ " WHERE fistotal=0"
			+ "AND ( (fsc=36 and fsu=361 and fst=1 and fcl_cod2=2)"
			+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=3)"
			+ " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=4)"
                  + " OR (fsc=36 and fsu=361 and fst=1 and fcl_cod2=5)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=1)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=2)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=3)"
                  + " OR (fsc=37 and fsu=374 and fst=1 and fcl_cod2=1 and fcl_cod3=4)"
                  + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=2)"
                  + " OR (fsc=37 and fsu=374 and fst=3 and fcl_cod2=1 and fcl_cod3=4)"
			+ " OR (fsc=68 and fsu=682 and fst=2)"
			+ " OR (fsc=68 and fsu=682 and fst=11)"
			+ ")"
		);

	// Колонка 17 = 18 + 19
	ExecuteSQL(
		"INSERT INTO gazpokat_all (fvalue, fcol, forg)"
		+ " SELECT a.fvalue as fvalue"
			+ ", 'f17' as fcol"
			+ ", forg"                      	
		+ " FROM gazpokat_all a"
		+ " WHERE fcol='f18'"
			+ " OR fcol='f19'"
		);
	// ------------------------------------------------

	/* было
	ExecuteSQL(
	        "UPDATE ( gazpokat_all g"
			+ " LEFT JOIN ^clrelclcl rel"
				+ " ON g.forg = rel.fcod"
			+ ") LEFT JOIN ^cl_post post"
				+ " ON post.fwid_cl = rel.fwid_cl"
		+ " SET g.fregion = post.fcodregion"
		+ " WHERE rel.fcl=0"
			+ " AND NOT post.fcodregion IS NULL"
		);
        */
	ExecuteSQL(
	        "UPDATE gazpokat_all g"
		+ " SET g.fregion = (SELECT MAX(post.fcodregion) FROM ^clrelclcl rel"
			+ " INNER JOIN ^cl_post post"
				+ " ON post.fwid_cl = rel.fwid_cl"
			+ " WHERE g.forg = rel.fcod"
				+ " AND rel.fcl=0"
			+ ")"
		+ " WHERE EXISTS (SELECT post.fcodregion FROM ^clrelclcl rel"
			+ " INNER JOIN ^cl_post post"
				+ " ON post.fwid_cl = rel.fwid_cl"
			+ " WHERE g.forg = rel.fcod"
				+ " AND rel.fcl=0"
			+ ")"
		);

	/* было
	var tExt = OpenTable("s", "SELECT a.FWID, a.FLABEL, a.FTXT, a.FTYPE, a.FWIDTH "
		+ " FROM ^CL_EXT a INNER JOIN ^CL_EXT_L b ON a.FWID = b.FWID "
		+ " WHERE b.FVID = 'CL'"
			+ " AND fcl = 0"
			+ " AND flabel='_BUDJET'"
			);

	ExecuteSQL(
		"UPDATE (gazpokat_all g"
			+ " INNER JOIN ^clrelclcl rel"
				+ " ON g.forg = rel.fcod"
			+ ") INNER JOIN ^ext_cl ext"
				+ " ON ext.fmainwid = rel.fwid_cl"
                                          + " SET g.fkat = "
      //*** додані назви категорій споживачів
 					+ IIF ("ext.fint=1 or ext.fint=2 or ext.fint=5 or ext.fint=7"
						      , "'1. Промисловість'"
                                    , IIF ("ext.fint=6"
							, "'2. Енергогенеруючі підприємства'"
						, IIF ("ext.fint=8"
							, "'4.1. Облгази для населення'"
						, IIF ("ext.fint=4"
							, "'4.2. Бюджетні установи'"
						, IIF ("ext.fint=3"
							, "'4.3. Підприємства теплокомуненерго' "
							, "' -- '" )))))
		+ " WHERE ext.fwid = " + sqlTo(tExt.getValue("fwid"))
			+ " AND NOT ext.fint IS NULL"
                            	+ " AND rel.fcl=0"
		);
	*/
	var strSQL = "select rel.fcod, count(rel.fcod) as kilkist from ^clrelclcl as rel LEFT JOIN " + getPath("EXT") 
				+ ".cl_0 ext ON ext.fmainwid = rel.fwid_cl and rel.fcl=12 where rel.fcl=12 "
				+ " group by rel.fcod,rel.fcl having count(rel.fcod)>1 order by rel.fcod";
	var t = OpenTable(strSQL)
	if(t.rowCount>0)
	{
		browse(t);
		alert("Найдены задвоенные контрагенты!!!")
	}
	t.close();
	ExecuteSQL(
		"UPDATE gazpokat_all g"
		+ " SET g.fkat = ("
			+ "SELECT " + IIF ("ext.f_budjet=1 or ext.f_budjet=2 or ext.f_budjet=5 or ext.f_budjet=7 or ext.f_budjet is null"
				            , "'1. Промисловість'"
					, IIF ("ext.f_budjet=6"
					      , "'2. Енергогенеруючі підприємства'"
					, IIF ("ext.f_budjet=8"
						, "'4.1. Облгази для населення'"
					, IIF ("ext.f_budjet=4"
						, "'4.2. Бюджетні установи'"
					, IIF ("ext.f_budjet=3"
						, "'4.3. Підприємства теплокомуненерго' "
						, "' -- '" )))))
			+ " FROM ^clrelclcl rel"
				+ " LEFT JOIN " + getPath("EXT") + ".cl_0 ext"
					+ " ON ext.fmainwid = rel.fwid_cl"
			+ " WHERE g.forg = rel.fcod"
				+ " AND rel.fcl=0"
				//+ " AND NOT ext.f_budjet IS NULL"
			+ ")"
		/*
		+ " WHERE EXISTS (SELECT ext.f_budjet"
			+ " FROM ^clrelclcl rel"
				+ " INNER JOIN " + getPath("EXT") + ".cl_0 ext"
					+ " ON ext.fmainwid = rel.fwid_cl"
			+ " WHERE g.forg = rel.fcod"
                            	+ " AND rel.fcl=0"
				+ " AND NOT ext.f_budjet IS NULL"
			+ ")"
		*/
		);

	ExecuteSQL("update gazpokat_all set fkat='' where fkat is null");            
      //*** 1-й категорії назва присвоюється примусово, бо відбиралася окремим рядком без назви 
	ExecuteSQL("update gazpokat_all set fkat='1. Промисловість' where fkat='                                   ' ");            
	
	DropTable("gazpokat_s")
	ExecuteSQL(
		"SELECT sum(a.fvalue) as fvalue, fkat, fregion, fcol"
			+ ", " + SqlConCat(Convert("fregion", "NVC"), "'/'", "fkat") + " as frowid"
			+ ", fcol as fcolid"
			+ ", max(a.forg) as forg"
		+ " INTO gazpokat_s"
		+ " FROM gazpokat_all a"
		+ " GROUP BY fkat, fregion, fcol"
		);	

	//ExecuteSQL( "CREATE INDEX RowCol ON gazpokat_s (FrowId, FcolId)" );

	// Итоги
	ExecuteSQL(
		"INSERT INTO gazpokat_s (fvalue, fregion, fcol, frowid, fkat, fcolid)"
		+ " SELECT sum(a.fvalue) as fvalue, fregion, fcol"
			+ ", " + Convert("fregion", "NVC") + " as frowid"
			+ ", 'TOT' as fkat"
			+ ", fcol as fcolid"
		+ " FROM gazpokat_all a"
		+ " GROUP BY fregion, fcol"
		);

	ExecuteSQL(
		"INSERT INTO gazpokat_s (fvalue, fcol, fcolid, frowid, fregion)"
		+ " SELECT sum(" + IIF("a.fvalue IS NULL", "0", "a.fvalue") + ") as fvalue, fcol"
			+ ", fcol as fcolid"
			+ ", '99999' as frowid"
			+ ", 99999 as fregion"
		+ " FROM gazpokat_all a"
		+ " GROUP BY fcol"
		);

      //*** підсумки по категоріях споживачів
            ExecuteSQL(
		"INSERT INTO gazpokat_s (fvalue, fkat, fcol, frowid, fregion, fcolid)"
		+ " SELECT sum(a.fvalue) as fvalue, fkat, fcol"
			+ ", " + Convert("fkat", "NVC") + " as frowid"
			+ ", '99' as fregion"
			+ ", fcol as fcolid"
		+ " FROM gazpokat_all a"
		+ " GROUP BY fkat, fcol"
		);
      //***	

	DropTable("gazpokat_r");
	ExecuteSQL(
		"SELECT max(a.forg) as forg, frowid, fkat, fregion"
		+ " INTO gazpokat_r"
		+ " FROM gazpokat_s a"
		+ " GROUP BY frowid, fkat, fregion"
		);
	ExecuteSQL( "CREATE INDEX gazpokat ON gazpokat_r (fregion, fkat, frowid)" );

	DropTable("gazpokat_c");
	ExecuteSQL(
		"SELECT DISTINCT fcolid"
		+ " INTO gazpokat_c"
		+ " FROM gazpokat_s"
		);

	/// Этот блок не нужен, но без таблицы gazpokat - не работает
	DropTable("gazpokat");
	ExecuteSQL(
		"SELECT DISTINCT fcolid"
		+ " INTO gazpokat"
		+ " FROM gazpokat_s"
		);
}

function listSrc()
{
	list.qrySet("Cross", "gazpokat"
		, "Order", new Array("fregion, fkat, frowid")
		);

	//t = OpenTable("c", "gazpokat", "gazpokat");

	//DataSource().source(t)
}

function listDpGrid()
{
	oGrid = new DpGrid("NOCREATE")

	with(oGrid)
	{
		defCond("=^fregion==99999", "tot");
		defCond("=^fkat==\"TOT\"", "totkat");

		color(1, "tot");
		color(2, "totkat");
		with(page())
		{
			with (group())
			{
				with(group("Регіон"))
				{
					cell("=^fregion==99999? \"\": ^fregion", "код", 4);
					cell("=^fregion==99999? \"РАЗОМ\": tcl('CL', '', 103, ^fregion)", "назва" ,10);
				}
				cell("=^fregion==99999?\"     \":^fkat==\"TOT\"? \"РАЗОМ\" :^fkat", "Категорія", 10)//.subCaption("1");

			}
			cell("f1", "Дт с-до\nна 01.01.10\nгрн", 10)//.subCaption("1");
                  cell("f2", "Кт с-до\nна 01.01.10\nгрн", 10)//.subCaption("2");
			cell("f3", "Факт.\nпротрансп.\nмлн.м3", 10)//.subCaption("3");
			cell("f4", "Нарах.всього\nгрн", 10)//.subCaption("4");
			cell("f5", "Нарах.\nу попер.м-ці\nгрн", 10)//.subCaption("5");
			cell("f6", "Оплата всього\nгрн", 10)//.subCaption("6");

			cell("f7", "Оплата\nпоточної\nзаборг.\nгрн", 10)//.subCaption("7");			
			with(group("в тому числi"))
			{
				cell("f8", "грошовi кошти", 10)//.subCaption("8");
				// cell("f9", "векселi", 10)//.subCaption("9"); *** у 2010 без КТ заборг-ті минулих років
				cell("f10", "взаємозалiки", 10)//.subCaption("10");
//                                                        cell("=iif(^f7>0 and (^f5 - ^f4)<>0, ^f7/(iif(^f5 - ^f4==0, 1, ^f5 - ^f4), 0))", "%", 10)//.subCaption("11");
//19.02.07				cell("=iif((^f4>0 and ^f5>0) and ^f7>0, ^f7/(iif(^f5==0, 1, ^f5)-iif(^f4==0, 1, ^f4)), 0)", "%", 10)//.subCaption("11");
//*** f12 - на тому ж рівні, що й f7 і f6
			}
	                            cell("f12", "Оплата\nминулих\nборгiв\nгрн", 10)//.subCaption("12");
			
			with(group("в тому числi"))
			{
				cell("f13", "грошовi кошти", 10)//.subCaption("13");
//*** f13 дублювалося на f14
				// cell("f14", "векселi", 10)//.subCaption("14"); *** у 2010 без КТ заборг-ті минулих років
				cell("f15", "взаємозалiки", 10)//.subCaption("15");
				//cell("=(^f2>0? ^f12/(^f2==0? 1: ^f2): 0)", "%", 10)//.subCaption("16")
				cell("=^f2>0? 100*^f12/^f2: 0", "%", 10)//.subCaption("16")
			}
			with(group("Заборгованість на кінець періоду"))
			{
				cell("f17", "Всього\nгрн", 10)//.subCaption("17");
				with(group("в тому числі"))
				{
					cell("f18", "За звітний\nперіод", 10)//.subCaption("18");
					cell("f19", "Минулі\nборги", 10)//.subCaption("19");
				}
			}
		}
		with(page())
		{
			cell("forg", "Орг", 10);
		}
		build();
	}
}			

function OnLoadMenu()
{
	stdMenuInit(DataSource());
}

function OnSelectMenu(ID)
{
	stdMenuHandler(ID,DataSource().getTable()); 
}

function getTblH()
{
	var m = new Object;
	m.FDAT = list.objAsk.dat1;
}