include("Objects/DpCl.js");
include("Objects/DpNmkl.js");

var t;
var edMode;
var mFwid;
var oClClient;
var oClNmkl;
var sHomoTbl = "CL_HOMO";
var sOutTbl = "BILL_ITERATED";

function onLoad()
{	
	edMode = extPar.mode;
	mFwid  = extPar.fwid;
			
	Caption(ru("Услуги и периоды", "Послуги та періоди"), extPar.mode);
		
	t = extPar.m_pTable;
	
	setPar("bill_to_cl_client", "1");
	
	oClNmkl = new DpNmkl();
	oClNmkl.linkCtrl(Fnmkl, tFnmkl);
	
	oClClient = new DpCl("!0", getPar("bill_cl"), 0);
	oClClient.linkSmartCtrl(Fclient);
	//oClClient.linkCtrl2("FTXT", tFclient);	
	oClClient.setContAssist();
	oClClient.setMode("");
		
	if(extPar.dat1)
	{
		Fbdate.value = extPar.dat1;
		Fedate.value = extPar.dat2;
	}
	
	if(extPar.mode=="ADD" && differ(new Date(Fbdate.value), new Date(D00))==0)
	{
		Fbdate.value = new Date().getVarDate();
	}
			
	if(edMode == "EDIT" || edMode == "COPY")
	{
		oClNmkl.setCod(Number(t.getValue("FNMKL"))); 
		oClClient.setFWID(t.getValue("FCLIENT"));
		Fbdate.value = t.getValue("FBDATE");
		Fedate.value = t.getValue("FEDATE");
		Frem.value = t.getValue("homo.FREM");
	}
	
	setValid(Fbdate, date_valid)
	setValid(Fedate, date_valid)
}

function date_valid()
{
	var bdat = new Date(Fbdate.value);
	var edat = new Date(Fedate.value);
	if(differ(bdat, edat)>0)
	{
		WAIT(ru("Дата начала не может быть больше даты конца"
				,"Дата початку не може бути більшою за дату кінця"));
		//setFocus(Fbdate);
		return false;
	}	
}

function onEscape()
{	
	setPar("bill_to_cl_client", "0");
	//t.Close();
}

function onSave()
{
	var m = new Object();
	m.Fwid = t.getValue("FWID");
	if (edMode!="EDIT")
		m.Fwid = GetUID();	
	m.FNMKL = oClNmkl.getCod(); 
	m.FCLIENT = oClClient.getFWID();
	m.FBDATE = new Date(Fbdate.value).getVarDate();
	m.FEDATE = new Date(Fedate.value).getVarDate();
	UpdateTable("^"+ sOutTbl, m, edMode!="EDIT");
	
	ExecuteSQL("update ^"+ sHomoTbl +" set FREM="+ sqlTo(Frem.value) 
				+" where fwid_cl="+ sqlTo(oClClient.getFWID()), false);	
}

include("sys/DpBaseDlg.js");