include("Objects/DpCl.js");
include("Objects/DpNmkl.js");

var sHomoTbl = "cl_homo";
var oClClient;
var oClNmkl;
var mode;

function listLoad()
{
	oClClient = new DpCl("0!", getPar("bill_cl"), 0);
	oClClient.linkCtrl(Fclient);
	oClClient.linkCtrl2("FTXT", tFclient);
	oClClient.setFWID(extPar.fclient);
			
	HUSUM.mask = MASK_SUM;
	HOSUM.mask = MASK_SUM;
	HDEBT.mask = MASK_SUM;
	HOVER.mask = MASK_SUM;
	
	Disable(Fclient);
	Disable(HUSUM);
	Disable(HOSUM);
	Disable(HDEBT);	
	Disable(HOVER);	
	Disable(Frem);
	
	with( list )
	{
		title = ru("Карточка клиента: ", "Картка кліента: ");		
			
		//subDpGrid = gridInit;
		subMenuInit = menuInit;
		subMenuRun = menuRun;
		subOnPrnList = onPrnList;
		printLabel = "BCARD";
		accDel = acceptDel;
	}
	recalc_sum();
	loadCond();	
	
	this.doEdit = doEdit;
	setButton(btnEdit, this, "doEdit");
	setFocus(btnEdit);	
}

function loadCond()
{
	curCond.setText(" ");	
	
	var z = getSnap("SELECT frem, fsls FROM ^"+ sHomoTbl
			+" WHERE FWID_CL="+ sqlTo(extPar.fclient));
	if(!z)
		return;
	
	var sText = ru("Подключен","Підключений");
	switch(Number(z[1]))
	{	
	case 1:
		sText = ru("Отключен по заявлению","Відключений по заяві");
		break;
	case 2:
		sText = ru("Отключен за неуплату","Відключений за несплату");
		break;
	case 3:
		sText = ru("Съехал","Виїхав");
		break;
	default:
		sText = ru("Подключен","Підключений");
		break;
	}
	curCond.setText(sText);	
	Frem.value = z[0];
}

function doEdit()
{
	var oCl4Edit = new DpCl("0!", getPar("bill_cl"), oClClient.getCod());
	oCl4Edit.zaval();
}

function acceptDel()
{
	return false;
}

function listSrc()
{	
	with(list)
	{ 		
		qrySet("From", "^rbill"
			, "Where", "FCLIENT = "+ extPar.fclient
			, "Order", "FDATE");
	
		//subTie("CLRELCLCL","CLREL","CLCOD","="+getPar("bill_cl")+",Fclient",null,TIE_NOSEARCH);
		subTie("CL", "x_cl", "FWID", "Fclient");
		subTie(sHomoTbl, "homo", "FWID_CL", "Fclient");		
		subTie("CL_NMK", "nmk", "FWID", "FNMKL");
	}
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	with(new DpGrid("NOCREATE"))
	{	
		defCond("=^FDOC=='BO'", "PAYMENT");
		color(1, "PAYMENT");
		
		with(page())
		{	
			with(group("Номенклатура"))
			{
				cell("=^FNMKL!=0? ^nmk.FCOD : ''", "Код", 5, "e");
				cell("=^FNMKL!=0? ^nmk.FTXTS : ''", "Найменування|Наименование", 20);
			}
			with(group("Період|Период"))
			{
				cell("Fdate", "Початок|Начало", 8, "e");
				cell("Fedate", "Кінець|Конец", 8, "e");
			}
			cell("Fsum", "Сума|Сумма", 10, "e", DP_FORMAT_SUM);
			
			cell("Frtype", "Заказ", 5, "e");
		}
		build();
	}
	grid.setFocus();
}

function menuInit()
{
	var ds = DataSource();
	var t = ds.getTable();
	with( list.dataSrc )
	{	
		if(!list.tbl.IsEmpty())
		{
			ds.AddMenuItem("CTRL-D", "Пошук документа|Поиск документа");
		}
	}
}

function menuRun(ID)
{
	var ds = DataSource();
	var t = ds.getTable();
	switch(ID)
	{
		case "CTRL-D":
			include("doc/DpDocPtn.js");
			var zzz = OpenTable("s", "SELECT * FROM ^hbill WHERE fwid = "+ sqlTo(t.getValue("fid_doc")));
			FindDocument(zzz.getValue("fdoc"), zzz.getValue("fnop"), t.getValue("fid_doc"));
			zzz.close();
			break;
		default:
			break;
	}
}

function onPrnList(tv)
{
	tv.setVar("HUSUM", HUSUM.value);
	tv.setVar("HOSUM", HOSUM.value);
	tv.setVar("HDEBT", HDEBT.value);
	tv.setVar("HOVER", HOVER.value);
	tv.setVar("HCLIENTCOD", oClClient.getCod());
	tv.setVar("HBILL_CL", getPar("bill_cl"));
}

function recalc_sum()
{
	HUSUM.value = 0;
	tSum = getSnap("SELECT SUM(r.fsum) AS fusum"
		+ " FROM ^rbill AS r"
		+ " WHERE FCLIENT = "+ extPar.fclient
		+ " AND FDOC = 'BU'");
	if(tSum)	
		HUSUM.value = tSum[0];

	HOSUM.value = 0;
	tSum = getSnap("SELECT SUM(r.fsum) AS fosum"
		+ " FROM ^rbill AS r"
		+ " WHERE FCLIENT = "+ extPar.fclient
		+ " AND FDOC = 'BO'");
	if(tSum)	
		HOSUM.value = tSum[0];
	
	HDEBT.value = Number(HUSUM.value) - Number(HOSUM.value);
	HOVER.value = 0;
	if(Number(HDEBT.value) < 0)
	{
		HOVER.value = Math.abs(HDEBT.value);
		HDEBT.value = 0;
	}	
}

include("sys/DpList.js")