include("Objects/DpNmkl.js");
include("Objects/DpCl.js");
include("servis/date.js");
include("sub/bil.js");

var sTblFrom = "RBILL";
var sTbl = "CONTRACT";
var oClClient;
var oClNmkl;
var codPlat;
var vidDog;
var client;
var mode;

function listLoad()
{
	sTblFrom = getRegTblName();
	if(!sTblFrom)
		return false;
	
	client = extPar.fclient;
	vidDog = extPar.fviddog;
	codPlat = getPar("bill_cl");
	if(vidDog==1)
		codPlat = getPar("biltel_cl");
			
	oClClient = new DpCl("0!", codPlat, 0);
	oClClient.linkCtrl(Fclient);
	oClClient.linkCtrl2("FTXT", tFclient);
	oClClient.setCod(client);
			
	HUSUM.mask = MASK_SUM;
	HOSUM.mask = MASK_SUM;
	HDEBT.mask = MASK_SUM;
	HOVER.mask = MASK_SUM;
	
	Disable(Fclient);
	Disable(HUSUM);
	Disable(HOSUM);
	Disable(HDEBT);	
	Disable(HOVER);	
	Disable(Frem);
	
	with( list )
	{
		title = ru("Карточка клиента: ", "Картка кліента: ");		
		
		subMenuInit = menuInit;
		subMenuRun = menuRun;
		subOnPrnList = onPrnList;
		printLabel = "BCARD";
		accDel = acceptDel;
	}
	recalc_sum();
	loadCond();	
	
	this.doEdit = doEdit;
	setButton(btnEdit, this, "doEdit");
	setFocus(btnEdit);	
}

function loadCond()
{
	curCond.setText(" ");	
	dogDate.setText(" ");
	
	var z = getSnap("select FSTATUS from ^"+ sTbl +" c "
			+" inner join ^BILDOG d on d.FID_DOG=c.FWID"
			+" where c.FORG="+ sqlTo(client)
				+" and d.FVID_DOG="+ sqlTo(vidDog));
	if(!z)
		return;
	
	var sText = ru("Подключен","Підключений");
	switch(Number(z[0]))
	{	
	case 1:
		sText = ru("Отключен по заявлению","Відключений по заяві");
		break;
	case 2:
		sText = ru("Отключен за неуплату","Відключений за несплату");
		break;
	case 3:
		sText = ru("Съехал","Виїхав");
		break;
	default:
		//sText = ru("Подключен","Підключений");
		var dogDat = new Date(extPar.dogdate);
		//if(month_difference(new Date(), dogDat)<=2)
		dogDate.setText(StrDat(dogDat, "DMY"));				
		break;
	}
	curCond.setText(sText);	
	//Frem.value = z[0];	
}

function doEdit()
{
	var oCl4Edit = new DpCl("0!", codPlat, oClClient.getCod());
	oCl4Edit.zaval();
}

function acceptDel()
{
	return false;
}

function listSrc()
{	
	with(list)
	{ 		
		qrySet("From", "^"+ sTblFrom +" r inner join ^BILDOG d on d.FID_DOG=r.FID_DOG"
			, "Where", "r.FCLIENT="+ client +" and d.FVID_DOG="+ sqlTo(vidDog)
			, "Order", "r.FID_DOG,r.FWID_CL,r.FNMKL,r.FDATE,"+ IIF("r.FDOC='BILL'", 0, 1));
	
		//subTie("CLRELCLCL", "CLREL", "CLCOD", "="+ codPlat +",Fclient");
		//subTie("CL", "x_cl", "CLREL.Fcod", "Fclient");
		//subTie(sTbl, "homo", "FWID_CL", "Fclient");		
		subTie("CL_NMK", "nmk", "FWID", "FNMKL");
		subTie("BIL_PACK", "pack", "FID_DOG", "FID_DOG");
		subTie("CL", "cl", "FWID", "pack.FWID_CL");
		subTie("CONTRACT", "dog", "FWID", "FID_DOG");
	}
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	with(new DpGrid("NOCREATE"))
	{	
		defCond("=^FDOC!='BILL'", "PAYMENT");
		color(1, "PAYMENT");
		
		with(page())
		{	
			cell("dog.Fdog_num", "Угода|Договор", 8);
			cell("cl.FTXT", "Пакет|Пакет", 10);
			cell("=^FNMKL!=0? ^nmk.FTXTS : ''", "Номенклатура|Номенклатура", 15);
			cell("Fdate", "Дата|Дата", 12);
			cell("Fsum", "Сума|Сумма", 10, "", DP_FORMAT_SUM);			
		}
		build();
	}
	grid.setFocus();
}

function menuInit()
{
	var ds = DataSource();
	var t = ds.getTable();
	if(!list.tbl.IsEmpty())
	{
		ds.AddMenuItem("CTRL-D", "Пошук документа|Поиск документа");
	}	
}

function menuRun(ID)
{
	var ds = DataSource();
	var t = ds.getTable();
	switch(ID)
	{
		case "CTRL-D":
			include("doc/DpDocPtn.js");
			var zzz = OpenTable("s", "SELECT * FROM ^hbill WHERE fwid = "+ sqlTo(t.getValue("fid_doc")));
			FindDocument(zzz.getValue("fdoc"), zzz.getValue("fnop"), t.getValue("fid_doc"));
			zzz.close();
			break;
		default:
			break;
	}
}

function onPrnList(tv)
{
	tv.setVar("HUSUM", HUSUM.value);
	tv.setVar("HOSUM", HOSUM.value);
	tv.setVar("HDEBT", HDEBT.value);
	tv.setVar("HOVER", HOVER.value);
}

function recalc_sum()
{
	HUSUM.value = 0;
	tSum = getSnap("SELECT SUM(r.fsum) AS fusum"
		+ " FROM ^"+ sTblFrom +" AS r"
			+" INNER JOIN ^BILDOG d on d.FID_DOG=r.FID_DOG"
		+ " WHERE r.FCLIENT = "+ client
			+ " AND r.FDOC = 'BILL'"
			+ " AND d.FVID_DOG="+ sqlTo(vidDog));
	if(tSum)	
		HUSUM.value = tSum[0];

	HOSUM.value = 0;
	tSum = getSnap("SELECT SUM(r.fsum) AS fosum"
		+ " FROM ^"+ sTblFrom +" AS r"
			+" INNER JOIN ^BILDOG d on d.FID_DOG=r.FID_DOG"
		+ " WHERE r.FCLIENT = "+ client
			+ " AND r.FDOC != 'BILL'"
			+ " AND d.FVID_DOG="+ sqlTo(vidDog));
	if(tSum)	
		HOSUM.value = tSum[0];
	
	HDEBT.value = Number(HUSUM.value) - Number(HOSUM.value);
	HOVER.value = 0;
	if(Number(HDEBT.value) < 0)
	{
		HOVER.value = Math.abs(HDEBT.value);
		HDEBT.value = 0;
	}	
}

include("sys/DpList.js")