include("gridedit.js");

function wizardInit()
{
	Caption("Побудова дiаграми|Построение диаграммы");
	document.WIZARD = this;
	
}

function wizardPageCreated()
{
	LEGEND.checked = true;
	TITLE.value = UR("Дiаграма|Диаграмма");
	var imagePieChart = lpProxy.getAppPlugLoc() + "icons/chart/pie.png";
	var imagePieChart3D = lpProxy.getAppPlugLoc() + "icons/chart/pie3d.png";
	var imageXYLineChart = lpProxy.getAppPlugLoc() + "icons/chart/xyline.png";
	var imageXYBarChart = lpProxy.getAppPlugLoc() + "icons/chart/xybar.png";
	var imageXYAreaChart = lpProxy.getAppPlugLoc() + "icons/chart/xyarea.png";
	var imageTimeSeriesChart = lpProxy.getAppPlugLoc() + "icons/chart/timeseries.png";
	var imageBarChart = lpProxy.getAppPlugLoc() + "icons/chart/bar.png";
	var imageBarChart3D = lpProxy.getAppPlugLoc() + "icons/chart/bar3d.png";
	var imageLineChart = lpProxy.getAppPlugLoc() + "icons/chart/line.png";
	var imageAreaChart = lpProxy.getAppPlugLoc() + "icons/chart/area.png";
	var imageStackedBarChart = lpProxy.getAppPlugLoc() + "icons/chart/stackedbar.png";
	var imageStackedBarChart3D = lpProxy.getAppPlugLoc() + "icons/chart/stackedbar3d.png";	
	var imageStackedAreaChart = lpProxy.getAppPlugLoc() + "icons/chart/stackedarea.png";
	
	btnPieChart.setImage(imagePieChart);
	btnPieChart.setData("TXT", UR("Кругова|Круговая"));
	btnPieChart.buttonHandler(onSelChart);
	
	btnPieChart3D.setImage(imagePieChart3D);
	btnPieChart3D.setData("TXT", UR("Кругова 3D|Круговая 3D"));
	btnPieChart3D.buttonHandler(onSelChart);
	
	btnXYLineChart.setImage(imageXYLineChart);
	btnXYLineChart.setData("TXT", UR("XY лiнiя|XY линия"));
	btnXYLineChart.buttonHandler(onSelChart);
	
	btnXYBarChart.setImage(imageXYBarChart);
	btnXYBarChart.setData("TXT", UR("Гістограма|XY гистограмма"));
	btnXYBarChart.buttonHandler(onSelChart);
	
	btnXYAreaChart.setImage(imageXYAreaChart);
	btnXYAreaChart.setData("TXT", UR("XY область"));
	btnXYAreaChart.buttonHandler(onSelChart);
	
	btnTimeSeriesChart.setImage(imageTimeSeriesChart);
	btnTimeSeriesChart.setData("TXT", UR("Часова|Временная"));
	btnTimeSeriesChart.buttonHandler(onSelChart);
	
	
	btnLineChart.setImage(imageLineChart);
	btnLineChart.setData("TXT", UR("Лiнiя|Линия"));
	btnLineChart.buttonHandler(onSelChart);
	
	btnBarChart.setImage(imageBarChart);
	btnBarChart.setData("TXT", UR("Гістограма|Гистограмма"));
	btnBarChart.buttonHandler(onSelChart);
	
	btnBarChart3D.setImage(imageBarChart3D);
	btnBarChart3D.setData("TXT", UR("Гістограма 3D|Гистограмма 3D"));
	btnBarChart3D.buttonHandler(onSelChart);
	
	btnAreaChart.setImage(imageAreaChart);
	btnAreaChart.setData("TXT", UR("Область"));
	btnAreaChart.buttonHandler(onSelChart);
	
	btnStackedBarChart.setImage(imageStackedBarChart);
	btnStackedBarChart.setData("TXT", UR("Гістограма накопичувальна |Гистограмма накопительная"));
	btnStackedBarChart.buttonHandler(onSelChart);
	
	btnStackedBarChart3D.setImage(imageStackedBarChart3D);
	btnStackedBarChart3D.setData("TXT", UR("Гістограма накопичувальна 3D|Гистограмма накопительная 3D"));
	btnStackedBarChart3D.buttonHandler(onSelChart);
	
	btnStackedAreaChart.setImage(imageStackedAreaChart);
	btnStackedAreaChart.setData("TXT", UR("Область накопичувальна|Область накопительная"));
	btnStackedAreaChart.buttonHandler(onSelChart);
	
	
	var columns = extPar.grid.getColumnsArray();
	
	var csi = seriesGrid.getColumn(0);
	var cci = categoryGrid.getColumn(0);
	var cvi = categoryGrid.getColumn(1);
	this.tblSeries = createObjectTable();
	this.tblSeries.setIdFld("yValue"); 
	this.tblCategory = createObjectTable();
	this.tblCategory.setIdFld("valueFld"); 
	//this.tblSeries.setIdFld("fvalue"); 
	
	keyFld.addItem("ROWNUM", UR("Номер рядка|Номер строки"));
	valueFld.addItem("ROWNUM",UR("Номер рядка|Номер строки"));
	xFld.addItem("ROWNUM", UR("Номер рядка|Номер строки"));
	
	xFld.value = valueFld.value = keyFld.value = "ROWNUM";	
	
	csi.addEditOption("ROWNUM", UR("Номер рядка|Номер строки"));
	cci.addEditOption("ROWNUM", UR("Номер рядка|Номер строки"));
	cvi.addEditOption("ROWNUM", UR("Номер рядка|Номер строки"));
	
	for (var i = 0; i < columns.length; i++)
	{
		var text = columns[i].getCaption();
		text = text.replaceAll("\n", " ");
		var group = columns[i].getGroup()
		if (group)
			text = group.getText().replaceAll("\n", " ") + " " + text;
		
		var field = columns[i].getField();
		keyFld.addItem(field, text);
		valueFld.addItem(field, text);
		xFld.addItem(field, text);
		
		csi.addEditOption(field, text);
		cci.addEditOption(field, text);
		cvi.addEditOption(field, text);
	}
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuHandler = gridMenuHandler;
	
	dpGridEdit = new DpGridEdit(seriesGrid);
	dpGridEdit.init = addSeriesRecord;	
	dpGridEdit.addValidField("yValue", beforeSetYValue, afterSetYValue);
	
	seriesGrid.setTable(this.tblSeries);
	seriesGrid._build();
	
	dpGridEdit = new DpGridEdit(categoryGrid);
	dpGridEdit.init = addCategoryRecord;
	dpGridEdit.addValidField("valueFld", beforeSetYValue, afterSetValueFld);
	
	
	categoryGrid.setTable(this.tblCategory);
	categoryGrid._build();
	
	
	chartTypePage.setDescription(UR("Оберiть тип дiаграми|Выберите тип диаграммы"));
	chartFinishPage.setDescription(UR("Вкажiть параметри вiдображення|Укажите параметры отображения"));
	
	btnPieChart.selected = true;
	onSelChart(btnPieChart);
	
	chartPiePage.setPreviousPage(chartTypePage);
	chartSeriesPage.setPreviousPage(chartTypePage);
	chartCategoryPage.setPreviousPage(chartTypePage);
	chartFinishPage.setPreviousPage(chartPiePage);
	
	seriesGrid.loadMenuHandler(this,"gridMenuInit");
	seriesGrid.selectMenuHandler(this,"gridMenuHandler");
	categoryGrid.loadMenuHandler(this,"gridMenuInit");
	categoryGrid.selectMenuHandler(this,"gridMenuHandler");
	
	//page2
}

function beforeSetYValue()
{
	
}

function afterSetYValue(oCtrl)
{
	if (WIZARD.tblSeries.getValue("name") == null || WIZARD.tblSeries.getValue("name") == "")
		WIZARD.tblSeries.setValue("name", oCtrl.getStringValue());
}

function afterSetValueFld(oCtrl)
{
	if (WIZARD.tblCategory.getValue("name") == null || WIZARD.tblCategory.getValue("name") == "")
		WIZARD.tblCategory.setValue("name", oCtrl.getStringValue());
}

function addSeriesRecord()
{
	this.initValue("yValue", "ROWNUM");
	this.initValue("name", "");
}

function addCategoryRecord()
{
	this.initValue("categFld", "ROWNUM");	
	this.initValue("valueFld", "ROWNUM");
	this.initValue("name", "");
}


function gridMenuInit(grid)
{
	if(IsDblClick(grid))
	{
		grid.runGridMenu("EDIT");
	}
}

function gridMenuHandler(ID, grid)
{
	if(ID == "DEL")
	{
		grid.getTable().Delete();
		grid.refresh();
	}
}



function wizardСanFlipToNextPage()
{
	return FORM.getCurrentPage().getName() != "chartFinishPage";
	
}

function wizardCanFinish()
{
	return FORM.getCurrentPage().getName() == "chartFinishPage";
}


function wizardGetNextPage(currentPage)
{
	if (String(currentPage.getName()) == String(chartTypePage.getName()))
	{
		if (!btnPieChart.selected && !btnPieChart3D.selected)
		{
			var isSer = btnXYLineChart.selected || btnXYBarChart.selected || btnXYAreaChart.selected || btnTimeSeriesChart.selected;
			return isSer?chartSeriesPage:chartCategoryPage;			
		}
		else
		{
			return chartPiePage;
		}
	}
	else if (String(currentPage.getName()) != String(chartFinishPage.getName()))
	{
		return chartFinishPage;
	}
	
}

function wizardGetPreviousPage(page)
{
	return chartTypePage;
}

function onSelChart(btn)
{
	btnPieChart.selected = btnPieChart.getData("ID") == btn.getData("ID");
	btnPieChart3D.selected = btnPieChart3D.getData("ID") == btn.getData("ID");
	btnXYLineChart.selected = btnXYLineChart.getData("ID") == btn.getData("ID");
	btnXYBarChart.selected = btnXYBarChart.getData("ID") == btn.getData("ID");
	btnXYAreaChart.selected = btnXYAreaChart.getData("ID") == btn.getData("ID");
	btnTimeSeriesChart.selected = btnTimeSeriesChart.getData("ID") == btn.getData("ID");
	btnLineChart.selected = btnLineChart.getData("ID") == btn.getData("ID");
	btnBarChart.selected = btnBarChart.getData("ID") == btn.getData("ID");
	btnBarChart3D.selected = btnBarChart3D.getData("ID") == btn.getData("ID");
	btnAreaChart.selected = btnAreaChart.getData("ID") == btn.getData("ID");
	btnStackedBarChart.selected = btnStackedBarChart.getData("ID") == btn.getData("ID");
	btnStackedBarChart3D.selected = btnStackedBarChart3D.getData("ID") == btn.getData("ID");
	btnStackedAreaChart.selected = btnStackedAreaChart.getData("ID") == btn.getData("ID");
	
	//chartPiePage.setVisible(false /*btnPieChart.selected || btnPieChart3D.selected*/);
	
	
	if (btn.getData("TXT"));
		chartTypeLbl.setText(btn.getData("TXT"));
}

function wizardPageChanged(ev)
{
	return;
	if (ev.getSelectedPage().getName() == "chartPiePage")
	{
		if (!btnPieChart.selected && !btnPieChart3D.selected)
		{
			chartPiePage.setVisible(false);
			var isSer = btnXYLineChart.selected || btnXYBarChart.selected || btnXYAreaChart.selected || btnTimeSeriesChart.selected;
			chartSeriesPage.setVisible(isSer);
			chartCategoryPage.setVisible(!isSer);
		}
	}
	else if(ev.getSelectedPage().getName() == "chartSeriesPage")
	{
		chartSeriesPage.setVisible(false);
		chartFinishPage.setVisible(true);
	}
	else
	{
		//alert(ev.getSelectedPage().getName())
	}
	
}

function onFinish()
{
	seriesGrid.onEndEditRow();
	categoryGrid.onEndEditRow();	 
	
	var par = new Object();
	par.tbl = extPar.grid.getTable();
	
	if (btnPieChart.selected)
		par.chartType = "PieChart"; 
	if (btnPieChart3D.selected)
		par.chartType = "PieChart3D";
	if (btnXYLineChart.selected)
		par.chartType = "XYLineChart";
	if (btnXYBarChart.selected)
		par.chartType = "XYBarChart";
	if (btnXYAreaChart.selected)
		par.chartType = "XYAreaChart";
	if (btnTimeSeriesChart.selected)
		par.chartType = "TimeSeriesChart";
	if (btnLineChart.selected)
		par.chartType = "LineChart";
	if (btnBarChart.selected)
		par.chartType = "BarChart";
	if (btnBarChart3D.selected)
		par.chartType = "BarChart3D";
	if (btnAreaChart.selected)
		par.chartType = "AreaChart";
	if (btnStackedBarChart.selected)
		par.chartType = "StackedBarChart";
	if (btnStackedBarChart3D.selected)
		par.chartType = "StackedBarChart3D";
	if (btnStackedAreaChart.selected)
		par.chartType = "StackedAreaChart";
	
	
	if (btnPieChart.selected ||  btnPieChart3D.selected)
	{
		par.keyFld = keyFld.value;  
		par.valueFld = valueFld.value;
	}
	else if (par.chartType == "TimeSeriesChart" || par.chartType.indexOf("XY") != -1)
	{
		par.xFld = xFld.value;
		par.series = new Array()
		this.tblSeries.moveFirst();
		while(!this.tblSeries.isEOF())
		{
			var oSer = new Object();
			oSer.name = String(this.tblSeries.getValue("name"));
			oSer.valueFld = String(this.tblSeries.getValue("yValue"));
			par.series[par.series.length] = oSer;
			this.tblSeries.moveNext();
		}			
	}
	else
	{
		par.series = new Array()
		this.tblCategory.moveFirst();
		while(!this.tblCategory.isEOF())
		{
			var oSer = new Object();
			oSer.name = String(this.tblCategory.getValue("name"));
			oSer.categoryFld = String(this.tblCategory.getValue("categFld"));
			oSer.valueFld = String(this.tblCategory.getValue("valueFld"));
			par.series[par.series.length] = oSer;			
			this.tblCategory.moveNext();
		}			
	}
	
	par.chartName = String(TITLE.value)
	par.legend = LEGEND.checked;
	par.horizontal = HORIZONTAL.checked;
	par.XAxisLabel = String(XTITLE.value);
	par.YAxisLabel = String(YTITLE.value);
	
	showWindow("chart.xml", SW_NOMODAL, par);
	return true;
}