

//проверка выполнялась ли архивация базы
function checkDump()
{
	try
	{
		include("servis/dump.js");
		var sDir = dumpDir();
		if(!isDir(sDir))
		{
			//при первом запуске проверку не выполняем
			createDirectory(sDir);
			return;
		}
		
		var host = getHostName();
		var comp = lpProxy.getOrgManager().getComp();
		var server = lpProxy.getOrgManager().getServer();	
		if(SUBD==ORACLE && comp!=host)
			return;
		if(SUBD==MSSQL && server!=host)
			return;
		if(SUBD==POSTGRE && comp!=host && comp!="localhost")
			return;
		if(SUBD==MYSQL)
		{ 
			var par = getPar("MYSQL_SERVER_PATH");
			if(!par && server!=host && server!="localhost")
				return;
		}
		
		trace("\n-------------------- checkDump --------------------");	
		var sBase = getPath("ALL_MDB");
		var sRegTbl = sBase +".DUMP_REG";
		if(SUBD==MSSQL)
			sRegTbl = sBase +"..DUMP_REG";
		var oSnap = getSnap("select FDATE,FLOGIN,FPASSWORD,FBASE,FPATH "
							+" from "+ sRegTbl 
							+" where FEXPORT="+ sqlTrue
							+" order by FDATE desc"
							, false
							);
		var sLogin = "DPADMIN";
		var sPassword = "";
		var sPath = dumpDir();		
		if(oSnap && oSnap[1])
		{
			if(oSnap[1])
				sLogin = oSnap[1];
			if(oSnap[2]!=null)
				sPassword = String(oSnap[2]).trim();
			if(oSnap[3])
				sBase = oSnap[3];
			if(oSnap[4])
				sPath = oSnap[4];
			var par = getPar("RUN_DUMP_ONCONNECT");
			if(par==true || par=="true")
			{
				var oExec = runDBExport(sLogin, sPassword, sBase, "", sPath);
				runInThread(readExec, oExec);
				return;
			}
		}
		
		if(!getPar("CHECK_DUMP"))
			return;

		var sMsg = UR("Архівація бази не виконувалась|Архивация базы не выполнялась");
		if(oSnap && oSnap[0])
		{
			include("servis/date.js");
			var date = new Date(oSnap[0]);
			var nDay = day_difference(date, new Date())-2;
			if(nDay>6)
				sMsg += " "+ nDay +" "+ UR("дн.|дн.");
			else
				return;
		}
		
		sMsg += UR("\nВиконати архівацію?|\nВыполнить архивацию?");
		var title = UR("Нагадування|Напоминание");		
		var checkTxt = UR("Відключити нагадування|Отключить напоминание");
		var oMsg = lpProxy.showMsgBox("yn", sMsg, title, checkTxt);		
		if(oMsg.isChecked())
		{
			setPar("CHECK_DUMP", false);
		}
		
		var res = oMsg.getResult();
		if(res=="y")
		{			
			if(oSnap && oSnap[1])
			{
				runDBExport(sLogin, sPassword, sBase, "", sPath);
			}
			else
			{
				var par = new Object();
				showWindow("dump.xml", SW_MODAL, par);
			}
		}
		trace("-------------------- checkDump --------------------\n");
	}
	catch(e)
	{
		trace("checkDump - "+ e);
	}
}

function readExec(oExec)
{	
	try
	{		
		oExec.waitFor();
		//CLEARWAIT();
		WAIT(UR("Архівацію виконано|Архивация выполнена"));
	}
	catch(e){}
}