
var sTblName = "TMP_CHEKNDS";

function listTitle()
{
	return ru("Контроль 20% НДС", "Контроль 20% ПДВ");
}

function listLoad()
{
	//this.xmlGridFile = "check_20NDS.xml";
		
	if(IsTable(sTblName))
		DropTable(sTblName);
		
	strSQL = " SELECT  "
				+" FSUM_20+FKSUM_20 AS FSUM, "
				+" A.FNDS+FKNDS AS FNDS, "
				+" (FSUM_20+FKSUM_20)/5  AS FKALKNDS,"
				+" (FSUM_20+FKSUM_20)/5 - (FNDS+FKNDS) AS FDIF,"
				+" FDOC_NUM,"
				+" FDOC_DAT,"
				+" FDOC,"
				+" FNOP,"
				+" FWID"
			+" INTO " + sTblName
			+" FROM ^" + extPar.hTbl +" AS  A "
			+" WHERE "
				+" ABS((FSUM_20+FKSUM_20)/5-(FNDS+FKNDS))>0.01 "
				+" AND A.FDOC_DAT BETWEEN " +sqlTo(extPar.bdat)
					+ " and " +sqlTo(extPar.edat) + " "
				+ sqlw0And("A.FNOP=",extPar.fnop)
				+ sqlw0And("A.FDOC=",extPar.fdoc)
			+" ORDER BY (FSUM_20+FKSUM_20)/5 - (FNDS+FKNDS) DESC";
	ExecuteSQL(strSQL);			
}

function listSrc()
{			
	this.qrySet("From", sTblName);		
}

function listDpGrid()
{
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
		with(prefix())
		{
			cell("Fdoc_num", "№ док.|№ док.", 8);
			cell("Fdoc_dat", "Дата|Дата", 12);
		}
		with(page())
		{
			cell("FSUM", "Сума|Сумма", 15, "", DP_FORMAT_SUM);
			cell("FNDS", "ПДВ|НДС", 8, "", DP_FORMAT_SUM)
			cell("FKALKNDS", "Сума/5|Сумма/5", 15, "", DP_FORMAT_SUM)
			cell("FDIF", "Різниця|Разница", 15, "", DP_FORMAT_SUM)
		}
		build();
	}
}

include("sys\\DpList.js")	