include("Objects/DpCl.js");

var obj = extPar.dpObj;
var oManager;

function onLoad()
{
	if(getSystem()!="BIL2")
		GRBILL.setVisible(false);
	
	Caption(ru("Контактные лица", "Контактні особи")
			+ ": " + modeName(extPar.mode));
	
	oManager = new DpCl("0");
   	oManager.setClcl(getPar("CODPERS"));
   	oManager.linkSmartCtrl(FMANAGER);
   	oManager.setContAssist();
	
	fillPost();
	
	if(!obj)
		return loadLeftCnt();
	
	obj.mode = extPar.mode;
		
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("HFIO",	FFIO);
	ctrlLinker.addLink("HPHONE",FPHONE);
	ctrlLinker.addLink("HEMAIL",FEMAIL);
	ctrlLinker.addLink("HTAXNUM",FTAXNUM);
	ctrlLinker.addLink("HSEX",	FSEX);
	ctrlLinker.addLink("HBIRTH",FBIRTH);
	ctrlLinker.addLink("HNOTE",	FNOTE);	
	ctrlLinker.addLink("HPOST",	FPOST);	
	ctrlLinker.addLink("HNOTIFY_DOCS",	CH_NOTIFY_DOCS);	
	ctrlLinker.addLink("HNOTIFY_DEBT",	CH_NOTIFY_DEBT);
	ctrlLinker.addLink("HNOTIFY_OTHER",	CH_NOTIFY_OTHER);
	ctrlLinker.addLink("HNOTIFY_OTHER_TXT",	FNOTIFY_OTHER);
	ctrlLinker.addLink("HNOTIFY_CARD", CH_NOTIFY_CARD);
	ctrlLinker.addLink("HNOTIFY_AKT", CH_NOTIFY_AKT);
	ctrlLinker.addLink("HNOTIFY_RECL", CH_NOTIFY_RECL);
	ctrlLinker.addLink("HNOTIFY_TECH", CH_NOTIFY_TECH);
	ctrlLinker.addClLink("HMANAGER", oManager);
	ctrlLinker.updateData(false); 
	
	setValid(CH_NOTIFY_OTHER, notify_other_valid);
	notify_other_valid();
	
	loadPost();
	if(extPar.mode == "ADD")
		FBIRTH.value = d00;		
}

function notify_other_valid()
{
	if(CH_NOTIFY_OTHER.checked)
		Enable(FNOTIFY_OTHER);
	else
		Disable(FNOTIFY_OTHER);
}

function onSave()
{
	if(extPar.tmpTblName)
		saveLeftCnt();
	if(!obj)
		return true;
	savePost();
	ctrlLinker.updateData(true);	
}

function fillPost()
{
	FPOST.addItem("0", UR("Директор|Директор"));
	FPOST.addItem("1", UR("Головний бухгалтер|Главный бухгалтер"));
	FPOST.addItem("2", UR("Касир|Кассир"));
}

function loadPost()
{	
	if(extPar.mode!="ADD")
	{
		if(Number(extPar.objCl.getVar("HBOSS")) == Number(obj.getID()))
		{
			FPOST.setSelectedIndex("0");
			//extPar.objCl.setVar("HBOSS", 0);
		}
		if(Number(extPar.objCl.getVar("HACCOUNTANT")) == Number(obj.getID()))
		{
			FPOST.setSelectedIndex("1");
			//extPar.objCl.setVar("HACCOUNTANT", 0);	
		}
		if(Number(extPar.objCl.getVar("HCAS")) == Number(obj.getID()))
		{
			FPOST.setSelectedIndex("2");	
			//extPar.objCl.setVar("HCAS", 0);
		}
	}
}

function savePost()
{
	var post = FPOST.getCtrl().getSelectionIndex();
	switch(String(post))
	{
		case "0":
			extPar.objCl.setVar("HBOSS", obj.getID());
			break;
			
		case "1":
			extPar.objCl.setVar("HACCOUNTANT", obj.getID());
			break;
						
		case "2":
			extPar.objCl.setVar("HCAS", obj.getID());
			break;
	}
	obj.setVar("HPOST", FPOST.value);	
}

//левый контакт из списка контактов
function loadLeftCnt()
{
	var tbl = extPar.tbl;
	if(!tbl)
		return false;
	
	if(extPar.mode!="ADD")
	{
		FFIO.value = tbl.getValue("FFIO");
		FPHONE.value = tbl.getValue("FPHONE");
		FEMAIL.value = tbl.getValue("FEMAIL");
		FTAXNUM.value = tbl.getValue("FTAXNUM");
		FSEX.value = tbl.getValue("FSEX");
		FBIRTH.value = tbl.getValue("FBIRTH");
		FNOTE.value = tbl.getValue("FNOTE");
		FPOST.value = tbl.getValue("FPOST");
		oManager.setCod(tbl.getValue("FMANAGER"));
		CH_NOTIFY_DOCS.value = tbl.getValue("FNOTIFY_DOCS");
		CH_NOTIFY_DEBT.value = tbl.getValue("FNOTIFY_DEBT");
		CH_NOTIFY_OTHER.value = tbl.getValue("FNOTIFY_OTHER");
		FNOTIFY_OTHER.value = tbl.getValue("FNOTIFY_OTHER_TXT");
	}
	setValid(CH_NOTIFY_OTHER, notify_other_valid);
	notify_other_valid();
		
	return true;
}

function saveLeftCnt()
{
	var tbl = extPar.tbl;
	if(!tbl)
		return false;
	
	var m = new Object();
	if(extPar.mode=="ADD" || extPar.mode=="COPY")
		m.FWID = GetUID();
	
	m.FFIO = FFIO.value;
	m.FPHONE = FPHONE.value;
	m.FEMAIL = FEMAIL.value;
	m.FTAXNUM = FTAXNUM.value;
	m.FSEX = FSEX.value;
	m.FBIRTH = FBIRTH.value;
	m.FNOTE = FNOTE.value;
	m.FPOST = FPOST.value;
	m.FNOTIFY_DOCS = CH_NOTIFY_DOCS.value;
	m.FNOTIFY_DEBT = CH_NOTIFY_DEBT.value;
	m.FNOTIFY_OTHER = CH_NOTIFY_OTHER.value;
	m.FNOTIFY_OTHER_TXT = FNOTIFY_OTHER.value;
	m.FMANAGER = oManager.getCod();	
	m.FWID_CL = 0;
	
	if(!obj)
		UpdateTable("^CL_ORGCP", m, extPar.mode!="EDIT");
	if(extPar.tmpTblName)
	{
		m.FMANAGER_TXT = oManager.getTxt();
		UpdateTable(extPar.tmpTblName, m, extPar.mode!="EDIT");
	}
		
	return true;
}

include("sys/DpBaseDlg.js");