include("objects/dpcl.js")
include("doc/DpDoc.js")
include("servis/date.js");
include("sys/udfs.js");
include("Objects/DpSbcs.js");
include("decodeinn.js");

var objCl = extPar.dpObj; 
var ctrlLinker = null;
var arrTempTbl = new Array();
var oCitizen, oCountry;
var strTempTableName;
var tblName;
var oPodr, codPodr;
var oSempol, codSempol;
var oVidInvalid, codVidInv;
var oVidPens, codVidPens;
var oDisMotive, codDisMotive;
var oVoenZv, codVoenZv;
var oMilGroup, codMilGroup;
var oRegion;
var oArea;
var oCity;
var dpSbcs;
var nootch=false;

function Load()
{
//showObject();
//CDR_TABFOLDER.items[0].control.children[0].tabList[6].setVisible(true);

	Caption(objCl.getCaption() + ": " + modeName(extPar.mode));
	ctrlLinker = new DpCtrlLinker(objCl);

//	HFIRM.value = getPar("OFIRM");
//	Disable(HFIRM);

	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof CDR_ORG_CL_PERS_PODR_CL != "undefined")
		codPodr = getPar(CDR_ORG_CL_PERS_PODR_CL);
	else
		codPodr = getPar("CDRPODR");
	oPodr = new DpCl("0", codPodr, 0);
	oPodr.linkCtrl(HPODR, HTPODR);
	if(!codPodr)
	{
		Disable(HPODR);
		Disable(HTPODR);
	}

	oCitizen = new DpCl("0", getPar("CODCOUNTRY"), 0);
	oCitizen.linkCtrl(HCITIZEN, HCITIZENTXT);
	
	oCountry = new DpCl("0", getPar("CODCOUNTRY"), 0);
	oCountry.linkCtrl(HCOUNTRY, HCOUNTRYTXT);

	if(!getPar("CODCOUNTRY"))
	{
		Disable(HCITIZEN);
		Disable(HCOUNTRY);
	}

	oRegion = new DpCl("U0", getPar("CODREGION"), 0, oCountry);
	oRegion.linkCtrl(HREGION, HTREGION);

	oArea = new DpCl("U0", getPar("CODAREA"), 0, oRegion);
	oArea.linkCtrl(HAREA, HTAREA);

	oCity = new DpCl("U0", getPar("CODLOCATE"), 0, oArea);
	oCity.linkCtrl(HCITY, HTCITY);
	

	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_SEMPOL != "undefined")
		codSempol = getPar(const_GETPAR_SEMPOL);
	else
		codSempol = getPar("CDRFAMSTAT");
	oSempol = new DpCl("0", codSempol, 0);
	oSempol.linkCtrl(HSEMPOL, HTSEMPOL);
	if(!codSempol)
	{
		Disable(HSEMPOL);
		Disable(HTSEMPOL);
	}

	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VIDINVALID != "undefined")
		codVidInv = getPar(const_GETPAR_VIDINVALID);
	else
		codVidInv = getPar("CDRINVTYPE");
	oVidInvalid = new DpCl("0", codVidInv, 0);
	oVidInvalid.linkCtrl(HINVALTYPE, HTINVALTYPE);
	if(!codVidInv)
	{
		Disable(HINVALTYPE);
		Disable(HTINVALTYPE);
	}

	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VIDPENS != "undefined")
		codVidPens = getPar(const_GETPAR_VIDPENS);
	else
		codVidPens = getPar("CDRPENSTYPE");
	oVidPens = new DpCl("0", codVidPens, 0);
	oVidPens.linkCtrl(HPENSTYPE, HTPENSTYPE);
	if(!codVidPens)
	{
		Disable(HPENSTYPE);
		Disable(HTPENSTYPE);
	}

	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_DISMOTIVE != "undefined")
		codDisMotive = getPar(const_GETPAR_DISMOTIVE);
	else
		codDisMotive = getPar("CDRSTATUV");
	oDisMotive = new DpCl("0", codDisMotive, 0);
	oDisMotive.linkCtrl(HDIS_STAT, HTDIS_STAT);
	if(!codDisMotive)
	{
		Disable(HDIS_STAT);
		Disable(HTDIS_STAT);
	}

	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VOENZV != "undefined")
		codVoenZv = getPar(const_GETPAR_VOENZV);
	else
		codVoenZv = getPar("CDRZVAN");
	oVoenZv = new DpCl("0", codVoenZv, 0);
	oVoenZv.linkCtrl(HMILRANG, HTMILRANG);
	if(!codVoenZv)
	{
		Disable(HMILRANG);
		Disable(HTMILRANG);
	}
	ctrlLinker.addClLink("HMILCODRANG",oVoenZv);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VOENSKLAD != "undefined")
		codMilGroup = getPar(const_GETPAR_VOENSKLAD);
	else
		codMilGroup = getPar("CDRSOST");
	oMilGroup = new DpCl("0", codMilGroup, 0);
	oMilGroup.linkCtrl(HMILGROUP, HMILGROUPTXT);	
	ctrlLinker.addClLink("HMILCODGROUP",oMilGroup);

	dpSbcs = new DpSbcs("0");
	dpSbcs.linkCtrl(FNUM_BNK, FTXT_BNK, FRAS_SCH, FMFO);
	if(extPar.mode != "ADD")
		dpSbcs.setCod(objCl.getVar("HNUM_BNK"));
	
//	ctrlLinker.addLink("HSURNAME", HSURNAME);
//	ctrlLinker.addLink("HFIRSTNAME", HFIRSTNAME);
//	ctrlLinker.addLink("HSECONDNAME", HSECONDNAME);
	ctrlLinker.addClLink("HPODR", oPodr);
	ctrlLinker.addLink("HCOD", HCOD);
	ctrlLinker.addLink("HTABN", HTABN);
	ctrlLinker.addLink("HADDR", HADDR);
	ctrlLinker.addLink("HBLD", HBLD);
	ctrlLinker.addLink("HLETTER", HLETTER);
	ctrlLinker.addLink("HCORP", HCORP);
	ctrlLinker.addLink("HAPART", HAPART);
	ctrlLinker.addLink("HZIP", HZIP);
	ctrlLinker.addLink("HWRKPHONE", HWRKPHONE);
	ctrlLinker.addLink("HPHONE", HPHONE);
	ctrlLinker.addLink("HMPHONE", HMPHONE);
	ctrlLinker.addLink("HDOCDAT", HDOCDAT);
	ctrlLinker.addLink("HDOCSER", HDOCSER);
	ctrlLinker.addLink("HDOCNOM", HDOCNOM);
	ctrlLinker.addLink("HDOCOWN", HDOCOWN);
	ctrlLinker.addLink("HINDNUM", HINDNUM);
	ctrlLinker.addLink("HORIGADDR", HORIGADDR);
	ctrlLinker.addLink("HORIGDAT", HORIGDAT);
	ctrlLinker.addLink("HSEX", HSEX);
	ctrlLinker.addLink("HSERTINS_SER", HSERTINS_SER);
	ctrlLinker.addLink("HSERTINS_NUM", HSERTINS_NUM);
	ctrlLinker.addLink("HNUM_DOC", HNUM_DOC);
	ctrlLinker.addLink("HALPHABET", HALPHABET);
	ctrlLinker.addLink("HPFILE_NUM", HPFILE_NUM);
	ctrlLinker.addLink("HADD_INF", HADD_INF);
	ctrlLinker.addLink("HDIS_MOT", HDIS_MOT);
	ctrlLinker.addClLink("HDIS_STAT", oDisMotive);
	ctrlLinker.addLink("HDIS_DAT", HDIS_DAT);
	ctrlLinker.addLink("HWRKDAT", HWRKDAT);
	ctrlLinker.addLink("HWRB_DAT", HWRB_DAT);
	ctrlLinker.addLink("HDAT_FULL", HDAT_FULL);
	ctrlLinker.addLink("HVISLDAT", HVISLDAT);
	ctrlLinker.addLink("HGRREGIS", HGRREGIS);
	ctrlLinker.addLink("HCATREGIS", HCATREGIS);
	ctrlLinker.addLink("HMILREGSPEC", HMILREGSPEC);
	ctrlLinker.addLink("HMILSERV", HMILSERV);
	ctrlLinker.addLink("HNAMEMILDEP", HNAMEMILDEP);
	ctrlLinker.addLink("HSPECREGIS", HSPECREGIS);
	ctrlLinker.addClLink("HCITIZEN", oCitizen);
	ctrlLinker.addClLink("HCOUNTRY", oCountry);
	ctrlLinker.addClLink("HSEMPOL", oSempol);
	ctrlLinker.addLink("HREGADDR", HREGADDR);
	ctrlLinker.addLink("HJOBTYPE", HJOBTYPE);
	ctrlLinker.addLink("HPROFPOD", HPROFPOD);
	ctrlLinker.addClLink("HINVALTYPE", oVidInvalid);
	ctrlLinker.addClLink("HPENSTYPE", oVidPens);
	ctrlLinker.addClLink("HREGION", oRegion);
	ctrlLinker.addClLink("HAREA", oArea);
	ctrlLinker.addClLink("HCITY", oCity);

	ctrlLinker.addLink("HOSDAT", HOSDAT);
	ctrlLinker.addLink("HOSYEAR", HOSYEAR);
	ctrlLinker.addLink("HOSMONTH", HOSMONTH);
	ctrlLinker.addLink("HOSDAY", HOSDAY);
	ctrlLinker.addLink("HNSDAT", HNSDAT);
	ctrlLinker.addLink("HNSYEAR", HNSYEAR);
	ctrlLinker.addLink("HNSMONTH", HNSMONTH);
	ctrlLinker.addLink("HNSDAY", HNSDAY);

	ctrlLinker.addLink("HINVAL", HINVAL);
	ctrlLinker.addLink("HBDATINVAL", HBDATINVAL);
	ctrlLinker.addLink("HEDATINVAL", HEDATINVAL);
	ctrlLinker.addLink("HPENS", HPENS);
	ctrlLinker.addLink("HBDATPENS", HBDATPENS);
	ctrlLinker.addLink("HREM", FREM);
	ctrlLinker.addLink("HOLDSURNAME", HOLDSURNAME);
	ctrlLinker.addLink("HSCHET_BNK", FSCHET_BNK);
	ctrlLinker.addLink("HCODFILIAL", FCODFILIAL);
	
	grEduc.setViewerID("e_prfile.js.educ");
	grFamily.setViewerID("e_prfile.js.family");
	grLWork.setViewerID("e_prfile.js.lwork");
	grCourses.setViewerID("e_prfile.js.courses");
	grInOut.setViewerID("e_prfile.js.inout");
	grLeave.setViewerID("e_prfile.js.leave");
	grOldshtat.setViewerID("e_prfile.js.oldshtat");
	grCert.setViewerID("e_prfile.js.cert");
	grDiscipl.setViewerID("e_prfile.js.discipl");

	HCOD.mask = "###########";
	if(extPar.sMode=="EDIT")
		HCOD.setEnabled(false);
	setValid(HCOD,HCOD_valid);
	setValid(HINVAL,HINVAL_valid);
	setValid(HPENS,HPENS_valid);
	setValid(HBDATINVAL,HBDATINVAL_valid);
	setValid(HEDATINVAL,HEDATINVAL_valid);
	setValid(HBDATPENS,HBDATPENS_valid);
	setValid(HTABN, HTABN_valid);
	setValid(FISPARSEIND, FISPARSEIND_valid);
	
	HTABN.mask = "##########";
	HINDNUM.mask = "&&&&&&&&&&";
	HSERTINS_SER.mask = "&&&&&&&&&";
	HSERTINS_NUM.mask = "&&&&&&&&&&";
	HNUM_DOC.mask = "&&&&&&&&&&";
	HALPHABET.mask = "&&&";
	HPFILE_NUM.mask = "&&&&&&&&&&";
	HWRKPHONE.mask = "&&&&&&&&&&&&&&&";
	HPHONE.mask = "&&&&&&&&&&&&&&&";
	HMPHONE.mask = "&&&&&&&&&&&&&&&";
	HBLD.mask = "###";
	HAPART.mask = "####";
	HCORP.mask = "##";
	HDIS_MOT.mask = strRepl("&", 255);
	HDIS_STAT.mask = "######";
	HGRREGIS.mask = strRepl("&", 255);
	HCATREGIS.mask = strRepl("&", 255);
	HMILREGSPEC.mask = strRepl("&", 255);
	HNAMEMILDEP.mask = strRepl("&", 255);
	HSPECREGIS.mask = strRepl("&", 255);
	
	HOSYEAR.mask = "##";
	HOSMONTH.mask = "##";
	HOSDAY.mask = "##";
	HNSYEAR.mask = "##";
	HNSMONTH.mask = "##";
	HNSDAY.mask = "##";
	FSCHET_BNK.mask = strRepl("&",20);
   	FCODFILIAL.mask = "#####";
	setValid(HOSDAT,HOSDAT_valid);
	setValid(HNSDAT,HNSDAT_valid);
	
//переделал на JDebet/scripts/enums/jobtype.xml
//	for (var i=1; i<CDR_JOBTYPE.length; i++)
//	{
//		HJOBTYPE.addItem(i, CDR_JOBTYPE[i]);
//	}

//переделал на JDebet/scripts/enums/profpod.xml
//	for (var i=0; i<CDR_PROFPOD.length; i++)
//	{
//		HPROFPOD.addItem(i, CDR_PROFPOD[i]);
//	}

	if (extPar.mode == "ADD")
	{
//дефолты проставлены в enums
//		HJOBTYPE.value = CDR_JOBTYPE_OSN;
//		HPROFPOD.value = CDR_PROFPOD_NO;
		HPENS.checked = false;
		HINVAL.checked = false;
		objCl.setVar("HORIGDAT", d00);
		objCl.setVar("HVISLDAT", d00);
		objCl.setVar("HDOCDAT", d00);
		objCl.setVar("HPENSDATE", d00);
		objCl.setVar("HINVALDATE", d00);
		objCl.setVar("HDAT_FULL", d00);
		objCl.setVar("HWRKDAT", d00);
		objCl.setVar("HDIS_DAT", d00);
		objCl.setVar("HWRB_DAT", d00);
		objCl.setVar("HOSDAT", d00);
		objCl.setVar("HNSDAT", d00);
	}
	else
	{
		HPENS.checked = toScrObj(objCl.getVar("HPENS"));
		HINVAL.checked = toScrObj(objCl.getVar("HINVAL"));
	}

	if(objCl.getVar("HSEX"))
		HSEX.value = 1;
	else
		HSEX.value = 0;
	
	setButton(sltImage, setImage);
	ctrlLinker.updateData(false);
	
	var codUkr = 0;
	if(objCl.getVar("HCOUNTRY")==0 || objCl.getVar("HCITIZEN")==0)
	{
		var snap = getSnap("select Fcod from ^listcl where Fcl="+getPar("CODCOUNTRY")+" and LOWER(Ftxt) like '%укра%'");
		if(snap)
			codUkr = snap[0];
	}
	if(objCl.getVar("HCOUNTRY")==0)
		oCountry.setCod(codUkr);
	else
		oCountry.setCod(objCl.getVar("HCOUNTRY"));
	if(objCl.getVar("HCITIZEN")==0)
		oCitizen.setCod(codUkr);
	else
		oCitizen.setCod(objCl.getVar("HCITIZEN"));
	oRegion.validCtrl();
	oArea.validCtrl();
	oCity.validCtrl();
	
	//добавил в модуль CDRP параметр по которому можно вести табельный номер отдельно от кода записи, по умолчанию true
	if(!getPar("CDRDBLTABN"))
		Disable(HTABN);
	if(HTABN.value == 0)
		HTABN.value = HCOD.value

	HOSDAT_valid();
	HNSDAT_valid();
		
	//если документ ещё не сохранялся до этого, то ФИО вытягиваем из таблицы
	if (extPar.mode != "ADD")
	{
		if(HSURNAME.value=="")
		{
			var FIO = new Array();
			if(extPar && extPar.tbl)
			{
				//06,08,12. Яна.Добавила из-за иностранца без отчества, но не могу проверить, не знаю, когда вызывается эта ветка
				var snap = getSnap("select Fisotch from ^listcl3 where Fcl="+getPar("CODPERS")+" and Fcod="+HCOD.value)
				if(snap){
					FIO = getFioArr(extPar.tbl.getValue("Ftxt"),false);					
				}else{
					FIO = getFioArr(extPar.tbl.getValue("Ftxt"),snap[0]);
				}
				HSURNAME.value = FIO[0];
				HFIRSTNAME.value = FIO[1];
				HSECONDNAME.value = FIO[2];
			}
			else
			{
				if(Number(HCOD.value)>0)
				{
					var snap = getSnap("select Ftxt,Fisotch from ^listcl3 where Fcl="+getPar("CODPERS")+" and Fcod="+HCOD.value)
					if(snap)
					{
						FIO = getFioArr(snap[0],snap[1]);
						HSURNAME.value = FIO[0];
						HFIRSTNAME.value = FIO[1];
						HSECONDNAME.value = FIO[2];
					}
				}
			}
		}
	}
	
   	this.sDocSourceDir = rootDirectory() + "cls/CL3/";
	this.initGrid = initGrid;
	this.initGrid(grEduc, "grEduc.xml", "education", "FEDAT");
	this.initGrid(grFamily, "grFamily.xml", "familyties", "FID_TLINK");
	this.initGrid(grLWork, "grLWork.xml", "lastjob", "FBDAT, FEDAT");
	this.initGrid(grCourses, "grCourses.xml", "courses", "FPROT_DAT");
	this.initGrid(grInOut, "grInOut.xml", "full_pers", "FBDAT");
	this.initGrid(grLeave, "grLeave.xml", "prk_otp");
	//если нет модуля CDRP, то грид штатного не инициализируем
	if(typeof const_URNAME_PODRTYPE == "undefined")
		this.initGrid(grOldshtat, "grOldshtat.xml", "oldshtat", "FBDAT");
	this.initGrid(grCert, "grCert.xml", "certification", "FBDAT");
	this.initGrid(grDiscipl, "grDiscipl.xml", "discipl", "FBDAT");

	var strFoto = objCl.getVar("HFOTO");
	if("" == strFoto)
		img.setFileName(rootDirectoryEx() + "icons/foto.gif");
	else
	{
		var path = lpProxy.getOrgPath() + "data/foto/" + strFoto;
		img.setFileName(path);
	}
	
	this.listMenuInit = listMenuInit;
	this.listMenuHandler = listMenuHandler;
	setValid(HMILSERV,HMILSERV_Valid);
	HMILSERV_Valid();
	HINVAL_valid();
	HPENS_valid();
	if(extPar.sMode=="EDIT")
	{
		checkInval();
		checkPens();
	}
	else
	{
		//если есть параметр, то инициализируем код при добавлении значением по умолчанию
		if(extPar.defCod)
		{
			var snap = getSnap("select Fwid_cl from ^clrelclcl where Fcl="+extPar.Fcl+" and Fcod="+extPar.defCod);
			if(!snap)
				HCOD.value = extPar.defCod;
		}
	}
	setValid(HSURNAME,surnameValid);
	setValid(HFIRSTNAME,firstnameValid);
	setValid(HSECONDNAME,secondnameValid);
	//вкладку штатного расписания из модуля CDRP уничтожаем при отсутствии модуля
	if(typeof const_URNAME_PODRTYPE == "undefined")
		TI_SHTRASP_CDR.dispose();
}

function surnameValid()
{
	//с помощью ф-и reTrans() сразу заменяем взаимообратимые латынские символы на кириллические
	HSURNAME.value = reTrans(String(HSURNAME.value));
	var ind = indexOfLatin(HSURNAME.value);
	if(ind != -1)
	{
		alert(ru("В фамилии присутствуют не кириллические символы ("+(ind+1)+"-й символ)!",
				"У прізвища присутні не кириличні символи ("+(ind+1)+"-й символ)!"));
		return false;
	}
	return true;
}

function firstnameValid()
{
	//с помощью ф-и reTrans() сразу заменяем взаимообратимые латынские символы на кириллические
	HFIRSTNAME.value = reTrans(String(HFIRSTNAME.value));
	var ind = indexOfLatin(HFIRSTNAME.value);
	if(ind != -1)
	{
		alert(ru("В имени присутствуют не кириллические символы ("+(ind+1)+"-й символ)!",
				"В імені присутні не кириличні символи ("+(ind+1)+"-й символ)!"));
		return false;
	}
	return true;
}

function secondnameValid()
{
	//с помощью ф-и reTrans() сразу заменяем взаимообратимые латынские символы на кириллические
	HSECONDNAME.value = reTrans(String(HSECONDNAME.value));
	var ind = indexOfLatin(HSECONDNAME.value);
	if(ind != -1)
	{
		alert(ru("В отчестве присутствуют не кириллические символы ("+(ind+1)+"-й символ)!",
				"У батькові присутні не кириличні символи ("+(ind+1)+"-й символ)!"));
		return false;
	}
	if (allt(HSECONDNAME.value)==""){
		nootch=true;
	}	
	return true;
}

function HCOD_valid()
{
	if(!getPar("CDRDBLTABN") && extPar.mode=="ADD")
		HTABN.value = HCOD.value;
	strSQL = "SELECT a.* FROM ^CL a"
		+" INNER JOIN ^CLRELCLCL b ON a.FWID=b.FWID_CL"
		+" WHERE b.FCOD=" + HCOD.getValue() + " AND b.FCL=" + objCl.getVar("HCL")
		+" and a.fwid <> "+ objCl.getID();
	ts = getSnap(strSQL);
	if(ts!=null)
	{		
		setFocus(HCOD);
		WAIT(ru("Запись с таким кодом уже существует.", "Запис з таким кодом вже існує."));
		return false;
	}
	return true;
}

function HTABN_valid()
{
	strSQL = " SELECT b.FWID_CL, b.FCOD, CL.FTXT "
			+" FROM ^CLRELCLCL b "
				+" INNER JOIN ^CL CL ON b.FWID_CL = CL.FWID "
				+" INNER JOIN ^CDR_CL_PERS PERS ON b.FWID_CL = PERS.FWID_CL "
			+" WHERE 1 = 1 "
				+" AND PERS.FTABN = " + HTABN.getValue()
				+" AND PERS.FPODR = " + oPodr.getCod()
				+" AND b.FCL=" + objCl.getVar("HCL")
				+" AND b.FWID_CL <> "+ objCl.getID();
	ts = getSnap(strSQL);

	if(ts!=null)
	{		
		setFocus(HTABN);
		WAIT(" .   "+tcl('CL', 'TXT', codPodr, oPodr.getCod())+"    " + ts[2]);
		return false;
	}
	return true;
}

//просто расчитываем разницу между установленной датой и текущей и выводим в контролы 
//не обращая внимания на записи в гриде
function HOSDAT_valid()
{
	var d = new Date(HOSDAT.getValue());
	if(differ(d,d00obj)==0)
	{
		HOSYEAR.value = 0;
		HOSMONTH.value = 0;
		HOSDAY.value = 0;
		return true;
	}
	if(differ(d,today)>0)
	{
		alert(ru("Дата не может быть больше текущей","Дата не може бути більше поточної"));
		return false;
	}
	var dayDif = day_difference(d,today);
	HOSYEAR.value = Math.floor(dayDif/365);
	dayDif = dayDif%365;
	HOSMONTH.value = Math.floor(dayDif/30);
	dd = d.getDate();
	td = today.getDate();
	HOSDAY.value = (td>=dd?td-dd:td+lastDayMonth(d).getDate()-dd);
	return true;
}

function HNSDAT_valid()
{
	var d = new Date(HNSDAT.getValue());
	if(differ(d,d00obj)==0)
	{
		HNSYEAR.value = 0;
		HNSMONTH.value = 0;
		HNSDAY.value = 0;
		return true;
	}
	if(differ(d,today)>0)
	{
		alert(ru("Дата не может быть больше текущей","Дата не може бути більше поточної"));
		return false;
	}
	var dayDif = day_difference(d,today);
	HNSYEAR.value = Math.floor(dayDif/365);
	dayDif = dayDif%365;
	HNSMONTH.value = Math.floor(dayDif/30);
	dd = d.getDate();
	td = today.getDate();
	HNSDAY.value = (td>=dd?td-dd:td+lastDayMonth(d).getDate()-dd);
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);	
	objCl.setVar("HTXT", HSURNAME.value + " " + HFIRSTNAME.value + " " + HSECONDNAME.value);
	var firstName = String(HFIRSTNAME.value);
	firstName = (firstName.length>0)?firstName[0]:"";
	var secondName = String(HSECONDNAME.value);
	secondName = (secondName.length>0)?secondName[0]:"";
	//06.08.12
	objCl.setVar("HISOTCH", nootch);	
	objCl.setVar("HTXTS", HSURNAME.value + " " 
						+ ((firstName.length!=0)?(firstName + ". " 
							+ ((secondName.length!=0)?(secondName + "."):"")):""));
	var strFoto = new DpFile(img.getFileName()).getCanonicalPath();

	if(-1 == strFoto.indexOf("foto.gif"))
	{
		var lstInd = strFoto.lastIndexOf("\\");
		if(lstInd==-1)
			lstInd = strFoto.lastIndexOf("/");
		strFoto = strFoto.substr(lstInd + 1);
		objCl.setVar("HFOTO", strFoto);
	}
	
   	//objCl.setVar("HCITIZEN", oCountry.getCod());
   	objCl.setVar("HNUM_BNK", dpSbcs.getCod());
   	objCl.setVar("HPENS", HPENS.checked);
	objCl.setVar("HINVAL", HINVAL.checked);
	if (differ(objCl.getVar("HDIS_DAT"),d00obj)!=0)
	{
		if(SUBD==MYSQL)
		{
			var fld = new Object();
			fld.FWID_CL = "LONG";
			fld.FBDAT = "DATE";
			fld.FEDAT = "DATE";
			CreateTable("tmp_work_pers", fld);
			ExecuteSQL("insert into tmp_work_pers (Fwid_cl, Fbdat, Fedat) "
						+" select Fwid_cl, Fbdat, Fedat from ^work_pers where Fwid_cl="+objCl.getID());	
			strSQL = "UPDATE ^WORK_PERS SET FEDAT = " + sqlTo(objCl.getVar("HDIS_DAT"))
					+", FIS_UV = "+SqlTrue
					+" WHERE FWID_CL = "+sqlTo(objCl.getID())
					+" AND FEDAT IN (SELECT MAX(FEDAT) FROM tmp_work_pers "
						+" WHERE FBDAT<="+sqlTo(objCl.getVar("HDIS_DAT"))
						+")"
			ExecuteSQL(strSQL);
		}
		else
		{
			strSQL = "UPDATE ^WORK_PERS SET FEDAT = " + sqlTo(objCl.getVar("HDIS_DAT"))
					+", FIS_UV = "+SqlTrue
					+" WHERE FWID_CL = "+sqlTo(objCl.getID())
					+" AND FEDAT IN (SELECT MAX(FEDAT) FROM ^WORK_PERS "
						+" WHERE FBDAT<="+sqlTo(objCl.getVar("HDIS_DAT"))
						+" AND FWID_CL = "+sqlTo(objCl.getID())
						+")"
			ExecuteSQL(strSQL);
		}
	}
	//если есть параметры мести перечислений и место по умолчанию, тогда при сохранении добавляем его
	if(extPar.mode=="ADD" && objCl.getVar("HCL")==getPar("CODPERS") && getPar("COD_CAS_TRTYPE") && getPar("CAS_TRPLACE"))
		addTrPlace(objCl.getVar("HCOD"),objCl.getVar("HTXT"),getPar("COD_CAS_TRTYPE"),getPar("TRSBERCAS"));

	storeBufToBase("education");
	storeBufToBase("familyties");
	storeBufToBase("lastjob");
	storeBufToBase("courses");
//	storeBufToBase("leave");
	//если нет модуля CDRP, то штатное расписание не сохраняем
	if(typeof const_URNAME_PODRTYPE == "undefined")
		storeBufToBase("oldshtat");
	storeBufToBase("certification");
	storeBufToBase("discipl");
}

function setImage()
{
	var strPath = lpProxy.openFile(new Array("All Files", "BMP Files", "GIF Files", "JPEG Files")
									, new Array("*.bmp;*.jpg;*.jpeg;*.gif", "*.bmp", "*.gif", "*.jpg;*.jpeg"));
	
	if(null == strPath)
		return;
		
	var lstInd = strPath.lastIndexOf("\\");
	if(lstInd==-1)
		lstInd = strPath.lastIndexOf("/");
	var fileName = strPath.substr(lstInd+1);
	var fotoDir = lpProxy.getOrgPath() + "data/foto/"
	var path = fotoDir + fileName;
	if (!isDir(fotoDir))
		createDirectory(fotoDir);
	if(strPath!=path)
	{
		if(lpProxy.copyFile(strPath, path))
			img.setFileName(path);
	}
	else
		img.setFileName(path);
}

function storeBufToBase(strTableName)
{
	strTempTableName = arrTempTbl[String(strTableName)];
	ExecuteSQL("delete from ^" + strTableName 
				+ " where fwid_cl = " + sqlTo(objCl.getID()));
	var sFLD = GetPatternIntersection(strTableName, strTableName);
	var sSQL = "INSERT INTO ^" + strTableName + "(" + sFLD + ")"
			+ " SELECT " + sFLD + " FROM " + strTempTableName;
	ExecuteSQL(sSQL);	
			
}

function initGrid(gridCtrl, strFileName, strTableName, strOrder)
{
	tblName = strTableName;
	var nId = (extPar.mode == "COPY")?objCl.nOldID : objCl.getID();
	if(null == arrTempTbl[strTableName])
	{
		strTableName = String(strTableName)
		if(inList(strTableName, "full_pers", "prk_otp"))
			arrTempTbl[String(strTableName)] = strTableName;
		else
		{
			strTempTableName = getTmpTableName("", true);
			arrTempTbl[String(strTableName)] = strTempTableName;
		}
		
	}
	
	strTempTableName = arrTempTbl[strTableName];
	var t = null;
	var sqlOrder = "";
	switch(strTableName)
	{
		case "prk_otp":
		case "work_pers":
		case "full_pers":
		case "lastjob":
		case "certification":
		case "discipl":
			sqlOrder = " order by Fbdat";
		break;
		case "familyties":
			sqlOrder = " order by Fbirthday";
		break;
		case "education":
			sqlOrder = " order by Fedat";
		break;
	}
	if(strTempTableName != strTableName)
	{
		CreateTable(strTempTableName, strTableName, "FWID");
		var strFLD = GetPatternIntersection(strTableName, strTableName);
		var sSQL = "INSERT INTO " + strTempTableName + "(" + strFLD + ")"
				+ " SELECT " + strFLD
				+ " FROM ^" + strTableName
				+ " WHERE fwid_cl = " + sqlTo(nId)
				+ " ORDER BY " + strOrder
		ExecuteSQL(sSQL);
		t = OpenTable("select * from ^" + strTempTableName+sqlOrder);
	}
	else
	{
		t = OpenTable("select * from ^" + strTempTableName + " where fwid_cl=" + sqlTo(nId)+sqlOrder);
	}

	switch(strTableName)
	{
		case "education":
			clTie(t, "inst", "=" + getPar(typeof const_GETPAR_UCHZAKL != "undefined"?const_GETPAR_UCHZAKL:"CDRINS") + ", FID_INSTITUT", "cl_inst");
			clTie(t, "form", "=" + getPar(typeof const_GETPAR_OBUCHFORM != "undefined"?const_GETPAR_OBUCHFORM:"CDRFRM") + ", FID_FORMEDUC", "cl_form");
			clTie(t, "educ", "=" + getPar(typeof const_GETPAR_OSVITA != "undefined"?const_GETPAR_OSVITA:"CDREDU") + ", FID_TYPEEDUC", "cl_educ");
			clTie(t, "degr", "=" + getPar(typeof const_GETPAR_NAUK != "undefined"?const_GETPAR_NAUK:"CDRDEG") + ", FID_DEGREE", "cl_degr");
			clTie(t, "spec", "=" + getPar(typeof const_GETPAR_SPEC != "undefined"?const_GETPAR_SPEC:"CDRSPEC") + ", FID_SPECIAL", "cl_spec");
			clTie(t, "qualif", "=" + getPar(typeof const_GETPAR_KVAL != "undefined"?const_GETPAR_KVAL:"CDRQLF") + ", FID_QUALIF", "cl_qualif");
		break;
		case "familyties":
			clTie(t, "link", "=" + getPar(typeof const_GETPAR_FAMTIES != "undefined"?const_GETPAR_FAMTIES:"CDRFTIE") + ", FID_TLINK", "cl_link");
		break;
		case "prk_otp":
			clTie(t, "otp", "=" + getPar("CODOTP") + ", FTYPE", "cl_otp");
			//t.tie("prk_otp", "otp", "fwid", "fwid_dol");
		break;
		case "work_pers":
			t.tie("stru_dol", "d", "fwid", "fwid_dol");
			clTie(t, "dol", "=" + getPar("CODDOL") + ", d.fcod", "cl_dol");
			t.tie("stru_org", "o", "fwid", "d.fwid_org");
			t.tie("cl", "CL_KAT", "FWID", "fwid_kat");
		break;
		case "certification":
			clTie(t, "doc", "=" + getPar("CDRDOCTYPE") + ", FDOC", "cl_doc");
		break;
	}
	
	gridCtrl.setXMLDir(this.sDocSourceDir);
	gridCtrl.setXMLFile(strFileName);
	gridCtrl.setData(strTableName);
	gridCtrl.setTable(t);
	gridCtrl.build();
	gridCtrl.loadMenuHandler(this,"listMenuInit");	
	gridCtrl.selectMenuHandler(this, "listMenuHandler");
}

function getTypeOtp(fwid)
{
	var res = "";
	var t = OpenTable("select t.Fdays,t.Fpdays,n.* from ^otp_type as t inner join ^nast_otp as n on t.Fwid_type=n.Fwid"
					+" where t.Fid_doc = " + sqlTo(fwid)+" order by t.Fwid");
	for(; !t.IsEOF(); t.MoveNext())
	{
		if(t.bookmark == 1)
			res += t.getValue("Fnazv")+"("+(Number(t.getValue("Fdays"))+Number(t.getValue("Fpdays")))+")";
		else
			res += " + "+t.getValue("Fnazv")+"("+(Number(t.getValue("Fdays"))+Number(t.getValue("Fpdays")))+")";
	}
	t.close();
	return res;
}

function listMenuInit(grid)
{
	var tbl = grid.getTable();
	switch(String(grid.getData()).toLowerCase())
	{
		case "full_pers":
			if(tbl.isEmpty())
			{
				grid.AddMenuItem("IN", "Призначити...|Назначить...", "ADD");
			}
			else
			{
				grid.AddMenuItem("OI", "Перевести...|Перевести...", "ADD");
				grid.AddMenuItem("OUT", "Звільнити...|Уволить...", "del");
			}
		
			grid.AddMenuItem("", "");
			grid.AddMenuItem("REFRESH", "Обновити|Обновить");
		break;
		case "prk_otp":
			grid.AddMenuItem("OTP", "Створити наказ|Создать приказ", "ADD");
			grid.AddMenuItem("", "");
			grid.AddMenuItem("REFRESH", "Обновити|Обновить");
		break;
		default:
			grid.AddMenuItem("ADD","Додати|Добавить");
			if (!tbl.isEmpty() && tbl.isRecord())
			{
				grid.AddMenuItem("EDIT","Редагувати|Редактировать");
				grid.AddMenuItem("COPY","Копіювати|Копировать");
				grid.AddMenuItem("DEL","Вилучити|Удалить");
			}
		break;
	}
}

function listMenuHandler(sID, grid)
{
	switch(sID)
	{
		case "DEL":
			if(grid.getTable().isRecord() && "-" == msgBox("c-"
					, ru("Подтвердите удаление записей.", "Підтвердіть видалення записів.")))
			{		
				objCl.deleteRow(grid.getData(), Number(grid.getTable().getRowID()));
				grid.getTable().Delete();
				grid.getTable().requery();
				grid.refresh();
			}
			break;
		
		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
			
			if (delRowCount <= 0)
			{
				return;
			}
			var selIds = grid.getSelectedIDs();
			
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + grid.getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}

			strSQL = " DELETE FROM " + grid.getTable().getTableName()
					+" WHERE " + grid.sqlSelected()
			ExecuteSQL(strSQL);

			grid.getTable().requery();
			grid.clearSelected();
			grid.refresh();
			setProgressPos(0);
			break;

		case "IN":
		case "OI":
		case "OUT":
		case "OTP":
			if(extPar.mode == "ADD")
			{
				alert(ru("Сперва сохраните запись в справочнике!","Спершу збережіть запис в довіднику!"));
				return false;
			}
			var oDocPrk = new DpDoc("CDR_" + sID.toUpperCase(), 0);
			var par = new Object();
			par.prk_fwid_cl = objCl.getID();
			oDocPrk.edit("ADD", Number(grid.getTable().getRowID()), par);
			//обновляем дату, причину и статью увольнения
			if(sID=="OUT")
			{
				var snap = getSnap("select Fedat, Freason_uv, Fwid from ^full_pers where Fwid_cl="+objCl.getID()
								+"  and Fedat=(select MAX(Fedat) from ^work_pers where Fwid_cl="+objCl.getID()+" and Fis_uv="+sqlTrue+")")
				HDIS_DAT.value = snap[0];
				HDIS_MOT.value = snap[1];
				var snapSt = getSnap("select Freason_stcod from ^prk_out where Fwid_wp="+snap[2]);
				if(snapSt)
					HDIS_STAT.value = snapSt[0];
			}
			grid.getTable().requery();
			grid.refresh();
		break;
		case "REFRESH":
			grid.getTable().requery();
			grid.refresh();
		break;
		default:
			var oRow;
			switch(sID)
			{
				case "ADD":
					oRow = objCl.createRow(grid.getData());
				break;
				case "EDIT":
					oRow = objCl.getRow(grid.getData(), Number(grid.getTable().getRowID()));
				break;
				case "COPY":
					oRow = objCl.copyRow(grid.getData(), Number(grid.getTable().getRowID()));
				break;
			}
			if(!oRow)
				break;
			editCl(sID, oRow, grid);			
			gridRefresh(grid, oRow.getID());	
		break;
	}
}

function editCl(sMode, oRow, grid)
{
	var form = "";
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = grid.getTable().getTableName();
	switch(String(grid.getData()))
	{
		case "education":
			form = "educ";
			break;
		case "familyties":
			form = "family";
			break;
		case "lastjob":
			form = "lwork";
			break;
		case "courses":
			form = "courses";
			break;
		case "leave":
			//если нет модуля CDRP, то отпускные не редактируем
			if(typeof CDR_OTP_NO != "undefined")
				form = "leave";
			break;
		case "oldshtat":
			form = "oldshtat";
			break;
		case "certification":
			form = "cert";
			break;
		case "discipl":
			form = "discipl";
			break;
	}
	if(form == "")
		return false;
	par.formFile = "cls/"+ objCl.sClassId +"/"+form+"/form.xml"; 	
	par.dpObj.hasExt = hasExt;
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	var id = oRow.getID();	
	if(inList(sMode, "ADD", "COPY"))
		objCl.appendRow(grid.getData(), oRow);

//	if(oRow.getVar("HMAIN")==true)
//		resetMainRs(id);
	obj2DB(id, oRow.jObj, null, grid.getTable().getTableName());
	//если есть параметр, то при редактировании предыдущих мест работы меняем дату выслуги
	if(grid.getData()=="lastjob" && getPar("CALCVISL"))
	{
		var tVisl = OpenTable("select * from "+grid.getTable().getTableName());
		var days = 0;
		for(; !tVisl.IsEOF(); tVisl.MoveNext())
		{
			if(toScrObj(tVisl.getValue("Fuseinvisl")))
				days += day_difference(tVisl.getValue("Fbdat"),tVisl.getValue("Fedat"));
		}
		tVisl.close();
		
		//если дата выслуги пустая и кол-во дней равно нулю, тогда оставляем как есть
		if(days!=0 || differ(new Date(HVISLDAT.value),d00obj)!=0)
		{
			var new_visl = goDay(HWRKDAT.value, -days);
			var old_visl = HVISLDAT.value;
			var msg = ru("Изменить дату выслуги","Змінити дату вислуги")+(differ(new Date(HVISLDAT.value),d00obj)!=0?ru(" с "," з ")+format("dd.mm.yyyy",old_visl):"")+format(" на dd.mm.yyyy?",new_visl);
			if(differ(new_visl,old_visl)!=0 && confirm(msg))
				HVISLDAT.value = new_visl;
		}
	}
	return true;
}

function hasExt()
{
	return false;
}

//возвращает массив состоящий из фамилии имени и отчества
function getFioArr(fio,nootch)
{
	fio = allt(fio);
	var j = 0;
	var FIO = new Array("","","");
	s = "";
	for(i=0; i<fio.length; i++)
	{
		if(fio[i]!=" ")
		{
			s+=fio[i];
			if(fio.length-1==i)
				FIO[j++] = s;
		}
		else
		{
			if(fio[i-1]!=" ")
			{
				FIO[j++] = s;
				s = "";
			}
		}
	}
        if (nootch==true){
           FIO[1]=FIO[1]+" "+FIO[2];
           FIO[2]="";
        }
	return FIO;
}

function gridRefresh(grid, fid)
{
	grid.getTable().requery();
	if(fid)
		grid.getTable().findByID(fid);		
	grid.setFocus();
	grid.refresh();
}

function HMILSERV_Valid()
{
	if(HMILSERV.value == "непригоден")
	{
		HMILREGSPEC.enabled = false;
		HMILRANG.enabled = false;
		HMILGROUP.enabled = false;
	}
	else
	{
		HMILREGSPEC.enabled = true;
		HMILRANG.enabled = true;
		HMILGROUP.enabled = true;
	}
}

function HINVAL_valid()
{
	if(HINVAL.value == true)
	{
		Enable(HBDATINVAL);
		Enable(HEDATINVAL);
		Enable(HINVALTYPE);
		Enable(HTINVALTYPE);
	}
	else
	{
		HBDATINVAL.value = d00;
		HEDATINVAL.value = d00;
		Disable(HBDATINVAL);
		Disable(HEDATINVAL);
		Disable(HINVALTYPE);
		Disable(HTINVALTYPE);
	}
	return true;
}

function HPENS_valid()
{
	if(HPENS.value == true)
	{
		Enable(HBDATPENS);
		Enable(HPENSTYPE);
		Enable(HTPENSTYPE);
	}
	else
	{
		HBDATPENS.value = d00;
		Disable(HBDATPENS);
		Disable(HPENSTYPE);
		Disable(HTPENSTYPE);
	}
	return true;
}

function HBDATINVAL_valid()
{
	if(HINVAL.value == true && differ(HBDATINVAL.value,d00)==0)
	{
		WAIT(ru("Дата начала периода инвалидности не может быть пустой!","Дата початку періоду інвалідності не може бути порожньою!"));
		return false;
	}
	return true;
}

function HEDATINVAL_valid()
{
	if(HINVAL.value == true && differ(HBDATINVAL.value,d00)==0)
	{
		WAIT(ru("Дата начала периода инвалидности не может быть пустой!","Дата початку періоду інвалідності не може бути порожньою!"));
		return false;
	}
	return true;
}

function HBDATPENS_valid()
{
	if(HPENS.value == true && differ(HBDATPENS.value,d00)==0)
	{
		WAIT(ru("Дата выхода на пенсию не может быть пустой!","Дата виходу на пенсію не може бути порожньою!"));
		return false;
	}
	return true;
}

function checkInval()
{
	if(HINVAL.value==true)
		return;
	var snap = getSnap("select Finval,Fbdat,Fedat from ^full_pers where Fwid_cl="+objCl.getID()+" and Fid=(select MAX(Fid) from ^work_pers where Fwid_cl="+objCl.getID()+")");
	if(snap)
	{
		msg = ru("В штатном расписании у данного сотрудника проставлен признак инвалидности с "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставить этот признак в личной карточке?",
				"В штатному розкладі у даного співробітника проставлено ознаку інвалідності з "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставити цю ознаку в особовій картці?")
		if(snap[0]==true && confirm(msg))
		{
			HINVAL.value = true;
			HBDATINVAL.value = snap[1];
			HEDATINVAL.value = snap[2];
			Enable(HBDATINVAL);
			Enable(HEDATINVAL);
		}
	}
}

function checkPens()
{
	if(HPENS.value==true)
		return;
	var snap = getSnap("select Fpens,Fbdat from ^full_pers where Fwid_cl="+objCl.getID()+" and Fid=(select MAX(Fid) from ^work_pers where Fwid_cl="+objCl.getID()+")");
	if(snap)
	{
		msg = ru("В штатном расписании у данного сотрудника проставлен признак пенсионера с "+format("dd.mm.yy",snap[1])+"\nПроставить этот признак в личной карточке?",
				"В штатному розкладі у даного співробітника проставлено ознаку пенсіонера з "+format("dd.mm.yy",snap[1])+"\nПроставити цю ознаку в особовій картці?")
		if(snap[0]==true && confirm(msg))
		{
			HPENS.value = true;
			HBDATPENS.value = snap[1];
			Enable(HBDATPENS);
		}
	}
}

function FISPARSEIND_valid()
{
	if(FISPARSEIND.value == true && String(HINDNUM.value).length == 10)
	{
		var mForigdat = decodeinn("BDAT", HINDNUM.value);
		var mFsex = decodeinn("SEX", HINDNUM.value);
		
		HORIGDAT.setValue(mForigdat);
		HSEX.value = (mFsex == true)?1:0;
	}
	return true;
}
include("sys\\DpBaseDlg.js");