include("decodeinn.js");
include("Objects/DpSbcs.js");
include("Objects/DpCl.js");
include("servis/initials.js");

var tHomo;
var objCl = extPar.dpObj;
var ctrlLinker, dpSbcs;
var oCountry, oCitizen, oRegion, oArea, oCity;
var arrTempTbl = new Array();

function Load()
{
	Caption(objCl.getClTxt(extPar.Fcl)
			+ ": " + modeName(this.sMode));
				
   	FCOD.setMask("###########");
   	FPHONE.mask = "&&&&&&&&&&&&&&&";
   	FWRKPHONE.mask = "&&&&&&&&&&&&&&&";
   	FMPHONE.mask = "&&&&&&&&&&&&&&&";
   	FDOCSER.mask = "&&&&&&&&&&";
   	FDOCNOM.mask = "&&&&&&&&&&";
   	FINDNUM.mask = "&&&&&&&&&&";
   	FBLD.mask = "######";
   	FLETTER.mask = "&&";
   	FCORP.mask = "#####";
   	FAPART.mask = "#####";
   	FOWNER.mask = "#####";
   	FZIP.mask = "&&&&&&";
   	FOLDSURNAME.mask = strRepl("&",50);
   	FSCHET_BNK.mask = strRepl("&",20);
   	FCODFILIAL.mask = "#####";
   	HSERTINS_SER.mask = "&&&&&&&&&";
	HSERTINS_NUM.mask = "&&&&&&&&&&";
   	if(extPar.sMode=="EDIT")
		FCOD.setEnabled(false);
	else
   		FCOD.setFocus();
   	
//   	oBank = new DpBank();
//	oBank.linkCtrl(FMFO,FTXT_BNK);
	
	dpSbcs = new DpSbcs("0");
	dpSbcs.linkCtrl(FNUM_BNK, FTXT_BNK, FRAS_SCH, FMFO);
	if(extPar.mode != "ADD")
		dpSbcs.setCod(objCl.getVar("HNUM_BNK"));
	else
	{
		FWRKDAT.value = d00;
		FVISLDAT.value = d00;
		FORIGDAT.value = d00;
		FDOCDAT.value = d00;
	}
	
	oCitizen = new DpCl("0", getPar("CODCOUNTRY"), 0);
	oCitizen.linkCtrl(HCITIZEN, HCITIZENTXT);
	
	oCountry = new DpCl("0", getPar("CODCOUNTRY"), 0);
	oCountry.linkCtrl(HCOUNTRY, HCOUNTRYTXT);
	if(!getPar("CODCOUNTRY"))
	{
		Disable(HCITIZEN);
		Disable(HCOUNTRY);
	}
	oRegion = new DpCl("U0", getPar("CODREGION"), 0, oCountry);
	oRegion.linkCtrl(HREGION, HTREGION);

	oArea = new DpCl("U0", getPar("CODAREA"), 0, oRegion);
	oArea.linkCtrl(HAREA, HTAREA);
	
	oCity = new DpCl("0", getPar("CODLOCATE"), oArea);
	oCity.linkCtrl(FCITY, FTCITY);
   	
	ctrlLinker = new DpCtrlLinker(objCl);	
	ctrlLinker.addLink("HCOD", FCOD);	
	ctrlLinker.addLink("HTXT", FTXT);	
	ctrlLinker.addLink("HTXT_INITIALS", FTXT_INITIALS);	
	ctrlLinker.addLink("HINDNUM", FINDNUM);	
	ctrlLinker.addLink("HWRKDAT", FWRKDAT);	
	ctrlLinker.addLink("HVISLDAT", FVISLDAT);
	ctrlLinker.addClLink("HCITIZEN", oCitizen);
	ctrlLinker.addClLink("HCOUNTRY", oCountry);
	ctrlLinker.addClLink("HREGION", oRegion);
	ctrlLinker.addClLink("HAREA", oArea);
	ctrlLinker.addClLink("HCITY", oCity);	
	ctrlLinker.addLink("HADDR", FADDR);	
	ctrlLinker.addLink("HWRKPHONE", FWRKPHONE);	
	ctrlLinker.addLink("HPHONE", FPHONE);		
	ctrlLinker.addLink("HMPHONE", FMPHONE);
	ctrlLinker.addLink("HORIGDAT", FORIGDAT);	
	ctrlLinker.addLink("HORIGADDR", FORIGADDR);	
	ctrlLinker.addLink("HDOCSER", FDOCSER);	
	ctrlLinker.addLink("HDOCNOM", FDOCNOM);	
	ctrlLinker.addLink("HDOCDAT", FDOCDAT);	
	ctrlLinker.addLink("HDOCOWN", FDOCOWN);	
	ctrlLinker.addLink("HREM", 	FREM);
	ctrlLinker.addLink("HSEX", 	FSEX);		
	ctrlLinker.addLink("HBLD", 	FBLD);	
	ctrlLinker.addLink("HLETTER", FLETTER);	
	ctrlLinker.addLink("HCORP", FCORP);	
	ctrlLinker.addLink("HAPART", FAPART);	
	ctrlLinker.addLink("HOWNER", FOWNER);	
	ctrlLinker.addLink("HZIP", 	FZIP);
	ctrlLinker.addLink("HEMAIL", FEMAIL);
	ctrlLinker.addLink("HWEB", FWEB);
	ctrlLinker.addLink("HOLDSURNAME", FOLDSURNAME);
	ctrlLinker.addLink("HSCHET_BNK", FSCHET_BNK);
	ctrlLinker.addLink("HCODFILIAL", FCODFILIAL);
	ctrlLinker.addLink("HSERTINS_SER", HSERTINS_SER);
	ctrlLinker.addLink("HSERTINS_NUM", HSERTINS_NUM);
	ctrlLinker.addLink("HISOTCH", FISOTCH);	
	
	ctrlLinker.toControls();
	FSEX.value = (objCl.getVar("HSEX") == true)?1:0;	
	
	if (extPar.mode == "EDIT")
		setFocus(FTXT);
	else
	{
		//если есть параметр, то инициализируем код при добавлении значением по умолчанию
		if(extPar.defCod)
		{
			var snap = getSnap("select Fwid_cl from ^clrelclcl where Fcl="+extPar.Fcl+" and Fcod="+extPar.defCod);
			if(!snap)
				FCOD.value = extPar.defCod;
		}
		FISOTCH.checked = false;		
	}
	
	var codUkr = 0;
	if(objCl.getVar("HCOUNTRY")==0 || objCl.getVar("HCITIZEN")==0)
	{
		var snap = getSnap("select Fcod from ^listcl where Fcl="+getPar("CODCOUNTRY")+" and LOWER(Ftxt) like '%укра%'");
		if(snap)
			codUkr = snap[0];
	}
	if(objCl.getVar("HCOUNTRY")==0)
		oCountry.setCod(codUkr);
	else
		oCountry.setCod(objCl.getVar("HCOUNTRY"));
	if(objCl.getVar("HCITIZEN")==0)
		oCitizen.setCod(codUkr);
	else
		oCitizen.setCod(objCl.getVar("HCITIZEN"));
	oRegion.validCtrl();
	oArea.validCtrl();
	oCity.validCtrl();
	
	grCert.setViewerID("e_prfile.js.cert");
	this.listMenuInit = listMenuInit;
	this.listMenuHandler = listMenuHandler;
	this.sDocSourceDir = rootDirectory() + "cls/CL3/";
	this.initGrid = initGrid;
	this.initGrid(grCert, "grCert.xml", "certification", "FBDAT");
	this.createMail = createMail;
	this.openWeb = openWeb;
	setButton(FEMAIL, this, "createMail");
	setButton(FWEB, this, "openWeb");
	
	FEMAIL.getBtn().setToolTipText(UR("Створити повідомлення|Создать сообщение"));
	FWEB.getBtn().setToolTipText(UR("Зайти на сайт|Зайти на сайт"));
	
   	Disable(FTXT_INITIALS);
   	setValid(FTXT, Ftxt_valid);
   	setValid(FISPARSEIND, FISPARSEIND_valid);
	//setValid(FINDNUM, Findnum_valid);
   	Ftxt_valid();
   	if(extPar.mode == "ADD")
	{
		//FWRKDAT.value = d00;
		FVISLDAT.value = d00;
		FORIGDAT.value = d00;
		FDOCDAT.value = d00;
	}
}

function onSave()
{
	var bOK, s, ts;
	s = "SELECT a.* FROM ^CL a"
		+" INNER JOIN ^CLRELCLCL b ON a.FWID=b.FWID_CL"
		+" WHERE b.FCOD=" + FCOD.getValue() + " AND b.FCL=" + objCl.getVar("HCL")
		+" and a.fwid <> "+ objCl.getID();
	ts = getSnap(s);
	if(ts!=null)
	{		
		setFocus(FCOD);
		WAIT(ru("Запись с таким кодом уже существует.", "Запис з таким кодом вже існує."));
		return false;
	}
	objCl.setVar("HNUM_BNK", dpSbcs.getCod());
	objCl.setVar("HSTREET", FADDR.value);
	ctrlLinker.toVars();
	//если есть параметры мести перечислений и место по умолчанию, тогда при сохранении добавляем его
	if(extPar.mode=="ADD" && objCl.getVar("HCL")==getPar("CODPERS") && getPar("COD_CAS_TRTYPE") && getPar("CAS_TRPLACE"))
		addTrPlace(objCl.getVar("HCOD"),objCl.getVar("HTXT"),getPar("COD_CAS_TRTYPE"),getPar("TRSBERCAS"));
	storeBufToBase("certification");
/*
	var m = new Object();
	m.FWID = this.sFWID;
	m.FTXT =String(FTXT.getValue());
	m.FCOD1 = cod1;
  	if(typeof(FTCOD)!="undefined")
  		m.ftcod = Number(FTCOD.getValue());
  	if(typeof(FTXTS)=="object")
  		m.Ftxts = Number(Ftxts.getValue());
	if(this.sMode == "EDIT")
	{
		s = "UPDATE ^CLRELCLCL SET FCOD=" + FCOD.getValue()
					+ " WHERE FWID_CL=" + sqlTo(this.sFWID);
				ExecuteSQL(s);
	}
	else
	{
		s = "INSERT INTO ^CLRELCLCL (FCL,FWID_CL,FCOD)"
				+" VALUES (" + nCl+ "," + sqlTo(this.sFWID) + "," + FCOD.getValue() + ")";
		ExecuteSQL(s);
	}
	
	m.FGRPID = extPar.parID;
  	m.FISGRP = (extPar.isGrpEdit?extPar.isGrpEdit:false);
	
	UpdateTable("^CL",m,this.sMode != "EDIT");
	
	extPar.nFwid = this.sFWID;
	extPar.nFtxt = m.FTXT;
	
// --------------для притаеных таблиц

	tHomo.MoveFirst()
	while(!tHomo.isEOF() && String(tHomo.getValue("FWID_CL")) != this.sFWID)
	{
		tHomo.MoveNext();
	}
	
	var fid;
   	if(tHomo.isEOF())
   	{
   		fid = GetUID();
		ExecuteSQL("INSERT INTO ^cl_homo (FWID) VALUES (" + sqlTo(fid) + ")");
   	}
   	else
   	{
   		fid = tHomo.getValue("FWID");
   	}

	var fid = null;
	var oSnap = getSnap("SELECT FWID FROM ^cl_homo WHERE FWID_CL=" + sqlTo(this.sFWID));
	if (oSnap != null)
	{
		fid = oSnap[0];
	}
	else
	{
		fid = GetUID();
		ExecuteSQL("INSERT INTO ^cl_homo (FWID) VALUES (" + sqlTo(fid) + ")");
	}	
	var sVals = "UPDATE ^CL_HOMO SET ";
	sVals += " FWID_CL=" + sqlTo(this.sFWID);
	sVals += ", FADDR=" + sqlTo(FADDR.value);
	sVals += ", FPHONE=" + sqlTo(FPHONE.value);
	sVals += ", FWRKPHONE=" + sqlTo(FWRKPHONE.value);
	sVals += ", FORIGADDR=" + sqlTo(FORIGADDR.value);
	sVals += ", FORIGDAT=" + sqlTo(FORIGDAT.value);
	sVals += ", FDOCSER=" + sqlTo(FDOCSER.value);
	sVals += ", FDOCNOM=" + sqlTo(FDOCNOM.value);
	sVals += ", FDOCOWN=" + sqlTo(FDOCOWN.value);
	sVals += ", FDOCDAT=" + sqlTo(FDOCDAT.value);
	sVals += ", FREM=" + sqlTo(FREM.value);
	sVals += ", FWRKDAT=" + sqlTo(FWRKDAT.value);
	sVals += ", FSEX=" + sqlTo(FSEX.value == "m");
	sVals += ", FVISLDAT=" + sqlTo(FVISLDAT.value);
	sVals += ", FINDNUM=" + sqlTo(FINDNUM.value);
	sVals += " WHERE FWID=" + sqlTo(fid);	
	ExecuteSQL(sVals);
*/		
}

function initGrid(gridCtrl, strFileName, strTableName, strOrder)
{
	tblName = strTableName;
	var nId = (extPar.mode == "COPY")?objCl.nOldID : objCl.getID();
	if(null == arrTempTbl[strTableName])
	{
		strTableName = String(strTableName)
		if(inList(strTableName, "full_pers", "prk_otp"))
			arrTempTbl[String(strTableName)] = strTableName;
		else
		{
			strTempTableName = getTmpTableName("", true);
			arrTempTbl[String(strTableName)] = strTempTableName;
		}
		
	}
	
	strTempTableName = arrTempTbl[strTableName];
	var t = null;
	if(strTempTableName != strTableName)
	{
		CreateTable(strTempTableName, strTableName, "FWID");
		var strFLD = GetPatternIntersection(strTableName, strTableName);
		var sSQL = "INSERT INTO " + strTempTableName + "(" + strFLD + ")"
				+ " SELECT " + strFLD
				+ " FROM ^" + strTableName
				+ " WHERE fwid_cl = " + sqlTo(nId)
				+ " ORDER BY " + strOrder
		ExecuteSQL(sSQL);
		t = OpenTable("select * from ^" + strTempTableName);
	}
	else
	{
		t = OpenTable("select * from ^" + strTempTableName + " where fwid_cl=" + sqlTo(nId));
	}

	switch(strTableName)
	{
		case "education":
			clTie(t, "inst", "=" + getPar(typeof const_GETPAR_UCHZAKL != "undefined"?const_GETPAR_UCHZAKL:"CDRINS") + ", FID_INSTITUT", "cl_inst");
			clTie(t, "form", "=" + getPar(typeof const_GETPAR_OBUCHFORM != "undefined"?const_GETPAR_OBUCHFORM:"CDRFRM") + ", FID_FORMEDUC", "cl_form");
			clTie(t, "educ", "=" + getPar(typeof const_GETPAR_OSVITA != "undefined"?const_GETPAR_OSVITA:"CDREDU") + ", FID_TYPEEDUC", "cl_educ");
			clTie(t, "degr", "=" + getPar(typeof const_GETPAR_NAUK != "undefined"?const_GETPAR_NAUK:"CDRDEG") + ", FID_DEGREE", "cl_degr");
			clTie(t, "spec", "=" + getPar(typeof const_GETPAR_SPEC != "undefined"?const_GETPAR_SPEC:"CDRSPEC") + ", FID_SPECIAL", "cl_spec");
			clTie(t, "qualif", "=" + getPar(typeof const_GETPAR_KVAL != "undefined"?const_GETPAR_KVAL:"CDRQLF") + ", FID_QUALIF", "cl_qualif");
		break;
		case "familyties":
			clTie(t, "link", "=" + getPar(typeof const_GETPAR_FAMTIES != "undefined"?const_GETPAR_FAMTIES:"CDRFTIE") + ", FID_TLINK", "cl_link");
		break;
		case "prk_otp":
			clTie(t, "otp", "=" + getPar("CODOTP") + ", FTYPE", "cl_otp");
			//t.tie("prk_otp", "otp", "fwid", "fwid_dol");
		break;
		case "work_pers":
			t.tie("stru_dol", "d", "fwid", "fwid_dol");
			clTie(t, "dol", "=" + getPar("CODDOL") + ", d.fcod", "cl_dol");
			t.tie("stru_org", "o", "fwid", "d.fwid_org");
			t.tie("cl", "CL_KAT", "FWID", "fwid_kat");
		break;
		case "certification":
			clTie(t, "doc", "=" + getPar("CDRDOCTYPE") + ", FDOC", "cl_doc");
		break;
	}
	
	gridCtrl.setXMLDir(this.sDocSourceDir);
	gridCtrl.setXMLFile(strFileName);
	gridCtrl.setData(strTableName);
	gridCtrl.setTable(t);
	gridCtrl.build();
	gridCtrl.loadMenuHandler(this,"listMenuInit");	
	gridCtrl.selectMenuHandler(this, "listMenuHandler");
}

function Ftxt_valid()
{
	//с помощью ф-и reTrans() сразу заменяем взаимообратимые латынские символы на кириллические
	FTXT.value = cleanSpace(String(reTrans(String(FTXT.value))));
	FTXT_INITIALS.value = initials(String(FTXT.value));
	var ind = indexOfLatin(FTXT.value);
	if(ind != -1)
	{
		alert(ru("В ФИО присутствуют не кириллические символы ("+(ind+1)+"-й символ)!",
				"В ПІБ присутні не кириличні символи ("+(ind+1)+"-й символ)!"));
		return false;
	}
	return true;
}

function Findnum_valid()
{
	if(String(FINDNUM.value).length == 10)
	{
		var mForigdat = decodeinn("BDAT", FINDNUM.value);
		var mFsex = decodeinn("SEX", FINDNUM.value);
		
		FORIGDAT.setValue( mForigdat );
		FSEX.value = (mFsex == true)?1:0;
	}
}

function FISPARSEIND_valid()
{
	if(FISPARSEIND.value == true)
		Findnum_valid()
	return true;
}

function openWeb()
{
	if(String(FWEB.value).trim()!="")	
		lpProxy.displayURL(FWEB.value);
}

function createMail()
{
	var mail = FEMAIL.value;
	var fio = FTXT.value;
	var nNop = getPar("SMTP_DOC");
	if(!nNop)
		nNop = 2;
	
	include("doc/DpDoc.js");
	var oDoc = new DpDoc("MMSG", nNop);		
	oDoc.setVar("HNOM", oDoc.getAutoNo().get());
			
	var oRow = oDoc.createRow("MCNT");	
	oRow.setVar("HMAIL", mail);
	oRow.setVar("HFIO", fio);
	oDoc.appendRow("MCNT", oRow);
	obj2DB(oRow.getID(), oRow.jDocRow, null, "MAIL_CNT");
	
	bRet = oDoc.edit("ADD");
	return bRet;
}

function listMenuInit(grid)
{
	var tbl = grid.getTable();
	switch(String(grid.getData()).toLowerCase())
	{
		case "full_pers":
			if(tbl.isEmpty())
			{
				grid.AddMenuItem("IN", "Призначити...|Назначить...", "ADD");
			}
			else
			{
				grid.AddMenuItem("OI", "Перевести...|Перевести...", "ADD");
				grid.AddMenuItem("OUT", "Звільнити...|Уволить...", "del");
			}
		
			grid.AddMenuItem("", "");
			grid.AddMenuItem("REFRESH", "Обновити|Обновить");
		break;
		case "prk_otp":
			grid.AddMenuItem("OTP", "Створити наказ|Создать приказ", "ADD");
			grid.AddMenuItem("", "");
			grid.AddMenuItem("REFRESH", "Обновити|Обновить");
		break;
		default:
			grid.AddMenuItem("ADD","Додати|Добавить");
			if (!tbl.isEmpty() && tbl.isRecord())
			{
				grid.AddMenuItem("EDIT","Редагувати|Редактировать");
				grid.AddMenuItem("COPY","Копіювати|Копировать");
				grid.AddMenuItem("DEL","Вилучити|Удалить");
			}
		break;
	}
}

function listMenuHandler(sID, grid)
{
	switch(sID)
	{
		case "DEL":
			if(grid.getTable().isRecord() && "-" == msgBox("c-"
					, ru("Подтвердите удаление записей.", "Підтвердіть видалення записів.")))
			{		
				objCl.deleteRow(grid.getData(), Number(grid.getTable().getRowID()));
				grid.getTable().Delete();
				grid.getTable().requery();
				grid.refresh();
			}
			break;
		
		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
			
			if (delRowCount <= 0)
			{
				return;
			}
			var selIds = grid.getSelectedIDs();
			
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + grid.getSelectedCount() + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}

			strSQL = " DELETE FROM " + grid.getTable().getTableName()
					+" WHERE " + grid.sqlSelected()
			ExecuteSQL(strSQL);

			grid.getTable().requery();
			grid.clearSelected();
			grid.refresh();
			setProgressPos(0);
			break;

		case "IN":
		case "OI":
		case "OUT":
		case "OTP":
			if(extPar.mode == "ADD")
			{
				alert(ru("Сперва сохраните запись в справочнике!","Спершу збережіть запис в довіднику!"));
				return false;
			}
			var oDocPrk = new DpDoc("CDR_" + sID.toUpperCase(), 0);
			var par = new Object();
			par.prk_fwid_cl = objCl.getID();
			oDocPrk.edit("ADD", Number(grid.getTable().getRowID()), par);
			//обновляем дату, причину и статью увольнения
			if(sID=="OUT")
			{
				var snap = getSnap("select Fedat, Freason_uv, Fwid from ^full_pers where Fwid_cl="+objCl.getID()
								+"  and Fedat=(select MAX(Fedat) from ^work_pers where Fwid_cl="+objCl.getID()+" and Fis_uv="+sqlTrue+")")
				HDIS_DAT.value = snap[0];
				HDIS_MOT.value = snap[1];
				var snapSt = getSnap("select Freason_stcod from ^prk_out where Fwid_wp="+snap[2]);
				if(snapSt)
					HDIS_STAT.value = snapSt[0];
			}
			grid.getTable().requery();
			grid.refresh();
		break;
		case "REFRESH":
			grid.getTable().requery();
			grid.refresh();
		break;
		default:
			var oRow;
			switch(sID)
			{
				case "ADD":
					oRow = objCl.createRow(grid.getData());
				break;
				case "EDIT":
					oRow = objCl.getRow(grid.getData(), Number(grid.getTable().getRowID()));
				break;
				case "COPY":
					oRow = objCl.copyRow(grid.getData(), Number(grid.getTable().getRowID()));
				break;
			}
			if(!oRow)
				break;
			editCl(sID, oRow, grid);			
			gridRefresh(grid, oRow.getID());	
		break;
	}
}

function editCl(sMode, oRow, grid)
{
	var form = "";
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = grid.getTable().getTableName();
	switch(String(grid.getData()))
	{
		case "education":
			form = "educ";
			break;
		case "familyties":
			form = "family";
			break;
		case "lastjob":
			form = "lwork";
			break;
		case "courses":
			form = "courses";
			break;
		case "leave":
			//если нет модуля CDRP, то отпускные не редактируем
			if(typeof CDR_OTP_NO != "undefined")
				form = "leave";
			break;
		case "oldshtat":
			form = "oldshtat";
			break;
		case "certification":
			form = "cert";
			break;
		case "discipl":
			form = "discipl";
			break;
	}
	if(form == "")
		return false;
	par.formFile = "cls/"+ objCl.sClassId +"/"+form+"/form.xml"; 	
	par.dpObj.hasExt = hasExt;
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	var id = oRow.getID();	
	if(inList(sMode, "ADD", "COPY"))
		objCl.appendRow(grid.getData(), oRow);

//	if(oRow.getVar("HMAIN")==true)
//		resetMainRs(id);
	obj2DB(id, oRow.jObj, null, grid.getTable().getTableName());
	//если есть параметр, то при редактировании предыдущих мест работы меняем дату выслуги
	if(grid.getData()=="lastjob" && getPar("CALCVISL"))
	{
		var tVisl = OpenTable("select * from "+grid.getTable().getTableName());
		var days = 0;
		for(; !tVisl.IsEOF(); tVisl.MoveNext())
		{
			if(toScrObj(tVisl.getValue("Fuseinvisl")))
				days += day_difference(tVisl.getValue("Fbdat"),tVisl.getValue("Fedat"));
		}
		tVisl.close();
		
		//если дата выслуги пустая и кол-во дней равно нулю, тогда оставляем как есть
		if(days!=0 || differ(new Date(HVISLDAT.value),d00obj)!=0)
		{
			var new_visl = goDay(HWRKDAT.value, -days);
			var old_visl = HVISLDAT.value;
			var msg = ru("Изменить дату выслуги","Змінити дату вислуги")+(differ(new Date(HVISLDAT.value),d00obj)!=0?ru(" с "," з ")+format("dd.mm.yyyy",old_visl):"")+format(" на dd.mm.yyyy?",new_visl);
			if(differ(new_visl,old_visl)!=0 && confirm(msg))
				HVISLDAT.value = new_visl;
		}
	}
	return true;
}

function hasExt()
{
	return false;
}

function gridRefresh(grid, fid)
{
	grid.getTable().requery();
	if(fid)
		grid.getTable().findByID(fid);		
	grid.setFocus();
	grid.refresh();
}

function storeBufToBase(strTableName)
{
	strTempTableName = arrTempTbl[String(strTableName)];
	ExecuteSQL("delete from ^" + strTableName 
				+ " where fwid_cl = " + sqlTo(objCl.getID()));
	var sFLD = GetPatternIntersection(strTableName, strTableName).replace(/(fwid\s*,)|(\s*fwid\W)/gi,"");
	var sSQL = "INSERT INTO ^" + strTableName + "(" + sFLD + ")"
			+ " SELECT " + sFLD + " FROM " + strTempTableName;
	ExecuteSQL(sSQL);	
			
}
include("sys/DpBaseDlg.js");