// JScript source code
include("Objects/DpCl.js")

var objCl = extPar.dpObj;
var ctrlLinker, oCl;
var ftxt_par="";
var fbdat_par=fedat_par=d00;
var fnorma_d_par=fnorma_ch_par=0;
var confirm_d = true;
var confirm_ch = true;

function Load()
{	
	Caption(objCl.getClTxt(extPar.Fcl)
			+ ": " + modeName(this.sMode))
	
	ctrlLinker = new DpCtrlLinker(objCl);	

	FCOD.setMask("###############");
	FNORMA_D.setMask("##.##");
	FNORMA_CH.setMask("###.##");
	FCLCL.mask="###";
	Disable(FCLCLTXT);
	oCl = new DpCl();
	oCl.linkCtrl(FCLCOD,FCLCODTXT);
	
	//инициализируем переменные из родительской записи
    var snap = getSnap("select cl1.Frel from ^clcl as cl1 inner join ^clcl as cl2 on cl1.Frel=cl2.Fcod "
    				+ " where cl1.Fcod="+extPar.Fcl+" and cl2.Fvid="+sqlTo("clnorm"))
    if(snap && snap[0])
    {
    	var tbl = OpenTable("select * from ^listclnorm where Fcl="+snap[0]+" and Fcod="+objCl.getVar("HIDPAR"))
    	if(!tbl.IsEmpty())
    	{
    		ftxt_par = tbl.getValue("Ftxt");
    		fbdat_par = tbl.getValue("Fbdat"); 
    		fedat_par = tbl.getValue("Fedat");
    		fnorma_d_par = Number(tbl.getValue("Fnorma_d"));
    		fnorma_ch_par = Number(tbl.getValue("Fnorma_ch"));
    	}
    	tbl.close();
    }
	
	ctrlLinker.addLink("HCOD", FCOD);
	ctrlLinker.addLink("HTXT", FTXT);
	ctrlLinker.addLink("HTXTS", FTXTS);
	ctrlLinker.addLink("HNORMA_D", FNORMA_D);
	ctrlLinker.addLink("HNORMA_CH", FNORMA_CH);
	ctrlLinker.addLink("HBDAT", FBDAT);
	ctrlLinker.addLink("HEDAT", FEDAT);
	ctrlLinker.addLink("HCLCL",FCLCL);
   	ctrlLinker.addClLink("HCLCOD",oCl);
	
	setValid(FBDAT,bdatValid);
	setValid(FEDAT,edatValid);
	
	setFocus(FTXT);	
		
	ctrlLinker.toControls();
	
	if (this.sMode == "ADD")
	{
		if(differ(fbdat_par,d00)!=0)
			FBDAT.value = fbdat_par;
		FEDAT.value = fedat_par;
		FTXT.value = ftxt_par;
	}
	else
	{
		if(this.sMode == "EDIT")
			FCOD.readOnly = !getPar("CHANGECOD");
		fclclValid();
		oCl.setClcl(objCl.getVar("HCLCL"));
		oCl.setCod(objCl.getVar("HCLCOD"));
	}
	
	setValid(FCLCL,fclclValid);
	setValid(FNORMA_D,norma_dValid);
	setValid(FNORMA_CH,norma_chValid);
	setWhen(FTXT,txtWhen);
    this.cl_selected = cl_selected;
    setButton(FCLCL, this, "cl_selected");
}

function onSave()
{
	var bOK,s, ts;
	s = "SELECT a.* FROM ^CL a"
		+" INNER JOIN ^CLRELCLCL b ON a.FWID=b.FWID_CL"
		+" WHERE b.FCOD=" + FCOD.getValue() + " AND b.FCL=" + objCl.getVar("HCL")
		+" and a.fwid <> "+ objCl.getID();
	ts = OpenTable(s);
	if( !ts.isEmpty() )
	{
		strError = ru("Запись с таким кодом уже существует"
			, "Запис із таким кодом вже існує");
		setFocus(FCOD);
		WAIT(strError);
		ts.close();
		return false;
	}
	ts.close();
	ctrlLinker.toVars();
}

function bdatValid()
{
	if(differ(FBDAT.value,d00)==0)
	{
		WAIT(ru("Дата начала не может быть пустой!", "Дата початку не може бути порожньою!"));
		return false;
	}
	if(differ(fbdat_par,d00)!=0 && differ(FBDAT.value,fbdat_par)<0)
	{
		WAIT(ru("Дата начала не может быть меньше, чем у родительской записи ", "Дата початку не може бути менша, ніж у батьківського запису ")+format("dd.mm.yyyy!",fbdat_par));
		return false;
	}
	return true;
}

function edatValid()
{
	if (differ(FEDAT.value, FBDAT.value)==-1)
	{
		WAIT(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	if(differ(fedat_par,d00)!=0 && differ(FEDAT.value,fedat_par)>0)
	{
		WAIT(ru("Дата окончания не может быть больше, чем у родительской записи ", "Дата закінчення не може бути більшою, ніж у батьківського запису ")+format("dd.mm.yyyy!",fedat_par));
		return false;
	}
	return true;
}

function fclclValid()
{
	if(FCLCL.value == 0)
	{
		var sMsg = UR("Не вказаний довідник!|Не указан справочник!");
		setFocus(FCLCL);
		FCLCL.showErr(sMsg);
		return false;
	}
	var Fcod = FCLCOD.value;
	oCl.setClcl(FCLCL.value);
	oCl.setCod(Fcod);
	var oSnap = getSnap("select Ftxt from ^CLCL where FCOD="+FCLCL.value);
	if(oSnap && oSnap[0])
		FCLCLTXT.value = UR(oSnap[0]);
	return true;
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FTXT = 0;
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	FCLCL.value = par.ret.FCOD;
	FCLCLTXT.value = UR(par.ret.FTXT);
}

function txtWhen()
{
	if(allt(FTXT.value)=="")
		FTXT.value = ftxt_par;
}

function norma_dValid()
{
	if(confirm_d && FNORMA_D.value!=0 && FNORMA_D.value==fnorma_d_par)
	{
		var msg = ru("Норма дней совпадает с родительской записью! Вы уверены, что так нужно?",
					"Норма днів збігається з батьківського записом! Ви впевнені, що так потрібно?");
		if(confirm(msg))
		{
			confirm_d = false;
			return true;
		}
		else
			return false;
	}
	return true;
}

function norma_chValid()
{
	if(confirm_ch && FNORMA_CH.value!=0 && FNORMA_CH.value==fnorma_ch_par)
	{
		var msg = ru("Норма часов совпадает с родительской записью! Вы уверены, что так нужно?",
					"Норма годин збігається з батьківського записом! Ви впевнені, що так потрібно?");
		if(confirm(msg))
		{
			confirm_ch = false;
			return true;
		}
		else
			return false;
	}
	return true;
}
include("sys/DpBaseDlg.js");