// JScript source code
include("Objects/DpCl.js");
include("Objects/DpOtpObsh.js");

var objCl = extPar.dpObj;
var ctrlLinker, oPers;

function Load()
{	
	Caption(objCl.getClTxt(extPar.Fcl)
			+ ": " + modeName(this.sMode))
	
	ctrlLinker = new DpCtrlLinker(objCl);	

	FCOD.setMask("###############");
	FTXT.setMask(strRepl("&", 255));
	
	var codpers = getPar("CODPERS");
	if(codpers==0)
 	{
 		alert(ru("В меню '"+getParItemPath("CODPERS", true)+"' установите код соответствующего справочника",
 				"В меню '"+getParItemPath("CODPERS", true)+"' встановіть код відповідного довідника"));
 		return false;
 	}
	oPers = new DpCl("", codpers, 0);
	oPers.linkCtrl(FTABN,FTXT_TABN);
	switch(this.sMode)
	{
		case "EDIT":
			FCOD.readOnly = !getPar("CHANGECOD");
			FDAT.setFocus();
		case "COPY":
			oPers.setFWID(objCl.getVar("HTABN_ID"));
			if(this.sMode=="COPY")
				FCOD.setFocus();
		break;
		case "ADD":
			FTABN.setFocus();
		break;
	}
	
	ctrlLinker.addLink("HCOD", FCOD);
	ctrlLinker.addLink("HTXT", FTXT);
	ctrlLinker.addLink("HDAT", FDAT);
	ctrlLinker.toControls();		
}

function onSave()
{
	objCl.setVar("HTABN_ID",oPers.getFWID())
	ctrlLinker.toVars();
}

include("sys/DpBaseDlg.js");