include("objects\\DpNmkl.js");
include("objects\\DpEdi.js");
include("sys\\DpBaseDlg.js");

var fgrpid, omesunit, odmesunit, oFedi_spr;

var oGroup = new DpNmkl();
var oNmkl = extPar.dpObj;

function Load()
{
	// Определимся с родительской группой
	
	
	oGroup.GroupOnly = true;
	oGroup.CanEmpty = true;
	oGroup.linkCtrl(mgroup, mgroup_text);	
	
	omesunit = new DpEdi("0");
	omesunit.setCod(0)
	omesunit.assocDpText(mesunit);
	
	odmesunit = new DpEdi("0");
	odmesunit.setCod(0)
	odmesunit.assocDpText(dmesunit);
		
	oFedi_spr = new DpEdi("0");
	oFedi_spr.setCod(0)
	oFedi_spr.assocDpText(fedi_spr);
	
	nds.setMask(MASK_SUM);

	
	sltImage.buttonHandler(document,"chooseImage");	
	setValid(sltImage ,validFileName);
		
	/*
	if (tbl.isEmpty())
	{
		fgrpid = extPar.nFolderID;
	}
	else if (extPar.mode=="ADDFLD" && toScrObj(tbl.getValue("FISGRP")))
	{
		fgrpid = tbl.getValue("FWID");
	}
	else
	{
		fgrpid = tbl.getValue("FGRPID");
	}
	*/ 

	fgrpid = oNmkl.getVar("HGRPID")
	
	if (fgrpid == -1)
		fgrpid = 0;		
	oGroup.setCod(fgrpid, false, "id");
	
	
	this.controlsLinker.addLink("HTXT0", FTXT);
	this.controlsLinker.addLink("HCOD", COD);
	
	this.controlsLinker.addClLink("HCEDIB", omesunit);
	this.controlsLinker.addClLink("HEDI1", odmesunit);
	this.controlsLinker.addClLink("HEDI_SPR", oFedi_spr);	
	this.controlsLinker.addLink("HVID", vid);
	this.controlsLinker.addLink("HIMGPATH", HIMGPATH);
	this.controlsLinker.addLink("HIMAGE", sltImage);
	this.controlsLinker.addLink("HNDS", nds);
	
	this.controlsLinker.toControls();
	
	setValid(HIMGPATH ,validPathName);
	if (extPar.sMode != "ADD")
	{
		/*
		FTXT.setValue(extPar.m_pTable.getValue("FTXT0"));		
		COD.setValue(extPar.m_pTable.getValue("FCOD"));
		
		omesunit.setCod(extPar.m_pTable.getValue("FCEDIB"));
		odmesunit.setCod(extPar.m_pTable.getValue("FEDI1"));
		oFedi_spr.setCod(extPar.m_pTable.getValue("FEDI_SPR"));
		
		vid.value = tbl.getValue("FVID");
		*/
				
		if (oNmkl.getID()==0)
		{
			Disable(COD);
			Disable(mgroup);
		}
		else
		{
			var tSubs = OpenTable("s",
					"SELECT *"
					+ " FROM ^cl_nmk"
				+ " WHERE fgrpid=" + oNmkl.getID()
				);
			
			if (!tSubs.IsEmpty())
			{
				Disable(COD);
				Disable(mgroup);
			}
		}
	}
	else
	{
		FTXT.setValue("");
		COD.setValue(nmk_getNextCod() + ".");
		if (oGroup.Fcedib)
			omesunit.setCod(oGroup.Fcedib);
		if (oGroup.Fedi1)
			odmesunit.setCod(oGroup.Fedi1);
		if (oGroup.Fedi_spr)
			oFedi_spr.setCod(oGroup.Fedi_spr)
		if (oGroup.Fvid)
			vid.value = String(oGroup.Fvid);		
		nds.value = oGroup.getNds();
	}
	
	var nmkImage = String(sltImage.value).trim();
	
	if(nmkImage)
	{
		if (isFile(nmkImage))
		{
			IMAGE.setFileName(nmkImage);
		}
		else
		{
			if(nmkImage.startsWith("/"))
				nmkImage = nmkImage.substr(1);
			var file = nmkGetImagePath() + "/" +  nmkImage;
			if (isFile(file))
				IMAGE.setFileName(file);
		}
	}
	
	setValid(COD,cod_valid);
	Caption(UR("Група номенклатури| Группа номенклатуры"));
}

function nmkGetImagePath()
{
	var ret = String(HIMGPATH.value).trim();
	
	if (ret)
		return ret;
	
	var snap = getSnap("SELECT fimgpath, fleftkey"
			+ " FROM ^cl_nmk"
			+ " WHERE fwid=" + oGroup.getCod()
			);
	
	if (snap)
	{
		if (snap[0] && snap[0].trim())
		{
			return snap[0].trim();			
		}
		
		
		var nLeftKey = snap[1];
		
		var tGroups = OpenTable("SELECT fimgpath  FROM ^cl_nmk "
				+ " WHERE fisgrp = " + sqlTrue 
				+ " and fleftkey < " + nLeftKey + " and frightkey > " + nLeftKey
				+ " order by fleftkey desc"
				);	
		
		while (!tGroups.isEOF())
		{
			ret = tGroups.getValue("fimgpath");
			if (!ret)
				ret = ""
			else
				ret = String(tGroups.getValue("fimgpath")).trim();
			
			if(ret)
				return ret;
			
			tGroups.moveNext()
		}
	}
		
	
	return ret;
}

var bufExt = new Object();

function onAfterLoad()
{
	for (var ctrl in this.extCtrlMap)
	{
		var alias = allt(ctrl.substr(0,ctrl.indexOf("_")));
		var label = allt(ctrl.substr(ctrl.indexOf("_") + 1));
		if (alias.substr(0,1) == "X" && alias.length == 1)
			alias = "#";
		if (alias == "" || label == "")
			continue;		
			
			
		bufExt[label] = toScrObj(oNmkl.getExt(label));
		
		/*
		var etable = extPar.tblSrc.GetTie(alias);
		if (etable == null)
			return;				
		
		bufExt[label] = toScrObj(etable.getValue(Number(this.sFWID),label));
		*/ 
	}	
}

function onSave()
{
	
	var m = new Object();
	m.FWID = oNmkl.getID();
	m.FCOD = COD.getValue();
	m.FTXTS = FTXT.getValue();
	m.FTXT0 = FTXT.getValue();
	m.FCEDIB = omesunit.getCod();
	m.Fedi1 = odmesunit.getCod();
	m.Fedi_spr = oFedi_spr.getCod();
	m.Fvid = vid.value;		
	
	m.FISGRP = true;
	if (m.FWID==0)
		m.FGRPID = -1;
	else
		m.FGRPID = oGroup.getFwid();

	UpdateTable("^cl_nmk", m, extPar.sMode != "EDIT");
	
	this.controlsLinker.toVars();
	oNmkl.setVar("HISGRP", true);
	oNmkl.setVar("HGRPID", m.FGRPID);
	oNmkl.setVar("HTXTS", m.FTXTS);
	
	
	var treeKeys = updateTreeKeys("^cl_nmk", m.FWID, new Array("fcod", "ftxts"));
	
	oNmkl.setVar("HLEFTKEY", treeKeys.leftKey);
	oNmkl.setVar("HRIGHTKEY", treeKeys.rightKey);
	oNmkl.setVar("HGRPDEEP", treeKeys.grpDeep);
	
	extPar.treePar.addFwid = m.FWID;
	//extPar.treePar.addTxt = m.FTXTS;
	extPar.treePar.addTxt = m.FCOD + ": " + m.FTXTS;
	extPar.treePar.addFgrpid = m.FGRPID;
	extPar.nFolderID = m.FGRPID;
	
	// Проверка, изменились ли расширения
	for (var ctrl in this.extCtrlMap)
	{
		var alias = allt(ctrl.substr(0,ctrl.indexOf("_")));
		var label = allt(ctrl.substr(ctrl.indexOf("_") + 1));
		if (alias.substr(0,1) == "X" && alias.length == 1)
			alias = "#";
		if (alias == "" || label == "")
			continue;		

		var newVal = toScrObj(this.extCtrlMap[ctrl].getValue());
			
		//var etable = extPar.tblSrc.GetTie(alias);
		//if (etable == null)
		//	return;
				
		//alert(label + ", "+ bufExt[label] + "="+newVal)
		if (bufExt[label] != newVal)
		{
			updateExtF(null, label, bufExt[label], newVal);
		}
	}		
}

// Обновить расширение для группы
// Нужно сделать по-людски, чтобы спрашивало, нужно ли изменять значения и т.д....
function updateExtF(etable, label, prevVal, newVal)
{
	var tSubNmk = OpenTable("m",
		"SELECT *"
		+ " FROM ^cl_nmk"
		+ " WHERE fleftkey>" + oNmkl.getVar("HLEFTKEY")
			+ " AND frightkey<" + oNmkl.getVar("HRIGHTKEY")
		)
	
	tSubNmk.ExtTie("CL_NMK");

	for (; !tSubNmk.IsEOF(); tSubNmk.MoveNext())
	{
		var etable = tSubNmk.GetTie("#");
		etable.setValue(Number(tSubNmk.getValue("fwid")), label, newVal);
	}
}

function cod_valid()
{
	var codValue = String(COD.getValue());
	if (oNmkl.getID()!=0 && (codValue == null || codValue == ""))
	{
		COD.showErr("Введіть код групи|Введите код группы");
		return false;
	}
	
	var sSQL = "SELECT Fcod FROM ^cl_nmk"
				+ " WHERE Fcod=" + sqlTo(codValue)
				+ " AND Fwid<>" + sqlTo(oNmkl.getID());
	var oSnap = getSnap(sSQL);
	if (oSnap != null)
	{
		COD.showErr("Номенклатура з таким кодом вже існує|"
				+ "Номенклатура с таким кодом уже существует");
		return false;
	}
	
	if (oGroup.getCod("c") 
		&& String(COD.getValue()).substr(0, String(oGroup.getCod("c")).length) != oGroup.getCod("c")
		)
	{
		COD.showErr("Код товара должен начинаться с кода группы '" + oGroup.getCod("c") + "'");
		return softInvalid;
	}
		
	return true;
}

function nmk_getNextCod()
{
	var sSQL = "SELECT MAX(FCOD)"
			   + " FROM ^cl_nmk"
			   + " WHERE FGRPID=" + fgrpid
				   + " AND FISGRP<>0"
			   
	var parCode = "";
	if (fgrpid != 0)
	{
		var parSnap = getSnap("SELECT FCOD "
							+ " FROM ^cl_nmk "
							+ " WHERE FWID=" + sqlTo(Number(fgrpid)));
		if (parSnap != null && parSnap[0] != null)
			parCode = parSnap[0];
	}

	var oSnap = getSnap(sSQL);
	if (oSnap == null)
	{
		return parCode + first0("1");
	}
	var maxCode = String(oSnap[0]);
	
	var nInd = maxCode.substr(0, maxCode.length-1).lastIndexOf(".");
	if (nInd != -1)
		maxCode = maxCode.substr(nInd + 1);
	if (isNaN(parseFloat(maxCode)))
		return parCode + first0("1");
	return parCode + first0(String(parseFloat(maxCode) + 1));
}

function chooseImage()
{
	 
	//var strPath = lpProxy.openFile(new Array("All Files", "BMP Files", "GIF Files", "JPEG Files")
	//								, new Array("*.bmp;*.jpg;*.jpeg;*.gif", "*.bmp", "*.gif", "*.jpg;*.jpeg"));
	
	var strPath = BrowseForFile("*.bmp;*.jpg;*.jpeg;*.gif|*.bmp|*.gif|*.jpg;*.jpeg"
			, "All Files|BMP Files|GIF Files|JPEG Files", nmkGetImagePath());
	if(!strPath)
		return;
		
	var file = new DpFile(strPath);
	var fileName = file.getAbsolutePath();
	IMAGE.setFileName(fileName);
	validFileName(fileName);
	
}

function validFileName(fileName)
{
	if (typeOf(fileName) != "String")
		fileName = sltImage.value;
	
	fileName = new java.lang.String(fileName);
	if (fileName.startsWith("\\\\"))
		fileName = fileName.substring(0, 2) + fileName.substring(2).replace("\\", "/");
	else	
		fileName = fileName.replace("\\", "/");
	
	
	var sPath = nmkGetImagePath();
	
	if (fileName.startsWith(sPath))
		fileName = fileName.substring(sPath.length);
	
	if (fileName.startsWith("/"))
		fileName = fileName.substr(1);
	
	sltImage.value = String(fileName);
	
}

function validPathName()
{
	fileName = HIMGPATH.value;	
	fileName = new java.lang.String(fileName);
	if (fileName.startsWith("\\\\"))
		fileName = fileName.substring(0, 2) + fileName.substring(2).replace("\\", "/");
	else
	{
		fileName = fileName.replace("\\", "/");
	}
	
	HIMGPATH.value = String(fileName);	
}

function first0(cod)
{
	while (cod.length < 3)
		cod = "0" + cod;
	return cod;
}