
var sTxt = "Очистка тимчасової бази|Очистка временной базы";
var tmpTblName = "TMP_CLEAR";

function listLoad()
{
	this.title = sTxt;
	this.startClear = startClear;	
	this.closeWnd = closeWnd;
	setButton(btnRUN, this, "startClear");
	setButton(btnCLOSE, this, "closeWnd");
	setButton(btnCLOSETmp, this, "closeWnd");
		
	createClearTbl(tmpTblName);
}

function listAfterLoad()
{
	loadUsers();
}

function listSrc()
{
	this.qrySet("From", tmpTblName
				,"Order", "FBASE");
}

function listDpGrid()
{
	with(grid)
	{
		FieldEx("FUSER", "Користувач|Пользователь", 15);
		FieldEx("FROWS", "Таблиць|Таблиц", 8);
	}
	grid.build();
}

function listMenuInit()
{
	if(!grid.getTable().isEmpty())
		grid.AddMenuItem("CLEAR", "Очистити|Очистить");
	grid.AddMenuItem("", "");
}

function listMenuRun(sID)
{
	if(sID=="CLEAR")
	{
		var user = this.tbl.getValue("FUSER");
		WAIT(UR(sTxt) +" : "+ user);
		clearUserBase(user);
		ExecuteSQL("update "+ tmpTblName +" set FROWS=0 where FUSER="+ sqlTo(user));
		grid.getTable().requery();
		grid.refresh();
	}
}

function createClearTbl(sTblName)
{
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("delete from "+ sTblName, false);
	var sSQL = "CREATE TABLE "+ sTblName
			   + "("
			   + " FWID "+ SqlType("COUNTER")
			   + ",FUSER "+ SqlType("TEXT", 20) +" default ''"
			   + ",FBASE "+ SqlType("TEXT", 20) +" default ''"
			   + ",FROWS "+ SqlType("INT") +" default 0"
			   + ")";
	ExecuteSQL(sSQL, false);
}

function loadUsers()
{
	var sAdminFile = lpProxy.getAdminMng().getAdministrationFile();
	var docAdmin = lpProxy.openXmlFile(sAdminFile);
	var mainElem = docAdmin.getDocumentElement();
	var logList = mainElem.getElementsByTagName("LOGIN");
	PROGRESS.setMinimum(0);
	PROGRESS.setMaximum(logList.length);
	PROGRESS.setSelection(0);
	for(var i=0; i<logList.length; i++)
	{
		var user = logList.item(i).getAttribute("value");
		if(user==null || user=="")
			continue;
		progressWorked(UR("ЗАВАНТАЖЕННЯ: |ЗАГРУЗКА: ") + user);
		var tableCount = 0;
		var shcema = lpProxy.getDBTemp(user);
		if(!shcema || shcema=="")
			shcema = user;
		var listTables = lpProxy.getDBManager().getTables(shcema, "TABLE");
		if(listTables)	
			tableCount = listTables.length;
		var sSQL = "INSERT INTO " + tmpTblName
				   	+ " (FUSER,FBASE,FROWS)"
				   	+ " VALUES("
				   		+ sqlTo(user)	
				   		+","+ sqlTo(shcema)				   		
				   		+","+ sqlTo(tableCount)				   		
				   	+ ")";
		ExecuteSQL(sSQL);
		grid.getTable().requery();
		grid.refresh();	
	}
	PROGRESS.setSelection(0);
	FSTATUS.setText("");
	grid.getTable().requery();
	grid.refresh();
}

function startClear()
{
	var sWhere = "";
	var arrSel = grid.getSelectedIDs();	
	if(arrSel.length>0)
		sWhere = " where "+ grid.sqlSelected();
	var tblClear = OpenTable("select * from "+ tmpTblName + sWhere); 
	for(tblClear.MoveFirst(); !tblClear.isEOF(); tblClear.MoveNext())
	{
		var sLogin = tblClear.getValue("FUSER");
		WAIT(UR(sTxt) +" : "+ sLogin);
		PROGRESS.setMinimum(0);
		PROGRESS.setMaximum(Number(tblClear.getValue("FROWS")));
		PROGRESS.setSelection(0);
		progressWorked("ОЧИСТКА: "+ sLogin);
		clearUserBase(sLogin);
		ExecuteSQL("update "+ tmpTblName +" set FROWS=0 where FBASE="+ sqlTo(sLogin));
	}
	tblClear.close();
	var sMsg = UR("Очистку завершено|Очистка завершена");
	FSTATUS.setText(sMsg);
	PROGRESS.setSelection(0);
	WAIT(sMsg);
	grid.getTable().requery();
	grid.refresh();
}

function clearUserBase(sLogin)
{
	//07.12.12 Яна
	// В БЦ водоканале позже, чем в последней версии в CVS изменена эта программа. Раз там сделали
	//эти изменения, заношу их под CVS, но точно не знаю, нужны ли они для всех.
	if(SUBD==ORACLE)
	{
		//Очистка корзины
		//ExecuteSQL("PURGE DBA_RECYCLEBIN");
	}
	
	var shcema = lpProxy.getDBTemp(sLogin);
	if(!shcema || shcema=="")
		shcema = sLogin;
	var listTables = lpProxy.getDBManager().getTables(shcema, "TABLE");	
	var listViewes = lpProxy.getDBManager().getTables(shcema, "VIEW");
	var nView = listViewes.length;
	var nTable = listTables.length + nView;
	var point = (SUBD == MSSQL ? ".." : ".");
	progressWorked(sLogin);
		
	for (var i in listViewes)
	{		
		progressWorked(sLogin);
		if(String(listViewes[i]).toUpperCase() === tmpTblName.toUpperCase())
			continue;
		var fullTableName = shcema + point + listViewes[i];
		//ExecuteSQL("DROP VIEW " + fullTableName + " CASCADE", false);
	}	
	
	for (var i in listTables)
	{		
		progressWorked(sLogin);
		if(String(listTables[i]).toUpperCase() === tmpTblName.toUpperCase())
			continue;
		var fullTableName = shcema + point + listTables[i];
		if (left(String(listTables[i]).toUpperCase(),4)=="TEMP" && listTables[i].indexOf("_")>0 ){
		//ExecuteSQL("DROP TABLE " + fullTableName, false);
		  ExecuteSQL("DROP TABLE " + fullTableName + " CASCADE", false);
		}  
		//if (left(String(listTables[i]).toUpperCase(),5)=="TEST_" && listTables[i].indexOf("_")>0 ){
		//ExecuteSQL("DROP TABLE " + fullTableName, false);
		//  ExecuteSQL("DROP TABLE " + fullTableName + " CASCADE", false);
		//}  
	}
	
	if(SUBD==ORACLE)
	{
		//Очистка корзины
		//ExecuteSQL("PURGE DBA_RECYCLEBIN");
	}
}

function progressWorked(sText)
{
	display.syncExec
	(
		function worked()
		{			
			try
			{
				var nPr = PROGRESS.getSelection()+1;
				PROGRESS.setSelection(nPr);
				PROGRESS.setToolTipText(String(nPr));
				if(sText)
					FSTATUS.setText(sText);
			}
			catch(ex)
			{
				//alert(ex);
			}
		}
	);
	display.update();
}

function closeWnd()
{
	CloseWindow();
}

include("sys/DpList.js");