
function DpDocRegAttrs()
{
	this.getRegAttr = DpDocRegAttrs_getRegAttr;
	this.setRegAttr = DpDocRegAttrs_setRegAttr;
	this.getRegNums = DpDocRegAttrs_getRegNums;
	this.getRegistrator = DpDocRegAttrs_getRegistrator;
	this.getRegValue = DpDocReg_getRegValue;
	this.editRegAttr = DpDocReg_editRegAttr;
}

function DpDocRegAttrs_getRegistrator()
{
	if (this.oReg == null)
	{
		include("objects/DpJRegistrator.js");
		this.oReg = new DpJRegistrator(this.sDocLbl,this.nNop,"US");
	}
	return this.oReg;
}

function DpDocRegAttrs_getRegAttr(nReg,sAttr)
{
	var oRet = this.jDoc.getRegAttr(nReg,sAttr);
	if (oRet == null)
	{
		oRet = this.getRegistrator().getValue(nReg,sAttr);
	}
	return oRet;
}

function DpDocRegAttrs_setRegAttr(nReg,sAttr,oVal)
{
	this.jDoc.setRegAttr(nReg,sAttr,oVal);
}

function DpDocRegAttrs_getRegNums()
{
	if (this.arrRegNums != null) return this.arrRegNums;  
	var arRet = new Array();
	var arrJ = this.getRegistrator().listRegJournals(true);
	this.getRegistrator().listJournals(true);
	for (var jID in arrJ)
	{
		var oJ = this.getRegistrator().listJournals()[jID];
		if (!oJ)
			continue;
		if (strIn("S",oJ.getType()))
		{
			arRet[arRet.length] = oJ;
		}
	}
	
	this.arrRegNums = arRet.sort(sortJournal);
	return this.arrRegNums;
}

function sortJournal(j1, j2)
{
	return differ(String(j1.Num), String(j2.Num));
}

function DpDocReg_getRegValue(jID,sVar)
{
	jID = String(jID).toUpperCase();
	var arrJ = this.getRegistrator().listRegJournals();
	if (!arrJ[jID])
		return null;
	var oJ = this.getRegistrator().listJournals()[jID];
	var sTbl = oJ.getFullTableName();
	
	var sSQL = "SELECT " + sVar
			 + " FROM " + sTbl
			 + " WHERE HREG=" + sqlTo(jID)
			 + " AND HID_DOC=" + sqlTo(this.getID());
	var oSnap = getSnap(sSQL);
	return (oSnap == null?null:oSnap[0]);
}

function DpDocReg_editRegAttr()
{
	var	par = new Object();
	par.docForReg = this;	
	par.mode = "EDIT";
	//par.hasTab = true;	
	showWindow("e_docRegAttr.xml",SW_MODAL, par)
	if (!par.escape)
		this.save(false, par.mode, false, true);
	return !par.escape;
}