include ("objects\\DpEval.js")

function DpDocRow(oParentDoc,jDocRow)
{
	derive(this, DpDoc);
	this.sClassId = jDocRow.getClassID();
	this.parent = oParentDoc;
	this.edit = DpDocRow_edit;
	var eval = new DpEval();
	this.jDocRow = jDocRow;
	this.jDoc = this.jDocRow;
	this.jDocRow.setEvaluator(eval);
	this.sDocLbl = "";
	
	this.setVar = oParentDoc.setVar;
	this.getVar = oParentDoc.getVar;
	this.eval = oParentDoc.eval;
	this.setID = DpDocRow_setID;
	this.getID = oParentDoc.getID;
	
	this.formFile = "docs/" + this.parent.sDocLbl 
	+ "/" + this.sClassId + "/form.xml";
	this.fifoFormFile = "docs/" + this.parent.sDocLbl 
	+ "/" + this.sClassId + "/fifo_form.xml";
	
	if (String(this.parent.jDoc.getModuleID()) == "")
	{
		this.formFile = "docs/" + this.parent.sDocLbl 
				+ "/" + this.sClassId + "/form.xml";
	}
	else
	{
		this.formFile = this.parent.jDoc.getModuleID() + ":docs/" 
				+ this.parent.jDoc.getShortClassID() + "/" + this.sClassId + "/form.xml";;
	}
	/*
	//Для наследуемых строк форма может лежать в папке родителя
	if(!isFile(this.formFile) && !isFile(rootDirectory() + this.formFile))
	{
		var sDir = this.jDoc.getClassDescriptionDir();
		sDir = sDir.substring(rootDirectory().length());
		this.formFile = sDir +"/form.xml";
	}
	*/
	this.getParent = DpDocRow_getParent;

	this.setAttribute = oParentDoc.setAttribute;
	this.getAttribute = oParentDoc.getAttribute;
	this.getJObject = DpDocRow_getJObject;
	this.setAbsFormFile = DpDocRow_setAbsFormFile;
}

function DpDocRow_setID(nID)
{
	this.nID = nID;
	this.jDocRow.setObjectID(nID);
	//this.jDocRow.setVar("RID",nID);
	
}

function DpDocRow_getParent()
{
	return this.parent;
}

function DpDocRow_edit(sMode, par)
{
	var fform = this.formFile;
	if(!par)
		par = new Object();
	par.obj = this;	
	par.fifomode = sMode;	
	if (sMode == "FIFOADD" || sMode == "FIFOEDIT")
	{
		if (sMode == "FIFOADD")
			sMode = "ADD";
		else
			sMode = "EDIT";
		par.bFifo = true;
		if (!(new DpFile(rootDirectoryEx() + "scripts/" + this.fifoFormFile).exists()))
			this.fifoFormFile = "docs/fifo_form.xml";			
		fform = this.fifoFormFile;
	}
	par.mode = sMode;
	par.parentWnd = display.getActiveShell();
	if (IS_WEB) //TODO:
		par.hasTab = true;
		
	showWindow(fform,"XMLDLG",par);
	return !par.escape;	
}

function DpDocRow_getJObject()
{
	return this.jDocRow;
}

function DpDocRow_setAbsFormFile(formFile)
{
	this.formFile = formFile;
}