include("objects\\DpCl.js");
include("objects\\DpSc.js");
include("objects\\DpVal.js");
include("objects\\DpNmkl.js");
include("objects\\DpUCena.js");
include("Objects\\DpClNo.js");
include("Objects\\DpKolFas.js");
include("Objects\\DpMsgBox.js");
include("sys\\dpsql.js");
include("sys\\dbase.js");
include("mtr_ost.js");

var Fid_pn = 0; 
var nMaxKol = null;		//остаток
var Fsc, Fsu, Fst;

var bFocus = false;
var bNew = true;		//активная строка
var load = true;
var otpsel_Proc = 0; 	//процент наценки при выборе отпускной цены 
var Fis_otl = false;
//////////////////////////параметры документа:
var getot;				//"Разрешить редактировать цену отпуска"
var iOtpsel;			//"Способ ввода отпускной цены"
var vipneg;				//"Разрешено выписывать в 'минус'"
var showan;				//показывать ли аналитики

//////////////////////////
 
function DpNkRow(obj)
{		
	this.obj = obj;
	this.Fnmkvid = '';
	this.Fedi = 0;		
	
	this.oNmkl = new DpNmkl();
	this.oNmkl.SetNakl(this.obj.parent);
	
	this.objKol = new DpKolFas(); //объект ввода количества с фасовками
	this.objKol.setNmkl(this.oNmkl);
	this.objKol.InitEmpty();	
	if(typeof(Fkol)!="undefined")
		this.objKol.linkCtrl(Fkol);
	
	this.load = DpNkRow_load;
	this.save = DpNkRow_save;	
	this.check_Fsum = check_Fsum;
	this.EnableTara = EnableTara;
	this.check_Ftara = check_Ftara;
	this.check_Fedi = check_Fedi;
	this.make_Otpcena = make_Otpcena;
	this.focus_Otpcena = focus_Otpcena;	
	this.blur_PostPrice = blur_PostPrice;
	this.obj.make_Otpcena = make_Otpcena;
	this.zaval_Fnmkl = DpNkRow_zaval_Fnmkl;
	this.Fnmkl_valid = DpNkRow_Fnmkl_valid;
	this.Fcena = check_Fcena;
	this.parChange = nk_parChange;
	this.getNextRowNum = DpNkRow_getNextRowNum;
	this.calc_discount = DpNkRow_calc_discount;
	this.discount_valid = DpNkRow_discount_valid;
	
	rnk = this;
}

function DpNkRow_load()
{				
	iOtpsel = this.obj.parent.getPar("_otpsel");
	getot = this.obj.parent.getPar("__getot");
	vipneg = this.obj.parent.getPar("_vipneg");
	showan = this.obj.parent.getPar("_showan");	//показывать ли аналитики
	//перестрахуемся:
	if(typeof(showan)=="undefined" || showan==null)
	{
		showan = null;
	}
	
	if(typeof(tFnmkl)=="undefined")
	{
		this.oNmkl.linkSmartCtrl(Fnmkl,tFedi, this, null, "zaval_Fnmkl");
	}
	else
	{
		this.oNmkl.linkCtrl(Fnmkl,tFnmkl,tFedi, null, this, null, "zaval_Fnmkl");
		this.oNmkl.setContAssist();
	}
		
	this.oPost = new DpCl("0");
	this.oPodr = new DpCl("0");
	this.oMol  = new DpCl("0");
	this.oPost.setClcl(getPar("CODPLAT"));
	this.oPodr.setClcl(sprPodr);	
	this.oMol.setClcl(sprMol);
	//this.oPost.setCod(this.obj.parent.getVar("HPLCH"));
	this.oPost.setCod(this.obj.parent.getVar("HPOST"));
	this.oPodr.setCod(this.obj.parent.getVar("HPODR"));
	this.oMol.setCod(this.obj.parent.getVar("HMOL"));

	
	var scModeSuff = "";
	if(showan)
	{
		scModeSuff = "xyz";
	}
	this.oSc   = new DpSc("cut"+scModeSuff);
	this.oSc1  = new DpSc("cut");

	if(showan)
	{
		this.oSc.linkCtrl(Fsc, Fsu, Fst, Fcod1, Fcod2, Fcod3);
	}
	else
	{
		this.oSc.linkCtrl(Fsc, Fsu, Fst);
	}
		
	if (typeof tFvcod!="undefined")
	{
		oVal = new DpVal();
		oVal.linkCtrl(tFvcod);	
	}
	objVal = new DpVal();
	
	ctrlLinker = new DpCtrlLinker(this.obj);
		
	Fkol.mask = MASK_KOL;
	ctrlLinker.addLink("RKOL",Fkol);		
	if (typeof Fvcena!="undefined")
	{
		Fvcena.mask = MASK_CENA;
		ctrlLinker.addLink("RVCENA",Fvcena);
	}	
	
	if (typeof Fnom_str!="undefined")
	{
		Fnom_str.mask = "####";		
		ctrlLinker.addLink("RNOM",Fnom_str);						
	}			
	if (typeof F1cena != "undefined")
	{
		var sDoc = String(this.obj.parent.getVar("HDOC"));
		F1cena.mask = MASK_CENA;
		if (sDoc != "SM")
			ctrlLinker.addLink("RPCENE",F1cena);		
	}
	
	if (typeof Fcena != "undefined")		
	{
		oCena = new DpUCena(this.obj);
		Fcena.mask = MASK_CENA;		
		oCena.linkCtrl(Fcena);
		if(typeof Fsn != "undefined")
			oCena.linkCtrlSN(Fsn);	
		ctrlLinker.addLink("RUCENA",Fcena);	
		//setValid(Fcena, make_Otpcena);
	}	
	if (typeof Ffactcena != "undefined")
	{
		Ffactcena.mask = MASK_CENA;
		Ffactcena.value = tanf(this.obj.getVar("R1ID"),"1cena");		
		Disable(Ffactcena);		
	}
	
			
	if (extPar.mode == "ADD")
	{
	    if(showan)
	    {
			this.oSc.set(this.obj.parent.getVar("HSC"),
				this.obj.parent.getVar("HSU"),
				this.obj.parent.getVar("HST"),
				this.obj.parent.getVar("HA1"),
				this.obj.parent.getVar("HA2"),
				this.obj.parent.getVar("HA3")
				);
	    }
	    else
	    {
			this.oSc.set(this.obj.parent.getVar("HSC"),
				this.obj.parent.getVar("HSU"),
				this.obj.parent.getVar("HST"));
	    }
		this.oPodr.setCod(this.obj.parent.getVar("HPODR"));
		this.oMol.setCod(this.obj.parent.getVar("HMOL"));
	}
	else
	{
		bNew = false;
	    if(showan)
	    {
			this.oSc.set(this.obj.getVar("RSC"),
				this.obj.getVar("RSU"),
				this.obj.getVar("RST"),
				this.obj.getVar("RA1"),
				this.obj.getVar("RA2"),
				this.obj.getVar("RA3")
				);
	    }
	    else
	    {
			this.oSc.set(this.obj.getVar("RSC"),
				this.obj.getVar("RSU"),
				this.obj.getVar("RST"));	
	    }
		this.oPodr.setCod(this.obj.getVar("RPODR"));
		this.oMol.setCod(this.obj.getVar("RMOL"));
		this.oPost.setCod(this.obj.getVar("RPOST"));
	}
	if(typeof oVal != "undefined")
		oVal.setCod(this.obj.getVar("R1SVAL"));		
	//this.objKol.loadFromTable(this.obj.getVar("REDIF"));
	this.objKol.setEdiFas(this.obj.getVar("REDIF"));
	if(this.obj.getVar("RTNMK"))
	{
		this.oNmkl.setCod(this.obj.getVar("RTNMK"));
		if(this.oNmkl.Fvid == "S" && this.obj.getVar("RKOL") == 0)
		{
			this.obj.setVar("RKOL", 1);
		}
		rnk.oldNmkl = this.obj.getVar("RTNMK");
	}
	
	
						
			

	if (typeof Fkol_spr != "undefined")
	{
		Fkol_spr.mask = MASK_KOL;
		ctrlLinker.addLink("RKOLSPR",Fkol_spr);		
		Disable(Fkol_spr);	
	}
	////////////////////////////////////////////
	ctrlLinker.updateData(false);
	////////////////////////////////////////////
	
	if(typeof Fsum!="undefined")
	{
		Fsum.mask = MASK_SUM;
		ctrlLinker.addLink("RSUM",Fsum);
		
		setValid(F1cena, check_Fsum);
		setValid(Fkol, check_Fsum);					
	}

	if(!bNew)
	{
		//var bFocus = false;
		/*
			если редактировать отпускную цену
			нельзя, но она вычисляется по процентам -
			процент нужно запросить здесь и пересчитать
			цену, но обработчик для этих случаев вызывается
			только по фокусу, поэтому нужно искусственно
			установить параметр
		*/
		if(!getot && (iOtpsel==3	|| iOtpsel==4))
			bFocus = true;
	}
	
	var toValidF1cenasnds = false;
	
	if (typeof F1cenasnds!="undefined")
	{
		toValidF1cenasnds = true; 	
		F1cenasnds.mask = MASK_CENA;
	}
	
	//в ряде случаев цену редактировать нельзя
	if(iOtpsel==1 || iOtpsel==2 || iOtpsel==5)
	{
		//если разрешено редактировать в параметрах, то разрешаем редактировать
		if (!getot) 
		{
			if (typeof F1cena != "undefined")
			{
				if(typeof otpcena=="undefined")
					Disable(F1cena);				
			}
			if (typeof F1cenasnds != "undefined")
			{
				toValidF1cenasnds = false;
				Disable(F1cenasnds);
			}
		}		
	}
	
	if (toValidF1cenasnds)
		setValid(F1cenasnds, F1cenasnds_valid)
	
	if (typeof otpcena != "undefined")
	{		
		if (!getot && iOtpsel!=0) 		
			Disable(otpcena);
		
		if(	iOtpsel==3 || iOtpsel==4 || iOtpsel==2)
		{
			setWhen(otpcena, this, "focus_Otpcena");
			setValid(otpcena, check_Fsum);
		}			
	}
		
	if (nMaxKol == null)
		nMaxKol = this.obj.getVar("ROST");
	if(typeof oCena != "undefined")
		nMaxKol = oCena.nMaxKol;
	
	if (EnableTara())
		this.Fnmkvid = FTARA.value = (this.obj.getVar("RNMKVID") != "O")? "" : "O";		
	
	if (typeof FTARA!="undefined")
		setValid(FTARA, check_Ftara);
		
	if(typeof Fnmkl!="undefined")	
		setValid(Fnmkl, rnk.Fnmkl_valid);
			
	if(typeof tFedi!="undefined")
		setValid(tFedi, this.check_Fedi);	
		
	if (typeof Fkekv!="undefined")
	{
		nKekv = getPar("CODKEKV")
		if (nKekv)
		{
			var oKekv = new DpCl("0");
			oKekv.setClcl(nKekv);
			oKekv.linkCtrl(Fkekv)
			ctrlLinker.addClLink("RKEKV",oKekv);
		}
		else
		{
			if (typeof KEKVGROUP !="undefined")
			{
				KEKVGROUP.visible = false;
			}
		}
	}
	
	if (typeof FDISCOUNT!="undefined")
	{
		FDISCOUNT.mask = "###.####";
		ctrlLinker.addLink("RDISCOUNT", FDISCOUNT);
		if(extPar.mode=="ADD")
			FDISCOUNT.value = rnk.obj.parent.getVar("HDISCOUNT");
		if (typeof FDISCOUNT_SUM!="undefined")
		{
			FDISCOUNT_SUM.mask = MASK_SUM;
			setValid(FDISCOUNT, this, "discount_valid");
			setValid(FDISCOUNT_SUM, this, "discount_valid");
		}
		if (typeof FSUM_DISCOUNT!="undefined")
		{
			FSUM_DISCOUNT.mask = MASK_SUM;
			setValid(FSUM_DISCOUNT, this, "discount_valid");
		}
		this.discount_valid(FDISCOUNT);
	}
	
	//this.check_Fedi();
	this.parChange();
	this.Fnmkl_valid();
	//this.make_Otpcena();	
	this.check_Fsum();
	
	/*
	if (extPar.fnmkl)
	{
		this.oNmkl.setCod(extPar.fnmkl);
	}
	*/

	if (extPar.isMass)
	{
		setFocus(Fkol)
	}
	else if(typeof(Fnmkl)!="undefined" && (typeof(extPar.disableFocusNmk)=="undefined" || extPar.disableFocusNmk==false))
	{
		setFocus(Fnmkl);
	}
	//ert();
}

function nk_parChange()
{
	var ecodnmk = this.obj.parent.getPar("_ecodnmk");
	var elcodnmk = this.obj.parent.getPar("_elcodnmk");
	var etextnmk = this.obj.parent.getPar("_etextnmk");
	
	var mode = "";
	if (ecodnmk)
		mode += "c";
	if (elcodnmk)
		mode += "l";
	if (etextnmk)
		mode += "t";
	
	rnk.oNmkl.setMode(mode); 
	rnk.oNmkl.UpdateCtrl();
}

function check_Fedi()
{
	if(load && extPar.mode != "ADD")
	{
		rnk.Fedi = rnk.oNmkl.Fedi = Number(rnk.obj.getVar("REDI"));		
		ComboBox_SetIndex(tFedi,rnk.oNmkl.Fedi)
	}
		
	var oldFedi = rnk.oNmkl.Fedi;
	rnk.oNmkl.setEdi();	
	rnk.Fedi = rnk.oNmkl.Fedi;
	
	var kf = Number(rnk.oNmkl.Fedikf1);
	kf = (kf != 0 && kf != null)? kf : 1;	
		
	if((oldFedi==0 || load) && rnk.oNmkl.Fedi==1)
	{
		Fkol.value = Number(Fkol.value) / kf;
		if(typeof Fcena != "undefined")
			Fcena.value	*= kf;
		if(typeof F1cena != "undefined")
			F1cena.value *= kf;
		if(typeof Fcenapr != "undefined")
			Fcenapr.value *= kf;
		if(typeof Fvcena != "undefined")
			Fvcena.value *= kf;
		if(typeof Fcenaspr != "undefined")
			Fcenaspr.value *= kf;
		if(typeof Ffactcena != "undefined")
			Ffactcena.value	*= kf;
		if(typeof Foldcena != "undefined")
			Foldcena *= kf;
	}
	else if(oldFedi==1 && rnk.oNmkl.Fedi==0)
	{
		Fkol.value *= kf;
		if(typeof Fcena != "undefined")
			Fcena.value	/= kf;
		if(typeof F1cena != "undefined")
			F1cena.value /= kf;
		if(typeof Fcenapr != "undefined")
			Fcenapr.value /= kf;
		if(typeof Fvcena != "undefined")
			Fvcena.value /= kf;
		if(typeof Fcenaspr != "undefined")
			Fcenaspr.value /= kf;
		if(typeof Ffactcena != "undefined")
			Ffactcena.value	/= kf;
		if(typeof Foldcena != "undefined")
			Foldcena /= kf;		
	}
	if(!load)
		rnk.make_Otpcena();
	rnk.check_Fsum();
	load = false;
}

function blur_PostPrice()
{
	if(iOtpsel==2)
		/*
			отпускная цена равна цене поставщика
		*/
		otpcena.value = F1cena.value;
}

function focus_Otpcena()
{
	rnk.make_Otpcena(true);
}

//	установка F1cena
function make_Otpcena(bFocus)
{
	if(typeof otpcena == "undefined")
		return;
		
//?	if (!getot && !ptrDpMass 
//		&& !Fnmkl.isChanged() && otpcena.value != 0)
//		return;

	/*
		при ручном выборе тупо выходим
	*/
	
	if(iOtpsel==0)
		return;
	/*
		прайс - снимем цену с номенклатуры
	*/
	else if(iOtpsel==1)
	{
		var nds = Number(rnk.obj.parent.getVar("HPNDS"));		
		if(nds!=0)
			nds = rnk.oNmkl.getNds();
		otpcena.value = rnk.oNmkl.F1cena;
		if (typeof F1cenasnds != "undefined")
			F1cenasnds.value = Number(F1cena.value)*(1+nds/100);
	/*
		учетная - снимаем
		(для PN это цена поставщика)
	*/
	}
	else if(iOtpsel==2)
		if(rnk.obj.parent.sDocLbl == "PN" || rnk.obj.parent.sDocLbl == "SA")
			otpcena.value = F1cena.value;
		else
			otpcena.value = Fcena.value;
	/*
		процент к учетной
	*/
	else if(iOtpsel==3 && bFocus)
	{
		var iProc = input(	ru("Введите процент наценки","Уведіть відсоток націнки"),
							ru("ввод отпускной цены по "+(rnk.obj.parent.sDocLbl=="PN"? "цене поставщика" : "учетной"),
							   "введення відпускноЇ ціни по "+(rnk.obj.parent.sDocLbl=="PN"? "ціні постачальника" : "обліковій")),
							otpsel_Proc, 3, 3 );
		if(iProc!=null)
		{
			otpsel_Proc = Number(iProc);
			var fltPrice = Number(rnk.obj.parent.sDocLbl=="PN"? F1cena.value : Fcena.value);
			otpcena.value = fltPrice + round(fltPrice * otpsel_Proc/100, Number(getPar("DECIPRI")));
		}
		//return;
	}
	/*
		процент к цене поставщика
	*/
	else if(iOtpsel==4 && bFocus)
	{
		var iProc = input(	ru("Введите процент наценки","Уведіть відсоток націнки"),
							ru("ввод отпускной цены по цене поставщика",
							   "введення відпускноЇ ціни по ціні постачальника"),
							otpsel_Proc, 3, 3);
		if(iProc!=null)
		{
			otpsel_Proc = Number(iProc);
			/*
				нужно учитывать, что при отсустствии записи
				tAnf вернет false
			*/
			var fltPrice = Number(tanf(Fid_pn,"1cena"));
			otpcena.value = fltPrice + round(fltPrice*otpsel_Proc/100, Number(getPar("DECIPRI")));
			//else
				//otpcena.value = 0;
		}
		//return;
	}
	/*
		отпускная цена == отп. при приходе
	*/
	else if(iOtpsel==5)
	{
		var fltPrice = Number(tanf(Fid_pn,"cenapr"));
		//if(typeof(fltPrice)=="number")
			otpcena.value = fltPrice;
		//else
			//otpcena.value = 0;
	}
	if(typeof Fsum!="undefined")
		check_Fsum();
	
	rnk.EnableTara();
}

function check_Fsum()
{		
	if(typeof Fsum == "undefined")
		return;
	
	var XCena = 0;
	if(typeof F1cena != "undefined")
		XCena = Number(F1cena.value);
	
	Fsum.value = round(XCena*Number(Fkol.value), Number(getPar("DECISUM")));

	if(typeof F1cenasnds != "undefined")
	{
		var nds = Number(rnk.obj.parent.getVar("HPNDS"));		
		if(nds!=0)
			nds = rnk.oNmkl.getNds();		
		F1cenasnds.value = XCena*(1+nds/100);	
	}
	
	rnk.discount_valid();
}

function DpNkRow_discount_valid(oCtrl)
{
	if(!oCtrl && typeof FDISCOUNT!="undefined")
		oCtrl = FDISCOUNT;
	if(!oCtrl)
		return;
	//trace(oCtrl.getData("ID") +" > "+ oCtrl.value);
	var sum = 0;
	if(typeof Fsum!="undefined")
		sum = Number(Fsum.value);
	if(oCtrl.getData("ID")=="FDISCOUNT")
	{
		var discount = Number(FDISCOUNT.value);
		if (typeof FDISCOUNT_SUM!="undefined")
			FDISCOUNT_SUM.value = sum*discount/100;
		if (typeof FSUM_DISCOUNT!="undefined")
			FSUM_DISCOUNT.value = sum - sum*discount/100;
	}
	else if(oCtrl.getData("ID")=="FDISCOUNT_SUM")
	{
		if (typeof FDISCOUNT!="undefined" && sum!=0)
			FDISCOUNT.value = Number(FDISCOUNT_SUM.value)/sum*100;
		if (typeof FSUM_DISCOUNT!="undefined")
			FSUM_DISCOUNT.value = sum - Number(FDISCOUNT_SUM.value);
	}
	else if(oCtrl.getData("ID")=="FSUM_DISCOUNT")
	{
		if (typeof FDISCOUNT_SUM!="undefined")
			FDISCOUNT_SUM.value = sum - Number(FSUM_DISCOUNT.value);
		if (typeof FDISCOUNT!="undefined" && sum!=0)
			FDISCOUNT.value = Number(FDISCOUNT_SUM.value)/sum*100;		
	}
}

function DpNkRow_calc_discount(cena, discount)
{
	if(!discount)
	{
		discount = Number(rnk.obj.parent.getVar("HDISCOUNT"));	
		if (typeof FDISCOUNT!="undefined")
			discount = Number(FDISCOUNT.value);
	}	
	if(!cena && typeof otpcena != "undefined")
		cena = Number(otpcena.value);
	if(discount)
	{
		var cena0 = Number(this.obj.getVar("RFOCENA"));
		if(cena0)
		{
			cena = cena0 - (cena0*discount/100);
		}
		else
		{
			rnk.obj.setVar("RFOCENA", cena);
			cena = cena - (cena*discount/100);
		}	
	}
	return round(cena, Number(getPar("DECIPRI")));
}

function F1cenasnds_valid()
{
	var nds = Number(rnk.obj.parent.getVar("HPNDS"));		
	if(nds!=0)
		nds = rnk.oNmkl.getNds();
	F1cena.value = Number(F1cenasnds.value) / (1+nds/100);   
	check_Fsum()		
}

function check_Fcena()
{			
	XCena = 0;	
	if(typeof F1cena != "undefined")
		XCena = Number(F1cena.value);
			
	dt = rnk.obj.parent.getVar("HDAT");
	objVal.setCod(rnk.obj.parent.getVar("HVAL"));
	kod1 = objVal.getNazv();
	if(!kod1)
		kod1 = 0;
	kurs = rnk.obj.parent.getVar("HVKURS");
	if(!kurs || kurs==0)
		kurs = 1;
	kod2 = 0;
	kurs_2 = 1;
	var Fcena = _nv2nv("", dt, kod1, XCena, kod2, kurs, kurs_2);

	return Number(Fcena);
}

function DpNkRow_zaval_Fnmkl()
{
	rnk.oNmkl.doZaval();
	rnk.Fnmkl_valid();		
}


function DpNkRow_Fnmkl_valid()
{	
	if(!rnk.oNmkl.getFwid())
		return;
	if (rnk.oldNmkl == rnk.oNmkl.getFwid())
	{
	
	}
		
	if(typeof Fkol_spr != "undefined")
		Enable(Fkol_spr, rnk.oNmkl.Fedi_spr!=0);
	
	if(typeof Fcena != "undefined")
	{
		if (rnk.oNmkl.Fvid!="S" && oCena)
		{
			var doCheck = false;
			
			if (rnk.oldNmkl != rnk.oNmkl.getFwid())
			{
				doCheck = true;
			}
			else if (Fcena.value == 0)
			{
				doCheck = true;
				// Если выбрана нулевая цена - не трогаем
				/*
				alert(oCena.cena)
				*/
				if(oCena.cena==0)
					doCheck = false;
			}
			if (doCheck)
			{
				oCena.check(false, "FIFO", Number(Fkol.value));
			}
		}

		Enable(Fcena, rnk.oNmkl.Fvid!="S"); //для услуг нет учетной цены
		if (rnk.oNmkl.Fvid=="S")
		{
			Fcena.value = 0;
		}
	}
	
	if(rnk.oNmkl.Fvid == "S" && Number(Fkol.value) == 0)
	{
		Fkol.value = 1;
	}
	
	if(iOtpsel==1 && rnk.oldNmkl!=rnk.oNmkl.getFwid())
		rnk.make_Otpcena();
			
	if (typeof grp_sn == "object") {
		// alert(toScrObj(rnk.oNmkl.Fissn))
		grp_sn.setVisible(rnk.oNmkl.Fissn == true);
		FORM.getShell().pack();
		// grp_sn.setVisible(false);
	}
	
	rnk.oldNmkl = rnk.oNmkl.getFwid();
	rnk.EnableTara();
}

function check_Ftara()
{
	if (rnk.EnableTara())
		rnk.Fnmkvid = FTARA.value;
}

function EnableTara()
{
	if (typeof FTARA != "undefined")
	{
		var vsbl = rnk.oNmkl.Fvid == "R";
		FTARA.setVisible(vsbl);		
		return (vsbl);
	}
	return false;	
}

function DpNkRow_getNextRowNum()
{
	if (typeof Fnom_str!="undefined" && (extPar.mode == "COPY" || extPar.mode == "ADD"))
		Fnom_str.value = findFreeClNo(this.obj.parent.bufName, "fnom_str");
	else if (extPar.mode == "COPY" || extPar.mode == "ADD")
		return findFreeClNo(this.obj.parent.bufName, "fnom_str");
}

function DpNkRow_save()
{
	// учесть коеффициент единиц измерения	
	if(rnk.Fedi==1)
	{
		var kf = rnk.oNmkl.Fedikf1;
		kf = (kf != 0 && kf != null)? kf : 1;		
		
		// перевести все цены и количество		
		Fkol.value *= kf;
		if(typeof otpcena != "undefined")
			otpcena /= kf;			
		if(typeof Fcena != "undefined")
			Fcena.value	/= kf;
		if(typeof F1cena != "undefined")
			F1cena.value /= kf;
		if(typeof Fcenapr != "undefined")
			Fcenapr.value /= kf;
		if(typeof Fvcena != "undefined")
			Fvcena.value /= kf;
		if(typeof Fcenaspr != "undefined")
			Fcenaspr.value /= kf;
		if(typeof Ffactcena != "undefined")
			Ffactcena.value	/= kf;
	}
	
	Fis_otl = (Number(rnk.obj.parent.getPar("_uchsel"))==3);	//отложенное расценивание
		
	var bCheckMaxKol = false;
	var bCheckF1cena = false; 
	doc = rnk.obj.parent.sDocLbl;
	if (   doc=="NK" || doc=="SF" || doc=="PU" || doc=="SM" || doc=="TC"
		|| doc=="PZ" || doc=="OT" || doc=="VP" || doc=="PM" || doc=="MP"
		|| doc=="MT" || doc=="OC" || doc=="VM" || doc=="MV" )
	{
		bCheckMaxKol = true;
	}
	if(doc=="NK" || doc=="SF" || doc=="PU" || doc=="SM" || doc=="TC")
	{
		bCheckFcena = bCheckF1cena = bCheckFkol = bCheckMaxKol = true;
	}
	if (typeof oCena!="undefined" && !oCena.valid() && !Fis_otl && rnk.oNmkl.Fvid!="S" && !vipneg)//проверка уч.цены
	{
		CLEARWAIT();
		setFocus(Fnmkl);
		alert(ru("Остатков для " + rnk.oNmkl.Ftxts + " нет.","Залишків для " + rnk.oNmkl.Ftxts + " немає."));
		return false;
	}
	
	if(bCheckF1cena && typeof F1cena!= "undefined" && F1cena.value==0)
	{
		setFocus(F1cena);
		//при установке фокуса срабатывает make_Otpcena()
		//еще раз проверяем
		if(F1cena.value==0)
		{	
			if(msgBox("yn",ru("Введена нулевая отпускная цена.\nПродолжить сохранение?",
					      "Введена нульова відпускна ціна.\nПродовжити збереження?"))=="n")
				return false;
		}
	}
	if(Fkol.value==0)
	{
		setFocus(Fkol);	
		if(msgBox("yn",ru("Введено нулевое количество.\n  Продолжить сохранение?",
					  	  "Введена нульова кількість.\n  Продовжити збереження?"))=="n")
			return false;
	}
	if(bCheckMaxKol && !Fis_otl && rnk.oNmkl.Fvid!="S" && (typeof extPar.bFifo=="undefined" || extPar.bFifo==false))
	{		
	  if ((Number(Fkol.value) > Number(nMaxKol)))
	  {			
		setFocus(Fkol);	
		if (vipneg)
		{
			if(msgBox("yn",ru("Выписанное количество превышает общий остаток.\n  Продолжить сохранение?",
							  "Виписана кількість перевищує загальний залишок.\n  Продовжити збереження?"))=="n")
				return false;
		}
		else
		{
			alert(ru("Выписанное количество превышает общий остаток. Сохранение невозможно",
					 "Виписана кількість перевищує загальний залишок. Збереження неможливе"));
			return false;
		}				
	  }
	}

	ctrlLinker.updateData(true);
	this.obj.setVar("RTNMK",  rnk.oNmkl.getCod());
	this.obj.setVar("REDI",   rnk.Fedi>0? rnk.Fedi : 0);
	this.obj.setVar("REDIF",  rnk.objKol.getEdiFas());
	this.obj.setVar("RPOST",  rnk.oNmkl.Fis_post?rnk.oPost.getCod():0);
	this.obj.setVar("RPODR",  rnk.oPodr.getCod());
	this.obj.setVar("RMOL",   rnk.oMol.getCod());
	this.obj.setVar("RSC",	  rnk.oSc.getSc());
	this.obj.setVar("RSU",	  rnk.oSc.getSu());
	this.obj.setVar("RST",    rnk.oSc.getSt());		
	if(showan)
	{
		this.obj.setVar("RA1",    rnk.oSc.getCl1());		
		this.obj.setVar("RA2",    rnk.oSc.getCl2());		
		this.obj.setVar("RA3",    rnk.oSc.getCl3());		
	}
	this.obj.setVar("RCTYPE", rnk.oSc.getType());	
	this.obj.setVar("RNMKVID",rnk.Fnmkvid);	
	this.obj.setVar("RSOTL",  Fis_otl);	
	this.obj.setVar("R1ID",	  Fid_pn!=null? Fid_pn : 0);	
	this.obj.setVar("RCENAORD",rnk.oNmkl.Fis_sred==false? this.obj.getVar("RUCENA") : 0);	
	
	//справочная валюта цены прихода
	if(typeof oVal != "undefined")
		this.obj.setVar("R1SVAL", oVal.getCod());
	if(this.obj.getVar("R1ID") && doc!="PN") //если ном-ра ведется по приходам, берем валюту прихода
		this.obj.setVar("R1SVAL", tanf(this.obj.getVar("R1ID"), 'VCOD'));
		
	// Fcena == "undefined" for FIFO 
	if (typeof Fsum == "undefined" && typeof Fcena != "undefined")
	{
		Fsum = Number(Fkol.value)*Number(Fcena.value);
		this.obj.setVar("RSUM",Fsum);		
	}	
	return true;
}