include("Objects\\DpVal.js");
include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");
include("sys\\udfs.js");
include("sys\\kursval.js");
include("Objects/DpMsgBox.js");

var edmode, t;
var cod_plat;
var oVal, oVal_spr, oOrg, oSc;
var objDoc = extPar.doc;
var ctrlLinker = null;
var oCntr;
var sTmpTbl = "TMP_RAVIZO";
var rsum = 0;
var d_sum = 0;
var viewHsc, kolSc;
var oldSc, oldSu, oldSt,oldCl1,oldCl2,oldCl3;
var mFid;
var tblObrScName = "TrnNBln_TMP";

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	objDoc.bufName = sTmpTbl;	//пригодится при автонумерации строк

	//DropTable("TMP_RBP");
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;
	mFid = extPar.doc.getID();

	viewHsc = toScrObj(objDoc.getPar("_hsc"));
	BLN.setVisible(false);
	kolSc = toScrObj(objDoc.getPar("_one_rsc"));
	if (kolSc == 0)
	{
		ONESUM.setVisible(true);
		TWOSUM.setVisible(false);
	}
	else
	{
		ONESUM.setVisible(false);
		TWOSUM.setVisible(true);	
	}
	SCHET.setVisible(viewHsc);

	var shell = FORM.ctrlComp.getShell();
	shell.pack();
	//Перерисуем окно
	var pnt = GRP;
	pnt.redraw();
	pnt.layout(true);

	HSUM.mask = MASK_SUM;
	HSUMD.mask = MASK_SUM;
	HSUMK.mask = MASK_SUM;
	HNOM.mask = MASK_DOCNUM;

	FBD.mask = MASK_SUM;
	FBK.mask = MASK_SUM;
	FOD.mask = MASK_SUM;
	FOK.mask = MASK_SUM;
	FED.mask = MASK_SUM;
	FEK.mask = MASK_SUM;

	oSc = new DpSc("c0utxyz");
	oSc.linkCtrl(FSC, FSU, FST, FCL1, FCL2, FCL3);
	oSc.linkCtrlTxt(FNAZV);
	
	oVal = new DpVal();
	oVal.assocDpText(FVAL);
	oVal.linkCtrlKurs(FVKURS);

	var cod_plat = 12;
   	oOrg = new DpCl("0");
   	oOrg.setClcl(cod_plat);
   	oOrg.linkCtrl(HORG, HORG_TXT);
   	oOrg.setContAssist();

   	ctrlLinker = new DpCtrlLinker(objDoc);

   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT);
 	ctrlLinker.addClLink("HORG",oOrg);
 	ctrlLinker.addLink("HSUM",HSUM);
 	ctrlLinker.addLink("HSUMD",HSUMD);
 	ctrlLinker.addLink("HSUMK",HSUMK);
 	ctrlLinker.addLink("HREM",HREM);
	ctrlLinker.addScLink("HSC","HSU","HST","HCL1","HCL2","HCL3",oSc);
	ctrlLinker.updateData(false);

    if(extPar.mode!="ADD")
	{
		oVal.setCod(objDoc.getVar("HVAL"));
	}

	if (viewHsc==true)
	{
		oldSc = oSc.getSc();
		oldSu = oSc.getSu();
		oldSt = oSc.getSt();
		oldCl1 = oSc.getCl1();
		oldCl2 = oSc.getCl2();
		oldCl3 = oSc.getCl3();
		Schet_Valid();
	}
	setValid(HDAT, mHDAT_Valid);
	setValid(FST,Schet_Valid);
	setValid(FCL1,Schet_Valid);
	setValid(FCL2,Schet_Valid);
	setValid(FCL3,Schet_Valid);
	setButton(VIEWBLN, onOffBln);

	Disable(HORG_TXT);
	Enable(HSUM, false);
	Enable(HSUMD, false);
	Enable(HSUMK, false);
	
	Enable(FBD, false);
	Enable(FBK, false);
	Enable(FOD, false);
	Enable(FOK, false);
	Enable(FED, false);
	Enable(FEK, false);
	
	FORM.Refresh();
	
	//подобьем суммы
	recalcSum();
}

var escape;

function onSave()
{
	ctrlLinker.updateData(true);
	saveRows();
	objDoc.setVar("HVAL",oVal.getCod());
}

function listMenuInit()
{
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		if (grid.getTable().getValue("FAVTO") != true)
		{
			grid.AddMenuItem("EDIT","Редагування | Редактирование");
			grid.AddMenuItem("COPY","Копіювання | Копирование");
			grid.AddMenuItem("DEL","Видалення | Удаление");
		}
	}
	grid.AddMenuItem("","");
	grid.AddMenuItem("LDPROV","Завантажити рядки з проведень по рахунку|Загрузить строки из проводок по счету");
}
function _initGrid()
{
   	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTbl,"RAVIZO","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("RAVIZO","RAVIZO");
	var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^RAVIZO"
			   + " WHERE fid_doc = " + nId;
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	if (kolSc == 0)
	{
		grid.setXMLFile("rowlist.xml");
	}
	else
	{
		//если в параметрах стоит, что отображать только корреспондирующий счет,
		//то грид для строк будет выглядеть так:
		// Корреспондирующий счет, Сумма по Дт, Сумма по Кт
		grid.setXMLFile("rowlist1.xml");
	
	}
	rtbl = OpenTable("m","select * from " + sTmpTbl+" order by fnom_str");
	rtbl.tie("cl_valut","x_cl_valut","fkod","FVAL");

	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(rtbl, "ROW", extPar.doc);

	grid.setTable(rtbl);

	grid.defCond("cond1", "=^FROWTYPE==1");
	grid.defCond("cond2", "=^FROWTYPE==2");
	grid.color(12, "cond1"); /*желтый цвет*/
	grid.color(1, "cond2");	/*голубой цвет*/
	// тип 3 (FROWTYPE==3) без роскраски
	
	grid.build();
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function onSelectRowMenu(sID)
{
	if(sID == "DEL")
	{
		extPar.doc.deleteRow("ROW", Number(grid.getTable().getRowID()));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
		//recalcSum();
	}
	else if (sID == "LDPROV")
	{
		addRowsInTbl();
	}
	else
	{
		var par = new Object();
		if (viewHsc == true)
		{
			par.oSc = oSc;
		}
		else
		{
			par.oSc = new DpSc("cutxyz");
		}
		
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow("ROW");
		//	var oSnap = getSnap("select max(fnom_str) as nom from " + sTmpTbl);
		//	var nNom = 1;
		//	if (oSnap && oSnap[0])
		//		nNom = Number(oSnap[0]) + 1;
		//	if(oDocRow)
		//		oDocRow.setVar("RNOM",nNom);

		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow("ROW",Number(grid.getTable().getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow("ROW",
						Number(grid.getTable().getRowID()));
		}

		var bOK = oDocRow.edit(sID, par);
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow("ROW",oDocRow)

			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();
		}
	}
	recalcSum();
	if (viewHsc == true)
	{
		Schet_Valid();
		recalcOst();
	}
	
}

function saveRows()
{
	//fruckt
	//все это надо было делать при загрузке
/*	
	//Если у нас были автоматически созданные строки, нужно им проставить fwid 
	//и номера строк
	strSQL = "SELECT * FROM "+sTmpTbl
			+" WHERE FWID = 0 OR FWID IS NULL"
			+" ORDER BY FROWTYPE"
	var sTbl = OpenTable(strSQL);
	
	var oSn = getSnap("SELECT MAX(FNOM_STR) FROM "+sTmpTbl+" WHERE FWID > 0");
	var maxNum = 0;
	if(oSn && !isEmpty(Number(oSn[0])))
	{
		var maxNum = Number(oSn[0]);
	}
	oSn = null;
	
	for (; !sTbl.IsEOF(); sTbl.MoveNext())
	{
		var m = new Object();
		m.FWID = GetUID();
		m.FNOM_STR = ++maxNum;
		
		updateTable(sTmpTbl, m, false, " FAVTO = "+SqlTrue
				+" AND FCR_SC="+sqlTo(sTbl.getValue("FCR_SC"))
				+" AND FCR_SU="+sqlTo(sTbl.getValue("FCR_SU"))
				+" AND FCR_ST="+sqlTo(sTbl.getValue("FCR_ST"))
				+" AND FCR_COD1="+sqlTo(sTbl.getValue("FCR_COD1"))
				+" AND FCR_COD2="+sqlTo(sTbl.getValue("FCR_COD2"))
				+" AND FCR_COD3="+sqlTo(sTbl.getValue("FCR_COD3"))
				+" AND FDB_SC="+sqlTo(sTbl.getValue("FDB_SC"))
				+" AND FDB_SU="+sqlTo(sTbl.getValue("FDB_SU"))
				+" AND FDB_ST="+sqlTo(sTbl.getValue("FDB_ST"))
				+" AND FDB_COD1="+sqlTo(sTbl.getValue("FDB_COD1"))
				+" AND FDB_COD2="+sqlTo(sTbl.getValue("FDB_COD2"))
				+" AND FDB_COD3="+sqlTo(sTbl.getValue("FDB_COD3"))
				+" AND FSUM="+sqlTo(sTbl.getValue("FSUM"))
				)
	}
	sTbl.close();
	sTbl = null;
	
	strSQL = "UPDATE "+sTmpTbl
			+" SET FDOC = "+sqlTo("AVIZO")
			+", FID_DOC = " + sqlTo(extPar.doc.getVar("ID"))
			+", FDATE = " + sqlTo(extPar.doc.getVar("HDAT"))
	ExecuteSQL(strSQL);		
*/
	ExecuteSQL("DELETE FROM ^RAVIZO WHERE fid_doc = " + sqlTo(extPar.doc.getVar("ID")));
	
	var sFLD = GetPatternIntersection("RAVIZO","RAVIZO");
	
	var sSQL = "INSERT INTO ^RAVIZO(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl;
	ExecuteSQL(sSQL);
}

function recalcSum()
{
	if (kolSc == 0)
	{
		var ctbl = OpenTable("s","SELECT SUM(FSUM) AS sumd FROM " + sTmpTbl);
		if (!ctbl.IsEmpty() && Number(ctbl.getValue("sumd")) != 0)
		{
			HSUM.value = (Number(ctbl.getValue("sumd")));
		}
		else
		{
			HSUM.value = 0;
		}
		ctbl.close();
	}
	else
	{
		strSQL = "SELECT "
			+" SUM( "+IIF("T.FISDB="+SqlTrue,"1","0")+"* T.FSUM) AS FSUMD,"
			+" SUM( "+IIF("T.FISDB="+SqlTrue,"0","1")+"* T.FSUM) AS FSUMK "
			+" FROM "+sTmpTbl+" AS T "
		var oSnap = getSnap(strSQL);//Получим обект
		if (oSnap !=null && oSnap[0] != null)
		{
			HSUMD.value = oSnap[0];
			HSUMK.value = oSnap[1];
		}
		else
		{
			HSUMD.value = 0;
			HSUMK.value = 0;
		}
		oSnap = null;
	}
	setFocus(grid);
}

function mHDAT_Valid() {
   return differ(HDAT.value, d00);
}

function HNOM_Valid()
{
   var nom;
   var snap = getSnap("SELECT MAX(fdoc_num) FROM ^HAVIZO");
   if(snap!=null)
   {
   		nom = snap[0];
   		nom = Number(nom)+1;
   }
   return String(nom);
}

function Schet_Valid()
{
	if (isSaving())
	{
		return true;
	}
	if (oldSc != oSc.getSc() || oldSu!= oSc.getSu() || oldSt != oSc.getSt() || 
	oldCl1 != oSc.getCl1() || oldCl2 != oSc.getCl2() || oldCl3 != oSc.getCl3())
	{
		if (!grid.getTable().isEmpty())
		{
			alert(ru("Внимание! При изменении счета \nвсе строки будут удалены.", 
					"Увага! При зміні рахунку \nусі рядки будуть видалені."));
			strSQL = "DELETE FROM "+sTmpTbl
			ExecuteSQL(strSQL);
		}
		oldSc = oSc.getSc();
		oldSu = oSc.getSu();
		oldSt = oSc.getSt();
		oldCl1 = oSc.getCl1();
		oldCl2 = oSc.getCl2();
		oldCl3 = oSc.getCl3();
		BLN.setVisible(false);
		var shell = FORM.ctrlComp.getShell();
		shell.pack();
		
		//Перерисуем окно
		var pnt = GRP;
		pnt.redraw();
		pnt.layout(true);
	}	
		
	szREqualShet = getWhereCond("rd", "S", sTmpTbl,oSc.getSc() ,oSc.getSu(), oSc.getSt());
	strSQL = " UPDATE "+sTmpTbl
				+" SET FROWTYPE = 1"
					+", FWIDPR = (SELECT S.FWID"
										+" FROM ^SCHET S"
										+" WHERE 1=1"
											+" AND S.FSUM = "+sTmpTbl+".FSUM"
											+" AND S.FID_DOC = "+sqlTo(mFid)
											+" AND "+szREqualShet+")"
				+" WHERE 1=1"
					+" AND FISDB = "+sqlTrue
					+" AND FAVTO = "+sqlFalse
	ExecuteSQL(strSQL);
	
	szREqualShet = getWhereCond("rc", "S", sTmpTbl,oSc.getSc() ,oSc.getSu(), oSc.getSt());
	strSQL = " UPDATE "+sTmpTbl
				+" SET FROWTYPE = 1"
					+", FWIDPR = (SELECT S.FWID"
										+" FROM ^SCHET S"
										+" WHERE 1=1"
											+" AND S.FSUM = "+sTmpTbl+".FSUM"
											+" AND S.FID_DOC = "+sqlTo(mFid)
											+" AND "+szREqualShet+")"
				+" WHERE 1=1"
					+" AND FISDB = "+sqlFalse
					+" AND FAVTO = "+sqlFalse
	ExecuteSQL(strSQL);				
	return true;
}

function addRowsInTbl()
{	
	var isLoarAvtRow = true;
	
	strSQL = " SELECT"
				+" *" 
			+" FROM"
				+" "+sTmpTbl
			+" WHERE 1 = 1"
				+" AND FAVTO = "+sqlTrue
	var oTbl = OpenTable(strSQL);
	if(!oTbl.IsEmpty())
	{		
		var msg = ru("В этом документе найдены загружаемые строки."
						, "В цьому документі знайдено завантажені рядки.");
		msg += "\n"+ru("Перезагрузить строки ?", "Перезавантажити рядки?")
		
		var oMsg = new DpMsgBox(); 
		oMsg.set("yn", msg, ru("Внимание!", "Увага!"));
		ask = oMsg.ask();
		
		if(ask == "n")
		{
			isLoarAvtRow = false;
		}
	}
	
	if(!isLoarAvtRow)
	{
		//если загружать строки не нужно то выйдем 
		oTbl.Close();
		oTbl = null;
		
		return;
	}
	
	if (!oTbl.IsEmpty())
	{
		var oDocRow;
		for (oTbl.MoveFirst(); !oTbl.IsEOF(); oTbl.MoveNext())
		{
			objDoc.deleteRow("ROW", toScrObj(oTbl.getValue("FWID")));
		}
	}
	oTbl.Close();
	oTbl = null;
	
	ExecuteSQL("DELETE FROM "+sTmpTbl+" WHERE FAVTO = "+SqlTrue);

	//соберем строки
	var sRowTmp = getTmpTableName("", true);
	CreateTable(sRowTmp, "RAVIZO", "FWID");
	
	var szDbFld = " S.FDB_SC "
				+",S.FDB_SU "
				+",S.FDB_ST "
				+",S.FDB_COD1 "
				+",S.FDB_COD2 "
				+",S.FDB_COD3 "
				
	var szCrFld ="S.FCR_SC "
				+",S.FCR_SU "
				+",S.FCR_ST "
				+",S.FCR_COD1 "
				+",S.FCR_COD2 "
				+",S.FCR_COD3 "

	strSQL  = "INSERT INTO "+sRowTmp+"(FSUM, FISDB, FAVTO, FROWTYPE"
			+", FCR_SC, FCR_SU, FCR_ST, FCR_COD1, FCR_COD2, FCR_COD3 "
			+", FDB_SC, FDB_SU, FDB_ST, FDB_COD1, FDB_COD2, FDB_COD3)"
			+" SELECT SUM(S.FSUM) AS FSUM "
				+" ,"+SqlFalse+" AS FISDB "
				+" ,"+SqlTrue+" AS FAVTO "
				+" ,3 AS  FROWTYPE "
				+", S.FCR_SC, S.FCR_SU, S.FCR_ST"
				+", S.FCR_COD1, S.FCR_COD2, S.FCR_COD3"
				+", S.FDB_SC, S.FDB_SU, S.FDB_ST"
				+", S.FDB_COD1, S.FDB_COD2, S.FDB_COD3"
		+" FROM "
				+"^SCHET AS S "
			+" WHERE 1=1 "
				+" AND S.FID_DOC = "+sqlTo(mFid)
				+getWhereCond("s","S.FCR",null,oSc.getSc(),oSc.getSu(),oSc.getSt()
								,oSc.getCl1(),oSc.getCl2(),oSc.getCl3())
				+" AND  S.FWID NOT IN (SELECT DISTINCT T.FWIDPR "
												+"FROM "+sTmpTbl+" AS T "
												+"WHERE 1=1"
													+" AND T.FISDB = "+sqlFalse
												+")"
			+" GROUP BY "
				+szCrFld
				+","+szDbFld
		ExecuteSQL(strSQL);
	

	strSQL  = "INSERT INTO "+sRowTmp+"(FSUM, FISDB, FAVTO, FROWTYPE"
			+", FDB_SC, FDB_SU, FDB_ST, FDB_COD1, FDB_COD2, FDB_COD3 "
			+", FCR_SC, FCR_SU, FCR_ST, FCR_COD1, FCR_COD2, FCR_COD3)"
			+" SELECT SUM(S.FSUM) AS FSUM "
				+" ,"+SqlTrue+" AS FISDB "
				+" ,"+SqlTrue+" AS FAVTO "
				+" ,3 AS  FROWTYPE "
				+", S.FDB_SC, S.FDB_SU, S.FDB_ST"
				+", S.FDB_COD1, S.FDB_COD2, S.FDB_COD3"
				+", S.FCR_SC, S.FCR_SU, S.FCR_ST"
				+", S.FCR_COD1, S.FCR_COD2, S.FCR_COD3"
		+" FROM "
				+"^SCHET AS S "
			+" WHERE 1=1 "
				+" AND S.FID_DOC = "+sqlTo(mFid)
				+getWhereCond("s","S.FDB",null,oSc.getSc(),oSc.getSu(),oSc.getSt()
								,oSc.getCl1(),oSc.getCl2(),oSc.getCl3())
				+" AND  S.FWID NOT IN (SELECT DISTINCT T.FWIDPR "
												+"FROM "+sTmpTbl+" AS T "
												+"WHERE 1=1"
													+" AND T.FISDB = "+sqlTrue
												+")"
			+" GROUP BY "
				+szDbFld
				+","+szCrFld
	ExecuteSQL(strSQL);	
	
	// Проводки не относятся к нашему документу.
	//Выберем все проводки у которых главный счет проходит по кредиту
	strSQL  = "INSERT INTO "+sRowTmp+"(FSUM, FISDB, FAVTO, FROWTYPE"
			+", FCR_SC, FCR_SU, FCR_ST, FCR_COD1, FCR_COD2, FCR_COD3 "
			+", FDB_SC, FDB_SU, FDB_ST, FDB_COD1, FDB_COD2, FDB_COD3)"
			+" SELECT SUM(S.FSUM) AS FSUM "
				+" ,"+SqlFalse+" AS FISDB "
				+" ,"+SqlTrue+" AS FAVTO "
				+" ,2 AS  FROWTYPE "
				+", S.FCR_SC, S.FCR_SU, S.FCR_ST"
				+", S.FCR_COD1, S.FCR_COD2, S.FCR_COD3"
				+", S.FDB_SC, S.FDB_SU, S.FDB_ST"
				+", S.FDB_COD1, S.FDB_COD2, S.FDB_COD3"
		+" FROM "
				+"^SCHET AS S "
			+" WHERE 1=1 "
				+getWhereCond("s","S.FCR",null,oSc.getSc(),oSc.getSu(),oSc.getSt()
								,oSc.getCl1(),oSc.getCl2(),oSc.getCl3())
				+" AND (S.FDATE BETWEEN "+sqlTo(firstDay(HDAT.value))+" AND "+sqlTo(lastDay(HDAT.value))+")"
				+" AND S.FID_DOC <>"+sqlTo(mFid)
			+" GROUP BY "
				+	szCrFld
				+","+szDbFld
	ExecuteSQL(strSQL);
	
	//Выберем все проводки у которых главный счет проходит по дебету
	strSQL  = "INSERT INTO "+sRowTmp+"(FSUM, FISDB, FAVTO, FROWTYPE"
			+", FDB_SC, FDB_SU, FDB_ST, FDB_COD1, FDB_COD2, FDB_COD3 "
			+", FCR_SC, FCR_SU, FCR_ST, FCR_COD1, FCR_COD2, FCR_COD3)"
			+" SELECT SUM(S.FSUM) AS FSUM "
				+" ,"+SqlTrue+" AS FISDB "
				+" ,"+SqlTrue+" AS FAVTO "
				+" ,2 AS  FROWTYPE "
				+", S.FDB_SC, S.FDB_SU, S.FDB_ST"
				+", S.FDB_COD1, S.FDB_COD2, S.FDB_COD3"
				+", S.FCR_SC, S.FCR_SU, S.FCR_ST"
				+", S.FCR_COD1, S.FCR_COD2, S.FCR_COD3"
			+" FROM "
				+"^SCHET AS S "
			+" WHERE 1=1 "
				+getWhereCond("s","S.FDB",null,oSc.getSc(),oSc.getSu(),oSc.getSt()
								,oSc.getCl1(),oSc.getCl2(),oSc.getCl3())
				+" AND (S.FDATE BETWEEN "+sqlTo(firstDay(HDAT.value))+" AND "+sqlTo(lastDay(HDAT.value))+")"
				+" AND S.FID_DOC <>"+sqlTo(mFid)
			+" GROUP BY "
				+szDbFld
				+","+szCrFld
	ExecuteSQL(strSQL);
	
	var oTbl = OpenTable(sRowTmp);
	if (!oTbl.IsEmpty())
	{
		var i  = 1;
		var oDocRow;
		for (oTbl.MoveFirst(); !oTbl.IsEOF(); oTbl.MoveNext())
		{
			oDocRow = objDoc.createRow("ROW");
			
			oDocRow.setVar("RNOM", i++);
			oDocRow.setVar("RDOC", objDoc.getVar("HDOC"));
			oDocRow.setVar("RDATE", objDoc.getVar("HDAT"));
		
			oDocRow.setVar("RDB_SC", toScrObj(oTbl.getValue("FDB_SC")));
			oDocRow.setVar("RDB_SU", toScrObj(oTbl.getValue("FDB_SU")));
			oDocRow.setVar("RDB_ST", toScrObj(oTbl.getValue("FDB_ST")));
			oDocRow.setVar("RDB_COD1", toScrObj(oTbl.getValue("FDB_COD1")));
			oDocRow.setVar("RDB_COD2", toScrObj(oTbl.getValue("FDB_COD2")));
			oDocRow.setVar("RDB_COD3", toScrObj(oTbl.getValue("FDB_COD3")));
			
			oDocRow.setVar("RCR_SC", toScrObj(oTbl.getValue("FCR_SC")));
			oDocRow.setVar("RCR_SU", toScrObj(oTbl.getValue("FCR_SU")));
			oDocRow.setVar("RCR_ST", toScrObj(oTbl.getValue("FCR_ST")));
			oDocRow.setVar("RCR_COD1", toScrObj(oTbl.getValue("FCR_COD1")));
			oDocRow.setVar("RCR_COD2", toScrObj(oTbl.getValue("FCR_COD2")));
			oDocRow.setVar("RCR_COD3", toScrObj(oTbl.getValue("FCR_COD3")));
			
			oDocRow.setVar("RISDB", toScrObj(oTbl.getValue("FISDB")));
			oDocRow.setVar("RAVTO", toScrObj(oTbl.getValue("FAVTO")));
			oDocRow.setVar("RROWTYPE", toScrObj(oTbl.getValue("FROWTYPE")));
			
			oDocRow.setVar("RSUM", toScrObj(oTbl.getValue("FSUM")));
			
			objDoc.appendRow("ROW",oDocRow)
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		}
	}
	oTbl.Close();
	oTbl = null;
	
	DropTable(sRowTmp);
	
	//обновимся
	grid.getTable().requery();
	grid.refresh();
}

//=============SQL API =============================
function sqlw0AndNoSqlTo(cmpExpr, cmpVal)
{
	if(isEmpty(cmpVal))
	{
		return "";
	}
	else
	{
		return " AND " + cmpExpr + cmpVal;
	}
}

function getWhereCond(mode,alias1,alias2,sc,su,st,a1,a2,a3)
{
	//Возвращает стороку условие
	//mode	- 's' для таблицы schet.
	//		- 'r' - для таблицы строк.
	var strRet ="";
	switch (mode.substr(0,1))
	{
		case "s":
			strRet = sqlw0And(alias1+"_SC=",sc)
					+sqlw0And(alias1+"_SU=",su)
					+sqlw0And(alias1+"_ST=",st)
					+sqlw0And(alias1+"_COD1=",a1)
					+sqlw0And(alias1+"_COD2=",a2)
					+sqlw0And(alias1+"_COD3=",a3)
			break;
		case "S":
			strRet = sqlw0AndNoSqlTo(alias1+"_SC=",sc)
					+sqlw0AndNoSqlTo(alias1+"_SU=",su)
					+sqlw0AndNoSqlTo(alias1+"_ST=",st)
					+sqlw0AndNoSqlTo(alias1+"_COD1=",a1)
					+sqlw0AndNoSqlTo(alias1+"_COD2=",a2)
					+sqlw0AndNoSqlTo(alias1+"_COD3=",a3)
			break;
		case "r":
			//Надо по дебету
			if (/d/.test(mode))
			{
				strRet += "("+alias2+".FISDB = "+SqlTrue
							+" AND ( 1=1 "+getWhereCond("S",alias1+".FCR",null
										,alias2+".FCR_SC"
										,alias2+".FCR_SU"
										,alias2+".FCR_ST"
										,alias2+".FCR_COD1"
										,alias2+".FCR_COD2"
										,alias2+".FCR_COD3")
									+" "
									+getWhereCond("S",alias1+".FDB",null
										,sc
										,su
										,st
										,alias2+".FDB_COD1"
										,alias2+".FDB_COD2"
										,alias2+".FDB_COD3")
									+")"
						+")"
			}
			//Надо по дебету и по кредиту
			if (/dc/.test(mode))
			{
				strRet +=" OR "
			}
			if (/c/.test(mode))
			{
					strRet+="("+alias2+".FISDB = "+SqlFalse
							+" AND ( 1=1 "+getWhereCond("S",alias1+".FDB",null
										,alias2+".FDB_SC"
										,alias2+".FDB_SU"
										,alias2+".FDB_ST"
										,alias2+".FDB_COD1"
										,alias2+".FDB_COD2"
										,alias2+".FDB_COD3")
									+" "
									+getWhereCond("S",alias1+".FCR",null
										,sc
										,su
										,st
										,alias2+".FCR_COD1"
										,alias2+".FCR_COD2"
										,alias2+".FCR_COD3")
									+")"
						+")"
			}
			break;
	}
	return strRet;
}

function onOffBln()
{
	//если BLN был включен то потушим его и наооборот
	//и изменим наименование кнопки
	if(BLN.getVisible())
	{
		BLN.setVisible(false);
		VIEWBLN.setText(ru("Показать обороты и остатки по основному счету"
								, "Показати обіги та залишки по основному рахунку"));
	}
	else
	{
		BLN.setVisible(true);
		VIEWBLN.setText(ru("Скрыть обороты и остатки по основному счету"
								, "Сховати обіги та залишки по основному рахунку"));
	}
	
	//обновление окна формы
	FORM.Refresh();
	
	if(BLN.getVisible())
	{		
		//при включении пересчитываем остатки и сальдо
		recalcOst();
	}
}

function recalcOst()
{
	//if(BLN.getVisible() == true)
	if(oSc.getSc()!=0 && oSc.valid() && BLN.getVisible())
	{
		include("TrnNBln.js");
		TrnNBln("3R",tblObrScName,firstDay(new Date(HDAT.getValue())),lastDay(new Date(HDAT.getValue())),oSc);
		//Вытянем итоговую строку по заданому счету.
		strSQL = " SELECT "
					+"  FSUM1" //сальдо на нач. по Дт
					+" ,FSUM2" //сальдо на нач. по Кт
					//+" ,FSUM5" //об. по Дт
					//+" ,FSUM6" //об. по Кт
					//+" ,FSUM3" //сальдо на кон. по Дт
					//+" ,FSUM4" //сальдо на кон. по Кт
				+" FROM "
					+tblObrScName
				+" WHERE 1=1"
					+" AND FSC = "+sqlTo(oSc.getSc())
					+" AND FSU = "+sqlTo(oSc.getSu())
					+" AND FST = "+sqlTo(oSc.getSt())
					+" AND FCL_COD1 = "+sqlTo(oSc.getCl1())
					+" AND FCL_COD2 = "+sqlTo(oSc.getCl2())
					+" AND FCL_COD3 = "+sqlTo(oSc.getCl3())
		var obal = getSnap(strSQL)
		DropTable(tblObrScName);
		
		if(obal)
		{
			FBD.setValue(toScrObj(obal[0]));
			FBK.setValue(toScrObj(obal[1]));
			FOD.setValue(Number(HSUMD.getValue()));
			FOK.setValue(Number(HSUMK.getValue()));
			var mesl = Number(FBD.getValue()) 
						- Number(FBK.getValue()) 
						+ Number(FOD.getValue()) 
						- Number(FOK.getValue());
			FED.setValue(mesl>0 ? mesl : 0);
			FEK.setValue(mesl<0 ? -mesl : 0);
		}
		else
		{
			FBD.setValue(0);
			FBK.setValue(0);
			FED.setValue(0);
			FEK.setValue(0);
		}
	}
}

include("sys\\DpBaseDlg.js");