include("Objects/DpCl.js");
include("Objects/DpNmkl.js");
include("Objects/DpCntrct.js");
include("sub/bil.js");

var ctrlLinker;
var obj;
var oNmkl;
var oClient;
var priType;
var codPlat;
var oCntr;

function Load()
{
	Caption(ru("Оплаты", "Оплати"),extPar.mode);
	
	obj = extPar.obj;
	
	priType = getPar("BILL_PRI");
	codPlat = obj.parent.getPar("_codplat");	
	vidDog  = obj.parent.getPar("_viddog");	
	if(vidDog==1)
		priType = getPar("BILL_PRI");
	if(!codPlat && vidDog==0)
		codPlat = getPar("BILL_CL");
	else if(!codPlat && vidDog==1)		
		codPlat = getPar("BILTEL_CL");
	if(!codPlat)
		codPlat = getPar("CODPLAT");
	
	oNmkl = new DpNmkl();
	oNmkl.linkCtrl(Fnmkl, tFnmkl);
	oNmkl.CanEmpty = true;
	
	setPar("bill_to_cl_client", "1");
	oClient = new DpCl("", codPlat, 0);
	oClient.linkCtrl(Fclient);
	oClient.linkCtrl2("FTXT", tFclient);	
	oClient.AfterLoad = setCtrtOrg;
	setValid(Fclient, setCtrtOrg);
	
	oCntr = new DpCntrct("+");
	oCntr.linkCtrl(Fdog, Fdog_txt);
	//setWhen(Fdog, setCtrtOrg);
	
	ctrlLinker = new DpCtrlLinker(obj);
	
	//ctrlLinker.addLink("RNMKL", Fnmkl);
	ctrlLinker.addLink("RSUM", Fsum);	
	//ctrlLinker.addLink("RPHONE", FPHONE); 
	ctrlLinker.updateData(false);
			
	if (extPar.mode != "ADD")
	{
		oClient.setCod(obj.getVar("RCLIENT"));
		oNmkl.setCod(obj.getVar("RNMKL"));
		oCntr.setOrg(obj.getVar("RCLIENT"));
		oCntr.setID(obj.getVar("RDOGID"));
	}
	this.recalcSum = recalcSum;
	setButton(Fsum, this, "recalcSum");
	Fsum.getBtn().setToolTipText(ru("Пересчитать","Перерахувати"));
	
	setWhen(Fsum, Fsum_when);	    
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RCLIENT", oClient.getCod());
	obj.setVar("RNMKL", oNmkl.getCod());
	obj.setVar("RDOGID", Number(oCntr.getID()));
}

function setCtrtOrg()
{
	obj.setVar("RDOGID", Number(oCntr.getID()));	
	oCntr.setOrg(oClient.getCod());
	oCntr.setID(obj.getVar("RDOGID"));
}

function Fsum_when()
{
	if(Fsum.value==0)
		recalcSum();
}

function recalcSum()
{
	Fsum.value = 0;
	var sum = getSum();
	if(sum>0)
		Fsum.value = sum;
}

function getSum(nmkl)
{	
	var date = new Date(obj.parent.getVar("HDAT"));
	var nClient = oClient.getCod();
	var dogID = oCntr.getID();
	if(dogID==id00)
		dogID = 0;
	return getDebt(date, nClient, dogID);
}

include("sys/DpBaseDlg.js");