include("Objects/DpCl.js");
include("Objects/DpNmkl.js");

var ctrlLinker;
var obj;
var oClNmkl;
var oClClient;
var priType = getPar("BILL_PRI");

function Load()
{
	Caption(ru("Оплаты", "Оплати"),extPar.mode);
	
	oClNmkl = new DpNmkl();
	oClNmkl.linkCtrl(Fnmkl, tFnmkl);
	oClNmkl.CanEmpty = true;
	
	setPar("bill_to_cl_client", "1");
	oClClient = new DpCl("", getPar("bill_cl"), 0);
	oClClient.linkSmartCtrl(Fclient);
	oClClient.setContAssist();
	oClClient.AfterUpdate = setOrg;
	
	obj = extPar.obj;
	
	ctrlLinker = new DpCtrlLinker(obj);
	
	//ctrlLinker.addLink("RNMKL", Fnmkl);
	ctrlLinker.addLink("RSUM", Fsum);	
	ctrlLinker.updateData(false);
			
	if (extPar.mode != "ADD")
	{
		oClClient.setFWID(obj.getVar("RCLIENT"));
		oClNmkl.setCod(obj.getVar("RNMKL"));
	}
	
	Fsum.mask = MASK_SUM;
	
	this.check_sum = check_sum
	setButton(Fsum, this, "check_sum");
	setWhen(Fsum, Fsum_when);
	
	Disable(FADDR);	    
}

function setOrg()
{
	var id = oClClient.getFWID();
	var oSnap = getSnap("select b.FNMKL,h.FADDR,h.FBLD,h.FLETTER,h.FAPART,h.FZIP "
					+" from ^BILL_ITERATED b "
					+" inner join ^CL_HOMO h on h.FWID_CL=b.FCLIENT "
					+" where b.FCLIENT="+ id
						+" order by b.FBDATE desc"
					, false);
	if(!oSnap)
		return;
	
	FADDR.value = oSnap[1] + " "+ oSnap[2] +""+ oSnap[3] +", кв."+ oSnap[4] +" "+ oSnap[5];
	
	oClNmkl.setCod(Number(oSnap[0]));
	Fsum_when();
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RCLIENT", oClClient.getFWID());
	obj.setVar("RNMKL", oClNmkl.getCod());	
}

function Fsum_when()
{
	if(Fnmkl.value != "" && Fsum.value==0)
		check_sum();
}

function check_sum()
{
	Fsum.value = getTariff(oClNmkl.getCod(), oClClient.getFWID())
}

function getTariff(nmkl, clnt)
{
	/*
	zzz = OpenTable("s", "SELECT fcena, fnmonths FROM ^bill_tariff"
			+ " WHERE fnmkl = " + sqlTo(oClNmkl.getCod())
			+ " AND fclient = " + sqlTo(oClClient.getCod())
			+ " ORDER BY fbdate DESC");
	if(zzz.IsEmpty())
	{
		zzz = OpenTable("s", "SELECT fcena, fnmonths FROM ^bill_tariff"
				+ " WHERE fnmkl = " + sqlTo(oClNmkl.getCod())
				+ " ORDER BY fbdate DESC");
	}
	var nCena = Number(zzz.getValue("FCENA"));
	var nMonth = Number(zzz.getValue("FNMONTHS"));
	*/
	var nCena = 0;
	var nMonth = 1;
	if(!corectPriType())	
		return 0;		
	
	var sSql = "select FWID, FDAT from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue
					+" order by FDAT desc"
	var oPri = getSnap(sSql);
	if(!oPri)
	{				
		showWindow("bill_tariff.js", SW_NOMODAL, new Object());		
		oPri = getSnap(sSql);
		if(!oPri)
			return 0;
	}			
	
	include("sub/mtr.js");
	var priName = pName(priType, oPri[1], oPri[0]);
	var sSql = "select FCENA from "+ priName
					+" where FNMKL="+ nmkl
	oPri = getSnap(sSql);
	if(!oPri)
	{
		var sNmk = oClNmkl.getTCod();
		var sMsg = ru("Не установлен тариф для '"+ sNmk +"'"
					 ,"Не встановлений тариф для '"+ sNmk +"'");
		sMsg += ru("\nОткрыть прайс-лист?"
				  ,"\nВідкрити прайс-лист?");			
		var ret = msgBox("yn", sMsg, ru("Тарифы","Тарифи"));
		if(ret=="y")
			showWindow("bill_tariff.js", SW_NOMODAL, new Object());
		else
			return 0;	
	}	
	nCena = Number(oPri[0]);		
	return nCena * nMonth;
}

function corectPriType()
{
	if(priType)
		priType = priType.toUpperCase();
	var s = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";	
	if(priType==null || s.indexOf(priType)==-1 || priType=="")
	{
		var sMsg = ru("Не установлен параметр 'Тип прайс-листа для тарифов'"
					 ,"Не встановлений параметр 'Тип прайс-листа для тарифів'");
		if(s.indexOf(priType)==-1)
			sMsg = ru("Не корректное значение параметра 'Тип прайс-листа для тарифов'"
					 ,"Не коректне значення параметру 'Тип прайс-листа для тарифов'");
		sMsg += ru("\nОткрыть окно для настройки параметров?"
				  ,"\nВідкрити вікно для налагодження параметрів?");			
		var ret = msgBox("yn", sMsg, ru("Тарифы","Тарифи"));
		if(ret=="y")	
			showWindow("bill_params.xml", SW_MODAL, new Object());
		else
			return false;	
		priType = getPar("BILL_PRI");
		return corectPriType();
	}
	return true;
}

include("sys/DpBaseDlg.js");