include("Objects/DpCl.js");
include("Objects/DpStruOrg.js");
include("Objects/DpShifPZ.js");
include("Objects/DpPost.js");
include("Objects/DpVopl.js");
include("Objects/DpClNo.js");
include("servis/format.js");
include("Objects/DpCtrlLinker.js");
include("sys/udfs.js");

var obj = extPar.obj; 
var oPers,org,dpShifPZ,dpDol,dpVopl,dpKodKat,dpKodZvan;
var fwid_org,fwid_dol,fwid_cldol,fwid_cl,fwid_kat,fwid_zvan,fvopl;
var lastMsg;
var ctrlLinker = null;

function Load() 
{
	Caption(ru("Назначение на должность","Призначення на посаду") + ": " + modeName(extPar.mode));
	RPRIEM.value = true;
  	RTERM.setMask("##");
  	ROKLAD.setMask("######.##");
  	RAVANS.setMask("######.##");
  	//RTABLE.setMask("#");
   	init_RTABLE();  	
	oPers = new DpCl("", getPar("CODPERS"), 0);
	oPers.linkCtrl(RTABN, RTABNTXT);
	if(extPar.mode == "EDIT")
		RTABN.enabled = false;
	
	ctrlLinker = new DpCtrlLinker(obj);
	Fnom_str.mask = "####";		
	ctrlLinker.addLink("RNOM",Fnom_str);
	ctrlLinker.addClLink("RCOD",oPers);
	ctrlLinker.addLink("RDATZ",RDATZ);
	ctrlLinker.addLink("RREASON",RREASON);
	ctrlLinker.addLink("RTERM",RTERM);
	
	RTERM.mask = "##";
   	RKOLST.setMask("######.##");	
	
	org = new DpStruOrg(true);
   	org.linkCtrl(RORG);
   	
   	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.linkCtrl(RSHPZ, RSHPZ_TXT);
	if(extPar.mode == "ADD")
	{
		RBDAT.value = obj.parent.getVar("HDAT");
		RTABLE.value = 1;
		dpShifPZ.setFshpz(0);
		if(extPar.prk_fwid_cl)
		{
			oPers.setFWID(extPar.prk_fwid_cl);
			RTABN.enabled = false;
			obj.setVar("RCOD", oPers.getCod());
		}
		RISMAIN.value = true;
		RTRSOG.value = false;		
   		RFIKSSUM.value = 0;
   		RPREWOKL.value = 0;   		
   		RBASEMIND.value = d00;	
   		RKOLST.value = 1;   		
		RKOD_UV.value = 0;   		
	}
   	
	//объект DpPost использовать нельзя, т.к. при редактировании строк ни разу не сохраненного приказа записей в таблице STRU_DOL еще нет 
//	dpDol = new DpPost(extPar.mode, extPar.mode!="EDIT");
//	dpDol.linkCtrl("fcod", RDOL);
//	dpDol.linkCtrl("dol_ftxt", RDOLTXT, true);
//	dpDol.linkCtrl("foklad", ROKLAD);
//	dpDol.linkCtrl("fshpz", dpShifPZ);
	dpDol = new DpCl("", getPar("CODDOL"), 0);
	dpDol.linkCtrl(RDOL, RDOLTXT);
	
	dpVopl = new DpVopl();
	dpVopl.linkCtrl(RVOPL, RVOPLTXT);
	
	var codKat = getPar("CODKAT","ZRP");
	dpKodKat = new DpCl("", codKat, 0);
	dpKodKat.linkCtrl(RKODKAT, RKODKATTXT);
	
	var codZvan = getPar("CODZVAN");
	dpKodZvan = new DpCl("0", codZvan, 0);
	dpKodZvan.linkCtrl(RKODZVAN, RKODZVANTXT);
	if(!codZvan)
		Disable(RKODZVAN);

	codSSV = getPar("ZRP_SSV");
	dpSSV = new DpCl("", codSSV, 0);
	dpSSV.linkCtrl(FCOD_SSV, FTXT_SSV);
	
	codKZO = getPar("ZRP_KZO");
	dpKZO = new DpCl("", codKZO, 0);
	dpKZO.linkCtrl(FCOD_KZO, FTXT_KZO);
	
	codSST = getPar("ZRP_SST");
	dpSST = new DpCl("0", codSST, 0);
	dpSST.linkCtrl(FCOD_SST, FTXT_SST);
	dpSST.linkExtCtrl("CODOSN",FCODOSN);
	
	if("ADD" != extPar.mode)
	{
		var tbl = OpenTable("SELECT * FROM tmp_full_pers "
   						+" WHERE Fwid_wp="+sqlTo(obj.getVar("RWID_WP")))
   		if(tbl.rowCount>0)
   		{
			RBDAT.value = tbl.getValue("Fbdat");
			fwid_org = tbl.getValue("Fwid_org");
   			RNAZN.value = tbl.getValue("Fnazn")==1?true:false;
			RZAPIS.value = tbl.getValue("Fis_serv")==1?true:false;
   			RPRIEM.value = tbl.getValue("Fis_nazn")==1?true:false;
   			RTABLE.value = Number(tbl.getValue("Ftable"));   			
   			fwid_dol = tbl.getValue("Fwid_dol");
   			fwid_cl = tbl.getValue("Fwid_cl");
   			fwid_kat = tbl.getValue("Fwid_kat");
   			fwid_zvan = tbl.getValue("Fwid_zvan");
   			fvopl = tbl.getValue("Fvopl");
   			RAVANS.value = tbl.getValue("Favans");
   			RINVAL.value = tbl.getValue("Finval")==1?true:false;
   			RTERM.value = tbl.getValue("Fterm");
   			RREASON.value = tbl.getValue("Freason");
   			fwid_cldol = tbl.getValue("Fwid_cldol");
   			ROKLAD.value = tbl.getValue("Foklad");
   			dpShifPZ.setFshpz(tbl.getValue("Fshpz"));
   			RPENS.value = tbl.getValue("Fpens");
   			//14.09.12
			RISMAIN.value = tbl.getValue("FISMAIN")==1?true:false; 
   			RTRSOG.value = tbl.getValue("FISTRSOG")==1?true:false;	
   			dpSSV.setCod(tbl.getValue("Fcod_ssv"));
   			dpKZO.setCod(tbl.getValue("Fcod_kzo"));
   			dpSST.setCod(tbl.getValue("Fcod_sst"));
   			RBASEMIND.value = tbl.getValue("Fbasemind");
   			RFIKSSUM.value = tbl.getValue("FFIKSSUM");
   			RPREWOKL.value = tbl.getValue("FPREWOKL"); 
			RKOLST.value = tbl.getValue("FKOLST");   
			RKOD_UV.value = toScrObj(tbl.getValue("Fkod_uv"));			
   		}
   		tbl.close();
	}
	if(fwid_org>0)
	{
		org.setDat(RBDAT.value);
		org.setID(fwid_org);
	}
	if(fwid_cl>0 && extPar.mode=="EDIT")
		oPers.setFWID(fwid_cl);
	if(fvopl>0)
		dpVopl.setVopl(fvopl);
	if(fwid_kat>0)
		dpKodKat.setFWID(fwid_kat);
	if(fwid_zvan>0)
		dpKodZvan.setFWID(fwid_zvan);
	if(fwid_cldol>0)
	{
		dpDol.setFWID(fwid_cldol);
	}
	
	if(extPar.mode=="EDIT"){
		if(RFIKSSUM.value==null){	
			RFIKSSUM.value = 0;
		}
		if(RPREWOKL.value==null){		
   			RPREWOKL.value = 0;
   		}   		
		if(RBASEMIND.value==null){   		
   			RBASEMIND.value = d00;
   		}
   	}	
	
	if (RTABLE.value==1 && RTRSOG.value==false){	
		Disable(RTRSOG);
	}else{
		Enable(RTRSOG);		
	}	
	
	setValid(RBDAT, bdatValid);
	setValid(RTABLE, RTABLE_valid);	
	setWhen(RREASON,reasonWhen);
	oPers.addCondition("condition");
	oPers.updateCtrl();
	ctrlLinker.updateData(false);
	if(extPar.mode == "ADD")
		RDATZ.value = d00;
	getNextRowNum();
}

function onSave()
{
	ctrlLinker.updateData(true);
	//т.к. при редактировании condition отработает только один раз, то добавляем следующую проверку
	if(extPar.mode=="EDIT" && !oPers.isValid)
	{
		WAIT(lastMsg);
		return false;
	}
	var m = new Object();
	//obj.setVar("RCOD", oPers.getCod());
	if(extPar.mode != "EDIT")
    {
		var snap = getSnap("SELECT MAX(fid) FROM ^work_pers WHERE fwid_cl=" + sqlTo(oPers.getFWID()));
		if(snap && snap[0])
			m.FID = snap[0] + 1; 
		else
			m.FID = 1; 
		obj.setVar("RWID_WP", GetUID());
		fwid_dol = GetUID();
    }
    m.FWID = obj.getVar("HID");
	//поля относящиеся к STRU_DOL
	m.FWID_CLDOL = dpDol.getFWID();
	m.FOKLAD = ROKLAD.value;
	m.FSHPZ = dpShifPZ.getFshpz();
	m.FWID_ORG = org.getID();
	m.FCODDOL = dpDol.getCod();
	m.FBDATDOL = RBDAT.value;
	if(extPar.mode != "EDIT")
		m.FEDATDOL = d00;
	//поля относящиеся к WORK_PERS
	m.FWID_WP = obj.getVar("RWID_WP");
	m.FWID_CL = oPers.getFWID();
	m.FWID_DOL = fwid_dol;
	m.FBDAT = RBDAT.value;
	if(extPar.mode != "EDIT")
		m.FEDAT = d00;
	m.FWID_KAT = dpKodKat.getFWID();
	m.FWID_ZVAN = dpKodZvan.getFWID();
	m.FVOPL = dpVopl.getVopl();
	m.FAVANS = RAVANS.value;
	m.FTABLE = RTABLE.value;
	m.FNAZN = RNAZN.value;
	m.FINVAL = RINVAL.value;
	m.FPENS = RPENS.value;
	m.FIS_NAZN = RPRIEM.value;
	if(extPar.mode != "EDIT")
		m.FIS_UV = false;
	m.FIS_SERV = RZAPIS.value;
	//причина и испытательный срок будут дублироваться в PRK_IN и WORK_PERS, чтоб можно было их указывать и в ШР и в приказе
	m.FTERM = RTERM.value;
	m.FREASON = RREASON.value;
	//поля относящиеся к FULL_PERS использующиеся в гриде
	m.FCODPERS = oPers.getCod();
	m.FTXTPERS = oPers.getTxt();
	m.FTXTDOL = dpDol.getTxt();
	m.FTXTORG = org.getNazv();
	m.FDATZ = RDATZ.value;
	m.FNOM_STR = Fnom_str.value;
	//14.09.12
	m.FISMAIN = RISMAIN.value;
	m.FISTRSOG = RTRSOG.value;	
	m.FCOD_SSV = dpSSV.getCod();
	m.FCOD_KZO = dpKZO.getCod();
	m.FCOD_SST = dpSST.getCod();
	m.FFIKSSUM = RFIKSSUM.value;
	m.FBASEMIND = RBASEMIND.value;
	m.FPREWOKL = RPREWOKL.value;	
	m.FKOLST = RKOLST.value;	
	m.FKOD_UV = Number(RKOD_UV.value);	
	
	UpdateTable("tmp_full_pers", m, "EDIT"!=extPar.mode);
}

function bdatValid()
{
	org.setDat(RBDAT.value);
	if(differ(new Date(RBDAT.value),new Date(obj.parent.getVar("HDAT")))<0)
	{
		WAIT(UR("Дата призначення не може бути меншою за дату наказу!|Дата назначения не может быть меньше даты приказа!"));
		setFocus(RBDAT);
		return false;
	}
	if(differ(new Date(RBDAT.value),d00obj)==0)
	{
		WAIT(UR("Дата призначення не може бути порожньою!|Дата назначения не может быть пустой!"));
		setFocus(RBDAT);
		return false;
	}
	var snap = getSnap("select count(*) from ^full_pers where Fcodpers="+RTABN.value+" and Fwid>"+obj.parent.getVar("HID"));
	if(snap && snap[0]>0 && extPar.mode!="EDIT")
	{
		WAIT(UR("По даному співробітнику вже були зміни в ШР після прийняття в штат!|По даному сотруднику уже были изменения в ШР после его принятия в штат!"));
		return false;
	}
	return true;
}

function reasonWhen()
{
	if(differ(new Date(RDATZ.value),d00)!=0 && allt(RREASON.value)=="")
		RREASON.value = ru("заявление ","заява ")+getSmallFIO(String(RTABNTXT.value));
}

function RTABLE_valid()
{
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if (RTABLE.value!=1){
		Enable(RTRSOG)
	}else{
		if (RTABLE.value==1){
			RTRSOG.value=false;			
			Disable(RTRSOG);
		}	
	}
}

function condition(cod)
{
trace(">>> condition")
	var snap2 = getSnap("select Fwid from tmp_full_pers where Fcodpers="+sqlTo(cod)+" and Fwid<>"+obj.getVar("HID"));
	if(snap2)
	{
		WAIT(lastMsg=ru("Таб.№ "+cod+" уже используется в текущем приказе!","Таб.№ "+cod+" вже використовується в поточному наказі!"));
		return false;
	}
	var fwid_cl = getIDFromCod(cod);
	var strSQL = "SELECT MAX(fedat),MAX(fbdat),Fwid_cl"
				+ " FROM ^work_pers"
				+ " WHERE Fwid_cl="+fwid_cl
				+ " GROUP BY Fwid_cl";
	var snap = getSnap(strSQL);
	if(!snap || !snap[0] || differ(d00,snap[0])!=0 || extPar.mode=="EDIT")
	{
		if(RINVAL.value == false)
			checkInval(fwid_cl);
		if(RPENS.value == false)
			checkPens(fwid_cl);
		return true;
	}
	WAIT(lastMsg=ru("Таб.№ "+cod+" уже принят в штат с ","Таб.№ "+cod+" вже прийнят в штат з ")+format("dd.mm.yyyy",snap[1]));
	return false;
}

//проверяем наличие признака инвалидности в справочнике персонала
function checkInval(fwid_cl)
{
	var snap = getSnap("select Finval,Fbdatinval,Fedatinval from ^persfile where Fwid_cl="+fwid_cl);
	if(snap)
	{
		msg = ru("В личной карточке сотрудника проставлен признак инвалидности с "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставить этот признак в приказе?",
				"В особовій картці співробітника проставлено ознаку інвалідності з "+format("dd.mm.yy",snap[1])+(differ(d00,snap[2])==0?"":format(" по dd.mm.yy",snap[2]))+"\nПроставити цю ознаку в наказі?")
		if(snap[0]==true && differ(snap[2],RBDAT.value)>=0 && differ(snap[1],RBDAT.value)<=0 && confirm(msg))
			RINVAL.value = true;
	}
}

////проверяем наличие признака пенсионера в справочнике персонала
function checkPens(fwid_cl)
{
	var snap = getSnap("select Fpens,Fbdatpens from ^persfile where Fwid_cl="+fwid_cl);
	if(snap)
	{
		msg = ru("В личной карточке сотрудника проставлен признак пенсионера с "+format("dd.mm.yy",snap[1])+"\nПроставить этот признак в приказе?",
				"В особовій картці співробітника проставлено ознаку пенсіонера з "+format("dd.mm.yy",snap[1])+"\nПроставити цю ознаку в наказі?")
		if(snap[0]==true && confirm(msg))
			RPENS.value = true;
	}
}

function getNextRowNum()
{
	if ((extPar.mode == "COPY" || extPar.mode == "ADD") && extPar.strTempTableName)
		Fnom_str.value = findFreeClNo(extPar.strTempTableName, "fnom_str");
}

function init_RTABLE()
{
	RTABLE.addItem(1, "1: "+getTxtKatPersTbl5(1));
	RTABLE.addItem(2, "2: "+getTxtKatPersTbl5(2));
}
include("sys\\DpBaseDlg.js");