include ("objects/DpClEx.js");

var objDoc = extPar.doc;
var ctrlLinker = null;
var strTempTableName = getTmpTableName();
var tblRow = null;
var oldDat = d00obj;

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
   	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM", HNUMBER);
	ctrlLinker.addLink("HDAT", HBDAT);
	ctrlLinker.updateData(false);
	oldDat = new Date(HBDAT.value);
	HBDAT_valid();
   	this.sDocSourceDir = rootDirectory() + "docs//" + objDoc.sDocLbl + "//";
	this.initGrid = initGrid;
	this.initGrid(grRows, "grOut.xml");
	this.listMenuInit = listMenuInit;
	this.listMenuHandler = listMenuHandler;
	setValid(HBDAT, HBDAT_valid);
}

function onSave()
{
	ctrlLinker.updateData(true);
	storeBufToBase();
	if(null!=tblRow)
		tblRow.Close();
}

function onEscape()
{
	if(null!=tblRow)
		tblRow.Close();
}

function storeBufToBase()
{
	ExecuteSQL("UPDATE ^stru_dol SET Fedat="+sqlTo(d00)
				+" WHERE fwid IN (SELECT fwid_dol FROM ^work_pers "
					+" WHERE exists(SELECT fwid_wp FROM ^prk_out as p "
						+" WHERE ^work_pers.Fwid=p.Fwid_wp AND p.fwid_prk = " + sqlTo(objDoc.getID())+"))");
	ExecuteSQL("UPDATE ^work_pers SET Fedat="+sqlTo(d00)+", Fis_uv="+sqlFalse+", Freason_uv="+sqlTo("")+", Freason_uvst=0"
				+" WHERE exists(SELECT fwid FROM ^prk_out as p "
					+" WHERE ^work_pers.Fwid=p.Fwid_wp AND p.fwid_prk = " + sqlTo(objDoc.getID())+")");
	ExecuteSQL("DELETE FROM ^prk_out WHERE fwid_prk = " + sqlTo(objDoc.getID()));

	var strFLD = GetPatternIntersection("prk_out", "prk_out");
	var strSQL = "INSERT INTO ^prk_out (" + strFLD + ")"
			+ " SELECT " + strFLD + " FROM " + strTempTableName 
				+ " where exists(select Fwid from tmp_full_pers as f where " + strTempTableName + ".Fwid_wp=f.Fwid_wp)";
	ExecuteSQL(strSQL);
	
	strSQL = "update ^work_pers set Fis_uv="+sqlTrue
			+ " ,Fedat=(SELECT Fedat FROM tmp_full_pers as t where t.Fwid_wp=^work_pers.Fwid)"
			+ " ,Freason_uv=(SELECT Freason_uv FROM tmp_full_pers as t where t.Fwid_wp=^work_pers.Fwid)"
			+ " ,Freason_uvst=(SELECT Freason_stcod FROM tmp_full_pers as t where t.Fwid_wp=^work_pers.Fwid)"
				+ " WHERE fwid IN (SELECT fwid_wp FROM tmp_full_pers)";
	ExecuteSQL(strSQL);
	strSQL = "update ^stru_dol set Fedat=(select Fedatdol FROM tmp_full_pers as t where ^stru_dol.Fwid=t.Fwid_dol)"
				+ " where exists(select Fwid from tmp_full_pers as t where ^stru_dol.Fwid=t.Fwid_dol)";
	ExecuteSQL(strSQL);
	//сохраняем в справочник персонала дату и причину увольнения
	var t = OpenTable("select * from tmp_full_pers");
	var oCl = new DpClEx("CL3", getPar("CODPERS"));
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		oCl.clear();	
		oCl.loadByID(t.getValue("Fwid_cl"));
		oCl.setVar("HDIS_DAT",t.getValue("Fedat"));
		oCl.setVar("HDIS_MOT",t.getValue("Freason_uv"));
		oCl.setVar("HDIS_STAT",t.getValue("Freason_stcod"));
		oCl.save();
	}
	t.close();
}

function initGrid(gridCtrl, strFileName)
{
	var nID = (extPar.mode == "COPY")?objDoc.nOldID : objDoc.getID();
	//Временная таблица из щтатного расписания
	//CreateTable("tmp_work_pers", "work_pers");
	//var sFLD = GetPatternIntersection("work_pers", "work_pers");
	//чтоб не создавать несколько временных таблиц, создадим одну по представлению full_pers  
	DropTable("tmp_full_pers");
	var sSQL = "SELECT f.*,f.Fwid as Fwid_wp,p.Fdays_otp,p.Fdatz,p.Freason_stcod,p.Fnom_str INTO tmp_full_pers"
			+ " FROM ^full_pers as f inner join ^prk_out as p on f.Fwid=p.Fwid_wp "
			+ " WHERE p.Fwid_prk=" + sqlTo(nID);
	ExecuteSQL(sSQL);
	//заменим Fwid из таблицы prk_out
	ExecuteSQL("update tmp_full_pers set Fwid=(SELECT fwid FROM ^prk_out as p WHERE p.fwid_prk="+ sqlTo(nID) + " and p.Fwid_wp=tmp_full_pers.Fwid_wp)");

	var strSQL = " SELECT * "
			+ " INTO " + strTempTableName 
			+ " FROM ^prk_out"
			+ " WHERE fwid_prk=" + sqlTo(nID);
	ExecuteSQL(strSQL);
	
	tblRow = OpenTable("select * from tmp_full_pers order by Fnom_str, Fcodpers");
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_DISMOTIVE != "undefined")
		var codDisMotive = getPar(const_GETPAR_DISMOTIVE);
	else
		var codDisMotive = getPar("CDRSTATUV");
	tblRow.clTie("stat", "=" + codDisMotive + ", Freason_stcod");
	
	gridCtrl.setXMLDir(this.sDocSourceDir);
	gridCtrl.setXMLFile(strFileName);
	gridCtrl.setTable(tblRow);
	gridCtrl.setData("prk_out");
	gridCtrl.build();
	gridCtrl.loadMenuHandler(this,"listMenuInit");	
	gridCtrl.selectMenuHandler(this, "listMenuHandler");
}

function listMenuInit(grid)
{
	var tbl = grid.getTable();
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!tbl.isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Вилучити|Удалить");
	}
}

function listMenuHandler(sID, grid)
{
	if("DEL" ==sID)
	{
		strRU = "Удаление этой записи и последующее сохранение приказа №"+HNUMBER.value+"\nповлечет за собой изменение в штатном расписании даты окончания соответствующей записи.\nПродолжить?";
		strUA = "Видалення цього запису і подальше збереження наказу №"+HNUMBER.value+"\nспричинить за собою зміну в штатному розкладі дати закінчення відповідного запису.\nПродовжити?";
		if("n" == msgBox("yn", ru(strRU,strUA), ru("Удаление приказа","Видалення наказу")))
			return;
		objDoc.deleteRow("prk_out", Number(grid.getTable().getRowID()));
		ExecuteSQL("delete from "+strTempTableName+" where Fwid="+grid.getTable().getRowID());
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{
		var oDocRow;
		switch(sID)
		{
			case "ADD":
				oDocRow = objDoc.createRow("prk_out");
			break;
			case "EDIT":
				oDocRow = objDoc.getRow("prk_out", Number(grid.getTable().getRowID()));
			break;
			case "COPY":
				oDocRow = objDoc.copyRow("prk_out", Number(grid.getTable().getRowID()));
			break;
			default:
				return false;
		}
		var par = new Object();
		if(extPar.prk_fwid_cl)
			par.prk_fwid_cl = extPar.prk_fwid_cl;
		par.strTempTableName = strTempTableName;
		var bOK = oDocRow.edit(sID, par);
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				objDoc.appendRow("prk_out", oDocRow);
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, strTempTableName);
			grid.getTable().requery();
			grid.refresh();
		}
	}
}

function HBDAT_valid()
{
	objDoc.setVar("HDAT",HBDAT.value);//чтобы коректно работала валидность на дату принятия
	var newDat = new Date(HBDAT.value);
	if(differ(oldDat,newDat)!=0)
	{
		oldDat = newDat;
		var t = OpenTable("select * from tmp_full_pers");
		for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
		{
			if(differ(new Date(HBDAT.value),new Date(t.getValue("Fbdat")))>0)
			{
				var msg = UR("Дата звільнення таб.№ "+t.getValue("Fcodpers")+" меньша за дату документа!"
							+ "|Дата увольнения таб.№ "+t.getValue("Fcodpers")+" меньше чем дата документа!");
				cnfrm = msgBox("&*^ki", msg);
				if("*" == cnfrm)
				{
					oDocRow = objDoc.getRow("prk_out", t.getValue("Fwid"));
					var bOK = oDocRow.edit("EDIT");
					if (bOK)
					{
						obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, strTempTableName);
						grRows.getTable().requery();
						grRows.refresh();
					}
				}
				else if("i" == cnfrm)
				{
					break;
				}
			}
		}
		t.close();
		return true;
	}
	return true;
}

include("sys\\DpBaseDlg.js");