include("Objects\\DpVal.js");
include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");
include("Tmoney.js");
include("doc\\DpDoc.js");
include("Objects\\DpDocPar.js");

var edmode, t;
var cod_plat;
var oVal, oVal_spr, oOrg, oSc;
var objDoc = extPar.doc; 
var ctrlLinker = null;
var m_fwid;
var toSetPassportData;


function Load() 
{  
	toSetPassportData = objDoc.getPar("_setpassport");
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	//var objDoc = new DpDoc(tbl, null, extPar.doc, extPar.nop, extPar.fwid);
   	ctrlLinker = new DpCtrlLinker(objDoc);
   	    
   	HSUM.mask = MASK_SUM;
   	HNOM.mask = MASK_DOCNUM;
	HNDS.mask = MASK_SUM;
	HCOD.mask = "&&&&&&";
	setFocus(HNOM);
	edmode = extPar.mode;
	m_fwid = extPar.fwid;
	
	Disable(mFtsum);	
	
	setValid(HSUM, mFsum_Valid);
	setValid(HDAT, mFdoc_dat_Valid);
	setValid(HVAL, mFval_Valid);
	setValid(HNOM, mDocNum_Valid);
	setValid(HVDPL, mFfio_Valid);
	setWhen(HVDPL, mFfio_Valid);
	setValid(HDOP, DOP_Valid);
	setWhen(HDOP, DOP_Valid);
	          	
	//setValid(HOSN, mFosnov_Valid);

	cod_plat = 12; 
   	oOrg = new DpCl("0");
   	oOrg.setClcl(cod_plat);     
    
   	oSc = new DpSc("cutxyz");	
	oSc.linkCtrl(HSC, HSU, HST, HCLCOD1, HCLCOD2, HCLCOD3);
		
	oVal = new DpVal();
	oVal.linkCtrl(HVAL);
	 
   	//oVal.linkCtrlKurs(HVKURS);
   	
   	//if (mFhandnds.isChecked) mFhandnds = 1; else mFhandnds = 0;
   	   	
   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT); 
 	ctrlLinker.addLink("HSUM",HSUM); 
 	ctrlLinker.addLink("HCOD",HCOD); 
 	ctrlLinker.addLink("HNDS",HNDS);      
 	ctrlLinker.addLink("HVDPL",HVDPL);      
 	ctrlLinker.addLink("HOSN",HOSN);      
 	ctrlLinker.addLink("HDOP",HDOP); 
 	
 	ctrlLinker.addScLink("HSC","HSU","HST","HCLCOD1","HCLCOD2","HCLCOD3", oSc);
 	ctrlLinker.addLink("HANDNDS",mFhandnds);
 	ctrlLinker.addClLink("HVAL",oVal);
 	
 	ctrlLinker.updateData(false);
    
   	if (extPar.mode != "ADD")
   	{   			
   	}
   	else
   	{
   		mFhandnds.checked = (objDoc.getPar("__ndsproc") == 0||objDoc.getPar("__ndsproc") ==null );
   		mFtsum.value = TMoney(HSUM.value, oVal.getCod());	
		
   	}
   	
   	setValid(HDAT, mHDAT_Valid);
   	setValid(mFhandnds, mFhandnds_Valid);
    mFhandnds_Valid(); 
  
}
var escape;

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());

	//убираем знаки абзаца в поле "Підстава"
	var str = objDoc.getVar("HOSN");
	str = str.replace(/\r\n/g," ");
	objDoc.setVar("HOSN", str);
}

function mHDAT_Valid() 
{
   return differ(HDAT.value, d00);
}

function mFhandnds_Valid()
{
	Enable(HNDS, mFhandnds.checked); 
	mFsum_Valid();
}

function mFsum_Valid() 
{
   mFtsum.value=TMoney(HSUM.value,oVal.getCod()); 
   //mtsum.innerText=mFtsum.value;
   var ndsproc = objDoc.getPar("__ndsproc");
   if(!mFhandnds.checked)
      HNDS.value = round((HSUM.value*ndsproc)/(100+parseInt(ndsproc)),2);
   return true;
}

function mFval_Valid() 
{
    if(oVal.zSetNazv(HVAL.value))
   {
       HVAL.value = oVal.getNazv();
       mFtsum.value=TMoney(HSUM.value,oVal.getCod());
       //mtsum.innerText=mFtsum.value;
   }
   return true;
}

function mDocNum_Valid() 
{
	return;
	
	
   var ss;
   HNOM.value=allt(HNOM.value);
   ss=HNOM.value;
   var val = parseInt(ss);
//   if (ss==""||ss.charAt(0)<'0'||ss.charAt(0)>'9')
	if (!val || val == null || typeof(val) != "number" )
      {
         WAIT("Недопустимое значение поля!");
         return false;
      };
   //else
      //mtdocnum.innerText=mDocNum.value;
   return true;   
}

function mFdoc_dat_Valid() 
{
   var docdt = new Date(HDAT.value);
   if (docdt.getFullYear()==d00obj.getFullYear() && docdt.getMonth()==d00obj.getMonth() && docdt.getDate()==d00obj.getDate())
      return false;
   else
      return true;
}

function mFfio_Valid() 
{	
	var FioClNo = Number(objDoc.getPar("_fioclno"));
	
	
	// если не будет установлен параметр, то берем из 1-го справочника
	
	if (!FioClNo)
	{
		FioClNo = getNomClVIDPers(oSc);
	}
		

	if(FioClNo <= 1 && allt(HVDPL.value) == "")
		oSc.linkCtrlTxtStCl1doc(HVDPL);
	else if (FioClNo == 2 && allt(HVDPL.value) == "")
		oSc.linkCtrlTxtStCl2doc(HVDPL);
	else if (FioClNo == 3 && allt(HVDPL.value) == "")  
		oSc.linkCtrlTxtStCl3doc(HVDPL);
	//else   
		//mtfio.innerText = mFfio.value;
   
   return true;

}

function DOP_Valid() 
{	
	if(!toSetPassportData)
		return;
	if (allt(HDOP.value) != "")
		return;
	
	var FioClNo = Number(objDoc.getPar("_fioclno"));
	
	if (!FioClNo)
	{
		FioClNo = getNomClVIDPers(oSc);
	}
	
	if (FioClNo == 0)
		return;
		
	var nCL = 0;
	var e = null;
	try
	{
		nCL = oSc["getClcl" + FioClNo]();
	}
	catch(e)
	{
		
	}	
	
	if (nCL == 0 || !isClTypePers(nCL))
	{
		return;	
	}
	
	var nCod = 0;
	try
	{
		nCod = document["HCLCOD" + FioClNo].value;
	}
	catch(e)
	{
		
	}
	
	if (nCod == 0)
		return;		
	var sql = "select fdocser, fdocnom, fdocown, fdocdat from ^LISTCL3 " 
			+ "where fcl = " + nCL + " AND fcod = " + nCod;
	
	var oSnap = getSnap(sql);
	
	if (oSnap == null)
		return;		
	
	var docser = allt(oSnap[0]);
	var docnum = allt(oSnap[1]);
	var docown = allt(oSnap[2]);
	var docdat = oSnap[3];
	
	if (!docser || !docnum || !docown)
		return;
		
	var text = docser + " " + docnum + UR(" виданий | выдан ") +  docown + format(" dd.mm.yyyy",docdat) ;
	HDOP.value = text;
}

function getNomClVIDPers(oSC)
{
	if (isClTypePers(oSc.getClcl1()))
		return 1;
		
	if (isClTypePers(oSc.getClcl2()))
		return 2;
		
	if (isClTypePers(oSc.getClcl3()))
		return 3;		
	
	return 0;	
		
}

function isClTypePers(nCL)
{
	if (isNaN(nCL))
		return false;
		
	nCl = Number(nCL);
	
	/*
	var oSnap = getSnap("select fvid from ^clcl where fcod = " + nCl);
	if (oSnap && oSnap[0] == 3)
		return true;
	*/ 
	
	var bRet = (nCL == Number(getPar("CODPERS")));
	if (bRet)
		return true;
		
	var oSnap = getSnap("select FVID from ^clcl where fcod = " + sqlTo(Number(nCl)));
	if (oSnap && oSnap[0] == "3")	
		return true;
	return false;		 	
}

include("sys\\DpBaseDlg.js");