include("servis/zrp.js");
include("Objects/DpAskEx.js");

function docMenuInit()
{
	this.dataSrc.AddMenuItem("", "");
	if(this.tbl.rowCount>0)
    	this.dataSrc.AddMenuItem("MAKE_1DF","Сформувати накази ПП для 1-ДФ в обліку з/п|Сформировать приказы ЧП для 1-ДФ в учете з/п");
}

function docMenuHandler(nID)
{
    switch (nID)
    {
        case "MAKE_1DF":
        	var snap = getSnap("select Fvid, Fis_slct, Fnazv from ^cl_prik where LOWER(Fedit)="+sqlTo("_df2"));
        	if(!snap)
        	{
        		alert(ru("Приказ 'ЧП для 1-ДФ' отсутствует в списке доплат и удержаний!\nВ меню '"+getMenuItemPath("l_clprik.js","l","N")+"' добавьте соответствующий приказ типа _df2.",
        				"Наказ 'ПП для 1-ДФ' відсутній у списку доплат та утримань!\nВ меню '"+getMenuItemPath("l_clprik.js","l","N")+"' додайте відповідний наказ типу _df2."));
        		return false;
        	}
        	var fvid = snap[0];
        	var vidnach = 42;
        	var msg = ru("Приказ '"+snap[2]+"' (код: "+snap[0]+") отключен в перечне доплат и удержаний.\nПродолжить формирование приказов?",
        				"Наказ '"+snap[2]+"' (код: "+snap[0]+") вимкнут в переліку допплат та утримань.\nПродолжить формування наказів?");
        	if(!snap[1] && !confirm(msg))
        		return false;
        	var tbl = OpenTable("select * from ^CAS_ORD where Fwid "+grid.sqlSelected(true)+" order by Fdoc_dat, Fdoc_num");
        	var step = 1;
        	var kol = 0;
        	var kolUpd = 0;
        	var showErrInd = true;
        	var toAsk = true;
        	var action = 0;
			setProgressRange(step, tbl.rowCount);
        	for(; !tbl.IsEOF(); tbl.MoveNext())
        	{
        		setProgressPos(step, step+"/"+tbl.rowCount);
        		step++;
        		var dat = quarter_begin(tbl.getValue("Fdoc_dat"));
        		var ind = getPlatOKPO(tbl.getValue("Fsc"),tbl.getValue("Fsu"),tbl.getValue("Fst"),tbl.getValue("Fcl_cod1"),tbl.getValue("Fcl_cod2"),tbl.getValue("Fcl_cod3"));
        		var sum = Number(tbl.getValue("Fsum"));
        		if(ind.length>0)
        		{
	        		var snap = getSnap("select p.Fbdat, c.TIN, p.Fsum, c.Fwid "
	        					+" from ^prk_all as p INNER JOIN ^PRK8DRD as c ON p.Fwid=c.Fwid"
	        					+" where p.Fbdat="+sqlTo(dat)+" and c.TIN="+sqlTo(ind)+" and c.Fvidnach="+vidnach);
	        		if(snap)
	        		{
						if(toAsk)
						{
							var oAsk = new DpAskEx();
							oAsk.setCaption(ru("Выбор действия для существующих приказов","Вибір дії для існуючих наказів"));
							var msg = ru("Найден приказ для "+tbl.getValue("Ffio")+"\nна "+format("dd.mm.yyyy",snap[0])+", идент.№ "+snap[1]+", сумма: "+snap[2]+"\nПо документу № "+tbl.getValue("Fdoc_num")+" от "+format("dd.mm.yyyy",tbl.getValue("Fdoc_dat"))+" на сумму "+tbl.getValue("Fsum"),
										"Знайдено наказ для "+tbl.getValue("Ffio")+"\nна "+format("dd.mm.yyyy",snap[0])+", ідент.№ "+snap[1]+", сума: "+snap[2]+"\nПо документу № "+tbl.getValue("Fdoc_num")+" від "+format("dd.mm.yyyy",tbl.getValue("Fdoc_dat"))+" на суму "+tbl.getValue("Fsum"));
							oAsk.add("REM", msg, "FREM");
							oAsk.add("RADIO", "Дія|Действие", "FACTION", 1, ru("Создать отдельный приказ","Сворити наказ окремо")+"|"+ru("Создать приказ, удалив найденый","Створити наказ, видаливши знайдений")+"|"+ru("Добавить сумму к найденному","Додати суму до знайденого"));
							oAsk.add("B", "Запом'ятати|Запомнить", "TOREPEAT", false);
							setProgressPos(0);
							oAsk.doAsk();
							if(oAsk.escape)
								break;
							setProgressPos(step, step+"/"+tbl.rowCount);
							action = oAsk.get("FACTION");
							toAsk = !oAsk.get("TOREPEAT");
						}
						switch(Number(action))
						{
							case 1:
								var oPrik = new DpPrik("_DF2", fvid);
								//oPrik.loadByID(snap[3]);
								oPrik.del(snap[3]);
							case 0:
								addPrikDf2(fvid, dat, vidnach, ind, sum, sum, 0, 0);
    	    					kol++;
							break;
							case 2:
								var oPrik = new DpPrik("_DF2", fvid);
								oPrik.loadByID(snap[3]);
								oPrik.setVar("FSUM",Number(oPrik.getVar("FSUM"))+sum);
								oPrik.setVar("FSUMN",Number(oPrik.getVar("FSUMN"))+sum);
								oPrik.setVar("FIN_TABLE","PRK8DRD");
								oPrik.save();
								kolUpd++;
							break;
						}
	        		}
	        		else
	        		{
	        			addPrikDf2(fvid, dat, vidnach, ind, sum, sum, 0, 0);
    	    			kol++;
	        		}
        		}
        		else
        		{
        			var msg = ru("Не удалось определить идентификационный код у ","Не вдалося визначити ідентифікаційний код у ")
        					+tbl.getValue("Ffio")+ru("Показывать это сообщение в дальнейшем?","Показувати це повідомлення надалі?");
        			if(showErrInd)
        			{
        				setProgressPos(0);
        				if(!confirm(msg))
        					showErrInd = false;
        				setProgressPos(step, step+"/"+tbl.rowCount);
        			}
        		}
        	}
        	setProgressPos(0);
        	tbl.close();
        	alert(ru("Кол-во созданных приказов: ","Кількість створених наказів: ")+kol+(kolUpd>0?"\n"+ru("Кол-во обновленных приказов: ","Кількість оновлених наказів: ")+kolUpd:""));
        break;
    }
}

function getPlatOKPO(sc,su,st,cod1,cod2,cod3)
{
	var cl = 0;
	var cod = cod1;
	var snap = getSnap("select Fcl1, Fcl2, Fcl2 from ^cl_schet where Fschet="+sc+" and Fsubschet="+su+" and Fstat="+st);
	if(snap)
	{
		for(var i in snap)
		{
			if(isClTypePlat(snap[i]))
			{
 				cl = snap[i];
				eval("cod = cod"+(Number(i)+1)); 
				break;
			}
		}
		if(cl>0)
			return tforg("OKPO", cod);
	}
	return "";
}

function isClTypePlat(nCL)
{
	if (isNaN(nCL))
		return false;
		
	nCl = Number(nCL);
	
	var bRet = (nCL>0 && nCL == Number(getPar("CODPLAT")));
	if (bRet)
		return true;
		
	var oSnap = getSnap("select FVID from ^clcl where fcod = " + sqlTo(Number(nCl)));
	if (oSnap && oSnap[0] == "2")	
		return true;
	return false;		 	
}