include ("Objects\\DpCl.js");
include("Objects\\DpCtrlLinker.js");
include ("Objects\\DpVal.js");
include ("sys\\mask.js");
//include("Objects\\DpPostRs.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var oOrg;
var param;
var oOrgRs;
var m_zntbl;
var edmode = extPar.mode;
var oShv, oShvd;
var oOl;
var oType;
var oState;
var oVid;
var oPodr;
var oVal;

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));

	ctrlLinker = new DpCtrlLinker(objDoc);

	HDOG_NUM.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	HSUM_DOG.mask=MASK_SUM;
	HSUMAV.mask=MASK_SUM;
	HSAL_OPL.mask=MASK_SUM;
	HSAL_VYK.mask=MASK_SUM;
	HAVANS.mask="###"

	
	oOrg0 = new DpCl();
	oOrg0.setClcl(getPar("CODMYORG"));
	oOrg0.linkCtrl(HORG0);
	oOrg0.linkCtrl2("Ftxt", HORG0TXT);	
		
	oOrg = new DpCl();
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkCtrl(HORG);
	oOrg.linkCtrl2("Ftxt", HORGTXT);
	//oOrg.setContAssist();
	
	oOl = new DpCl("0");
	oOl.setClcl(getOrgVar('HOZPERS',true)==null?getPar('CODPERS'):getOrgVar('HOZPERS',true));
	oOl.linkCtrl(HOL);
	oOl.linkCtrl2("Ftxt",HOL_TXT);
	//oOl.setContAssist();
	
	oType = new DpCl("0");
	oType.setClcl(objDoc.getPar("__cl_type_dog"));
	oType.linkCtrl(HTYPE_DOG);
	oType.linkCtrl2("Ftxt",HTYPE_DOG_TXT);
	//oType.setContAssist();

	oPodr = new DpCl();
	oPodr.setClcl(getPar("CODPODR"));
	oPodr.linkCtrl(HPODR);
	oPodr.linkCtrl2("Ftxt", HPODR_TXT);
	
	oState = new DpCl("0");
	oState.setClcl(objDoc.getPar("__cl_state_dog"));
	oState.linkCtrl(HSTATE_DOG);
	oState.linkCtrl2("Ftxt",HSTATE_DOG_TXT);
	
	oVal = new DpVal();
	oVal.linkCtrl(HVAL);
	
	m_zntbl = edmode=="EDIT" || edmode=="COPY";
	
	ctrlLinker.addLink("HDAT",HDAT);
	ctrlLinker.addClLink("HORG0",oOrg0);     
   	ctrlLinker.addClLink("HORG",oOrg);     
  	ctrlLinker.addLink("HTXT",HTXT);
  	ctrlLinker.addLink("HEDAT",HEDAT);
  	ctrlLinker.addLink("HBDAT",HBDAT);
  	ctrlLinker.addLink("HCOD",HCOD);
  	ctrlLinker.addLink("HDOG_NUM",HDOG_NUM);
  	ctrlLinker.addClLink("HOL",oOl);
  	ctrlLinker.addLink("HSUM_DOG",HSUM_DOG);
  	ctrlLinker.addLink("HTYPE_DOG",HTYPE_DOG);
	ctrlLinker.addLink("HAVANS_DAT",HAVANS_DAT);
	ctrlLinker.addLink("HAVANS",HAVANS);
	ctrlLinker.addLink("HDAT_SAL",HDAT_SAL);
	ctrlLinker.addLink("HSAL_OPL",HSAL_OPL);
	ctrlLinker.addLink("HSAL_VYK",HSAL_VYK);
	ctrlLinker.addLink("HOPL_TYPE", HOPL_TYPE);
  	ctrlLinker.addClLink("HPODR",oPodr);
  	ctrlLinker.addLink("HREM",HREM);
  	ctrlLinker.addLink("HSTATE_DOG",HSTATE_DOG);
	ctrlLinker.addLink("HSTATE_DAT",HSTATE_DAT);
	
 	ctrlLinker.updateData(false);
 	oVal.setCod(objDoc.getVar("HVAL"));        
 	 	
 	if (edmode != "ADD")
 	{
 		//oOrg.setClcl(getPar("CODPLAT"));
        //oOrg.setCod(objDoc.getVar("HORG"));
        oOl.setCod(objDoc.getVar("HOL"));
        oType.setCod(objDoc.getVar("HTYPE_DOG"));
        //oPodr.setCod(objDoc.getVar("HPODR"));
        oState.setCod(objDoc.getVar("HSTATE_DOG"));
        
 	}
 	else
 	{
 		setValid(HBDAT,srok);
 		srok();
 	}
 	Disable(HSUMAV);
 	
 	setValid(HAVANS,avans);
 	setValid(HSUM_DOG,avans);
 	
 	avans();
 	 	
}
function srok()
{
	var dat = HBDAT.value;
	var dat_srok = new Date(dat.getYear()+1900,dat.getMonth(),dat.getDate()+10);
	if(differ(HAVANS_DAT.value, d00) == 0)
		HAVANS_DAT.value = dat_srok.getVarDate();
	var dat_end = new Date(dat.getYear()+1900,11,31);
	if(differ(HEDAT.value, d00) == 0)
		HEDAT.value = dat_end.getVarDate();
	return true;
	
}
function avans()
{
	HSUMAV.value = Number(HSUM_DOG.value)/100*Number(HAVANS.value);
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());
}

include("sys\\DpBaseDlg.js");