include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpPostRs.js");
include("Objects\\DpNmkl.js");
include("objects\\DpRasSc.js");
include("doc\\dpDoc.js");
include("sys\\dbase.js");
include("Objects\\DpCtrlLinker.js");

var table, objDoc, objPotr, objPlat, objPost, objPostRs;
var oNmkl1, oNmkl2, oNmkl3, oNmkl4, oNmkl5, oNmkl6, oNmkl7, oNmkl8, oNmkl9, oNmkl10, oNmkl11, oNmkl12, mode, oRasSc;
var Validation = true;
var objDoc = extPar.doc;

function Load()
{
	HNOM.mask = MASK_DOCNUM;
	HTFIO.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	HPASSER.mask = "&&&&&&&&";	
	HPASNOM.mask = "&&&&&&&&&&";
	HPASVID.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	//HSFNUM.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&";	
    HSFSUM.mask = MASK_SUM;
	HKLTEL.mask = "&&&&&&&&&&&";
	HKLNUM.mask = "#######";	
	HKOL1.mask = MASK_KOL;
	HKOL2.mask = MASK_KOL;			
	HKOL3.mask = MASK_KOL;		
	HKOL4.mask = MASK_KOL;
	HKOL5.mask = MASK_KOL;	
	HKOL6.mask = MASK_KOL;	
	HKOL7.mask = MASK_KOL;
	HKOL8.mask = MASK_KOL;	
	HKOL9.mask = MASK_KOL;	
	HKOL10.mask = MASK_KOL;	
	HKOL11.mask = MASK_KOL;
	HKOL12.mask = MASK_KOL;			
	Enable(HKLNUM);		
	Enable(HKLTEL);		
	Enable(HSFSUM);		

	setValid(HDATEND, DOV_SROK_Valid);
	setValid(HDAT, FDOC_DAT_Valid);	
	setValid(HPASDAT, PASP_DAT_Valid);
	//setValid(DAT_KL, DAT_KL_Valid);			

//    objDoc = new dpDoc(table,null,extPar.fdoc,extPar.fnop,extPar.fwid);
//    objDoc.editInit(extPar.mode, DOC_NUM);

   	objPotr = new DpCl("0");   
   	objPotr.linkCtrl(HPOTR,HPOTR_N);
	objPotr.setClcl(getPar("CODPLAT"));
	setValid(HPOTR, POTR_Valid);

  	objPlat = new DpCl("0");
   	objPlat.linkCtrl(HPLAT,HPLAT_N);
	objPlat.setClcl(getPar("CODPLAT"));	
	setValid(HPLAT, PLAT_Valid);
	
	objPost = new DpCl();
   	objPost.linkCtrl(HPOST,HPOST_N);
	objPost.setClcl(getPar("CODPLAT"));
	
	var nCl = objDoc.getPar("__nsan");
	if (!nCl)
		nCl = getPar("CODPERS");
	objVed = new DpCl();
   	objVed.linkCtrl(HFIO,HTFIO);
	objVed.setClcl(nCl);	
	objVed.linkCtrl2("FDOCSER",HPASSER);
	objVed.linkCtrl2("FDOCNOM",HPASNOM);
	objVed.linkCtrl2("FDOCDAT",HPASDAT);
	objVed.linkCtrl2("FDOCOWN",HPASVID);
  	
    oNmkl1 = new DpNmkl();	
	oNmkl1.CanSelectAll = true;   
	oNmkl1.CanEmpty = true;
	oNmkl1.linkCtrl(HNMK1,HNAZV1,HNAZV_E1);
	
    oNmkl2 = new DpNmkl();
  	oNmkl2.CanSelectAll = true;      
	oNmkl2.CanEmpty = true;
	oNmkl2.linkCtrl(HNMK2,HNAZV2,HNAZV_E2);

    oNmkl3 = new DpNmkl();    
	oNmkl3.CanSelectAll = true;      
	oNmkl3.CanEmpty = true;
	oNmkl3.linkCtrl(HNMK3,HNAZV3,HNAZV_E3);

    oNmkl4 = new DpNmkl();    
	oNmkl4.CanSelectAll = true;      
	oNmkl4.CanEmpty = true;
	oNmkl4.linkCtrl(HNMK4,HNAZV4,HNAZV_E4);

    oNmkl5 = new DpNmkl();   
	oNmkl5.CanSelectAll = true;      
	oNmkl5.CanEmpty = true;
	oNmkl5.linkCtrl(HNMK5,HNAZV5,HNAZV_E5);

    oNmkl6 = new DpNmkl();   
	oNmkl6.CanSelectAll = true;      
	oNmkl6.CanEmpty = true;
	oNmkl6.linkCtrl(HNMK6,HNAZV6,HNAZV_E6);

    oNmkl7 = new DpNmkl();   
	oNmkl7.CanSelectAll = true;      
	oNmkl7.CanEmpty = true;
	oNmkl7.linkCtrl(HNMK7,HNAZV7,HNAZV_E7);

    oNmkl8 = new DpNmkl();   
	oNmkl8.CanSelectAll = true;      
	oNmkl8.CanEmpty = true;
	oNmkl8.linkCtrl(HNMK8,HNAZV8,HNAZV_E8);

    oNmkl9 = new DpNmkl();   
	oNmkl9.CanSelectAll = true;      
	oNmkl9.CanEmpty = true;
	oNmkl9.linkCtrl(HNMK9,HNAZV9,HNAZV_E9);

    oNmkl10 = new DpNmkl();   
	oNmkl10.CanSelectAll = true;      
	oNmkl10.CanEmpty = true;
	oNmkl10.linkCtrl(HNMK10,HNAZV10,HNAZV_E10);

    oNmkl11 = new DpNmkl();   
	oNmkl11.CanSelectAll = true;      
	oNmkl11.CanEmpty = true;
	oNmkl11.linkCtrl(HNMK11,HNAZV11,HNAZV_E11);

    oNmkl12 = new DpNmkl();   
	oNmkl12.CanSelectAll = true;      
	oNmkl12.CanEmpty = true;
	oNmkl12.linkCtrl(HNMK12,HNAZV12,HNAZV_E12);

	ctrlLinker = new DpCtrlLinker(objDoc);

	ctrlLinker.addLink("HNOM",HNOM);
	ctrlLinker.addLink("HDATEND",HDATEND);
	//ctrlLinker.addLink("HPOTR",HPOTR);
	//ctrlLinker.addLink("HPLAT",HPLAT);
	ctrlLinker.addLink("HRS",HRS);
	ctrlLinker.addLink("HBNK",HBNK);
	ctrlLinker.addLink("HDAT",HDAT);
	ctrlLinker.addLink("HTFIO",HTFIO);
	ctrlLinker.addLink("HPASSER",HPASSER);
	ctrlLinker.addLink("HPASNOM",HPASNOM);
	ctrlLinker.addLink("HPASDAT",HPASDAT);
	ctrlLinker.addLink("HPASVID",HPASVID);
	//ctrlLinker.addLink("HPOST",HPOST);
	//ctrlLinker.addLink("HNMK1",HNMK1);
	ctrlLinker.addLink("HKOL1",HKOL1);
	//ctrlLinker.addLink("HNMK2",HNMK2);
	ctrlLinker.addLink("HKOL2",HKOL2);
	//ctrlLinker.addLink("HNMK3",HNMK3);
	ctrlLinker.addLink("HKOL3",HKOL3);
	//ctrlLinker.addLink("HNMK4",HNMK4);
	ctrlLinker.addLink("HKOL4",HKOL4);
	//ctrlLinker.addLink("HNMK5",HNMK5);
	ctrlLinker.addLink("HKOL5",HKOL5);
        //ctrlLinker.addLink("HNMK6",HNMK6);
	ctrlLinker.addLink("HKOL6",HKOL6);
	//ctrlLinker.addLink("HNMK7",HNMK7);
	ctrlLinker.addLink("HKOL7",HKOL7);
	//ctrlLinker.addLink("HNMK8",HNMK8);
	ctrlLinker.addLink("HKOL8",HKOL8);
	//ctrlLinker.addLink("HNMK9",HNMK9);
	ctrlLinker.addLink("HKOL9",HKOL9);
        //ctrlLinker.addLink("HNMK10",HNMK10);
	ctrlLinker.addLink("HKOL10",HKOL10);
	//ctrlLinker.addLink("HNMK11",HNMK11);
	ctrlLinker.addLink("HKOL11",HKOL11);
	//ctrlLinker.addLink("HNMK12",HNMK12);
	ctrlLinker.addLink("HKOL12",HKOL12);		
	ctrlLinker.addLink("HOBMEN",HOBMEN);
	ctrlLinker.addLink("HKLNUM",HKLNUM);
	ctrlLinker.addLink("HKLTEL",HKLTEL);
	ctrlLinker.addLink("HSFNUM",HSFNUM);
	ctrlLinker.addLink("HSFSUM",HSFSUM);
		
  	if (extPar.mode != "ADD")
   	{
   		oNmkl1.setCod(objDoc.getVar("HNMK1"));
		oNmkl2.setCod(objDoc.getVar("HNMK2"));
		oNmkl3.setCod(objDoc.getVar("HNMK3"));
		oNmkl4.setCod(objDoc.getVar("HNMK4"));
		oNmkl5.setCod(objDoc.getVar("HNMK5"));
		oNmkl6.setCod(objDoc.getVar("HNMK6"));
		oNmkl7.setCod(objDoc.getVar("HNMK7"));
		oNmkl8.setCod(objDoc.getVar("HNMK8"));
		oNmkl9.setCod(objDoc.getVar("HNMK9"));
		oNmkl10.setCod(objDoc.getVar("HNMK10"));
		oNmkl11.setCod(objDoc.getVar("HNMK11"));
		oNmkl12.setCod(objDoc.getVar("HNMK12"));
   		objPotr.setCod(objDoc.getVar("HPOTR"));
   		objPlat.setCod(objDoc.getVar("HPLAT"));   		
   		objPost.setCod(objDoc.getVar("HPOST"));
   		objVed.setCod(objDoc.getVar("HFIO")); 
   		
   		//oRasSc.set(objDoc.getVar("HRS")); 
   					
   		if (oNmkl1.getCod()!="")
		{
			Enable(HKOL1);
			if(oNmkl1.ctrlEdi.length>1)
				Enable(oNmkl1.ctrlEdi);
		}
		if (oNmkl2.getCod()!="")
		{
			Enable(HKOL2);
			if(oNmkl2.ctrlEdi.length>1)
				Enable(oNmkl2.ctrlEdi);
		}
		if (oNmkl3.getCod()!="")
		{
			Enable(HKOL3);
			if(oNmkl3.ctrlEdi.length>1)
				Enable(oNmkl3.ctrlEdi);
		}
		if (oNmkl4.getCod()!="")
		{
			Enable(HKOL4);
			if(oNmkl4.ctrlEdi.length>1)
				Enable(oNmkl4.ctrlEdi);
		}
		if (oNmkl5.getCod()!="")
		{
			Enable(HKOL5);
			if(oNmkl5.ctrlEdi.length>1)
				Enable(oNmkl5.ctrlEdi);
		}  	

		if (oNmkl6.getCod()!="")
		{
			Enable(HKOL6);
			if(oNmkl6.ctrlEdi.length>1)
				Enable(oNmkl6.ctrlEdi);
		} 

		if (oNmkl7.getCod()!="")
		{
			Enable(HKOL7);
			if(oNmkl7.ctrlEdi.length>1)
				Enable(oNmkl7.ctrlEdi);
		}  

		if (oNmkl8.getCod()!="")
		{
			Enable(HKOL8);
			if(oNmkl8.ctrlEdi.length>1)
				Enable(oNmkl8.ctrlEdi);
		}  	
		if (oNmkl9.getCod()!="")
		{
			Enable(HKOL9);
			if(oNmkl9.ctrlEdi.length>1)
				Enable(oNmkl9.ctrlEdi);
		}  	

		if (oNmkl10.getCod()!="")
		{
			Enable(HKOL10);
			if(oNmkl10.ctrlEdi.length>1)
				Enable(oNmkl10.ctrlEdi);
		} 

		if (oNmkl11.getCod()!="")
		{
			Enable(HKOL11);
			if(oNmkl11.ctrlEdi.length>1)
				Enable(oNmkl11.ctrlEdi);
		}  

		if (oNmkl12.getCod()!="")
		{
			Enable(HKOL12);
			if(oNmkl12.ctrlEdi.length>1)
				Enable(oNmkl12.ctrlEdi);
		}  												 							
   	}
   	
   	//oRasSc = new DpRasSc();
	//oRasSc.linkCtrl(HRS, null, HBNK);
	oRasSc = new DpPostRs();
  	oRasSc.setDpCl(objPlat, true);
   	oRasSc.linkCtrl(HRS, null, HBNK);
	
   	if (extPar.mode=="ADD")
	{
		//oRasSc.setRasScAttr();
		HOBMEN.checked = true;		
	}	
	
	ctrlLinker.updateData(false);   	
   	   		
	setValid(HOBMEN, OBMEN_onclick);
	
	setValid(HNMK1, NMK1_Valid);
	setValid(HNMK2, NMK2_Valid);			   				   
	setValid(HNMK3, NMK3_Valid);			   	
	setValid(HNMK4, NMK4_Valid);			   	
	setValid(HNMK5, NMK5_Valid);			   	
	setValid(HNMK6, NMK6_Valid);			   	
	setValid(HNMK7, NMK7_Valid);			   	
	setValid(HNMK8, NMK8_Valid);
	setValid(HNMK9, NMK9_Valid);			   	
	setValid(HNMK10, NMK10_Valid);			   	
	setValid(HNMK11, NMK11_Valid);			   	
	setValid(HNMK12, NMK12_Valid);			   	

	//objPostRs = new DpPostRs();
	//objPostRs.setDpCl(objPlat, (mode=="EDIT" || mode=="COPY") && objPlat.getCod() != 0);
	//objPostRs.linkCtrl(HRS, null, HBNK);
		
	OBMEN_onclick()
	POTR_Valid();
	PLAT_Valid();
	NMK1_Valid();
	NMK2_Valid();
	NMK3_Valid();
	NMK4_Valid();
	NMK5_Valid();
	NMK6_Valid();
	NMK7_Valid();
	NMK8_Valid();
	NMK9_Valid();
	NMK10_Valid();
	NMK11_Valid();
	NMK12_Valid();
	
	setFocus(HDATEND);
}

function DOV_SROK_Valid()
{
	if (HDATEND.value <= d00 && HDATEND.value >= d00)
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
	return true;
}

function FDOC_DAT_Valid()
{
	if (HDAT.value <= d00 && HDAT.value >= d00)
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
	return true;
}

function PASP_DAT_Valid()
{
	if (HPASDAT.value <= d00 && HPASDAT.value >= d00)
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
	return true;
}
/*
function DAT_KL_Valid()
{
	if (DAT_KL.value <= d00 && DAT_KL.value >= d00)
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
	return true;
}
*/
function NMK1_Valid()
{
	if (oNmkl1.getCod()!="")
	{
		Enable(HKOL1);
		if(oNmkl1.ctrlEdi.length>1)
			Enable(oNmkl1.ctrlEdi)
		else
			Disable(oNmkl1.ctrlEdi);	
	}
	else
	{
		Disable(HKOL1);
		Disable(oNmkl1.ctrlEdi);	
	}
	return true;
}

function NMK2_Valid()
{
	if (oNmkl2.getCod()!="")
	{
		Enable(HKOL2);
		if(oNmkl2.ctrlEdi.length>1)
			Enable(oNmkl2.ctrlEdi)
		else
			Disable(oNmkl2.ctrlEdi);	
	}
	else
	{
		Disable(HKOL2);
		Disable(oNmkl2.ctrlEdi);	
	}
	return true;
}

function NMK3_Valid()
{
	if (oNmkl3.getCod()!="")
	{
		Enable(HKOL3);
		if(oNmkl3.ctrlEdi.length>1)
			Enable(oNmkl3.ctrlEdi)
		else
			Disable(oNmkl3.ctrlEdi);	
	}
	else
	{
		Disable(HKOL3);
		Disable(oNmkl3.ctrlEdi);	
	}
	return true;
}

function NMK4_Valid()
{
	if (oNmkl4.getCod()!="")
	{
		Enable(HKOL4);
		if(oNmkl4.ctrlEdi.length>1)
			Enable(oNmkl4.ctrlEdi)
		else
			Disable(oNmkl4.ctrlEdi);
	}
	else
	{
		Disable(HKOL4);
		Disable(oNmkl4.ctrlEdi);	
	}
	return true;
}

function NMK5_Valid()
{
	if (oNmkl5.getCod()!="")
	{
		Enable(HKOL5);
		if(oNmkl5.ctrlEdi.length>1)
			Enable(oNmkl5.ctrlEdi)
		else
			Disable(oNmkl5.ctrlEdi);	
	}
	else
	{
		Disable(HKOL5);
		Disable(oNmkl5.ctrlEdi);	
	}
	return true;
}

function NMK6_Valid()
{
	if (oNmkl6.getCod()!="")
	{
		Enable(HKOL6);
		if(oNmkl6.ctrlEdi.length>1)
			Enable(oNmkl6.ctrlEdi)
		else
			Disable(oNmkl6.ctrlEdi);	
	}
	else
	{
		Disable(HKOL6);
		Disable(oNmkl6.ctrlEdi);	
	}
	return true;
}

function NMK7_Valid()
{
	if (oNmkl7.getCod()!="")
	{
		Enable(HKOL7);
		if(oNmkl7.ctrlEdi.length>1)
			Enable(oNmkl7.ctrlEdi)
		else
			Disable(oNmkl7.ctrlEdi);	
	}
	else
	{
		Disable(HKOL7);
		Disable(oNmkl7.ctrlEdi);	
	}
	return true;
}

function NMK8_Valid()
{
	if (oNmkl8.getCod()!="")
	{
		Enable(HKOL8);
		if(oNmkl8.ctrlEdi.length>1)
			Enable(oNmkl8.ctrlEdi)
		else
			Disable(oNmkl8.ctrlEdi);	
	}
	else
	{
		Disable(HKOL8);
		Disable(oNmkl8.ctrlEdi);	
	}
	return true;
}

function NMK9_Valid()
{
	if (oNmkl9.getCod()!="")
	{
		Enable(HKOL9);
		if(oNmkl9.ctrlEdi.length>1)
			Enable(oNmkl9.ctrlEdi)
		else
			Disable(oNmkl9.ctrlEdi);	
	}
	else
	{
		Disable(HKOL9);
		Disable(oNmkl9.ctrlEdi);	
	}
	return true;
}

function NMK10_Valid()
{
	if (oNmkl10.getCod()!="")
	{
		Enable(HKOL10);
		if(oNmkl10.ctrlEdi.length>1)
			Enable(oNmkl10.ctrlEdi)
		else
			Disable(oNmkl10.ctrlEdi);	
	}
	else
	{
		Disable(HKOL10);
		Disable(oNmkl10.ctrlEdi);	
	}
	return true;
}

function NMK11_Valid()
{
	if (oNmkl11.getCod()!="")
	{
		Enable(HKOL11);
		if(oNmkl11.ctrlEdi.length>1)
			Enable(oNmkl11.ctrlEdi)
		else
			Disable(oNmkl11.ctrlEdi);	
	}
	else
	{
		Disable(HKOL11);
		Disable(oNmkl11.ctrlEdi);	
	}
	return true;
}

function NMK12_Valid()
{
	if (oNmkl12.getCod()!="")
	{
		Enable(HKOL12);
		if(oNmkl12.ctrlEdi.length>1)
			Enable(oNmkl12.ctrlEdi)
		else
			Disable(oNmkl12.ctrlEdi);	
	}
	else
	{
		Disable(HKOL12);
		Disable(oNmkl12.ctrlEdi);	
	}
	return true;
}

function POTR_Valid()
{
	if (!HPOTR.value || HPOTR.value == "0")
		objPotr.setCod(getPar("ORGNOM"));
}

function PLAT_Valid()
{
	if (!HPLAT.value || HPLAT.value == "0")
	{
		//objPostRs.setOwner(false);
		//oRasSc.setOwner(true);
		objPlat.setCod(getPar("ORGNOM"));
		//oRasSc.setRasScAttr();
	}
	else
	{
		//objPostRs.setOwner(true);
		//oRasSc.setOwner(false);
	}
}

function OBMEN_onclick() 
{
	if (HOBMEN.checked)
	{
		Enable(HKLNUM);
		//Enable(DAT_KL);		
		Enable(HKLTEL);		
		Enable(HSFSUM);		
	}
	else
	{
		Disable(HKLNUM);
		//Disable(DAT_KL);		
		Disable(HKLTEL);		
		Disable(HSFSUM);		
	}
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HPOTR",objPotr.getCod());
	objDoc.setVar("HPLAT",objPlat.getCod());
	objDoc.setVar("HPOST",objPost.getCod());
	objDoc.setVar("HFIO",objVed.getCod());
	objDoc.setVar("HNMK1",oNmkl1.getCod());
	objDoc.setVar("HNMK2",oNmkl2.getCod());
	objDoc.setVar("HNMK3",oNmkl3.getCod());
	objDoc.setVar("HNMK4",oNmkl4.getCod());
	objDoc.setVar("HNMK5",oNmkl5.getCod());
 	objDoc.setVar("HNMK6",oNmkl6.getCod());
	objDoc.setVar("HNMK7",oNmkl7.getCod());
	objDoc.setVar("HNMK8",oNmkl8.getCod());
	objDoc.setVar("HNMK9",oNmkl9.getCod());
 	objDoc.setVar("HNMK10",oNmkl10.getCod());
	objDoc.setVar("HNMK11",oNmkl11.getCod());
	objDoc.setVar("HNMK12",oNmkl12.getCod());
}
			
include("sys\\DpBaseDlg.js");
