﻿include ("Objects\\DpGetDat.js");


function docMenuInit()
{
	if (list.oDoc.sDocLbl == "GP")
	{
		if (this.oDoc.getPar("sklad_isuch"))
			grid.AddMenuItem("CHECK_ON_PODR2","Подобрать недостающие элементы на другом складе (по учетной цене)");
		else		
			grid.AddMenuItem("CHECK_ON_PODR","Подобрать недостающие элементы на другом складе");		
		grid.AddMenuItem("ADD_PN","Создать приход для недостающих элементов");
	}	
}



function docMenuHandler(mnuID)
{
		if(mnuID == "CHECK_ON_PODR")
	{
		include("objects\\DpGetDat.js")
		// запрашиваем дополнительные параметры
		var gd = new DpGetDat(new Array("s:c0ut", "p", "m"));
		if (gd.escape == true)
			return;
		
		checkGPOnPodr("SM", this.dataSrc.sqlSelected(), gd);
	    checkMinus(this.dataSrc.sqlSelected());

		this.tbl.requery();	
		grid.refresh();		
		return;
	}
	if(mnuID == "CHECK_ON_PODR2")
	{
		include("objects\\DpGetDat.js")
		// запрашиваем дополнительные параметры
		var gd = new DpGetDat(new Array("s:c0ut", "p", "m"));
		if (gd.escape == true)
			return;
		
		checkGPOnPodr("PM", this.dataSrc.sqlSelected(), gd);
	    checkMinus(this.dataSrc.sqlSelected());

		this.tbl.requery();	
		grid.refresh();		
		return;
	}
	if(mnuID == "ADD_PN")
	{
		addPN4GP(this.dataSrc.sqlSelected());
	    checkMinus(this.dataSrc.sqlSelected());

		this.tbl.requery();	
		grid.refresh();		
		return;
	}
}


function checkGPOnPodrImpl(objDoc, docType, tblOst, gd, strSubWhere)
{
	include("mtr_ost.js")
		
	var oSmDoc = new DpDoc(docType, 1);
	oSmDoc.setVar("HDAT", objDoc.getVar("HDAT"));
	
	include("doc\\dpAutoNo.js");
	var autono = new dpAutoNo(oSmDoc);
	oSmDoc.setVar("HNOM", autono.get());
//	oSmDoc.setVar("HSC", gd.fsc);
//	oSmDoc.setVar("HSU", gd.fsu);
//	oSmDoc.setVar("HST", gd.fst);			
	oSmDoc.setVar("HSC", objDoc.getVar("HSCRS"));
	oSmDoc.setVar("HSU", objDoc.getVar("HSURS"));
	oSmDoc.setVar("HST", objDoc.getVar("HSTRS"));			
	oSmDoc.setVar("HMOLOT", gd.fmol);
	oSmDoc.setVar("HPODROT", gd.fpodr);
	oSmDoc.setVar("HMOLTO", objDoc.getVar("HMOLRS"));
	oSmDoc.setVar("HPODRTO", objDoc.getVar("HPODRRS"));

	var bEmpty = true;	
	var tbl = OpenTable("SELECT MAX(-b.Fsum) as ost, a.FNMKL,a.FSC,a.FSU,a.FST," 
		+ First("a.FEDI") + " as edi," + First("a.FCENA_ORD") + " as CENA_ORD"//, a.FCENA_ORD, a.FIS_OTL, a.FID_PN, a.FPOST"
		+ " FROM ^anltk a left join " + tblOst + " b on a.fwid=b.fwid"
		+ " WHERE a.fid_doc in (SELECT fwid FROM ^SCH_ZAG " + " WHERE " + strSubWhere + ")"
		+ " AND b.Fsum < 0"
		+ " GROUP BY a.FNMKL, a.FIS_OTL, a.FPODR, a.FMOL, a.FSC, a.FSU, a.FST, a.FPOST, a.FID_PN"		
		);
		
	var num = 1;			
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		var o;
		with(o=new DpMtrOb())
		{
			date1   = objDoc.getVar("HDAT");
			pattern = "obr";
			date2   = objDoc.getVar("HDAT");
			fnmkl   = tbl.getValue("FNMKL");
			fpodr   = gd.fpodr;
			fmol    = gd.fmol;
			fsc     = gd.fsc;
			fsu     = gd.fsu;
			fst     = gd.fst;
//			fis_otl = tbl.getValue("FIS_OTL");
//			fcena = tbl.getValue("FCENA_ORD");
//			fid_pn = tbl.getValue("FID_PN");
//			fpost = tbl.getValue("FPOST");
			fis_otl = false;
			doCalc();
		}				

		var oSnap = getSnap("select SUM(FEKOL) as kol, MAX(FCENA) as cena, MAX(FID_PN) as ID_PN, MAX(FPOST) as post from " + o.tblName
				+ " WHERE FEKOL>0");
		if (oSnap != null && oSnap[0] > 0)
		{
			var oDocRow = oSmDoc.createRow("ROW");
			oDocRow.setVar("RNOM", toScrObj(num++));
			oDocRow.setVar("RTNMK", toScrObj(tbl.getValue("FNMKL")));
			oDocRow.setVar("RKOL", round(Number(oSnap[0] < tbl.getValue("ost") ? oSnap[0] : tbl.getValue("ost")), 3));
			//oDocRow.setVar("RKOLSPR", round(Number(oSnap[0] < tbl.getValue("ost") ? oSnap[0] : tbl.getValue("ost")), 3));
			oDocRow.setVar("REDI", toScrObj(tbl.getValue("edi")));
			oDocRow.setVar("RSC", gd.fsc);
			oDocRow.setVar("RSU", gd.fsu);
			oDocRow.setVar("RST", gd.fst);
			oDocRow.setVar("RSC1", objDoc.getVar("HSCPR"));
			oDocRow.setVar("RSU1", objDoc.getVar("HSUPR"));
			oDocRow.setVar("RST1", objDoc.getVar("HSTPR"));
			oDocRow.setVar("RPODR", gd.fpodr);
			oDocRow.setVar("RMOL", gd.fmol);
			oDocRow.setVar("RTYPE", RTYPE_PMP);
			oDocRow.setVar("RUCENA", Number(oSnap[1]));
			oDocRow.setVar("RCENAORD", Number(oSnap[1]));
			oDocRow.setVar("R1ID", toScrObj(oSnap[2]));
			oDocRow.setVar("RPOST", toScrObj(oSnap[3]));
			if (docType == "PM")
				oDocRow.setVar("R1OCENA", Number(oSnap[1]));
			else
			{
				var oSnap = getSnap("SELECT FCENAPR FROM ^cl_nmk "
					+ " WHERE FWID=" + sqlTo(Number(tbl.getValue("Fnmkl"))));
					
			 	if (oSnap != null && oSnap[0] != null && oSnap[0] > 0)
			 	{
					oDocRow.setVar("ROCENA", Number(oSnap[0]));
					oDocRow.setVar("R0OCENA", Number(oSnap[0]));
					
			 	}
				else
					oDocRow.setVar("ROCENA", Number(tbl.getValue("FCENA_ORD")));
			}
			
			oSmDoc.appendRow(oDocRow.sClassId, oDocRow);
			bEmpty = false;
		}				
	}

	var obj = new Object();
	obj.save_after_load = true;
	obj.isTransform = true;
	if (!bEmpty && oSmDoc.edit("ADD", null, obj))
	{
		include("doc\\Nakl\\DpDocRasc.js")
		include("doc\\Nakl\\DpHonr.js")

		var oRasc = new DpDocRasc(oSmDoc);
		oRasc.rasc();
	}
	
	return true;
}

function checkGPOnPodr(docType, strWhere, gd)
{
	include("doc\\nakl\\DpNakl.js");
	include("sys\\dpsql.js");
	var tbl_Sch_zag = OpenTable("s", "SELECT FPODR, FMOL, FSC, FSU, FST, " 
		+ First("FDOC_DAT") + " as DOC_DAT," 
		+ First("FDOC") + " as DOC, "
		+ First("FNOP") + " as NOP, "
		+ First("FWID") + " as id "
			+ "  FROM ^SCH_ZAG "
			+ " WHERE " + strWhere + " GROUP BY FPODR, FMOL, FSC, FSU, FST");

	for(;!tbl_Sch_zag.IsEOF();tbl_Sch_zag.MoveNext())
	{
		var strSubWhere = strWhere 
			+ " AND FPODR = " + sqlTo(tbl_Sch_zag.getValue("FPODR"))
			+ " AND FMOL = " + sqlTo(tbl_Sch_zag.getValue("FMOL"))
			+ " AND FSC = " + sqlTo(tbl_Sch_zag.getValue("FSC"))
			+ " AND FSU = " + sqlTo(tbl_Sch_zag.getValue("FSU"))
			+ " AND FST = " + sqlTo(tbl_Sch_zag.getValue("FST"))
		var tmp_anltk_minost = getTmpTableName();
		var tmp_anltk_bal = getTmpTableName();

		ExecuteSQL(
			"SELECT MAX(a.fdoc_dat) AS fdate, fsc"
			+ " INTO " + tmp_anltk_minost
			+ " FROM ^sch_zag a"
			+ " WHERE fdoc='SA'"
				+ " AND a.fdoc_dat<=" + sqlTo(tbl_Sch_zag.getValue("DOC_DAT"))
			+ " GROUP BY fsc"
			);
	
		var cKey = "a.fwid";
		var strSql =
			"SELECT " + cKey
				+ ", " + sqlRound("SUM(" + sRecSign.replace(/a\./g, "b.") + "*b.Fkol)", 5) + "  AS Fsum"
				+ ", " + sqlRound("SUM(" + sRecSignSF.replace(/a\./g, "b.") + "*b.Fkol)", 5) + " AS Fsumfact"
			+ " INTO " + tmp_anltk_bal
			+ " FROM ((^ANLTK a"
				+ " LEFT JOIN " + tmp_anltk_minost + " sa"
					+ " ON a.fsc=sa.fsc"
				+ ")"
				+ " LEFT JOIN ^ANLTK b"
					+ " ON " + joinKey
						+ " AND (" + sqlCmpVectors("<="
							, "b.Fdate",  "a.Fdate"
							, "b.Frtype", "a.Frtype"
							, "b.fwid",   "a.fwid"
							)
						+ "))"
				+ " LEFT JOIN ^cl_nmk AS nmk"
					+ " ON a.fnmkl=nmk.fwid" 
//			+ " WHERE a.fid_doc = "+sqlTo(Number(tbl_Sch_zag.getValue("FWID")))
			+ " WHERE a.fid_doc in (SELECT fwid FROM ^SCH_ZAG " + " WHERE " + strSubWhere + ")"
				+ " AND (sa.fdate IS NULL OR b.fdate>=sa.fdate)"
				+ " AND (nmk.fvid IS NULL OR nmk.fvid<>'S')" 
			+ " GROUP BY " + cKey;				
		ExecuteSQL(strSql);

		var objDoc = new DpDoc(String(tbl_Sch_zag.getValue("DOC")), Number(tbl_Sch_zag.getValue("NOP")));
		if (objDoc.loadByID(Number(tbl_Sch_zag.getValue("id"))))
		{
			checkGPOnPodrImpl(objDoc, docType, tmp_anltk_bal, gd, strSubWhere);
		}
		
		// Расцениванием документы, возможно что-то уже переместилось со склада
		var tblZag = OpenTable("s", "SELECT * FROM ^SCH_ZAG  WHERE " + strSubWhere );	
		for(;!tblZag.IsEOF();tblZag.MoveNext())
		{
			var objDoc2 = new DpDoc(String(tblZag.getValue("FDOC")), Number(tblZag.getValue("FNOP")));
			if (objDoc2.loadByID(Number(tblZag.getValue("fwid"))))
			{
				include("doc\\Nakl\\DpDocRasc.js")
				include("doc\\Nakl\\DpHonr.js")
				var oRasc2 = new DpDocRasc(objDoc2);
				oRasc2.rasc();
			}
		}
	}
	
	tbl_Sch_zag.close();
}

function addPN4GPImpl(dat, tblOst, strWhere)
{
	var oPnDoc = new DpDoc("PN", 1);
	oPnDoc.setVar("HDAT", dat);
	
	var autono = new dpAutoNo(oPnDoc);
	oPnDoc.setVar("HNOM", autono.get());
	
	var tblNAME = getTmpTableName();
	var bEmpty = true;
	ExecuteSQL("SELECT MAX(-b.Fsum) as fost, a.FNMKL,a.FSC,a.FSU,a.FST"
		+ " INTO " + tblNAME
		+ " FROM ^anltk a left join " + tblOst + " b on a.fwid=b.fwid"
		+ " WHERE a.fid_doc in (SELECT fwid FROM ^SCH_ZAG " + " WHERE " + strWhere + ")"
		+ " AND b.Fsum < 0"
		+ " GROUP BY a.FNMKL, a.FIS_OTL, a.FPODR, a.FMOL, a.FSC, a.FSU, a.FST, a.FPOST, a.FID_PN"		
//		+ " GROUP BY a.FNMKL, a.FIS_OTL, a.FCENA_ORD, a.FPODR, a.FMOL, a.FSC, a.FSU, a.FST, a.FID_PN, a.FPOST"		
		);
		
	//browse("select * from "+tblNAME)
	tbl = OpenTable("SELECT SUM(fost) as ost, FNMKL,FSC,FSU,FST"
		+ " FROM " + tblNAME
		+ " GROUP BY FNMKL"		
		);
		
	var num = 1;			
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		{
			var oDocRow = oPnDoc.createRow("ROW");
			oDocRow.setVar("RNOM", toScrObj(num++));
			oDocRow.setVar("RTNMK", toScrObj(tbl.getValue("FNMKL")));
			oDocRow.setVar("RKOL", round(Number(tbl.getValue("ost")), 5));
			oDocRow.setVar("REDI", toScrObj(tbl.getValue("EDI")));
			oDocRow.setVar("RTYPE", RTYPE_PR);					
			var oSnap = getSnap("SELECT F1CENA FROM ^cl_nmk "
				+ " WHERE FWID=" + sqlTo(Number(tbl.getValue("Fnmkl"))));
		 	if (oSnap != null && oSnap[0] != null && oSnap[0] > 0)
		 	{
				cena = oSnap[0];
				oDocRow.setVar("RUCENA", Number(cena));
				oDocRow.setVar("RCENAORD", Number(cena));
				oDocRow.setVar("RPCENE", Number(cena));
		 	}
			oDocRow.setVar("R1OCENA", Number(tbl.getValue("FCENA_ORD")));
			oDocRow.setVar("R1ID", toScrObj(oDocRow.getID()));
			
			oPnDoc.appendRow(oDocRow.sClassId, oDocRow);
			bEmpty = false;
		}				
	}

	if (!bEmpty && oPnDoc.edit("ADD", null, {isTransform:true})) 
	{
		include("doc\\Nakl\\DpDocRasc.js")
		include("doc\\Nakl\\DpHonr.js")
	}
}

function addPN4GP(strWhere)
{
	include("doc\\nakl\\DpNakl.js");
	include("sys\\dpsql.js");

	var tbl_Sch_zag = OpenTable("s", "SELECT " 
		+ First("FDOC_DAT") + " as DOC_DAT," 
		+ First("FDOC") + " as DOC, "
		+ First("FNOP") + " as NOP, "
		+ First("FWID") + " as id "
			+ "  FROM ^SCH_ZAG "
			+ " WHERE " + strWhere);
	for(;!tbl_Sch_zag.IsEOF();tbl_Sch_zag.MoveNext())
	{
		var tmp_anltk_minost = getTmpTableName();
		var tmp_anltk_bal = getTmpTableName();

		ExecuteSQL(
			"SELECT MAX(a.fdoc_dat) AS fdate, fsc"
			+ " INTO " + tmp_anltk_minost
			+ " FROM ^sch_zag a"
			+ " WHERE fdoc='SA'"
				+ " AND a.fdoc_dat<=" + sqlTo(tbl_Sch_zag.getValue("DOC_DAT"))
			+ " GROUP BY fsc"
			);
	
		var cKey = "a.fwid";
		var strSql =
			"SELECT " + cKey
				+ ", " + sqlRound("SUM(" + sRecSign.replace(/a\./g, "b.") + "*b.Fkol)", 5) + "  AS Fsum"
				+ ", " + sqlRound("SUM(" + sRecSignSF.replace(/a\./g, "b.") + "*b.Fkol)", 5) + " AS Fsumfact"
			+ " INTO " + tmp_anltk_bal
			+ " FROM ((^ANLTK a"
				+ " LEFT JOIN " + tmp_anltk_minost + " sa"
					+ " ON a.fsc=sa.fsc"
				+ ")"
				+ " LEFT JOIN ^ANLTK b"
					+ " ON " + joinKey
						+ " AND (" + sqlCmpVectors("<="
							, "b.Fdate",  "a.Fdate"
							, "b.Frtype", "a.Frtype"
							, "b.fwid",   "a.fwid"
							)
						+ "))"
				+ " LEFT JOIN ^cl_nmk AS nmk"
					+ " ON a.fnmkl=nmk.fwid" 
			+ " WHERE a.fid_doc in (SELECT fwid FROM ^SCH_ZAG " + " WHERE " + strWhere + ")"
				+ " AND (sa.fdate IS NULL OR b.fdate>=sa.fdate)"
				+ " AND (nmk.fvid IS NULL OR nmk.fvid<>'S')" 
			+ " GROUP BY " + cKey;				
		ExecuteSQL(strSql);

		addPN4GPImpl(tbl_Sch_zag.getValue("DOC_DAT"),  tmp_anltk_bal, strWhere);
	}
	
	tbl_Sch_zag.close();
}
