include ("Objects\\DpCl.js");
include("Objects\\DpCtrlLinker.js");
include ("Objects\\DpVal.js");
include ("sys\\mask.js");
//include("Objects\\DpPostRs.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var oOrg;
var param;
var oOrgRs;
var m_zntbl;
var edmode = extPar.mode;
var oShv, oShvd;
var oOl;
var oVal;
var oType;
var oVid;

function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));

	param = CreateDocPar(objDoc.sDocLbl, objDoc.nNop);
	
	ctrlLinker = new DpCtrlLinker(objDoc);

	HDOG_NUM.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	HSUM_DOG.mask=MASK_SUM;
	//HSAL_VYK.mask=MASK_SUM;
	//HSAL_OPL.mask=MASK_SUM;
	HSUMAV.mask=MASK_SUM;
	HSAL_VYK.mask=MASK_SUM;
	HSAL_OPL.mask=MASK_SUM;
	HAVANS.mask="###"
	
	oOrg = new DpCl();
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkCtrl(HORG);
	oOrg.linkCtrl2("Ftxt", HORGTXT);
	oOrg.setContAssist();
	
	oShv = new DpCl("0");
	oShv.setClcl(getOrgVar("SHV"));
	oShv.linkCtrl(HSHV);
	oShv.linkCtrl2("Ftxt",HSHV_TXT);
	oShv.setContAssist();
	
	oShvd = new DpCl("0");
	oShvd.setClcl(getOrgVar("SHV"));
	oShvd.linkCtrl(HSHVD);
	oShvd.linkCtrl2("Ftxt",HSHVD_TXT);
	oShvd.setContAssist();
	
	oOl = new DpCl("0");
	oOl.setClcl(getOrgVar('HOZPERS',true)==null?getPar('CODPERS'):getOrgVar('HOZPERS',true));
	oOl.linkCtrl(HOL);
	oOl.linkCtrl2("Ftxt",HOL_TXT);
	oOl.setContAssist();
	
	oVal = new DpVal();
	oVal.linkCtrl(HVAL);	
	
	oType = new DpCl("0");
	oType.setClcl(getOrgVar("CL_TYPE_DOG"));
	oType.linkCtrl(HTYPE_DOG);
	oType.linkCtrl2("Ftxt",HTYPE_DOG_TXT);
	oType.setContAssist();
	
	oVid = new DpCl("0");
	oVid.setClcl(getOrgVar("CL_VID_DOG"));
	oVid.linkCtrl(HVID_DOG);
	oVid.linkCtrl2("Ftxt",HVID_DOG_TXT);
	oVid.setContAssist();
	
	m_zntbl = edmode=="EDIT" || edmode=="COPY";
	
	ctrlLinker.addLink("HDAT",HDAT);     
   	ctrlLinker.addClLink("HORG",oOrg );     
  	ctrlLinker.addLink("HTXT",HTXT);
  	ctrlLinker.addLink("HEDAT",HEDAT);
  	ctrlLinker.addLink("HBDAT",HBDAT);
  	ctrlLinker.addLink("HCOD",HCOD);
  	ctrlLinker.addLink("HDOG_NUM",HDOG_NUM);
  	ctrlLinker.addLink("HPREM",HPREM);
  	ctrlLinker.addLink("HSHV",HSHV);
  	ctrlLinker.addLink("HSHVD",HSHVD);
  	ctrlLinker.addLink("HOL",HOL);
  	ctrlLinker.addLink("HSUM_DOG",HSUM_DOG);
  //	ctrlLinker.addLink("HDAT_SAL",HDAT_SAL);
 // 	ctrlLinker.addLink("HSAL_VYK",HSAL_VYK);
 // 	ctrlLinker.addLink("HSAL_OPL",HSAL_OPL);
  	ctrlLinker.addLink("HTYPE_DOG",HTYPE_DOG);
  	ctrlLinker.addLink("HVID_DOG",HVID_DOG);
	ctrlLinker.addLink("HSROK",HSROK);
	ctrlLinker.addLink("HSROKREM_VYK",HSROKREM_VYK);
	ctrlLinker.addLink("HSROKREM_OPL",HSROKREM_OPL);
	ctrlLinker.addLink("HAVANS",HAVANS);
	ctrlLinker.addLink("HDK",HDK);
	ctrlLinker.addLink("HKONK",HKONK);
	ctrlLinker.addLink("HDOP_DOG",HDOP_DOG);
	ctrlLinker.addLink("HROZRAH",HROZRAH);
	ctrlLinker.addLink("HDAT_SAL",HDAT_SAL);
	ctrlLinker.addLink("HSAL_VYK",HSAL_VYK);
	ctrlLinker.addLink("HSAL_OPL",HSAL_OPL);
  	
 	ctrlLinker.updateData(false);        
 	 	
 	if (edmode != "ADD")
 	{
 		//oOrg.setClcl(getPar("CODPLAT"));
        oOrg.setCod(objDoc.getVar("HORG"));
        oShv.setCod(objDoc.getVar("HSHV"));
        oShvd.setCod(objDoc.getVar("HSHVD"));
        oOl.setCod(objDoc.getVar("HOL"));
        oType.setCod(objDoc.getVar("HTYPE_DOG"));
        oVid.setCod(objDoc.getVar("HVID_DOG"));
      	oVal.setCod(objDoc.getVar("HVAL"));
 	}
 	else
 	{
 	//	HDAT_SAL.value=new Date(3000,0,1).getVarDate(); 	
 		if(extPar.org)
 			oOrg.setCod(extPar.org);
 		setWhen(HEDAT,srok);
 		//srok();
 	}
 	Disable(HSUMAV);
 	
 	setValid(HAVANS,avans);
 	setValid(HSUM_DOG,avans);
 	
 	avans();
 	 	
}
function srok()
{
	if(differ(HEDAT.value, d00)==0)
	{
		var dat = HBDAT.value;
		var dat_srok = new Date(dat.getYear()+1900,dat.getMonth(),dat.getDate()+10);
		HSROK.value = dat_srok.getVarDate();
		var dat_end = new Date(dat.getYear()+1900,11,31);
		HEDAT.value = dat_end.getVarDate();
	}
	return true;
	
}
function avans()
{
	HSUMAV.value = Number(HSUM_DOG.value)/100*Number(HAVANS.value);
	return true;
}

function onSave()
{
	
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());
	
}

include("sys\\DpBaseDlg.js");