include("Objects/DpCl.js");

var obj = extPar.obj;
var ctrlLinker;
var sMenTbl = "SC_PRIVMEN";			//льготники
var sTmpTbl = getTmpTableName();

function onLoad()
{		
	Caption(UR("Пільга|Льгота")	+": "+ modeName(this.sMode));
	
	FLGNOM.mask = "&&&&&&&&&&&&&&&";
	FDOCSER.mask = "&&&&&&&&&&";
	FKOL.mask = "##";
	
	oExempt = new DpCl("", getPar("CODLGT"), 0);
	oExempt.linkSmartCtrl(FEXEMPT);
	oExempt.setContAssist();	
	oExempt.AfterUpdate = privValid;
	
	if(!fillMen())
		return false;
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RBDAT", FBDAT);
	ctrlLinker.addLink("REDAT", FEDAT);
	ctrlLinker.addLink("RMEN", FMEN);
	ctrlLinker.addLink("RKOL", FKOL);
	ctrlLinker.addLink("RCONFIRMDAT", FCONFIRMDAT);
	ctrlLinker.addLink("RLGNOM", FLGNOM);
	ctrlLinker.addLink("RDOCSER", FDOCSER);
	ctrlLinker.addLink("RDOCDAT", FDOCDAT);
	ctrlLinker.addLink("RDOCKAT", FDOCKAT);
	ctrlLinker.addLink("RDOCREM", FDOCREM);
	ctrlLinker.toControls();
	
	if(extPar.mode=="ADD")
	{
		FBDAT.value = new Date(obj.parent.getVar("HBDAT")).getVarDate();
		FEDAT.value = d00;
		FKOL.value = 1;
	}
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		if(obj.getVar("RPRIV"))
			oExempt.setFWID(obj.getVar("RPRIV"));		
	}
	Disable(FKOL);
	
	setButton(ADDMAN, add_man);
	
	setValid(FMEN, menValid);
	loadMen();
}

function add_man()
{
	gridMenuRun("ADD", grid);
}

function loadMen()
{		
	var sFld = GetPatternIntersection(sMenTbl, sMenTbl);
	CreateTable(sTmpTbl, sMenTbl);
	var sSQL = "INSERT INTO "+ sTmpTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM ^"+ sMenTbl
				+" WHERE FID_PRIV="+ obj.getID();	
	ExecuteSQL(sSQL);	
	
	var tbl = OpenTable("m", "select * from "+ sTmpTbl +" order by FCOD");
	tbl.tie(extPar.tblMen, "men", "FWID", "FID_MEN");
	grid.setTable(tbl);
	grid.build();	
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");	
}

function gridMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	oGrid.AddMenuItem("ADD", "Додати | Добавить");
	if (!tbl.isEmpty())
	{
		oGrid.AddMenuItem("EDIT", "Редагувати | Редактировать");
		//oGrid.AddMenuItem("COPY", "Копіювати | Копировать");
		oGrid.AddMenuItem("DEL", "Видалити | Удалить");
	}
}

function gridMenuRun(sID, oGrid)
{
	var sRowClass = oGrid.getData("ROWCLASS");
	var tbl = oGrid.getTable();
	var rowID = Number(tbl.getValue("FWID"));
	var sTmpTbl = tbl.getTableName();
		
	switch(sID)
	{
	case "DEL":
		var sMsg = UR("Видалити запис?|Удалить запись?");
		if(!confirm(sMsg))
			return true;
		oGrid.getTable().Delete();
		oGrid.getTable().requery();
		oGrid.refresh();
		break;
		
	case "__XDEL":	//массовое удаление 
		var delRowCount = oGrid.getSelectedCount();
		if (delRowCount<=0)
			return;
		var selIds = oGrid.getSelectedIDs();
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів") +" ("+ delRowCount +").";
		if("c"==msgBox("c-", sMsg, sCapt))
			return;
		setProgressRange(0, delRowCount);		
		for (var nRow=0; nRow<selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			var rowID = Number(selIds[nRow]);
			ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE FWID="+ rowID);				
		}		
		oGrid.clearSelected();
		oGrid.getTable().requery();
		oGrid.refresh();
		setProgressPos(0);
		break;

	case "ADD": case "EDIT": case "COPY":
		var par = new Object();
		par.mode = sID;
		par.tblName = sTmpTbl;
		par.m_pTable = oGrid.getTable();
		par.fid_lg = oExempt.getFWID();
		par.oPriv = obj;
		par.tblMen = extPar.tblMen;
		showWindow("/docs/LICSC/PRIV/MEN/form.xml", SW_MODAL, par);
		if(!par.escape)
		{
			oGrid.getTable().requery();			
			oGrid.getTable().findByID(par.fwid);
			oGrid.refresh();			
		}
		break;
	}
			
	calc_men();
}

function calc_men()
{
	FKOL.value = 0;
	var oSnap = getSnap("select count(distinct FID_MEN) as cnt "
						+" from "+ sTmpTbl 
						,false);
	if(oSnap && oSnap[0])
		FKOL.value = oSnap[0];
}

function onSave()
{		
	obj.setVar("RPRIV", oExempt.getFWID());
	if(extPar.mode=="ADD" || extPar.mode=="COPY")
		obj.setVar("RCOD", nextPrivCod());
	ctrlLinker.toVars();
	saveRows();
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^"+ sMenTbl +" WHERE FID_PRIV="+ obj.getID());
	var sFld = GetPatternIntersection(sMenTbl, sMenTbl);
	var sSql = "INSERT INTO ^"+ sMenTbl +"("+ sFld +")"
				+" SELECT "+ sFld +" FROM "+ sTmpTbl;
	ExecuteSQL(sSql);
}

function privValid()
{
	if(Number(FMEN.value))
		menValid();
}

function menValid()
{
	var men = Number(FMEN.value);
	if(!men)
	{
		WAIT(UR("Необхідно вказати мешканця!|Нужно выбрать жильца!"));
		return false;		
	}
	var oSnap = getSnap("select count(*) as cnt from "+ sTmpTbl, false);
	if(oSnap && oSnap[0]==0)
	{
		var m = new Object();
		m.FWID = GetUID();
		m.FCOD = 1;
		m.FID_DOG = obj.parent.getID();
		m.FID_PRIV = obj.getID();
		m.FID_LG = oExempt.getFWID();
		m.FID_MEN = FMEN.value;
		m.FMAIN = true;
		m.FELECTRICPRIVILEGE = true;
		UpdateTable(sTmpTbl, m, true);
		
		grid.getTable().requery();			
		grid.refresh();
	}
	return true;
}

function fillMen()
{
	var men = Number(FMEN.value);
	FMEN.clear();
	var sWhere = "";
	if(extPar.mode=="ADD")
		sWhere = " where FEDAT>"+ sqlTo(today);
	var tbl = OpenTable("select * from "+ extPar.tblMen + sWhere +" order by FCOD");
	if(tbl.isEmpty())
	{
		alert(UR("Спочатку треба додати мешканця!|Сначала нужно добавить жильца!"));
		return false;
	}
	var menID = 0;
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		menID = tbl.getValue("FWID");
		var txt = tbl.getValue("FCOD") +" - "+ tbl.getValue("FFIO");
		FMEN.addItem(menID, txt);
	}
	if(tbl.recordCount==1)
		FMEN.value = menID;
	if(men)
		FMEN.value = men;
	tbl.close();
	return true;
}

function nextPrivCod()
{
	var oSnap = getSnap("select max(FCOD) from "+ extPar.tblName);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

include("sys/DpBaseDlg.js");