include("Objects/DpNmkl.js");

var obj = extPar.obj;
var ctrlLinker;

function onLoad()
{		
	Caption(UR("Послуга|Услуга") +": "+ modeName(this.sMode));
	
	FKOL.mask = MASK_KOL;
	FNORM.mask = MASK_KOL;
	FDISCOUNT.mask = MASK_SUM;
	FDRAINPERC.mask = MASK_KOL;
	
	oNmk = new DpNmkl();
	oNmk.linkSmartCtrl(FNMKL);
				
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RSERV", FSERV);
	ctrlLinker.addLink("RBDAT", FBDAT);
	ctrlLinker.addLink("REDAT", FEDAT);
	ctrlLinker.addLink("RKOL", FKOL);
	ctrlLinker.addLink("RNORM", FNORM);
	ctrlLinker.addLink("RBILL", FBILL);
	ctrlLinker.addLink("RDISCOUNT", FDISCOUNT);
	ctrlLinker.addLink("RFACTOR", FFACTOR);
	ctrlLinker.addLink("RDRAINPERC", FDRAINPERC);
	ctrlLinker.addLink("RDRAINCALC", FDRAINCALC);
	ctrlLinker.addLink("RINPUT", FINPUT);
	ctrlLinker.toControls();

	loadInputs();
	if(extPar.mode=="ADD")
	{
		FBDAT.value = new Date(obj.parent.getVar("HBDAT")).getVarDate();
		FEDAT.value = d00;
		FBILL.checked = true;
	}
	else
	{
		oNmk.setCod(Number(obj.getVar("RNMKL")));
		FINPUT.value = Number(obj.getVar("RINPUT"));
		FDRAINCALC.value = Number(obj.getVar("RDRAINCALC"));
	}
	
	var nObj = obj.parent.getVar("HOBJECT");
	if(nObj)
	{
		this.loadObjectNorm = loadObjectNorm;
		setButton(FNORM, this, "loadObjectNorm");
	}

	setValid(FINPUT, inputValid);
	setValid(FSERV, servValid);
	servValid();
}

function onSave()
{
	ctrlLinker.toVars();
	obj.setVar("RNMKL", oNmk.getCod());
}

function servValid()
{
	var serv = String(FSERV.value);
	if(serv=="DRAIN" || serv=="CDRAIN" || serv=="HDRAIN")
		GRDRAINPERC.setVisible(true);
	else
		GRDRAINPERC.setVisible(false);
	if(serv.indexOf("WATER")!=-1 || serv=="WASHER")
		GRDRAINCALC.setVisible(true);
	else
		GRDRAINCALC.setVisible(false);
	//loadInputs();
	//FORM.Refresh();
}

function inputValid()
{
	if(Number(FNORM.value)==0)
		loadObjectNorm();
	if(!FSERV.value)
	{
		var input = Number(FINPUT.value);
		var oSnap = getSnap("select FSERV from ^CL_INPUT where FWID="+ input, false);
		if(oSnap)
			FSERV.value = oSnap[0];
	}
}

function loadObjectNorm()
{
	var input = Number(FINPUT.value);
	var oSnap = getSnap("select FCALCMODE, FNORM, FMLIMIT from ^CL_INPUT where FWID="+ input, false);
	if(oSnap)
	{
		if(oSnap[0]==1 && FFACTOR.value=="")
			FFACTOR.value = "NORM";
		if(Number(oSnap[1]))
			FNORM.value = oSnap[1];
		else if(Number(oSnap[2]))
			FNORM.value = oSnap[2];
	}
	if(Number(FNORM.value)==0)
	{
		var nObj = obj.parent.getVar("HOBJECT");
		oSnap = getSnap("select FMLIMIT from ^CL_FACTORY f inner join ^CLRELCLCL r on r.FWID_CL=f.FWID_CL where r.FCOD="+ nObj, false);
		if(oSnap && Number(oSnap[0]))
			FNORM.value = oSnap[0];
	}
}

function loadInputs()
{
	var nObj = obj.parent.getVar("HOBJECT");
	if(nObj)
	{
		var input = Number(FINPUT.value);
		FINPUT.clear();
		GRINPUT.setVisible(true);
		var serv = FSERV.value;
		var tbl = OpenTable("select l.* from ^CL_INPUT l"
							+" inner join ^CLRELCLCL r on r.FWID_CL=l.FWID_CL"
							+" where r.FCOD="+ nObj 
								+" and l.FBDAT<="+ sqlTo(today)
								+" and l.FEDAT>="+ sqlTo(today)
							);
		for(; !tbl.isEOF(); tbl.MoveNext())
		{
			var inputID = tbl.getValue("FWID");
			var txt = tbl.getValue("FCOD") +" - "+ tbl.getValue("FPLACE");
			var serv = String(tbl.getValue("FSERV")).trim();
			if(serv=="CWATER")
				txt += " (ХВС)";
			if(serv=="HWATER")
				txt += " (ГВС)";
			if(serv=="DRAIN")
				txt += " ("+ UR("Каналізація|Канализация") +")";
			FINPUT.addItem(inputID, txt);
		}
		tbl.close();
		if(input)
			FINPUT.value = input;
	}
	else
	{
		GRINPUT.setVisible(false);
	}
}

include("sys/DpBaseDlg.js");