include ("Objects\\DpGetDat.js");
include("Objects\\DpXMLDomDocument.js");

var m_Doclabel = this.m_Doclabel;
var m_Nop = this.m_Nop;
if(!m_Doclabel && extPar.doc)
{
	m_Doclabel = extPar.doc;	
	m_Nop = extPar.nop;
}
var aOper_type = [];	

function docSrc()
{		
	//параметр тип операции
	//читаем XML и пишем в масив для грида list.xml
	var oXML = new DpXMLDOMDocument();
	oXML.load(rootDirectory()+"enums/oper_type.xml");
	var root = oXML.getDocumentElement();	
	var xmlRow = root.getChildNodes();
	for (var i in xmlRow)
	{
		aOper_type[String(xmlRow[i].getAttribute("value"))] = UR(xmlRow[i].getText());
	}

	var sWhere = "";
	if(extPar.fid_doc && extPar.base_doc)
	{		
		sWhere = "Fid_doc="+ sqlTo(extPar.fid_doc);			
		sWhere += " and Fnop="+ sqlTo(extPar.nop);	
		this.qrySet("From","^HNV",
				"Where", sWhere, 		  
				"Order","Fdoc_num, Fdoc_dat");
		return true;
	}
	if(this.docList.buildQuery())
	{
		this.docList.subTie();			
		return true;
	}
	return false;
	//this.clTie("x_cl_post", "="+ sqlTo(sprOrg) +",FORG");	
}

function docMenuInit()
{
	var ds1 = this.dataSrc;
	if(!ds1.getTable().isEmpty())
	{
		ds1.AddMenuItem("", "");		
		ds1.AddMenuItem("BASEDOC", "Знайти базовий документ|Найти базовый документ");		
		//ds1.AddMenuItem("RNVP_R", "Реєстр виданих податкових|Реестр выданных налоговых");
		ds1.AddMenuItem("J_NV", "Реєстр виданих податкових|Реестр выданных налоговых");
	}
}

function docMenuHandler(nID)
{		
	var ds1 = this.dataSrc;
	var tbl = this.dataSrc.getTable();	
			
	if (nID == "BASEDOC")
	{
		var sDoc = tbl.getValue("FBASE_DOC");
		var nNop = tbl.getValue("FBASE_NOP");
		var docId = tbl.getValue("FID_DOC");
		include("doc\\DpDocPtn.js");
		FindDocument(String(sDoc), nNop, docId);
		return true;
	}			
	if(nID == "RNVP_R")
	{
		var oPar = new Object;
		oPar.fdoc = m_Doclabel;
		oPar.fnop = m_Nop;
		showWindow("l_rnvp_r.js", SW_NOMODAL, oPar);
	}
	if(nID=="J_NV")
	{
		var oPar = new Object();		
		oPar.JID = "NV";
		oPar.doc = this.m_Doclabel;
		if(this.m_Nop && this.m_Nop != 0)
		{
			oPar.nop = this.m_Nop;
		}
		showWindow("l_journal.xml",SW_NOMODAL,oPar);
	}

}

function docDel(fid_doc)
{
	ExecuteSQL("delete from ^RNV where FID_DOC="+ fid_doc, false);
}

function listInitEditParam(oPar)
{
	oPar.fid_doc   = extPar.fid_doc;
	oPar.base_doc  = extPar.base_doc;
	oPar.base_nop  = extPar.base_nop;
	oPar.doc 	   = extPar.doc;
	oPar.nop 	   = extPar.nop;
	oPar.fplat 	   = extPar.fplat;
	oPar.fdate 	   = extPar.fdate;
	oPar.fnds_proc = extPar.fnds_proc;
	oPar.tblRows   = extPar.tblRows
}

function getOper_type(indx)
{	
	return aOper_type[indx];
}