include ("Objects\\DpGetDat.js");
include ("doc/DpDoc.js");

var tblSrcName = "^OS1";

function docSrc()
{
	gd = new Object;	
	if (typeOf(DOC) == "DpTextEx")
	{
		DATB.value = d00min;
		DATB.setEnabled(false);
		gd.dat2 = DATE.value;
	}
	else
	{
		gd = new DpGetDat("D");	
		if (gd.escape) return false;
		dat = gd.dat2;
	}
	
	this.qrySet("From",tblSrcName,
					"Where", "FDOC_DAT <= " + sqlTo(gd.dat2) + " " + sqlw0And(" Fnop=", extPar.nop),
					"Order","Finv_num"
					);
	this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	this.subTie("KOMPL", "x_oskompl", "Fkompl", "Fkompl");
}

function docInit()
{
	//групируем визуально комплекты
	grid.setFilling("=^FKOMPL>0?^FKOMPL:^FWID");
}

function docMenuInit()
{
	this.dataSrc.AddMenuItem("", "");
	this.dataSrc.AddMenuItem(12,"Складові частини|Составные части");
	this.dataSrc.AddMenuItem(13,"Дорог.метали|Драг.металлы ");
	this.dataSrc.AddMenuItem(14,"Побудувати коди видів ОЗ|Проставить коды видов ОС ");
	//this.dataSrc.AddMenuItem(15,"Проставити N комплектів|Проставить N комплектов");
	if(grid.selectedCount>1)
		this.dataSrc.AddMenuItem("GROUP_KMPL","Об'єднати в комплект|Объеденить в комплект");
	if(this.tbl.getValue("Fkompl")>0)
		this.dataSrc.AddMenuItem("UNGROUP_KMPL","Вилучити комплект|Удалить комплект");
	this.dataSrc.AddMenuItem("","");
	if(tblSrcName == "^OS1")
		this.dataSrc.AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты");
	else
		this.dataSrc.AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты",ICON_RADIO);
	if(tblSrcName != "^OS1")
		this.dataSrc.AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты");
	else
		this.dataSrc.AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты",ICON_RADIO);
	this.dataSrc.AddMenuItem("","");
	this.dataSrc.AddMenuItem("RESAVE","Перезберегти акти прийняття|Пересохранить акты приемки");
}

function docMenuHandler(nID)
{
	var par = new Object();
	if(nID==12)
	{
		par.Inv_num = this.tbl.getValue("Finv_num");
		showWindow("l_detali.js",SW_NOMODAL,par,"");
	} else
	if(nID==13)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		showWindow("l_metali.js",SW_NOMODAL,par,"");
	} else
	if(nID==14)
	{
		
	} else
	if(nID==15)
	{
		
	} else
	if(nID=="GROUP_KMPL")
	{
		t = OpenTable("select s1.Finv_num,n.Finv_nak, s1.Fwid, s7.Fwid as Fwid7, s4.Fwid as Fwid4 "
				+" from ^os1 as s1 inner join ^os7 as s7 on s1.Finv_num=s7.Finv_num "
				+" left join ^os4 as s4 on s4.Finv_num=s1.Finv_num "
				+" left join ^osnazv as n on n.Finv_num=s1.Finv_num "
				+" where s1.Fwid "+grid.sqlSelected(true));
		par = new Object();
		par.tbl = t;
		par.fkompl = 0;
		par.mode = "ADD";
		showWindow("e_kompl.xml",SW_MODAL, par);
		if(par.escape)
			return false;
		fkompl = par.fkompl;
		var o1 = new DpDoc("O1",0);
		var o7 = new DpDoc("O7",0);
		var o4 = new DpDoc("O4",0);
		for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
		{
			o1.clear();
			if(o1.loadByID(t.getValue("Fwid")))
			{
				o1.setVar("HKOMPL",fkompl);
				o1.save();
				o7.clear();
				if(o7.loadByID(t.getValue("Fwid7")))
				{
					o7.setVar("HKOMPL",fkompl);
					o7.save();
				}
				o4.clear();
				if(o4.loadByID(t.getValue("Fwid4")))
				{
					o4.setVar("HKOMPL",fkompl);
					o4.save();
				}
			}
		}
		t.close();
		this.tbl.requery();
		grid.clearSelected();
		grid.refresh();
	} else
	if(nID=="UNGROUP_KMPL")
	{
		t1 = OpenTable("select Fwid from ^os1 where Fkompl="+this.tbl.getValue("Fkompl"));
		t4 = OpenTable("select Fwid from ^os4 where Fkompl="+this.tbl.getValue("Fkompl"));
		t7 = OpenTable("select Fwid from ^os7 where Fkompl="+this.tbl.getValue("Fkompl"));
		var o1 = new DpDoc("O1",0);
		var o4 = new DpDoc("O4",0);
		var o7 = new DpDoc("O7",0);
		for(; !t1.IsEOF(); t1.MoveNext())
		{
			o1.clear();
			if(o1.loadByID(t1.getValue("Fwid")))
			{
				o1.setVar("HKOMPL",0);
				o1.save();
			}
		}
		for(; !t4.IsEOF(); t4.MoveNext())
		{
			o4.clear();
			if(o4.loadByID(t4.getValue("Fwid")))
			{
				o4.setVar("HKOMPL",0);
				o4.save();
			}
		}
		for(; !t7.IsEOF(); t7.MoveNext())
		{
			o7.clear();
			if(o7.loadByID(t7.getValue("Fwid")))
			{
				o7.setVar("HKOMPL",0);
				o7.save();
			}
		}
		ExecuteSQL("delete from ^kompl where Fkompl="+this.tbl.getValue("Fkompl"));
		t1.close();
		t4.close();
		t7.close();
		this.tbl.requery();
		grid.clearSelected();
		grid.refresh();
	} else
	if(nID == "MIN_KMPL" && tblSrcName == "^OS1")
	{
		DropTable("TMP_OS1_SRC");
		ExecuteSQL("select * into TMP_OS1_SRC from ^os1 where "+this.qryWhere+" and Fkompl=0");
		ExecuteSQL("insert into TMP_OS1_SRC (Fwid,Finv_num,Fkompl,Fvvod_ecsp,Fnach_plat,Fdoc_dat,"
					+"Fdat_vib,Fiznos,Forig_all,Forig_pric,Forig_buh,Fiznosb,Fnop,Fcod_mol,Fcod_podr,"
					+"Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,"
					+"Fcr_cod2,Fcr_cod3,Fotn_z_sc,Fotn_z_su,Fotn_z_st,Fotn_c1,Fotn_c2,Fotn_c3) "
				+" select MIN(Fwid),Fkompl,Fkompl,MIN(Fvvod_ecsp),MIN(Fnach_plat),MIN(Fdoc_dat),"
					+"MAX(Fdat_vib),SUM(Fiznos),SUM(Forig_all),SUM(Forig_pric),SUM(Forig_buh),SUM(Fiznosb),"
					+"MIN(Fnop),MIN(Fcod_mol),MIN(Fcod_podr),MIN(Fdb_sc),MIN(Fdb_su),MIN(Fdb_st),"
					+"MIN(Fdb_cod1),MIN(Fdb_cod2),MIN(Fdb_cod3),MIN(Fcr_sc),MIN(Fcr_su),MIN(Fcr_st),"
					+"MIN(Fcr_cod1),MIN(Fcr_cod2),MIN(Fcr_cod3),MIN(Fotn_z_sc),MIN(Fotn_z_su),"
					+"MIN(Fotn_z_st),MIN(Fotn_c1),MIN(Fotn_c2),MIN(Fotn_c3) "
				+" from ^os1 where Fkompl>0 group by Fkompl");
		tblSrcName = "TMP_OS1_SRC";
		//browse(tblSrcName);
		grid.DeletePages();
		list.init();
	} else
	if(nID == "MAX_KMPL" && tblSrcName != "^OS1")
	{
		tblSrcName = "^OS1";
		grid.DeletePages();
		list.init();
	}else
	if(nID == "RESAVE")
	{
		var msg = ru("Вы уверены, что хотите пересохранить отмеченные акты приемки?",
						"Ви впевнені, що бажаєте перезберегти відмічені акти прийняття?");
		if(!confirm(msg))
			return false;
		include("Objects/dpNop.js");
		include("doc/DpDoc.js");
		var znop = new DpNop();
    	znop.setCod(0);
		znop.zSetCod(0,"O7");
		doc7 = new DpDoc("O7",0);
		doc1 = new DpDoc("O1",0);
		var FNEM;
	  	var tblOS = OpenTable("select o1.*,o7.Fwid as Fwid7 from ^os1 as o1 left join ^os7 as o7 on o1.Finv_num=o7.Finv_num where o1.Fwid "+DataSource().sqlSelected(true));
	  	setProgressRange(1, tblOS.rowCount);
	  	for(; !tblOS.IsEOF(); tblOS.MoveNext())
	  	{
		   	setProgressPos(tblOS.bookmark, ru("Инв.№","Інв.№")+tblOS.getValue("Finv_num")+"  "+tblOS.bookmark+"/"+tblOS.rowCount);
		   	doc1.clear();
		   	doc7.clear();
		   	doc1.loadByID(tblOS.getValue("Fwid"));
		   	if(tblOS.getValue("Fwid7"))
	    		doc7.loadByID(tblOS.getValue("Fwid7"));
		   	else
		   		doc7.setVar("HOP",znop.getCod());
			doc7.setVar("HCALC",0);
			doc7.setVar("HDOC","O7");
			doc7.setVar("HNOM",doc1.getVar("HNOM"));
	   		doc7.setVar("HDAT",doc1.getVar("HDAT"));
	   		doc7.setVar("HNEM",doc1.getVar("HNEM"));
	   		doc7.setVar("HAREND",doc1.getVar("HAREND")?doc1.getVar("HAREND"):"-");
			doc7.setVar("HNEPR",doc1.getVar("HNEPR"));
	   		doc7.setVar("HDETAL",doc1.getVar("HDETAL")?doc1.getVar("HDETAL"):"-");
			doc7.setVar("HMETAL",doc1.getVar("HMETAL")?doc1.getVar("HMETAL"):"-");
			doc7.setVar("HNOTPRIV",doc1.getVar("HNOTPRIV"));
			doc7.setVar("HCS",doc1.getVar("HCS"));
	   		doc7.setVar("HCU",doc1.getVar("HCU"));
			doc7.setVar("HCT",doc1.getVar("HCT"));
	   		doc7.setVar("HCCOD1",doc1.getVar("HCCOD1"));
	   		doc7.setVar("HCCOD2",doc1.getVar("HCCOD2"));
	   		doc7.setVar("HCCOD3",doc1.getVar("HCCOD3"));
		   	doc7.setVar("HDS",doc1.getVar("HDS"));
	   		doc7.setVar("HDU",doc1.getVar("HDU"));
	   		doc7.setVar("HDT",doc1.getVar("HDT"));
	   		doc7.setVar("HDCOD1",doc1.getVar("HDCOD1"));
	   		doc7.setVar("HDCOD2",doc1.getVar("HDCOD2"));
	   		doc7.setVar("HDCOD3",doc1.getVar("HDCOD3"));
			doc7.setVar("HZC",doc1.getVar("HZC"));
	   		doc7.setVar("HZU",doc1.getVar("HZU"));
	   		doc7.setVar("HZT",doc1.getVar("HZT"));
	   		doc7.setVar("HZCOD1",doc1.getVar("HZCOD1"));
	   		doc7.setVar("HZCOD2",doc1.getVar("HZCOD2"));
			doc7.setVar("HZCOD3",doc1.getVar("HZCOD3"));
		   	doc7.setVar("HPDR",doc1.getVar("HPDR")) ;
	  		doc7.setVar("HMOL",doc1.getVar("HMOL"));
			doc7.setVar("HCODSROK",doc1.getVar("HCODSROK"));
			doc7.setVar("HSROC",doc1.getVar("HSROC"));
			doc7.setVar("HLIKVST",doc1.getVar("HLIKVST"));
			doc7.setVar("HKOLLIKV",doc1.getVar("HKOLLIKV"));
			doc7.setVar("HINVN",doc1.getVar("HINVN"));
			doc7.setVar("HINVOLD",doc1.getVar("HINVOLD"));
			doc7.setVar("HKOMPL",doc1.getVar("HKOMPL"));
			doc7.setVar("HNRATE",doc1.getVar("HNRATE"));
	   		doc7.setVar("HGR",doc1.getVar("HGR"));
	   		doc7.setVar("HGRB",doc1.getVar("HGRB"));
			doc7.setVar("HPRICE",doc1.getVar("HPRICE"));
		   	doc7.setVar("HPRICEB",doc1.getVar("HPRICEB"));
			doc7.setVar("HPRICEAL",doc1.getVar("HPRICEAL"));
			doc7.setVar("HKOL",doc1.getVar("HKOL"));
			doc7.setVar("HNDS",doc1.getVar("HNDS"));
			doc7.setVar("HIZN_NDS",doc1.getVar("HIZN_NDS"));
			doc7.setVar("HIZNOS",doc1.getVar("HIZNOS"));
			doc7.setVar("HIZNOSB",doc1.getVar("HIZNOSB"));
			doc7.setVar("HVIDOS",doc1.getVar("HVIDOS"));
			doc7.setVar("HKISP",doc1.getVar("HKISP"));
			doc7.setVar("HPNOM",doc1.getVar("HPNOM"));
			doc7.setVar("HZNOM",doc1.getVar("HZNOM"));
			doc7.setVar("HGOD",doc1.getVar("HGOD"));
		   	doc7.setVar("HVVOD",doc1.getVar("HVVOD"));
			doc7.setVar("HNACHPL",doc1.getVar("HNACHPL"));
	   		doc7.setVar("HDVIB",d00obj.getVarDate());
		   	doc7.setVar("HDORAB",doc1.getVar("HDORAB"));
	   		doc7.setVar("HTEXUSL2",doc1.getVar("HTEXUSL2"));
	   		doc7.setVar("HISP",doc1.getVar("HISP"));
	   		doc7.setVar("HXAR",doc1.getVar("HXAR"));
	   		doc7.setVar("HPLACE",doc1.getVar("HPLACE"));
	   		doc7.setVar("HBMET",doc1.getVar("HBMET"));
			doc7.setVar("HSCH",doc1.getVar("HSCH"));
	   		doc7.save();
		
		   	if (!tblOS.getValue("Fwid7") && !getSnap("select * from ^INV_NUM where Finv_num=" + sqlTo(tblOS.getValue("Finv_num"))))
				ExecuteSQL("insert into ^INV_NUM (Fwid,Finv_num) values ( " +sqlTo(GetUID()) +"," + sqlTo(tblOS.getValue("Finv_num")) + ")");
		
			var m0 = new Object();
			fis_updos0 = true;
			gS = getSnap("select Fedat, Fwid from ^OS0 where Finv_num =" + sqlTo(tblOS.getValue("Finv_num"))+" order by fbdat");
		 	if (gS == null)
		   	{
		   		flagos0 = true;
				strSQL1="";
				m0.fwid=GetUID();
			    m0.fbdat=doc1.getVar("HDAT");
			    m0.fedat=d00;
			
			    m0.finv_num = tblOS.getValue("Finv_num");
			    m0.forig_pric = doc1.getVar("HPRICE");
			    m0.forig_all = doc1.getVar("HPRICEAL");
			    m0.fkol = doc1.getVar("HKOL");
			    m0.fiznos = doc1.getVar("HIZNOS");
			
			    m0.fcod_rate = doc1.getVar("HCODSROK");
				m0.fgroup = doc1.getVar("HGR");
				
				if (doc1.getVar("HNEM") == "+")
				{
		    		if (doc1.getVar("HNEPR") == "-")
		    			FNEM = "nemat";
		    		else 
		    			FNEM = "nemat4";
				}
		    	else
		    	{
		    		if (doc1.getVar("HNEPR") == "-")
		    			FNEM = "neproizv";
		    		else 
		    			FNEM = "proizv";
		    	}
			    
//			    if (FNEM == "proizv")
//			    	m0.fcod_rate = doc1.getVar("HGR");
					
			    m0.fkf_ispol = doc1.getVar("HKISP");
			
				m0.fcr_sc  = doc1.getVar("HCS");
			    m0.fcr_su  = doc1.getVar("HCU");
			    m0.fcr_st  = doc1.getVar("HCT");
				m0.fcr_cod1 = doc1.getVar("HCCOD1");
				m0.fcr_cod2 = doc1.getVar("HCCOD2");
				m0.fcr_cod3 = doc1.getVar("HCCOD3");
		
				m0.fdb_sc = doc1.getVar("HDS");
				m0.fdb_su = doc1.getVar("HDU");
				m0.fdb_st = doc1.getVar("HDT");
				m0.fdb_cod1 = doc1.getVar("HDCOD1");
				m0.fdb_cod2 = doc1.getVar("HDCOD2");
				m0.fdb_cod3 = doc1.getVar("HDCOD3");
		
				m0.fsrokadd = doc1.getVar("HSROC");
				m0.farend = doc7.getVar("HAREND");      
			}
			else
			{
				edat = new Date(gS[0]).getVarDate();
				if ( differ(edat,d00)==0 || differ(doc1.getVar("HDAT"),edat)<0)
				{
			        flagos0 = false;
			        strSQL1 = " Fwid=" + sqlTo(gS[1]);	       
			        m0.fbdat = doc1.getVar("HDAT");
			        m0.finv_num = tblOS.getValue("Finv_num");
			        m0.forig_pric = doc1.getVar("HPRICE");
			        m0.forig_all = doc1.getVar("HPRICEAL");
			        m0.fkol = doc1.getVar("HKOL");
			        m0.fiznos = doc1.getVar("HIZNOS");
			        m0.fcod_rate = doc1.getVar("HCODSROK");
			        m0.fgroup = doc1.getVar("HGR");
			        m0.fkf_ispol = doc1.getVar("HKISP");
			        m0.fcr_sc  =doc1.getVar("HCS");
			        m0.fcr_su  = doc1.getVar("HCU");
			        m0.fcr_st  = doc1.getVar("HCT");
			        m0.fcr_cod1 = doc1.getVar("HCCOD1");
			        m0.fcr_cod2 = doc1.getVar("HCCOD2");
			        m0.fcr_cod3 = doc1.getVar("HCCOD3");
			        m0.fdb_sc  = doc1.getVar("HDS");
			        m0.fdb_su  = doc1.getVar("HDU");
			        m0.fdb_st  = doc1.getVar("HDT");
			        m0.fdb_cod1 = doc1.getVar("HDCOD1");
			        m0.fdb_cod2 = doc1.getVar("HDCOD2");
			        m0.fdb_cod3 = doc1.getVar("HDCOD3");
			        m0.fsrokadd = doc1.getVar("HSROC");
			        m0.farend = doc7.getVar("HAREND");
				}
				else
				{
					alert("Невозможно исправить дату приемки в справочн.измен.перв.стоимости для инв.№"+tblOS.getValue("Finv_num")
						+"\nПроизведите данные изменения вручную");
					fis_updos0 = false;
				}
		   	}
			var m0b = new Object();
			fis_updos0b = true;
			gS = getSnap("select Fedat, Fwid from ^OS0b where Finv_num=" + sqlTo(tblOS.getValue("Finv_num"))+" order by fbdat");
			if (gS == null)
			{
				strSQL2 = "";
				flagos0b = true;
				m0b.fwid = GetUID();
				m0b.fbdat = doc1.getVar("HDAT");
				m0b.fedat = d00;
				m0b.finv_num = tblOS.getValue("Finv_num");
				m0b.forig_pric = doc1.getVar("HPRICEB");
				m0b.forig_all = doc1.getVar("HPRICEB");
				m0b.fkol = doc1.getVar("HKOL");
				m0b.fiznos = doc1.getVar("HIZNOSB");
				m0b.fcod_rate = doc1.getVar("HCODSROK");
				m0b.fgroup = doc1.getVar("HGRB");
				if (FNEM == "nemat" || FNEM == "nemat4")
					m0b.fgroup = 6;
				if (doc1.getVar("HGRB")==0 && FNEM == "neproizv")
		         	m0b.fgroup = 7;
				m0b.fkf_ispol = doc1.getVar("HKISP");
				m0b.fcr_sc  = doc1.getVar("HCS");
				m0b.fcr_su  = doc1.getVar("HCU");
				m0b.fcr_st  = doc1.getVar("HCT");
				m0b.fcr_cod1= doc1.getVar("HCCOD1");
				m0b.fcr_cod2= doc1.getVar("HCCOD2");
				m0b.fcr_cod3= doc1.getVar("HCCOD3");
		
				m0b.fdb_sc  =doc1.getVar("HDS");
				m0b.fdb_su  =doc1.getVar("HDU");
				m0b.fdb_st  =doc1.getVar("HDT");
				m0b.fdb_cod1=doc1.getVar("HDCOD1");
				m0b.fdb_cod2=doc1.getVar("HDCOD2");
				m0b.fdb_cod3=doc1.getVar("HDCOD3");
		
				m0b.fsrokadd = doc1.getVar("HSROC");
				m0b.farend = doc7.getVar("HAREND");
				m0b.FBUHMETOD = doc1.getVar("HBMET");
			}
			else
			{
				edat = new Date(gS[0]).getVarDate();
				if ( differ(edat,d00)==0 || differ(doc1.getVar("HDAT"),edat)<0)
				{
					flagos0b = false;
					strSQL2 = " Fwid=" + sqlTo(gS[1]);
					m0b.fbdat = doc1.getVar("HDAT");
					m0b.finv_num = tblOS.getValue("Finv_num");
					m0b.forig_pric = doc1.getVar("HPRICEB");
					m0b.forig_all = doc1.getVar("HPRICEB");
					m0b.fkol = doc1.getVar("HKOL");
					m0b.fiznos = doc1.getVar("HIZNOSB");
					m0b.fcod_rate = doc1.getVar("HCODSROK");
					m0b.fgroup = doc1.getVar("HGRB");
					if (FNEM == "nemat" || FNEM == "nemat4")
		        		m0b.fgroup = 6;
					if (doc1.getVar("HGRB")==0 && FNEM == "neproizv")
		           		m0b.fgroup = 7;
					m0b.fkf_ispol = doc1.getVar("HKISP");
					
					m0b.fcr_sc  =doc1.getVar("HCS");
					m0b.fcr_su  =doc1.getVar("HCU");
					m0b.fcr_st  =doc1.getVar("HCT");
					m0b.fcr_cod1=doc1.getVar("HCCOD1");
					m0b.fcr_cod2=doc1.getVar("HCCOD2");
					m0b.fcr_cod3=doc1.getVar("HCCOD3");
		
					m0b.fdb_sc  =doc1.getVar("HDS");
					m0b.fdb_su  =doc1.getVar("HDU");
					m0b.fdb_st  =doc1.getVar("HDT");
					m0b.fdb_cod1=doc1.getVar("HDCOD1");
					m0b.fdb_cod2=doc1.getVar("HDCOD2");
					m0b.fdb_cod3=doc1.getVar("HDCOD3");
		
					m0b.fsrokadd=doc1.getVar("HSROC");
					m0b.farend = doc7.getVar("HAREND");
					m0b.FBUHMETOD = doc1.getVar("HBMET");
				}
				else
				{
					alert("Невозможно исправить дату приемки в справочн.измен.перв.стоимости для инв.№"+tblOS.getValue("Finv_num")
						+"\nПроизведите данные изменения вручную");
					fis_updos0b = false;
				}
			}
			var perem = new Object();
			fis_updper = true;
			gS = getSnap("select Fedat,Fwid from ^VN_PEREM where Finv_num=" + sqlTo(tblOS.getValue("Finv_num"))+" order by fbdat");
			if ( gS == null)	   
		    {
				flagperem = true,
				strSQL3="";
				perem.fwid=GetUID();
				perem.fbdat = doc1.getVar("HDAT");
				perem.fedat = d00;
				perem.finv_num = tblOS.getValue("Finv_num");
				perem.fpodr = doc1.getVar("HPDR");
				perem.fpodro = 0;
				perem.ftabn = doc1.getVar("HMOL");
				perem.fsc = doc1.getVar("HZC");
				perem.fsu = doc1.getVar("HZU");
				perem.fst = doc1.getVar("HZT");
				perem.fcl_cod1 = doc1.getVar("HZCOD1");
				perem.fcl_cod2 = doc1.getVar("HZCOD2");
				perem.fcl_cod3 = doc1.getVar("HZCOD3");
				perem.farend = doc7.getVar("HAREND");
			}
			else
			{
				edat = new Date(gS[0]).getVarDate();
				if ( differ(edat,d00)==0 || differ(doc1.getVar("HDAT"),edat)<0)
				{
					flagperem = false;
					strSQL3 = " Fwid= " + sqlTo(gS[1]);
					perem.fbdat=doc1.getVar("HDAT");
					perem.finv_num = tblOS.getValue("Finv_num");
					perem.fpodr = doc1.getVar("HPDR");
					perem.fpodro = 0;
					perem.ftabn = doc1.getVar("HMOL");
					perem.fsc = doc1.getVar("HZC")
					perem.fsu = doc1.getVar("HZU")
					perem.fst = doc1.getVar("HZT")
					perem.fcl_cod1 = doc1.getVar("HZCOD1")
					perem.fcl_cod2 = doc1.getVar("HZCOD2")
					perem.fcl_cod3 = doc1.getVar("HZCOD3")
					perem.farend = doc7.getVar("HAREND");
				}
				else
				{
					alert("Невозможно исправить дату приемки в справочн.внутр.перемещений для инв.№"+tblOS.getValue("Finv_num")
						+"\nПроизведите данные изменения вручную");
					fis_updper = false;
				}
			}
			tbl0n = new Object();
			fis_updos0n = true;
			gS = getSnap("select Fedat,Fwid,fgroup from ^OS0NDS where Finv_num=" + sqlTo(tblOS.getValue("Finv_num")));
			if (gS == null)
			{
				tbl0n.fwid = GetUID();
				tbl0n.fbdat = doc1.getVar("HDAT");
				tbl0n.fedat = d00;
				tbl0n.finv_num = tblOS.getValue("Finv_num");
				tbl0n.forig_pric = doc1.getVar("HNDS");
				tbl0n.fkol = doc1.getVar("HKOL");
				tbl0n.fiznos = doc1.getVar("HIZN_NDS");
		      
				//вместо бухгалтерского проставляем код группы по налоговому учёту
				tbl0n.fgroup = doc1.getVar("HGR");
				if (FNEM == "nemat" || FNEM == "nemat4")
		      		tbl0n.fgroup = 6;
				if (doc1.getVar("HGR") == 0 && FNEM == "neproizv")
	         		tbl0n.fgroup = 7;
				UpdateTable("^OS0NDS",tbl0n,true);
			}
			else
			{
				strSQL = "select * from ^OS0NDS where Finv_num="+sqlTo(tblOS.getValue("Finv_num"))+" and (Fedat>"+sqlTo(doc1.getVar("HDAT"))+" or Fedat="+sqlTo(d00obj)+") order by Finv_num, Fbdat";
				tbl0n1 = OpenTable(strSQL);
				t = new Object();
				if (!tbl0n1.IsEmpty())
				{
					if ((extPar.mode=="EDIT" && !differ(prevddat, tbl0n1.getValue("fbdat"))) || extPar.mode!="EDIT")
					{
						t.fbdat = doc1.getVar("HDAT");
						t.finv_num = tblOS.getValue("Finv_num");
						t.forig_pric = doc1.getVar("HNDS");
						t.fkol = doc1.getVar("HKOL");
						t.fiznos = doc1.getVar("HIZN_NDS");
						t.fgroup = doc1.getVar("HGR");
						if (FNEM == "nemat" || FNEM == "nemat4")
		            		t.fgroup = 6;
						if (Number(doc1.getVar("HGR")) == 0 && FNEM == "neproizv")
							t.fgroup = 7;
						UpdateTable("^OS0NDS",t,false," FWID=" + sqlTo(tbl0n1.getValue("FWID")));
					}
				}
				else
				{
					alert("Невозможно исправить дату приемки в справочн.измен.НДС для инв.№"+tblOS.getValue("Finv_num")
						+"\nПроизведите данные изменения вручную");
					fis_updos0n = false;
				}
				tbl0n1.close();
			}
		  	if (fis_updos0)
		  		UpdateTable("^OS0",m0,flagos0,strSQL1);
			if (fis_updos0b)
				UpdateTable("^OS0b",m0b,flagos0b,strSQL2);
			if (fis_updper)
				UpdateTable("^VN_PEREM",perem,flagperem,strSQL3);
	  	}
	  	setProgressPos(0);
	  	tblOS.close();
	}
}

function filterMode(mode)
{
	if(list.tbl.getValue("Finv_num") == list.tbl.getValue("Fkompl") && (mode == "EDIT" || mode == "COPY"))
		return false;
	return true;	
}

function getGroupConcat(kompl)
{
	var ret = "";
	var t = OpenTable("select Fgroup from ^OS1 where Fkompl="+kompl);
	for(; !t.IsEOF(); t.MoveNext())
		ret += (t.absolute==1?"":"+")+t.getValue("Fgroup");
	t.close();
	return ret;
}