include("Objects/DpCl.js");
include("Objects/DpCntr.js");
include("sys/mask.js");
include("servis/format.js");

var mode,oCl,objCntr,codtarif,fwid;
var objDoc = extPar.doc; 
var ctrlLinker = null;

function Load()
{
	Caption( UR("Довідник зв'язків довідників з процентними надбавками|Справочник связей справочников с процентными надбавками")
		+ ": " + modeName(extPar.mode));
	mode = extPar.mode;
	
	oCl = new DpCl();
	oCl.linkCtrl(FCOD,FTXT);
	
	objCntr = new DpCntr();
	objCntr.setFnum(Number(FPRKNUM.value));
	objCntr.linkCtrl(FPRKNUM,FPRKNAZV);
	
    FPROC.mask="-###.##";
    FSUM.mask="-########.##";
    FCL.mask="###";
    Disable(FCLTXT);
    Disable(FPRKNAZV);
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HSUM",FSUM);
   	ctrlLinker.addLink("HPROC",FPROC);
   	ctrlLinker.addLink("HDAT",FBDAT);
   	ctrlLinker.addLink("HBDAT",FBDAT);
   	ctrlLinker.addLink("HEDAT",FEDAT);
   	ctrlLinker.addLink("HCL",FCL);
   	ctrlLinker.addClLink("HCOD",oCl);
   	ctrlLinker.updateData(false);
   
    setValid(FBDAT, FBDAT_Valid);
    setValid(FEDAT, FEDAT_Valid);

    tbl= extPar.m_pTable;    

	switch(mode)
    {
		case "EDIT":
		case "COPY":
//			FCL.value = tbl.getValue("Fcl");
			fclValid();
			oCl.setClcl(objDoc.getVar("HCL"));
			oCl.setCod(objDoc.getVar("HCOD"));
//			FPROC.value = tbl.getValue("Fproc");
//			FSUM.value = tbl.getValue("Fsum");
//			FBDAT.value = tbl.getValue("Fbdat");
//			FEDAT.value = tbl.getValue("Fedat");
			var snap = getSnap("select Fnum from ^cl_prik where Fvid="+objDoc.getVar("HVID_PRK"));
			if(snap && snap[0])
				objCntr.setFnum(snap[0]);
			break;
		case "ADD":
			FPROC.value = 0;
			FSUM.value = 0;
			FBDAT.value = d00;
			FEDAT.value = d00;
			break;
    }
    setValid(FCL,fclValid);
    this.cl_selected = cl_selected;
    setButton(FCL, this, "cl_selected");
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVID_PRK",objCntr.getFvid());
//	var m = new Object();
//	m.Fcl = FCL.value;
//	m.Fvid_prk = objCntr.getFvid();
//	m.Fcod = oCl.getCod();
//	m.Fbdat = FBDAT.value;
//	m.Fedat = FEDAT.value;
//	m.Fproc = FPROC.value;
//	m.Fsum = FSUM.value;
//	UpdateTable("^cl_lnkprkproc", m, mode!="EDIT");
}

function FBDAT_Valid()
{
	if(differ(FBDAT.value,d00)==0)
	{
		WAIT(ru("Введите значение даты начала!","Введіть значення дати початку!"));
		//setFocus(FBDAT);
		return false;
	}
	return true;
}

function FEDAT_Valid()
{
	if(differ(FBDAT.value,FEDAT.value)>0)
	{
		WAIT(ru("Дата окончания не может быть меньше даты начала!",
				"Дата закінчення не може бути меншою за дату початку!"));
		return false;
	}
	if(mode!="EDIT")
	{
		var snap = getSnap("select Fcl,Fvid_prk,Fcod,Fbdat,Fedat,Fproc from ^cl_lnkprkproc "
						+" where Fcl="+FCL.value+" and Fvid_prk="+objCntr.getFvid()+" and Fcod="+oCl.getCod()
							+" and Fbdat<="+sqlTo(FEDAT.value)+" and Fedat>="+sqlTo(FBDAT.value));
		if(snap!=null)
		{
			WAIT(ru("Период действия записи пересекается с другой записью",
					"Період дії запису перетинається з іншим записом"));
			return false;
		}
	}
	return true;
}

function fclValid()
{
	if(FCL.value == 0)
	{
		var sMsg = UR("Не вказаний довідник!|Не указан справочник!");
		setFocus(FCL);
		FCL.showErr(sMsg);
		return false;
	}
	var Fcod = FCOD.value;
	oCl.setClcl(FCL.value);
	oCl.setCod(Fcod);
	var oSnap = getSnap("select Ftxt from ^CLCL where FCOD="+FCL.value);
	if(oSnap && oSnap[0])
		FCLTXT.value = UR(oSnap[0]);
	return true;
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FTXT = 0;
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	FCL.value = par.ret.FCOD;
	FCLTXT.value = UR(par.ret.FTXT);
}
include("sys/DpBaseDlg.js");