include("Objects\\DpCl.js");
include("Objects\\DpPostRs.js");
include("Objects\\DpRasSc.js");
include("Objects\\DpClcl.js");
include("Objects\\DpCtrlLinker.js");
include("Objects\\DpDocPar.js");
include("doc\\DpDoc.js");
include("sys\\mask.js");
include("Tmoney.js");

var cl, val, oSch, oRasSc;
var objDoc = extPar.doc;
var Validation = true;

function Load()
{	
    HCOT.mask=MASK_OKPO;
	HCTO.mask=MASK_OKPO;
    DOC_NUM.mask=MASK_DOCNUM;
    HSUM.mask = MASK_SUM;
    RSUM.mask = MASK_SUM;   
    HSNDS.mask = MASK_SUM;
    RSCH_F.mask = "&&&&&&&&&&&&&&&";
       
    objPlat = new DpCl();
    objPlat.linkCtrl(HORG,HTOT);
    objPlat.linkCtrl2("Fcod_st", HCOT);   
	objPlat.setClcl(12);
	
	setValid(FDOC_DAT, FDOC_DAT_Valid);
	setValid(HORG, HORG_Valid);
	setValid(HDBSC, HDBSC_Valid);									
	setValid(HMFOOT, HMFOOT_Valid);				
	setValid(HSUM, HSUM_Valid);			
	setValid(HSNDS, HSNDS_Valid);
	
	ctrlLinker = new DpCtrlLinker(objDoc);

	ctrlLinker.addLink("HNOM",DOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	
	
	ctrlLinker.addLink("HORG",HORG);
	ctrlLinker.addLink("HCOT",HCOT);	
	ctrlLinker.addLink("HTOT",HTOT);
	ctrlLinker.addLink("HMFOOT",HMFOOT);
	ctrlLinker.addLink("HBNKOT",HBNKOT);	
	ctrlLinker.addLink("HDBSC",HDBSC);
	
	ctrlLinker.addLink("HTTO",HTTO);
	ctrlLinker.addLink("HCTO",HCTO);
	ctrlLinker.addLink("HBNKTO",HBNKTO);
	ctrlLinker.addLink("HMFOTO",HMFOTO);
	ctrlLinker.addLink("HCRSC",HCRSC);	
	
	ctrlLinker.addLink("HSF",RSCH_F);
	//ctrlLinker.addLink("HRDBN",RDB_SC);	
		
	ctrlLinker.addLink("HSUM",HSUM);
	ctrlLinker.addLink("HNDS",HSNDS);	
	ctrlLinker.addLink("HTOVAR",HTPL);

	ctrlLinker.updateData(false);
		
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
   	{   		
   		RSUM.value = HSUM.value;
   		HTSUM.value=TMoney(HSUM.value);
   		objPlat.setCod(objDoc.getVar("HORG"));
   		HORG_Valid(); 
	}   	  	   		
   	objPlatRs = new DpPostRs();
	objPlatRs.setDpCl(objPlat, objPlat.getCod() != 0);
	objPlatRs.linkCtrl(HDBSC,HMFOOT,HBNKOT);

	HCTO.value = getPar("OOKPO");
	HTTO.value = getPar("OFIRM");
	HMFOTO.value = objDoc.getPar("CUR_RSC_MFO");
	HBNKTO.value = objDoc.getPar("CUR_RSC_BANK");			    
    HCRSC.value = objDoc.getPar("__rscnom");   
    
	Disable(HCTO);
	Disable(HTTO);
	Disable(HMFOTO);
	Disable(HBNKTO);
	Disable(HCRSC);
	
	Disable(RDB_SC);
	Disable(RSUM);
	Disable(HTSUM);	
		
	setFocus(DOC_NUM);			
}

function FDOC_DAT_Valid()
{
/*	if (FDOC_DAT.value <= d00 && FDOC_DAT.value >= d00)	
	{		
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
*/	
	if (differ(FDOC_DAT.value,getPar("GLOBDAT1"))<0 || differ(FDOC_DAT.value,getPar("GLOBDAT2"))>0)
	{
		WAIT(ru("Дата за пределами рабочего периода", 
			"Дата за межами робочого перiоду"));
	}
	return true;
}

function HORG_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}

function HDBSC_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}
function HMFOOT_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}

function HSUM_Valid()
{
	RSUM.value = HSUM.value;
	//var ndsProc = objDoc.getPar("__ndsproc");		
	var ndsProc = objDoc.getPar("__ndsproc");
	SUM = Number(HSUM.value)
	NDS = Number(ndsProc)
	if(ndsProc)
	{
		HSNDS.value = SUM * NDS / (100 + NDS);
		HSNDS_Valid();
	}
	HTSUM.value = TMoney(HSUM.value,0);
	return true;
}

function HSNDS_Valid()
{
	if (Number(HSNDS.value) > Number(HSUM.value))
	{
		WAIT(ru("Сумма НДС не должна превышать сумму!","Сума ПДВ не повинна перевищувати суму!"));
		return false;
	}
	if (HTPL.value == "")
	{
		var str = "НДС "+String(HSNDS.value)+" грн.";
		HTPL.value = str;		
	}
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);	
}

include("sys\\DpBaseDlg.js");