include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("objects\\DpCl.js");
include("objects\\DpClNo.js");
include("Objects\\DpCtrlLinker.js");
include("doc\\DpDoc.js");
include("sys\\mask.js");

var objDoc = extPar.obj; 
var ctrlLinker = null;
var edmode = extPar.mode;

function Load()
{		
	Caption(ru("Додав./Редагув. реєстру квітанцій","Добавл./Редактир. реестра квитанций"));
	
	RSUM.setMask(MASK_SUM);
	setValid(RDAT, HDAT_Valid);
 
	objPotr = new DpCl();
    objPotr.linkCtrl(RORG,RNAME);   
    objPotr.setClcl(objDoc.getParent().getPar("__nomrk"));   
   
 	ctrlLinker = new DpCtrlLinker(objDoc);		
	ctrlLinker.addLink("RDAT",RDAT);
	ctrlLinker.addLink("RSUM",RSUM);
	ctrlLinker.addLink("RORG",RORG);
	ctrlLinker.addLink("RNAME",RNAME);
	
	if(edmode=="EDIT" || edmode=="COPY")
	{
		objPotr.setCod(objDoc.getVar("RORG"));	
	}	
	ctrlLinker.updateData(false);	
	
	setFocus(RORG);
}

function onSave()
{					
	ctrlLinker.updateData(true);
	RNOM = findFreeClNo("RRKTMP","FNOM_STR");    
	objDoc.setVar("RNOM", RNOM);
}

function HDAT_Valid()
{
   if ((RDAT.value<=d00) && (RDAT.value>=d00))
   {
      WAIT("Пустая дата недопустима!");
      return false;
   }

	fbdat = objDoc.getVar("par.HDAT");
	fedat = objDoc.getVar("par.HEDAT");

   if (differ(RDAT.value,fbdat) < 0 || differ(RDAT.value,fedat) > 0)
   {
      WAIT(ru("Дата должна быть в пределах дат документа!","Дата повинна бути в межах дат документу!"));
      return false;
   }

   return true;
}

include("sys\\DpBaseDlg.js");