include("Objects/DpNmkl.js");
include("servis/hoc.js");
include("sys/udfs.js");

var obj = extPar.obj;
var sTblName = "SKU_SERV";
var oNmkl;

function onLoad()
{
	Caption(UR("Послуги|Услуги") +": "+ modeName(extPar.mode));
	
	//FNUM.mask = "##";
	FKOL.mask = MASK_KOL;
	FNORM.mask = MASK_KOL;
	FREGISTR.mask = MASK_KOL;
	FCENA.mask = MASK_CENA;
	FSUM.mask = MASK_SUM;
	FSUMPAY.mask = MASK_SUM;
	FRECALC.mask = MASK_SUM;
	FSUBSIDY.mask = MASK_SUM;
	FPRIVSUM.mask = MASK_SUM;
	//FPRIVKOL.mask = MASK_KOL;
	FDISCOUNT.mask = MASK_SUM;
	
	oNmkl = new DpNmkl();
	oNmkl.linkSmartCtrl(FNMK);
	//oNmkl.setContAssist();
	oNmkl.afterLoad	= loadNmk;
	
	ctrlLinker = new DpCtrlLinker(obj);
	//ctrlLinker.addLink("RNUM", FNUM);
	ctrlLinker.addLink("RKOL", FKOL);
	ctrlLinker.addLink("RNORM", FNORM);
	ctrlLinker.addLink("RSERV", FSERV);
	ctrlLinker.addLink("RCENA", FCENA);
	ctrlLinker.addLink("RCOUNTER", FCOUNTER);
	ctrlLinker.addLink("RREGISTR", FREGISTR);
	ctrlLinker.addLink("RSUM", FSUM);
	//ctrlLinker.addLink("RCOMMENT", FCOMMENT);
	ctrlLinker.addLink("RRECALC", FRECALC);
	ctrlLinker.addLink("RSUBSIDY", FSUBSIDY);
	ctrlLinker.addLink("RPRIVSUM", FPRIVSUM);
	//ctrlLinker.addLink("RPRIVKOL", FPRIVKOL);
	ctrlLinker.addLink("RDISCOUNT", FDISCOUNT);
	ctrlLinker.updateData(false);
	
	fillCounters();
	
	if(extPar.mode=="ADD" || extPar.mode=="COPY")
	{
		//FNUM.value = nextServNum();
		obj.setVar("RNUM", nextServNum());
	}
	if(extPar.mode!="ADD")
	{
		oNmkl.setCod(Number(obj.getVar("RNMKL")));
		FCOUNTER.value = obj.getVar("RCOUNTER");
		sumCalc();
	}
	
	if(extPar.serv)
	{
		FSERV.value = extPar.serv;
		fillCounters();
	}
	if(extPar.counter)
	{
		FCOUNTER.value = extPar.counter;
		setFocus(FREGISTR);
	}
	if(extPar.nmk)
	{
		oNmkl.setCod(extPar.nmk);
		loadNmk();
	}
	if(extPar.tariff)
		FCENA.value = extPar.tariff;
	if(extPar.norm)
		FNORM.value = extPar.norm;
	if(extPar.kol)
		FKOL.value = extPar.kol;
	
	setValid(FSERV, fillCounters);
	setValid(FREGISTR, regValid);
	setValid(FKOL, kolValid);
	setValid(FDISCOUNT, sumCalc);
	setValid(FPRIVSUM, sumCalc);
	setValid(FSUBSIDY, sumCalc);
	setValid(FRECALC, sumCalc);
	
	this.regCalc = regCalc;
	this.kolCalc = kolCalc;
	setButton(FREGISTR, this, "regCalc");
	setButton(FKOL, this, "kolCalc");
	
	//Disable(FNORM);
	Disable(FCENA);	
	Disable(FSUM);
	Disable(FSUMPAY);
	Disable(FPRIVSUM);
	//Disable(FPRIVKOL);
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RNMKL", oNmkl.getCod());
	obj.setVar("RBILL", true);
}

function nextServNum()
{
	var num = 1;
	var tNum = getSnap("select max(FNOM_STR) from "+ extPar.tblName);
	if(tNum!=null && tNum[0])
		num = Number(tNum[0])+1;
	return num;
}

function loadNmk()
{
	if(extPar.mode!="ADD")
		return;
	var nmk = oNmkl.getCod();
	var norm = xnmk(nmk, "NORMA");
	var discount = 0;
	var date = obj.parent.getVar("HDAT");
	var tariff = skuTariff(nmk, date);
	var oSnap = getSnap("select FKOL, FNORM, FDISCOUNT"
						+" from ^SC_SERV"
						+" where FID_DOG="+ obj.parent.dogID 
							+" and FSERV="+ sqlTo(FSERV.value)
							+" and FNMKL="+ sqlTo(nmk)
							+" and FBDAT<="+ sqlTo(date)
							+" and FEDAT>="+ sqlTo(date)							
						);
	if(oSnap)
	{
		if(oSnap[1])
			norm = Number(oSnap[1]);
		discount = Number(oSnap[2]);
		//if(discount)
		//	tariff = tariff-(tariff*discount/100);
	}
	FCENA.value = tariff;
	FNORM.value = norm;
	FDISCOUNT.value = discount;
	sumCalc();
}

function fillCounters()
{
	var counter = FCOUNTER.value;
	FCOUNTER.clear();
	var date = obj.parent.getVar("HDAT");
	var dat1 = firstDay(date);
	var dat2 = lastDay(date);
	var tbl = OpenTable("select * from ^SC_COUNTERS "
						+" where FID_DOG="+ obj.parent.dogID 
							+" and FSERV="+ sqlTo(FSERV.value)
							+" and ((FBDAT<="+ sqlTo(dat1) +" and FEDAT>="+ sqlTo(dat2) +")"
								+" or (FBDAT>="+ sqlTo(dat1) +" and FBDAT<="+ sqlTo(dat2) +")"
								+" or (FEDAT>="+ sqlTo(dat1) +" and FEDAT<="+ sqlTo(dat2) +"))"
						);
	var counterID = 0;
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		var txt = tbl.getValue("FNUM");
		var ser = String(tbl.getValue("FSERIAL")).trim();
		var place = String(tbl.getValue("FPLACE")).trim();
		if(ser!="")
			txt += " - "+ ser;
		if(place!="")
			txt += " ("+ place +")";
		counterID = tbl.getValue("FNUM");
		FCOUNTER.addItem(counterID, txt);
	}
	if(tbl.recordCount==1)
		FCOUNTER.value = counterID;
	if(counter)
		FCOUNTER.value = counter;
	if(FCOUNTER.getLength()>0)
	{
		LCOUNTER.setVisible(true);
		GRCOUNTER.setVisible(true);
	}
	else
	{
		LCOUNTER.setVisible(false);
		GRCOUNTER.setVisible(false);
	}
}

function regValid()
{
	//if(Number(FREGISTR.value)>0)
	//	kolCalc();
}

function kolValid()
{
	//if(Number(FREGISTR.value)==0)
	//	regCalc();
	sumCalc();
}

function regCalc()
{
	var date = obj.parent.getVar("HDAT");
	var dat1 = firstDay(date);
	var dat2 = lastDay(date);
	var dogID = obj.parent.dogID;
	var oSnap = getSnap("select FCURRENT, FPREVIOUS, FDIFFERENCE"
						+" from ^COUNTERS"
						+" where FID_DOG="+ dogID 
							+" and FNUM="+ sqlTo(FCOUNTER.value)
							+" and FISRECALC<>"+ sqlTrue
							+" and FDATE>="+ sqlTo(dat1)
							+" and FDATE<="+ sqlTo(dat2)
						+" order by FDATE DESC"
						);
	if(oSnap && Number(oSnap[0]))
	{
		FREGISTR.value = Number(oSnap[0]);
		if(Number(oSnap[2]))
		{
			FKOL.value = Number(oSnap[2]);
			sumCalc();
			return;
		}
	}
	var prevKol = getPrevKol(FSERV.value, FCOUNTER.value);
	FREGISTR.value = Number(FKOL.value)+prevKol;
	sumCalc();
}

function kolCalc()
{
	var prevKol = getPrevKol(FSERV.value, FCOUNTER.value);
	if(!prevKol)
		prevKol = 0;
	FKOL.value = Number(FREGISTR.value)-prevKol;	
	sumCalc();
}

function sumCalc()
{
	var sum = Number(FKOL.value)*Number(FCENA.value);
	var discount = Number(FDISCOUNT.value);
	if(discount)
		sum = sum-(sum*discount/100);
	FSUM.value = round(sum, getPar("DECISUM"));
	FSUMPAY.value = Number(FSUM.value)-Number(FPRIVSUM.value)-Number(FSUBSIDY.value)+Number(FRECALC.value);
}

function getPrevKol(serv, counter)
{
	var prevKol = 0;	
	var date = obj.parent.getVar("HDAT");
	var oSnap = getSnap("select r.FREGISTR"
						+" from ^"+ sTblName +" r "
							+" inner join ^RAS_SKU h on h.FWID=r.FID_DOC" 
						+" where h.FID_DOG="+ obj.parent.dogID 
							+" and h.FWID<>"+ obj.parent.getID()							
							+" and h.FDOC_DAT<="+ sqlTo(date)
							+(serv? " and r.FSERV="+ sqlTo(serv) : "")
							+(counter? " and r.FCOUNTER="+ sqlTo(counter) : "")
						+" order by h.FDOC_DAT DESC"
						, false
						);
	if(!oSnap || !Number(oSnap[0]))
	{
		var fld = serv;
		if(serv=="HEAT")
			fld = "FHEAT";
		else if(serv=="CWATER")
			fld = "FCOOL";
		else if(serv=="HWATER")
			fld = "FHOT";
		else if(serv=="DRAIN")
			fld = "FDRAIN";
		else if(serv=="GAS")
			fld = "FGAS";
		else if(serv=="ELECTRIC")
			fld = "FELECTRIC";		
		oSnap = getSnap("select "+ fld 
						+" from ^RAS_SKU"
						+ " where FID_DOG="+ obj.parent.dogID 
							+" and FWID<>"+ obj.parent.getID()
							+" and FDOC_DAT<="+ sqlTo(date)
						+" order by FDOC_DAT DESC"
						, false
						);
	}
	if(oSnap!=null && Number(oSnap[0]))
		prevKol = Number(oSnap[0]);
	return round(prevKol, getPar("DECIKOL"));
}

include("sys/DpBaseDlg.js");