include("Objects/DpCl.js");

var oStreet;
var oHouse;
var oPlat;
var oLot;
var oGek;

function onLoad()
{
	extPar.escape = true;
	Caption("Параметри відбору|Параметры отбора");
	if(extPar.title)
		Caption(extPar.title);
	
	oStreet = new DpCl("0!");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	
	oHouse = new DpCl("0!", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	
	oPlat = new DpCl("0!");
	oPlat.setClcl(getPar("CODPLAT"));
	oPlat.linkSmartCtrl(FPLAT);
	oPlat.setContAssist();
	
	oLot = new DpCl("0!");
	oLot.setClcl(getPar("CODLOT"));
	oLot.linkSmartCtrl(FLOT);
	oLot.setContAssist();
	
	oGek = new DpCl("0!");
	oGek.setClcl(getPar("CODGEK"));
	oGek.linkSmartCtrl(FGEK);
	oGek.setContAssist();
		
	if(extPar.lot)
	{
		if(getPar("CODLOT"))
			GLOT.setVisible(true);
	}
	
	if(extPar.street)
		oStreet.setFWID(extPar.street);
	if(extPar.house)
		oHouse.setFWID(extPar.house);
	if(extPar.org)
		oPlat.setCod(extPar.org);
	
	setValid(FBDAT, date_valid);
	setValid(TYPEPER, onChangePeriod);
	
	TYPEPER.value = "TM";
	onChangePeriod();
}

function date_valid()
{
	TYPEPER.value="-"; 
	return true;
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			FBDAT.value = today.getVarDate();
			FEDAT.value = today.getVarDate();
			break;
		case "YTD":
			FBDAT.value = goDay(today, -1);
			FEDAT.value = goDay(today, -1);
			break;
		case "TW":
			FBDAT.value = goDay(today, -today.getDay());
			FEDAT.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			FBDAT.value = firstDayMonth(today);
			FEDAT.value = lastDayMonth(today);
			break;
		case "LM":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(today);
			break;		
		case "TY":
			FBDAT.value = jan01(today);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			FBDAT.value = jan01(bdat);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			FBDAT.value = d00min;
			FEDAT.value = d00;
			break;
		default:
			break;
	}
}

function onSave()
{
	var par = new Object();
	par.doc = "SKU";
	par.nop = getPar("HOC_SKU");
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
	par.org = oPlat.getCod();
	par.lot = oLot.getCod();
	par.gek = oGek.getCod();
	par.bdat = FBDAT.getValue();
	par.edat = FEDAT.getValue();
	var licsc = String(FLICSC.value).trim();
	if(FLICSC.value && licsc!="")
		par.dog_num = licsc;
	showWindow("l_docekz.xml", SW_NOMODAL, par);
	return true;
}

include("sys/DpBaseDlg.js");