include("objects\\DpCl.js");
include("sys\\mask.js");

var ctrlLinker;
var oOrg;

function Load()
{
	Caption(ru("Налоговые остатки)","Податкові залишки"),extPar.mode);
	
	ctrlLinker = new DpCtrlLinker(extPar.obj);

	var oOrg = new DpCl("", sprOrg, 0);
	oOrg.linkSmartCtrl(HORG); 	
	
	HTPO20.setMask(MASK_SUM);
	HDPO20.setMask(MASK_SUM);
	HDVO20.setMask(MASK_SUM);
	HTVO20.setMask(MASK_SUM);
	
	HTPONDS.setMask(MASK_SUM);
	HDPONDS.setMask(MASK_SUM);
	HTVONDS.setMask(MASK_SUM);
	HDVONDS.setMask(MASK_SUM);
	
	ctrlLinker.addClLink("HORG",oOrg);

	ctrlLinker.addLink("HTPO20",HTPO20);
	ctrlLinker.addLink("HDPO20",HDPO20);
	ctrlLinker.addLink("HDVO20",HDVO20);
	ctrlLinker.addLink("HTVO20",HTVO20);

	ctrlLinker.addLink("HTPONDS",HTPONDS);
	ctrlLinker.addLink("HDPONDS",HDPONDS);
	ctrlLinker.addLink("HTVONDS",HTVONDS);
	ctrlLinker.addLink("HDVONDS",HDVONDS);

	ctrlLinker.addLink("HTPOSNDS",HTPOSNDS);
	ctrlLinker.addLink("HDPOSNDS",HDPOSNDS);
	
	/*
	ctrlLinker.addLink("RNOM",NOM_STR);
	ctrlLinker.addLink("RDAT",DATE);
	ctrlLinker.addLink("RSUMD",SUMD);
	ctrlLinker.addClLink("RVAL",oVal);
	ctrlLinker.addLink("RSC",DB_SC);
	ctrlLinker.addLink("RSU",DB_SU);
	ctrlLinker.addLink("RST",DB_ST);
	ctrlLinker.addLink("RA1",DB_A1);
	ctrlLinker.addLink("RA2",DB_A2);
	ctrlLinker.addLink("RA3",DB_A3);
	ctrlLinker.addLink("RTXT",TXT);
	
	
	if (extPar.mode != "ADD")
	{
		oVal.setCod(extPar.obj.getVar("RVAL"));
		oSc.set(extPar.obj.getVar("RSC"),extPar.obj.getVar("RSU"),extPar.obj.getVar("RST"),
				extPar.obj.getVar("RA1"),extPar.obj.getVar("RA2"),extPar.obj.getVar("RA3"));
		
	}

    setValid(NOM_STR, NOM_STR_Valid);
    setValid(DATE, DATE_Valid);	
	setValid(SUMD, SUMD_Valid);
	*/	
	ctrlLinker.updateData(false);
}

function SUMD_Valid()
{
	if (SUMD.getValue()==0)
	{
		WAIT(ru("Нулевая сумма недопустима!","Нульова сума неприпустима!"));
		return false;
	}
	return true;
}

function NOM_STR_Valid()
{
	var val = parseInt(NOM_STR.getValue());
	if (!val || val > 32766)
	{
		WAIT(ru("Слишком большое значение","Надто велике значення"));
		return false;
	}
	return true;
}

function DATE_Valid()
 {
	if ((DATE.getValue()<=d00) && (DATE.getValue()>=d00))
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима"));
		return false;
	}
	return true;
}

function onSave()
{
	extPar.obj.setVar("HREG", extPar.obj.parent.getVar("HREG"))
	ctrlLinker.updateData(true);
	alert(extPar.obj.getVar("HREG"))
}


include("sys\\DpBaseDlg.js");