include("doc\\DpDocList.js");
include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("sys\\dbase.js");
include("Tmoney.js");
include("Objects\\DpZJournal.js"); 
include("sys\\servis.js");

var sTmpTbl = "tmp_sld_mdocreg";
var ctrlLinker;
var oVal;
var tbl;
var oZJ;


function Load()
{
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;
	
	Caption(extPar.doc.getCaption() + ": " + modeName(extPar.mode));

	oZJ = new DpZJournal("S");
	oZJ.linkCtrl(HREG);
	
	ctrlLinker = new DpCtrlLinker(extPar.doc);
	ctrlLinker.addLink("HNOM", HNOM);
	ctrlLinker.addLink("HDAT", HDAT);
	ctrlLinker.addLink("HREG", HREG);
	
	ctrlLinker.toControls();	

	HNOM.setMask(MASK_DOCNUM);
}

function listMenuInit()
{
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
	
	grid.AddMenuItem("MAKEOST", "Сформировать остатки");
	grid.AddMenuItem("MAKEOST_ORG", "Сформировать остатки по организациям");
}

function _initGrid()
{
   	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
   	
   	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
   	
   	DropTable(sTmpTbl);
   	
   	ExecuteSQL(s = 
   		"SELECT *"
   		+ " INTO " + sTmpTbl
   		+ " FROM ^mdocreg"
   		+ " WHERE hid_doc=" + nId
   		+ " ORDER BY horg, hiddeal"
   		)
   			
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	tbl = OpenTable(
		"select *"
		+ " from " + sTmpTbl
		);
		
	//if(extPar.mode=="COPY")
	//	extPar.doc.resetFnids(tbl, "AOROW", extPar.doc);
	
	grid.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	grid.build();
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function onSelectRowMenu(sID)
{
	if (sID == "MAKEOST" || sID == "MAKEOST_ORG")
	{
		var sGroupFields, sFields;
		var sOtherFields = "";
		 
		if (sID == "MAKEOST_ORG")
		{
			sGroupFields = "horg"
			sOtherFields = ", 0 AS hidcontr"
				+ ", MIN(m.hgroup) AS hgroup"
				+ ", MAX(m.hiddeal) AS hiddeal"	
		}
		else
		{
			sGroupFields = "horg, hiddeal, hgroup, hidcontr"
		}
		
		/*
		var tOst = OpenTable(
			"SELECT horg, hiddeal, hidcontr, hgroup"
				+ ", SUM(m.htpo20) AS htpo20"
				+ ", SUM(m.hdpo20) AS hdpo20"
				+ ", SUM(m.htvo20) AS htvo20"
				+ ", SUM(m.hdvo20) AS hdvo20"
				+ ", SUM(m.htso20) AS htso20"
				+ ", SUM(m.htponds) AS htponds"
				+ ", SUM(m.hdponds) AS hdponds"
				+ ", SUM(m.htvonds) AS htvonds"
				+ ", SUM(m.hdvonds) AS hdvonds"
				+ ", SUM(m.htsonds) AS htsonds"
				+ ", SUM(m.htpo00) AS htpo00"
				+ ", SUM(m.hdpo00) AS hdpo00"
				+ ", SUM(m.htvo00) AS htvo00"
				+ ", SUM(m.hdvo00) AS hdvo00"
				+ ", SUM(m.htso00) AS htso00"
				+ ", SUM(m.htpoa0) AS htpoa0"
				+ ", SUM(m.hdpoa0) AS hdpoa0"
				+ ", SUM(m.htvoa0) AS htvoa0"
				+ ", SUM(m.hdvoa0) AS hdvoa0"
				+ ", SUM(m.htsoa0) AS htsoa0"
				+ ", SUM(m.htpob0) AS htpob0"
				+ ", SUM(m.hdpob0) AS hdpob0"
				+ ", SUM(m.htvob0) AS htvob0"
				+ ", SUM(m.hdvob0) AS hdvob0"
				+ ", SUM(m.htsob0) AS htsob0"
				+ ", SUM(m.htpoe0) AS htpoe0"
				+ ", SUM(m.hdpoe0) AS hdpoe0"
				+ ", SUM(m.htvoe0) AS htvoe0"
				+ ", SUM(m.hdvoe0) AS hdvoe0"
				+ ", SUM(m.htsoe0) AS htsoe0"
				+ ", SUM(m.htpoxx) AS htpoxx"
				+ ", SUM(m.hdpoxx) AS hdpoxx"
				+ ", SUM(m.htvoxx) AS htvoxx"
				+ ", SUM(m.hdvoxx) AS hdvoxx"
				+ ", SUM(m.htsoxx) AS htsoxx"
			+ " FROM ^mdocreg m"
			+ " WHERE hreg=" + sqlTo(HREG.value)
				+ " AND hdat<" + sqlTo(HDAT.value)
			+ " GROUP BY horg, hiddeal, hidcontr, hgroup"
			)
		*/
		
		var prevSldCond = "";
		oSld = getSnap(
				"SELECT MAX(fdoc_dat)"
				+ " FROM ^hsldregm"
				+ " WHERE fdoc_dat<" + sqlTo(HDAT.value)
				)
			
		if (oSld[0])
		{
			prevSldCond = " AND hdat>=" + sqlTo(oSld[0])
		}
		
		var tOst = OpenTable(s = 
			"SELECT " + sGroupFields + sOtherFields
				+ getSumExpr("20")
				+ getSumExpr("nds")
				+ getSumExpr("snds")
				+ getSumExpr("00")
				+ getSumExpr("a0")
				+ getSumExpr("b0")
				+ getSumExpr("e0")
				+ getSumExpr("xx")
			+ " FROM ^mdocreg m"
			+ " WHERE hreg=" + sqlTo(HREG.value)
				+ " AND hdat<" + sqlTo(HDAT.value)
				+ prevSldCond
			+ " GROUP BY " + sGroupFields
			)
		
		var m = new Object;
		for(tOst.MoveFirst(); !tOst.IsEOF(); tOst.MoveNext())
		{
			m = scatter(tOst);
			m.HDAT = HDAT.value;
			m.HID_DOC = extPar.doc.getID();
			m.HDOC = extPar.doc.sDocLbl;
			m.HSORT = -1;
			m.HREG = HREG.value;
			m.FWID = GetUID();
			if(allt(m.HGROUP)=="")
				m.HGROUP = "0";
			insertIntoTable(sTmpTbl, m);
		}	
		
		//browse(tOst)
		grid.getTable().requery();
		grid.refresh();
	}
	else if (sID == "DEL")
	{
		extPar.doc.deleteRow("RSLDREGM",
				Number(grid.getTable().getRowID()));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow("RSLDREGM");
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow("RSLDREGM",Number(grid.getTable().getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow("RSLDREGM", 
						Number(grid.getTable().getRowID()));			
		}
		
		var bOK = oDocRow.edit(sID)
		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}	
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow("RSLDREGM",oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();
		}
	}
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^mdocreg "
		+ "WHERE hid_doc=" + sqlTo(extPar.doc.getVar("ID"))
		);
		
	var columns = getColumn(sTmpTbl);
	ExecuteSQL("INSERT INTO ^mdocreg (" + columns + ")"
		+ " SELECT " + columns 
		+ " FROM " + sTmpTbl
		);
}

function onSave()
{
	ctrlLinker.toVars();
	saveRows();
	tbl.close();
}

function onEscape()
{
	tbl.close();
}

function getSumExpr(prefix)
{
	var sumT_D = "SUM(m.htpo"+prefix+" - m.hdpo"+prefix
		+ " - abs(m.htvo"+prefix+") + abs(m.hdvo"+prefix+"))"

	var ret = "," + sqlRound(sqlMax(0,      sumT_D), 2) + " AS htpo"+prefix+""
		+ "," + sqlRound(sqlMax(0, "-"+ sumT_D), 2) + " AS hdpo"+prefix+""
		+ ", 0 AS htvo"+prefix+""
		+ ", 0 AS hdvo"+prefix+""
		+ (prefix=="snds"? "": ", SUM(m.htso"+prefix+") AS htso"+prefix+"")

	return ret;
}

include("sys\\DpBaseDlg.js");