include("Objects/DpCl.js");

load();
function load()
{		
	GRCONTENT.setVisible(true);
	GRSOLUTION.setVisible(true);
	GRDOC.setVisible(false);
	GRBUTTON.setVisible(false);	
		
	list.oType = new DpCl("0", getPar("CRM_CALL_TYPE"), 0);
	list.oType.linkSmartCtrl(FTYPE);
	list.oType.setContAssist();
	list.oType.AfterUpdate = filter_apply;
	
	list.oCat = new DpCl("0", getPar("CRM_CALL_CAT"), 0);
	list.oCat.linkSmartCtrl(FCAT);
	list.oCat.setContAssist();
	list.oCat.AfterUpdate = filter_apply;
	
	list.oTopic = new DpCl("0", getPar("CRM_CALL_TOPIC"), 0);
	list.oTopic.linkSmartCtrl(FTOPIC);
	list.oTopic.setContAssist();
	list.oTopic.AfterUpdate = filter_apply;
	
	if(extPar && extPar.keyWords)
		FKEYWORD.value = extPar.keyWords;
	
	this.filter_apply = filter_apply;
	//FKEYWORD.setEnterHandler(this, "filter_apply");
	//FKEYWORD.setModifyHandler(this, "filter_apply");
	//FKEYWORD.setSelectionHandler(this, "filter_apply");
	//setValid(FKEYWORD, keyword_valid);
	//setWhen(FKEYWORD, when_keyword);	 	
	
	BTN_CLEAR_FILTER.setImage(lpProxy.getWrkDir() +"/icons/undo.gif");
	BTN_CLEAR_FILTER.getCtrl().setToolTipText(UR("Скидання фільтру|Сброс фильтра"));
	setButton(BTN_CLEAR_FILTER, clear_filter);
	setButton(BTN_FILTER, filter_apply);
	
	this.showContent = showContent;
	grid.setSelHandler(this, "showContent");
	
	runInThread(fillKeyWords);
}

function showContent()
{
	try
	{
		var tbl = grid.getTable();
		if(!tbl.isEmpty())
			FCONTENT.value = tbl.getValue("FTYPE_TXT") +": "+ tbl.getValue("FSUBJECT") +". "
						+"\r\n"+ tbl.getValue("FSOLUTION");
	}
	catch(e)
	{
		
	}
}

function when_keyword()
{
	try
	{
		FKEYWORD.getCtrl().setSelection(0, String(FKEYWORD.value).length);
	}
	catch(e){}	
}

function clear_filter()
{
	list.oType.setCod(0);
	list.oCat.setCod(0);
	list.oTopic.setCod(0);
	FKEYWORD.value = "";
	filter_apply();
}

function filter_apply()
{
	try
	{
		list.init(true);
		var sKeyWord = java.lang.String(FKEYWORD.value).trim();
		if(sKeyWord!="")
		{ 
			if(FKEYWORD.getCtrl().indexOf(sKeyWord)==-1)
				FKEYWORD.getCtrl().add(sKeyWord, 0);
		}
	}
	catch(e)
	{
		trace(e)
	}
}

function keyword_valid()
{
	list.init(true);
}

function gridCond(oGrid)
{
	for(var nColor=1; nColor<=26; nColor++)
	{
		oGrid.defCond(nColor, "=^FCOLOR=="+ nColor);
		oGrid.color(nColor, nColor);
	}	
}

function docSrc()
{
	var sWhere = "1=1";
	if(list.oType && list.oType.getCod())
		sWhere += " and FTYPE="+ list.oType.getCod();
	if(list.oCat && list.oCat.getCod())
		sWhere += " and FCAT="+ list.oCat.getCod();
	if(list.oTopic && list.oTopic.getCod())
		sWhere += " and FTOPIC="+ list.oTopic.getCod();
	
	if(extPar && extPar.subWhere)
		sWhere += " and ("+ extPar.subWhere +")";
	
	var sKeyWords = java.lang.String(FKEYWORD.value).trim();
	sKeyWords = sKeyWords.replace(",", " ");
	sKeyWords = sKeyWords.replace("|", " ");
	sKeyWords = sKeyWords.replace(";", " ");
	var arrKeys = sKeyWords.split(" ");
	if(arrKeys.length>0)
	{
		var sWhereKeyWords = "";
		for(var n=0; n<arrKeys.length; n++)
		{
			var sKey = String(arrKeys[n]).trim();
			if(!sKey || sKey=="" || sKey=="undefined")
				continue;
			if(n>0)
				sWhereKeyWords += " or ";			
			sWhereKeyWords += "("+ whereKeyWord(sKey) +")";
		}
		if(sWhereKeyWords.trim()!="")
			sWhere += " and ("+ sWhereKeyWords +")";
	}			

	this.qrySet("From", "^LISTSOLUTIONS"
				, "Order", "FTYPE_TXT, FCAT_TXT, FTOPIC_TXT"				
				, "Where", sWhere
				);	
}

function whereKeyWord(sKeyWord)
{
	sKeyWord = String(sKeyWord).trim().toLowerCase();
	var sWhere = "LOWER(FKEYWORD) like '%"+ sKeyWord +"%'"
			+" or (FKEYWORD="+ sqlEmpStr
			+" and (LOWER(FTYPE_TXT) like '%"+ sKeyWord +"%'"
				+" or LOWER(FCAT_TXT) like '%"+ sKeyWord +"%'"
				+" or LOWER(FTOPIC_TXT) like '%"+ sKeyWord +"%'"
				+" or LOWER(FSUBJECT) like '%"+ sKeyWord +"%'"
				+" or LOWER(FSOLUTION) like '%"+ sKeyWord +"%'"
				+"))"			
	return sWhere;
}

function listInitEditParam(oPar)
{
	oPar.grid = grid;
	oPar.topic = list.oTopic.getCod();
	oPar.cat = list.oCat.getCod();
	oPar.type = list.oType.getCod();
	oPar.keyWord = FKEYWORD.value;
}

function fillKeyWords()
{
	var tbl = OpenTable("select FKEYWORD from ^SOLUTIONS");
	display.asyncExec
	(
		function addKeys()
		{
			var t = new Date().getTime();
			for(; !tbl.isEOF(); tbl.MoveNext())
			{
				try
				{
					var sKeyText = java.lang.String(tbl.getValue("FKEYWORD")).trim();
					if(!tbl.getValue("FKEYWORD") || sKeyText=="")
						continue;
					sKeyText = sKeyText.replace("\n", " ");
					sKeyText = sKeyText.replace(",", " ");
					sKeyText = sKeyText.replace(".", " ");
					sKeyText = sKeyText.replace(";", " ");
					sKeyText = sKeyText.replace("'", "");					
					var arrWords = sKeyText.split(" ");
					for(var i=0; i<arrWords.length; i++)
					{
						if(arrWords[i])
						{
							var sWord = java.lang.String(arrWords[i]).trim();
							if(sWord!="" && FKEYWORD.getCtrl().indexOf(sWord)==-1)
								FKEYWORD.addItem(sWord, sWord);
						}
					}
				}
				catch(e)
				{
					trace(e);
				}
			}						
		}
	);
}

include("sys/DpList.js");