include("Objects/DpCl.js");
include("sys\\servis.js");

var programmerCl;
var finderCl;
var finder = ReadParEx("CURTASKFINDER");
var programmer = ReadParEx("CURTASKPROGRAMMER");
var myCod = 0;

loadTask();
function loadTask()
{
	if(extPar.menuMode=="MY")
	{
		myCod = getPersCod(getUserName());
		programmer = 0;
		finder = 0;
	}
	else
	{
		GRTASK.setVisible(true);
	}		
	
	if(extPar.menuMode=="OWN")
	{
		programmer = 0;
		finder = getPersCod(getUserName());		
	}
	else if(extPar.menuMode=="MY_OWN")
	{
		programmer = getPersCod(getUserName());
		finder = getPersCod(getUserName());
	}
	else if(extPar.menuMode=="ALL")
	{
		programmer = 0;
		finder = 0;
	}	
	
	if(extPar.programmer)
		programmer = extPar.programmer;		
	if(extPar.finder)
		finder = extPar.finder;
	if(extPar.dat1)
		setPar("GLOBDAT1", extPar.dat1);
	if(extPar.dat2)
		setPar("GLOBDAT2", extPar.dat2);

	programmerCl = new DpCl("0", getPar("CODPERS"), 0);
	programmerCl.linkCtrl(FPROGRAMMER, FPROGRAMMER_TXT);

	finderCl = new DpCl("0", getPar("CODPERS"), 0);
	finderCl.linkCtrl(FFINDER, FFINDER_TXT);
	
	if(finder!=null)
		finderCl.setCod(finder);
	if(programmer!=null)	
		programmerCl.setCod(programmer);
	
	if(extPar.menuMode=="FORPROG" && extPar.objAsk && extPar.objAsk.programmer)
	{
		programmerCl.setCod(extPar.objAsk.programmer);
		Disable(FPROGRAMMER);
	}
	
	list.AfterLoad = listAfterLoad;
	list.subUnLoad = unLoad; 		
}

function listAfterLoad()
{
	showContent();
}

function selRecordTaskHandler()
{
	if (this.tmContext == null)
	{
		this.tmContext = runTimer(runContentView, 50)	
	}
	else
	{
		this.tmContext.stop();
		this.tmContext.start();
	}	
	
}

function runContentView()
{
	if(!list.tbl)
		return;
	var par = new Object();	
	par.content = list.tbl.getValue("fcontent");
	par.docID = Number(list.tbl.getValue("FWID"));
	var view = lpProxy.getView("content");
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("content", par);	
		}		
	}	
}

function showContent()
{
	list.selRecordHandler = selRecordTaskHandler;
	grid.setSelHandler(list, "selRecordHandler"); 
	
	var par = new Object();
	list.tbl.absolute = 1;
	par.content = list.tbl.getValue("fcontent");	
	par.docID = Number(list.tbl.getValue("FWID"));
	par.showLinks = true;
	var view = lpProxy.getView("content");
	//if (view == null)
	{		
		view = lpProxy.showView("content", "content.xml", par)
	}/*
	else
	{
		view.sendMessage("content", par);	
	}*/
}
	
function docSrc()
{		
	finder = finderCl.getCod();
	programmer = programmerCl.getCod();
	WriteParEx("CURTASKFINDER", String(finder));
	WriteParEx("CURTASKPROGRAMMER", String(programmer));
		
	var strWhere = getListWhere(extPar.menuMode);	
	if(finder!=0 && finder!=null)
		strWhere += " and FFINDER="+ sqlTo(finder);
	if(programmer!=0 && programmer!=null)
		strWhere += " and FPROGRAMMER="+ sqlTo(programmer);
	if(extPar && extPar.fid_doc)
		strWhere += " and FWID="+ sqlTo(extPar.fid_doc);
	if(extPar && extPar.org)
		strWhere += " and FCUSTOMER="+ sqlTo(extPar.org);
	if(extPar && extPar.subWhere)
		strWhere += " and ("+ extPar.subWhere +")";
	this.qrySet("From", "^LISTDOCSTASK",
				"Where", strWhere,
				"Order", "FDOC_DAT, FCUSTOMER",
				"Ptn", "TASK");
	return true;		
}

function docTitle()
{
	return getTitle(extPar.menuMode);
}

function listInitEditParam(par)
{
	if(extPar)
	{
		par.org = extPar.org;		
	}
	par.programmer = programmerCl.getCod();
	par.finder = finderCl.getCod();
	if(!par.finder)
		par.finder = getPersCod(getUserName(), false);
}

function docMenuInit()
{
	var tbl = this.dataSrc.getTable();
	if (tbl.IsRecord())
	{
		this.dataSrc.AddMenuItem("HISTORYTASK", "Історія|История");
		if(lpProxy.getView("content")==null)
			this.dataSrc.AddMenuItem("SHOWCONTENT","Показати зміст|Показать содержание");
		this.dataSrc.AddMenuItem("MYTASK_TO_STARTUP", "Додати мої завдання до автозагрузки|Добавить мои задачи в автозагрузку");
		this.dataSrc.AddMenuItem("","");		
		this.dataSrc.AddMenuItem("FORM_SF", "Сформувати рахунок|Сформировать счет");
		this.dataSrc.AddMenuItem("FIND_SF", "Знайти рахунки|Найти счета");
		this.dataSrc.AddMenuItem("","");
		this.dataSrc.AddMenuItem("GANTTGRAPH", "Графiк Гантта|График Гантта");
	}
} 

function docMenuHandler(szID)
{		
	switch(szID)
	{
	case "HISTORYTASK":
		var par = new Object();
		par.fwid = this.tbl.getValue("FWID");
		par.fstatus = this.tbl.getValue("FSTATUS");
		showWindow("l_vsshr.js", SW_MODAL, par, "");
		break;
	case "GANTTGRAPH":
		var par = new Object();		
		showWindow("ganttchart.xml", SW_NOMODAL, par, "");
		break;
		
	case "MYTASK_TO_STARTUP":				
		addStartup("r", "loadMyTask.js");
		break;
		
	case "FORM_SF":
		formSFbyTask();
		break;
	
	case "FIND_SF":
		var par = new Object();
		par.doc = "SF";
		par.FORG = this.tbl.getValue("FCUSTOMER");
		//par.fid_doc = this.tbl.getValue("FID_SF");
		par.subWhere = " FWID in (select FDOCWID from ^DOC_LINKS where FMAINWID="+ this.tbl.getValue("FWID") +")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);
		break;
	
	case "SHOWCONTENT":
		showContent();
		break;
				
	case "DEL":
		listDel();
		break;		
	}		
}

function formSFbyTask()
{
	include("doc/DpDoc.js");
	include("Objects/DpClEx.js");
	
	var tbl = list.tbl;	
	var sTxt = String(tbl.getValue("FCAPTION")).trim();
	/*
	if(!sTxt || sTxt=="")
	{
		var sMsg = UR("Введіть назву номенклатури|Введите название номенклатуры");
		sTxt = input(sMsg, "", "", 250);
		if(!sTxt)
			return false;
	}
	*/
	var nmkID = 0;		
	var oSnap = getSnap("select FWID, FCOD, FGRPID "
						+" from ^CL_NMK "
						+" where FTXTS="+ sqlTo(sTxt)
							+" or FTXT0="+ sqlTo(sTxt)
						);
	if(oSnap)
	{
		nmkID = oSnap[0];
	}
	else
	{	
		var par = new Object();
		par.ret = new Object();
		par.ret.FWID = null;
		//par.GroupOnly = true;
		par.title = UR("Виберіть номенклатуру|Выберите номенклатуру");
		showWindow("l_clnmktree.xml", SW_MODAL, par);
		if(par.escape)
			return;
		nmkID = par.ret.FWID;		
		/*
		var groupID = par.ret.FWID;
		var nmkCod = getNextNmkCod(groupID);
			
		var oNmkl = new DpClEx("nmkl", 0);
		oNmkl.setVar("HCOD", nmkCod);
		oNmkl.setVar("HGRPID", groupID);	
		oNmkl.setVar("HTXT0", sTxt);
		oNmkl.setVar("HTXTS", sTxt);
		oNmkl.setVar("HVID", "S");
		oNmkl.setVar("HCEDIB", 1);
		var bRet = oNmkl.save("ADD");
		if(!bRet)
			return;
		nmkID = oNmkl.getID();
		updateTreeKeys("^CL_NMK", nmkID, new Array("FCOD", "FTXTS"));
		*/
	}
	
	var time = Number(tbl.getValue("FTIMEVIPOLN"));
	var tax = Number(ReadParameter("TAX"));
	if(!tax)
	{
		tax = 200;
		WriteParameter("TAX", tax);
	}
	var sum = tax;
	if(time)
		sum = tax*time;
	var sMsg = UR("Введіть суму рахунку|Введите сумму счета");
	sum = input(sMsg, "", sum, 20);
	if(sum==null)
		return false;
	if(time>0)
		WriteParameter("TAX", sum/time);
	
	var sDoc = "SF";
	var nNop = 1;
	
	var oSnap = getSnap("select count(*) as cnt from ^CL_LNK where UPPER(FDOC)='SF' and FNOP>0");
	if(oSnap && Number(oSnap[0])==1)
	{
		oSnap = getSnap("select FNOP from ^CL_LNK where UPPER(FDOC)='SF' and FNOP>0");
		if(oSnap && oSnap[0])
			nNop = oSnap[0];
	}
	else
	{
		var par = new Object();
		par.ret = new Object();
		par.ret.Fdoc = null;
		par.ret.Fnop = null;
		par.escape = true;
		par.doc = sDoc;
		par.mode = "DOCONLY";
		showWindow("l_cl_lnk.xml", SW_MODAL, par);
		if(par.escape)
			return;		
		nNop = par.ret.Fnop;
	}
	
	var oDoc = new DpDoc(sDoc, nNop);
	
	var oPar = new Object();	
	oPar.org = tbl.getValue("FCUSTOMER");
	oPar.submode = "GETORDER";
	
	var oRow = oDoc.createRow("ROW");
	oDoc.appendRow("ROW", oRow);
	oRow.setVar("RTNMK", nmkID);
	oRow.setVar("RKOL",	1);
	oRow.setVar("RNOM", 1);
	oRow.setVar("RTYPE", "7");
	oRow.setVar("RPCENE", sum);
	oRow.setVar("RCENAORD", sum);
	oRow.setVar("ROCENA", sum);		
	oRow.setVar("RFOCENA", sum);
	oRow.setVar("RSUM", sum);
	//oRow.setVar("RPOST", oPar.org);
	obj2DB(oRow.getID(), oRow.jDocRow, null, "ANLTK");	
			
	oDoc.setVar("HPSUM", sum);
	oDoc.setVar("HSUM", sum);
	oDoc.setVar("HKOL", 1);
		
	var bRet = oDoc.edit("ADD", 0, oPar);
	if(bRet)
	{
		var m = new Object(); 
		m.FMAINWID = tbl.getValue("FWID");
		m.FDOCWID = oDoc.getID();
		m.Fdoc = sDoc;
		m.Fnop = nNop;
		m.FISPARENT = true;
		m.FWID = GetUID();
		updateTable("^doc_links", m, true);
		
		var m = new Object(); 
		m.FMAINWID = oDoc.getID();
		m.FDOCWID = tbl.getValue("FWID");
		m.Fdoc = tbl.getValue("FDOC");
		m.Fnop = Number(tbl.getValue("FNOP"));
		m.FISPARENT = false;
		m.FWID = GetUID();
		updateTable("^doc_links", m, true);
		
		var nRow = tbl.getAbsolute();
		grid.getTable().requery();
		grid.refresh();
		grid.getTable().setAbsolute(nRow);
	}
	else
	{
		ExecuteSQL("delete from ^ANLTK where FWID="+ oRow.getID());
	}
}

function isTaskSF(taskID)
{
	var oSnap = getSnap("select FDOCWID from ^DOC_LINKS where FMAINWID="+ taskID);
	return oSnap!=null;
}

function getNextNmkCod(groupID)
{
	var parCode = "";
	if (groupID)
	{
		var parSnap = getSnap("SELECT FCOD "
							+ " FROM ^cl_nmk "
							+ " WHERE FWID=" + sqlTo(Number(groupID)));
		if (parSnap != null && parSnap[0] != null)
			parCode = parSnap[0];
	}
	var sSQL = "SELECT FCOD"
			   	+" FROM ^cl_nmk"
			   	+" WHERE FGRPID="+ sqlTo(Number(groupID))
			   		+" AND (FISGRP<>" + sqlTo(true)
			   		+" OR FISGRP IS NULL)"
			   	+" order by FWID desc";	
	var oSnap = getSnap(sSQL);
	if (!oSnap)
		return parCode + first0("1");
	var maxCode = String(oSnap[0]);
	var nInd = maxCode.lastIndexOf(".");
	if (nInd != -1)
		maxCode = maxCode.substr(nInd + 1);		
	if (isNaN(parseFloat(maxCode)))
		return parCode + first0("1");
	return parCode + first0(String(parseFloat(maxCode) + 1));
}

function first0(cod)
{
	while (cod.length < 4)
		cod = "0" + cod;
	return cod;
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^historytask WHERE fiddoc = " + sqlTo(list.tbl.getValue("FWID")));
	/*var sFWID = list.tbl.getValue("FWID");
	if(sFWID && sFWID!="")
		ExecuteSQL("DELETE FROM " + list.qryFrom + " WHERE fwid = " + sqlTo(sFWID));
	else
		alert("Отсутствует поле FWID или его значение пустое");
	*/ 
}

function getTitle(menuMode)
{	
	var strTitle = ru("Список заданий", "Список завдань");
	if(!menuMode || menuMode=="CALC")
		menuMode = "LIST";
	switch(menuMode)
	{
	case "LIST":
		strTitle += ru(" на период с ", " на період з ");
		strTitle += StrDat(getPar("GLOBDAT1"), "DMY") 
					+ ru(" по ", " до ")
					+ StrDat(getPar("GLOBDAT2"), "DMY");
		break;
		
	case "NOTWORK":
		strTitle += ru(", которые не разрабатываются", ", які не є в розробці");
		break;

	case "ISWORK":
		strTitle += ru(", которые разрабатываются", ", які є в розробці");
		break;

	case "NOTTEST":
		strTitle += ru(", которые не тестируются", ", які не є в тестуванні");
		break;
		
	case "ISTEST":
		strTitle += ru(", которые тестируются", ", які є в тестуванні");
		break;

	case "ISHOLD":
		strTitle += ru(", которые приостановлены", ", які заморожено");
		break;

	case "FORPROG":
		if(extPar.objAsk.programmer)
		{
			strTitle += ru(" для исполнителя: ", " для виконавця: ");
			strTitle += extPar.objAsk.programmerTXT;
		}
		else
			strTitle += ru(" для всех исполнителей ", " для всіх виконавців ");
		
		strTitle += ", статус: "
		if(extPar.objAsk.status)
			strTitle += extPar.objAsk.statusTXT;
		else
			strTitle += ru("любой", "будь-який");
			
		break;
		
	case "FORTEST":
		if(extPar.objAsk.tester)
		{
			strTitle += ru(" для тестировщика: ", " для тестувальника: ");
			strTitle += extPar.objAsk.testerTXT;
		}
		else
			strTitle += ru(" для всех исполнителей ", " для всіх виконавців ");
		
		strTitle += ", статус: "
		if(extPar.objAsk.status)
			strTitle += extPar.objAsk.statusTXT;
		else
			strTitle += ru("любой", "будь-який");
		
		break;
		
	case "MY":		
		if(myCod)
		{
			var txt = tcl("CL", "TXT", getPar("CODPERS"), myCod);
			strTitle += ru(" для исполнителя: ", " для виконавця: ");
			strTitle += txt;
		}				
		break;
	}
	
	return strTitle;
}

function getPersCod(userName, bAddifnotexist)
{
	var oSnap = getSnap("select rel.FCOD "
							+" from ^CL_PERS p "
							+" inner join ^CLRELCLCL rel on rel.FWID_CL=p.FWID_CL "
							+" where p.FLOGIN="+ sqlTo(userName)
						, false
						);
	if(oSnap)
		return oSnap[0];
	
	if(bAddifnotexist===false)
		return 0;
	
	var sMsg = UR("У довіднику немає користувача '"+ userName +"'."
					+"\nДодати користувача?"
				+"|В справочнике нет пользователя '"+ userName +"'."
					+"\nДобавить пользователя?"
				);
	if(!confirm(sMsg))
		return 0;
	
	var par = new Object();
	par.login = userName;
	showWindow("e_pers.xml", SW_MODAL, par);
	if(!par.escape)
		return getPersCod(userName);
	
	return 0;
}

function getListWhere(menuMode)
{	
	var strWhere = " AND FDOC_DAT<=" +sqlTo(DATE.value);
	if(differ(DATB.value, d00)<0)		
		strWhere += " AND FDOC_DAT>=" +sqlTo(DATB.value)	
	if(NOP.value && Number(NOP.value)!=0)
		strWhere += " and FNOP in ("+ NOP.value +")"
	if(!menuMode)
		return strWhere;
	switch(menuMode)
	{			
		case "NOTWORK":
			strWhere += " AND (fprogrammer = 0)";  
	
		case "ISWORK":
			if(typeof(extPar.objAsk.status) == "object")
			{
				if(strWhere != "")
					strWhere += " AND ";
						
				strWhere += "(fstatus IN (";
				second = false;
				for(i in extPar.objAsk.status)
				{
					if(second)
						strWhere += ", ";
						
					strWhere += sqlTo(extPar.objAsk.status[i]);
					second = true;
				}				
				strWhere += "))";
			}
			
			break;
	
		case "NOTTEST":
			strWhere += " AND (ftester = 0)";  
	
		case "ISTEST":
		case "ISHOLD":
			if(typeof(extPar.objAsk.status) == "object")
			{
				if(strWhere != "")
					strWhere += " AND ";
						
				strWhere += "(fstatus IN (";
				second = false;
				for(i in extPar.objAsk.status)
				{
					if(second)
						strWhere += ", ";
						
					strWhere += sqlTo(extPar.objAsk.status[i]);
					second = true;
				}
				
				strWhere += "))";
			}
			break;
	
		case "FORPROG":
			if(extPar.objAsk.status)
				strWhere += " AND (fstatus="+sqlTo(extPar.objAsk.status)+")";
				
			if(extPar.objAsk.programmer)
			{
				if(""!=strWhere)
					strWhere += " AND ";					
				strWhere += "(fprogrammer="+sqlTo(extPar.objAsk.programmer)+")";
			}
			
			break;
	
		case "FORTEST":
			if(extPar.objAsk.status)
				strWhere += "(fstatus="+sqlTo(extPar.objAsk.status)+")";
				
			if(extPar.objAsk.tester)
			{
				if(""!=strWhere)
					strWhere += " AND ";					
				strWhere += "(ftester="+sqlTo(extPar.objAsk.tester)+")";
			}
			
			break;
			
		case "MY":
			//var myCod = getPersCod(getUserName());
			if(myCod)
			{
				if(""!=strWhere)
					strWhere += " AND ";					
				strWhere += "(fprogrammer="+sqlTo(myCod)+")";
			}				
			break;
	}	
	return strWhere;		
}


function onAfterEdit(oDoc, mode)
{
	updateTreeKeys("^task", oDoc.getID(), new Array("fdoc_dat", "fdoc_num"));
}

function unLoad()
{
	var view = lpProxy.getView("content");	
	if(view!=null)
		view.close();
}

function convertTimeToHours(oVal, sUnit)
{
	try
	{
		oVal = Number(oVal);
		sUnit = String(sUnit).trim().toLowerCase();
		switch(sUnit)
		{
			case "d":
				return round(oVal*8, 2);
							
			case "m":	
				return round(oVal/60, 2);
		}		
	}
	catch(e)
	{
		
	}
	return oVal;
}
	