include("doc\\DpDoc.js");
include("doc\\DpDocList.js");
include("doc\\nakl\\DpNakl.js");
include("Objects\\DpNmkl.js");
include("doc\\nakl\\DpNkRow.js");
include("Objects\\DpUCena.js");
include("Objects\\DpPrList.js");

var noFirstSave = false;

var objDoc;
var m = new Object();
var Fid_pn = 0;
var otpcena = F1cena;

function Load()
{		
	objDoc = extPar.doc;
		
	nmklsel = objDoc.getPar("_nmklsel");
	iOtpsel = objDoc.getPar("_otpsel");
	
	var rowmol = objDoc.getPar("_rowmol");
	var rowpdr = objDoc.getPar("_rowpdr");
	var rowpst = objDoc.getPar("_rowpst"); 
		
	objDoc.isBuf = false;
		
	nk = new DpNakl(objDoc, this);	
	nk.load();	 
	
	objDoc.parent = objDoc;	
	rnk = new DpNkRow(objDoc);
	//rnk.load();
			
	Fcena.mask 	  = MASK_CENA;		
	F1cena.mask	  = MASK_CENA;
	MainSum.mask  = MASK_SUM;
	Fkol.mask     = MASK_KOL;
	
	//rnk.oNmkl = new DpNmkl();	
	rnk.oNmkl.linkCtrl(Fnmkl, tFnmkl, null, lFnmkl);
	rnk.oNmkl.SetNakl(objDoc);
	nds = Number(rnk.oNmkl.getExt("_NDS"));
	
	rnk.oVal = new DpVal();		
	rnk.oSc = new DpSc();	
	rnk.oSc.setMode("c0ut");	
	rnk.oPodr = new DpCl();   		
	rnk.oMol = new DpCl();
	rnk.oPost = new DpCl();
   	rnk.oPost.linkCtrl(FDBKR,FDBKR_TXT);
	rnk.oPost.setClcl(getPar("CODPLAT"));	
  	rnk.oPost.setContAssist();
  		
	rnk.oMol.setMode( rowmol?  "0!" : "");
	rnk.oPodr.setMode( rowpdr? "0!" : "");
	rnk.oPost.setMode( rowpst? "0!" : "");
	
	oCena = new DpUCena(objDoc);		
	oCena.linkCtrl(Fcena);
				
	ctrlLinker = new DpCtrlLinker(objDoc);	
	ctrlLinker.addLink("HSUM",MainSum);		
	//ctrlLinker.addLink("HKOL",Fkol);	
	ctrlLinker.addClLink("HPLCH",rnk.oPost);		
		
	ctrlLinker.updateData(false);
	
	if (extPar.mode != "ADD")	
	{		
		rnk.oPost.setCod(objDoc.getVar("HPLCH"));		
	}		
	MainSum.value = 0;
	Fkol.value = 1;
	
	setValid(Fnmkl, rnk.make_Otpcena);
	setWhen(F1cena, rnk.make_Otpcena);
		
	setWhen(Fkol, _WhenFkol);
	setButton(btnSaveRow, _SaveRow);
	setButton(btnClear, _Clear);
	setButton(btnSave, _Save);
	setButton(btnExit, _Exit);	
	//setButton(btnEnd, _End);	
	
	Disable(MainSum);
	//Disable(lFnmkl);
			
	//setFocus(FDBKR);	
	setFocus(grid);	
	rnk.parChange();
	recalcSum();	
}

function recalcSum()
{		
	MainSum.value = 0;
	
	nk.wItog(m);	
	
	//Fkol.value = m.hKol;
	MainSum.value = m.hsumu1c;
	m.hndsu = round((m.hndsu * nds)/100,2);
	m.hndso = round((m.hndso * nds)/100,2);
}

function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HP", objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",objDoc.getPar("_priceuse"));		
}		

function _Save()
{	
	updateData();
	
	objDoc.setVar("HPOST",  rnk.oPost.getCod());	
	objDoc.setVar("HPLCH",  rnk.oPost.getCod());	
	objDoc.setVar("HSMTOV",	m.Fsum_tov);
	objDoc.setVar("HSBTOV",	m.Fseb_tov);
	objDoc.setVar("HSMMAT",	m.Fsum_mat);
	objDoc.setVar("HSBMAT",	m.Fseb_mat);	
	objDoc.setVar("HOSTAR",	m.Fsum_tar);
	objDoc.setVar("HUSTAR",	m.Fseb_tar);	
	objDoc.setVar("HTOTL",	m.hIsRasc);	
	objDoc.setVar("HSNDS",	m.hndso);
	objDoc.setVar("HSNDS1",	m.hndsu);
	objDoc.setVar("HPSUM",	m.hsumuc);	
	objDoc.setVar("HKOL",	m.hKol);
	objDoc.setVar("HNR",	m.hNr);
	objDoc.setVar("HSUM", 	m.hsumu1c);
		
	nk.saveRows();	
	
	var par = new Object();
	par.Fsum = Number(MainSum.value);
	par.nk = objDoc;
	par.noFirstSave = noFirstSave;
	par.escape = true;
	
	showWindow("e_tc_sav.xml", SW_MODAL, par );
	
	if (par.escape)
		return;
	
	//сохраняем текущий чек			
	objDoc.save(false, extPar.mode);
	hNom = Number(objDoc.getVar("HNOM"));
	noFirstSave = true;
	MainSum.value = 0;

	extPar.dataSrc.getTable().requery();
	extPar.dataSrc.refresh();		
	
	//создаем DpDoc для нового чека		
	objDoc = new DpDoc(objDoc.sDocLbl, objDoc.nNop);		
	//objDoc.loadByID(objDoc.getID());
	objDoc.setVar("HNOM", hNom + 1);	
	nk.fwid = objDoc.getID();
	nk.where = " FID_DOC = "+ sqlTo(nk.fwid);
	
	//очищаем грид
	_Clear();
	return true;
}

function _WhenFkol()
{
	//nkrow.check_Fnmkl(true);
}

function _SaveRow()
{
	CLEARWAIT();
	if (rnk.oNmkl.getCod() == "" || rnk.oNmkl.getCod() == null)
	{
		WAIT(ru("Нужно ввести номенклатуру.","Потрібно ввести номенклатуру."));
		setFocus(Fnmkl);
		return false;
	}
	
	include("Objects\\DpClNo.js");	
	var oDocRow = objDoc.createRow("ROW");	
	if(!rnk.save())
		return false;

	with(oDocRow)
	{
		setVar("RNOM",	 findFreeClNo(nk.bufName, "fnom_str"));							
		setVar("RCENAORD",rnk.oNmkl.Fis_sred==false? Number(Fcena.value) : 0);
		setVar("RKOL",	 Number(Fkol.value));
		setVar("REDIF",  rnk.objKol.getEdiFas());
		setVar("RUCENA", Number(Fcena.value));		
		setVar("ROCENA", Number(F1cena.value));
		setVar("RFOCENA",Number(F1cena.value));				
		setVar("RTNMK",	 rnk.oNmkl.getCod());
		setVar("RPOST",	 rnk.oPost.getCod());
		setVar("RSC",	 rnk.oSc.getSc());
		setVar("RSU",	 rnk.oSc.getSu());
		setVar("RST",	 rnk.oSc.getSt());
		setVar("RPODR",	 rnk.oPodr.getCod());
		setVar("RMOL",	 rnk.oMol.getCod());				
		setVar("R1ID",	 Fid_pn);		
		setVar("RTYPE",	 objDoc.getAttr("RTYPE"));
	}

	objDoc.appendRow("ROW", oDocRow);
	obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, nk.bufName);

	nk.refreshViewer();
	//rnk.oNmkl.empty();
	Fkol.value = 1;
	F1cena.value = 0;
	//Fcena.value = 0;	
}

function _Clear()
{
	MainSum.value = 0;
	var tbl = grid.getTable();
	
	if(tbl.isEmpty())
		return;
		
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		//objDoc.deleteRow("ROW",Number(tbl.getRowID()));
		tbl.Delete();		
	}
	tbl.requery();
	grid.refresh();	
}

function _Exit()
{
	if (extPar.mode == "ADD" && !nk.tbl4Grid.isEmpty())
	{
		if (confirm(ru("Товарный чек не закончен, выйти без сохранения",
						"Товарний чек не завершено, вийти без збереження")))
			_Clear();
		else
			return false;
	}		
	if(!IsTable(nk.sTmpTbl))
	{
		CloseWindow();
		return true;
	}
	nk.modifyData("EDIT", nk.rowsName, fields2copy, nk.sTmpTbl, nk.fwid);
	DropTable(nk.sTmpTbl);
	
	CloseWindow();
	return true;
}

include("sys\\DpBaseDlg.js");