include("doc/DpDoc.js");
include("Objects/DpClEx.js");
include("Objects/DpNmkl.js");
include("Objects/DpCl.js");
include("Objects/DpScannerHandler.js");
include("gridedit.js");

var oScan;
var sTmpTbl = getTmpTableName();
var noFirstSave = false;
var objDoc;
var m = new Object();
var Fid_pn = 0;
var otpcena = F1cena;
var oNmkl = null;
var ctrlLinker;
var discExpr = "";
var discSum = 0;
var deciPri = getPar("DECIPRI");
var deciSum = getPar("DECISUM");

function Load()
{		
	objDoc = extPar.doc;		
	discExpr = allt(objDoc.getPar("_discount"));
	deciSum = Number(objDoc.getPar("_decisum"));
	
	F1cena.mask	  = MASK_CENA;
	MainSum.mask  = MASK_SUM;
	SUM1.mask  = MASK_SUM;
	SUM2.mask  = MASK_SUM;
	Fkol.mask     = MASK_KOL;
	Fsum.mask     = MASK_SUM;
	Fdiscount.mask  = MASK_SUM;
	FMAINDISC.mask  = MASK_SUM;
	
	oNmkl = new DpNmkl();
	oNmkl.SetNakl(objDoc);
	oNmkl.CanEmpty = true;
	//oNmkl.linkCtrl(Fnmkl, TFnmkl);
	oNmkl.linkSmartCtrl(Fnmkl);	
	setValid(Fnmkl, nmkl_valid);
	setWhen(Fnmkl, writeInfo);
	oNmkl.afterLoad = loadNmkl;
	
	this.initGrid = _initGrid;
	this.initGrid();	
	
	//oVal = new DpVal();		
	
	//oPodr = new DpCl();
	
	
	oPost = new DpCl();
   	oPost.setClcl(getPar("CODPLAT"));
   	oPost.linkSmartCtrl(FDBKR);
   	oPost.AfterUpdate = orgUpdate;
   	
   	oPodr = new DpCl();
   	oPodr.setClcl(getPar("CODPODR"));
   	oPodr.linkSmartCtrl(FPODR);
   	
   	oMol = new DpCl();
   	oMol.setClcl(getPar("CODMOL"));
   	oMol.linkSmartCtrl(FMOL)
  	
  	ctrlLinker = new DpCtrlLinker(objDoc);	
	ctrlLinker.addLink("HSUM",MainSum);
	ctrlLinker.addLink("HSUM1",SUM1);				
	ctrlLinker.addLink("HSUM2",SUM2);
	ctrlLinker.addLink("HTYPE_OPL",TYPE_OPL);
	//ctrlLinker.addLink("HKOL",Fkol);	
	ctrlLinker.addClLink("HPLCH",oPost);		
	ctrlLinker.addClLink("HPODR",oPodr);
	ctrlLinker.addClLink("HMOL",oMol);
		
	ctrlLinker.updateData(false);
	
			
	MainSum.value = 0;
	Fkol.value = 1;
	
	//setValid(Fnmkl, rnk.make_Otpcena);
	//setWhen(F1cena, rnk.make_Otpcena);
		
	setWhen(Fkol, _WhenFkol);
	setWhen(F1cena, _WhenCena);
	setWhen(Fdiscount, _WhenDisc);
	setButton(btnSaveRow, _btnSaveRow);
	setButton(btnClear, _Clear);
	this._Save = _Save;
	setButton(btnSave, this, "_Save");
	setButton(btnExit, _Exit);	
	//setButton(btnEnd, _End);
	setButton(btnAPPLYDISC, applyDiscount);	
	
	Disable(MainSum);
	
	if(!objDoc.getPar("__getot"))
		Disable(F1cena);
	if(!objDoc.getPar("__getkol"))
		Disable(Fkol);
	if(!objDoc.getPar("_discedit"))
		Disable(Fdiscount);
	Disable(Fsum);
	
	//setFocus(FDBKR);	
	recalcSum();	
	this.onInputLineCode = onInputLineCode;
	oScan = new DpScannerHandler()
	oScan.setHandler(this, "onInputLineCode")
	
	FORM.getShell().setDefaultButton(btnSave.getCtrl());
	this.nmklEnter = nmklEnter;
	this.nmklInsert = nmklInsert;
	Fnmkl.setEnterHandler(this, "nmklEnter");
	Fnmkl.setInsertHandler(this, "nmklInsert");
	
	this.cenaEnter = cenaEnter;
	F1cena.setEnterHandler(this, "cenaEnter");
	this.discEnter = discEnter;
	Fdiscount.setEnterHandler(this, "discEnter");
	this.kolEnter = kolEnter;
	Fkol.setEnterHandler(this, "kolEnter");
	this.mainDiscEnter = mainDiscEnter;
	FMAINDISC.setEnterHandler(this, "mainDiscEnter");
	this.discEdit = discEdit;
	FMAINDISC.setEdit(this, "discEdit");
	Disable(btnAPPLYDISC);
	
	setButton(btnLOADORGDISC, loadOrgDisc);
	Disable(btnLOADORGDISC);
		
	setValid(F1cena, calcNmkSum);
	setValid(Fdiscount, calcNmkSum);
	setValid(Fkol, calcNmkSum);
	
	setWhen(grid, writeInfo);
	writeInfo();
	
	setFocus(Fnmkl);
}

function discEdit()
{
	if(grid.getTable().isEmpty())
		Disable(btnAPPLYDISC);
	else
		Enable(btnAPPLYDISC);
}

function cenaEnter()
{
	if(objDoc.getPar("_discedit"))
		setFocus(Fdiscount);
	else if(objDoc.getPar("__getkol"))
		setFocus(Fkol);
	else
		_SaveRow();
}

function discEnter()
{
	if(objDoc.getPar("__getkol"))
		setFocus(Fkol);
	else
		_SaveRow();
}

function kolEnter()
{
	_SaveRow();
	setFocus(Fnmkl);
}

function _WhenCena()
{
	writeInfo();
}

function _WhenDisc()
{
	writeInfo();
}

function mainDiscEnter()
{
	Fdiscount.value = FMAINDISC.value;
	setFocus(Fnmkl);
}

var oldNmklId = 0;
function nmkl_valid()
{
	if (oldNmklId != oNmkl.getCod())
	{
		loadNmkl();
	}
	writeInfo();
}

function nmklEnter()
{
	loadNmkl();
	var txt = allt(Fnmkl.value);
	if(!oNmkl.getCod())
		return;
	if(objDoc.getPar("__getot"))
		setFocus(F1cena);
	else if(objDoc.getPar("_discedit"))
		setFocus(Fdiscount);
	else if(objDoc.getPar("__getkol"))
		setFocus(Fkol);
	else if(txt.length>1 || (txt!="" && !Number(txt)))	//сканер вызывает Enter и происходит повторное добавление
		_SaveRow();
}

function loadNmkl()
{
	try
	{
		oldNmklId = oNmkl.getCod();
		Fdiscount.value = loadDiscount();
		F1cena.value = calcCena();
		calcNmkSum();
		writeInfo();
	}
	catch(e){}
}

function nmklInsert()
{
	var oCL = new DpClEx("nmkl", 0);
	var par = new Object();
	par.txt = Fnmkl.value;
	var bRet = oCL.edit("ADD", null, par);
	if(bRet)
		oNmkl.setCod(oCL.getVar("HCOD"));
}

function writeInfo(bGridEdit)
{
	var sInfo = "";
	try
	{
		if(!oNmkl.getCod() && (oldNmklId==-1 || !oldNmklId))
			sInfo = UR("Введіть номенклатуру|Введите номенклатуру") +". ";
		if(Fnmkl.getCtrl().isFocusControl())
		{
			sInfo += UR("[F4] - відкрити список|[F4] - открыть список") +"; ";
			sInfo += UR("[Insert] - додати у довідник|[Insert] - добавить в справочник") +"; \n";
			sInfo += UR("[Enter] - увести (+1)|[Enter] - ввести (+1)") +"; ";
		}
		else if(Fkol.getCtrl().isFocusControl())
		{
			sInfo += UR("[Enter] - увести|[Enter] - ввести") +"; ";
		}
		else if(grid.getTableControl().isFocusControl())
		{
			if(bGridEdit || grid.isInEditMode())
			{
				sInfo += UR("[Enter] - зберегти|[Enter] - сохранить") +"; ";
				sInfo += UR("[Esc] - відміна|[Esc] - отмена") +"; ";
				var col = grid.getColumn(grid.getActiveCol()-1);
				trace("\n>>> "+ grid.getActiveCol() +" > "+ col + (col? " > "+ col.getField() : " > "));
				if(col && col.getField()=="FISWHITE")
					sInfo += UR("[Space] - так/ні|[Space] - да/нет") +"; ";
				sInfo += "\n";
			}
			else
			{
				sInfo += UR("[F4] - редакувати рядок|[F4] - редактировать строку") +"; ";
				sInfo += UR("[Insert] - додати рядок|[Insert] - добавить строку") +"; \n";
				sInfo += UR("[Del] - видалити рядок|[Del] - удалить строку") +"; ";
				sInfo += UR("[Ctrl+0] - очистити чек|[Ctrl+0] - очистить чек") +"; ";
			}
		}
		sInfo += UR("[Ctrl+Enter] - вибити чек|[Ctrl+Enter] - выбить чек") +"; \n";
		sInfo += UR("[Tab] - перехід|[Tab] - переход") +"; ";
		sInfo += UR("[Shift+Tab] - зворотній перехід|[Shift+Tab] - обратный переход") +"; ";
	}
	catch(e){}
	LINFO.setText(sInfo);
}

function calcCena()
{
	try
	{
		discSum = 0;
		if(!oldNmklId)
			return 0;
		var cena = Number(oNmkl.Fcenapr);
		objDoc.setVar("RTNMK", oldNmklId);
		objDoc.setVar("RCENA", cena);
		objDoc.setVar("RKOL", Fkol.value);
		//в параметрах папки можно указать выражение для спец цены, например значение расширения номенклатуры.
		var specExpr = allt(objDoc.getPar("_specprice"));	//выражение для спец. цены
		if(specExpr && specExpr!="0")
		{
			var specCena = objDoc.eval(specExpr);
			if(specCena && Number(specCena))
			{
				cena = Number(specCena);
				Fdiscount.value = 0;						//для спец. цены скидка не действует
			}
		}
		else if(cena>0)	//если нет выражения для спец. цены, проверяем выражение для суммы скидки
		{
			var dsumExpr = allt(objDoc.getPar("_discsum"));	//выражение для суммы скидки
			if(dsumExpr && dsumExpr!=0)
			{
				discSum = objDoc.eval(dsumExpr);
				if(discSum && Number(discSum) && Number(discSum)>(cena*Number(Fdiscount.value)/100))
				{
					cena -= Number(discSum);
					Fdiscount.value = 0;					//если есть сумма скидки, % скидки не учитывается
				}
			}
		}
		return round(cena * (100 + Number(oNmkl.getNds()))/100, deciPri);
	}
	catch(e)
	{
		return 0;
	}
}

function _initGrid()
{
   	
   	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTbl,"RTCS","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("RTCS","RTCS");
	var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^RTCS"
			   + " WHERE fid_doc = " + nId;
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	tbl = OpenTable("m","select * from " + sTmpTbl + " order by fnom_str");
	tbl.tie("cl_nmk","nmk","fwid","fnmkl");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tbl, "ROW", extPar.doc);
	
	grid.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	grid.build();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
	dpGridEdit = new DpGridEdit(grid);
	//dpGridEdit.addValidField("fcena", recalcSum, recalcSum);
	//dpGridEdit.addValidField("fsum", recalcSum, recalcSum);
	dpGridEdit.canEdit = canEditRow;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.useInitOnEdit = gridInitOnEdit;
	
	grid.afterEditHandler(gridAfterEdit, null);
	
	grid.addAccel(GA_CTRL, "0", "CLEAR");
}

function saveRecord()
{
	var tbl = grid.getTable();
	var kol = Number(tbl.getValue("FKOL"));
	var cena = Number(tbl.getValue("FCENA"));
	var rowID = Number(tbl.getValue("FWID"));
	var oDocRow =  objDoc.getRow("ROW", rowID);
	oDocRow.setVar("RKOL",	 kol);
	oDocRow.setVar("ROCENA", cena);
	oDocRow.setVar("RSUM", round(cena*kol, deciSum));
	oDocRow.setVar("RISWHITE", tbl.getValue("FISWHITE"));
}

function gridAfterEdit()
{
	recalcSum();
	grid.getTable().requery();
	grid.refresh();
}

function recalcSum()
{		
	try
	{
		var nSUM = 0;
		var oSnap = getSnap("select sum("+ sqlRound("fcena * fkol", deciSum) +") as fsum"
							+", sum(FKOL) as FKOL"
							+" from "+ sTmpTbl
							);
		if(oSnap && oSnap[0])
			nSUM = oSnap[0];
		MainSum.value = round(nSUM, deciSum);
		objDoc.setVar("HKOL", oSnap[1]);
		ExecuteSQL("update "+ sTmpTbl +" set FSUM="+ sqlRound("FCENA * FKOL", deciSum));
	}
	catch(e)
	{
		alert(e);
	}
	return true;
}

function gridInitOnEdit()
{
	writeInfo(true);
}

function canEditRow(sMode)
{
	if(sMode=="ADD")
	{
		setFocus(Fnmkl);
		return false;
	}
	return true;
}

function listMenuInit()
{
	if(IsDblClick(grid))
	{
		grid.runGridMenu("EDIT");
	}
}


function onSelectRowMenu(ID)
{
	if(ID == "DEL" && "-"==msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису")))
	{
		var tbl = grid.getTable();
	
		if(tbl.isEmpty())
			return;
		
		objDoc.deleteRow("ROW",Number(tbl.getRowID()));
		tbl.Delete();
		tbl.requery();
		grid.refresh();
		recalcSum();	
	}
	
	if(ID == "ADD")
	{
		setFocus(Fnmkl);
		return 23;
	}
	
	if(ID=="CLEAR")
	{
		_Clear();
		return 23;
	}
}



function updateData()
{	
	ctrlLinker.updateData(true);
	objDoc.setVar("HP", objDoc.getPar("_pricetyp"));	
	objDoc.setVar("HPN",objDoc.getPar("_priceuse"));		
}		

function _Save()
{	
	try
	{
		updateData();
		
		var sFLD = GetPatternIntersection("RTCS","RTCS");
		var sSQL = " DELETE FROM ^RTCS"
				   + " WHERE fid_doc = " + objDoc.getID();
		ExecuteSQL(sSQL);
		var sSQL = "INSERT INTO ^RTCS (" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM " + sTmpTbl;	
		ExecuteSQL(sSQL);
		
		var par = new Object();
		par.Fsum = Number(MainSum.value);
		par.nk = objDoc;
		par.noFirstSave = noFirstSave;
		par.escape = true;
		par.typeopl = Number(TYPE_OPL.value); 
		
		showWindow("e_tc_sav.xml", SW_MODAL, par );
		
		if (par.escape)
			return;
		
		//сохраняем текущий чек
		this.saveExt(true);
		objDoc.save(true, extPar.mode);
		objDoc.doTransform(true);
		
		hNom = Number(objDoc.getVar("HNOM"));
		noFirstSave = true;
		MainSum.value = 0;
		
		extPar.dataSrc.getTable().requery();
		extPar.dataSrc.getTable().FindFirst("FWID="+ objDoc.getID());
		extPar.dataSrc.refresh();
		
		if(objDoc.getPar("_autoprint"))
			runPrint(objDoc);
		
		if(objDoc.getPar("_autoclose"))
		{
			onExit();
			ExecuteSQL("drop table "+ sTmpTbl, false);
			CloseWindow();
			return true;
		}
		
		//создаем DpDoc для нового чека		
		objDoc = new DpDoc(objDoc.sDocLbl, objDoc.nNop);		
		//objDoc.loadByID(objDoc.getID());
		objDoc.setVar("HDAT", today.getVarDate());
		objDoc.setVar("HNOM", objDoc.getAutoNo().get());	
		ctrlLinker.obj = objDoc; 
		oNmkl.SetNakl(objDoc);		
		
		//очищаем грид
		_Clear();
		
		if(objDoc.getPar("_orgclear"))
		{
			oPost.setCod(objDoc.getVar("HPLCH"));
			setFocus(FDBKR);
		}
		return true;
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function runPrint(oDoc)
{
	try
	{
		extPar.list.mnuHandler("PRINT1");
		/*
		include("Objects/DpTVars.js");
		var vars = new DpTVars("DOC", oDoc.sDocLbl, null, null, oDoc.nNop);
		vars.setDoc(oDoc.sDocLbl, oDoc.nNop);
		vars.eval.setJDoc(oDoc);
		var childId = String(oDoc.getChildIDs()[0]);
		vars.eval.setRowTable(oDoc.jDoc.getRowTable(childId, "RNOM"));
		vars.print();
		*/
	}
	catch(e)
	{
		alert(e);
	}
}

function _WhenFkol()
{
	//nkrow.check_Fnmkl(true);
	writeInfo();
}

function _btnSaveRow()
{
	if(oScan && oScan.linecode && String(oScan.linecode).length > 5)
	{
		oScan.handleLinecode();
		return;
	}
	_SaveRow();
}

function _SaveRow(bClear)
{	
	try
	{
		if(Number(Fkol.value)==0)
			Fkol.value = 1;
		if (Number(F1cena.value) == 0)
			F1cena.value = calcCena();
		calcNmkSum();
		
		CLEARWAIT();
		if (oNmkl.getCod() == "" || oNmkl.getCod() == null)
		{
			//WAIT(ru("Нужно ввести номенклатуру.","Потрібно ввести номенклатуру."));
			Fnmkl.showErr(UR("Потрібно вибрати номенклатуру|Нужно выбрать номенклатуру"));
			setFocus(Fnmkl);
			return false;
		}
		
		var sql = "select fwid from " + sTmpTbl + " where fnmkl = " + sqlTo(oNmkl.getCod()) + " and f1cena = " + Number(F1cena.value);  
		include("Objects\\DpClNo.js");	
		var oSnap = getSnap(sql);
		var oDocRow = null;
		var isEdit = false;
		if (oSnap && oSnap[0])
		{
			oDocRow = objDoc.getRow("ROW", oSnap[0]);
			isEdit = true;
		}
		else
		{
			oDocRow = objDoc.createRow("ROW");
		}	
		
		if (isEdit)
		{
			var cena = Number(oDocRow.getVar("ROCENA"));
			var kol = Number(oDocRow.getVar("RKOL")) + Number(Fkol.value);
			oDocRow.setVar("RKOL", kol);
			oDocRow.setVar("RSUM", round(cena*kol, deciSum));
		}
		else
		{
			var kol = Number(Fkol.value);
			var cena = Number(F1cena.value);
			var perc = Number(Fdiscount.value);
			var disc = round(cena*perc/100, deciPri);
			if(perc!=0)
				cena -= disc;
			oDocRow.setVar("RNOM",	 findFreeClNo(sTmpTbl, "fnom_str"));
			oDocRow.setVar("RKOL",	 kol);
			oDocRow.setVar("ROCENA", cena);
			oDocRow.setVar("RSUM", round(cena*kol, deciSum));
			oDocRow.setVar("R1CENA", Number(F1cena.value));							
			oDocRow.setVar("RTNMK",	 oNmkl.getCod());
			oDocRow.setVar("RPODR",	 oNmkl.Fpodr?oNmkl.Fpodr:oPodr.getCod());
			oDocRow.setVar("RMOL",	 oMol.getCod());
			oDocRow.setVar("RDISCOUNT",	 Number(Fdiscount.value));
			if(disc)	//введен процент скидки
			{
				oDocRow.setVar("RDISCSUM", disc);
			}
			else if(discSum)	//введена сумма скидки, которая применяется к цене
			{
				oDocRow.setVar("RDISCSUM", discSum);
				oDocRow.setVar("R1CENA", Number(F1cena.value)+discSum);
			}
			objDoc.appendRow("ROW", oDocRow);
		}
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
		grid.getTable().requery();
		grid.getTable().FindFirst("FWID="+ oDocRow.getID());
		grid.refresh();
		Fkol.value = 1;
		if(bClear)
		{
			F1cena.value = 0;	
			oNmkl.empty();
		}
		recalcSum();
		setFocus(Fnmkl);
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function _Clear()
{
	try
	{
		MainSum.value = 0;
		SUM1.value = 0;
		SUM2.value = 0;
		var tbl = grid.getTable();
		
		if(tbl.isEmpty())
			return;
			
		for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		{
			objDoc.deleteRow("ROW",Number(tbl.getRowID()));
			tbl.Delete();		
		}
		tbl.requery();
		grid.refresh();
		oNmkl.setCod(0);
		setFocus(Fnmkl);
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function _Exit()
{
	if (extPar.mode == "ADD" && !grid.getTable().isEmpty())
	{
		if (confirm(ru("Товарный чек не закончен, выйти без сохранения",
						"Товарний чек не завершено, вийти без збереження")))
			_Clear();
		else
			return false;
	}
	onExit();
	if(!IsTable(sTmpTbl))
	{
		CloseWindow();		
		return true;
	}
	
	DropTable(sTmpTbl);
	
	CloseWindow();
	return true;
}

function onExit()
{
	if (oScan)
	{
		oScan.dispose();	
	}
}

function onInputLineCode(linecode)
{
	try
	{
		oNmkl.noValid = true;
		var idNMKL = getCodByLinecode(linecode);
		Fnmkl.value = linecode;
		oNmkl.noValid = false;
		oNmkl.blurSmartCtrl();
		if(!idNMKL)
		{
			setFocus(Fnmkl);
			//oNmkl.setCod(0);
			F1cena.value = 0;
			Fkol.value = 0;
			return;
		}
		oNmkl.setCod(idNMKL);
		F1cena.value = calcCena();
		Fkol.value = 1;
		//calcNmkSum();
		oNmkl.noValid = false;
		
		if(objDoc.getPar("__getot"))
			setFocus(F1cena);
		else if(objDoc.getPar("_discedit"))
			setFocus(Fdiscount);
		else if(objDoc.getPar("__getkol"))
			setFocus(Fkol);
		else
			_SaveRow();
	}
	catch(e)
	{
		alert(e);
		return false;
	}
}

function getCodByLinecode(linecode)
{
	try
	{
		var oSnap = getSnap("SELECT fwid FROM ^cl_nmk "
				+" WHERE flinecod=" + sqlTo(linecode)
				+" AND (Fisgrp<>"+ sqlTrue
				+" OR Fisgrp IS NULL)");
		
		
		if(!oSnap || !oSnap[0])
			return null;
		return oSnap[0];
	}
	catch(e)
	{
		alert(e);
		return null;
	}
}

function orgUpdate()
{
	var tbl = grid.getTable();
	if(tbl.isEmpty())
		return;
	if(discExpr!="")
		Enable(btnLOADORGDISC);
}

function loadOrgDisc()
{
	objDoc.setVar("HDAT", today.getVarDate());
	objDoc.setVar("HPLCH", oPost.getCod());
	var tblRow = OpenTable("select * from  "+ sTmpTbl);
	for(; !tblRow.isEOF(); tblRow.MoveNext())
	{
		var rowID = tblRow.getValue("FWID");
		var oDocRow = objDoc.getRow("ROW", rowID);
		if(!oDocRow)
			continue;
		var nmk = Number(tblRow.getValue("FNMKL"));
		var kol = Number(tblRow.getValue("FKOL"));
		var perc = oDocRow.eval(discExpr);
		if(!perc)
			perc = 0;
		var cena = Number(tblRow.getValue("F1CENA"));
		var disc = Number(tblRow.getValue("FDISCSUM"));
		var newDisc = round(cena*Number(perc)/100, deciPri);
		if(newDisc<disc)
		{
			var sMsg = UR("Для '"+ tfnmk('TXT', nmk) +"' введена більша знижка!\nЗастосувати нову знижку?"
						+"|Для '"+ tfnmk('TXT', nmk) +"' введена бо'льшая скидка!\nПрименить новую скидку?"
						);
			if(!confirm(sMsg, UR("Знижка|Скидка"), "LOADORGDISC"))
				continue;
		}
		cena -= round(cena*Number(perc)/100, deciPri);
		oDocRow.setVar("ROCENA", cena);
		oDocRow.setVar("RSUM", round(cena*kol, deciSum));
		oDocRow.setVar("RDISCOUNT",	perc);
		oDocRow.setVar("RDISCSUM", newDisc);
		oDocRow.setVar("RKOL", kol);
		oDocRow.setVar("RISWHITE", tblRow.getValue("FISWHITE"));
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	}
	tblRow.close();
	grid.getTable().requery();
	grid.refresh();
	recalcSum();
}

function loadDiscount()
{
	try
	{
		var mainDisc = Number(FMAINDISC.value);
		if(mainDisc)
			return mainDisc;
		if(!oldNmklId)
			return 0;
		var kol = Number(Fkol.value);
		var cena = Number(F1cena.value);
		objDoc.setVar("HDAT", today.getVarDate());
		objDoc.setVar("HPLCH", oPost.getCod());
		objDoc.setVar("RTNMK", oldNmklId);
		objDoc.setVar("RCENA", cena);
		objDoc.setVar("RKOL", kol);
		var disc = 0;
		var perc = objDoc.eval(discExpr);
		if(perc)
			return Number(perc);
	}
	catch(e)
	{
		alert(e);
		return 0;
	}
}

function applyDiscount()
{
	var perc = Number(FMAINDISC.value);
	Fdiscount.value = perc;
	var tblRow = OpenTable("select * from  "+ sTmpTbl);
	for(; !tblRow.isEOF(); tblRow.MoveNext())
	{
		var rowID = tblRow.getValue("FWID");
		var oDocRow = objDoc.getRow("ROW", rowID);
		if(!oDocRow)
			continue;
		var kol = Number(tblRow.getValue("FKOL"));
		var cena = Number(tblRow.getValue("F1CENA"));
		var disc = round(cena*Number(perc)/100, deciPri);
		cena -= disc;
		oDocRow.setVar("ROCENA", cena);
		oDocRow.setVar("RDISCOUNT",	perc);
		oDocRow.setVar("RDISCSUM", disc);
		oDocRow.setVar("RKOL", tblRow.getValue("FKOL"));
		oDocRow.setVar("RSUM", round(cena*kol, deciSum));
		oDocRow.setVar("RISWHITE", tblRow.getValue("FISWHITE"));
		obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, sTmpTbl);
	}
	//ExecuteSQL("update "+ sTmpTbl +" set FDISCOUNT="+ perc +", FCENA="+ sqlRound("F1cena-F1cena*"+perc/100, deciPri));
	tblRow.close();
	grid.getTable().requery();
	grid.refresh();
	recalcSum();
}

function calcNmkSum()
{
	try
	{
		Fsum.value = 0;
		var kol = Number(Fkol.value);
		var cena = Number(F1cena.value);
		var perc = Number(Fdiscount.value);
		if(perc)
			cena -= round(cena*Number(perc)/100, deciPri);
		Fsum.value = round(cena*kol, getPar("DECISUM"));
	}
	catch(e)
	{
		alert(e);
	}
}

function nmklFocus()
{
	setFocus(Fnmkl);
	Fnmkl.selectAll();
}

include("sys\\DpBaseDlg.js");