include ("Objects\\DpJRegistrator.js");
include ("Objects\\DpGetDat.js");
include ("Objects\\DpXMLDomDocument.js");

var oDoc = new DpDoc(extPar.doc,extPar.nop);
var fl = true;
var jID = oDoc.getPar("__jrn");
var tbl_j;
var journal;
var oReg; 
var j_fwid = 0;
var nSumOpl = 0;
var nSumVik = 0;
var objDoc = extPar.doc;
var objNop = extPar.nop;
var zon = oDoc.getPar("__zona");

function docSrc()
{
	if ((jID != "0") && (jID != null) && (jID != "undefined") && (jID != ""))
	{
		oReg = new DpJRegistrator(null,null);
		journal = oReg.listJournals()[jID];
		tbl_j=journal.getFullTableName();
	}
	else
	{
		fl = false;
		alert("Не задан журнал регистрации договоров");
		
	}
	gd = new Object;	
	if (typeof(DOC) != "undefined" && typeOf(DOC) == "DpTextEx")
	{
		gd.dat1 = DATB.value;
		gd.dat2 = DATE.value;
	}
	else
	{
		gd = new DpGetDat("dD");	
		if (gd.escape) return false;
		dat = gd.dat2;
	}
	
	var sWhere="";
	if (extPar.nop != "0")
		sWhere="C.FNOP="+ sqlTo(extPar.nop)+ " AND ";
	
	sWhere += "C.FDOC = 'TD' AND ((C.FBDAT <= " + sqlTo(gd.dat1) + 
				" AND C.FEDAT >= " + sqlTo(gd.dat2) +") " +
				" OR (C.FBDAT >= " + sqlTo(gd.dat1) + " AND C.FBDAT <= " + sqlTo(gd.dat2) +") " +
				" OR (C.FEDAT >= " + sqlTo(gd.dat1) + " AND C.FEDAT <= " + sqlTo(gd.dat2) +"))";
	//if (gd.forg !=0)
	//	sWhere+=" AND C.FORG="+gd.forg;
	
	this.qrySet("From","^HTD H INNER JOIN ^CONTRACT C ON C.FWID = H.FID_DOG",
			"Where",sWhere,
			"Order","C.Forg"
			,"WhereArr", new Array("C.FCLOSE="+ sqlFalse, "C.FCLOSE<>"+ sqlFalse)
			,"WhereArrName", new Array("Відкриті|Окрытые", "Закриті|Закрытые")
			//,"WhereArrI", 0
		);
	this.clTie("org", "=0, Forg");
	//this.subTie("LISTCLORG","org","Fcod","Forg");
	this.extTieEx("xorg", "org.fwid", "CL", "0");
	this.showDocView = showDocView;
	this.tm = null;
}


function docMenuInit()
{
	this.dataSrc.AddMenuItem("jTD","Показати документи по договору|Показать документи по договору");
/*	this.dataSrc.AddMenuItem("+++","Акт звіряння");
	this.dataSrc.AddMenuItem("AKT1","За договором|По договору");
	this.dataSrc.AddMenuItem("AKT2","За контрагентом|По контрагенту");
	this.dataSrc.AddMenuItem("AKT3","Всі|Все");
	this.dataSrc.AddMenuItem("---");
	this.dataSrc.AddMenuItem("+++","Документи|Документы");
	this.dataSrc.AddMenuItem("DOC_CN","По договору|По договору");
	this.dataSrc.AddMenuItem("ALL_DOC_ORG","По контрагенту|По контрагенту");
	this.dataSrc.AddMenuItem("ALL_DOC","Всі|Все");
	this.dataSrc.AddMenuItem("---");
	this.dataSrc.AddMenuItem("SUM_CN", "Проставити суму виконаного\\оплаченого|Проставить сумму выполненного\\оплаченного");
	this.dataSrc.AddMenuItem("PRINT_DOG","Надрукувати договір|Напечатать договор");
	this.dataSrc.AddMenuItem("","");*/
/*	this.dataSrc.AddMenuItem("PRT_LITTLE","Друк скороченого акту звірки|Печать сокращенного акта сверки");
	this.dataSrc.AddMenuItem("PRT_RAH","Друк рхунку за послуги|Печать счета за услуги");
	this.dataSrc.AddMenuItem("KONVERT","Друк конвертів|Печать конвертов");
	this.dataSrc.AddMenuItem("","");
*/
	//this.dataSrc.AddMenuItem("XML","Вигрузка в XML|Выгрузка в XML");
}

function docMenuHandler(nID)
{
	var par = new Object();
	
	if (nID == "AKT1")
	{
		par.tbl_j = tbl_j;
		par.ind = 1;
		par.dog = list.tbl.getValue("FWID");
		showWindow("l_dog_aktgaz.js",SW_NOMODAL,par);
	}
	if (nID == "AKT2")
	{
		par.tbl_j = tbl_j;
		par.ind = 2;
		par.org = list.tbl.getValue("FORG");	
		showWindow("l_dog_aktgaz.js",SW_NOMODAL,par);
	}
	if (nID == "AKT3")
	{
		par.tbl_j = tbl_j;
		par.ind = 3;		
		showWindow("l_dog_aktgaz.js",SW_NOMODAL,par);
	}
	
	if (nID == "XML")
	{
		var expPath = askDirectory(false
						,UR("Вкажіть директорію для вигрузки|Укажите директорию для выгрузки")
						,UR("Вигрузка в XML|Выгрузка в XML"));
		if (expPath == null)
			return;
		
		var strSQL = "select c.fdog_num,c.fwid,c.fdoc_dat,c.forg,h.flpu from ^CONTRACT as c "
					+ " INNER JOIN ^HTD as h ON h.fid_dog=c.fwid WHERE " + grid.sqlSelected(); 
		var tbl = OpenTable("s",strSQL);
		
		if (!tbl.isEmpty())
		{
			var xmlDom = new DpXMLDOMDocument();
			var xmlDogs = xmlDom.createElement("dogovors");
			xmlDom.appendChild(xmlDogs);
			tbl.MoveFirst();
			while (!tbl.isEOF())
			{
				var xmlDog = xmlDom.createElement("dogovor");
				xmlDogs.appendChild(xmlDog);
				xmlDog.setAttribute("ID",tbl.getValue("Fwid"));
				var xmlOrg = xmlDom.createElement("org");
				xmlDog.appendChild(xmlOrg);
				xmlOrg.setText(tbl.getValue("forg"));
				var xmlNum = xmlDom.createElement("num");
				xmlDog.appendChild(xmlNum);
				xmlNum.setText(tbl.getValue("fdog_num"));
				var xmlDat = xmlDom.createElement("dat");
				xmlDog.appendChild(xmlDat);
				xmlDat.setText(format("dd.mm.yyyy",tbl.getValue("fdoc_dat")));
				var xmlLpu = xmlDom.createElement("lpu");
				xmlDog.appendChild(xmlLpu);
				xmlLpu.setText(tbl.getValue("flpu"));
				
				tbl.MoveNext();
			}
			xmlDom.save(expPath + "\\dogovora.xml");
		}
		
	}
	
	if(nID=="DOC_CN")
	{
		par.file = "CONTRACT";
		par.jour = jID;
		par.fwid = list.tbl.getValue("Fwid");
				
		showWindow("l_dog_journal.js",SW_NOMODAL,par,"");	
	}
	
	if(nID=="ALL_DOC_ORG")
	{
		par.jour = jID;
		par.Fpost =list.tbl.getValue("Forg");
		showWindow("l_dog_journal.js",SW_NOMODAL,par,"");	
	}
	
	if(nID=="ALL_DOC")
	{
		par.file = "CONTRACT_A";
		par.jour = jID;
	
		showWindow("l_dog_journal.js",SW_NOMODAL,par,"");	
	}
	if (nID == "SUM_CN")
	{
		var id = Number(list.tbl.getValue("Fwid"));
		//strSQL = "update ^HOZDOG set Fdat_opl=" + opl_dat()+", Fdat_vyk=" + vyk_dat() 
		//		+ ", Fsum_opl=" + sum("OPL") + ", Fsum_vyk=" + sum("VYK") 
		//		+ " where fwid=" + j_fwid;
		//ExecuteSQL(strSQL);	
		
		var oDoc = new DpDoc(objDoc,extPar.nop);
		oDoc.loadByID(id);
		
		oDoc.setVar("HDAT_OPL",opl_dat());
		oDoc.setVar("HDAT_VYK",vyk_dat());
		oDoc.setVar("HSUM_OPL",sum("opl"));
		oDoc.setVar("HSUM_VYK",sum("vyk"));
		
		oDoc.save();
		
	}
	
	if (nID == "PRINT_DOG")
	{
		var id = Number(list.tbl.getValue("Fwid"));
		
		//var oDoc = new DpDoc(extPar.doc,extPar.nop);
		
		par.id = id;		
		par.doc = extPar.doc;
		par.nop = extPar.nop;
		
		showWindow("i_trgazdog.xml",SW_MODAL,par);	
		this.tbl.requery();
		grid.refresh();	
	}
	
	if (nID == "jTD")
	{
		this.showDocView();
		return;
	}
	if (nID == "PRT_LITTLE")
	{
		var DT = new DpGetDat("dD");	
		if (DT.escape) return false;
		
		include ("Objects/DpTVars.js");
		var oTV = new DpTVars();
		
		if(IsTable("ptdk_as1"))
			ExecuteSQL("DROP TABLE ptdk_as1");
		
		if(IsTable("ptdk_as2"))
			ExecuteSQL("DROP TABLE ptdk_as2");
		
		ExecuteSQL("CREATE TABLE ptdk_as1" 
			   + "("
			   + " SODER " + SqlType("TEXT",40)
			   + " ,KOL " + SqlType("DOUBLE",10)
			   + " ,SDB " + SqlType("CURRENCY",8)
			   + " ,SCR " + SqlType("CURRENCY",8)
			   + " ,TS " + SqlType("INT")
			   + ")");
		
		
		var strSQL;
		strSQL = "INSERT INTO ptdk_as1 (SODER,SDB,SCR,TS)(SELECT "
				  + SqlConCat("'Сальдо на '","'" + format("dd.mm.yyyy",DT.dat1) + "'")
				  + " as SODER ,SUM(FSUM_VYK) as SDB,SUM(FSUM_OPL) as SCR,-1 as TS FROM "
				  + tbl_j + " where  FDAT<" + sqlTo(DT.dat1)
				  +" AND FDOG=" + Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG)";
		ExecuteSQL(strSQL);
		
		if (getSnap("SELECT * FROM ptdk_as1") == null)
			ExecuteSQL("INSERT INTO ptdk_as1 (SODER,SDB,SCR,TS) VALUES ("
						+ SqlConCat("'Сальдо на '","'" + format("dd.mm.yyyy",DT.dat1) + "'")
						+ ",0,0,-1)");
		
		strSQL = "INSERT INTO ptdk_as1 (SODER,KOL,TS) (SELECT 'Нараховано' as SODER ,SUM(FKOL) as KOL, 0 as TS FROM ^RRU WHERE "
		+" FDATE>=" + sqlTo(DT.dat1)+ " AND FDATE<=" + sqlTo(DT.dat2)
		+" AND FID_DOG=" + Number(list.tbl.getValue("FWID")) + " GROUP BY FID_DOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE ptdk_as1 set SDB=(SELECT SUM(FSUM_VYK) FROM "
				+  tbl_j + " WHERE FDAT>=" + sqlTo(DT.dat1)+ " AND FDAT<=" + sqlTo(DT.dat2)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG)"
				+ " WHERE TS=0";
		ExecuteSQL(strSQL);
		
		strSQL = "INSERT INTO ptdk_as1 (SODER,SCR,TS) SELECT 'Сплачено' as SODER ,SUM(FSUM_OPL) as SCR,1 as TS FROM " 
				+  tbl_j + " WHERE FDAT>=" + sqlTo(DT.dat1)+ " AND FDAT<=" + sqlTo(DT.dat2)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG";
		ExecuteSQL(strSQL);
		var dt2 = new Date(DT.dat2.getYear()+1900,DT.dat2.getMonth(),DT.dat2.getDate()+1);
		
		strSQL = "INSERT INTO ptdk_as1 (SODER,SDB,SCR,TS) SELECT " +SqlConCat("'Сальдо на '","'" + format("dd.mm.yyyy",dt2) + "'") + " as SODER "
				+ ", SUM(FSUM_VYK) as  SDB,SUM(FSUM_OPL) as SCR, 2 as TS FROM "
				+ tbl_j + " WHERE FDAT<=" + sqlTo(DT.dat2)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG";
		ExecuteSQL(strSQL);
		
		ExecuteSQL("CREATE TABLE ptdk_as2" 
			   + "("
			   + " DAT1 " + SqlType("DATE")
			   + " ,DAT2 " + SqlType("DATE")
			   + " ,DAT3 " + SqlType("DATE")
			   + " ,ORG " + SqlType("INT")
			   + " ,DOG " + SqlType("TEXT",20)
			   + " ,DOG_DAT " + SqlType("DATE")
			   + ")");
		
		strSQL = "INSERT INTO ptdk_as2 (DAT1,DAT2,DAT3,ORG,DOG,DOG_DAT) VALUES "
				+ " (" + sqlTo(DT.dat1) + "," + sqlTo(DT.dat2) + ","
				+ sqlTo(dt2)+","+sqlTo(Number(list.tbl.getValue("FORG"))) + "," +sqlTo(list.tbl.getValue("FDOG_NUM"))
				+ "," + sqlTo(list.tbl.getValue("FDOC_DAT"))+")";
		ExecuteSQL(strSQL);
		
		oTV.setHTbl(OpenTable("s","ptdk_as2"));
		oTV.setRTbl(OpenTable("s","select * from ptdk_as1 order by TS"));
		
		oTV.setPatt(rootDirectory() + "/docs/TD/printforms/usptdk10.jrxml",true);
		oTV.print();
				
	}
	if (nID == "PRT_RAH")
	{
		var DT = new DpGetDat("dD");	
		if (DT.escape) return false;
		
		include ("Objects/DpTVars.js");
		var oTV = new DpTVars();
		
		if(IsTable("rah_1"))
			ExecuteSQL("DROP TABLE rah_1");
		
		if(IsTable("rah_2"))
			ExecuteSQL("DROP TABLE rah_2");
		
		ExecuteSQL("CREATE TABLE rah_1" 
			   + "("
			   + " DT1 " + SqlType("DATE")
			   + " ,DT2 " + SqlType("DATE")
			   + " ,DTN " + SqlType("DATE")
			   + " ,ORG " + SqlType("INT")
			   + " ,UMG " + SqlType("INT")
			   + " ,DBN " + SqlType("CURRENCY",10)
			   + " ,CRN " + SqlType("CURRENCY",10)
			   + " ,VYK " + SqlType("CURRENCY",10)
			   + " ,OPL " + SqlType("CURRENCY",10)
			   + ")");
		
		var dtn = new Date(DT.dat2.getYear()+1900,DT.dat2.getMonth(),DT.dat2.getDate()+1);
		var strSQL;
				
		strSQL = "INSERT INTO rah_1 (DT1,DT2,DTN,ORG,UMG) VALUES ("
				+ sqlTo(DT.dat1) + ", " + sqlTo(DT.dat2) + ", "
				+ sqlTo(dtn) + ", " + sqlTo(list.tbl.getValue("FORG")) + ", "
				+ sqlTo(list.tbl.getValue("FLPU"))+ ")";
		ExecuteSQL(strSQL);
		
		var gS = getSnap("SELECT SUM(FSUM_VYK),SUM(FSUM_OPL) FROM "
				+ tbl_j + " WHERE FDAT<" + sqlTo(DT.dat1)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG");
		if (gS != null)
		{
			strSQL = "UPDATE rah_1 set DBN =" + gS[0] + " , CRN =" + gS[1];
			ExecuteSQL(strSQL);
		}
		strSQL = "UPDATE rah_1 set VYK = (SELECT SUM(FSUM_VYK) FROM " + tbl_j
				+ " WHERE FDAT<=" + sqlTo(DT.dat2) + " AND FDAT>=" + sqlTo(DT.dat1)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE rah_1 set OPL = (SELECT SUM(FSUM_OPL) FROM " + tbl_j
				+ " WHERE FDAT<=" + sqlTo(DT.dat2) + " AND FDAT>=" + sqlTo(DT.dat1)
				+ " AND FDOG="+ Number(list.tbl.getValue("FWID")) + " GROUP BY FDOG)";
		ExecuteSQL(strSQL);
		
		ExecuteSQL("CREATE TABLE rah_2" 
			   + "("
			   + " NMKL" + SqlType("INT")
			   + " ,KOL" + SqlType("DOUBLE",8)
			   + " ,CENA " + SqlType("CURRENCY",10)
			   + ")");
		
		strSQL = "INSERT INTO rah_2 (NMKL,KOL) (SELECT FNMKL as NMKL, SUM(FKOL) as KOL FROM ^RRU WHERE "
				+" FDATE>=" + sqlTo(DT.dat1)+ " AND FDATE<=" + sqlTo(DT.dat2)
				+" AND FID_DOG=" + Number(list.tbl.getValue("FWID")) + " GROUP BY FNMKL)";
		ExecuteSQL(strSQL);
		
			
		strSQL = "UPDATE rah_2 set CENA=(SELECT Fcena FROM ^RRU WHERE "
				+" FDATE>=" + sqlTo(DT.dat1)+ " AND FDATE<=" + sqlTo(DT.dat2)
				+" AND FID_DOG=" + Number(list.tbl.getValue("FWID")) + ")";
		ExecuteSQL(strSQL);
		
		oTV.setHTbl(OpenTable("s","rah_1"));
		oTV.setRTbl(OpenTable("s","rah_2"));
		oTV.setPatt(rootDirectory() + "/docs/TD/printforms/usptdk05.jrxml",true);
		oTV.print();
	}


}

function opl_dat()
{
	if (!fl)
		return new Date(3000,0,1).getVarDate();
	
	j_fwid = Number(list.tbl.getValue("Fwid"));
	
	var oSnap = getSnap("select MAX(FDAT) as fdat from " + tbl_j + " where FSUM_OPL<>0 and fdog=" + j_fwid);
//-	var hz = OpenTable("s","select MAX(FDAT) as fdat from " + tbl_j + " where FSUM_OPL<>0 and fdog=" + j_fwid );
	if (oSnap != null)
		return oSnap[0];
/*
	if (hz.getValue("fdat") != null)
		return hz.getValue("fdat");
	else
*/
	return new Date(3000,0,1).getVarDate();
	
}

function vyk_dat()
{

	if (!fl)
		return new Date(3000,0,1).getVarDate();
	
	j_fwid = Number(list.tbl.getValue("Fwid"));
	var oSnap = getSnap("select MAX(FDAT) as fdat from "+ tbl_j + " where FSUM_VYK<>0 and fdog="
				+ j_fwid);
/*
	var hz =OpenTable("s","select MAX(FDAT) as fdat from "+ tbl_j + " where FSUM_VYK<>0 and fdog="
				+ j_fwid );

	if (hz.getValue("fdat") != null)
		return hz.getValue("fdat");
	else
*/
	if (oSnap != null)
		return oSnap[0];
	return new Date(3000,0,1).getVarDate();
}


function sum(str)
{
	if (!fl)
		return 0;

	str = str.toUpperCase();
	var id = Number(list.tbl.getValue("Fwid"));
	
	//if(id != j_fwid)
	{
//-		trace("CALLSUM")
		strSQL = "select SUM(FSUM_OPL) as Fsum_opl, SUM(FSUM_VYK) as Fsum_vik from "+ tbl_j + " where fdog=" + id;	
//-		var hz = OpenTable("s",strSQL);
		var oSnap = getSnap("select SUM(FSUM_OPL) as Fsum_opl, SUM(FSUM_VYK) as Fsum_vik from "+ tbl_j + " where fdog=" + id);
		j_fwid = id;
//-		nSumOpl = Number(hz.getValue("Fsum_opl"));
//-		nSumVik = Number(hz.getValue("Fsum_vik"));
		nSumOpl = Number(oSnap[0]);
		nSumVik = Number(oSnap[1]);
	}
	
	return (str == "OPL") ? nSumOpl : nSumVik;
}

function getTDRowCount(fwid)
{
	var snap = getSnap("select count(*) from ^rtd where Fid_doc="+fwid,false);
	if(snap)
		return snap[0];
	else
		return 0;
}

function showDocView()
{
	
	var par = new Object();
	par.dat = 0;
	par.file = "CONTRACT";
	par.jour = jID;
	par.fwid = Number(this.tbl.getValue("fwid"));
	var view = lpProxy.getView("doc" + objDoc+objNop);
	if (view == null)
	{
		
		//this.selRecordHandler = selRecordHandler;
		//grid.setSelHandler(this, "selRecordHandler"); 
		lpProxy.showView("doc" + objDoc+objNop, "l_dog_journal.js", par)
	}
	else
	{
		view.sendMessage("doc", par);	
	}
}

/*
function selRecordHandler()
{
	if (this.tm == null)
	{
		this.tm = runTimer(runViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
	
}
*/

function docRunViews()
{
	var par = new Object();
	par.dat = 0;
	par.file = "CONTRACT";
	par.jour = jID;
	par.fwid = Number(list.tbl.getValue("fwid"));
	var view = lpProxy.getView("doc" + objDoc+objNop);
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("doc", par);	
		}
	}
	grid.setFocus();
}
