var DT;
var tbl_j;

function print_onBeforePrint(vars)
{
	this.progressMonitor = getProgressMonitor();
	this.progressMonitor.beginTask("print",list.tbl.getRecordCount());
	
	var oDoc = new DpDoc("TD",0);
	//var jID = vars.eval.jDoc.getPar("__jrn");
	var jID = oDoc.getPar("__jrn");
	var oReg = new DpJRegistrator(null,null);
	var journal = oReg.listJournals()[jID];
	tbl_j=journal.getFullTableName();
	
	
	DT = new DpGetDat("dD");	
	if (DT.escape) return false;
	
}

function print_onBeforeInstancePrint(vars)
{
	var oDoc = vars.eval.jDoc;
	
	if(IsTable("rah_1"))
			ExecuteSQL("DROP TABLE rah_1");
		
	if(IsTable("rah_2"))
			ExecuteSQL("DROP TABLE rah_2");
		
		ExecuteSQL("CREATE TABLE rah_1" 
			   + "("
			   + " DT1 " + SqlType("DATE")
			   + " ,DT2 " + SqlType("DATE")
			   + " ,DTN " + SqlType("DATE")
			   + " ,ORG " + SqlType("INT")
			   + " ,UMG " + SqlType("INT")
			   + " ,DBN " + SqlType("CURRENCY",10)
			   + " ,CRN " + SqlType("CURRENCY",10)
			   + " ,VYK " + SqlType("CURRENCY",10)
			   + " ,OPL " + SqlType("CURRENCY",10)
			   + " ,SUM3 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + " ,SUM4 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + " ,SUM5 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + " ,SUMK3 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + " ,SUMK4 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + " ,SUMK5 " + SqlType("CURRENCY",10) + " DEFAULT 0"
			   + ")");
		
		var dtn = new Date(DT.dat2.getYear()+1900,DT.dat2.getMonth(),DT.dat2.getDate()+1);
		var strSQL;
				
		strSQL = "INSERT INTO rah_1 (DT1,DT2,DTN,ORG,UMG) VALUES ("
				+ sqlTo(DT.dat1) + ", " + sqlTo(DT.dat2) + ", "
				+ sqlTo(dtn) + ", " + sqlTo(oDoc.getVar("HORG")) + ", "
				+ sqlTo(oDoc.getVar("HLPU"))+ ")";
		ExecuteSQL(strSQL);
		
		var gS = getSnap("SELECT SUM(FSUM_VYK),SUM(FSUM_OPL) FROM "
				+ tbl_j + " WHERE FDAT<" + sqlTo(DT.dat1)
				+ " AND FDOG="+ Number(oDoc.getVar("HID")) + " GROUP BY FDOG");
		if (gS != null)
		{
			strSQL = "UPDATE rah_1 set DBN =" + gS[0] + " , CRN =" + gS[1];
			ExecuteSQL(strSQL);
		}
		strSQL = "UPDATE rah_1 set VYK = (SELECT SUM(FSUM_VYK) FROM " + tbl_j
				+ " WHERE FDAT<=" + sqlTo(DT.dat2) + " AND FDAT>=" + sqlTo(DT.dat1)
				+ " AND FDOG="+ Number(oDoc.getVar("HID")) + " GROUP BY FDOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE rah_1 set OPL = (SELECT SUM(FSUM_OPL) FROM " + tbl_j
				+ " WHERE FDAT<=" + sqlTo(DT.dat2) + " AND FDAT>=" + sqlTo(DT.dat1)
		//		+ " AND FDOG="+ Number(oDoc.getVar("HID")) + " GROUP BY FDOG)";
				+ " AND FORG=" + sqlTo(oDoc.getVar("HORG")) + " GROUP BY FORG)";
		ExecuteSQL(strSQL);
		
		strSQL = "SELECT FWID from ^CONTRACT where Fdoc='TD' and Forg=" + sqlTo(oDoc.getVar("HORG"))
				+ " and Fbdat>=" + sqlTo(new Date(2003,0,1)) + " and Fedat<=" + sqlTo(new Date(2003,11,31));
		var hWid3 = 0;
		gS = getSnap(strSQL);
		if (gS != null)
		{
			hWid3 = gS[0];
		}
		
		strSQL = "SELECT FWID from ^CONTRACT where Fdoc='TD' and Forg=" + sqlTo(oDoc.getVar("HORG"))
				+ " and Fbdat>=" + sqlTo(new Date(2004,0,1)) + " and Fedat<=" + sqlTo(new Date(2004,11,31));
		var hWid4 = 0;
		gS = getSnap(strSQL);
		if (gS != null)
		{
			hWid4 = gS[0];
		}
		
		strSQL = "SELECT FWID from ^CONTRACT where Fdoc='TD' and Forg=" + sqlTo(oDoc.getVar("HORG"))
				+ " and Fbdat>=" + sqlTo(new Date(2005,0,1)) + " and Fedat<=" + sqlTo(new Date(2005,11,31));
		var hWid5 = 0;
		gS = getSnap(strSQL);
		if (gS != null)
		{
			hWid5 = gS[0];
		}
		
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid3) + " and FDAT<" + sqlTo(DT.dat1)
		gS = getSnap(strSQL);
		
		if (gS != null) 
		{
			if (gS[0] != null)
				strSQL = "UPDATE rah_1 set SUM3 = " + gS[0];
			
		}
		
		
		ExecuteSQL(strSQL);
		
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid4) + " and FDAT<" + sqlTo(DT.dat1)
		gS = getSnap(strSQL);
		
		if (gS != null) 
		{
			if (gS[0] != null)
				strSQL = "UPDATE rah_1 set SUM4 = " + gS[0];
		}
		
		
		ExecuteSQL(strSQL);
		
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid5) + " and FDAT<" + sqlTo(DT.dat1)
		gS = getSnap(strSQL);
		
		if (gS != null) 
		{
			if (gS[0] != null)	
				strSQL = "UPDATE rah_1 set SUM5 = " + gS[0];
		}
		
		
		ExecuteSQL(strSQL);
		
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid3) + " and FDAT<=" + sqlTo(DT.dat2)
		gS = getSnap(strSQL);
		if (gS != null) 
		{
			if (gS[0] != null)
				strSQL = "UPDATE rah_1 set SUMK3 = " + gS[0];
		}
		
		
		ExecuteSQL(strSQL);
		
			
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid4) + " and FDAT<=" + sqlTo(DT.dat2)
		gS = getSnap(strSQL);
		if (gS != null) 
		{
			if (gS[0] != null)
				strSQL = "UPDATE rah_1 set SUMK4 = " + gS[0];
		}
		
		
		ExecuteSQL(strSQL);
		
			
		strSQL = "SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j
					+ " where FDOG=" + sqlTo(hWid5) + " and FDAT<=" + sqlTo(DT.dat2)
		gS = getSnap(strSQL);
		if (gS != null) 
		{
			if (gS[0] != null)
				strSQL = "UPDATE rah_1 set SUMK5 = " + gS[0];
		}
		
		
		ExecuteSQL(strSQL);
		
		ExecuteSQL("CREATE TABLE rah_2" 
			   + "("
			   + " NMKL" + SqlType("INT")
			   + " ,KOL" + SqlType("DOUBLE",8)
			   + " ,CENA " + SqlType("CURRENCY",10)
			   + ")");
		
		strSQL = "INSERT INTO rah_2 (NMKL,KOL) (SELECT FNMKL as NMKL, SUM(FKOL) as KOL FROM ^RRU WHERE "
				+" FDATE>=" + sqlTo(DT.dat1)+ " AND FDATE<=" + sqlTo(DT.dat2)
				+" AND FID_DOG=" + Number(oDoc.getVar("HID")) + " GROUP BY FNMKL)";
		ExecuteSQL(strSQL);
		
			
		strSQL = "UPDATE rah_2 set CENA=(SELECT Fcena FROM ^RRU WHERE "
				+" FDATE>=" + sqlTo(DT.dat1)+ " AND FDATE<=" + sqlTo(DT.dat2)
				+" AND FID_DOG=" + Number(oDoc.getVar("HID")) + ")";
		ExecuteSQL(strSQL);
		
		vars.setHTbl(OpenTable("s","rah_1"));
		vars.setRTbl(OpenTable("s","rah_2"));
	
}