include("transf:Objects/DpTransfer.js");

var objDoc = new DpDoc(extPar.doc, extPar.nop);

var sprPodr = Number(objDoc.getPar("_sprPodr"));
var isModuleTransf = isEmpty(getModulePath("TRANSF")) ? false : true;


function docMenuInit()
{
	if(!this.dataSrc.getTable().isEmpty() && isModuleTransf)
	{
		this.dataSrc.AddMenuItem("VIEW_TRANSF", "Перегляд сум перерахувань|Просмотр сум перечислений");
	}
}

function docMenuHandler(nID)
{
	var tbl = this.dataSrc.getTable();
	var ds1 = this.dataSrc;
	switch(nID)
	{
		case	 "VIEW_TRANSF":
			var oTransf = new DpTransfer();
			var TBL_4GRID = "TBL4GRID";			
			
			var mFwid = tbl.getValue("FWID");
			var mTrNom = Number(tbl.getValue("FTYPE_TR"));
			if(isEmpty(mTrNom))
			{
				alert(ru("В данном документе нет данных для перечислений."
						,"В даному документі відсутні дані для перерахувань."));
				return false;
			}
			
			//вытянем метку типа перечислений
			sn = getSnap("SELECT CL.FTXTS"
						+" FROM ^CL CL INNER JOIN ^CLRELCLCL REL ON CL.FWID = REL.FWID_CL"
						+" WHERE 1=1"
							+" AND REL.FCL = "+sqlTo(getPar("CAS_TRTYPE"))
							+" AND REL.FCOD = "+sqlTo(mTrNom));
			var mTrType = (sn != null && !isEmpty(sn[0]) ? sn[0] : "");
						
			var TBL_CAS_TR = getTmpTableName();
			strSQL = " SELECT *"
					+" INTO "+TBL_CAS_TR
					+" FROM ^RVD"
					+" WHERE FID_DOC = "+sqlTo(mFwid)
			ExecuteSQL(strSQL);
			
			//вместо кода перечислений должен быть записан FWID
			var opTbl = OpenTable(TBL_CAS_TR);
			for(; !opTbl.IsEOF(); opTbl.MoveNext())
			{
				var sn = getSnap("SELECT FWID_CL FROM ^CLRELCLCL WHERE FCL="
							+sqlTo(getPar("CAS_TRPLACE"))+" AND fcod = "+Number(opTbl.getValue("FPLTR")));
				opTbl.Edit();
				opTbl.setValue("FPLTR", (sn != null && !isEmpty(sn[0]) ? sn[0] : 0));
				opTbl.Update();
				sn = null;
			}
			opTbl.close();
			
			var TBL_CAS = TBL_CAS_TR;
			with(oTransf)
			{
				transfFrom = "VD";
				dPrdate = tbl.getValue("FDOC_DAT");
				setTable(TBL_4GRID);
				setField("FTRSUM","FSUM");
				setField("FTABN","FCOD");
				setField("FWIDTR","FPLTR");
				//Тип перечисления
				setAttr("trType", mTrType);
				
				//Таблица с данными
				setAttr("tblFrom", TBL_CAS);
				
				//Добавляем переменную для формы печати.
				mEval.addVar("TRNAME","витрати на відрядження");
				mEval.addVar("TRHEADER","Відомість № ");	
			
				showTrSum("TRTYPE");
			}
		break;
	}
}