include("doc\\DpDoc.js");
include("sys\\mask.js");
include("Objects\\DpCl.js");

include("Objects\\DpCtrlLinker.js");
include ("Objects\\DpWDAuto.js");

var fnop;
var tblH;
var patTbl;
var Validation = true;
var oCl, oAutoNo;
var objDoc = extPar.doc;
var ctrlLinker = null;
var par = new Object();
var folder = "";

function Load()
{
	if (!extPar )
		extPar = new Object();
	fnop = (objDoc.nNop)? objDoc.nNop: 0;
	
	Caption(ru("Редактирование екземпляра документа", "Редагування екземляру документа"));	
	
	if (fnop != 0)
		patTbl = OpenTable("s", "SELECT * FROM ^WDPATT WHERE FNOP = " + sqlTo(fnop) + " OR FNOP = 0");
	else
		patTbl = OpenTable("s", "SELECT * FROM ^WDPATT ");
	
	HSUM.mask = MASK_SUM;	

	oCl = new DpCl();
	oCl.setClcl(0);
	oCl.linkCtrl(HCLCOD, Ftxt);
	//this.oOrg = oCl;

	if (!patTbl.IsEmpty())
		for(patTbl.MoveFirst(), i = 1; !patTbl.IsEOF(); patTbl.MoveNext(), i++)
		{
			HPATTERN.addItem(String(patTbl.getValue("Fwid")),patTbl.getValue("FNAME"));
		}
	patTbl.close();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	
	ctrlLinker.addLink("HNOM",HNOM);
    ctrlLinker.addLink("HDAT",HDAT);
    ctrlLinker.addLink("HNAME",HNAME);
    ctrlLinker.addLink("HSUM",HSUM);
    ctrlLinker.addLink("HREM",HREM);
    ctrlLinker.addClLink("HCLCOD",oCl);
  //	ctrlLinker.addLink("HPATTERN",HPATTERN);
    ctrlLinker.addLink("HFOLDER",HFOLDER);
    
    ctrlLinker.updateData(false);
    
	switch(extPar.mode)
	{
		case "EDIT":
			Disable(HNOM);
			Disable(HDAT);
			//Disable(HREM);
			Disable(HSUM);
			Disable(HNAME);
			Disable(HPATTERN);
			Disable(HFOLDER);
			
		case "COPY":
			HPATTERN.setValue(String(objDoc.getVar("HPATTERN")));
			break;
		
		case "ADD":
			HFOLDER.setFilterPath(getPar("OFFICEDIR"));
			break;
	}
	
	
	oCl.setCod(objDoc.getVar("HCLCOD"));
	if (extPar.mode == "EDIT")
	{
		Disable(HCLCOD);
		Disable(HID_DOG);
	}
	
}


function onSave()
{
	//alert(HPATTERN.value);
	ctrlLinker.updateData(true);
	objDoc.setVar("HPATTERN",Number(HPATTERN.getValue()));
}

function onAfterSave()
{
	if (Number(HPATTERN.getValue()) != 0)
	{
		var docFile = HPATTERN.getStringValue() + ".doc";
		
		var par = new Object();
		par.ret = new Array();
	
		var wdPar = new WDPar();
		wdPar.fileName		= objDoc.getVar("HNAME");
		if (String(HFOLDER.value))
			wdPar.fileFolder	= HFOLDER.value;
		else
		{
			wdPar.fileFolder	= documentFolder;
			
		}
			
		wdPar.templateName	= (HPATTERN.getStringValue() != "")?HPATTERN.getStringValue()+".doc":"Empty.doc";
	
		wdPar.fnop			= objDoc.nNop;

		var fileName = objDoc.getVar("HNAME");
		if (!fileName.endsWith(".doc"))
			fileName = fileName + ".doc";
		
		if (extPar.mode != "EDIT")
		{
			copyFile(templateFolder + HPATTERN.getStringValue() + ".doc", wdPar.fileFolder +"/"+ fileName);
			wdPar.arrValues		= par.ret;
			DpWDAuto(wdPar, false, objDoc);
		}
		else
		{		
			shellOpen(wdPar.fileFolder + "/" + fileName);
		}
	}
	else if (extPar.mode != "EDIT" && getPar("OFFICEDIR") != "")
	{
		var strFolder = getPar("OFFICEDIR");
		strFolder = new java.lang.String(strFolder);
		
		if (strFolder.startsWith("\\\\"))
			strFolder = strFolder.substring(0, 2) + strFolder.substring(2).replace("\\", "/");
		else	
			strFolder = strFolder.replace("\\", "/");
		
		
		var strFile = objDoc.getVar("HNAME"); 	
		var file = new DpFile(strFile);
		var fileName = file.getAbsolutePath();
		
		fileName = new java.lang.String(fileName);
		if (fileName.startsWith("\\\\"))
			fileName = fileName.substring(0, 2) + fileName.substring(2).replace("\\", "/");
		else	
			fileName = fileName.replace("\\", "/");
		
		//if (fileName.startsWith("/"))
		//	fileName = fileName.substr(1);
		
		if (!fileName.startsWith(strFolder))
		{
			if (String(strFolder).right(1) != "\\" && String(strFolder).right(1) != "/")
				strFolder += "/"; 
				
			var internalFile = strFolder + String(objDoc.getID()) + file.getName()
			if (new DpFile(internalFile).exists() &&
				!confirm("Такой файл уже существует в системе. Заменить?"))
			{	
				return;			
			}
			else
			{
				//Файл копируется в директорию MS Word в имя пишем только имя файла без пути в папку ничего.
				copyFile(fileName, internalFile);
				objDoc.setVar("HNAME", String(objDoc.getID()) + file.getName());
				objDoc.setVar("HFOLDER", "");
			}
		}
	}

}

include("sys\\DpBaseDlg.js");