include("objects/dpcl.js");

include("objects/DpOrg.js");
include("objects/DpDol.js");

var tblOrg = null;
var tblDol = null;
var obj = extPar.doc; 
var param = extPar.param;
var ctrlLinker = null;
var oPers = null;
var valid = false;

var dpOrg = null;
var dpDol = null;

function Load() 
{
	Caption(UR("Наказ: звільнення з посади |Приказ: увольнение с должности "));
 
	oPers = new DpCl("", getPar("CODPERS"), 0);
   	ctrlLinker = new DpCtrlLinker(obj);
 	ctrlLinker.addLink("REDAT", REDAT);
 	ctrlLinker.addLink("RREASON", RREASON);
 	ctrlLinker.addSetGetLink("RWID_ORG", RORG);
 	ctrlLinker.addSetGetLink("RWID_DOL", RDOL);
  	ctrlLinker.updateData(false);

	oPers.linkCtrl(RTABN, RTABNTXT);
	oPers.addCondition("condition");
	oPers.addListCondition(listCondition);
	//if(extPar.mode != "ADD")
	
	
	dpOrg = new DpOrg();
  	dpOrg.linkCtrl(RORG);
	dpDol = new DpDol();		
	dpDol.linkCtrl(RDOL);
	dpDol.setFindFree(false);
	dpOrg.setDpDol(dpDol);
	dpOrg.setDpPers(oPers);
  	 
	if (param != null)
	{
		oPers.setFWID(param.fwid_cl);
		dpOrg.setPeriod(param.bdat, param.edat);
		dpOrg.setFWID(param.fwid_org);
		dpOrg.setFWID_CL(param.fwid_cl);
		dpDol.setFWID(param.fwid_dol);
  		
		if (param.dat_prk != null)
		{
			/*RBDAT.value = param.dat_prk;
			lowDat = toScriptDate(RBDAT.value);*/
		}
	}

	/*setValid(REDAT, bdatValid);
	setValid(RORG, orgValid);
	setValid(RDOL, dolValid);
	setValid(RTABN, persValid);*/
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RWID_CL", oPers.getFWID());	
	obj.setVar("RWID_DOL", RDOL.getValue());
	obj.setVar("RWID_ORG", RORG.getValue());
	var m = new Object();
	m.FWID = obj.getVar("RWID_WP");
	m.FEDAT = REDAT.value;
	if("ADD" == extPar.mode
    || "COPY" == extPar.mode)	
	{
		var sFLD = GetPatternIntersection("work_pers", "work_pers");
		strSQL = "INSERT INTO tmp_work_pers (" + sFLD + ")"
				+ " SELECT " + sFLD + " FROM ^work_pers WHERE fwid=" + sqlTo(m.FWID);
		ExecuteSQL(strSQL);
	}
	
	updateTable("tmp_work_pers", m, false);
	if(null!=tblDol)
		tblDol.Close();
	
	if(null!=tblOrg)
		tblOrg.Close();
}

function onEscape()
{
	if(null!=tblDol)
		tblDol.Close();
	
	if(null!=tblOrg)
		tblOrg.Close();
}

function fillOrg(dat)
{
	if(null!=tblOrg)
	{
		tblOrg.Close();
		tblOrg = null;
	}

	var strSQL = "SELECT fwid, ftxts FROM org_out"
				+ " WHERE fbdat<=" + sqlTo(dat) 
					+ " AND fedat>=" + sqlTo(dat);
	tblOrg = OpenTable("s", strSQL);
	if(tblOrg.isEmpty())
	{
		RORG.clear();
		return false; 
	}
	
	if(null==RORG.getValue() 
	||!tblOrg.FindFirst("FWID="+sqlTo(RORG.getValue())))
	{
		RORG.clear();
		for(tblOrg.MoveFirst(); !tblOrg.isEOF(); tblOrg.MoveNext())
		{
			RORG.addItem(Number(tblOrg.getValue("fwid")), tblOrg.getValue("ftxts"));
		}
		
		RORG.setSelectedIndex(0);
	}
	
	return fillDol(dat, RORG.getValue());
}

function fillDol(dat, fwid_org)
{
	if(null!=tblDol)
	{
		tblDol.Close();
	}
	
	var strSQL = "SELECT fwid, fcod"
				+ " FROM dol_out"
				+ " WHERE fwid_org=" + sqlTo(fwid_org)
					+ " AND ffree = " + sqlFalse;
	tblDol = OpenTable("m", strSQL);
	if(tblDol.isEmpty())
	{
		RDOL.clear();
		return false;
	}
	
	clTie(tblDol, "dol", "="+getPar("CODDOL")+", FCOD");
	if(!tblDol.FindFirst("fwid="+sqlTo(RDOL.getValue())))
	{
		RDOL.clear();
		for(tblDol.MoveFirst(); !tblDol.isEOF(); tblDol.MoveNext())
		{
			RDOL.addItem(Number(tblDol.getValue("fwid")), tblDol.getValue("dol.ftxt"));
		}

		RDOL.setSelectedIndex(0);
	}
	
	return dolValid();
}

function bdatValid()
{
	return fillOrg(REDAT.value);
}

function orgValid()
{
	return fillDol(REDAT.value, RORG.getValue());
}

function dolValid()
{
	if(valid)
		return valid;
		
	var strSQL = "SELECT wp.fwid_cl, wp.fwid"
				+ " FROM ^work_pers AS wp"
				+ " WHERE wp.fwid_dol=" + sqlTo(RDOL.getValue())
					+ " AND wp.FEDAT="  + sqlTo(d00);
	var man = getSnap(strSQL);
	if(null == man)
	{
		strSQL = "SELECT wp.fwid_cl, wp.fwid"
				+ " FROM ^work_pers AS wp INNER JOIN dol_out AS o"
						+ " ON (wp.fwid_dol=o.fwid)"
				+ " WHERE wp.fwid_dol=" + sqlTo(RDOL.getValue())
						+ " AND o.ffree=" + sqlFalse;
		man = getSnap(strSQL);
	}
	
	if(null == man)
		return false;

	if(oPers.setFWID(man[0]))
	{
		obj.setVar("RWID_WP", man[1]);
		return true;
	}
	else
	{
		oPers.setCod(0);
		return false;
	}
}

function persValid()
{
	var strSQL = "SELECT fwid_dol"
				+ " FROM ^work_pers"
				+ " WHERE fwid_cl=(SELECT fwid_cl FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(RTABN.value) 
									+  " AND fcl=" + sqlTo(getPar("CODPERS")) + ")";
						+ " AND fedat=" + sqlTo(d00);
						
	var snap = getSnap(strSQL);
	var codDol = snap[0];
	strSQL = "SELECT fwid_org FROM ^stru_dol WHERE fwid=" + sqlTo(snap[0]);
	snap = getSnap(strSQL);
	valid = true;
	RORG.setValue(Number(snap[0]));
	RDOL.setValue(Number(codDol));
	valid = false;
	return true;
}

function condition(cod)
{
	var strSQL = "SELECT fwid_dol"
				+ " FROM ^work_pers"
				+ " WHERE fwid_cl=(SELECT fwid_cl FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(cod) 
									+  " AND fcl=" + sqlTo(getPar("CODPERS")) + ")"
						+ " AND fedat=" + sqlTo(d00);
						
	var snap = getSnap(strSQL);
	if(null != snap
	&& null != snap[0]
	&& 0 != snap[0])
		return true;

	var strSQL = "SELECT wp.fwid_cl"
				+ " FROM ^work_pers AS wp INNER JOIN dol_out AS o"
						+ " ON (wp.fwid_dol=o.fwid)"
				+ " WHERE wp.fwid_cl=(SELECT fwid_cl FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(cod) 
									+  " AND fcl=" + sqlTo(getPar("CODPERS")) + ")"
						+ " AND o.ffree=" + sqlFalse;
	snap = getSnap(strSQL);
	if(null != snap
	&& null != snap[0]
	&& 0 != snap[0])
		return true;
		
	return false;
}

function listCondition()
{
	var addWhere = "(a.fwid IN"
				+ " (SELECT w.fwid_cl FROM ^work_pers as w INNER JOIN dol_out AS o"
						+ " ON (w.fwid_dol=o.fwid)"
				+ " WHERE w.fedat=" + sqlTo(d00) 
					+ " AND w.fbdat<=" + sqlTo(REDAT.value) + "))"
					+ " OR a.fwid=" + sqlTo(obj.getVar("RWID_CL"));

	return addWhere;
}
include("sys\\DpBaseDlg.js");