
var doc = extPar.doc; 
var param = extPar.param;
var ctrlLinker = null;
var valid = false;
var lowDat = null;

function Load() 
{
	Caption(UR("Наказ: звільнення з посади |Приказ: увольнение с должности ")
					+ (extPar.mode == "EDIT" ? UR("(редагування)|(редактирование)") : ""));
 
   	ctrlLinker = new DpCtrlLinker(doc);
 	ctrlLinker.addLink("REDAT", REDAT);
 	ctrlLinker.addLink("RREASON", RREASON);
 	ctrlLinker.addLink("RNAZN", RNAZN);
  	var snap = getSnap("SELECT Fedat,Fnazn FROM ^work_pers WHERE Fwid="+sqlTo(param.fwid))
   	if(snap!=null)
   	{
   		if(extPar.mode=="EDIT")
   			doc.setVar("REDAT",snap[0]);
   		doc.setVar("RNAZN",snap[1]==1?true:false);
   	}
   	ctrlLinker.updateData(false);
  	
  	if (extPar.mode == "ADD")
  	{
		doc.setVar("RWID_WP", param.fwid);
		doc.setVar("RWID_DOL", param.fwid_dol);
		doc.setVar("RWID_ORG", param.fwid_podr);
	}

	var snap = getSnap("SELECT wp.fbdat, wp.fwid_cl, cl.ftxt "
				+ " FROM ^work_pers AS wp LEFT JOIN ^cl AS cl ON wp.fwid_cl=cl.fwid "
					+ " WHERE wp.fwid=" + sqlTo(doc.getVar("RWID_WP")));	
	if (snap != null)
	{
		lowDat = new Date(snap[0]);
		FIO.setText(snap[2]);
		if (extPar.mode == "ADD")
			doc.setVar("RWID_CL", snap[1]);
	}

	var snap = getSnap("SELECT cl.ftxt FROM ^stru_dol AS dol LEFT JOIN ^cl AS cl ON dol.fwid_cl=cl.fwid "
				+ " WHERE dol.fwid=" + sqlTo(doc.getVar("RWID_DOL")));
	if (snap != null)
		DOL.setText(snap[0]);	
			
	//RNAZN.value = true;
	if (extPar.mode == "EDIT")
		LIKV.value = true;

	setValid(REDAT, bdatValid);
}

function onSave()
{
	ctrlLinker.updateData(true);
		
	doc.setID(doc.getVar("RWID_WP"));
	
	var m = new Object();
	m.FWID = doc.getVar("RWID_WP");
	m.FNAZN = doc.getVar("RNAZN");
	m.FIS_UV = true;
	m.FEDAT = REDAT.value;
	updateTable("^work_pers", m, false);
	
	if (LIKV.value == true)
	{
		var m = new Object();
		m.FWID = doc.getVar("RWID_DOL");
		m.FEDAT = REDAT.value;
		updateTable("^stru_dol", m, false);	
	}
	else if (extPar.mode == "EDIT")
	{		
		
		var m = new Object();
		m.FWID = doc.getVar("RWID_DOL");
		m.FEDAT = getSnap("SELECT org.fedat FROM ^stru_dol AS dol "
				+ " INNER JOIN ^stru_org AS org ON dol.fwid_org=org.fwid")[0];
		updateTable("^stru_dol", m, false);	
	}	
}

function bdatValid()
{
	if (lowDat == null)
		return true;
	var newdat = new Date(REDAT.value)
	if (differ(lowDat, newdat) == 1)
	{
		WAIT(UR("Дата наказу не може бути менша |Дата приказа не может быть меньше ") + StrDat(lowDat, "DMY"));
		return false;
	}
	return true;
}

include("sys\\DpBaseDlg.js");