include("objects//DpSc.js");

var m_fwid;
var tbl;
var tSc;

function onLoad()
{
    Caption(UR("Включення рахункiв в рядки балансу|Включение счетов в стpоки баланса"), extPar.mode);
    
    tSc = new DpSc("cu0");
    tSc.linkCtrl(mFsch, mFsub, mFsta);    

	mFsch.setMask("###");
	mFsub.setMask("####");
	mFsta.setMask("####");

	setValid(mFsub, mFsub_Valid);
	setValid(mFsta, mFsub_Valid);
	setValid(radio, radio_Valid); 	
    
	tbl = extPar.tbl;
	radio.setValue("aktiv");
	
	switch(extPar.mode)
	{
		case "EDIT":
			tSc.set(tbl.getValue("fsch"), tbl.getValue("fsub"), tbl.getValue("fsta"));
			m_fwid = tbl.getValue("fwid");
			switch(String(tbl.getValue("fact")))
			{
				// актив:
				case "+":	//добавление активного счета
				case "#":	//добавление дбт. части акт./пас. счета
				case "!":	//вычитание пассивного счета
					mFact1value = tbl.getValue("fact");
					break;	
				// пассив:
				case "-":	//добавление пассивного счета
				case "=":	//добавление крд. части акт./пас. счета
				case "?":	//вычитание активного счета
					mFact2.value = tbl.getValue("fact");
					radio.setValue("pasiv");
					break;
				}				
			break;
		case "ADD":
			m_fwid = GetUID();
			break;
	}
	radio_Valid();
}

function persql()
{
	var strSQL = "SELECT * FROM ^BALANS_U " + 
			 "WHERE FSCH=" + sqlTo(mFsch.getValue()) +
      		 " AND (FSUB=" + sqlTo(mFsub.getValue()) + " OR FSUB=0)" +
      		 " AND (FSTA=" + sqlTo(mFsta.getValue()) + " OR FSTA=0)" + 
      		 //" AND FWID<>'" + sqlTo(m_fwid) + "' AND FIDS='" + sqlTo(tbl.getValue("fids")) + "'";
			 " AND FWID<>" + sqlTo(m_fwid) + " AND FIDS=" + sqlTo(tbl.getValue("fids")) + "";
	return  getSnap(strSQL) == null;
}

function onSave()
{
	var m = fillFields();
	var str = "";
	/*for (var i in m)
		str += i + " = " + m[i] + "\n";
	alert("Имя таблицы: " + tbl.getTableName() + "\n" + str);*/
	updateTable(tbl.getTableName(), fillFields(), extPar.mode != "EDIT");
}

function fillFields()
{
	var m = new Object();
	if (radio.getValue() == "aktiv")
		m.FACT = mFact1.getValue();
	else
		m.FACT = mFact2.getValue();
	
	m.FWID = m_fwid;
	m.FLINE = tbl.getValue("fline");
	m.FIDS = tbl.getValue("fids");	
	m.FSCH = tSc.getSc();
	m.FSUB = tSc.getSu();
	m.FSTA = tSc.getSt();
		
	return m;
}

function mFsub_Valid() 
{
	if (!persql())
    {
    	WAIT(UR("Такий запис вже існує! Зміните номер рахунку або субрахунку.|" +
    			"Такая запись уже существует!. Измените номер счета или субсчета."));
        return false;
    }
    return true;
}

function radio_Valid()
{
	if (radio.getValue() == "aktiv")
	{
		Disable(mFact2);
		Enable(mFact1, true);
	}
	else
	{
		Disable(mFact1);
		Enable(mFact2, true);
	}
}


include("sys//DpBaseDlg.js");