include("objects\\DpDcExpr.js");

function onLoad()
{
	Caption(UR("Група калькуляцій |Группа калькуляций "),extPar.sMode);
	new DpDcExpr("R", extPar.doc,0,frkCondition);
	setValid(txtNum,num_valid);
	
	if (extPar.sMode != "ADD")
	{
		txtNum.setValue(extPar.group.nNum);
		txtComment.setValue(extPar.group.sComment);
		frkCondition.setValue(extPar.group.sCondition);
	}
}

function num_valid()
{
	var nVal = parseInt(txtNum.getValue());
	if (nVal == 0 || isNaN(nVal))
	{
		txtNum.showErr("Введіть номер групи калькуляцій"
							+ "|Введите номер группы калькуляций");
		return false;
	}
	if (extPar.sMode == "EDIT" && extPar.group.nNum == nVal)
		return true;
	if (extPar.calcs.listGroups()[nVal])
	{
		txtNum.showErr("Група з таким номером вже існує"
							+ "|Группа с таким номером существует");
		return false;
	}
	return true;
}

function onSave()
{
	var retObject = new Object();
	retObject.nNum = txtNum.getValue();
	retObject.sComment = txtComment.getValue();
	retObject.sCondition = frkCondition.getValue();
	extPar.ret = retObject;
}