include("Objects\\DpSc.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpTotals.js");
include("Objects\\DpPrList.js");
include("sys\\mask.js");
include("mtr_ost.js");

var Validation = true;
var edmode = extPar.mode;
var isedit;
var isgroup;
var grpId = 0;
var m_fwid  = extPar.fwid;
var cod_mol = sprMol,
	cod_podr = sprPodr; 
var t;
var	osc,
	ofnmkl,
	ofpodr,
	ofmol;

function Load()
{		
	addgrp = edmode == "ADDFLD";	
	isedit = edmode == "EDIT";
	
	Caption(ru("Перечень прайс-листов",
			 	"Перелiк прайс-листiв"),
			addgrp? "ADD" : edmode);

	//t = OpenTable("s","select * from ^cl_pri where fwid="+ m_fwid);
	t = extPar.m_pTable;		
	if(!m_fwid)
		m_fwid = t.getValue("fwid");
	
	grpId = extPar.listPar.grpId;
	if(!grpId)
		grpId = 0;
	
	isgroup = (addgrp || t.getValue("fgrpid")==0) && edmode!="ADD";
	if(isgroup)
		Caption(FORM.getCaption()+ ru(" группы"," групи"));

	oPri = new DpPrList(); 	
	osc = new DpSc("c0u0");
	ofmol = new DpCl();
	ofpodr = new DpCl();
	ofnmkl = new DpNmkl();
	ofnmkl.CanSelectAll = true;
	ofnmkl.CanSelectGroup = true;	
		
	osc.linkCtrl(mfsc,mfsu);	
	ofnmkl.linkCtrl(mfnmkl,tfnmkl);	
	ofpodr.linkCtrl(mfpodr);
	ofmol.linkCtrl(mfmol);
	
	ofmol.setClcl(cod_mol);
	ofpodr.setClcl(cod_podr);
	ofmol.setMode("0");
	ofpodr.setMode("0");
	
	mfcod.mask="&";
	mftxt.mask=replicate("&", 250);
	
	setValid(mfcod, mfcod_Valid);
	setValid(mfdat, mfdat_Valid);
	
	switch(edmode)
	{
		case "EDIT":
		case "COPY":			
			osc.set(t.getValue("fsc"),t.getValue("fsu"));				
			ofpodr.setCod(t.getValue("fpodr"));				
			ofmol.setCod(t.getValue("fmol"));
			ofnmkl.setCod(Number(t.getValue("fnmkl")),false);
			mftxt.value = t.getValue("ftxt");
			//mfpressed.checked = t.getValue("fpressed");
			mfpressed.value = t.getValue("fpressed");
			mfcod.value = t.getValue("fcod");
			mfdat.value = t.getValue("fdat");
			if(edmode=="COPY")
				mfdat.value = new Date().getVarDate();
			//isgroup = (t.getValue("fdat")<=d00 && t.getValue("fdat")>=d00);
			//isgroup = differ(t.getValue("fdat"), d00)<=0 && differ(t.getValue("fdat"), d00)>=0
			break;
		case "ADD":		
			//var oGroup = getSnap("select fcod,fnmkl,fmol,fpodr,fsc,fsu,ftxt from ^cl_pri where fwid="+ grpId);
			mfdat.value = (new Date()).getVarDate();
			mfpressed.checked = true;

			//mfcod.value = extPar.listPar.fcod;
			//Disable(mfcod);								
			//mfcod.value = oGroup!=null? oGroup[0] : "";

			//проинициализируем контролы
			if(t.isRecord())
			{
				mfcod.value = t.getValue("fcod");
				
				//При добавлении название проинициализируем названием группы
				var strSQL = "select "
					+" ftxt "
					//+", fsc "
					//+", fsu "
				+" from "
					+" ^cl_pri"
				+" where"
					+" fisgrp=" + sqlTrue
					+" and fcod=" + sqlTo(t.getValue("fcod"))
				var oGroup = getSnap(strSQL);
				if(oGroup!=null)
				{
					mftxt.value = oGroup[0];
					//var sc = oGroup[1];
					//var su = oGroup[2];
					//osc.set(sc, su);			
				}
			}

			/*
			ofnmkl.setCod((oGroup!=null? oGroup[1] : ""),false);				
			ofmol.setCod(oGroup!=null? oGroup[2] : 0);
			ofpodr.setCod(oGroup!=null? oGroup[3] : 0);	
			var sc = oGroup!=null? oGroup[4] : 0;
			var su = oGroup!=null? oGroup[5] : 0;
			osc.set(sc,su);			
			*/
		case "ADDFLD":					
			ofpodr.setCod(0);				
			ofmol.setCod(0);							
			mfnmkl.value = "";
			break;
	}
	if(isedit)
	{
		Disable(mfcod);
		Disable(mfpressed);
		Disable(mfnmkl);
		Disable(mfdat);
		Disable(mfpodr);
		Disable(mfmol);
		Disable(mfsc);
		Disable(mfsu);		
	}
	if(isgroup)
	{
		Disable(mfdat);
		Disable(mfpressed);			
	}		
	setFocus(mftxt);
	
	loadTCena();		
}

function loadTCena()
{		
	var id;
	if(edmode == "ADD" && !isgroup)
		id = grpId;
	else if(edmode == "ADDFLD")
		id = 0;
	else
		id = m_fwid;
		
	var	m = oPri.getTCen(id);
	var maxn = 10;
	for(var n=0; n<maxn; n++)
	{
		eval("tfcena"+ n +".value = m[n]");
		eval("tfcena"+ n +".mask = '&&&&&&&&&&&&&&&'");
		//setValid(eval("tfcena"+ n), checkFcena);
		//if(n<maxn-1 && eval("tfcena"+ n +".value==''"))
			//Disable(eval("tfcena"+ (n+1)));
	}
}

function checkFcena(obj)
{	
	var id = obj.getData("ID");
	var sNum = String(id).replace(/tfcena/gi,"");
	var n = Number(sNum)+1;
	if(n >= 10)
		return;
	if(eval(id +".value != ''"))
		Enable(eval("tfcena"+ n),true);
	else
		Disable(eval("tfcena"+ n));
}

function saveCena(m)
{
	if(!m)
		var m = new Object();
	m.ftcena  = tfcena0.value;
	m.ftcena1 = tfcena1.value;
	m.ftcena2 = tfcena2.value;
	m.ftcena3 = tfcena3.value;
	m.ftcena4 = tfcena4.value;
	m.ftcena5 = tfcena5.value;
	m.ftcena6 = tfcena6.value;
	m.ftcena7 = tfcena7.value;
	m.ftcena8 = tfcena8.value;
	m.ftcena9 = tfcena9.value;
	return m;
}

function onSave()
{
	var m = new Object();
	m_fwid = this.sFWID;
	var fcod = String(mfcod.value).toUpperCase();
	var ftxt = mftxt.value!=""? mftxt.value : fcod;	
	
	if(!isgroup && edmode=="ADD" && !checkExist(fcod, true))
	{
		m.FWID = m_fwid;
		m_fwid = GetUID();
		m.ftxt 	= ftxt;		
		m.fsc  	= 0;
		m.fsu 	= 0;
		m.fpodr = 0;
		m.fmol 	= 0;
		m.fnmkl = 0;
		m.fpressed = false;
		m.fcod 	= fcod;
		m.fdat 	= d00;
		m.FISGRP= true;
		m.Fgrpid= 0;
		saveCena(m);
		
		extPar.listPar.sFolderID = 0;
		extPar.treePar.addFwid = m.FWID;
		extPar.treePar.addTxt = m.ftxt;
	
		UpdateTable("^cl_pri", m, true);
		extPar.listPar.priMenuRun("ADD", true);
	}			
	//var findDat = mfdat.value<=t.getValue("fdat") && mfdat.value>=t.getValue("fdat");
	
	var sMsg = ru("Прайс-лист данного типа на указанную дату уже существует",
				  "Прайс-лист даного типу на вказану дату вже існує");
		
	if((edmode=="COPY" || edmode=="ADD") && checkExist(mfcod.value))
	{
		if (SQL)
			alert(sMsg);
		else
			WAIT(sMsg);
		return false;
	}
	
	m.FWID =  m_fwid;
	
	if(isgroup)
	{			
		m.ftxt 	= mftxt.value!=""? mftxt.value : ftxt;		
		m.fsc  	= 0;
		m.fsu 	= 0;
		m.fpodr = 0;
		m.fmol 	= 0;
		m.fnmkl = 0;
		m.fpressed = false;
		m.fcod 	= fcod;
		m.fdat 	= d00;
		m.FISGRP= true;
		m.Fgrpid= 0;				
		txt = m.ftxt;
	}
	else 
	{
		m.fpressed = mfpressed.checked;
		m.fsc 	= Number(mfsc.value);
		m.fsu 	= Number(mfsu.value);
		m.fpodr = ofpodr.getCod();
		m.fmol 	= ofmol.getCod();
		m.fnmkl = mfnmkl.value!=""? ofnmkl.getCod() : 0;
		m.ftxt 	= mftxt.value;
		m.fcod 	= fcod;		
		m.fdat 	= mfdat.value;		
		m.FISGRP= false;
		m.Fgrpid= getGrpId(mfcod.value);
		txt = StrDat(m.fdat, "DMY") + ((m.ftxt!="" && m.ftxt!=null)? " - "+m.ftxt : "");	
	}	
	saveCena(m);

	//extPar.listPar.sFolderID = getGrpId(mfcod.value);
	extPar.listPar.sFolderID = m.Fgrpid;
	extPar.treePar.addFwid = m.FWID;	
	extPar.treePar.addTxt = txt;

	UpdateTable("^cl_pri", m, edmode!="EDIT");		
/*
	mcod = t.getValue("fcod");
	if(nulldat(mfdat) && edmode=="EDIT" && mcod!=mfcod.value)
	{
		sqlStr="UPDATE ^cl_pri "+
				"SET fcod='"+ sqlTo(mfcod.value) +"'"+
				" where fcod='"+ sqlTo(mcod) +"'";
        ExecuteSQL(sqlStr);
	}
*/
	if(!isgroup && edmode!="EDIT" )
	{
		tbl_refresh()
	}
}

function getGrpId(v)
{
	if(!v)
		v = mfcod.value;
	grp = getSnap("SELECT fwid from ^cl_pri where fgrpid = 0 and fcod='"+ v +"'");
	return grp!=null? grp[0] : 0;
}

function checkExist(cod, isGroup)
{
	var tt, res, sq;
	if(isGroup)
		sq = " UPPER(fcod)="+ sqlTo(cod);
	else
        sq = " UPPER(fcod)="+ sqlTo(cod) +" and fdat="+ sqlTo(mfdat.value);
    
    tt = getSnap("SELECT fcod,fwid,fgrpid from ^cl_pri where "+ sq);
	res = tt!=null;

	//tt.close();
	//isDat = t.getValue("fdat")<mfdat.value || t.getValue("fdat")>mfdat.value;
	isDat = differ(t.getValue("fdat"),mfdat.value)<0 || differ(t.getValue("fdat"),mfdat.value)>0;
	if(res)
	{
		if(edmode=="EDIT")
			return t.getValue("fcod")!=cod;
		else if(!isGroup && edmode=="COPY")
			return (t.getValue("fcod")!=cod || isDat);
		else
			return res;
	}
	else
		return res;
}

function nulldat(dat)
{
	return typeof(dat)=="object" && isEmpty(dat.value)
}

function tbl_refresh()
{		
	var tt;
	var objAsk = new Object();
	//objAsk.fnmk = mfnmkl.value;
	objAsk.fnmk = ofnmkl.getCod();
	objAsk.fpodr = ofpodr.getCod();
	objAsk.fmol = ofmol.getCod();
	objAsk.fsc = mfsc.value;
	objAsk.fsu = mfsu.value;
	objAsk.dat1 = mfdat.value;
	objAsk.fcena = 0;
	objAsk.fpost = 0;

	var srcTbl = "";
	if(edmode=="COPY")
		srcTbl = pName(t.getValue("FCOD"),t.getValue("FDAT"), t.getValue("FWID"));

	var tblOutOut = pName(mfcod.value, mfdat.value, m_fwid);
	var tblOut = "TMP_TMP";
	var tblMain = "^anltk";
	var where, sSl;
	var bk, bk1, bs, bs1;
	var msql,chist;
	/*
	if(false)
	{
		DropTable(tblOut);
		with( objAsk )
		{
			where = ""
				+ sqlwNmk("fnmkl", fnmk)
				+ (fcena? " AND fcena=" + fcena: "")
				+ (fpodr? " AND fpodr=" + fpodr: "")
				+ (fmol? " AND fmol=" + fmol: "")
				+ (fsc? " AND fsc=" + fsc + (fsu? " AND fsu=" + fsu: ""): "")
				+ (fpost? " AND fpost=" + fpost: "")
			
			bk  = sqlRound("sum(" + sRecSign + "*fkol)",prmDecKol)
			bk1 = sqlRound("sum(" + sRecSignSF + "*fkol)",prmDecKol)
			bs  = sqlRound("sum(" + sRecSign + "*fkol*fcena)",prmDecSum)
			bs1 = sqlRound("sum(" + sRecSignSF + "*fkol*fcena)",prmDecSum)
			
			sSl = "SELECT " + fldGroupKey
					+ "," + bk + " as fost"
					+ "," + bk1 + " as fost1"
        			+ ","+Convert("0", "MONEY")+" as fcena1"
        			+ ","+Convert("0", "MONEY")+" as fcena2"
        			+ ","+Convert("0", "MONEY")+" as fcena3"
        			+ ","+Convert("0", "MONEY")+" as fcena4"
        			+ ","+Convert("0", "MONEY")+" as fcena5"
        			+ ","+Convert("0", "MONEY")+" as fcena6"
        			+ ","+Convert("0", "MONEY")+" as fcena7"
        			+ ","+Convert("0", "MONEY")+" as fcena8"
        			+ ","+Convert("0", "MONEY")+" as fcena9"
				+ " INTO " + tblOut
				+ " FROM " + tblMain + " a"
				+ " WHERE a.fdate<=" + sqlTo(dat1)
					+ where
					+ " AND a.fdate >= ALL (SELECT b.fdate FROM " + tblMain + " b"
						+ " WHERE " + joinKey
						+ " AND b.frtype='1'"
						+ " AND b.fdate<=" + sqlTo(dat1)
						+ ")"
				+ " GROUP BY " + fldGroupKey
				+ " HAVING NOT (" + bk + "=0 AND " + bk1 + "=0)";
		}
		ExecuteSQL(sSl);
	}else{}
	*/	
	if(false && edmode!="COPY")
	{
		with(new DpMtrOb)
		{
			fnmkl = objAsk.fnmk;
			fcena = objAsk.fcena;
			fpodr = objAsk.fpodr;
			fmol = objAsk.fmol;
			fsc = objAsk.fsc;
			fsu = objAsk.fsu;
			fpost = objAsk.fpost;
			tblName = tblOut;
			pattern = "PRICE"
			indexes = "";
			isFostsum = false;
			fdate = objAsk.dat1;
			doCalc();
		}
	}	
	
	
	if (false)
	{
	// Построение итогов по номенклатуре
		var tot = new DpTotals();
		tot.AddGroup("fnmkl", "_", "''", "NM", "");
		tot.AddItog("fost", "SUM");
		tot.AddItog("fost1", "SUM");
		tot.AddItog("fcena", "MAX");
		tot.MkTotals("", tblOut, "PRICE", 1, "FTT", tblOut, null);
	}

	// Перенос цен из текущего прайса (tblSrc)
	/*
	if(edmode=="COPY" && !isgroup)
	{
		if (SQL)
			msql="UPDATE "+tblOut+" inner join "+srcTbl+
				" on "+tblOut+".ftt="+srcTbl+".ftt"+
				" SET "+tblOut+".fcena="+srcTbl+".fcena,"+
				" "+tblOut+".fcena1="+srcTbl+".fcena1,"+
				" "+tblOut+".fcena2="+srcTbl+".fcena2,"+
				" "+tblOut+".fcena3="+srcTbl+".fcena3,"+
				" "+tblOut+".fcena4="+srcTbl+".fcena4,"+
				" "+tblOut+".fcena5="+srcTbl+".fcena5,"+
				" "+tblOut+".fcena6="+srcTbl+".fcena6,"+
				" "+tblOut+".fcena7="+srcTbl+".fcena7,"+
				" "+tblOut+".fcena8="+srcTbl+".fcena8,"+
				" "+tblOut+".fcena9="+srcTbl+".fcena9 "+
				"where "+tblOut+".fnmkl="+srcTbl+".fnmkl "+
				"and "+tblOut+".ftt="+srcTbl+".ftt and "+tblOut+".ftt='NM'";
		else
			msql="UPDATE "+tblOut+" inner join "+srcTbl+
				" on "+tblOut+".ftt="+srcTbl+".ftt"+
				" SET "+tblOut+".fcena="+srcTbl+".fcena,"+
				" "+tblOut+".fcena1="+srcTbl+".fcena1,"+
				" "+tblOut+".fcena2="+srcTbl+".fcena2,"+
				" "+tblOut+".fcena3="+srcTbl+".fcena3,"+
				" "+tblOut+".fcena4="+srcTbl+".fcena4,"+
				" "+tblOut+".fcena5="+srcTbl+".fcena5,"+
				" "+tblOut+".fcena6="+srcTbl+".fcena6,"+
				" "+tblOut+".fcena7="+srcTbl+".fcena7,"+
				" "+tblOut+".fcena8="+srcTbl+".fcena8,"+
				" "+tblOut+".fcena9="+srcTbl+".fcena9 "+
				"where "+tblOut+".fnmkl="+srcTbl+".fnmkl "+
				"and "+tblOut+".ftt="+srcTbl+".ftt and "+tblOut+".ftt='NM'";
		//ExecuteSQL(msql);
	}
	*/
	// Занесение в конечную таблицу (tblOutOut)
	chist = (mfpressed.checked)?" where ftt='NM'" : "";
	var strPath = getPath("PR_MDB") + (SUBD==MSSQL? "." : "") +".mtr_";
	var tName = strPath + tblOutOut.substr(1);
//	CreateTableEx("PR_MDB", tName, "PRICE", "*");
	ExecuteSQL("drop table "+ tName, false);
	CreateTable(tName, "PRICE");
	if(SUBD != DERBY)
		ExecuteSQL("alter table "+ tblOutOut +" DROP COLUMN FWID ", false);
	ExecuteSQL("alter table "+ tblOutOut +" ADD FWID "+ SqlType("COUNTER"), false);
	ExecuteSQL("alter table "+ tblOutOut +" ADD FGRPID "+ SqlType("INTEGER"), false);
	ExecuteSQL("alter table "+ tblOutOut +" ADD FISGRP "+ SqlType("LOGICAL"), false);
	
   	var szFields = GetPatternIntersection("PRICE", "ANLTK")+",ftt";
   	szFields = szFields.replace(",FWID", "");
	szFields = szFields.replace("FWID,", "");
  	/*if (SQL)
		ExecuteSQL("INSERT into "+ tblOutOut + " select "+ szFields +" from "+ tblOut + chist);
	else*/
	if(false && edmode!="COPY")
		ExecuteSQL("INSERT into "+ tblOutOut + "(" + szFields + ") select "+szFields+" from "+tblOut+chist);
	ExecuteSQL("update "+ tblOutOut +" SET FGRPID="+ m_fwid, false);	   	
}

function mfdat_Valid() 
{
	if(nulldat(mfdat))
	{
		if(checkExist(mfcod.value))
		{
			WAIT(ru("Такая запись уже существует.","Такий запис вже існує."));
			return false;
		}
		if(!isedit)
		{
			Disable(mfpressed);
			Disable(mfnmkl);
			Disable(mfdat);
			Disable(mfpodr);
			Disable(mfmol);
			Disable(mfsc);
			Disable(mfsu);
		}
	}
	else
	{
		if(!isedit && mfpressed.disabled)
		{
			Enable(mfpressed);
			Enable(mfnmkl);
			Enable(mfdat);
			Enable(mfpodr);
			Enable(mfmol);
			Enable(mfsc);
			Enable(mfsu);
		}
	}
	return true;
}

function mfcod_Valid() 
{
	var s="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	var scod = mfcod.value;

	if(scod)
		mfcod.value = scod.toUpperCase();

	if(s.indexOf(mfcod.value)==-1 || mfcod.value==null || mfcod.value=="")
	{
		WAIT(ru("Недопустимое значение поля!","Недопустиме значення поля!"));
		return false;
	}	
	
	if(isgroup)
	{
		var grp = getSnap("select ftxt from ^CL_PRI where fgrpid=0 and fisgrp<>"+ sqlFalse +" and fcod='"+ scod +"'");
		if(grp!=null)
		{
			WAIT(ru("Такая группа уже существует: ","Така група вже існує: ")+ grp[0]);
			return false;
		}
	}
}