include("sys/mask.js");
include("Objects/DpCl.js");
include("servis/format.js");

var mode,tbl,oCl,codtarif,fwid;

function Load()
{
	Caption( ru("Тарифная ставка", "Тарифна ставка")
		+ ": " + modeName(extPar.mode));
	mode = extPar.mode;
	
	codtarif = getPar("ZRPTARIF");
	if(codtarif == 0)
	{
		alert(ru("В установках параметров не указан справочник типов тарифных ставок!",
				"В встановленні параметрів не зазначен довідник типів тарифних ставок!"));
		return false;
	}
	
	oCl = new DpCl();
	oCl.linkCtrl(FCOD,FTXT);
	oCl.setClcl(codtarif);
    FSUM.mask="####.###";
   
    setValid(FBDAT, FBDAT_Valid);
    setValid(FEDAT, FEDAT_Valid);
     
    tbl= extPar.m_pTable;    

	switch(mode)
    {
		case "EDIT":
		case "COPY":
			oCl.setCod(tbl.getValue("Fcod"));
			FSUM.value = tbl.getValue("Fsum");
			FBDAT.value = tbl.getValue("Fbdat");
			FEDAT.value = tbl.getValue("Fedat"); 
			oCl.updateCtrl();
			break;
		case "ADD":
			FCOD.value = 0;
			FSUM.value = 0;
			FBDAT.value = d00;
			FEDAT.value = d00;
			break;
    }
    if(mode == "EDIT")
    	fwid = tbl.getValue("Fwid");
    else
    	fwid = GetUID();
}

function onSave()
{
	var m = new Object();
	m.Fwid = fwid;
	m.Fcod = FCOD.value;
	m.Fbdat = FBDAT.value;
	m.Fedat = FEDAT.value;
	m.Fsum = FSUM.value;
	UpdateTable("^cl_tarif", m, mode!="EDIT", "Fwid="+fwid);
}

function FBDAT_Valid()
{
	if(differ(FBDAT.value,d00)==0)
	{
		WAIT(ru("Введите значение даты начала!","Введіть значення дати початку!"));
		//setFocus(FBDAT);
		return false;
	}
	return true;
}

function FEDAT_Valid()
{
	if(differ(FBDAT.value,FEDAT.value)>0)
	{
		WAIT(ru("Дата окончания не может быть меньше даты начала!",
				"Дата закінчення не може бути меншою за дату початку!"));
		//setFocus(FEDAT);
		return false;
	}
	if(mode!="EDIT")
	{
		var snap = getSnap("select Fsum,Fbdat,Fedat,Fwid from ^cl_tarif "
						+" where Fcod="+FCOD.value+" and Fbdat<="+sqlTo(FEDAT.value)
							+" and Fedat>="+sqlTo(FBDAT.value));
		if(snap!=null)
		{
			WAIT(ru("Период действия тарифной ставки пересекается с другой тарифной ставкой\nСтавка: "+snap[0]+"; период: "+format("dd.mm.yy",snap[1])+"-"+format("dd.mm.yy",snap[2]),
					"Період дії тарифної ставки перетинається з іншою тарифною ставкою\nСтавка: "+snap[0]+"; період: "+format("dd.mm.yy",snap[1])+"-"+format("dd.mm.yy",snap[2])));
			//setFocus(FBDAT);
			return false;
		}
	}
	return true;
}