include ("objects/DpXMLDomDocument.js")

var bnkconfpath = "";
var root = null;//root of bnkconfexp.xml = BANKCONFIG.
var bnkConfObj = null;
var sFileName,pathTempDBF,pathTemplate;

function bnkParams()
{
	this.cFformat = "";	
	this.clbdir = "";
	this.template = "";
	this.clbmask = "";
	this.existfile = 0;
	//this.clbdebug = false;
	this.dformat = "";
}

function Load()
{
	Caption(ru("Редактирование параметров экспорта в к-б","Редагування параметрів експорту в к-б"),extPar.mode);
		   
	bnkconfpath = getOrgPath() + "clbank/export/bnkconfexp.xml";
	var confFile = new DpFile(bnkconfpath);
	var alertStr = "";
	if (!confFile.exists())
	{
		var alertStr = UR('Файл "' + bnkconfpath + '" не існує.|Файл "' + bnkconfpath + '" не существует.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}
	fill_dformat();
	var xmlBnk = new DpXMLDOMDocument();
	var bnkPath = getOrgPath() + "clbank/export/"+extPar.bnkLbl+".xml";
	if(!isFile(bnkPath))
	{
		bnkPath = getOrgPath() + "clbank/export/"+extPar.bnkLbl+".XML";
		if(!isFile(bnkPath))
		{
			alertStr = UR('Файл "' + bnkPath + '" не знайдено. Скоріш за все помилка в регістрі імені або розширення файлу.'
							+ '|Файл "' + bnkPath + '" не найден. Скорей всего ошибка в регистре имени или расширения файла.');		
			alert(alertStr, ICON_ERROR);
			return false;
		}
	}
	xmlBnk.load(bnkPath);
	bnkRoot = xmlBnk.getDocumentElement();
	var typeAttr = bnkRoot.getAttribute("type").toUpperCase();
	var rowAttr = bnkRoot.getAttribute("row").toUpperCase();
	
	var xmlDoc = new DpXMLDOMDocument();
	xmlDoc.load(bnkconfpath);
	var root = xmlDoc.getDocumentElement();
	if (!root.getNodeName().equalsIgnoreCase("BANKCONFIG"))
	{
		alertStr = UR('Файл "' + bnkconfpath + '" зіпсовано. Вузол BANKCONFIG не існує.'
							+ '|Файл "' + bnkconfpath + '" испорчен. Нет узла BANKCONFIG.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}
	
	bnkConfObj = new bnkParams();
	bnkConfObj.cFformat = extPar.bnkLbl;
	var bnkconfnode = root.getElementsByTagName(extPar.bnkLbl)[0];
	if (bnkconfnode != null)
		bnkConfObj = initObjFromAttr(bnkConfObj, bnkconfnode);			
	setValueOn("CONTROL");
	
	//проверяем если в папке clbank/template шаблон по имени настройки для DBF файлов
	if(typeAttr=="DBF")
	{
		pathTemplate = extPar.pathTemplate;
		if(!isDir(pathTemplate))
		{
			alert(ru("Не найдена директория шаблонов экспорта: ","Не знайдена директорія шаблонів експорту: ")+"\n"+pathTemplate);
			return false;
		}
		pathTempDBF = pathTemplate+extPar.bnkLbl+".dbf";
		if(!isFile(pathTempDBF))
		{
			template.value = "";
			if(confirm(ru("Шаблон DBF файла не найден!\nСкопировать новый?","Шаблон DBF файлу не знайдено!\nСкопіювати новий?")))
				copyTemplate();
			else
				return false;
		}
		template.value = new DpFile(pathTempDBF);
	} 
    
	Disable(cFformat);
	Disable(template);
    setValid(clbmask, clbmask_Valid);
    setValid(dformat, dformat_Valid)
	clbmask_Valid();
    dformat_Valid();
	setFocus(clbdir);
}

function setValueOn(key)
{
	for (var i in bnkConfObj)
	{
		try
		{
			var oCtrl = eval(i);
			if (typeof oCtrl == "object")
			{
				if (key == "CONTROL")
				{
					oCtrl.value = bnkConfObj[i];
				}
				else if (key == "PARAMETR")
					 bnkConfObj[i] = oCtrl.value;
			}
		}
		catch(x){}
	}
}

function cFformatValid()
{
	
}

function onSave()
{
	var obj = new Object();	
	var xmlDoc = new DpXMLDOMDocument();
	xmlDoc.load(bnkconfpath);
	root = xmlDoc.getDocumentElement();
	if (!root.getNodeName().equalsIgnoreCase("BANKCONFIG"))
	{
		alertStr = UR('Файл "' + bnkconfpath + '" зіпсовано. Вузол BANKCONFIG не існує.'
							+ '|Файл "' + bnkconfpath + '" испорчен. Нет узла BANKCONFIG.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}	
	setValueOn("PARAMETR");
	var bnkconfnode = root.getElementsByTagName(extPar.bnkLbl)[0];
	var BNKLblEl = null;
	var create = (bnkconfnode == null || bnkconfnode == undefined);
	if (create == true)
		BNKLblEl = xmlDoc.createElement(extPar.bnkLbl);
	else
		BNKLblEl = root.getElementsByTagName(extPar.bnkLbl)[0];
	loadObjToAttr(BNKLblEl, bnkConfObj, "cFformat");
	if (create == true)
		root.appendChild(BNKLblEl);
	xmlDoc.save(bnkconfpath);
}

function clbmask_Valid()
{
	if(clbmask.value.indexOf("*")>-1)
		Enable(dformat);
	else
	{
		Disable(dformat);
		dformat.value = "";
	}
}

function dformat_Valid()
{
	if(Array.every(String(dformat.value), isCorectDForamt) && String(dformat.value).length>0)
		return true;
	else
	{
		if(String(dformat.value).length>0)
		{
			WAIT(ru("Некоректний формат дати в імені файлу!","Некоректный формат даты в имени файла!"))
			return false;
		}
		else
			return true;		
	}
}

function isCorectDForamt(ch)
{
	return (ch=="d" || ch=="m" || ch== "y" || ch== "M" || ch== "H" || ch== "S" || ch=="|" || ch=="-" || ch=="." || ch=="_");
}

function copyTemplate()
{
	sFileName = BrowseForFile("*.dbf", "Файлы  *.dbf");
	if(sFileName)
	{
		if(!isDir(pathTemplate))
		{
			alert(ru("Не найдена директория шаблонов экспорта: ","Не знайдена директорія шаблонів експорту: ")+"\n"+pathTemplate);
			return false;
		}
		if(isFile(sFileName))
		{
			t = OpenTable("f",sFileName);
			if(t.rowCount>0)
			{
				alert(ru("В указанном вами файле есть данные!\nПеред копированием необходимо удалить все строки из dbf файла.",
						"У вказаному вами файлі є дані!\nПеред копіюванням необхідно видалити всі рядки з dbf файлу."));
				t.close();
				return false;
			}
			t.close();
			copyFile(sFileName,pathTempDBF);
			if(clbmask.value == "")
				clbmask.value = new DpFile(sFileName).getName();
		}
	}
}

function fill_dformat()
{
	dformat.addItem("0", "ddmmyyyyHHMMSS");
	dformat.addItem("1", "ddmmyyyyHHMM");
	dformat.addItem("2", "ddmmyyHHMM");
	dformat.addItem("3", "ddHHMM");
}

include("sys/DpBaseDlg.js");