include("Objects/DpDocEx.js");
include("Objects/DpCl.js");
include("servis/date.js");

var tbl = extPar.m_pTable;
var oLicsc;
var oSource;
var fid_dog = 0;
var sTmpCnt = getTmpTableName();
var date;
var type = 0;

function Load()
{
	Caption(UR("Показання лічильника|Показания счетчика"));
	
	FCURRENT.mask = MASK_KOL;
	FPREVIOUS.mask = MASK_KOL;
	FDIFFERENCE.mask = MASK_KOL;
	FKOEF.mask = MASK_KOL;
	FMENKOL.mask = MASK_KOL;
	FNORM.mask = MASK_KOL;
	FNORMLIMIT.mask = "##";
	
	oLicsc = new DpDocEx("LICSC", 1);
	oLicsc.linkCtrl(FLICSC);
	oLicsc.subUpdate = loadLicsc;
	setValid(FLICSC, loadLicsc);
	
	oSource = new DpCl("0");
	oSource.setClcl(getPar("CODREGSOURCE"));
	oSource.linkSmartCtrl(FSOURCE);
	oSource.setContAssist();
		
	if(extPar.mode=="ADD")
	{
		//FDATE.value = today;
		date = today;
		FKOEF.value = 1;
		setFocus(FLICSC);
	}
	else
	{
		//FDATE.value = tbl.getValue("FREGDATE");
		date = tbl.getValue("FREGDATE");
		oLicsc.setFwid(tbl.getValue("FID_DOG"));
		FKOEF.value = tbl.getValue("FKOEF");
		loadLicsc();
		FCOUNTER.value = String(tbl.getValue("FCOUNTER"));
		FSERV.value = tbl.getValue("FSERV");
		FCURRENT.value = tbl.getValue("FCURRENT");
		oSource.setCod(tbl.getValue("FSOURCE"));
		FCOMMENT.value = tbl.getValue("FCOMMENT");
		loadPrev();
		FPREVIOUS.value = tbl.getValue("FPREVIOUS");
		FDIFFERENCE.value = tbl.getValue("FDIFFERENCE");
		FISBREAK.checked = tbl.getValue("FISBREAK")==true;
		FBDATBREAK.value = tbl.getValue("FBDATBREAK");
		FEDATBREAK.value = tbl.getValue("FEDATBREAK");
		FISCHECK.checked = tbl.getValue("FISCHECK")==true;
		FBDATCHECK.value = tbl.getValue("FBDATCHECK");
		FEDATCHECK.value = tbl.getValue("FEDATCHECK");
		FCHECKMIDDLE.value = tbl.getValue("FCHECKMIDDLE");
		FMIDDLE.value = tbl.getValue("FMIDDLE");
		FNORM.value = tbl.getValue("FNORM");
		FNORMLIMIT.value = tbl.getValue("FNORMLIMIT");
		FMENKOL.value = tbl.getValue("FMENKOL");
		setFocus(FCURRENT);
		Disable(FCOUNTER);
		Disable(FLICSC);
		//Disable(FDATE);
	}
	
	if(extPar.date)
	{
		date = extPar.date;
		//FDATE.value = extPar.date;
		//Disable(FDATE);
	}
	
	if(extPar.mode=="ADDCOMMENT")
	{
		Disable(FCURRENT);
		Disable(FPREVIOUS);
		setFocus(FSOURCE);
	}
	/*
	if(extPar.recalc)
	{
		LCURRENT.setText(UR("Нові|Новые"));
		LPREVIOUS.setText(UR("Старі|Старые"));
	}
	*/
	Disable(FORG);
	Disable(FADDR);
	Disable(FSERV);
	Disable(FDIFFERENCE);
	Disable(FPREVIOUSDATE);
	Disable(FKOEF);
	Disable(FNORM);
	Disable(FPREVIOUS);
	if(getPar("HOCPREVEDIT"))
		Enable(FPREVIOUS);
	
	this.loadPrev = loadPrev;
	setButton(FPREVIOUS, this, "loadPrev");
	
	setValid(FCOUNTER, counterValid);
	setValid(FCURRENT, calcDif);
	setValid(FPREVIOUS, calcDif);
	
	FMIDDLE.mask = MASK_KOL;
	FCHECKMIDDLE.mask = MASK_KOL;
	this.calcMiddle = calcMiddle;
	setButton(FMIDDLE, this, "calcMiddle");
	this.calcCheckMiddle = calcCheckMiddle;
	setButton(FCHECKMIDDLE, this, "calcCheckMiddle");
	
	this.calcMenKol = calcMenKol;
	setButton(FMENKOL, this, "calcMenKol");
	
	if(extPar.cyclic)
	{
		btnOK.setToolTipText(UR("Наступний (Ctrl+Enter)|Следующий (Ctrl+Enter)"));
		btnCancel.setToolTipText(UR("Завершити (Esc)|Завершить (Esc)"));
	}
	
	setValid(FISCHECK, checkValid);
	setValid(FBDATCHECK, checkValid);
	setValid(FEDATCHECK, checkValid);
	setValid(FISBREAK, breakValid);
	
	counterValid();
	checkValid();
	breakValid();
}

function breakValid()
{
	if(FISBREAK.value==true)
	{
		Enable(FBDATBREAK);
		Enable(FEDATBREAK);
	}
	else
	{
		Enable(FBDATBREAK, false);
		Enable(FEDATBREAK, false);
	}
}

function checkValid()
{
	if(FISCHECK.value==true)
	{
		Enable(FBDATCHECK);
		Enable(FEDATCHECK);
		Enable(FCHECKMIDDLE);
	}
	else
	{
		Enable(FBDATCHECK, false);
		Enable(FEDATCHECK, false);
		Enable(FCHECKMIDDLE, false);
	}
	
	var bdatcheck = FBDATCHECK.value;
	var edatcheck = FEDATCHECK.value;
	//var date = tbl.getValue("FDATE");
	var bdat = firstDay(date);
	var edat = lastDay(date);
	if(FISCHECK.value==true && differ(bdatcheck, bdat)<=0 && differ(edatcheck, edat)>=0)
	{
		Enable(FCURRENT, false);
		Enable(FPREVIOUS, false);
		FCURRENT.value = FPREVIOUS.value;
		FDIFFERENCE.value = 0;
	}
	else
	{
		Enable(FCURRENT);
		if(getPar("HOCPREVEDIT"))
			Enable(FPREVIOUS);
	}
}

function calcMenKol()
{
	FMENKOL.value = 0;
	//var date = FDATE.value;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var house = tbl.getValue("FHOUSE");
	var serv = FSERV.value;
	/*
	var oSnap = getSnap("select count(*) as cnt"
						+" from ^SC_MEN m"
							+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
						+" where m.FBDAT<="+ sqlTo(d2)
							+" and m.FEDAT>="+ sqlTo(d1)
							+" and l.FHOUSE="+ house
							+" and not exists (select FID_DOG c from ^SC_COUNTERS c"
											+" where c.FID_DOG=l.FID_DOG"
												+" and c.FSERV="+ sqlTo(serv) 
												+" and c.FBDAT<="+ sqlTo(d1)
												+" and c.FEDAT>="+ sqlTo(d2)
											+")"
						);
	*/
	var sTmpMen = getTmpTableName();
	var sSQL = "select m.* into "+ sTmpMen
			+" from ^SC_MEN m"
			+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
			+" where m.FBDAT<="+ sqlTo(d2)
				+" and m.FEDAT>="+ sqlTo(d1)
				+" and l.FHOUSE="+ house
				+" and not exists (select FID_DOG c from "+ sTmpCnt +" c"
								+" where c.FID_DOG=l.FID_DOG"
									+" and c.FSERV="+ sqlTo(serv) 
								+")";
	ExecuteSQL(sSQL);
	var oSnap = getSnap("select count(*) as cnt from "+ sTmpMen);
	if(!oSnap || !oSnap[0])
		return;
	/*
	browse("select FID_DOG, FBDAT, FEDAT from  "+ sTmpCnt)
	browse("select m.FID_DOG, m.FBDAT, m.FEDAT from ^SC_MEN m"
						+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
						+" where m.FBDAT<="+ sqlTo(d2)
							+" and m.FEDAT>="+ sqlTo(d1)
							+" and l.FHOUSE="+ house)
	browse("select m.FID_DOG, m.FBDAT, m.FEDAT from ^SC_MEN m"
						+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
						+" where m.FBDAT<="+ sqlTo(d2)
							+" and m.FEDAT>="+ sqlTo(d1)
							+" and l.FHOUSE="+ house
						+" and not exists (select FID_DOG c from "+ sTmpCnt +" c"
											+" where c.FID_DOG=l.FID_DOG"
												+" and c.FSERV="+ sqlTo(serv) 
												+" and c.FBDAT<="+ sqlTo(d1)
												+" and c.FEDAT>="+ sqlTo(d2)
											+")")
	*/
	var menCount = Number(oSnap[0]);
	var balance = Number(FDIFFERENCE.value);
	oSnap = getSnap("select sum(FDIFFERENCE) as FDIF from "+ tbl.getTableName() 
					+" where FTYPE<>2"
					+" and FHOUSE="+ house 
						+" and FSERV="+ sqlTo(serv)
						+" and FDATE>="+ sqlTo(d1) 
						+" and FDATE<="+ sqlTo(d2)
					);
	if(oSnap)
		balance -= Number(oSnap[0]);
	
	if(oSnap && menCount>0 && balance>0)
	{
		//если есть счетчики или жители включенные в расчетный период нужно учитывать количество дней
		var days = getDaysInMonth(date);
		/*
		oSnap = getSnap("select FWID from "+ sTmpCnt +" where FBDAT>"+ sqlTo(d1) +" or FEDAT<"+ sqlTo(d2));
		if(oSnap && oSnap[0])
		{
			ExecuteSQL("alter table "+ sTmpCnt +" add FDAYS "+ sqlType("SHORT"), false);
			ExecuteSQL("update "+ sTmpCnt 
						+" set FDAYS="
							+ IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT>="+ sqlTo(d2), SqlDaysBWDates("FBDAT", sqlTo(d2)) +"+1"
							, IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates("FBDAT", "FEDAT") +"+1"
							, IIF("FBDAT<="+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates(sqlTo(d1), "FEDAT") +"+1"
							, days)))
						);
			
		}*/
		//browse("select * from "+ sTmpCnt);
		
		oSnap = getSnap("select FWID from "+ sTmpMen +" where FBDAT>"+ sqlTo(d1) +" or FEDAT<"+ sqlTo(d2));
		if(oSnap && oSnap[0])
		{
			ExecuteSQL("alter table "+ sTmpMen +" add FDAYS "+ sqlType("DOUBLE"), false);
			ExecuteSQL("alter table "+ sTmpMen +" add FKOL "+ sqlType("DOUBLE"), false);
			ExecuteSQL("alter table "+ sTmpMen +" add FEXT "+ sqlType("DOUBLE"), false);
			ExecuteSQL("update "+ sTmpMen 
						+" set FDAYS="
							+ IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT>="+ sqlTo(d2), SqlDaysBWDates("FBDAT", sqlTo(d2)) +"+1"
							, IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates("FBDAT", "FEDAT") +"+1"
							, IIF("FBDAT<="+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates(sqlTo(d1), "FEDAT") +"+1"
							, days)))
						);
			var menKol = balance/menCount;
			ExecuteSQL("update "+ sTmpMen +" set FKOL="+ sqlRound(menKol +"/"+ days +"*FDAYS", 2));
			ExecuteSQL("update "+ sTmpMen +" set FEXT="+ menKol +"-FKOL");
			//остаток от выселенного жилца нужно распределить между остальными
			oSnap = getSnap("select sum(FEXT) from "+ sTmpMen +" where FEXT>0");
			//if(oSnap && Number(oSnap[0]))
			//	balance += Number(oSnap[0]);
		}
		//browse("select * from "+ sTmpMen);
	}
	
	if(menCount>0 && balance>0)
		FMENKOL.value = balance/menCount;
}

function getPeriod(dat1, dat2)
{
	var par = new Object();
	par.bdat = dat1;
	par.edat = dat2;
	par.title = UR("Період розрахунку|Период расчета");
	showWindow("e_period.xml", SW_MODAL, par);
	if(par.escape)
		return null;
	return par;
}

function calcMiddle()
{
	var cnt = Number(FCOUNTER.value);
	//var date = FDATE.value;
	var dat1 = firstDay(gomonth(date, -3));
	var dat2 = lastDay(gomonth(date, -1));
	var par = getPeriod(dat1, dat2);
	if(!par)
		return;
	dat1 = par.bdat;
	dat2 = par.edat;
	FMIDDLE.value = 0;
	var oSnap = getSnap("select sum(c.FDIFFERENCE), count(*) as cnt"
							//+", s.FBDAT, s.FEDAT"
							+", min(c.FDATE) as FMINDATE"
							+", max(c.FDATE) as FMAXDATE"
						+" from ^COUNTERS c"
							+" inner join ^SC_COUNTERS s on s.FWID=c.FCOUNTER"
						+" where c.FCOUNTER="+ cnt
							+" and c.FDATE>="+ sqlTo(dat1)
							+" and c.FDATE<="+ sqlTo(dat2)
						);
	if(oSnap && Number(oSnap[0]))
	{
		//var bdat = oSnap[2];	//если дата установки счетчика попадает в расчетный период - берем её
		//if(differ(bdat, dat1)==1)
		//	dat1 = bdat;
		var days = day_difference(dat1, dat2);
		FMIDDLE.value = round(Number(oSnap[0])/days, 4);
	}
}

function calcCheckMiddle()
{	
	var cnt = Number(FCOUNTER.value);
	var dat1 = firstDay(gomonth(FBDATCHECK.value, -2));
	var dat2 = lastDay(gomonth(FBDATCHECK.value, -1));
	var par = getPeriod(dat1, dat2);
	if(!par)
		return;
	dat1 = par.bdat;
	dat2 = par.edat;
	FCHECKMIDDLE.value = 0;
	var oSnap = getSnap("select sum(c.FDIFFERENCE), count(*) as cnt"
							//+", s.FBDAT, s.FEDAT"
							+", min(c.FDATE) as FMINDATE"
							+", max(c.FDATE) as FMAXDATE"
						+" from ^COUNTERS c"
							+" inner join ^SC_COUNTERS s on s.FWID=c.FCOUNTER"
						+" where c.FCOUNTER="+ cnt
							+" and c.FDATE>="+ sqlTo(dat1)
							+" and c.FDATE<="+ sqlTo(dat2)
						);
	if(oSnap && Number(oSnap[0]))
	{
		//dat1 = firstDay(oSnap[2]);
		//dat2 = lastDay(oSnap[3]);
		var days = day_difference(dat1, dat2);
		FCHECKMIDDLE.value = round(Number(oSnap[0])/days, 4);
	}
}

function loadLicsc()
{
	var dat1 = firstday(date);
	var dat2 = lastday(date);
	var licsc = String(FLICSC.value);
	if(licsc==oLicsc.num)
		return;
	oLicsc.num = licsc;
	var oSnap = getSnap("select FID_DOG, FSTREET_TXT, FHOUSE_NOM, FAPT_NOM, FSTREET, FHOUSE, FAPMT, FORG_TXT"
						+" from ^LISTLICSC"
						+" where FDOG_NUM="+ sqlTo(licsc)
							+" and FBDAT<="+ sqlTo(dat2)
							+" and FEDAT>="+ sqlTo(dat1)
						);
	if(oSnap)
	{
		oLicsc.fwid = oSnap[0];
		oLicsc.street = oSnap[4];
		oLicsc.house = oSnap[5];
		oLicsc.apart = oSnap[6];
		
		FADDR.value = "";
		FORG.value = "";
		if(oSnap)
		{
			var addr = oSnap[1];
			if(oSnap[2])
				addr += " "+ oSnap[2];
			if(oSnap[3])
				addr += ", кв. "+ oSnap[3];
			FADDR.value = addr;
			FORG.value = oSnap[7];
		}
	}
	
	loadCounters();
}

function loadCounters()
{
	var dat1 = firstday(date);
	var dat2 = lastday(date);
	var counter = String(FCOUNTER.getValue());
	var house = tbl.getValue("FHOUSE");
	var serv = tbl.getValue("FSERV");
	FCOUNTER.clear();
	var tCnt = null;
	ExecuteSQL("drop table"+ sTmpCnt, false);
	if(Number(oLicsc.fwid))
	{
		ExecuteSQL("select * into "+ sTmpCnt 
				+" from ^SC_COUNTERS "
				+" where FID_DOG="+ oLicsc.fwid
					+" and FSERV="+ sqlTo(serv)
					+" and FBDAT<="+ sqlTo(dat2)
					+" and FEDAT>="+ sqlTo(dat1)
				);
		tCnt = OpenTable(sTmpCnt);
	}
	else
	{
		ExecuteSQL("select c.* into "+ sTmpCnt 
				+" from ^SC_COUNTERS c"
					+" inner join ^LICSC l on c.FID_DOG=l.FID_DOG"
				+" where (c.FWID_CL="+ house +" or l.FHOUSE="+ house +")"
					+" and c.FSERV="+ sqlTo(serv)
					+" and c.FBDAT<="+ sqlTo(dat2)
					+" and c.FEDAT>="+ sqlTo(dat1)
				);
		tCnt = OpenTable("select * from ^SC_COUNTERS "
							+" where FWID_CL="+ house
								+" and FBDAT<="+ sqlTo(dat2)
								+" and FEDAT>="+ sqlTo(dat1)
							);
	}
	while(!tCnt.isEOF())
	{
		var nid = String(tCnt.getValue("FWID"));
		var num = tCnt.getValue("FNUM");
		var txt = tCnt.getValue("FNUM");
		var serial = tCnt.getValue("FSERIAL");
		if(serial!="")
			txt += " - "+ serial;
		FCOUNTER.addItem(nid, txt);
		tCnt.MoveNext();
	}
	tCnt.close();
	FCOUNTER.setValue(counter);
}

function counterValid()
{
	var cntID = Number(tbl.getValue("FCOUNTER"));
	var oSnap = getSnap("select FSERV, FUNIT, FTYPE, FNORMLIMIT"
						+" from ^SC_COUNTERS"
						+" where FWID="+ cntID 
						);
	if(oSnap)
	{
		FSERV.value = oSnap[0];
		type = Number(oSnap[2]);
		FNORMLIMIT.value = oSnap[3];
		if(Number(oSnap[1]))
		{
			oSnap = getSnap("select FKOEF from ^CL_EDI where FCOD="+ oSnap[1]);
			if(oSnap && Number(oSnap[0]))
				FKOEF.value = oSnap[0];
			//Enable(FKOEF);
		}
	}
	
	if(type==10)
	{
		FPREVIOUS.value = 0;
		//Disable(FPREVIOUS);
		Enable(FDIFFERENCE);
	}
	else if(extPar.mode!="EDIT")
	{
		Enable(FDIFFERENCE, false);
		loadPrev();
	}
	
	if(type==2)
		GRNORM.setVisible(true);
	else
		GRNORM.setVisible(false);
	loadNorm();
}

function loadNorm()
{
	//var date = FDATE.value;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var house = tbl.getValue("FHOUSE");
	var serv = tbl.getValue("FSERV");
	var dogID = Number(oLicsc.fwid);
	
	var oSnap = getSnap("select sum(FNORM), max(FNORMLIMIT)"
					+" from ^WATER"
					+" where FHOUSE="+ house
						+" and FSERV="+ sqlTo(serv)
						+" and FBDAT<="+ sqlTo(d2) +" and FEDAT>="+ sqlTo(d1)
					, false
					);
	if(oSnap && Number(oSnap[0]))
	{
		FNORM.value = oSnap[0];
		//FNORMLIMIT.value = oSnap[1];
	}
	else
	{
		oSnap = getSnap("select sum("+ IIF("s.FNORM=0 and t.FNORM is not null", "t.FNORM", "s.FNORM") +")"
						+" from ^SC_SERV s "
						+" inner join ^LICSC l on l.FID_DOG=s.FID_DOG"
						+" left join ^TARIF t on t.FNMKL=s.FNMKL"
							+" and t.FBDAT<="+ sqlTo(d2) +" and t.FEDAT>="+ sqlTo(d1)
						+" where l.FID_DOG="+ dogID
							+" and s.FSERV="+ sqlTo(serv)
							+" and s.FBDAT<="+ sqlTo(d2) +" and s.FEDAT>="+ sqlTo(d1)
						, false
						);
		if(oSnap)
		{
			FNORM.value = oSnap[0];
		}
	}
}

function loadPrev()
{
	//var date = FDATE.value;
	var rowID = 0;
	if(extPar.mode=="EDIT")
		rowID = tbl.getValue("FWID");
	var dogID = oLicsc.fwid;
	var cntID = Number(FCOUNTER.value);
	if(!cntID)
		return;
	if(extPar.recalc)
	{
		var sTbl = tbl.getTableName();
		var oSnap = getSnap("select FCURRENT, FDIFFERENCE, FREGDATE"
							+" from "+ sTbl
							+" where FWID<>"+ sqlTo(rowID)
								+" and FCOUNTER="+ cntID
								+" and FDATE<="+ sqlTo(date)
							+" order by FREGDATE desc"
							);
		if(oSnap && Number(oSnap[0]))
		{
			var oldDif = Number(tbl.getValue("FDIFFERENCE_OLD"));
			var oldCur = Number(tbl.getValue("FCURRENT_OLD"));
			FPREVIOUS.value = oldCur+Number(oSnap[1]);
			calcDif();
		}
		return;
	}
	
	var oSnap = getSnap("select FCURRENT, FREGDATE"
						+" from ^COUNTERS"
						+" where FID_DOG="+ dogID 
							+" and FCOUNTER="+ cntID
							+" and FDATE<="+ sqlTo(date)
							+" and FWID<>"+ sqlTo(rowID)
						+" order by FREGDATE desc"
						);
	if(oSnap && Number(oSnap[0]))
	{
		FPREVIOUS.value = Number(oSnap[0]);
		FPREVIOUSDATE.value = oSnap[1];
		calcDif();
	}
}

function calcDif()
{
	if(type==10)	//для условного счетчика разницу можно вносить вручную
	{
		if(Number(FCURRENT.value)==0 && Number(FPREVIOUS.value)==0)
			return;
	}
	FDIFFERENCE.value = 0;
	if(tbl.getValue("FINIT")==true)
		return;
	if(!__isRazv)
	{
		if(Number(FCURRENT.value)==0 || (!extPar.recalc && Number(FCURRENT.value)<Number(FPREVIOUS.value)))
		{
			showCurrentError();
			if(Number(FCURRENT.value)!=0)
				return false;
		}
	}
	FDIFFERENCE.value = Number(FCURRENT.value) - Number(FPREVIOUS.value);
}

function showCurrentError()
{
	if(Number(FCURRENT.value)==0)
	{
		var sMsg = UR("Внесені нульові поточні показники!"
					+"|Внесены нулевые текущие показания!"
					);
		FCURRENT.showErr(sMsg);
	}
	else if(Number(FCURRENT.value)<Number(FPREVIOUS.value))
	{
		var sMsg = UR("Поточні показники не можуть бути меншими за попередні!"
					+"|Текущие показания не могут быть меньше предыдущих!"
					);
		FCURRENT.showErr(sMsg);
		setFocus(FCURRENT);
	}
}

function onSave()
{
	if(Number(FCURRENT.value)==0 && type!=10)
	{
		if(Number(FCURRENT.value)<Number(FPREVIOUS.value) && !__isRazv)
		{
			showCurrentError();
			return false;
		}
		var sMsg = UR("Зберегти нульові показники?|Сохранить нулевые показания?");
		if(!confirm(sMsg))
			return false;
	}
	
	var m = new Object();
	if(extPar.mode=="EDIT")
		m.FWID = tbl.getValue("FWID");
	else
		m.FWID = GetUID();
	
	var kol = Number(FDIFFERENCE.value);
	
	if(extPar.mode=="ADD")
	{
		m.FID_DOG = oLicsc.fwid;
		m.FCOUNTER = Number(FCOUNTER.value);
		m.FDATE = date;
	}
	else
	{
		var cdate = tbl.getValue("FDATE");
		m.FMONTH = (new Date(cdate).getMonth())+1;
	}
	m.FSERV = FSERV.value;
	m.FREGDATE = date;
	m.FCURRENT = FCURRENT.value;
	m.FPREVIOUS = FPREVIOUS.value;
	m.FDIFFERENCE = FDIFFERENCE.value;
	m.FMIDDLE = FMIDDLE.value;
	m.FCHECKMIDDLE = FCHECKMIDDLE.value;
	m.FISBREAK = FISBREAK.value;
	m.FBDATBREAK = FBDATBREAK.value;
	m.FEDATBREAK = FEDATBREAK.value;
	m.FISCHECK = FISCHECK.value;
	m.FBDATCHECK = FBDATCHECK.value;
	m.FEDATCHECK = FEDATCHECK.value;
	
	m.FSOURCE = oSource.getCod();
	m.FCOMMENT = FCOMMENT.value;
	//m.FREGDATE = today;
	m.FKOEF = FKOEF.value;
	m.FKOL = FDIFFERENCE.value;
	if(Number(FKOEF.value)!=0)
		m.FKOL = round(Number(FDIFFERENCE.value)/Number(FKOEF.value), getPar("DECIKOL"));
	m.FNORM = FNORM.value;
	m.FNORMLIMIT = FNORMLIMIT.value;
	m.FMENKOL = FMENKOL.value;
	m.FMUSER = getUserName();
	m.FMHOST = getHostName();
	m.FMDATE = new Date();
	if(oLicsc.street)
		m.FSTREET = oLicsc.street;
	if(oLicsc.house)
		m.FHOUSE = oLicsc.house;
	if(oLicsc.apart)
		m.FAPMT = oLicsc.apart;
	
	extPar.FSOURCE = m.FSOURCE;
	extPar.FCOMMENT = FCOMMENT.value;
	extPar.FCURRENT = FCURRENT.value;
	extPar.FPREVIOUS = FPREVIOUS.value;
	extPar.FDIFFERENCE = FDIFFERENCE.value;
	var bNew = extPar.mode=="ADD" || extPar.mode=="COPY";
	UpdateTable(tbl.getTableName(), m, bNew);
	
	var m = new Object();
	m.FMIDDLE = FMIDDLE.value;
	m.FCHECKMIDDLE = FCHECKMIDDLE.value;
	m.FISBREAK = FISBREAK.value;
	m.FBDATBREAK = FBDATBREAK.value;
	m.FEDATBREAK = FEDATBREAK.value;
	m.FISCHECK = FISCHECK.value;
	m.FCHECKDATE = FBDATCHECK.value;
	m.FBDATCHECK = FBDATCHECK.value;
	m.FEDATCHECK = FEDATCHECK.value;
	m.FWID = Number(FCOUNTER.value);
	UpdateTable("^SC_COUNTERS", m, false);
	
	exit();
}

function onEscape()
{
	exit();
}

function exit()
{
	ExecuteSQL("drop table"+ sTmpCnt, false);
}

include("sys/DpBaseDlg.js");