include("Objects/DpCl.js");
include("Objects/DpShifPZ.js");
var clDol = dpShifPZ = null;
var Validation = true;
var bdat = edat = null;
var codDol = 0;

function Load()
{
	Caption(ru("Должность", "Посада") + ": " + getModeName(extPar.sMode));
	
	extPar.fwid = Number(extPar.fwid)

	codDol = getPar("CODDOL");
	clDol = new DpCl("", codDol, 0);
	clDol.linkCtrl(FCOD, FTXT);
	FOKLAD.setMask("#####.##");
	
	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);
	dpShifPZ.setFshpz(0);
	
	
	switch (extPar.sMode)
	{
		case "EDIT":
		case "LIKV":
			var snap = getSnap("SELECT fcod, fbdat, fedat, foklad, fshpz FROM ^stru_dol WHERE fwid="
				+ Convert(sqlTo(extPar.fwid), "INT"));
			if (snap == null)
			{
				alert(UR("Запис не знайдено!|Запись не найдена!"), ICON_ERROR);
				return false;
			}
			clDol.setCod(snap[0]);
			FBDAT.value =  snap[1];
			FEDAT.value =  snap[2];
			FOKLAD.value = snap[3];
			dpShifPZ.setFshpz(snap[4]);
			bdat = FBDAT.value;
			edat = FEDAT.value;
			if (extPar.sMode == "EDIT")
			{
				if (extPar.disabledED)
					{
					Disable(FEDAT);							
					}else
				{
					Disable(FCOD, FTXT, FBDAT, FOKLAD, HSHPZ, HSHPZ_TXT);
					setFocus(FEDAT);					
				}
			}
			else if (extPar.sMode == "LIKV")
			{
				Disable(FCOD, FTXT, FBDAT, FOKLAD, HSHPZ, HSHPZ_TXT);
				FEDAT.value = new Date().getVarDate();
				setFocus(FEDAT);
			}
			break;
		case "ADD":
			if (extPar.outValue)
			{
				Disable(FCOD, FTXT, FBDAT, FEDAT);
				clDol.setCod(extPar.cod);
				FBDAT.value = extPar.bdat;
				setFocus(FOKLAD);
			}
			else
			{
				FBDAT.value = new Date().getVarDate();	
			}
			break;					
		default:
			alert(UR("Невідома команда!|Неизвестная команда!"), ICON_WARNING);
			return false;	
	}

	setValid(FBDAT, fbdat_valid);
	setValid(FEDAT, fedat_valid);
}

function onSave()
{
	var m = new Object();
	if (extPar.sMode == "ADD")
	{
		m.FWID_ORG = Number(extPar.fwid == "" ? 0 : extPar.fwid);
		
		m.FWID = GetUID();
		extPar.fwid = m.FWID;
	}
	else
		{
			m.FWID = Number(extPar.fwid);
		}
		
	if (extPar.sMode == "LIKV")
		extPar.sMode = "EDIT";
		
	m.FCOD = clDol.getCod();
	m.FWID_CL = clDol.getFWID();
	m.FBDAT = FBDAT.value;
	m.FEDAT = FEDAT.value;
	m.FOKLAD = FOKLAD.value;
	m.FSHPZ = dpShifPZ.getFshpz();

	updateTable("^stru_dol", m, "EDIT" != extPar.sMode);
	
	extPar.refPar = false;
	if (extPar.sMode == "EDIT" && (differDate(bdat, FBDAT.value) != 0 || differDate(edat, FEDAT.value) != 0))
		extPar.refPar = true;
}

function fbdat_valid()
{
	var objbdat = toScriptDate(FBDAT.value);
	if (differ(toScriptDate(d00), objbdat) == 0)
	{
		WAIT(UR("Введіть дату створення посади!|Введите дату создания должности!"));
		return false;
	}
	else 
	{
		var snap = null;
		switch (extPar.sMode)
		{
			case "EDIT":
			case "LIKV":
				snap = getSnap("SELECT fbdat, fedat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol WHERE fwid=" + Convert(sqlTo(extPar.fwid), "INT") + ")");
				break;
			case "ADD":
				snap = getSnap("SELECT fbdat, fedat FROM ^stru_org WHERE fwid=" + Convert(sqlTo(extPar.fwid), "INT"));
				break;
		}
		if (snap == null)
		{
			WAIT(UR("Не знайдено данних підрозділу чи суперпідрозділу!|Не найдено данных подразделения или суперподразделения!"));
			return false;
		}
		var pbdate = toScriptDate(snap[0]);
		var pedate = toScriptDate(snap[1]);
		var ibdate = objbdat;
	
		if (differ(ibdate, pbdate) == -1)
		{
			WAIT(UR("Дата створення посади менша за дату створення суперпідрозділу!|"
				+ "Дата создания должности меньше даты создания суперподразделения!"));
			return false;				
		}
		if (differ(ibdate, pedate) == 1)
		{
			WAIT(UR("Дата створення посади більша за дату ліквідації суперпідрозділу!|"
				+ "Дата создания должности больше даты ликвидации суперподразделения!"));
			return false;				
		}			
		return true;
	}
}

function fedat_valid()
{
	var objedat = toScriptDate(FEDAT.value);
	if (differ(toScriptDate(d00), objedat) == 0)
	{
		return true;
	}
	else
	{
		if (differ(toScriptDate(FBDAT.value), toScriptDate(FEDAT.value)) == 1)
		{
			WAIT(UR("Дата ліквідації менша за дату створення!|Дата ликвидации меньше даты создания!"));
			return false;				
		}	
			
		var snap = null;
		switch (extPar.sMode)
		{
			case "EDIT":
			case "LIKV":
				snap = getSnap("SELECT fbdat, fedat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol WHERE fwid=" + Convert(sqlTo(extPar.fwid), "INT") + ")");
				break;
			case "ADD":
				snap = getSnap("SELECT fbdat, fedat FROM ^stru_org WHERE fwid=" + Convert(sqlTo(extPar.fwid), "INT"));
				break;
		}
		if (snap == null)
		{
			WAIT(UR("Не знайдено данних підрозділу чи суперпідрозділу!|Не найдено данных подразделения или суперподразделения!"));
			return false;
		}
		var pbdate = toScriptDate(snap[0]);
		var pedate = toScriptDate(snap[1]);
		var ibdate = objedat;
		if (differ(ibdate, pbdate) == -1)
		{
			WAIT(UR("Дата ліквідації посади менша за дату створення суперпідрозділу!|"
				+ "Дата ликвидации должности меньше даты создания суперподразделения!"));
			return false;				
		}
		if (differ(ibdate, pedate) == 1)
		{
			WAIT(UR("Дата ліквідації посади більша за дату ліквідації суперпідрозділу!|"
				+ "Дата ликвидации должности больше даты ликвидации суперподразделения!"));
			return false;				
		}	
		if (typeof extPar.maxEdat != "undefined" &&  extPar.maxEdat != null
			 && differ(toScriptDate(extPar.maxEdat), objedat) == 1)
		{
			WAIT(UR("Дата ліквідації посади менша за дату ліквідації одного чи декількох піделементів!|"
				+ "Дата ликвидации должности меньше даты ликвидации одного или нескольких подэлементов!"));
			return false;			
		}		
		return true;
	}
}

function differDate(date1, date2)
{
	return differ(toScriptDate(date1), toScriptDate(date2));
}

function getModeName(mode)
{
	var strMode = modeName(mode);
	if (strMode != mode)
		return strMode;
	switch (mode)
	{
		case "LIKV":
			return UR("ліквідація|ликвидация");
		default:
			return mode; 
	}
}

include("sys/DpBaseDlg.js");