include("objects\\DpPrintSelect.js");

function Load()
{
	Caption("Група друку|Група печати");
	if (extPar.sMode == "EDIT")
	{
		SHABLBL.setValue(extPar.sLbl);
		SHABTYPE.setValue(extPar.sType);
		SHABTEXT.setValue(extPar.sText);
		Disable(SHABLBL);
		Disable(SHABTYPE);
	}
	else
		setValid(SHABLBL,lbl_valid);
}

function lbl_valid()
{
	var lbl = allt(SHABLBL.getValue()).toUpperCase();
	SHABLBL.setValue(lbl);
	if (lbl == "")
	{
		SHABLBL.showErr("Введіть мітку групи|Введите метку группы");
		return false;
	}
	if (!/^\s*[A-Za-z_][A-Za-z0-9_]*\s*$/.test(lbl))
	{
		SHABLBL.showErr("Мітка може складатися тільки з англійських літер та цифр|"
				+ "Метка может состоять только из латинских букв и цифр");
		return false;
	}
	var idx;
	if (SHABTYPE.getValue() == "LIST")
		idx = extPar.listIdx;
	else
		idx = extPar.docIdx;
	if (idx[lbl])
	{
		SHABLBL.showErr("Мітка з таким ім'ям вже існує"
				+ "|Метка с таким именем уже существует");
		return false;
	}
	return true;
}

function onSave()
{
	var sType = allt(SHABTYPE.getValue());
	var sLbl = allt(SHABLBL.getValue()).toUpperCase();
	var sName = allt(SHABTEXT.getValue());
	var printSelect = new DpPrintSelect(sType,sLbl);
	printSelect.createIfNo();
	printSelect.setInfoName(sName);
	extPar.sText = sName;
	extPar.sType = sType;
	extPar.sLbl = sLbl;
	extPar.printSelect = printSelect;
}