var table;

function onLoad()
{
	Caption("Спискова операція|Списковая операция");
	table=OpenTable("SELECT * FROM "+extPar.tabname+
					" WHERE "+extPar.sele);
	if (table.IsEmpty())				 
		return false;
	FKOLDN.mask = "##";
	FKOLCH.mask = "###.##";
	FPROC.mask = "###.##";
	FKOLDN.enabled = false;
	FKOLCH.enabled = false;
	FPROC.enabled = false;
	FBOLDAT.enabled = false;
	FBEGDAT.enabled = false;
	FENDDAT.enabled = false;
	setValid(FENDDAT,FENDDAT_Valid);
	setValid(CHKOLDN,CHKOLDN_Valid);
	setValid(CHKOLCH,CHKOLCH_Valid);
	setValid(CHPROC,CHPROC_Valid);
	setValid(CHBOLDAT,CHBOLDAT_Valid);
	setValid(CHBEGDAT,CHBEGDAT_Valid);
	setValid(CHENDDAT,CHENDDAT_Valid);
	setValid(CHDEL,CHDEL_Valid);
}

function onSave()
{
	if (toScrObj(CHDEL.checked))
	{
		ExecuteSQL("DELETE FROM "+extPar.tabname+" WHERE "+extPar.sele);
	}
	else
	{
		if (!table.IsEmpty())
			table.MoveFirst();
		while (!table.IsEOF())
		{
			var m = new Object();
			var bUpd = false;
			if (toScrObj(CHKOLDN.checked))
			{
				var hor = Number(table.getValue("FSUM"))-Math.floor(Number(table.getValue("FSUM"))/1000)*1000;//часы
				m.FSUM = Number(FKOLDN.value)*1000 + hor;
				bUpd = true;
			}
			if (toScrObj(CHKOLCH.checked))
			{
				var dn = Math.floor(Number(table.getValue("FSUM"))/1000);//дни
				m.FSUM = dn*1000 + Number(FKOLCH.value);
				bUpd = true;
			}
			if (toScrObj(CHPROC.checked))
			{
				m.FPROC = FPROC.value;
				bUpd = true;
			}
			if (toScrObj(CHBOLDAT.checked))
			{
				m.FDAT_BOL = FBOLDAT.value;
				bUpd = true;
			}
			if (toScrObj(CHBEGDAT.checked))
			{
				m.FBDAT = FBEGDAT.value;
				bUpd = true;
			}
			if (toScrObj(CHENDDAT.checked))
			{
				m.FEDAT = FENDDAT.value;
				bUpd = true;
			}
			if(bUpd)
			{
				var tbl = extPar.tabname.toLowerCase();
				var n = tbl.indexOf('as')
				if(n!=-1)
					tbl=tbl.substr(0,n);
				UpdateTable(tbl,m,false,"Fwid="+sqlTo(table.getValue("Fwid")));
			}
			table.MoveNext();
		}
	}
	return true;
}

function FENDDAT_Valid()
{
	if (differ(new Date(FBEGDAT.value),new Date(FENDDAT.value))==1)
	{
		WAIT(ru("Дата конца должна быть не меньше даты начала!","Дата конца повинна бути не меншою за дату початку!"));
		return false;
	}
	return true;
}

function CHKOLDN_Valid()
{
	if (toScrObj(CHKOLDN.checked))
	{
		CHDEL.checked = false;
		FKOLDN.enabled = true;
	}
	else  
		FKOLDN.enabled = false;
	return true;
}


function CHKOLCH_Valid()
{
	if (toScrObj(CHKOLCH.checked))
	{
		CHDEL.checked = false;
		FKOLCH.enabled = true;
	}     
	else  
		FKOLCH.enabled = false;
	return true;
}

function CHPROC_Valid()
{
	if (toScrObj(CHPROC.checked))
	{
		CHDEL.checked = false;
		FPROC.enabled = true;
	}
	else  
		FPROC.enabled = false;
	return true;
}

function CHBOLDAT_Valid()
{
	if (toScrObj(CHBOLDAT.checked))
	{
		CHDEL.checked = false;
		FBOLDAT.enabled = true;
	}
	else  
		FBOLDAT.enabled = false;
	return true;
}

function CHBEGDAT_Valid()
{
	if (toScrObj(CHBEGDAT.checked))
	{
		CHDEL.checked = false;
		FBEGDAT.enabled = true;
	}
	else  
		FBEGDAT.enabled = false;
	return true;
}

function CHENDDAT_Valid()
{
	if (toScrObj(CHENDDAT.checked))
	{
		CHDEL.checked = false;
		FENDDAT.enabled = true;
	}
	else  
		FENDDAT.enabled = false;
	return true;
}


function CHDEL_Valid()
{
	if(toScrObj(CHDEL.checked))
	{
		CHKOLDN.checked = false;
		FKOLDN.enabled = false;
		CHKOLCH.checked = false;
		FKOLCH.enabled = false;
		CHPROC.checked = false;
		FPROC.enabled = false;
		CHBOLDAT.checked = false;
		FBOLDAT.enabled = false;
		CHBEGDAT.checked = false;
		FBEGDAT.enabled = false;
		CHENDDAT.checked = false;
		FENDDAT.enabled = false;
	}
	return true;
}