include ("Objects\\DpCl.js");

var flag;
var oOrg, codmet, isObCl;

function Load()
{
	Caption(ru("Справочник драгоценных металлов",
      "Довiдник дорогоцiнних металiв"),
      extPar.mode);
   
   tbl = extPar.tblSrc;
   
   isObCl = true;
   //параметр для справочника драгметаллов
   codmet = getPar("CODMET");
   if (codmet==0)
      isObCl = false;
   if (extPar.mInv_num==null)
    {
       flag=true;
    }
    else
    {
      Disable(Finv_num);
      flag=false;
    }

    if (isObCl)   
    {
      oOrg = new DpCl();
      oOrg.setClcl(codmet);
      oOrg.linkCtrl(Fnum);
      oOrg.linkCtrl2("Ftxt", Fnaim);
    } 

    Finv_num.mask="####";    
    Fnum.mask="####";
    Fkol.mask="###.#######";
    Fnaim.mask="&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
    Fpodr.mask="######";
    Fmol.mask="######";

    setValid(Fnum, Fnum_Valid);
    setValid(Finv_num, Finv_num_Valid);  
    setValid(Fnaim, Fnaim_Valid);
   
   
    switch(extPar.mode)
    {
      case "EDIT":
      case "COPY":
           if(isObCl)
           {
               oOrg.setCod(tbl.getValue("Fnum"));
           }
           else
               Fnum.value = tbl.getValue("Fnum");       
           Finv_num.value=tbl.getValue("Finv_num");
           Fnaim.value=tbl.getValue("Fnaim");
           Fkol.value=tbl.getValue("Fkol");
           Fpodr.value=tbl.getValue("Fcod_podr");
           Fmol.value=tbl.getValue("Fcod_mol");
           Fbdat.value=tbl.getValue("Fbdat");
           Fedat.value=tbl.getValue("Fedat");
           break;
      case "ADD":
           if (!flag) 
               Finv_num.value=extPar.mInv_num
           else  
               Finv_num.value=0;
           Fkol.value=0;
           if(isObCl)
           {
               oOrg.setCod(0);
           }
           else   
               Fnum.value=0;
           Fnaim.value="";               
           break;
    }
    

}

function onSave()
{
   if(isObCl)
     oOrg.zSetCod(Fnum.value);
   var p = true;
   var m = new Object();
   switch(extPar.mode)
   {
      case "EDIT":
       //  tbl.Edit();
       	p = false;
         break;
      case "ADD" :
      case "COPY":
         
         m.FWID=GetUID();
         break;
      default:
         return;
   }
   __SaveFWID(tbl);
  if(isObCl)
  {
      m.Fnum=oOrg.getCod();
      m.Fnaim=oOrg.getTxt();
   }
   else
   {
      m.Fnum=Fnum.value;
      m.Fnaim=Fnaim.value;
   }
   m.Finv_num=Finv_num.value;
   m.Fkol=Fkol.value;
   m.Fcod_podr=Fpodr.value;
   m.Fcod_mol=Fmol.value;
   m.Fbdat=Fbdat.value;
   m.Fedat=Fedat.value;
   //tbl.Update();
   UpdateTable("^METALL",m,p," Fwid = " + sqlTo(tbl.getValue("Fwid")));
   tbl.Close();
}

function Fnum_Valid()
{
	if (flag)
	{
   		if(getSnap( 
      		"SELECT *"
      		+ " FROM ^METALL"
		      + " WHERE "
        		 + " FINV_NUM=" + sqlTo(Finv_num.value)
		         + " AND FNUM="+sqlTo(Fnum.value)
        		 + (extPar.mode=="EDIT"?
		            " and fwid<>" + sqlTo(tbl.getValue("fwid")):
        		    "")
    		  ) !=null )
   		{
      		WAIT("Запись с данным номером уже существует");
      		return false;
   	 	}
	}  
	return true;
}

function Finv_num_Valid() 
{
   if (Finv_num.Value ==0)
   {
      WAIT("Нулевой инвариантный номер недопустим!");
      return false;
   }
return true;
}

function Fnaim_Valid() 
{
   if (Fnaim.Value=="")
   {
      WAIT("Пустое наименование недопустимо!");
      return false;
   }
	return true;
}