include("sys/mask.js");
include("Objects/DpCl.js");

var mode, oCl;

function Load()
{
	if(!getPar("ZRP_KZO"))
 	{
 		alert(ru("В меню '"+getParItemPath("ZRP_KZO", true)+"' установите код соответствующего справочника",
 				"В меню '"+getParItemPath("ZRP_KZO", true)+"' встановіть код відповідного довідника"));
 		return false;
 	}
	mode = extPar.mode;
	Caption( ru("Ставка ЕСВ", "Ставка ЄСВ") + ": " + modeName(mode));
	
	Fproc_n.mask="##.##";
	Fproc_u.mask="##.##";
	oCl = new DpCl("", getPar("ZRP_KZO"), 0);
	oCl.linkCtrl(Fcod_kzo, Ftxt_kzo);
	oClb = new DpCl("0", getPar("ZRP_KZO"), 0);	
	oClb.linkCtrl(Fcod_bln, Ftxt_bln);
	
	this.tbl = extPar.tblSrc;
	
	switch(mode)
	{
		case "EDIT":
		case "COPY":
			Fproc_n.value = this.tbl.getValue("Fproc_n");
			Fproc_u.value = this.tbl.getValue("Fproc_u");
			Fbdat.value = this.tbl.getValue("Fbdat");
			Fedat.value = this.tbl.getValue("Fedat");  
			Fvidnach.value = this.tbl.getValue("Fvidnach");
			oCl.setCod(this.tbl.getValue("Fcod_kzo"));
			oClb.setCod(this.tbl.getValue("Fcod_bln"));			
		break;
		case "ADD":
		
		break;					
	}
	setValid(Fbdat,bdatValid);
	setValid(Fedat,edatValid);
}

function onSave()
{
	var m = new Object();
	if(mode != "EDIT")
		m.Fwid = GetUID();
//	__SaveFWID(this.tbl);
	m.Fproc_n=Fproc_n.value;
	m.Fproc_u=Fproc_u.value;
	m.Fbdat=Fbdat.value;
	m.Fedat=Fedat.value;  
	m.Fvidnach = Fvidnach.value;
	m.Fcod_kzo = oCl.getCod();
	m.Fcod_bln = oClb.getCod();	
	UpdateTable("^NALOG_ESV",m);
}

function bdatValid()
{
	if(differ(Fbdat.value,d00)==0)
	{
		WAIT(ru("Дата начала не может быть пустой!","Дата початку не може бути порожньою!"));
		return false;
	}
	return true;
}

function edatValid()
{
	if(differ(Fbdat.value,Fedat.value)>0)
	{
		WAIT(ru("Дата окончания не может быть меньше даты начала!","Дата закінчення не може бути меншою за дату початку!"));
		return false;
	}
	return true;
}