include("servis\\date.js");
include("objects\\dpCalendar.js");

var FVOPL = null;
var workHours = 8;
var FVSEGO_CH_edit = false;
var FNORMA_CH_edit = false;
var oCalend;
var isSubtract = getPar("NVK_SUBTRACT");

function onLoad()
{
	Caption(ru("Нормы времени","Норму часу"),extPar.mode);
	FNORMA_D.setMask("##.##");
	FNORMA_CH.setMask("###.##");
	FVSEGO_D.setMask("##.##");
	FVSEGO_CH.setMask("###.##");
	FVOPL = extPar.fvopl;

	if (isSubtract)
	{
		oCalend = new dpCalendar();
		oCalend.linkCtrl(FCALNUM, FREM);
		Enable(FNORMA_D, false);
		//оставим возможность подкоректировать вручную норму часов
		//Enable(FNORMA_CH, false);
	}

	if("EDIT" == extPar.mode || "COPY" == extPar.mode)
	{

		var strSQL = "SELECT fvopl, fnorma_d, fnorma_ch, fvsego_d, fvsego_ch, fbdat, FCALNUM"
					+ " FROM ^tbl_ini WHERE fwid=" + Number(extPar.fwid);

		var snap = getSnap(strSQL);
		if(null == snap)
			return false;

		FNORMA_D.value = snap[1];
		FNORMA_CH.value = snap[2];
		FVSEGO_D.value = snap[3];
		FVSEGO_CH.value = snap[4];
		FBDAT.value = snap[5];
		if (isSubtract)
		{
			oCalend.setCod(toScrObj(snap[6]));
		}
	}
	if(extPar.mode == "ADD" || extPar.mode=="COPY")
	{
		if(extPar.fbdat)
		{
			FBDAT.value = extPar.fbdat;
			setFocus(FNORMA_D);
		}
		else
		{
			var snap = getSnap("select MAX(Fbdat) from ^tbl_ini where Fvopl="+extPar.fvopl);
			if(snap && snap[0])
				FBDAT.value = goMonth(snap[0], 1);
			else
				FBDAT.value = firstDay(new Date());
		}
	}

	setValid(FBDAT, FBDAT_valid);
	if (isSubtract)
	{
		setValid(FCALNUM, FCALNUM_valid);
	}
	else
	{
		GR_CALEND.setVisible(false);
		setValid(FNORMA_D, FNORMA_D_valid);
		setValid(FNORMA_CH, FNORMA_CH_valid);
		setValid(FVSEGO_D, FVSEGO_D_valid);
		setValid(FVSEGO_CH, FVSEGO_CH_valid);
	}
	FCALNUM_valid()
}

function FCALNUM_valid()
{
	if (isSubtract)
	{
		var calDays = oCalend.getCalDays("Р", firstDay(FBDAT.value), lastDay(FBDAT.value));
		var calHours = oCalend.getCalHours("Р", firstDay(FBDAT.value), lastDay(FBDAT.value));
	}
	else
		return true;
	FNORMA_D.value = calDays;
	FVSEGO_D.value = calDays;
	//не у всех в календарях могут быть проставлены часы, поэтому для таких случаев часы проставляем по дням * 8
	if(calHours == 0)
	{
		if(FNORMA_CH.value == 0)
			FNORMA_CH.value = calDays*8;
		if(FVSEGO_CH.value == 0)
			FVSEGO_CH.value = calDays*8;
	}
	else
	{
		FNORMA_CH.value = calHours;
		if(FVSEGO_CH.value==0)
			FVSEGO_CH.value = calHours;
	}
	return true;
}


function FNORMA_D_valid()
{
	if(!FNORMA_CH_edit && Number(FNORMA_CH.value)==0)
		FNORMA_CH.value = Number(FNORMA_D.value)*workHours;
}

function FNORMA_CH_valid()
{
	FNORMA_CH_edit = true;
}

function FVSEGO_D_valid()
{
	if(!FVSEGO_CH_edit && Number(FVSEGO_CH.value)==0)
		FVSEGO_CH.value = Number(FVSEGO_D.value)*workHours;
}

function FVSEGO_CH_valid()
{
	FVSEGO_CH_edit = true;
}

function FBDAT_valid()
{
	if("ADD" == extPar.mode
	|| "COPY" == extPar.mode)
	{
		var strSQL = "SELECT COUNT(*) FROM ^tbl_ini WHERE fbdat=" + sqlTo(FBDAT.value)
												+ " AND fvopl=" + sqlTo(FVOPL);
		var snap = getSnap(strSQL);
		if(snap != null && snap[0]!=0)
			return false;
	}

	if(isEmpty(FBDAT.value))
		return false;
	FBDAT.value = firstDay(FBDAT.value);
	return true;
}

function onSave()
{
	var m = new Object();
	if("ADD" == extPar.mode
	|| "COPY" == extPar.mode)
	{
		m.FWID = GetUID();
		extPar.fwid = m.FWID;
	}

	m.FNORMA_D = FNORMA_D.value;
	m.FNORMA_CH = FNORMA_CH.value;
	m.FVSEGO_D = FVSEGO_D.value;
	m.FVSEGO_CH = FVSEGO_CH.value;
	m.FBDAT = FBDAT.value;
	if (isSubtract)
	{
		m.FCALNUM = oCalend.getCod();
	}
	var dat = FBDAT.value;
	dat.setMonth(dat.getMonth()+1);
	dat.setDate(0);
	//alert(dat);
	m.FEDAT = dat;
	m.FVOPL = FVOPL;
	updateTable("^tbl_ini", m, "EDIT" != extPar.mode);
	extPar.escape = false;
}

include("sys/DpBaseDlg.js");