include("Objects/DpShtat.js");
include("Objects/DpShifPZ.js");
include("Objects/dpCalendar.js");

var gridXml = "otpuskRows.xml";
var tblName = "otpuskRows";
var tblExt = extPar.m_pTable;
var dpShtat, dpShifPZ, oCal;

function listLoad()
{
	if(extPar.mode != "EDIT" && extPar.mode != "VEIW")
	{
		alert(ru("Недопустимый режим: ","Неприпустимий режим:"+modeName(extPar.mode)),1);
		return false;
	}
	this.title = UR("Зпрощені відпускні|Упрощенные отпускные")+": "+modeName(extPar.mode);
	this.escape = escape;
	this.save = save;
	this.editTask = "e_otpusk_row.xml";
	grid.setXMLFile(gridXml);
	var fld = new Object();
	fld.Fwid = "counter";
	fld.Fcod = "long";
	fld.Fdays = "long";
	CreateTable(tblName, fld);
	var t = OpenTable("SELECT * FROM ^NAST_OTP WHERE Fvid_n<>0 ORDER BY Fnom")
	var i = 0;
	for(; !t.IsEOF(); t.MoveNext())
	{
		var m = new Object();
		m.Fcod = t.getValue("Fnom");
		var snap = getSnap("select Fsum from ^prk_all where Foutid="+sqlTo(format("#",extPar.fwid))+" and Fvopl="+i);
		if(snap)
			m.Fdays = snap[0];
		UpdateTable(tblName, m, true);
		i++;
	}
	t.close();
	RBDAT.value = tblExt.getValue("Fbdat");
	RDAT_PRIK.value = tblExt.getValue("Fdat_prik");
	RNOM_PRIK.value = tblExt.getValue("Fnom_prik");
	RNOM_PRIK.mask = "$$$$$$$$$$$$$$$";
	dpShtat = new DpShtat("NOTSHTID", tblExt.getValue("Fbdat"), d00);	
	dpShtat.linkCtrl("fcod", RTABN);
	dpShtat.linkCtrl("wcl.ftxt", RTABNTXT);
	dpShtat.setFwid(tblExt.getValue("Fwid_wp"));
	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(RSHPZ,RSHPZ_TXT);
	dpShifPZ.setFshpz(tblExt.getValue("Fshpz"));
	oCal = new dpCalendar();
	oCal.linkCtrl(RCALNUM, RCALTXT, RBDAT, null/*REDAT*/, RTABN, RTABNTXT);
	oCal.setCod(tblExt.getValue("Fcalend"));
	//browse("CH_OTP1")
}

function listSrc()
{
	this.qrySet("From",tblName,"Order","Fcod");
	this.subTie("nast_otp","otp","Fnom","Fcod");
}

function filterMode(s)
{
	if(s != "EDIT")
		return false;
	return true;		
}

function save()
{
	if(!extPar || typeof extPar.saveRecord != "function")
	{
		alert(ru("Отсутствует функция saveRecord","Відсутня функція saveRecord"),2);
		return false;
	}
	var m = new Object();
	m.Fbdat = RBDAT.value;
	m.Fdat_prik = RDAT_PRIK.value;
	m.Fnom_prik = RNOM_PRIK.value;
	m.Fwid_wp = dpShtat.getFwid();
	m.Ftabn_id = dpShtat.getEmployeFwid();
	m.Fshpz = dpShifPZ.getFshpz();
	m.Fcalend = oCal.getCod();
	var t = OpenTable("SELECT * FROM "+tblName+" ORDER BY Fcod")
	var i = 0;
	for(; !t.IsEOF(); t.MoveNext())
	{
		eval("m.Fvid_"+String.fromCharCode(65+i)+"="+t.getValue("Fdays")+";");
		i++;
	}
	UpdateTable(tblExt.getTableName(), m, false, "Fwid="+extPar.fwid);
	t.close();
	extPar.saveRecord(extPar.fwid);
	FORM.close();
}

function escape()
{
	FORM.close();
}