include("Objects/DpCl.js");

var codPers = getPar("CODPERS");
var oCL = null;
var tbl;

function Load()
{
	Caption(UR("Користувач|Пользователь"), extPar.sMode);
	tbl = extPar.tblSrc;
	
	oCL = new DpCl("", codPers, 0);
	oCL.linkSmartCtrl(FPERS);
	oCL.setContAssist();
	
	loadLogins(FLOGIN);
	
	switch(extPar.sMode)
	{
		case "EDIT":
		case "COPY":
			FLOGIN.value = tbl.getValue("FLOGIN");
			oCL.setFWID(tbl.getValue("FWID_CL"))
			break;
		
		case "ADD":
			
			break;		
	}
	setValid(FLOGIN, login_valid);
	
	if(extPar.login)
		FLOGIN.value = extPar.login;
	if(extPar.cod)
		oCL.setCod(extPar.cod);
}

function loadLogins(oCombo)
{
	var sAdminFile = lpProxy.getAdminMng().getAdministrationFile();
    var docAdmin = lpProxy.openXmlFile(sAdminFile);
    var mainElem = docAdmin.getDocumentElement();
    var logList = mainElem.getElementsByTagName("LOGIN");
    for (var i=0; i<logList.getLength(); i++)
    {
    	var eLogin = logList.item(i);
    	var sLogin = eLogin.getAttribute("value");
    	if(sLogin!=null && sLogin!="")
    		oCombo.addItem(sLogin, sLogin);
    }
}

function onSave()
{
	var m = new Object();
	if(extPar.sMode=="EDIT")
		m.FWID = extPar.fwid;		
	else
		m.FWID = GetUID();
		
	m.FLOGIN = FLOGIN.value;
	m.FWID_CL = oCL.getFWID();
	
	updateTable("^CL_PERS", m, extPar.sMode!="EDIT");
}

function login_valid()
{
	if(extPar.sMode=="EDIT" && tbl && FLOGIN.value==tbl.getValue("FLOGIN"))
		return true;
		
	var oSnap = getSnap("select rel.FCOD, cl.FTXT "
						+" from ^CL_PERS pers "
						+" inner join ^CL cl on cl.FWID=pers.FWID_CL "
						+" inner join ^CLRELCLCL rel on rel.FWID_CL=cl.FWID"
						+" Where rel.FCL="+ getPar("CODPERS")
							+" and FLOGIN="+ sqlTo(FLOGIN.value)
					);
	if(oSnap && oSnap[0])
	{
		var sMsg = UR("Такий логін вже існує - |Такой логин уже существует - ") 
					+ oSnap[0] +": "+ oSnap[1];
		WAIT(sMsg);
	}
	return true;
}