include("objects\\DpClNo.js");
include("objects\\DpNmkl.js");
include("objects\\DpRecept.js");
include("Objects\\DpCl.js");

var table, ofnmkl, orecept;
var Validation = true;
var RECSTRTMP;

var noCl;
var oKind;
var nKind;
var s = 0;
var oCL1; 	//аналитика
var nCL1;

function Load()
{
	if (extPar.mode != "MASS")
	{
		Caption(ru("Строка правочника рецептов ","Рядок довідника рецептів "),
					extPar.mode);
	}
	else
	{
		Caption(ru("Строка правочника рецептов: массовый вибор",
			"Рядок довідника рецептів: масовий вибір"));
		Disable(RG1);
	}
	
	noCl = getOrgVar("SPR_RRECKIND" ,true);
	if(noCl)
	{
		oKind = new DpCl("0", noCl, 0);
	}
	else
	{
		nKind = 0;
	}

	RECSTRTMP = extPar.tblName;
	table = extPar.m_pTable;
	
	FNOM_STR.mask = "####";
	FKOL.setMask(MASK_KOL);
	setValid(FNMK, NMK_Valid);
	setValid(FREC, REC_Valid);
	RG1.setValue("NMKX");
	setValid(RG1, NMK_REC_Valid);

	ofnmkl = new DpNmkl();
	orecept = new DpRecept();
	orecept.EditRecept = true;
	orecept.linkCtrl(FREC,FREC_TXT);
	orecept.EnableCtrl(false);
	//ofnmkl.linkCtrl(FNMK,FNMK_TXT,FEDI);
	ofnmkl.linkSmartCtrl(FNMK,FEDI);
	
	setValid(FNMK, FNMK_Valid);
	setValid(FKOL, FKOL_Valid);
	setValid(FREC, FREC_Valid);
	setValid(FREC, Rec_Valid);

	if(noCl)
		oKind.linkSmartCtrl(FKIND);
	else
		FKIND.setMask("#####");
		
	nCL1 = getPar("RECEPT_CL1");
	oCL1 = new DpCl("0", nCL1, 0);
	if(nCL1)
	{
		GRCL.setVisible(true);
		oCL1.linkSmartCtrl(FCL1);
		oCL1.setContAssist();
		var txt1 = oCL1.getClTxt();
		if(txt1)
			LCL1.setText(UR(txt1));
	}

//	setOnSave(FMAIN_Valid);
//	setWhenSave(resetFmain);

	setFocus(FNOM_STR);

	switch(extPar.mode)
	{
	case "EDIT":
	case "COPY":
		if (table.getValue("frtype") == RTYPE_PR)
			RG2.setValue("PRIX");
		else 
			RG2.setValue("RASX");
		
		if (extPar.mode == "EDIT")
			FNOM_STR.value = table.getValue("fnom_str")
		else
			FNOM_STR.value = findFreeClNo(RECSTRTMP, "fnom_str", "fhno=" + sqlTo(extPar.Fno));

		// ES 20050210. Разрез ведения по датам добавился недавно.
		mFbdat.value = table.getValue("fbdat");
		mFedat.value = table.getValue("fedat");
		
		if (table.getValue("fnmkl")!=0 && table.getValue("fnmkl") != "")
		{
			RG1.setValue("NMKX");
			ofnmkl.setCod(Number(table.getValue("fnmkl")));	
			//setFocus(FNMK);
		}
		else if (table.getValue("FREC")!=0)
		{
			RG1.setValue("RECX");
			orecept.setCod(table.getValue("FREC"));
			FREC_Valid();
			//setFocus(FREC);
		} 
		ofnmkl.Fedi = table.getValue("fedi");
		ofnmkl.UpdateCtrl();
		var kf = ofnmkl.Fedikf1;
		if (ofnmkl.Fedi==0 || typeof(kf)!="number")
			kf=1;
		FKOL.value = table.getValue("fkol") / kf;
		FMAIN.setChecked(table.getValue("fmain") != 0);
		
		if(noCl)
		{
			oKind.setCod(table.getValue("fkind"))
		}
		else
		{
			FKIND.value = table.getValue("fkind");
		}
		if(nCL1)
			oCL1.setCod(table.getValue("FCL1"));
		break;
	case "ADD":
		FNOM_STR.value = findFreeClNo(RECSTRTMP, "fnom_str", "fhno=" + sqlTo(extPar.Fno));
		RG2.setValue("RASX");
		ofnmkl.setCod(0);
		FKOL.value = 0;
		//setFocus(RG1);
		break;
   	case "MASS":
		FNOM_STR.value = findFreeClNo(RECSTRTMP, "fnom_str"
			, "fhno=" + sqlTo(extPar.Fno));
			
   		RG2.setValue("RASX");
   		ofnmkl.setCod(extPar.fnmkl);
   		Disable(FNMK);
   		if (extPar.fkol != null)
   		{
   			FKOL.value = extPar.fkol;
   			extPar.mode = "EDIT";
   			if (extPar.frtype == RTYPE_PR)
   				RG2.setValue("PRIX");
   		}
   		else
   		{
   			FKOL.value = 0;
   			extPar.mode = "ADD";
   		}
   		setFocus(FKOL);
   		break;
	}
	NMK_REC_Valid();
	FNMK_Valid();
}

function FNMK_Valid()
{
	if (ofnmkl.ctrlEdi.length > 1)
		Enable(ofnmkl.ctrlEdi)
	else
		Disable(ofnmkl.ctrlEdi);	
	return true;
}

function FKOL_Valid()
{
   if(FKOL.getValue() == 0)
   {
      WAIT(ru("Нулевое количество недопустимо!","Нульова кількість неприпустима!"));
      return false;
   }
   return true;
}

function FMAIN_Valid()
{
	if(FMAIN.checked)
	{
		var tbl = OpenTable("s", 
			"SELECT *"
			+ " FROM " + extPar.tblName
			+ " WHERE fhno=" + extPar.Fno
				+ " AND fmain = " + SqlTrue
				+ (extPar.mode!="EDIT"? ""
					: " AND fwid<>" + sqlTo(table.getValue("FWID")))
			);
		if(!tbl.IsEmpty())
		{
			if("c"==msgBox("oc"
				, "Для данного рецепта уже указана основная номенклатура " + tbl.getValue("fnmkl")
				+ "\nНажмите продолжение, чтобы сделать текущую номенклатуру основной "))
			{
				FMAIN.checked = false
				return false;
			}
		}
	}
}

function resetFmain()
{
	if(FMAIN.checked)
		ExecuteSQL(
			"UPDATE " + extPar.tblName
			+ " SET fmain=(Fwid=" + sqlTo(table.getValue("FWID")) + ")"
			+ " WHERE fhno=" + extPar.Fno
		);
}

function FREC_Valid()
{
	var tmptbl = OpenTable("s", "SELECT * FROM ^CL_RREC WHERE FMAIN = " + SqlTrue + " AND FHNO = " + sqlTo(orecept.getCod()));
	if (!tmptbl.IsEmpty())
		ofnmkl.setCod(Number(tmptbl.getValue("FNMKL"))); 
}

function NMK_Valid()
{
	if (RG1.getValue() == "RECX")
	{
		ofnmkl.CanEmpty = true;
		ofnmkl.setCod(null);
		NMK_REC_Valid();
	}
	
}

function REC_Valid()
{
	if (RG1.getValue() == "NMKX")
	{
		orecept.CanZero = true;
		orecept.setCod(0);
		NMK_REC_Valid();
	}
}

function NMK_REC_Valid()
{
	//alert(RG1.getValue());
	if (RG1.getValue() == "RECX")
	{
		orecept.CanZero = false;
		
		RG2.setValue("RASX");
		Disable(RG2);
		Disable(FMAIN);
		orecept.EnableCtrl(true);
		Disable(FNMK);
	}
	else if (RG1.getValue() == "NMKX")
	{
		ofnmkl.CanEmpty = false;
		Enable(RG2, true);
		Enable(FMAIN, true);
		orecept.EnableCtrl(false);
		Enable(FNMK, true);
	}
}

function Rec_Valid()
{
	var recObj = new Object();
	recObj[extPar.Fno] = orecept.getCod();
	var szSql = "SELECT DISTINCT FHNO, FREC "
			+ " FROM ^CL_RREC"
			+ " WHERE FREC <> 0 AND FREC IS NOT NULL";
	var tbl = OpenTable("s", szSql);
	
	if (extPar.Fno == orecept.getCod() || (!tbl.IsEmpty() && !ValidRecept(recObj, orecept.getCod(), szSql)))
	{
		var szMsg = ru("Возникло цикличное включение рецепта: ", "Виникло циклічне включення рецепту: ") + "\n";
		var currRec = extPar.Fno;
		var oRec = new DpRecept();
		oRec.setCod(currRec);
		szMsg += "рецепт " + currRec + ": \"" + oRec.getFtxt() + "\""+ ru(" использует", " використовує") + "\n";
		for(currRec = recObj[currRec] ;currRec != extPar.Fno && currRec; currRec = recObj[currRec])
		{
			oRec.setCod(currRec)
			szMsg += "рецепт " + currRec + ": \"" + oRec.getFtxt() + "\"" + ru(" использует", " використовує") + "\n"; 
		}
		oRec.setCod(extPar.Fno);
		szMsg += "рецепт " + extPar.Fno + ": \"" + "\"" + oRec.getFtxt() + "\n\n";
		szMsg += ru("Пожалуйста выберите другой рецепт.", "Будь-ласка виберіть інший рецепт.");
		alert(szMsg);
		return false;
	}
	return true;
}

// obj - результат проверки (фиксируются все вложенные рецепты). 
// hno - номер рецепта, который проверяется

function ValidRecept(obj, hno, strSql)
{
	var validRec = true; 
	var szSQL = strSql + " AND FHNO = " + sqlTo(hno);
	var tValid = OpenTable("s", szSQL);
	
	while(validRec && !tValid.isEOF())
	{
		var frec = tValid.getValue("FREC");
		if (obj[frec])
			validRec = false;
		else
		{
			obj[hno] = frec;
			if (validRec = ValidRecept(obj, frec, strSql))
				obj[hno] = 0;
			tValid.FindFirst("FREC = " + frec)
		}
		tValid.MoveNext();
	}
		
	tValid.Close();
	
	return validRec;
}


function onSave()
{
	var isFwid;
	if (extPar.mode == "EDIT")
		isFwid = table.getValue("FWID")
	else
		if (extPar.mode=="ADD" || extPar.mode=="COPY")
			isFwid = GetUID();

	var m = fillFields();
	m.FWID = isFwid;
	updateTable(extPar.tblName, m, extPar.mode != "EDIT");
	extPar.escape = false;	
}

function fillFields()
{
	var m = new Object();
	m.FHNO	= extPar.Fno;
	m.FNMKL	= (RG1.getValue() == "NMKX") ? ofnmkl.getCod() : 0;
	m.FREC = (RG1.getValue() == "RECX") ? orecept.getCod() : 0;
	m.FRTYPE = (RG2.getValue() == "PRIX") ? RTYPE_PR : RTYPE_RS;
	var kf = ofnmkl.Fedikf1;
	if (ofnmkl.Fedi==0 || typeof(kf)!="number")
		kf=1;
	m.FEDI  = ofnmkl.Fedi;
	m.FKOL  = FKOL.getValue() * kf;
	m.FMAIN = FMAIN.checked;
	m.FNOM_STR = FNOM_STR.getValue();
	
	if(noCl)
		m.FKIND = oKind.getCod();
	else
		m.FKIND = FKIND.getValue();
	m.FBDAT = mFbdat.getValue();
	m.FEDAT = mFedat.getValue();
	if(nCL1)
	{
		m.FCL1 = oCL1.getCod();
	}
	
	return m;
}