include("objects/DpCl.js");
include("objects/DpClcl.js");
include("objects/DpSc.js");
include("objects/DpLicfld.js");
include("servis/date.js");
include("doc/DpDoc.js");
include("sys/servis.js");
include("add_licf.js");
include("add_sotr.js");

var Validation = true;
var tdb_sch = new DpSc();
var tcr_sch = new DpSc();
var tbl = new Object();
var edmode, m_fwid, ls_list, lv_list, le_list, kt_list, ke_list;
var isLicOk;
var sTblName = "VSRAZN";	// Имя таблицы, которую редактируем (значение по умолчанию)
var sMode = "RAZN"			// Режим по умолчанию

function onLoad()
{
   	var cod_kat = getPar("CODKAT");

	// разберемся с тем, с какими параметрами был вызван l_vsrazn.htm
	if(extPar && extPar.listPar && extPar.listPar.mode)
	{
		// вызывающему списку был передан extPar.mode
		sMode = extPar.listPar.mode;

		switch(sMode)
		{
			case "RAZN":
				sTblName = "VSRAZN";
				break;
			default:
				alert(ru("Неверный режим вызова: ","Невірний режим виклику: ")+extPar.mode);
				//CloseWindow();
				return false;
		}
	}	// end of if(extPar && extPar.listPar && extPar.listPar.mode)

	// Установим заголовок окна
	//
	var sCaption = "";
	switch(sMode)
	{
		case "RAZN":
			sCaption = "Настройка повного рознесення по рахунках|Настройка полной разноски по счетам";
			//Disable(mFid);
			//divFid.style.display = "none";
			tFid.text = "";
			mFid.setVisible(false);
			break;
	}
	Caption(sCaption, extPar.mode);

   	tdb_sch.setMode("c0utxyz");
   	//коды аналитики не линкуем, т.к. контрол не даст проставить текстовое значение FTABN
    tdb_sch.linkCtrl(mFdb_sc,mFdb_su,mFdb_st);

    tcr_sch.setMode("c0utxyz");
    tcr_sch.linkCtrl(mFcr_sc,mFcr_su,mFcr_st);

    ls_list = "";
    lv_list = "";
    le_list = "";
    kt_list = "";

	setFocus(mFnom);

	mFid.mask = "######";
	mFnom.mask = "######";
	mFnazv_op.mask = strRepl("&",255);
	mFrem.mask = strRepl("&",80);
	mFproc.mask = strRepl("&",255);

	tbl = extPar.tblSrc;
	if(!tbl)
		tbl = OpenTable("s", "select * from ^"+ sTblName);
		
	edmode = extPar.mode;
	m_fwid = 0;
	/*
	if (edmode == "EDIT" && !(tbl.Seek("=", extPar.fwid)))
	{
		alert("Не найдена запись. Редактирование невозможно");
		CloseWindow();
	}	
	if ((edmode=="EDIT" || edmode=="COPY")&& tbl.Seek("=", extPar.fwid)){
	// alert("Редактируем");
	}
	*/
	
	switch(edmode)
	{
		case "EDIT":
			//m_fwid = tbl.getValue("Fwid");
			mFnom.value = tbl.getValue("Fnom");
		case "COPY":
			if(edmode=="COPY")
				mFnom.value = getNextNom();
			mFid.value       = tbl.getValue("Fid");
			mFnazv_op.value  = tbl.getValue("Fnazv_op");
			mFrem.value  	 = tbl.getValue("Frem");
           	mFdbcr.checked 	 = toScrObj(tbl.getValue("Fis_sh"));
            //mFrassh.checked  = toScrObj(tbl.getValue("Fis_exp"));
            mFdb_cod1.value = tbl.getValue("Fdb_cod1");
    		mFdb_cod2.value = tbl.getValue("Fdb_cod2");
	    	mFdb_cod3.value = tbl.getValue("Fdb_cod3");
	    	mFcr_cod1.value = tbl.getValue("Fcr_cod1");
    		mFcr_cod2.value = tbl.getValue("Fcr_cod2");
    		mFcr_cod3.value = tbl.getValue("Fcr_cod3");

            vr_db_cod1 =  tbl.getValue("Fdb_cod1") 
            if (allt(tbl.getValue("Fdb_cod1"))=="FTABN")
            {
            	mFdbcr.checked = true;
                vr_db_cod1 = 0;
           	}
            vr_cr_cod1 =  tbl.getValue("Fcr_cod1") 
            if (allt(tbl.getValue("Fcr_cod1"))=="FTABN")
            {
            	mFdbcr.checked = false;
                vr_cr_cod1 = 0;
         	}
            tdb_sch.set(tbl.getValue("Fdb_sc"),tbl.getValue("Fdb_su"),tbl.getValue("Fdb_st")
            			,vr_db_cod1,tbl.getValue("Fdb_cod2"),tbl.getValue("Fdb_cod3"));
            tcr_sch.set(tbl.getValue("Fcr_sc"),tbl.getValue("Fcr_su"),tbl.getValue("Fcr_st")
            			,vr_cr_cod1,tbl.getValue("Fcr_cod2"),tbl.getValue("Fcr_cod3"));
			mFinval.value 	 = Number(tbl.getValue("Fgroup"));
			mFis_ogr.checked = toScrObj(tbl.getValue("Fis_ogr"));
            mFis_tabn.checked = toScrObj(tbl.getValue("Fis_tabn"));
			mFproc.value     = tbl.getValue("Fproc");
			mFprizn.value    = tbl.getValue("Fprizn");
			mFls_incl.value  = tbl.getValue("Fls_incl");
			mFls_excl.value  = tbl.getValue("Fls_excl");
			mFis_ls.checked  = toScrObj(tbl.getValue("Fis_ls"));
			mFlv_incl.value  = tbl.getValue("Flv_incl");
			mFlv_excl.value  = tbl.getValue("Flv_excl");
			mFis_lv1.checked = toScrObj(tbl.getValue("Fis_lv1"));
			mFis_lv2.checked = toScrObj(tbl.getValue("Fis_lv2"));
			mFis_lv3.checked = toScrObj(tbl.getValue("Fis_lv3"));
			mFis_lv4.checked = toScrObj(tbl.getValue("Fis_lv4"));
			mFkat_incl.value = tbl.getValue("Fkat_incl");
			mFkat_excl.value = tbl.getValue("Fkat_excl");
			mFis_kat.checked = toScrObj(tbl.getValue("Fis_kat"));
			mFexpr.value     = tbl.getValue("Fexpr");
			mFexp_incl.value = tbl.getValue("Fexp_incl");
			mFexp_excl.value = tbl.getValue("Fexp_excl");
			mFis_exp.checked  = toScrObj(tbl.getValue("Fis_exp"));
			break;
		
		case "ADD":
			mFid.value = getNextValue("","FID","",10);
			mFnom.value = getNextNom();
			mFnazv_op.value = "";
			mFrem.value  = "";
			mFdb_cod1.value = "";
    		mFdb_cod2.value = "";
	    	mFdb_cod3.value = "";
	    	mFcr_cod1.value = "";
    		mFcr_cod2.value = "";
    		mFcr_cod3.value = "";
            tdb_sch.set(0,0,0,0,0,0);
            tcr_sch.set(0,0,0,0,0,0);
            mFinval.value = 0;
            mFis_tabn.checked = false;
            mFis_ogr.checked = false;
            mFdbcr.checked = false;
            //mFrassh.checked = false;
			mFproc.value = "100";
			mFprizn.value = "";
			mFls_incl.value = "";
			mFls_excl.value = "";
			mFis_ls.checked = false;	
			mFlv_incl.value = "";
			mFlv_excl.value = "";
			mFis_lv1.checked = false;
			mFis_lv2.checked = false;
			mFis_lv3.checked = false;
			mFis_lv4.checked = false;
			mFkat_incl.value = "";
			mFkat_excl.value = "";
			mFis_kat.checked = false;
			break;
	}//end of switch(edmode){
	//mFis_ogr_valid();
	
	setValid(mFid, mFid_valid);		
	
	this.mFls_button = mFls_button;
	this.mFlse_button = mFlse_button;
	this.mFlv_button = mFlv_button;
	this.mFle_button = mFle_button;	
	this.mFkt_button = mFkt_button;
	this.mFke_button = mFke_button;
		
	setButton(mFls_incl, this, "mFls_button");	//Поле ЛС
	setButton(mFls_excl, this, "mFlse_button");
	setButton(mFlv_incl, this, "mFlv_button");	//Подразделение
	setButton(mFlv_excl, this, "mFle_button");
	setButton(mFkat_incl, this, "mFkt_button");	//Категория
	setButton(mFkat_excl, this, "mFke_button");
}//end of function Load(){

//============================================
// ksm 05.08.2004
function getNextValue(mode,fld,cond,step)
{
	strSQL = " SELECT MAX("+fld+") FROM ^"+ sTblName
			+(isEmpty(cond)?"":" WHERE "+cond)
	
	var oSnap = getSnap(strSQL);
	var nNum = step;
	if (oSnap!=null && oSnap[0]!=null)
	{
		nNum += oSnap[0];
	}
	oSnap = null;
	return	nNum;
}

//============================================
function getNextNom(mode)
{
	var num=10;
	//debug();
	if (sMode=="RAZN")
	{
		if (tbl.IsEmpty())
		{
			num = getNextValue("","FNOM","",1)
		}
		else
		{//end of if (tbl.IsEmpty())
			strSQL = " SELECT * FROM ^CL_FLV"
				+" WHERE "+sqlTo(extPar.m_pTable.getValue("FNOM"))+" BETWEEN FBNOM AND FENOM"
			var tblNom = OpenTable("s",strSQL)
			if (!tblNom.isEmpty())
			{
				//Добавим только 1
				num = getNextValue("","FNOM",
						"FNOM BETWEEN "
							+sqlTo(tblNom("FBNOM"))
								+" AND "+sqlTo(tblNom("FENOM")),1)
				//В промежуток помещаемся
				if (tblNom("FENOM")- num>9)
				{
					num += 9
				}
				else
				{
					alert("Внимание не хватает номеров разноски.\n"
						+" Зайдите в настройку подразделений и для подразделения с номерами в "
						+" диапазоне с "+tblNom("FBNOM")+" по "+tblNom("FENOM")
						+" увеличте конечный номер."
					);
				}//end of if (tblNom("FENOM")- num>9){
			}
			else
			{// end of if (!tblNom.Empty()){
				num = getNextValue("","FNOM","",10)
			}// end of else if (!tblNom.Empty()){
			tblNom.Close(5652);
		}////end of else if (tbl.IsEmpty()){
	}
	else
	{
		num = getNextValue("","FNOM","FID="+sqlTo(mFid.value),10)
	}
	return num;
}

//============================================
// ksm 27.09.2004
//============================================
// ksm 06.08.2004
function mFid_valid()
{
	if (isSaving())
	{
		return true;
	}
	strSQL = " SELECT Fid,FNOM "
			+"FROM ^"
					+sTblName
			+" WHERE "
					+" Fid="+sqlTo(mFid.value)
					+(extPar.fwid?" AND NOT FWID="+sqlTo(extPar.fwid):"")
	var oSnap = getSnap(strSQL);
	var retval = true;
	if (oSnap!=null && oSnap[0]!=null)
	{
		retval = false;
		WAIT(ru("Шаблон с номером "+oSnap[0]+" уже существует"
				,"Шаблон з номером "+oSnap[0]+" вже існує"))
	}
	oSnap = null;
	return retval;
}
//============================================

function mFls_button()
{   	
   	lse_list= "";
   	if (mFls_incl.value!="")
   	{
      	lse_list = mFls_incl.value+",";
   	}   	
   	mFls_incl.value = getLicList(lse_list);
   	return true;
}

function mFlse_button()
{   	
   	lse_list= "";
   	if (mFls_excl.value!="")
   	{
      	lse_list = mFls_excl.value+",";
   	}   	
   	mFls_excl.value = getLicList(lse_list);
   	return true;
}

function getLicList(lse_list)
{	
   	if (IsTable("TMP_LIC"))
   	{
      	ExecuteSQL("DELETE from TMP_LIC");
   	}
   	AddLicfld();
   	if (IsTable("TMP_LIC"))
   	{
      	ttte = OpenTable("s", "TMP_LIC");
      	if (!ttte.IsEmpty())
      	{
         	ttte.MoveFirst();
         	while (!ttte.IsEOF())
         	{
            	lse_list = lse_list + String(ttte.getValue("Fid"))+",";
            	ttte.MoveNext();
         	}  
         	lse_list = lse_list.substr(0, lse_list.length-1);
         	ExecuteSQL("DELETE from TMP_LIC");
      	}
      	ttte.Close(5652);
   	}
   	return lse_list;
}

function mFlv_button()
{
   	lv_list = "";
   	if (mFlv_incl.value!="")
   	{
      	lv_list = mFlv_incl.value+",";
   	}   	
   	mFlv_incl.value = getPodrList(lv_list);
   	return true;
}

function mFle_button()
{   	
   	lv_list = "";
   	if (mFlv_excl.value!="")
   	{
      	lv_list = mFlv_excl.value+",";
   	}   	
   	mFlv_excl.value = getPodrList(lv_list);
   	return true;
}	

function getPodrList(lv_list)
{   	 	
 	var  parpd = new Object();
   	parpd.dat1 = new Date(today.getFullYear(),today.getMonth(),1);
   	parpd.dat2 = new Date(today.getFullYear(),today.getMonth()+1,0);
   	
   	var listFwid = AddSotrPrk(parpd.dat1, parpd.dat2);   
   	
   	if(listFwid!="")
   	{
      	var ts = OpenTable("s", "select * from ^work_pers p "
      			+" inner join ^stru_dol d on p.fwid_dol=d.fwid "
      			+" inner join ^stru_org o on d.fwid_org=o.fwid"
      			+" where p.fwid in ("+ listFwid +")");
      	if (!ts.IsEmpty())
      	{      	 
         	ts.MoveFirst();   
         	if (ts.getValue("Flv1")==0 && ts.getValue("Flv2")==0 
         	 && ts.getValue("Flv3")==0 && ts.getValue("Flv4")==0)
         	{
            	return;
         	}
         	else
         	{
            	while (!ts.IsEOF())
            	{
               		var mFl1vpd = allt(String(ts.getValue("Flv1")));
               		var mFl2vpd = (ts.getValue("Flv2")!=0)?("/"+allt(String(ts.getValue("Flv2")))):"";
               		var mFl3vpd = (ts.getValue("Flv3")!=0)?("/"+allt(String(ts.getValue("Flv3")))):"";
               		var mFl4vpd = (ts.getValue("Flv4")!=0)?("/"+allt(String(ts.getValue("Flv4")))):"";
               		var pdrin =  mFl1vpd + mFl2vpd + mFl3vpd + mFl4vpd;
               		lv_list = lv_list+pdrin+",";
               		ts.MoveNext();
            	} 
         	}
      	}
      	ts.Close(5652);
      	lv_list = lv_list.substr(0, lv_list.length-1);     	
   	}
   	return lv_list;
}

function mFkt_button()
{   	
   	kt_list= "";
   	if (mFkat_incl.value!="")
   	{
   	   	kt_list = mFkat_incl.value+",";
   	}   	
   	mFkat_incl.value = getKatList(kt_list);
   	return true;
}

function mFke_button()
{   	
   	kt_list= "";
   	if (mFkat_excl.value!="")
   	{
   	   	kt_list = mFkat_excl.value+",";
   	}   	
   	mFkat_excl.value = getKatList(kt_list);
   	return true;
}

function getKatList(kt_list)
{   	   	
   	var  parpd = new Object();
   	parpd.dat1 = new Date(today.getFullYear(),today.getMonth(),1);
   	parpd.dat2 = new Date(today.getFullYear(),today.getMonth()+1,0);
   	
   	var listFwid = AddSotrPrk(parpd.dat1, parpd.dat2); 
   	   	
   	if(listFwid!="")
   	{
   		var kt = OpenTable("s", "select * from ^clrelclcl r "
   				+" inner join ^work_pers p on p.fwid_kat=r.fwid_cl "
   				+" where p.fwid in ("+ listFwid +")");
      	if (!kt.IsEmpty())
      	{ 
         	kt.MoveFirst();   
         	while (!kt.IsEOF())
         	{
            	var mFkt = kt.getValue("Fcod");
            	kt_list = kt_list + mFkt + ",";
            	kt.MoveNext();
         	} 
      	}	
      	kt.Close(5652);
      	kt_list = kt_list.substr(0, kt_list.length-1);      	
   	}
   	return kt_list;
}

function UnLoad()
{
   	//super vv ругалось на close
   	//alert("UnLoad.Close before");
   	//tbl.Close();
   	//alert("UnLoad.Close after");
}

function onSave()
{
	var m = new Object();
	
	if(edmode=="ADD" || edmode=="COPY")
		m.Fwid = GetUID();
   	
   	m.Fnom      = mFnom.value;
   	m.Fid       = mFid.value;
   	m.Fnazv_op  = mFnazv_op.value;
   	m.Frem      = mFrem.value;		
   	m.Fdb_sc	= tdb_sch.getSc();
   	m.Fdb_su	= tdb_sch.getSu();
   	m.Fdb_st	= tdb_sch.getSt();
   	m.Fdb_cod1	= mFdb_cod1.value;
   	m.Fdb_cod2	= mFdb_cod2.value;
   	m.Fdb_cod3	= mFdb_cod3.value;
   	m.Fcr_sc	= tcr_sch.getSc();
   	m.Fcr_su	= tcr_sch.getSu();
   	m.Fcr_st	= tcr_sch.getSt();
   	m.Fcr_cod1  = mFcr_cod1.value;
   	m.Fcr_cod2	= mFcr_cod2.value;
   	m.Fcr_cod3	= mFcr_cod3.value;	
   	m.Fgroup	= mFinval.value;
   	m.Fis_tabn	= mFis_tabn.checked;
   	m.Fis_ogr	= mFis_ogr.checked;
   	m.Fis_sh	= mFdbcr.checked;
   	//m.Fis_exp	= mFrassh.checked;
   	m.Fproc    	= Number(mFproc.value);
   	m.Fprizn    = mFprizn.value;
   	m.Fls_incl  = (mFls_incl.value=="")? ls_list : mFls_incl.value;
  	m.Fls_excl  = mFls_excl.value;
   	m.Fis_ls    = mFis_ls.checked;
   	m.Flv_incl  = mFlv_incl.value;
   	m.Flv_excl  = mFlv_excl.value;
   	m.Fis_lv1   = mFis_lv1.checked;
   	m.Fis_lv2   = mFis_lv2.checked;
  	m.Fis_lv3   = mFis_lv3.checked;
   	m.Fis_lv4   = mFis_lv4.checked;
   	m.Fkat_incl = mFkat_incl.value;
   	m.Fkat_excl = mFkat_excl.value;
   	m.Fis_kat   = mFis_kat.checked;
	m.Fexpr     = mFexpr.value;
	m.Fexp_incl = mFexp_incl.value;
	m.Fexp_excl = mFexp_excl.value;
	m.Fis_exp   = mFis_exp.checked;
   	UpdateTable("^"+ sTblName, m);
}