include("Objects/DpCl.js");

var tbl = extPar.m_pTable;
var mode = extPar.mode;

function onLoad()
{
	Caption(UR("Пільга|Льгота") +": "+ modeName(mode));
	
	FPRIVKOL.mask = MASK_KOL;
	FNORM.mask = MASK_KOL;
	FPRIVSUM.mask = MASK_SUM;
	FCENA.mask = MASK_CENA;
	FPERC.mask = "###";
	
	var oPriv = new DpCl("", getPar("CODLGT"), 0);
	oPriv.linkSmartCtrl(FPRIV);
	oPriv.setContAssist();
	
	if(mode!="ADD")
	{
		FSERV.value = tbl.getValue("FSERV");
		FBDATSERV.value = tbl.getValue("FSERVBDAT");
		FEDATSERV.value = tbl.getValue("FSERVEDAT");
		FFIO.value = tbl.getValue("FFIO");
		FBDATMEN.value = tbl.getValue("FBDAT");
		FEDATMEN.value = tbl.getValue("FEDAT");
		FPERC.value = tbl.getValue("FPRIVPERC");
		oPriv.setFWID(tbl.getValue("FID_LG"));
		FBDATPRIV.value = tbl.getValue("FBDATLG");
		FEDATPRIV.value = tbl.getValue("FEDATLG");
		FPRIVKOL.value = tbl.getValue("FPRIVKOL");
		FCENA.value = tbl.getValue("FCENA");
		FNORM.value = tbl.getValue("FNORM");
		FPRIVSUM.value = tbl.getValue("FPRIVSUM");
	}
	Disable(FSERV);
	Disable(FPRIV);
	
	setValid(FPRIVKOL, recalcSum);
	setValid(FPRIVSUM, recalcKol);
	setFocus(FPRIVSUM);
}

function recalcKol()
{
	FPRIVKOL.value = round(Number(FPRIVSUM.value)/Number(FCENA.value), getPar("DECIKOL"));
}

function recalcSum()
{
	FPRIVSUM.value = round(Number(FPRIVKOL.value)*Number(FCENA.value), getPar("DECIKOL"));
}

function onSave()
{
	var m	= new Object();
	if(mode!="EDIT")
		m.FWID	= GetUID();		
	else
		m.FWID = extPar.fwid;
	m.FPRIVKOL = FPRIVKOL.value;
	m.FPRIVSUM = FPRIVSUM.value;
	//updateTable(tbl.getTableName(), m);
	ExecuteSQL("update "+ tbl.getTableName() 
				+" set FPRIVKOL="+ m.FPRIVKOL +", FPRIVSUM="+ m.FPRIVSUM 
				+" where FID_MEN="+ tbl.getValue("FID_MEN") 
					+" and FID_PRIV="+ tbl.getValue("FID_PRIV")
					+" and FSERV="+ sqlTo(tbl.getValue("FSERV"))
					+" and FWID="+ sqlTo(m.FWID)
				);
}

include("sys/DpBaseDlg.js");