var taskManager = null;
var dpMTask = null;
var name = "";
var outHost = "";

var min = 1;
var hour = 60 * min;
var day = 24 * hour;
var week = 7 * day;

function onLoad()
{
	Caption(UR("Перегляд задач |Просмотр задач"), (extPar.isView ? "VIEW" : extPar.mode));
	taskManager = extPar.taskManager;
	if (taskManager == null)
		return false;
	
	DATE.value = new Date().getVarDate();
	TIME.value = new Date().getVarDate();
	
	switch (extPar.mode)
	{
		case "ADD":
			if(extPar)
			{ 
				if(extPar.command)
					COMMAND.value = extPar.command;
				if(extPar.name)
					NAME.value = extPar.name;
				if(extPar.param)
					PAR.value = extPar.param;
				if(extPar.type)
					TYPE.value = extPar.type;
				
				LOCAL.value = true;
				USER.value = getUserName();
			}
			break;
		case "EDIT":
		case "COPY":
			parDpTask = extPar.parentWnd.task;
			var id = extPar.m_pTable.getValue("fwid");
			var status = extPar.m_pTable.getValue("fstatus");
			dpMTask = evalFunction(extPar.parentWnd.task, "getDpMTask", new Array(id, status));
			USER.value = dpMTask.getToUser();
			HOST.value = dpMTask.getToHost();
			if (dpMTask.isLocal())
			{
				LOCAL.value = true;
				Disable(HOST);
			}
			var time = javaDate2Script(dpMTask.getTime(), true);
			DATE.value = time.getVarDate();
			TIME.value = time.getVarDate();
			REPIT.value = dpMTask.isCyclic();
			PERIOD.value = dpMTask.getPeriod();
			TYPE_PERIOD.setValue(getPeriodType(PERIOD.value));
			NAME.value = dpMTask.getName();
			COMMAND.value = dpMTask.getTaskContent().getCommand();	
			TYPE.value = dpMTask.getTaskContent().getType();
			PAR.value = dpMTask.getTaskContent().getPar();
			if (extPar.mode == "EDIT" && !extPar.isView)	
				Disable(REPIT);
			break;		
	}	
	setValid(REPIT, repit_valid);
	repit_valid();
	setValid(PERIOD, period_valid);
	setValid(LOCAL, local_valid);
	setValid(USER, to_valid);
	setValid(HOST, to_valid);
	setValid(DATE, date_valid);
	setValid(COMMAND, command_valid);
	setButton(LOADTASK, loadTask_valid);
	
	local_valid();
}

function onSave()
{
	switch (extPar.mode)
	{
		case "ADD":
			dpMTask = taskManager.getDefaultTask();
			break;
		case "COPY":
			dpMTask = dpMTask.clone(true);
			break;
	}
	
	dpMTask.setCyclic(REPIT.getValue());		

	if (extPar.mode == "COPY")
		extPar.mode = "ADD";
	
	dpMTask.setToUser(USER.getValue());
	dpMTask.setToHost(HOST.getValue());
	
	var date = javaDate2Script(DATE.getValue());
	var time = new Date(TIME.value);
	dpMTask.setTime(new Date(date.getFullYear(), date.getMonth(), date.getDate(),
			time.getHours(), time.getMinutes()));
	
	if (dpMTask.isCyclic())
		dpMTask.setPeriod(Number(PERIOD.getValue() * eval(String(TYPE_PERIOD.getValue()))));
	dpMTask.setName(NAME.getValue());
	dpMTask.setTask(COMMAND.getValue(), TYPE.getValue(), PAR.getValue());
		
	taskManager.addTask(dpMTask, extPar.mode);
	
	extPar.task = dpMTask;
}


function repit_valid()
{
	if (REPIT.getValue() == false)
		Disable(PERIOD, TYPE_PERIOD)
	else
	{
		Enable(PERIOD, true);
		Enable(TYPE_PERIOD, true);
	}
}

function local_valid()
{
	if (LOCAL.value == true)
	{
		outHost = String(HOST.value);
		HOST.value = taskManager.getHostName();
		Disable(HOST);
	}
	else
	{
		HOST.value = outHost;
		Enable(HOST, true);
	}
}

function period_valid()
{
	if (REPIT.value == false)
		return true;
	if (PERIOD.value > 0)
		return true;
	WAIT(UR("Період не може бути нульовим|Период не может быть нулевым"));
	return false;		
}

function to_valid()
{
	if (String(USER.value).length > 0)
		return true;
	else if (String(HOST.value).length > 0)
		return true;
	WAIT(UR("Призначте виконавця!|Назначте исполнителя!"));
	return false;
}

function date_valid()
{
	if (differ(toScriptDate(DATE.value), toScriptDate(d00)) != 0)
		return true;
	WAIT(UR("Призначте дату виконання|Назначте дату исполнения"));
	return false;
	
}

function loadTask_valid()
{
	var element = lpProxy.showDebetMenu(FORM.getShell());
	if (element == null)
		return;
	TYPE.setValue(element.getAttribute("type"));
	COMMAND.setValue(element.getAttribute("command"));
	PAR.setValue(element.getAttribute("par"));
	NAME.setValue(UR(element.getAttribute("ua") + "|" + element.getAttribute("ru")));
}

function command_valid()
{
	if (String(COMMAND.value).length > 0)
		return true;
	WAIT(UR("Призначте задачу|Назначте задачу"));
	return false;
}

function getPeriodType(period)
{
	var tmp = parseInt(period / week);
	if (tmp > 0)
		return "week";
	tmp = parseInt(period / day);
	if (tmp > 0)
		return "day";
	tmp = parseInt(period / hour);
	if (tmp > 0)
		return "hour";
	if (period > 0)
		return "min";
	return "day";
}

include("sys/DpBaseDlg.js");