include("objects\\DpPrintSelect.js");

var oldLabel = "";
var printSelect = null;

function Load()
{
	Caption("Змінна|Переменная",extPar.sMode);
	
	if (extPar.sMode == "EDIT" || extPar.sMode == "COPY")
	{
		VARNAME.setValue(extPar.varname);
		VARTEXT.setValue(extPar.vartext);
		VAREXPR.setValue(extPar.varexpr);
		if (extPar.sMode == "EDIT")
			oldLabel = extPar.varname;
	}
	
	if (!extPar.printSelect && (!extPar.sType || !extPar.sLabel))
	{
		alert("Недостаточно параметров");
		return false;
	}
	
	if (!extPar.printSelect)
		printSelect = new DpPrintSelect(extPar.sType,extPar.sLabel);
	else
		printSelect = extPar.printSelect;
	
	setValid(VARNAME,varname_valid);
	setValid(VAREXPR,varexpr_valid);
}

function varexpr_valid()
{
	var sExpr = allt(VAREXPR.getValue());
	if (sExpr == "")
	{
		VAREXPR.showErr("Значення виразу не може бути порожнім|"
						+ "Значение выражения не может быть пустым");
		return false;
	}
	return true;
}

function varname_valid()
{
	var sVarName = allt(VARNAME.getValue()).toUpperCase();
	VARNAME.setValue(sVarName);
	if (sVarName == "")
	{
		VARNAME.showErr("Введіть ім'я змінної|Введите имя переменной");
		return false;
	}
/*
	var sLetter = sVarName.substring(0,1);
	if (sLetter == "H" || sLetter == "R" || sLetter == "X" || sLetter == "F")
	{
		VARNAME.showErr("Ім'я змінної не повинно починатися з літер H,R,X,F|"
						+ "Имя переменной не должно начинаться с букв H,R,X,F");
		return false;
	}
*/
	if (!/^\s*[A-Za-z_][A-Za-z0-9_]*\s*$/.test(sVarName))
	{
		VARNAME.showErr("Ім'я змінної може складатися тільки з англійських літер та цифр|"
						+ "Имя переменной может состоять только из латинских букв и цифр");
		return false;
	}
	if (oldLabel == sVarName)
		return true;
	var varList = printSelect.getVarList(true);
	for (var nV = 0; nV < varList.length; nV++)
	{
		if (sVarName == allt(varList[nV].varName).toUpperCase())
		{
			VARNAME.showErr("Така змінна вже існує|Такая переменная уже существует");
			return false;
		}
	}
	return true;
}

function onSave()
{
	var sName = allt(VARNAME.getValue()).toUpperCase();
	var sExpr = allt(VAREXPR.getValue());
	var sDescr = allt(VARTEXT.getValue());
	if (extPar.sMode == "EDIT")
	{
		alert("???????");
		printSelect.delUserVar(oldLabel);
	}
	printSelect.addUserVar(sName,sExpr,sDescr);
	return true;
}