﻿include("objects\\DpSc.js");
include("objects\\DpCl.js");
include("objects\\DpClcl.js");
include("servis\\Date.js");

var Validation = true;

var edmode,m_fwid,tbl=new Object();

var schet,schet_to,schet_ob, cl, cl_to;
var schet_mode, schet_to_mode

var mFkind;
var tmpDistr = "TMP_ZAKR_R_DISTR";
var tblDistr;

// Константы для поля FKIND
var KIND_SL = 1;	//брать остаток
var KIND_OB = 2;	//брать оборот
var KIND_DB = 4;	//дебетовый
var KIND_CR = 8;	//кредитовый
var KIND_TURN = 16;	//сворачивать
var KIND_NOTURN = 32;	//сворачивать
var KIND_ZDB = 64;	//Закрываемый счет - по Дт
var KIND_ZCR = 128;	//Закрываемый счет - по Кт
var KIND_IGNORE_CL1 = 256;	// по всем аналитикам 1
var KIND_IGNORE_CL2 = 512;	// по всем аналитикам 2
var KIND_IGNORE_CL3 = 1024;	// по всем аналитикам 3
var KIND_ZERO_SL = 2048;	// Закрыть полностью (сальдо после закрытия==0)
var KIND_STORNO = 4096;     // Закрыть сторнирующей проводкой
var KIND_SUMOB = 8192;	// Брать конкретную сумму пропорционально оборотам
var KIND_SUMSL = 16384;	// Брать конкретную сумму пропорционально остаткам
var KIND_DEFAULT = KIND_SL | KIND_DB | KIND_TURN | KIND_ZCR;

function onAfterLoad()
{
	setValid(mFbdat, mFbdat_Valid);
	setValid(mFedat, mFedat_Valid);

	setValid(mFsposob, mFsposob_Valid);
	
	//fruckt
	//проценты перенесены в строки
	//setValid(mFproc, mFproc_Valid);
	
	setValid(mSLOB, mSLOB_Valid);
	mFsposob_Valid();
	mSLOB_Valid();
	if (extPar.mode=="EDIT")
	{
		setFocus(grid);
	}
	else
	{
		setFocus(mFnom);
	}
}

function Load()
{
	Caption(ru("Порядок закрытия счетов",
	"Порядок закриття рахункiв"),
	extPar.mode);

	schet=new DpSc("cutxyz0");
	schet_to=new DpSc("cutxyz0");
	schet_ob=new DpSc("c0");


	mFnom.mask='####';
	mFsc.mask='###';
	mFsu.mask='###';
	mFst.mask='######';
	mFcl1.mask='######';
	mFsc_to.mask='###';
	mFsu_to.mask='###';
	mFst_to.mask='######';
	mFcl1_to.mask='######';
	mFoborot_to.mask='###';

	mFgroup.mask='#####';
	mFexpr.mask = replicate("&", 255);
	mFproc.mask='-###.####';

	tbl = extPar.m_pTable;
	edmode = extPar.sMode;

	schet_to.setMode("cutxyz0");
	schet.linkCtrl(mFsc, mFsu, mFst, mFcl1, mFcl2, mFcl3);

	schet_to.linkCtrl(mFsc_to, mFsu_to, mFst_to, mFcl1_to, mFcl2_to, mFcl3_to);

	schet_ob.linkCtrl(mFoborot_to);

	switch(edmode)
	{
		case "EDIT":
		case "COPY":
			m_fwid=tbl.getValue("Fwid");
			schet.set(tbl.getValue('Fsc'),tbl.getValue('Fsu'),tbl.getValue('Fst')
				,tbl.getValue('Fcod1'), tbl.getValue('Fcod2'), tbl.getValue('Fcod3'));

			schet_to.set(tbl.getValue('Fsc_to'),tbl.getValue('Fsu_to'),tbl.getValue('Fst_to')
				,tbl.getValue('Fcod1_to') ,tbl.getValue('Fcod2_to') ,tbl.getValue('Fcod3_to'));

			schet_ob.set(tbl.getValue('Foborot_to'));
			mFsposob.value=tbl.getValue('Fsposob');
			mFnom.value=tbl.getValue('Fnom');
			mFbdat.value=tbl.getValue("Fbdat");
			mFedat.value=tbl.getValue("Fedat");
			mFexcl1.value=tbl.getValue("Fexcl1");
			mFexcl2.value=tbl.getValue("Fexcl2");
			mFexcl3.value=tbl.getValue("Fexcl3");

			mFgroup.value=tbl.getValue("Fgroup");
			mFexpr.value=tbl.getValue("Fexpr");
			mFproc.value=tbl.getValue("Fproc");
			mFkind = tbl.getValue("Fkind");
			mFrem.value = tbl.getValue("Frem");

			break;
		case "ADD":
			m_fwid=GetUID();//'fid';
			schet.set(0,0,0,0,0,0);
			schet_to.set(0,0,0,0,0,0);
			schet_ob.set(0);
			mFsposob.value='DISTR';

			strSQL = "SELECT MAX(FNOM) FROM ^ZAKRSC";
			sn = getSnap(strSQL);
			max = (sn != null && sn[0] != null) ? sn[0] : 0;
			mFnom.value=max-(max % 10) +10;

			mFexcl1.value="";
			mFexcl2.value="";
			mFexcl3.value="";

			mFgroup.value=mFnom.value;
			mFexpr.value="1";
			mFproc.value=100;
			mFkind = KIND_DEFAULT;

			mFbdat.value = firstDay(new Date());

			break;
	}

	// Отдельно обработаем для полей  mSLOB, mDBCR, mTurn

	if(mFkind&KIND_SL)
	{
		mSLOB.value="SL"
	}
	else if(mFkind&KIND_OB)
	{
		mSLOB.value="OB"
	}
	else if(mFkind&KIND_SUMOB)
	{
		mSLOB.value="SUMOB"
	}
	else if(mFkind&KIND_SUMSL)
	{
		mSLOB.value="SUMSL"
	}

	if(mFkind&KIND_DB)
	{
		mDBCR.value="DB"
	}
	else
	{
		mDBCR.value="CR"
	}

	if(mFkind&KIND_TURN)
	{
		mTurn.value="TURN"
	}
	else
	{
		mTurn.value="NOTURN"
	}

	if(mFkind&KIND_ZDB)
	{
		mZsc.value="DB"
	}
	else
	{
		mZsc.value="CR"
	}

	mIgn1.checked = new Boolean(mFkind & KIND_IGNORE_CL1).valueOf();
	mIgn2.checked = new Boolean(mFkind & KIND_IGNORE_CL2).valueOf();
	mIgn3.checked = new Boolean(mFkind & KIND_IGNORE_CL3).valueOf();
	mZeroSl.checked = new Boolean(mFkind & KIND_ZERO_SL).valueOf();
	mStorno.checked =  Boolean(mFkind & KIND_STORNO);
	
	DropTable(tmpDistr);
	strSQL = "SELECT * "
			+" INTO " + tmpDistr
			+" FROM ^ZAKRSC_R_DISTR"
			+" WHERE FID_DOC = " + sqlTo(m_fwid)
			+" AND (((FBDAT <= "+sqlTo(mFbdat.value)+" OR FBDAT = "+sqlTo(d00)+") AND (FEDAT >= "+sqlTo(mFedat.value)+" OR FEDAT = "+sqlTo(d00)+"))"
			+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
			+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
	ExecuteSQL(strSQL);

	tblDistr = OpenTable("m", tmpDistr);

	this.initGrid = _initGrid;
	this.initGrid();
	this.OnLoadMenu = OnLoadMenu;
	this.OnSelectMenu = OnSelectMenu;	
}


function _initGrid()
{
	divGrid.setVisible(true);
	grid.setTable(tblDistr);
	loadGrid(grid);
	
	ds = DataSource();
	grid.RefreshGrid();
	
	editAcc = new Function ("return 'ACE'");
	accDel = new Function ("return true");
	
	grid.loadMenuHandler(this,"OnLoadMenu");
	grid.selectMenuHandler(this,"OnSelectMenu");
	
	//fruckt
	grid.hideToolBar();
}

function loadGrid(oGrid)
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE", grid);
	oGrid.DeletePages();

	with(oGrid)
	{
		onePageMode(false);
		with (page(""))
		{
			with (group("Період дії|Период действия"))
			{
				cell("FBDAT", "початок|начало", 8);
				cell("FEDAT", "кінець|конец", 8);
			}
			//cell("FGROUP", "Група|Группа", 6);
			with (group("Рахунок, на який закривати|Счет, на который закрывать"))
			{
				cell("FSC_TO", "Рах.|Сч.", 5);
				cell("FSU_TO", "С/рах|С/сч", 5);
				cell("FST_TO", "Ст.|Ст.", 5);				
				cell("=(getTxtWithType(^Fcod1_type, ^Fcod1_to))", "Текст ан.1", 10);				
				cell("=(getTxtWithType(^Fcod2_type, ^Fcod2_to))", "Текст ан.2", 10);				
				cell("=(getTxtWithType(^Fcod3_type, ^Fcod3_to))", "Текст ан.3", 10);
			}
			
			if(mFsposob.getValue() == "DISTR")
			{
			cell("Fexpr", "Пропорційно чому розподіляти|пропорционально чему распределять", 8);
			}
			if(mFsposob.getValue() == "TRANSF")
			{
				cell("Fproc", "Процент", 8);
			}
		}
	}
	oGrid.build();
}

function OnLoadMenu()
{
	switch (String(mFsposob.getValue()))
	{
		case "DISTR":
			grid.AddMenuItem ("MKDISTR_OB","Додати рядки закриття пропорційно обігам(залишкам) рахунку, на який закриваємо|Добавить строки закрытия пропорционально оборотам(остаткам) счета, на к-й закрываем");
			grid.AddMenuItem ("MKDISTR_KOR","Додати рядки закриття пропорційно обігам кориспонденції рахунків|Добавить строки закрытия пропорционально оборотам кореспонденции счетов");
			grid.AddMenuItem("","");
		break;
		default:
		break;
	}
	
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}

function OnSelectMenu(nID)
{
	var par = new Object();
	par.id_doc = m_fwid;
	par.bdat = mFbdat.value;
	par.edat = mFedat.value;
	par.mode = nID;
	par.tbl = tmpDistr;
	par.m_pTable = grid.getTable();
	par.sposob = String(mFsposob.getValue());

	switch(nID)
	{
		case "DEL":
			ExecuteSQL("Delete From " + tmpDistr
						+ " Where Fwid=" + sqlTo(grid.getTable().getValue("Fwid")));
			bm = tblDistr.bookmark;
			tblDistr.Requery();
			tblDistr.bookmark = bm;
			grid.RefreshGrid(RG_SAVEROW);
			//grid.RefreshGrid(true);
			break;
		case "__XDEL":
			var delRowCount = grid.getSelectedCount();
			if (delRowCount <= 0)
			{
				return;
			}
			
			var sCapt = ru("Удаление записей", "Видалення записів");
			var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + delRowCount + ").";
			if("c"==msgBox("c-", sMsg, sCapt))
			{
				return;
			}
			var sSQL = "DELETE FROM " +tmpDistr+ " WHERE " + grid.sqlSelected();
			ExecuteSQL(sSQL);
			bm = tblDistr.bookmark;
			tblDistr.Requery();
			tblDistr.bookmark = bm;
			grid.RefreshGrid(RG_SAVEROW);
			break;
		case "ADD":
		case "COPY":
		case "EDIT":
			showWindow("e_rzak_distr.xml",SW_MODAL,par);
			bm = tblDistr.bookmark;
			tblDistr.Requery();
			tblDistr.bookmark = bm;
			grid.RefreshGrid(RG_SAVEROW);
			//grid.RefreshGrid(true);
			break;
		case "MKDISTR_OB":
			//Створити закриття пропорційно обігам рахунку, на який закриваємо

			var oR = new Object();
			oR.FID_DOC = m_fwid;

			if (grid.getTable().recordCount>0)
			{
				if (!confirm(UR("У налаштуванні вже є рядки. Видалити?|В настройке уже есть строки. Удалить?")))
				{
					//return;
				}
				else
				{
					strSQL = "DELETE FROM "+tmpDistr;
					ExecuteSQL(strSQL);
				}
			}
			//Для начала спросим исходные данные
			include("objects\\DpEval.js");
			include("objects\\DpAskEx.js");
			var oA = new DpAskEx();
			oA.add("C0UT", "Рахунок, на який закривати|Счет,на к-й закрывать", "SC_TO", "0|0|0");
			oA.add("COMBO", "Пропорційно чому закривати|Пропорционально чему закрывать", "SL_OB", 0, ru("оборотам","обігам")+"|"+ru("остаткам","залишкам"));
			oA.add("COMBO", "Пропорційно обігам(залишкам) по |Пропорционально оборотам(остаткам) по ", "TO_DBCR", 0, "дебету|кредиту");
			oA.add("HR", "", "HR1");
			oA.add("COMBO", "Групувати до аналітики №|Групировать до аналитики №", "GR_AN", 2, "1|2|3");
			oA.add("CLCL", "№ довідника видів затрат|№ справочника видов затрат ", "NUM_ZATR", 3);
			oA.add("REM", "Вкажіть через кому список кодів видів затрат|Укажите через запятую список кодов видов затрат ", "R1");
			oA.add("REM", "обіги по яких потрібно відняти від загального обігу|обороты по которым следует отнять от общего оборота", "R2");
			oA.add("T0", "Список кодів витрат ч/з кому:|Список кодов затрат ч/з запятую:", "ANLIST", "", 50);
			oA.doAsk()
			if (oA.escape)
			{
				return;
			}
			oR.FSC_TO = oA.get("SC_TO").getSc();
			oR.FSU_TO = oA.get("SC_TO").getSu();
			oR.FST_TO = oA.get("SC_TO").getSt();
			oR.FBDAT = new Date(par.bdat);
			oR.FEDAT = new Date(par.edat);
			var grAn = oA.get("GR_AN")+1;
			sprZatr = oA.get("NUM_ZATR").getCod();
			var anList = oA.get("ANLIST");
			var oSlOb = oA.get("SL_OB");
			var oDbCr = oA.get("TO_DBCR");
			//Защита от дурака
			//1) Уберем не цифры и не запятые
			anList = anList.replace(/[^0-9,]/g, "");
			//2) а теперь уберем запятые спереди и сзади 
			anList = anList.replace(/(^\,)|(\,$)/g, "");
			//3) и, наконец, заменим несколько подряд идущих запятых на одну
			anList = anList.replace(/\,+/g, ",");

			//произведем расчет оборотов и остатков по счету,
			//на который закрываем
			include("TrnNBln.js");
			WAIT(UR("Выполняется расчет|Виконується розрахунок"));
			var obName = "MKDISTR_OB";
			TrnNBln("3n"
				, obName
				, oR.FBDAT 
				, oR.FEDAT
				, new DpSc(oR.FSC_TO, oR.FSU_TO, oR.FST_TO)
			);
			// узнаем на какой аналитике у нас привязан справочник затрат
			strSQL = "SELECT FCL1, FCL2, FCL3 FROM ^CL_SCHET"
					+" WHERE FSCHET = "+sqlTo(oR.FSC_TO)
					+" AND FSUBSCHET = "+sqlTo(oR.FSU_TO)
					+" AND FSTAT = "+sqlTo(oR.FST_TO)
			var sn = getSnap(strSQL);
			var zatrAn = 0;
			if (sn != null)
			{
				switch (sprZatr)
				{
					case sn[0]:
						zatrAn = 1;
						break;
					case sn[1]:
						zatrAn = 2;
						break;
					case sn[2]:
						zatrAn = 3;
						break;
				}
			}
			sn = null;
			strAnalit = (grAn==1 ? "S.FCL_COD1" : (grAn==2?"S.FCL_COD1, S.FCL_COD2" : (grAn==3?"S.FCL_COD1, S.FCL_COD2, S.FCL_COD3" : "")));
			//теперь выберем из нашей т-цы все кроме аналитик, которые не нужны
			strSQL = "SELECT "
				+IIF(oDbCr+"=0",IIF(oSlOb+"=0"," SUM(S.FSUM5) "," SUM(S.FSUM3) "),IIF(oSlOb+"=0"," SUM(S.FSUM6) "," SUM(S.FSUM4) "))+" AS FSUM"
				+", S.FSC "
				+", S.FSU "
				+", S.FST "
				+", "+strAnalit
			+" FROM "			
				+" "+obName+" S "
				+(anList!="" && zatrAn!=0 ? " WHERE S.FCL_COD"+zatrAn+" NOT IN("+anList+")" : "")
			+" GROUP BY "
				+" S.FSC "
				+", S.FSU "
				+", S.FST "
				+", "+strAnalit
			+" ORDER BY "
				+" S.FSC "
				+", S.FSU "
				+", S.FST "
				+", "+strAnalit
			tsc   = OpenTable("s", strSQL);
			for( tsc.MoveFirst(); !tsc.IsEOF(); tsc.MoveNext())
			{
				if (toScrObj(tsc.getValue("FSUM")) == 0)
				{
					continue;
				}
				oR.FSC_TO = tsc.getValue("FSC");
				oR.FSU_TO = tsc.getValue("FSU");
				oR.FST_TO = tsc.getValue("FST");
				oR.FCOD1_TO = tsc.getValue("FCL_COD1");
				oR.FCOD2_TO = (grAn>=2? tsc.getValue("FCL_COD2") : 0);
				oR.FCOD3_TO = (grAn==3? tsc.getValue("FCL_COD3") : 0);
				oR.FEXPR = String(tsc.getValue("FSUM"));
				oR.FGROUP = 0;
				//получим новый FWID
				oR.FWID = GetUID();
				//и теперь добавляем строку
				updateTable(tmpDistr, oR, true);
			}
			tsc.close(5652);
			tsc = null;
			tblDistr.Requery();
			grid.RefreshGrid(true);
			grid.setFocus();
			CLEARWAIT();
			break;
		case "MKDISTR_KOR":
			//Створити закриття пропорційно обігам рахунку, на який закриваємо

			var oR = new Object();
			oR.FID_DOC = m_fwid;

			if (grid.getTable().recordCount>0)
			{
				if (!confirm(UR("У налаштуванні вже є рядки. Видалити?|В настройке уже есть строки. Удалить?")))
				{
					//return;
				}
				else
				{
					strSQL = "DELETE FROM "+tmpDistr;
					ExecuteSQL(strSQL);
				}
			}
			//Для начала спросим исходные данные
			include("objects\\DpEval.js");
			include("objects\\DpAskEx.js");
			var oA = new DpAskEx();
			oA.add("C0UT", "Рахунок, на який закривати|Счет,на к-й закрывать", "SC_TO", "0|0|0");
			oA.add("C0UT", "Кореспондуючий рахунок|Кореспондирующий счет", "SC_KOR", "66|661|0");
			oA.add("COMBO", "Пропорційно обігам по |Пропорционально оборотам по ", "TO_DBCR", 0, "дебету|кредиту");
			oA.add("HR", "", "HR1");
			oA.add("COMBO", "Групувати до аналітики №|Групировать до аналитики №", "GR_AN", 2, "1|2|3");
			oA.add("CLCL", "№ довідника видів затрат|№ справочника видов затрат ", "NUM_ZATR", 3);
			oA.add("REM", "Вкажіть через кому список кодів видів затрат|Укажите через запятую список кодов видов затрат ", "R1");
			oA.add("REM", "обіги по яких потрібно відняти від загального обігу|обороты по которым следует отнять от общего оборота", "R2");
			oA.add("T0", "Список кодов затрат ч/з запятую:", "ANLIST", "", 50);
			oA.doAsk()
			if (oA.escape)
			{
				return;
			}
			oR.FSC_TO = oA.get("SC_TO").getSc();
			oR.FSU_TO = oA.get("SC_TO").getSu();
			oR.FST_TO = oA.get("SC_TO").getSt();
			oR.FBDAT = new Date(par.bdat);
			oR.FEDAT = new Date(par.edat);
			korSc = oA.get("SC_KOR").getSc();
			korSu = oA.get("SC_KOR").getSu();
			korSt = oA.get("SC_KOR").getSt();
			var grAn = oA.get("GR_AN")+1;
			sprZatr = oA.get("NUM_ZATR").getCod();
			var anList = oA.get("ANLIST");
			var oDbCr = oA.get("TO_DBCR");
			//Защита от дурака
			//1) Уберем не цифры и не запятые
			anList = anList.replace(/[^0-9,]/g, "");
			//2) а теперь уберем запятые спереди и сзади 
			anList = anList.replace(/(^\,)|(\,$)/g, "");
			//3) и, наконец, заменим несколько подряд идущих запятых на одну
			anList = anList.replace(/\,+/g, ",");

			sKor = oDbCr==0?"FDB":"FCR";
			sZakr = oDbCr==0?"FCR":"FDB";

			// узнаем на какой аналитике у нас привязан справочник затрат
			strSQL = "SELECT FCL1, FCL2, FCL3 FROM ^CL_SCHET"
					+" WHERE FSCHET = "+sqlTo(korSc)
					+" AND FSUBSCHET = "+sqlTo(korSu)
					+" AND FSTAT = "+sqlTo(korSt)
			var sn = getSnap(strSQL);
			var zatrAn = 0;
			if (sn != null)
			{
				switch (sprZatr)
				{
					case sn[0]:
						zatrAn = 1;
						break;
					case sn[1]:
						zatrAn = 2;
						break;
					case sn[2]:
						zatrAn = 3;
						break;
				}
			}
			sn = null;
			strAnalit = (grAn==1 ? "S."+sZakr+"_COD1" : (grAn==2?"S."+sZakr+"_COD1, S."+sZakr+"_COD2" : (grAn==3?"S."+sZakr+"_COD1, S."+sZakr+"_COD2, S."+sZakr+"_COD3" : "")));

			// выберем из проводок то, что нужно
			strSQL = "SELECT SUM(S.FSUM) AS FSUM"
				+", S."+sZakr+"_SC , S."+sZakr+"_SU , S."+sZakr+"_ST "
				+", "+strAnalit
			+" FROM  ^SCHET S"
			+" WHERE S."+sZakr+"_SC="+sqlTo(oR.FSC_TO)
				+ sqlw0And("S."+sZakr+"_SU=", +sqlTo(oR.FSU_TO))
				+ sqlw0And("S."+sZakr+"_ST=", +sqlTo(oR.FST_TO))
				+" AND S."+sKor+"_SC="+sqlTo(korSc)
				+ sqlw0And("S."+sKor+"_SU=", +sqlTo(korSu))
				+ sqlw0And("S."+sKor+"_ST=", +sqlTo(korSt))
				+(anList!="" && zatrAn!=0 ? " AND S."+sKor+"_COD"+zatrAn+" NOT IN("+anList+")" : "")
			+" GROUP BY "
				+"  S."+sZakr+"_SC , S."+sZakr+"_SU , S."+sZakr+"_ST "
				+", "+strAnalit
			+" ORDER BY "
				+"  S."+sZakr+"_SC , S."+sZakr+"_SU , S."+sZakr+"_ST "
				+", "+strAnalit
			tsc   = OpenTable("s", strSQL);
			for( tsc.MoveFirst(); !tsc.IsEOF(); tsc.MoveNext())
			{
				oR.FSC_TO = tsc.getValue(sZakr+"_SC");
				oR.FSU_TO = tsc.getValue(sZakr+"_SU");
				oR.FST_TO = tsc.getValue(sZakr+"_ST");
				oR.FCOD1_TO = tsc.getValue(sZakr+"_COD1");
				oR.FCOD2_TO = (grAn>=2? tsc.getValue(sZakr+"_COD2") : 0);
				oR.FCOD3_TO = (grAn>=2? tsc.getValue(sZakr+"_COD3") : 0);
				oR.FEXPR = String(tsc.getValue("FSUM"));
				oR.FGROUP = 0;
				//получим новый FWID
				oR.FWID = GetUID();
				//и теперь добавляем строку
				updateTable(tmpDistr, oR, true);
			}
			tsc.close(5652);
			tsc = null;
			tblDistr.Requery();
			grid.RefreshGrid(true);
			grid.setFocus();
			CLEARWAIT();
			break;
	}
}

function UnLoad()
{
}


function onSave()
{
	var m = new Object();
	switch(edmode)
	{
		case "EDIT":
			break;
		case "ADD" :
			m.FWID = m_fwid;
			break;
		case "COPY":
			m.FWID = GetUID();
			m_fwid = m.FWID;
			break;
		default:
			return;
	}
	if (edmode=="COPY")
	{
		if (!tblDistr.isEmpty())
		{
			for(tblDistr.MoveFirst(); !tblDistr.IsEOF(); tblDistr.MoveNext())
			{
				tblDistr.Edit();
				tblDistr.setValue("FWID", GetUID());
				tblDistr.Update();
			}
		}
	}
	
	strSQL = "UPDATE " + tmpDistr+" SET FID_DOC = " + sqlTo(m_fwid);
	ExecuteSQL(strSQL);
	
	strSQL = "DELETE FROM ^ZAKRSC_R_DISTR WHERE FID_DOC = " +sqlTo(m_fwid)
			+" AND (((FBDAT <= "+sqlTo(mFbdat.value)+" OR FBDAT = "+sqlTo(d00)+") AND (FEDAT >= "+sqlTo(mFedat.value)+" OR FEDAT = "+sqlTo(d00)+"))"
			+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
			+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO ^ZAKRSC_R_DISTR SELECT * FROM "+ tmpDistr
	ExecuteSQL(strSQL);
	
	// Вид закрытия
	mFkind=0;
	if(mSLOB.value=="SL")
	{
		mFkind = mFkind | KIND_SL
	}
	else if(mSLOB.value=="OB")
	{
		mFkind = mFkind | KIND_OB
	}
	else if(mSLOB.value=="SUMOB")
	{
		mFkind = mFkind | KIND_SUMOB
	}
	else if(mSLOB.value=="SUMSL")
	{
		mFkind = mFkind | KIND_SUMSL
	}

	if(mDBCR.value=="DB"){
	mFkind = mFkind | KIND_DB
	} else {
	mFkind = mFkind | KIND_CR
	}
	
	if(mTurn.value=="TURN"){
	mFkind = mFkind | KIND_TURN
	} else {
	mFkind = mFkind | KIND_NOTURN
	}
	
	if(mZsc.value=="DB")
	{
		mFkind = mFkind | KIND_ZDB
	}
	else
	{
		mFkind = mFkind | KIND_ZCR
	}
	if(mIgn1.checked)
	{
		mFkind = mFkind | KIND_IGNORE_CL1
		//m.Fexcl1="";
	}	
	
	if(mIgn2.checked)
	{
		mFkind = mFkind | KIND_IGNORE_CL2
		//m.Fexcl2="";
	}
	
	
	if(mIgn3.checked)
	{
		mFkind = mFkind | KIND_IGNORE_CL3
		//m.Fexcl3="";
	}	
	
	if(mZeroSl.checked)
	{
		mFkind = mFkind | KIND_ZERO_SL
	}
	if (mStorno.checked)
	{
		mFkind |= KIND_STORNO;
	}

	m.Fexcl1=mFexcl1.value;
	m.Fexcl2=mFexcl2.value;
	m.Fexcl3=mFexcl3.value;
	m.Fnom = mFnom.value;
	m.Fbdat = mFbdat.value;
	m.Fedat = mFedat.value;
	m.Fsc = schet.getSc();
	m.Fsu = schet.getSu();
	m.Fst = schet.getSt();
	m.Fcod1 = schet.getCl1();
	m.Fcod2 = schet.getCl2();
	m.Fcod3 = schet.getCl3();
	
	if (mFsposob.value != "DOOC" && mFsposob.value != "DISTR")
	{
		m.Fsc_to = schet_to.getSc();
		m.Fsu_to = schet_to.getSu();
		m.Fst_to = schet_to.getSt();
		m.Fcod1_to = schet_to.getCl1();
		m.Fcod2_to = schet_to.getCl2();
		m.Fcod3_to = schet_to.getCl3();
	}
	else
	{
		m.Fsc_to = 0;
		m.Fsu_to = 0;
		m.Fst_to = 0;
		m.Fcod1_to = 0;
		m.Fcod2_to = 0;
		m.Fcod3_to = 0;
	}
	
	m.Foborot_to = schet_ob.getSc();
	m.Fsposob = mFsposob.value;
	m.Fgroup = mFgroup.value;
	m.Fexpr = mFexpr.value;
	m.Fkind = mFkind;
	m.Fproc = mFproc.value;
	m.Frem = mFrem.value;
	UpdateTable("^zakrsc",m,edmode != "EDIT");
}

function onEscape()
{
   extPar.escape=true;
}


function mFedat_Valid()
{
	if (mFedat.value>=d00 && mFedat.value<=d00)
	{
		
	}
	else if (differ(mFedat.value, mFbdat.value)<0)
	{
		WAIT(ru("Дата конца периода не может быть меньше даты начала", "Дата закінчення періоду не може бути меншою за дату початку"));
		mFedat.value=mFbdat.value;
		return false;
	}
	if (!isSaving)
	{
		strSQL = "DELETE FROM "+tmpDistr
			+" WHERE NOT ((FBDAT <="+sqlTo(mFbdat.value)+" AND FEDAT>="+sqlTo(mFedat.value)+")"
				+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
				+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO "+tmpDistr
			+" SELECT * FROM ^ZAKRSC_R_DISTR "
			+"WHERE FID_DOC = " + sqlTo(m_fwid)
				+" AND ((FBDAT <="+sqlTo(mFbdat.value)+" AND FEDAT>="+sqlTo(mFedat.value)+")"
				+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
				+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
				+" AND NOT FWID IN (SELECT FWID FROM "+tmpDistr+")"
		ExecuteSQL(strSQL)
		tblDistr.Requery();
		grid.RefreshGrid(true);
	}
	return true;
}


function mFbdat_Valid()
{
	if (mFbdat.value>=d00 && mFbdat.value<=d00)
	{
		WAIT(ru("Введите дату начала периода", "Введіть дату початку періоду"));
		return false;
	}

	if (differ(mFedat.value, mFbdat.value)<0)
	{
		WAIT(ru("Дата окончания периода не может быть меньше даты начала", "Дата закінчення періоду не може бути меншою за дату початку"));
		mFedat.value=mFbdat.value;
		return false;
	}
	if (!isSaving)
	{
		strSQL = "DELETE FROM "+tmpDistr
			+" WHERE NOT ((FBDAT <="+sqlTo(mFbdat.value)+" AND FEDAT>="+sqlTo(mFedat.value)+")"
				+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
				+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO "+tmpDistr
			+" SELECT * FROM ^ZAKRSC_R_DISTR "
			+"WHERE FID_DOC = " + sqlTo(m_fwid)
				+" AND ((FBDAT <="+sqlTo(mFbdat.value)+" AND FEDAT>="+sqlTo(mFedat.value)+")"
				+" OR (FBDAT >="+sqlTo(mFbdat.value)+" AND FBDAT<="+sqlTo(mFedat.value)+")"
				+" OR (FEDAT >="+sqlTo(mFbdat.value)+" AND FEDAT<="+sqlTo(mFedat.value)+"))"
				+" AND NOT FWID IN (SELECT FWID FROM "+tmpDistr+")"
		ExecuteSQL(strSQL)
		tblDistr.Requery();
	}
	return true;
}

//контроль суммы процентов по группе в методе TRANSF
function mFproc_Valid()
{
	switch (String(mFsposob.getValue()))
	{
		case "TRANSF":
			var proc = 0;
			strSQL = " SELECT"
							+" SUM(FPROC)"
						+" FROM"
							+" "+tmpDistr
						+" WHERE 1 = 1"
			var aSnap = getSnap(strSQL);
			if (!isEmpty(aSnap) && !isEmpty(aSnap[0]))
			{
				proc = round(aSnap[0],0);
			}

			if (proc != 100)
			{
				msg = ru("Общая сумма процентов по данной группе должна равнятся 100!"
						,"Загальна сума процентів по даній групі повинна бути рівною 100!")
				WAIT(msg);
				return false;
			}
		break;
		default:
		break;
	}

	return true;
}
// Предназначена для "зажигания"
// только "нужных" контролов

function mFsposob_Valid()
{
	var sposob = String(mFsposob.getValue());

	switch(sposob){
	case "SOBR":
	case "TRAN":
		showOborot_to("");
		showSc("cutxyz");
		showSc_to("cutxyz");

		divGroup.setVisible(false);
		divGrid.setVisible(false);

		divExpr.setVisible(false);

		divWhat.setVisible(false);

		divSLOB.setVisible(false);
		divDBCR.setVisible(false);
		divTurn.setVisible(false);
		divZsc.setVisible(false);
		divZeroSl.setVisible(false);
		divStorno.setVisible(false);

		divProc.setVisible(false);
		schet_to.setMode("cutxyz0");
		
		break;
	case "SOBR1":
		showOborot_to("");
		showSc("cutxyz");
		showSc_to("cutxyz");

		divGroup.setVisible(false);
		divGrid.setVisible(false);

		divExpr.setVisible(false);

		divWhat.setVisible(true);

		divSLOB.setVisible(false);
		divDBCR.setVisible(true);
		divTurn.setVisible(false);
		divZsc.setVisible(false);
		divZeroSl.setVisible(false);
		divStorno.setVisible(true);

		divProc.setVisible(false);
		schet_to.setMode("cutxyz0");
		break;
	case "RASP":
		showOborot_to("c")
		showSc("cutxyz");
		showSc_to("cutxyz");

		divGroup.setVisible(false);
		divGrid.setVisible(false);

		divExpr.setVisible(false);

		divWhat.setVisible(false);

		divSLOB.setVisible(false);
		divDBCR.setVisible(false);
		divTurn.setVisible(false);
		divZsc.setVisible(false);
		divProc.setVisible(false);
		divZeroSl.setVisible(false);
		divStorno.setVisible(false);
		schet_to.setMode("cutxyz0");

		break;
	case "DISTR":
		showOborot_to("")
		showSc("cutxyze");
		showSc_to("");

		divGroup.setVisible(false);
		divGrid.setVisible(true);

		divExpr.setVisible(false);

		divWhat.setVisible(true);

		divSLOB.setVisible(true);
		divDBCR.setVisible(true);
		divTurn.setVisible(true);
		divZsc.setVisible(true);
		divProc.setVisible(true);
		divZeroSl.setVisible(false);
		divStorno.setVisible(false);

		mSLOB.setEnabled(true);
		//schet_to.setMode("cutxyz0");
		schet_to.setMode("c0utxyz");
		break;
	case "DOOC":
		showOborot_to("")
		showSc("cutxyzie");
		showSc_to("");

		divGroup.setVisible(false);
		divGrid.setVisible(false);

		divExpr.setVisible(false);

		divWhat.setVisible(true);

		divSLOB.setVisible(true);
		divDBCR.setVisible(true);
		divTurn.setVisible(false);

		divZsc.setVisible(false);

		divProc.setVisible(true);
		divZeroSl.setVisible(true);
		divStorno.setVisible(false);

		// Способ DOOC работает только с оборотами
		mSLOB.value="OB"
		mSLOB.setEnabled(false);
		schet_to.setMode("c0utxyz");
		break;

	case "TRANSF":
		showOborot_to("")
		//fruckt
		//нам впринципе никакие счета в заголовке не нужны
		//showSc("cutxyzie");
		//showSc_to("cutxyz");
		showSc("cutxyz");
		showSc_to("");

		//fruckt
		//divGroup.setVisible(true);
		//divGrid.setVisible(false);
		divGroup.setVisible(false);
		divGrid.setVisible(true);

		divExpr.setVisible(false);

		divWhat.setVisible(true);

		divSLOB.setVisible(true);
		divDBCR.setVisible(true);
		divTurn.setVisible(false);

		divZsc.setVisible(false);
		
		//fruckt
		//divProc.setVisible(true);
		divProc.setVisible(false);
		
		divZeroSl.setVisible(false);
		divStorno.setVisible(false);

		// Способ DOOC работает только с оборотами
		mSLOB.value="OB"
		mSLOB.setEnabled(false);
		schet_to.setMode("c0utxyz");
	break;

	default:
		alert("Способ "+sposob+" не поддерживается")
		break;
	}

	loadGrid();
	var shell = FORM.ctrlComp.getShell();
	//var size = shell.computeSize(-1,-1,true);
	//shell.setSize(size);
	shell.pack();
	//Перерисуем окно
	var pnt = div1;
	pnt.redraw();
	pnt.layout(true);

	//fruckt
	var ret = mFproc_Valid();
	return ret;
}

function mSLOB_Valid()
{
	var slob = mSLOB.value;
	switch(slob)
	{
		case "SL":
		case "OB":
			divTproc.value ="Процент";
			break;
		case "SUMOB":
		case "SUMSL":
			divTproc.value ="Сумма";
			break;
	}
}

// Зажигает-тушит контролы, касающиеся закрываемого счета
// mode	[c][u][t][x][y][z][i][e]
// "i" - рядом с аналитикой колонка "Любая"
// "e" - рядом с аналитикой колонка "Исключить коды"
// если mode=="", то тушим все
function showSc(mode){
	mode = mode.toLowerCase();
	var isIgn = strIn("i", mode)
	var isExcl = strIn("e", mode)
	// сначала все тушим
	divHsc.setVisible(false);
	divSc.setVisible(false);
	divSu.setVisible(false);
	divSt.setVisible(false);
	divCl1.setVisible(false);
	divCl2.setVisible(false);
	divCl3.setVisible(false);
	divIgn1.setVisible(false);
	divIgn2.setVisible(false);
	divIgn3.setVisible(false);
	divExcl1.setVisible(false);
	divExcl2.setVisible(false);
	divExcl3.setVisible(false);

	// а теперь зажгем только то, что нужно
	if(mode==""){
		divHsc.setVisible(false);
	}
	else
	{
		divHsc.setVisible(true);
	}

	if( strIn("c", mode) )
	{
		divSc.setVisible(true);
	}
	if( strIn("u", mode) )
	{
		divSu.setVisible(true);
	}
	if( strIn("t", mode) )
	{
		divSt.setVisible(true);
	}
	if( strIn("x", mode) )
	{
		divCl1.setVisible(true);
		if(isIgn){
			divIgn1.setVisible(true);
		}
		if(isExcl){
			divExcl1.setVisible(true);
		}
	}
	if( strIn("y", mode) )
	{
		divCl2.setVisible(true);
		if(isIgn)
		{
			divIgn2.setVisible(true);
		}
		if(isExcl){
			divExcl2.setVisible(true);
		}
	}
	if( strIn("z", mode) )
	{
		divCl3.setVisible(true);
		if(isIgn)
		{
			divIgn3.setVisible(true);
		}
		if(isExcl){
			divExcl3.setVisible(true);
		}
	}
}

// Зажигает-тушит контролы, касающиеся счета "Куда"
// mode	[c][u][t][x][y][z]
// если mode=="", то тушим все
function showSc_to(mode){
	mode = mode.toLowerCase();

	// сначала все тушим
	divHsc_to.setVisible(false);
	divSc_to.setVisible(false);
	divSu_to.setVisible(false);
	divSt_to.setVisible(false);
	divCl1_to.setVisible(false);
	divCl2_to.setVisible(false);
	divCl3_to.setVisible(false);

	// а теперь зажгем только то, что нужно
	if(mode==""){
		divHsc_to.setVisible(false);
	} else {
		divHsc_to.setVisible(true);
	}

	if( strIn("c", mode) ){
		divSc_to.setVisible(true);
	}
	if( strIn("u", mode) ){
		divSu_to.setVisible(true);
	}
	if( strIn("t", mode) ){
		divSt_to.setVisible(true);
	}
	if( strIn("x", mode) ){
		divCl1_to.setVisible(true);
	}
	if( strIn("y", mode) ){
		divCl2_to.setVisible(true);
	}
	if( strIn("z", mode) ){
		divCl3_to.setVisible(true);
	}
}

// Зажигает-тушит контролы, касающиеся счета "Оборот"
// mode	[c]
// если mode=="", то тушим все
function showOborot_to(mode)
{
	if (mode == "")
	{
		divOborot_to.setVisible(false);
		return;
	}
	divOborot_to.setVisible(true);
	return;
}

function getTxtWithType(type, value)
{
	type = String(type);
	mode = type.split(":")[0].toUpperCase();
	value = toScrObj(value);
	var retVal = "";	
	
	switch (mode)
	{
		case "CL":
			var nCl = isNaN(Number(type.split(":")[1])) ? 0 : Number(type.split(":")[1]);
			var oSn = getSnap("SELECT FTXT"
							+" FROM ^LISTCL"
							+" WHERE 1=1"
								+" AND FCL = "+sqlTo(nCl)
								+" AND FCOD = "+sqlTo(isNaN(Number(value)) || isEmpty(value) ? -1 : Number(value)));
			if(oSn)
			{
				retVal = value+":"+oSn[0];
			}
			else
			{
				retVal = value;
			}
			oSn = null;
		break;
		
		case "NMKL":
			var oSn = getSnap("SELECT FCOD, FTXTS"
							+" FROM ^CL_NMK"
							+" WHERE 1=1"
								+" AND FWID = "+sqlTo(isNaN(Number(value)) || isEmpty(value) ? -1 : Number(value)));
			if(oSn)
			{
				retVal = oSn[0]+":"+oSn[1];
			}
			else
			{
				retVal = value;
			}
			oSn = null;
		break;
		
		case "CNTRCT":
			var oSn = getSnap("SELECT FDOG_NUM, FTXT"
							+" FROM ^CONTRACT"
							+" WHERE 1=1"
								+" AND FWID = "+sqlTo(isNaN(Number(value)) || isEmpty(value) ? -1 : Number(value)));
			if(oSn)
			{
				retVal = oSn[0]+":"+oSn[1];
			}
			else
			{
				retVal = value;
			}
			oSn = null;
		break;		
		
		default:
			retVal = value;
		break
	}
	
	return retVal;
}