include("Objects/DpzDoc.js");
include("Objects/DpCl.js");
include("doc/DpDoc.js");

var sTitle = UR("Повний список документів|Полный список документов");
var sTmpTbl = getTmpTableName();
var sErrorTbl = getTmpTableName();
var listName = "FULLDOCLIST";
var oThread;
var tblDocs;
var dpzDoc;
var dat1;
var dat2;
var oOrg;
var isStop = false;
var arrTbl = new Array();
var arrSys = new Array();
var arrDoc = new Array();
var arrNop = new Array();
var arrUser = new Array();
var arrError = new Array();
var cod_org;

function listLoad()
{
	this.title = sTitle;
	if(GetMenuMode()=="ORG")
	{
		include("Objects/DpAskEx.js");
		var oAsk = new DpAskEx();
		oAsk.add("CL","Код контрагенту","ORG",0,getPar("CODPLAT"));
		oAsk.doAsk();
		if(oAsk.escape)
			return false;
		cod_org = oAsk.get("ORG").getCod();
	}
	
	if(SUBD==MSSQL)
		sTmpTbl = "TMP_FULLDOCS";
	
	setButton(BTN_STOP, stopThread);
	
	tblDocs = OpenTable("select * from ^CL_LNK where FNOP=0");
	
	dpzDoc = new DpzDoc("", 0, null, true);
	dpzDoc.canEmpty = true;
	dpzDoc.linkCtrlNop(NOP);
	dpzDoc.linkSmartCtrl(DOC);
	dpzDoc.setContAssist();	
	dpzDoc.subUpdate = aplyFilter;
	DOC.value = "";
	NOP.value = dpzDoc.allTxt;
	if(extPar && extPar.doc)
		dpzDoc.setCod(extPar.doc);
	if(extPar && extPar.nop)
		dpzDoc.setDocNop(extPar.nop);
		
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	if(extPar && extPar.bdat)
		DATB.value = extPar.bdat;
	if(extPar && extPar.edat)
		DATE.value = extPar.edat;
	if(differ(DATB.value, d00min)==0)
		DATB.value = d00;
	this.datValid = datValid;
	setValid(DATB, this, "datValid");
	setValid(DATE, this, "datValid");
	
	this.getSystems = getSystems;
	setButton(FSYS, this, "getSystems");
	FSYS.getBtn().setToolTipText(UR("Вибрати системи|Выбрать системы"));
	if(extPar && extPar.sys)
		FSYS.value = extPar.sys;
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.AfterUpdate = aplyFilter;
	if(extPar && extPar.org)
		oOrg.setCod(extPar.org);
	if(cod_org)
	{
		oOrg.setCod(cod_org);
		Disable(FORG);
	}
		
	if(extPar && extPar.onlyMy!=null)
		ONLYMY.checked = extPar.onlyMy;
	
	BTN_CLEAR_FILTER.setImage(lpProxy.getWrkDir() +"/icons/undo.gif");
	BTN_CLEAR_FILTER.getCtrl().setToolTipText(UR("Скидання фільтру|Сброс фильтра"));
	setButton(BTN_CLEAR_FILTER, clearFilter);
	setButton(BTN_FILTER, aplyFilter);
	setValid(TYPEPER, onChangePeriod);
	
	this.hintErrorList = hintErrorList;	
	FORM.getDialogBuilder().setToolItemSelection(BTNHINTERROR, this, "hintErrorList");	
	
	createTblOut();
}

function listTitle()
{
	return sTitle;
}

function listAfterLoad()
{
	PROGRESSBAR.setMinimum(0);
	PROGRESSBAR.setMaximum(tblDocs.recordCount+3);
	PROGRESSBAR.setSelection(1);
	oThread = runInThread(fillDocs);
	
	this.gridERRORMenuInit = gridERRORMenuInit;
	this.gridERRORMenuRun = gridERRORMenuRun;
	gridERROR.loadMenuHandler(this, "gridERRORMenuInit");
	gridERROR.selectMenuHandler(this, "gridERRORMenuRun");
	gridERROR.defCond("FALL", "=^FDOCCOUNT>0");
	gridERROR.color(16, "FALL");	
}

function gridERRORMenuInit(oGrid)
{
	if(IsDblClick(oGrid))
	{
		gridERRORMenuRun("RUN", oGrid);
		return true;
	}
	oGrid.AddMenuItem("RUN", UR("Виконати SQL-запрос|Выполнить SQL-запрос"));
}

function gridERRORMenuRun(sID, oGrid)
{
	var tbl = oGrid.getTable();
	if(sID=="RUN")
	{
		var sTable = tbl.getValue("FTABLE");
		var sQuery = String(tbl.getValue("FQUERY"));
		sQuery = sQuery.substring(0, sQuery.lastIndexOf("from")+5);
		sQuery += " ^"+ sTable;
		ExecuteSQL(sQuery);
	}
}

function listSrc()
{	
	var sWhere = "1=1";
	
	if(oOrg.getCod())
		sWhere += " and FORG="+ oOrg.getCod();
	
	if(String(FSYS.value).trim()!="")
	{
		var sys = String(FSYS.value).trim().split("_");
		sWhere += " and (UPPER(FSYS) like '%"+ sys[0].toUpperCase() +"%'";
		for(var i=1; i<sys.length; i++)
			sWhere += " or UPPER(FSYS) like '%"+ sys[i].toUpperCase() +"%'";
		//sWhere += " or UPPER(FSYS)='COM' or FSYS="+ sqlEmpStr
		sWhere += ")";
	}
	
	if(String(DOC.value).trim()!="")
		sWhere += " and UPPER(FDOC)="+ sqlTo(String(DOC.value).trim().toUpperCase());
	if(NOP.value && String(NOP.value).trim()!="" && String(NOP.value).trim()!=dpzDoc.allTxt)
		sWhere += " and FNOP in ("+ NOP.value +")";
	
	dat1 = DATB.value;
	dat2 = DATE.value;
	if(differ(dat1, d00)<0)		
		sWhere += " and FDOC_DAT>="+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and FDOC_DAT<="+ sqlTo(dat2);
	
	if(ONLYMY.checked)
	{
		sWhere += " and UPPER(FUSER)="+ sqlTo(getUserName().toUpperCase());
		/*
		sWhere += " and FID_DOC in (select max(FID_DOC) from ^ARCHIVE"
				+" where UPPER(FMUSER)="+ sqlTo(getUserName().toUpperCase()) 
				+" and (FMACTION='A' or FMACTION='C'))";
		*/
	}	
	
	if(extPar && extPar.subWhere)
		sWhere += " and ("+ extPar.subWhere +")";
	
	list.qrySet("From", listName
				, "Order", "FDOC_DAT, FDOC, FNOP"
				, "Where", sWhere
				);
}

function getSystems()
{
	var par = new Object();
	par.sys = FSYS.value;
	showWindow("sys_choice.xml", SW_MODAL, par);
	if(!par.escape)
	{
		FSYS.value = par.sys;
		aplyFilter();
	}
}

function datValid()
{
	TYPEPER.value="-";
}

function aplyFilter()
{
	if(!list.grid)
		return;
	
	INFO.setText(UR("Завантаження списку . . . |Загрузка списка . . . "));
	list.init(true);
	grid.setFocus();
	grid.getTable().setAbsolute(1);
	INFO.setText(UR("Відібрано документів: |Отобрано документов: ") + grid.getTable().recordCount);
}

function clearFilter()
{
	oOrg.setCod(0);
	FSYS.value = "";
	DOC.value = "";
	NOP.value = dpzDoc.allTxt;
	DATB.value = d00;
	DATE.value = d00;
	TYPEPER.value = "ALL";
	ONLYMY.checked = false;
	aplyFilter();
	INFO.setText(UR("Завантажено документів: |Загружено документов: ") + grid.getTable().recordCount);
}

function hintErrorList()
{
	GRERROR.setVisible(false);
	FORM.Refresh();
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00;
			DATE.value = d00;
			break;
		default:
			break;
	}
	aplyFilter();
}

function createTblOut()
{
	ExecuteSQL("drop view "+ listName, false);
	ExecuteSQL("drop table "+ sTmpTbl, false);
	ExecuteSQL("create table "+ sTmpTbl 
				+" (FDOC "+ SqlType("TEXT", 50) 
				+", FNOP "+ sqlType("INT") 
				//+", FTXT "+ sqlType("TEXT", 254)
				//+", FDOC_TXT "+ sqlType("TEXT", 254)  
				+", FID_DOC "+ sqlType("LONG")
				+", FID_DOG "+ sqlType("LONG")
				+", FWID "+ sqlType("COUNTER")
				+", FDOC_DAT "+ sqlType("DATE") 
				+", FDOC_NUM "+ sqlType("TEXT")
				+", FORG "+ sqlType("LONG")
				//+", FORG_TXT "+ sqlType("TEXT")
				+", FSUM "+ sqlType("DOUBLE")
				+", FTABLE "+ sqlType("TEXT")
				//+", FSYS "+ sqlType("TEXT")
				+", FSYS_TXT "+ sqlType("TEXT")
				//+", FUSER "+ sqlType("TEXT")
				+")");
	createIndex(sTmpTbl, "FID_DOC", "FID_DOC");
	createIndex(sTmpTbl, "FDOC_DAT", "FDOC_DAT");
	createIndex(sTmpTbl, "FDOC", "FDOC");
	createIndex(sTmpTbl, "FNOP", "FNOP");
	createIndex(sTmpTbl, "FORG", "FORG");
	//createIndex(sTmpTbl, "FUSER", "FUSER");
		
	sSQL = "select t.*, lnk.FTXT as FTXT, lnk0.FTXT as FDOC_TXT, lnk.FSYS"
				+", cl.FTXT as FORG_TXT, a.FMUSER as FUSER"
			+" from "+ sTmpTbl +" t "
			+" left join ^CL_LNK lnk on lnk.FDOC=t.FDOC and lnk.FNOP=t.FNOP"
			+" left join ^CL_LNK lnk0 on lnk0.FDOC=t.FDOC and lnk0.FNOP=0"
			+" left join ^LISTCL cl on cl.FCOD=t.FORG and cl.FCL=0"
			+" left join ^ARCHIVE a on a.FID_DOC=t.FID_DOC and (a.FMACTION='A' or a.FMACTION='C') and a.FVER<2"
	createView(listName, sSQL);
}

function listDpGridEx(grid)
{
	with(grid)
	{	
		with(page())
		{
			with(group("Тип документу|Тип документа"))
			{
				cell("FDOC", "Мітка|Метка", 10);
				cell("FDOC_TXT", "Назва|Название", 15);
			}
			with(group("Папка|Папка"))
			{
				cell("FNOP", "№", 5);
				cell("FTXT", "Назва|Название", 15);
				//cell("=nopTxt(^FDOC, ^FNOP)", "Назва|Название", 15);
			}
			cell("FDOC_NUM", "     №\nдокумента", 12);
			cell("FDOC_DAT", "   Дата\nдокумента", 12);
			with(group("Контрагент|Контрагент"))
			{
				cell("FORG", "Код|Код", 5, null, "", 1, "CLS.CL2", "FCOD");
				cell("FORG_TXT", "Назва|Наименование", 15);
			}
			cell("FSUM", "Сума|Сумма", 10, null, DP_FORMAT_SUM);
			with(group("Система|Система"))
			{
				cell("FSYS", "Мітка|Метка", 8);
				cell("=sysTxt(^FSYS)", "Назва|Название", 15);
			}
			cell("=getDogNumByID(^Fid_dog)", "№ договору|№ договора", 10);
			cell("FUSER", "Користувач|Пользователь", 10);
			//cell("=userTxt(^FID_DOC)", "Користувач|Пользователь", 10);
			//cell("=nomDogToXML(^Fid_dog)", "№ договору|№ договора", 10);
			if(getPar("IS_DEBUG"))
			{
				cell("FID_DOC", "ID|ID", 10);
				cell("Fid_dog", "ID дог.|ID дог.", 10);
				cell("FTABLE", "Таблиця|Таблица", 10);
			}
		}		
	}	
}

function fillDocs()
{
	var nDoc = 1;
	arrSys = getArrSys();
	
	ExecuteSQL("drop table "+ sErrorTbl, false);
	ExecuteSQL("create table "+ sErrorTbl 
			+" (FDOC "+ sqlType("TEXT")
			+", FTABLE "+ sqlType("TEXT")
			+", FQUERY "+ sqlType("LONGTEXT")
			+", FERROR "+ sqlType("LONGTEXT")
			+", FDOCCOUNT "+ sqlType("LONG")
			+", FWID "+ sqlType("COUNTER")
			+")", false
			);
	
	for(tblDocs.MoveFirst(); !tblDocs.isEOF(); tblDocs.MoveNext())
	{
		try
		{
			if(isStop)
				return;
			var doc = String(tblDocs.getValue("FDOC")).toUpperCase();

			if (String(getAccess(doc)) == "")
			{
				continue;
			}

			var oDoc = new DpDoc(doc, 0);
			var tblName = oDoc.getTableName();			
//			var docArray = new Array();
//			if(arrTbl[tblName])
//				docArray = arrTbl[tblName];
			var sOrgFld = oDoc.getOrgField();
			if(doc=="GP")
				sOrgFld = "FDBKR";
			var sSumFld = oDoc.getFieldName("HSUM");
			if(doc=="NN")
				sSumFld = oDoc.getFieldName("HSUM_20");
			var sDocName = UR(oDoc.getName());
			var sys = String(oDoc.getSys()).toUpperCase();
			var sysName	= arrSys[sys.split("_")[0]];
			oDoc.sysName = sysName;
			if(sys=="COM")
				sys = "";			
//			docArray[docArray.length] = oDoc;
			trace("\n>>> "+ doc +" > "+ tblName+"  sSumFld > "+sSumFld);
			arrDoc[doc] = oDoc;
			moveProgress();
//			if(arrTbl[tblName])
//			{
//				arrTbl[tblName] = docArray;				
//				continue;
//			}
//			arrTbl[tblName] = docArray;
			
			var isDog = true;
			var snap = getSnap("select MIN(Fid_dog) from ^"+tblName+" where 1<>1", false);
			if(!snap || oDoc.instanceOf("COM.DEBET.DOGOVOR"))
				isDog = false;
			var sSQL = "insert into "+ sTmpTbl 
							+" (FDOC, FNOP, FID_DOC, "+(isDog?"Fid_dog, ":"")+" FDOC_DAT, FDOC_NUM"
								+", FTABLE, FORG, FSUM) "
							+" select FDOC, FNOP, FWID, "+(isDog?"Fid_dog, ":"")+"FDOC_DAT, FDOC_NUM"
								+", "+ sqlTo(tblName)
								+", "+ (sOrgFld? sOrgFld : "0") 
								+", "+ (sSumFld? sSumFld : "0")								
							+" from ^"+ tblName
							+" where Fdoc="+sqlTo(doc)//для разных документов поле суммы может быть разным, поэтому записи добавляем строго по типу
								+(cod_org?" and "+(sOrgFld?sOrgFld+"="+cod_org:"1<>1"):"")
			var bRet = ExecuteSQL(sSQL, false);
			//updateTxt(false, doc);			
			if(!bRet)
			{
				var docCount = 0;
				var oSnap = getSnap("select count(*) as cnt from ^"+ tblName, false);
				if(oSnap && oSnap[0])
					docCount = Number(oSnap[0]);				
				var sError = lpProxy.getDBManager().getLastErrorMessage();
				arrError[arrError.length] = sError;
				var sSql = "insert into "+ sErrorTbl 
							+" (FDOC, FTABLE, FDOCCOUNT, FERROR, FQUERY) "
							+" values ("+ sqlTo(doc) 
								+", "+ sqlTo(tblName) 
								+", "+ sqlTo(docCount)
								+", "+ sqlTo(sError)
								+", "+ sqlTo(sSQL) 
								+")"
				ExecuteSQL(sSql, false);				
			}
			refreshGrid();		
		}
		catch(e){}
	}
	stopProgress(true);	
}

function stopThread()
{
	if(oThread)
	{
		oThread.stop();
		oThread = null;
	}
	runInThread(stopProgress);
}

function moveProgress()
{
	display.asyncExec
	(
		function run()
		{						
			try
			{					
				var nPr = PROGRESSBAR.getSelection()+1;
				PROGRESSBAR.setSelection(nPr);
			}
			catch(e){}
		}
	);
}

function stopProgress(bMoveProgress)
{	
	if(isStop)
		return;	
	isStop = true;	
	display.asyncExec
	(
		function run()
		{						
			try
			{
				INFO.setText(UR("Завантаження списку . . . |Загрузка списка . . . "));
				grid.getTable().requery();
				grid.refresh();
				var recordCount = grid.getTable().recordCount;
				var oSnap = getSnap("select count(*) as cnt from "+ sTmpTbl);
				var sMsg = UR("Звантажено документів: |Загружено документов: ") + recordCount;
				if(Number(recordCount)<Number(oSnap[0]))
					sMsg = UR("Звантажено документів: |Загружено документов: ") + oSnap[0]
							+"	"+ UR("Відібрано: |Отобрано: ") + recordCount;						
				INFO.setText(sMsg);
				PROGRESSBAR.setSelection(PROGRESSBAR.getMaximum());
				GRPROGRESS.setVisible(false);
				grid.setFocus();				
			}
			catch(e){}
		}
	);	
}

function updateTxt(bMoveProgress, sDoc)
{	
	if(SUBD==MSSQL || SUBD == POSTGRE)
		ExecuteSQL("update "+ sTmpTbl +" set "+ sTmpTbl +".FORG_TXT=("
					+"select max(^CL.FTXT) "
					+" from ^CL inner join ^CLRELCLCL on ^CLRELCLCL.FWID_CL=^CL.FWID "
					+" where ^CLRELCLCL.FCOD="+ sTmpTbl +".FORG "
						+" and ^CLRELCLCL.FCL=0)"
					+(sDoc? " where UPPER("+ sTmpTbl +".FDOC)="+ sqlTo(sDoc.toUpperCase()) : "")
					, false);
	else
		ExecuteSQL("update "+ sTmpTbl +" t set t.FORG_TXT=(select max(cl.FTXT) "
					+" from ^CL cl inner join ^CLRELCLCL rel on rel.FWID_CL=cl.FWID "
					+" where rel.FCOD=t.FORG and rel.FCL=0)"
					+(sDoc? " where UPPER(t.FDOC)="+ sqlTo(sDoc.toUpperCase()) : "")
					, false);
	if(bMoveProgress)
		moveProgress();
		
	if(SUBD==MSSQL || SUBD == POSTGRE)
		ExecuteSQL("update "+ sTmpTbl +" set "+ sTmpTbl +".FUSER=("
					+"select max(^ARCHIVE.FMUSER) "
					+" from ^ARCHIVE "
					+"where ^ARCHIVE.FID_DOC="+ sTmpTbl +".FID_DOC "
						+" and UPPER(^ARCHIVE.FMACTION)='A')"
					+(sDoc? " where UPPER("+ sTmpTbl +".FDOC)="+ sqlTo(sDoc.toUpperCase()) : "")
					, false);
	else
		ExecuteSQL("update "+ sTmpTbl +" t set t.FUSER=(select max(a.FMUSER) "
					+" from ^ARCHIVE a where a.FID_DOC=t.FID_DOC "
						+" and UPPER(a.FMACTION)='A')"
					+(sDoc? " where UPPER(t.FDOC)="+ sqlTo(sDoc.toUpperCase()) : "")
					, false);
	if(bMoveProgress)
		moveProgress();	
}

function refreshGrid()
{
	try
	{
		if(arrError.length>0)
		{
			display.asyncExec
			(
				function run()
				{						
					try
					{					
						var oSnap = getSnap("select count(*) as cnt from "+ sErrorTbl +" where FDOCCOUNT>0", false);
						if(oSnap && Number(oSnap[0])>0)
						{
							if(gridERROR.getTable())
							{
								gridERROR.getTable().requery();
								gridERROR.refresh();
							}
							else
							{
								var tblError = OpenTable("select * from "+ sErrorTbl +" order by FDOC");
								gridERROR.setTable(tblError);
								gridERROR.build();
							}
							GRERROR.setVisible(true);							
						}
					}
					catch(e){}
				}
			);
		}
		
		var oSnap = getSnap("select count(*) as cnt from "+ sTmpTbl);
		var recordCount = Number(list.tbl.recordCount);
		if(recordCount>1000 || Number(oSnap[0])>10000 || Number(oSnap[0])==recordCount)
		{
			display.asyncExec
			(
				function run()
				{						
					try
					{					
						INFO.setText(UR("Завантажено документів: |Загружено документов: ") + oSnap[0]);
					}
					catch(e){}
				}
			);
			return;		
		}		
	}
	catch(e){}
	
	display.asyncExec
	(
		function run()
		{
			try
			{
				trace("\n>>> refreshGrid: "+ (isStop))
				if(isStop)
					return;				
				grid.getTable().requery();
				grid.getTable().setAbsolute(1);
				grid.refresh();
				grid.getTableControl().setSelection(1, 1, true);
				INFO.setText(UR("Завантажено документів: |Загружено документов: ") + grid.getTable().recordCount);
				if(!oThread)
					isStop = true;
			}
			catch(e)
			{
				
			}
		}
	);
}

function listMenuInit(oGrid)
{
	var tbl = oGrid.getTable();
	var doc = tbl.getValue("FDOC");
	if (!tbl.isEmpty())
	{
		if(doc && String(doc).trim()!="")
		{
			if(IsDblClick())
			{
				listMenuRun("VIEW_DOC", oGrid);
				return true;
			}
			oGrid.AddMenuItem("FIND_DOC", "Знайти документ|Найти документ");
			oGrid.AddMenuItem("VIEW_DOC", "Відкрити документ|Открыть документ");
			oGrid.AddMenuItem("VIEW_FOLDER", "Відкрити папку|Открыть папку");			
		}
		if(getPar("IS_DEBUG"))
			oGrid.AddMenuItem("VIEW_TABLE", "Відкрити таблицю|Открыть таблицу");
	}
}

function listMenuRun(sID, oGrid)
{
	if(!oGrid)
		return;
	var tbl = oGrid.getTable();
	var doc = tbl.getValue("FDOC");
	var nop = tbl.getValue("FNOP");
	var docID = tbl.getValue("FID_DOC");
	if(sID=="VIEW_DOC")
	{
		var oDoc = new DpDoc(doc, nop);
		oDoc.edit("VIEW", docID);
		return true;
	}
	if(sID=="FIND_DOC")
	{
		var par = new Object();
		par.doc = doc;
		par.nop = nop;
		par.fid_doc = docID;
		//WriteParEx("ONLYMYDOC", 0);
		showWindow("l_docekz.xml", SW_NOMODAL, par);
		return true;
	}
	if(sID=="VIEW_FOLDER")
	{
		var par = new Object();
		par.doc = doc;
		par.nop = nop;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
		return true;
	}
	if(sID=="VIEW_TABLE")
	{
		if(tbl.getValue("FTABLE"))
			browse(String(tbl.getValue("FTABLE")));
		return true;
	}
}

function userTxt(fid_doc)
{
	if(arrUser[fid_doc])
		return arrUser[fid_doc];
	var user = "";
	var oSnap = getSnap("select FMUSER from ^ARCHIVE where FID_DOC="+ fid_doc +" and (FMACTION='A' or FMACTION='C')");
	if(oSnap)
		user = oSnap[0];
	arrUser[fid_doc] = user;
	return user;
}

function docTxt(doc)
{
	if(arrDoc && arrDoc[doc])
		return UR(arrDoc[doc].getName());
	return "";
}

function nopTxt(doc, nop)
{
	if(arrNop[doc] && arrNop[doc][nop])
		return arrNop[doc][nop];
	var sTxt = UR(tdoc(doc, nop));
	if(!arrNop[doc])
		arrNop[doc] = new Object();
	arrNop[doc][nop] = sTxt;
	return sTxt;
}

function sysTxt(sys)
{
	if(sys)
		sys = String(sys).split("_")[0];
	if(sys=="COM" || sys=="" || !sys)
		return UR("Усі|Все");
	if(sys && arrSys && arrSys[sys])
		return arrSys[sys];
	return "";
}

function getArrSys()
{
	var arrSys = new Array();
	var sysList = lpProxy.getOrgManager().getSysList();
	for(var i=0; i<sysList.size(); i++)
	{
		var sys = sysList.get(i);			
		if(sys)
			arrSys[sys.label] = UR(sys.name);		
	}
	return arrSys;
}

function listUnLoad()
{
	if(oThread)
		oThread.stop();
	isStop = true;
	list.tbl.close();
	ExecuteSQL("drop view "+ listName, false);
	ExecuteSQL("drop table "+ sTmpTbl, false);
}

function filterMode(mnuID)
{
	var tbl = grid.getTable();
	var doc = toScrObj(tbl.getValue("FDOC"));
	var nop = toScrObj(tbl.getValue("FNOP"));
	var acc = String(getAccess(doc, nop));
	
	if (mnuID == "ADD" && acc.indexOf("A") == -1 )
		return false;
	
	if (mnuID == "EDIT" && acc.indexOf("E") == -1 )
		return false;
		
	if (mnuID == "DEL" && acc.indexOf("D") == -1 )
		return false;
		
	if (mnuID == "COPY" && acc.indexOf("A") == -1 )
		return false;
		
	if (mnuID == "XDEL" && acc.indexOf("D") == -1 )
		return false;
	
	return true;
}

include("sys/DpList.js");
