include("sys/udfs.js");
include ("Objects/DpRSS.js");
var url = null;
function gadgetLoad()
{		
	if(Task.getMenuMode())
		url = String(Task.getMenuMode());
	if (extPar && extPar.rssURL)
		url = extPar.rssURL;
	this.tbl = createObjectTable();
	
	grid.setTable(this.tbl);
	grid.build();
	gadgetRefresh();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function gadgetRefresh()
{
	var thr = new java.lang.Thread(
			function func()
			{
				var newTbl = fillNewsTableTable();
				display.syncExec
				(
					function fnk()
					{
						grid.setTable(newTbl);
						newTbl.moveFirst();
						grid.refresh();
					}
					
				)
				
			}
		);
	
	thr.start();
}

function fillNewsTableTable()
{
	this.tbl = createObjectTable();
	this.tbl.setIdFld("FWID"); 
	if (url == null || !url)
		return this.tbl;
	
	var arrURL = url.split(";");
	for (var i = 0; i < arrURL.length; i++)
		addRss(arrURL[i], this.tbl);
	
	
	
	return this.tbl;
}

function addRss(urlRSS, tbl)
{
	include ("Objects/DpRSS.js");
	var oRss = new DpRSS();
	//oRss.parseRSS("http://www.debet.kiev.ua/rss.xml")
	var isParse = oRss.parseRSS(urlRSS);
	if (!isParse)
		return;
	
	tbl.AddNew();
	tbl.setValue("FTITLE", oRss.title);		
	tbl.setValue("FLINK", oRss.link);
	tbl.setValue("FDESCRIPTION", oRss.description);
	tbl.setValue("FPUBDATE", d00);	
	tbl.setValue("FTT", 1);	
	tbl.Update();
	
	var items = oRss.rssItems;
	
	for (var i = 0; i < items.length; i++)
	{
		tbl.AddNew();
		tbl.setValue("FTITLE", items[i].title);		
		tbl.setValue("FLINK", items[i].link);
		tbl.setValue("FDESCRIPTION", items[i].description);
		tbl.setValue("FPUBDATE", items[i].pubDate);
		tbl.setValue("FCREATOR", items[i].creator?items[i].creator :"");
		tbl.setValue("FITEM", items[i]);
		tbl.setValue("FTT", 0);	
		tbl.Update();
	}
}


function gadgetExpand()
{
	var par = new Object();
	par.isFull = true;
	par.rssURL = url
	showWindow("gadgets/RSS/full.xml", SW_MODAL, par);
}

function gridMenuInit()
{
	
	if(!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("OPENURL", "Перейти|Перейти");
		if(IsDblClick())
		{
			gridMenuRun("OPENURL", grid);
			return false;
		}
		//grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		//grid.AddMenuItem("VIEW", "Перегляд|Просмотр");		
	}	
}

function gridMenuRun(sID)
{
	var tbl = grid.getTable();	
	if(sID=="OPENURL")
	{
		var urlLink = tbl.getValue("FLINK");
		lpProxy.displayURL(urlLink);		
	}
	else if(sID=="VIEW")
	{
		showWindow(oDoc.formFile,"XMLDLG",par);
	}
	
}



function gridCond(oGrid)
{
	for(var nColor=1; nColor<=26; nColor++)
	{
		oGrid.defCond(nColor, "=^FTT=="+ nColor);
		oGrid.color(nColor, nColor);
	}	
}

include("gadgets/DpGadget.js");