include("doc/DpDoc.js")

var userCod = 0;
var nop = 0;

function gadgetLoad()
{		
	if(Task.getMenuMode())
		nop = Number(Task.getMenuMode());
	userCod = 0;
	var userName = getUserName();
	var oSnap = getSnap("select rel.FCOD "
							+" from ^CL_PERS p "
							+" inner join ^CLRELCLCL rel on rel.FWID_CL=p.FWID_CL "
							+" where p.FLOGIN="+ sqlTo(userName)
						, false
						);
	if(oSnap)
		userCod = oSnap[0];	
	var tbl = OpenTable("select * from ^LISTDOCSTASK"
						+" where FSTATUS=1"
							+" and FPROGRAMMER="+ sqlTo(userCod)
							+(nop? " and FNOP="+ nop : "")
						+" order by FDOC_DAT, FCUSTOMER"
						);
	grid.setTable(tbl);
	grid.build();
	
	FNEWTASK.mask = "######";
	FCURTASK.mask = "######";
	Disable(FNEWTASK);
	Disable(FCURTASK);
	
	gadgetRefresh();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
	
	setValid(FFILTER, filter);
}

function filter()
{
	var sWhere = sqlFilter();
	var tbl = OpenTable("select * from ^LISTDOCSTASK" 
						+ sWhere
						+" order by FDOC_DAT, FCUSTOMER"
						);
	grid.setTable(tbl);
	gadgetRefresh();
}

function sqlFilter()
{
	var sWhere = " where FSTATUS=1";
	var nFilter = Number(FFILTER.value);
	if(nFilter==1)
		sWhere += " and FPROGRAMMER="+ sqlTo(userCod);
	else if(nFilter==2)
		sWhere += " and FPROGRAMMER=0";
	else 
		sWhere += " and (FPROGRAMMER="+ sqlTo(userCod) +" or FPROGRAMMER=0)";
	return sWhere;
}

function gadgetRefresh()
{
	var oSnap = getSnap("select count(*) as cnt from ^LISTDOCSTASK "
						+ sqlFilter()
						, false
						);
	if(oSnap)
	{
		FNEWTASK.value = oSnap[0];
		
		var nGridPos = grid.getRowSelected();
		grid.getTable().requery();
		grid.getTable().setAbsolute(nGridPos);
		grid.refresh();
	}
	
	oSnap = getSnap("select count(*) as cnt from ^LISTDOCSTASK "
						+ sqlFilter()
							+" and FNAZNACHDATE="+ sqlTo(today)
						, false
						);
	if(oSnap)
	{
		if(Number(oSnap[0])>Number(FCURTASK.value))
			WAIT(UR("Назначене нове завдання|Назначено новое задание"));
		FCURTASK.value = oSnap[0];
	}
}

function gadgetExpand()
{
	var par = new Object();
	par.isFull = true;
	showWindow("gadgets/TASK/full.xml", SW_MODAL, par);
}

function gridMenuInit()
{
	grid.AddMenuItem("FULL", "Перейти до списку завдань|Перейти к списку заданий");
	grid.AddMenuItem("", "");
	if(!grid.getTable().isEmpty())
	{
		if(IsDblClick())
		{
			gridMenuRun("VIEW", grid);
			return false;
		}
		grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("VIEW", "Перегляд|Просмотр");		
	}	
}

function gridMenuRun(sID)
{
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="VIEW" || sID=="EDIT")
	{
		var oDoc = new DpDoc("TASK", nop);
		var bRet = oDoc.edit(sID, rowID);
		if(bRet && sID=="EDIT")
		{
			tbl.requery();
			tbl.FindFirst("FWID="+ oDoc.getID());
			grid.refresh();
		}
	}
	if(sID=="FULL")
	{
		var par = new Object();
		par.doc = "TASK";
		par.nop = nop;
		par.menuMode = "MY";
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
}

include("gadgets/DpGadget.js");