
function Load()
{
	Caption(UR("Готельне господарство|Отельное хозяйство"));
	
	FORM.setImage(rootDirectoryEx() +"/icons/house.gif");
	
	loadCntPanel();
	loadRegPanel();
	loadClsPanel()
	loadParamPanel();
}

function loadCntPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Реєстр путівок|Реестр путевок"));
	
	panel.addItem("PUT", UR("Путівки|Путевки"), true);	
	panel.addItem("BRN", UR("Бронювання|Бронирование"), true);	
			
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
}

function loadRegPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Звіти|Отчеты"));
	
	panel.addItem("CNT", UR("Звіт по країнах|Отчет по странах"), true);	
	panel.addItem("CNT_OPL", UR("Звіт по країнах та видах оплат|Отчет по странах и видах расчета"), true);	
	panel.addItem("OPL", UR("Звіт по видах оплат|Отчет по видах расчета"), true);	
	//panel.addItem("HARCH", UR("Звіт по харчуванню|Отчет по питанию"), true);	
	panel.addItem("ORG", UR("Звіт по організаціях|Отчет по органицациях"), true);	
	//panel.addItem("ORGALL", UR("Звіт по організаціях (розгорнутий)|Отчет по органицациях (развернутый)"), true);
	panel.addItem("NAL", UR("Звіт по готівкових розрахунках|Отчет по налу"), true);	
	panel.addItem("BEZNAL", UR("Звіт по безготівкових розрахунках|Отчет по безналу"), true);	
	//panel.addItem("INOZ", UR("Звіт по іноземцях|Отчет по иностранцах"), true);	
	//panel.addItem("OPT", UR("Звіт по путівках|Отчет по путевках"), true);	
				
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
}

function loadClsPanel()
{
	pCl = PANELBAR.createPanel();
	pCl.setCaption(UR("Довідники|Справочники"));
		
	pCl.addItem("CLS_CLIENTS", UR("Довідник клієнтів|Справочник клиентов"), true);
	pCl.addItem("CONTR", UR("Контрагенти|Контрагенты"), true);
	pCl.addItem("CLS_PAYTYPE", UR("Типи оплати|Типы расчета"), true);
	pCl.addItem("CLS_OTDTYPE", UR("Тип відпочиваючих|Тип отдыхающих"), true);
	pCl.addItem("CLS_CORPUSA", UR("Корпуси|Корпуса"), true);
	pCl.addItem("CLS_EATTYPE", UR("Види харчування|Виды питания"), true);
	pCl.addItem("CLS_NOMTYPE", UR("Типи номерів|Типы номеров"), true);
	pCl.addItem("CLS_ROOMS", UR("Довідник номерів|Справочник номеров"), true);
	pCl.addItem("CLS_DOPPOSL", UR("Додаткові послуги|Дополнительные услуги"), true);
	
	this.selHandler = selHandler;
	pCl.setSelectHandler(this, "selHandler");
}


function loadParamPanel()
{
	pCl = PANELBAR.createPanel();
	pCl.setCaption(UR("Налагодження|Настройки"));
		
	pCl.addItem("PARAMS", UR("Параметри|Параметры"), true);
	pCl.addItem("ZASEL", UR("Заселення номерів|Заселение номеров"), true);	
	pCl.addItem("ZASEL_CHESS", UR("Заселення номерів (Шахматка)|Заселение номеров (Шахматка)"), true);		
	this.selHandler = selHandler;
	pCl.setSelectHandler(this, "selHandler");
}

function selHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "PUT":
			par.doc = "HO";
			par.nop = 1;
			sDlg = "l_docekz.xml";		
			break;		
		
		case "BRN":
			par.doc = "HB";
			par.nop = 1;
			sDlg = "l_docekz.xml";
			break;
			
		case "CNT":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_countris.js";
			break;
		
		case "CNT_OPL":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_cntopl.js";
			break;
		
		case "OPL":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_opl.js";
			break;
		
		//case "ORGALL":
		//	alert(sID + " - в розробці...");
		//	sType = SW_NOMODAL;
		//	sDlg = "htl_zvit_orgall.js";
		//	break;
			
		case "ORG":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_org.js";
			break;
		
		case "NAL":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_nal.js";
			break;
		
		case "BEZNAL":
			sType = SW_NOMODAL;
			sDlg = "htl_zvit_beznal.js";
			break;
	
		case "PARAMS":
			sType = SW_MODAL;
			sDlg = "e_param.xml";
			break;			
		
		case "ZASEL":
			//alert(sID + " - в розробці...");
			sType = SW_NOMODAL;
			par.TYPE = sID;
			sDlg = "htl_zved_po_nom.js";
			break;		
		
		case "ZASEL_CHESS":
			//alert(sID + " - в розробці...");
			sType = SW_NOMODAL;
			par.TYPE = sID;
			sDlg = "htl_zved_po_nom.js";
			break;		
		
		//--------------
		case "CLS_CLIENTS":
			par.Fcl = getPar("HTL_CLIENTS");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;
		
		case "CONTR":
			par.Fvid = 2;
			par.Fcl = getPar("CODPLAT");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		case "CLS_PAYTYPE":
			par.Fcl = getPar("HTL_PAYTYPE");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		
		case "CLS_OTDTYPE":
			par.Fcl = getPar("HTL_OTDTYPE");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		case "CLS_CORPUSA":
			par.Fcl = getPar("HTL_CORPUSA");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		
		case "CLS_EATTYPE":
			par.Fcl = getPar("HTL_EATTYPE");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		
		case "CLS_NOMTYPE":
			par.Fcl = getPar("HTL_NOMTYPE");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		
		case "CLS_ROOMS":
			par.Fcl = getPar("HTL_ROOMS");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
		
		case "CLS_DOPPOSL":
			par.Fcl = getPar("HTL_DOPPOSL");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;		
					
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}

include("sys/DpBaseDlg.js");