include("objects\\DpGetDat.js");
include("objects\\DpGrid.js");
include("servis\\date.js");

var dat1,dat2;
var gd;
var tblName;
var monthHistory = 1;
var data_s;

function listLoad()
{
	with( this )
	{
		subAsk = askParam;
		subSrc = infSrc;
		printLabel = "PRHTL";
		this.accDel = null;
		switch(extPar.TYPE)
		{
			case "ZASEL":
				tblName = "tmp_nomer";
				//this.xmlGridFile = "htl_zved_po_nom.xml";
			break;
			
			case "ZASEL_CHESS":
			    tblName = getTmpTableName();
				//this.xmlGridFile = "htl_zved_po_nom.xml";
			break;
		}
	}
}

function askParam()
{
	gd=new DpGetDat("D");			
	return gd;
}

function listMake()
{
	data_s = gd.dat2;
	//var dat2 = sqlTo(gd.dat2);
	switch(extPar.TYPE)
	{
		case "ZASEL":
			//alert("ZASEL  -  " + this.xmlGridFile);
			CreateTable(tblName, "HHO")
			ExecuteSQL("ALTER TABLE " + tblName + " ADD FCL1 " + SqlType("LONG"));
			
			ExecuteSQL("INSERT INTO " + tblName + "(FWID, FDOC_DAT, Fkimnata, FKODKAT, FDOC_NUM, FCTRLDAT, FCL1)"
	         		+ " SELECT MAX(FWID)  as FWID, MAX(a.FDOC_DAT) as FDOC_DAT, Fkimnata, " 
	         		+ " MAX(a.FKODKAT) as FKODKAT, MAX(a.FDOC_NUM) as FDOC_NUM, MAX(a.FCTRLDAT)as FCTRLDAT, 1 as FCL1 "
	         		+ " FROM ^HHO a WHERE FDOC_DAT <= " + sqlTo(data_s) + " and FCTRLDAT >= " + sqlTo(data_s)
	         		+ " GROUP BY FKIMNATA ");
	
			
			
			ExecuteSQL("INSERT INTO " + tblName + "(FWID, FDOC_DAT, Fkimnata, FKODKAT, FDOC_NUM, FCTRLDAT, FCL1)"
	        		+ " SELECT a.FWID_CL as FWID, " + sqlTo(d00) + " as FDOC_DAT, a.Fcod as Fkimnata, " 
	         		+ " 0 as FKODKAT, '' as FDOC_NUM, " + sqlTo(d00) + " as FCTRLDAT, 0 as FCL1 "
	         		+ " FROM ^CLRELCLCL a left join " + tblName + " k on a.fcod = k.Fkimnata where a.FCL = " + getPar("HTL_ROOMS") + " and k.Fkimnata is null"
	         		+ "");
	         		 
	        		
		break;
		
		case "ZASEL_CHESS":
			
			var strSQL = "SELECT rel.Fcl, rel.Fcod, a.ftxt "
					+ " INTO " + tblName 
					+ " FROM (^cl a "
					+ "INNER JOIN ^clrelclcl rel "
						+ "ON a.Fwid=rel.Fwid_cl) "
					+ " WHERE rel.Fcl=" + getPar("HTL_ROOMS")
					+ " order by rel.Fcod "
					;
    		ExecuteSQL(strSQL);
    		ExecuteSQL("ALTER TABLE " + tblName + " ADD FWID " + SqlType("COUNTER"));
    		for(var i=0; i<monthHistory; i++)
			{
				month2tbl(tblName, goMonth(data_s, -1*i));
				WAIT("Зачекайте...")
			}
			
			//browse("Select * From " + tblName);
		break;
	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	switch(extPar.TYPE){
	case "ZASEL_CHESS":
		
		var page = oGrid.page(); 
		page.cell("fcod", "Код|Код", 4);
		page.cell("ftxt", "Назва|Наименование", 10);
			//for(var i=0; i<monthHistory; i++)
		month2grid(page, data_s);
			
		oGrid.build();
		
	break;
	
	case "ZASEL":
		with(oGrid)
		{
			with(oGrid)
			{		
				defCond("=^FCL1=='1'", "BALANCE");	
				color(6, "BALANCE");
			}
			with(oGrid.page())
			{
				cell("x_cl_room.Ftxt", "Номер|Номер", 10);
				cell("x_cl_kat.Ftxt", "Категорія номера|Категория номера", 25);
				cell("FDOC_NUM", "Номер пут.|Номер пут.", 10);
				cell("FDOC_DAT", "Дата посел.", 10);
				cell("FCTRLDAT", "Дата висел.|Дата высел.", 10);			
			}
			build();
		}
	break;
	}
}

function month2grid( page, d2 )
{
	var ddd = new Date(d2);	
	for (var i = 1; i<=getDaysInMonth(d2); i++)
	{
		ddd.setDate(i);
		var fldName = format("ddmmyyyy", ddd);
		page.cell("f"+fldName, "" + i + "", 4);
	}
}

function month2tbl( tblName, d2)
{
	var ddd = new Date(d2);
	for (var i = 1; i<= getDaysInMonth(d2); i++)
	{
		ddd.setDate(i);
		var fldName = format("ddmmyyyy", ddd);
		ExecuteSQL("ALTER TABLE " + tblName + " ADD " + "f"+fldName + " " + SqlType("BIT"));
		ExecuteSQL("UPDATE " + tblName + " a "
					+ " SET " + "f"+fldName + " = " + sqlTrue
						+ " WHERE EXISTS (SELECT FKIMNATA FROM ^hho where "
						+ sqlTo(ddd) + " BETWEEN FDOC_DAT AND FCTRLDAT "
						+ " and A.fcod = FKIMNATA" 
						+ " ) "
					);
	}
}


function infSrc()
{
	this.dataSrc.addAccel(GA_CTRL, "D", "FIND_DOC");
	this.dataSrc.addAccel(GA_CTRL, "P", "CTRL-P");
	if(extPar.TYPE ==  "ZASEL_CHESS")	
		this.qrySet("From", tblName, "Order","FCOD");
	else
		this.qrySet("From", tblName, "Order","FKIMNATA");
	
	this.clTie("x_cl_kat", "="+getPar("HTL_NOMTYPE")+",FKODKAT",  subalias="kat");
	//this.clTie("x_cl_org", "="+getPar("HTL_CLIENTS")+",FORG1",    subalias="org");
	this.clTie("x_cl_room", "="+getPar("HTL_ROOMS")+",FKIMNATA",  subalias="rom");
	
	//this.clTie("COUNTRY", "="+sqlTo(getPar("CODCOUNTRY"))+", FCOUNTRY");
	//grid.setSQLQueryCount(true);	
}

function listTitle()
{
	switch(extPar.TYPE)
	{
		case "ZASEL":
			var sCapt = "Заселення номерів - " + format("Mmm yyyy",data_s);
		break;
		
		case "ZASEL_CHESS":
			var sCapt = "Заселення номерів (ШАХМАТКА) - " + format("Mmm yyyy",data_s);
		break;
	}
	return sCapt;
}

include("sys/DpList.js");