include ("sys/udfs.js")
include ("objects/DpXMLDOMDocument.js");

function importKursValWeb(sVal, dat1, dat2)
{
	if (!dat1)
		dat1= today;
	if (!dat2)
		dat2= today; 
	
	var sDat1 = format("yyyy-mm-dd", dat1);
	var sDat2 = format("yyyy-mm-dd", dat2);
	var sURL = "http://www.debet.kiev.ua/a-kurs/xml.php?tkod=" 
	+ String(sVal).toUpperCase() + "&mindate=" + sDat1 + "&maxdate=" + sDat2 ;
	
	var xmlDom = new  DpXMLDOMDocument();
	xmlDom.loadFromURL(sURL);
	//xmlDom.save("C:\\aaa.xml");
	var root = xmlDom.getDocumentElement();
	var nodes = root.getElementsByTagName("item");
	
	var sdf = new java.text.SimpleDateFormat();
	sdf.applyPattern("yyyy-MM-dd");
	
    for (var i = 0; i< nodes.length; i++)
    {
        var vals = nodes[i];
    	var valname = vals.getAttribute("tkod");
        var sdate = vals.getAttribute("date");                    
        var sKurs =  vals.getAttribute("kurs");
        if (sKurs == "0.01")
        	continue;
		var dat = sdf.parse(sdate);
        insertKurs(sVal, Number(sKurs), dat)
    }
    ExecuteSQL("delete from ^KURSVAL where fedat < fbdat ");		
}

function insertKurs(sVal, nKurs, dat)
{
	var nKod = getCodValByTKod(sVal);
	if (nKod == -1) return;
	
	trace(sVal + " " + dat + " " + nKurs);
	var sSQL = "SELECT FKURS, FBDAT, FEDAT, FWID FROM ^KURSVAL WHERE FKOD = " + nKod 
	+ " AND  FBDAT <= " + sqlTo(dat) + " AND FEDAT >= " + sqlTo(dat);
		
	var oSnap = getSnap(sSQL)
	if (oSnap)
	{
		if (oSnap[0] == nKurs)
		{
			return;
		}
		
		ExecuteSQL("update ^KURSVAL set fedat = " + sqlTo(goDay(dat, -1)) + " where fwid = " + oSnap[3]);		
		
		var m = new Object();
		m.fkod = nKod
		m.fkurs = nKurs;
		m.fbdat = dat;
		m.fedat = oSnap[2];
		m.Fwid = GetUID();
		updateTable("^KURSVAL", m, true);
		
		
	} 
	else
	{
		var bdat = dat;
		var edat = new Date(2100,0,1);
		
		var sSQL = "SELECT MIN(FBDAT) FROM ^KURSVAL  WHERE FKOD = " + nKod 
			+ " AND  FBDAT >= " + sqlTo(dat);
		var oSnap = getSnap(sSQL)
		if (oSnap && oSnap[0])
		{
			edat = goDay(oSnap[0], -1);
		}
		
		var m = new Object();
		m.fkod = nKod;
		m.fkurs = nKurs;
		m.fbdat = bdat;
		m.fedat = edat;
		m.Fwid = GetUID();
		updateTable("^KURSVAL", m, true);
		
		 
	}
}

function getCodValByTKod(sKod)
{
	var sSQL = "SELECT FKOD FROM ^CL_VALUT WHERE " 
		+ sqlUpper("FNAZVS") + " = " + sqlTo(sKod.toUpperCase())

	var oSnap = getSnap(sSQL)
	if (oSnap && oSnap[0])
		return oSnap[0];
	return -1;
}

function importKursAllValWeb(dat1, dat2)
{
	if (!dat1)
		dat1= today;
	if (!dat2)
		dat2= today; 
	
	var tbl = OpenTable("select FNAZVS from ^cl_valut where fkod > 0")
	while(!tbl.isEOF())
	{
		var kursKod = tbl.getValue("FNAZVS");
		if(kursKod && String(kursKod) && allt(String(kursKod)) != "")
		{
			importKursValWeb(allt(String(kursKod)), dat1, dat2);
		}
		tbl.moveNext();
	}
}

if(GetMenuMode() == "RUN")
	importKursAllValWeb();