include("Objects/DpXMLDomDocument.js");
include("Objects/DbImporter.js");
include("servis/dump.js");

var sTmpTbl = "TMP_BASE_LIST";
var arrUser = new Array();
var sSourceFile = "";
var sSourceBase = "";
var sSourceSUBD = "";
var sSettingsFile = "";
var nWorkBase = 1;
var nBase = 1;
var orgMan = lpProxy.getOrgManager();
var oImporter = new DbImporter();
var arrTables = new Array();
var sTotal = "";
var sSourceDir = rootDirectoryEx() +"Source/import/";
var connection = null;
var finish = false;

function wizardInit()
{
	Caption("Майстер імпорту БД|Мастер импорта БД");
	document.WIZARD = this;
	if(getAccess("BAN_IMPORT")=="R")
	{
		alert(UR("Не достатньо прав!|Не достаточно прав!"), 1);
		return false;
	}
}

function wizardPageCreated()
{
	FORM.getShell().setImage(org.eclipse.swt.graphics.Image(null, rootDirectoryEx() +"/icons/wizard2.gif"));
	
	FPATH.setFilterPath(DpFile(orgMan.getOrgPath()));	
	FSOURCE.setFilterExtensions(new Array("*.xml"));
	if(isDir(sSourceDir))
		FSOURCE.setFilterPath(sSourceDir);
	
	RGSOURCE.value = "FULL";
	RGBASE.value = "NEW";
	
	if(extPar && extPar.source && isFile(extPar.source))
		FSOURCE.value = extPar.source;
	if(extPar && extPar.base_type)
		RGBASE.value = extPar.base_type;
	if(extPar && extPar.oldbase)
		RGBASE.value = "OLD";
	if(extPar && extPar.base)
		FBASE.value = extPar.base;
		
	Disable(FSUBD);
	
	this.base_valid = base_valid;
	FBASE.setModifyHandler(this, "base_valid");
	
	setValid(FSOURCE, source_valid);
	setValid(RGBASE, dbtype_valid);
	setValid(CDBMOD, modcheck_valid);
	
	//table_total.getCtrl().setHeaderVisible(false);	
	table_total.addColumn("FNAME", UR("Параметр|Параметр"), 180);
	table_total.addColumn("FINFO", UR("Значення|Значение"), 200);
	table_total.addColumn("FCOMMENT", UR("Примітка|Примечание"), 100);
		
	source_valid();
	dbtype_valid();
}

function wizardGetNextPage(curPage)
{
	finish = false;
	
	if (String(curPage.getName())==String(SOURCE.getName()))
	{
		if(!source_valid())
			return SOURCE;
		
		loadBaseList();
		
		if (RGSOURCE.value=="TABLES")
		{
			closeTables();
			ExecuteSQL("drop table TMP_TABLES", false);
			var sSQL = "create table TMP_TABLES"
					+" (FBASE "+ SqlType("TEXT", 50) +" default "+ sqlEmpStr 
					+", FTABLE "+ SqlType("TEXT", 250) +" default "+ sqlEmpStr 
					+", FCOMMENT "+ SqlType("TEXT", 250) +" default "+ sqlEmpStr
					+", FTT "+ SqlType("TEXT", 3) +" default "+ sqlEmpStr
					+", FWID "+ SqlType("COUNTER")
					+")";
			ExecuteSQL(sSQL);
			
			var tblList = oImporter.getListTbl(sSourceFile);
			if(tblList)
			{
				for (var nTbl=0; nTbl<tblList.length; nTbl++)
				{
					var eTbl = tblList[nTbl];		
					var sName = eTbl.getAttribute("name");
					ExecuteSQL("insert into TMP_TABLES (FTABLE) values ('"+ sName +"')");
				}
			}
			var tbl = OpenTable("select * from TMP_TABLES order by FTABLE");
			grid_TABLES.setTable(tbl);
			grid_TABLES.build();
			grid_TABLES.setFocus();
			return SOURCE_TABLES;
		}			
		else
		{
			return BD_TYPE;
		}		
	}
	else if (String(curPage.getName())==String(BD_TYPE.getName()))
	{
		if (RGBASE.value=="NEW")
		{
			INFO_DB.setText(UR("Введіть назву нової бази|Введите название новой базы"));
			CDBMOD.value = true;
			Enable(CDBMOD, false);
			Enable(FBASE);
			modcheck_valid();
			
			if(!grid_SUBD.getTable())
			{				
				ExecuteSQL("drop table TMP_SUBD", false);
				var sSQL = "create table TMP_SUBD"
						+" (FID "+ SqlType("INT") +" default 0" 
						+", FSUBD "+ SqlType("TEXT", 50) +" default "+ sqlEmpStr 
						+", FCOMMENT "+ SqlType("TEXT", 250) +" default "+ sqlEmpStr
						+", FTT "+ SqlType("TEXT", 3) +" default "+ sqlEmpStr
						+", FWID "+ SqlType("COUNTER")
						+")";
				ExecuteSQL(sSQL);
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('ORACLE')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('MYSQL')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('MSSQL')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('SYBASE')");
				//ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('DERBY')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('DB2')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('POSTGRE')");
				ExecuteSQL("insert into TMP_SUBD (FSUBD) values ('HSQLDB')");
				var tbl = OpenTable("select * from TMP_SUBD order by FSUBD");
				grid_SUBD.setTable(tbl);
				grid_SUBD.build();
				this.grid_SUBD_selHandler = grid_SUBD_selHandler;
				grid_SUBD.setSelHandler(this, "grid_SUBD_selHandler");
				FSUBD.value = "ORACLE";
			}
			return PSUBD;
		}			
		else
		{
			INFO_DB.setText(UR("Виберіть базу із списку|Быберите базу из списка"));
			//Enable(FBASE, false);
			Enable(CDBMOD);
			
			grid_DB.DeletePages();
			with(grid_DB)
			{
				FieldEx("FBASE", "База|База", 10);
				FieldEx("FSUBD", "СКБД|СУБД", 8);				
				FieldEx("FSERVER", "Сервер|Сервер", 10);				
				FieldEx("FPATH", "Налаштування|Настройки", 15);
				FieldEx("FCOMMENT", "Примітка|Примечание", 10);
			}			
						
			var tbl = OpenTable("select * from "+ sTmpTbl +" order by FSUBD, FBASE");
			grid_DB.setTable(tbl);
			grid_DB.build();
						
			this.grid_DB_selHandler = grid_DB_selHandler;
			grid_DB.setSelHandler(this, "grid_DB_selHandler");
			
			grid_DB.getTable().FindFirst("FID="+ lpProxy.getOrgManager().getOrg());
			grid_DB.refresh();
			grid_DB_selHandler();
					
			return DB;
		}		
	}
	else if (String(curPage.getName())==String(PSUBD.getName()))
	{
		if (RGBASE.value=="NEW")
		{
			var subd = String(FSUBD.value).toUpperCase();
						
			var tbl = OpenTable("select FSERVER, FCOMP, FPORT from "+ sTmpTbl 
								+" where UPPER(FSUBD)='"+ subd +"'"
								+" group by FSERVER, FCOMP, FPORT"
								+" order by FSERVER"
								);
			if(tbl.isEmpty())
			{
				sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE, FPATH"
							+", FCOMP, FPORT, FTT, FCONNECT, FCOMMENT)"
						+" values ("+ nBase++ +", '"+ subd +"', 'localhost'" 
							+", 'dpbase', '"+ getOrgPath() +"', '', ''"
							+", '', "+ sqlFalse 
							+", ''" 
							+")";
				ExecuteSQL(sSQL, false);
				tbl.requery();
			}
			
			grid_SERVER.setTable(tbl);
			grid_SERVER.build();
			this.grid_SERVER_selHandler = grid_SERVER_selHandler;
			grid_SERVER.setSelHandler(this, "grid_SERVER_selHandler");
			
			grid_SERVER_selHandler();
		}		
	}
	else if (String(curPage.getName())==String(SERVER.getName()))
	{
		var subd = String(FSUBD.value).toUpperCase();
		if(subd=="DERBY")
			FPATH.value = FSERVER.value;		
		else if(subd=="POSTGRE")
			FPATH.value = DpFile(orgMan.getOrgPath()).getParent() +"/pgdpbase";
		else
			FPATH.value = DpFile(orgMan.getOrgPath()).getParent() +"/org2";
		
		if (RGBASE.value=="NEW")
		{
			grid_DB.DeletePages();
			grid_DB.FieldEx("FBASE", "База|База", 10);
						
			tbl = OpenTable("select FBASE from "+ sTmpTbl 
								+" where UPPER(FSUBD)='"+ subd +"'"
									+" and FSERVER='"+ FSERVER.value +"'"
								+" group by FBASE"
								+" order by FBASE");
			grid_DB.setTable(tbl);		
			grid_DB.build();
			
			this.grid_DB_selHandler = grid_DB_selHandler;
			grid_DB.setSelHandler(this, "grid_DB_selHandler");
			
			FBASE.value = sSourceBase;
		}
		
		if(!checkConnection())
			return SERVER;
	}
	else if (String(curPage.getName())==String(DB.getName()))
	{
		if (RGBASE.value=="OLD")
		{
			if(!checkConnection())
				return DB;
		}
	}
	else if (String(curPage.getName())==String(DBMOD.getName()))
	{
		var sTables = "";
		arrTables = new Array();
		
		if(RGSOURCE.value=="TABLES")
		{
			var nTableCount = grid_TABLES.getSelectedCount();
			if(nTableCount<6)
			{
				var sTblName = grid_TABLES.getTable().getTableName();
				var tbl = OpenTable("select * from "+ sTblName +" where "+ grid_TABLES.getSqlSelected());
				for(; !tbl.isEOF(); tbl.MoveNext())
				{
					var sTblName = tbl.getValue("FTABLE");
					sTables += (sTables!=""? ";\n			" : "") + sTblName;
					arrTables[arrTables.length] = sTblName;
				}
				tbl.close();
			}
			else
			{
				sTables = nTableCount;
			}
		}
		else
		{
			var tblList = oImporter.getListTbl(sSourceFile);
			if(!tblList)
			{
				INFO_FINISH.setText("");
				return false;
			}
			if(tblList.length>5)
				sTables = tblList.length;
			for (var nTbl=0; nTbl<tblList.length; nTbl++)
			{
				var eTbl = tblList[nTbl];
				var sTblName = eTbl.getAttribute("name");
				arrTables[arrTables.length] = sTblName;
				if(tblList.length<6)
					sTables += (sTables!=""? ";\n			" : "") + sTblName;
			}
		}
		
		var size = round(Number(DpFile(sSourceFile).length())/(1024*1024), 3);		
		sTotal = UR("Джерело: 	"+ FSOURCE.value +"	"+ size +" Mb"
						+"\n	Таблиці: 	"+ sTables
						+"\n\nПриймач: 	"+ FBASE.value + (RGBASE.value=="NEW"? " 	нова база" : "")
						+"\n	СКБД: 	"+ FSUBD.value
						+"\n	Сервер: 	"+ FSERVER.value
						+ (FCOMP.value!=""? "\n	Машина: 	"+ FCOMP.value : "")
						+ (FPORT.value!=""? "\n	Порт: 	"+ FPORT.value : "")
						+"\n	Налаштування: 	"+ FPATH.value
						+"\n\nОновлення структури БД: 	"+ (CDBMOD.value==true? "так" : "ні")
					+"|Источник: 	"+ FSOURCE.value +"	"+ size +" Mb"
						+"\n	Таблицы: 	"+ sTables
						+"\n\nПриёмник: 	"+ FBASE.value + (RGBASE.value=="NEW"? " 	новая база" : "")
						+"\n	СУБД: 	"+ FSUBD.value
						+"\n	Сервер: 	"+ FSERVER.value
						+ (FCOMP.value!=""? "\n	Машина: 	"+ FCOMP.value : "")
						+ (FPORT.value!=""? "\n	Порт: 	"+ FPORT.value : "")
						+"\n	Настройки: 	"+ FPATH.value
						+"\n\nОбновление структуры БД: 	"+ (CDBMOD.value==true? "да" : "нет")
					);
		//FTOTAL.value = sTotal;				
		fillTotals(table_total);
		finish = true;
	}
	
	//INFO_FINISH.setText(UR("Для виконання імпорту натисніть кнопку 'Готово'|Для выполнения импорта нажмите кнопку 'Готово'"));
}

function fillTotals(oCtrl)
{
	oCtrl.removeAll();
	
	var id = 0;
	var tab = "         ";
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", UR("ДЖЕРЕЛО: |ИСТОЧНИК: "));
	oCtrl.setValue(id, "FINFO", FSOURCE.value);
	var size = round(Number(DpFile(sSourceFile).length())/(1024*1024), 3);
	oCtrl.setValue(id, "FCOMMENT", size +" Mb");
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", tab + UR("Таблиці: |Таблицы: "));
	if(arrTables.length<6)
	{
		for (var nTbl=0; nTbl<arrTables.length; nTbl++)
		{
			trace(nTbl +": "+ id +" > "+ arrTables[nTbl])
			oCtrl.setValue(id++, "FINFO", arrTables[nTbl]);
			oCtrl.addItem(id);
		}
	}
	else
	{
		oCtrl.setValue(id, "FINFO", arrTables.length);
		oCtrl.addItem(++id);
	}
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", UR("ПРИЙМАЧ: |ПРИЁМНИК: "));
	oCtrl.setValue(id, "FINFO", FBASE.value);
	var sComm = UR("ІСНУЮЧА БАЗА|СУЩЕСТВУЮЩАЯ БАЗА");
	if(RGBASE.value=="NEW")
	{
		if(base_valid())
			sComm = UR("нова база|новая база");
		oCtrl.setValue(id, "FCOMMENT", sComm);
	}
	else
	{
		oCtrl.setValue(id, "FCOMMENT", sComm);
	}
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", tab + UR("СКБД: |СУБД: "));
	oCtrl.setValue(id, "FINFO", FSUBD.value);
	oCtrl.setValue(id, "FCOMMENT", UR("|"));
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", tab + UR("Сервер: |Сервер: "));
	oCtrl.setValue(id, "FINFO", FSERVER.value);
	oCtrl.setValue(id, "FCOMMENT", UR("|"));
	
	var comp = String(FCOMP.value).trim();
	if(comp!="")
	{
		oCtrl.addItem(++id);
		oCtrl.setValue(id, "FNAME", tab + UR("Машина: |Машина: "));
		oCtrl.setValue(id, "FINFO", comp);
		oCtrl.setValue(id, "FCOMMENT", UR("|"));
	}
	
	var port = String(FPORT.value).trim();
	if(port!="")
	{
		oCtrl.addItem(++id);
		oCtrl.setValue(id, "FNAME", tab + UR("Порт: |Порт: "));
		oCtrl.setValue(id, "FINFO", port);
		oCtrl.setValue(id, "FCOMMENT", UR("|"));
	}
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", tab + UR("Налаштування: |Настройки: "));
	oCtrl.setValue(id, "FINFO", FPATH.value);
	oCtrl.setValue(id, "FCOMMENT", UR("|"));
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", "");
	
	oCtrl.addItem(++id);
	oCtrl.setValue(id, "FNAME", UR("Оновлення структури БД: |Обновление структуры БД: "));
	oCtrl.setValue(id, "FINFO", (CDBMOD.value==true? UR("так|да") : UR("ні|нет")));
	oCtrl.setValue(id, "FCOMMENT", UR("|"));
}

function grid_SUBD_selHandler()
{
	var tbl = grid_SUBD.getTable();	
	if(finish || !tbl || !tbl.getValue("FSUBD"))
		return;
	FSUBD.value = tbl.getValue("FSUBD");
}

function grid_DB_selHandler()
{
	var tbl = grid_DB.getTable();	
	if(finish || !tbl || !tbl.getValue("FBASE"))
		return;
	if(RGBASE.value!="NEW")
	{
		FBASE.value = tbl.getValue("FBASE");
		FSUBD.value = tbl.getValue("FSUBD");
		FSERVER.value = tbl.getValue("FSERVER");
		FCOMP.value = tbl.getValue("FCOMP");
		FPORT.value = tbl.getValue("FPORT");
		FPATH.value = tbl.getValue("FPATH");
	}
	base_valid();
}

function grid_SERVER_selHandler()
{
	var tbl = grid_SERVER.getTable();	
	if(finish || !tbl || !tbl.getValue("FSERVER"))
		return;
	FSERVER.value = tbl.getValue("FSERVER");
	FCOMP.value = tbl.getValue("FCOMP");
	FPORT.value = tbl.getValue("FPORT");
}

function wizardСanFlipToNextPage()
{
	if(FORM.getCurrentPage().getName()!="SOURCE")
	{
		if(!source_valid())
			return false;
	}	 
	return FORM.getCurrentPage().getName()!="FINISH";	
}

function wizardCanFinish()
{
	return FORM.getCurrentPage().getName()=="FINISH";
}

function onFinish()
{
	if(!source_valid())
		return closeTables();
	
	if(!setConnection())
		return closeTables();	
	
	if(!runImport())
		return closeTables();
	
	if(CDBMOD.value==true)
		runModifyStru();
	
	var sMsg = UR("Імпорт завершено.\nДебет підключений до імпортованої бази "+ FBASE.value 
				+"|Импорт завершен.\nДебет подключен к импортированной базе "+ FBASE.value
				);
	alert(sMsg);
	
	closeTables();	
	return true;
}

function wizardPerformCancel()
{
	closeTables();
}

function closeTables()
{
	if(grid_TABLES.getTable())
		grid_TABLES.getTable().close();
	if(grid_SUBD.getTable())
		grid_SUBD.getTable().close();
	if(grid_SERVER.getTable())
		grid_SERVER.getTable().close();
	if(grid_DB.getTable())
		grid_DB.getTable().close();
}

function checkConnection()
{
	var base = String(FBASE.value).trim();
	var server = String(FSERVER.value);
	var subd = String(FSUBD.value).trim().toUpperCase();
	
	var strConn = strForDBConnection(server, eval(subd), FCOMP.value, FPORT.value);
	var user = getDBUserName();
	var password = lpProxy.getDBPassword(user);		
	connection = lpProxy.getDBManager().getConnection(strConn, user, password, false);	
	if(!connection || subd=="MYSQL")
	{
		user = "DPADMIN";
		password = "";
		
		if(subd=="MYSQL")
			user = "root";
		else if(subd=="POSTGRE")
			user = "postgres";
		else if(subd=="ORACLE")
			user = "sys@"+ server +" as sysdba";
		
		connection = lpProxy.getDBManager().getConnection(strConn, user, password);
	}	
	
	if(!connection)
	{
		password = askDBAdminPassword();
		if(password==null)
			return false;
		connection = getDBConnection(strConn, user, password);
		trace("\n"+ strConn +" > base: "+ base +" > user: "+ user +" > password: "+ password +"\n")
		if(!connection)
		{
			var sMsg = UR("Не вдалося підключитися до сереверу "+ server +"!"
							+"\nМожливо у вас немає прав доступу."
							+"\nСпробуйте виконати імпорт на сервері або зверніться до адміністратора."
						+"|Не удалось подключится к серверу "+ server +"!"
							+"\nВозможно у вас нет прав доступа."
							+"\nПопробуйте выполнить импорт на сервере или обратитесь к администратору."
						);
			alert(sMsg);
			return false;
		}
	}
	
	return true;
}

function setConnection()
{
	var base = String(FBASE.value).trim();
	var server = String(FSERVER.value);
	var subd = String(FSUBD.value).trim().toUpperCase();	
	var nSUBD = eval(subd);
	var user = getDBUserName();
	var password = lpProxy.getDBPassword(user);
	
	if(!connection)
	{
		checkConnection();
		if(!connection)
			return false;
	}
	
	createDatabase(base, false, connection, nSUBD);
	createDBUser(user, password, base, connection, false, nSUBD);
		
	var oSnap = getSnap("select FID, FCONNECT, FTT from "+ sTmpTbl 
						+" where FSUBD='"+ subd +"'"
							+" and FSERVER='"+ server +"'"
							+" and FBASE='"+ base +"'"
						, false
						);	
	if(oSnap && oSnap[1]==true)
	{
		nWorkBase = oSnap[0];
		setActiveBase(nWorkBase);
		lpProxy.getAppView().update();
	}
	else
	{
		nWorkBase++;
		var xmlDom = new DpXMLDOMDocument();	
		xmlDom.load(sSettingsFile);
		var xmlDoc = xmlDom.getDocumentElement();
		var eOrg = xmlDom.createElement("ORG");
		xmlDoc.appendChild(eOrg);
		eOrg.setAttribute("ID", nWorkBase);
		eOrg.setAttribute("SERVER", server);
		eOrg.setAttribute("SUBD", subd);
		eOrg.setAttribute("USEFORALL", base);
		eOrg.setAttribute("USEAUTHORIZE", 1);
		eOrg.setAttribute("TEXT", base);
		eOrg.setAttribute("DOCPARPATH", FPATH.value);
		eOrg.setAttribute("COMPNAME", FCOMP.value);
		eOrg.setAttribute("PORT", FPORT.value);
						
		var org0 = xmlDoc.getElementsByTagName("ORG")[0];
		var sysList = org0.getChildNodes();	
		for (var i=0; i<sysList.length; i++)
		{
			var sys = sysList[i];		
			var eSys = xmlDom.createElement(sys.getNodeName());
			eSys.setText(base);
			eOrg.appendChild(eSys);
		}
		
		xmlDom.save(sSettingsFile);
				
		lpProxy.getOrgManager().reloadOrgList();
		
		setActiveBase(nWorkBase);		
		lpProxy.getAppView().update();
	}
	
	user = getDBUserName();		
	var bRet = grantAllPrivileges(user, base, connection, false, nSUBD);
	if(!bRet && nSUBD!=DERBY)
	{
		trace("\nnWorkBase - "+ nWorkBase +" > SUBD - "+ SUBD);		 
		trace("SUBD - "+ nSUBD +" > '"+ subd +"'")
		bRet = grantAllPrivileges(user, base, connection, true, nSUBD);
		setActiveBase(nWorkBase);
		trace("\nSUBD - "+ SUBD +"\n")		
		if(!bRet)
		{
			var sMsg = UR("Не вдалося встановити права на базу для користувача "+ user +"."
							+"\nІмпорт може бути виконаний з помилками."
							+"\nПродовижити імпорт?"
						+"|Не удалось установить права на базу для пользователя "+ user +"."
							+"\nИмпорт может быть выполнен с ошибками."
							+"\nПродолжить импорт?"
						);
			if(!confirm(sMsg))
				return false;
		}
	}	
	
	var tables = lpProxy.getDBManager().getTables(base, "TABLE");
	if(tables.length>1)
	{
		var sMsg = UR("УВАГА!!!\nІмпорт до існуючої бази може призвести до втрати даних!"
						+"\nРекомендується спочатку виконати архівацію."
						+"\nПродовижити імпорт?"
					+"|ВНИМАНИЕ!!!\nИмпорт в существующую базу может привести к потере данных!"
						+"\nРекомендуется сначала выполнить архивацию."
						+"\nПродолжить импорт?"
					);
		if(!confirm(sMsg))
			return false;
	}
	
	return true;
}

function setActiveBase(nOrg)
{
	lpProxy.setBaseChecking(false);
	orgMan.setOrg(nOrg);
	lpProxy.setBaseChecking(true);
}

function runImport()
{
	saveImportLog(sTotal);
	INFO_FINISH.setText(UR("Виконується імпорт...|Выполняется импорт..."));
				
	oImporter.sFileParam = sSourceFile;
	oImporter.base = FBASE.value;
	oImporter.arrTbl = arrTables;
	oImporter.run();
	return true;
}

function runModifyStru()
{
	setActiveBase(nWorkBase);	
	
	var par = new Object();
	par.extentions = true;
	par.reindex = true;
	par.updmenu = false;
	//par.journal = false;
	//par.etalon = false;
	par.run = true;
	showWindow("modifyStru.xml", SW_MODAL, par);
}

function dbtype_valid()
{
	var sInfo = "";
	if(RGBASE.value=="NEW")
	{
		sInfo = UR("Буде створено нову базу з відповідними налаштуваннями."
				+"|Будет создана новая база с соответствующими настройками."
				);
	}
	else
	{
		sInfo = UR("Дані будуть занесені у відповідні таблиці існуючої бази. "
					+"При цьому інформація, що зараз знаходиться у цих таблицях буде знищена. "
					+"Рекомендується спочатку виконати архівацію даних. "
				+"|Данные будут занесены в соответствующие таблицы существующей базы. "
					+"При этом информация, хранящаяся сейчас в этих таблицах будет уничтожена. "
					+"Рекомендуется сначала выполнить архивацию данных. "
				);
	}	
	INFO_BD_TYPE.setText(sInfo);	
}

function source_valid()
{
	INFO_SOURCE.setText("");
		
	loadSource();
	
	sSourceFile = FSOURCE.value;
	FSOURCE.setBackground(0xFFFFFF);
	if(!sSourceFile || !isFile(sSourceFile))
	{
		INFO_SOURCE.setText(UR("Виберіть файл-джерело|Выберите файл-источник"));				
		FSOURCE.setBackground(0xFFAAAA);
		setFocus(FSOURCE);
		return false;
	}
	
	return true;
}

function base_valid()
{
	if(RGBASE.value=="NEW")
	{
		FBASE.setBackground(0xFFFFFF);
		INFO_DB.setText("");
		
		var sTblName = grid_DB.getTable().getTableName();
		var subd = String(FSUBD.value).toUpperCase();
		var server = FSERVER.value;
		var base = String(FBASE.value).trim().toUpperCase();		
		if(base=="")
		{
			INFO_DB.setText("Введіть назву нової бази|Введите название новой базы");
			return;
		}
		
		var oSnap = getSnap("select FBASE from "+ sTmpTbl 
							+" where UPPER(FSUBD)='"+ subd +"'"
								+" and FSERVER='"+ server +"'"
								+" and UPPER(FBASE)='"+ base +"'"
							);
		if(oSnap)
		{
			setFocus(FBASE);
			FBASE.setBackground(0xFFAAAA);			
			INFO_DB.setText(UR("Така база вже існує|Такая база уже существует"));
			return false;
		}
	}
	return true;
}

function modcheck_valid()
{
	if(CDBMOD.value==true)
	{
		INFO_DBMOD.setText(UR("Після завершення імпорту буде виконано оновлення"
								+" структури бази з переіндексацією усіх таблиць."
							+"|После завершения импорта будет выполнено обновление"
								+" структуры базы с переиндексацией всех таблиц."
							));
	}
	else
	{
		INFO_DBMOD.setText(UR("Після імпорту рекомендується виконати модифікацію структур (меню Сервис/Оновлення структур БД)."
								+" При роботі з немодифікованою базою можуть виникати помилки."
								+" Для прискорення роботи з базою потрібно виконати переіндексацію імпортованих таблиць."
							+"|После импорта рекомендуется выполнить модификацию струкур (меню Сервис/Обновление структур БД)."
								+" При работе с немодифицированной базой могут возникать ошибки."
								+" Для ускорения работы с базой необходимо выполнить переиндексацию импортированных таблиц."
							));
	}
}

function loadSource()
{
	try
	{
		if(FSOURCE.value==sSourceFile)
			return false;
		sSourceFile = FSOURCE.value;
		if(!isFile(sSourceFile))
			return false;
		
		var freeMemory = java.lang.Runtime.getRuntime().maxMemory()
						- java.lang.Runtime.getRuntime().totalMemory()
						+ java.lang.Runtime.getRuntime().freeMemory();
		var memory = round(freeMemory/(1024*1024)/10, 3);
		var size = round(Number(DpFile(sSourceFile).length())/(1024*1024), 3);
		if(size>memory)
		{
			var sMsg = UR("Файл-джерело завеликий: "
							+"\n	розмір файлу - "+ size +" МВ, "
							+"\n	доступно пам'яті - "+ memory +" МВ."
							+"\nЗавантаження файлу може призвести до зриву програми."
							+"\nПродовжити імпорт?"
						+"|Файл-источник слишком большой: "
							+"\n	размер файла - "+ size +" МВ, "
							+"\n	доступно памяти - "+ memory +" МВ."
							+"\nЗагрузка файла может привести к срыву программы."
							+"\nПродолжить импорт?"
						);
			if(!confirm(sMsg))
				return false;
		}
		
		var xmlDoc = new DpXMLDOMDocument();
		xmlDoc.load(sSourceFile);
		var xmlDocElement = xmlDoc.getDocumentElement();
		sSourceSUBD = Number(xmlDocElement.getAttribute("subd"));
		sSourceBase = String(xmlDocElement.getAttribute("database"));		
		/*
		if(sSourceBase.toUpperCase()==getPath("ALL_MDB").toUpperCase())
			return;		
		var oSnap = getSnap("select FSUBD, FSERVER from "+ sTmpTbl 
							+" where UPPER(FBASE)='"+ sqlTo(sSourceBase.toUpperCase())
								+" and FSUBD='"+ sqlTo(orgMan.getSUBD())
								+" and FSERVER='"+ sqlTo(orgMan.getServer())
							, false
							);
		if(!oSnap)
		{
			sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE"
						+", FCOMP, FPORT, FTT, FCOMMENT)"
					+" values ("+ sqlTo(nBase++) 
						+", '"+ orgMan.getSUBD() +"'"
						+", '"+ orgMan.getServer() +"'"
						+", '"+ sSourceBase +"'"
						//+", '"+ orgMan.getOrgPath() +"'"
						+", '"+ orgMan.getComp() +"'"
						+", '"+ orgMan.getPort() +"'"
						+", 'O'"
						+", '"+ UR("Оригінал|Оригинал") +"'"
						+")";
			ExecuteSQL(sSQL);		
		}
		*/ 
	}
	catch(e)
	{
		alert(e);
	}
	return true;
}

function loadBaseList()
{
	closeTables();
	ExecuteSQL("drop table "+ sTmpTbl, false);
	var sSQL = "create table "+ sTmpTbl 
			+" (FBASE "+ SqlType("TEXT", 50) +" default "+ sqlEmpStr 
			+", FSUBD "+ SqlType("TEXT", 15) +" default "+ sqlEmpStr 
			+", FSERVER "+ SqlType("TEXT", 250) +" default "+ sqlEmpStr
			+", FID "+ SqlType("INT") +" default 0"
			+", FPATH "+ SqlType("LONGTEXT")
			+", FCOMP "+ SqlType("TEXT", 50) +" default "+ sqlEmpStr
			+", FPORT "+ SqlType("TEXT", 15) +" default "+ sqlEmpStr
			+", FCOMMENT "+ SqlType("TEXT", 250) +" default "+ sqlEmpStr
			+", FCONNECT "+ SqlType("BIT") +" default "+ sqlFalse
			+", FTT "+ SqlType("TEXT", 3) +" default "+ sqlEmpStr
			+", FWID "+ SqlType("COUNTER")
			+")";
	ExecuteSQL(sSQL);
		
	var arrDB = new Object();
		
	sSettingsFile = lpProxy.getSettingsDir() +"XMLOrgs.xml";
	var xmlDom = new DpXMLDOMDocument();	
	xmlDom.load(sSettingsFile);
	var root = xmlDom.getDocumentElement();
	var orgs = root.getChildNodes();
	for(var i = 0; i<orgs.length; i++)
	{
		var org = orgs[i];
		var id = Number(org.getAttribute("ID"));
		var subd = org.getAttribute("SUBD");				
		var comp = org.getAttribute("COMPNAME");
		var port = org.getAttribute("PORT");		
		var base = String(org.getAttribute("USEFORALL")).trim();
		var path = String(org.getAttribute("DOCPARPATH"));
		var server = org.getAttribute("SERVER");
		path = java.lang.String(path).replace("\\", "/");
		server = java.lang.String(server).replace("\\", "/");
		if(port)
			port = String(port);
		else
			port = "";
		var ftt = "C";
		
		if(id==Number(orgMan.getOrg()))
		{
			if(RGBASE.value!="NEW")
			{
				FBASE.value = base;
				FSUBD.value = subd;
				FSERVER.value = server;
				FCOMP.value = comp;
				FPORT.value = port;
				FPATH.value = path;
			}
			ftt = "A";
		}
		
		if(base=="")
		{
			var orgList = org.getChildNodes();
			for(var n=0; n<orgList.length; n++)
			{
				base = String(orgList[n].getText()).trim();
				if(base=="" || arrDB[subd +"_"+ server +"_"+ base]!=null)
					continue;
					
				arrDB[subd +"_"+ server +"_"+ base] = id;
				var sComment = (ftt=="A"? UR("Активна|Активная") : UR("Підключена|Подключенная"));
				sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE, FPATH"
							+", FCOMP, FPORT, FTT, FCONNECT, FCOMMENT)"
						+" values ("+ id +", '"+ subd +"', '"+ server +"'" 
							+", '"+ base +"', '"+ path +"', '"+ comp +"', '"+ port +"'"
							+", '"+ ftt +"', "+ sqlTrue 
							+", '"+ sComment +"'" 
							+")";
				ExecuteSQL(sSQL);
			}
			continue;
		}
		
		if(base=="" || arrDB[subd +"_"+ server +"_"+ base]!=null)
			continue;
		arrDB[subd +"_"+ server +"_"+ base] = id;
		var sComment = (ftt=="A"? UR("Активна|Активная") : UR("Підключена|Подключенная"));
		sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE, FPATH"
					+", FCOMP, FPORT, FTT, FCONNECT, FCOMMENT)"
				+" values ("+ id +", '"+ subd +"', '"+ server +"'"
					+", '"+ base +"', '"+ path +"', '"+ comp +"', '"+ port +"'"
					+", '"+ ftt +"', "+ sqlTrue 
					+", '"+ sComment +"'"
					+")";
		ExecuteSQL(sSQL);
		
		if(id>nWorkBase)
			nWorkBase = id;
	}
	
	loadUsers();
		
	nBase = nWorkBase+1;	
	var arrBase = lpProxy.getDBManager().getDatabases()
	for(var i=0; i<arrBase.length; i++)
	{		
		base = arrBase[i];		
		if(base=="information_schema" || isUserBase(base))
			continue;
		if(base=="" || arrDB[subd +"_"+ server +"_"+ base]!=null)
			continue;
		arrDB[subd +"_"+ server +"_"+ base] = id;
		var path = java.lang.String(orgMan.getOrgPath()).replace("\\", "/");
		var server = java.lang.String(orgMan.getServer()).replace("\\", "/");
		sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE, FPATH, FCOMP, FPORT)"
				+" values ("+ nBase++ 
					+", '"+ orgMan.getSUBD() +"'"
					+", '"+ server +"'"
					+", '"+ arrBase[i] +"'"
					+", '"+ path +"'" 
					+", '"+ orgMan.getComp() +"'"
					+", '"+ orgMan.getPort() +"'" 
					+")";
		ExecuteSQL(sSQL);
	}
	
	var strConn = strForDBConnection("localhost", MYSQL);
	var conn = lpProxy.getDBManager().getConnection(strConn, "root", "", false);
	if(conn)
	{
		var oSnap = getSnap("select FSERVER from "+ sTmpTbl 
							+" where FSUBD='MYSQL'"							
							);
		if(!oSnap)
		{
			var path = DpFile(orgMan.getOrgPath()).getParent() +"/org2";
			path = java.lang.String(path).replace("\\", "/");
			sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE"
						+", FPATH, FTT, FCOMMENT)"
					+" values ("+ nBase++ 
						+", 'MYSQL'"
						+", 'localhost'"
						+", 'dpbase'" 
						+", '"+ path +"'"
						+", 'N'"
						+", '"+ UR("Нова (буде створена)|Новая (будет создана)") +"'"
						+")";
			ExecuteSQL(sSQL);
		}
	}
	
	strConn = strForDBConnection("dpbase", POSTGRE);
	conn = lpProxy.getDBManager().getConnection(strConn, "postgres", "", false);
	if(conn)
	{
		var oSnap = getSnap("select FSERVER from "+ sTmpTbl 
							+" where FSUBD='POSTGRE'"							
							);
		if(!oSnap)
		{
			var path = DpFile(orgMan.getOrgPath()).getParent() +"/pgdpbase";
			path = java.lang.String(path).replace("\\", "/");
			sSQL = "insert into "+ sTmpTbl +" (FID, FSUBD, FSERVER, FBASE, FPATH"
						+", FCOMP, FPORT, FTT, FCOMMENT)"
					+" values ("+ nBase++ 
						+", 'POSTGRE'"
						+", 'dpbase'"
						+", 'dpbase'"
						+", '"+ path +"'"
						+", 'localhost'"
						+", '5432'"
						+", 'N'"
						+", '"+ UR("Нова (буде створена)|Новая (будет создана)") +"'"
						+")";
			ExecuteSQL(sSQL);
		}
	}
}

function isUserBase(sBase)
{
	for(var i=0; i<arrUser.length; i++)
	{
		var sLogin = String(arrUser[i]).trim().toUpperCase();
		if(sLogin==String(sBase).toUpperCase())
			return true;
	}
	return false;
}

function loadUsers()
{
	var sAdminFile = lpProxy.getAdminMng().getAdministrationFile();
	var docAdmin = lpProxy.openXmlFile(sAdminFile);
	var mainElem = docAdmin.getDocumentElement();
	var logList = mainElem.getElementsByTagName("LOGIN");
	for(var i=0; i<logList.length; i++)
	{
		var sLogin = logList.item(i).getAttribute("value");
		if(sLogin==null || sLogin=="")
			continue;		
		arrUser[i] = sLogin;
	}
}