//для Черкасс
//просмотр амортизации за квартал по введённой дате
include ("Objects\\DpGetDat.js");
include ("firstkv.js");
include ("lastkv.js");
include("norm_am.js");

var CaptDat,captDat, dt, tblOut;

function listLoad()
{
	dt = new DpGetDat("d");
	if (dt.escape == true)
		return false;
	dt = new Date(firstkv(dt.dat1));
	CaptDat = StrDat(dt, "DMY");
	captDat = CaptDat = CaptDat + ' - ' + StrDat(lastkv(dt), "DMY");
	this.xmlGridFile = "l_amnn.xml";
	this.printLabel = "amort";
	var oSnap = getSnap("select * from ^RAMORT where Fdatkv="+sqlTo(dt));
	if(oSnap==null)
	{
		alert(ru("Амортизация за данный квартал не рассчитана!","Амортизацію за даний квартал не розраховано!"));
		return false;
	}
}

function listMake()
{
	DropTable("TAMO1");
	DropTable("TAMO2");
	DropTable("AMORT_OUT");
	if (IsTable("AMORT_OUT"))
	{
		alert(ru("Невозможно загрузить просмотр."
           +"\nПроверьте, возможно окно с данным просмотром уже открыто,"
           +"\nили перезапустите систему.",
           "Неможливо завантажити перегляд."
           +"\nПеревірте, можливо вікно з даним переглядом вже відкрито,"
           +"\nабо перезапустіть систему."));
		return false;
	}
	CreateTable("AMORT_OUT", "AMORT");
	
	var min_zp  = getPar("MINZP");
	ram = OpenTable("s","SELECT Famort, Fbalst, Fdatkv, Fgroup, Finv_num, "
				+"Fiznos,Fkompl,Fprib,Fvib FROM ^RAMORT WHERE Fdatkv="+sqlTo(dt));
	ram.MoveFirst();
	while (!ram.IsEOF())
	{
		if (Number(ram.getValue("Fbalst"))!=0 || Number(ram.getValue("Famort"))!=0 || Number(ram.getValue("Fiznos"))!=0)
		{
			m = new Object();	
			m.Finv_num  = (Number(ram.getValue("Fkompl"))!=0)?0:ram.getValue("Finv_num");
			m.Fkompl    = Number(ram.getValue("Fkompl"));
			m.Fgroup    = Number(ram.getValue("Fgroup"));
			m.Forig_pric=(Number(ram.getValue("Fbalst"))+Number(ram.getValue("Fprib"))
						-Number(ram.getValue("Fvib"))>0)?Number(ram.getValue("Fbalst"))
						+Number(ram.getValue("Fprib"))-Number(ram.getValue("Fvib")):0;
			m.Fkf_ispol = 1;
			m.Fiznos    = 0;
			m.Fvost_rate= norm_am(dt, ram.getValue("Fgroup"), "")*100;
			m.Fsum_pv   = Number(ram.getValue("Famort"));
			m.Fsum_izn  = Number(ram.getValue("Fiznos"));
			m.Fdatkv    = dt.getVarDate();
			m.Fdat_post = new Date(3000,0,1).getVarDate();
			if ((Number(ram.getValue("Fgroup"))==1 || Number(ram.getValue("Fgroup"))==11) && Number(ram.getValue("Fbalst"))+Number(ram.getValue("Fprib"))-Number(ram.getValue("Fvib"))<=100*min_zp)
				m.Forig_pric=0;
			if (Number(ram.getValue("Finv_num"))==0)
				m.Ftdsc=1;
			UpdateTable("AMORT_OUT",m,true);
		}
		ram.MoveNext();
	}// end while (!ram.IsEOF())
	
	strSQL = "select sum(AMORT_OUT.Fsum_pv) as Fsum_pv, sum(AMORT_OUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORT_OUT.Forig_pric) as Forig_pric, "+
			"1 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup, Fvost_rate into TAMO1 from AMORT_OUT "+
			" where Fgroup=1 or Fgroup=11 group by Fgroup, Fvost_rate";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORT_OUT.Fsum_pv) as Fsum_pv, sum(AMORT_OUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORT_OUT.Forig_pric) as Forig_pric, "+
			"2 as Ftdsc, 0 as finv_num, 0 as Fkompl, 9 as Fgroup into TAMO2 from AMORT_OUT ";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORT_OUT " + getColumn("TAMO1", true) + 
			" select " + getColumn("TAMO1", false) + " from TAMO1";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORT_OUT " + getColumn("TAMO2", true) + 
			" select " + getColumn("TAMO2", false) + " from TAMO2";
	ExecuteSQL(strSQL, true);
}

function listTitle()
{
	return  "Амортизацiя по ОЗ за квартал "+CaptDat+"|Амортизация по ОС за квартал "+CaptDat;
}

function listSrc()
{
	this.qrySet	("From", "AMORT_OUT", "Order", "Ftdsc, Fgroup, Fkompl DESC, Finv_num");
	this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	this.subTie("KOMPL", "x_kompl", "KOMPL", "Fkompl");
}
include ("sys\\DpList.js");