include ("firstkv.js");
include ("lastkv.js");
include ("Objects\\DpGrid.js");
include ("r_amnalm.js");
include ("r_amnalc.js");

var ds, gr;
var prnPatt = "amrti";
var editAcc = ""
var delFilter = false
var captDat;
var sCaptDat = "";
var par;

function listLoad()
{
	menuMode = GetMenuMode();
	if(!menuMode && this.par.menuMode)
		menuMode = this.par.menuMode;
	if(menuMode=="VIEW")
	{
		if (!IsTable("AMORTIN"))
		{
			// Текст лучше сменить
			alert(ru("Амортизация не просчитана. Сначала сделайте расчет",
				"Амортизацiю не розраховано. Спочатку виконайте розрахунок."));
			return false;
		}
	}
	else
	{
		if(menuMode=="CALCM")
		{
			par = new Object();
			par.escape = true;
			par.rdat1 = getPar("GLOBDAT1");
			par.numtot = 1;
			showWindow("i_aminds.xml",SW_MODAL,par);
			if (par.escape)
				return false;
			rdat1 = new Date(par.rdat1);
			rnumtot = par.numtot;
			Caption("Розрахунок амортизацiї по ОЗ - "+StrDat(rdat1, "DMY")+"| Расчет амортизации по ОС  - "+StrDat(rdat1, "DMY"));
			r_amnalm(rdat1, rnumtot);
		}
		else
		{
			par = new Object();
			par.escape = true;
			par.rdat1   = getPar("GLOBDAT1");
			par.numtot = 1;
			showWindow("i_aminds.xml",SW_MODAL,par);
			if (par.escape)
				return false;
			rdat1   = new Date(par.rdat1);
			rnumtot = par.numtot;
			Caption("Розрахунок амортизацiї поквартально по ОЗ - "+StrDat(rdat1, "DMY")+"| Расчет амортизации поквартально по ОС  - "+StrDat(rdat1, "DMY"));
			r_amnalc(rdat1, rnumtot);
		}
	}
	tcaptDat = getSnap("SELECT " + First("Fdatkv")
			+ " FROM ^amortin"
			+ " WHERE Fdatkv<>" + sqlTo(d00));
	if (tcaptDat==null)
	{
		alert(ru("Амортизация не просчитана. Сначала сделайте расчет","Амортизацiю не розраховано. Спочатку виконайте розрахунок."));
		return false;
	}
	else
		captDat = tcaptDat[0];
	if (captDat)
		sCaptDat = StrDat(captDat, "DMY");
	this.xmlGridFile = "l_amnalm.xml";
	this.printLabel = "AMRTI";
}

function listTitle()
{
   return  "Амортизацiя по кожному ОЗ - "+sCaptDat+"|Амортизация по каждому ОС - "+sCaptDat;
}

function listSrc()
{
	list.qrySet("From", "AMORTIN"
				, "WhereArr", new Array(
								"Ftdpodr=1 OR Ftda3<>0 OR Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0",
                                "Ftdpodr=2 OR Ftda3<>0 OR Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0",				
								"Ftdpodr=0 AND (Ftda3<>0 OR Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND (Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND (Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND (Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND (Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND Ftdsu=0 AND Ftdsc<>0",
								"Ftdpodr=0 AND Ftda3<>0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND Ftdsu=0 AND Ftdsc=0")
		, "WhereArrName", new Array("Свернуть по признаку приватизации", 
									"Свернуть до подразделений", 
									"Свернуть до аналитики 3",
									"Свернуть до аналитики 2",
									"Свернуть до аналитики 1",
									"Свернуть до статей",
									"Свернуть до субсчетов",
									"Свернуть до счетов",
									"Только 3-я ан-ка(для проводок)"
									)								
		, "Ptn", "AMORT"
		,"Order","FDB_SC, FTDSC, FDB_SU, FTDSU, FDB_ST, FTDST, FDB_COD1, FTDA1, FDB_COD2, FTDA2, FDB_COD3, FTDA3, FPODR, FTDPODR, FINV_NUM"
		);

	if (SQL)
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	else
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
}

function listGrid1()
{
alert(1)	
   //-------------grid---------------
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		onePageMode(false);

		defCond("=CBool(^Ftdpodr<>0)", "ITOG_PODR");
		bold("ITOG_PODR");
		color(20, "ITOG_PODR");

		defCond("=CBool(^Ftdsc=2 and ^Fgroup <> 0)", "ITOG_GR");
		bold("ITOG_GR");
		color(2, "ITOG_GR");

		defCond("=CBool(^Ftdsc=1)", "ITOG_SC");
		bold("ITOG_SC");
		color(3, "ITOG_SC");

		defCond("=CBool(^Ftdsu=1)", "ITOG_SU");
		bold("ITOG_SU");
		color(4, "ITOG_SU");

		defCond("=CBool(^Ftdst=1)", "ITOG_ST");
		bold("ITOG_ST");
		color(5, "ITOG_ST");

		defCond("=CBool(^Ftda1=1 or ^Ftda2=1 or ^Ftda3=1)", "ITOG_A");
		bold("ITOG_A");
		color(1, "ITOG_A");

		defCond("=CBool(^Ftdsc=2 and ^Fgroup = 0)", "ITOG_ALL");
		bold("ITOG_ALL");
		color(14, "ITOG_ALL");
		
		//with(prefix())
		with(page())		
		{
		
			cell("Finv_num", "Iнв.№ |Инв.№", 6, "zn");

			var sz = "=iif(^Ftdpodr=2, \"" + UR("По пiдр.: |По подр.: ") + "\" + Cstr(^Fpodr), "
					+ "iif(^Ftdpodr=1 and ^Fnotprivat, \"" + UR("Не пiдл.приватизац. по пiдр.: |Не подлежат приватиз. по подр.") + "\"+ Cstr(^Fpodr), "
					+ "iif(^Ftdpodr=1 and ^Fnotprivat=false, \"" + UR("Пiдл.приватизац. по пiдр.: |Подлежат приватиз. по подр.") + "\"+ Cstr(^Fpodr), "
					+ "iif(^Ftdsc=1, \"" + UR("По рахунку: |По счету: ") + "\" + Cstr(^Fdb_sc), "
					+ "iif(^Ftdsu=1, \"" + UR("По субрахунку: |По субсчету: ") + "\" + Cstr(^Fdb_sc) + \" / \" + CStr(^Fdb_su), "
					+ "iif(^Ftdst=1, \"" + UR("По статтi: |По статье: ") + "\" + Cstr(^Fdb_sc) + \" / \" + CStr(^Fdb_su) + \" / \" + CStr(^Fdb_st), "
					+ "iif(^Ftda1=1, \"" + UR("По ан.1: |По ан.1: ") + "\" + Cstr(^Fdb_sc) + \" / \" + CStr(^Fdb_su) + \" / \" + CStr(^Fdb_st) + \" / \" + CStr(^Fdb_cod1), "
					+ "iif(^Ftda2=1, \"" + UR("По ан.2: |По ан.2: ") + "\" + Cstr(^Fdb_sc) + \" / \" + CStr(^Fdb_su) + \" / \" + CStr(^Fdb_st) + \" / \" + CStr(^Fdb_cod1) + \" / \" + CStr(^Fdb_cod2), "
					+ "iif(^Ftda3=1, \"" + UR("По ан.3: |По ан.3: ") + "\" + Cstr(^Fdb_sc) + \" / \" + CStr(^Fdb_su) + \" / \" + CStr(^Fdb_st) + \" / \" + CStr(^Fdb_cod1) + \" / \" + CStr(^Fdb_cod2) + \" / \" + CStr(^Fdb_cod3), "
					+ "iif(^Ftdsc=2 and ^Fgroup=0, \"" + UR("Всього по рахунках:|Всего по счетам:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=1, \"" + UR("Амортизацiя по 1 групi:|Амортизация по 1 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=2, \"" + UR("Амортизацiя по 2 групi:|Амортизация по 2 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=3, \"" + UR("Амортизацiя по 3 групi:|Амортизация по 3 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=4, \"" + UR("Амортизацiя по 4 групi:|Амортизация по 4 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=5, \"" + UR("Амортизацiя по 5 групi:|Амортизация по 5 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=11, \"" + UR("Амортизацiя по 11 групi:|Амортизация по 11 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=12, \"" + UR("Амортизацiя по 12 групi:|Амортизация по 12 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=13, \"" + UR("Амортизацiя по 13 групi:|Амортизация по 13 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=14, \"" + UR("Амортизацiя по 14 групi:|Амортизация по 14 группе:") + "\", "
					+ "iif(^Ftdsc=2 and ^Fgroup=15, \"" + UR("Амортизацiя по 15 групi:|Амортизация по 15 группе:") + "\", "
					+ "^x_osnazv.Ftxt))))))))))))))))))";

			cell(sz, "Назва ОЗ |Название ОС", 24, "w");
				
			cell("Fsum_am", "Первiсна\nвартiсть|Первонач.\nстоимость", 15);
			cell("Forig_pric", "Баланс.варт.\nна поч.мiс|Баланс.стоим.\nна нач.мес", 15);
			cell("Fgroup", "Гр.|Гр.", 3, "zn");
		//}
		
		//with(page())
		//{
			cell("Fsum_pv", "Аморт.відр.\nв поточн.мiс|Аморт.отч.\nв текущ.мес", 15);
			cell("Fsum_izn", "Всього ам.відр.\nна кiнець мiс|Всего ам.отч.\nна конец мес", 15);
			cell("Flikvst", "Лiквiд.вартiсть|Ликвид.стоим.", 15);			
			cell("Fnotprivat", "Не \nприв|Не \nприв", 3);			
			//cell("Fgosnum", "Гос.N|Гос.N", 15);
			cell("Fnop", "N oп.|N oп.", 5);
			cell("Ftxts", "Назва|Назв.", 10);
			cell("FkatOS", "Катег. \nОЗ|Катег. \nОС",5);
			cell("FtypeOS", "Тип \nОЗ|Тип \nОС", 4);
			cell("Fiznos", "Гр.по б/о|Гр.по б/у", 3, "zn");			
			
		}

		with(page())
		{
			with(group("Віднес.витрат на|Отнес.затрат на"))
			{
				cell("=iif(^Fdb_sc=999, \"\", ^Fdb_sc)", "рах.|сч.", 5);
				cell("=iif(^Fdb_sc=999, \"\", ^Fdb_su)", "с/р.|с/сч.", 5);   
				cell("=iif(^Fdb_sc=999, \"\", ^Fdb_st)", "ст.|ст.", 5);   
			}
		}
		
		build();
	}	
}

function listMenuInit()
{  
	with( list.dataSrc )
   {
		if (!list.tbl.IsEOF() && !list.tbl.IsBOF())
		{
                    AddMenuItem("TODOC", ru("Формирование проводок", "Формування проведень"))
                    AddMenuItem("DOCEKZ", ru("Реестр сформированных операций", "Реєстр сформованих операцій"))
                    AddMenuItem("PRINT", ru("Печать", "Друк"), ICON_PRT)
                    AddMenuItem ("","");
		}
   }
}

function listMenuRun(ID)
{	
   var cDoc = "AB";
   switch(ID)
   {
	// Формирование проводок
	case "TODOC":
		include("Objects\\DpDstDoc.js");
		var oDstDoc = new DpDstDoc(cDoc);
		if(oDstDoc.findNop())
		{
			var t2Doc = OpenTable("s", 
				"SELECT *"
				+ " FROM amortin"
				+ " WHERE " + DataSource().sqlSelected()
				);
			var m = new Object();
			while(!t2Doc.IsEOF())
			{
				m.HDAT   = captDat;
				m.HSC        = t2Doc.getValue("Fdb_sc");
				m.HSU        = t2Doc.getValue("Fdb_su");
				m.HST        = t2Doc.getValue("Fdb_st");
				m.HA1        = t2Doc.getValue("Fdb_cod1");
				m.HA2        = t2Doc.getValue("Fdb_cod2");
				m.HA3        = t2Doc.getValue("Fdb_cod3");
				m.HPODR      = t2Doc.getValue("fpodr");
				m.HSUM       = t2Doc.getValue("Fsum_pv");
				oDstDoc.append(m);
				t2Doc.MoveNext();
			}
			t2Doc.close();
			oDstDoc.done();
		}
		break;
	case "DOCEKZ":
		var oPar = new Object();
		oPar.doc = cDoc;
		showWindow("l_docekz.xml", SW_NOMODAL, oPar);
		break;
    case "PRINT":
        include("objects\\DpTVars.js");
        var tv = new DpTVars(prnPatt);
        var bm = list.tbl.bookmark;
        tv.setRTbl(list.tbl);
        var h = new Object();
		if (!list.tbl.IsEmpty())
		{
			h.FD1 = quarter_begin(captDat);
			h.FD2 = quarter_end(captDat);
			h.D1 = quarter_begin(captDat);
			h.D2 = quarter_end(captDat);
		} 
		else
		{
			h.FD1 = d00;
			h.FD2 = d00;
			h.D1 = d00;
			h.D2 = d00;
		}
        tv.setHTbl(h);
        tv.print();
        list.tbl.bookmark = bm;
        break;
       default:
            return;
   }
}

include ("sys\\DpList.js");