//для Черкасс
//просмотр амортизации за месяц по введённой дате
include ("Objects\\DpGetDat.js");
include ("izosdatb.js");

var CaptDat, dt, tblOut;

function listLoad()
{
	dt = new DpGetDat("d");
	if (dt.escape == true)
		return false;
	dt = new Date(firstDay(dt.dat1));
	CaptDat = StrDat(dt, "DMY");
	this.xmlGridFile = "l_amnalm.xml";
	var oSnap = getSnap("select * from ^RAMORIB where Fdatkv="+sqlTo(dt));
	if(oSnap==null)
	{
		alert(ru("Амортизация за данный месяц не расчитана!","Амортизацію за даний місяць не розраховано!"));
		return false;
	}
}

function listMake()
{
	DropTable("AMORTOUT");
	if (IsTable("AMORTOUT"))
	{
		alert(ru("Невозможно загрузить просмотр."
           +"\nПроверьте, возможно окно с данным просмотром уже открыто,"
           +"\nили перезапустите систему.",
           "Неможливо завантажити перегляд."
           +"\nПеревірте, можливо вікно з даним переглядом вже відкрито,"
           +"\nабо перезапустіть систему."));
		return false;
	}
	DropTable("TVN");
	DropTable("TAM0");
    DropTable("TAM00");
	DropTable("TAM1");
	DropTable("TAM2");
	DropTable("TAM3");
	DropTable("TAM4");
	DropTable("TAM5");
	DropTable("TAM6");
	DropTable("TAM7");
	DropTable("TAM8");
	DropTable("TAM9");
	DropTable("TAM10");
	DropTable("TAM11");
	DropTable("TAM12");
	
	CreateTable("AMORTOUT", "AMORT");
	ExecuteSQL("ALTER TABLE AMORTOUT ADD Fnop "+SqlType("LONG"), false)
	ExecuteSQL("ALTER TABLE AMORTOUT ADD Ftxts "+SqlType("TEXT"), false)
	ExecuteSQL("ALTER TABLE AMORTOUT ADD Ftabn "+SqlType("LONG"), false)
	ExecuteSQL("ALTER TABLE AMORTOUT ADD Fnotprivat "+SqlType("BIT"), false)
	ExecuteSQL("ALTER TABLE AMORTOUT ADD FkatOS "+SqlType("LONG"), false)
	ExecuteSQL("ALTER TABLE AMORTOUT ADD FtypeOS "+SqlType("LONG"), false)
	
	strSQL = "select * INTO TVN from ^VN_PEREM where "+sqlTo(dt)+">=Fbdat and "+sqlTo(dt)+"<=Fedat ";
	ExecuteSQL(strSQL, true);
	
	vn = OpenTable("s", "TVN");
	var prev_dt = new Date(dt.getFullYear(), dt.getMonth(), dt.getDate()-1);
	var dt_e = new Date(lastDay(prev_dt));
	rami01 = OpenTable("s", "select * from ^RAMORIB where (Fampred=3 or Fampred=0) and Fdatkv="+sqlTo(dt));
	if (!rami01.IsEmpty())
	{
		rami01.MoveFirst();
		var oDoc = new DpDoc("O7",0);
		while (!rami01.IsEOF())
		{
			if (rami01.getValue("Flicv") != true)
			{
				mFprice = Number(izosdatb(dt_e, Number(rami01.getValue("Finv_num")), "orig_pric"));
				if (mFprice==-100)
					Number(mFprice = izosdatb(dt, Number(rami01.getValue("Finv_num")), "orig_pric"));
				if (mFprice==-100)
					mFprice = 0;  
			}
			else
				mFprice = 0;
			m = new Object();
			m.Finv_num= Number(rami01.getValue("Finv_num"));
			m.Fkompl  = 0;
			m.Fgroup  = Number(rami01.getValue("Fgroup"));
			m.Fsum_am = mFprice;
			m.Forig_pric= (Number(rami01.getValue("Fbalst"))+Number(rami01.getValue("Fprib"))-Number(rami01.getValue("Fvib"))>0)?Number(rami01.getValue("Fbalst"))+Number(rami01.getValue("Fprib"))-Number(rami01.getValue("Fvib")):0;
			m.FKF_ISPOL = 1;
			m.FIZNOS    = Number(izosdat(dt, Number(rami01.getValue("Finv_num")), "group"));       
//			m.FVOST_RATE= round(nr_am*100, 3);
			m.FSUM_PV   = Number(rami01.getValue("Famort"));
			m.FSUM_IZN  = Number(rami01.getValue("Fiznos"));
			m.FDATKV    = dt.getVarDate();
			m.FDAT_POST = d00;
			m.Flicv  = rami01.getValue("Flicv");
			m.Fkol  = Number(rami01.getValue("Fkol"));
			m.FkatOS  = 0;
			m.FtypeOS = 0;
			gS = getSnap("select Fgod_vip,Fvvod_ecsp,Fwid from ^OS7 where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
			if (gS != null)
			{
				m.Fgod_vip   = Number(gS[0]);
				m.Fvvod_ecsp = gS[1];
				//12.10.06 m  расширения к инв.карт. 
				var nID = gS[2];
				oDoc.clear();
				oDoc.loadByID(nID);      
				if (oDoc.getExt("XAROS")!="undefined")    
					m.FkatOS = oDoc.getExt("XAROS");
				if (oDoc.getExt("TYPOS")!="undefined")    
					m.FtypeOS = oDoc.getExt("TYPOS");
				//****
			}
			else
			{
				m.Fgod_vip   = 0;
				m.Fvvod_ecsp = d00obj.getVarDate();
			}
			gS = getSnap("select Fnach_plat from ^OS1 where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
			if (gS != null)
				m.Fnach_plat = gS[0];
			else
				m.Fnach_plat = d00obj.getVarDate();
			//12.10.06 m
			gS = getSnap("select Fnach_plat,Fnop,Fnotprivat,Fdoc from ^OS1 where finv_num=" + sqlTo(rami01.getValue("Finv_num")))
			if (gS != null)
			{
				m.Fnach_plat = gS[0];
				m.Fnop = Number(gS[1]);
				m.Fnotprivat = gS[2];
				strSQL = "select Ftxts from ^CL_LNK where Fnop="+sqlTo(gS[1])+" and Fdoc="+sqlTo(gS[3]);
				var gSn = getSnap(strSQL);
				if (gSn!=null)
					m.Ftxts = gSn[0];             
				else
					m.Ftxts = "";
			}
			else
			{
				m.Fnach_plat = d00obj.getVarDate();
				m.Fnop  = 0;
				m.Ftxts = "";             
			}
			//********** 
			if ((Number(rami01.getValue("Fgroup"))==1 || Number(rami01.getValue("Fgroup"))==11) && Number(rami01.getValue("Fbalst"))+Number(rami01.getValue("Fprib"))-Number(rami01.getValue("Fvib"))<=100*min_zp)
				if (getSnap("select * from ^OS7 where Finv_num="+sqlTo(rami01.getValue("Finv_num"))) != null)
					m.Forig_pric= 0;
			mFpodr = 0;
			mFscvn = 0;
			mFsuvn = 0;
			mFstvn = 0;
			mFclvn1 = 0;
			mFclvn2 = 0;
			mFclvn3 = 0;
			if (Number(rami01.getValue("Fcalcnum"))==1)
			{
				if (!vn.IsEmpty())
				{
					gS = getSnap("select Fpodr,Fsc,Fsu,Fst,Fcl_cod1,Fcl_cod2,Fcl_cod3 from ^TVN where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
					if (gS != null)
					{
						mFpodr = Number(gS[0]);
						mFscvn = Number(gS[1]);
						mFsuvn = Number(gS[2]);
						mFstvn = Number(gS[3]);
						mFclvn1 = Number(gS[4]);
						mFclvn2 = Number(gS[5]);
						mFclvn3 = Number(gS[6]);
					}
				}
			}
			else
			{
				if (!vn.IsEmpty())
				{
					gS = getSnap("select Fpodr from ^TVN where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
					if (gS != null)
						mFpodr = Number(gS[0]);
				}
				gS = getSnap("select Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdbl_cod3 from ^OS7 where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
				if (gS != null)
				{
					mFscvn = Number(gS[0]);
					mFsuvn = Number(gS[1]);
					mFstvn = Number(gS[2]);
					mFclvn1 = Number(gS[3]);
					mFclvn2 = Number(gS[4]);
					mFclvn3 = Number(gS[5]);
				}
			}
			m.FDB_SC = mFscvn;
			m.FDB_SU = mFsuvn;
			m.FDB_ST = mFstvn;
			m.FDB_cod1 = mFclvn1;
			m.FDB_cod2 = mFclvn2;
			m.FDB_cod3 = mFclvn3;
			m.FPODR  = mFpodr;
			mFzt_sc = 0;
			mFzt_su = 0;
			mFzt_st = 0;
			mFzt_cod1 = 0;
			if (!vn.IsEmpty())
			{
				gS = getSnap("select Fsc,Fsu,Fst,Fcl_cod1 from ^TVN where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
				if (gS != null)
				{
					mFzt_sc = Number(gS[0]);
					mFzt_su = Number(gS[1]);
					mFzt_st = Number(gS[2]);
					mFzt_cod1 = Number(gS[3]);
				}
			}
			m.Fzt_sc = mFzt_sc;
			m.Fzt_su = mFzt_su;
			m.Fzt_st = mFzt_st;
			m.Fzt_cod1 = mFzt_cod1;
			gS = getSnap("select Fost_licv from ^OS1 where Finv_num=" + sqlTo(rami01.getValue("Finv_num")));
			if (gS != null && gS[0] == true)
				m.Flicv  = true;
			UpdateTable("AMORTOUT",m,true);
			rami01.MoveNext();
		}
	}
	rami01.close();
	vn.close();
	
	//подбивка итогов по индивидуальному расчету
	//Fnotprivat
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, fpodr, 1 as ftdpodr, Fnotprivat, "+
			"0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 0 as Ftda2, 0 as Ftda3, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM00 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, Fpodr, Fnotprivat";
	ExecuteSQL(strSQL, true);

	//PODR
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, fpodr, 1 as ftdpodr, "+
			"0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 0 as Ftda2, 0 as Ftda3, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM0 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, Fpodr";
	ExecuteSQL(strSQL, true);

	//AN3
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, "+
			"0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 0 as Ftda2, 1 as Ftda3, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM1 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3";
	ExecuteSQL(strSQL, true);

	//AN2
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, Fdb_cod1, Fdb_cod2, "+
			"0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 1 as Ftda2, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM2 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2";
	ExecuteSQL(strSQL, true);

	//AN1
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, Fdb_cod1, "+
			"0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 1 as Ftda1, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM3 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1";
	ExecuteSQL(strSQL, true);

	//ST
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, fdb_st, 1 as ftdst, "+
			"0 as Ftdsu, 0 as Ftdsc, 0 as finv_num, 0 as Fkompl, 0 as Fgroup into TAM4 from AMORTOUT "+
			" group by Fdb_sc, Fdb_su, Fdb_st";
	ExecuteSQL(strSQL, true);

	//SU
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, fdb_su, "+
			"1 as Ftdsu, 0 as Ftdsc, 0 as finv_num, 0 as Fkompl, 0 as Fgroup  into TAM5 from AMORTOUT "+
			" group by fdb_sc, fdb_su";
	ExecuteSQL(strSQL, true);

	//SC
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, fdb_sc, "+
			"1 as Ftdsc, 0 as finv_num, 0 as Fkompl, 0 as Fgroup  into TAM6 from AMORTOUT "+
			" group by fdb_sc";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, 0 as Fgroup  into TAM7 from AMORTOUT ";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup into TAM8 from AMORTOUT "+
			" where Fgroup=1 or Fgroup=11 group by fgroup";
	ExecuteSQL(strSQL, true);
	//12.10.06 m
	strSQL = "INSERT into AMORTOUT " + getColumn("TAM00", true) + 
			" select " + getColumn("TAM00", false) + " from TAM00";
	ExecuteSQL(strSQL, true);
	//***********
	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup into TAM9 from AMORTOUT "+
			" where Fgroup=2 or Fgroup=12  group by fgroup";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup into TAM10 from AMORTOUT "+
			" where Fgroup=3 or Fgroup=13  group by fgroup";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0  as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup into TAM11 from AMORTOUT "+
			" where Fgroup=4 or Fgroup=14  group by fgroup";
	ExecuteSQL(strSQL, true);

	strSQL = "select sum(AMORTOUT.Fsum_pv) as Fsum_pv, sum(AMORTOUT.Fsum_am) as Fsum_am, sum(AMORTOUT.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTOUT.Forig_pric) as Forig_pric, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num, 0 as Fkompl, Fgroup into TAM12 from AMORTOUT "+
			" where Fgroup=5 or Fgroup=15 group by fgroup";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM0", true) + 
			" select " + getColumn("TAM0", false) + " from TAM0";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM1", true) + 
			" select " + getColumn("TAM1", false) + " from TAM1";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM2", true) + 
			" select " + getColumn("TAM2", false) + " from TAM2";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM3", true) + 
         " select " + getColumn("TAM3", false) + " from TAM3";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM4", true) + 
         " select " + getColumn("TAM4", false) + " from TAM4";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM5", true) + 
         " select " + getColumn("TAM5", false) + " from TAM5";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM6", true) + 
         " select " + getColumn("TAM6", false) + " from TAM6";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM7", true) + 
         " select " + getColumn("TAM7", false) + " from TAM7";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM8", true) + 
         " select " + getColumn("TAM8", false) + " from TAM8";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM9", true) + 
         " select " + getColumn("TAM9", false) + " from TAM9";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM10", true) + 
         " select " + getColumn("TAM10", false) + " from TAM10";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM11", true) + 
         " select " + getColumn("TAM11", false) + " from TAM11";
	ExecuteSQL(strSQL, true);

	strSQL = "INSERT into AMORTOUT " + getColumn("TAM12", true) + 
         " select " + getColumn("TAM12", false) + " from TAM12";
	ExecuteSQL(strSQL, true);

	ExecuteSQL("SELECT * INTO AMORTI_TMP FROM AMORTOUT ORDER BY "
         + "FDB_SC,FTDSC,FDB_SU,FTDSU,FDB_ST, FTDST,FDB_COD1, "
         + "FTDA1,FDB_COD2,FTDA2,FDB_COD3,FTDA3,FPODR,FTDPODR,FGROUP,FINV_NUM")

	DropTable("AMORTOUT");			
	ExecuteSQL("SELECT * INTO AMORTOUT FROM AMORTI_TMP");	
	DropTable("AMORTI_TMP");
}

function listTitle()
{
	return  "Амортизацiя по кожному ОЗ - "+CaptDat+"|Амортизация по каждому ОС - "+CaptDat;
}

function listSrc()
{
	this.qrySet("From", "AMORTOUT"
				, "WhereArr", new Array(
								"Ftdpodr<>0 OR Ftda3<>0 OR Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0",
								"Ftdpodr=0 AND (Ftda3<>0 OR Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND (Ftda2<>0 OR Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND (Ftda1<>0 OR Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND (Ftdst<>0 OR Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND (Ftdsu<>0 OR Ftdsc<>0)",
								"Ftdpodr=0 AND Ftda3=0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND Ftdsu=0 AND Ftdsc<>0",
								"Ftdpodr=0 AND Ftda3<>0 AND Ftda2=0 AND Ftda1=0 AND Ftdst=0 AND Ftdsu=0 AND Ftdsc=0")
		, "WhereArrName", new Array("Свернуть до подразделений", 
									"Свернуть до аналитики 3",
									"Свернуть до аналитики 2",
									"Свернуть до аналитики 1",
									"Свернуть до статей",
									"Свернуть до субсчетов",
									"Свернуть до счетов",
									"Только 3-я ан-ка(для проводок)"
									)								
		, "Ptn", "AMORT"
		,"Order","Fdb_sc,Ftdsc,Fdb_su,Ftdsu,Fdb_st,Ftdst,Ftda1,Ftda2,Ftda3,,Ftdpodr,Fpodr,Finv_num");
	this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
}
include ("sys\\DpList.js");