//просмотр и расчёт амортизации НДС
include("r_amnds.js");
include("objects\\DpGetDat.js");
include("servis\\date.js")
include("izosdat.js");
include("izosdatb.js");
include("koef_am.js");
include("norm_am.js");
include("r_zpnds.js");
include("r_zpndsn.js");
//include("riznnds.js");
include("riznosb.js");
include("riznosbp.js");
include("riznos.js");

var ds,t, gr;
var listPrnForm = "amrti";
var editAcc = ""
var delFilter = false
var captDatb, captDate;

function listLoad()
{
	menuMode = GetMenuMode();
	if(menuMode=="VIEW")
	{
		if (!IsTable("AMORTSRN"))
		{
			alert(ru("Амортизация НДС не просчитана. Сначала сделайте расчет",
				"Амортизацiю ПДВ не розраховано. Спочатку виконайте розрахунок."));
			return false;
		}
	}
	else
	{
		var gd=new DpGetDat("d");
		if (gd.escape)
			return false;
		rdat1   = new Date(gd.dat1);

		Caption("Розрахунок амортизацiї ПДВ - "+StrDat(rdat1, "DMY")+"| Расчет амортизации НДС  - "+StrDat(rdat1, "DMY"));

		tblNameDate = "AMORTSRN_DT";
		DropTable(tblNameDate);
		strSQL = "CREATE TABLE " + tblNameDate + " (fbdat "+SqlType("DATE")+", fedat "+SqlType("DATE")+")";
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO " + tblNameDate + " (fbdat, fedat) VALUES (" + sqlTo(firstDay(rdat1)) + ", " + sqlTo(lastDay(rdat1)) + ")";
		ExecuteSQL(strSQL);
		r_amnds (rdat1);
	}
	var oSnap = getSnap("SELECT Fbdat, Fedat FROM AMORTSRN_DT");
	if (oSnap!=null)
	{
		captDatb = oSnap[0];
		captDate = oSnap[1];
	}
	else
	{
		captDatb = d00;
		captDate = d00;
	}
	this.title = "Амортизацiя по кожному ОЗ - "+format("dd-mm-yyyy", captDatb)
				+ "|Амортизация по каждому ОС - "+format("dd-mm-yyyy", captDatb)
	this.xmlGridFile = "l_amnds.xml";
}

function listSrc()
{
	this.qrySet("From", "AMORTSRN", "Order", "FKEYEXPR", "WhereArr", 
			new Array("", "^Ftdpodr<>0 OR ^Ftda3<>0 OR ^Ftda2<>0 OR ^Ftda1<>0 OR ^Ftdst<>0 OR ^Ftdsu<>0 OR ^Ftdsc<>0"), 
			"Ptn", "AMORT");
	this.subTie("OSNAZV", "x_osnazv", "FINV_NUM", "Finv_num");
}

function listMenuInit()
{  
	with( this.dataSrc )
	{
		if (!this.tbl.IsEOF() && !this.tbl.IsBOF())
		{
			AddMenuItem("VVKOEF", ru("Формир.сумм для списка изм.стоимости", 
								"Форм.сум для списку змiни варт."))
			AddMenuItem("ZPOS0B", ru("Запись в изм.стоим.по б/у", 
								"Запис в змiни варт. по б/о"))
			AddMenuItem("ZPOS0", ru("Запись в изм.стоим.по н/у", 
								"Запис в змiни варт. по п/о"))
			AddMenuItem("ZPBS1", ru("Выгрузка в бух.справки аморт.НДС", 
								"Вигрузка в бух.довiдки аморт.ПДВ"))
			AddMenuItem("PRINT", ru("Печать", "Друк"), ICON_PRT)
			AddMenuItem ("","");
		}
	}
}

function listMenuRun(ID)
{	
	switch(ID)
	{
		// Формир.сумм для списка изм.стоимости
		case "VVKOEF":
			var kfraspr=0;
			//kfraspr = input("Введите к-т распределения НДС", "", 0, 8,6);
			var form = createForm(ru("Введите к-т распределения НДС","Введіть к-нт розподілення ПДВ"));
			var koef = form.addObj("kf","float","");
			koef.mask="-#.######";
			form.show();
			if(form.escape)
				return false;
			kfraspr = form.kf;
			if (kfraspr!=0)
			{
				strSQL = "UPDATE AMORTSRN set Fiznos = Fsum_pv*"+sqlTo(kfraspr)
				ExecuteSQL(strSQL);
				list.tbl.requery();
				grid.refresh();
			}
			break;
		case "ZPOS0B":
			var t3Doc = OpenTable("s", "SELECT * FROM amortsrn WHERE " + DataSource().sqlSelected());
			r_zpnds(t3Doc);
			t3Doc.close()
			break;
		case "ZPOS0":
			var t3Doc = OpenTable("s", "SELECT * FROM amortsrn WHERE " + DataSource().sqlSelected());
			r_zpndsn(t3Doc);
			t3Doc.close()
			break;
		// Выгрузка в бух.справки аморт.НДС
		case "ZPBS1":
			DropTable("BSNDS")
			strSQL = "SELECT * into BSNDS  FROM amortsrn  WHERE " + DataSource().sqlSelected();
			ExecuteSQL(strSQL);  
			break;
		case "PRINT":
			/*include("objects\\DpTVars.js");
			var tv = new DpTVars(prnPatt);
			var bm = list.tbl.bookmark;
			tv.setRTbl(list.tbl);
			var h = new Object();
			if (!list.tbl.IsEmpty())
			{
				h.FD1 = captDat;
				//h.FD2 = quarter_end(captDat);
				//h.D1 = quarter_begin(captDat);
				//h.D2 = quarter_end(captDat);
			} 
			else
			{
				h.FD1 = d00;
				//h.FD2 = d00;
				//h.D1 = d00;
				//h.D2 = d00;
			}
			tv.setHTbl(h);
			tv.print();
			list.tbl.bookmark = bm;*/
			break;
	}
}

function getTblH()
{
	var obj = new Object();
	obj.FD1 = captDatb;
	obj.FD2 = captDate;
	return obj;
}
include ("sys\\DpList.js");