include("Objects\\DpGetDat.js");
include("doc\\dpDocPtn.js");
include("objects\\DpGrid.js");
include("sys\\udfs.js");

//__CreateGrid();
var gr;

var ds,t;
var zmbDate;
var zmeDate;
var nPodr;


function listLoad()
{
	with( list )
	{
		subAsk = listAsk;
		subSrc = listSrc;
		printLabel = "brnk_rows";
		objTotal.init("BRNK")
//		objTotal.init("obsch")
	}
}

function listAsk()
{
	var gd=new DpGetDat(new Array("r","p0"));
	zmbDate = gd.dat1;
	zmeDate = gd.dat2;
	nPodr = gd.fpodr;
	
	return gd;
}

function listDpGrid()
{
	with(new DpGrid("NOCREATE"))
	{
		with(page())
		{
			//cell("fdate", "Дата", 9);
			with(group("Подразделение"))
			{
				cell("fpodr", "Код", 5);
				cell("=^PD.FTXT", "Наименование", 9);
			}
			with(group("Банк"))
			{
				cell("fbank", "Код", 5);
				cell("=^BNK.FTXT", "Наименование", 9);
			}
			cell("FMARKA", "Марка", 10);			
			cell("FSUM_POL", "Получено", 11,null,DP_FORMAT_SUM);
			cell("FSUM_VSKLAD", "Возврат на склад", 11,null,DP_FORMAT_SUM);
			cell("FSUM_VPOK", "Возврат от покупателя", 11,null,DP_FORMAT_SUM);
			cell("FSUM_REAL", "Реализовано", 11,null,DP_FORMAT_SUM);
			cell("FSUM_DISCOUNT", "Скидки", 11,null,DP_FORMAT_SUM);
			cell("FSUM_VITORG", "Выторг", 11,null,DP_FORMAT_SUM);
			cell("FSUM_CALC1", "Инкасация", 11,null,DP_FORMAT_SUM);
			cell("FSUM_V2POK", "Возврат денег покупателю", 11,null,DP_FORMAT_SUM);
			cell("FSUM_CRED", "Кредитные карточки", 11,null,DP_FORMAT_SUM);
			cell("FSUM_VCRED", "Возврат по кредитным карточкам", 11,null,DP_FORMAT_SUM);
			cell("FSUM_RRO", "Показания РРО", 11,null,DP_FORMAT_SUM);
			cell("FSUM_KRK", "Показания терминала по кр/к Приватбанк", 11,null,DP_FORMAT_SUM);
			cell("FSUM_KRK2", "Показания терминала по кр/к Райффайзенбанк", 11,null,DP_FORMAT_SUM);
			cell("FSUM_CALC2", "Ошибка по кр/к", 11,null,DP_FORMAT_SUM);
			cell("FSUM_CALC3", "Ошибка  выторга", 11,null,DP_FORMAT_SUM);
			cell("FSUM_2BNK", "Сдано в банк", 11,null,DP_FORMAT_SUM);
			cell("Fdoc_num", "№ Документа", 11);
			
		}
		build();
		setColorField("Fttlevel");	
	}
}

function listTitle()
{
	return "Продажи по магазинам по дням";
}

function listSrc()
{
	if(zmbDate && zmeDate)
		cWhere = "a.FDATE BETWEEN "
				+ sqlTo(zmbDate)+" AND "+sqlTo(zmeDate);
	else
		cWhere = sqlCmpTrue;
	cWhere += sqlw0And("b.fpodr=", nPodr);

	var tblSource = getTmpTableName(null, true);
	ExecuteSQL("SELECT b.fpodr "
			+ ", SUM(a.FSUM_VITORG - a.FSUM_V2POK - a.FSUM_CRED + a.FSUM_VCRED) as FSUM_CALC1"
			+ ", SUM(a.FSUM_CRED - a.FSUM_KRK - a.FSUM_KRK2 + a.FSUM_VCRED) as FSUM_CALC2"
			+ ", SUM(a.FSUM_REAL - a.FSUM_DISCOUNT - a.FSUM_VITORG) as FSUM_CALC3"
			+ ", SUM(a.FSUM_POL) as FSUM_POL"
			+ ", SUM(a.FSUM_VSKLAD) as FSUM_VSKLAD"
			+ ", SUM(a.FSUM_VPOK) as FSUM_VPOK"
			+ ", SUM(a.FSUM_REAL) as FSUM_REAL"
			+ ", SUM(a.FSUM_DISCOUNT) as FSUM_DISCOUNT"
			+ ", SUM(a.FSUM_VITORG) as FSUM_VITORG"
			+ ", SUM(a.FSUM_V2POK) as FSUM_V2POK"
			+ ", SUM(a.FSUM_CRED) as FSUM_CRED"
			+ ", SUM(a.FSUM_VCRED) as FSUM_VCRED"
			+ ", SUM(a.FSUM_RRO) as FSUM_RRO"
			+ ", SUM(a.FSUM_KRK) as FSUM_KRK"
			+ ", SUM(a.FSUM_KRK2) as FSUM_KRK2"
			+ ", SUM(a.FSUM_2BNK) as FSUM_2BNK"	
			+ "," + Convert("0", "INT") + " AS FBANK "		
			+ "," + Convert("0", "STR", 30) + " AS FMARKA "		
			+ ", " + First("b.Fdoc_num") +" as Fdoc_num"		
		+ " INTO " + tblSource + " FROM ^RBRNK a "
		+ " left join ^HBRNK b on a.fid_doc = b.fwid WHERE FTT=1 AND "
			+ cWhere
			+ " and b.fwid is not null "
		+ " GROUP BY b.fpodr")
		
	ExecuteSQL("ALTER TABLE "+tblSource+" ADD FTT "+SqlType("TEXT"),false);
	ExecuteSQL("ALTER TABLE " + tblSource +" ADD FWID "+ SqlType("COUNTER"));
	var tbl = OpenTable("SELECT * FROM " + tblSource);
	while (!tbl.IsEOF())
	{
		m = new Object();
		m.Fwid = Number(tbl.getValue("Fwid"));
		m.FBANK = xcl(sprPodr, Number(tbl.getValue("Fpodr")), "BANK");
		m.FMARKA = xcl(sprPodr, Number(tbl.getValue("Fpodr")), "MARKA");
	   	UpdateTable(tblSource, m, false);
	   	
	    tbl.MoveNext();
	}
	tbl.close();
		
	this.qrySet("From", tblSource
				,"Order", new Array("FMARKA", "Fdoc_num")
   				);
	// подр
	this.subTie("clrelclcl","CLRELPD","CLCOD","="+sqlTo(sprPodr)+",FPODR");
	this.subTie("cl","PD","FWID","CLRELPD.FWID_CL",null,TIE_NOSEARCH);
	this.subTie("clrelclcl","CLRELBNK","CLCOD","="+sqlTo(sprOrg)+",FBANK");
	this.subTie("cl","BNK","FWID","CLRELBNK.FWID_CL",null,TIE_NOSEARCH);
	
	this.htmPrnList = "brnk_rows"; 
	
	addTtlTbl();
	grid.setColorField("Fttlevel");
}


function getTblH()
{
	var obj = new Object();
	
    obj.FD1  = zmbDate;
    obj.FD2  = zmeDate;
	obj.FCAPTION1 = "Продажи по дням " + String(nPodr == 0 ? "по всем магазинам" : tcl("CL", "TXT", sprPodr, nPodr));
	return obj;
}

include("sys\\DpList.js");