function listDpGrid()
{
	include("Objects//DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var bool = "=(!^fsch && !^fsub && !^fsta && !^fact) ? ";		
	oGrid.defCond("=(!^fsch && !^fsub&& !^fsta && !^fact)", "main");
	oGrid.color(1, "main");
	with (oGrid.page())
	{
    	cell(bool + "^BU_WITH_B.Fnazv1 : ''","Рядок балансу|Строка баланса",40, null, "%10d");
	    cell(bool + "^fline : ''","№ рядка|№ строки",7, null, "%10d");
	    cell(bool + "'' : ^fsch", "Рах.|Счёт",4, null, "%10d");
	    cell(bool + "'' : ^fsub", "C/рах|C/Сч.",4, null, "%10d");
	    cell(bool + "'' : ^fsta", "Cт|Cт",4, null, "%10d");
	    cell(bool + "'' : ^fact","Вид|Вид",4, null, "%10d");
	}	
	oGrid.build();
	
	//Становимся на нужную строку
	if(typeof extPar != "undefined" && typeof extPar.nLine == "number")
	{
		//индекс первой строки
		var startInd = DataSource().getRowSelected();
		
		var tGridName = DataSource().getTable().getTableName();
		var ind = getSnap("SELECT COUNT(*) FROM "+tGridName+" WHERE FLINE < "+sqlTo(extPar.nLine))[0];
		
		DataSource().setRowSelected(ind+startInd);
		grid.refresh();
	}
}

function listLoad()
{
	this.title = "Включення рахунків в рядки балансу|Включение счетов в строки баланса";
	var strSQL= "DELETE FROM ^balans_u WHERE NOT (fids IN (SELECT b.fwid FROM ^balans b))";
    ExecuteSQL(strSQL);
    
	if (SQL)
	{
		if (SUBD == ORACLE)
		{
			strSQL = "UPDATE ^BALANS_U " +
				"SET FLINE = (SELECT FLINE FROM ^BALANS " +
				"WHERE ROWNUM = 1 AND ^BALANS_U.FIDS = ^BALANS.FWID) " +
				"WHERE EXISTS (SELECT FLINE FROM ^BALANS " +
				"WHERE ROWNUM = 1 AND ^BALANS_U.FIDS = ^BALANS.FWID)";
		}
		else
		{
			strSQL = 
				"UPDATE ^balans_u SET fline = " +
				"(SELECT MAX(fline) FROM ^balans WHERE ^balans_u.fids = ^balans.fwid) " +
				"WHERE EXISTS (SELECT MAX(fline) FROM ^balans WHERE ^balans_u.fids = ^balans.fwid)";
		}
	}
	else
		strSQL = 
			"UPDATE ^BALANS_U " +
			"INNER JOIN ^BALANS " +
			"ON ^BALANS_U.FIDS = ^BALANS.FWID " +
			"SET ^BALANS_U.FLINE = ^BALANS.FLINE";
				
    ExecuteSQL(strSQL);

    strSQL = "INSERT INTO ^balans_u (fids, fline, fkd_str, fsch) " +
             "SELECT a.fwid AS fids, a.fline AS fline, a.fkd_str AS fkd_str, 0 AS fsch " +
             "FROM ^balans a WHERE NOT EXISTS (SELECT * FROM ^balans_u b WHERE b.fids = a.fwid)";
    ExecuteSQL(strSQL);
    
   	var doptab = OpenTable("s", "SELECT fwid, fids, fsch, fsta, fsub FROM ^balans_u WHERE fwid is null");
   	if (!doptab.IsEmpty)
   	{ 
   		doptab.MoveFirst();  	
   		while (!doptab.IsEOF())
   		{   		
   			ExecuteSQL("UPDATE ^balans_u SET fwid=" + sqlTo(GetUID()) + 
   				" WHERE fids=" + sqlTo(doptab.getValue("fids")) +
	   			" AND fsch=" + sqlTo(doptab.getValue("fsch")) + 
	   			" AND fsta=" + sqlTo(doptab.getValue("fsta")) +
	   		   	" AND fsub=" + sqlTo(doptab.getValue("fsub")));
			doptab.MoveNext();
		}
	}
	doptab.Close();
}

function listSrc()
{
	this.qrySet("From", "^BALANS_U", "Order", new Array("fline, fsch, fsub, fsta"));
	if (SQL)
		this.subTie("BALANS","BU_WITH_B","FLINE","fline");
	else
		this.subTie("BALANS","BU_WITH_B","balans","fline");
}

function listAfterLoad()
{
	if (this.tbl.isEmpty())
		alert(UR("Додайте спочатку рядки балансу!|Добавте сначала строки баланса!"), ICON_WARNING);
}

function listMenuInit()
{
	with (this.dataSrc)
	{
   		if (!(this.tbl.IsEOF() && this.tbl.IsBOF()))
   		{
   		    AddMenuItem("ADD", "Додавання номеру рахунку|Добавление номера счета");
            if ((this.tbl.getValue("fsch") != null) && (this.tbl.getValue("fsch") != 0))
            {
                AddMenuItem("EDIT", "Редагування номеру рахунку|Редактирование номера счета");
		        if(!CanDeleteRecord(this.tbl))
            		this.accDel = new Function("return true");
            	else
            		this.accDel = new Function("return false");
	        }
	        AddMenuItem("PRINT","Друк включення рахунків|Печать включения счетов");
        }
        else
          alert(UR("Додайте спочатку рядки балансу!|Добавте сначала строки баланса!"), ICON_WARNING);
    }
}

function listMenuRun(ID)
{
	par = new Object();
	switch (ID)
	{
		case "PRINT":
    	    stdMenuHandler(ID,this.tbl);
    	    break; 
    	case "EDIT":
    		par.fwid = this.tbl.getValue("fwid");
    	case "ADD":   		    	 
    	    par.tbl = this.tbl;
			par.mode = ID;						
			showWindow("e_bsch2.xml", SW_MODAL , par);
			break;    	        
	}
}

include("sys\\DpList.js");