include("objects\\DpGetDat.js");
include("objects\\DpGrid.js");
include("objects/DpCalendar.js");
include("servis/date.js");

var isTabn = false;
var bdate, edate;
var mFtabn;
var mFcod;
var gd, dat1, dat2;
var sqlWhere;

function listLoad()
{
	this.title = extPar.title?extPar.title:ru("Календарь","Календар");
	this.editTask = "e_calendar.xml";
}

function listSrc()
{
	if (typeof(extPar) != "undefined")
	{
		if (extPar.isTabn==true)
			isTabn = true;
		mFcod = typeof(extPar.fcod) != "undefined" ? extPar.fcod : 0;

		if (extPar.zaval)
		{
			var form = createForm(UR("Введіть данні для відбору інформації|Введите данные для отбора информации"));
			var D1=form.addObj("D1","date",UR("Дата початку періоду|Дата начала периода"));
			D1.setValue(new Date(today.getFullYear(), 0, 1).getVarDate());
			var D2=form.addObj("D2","date",UR("Дата кінця періоду|Дата конца периода"));
			D2.setValue(new Date(today.getFullYear(), 11, 1).getVarDate());
			form.setFormValid(D1,D1_valid);
			form.setFormValid(D2,D2_valid);
			if (isTabn)
				oCl = form.addCodPers(false);
			form.show();
			
			if(form.escape==true)
				return false;
			bdate = new Date(form.D1);
			edate = new Date(form.D2);
			if (isTabn)
			{
				mFtabn = oCl.getCod();
				this.title += " по таб.№"+mFtabn;
			}
			sqlWhere = "(FDATE BETWEEN " + sqlTo(bdate) + " AND " + sqlTo(edate)+") "
						+sqlw0And("FCOD = ", mFcod)
						+sqlw0And("FTABN = ", mFtabn)
		}
	}
	else
	{
		gd = new DpGetDat("dD");
		if(gd.escape)
			return false;
		dat1 = gd.dat1;
		dat2 = gd.dat2;

	    this.qrySet();
		sqlWhere = "FDATE >= "+sqlTo(dat1)
				+" AND FDATE <= "+sqlTo(dat2)
	}
	this.qrySet("From", "^HCALEND", "Where", sqlWhere, "Order", "FCOD, FDATE, FTABN")
	this.clTie("REL", "="+getPar("CODPERS")+",FTABN");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	gr.FieldEx("FCOD","№ календаря",10);
    gr.FieldEx("FDATE","Дата",8);
    gr.FieldEx("FREM","Коментар|Комментарий",20);
    if (isTabn)
    {
    	gr.FieldEx("FTABN","Таб.№",3);
    	gr.FieldEx("REL.FTXT","ПІБ|ФИО",20);
	}
    gr.FieldEx("FFULLTIME","Повн.тиждень|Полн.неделя",5);
    gr.FieldEx("FHALFTIME","Неповн.тиждень|Неполн.неделя",5);
	oGrid.build();
}

function listMenuInit()
{
	if(this.tbl.rowCount>0)
	{
		grid.AddMenuItem("SET_OTP_DAYS","Проставити кіл-ть днів в календарних днях для відпускних|Проставить кол-во дней в календарных днях для отпускных");
	}
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "SET_OTP_DAYS":
			var oCal = new dpCalendar();
			oCal.setCod(this.tbl.getValue("Fcod"));
			var t = OpenTable("select * from ^hcalend where "+grid.sqlSelected());
			for(; !t.IsEOF(); t.MoveNext())
			{
				var bdat = firstDayMonth(t.getValue("Fdate"));
				var edat = lastDayMonth(t.getValue("Fdate"));
				var days = edat.getDate()-oCal.getCalDays("П",bdat,edat);
				var snap = getSnap("select Fwid from ^cl_kalen where Fbdat="+sqlTo(bdat));
				var fwid = 0;
				if(snap)
					fwid = snap[0];
				var m = new Object();
				if(fwid==0)
					m.Fwid = GetUID();
				m.Fbdat = bdat;
				m.Fkoldn = days;
				UpdateTable("^cl_kalen", m, fwid==0, "Fwid="+fwid);
			}
			t.Close();
			grid.clearSelected();
			grid.refresh();
			alert(ru("Данные перенесены в список календарные дни для отпускных,\nкоторый находится в меню ",
					"Данні перенесено в сисок календарні дні для відпускних,\nякий знаходиться в меню ")+getMenuItemPath("l_kalen.js","l"));
		break;
	}
}

function D1_valid()
{
	if(differ(D1.getValue(),D2.getValue())>=0)
	{
		WAIT(ru("Начальная дата не может быть больше конечной!",
				"Початкова дата не може бути більше кінцевої!"));
		return false;
	}
}

function D2_valid()
{
	if(differ(D1.getValue(),D2.getValue())>=0)
	{
		WAIT(ru("Конечная дата не может быть меньше начальной!",
				"Кінцева дата не може бути менше початкової!"));
		return false;
	}
}

function sqlBeetwin(szField, dDat1, dDat2)
{
	return szField + " BETWEEN " + sqlTo(dDat1) + " AND " + sqlTo(dDat2);
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^RCALEND"
		+" WHERE FID_CAL="+sqlTo(list.tbl.getValue("FWID")));

	ExecuteSQL("DELETE FROM ^HCALEND"
		+" WHERE FWID = "+sqlTo(list.tbl.getValue("FWID")));
}

function listInitEditParam(par)
{
	par.fcod = mFcod;
	par.ftabn = mFtabn;
	par.tbl_cl_cal = extPar.tbl_cl_cal;
	par.tbl_hc = list.tbl;
}
include("sys\\DpList.js")