include("objects/DpJRegistrator.js");

var strSelectID = "0";
var Jtype = "U";

var bufTbl = getTmpTableName();

var oReg = null;

var isZaval = (extPar && extPar.zaval);

var TREE_ITEM = 3;
var TREE_FOLDER = 1;
var TREE_FOPEN = 0;
var ICON_PAR	= 8;

function onLoad()
{
	Jtype = (extPar && extPar.jtype?extPar.jtype:GetMenuMode());
	if (Jtype == "U")
		Caption(UR("Довідник журналів реєстрації|Справочник журналов регистрации"));
	else if (Jtype == "S")
		Caption(UR("Журнали налогової реєстрації|Журналы налоговой регистрации"));
	else if (!isZaval)
		return false;
	if (!isZaval)
		oReg = new DpJRegistrator(null,null,Jtype);
	else
		oReg = new DpJRegistrator(null,null,"US");
	Tree.setItemImage(TREE_FOPEN,rootDirectoryEx() + "/icons/Jo.gif");
	Tree.setItemImage(TREE_FOLDER,rootDirectoryEx() + "/icons/Jc.gif");
	
	this.Tree_mnuHandler = Tree_mnuHandler;
	this.Tree_mnuInit = Tree_mnuInit;
	this.onTreeSelected = onTreeSelected;
	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	Tree.loadMenuHandler(this, "Tree_mnuInit");
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	
	Tree.addColumn("journal",UR("Журнал"),300);
	Tree.addColumn("type",UR("Тип"),80);
	Tree.addColumn("def",UR("Замовчення|Умолчание"),100);
	Tree.addColumn("rem",UR("Коментарий"),200);
	
	fill_Tree();
	
	this.canEdit = tree_canEdit;
	Tree.setCanEditHandler(this,"canEdit");
}

function tree_canEdit(sItem,sCol)
{
	return false;
}

function onTreeSelected(sCod,sMode)
{
	if("ENTER" != sMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = sCod;
}

function Tree_mnuHandler(sID,toObject)
{
	var isJournal = strSelectID != "0" && strSelectID.substr(0,1) == "J";
	var sReg = "";
	if (isJournal)
		sReg =  String(strSelectID.substr(1)).toUpperCase();
	else
	{
		if (Tree.getItem(strSelectID) != null)
		{
			var sRegId = Tree.getItem(strSelectID).getParentItem().getData();
			sReg =  String(sRegId.substr(1)).toUpperCase();
		}
	}
	if (sID == "DOUBLECLICK" && isZaval && isJournal)
	{
		extPar.ret = new Object();
		extPar.ret.jID = sReg;
		extPar.ret.txt = oReg.listJournals()[extPar.ret.jID].getName();
		CloseWindow();
		extPar.escape = false;
		return;
	}

	if (sID == "REGDOCS")
	{
		var oPar = new Object();
		oPar.freg = sReg;
		
		showWindow("l_regekz.js",SW_NOMODAL,oPar);
		return;
	}
	
	if (sID == "SHOWREGFLDR")
	{
		var oPar = new Object();		
		oPar.JID = sReg;
		var jor = oReg.listJournals()[sReg];
		if (jor == null) return;
		oPar.type = jor.getType(); 
		showWindow("regdocfldr.js", SW_NOMODAL, oPar);		
		return;
	}
	
	
	if (sID == "CLOP")
	{
		var oPar = new Object();
		oPar.doc = "_R";
		oPar.nop = Jtype + String(strSelectID).toUpperCase();
		showWindow("l_clop.xml", SW_NOMODAL, oPar);
	}

	if (sID == "ADD" || sID == "EDIT" || sID == "ADDP" || sID == "ADDM" || sID == "COPY")
	{
		var oPar = new Object();
		oPar.jType = Jtype;
		if (sID == "ADDP")
		{
			oPar.jType += "P";
			oPar.sMode = "ADD";
		}
		else if (sID == "ADDM")
		{
			oPar.jType += "M";
			oPar.sMode = "ADD";
		}
		else
		{
			oPar.sMode = sID;
		}
		
		var jNum = "0";
		if (sID == "EDIT" || sID == "COPY")
			jNum = sReg;
		oPar.journal = null;
		if (oReg.listJournals(true)[jNum])
			oPar.journal = oReg.listJournals()[jNum];
		else
			oPar.journal = new DpJournal(oPar.jType,jNum);
		if(sID == "COPY")
			oPar.journal.Num = jNum +"_COPY";
			
		var doRefresh = !oPar.journal.editImpl(oPar.sMode);
		oPar.journal.rollbackStructure();
		if (doRefresh)
		{
			if (sID == "ADD" || sID == "ADDP" || sID == "ADDM" || sID == "COPY")
				Tree.addItem("0", "J" + oPar.journal.Num, oPar.journal.Num + "." + oPar.journal.getName(),TREE_FOLDER);
			else
				Tree.modifyItem("J" + oPar.journal.Num, oPar.journal.Num + "." + oPar.journal.getName());
				
			Tree.setValue("J" + oPar.journal.Num,"type",getJType(oPar.journal.sType));
			Tree.setValue("J" + oPar.journal.Num,"rem",oPar.journal.getRem());
			
			Tree.removeAllIn("J" + oPar.journal.Num);
			build_nodesIn(oPar.journal.Num);
		}
		return;
	}
	
	if (sID == "DEL")
	{
		var jNum = String(strSelectID.substr(1)).toUpperCase();
		if (!oReg.listJournals(true)[jNum])
			return;
		var oJ = oReg.listJournals()[jNum];		
		var confrm = msgBox("yn"
							,UR("Видалити журнал |Удалить журнал ")
							+ jNum + " : " + oJ.getName() + " ?"
						    ,UR("Видалення|Удаление"));
		if (confrm != "y")
			return;
		if (oJ.remove())
			Tree.removeItem("J" + jNum);
		return;
	}
	
	if (sID == "GRIDEDIT")
	{
		var jNum = String(strSelectID.substr(1)).toUpperCase();
		if (!oReg.listJournals(true)[jNum])
			return;
		var journal = oReg.listJournals()[jNum];
		var gridFile = journal.getGridDescrFile();
		if (gridFile == null)
		{
			var sMsg = "Створити табличну Форму за змінними журналу|Создать табличную форму по переменным журнала";
			if (!confirm(UR(sMsg))) return;
			
			include ("Objects/DpXMLDomDocument.js");
			var oDom = new DpXMLDOMDocument();
			root = oDom.createElement("grid");
			oDom.appendChild(root);
			
			var vList = journal.getFieldsImpl();
			for (var nFld = 0; nFld < vList.length; nFld++)
			{
				var curFld = vList[nFld];
				xmlFld = oDom.createElement("field");
				
				var fldName = allt(String(curFld.FREM));
				var fldFld = String(curFld.FVAR).toUpperCase();
				if (fldName == "")
				{
					fldName = fldFld;
				}
				var fldWidth = getWdt(curFld.FTYPE);
				
				xmlFld.setAttribute("field", fldFld);
				xmlFld.setAttribute("text", fldName);
				xmlFld.setAttribute("width", fldWidth);
				
				root.appendChild(xmlFld);
			}
			
			gridFile = journal.getPath() + "grid.xml";
			oDom.save(gridFile); 
		}
		
		var par = new Object();
		par.gridfile = gridFile;
		showWindow("dpgrideditor.xml", SW_NOMODAL, par);	
	}
	
	if(sID == "SETREGFLDR")
	{
		var par = nopSelection();
		if(par.escape)
			return;
						
		if(par.retArray && par.retArray.length>0)
		{
			for(var i=0; i<par.retArray.length; i++)
			{
				var oRet = par.retArray[i];
				var doc = oRet.FDOC;
				var nop = oRet.FNOP;
				
				var dpReg = new DpJRegistrator(doc, nop, "US");
				dpReg.regTo(sReg, "", false);
				dpReg.saveReg();
			}
			return;
		}
		
		var doc = par.ret.FDOC;
		var nop = par.ret.FNOP;		
				
		var dpReg = new DpJRegistrator(doc, nop, "US");
		dpReg.regTo(sReg, "", false);
		dpReg.saveReg();
	}
}


function getWdt(type)
{
	type = String(type).toLowerCase();
	switch(type)
	{
		case "date":
			return 9;
		case "text(255)":
			return 15;
	}
	return 7;
}

function Tree_mnuInit(toObject)
{
	var isJournal = strSelectID != "0" && strSelectID.substr(0,1) == "J";
	var isUnit = strSelectID != "0" && strSelectID.substr(0,1) == "V";

	if (isZaval && isJournal)
	{
		extPar.ret = new Object();
		extPar.ret.jID = strSelectID.substr(1);
		extPar.ret.txt = oReg.listJournals()[extPar.ret.jID].getName();
		CloseWindow();
		extPar.escape = false;
		return;
	}

	if (Jtype == "U")
		toObject.AddMenuItem("ADD","Додати журнал|Добавить журнал");
	else
	{
		toObject.AddMenuItem("+++","Додати журнал|Добавить журнал","ADD");
		toObject.AddMenuItem("ADDP","Журнал покупок|Журнал покупок");
		toObject.AddMenuItem("ADDM","Журнал продаж");
		toObject.AddMenuItem("---","");
		toObject.AddMenuItem("REGDOCS","Документи|Документы");
		toObject.AddMenuItem("CLOP", "Операції|Операции");		
	}
	/*isJournal && */toObject.AddMenuItem("EDIT","Редагувати журнал|Редактировать журнал");
	toObject.AddMenuItem("COPY", "Копіювати журнал|Копировать журнал");
	/*isJournal && */toObject.AddMenuItem("DEL","Видалити журнал|Удалить журнал");
	toObject.AddMenuItem("", "");
	/*isJournal && */toObject.AddMenuItem("SHOWREGFLDR","Зареєстровані папки документів|Зарегистрированые папки документов");
	toObject.AddMenuItem("SETREGFLDR","Зареєструвати документи|Зарегистрировать документы");
	isJournal && toObject.AddMenuItem("GRIDEDIT", "Редагивати табличну форму|Редактировать табличную форму");
}

function build_nodesIn(jID)
{
	if (isZaval)
		return;
	var oJ = oReg.listJournals(true)[jID];
	if (!oJ)
		return;
	var flds = oJ.getFieldsImpl();
	for (var i = 0; i < flds.length; i++)
	{
		if (strIn("s",flds[i].FATTR))
			continue;
		Tree.addItem("J" + jID,"V" + flds[i].FVAR,flds[i].FVAR,TREE_ITEM);
		Tree.setValue("V" + flds[i].FVAR,"type",getTextForType(flds[i].FTYPE));
		Tree.setValue("V" + flds[i].FVAR,"rem",flds[i].FREM);
		Tree.setValue("V" + flds[i].FVAR,"def",flds[i].FDEF);
	}
}

function fill_Tree()
{
//-	Tree.addItem("", "0", ru("Журналы регистрации", "Журнали реєстрації"),TREE_FOLDER);
	var allJ = oReg.listJournals();
	for (var jID in allJ)
	{
		var oJ = oReg.listJournals()[jID];
		if (!oJ)
			return;
		Tree.addItem("0","J" + jID,oJ.Num + "." + oJ.getName(),TREE_FOLDER);
		Tree.setValue("J" + jID,"type",getJType(oJ.sType));
		Tree.setValue("J" + jID,"rem",oJ.getRem());
	
		build_nodesIn(jID);
	}
}


function getTextForType(sType)
{
	sType = String(sType).toLowerCase();
	if (sType == "text(255)")
		return UR("текст");
	if (sType == "short")
		return UR("ціле число|целое число");
	if (sType == "long")
		return UR("велике ціле|большое целое");
	if (sType == "currency")
		return UR("сума(ціна)|сумма(цена)");
	if (sType == "double")
		return UR("дійсне|действительное");
	if (sType == "date")
		return UR("дата");
	if (sType == "bit")
		return UR("так/ні|да/нет");
	return sType;
}

function getJType(sType)
{
	if (!sType)
		return "неизв.";
	if (sType == "U")
		return UR("користув.|польз.");
	else if (strIn("S",sType) && strIn("P",sType))
		return "покупок";
	else if (strIn("S",sType) && strIn("M",sType))
		return "продаж";
	return "неизв.";
}

include("sys/DpBaseDlg.js");