//Создание настроечного файла экспорта из дебета в клиент-банк на основе шаблона dbf файла
include("objects/DpXMLDomDocument.js");
include("sys/mask.js");
include("doc/DpDoc.js");
include("sys/dbase.js");

var mode, sFileName;
var field;
var tblName = "BNK_CONFIGEXP";
//массив переменных документа платежек (чтоб не выводить избыточные)
var docVarsAr = new Array("HNOM","HDAT","HSUM","HNDS","HCOT","HCTO",
						"HTOT","HTTO","HMFOOT","HMFOTO","HDBSC","HCRSC",
						"HTOVAR","HVAL","HBNKOT","HBNKTO");

function listLoad()
{
	//создаем таблицу с переменными платежного поручения
	tmpTbl = "PPDOCVARS";
	CreateTable(tmpTbl,"BNK_CONFIG");
	var oDoc = new DpDoc("PP",0);
	var varsInfo = oDoc.getVarsInfo();
	var m = new Object();
	for(var i=0; i<varsInfo.length; i++)
	{
		m.FIELD = varsInfo[i].name;
		m.FTYPE = getType(varsInfo[i].dataType);
		m.FTXT = varsInfo[i].rem;
		if(docVarsAr.some( function(item){ return item==varsInfo[i].name } ) )
			UpdateTable(tmpTbl, m, true);
	}
	
	mode = extPar.mode;
	this.title = (mode=="ADD"?ru("Добавление ","Додавання "):ru("Редактирование ","Редагування "))+ru("настройки экспорта в клиент-банк","налаштування експорту в клієнт-банк");
	this.editTask = "e_clbnkdbfexp.xml";
	this.escape = escape;
	this.save = save;
	CreateTable(tblName,"BNK_CONFIGEXP");
	if(mode=="ADD")
	{
		CONF_NAME.value = "NEWBANK_EXP";
		NAZN.value = ru("Экспорт платежных документов для ","Експорт платіжних документів для ");
	}
	else
	if(mode=="EDIT")
	{
		CONF_NAME.value = extPar.bnkLbl;
		Disable(CONF_NAME);
		//инициализируем общие данные из настроечного xml файла,
		var sPath = getOrgPath() + "clbank/export/" +extPar.bnkLbl+".xml";
		sPath = new DpFile(sPath);
		var xmlDoc = new DpXMLDOMDocument();
		var bLoad = xmlDoc.load(sPath);
		if(!bLoad)
		{
			alert(ru("Ошибка при чтении файла ","Помилка при зчитуванні файлу ")+sPath);
			return false;
		}
		var xmlObj = xmlDoc.getDocumentElement();
		ENCOD.value = String(xmlObj.getAttribute("encodding")).toLowerCase();
		
		//загружаем поля dbf шаблона в таблицу
		sFileName = getOrgPath() + "clbank/export/template/"+extPar.bnkLbl+".dbf";
		sFileName = new DpFile(sFileName);
		if(!isFile(sFileName))
		{
			alert(ru("Не найден файл ","Не знайдено файл ")+sFileName);
			return false;
		}
		loadDBF();
		FSOURCE.value = sFileName;
		
		var childs = xmlObj.getChildNodes();
		var nCount = childs.length;
		for(var n=0; n<nCount; n++)
		{
			var xmlElement = childs[n];
			switch(String(xmlElement.xmlNode.tagName))
			{
				case "NAZN":
					NAZN.value = xmlElement.xmlNode.textContent; 
				break;
				case "REM":
					REM.value = xmlElement.xmlNode.textContent;
				break;
				case "FIELDS":
					fields = xmlElement.getChildNodes();
					fCount = fields.length;
					for(var i=0; i<fCount; i++)
					{
						fieldEl = fields[i];
						var m = new Object();
						var fieldName = fieldEl.xmlNode.tagName;
						var fieldExpr = fieldEl.xmlNode.textContent;
						m.FEXPR = fieldExpr;
						//анализируем выражение и пытаемся определить имя переменной:
						//создадим подмассив элементы которого встречаются в выражении
						//и если это всего одна переменная, тогда ее записываем
						var newDocVarsAr = docVarsAr.filter( function(item){ return fieldExpr.indexOf(item)!=-1; } );
						if(newDocVarsAr.length == 1)
						{
							var snap = getSnap("select Ftype from "+tmpTbl+" where Field="+sqlTo(newDocVarsAr[0]))
							if(snap)
							{
								m.FSOURCE = newDocVarsAr[0];
								m.FTYPESRC = snap[0];
							}
						}
						UpdateTable(tblName, m, false, "Field="+sqlTo(fieldName));
					} 
				break;
			}
		}
	}
	setButton(BTN_OPEN, openDBF);
	setValid(CONF_NAME, conf_Valid);
	Disable(FSOURCE);
	
	if(mode=="ADD")
	{

	}
	else
	{
		Disable(BTN_OPEN);
	}
	this.fldnameSelect = fldnameSelect;
	setFocus(CONF_NAME);
}

function listSrc()
{
	this.qrySet("From", tblName, "Order", "FNUM");
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	var grid = new DpGrid("NOCREATE");
    var gr = grid.page();
	with(gr)
	{
		FieldEx("FNUM", "№|№", 5);
		with(group("Приймач|Приемник"))
		{
			FieldEx("FIELD", "Поле", 10);
			FieldEx("FTYPE", "Тип", 8);
		}
		with(group("Джерело|Источник"))
		{
			FieldEx("FSOURCE", "Змінна|Переменная", 10);
			FieldEx("FTYPESRC", "Тип", 8);
		}
		FieldEx("FEXPR", "Вираз|Выражение", 10);
	}
	grid.build();
}

function openDBF()
{
	sFileName = BrowseForFile("*.dbf", "Файлы  *.dbf");
	if(sFileName)
	{
		loadDBF(true);
		FSOURCE.value = sFileName;
	}
}

function loadDBF(renew)
{
	ExecuteSQL("DELETE FROM "+ tblName, false);
	tblDBF = OpenTable("f",sFileName,ENCOD.value);
	
	var fieldList = tblDBF.getFieldsInfo();
	for(var i = 0; i < fieldList.length; i++) 
	{
		var fld = fieldList[i];
		var fldName = String(fld.getName()).toUpperCase();
		if((fldName.indexOf("#") + fldName.indexOf(".")) >= 0)
			continue;
		var m = new Object();
		m.FNUM = i+1;
		m.FIELD = fldName;
		m.FTYPE = getDPType(fld.getType());
		UpdateTable(tblName, m, true);
	}
	tblDBF.close();
	if(renew)
	{
		grid.DeletePages();
		list.init();//чтоб перезапустить listSrc
	} 
}

function conf_Valid()
{
	var sFile = getOrgPath() + "clbank/export/"+CONF_NAME.value+".xml";
	if(mode=="ADD" && (isFile(sFile) || isFile(sFile.toLowerCase())))
	{
		alert(ru("Настройка с таким именем уже существует!","Налаштування з такою назвою вже існує!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(allt(CONF_NAME.value)=="")
	{
		alert(ru("Пустое название не допустимо!","Неможна вводити порожню назву!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(String(CONF_NAME.value).length>0 && Number(String(CONF_NAME.value)[0])>=0)
	{
		alert(ru("Название не должно начинаться с цифры!","Назва не повинна починатись з цифри!"));
		return false;
	}
	if(!Array.every(String(CONF_NAME.value), isValid))
	{
		alert(ru("В названии допустимо использовать только символы латынского алфавита и цифры!",
				"У назві допустимо використовувати лише символи латинського алфавіту і цифри!"));
		setFocus(CONF_NAME);
		return false;
	}
	return true;
}

function isValid(ch)//принадлежность к латынскому алфавиту и цифрам
{
	return ((ch >= "a" && ch <= "z") || (ch >= "A" && ch <="Z") || (ch >= "0" && ch <= "9") || ch == "_");
}

function getDPType(sType)
{
	sType = String(sType).toLowerCase();
	switch(sType)
	{
		case "string":
			return "text";		
		case "date":
			return "date";
		case "integer":
			return "number";
		case "double":
			return "number";		
		default:
			return sType;
	}
}

function filterMode(s)
{
	switch(s)
	{
		case "VIEW":
		case "COPY":
		case "DEL":
		case "ADD":
		case "__XDEL":
			return false;
		case "EDIT":
			return true;
	}
	return true;		
}

function fldnameSelect()
{
	var par = new Object();
	par.ret = new Object();
	par.ret.FIELD = "";
	par.ret.FTXT = "";
	par.ret.FNUM = "";
	
	par.cells = new Object();

	par.cells[1] = new Object();
	par.cells[1].name = "FNUM";
	par.cells[1].width = 3;
	par.cells[1].text = UR("№|№");

	par.cells[2] = new Object();
	par.cells[2].name = "FIELD";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Стовпчик|Столбик");	
	
	par.cells[3] = new Object();
	par.cells[3].name = "FTYPE";
	par.cells[3].width = 10;
	par.cells[3].text = UR("Тип|Тип");
	
	par.cells[4] = new Object();
	par.cells[4].name = "FTXT";
	par.cells[4].width = 10;
	par.cells[4].text = UR("Примітка|Примечание");

	par.caption = UR("Джерело|Источник");
	t = OpenTable("DBF_"+allt(CONF_NAME.value));
	browse(t, par, SW_MODAL);
	t.close();
}

function save()
{
	if(mode == "ADD")//копируем dbf в папку шаблонов
		copyFile(sFileName, getOrgPath() + "clbank/export/template/" +allt(CONF_NAME.value)+".dbf")
	var sPath = getOrgPath() + "clbank/export/" +allt(CONF_NAME.value)+".xml";
	var xmlDoc = new DpXMLDOMDocument();
	//заносим в исходный xml файл необходимые настройки
	var xmlCLBANK = xmlDoc.createChild("CLBANK", null, {type:"DBF", encodding:ENCOD.value});
	xmlCLBANK.createChild("NAZN", NAZN.value);
	xmlCLBANK.createChild("REM", REM.value);
	var xmlVARDOC = xmlCLBANK.createChild("FIELDS", null);
	for(this.tbl.MoveFirst(); !this.tbl.IsEOF(); this.tbl.MoveNext())
		xmlVARDOC.createChild(this.tbl.getValue("FIELD"), this.tbl.getValue("FEXPR"));
	xmlDoc.save(sPath);
	FORM.close();
}

function escape()
{
	grid.getTable().close();
	FORM.close();
}

function getType(sType)
{
	sType = String(sType).toLowerCase();
	switch(sType)
	{
		case "5":
			return "boolean";		
		case "3":
			return "date";
		case "4":
			return "number";
		case "2":
			return "number";		
		case "1":
			return "text";		
		default:
			return sType;
	}
}