//Создание настроечного файла экспорта из дебета в клиент-банк на основе примера текстового файла
//пример нужен лишь для формирования перечня названий переменных в файле, при отсутствии файла, этот перечень можно сформровать вручную
include("Objects/DpXMLDomDocument.js");
include("Objects/DpGrid.js");
include("sys/mask.js");
include("doc/DpDoc.js");
include("sys/dbase.js");

var mode, sFileName;
var field;
var tblName = "BNK_CONFIGEXP";
var tblRangeName = "TXT_RANGE";
var rangeLength = 0;
var minVarCount = 6;
//массив переменных документа платежек (чтоб не выводить избыточные)
var docVarsAr = new Array("HNOM","HDAT","HSUM","HNDS","HCOT","HCTO",
						"HTOT","HTTO","HMFOOT","HMFOTO","HDBSC","HCRSC",
						"HTOVAR","HVAL","HBNKOT","HBNKTO");

function listLoad()
{
	//создаем таблицу с переменными платежного поручения
	tmpTbl = "PPDOCVARS";
	CreateTable(tmpTbl,"BNK_CONFIG");
	var oDoc = new DpDoc("PP",0);
	var varsInfo = oDoc.getVarsInfo();
	var m = new Object();
	for(var i=0; i<varsInfo.length; i++)
	{
		m.FIELD = varsInfo[i].name;
		m.FTYPE = getType(varsInfo[i].dataType);
		m.FTXT = varsInfo[i].rem;
		if(docVarsAr.some( function(item){ return item==varsInfo[i].name } ) )
			UpdateTable(tmpTbl, m, true);
	}
	
	mode = extPar.mode;
	this.title = (mode=="ADD"?ru("Добавление ","Додавання "):ru("Редактирование ","Редагування "))+ru("настройки экспорта в клиент-банк","налаштування експорту в клієнт-банк");
	this.editTask = "e_clbnkdbfexp.xml";
	this.escape = escape;
	this.save = save;
	CreateTable(tblName,"BNK_CONFIGEXP");
	if(mode=="ADD")
	{
		CONF_NAME.value = "NEWBANK_EXP";
		NAZN.value = ru("Экспорт платежных документов для ","Експорт платіжних документів для ");
		SPLITTER.value = "=";
	}
	else
	if(mode=="EDIT")
	{
		CONF_NAME.value = extPar.bnkLbl;
		Disable(CONF_NAME);
		//инициализируем общие данные из настроечного xml файла,
		var sPath = getOrgPath() + "clbank/export/" +extPar.bnkLbl+".xml";
		sPath = new DpFile(sPath);
		var xmlDoc = new DpXMLDOMDocument();
		var bLoad = xmlDoc.load(sPath);
		if(!bLoad)
		{
			alert(ru("Ошибка при чтении файла ","Помилка при зчитуванні файлу ")+sPath);
			return false;
		}
		var xmlObj = xmlDoc.getDocumentElement();
		ENCOD.value = String(xmlObj.getAttribute("encodding")).toLowerCase();
		ROWTYPE.value = String(xmlObj.getAttribute("row")).toUpperCase();
		
		var childs = xmlObj.getChildNodes();
		var nCount = childs.length;
		for(var n=0; n<nCount; n++)
		{
			var xmlElement = childs[n];
			switch(String(xmlElement.xmlNode.tagName))
			{
				case "NAZN":
					NAZN.value = xmlElement.xmlNode.textContent; 
				break;
				case "REM":
					REM.value = xmlElement.xmlNode.textContent;
				break;
				case "HEADER":
					HEADER.value = xmlElement.xmlNode.textContent;
				break;
				case "FOOTER":
					FOOTER.value = xmlElement.xmlNode.textContent;
				break;
				case "FIELDS":
					var splitter = xmlElement.getAttribute("splitter");
					if(splitter)
						SPLITTER.value = splitter;
					var docbegin = xmlElement.getAttribute("docbegin");
					if(docbegin)
						DOCBEGIN.value = docbegin;
					var docend = xmlElement.getAttribute("docend");
					if(docend)
						DOCEND.value = docend;
					var endofline = xmlElement.getAttribute("endofline");
					if(endofline)
						ENDOFLINE.value = endofline;
					var textalign = xmlElement.getAttribute("textalign");
					if(textalign)
						TEXTALIGN.value = textalign;
					var numberalign = xmlElement.getAttribute("numberalign");
					if(numberalign)
						NUMBERALIGN.value = numberalign;
					fields = xmlElement.getChildNodes();
					fCount = fields.length;
					for(var i=0; i<fCount; i++)
					{
						fieldEl = fields[i];
						var m = new Object();
						var fieldName = fieldEl.xmlNode.tagName;
						var fieldExpr = fieldEl.xmlNode.textContent;
						if(ROWTYPE.value == "DOC_IND")
						{
							m.FIND1 = Number(fieldEl.getAttribute("ind1"));
							m.FIND2 = Number(fieldEl.getAttribute("ind2"));
						}
						m.FNUM = i;
						m.FIELD = fieldName;
						m.FEXPR = fieldExpr;
						m.FTYPE = fieldEl.getAttribute("type")?fieldEl.getAttribute("type"):"text";
						//анализируем выражение и пытаемся определить имя переменной:
						//создадим подмассив элементы которого встречаются в выражении
						//и если это всего одна переменная, тогда ее записываем
						var newDocVarsAr = docVarsAr.filter( function(item){ return fieldExpr.indexOf(item)!=-1; } );
						if(newDocVarsAr.length == 1)
						{
							var snap = getSnap("select Ftype from "+tmpTbl+" where Field="+sqlTo(newDocVarsAr[0]))
							if(snap)
							{
								m.FSOURCE = newDocVarsAr[0];
								m.FTYPESRC = snap[0];
								//проставляем признак уже выбраной переменной
								ExecuteSQL("update PPDOCVARS set Fissel="+sqlTrue+" where Field="+sqlTo(newDocVarsAr[0]));
							}
						}
						UpdateTable(tblName, m, true/*, "Field="+sqlTo(fieldName)*/);
					} 
				break;
			}
		}
	}
	setButton(BTN_OPEN, openTxt);
	setButton(BTN_RANGE, initRange);
	setValid(ENCOD, encod_Valid);
	setValid(CONF_NAME, conf_Valid);
	setValid(ROWTYPE,rowtype_Valid);
	setValid(SPLITTER,splitter_Valid);
	setValid(ENDOFLINE,endofline_Valid);
	setValid(HEADER,header_Valid);
	//setWhen(SPLITTER,splitter_When);
	rowtype_Valid();
	Disable(FSOURCE);
	
	if(mode!="ADD")
		Disable(BTN_OPEN);
//	this.fldnameSelect = fldnameSelect;
	setFocus(CONF_NAME);
}

function listSrc()
{
	this.qrySet("From", tblName, "Order", "FNUM");
}

function listDpGrid()
{
	with(grid)
	{
		FieldEx("FNUM", "№|№", 5);
		var grp = addGroup(UR("Приймач|Приемник"));
		grp.addField(FieldEx("FIELD", "Поле", 10));
		grp.addField(FieldEx("FTYPE", "Тип", 8));
		if(ROWTYPE.value == "DOC_SPLIT" && mode=="ADD")
			grp.addField(FieldEx("FREM", "Можливе значення|Возможное значение", 10));
		var grp = addGroup(UR("Джерело|Источник"));
		grp.addField(FieldEx("FSOURCE", "Змінна|Переменная", 10));
		grp.addField(FieldEx("FTYPESRC", "Тип", 8));
		FieldEx("FEXPR", "Вираз|Выражение", 10);
		if(ROWTYPE.value=="DOC_IND")
		{
			var grp = addGroup(UR("Індекси|Индексы"));
			grp.addField(FieldEx("FIND1", "Перший|Первый", 6, "e", "%10d"));
			grp.addField(FieldEx("FIND2", "Останній|Последний", 6, "e", "%10d"));
		}
	}
	grid.build();
}

function listInitEditParam(par)
{
	par.type = "TXT";
	par.rowtype = String(ROWTYPE.value);
}

function listMenuInit()
{
	if(ROWTYPE.value == "DOC_SPLIT" && this.tbl.rowCount>1 && this.tbl.bookmark!=1)
		this.dataSrc.AddMenuItem("MOVE_UP","Змістити на одну позицію вгору|Сместить на одну позицию вверх");
	if(ROWTYPE.value == "DOC_SPLIT" && this.tbl.rowCount>1 && this.tbl.bookmark!=this.tbl.rowCount)
		this.dataSrc.AddMenuItem("MOVE_DOWN","Змістити на одну позицію вниз|Сместить на одну позицию вниз");
}

function listMenuRun(sID)
{
	switch(sID)
	{
		case "MOVE_UP":
			var num = Number(this.tbl.getValue("Fnum"));
			if(num<1)
				return false;
			var bookmark = this.tbl.bookmark;
			ExecuteSQL("update "+tblName+" set Fnum="+num+" where Fnum="+sqlTo(num-1));
			ExecuteSQL("update "+tblName+" set Fnum="+sqlTo(num-1)+" where Fwid="+this.tbl.getValue("Fwid"));
			this.tbl.requery();
			this.tbl.bookmark = bookmark-1;
			grid.refresh();
			
		break;
		case "MOVE_DOWN":
			var num = Number(this.tbl.getValue("Fnum"));
			var bookmark = this.tbl.bookmark;
			ExecuteSQL("update "+tblName+" set Fnum="+num+" where Fnum="+sqlTo(num+1));
			ExecuteSQL("update "+tblName+" set Fnum="+sqlTo(num+1)+" where Fwid="+this.tbl.getValue("Fwid"));
			this.tbl.requery();
			this.tbl.bookmark = bookmark+1;
			grid.refresh();
			
		break;
	}
}

function openTxt()
{
	sFileName = BrowseForFile("*.*","Все файлы (*.*)|*.*|");
	if(sFileName)
	{
		loadTxt(true);
		FSOURCE.value = sFileName;
	}
}

function loadTxt(toRenew)
{
	ExecuteSQL("DELETE FROM "+ tblName, false);
	
	var sFile = String(ReadTxtFile(sFileName,ENCOD.value));
	nNewLine = 0,
	sLine = "";
	if(sFile.length == 0)
		return;
	//проверяем вводились ли диапазоны индексов
	if(ROWTYPE.value == "DOC_IND")
	{
		Enable(BTN_RANGE);
		if(rangeLength == 0)
		{
			if(ROWTYPE.value == "DOC_IND")
			{
				if(IsTable(tblRangeName))
				{
					var snap = getSnap("select count(*) from "+tblRangeName);
					if(snap)
						rangeLength = snap[0];
				}
			}
		}
		if(!IsTable(tblRangeName) || rangeLength<minVarCount)
			initRange();
	}
	var sLineBegin = allt(DOCBEGIN.value);
	var sLineEnd = allt(DOCEND.value);
	var fieldList = new Array();
	while(sFile.length>0)
	{
		nNewLine = sFile.indexOf('\n');
		if(-1 == nNewLine)
		{
			sLine	= sFile;
			sFile	= "";
		}
		else
		{
			sLine	= sFile.substr(0, nNewLine);
			sFile	= sFile.substr(nNewLine+1);
		}
		var splitInd = sLine.indexOf(SPLITTER.value);
		switch(String(ROWTYPE.value))
		{
			case "VAR":
				var isNotDocBegin = (sLineBegin=="" || (sLineBegin && !strIn(sLineBegin, sLine)));
				var isNotDocEnd = (sLineEnd=="" || (sLineEnd && !strIn(sLineEnd, sLine)));
				//пропускаем пустые строки, строки в которых нет разделителя, строки начала и конца документа 
				if(sLine.length!=0 && splitInd!=-1 && isNotDocBegin && isNotDocEnd)
				{
					var field = sLine.substr(0,splitInd);
					if(!fieldList.some( function(item){ return item==field } ) )
						fieldList[fieldList.length] = field;
				}
			break;
			case "DOC_SPLIT":
				if(sLine.length!=0 && splitInd!=-1)
				{
					fieldList = sLine.split(SPLITTER.value);
					sFile = "";
				}
			break;
			case "DOC_IND":
				if(IsTable(tblRangeName))
				{
					var indList = new Array();
					var tblRange = OpenTable("select * from "+tblRangeName+" order by Find1");
					for(; !tblRange.IsEOF(); tblRange.MoveNext())
					{
						fieldList[fieldList.length] = allt(sLine.substring(tblRange.getValue("Find1")-1,tblRange.getValue("Find2")));
						var ind = new Object();
						ind.ind1 = Number(tblRange.getValue("Find1"));
						ind.ind2 = Number(tblRange.getValue("Find2"));
						indList[indList.length] = ind; 
					}
					sFile = "";
				}
			break;
		}
	}
	for(var i = 0; i < fieldList.length; i++) 
	{
		var fld = fieldList[i];
		var m = new Object();
		m.FNUM = i;
		m.FTYPE = "text";
		if(ROWTYPE.value != "VAR")
		{
			m.FREM = fld;
			m.FIELD = "FIELD"+i;
		}
		else
			m.FIELD = fld;
		if(ROWTYPE.value == "DOC_IND")
		{
			m.FIND1 = indList[i].ind1;
			m.FIND2 = indList[i].ind2;
		}
		UpdateTable(tblName, m, true);
	}
	if(toRenew)
	{
		grid.DeletePages();
		list.init();//чтоб перезапустить listSrc
	}
}

function encod_Valid()
{
	if(sFileName)
		loadTxt(true);
	return true;
}

function conf_Valid()
{
	if(ROWTYPE.value == "DOC_IND")
	{
		if(IsTable(tblRangeName))
		{
			var snap = getSnap("select count(*) from "+tblRangeName);
			if(snap)
				rangeLength = snap[0];
		}
	}
	var sFile = getOrgPath() + "clbank/export/"+CONF_NAME.value+".xml";
	if(mode=="ADD" && (isFile(sFile) || isFile(sFile.toLowerCase())))
	{
		alert(ru("Настройка с таким именем уже существует!","Налаштування з такою назвою вже існує!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(allt(CONF_NAME.value)=="")
	{
		alert(ru("Пустое название не допустимо!","Неможна вводити порожню назву!"));
		setFocus(CONF_NAME);
		return false;
	}
	if(String(CONF_NAME.value).length>0 && Number(String(CONF_NAME.value)[0])>=0)
	{
		alert(ru("Название не должно начинаться с цифры!","Назва не повинна починатись з цифри!"));
		return false;
	}
	if(!Array.every(String(CONF_NAME.value), isValid))
	{
		alert(ru("В названии допустимо использовать только символы латынского алфавита и цифры!",
				"У назві допустимо використовувати лише символи латинського алфавіту і цифри!"));
		setFocus(CONF_NAME);
		return false;
	}
	return true;
}

function rowtype_Valid()
{
	switch(String(ROWTYPE.value))
	{
		case "VAR":
			DOCBEGIN.enabled = true;
			DOCEND.enabled = true;
			FOOTER.enabled = true;
			LSPLITTER.enabled = true;
			SPLITTER.enabled = true;
			LTEXTALIGN.enabled = false;
			TEXTALIGN.enabled = false;
			LNUMBERALIGN.enabled = false;
			NUMBERALIGN.enabled = false;
			BTN_RANGE.setVisible(false);
		break;
		case "DOC_SPLIT":
			DOCBEGIN.value = "";
			DOCEND.value = "";
			FOOTER.value = "";
			DOCBEGIN.enabled = false;
			DOCEND.enabled = false;
			FOOTER.enabled = false;
			LSPLITTER.enabled = true;
			SPLITTER.enabled = true;
			LTEXTALIGN.enabled = false;
			TEXTALIGN.enabled = false;
			LNUMBERALIGN.enabled = false;
			NUMBERALIGN.enabled = false;
			BTN_RANGE.setVisible(false);
		break;
		case "DOC_IND":
			DOCBEGIN.value = "";
			DOCEND.value = "";
			FOOTER.value = "";
			DOCBEGIN.enabled = false;
			DOCEND.enabled = false;
			FOOTER.enabled = false;
			LSPLITTER.enabled = false;
			SPLITTER.enabled = false;
			LTEXTALIGN.enabled = true;
			TEXTALIGN.enabled = true;
			LNUMBERALIGN.enabled = true;
			NUMBERALIGN.enabled = true;
			BTN_RANGE.setVisible(true);
		break;
	}
	if(sFileName)
		loadTxt(true);
	return true;
}

function splitter_Valid()
{
	if(ROWTYPE.value == "DOC_IND")
		return true;
	if(SPLITTER.value == "")
	{
		WAIT(ru("Не указан разделитель!","Не вказано роздільник!"))
		return false;
	}
	if(SPLITTER.value.indexOf(" ")>-1 && !ignorSplitSpace)
	{
		if(confirm(ru("Разделитель содержит в себе пробелы! Вы уверены, что он коректен?",
					"Роздільник містить в собі пробіли! Ви упевнені, що він коректен?")))
			ignorSplitSpace = true;
		else
			return false;
	}
	if(sFileName)
		loadTxt(true);
	return true;
}

function endofline_Valid()
{
	switch(String(ENDOFLINE.value))
	{
		case "LF":
			WAITTIMEOUT(ru("Строка заканчивается символом \"конец строки\" LF","Рядок закінчується символом \"кінець рядка\" LF"),40);
		break;
		case "CRLF":
			WAITTIMEOUT(ru("Строка заканчивается символами \"перевод каретки\" CR и \"конец строки\" LF","Рядок закінчується символами \"переведення каретки\" CR та \"кінець рядка\" LF"),40);
		break;
	}
	return true;
}

function header_Valid()
{
	if(allt(HEADER.value) == "" && ROWTYPE.value == "VAR")
	{
		WAIT(ru("Не указан заголовок файла!","Не вказано заголовок файлу!"));
		return false;
	}
	return true;
}

function splitter_When()
{
	switch(String(ROWTYPE.value))
	{
		case "DOC_SPLIT":
			WAITTIMEOUT(ru("Укажите символ (комбинацию символов), разделяющий в строке файла значения переменных",
					"Вкажіть символ (комбінацію символів), що розділяє в рядку файлу значення змінних"),40);
		break;
		case "VAR":
			if(SPLITTER.value == "")
				SPLITTER.value = "=";
			WAITTIMEOUT(ru("Укажите символ (комбинацию символов), после которого в строке файла записано значение переменной",
					"Вкажіть символ (комбінацію символів), після якого в рядку файлу записано значення змінної"),40);
		break;
	}
}

function isValid(ch)//принадлежность к латынскому алфавиту и цифрам
{
	return ((ch >= "a" && ch <= "z") || (ch >= "A" && ch <="Z") || (ch >= "0" && ch <= "9") || ch == "_");
}

function save()
{
	if(!conf_Valid() || !splitter_Valid() || !header_Valid())
		return false;
	var sPath = getOrgPath() + "clbank/export/" +allt(CONF_NAME.value)+".xml";
	var xmlDoc = new DpXMLDOMDocument();
	//заносим в исходный xml файл необходимые настройки
	var xmlCLBANK = xmlDoc.createChild("CLBANK", null, {type:"TXT", encodding:ENCOD.value, row:ROWTYPE.value});
	xmlCLBANK.createChild("NAZN", NAZN.value);
	xmlCLBANK.createChild("REM", REM.value);
	xmlCLBANK.createChild("HEADER", HEADER.value);
	var xmlVARDOC;
	switch(String(ROWTYPE.value))
	{
		case "VAR":
			xmlCLBANK.createChild("FOOTER", FOOTER.value);
			xmlVARDOC = xmlCLBANK.createChild("FIELDS", null, {splitter:SPLITTER.value, docbegin:DOCBEGIN.value, docend:DOCEND.value, endofline:ENDOFLINE.value});
		break;
		case "DOC_SPLIT":
			xmlVARDOC = xmlCLBANK.createChild("FIELDS", null, {splitter:SPLITTER.value, endofline:ENDOFLINE.value});
		break;
		case "DOC_IND":
			xmlVARDOC = xmlCLBANK.createChild("FIELDS", null, {endofline:ENDOFLINE.value, textalign:TEXTALIGN.value, numberalign:NUMBERALIGN.value});
		break;
	}
	if(!xmlVARDOC)
	{
		alert(ru("Ошибка при сохранении настройки!","Помилка при збереженні налаштування!"))
		return false;
	}
	for(this.tbl.MoveFirst(); !this.tbl.IsEOF(); this.tbl.MoveNext())
	{
		if(ROWTYPE.value == "DOC_IND")
			xmlVARDOC.createChild("FIELD", this.tbl.getValue("FEXPR"), {ind1:this.tbl.getValue("FIND1"), ind2:this.tbl.getValue("FIND2"), type:this.tbl.getValue("Ftype")});
		else
			xmlVARDOC.createChild(this.tbl.getValue("FIELD"), this.tbl.getValue("FEXPR"));
	}
	xmlDoc.save(sPath);
	FORM.close();
}

function escape()
{
	grid.getTable().close();
	FORM.close();
}

function getType(sType)
{
	sType = String(sType).toLowerCase();
	switch(sType)
	{
		case "5":
			return "boolean";		
		case "3":
			return "date";
		case "4":
			return "number";
		case "2":
			return "number";		
		case "1":
			return "text";		
		default:
			return sType;
	}
}

function initRange()
{
	var par = new Object();
	par.tblName = tblRangeName;
	par.minVarCount = minVarCount;
	//найдем первую строчку, с которой можно считывать данные
	var sFile = String(ReadTxtFile(sFileName,ENCOD.value));
	var nNewLine = 0;
	var sLine = "";
	if (sFile.length != 0)
	{
		var lineNom = 1;
		while(sFile.length>0)
		{
			nNewLine = sFile.indexOf('\n');
			if(-1 == nNewLine)
			{
				sLine	= sFile;
				sFile	= "";
			}
			else
			{
				sLine	= sFile.substr(0, nNewLine);
				sFile	= sFile.substr(nNewLine+1);
			}
			par.str = sLine;
			break;
		}
	}
	showWindow("l_txtrange.js", SW_MODAL, par);
	
	while(par.rowCount < minVarCount)
	{
		if(confirm(ru("Введено слишком мало диапазонов. Минимальное кол-во диапазонов: ","Введено дуже мало діапазонів. Мінімальна к-ть діапазонів: ")+minVarCount
			+"\n"+ru("Продолжить ввод данных?","Продовжити введення даних?")))
		{
			showWindow("l_txtrange.js", SW_MODAL, par);
		}
		else
			break;
	}
	rangeLength = par.rowCount;
	BTN_RANGE.text = UR("Редагувати діапазони|Редактировать диапазоны");
	loadTxt(true);
}