
var bCompact = false;
var sFolderID = "0";
var sParID = "0";

var isTree = false;
var isMass = false;
isMass = (typeof(extPar)!= "undefined" && extPar && extPar.isMass);
include ("objects/DpClEx.js")

function listLoad()
{
	if (String(getAccess("L_CLNMK")) == "")
		return false;
	
	// Проеверяем, есть ли коренная запись (fid=0)
	// Если нет - добавляем
	
	if (OpenTable("s",
			"SELECT COUNT(*) as cnt"
			+ " FROM ^cl_nmk"
			+ " WHERE fwid=0"
		).getValue("cnt") == 0)
	{
		var oRoot = new Object;
		oRoot.FWID = 0;
		oRoot.FCOD = "";
		oRoot.FTXTS = oRoot.FTXT0 = ru("Справочник номенклатуры"
			, "Довідник номенклатури");
		oRoot.FISGRP = true;
		oRoot.FGRPID = -1;
		oRoot.FLEFTKEY = 0;			
		oRoot.FRIGHTKEY = 100000000;
			
		updateTable("^cl_nmk", oRoot, true);
	}

	this.editTask = "e_nmk";
	this.helpID = "cl_nmk";
	this.printLabel = "CLNMK";
	this.xmlGridFile = getXmlGridFile();
	
	this.showTreeByDefault = true;
	
	//isMass = (typeof(extPar)!= "undefined" && extPar && extPar.mass!=null);
	isAdmitFvid = (typeof(extPar)!= "undefined" && extPar.Fvid && extPar.Fvid != "");
	if (typeof(extPar)!= "undefined" && extPar && typeof(extPar.zMode) == "string")
		zMode = extPar.zMode.toLowerCase();
	else
		zMode = "c";
		
	this.initTree(Tree,"=(^fcod? ^fcod+': ': '')+^FTXTS","^CL_NMK",sash);
	//this.buildNode = buildNode_NMK;
	this.treeModXml = "e_nmkF.xml";
	
	if (isMass)
	{
		grid.setViewerID("l_clnmktree.js.mass");
		
		grid_nkrows.setTable(extPar.nk.getCondRows(new Object));

		if(extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_RS || extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_PMR)
			list.defaultMenuID = "ADDNKROWFIFO";
		else
			list.defaultMenuID = "ADDNKROW";
		
		extPar.nk.loadGrid(grid_nkrows);
		
		list.onSelectNmkl = onSelectNmkl;		
		grid.setSelHandler(this, "onSelectNmkl");
		
		setButton(btnOk, CloseWindow);
	}
	
	this.setGridMassUpdate(grid);
	//grid.setHelp("cl_nmk");	
	
	this.selRecordHandler = selRecordHandler;
	this.showRecView = showRecView;
	this.showAnalogView = showAnalogView;
	if(!isMass)
	{
		grid.setSelHandler(this, "selRecordHandler");
		grid.setWhen(this, "selRecordHandler"); 
	}
	return true;
}

function onEditObject(mnuID)
{
	var ret = false;
	oNmkl = new DpClEx("nmkl", 0);
	
	this.objParMenu.ExtAliases = null;
	
	if(this.isEditGrp)
	{
		oNmkl.setFormFile("formGRP");
	}
	else
	{
		//return false;
	}
	if(mnuID != "ADD" && mnuID != "ADDFLD")
	{
		ret = oNmkl.edit(mnuID,this.tbl.getRowID(), this.objParMenu);
	}
	else
	{
		
		var fgrpid = this.sFolderID;
		
		if (toScrObj(this.tbl.getValue("FISGRP")))
		{
			fgrpid = Number(this.tbl.getValue("FWID"));
		}
		else
		{
			fgrpid = Number(this.tbl.getValue("FGRPID"));
		}
		
		if(fgrpid)
		{
			oNmkl.setVar("HGRPID", fgrpid);
		}
		
		ret = oNmkl.edit("ADD", null, this.objParMenu);
	}
	_retArray.FWID = oNmkl.getID();
	return ret;
}

function selRecordHandler()
{
	if(list.zaval)	//при редактировании строк рецепта можно завалиться в список номенклатуры. Вьюв в этом случае обновлять нельзя.
		return;
	if (this.tm == null)
	{
		this.tm = runTimer(runViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
	
}

function runViews()
{
	if (!list.tbl || typeof(list.tbl.isBOF) == "undefined" || list.tbl.isBOF() || list.tbl.isEOF())
	{
		return;
	}
	
	var par = new Object();	
	par.fnmkl = list.tbl.getValue("fwid");
	var view = lpProxy.getView("cl_recept");
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("rec", par);	
		}
	}
	
	par = new Object();	
	par.fnmkl = list.tbl.getValue("fwid");
	par.isAnalog = true;
	view = lpProxy.getView("cl_analog");
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("rec", par);	
		}
	}
	grid.setFocus();
}

function showRecView()
{
	
	var par = new Object();	
	par.fnmkl = list.tbl.getValue("fwid");
	var view = lpProxy.getView("cl_recept");
	if (view == null)
	{
		
		lpProxy.showView("cl_recept", "l_cl_rec.js", par)
	}
	else
	{
		view.sendMessage("rec", par);	
	}
}

function showAnalogView()
{
	
	var par = new Object();	
	par.fnmkl = list.tbl.getValue("fwid");
	par.isAnalog = true;
	var view = lpProxy.getView("cl_analog");
	if (view == null)
	{
		
		lpProxy.showView("cl_analog", "l_cl_rec.js", par)
	}
	else
	{
		view.sendMessage("rec", par);	
	}
}

function buildNode_NMK(id,toObject)
{
	id = String(id);
	var bIsBuilt = false;
	var item = this.oTree.getItem(id);
	if (item != null)
		bIsBuilt = item.getData("ISBUILT");
	if (bIsBuilt)
		return;
		this.oTree.removeItem(id + "STUB");
	var tbl;
	var sSQL = "SELECT maintbl.FWID, maintbl.FTXTS ,maintbl.FCOD, tblc.FGRPID"
			 + " FROM ^cl_nmk maintbl LEFT JOIN  ^cl_nmk tblc "
			 + " ON "
			 	+ " tblc.FGRPID=maintbl.FWID"
			 	+ " AND tblc.FISGRP <>  0 "
			 	+ " AND tblc.FISGRP IS NOT NULL "
			 + " WHERE maintbl.FGRPID=" + sqlTo(Number(id))
			 + " AND maintbl.FISGRP<>" + sqlTo(false)
			 + " AND maintbl.FISGRP IS NOT NULL "
			 + " GROUP BY maintbl.FWID,maintbl.FTXTS,maintbl.FCOD, tblc.FGRPID"
			 + " ORDER BY maintbl.FTXTS";
	tbl = OpenTable("s",sSQL);
	if (tbl.isEmpty())
		return;
	tbl.MoveFirst();
	while(!tbl.isEOF())
	{
		var Fwid = tbl.getValue("Fwid");
		this.oTree.addItem(id,Fwid,"(" + tbl.getValue("FCOD") + ")"
			+ nvl(tbl.getValue(this.sTtxtFld),''));
		var itm = this.oTree.getItem(Fwid);
		var oSnap = tbl.getValue("FGRPID");
		if (oSnap != null)
			this.oTree.addItem(Fwid,Fwid + "STUB","");
		else
			itm.setData("ISBUILT",true);
		tbl.MoveNext();
	}
	tbl.close();
	if (item != null)
		item.setData("ISBUILT",true);
}

function listTitle()
{
	if(extPar && extPar.title)
		return extPar.title;
	return 	capt = "Довідник номенклатури"+(isMass?":масовий вибір":"")+(!isAdmitFvid?"":(extPar.Fvid =="S")?" (послуги) ": (extPar.Fvid =="R")?" (тара) " : " (ТМЦ) ")+"|Справочник номенклатуры"+(isMass?":массовый ввод":"") +(!isAdmitFvid?"":(extPar.Fvid =="S")?" (услуги) ": (extPar.Fvid =="R")?" (тара) " : " (ТМЦ) ");
}

function getXmlGridFile()
{
	if (isMass)
		return "l_clnmk_mass.xml";
	else
		return "l_clnmk.xml";
}

function listBeforeGridBuild()
{
	if(getPar("SHOWNMKIMAGE"))
		grid.FieldEx("FIMAGE", "Зображення|Изображение", 15, "img", "");
	grid.addExtPage();
}
var sFields =   getEdiTextSQL("n.FCEDIB","s") +" as FEDITXT,"
				+ getEdiTextSQL("n.FEDI1","s") +" as FEDITXT1,"
				+ getEdiTextSQL("n.FFAS1","s") +" as Feftxt1,"
				+ getEdiTextSQL("n.FFAS2","s") +" as Feftxt2,"
				+ getEdiTextSQL("n.FFAS3","s") +" as Feftxt3,"
				+ getEdiTextSQL("n.FFAS4","s") +" as Feftxt4,"
				+ getEdiTextSQL("n.FFAS5","s") +" as Feftxt5"


function listSrc()
{
	var sWhere = typeof(extPar)=="object" && extPar.GroupOnly? "fisgrp<>" + sqlFalse: "1=1";
	
	if (this.isTree)
	{
		//this.qryAlias = "n";
		this.qrySet("From", "^cl_nmk"
			, "Where", sWhere
			, "WhereArr", new Array("FISGRP="+ sqlTrue)
			, "WhereArrI", (extPar && extPar.groupsel? 0 : -1)
			//, "Order", new Array(IIF("Fisgrp<>" + sqlTo(false),"1","0") + "DESC","Fcod")
			, "Order", "fleftkey"
			);
	}
	else 
	{
		this.qrySet("Fields", "n.fisgrp as fgroup,n.*",
					"From", "^cl_nmk n",
					"Where", sWhere,
					"WhereArr", new Array("FISGRP="+ sqlTrue),
					"WhereArrI", (extPar && extPar.groupsel? 0 : -1),
					"Order","Fcod "//new Array(IIF("Fisgrp<>" + sqlTo(false),"1","0") + "DESC"))
					);
	}
	if(isAdmitFvid)
	{
		this.qrySet("Fields",
					"n.fisgrp as fgroup,n.*",
					"From",
					"^cl_nmk n",
					"Where",
					"n.Fvid=" + sqlTo(extPar.Fvid)+" OR Fisgrp<>"+ sqlTo(false),
					"Order","Fcod",new Array(IIF("Fisgrp<>" + sqlTo(false),"1","0") + "DESC")
					);
	}
	
	this.subTie("cl_edi", "x_cl_edi",  "COD", "FCEDIB");
	this.subTie("cl_edi", "x_cl_edi1", "COD", "FEDI1");
	this.subTie("cl_edi", "x_cl_edi2", "COD", "FFAS1");
	this.subTie("cl_edi", "x_cl_edi3", "COD", "FFAS2");
	this.subTie("cl_edi", "x_cl_edi4", "COD", "FFAS3");
	this.subTie("cl_edi", "x_cl_edi5", "COD", "FFAS4");
	this.subTie("cl_edi", "x_cl_edi6", "COD", "FFAS5");
	this.clTie("tnved", "="+getPar("CODTNVED")+", FTNVED");
	
	this.extTie("CL_NMK");
	grid.setSQLQueryCount(true);
}
/*
function onOpenDataSource1()
{
	if (zMode != "t" || extPar.Fcod == "")
	{
		if (isAdmitFvid)
			 return OpenSourceTable("m","SELECT * FROM ^CL_NMK WHERE FVID = " + sqlTo(extPar.Fvid) +
								(bCompact?" AND FCOD LIKE '"+SqlStr4Like+".'":"") + " ORDER BY FCOD");
		else
		{
			if (bCompact)
				return OpenSourceTable("m","SELECT * FROM ^CL_NMK WHERE FCOD LIKE '"+SqlStr4Like+".' ORDER BY FCOD");
			else
			{
				var sSQL = //-"SELECT  "
				 getEdiTextSQL("n.FCEDIB","s") +" as FEDITXT,"
				+ getEdiTextSQL("n.FEDI1","s") +" as FEDITXT1,"
				+ getEdiTextSQL("n.FFAS1","s") +" as Feftxt1,"
				+ getEdiTextSQL("n.FFAS2","s") +" as Feftxt2,"
				+ getEdiTextSQL("n.FFAS3","s") +" as Feftxt3,"
				+ getEdiTextSQL("n.FFAS4","s") +" as Feftxt4,"
				+ getEdiTextSQL("n.FFAS5","s") +" as Feftxt5,"
//				+IIF("fcod like '%.'","1","0")+ " as fgroup, n.* FROM ^cl_nmk n where fcod not like '%.%' order by fcod ";
//				+IIF("fisgrp","1","0")+ " as fgroup, n.* FROM ^cl_nmk n where Fpar='0' order by fcod ";
//-				+ "fisgrp as fgroup,n.* FROM ^cl_nmk n where Fpar='0' order by Fisgrp DESC,Fcod ";
//-				return OpenSourceTable("m",sSQL);
				return sSQL;
			}
		}
	}
	else
		return OpenSourceTable("m","SELECT * FROM ^cl_nmk WHERE FTXTS LIKE " + sqlTo(extPar.Fcod + SqlStr4Like) +
							 ((isAdmitFvid)? " AND Fvid = " + sqlTo(extPar.Fvid):"") +
							 (bCompact?" AND FCOD LIKE '*.'":""));
}
*/
function listMenuInit()
{

//-	var isFld = (isTree && this.tbl.getValue("Fisgrp") == true);
	if (IsDblClick())
	{
		if (this.isZaval)
		{
			extPar.selectedIDs = null;
			alert(extPar.selectedIDs)

			extPar.escape = false;
			CloseWindow();
			return;
		}
/*		if (isFld)
		{
			list.mnuHandler("ENTER");
			return false;
		}
*/
	}
/*	grid.AddMenuItem("",",");
	if (isFld == true)
	{
		grid.AddMenuItem("ENTER","Войти в группу");
	}
	if (sFolderID != "0")
	{
		grid.AddMenuItem("OUT","На уровень вверх");
	}
*/
	
	if (list.zaval && extPar.CanPolySelect)
	{
		grid.AddMenuItem("GETMASS", "Выбрать отмеченные");
	}
	
	if (isMass)
	{
		if(extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_RS || extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_PMR)
			grid.AddMenuItem("ADDNKROWFIFO", "Добавить в накладную (FIFO)")
		grid.AddMenuItem("ADDNKROW", "Добавить в накладную")
	}
	
	grid.AddMenuItem("","");
	grid.AddMenuItem("EXT",ru("Расширения справочника","Розширення довідника"));
	grid.AddMenuItem("RVDOST", "Розрахувати відомість залишків|Рассчитать ведомость остатков");
	grid.AddMenuItem("","");
	grid.AddMenuItem("BUILDNESTEDKEYS", ru("Восстановить дерево", "Відновити дерево"));
	grid.AddMenuItem("BUILDGROUPS", "Проставити групи по коду|Проставить группы по коду");
	grid.AddMenuItem("","");
	grid.AddMenuItem("SHOWRECEPT","Показати рецепти|Показать рецепты");
	grid.AddMenuItem("SHOWANALOG","Показати аналоги|Показать аналоги");
	grid.AddMenuItem("", "");
	grid.AddMenuItem("FLDRARCH", "Архів|Архив");
	if(!this.tbl.IsEmpty())
	{
		grid.AddMenuItem("DOCARCH", "Історія|История");
	}
	grid.AddMenuItem("", "");
	grid.AddMenuItem("FIND_CHNG", "Знайти в назві і замінити|Найти в названии и заменить");
	
//-	grid.AddMenuItem("ADDFLDR","Добавить группу");
/*	var sCapt = UR("Показати |Показывать ") 
				+ UR((isTree?"як список|как список":"ієрархічно|иерархично"));
	grid.AddMenuItem("RETREE_NMK",sCapt);
*/
	
}

var isEditGrp = false;
function listMenuRun(sID)
{
	switch(sID)
	{
		case "EXT":
			var p = new Object();
			p.vid = "CL_NMK";
			p.FORM = FORM;
			showWindow("l_extent.js", SW_NOMODAL, p);
			break;
		case "BUILDNESTEDKEYS":
			include("sys\\servis.js");
			if(confirm(ru("Вы уверены, что хотите восстановить дерево?", "Ви впевнені, що бажаєте відновити дерево?")))
				//под MSSQL функцию переделали на SQL процедуру
				//buildNestedKeys("^cl_nmk", -1, 0, "fcod, fisgrp, ftxts");
				buildTreeKeysOnTable("^cl_nmk", -1, 0, "fcod, fisgrp, ftxts");
			break;
		case "BUILDGROUPS":
			var sMsg = UR("Дана процедура проставить ідентифікатори груп "
							+"\n	для усіх рядків довідника та відновить дерево!"
							+"\nЯкщо не вистачає груп - потрібно спочатку їх створити."
							+"\nДля цього можна скористатися контекстним меню:"
							+"\n	"+ (this.isTree? "" : "\"Показати ієрархічно\" та ") 
								+"\"Додати групу\"."
							+"\nВи впевнені що бажаєте виконати процедуру?"
						+"|Данная процедура проставит идентификаторы групп "
							+"\n	для всех записей справочника и восстановит дерево!"
							+"\nЕсли не хватает групп - нужно сначала их создать."
							+"\nДля этого можно воспользоваться контекстным меню:"
							+"\n	"+ (this.isTree? "" : "\"Показать иерархично\" и ") 
								+"\"Добавить группу\"."
							+"\nВы уверены что желаете выполнить процедуру?");
			if(!confirm(sMsg))
				return;
			include("nom_trans.js");
			include("sys\\servis.js");
			ExecuteSQL("drop table TMP_CL_NMK", false);
			ExecuteSQL("select * into TMP_CL_NMK from ^CL_NMK", false);
			makeTrans_new();
			//под MSSQL функцию переделали на SQL процедуру
			//buildNestedKeys("^cl_nmk", -1, 0, "fcod, fisgrp, ftxts");
			buildTreeKeysOnTable("^cl_nmk", -1, 0, "fcod, fisgrp, ftxts");
			grid.getTable().requery();
			grid.RefreshGrid();			
			sMsg = UR("Оновлення завершене."
						+"\nДля того щоб зміни подіяли потрібно ще раз відкрити довідник."
						+"\nЗакрити поточне вікно довідника?"
					+"|Обновление завершено."
						+"\nДля того чтобы изменения подействовали нужно еще раз открыть справочник."
						+"\nЗакрыть текущее окно справочника?");
			if(confirm(sMsg))
			{
				this.isTree = false;
				CloseWindow();
				showWindow("l_clnmktree.xml");
				return true;
			}	
			break;
		case "ADDNKROW":
			extPar.nk.addRowsMass(toScrObj(list.tbl.getValue("fwid")), toScrObj(list.tbl.getValue("fcenapr")), toScrObj(list.tbl.getValue("f1cena")));
			list.onSelectNmkl();
			grid.RefreshGrid();
			break;
		case "ADDNKROWFIFO":
			if (list.tbl.getValue("fvid") == null || String(list.tbl.getValue("fvid")).trim() == "")
				extPar.nk.addRowsMassFifo(toScrObj(list.tbl.getValue("fwid")), toScrObj(list.tbl.getValue("fcenapr")));
			else
				extPar.nk.addRowsMass(toScrObj(list.tbl.getValue("fwid")), toScrObj(list.tbl.getValue("fcenapr")), toScrObj(list.tbl.getValue("f1cena")));
			list.onSelectNmkl();
			grid.RefreshGrid();
			break;
		case "SHOWRECEPT":	
			this.showRecView();
			break;
		case "SHOWANALOG":	
			this.showAnalogView();
			break;	
		case "FLDRARCH":
		case "DOCARCH":	
			var par = new Object();
				
			par.fdoc = "CLS.nmkl";
			par.fnop = 0;
			if(sID == "DOCARCH")
				par.fid = this.tbl.getValue("fwid");
				
			par.mode = sID;
			showWindow("l_archive.js", SW_NOMODAL, par);
			break;;	
			
		case "RVDOST":
			var par = new Object();
			par.noAsk = true;
			par.menuMode = "CALC";
			//par.fitog = 57;
			par.fitog = 50;
			par.fdat = new Date();
			par.fnmk = this.tbl.getValue("FWID");
			par.oNmkl = new DpNmkl();
			if(grid.getSelectedCount()>0)
				par.oNmkl.selectedIDs = grid.getSelectedIDs();
			showWindow("r_vdost.js", SW_NOMODAL, par);
			break;

		case "GETMASS":
			extPar.selectedIDs = this.dataSrc.getSelectedIDs()
			//this.dataSrc.setSelectedIDs(extPar.selectedIDs)
			CloseWindow();
			return;
		case "FIND_CHNG":
			var par = new Object();
			if(grid.selectedCount==0)
			{
				if(!confirm(ru("Не отмечено ни одной записи! Искать по всем?","Не відмічено жодного рядку! Шукати по всім?")))
					return false;
			}
			else
				par.sqlSelected = grid.sqlSelected(true)
			showWindow("e_srchNmk.xml",SW_MODAL, par);
			if(!par.escape)
			{
				list.tbl.requery();
				grid.RefreshGrid();
			}
			break;
	}
}


function listInitEditParam(oPar)
{
	oPar.Fpar = sFolderID;
	oPar.Fwid = list.tbl.getValue("Fwid");
}
/*
function listAfterMenuInit()
{
	if (isEditGrp && ! this.objParMenu.escape)
	{
		if (this.objParMenu.sMode == "ADD")
			Tree.addItem(sFolderID,this.objParMenu.nFwid,"(" + this.objParMenu.nCode + ")" + this.objParMenu.nFtxt);
		else if (this.objParMenu.sMode == "EDIT")
			Tree.modifyItem(this.objParMenu.nFwid,"(" + this.objParMenu.nCode + ")" + this.objParMenu.nFtxt);
	}
}
*/
/*
function onEditList(par)
{
	if (par.tblSrc.getValue("Fisgrp") == true)
	{
		var oPar = new Object();
		oPar.mode = par.sMode;
		oPar.m_pTable = par.tblSrc;
		oPar.Fwid = par.tblSrc.getValue("Fwid");
		oPar.Fpar = sFolderID;
		showWindow("e_clnmkF.xml",SW_MODAL,oPar);
		var t = OpenTable("s","Select Ftxts, Fcod From ^cl_nmk Where Fwid=" + sqlTo(oPar.Fwid));
		Tree.modifyItem(oPar.Fwid,"(" + t.getValue("Fcod") + ")" + t.getValue("Ftxts"));
		t.close();
		par.tblSrc.requery();
		return false;
	}
//	if (par.tblSrc.getValue("Fisgrp") != true || par.sMode == "ADD" )
	else
	{
		par.Fpar = sFolderID;
		showWindow("e_nmk.xml","XMLDLG",par);
	}
}
*/
/*
function listDel()
{
	var Fwid = this.tbl.getValue("Fwid");
	var sSQL = "delete from ^cl_nmk where fwid = "+sqlTo(Fwid); 
	if (this.tbl.getValue("Fisgrp") == true)
	{
		removeGroup(Fwid);
	}
	ExecuteSQL(sSQL);
	this.tbl.requery();		
}
*/
function listDel()
{
	var tbl = list.tbl;
	var fnmkl = tbl.getValue("Fcod");
	var oSnap = getSnap("Select * From ^ANLTK Where Fnmkl=" + tbl.getValue("FWID"));
	strAlert = "Попытка удалить номенклатуру, по которой есть движение.";

	if(oSnap == null)
	{
		var Fwid = tbl.getValue("Fwid");
		var doIt = true;
		if (tbl.getValue("Fisgrp") == true)
		{
/*		
			var tChilds = OpenTable("s","Select * From ^cl_nmk Where FGRPID=" 
												+ sqlTo(tbl.getValue("Fwid"))
												+ " And Fwid <> Fpar");
			if (!tChilds.isEmpty())
			{
*/
//-					return;
//-			}
			doIt = listTreeDel(Fwid);
		}
		if (!doIt)
			return false;
		include ("objects/DpClEx.js");
		var oDoc = new DpClEx("nmkl", 0);
		oDoc.del(Fwid);	
		//var sSQL = "delete from ^cl_nmk where fwid = " + sqlTo(Fwid);
		//ExecuteSQL(sSQL);
	}
	else
	{
		alert(strAlert);
	}
	return false;
}

function listTreeDel(sFid)
{
	var oTbl = OpenTable("s","Select * From ^cl_nmk Where FGRPID=" + sqlTo(sFid));
	if (!oTbl.isEmpty())
	{
		oTbl.MoveFirst();
	}
	while(!oTbl.isEOF())
	{
		var sSQL = "Delete From ^cl_nmk Where Fwid=";
		var Fwid = oTbl.getValue("Fwid");
		if (oTbl.getValue("Fisgrp") == true)
		{
			listTreeDel(Fwid);
		}
		include ("objects/DpClEx.js");
		var oDoc = new DpClEx("nmkl", 0);
		oDoc.del(Fwid);	
		//ExecuteSQL(sSQL + sqlTo(Fwid));
		Tree.removeItem(Fwid);
		oTbl.moveNext();
	}
	oTbl.close();
	var oDoc = new DpClEx("nmkl", 0);
	oDoc.del(sFid);	
	//ExecuteSQL("DELETE FROM ^cl_nmk WHERE FWID=" + sqlTo(sFid));
	Tree.removeItem(sFid);
}

function onExitZaval()
{
	extPar.escape = false;
	extPar.ret.FCOD = this.tbl.getValue("FCOD");
	this.close();
}

function _exitConfirm()
{
	if (isMass)
	{
		extPar.escape = true;
		var iret = __confirm("Сохранить введенные даные?");
		if (iret == 0)
		{
			/*
				сохраним введенные данные
			*/
			extPar.mass.Save();
			extPar.escape = false;
		}
		else if (iret == 2)//2- значит продолжить
			return false;
	}
	return true;
}

function filterMode(ID)
{
	if (ID == "ZAVAL")
	{
		if(list.tbl.getValue("FISGRP") == true)
			return extPar.CanSelectGroup;
		else
			return true;
	}
	
	
	
	//var iAcc = lookForCl(cod);
	switch(ID)
	{
		
	case "ADD": 
	case "COPY":
		//return iAcc&acc_a;
		return getAccessOnAction("L_CLNMK", "A");
	
	case "EDIT":
		//return iAcc&acc_e;
		return getAccessOnAction("L_CLNMK", "E");
	
	case "DEL":
		//return iAcc&acc_d;
		return getAccessOnAction("L_CLNMK", "D");		
	
	case "__XDEL":		
		//return iAcc&acc_d && getAccess("XDEL");
		return getAccessOnAction("L_CLNMK","D") && getAccess("XDEL") != "";
		
	}
		
	return true;
}

function onSelectNmkl()
{
	try
	{
		grid_nkrows.getTable().close();
	
		var oCond = new Object;
		oCond.fnmkl = toScrObj(list.tbl.getValue("fwid"));
		grid_nkrows.setTable(extPar.nk.getCondRows(oCond));
		grid_nkrows.refresh();
	} 
	catch(e)
	{
	}

}

function getNkCondKol()
{
	var oCond = new Object;
	oCond.fnmkl = toScrObj(list.tbl.getValue("fwid"));
	
	var snap = extPar.nk.getCondRows(oCond, "sum(fkol)"); 
	return snap? snap[0]: 0;
}
/*
fuction listHeaderMenuInit(oCol,toObject)
{
	var sCapt = UR("Показати |Показывать ") 
				+ UR((isTree?"як список|как список":"ієрархічно|иерархично"));
	toObject.addHeaderMenuItem("RETREE",sCapt);
}

function listHeaderMenuRun(sID,oCol,toObject)
{
	if (sID == "RETREE")
	{
		isTree = !isTree;
		this.qryWhere = "";
		this.qryOrder = new Array();
		this.subSrc();
		this.tblInit();
		WriteParameter("isnmktree",String(isTree),"cl_nmk","nmktree","mtr");
	}
}
*/
include("sys\\DpList.js");