function listLoad()
{
	if (String(getAccess("L_CLSCH")) == "")
		return false;
	
	with( this )
	{
		title="План рахунків|План счетов";
		editTask="e_clsch";
		printLabel="CLSCH";
		xmlGridFile = "l_clsch.xml";
		helpID = "clsch";
	}	
}

function listSrc()
{
	this.qrySet(
					"From", "^CL_SCHET",
					"Order", new Array("FSCHET,FSUBSCHET,FSTAT"),
					"Ptn", "CL_SCHET"
				);				
	if (extPar && extPar.isMat)
	{
		if (SUBD==MYSQL)
		{
			var t = OpenTable("select distinct fsc from ^anltk ")
			var matSc = "0";
			for (; !t.IsEOF(); t.MoveNext())
			{
				if (matSc)
					matSc += ","
				matSc += t.getValue("fsc");
			}
			this.qrySet("WhereArr", new Array("fschet in ("+ matSc+ ")"))
		}
		else
			this.qrySet("WhereArr", new Array("fschet in (select fsc from ^anltk )"))
		
		this.qrySet("WhereArrName", new Array("Материальные счета")
			, "WhereArrI", (SUBD==MYSQL && matSc == "0")?1:0
			);
	}
}

function listDel(tbl)
{
	ExecuteSQL("DELETE FROM ^cl_schet WHERE fwid = " 
		+ sqlTo(this.tbl.getValue("FWID")));	
}

//Нельзя удалять, если:
//	на счете есть субсчета или статьи
//	на субсчете есть статьи
function listDelAcc()
{
	var retVal = true;
	if(!this.tbl.IsEOF())
	{
		var mFschet = Number(this.tbl.getValue("Fschet"));
		var mFsubschet = Number(this.tbl.getValue("Fsubschet"));
		var mFstat = Number(this.tbl.getValue("Fstat"));

		var bm = this.tbl.getBookmark();
		this.tbl.MoveNext();
	
		if(!this.tbl.IsEOF())
		{
			var m2Fschet = Number(this.tbl.getValue("Fschet"));
			var m2Fsubschet = Number(this.tbl.getValue("Fsubschet"));
			var m2Fstat = Number(this.tbl.getValue("Fstat"));
			retVal = !(
                //К счету либо к субсчету привязана статья:
				(mFschet == m2Fschet) && (mFsubschet == m2Fsubschet) && (mFstat==0) && (m2Fstat!=0)
                //К счету привязан субсчет:
				|| (mFschet == m2Fschet) && (mFsubschet==0) && (m2Fsubschet!=0)
			);
		}
		this.tbl.setBookmark(bm);
	}
	return retVal;
}


function filterMode(s)
{
	switch(s)
	{
		
	case "ADD": 
	case "COPY":
		return getAccessOnAction("L_CLSCH", "A");
	
	case "EDIT":
		return getAccessOnAction("L_CLSCH", "E");
	
	case "DEL":
		return getAccessOnAction("L_CLSCH", "D");		
	
	case "__XDEL":		
		return getAccessOnAction("L_CLSCH","D") && getAccess("XDEL") != "";
		
	}
		
	return true;
}

function type_name(sType, nCl)
{
	var txt = "";
	if(!sType && Number(nCl))
		return nCl;
	sType = String(sType).toLowerCase().trim();
	var sDoc = "";
	if(sType.indexOf(".")!=-1)
	{
		sDoc = sType.substring(sType.indexOf(".")+1).toUpperCase();
		sType = sType.substring(0, sType.indexOf("."));		
	}
	switch(sType)
	{
		case "nmkl":	txt = UR("Ном-ра|Ном-ра");		
			break;		
		case "docs":	txt = UR("Док-т|Док-т") +": "+ sDoc;	
			break;
		case "cntrct":	txt = UR("Угода|Договор");
			break;
		case "rs":		txt = UR("Р/р.|Р/сч.");
			break;
		case "val":		txt = UR("Валюта|Валюта");
			break;
		case "edi":		txt = UR("Од.вим.|Ед.изм.");
			break;		
		default:		txt = nCl;
			break;
	}
	return txt;
}


include("sys\\DpList.js")