//просмотр справки в пенсионный фонд помесячной
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("r_compnm.js");
include("servis/date.js");
include("get_const.js");
include("sys/udfs.js");
var sortMode = "Ftt,FTABNN";
var Ftabn = 0;
var isDblInd = false;
var dblColor = 17;
var gd, szTag, zppnm6, zppnm7, zppnm7d;

function listLoad()
{
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm6 = "^ZPPNMVI"+szTag;
	zppnm7 = "^ZPPNMVII"+szTag;
	zppnm7d = "^ZPPNMVIID"+szTag;
	this.printLabel = "COMP";
	menuMode = GetMenuMode();
	if(menuMode!="CALC")
	{
		if (!IsTableEx("ZRP_RES","ZRP_ZPPNMVI"+szTag))
		{
			alert(ru("Cначала сделайте расчет таблиц 6 и 7 за ",	"Спочатку виконайте розрахунок таблиць 6 та 7 за ")+format("Mmm yyyy",gd.dat1).toLowerCase());
			return false;
		}
		this.title = UR("Перегляд 6 таблиці - |Просмотр 6 таблицы - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	}
	else
	{
		var msg = ru("Таблицы 6 и 7 уже расчитаны за ",
				"Таблиці 6 та 7 вже розраховани за ")+format("Mmm yyyy",gd.dat1).toLowerCase()+"\n"+ru("Продолжить расчет?","Продовжити розрахунок?");
		if (IsTableEx("ZRP_RES","ZRP_ZPPNMVI"+szTag) && !confirm(msg))
			return false;
		var par=new Object();
//		par.sysname = getSysName();
//		par.escape = false;
		par.xyear = gd.dat1;		
//	    par.typ1 = true;
//	    par.typ2 = false;
//	    par.sdatr = today.getVarDate();
//		par._KPFU = "";
//		par._KTSZ = "0";
//	    
//		showWindow("e_zsprpnm.xml", SW_MODAL, par);	
//		setParWithDef("DAT1_P", par.xyear, par.sysname);
//		if (par.escape)
//			return false;

		this.title = UR("Розрахунок персоніфікації 6 таблиця - | Расчет персонификации 6 таблица - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	
		r_compnm(par);
	}
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	var snap = getSnap("select count(*) from "+zppnm6+" where Fisdblind="+sqlTrue)
	if(snap && snap[0]>0)
	{
		isDblInd = true;
		snap = getSnap("select count(ftabn) from "+zppnm6+"  where Ftt=0 group by Fld6,Fld14 having count(ftabn)>1");
		if(snap && snap[0]>1)
			dblColor = 17;
		else
			dblColor = 2;
	}
}

function listSrc()
{
	this.qrySet("From", zppnm6, "Order", getOrder(sortMode));
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with( oGrid )
	{
		defCond("=^Ftt==1", "ITOG_ALL");
		color(1, "ITOG_ALL");
		bold("ITOG_ALL");
		defCond("=^Fisdblind==true", "DBL_IND");
		color(dblColor, "DBL_IND");
	}
	
	gr.FieldEx("=(^Ftt==0)?^Ftabnn:'Итого'","Таб.№|Таб.№",6,"","%10d");	
	gr.FieldEx("=(^Ftt==1)?'':getSmallFIO(^Fld7)","ПIБ|ФИО",15);	
	gr.FieldEx("=(^Ftt==1)?'':^Fld6","Iдент-й №|Идент-й №",12);
	if(isDblInd)
		gr.FieldEx("Fisdblind","Задв.\nід.№|Задв.\nид.№",3);
	with(gr.group("Сума|Сумма"))
	{
		FieldEx("FLD10","доходу|дохода",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD11","дох.с огр.|дох.з гран.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD12","податку|налога",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	}
	gr.FieldEx("FLD8","Кат.\nЗО|Кат.\nЗЛ", 3, "e");
	gr.FieldEx("FLD9","Кат.\nс/сб|Кат.\nс/зб", 3, "e");
	gr.FieldEx("FLD13","Тр.\nкн.|Тр.\nкн.",3,"e");
	gr.FieldEx("FLD14","с/стаж|с/стаж",3,"e");			
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			AddMenuItem("MININD", "Згорнути по ідентифікаційному номеру|Свернуть по идентификационному номеру");
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
			AddMenuItem("PSOG", "Проставить сумму ограничения = сумме дохода");
			AddMenuItem("RIT","Перерахувати пiдсумки|Пересчитать итоги");						
			AddMenuItem("DBF_EXP",ru("Экспорт данных персонификации", "Експорт даних персоніфікації"));
			AddMenuItem("CHECKSUM","Перевірити суми по 6 та 7 таблицям|Проверить суммы по 6 и 7 таблицам");
			AddMenuItem("LT6","Переглянути попер. результати по 6 таблицi|Просмотреть предв. результаты по 6 таблице");
			AddMenuItem("LT7","Переглянути попер. результати по 7 таблицi|Просмотреть предв. результаты по 7 таблице");
			AddMenuItem("PERITM","Перерахувати кiнцевi результати персон.|Перерасчитать окончат.расчеты персониф.");									
		}
	}
}


function listMenuRun(ID)
{
	switch(ID)
	{
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
	   		var m = new Object()
			m.Fld8   = 0
			m.Fld9   = 0
			m.Fld10  = 0
			m.Fld11  = 0
			m.Fld12  = 0
			m.Fld13  = 0
			m.Fld14  = 0				
			m.Ftabn = tabn_id
			m.Ftabnn= tabn
			m.Ftt = 0
			m.Fld7  = toScrObj(t.getValue("FTXT"))
			
			var tmpName = (toScrObj(t.getValue("FTXT"))).replace("/\./g", ". ");
			var aWords = tmpName.split(" ");
       		var pfam = aWords[0]
       		var pnam = aWords[1]
       		var potch= aWords[2]
       		if (toScrObj(t.getValue("FISOTCH"))==true){
           		var pnam = aWords[1]+" "+aWords[2]
           		var potch= ""
       		}
			m.Fld7f  = toScrObj(pfam)
			m.Fld7i  = toScrObj(pnam)
			m.Fld7o  = toScrObj(potch)
			
			m.Fld6 = toScrObj(t.getValue("FINDNUM"))
			UpdateTable(zppnm6, m, true)
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
        case "RIT":
	  		DropTable("ZPPNS63")
	  		ExecuteSQL("delete from "+zppnm6+" where Ftt=1");
	  		ExecuteSQL("select sum(a.Fld10) as Fld10, sum(a.Fld11) as Fld11,sum(a.Fld12) as Fld12, 1 as Ftt"
	          	+" into ZPPNS63 from "+zppnm6+" as a where Ftt<>1")
	  		ExecuteSQL("insert into "+zppnm6+" (Fld10,Fld11,Fld12,Ftt) select Fld10,Fld11,Fld12, Ftt  from ZPPNS63");	          	
			list.tbl.requery();
			grid.RefreshGrid();
	        break;
		case "MININD":
			var msg = ru("Данная операция предназначена для сворачивания сумм совместителей заведенных на разные табельные номера " +
					"(удобнее заводить совместителей на тотже табельный номер).\n" +
					"Суммы сворачиваются по идентификационному номеру к минимальному табельному номеру, " +
					"обратно развернуть суммы уже будет невозможно (только расчитав заново).\nПродолжить?",
					"Дана операція призначена для згортання сум сумісників заведених на різні табельні номери " +
					"(зручніше заводити сумісників на той самий табельний номер).\n" +
					"Суми згортаються за ідентифікаційним номером до мінімального табельного номеру, " +
					"назад розгорнути суми вже буде неможливо (тільки розрахував знову).\nПродовжити?");
			if(!confirm(msg))
				break;
			DropTable("dblind_min_tabn");
			//отбираем номера с максимальным табельным номером
			var ok = ExecuteSQL("select Ftabn into dblind_min_tabn from "+zppnm6+" as z1 where Fisdblind="+sqlTrue+" and Ftt=0 "
						+" and Ftabn=(select MAX(Ftabn) from "+zppnm6+" as z2 where z1.Fld6=z2.Fld6)");
			DropTable("tbl_sum");
			//сумируем
			if(ok)
				ok = ExecuteSQL("update "+zppnm6+" "
					+" set Fld10=(select SUM(Fld10) from "+zppnm6+" as z2 where "+zppnm6+".Fld6=z2.Fld6 and "+zppnm6+".Ftt=z2.Ftt), "
						+" Fld11=(select SUM(Fld11) from "+zppnm6+" as z2 where "+zppnm6+".Fld6=z2.Fld6 and "+zppnm6+".Ftt=z2.Ftt), "
						+" Fld12=(select SUM(Fld12) from "+zppnm6+" as z2 where "+zppnm6+".Fld6=z2.Fld6 and "+zppnm6+".Ftt=z2.Ftt) "
					+" where Fisdblind="+sqlTrue+" and not exists(select Ftabn from dblind_min_tabn as d where "+zppnm6+".Ftabn=d.Ftabn)");
			//удаляем номера с максимальным номером
			if(ok)
				ok = ExecuteSQL("delete from "+zppnm6+" where Fisdblind="+sqlTrue+" and Ftabn in (select Ftabn from dblind_min_tabn)");
			if(ok)
			{
				dblColor = 2;
				list.tbl.requery();
				grid.DeletePages();
				list.init();
			}
		break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
	    case "PSOG":
		  ExecuteSQL("update "+zppnm6+" set Fld11=Fld10 where "+DataSource().sqlSelected());
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
		case "DBF_EXP":
			var sFileName = BrowseForFile("*.dbf",ru("Экспорт в dbf файл 6-й таблицы","Експорт в dbf файл 6-у таблицю"),null,"save","P04t06b.dbf")
			if (sFileName)
				expToDbfMonthPers(zppnm6, sFileName);
		break;
		case "CHECKSUM":
			var t6 = OpenTable("select Ftabn, Ftabnn, sum(Fld11) as Fsum, sum(Fld12) as Fnal from "+zppnm6+" where Ftt=0 group by Ftabn, Ftabnn order by Ftabnn");
			var m = new Object();
			m.Fwid = "COUNTER";
			m.Ftabnn = "LONG";
			m.Fsum = "MONEY";
			m.Fnal1 = "MONEY";
			m.Fnal2 = "MONEY";
			m.Fsumd = "MONEY";
			CreateTable("check_pers", m);
			
			var proc = get_cnst("proc_pns",gd.dat1);
			setProgressRange(1, t6.rowCount);
			for(; !t6.IsEOF(); t6.MoveNext())
			{
				setProgressPos(t6.bookmark, t6.bookmark+"/"+t6.rowCount);
				var Fsum = Number(t6.getValue("Fsum"));
				var Fnal = Number(t6.getValue("Fnal"));
				var snap = getSnap("select sum(Fld13), sum(Fld14) from "+zppnm7+" where Ftabn="+t6.getValue("Ftabn"));
				if(snap)
				{
					Fsum += Number(snap[0]);
					Fnal += Number(snap[1]);
				}
				//проверяем если расхождение больше 2 копеек
				if(Math.abs(round(Fsum*proc/100,2)-round(Fnal,2))>0.02)
				{
					var m = new Object();
					m.Ftabnn = t6.getValue("Ftabnn");
					m.Fsum = Fsum;
					m.Fnal1 = round(Fsum*proc/100,2);
					m.Fnal2 = round(Fnal,2);
					m.Fsumd = round((m.Fnal2-m.Fnal1)*100/proc,2);
					UpdateTable("check_pers", m, true);
				}
			}
			setProgressPos(0);
			var par = new Object();
			par.cells = new Object();
			par.caption = UR("Таб.№ з помилковими сумами|Таб.№ с ошибочными суммами");
		
			par.cells[1] = new Object();
			par.cells[1].name = "Ftabnn";
			par.cells[1].width = 6;
			par.cells[1].text = UR("Таб.№|Таб.№");
		
			par.cells[2] = new Object();
			par.cells[2].name = "Fsum";
			par.cells[2].width = 10;
			par.cells[2].text = UR("База");	
			
			par.cells[3] = new Object();
			par.cells[3].name = "Fnal2";
			par.cells[3].width = 10;
			par.cells[3].text = UR("Утримано в ПФ|Удержано в ПФ");
			
			par.cells[4] = new Object();
			par.cells[4].name = "Fnal1";
			par.cells[4].width = 10;
			par.cells[4].text = UR("Утримано в ПФ (перевірка)|Удержано в ПФ (проверка)");
			
			par.cells[5] = new Object();
			par.cells[5].name = "Fsumd";
			par.cells[5].width = 10;
			par.cells[5].text = UR("Різниця бази ПФ\n(приблизно)|Разница базы ПФ\n(приблизительно)");
			var tbl = OpenTable("select * from check_pers order by Ftabnn");
			if(tbl.rowCount>0)
				browse(tbl, par, SW_MODAL);
			else
				alert(ru("Помилок не знайдено.","Ошибок не найдено."))
			tbl.close();
			t6.close();
		break;
		case "LT6":
		showWindow("l_comp6t.js", SW_NOMODAL);
		break;				
		case "LT7":
		showWindow("l_comp7t.js", SW_NOMODAL);		
		break;
    case "PERITM":
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm6 = "^ZPPNMVI"+szTag;
	zppnm7 = "^ZPPNMVII"+szTag;
	zppnm7d = "^ZPPNMVIID"+szTag;
	    
    //переделал на постоянные таблицы, чтоб одни и те же пользователи работающие с несколькими базами не затирали результаты предыдущей расчитанной базы
    //CreateTableEx("ZRP_RES","ZRP_ZPPNMVI"+szTag, "ZPPNM6", "*");
    //var zppnm6 = "^ZPPNMVI"+szTag;
    ExecuteSQL("delete from "+zppnm6)
    strSQL = "insert into "+zppnm6+"(Fisdblind,Ftabn,Ftabnn,Fld10,Fld11,Fld12,Ftt,Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fld13,Fld14)"
    		+" select Fisdblind,Ftabn,Ftabnn,sum(Fld10) as Fld10, sum(Fld11) as Fld11,sum(Fld12) as Fld12, 0 as Ftt,"
            	+" Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8, Fld9, Fld13,Fld14 "
            +" from ZPPNS6 "
            +" group by Ftabn,Ftabnn,Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8, Fld9, Fld13,Fld14,Fisdblind"
    ExecuteSQL(strSQL);
    
    //если прописываем дату возникновения в 7 таблице, то используем этот оператор
    //ExecuteSQL("update ZPPNS7 set Fmes="+sqlTo(d00obj)+" where Fmes="+sqlTo(bkv));
    
    //DropTable("ZPPNS71")
    //CreateTableEx("ZRP_RES","ZRP_ZPPNMVII"+szTag, "ZPPNM7", "*");
    //var zppnm7 = "^ZPPNMVII"+szTag;
    ExecuteSQL("delete from "+zppnm7)    
	//если делаем дату возникновения пустой всегда в 7 таблице, то используем этот оператор    
    //strSQL ="select Fisdblind,Ftabn, Ftabnn, sum(a.Fld12) as Fld12, sum(a.Fld13) as Fld13,sum(a.Fld14) as Fld14, 0 as Ftt,"
    //        +" Fld6, Fld7, Fld7f, Fld7i, Fld7o, Fld8, Fld9, Fld10, Fld11, Fld15, Fld16 into ZPPNS71 from ZPPNS7 as a group by Ftabn, Ftabnn, Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8,Fld9,Fld10,Fld11,Fld15,Fld16,Fisdblind"
    //если прописываем дату возникновения в 7 таблице, то используем этот оператор
    strSQL ="insert into "+zppnm7+"(Fisdblind,Ftabn,Ftabnn,Fld10,Fld12,Fld13,Fld14,Ftt,Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fld11,Fld15,Fld16)"
    		+" select Fisdblind,Ftabn, Ftabnn, Fmes as Fld10,sum(a.Fld12) as Fld12, sum(a.Fld13) as Fld13,sum(a.Fld14) as Fld14, 0 as Ftt,"
            	+" Fld6, Fld7, Fld7f, Fld7i, Fld7o, Fld8, Fld9, Fld11, Fld15, Fld16 "
            +" from ZPPNS7 as a "
            +" group by Ftabn, Ftabnn, Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8,Fld9,Fmes,Fld11,Fld15,Fld16,Fisdblind"
    ExecuteSQL(strSQL);
    ExecuteSQL("delete from "+zppnm7+" where Fld12+Fld13+Fld14=0");

    DropTable("ZPPNS62")
    ExecuteSQL("select sum(Fld10) as Fld10, sum(Fld11) as Fld11,sum(Fld12) as Fld12, 1 as Ftt"
            +" into ZPPNS62 from "+zppnm6);
    ExecuteSQL("insert into "+zppnm6+" (Ftabn,Ftabnn,Ftt,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Fld12,Fld13,Fld14) select 0,0,Ftt,'','',0,0,Fld10,Fld11,Fld12,0,0 from ZPPNS62");

    DropTable("ZPPNS72")
    ExecuteSQL("select sum(Fld12) as Fld12, sum(Fld13) as Fld13,sum(Fld14) as Fld14, 1 as Ftt"
            +" into ZPPNS72 from "+zppnm7 )
    ExecuteSQL("insert into "+zppnm7+" (Ftabn,Ftabnn,Ftt,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Fld12,Fld13,Fld14,Fld15,Fld16)select 0,0,Ftt,'','',0,0,"+sqlTo(d00obj)+",0,Fld12,Fld13,Fld14,0,0 from ZPPNS72");
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	if(list.tbl.getValue("Ftt")==0)
	{
		var n = new Object();
		n.Fld10 = list.tbl.getValue("Fld10");
		n.Fld11 = list.tbl.getValue("Fld11");
		n.Fld12 = list.tbl.getValue("Fld12");			
		n.Fld8  = list.tbl.getValue("Fld8");
		n.Fld9  = list.tbl.getValue("Fld9");
		n.Fld13  = list.tbl.getValue("Fld13");
		n.Fld14  = list.tbl.getValue("Fld14");
		UpdateTable(zppnm6, n, false, "Fwid="+list.tbl.getValue("Fwid"));
								
		//апдейтим общий итог
		var snap = getSnap("select SUM(Fld10),SUM(Fld11),SUM(Fld12)"
						+" from "+zppnm6+""
						+" where Ftt<>1");
		if(snap)
		{
				m.Fld10 = snap[0];
				m.Fld11 = snap[1];
				m.Fld12 = snap[2];
				UpdateTable(zppnm6, m, false, "Ftt=1");
		}

	}
	return true;
}

function listDel()
{

	ExecuteSQL("delete from "+zppnm6+" where Fwid="+list.tbl.getValue("Fwid"));
	//апдейтим общий итог
	var snap = getSnap("select SUM(Fld10),SUM(Fld11),SUM(Fld12) "
				+" from "+zppnm6+" where Ftt=0");
	var m = new Object();				
	if(snap)
	{
		m.Fld10 = snap[0];
		m.Fld11 = snap[1];
		m.Fld12 = snap[2];
		UpdateTable(zppnm6, m, false, "Ftt=1");
	}
	return false;
}

function getTblH()
{ 
	var h = new Object();
	h.HDAT1 = gd.dat1;
	return h;
}

function getOrder(mode)
{
	var sOrder = "Ftt,Ftabnn";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Ftt,Fld7, Ftabnn";
		break;
		case "IND":
			sOrder = "Ftt,Fld6, Ftabnn";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");	
	