//просмотр справки в пенсионный фонд
include("r_compns.js");
include("r_compns2.js");
include("r_imppns.js");
include("gridedit.js");
include("servis/date.js");

var mode,yearTag,dpGridEdit, oGrid;
var isMinimize = false;
var sortMode = "TABN";
var isMinPers = true;
var Ftabn = 0;
var isDblInd = false;
var dblColor = 17;

function listLoad()
{
	this.title = ru("Просмотр справки в пенсионный фонд","Перегляд довідки в пенсійний фонд");
	this.printLabel = "ZPPNS";
	mode=GetMenuMode();
	if (mode=="R")
	{
		var par=new Object();
		par.sysname = getSysName();
		par.escape = false;
		par._is1000nch = true;
		par._is1000pns = true;
		par._isbln = true;
		par._isblnpns = true;
		par._isprsh = true;
		par.xyear = getParWithDef("DAT1_P", par.sysname, d00);
		par.xyeare = getParWithDef("DAT2_P", par.sysname, d00);
		par.xyearv = par.xyear?new Date(par.xyear).getFullYear():today.getFullYear();
		par._KPFU = "";
		par._KTSZ = "1";
		par.xdtzap = today.getVarDate();
		showWindow("e_zsprpns.xml", SW_MODAL, par);	
		setParWithDef("DAT1_P", par.xyear, par.sysname);
		setParWithDef("DAT2_P", par.xyeare, par.sysname);
		if (par.escape)
			return false;
		yearTag = par.xyearv+"01";
		r_compns(par);
		ExecuteSQL("update ^zppns"+yearTag+" set FIO = (select Ftxt from ^cl as cl where cl.Fwid=^zppns"+yearTag+".Ftabn)");
		//проставим признак задвоенности идентификационных номеров для разных табельных номеров
		if(SUBD!=MYSQL)
			ExecuteSQL("update ^zppns"+yearTag+" set Fisdblind="+sqlTrue+" where tin in (select tin from ^zppns"+yearTag+" where Ftt=1 group by tin having count(fcod)>1)");
		else
		{
			DropTable("BUF_TIN");
			ExecuteSQL("select * into BUF_TIN from ^zppns"+yearTag);
			ExecuteSQL("update ^zppns"+yearTag+" set Fisdblind="+sqlTrue
					+" where tin in (select tin from BUF_TIN"
							+" where Ftt=1 group by tin having count(fcod)>1)");
		}
		if(getPar("ZPPNS_YEAR"))
			wholeYear(par.xyear,par.xyeare);
	}
	else
	{
		if (mode=="R2")
		{
			var par=new Object();
			par.sysname=getSysName();
			par.escape=false;
			par._is1000nch = true;
			par._is1000pns = true;
			par._isbln = true;
			par._isblnpns = true;
			par._isprsh = true;
			par.xyear = getParWithDef("DAT1_P", par.sysname, d00);
			par.xyeare = getParWithDef("DAT2_P", par.sysname, d00);
			par.xyearv = par.xyear?new Date(par.xyear).getFullYear():today.getFullYear();
			par._KPFU = "";
			par._KTSZ = "1";
			par.xdtzap = today.getVarDate();
			showWindow( "e_zsprpns.xml", SW_MODAL, par);
			setParWithDef("DAT1_P", par.xyear, par.sysname);
			setParWithDef("DAT2_P", par.xyeare, par.sysname);
			if (par.escape)
				return false;
			yearTag = par.xyearv+"01";
			r_compns2(par);
			ExecuteSQL("update ^zppns"+yearTag+" set FIO = (select Ftxt from ^cl as cl where cl.Fwid=^zppns"+yearTag+".Ftabn)");
			//проставим признак задвоенности идентификационных номеров для разных табельных номеров
			if(SUBD!=MYSQL)
				ExecuteSQL("update ^zppns"+yearTag+" set Fisdblind="+sqlTrue+" where tin in (select tin from ^zppns"+yearTag+" where Ftt=1 group by tin having count(fcod)>1)");
			else
			{
				DropTable("BUF_TIN");
				ExecuteSQL("select * into BUF_TIN from ^zppns"+yearTag);
				ExecuteSQL("update ^zppns"+yearTag+" set Fisdblind="+sqlTrue
						+" where tin in (select tin from BUF_TIN"
								+" where Ftt=1 group by tin having count(fcod)>1)");
			}
			if (getPar("ZPPNS_YEAR"))
				wholeYear(par.xyear,par.xyeare);
		}
		else
		{
			var form = createForm(UR("Введіть рік розрахунку|Введите год расчета"));
			var year = form.addObj("year","combo",UR("Рік|Год"));
			curYear = today.getFullYear()
			for(var i=curYear-10; i<curYear+10; i++)
				year.addItem(i,i);
			year.setValue(Number(ReadParEx("persYear")));
			form.show();
			if(form.escape)
				return false;
			WriteParEx("persYear",form.year);
			yearTag = Number(form.year)+"01";
			if (!IsTableEx("ZRP_RES", "ZRP_ZPPNS"+yearTag))
		    {
    		    alert(ru("Произведите сначала расчёт персонификации за "+form.year+" год!",
    		    		"Спершу виконайте розрахунок персоніфікації за "+form.year+" рік!"));
	        	return false;
	    	}
		}
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	var snap = getSnap("select count(*) from ^zppns"+yearTag+" where Fisdblind="+sqlTrue)
	if(snap && snap[0]>0)
	{
		isDblInd = true;
		snap = getSnap("select count(fcod) from ^zppns"+yearTag+" where Ftt=1 group by tin having count(fcod)>1");
		if(snap && snap[0]>1)
			dblColor = 17;
		else
			dblColor = 2;
	}
}

function listSrc()
{
	if(isMinimize)
		this.qrySet("From", "^zppns"+yearTag, "Where", "Ftt>0 "+(isMinPers?"":" OR Ftabn="+ftabn), "Order", getOrder(sortMode));
	else
		this.qrySet("From", "^zppns"+yearTag, "Order", getOrder(sortMode));
	this.subTie("cl","cl","Fwid","Ftabn");
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with( oGrid )
	{
		defCond("=^Ftt==2", "ITOG_ALL");
		color(1, "ITOG_ALL");
		bold("ITOG_ALL");
		defCond("=^Ftt==1", "ITOG_GET");
		color(25, "ITOG_GET");
		defCond("=^Fisdblind==true", "DBL_IND");
		color(dblColor, "DBL_IND");
		defCond("=^Fisdblind==true && ^Ftt==1", "ITOG_DBL_IND");
		color(dblColor, "ITOG_DBL_IND");
		bold("ITOG_DBL_IND");
	}
	
	gr.FieldEx(isMinimize?"=(^Ftt<2)?^Fcod:'Итого'":"=(^Ftt==0)?^Fcod:'Итого'","Таб.№|Таб.№",6,"","%10d");
	gr.FieldEx("=(^Ftt==0)?'':getSmallFIO(^Fio)","ПIБ|ФИО",15);
	gr.FieldEx("=(^Ftt==0)?'':^TIN","Iдент-й №|Идент-й №",6);
	if(isDblInd)
		gr.FieldEx("Fisdblind","Задв.\nід.№|Задв.\nид.№",3);
	with(gr.group("Сума|Сумма"))
	{
		FieldEx("S_DOX","доходу|дохода",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("S_DOXPNS","дох.для пенс.|дох.для пенс.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("S_BOLN","лiкарняних|больничных",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("S_TAX","податку|налога",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("S_DOXZP","для нарах.на ЗП|для нач.на ЗП",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	}
	gr.FieldEx("S_TAXZP","Нарахування\nна ЗП|Начисления\nна ЗП",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("DN_STMES","Повн.дн.стажу|Полн.дн.стажа",8, "e");
	gr.FieldEx("DAT_BEG","Початок стажу|Начало стажа",6, "e");
	gr.FieldEx("DAT_END","Кiнець стажу|Конец стажа",6, "e");
	with(gr.group("Повн.для ст.|Полн.для ст."))
	{
		FieldEx("MES_ST","мiсяцiв|месяцев",3,"e");
		FieldEx("DN_ST","днiв|дней",3,"e");
	}
	gr.FieldEx("=^Ftt==0?new Date(^Fmes).getMonth()+1:''","№ мiс.|№ мес.",3,"e","%10d");
	gr.FieldEx("FOTK","Тр.кн.|Тр.кн.",3,"e");
	gr.FieldEx("KTSZ","Код типу\nст.стр.зб.|Код типа\nст.стр.сб.",3,"e");
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			if(isMinimize)
			{
				AddMenuItem("MINIMIZE", "Згорнути|Свернуть",ICON_RADIO);
				AddMenuItem("MAXIMIZE", "Розгорнути|Развернуть");
				AddMenuItem ("","");
				if(isMinPers)
				{
					AddMenuItem("MINPERS", "Згорнути по співробітнику|Свернуть по сотруднику",ICON_RADIO);
					AddMenuItem("MAXPERS", "Розгорнути по співробітнику|Развернуть по сотруднику");
				}
				else
				{
					if(ftabn == list.tbl.getValue("Ftabn"))
					{
						AddMenuItem("MINPERS", "Згорнути по співробітнику|Свернуть по сотруднику");
						AddMenuItem("MAXPERS", "Розгорнути по співробітнику|Развернуть по сотруднику",ICON_RADIO);
					}
					else
					{
						AddMenuItem("MINPERS", "Згорнути по співробітнику|Свернуть по сотруднику",ICON_RADIO);
						AddMenuItem("MAXPERS", "Розгорнути по співробітнику|Развернуть по сотруднику");
					}
				}
			}
			else
			{
				AddMenuItem("MINIMIZE", "Згорнути|Свернуть");
				AddMenuItem("MAXIMIZE", "Розгорнути|Развернуть",ICON_RADIO);
			}
			AddMenuItem ("","");
			AddMenuItem("MININD", "Згорнути по ідентифікаційному номеру|Свернуть по идентификационному номеру");
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem ("","");
			AddMenuItem("EXPNF", ru("Экспорт данных персонификации", "Експорт даних персоніфікації"));
			//печать переделали на стандартную
			//AddMenuItem("PRINTPNF", ru("Печать", "Друк"), 9);
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
		}
	}	
}


function wholeYear(bdat,edat)
{
	bdat = new Date(bdat);
	edat = new Date(edat);
	if(bdat.getFullYear()!=edat.getFullYear())
		return false;
	t = OpenTable("select distinct fcod, ftabn, tin, fio from ^zppns"+yearTag+" where Ftt!= 1 and fcod!= 0")
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
    {
    	for (var i=bdat.getMonth(); i < edat.getMonth()+1; i++) 
		{
			snap = getSnap("select Fmes from ^zppns"+yearTag+" WHERE Fcod = "+t.getValue("Fcod")+" and Fmes = "+sqlTo(new Date(bdat.getFullYear(),i,1)))
			if (!snap)//если не нашли запись по человеку на данный месяц, то генерируем ее
			{
				d = new Date(bdat.getFullYear(),i,1)
		   		var m = new Object()
				//m.DAT_BEG = null
				//m.DAT_END = null
				//m.DN_ST = null
				//m.DN_STMES = null
				m.FMES = toScrObj(d)
				//m.FOTK = null
				m.FTABN = toScrObj(t.getValue("Ftabn"))
				m.FTT = 0
				//m.FULL_MES = null
				//m.MES_ST = null
				//m.NP = null
				m.S_BOLN = 0
				m.S_DOX = 0
				m.S_DOXPNS = 0
				m.S_DOXZP = 0
				m.S_TAX = 0
				m.S_TAXZP = 0
				m.TIN = toScrObj(t.getValue("TIN"))
				//m.KTSZ = null
				m.FCOD = toScrObj(t.getValue("fcod"))
				m.FIO = toScrObj(t.getValue("Fio"))
				UpdateTable("^zppns"+yearTag, m, true)
			}
			
		}
 	}
}



function listMenuRun(ID)
{
	switch(ID)
	{
		case "EXPNF":
			r_imppns("^zppns"+yearTag);
		break;
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			strD1 = getParWithDef("DAT1_P", getSysName());
			strD1 = strD1.substr(0,strD1.indexOf(" "))
			strD2 = getParWithDef("DAT2_P", getSysName());
			strD2 = strD2.substr(0,strD2.indexOf(" "))
			D1=new Date(strToDateFormat(strD1,"dd.mm.yy"));
			D2=new Date(strToDateFormat(strD2,"dd.mm.yy"));
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
			for (var i=D1.getMonth(); i < D2.getMonth()+1; i++) 
			{
				d = new Date(D1.getFullYear(),i,1)
		   		var m = new Object()
				m.DAT_BEG = null
				m.DAT_END = null
				m.DN_ST = 0
				m.DN_STMES = null
				m.FMES = d.getVarDate()
				m.FOTK = null
				m.FTABN = tabn_id
				m.FTT = 0
				m.FULL_MES = null
				m.MES_ST = 0
				m.NP = null
				m.S_BOLN = 0
				m.S_DOX = 0
				m.S_DOXPNS = 0
				m.S_DOXZP = 0
				m.S_TAX = 0
				m.S_TAXZP = 0
				m.TIN = toScrObj(t.getValue("FINDNUM"))
				m.KTSZ = null
				m.FCOD = toScrObj(tabn)
				m.FIO = toScrObj(t.getValue("FTXT"))
				UpdateTable("^zppns"+yearTag, m, true)
			}
		
			ExecuteSQL("insert into ^zppns"+yearTag+"(DAT_BEG, DAT_END, DN_ST, DN_STMES, FMES, FOTK, FTABN, FTT, FULL_MES, MES_ST,"
							+"NP, S_BOLN, S_DOX, S_DOXPNS, S_DOXZP, S_TAX, S_TAXZP, TIN, KTSZ, FCOD,FIO ) "
					+" select "+sqlTo(D1)+", "+sqlTo(D2)+", 0, sum(DN_STMES), null,  "+sqlTo("1")+","+t.getValue("fwid_cl")+", 1, null, 0,"
							+"null, sum(S_BOLN), sum(S_DOX), sum(S_DOXPNS), sum(S_DOXZP), sum(S_TAX), sum(S_TAXZP), "+t.getValue("FINDNUM")+", "+sqlTo("1")+","
							+tabn+", "+sqlTo(t.getValue("FTXT"))
					+" from ^zppns"+yearTag
					+" where Ftt<1 and Fcod="+tabn);
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
		case "MINIMIZE":
			if(isMinimize)
				break;
			isMinimize = true;
			grid.DeletePages();
			list.init();
		break;
		case "MAXIMIZE":
			if(!isMinimize)
				break;
			isMinimize = false;
			grid.DeletePages();
			list.init();
		break;
		case "MINPERS":
			if(isMinPers)
				break;
			isMinPers = true;
			ftabn = 0;
			grid.DeletePages();
			list.init();
		break;
		case "MAXPERS":
			isMinPers = false;
			ftabn = list.tbl.getValue("Ftabn");
			grid.DeletePages();
			list.init();
		break;
		case "MININD":
			var msg = ru("Данная операция предназначена для сворачивания сумм совместителей заведенных на разные табельные номера " +
					"(удобнее заводить совместителей на тотже табельный номер).\n" +
					"Суммы сворачиваются по идентификационному номеру к минимальному табельному номеру, " +
					"обратно развернуть суммы уже будет невозможно (только расчитав заново).\nПродолжить?",
					"Дана операція призначена для згортання сум сумісників заведених на різні табельні номери " +
					"(зручніше заводити сумісників на той самий табельний номер).\n" +
					"Суми згортаються за ідентифікаційним номером до мінімального табельного номеру, " +
					"назад розгорнути суми вже буде неможливо (тільки розрахував знову).\nПродовжити?");
			if(!confirm(msg))
				break;
			DropTable("dblind_min_tabn");
			//отбираем номера с максимальным табельным номером
			var ok = ExecuteSQL("select Fcod into dblind_min_tabn from ^zppns"+yearTag+" as z1 where Fisdblind="+sqlTrue+" and Ftt=0 "
						+" and Fcod=(select MAX(Fcod) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin)");
			DropTable("tbl_sum");
			//сумируем
			if(ok)
				ok = ExecuteSQL("update ^zppns"+yearTag+" as z1 "
					+" set S_DOX=(select SUM(S_DOX) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes), "
						+" S_DOXPNS=(select SUM(S_DOXPNS) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes), "
						+" S_BOLN=(select SUM(S_BOLN) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes), "
						+" S_TAX=(select SUM(S_TAX) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes), "
						+" S_DOXZP=(select SUM(S_DOXZP) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes), "
						+" S_TAXZP=(select SUM(S_TAXZP) from ^zppns"+yearTag+" as z2 where z1.Tin=z2.Tin and z1.Ftt=z2.Ftt and z1.Fmes=z2.Fmes) "
					+" where Fisdblind="+sqlTrue+" and not exists(select Fcod from dblind_min_tabn as d where z1.Fcod=d.Fcod)");
			//удаляем номера с максимальным номером
			if(ok)
				ok = ExecuteSQL("delete from ^zppns"+yearTag+" where Fisdblind="+sqlTrue+" and Fcod in (select Fcod from dblind_min_tabn)");
			if(ok)
			{
				dblColor = 2;
				list.tbl.requery();
				grid.DeletePages();
				list.init();
			}
		break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
		case "PRINTPNF":
			var t = OpenTable("select * from ^zppns"+yearTag+" where Ftabn="+list.tbl.getValue("Ftabn")+" Order by Fmes")
			include("Objects/DpTVars.js");
  			var tv = new DpTVars("ZPPNS");
			var h = new Object();
			
			var snapFIO = getSnap("select Ftxt,Fisotch from ^listcl3 where Fwid_cl="+list.tbl.getValue("Ftabn"));
			if(snapFIO)
			{
    			var arFIO = snapFIO[0].split(" ");
    			h.HSERNAME = arFIO[0];
    			h.HPERSNAME = arFIO[1];
    			h.HSECONDNAME = arFIO[2];
           		if (snapFIO[1]==true){
           			h.HPERSNAME = arFIO[1]+" "+arFIO[1]
           			h.HSECONDNAME= ""
           		}
			}
			
			h.HRIK = yearTag;
			var S = OpenTable("select * from ^zppns"+yearTag+" where Ftt = 1 and Ftabn="+list.tbl.getValue("Ftabn"))
			h.HOTK = Number(S.getValue("Fotk"));
			h.HSTAVKA = S.getValue("KTSZ")
			dat = new Date ();
			var dmy = format("ddmmyyyy",dat)
			d1 = dmy[0]
			d2 = dmy[1]
			m1 = dmy[2]
			m2 = dmy[3]
			y1 = dmy[4]
			y2 = dmy[5]
			y3 = dmy[6]
			y4 = dmy[7]
								
			for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
 		    {
 		    	if(t.getValue("Ftt")==0)//идем по месяцам
 		    	{
 		    		var mon = month(t.getValue("Fmes"))
 		    		eval("h.HMES"+mon+" = "+mon);
 		    		var sum = t.getValue("S_DOX")
 		    		eval("h.HDOX"+mon+" = "+sum);
 		    		var pns = t.getValue("S_DOXPNS")
 		    		eval("h.HDOXP"+mon+" = "+pns);
 		    		var boln = t.getValue("S_BOLN")
 		    		eval("h.HBOLN"+mon+" = "+boln);
 		    		var vnes = t.getValue("S_TAX")
 		    		eval("h.HVNES"+mon+" = "+vnes);
 		    		var dn_st = t.getValue("DN_STMES")
 		    		eval("h.HDNST"+mon+"= "+dn_st);
 		    		
 		    	}
 		    	else//итоговая строчка
 		    	{
 		    		
 		    	}
 		    }
 		    nal = S.getValue("S_TAXZP")
			d = format('#####00',nal)
			
 		    n = S.getValue("S_TAX")
 		    n1 = format('#####00',n)
 		    
 		    Min = S.getValue("DAT_BEG")
 		    var beg = format("ddmmyyyy",Min)
 		    b1 = beg[0]
 		    b2 = beg[1]
 		    b3 = beg[2]
 		    b4 = beg[3]
 		    b5 = beg[6]
 		    b6 = beg[7]
 		    Max = S.getValue("DAT_END")
 		    var end = format("ddmmyyyy",Max)
 		  	e1 = end[0]
 		  	e2 = end[1]
 		  	e3 = end[2]
 		  	e4 = end[3]
 		  	e5 = end[6]
 		  	e6 = end[7]
 		  	
 		  	mo = S.getValue("MES_ST")
 		  	mont = format("##",mo)
 		  			  	
 		  	da = S.getValue("DN_ST")
 		  	days = format("##",da)
 		  	
 		     tv.setHTbl(h);
 		    //tv.setRTbl(t);
			tv.print();
			t.close();
		break;
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	if(list.tbl.getValue("Ftt")==0)
	{
		var totalID = getSnap("select Fwid from ^zppns"+yearTag+" where Ftt=2");
		var snapID = getSnap("select Fwid from ^zppns"+yearTag+" where Ftt=1 and Ftabn="+list.tbl.getValue("Ftabn"));
		if(snapID && totalID)
		{
			var n = new Object();
			n.S_DOX = list.tbl.getValue("S_DOX");
			n.S_DOXPNS = list.tbl.getValue("S_DOXPNS");
			n.S_BOLN = list.tbl.getValue("S_BOLN");
			n.S_TAX = list.tbl.getValue("S_TAX");
			n.S_DOXZP = list.tbl.getValue("S_DOXZP");
			n.S_TAXZP = list.tbl.getValue("S_TAXZP");
			n.DN_STMES = list.tbl.getValue("DN_STMES");
			UpdateTable("^zppns"+yearTag, n, false, "Fwid="+list.tbl.getValue("Fwid"));										
			//апдейтим итоговые стоки
			var snap = getSnap("select SUM(S_DOX),SUM(S_DOXPNS),SUM(S_BOLN),SUM(S_TAX),SUM(S_DOXZP),SUM(S_TAXZP),SUM(DN_STMES)"
						+" from ^zppns"+yearTag
						+" where Ftt=0 and Ftabn="+list.tbl.getValue("Ftabn"));
			if(snap)
			{
				m.S_DOX = snap[0];
				m.S_DOXPNS = snap[1];
				m.S_BOLN = snap[2];
				m.S_TAX = snap[3];
				m.S_DOXZP = snap[4];
				m.S_TAXZP = snap[5];
				m.DN_STMES = snap[6];
				UpdateTable("^zppns"+yearTag, m, false, "Fwid="+snapID[0]);
			}
			//апдейтим общий итог
			var snap = getSnap("select SUM(S_DOX),SUM(S_DOXPNS),SUM(S_BOLN),SUM(S_TAX),SUM(S_DOXZP),SUM(S_TAXZP)"
						+" from ^zppns"+yearTag
						+" where Ftt=1");
			if(snap)
			{
				m.S_DOX = snap[0];
				m.S_DOXPNS = snap[1];
				m.S_BOLN = snap[2];
				m.S_TAX = snap[3];
				m.S_DOXZP = snap[4];
				m.S_TAXZP = snap[5];
				m.Fcod = 9999999;//чтоб общий итог был в конце
				UpdateTable("^zppns"+yearTag, m, false, "Fwid="+totalID[0]);
			}
		}
	}
	else
	{
		m.FOTK = list.tbl.getValue("FOTK");
		m.KTSZ = list.tbl.getValue("KTSZ");
		m.MES_ST = list.tbl.getValue("MES_ST");
		m.DN_ST = list.tbl.getValue("DN_ST");
		m.DAT_BEG = list.tbl.getValue("DAT_BEG");
		m.DAT_END = list.tbl.getValue("DAT_END");
		UpdateTable("^zppns"+yearTag, m, false, "Fwid="+list.tbl.getValue("Fwid"));
	}
	return true;
}

function listDel()
{
	ExecuteSQL("delete from ^zppns"+yearTag+" where Fwid="+list.tbl.getValue("Fwid"));
	var snapID = getSnap("select Fwid from ^zppns"+yearTag+" where Ftt=1 and Ftabn="+list.tbl.getValue("Ftabn"));
	//апдейтим итоговые строки
	var snap = getSnap("select SUM(S_DOX),SUM(S_DOXPNS),SUM(S_BOLN),SUM(S_TAX),SUM(S_DOXZP),SUM(S_TAXZP) "
				+" from ^zppns"+yearTag
				+" where Ftt=0 and Ftabn="+list.tbl.getValue("Ftabn"));
	var m = new Object();
	if(snap && snapID)
	{
		m.S_DOX = snap[0];
		m.S_DOXPNS = snap[1];
		m.S_BOLN = snap[2];
		m.S_TAX = snap[3];
		m.S_DOXZP = snap[4];
		m.S_TAXZP = snap[5];
		UpdateTable("^zppns"+yearTag, m, false, "Fwid="+snapID[0]);
	}
	//апдейтим общий итог
	var snap = getSnap("select SUM(S_DOX),SUM(S_DOXPNS),SUM(S_BOLN),SUM(S_TAX),SUM(S_DOXZP),SUM(S_TAXZP) "
				+" from ^zppns"+yearTag
				+" where Ftt=1");
	if(snap)
	{
		m.S_DOX = snap[0];
		m.S_DOXPNS = snap[1];
		m.S_BOLN = snap[2];
		m.S_TAX = snap[3];
		m.S_DOXZP = snap[4];
		m.S_TAXZP = snap[5];
		UpdateTable("^zppns"+yearTag, m, false, "Ftt=2");
	}
	return false;
}

function getTblH()
{
	var t = OpenTable("select * from ^zppns"+yearTag+" where Ftabn="+list.tbl.getValue("Ftabn")+" Order by Fmes")
	var h = new Object();
	//var snapFIO = getSnap("select Ftxt from ^cl where Fwid="+list.tbl.getValue("Ftabn"));
	//if(snapFIO)
	//{
	//	var arFIO = snapFIO[0].split(" ");
	//	h.HSERNAME = arFIO[0];
	//	h.HPERSNAME = arFIO[1];
	//	h.HSECONDNAME = arFIO[2];
	//}
	var snapFIO = getSnap("select Ftxt,Fisotch from ^listcl3 where Fwid_cl="+list.tbl.getValue("Ftabn"));
	if(snapFIO)
	{
		var arFIO = snapFIO[0].split(" ");
		h.HSERNAME = arFIO[0];
		h.HPERSNAME = arFIO[1];
		h.HSECONDNAME = arFIO[2];
   		if (snapFIO[1]==true){
   			h.HPERSNAME = arFIO[1]+" "+arFIO[1]
   			h.HSECONDNAME= ""
   		}
	}
	
	h.HRIK = yearTag;
	var S = OpenTable("select * from ^zppns"+yearTag+" where Ftt = 1 and Ftabn="+list.tbl.getValue("Ftabn"))
	h.HOTK = Number(S.getValue("Fotk"));
	h.HSTAVKA = S.getValue("KTSZ")
	dat = new Date ();
	var dmy = format("ddmmyyyy",dat)
	d1 = dmy[0]
	d2 = dmy[1]
	m1 = dmy[2]
	m2 = dmy[3]
	y1 = dmy[4]
	y2 = dmy[5]
	y3 = dmy[6]
	y4 = dmy[7]
						
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
    {
    	if(t.getValue("Ftt")==0)//идем по месяцам
    	{
    		var mon = month(t.getValue("Fmes"))
    		eval("h.HMES"+mon+" = "+mon);
    		var sum = t.getValue("S_DOX")
    		eval("h.HDOX"+mon+" = "+sum);
    		var pns = t.getValue("S_DOXPNS")
    		eval("h.HDOXP"+mon+" = "+pns);
    		var boln = t.getValue("S_BOLN")
    		eval("h.HBOLN"+mon+" = "+boln);
    		var vnes = t.getValue("S_TAX")
    		eval("h.HVNES"+mon+" = "+vnes);
    		var dn_st = t.getValue("DN_STMES")
    		eval("h.HDNST"+mon+"= "+dn_st);
    		
    	}
    	else//итоговая строчка
    	{
    		
    	}
    }
	t.close();
	return h;
}

function getOrder(mode)
{
	var sOrder = "Fcod, Fmes";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Fio, Fcod, Fmes";
		break;
		case "IND":
			sOrder = "Tin, Fcod, Fmes";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");