include("objects\\DpGrid.js");
include("objects\\DpGetDat.js");
include("get_cnst.js");
include("sys/udfs.js");
include("servis/zrp.js");
include("Objects/DpCl.js");
include("Objects/DpAskEx.js");

var strSelectID = "0";
var oYear;
var oMonth;
var tblName;
var tblOldName;
var button=true;
var dat1;
var dat2;
var sID;
//var objAsk = new Object();
var tblPers;
var tabn,FIO,dolName,oklad;
var isNotUseView = (SUBD==DERBY || SUBD==POSTGRE) //на дерби и PostGre запрос с предаставлением может выполняться очень долго
var oClKat;
var minCodLsKat = 0;
var gd = null;
var isFirstMakeList = true;
var calcNum = 0;

function listAsk()
{
	if(getPar("ZRP_PRIVAT_CALCS"))
	{
		var oAsk = new DpAskEx();
		oAsk.add("D","Дата початку|Дата начала","DAT1", getPar("GLOBDAT1"));
		oAsk.add("B","Основні особові рахунки|Основные лицевые счета","ISBASE", true);
		oAsk.add("CL","ОР за окремим розрахунком|ЛС по отдельному расчету","CALC", 0, getPar("ZRP_PRIVAT_CALCS"));
		oAsk.defCond("this.aQryList['ISBASE'].controls[0].checked == false", "COND_IS_PRIVAT");
		oAsk.enable("CALC", "COND_IS_PRIVAT");
		oAsk.doAsk();
		gd = new Object();
		gd.escape = oAsk.escape;
		if(!oAsk.escape)
		{	
			gd.dat1 = oAsk.get("DAT1"); 
			if(!oAsk.get("ISBASE"))
			{
				gd.calcNum = oAsk.get("CALC").getCod();
				list.title = ru("Лицевые счета","Особисті рахунки")+" ("+UR(oAsk.get("CALC").getTxt())+")";
			}
			else
				gd.calcNum = 0;			
		}
		list.objAskIs = true;
	}
	else
	{
		if (gd == null)
			gd = new DpGetDat("d");
	}
	return gd;
}

function listLoad()
{
	if(typeof(Tree) == "undefined") return;
     
     /* objAsk = new DpGetDat("d");
      if (objAsk.escape)
      	return false;
      //	showObject(objAsk.dat1,SW_MODAL);
      dat1 = toScriptDate(firstDayMonth(objAsk.dat1));
      dat2 = toScriptDate(lastDayMonth(objAsk.dat1));
      
      var sSql = "SELECT rel.fcod,cl.ftxt as ftxt,wp.fwid as fid_wp,cl_2.ftxt as fdol "
      			+ " FROM ^work_pers as wp inner join ^stru_dol as dol on wp.fwid_dol=dol.fwid "
      			+ " inner join ^clrelclcl as rel_2 on dol.fcod=rel_2.fcod and rel_2.fcl=" + getPar("CODDOL")
      			+ " inner join ^cl as cl_2 on cl_2.fwid=rel_2.fwid_cl"
      			+ " inner join ^clrelclcl as rel on wp.fwid_cl=rel.fwid_cl "
      			+ " inner join ^cl as cl on cl.fwid=rel.fwid_cl";
      
      sSql += " WHERE (wp.fbdat<=" + sqlTo(dat1) + " AND wp.fedat>=" + sqlTo(dat2) + ")"
		+ " OR (wp.fbdat>=" + sqlTo(dat1) + " AND wp.fbdat<=" + sqlTo(dat2) + ")"
		+ " OR (wp.fedat>=" + sqlTo(dat1) + " AND wp.fedat<=" + sqlTo(dat2) + ")"
						
	  sSql += " ORDER BY rel.fcod ";
	
	var tblPers = OpenTable("s", sSql);
	while(!tblPers.isEOF())
	{
		var cod = String(tblPers.getValue("fid_wp"));
		Tree.addItem("0",cod, tblPers.getValue("fcod")+"." +tblPers.getValue("ftxt") + "(" + tblPers.getValue("fdol")+")", TREE_ITEM);
	   	tblPers.moveNext();
	}
	*/	
	this.onTreeSelected = onTreeSelected;	
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	this.loadTreeMenu = loadTreeMenu;
	Tree.loadMenuHandler(this, "loadTreeMenu");
	this.runTreeMenu = runTreeMenu;
	Tree.selectMenuHandler(this, "runTreeMenu");	
	
	//Tree.addAccel(0, "right", "NEXT_DAT");
	//Tree.addAccel(0, "left", "PREV_DAT");
	Tree.addAccel(0, ".", "NEXT_DAT");
	Tree.addAccel(0, ",", "PREV_DAT");
	grid.addAccel(0, ".", "NEXT_DAT");
	grid.addAccel(0, ",", "PREV_DAT");
	
	NEXT_DAT.getCtrl().setToolTipText(UR("Наступний місяць|Следующий месяц"));
	PREV_DAT.getCtrl().setToolTipText(UR("Попередній місяць|Предыдущий месяц"));
	//Disable(HDAT);
	setButton(PREV_DAT, prev);
	setButton(NEXT_DAT, next);
	setValid(HDAT, HDAT_valid);
	HDAT.setSelectionHandler(HDAT_change);
	
	if(getPar("LS_KAT"))
	{
		oClKat = new DpCl("0!",getPar("LS_KAT"),0);
    	oClKat.linkCombo(FLS_KAT);
		LSKAT_GRP.visible = true;
		setValid(FLS_KAT, FLS_KAT_valid);
	}
	list.title = ru("Лицевые счета","Особисті рахунки")
//	HOKLAD.text = "";
//	HOKLAD.setEnabled(false);
}

function HDAT_valid()
{
	//Tree.removeAll();
	//tblPers.close();
	//listMake();
	//list.subSrc();
	//list.tblInit();
	prevDat = HDAT.value;
}

function HDAT_change()
{	
	if (!IsTableEx("ZRP_RES","zrp_svnr"+(calcNum>0?calcNum:"")+getDateTag(HDAT.value)))
	{
		alert("За заданный период зарплата не расчитана!");
		HDAT.value = prevDat;
		return false;
	}
	if(differ(HDAT.value,prevDat)!=0)
	{
		Tree.removeAll();
		tblPers.close();
		isFirstMakeList = true;
		listMake();
		list.subSrc();
		list.tblInit();
	}
}

function FLS_KAT_valid()
{
	if(getPar("LS_KAT"))
	{
		Tree.removeAll();
		tblPers.close();
		isFirstMakeList = true;
		listMake();
		list.subSrc();
		list.tblInit();
	}
	return true;
}

function next()
{
	HDAT_valid();
	var dat = new Date(HDAT.value);
	dat = new Date(dat.getFullYear(), dat.getMonth()+1, 1);
	if (!IsTableEx("ZRP_RES","zrp_svnr"+(calcNum>0?calcNum:"")+getDateTag(dat)))
	{
		alert("За заданный период зарплата не расчитана!");
		return false;
	}
	HDAT.value = dat.getVarDate();
	//HDAT_change();
	list.subSrc();
	list.tblInit();
	if(list.tbl)
		list.tbl.addQuery();
	buildTree();
}

function prev()
{
	HDAT_valid();
	var dat = new Date(HDAT.value);
	dat = new Date(dat.getFullYear(), dat.getMonth()-1, 1);
	if (!IsTableEx("ZRP_RES","zrp_svnr"+(calcNum>0?calcNum:"")+getDateTag(dat)))
	{
		alert("За заданный период зарплата не расчитана!");
		return false;
	}
	HDAT.value = dat.getVarDate();
	//HDAT_change();
	list.subSrc();
	list.tblInit();
	if(list.tbl)
		list.tbl.addQuery();
	buildTree()
}

function onTreeSelected(strCod, strMode)
{
	if("ENTER" != strMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = strCod;
	list.isSetFocusOnGrid = false;
	this.reLoad();
	list.isSetFocusOnGrid = true;
	return;
}

function listSrc()
{
	if (HDAT.isNull())
		HDAT.value = list.objAsk.dat1;
	prevDat = HDAT.value;
	if(list.objAsk.calcNum)
		calcNum = list.objAsk.calcNum;
//	var oSnap = getSnap("SELECT sd.Foklad, cv.Fvopl, cv.Fnzv_vopl, wp.Fwid, rel.Fcod, cw.Ftxt, cd.Ftxt AS Fdoltxt, so.Ftxt as Forgtxt FROM ^work_pers AS wp "
//				+ " INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
//				+ " INNER JOIN ^cl_vopl AS cv ON wp.Fvopl=cv.Fvopl "
//				+ " INNER JOIN ^clrelclcl AS rel ON rel.Fwid_cl=wp.Fwid_cl "
//				+ " INNER JOIN ^cl AS cw ON cw.Fwid=wp.Fwid_cl "
//				+ " INNER JOIN ^cl AS cd ON cd.Fwid=sd.Fwid_cl "
//				+ " INNER JOIN ^stru_org AS so ON so.Fwid=sd.Fwid_org "
//			+" WHERE wp.Fwid_cl="+sqlTo(Number(strSelectID))+" AND cv.Fgroup="+sqlTrue
//			+" AND (wp.fbdat<=" + sqlTo(HDAT.value) + " AND wp.fedat>=" + sqlTo(HDAT.value) + ")");
	var ftabn_id = isNaN(Number(strSelectID))?0:Number(strSelectID);

	if(isNotUseView)
	{
		var oSnap = getSnap("SELECT d.Foklad, cv.Fvopl, cv.Fnzv_vopl, f.Fwid, cl.Fcod as Fcod, cl.Ftxt as Ftxt,"
					+ " cld.Ftxt AS Fdoltxt, o.Ftxt as Forgtxt, cl3.Fwrkdat, ti.Fnorma_d, ti.Fnorma_ch "
				+ " FROM ^work_pers AS f "
					+" INNER JOIN ^cl_vopl AS cv ON f.Fvopl = cv.Fvopl "
					+" INNER JOIN ^stru_dol d on f.fwid_dol = d.fwid "
					+" INNER JOIN ^stru_org o on d.fwid_org = o.fwid "
					+" INNER JOIN ^listcl cl on f.fwid_cl = cl.fwid "
					+" INNER JOIN ^listcl cld on d.fwid_cl = cld.fwid "
					+" LEFT JOIN ^listcl3 cl3 on f.fwid_cl = cl3.fwid "
					+" LEFT JOIN ^tbl_ini as ti ON f.Fvopl=ti.Fvopl and ti.Fbdat="+sqlTo(HDAT.value)
				+" WHERE cv.Fgroup = "+sqlTrue
					+" AND F.Fwid_cl = "+sqlTo(ftabn_id)
					+" AND F.fbdat <= " + sqlTo(lastDayMonth(HDAT.value))
					+" AND F.fedat >= " + sqlTo(firstDayMonth(HDAT.value))
				+" ORDER BY "
					+" F.FWID DESC ");
	}
	else
	{
		var oSnap = getSnap("SELECT f.Foklad, cv.Fvopl, cv.Fnzv_vopl, f.Fwid, f.Fcodpers as Fcod, f.Ftxtpers as Ftxt,"
					+ " f.Ftxtdol AS Fdoltxt, f.Ftxtorg as Forgtxt, f.Fwrkdat, ti.Fnorma_d, ti.Fnorma_ch "
				+ " FROM ^full_pers AS f "
					+ " INNER JOIN ^cl_vopl AS cv ON f.Fvopl=cv.Fvopl "
					+ " LEFT JOIN ^tbl_ini as ti ON f.Fvopl=ti.Fvopl and ti.Fbdat="+sqlTo(HDAT.value)
				+" WHERE cv.Fgroup="+sqlTrue+" and f.Fwid=(select MAX(Fwid) from ^work_pers where Fwid_cl="+sqlTo(ftabn_id)
					+" and fbdat<=" + sqlTo(lastDayMonth(HDAT.value)) + " and fedat>=" + sqlTo(firstDayMonth(HDAT.value))+")");
	}
	if(oSnap!=null)
	{
		oklad = oSnap[0];
		HINFO.text = "Оклад: "+oklad+ru("  Вид оплаты: ","  Вид оплати: ") + oSnap[1] + "(" + oSnap[2] + ")"+ru("  Норма: ","  Норма: ")+Number(oSnap[9])+"/"+Number(oSnap[10])
						+ru("  Дата приема: ","  Дата прийняття: ")+format("dd.mm.yy",oSnap[8])+ru("  Подразделение: ","  Підрозділ: ")+oSnap[7]
		//HVOPL.text = ru("Вид оплаты: ","Вид оплати: ") + oSnap[1] + "(" + oSnap[2] + ")";
		//HPODR.text = ru("Підрозділ: ","Подразделение: ")+oSnap[7]
		tabn = oSnap[4];
		FIO = oSnap[5];
		dolName = oSnap[6];
		//HFWID_WP.text = "Fwid_wp: "+oSnap[3];
	}
	else
	{
		HINFO.text = "";
	}
	
	oYear = String(HDAT.getYear());
	oMonth = String(HDAT.getMonth());
	tblOldName = tblName;
	
	tblName ="svnr"+(calcNum>0?calcNum:"") + getDateTag(HDAT.value);
	
	var sWhere = "Ftabn_id=" + sqlTo(Number(strSelectID)) 
		+ (getPar("SHOW_PAST_LS")?"":" AND NOT (Fvp=1 AND Fmn>=" + sqlTo(HDAT.value)+") AND NOT (FSUM=0 AND FDNKL<>0)")
		+ (getPar("SHOW_BASE_LS")?"":" AND (NOT (Fis12='1' OR Fis12='2' OR Fis12='3' OR Fis12='4' OR Fis12='5' OR Fis12='6' OR Fis12='7') OR Fis12 is null)");
//	var sWhere = "Ftabn_id=" + sqlTo(Number(strSelectID));
	if(getPar("LS_KAT"))
	{
		if(FLS_KAT.value!=0)
			sWhere += " AND s.Fls_kat="+sqlTo(FLS_KAT.value);
		else//в общем режиме не выводим итоговые суммы по категориям
			sWhere += " AND (NOT Fis6 like 'ф_' OR Fis6 is null) AND (NOT Fis6 like 'у_' OR Fis6 is null) "
						+" AND (NOT Fis6 like 'н_' OR Fis6 is null) AND (NOT Fis6 like 'з_' OR Fis6 is null) "
						+" AND (NOT Fis6 like 'б_' OR Fis6 is null)";
	}
	
	if (!IsTableEx("ZRP_RES","zrp_"+tblName))
	{
		alert("За заданный период зарплата не расчитана!");
		tblName = tblOldName;
		CloseWindow();
		return false;	
	}
	with(list)
	{
		qrySet("Fields","s.*,ls.Ftxt as Ftxt_ls,ls.Fis6,ls.Fis12"
				,"From","^"+tblName+" as s left join ^lic_fld as ls on s.Flsfid=ls.Fid"
				,"Where",sWhere
				,"Order","ls.ffld_num,s.Fls_kat,s.Foffset"//нумерация из за сдвигов в LIC_FLD может отличаться от svnr, поэтому сортируем по номеру из LIC_FLD
				,"Alias","s" 	
			);
	 	//subTie("lic_fld", "ls", "lic_fid", "flsfid");
	 	subTie("work_pers", "wp", "fwid", "fwid_wp");
	}
}

function listMake()
{
	//чтоб не перестраивать список сотрудников при каждом вызове this.reLoad()
	if(isFirstMakeList)
	{
		buildTree();
		isFirstMakeList = false;
	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		onePageMode(false);

		defCond("=(String(^Fis6)[0]=='н'||String(^Fis6)[0]=='у'||String(^Fis6)[0]=='п'||String(^Fis6)[0]=='з'||String(^Fis6)[0]=='б')", "ITOG_ALL");
		color(26, "ITOG_ALL");
		
		defCond("=(String(^Fis6)[0]=='ф')", "ITOG_GET");
		bold("ITOG_GET");
		color(25, "ITOG_GET");
		
		defCond("=^Fis6=='s' && !isLastLS(^Fvp,^Fmn,^Fsum,^Fdnkl)", "SPRAV_LS");
		color(2, "SPRAV_LS");
		
		defCond("=isLastLS(^Fvp,^Fmn,^Fsum,^Fdnkl) || ^Fis12=='1' || ^Fis12=='2' || ^Fis12=='3' || ^Fis12=='4' || ^Fis12=='5' || ^Fis12=='6' || ^Fis12=='7'", "PAST_LS");
		color(12, "PAST_LS");
		
		if(getPar("LS_KAT"))
		{
			var snapKat = getSnap("select MIN(Fcod) from ^listcl where Fcl="+getPar("LS_KAT"));
			if(snapKat)
				var minKat = snapKat[0];
			else
				var minKat = 0;
			defCond("=^Fls_kat>"+minKat+" && !(String(^Fis6)[0]=='н'||String(^Fis6)[0]=='у'||String(^Fis6)[0]=='п'||String(^Fis6)[0]=='з'||String(^Fis6)[0]=='б') && !(String(^Fis6)[0]=='ф') && !(isLastLS(^Fvp,^Fmn,^Fsum,^Fdnkl) || ^Fis12=='1' || ^Fis12=='2' || ^Fis12=='3' || ^Fis12=='4')", "LS_KAT");
			color(2, "LS_KAT");
		}

		with(page())
		{
			cell("ftxt_ls", "Поле\nособистого рахунку|Поле\nлицевого счета", 13);
			cell("fsum", "Сума|Сумма", 6, "", DP_FORMAT_SUM);
			cell("fproc", "%", 4, "", DP_FORMAT_SUM);
			cell("Fpr", "Збiр|Сбор", 5);
			cell("fday", "днів|дней", 5, "", "%3");
			cell("fchas", "годин|часов", 5, "", "%3");
			cell("=(^Fis_day==2?'л':'')", "", 2);
			with (group("Сплачено|Выплачено"))
			{
				var str = "=(^Fvp==1? format('mm/yy', ^Fmn):"+
							"(^Fvp==2? format('mm/yy',HDAT.value): ''))";
				cell(str, "в", 5, "r");
				str = "=(^Fvp==1?format('mm/yy', HDAT.value):"+
							"(^Fvp==2? format('mm/yy', ^Fmn): ''))";
				cell(str, "за", 5, "r");
				str = "=((^Fvid_prk!=0) && (^Fid_prk!=0))?'+':''";
				cell(str, "", 2);
			}
			cell("fshpz", "ШВВ|ШПЗ", 4);
			if(getPar("PRIK_IZD"))
				cell("fkodizd", "Код\nвиробу|Код\nизделия", 4);
			cell("wp.Fid", "Код ШР|Код ШР",6);
			cell("Fvid_prk", "Код\nПриказу|Код\nПриказа", 6);
			cell("fdnkl", "КДЛ/РДВ|КДБ/РДО", 5, "", "%3");			
			if(get_cnst("calc_prop", HDAT.value))
			{
				cell("fday_prop", "Дн.прор.|Дн.проп.", 4);
				cell("fchas_prop", "Год.прор.|Час.проп.", 4);
			}
			cell("FTABN_ID", "FTABN_ID", 10, "", "", 1, "CLS.CL3", "FTABN_ID");
		}
		build(); 
	}
}

function listMenuInit(oGrid)
{
	with(oGrid)
	{
		AddMenuItem("SHOW_LICFLD","Показати в формуванні переліку полів ОР|Показать в формировании перечня полей ЛС");
		AddMenuItem("FIND_PRIK","Знайти наказ|Найти приказ");
		AddMenuItem("FIND_ALLPRIK","Знайти всі накази даного виду|Найти все приказы данного вида");
		AddMenuItem("+++","Додати наказ готової суми|Добавить приказ готовой суммы");
		AddMenuItem("ADD_SUM_3",ru("Готовая сумма","Готова сума"));
		AddMenuItem("ADD_SUM_2",ru("Готовая сумма прошлых периодов","Готова сума минулих періодів"));
		AddMenuItem("ADD_SUM_1",ru("Готовая сумма будущих периодов","Готова сума майбутніх періодів"));
		AddMenuItem("---","");
		AddMenuItem("+++","Вилучити наказ готової суми|Удалить приказ готовой суммы");
		AddMenuItem("DEL_SUM_3",ru("Готовая сумма","Готова сума"));
		AddMenuItem("DEL_SUM_2",ru("Готовая сумма прошлых периодов","Готова сума минулих періодів"));
		AddMenuItem("DEL_SUM_1",ru("Готовая сумма будущих периодов","Готова сума майбутніх періодів"));
		AddMenuItem("---","");
		//AddMenuItem("RASCHYR", "Розрах.за рiк по таб.N|Расчет за год по таб.N");
		//AddMenuItem("PRNLIST","Друк|Печать");
	}
}

function filterMode(mode)
{
	if(mode.indexOf("DEL")!=-1 && mode.indexOf("DEL_SUM_")==-1)
		return false;
	return true;
}

function listMenuRun(ID, oGrid)
{
	switch(ID)
	{
		case "NEXT_DAT":
			next();
			break;
		
		case "PREV_DAT":
			prev();
			break;
		
		case "RASCHYR":
			var obj = new Object();
			obj.mode = "CALC";
			obj.tabn = tabn;
			obj.year = oYear;
			obj.oklad = oklad;
			obj.fio = FIO;
			obj.dolname = dolName;
			showWindow("r_svzpall.js",SW_NOMODAL,obj,"");
		break;

		case "PRNLIST":
			include("objects\\DpTVars.js");
			var tv = new DpTVars("CRDV");
			var h = new Object();
			h.FDATE = new Date(HDAT.value);
			h.FYEAR = oYear;
			h.FMONTH = oMonth;
			h.FTABN = tabn;
			h.FNAM_LEV = FIO;	//ФИО
			h.FOKLAD = oklad;	//оклад
			h.FNAM_LEVS = dolName;	//должность

			tv.setHTbl(h);
			tv.setRTbl(this.tbl);
			tv.print();
		break;
		case "SHOW_LICFLD":
			var par = new Object();
			t = OpenTable("select * from ^"+tblName+" where fwid "+DataSource().sqlSelected(true));
			var flsfids = new Array();
			for(; !t.IsEOF(); t.MoveNext())
				flsfids[t.bookmark-1] = t.getValue("Flsfid");
			par.where = " Fid in ("+flsfids+")";
			showWindow("r_licfld.js", SW_NOMODAL, par);
			t.close();
		break;
		case "FIND_PRIK":
		case "FIND_ALLPRIK":
			var mFnop = 0;
			var mFdoc;
			if(ID=="FIND_PRIK" && !this.tbl.getValue("Fid_prk"))
			{
				WAIT(ru("Не определен идентификатор записи приказа!","Не визначений ідентифікатор запису наказу!"));
				return false;
			}
			var par = new Object();
			var vid = 0;
			var snap = getSnap("select Fvid_prk from ^prk_all where Fwid="+this.tbl.getValue("Fid_prk"));
			if(isEmpty(snap))
			{
				//проверяем также документы ведомостей VD
				var sn = getSnap("select Fnop, Fdoc from ^hvd where Fwid="+this.tbl.getValue("Fid_prk"));
				if(!isEmpty(sn) && !isEmpty(sn[0]))
				{
					mFnop = sn[0];
					mFdoc = sn[1];
				}

				//проверяем также реализацию в счет зарплаты
				strSQL = " SELECT FNOP, FDOC FROM ^SCH_ZAG WHERE FWID = "+this.tbl.getValue("Fid_prk")
				sn = getSnap(strSQL);
				if(!isEmpty(sn) && !isEmpty(sn[0]))
				{
					mFnop = sn[0];
					mFdoc = sn[1];
				}

				if (mFnop == 0)
				{
					alert(ru("Невозможно найти приказ или документ с идентификатором ",
							 "Неможливо знайти наказ чи документ з ідентифікатором ")+this.tbl.getValue("Fid_prk"))
					return false;
				}
			}
			else
			{
				vid = snap[0];
			}

			if(mFnop != 0)
			{
				if(ID=="FIND_PRIK")
				{
					include("doc/DpDocPtn.js");
					FindDocument(mFdoc, mFnop, this.tbl.getValue("Fid_prk"));
				}
				else
				{
					var objPar = new Object();
					objPar.doc = mFdoc;
					objPar.nop = mFnop;
					objPar.bdat = firstDayMonth(HDAT.value);
					objPar.edat = lastDayMonth(HDAT.value);
					showWindow("l_docekz.xml", SW_NOMODAL, objPar, "");
				}
			}
			else
			{
				var t = OpenTable("select * from ^cl_prik where Fvid="+sqlTo(vid));
				if(!t.rowCount)
				{
					WAIT(ru("Невозможно определить приказ!","Неможливо визначити наказ!"));
					return false;
				}

				if(ID=="FIND_PRIK")
				{
					par.fid_prk = this.tbl.getValue("Fid_prk");
					par.title = ru("Приказ на ","Наказ на ")+getSmallFIO(getTxtFromID(this.tbl.getValue("Ftabn_id")))+" - "+par.fnazv;
				}

				par.fnazv = t.getValue("Fnazv");
				par.is_clnd = toScrObj(t.getValue("Fis_clnd"));
				par.fvid = Number(t.getValue("fvid"));
				nzvproc  = t.getValue("fproc");
				par.fz2 = t.getValue("fz2");
				par.fz6 = t.getValue("fz6");
				par.priklbl = par.edit = t.getValue("fedit").toUpperCase();
				par.GLOBAL_TABLE = "^PRK_ALL";
				par.dat1 = firstDayMonth(HDAT.value);
				par.dat2 = lastDayMonth(HDAT.value);
				par.notLoad = true;
				t.close(5652);
				t = null;

				var xmlPrik = new DpXMLDOMDocument();
				if (xmlPrik.load(rootDirectory() + "prik/" + par.edit + "/prik.xml", false))
				{
					var xmlEl = xmlPrik.getDocumentElement();
					loadSettingToObj(par, xmlEl, new Array("list"));
					if (!spLoad(par, "list"))
						showWindow("l_prkekz.xml", SW_NOMODAL, par);
				}
				else
					showWindow("l_prkekz.xml", SW_NOMODAL, par);
			}
		break;
		case "ADD_SUM_3":
		case "ADD_SUM_2":
		case "ADD_SUM_1":
			var fedit = ID.substr(3);
			var snap = getSnap("select MIN(Fvid) from ^cl_prik where UPPER(Fedit)="+sqlTo(fedit));
			if(!snap || !snap[0])
			{
				alert(ru("Не найден приказ готовой суммы!","Не знайден наказ готової суми!"));
				return false;
			}
			fvid_prk = snap[0];
			bdat = firstDayMonth(HDAT.value);
			edat = lastDayMonth(HDAT.value);
			addPrik(fedit,fvid_prk,this.tbl.getValue("Ftabn_id"),this.tbl.getValue("Fwid_wp"),bdat,edat,this.tbl.getValue("Flsfid"),true);
		break;
		case "DEL_SUM_3":
		case "DEL_SUM_2":
		case "DEL_SUM_1":
			var fedit = ID.substr(3);
			var snap = getSnap("select MIN(Fvid) from ^cl_prik where UPPER(Fedit)="+sqlTo(fedit));
			if(!snap || !snap[0])
			{
				alert(ru("Не найден приказ готовой суммы!","Не знайден наказ готової суми!"));
				return false;
			}
			fvid_prk = snap[0];
			bdat = firstDayMonth(HDAT.value);
			edat = lastDayMonth(HDAT.value);
			delPrkSum(fedit,fvid_prk,list.tbl.getValue("Ftabn_id"),list.tbl.getValue("Fwid_wp"),bdat,edat,list.tbl.getValue("Flsfid"));
		break;
	}
}

function loadTreeMenu(oTree)
{	
	oTree.AddMenuItem("NEXT_DAT", "Наступний місяць|Следующий месяц");
	oTree.AddMenuItem("PREV_DAT", "Попередній місяць|Предыдущий месяц");
	var snap = getSnap("select fwid from ^"+tblName+" where "
		+" not exists(select fwid from ^work_pers where Fwid_cl=^"+tblName+".Ftabn_id) ");
	if(snap!=null)
		oTree.AddMenuItem("CLEAN", "Очистити відсутніх в ШР|Очистить отсутствующих в ШР");
	if(!isNotUseView)
	{
		if(Number(ReadParEx("MINLS"))==1)
			oTree.AddMenuItem("MAXIMIZE", "Відображати усі записи|Отображать все записи");
		else
			oTree.AddMenuItem("MINIMIZE", "Відображати тільки коректні записи|Отображать только коректные записи");
	}
	if(Number(ReadParEx("FULL_FIO"))==1)
		oTree.AddMenuItem("SMALL_FIO", "Відображати ПІБ скорочено|Отображать ФИО сокращенно");
	else
		oTree.AddMenuItem("FULL_FIO", "Відображати ПІБ повністю|Отображать ФИО полностью");
	oTree.AddMenuItem("", "");
	oTree.AddMenuItem("FULLINFO", "Повна інформація по співробітнику|Полная информация по сотруднику");
}

function runTreeMenu(sID)
{
	switch(String(sID))
	{
		case "NEXT_DAT":
			next();
			break;
		
		case "PREV_DAT":
			prev();
			break;
		
		case "CLEAN":
			if (confirm(ru("Будут удалены данные из свода за текущий месяц!\nПродолжить?",
							"Будуть вилучені дані із зведення за поточний місяць!\nПродовжити?")))
			{
				ExecuteSQL("DELETE FROM ^"+tblName+" WHERE NOT EXISTS(SELECT Fwid FROM "
							+" ^work_pers WHERE Fwid_cl=^"+tblName+".Ftabn_id)");
				buildTree();
			}
			break;
		case "MINIMIZE":
			WriteParEx("MINLS",1)
			buildTree();
			break;
		case "MAXIMIZE":
			WriteParEx("MINLS",0)
			buildTree();
			break;
		case "FULL_FIO":
			WriteParEx("FULL_FIO",1);
			buildTree();
			break;
		case "SMALL_FIO":
			WriteParEx("FULL_FIO",0);
			buildTree();
			break;
		case "DOUBLECLICK":
		case "FULLINFO":
			list.mnuHandler("FULLINFO0");
			break;		
	}	
}

function buildTree()
{
	if(typeof(Tree) == "undefined") 
		return;
	Tree.removeAll();
	tblName ="svzp"+(calcNum>0?calcNum:"") + getDateTag(HDAT.value);
	//	showObject(objAsk.dat1,SW_MODAL);
	dat1 = toScriptDate(firstDayMonth(HDAT.value));
	dat2 = toScriptDate(lastDayMonth(HDAT.value));
      
	var sSql;
	//при отборе людей за период будем искать с минимальным Fwid-ом, 
	//т.к. человек может быть уволен и новый Fwid не попадет в SVZP (оклад будет расчитан на старый Fwid) 
	
	DropTable("TABN_BUF");
	ExecuteSQL("select DISTINCT Ftabn_id into TABN_BUF from ^"+tblName);
	if(Number(ReadParEx("MINLS"))==1 || isNotUseView)//если есть параметр, то не выводим отсутствующих
	{
		DropTable("tmp_work_pers");
		ExecuteSQL("SELECT * INTO tmp_work_pers FROM ^work_pers");
		sSql = "SELECT rel.fcod, cl.ftxt as ftxt, wp.fwid as fid_wp, s.ftabn_id, wp.Ftabnorg, cl_2.ftxt as fdol "
      			+ " FROM TABN_BUF s "
				+ " LEFT join ^work_pers as wp on s.Ftabn_id=wp.Fwid_cl "
				+ " LEFT join ^stru_dol as dol on wp.fwid_dol=dol.fwid "
      			+ " LEFT join ^clrelclcl as rel_2 on dol.fcod=rel_2.fcod and rel_2.fcl=" + getPar("CODDOL")
      			+ " LEFT join ^cl as cl_2 on cl_2.fwid=rel_2.fwid_cl"
      			+ " LEFT join ^clrelclcl as rel on s.ftabn_id=rel.fwid_cl "
      			+ " LEFT join ^cl as cl on cl.fwid=rel.fwid_cl"
		sSql += " WHERE "
				+" ((wp.Fbdat<="+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ")"
				+" AND wp.Fwid=(SELECT MIN(Fwid) FROM tmp_work_pers AS wp2 WHERE wp2.Fwid_cl=wp.Fwid_cl AND wp2.Fbdat<="+sqlTo(dat2)+" AND wp2.Fedat>="+sqlTo(dat1)+"))"
				+" OR (WP.FWID IS NULL) "
		if(getPar("TABNORG"))
			sSql += " ORDER BY wp.ftabnorg ";
		else
			sSql += " ORDER BY rel.fcod ";
	}
	else
	{
		sSql = "SELECT DISTINCT s.Ftabn_id, r.Fcod, cl.Ftxt as Ftxt, cld.Ftxt as Fdol, f.Ftabnorg, f.fwid as fid_wp "
			//джоинить с clrelclcl все-равно прийдётся чтобы выводить и те табельные номера, которых уже нет в ШР
			+" FROM TABN_BUF as s "
				+" INNER JOIN ^clrelclcl as r ON s.Ftabn_id=r.Fwid_cl "
				+" LEFT JOIN ^work_pers AS F ON S.FTABN_ID=F.FWID_CL "
				+" LEFT JOIN ^stru_dol d on f.fwid_dol = d.fwid "
				+" LEFT JOIN ^listcl cl on s.ftabn_id = cl.fwid "
				+" LEFT JOIN ^listcl cld on d.fwid_cl = cld.fwid "
			+" WHERE f.Fwid=(SELECT MIN(Fwid) FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl AND wp.Fbdat<="
							+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ") "
						+" OR (NOT EXISTS(SELECT Fwid FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl AND wp.Fbdat<="
							+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ") "
							+" AND f.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl ))"
						+" OR (F.FWID IS NULL) "
			//+" ORDER BY r.Fcod ";
		if(getPar("TABNORG"))
			sSql += " ORDER BY f.ftabnorg ";
		else
			sSql += " ORDER BY r.fcod ";
	}
	
	Tree.Lock();
	tblPers = OpenTable(sSql);
	tblPers.MoveFirst();
	while(!tblPers.isEOF())
	{
		var cod = String(tblPers.getValue("ftabn_id"));
		var txt = ru("ОТСУТСТВУЕТ В ШР!!!","ВІДСУТНІЙ В ШР!!!");
		if(tblPers.getValue("ftxt")==null && !isNotUseView)
		{
			var snap = getSnap("select fwid from ^full_pers where Fcodpers="+tblPers.getValue("fcod"))
			if(snap != null)
				txt = ru("ДАННЫЕ В ШР НЕ СООТВЕТСТВУЮТ МЕСЯЦУ РАСЧЕТА!!!","ДАННІ В ШР НЕ ВІДПОВІДАЮТЬ МІСЯЦЮ РОЗРАХУНКА!!!");
		}
		var tabnn = tblPers.getValue("fcod")==tblPers.getValue("ftabnorg") || !getPar("TABNORG") || Number(tblPers.getValue("ftabnorg"))==0?tblPers.getValue("fcod"):tblPers.getValue("ftabnorg")+"("+tblPers.getValue("fcod")+")"
		var sFIO = Number(ReadParEx("FULL_FIO"))==1?String(tblPers.getValue("ftxt")):getSmallFIO(String(tblPers.getValue("ftxt")));
		var itemCap = sFIO + "(" + (tblPers.getValue("fdol")!=null ? tblPers.getValue("fdol"):ru("отсутствует должность","відсутня посада"))+")";
		itemCap += tblPers.getValue("fid_wp") == null ? (" "+txt) : "";
		Tree.addItem("0",cod, tabnn+"." + itemCap, TREE_ITEM);
	   	tblPers.moveNext();
	}
	
	if (strSelectID != 0)
		Tree.setSelected(strSelectID);
	else
	{
		tblPers.MoveFirst();
		if(tblPers.rowCount>0)
			strSelectID = String(tblPers.getValue("Ftabn_id"));
		Tree.setSelected(strSelectID);
		list.subSrc();
	}
	Tree.Unlock();
}

function isLastLS(Fvp,Fmn,Fsum,Fdnkl)
{
	if((Fvp==1 && differ(new Date(Fmn),new Date(HDAT.value))>=0)){
		return true;
	}else{
		 if (Fsum==0 && Fdnkl!=0){
				return true;			 
		 }else{		
			 return false;
		 }	 
	}	
}

include("sys\\DpList.js");