include("Objects\\DpGetDat.js");
include("Objects\\DpJRegistrator.js");
include("doc\\DpDoc.js");

var tbl = "AKT_DOG";
var dat1,dat2,forg,flpu;

/*function listAsk()
{
	return new DpGetDat(new Array("r","o0"));
}*/

function listLoad()
{
	//this.title = "Акт сверки";
	this.xmlGridFile = "l_dog_aktgaz.xml";
	this.printLabel = "USPTDA";
	var form = createForm(UR("Введіть дані для відбору інформації|Введите данные для отбора информации"));
	var ctrldat1 = form.addObj("dat1","date",UR("Дата початку|Дата начала"));
	var ctrldat2 = form.addObj("dat2","date",UR("Дата кінця|Дата конца"));
	var umg = form.addObj("umg","combo",UR("В розрізі по УМГ|В разрезе по УМГ"));
	umg.addItem(0, UR("Усі УМГ|Все УМГ"));
	umg.addItem(360, UR("360 Первомайськ|360 Первомайск"));
	umg.addItem(380, UR("380 Кременчук|380 Кременчуг"));
	umg.addItem(400, UR("400 Золотоноша|400 Золотоноша"));
	umg.addItem(420, UR("420 Олександрівка|420 Александровка"));
	umg.addItem(440, UR("440 Гайсин|440 Гайсин"));
	umg.addItem(460, UR("460 Бар|460 Бар"));
	umg.setValue(0);
	var contr = form.addContragent(true,0,true);
	form.show();
	if(form.escape == true)
		return false;
	dat1 = new Date(form.dat1);
	dat2 = new Date(form.dat2);
	forg = contr.getCod();
	flpu = form.umg;
}

function listTitle()
{
	return UR("Акт звіряння з "+ StrDat(dat1,"DMY")  + " по " + StrDat(dat2,"DMY"),
				"Акт сверки с "+ StrDat(dat1,"DMY")  + " по " + StrDat(dat2,"DMY"))
}

function listSrc()
{
	this.qrySet("From",tbl
				,"Order","forg,ftt,fdat"
				,"WhereArr",new Array("ftt=0")
				,"WhereArrName",new Array("Свернуть")
				,"WhereArrI",-1
				);
	this.subTie("CLRELCLCL","CLREL","CLCOD","="+getPar("CODPLAT")+",FORG");
	this.subTie("CL","x_cl","FWID","CLREL.FWID_CL");
	this.subTie("RAS_SCH","pv","FWID","FWID_DOC");
	this.extTieEx("xorg", "CLREL.fwid_cl", "CL", "0")	
}

function listMake()
{
	var oTD = new DpDoc("TD",0);
	var jID = oTD.getPar("__jrn");
	var tbl_j;
	var journal;
	var oReg; 
	var j_fwid = 0;
	if ((jID != "0") && (jID != null) && (jID != "undefined") && (jID != ""))
	{
		oReg = new DpJRegistrator(null,null);
		journal = oReg.listJournals()[jID];
		tbl_j=journal.getFullTableName();
	}
	else
	{
		alert("Не задан журнал регистрации договоров");
		CloseWindow();
		return true;
	}
	
	
	DropTable(tbl);
	
	ExecuteSQL("CREATE TABLE " + tbl + "("
					+ "FORG " + SqlType("LONG") + " DEFAULT 0, "
					+ " FDOC " + SqlType("TEXT") + ","
					+ " FWID_DOG " + SqlType("LONG") + ","
					+ " FDOG " + SqlType("TEXT") + ","
					+ " FDOG_DAT " + SqlType("DATE") + ","
					+ " FNOP " + SqlType("LONG") + ","
					+ " FDAT " + SqlType("DATE") + ","
					+ " FDOC_NUM " + SqlType("TEXT") + ","
					+ " FWID_DOC " + SqlType("LONG") + " DEFAULT 0, "
					+ " FDBN " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ " FCRN " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ " FDBO " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ " FCRO " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ " FKOL " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ " FWID " + SqlType("COUNTER") + ", "
					+ " FTT " + SqlType("SHORT")
					+ ")"
				);
	
	var addStrSQL1="";
	var addStrSQL2="";
	if(flpu!=0)
	{
		addStrSQL1 = " LEFT JOIN ^contract AS c ON j.Fdog=c.Fwid INNER JOIN ^htd AS h ON c.Fwid=h.Fid_dog ";
		addStrSQL2 = " AND h.Flpu="+sqlTo(flpu);
	}
	if (forg != 0)
	{
			strSQL = "INSERT INTO "+tbl + " (ftt,forg,fdoc,fdat,fnop,fdoc_num,fwid_doc,fdbo,fcro,fkol,fwid_dog)" 
					+ " SELECT 1 as ftt, j.forg, j.hdoc as fdoc, j.fdat, j.hnop as fnop, j.fdoc_num, j.hid_doc as fwid_doc, j.fsum_vyk as fdbo, j.fsum_opl as fcro,j.fkol,j.fdog"
					+ " FROM " + tbl_j + " AS j " + addStrSQL1
					+ " WHERE j.forg=" + sqlTo(forg) + " AND j.fdat>=" + sqlTo(dat1) + " AND j.fdat<=" + sqlTo(dat2) + addStrSQL2;
			ExecuteSQL(strSQL);
				
			
			strSQL = "INSERT INTO " + tbl + "(ftt,fdbo,fcro,fkol,forg,fwid_dog)"
					+ " SELECT 0 as ftt, SUM(j.fsum_vyk) as fdbo, "
						+ "SUM(j.fsum_opl) as fcrn,SUM(j.fkol) as fkol ,j.forg, max(j.fdog)"
					+ " FROM " + tbl_j + " AS j " + addStrSQL1
					+ " WHERE j.forg=" + sqlTo(forg) + " AND j.fdat>=" + sqlTo(dat1) 
						+ " AND j.fdat<=" + sqlTo(dat2) + addStrSQL2
					+ " GROUP BY j.Forg";
			
			ExecuteSQL(strSQL);
			
						
						
			strSQL = "UPDATE " + tbl +  " as a"
					+ " set a.FDBN=(select SUM(b.fsum_vyk) from " + tbl_j + " as b" 
					+" where b.forg=" + sqlTo(forg) + " AND b.fdat<" + sqlTo(dat1) +")"
					+ " WHERE a.ftt=0";
			
			ExecuteSQL(strSQL);
			
			strSQL = "UPDATE " + tbl +  " as a"
					+ " set a.FCRN=(select SUM(b.fsum_opl) from " + tbl_j + " as b" 
					+" where b.forg=" + sqlTo(forg) + " AND b.fdat<" + sqlTo(dat1) +")"
					+ " WHERE a.ftt=0";
			
			ExecuteSQL(strSQL);
			
			
	}
	else
	{
			strSQL = "INSERT INTO "+tbl + " (ftt,forg,fdoc,fdat,fnop,fdoc_num,fwid_doc,fdbo,fcro,fkol,fwid_dog)" 
						+ " SELECT 1 as ftt, j.forg, j.hdoc as fdoc, j.fdat, j.hnop as fnop, j.fdoc_num, j.hid_doc as fwid_doc, j.fsum_vyk as fdbo, j.fsum_opl as fcro,j.fkol,j.fdog "
						+ " FROM " + tbl_j + " AS j " + addStrSQL1
						+ " WHERE j.fdat>=" + sqlTo(dat1) + " AND j.fdat<=" + sqlTo(dat2) + addStrSQL2;
				ExecuteSQL(strSQL);
				
			strSQL = "INSERT INTO " + tbl + "(ftt,fdbo,fcro,forg,fkol,fwid_dog)"
						+ " SELECT 0 as ftt, SUM(j.fsum_vyk) as fdbo,"
						+ "SUM(j.fsum_opl) as fcro, j.forg, SUM(j.fkol) as fkol, max(j.fdog)"
						+ " FROM " + tbl_j + " AS j " + addStrSQL1
						+ " WHERE j.fdat>=" + sqlTo(dat1) + " AND j.fdat<=" + sqlTo(dat2) + addStrSQL2
						+ " GROUP BY j.FORG";
				
			ExecuteSQL(strSQL);
				
							
				strSQL = "UPDATE " + tbl +  " as a"
						+ " set a.FDBN=(select SUM(b.fsum_vyk) from " + tbl_j + " as b" 
						+" where b.fdat<" + sqlTo(dat1) +" and b.FORG=a.FORG)"
						+ " WHERE a.ftt=0";
				
				ExecuteSQL(strSQL);
				
							
				strSQL = "UPDATE " + tbl +  " as a"
						+ " set a.FCRN=(select SUM(b.fsum_opl) from " + tbl_j + " as b" 
						+" where  b.fdat<" + sqlTo(dat1) +" and b.FORG=a.FORG)"
						+ " WHERE a.ftt=0";
				
				ExecuteSQL(strSQL);
	}
	
	strSQL = "update " + tbl + " as a set a.fdog=" 
			+ "(select c.fdog_num from ^contract as c where c.fwid=a.fwid_dog) where a.ftt=0";
	ExecuteSQL(strSQL);
	
	strSQL = "update " + tbl + " as a set a.fdog_dat=" 
			+ "(select c.fdoc_dat from ^contract as c where c.fwid=a.fwid_dog) where a.ftt=0";
	ExecuteSQL(strSQL);
}

function getTblR()
{
		
	var dt2 = new Date(dat2.getYear()+1900,dat2.getMonth(),dat2.getDate()+1);
	if (list.dataSrc.getSelectedCount() > 0)
	{
		var selIDs = list.dataSrc.getSelectedIDs();
		//var tmpTbl = getTmpTableName();
		
		DropTable("ptdk_as2");
		
		ExecuteSQL("CREATE TABLE ptdk_as2" 
			   + "("
			   + " DAT1 " + SqlType("DATE")
			   + " ,DAT2 " + SqlType("DATE")
			   + " ,DAT3 " + SqlType("DATE")
			   + " ,ORG " + SqlType("INT")
			   + " ,DOG " + SqlType("TEXT",20)
			   + " ,DOG_DAT " + SqlType("DATE")
			   + " ," + list.tbl.getIdFld() + SqlType("LONG")
			   + ")");
		
		
		
		//ExecuteSQL("CREATE TABLE " + tmpTbl + "(" + list.tbl.getIdFld() + " " + SqlType("LONG") + ")");
		for (var nid = 0; nid < selIDs.length; nid++)
		{
			strSQL = "INSERT INTO ptdk_as2 SELECT "
				+  sqlTo(dat1) + " as DAT1," + sqlTo(dat2) + " as DAT2,"
				+ sqlTo(dt2)+" as DAT3,FORG as ORG, fdog as dog"
				+ ",FDOG_DAT as DOG_DAT, "+ sqlTo(selIDs[nid]) + " as " + list.tbl.getIdFld() + " from " + tbl
				+ " where fwid = " + sqlTo(selIDs[nid]);
			ExecuteSQL(strSQL);
			/*sSQL = "INSERT INTO " + tmpTbl + " VALUES(" + sqlTo(selIDs[nid]) + ")";
			ExecuteSQL(sSQL);*/
		}
		
		var prtTbl = OpenTable("s","ptdk_as2");
		return prtTbl;
	}
	else
		return list.tbl;
	
}

function listMenuInit()
{
	if (this.tbl.isEmpty())
		return;
	this.dataSrc.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
	this.dataSrc.AddMenuItem("VIEW","Перегляд документу|Просмотр документа");
}

function listMenuRun(sID)
{
	if (sID == "FINDDOC")
	{
		var doc = String(this.tbl.getValue("FDOC"));
		var nop = this.tbl.getValue("FNOP");
		var fid_doc = this.tbl.getValue("FWID_DOC");
		include("doc/DpDocPtn.js");
		FindDocument(doc,nop,fid_doc);
		return;
	}
	if (sID == "EDIT")
	{
		include("doc/DpDoc.js");
		var doc = String(this.tbl.getValue("FDOC"));
		var nop = this.tbl.getValue("FNOP");
		var fid_doc = this.tbl.getValue("FWID_DOC");
		
		var oDoc = new DpDoc(doc,nop,this);
		oDoc.edit("VIEW",fid_doc);
	}
}

function filterMode(sID)
{
	if (sID == "DEL")
		return false;
	return true;
}

include ("sys\\DpList.js");