//Редактирование результатов лицевых счетов
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");

var szTag, gd, fidnar;
var dpGridEdit = null;
var dpShifPZ = null;

function listLoad()
{
	this.title = "Склад виконавцiв |Состав исплнителей";
	//this.editTask = "e_sotktu.xml";	
	this.xmlGridFile = "l_ktuisp.xml";
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("FSHPZ", startEdit_fshpz, save_fshpz);
	dpGridEdit.addValidField("FKODIZD", startEdit_kizd, save_kizd);	
}

function listSrc()
{
    fidnar = extPar.priklbl;	
	sOrder = "c.fcod";
	var sWhere = " p.fvid_prk = " + sqlTo(extPar.fvid) + " AND p.fin_table='KTU_ISP'"  
		+ " AND p.fid=" + sqlTo(fidnar);

	this.qrySet("Fields", "p.*, d.Fsum_tar, d.Fsum_sd, d.Fktu, d.Fvsego_ch, d.Fproc_prem, c.Fcod", 
				"From", "^PRK_ALL AS p INNER JOIN ^KTU_ISP AS d ON p.Fid=d.Fid and p.Fwid_wp=d.Fwid_wp and p.Fwid=d.Fwid INNER JOIN ^clrelclcl AS c ON p.Ftabn_id=c.Fwid_cl", 
				"Where", sWhere,
				"Order", sOrder);

	this.subTie("cl", "cl", "fwid", "ftabn_id");
	this.qrySet("Alias", "p");
}


function listMenuInit()
{
	this.dataSrc.AddMenuItem("RCAD", ru("Добавить сотрудника в наряд","Добавити спiвробiтника до наряду"));
	this.dataSrc.AddMenuItem("MSPR", ru("Ред.КТУ для отм.зап.","Ред.КТУ ЗП для вiдм.зап."));
	this.dataSrc.AddMenuItem("MSPP", ru("Ред.% прем. для отм.зап.","Ред.% прем. для вiдм.зап."));
	this.dataSrc.AddMenuItem("RNAR1", "Розрахунок наряду (час з табеля)|Расчет наряда (время из табеля)");
	this.dataSrc.AddMenuItem("TMTAB", "Перенести час з табеля|Перенести время из табеля");
	this.dataSrc.AddMenuItem("EDTM", "Редагування відпр.часу для вiдм.зап.|Редактирование отраб.времени для отм.зап.");
	this.dataSrc.AddMenuItem("RNAR2", "Розрахунок наряду - час з нар.|Расчет наряда - время из нар.");
	//this.dataSrc.AddMenuItem("RCED", ru("Редактировать сотрудника по наряду","Редагувати спiвробiтника по наряду"));	
	//this.dataSrc.AddMenuItem("ISSHPL","Перевірка ШВЗ|Проверка ШПЗ");	
}

function listMenuRun(ID)
{
	var opar = new Object();
	opar.fvid = extPar.fvid
	opar.mode = "ADD"	
	opar.fid   = fidnar
	var gs = getSnap("select Fbdat, Fdat_zakr from ^NAR_KTU where Fvid_prk="+sqlTo(extPar.fvid)+" and Fwid="+sqlTo(fidnar))
	if (gs!=null){
		opar.fbdat = new Date(gs[0]);
		opar.fedat = new Date(gs[1]);		
	}else{
		opar.fbdat = d00obj;
		opar.fedat = d00obj;		
	}	
	switch (ID)
	{
    	case "RCAD":
			showWindow("e_tarisp.xml", SW_MODAL , opar);
			this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
			break;    	        
    	case "MSPR":
   		    var codm = 0;
   		    codm = input("Введите КТУ", "Состав исполнителей по наряду", codm, 4,2);
   		    if (codm){
   				var t2Doc = OpenTable("s", "SELECT p.* FROM ^PRK_ALL as p WHERE " 
   	         			+ this.dataSrc.sqlSelected());
   				while(!t2Doc.IsEOF())
   				{
   	   		    	ExecuteSQL("update ^KTU_ISP set Fktu="+sqlTo(codm)+" where (Fid="+sqlTo(fidnar)+") and Fwid="+sqlTo(t2Doc.getValue("Fwid")))
   	   				t2Doc.MoveNext();
   				}       
   				t2Doc.close();    
   		    }	
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
			break;    	        
    	case "MSPP":
   		    var codm = 0;
   		    codm = input("Введите % премии", "Состав исполнителей по наряду", codm, 6,2);
   		    if (codm){
   				var t2Doc = OpenTable("s", "SELECT p.* FROM ^PRK_ALL as p WHERE " 
   	         			+ this.dataSrc.sqlSelected());
   				while(!t2Doc.IsEOF())
   				{
   	   		    	ExecuteSQL("update ^KTU_ISP set Fproc_prem="+sqlTo(codm)+" where (Fid="+sqlTo(fidnar)+") and Fwid="+sqlTo(t2Doc.getValue("Fwid")))
   	   				t2Doc.MoveNext();
   				}       
   				t2Doc.close();    
   		    }	
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
			break;
		case "RNAR1":
			include("r_nar1.js");
			r_nar1(fidnar);
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
		break;
		case "TMTAB":
			include("r_vrtab.js");
			r_vrtab(fidnar);
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
		break;
		case "EDTM":
			var chas = input(ru("Введите отработанные часы","Введіть відпрацьовані години"), "", 0, 3,2);
			if(chas==null)
				return false;
			ExecuteSQL("UPDATE ^KTU_ISP SET Fvsego_ch="+sqlTo(chas)+" WHERE "+DataSource().sqlSelected());
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
		break;
		case "RNAR2":
			include("r_nar2.js");
			r_nar2(fidnar);
		    this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
		break;
	}
   //stdMenuHandler(ID,this.tbl,opar);		
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^KTU_ISP WHERE fid="+sqlTo(fidnar)+" and fwid=" + sqlTo(list.tbl.getValue("Fwid")));
	ExecuteSQL("DELETE FROM ^PRK_ALL WHERE fid="+sqlTo(fidnar)+" and fwid=" + sqlTo(list.tbl.getValue("Fwid")));	
	return false;
}

function gridEdit(modeID)
{
	if(modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fktu    = list.tbl.getValue("Fktu");
	m.Fvsego_ch  = list.tbl.getValue("Fvsego_ch");	
	m.Fproc_prem = list.tbl.getValue("Fproc_prem");
	m.Fsum_tar   = list.tbl.getValue("Fsum_tar");	
	m.Fsum_sd   = list.tbl.getValue("Fsum_sd");	
	m.Fsum  = Number(list.tbl.getValue("Fsum_tar"))+Number(list.tbl.getValue("Fsum_sd"));	
	//m.Fshpz = String(list.tbl.getValue("Fshpz"));
	//if( getPar("PRIK_IZD") ){	
	//	m.Fkodizd = list.tbl.getValue("Fkodizd");
	//}	
	UpdateTable("^ktu_isp", m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));

	var n = new Object();
	n.Fshpz = String(list.tbl.getValue("Fshpz"));
	n.Fsum  = Number(list.tbl.getValue("Fsum_tar"))+Number(list.tbl.getValue("Fsum_sd"));	
	if( getPar("PRIK_IZD") ){	
		n.Fkodizd = list.tbl.getValue("Fkodizd");
	}	
	UpdateTable("^prk_all", n, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function startEdit_fshpz(oCtrl)
{
	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.setFshpz(Number(oCtrl.getValue()));
	dpShifPZ.linkCtrl(oCtrl);
}

function save_fshpz(oCtrl)
{
	if (!dpShifPZ.validCtrl())
		return false;
	return true;
}

function startEdit_kizd(oCtrl)
{
	
		oClIzd = new DpCl("0");
		ctrlIzd = eval(oCtrl);
		oClIzd.linkCtrl(oCtrl);
		if( getPar("PRIK_IZD") && dpShifPZ.getClIzd()>0)
		{
			oClIzd.setClcl(dpShifPZ.getClIzd());
			Enable(ctrlIzd);
			if(oClIzd.getCod()==0 && oClIzd.getClcl() && dpShifPZ.getCodIzd())
				oClIzd.setCod(dpShifPZ.getCodIzd());
		}
		else
		{
			oClIzd.setClcl(0);
			Disable(ctrlIzd);
			oClIzd.setCod(0);		
		}
	
}

function save_kizd(oCtrl)
{
	return true;
}

include("sys/DpList.js")

