//"Завантаження даних в 1ДФ з документу відомість
include("sys\\main.js");
include("sys\\servis.js");
include("servis\\date.js");
include("Objects\\DpGrid.js");
include("Objects\\DpAskEx.js");

var tblOut = getTmpTableName("", true);

function listLoad()
{
	dsSaveFormat(false);
	this.title = "Завантаження даних 1-ДФ з док. відомість(VD)|Загрузка данных в 1ДФ из документа ведомость(VD)";
}

function listAsk()
{	
	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "FBDAT", today.getVarDate());
	oA.add("D", "Дата закінчення|Дата окончания", "FEDAT", today.getVarDate());
	oA.add("CL_LNK", "Папка, з якої брати дані|Папка, из которой брать данные", "FOLD", "VD|210", "VD");
	oA.add("CLCL", "Довідник аналітики, з якого брати інформацію|Справочник аналитики, из которого брать информацию", "CLAN", 241);
	oA.add("NUM", "Ознака доходу для 1-ДФ|Признак дохода для 1-ДФ", "FKOD", 0, 3);
	oA.add("REM", "Суму записати в колонки:|Сумму записать в колонки:", "MREM2");
	oA.add("B", "    Дохiд нарахований|    Доход начисленный", "ISDOHNAR", false);
	oA.add("B", "    Дохiд виплачений|    Доход выплаченный", "ISDOHVYPL", false);
	oA.add("B", "    Податок нарахований|    Налог начисленный", "ISPODNAR", false);
	oA.add("B", "    Податок виплачений|    Налог выплаченный", "ISPODVYPL", false);
	oA.setRel(">=", "FEDAT", "FBDAT");
	oA.setValid("FKOD", FKOD_Valid);
	oA.doAsk();
	
	return oA;
}


function listMake()
{
	var bDat = new Date(list.objAsk.get("FBDAT"));
	var eDat = new Date(list.objAsk.get("FEDAT"));
	var oDoc = list.objAsk.get("FOLD");
	var nKod = list.objAsk.get("FKOD");
	var nCl = list.objAsk.get("CLAN").getCod();
	var isDohNar = list.objAsk.get("ISDOHNAR");
	var isDohVypl = list.objAsk.get("ISDOHVYPL");
	var isPodNar = list.objAsk.get("ISPODNAR");
	var isPodVypl = list.objAsk.get("ISPODVYPL");
	
	strSQL = " SELECT"
				+" SUM(R.FSUM) AS FSUM"
				+", R.FCOD AS FCOD"
			+" INTO "+tblOut
			+" FROM ^RVD R INNER JOIN ^HVD H ON R.FID_DOC = H.FWID"
			+" WHERE 1=1 "
				+" AND H.FDOC_DAT >= "+sqlTo(bDat)
				+" AND H.FDOC_DAT <= "+sqlTo(eDat)
				+" AND H.FDOC = "+sqlTo(oDoc.pFdoc)
				+" AND H.FNOP = "+sqlTo(parseInt(oDoc.pFnop, 10))
			+" GROUP BY"
				+" R.FCOD"
	ExecuteSQL(strSQL);

	//проставляем идент.код
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD COLUMN FOKPO "+sqlType("TEXT", 12));
	strSQL = " UPDATE "+tblOut
			+" SET FOKPO = (SELECT RTRIM(LTRIM(HOMO.FINDNUM))"
						+" FROM ^CLRELCLCL REL INNER JOIN ^CL_HOMO HOMO ON HOMO.FWID_CL = REL.FWID_CL"
						+" WHERE 1=1"
							+" AND "+tblOut+".FCOD = REL.FCOD"
							+" AND REL.FCL = "+sqlTo(nCl)+")"
	ExecuteSQL(strSQL);
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD COLUMN FWID "+sqlType("COUNTER"));
}

function listSrc()
{
	this.qrySet("From", tblOut);
	this.clTie("cl", "="+list.objAsk.get("CLAN").getCod()+", FCOD");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix()
	list.GroupPage(oGrid, oPrefix);            
	with (oGrid)
	{
		with (page("1ДФ"))
		{
			with (group("1ДФ"))
			{
				cell("FCOD", "код", 5);
				cell("CL.FTXT", "ПІБ", 25);
				cell("FSUM", "Сума", 9);
				cell("FOKPO", "ІПН", 10);
			}
		}
	}
	oGrid.build();
}

function listMenuInit(ds)
{
	if(!grid.getTable().IsEmpty())
	{
		ds.AddMenuItem("LDSOTR", "Завантажити відмічені записи в наказ|Загрузить отмеченные записи в приказ");
	}
}

function listMenuRun(szID)
{
	var  t = grid.getTable();
	switch(szID)
	{
		case "LDSOTR":
			var nType = extPar.priklbl.toUpperCase() == "_DF2" ? 1 : 0;
			var nKod = list.objAsk.get("FKOD");
			if (r_imp2prk(new Date(list.objAsk.get("FEDAT")), extPar.fvid, tblOut, nType, nKod))
			{
				alert(ru("Перенос данных завершено.","Перенесення даних закінчено."));
				grid.getTable().requery();
		    	grid.refresh();
				
				//сами закроем окно после переноса данных в приказ
				CloseWindow();
			}
		break;
	}
}

function r_imp2prk(dat, vidprk, tbl, nType, nKod)
{
	include("sys/udfs.js");
	var isPer = false;
	var D1 = firstday(new Date(dat)).getVarDate();
	var mFin_Table;
	mFin_Table = nType == 0 ? "PRK8DR" : "PRK8DRD";

	strSQL = " SELECT * "
				+" FROM " + tbl
				+" WHERE " +DataSource().sqlSelected()
	tbl_svwr = OpenTable(strSQL);

	if (tbl_svwr.IsEmpty())
	{
		strMsg = ru("Отсутствуют данные для переноса", "Відсутні дані для переносу")
		alert(strMsg);
		return false;
	}

	var oPrik = new DpPrik("_DF2", vidprk);
	var step = 1;		
	setProgressRange(0, tbl_svwr.recordCount);	
	for(tbl_svwr.MoveFirst(); !tbl_svwr.IsEOF(); tbl_svwr.MoveNext())
	{
		if(tbl_svwr.getAbsolute() % step == 0)
			setProgressPos(tbl_svwr.getAbsolute(), tbl_svwr.getAbsolute() +"/"+ tbl_svwr.recordCount);
		switch (nType)
		{
			case 1: // ЧП или Орендодатели
				okpo = tbl_svwr.getValue("FOKPO");
				if (!isEmpty(okpo))
				{
					WAIT(okpo);
					oPrik.clear();
					
					oPrik.setVar("FVID_PRK", vidprk);
					oPrik.setVar("TIN", okpo);
					oPrik.setVar("FBDAT", D1) ;
					oPrik.setVar("FSUM", (list.objAsk.get("ISDOHVYPL") ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMN", (list.objAsk.get("ISDOHNAR") ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNAL", (list.objAsk.get("ISPODVYPL") ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNALN", (list.objAsk.get("ISPODNAR") ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FVIDNACH", Number(nKod));
					oPrik.setVar("FWID", GetUID());
					oPrik.setVar("FIN_TABLE", mFin_Table);
					
					oPrik.save();

					strSQL = "DELETE FROM "+tbl
							+" WHERE 1=1"
							+" AND FWID = "+sqlTo(tbl_svwr.getValue("FWID"))
					ExecuteSQL(strSQL);
					
					isPer = true;
				}
			break;
		}
	}
	setProgressPos(0);

	CLEARWAIT();
	tbl_svwr.close();
	tbl_svwr = null;
	return isPer;
}

function FKOD_Valid()
{
	if(isEmpty(this.aQryList.FKOD.controls[0].value))
	{		
		alert(ru("Признак дохода не может быть равен нулю. Введите корректное значение", "Ознака доходу не може бути рівною нулю. Введіть коректне значення"));
		return false;
	}
	return true;
}

include("sys\\DpList.js");