//"Завантаження даних по кореспонденцiї в довідку 1-ДФ
include("sys\\main.js");
include("sys\\servis.js");
include("servis\\date.js");
include("Objects\\DpGrid.js");
include("Objects\\DpAskEx.js");

var oA;
var ds;
var nCl;
var tblOut = getTmpTableName("", true);
var nType;
var nKod;
var	isDohNar;
var	isDohVypl;
var	isPodNar;
var	isPodVypl;	

var	bDat;
var eDat;
var oScDt;
var	oScCr;
var	nProc;
var grpByFld;
var condDt;
var condCr;
var ret = true;
function listLoad()
{
	dsSaveFormat(false);

	with( list )
	{
		title = "Завантаження даних по кореспонденцiї в довідку 1-ДФ|Загрузка данных по кореспонденции в справку 1ДФ";
	}
}

function listAsk()
{
	ds = DataSource();
	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "FBDAT", new Date().getVarDate());
	oA.add("D", "Дата закінчення|Дата окончания", "FEDAT", new Date().getVarDate());
	oA.add("C0UTXYZ", "Рахунок по Дт|Счет по Дт", "SCDT", "0|0|0");
	oA.add("C0UTXYZ", "Рахунок по Кт|Счет по Кт", "SCCR", "0|0|0");
	oA.add("NUM", "Ознака доходу для 1-ДФ|Признак дохода для 1-ДФ", "FKOD", 42, 3);
	oA.add("NUM", "Відсоток|Процент", "FPROC", 100, 8, 5);
	oA.add("REM", "Суму записати в колонки:|Сумму записать в колонки:", "MREM2");
	oA.add("B", "Дохiд нарахований|Доход начисленный", "ISDOHNAR", false);
	oA.add("B", "Дохiд виплачений|Доход выплаченный", "ISDOHVYPL", false);
	oA.add("B", "Податок нарахований|Налог начисленный", "ISPODNAR", false);
	oA.add("B", "Податок виплачений|Налог выплаченный", "ISPODVYPL", false);

	oA.setRel(">=", "FEDAT", "FBDAT");
	oA.doAsk();
	//Если Escape - закрываем расчёт
	if (oA.escape)
	{
		CloseWindow();
		return oA;
	}

	bDat = new Date(oA.get("FBDAT"));
	eDat = new Date(oA.get("FEDAT"));
	oScDt = oA.get("SCDT");
	oScCr = oA.get("SCCR");
	nKod = oA.get("FKOD");
	nProc = oA.get("FPROC");
	isDohNar = oA.get("ISDOHNAR");
	isDohVypl = oA.get("ISDOHVYPL");
	isPodNar = oA.get("ISPODNAR");
	isPodVypl = oA.get("ISPODVYPL");	
	nType = extPar.priklbl.toUpperCase() == "_DF2" ? 1 : 0;

	if (nKod == 0)
	{
		alert(ru("Признак дохода не может быть равен нулю","Ознака доходу не може бути рівною нулю"));
		CloseWindow();
		return false;
	}	

	// выполним расчет оборотов
	// Формирование условия для отбора по счету
	var scDt = oScDt.getSc(), suDt = oScDt.getSu(), stDt = oScDt.getSt(),
		cl1Dt = oScDt.getCl1(), cl2Dt=oScDt.getCl2(), cl3Dt=oScDt.getCl3();
	var scCr = oScCr.getSc(), suCr = oScCr.getSu(), stCr = oScCr.getSt(),
		cl1Cr = oScCr.getCl1(), cl2Cr=oScCr.getCl2(), cl3Cr=oScCr.getCl3();

	condDt = (scDt? " and fdb_sc=" + scDt: (" and 1 = 1"))
		+ ( suDt? " and fdb_su=" + suDt: "" )
		+ ( stDt? " and fdb_st=" + stDt: "" )
		+ ( cl1Dt? " and fdb_cod1=" + cl1Dt: "" )
		+ ( cl2Dt? " and fdb_cod2=" + cl2Dt: "" )
		+ ( cl3Dt? " and fdb_cod3=" + cl3Dt: "" );
	condCr = (scCr? " and fcr_sc=" + scCr: (" and 1 = 1"))
		+ ( suCr? " and fcr_su=" + suCr: "" )
		+ ( stCr? " and fcr_st=" + stCr: "" )
		+ ( cl1Cr? " and fcr_cod1=" + cl1Cr: "" )
		+ ( cl2Cr? " and fcr_cod2=" + cl2Cr: "" )
		+ ( cl3Cr? " and fcr_cod3=" + cl3Cr: "" );
	//Найдем поле, с которого будем снимать код человека - это
	//та аналитика, к которой привязан либо 2-й либо 12-й справочники
	grpByFld = "";

	var oClClDb1 = new DpClcl();
	oClClDb1.setCod(oScDt.getClcl1());
	var oClClDb2 = new DpClcl();
	oClClDb2.setCod(oScDt.getClcl2());
	var oClClDb3 = new DpClcl();
	oClClDb3.setCod(oScDt.getClcl3());		

	var oClClCr1 = new DpClcl();
	oClClCr1.setCod(oScCr.getClcl1());
	var oClClCr2 = new DpClcl();
	oClClCr2.setCod(oScCr.getClcl2());
	var oClClCr3 = new DpClcl();
	oClClCr3.setCod(oScCr.getClcl3());	

	if(inlist(oClClDb1.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScDt.getClcl1();
		grpByFld = "FDB_COD1";
	}
	else if(inlist(oClClDb2.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScDt.getClcl2();
		grpByFld = "FDB_COD2";
	}
	else if(inlist(oClClDb3.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScDt.getClcl3();
		grpByFld = "FDB_COD3";
	}
	else if(inlist(oClClCr1.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScCr.getClcl1();
		grpByFld = "FCR_COD1";
	}
	else if(inlist(oClClCr2.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScCr.getClcl2();
		grpByFld = "FCR_COD2";
	}
	else if(inlist(oClClCr3.getVid(), "2", "3", "6", "cdr.cl.pers"))
	{
		nCl = oScCr.getClcl3();
		grpByFld = "FCR_COD3";
	}
	else
	{
		alert(ru("На выбранных счетах отсутствует аналитика ПЕРСОНАЛ или КОНТРАГЕНТЫ","На вибраних рахунках відсутня аналітика ПЕРСОНАЛ або КОНТРАГЕНТИ"))
		CloseWindow();
		ret = false;
		return false;
	}
	
	//Формируем заголовок окна
	list.title = ru(" Данные ", " Дані ")
		+ ru("за период с ","за період з ") + d_m_y(new Date(oA.get("FBDAT")))
		+ " по " + d_m_y(new Date(oA.get("FEDAT")));
	return oA;
}


function listMake()
{
	if(!ret)
	{
		CloseWindow();
		return false;		
	}
	strSQL = " SELECT SUM (S.FSUM) AS FSUM "
	+", S."+grpByFld+" AS FCOD"
	+" INTO " + tblOut
	+" FROM ^SCHET S"
	+" WHERE  1 = 1"
		+condDt
		+condCr
		+" AND S.FDATE>="+sqlTo(bDat)
		+" AND S.FDATE<="+sqlTo(eDat)
	+" GROUP BY S."+grpByFld
	ExecuteSQL(strSQL);
		
		var oClCl = new DpClcl();
		oClCl.setCod(nCl);
		
		if (nType == 1)
		{
		    if(inlist(oClCl.getVid(), "2"))
		    {
				//проставляем ОКПО
				ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FOKPO " + SqlType("TEXT", 12));
				strSQL = " UPDATE "
						+" " + tblOut
					+" SET FOKPO = "
						+"("
							+" SELECT DISTINCT POST.FCOD_ST"
								+" FROM "
							+" ^CLRELCLCL REL, "
							+" ^CL_POST POST"
						+" WHERE "
							+ tblOut + ".FCOD = REL.FCOD "
							+" AND REL.FCL = "+nCl
							+" AND POST.FWID_CL = REL.FWID_CL "
						+")"
				ExecuteSQL(strSQL);
				
				//Удаляем ненужные записи, если надо
				var sMsg = UR("Показувати фізичних осіб без ІПН? "
							+"|Показывать физические лица без ИНН?"
							);
							
				if(!confirm(sMsg))
				{
					strSQL = " DELETE "
						+" FROM "
							+" " + tblOut
						+" WHERE"
							+" "+SqlLen("FOKPO")+"<10"
							+" OR FOKPO IS NULL"
					ExecuteSQL(strSQL);
				}
			}
			else if(inlist(oClCl.getVid(), "3", "6", "cdr.cl.pers"))
		    {
				//проставляем идент.код
				ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FOKPO " + SqlType("TEXT", 12));
				strSQL = " UPDATE "
						+" " + tblOut
					+" SET FOKPO = "
						+"("
							+" SELECT DISTINCT HOMO.FINDNUM"
								+" FROM "
							+" ^CLRELCLCL AS REL, "
							+" ^CL_HOMO AS HOMO"
						+" WHERE "
							+tblOut+".FCOD = REL.FCOD "
							+" AND REL.FCL = " + nCl
							+" AND HOMO.FWID_CL = REL.FWID_CL "
						+")"						
				ExecuteSQL(strSQL);
			}
		}
		ExecuteSQL("ALTER TABLE " + tblOut + " ADD COLUMN FWID " + sqlType("COUNTER"));
		
		//Проапдейтим сумму это нада для того чтоб была возможность загрузить налог перечисленный
		strSQL = " UPDATE"
						+" " + tblOut
					+" SET"
						+" FSUM = " + sqlRound("FSUM*"+sqlTo(nProc/100),2)
					+" WHERE 1 = 1"
		ExecuteSQL(strSQL)		
}

function listSrc()
{
	with( list )
	{
		qrySet("From", tblOut);
		//clTie("cl", "="+ (extPar.priklbl.toUpperCase() == "_DF2" ? 12 : 2) +", FCOD");
		clTie("cl", "="+ nCl +", FCOD");
	}
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix()
	list.GroupPage(oGrid, oPrefix);            
	with (oGrid)
	{
		with(oPrefix)
		{
		}

		with (page("1ДФ"))
		{
			with (group("1ДФ"))
			{
				cell("FCOD", "код", 5);
				cell("CL.FTXT", "ПІБ", 25);
				cell("FSUM", "Сума", 9);
				cell("FOKPO", "ІПН", 10);
			}
		}
	}
	oGrid.build();
}

function listMenuInit(ds)
{
	if(!grid.getTable().IsEmpty())
	{
		ds.AddMenuItem("LDSOTR", "Завантажити відмічені записи в наказ|Загрузить отмеченные записи в приказ");
	}
}

function listMenuRun(szID)
{
	var  t = grid.getTable();
	switch(szID)
	{
		case "LDSOTR":
			if (r_imp2prk(new Date(oA.get("FEDAT")), extPar.fvid, tblOut, nType, nKod))
			{
				alert(ru("Перенос данных завершено.","Перенесення даних закінчено."));
				grid.getTable().requery();
		    	grid.refresh();
			}
		break;
	}
}

function r_imp2prk(dat, vidprk, tbl, nType, nKod)
{
	include("sys/udfs.js");
	var isPer = false;
	var D1 = firstday(new Date(dat)).getVarDate();
	var mFin_Table;
	mFin_Table = nType == 0 ? "PRK8DR" : "PRK8DRD";

	strSQL = " SELECT * "
					+" FROM " + tbl
				+" WHERE " +DataSource().sqlSelected()
	tbl_svwr = OpenTable(strSQL);

	if (tbl_svwr.IsEmpty())
	{
		strMsg = "Відсутні дані для переносу"
		alert(strMsg);
		return false;
	}

	var oPrik = new DpPrik("_DF2", vidprk);
	for(tbl_svwr.MoveFirst(); !tbl_svwr.IsEOF(); tbl_svwr.MoveNext())
	{
		switch (nType)
		{
			//Для обычного приказа 1 ДФ пока не реализовано
			/*
			case 0:
				mFtabn = tbl_svwr("FCOD");
				WAIT(mFtabn);
				tbl_prk1.AddNew();

				tbl_prk1("Fvid_prk") = vidprk;
				tbl_prk1("Ftabn")	= mFtabn;
				tbl_prk1("Fbdat")	= new Date(extPar.pDat).getVarDate();
				tbl_prk1("Fedat")	= new Date(extPar.pDat).getVarDate();

				tbl_prk1("FSUM")		= (isDohVypl ? tbl_svwr("FSUM") : 0);
				tbl_prk1("FSUMN")		= (isDohNar ? tbl_svwr("FSUM") : 0);
				tbl_prk1("FSUMNAL")		= (isPodVypl ? round(tbl_svwr("FSUM"), 2) : 0);
				tbl_prk1("FSUMNALN")	= (isPodNar ? round(tbl_svwr("FSUM"), 2) : 0);
				tbl_prk1("FVIDNACH")	= Number(nKod);
				tbl_prk1("Fwid") = GetUID();
				tbl_prk1.Update();

				strSQL = "DELETE FROM "+tbl
					+" WHERE 1=1"
						+" AND FWID = "+sqlTo(tbl_svwr("FWID"))
				ExecuteSQL(strSQL);
				isPer = true;
			break;
			*/

			case 1: // ЧП или Орендодатели
				okpo = tbl_svwr.getValue("FOKPO");
				if (!isEmpty(okpo))
				{
					WAIT(okpo);
					oPrik.clear();
					
					oPrik.setVar("FVID_PRK", vidprk);
					oPrik.setVar("TIN", okpo);
					oPrik.setVar("FBDAT", D1) ;
					oPrik.setVar("FSUM", (isDohVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMN", (isDohNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNAL", (isPodVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNALN", (isPodNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FVIDNACH" ,Number(nKod)) ;					
					oPrik.setVar("FWID", GetUID());		
					oPrik.setVar("FIN_TABLE", mFin_Table);
					
					oPrik.save();

					strSQL = "DELETE FROM "+tbl
							+" WHERE 1=1"
							+" AND FWID = "+sqlTo(tbl_svwr.getValue("FWID"))
					ExecuteSQL(strSQL);
					
					isPer = true;
				}
			break;
		}
	}

	CLEARWAIT();
	tbl_svwr.close();
	tbl_svwr = null;

	return isPer;
}
include("sys\\DpList.js");