//Редактирование результатов лицевых счетов
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");

var szTag, gd;
var dpGridEdit = null;
var dpShifPZ = null;

function listLoad()
{
	this.title = "Склад робiт |Состав работ";
	//this.editTask = "e_narrab.xml";	
	this.xmlGridFile = "l_narrab.xml";
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("FSHPZ", startEdit_fshpz, save_fshpz);
	dpGridEdit.addValidField("FKODIZD", startEdit_kizd, save_kizd);	
}

function listSrc()
{
	sOrder = "fshpz";
	var sWhere = " fid=" + sqlTo(extPar.priklbl);

	this.qrySet("Fields", "*", 
				"From", "^NAR_RAB", 
				"Where", sWhere,
				"Order", sOrder);

}


function listMenuInit()
{
	this.dataSrc.AddMenuItem("RCAD", ru("Добавить работу в наряд","Добавити роботу до наряду"));
	//this.dataSrc.AddMenuItem("ISSHPL","Перевірка ШВЗ|Проверка ШПЗ");	
}

function listMenuRun(ID)
{
	var opar = new Object();
	opar.mode = "ADD"	
	opar.fid   = extPar.priklbl
	switch (ID)
	{
    	case "RCAD":
			showWindow("e_narrab.xml", SW_MODAL , opar);
			this.tbl.Requery();
			RestoreMarker(this.tbl);
			grid.refresh();
			break;    	        
	}
   //stdMenuHandler(ID,this.tbl,opar);		
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^NAR_RAB WHERE Fid="+sqlTo(extPar.priklbl)+" and fwid=" + sqlTo(list.tbl.getValue("Fwid")));
	return false;
}

function gridEdit(modeID)
{
	if(modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Frasc  = list.tbl.getValue("Frasc");
	m.Fkoled = list.tbl.getValue("Fkoled");
	m.Fshpz = String(list.tbl.getValue("Fshpz"));
	if( getPar("PRIK_IZD") ){	
		m.Fkodizd = list.tbl.getValue("Fkodizd");
	}	
	UpdateTable("^nar_rab", m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
}

function startEdit_fshpz(oCtrl)
{
	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.setFshpz(Number(oCtrl.getValue()));
	dpShifPZ.linkCtrl(oCtrl);
}

function save_fshpz(oCtrl)
{
	if (!dpShifPZ.validCtrl())
		return false;
	return true;
}

function startEdit_kizd(oCtrl)
{
	
		oClIzd = new DpCl("0");
		ctrlIzd = eval(oCtrl);
		oClIzd.linkCtrl(oCtrl);
		if( getPar("PRIK_IZD") && dpShifPZ.getClIzd()>0)
		{
			oClIzd.setClcl(dpShifPZ.getClIzd());
			Enable(ctrlIzd);
			if(oClIzd.getCod()==0 && oClIzd.getClcl() && dpShifPZ.getCodIzd())
				oClIzd.setCod(dpShifPZ.getCodIzd());
		}
		else
		{
			oClIzd.setClcl(0);
			Disable(ctrlIzd);
			oClIzd.setCod(0);		
		}
	
}

function save_kizd(oCtrl)
{
	return true;
}

include("sys/DpList.js")

