//Редактирование доплат за будущие периоды по фондам
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");

var xdat1, xdat2
var dpGridEdit = null;
var gd

function listLoad()
{
	gd = new DpGetDat("dD");
	if (gd.escape)
		return false;
			
	this.title = "Список доплат за майбутні періоди по фондах |Список доплат за будущие периоды по фондам "
				+format("dd.mm.yyyy",gd.dat1)+"-"+format("dd.mm.yyyy",gd.dat2);
	this.xmlGridFile = "l_vvodnx.xml";
	this.editTask = "e_nxtpf.xml";

	var snap = getSnap("SELECT * FROM ^NXTF"
         +" WHERE FMN>="+sqlTo(gd.dat1)+" AND FMN<="+sqlTo(gd.dat2));
	if (snap == null)
	{
		alert(ru("Нет данных за данный период!","Немає даних на вказаний період!"));
		return false;
	}
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	
	xdat1 = gd.dat1;
	xdat2 = gd.dat2;
}

function listSrc()
{
	this.qrySet("Fields", "s.*, rel.Fcod",
				"From", "^nxtf AS s LEFT JOIN ^clrelclcl AS rel ON s.Ftabn_id=rel.Fwid_cl",
		        "Where", " s.FMN>="+sqlTo(xdat1)+" AND s.FMN<="+sqlTo(xdat2),
				"Order", "rel.Fcod, s.ffld_num");
	this.subTie("LIC_FLD","LCFLD","FID","FLSFID");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
	this.qrySet("Alias", "s");
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^nxtf"+" WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	m.Fmn = list.tbl.getValue("Fmn");
	m.Fmn1 = list.tbl.getValue("Fmn1");
	UpdateTable("^nxtf", m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function listInitEditParam(par)
{
	par.bdat = gd.dat1;
	par.edat = gd.dat2;
}
include("sys/DpList.js");