include("objects\\DpGetDat.js");
include("oblns.js");
var listPrnForm = "oblns";
var tblName = "tmp_oblns"+iOrg;


function listLoad()
{
	this.printLabel = "oblns";
	this.xmlGridFile = "l_oblns.xml";	
	list.defaultMenuID = "Calc";
}


function listAsk()
{
   
   //return new DpGetDat("dD");////asis!
      var oGD = new DpGetDat("dD");
	//var tblName = getTblName(oGD.fsc);

	DropTable(tblName);
	if(IsTable(tblName))
	{
		 alert("Невозможно выполнить расчет."+"\nПроверьте, возможно окно с данным расчетом уже открыто,"+"\nили перезапустите систему.");
			//+ "\nВозможно окно с данным расчетом уже открыто");
		oGD.escape = true;
	}	
	return oGD;
}

function listTitle()
{
	if(list.objAsk.dat2 )
	   return "Оборотный баланс "
	      + " за " + StrDat(list.objAsk.dat1, "DMY")
	      + " - " + StrDat(list.objAsk.dat2, "DMY");
	else if(IsTable(tblName + "_date"))
	{
		var t1 = OpenTable("s",tblName + "_date");
		var sRet = "Оборотный баланс "
         + " за " + StrDat(t1.getValue("FBDAT"), "DMY")
         + " - " + StrDat(t1.getValue("FEDAT"), "DMY");
         t1.close();
      return sRet;
	}
	return "";
}

function listMake()
{
   with(list.objAsk)
      oblns("_", dat1, dat2, tblName);     
//-------- add Sergey Kovtunenko 27.04.00---------        
		cdat1 = sqlTo(list.objAsk.dat1);
		cdat2 = sqlTo(list.objAsk.dat2);
		tblNameDate = tblName + "_date";
        DropTable(tblNameDate);
//        alert(tblNameDate);
		  
        strSQL = "CREATE TABLE " + tblNameDate + " (fbdat "+SqlType("DATE")+", fedat "+SqlType("DATE")+")";
        ExecuteSQL(strSQL);
        strSQL = "INSERT INTO " + tblNameDate + " (fbdat, fedat) VALUES (" + cdat1 + ", " + cdat2 + ")";
        ExecuteSQL(strSQL);
//        browse(tblNameDate);
//---------------------------------------        
  
}

function listSrc()
{
	var parZabalB = Number(getPar("ZABALB")),
		parZabalE = Number(getPar("ZABALE")),
		parNZabalB = Number(getPar("NZABALB")),
		parNZabalE = Number(getPar("NZABALE"));
   
   var whereZabal = null;
   
   if (parZabalB != 0 || parZabalE != 0)
   {
   		whereZabal = "((fsc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND (fclass NOT BETWEEN " + parZabalB/10 + " AND " + parZabalE/10 + ") )";
   }
   
   if (parNZabalB != 0 || parNZabalE != 0)
   {
   		if (whereZabal != null)
   			whereZabal += " AND ";
   		else
   			whereZabal = "";
   		whereZabal += "((fsc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ") AND (fclass NOT BETWEEN " + parNZabalB/10 + " AND " + parNZabalE/10 + ") )";
   }
   
   list.qrySet("From", tblName,
		"WhereArr", new Array(
			"fttlevel<>2",
			"fcl_cod1=0",
			"fttlevel<>2 and fcl_cod1=0",
			"fcl_cod1=0 and fst=0",
			"fcl_cod1=0 and fst=0 and fsu=0",
			"fcl_cod1=0 and fst=0 and fsu=0 and fsc=0"
		),
		"WhereArrName", new Array(
			ru("Без итогов по классам", "Без підсумків за класами"),
			ru("Свернуть по статье", "Згорнути за статтею"),
			ru("Свернуть по статье (без итогов по классам)", "Згорнути за статтею (без підсумків по класах)"),
			ru("Свернуть по субсчету", "Згорнути за субрахунком"),
			ru("Свернуть по счету", "Згорнути по рахунку"),
			ru("Свернуть по классу", "Згорнути по класу")
		),
	"WhereArrI", -1,
      
      "Order", "fclass, fsc, fsu, fst, fcl_cod1",
      "Ptn", "OBLNS"
      );
      
      if (whereZabal != null)
      {
	      list.qrySet("WhereArr0", new Array(whereZabal),
	      "WhereArrName0", new Array(
			"Не показывать забалансовые счета"
			 ),
	      "WhereArrI0", -1)
      }
}

function listGrid1()
{
   _row(0);
   _row(1);
   _row(2);
   _row(3);
   _row(4); 
   _row(5);
}

function _row(nRow)
{
	var cCond = "";
	switch(nRow)
	{
	case 1:
		cCond = " ^fclass=99"
		break;
	case 2:
		cCond = " ^fsc=0";
		break;
	case 3:
		cCond = " ^fsc<>0 AND ^fsu=0 AND ^fst=0 AND ^fcl_cod1=0";
		break;
	case 4:
		cCond = " ^fsu<>0 AND ^fst=0 AND ^fcl_cod1=0";
		break;
	case 5:
		cCond = " ^fst<>0 AND ^fcl_cod1=0";
		break;
	case 0:
		cCond = "";
	}
	
   if(cCond)
		cCond = "=CBool(" + cCond + ")";
   
	var r = row(cCond);
   r.textColor(colorLevel(nRow));
   
   fieldEx(nRow==1? "": "=iif(^fclass=99,\"\",^fclass)", "", 3); 
   fieldEx(nRow==1? "": "fsc", "", 3);
   fieldEx(nRow==1? "": "fsu", "рах.|сч.", 5);
   fieldEx(nRow==1? "": "fst", "", 5);
   fieldEx(nRow==1? "": "fcl_cod1", "", 5);
   //было раньше до 22.02.00 изменила Яна
   //if(nRow==1)
   //   fieldEx(ru("Итого","Усього"), "", 12, "c");
   //else
   //fieldEx("=sccltxt(^fclass, ^fsc, ^fsu, ^fst, ^fcl_cod1, 0, 0)", "", 12);
   //---------------
   if(nRow==1)
   {
		fieldEx(UR("Усього|Итого"), "", 12, "c");
   }
   else
	   fieldEx("=iif(Cbool("+nRow+"=1),"+"\""+UR("Усього|Итого")+"\""
			+ ",iif(Cbool(^Fsc=0),"+"\""+UR("Всього по класу  |Всего по классу  ")+"\""+"+Cstr(^Fclass)"
			+ ", sccltxt(^fclass, ^fsc, ^fsu, ^fst, ^fcl_cod1, 0, 0)))", "", 12);
   fieldEx("fsum1","Дебет|Дебет",8,DP_FORMAT_SUM);
   fieldEx("fsum2","Кредит|Кредит",8,DP_FORMAT_SUM);
   fieldEx("fsum5","Дебет|Дебет",8,DP_FORMAT_SUM);
   fieldEx("fsum6","Кредит|Кредит",8,DP_FORMAT_SUM);
   fieldEx("fsum3","Дебет|Дебет",8,DP_FORMAT_SUM);
   fieldEx("fsum4","Кредит|Кредит",8,DP_FORMAT_SUM);


   HeaderRow(cCond).textColor(colorLevel(nRow));
   fieldEx("","Кл.|Кл.",1).Empty(); 
   fieldEx("","Рах.|Сч.",1).Empty();
   fieldEx("","Суб|Суб",1).Empty();
   fieldEx("","Ст.|Ст.",1).Empty();
   fieldEx("","Ан.1|Ан.1",1).Empty();
   fieldEx("","Назва|Название", 1).Empty();
   fieldEx("","Сальдо на початок|Сальдо на начало",2);
   fieldEx("","Обіги|Обороты",2);
   fieldEx("","Сальдо на кінець|Сальдо на конец",2);
}

function listDelAcc()
{
   return false;
}

function disCharge()
{
  var nameTable = "oblns__"+iOrg;
  DropTable(nameTable);
  CreateTable(nameTable,"SVOBLNS","*");
  var t1 = OpenTable("s",tblName + "_date");
  var t2 = OpenTable("s","SELECT FOBL FROM ^CL_SVBAL WHERE FRN=" + iOrg);
  var iObl = (t2.IsEmpty())? 0 : t2("fobl");
  ExecuteSQL("INSERT INTO " + nameTable  + " (FCLASS,FSC,FSU,FSUM1,FSUM2,FSUM3,FSUM4,FSUM5,FSUM6,"
			+ "FISTOTAL,FTTLEVEL,FVID,FRN,FOBL,FBDAT,FEDAT)"
			+ " SELECT FCLASS,FSC,FSU,FSUM1,FSUM2,FSUM3,FSUM4,FSUM5,FSUM6," +
			 " FISTOTAL,FTTLEVEL,FVID, " + iOrg + " AS FRN," + iObl + " AS FOBL," +
			 sqlTo(t1("FBDAT")) + " AS FBDAT, " + sqlTo(t1("FEDAT")) + " AS FEDAT" +
			 " FROM ^" + tblName + " WHERE fst=0 AND fcl_cod1=0");
  t1.close()
  t2.close()
}

function listMenuInit()
{
  
   with( list.dataSrc )
   {
      AddMenuItem ("ObDeb","Розкрити дебетові обіги|Раскрыть дебетовые обороты");
      AddMenuItem ("ObKred","Розкрити кредитові обіги|Раскрыть кредитовые обороты");
      AddMenuItem ("Calc","Розрахувати виписку по рахунку|Рассчитать выписку по счету");     
      AddMenuItem ("", "")
      AddMenuItem ("Load","Вивантаження|Выгрузка");     
   }
}

function listMenuRun(ID)
{
	list.objParMenu.pdat = list.objAsk.dat1;
	list.objParMenu.pdat2 = list.objAsk.dat2;
	list.objParMenu.psc = Number(list.tbl.getValue("fsc"));
	list.objParMenu.psu = Number(list.tbl.getValue("fsu"));
	list.objParMenu.pst = Number(list.tbl.getValue("fst"));
	list.objParMenu.pcl1 = Number(list.tbl.getValue("fcl_cod1"));
	list.objParMenu.val = 0;
	list.objParMenu.val_nzv = "ГРН";
	list.objParMenu.modegrn = true;
	list.objParMenu.isRaskr = true;

	var retValue = DpList_exit;

	switch (ID) {
	case "ObDeb":
		showWindow("vp_dc.js", SW_NOMODAL, list.objParMenu);
		break;
	case "ObKred":
		showWindow("vp_cd.js", SW_NOMODAL, list.objParMenu);
		break;
	case "Calc":
		showWindow("r_vip.js", SW_NOMODAL, list.objParMenu);
		break;
	case "Load":
		disCharge();
		break;
	default:
		retValue = 0;
	}

	return retValue;
}

function listOnPrnList(tv)
{
    var zmbDate=list.objAsk.dat1;
    var zmeDate=list.objAsk.dat2;
    
    var h = new Object();
    h.FD1  = zmbDate;
    h.FD2  = zmeDate;
    tv.setHTbl(h);
}

include("sys\\dplist.js");