include("reciznos0.js");
include("r_ost2011.js");
include("Objects/DpAskEx.js");
include("sys/dbase.js");
include("riznosb.js");
include("riznosbp.js");
include("izosdatb.js");
var tblSrcName = "^OS0B";

function listLoad()
{
	with(this)
	{
		title="Список змiни вартостi ОЗ по бух.облiку|Список изменения стоимости ОС по бух.учету";
		editTask = "e_sizmb.xml";
		xmlGridFile = "l_os0b.xml";
	}
	//групируем визуально комплекты
	grid.setFilling("=^FKOMPL>0?^FKOMPL:^FWID");
}

function listSrc()
{
	if(tblSrcName == "TMP_OS0B_SRC")
		this.qrySet	("From", tblSrcName,"Order","Finv_num,Fbdat,Fedat");
	else
		this.qrySet	("Fields", "s0.*,s1.Fkompl", 
				"From", "^OS0B as s0 left join ^OS1 as s1 on s0.Finv_num=s1.Finv_num", 
				"Order","s0.Finv_num, s0.Fbdat, s0.Fedat",
				"Alias", "s0");
		this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");				
}

function listMenuInit()
{  
	with(this.dataSrc)
    {
		AddMenuItem("OS2011", ru("Выведение остатков по б/у на 01.01.2011", "Виведення залишків по б/о на 01.01.2011"))
		//AddMenuItem("MB2011", ru("Массовое изм.групп и сроков службы", "Масова замiна груп та терм.вик."))
		AddMenuItem("ISPR2", ru("Исправление износа для отмеч.записей c 2011", "Виправлення зносу для відміч.записів з 2011"))		
		//AddMenuItem("ISPR", ru("Перерасчет износа по 2 методу для отм.зап.", "Перерахування зносу по 2 методу для відм.зап."))
		//AddMenuItem("ISPR1", ru("Исправление износа для отмеч.записей", "Виправлення зносу для відміч.записів"))
		AddMenuItem("ON2011", ru("Выведение остатков по н/у на 01.04.2011", "Виведення залишків по п/о на 01.04.2011"))
		AddMenuItem("GN2011", ru("Перенос групп и сроков в н/у с 01.04.2011", "Перенесення груп та терм. до п/о з 01.04.2011"))		
		
		AddMenuItem ("","");
		if(tblSrcName != "TMP_OS0B_SRC")
			AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты");
		else
			AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты",ICON_RADIO);
		if(tblSrcName == "TMP_OS0B_SRC")
			AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты");
		else
			AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты",ICON_RADIO);
		this.dataSrc.AddMenuItem("","");
		AddMenuItem("ADD_ON_DATE", ru("Добавить на новую дату для отмеченных записей", "Додати на нову дату для відмічених записів"));
		AddMenuItem("IMP_IZM_XLS", ru("Импортировать изменения стоимости из Excel (инв.№, сумма изменения)", "Імпортувати зміни вартості з Excel (інв. №, сума зміни)"));
    }
}

function listMenuRun(ID)
{	
	switch(ID)
   	{
   		case "OS2011":
   			if(!confirm(ru("Будут созданы записи по выведенным остаткам.Продолжить?",
						"Будуть сформовані записи по виведених залишках.Продовжити?")))
   				return false;
   			r_ost2011("BUH");
   			this.tbl.requery();
   			grid.RefreshGrid();
   			break;
   		case "ON2011":
   			if(!confirm(ru("Будут созданы записи по выведенным остаткам.Продолжить?",
						"Будуть сформовані записи по виведених залишках.Продовжити?")))
   				return false;
   			r_ost2011("NAL");
   			this.tbl.requery();
   			grid.RefreshGrid();
   			break;
   		case "GN2011":
   			if(!confirm(ru("Будут перезаписаны группы и сроки.Продолжить?",
						"Будуть перезап.групи та терміни.Продовжити?")))
   				return false;
   			  var dt_iz  = getPar("UOSDAT2011");   			
		      var xos0 = OpenTable("s", "select * from  ^OS0B where Fbuhmetod=8 and Fbdat="+sqlTo(dt_iz))  
		      if (!xos0.IsEmpty()){
		         while (!xos0.IsEOF()){
		        	 ExecuteSQL("update ^OS0 set Fgroup="+sqlTo(xos0.getValue("Fgroup"))+", Fsrokadd="+sqlTo(xos0.getValue("Fsrokadd"))+" where Finv_num="+sqlTo(xos0.getValue("Finv_num"))+" and Fbuhmetod=8 and Fbdat>="+sqlTo(new Date(2011,3,1)))            
		             xos0.MoveNext();
		         }  
		      }
		      xos0.close();
   			this.tbl.requery();
   			grid.RefreshGrid();
   			break;
   		case "ISPR":
			if(!confirm(ru("В отмеченных записях будет перерасчитан износ и проставлен 2 метод расчета амортизации.\nПродолжить?",
							"У відмічених записах буде перераховано знос та проставлено 2 метод розрахунку амортизації.\nПродовжити?")))
				return false;
			var t = OpenTable("select b.*, o1.Fdoc_dat from ^os0b as b inner join ^os1 as o1 on b.Finv_num=o1.Finv_num "
						+" where b.Fwid "+grid.sqlSelected(true)+" order by b.Finv_num, b.Fbdat, b.Fedat");
			reciznos0(t, "PR");
			t.close();
			this.tbl.requery();
			grid.RefreshGrid();
   			break;			
   		case "MB2011":
			var dt_iz  = getPar("UOSDAT2011");   			
   			var codm=0;
   			codm = input("Введите номер группы для отмеч.записей", "", 0, 3);
   			if (codm==null)
   				return false;

   			var tsrok=0;
   			tsrok = input("Введите срок службы для указанной ранее группы в месяцах", "", 0, 6,2);
   			if (tsrok==null)
   				return false;
   			
   			ExecuteSQL("update ^OS0B set Fgroup="+sqlTo(codm)+", Fsrokadd="+sqlTo(tsrok)+" where Fwid "+grid.sqlSelected(true))
   			
			if(confirm(ru("Перезаписать данные в налоговом учете?",
				"Перерахувати данi у податковому облiку?"))){
			      var xos0 = OpenTable("s", "select distinct Finv_num from ^OS0B where Fwid "+grid.sqlSelected(true))  
			      if (!xos0.IsEmpty()){
			         while (!xos0.IsEOF()){
			        	 ExecuteSQL("update ^OS0 set Fgroup="+sqlTo(codm)+", Fsrokadd="+sqlTo(tsrok)+" where Finv_num="+sqlTo(xos0.getValue("Finv_num"))+" and Fbuhmetod=8 and Fbdat>="+sqlTo(new Date(dt_iz)))            
			             xos0.MoveNext();
			         }  
			      }
			      xos0.close();
			}
   			this.tbl.requery();
   			grid.RefreshGrid();
   			break;
		case "ISPR1":
			if(!confirm(ru("В отмеченных записях будет перерасчитан износ.Продолжить?",
							"У відмічених записах буде перераховано знос.Продовжити?")))
				return false;
			var t = OpenTable("select b.*, o1.Fdoc_dat from ^os0b as b inner join ^os1 as o1 on b.Finv_num=o1.Finv_num "
						+" where b.Fwid "+grid.sqlSelected(true)+" order by b.Finv_num, b.Fbdat, b.Fedat");
			reciznos0(t,"SR");
			t.close();
			this.tbl.requery();
			grid.RefreshGrid();
		break;
		case "ISPR2":
			if(!confirm(ru("В отмеченных записях будет перерасчитан износ.Продолжить?",
							"У відмічених записах буде перераховано знос.Продовжити?")))
				return false;
			var dt_iz  = getPar("UOSDAT2011");			
			var t = OpenTable("select b.*, o1.Fdoc_dat from ^os0b as b inner join ^os1 as o1 on b.Finv_num=o1.Finv_num "
						+" where b.Fbdat>"+sqlTo(dt_iz)+" and b.Fwid "+grid.sqlSelected(true)+" order by b.Finv_num, b.Fbdat, b.Fedat");
			reciznos0(t,"NK");
			t.close();
			this.tbl.requery();
			grid.RefreshGrid();
		break;
		case "MIN_KMPL":
			DropTable("TMP_OS0B_SRC");
			ExecuteSQL("select s0.*,s1.Fkompl into TMP_OS0B_SRC from ^os0 as s0 inner join ^os1 as s1"
					+" on s0.Finv_num=s1.Finv_num where s1.Fkompl=0");
			ExecuteSQL("insert into TMP_OS0B_SRC (Fwid,Finv_num,Fkompl,Forig_pric,Fiznos,Fcod_rate,Fkf_ispol,Fbdat,Fedat,Fsrokadd,"
						+"Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,"
						+"Fcr_cod2,Fcr_cod3) "
					+" select MIN(s0.Fwid),s1.Fkompl,s1.Fkompl,SUM(s0.Forig_pric),SUM(s0.Fiznos),MIN(s0.Fcod_rate),"
						+"MIN(s0.Fkf_ispol),MIN(s0.Fbdat),MIN(s0.Fedat),MIN(s0.Fsrokadd),MIN(s0.Fdb_sc),"
						+"MIN(s0.Fdb_su),MIN(s0.Fdb_st),MIN(s0.Fdb_cod1),MIN(s0.Fdb_cod2),MIN(s0.Fdb_cod3),MIN(s0.Fcr_sc),"
						+"MIN(s0.Fcr_su),MIN(s0.Fcr_st),MIN(s0.Fcr_cod1),MIN(s0.Fcr_cod2),MIN(s0.Fcr_cod3) "
					+" from ^os0b as s0 inner join ^os1 as s1 on s0.Finv_num=s1.Finv_num "
					+" where s1.Fkompl>0 group by s1.Fkompl,s0.Fbdat");
			tblSrcName = "TMP_OS0B_SRC";
			grid.DeletePages();
			list.init();
		break;
		case "MAX_KMPL":
			tblSrcName = "^OS0B";
			grid.DeletePages();
			list.init();
		break;
		case "ADD_ON_DATE":
			var oAsk = new DpAskEx();
			oAsk.add("D","Введіть дату зміни|Введите дату изменения","dat",getPar("GLOBDAT1"));
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			var fld = new Object();
			fld.FWID = "LONG";
			var ind = new Object();
			ind.FWID = "FWID";
			CreateTable("tmp_fwids", fld, ind);//таблица в которую будем запоминать идентификаторы добавленных в справочник записей
			var t = OpenTable("select * from ^os0b where Fwid "+grid.sqlSelected(true)+" and Fedat="+sqlTo(d00)+" and Fbdat<"+sqlTo(oAsk.get("dat"))+" order by Finv_num, Fbdat");
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, t.bookmark+"/"+t.rowCount);
				var m = scatter(t);
				var old_fwid = m.FWID;
				m.FWID = GetUID();
				m.FBDAT = oAsk.get("dat");
				var edat = goDay(m.FBDAT, -1);
				var b = ExecuteSQL("update ^os0b set Fedat="+sqlTo(edat)+" where Fwid="+old_fwid);
				if(b)
				{
					UpdateTable("^os0b", m, true);
					ExecuteSQL("insert into tmp_fwids(Fwid) values("+m.FWID+")");
				}
			}
			setProgressPos(0);
			t.close();
			//исправляем износ
			var dt_iz  = getPar("UOSDAT2011");			
			var t = OpenTable("select b.*, o1.Fdoc_dat from ^os0b as b inner join ^os1 as o1 on b.Finv_num=o1.Finv_num "
						+" where b.Fbdat>"+sqlTo(dt_iz)+" and b.Fwid in (select Fwid from tmp_fwids) order by b.Finv_num, b.Fbdat, b.Fedat");
			reciznos0(t,"NK");
			t.close();
			this.tbl.requery();
			grid.RefreshGrid();
		break;
		case "IMP_IZM_XLS":
			var oAsk = new DpAskEx();
			oAsk.add("D","Дата внесення змін|Дата внесения изменений","DAT",new Date(2011,3,1));
			oAsk.add("FILE","Excel файл","XLSFILE","","*.xls;","Документы MS Excel (*.xls)|*.xls|Все файлы (*.*)|*.*");
			oAsk.add("B","Копіювати причину зміни з поточного запису|Копировать причину изменения с текущей записи","COPYTYPEIZ",false);
			oAsk.add("COMBO","Причина змін|Причина изменений","TYPEIZ",0,"Прочие причины|Модернизация|Улучшение|Индексация|Ремонт|Измен.за счет НДС|Изменение метода б/у|Консервация|Изменение группы|Модерн.в период конс.|Ремонт.в период конс.");
			oAsk.defCond("this.aQryList['COPYTYPEIZ'].controls[0].checked == false", "COND_IS_TYPE");
			oAsk.enable("TYPEIZ", "COND_IS_TYPE");
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			var dat = oAsk.get("DAT");
			var sFileName = oAsk.get("XLSFILE");
			var exldoc = lpProxy.openExcelWorkbook(sFileName);
			var copyType = oAsk.get("COPYTYPEIZ");
			var typeIz;
			switch(Number(oAsk.get("TYPEIZ")))
			{
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
					typeIz = Number(oAsk.get("TYPEIZ"));
				break;
				case 9:
					typeIz = 17;
				break;
				case 10:
					typeIz = 27;
				break;
				default:
					typeIz = 0;
			}
			if(exldoc==null)
			{
				alert(ru("Ошибка открытия документа Excel!","Помилка відкриття документа Excel!"),2);
				return false;
			}
			//считываем количество строк на первом листе
			var nY	= exldoc.getSheet(exldoc.getSheetName(0)).getLastRowNum();
			var nrow = 0;
			var inv_num, psum,retVal,amort,group,subgroup,vid,srok,dsu,dst,da1,za3,konserv;
			setProgressRange(1, nY);
			var arFwid = new Array();
			while (nrow <= nY)
			{
				setProgressPos(nrow+1, "Импорт данных из EXCEL: "+(nrow+1)+"/"+(nY+1));		
				//считываем данные 1 столбец - инв.№, 2 столбец - сумма
				if(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow)==null || exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(0)==null)
				{
					nrow++;
					continue;
				}
				var cell0Type,cell1Type;
				if(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow)!=null)
				{
					if(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(0))
						cell0Type = exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(0).getCellType();
					if(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(1))
						cell1Type = exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(1).getCellType();
				}
				else
				{
					nrow++;
					continue;
				}
				if(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow)!=null && cell1Type==0)
				{
					var isErr = false;
					if(cell0Type==0)
						inv_num = Number(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(0).getNumericCellValue());
					else
						inv_num = Number(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(0).getStringCellValue());
					if(isNaN(inv_num))
						isErr = true;
					if(cell1Type==0)
						psum = Number(exldoc.getSheet(exldoc.getSheetName(0)).getRow(nrow).getCell(1).getNumericCellValue());
					else
						isErr = true;
					if(isErr)
					{
						var nn = nrow+1;
						setProgressPos(0);
						alert(ru("Не коректные данные в "+nn+" строчке Excel файла!","Не коректні дані в "+nn+" строчці Excel файлу!"),1);
						nrow++;
						continue;
					}
					var tbl = OpenTable("select * from ^os0b where Finv_num="+inv_num+" and Fbdat<"+sqlTo(dat)+" and Fedat="+sqlTo(d00));
					if(tbl.rowCount==0 || tbl.rowCount>1)
					{
						if(tbl.rowCount>1)
							alert("Для инвент.№"+inv_num+" в справочнике изменений стоимости по б/у найдено "+tbl.rowCount+" строк, которые пересекаются с датой "+format("dd.mm.yyyy",dat),1);
						if(tbl.rowCount==0)
							alert("Для инвент.№"+inv_num+" в справочнике изменений стоимости по б/у не найдено записи с открытым периодом пересекающимся с датой "+format("dd.mm.yyyy",dat),1);
						nrow++;
						continue;
					}
					//текущую запись в списке закрываем на день раньше
					ExecuteSQL("update ^os0b set Fedat="+sqlTo(goDay(dat,-1))+" where Fwid="+tbl.getValue("Fwid"));
					var m = scatter(tbl);
					m.FWID = GetUID();
					arFwid[arFwid.length] = m.FWID;
					m.FORIG_PRIC += psum;
					m.FBDAT = new Date(dat).getVarDate();
					if(copyType)
					{
						if(m.FTYPEIZ == 6)//изменение метода перебъем на ремонты для корректного расчета амортизации
							m.FTYPEIZ = 4;
					}
					else
						m.FTYPEIZ = typeIz;
					UpdateTable("^os0b", m, true);
					tbl.close();
				}
				nrow++;
			}
			setProgressPos(0);
			//исправляем износ
			var dt_iz  = getPar("UOSDAT2011");
			if(arFwid.length>0)
			{
				var t = OpenTable("select b.*, o1.Fdoc_dat from ^os0b as b inner join ^os1 as o1 on b.Finv_num=o1.Finv_num "
							+" where b.Fbdat>"+sqlTo(dt_iz)+" and b.Fwid in ("+arFwid+") order by b.Finv_num, b.Fbdat, b.Fedat");
				reciznos0(t,"NK");
				t.close();
			}
			list.tbl.requery();
			grid.refresh();
		break;
	}
}

function getGroupConcat(kompl,bdat)
{
	var ret = "";
	var t = OpenTable("select s0.Fgroup from ^os0b as s0 inner join ^os1 as s1 on s0.Finv_num=s1.Finv_num "
					+" where s1.Fkompl="+kompl+" and s0.Fbdat="+sqlTo(bdat));
	for(; !t.IsEOF(); t.MoveNext())
		ret += (t.absolute==1?"":"+")+t.getValue("Fgroup");
	t.close();
	return ret;
}

function filterMode(mode)
{
	if(tblSrcName == "TMP_OS0B_SRC" && (mode == "ADD" || mode == "COPY" || mode == "DEL"|| mode == "EDIT"))
	{
		WAIT(ru("Для выполнения каких-либо действий над записями перейдите к развернутому виду.",
				"Для виконання яких-небудь дій над записами перейдіть до розгорнутого вигляду."));
		return false;
	}
	return true;	
}

function listDel()
{
/*из общего списка при обычном удалении записи апдейтить предыдущую не будем, при массовом удалении предложим на выбор	
   var oSnap = getSnap("SELECT Fwid FROM ^os0b a WHERE a.Finv_num="
			+this.tbl.getValue("Finv_num")+" AND a.Fbdat=(SELECT MAX(b.Fbdat) "
			+"FROM ^os0b b WHERE a.Finv_num=b.Finv_num AND Fwid<>"+this.tbl.getValue("Fwid")+")");
	if(oSnap!=null)
		ExecuteSQL("UPDATE ^os0b SET Fedat="+sqlTo(d00)+" WHERE Fwid="+oSnap[0]);*/
	ExecuteSQL("delete from ^os0b where Fwid="+list.tbl.getValue("Fwid"));
	return false;
}

function listMassDel()
{
	var msg = ru("Проставлять после удаления пустую дату окончания в последней записи по соответствующему инвентарному номеру?",
				"Проставляти після видалення порожню дату закінчення в останній запис за відповідним інвентарним номером?");
	if(confirm(msg))
	{
		if(SUBD == MYSQL || SUBD == MSSQL || SUBD == POSTGRE)
		{
			DropTable("tmp_os_all");
			ExecuteSQL("select * into tmp_os_all from ^os0b");
			ExecuteSQL("UPDATE ^os0b SET Fedat="+sqlTo(d00)+" WHERE exists(select Fwid from tmp_os_all as b2 where ^os0b.Finv_num=b2.Finv_num and b2.Fwid "+grid.sqlSelected(true)+") "
					+" and Fbdat in (select MAX(Fbdat) from tmp_os_all as b2 where ^os0b.Finv_num=b2.Finv_num and not b2.Fwid "+grid.sqlSelected(true)+")");
		}
		else
			ExecuteSQL("UPDATE ^os0b as b1 SET Fedat="+sqlTo(d00)+" WHERE exists(select Fwid from ^os0b as b2 where b1.Finv_num=b2.Finv_num and b2.Fwid "+grid.sqlSelected(true)+") "
					+" and Fbdat in (select MAX(Fbdat) from ^os0b as b2 where b1.Finv_num=b2.Finv_num and not b2.Fwid "+grid.sqlSelected(true)+")");
	}
	ExecuteSQL("delete from ^os0b where fwid "+grid.sqlSelected(true));
	return true;
}

function getChangeCost(inv_num, bdat, orig_pric)
{
	var oSnap = getSnap("select Forig_pric from ^os0b a where Finv_num="+inv_num
						+" and Fbdat=(select max(Fbdat) from ^os0b b where "
						+"a.Finv_num=b.Finv_num and b.Fbdat<"+sqlTo(bdat)+")");
	if(oSnap!=null)
		return Number(orig_pric)-Number(oSnap[0]);
	else
		return 0;
}

include("sys\\DpList.js")