// JScript source code

var titleRU = "Личные дела сотрудников", titleUA = "Особові справи працівників";
var strBDat = Convert("(SELECT MIN(w.FBDAT) FROM ^work_pers as w WHERE b.FWID = w.FWID_CL AND w.Fis_serv="+sqlFalse+")","DATE");
var strEDat = Convert("(SELECT MAX(w1.FEDAT) FROM ^work_pers AS w1 WHERE b.FWID = w1.FWID_CL AND w1.Fis_serv="+sqlFalse+")","DATE");
var strCodDol = "(SELECT sd.FCOD FROM ^stru_dol AS sd LEFT JOIN ^work_pers AS w4 ON sd.FWID = w4.FWID_DOL WHERE w4.FWID_CL=b.FWID AND w4.FID=(SELECT MAX(w5.FID) FROM ^work_pers AS w5 WHERE w5.FWID_CL=b.FWID AND w5.Fis_serv="+sqlFalse+"))";
var strFwidOrg = "(SELECT sd.Fwid_org FROM ^stru_dol AS sd LEFT JOIN ^work_pers AS w4 ON sd.FWID = w4.FWID_DOL WHERE w4.FWID_CL=b.FWID AND w4.FID=(SELECT MAX(w5.FID) FROM ^work_pers AS w5 WHERE w5.FWID_CL=b.FWID AND w5.Fis_serv="+sqlFalse+"))";
var strOklad = "(SELECT sd.FOKLAD FROM ^stru_dol AS sd LEFT JOIN ^work_pers AS w4 ON sd.FWID = w4.FWID_DOL WHERE w4.FWID_CL=b.FWID AND w4.FID=(SELECT MAX(w5.FID) FROM ^work_pers AS w5 WHERE w5.FWID_CL=b.FWID AND w5.Fis_serv="+sqlFalse+"))";
var strWhere = "";
var gDat;

include("Objects/DpGetDat.js")
include("servis/date.js");

function listLoad()
{
	with( this )
	{
		editTask = "e_list.xml";
		printLabel = "LIST";
		xmlGridFile = "l_prfile.xml";
	}
	
	switch(this.par.menuMode)
	{
	case "ALL":
		titleRU += " - все";
		titleUA += " - всі";
		strWhere = sqlCmpTrue;
		break;
	
	case "WRK":
		titleRU += " - работающих";
		titleUA += ", що працюють";
		strWhere = " exists(SELECT w1.FEDAT FROM ^work_pers AS w1 WHERE b.FWID = w1.FWID_CL AND w1.Fbdat<"+sqlTo(d00)+" and w1.Fedat="+sqlTo(d00)+" AND w1.Fis_serv="+sqlFalse+")"
//		strWhere = "((" + strEDat + " = " + SqlMaxDate + ")"
//					+ " OR (( NOT " + strBDat + " IS NULL) AND ( " + strEDat + " IS NULL)))";
		break;

	case "IN":
		
		gDat = new DpGetDat("dD");	
		if(gDat.escape) 
			return false;

		titleRU += " принятых в период " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		titleUA += ", які прийняті за період " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		strWhere = "(" + strBDat + " BETWEEN " + sqlTo(gDat.dat1) + " AND " + sqlTo(gDat.dat2)+ ")";
		break;
	
	case "OUT":
		gDat = new DpGetDat("dD");	
		if(gDat.escape) 
			return false;
		titleRU += " уволенных в период " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		titleUA += ", які звільнені за період " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		//strWhere = "(" + strEDat + " BETWEEN " + sqlTo(gDat.dat1) + " AND "  + sqlTo(gDat.dat2) + ")";
		
		//ищем по признаку увольнения и проверяем, чтобы не было записей в ШР после увольнения
		strWhere = "exists(select * from ^work_pers as wp where wp.Fwid_cl=b.Fwid and wp.Fis_uv="+sqlTrue
				+" and wp.Fedat>=" + sqlTo(gDat.dat1) + " AND wp.Fedat<="  + sqlTo(gDat.dat2) + ")"
				+" and (" + strEDat + " BETWEEN " + sqlTo(gDat.dat1) + " AND "  + sqlTo(gDat.dat2) + ")";
		break;
		
	case "LEAVE":
		gDat = new DpGetDat("dD");	
		if(gDat.escape) 
			return false;
		titleRU += ", находившихся в отпуске в период " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		titleUA += ", які знаходилися у відпустці за період " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		strWhere = "(c.Fwid_cl IN (SELECT tr1.Fwid_cl"
				+ " FROM ^prk_otp AS tr1" +
				" WHERE tr1.FBDAT<=" + sqlTo(gDat.dat2) + " AND tr1.FEDAT>=" + sqlTo(gDat.dat1)+
							")" +
							")";
		break;
/*	
	case "TRIP":
		if(getPeriod())
		{
			CloseWindow();
			return;
		}

		titleRU += ", находившихся в командировках в период " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		titleUA += ", які знаходилися у відрядженні за період " + StrDat(gDat.dat1, "DMY") + " - " + StrDat(gDat.dat2, "DMY");
		where = "(b.FWID IN (SELECT tr1.FWID_CL"
				+ " FROM ^busnesstrip AS tr1"
				+ " WHERE (tr1.FBDAT>=" + sqlTo(gDat.dat1.getVarDate()) + " AND tr1.FEDAT<=" + sqlTo(gDat.dat2.getVarDate()) + ")" 
					+ " OR (tr1.FBDAT BETWEEN" + sqlTo(gDat.dat1.getVarDate()) + " And " + sqlTo(gDat.dat2.getVarDate()) + ")"
					+ "	OR (tr1.FEDAT BETWEEN" + sqlTo(gDat.dat1.getVarDate()) + " And " + sqlTo(gDat.dat2.getVarDate()) + ")))";
		break;
		
	case "EDUC":
		var par = new Object();
		par.menuMode = menuMode;
		par.escape = true;
		showWindow("cdrAsk.htm", SW_MODAL, par);
		if(par.escape)
		{
			CloseWindow();
			return;
		}

		var whereIn = "";
		if(par.cEduc)
			whereIn += "te3.FID_TYPEEDUC=" + sqlTo(par.cEduc);
		
		if(par.cInst)
			whereIn += (((""==whereIn)?"":(" AND ")) + "te3.FID_INSTITUT=" + sqlTo(par.cInst));
			
		if(par.cForm)
			whereIn += (((""==whereIn)?"":(" AND ")) + "te3.FID_FORMEDUC=" + sqlTo(par.cForm));
		
		if(par.cDegr)
			whereIn += (((""==whereIn)?"":(" AND ")) + "te3.FID_DEGREE=" + sqlTo(par.cDegr));

		if(null!=par.datStart)
			whereIn += (((""==whereIn)?"":(" AND ")) + "(te3.FEDAT BETWEEN " + sqlTo(par.datStart) + " AND " + sqlTo(par.datEnd)+ ")");
		
		strWhere = "(b.FWID IN (SELECT te3.FWID_CL"
				+ " FROM ^education AS te3"
				+ ((""==whereIn)?"))":" WHERE " + whereIn + "))");
		
		titleRU += ", по образованию";
		titleUA += ", за освітою";
		break;
*/	
	default:
		alert("Not present");		
		return false;
	}
	
	this.title = titleUA + "|" + titleRU;
}

function listSrc()
{
	this.qrySet( "Fields"
				,"b.FWID, c.FCOD, b.FTXT, a.FORIGDAT, a.FSEX, a.FWRKDAT, a.FVISLDAT, a.FINDNUM, " + strBDat   + " AS FBDAT, " + strEDat +" AS FEDAT, " 
					+ strCodDol + " AS FKOD_DOL, " + strOklad  + " AS FOKLAD, p.Finval, p.Fpens,"+strFwidOrg+" as Fwid_org "
				,"From"
				,"(^cl AS b INNER JOIN ^clrelclcl AS c ON b.FWID = c.FWID_CL) INNER JOIN ^cl_homo AS a ON b.FWID = a.FWID_CL LEFT JOIN ^persfile as p ON p.Fwid_cl=a.Fwid_cl"
				,"OrderName"
				,new Array("Сортировка по коду", "Сортировка по имени", "Сортировка по дате рождения", "Сортировка по месяцу рождения", "Сортировка по полу")
				,"Order"
				,new Array("FCOD"
				,"FTXT"
				,"FORIGDAT, FCOD"
				,(sqlMonth("FORIGDAT")+ "," +sqlDay("FORIGDAT")+ "," +sqlYear("FORIGDAT")+ ", FCOD")
				,"FSEX, FCOD")
				,"Where"
				,"c.FCL=" 
				+getPar("CODPERS")
				+" AND "
				+ strWhere
				);		

	this.clTie("dol", "="+getPar("CODDOL")+", FKOD_DOL");
	this.subTie("stru_org","org","Fwid","Fwid_org");
}

function onEditObject(ID)
{
	if (inList(ID,"ADD","EDIT","COPY","VIEW"))
	{
		var oPar = new Object();		
		
		oPar.Fvid = 3;
		oPar.tbl = this.tbl;
		
		include ("objects/DpClEx.js")
		var oCL = null 
		
		oCL = new DpClEx("CL3", getPar("CODPERS"));
		oCL.setFormFile("formpf");
		
		var ret = false;
		if(ID != "ADD")
			ret = oCL.edit(ID,this.tbl.getRowID(), oPar);			
		else
			ret = oCL.edit(ID, null, oPar);
		
		if(ret)
		{
			this.tbl.requery();
			this.tbl.findByID(oCL.getID());
			grid.refresh();	
		}		
		return;
	}
}

function listDel()
{
	if(!this.tbl.IsEmpty()	&&	this.accDel!=null	&&	this.accDel()
		&&	"-"==msgBox("c-"
			, ru("Сотрудник "+this.tbl.getValue("Ftxt")+" будет удален из справочника персонала!\nТакже будут удалены все кадровые приказы и запись в штатном расписании по данному сотруднику.\nПодтвердите удаление записи",
				"Співробітник "+this.tbl.getValue("Ftxt")+" буде вилучен з довідника персоналу!\nТакож будуть видалені усі кадрові накази та запис в штатному розкладі по даному співробітнику.\nПідтвердіть вилучення запису")
			, ru("Удаление записи", "Вилучення запису"))
		)
	{		
		//удаляем кадровые приказы, т.к. приказ может быть на несколько человек, то сперва чистим людей, а потом удаляем приказы без строк
		ExecuteSQL("DELETE FROM ^prk_in WHERE Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+sqlTo(this.tbl.getValue("Fwid"))+")");
		ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_IN")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_in as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
		ExecuteSQL("DELETE FROM ^prk_outin WHERE Fwid_in in (select Fwid from ^work_pers where Fwid_cl="+sqlTo(this.tbl.getValue("Fwid"))+")");
		ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OI")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_outin as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
		ExecuteSQL("DELETE FROM ^prk_out WHERE Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+sqlTo(this.tbl.getValue("Fwid"))+")");
		ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OUT")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_out as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
		ExecuteSQL("DELETE FROM ^prk_otp WHERE Fwid_cl="+sqlTo(this.tbl.getValue("Fwid")));
		ExecuteSQL("DELETE FROM ^cdr_prk WHERE  Fdoc="+sqlTo("CDR_OTP")+" and not EXISTS(SELECT Fwid_prk FROM ^prk_otp as i WHERE i.Fwid_prk=^cdr_prk.Fwid)");
		//удаляем записи из ШР
		ExecuteSQL("delete from ^stru_dol where Fwid in (select Fwid_dol from ^work_pers where Fwid_cl="+sqlTo(this.tbl.getValue("Fwid"))+")");
		ExecuteSQL("delete from ^work_pers where Fwid_cl="+sqlTo(this.tbl.getValue("Fwid")));
		//удаляем из справочника
		include ("objects/DpClEx.js");
		var oDoc = new DpClEx("CL3", getPar("CODPERS"));
		oDoc.del(this.tbl.getRowID());	
		this.tbl.requery();
		grid.refresh();		
	}
	return false;
}

function filterMode(s)
{
	return true;		
}

function getTblH()
{
	var h = new Object();
	h.HBDAT = gDat.dat1;
	h.HEDAT = gDat.dat2;
	return h;
}
include("sys/DpList.js");