include("Objects\\DpGrid.js");
include("Objects\\DpGetDat.js");
include("Objects\\dpEval.js");
include("Objects\\DpPrList.js");
include("sys\\dpsql.js");
include("sub\\mtr.js");
include("mtr_ost.js");


//	SERGEY: не изменять (по возможности)
if(extPar!=null && extPar.mode=="MASS")
	lpProxy.name += "_"+extPar.mode;
//	/SERGEY

var szFcena;
var oRecalc;
var fcod, fdat;

var bMass	= false; 	//находимся ли в массовом выборе
var bAsk	= false;	//запрашивать ли подтверждение на сохранение
var szFost	= "fost";	//поле для вывода остатка
var szFost1	= "fost1";
var bDynaOst = false;	//наличие динамического перерасчета остатков
var szPrice;

function listLoad()
{
	//var tbl = OpenTable("s","select * from ^cl_pri where fwid="+ list.par.fwid);
	//if (SQL)
	//	tbl.Index = "FWID";
	//tbl.Seek("=",list.par.fwid);
	
	oPri = new DpPrList(); 	
	
	if (list.par.isMass)
	{
		var cod = list.par.nk.oDoc.getPar("_pricetyp");
		var date = list.par.nk.oDoc.getVar("HDAT");
		
		var tbl = OpenTable("s", 
				"select fwid, fdat"
				+ " from ^cl_pri"
				+ " where fcod=" + sqlTo(cod)
					+ " AND fdat<=" + sqlTo(date)
				+ " order by fdat desc"
				);
			
		if (tbl.IsEOF())
		{
			alert("Прайс лист типа '" + cod + "' на дату " + format("dd.mm.yy", date) + " не найден")
			
			return false;
		}		
		
		oPri.load(tbl.getValue("fwid"));
		
		setButton(btnOk, CloseWindow);
	}
	else
		oPri.load(list.par.fwid);

	/*
	fcod = tbl.getValue("fcod");
	fdat = tbl.getValue("fdat");
		
	oRecalc = new Object();
	oRecalc.fcod 	= fcod;
	oRecalc.fdat 	= fdat;
	oRecalc.fnmkl 	= tbl.getValue("fnmkl");	
	oRecalc.fmol 	= tbl.getValue("fmol");	
	oRecalc.fpodr 	= tbl.getValue("fpodr");
	oRecalc.fsc 	= tbl.getValue("fsc");
	oRecalc.fsu 	= tbl.getValue("fsu");	
		
	/*
		проверим, если о прайсе есть запись, но
		таблицы нет - сообщим
	*/
	szPrice = String(pName(fcod, fdat, list.par.fwid));
	
	if( !IsTableEx("pr_mdb", "mtr_"+szPrice.substr(1)) )
		WAIT(ru("На эту дату отсутствует прайс-лист","На цю дату відсутній прайс-лист"));
	/*
		проверим, находимся ли мы в массовом вводе
	*/
	/*
	bMass = list.par.mode=="MASS";
	if(bMass)
		bDynaOst = list.par.mass.recallFromPrice(
			oPri.tbl.getValue("fnmkl"),
			oPri.tbl.getValue("fmol"),
			oPri.tbl.getValue("fpodr"),
			oPri.tbl.getValue("fsc"),
			oPri.tbl.getValue("fsu"));
	*/
	
	with( list )
	{
		title = ru("Прайс-лист типа " + fcod + " на дату " + StrDat(fdat,"DMY"),
					"Прайс-лист типу " + fcod + " на дату " + StrDat(fdat,"DMY"));
		if(bMass)
			title += ru(": массовый выбор",": масовий вибор");
		
		subMenuInit = oPri.menuInit;
		subMenuRun 	= oPri.menuRun;
		//subSrc 		= oPri.src;
		editTask		= "e_price.xml";
		par.grpId 	= extPar.fwid;				
	}
	
	if (list.par.isMass)
	{
		grid_nkrows.setTable(extPar.nk.getCondRows(new Object));
		if(extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_RS || extPar.nk.oDoc.getAttr("RTYPE") == RTYPE_PMR)
			list.defaultMenuID = "ADDNKROWFIFO";
		else
			list.defaultMenuID = "ADDNKROW";
		extPar.nk.loadGrid(grid_nkrows);
		
		list.onChangeRow = onChangeRow;
		grid.setSelHandler(list, "onChangeRow"); 
	}
	list.printLabel="L_PRIC";		
}

function listGetTie(sAlias, tbl)
{
/*	sAlias = sAlias.toUpperCase();
	if (sAlias == "NMK")
	{
		var pExt = tbl.ExtTie("CL_NMK");
		if (pExt != null)
			for(pExt.topField(); pExt.isField(); pExt.nextField())
				if (pExt.getInfo("ISSEARCH") == "+")
					list.dataSrc.AddSearchField(sAlias + ".#"+pExt.getInfo("LABEL"), pExt.getInfo("TXT"), getExtType(pExt.getInfo("TYPE")));
	}
*/
}

function listSrc()
{	
	with( list )
	{
	    qrySet(
			"From", szPrice,
			"Order", "fnmkl, forg, ftt DESC",
			"WhereArr", "Ftt='NM'" + ((par.zMode != "t")? "" 
						:" AND fnmkl in (SELECT fcod as fnmkl FROM ^CL_NMK "
								+"WHERE ftxts LIKE " + sqlTo(par.Ftxts + SqlStr4Like) + " )"),
			"Ptn", "PRICE"
			);
		if (par.zMode == "l")
		{
			var tmptbl = OpenTable("s", "CL_NMK", "LINECOD");
			if (SQL)
				tmptbl.index = "FLINECOD";
			//if (tmptbl.Seek(">=", par.Flinecod))
			if (tmptbl.FindFirst("FLINECOD>="+ par.Flinecod))
				par.ret.FNMKL = tmptbl.getValue("Fwid");
		}	
		if (SQL)
		{
			subTie("cl_nmk", "nmk", "fwid", "Fnmkl", null, TIE_NOSEARCH);
			subTie("cl_edi", "ed", "fcod", "nmk.Fcedib", "getTie('nmk')",TIE_NOSEARCH);			
			clTie("podr", "=" + getPar("codPodr") + ",Fpodr", "clc");
		}
		else
		{
			subTie("cl_nmk", "nmk", "fwid", "Fnmkl",null,TIE_NOSEARCH);
			subTie("cl_edi", "ed", "cod", "nmk.Fcedib","getTie('nmk')",TIE_NOSEARCH);
		}
		/*
			если идет массовый ввод, то нужно добавить
			связку для просмотра введенных значений
		*/
		if(bMass)
		{
			if (SQL)
				subTie(list.par.mass.getViewBuffer(),"mass","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
			else
				subTie(list.par.mass.getViewBuffer(),"mass","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
			if(bDynaOst)
			{
				if (SQL)
					subTie(list.par.mass.RestTable,"ost","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
				else
					subTie(list.par.mass.RestTable,"ost","Fnmkl","Fnmkl",null,TIE_NOSEARCH);
				/*
					переопределим поле для остатка
				*/
				szFost = "ost."+ list.par.mass.RestField;
				szFost1 = "ost."+ list.par.mass.RestField;
			}
		}
	}
}

function listDpGrid()
{
	/*
		если идет массовый ввод -
		поля в grid'е будут другими
	*/
	szFcena = "Fcena";
	if(bMass && extPar.mass.parentNk.getPar("_priceview")>0)
		szFcena += String( extPar.mass.parentNk.getPar("_priceview") );
	var oGrid = new DpGrid("NOCREATE");
	
	oPri.initGrid(list.par.fwid);
}


function getRowCond()
{
	var oCond = new Object;
	oCond.fnmkl = toScrObj(list.tbl.getValue("fnmkl"));
	return oCond;
}

function getTblH()
{
	var oH = new Object;
	oH.FCOD = fcod;
	oH.FDAT = new Date(fdat).getVarDate();
	
	return oH;
}

function onChangeRow()
{
	grid_nkrows.getTable().close();
	
	grid_nkrows.setTable(extPar.nk.getCondRows(getRowCond()));
	grid_nkrows.refresh();
}

include("sys\\DpList.js");