include ("prik/DpPrik.js");
include ("Objects/DpGetDat.js");
include ("prik/MenuHandler.js");
include ("Objects/DpXMLDomDocument.js");

var IsSORT = getPar("SORT_PRIK");
var GLOBAL_TABLE;
var mFproc;
var gd = new Object();
var tblName = "";
var sTableName = "";
var edit;
var moduleName;

function listLoad()
{
	if(!extPar)
	{
		extPar = new Object();
		var startPar = list.par.menuMode;
		if(startPar)
		{
			if(startPar.indexOf("/%")!=-1)
			{
				var parAr = startPar.split("/%");
				extPar.edit = parAr[0];
				extPar.fvid = Number(parAr[1]);
				extPar.fnazv = parAr[2];
			}
			else
			{
				alert(ru("Не возможно инициализировать объект extPar!", "Не можливо ініціалізувати об'єкт extPar!"),ICON_ERROR);
				return false;
			}
		}
		else
		{
			alert(ru("Не возможно инициализировать объект extPar!", "Не можливо ініціалізувати об'єкт extPar!"),ICON_ERROR);
			return false;
		}
	}
	if(extPar && extPar.GLOBAL_TABLE)
		GLOBAL_TABLE = extPar.GLOBAL_TABLE;
	else
		GLOBAL_TABLE = "^prk_all";
	var k = extPar.edit.indexOf(":");
	if(k!=-1)
	{
		edit = allt(extPar.edit.substr(k+1));
		moduleName = allt(extPar.edit.substr(0,k));
	}
	else
		edit = extPar.edit;
	if(extPar.title)
		this.title = extPar.title;
	else
		this.title = UR("Список співробітників за видом наказу|Список сотрудников по виду приказа")+" - "+extPar.fnazv;
	this.oPrik = new DpPrik(extPar.edit, extPar.fvid, this);
	this.m_prikLabel = edit;
	this.selRecordHandler = selRecordHandler;
	grid.setSelHandler(this, "selRecordHandler");
	grid.setWhen(this, "selRecordHandler");
	//gd = new DpGetDat("dD");
	//if(gd.escape == true)
	//	return false;
	if(extPar.dat1)
		gd.dat1 = extPar.dat1;
	else
		gd.dat1 = getPar("GLOBDAT1");
	if(extPar.dat2)
		gd.dat2 = extPar.dat2;
	else
		gd.dat2 = getPar("GLOBDAT2");
	this.btnChangeClick = btnChangeClick;
	setButton(butt, this, "btnChangeClick")
	setValid(TYPEPER, onChangePeriod);
	
	var nOnlyMy = Number(ReadParEx("ONLYMYPRK"));
	if (!isNaN(nOnlyMy) && nOnlyMy != 0)
		ONLYMY.checked = true;
	if(extPar.fid_prk)
		ONLYMY.checked = false;
	
	DATB.value = gd.dat1;
	DATE.value = gd.dat2;
	
	//чтобы в дальнейшем передать в l_archive.js
	extPar.dat1 = gd.dat1;
	
	this.prkList = this.oPrik.getPrikList();
	if (!this.prkList.load())
	{
		alert(ru("Выполните настройку в меню Настройки->Настройка зарплаты->Формирование перечня доплат/удержаний!",
				"Виконайте налагодження в меню Настройки->Настроювання зарплати->Формування переліку доплат/утримань!"), ICON_ERROR);
		return false;
	}
	applySetting(this.prkList.setting);	
//	if (extPar.fz6 != 0)
//	{
	/*
		var xmlPrik = new DpXMLDOMDocument();
		if (xmlPrik.load(rootDirectory() + "prik/" + edit + "/prik.xml"))
		{
			var xmlEl = xmlPrik.getDocumentElement();
			var xmlNode = xmlEl.selectSingleNode("form2");
			if (xmlNode != null)
				this.editTask = "prik/" + xmlNode.getText() + "/form2.xml";
			else
				this.editTask = "prik/" + edit + "/form2.xml";
		}
		else
		{
			this.editTask = "prik/" + edit + "/form2.xml";
		}
//	}
 	*/
 	this.editTask = this.oPrik.editXML;
	if (typeof prkLoad == "function" && !extPar.notLoad)
		return prkLoad();
	mFproc = extPar.prik;
}


function listInitEditParam(obj)
{	
	obj.dat1 = gd.dat1;
	obj.dat2 = gd.dat2;
	obj.fvid = Number(extPar.fvid); 
	obj.tblName = tblName;
	obj.priklbl = extPar.edit;
	obj.GLOBAL_TABLE = GLOBAL_TABLE;
	obj.sTableName = sTableName;
	if (typeof prkInitEditParam == "function")
		prkInitEditParam(obj);
	if (typeof this.prkList.setting.global == "object")
		obj.global = this.prkList.setting.global;
	if (typeof this.prkList.setting.form2 == "object")
		obj.form2 = this.prkList.setting.form2;		
	obj.dd = DATE.value;
	obj.fnazv = extPar.fnazv;
	obj.is_clnd = extPar.is_clnd;
}

function listSrc()
{
	this.extTie("PRK", extPar.fvid);
	
	if (typeof(prkSrc) == "function")
	{
		this.prkSrc = prkSrc;
		bRet = this.prkSrc();
		this.prkList.subTie();
		DATB.value = gd.dat1;
		DATE.value = gd.dat2;
		//если передан идентификатор приказа, то выводим только его
		if(extPar.fid_prk)
			this.qrySet("Where",this.qryAlias+".Fwid="+extPar.fid_prk)
		if(toScrObj(ONLYMY.checked))
			this.qrySet("Where",this.qryWhere+" and "+this.qryAlias+".fwid in "
				+"(select fid_doc from ^archive where upper(fmuser)=" + sqlTo(getUserName().toUpperCase()) + ")");
		return bRet;
	}
	
	if(this.prkList.buildQuery())
	{
		this.prkList.subTie();
		return true;
	}
	
	return false;
}

function accEdit()
{
	if (typeof prkAccEdit == "function")
		return prkAccEdit();
	return "AECV";
}

function listAfterLoad()
{
	if (typeof prkAfterLoad == "function")
		prkAfterLoad();
}

function listAfterEdit(ID)
{
	if (typeof prkAfterEdit == "function")
		prkAfterEdit(ID);
}

function listDel()
{
	var result = true;
	if (typeof prkDel == "function")
		result = prkDel();
	if(result === false)
		return result;
	this.oPrik = new DpPrik(extPar.edit, extPar.fvid, this);
	//для приказа _SUM_2 передаём ещё дату, содержащуюся в названии таблицы
	if(edit.toUpperCase()=="_SUM_2")
	{
		this.oPrik.loadByID(list.tbl.getValue("Fwid"),null,null,gd.dat1);
		this.oPrik.del(Number(list.tbl.getValue("FWID")),gd.dat1);
	}
	else
	{
		this.oPrik.loadByID(list.tbl.getValue("Fwid"));
		this.oPrik.del(Number(list.tbl.getValue("FWID")));
	}
	
	return result;
}

function listMassDel()
{
	var result = true;
	if (typeof prkMassDel == "function")
		result = prkMassDel();
	if(result === false)
		return result;
	var arrIds = grid.getSelectedIDs();
	//для приказа _SUM_2 передаём ещё дату, содержащуюся в названии таблицы
	this.oPrik = new DpPrik(extPar.edit, extPar.fvid, this);
	for (var i = 0; i < arrIds.length; i++)
	{
		if(edit.toUpperCase()=="_SUM_2")
			this.oPrik.del(arrIds[i],gd.dat1);
		else
			this.oPrik.del(arrIds[i]);
	}
	return result;
}

function listGrid()
{
	var xmlgrid = this.prkList.getGrid();
	grid.DeletePages();	
	grid.parseXML(xmlgrid.xmlNode);
	grid.build();
}

function listMenuInit()
{
	extPar.fin_table = list.tbl.getValue("Fin_table");
	if (typeof menuInit == "function")
		this.prkMenuInit = menuInit;
	else if (typeof prkMenuInit == "function")
		this.prkMenuInit = prkMenuInit;
	if (typeof this.prkMenuInit == "function")
		this.prkMenuInit();
	if(this.tbl.recordCount>0)
	{
		DataSource().AddMenuItem("MOVE","Переведення наказів|Перевод приказов");
		DataSource().AddMenuItem("SET_PROP","Проставити пропорцію днів/годин|Проставить пропорцию дней/часов");
		DataSource().AddMenuItem("SET_PROP_CALEND","Проставити пропорцію днів/годин по календарю|Проставить пропорцию дней/часов по календарю");
		DataSource().AddMenuItem("SET_PROP_PRK","Проставити пропорцію днів/годин по іншому наказу|Проставить пропорцию дней/часов по другому приказу");
	}
	DataSource().AddMenuItem("FLDRARCH","Архів наказів|Архив приказов");
	DataSource().AddMenuItem("DOCARCH","Історія наказу|История приказа");
}

function applySetting(setting)
{
	if(typeof setting.global == "object")
	{
		if (typeof setting.global.tblname == "string")
		{
			tblName = setting.global.tblname;
			sTableName = tblName;
			if (sTableName.indexOf("^") != -1)
				sTableName = sTableName.substring(sTableName.indexOf("^") + 1);
		}
	}
	if (typeof setting.list == "object")
	{
		if (setting.list.menuinit == true)
			moduleName?include(lpProxy.getModulePath(moduleName) + "/scripts/prik/" + edit + "/MenuInit.js"):include(rootDirectory() + "prik/" + edit + "/MenuInit.js");
	}
}

function btnChangeClick()
{
	gd.dat1 = DATB.value;
	gd.dat2 = DATE.value;
	setPar("GLOBDAT1", DATB.value);
	setPar("GLOBDAT2", DATE.value);
	this.tbl.clearQuery();
	this.tblSrc[this.tblSrcNo] = "";
	this.reLoad();
	WriteParEx("ONLYMYPRK", ONLYMY.checked?"1":"0");
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}

}

function getTblH()
{
	var o = new Object;
	o.FBDATE = toScrObj(DATB.value);
	alert(o.FBDATE);
	o.FEDATE = toScrObj(DATE.value);
}

function selRecordHandler()
{
	if (this.tm == null)
	{
		this.tm = runTimer(runViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
}

function runViews(oPar)
{
	if (!list || !list.tbl || typeof(list.tbl) == "undefined" || list.tbl.isBOF() || list.tbl.isEOF())
	{
		return;
	}
	
	var par = new Object()
	//par.fvid = extPar.fvid;
	var view = lpProxy.getView("prk");
	grid.syncRecordset();
	if (view != null)
	{
		par.IDs = Number(list.tbl.getValue("fwid"));	
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("prk", par);	
		}
	}
	
	if (typeof(prkRunViews) == "function")
	{
		list.prkRunViews = prkRunViews;
		list.prkRunViews(); 
	}
}

include ("sys\\DpList.js");