include("Objects/DpGrid.js");
include("Objects/DpAskEx.js");
include("Objects/DpEval.js");

var dat;

function listLoad()
{
	if(extPar && extPar.dat)
		dat = extPar.dat;
	else
	{
		var gd = new DpGetDat("d")
		if(gd.escape)
			return false;
		dat = gd.dat1;
	}
	this.title = ru("Лог рассылки расчетных листов за ","Лог розсилки розрахункових листів за ")+format("Mmm yyyy",dat).toLowerCase();
	if(!IsTable("mail_log"))
	{
		alert(ru("Данные отсутствуют!","Дані відсутні!"),1);
		return false;
	}
}

function listSrc()
{
	list.qrySet("From", "mail_log", "Order", "Fcodmin,Femail,Fcod");
	list.subTie("cl","cl","Fwid","Ftabn_id");
}

function listGrid()
{
	//групируем визуально по почтовым ящикам
	grid.setFilling("Femail");
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
		onePageMode(false);
		with(page())
		{
			cell("Fcod", "Таб.№", 6);
			cell("cl.Ftxt", "ПІБ|ФИО", 6);
			cell("Fnach", "Нараховано|Начислено", 8, null, DP_FORMAT_SUM);
			cell("Fuder", "Утримано|Удержано", 8, null, DP_FORMAT_SUM);
			cell("Fkvip", "До виплати|К выплате", 8, null, DP_FORMAT_SUM);
			cell("Femail", "E-mail", 15);
			cell("Fis_send", "Надіслано|Отослано", 6);
			cell("Fmphone", "Моб.тел.", 15);
			cell("Ffile", "Файл", 20);
		}
		build(); 
	}
}

function listMenuInit(oGrid)
{
	with(oGrid)
	{
		AddMenuItem("SEND_FILE","Відіслати на E-mail|Отослать на E-mail");
		AddMenuItem("+++","SMS повідомлення|SMS сообщения");
			AddMenuItem("MAKE_SMS","Сформувати SMS|Сформировать SMS");
			AddMenuItem("VIEW_SMS_LOG","Лог SMS|Лог SMS");
		AddMenuItem("---");
		AddMenuItem("OPEN_FILE","Відкрити файл розрахункового листа|Открыть файл расчетного листа");
	}
}

function listMenuRun(ID, oGrid)
{
	switch(ID)
	{
		case "SEND_FILE":
			var topic = /*ru("Расчетный лист за ","Розрахунковий лист за ")*/"zarplata "+format("mm/yyyy",dat);
			var msg = ReadParEx("MSG");
			var oAsk = new DpAskEx();
			oAsk.useDefsOnly = true;
			oAsk.add("T","Тема","TOPIC",topic,255);
			oAsk.add("T0","Повідомлення|Сообщение","MSG","",500,60);
			oAsk.add("COMBO","Кодування|Кодировка","ENCOD",getPar("MAIL_ENCODING"),"cp1251|cp866|utf8|latin1|KOI8-R",true);
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			topic = java.lang.String(java.lang.String(oAsk.get("TOPIC")).getBytes(oAsk.get("ENCOD")));
			msg = java.lang.String(java.lang.String(oAsk.get("MSG")).getBytes(oAsk.get("ENCOD")));
			WriteParEx("MSG",msg);
			setPar("MAIL_ENCODING",oAsk.get("ENCOD"));
			var t = OpenTable("select Femail,Ffile from mail_log where Fwid "+DataSource().sqlSelected(true)+" group by Femail,Ffile");
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, ru("Рассылка: ","Розсилання: ")+t.getValue("Femail")+" ("+t.bookmark+"/"+t.rowCount+")");
				var ok = false;
				if(isFile(t.getValue("Ffile")))				
					ok = sendMailMsg(topic, msg, t.getValue("Femail"), t.getValue("Ffile"), true);
				else
				{
					setProgressPos(0);
					alert(ru("Не удалось найти файл","Не вдалося знайти файл")+"\n"+t.getValue("Ffile"),1);
					setProgressPos(t.bookmark, ru("Рассылка: ","Розсилання: ")+t.getValue("Femail")+" ("+t.bookmark+"/"+t.rowCount+")");
				}
				var m = new Object();
				m.Fis_send = ok;
				UpdateTable("mail_log", m, false, "Femail="+sqlTo(t.getValue("Femail")));
			}
			this.tbl.requery();
   			grid.RefreshGrid();
			setProgressPos(0);
			t.close();
		break;
		case "MAKE_SMS":
			if(getPar("SMS_OZEKI_OUT")==null)
			{
				alert(ru("Отсутствует модуль sms_ozeki","Відсутній модуль sms_ozeki"),1);
				return false;
			}
			if(!isDir(getPar("SMS_OZEKI_OUT")))
			{
				var msg = ru("Не существующая директория указана в меню '","Не існуюча директорія вказана в меню '")+getParItemPath("SMS_OZEKI_OUT",true)+"'";
				alert(msg,1);
				return false;
			}
			var fld = new Object();
			fld.fwid = "counter";
			fld.femail = "text";
			fld.fmphone = "text";
			fld.ftabn_id = "long";
			fld.fis_send = "bit";
			fld.fcod = "long";
			fld.Fcodmin = "long";
			fld.fmsg = "longtext";
			fld.fnach = "double";
			fld.fuder = "double";
			fld.fkvip = "double";
			CreateTable("sms_log", fld);
			var msg = ReadParEx("MSG");
			var lang = ReadParEx("LANG");
			//if(allt(msg)=="")
				msg = UR("Розрахунковий лист за {DATE} надіслано на {FEMAIL}. Нараховано: {FNACH}, утримано: {FUDER}, до видачі: {FKVIP}|Расчетный лист за {DATE} выслан на {FEMAIL}. Начислено: {FNACH}, удержано: {FUDER}, к выдаче: {FKVIP}");
			if(allt(lang)=="")
				lang = getPar("LANGUAGE")?"rus":"ukr";
			var oAsk = new DpAskEx();
			oAsk.useDefsOnly = true;
			oAsk.add("REM","Вирази для використання в повідомленні: \n\t{FNACH}\t- всього нараховано;\n\t{FUDER}\t- всього утримано;\n\t{FKVIP}\t- всього до видачі;\n\t{DATE}\t- місяць розрахунку;\n\t{FEMAIL}\t- E-mail|Выражения для использования в сообщении:\n\t{FNACH}\t- всего начислено;\n\t{FUDER}\t- всего удержано;\n\t{FKVIP}\t- всего к выдачи;\n\t{DATE}\t- месяц расчета;\n\t{FEMAIL}\t- E-mail","LBL");
			oAsk.add("T0","Повідомлення|Сообщение","MSG",msg,200,60);
			oAsk.add("COMBO","Мова повідомлення|Язык сообщения","LANG",lang,"rus|ukr|eng",true);
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			msg = oAsk.get("MSG");
			lang = oAsk.get("LANG");
			WriteParEx("MSG",msg);
			WriteParEx("LANG",lang);
			msg = translit(msg, oAsk.get("LANG"));
			//обрабатываем выражение для DpEval
			var k = 0;
			msg = "'"+msg+"'";
			while(msg.indexOf("{")!=-1 || msg.indexOf("]")!=-1)
			{
				msg = msg.replace("{","'+").replace("}","+'");
				if(k++>1000)//на всякий случай защита от вечного цикла
					break;
			}
			var t = OpenTable("select * from mail_log where Fwid "+DataSource().sqlSelected(true));
			
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, ru("Формирование sms сообщений: ","Формування sms повідомлень: ")+t.bookmark+"/"+t.rowCount);
				var oEval = new DpEval();
				oEval.setTable(t);
				oEval.addVar("DATE", format("mm/yyyy",dat)); 
				var sms = oEval.eval(msg);
				var m = new Object();
				m.Fmsg = sms;
				m.Femail = t.getValue("Femail");
				m.Fmphone = t.getValue("Fmphone");
				m.Ftabn_id = t.getValue("Ftabn_id");
				m.Fcod = t.getValue("Fcod");
				m.Fcodmin = t.getValue("Fcodmin");
				m.Fnach = t.getValue("Fnach");
				m.Fuder = t.getValue("Fuder");
				m.Fkvip = t.getValue("Fkvip");
				UpdateTable("sms_log", m, true);
			}
			var par = new Object();
			par.dat = dat;
			showWindow("l_rasl_sms.js",SW_NOMODAL,par);
			setProgressPos(0);
			t.close();
		break;
		case "VIEW_SMS_LOG":
			var par = new Object();
			par.dat = dat;
			showWindow("l_rasl_sms.js",SW_NOMODAL,par);
		break;
		case "OPEN_FILE":
			var t = OpenTable("select * from mail_log where Fwid "+DataSource().sqlSelected(true));
			for(; !t.IsEOF(); t.MoveNext())
			{
				if(isFile(t.getValue("Ffile")))
					shellOpen(t.getValue("Ffile"));
				else
					alert(ru("Не удалось найти файл","Не вдалося знайти файл")+"\n"+t.getValue("Ffile"),1);
			}
			t.close();
		break;
	}
}

include("sys/DpList.js");