//расчёт платёжной ведомости
include("Objects/DpAskEx.js");
include("get_cnst.js");
include("prik/calculate/r_raslsd.js");
include("servis/date.js");
include("servis/format.js");
include("Objects/DpTVars.js");
include("gridedit.js");
include("Objects/DpGetDat.js");

var par = new Object();
var prnPatt_v = "l_ved";
var prnPatt_l = "ved_ls";
var prnPatt_lp = "ved_lp";
var prnPatt_ord = "p_ord";
var tblFOut;
var D1, D2;

function listLoad()
{
	with(this)
	{
   		title = ru("Просмотр платежной ведомости","Перегляд платіжної відомості");
   		xmlGridFile = getPar("TABNORG")?"r_raslsd2.xml":"r_raslsd.xml";
   		printLabel = "L_VED";
   	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
  	
   	menuMode = GetMenuMode();
   	if(menuMode.toUpperCase() != "VIEW")
    	r_raslsd(extPar);
    
    tblFOut="FOUT";	//создание выходной таблицы
	DropTable(tblFOut);
	if(menuMode.toUpperCase() == "VIEW")
	{
		var gd = new DpGetDat("d");
		D1 = new Date(gd.dat1);
		D2 = new Date(gd.dat2);
	}
	else
	{
		D1 = new Date(extPar.dat1);
		D2 = new Date(extPar.dat2);
	}
	tblOut = "rasl_e"+getDateTag(D1);
	if(!IsTable(tblOut))
	{
		alert(ru("Сначала произведите расчет!","Спочатку виконайте розрахунок!"));
		return false;
	}
	D2 = new Date(lastDayMonth(D1));
	this.title += " за "+format("dd.mm.yyyy",D1)+(extPar && extPar.fwid?" по '"+getTxtOrgByID(extPar.fwid)+"'":"");
	
	strSQL = " select distinct tb.Fwid, tb.Ftabn_id, tb.Fnach, tb.Fuder, tb.Fkvip, h.Findnum AS Fpercod, h.Femail, "
		+ "	sd.Fwid_org, wp.Fid, wp.Ftabnorg, r.Fcod, cl.Ftxt"
	 		+ " INTO " + tblFOut + " FROM "
	 		+ " ((((( " + tblOut + " tb LEFT JOIN (^work_pers wp right join "
			+"(select max(fwid) as fwid,Fwid_cl from ^work_pers WHERE Fbdat <="+sqlTo(D2)+" AND Fedat >= "+sqlTo(D1)
					+" AND FISMAIN = "+sqlTrue			
			+" group by Fwid_cl ) wp1 on wp1.Fwid=wp.Fwid)  ON tb.Ftabn_id=wp.Fwid_cl) "
	 		+ " INNER JOIN ^stru_dol sd ON wp.Fwid_dol=sd.Fwid) "
	 		+ " INNER JOIN ^cl_homo h ON h.Fwid_cl=tb.Ftabn_id) "
	 		+ " INNER JOIN ^clrelclcl r ON r.Fwid_cl=tb.Ftabn_id) "
	 		+ " INNER JOIN ^cl cl ON r.Fwid_cl=cl.Fwid) "
	 		//+ " WHERE wp.Fbdat <="+sqlTo(D2)+" AND wp.Fedat >= "+sqlTo(D1) 		
	ExecuteSQL(strSQL);
}

function listSrc()
{
	with(this)
	{
		qrySet("From", "FOUT", 
				"Order", new Array("Fcod","Ftxt"),
				"OrderName", new Array("Сортувати по таб.№|Сортировать по таб.№","Сортувати по ПІБ|Сортировать по ФИО"));
		subTie("cl","x_cl","Fwid","Ftabn_id");
	}	
}

function listMenuInit()
{
	list.dataSrc.AddMenuItem("PRINT_P","Друк розрахункових листів (з перенесенням)|Печать расчётных листов (с переносом)",9);
    list.dataSrc.AddMenuItem("PRINT_S","Друк скорочених розрахункових листів (з перенесенням)|Печать сокращённых расчётных листов  (с переносом)",9);
	//Tori 2008.05.23 не рабочие закоментировал
	//list.dataSrc.AddMenuItem("PRINT_V","Печать ведомостей");
	//list.dataSrc.AddMenuItem("PRINT_L","Печать расчётных листов");
	list.dataSrc.AddMenuItem("PRINT_L_LG","Друк розрахункових листів (скор.)|Печать расчётных листов(сокр)",9);
	//list.dataSrc.AddMenuItem("PRINT_LP","Печать расчётных листов за период");
	//list.dataSrc.AddMenuItem("PRINT_LP_LG","Печать расчётных листов за период(сокр)");
	//list.dataSrc.AddMenuItem("PRINT_RL","Печать расчётных листов(две кол)");
	//list.dataSrc.AddMenuItem("PRINT_ORD","Печать кассовых ордеров");
	list.dataSrc.AddMenuItem("+++","Надіслати розрахункові листи поштою|Отослать расчетные листы по почте");
		list.dataSrc.AddMenuItem("SEND_S","Формування листів|Формирование листов");
		list.dataSrc.AddMenuItem("VIEW_LOG","Лог останнього формування|Лог последнего формирования");
	list.dataSrc.AddMenuItem("---");
}

function listMenuRun(ID)
{
	this.objParMenu.dat1 = D1;
	
	var lv1,lv2,lv3,lv4;
	if (extPar==null){
		lv1 = 0;
		lv2 = 0;
		lv3 = 0;
		lv4 = 0;
	}else{
		lv1 = extPar.lv1;
		lv2 = extPar.lv2;
		lv3 = extPar.lv3;
		lv4 = extPar.lv4;
	}
	
	var szTag;
//	var D1 = javaDate2Script(D1); // дата начала
	//var D2 = javaDate2Script(D2); // дата конца
	// достаем цифры к названию файла
	if (D1.getMonth() < 9)  
		szTag = String(javaDate2Script(D1).getFullYear()) + "0"+String(javaDate2Script(D1).getMonth()+1);
	else
		szTag = String(javaDate2Script(D1).getFullYear()) + String(javaDate2Script(D1).getMonth()+1);
	
	var d = DataSource();
	var t = d.getTable();
	switch(ID)
	{
		case "PRINT_V":
		var nVed=Number(input("№ расчётной ведомости", "Печать", "",5,0));
		if (!nVed)
			break;
		var d_b_zrp=new Date(today.getFullYear(), today.getMonth(), 1);
		var d_e_zrp=new Date(today.getFullYear(), today.getMonth(), 1);
		var d1 = input("Начало выдачи зарплаты", "Печать", d_b_zrp.getVarDate());
		if (d1==null)
			break;
		var d2 = input("Окончание выдачи зарплаты", "Печать", d_e_zrp.getVarDate());
		if (d2==null)
			break;
		d_b_zrp=new Date(d1);
		d_e_zrp=new Date(d2);

		var doptab;
		doptab=OpenTable("s","SHTAT");
		var nazv_p1,nazv_p2,nazv_p3,nazv_p4;
		var nazv_org;
		nazv_p1="";
		nazv_p2="";
		nazv_p3="";
		nazv_p4="";

		doptab.index="shtat";
		if (SQL)
			doptab.index="FLV1,FLV2,FLV3,FLV4,FKOD_DOL,FTABN_ID,FID";
		if (!doptab.Seek("=",lv1,lv2,lv3,lv4,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_p4=doptab("Fnazv_podr");

		if (!doptab.Seek("=",lv1,lv2,lv3,0,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_p3=doptab("Fnazv_podr");

		if (!doptab.Seek("=",lv1,lv2,0,0,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_p2=doptab("Fnazv_podr");

		if (!doptab.Seek("=",lv1,0,0,0,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_p1=doptab("Fnazv_podr");

		if (!doptab.Seek("=",0,0,0,0,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_org=doptab("Fnazv_podr");

		strSQL = "select * from fout where Fkvip<>0 " + (DataSource().selected ? " and " + DataSource().sqlSelected() : "") + " order by FTABN_ID" ;
		tblprn = OpenTable("m",strSQL);
		tblprn.tie("fout"+szTag,"fout","FTABN_ID","FTABN_ID");
		//tbl.tie("CLRELCLCL","REL","clcod","="+getPar("CODPERS")+",FTABN_ID");
		clTie(tblprn,"REL","="+getPar("CODPERS")+",FTABN_ID");
		tblprn.tie("CL_HOMO","HOMO","FWID_CL","CLREL.FWID_CL");

		var tv = new DpTVars(prnPatt_v);
		var bm = tbl.bookmark;
		var h = new Object();
		h.FN_VED =nVed;
		h.FBD_ZP = d_b_zrp;
		h.FED_ZP = d_e_zrp;
		h.FLV1 = lv1;
		h.FLV2 = lv2;
		h.FLV3 = lv3;
		h.FLV4 = lv4;
		h.FNAZ_P1 = nazv_p1;
		h.FNAZ_P2 = nazv_p2;
		h.FNAZ_P3 = nazv_p3;
		h.FNAZ_P4 = nazv_p4;
		h.FNAZ_OR = nazv_org;
		h.FBDAT = D1;
		h.FEDAT = D2;
		tv.setHTbl(h);
		tv.setRTbl(tblprn);
		tv.print();
		tbl.bookmark = bm;
		doptab.Close();
		break;
		case "PRINT_L":
		//------создаём нужные таблицы для печати расчётных листов------
		var szTbl="SVZP"+szTag;

		CreateTable("tmp_rlst1", "rlst", "tabn");
		CreateTable("tmp_rlst2", "rlst", "tabn");

		strSQL =
			"INSERT INTO tmp_rlst1 (" + GetPatternIntersection("SVZP","SVZP").toUpperCase().replace(",FWID","") + ",Ftxt) "
			+ " SELECT " + GetPatternIntersection("SVZP","SVZP", "a").toUpperCase().replace(",A.FWID,","") + ",b.Ftxt"
			+ " FROM (fout"
				+ " LEFT JOIN ^" + szTbl + " a"
				+ " ON fout.FTABN_ID=a.FTABN_ID)"
				+ " LEFT JOIN ^lic_fld b"
				+ " ON b.fid=a.flsfid"
			+ " WHERE "+ SqlCmpTrue
/*				+ ((lv1==0)?(" "):(" AND fout.flv1 = " + sqlTo(lv1)))
				+ ((lv2==0)?(" "):(" AND fout.flv2 = " + sqlTo(lv2)))
				+ ((lv3==0)?(" "):(" AND fout.flv3 = " + sqlTo(lv3)))
				+ ((lv4==0)?(" "):(" AND fout.flv4 = " + sqlTo(lv4)))
*/
		if (!IsTable(DataSource().PlusName)) return;

		strSQL =
			"INSERT INTO tmp_rlst1(" + GetPatternIntersection("SVZP","SVZP").toUpperCase().replace(",FWID","") + ",Ftxt) "
			+ " SELECT " + GetPatternIntersection("SVZP","SVZP", "a").toUpperCase().replace(",A.FWID","") + ",b.Ftxt"
			+ " FROM ((" + DataSource().PlusName + " p"
				+ " LEFT JOIN fout ON p.fwid_=fout.fwid)"
				+ " LEFT JOIN ^" + szTbl + " a"
				+ " ON fout.FTABN_ID=a.FTABN_ID)"
				+ " LEFT JOIN ^lic_fld b"
				+ " ON b.fid=a.flsfid"
			+ " WHERE "+SqlCmpTrue
/*				+ ((lv1==0)?(" "):(" AND fout.flv1 = " + sqlTo(lv1)))
				+ ((lv2==0)?(" "):(" AND fout.flv2 = " + sqlTo(lv2)))
				+ ((lv3==0)?(" "):(" AND fout.flv3 = " + sqlTo(lv3)))
				+ ((lv4==0)?(" "):(" AND fout.flv4 = " + sqlTo(lv4)))
*/
		ExecuteSQL(strSQL);
		strSQL =
			"INSERT INTO tmp_rlst2 (FBDY,FDAY,FCHAS,FEDY,FFLD_NUM,FID_PRK,FIS_DAY,FIS_SLCT,FLSFID,FMN,FSUM,FTABN_ID,FTPS,FVID_PRK,FVP) "
			+ " SELECT min(a.fbdy) as FBDY"
				+ ", min(a.fday) as FDAY"
				+ ", min(a.fchas) as FCHAS"
				+ ", min(a.fedy) as FEDY"
				+ ", -1 as FFLD_NUM"
				+ ", min(a.fid_prk) as FID_PRK"
				+ ", " + First("a.fis_day") + " as FIS_DAY"
				+ ", " + First("a.fis_slct") + " as FIS_SLCT"
				+ ", min(a.flsfid) as FLSFID"
				+ ", min(a.fmn) as FMN"
				+ ", min(a.fsum) as FSUM"
				+ ", a.FTABN_ID as FTABN_ID"
				+ ", 1 as FTPS"
				+ ", min(a.fvid_prk) as FVID_PRK"
				+ ", min(a.fvp) as FVP"
			+ " FROM tmp_rlst1 a"
			+ " GROUP BY FTABN_ID";
		ExecuteSQL(strSQL);

		strSQL="INSERT INTO tmp_rlst1 " + getColumn("tmp_rlst2",true) + 
				" SELECT " + getColumn("tmp_rlst2",false) + " FROM tmp_rlst2";
		ExecuteSQL(strSQL);
		//----------------------------------------------------------------

		var tab = OpenTable("tmp_rlst1");

		tab.tie("fout"+szTag,"fout","FTABN_ID","FTABN_ID");

/*		tab.tie("SHTAT","SHT_P","SHTAT","fout.FLV1,fout.FLV2,fout.FLV3,fout.FLV4,=0,=0,=0");
		tab.tie("CLRELCLCL","REL","clcod","="+getPar("CODPERS")+",FTABN_ID");
		tab.tie("CL_HOMO","HOMO","FWID_CL","REL.FWID_CL");
*/
		tab.MoveFirst();

		var tv = new DpTVars(prnPatt_l);
		var bm = tab.bookmark;
		var h = new Object();
		h.FBDAT = D1;
		tv.setHTbl(h);
		tv.setRTbl(tab);
		tv.print();
		tab.bookmark = bm;

		break;
		case "PRINT_LP":
		//------производим расчёт ---------------------------------------

		gd = new DpGetDat("dD");
		if (gd.escape)
		{
			CloseWindow();
			return;
		}
		var dat_beg = new Date(gd.dat1);
		var dat_end = new Date(gd.dat2);

		dat_beg.setDate(1);
		dat_end.setDate(1);

		var dat_now =new Date(dat_beg.getVarDate());
		var str_month="";
		var par = new Object();
		var all_month = true;
		var no_month = true;

		CreateTable("fout_eall", "fout_e", "*");

		while (dat_now.getVarDate()<=dat_end.getVarDate())
		{
			par.spLS = true;
			par.svzp_t = true;
			par.svzp_noempty = true;
			r_raslsd(dat_now,par);

			if (!par.spLS)
				break;

			if (!par.svzp_t)
			{
				str_month = str_month+(all_month?"":", ")+month_txtP(dat_now);
				all_month = false;
			}
			else
			{
				no_month = false;
				strSQL = "INSERT INTO fout_eall "+ getColumn("fout_e"+month_txt(dat_now),true) +
							" SELECT " + getColumn("fout_e"+month_txt(dat_now),false) + " FROM fout_e"+month_txt(dat_now);
				ExecuteSQL(strSQL);
			}

			dat_now.setMonth(dat_now.getMonth()+1);
		}
		if (!par.spLS)
			break;

		if (no_month)
		{
			alert("За жоден мiсяць з указаного вами перiоду \n не виконано розрахунок ЗП");
			break;
		}
		else if (!all_month)
			alert("За наступнi мiсяцi з указаного вами перiоду: \n "+str_month+" \n не виконано розрахунок ЗП");


		//------создаём нужные таблицы для печати расчётных листов ------

		var dat_now2 = new Date(dat_beg.getVarDate());

		CreateTable("tmp_rlstp1", "rlstp", "*");
		CreateTable("tmp_rlstp2", "rlstp", "*");
		CreateTable("tmp_rlstp",  "rlstp", "*");

		while (dat_now2.getVarDate()<=dat_end.getVarDate())
		{
			var szTagp = month_txt(dat_now2);
			var szTbl="SVZP"+szTagp;

			if (IsTableEx("zrp_res", "zrp_"+szTbl))
			{
				strSQL = "INSERT INTO tmp_rlstp ("+GetPatternIntersection("SVZP","SVZP").toUpperCase().replace(",FWID","") + ",Ftxt,Fdatar) "+
						"SELECT " + GetPatternIntersection("SVZP","SVZP", "a").toUpperCase().replace(",A.FWID","") + ",b.Ftxt, "+sqlTo(dat_now2)+" AS Fdatar "+
						"FROM ^"+szTbl+" a, ^LIC_FLD b "+
						"WHERE a.FTABN_ID in "+
						"(SELECT DISTINCT FTABN_ID FROM fout_e"+szTagp+
						" WHERE "+SqlCmpTrue+
/*						((lv1==0)?(" "):(" AND flv1 = " + sqlTo(lv1))) +
						((lv2==0)?(" "):(" AND flv2 = " + sqlTo(lv2))) +
						((lv3==0)?(" "):(" AND flv3 = " + sqlTo(lv3))) +
						((lv4==0)?(" "):(" AND flv4 = " + sqlTo(lv4))) +
*/						") "+
						"AND a.flsfid=b.fid ";
				ExecuteSQL(strSQL);
			}
			dat_now2.setMonth(dat_now2.getMonth()+1);
		}

		strSQL = "INSERT INTO tmp_rlstp1 (FBDY,FDAY,FCHAS,FEDY,FFLD_NUM,FID_PRK,"+
					"FIS_DAY,FIS_SLCT,FLSFID,FMN,FTPS2,FSUM,FTABN_ID,FDATAR,FTPS1,FVID_PRK,FVP) " + 
					"SELECT min(a.fbdy) as FBDY, min(a.fday) as FDAY, min(a.fchas) as FCHAS, "+
					"min(a.fedy) as FEDY, min(a.ffld_num) as FFLD_NUM, min(a.fid_prk) as FID_PRK, "+
					"" + First("a.fis_day") + " as FIS_DAY, " + First("a.fis_slct") + " as FIS_SLCT, min(a.flsfid) as FLSFID, "+
					"min(a.fmn) as FMN, min(a.ftps2) as FTPS2, min(a.fsum) as FSUM, "+
					"a.FTABN_ID as FTABN_ID,a.fdatar as FDATAR, 1 as FTPS1, min(a.fvid_prk) as FVID_PRK, min(a.fvp) as FVP "+
					"FROM tmp_rlstp a "+
					"GROUP BY FTABN_ID, FDATAR";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO tmp_rlstp2 (FBDY,FDAY,FCHAS,FEDY,FFLD_NUM,FID_PRK,"+
					"FIS_DAY,FIS_SLCT,FLSFID,FMN,FSUM,FDATAR,FTABN_ID,FTPS1,FTPS2,FVID_PRK,FVP) " + 
					"SELECT min(a.fbdy) as FBDY, min(a.fday) as FDAY, min(a.fchas) as FCHAS, "+
					"min(a.fedy) as FEDY, min(a.ffld_num) as FFLD_NUM, min(a.fid_prk) as FID_PRK, "+
					"" + First("a.fis_day") + " as FIS_DAY, " + First("a.fis_slct") + " as FIS_SLCT, min(a.flsfid) as FLSFID, "+
					"min(a.fmn) as FMN, min(a.fsum) as FSUM, min(a.fdatar) as FDATAR, "+
					"a.FTABN_ID as FTABN_ID, min(a.ftps1) as FTPS1, 1 as FTPS2, min(a.fvid_prk) as FVID_PRK, min(a.fvp) as FVP "+
					"FROM tmp_rlstp a "+
					"GROUP BY FTABN_ID";
		ExecuteSQL(strSQL);

		strSQL="INSERT INTO tmp_rlstp" + getColumn("tmp_rlstp1",true) + 
						" SELECT " + getColumn("tmp_rlstp1",false) + " FROM tmp_rlstp1";
		ExecuteSQL(strSQL);

		strSQL="INSERT INTO tmp_rlstp" + getColumn("tmp_rlstp2",true) + 
						" SELECT " + getColumn("tmp_rlstp2",false) + " FROM tmp_rlstp2";
		ExecuteSQL(strSQL);

		//----------------------------------------------------------------

		var tab;
		if (SQL)
			tab = OpenTable("m","select * from tmp_rlstp order by FTABN_ID,FDATAR,FFLD_NUM,FTPS2 DESC,FTPS1 DESC");
		else
			tab = OpenTable("m","tmp_rlstp");

		if (SQL)
			{
			tab.tie("RASL_EALL","RALL","FTABN_ID,FDATAR","FTABN_ID,FDATAR");
			tab.tie("SHTAT","SHT_P","FLV1,FLV2,FLV3,FLV4,FKOD_DOL,FTABN_ID,FID","RALL.FLV1,RALL.FLV2,RALL.FLV3,RALL.FLV4,=0,=0,=0");
			tab.tie("CLRELCLCL","REL","FCL,FCOD","="+getPar("CODPERS")+",FTABN_ID");
			}
			else
			{
			tab.tie("RASL_EALL","RALL","FDATAR","FTABN_ID,FDATAR");
			tab.tie("SHTAT","SHT_P","SHTAT","RALL.FLV1,RALL.FLV2,RALL.FLV3,RALL.FLV4,=0,=0,=0");
			tab.tie("CLRELCLCL","REL","clcod","="+getPar("CODPERS")+",FTABN_ID");
			}    
		tab.tie("CL_HOMO","HOMO","FWID_CL","REL.FWID_CL");

		tab.index="tabd";
		if (SQL)
			tab.index="FTABN_ID,FDATAR,FFLD_NUM,FTPS2 DESC,FTPS1 DESC";
		if (!tab.IsEmpty())
			tab.MoveFirst();

		var tv = new DpTVars(prnPatt_lp);
		var bm = tab.bookmark;
		tv.setRTbl(tab);
		tv.setVar("HBDAT", dat_beg);
		tv.setVar("HEDAT", dat_end);
		tv.print()
		tab.bookmark = bm;

		break;

		case "PRINT_L_LG":
		//------создаём нужные таблицы для печати расчётных листов------
		var szTbl="SVZP"+szTag;

        var tmpTbl = "rasch_papers";
        ExecuteSQL("drop table "+tmpTbl, false);
        if(IsTable(tmpTbl))
        	ExecuteSQL("delete from "+tmpTbl);
        else
        {
        	//DropTable(tmpTbl)
        	ExecuteSQL("create table "+tmpTbl+" (Ftabn_id "+sqlType("LONG")
        		+",Foklad "+sqlType("DOUBLE")
        		+",Fvopl "+sqlType("INT")
        		+",Fnzv_vopl "+sqlType("TEXT")
        		+",Fwid "+sqlType("LONG")
        		+",Ftabn "+sqlType("LONG")
        		+",Ftxt "+sqlType("TEXT")
        		+",Fdoltxt "+sqlType("TEXT")
        		+",Forgtxt "+sqlType("TEXT")
        		+",Ftps "+sqlType("INT")
        		+",Fsum "+sqlType("DOUBLE")
        		+",Fpr "+sqlType("INT")
        		+",Fday "+sqlType("INT")
        		+",Fchas "+sqlType("INT")
        		+",Fis_day "+sqlType("INT")
        		+",Fvp "+sqlType("INT")
        		+",Fvid_prk "+sqlType("INT")
        		+",Fshpz "+sqlType("TEXT")
        		+",Ffld_num "+sqlType("INT")
        		+",Fmn "+sqlType("DATE")
        		+",Fcoddol "+sqlType("LONG")
        		+",Fleftkey "+sqlType("INT")
        		+",Fwrkdat "+sqlType("DATE")
        		+",FPROC "+sqlType("DOUBLE")				
        		+")");
        }
        
//		ExecuteSQL("SELECT wp.fwid_cl as Ftabn_ID, sd.Foklad, cv.Fvopl, cv.Fnzv_vopl, wp.Fwid, rel.Fcod as Ftabn, cw.Ftxt, cd.Ftxt AS Fdoltxt, so.Ftxt as Forgtxt "
//		        + ", 1 as FTPS, "+Convert(0,"DBL")+" as fsum, 0 AS Fpr, 0 AS fday, 0 AS fchas, 0 AS Fis_day, 0 AS Fvp, 0 AS Fvid_prk, " 
//		        + Convert("0","NVC") + " AS fshpz, 0 as Ffld_num, "+sqlTo(d00)+" AS Fmn , rdol.Fcod AS Fcoddol,so.Fleftkey "
//			+ " INTO " + tmpTbl
//		        + " FROM ^work_pers AS wp "
//				+ " INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
//				+ " INNER JOIN ^clrelclcl as rdol ON sd.Fwid_cl=rdol.Fwid_cl "
//				+ " INNER JOIN ^cl_vopl AS cv ON wp.Fvopl=cv.Fvopl "
//				+ " INNER JOIN ^clrelclcl AS rel ON rel.Fwid_cl=wp.Fwid_cl "
//				+ " INNER JOIN ^cl AS cw ON cw.Fwid=wp.Fwid_cl "
//				+ " INNER JOIN ^cl AS cd ON cd.Fwid=sd.Fwid_cl "
//				+ " INNER JOIN ^stru_org AS so ON so.Fwid=sd.Fwid_org "
//			+ " WHERE "
//			+ " wp.fwid in (SELECT MAX(wp2.Fwid) FROM ^work_pers as wp2 INNER JOIN FOUT as f ON wp2.Fwid_cl=f.Ftabn_id WHERE f.Fwid " + DataSource().sqlSelected(true) + " GROUP BY wp2.Fwid_cl)"
//			+ " AND cv.Fgroup="+sqlTrue
//			+ " AND rdol.Fcl="+getPar("CODDOL")
//			+ " AND rel.Fcl="+getPar("CODPERS")
//			+ " AND (wp.fbdat<=" + sqlTo(D2) + " AND wp.fedat>=" + sqlTo(D1) + ")");
		ExecuteSQL("INSERT INTO " + tmpTbl + " (Ftabn_id,Foklad,Fvopl,Fnzv_vopl,Fwid,Ftabn,Ftxt,Fdoltxt,Forgtxt,Ftps,"
					+"Fsum,Fpr,Fday,Fchas,Fis_day,Fvp,Fvid_prk,Fshpz,Ffld_num,Fmn,Fcoddol,Fleftkey,Fwrkdat)"
				+"SELECT wp.fwid_cl as Ftabn_ID, sd.Foklad, cv.Fvopl, cv.Fnzv_vopl, wp.Fwid, rel.Fcod as Ftabn, cw.Ftxt, cd.Ftxt AS Fdoltxt, so.Ftxt as Forgtxt "
		        + ", 1 as FTPS, "+Convert(0,"DBL")+" as fsum, 0 AS Fpr, 0 AS fday, 0 AS fchas, 0 AS Fis_day, 0 AS Fvp, 0 AS Fvid_prk, " 
		        + Convert("0","NVC") + " AS fshpz, 0 as Ffld_num, "+sqlTo(d00)+" AS Fmn , rdol.Fcod AS Fcoddol,so.Fleftkey, h.Fwrkdat "
		        + " FROM ^work_pers AS wp "
				+ " INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
				+ " INNER JOIN ^clrelclcl as rdol ON sd.Fwid_cl=rdol.Fwid_cl "
				+ " INNER JOIN ^cl_vopl AS cv ON wp.Fvopl=cv.Fvopl "
				+ " INNER JOIN ^clrelclcl AS rel ON rel.Fwid_cl=wp.Fwid_cl "
				+ " INNER JOIN ^cl AS cw ON cw.Fwid=wp.Fwid_cl "
				+ " INNER JOIN ^cl AS cd ON cd.Fwid=sd.Fwid_cl "
				+ " INNER JOIN ^stru_org AS so ON so.Fwid=sd.Fwid_org "
				+ " INNER JOIN ^CL_HOMO AS h ON wp.fwid_cl=h.Fwid_cl "				
			+ " WHERE "
			+ " wp.fwid in (SELECT MAX(wp2.Fwid) FROM ^work_pers as wp2 INNER JOIN FOUT as f ON wp2.Fwid_cl=f.Ftabn_id "
						+" WHERE f.Fwid " + DataSource().sqlSelected(true) + " AND wp2.fbdat<=" + sqlTo(toScrObj(D2)) + " AND wp2.fedat>=" + sqlTo(toScrObj(D1)) + " GROUP BY wp2.Fwid_cl)"
			+ " AND cv.Fgroup="+sqlTrue
			+ " AND rdol.Fcl="+getPar("CODDOL")
			+ " AND rel.Fcl="+getPar("CODPERS")
			+ " AND (wp.fbdat<=" + sqlTo(toScrObj(D2)) + " AND wp.fedat>=" + sqlTo(toScrObj(D1)) + ")");
			
        ExecuteSQL("INSERT INTO " + tmpTbl + " (Ftabn_ID, Ftabn, Fcoddol, Fleftkey, FTPS, fsum, Fpr, fday, fchas, Fis_day, Fvp, Fvid_prk, Ftxt, Ffld_num, Fmn, Fwrkdat, FPROC) "
            + " SELECT a.Ftabn_ID, r.Ftabn, r.Fcoddol, r.Fleftkey, 0, a.fsum, a.Fpr, a.fday, a.fchas, a.Fis_day, a.Fvp, a.Fvid_prk, ls.ftxt, a.Ffld_num, a.Fmn, h.Fwrkdat, a.FPROC"
            + " FROM ^" + szTbl + " as a left join ^lic_fld as ls on a.FLSFID = ls.FID "
            + " INNER JOIN "+tmpTbl+" as r on a.Ftabn_id=r.Ftabn_id"
			+ " INNER JOIN ^CL_HOMO h ON a.Ftabn_id = h.Fwid_cl "			
			+ " WHERE a.Ftabn_ID in (SELECT ftabn_id from FOUT WHERE " + DataSource().sqlSelected() + ")"
				+ " AND (ls.Fis12 not in ("+sqlTo("1")+","+sqlTo("2")+","+sqlTo("3")+","+sqlTo("4")+","+sqlTo("5")
					+","+sqlTo("6")+","+sqlTo("7")+") OR ls.Fis12 is null)"//отсекаем базы удержаний
				+ " AND (ls.Fis6<>'s' or ls.Fis6 is null) "//также отсекаем справочные поля
            );
            
		//ExecuteSQL("alter table "+ tmpTbl +" add column FWID "+ SqlType("COUNTER"), false);

		var t = OpenTable("SELECT * FROM " + tmpTbl + " ORDER BY Fleftkey, Fcoddol, Ftabn, Ffld_num");

		var tv = new DpTVars(prnPatt_l);
		var h = new Object();
		h.FBDAT = D1;
		tv.setHTbl(h);
		tv.setRTbl(t);
		tv.print();
		break;
		case "PRINT_LP_LG":
		//------производим расчёт ---------------------------------------

		gd = new DpGetDat("dD");
		if (gd.escape)
		{
			CloseWindow();
			return;
		}
		var dat_beg = new Date(gd.dat1);
		var dat_end = new Date(gd.dat2);

		dat_beg.setDate(1);
		dat_end.setDate(1);

		var dat_now =new Date(dat_beg.getVarDate());
		var str_month="";
		var par = new Object();
		var all_month = true;
		var no_month = true;

		CreateTable("fout_eall", "fout_e", "*");

		while (dat_now.getVarDate()<=dat_end.getVarDate())
		{
			par.spLS = true;
			par.svzp_t = true;
			par.svzp_noempty = true;
			r_raslsd(dat_now,par);

			if (!par.spLS)
				break;

			if (!par.svzp_t)
			{
				str_month = str_month+(all_month?"":", ")+month_txtP(dat_now);
				all_month = false;
			}
			else
			{
				no_month = false;
				strSQL = "INSERT INTO fout_eall "+ getColumn("fout_e"+month_txt(dat_now),true) +
							" SELECT " + getColumn("fout_e"+month_txt(dat_now),false) + " FROM fout_e"+month_txt(dat_now);
				ExecuteSQL(strSQL);
			}

			dat_now.setMonth(dat_now.getMonth()+1);
		}
		if (!par.spLS)
			break;

		if (no_month)
		{
			alert("За жоден мiсяць з указаного вами перiоду \n не виконано розрахунок ЗП");
			break;
		}
		else if (!all_month)
			alert("За наступнi мiсяцi з указаного вами перiоду: \n "+str_month+" \n не виконано розрахунок ЗП");


		//------создаём нужные таблицы для печати расчётных листов ------

		var dat_now2 = new Date(dat_beg.getVarDate());

		CreateTable("tmp_rlstp1", "rlstp", "*");
		CreateTable("tmp_rlstp2", "rlstp", "*");
		CreateTable("tmp_rlstp",  "rlstp", "*");

		while (dat_now2.getVarDate()<=dat_end.getVarDate())
		{
			var szTagp = month_txt(dat_now2);
			var szTbl="SVZP"+szTagp;

			if (IsTableEx("zrp_res", "zrp_"+szTbl))
			{
				strSQL = "INSERT INTO tmp_rlstp ("+GetPatternIntersection("SVZP","SVZP").toUpperCase().replace(",FWID","") + ",Ftxt,Fdatar) "+
						"SELECT " + GetPatternIntersection("SVZP","SVZP", "a").toUpperCase().replace(",A.FWID","") + ",b.Ftxt, "+sqlTo(dat_now2)+" AS Fdatar "+
						"FROM ^"+szTbl+" a, ^LIC_FLD b "+
						"WHERE a.FTABN_ID in "+
						"(SELECT DISTINCT FTABN_ID FROM fout_e"+szTagp+
						" WHERE "+SqlCmpTrue+
						((lv1==0)?(" "):(" AND flv1 = " + sqlTo(lv1))) +
						((lv2==0)?(" "):(" AND flv2 = " + sqlTo(lv2))) +
						((lv3==0)?(" "):(" AND flv3 = " + sqlTo(lv3))) +
						((lv4==0)?(" "):(" AND flv4 = " + sqlTo(lv4))) +
						") "+
						"AND a.flsfid=b.fid ";
				ExecuteSQL(strSQL);
			}
			dat_now2.setMonth(dat_now2.getMonth()+1);
		}

		strSQL = "INSERT INTO tmp_rlstp2 (FBDY,FDAY,FCHAS,FEDY,FFLD_NUM,FID_PRK,"+
					"FIS_DAY,FIS_SLCT,FLSFID,FMN,FTPS2,FSUM,FTABN_ID,FDATAR,FTPS1,FVID_PRK,FVP) " + 
					"SELECT min(a.fbdy) as FBDY, min(a.fday) as FDAY, min(a.fchas) as FCHAS, "+
					"min(a.fedy) as FEDY, min(a.ffld_num) as FFLD_NUM, min(a.fid_prk) as FID_PRK, "+
					"" + First("a.fis_day") + " as FIS_DAY, " + First("a.fis_slct") + " as FIS_SLCT, min(a.flsfid) as FLSFID, "+
					"min(a.fmn) as FMN, min(a.ftps2) as FTPS2, min(a.fsum) as FSUM, "+
					"a.FTABN_ID as FTABN_ID,a.fdatar as FDATAR, 1 as FTPS1, min(a.fvid_prk) as FVID_PRK, min(a.fvp) as FVP "+
					"FROM tmp_rlstp a "+
					"GROUP BY FTABN_ID, FDATAR";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO tmp_rlstp2 (FBDY,FDAY,FCHAS,FEDY,FFLD_NUM,FID_PRK,"+
					"FIS_DAY,FIS_SLCT,FLSFID,FMN,FSUM,FDATAR,FTABN_ID,FTPS1,FTPS2,FVID_PRK,FVP) " + 
					"SELECT min(a.fbdy) as FBDY, min(a.fday) as FDAY, min(a.fchas) as FCHAS, "+
					"min(a.fedy) as FEDY, min(a.ffld_num) as FFLD_NUM, min(a.fid_prk) as FID_PRK, "+
					"" + First("a.fis_day") + " as FIS_DAY, " + First("a.fis_slct") + " as FIS_SLCT, min(a.flsfid) as FLSFID, "+
					"min(a.fmn) as FMN, min(a.fsum) as FSUM, min(a.fdatar) as FDATAR, "+
					"a.FTABN_ID as FTABN_ID, min(a.ftps1) as FTPS1, 1 as FTPS2, min(a.fvid_prk) as FVID_PRK, min(a.fvp) as FVP "+
					"FROM tmp_rlstp a "+
					"GROUP BY FTABN_ID";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO tmp_rlstp1 (FTXT, FTPS1, FTPS2, FDATAR, FAVT, FBDY, FCHAS, FDAY, FEDY, FFLD_NUM, FID_PRK, FIS_DAY, FIS_SLCT, FLSFID, FMN, FPR, FSUM, FTABN_ID, FVID_PRK, FVP)"
				+ " SELECT a.FTXT, a.FTPS1, a.FTPS2, a.FDATAR, a.FAVT, a.FBDY, a.FCHAS, a.FDAY, a.FEDY, a.FFLD_NUM, a.FID_PRK, a.FIS_DAY, a.FIS_SLCT, a.FLSFID, a.FMN, a.FPR, Sum(a.FSUM) AS FSUM, a.FTABN_ID, a.FVID_PRK, a.FVP"
				+ " FROM tmp_rlstp AS a"
				+ " GROUP BY a.FTXT, a.FTPS1, a.FTPS2, a.FDATAR, a.FAVT, a.FBDY, a.FCHAS, a.FDAY, a.FEDY, a.FFLD_NUM, a.FID_PRK, a.FIS_DAY, a.FIS_SLCT, a.FLSFID, a.FMN, a.FPR, a.FTABN_ID, a.FVID_PRK, a.FVP"
				+ " ORDER BY a.FFLD_NUM";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO tmp_rlstp2 ( FTXT, FTPS1, FTPS2, FDATAR, FAVT, FBDY, FCHAS, FDAY, FEDY, FFLD_NUM, FID_PRK, FIS_DAY, FIS_SLCT, FLSFID, FPR, FSHPZ, FSUM, FTABN_ID, FVID_PRK, FVP)"
				+ " SELECT a.FTXT, a.FTPS1, a.FTPS2, a.FDATAR, a.FAVT, a.FBDY, Sum(a.FCHAS) AS FCHAS, Sum(a.FDAY) AS FDAY, a.FEDY, a.FFLD_NUM, Min(a.FID_PRK) AS FID_PRK, a.FIS_DAY, a.FIS_SLCT, a.FLSFID, a.FPR, a.FSHPZ, Sum(a.FSUM) AS FSUM, a.FTABN_ID, a.FVID_PRK, a.FVP"
				+ " FROM tmp_rlstp1 AS a"
				+ " GROUP BY a.FTXT, a.FTPS1, a.FTPS2, a.FDATAR, a.FAVT, a.FBDY, a.FEDY, a.FFLD_NUM, a.FIS_DAY, a.FIS_SLCT, a.FLSFID, a.FPR, a.FPR, a.FSHPZ, a.FTABN_ID, a.FVID_PRK, a.FVP";
		ExecuteSQL(strSQL);

		//----------------------------------------------------------------
		var tab;
		if (SQL)
			tab = OpenTable("m","select * from tmp_rlstp2 order by FTABN_ID,FDATAR,FFLD_NUM,FTPS2 DESC,FTPS1 DESC");
		else
			tab = OpenTable("m","tmp_rlstp2");

		if (SQL)
			{
			tab.tie("RASL_EALL","RALL","FTABN_ID,FDATAR","FTABN_ID,FDATAR");
			tab.tie("SHTAT","SHT_P","FLV1,FLV2,FLV3,FLV4,FKOD_DOL,FTABN_ID,FID","RALL.FLV1,RALL.FLV2,RALL.FLV3,RALL.FLV4,=0,=0,=0");
			tab.tie("CLRELCLCL","REL","FCL,FCOD","="+getPar("CODPERS")+",FTABN_ID");
			}
			else
			{
			tab.tie("RASL_EALL","RALL","FDATAR","FTABN_ID,FDATAR");
			tab.tie("SHTAT","SHT_P","SHTAT","RALL.FLV1,RALL.FLV2,RALL.FLV3,RALL.FLV4,=0,=0,=0");
			tab.tie("CLRELCLCL","REL","clcod","="+getPar("CODPERS")+",FTABN_ID");
			}    
		tab.tie("CL_HOMO","HOMO","FWID_CL","REL.FWID_CL");

		tab.index="tabd";
		if (!tab.IsEmpty())
			tab.MoveFirst();

		var tv = new DpTVars(prnPatt_lp);
		var bm = tab.bookmark;
		tv.setRTbl(tab);
		tv.setVar("HBDAT", dat_beg);
		tv.setVar("HEDAT", dat_end);
		tv.print()
		tab.bookmark = bm;
		//tab.Close(5652);
		tab = null;
		break;

		case "PRINT_ORD":
		var doptab;
		doptab=OpenTable("s","SHTAT");
		var nazv_org;

		doptab.index="shtat";
		if (SQL)
			doptab.index="FLV1,FLV2,FLV3,FLV4,FKOD_DOL,FTABN_ID,FID";
		if (!doptab.Seek("=",0,0,0,0,0,0,0))
			alert("Ошибка в таблице SHTAT");
		else
			nazv_org=doptab("Fnazv_podr");
		doptab.Close();

		var tv = new DpTVars(prnPatt_ord);
		var bm = tbl.bookmark;
		var h = new Object();
		h.FNAZ_OR = nazv_org;
		h.FBDAT = D1;
		tv.setHTbl(h);
		tv.setRTbl(tbl);
		//tv.print();
		tv.print();
		tbl.bookmark = bm;
		break;
		// печать расчётных листоков на две колонки
		case "PRINT_RL":
			//------создаём нужные таблицы для печати расчётных листов------
			/*var szTbl="SVZP"+szTag;

			CreateTable("tmp_RL", "raslis", "tabn");
			tabRL = OpenTable("m", "tmp_RL");
			if (IsTable(DataSource().PlusName))
			{
				strSQL = "SELECT fout.FTABN_ID FROM " + DataSource().PlusName + " p"
											+ " LEFT JOIN fout ON p.fwid_=fout.fwid"
			}
			else
			{
				strSQL = "SELECT fout.FTABN_ID FROM fout"
					+ " WHERE "+SqlCmpTrue
						+ ((lv1==0)?(" "):(" AND fout.flv1 = " + sqlTo(lv1)))
						+ ((lv2==0)?(" "):(" AND fout.flv2 = " + sqlTo(lv2)))
						+ ((lv3==0)?(" "):(" AND fout.flv3 = " + sqlTo(lv3)))
						+ ((lv4==0)?(" "):(" AND fout.flv4 = " + sqlTo(lv4)));
			}
	
			var listTABN = OpenTable("s", strSQL);

			listTABN.MoveFirst();

			while(!listTABN.IsEOF())
			{
				var recNum = 1;
				//Добавление в соответствующую колонку каждого из видов начислений или удержаний
				strSQL = "SELECT Max(a.FDAY) AS FDAY, Max(a.FCHAS) AS FCHAS, a.FFLD_NUM, a.FMN, Sum(a.FSUM) AS FSUM, a.FTABN_ID, a.FVP, b.FTXT"
						+ " FROM ^" + szTbl + " a LEFT JOIN ^lic_fld b ON b.fid=a.flsfid"
						+ " WHERE b.FIS6='+' AND a.FTABN_ID="+ listTABN("FTABN_ID")
						+ " GROUP BY a.FFLD_NUM, a.FMN, a.FTABN_ID, a.FVP, b.FTXT"
						+ " ORDER BY a.FFLD_NUM";
				var plus = OpenTable("s", strSQL);
				plus.MoveFirst();
				strSQL = "SELECT a.FFLD_NUM, a.FMN, a.FSUM, a.FTABN_ID, a.FVP, b.FTXT"
						+ " FROM ^" + szTbl + " a LEFT JOIN ^lic_fld b ON b.fid=a.flsfid"
						+ " WHERE b.FIS6='-' AND a.FTABN_ID="+ listTABN("FTABN_ID")
						+ " ORDER BY a.FFLD_NUM";
				var sub = OpenTable("s", strSQL);
				sub.MoveFirst();
				
				while(!plus.IsEOF() || !sub.IsEOF())
				{
					tabRL.AddNew();
					if(!plus.IsEOF())
					{
						tabRL("FDAYP") = plus("FDAY");
						tabRL("FCHASP") = plus("FCHAS");
						tabRL("FMNP") = plus("FMN");
						tabRL("FSUMP") = plus("FSUM");
						tabRL("FVPP") = plus("FVP");
						tabRL("FTXTP") = plus("FTXT");
						tabRL("FTABN_ID") = plus("FTABN_ID");
						plus.moveNext();
					}
					else
						tabRL("FTABN_ID") = sub("FTABN_ID");
					
					if(!sub.IsEOF())
					{
						tabRL("FMNS") = sub("FMN");
						tabRL("FSUMS") = sub("FSUM");
						tabRL("FVPS") = sub("FVP");
						tabRL("FTXTS") = sub("FTXT");
						sub.moveNext();
					}
				
					tabRL("FTPS") = 2;
					tabRL("FRECNUM")= recNum;
					tabRL.Update();
					recNum++;
				}
			
				plus.Close();
				sub.Close();
				//Добавление суммы всего начислено и всего удержано
				strSQL = "SELECT Max(a.FDAY) AS FDAY, Max(a.FCHAS) AS FCHAS, a.FFLD_NUM, a.FMN, Sum(a.FSUM) AS FSUM, a.FTABN_ID, a.FVP, b.FTXT"
						+ " FROM ^" + szTbl + " a LEFT JOIN ^lic_fld b ON b.fid=a.flsfid"
						+ " WHERE b.FIS6='н' AND a.FTABN_ID="+ listTABN("FTABN_ID")
						+ " GROUP BY a.FFLD_NUM, a.FMN, a.FTABN_ID, a.FVP, b.FTXT"
						+ " ORDER BY a.FFLD_NUM";
				plus = OpenTable("s", strSQL);
				plus.MoveFirst();
				strSQL = "SELECT a.FFLD_NUM, a.FMN, a.FSUM, a.FTABN_ID, a.FVP, b.FTXT"
						+ " FROM ^" + szTbl + " a LEFT JOIN ^lic_fld b ON b.fid=a.flsfid"
						+ " WHERE b.FIS6='у' AND a.FTABN_ID="+ listTABN("FTABN_ID")
						+ " ORDER BY a.FFLD_NUM";
				sub = OpenTable("s", strSQL);
				sub.MoveFirst();
				tabRL.AddNew();
				tabRL("FDAYP") = plus("FDAY");
				tabRL("FCHASP") = plus("FCHAS");
				tabRL("FMNP") = plus("FMN");
				tabRL("FSUMP") = plus("FSUM");
				tabRL("FVPP") = plus("FVP");
				tabRL("FTXTP") = plus("FTXT");
				tabRL("FTABN_ID") = plus("FTABN_ID");
				tabRL("FMNS") = sub("FMN");
				tabRL("FSUMS") = sub("FSUM");
				tabRL("FVPS") = sub("FVP");
				tabRL("FTXTS") = sub("FTXT");
				tabRL("FTPS") = 3;
				tabRL("FRECNUM")= recNum;
				tabRL.Update();
				recNum++;
			
				plus.Close();
				sub.Close();
				//Добавление за прошлые и будущие периоды, к выдаче 
				strSQL = "SELECT b.FTXT, a.FSUM, a.FTABN_ID"
						+ " FROM ^" + szTbl + " a LEFT JOIN ^lic_fld b ON b.fid=a.flsfid"
						+ " WHERE ( b.FIS6='з' OR b.FIS6='б' OR b.FIS6='ф') AND a.FTABN_ID="+ listTABN("FTABN_ID")
						+ " ORDER BY a.FFLD_NUM";

				plus = OpenTable("s", strSQL);
				if(!plus.IsEmpty())
				{
					plus.MoveFirst();
					while(!plus.IsEOF())
					{
						tabRL.AddNew();
						tabRL("FTXTP") = plus("FTXT");
						tabRL("FSUMP") = plus("FSUM");
						tabRL("FTABN_ID") = plus("FTABN_ID");
						tabRL("FTPS") = 4;
						tabRL("FRECNUM")= recNum;
						tabRL.Update();
						recNum++;
						plus.moveNext();
					}
				}
			
				plus.Close();
			
				listTABN.moveNext();
			}

			listTABN.Close();

			strSQL = "INSERT INTO tmp_RL (FTABN_ID, FRECNUM, FTPS)"
					+ " SELECT a.FTABN_ID as FTABN_ID, 0 as FRECNUM, 1 as FTPS"
					+ " FROM tmp_RL a"
					+ " GROUP BY FTABN_ID";
			ExecuteSQL(strSQL);
			//----------------------------------------------------------------

			tabRL.index = "tabn";
			tabRL.Requery();

			tabRL.tie("fout"+szTag,"fout","FTABN_ID","FTABN_ID");
			if (SQL)
			{
				tabRL.tie("SHTAT","SHT_P","FLV1,FLV2,FLV3,FLV4,FKOD_DOL,FTABN_ID,FID","fout.FLV1,fout.FLV2,fout.FLV3,fout.FLV4,=0,=0,=0");
				tabRL.tie("CLRELCLCL","REL","FCL,FCOD","="+getPar("CODPERS")+",FTABN_ID");
			}
			else
			{
				tabRL.tie("SHTAT","SHT_P","SHTAT","fout.FLV1,fout.FLV2,fout.FLV3,fout.FLV4,=0,=0,=0");
				tabRL.tie("CLRELCLCL","REL","clcod","="+getPar("CODPERS")+",FTABN_ID");
			}

			tabRL.tie("CL_HOMO","HOMO","FWID_CL","REL.FWID_CL");

			tabRL.MoveFirst();

			include("objects\\DpTVars.js");
			var tv = new DpTVars(prnPatt_l);
			var bm = tabRL.bookmark;
			var h = new Object();
			h.FBDAT = D1;
			tv.setHTbl(h);
			tv.setRTbl(tabRL);
			tv.print();
			tabRL.bookmark = bm;*/
		break;
		case "PRINT_P":
			printRLists("POL")//Полный вариант выделяем переходящие начисления и удержания
		break;
		case "PRINT_S":
			printRLists("SOK")//Сокращённый вариант не выделяем переходящие начисления и удержания
		break;
		case "SEND_P":
			printRLists("SEND_POL")
		break;
		case "SEND_S":
			printRLists("SEND_SOK")
		break;
		case "VIEW_LOG":
			var par = new Object();
			par.dat = D1;
			showWindow("l_rasl_mail.js",SW_NOMODAL,par);
		break;
		default:
			break;
	}
}

//Tori 2008.05.23 перенёс печать расчётных листов из ЧТГ в платёжную ведомость из l_homlist.js
var dat1, dat2, fleftkeys, frightkeys, sWhere;
var TblName=new Array();
TblName[0] = "CH_TEMP";
TblName[1] = "CH_CL_N";
TblName[2] = "CH_COUNT";
var pref=new Array();
pref[0]="N";
pref[1]="U";
pref[2]="V";
var nameT=new Array();
nameT[0]=pref[0]+"ACH_T";
nameT[1]=pref[1]+"D_T";
nameT[2]=pref[2]+"ID_T";

function max_num()
{
	//первый параметр режим
	//"arg"-макисмум
	//"num"-номер максимального єлемента
	var maxArg,maxnum=1;
	for(var i = 2, maxArg = max_num.arguments[1]; i < max_num.arguments.length; i++)
		if(maxArg < max_num.arguments[i])
			if(typeof max_num.arguments[i]!="date" || !isEmpty(max_num.arguments[i]))
			{
				maxArg = max_num.arguments[i];
				maxnum=i;
			}
	maxArg=(max_num.arguments[0]=="arg")?maxArg:maxnum;
	return maxArg;
}

function setNum(tblName,numFld)
{
	if(numFld==null)
		numFld = "Fnum";
	var tnum=OpenTable("SELECT * FROM "+tblName
					+" order by ftabn_id,fnum desc,ffld_num,fvp");
	var mtabn=0;
	var k=1;
	if(!tnum.IsEmpty())
	{ 
		for(tnum.MoveFirst();!tnum.IsEOF();tnum.MoveNext())
		{
			if(Number(tnum.getValue("FTABN_ID"))!=mtabn)
			{
				mtabn=Number(tnum.getValue("FTABN_ID"));
				k=1;
			}
			if(tnum.getValue("FNUM")==0)
			{
				ExecuteSQL("UPDATE "+tblName+" SET "+numFld+"="+k+" WHERE FWID="+sqlTo(tnum.getValue("FWID")));
			}
			k++;
		}
		tnum.close();
		return true;
	}
	else
		return false;
}

function printRLists(mParam)
{
	if(mParam.indexOf("SEND_")!=-1)
	{
		if(!getPar("SMTPSERVER") || allt(getPar("SMTPSERVER"))=="")
		{
			alert(ru("Укажите сервер исходящей почты в меню ","Вкажіть сервер вихідної пошти в меню ")+"'"+getParItemPath("SMTPSERVER",true)+"'",1);
			return false;
		}
		if(!getPar("EMAIL") || allt(getPar("EMAIL"))=="")
		{
			alert(ru("Укажите адрес отправителя почтовых сообщений в меню ","Вкажіть адресу відправника почтових повідомлень в меню ")+"'"+getParItemPath("EMAIL",true)+"'",1);
			return false;
		}
	}
	var oClKat;
	//если есть справочник, то запрашиваем категорию лицевых счетов
	if(getPar("LS_KAT"))
	{
		var form = createForm(ru("Введите данные для отбора","Введіть дані для відбору"));
		oClKat = form.addObjClCombo(getPar("LS_KAT"),"0!",UR("Категорія ОР|Категория ЛС"));
		form.show();
		if(form.escape)
			return false;
	}
	
	if(IsTable("CH_CL_N"))
		DropTable("CH_CL_N");
	StrSQL="CREATE TABLE CH_CL_N " +
				"(FTXT " + SqlType("TEXT",255) + "," +
				"FCOD " + SqlType("INT") + "," +
				"FID " + SqlType("BYTE") + "," +
				"FWID_CL " + SqlType("LONG") + "," +
				"FWID " + SqlType("LONG") + ")"
	ExecuteSQL(StrSQL);
	
	//Записываем данные из таблиц по зарплате за указанный период
	StrSQL=" INSERT INTO CH_CL_N (Ftxt,Fcod,Fwid_cl,Fwid,Fid)"
			+" SELECT c.Ftxt,r.Fcod,w.Fwid_cl,f.Fwid,w.Fid"
			+" FROM FOUT as f INNER JOIN ^work_pers as w ON f.Ftabn_id=w.Fwid_cl and f.Fid=w.Fid "
				+" INNER JOIN ^cl as c ON f.Ftabn_id=c.Fwid "
				+" INNER JOIN ^clrelclcl as r ON f.Ftabn_id=r.Fwid_cl "
			+" WHERE (w.Fbdat<="+sqlTo(D2)+" AND w.Fedat>="+sqlTo(D1)+") "
				+" AND r.Fcl="+getPar("CODPERS")
				+" AND "+(DataSource().selectedCount>0?" f.Fwid "+DataSource().sqlSelected(true):" 1=1 ")
			+" ORDER BY r.Fcod"
	ExecuteSQL(StrSQL);
	
	var i,main,k;
	//Определяем расчитана ли зарплата за указанный месяц
	if(IsTableEx("ZRP_RES","ZRP_SVZP"+getDateTag(D1))) 
		var TabSvzp="SVZP"+getDateTag(D1);
	else
	{
		alert("Произведите расчёт зарплаты за "+format("Mmm yyyy",D1).toLowerCase())
		return;
	}
	//Найдём номер и код ЛС (Всего начислено,всего удержания,к выдаче)
	//tbl_lic=OpenTable("LIC_FLD");
	var fis6 = "н";
	if(oClKat && oClKat.getCod())
		fis6 += oClKat.getCod();
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6="+sqlTo(fis6));
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: Всего начислено\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var nach_lsfid = tbl_lic[0];
	var nach_lsnum = tbl_lic[1];
	fis6 = "у";
	if(oClKat && oClKat.getCod())
		fis6 += oClKat.getCod();
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6="+sqlTo(fis6));
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: Всего удержано\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var uder_lsfid = tbl_lic[0];
	var uder_lsnum = tbl_lic[1];
	fis6 = "ф";
	if(oClKat && oClKat.getCod())
		fis6 += oClKat.getCod();
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6="+sqlTo(fis6));
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: К выдаче\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var vyd_lsfid = tbl_lic[0];
	var vyd_lsnum = tbl_lic[1];
	var dolg_lsfid = 0;
	var dolg_lsnum = 0;
	fis6 = "б";
	if(oClKat && oClKat.getCod())
		fis6 += oClKat.getCod();
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6="+sqlTo(fis6));
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: задолженность на буд.период\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
	}
	else
	{
		dolg_lsfid = tbl_lic[0];
		dolg_lsnum = tbl_lic[1];
	}
	if(IsTable(TblName[0])) 
		DropTable(TblName[0])
	ExecuteSQL("CREATE TABLE " + TblName[0]
			+" (FNUM " + SqlType("INT") +
			", FFLD_NUM " + SqlType("INT") +
			",FLSFID " + SqlType("INT") +
			",FSUM " + SqlType("DOUBLE") +
			",FPROC " + SqlType("DOUBLE") +
			",FCOD " + SqlType("INT") +
			",FWID " + SqlType("LONG") +
			",FTABN_ID " + SqlType("LONG") +
			",FNACH " + SqlType("INT") +
			",FUDER " + SqlType("INT") +
			",FVYD " + SqlType("INT") + ")");
	//Собираем отмеченные записи
	StrSQL="INSERT INTO " + TblName[0] + " (FCOD,FWID,FTABN_ID)"
		+" SELECT FCOD,FWID,FWID_Cl FROM " + TblName[1]
		+" WHERE "+(DataSource().selectedCount>0?DataSource().sqlSelected():" 1=1 ");
	ExecuteSQL(StrSQL);
	
	var toNotPrnSprav = true;
	if(mParam.indexOf("SEND_")==-1)//для почтовых сообщений справочные поля не печатаем
	{
		var msg = ru("Печатать справочные поля ЛС?","Друкувати довідкові поля ОР?");
		toNotPrnSprav = !confirm(msg);
	}
		
	//Создаём Таблицы для начисления, удержаний и к выдаче отдельно
	for(i=0;i<nameT.length;i++)
	{
		DropTable(nameT[i])
		StrSQL="CREATE TABLE "+ nameT[i]
						+" (FNUM " + SqlType("INTEGER") +
						", FFLD_NUM " + SqlType("INTEGER") +
						",FLSFID " + SqlType("INTEGER") +
						",FSUM " + SqlType("DOUBLE") +
						",FPROC " + SqlType("DOUBLE") +
						",FTABN_ID " + SqlType("LONG") +
						",FCOD " + SqlType("INTEGER") +
						",FLEVEL " + SqlType("BYTE") +
						",FVP " + SqlType("BYTE") +
						",FMN " + SqlType("DATE") +
						",FDAY_N " + SqlType("INTEGER") +
						",FCHAS_N " + SqlType("DOUBLE") +
						",FWID" + SqlType("COUNTER") + ")"
		ExecuteSQL(StrSQL);
		
		var field4update1 = "";
		var field4update2 = "";
		StrTab=" A.FTABN_ID=B.FTABN_ID"
		//записываем по каждому табелю (всего начислено, всего удержано, к выдаче)
		StrSQL="INSERT INTO "+nameT[i] + " (FLSFID,FFLD_NUM,FSUM,FPROC,FNUM,FLEVEL,FTABN_ID)"
					+" SELECT A.FLSFID,c.FFLD_NUM,A.FSUM,A.FPROC,1 AS FNUM,2 AS FLEVEL,A.FTABN_ID"
					+" FROM ^"+TabSvzp+" AS A, " + TblName[0] + " AS B, ^lic_fld as c";
		switch (i)
		{
			case 0:
				StrSQL+=" WHERE A.FLSFID="+sqlTo(nach_lsfid)+" AND "+StrTab+" and a.FLSFID=c.fid "
				StrSQL1=" WHERE c.FFLD_NUM<"+sqlTo(nach_lsnum)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FNACH=B.FNACH"
				field4update1 = "FNACH";
				field4update2 = "FNACH";
			break;
			case 1:
				StrSQL+=" WHERE A.FLSFID="+sqlTo(uder_lsfid)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrSQL1=" WHERE c.FFLD_NUM>"+sqlTo(nach_lsnum)
				   +" AND c.FFLD_NUM<"+sqlTo(uder_lsnum)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FUDER=B.FNACH"
				field4update1 = "FUDER";
				field4update2 = "FNACH";
			break;
			case 2:
				StrSQL+=" WHERE (A.FLSFID="+sqlTo(vyd_lsfid)+
							" OR (A.FLSFID="+sqlTo(dolg_lsfid)+ " and A.FSUM<=-1/100)) AND "+StrTab+" and a.FLSFID=c.fid ";
				StrSQL1=" WHERE ((c.FFLD_NUM>"+sqlTo(vyd_lsnum)+" and c.FFLD_NUM<>"+sqlTo(dolg_lsnum)+
							") or (c.FFLD_NUM>"+sqlTo(dolg_lsnum)+" and c.FFLD_NUM<>"+sqlTo(vyd_lsnum)+")) AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FVYD=B.FNACH"
				field4update1 = "FVYD";
				field4update2 = "FNACH";
			break;
		}
		ExecuteSQL(StrSQL);
		//записываем все остальные лицевые поля				
		StrSQL = "INSERT INTO " + nameT[i] + " (FLSFID,FFLD_NUM,FSUM,FPROC";
		if(mParam.indexOf("SOK")!=-1)
			StrSQL+=",FNUM,FLEVEL,FVP,FMN,FTABN_ID,FDAY_N,FCHAS_N) ";
		else
	 		StrSQL+=",FNUM,FLEVEL,FVP,FMN,FTABN_ID,FDAY_N,FCHAS_N) ";
		if(mParam.indexOf("SOK")!=-1)
		{
			StrSQL += " SELECT A.FLSFID,MAX(c.FFLD_NUM) AS FFLD_NUM,SUM(A.FSUM) AS FSUM,MAX(A.FPROC) as FPROC";
			StrSQL+=",0 AS FNUM,3 AS FLEVEL,0 AS FVP," + sqlTo(d00)
							+ " AS FMN,A.FTABN_ID"
							+",SUM(A.FDAY*A.FSUM/ABS(A.FSUM)) AS FDAY_N"
							+",SUM(A.FCHAS*A.FSUM/ABS(A.FSUM)) AS FCHAS_N"
		}
		else
		{
			StrSQL += " SELECT A.FLSFID,c.FFLD_NUM AS FFLD_NUM,A.FSUM,A.FPROC";
			StrSQL+=",0 AS FNUM,3 AS FLEVEL,A.FVP,A.FMN,A.FTABN_ID"
							+",(A.FDAY) AS FDAY_N"
							+",(A.FCHAS) AS FCHAS_N"
		}
		StrSQL+=" FROM ^"+TabSvzp+" AS A, " + TblName[0] + " AS B, ^lic_fld as c "+StrSQL1+" AND A.FSUM<>0"+(oClKat && oClKat.getCod()?" AND A.Fls_kat="+oClKat.getCod():"")
			+ " AND (c.Fis12 not in ("+sqlTo("1")+","+sqlTo("2")+","+sqlTo("3")+","+sqlTo("4")+","+sqlTo("5")+","+sqlTo("6")+","+sqlTo("7")+") OR c.Fis12 is null) "
				+" AND (NOT c.Fis6 like 'ф_' OR c.Fis6 is null) AND (NOT c.Fis6 like 'у_' OR c.Fis6 is null) "
				+" AND (NOT c.Fis6 like 'н_' OR c.Fis6 is null) AND (NOT c.Fis6 like 'з_' OR c.Fis6 is null) "
				+" AND (NOT c.Fis6 like 'б_' OR c.Fis6 is null)"//отсекаем базы удержаний и итоговые суммы по категориям;
		//NI:
		StrSQL += " AND (not (a.fvp = 1 AND a.FMN >="+sqlTo(D1)+"))";
		//END NI
		if(toNotPrnSprav)
			StrSQL += " AND (c.Fis6<>'s' OR c.Fis6 is null)"

		if(mParam.indexOf("SOK")!=-1)
			StrSQL+=" GROUP BY A.FLSFID,A.FTABN_ID HAVING SUM(A.FSUM)<>0";
		else			  //StrSQL+=" GROUP BY A.FFLD_NUM,A.FLSFID,A.FVP,A.FMN,A.FTABN"
			StrSQL+=" ORDER BY A.FTABN_ID,c.FFLD_NUM"
		ExecuteSQL(StrSQL);
		//Подсчитываем количество строк в разрезе 
		//табель, (всего начислено или всего удержано или всего к выдаче)
		if(IsTable(TblName[2])) 
	 		ExecuteSQL("DELETE FROM " + TblName[2]);
		else
			ExecuteSQL("CREATE TABLE " + TblName[2] + " (FNACH " + SqlType("INTEGER") 
				+",FTABN_ID " + SqlType("LONG") + ")");
		StrSQL="INSERT INTO " + TblName[2] + " (FNACH,FTABN_ID) "
			+" SELECT COUNT(A.FFLD_NUM) AS FNACH,A.FTABN_ID"
			+" FROM "+nameT[i]+" AS A"
			+" GROUP BY A.FTABN_ID"
		ExecuteSQL(StrSQL);
				
		//SqlUpdate4Join("inner", TblName[0], TblName[2], "A", "B", field4update1, field4update2, StrTab)
		ExecuteSQL("UPDATE "+TblName[0]+" SET "+field4update1
				+"=(SELECT "+field4update2+" FROM "+TblName[2]+" AS b WHERE "+TblName[0]+".FTABN_ID=B.FTABN_ID)");
	}
	//Проставляем номера строк для Начислений,удержаний, к выдаче
	var flg_num=true;
	for(i=0;i<nameT.length;i++)
	{
		flg_num=setNum(nameT[i],"Fnum")
	}
//	if(!flg_num)
//	{
//		alert("Данных по указанным табелям нет");
//		return;
//	}
	//Записывем взависимости от количества строк попорядку 
	//начисления, удержания, к выдаче
	//Добавляем тот вид, у которого больше строк, остальные абдейтим
	var crstr="(FTABN_ID " + SqlType("LONG") +
				",FTABN " + SqlType("LONG") +
				",FNUM " + SqlType("INTEGER") +
				",FFLD_NUM_N " + SqlType("INTEGER") +
				",FLSFID_N " + SqlType("INTEGER") +
				",FSUM_N " + SqlType("Currency") +
				",FPROC_N " + SqlType("DOUBLE") +
				",FVP_N " + SqlType("BYTE") +
				",FMN_N " + SqlType("DATE") +
				",FFLD_NUM_U " + SqlType("INTEGER") +
				",FLSFID_U " + SqlType("INTEGER") +
				",FSUM_U " + SqlType("Currency") +
				",FPROC_U " + SqlType("DOUBLE") +
				",FVP_U " + SqlType("BYTE") +
				",FMN_U " + SqlType("DATE") +
				",FFLD_NUM_V " + SqlType("INTEGER") +
				",FLSFID_V " + SqlType("INTEGER") +
				",FSUM_V " + SqlType("Currency") +
				",FPROC_V " + SqlType("DOUBLE") +
				",FVP_V " + SqlType("BYTE") +
				",FMN_V " + SqlType("DATE") +
				",FLEVEL " + SqlType("BYTE") +
				",FRAZR " + SqlType("BIT") +
				",FDAY_N " + SqlType("INTEGER") +
				",FCHAS_N " + SqlType("DOUBLE");
	if(IsTable("CH_MAIN")) 
		//ExecuteSQL("DELETE FROM CH_MAIN");
		DropTable("CH_MAIN");
	ExecuteSQL("CREATE TABLE CH_MAIN "+crstr+")");
	var tcount=OpenTable(TblName[0]);	
	for(tcount.MoveFirst();!tcount.IsEOF();tcount.MoveNext())
	{
		for(i=0;i<nameT.length;i++)
		{
			//main=Number(max_num("num",tcount.getValue("FNACH"),tcount.getValue("FUDER"),tcount.getValue("FVYD")))-1;
			snap = getSnap("select Fnach, Fuder, Fvyd from "+TblName[0]+" where Fwid="+sqlTo(tcount.getValue("FWID")));
			main=Number(max_num("num",snap[0],snap[1],snap[2]))-1;
			//tcount.Edit();
			switch (main)
			{
				case 0:
					//tcount("FNACH")=0;//ОБНУЛЯЕМ МАКСИМУМ, ЧТОБЫ НАЙТИ СЛЕДЮЩИЙ ПО ВЕЛИЧЕНЕ МАКСИМУМ
					ExecuteSQL("UPDATE "+TblName[0]+" SET FNACH=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
				break;
				case 1:
					//tcount("FUDER")=0;
					ExecuteSQL("UPDATE "+TblName[0]+" SET FUDER=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
	  			break;
	  			case 2:
					//tcount("FVYD")=0;
					ExecuteSQL("UPDATE "+TblName[0]+" SET FVYD=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
	  			break;
			}
			//tcount.Update();
			//Добавляем основную запись по табелю
			if(i==0)
			{ //ЕСЛИ ПЕРВЫЙ МАКСИМУМ(МАКС. КОЛИЧ. СТРОК НАЧИСЛЕНИЙ) ТО ДОБАВЛЯЕМ
				StrSQL="INSERT INTO CH_MAIN (FMN_"+pref[main]+",FVP_"+pref[main]+",FTABN_ID,FNUM,FFLD_NUM_"+pref[main]+
					",FLSFID_"+pref[main]+",FSUM_"+pref[main]+",FPROC_"+pref[main];
				if(main==0)
					StrSQL+=",FDAY_N,FCHAS_N) ";
				else
					StrSQL+=") ";
				StrSQL+=" SELECT FMN AS FMN_"+pref[main]+",FVP AS FVP_"+pref[main]
					+",FTABN_ID,FNUM,FFLD_NUM AS FFLD_NUM_"+pref[main]
					+",FLSFID AS FLSFID_"+pref[main]+",FSUM AS FSUM_"+pref[main]+",FPROC AS FPROC_"+pref[main]
				if(main==0)
					StrSQL+=",FDAY_N,FCHAS_N"
				StrSQL+=" FROM "+nameT[main]+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID");
				ExecuteSQL(StrSQL);
			}
			else
			{
				//абдейтим остальные виды "начислений"
				if(!ExecuteSQL("UPDATE CH_MAIN SET "
							+" FMN_"+pref[main]+"=(SELECT MIN(FMN) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID")))
				{
							browse("SELECT * FROM "+nameT[main]+" WHERE ftabn_id="+tcount.getValue("FTABN_ID")+" order by fnum");
							return false;
				}
				ExecuteSQL("UPDATE CH_MAIN SET "
							+" FVP_"+pref[main]+"=(SELECT MIN(FVP) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN SET "
							+" FFLD_NUM_"+pref[main]+"=(SELECT MIN(FFLD_NUM) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN SET "
							+" FLSFID_"+pref[main]+"=(SELECT MIN(FLSFID) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN SET "
							+" FSUM_"+pref[main]+"=(SELECT SUM(FSUM) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN SET "
							+" FPROC_"+pref[main]+"=(SELECT MAX(FPROC) FROM "+nameT[main]+" AS B WHERE "
							+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				if(main==0)
				{
					ExecuteSQL("UPDATE CH_MAIN SET "
								+" FDAY_N=(SELECT SUM(FDAY_N) FROM "+nameT[main]+" AS B WHERE "
								+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
								+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
					ExecuteSQL("UPDATE CH_MAIN SET "
								+" FCHAS_N=(SELECT SUM(FCHAS_N) FROM "+nameT[main]+" AS B WHERE "
								+" CH_MAIN.FTABN_ID=B.FTABN_ID AND CH_MAIN.FNUM=B.FNUM) "
								+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				}
			}
		}//	end	for(i=1;i<4;i++)
	}//	end for(tcount.MoveFirst();!tcount.IsEOF();tcount.MoveNext())
	//Добавляем строку  табельного номера, чтобы далее по нему вытянуть данные
	tcount.close();
	//ДОБАВЛЯТЬ ТОЛЬКО ДЛЯ ТЕХ У КОГО ЕСТЬ ИНФОРМАЦИЯ В РАСЧЕТНОМ ЛИСТЕ
	if(IsTable("CH_TEMP1"))
		DropTable("CH_TEMP1");
	ExecuteSQL("SELECT DISTINCT FTABN_ID INTO CH_TEMP1 FROM CH_MAIN ")
	StrSQL="INSERT INTO CH_MAIN (FTABN_ID,FLEVEL,FNUM)"
				+" SELECT DISTINCT FTABN_ID,1 AS FLEVEL,0 AS FNUM"
				+" FROM CH_TEMP1";
	ExecuteSQL(StrSQL);
	StrSQL="INSERT INTO CH_MAIN (FTABN_ID,FLEVEL,FNUM)"
				+" SELECT DISTINCT FTABN_ID,2 AS FLEVEL,0 AS FNUM"
				+" FROM CH_TEMP1" ;
	ExecuteSQL(StrSQL);
	//проставим табельный номер
	ExecuteSQL("UPDATE CH_MAIN SET Ftabn=(SELECT Fcod FROM ^clrelclcl AS r WHERE CH_MAIN.Ftabn_id=r.Fwid_cl)");

	//Устанавливаем левелы для "всего начисленно и удержанои к выдаче"
	ExecuteSQL("UPDATE CH_MAIN SET FLEVEL=2 WHERE FNUM=1");
	//Устанавливаем левелы для остальнх ""
	ExecuteSQL("UPDATE CH_MAIN SET FLEVEL=3 WHERE FNUM>1");
	if(IsTable("CH_MAIN_PRN")) 
		//ExecuteSQL("DELETE FROM CH_MAIN_PRN");
		DropTable("CH_MAIN_PRN")
	ExecuteSQL("CREATE TABLE CH_MAIN_PRN "+crstr +
						",FID " + SqlType("LONG") + //поле для сквозной нумерации
						",FWID" + SqlType("COUNTER") +
						",FNAZV_N " + SqlType("TEXT") +
						",FNAZV_U " + SqlType("TEXT") +
						",FNAZV_V " + SqlType("TEXT") +
						",FNAZV_PODR " + SqlType("TEXT") +
						",FNAZV_DOL " + SqlType("TEXT") +
						",FOKLAD " + SqlType("MONEY") +
						",FNAM_LEVS " + SqlType("TEXT") +
						",FWID_ORG " + SqlType("LONG") +
						",FTABNORG " + SqlType("LONG") +
                        ",FID_DOl " + SqlType("LONG") +
						",FPEREX_N " + SqlType("TEXT") +
						",FPEREX_U " + SqlType("TEXT") + ")");

	//ПОДТЯГИВАЕМ ФИО, ОКЛАД, 
	/*ExecuteSQL("INSERT INTO CH_MAIN_PRN (" + getColumn("CH_MAIN",false) + ",FOKLAD,FNAM_LEVS,FWID_ORG)"
					+" SELECT A.*,B.FOKLAD,B.FNAM_LEVS,B.FLV1,B.FLV2,B.FLV3,B.FLV4"
					+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^SHTAT AS B  ON B.FTABN=D.FCOD and B.FID=D.FID)  "
					+" ON A.FTABN=D.FCOD"
					+" ORDER BY A.FTABN_ID,A.FNUM,A.FLEVEL,A.FFLD_NUM_N");*/
	ExecuteSQL("INSERT INTO CH_MAIN_PRN (" + getColumn("CH_MAIN",false) + ",FOKLAD,FNAM_LEVS,FWID_ORG,FID_DOL,FTABNORG)"
					+" SELECT "+getColumn("CH_MAIN",false,"A")+",SD.FOKLAD,CL.FTXT,SD.FWID_ORG,SD.FWID_CL,WP.FTABNORG"
					//+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^SHTAT AS B  ON B.FTABN=D.FCOD and B.FID=D.FID)  "
					+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^work_pers AS WP ON D.Fwid_cl=WP.Fwid_cl AND D.Fid=WP.Fid AND WP.FISMAIN = " +sqlTrue
							+" INNER JOIN ^stru_dol AS SD ON WP.Fwid_dol=SD.Fwid "
							+" INNER JOIN ^cl AS CL ON CL.Fwid=WP.Fwid_cl) ON A.FTABN_ID=D.FWID_CL "
					+" ORDER BY A.FTABN_ID,A.FNUM,A.FLEVEL,A.FFLD_NUM_N");
	//ПОДТЯГИВАЕМ НАЗВАНИЕ ПОДРАЗДЕЛЕНИЯ
	ExecuteSQL("UPDATE CH_MAIN_PRN SET FNAZV_PODR=(SELECT Ftxt FROM ^stru_org WHERE Fwid=CH_MAIN_PRN.Fwid_org) WHERE Flevel=2");
	//ПОДТЯГИВАЕМ НАЗВАНИЕ ДОЛЖНОСТИ
/*	ExecuteSQL("UPDATE CH_MAIN_PRN AS c SET FNAZV_DOL=(SELECT cl.Ftxt "
								+" FROM ^cl AS cl INNER JOIN ^stru_dol AS sd ON cl.Fwid=sd.Fwid_cl "
									+" INNER JOIN ^work_pers AS wp ON sd.Fwid=wp.Fwid_dol "
										+" WHERE wp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers WHERE "
														+" Fwid_cl=c.Ftabn_id AND Fbdat<="
														+sqlTo(D1)+" AND Fedat>="+sqlTo(D1)+")) "
								+" WHERE Flevel=2");
*/
	ExecuteSQL("UPDATE CH_MAIN_PRN SET FNAZV_DOL=(SELECT cl.Ftxt "
								+" FROM ^cl AS cl WHERE cl.Fwid=CH_MAIN_PRN.Fid_dol)"
								+" WHERE Flevel=2");
	//проставим название лицевых полей
	for(i=0;i<nameT.length;i++)
	{
		ExecuteSQL("UPDATE CH_MAIN_PRN SET FNAZV_"+pref[i]
			+"=(SELECT FTXT FROM ^LIC_FLD AS B WHERE CH_MAIN_PRN.FLSFID_"+pref[i]+"=B.FID)");
		ExecuteSQL("UPDATE CH_MAIN_PRN SET FFLD_NUM_"+pref[i]
			+"=(SELECT FFLD_NUM FROM ^LIC_FLD AS B WHERE CH_MAIN_PRN.FLSFID_"+pref[i]+"=B.FID)");
		if(i<2)
		{//Проставляем данные о переходящих суммах
					// !!!!!!!!!!!!! ES НЕ РААЛИЗОВАНО !!!!!!!!!!!!
					/*if (SQL)
						ExecuteSQL("UPDATE CH_MAIN_PRN AS A "
							+" SET FPEREX_"+pref[i]+"=" + sqlTo("ORACLE - NOT IMPLEMENTED")
							+" WHERE A.FMN_"+pref[i]+"<>"+SqlMaxDate
							+" AND  A.FMN_"+pref[i]+"IS NOT NULL");
					else
						ExecuteSQL("UPDATE CH_MAIN_PRN AS A "
		                	+" SET FPEREX_"+pref[i]+"= IIF((FMN_"+pref[i]+"<"+sqlTo(D1)
							+") AND (FVP_"+pref[i]+"=1),'в '+Cstr(Month(FMN_"+pref[i]
							+"))+'/'+Right(Cstr(Year(FMN_"+pref[i]+")),2) +' за '+Cstr(Month("+sqlTo(D1)
							+"))+'/'+Right(Cstr(Year("+sqlTo(D1)+")),2),"
							+"'в '+Cstr(Month("+sqlTo(D1)+"))"
							+"+'/'+Right(Cstr(Year("+sqlTo(D1)+")),2)+' за '+Cstr(Month(FMN_"+pref[i]+"))"
							+"+'/'+Right(Cstr(Year(FMN_"+pref[i]+")),2)"
							+")"
							+" WHERE A.FMN_"+pref[i]+"<>"+SqlMaxDate
							+" AND  A.FMN_"+pref[i]+" IS NOT NULL");*/
		}
	}

	include("objects\\DpAskEx.js");
	oA = new DpAskEx();
	oA.add("NUM", "Введіть максимальну кількість рядків на сторінці друку|Введите максимальное кол-во строк на странице печати", "MRC", 50, 5);
	if (!oA.doAsk())
	{
		return false;
	}
	var maxRowCount = oA.get("MRC");
	
	
	//добавим пустую запись-разделитель и проставим в не признак последней записи по каждому сотруднику Flevel=4
	//ExecuteSQL("update CH_MAIN_PRN as p1 set Flevel=4 where "
	// 		+" Fnum=(select MAX(Fnum) from CH_MAIN_PRN as p2 where p1.Ftabn_id=p2.Ftabn_id)")
	ExecuteSQL("insert into CH_MAIN_PRN (Ftabn_id,Ftabn,Ftabnorg,Fnum,Flevel) select DISTINCT Ftabn_id, Ftabn, Ftabnorg,99 as Fnum, 4 as Flevel from CH_MAIN_PRN")

	shabl = "CIKLIC";
	if(mParam.indexOf("SEND_")==-1)
		var tv = new DpTVars(shabl);
	else
		var tv = new DpTVars("LIST",shabl,true);
	var h = new Object();
	h.HDAT1 = D1;
	tv.setHTbl(h);
	tv.setVar("BDAT",D1)
	if(mParam.indexOf("SEND_")==-1)//печатаем список
	{
		//проставим признак (Flevel=5), по которому потом в печатной форме будем устанавливать разрыв страницы печати (PAGE BREAK=*RFLEVEL==5)
		var t2=OpenTable("select * from CH_MAIN_PRN order by "+(getPar("FTABNORG")?"ftabnorg":"ftabn")+",fnum,flevel");
		if (!isEmpty(maxRowCount) && t2.rowCount>maxRowCount)
		{
			var nRow = 1;
			var m_fwid=0;
			for(t2.MoveFirst(); !t2.IsEOF(); t2.MoveNext())
			{
				if(t2.getValue("Flevel")==4)
				{
					m_fwid=t2.getValue("Fwid") //запоминаем предыдущий
					nRow++;
				}
				if(t2.getValue("Flevel")==1)
				{
					snap = getSnap("select count(*) from CH_MAIN_PRN where ftabn_id="+t2.getValue("ftabn_id"));
					maxTabnCount = snap[0];//максимальное кол-во строк по сотруднику
					if (maxRowCount-nRow<=maxTabnCount)
					{
						ExecuteSQL("update CH_MAIN_PRN set Flevel=5 where Fwid="+sqlTo(m_fwid));
						nRow = 0;
					}
				}
				nRow++;
			}
			t2.requery();
		}
		tv.setRTbl(t2);
		tv.print();
		return tv;
	}
	else//печатаем в файл и рассылаем по почте сгруппировав расчетки по электронным ящикам
	{
		var tblMail = OpenTable("select Femail, count(*) as Fcnt, min(Fcod) as Fcod, min(Ftabn_id) as Ftabn_id from fout where "+(DataSource().selectedCount>0?" Fwid "+DataSource().sqlSelected(true):" 1=1 ")+" group by Femail");
		for(; !tblMail.IsEOF(); tblMail.MoveNext())
		{
//			if(allt(tblMail.getValue("Femail"))=="")
//				continue;
			if(tblMail.getValue("Femail").indexOf("@")==-1 && allt(tblMail.getValue("Femail"))!="")
			{
				if(!confirm(ru("Некорректный электронный адрес: ","Некоректна електрона адреса:")+tblMail.getValue("Femail"))+"\n"+ru("Продолжить?","Продовжити?"))
					return false;
			}
		}
		var form,ext;
		var fld = new Object();
		fld.fwid = "counter";
		fld.femail = "text";
		fld.fmphone = "text";
		fld.ftabn_id = "long";
		fld.fis_send = "bit";
		fld.fcod = "long";
		fld.Fcodmin = "long";
		fld.ffile = "longtext";
		fld.fnach = "double";
		fld.fuder = "double";
		fld.fkvip = "double";
		CreateTable("mail_log", fld);
		var curDat = new Date();
		var sDir = userDirectory()+"mail/zrp"+format("yyyymm",D1)+"_"+format("yyyy.mm.dd_HH-MM-SS",curDat);
		if(!isDir(sDir))
			createDirectory(sDir);
		var msgAsk = ru("Выполнить сразу отсылку расчетных листов по электронным адресам?","Виконати відразу відсилання розрахункових листів на електронні адреси?");
		var topic = /*ru("Расчетный лист за ","Розрахунковий лист за ")*/"zarplata "+format("mm/yyyy",D1);
		var msg = ReadParEx("MSG");
		var toSend = false;
		if(confirm(msgAsk))
		{
			toSend = true;
			var oAsk = new DpAskEx();
			oAsk.useDefsOnly = true;
			oAsk.add("T","Тема","TOPIC",topic,255);
			oAsk.add("T0","Повідомлення|Сообщение","MSG","",500,60);
			oAsk.add("COMBO","Кодування|Кодировка","ENCOD",getPar("MAIL_ENCODING"),"cp1251|cp866|utf8|latin1|KOI8-R",true);
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			topic = java.lang.String(java.lang.String(oAsk.get("TOPIC")).getBytes(oAsk.get("ENCOD")));
			msg = java.lang.String(java.lang.String(oAsk.get("MSG")).getBytes(oAsk.get("ENCOD")));
			WriteParEx("MSG",msg);
			setPar("MAIL_ENCODING",oAsk.get("ENCOD"));
		}
		setProgressRange(1, tblMail.rowCount);
		for(tblMail.MoveFirst(); !tblMail.IsEOF(); tblMail.MoveNext())
		{
			setProgressPos(tblMail.bookmark, (toSend?ru("Рассылка: ","Розсилання: "):ru("Формирование: ","Формування: "))+tblMail.getValue("Femail")+" ("+tblMail.bookmark+"/"+tblMail.rowCount+")");
			if(tblMail.getValue("Femail").indexOf("@")==-1 && allt(tblMail.getValue("Femail"))!="")
				continue;
			var t2=OpenTable("select * from CH_MAIN_PRN "
						+" where exists(select * from fout as f where f.ftabn_id=CH_MAIN_PRN.Ftabn_id and "+(allt(tblMail.getValue("Femail"))==""?"(f.Femail is null or f.Femail='' or f.Femail=' ')":"f.Femail="+sqlTo(tblMail.getValue("Femail")))+") "
						+" order by "+(getPar("FTABNORG")?"ftabnorg":"ftabn")+",fnum,flevel");
			if (!isEmpty(maxRowCount) && t2.rowCount>maxRowCount)//проставим признак (Flevel=5), по которому потом в печатной форме будем устанавливать разрыв страницы печати (PAGE BREAK=*RFLEVEL==5)
			{
				var nRow = 1;
				var m_fwid=0;
				for(t2.MoveFirst(); !t2.IsEOF(); t2.MoveNext())
				{
					if(t2.getValue("Flevel")==4)
					{
						m_fwid=t2.getValue("Fwid") //запоминаем предыдущий
						nRow++;
					}
					if(t2.getValue("Flevel")==1)
					{
						snap = getSnap("select count(*) from CH_MAIN_PRN where ftabn_id="+t2.getValue("ftabn_id"));
						maxTabnCount = snap[0];//максимальное кол-во строк по сотруднику
						if (maxRowCount-nRow<=maxTabnCount)
						{
							ExecuteSQL("update CH_MAIN_PRN set Flevel=5 where Fwid="+sqlTo(m_fwid));
							nRow = 0;
						}
					}
					nRow++;
				}
				t2.requery();
			}
			tv.setRTbl(t2);
			tv.bPreview = false;
			if(form)
			{
				tv.form = form;
				tv.ext = ext;
			}
			tv.form = rootDirectoryEx() +"listPrintForms/CIKLIC/ciklic_mail.xls";
			tv.ext = "xls";
			tv.bSave = true;
			var mailLogin = allt(tblMail.getValue("Femail"));
			if(mailLogin=="")
				mailLogin = "NO_MAIL";
			var ind = mailLogin.indexOf("@");
			if(ind!=-1)
			{
				mailLogin = mailLogin.substr(0,ind);
				ind = mailLogin.indexOf(".");
				if(ind!=-1)
					mailLogin = mailLogin.substr(0,ind);
			}
			mailLogin += format("_yyyymm",D1);
			if(tblMail.getValue("Fcnt")==1)
				mailLogin = mailLogin+"_tab№"+tblMail.getValue("Fcod");
			else
				mailLogin = mailLogin+"_"+tblMail.getValue("Fcnt");
			tv.sSaveFile = sFile = sDir+"/"+mailLogin+".xls";
			tv.print();
			var ok = false;
			if(isFile(sFile) && toSend)
				ok = sendMailMsg(topic, msg, tblMail.getValue("Femail"), sFile, true);
			//расгруппировываем по электронной почте
			var tPers = OpenTable("select * from fout where "+(allt(tblMail.getValue("Femail"))==""?"(Femail is null or Femail='' or Femail=' ')":"Femail="+sqlTo(tblMail.getValue("Femail")))+"")
			for(; !tPers.IsEOF(); tPers.MoveNext())
			{
				var m = new Object();
				m.Femail = tPers.getValue("Femail");
				m.Fmphone = tPers.getValue("Fmphone");
				m.Ftabn_id = tPers.getValue("Ftabn_id");
				m.Fcod = tPers.getValue("Fcod");
				m.Fcodmin = tblMail.getValue("Fcod");
				m.Fnach = tPers.getValue("Fnach");
				m.Fuder = tPers.getValue("Fuder");
				m.Fkvip = tPers.getValue("Fkvip");
				m.Fis_send = ok;
				var file = new java.io.File(sFile);
				m.Ffile = file.getAbsolutePath();
				UpdateTable("mail_log", m, true);
			}
		}
		setProgressPos(0);
		tblMail.close();
		var par = new Object();
		par.dat = D1;
		showWindow("l_rasl_mail.js",SW_NOMODAL,par);
	}
}
function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}
function saveRecord()
{
	var m = new Object()
	m.Fnach = list.tbl.getValue("Fnach")
	m.Fuder = list.tbl.getValue("Fuder")
	m.Fkvip = list.tbl.getValue("Fkvip")
	UpdateTable("fout", m, false, "Fwid="+list.tbl.getValue("Fwid"));
	return true;
}

function getTblH()
{
	num = input(ru("Введите номер ведомости: ","Введіть номер відомості"),ru("Ввод информации","Введення інформації"),0,4);
	bd = input(ru("Начало выдачи зарплаты: ","Початок виплати зарплати"),ru("Ввод информации","Введення інформації"),getPar("GLOBDAT1"))
	ed = input(ru("Окончание выдачи зарплаты: ","Закінчення виплати зарплати"),ru("Ввод информации","Введення інформації"),getPar("GLOBDAT2"))
	var h = new Object();
	h.HN_VED = num;
//	h.HSUM_KVIP = sum_vip;
	h.HBDAT = D1.getVarDate();
	h.HEDAT = D2.getVarDate();
	h.HBD_ZP = bd; 
	h.HED_ZP = ed;
	//если подразделение корневое, то не выводим
	var snap = getSnap("select Ftxt, Fwid_par from ^stru_org where fwid="+extPar.fwid)
	if(snap && snap[0] && snap[1])
		h.HPODR = snap[0];
	else
		h.HPODR = "";
	return h;	
}
include("sys/DpList.js");