//новая расчетно-платежная ведомость для печати типовой формы № П-7
include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");

var szTag,fwid,D1,D2,tblOut,tblName,tblNameN,tblNameU,svzpName;

function listLoad()
{
	with(this)
	{
   		title = ru("Просмотр расчетно-платежной ведомости","Перегляд розрахунково-платіжної відомості");
   		printLabel = "RPVP7";
   	}
	
	menuMode = GetMenuMode();
	if(menuMode.toUpperCase() == "VIEW")
	{
		var gd = new DpGetDat("d");
		D1 = new Date(firstDayMonth(gd.dat1));
		D2 = new Date(lastDayMonth(D1));
	}
	else
	{
		D1 = new Date(extPar.dat1); // дата начала
		D2 = new Date(extPar.dat2); // дата конца
	}
	this.title += " за "+format("dd.mm.yyyy",D1)+(extPar && extPar.fwid?" по '"+getTxtOrgByID(extPar.fwid)+"'":"");
	szTag = getDateTag(D1);
	tblName="RPVP7_"+szTag;
	tblNameN="RPVP7N_"+szTag;
	tblNameU="RPVP7U_"+szTag;
	// достаем цифры к названию файла
	svzpName = "^svzp"+szTag;
	if(!IsTableEx("zrp_res", "zrp_svzp"+szTag))
	{
		alert(ru("Сперва выполните расчет заработной платы за ","Спочатку виконайте розрахунок заробітної платні за ")+format("mm/yyyy",D1));
		return false;
	}
}

function listSrc()
{
	this.qrySet("From",tblName,"Order","Ftt,Fnum");
	this.clTie("nach", "=" + getPar("ZRP_RPLVED") + ", Fcod_n", "cl_nach");
	this.clTie("uder", "=" + getPar("ZRP_RPLVED") + ", Fcod_u", "cl_uder");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	oGrid.defCond("=^Ftt==1", "total")
	oGrid.color(1, "total");
	var grNach = gr.group("Нараховано за видами оплат|Начислено по видам оплат");
	grNach.FieldEx("Fnum_n", "№ п/п", 5, "zn");
	var grVopl = grNach.group("Вид оплати|Вид оплаты");
	grVopl.FieldEx("Fcod_n", "Код", 5, "zn");
	grVopl.FieldEx("=^Fisgr_n?String(^nach.Ftxt).toUpperCase():^Ftt==1?UR('Всього нараховано|Всего начислено'):^nach.Ftxt", "Назва|Название", 25);
	grNach.FieldEx("Fsum_n", "Сума|Сумма", 10, null, DP_FORMAT_SUM);
	
	var grUder = gr.group("Утримано|Удержано");
	grUder.FieldEx("Fnum_u", "№ п/п", 5, "zn");
	var grVuder = grUder.group("Вид утримання|Вид удержания");
	grVuder.FieldEx("Fcod_u", "Код", 5, "zn");
	grVuder.FieldEx("=^Fisgr_u?String(^uder.Ftxt).toUpperCase():^Ftt==1?UR('Всього утримано|Всего удержано'):^uder.Ftxt", "Назва|Название", 25);
	grUder.FieldEx("Fsum_u", "Сума|Сумма", 10, null, DP_FORMAT_SUM);
	oGrid.build();   		
}

function listMake()
{
	if(extPar.fwid!=null)
		fwid = extPar.fwid;
	else
	{
		alert(ru("Отсутствует идентификатор подразделения","Відсутній ідентифікатор підрозділ"),1);
		return false;
	}
	var fld = new Object();
	fld.Fwid = "COUNTER";
	fld.Fnum = "SHORT";
	fld.Fnum_n = "SHORT";
	fld.Fnum_u = "SHORT";
	fld.Fcod_n = "LONG";
	fld.Fcod_u = "LONG";
	fld.Fsum_n = "DOUBLE";
	fld.Fsum_u = "DOUBLE";
	fld.Fisgr_n = "BIT";
	fld.Fisgr_u = "BIT";
	fld.Ftt = "BYTE";
	var ind = new Object();
	ind.Fnum = "Fnum";
	ind.Fcod_n = "Fcod_n";
	ind.Fcod_u = "Fcod_u";
	CreateTable(tblName, fld, ind);
	fld.Fleftkey = "LONG";
	fld.Frightkey = "LONG";
	CreateTable(tblNameN, fld, ind);
	CreateTable(tblNameU, fld, ind);
	var snap = getSnap("select MIN(Fleftkey) as Fleftkey_n, MAX(Fleftkey) as Fleftkey_u, "
							+" MIN(Frightkey) as Frightkey_n, MAX(Frightkey) as Frightkey_u "
						+" from ^listcl where Fcl="+getPar("ZRP_RPLVED")+" and Fgrpid=0");
	if(snap)
	{
		var leftKeyN = snap[0];
		var leftKeyU = snap[1];
		var rightKeyN = snap[2];
		var rightKeyU = snap[3];
	}
	else
	{
		alert(ru("Не удалось определить коды групп начислений и удержаний в соответствующем справочнике расчетно-платежной ведомости",
				"Не вдалося визначити коди груп нарахувань і утримань у відповідному довіднику розрахунково-платіжної відомості"),2);
		return false;
	}
	var keySnap = getSnap("SELECT Fleftkey,Frightkey FROM ^stru_org WHERE Fwid="+fwid);
	if(!keySnap)
	{
		alert(ru("Не удалось определить левый и правый ключ для таблицы подразделений",
				"Не вдалося визначити лівий і правий ключ для таблиці підрозділів"),2);
		return false;
	}
	//сформируем таблицу начислений
	ExecuteSQL("insert into "+tblNameN+" (Fcod_n,Fsum_n,Fisgr_n,Fleftkey,Frightkey) "
				+" select v.Fcod, SUM(s.Fsum), v.Fisgrp, v.Fleftkey, v.Frightkey "
				+" from "+svzpName+" as s "
					+" inner join ^lic_fld as l on s.Flsfid=l.Fid "
						+" and NOT (s.Fvp=1 and s.Fmn>="+sqlTo(D1)+")"
					+" inner join ^full_pers as wp on wp.Fwid_cl=s.Ftabn_id and wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)
						+" and wp.Fleftkey>="+keySnap[0]+" and wp.Frightkey<="+keySnap[1]
						+" and wp.Fwid=(select MAX(Fwid) from ^work_pers as wp2 where wp.Fwid_cl=wp2.Fwid_cl "
							+" and wp2.Fbdat<="+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+")"
					+" right join ^listcl as v on v.Fcod=l.Frplatved "
				+" where v.Fcl="+getPar("ZRP_RPLVED")+" and v.Fleftkey>"+leftKeyN+" and v.Frightkey<"+rightKeyN
				+" group by v.Fcod,v.Fisgrp,v.Fleftkey,v.Frightkey");
	var tblN = OpenTable("select * from "+tblNameN+" order by Fcod_n");
	var k = 0;
	for(; !tblN.IsEOF(); tblN.MoveNext())
	{
		var m = new Object();
		m.Fnum = tblN.bookmark;
		if(tblN.getValue("Fisgr_n")==false)
			m.Fnum_n = ++k;
		UpdateTable(tblNameN, m, false, "Fwid="+tblN.getValue("Fwid"));
	}
	tblN.close();
	//сформируем таблицу удержаний
	ExecuteSQL("insert into "+tblNameU+" (Fcod_u,Fsum_u,Fisgr_u,Fleftkey,Frightkey) "
				+" select v.Fcod, SUM(s.Fsum), v.Fisgrp, v.Fleftkey, v.Frightkey "
				+" from "+svzpName+" as s "
					+" inner join ^lic_fld as l on s.Flsfid=l.Fid "
						+" and NOT (s.Fvp=1 and s.Fmn>="+sqlTo(D1)+")"
					+" inner join ^full_pers as wp on wp.Fwid_cl=s.Ftabn_id and wp.Fbdat<="+sqlTo(D2)+" and wp.Fedat>="+sqlTo(D1)
						+" and wp.Fleftkey>="+keySnap[0]+" and wp.Frightkey<="+keySnap[1]
						+" and wp.Fwid=(select MAX(Fwid) from ^work_pers as wp2 where wp.Fwid_cl=wp2.Fwid_cl "
							+" and wp2.Fbdat<="+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+")"
					+" right join ^listcl as v on v.Fcod=l.Frplatved "
				+" where v.Fcl="+getPar("ZRP_RPLVED")+" and v.Fleftkey>"+leftKeyU+" and v.Frightkey<"+rightKeyU
				+" group by v.Fcod,v.Fisgrp,v.Fleftkey,v.Frightkey");
	var tblU = OpenTable("select * from "+tblNameU+" order by Fcod_u");
	var k = 0;
	for(; !tblU.IsEOF(); tblU.MoveNext())
	{
		var m = new Object();
		m.Fnum = tblU.bookmark;
		if(tblU.getValue("Fisgr_u")==false)
			m.Fnum_u = ++k;
		UpdateTable(tblNameU, m, false, "Fwid="+tblU.getValue("Fwid"));
	}
	tblU.close();
	//итоги по группам
	var tblNameBuf = "tmp_tbl_buf";
	DropTable(tblNameBuf);
	ExecuteSQL("select * into "+tblNameBuf+" from "+tblNameN);
	ExecuteSQL("update "+tblNameN+" as t1 set Fsum_n=(select SUM(Fsum_n) from "+tblNameBuf+" as t2 where t2.Fisgr_n="+sqlFalse+" and t2.Fleftkey>t1.Fleftkey and t2.Frightkey<t1.Frightkey) where Fisgr_n="+sqlTrue);
	DropTable(tblNameBuf);
	ExecuteSQL("select * into "+tblNameBuf+" from "+tblNameU);
	ExecuteSQL("update "+tblNameU+" as t1 set Fsum_n=(select SUM(Fsum_n) from "+tblNameBuf+" as t2 where t2.Fisgr_u="+sqlFalse+" and t2.Fleftkey>t1.Fleftkey and t2.Frightkey<t1.Frightkey) where Fisgr_u="+sqlTrue);
	//сформируем результирующую таблицу
	ExecuteSQL("insert into "+tblName+" (Fnum, Fnum_n, Fnum_u, Fcod_n, Fcod_u, Fsum_n, Fsum_u, Fisgr_n, Fisgr_u) "
				+" select n.Fnum, n.Fnum_n, "+IIF("u.Fnum_u is null","0","u.Fnum_u")+", n.Fcod_n, "+IIF("u.Fcod_u is null","0","u.Fcod_u")
					+", "+IIF("n.Fsum_n is null","0","n.Fsum_n")+", "+IIF("u.Fsum_u is null","0","u.Fsum_u")+", n.Fisgr_n, "+IIF("u.Fisgr_u is null",sqlFalse,"u.Fisgr_u")
				+" from "+tblNameN+" as n left join "+tblNameU+" as u on n.Fnum=u.Fnum");
	//подбиваем итог
	var snap = getSnap("select SUM(Fsum_n) as Fsum_n from "+tblName+" where Fisgr_n="+sqlFalse);
	if(snap)
	{
		var m = new Object();
		m.Fsum_n = snap[0];
		var snap = getSnap("select SUM(Fsum_u) as Fsum_u from "+tblName+" where Fisgr_u="+sqlFalse);
		if(snap)
			m.Fsum_u = snap[0];
		m.Ftt = 1;
		UpdateTable(tblName, m, true);
	}
	return true;
}

function getTblH()
{
	var h = new Object();
	h.HDAT = D1.getVarDate();
	return h;
}
include("sys/DpList.js"); 