include("Objects/DpGetDat.js");
include("servis/format.js");
include("sys/dbase.js")
include("gridedit.js");

var editAcc = "E"
var prnPatt = "rezraz";
var delFilter = false;
var tblName;
var tbl;
var gr;
var ds;
var res_moni;
var objAsk, dpGridEdit;

function listLoad()
{ 
	ds = DataSource();
   	this.printLabel = "REZRAZ";
   	this.editTask = "e_rezraz.xml";
   	
   	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
 	
  	if(extPar && extPar.objAsk)
  		objAsk = extPar.objAsk;
  	else
  		objAsk = new DpGetDat("d");
	if(objAsk.escape)
		return false;

	if(extPar)
		extPar.dat1 = objAsk.dat1;
	res_moni = new Date(objAsk.dat1.getYear()+1900, objAsk.dat1.getMonth(), 1);
	//чтоб можно потом было считать дату в скриптах из popupmenu
	list.objAsk = objAsk;
	var res_mon = res_moni;
	monthtxt1 = format("yyyymm", res_mon);
	menuMode = GetMenuMode();
	if(extPar && extPar.menuMode)
		menuMode = extPar.menuMode;
	if(menuMode.length>0)
		tblName = menuMode+monthtxt1;
	else
		tblName = "schrii"+monthtxt1;
	switch(String(menuMode))
	{
		case "RZSHPB":
			this.title = ru("Просмотр разнесения по счетам (ШПЗ) за ","Перегляд рознесення по рахунках (ШВВ) за ")+format("dd.mm.yy",objAsk.dat1);
		break;
		case "RZSHPT":
			this.title = ru("Просмотр разнесения по счетам (ШПЗ + поля ЛС) за ","Перегляд рознесення по рахунках (ШВВ + поля ОР) за ")+format("dd.mm.yy",objAsk.dat1);
		break;
		case "RAZN2B":
		default:
			this.title = ru("Просмотр разнесения по счетам за ","Перегляд рознесення по рахунках за ")+format("dd.mm.yy",objAsk.dat1);
		break;
	}
	if (!IsTable(tblName))
    { 
   	    alert(ru("Выполните разнесение по счетам за выбранный месяц","Виконайте рознесення по рахункам за обраний місяць"));
       	return false;
   	}  
}

function listSrc()
{
	this.qrySet("From", tblName
				//,"Order", "FNAZV_OP");
				//,"Order", "FDB_SC,FDB_SU,FCR_SC,FCR_SU");
				//,"Order", "Fdoc_num,FDB_SC,FDB_SU,FDB_ST,FDB_COD1,FCR_SC,FCR_SU,FCR_ST,FCR_COD1,FNAZV_OP");
				,"Order", "FDB_SC,FDB_SU,FDB_ST,FDB_COD1,FCR_SC,FCR_SU,FCR_ST,FCR_COD1,FNAZV_OP");
	this.clTie("org0", "="+ getPar("CODMYORG") +",FORG0", "clorg0");
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	gr.FieldEx("Fdoc_num","№\nдок.|№\nдок.",5);
    gr.FieldEx("FNAZV_OP","Змiст  операцiї\n(пiдстава)|Содержание операции\n(основания)",20);
    with(gr.group("Дебет|Дебет"))
    {
    	FieldEx("Fdb_sc","Рах.|Сч.",7);
    	FieldEx("Fdb_su","С/рах.|С/сч.",7);
    	FieldEx("Fdb_st","Ст.|Ст.",7);
    	FieldEx("Fdb_cod1","Ан.1|Ан.1",7);
    	FieldEx("Fdb_cod2","Ан.2|Ан.2",7);
    	FieldEx("Fdb_cod3","Ан.3|Ан.3",7);
    }
    with(gr.group("Кредит|Кредит"))
    {
    	FieldEx("Fcr_sc","Рах.|Сч.",7);
    	FieldEx("Fcr_su","С/рах.|С/сч.",7);
    	FieldEx("Fcr_st","Ст.|Ст.",7);
    	FieldEx("Fcr_cod1","Ан.1|Ан.1",7);
        FieldEx("Fcr_cod2","Ан.2|Ан.2",7);
    	FieldEx("Fcr_cod3","Ан.3|Ан.3",7);
    }
    gr.FieldEx("Fsum","Сума|Сумма", GRID_SUM_WDT, "e", DP_FORMAT_SUM);
    gr.FieldEx("Fdate","Дата|Дата", 12);
	gr.FieldEx("=!^Forg0? '' : ^Forg0 +': '+ ^org0.Ftxt", "Організація|Организация", 6);
   	oGrid.build();   
}

function listMenuInit(ds)
{
	if(!list.tbl.isEmpty())
	{
		//ds.AddMenuItem("1","Перегляд списку платiжних доручень|Просмотр списока платежных поручений");   
    	//ds.AddMenuItem("2","Додавання платiжного доручення|Добавление платежного поручения");   
    	ds.AddMenuItem("MOVE_PROV","Перенести проведення в список|Перенести проводки в список");   
    	ds.AddMenuItem("4","Округлити суми|Округлить суммы");   
		ds.AddMenuItem("RBAZNACH","Показати базу та нарах.ЄСВ для розр.з кодами вир.|Показать базу и нач.ЕСВ для расч.с кодами изд.");		
    }
}


function listMenuRun(nID)
{
	switch (nID)
   	{
    	case "MOVE_PROV":	//просто переносим все в список проводок
    		var sFields = GetPatternIntersection("schr", "schet").replace(/(fwrk\s*,)|(,\s*fwrk)/gi,"")
       		var t = OpenTable("SELECT " + sFields + ", 5 as Fwrk, Fnazv_op as Ftxt, Fdoc_num as Fdocnum "
        		+" FROM "+tblName+" WHERE "+ds.sqlSelected());
    		
        	var k = 0;
        	if (!t.IsEmpty())
			{
				t.MoveFirst();
				while (!t.isEOF())
				{
					var m = scatter(t);
					delete(m.FNAZV_OP);
					delete(m.FDOC_NUM);
					m.FTXT = t.getValue("Ftxt")+" ("+t.getValue("Fdocvid")+")";
					m.FSUMSPR = 0;
					m.FVAL = 0;
					m.FVKURS = 0;
					m.FVALSPR = 0;
					m.FDOC = "";
					m.FNOP = 0;
					m.FID_DOC = 0;
					m.FWID = GetUID();
					UpdateTable("^schet", m, true);

					t.MoveNext();
					k++;
				}
			}
			t.close();
    		
       		alert(ru("Проводки перенесены в список.","Проведення перенесени до списку.")+" ("+k+" штук)");
      		break;
      		
    	case "4":  
       		var tabn = 0
       		var p_tabn = input(ru("Введите знак, до которого округлять суммы","Введіть знак, до якого округляти суми")
       						 , ru("Округление","Округлення"), tabn,2,0)
        	if(!p_tabn || p_tabn<0)
            	return;
        	var bm = list.tbl.bookmark;
        	
        	for(list.tbl.MoveFirst(); !list.tbl.IsEOF(); list.tbl.MoveNext())
            {
            	mFsum = list.tbl.getValue("Fsum");
                if (mFsum%(10*p_tabn)!=0)
                {	
                    ExecuteSQL("UPDATE ^"+ tblName +" SET FSUM="+ round(mFsum,p_tabn) +" WHERE FSUM="+ mFsum);
               	}
          	}
         	list.tbl.bookmark = bm;
         	grid.RefreshGrid(RG_SAVEROW);        
         	break;
		case "RBAZNACH":
	         par = new Object();
	         showWindow("l_fndev.js", SW_NOMODAL, par);
         	break;
        /* 	
      	case "PRINT":
        	include("objects\\DpTVars.js");
      		var tv = new DpTVars(prnPatt);
      		tv.setRTbl(tbl);
      		tv.print();
        	break;    
      	*/
      	//default:
         	//stdMenuHandler(nID, tbl);
   	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	UpdateTable(tblName, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function getTblH()
{
	var h = new Object();
	h.HFD1 = res_moni.getVarDate();
	h.HFD2 = lastDayMonth(res_moni);
	return h;
}

function listInitEditParam(par)
{
	par.tblName = tblName;
	par.dat1 = res_moni;
}
include("sys/DpList.js");