//include("sys\\ext.js");
include("sys\\dbase.js");

var title = "";
var tbl, ds;
var mFid_doc;
var tblName;
var TMPSZ;
var FDat = d00;
var FNom = 0;
var FRem = "";
var sMode = "";
if(extPar)
	sMode = extPar.mode.toUpperCase();

function listLoad()
{
	var group;
	var fields;
		
	mFid_doc = extPar.Fid_doc;
	tblName  = extPar.tblname;
	
	switch (sMode)
	{
		case "TRLIST":
			this.title = (ru("Транспортный лист", "Транспортний лист"));
			fields = "FDBKR,FADDOS";
			mForm = "svodsf";
			break;
		case "ZAKAZ":
			this.title = (ru("Сводный заказ", "Зведене замовлення"));
			fields = "FNMKL";
			mForm = "zakaz";
			break;
		case "TRNAKL":
			this.title = (ru("Транспортная накладная","Транспортна накладна"));
			fields = "FNMKL,FCENAPR,FPNDS";
			mForm = "trnakl";
			break;
		case "TRNKNP":
			this.title = (ru("Транспортная накладная (по  покупателям)", "Транспортна накладнa (за покупцями)"));
			fields = "FNMKL,FCENAPR,FDBKR,FPNDS";
			mForm = "trnakl";
	}
	group = (fields)? " GROUP BY "+fields : "";
	
	if (mFid_doc)
	{
		tbl = OpenTable("s", "SELECT * FROM ^ZAK_NAME");
		if (SQL)
			tbl.index = "FWID";

		if (!tbl.IsEmpty() && tbl.FindFirst("Fid_doc="+ mFid_doc))
		{
			FDat = tbl.getValue("FDOC_DAT");
			FNom = tbl.getValue("FDOC_NUM");
			FRem = tbl.getValue("NAME_D");
		}
		else
		{
			tblName = getTmpTableName();
			ExecuteSQL("SELECT "
					+ " INTO " + tblName
					+ " * FROM ^ZAK_STOR "
					+ " WHERE FID_DOC = " + sqlTo(mFid_doc)					
					);
		}
	}
	TMPSZ = getTmpTableName();	
	ExecuteSQL("SELECT 0000 AS FN, "
			+ " SUM(FKOL) as FKOL_GR,"
			+ " SUM(FCENAPR * FKOL) as FOSUM_GR,"
			+ " SUM(FCENAPR * FKOL * (1 + FPNDS)) as FOSUMN_GR "			
			+ ((fields)?", " + fields:"")
			+ " INTO " + TMPSZ
			+ " FROM " + tblName
			+ group
			);
			
	tbl.requery();
}

function listMenuInit()
{
  	var ds = this.dataSrc;
  	if (sMode != "TRLIST")
		ds.AddMenuItem("TRLIST","Транспортний лист|Транспортный лист" );
	if (sMode != "ZAKAZ")
		ds.AddMenuItem("ZAKAZ","Зведене замовлення|Сводный заказ");
	if (sMode != "TRNAKL")
		ds.AddMenuItem("TRNAKL","Транспортна накладна|Транспортная накладная");
	if (sMode != "TRNKNP")
		ds.AddMenuItem("TRNKNP","Транспортна накладнa (за покупцями)|Транспортная накладна (по  покупателям)");
//	ds.AddMenuItem("","");
//	ds.AddMenuItem("DEL","Видалити|Удалить");
//	ds.AddMenuItem("PRINT","Друк|Печать");  	
}

function listMenuRun(nID)
{
	var par = new Object();
	par.Fid_doc = mFid_doc;
	par.tblname = tblName;
			
	switch (nID)
	{
		case "TRNKNP":
			par.mode = "TRNKNP";
			break;
		case "TRLIST":
			par.mode = "TRLIST";
			break;
		case "ZAKAZ":
			par.mode = "ZAKAZ";
			break;
		case "TRNAKL":
			par.mode = "TRNAKL";
			break;
/*		case "DEL":
			tbl.Delete();
			grid.Refreshgrid();			
			return;
		case "PRINT":
		    include("objects\\DpTVars.js");
			var tv      = new DpTVars();
			var prnName = "";
			switch (sMode)
			{
				case "TRNAKL":
				case "TRNKNP":
					prnName = "TRNAKL";
					break;
				case "TRLIST":
					prnName = "SVODSF";
					break;
				case "ZAKAZ":
					prnName = "ZAKAZ";
			}
			var tblH = new Object();
			tblH.FDOC_NUM = FNom;
			tblH.FDOC_DAT = FDat;
			tv.setPatt(prnName);
            tv.setDoc("SZ");
            tv.setHTbl(tblH);
            tv.setRTbl(tbl);
            tv.print();
			return;
*/		
		default:
			return;
	}
	showWindow("l_rsz.js", SW_NOMODAL, par);
}

function listSrc()
{			
	this.qrySet("From", TMPSZ)//, "Order", IIF("f_01=0", "99999", "f_01"));
	//if (SQL)
		this.subTie("CL_NMK", "x_nmk", "FWID", "Fnmkl");
	//else
		//this.subTie("CL_NMK", "x_nmk", "COD", "Fnmkl");
	this.clTie("x_post", "="+sprOrg+",Fdbkr");		
}

function listDpGrid()
{
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{		
		with(page())
		{
			cell("=list.dataSrc.getTable().getAbsolute()", "№|№", 5, null, "%10d");
			if (sMode == "TRLIST")
			{
				cell("x_post.Ftxt", "Платник|Плательщик", 10);
				cell("FADDOS", "Адреса доставки|Адрес доставки", 10);
				cell("FOSUMN_GR", "Сума|Сумма", 10, "", DP_FORMAT_SUM);	
			}
			else	
			{
				cell("=^x_nmk.Fcod+\": \"+^x_nmk.Ftxts", "Найменування|Наименование", 20);
				if (sMode == "TRNKNP" || sMode == "TRNAKL")
					cell("FCENAPR", "Ціна|Цена", 10);
				cell("FKOL_GR", "Кількість|Количество", 10, "", DP_FORMAT_KOL);
				cell("FOSUMN_GR", "Сума|Сумма", 10, "", DP_FORMAT_SUM);	
	
				if (sMode == "TRNKNP")
				{
					//cell("FN", "№|№", 5);
					cell("x_post.Ftxt", "Платник|Плательщик", 20);
					//cell("FCENAPR", "Ціна|Цена", 10);
					//cell("FKOL_GR", "Кількість|Количество", 10);
					//cell("FOSUMN_GR", "Сума|Сумма", 15);
				}
			}
		}
		build();
	}	
}

include("sys\\DpList.js")	