include("doc/DpDoc.js");

var tmpName = getTmpTableName();
var workTbl; 
var par = Object();
function listAsk()
{
	
	showWindow("i_filter.xml",SW_MODAL,par);
	return par;
}

function listLoad()
{
	workTbl = (extPar.tblName)?extPar.tblName:getTmpTableName();
	
	tblName = (extPar.FltName)?extPar.FltName:"CLRELCLCL";
	
	ExecuteSQL("CREATE TABLE " + workTbl + "("
					+ "FCOD " + SqlType("LONG") + ", "
					+ "FCOUNTRY " + SqlType("LONG") + ", "
					+ "FREGION " + SqlType("LONG") + ", "
					+ "FAREA " + SqlType("LONG") + ", "
					+ "FLOCATE " + SqlType("LONG") + ", "
					+ "FLPU " + SqlType("LONG") + ", " 
					+ "FBUDJET " + SqlType("LONG") + ", " 
					+ "FDOG " + SqlType("TEXT",25)+ ", "
					+ "FID_DOG " + SqlType("LONG")+ ", "
					+ "FZONE " + SqlType("LONG") + ", "
					+ "FCENA " + SqlType("DOUBLE") + ", "
					+ "FKOL " + SqlType("CURRENCY") + ", "
					+ "FEXIST " + SqlType("BYTE") + " default "+ SqlFalse +", "
					+ "FWID " + SqlType("COUNTER")
					+ ")"
				);	
	var dat = new Date(extPar.dat.getYear()+1900,0,0);
	include ("Objects\\DpExtentionBuilder.js");
	var oBujet = new DpExtentionBuilder("CL","0",null);
	var tblBudName = oBujet.getValueTableName();
	
	ExecuteSQL("INSERT INTO " + workTbl + "(FCOD,FCOUNTRY,FREGION,FAREA,FLOCATE,FLPU,FDOG,FID_DOG,FZONE,FCENA,FBUDJET) "
			+ "SELECT c.forg,h.fcountry,h.fregion,h.farea,h.flocate,h.flpu,c.fdog_num,c.fwid,h.fzone,0,ext.f_budjet as FBUDJET from ^contract as c inner join ^htd as h on c.fwid=h.fid_dog "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblBudName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " where c.fbdat <= " + sqlTo(extPar.dat) + " and c.fedat >= " + sqlTo(extPar.dat) + " and cl.Fcl=12"
			);
						
	
	
	var oDoc = new DpDoc("TD",0);
	var tf = oDoc.getPar("__tarif");
	if (tf == 0)
	{
		alert(UR("Виконайте налагодження документу TD|Настройте документ TD"));
		return false;
	}
	var oExt = new DpExtentionBuilder("CL",tf,null);
	var tblEName = oExt.getValueTableName();
	
	ExecuteSQL("update " + workTbl+ " set Fcena=(select MAX(FTARIF) from " + tblEName + " where FBDAT = (select MAX(FBDAT) from " + tblEName + " where fzona = " + workTbl+ ".fzone"
			 + " and FBDAT<=" + sqlTo(extPar.dat) + " group by fzona) and fzona = " + workTbl+ ".fzone )" );
	
	var sRowTbl = extPar.rowName;
	if(sRowTbl)
	{
		var sSQL = "update "+ workTbl +" as w "
					+" set w.FKOL=(select SUM(r.FKOL) "
						+" from "+ sRowTbl +" as r"
						+" where w.FCOD=r.FCLIENT"
							+" and w.FID_DOG=r.FID_DOG)";
		ExecuteSQL(sSQL);
		ExecuteSQL("update "+ workTbl +" set FEXIST="+ SqlTrue +" where FKOL>0");
	}
	
	with(this)
	{
		title = "Масовий вибір|Массовый выбор";
		xmlGridFile = "l_rumass.xml";
	}
	include("gridedit.js");
	new DpGridEdit(grid);
			
	this.subUnLoad = subUnLoad;
}

function listSrc()
{	
	var sWhere = "1 = 1";
	if (par.oLpu != null && par.oLpu != 0)
		sWhere += " AND FLPU=" + sqlTo(par.oLpu);
	if (par.oObl != null && par.oObl != 0)
		sWhere += " AND FREGION=" + sqlTo(par.oObl);
	if (par.oArea != null && par.oArea != 0)
		sWhere += " AND FAREA=" + sqlTo(par.oArea);
	if (par.oBud != null && par.oBud != 0)
		sWhere += " AND FBUDJET=" + sqlTo(par.oBud);
	
	this.qrySet("From",workTbl
				,"Where",sWhere
				,"Order","Fcod"
				);	
	this.clTie("cl","=" + sqlTo(getPar("CODPLAT"))+", Fcod");	
}

function subUnLoad()
{
	if (!confirm(ru("Сохранить введенные данные?","Зберегти введені дані?")))
		ExecuteSQL("update " + workTbl + " set Fkol=0");
	extPar.tblName = workTbl;
}

include ("sys/DpList.js");