include("Objects/DpAskEx.js");

// идентификатор базы
var sBase;

// Имя таблицы и индекса, по которому бегаем
var sTblName = "VSRAZN";
var sIdxName = "VSRAZN";
// Режим по умолчанию
var sMode = "RAZN";

function listLoad()
{
    // 25.12.2001
    // Теперь этот файл предназначен для просмотра как самой разноски, так
    // и списка шаблонов проводок. Вариант вызова - в extPar.mode:
    // "RAZN" - настройка собственно разноски (таблица VSRAZN)
    // Если в extPar ничего не передано, то считаем, что "RAZN"
	
	this.editTask = "e_rznfnd.xml";
	
    if(extPar && extPar.mode)
    {
       	// передан extPar.mode
       	sMode = extPar.mode;

       	switch(sMode)
       	{
       	case "RAZN":
          	sTblName = "VSRAZN";
          	sIdxName = "VSRAZN";
          	break;
       	default:
          	alert(ru("Неверный режим вызова: ","Невірний режим виклику: ") + extPar.mode);
          	return false;
       	}
    } 

    // Установим заголовок окна
    var sCaption = "";
    switch(sMode)
    {
    case "RAZN":
       sCaption = "Настроювання рознесення по рахунках 2|Настройка разноски по счетам 2";
       break;
    }
    this.title = sCaption;
/*    
    var gr, strSQL;
    t1 = OpenTable("s", sTblName, sIdxName);
	ds1.Source(t1);  
	
	ds1.AddSearchField("FNOM", "Номеру|Номера", dbInteger);
	ds1.AddSearchField("FNAZV_OP", "Назва оп|Название оп", dbText);
	ds1.AddSearchField("Fdb_sc", "Дебет рах.|Дебет сч.", dbInteger);
	ds1.AddSearchField("Fdb_su", "Дебет с/р.|Дебет с/с.",dbInteger);
	ds1.AddSearchField("Fdb_st", "Дебет с/р.|Дебет с/с.",dbInteger);
	ds1.AddSearchField("Fdb_cod1", "Ан.1 по дебету|Ан.1 по дебету",dbInteger);
	ds1.AddSearchField("Fdb_cod2", "Ан.2 по дебету|Ан.2 по дебету",dbInteger);
	ds1.AddSearchField("Fdb_cod3", "Ан.3 по дебету|Ан.3 по дебету",dbInteger);
	ds1.AddSearchField("Fcr_sc", "Кредит рах.|Кредит сч.", dbInteger);
	ds1.AddSearchField("Fcr_su", "Кредит с/р.|Кредит с/с.",dbInteger);
	ds1.AddSearchField("Fcr_st", "Кредит с/р.|Кредит с/с.",dbInteger);
	ds1.AddSearchField("Fcr_cod1", "Ан.1 по кредиту|Ан.1 по кредиту",dbInteger);
	ds1.AddSearchField("Fcr_cod2", "Ан.2 по кредиту|Ан.2 по кредиту",dbInteger);
	ds1.AddSearchField("Fcr_cod3", "Ан.3 по кредиту|Ан.3 по кредиту",dbInteger);
*/      
}

function listSrc()
{       
	this.qrySet("From", "^"+ sTblName
				,"Order", "Fnom");
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	var grid = new DpGrid("NOCREATE");
    var gr = grid.page();
            
	//----- Содержание ------    
    switch(sMode)
    {
    case "RAZN":
       	gr.FieldEx("Fnom", "Номеp|Номеp", 6);
       	break;
    }
    gr.FieldEx("Fnazv_op", "Змiст\nоперацiї|Содеpжание\nоперации", 20, "w");
    gr.FieldEx("Frem", "Коментар|Комментарий", 25, "w");
    gr.FieldEx("Fproc", "Відсоток|Процент", 5, "w");
    
    //----- Хоз.оп. ------
    with(gr.group("Дебет|Дебет"))
    {
    	FieldEx("Fdb_sc", "Рах.|Сч.", 4);
    	FieldEx("Fdb_su", "С/р.|С/с.", 4);
    	FieldEx("Fdb_st", "Ст.|Ст.", 6);
    	FieldEx("Fdb_cod1", "Ан.1|Ан.1", 6);
    	FieldEx("Fdb_cod2", "Ан.2|Ан.2", 6);
    	FieldEx("Fdb_cod3", "Ан.3|Ан.3", 6);
	}
	with(gr.group("Кредит|Кредит"))
    {
    	FieldEx("Fcr_sc", "Рах.|Сч.", 4);
    	FieldEx("Fcr_su", "С/р.|С/с.", 4);
    	FieldEx("Fcr_st", "Ст.|Ст.", 6);
    	FieldEx("Fcr_cod1", "Ан.1|Ан.1", 6);
    	FieldEx("Fcr_cod2", "Ан.2|Ан.2", 6);
    	FieldEx("Fcr_cod3", "Ан.3|Ан.3", 6);
	}    

    //----- Сумма ------    
    gr.FieldEx("=^Fgroup==0? '"+ UR("не розбивати|не разбивать")+"'"
        	+" : ^Fgroup==1? '"+ UR("по iнвал.|по инвал.")+"'"
        	+" : ^Fgroup==2? '"+ UR("по iншим спiвр.|по ост.сотр.")+"'"
    		+" : ''", "Iнвалiди\nсуми|Инвалиды\nсуммы", 12);
    gr.FieldEx("Fis_ogr", "Обмеж.|Огр.", 5);
    gr.FieldEx("Fis_tabn", "Пров.по TN|Пров.по TN", 5);
    gr.FieldEx("Fis_sh", "TN до деб.|TN до деб.", 5);
    gr.FieldEx("Fis_exp", "TN з розш.|TN из расш.", 5);
    gr.FieldEx("=^Fprizn=='т'? '"+ UR("за поточний місяць|за текущий месяц")+"'"
    		+" : ^Fprizn=='б'? '"+ UR("за майбутні місяці|за будущие месяцы")+"'"
    		+" : ^Fprizn=='п'? '"+ UR("за минулі місяці|за прошлые месяцы")+"'"
    		+" : ^Fprizn=='с'? '"+ UR("випл.в минулому(сторно)|выпл.в прошл.(сторно)")+"'"
    		+" : '"+ UR("всі|все")+"'", "Брати\nсуми|Брать\nсуммы", 20);

    //----- Поле ЛС ------    
    with(gr.group("Поле ОР|Поле ЛС"))
    {
    	FieldEx("Fls_incl", "Для|Для", 20);
    	FieldEx("Fls_excl", "Кpiм|Кpоме", 20);    	
    	FieldEx("=^Fis_ls!=true?false:^Fis_ls", "Гpупувати|Гpуппиpовать", 12);
    }
    
    //----- Подразделение ------
    with(gr.group("Підрозділ|Подразделение"))
    {
    	FieldEx("Flv_incl", "Для|Для", 20);
    	FieldEx("Flv_excl", "Кpiм|Кpоме", 20);    	
    	//with(group("Гpупувати|Гpуппиpовать"))
    	{
    		FieldEx("=^Fis_lv1!=true?false:^Fis_lv1", "Груп.1", 5);
    		FieldEx("=^Fis_lv2!=true?false:^Fis_lv2", "Груп.2", 5);
    		FieldEx("=^Fis_lv3!=true?false:^Fis_lv3", "Груп.3", 5);
    		FieldEx("=^Fis_lv4!=true?false:^Fis_lv4", "Груп.4", 5);
    	}    	
	}
    
    //----- Категория ------    
    with(gr.group("Категорія|Категория"))
    {	
    	FieldEx("Fkat_incl", "Для|Для", 20);
    	FieldEx("Fkat_excl", "Кpiм|Кpоме", 20);
    	FieldEx("=^Fis_kat!=true?false:^Fis_kat", "Гpупувати|Гpуппиpовать", 2);
	}
	with(gr.group("Вираз|Выражение"))
    {	
    	FieldEx("Fexpr", "Вираз|Выражение", 20);
    	FieldEx("Fexp_incl", "Для|Для", 20);
    	FieldEx("Fexp_excl", "Кpiм|Кpоме", 20);
    	FieldEx("=^Fis_exp!=true?false: ^Fis_exp", "Гpупувати|Гpуппиpовать", 2);
	}
    grid.build();
}

function listMenuInit(ds1)
{
    ds1.AddMenuItem("SHR","Пiдроздiли|Подразделения");
    ds1.AddMenuItem("CL_LIC","Коди полiв особових рахунків|Коды полей лицевых счетов");
    if(ds1.getTable().isRecord())
    {
	    ds1.AddMenuItem("+++","Сервіс|Сервис");
//	    ds1.AddMenuItem("RENUM","Перенумерувати|Перенумеровать");
	    ds1.AddMenuItem("EDIT_FWID","Проставити унікальні FWIDи|Проставить уникальные FWIDы");
	    ds1.AddMenuItem("EDIT_PD","Скопировать записи с новыми подразд.|Скопировать записи с новыми подр.");	    
    	ds1.AddMenuItem("---","Сервіс|Сервис");
	}
	ds1.AddMenuItem("COPY_MASS","Копіювати масово зі змінами рахунків|Копировать массово с изменением счетов");
}

function listMenuRun(ID)
{
	var par = new Object();
	var t1 = list.tbl;
	var tmFwid = t1.getValue("Fwid");

	switch(ID)
	{
	   	case "EDIT_FWID":
	    	// проставляет уникальные Fwidы
	        // Нужно после копирования Access'ом строк
	        for(t1.MoveFirst(); !t1.IsEOF(); t1.MoveNext())
	        {
	        	tmFwid = t1.getValue("Fwid");
	        	ExecuteSQL("UPDATE "+ sTblName +" SET FWID="+ GetUID()
	        			+" WHERE FWID="+ tmFwid); 
	        }
	        break;
   	case "EDIT_PD":
   		fidd = input(ru("Введите код ан.1 по дебету","Уведіть код ан.1 по дебету")
		  , ru("Массовое копирование","Масове копіювання"), 0, 6, 0);
   		if(!fidd)
   			break;
   		
   		fidk = input(ru("Введите код ан.1 по кредиту","Уведіть код ан.1 по кредиту")
   			  , ru("Массовое копирование","Масове копіювання"), 0, 6, 0);
   	   		if(!fidk)
   	   			break;

   		fpdr = input(ru("Введите код подр.","Уведіть код пiдр.")
   	   			  , ru("Массовое копирование","Масове копіювання"), 0, 6, 0);
   	   	if(!fpdr)
   	   	   			break;

   	   	DropTable("trshpz");
   	   	strSQL = "select * into trshpz from ^"+ sTblName +"  WHERE "+ DataSource().sqlSelected();
   	   	ExecuteSQL(strSQL);
   	   	ExecuteSQL("update trshpz set Fdb_cod1="+sqlTo(fidd)+", Fcr_cod1="+sqlTo(fidk)+", Flv_incl="+sqlTo(fpdr))
   	   	

   	   	var trshp = OpenTable("s", "select * from trshpz")
   	   	for(trshp.MoveFirst(); !trshp.IsEOF();  trshp.MoveNext())
   	   	{
   	   		ExecuteSQL("update trshpz set fwid="+ GetUID() +" where fwid="+ trshp.getValue("fwid"));
   	   	}
   	   	strSQL = "INSERT into ^"+ sTblName + getColumn("trshpz",true) + 
			" select " + getColumn("trshpz",false) + " from trshpz";
   	   	ExecuteSQL(strSQL);
	   	
   	   	t1.requery();
   	   	RestoreMarker(t1);
   	   	grid.clearSelected();
   	   	grid.RefreshGrid();
   	   	break;
	   	case "RENUM":	// перенумеровать строки
			oA = new DpAskEx();
			oA.add("NUM", "Перенумеровать с ", "BNOM",0, 5)
			oA.add("NUM", "Перенумеровать по ", "ENOM",0, 5)
			oA.add("NUM", "С шагом", "STEP",10, 5)
			oA.doAsk();
			if(oA.escape)
			{
				return;
			}
			
			var step	= oA.get("STEP");
			var bNom	= oA.get("BNOM");
			var eNom	= oA.get("ENOM");
			var mFnom	= 1000;
			var ttt = OpenTable("s","SELECT * FROM ^VSRAZN ORDER BY FNOM");
			for(ttt.MoveFirst(); !ttt.IsEOF(); ttt.MoveNext())
			{
				if(ttt("FNOM")>=bNom && ttt("FNOM")<eNom)
				{
					ttt.Edit();
					ttt("FNOM") = mFnom;
					ttt.Update();
					mFnom+=step;
				}
			}
			ttt.Close();
			t1.Requery();
			break;
	   
	   case "CL_LIC":
	         // Параметры лицевых счетов
	         par = new Object();
	         showWindow("r_licfld.js", SW_NOMODAL, par);
	         break;
	   
	   case "SHR":
	         // Параметры подразделений
	         showWindow("l_shtat.xml", SW_NOMODAL, par);
	         break;
		case "COPY_MASS":
			var oAsk = new DpAskEx();
			oAsk.add("CUT","Дебет рахунок|Дебет счет","DB_SC",null,"CUT");
			oAsk.add("T","Дебет ан.1|Дебет ан.1","DB_A1","0",10);
			oAsk.add("T","Дебет ан.2|Дебет ан.2","DB_A2","0",10);
			oAsk.add("T","Дебет ан.3|Дебет ан.3","DB_A3","0",10);
			oAsk.add("HR", null, "HR");
			oAsk.add("CUT","Кредит рахунок|Кредит счет","CR_SC",null,"CUT");
			oAsk.add("T","Кредит ан.1|Кредит ан.1","CR_A1","0",10);
			oAsk.add("T","Кредит ан.2|Кредит ан.2","CR_A2","0",10);
			oAsk.add("T","Кредит ан.3|Кредит ан.3","CR_A3","0",10);
			oAsk.add("B","Створювати додатковий рядок з інвертованою кореспонденцією|Создавать дополнительную строку с инвертированной корреспонденцией","TO_INVERT",false);
			oAsk.doAsk();
			if(oAsk.escape)
				return false;
			var t = OpenTable("select * from ^"+sTblName+" where Fwid "+DataSource().sqlSelected(true));
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, t.bookmark+"/"+t.rowCount);
				var m = scatter(t);
				m.FWID = GetUID();
				m.FDB_SC = oAsk.get("DB_SC").getSc();
				m.FDB_SU = oAsk.get("DB_SC").getSu();
				m.FDB_ST = oAsk.get("DB_SC").getSt();
				m.FDB_COD1 = oAsk.get("DB_A1");
				m.FDB_COD2 = oAsk.get("DB_A2");
				m.FDB_COD3 = oAsk.get("DB_A3");
				m.FCR_SC = oAsk.get("CR_SC").getSc();
				m.FCR_SU = oAsk.get("CR_SC").getSu();
				m.FCR_ST = oAsk.get("CR_SC").getSt();
				m.FCR_COD1 = oAsk.get("CR_A1");
				m.FCR_COD2 = oAsk.get("CR_A2");
				m.FCR_COD3 = oAsk.get("CR_A3");
				UpdateTable("^"+sTblName, m, true);
				if(oAsk.get("TO_INVERT")==true)
				{
					m.FWID = GetUID();
					m.FCR_SC = oAsk.get("DB_SC").getSc();
					m.FCR_SU = oAsk.get("DB_SC").getSu();
					m.FCR_ST = oAsk.get("DB_SC").getSt();
					m.FCR_COD1 = oAsk.get("DB_A1");
					m.FCR_COD2 = oAsk.get("DB_A2");
					m.FCR_COD3 = oAsk.get("DB_A3");
					m.FDB_SC = oAsk.get("CR_SC").getSc();
					m.FDB_SU = oAsk.get("CR_SC").getSu();
					m.FDB_ST = oAsk.get("CR_SC").getSt();
					m.FDB_COD1 = oAsk.get("CR_A1");
					m.FDB_COD2 = oAsk.get("CR_A2");
					m.FDB_COD3 = oAsk.get("CR_A3");
					UpdateTable("^"+sTblName, m, true);
				}
			}
			setProgressPos(0);
			t.close();
			this.tbl.requery();
			grid.RefreshGrid();
		break;
	}
	/*
	//super vv поборемся, чтобы маркер не скакал
	if (!isEmpty(tmFwid))
	{
		var tttt = ds1.GetTable();
		tttt.Requery();
		tttt.FindFirst("Fwid="+sqlTo(tmFwid));
		grid.RefreshGrid(RG_SAVEROW);
	}
	*/
}

include("sys/DpList.js");