include("objects/DpGetDat.js");
include("doc/DpDoc.js");
include("servis/date.js");


var strSelectID = "";
var bdat = edat = null;;
var dpTree = null;

function onLoad()
{
	var gd = new DpGetDat("dD");
	if (gd.escape == true)
		return false;
	bdat = gd.dat1;
	edat = gd.dat2;
	
	Caption(UR("Штатний розклад підприємства з |Штатное расписание предприятия с ")
		 + StrDat(bdat, "DMY") + UR(" до | по ") + StrDat(edat, "DMY"));
		 
	dpTree = createDpTree();
	if (dpTree.elements.length > 0)
		loadTree();
	else
		Tree.addItem("0", "empty", UR("Не знайдено жодної організації|Не найдено ни одной организации"));
}

function loadTree()
{
	Tree.setItemImage(8, rootDirectoryEx() + "/icons/iDol.gif");
	Tree.setItemImage(9, rootDirectoryEx() + "/icons/iLDol.gif");
	Tree.setItemImage(10, rootDirectoryEx() + "/icons/iVDol.gif");

	list.onTreeSelected = onTreeSelected;
	list.onTreeExpand = onTreeExpand;
	
	list.onTreeSelectMenuHandler = onTreeSelectMenuHandler;
	list.onTreeMenuInit = onTreeMenuInit;	
	Tree.selectMenuHandler(this, "onTreeSelectMenuHandler");
	Tree.loadMenuHandler(this, "onTreeMenuInit");
	Tree.setTreeSelHandler(this, "onTreeSelected");
	Tree.setExpandHandler(this, "onTreeExpand");
	list.onTreeCanEdit = new Function("return false");
	Tree.setCanEditHandler(this, "onTreeCanEdit");	
	
	fillTreeEx(dpTree, 0, 2);
	strSelectID = dpTree.elements[0].getID();
	Tree.setSelected(strSelectID);
		
	list.onGridMenuInit = onGridMenuInit;
	list.onGridMenuHandler = onGridMenuHandler;
	grid.loadMenuHandler(this, "onGridMenuInit");
	grid.selectMenuHandler(this, "onGridMenuHandler");
	
	DropTable("tmp_table");
	createTmpTable();
	grid.setXMLFile("l_shtatRas.xml");	
	showGrid(strSelectID);
}

function onEscape()
{
	dpTree.dispose();
}

function onTreeSelectMenuHandler(sID)
{
	var useObject = Tree.getObject(strSelectID);
	switch(sID)
	{
		case "ADDP":
			onGridMenuHandler(sID);
			break;
			
		case "DOUBLECLICK":
			onTreeExpand(strSelectID);
			Tree.reExpand(strSelectID);
			break;
			
		case "SHOW_OBJ":
			showObject(useObject, SW_MODAL);
			break;
	}
}

function onTreeMenuInit(toObject)
{
	var useObject = Tree.getObject(strSelectID);		
	if (useObject.isorg)
	{
		toObject.AddMenuItem("EDITORG", "Редагувати організацію|Редактировать организацию");
		toObject.AddMenuItem("EDITORG", "Ліквідувати організацію|Ликвидировать организацию");
	}
	if (useObject.ispodr)
		toObject.AddMenuItem("ADDP","Призначити...|Назначить...");

	if (lpProxy.isDebug() == true && isAdministrator())
	{
		toObject.AddMenuItem("", "");
		toObject.AddMenuItem("SHOW_OBJ", UR("Показати об'єкт|Показать объект"));	
	}
}

function onGridMenuInit(toObject)
{
	toObject.AddMenuItem("ADDP","Призначити...|Назначить...");
	toObject.AddMenuItem("", "");
	if (!grid.table.IsEmpty())
	{
		if (differ(toScriptDate(grid.table.getValue("fedat")), toScriptDate(d00)) == 0)
		{
			toObject.AddMenuItem("MOVEP","Перевести...|Перевести...");
			toObject.AddMenuItem("DELP","Звільнити...|Уволить...");	
			toObject.AddMenuItem("", "");
		}
		var isInPRK = false;

		var fwid = Number(grid.table.getValue("fwid"));
		var fields = new Array();
		fields[0] = "fwid_in";
		if (differ(toScriptDate(d00), toScriptDate(grid.table.getValue("fedat"))) == 1)
			 fields[0] = "fwid_out";
		
		var snap = getSnap("SELECT COUNT(*) FROM ^prk_in WHERE fwid_wp=" + sqlTo(fwid));			
		if (snap[0] == 1)
		{
			snap = getSnap("SELECT COUNT(*) FROM ^prk_outin WHERE fwid_in=" + sqlTo(fwid));			
			if (snap[0] == 0)
			{
				toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
				isInPRK = true;
			}
			else if (snap[0] == 1 && fields[0] == "fwid_out")
			{
				 fields[0] = "fwid_in";
				 fields[1] = "fwid_out"
			}							
		}
		else if (snap[0] > 1)
		{
			toObject.AddMenuItem("XXXX","ERROR IN");
			isInPRK = true;
		}

		for (var i in fields)
		{
			var snap = getSnap("SELECT COUNT(*) FROM ^prk_outin WHERE " + fields[i] + "=" + sqlTo(fwid));
			if (snap[0] == 1)
			{
				if (fields[0] == "fwid_out" && !isInPRK)
					toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
				toObject.AddMenuItem("EDIT_OI_" + i,"Редагувати наказ на переведення|Редактировать приказ на перевод", 2);
				toObject.setData("field" + i, fields[i]);
				isInPRK = true;
			}	
			else if (snap[0] > 1)
			{
					toObject.AddMenuItem("XXXX","ERROR IN_OUT");
					isInPRK = true;	
			}
		}
		
		if (typeof fields[1] == "undefined" && fields[0] != "fwid_out")
		{
			snap = getSnap("SELECT COUNT(*) FROM ^prk_out WHERE fwid_wp=" + sqlTo(fwid));
			if (snap[0] == 1)
			{
				toObject.AddMenuItem("EDIT_O","Редагувати наказ на звільнення|Редактировать приказ на увольнение", 2);
				isInPRK = true;
			}
			else if (snap[0] > 1)
			{
				toObject.AddMenuItem("XXXX","ERROR OUT");
				isInPRK = true;
			}
		}	
		if (!isInPRK)
		{
			toObject.AddMenuItem("EDIT_I","Редагувати наказ на призначення|Редактировать приказ на назначение", 2);
			if (differ(toScriptDate(d00), toScriptDate(grid.table.getValue("fedat"))) == 1)
				toObject.AddMenuItem("EDIT_O","Редагувати наказ на звільнення|Редактировать приказ на увольнение", 2);
		}
	}
}

function onGridMenuHandler(sID, toObject)
{
	var useObject = Tree.getObject(strSelectID);
	var par = new Object();			
	par.param = new Object();
	par.param.fwid_podr = Number(useObject.getID());
	par.param.bdat = bdat;
	par.param.edat = edat;
	var prk = null;
	var mode = "ADD";
	var ID = 0;
	switch(sID)
	{
		case "ADDP":			
			prk = new DpDoc("com.debet.cdr.in", 0);
			break;
		case "MOVEP":
			prk = new DpDoc("com.debet.cdr.oi", 0);
			par.param.fwid_out = useObject.table.getValue("fwid");
			par.param.fwid_dol = useObject.table.getValue("fwid_dol");
			break;
		case "DELP":
			prk = new DpDoc("com.debet.cdr.out", 0);
			par.param.fwid = useObject.table.getValue("fwid");
			par.param.fwid_dol = useObject.table.getValue("fwid_dol");
			break;
		case "EDIT_I":
			prk = new DpDoc("com.debet.cdr.in", 0);
			ID = useObject.table.getValue("fwid");
			mode = "EDIT";
			break;
		case "EDIT_O":
			prk = new DpDoc("com.debet.cdr.out", 0);
			ID = useObject.table.getValue("fwid");
			mode = "EDIT";
			break;
		default:
			if (sID.substring(0, 7).toUpperCase() == "EDIT_OI")
			{
				prk = new DpDoc("com.debet.cdr.oi", 0);
				var field = String(toObject.getData("field" + sID.substring(sID.lastIndexOf("_") + 1)));
				if (field != "")
				{
					var snap = getSnap("SELECT fwid FROM ^prk_outin WHERE "
										+ field + "=" + sqlTo(useObject.table.getValue("fwid")));
					if (snap != null)
					{
						ID = snap[0];
						mode = "EDIT";
						break;
					}				
				}
				prk = null;
			}
			break;
	}
	if (prk != null)
	{		
		prk.setFormFile("formzrp");
		prk.edit(mode, ID, par);
		grid.getTable().requery();
		grid.refresh();
	}
}

function showGrid(ID)
{
	/*obj = Tree.getObject(ID);
	alert(obj)
	if (!obj)
		return;
	if (obj.isorg || obj.ispodr)
	{
		if (obj.table)
			obj.table.close();
		ExecuteSQL("DELETE FROM tmp_table");
		var qryTable = getQryTable(obj)
		for (var i in qryTable)		
		{
			ExecuteSQL("INSERT INTO tmp_table"
					+ " (fwid, fwid_dol, fbdat, fedat, fvopl, ftxt, fcod, fpos,fident) "
					+ qryTable[i]);
		}
		//obj.table = OpenTable("m", obj.qryTable);
		obj.table = OpenTable("m", "SELECT * FROM tmp_table ORDER BY fcounter");
		grid.setTable(obj.table);	
		grid.build();
	}
	alert(obj.isorg || obj.ispodr);
	grid.setVisible(obj.isorg || obj.ispodr);*/
		
}

function fillTreeEx(obj, index, maxindex)
{
	/*if (index > maxindex)
	{
		Tree.addItem(obj.id, "wait", UR("Зачекайте...|Подождите..."));
		return;
	}*/
	index += 1;
	for (var id in obj.elements)
	{
		var tmp = obj.elements[id];
		
		if (obj.isorg)
			Tree.expand(obj.getID());
		Tree.addItem(tmp.parentID, tmp.id, tmp.txt);
		Tree.setObject(tmp.getID(), tmp);
		fillTreeEx(tmp, index, maxindex);
	}
}

function onTreeSelected(sCod, sMode)
{	
	if (sMode != "ENTER" && strSelectID == sCod)
		return;
	strSelectID = sCod;
	showGrid(strSelectID);
}

function onTreeExpand(id)
{
	var child = Tree.getChildsOf(id);
	if (child.length > 0 && String(child[0]) == "wait")
	{
		var element = Tree.getObject(id);
		if (element != null)
		{
			Tree.removeAllIn(id);
			element.getSubItems();
			fillTreeEx(element, 0, 0);
		}
	}
}

function createDpTree()
{
	var result = new DpShtatTree();
	result.arrQuary[0] = "SELECT fwid, fwid_par, " + sqlFalse + " AS fisdol, fbdat, fedat, ftxt"
		+ " FROM ^stru_org WHERE fwid_par IS NULL OR fwid_par=0"
		+ " AND ((fbdat<=" + sqlTo(bdat) + " AND fedat>=" + sqlTo(edat) + ")"
		+ " OR (fbdat>=" + sqlTo(bdat) + " AND fbdat<=" + sqlTo(edat) + ")"
		+ " OR (fedat>=" + sqlTo(bdat) + " AND fedat<=" + sqlTo(edat) + "))";
	result.getSubItems();
	for (var i in result.elements)
	{
		result.elements[i].getSubItems();
		for (var j in result.elements[i].elements)
			result.elements[i].elements[j].getSubItems();
	}

	return result;
}

// функции для работы с DpTree

function getMyStrDat(d, add)
{
	if (d == null)
		return "";
	var tmp = javaDate2Script(d);
	if (String(tmp) == "Invalid Date")
		return "";
	if (d00.compareTo(tmp) == 0)
		return "";
	else
	{
		if (add === true)
			tmp.setDate(Number(tmp.getDate() + 1));
		return StrDat(tmp, "DMY");
	}
}

function getMaxEdat(element)
{
	if (element.isdol)
	{
		var result = null;
		for (element.table.MoveFirst(); !element.table.IsEOF(); element.table.MoveNext())
		{
			if (result == null)
				result = element.table.getValue("fwedat");
			else if (differ(toScriptDate(result), toScriptDate(element.table.getValue("fwedat"))) == -1)
				result = element.table.getValue("fwedat");
		}
		return result;
	}
	else
	{
		var arr = element.elements;
		var tmp = "";
		for (var i in arr)
		{
			if (String(arr[i].info.edat) == "")
				continue;
			var date = String(arr[i].info.edat).split(".");
			date = date[2] + "." + String(Number(date[1]) - 1) + "." + date[0];
			if (tmp != "")
			{
				if (tmp < date)
					tmp = date;
			}
			else
				tmp = date;
		}
		if (tmp == "")
			return null;
		tmp = tmp.split(".");
		return new Date(Number(tmp[0]), Number(tmp[1]), Number(tmp[2]));
	}
}

function getQrySubItem(element)
{	
	var result = new Array();
	if (typeof element.isdol == "undefined" || element.isdol == false)
	{
		result[0] = "SELECT fwid, fwid_par, fbdat, fedat, ftxts, ftxt"
			+ " FROM ^stru_org WHERE fwid_par=" + sqlTo(Number(element.getID())) 
			+ " AND ((fbdat<=" + sqlTo(bdat) + " AND fedat>=" + sqlTo(edat) + ")"
					+ " OR (fbdat>=" + sqlTo(bdat) + " AND fbdat<=" + sqlTo(edat) + ")"
					+ " OR (fedat>=" + sqlTo(bdat) + " AND fedat<=" + sqlTo(edat) + "))";
	}
	return result;
}

function getQryRefresh(element)
{
	if (element.ispodr)
		return "SELECT ftxt, ftxts, fbdat, fedat FROM ^stru_org WHERE fwid=" + sqlTo(Number(element.getID()));
	if (element.isdol)
		return "SELECT dol.fbdat AS fbdat, dol.fedat AS fedat, dol.foklad AS foklad, dol.fshpz AS fshpz, cl.ftxts AS ftxts,"
			+  " (SELECT MAX(p.FEDAT) FROM ^work_pers AS p WHERE p.fwid_dol=dol.fwid) AS fwedat, cl.ftxt AS ftxt"
			+ " FROM ^stru_dol AS dol, ^cl AS cl "
			+ " WHERE dol.fwid=" + sqlTo(Number(element.getID())) + " AND dol.fwid_cl=cl.fwid";
	return "";
}

function getQryTable(element)
{
	/*if (!element.ispodr)
		return new Array();*/
	result = new Array();	
	var n = 0;
	result[n++] = "SELECT fwid, 0 AS fwid_dol, fbdat,"
		+ " fedat, 0 AS fvopl," + sqlTo(element.txt) + " AS ftxt, 0 AS fcod, '' AS fpos, 1 AS fident "
		+ " FROM ^stru_org WHERE fwid=" + sqlTo(Number(element.id));	
	if (element.ispodr)
	result[n++]="SELECT wp.fwid AS fwid, wp.fwid_dol AS fwid_dol, wp.fbdat AS fbdat,"
		+ " wp.fedat AS fedat, wp.fvopl AS fvopl, wp_cl.ftxt AS ftxt, crc.fcod AS fcod, dol_cl.ftxt AS fpos, 0 AS fident " 	
		+ " FROM ((((^stru_org AS pod LEFT JOIN ^stru_dol AS dol ON pod.fwid=dol.fwid_org) "
			+ " LEFT JOIN ^cl AS dol_cl ON dol.fwid_cl=dol_cl.fwid) "
			+ " LEFT JOIN ^work_pers AS wp ON wp.fwid_dol=dol.fwid "
			+ " LEFT JOIN ^cl AS wp_cl ON wp.fwid_cl=wp_cl.fwid) "
			+ " LEFT JOIN ^clrelclcl AS crc ON wp.fwid_cl=crc.fwid_cl) "
		+ " WHERE pod.fwid=" +  + sqlTo(Number(element.getID())) 
			+ " AND ((wp.fbdat<=" + sqlTo(bdat) + " AND wp.fedat>=" + sqlTo(edat) + ")"
			+ " OR (wp.fbdat>=" + sqlTo(bdat) + " AND wp.fbdat<=" + sqlTo(edat) + ")"
			+ " OR (wp.fedat>=" + sqlTo(bdat) + " AND wp.fedat<=" + sqlTo(edat) + "))"
		+ " ORDER BY fcod, fbdat, fedat";
	for (var j in element.elements)
	{
		var arrQry = element.elements[j].qryTable; //getQryTable(); //
		for (var i in arrQry)
			result[n++] = arrQry[i];
	}
	return result;
}

// описание DpTree

function DpShtatTree()
{
	this.arrQuary = new Array();
	this.elements = new Array();
	this.id = "0";
	this.getSubItems = DpShtatTree_getSubItems;
	this.dispose = DpShtatTree_dispose;
}

function DpShtatTree_dispose()
{
	for (var i in elements)
		elements[i].dispose();
}

function DpShtatTree_getSubItems()
{
	if (typeof this.arrQuary == "object")
	{
		for (var i in this.arrQuary)
		{
			var strSQL = String(this.arrQuary[i])
			{
				var tbl = OpenTable("m", strSQL);
				var id = -1;
				for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{					
					this.elements[++id] = new DpShtatTreeItem();
					this.elements[id].tree = this;
					this.elements[id].setID(tbl.getValue("fwid"));
					this.elements[id].setParentID(this.id);
					this.elements[id].isorg = true;
					this.elements[id].fillData(tbl);
					this.elements[id].qryTable = getQryTable(this.elements[id]);
					this.elements[id].arrQuary = getQrySubItem(this.elements[id]);
				}
				tbl.close();			
			}
		}
	}
}

function DpShtatTreeItem()
{	
	this.tree = null;
	
	this.arrQuary = new Array();	
	this.elements = new Array();
	this.info = new DpShtatInfo();
	this.parent = null;	
	this.table = null;
	
	this.id = null;
	this.parentID = null;
	this.isorg = false;
	this.ispodr = false;
	this.isdol = false;
	this.ishomo = false;
	this.islikv = false;
	this.txt = "";
	this.qryTable = null;
	
	this.setParentID = DpShtatTreeItem_setParentID;
	this.getParentID = DpShtatTreeItem_getParentID;
	this.setID = DpShtatTreeItem_setID;
	this.getID = DpShtatTreeItem_getID;
	this.fillData = DpShtatTreeItem_fillData;
	this.getSubItems = DpShtatTreeItem_getSubItems;
	this.getText = DpShtatTreeItem_getText;
	this.dispose = DpShtatTreeItem_dispose;
}

function DpShtatTreeItem_dispose()
{
	if (this.table != null)
		this.table.close();
	for (var i in this.elements)
		this.elements[i].dispose();
}

function DpShtatTreeItem_setID(id)
{
	this.id = String(id);
}

function DpShtatTreeItem_getID()
{
	return this.id;
}

function DpShtatTreeItem_setParentID(parentID)
{
	this.parentID = String(parentID);
}

function DpShtatTreeItem_getParentID()
{
	return this.parentID;
}

function DpShtatTreeItem_fillData(tbl)
{
	if (this.ishomo == true)
	{
		this.sex = (tbl.getValue("fsex") == true ? true : false);
		this.txt = getSmallFIO(this.getText(tbl));
	}
	else
		this.txt = this.getText(tbl);
	this.info.bdat = getMyStrDat(tbl.getValue("fbdat"));	
	this.info.edat = getMyStrDat(tbl.getValue("fedat"));	
	this.islikv = this.info.edat != "";
	if (this.isdol && this.info.edat == "")
	{
		if (tbl.getValue("fwedat") == null)
			this.info.wedat = this.info.bdat;
		else
			this.info.wedat =  getMyStrDat(tbl.getValue("fwedat"), true);
	}
	this.info.oklad = (tbl.getValue("foklad") == null ? "" : String(tbl.getValue("foklad")));	
	this.info.shpz = (tbl.getValue("fshpz") == null ? "" : String(tbl.getValue("fshpz")));
}

function DpShtatTreeItem_getSubItems()
{
	this.dispose();
	this.elements = new Array();
	if (typeof this.arrQuary == "object")
	{
		for (var i in this.arrQuary)
		{
			var strSQL = String(this.arrQuary[i])

			var tbl = OpenTable("m", strSQL);
			var id = this.elements.length - 1;
			for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				this.elements[++id] = new DpShtatTreeItem();
				this.elements[id].tree = this.tree;	
				this.elements[id].parent = this;
				this.elements[id].setID(String(tbl.getValue("fwid")));
				var parID = tbl.getValue("fwid_par");
				this.elements[id].setParentID(((parID == null) || (typeof parID == "undefined"))  ? "0" : String(parID));
				this.elements[id].ispodr = true;	
				this.elements[id].fillData(tbl);
				this.elements[id].qryTable = getQryTable(this.elements[id]);
				this.elements[id].arrQuary = getQrySubItem(this.elements[id]);
			}
			tbl.close();			
		}
	}
}

function DpShtatTreeItem_getText(tbl)
{
	var text = tbl.getValue("ftxts");
	if (text != null && text != "")
		return UR(String(text));
	text = tbl.getValue("ftxt");
	if (text != null)
		return UR(String(text));
	return "undefined";
}

function DpShtatInfo()
{
	this.bdat = "";
	this.edat = "";
	this.wedat = "";
	this.oklad = "";
	this.shpz = "";
}


function createTmpTable()
{
	var sql = "CREATE TABLE tmp_table ("
			+ "fwid " + SqlType("long")
			+ ",fwid_dol " + SqlType("long")
			+ ",fbdat " + SqlType("date")
			+ ",fedat " + SqlType("date")
			+ ",fvopl " + SqlType("int")
			+ ",ftxt " + SqlType("text")
			+ ",fcod " + SqlType("int")
			+ ",fpos " + SqlType("text")
			+ ",fident" + SqlType("bit")
			+ ",fcounter" + SqlType("counter")
			+ ")";
	ExecuteSQL(sql);
}

include("sys\\DpBaseDlg.js");