// JScript source code

var d2007b, d2007e, gd;

function listLoad()
{
	include("sys/udfs.js");
	include("doc/DpDoc.js");
	include("Objects/DpJRegistrator.js");
	include("servis/format.js")
	//include("Objects/DpGetDat.js");
	var form = createForm(UR("Введіть дані для відбору інформації|Введите данные для отбора информации"));
	var ctrldat1 = form.addObj("dat1","date",UR("Дата початку|Дата начала"));
	ctrldat1.setValue(getPar("GLOBDAT1"));
	var ctrldat2 = form.addObj("dat2","date",UR("Дата кінця|Дата конца"));
	ctrldat2.setValue(getPar("GLOBDAT2"));
	var doc = form.addObj("doc","combo",UR("Договора"));
	doc.addItem("TD", UR("Транспортные договора"));
	doc.addItem("HOZDOG", UR("Хозяйственные договора"));
	doc.setValue("TD");
	form.show();
	if(form.escape == true)
		return false;
	//gd = new DpGetDat("Dd");
	//d2007b = new Date(2007,0,1);
	d2007b = new Date(form.dat1);
	//d2007e = new Date(2007,11,31);
	d2007e = new Date(form.dat2);
	var tDoc = form.doc;
	with( this )
	{
		title = "Остатки по "+(tDoc=="TD"?"транспортным":"хозяйственным")+" договорам за "+format("dd.mm.yy",form.dat1)+" - "+format("dd.mm.yy",form.dat2);
		xmlGridFile = "l_sldog.xml";
	}
	
	include("TrnNBln.js");
	include("Objects\\DpSc.js");
	var oSc = new DpSc(36,361,1);
	TrnNBln("", "TMP_SL", d2007b, d2007e, oSc);
	
	DropTable("sldog200712");
	ExecuteSQL("CREATE TABLE sldog200712 ("
			+ " Fwid " + SqlType("LONG")
			+ " ,Forg " + SqlType("INT")
			+ " ,Fdat " + SqlType("DATE")
			+ " ,Fdat_dog " + SqlType("DATE")
			+ " ,Fsl " + SqlType("MONEY")
			+ " ,Fvyk " + SqlType("MONEY")
			+ " ,Fopl " + SqlType("MONEY")
			+ " ,Fvyk_opl " + SqlType("MONEY")
			+ " ,Fres " + SqlType("MONEY")
			+ " ,Fnum " + SqlType("TEXT")
	+")");
	
	ExecuteSQL("INSERT INTO sldog200712 (Fwid, Forg, Fdat_dog, Fsl) "
			+" SELECT c.Fwid, c.Forg, c.Fdoc_dat, s.Fsum5-s.Fsum6 as Fsl FROM ^contract AS c INNER JOIN ^"+(tDoc=="TD"?"htd":"hozdog")+" AS h ON c.Fwid=h.Fid_dog "
			+" INNER JOIN TMP_SL AS s ON c.Forg=s.Fcl_cod1"
			+" WHERE c.Fdoc_dat>="+sqlTo(d2007b)+" AND c.Fdoc_dat<="+sqlTo(d2007e)
			);
			
	/*var tbl = OpenTable("sldog")
	nPos = 0;
	maxPos = tbl.rowCount;
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		dk = sl_("D",lastDay(d2007e),0,36,361,1,tbl.getValue("Forg"))-sl_("K",lastDay(d2007e),0,36,361,1,tbl.getValue("Forg"))
		ExecuteSQL("update sldog set Fsl="+sqlTo(dk)+" where Fwid="+tbl.getValue("Fwid"));
		trace("trace >>> "+dk)
	}
	tbl.close();
	*/
	
	var oDoc = new DpDoc(tDoc,0);
	var jID = oDoc.getPar("__jrn");
	var oReg = new DpJRegistrator(null,null);
	var journal = oReg.listJournals()[jID];
	tbl_j=journal.getFullTableName();
	strSQL = "UPDATE sldog200712 AS s SET Fvyk = (SELECT SUM(j.Fsum_vyk) FROM " + tbl_j
				+ " AS j WHERE j.Fdat<=" + sqlTo(d2007e) + " AND j.Fdat>=" + sqlTo(d2007b)
				+ " AND j.Fdog=s.Fwid )";
	ExecuteSQL(strSQL);
	strSQL = "UPDATE sldog200712 AS s set s.Fopl = (SELECT SUM(j.Fsum_opl) FROM " + tbl_j
				+ " AS j WHERE j.Fdat<=" + sqlTo(d2007e) + " AND j.Fdat>=" + sqlTo(d2007b)
				+ " AND j.Forg=s.Forg)";
	ExecuteSQL(strSQL);
	ExecuteSQL("UPDATE sldog200712 SET Fvyk=0 WHERE Fvyk is null");
	ExecuteSQL("UPDATE sldog200712 SET Fopl=0 WHERE Fopl is null")
	
	ExecuteSQL("UPDATE sldog200712 SET Fvyk_opl=Fvyk-Fopl");
	
	ExecuteSQL("UPDATE sldog200712 SET Fres=Fsl-Fvyk_opl");
	ExecuteSQL("UPDATE sldog200712 as s SET Fnum=(SELECT Fdoc_num FROM ^contract as c WHERE c.Fwid=s.Fwid)");
}

function listSrc()
{
	this.qrySet("From","sldog200712","Order","Forg");
}

function listMenuInit()
{
	DataSource().AddMenuItem("BS","Экспорт в BS");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "BS":
			var tbl = OpenTable("select * from sldog200712 where "+grid.sqlSelected());
			k=0;
			for(; !tbl.IsEOF(); tbl.MoveNext())
			{
				sum = tbl.getValue("Fres");
				if(sum!=0)
				{
					var oDoc = new DpDoc("BS",0);
					oDoc.setVar("HNOM","CORECT"+tbl.getValue("Forg"));
					oDoc.setVar("HDAT",today.getVarDate());
					//если результат положительный, то записываем в BS выполнено, 
					//в противном случае записываем по модулю в оплаты
					oDoc.setVar("HSUM",sum>0?sum:Math.abs(sum));
					oDoc.setVar("HOP",sum>0?8000:8001);
					oDoc.setVar("HORG",tbl.getValue("Forg"));
					oDoc.setVar("HID_DOG",tbl.getValue("Fwid"));
					oDoc.save();
					k++;
				}
			}
			alert("Кол-во созданных BS документов: "+k)
			tbl.close();
		break;
	}
}
include("sys/DpList.js");