include("objects/DpGetDat.js");
include("doc/DpDoc.js");
include("servis/date.js");

var strSelectID = "";
var bdat = edat = null;;
var dpTree = null;
var showTable = true;

function onLoad()
{
	var gd = new DpGetDat("dD");
	if (gd.escape == true)
		return false;
	bdat = gd.dat1;
	edat = gd.dat2;
	
	Caption(UR("Оргструктура підприємства з |Оргструктура предприятия с ")
		 + StrDat(bdat, "DMY") + UR(" до | по ") + StrDat(edat, "DMY"));	

	this.onTreeSelectMenuHandler = onTreeSelectMenuHandler;
	this.onTreeMenuInit = onTreeMenuInit;
	Tree.selectMenuHandler(this, "onTreeSelectMenuHandler");
	Tree.loadMenuHandler(this, "onTreeMenuInit");
	
	dpTree = createDpTree();
	if (dpTree.elements.length > 0)
		loadTree();
	else
	{
		if (getSnap("SELECT COUNT(*) FROM ^stru_org WHERE fwid_par=0 OR fwid_par IS NULL")[0] == 0)
		{
			createOrg();
			dpTree = createDpTree();
			loadTree();
		}
		else
			setInfoPage();			
	}
}

function loadTree()
{
	Tree.setItemImage(8, rootDirectoryEx() + "/icons/iDol.gif");
	Tree.setItemImage(9, rootDirectoryEx() + "/icons/iLDol.gif");
	Tree.setItemImage(10, rootDirectoryEx() + "/icons/iVDol.gif");


	this.onTreeSelected = onTreeSelected;
	this.onTreeExpand = onTreeExpand;
	this.onTreeCanEdit = new Function("return false");
	Tree.setTreeSelHandler(this, "onTreeSelected");
	Tree.setExpandHandler(this, "onTreeExpand");
	Tree.setCanEditHandler(this, "onTreeCanEdit");	
		
	dpTree = createDpTree();
	fillTreeEx(dpTree, 0, 1);
	strSelectID = dpTree.elements[0].getID();
	Tree.setSelected(strSelectID);
	
	setPage(strSelectID);
	
	this.onGridMenuInit = onGridMenuInit;
	this.onGridMenuHandler = onGridMenuHandler;
	grid.loadMenuHandler(this, "onGridMenuInit");
	grid.selectMenuHandler(this, "onGridMenuHandler");
	
	grid.setXMLFile("l_structOrg.xml");	
	grid.getGridControl().setVisible(false);
	showGrid(strSelectID);
}

function onEscape()
{
	dpTree.dispose();
}

function selectPersonalMenu(sID, useObject)
{
	var par = new Object();			
	par.param = new Object();
	par.param.fwid_org = Number(useObject.getParentID());
	par.param.fwid_dol = Number(useObject.getID());
	par.param.bdat = bdat;
	par.param.edat = edat;
	var dat = useObject.info.wedat;
	if (dat == "")
		dat = null;				
	par.param.dat_prk = dat;
	var prk = null;
	switch(sID)
	{
		case "ADDP":			
			prk = new DpDoc("com.debet.cdr.in", 0);
			break;
		case "MOVEP":
			prk = new DpDoc("com.debet.cdr.prk_oi", 0);
			break;
		case "DELP":
			prk = new DpDoc("com.debet.cdr.out", 0);
			par.param.fwid_cl = getSnap("SELECT fwid_cl FROM ^work_pers WHERE fwid="
							+ sqlTo(useObject.table.getValue("fwid")))[0];
			break;
	}
	if (prk != null)
	{
		prk.edit("ADD", 0, par);
		grid.getTable().requery();
		grid.refresh();
		refreshTreeItem(useObject);
	}
}

function onTreeSelectMenuHandler(sID)
{
	var useObject = Tree.getObject(strSelectID);
	switch(sID)
	{
		case "ADD_ORG":
			var par = new Object();
			par.sMode = "ADD"; 
			showWindow("e_org.xml", SW_MODAL, par);
			if (!par.escape)
			{
				dpTree = createDpTree();
				Tree.removeAll();
				loadTree();	
			}
			break;
		case "ADD_PODR":
		case "ADD_DOL":			
			var par = new Object();
			par.disabledED = true;
			par.sMode = "ADD";
			par.fwid = useObject.getID();
			var openFile = "";
			if (sID == "ADD_PODR")
				openFile = "e_podr.xml";
			else
				openFile = "e_dol.xml";
			showWindow(openFile, SW_MODAL, par);	
			if (!par.escape)
			{
				refillTreeItem(useObject.getID());
				strSelectID = "";
				Tree.setSelected(String(par.fwid));
				refreshPage(String(par.fwid));
				onTreeSelected(String(par.fwid), "ENTER");
			}
			break;
		case "EDIT":
			var par = new Object();
			par.disabledED = !useObject.islikv;
			par.sMode = sID;
			par.fwid = Number(useObject.getID());
			par.isAllSubLikv = true;
			for (var i in useObject.elements)
					par.isAllSubLikv = par.isAllSubLikv && useObject.elements[i].islikv;
			//par.maxEdat = getMaxEdat(useObject);
			var openFile = "";
			if (useObject.isdol)
				openFile = "e_dol.xml";
			else if (useObject.ispodr)
				openFile = "e_podr.xml";
			else if (useObject.isorg)
				openFile = "e_org.xml";
			
			showWindow(openFile, SW_MODAL, par);
			if (!par.escape)
			{
				if (par.refPar)
				{					
					refillTreeItem(useObject.getParentID());					
					strSelectID = "";
					Tree.setSelected(useObject.getID());
					refreshPage(useObject.getID());
					onTreeSelected(useObject.getID(), "ENTER");
				}	
				else
					refreshTreeItem(useObject);
			}
			break;		
		case "LIKV":
			var isAllSubLikv = true;
			if (!useObject.isorg)
			{
			if (false)
			{
				var snap = getSnap("SELECT COUNT(*) FROM ^stru_dol "
						+ " WHERE fwid_org=" + sqlTo(useObject.getID()) + " AND fedat=" + SqlMaxDate);
				if (snap[0] > 0)
					isAllSubLikv = false;
				if (isAllSubLikv)
				{
					snap = getSnap("SELECT COUNT(*) FROM ^stru_org AS org "
						+ " LEFT JOIN ^stru_dol AS dol ON org.fwid=dol.fwid_org "
							+ " LEFT JOIN ^work_pers AS wp ON dol.fwid=wp.fwid_dol "
						+ " WHERE org.fwid=" + sqlTo(Number(useObject.getID()))
							+ " AND dol.fedat=" + SqlMaxDate
							+ " AND wp.fedat=" + SqlMaxDate);
					if (snap[0] > 0)
						isAllSubLikv = false;
				}
				if (!isAllSubLikv)
				{
				 	alert(ru(
				 		"В этом подразделении есть неликвидированные подразделения или должности.\nЛиквидируйте сначала их.", 
               			"В цьому підрозділі є неліквідовані підрозділи або посади.\nЛіквідуйте спочатку їх."),
	               		ICON_WARNING);
	            	return;
				}				
			}
			else
			{		
			if (useObject.ispodr)
			{
				onTreeExpand(useObject.getID());
				for (var i in useObject.elements)
					isAllSubLikv = isAllSubLikv && useObject.elements[i].islikv;
				if (!isAllSubLikv)
				{
				 	alert(ru(
				 		"В этом подразделении есть неликвидированные подразделения или должности.\nЛиквидируйте сначала их.", 
               			"В цьому підрозділі є неліквідовані підрозділи або посади.\nЛіквідуйте спочатку їх."),
	               		ICON_WARNING);
	            	return;
				}
			}
			else if (useObject.isdol)
			{
				if (!useObject.table.IsEmpty()
						&& useObject.table.MoveFirst()
							&& differ(toScriptDate(useObject.table.getValue("fedat")), toScriptDate(d00)) == 0)
				{
				    alert(ru(
				      	"На этой должности есть работающий сотрудник.\nСначала произведите операции над сотрудником.", 
               			"На цій посаді є працюючий співробіткик.\nСпочатку здійсніть операції над співробіткиком."),
               			ICON_WARNING);
            		return;
				}
			}
			}
			}
			var par = new Object();
			par.sMode = sID;
			par.fwid = Number(useObject.getID());
			par.maxEdat = getMaxEdat(useObject);
			var openFile = "";
			if (useObject.isdol)
				openFile = "e_dol.xml";
			else if (useObject.ispodr)
				openFile = "e_podr.xml";
			else if (useObject.isorg)
				openFile = "e_org.xml";
								
			showWindow(openFile, SW_MODAL, par);
			if (!par.escape)
			{
				refillTreeItem(useObject.getParentID());					
				strSelectID = "";
				Tree.setSelected(useObject.getID());
				refreshPage(useObject.getID());
				onTreeSelected(useObject.getID(), "ENTER");
			}	
			break;
		
		case "ADDP":
		case "MOVEP":
		case "DELP":
			selectPersonalMenu(sID, useObject);
			break;
			
		case "DOUBLECLICK":
			onTreeExpand(strSelectID);
			Tree.reExpand(strSelectID);
			break;
			
		case "SHOW_OBJ":
			showObject(useObject, SW_MODAL);
			break;
	}
}

function initPersonalMenu(useObject, toObject)
{
	if (!useObject.islikv)
	{
		if (!(useObject.info.wedat == ""))
			toObject.AddMenuItem("ADDP","Призначити...|Назначить...");
		else
		{
			toObject.AddMenuItem("MOVEP","Перевести...|Перевести...");
			toObject.AddMenuItem("DELP","Звільнити...|Уволить...");	
		}
	}
}

function onTreeMenuInit(toObject)
{
	if (dpTree.elements.length <= 0)
	{
		//toObject.AddMenuItem("ADD_ORG","Створити організацію|Создать организацию");
	}
	else
	{
		var useObject = Tree.getObject(strSelectID);
		if (useObject.isorg || useObject.ispodr)
			toObject.AddMenuItem("ADD_PODR","Додати підрозділ|Добавить подразделение");
			
		if (useObject.ispodr)
			toObject.AddMenuItem("ADD_DOL", "Додати посаду|Добавить должность", "addDol");
			
		if (useObject.ispodr || useObject.isorg)
		{
			toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
			toObject.AddMenuItem("LIKV","Ліквідувати|Ліквідувати", "del");
		}	
		if (useObject.isdol)
		{
			toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
			if (!(useObject.info.wedat == ""))
				toObject.AddMenuItem("LIKV","Ліквідувати|Ліквідувати", "del");
			if (showTable)
			{
				/*toObject.AddMenuItem("", "");
				initPersonalMenu(useObject, toObject);*/
			}
		}
	}	
	if (lpProxy.isDebug() == true && isAdministrator())
	{
		toObject.AddMenuItem("", "");
		toObject.AddMenuItem("SHOW_OBJ", UR("Показати об'єкт|Показать объект"));	
	}
}

function onGridMenuInit(toObject)
{
	/*initPersonalMenu(Tree.getObject(strSelectID), toObject);
	if (!grid.table.IsEmpty())
	{
		toObject.AddMenuItem("", "");
		toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
	}*/
}

function onGridMenuHandler(sID)
{
	selectPersonalMenu(sID, Tree.getObject(strSelectID));
}

function showGrid(ID)
{
	if (!showTable)
		return;	
	obj = Tree.getObject(ID);
	if (obj.isdol)
	{
		if (obj.table == null)
			obj.table = OpenTable("m", obj.qryTable);
		grid.setTable(obj.table);	
		grid.build();
		grid.refresh();
	}
	grid.getGridControl().setVisible(obj.isdol);
		
}

function fillTreeEx(obj, index, maxindex)
{
	if (index > maxindex)
	{
		if (!obj.isdol)
			Tree.addItem(obj.id, "wait", UR("Зачекайте...|Подождите..."));
		return;
	}
	index += 1;	
	for (var id in obj.elements)
	{
		var tmp = obj.elements[id];
		
		var icon = null;
		if (tmp.isdol == true)
		{
			icon = 8;
			if (tmp.islikv)
				icon = 9;
			else if (tmp.info.wedat != "")
				icon = 10;
		}
		else if (obj.isorg)
			Tree.expand(obj.getID());
					
		if (icon != null)
			Tree.addItem(tmp.parentID, tmp.id, tmp.txt, icon);
		else
			Tree.addItem(tmp.parentID, tmp.id, tmp.txt);
		Tree.setObject(tmp.getID(), tmp);
		fillTreeEx(tmp, index, maxindex);
	}	
}

function onTreeSelected(sCod, sMode)
{	
	if (sMode != "ENTER" && strSelectID == sCod)
		return;
	strSelectID = sCod;
	setPage(strSelectID);
	showGrid(strSelectID);
}

function onTreeExpand(id)
{
	var child = Tree.getChildsOf(id);
	if (child.length > 0 && String(child[0]) == "wait")
	{
		var element = Tree.getObject(id);
		if (element != null)
		{
			Tree.removeAllIn(id);
			element.getSubItems();
			fillTreeEx(element, 0, 0);
		}
	}
}

function refreshTreeItem(element)
{
	element.refresh();
	Tree.setItemText(element.getID(), element.txt);	
	if (element.isdol == true)
	{
		var icon = 8;
		if (element.islikv)
			icon = 9;
		else if (element.info.wedat != "")
			icon = 10;
		Tree.setItemImage(element.getID(), icon);
	}
	refreshPage(element.getID());
}

function refillTreeItem(id)
{
	var element = Tree.getObject(id);
	Tree.setExpanded(id, false);
	Tree.removeAllIn(id);
	element.getSubItems();	
	if (element.elements.length > 0)
	{
		Tree.addItem(element.getID(), "wait", UR("Зачекайте...|Подождите..."));
		onTreeExpand(id);
	}
}

function createDpTree()
{
	var result = new DpShtatTree();
	result.arrQuary[0] = "SELECT fwid, fwid_par, " + sqlFalse + " AS fisdol, fbdat, fedat, ftxt"
		+ " FROM ^stru_org WHERE fwid_par IS NULL OR fwid_par=0"
		+ " AND ((fbdat<=" + sqlTo(bdat) + " AND fedat>=" + sqlTo(edat) + ")"
		+ " OR (fbdat>=" + sqlTo(bdat) + " AND fbdat<=" + sqlTo(edat) + ")"
		+ " OR (fedat>=" + sqlTo(bdat) + " AND fedat<=" + sqlTo(edat) + "))";
	
	result.getSubItems();
				
	for (var i in result.elements)
	{
		result.elements[i].getSubItems();
		/*for (var j in result.elements[i].elements)
			result.elements[i].elements[j].getSubItems();*/
	}
		
	return result;
}

// функции для работы с DpTree

function getMyStrDat(d, add)
{
	if (d == null)
		return "";
	var tmp = javaDate2Script(d);
	if (String(tmp) == "Invalid Date")
		return "";
	if (d00.compareTo(tmp) == 0)
		return "";
	else
	{
		if (add === true)
			tmp.setDate(Number(tmp.getDate() + 1));
		return StrDat(tmp, "DMY");
	}
}

function getMaxEdat(element)
{
	if (element.isdol)
	{
		var result = null;
		for (element.table.MoveFirst(); !element.table.IsEOF(); element.table.MoveNext())
		{
			if (result == null)
				result = element.table.getValue("fwedat");
			else if (differ(toScriptDate(result), toScriptDate(element.table.getValue("fwedat"))) == -1)
				result = element.table.getValue("fwedat");
		}
		return result;
	}
	else
	{
		var arr = element.elements;
		var tmp = "";
		for (var i in arr)
		{
			if (String(arr[i].info.edat) == "")
				continue;
			var date = String(arr[i].info.edat).split(".");
			date = date[2] + "." + String(Number(date[1]) - 1) + "." + date[0];
			if (tmp != "")
			{
				if (tmp < date)
					tmp = date;
			}
			else
				tmp = date;
		}
		if (tmp == "")
			return null;
		tmp = tmp.split(".");
		return new Date(Number(tmp[0]), Number(tmp[1]), Number(tmp[2]));
	}
}

function getQrySubItem(element)
{	
	var result = new Array();
	if (typeof element.isdol == "undefined" || element.isdol == false)
	{
		result[0] = "SELECT fwid, fwid_par, fbdat, fedat, ftxts, ftxt"
			+ " FROM ^stru_org WHERE fwid_par=" + sqlTo(Number(element.getID())) 
			+ " AND ((fbdat<=" + sqlTo(bdat) + " AND fedat>=" + sqlTo(edat) + ")"
					+ " OR (fbdat>=" + sqlTo(bdat) + " AND fbdat<=" + sqlTo(edat) + ")"
					+ " OR (fedat>=" + sqlTo(bdat) + " AND fedat<=" + sqlTo(edat) + "))";
		result[1] =
			"SELECT dol.fcod AS fcod, dol.fwid AS fwid, dol.fwid_org AS fwid_par, " + sqlTrue + " AS fisdol,"
			+ " dol.fbdat AS fbdat, dol.fedat AS fedat, cl.ftxts AS ftxts,"
			+ " cl.ftxt AS ftxt, dol.foklad AS foklad, dol.fshpz AS fshpz,"
			+ " (SELECT MAX(p.FEDAT) FROM ^work_pers AS p WHERE p.fwid_dol=dol.fwid) AS fwedat"
			+ " FROM ^stru_dol AS dol, ^cl AS cl "
			+ "WHERE dol.fwid_org=" + + sqlTo(Number(element.getID())) + " AND dol.fwid_cl=cl.fwid"
			+ " AND ((dol.fbdat<=" + sqlTo(bdat) + " AND dol.fedat>=" + sqlTo(edat) + ")"
			+ " OR (dol.fbdat>=" + sqlTo(bdat) + " AND dol.fbdat<=" + sqlTo(edat) + ")"
			+ " OR (dol.fedat>=" + sqlTo(bdat) + " AND dol.fedat<=" + sqlTo(edat) + "))"
			+ " ORDER BY fcod, fwid, fbdat, fedat";
	}
	return result;
}

function getQryRefresh(element)
{
	if (element.isorg || element.ispodr)
		return "SELECT ftxt, ftxts, fbdat, fedat FROM ^stru_org WHERE fwid=" + sqlTo(Number(element.getID()));
	if (element.isdol)
		return "SELECT dol.fbdat AS fbdat, dol.fedat AS fedat, dol.foklad AS foklad, dol.fshpz AS fshpz, cl.ftxts AS ftxts,"
			+  " (SELECT MAX(p.FEDAT) FROM ^work_pers AS p WHERE p.fwid_dol=dol.fwid) AS fwedat, cl.ftxt AS ftxt"
			+ " FROM ^stru_dol AS dol, ^cl AS cl "
			+ " WHERE dol.fwid=" + sqlTo(Number(element.getID())) + " AND dol.fwid_cl=cl.fwid";
	return "";
}

function getQryTable(element)
{
	if (!element.isdol)
		return null;
	var cldol = getPar("CODDOL");
	return "SELECT wp.fwid AS fwid, wp.fwid_dol AS fwid_par, wp.fbdat AS fbdat,"
		+ " wp.fedat AS fedat, wp.fvopl AS fvopl, cl.ftxt AS ftxt, crc.fcod AS fcod" 
		+ " FROM ((^work_pers AS wp LEFT JOIN ^cl AS cl ON wp.fwid_cl=cl.fwid)"
		+ " INNER JOIN ^clrelclcl AS crc ON wp.fwid_cl=crc.fwid_cl)"
		+ " WHERE wp.fwid_dol=" + sqlTo(Number(element.getID())) 
		+ " AND crc.fcl=" + sqlTo(cldol)
		+ " AND ((wp.fbdat<=" + sqlTo(bdat) + " AND wp.fedat>=" + sqlTo(edat) + ")"
		+ " OR (wp.fbdat>=" + sqlTo(bdat) + " AND wp.fbdat<=" + sqlTo(edat) + ")"
		+ " OR (wp.fedat>=" + sqlTo(bdat) + " AND wp.fedat<=" + sqlTo(edat) + "))"
		+ " ORDER BY fbdat DESC, fedat DESC";
}

// описание DpTree

function DpShtatTree()
{
	this.arrQuary = new Array();
	this.elements = new Array();
	this.id = "0";
	this.getSubItems = DpShtatTree_getSubItems;
	this.dispose = DpShtatTree_dispose;
}

function DpShtatTree_dispose()
{
	for (var i in elements)
		elements[i].dispose();
}

function DpShtatTree_getSubItems()
{
	if (typeof this.arrQuary == "object")
	{
		for (var i in this.arrQuary)
		{
			var strSQL = String(this.arrQuary[i])
			{
				var tbl = OpenTable("m", strSQL);
				var id = -1;
				for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
				{					
					this.elements[++id] = new DpShtatTreeItem();
					this.elements[id].tree = this;
					this.elements[id].setID(tbl.getValue("fwid"));
					this.elements[id].setParentID(this.id);
					this.elements[id].isorg = true;
					this.elements[id].fillData(tbl);
					this.elements[id].qryTable = getQryTable(this.elements[id]);
					this.elements[id].qryRefresh = getQryRefresh(this.elements[id]);
					this.elements[id].arrQuary = getQrySubItem(this.elements[id]);
				}
				tbl.close();			
			}
		}
	}
}

function DpShtatTreeItem()
{	
	this.tree = null;
	
	this.arrQuary = new Array();	
	this.elements = new Array();
	this.info = new DpShtatInfo();
	this.parent = null;	
	this.table = null;
	
	this.id = null;
	this.parentID = null;
	this.isorg = false;
	this.ispodr = false;
	this.isdol = false;
	this.ishomo = false;
	this.islikv = false;
	this.qryRefresh = "";
	this.txt = "";
	this.qryTable = null;
	
	this.getText = DpShtatTreeItem_getText;
	this.setParentID = DpShtatTreeItem_setParentID;
	this.getParentID = DpShtatTreeItem_getParentID;
	this.setID = DpShtatTreeItem_setID;
	this.getID = DpShtatTreeItem_getID;
	this.fillData = DpShtatTreeItem_fillData;
	this.getSubItems = DpShtatTreeItem_getSubItems;
	this.refresh = DpShtatTreeItem_refresh;
	this.dispose = DpShtatTreeItem_dispose;
}

function DpShtatTreeItem_dispose()
{
	if (this.table != null)
		this.table.close();
	for (var i in this.elements)
		this.elements[i].dispose();
}

function DpShtatTreeItem_setID(id)
{
	this.id = String(id);
}

function DpShtatTreeItem_getID()
{
	return this.id;
}

function DpShtatTreeItem_setParentID(parentID)
{
	this.parentID = String(parentID);
}

function DpShtatTreeItem_getParentID()
{
	return this.parentID;
}

function DpShtatTreeItem_fillData(tbl)
{
	if (this.ishomo == true)
	{
		this.sex = (tbl.getValue("fsex") == true ? true : false);
		this.txt = getSmallFIO(this.getText(tbl));
	}
	else
		this.txt = this.getText(tbl);
	this.info.bdat = getMyStrDat(tbl.getValue("fbdat"));	
	this.info.edat = getMyStrDat(tbl.getValue("fedat"));	
	this.islikv = this.info.edat != "";
	if (this.isdol && this.info.edat == "")
	{
		if (tbl.getValue("fwedat") == null)
			this.info.wedat = this.info.bdat;
		else
			this.info.wedat =  getMyStrDat(tbl.getValue("fwedat"), true);
	}
	this.info.oklad = (tbl.getValue("foklad") == null ? "" : String(tbl.getValue("foklad")));	
	this.info.shpz = (tbl.getValue("fshpz") == null ? "" : String(tbl.getValue("fshpz")));
}

function DpShtatTreeItem_getSubItems()
{
	this.dispose();
	this.elements = new Array();
	if (typeof this.arrQuary == "object")
	{
		for (var i in this.arrQuary)
		{
			var strSQL = String(this.arrQuary[i])

			var tbl = OpenTable("m", strSQL);
			var id = this.elements.length - 1;
			for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				this.elements[++id] = new DpShtatTreeItem();
				this.elements[id].tree = this.tree;	
				this.elements[id].parent = this;
				this.elements[id].setID(String(tbl.getValue("fwid")));
				var parID = tbl.getValue("fwid_par");
				this.elements[id].setParentID(((parID == null) || (typeof parID == "undefined"))  ? "0" : String(parID));
				this.elements[id].isorg = false;
				this.elements[id].isdol = (tbl.getValue("fisdol") == true ? true : false);
				this.elements[id].ishomo = (tbl.getValue("fishomo") == true ? true : false);
				this.elements[id].ispodr = (!this.elements[id].isdol && !this.elements[id].ishomo);	
				this.elements[id].fillData(tbl);
				this.elements[id].qryTable = getQryTable(this.elements[id]);
				this.elements[id].qryRefresh = getQryRefresh(this.elements[id]);
				this.elements[id].arrQuary = getQrySubItem(this.elements[id]);
			}
			tbl.close();			
		}
	}
}

function DpShtatTreeItem_refresh()
{
	if (typeof this.qryRefresh == "string" && this.qryRefresh != "")
	{
		var tbl = OpenTable("m", this.qryRefresh);
		if (!tbl.IsEmpty())
		{
			tbl.MoveFirst();
			this.fillData(tbl);
		}
		tbl.close();	
	}
}

function DpShtatTreeItem_getText(tbl)
{
	var text = tbl.getValue("ftxts");
	if (text != null && text != "")
		return UR(String(text));
	text = tbl.getValue("ftxt");
	if (text != null)
		return UR(String(text));
	return "undefined";
}

function DpShtatInfo()
{
	this.bdat = "";
	this.edat = "";
	this.wedat = "";
	this.oklad = "";
	this.shpz = "";
}

/*function DpShtatInfo_init()
{
	for (var i in this)
		if (typeof this[i] != "function")
		{
			var j = String(i)[0].toUpperCase() + String(i).substring(1);
			eval("function get" + j + "(){"
				+ " if (typeOf(this." + i + ") == 'Date') return getMyStrDate(this." + i + ");"
				+ " else return String(this." + i + ")}");
			this["get" + j] = eval("get" + j);
		}
}*/

// BEGIN ================= new : work with stack composite
function setPage(id)
{
	if (stack.hasPage(id))
	{return stack.setPage(id)
		};
	obj = Tree.getObject(id);
	var dlgBuilder = FORM.getDialogBuilder();	
	var page = null;
	var BOLD = 1 << 0;
	if (!obj.isdol)
	{
		page = stack.addPage(id, getTextForPage(obj), 2);
		var tmpStrDat = String(obj.info.bdat) == "" ? "-----" : String(obj.info.bdat);						
		dlgBuilder.addLabel(page, UR("Дата створення: |Дата создания: "), BOLD);
		dlgBuilder.addLabel(page, tmpStrDat);
		tmpStrDat = String(obj.info.edat) == "" ? "-----" : String(obj.info.edat);
		dlgBuilder.addLabel(page, UR("Дата ліквідації: |Дата ликвидации: "), BOLD);
		dlgBuilder.addLabel(page, tmpStrDat);	
	}
	else
	{	
		page = stack.addPage(id, getTextForPage(obj), 4);

		var tmpStrDat = String(obj.info.bdat) == "" ? "-----" : String(obj.info.bdat);
		dlgBuilder.addLabel(page, UR("Дата створення: |Дата создания: "), BOLD);
		dlgBuilder.addLabel(page, tmpStrDat);	
		dlgBuilder.addLabel(page, "\tОклад: ", BOLD);
		dlgBuilder.addLabel(page, String(obj.info.oklad) + " грн.");	
	
		tmpStrDat = String(obj.info.edat) == "" ? "-----" : String(obj.info.edat);
		dlgBuilder.addLabel(page, UR("Дата ліквідації: |Дата ликвидации: "), BOLD);
		dlgBuilder.addLabel(page, tmpStrDat);
		dlgBuilder.addLabel(page, "\tШПЗ: ", BOLD);
		dlgBuilder.addLabel(page, String(obj.info.shpz));
	
		if (obj.info.edat == "")
		{
			tmpStrDat = String(obj.info.wedat) == "" ? "-----" : String(obj.info.wedat);
			dlgBuilder.addLabel(page, UR("Вакантна з: |Вакантная с: "), BOLD);		
			dlgBuilder.addLabel(page, tmpStrDat);
		}		
	}
	stack.setPage(id);	
}

function refreshPage(id)
{
	if (stack.hasPage(id))
		stack.deletePage(id);
	setPage(id);
}

function setInfoPage()
{
	var id = "information";
	page = stack.addPage(id, UR("Увага!|Внимание!"), 1);
	var dlgBuilder = FORM.getDialogBuilder();
	dlgBuilder.addLabel(page, UR("На заданий період організації не знайдено.|На заданый период организации не найдено."));
	/*dlgBuilder.addLabel(page, UR("Для створення організації скористуйтеся відповідним пунктом меню дерева|"+
		"Для создания организации воспользуйтесь соответствующим пунктом меню дерева."));*/
	stack.setPage(id);
}

// END ================= new : work with stack composite

function getTextForPage(obj)
{	
	var result = "";
	do
	{
		if (result != "")
			result = obj.txt + " > " + result;
		else
			result =  obj.txt;
		if (typeof obj.parent == "undefined" || obj.parent == null)
			return result;
		obj = obj.parent;
	}
	while (true);
}


function createOrg()
{
	var txt = UR("Ваша організація|Ваша организация");
	ExecuteSQL("INSERT INTO ^stru_org (fwid, fwid_par, ftxt, ftxts, fbdat) values(" + sqlTo(GetUID())
			+ ",0," + sqlTo(txt) + "," + sqlTo(txt) + "," + sqlTo(new Date().getVarDate()) + ")");
}


include("sys\\DpBaseDlg.js");