//просмотр справки в пенсионный фонд помесячной
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("r_svb11.js");
include("servis/date.js");
include("get_const.js");
include("sys/udfs.js");

var gd, szTag;

function listLoad()
{
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	
	var par=new Object();
	par.dat1 = gd.dat1;		

	this.title = UR("Розрахунок - | Расчет - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	r_svb11(par);

	if (!IsTable("XSV14") && !IsTable("XSV15") && !IsTable("XSV17"))
	{
		return false;
	}
	this.title = UR("Перегляд звiр.бази ЄСВ в ОР та перс.-|Просмотр сверки базы ЕСВ в ЛС и перс.- ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	
	dpGridEdit = new DpGridEdit(grid);
	//dpGridEdit.canEdit = gridEdit;
	//dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("From", "XSV14", "Order", "Ftabn_id");
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	gr.FieldEx("=getCodFromID(^Ftabn_id)","Таб.№|Таб.№",6,"","%10d");	
	gr.FieldEx("=getSmallFIO(getTxtFromID(^Ftabn_id))","ПIБ|ФИО",15);
	gr.FieldEx("FDAY","Кат.\nОР|Кат.\nЛС", 3, "e");	
	gr.FieldEx("FSUMLS","База ЄСВ ОР|База ЕСВ ЛС",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("FLD9","Кат.\nПерс.|Кат.\nПерс.", 3, "e");	
	gr.FieldEx("FSUMPS","База ЄСВ перс.|База ЕСВ перс.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		AddMenuItem("BASE2", "Звіряння ЄСВ|Сверка ЕСВ");
		AddMenuItem("BASE3", "Звіряння сум доходу|Сверка сумм дохода");
    }
}


function listMenuRun(ID)
{
	switch(ID)
	{
    case "BASE2":
		var par = new Object();    
		showWindow("l_svbesv.js", SW_NOMODAL, par);    	
		list.tbl.requery();
		grid.RefreshGrid();
        break;
    case "BASE3":
		var par = new Object();    	
		showWindow("l_svbdox.js", SW_NOMODAL, par);    	
		list.tbl.requery();
		grid.RefreshGrid();
        break;
	}
}


include("sys/DpList.js");	
	