var szTable;

function listLoad()
{
	this.title = ru("Импортированные балансы","Імпортовані баланси");
	this.xmlGridFile = "l_svoamort2.xml";
	
	if (!IsTable("svamort"))
		CreateTable("svamort","SVOAMORT","*");
	if (!IsTable("svoamort_info"))
		CreateTable("svoamort_info","CL_SVODN","*");
}

function listSrc()
{
	this.qrySet("From", "^svoamort_info");
}

function showAmort(name,rn_obl,date,sqlWhere)
{
	var p = new Object();
	p.nameTable = name;
	if (sqlWhere) 
		p.sqlWhere = sqlWhere;
	if (!rn_obl) 
		p.rn_obl = 0; 
	else 
		p.rn_obl = 1;
	if (!date) 
		p.date = 0; 
	else 
		p.date = 1;
	showWindow("showamort.js",SW_NOMODAL,p);
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("IMPORT_AMORT","Iмпорт розр.по рах.|Импорт расч.по сч.");
	this.dataSrc.AddMenuItem("DEL_AMORT","Вилуч. розр.по рах.|Удал.расч.по сч.");
	this.dataSrc.AddMenuItem("VIEW_AMORT","Перегляд розр.по рах.|Просмотр расч.по сч.");
	this.dataSrc.AddMenuItem("COUNT_SVOBRAMORT","Розр.звед.розр.по рах.|Расч.сводн.расч.по сч.");
	this.dataSrc.AddMenuItem("VIEW_SVOBRAMORT","Перегл.звед.розр.по рах.|Просм.сводн.расч.по сч.");
}

function listMenuRun(ID)
{
	if (ID == "IMPORT_AMORT")
	{
		Org = input("Введите номер организации", "", 0, 6);
		if (Org != null)
		{
			var nameTable = "amort__" + Org;

			if (!IsTable(nameTable)) 
				alert(ru("Для этого района не была расчитана амортизация","Для цього району не було розраховано амортизацію"));
			else
			{
				var t1 = OpenTable("s",nameTable);
				if (!t1.IsEmpty())
				{
					var t2 = OpenTable("s","svamort");
					var sqlstr = " frn = " + Org +
							 " AND fbdat = " + sqlToFind(t1.getValue("fbdat")) +
							 " AND fedat = " + sqlToFind(t1.getValue("fedat"));
					if (t2.findFirst(sqlstr))
					{
						if (confirm("В баланс по амортизации ранее уже была импортирована \n" +
								"    таблица амортизации '" + Org + "' организации \n" +
								"за промежуток времени c " + StrDat(t1.getValue("fbdat"),"DMY") + " по " + StrDat(t1.getValue("fedat"),"DMY") + ".\n" +
								"    Заменить существуещие записи новыми ?"))
						{
							ExecuteSQL("DELETE FROM svamort WHERE " + sqlstr );
							ExecuteSQL("INSERT INTO svamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn , fobl) " +
								" SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST," +
								" FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn , fobl FROM " + nameTable);
						}
					}
					else
					{
						ExecuteSQL("INSERT INTO svamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl) " +
								" SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST," +
								" FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl FROM " + nameTable);
						var curFwid = GetUID();
						var m = new Object();
						m.Fwid = curFwid;
						m.Frn = t1.getValue("FRN");
						m.Fbdat = t1.getValue("FBDAT");
						m.Fedat = t1.getValue("FEDAT");
						m.Fobl = t1.getValue("FOBL");
						var oSnap = getSnap("SELECT FNAZV FROM ^CL_SVBAL WHERE FRN=" + Org);
						if (oSnap!=null)
							m.Fnazv = oSnap[0];
						UpdateTable("^svoamort_info", m, true);
					}
					t2.close();
				}
				else
					alert(ru("Импортарованная таблица пустая","Імпортована таблиця порожня"));
				t1.close();
			}
			list.tbl.requery();
			grid.refresh();
		}
	}else
	if ((ID == "DEL_AMORT") && !(list.tbl.IsEmpty()))
	{
		ExecuteSQL( "DELETE FROM svamort WHERE " +
				" frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
				" fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
				" fedat = " + sqlTo(list.tbl.getValue("fedat")));
		ExecuteSQL("DELETE FROM ^svoamort_info WHERE Fwid="+list.tbl.getValue("Fwid"));
		list.tbl.requery();
		grid.refresh();
	}else
	if ((ID == "VIEW_AMORT") && (!(list.tbl.IsEmpty())))
	{
		showAmort("svamort",1,0,"frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
						 " fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
						 " fedat = " + sqlTo(list.tbl.getValue("fedat")));
	}else
	if (ID == "COUNT_SVOBRAMORT")
	{
		//setDsAlias("B.");
		//var str1 = DataSource().sqlSelected(null," B.FWID ");
		var str1 = DataSource().sqlSelected();
		DropTable("svo_obr_amort");
		CreateTable("svo_obr_amort","SVOAMORT","*");
		var strSQL = " INSERT INTO svo_obr_amort " +
				 "(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
				 "FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV)" +
				 " SELECT A.FBDAT,A.FEDAT,A.FGROUP,A.FINV_NUM,A.FKOMPL,A.FTDSC," +
				 " SUM(A.FORIG_PRIC) AS FORIG_PRIC," +
				 " SUM(A.FSUM_AM) AS FSUM_AM," +
				 " SUM(A.FSUM_IZN) AS FSUM_IZN," +
				 " SUM(A.FSUM_PV) AS FSUM_PV " +
       	   " FROM SVAMORT A RIGHT JOIN svoamort_info B" +
			     " 	ON ( a.FRN = b.FRN AND a.FBDAT = b.FBDAT AND a.FEDAT = b.FEDAT )" +
				 "		WHERE B.Fwid=(SELECT Fwid FROM svoamort_info WHERE " + str1 + ")" +
				 " GROUP BY A.FBDAT,A.FEDAT,A.FGROUP,A.FINV_NUM,A.FKOMPL,A.FTDSC";
		ExecuteSQL(strSQL);
	}else
	if ((ID == "VIEW_SVOBRAMORT") && (IsTable("svo_obr_amort"))) 
		showAmort("svo_obr_amort");
}
include ("sys\\DpList.js");