var szTable;

function listLoad()
{
	this.title = ru("Импортированные балансы","Імпортовані баланси");
	this.xmlGridFile = "l_svoamort2.xml";
	if (!IsTable("svoapodr")) 
		CreateTable("svoapodr","SVOAPODR","*");
	if (!IsTable("svoapodr_info")) 
		CreateTable("svoapodr_info","CL_SVODN","*");
}

function showApodr(name,rn_obl,date,sqlWhere)
{
	var p = new Object();
	p.nameTable = name;
	if (sqlWhere) 
		p.sqlWhere = sqlWhere;
	if (!rn_obl) 
		p.rn_obl = 0; 
	else 
		p.rn_obl = 1;
	if (!date) 
		p.date = 0; 
	else 
		p.date = 1;
	showWindow("showapodr.js",SW_NOMODAL,p);
}

function listSrc()
{
	this.qrySet("From", "^svoapodr_info");
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("IMPORT_APODR","Iмпорт розр.по рах.");
	this.dataSrc.AddMenuItem("DEL_APODR","Вилуч. розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_APODR","Перегляд розр.по рах.");
	this.dataSrc.AddMenuItem("COUNT_SVOBRAPODR","Розр.звед.розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_SVOBRAPODR","Перегл.звед.розр.по рах.");
}

function listMenuRun(ID)
{
	if ((ID == "DEL_APODR") && (!(list.tbl.IsEmpty())))
	{
		ExecuteSQL( "DELETE FROM svoapodr WHERE " +
					" frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
					" fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
					" fedat = " + sqlTo(list.tbl.getValue("fedat")));
		list.tbl.requery();
		grid.refresh();
	}
	if ((ID == "VIEW_APODR") && (!(list.tbl.IsEmpty())))
	{
		showApodr("svoapodr",1,0,"frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
					 " fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
					 " fedat = " + sqlTo(list.tbl.getValue("fedat")));
	}
	if (ID == "COUNT_SVOBRAPODR")
	{
//		setDsAlias("B.");
//		var str1 = d.sqlSelected(null," B.FWID ");
		var str1 = DataSource().sqlSelected();
		DropTable("svo_obr_apodr");
		CreateTable("svo_obr_apodr","SVOAPODR","*");
		var strSQL = " INSERT INTO svo_obr_apodr " +
					 "(FDATKV, FDB_SC, FDB_ST, FDB_SU, FPODR, FGROUP, FINV_NUM, FTDPODR, FBDAT, FEDAT,FSUM_PV) " +
					 " SELECT A.FDATKV, A.FDB_SC, A.FDB_ST, A.FDB_SU, A.FPODR, A.FGROUP, A.FINV_NUM, A.FTDPODR, A.FBDAT, A.FEDAT," +
					 " SUM(A.FSUM_PV) AS FSUM_PV " +
           " FROM SVOAPODR A RIGHT JOIN svoapodr_info B" +
				     "    ON ( a.FRN = b.FRN AND a.FBDAT = b.FBDAT AND a.FEDAT = b.FEDAT )" +
					 " 		WHERE B.Fwid=(SELECT Fwid FROM svoapodr_info WHERE " + str1 + ")" +
					 " GROUP BY A.FDATKV, A.FDB_SC, A.FDB_ST, A.FDB_SU, A.FPODR, A.FGROUP, A.FINV_NUM, A.FTDPODR, A.FBDAT, A.FEDAT";
		ExecuteSQL(strSQL);
	}

	if ((ID == "VIEW_SVOBRAPODR") && (IsTable("svo_obr_apodr"))) 
		showApodr("svo_obr_apodr");
	if (ID == "IMPORT_APODR")
	{
		Org = input("Введите номер организации", "", 0, 6);
		if ( Org != null)
		{
			var nameTable = "apodr__" + Org;
			if (!IsTable(nameTable)) 
				alert("Для этого района не была расчитана амортизация");
			else
			{
				var t1 = OpenTable("s",nameTable);
				if (!t1.IsEmpty())
				{
 					var t2 = OpenTable("s","SELECT * FROM svoapodr");
					var sqlstr = " frn = " + Org +
							 " AND fbdat = " + sqlToFind(t1.getValue("fbdat")) +
							 " AND fedat = " + sqlToFind(t1.getValue("fedat"));
					if (t2.findFirst(sqlstr))
					{
						if (confirm("       В свод по амортизации ранее уже была \n" +
								    "    импортирована амортизация '" + Org + "' организации \n" +
									"за промежуток времени c " + StrDat(t1("fbdat"),"DMY") + " по " + StrDat(t1("fedat"),"DMY") + ".\n" +
									"      Заменить существуещие записи новыми ?"))
						{
							ExecuteSQL("DELETE FROM svoapodr WHERE " + sqlstr );
							ExecuteSQL("INSERT INTO svoapodr(FDATKV, FDB_SC, FDB_ST, FDB_SU, FPODR, FGROUP, FINV_NUM, FTDPODR, FBDAT, FEDAT, FSUM_PV,frn, fobl) " +
										" SELECT FDATKV, FDB_SC, FDB_ST, FDB_SU, FPODR, FGROUP, FINV_NUM, FTDPODR, FBDAT, FEDAT, FSUM_PV," +
									    "frn, fobl FROM " + nameTable);
						}
					}
					else
					{
						ExecuteSQL("INSERT INTO svoapodr(FDATKV, FDB_SC, FDB_ST, FDB_SU, FPODR, FGROUP, FINV_NUM, FTDPODR, FBDAT, FEDAT, FSUM_PV,frn, fobl) " +
									" SELECT FDATKV, FDB_SC, FDB_ST, FDB_SU, FPODR, FGROUP, FINV_NUM, FTDPODR, FBDAT, FEDAT, FSUM_PV," +
								    "frn, fobl FROM " + nameTable);
						var curFwid = GetUID();
						var m = new Object();
						m.Fwid = curFwid;
						m.Frn = t1.getValue("FRN");
						m.Fbdat = t1.getValue("FBDAT");
						m.Fedat = t1.getValue("FEDAT");
						m.Fobl = t1.getValue("FOBL");
						var oSnap = getSnap("SELECT FNAZV FROM ^CL_SVBAL WHERE FRN=" + Org);
						if (oSnap!=null)
							m.Fnazv = oSnap[0];
						UpdateTable("^svoapodr_info", m, true);
					}
				}
				else
					alert(ru("Импортарованная таблица пустая","Імпортована таблиця порожня"));
			}
			list.tbl.requery();
			grid.refresh();
		}
	}
}	
include ("sys\\DpList.js");