include("Objects//DpGetDat.js");
include("firstkv.js");
include("lastkv.js");

var szTable;

function listLoad()
{
	this.title = ru("Сводная аморт. н/акт.","Зведена аморт. н/акт.");
	this.xmlGridFile = "l_svoamort.xml";
	if (!IsTable("svnamort"))
		CreateTable("svnamort","SVOAMORT","*");
	if (!IsTable("svonamort_info"))
		CreateTable("svonamort_info","CL_SVODN","*");
}

function listSrc()
{
	this.qrySet("From", "^cl_svbal");
}

function showNAmort(name,rn_obl,date,sqlWhere)
{
	var p = new Object();
	p.nameTable = name;
	p.prnPatt = "AMNEM";
	if (sqlWhere) 
		p.sqlWhere = sqlWhere;
	if (!rn_obl)
		p.rn_obl = 0
	else
		p.rn_obl = 1;
	if (!date) 
		p.date = 0
	else 
		p.date = 1;
	showWindow("shownamort.js",SW_NOMODAL,p);
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("LIST_NAMORT","Импортированные балансы");
	this.dataSrc.AddMenuItem("IMPORT_NAMORT","Iмпорт розр.по рах.");
	this.dataSrc.AddMenuItem("DEL_NAMORT","Вилуч. розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_NAMORT","Перегляд розр.по рах.");
	this.dataSrc.AddMenuItem("COUNT_SVOBRNAMORT","Розр.звед.розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_SVOBRNAMORT","Перегл.звед.розр.по рах.");
}

function listMenuRun(ID)
{
	if (ID == "LIST_NAMORT") 
		showWindow("l_svonamort2.js", SW_NOMODAL);
	if (ID == "svnamort") 
		showNAmort("svnamort",1);
	if ((ID == "DEL_NAMORT") && (!list.tbl.IsEmpty()))
	{
		var date = new DpGetDat("d");
		if (!date.escape)
		{
			var sqlStr = " frn = " + sqlTo(list.tbl.getValue("frn")) + " AND fbdat = " + sqlTo(firstDay(date.dat1)) + " AND fedat = " + sqlTo(lastDay(date.dat1));
			ExecuteSQL("DELETE FROM svnamort WHERE " + sqlStr);
			ExecuteSQL("DELETE FROM svonamort_info WHERE " + sqlStr);
		}
		date = null;
	}
	if ((ID == "VIEW_NAMORT") && (!list.tbl.IsEmpty()))
	{
		var date = new DpGetDat("d");
		if (!date.escape)
				showNAmort("svnamort",1,0,"frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
								 " fbdat = " + sqlTo(firstDay(date.dat1)) + " AND " +
								 " fedat = " + sqlTo(lastDay(date.dat1)) );
		date = null;
	}
	if (ID == "COUNT_SVOBRNAMORT")
	{
		var date = new DpGetDat("d");
		if (!date.escape)
		{
			DropTable("svo_obr_namort");
			CreateTable("svo_obr_namort","SVOAMORT","*");
			var strSQL = " INSERT INTO svo_obr_namort " +
						 "(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
						 "FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
						 "FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV) " +
						 " SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
						 " FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
						 " SUM(a.FORIG_PRIC) AS FORIG_PRIC," +
						 " SUM(a.FSUM_AM) AS FSUM_AM," +
						 " SUM(a.FSUM_IZN) AS FSUM_IZN," +
						 " SUM(a.FSUM_PV) AS FSUM_PV " +
						 " FROM SVNAMORT a" +
						 " WHERE a.FRN IN (SELECT FRN FROM ^cl_svbal " +
						 "                 WHERE " + DataSource().sqlSelected() + ")" +
						 "       AND FBDAT = " + sqlTo(firstDay(date.dat1)) +
						 "       AND FEDAT = " + sqlTo(lastDay(date.dat1)) +
						 " GROUP BY FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
						 " FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE";
			ExecuteSQL(strSQL);
		}
	}
	if ((ID == "VIEW_SVOBRNAMORT") && (IsTable("svo_obr_blns")))
		showNAmort("svo_obr_namort");
	if (ID == "IMPORT_NAMORT")
	{
		var nameTable = "namort__" + list.tbl.getValue("frn");

		if (!IsTable(nameTable))
			alert(ru("Для этого района не была расчитана нематериальная амортизация","Для цього району не було розраховано нематеріальну амортизацію"));
		else
		{
			var t1 = OpenTable("s",nameTable);
			if (!t1.IsEmpty())
			{
				var t2 = OpenTable("s","SELECT * FROM svnamort");
				var sqlstr =" frn = " + sqlToFind(list.tbl.getValue("frn")) +
						" AND fbdat = " + sqlToFind(t1.getValue("fbdat")) +
						" AND fedat = " + sqlToFind(t1.getValue("fedat"));
				if (t2.findFirst(sqlstr))
				{
					if (confirm("В сводную нематериальную амортизацию ранее уже была импортирована \n" +
								"    таблица нематериальной амортизации '" + sqlTo(list.tbl.getValue("frn")) + "' организации \n" +
								"за промежуток времени c " + StrDat(t1.getValue("fbdat"),"DMY") + " по " + StrDat(t1.getValue("fedat"),"DMY") + ".\n" +
								"    Заменить существуещие записи новыми ?"))
					{
						ExecuteSQL("DELETE FROM svnamort WHERE " + sqlstr );
						ExecuteSQL("INSERT INTO svnamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl) " +
								   " SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
								   " FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
								   " FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl FROM " + nameTable);
					}
				} 
				else
				{
					ExecuteSQL("INSERT INTO svnamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl) " +
						   " SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
						   " FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
						   " FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl FROM " + nameTable);
					var curFwid = GetUID();
					var oSnap = getSnap("SELECT FNAZV FROM ^CL_SVBAL WHERE FRN=" + iOrg);
					if (oSnap!=null)
						var iNazv = oSnap[0];
					ExecuteSQL("INSERT INTO svonamort_info (fnazv, fobl, frn, fbdat, fedat, fwid) VALUES ( " + sqlTo(iNazv) + ", " + list.tbl.getValue("fobl") + ", " + list.tbl.getValue("frn") + ", " + sqlTo(t1.getValue("fbdat")) + ", " + sqlTo(t1.getValue("fedat")) + ", " + sqlTo(curFwid) + " )");
				}
			}else alert(ru("Импортарованная таблица пустая","Імпортована таблиця порожня"));
		}
	}
	else
		stdMenuHandler(ID);
}	
include ("sys\\DpList.js");