var szTable;

function listLoad()
{
	this.title = ru("Импортированные балансы","Імпортовані баланси");
	this.xmlGridFile = "l_svoamort2.xml";
	if (!IsTable("svnamort")) 
		CreateTable("svnamort","SVOAMORT","*");
	if (!IsTable("svonamort_info")) 
		CreateTable("svonamort_info","CL_SVODN","*");
}

function listSrc()
{
	this.qrySet("From", "^svonamort_info");
}

function showNAmort(name,rn_obl,date,sqlWhere)
{
	var p = new Object();
	p.nameTable = name;
	p.prnPatt = "AMNEM";
	if (sqlWhere) 
		p.sqlWhere = sqlWhere;
	if (!rn_obl) 
		p.rn_obl = 0; 
	else 
		p.rn_obl = 1;
	if (!date) 
		p.date = 0; 
	else 
		p.date = 1;
	showWindow("shownamort.js",SW_NOMODAL,p);
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("IMPORT_NAMORT","Iмпорт розр.по рах.");
	this.dataSrc.AddMenuItem("DEL_NAMORT","Вилуч. розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_NAMORT","Перегляд розр.по рах.");
	this.dataSrc.AddMenuItem("COUNT_SVOBRNAMORT","Розр.звед.розр.по рах.");
	this.dataSrc.AddMenuItem("VIEW_SVOBRNAMORT","Перегл.звед.розр.по рах.");
}

function listMenuRun(ID)
{
	if ((ID == "DEL_NAMORT") && (!(list.tbl.IsEmpty())))
	{
		ExecuteSQL( "DELETE FROM svnamort WHERE " +
					" frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
					" fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
					" fedat = " + sqlTo(list.tbl.getValue("fedat")));
		if(!list.tbl.isEof()) 
			list.tbl.moveNext();
		if(!list.tbl.isBof()) 
			list.tbl.movePrev();
		list.tbl.requery();
		grid.refresh();
	}
	if ((ID == "VIEW_NAMORT") && (!(list.tbl.IsEmpty())))
	{
		showNAmort("svnamort",1,0,"frn = " + sqlTo(list.tbl.getValue("frn")) + " AND " +
							 " fbdat = " + sqlTo(list.tbl.getValue("fbdat")) + " AND " +
							 " fedat = " + sqlTo(list.tbl.getValue("fedat")));
	}
	if (ID == "COUNT_SVOBRNAMORT")
	{
//		setDsAlias("B.");
//		var str1 = d.sqlSelected(null," B.FWID ");
		var str1 = DataSource().sqlSelected();
		DropTable("svo_obr_namort");
		CreateTable("svo_obr_namort","SVOAMORT","*");
		var strSQL = " INSERT INTO svo_obr_namort " +
					 "(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC," +
					 "FPODR,FDB_SC,FDB_ST,FDB_SU,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
					 "FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV) " +
					 " SELECT A.FBDAT,A.FEDAT,A.FGROUP,A.FINV_NUM,A.FKOMPL,A.FTDSC," +
					 " A.FPODR,A.FDB_SC,A.FDB_ST,A.FDB_SU,A.FTDST,A.FTDSU,A.FTDPODR,A.FVOST_RATE," +
					 " SUM(A.FORIG_PRIC) AS FORIG_PRIC," +
					 " SUM(A.FSUM_AM) AS FSUM_AM," +
					 " SUM(A.FSUM_IZN) AS FSUM_IZN," +
					 " SUM(A.FSUM_PV) AS FSUM_PV " +
           " FROM SVNAMORT A RIGHT JOIN svonamort_info B" +
				     "    ON ( a.FRN = b.FRN AND a.FBDAT = b.FBDAT AND a.FEDAT = b.FEDAT )" +
					 " 		WHERE B.Fwid=(SELECT Fwid FROM svonamort_info WHERE " + str1 + ")" +
					 " GROUP BY A.FBDAT,A.FEDAT,A.FGROUP,A.FINV_NUM,A.FKOMPL,A.FTDSC," +
					 " A.FPODR,A.FDB_SC,A.FDB_ST,A.FDB_SU,A.FTDST,A.FTDSU,A.FTDPODR,A.FVOST_RATE";
		ExecuteSQL(strSQL);
	}

	if ((ID == "VIEW_SVOBRNAMORT") && (IsTable("svo_obr_blns"))) 
		showNAmort("svo_obr_namort");
	if (ID == "IMPORT_NAMORT")
	{
		Org = input("Введите номер организации", "", 0, 6);
		if ( Org != null)
		{
			var nameTable = "namort__" + Org;

			if (!IsTable(nameTable)) 
				alert(ru("Для этого района не была расчитана нематериальная амортизация","Для цього району не було розраховано нематеріальну амортизацію"));
			else
			{
				var t1 = OpenTable("s",nameTable);
				if (!t1.IsEmpty())
				{
 					var t2 = OpenTable("s","SELECT * FROM svnamort");
					var sqlstr = " frn = " + Org +
								 " AND fbdat = " + sqlToFind(t1.getValue("fbdat")) +
								 " AND fedat = " + sqlToFind(t1.getValue("fedat"));
					if (t2.findFirst(sqlstr))
					{
						if (confirm("В сводную нематериальную амортизацию ранее уже была импортирована \n" +
									"    таблица нематериальной амортизации '" + Org + "' организации \n" +
									"за промежуток времени c " + StrDat(t1.getValue("fbdat"),"DMY") + " по " + StrDat(t1.getValue("fedat"),"DMY") + ".\n" +
									"    Заменить существуещие записи новыми ?"))
						{
							ExecuteSQL("DELETE FROM svnamort WHERE " + sqlstr );
							ExecuteSQL("INSERT INTO svnamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FTDST,FTDSU,FTDPODR,FVOST_RATE,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl) " +
										" SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
										" FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl FROM " + nameTable);
						}
					}
					else
					{
						ExecuteSQL("INSERT INTO svnamort(FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FTDST,FTDSU,FTDPODR,FVOST_RATE,FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl) " +
									" SELECT FBDAT,FEDAT,FGROUP,FINV_NUM,FKOMPL,FTDSC,FPODR,FDB_SC,FDB_ST,FTDST,FTDSU,FTDPODR,FVOST_RATE," +
									" FORIG_PRIC,FSUM_AM,FSUM_IZN,FSUM_PV, frn, fobl FROM " + nameTable);
						var m = new Object();
						var curFwid = GetUID();
						m.Fwid = curFwid;
						m.Frn = t1.getValue("FRN");
						m.Fbdat = t1.getValue("FBDAT");
						m.Fedat = t1.getValue("FEDAT");
						m.Fobl = t1.getValue("FOBL");
						var oSnap = getSnap("SELECT FNAZV FROM ^CL_SVBAL WHERE FRN=" + Org);
						if (oSnap!=null)
							m.Fnazv = oSnap[0];
						UpdateTable("^svonamort_info", m, true);
					}
				}
				else 
					alert(ru("Импортарованная таблица пустая","Імпортована таблиця порожня"));
			}
			list.tbl.requery();
			grid.refresh();
		}
	}
}	
include ("sys\\DpList.js");