//Редактирование результатов лицевых счетов
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");

var szTag, gd;
var dpGridEdit = null;
var dpShifPZ = null;

function listLoad()
{
	gd = new DpGetDat("d");
	if (gd.escape)
		return false;
	this.title = "Перегляд підсумків |Просмотр итогов "+format("dd.mm.yyyy",gd.dat1);
	this.xmlGridFile = "l_svzptn.xml";
	szTag = getDateTag(gd.dat1);

	if (!IsTableEx("ZRP_RES","ZRP_SVPF"+szTag))
	{
		alert(ru("Произведите сначала расчет ЗП за данный месяц!",
				"Виконайте спершу розрахунок ЗП за даний місяць!"));
		return false;
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.addValidField("FSHPZ", startEdit_fshpz, save_fshpz);
}

function listSrc()
{
	this.qrySet("Fields", "s.*, rel.Fcod",
				"From", "^svpf"+szTag+" AS s LEFT JOIN ^clrelclcl AS rel ON s.Ftabn_id=rel.Fwid_cl",
				"Where", "not(s.Fvp=1 and Fmn>="+sqlTo(firstDay(gd.dat1))+")",
				"Order", "rel.Fcod, ffld_num");
	this.subTie("LIC_FLD","LCFLD","FID","FLSFID");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
	this.qrySet("Alias", "s");
}

function listMenuInit()
{
	//this.dataSrc.AddMenuItem("VST", ru("Восстан.записи за буд.периоды","Відновл.запису за майб.періоди"));
	this.dataSrc.AddMenuItem("ISSHPL","Перевірка ШВЗ|Проверка ШПЗ");	
}

function listMenuRun(nID)
{
	if (nID=="VST")
	{
		include("r_vostnx.js");
		r_vostnx();
		list.tbl.requery();
		grid.refresh();
	}
	if (nID=="ISSHPL")
	{
		strSQL = "select * from ^svpf"+szTag+" WHERE Fwid_wp<>0 and FWID " + grid.sqlSelected(true);
		var tprk = OpenTable("s", strSQL);
		for(; !tprk.IsEOF(); tprk.MoveNext())
		{ 
	   		var gsn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(Number(tprk.getValue("Flsfid"))));
   			if (gsn2!=null){    
   				zat = allt(String(gsn2[0]));
   			}else{
   				zat = "0";
   			}
   				
			var gsn = getSnap("select d.Fshpz FROM ^work_pers w inner join ^stru_dol d on w.fwid_dol=d.fwid WHERE w.Fwid_cl="+sqlTo(Number(tprk.getValue("Ftabn_id")))+" and w.Fwid="+sqlTo(Number(tprk.getValue("Fwid_wp"))))				
			if (gsn!=null){
				cshpz = gsn[0]
			}else{
				cshpz = ""
			}
	       	if (zat!="0"){
   				//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
   				cshpz = allt(cshpz).substring(0,allt(cshpz).length-1)+allt(String(zat))
    		}
   				alert(cshpz)    		
			strSQL = "UPDATE ^svpf"+szTag+" SET Fshpz="+allt(cshpz)+" WHERE Fwid="+ tprk.getValue("Fwid")+" and Ftabn_id="+sqlTo(Number(tprk.getValue("Ftabn_id")))+" and Fwid_wp="+sqlTo(Number(tprk.getValue("Fwid_wp")))
			ExecuteSQL(strSQL);
		}
		list.tbl.requery();
		grid.refresh();
	}
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^svpf"+szTag+" WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
}

function listMassDel()
{
	ExecuteSQL("DELETE FROM ^svpf"+szTag+" WHERE FWID " + grid.sqlSelected(true));
	return false;
}

function gridEdit(modeID)
{
	if(modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fday = list.tbl.getValue("Fday");
	m.Fchas = list.tbl.getValue("Fchas");
	m.Fsum = list.tbl.getValue("Fsum");
	m.Fshpz = String(list.tbl.getValue("Fshpz"));
	UpdateTable("^svpf"+szTag, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}


function startEdit_fshpz(oCtrl)
{
	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.setFshpz(Number(oCtrl.getValue()));
	dpShifPZ.linkCtrl(oCtrl);
}

function save_fshpz(oCtrl)
{
	if (!dpShifPZ.validCtrl())
		return false;
	return true;
}
include("sys/DpList.js")