include("Objects/DpGetDat.js");
include("servis/date.js");
include("prik/calculate/r_vsp_f.js");
include("Objects/DpXMLDomDocument.js");
include("sys/udfs.js");

var bdat;
var edat;
var podrValue = 0;
var tblTabel = null;
var sttTableName = "stt1";
var tblTableName = "tbl";
var arrResult = new Array();
var selectID = 0;
var szTag;
var leftkey = 0;
var rightkey = 0;
var tblNvk, sortMode;
var isSubtract = getPar("NVK_SUBTRACT");

function onLoad()
{
	sortMode = ReadParEx("TABEL_ORDER");
	if(allt(sortMode)=="")
		sortMode = "TABN";
	if(null != extPar
	&& null != extPar.bdat)
	{
		bdat = extPar.bdat;
	}
	else
	{
		gd = new DpGetDat("d");
		if(true == gd.escape)
			return false;
		
		bdat = gd.dat1;
	}
	
	bdat = new Date(bdat.getYear() + 1900, bdat.getMonth(), 1);
	edat = new Date(bdat.getYear() + 1900, bdat.getMonth() + 1, 1);
	edat.setDate(0);
	Caption("Список наявності табелів за " + StrDat(bdat, "MY") + "|Список наличия табелей за " + StrDat(bdat, "MY"));
	szTag = getDateTag(bdat);
	sttTableName += szTag;
	tblTableName += szTag;
	
	if(!IsTableEx("ZRP_MDB","ZRP_"+sttTableName)||!IsTableEx("ZRP_MDB","ZRP_"+tblTableName))
	{
		alert(ru("Табеля на данный месяц не существует!","Табеля на даний місяць не існує!"));
		return false;
	}
	var snap = getSnap("select fleftkey,frightkey from ^stru_org where fwid_par=0 or fwid_par is null")
	if(snap)
	{
		leftkey = snap[0];
		rightkey = snap[1];
	}
	else
	{
		alert(ru("Не найдено корневое подразделение!","Не знайдено корневий підрозділ"));
		return false;
	}
	
	//таблица неявок по которой будем динамически добавлять поля
	tblNvk = OpenTable("select * from ^cl_nvk where Fis_slct="+sqlTrue+" order by Fkod_nvk");
	var ret = fillGrid();
	//копируем все табеля в отдельную таблицу, чтобы потом коректно обрабатывать элементы дерева
	DropTable("all_tabels");
	ExecuteSQL("select * into all_tabels from tabel");
	if(false==fillPodr())
	{
		alert(ru("Ошибка формирования дерева подразделений!",
				"Помилка формування дерева підрозділів!"));
		return false;
	}
	
	if (ret == false)
	{
		var msg_ua = "Неможливо перезаписати таблицю табелів !!! \n Можливо вона відкрита на перегляд \n закрийте її, та повторіть розрахунок";
		var msg_ru = "Невозможно перезаписать таблицу табелей !!! \n Возможно она открыта на просмотр \n закройте её, и повторите расчет";
		alert( ru( msg_ru, msg_ua));
		return false;	
	}
	//проверяем есть ли в STT1 люди которые уже закрыты в ШР задним числом
	var t = OpenTable("select f.* from ^STT1"+szTag+" as s inner join ^full_pers as f on s.Fwid_wp=f.Fwid "
			+" where NOT (f.Fbdat<="+sqlTo(edat)+" AND f.Fedat>="+sqlTo(bdat)+")");
	if(t.rowCount>0)
	{
		if(confirm(ru("Найдены некоректные табеля. Необходимо выполнить переформирование табелей за "+format("Mmm yyyy\n",bdat).toLowerCase()+"Открыть список некоректных табелей?",
				"Знайдено некоректні табеля. Необхідно провести переформування табелів за "+format("Mmm yyyy\n",bdat).toLowerCase()+"Відкрити список некоректних табелів?")))
		{
			var par = new Object();
			par.cells = new Object();
			par.caption = UR("Некоректні табеля за |Некоректные табеля за ")+format("Mmm yyyy",bdat).toLowerCase();
		
			par.cells[1] = new Object();
			par.cells[1].name = "Fcodpers";
			par.cells[1].width = 3;
			par.cells[1].text = UR("Таб.№|Таб.№");
		
			par.cells[2] = new Object();
			par.cells[2].name = "Ftxtpers";
			par.cells[2].width = 15;
			par.cells[2].text = UR("ФИО|ПІБ");	
			
			par.cells[3] = new Object();
			par.cells[3].name = "Fbdat";
			par.cells[3].width = 8;
			par.cells[3].text = UR("Дата поч.|Дата нач.");
			
			par.cells[4] = new Object();
			par.cells[4].name = "Fedat";
			par.cells[4].width = 8;
			par.cells[4].text = UR("Дата закінч.|Дата окнч.");
			
			browse(t, par, SW_MODAL);
		}
	}
	t.close();
	
//	grTabel.setXMLDir(rootDirectory());
//	if(getPar("TABNORG"))
//		grTabel.setXMLFile("grTabelOrg.xml");
//	else
//		grTabel.setXMLFile("grTabel.xml");
		
	
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(rootDirectory()+(getPar("TABNORG")?"grTabelOrg.xml":"grTabel.xml"));
    var xmlGrid = xmlDom.getDocumentElement();
    //динамически добавляем в грид поля из справочника неявок по признаку "отображать в контролах"
    for(tblNvk.MoveFirst(); !tblNvk.IsEOF(); tblNvk.MoveNext())
    {
    	var fldTxt = allt(tblNvk.getValue("Fnams_nvk"))==""?tblNvk.getValue("Fnam_nvk"):tblNvk.getValue("Fnams_nvk");
		var xmlGrp = xmlGrid.createChild("group", null, {text:fldTxt});
		xmlGrp.createChild("field", null, {text:"Дні|Дни", width:"5", field:"Fday_nvk"+tblNvk.getValue("Fkod_nvk")});
		xmlGrp.createChild("field", null, {text:"Години|Часы", width:"5", field:"Fchasnvk"+tblNvk.getValue("Fkod_nvk")});
    }
	grTabel.parseXML(xmlGrid.xmlNode);
	
	
	grTabel.setTable(tblTabel);
	grTabel.build();
	this.grid_MenuInit = grid_MenuInit;
	this.grid_MenuHandler = grid_MenuHandler;
	grTabel.loadMenuHandler(this, "grid_MenuInit");	
	grTabel.selectMenuHandler(this, "grid_MenuHandler");
	
	this.onSelTreeItem = onSelTreeItem;
	tree.setTreeSelHandler(this, "onSelTreeItem");
	
	tree.setSelected(selectID);
	podr_valid();
	
	//setValid(PODR, podr_valid);
	include("sys/ListApi.js");
	initObjectMenu(grTabel);
}

function onSelTreeItem(sID)
{
	selectID = parseInt(sID);
	var treeItem = tree.getItem(sID);
	rightkey = leftkey = -1;
	if (treeItem != null)
	{
		leftkey = treeItem.getData("LEFTKEY");
		rightkey = treeItem.getData("RIGHTKEY");
	}
	trace(">>>> leftkey = " + leftkey + "    <<<<>>>> rightkey = " + rightkey);
	podr_valid();		
}

function onExit()
{
	if(null!=tblTabel)
		tblTabel.Close();
}

function podr_valid()
{
	/*if(PODR.getValue() != podrValue)
	{
		podrValue = PODR.getValue();
		fillGrid();
		grTabel.setTable(tblTabel);
		grTabel.refresh();
			
	}*/
	if(podrValue != 0)
		arrResult[podrValue] = grTabel.getSelectedIDs();
	
	if (selectID != podrValue)
	{
		podrValue = selectID;
		fillGrid();
		grTabel.setTable(tblTabel);
		grTabel.build();	
		if (arrResult[podrValue] != null && arrResult[podrValue].length != 0)
			grTabel.setSelectedIDs(arrResult[podrValue], podrValue);		
		grTabel.refresh();
	}
}

function fillPodr()
{
	var result = false;
	/*var strSQL = "SELECT o.fwid, o.ftxt FROM ^stru_org AS o"
				+ " WHERE o.fwid IN (SELECT DISTINCT d.fwid_org"
									+ " FROM ^work_pers AS w LEFT JOIN ^stru_dol AS d"
										+ " ON (w.FWID_DOL=d.FWID)"
									+ " WHERE (w.fbdat<=" + sqlTo(bdat) + " AND w.fedat>=" + sqlTo(edat) + ")"
										+ " OR (w.fbdat>=" + sqlTo(bdat) + " AND w.fbdat<=" + sqlTo(edat) + ")"
										+ " OR (w.fedat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + "))"
	*/
	
	
	DropTable("tabpodr");
	//создаем таблицу в которую запишем кол-во табелируемых сотрудников,
	//кол-во сущ-их (+), несущ-их (-) и табелей по умолчанию (*) по каждому подразделению
	ExecuteSQL("select Fwid, Fleftkey, Frightkey, Ftxt, "+Convert("0","INT")+" as Fplus, "
				+Convert("0","INT")+" as Fminus, "+Convert("0","INT")+" as Fdef, "+Convert("0","INT")+" as Ftab"
			+" into tabpodr from ^stru_org as so "
			+" where Fbdat<="+sqlTo(edat)+" and Fedat>="+sqlTo(bdat)
			+" order by Fleftkey");
	ExecuteSQL("update tabpodr set "
			+" Ftab=(select COUNT(distinct wp.Fwid_cl) from all_tabels as s "
				+" inner join ^work_pers as wp on wp.Fwid=s.Fwid "
				+" inner join ^stru_dol as sd on sd.Fwid=wp.Fwid_dol "
				+" inner join ^stru_org as so on so.Fwid=sd.Fwid_org "
				+" where so.Fleftkey between tabpodr.Fleftkey and tabpodr.Frightkey),"
			+" Fplus=(select COUNT(Fis_tabel) from all_tabels as s "
				+" inner join ^work_pers as wp on wp.Fwid=s.Fwid "
				+" inner join ^stru_dol as sd on sd.Fwid=wp.Fwid_dol "
				+" inner join ^stru_org as so on so.Fwid=sd.Fwid_org "
				+" where (so.Fleftkey between tabpodr.Fleftkey and tabpodr.Frightkey) "
					+" and s.Fis_tabel="+sqlTo("+")+"),"
			+" Fminus=(select COUNT(Fis_tabel) from all_tabels as s "
				+" inner join ^work_pers as wp on wp.Fwid=s.Fwid "
				+" inner join ^stru_dol as sd on sd.Fwid=wp.Fwid_dol "
				+" inner join ^stru_org as so on so.Fwid=sd.Fwid_org "
				+" where (so.Fleftkey between tabpodr.Fleftkey and tabpodr.Frightkey) "
					+" and s.Fis_tabel="+sqlTo("-")+"),"
			+" Fdef=(select COUNT(Fis_tabel) from all_tabels as s "
				+" inner join ^work_pers as wp on wp.Fwid=s.Fwid "
				+" inner join ^stru_dol as sd on sd.Fwid=wp.Fwid_dol "
				+" inner join ^stru_org as so on so.Fwid=sd.Fwid_org "
				+" where (so.Fleftkey between tabpodr.Fleftkey and tabpodr.Frightkey) "
					+" and s.Fis_tabel="+sqlTo("*")+")")
	
	var strSQL = "SELECT so.fwid,so.fwid_par,so.ftxts,so.fleftkey,so.frightkey,p.Ftab,p.Fplus,p.Fminus,p.Fdef "
					+ " from ^stru_org as so  inner join tabpodr as p on so.Fwid=p.Fwid "
					+ " where Fbdat<=" + sqlTo(edat) + " AND Fedat>=" + sqlTo(bdat)
					+ " order by Fleftkey";
	var tblPodr = OpenTable(strSQL);
	var parent;
	var nodeID;
	if(!tblPodr.isEmpty())
	{
		//PODR.clear();
		tree.removeAll();
		//tree.addItem("", "0", UR("Штат|Штат"));

		for(tblPodr.MoveFirst(); !tblPodr.isEOF(); tblPodr.MoveNext())
		{
			/*if (selectID == 0)
				selectID = String(tblPodr.getValue("fwid"));
			tree.addItem("", String(tblPodr.getValue("fwid")), tblPodr.getValue("ftxt"));
			*/
			//PODR.addItem(Number(tblPodr.getValue("fwid")), tblPodr.getValue("ftxt"));
			parent = String(tblPodr.getValue("fwid_par"));
			nodeID = String(tblPodr.getValue("fwid"));
			tree.expand(parent);
			txt = " ("+ru("сотр.:","співр.:")+tblPodr.getValue("ftab")+"; +"+tblPodr.getValue("fplus")+"; -"+tblPodr.getValue("fminus")+"; *"+tblPodr.getValue("fdef")+")";
			tree.addItem(parent, nodeID, (tblPodr.getValue("ftxts") != null ? tblPodr.getValue("ftxts")+txt : ""));
			var treeItem = tree.getItem(nodeID);
			//помечаем красным цветом подразделения, где есть несуществующие табели и синим те подразделения, где не было редактирований
			if(tblPodr.getValue("fminus")>0)
				tree.setItemColor(nodeID,255,0,0)
			else if(tblPodr.getValue("ftab")>0 && tblPodr.getValue("fplus")==0)
				tree.setItemColor(nodeID,0,200,255)

			treeItem.setData("LEFTKEY", tblPodr.getValue("fleftkey"));
			treeItem.setData("RIGHTKEY", tblPodr.getValue("frightkey"));
			if (parent == null || parent == 0)
			{
				leftkey = treeItem.getData("LEFTKEY");
				rightkey = treeItem.getData("RIGHTKEY");
			}
		}
		
		result = true;
	}
	tblPodr.Close();
	return result;
}

function fillGrid()
{
	requaryTable();
	var strOrder;
	switch(String(sortMode))
	{
		case "FIO":
			strOrder = "Ftxts, Fbdat, Fedat";
		break;
		case "VOPL":
			strOrder = "Fvopl, Fcod, Fbdat, Fedat";
		break;
		case "TABN":
		default:
			strOrder = "Fcod, Fbdat, Fedat";
		break;
	}
	tblTabel = OpenTable("s", "select * from TABEL order by "+strOrder);
}

function grid_MenuInit(toObject)
{
	loadObjectMenu(toObject);
	
	toObject.AddMenuItem("EDIT", "Редагувати|Редактировать");
	toObject.AddMenuItem("DEL", "Вилучити|Удалить");
	toObject.AddMenuItem("","");
	switch(String(sortMode))
	{
		case "FIO":
			toObject.AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
			toObject.AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
			toObject.AddMenuItem("SORTVOPL", "Сортувати по виду оплати|Сортировать по виду оплаты");
		break;
		case "VOPL":
			toObject.AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
			toObject.AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
			toObject.AddMenuItem("SORTVOPL", "Сортувати по виду оплати|Сортировать по виду оплаты",ICON_RADIO);
		break;
		case "TABN":
		default:
			toObject.AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
			toObject.AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
			toObject.AddMenuItem("SORTVOPL", "Сортувати по виду оплати|Сортировать по виду оплаты");
		break;
	}
	toObject.AddMenuItem("","");
	toObject.AddMenuItem("+++","Друк списку|Печать списка");
	toObject.AddMenuItem("FORMPRN","Друк списку по форме|Печать списка по форме");
	toObject.AddMenuItem("DEFPRN","Як на екрані|Как на экране");
	toObject.AddMenuItem("DEFPRNСOLS","Вибрати колонки для друку|Выбрать колонки для печати");
	toObject.AddMenuItem("---","");
	toObject.AddMenuItem("EXPORTCALC","Експорт в Calc|Экспорт в Calc");
	toObject.AddMenuItem("IMPORT_KOMM","Импорт командировок|Импорт командировок");
	//toObject.AddMenuItem("ADT", "Додати таб.N для небазов.мiсяця|Добавить таб.N для небазов.месяца");	
}

function grid_MenuHandler(ID, toObject)
{
	runObjectMenu(ID, toObject);
	
	switch(ID)
	{
		case "EDIT":
			var nRow = tblTabel.absolute;
			var par = new Object();
			par.tbl = toObject.getTable();
			par.bdat = bdat;
			par.escape = true;
			fis_tabel = par.tbl.getValue("Fis_tabel");
			fwid = par.tbl.getValue("Fwid");
			fbdat = par.tbl.getValue("Fbdat");
			showWindow("e_tabtime.xml", SW_MODAL, par);
			if(false == par.escape)
			{
				/*
				fillGrid();
				grTabel.setTable(tblTabel);
				tblTabel.requery();
				tblTabel.absolute = nRow;
				grTabel.build();
				*/
				refreshGrid(toObject);
				//дерево перестраиваем только если этот табель не редактировался ранее 
				if(fis_tabel!="+")
				{
					ExecuteSQL("update all_tabels set Fis_tabel="+sqlTo("+")+" where Fwid="+fwid+" and Fbdat="+fbdat);
					fillPodr();
					onSelTreeItem(selectID);
					tree.setSelected(selectID);
				}
			}
			break;
		case "EXPORTCALC":
			var oPar = new Object();
			oPar.grid = grTabel;
			showWindow("grid_to_scalc.xml",SW_MODAL,oPar);
			break;
		case "IMPORT_KOMM":
	    	include("importKomm.js");
			startImportXlsKommData2Tabel("IMPORT_KOMM", szTag);
			break;
		case "FORMPRN":
	    	include("objects\\DpTVars.js");
	  		var tv = new DpTVars("STT1");
	  		tv.setRTbl(toObject.getTable());
	  		
	     	var h = new Object();
	     	h.FDAT = bdat;
	     	tv.setHTbl(h);
	  		tv.print();
			break;
		case "DEFPRN":
			toObject.runDefaultPrint(FORM.getCaption());
			break;
		case "DEFPRNСOLS":
			var oPar = new Object();
			oPar.cols = grTabel.getColumnsArray();
			oPar.forPrint = true;
			showWindow("dpGridSort.xml",SW_MODAL,oPar);
	
			if (!oPar.escape)
			{
				toObject.runCustomDefaultPrintEx(FORM.getCaption(),oPar.ret.cols);
			}
			break;
		case "DEL":
			var strRu = "Внимание! Будут удалены табеля по отмеченным записям";
			var strUr = "Увага! Буде вилучено табелі по відміченим записам";
			if ('c'== msgBox("co", ru(strRu, strUr), ru("Удаление табелей", "Вилучення табелів")))
			{
				return;
			}
			if(!askPwd())
			{
				alert(ru("Неверный пароль", "Невірний пароль"));
				return;
			}
			var cDate = new Date(bdat);
			var sttTbl = "STT1"+month_txt(cDate);
			var tblTbl = "TBL"+month_txt(cDate);
			
			strWhere = String(grTabel.sqlSelected(true));
			//strWhere = strWhere.replace(/\FWID/gi, "FWID_WP");
			
			strSQL = "SELECT * FROM ^"+sttTbl+" WHERE FWID_WP "+strWhere
			var rsStt = OpenTable(strSQL);
			for (; !rsStt.IsEOF(); rsStt.MoveNext())
			{
				wid_wp = toScrObj(rsStt.getValue("FWID_WP"));
				strSQL = "DELETE FROM ^"+tblTbl+" WHERE FWID_WP = "+sqlTo(wid_wp)
				ExecuteSQL(strSQL);
				
				strSQL = "DELETE FROM ^"+sttTbl+" WHERE FWID_WP = "+sqlTo(wid_wp)
				ExecuteSQL(strSQL);
			}

			refreshGrid(toObject);
			break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTVOPL":
			if(ID.replace("SORT","")==ReadParEx("TABEL_ORDER"))
				return false;
			sortMode = ID.replace("SORT","");
			WriteParEx("TABEL_ORDER",sortMode);
			refreshGrid(toObject);
		break;
	}
	
	//if (ID=="ADT"){
	//	var par = new Object();
	//	par.rdate = getPar("GLOBDAT1");
	//    par.fwid_cl = 0;
	//    showWindow("i_allprk.xml", SW_MODAL, par);    
	//   if (!par.escape)
    //	{
	//		r_vsp_f(par.idat1,0,"HTML","TSTT1",0,par.fwid_cl)
    //	}
	//	return;    			
	//}
	
	return;
}

function requaryTable()
{
	if(null!=tblTabel)
	{
		tblTabel.Close();
		tblTabel = null;
	}
	
	var cldol = getPar("CODDOL");
	var ret = DropTable("TABEL");
	if (!ret) return false;
	
	var sFld = "";
	var sFrom = "";
	for(tblNvk.MoveFirst(); !tblNvk.IsEOF(); tblNvk.MoveNext())
    {
    	var nvk = tblNvk.getValue("Fkod_nvk");
    	sFld += ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb"+nvk+".fday_nvk") + " AS Fday_nvk"+nvk
				+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb"+nvk+".fchasnvk") + " AS Fchasnvk"+nvk;
		sFrom += " LEFT JOIN ^" + tblTableName + " AS tb"+nvk+" ON (w.fwid=tb"+nvk+".fwid_wp AND st.fbdat=tb"+nvk+".fbdat AND st.fedat=tb"+nvk+".fedat AND tb"+nvk+".fkod_nvk="+nvk+")";
    }
	var strSQL = "SELECT w.fwid, w.fid, w.Fwid_cl as Ftabn_id, w.Ftabnorg, cl_dol.ftxts as ftxt, org.ftxt as fpodr, rel.fcod as fcod, cl.ftxt as ftxts, w.fvopl, d.foklad, st.fis_tabel, st.fbdat, st.fedat"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_d", IIF("tb.fday_nvk IS NULL", "ti.fnorma_d", "tb.fday_nvk")) + " AS fnorma_d"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_ch", IIF("tb.fchasnvk IS NULL", "ti.fnorma_ch", "tb.fchasnvk")) + " AS fnorma_ch"
					//+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_d", "tb2.fday_nvk") + " AS fvsego_d"
					//+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_ch", "tb2.fchasnvk") + " AS fvsego_ch"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fvsego_d", "tb2.fday_nvk") + " AS fvsego_d"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fvsego_ch", "tb2.fchasnvk") + " AS fvsego_ch"
					+ sFld
					+(isSubtract ? ", ti.FCALNUM as FCALNUM" : "")
					/*+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb3.fday_nvk") + " AS FNOCH_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb3.fchasnvk") + " AS FNOCH_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb4.fday_nvk") + " AS FKLASS_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb4.fchasnvk") + " AS FKLASS_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb5.fday_nvk") + " AS FPRAZN_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb5.fchasnvk") + " AS FPRAZN_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb6.fday_nvk") + " AS FVRED_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb6.fchasnvk") + " AS FVRED_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb7.fday_nvk") + " AS FKOM_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb7.fchasnvk") + " AS FKOM_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb8.fday_nvk") + " AS FVECH_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb8.fchasnvk") + " AS FVECH_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb9.fday_nvk") + " AS FPROST_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb9.fchasnvk") + " AS FPROST_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb10.fday_nvk") + " AS FRAZ_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb10.fchasnvk") + " AS FRAZ_CH"*/
				+ " INTO TABEL FROM (((((((((^work_pers AS w INNER JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid)"
					+ " INNER JOIN ^cl AS cl ON w.fwid_cl=cl.fwid)"
					+ " INNER JOIN ^clrelclcl AS rel ON w.fwid_cl=rel.fwid_cl)"
					+ " INNER JOIN ^clrelclcl AS rel_dol ON d.fcod=rel_dol.fcod)"
					+ " INNER JOIN ^cl AS cl_dol ON cl_dol.fwid=rel_dol.fwid_cl)"
					+ " RIGHT JOIN ^" + sttTableName + " AS st ON w.fwid=st.fwid_wp)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb ON (w.fwid=tb.fwid_wp AND st.fbdat=tb.fbdat AND st.fedat=tb.fedat AND tb.fkod_nvk=1)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb2 ON (w.fwid=tb2.fwid_wp AND st.fbdat=tb2.fbdat AND st.fedat=tb2.fedat AND tb2.fkod_nvk=2)"
					+ sFrom + ")"
					/*+ " LEFT JOIN ^" + tblTableName + " AS tb3 ON (w.fwid=tb3.fwid_wp AND st.fbdat=tb3.fbdat AND st.fedat=tb3.fedat AND tb3.fkod_nvk=3)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb4 ON (w.fwid=tb4.fwid_wp AND st.fbdat=tb4.fbdat AND st.fedat=tb4.fedat AND tb4.fkod_nvk=4)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb5 ON (w.fwid=tb5.fwid_wp AND st.fbdat=tb5.fbdat AND st.fedat=tb5.fedat AND tb5.fkod_nvk=5)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb6 ON (w.fwid=tb6.fwid_wp AND st.fbdat=tb6.fbdat AND st.fedat=tb6.fedat AND tb6.fkod_nvk=6)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb7 ON (w.fwid=tb7.fwid_wp AND st.fbdat=tb7.fbdat AND st.fedat=tb7.fedat AND tb7.fkod_nvk=7)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb8 ON (w.fwid=tb8.fwid_wp AND st.fbdat=tb8.fbdat AND st.fedat=tb8.fedat AND tb8.fkod_nvk=8)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb9 ON (w.fwid=tb9.fwid_wp AND st.fbdat=tb9.fbdat AND st.fedat=tb9.fedat AND tb9.fkod_nvk=9)"					
					+ " LEFT JOIN ^" + tblTableName + " AS tb10 ON (w.fwid=tb10.fwid_wp AND st.fbdat=tb10.fbdat AND st.fedat=tb10.fedat AND tb10.fkod_nvk=10)"*/
					+ " LEFT JOIN ^tbl_ini AS ti ON w.fvopl=ti.fvopl)"
					+ " LEFT JOIN ^stru_org AS org ON d.fwid_org=org.fwid) "
				+ " WHERE w.fbdat<=" + sqlTo(edat) + " AND w.fedat>=" + sqlTo(bdat)
					+ " AND (d.fwid_org = " + sqlTo(podrValue)
						+ " OR (org.fleftkey BETWEEN " + sqlTo(leftkey)
							+ " AND " + sqlTo(rightkey) + ") AND org.fwid<>0 ) "					
					+ " AND rel_dol.fcl=" + sqlTo(cldol)
					+ " AND ti.fbdat=" + sqlTo(bdat);
				+ " GROUP BY w.fwid";
	
	
	ExecuteSQL(strSQL);
}

function refreshGrid(toObject)
{
	var gridID = toObject.getTable().getValue("FWID");
	
	requaryTable();
				
	var absolute = 1;
	if (tblTabel != null)
		absolute = tblTabel.getAbsolute();
	var strOrder;
	switch(String(sortMode))
	{
		case "FIO":
			strOrder = "Ftxts, Fbdat, Fedat";
		break;
		case "VOPL":
			strOrder = "Fvopl, Fcod, Fbdat, Fedat";
		break;
		case "TABN":
		default:
			strOrder = "Fcod, Fbdat, Fedat";
		break;
	}
	var sSQL = "select * from TABEL order by "+strOrder;
	if(tblTabel!=null)
		tblTabel.requery();
	else
		tblTabel = OpenTable(sSQL);  
	
	if (typeof gridID != "undefinad")	
	{
		if (!tblTabel.findByID(Number(gridID)))
		{
			if (absolute <= tblTabel.getRecordCount() + 1)
				tblTabel.setAbsolute(absolute);
		}		
	}
	else if (absolute <= tblTabel.getRecordCount() + 1)
	{
		tblTabel.setAbsolute(absolute);
	}		
	list.tbl = tblTabel;
	toObject.setTable(tblTabel);
	toObject.refresh();	
}

function onEscape()
{
	if(tblNvk)
		tblNvk.close();
}

include("sys/DpBaseDlg.js");