include("Objects/DpGrid.js");

function listLoad()
{
	with(this)
	{
		accDel = listDel;
	}
}

function listTitle()
{
	var title = UR("Архів операцій по таблиці|Архив операций по таблице");
	return title;
}

function listSrc()
{
	var sWhere = " "+sqlCmpTrue;
	if (!isEmpty(extPar))
	{
		if (!isEmpty(extPar.tName))
		{
			sWhere += " AND FTBL = "+sqlTo(String(extPar.tName).toUpperCase());
		}
		
		sWhere += " "+sqlw0And("FSYS = ", extPar.sSys);
		sWhere += " "+sqlw0And("FID_ROW = ", extPar.nID);
	}
	
	this.qrySet ("From", "^TBLARCHIVE"
				, "Where", sWhere	
				, "Order", "FMDATE DESC");	
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		with(page("Архів|Архив"))
		{
			cell("FTBL", "Таблиця|Таблица", 12);
			cell("FSYS", "Режим", 12);
			cell("FID_ROW", "ID", 12);
			cell("FMDATE", "Дата", 8);
			cell("=format(\"HH:MM:SS\",^FMDATE)", "Час|Время", 8);
			cell("FMACTION", "Д.", 5);
			cell("FMUSER", "Корист.|Польз.", 15);
			cell("FMHOST", "Комп.", 15);
		}
		build();
	}
}

function listMenuInit()
{
	if (this.dataSrc.getTable().IsRecord())
	{
		this.dataSrc.AddMenuItem("COMPARE","Порівняти|Сравнить");
	}
}

function listMenuRun(ID, toObject)
{
	switch(ID)
	{
		case "COMPARE":
			
			if (this.dataSrc.getSelectedCount() != 2)
			{
				alert(UR("Потрібно вибрати два записи|Необходимо выбрать две записи"));
				return;
			}
			
			var tmp = getTmpTableName("", true);
			var m = new Object();
			m.FFIELD = "TEXT";
			m.FVALUE1 = "TEXT";
			m.FVALUE2 = "TEXT";
			CreateTable(tmp, m);
			m = null;
			
			var selIDList = this.dataSrc.getSelectedIDs();
			
			var oXml1 = new DpXMLDOMDocument();
			oXml1.loadXML(String(getSnap("SELECT FDATA FROM ^TBLARCHIVE WHERE FWID = "+selIDList[0])[0]));
			var date1 = getSnap("SELECT FMDATE FROM ^TBLARCHIVE WHERE FWID = "+selIDList[0])[0];
			
			var oXml2 = new DpXMLDOMDocument();
			oXml2.loadXML(String(getSnap("SELECT FDATA FROM ^TBLARCHIVE WHERE FWID = "+selIDList[1])[0]));
			var date2 = getSnap("SELECT FMDATE FROM ^TBLARCHIVE WHERE FWID = "+selIDList[1])[0];
			
			var rows1 = oXml1.getDocumentElement().selectSingleNode("rows/row");
			if (!isEmpty(rows1) && rows1.hasChildNodes() == true)
			{
				var isDiff = false;
				var fields1 = rows1.getChildNodes();
				for (var i in fields1)
				{
					var field1 = fields1[i].getNodeName();
					var value1 = fields1[i].getText();
					
					var fields2 = oXml2.getDocumentElement().selectSingleNode("rows/row/"+field1);
					var value2 = fields2.getText();
					
					if (value1 != value2)
					{
						var m = new Object();
						m.FFIELD = field1;
						m.FVALUE1 = value1;
						m.FVALUE2 = value2;
						updateTable(tmp, m, true);
						
						isDiff = true;
					}
				}
				
				if (isDiff)
				{
					var title = UR("Різниця|Разница");
					include("Objects/DpZaval.js");
					var oZaval = new DpZaval(title);
					strSQL = " SELECT"
								+" *"
							+" FROM"
								+" "+tmp
					oZaval.setSQL(strSQL);
					oZaval.FieldEx("FFIELD", "Поле", 15);
					oZaval.FieldEx("FVALUE1", UR("Значення|Значение")+" "+format("dd.mm.yyyy HH.MM.SS", new Date(date1)), 30);
					oZaval.FieldEx("FVALUE2", UR("Значення|Значение")+" "+format("dd.mm.yyyy HH.MM.SS", new Date(date2)), 30);
					oZaval.open();
					oZaval = null;
				}
				else
				{
					var msg = UR("Різницю не знайдено.|Разница не найдена.");
					alert(msg);
				}
			}
			
			DropTable(tmp);
		break;
	}
}

function listDel()
{
	return false;
}

include("sys/DpList.js");
