include("objects\\DpPrintSelect.js");

var printSelect = null;

function Load()
{
	var sType = (extPar && extPar.sType?extPar.sType:"LIST");
	var sForm = (extPar && extPar.sForm?extPar.sForm:null);
	if (sForm == null)
	{
		alert("Недостаточно параметров");
		return false;
	}
	Caption(UR("Змінні форми друку|Переменные формы печати") + " " + sType + ":" + sForm);
	
	if (extPar && extPar.printSelect)
		printSelect = extPar.printSelect;
	else
		printSelect = new DpPrintSelect(sType,sForm);
	
	tblVAR.addColumn("var",UR("Змінна|Переменная"),150);
	tblVAR.addColumn("text",UR("Опис|Описание"),300);
	tblVAR.addColumn("expr",UR("Вираз|Выражение"),250);
	
	var mnuHandler = new Object();
	mnuHandler.mnuInit = tbl_mnuInit;
	mnuHandler.mnuRun = tbl_mnuRun;
	
	tblVAR.setMenuFillHandler(mnuHandler,"mnuInit");
	tblVAR.setMenuRunHandler(mnuHandler,"mnuRun");
	
	fillTbl();
}

function tbl_mnuInit(toObject)
{
	if(extPar.isZaval)
	{
		if(extPar.ret)
		{
			var id = tblVAR.getSelectedIDs()[0];
			extPar.ret.FVAR = tblVAR.getValue(id, "var");
			extPar.ret.FTXT = tblVAR.getValue(id, "text");
			extPar.ret.FEXPR = tblVAR.getValue(id, "expr");
		}
		extPar.escape = false;
		CloseWindow();
		return true;
	}
	
	toObject.AddMenuItem("ADD",UR("Додати змінну|Добавить переменную"),"ADD");
	var selIDs = tblVAR.getSelectedIDs();
	var bSys = String(selIDs[0]).lastIndexOf("#") < 0;
	if (selIDs.length > 0)
	{
		bSys && toObject.AddMenuItem("EDIT",UR("Редагувати змінну|Редактировать переменную"),"EDIT");
		toObject.AddMenuItem("COPY",UR("Копіювати змінну|Копировать переменную"),"COPY");
		bSys && toObject.AddMenuItem("DEL",UR("Видалити змінну|Удалить переменную"),"DEL");
	}
}

function tbl_mnuRun(sID)
{
	if (sID == "ADD")
	{
		var oPar = new Object();
		oPar.sMode = "ADD";
		oPar.printSelect = printSelect;
		showWindow("e_varfrm.xml",SW_MODAL,oPar);
		if (!oPar.escape)
		{
			tblVAR.removeAll();
			fillTbl();
			return;
		}
	}
	if (sID == "EDIT" || sID == "COPY")
	{
		var vName = tblVAR.getSelectedIDs();
		if (vName.length <= 0)
			return;
		vName = String(vName[0]);
		if (sID == "EDIT" && vName.lastIndexOf("#") >= 0)
			return;
		else
			vName = vName.substring(0,vName.lastIndexOf("#"));
	
		var oPar = new Object();
		oPar.sMode = sID;
		oPar.printSelect = printSelect;
		var vList = printSelect.getVarList();
		for (var nV = 0; nV < vList.length; nV ++)
		{
			trace(vList[nV].varName + "==" + vName);
			if (vList[nV].varName == vName)
			{
				oPar.varname = vName;
				oPar.vartext = vList[nV].text;
				oPar.varexpr = vList[nV].expr;
				break;
			}
		}
		showWindow("e_varfrm.xml",SW_MODAL,oPar);
		if (!oPar.escape)
		{
			tblVAR.removeAll();
			fillTbl();
			return;
		}
	}
	else if (sID == "DEL")
	{
		var sVarName = tblVAR.getSelectedIDs();
		if (sVarName.length <= 0)
			return;
		sVarName = String(sVarName[0]);
		printSelect.delUserVar(sVarName);
		tblVAR.removeAll();
		fillTbl();
		return;
	}
}

function fillTbl()
{
	var varList = printSelect.getVarList(true);
	for (var nV = 0; nV < varList.length; nV++)
	{
		var curVar = varList[nV];
		var varID = curVar.varName + (curVar.isSys?"#S":"");
		tblVAR.addItem(varID);
		tblVAR.setValue(varID,"var",curVar.varName);
		tblVAR.setValue(varID,"text",UR(curVar.text));
		tblVAR.setValue(varID,"expr",curVar.expr);
		if (curVar.isSys)
			tblVAR.colorItem(varID,249,254,214);
		else
			tblVAR.colorItem(varID,202,232,225);
	}
}
