﻿include("Objects\\DpGetDat.js");
include("Objects\\DpSc.js");

function listLoad()
{
	with(this)
	{
		title="Список початкових залишків|Список начальних остатков";
		printLabel="ost";
		xmlGridFile = "l_viewost.xml";
		subMenuInit=MenuInit;
		subMenuRun=MenuRun;
	}
}	

function listAsk()
{
	var oGD = new DpGetDat("dD");
	return oGD;
}	

function listSrc()	
{	
	var sWhere = "fdate" + " BETWEEN " + sqlTo(this.objAsk.dat1) + " AND " + sqlTo(this.objAsk.dat2);
	this.qrySet("From", "^schet_sl",
				"Where", sWhere,
				"Order", new Array("fsc ,fdate desc ,fsu ,fst ,fcl_cod1 ,fcl_cod2 ,fcl_cod3"),
				"Ptn", "schet_sl"
				);
	this.subTie("cl_valut", "x_cl_valut", "FKod", "Fval");
	this.clTie("org0", "="+ getPar("CODMYORG") +",FORG0", "clorg0");
}

function MenuInit()
{
	this.dataSrc.AddMenuItem("TOBS","Cформувати бухгалтерські довідки|Сформировать бухгалтерские справки");
	if(!this.tbl.IsEmpty())
		this.dataSrc.AddMenuItem("EDSLD", "Редактирование остатков");
}

function MenuRun(nID)
{
	if (nID == "TOBS")
	{
		
		var par = new Object();
		par.onlyDoc = "BS";
		par.doc = "BS";
		par.isZaval = true;
		par.escape = true;
		par.ret = new Object;
		par.ret.FNOP = 0;
		par.ret.FDOC = "BS";
		showWindow("l_cl_lnk.xml", SW_MODAL, par);
		if (par.escape)
			return;
			
		var fnop = par.ret.FNOP;
		
		var sqlStr = grid.sqlSelected();
		var resTblName = getUniqName();
		CreateTable(resTblName, "HBS", "*");
	
		var tbl = OpenTable("s", "SELECT * FROM ^SCHET_SL WHERE " + sqlStr);
		
		var dateBS = input("Введите дату, с которой будет созадн BS", "Запрос", tbl.getValue("fdate"))
		if (!dateBS)
			return;

		
		//var distTbl = OpenTable("s", resTblName);
		//var plschet = OpenTable("s", "CL_SCHET", "U0");
		var oSc = new DpSc();
		include ("doc/DpDoc.js");
		var param = new DpDoc("BS", fnop);
		var ClCod = Number(param.getPar("__nsan"));
		var count = Number(this.tbl.recordCount);
		var vid;
		var fcl = 0;
		
			
		WAIT(ru("Осталось ", "Залишилось ") + count + ru(" документов", " документів"));

		for (;!tbl.IsEOF(); tbl.MoveNext(), count--)
		{
			//if (Pump())
			//	break;
				
			if (count % 10 == 0)
				WAIT(ru("Осталось ", "Залишилось ") + count + ru(" документов", " документів"));
				
			var sSQL = "select fcl1 , fcl2, fcl3 from ^cl_schet where fschet = " 
				+ sqlTo(tbl.getValue("fsc"))
				+ " and fsubschet = " + sqlTo(tbl.getValue("fsu"))
				+ " and fstat = " + sqlTo(tbl.getValue("fst"))
			
			
			var oSnap = getSnap(sSQL);
			
			if (oSnap)
			{
				fcl = oSnap[0] == ClCod ? 1 : oSnap[1] == ClCod ? 2 : oSnap[2] == ClCod ? 3 : 0;
				if(ClCod==0)
					fcl = oSnap[0]!=0? 1 : oSnap[1]!=0? 2 : oSnap[2]!=0? 3 : 0;
			}
			/*
			if (plschet.Seek("=", this.tbl.getValue("fsc"), this.tbl.getValue("fsu"), this.tbl.getValue("fst")))
			{
				fcl = plschet("fcl1") == ClCod ? 1 : plschet("fcl2") == ClCod ? 2 : plschet("fcl3") == ClCod ? 3 : 0;
			}

			oSc.set(this.tbl.getValue("fsc"), this.tbl.getValue("fsu"), this.tbl.getValue("fst"), this.tbl.getValue("fcl_cod1"), this.tbl.getValue("fcl_cod2"), this.tbl.getValue("fcl_cod3"));

			vid = oSc.getVid();
*/			
			
			var m = new Object();
			m.FSC = Number(tbl.getValue("fsc"));
			m.FSU = Number(tbl.getValue("fsu"));
			m.FST = Number(tbl.getValue("fst"));
			m.FORG = (fcl == 0)? 0: Number(tbl.getValue("fcl_cod" + fcl));
			m.FDOC_DAT =dateBS;
			m.FSUM = (Number(tbl.getValue("fsumk")) - Number(tbl.getValue("fsumd"))) * (Number(tbl.getValue("fsumk")) - Number(tbl.getValue("fsumd")) >= 0 ? 1 : -1);
			m.FVAL = Number(tbl.getValue("fval"));
			m.FSUM1 = (Number(tbl.getValue("fsumkspr")) - Number(tbl.getValue("fsumdspr"))) * (Number(tbl.getValue("fsumkspr")) - Number(tbl.getValue("fsumdspr")) >= 0 ? 1 : -1);
			m.FVAL1 = tbl.getValue("fvalspr");
			m.FWID = GetUID();
			m.FCL1 = Number(tbl.getValue("fcl_cod1"));
			m.FCL2 = Number(tbl.getValue("fcl_cod2"));;
			m.FCL3 = Number(tbl.getValue("fcl_cod3"));;
			UpdateTable(resTblName, m, true);
		}	
	
		CLEARWAIT();
		ExecuteSQL("INSERT INTO ^HBS (FSC, FSU, FST, FCL1, FCL2, FCL3, FORG, FDOC_DAT, FVAL, FVAL1,FCL,FSUM1,FSUM, FWID, FDOC, FNOP) "
				+ " SELECT  a.FSC, a.FSU, a.FST, a.FCL1, a.FCL2, a.FCL3, a.FORG, a.FDOC_DAT, a.FVAL, a.FVAL1, " + sqlTo(ClCod) + " AS FCL,"
				+ " SUM(a.FSUM1) AS FSUM1, SUM(a.FSUM) AS FSUM, MAX(a.FWID) AS FWID, 'BS' AS FDOC, " + sqlTo(fnop) + " AS FNOP"
				+ " FROM " + resTblName + " a"
				+ " GROUP BY a.FSC, a.FSU, a.FST, a.FCL1, a.FCl2, a.FCl3, a.FORG, a.FDOC_DAT, a.FVAL, a.FVAL1");
	}
	else 
	if (nID == "EDSLD")
	{
		par = new Object;
		par.fsc = this.tbl.getValue("fsc");
		par.dat1 = this.tbl.getValue("fdate");
		par.fwid = this.tbl.getValue("fwid");
		showWindow("l_edsld.xml", SW_NOMODAL, par);
		this.tbl.Requery();
		this.tbl.FindFirst("FWID=" + sqlToFind(par.fwid));
		this.grid.RefreshGrid();
	}
	
}

function filterMode(nID)
{
	if (nID == "ADD" || nID == "EDIT" || nID == "COPY")
		return false;
	else
		return true;
}

include("sys\\DpList.js");