var isKompl = extPar.isKompl;
var tblSrcName = "^VN_PEREM";
var m_Inv_num;

function listLoad()
{
	with(this)
	{
		title="Список внутрішніх переміщень"+(isKompl?" комплекту":"")+" ОЗ|Список внутренних перемещений"+(isKompl?" комплекта":"")+" ОС";
		editTask = "e_svpri.xml";
		xmlGridFile = "l_vnpri.xml";
	}
}

function listSrc()
{
	if(extPar.Inv_num==null)
		m_Inv_num=0;
	else
		m_Inv_num=extPar.Inv_num;
	if(isKompl)
	{
		if(tblSrcName == "TMP_VN_PEREM_SRC")
			this.qrySet	("From", tblSrcName,"Where","Fkompl="+m_Inv_num,"Order","Finv_num,Fbdat,Fedat");
		else
			this.qrySet	("Fields", "vn.*,s1.Fkompl", 
					"From", "^VN_PEREM as vn inner join ^OS1 as s1 on vn.Finv_num=s1.Finv_num",
					"Where","s1.Fkompl="+m_Inv_num,
					"Order","vn.Finv_num, vn.Fbdat, vn.Fedat",
					"Alias","vn");
	}
	else
	{
		this.qrySet	(	"From", "^VN_PEREM",
						"Where","Finv_num = "+m_Inv_num,
						"Order","Finv_num, Fbdat");	
	}			
}

function listMenuInit()
{  
	if(isKompl)
	{
		with(this.dataSrc)
	    {
			if(tblSrcName != "TMP_VN_PEREM_SRC")
				AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты");
			else
				AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты",ICON_RADIO);
			if(tblSrcName == "TMP_VN_PEREM_SRC")
				AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты");
			else
				AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты",ICON_RADIO);
			this.dataSrc.AddMenuItem("","");
	    }
	}
}

function listMenuRun(ID)
{	
	switch(ID)
   	{     
		case "MIN_KMPL":
			DropTable("TMP_VN_PEREM_SRC");
			ExecuteSQL("select MIN(vn.Fwid) as Fwid,s1.Fkompl as Finv_num,s1.Fkompl,MIN(vn.Fbdat) as Fbdat,MIN(vn.Fedat) as Fedat,MIN(vn.Fpodr) as Fpodr,MIN(vn.Fpodro) as Fpodro,"
						+"MIN(vn.Ftabn) as Ftabn,MIN(vn.Fsc) as Fsc,MIN(vn.Fsu) as Fsu,MIN(vn.Fst) as Fst,"
						+"MIN(vn.Fcl_cod1) as Fcl_cod1,MIN(vn.Fcl_cod2) as Fcl_cod2,MIN(vn.Fcl_cod3) as Fcl_cod3"
					+" into TMP_VN_PEREM_SRC"
					+" from ^vn_perem as vn inner join ^os1 as s1 on vn.Finv_num=s1.Finv_num "
					+" where s1.Fkompl="+m_Inv_num+" group by s1.Fkompl,vn.Fbdat");
			tblSrcName = "TMP_VN_PEREM_SRC";
			grid.DeletePages();
			list.init();
		break;
		case "MAX_KMPL":
			tblSrcName = "^VN_PEREM";
			grid.DeletePages();
			list.init();
		break;
	}
}

function filterMode(mode)
{
	if(tblSrcName == "TMP_VN_PEREM_SRC" && (mode == "ADD" || mode == "COPY" || mode == "DEL"|| mode == "EDIT"))
	{
		WAIT(ru("Для выполнения каких-либо действий над записями перейдите к развернутому виду.",
				"Для виконання яких-небудь дій над записами перейдіть до розгорнутого вигляду."));
		return false;
	}
	return true;	
}
include("sys\\DpList.js")