include("Objects\\DpGetDat.js");
include("doc\\DpDocPtn.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\DpSql.js");
include("sub\\mtr.js");
include("GetParam.js");
include("objects\\DpExtentionBuilder.js");

var label = "zrp_bonus";
var tblOut;

function listLoad()
{
	with( list )
	{
        title = "Kол-во работников и сумму ЗП сгруппированную по подразделению";
		printLabel = "zrp_bonus_calc2";
	}
}

function listSrc()
{
    with (list)
    {
        title = "Kол-во работников и сумму ЗП сгруппированную по подразделению"+
		         StrDat(extPar.dat1, "DMY")+"-"+StrDat(extPar.dat2, "DMY");

   	}

	oYear = String((new Date(extPar.dat1)).getFullYear());
	oMonth = String((new Date(extPar.dat1)).getMonth() + 1);

	if (oMonth<10)
		tblOut = "BONUS" + oYear+"0"+oMonth;
	else
		tblOut = "BONUS" + oYear+oMonth;
		
	if (!IsTableEx("zrp_mdb", "ZRP_"+tblOut))
		return;
	
	var tmpTbl = getTmpTableName();
	ExecuteSQL("SELECT FPODRTXT, sum((Fchas2 * FSUM_OKLAD) / Fchas + FSUM_VACATION + FSUM_SAIL + (FSUM_SAIL+FSUM_PREMIYA)*FPLAN_PROC/100 + FSUM_BONUS + FSUM_PREMIYA - FSUM_PREMIYA2 - FSUM_PREMIYA3 - FSUM_PREMIYA4) as FSUM, count(*) as FKOL"
		+ " INTO " + tmpTbl 
		+ " FROM ^" + tblOut
			+ " WHERE FCHAS <> 0"
				+ " AND ((Fchas2 * FSUM_OKLAD) / Fchas + FSUM_VACATION + FSUM_SAIL + (FSUM_SAIL+FSUM_PREMIYA)*FPLAN_PROC/100 + FSUM_BONUS + FSUM_PREMIYA - FSUM_PREMIYA2 - FSUM_PREMIYA3 - FSUM_PREMIYA4) <> 0"
			+ " GROUP BY FPODRTXT"); 
   	with( list )
	{
		qrySet( "From", "^" + tmpTbl, "Order","FPODRTXT" )
	}
}

function listGrid()
{	
	var gr = new DpGrid("NOCREATE");
	
   	with(gr.page())
   	{
		FieldEx("FPODRTXT", "Подр", 10);
		FieldEx("FSUM", "Сумма", 10, "!zn", DP_FORMAT_SUM);
		FieldEx("FKOL", "Кол-во", 10, "!zn", DP_FORMAT_KOL);
	}
	gr.build();
}
include("sys\\DpList.js");