include("objects\\DpDefVed.js");
include("doc/DpDoc.js");
include("sys\\DpList.js");

var DefVed = new DpDefVed();

function listLoad()
{
	if(confirm(ru("Изменить срок службы для ОС?","Змінити терміни служби для ОЗ?")))
	{
		ModernOS("^OS1");
		ModernOS("^OS4");
		ModernOS("^OS7");
		ModernOS("^OS0B");
		
		alert(ru("Модификация сроков службы для ОС закончена!","Модифікація термінів служби для ОЗ закінчена!"));
	}
}

function ModernOS(UOS_Table)
{
	var mes1,mes2;
	if(UOS_Table=="^OS0B")
	{ 
		ExecuteSQL("update ^OS0B SET "
				+"FCOD_RATE=(select a.FCODSROK from ^OS1 a where a.FINV_NUM=^OS0B.FINV_NUM), "
				+"FSROKADD=(select a.FSROK from ^OS1 a where a.FINV_NUM=^OS0B.FINV_NUM)")
	}
	else
	{
		var OSx=OpenTable("s",UOS_Table);
		var oDoc=new DpDoc("O"+UOS_Table.charAt(UOS_Table.length-1),0)
		if(!OSx.isEmpty())
		{
			for(OSx.MoveFirst();!OSx.IsEOF();OSx.MoveNext())
			{
				var nID = OSx.getValue("Fwid");
				oDoc.clear();
				oDoc.loadByID(nID);
				oDoc.setVar("HSROC",getSS(oDoc.getVar("HVIDOS"))*12);
				oDoc.setVar("HCODSROK",getSS(oDoc.getVar("HVIDOS")));
				oDoc.save();
			}
		}
		OSx.close();
	}
}

//Возвр. 3-ю анал. затр. счета произв. ОС
// - смотрим на nVidos
function getSS(nVidos)
{
	var nSS=0;
	//будівлі
	if(nVidos>0 && nVidos<=199999)//240101
		nSS = 40;
	//транспорт легковий
	else if(nVidos>=210100 && nVidos<210200)
		nSS = 6;
	//транспорт вантажний
	else if((nVidos>=210200 && nVidos<=210203) || (nVidos>=210301 && nVidos<=210310))
		nSS = 10;
	//спеціалізований транспорт
	else if(nVidos==210300)
		nSS = 10;
	//транспорт (автобуси)
	else if(nVidos>=210400 && nVidos<210500)
		nSS = 10;
	//корпуси і причепи автомобільні
	else if(nVidos>=210500 && nVidos<211000)
		nSS =  10;
	//мото-вело
	else if(nVidos>=211001 && nVidos<211100)
		nSS =  6;
	//електротягачі, електронавантажувачі
	else if(nVidos>=211100 && nVidos<220000)
		nSS =  10;
	//інші транспортні засоби
	else if(nVidos==299999)
		nSS =  10;
	//меблі
	else if((nVidos>=220100 && nVidos<220200) || (nVidos==220208))
		nSS =  6;
	//офісна техніка, обчисл., копіювальна, друкувальна
	else if((nVidos>=220200 && nVidos<230000) || (nVidos>=240100 && nVidos<250000))
		nSS =  3;
	//машини та обладнання
	else if((nVidos>=310000 && nVidos<340000) || (nVidos==499999))
		nSS =  12;
	//інструменти, прилади, інвентар
	else if((nVidos>=230100 && nVidos<240000) || (nVidos==399999))
		nSS =  4;
	//інші ОС (необоротні мат.активи)
	else nSS =  3;
	return nSS;
}