
function Load()
{
	Caption(UR("Облік ТМЦ|Учет ТМЦ"));
	
	FORM.setImage(rootDirectoryEx() +"/icons/mtr.gif");
	
	fillSysCombo(SYSCOMBO);
	setValid(SYSCOMBO, selSysCombo);
	
	loadDocsPanel();	
	loadCalcPanel();
	loadVibPanel();
	loadClPanel();	
	
	var ctrl = PANELBAR.getCtrl();
	ctrl.setWeights([100,50,50,50])
}

function loadDocsPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Первинні документи|Первичные документы"));
		
	panel.addItem("PN", UR("Прибуткування ТМЦ (PN)|Приходование ТМЦ (PN)"), true);	
	panel.addItem("NK", UR("Вид. накладна (NK)|Расх. накладная (NK)"), true);	
	panel.addItem("SF", UR("Рахунок-фактура (SF)|Счет-фактура (SF)"), true);
	panel.addItem("PM", UR("Внутрішнє переміщення (PM)|Внутреннее перемещение (PM)"), true);
	panel.addItem("SM", UR("Передача за відп.цінами (SM)|Передача ТМЦ по отп.ценам (SM)"), true);
	panel.addItem("PZ", UR("Списання ТМЦ (PZ)|Списание ТМЦ (PZ)"), true);
	panel.addItem("VR", UR("Повернення реалізованих ТМЦ (VR)|Возврат реализованных ТМЦ (VR)"), true);
	panel.addItem("VP", UR("Повернення постачальникові (VP)|Возврат поставщику (VP)"), true);
		
	panel.addItem("NN", UR("Податкові накладні отримані (NN)|Налоговые накладные полученные (NN)"), true);	
	panel.addItem("DOCS", UR("Інші документи|Другие документы"), true);
	
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
	
}

function loadCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Вихiднi документи|Выходные документы"));
		
	panel.addItem("KART", 	  UR("Картка складського облiку|Карточка складского учета"), true);	
	panel.addItem("OBSLDVED", UR("Обiгово-сальдова вiдомiсть|Оборотно-сальдовая ведомость"), true);	
	panel.addItem("VDOST", 	  UR("Вiдомiсть залишкiв|Ведомость остатков"), true);	
		
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
}

function loadVibPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Відбори|Выборки"));
		
	panel.addItem("VBRS", ru("Выборка по отпуску","Вибірка по відпуску"), true);	
	panel.addItem("VBPM", ru("Выборка по перемещению","Вибірка по переміщенню"), true);	
	panel.addItem("VBPR", ru("Выборка по приходу","Вибірка по приходу"), true);
	panel.addItem("VBRS2", ru("Выборка по списанию","Вибірка по списанню"), true);
		
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
}


function loadClPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Довідники|Справочники"));
		
	panel.addItem("CL",	 UR("Контрагенти|Контрагенты"), true);
	panel.addItem("NMK", UR("Номенклатура|Номенклатура"), true);	
	panel.addItem("PODR", UR("Підрозділи|Подразделения"), true);
	panel.addItem("MOL", UR("МВО|МОЛ"), true);
		
	this.selHandler = selHandler;
	panel.setSelectHandler(this, "selHandler");
}

function selHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "PN":
		case "NK":
		case "SF":
		case "NN":
		case "SM":
		case "PM":
		case "VR":
		case "VP":
		case "PZ":
		case "DOCS":
			var oPar = new Object();		
			oPar.ret = new Object();
			oPar.isZaval = true;			
			if(sID!="DOCS")
			{
				oPar.onlyDoc = sID;
				oPar.simple = true;
			}
			oPar.ret.fdoc = sID;
			oPar.ret.fnop = 0;			
			oPar.title = UR("Виберіть папку|Выберите папку");
			showWindow("l_cl_lnk.xml", SW_MODAL, oPar);		
			if (oPar.escape)
				return false;				
			par.nop = oPar.ret.fnop;
			par.doc = oPar.ret.fdoc;
			sDlg = "l_docekz.xml";
			break;
		
		case "CL":
			par.Fcl = getPar("CODPLAT");
			par.Fvid = 2;
			sDlg = "l_cl.xml";
			break;
		case "PODR":
			par.Fcl = getPar("CODPODR", "MTR");
			par.Fvid = 1;
			sDlg = "l_cl.xml";
			break;
		case "MOL":
			par.Fcl = getPar("CODMOL", "MTR");
			par.Fvid = 1;
			sDlg = "l_cl.xml";
			break;	
		
		case "NMK":
			sDlg = "l_clnmktree.xml";
			break;
			
		case "KART":
			sDlg = "r_ksu.js";
			break;
			
		case "OBSLDVED":
			sDlg = "r_obr.js";
			break;		
				
		case "VDOST":
			sDlg = "r_vdost.js";
			break;	
		case "VBPR":
			sDlg = "r_vbpr.js";
			break;
		case "VBRS":
		case "VBRS2":
			WriteParameter("FDOC",(sID == "VBRS"?"NK":"PZ"),"r_vbrs")
			sDlg = "r_vbrs.js";
			break;
		case "VBPM":
			sDlg = "r_vbpm.js";
			break;
				
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}

include("sys/DpBaseDlg.js");