function createObtmTables(bdat, fwidPodr)
{
	DropTable("obtm_c", false);
	DropTable("obtm_r", false);
	DropTable("obtm_s", false);
	var tabName = "obtm" + 	(bdat.getYear() + 1900) + (((bdat.getMonth()+1)<10)?"0":"") + (bdat.getMonth()+1);
		
	bdat.setDate(1);
	var edat = new Date(bdat.getYear()+1900, bdat.getMonth()+1, 1);
	edat.setDate(0);
	
	ExecuteSQL("CREATE TABLE " + tblName + "_c "
			+ " ( FCOLID " + SqlType("INT") 
			+ ", FDAY "+ SqlType("TEXT", 254) + ")" )	

	strSQL = "INSERT INTO " + tblName + "_c (FCOLID, FDAY) " 
			+ "SELECT " + Convert("a.fday", "INT") 
			+ " , " + Convert("a.fday", "STR")
			+ " FROM ^" + tabName + " AS a"
			+ " WHERE a.fday<32 GROUP BY a.fday";
	
	/*
	strSQL = "SELECT " + Convert("a.fday", "INT") + " AS fcolid"
			+ ", " + Convert("a.fday", "STR") + " AS fday "
			+ " INTO " + tblName + "_c " +
					"FROM ^" + tabName + " AS a"
			+ " WHERE a.fday<32 GROUP BY a.fday";
	*/	
	ExecuteSQL(strSQL);
	for(var i=0; i < captionCol.length; i++)
	{
		strSQL = "INSERT INTO " + tblName + "_c(fcolid, fday) VALUES("+sqlTo(i+33)+", "+sqlTo(captionCol[i])+")";	
		ExecuteSQL(strSQL);
	}
	
	strSQL = "SELECT "
			+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + Convert("a.fday", "STR") + " AS fcolid, " + Convert("b.ftxt", "INT") + " AS fvalue"
		+ " INTO " + tblName + "_s FROM ^" + tabName + " AS a LEFT JOIN ^time AS b ON a.fvalue = b.fwid"
		+ " WHERE a.FDAY<>32"
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"");
	ExecuteSQL(strSQL);
	
	if (SUBD == ORACLE || SUBD == DERBY)
	{
		ExecuteSQL("DROP INDEX RowCol", false);
	}
	
	ExecuteSQL("CREATE INDEX RowCol ON " + tblName + "_s (frowid, fcolid)");
	//Вставка количества дней
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
				+ ", " + sqlTo("45") + " AS fcolid, " + sqlTo(edat.getDate()) + " AS fvalue"
			+ " FROM ^" + tabName + " AS a"
			+ " WHERE " + SqlCmpTrue
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"");
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);

	//Вставка количества выходных и праздничных
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + sqlTo("44") + " AS fcolid, Count(a.FTYPE) AS fvalue"
			+ " FROM ^"+tabName+" AS a"
			+ " WHERE a.FTYPE="+sqlTrue
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);

	//Вставка количества отработаных дней по плану
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + sqlTo("34") + " AS fcolid, (" + sqlTo(edat.getDate()) + " - COUNT(a.FTYPE)) AS fvalue"
			+ " FROM ^" + tabName + " AS a"
			+ " WHERE a.FTYPE=" + sqlTrue
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);

	//Вставка фактически отработанных дней
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + sqlTo("33") + " AS fcolid, COUNT(a.FTABN_ID) AS fvalue"
			+ " FROM ^" + tabName + " AS a LEFT JOIN ^time AS b ON a.fvalue = b.fwid"
			+ " WHERE b.fvalue<>0 AND a.fday<32"
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);

	//Вставка отработанных часов
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + sqlTo("46") + " AS fcolid, SUM(b.fvalue) AS fvalue"
			+ " FROM ^" + tabName + " AS a LEFT JOIN ^time AS b ON a.fvalue = b.fwid"
			+ " WHERE b.fvalue<>0 AND a.fday<32"
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);
	//Вставка количества отработанных часов по плану
	strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
			+ ", " + sqlTo("47") + " AS fcolid, SUM(b.fvalue) AS fvalue"
			+ " FROM ^" + tabName + " AS a LEFT JOIN ^time AS b ON a.fdefvalue = b.fwid"
			+ " WHERE b.fvalue<>0"
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
	ExecuteSQL(strSQL);

	//Вставка информационных полей
	for(var i=2; i<captionCol.length-3; i++)
	{
		strSQL = "INSERT INTO " + tblName + "_s (frowid, fcolid, fvalue)"
			+ " SELECT "
				+ SqlConCat(Convert("a.fwid_dol","STR"), sqlTo("@"), Convert("a.FTABN_ID", "STR")) + " AS frowid"
				+ ", " + Convert(i+33, "STR") + " AS fcolid, COUNT(a.FTABN_ID) AS fvalue"
				+ " FROM ^" + tabName + " AS a LEFT JOIN ^time AS b ON a.fvalue = b.fwid"
				+ " WHERE b.FTXT="+sqlTo(captionCol[i])
			+ ((null!=fwidPodr)?(" AND a.fwid_dol IN"
						+ " (SELECT fwid FROM leo_cdr.cdr_stru_dol WHERE fwid_org=" + fwidPodr + ")")
						:"")
			+ " GROUP BY a.fwid_dol, a.FTABN_ID";
		ExecuteSQL(strSQL);
	}
	
	strSQL = "SELECT "
		+ SqlConCat(
			Convert("o.fwid_dol","STR"), 
			sqlTo("@"), 
			Convert("o.FTABN_ID", "STR")
		) 
		+ " AS frowid, relh.fcod, cl.ftxt, clh.ftxts"
		+ " INTO " + tblName + "_r"
		+ " FROM (((((^" + tabName + " AS o"
			+ " INNER JOIN ^stru_dol AS d ON o.fwid_dol=d.fwid)"
			+ " INNER JOIN ^clrelclcl AS rel ON d.fcod=rel.fcod and rel.fcl = " + getPar("CODDOL") + ")"
			+ " INNER JOIN ^cl AS cl ON cl.fwid=rel.FWID_CL)"
			+ " INNER JOIN ^cl AS clh ON clh.fwid=o.FTABN_ID)"
			+ " INNER JOIN ^clrelclcl AS relh ON clh.fwid=relh.FWID_CL)"
		+ " WHERE rel.fcl=" + getPar("CODDOL")
			+ ((null!=fwidPodr)?(" AND d.fwid_org=" + sqlTo(fwidPodr)):"")
		+ " GROUP BY " +
				"o.fwid_dol" +
				", " +
				"o.FTABN_ID , relh.fcod, cl.ftxt, clh.ftxts",
		+ " ORDER BY clh.ftxts, relh.fcod";
	
	ExecuteSQL(strSQL);

	return true;
}