include ("Objects//DpCOMObject.js")
// SK 020913
// Есть формы, кот. не могут быть решены чисто заполнением ячеек Excel'а
// поэтому для них предусмотрено програмное завершение

var szStop	= "*****";
//Установим максимальное кол-во строк на одном листе
var nMaxRowPerPage = 65000;

function Office_printExcel()
{
	this.printRows	= Office_printRows;
	this.makeCross	= Office_makeCross;
	var exl	= new DpCOMObject("Excel.Application");
	if(!exl)
	{
		alert("Ошибка при создании Excel-сервера.");
		return;
	}
	
	var	bPreview	= getPar("PrtPreview");
	exl.visible	= true;
	exl.DisplayAlerts = false;
	delete exl.Cells;
	exl.Cells = new Function("row, col", "return this.get('Cells',row, col);")
	
	var doc		= exl.Workbooks.Open(this.file),
		csOut	= doc.ActiveSheet.Cells,
		iX	= csOut.Cells.Count,
		iY	= csOut.Rows.Count,
		maDst	= null,
		rTbl	= this.vars.getRTbl(),
		iDstY	= 1;
	var bmrk	= null;
	if(rTbl && rTbl.isRecord())
	{
		bmrk	= rTbl.bookmark;
		rTbl.moveFirst();
	}

	if(this.beginPrint)
		this.beginPrint(doc, this.vars);
	
	//сразу делаем расчет числа строк для прогресса
	for(var i=1; i<iY; i++)
	{
		maDst	= csOut.Range("A"+i);
		//trace(i + "\n" + maDst.value + "\n" + szStop + "\n" + (maDst.value==szStop));
		if(maDst.value==szStop)
		{
			iY	= i;
			break;
		}
	}
	var nUsedRows	= iY;

//	setProgressRange(0, iY);
	setProgressRange(0, rTbl ? rTbl.recordCount : 0);
	//откатим назад - пусть все работает как было
	iY	= csOut.Rows.Count;
	var sVal		= "";
	for(var i=1; i<iY; i++, iDstY++)
	{
		for(var j	= 0; j<iX; j++)
		{
			var t = new Date().getTime();
			maDst	= exl.Cells(iDstY, j+1);
			trace(i + " GET CELS - " + (new Date().getTime() - t));
			//trace(String(maDst.value));
			
			var t = new Date().getTime();
			if((1==i || 0==j) && maDst.value==szStop)
			{
				if(i==1)
				{
					maDst.value	= "";
					iX	= j;
				}
				else
				{
					doc.ActiveSheet.Cells.Rows.getItem(iDstY).ClearContents();
					iY	= i;
				}
				
				break;
			}
			trace(i + " CHECK CELS - " + (new Date().getTime() - t));
			
			var t = new Date().getTime();
			/*
			if(maDst.__jCOMObj.get("MergeCells",null) != null)
				j	+= maDst.Cells.Count-1;
				*/ 
			trace(i + " merge - " + (new Date().getTime() - t));
			
			if(typeof(maDst.value)=="string")
			{
				sVal	= ""+maDst.value;
				if(sVal.length>1 && sVal.charAt(0)=='*')
				{	
					if (sVal.substr(1, 6) == "CROSSH")
					{
						iX += this.makeCross(exl, rTbl, maDst);
					}
					else if (sVal.substr(1, 1) == "+")
					{
						csOut.Rows.getItem(iDstY).Delete();

						var nRecords = rTbl ? rTbl.recordCount : 0;
							
						var alias = "";
						if( sVal.length > 2)
						{
							if ("MOVE" == sVal.substr(2))
							{
								--nRecords;
								rTbl.MoveNext();
							}
							else
							{
								alias = sVal.substr(2);
							}
						}
						
						iDstY = this.printRows(exl, csOut, (alias == "" ? rTbl : this.vars.getRTbl(alias)), iX, iDstY, nUsedRows, this.FormID);
						j	= iX;// чтобы выйти
					}
					else
					{
						sVal	=
							this.setField(sVal.substr(1));
						maDst.value	= sVal;
					}
				}
			}
		}
	}
	setProgressPos(0);
	//после ***** можно оставить набор управляющих ячеек
	maDst	= exl.Range(getCellName(0)+(iDstY));
	var	bEdit	= false;
	if(maDst.value=="EDIT DOCUMENT")
	{
		//удалить эту строку
		doc.ActiveSheet.Cells.Rows.getItem(iDstY).ClearContents();
		bEdit	= true;
	}
	CLEARWAIT();
	if(this.endPrint)
		this.endPrint(doc, this.vars);
		
	exl.Sheets.getItem(1).Select;
	
	CustomizeForm(exl, csOut, this.FormID, rTbl);

	if(rTbl && bmrk)
		rTbl.bookmark	= bmrk;
	doc.saved	= true;
	if(bPreview)
	{
		exl.visible	= true;
		if(!bEdit)
			doc.printPreview();
	
	}
	else
		doc.printOut();
	
	exl.DisplayAlerts = true;

	if(!bEdit)
		//если вошли в редактирование, то пусть Excel остается
		exl.quit();
	else
		exl.Range("A1").Select();
	exl.release();	
	exl	= "";
}


var alph= new String("ABCDEFGHIJKLMNOPQRSTUVWXYZ");

function getCellName(iNum)
{
	var szRet= "";
	var iMod	= 0;
	while(iNum>25)
	{
		iMode = iNum%26;
		szRet = alph.charAt(iMode)+szRet;
		iNum	= Math.floor(iNum/26)-1;
	}
	
	szRet = alph.charAt(iNum)+szRet;
	return szRet;
}

function getCellNum(name)
{
	if (isEmpty(name))
	{
		var allNum = -1;
		return;
	}
	var allNum = 0;
	for (var i=0; i<name.length; i++)
	{
		var ch = name[i];
		var num = (name.length > 1 && i == 0 ? (alph.indexOf(ch)+1)*26 : alph.indexOf(ch))
		allNum += num;
	}
	return allNum;
}

//печатаем зону строк
//возвращаем номер строки, с которого нужно
//продолжать печатать
//строка nRow содержала *+, перед вызовом этой функции мы строку удалим
//	oCells	- кол-я ячеек
//	rTbl	- таблица со строками, по которой будем печатать
//	nCols	- число столбцов в печатаемой области
//	nRow	- номер строки с которой начинается все
//	nUsedRows	- сколько всего значимых строк
function Office_printRows(oExcel, oCells, rTbl, nCols, inRow, nUsedRows, sForm)
{
	WAITTIMER("Идет печать...");
	var nRow = inRow;
	var iAmountRowsWithCondition = 0;
	var iAmountRowsWithOutCondition = 0;
	var oCellsInRowWC = new Array();
	var oCellsInRowWOC = new Array();
	//Определение кол-ва строк с условиями и без них.
	//Кеширование этих строк.
	for(var n = 0; oCells.Range("A"+(nRow+n)).value != "*-"; n++)
	{
		var oCellValue;
		var oRow	= new Array();
		
		for(var nRCell=1; nRCell < nCols; nRCell++)
		{
			oCellValue	= "" + oCells(nRow+n, nRCell).value;
			if(typeof(oCells(nRow+n, nRCell).value) != "undefined")
			{
				if((oCellValue.length > 1) && (oCellValue.charAt(0) == '*'))
					oRow[nRCell]	= oCellValue.substr(1);
				else
					oRow[nRCell]	= oCellValue.substr(0, oCellValue.length);
			}
			else
				oRow[nRCell] = null;
		}
		
		oCellValue	= "" + oCells(nRow+n, nCols).value;
		if(1 < oCellValue.length && '*' == oCellValue.charAt(0))
		{
			oRow[0]	= oCellValue.substr(1);
			oCellsInRowWC[iAmountRowsWithCondition++] = oRow;
		}
		else
		{
			oRow[0]	= null;
			oCellsInRowWOC[iAmountRowsWithOutCondition++] = oRow;
		}

	}
	
	if(0 == iAmountRowsWithCondition && 0 == iAmountRowsWithOutCondition)
		return nRow;

	var exlVer = oExcel.Version;
	exlVer = exlVer.left(exlVer.search(/\./ig));
	exlVer = Number(exlVer);

	nRecords = rTbl ? rTbl.recordCount : 0;
	//уточним диапазон прогресса
	setProgressRange(0, nRecords);
	var nProgress		= 0;
	var iAmountRow		= (0 == iAmountRowsWithCondition)?0:1;
	iAmountRow			= iAmountRow + iAmountRowsWithOutCondition;
	var iFirstFooterRow	= nRow+iAmountRowsWithCondition+iAmountRowsWithOutCondition;
	var iLastFooterRow	= nUsedRows + 4;
	var iOffset			= nRecords*iAmountRow;
	var iRowsInFooter	= iLastFooterRow - iFirstFooterRow + 1;
	var sNewAddress;
	//Кол-во листов
	nSheets = 0;
	//Кол-во элементов на всех листах, кроме последнего
	nItems = 0;
	
	//Вычислим кол-во нужных листов и добавим, если нужно
	if(nRow+iOffset+iRowsInFooter > nMaxRowPerPage)
	{
		//Если весь документ не помещается на один лист
		var j = 0;
		//Подсчет кол-ва элементов на всех листах, кроме последнего и кол-ва листов
		while(nItems < nRecords)
		{
			j = Math.floor((nMaxRowPerPage-nRow)/iAmountRow);
			nItems += j;
			nSheets++;
		}
		
		nItems-=j;
		
		//Вставляем недостающие листы
		for (var sh = oExcel.Sheets.Count + 1; sh <= nSheets; sh++)
		{
			oExcel.Sheets(1).Select;
			oExcel.Sheets.Add();
			oExcel.Sheets(1).Move(oExcel.Sheets(3));
		}
		
		//Нумеруем листы
		for (var sh =  1; sh <= oExcel.Sheets.Count; sh++)
			oExcel.Sheets(sh).Name = sh;
	}
	else
	{
		nSheets = 1;
	}
	
	//Создадим два временных листа.
	oExcel.Sheets(1).Select;
	oExcel.Sheets.Add();
	oExcel.Sheets(1).Name = "footer";
	oExcel.Sheets("footer").Move(null, oExcel.Sheets(oExcel.Sheets.Count));
	oExcel.Sheets(1).Select;
	oExcel.Sheets.Add();
	oExcel.Sheets(1).Name = "condition";
	oExcel.Sheets("condition").Move(null, oExcel.Sheets(oExcel.Sheets.Count));
	oExcel.Sheets(1).Select;
	
	//переносим footer
	oExcel.Sheets(1).Range("A"+iFirstFooterRow+":"+getCellName(nCols)+iLastFooterRow).Cut(
			oExcel.Sheets("footer").Range("A1:"+getCellName(nCols)+iRowsInFooter));
	oExcel.Sheets(1).Rows(""+iFirstFooterRow+":"+iLastFooterRow).Delete();
	
	//переносим condition
	oExcel.Sheets(1).Range("A"+nRow+":"+getCellName(nCols)+(iFirstFooterRow-1)).Cut(
			oExcel.Sheets("condition").Range("A1:"+getCellName(nCols)+(iFirstFooterRow-nRow)));
	oExcel.Sheets(1).Rows(""+nRow+":"+(iFirstFooterRow-1)).Delete();

	//Установка на всех листах одинаковой ширины столбцов
	if (exlVer < 10)
	for(var sh = 2; sh <= nSheets; sh++)
	for(var nCol=1; nCol<=nCols; nCol++)
		oExcel.Sheets(sh).Columns(getCellName(nCol - 1)+":"+getCellName(nCol - 1)).ColumnWidth =
			oExcel.Sheets(1).Columns(getCellName(nCol - 1)+":"+getCellName(nCol - 1)).ColumnWidth;

	//теперь поехали печатать
	var sField, oInCell;
	var iItemOnPage = 0;
	for(var sh = 1; sh <= nSheets; sh++)
	{
		if(sh!= 1)
			nRow=0;
		//Проходим по листам
		oExcel.Sheets(sh).Select;
		
		if (sh != nSheets)
			iItemOnPage = Math.floor((nMaxRowPerPage-nRow)/iAmountRow);
		else
			iItemOnPage = nRecords-nItems;

		for(var n=0; n<iItemOnPage; n++)
		{
			//сначала строки без условия
			if(iAmountRowsWithOutCondition)
			{
				oExcel.Sheets("condition").Range("A1:"+getCellName(nCols-2)+iAmountRowsWithOutCondition+1).Copy(
				oExcel.Sheets(sh).Range("A"+(nRow)));
			}
			
			for(var i = 0; i < iAmountRowsWithOutCondition; i++)
			{
				for(var iCol = 1; iCol <nCols; iCol++)
				if((sField=oCellsInRowWOC[i][iCol]) != null)
				{
					oInCell = oExcel.Cells(nRow+i, iCol);
					if("^NUM" == sField)
						oInCell.value = n+1;
					else
					if("CROSSR" == sField.substr(0,6))
					{
						var cTbl = rTbl.getCol();
						cTbl.moveFirst();
						
						for (j = 0; j < cTbl.recordCount; j++)
						{
							oExcel.Sheets("condition").Range(getCellName(iCol-1)+"1").Copy();
							oExcel.Sheets(sh).Range(getCellName(iCol-1+j) + (nRow+i)).PasteSpecial(-4122);
							oInCell.value	= this.setField("r" + cTbl("fcolid"));
							oInCell = oExcel.Cells(nRow+i, iCol + j + 1);
							cTbl.moveNext();
						}
						
						iCol += j;
					}
					else
						oInCell.value	= this.setField(sField);
				}
			}
			nRow+=iAmountRowsWithOutCondition;
			//теперь ячейки с условием
			for(var i = 0; i< iAmountRowsWithCondition ; i++)
			{
				if(this.setField(oCellsInRowWC[i][0]))
				{
					oExcel.Sheets("condition").Range("A"+(i+1+iAmountRowsWithOutCondition)
													+":"+getCellName(nCols-2)
													+(i+1+iAmountRowsWithOutCondition)).Copy();
					oExcel.Sheets(sh).Range("A"+(nRow)).PasteSpecial(-4122);

					for(var iCol = 1; iCol <nCols; iCol++)
					{
						if((sField=oCellsInRowWC[i][iCol]) != null)
						{
							oInCell = oExcel.Cells(nRow, iCol);
							if("^NUM" == sField)
								oInCell.value = n+1;
							else
							if("CROSSR" == sField.substr(0,6))
							{
								var cTbl = rTbl.getCol();
								cTbl.moveFirst();
															
								for (j = 0; j < cTbl.recordCount; j++)
								{
									oExcel.Sheets("condition").Range(getCellName(iCol-1)+"1").Copy();
									oExcel.Sheets(sh).Range(getCellName(iCol-1+j) + (nRow+i)).PasteSpecial(-4122);
									oInCell.value	= this.setField("r" + cTbl("fcolid"));
									oInCell = oExcel.Cells(nRow+n*iAmountRow+i, iCol + j + 1);
									cTbl.moveNext();
								}

								iCol += j;
							}
							else
								oInCell.value	= this.setField(sField);
						}
					}
					
					nRow++;
				}
			}
			
			rTbl.moveNext();
			nProgress++;
			setProgressPos(nProgress, "Обработано записей "+nProgress+" из "+nRecords);
		}
	}

	sNewAddress	= "A"+nRow+":"+getCellName(nCols)+(nRow+iRowsInFooter-1);
	
	oExcel.Sheets("footer").Range("A2:"+getCellName(nCols)+(iRowsInFooter+1)).Cut(oExcel.Sheets(nSheets).Range(sNewAddress));

	//Разбивка на траницы, если нужно
	var strCommand = oExcel.Range("A" + (inRow + iItemOnPage*iAmountRow - 1 + 3)).Value;
	if (typeof(strCommand) == "string" && strCommand.left(11) == "PAGE BREAK=" &&
			 strCommand.right(strCommand.length - 11).search(/\D/gi) == -1)
	{
		InsertPageBreak(oExcel, inRow, iAmountRow, Number(strCommand.right(strCommand.length - 11)));
		oExcel.Range("A" + (inRow + iItemOnPage*iAmountRow - 1 + 3)).ClearContents;
	}

	//удаляем временные листы
	oExcel.Sheets("footer").Delete();
	oExcel.Sheets("condition").Delete();

	//все, строки должны быть готовы
	return nRow-1;
}

function CustomizeForm( oExcel, csOut, sForm, tbl )
{
	switch( sForm )
	{
		case "nk_ex53":	// налоговая накладная
		{
			var nRows	= tbl.recordCount;
			var oRange	= csOut.Range( "A30:A"+(30+nRows) );
			if( nRows > 1 )
				oRange.merge();
			csOut.Range( "A30" ).value	= "I";
			break;
		}
	}
}

function InsertPageBreak(exl, nRow, nRowsHeight, nItemForPage)
{
	var page = 0;

	setProgressPos(0);
	setProgressRange(0, nRecords);

	for(i = 1; i <= nSheets; i++)
		for(j = nItemForPage; j <= (i == nSheets ? nRecords - nItems : nRecords/nSheets); j+=nItemForPage)
		{
			page++;
			exl.Rows(nRow + j*nRowsHeight).Select;
			exl.Sheets(i).HPageBreaks.Add(exl.ActiveCell);
			setProgressPos(j, "Разбивка на страницы: " + page + " страниц");
    	}
}

function Office_makeCross(exl, rTbl, cell)
{
	var col = cell.Column;
	var row = cell.Row;
	
	var sVal = exl.Cells(row, col).Value;
	exl.Cells(row, col).Value = sVal.replace(/CROSSH/i, "");
	
	var cTbl = rTbl.getCol();
	cTbl.moveLast();
	
	var i = cTbl.recordCount;
	while (i != 1)
	{
		exl.Cells(row, col).Select;
		exl.Selection.Copy;
		exl.Cells(row, col + 1).Select;
		exl.Selection.Insert(-4161);
		exl.CutCopyMode = 0;
		sVal = exl.Cells(row, col + 1).Value;
		exl.Cells(row, col + 1).Value = this.setField(sVal.substr(1));

		i--;
		cTbl.movePrev();
	}
	
	cTbl.moveFirst();
	sVal = exl.Cells(row, col).Value;
	exl.Cells(row, col).Value = this.setField(sVal.substr(1));

	for (i = 1; i < cTbl.recordCount; i++)
		exl.Cells(row, col + i).ColumnWidth = exl.Cells(row, col).ColumnWidth;
	
	return cTbl.recordCount - 1;
}