include("Objects\\DpEval.js");
include("sys\\dbase.js");
include("office/ExcelWrappers/xlsWorkBook.js");

function Office_printExcel()
{
	this.setField	= POI_stdSetField;
	this.beforeInstancePrint = Office_beforeInstancePrint;

	var userScript = this.vars.form;
	userScript = userScript.substr(0, userScript.indexOf("/")) + "/" + this.vars.prSelectLbl + ".js";
	if (isFile(userScript))
	{
		include(userScript);
	}
	else
	{
		userScript = userScript.substr(0, userScript.indexOf("/")) + "/" + this.vars.sFormLbl + ".js";
		if (isFile(userScript))
		{
			include(userScript);
		}
	}

	//fruckt
	//если печатаем несколько форм со скриптами
	//исполняются функции последней заинклуженой	
	
	//Олег 
	//функция должна называтся "onBeforeInstancePrint_"+Имя патерна формы печати
	//например onBeforeInstancePrint_NV_EX10
	if (eval("typeof(onBeforeInstancePrint_"+this.vars.sFormLbl+") == 'function'"))
	{
		eval("this.beforeInstancePrint = onBeforeInstancePrint_"+this.vars.sFormLbl);
	}
	else if (typeof(print_onBeforeInstancePrint) == "function")
	{
		this.beforeInstancePrint = print_onBeforeInstancePrint;
	}
	
	WAIT("");
	WAIT(ru("Идет подготовка к печати...", "Йде підготовка до друку..."));

	var workBook = new xlsWorkBook(this);

	// Путь к файлу.
	if (isEmpty(this.vars.getVar("_filepath")))
	{
		this.vars.setVar("_filepath", "");
	}

	//vvs 06.05.2006
	this.vars.setVar("D", (new Date()).getVarDate() );	// сегодняшнее число
	this.vars.setVar("T", format("th:tm:ts", ((new Date()).getTime() - today.getTime())/3600000 ) );	// текущее время

	if (!this.beforeInstancePrint(this.vars))
	{
		return false;
	}

	workBook.load();

	WAIT(ru("Идет печать...", "Виконується друк..."));
	workBook.parse();

	WAIT(ru("Подготовка файла...", "Підготовка файлу..."));
	workBook.print();

	WAIT(ru("Запуск Excel...", "Запуск Excel..."));

	if(this.vars.getVar("_filepath")!="")
	{
		this.file = this.vars.getVar("_filepath");
	}
	var oStream = new DpFileOutputStream(this.file);
	workBook.workBook.write(oStream);
	oStream.close();
	var	bPreview	= getPar("PrtPreview");

	//признак експорта печатью ( в этом случае нужно только создать файл, открывать и печатать не нужно)
	var _isExport = (this.vars && this.vars.getVar("_isExport") ? true : false);

	//признак того что нужно сразу отправлять на печать
	var prnimdl = (this.vars && this.vars.getVar("_PRNIMDL") ? true : false);

	//vlad 21.05.2010
	//Если нам сказали экспортировать, то никаких экселей и офисов открывать не надо
	//И вообще, этот кусок следует переписать
	if(_isExport)
	{
		workBook.workBook = null;
		workBook.release();
		CLEARWAIT();
		return;
	}

	if (typeof(IS_WEB) != "undefined" && IS_WEB)
	{
		workBook.workBook = null;
		workBook.release();

		shellOpen(this.file);

		CLEARWAIT();
		return;
	}

	if(workBook.getPostProcessAction()==xlsConst.PPA_EDIT_DOCUMENT && !prnimdl)
	{
		workBook.workBook = null;
		workBook.release();

		var ret = Packages.org.eclipse.swt.program.Program.launch(new DpFile(this.file));
		if (ret == false && Packages.org.eclipse.core.runtime.Platform.getWS() == "gtk")
		{
			shellOpen(this.file);
		}

		CLEARWAIT();
		return;
	}
	workBook.workBook = null;
	workBook.release();

	var exl = null;

	if(Packages.org.eclipse.core.runtime.Platform.getWS() == "win32")
	{
		include ("Objects/DpCOMObject.js");
		var e;
		try
		{
			exl = new DpCOMObject("Excel.Application");
		}
		catch(e)
		{
		}
	}

	if (exl && exl.__jCOMObj != null)
	{
		var doc = exl.Workbooks.Open(this.file);
		if(prnimdl)
		{
			exl.visible = false;
			doc.printOut();
		}
		else if(bPreview)
		{
			exl.visible = true;
			doc.printPreview();
		}
		else
		{
			exl.visible = false;
			doc.printOut();
		}

		exl.release();
	}
	else
	{
		//Нужна версия 11.9.7
		var oCalcPrinter = lpProxy.getOfficePrinter("scalc");
		oCalcPrinter.setFormFile(this.file);
		var xSpreadsheetComponent = oCalcPrinter.getDocument(this.file);

		if (prnimdl)
		{
			oCalcPrinter.quickPrint(xSpreadsheetComponent);
			oCalcPrinter.close(xSpreadsheetComponent);
		}
		else if(bPreview)
		{
			oCalcPrinter.printPreview(xSpreadsheetComponent);
		}
		else
		{
			oCalcPrinter.quickPrint(xSpreadsheetComponent);
			oCalcPrinter.close(xSpreadsheetComponent);
		}
		//java.awt.Desktop.getDesktop().open(new DpFile(this.file));
		return;
	}
	return;

	CLEARWAIT();
}

function Office_beforeInstancePrint()
{
	return true;
}

//Функция не приводит результат к строке как стандартная - office.js
function POI_stdSetField(fld, t)
{

	var res = fld;

	if(this.vars)
	{
		//must be DpTVars
		res =  this.vars.getVar(String(fld));
	}
	trace(fld+ " = "+ res);

	if (res == null)
		res = "";

	if (typeof(res) != "string")
		return res;

	var pos = res.indexOf("|");

	if (pos == -1)
		return res;

	if (this.prtLang == 0)
		res = res.left(pos);
	else
		res = res.right(res.length - pos - 1);

	return res;

}