include ("iCalApi.js");
include ("doc/DpDoc.js");
		
function Load()
{
	Caption("Календар|Календарь");
	
	this.loadCals = loadCals;
	this.onCalSelect = onCalSelect;
	//evCalendar.setSource(this.source);

	//evCalendar.setWeek(today.year, 14, 1);
	//evCalendar.setDay(today);

	evCalendar.setMonth(today.year, today.month);
	//evCalendar.setWeek(today.year, 9, 4);

	
	this.loadCals();
	
	gridCals.FieldEx("FTXT", UR("Календар|Календарь"), 10);
	gridCals.setTable(this.tbl);	
	gridCals._build();
	gridCals.selectAll();
	this.onCalSelect();
	gridCals.addCheckHandler(this, "onCalSelect");	
	
	CALSGRP.setBackground(evCalendar.getCtrl().getBackground());
	MONTHGRP.setBackground(evCalendar.getCtrl().getBackground());
	
	monthCal.setSelectionHandler(monthSel);
	
	this.calLoadMenuInit = organizer_calLoadMenuInit;
	evCalendar.loadMenuHandler(this, "calLoadMenuInit");
	
	this.calSelMenuRun = organizer_calSelMenuRun;
	evCalendar.selectMenuHandler(this, "calSelMenuRun");
	
	this.calsMenuInit = calsMenuInit;
	this.calsMenuRun = calsMenuRun;
	gridCals.loadMenuHandler(this,"calsMenuInit");
	gridCals.selectMenuHandler(this,"calsMenuRun");
	this.refreshOrganizer = refreshOrganizer;
	
}

function calsMenuInit()
{
	gridCals.AddMenuItem("ADD","Додавання | Добавление");
	if (!gridCals.getTable().isEmpty())
	{
		//grid.AddMenuItem("EDIT","Редагування | Редактирование");
		//grid.AddMenuItem("COPY","Копіювання | Копирование");
		var id = gridCals.getTable().getValue("FWID");
		if (id != null && String(id).endsWith(".ics"))	
			gridCals.AddMenuItem("DEL","Видалення | Удаление");
	}
	//gridCals.AddMenuItem("","");
}

function calsMenuRun(ID)
{
	if (ID == "ADD")
	{
		var nameCal = input(UR("Ім'я|Имя"),UR("Додати календар|Добавить календарь"),"",100);
		if (!nameCal)
			return;
		
		if (!nameCal.endsWith(".ics"))
			nameCal += ".ics";
		var iCalDir = userDirectory() + "iCals";
		var fileName = iCalDir + "/" + nameCal; 
		if (isFile(fileName))
		{
			alert(UR("Такий календар вже iснує|Такой календарь уже существует"));
			return false;
		}
		
		var calendar = iCalApi.createCalendar();
		createDirectory(iCalDir);
		iCal_saveCalendar(calendar, fileName);
		this.refreshOrganizer();
		
	}
	if (ID == "DEL")
	{
		if("-" != msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису"))
			)
			return;
		var nameCal = gridCals.getTable().getValue("FWID");	
		deleteFile(nameCal);
		this.refreshOrganizer();
	}
	
}

function iCal_saveCalendar(calendar, fileName)
{
	var arhFile = fileName + "_arh";
	
	if (isFile(fileName))
		copyFile(fileName, arhFile);
		
	var ret = iCalApi.saveCalendar(calendar, fileName);
	if (!ret)
		copyFile(arhFile,fileName);
		
}

function refreshOrganizer()
{
	this.loadCals();
	gridCals.setTable(this.tbl);	
	gridCals._build();
	gridCals.selectAll();
	this.onCalSelect();
}

function loadCals()
{
	this.tbl = createObjectTable();
	this.tbl.setIdFld("FWID"); 
	
	var tblNop = OpenTable("select FNOP, FTXT from ^cl_lnk where fdoc = 'EVENT' and fnop <> 0 order by fnop");
	if(tblNop.isEmpty() && String(getAccess('EVENT')) != "")
	{
		this.tbl.AddNew();
		this.tbl.setValue("FWID", "DOCEVENT");
		this.tbl.setValue("FTXT", UR("Загальнi|Общие"));
		this.tbl.Update();
	}
	else
	{
		while(!tblNop.isEOF())
		{
			var nNop = Number(tblNop.getValue("FNOP")); 
			if(String(getAccess('EVENT', nNop)) != "")
			{
			this.tbl.AddNew();
			this.tbl.setValue("FWID", "DOCEVENT_" + nNop);
			this.tbl.setValue("FTXT", UR(tblNop.getValue("FTXT")));
			this.tbl.Update();
			}
			tblNop.moveNext();
		}
	}
	tblNop.close();
	var iCalDir = userDirectory() + "iCals";
	createDirectory(iCalDir);
	var dir = new DpFile(iCalDir);
	var files = dir.listFiles();
	for (var i = 0; i < files.length; i++)
	{
		if (files[i].isDirectory() || !files[i].getName().endsWith(".ics"))
			continue;
		this.tbl.AddNew();
		this.tbl.setValue("FWID", files[i].getAbsolutePath());
		this.tbl.setValue("FTXT", files[i].getName());
		this.tbl.Update();		
	}
	
	
}

function getiCalsArray()
{
	var arr = new Array();
	var bm = list.tbl.absolute;
	list.tbl.moveFirst();
	while(!list.tbl.isEOF())
	{
		var id = String(list.tbl.getValue("FWID"));
		if (!id.startsWith("DOCEVENT"))
		{
			arr[arr.length] = String(list.tbl.getValue("FTXT"));
		}
		list.tbl.moveNext();
	}
	
	list.tbl.absolute = bm;
	return arr;
}

function onCalSelect()
{
	var source = getJavaClass("org.debet.utils.DpiCalSource").newInstance();
	var dbsource = getJavaClass("org.debet.utils.DpDocEventSource").newInstance();
	var arrSource = new Array();
	arrSource[0] = source; 
	var arr = gridCals.getSelectedIDs();
	var arrNop = new Array();
	for (var i = 0; i < arr.length; i++)
	{
		if (arr[i] == "DOCEVENT" || String(arr[i]).startsWith("DOCEVENT_"))
		{
			arrSource[1] = dbsource;
			if (String(arr[i]).startsWith("DOCEVENT_"))
				arrNop[arrNop.length] = parseInt(String(arr[i]).substr(9));
		}
		else
			source.addCalendar(arr[i]);
	}
	
	if(arrNop.length != 0)
		dbsource.setNops(arrNop);
	evCalendar.setSources(arrSource);
}

function monthSel()
{
	evCalendar.setDate(monthCal.getValue());
}

function organizer_calLoadMenuInit()
{
	var taskDay = evCalendar.getActiveTaskDay();
	if (taskDay == null)
		return;
	var event = taskDay.getActiveEvent();
	if (event != null)
		taskDay.addMenuItem("OPEN", "Відкрити|Открыть");
	
	if (getiCalsArray().length > 0)
		taskDay.addMenuItem("ADD", "Додати подію|Добавить личное событие");
	taskDay.addMenuItem("ADDGRPEVENT", "Додати загальну подію|Добавить общее событие");
	
	
	if (event != null)
		taskDay.addMenuItem("DEL", "Видалити|Удалить");
}

function organizer_calSelMenuRun(ID)
{
	var taskDay = evCalendar.getActiveTaskDay();
	if (ID == "OPEN")
	{
		var event = taskDay.getActiveEvent();
		organizer_editEvent(event);
	}
	if (ID == "ADD")
	{
		var event = taskDay.getActiveEvent();
		organizer_addEvent(taskDay.getDate());
	}
	if (ID == "ADDGRPEVENT")
	{
		organizer_addGroupEvent(taskDay.getDate());
	}
	if (ID == "DEL")
	{
		if("-" != msgBox("c-"
				, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
				, ru("Удаление записи", "Вилучення запису"))
			)
			return;
		var event = taskDay.getActiveEvent();
		var uid = String(event.getUID());
		if (uid.startsWith("DP"))
		{
			var nID = parseInt(uid.substr(2));
			if(isNaN(nID))
				return;
			oDoc = new DpDoc("EVENT", 0);
			oDoc.del(nID);
			evCalendar.update();
			lpProxy.getEventsReminder().reloadDocEvents();
		}
		else
		{
			var fileName = event.getCalID();
			var calendar = iCalApi.openCalendar(fileName);
			iCalApi.removeComponent(calendar, uid);
			iCal_saveCalendar(calendar, fileName);
			list.refreshOrganizer();
		}
		
		
	}
}

function organizer_editEvent(event)
{
	include ("doc/DpDoc.js");
	var uid = String(event.getUID());
	var oDoc = null;
	if (uid.startsWith("DP"))
	{
		var nID = parseInt(uid.substr(2));
		if(isNaN(nID))
			return;
		oDoc = new DpDoc("EVENT", 0);
		var ret = oDoc.edit("EDIT", nID);
		if (ret)
		{
			evCalendar.update();
			lpProxy.getEventsReminder().reloadDocEvents();
		}
		
	}
	else
	{
		oDoc = vEventToDoc(event.getVEvent(), "ASK");
		var par = new Object();
		par.doc = oDoc;	
		par.mode = "EDIT";
		par.isApplyBtn = true;
		par.idtmpl = true;
		par.isiCal = true;
		par.iCalArr =  getiCalsArray();
		
		
		var fileName = event.getCalID();
		par.iCalName = String(new DpFile(fileName).getName());
		var oldiCal = par.iCalName; 
		par.hasTab = true;
		showWindow(oDoc.formFile,"XMLDLG",par);
		if (!par.escape || par.apply)
		{
			var vEvent = docToVEvent(oDoc);
			var fileCal = getCalendarFileByName(par.iCalName)
			var calendar = iCalApi.openCalendar(fileCal);
			if (oldiCal == par.iCalName)
			{
				iCalApi.replaceComponent(calendar, vEvent);
				iCal_saveCalendar(calendar, fileCal);
			}
			else
			{
				iCalApi.addComponent(calendar, vEvent);
				iCal_saveCalendar(calendar, fileCal);
				
				var fileCalOld = getCalendarFileByName(oldiCal);				
				var calendarOld = iCalApi.openCalendar(fileCalOld);
				iCalApi.removeComponent(calendarOld, uid);
				iCal_saveCalendar(calendarOld, fileCalOld);
			}
			//evCalendar.update();
			
			list.refreshOrganizer();
			lpProxy.getEventsReminder().reloadiCalEvents();
		}
	}
}



function organizer_addEvent(dat)
{
	include ("doc/DpDoc.js");
	//var uid = String(event.getUID());
	var oDoc = new DpDoc("EVENT", 0);
	oDoc.setVar("HBDATE", dat);
	oDoc.setVar("HEDATE", dat);
	var par = new Object();
	par.doc = oDoc;	
	par.mode = "ADD";
	par.isApplyBtn = true;
	par.idtmpl = true;
	par.isiCal = true;
	par.iCalArr =  getiCalsArray();
	
	if (par.iCalArr.length > 0)
		par.iCalName = par.iCalArr[0];
	showWindow(oDoc.formFile,"XMLDLG",par);
	if (!par.escape || par.apply)
	{
		var vEvent = docToVEvent(oDoc);
		
		var fileCal = getCalendarFileByName(par.iCalName)
		var calendar = iCalApi.openCalendar(fileCal);
		iCalApi.addComponent(calendar, vEvent);
		//evCalendar.update();
		iCal_saveCalendar(calendar, fileCal);
		list.refreshOrganizer();
		lpProxy.getEventsReminder().reloadiCalEvents();
	}
}

function organizer_addGroupEvent(dat)
{
	include ("doc/DpDoc.js");
	//var uid = String(event.getUID());
	var oDoc = new DpDoc("EVENT", 0);
	oDoc.setVar("HBDATE", dat);
	oDoc.setVar("HEDATE", dat);
	var ret = oDoc.edit("ADD", -1, new Object());
	
	if (ret)
	{
		evCalendar.update();
		lpProxy.getEventsReminder().reloadDocEvents();
		//list.refreshOrganizer();
	}
}

function getCalendarFileByName(name)
{
	name = String(name);
	if(!name.endsWith(".ics"))
			name += "ics";
	var iCalDir = userDirectory() + "iCals";
	return iCalDir + "/" + name;
}
