include("l_eprkekz.js");
include("servis/date.js");
include("get_cnst.js");
include("prik/calculate/r_mnvk.js");

var oCalend, dayDif, dayDifP, dayDifS, oCl;
var isPredpr = true;
var isSocstr = true;
var kodnvk=0;
var defCalCod = 1000;
var sprPrBln;
function prkLoad()
{
	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);

	include("objects/DpCalendar.js");
	oCalend = new dpCalendar();	//календарь на общий период
	oCalend.linkCtrl(HCALNUM, HREM, HBDAT, HEDAT, COD, TXT);

	include("objects/DpCl.js");
	sprPrBln = getPar("FUNDS_CLCAUSE_NP");
	oCl = new DpCl("", sprPrBln, 0);	//календарь на общий период
	oCl.linkSmartCtrl(HKOD_PR);

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);

	switch (extPar.mode)
	{
		case "ADD":
			HDAT_BOL.value = d00;
			HBDAT.value = d00;
			HEDAT.value = d00;
			HMES_VIP.value = d00;
			HSUM.value  = 0;
			HDN.value  = 0;
			HCHAS.value  = 0;
			HDN_P.value  = 0;
			HCHAS_P.value  = 0;
			HDN_S.value  = 0;
			HCHAS_S.value  = 0;
			HNUM.value = "";
			oCalend.setCod(0);
			oCl.setCod(0);
			break;
		case "EDIT":
		case "COPY":
		case "VIEW":
			HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");
			HSUM.value = table.getValue("fproc");
			HMES_VIP.value = table.getValue("fmes_vip");
			HDAT_BOL.value = table.getValue("fdat_bol");
			//HDN.value = table.getValue("fday");
			//HCHAS.value = table.getValue("fchas");
			HDN.value = Number(Math.floor(Number(table.getValue("fsum"))/1000));			
			HCHAS.value = Number(table.getValue("fsum") - (Math.floor(Number(table.getValue("fsum"))/1000)) * 1000);
			HBDATP.value = table.getValue("fbdatp");
			HEDATP.value = table.getValue("fedatp");
			HBDATS.value = table.getValue("fbdats");
			HEDATS.value = table.getValue("fedats");
			HDN_P.value = table.getValue("fday_p")
			HCHAS_P.value = table.getValue("fchas_p")
			HDN_S.value = table.getValue("fday_s")
			HCHAS_S.value = table.getValue("fchas_s")
			HNUM.value = table.getValue("fnum");
			HNUM_ZVK.value = table.getValue("fnum_zvk");
			COD.value = table.getValue("fcod");
			if(table.getValue("fcalnum")!=null)
			{
				oCalend.setTabn(COD.value);
				oCalend.setCod(table.getValue("fcalnum"));
			}
			oCl.setCod(Number(table.getValue("fkod_pr")));
			edat_Valid();
			dat_bol_Valid();
			break;
	}

	useDefValid = false;
	dpShtat.updateCtrls();
	setValid(HEDAT,edat_Valid);
	setValid(HDAT_BOL,dat_bol_Valid);
	setWhen(HCALNUM,calnum_When);
	setAttr();
}

function setAttr()
{
	//.setBackground(0xFFFFFF);
	HNUM.setMask("&&&&&&&&&&&&");
	HSUM.setMask("###.##");
	Disable(HDN);
	Disable(HCHAS);
	Disable(HBDATP);
	Disable(HEDATP);
	Disable(HBDATS);
	Disable(HEDATS);
	Disable(HDN_P);
	Disable(HCHAS_P);
	Disable(HDN_S);
	Disable(HCHAS_S);

	if (extPar.mode == "ADD")
	{
		oCalend.setCod(defCalCod);
		HMES_VIP.setValue(new Date().getVarDate());
	}
}

function prkSave(m)
{
	var f = false;
	var mfwid = "";
	if (extPar.mode!= "EDIT")
	{
		m.Fwid = GetUID();
		f = true ;
	}
	else
	{
		mfwid = " fwid = "+table.getValue("fwid");
	}

	m.FVID_PRK = extPar.fvid;
	//m.FWID_PRIK = (extPar.mode!= "EDIT"?m.Fwid:table.getValue("fwid"));
	m.FBDAT = HBDAT.value;
	m.FEDAT = HEDAT.value;
	m.FDAT_BOL = HDAT_BOL.value;
	m.FMES_VIP = HMES_VIP.value;
	m.FPROC = HSUM.value;
	m.FWID_WP = dpShtat.getFwid();
	m.FCALNUM = HCALNUM.value;

	m.FDAY = HDN.value;
	m.FCHAS = HCHAS.value;
	m.FDAY_P = HDN_P.value;
	m.FCHAS_P = HCHAS_P.value;
	m.FDAY_S = HDN_S.value;
	m.FCHAS_S = HCHAS_S.value;
	m.FBDATP = HBDATP.value;
	m.FEDATP = HEDATP.value;
	m.FBDATS = HBDATS.value;
	m.FEDATS = HEDATS.value;
	m.FNUM = HNUM.value;
	m.FNUM_ZVK = HNUM_ZVK.value;
	m.FSUM	= Number(Number(HDN.value) * 1000 + Number(HCHAS.value));	
	
	if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat))
	{
		cFshpz = dpShtat.getFshpz()
	}
	m.FSHPZ = cFshpz;
	m.FKOD_PR = oCl.getCod();
	m.FTABN_ID = dpShtat.getEmployeFwid();

	//если есть параметр, то пытаемся проставить признак неявки в табеле
	if(getPar("NVK_PRIK"))
	{
		var oSnap = getSnap("select Fkod_nvk from ^cl_nvk where Frblnall='+'");
		if (oSnap!=null)
			kodnvk=Number(oSnap[0])
		if (kodnvk==0)
		{
			alert(ru("Не найдено ни одной записи, относящейся к больничным в настройках табелей",
					"Не знайдено жодного запису, який би відносився до лікарняних в налаштуванні табелів!"));
		}
	  	r_mnvk(m.FTABN_ID, m.FWID_WP, 0, 0, day_difference(m.FBDAT,m.FEDAT), 0, kodnvk, m.FBDAT, this.oPrik.getID());
	}
}

function edat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		alert(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if (differ(HEDAT.value, HBDAT.value) == -1)
	{
		alert(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	return updateAll();
}

function dat_bol_Valid()
{
	if (differ(toScriptDate(HDAT_BOL.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if(differ(HBDAT.value,d00)==0)
		HBDAT.value = HDAT_BOL.value;
	return true;
}

function updateAll()
{
	var par = new Object();
	par.fstDay = HDAT_BOL.value;
	par.bDat = HBDAT.value;
	par.eDat = HEDAT.value;

//	par.tabn = dpShtat.getEmployeCod();
	par.tabn = COD.value;

	oCalend.getTime4Bol(par);

	HDN.value = par.daysTot;
	HDN_P.value = par.daysPr;
	HDN_S.value = par.daysSs;
	HBDATP.value = par.dbpr;
	HEDATP.value = par.depr;
	HBDATS.value = par.dbss;
	HEDATS.value = par.dess;

	//если у сотрудника расчет ведется
	//исходя из часов то ставим еще и часы
	dat = firstDay(HBDAT.value);
	isHours = oCalend.getFisHours("", dat);
	if (isHours)
	{
		HCHAS.value = par.hoursTot;
		if(isPredpr)
			HCHAS_P.value = par.hoursPr;
		else
			HCHAS_P.value = 0;
		if(isSocstr)
			HCHAS_S.value = par.hoursSs;
		else
			HCHAS_S.value = 0;
	}
	else
	{
		HCHAS.value = 0;
		HCHAS_P.value = 0;
		HCHAS_S.value = 0;
	}
	return true;
}


function calnum_When()
{
	if(HCALNUM.value == 0 && dpShtat.getCalend()>0)
		oCalend.setCod(dpShtat.getCalend());
	return true;
}