include("l_eprkekz.js");
include("servis/date.js");
include("get_cnst.js");

var oBln, oCalend, dayDif, dayDifP, dayDifS;
var isPredpr = true;
var isSocstr = true;
var kodnvk=0;

function prkLoad()
{
	//для коректной взаимоработы двух подсистем делаем проверку
	if(getSystem()!="ZRP" && getSystem()!="CDR")
	{
		alert(ru("Для работы с этим приказом перейдите в подсистему учета з/п либо кадров!",
				"Для роботи з цим наказом перейдіть в підсистему обліку з/п або кадрів!"),ICON_WARNING)
		return false;
	}
	var snap = getSnap("select count(*) from ^nast_bln")
	if(snap==null)
	{
		alert(ru("Отсутствует таблица NAST_BLN!\nПроведите обновление структур БД и затем выполните настройку в меню:\nПервичные документы-Упрощённые больничные-Настройка",
				"Відсутня таблиця NAST_BLN!\nПроведіть оновлення структур БД і потім виконайте настройку в меню:\nПервинні документи-Зпрощені лікарняні-Налагодження"));
		return false;
	}
	else
	/*if(snap[0]==0)
	{
		alert(ru("Не выполнена настройка упрощенных больничных в меню:\nПервичные документы-Упрощённые больничные-Настройка",
				"Не виконане налагодження зпрощених лікарняних в меню:\nПервинні документи-Зпрощені лікарняні-Налагодження"));
		return false;
	}*/
	
	HSUM.setMask("###.##");
	HDN.setMask("###");
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
	HDN_KF.setMask("##");
	HKF.setMask("###.###");
	HCHAS.setMask("###.##");
	HCALNUM.setMask("##");
	HDN_P.setMask("###");
	HCHAS_P.setMask("###.##");
	HDN_S.setMask("###");
	HCHAS_S.setMask("###.##");
	HNUM.setMask("&&&&&&&&&&&&");
	HNUM_ZVK.setMask("&&&&&&&&");
	HNUM_PROTOKOL.setMask("&&&&&&&&");
	Disable(HDN);
	Disable(HCHAS);
	Disable(HBDATP);
	Disable(HEDATP);
	Disable(HBDATS);
	Disable(HEDATS);
	Disable(HDN_P);
	Disable(HCHAS_P);
	Disable(HDN_S);
	Disable(HCHAS_S);
	
	include("objects/DpBlnObsh.js");
	oBln = new DpBlnObsh(null, extPar.mode);
	oBln.linkCtrl(HBLN,HBLNTXT);
	
    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }
	
   	dpShtat = new DpShtat(null, null, null);	
 	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);
	
	include("objects/DpCalendar.js");
	oCalend = new dpCalendar();	//календарь на общий период
	//oCalend.setMode("0");
	oCalend.linkCtrl(HCALNUM, HREM, HBDAT, HEDAT, COD, TXT);
	
	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT); 
	
	switch (extPar.mode)
	{
		case "ADD":
         	HDAT_BOL.value = d00;
         	HBDAT.value = d00;
         	HEDAT.value = d00;
         	HMES_VIP.value = d00;
         	HSUM.value  = 0;
         	HDN.value  = 0;
         	HCHAS.value  = 0;
         	HDN_P.value  = 0;
         	HCHAS_P.value  = 0;
         	HDN_S.value  = 0;
         	HCHAS_S.value  = 0;
         	HDN_KF.value  = 0;
         	HKF.value  = 0;
         	HNUM.value = "";
         	oCalend.setCod(0);
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
            HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");
			HSUM.value = table.getValue("fproc");
			HMES_VIP.value = table.getValue("fmes_vip");
			HDAT_BOL.value = table.getValue("fdat_bol");
			HDN_KF.value  = table.getValue("fnom_prik");
			HDN.value = table.getValue("fday")//Number(Math.floor(Number(table.getValue("fsum"))/1000));			
			HCHAS.value = table.getValue("fchas")//Number(table.getValue("fsum") - (Math.floor(Number(table.getValue("fsum"))/1000)) * 1000);
			HBDATP.value = table.getValue("fbdatp");
			HEDATP.value = table.getValue("fedatp");
			HBDATS.value = table.getValue("fbdats");
			HEDATS.value = table.getValue("fedats");
			HDN_P.value = table.getValue("fday_p")
			HCHAS_P.value = table.getValue("fchas_p")
			HDN_S.value = table.getValue("fday_s")
			HCHAS_S.value = table.getValue("fchas_s")
			HKF.value  = Number(table.getValue("fcalnum"));
			HNUM.value = table.getValue("fnum");
			HNUM_ZVK.value = table.getValue("fnum_zvk");
			HNUM_PROTOKOL.value = table.getValue("FNUM_PROTOKOL");
			if(table.getValue("fcalnum")!=null)
				oCalend.setCod(table.getValue("fcalnum"));
			//l_eprkekz.js установит табельный номер после prkLoad(), поэтому установим занчения вручную
			dpShtat.setPeriod(table.getValue("fbdat"), table.getValue("fedat"));
			dpShtat.setFwid(table.getValue("fwid_wp"));
			if(table.getValue("fbln_type")!=null)
			{
				oBln.zSetCod(table.getValue("fbln_type"));
			}
			edat_Valid();
			dat_bol_Valid();
		break;	
	}
	useDefValid = false;
	dpShtat.updateCtrls();
	setValid(HEDAT,edat_Valid);
	setValid(HDAT_BOL,dat_bol_Valid);
	setWhen(HCALNUM,calnum_When);
	setFocus(COD);
}
function prkSave(m)
{
	//из подсистемы кадров в случае редактирования приказа с существующими дочерними приказами 
	//и включенном режиме "сохранения через контекстное меню" родительский приказ не редактируем
	if(getSystem()=="CDR" && extPar.mode=="EDIT" && getPar("SAVEBLNINZRP")=="menu" && isExistsDaughterPrk(oPrik.getVar("HID")))
	{
		var kol = getZrpPrkCount(oPrik.getVar("HID"));
		alert(ru("Приказ сохранен не будет, т.к. данный приказ имеет дочерние приказы ("+kol+" шт.) и \n"
					+"в параметре '"+getParItemPath("SAVEBLNINZRP")+"'\nвыбран режим 'из контекстного меню'"
					+"\nИзменения для таких случаев доступны лишь из подсистемы учета з/п!",
				"Наказ збережений не буде, тому що даний наказ має дочірні накази ("+kol+" шт.) та \n"
					+"в параметрі '"+getParItemPath("SAVEBLNINZRP")+"'\nобрано режим 'з контекстного меню'"
					+"\nЗміни для таких випадків доступні лише з підсистеми обліку з/п!"));
		return false;
	}
	m.FVID_PRK = extPar.fvid;
	m.FBDAT = HBDAT.value;
	m.FEDAT = HEDAT.value;	
	//m.FDAT_BOL = HDAT_BOL.value;
	//дату первого дня больничного будем проставлять датой начала периода, 
	//ее потом будем брать для переходящих приказов из одного месяца в другой
	m.FDAT_BOL = HDAT_BOL.value;
	m.FMES_VIP = HMES_VIP.value;
	//m.FSUM	= Number(Number(HDN.value) * 1000 + Number(HCHAS.value));	
	m.FNOM_PRIK = HDN_KF.value;
	//m.FCALNUM = HKF.value;	
	m.FPROC = HSUM.value;
	m.FWID_WP = dpShtat.getFwid();
	m.FCALNUM = HCALNUM.value;
	m.FBLN_TYPE = oBln.getCod();
	
	m.FDAY = HDN.value;
	m.FCHAS = HCHAS.value;
	m.FDAY_P = HDN_P.value;
	m.FCHAS_P = HCHAS_P.value;
	m.FDAY_S = HDN_S.value;
	m.FCHAS_S = HCHAS_S.value;
	m.FBDATP = HBDATP.value;
	m.FEDATP = HEDATP.value;
	m.FBDATS = HBDATS.value;
	m.FEDATS = HEDATS.value;
	m.FNUM = HNUM.value;
	m.FNUM_ZVK = HNUM_ZVK.value;
	m.FNUM_PROTOKOL = HNUM_PROTOKOL.value;
	
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;
	m.FTABN_ID = dpShtat.getEmployeFwid();
	
	//сохраняем дочерние приказы только из подсистемы з/п либо из кадров но при наличии соответсвующего параметра 
	if(getSystem()=="ZRP" || (getSystem()=="CDR" && getPar("SAVEBLNINZRP")=="save"))
	{
		//если есть параметр, то пытаемся проставить признак неявки в табеле
		if(getPar("NVK_PRIK"))
		{
			
		    var oSnap = getSnap("select Fkod_nvk from ^cl_nvk where Frblnall='+'");
		    if (oSnap!=null)
		    	kodnvk=Number(oSnap[0])
		    if (kodnvk==0)
		    {
		    	alert(ru("Не найдено ниодной записи, относящейся к больничным в настройках для табелей",
		    			"Не знайдено жодного запису, який би відносився до лікарняних в налагодженні для табелів!"));
		    }
		}
		
		var par = new Object();
		par.isPredpr = isPredpr;
		par.isSocstr = isSocstr;
		par.oBln = oBln;
		par.oCalend = oCalend;
		par.m = m;
		par.kodnvk = kodnvk;
		par.fwid = oPrik.getVar("HID");
		par.mode = extPar.mode;
		par.oPrik = oPrik;
		if(!saveBlnPrk(par))
		{
			//удаляем все поля объекта, чтобы отменить сохранение в l_eprkekz.js
			for(var i in m)
				delete(m[i]);
		}
	}
}

function edat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		alert(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if (differ(HEDAT.value, HBDAT.value) == -1)
	{
		alert(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	if (oCalend.getCod()!=0)
	{
		//HDN.value = oCalend.getCalDays("Р", HBDAT.value, HEDAT.value);
		//HCHAS.value = oCalend.getCalHours("Р", HBDAT.value, HEDAT.value);
	}
	return updateAll();
}

function dat_bol_Valid()
{
	if (differ(toScriptDate(HDAT_BOL.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if(differ(HBDAT.value,d00)==0)
		HBDAT.value = HDAT_BOL.value;
	return true;
}

function updateAll()//расчитываем даты, дни, часы дле всех приказов
{
	if(oBln.getFidP()==0 && oBln.getFidS()==0)
	{
		alert(ru("В настройке упрощенных больничных '","В налагодженні зпрощених лікарняних '")+oBln.getNazv()
			+ru("' отсутствуют оба кода приказов больничных за счет предприятия и за счет соцстарха!",
				"' відсутні обидва коди наказів лікарняних за рахунок підприємства і за рахунок соцстарху!"));
		return false;
	}
	var par = new Object();
	//par.fstDay = HDAT_BOL.value;
	par.fstDay = HBDAT.value;
	par.bDat = HBDAT.value;
	par.eDat = HEDAT.value;
	par.tabn = 0//dpShtat.getEmployeFwid();
	par.isBerem = oBln.isBerem();//передаем признак беременности, чтоб посчитать календарные дни
	if(getSystem()=="CDR" && (getPar("SAVEBLNINZRP")=="menu" || getPar("SAVEBLNINZRP")=="no"))
		var fvid = extPar.fvid;//если дочерних приказов нет или их может не быть, то первичный больничный ищем по упрощенным больничным
	else
		var fvid = oBln.getFidP();
	//создаём больничный за счёт предприятия если он есть в настройках и это не продолжение уже заведённого ранее или же в заведённом ранее было меньше 5 дней
	var daysp_prev = getDaysInPrev(HDAT_BOL.value,dpShtat.getEmployeFwid(),fvid);//кол-во дней за счет предприятия у первичного больничного
	if(oBln.getFidP()==0)//если больничный идет только по с/с, тогда передадим 5 дней за счет предприятия якобы у первичного больничного, чтобы система правильно высчитала время
		daysp_prev = 5;
	par.daysp_prev = daysp_prev;
	oCalend.getTime4Bol(par);

//	if(oBln.isBerem() && get_cnst("br2010",HDAT_BOL.value))//для беременных по новому законодательству с 15.12.2009 берем календарные дни
//	{
//		HDN.value = day_difference(HBDAT.value,HEDAT.value);
//		HDN_S.value = par.daysSs;
//		HBDATS.value = par.dbss;
//		HEDATS.value = par.dess;
//	}
//	else
	{
		HDN.value = par.daysTot;
		HDN_S.value = par.daysSs;
		HBDATS.value = par.dbss;
		HEDATS.value = par.dess;
	}
	//создаём больничный за счёт предприятия если он есть в настройках и это не продолжение уже заведённого ранее или же в заведённом ранее было меньше 5 дней
	if(getSystem()=="CDR" && (getPar("SAVEBLNINZRP")=="menu" || getPar("SAVEBLNINZRP")=="no"))
		fvid = extPar.fvid;//если дочерних приказов нет или их может не быть, то первичный больничный ищем по упрощенным больничным
	else
		fvid = oBln.getFidP()?oBln.getFidP():oBln.getFidS();
	var isFind = findBln(HDAT_BOL.value,dpShtat.getEmployeFwid(),fvid);
	if(oBln.getFidS()==0)
		isSocstr = false;
	else
		isSocstr = true;
	//если продолжение больничного и сущестует соцстрах и у предыдущего больничного за счет предприятия были использованы все дни, то за счет предприятия не создаем
	if(oBln.getFidP()==0 || (isFind && isSocstr && daysp_prev>=get_cnst("dayspidp",HDAT_BOL.value)))
		isPredpr = false;
	else
		isPredpr = true;
	//
	if(differ(HDAT_BOL.value,HBDAT.value)!=0 && !isFind)
	{
		alert(ru("Не найден первичный больничный на ",
				"Не знайдено первісний лікарняний на ")+format("dd.mm.yyyy ",HDAT_BOL.value));
		return false;
	}
	if(!isPredpr)//больничные только за счет соцстраха
	{
		HDN_P.value = 0;
		HBDATP.value = d00;
		HEDATP.value = d00;
		
		HDN_S.value = par.daysTot;
		HBDATS.value = HBDAT.value;
		HEDATS.value = HEDAT.value;
	}
	else
	{
		if(isSocstr)//больничные за счет предприятия и за счет соцстраха
		{
			HDN_P.value = par.daysPr;
			HBDATP.value = par.dbpr;
			HEDATP.value = par.depr;
			
			HDN_S.value = par.daysSs;
			HBDATS.value = par.dbss;
			HEDATS.value = par.dess;
		}
		else//больничные только за счет предприятия
		{
			HDN_P.value = par.daysTot;
			HBDATP.value = HBDAT.value;
			HEDATP.value = HEDAT.value;
			
			HDN_S.value = 0;
			HBDATS.value = d00;
			HEDATS.value = d00;
		}
	}
	//если у сотрудника расчет ведется
	//исходя из часов то ставим еще и часы
	dat = firstDay(HBDAT.value);
	isHours = oCalend.getFisHours("", dat);
	if (isHours)
	{
		HCHAS.value = par.hoursTot;
		if(isPredpr)
			HCHAS_P.value = par.hoursPr;
		else
			HCHAS_P.value = 0;
		if(isSocstr)
			HCHAS_S.value = par.hoursSs;
		else
			HCHAS_S.value = 0;
	}
	else
	{
		HCHAS.value = 0;
		HCHAS_P.value = 0;
		HCHAS_S.value = 0;
	}
	return true;
}

function findBln(dat_bol,ftabn_id,fvid)
{
	if(differ(new Date(dat_bol),d00obj)!=0)
	{
		var snap = getSnap("select fwid from ^prk_all where Fvid_prk="+fvid+" and Ftabn_id="
				+ftabn_id+" and Fdat_bol="+sqlTo(dat_bol)
				//нужно еще смотреть чтоб не искал наши же дочерние приказы
				+(extPar.mode=="EDIT"?" and Fwid_prik<>"+table.getValue("Fwid"):""))
		if(snap)
			return true;
	}
	return false;
}

//возвращает кол-во календарных дней у первичного больничного
function getDaysInPrev(dat_bol,ftabn_id,fvid)
{
	if(differ(new Date(dat_bol),d00obj)!=0)
	{
		if(extPar.fvid == fvid)
		{
			var snap = getSnap("select MIN(b.Fbdatp),MAX(b.Fedatp) from ^prk_all as p inner join "
					+" ^prk_blnobsh as b on p.Fwid=b.Fwid where p.Fvid_prk="+fvid+" and p.Ftabn_id="
					+ftabn_id+" and p.Fdat_bol="+sqlTo(dat_bol)
					//нужно еще смотреть чтоб не искал наш упрощенный больничный
					+(extPar.mode=="EDIT"?" and p.Fwid<>"+table.getValue("Fwid"):""))
		}
		else
		{
			var snap = getSnap("select MIN(Fbdat),MAX(Fedat) from ^prk_all where Fvid_prk="+fvid+" and Ftabn_id="
					+ftabn_id+" and Fdat_bol="+sqlTo(dat_bol)
					//нужно еще смотреть чтоб не искал наши же дочерние приказы
					+(extPar.mode=="EDIT"?" and Fwid_prik<>"+table.getValue("Fwid"):""));
		}
		if(snap && snap[0])
			return day_difference(snap[0],snap[1]);
	}
	return 0;
}

function calnum_When()
{
	if(HCALNUM.value == 0 && dpShtat.getCalend()>0)
		oCalend.setCod(dpShtat.getCalend());
	return true;
}