include("l_eprkekz.js");

function prkLoad()
{	
	HSUM.setMask("-#########.##");
	HSUMN.setMask("-#########.##");
	HSUMOBL.setMask("##");
	HSUMNAL.setMask("-#########.##");
	HSUMNALN.setMask("-#########.##");	
	
	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);
	
	useDefValid=false;
	setValid(HBDAT, bdat_Valid);
	setValid(HEDAT, edat_Valid);
	
	switch (extPar.mode)
	{
		case "ADD":
			HSUM.value = 0;
			HSUMN.value = 0;
			HSUMOBL.value = 0;
			HSUMNAL.value = 0;
			HSUMNALN.value = 0; 		
			HBDAT.value = d00;
			HEDAT.value = d00;
			HMN.value = d00;
			HVDN.value = 1;			
		break;
		case "EDIT": 
		case "COPY":
		case "VIEW":
			HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");		
			HMN.value = table.getValue("fmn");
			HSUM.value = table.getValue("fsum");
			HSUMN.value = table.getValue("fsumn");
			HSUMOBL.value = table.getValue("fsumobl");
			HSUMNAL.value = table.getValue("fsumnal");
			HSUMNALN.value = table.getValue("fsumnaln");
			HVIDNACH.value = String(table.getValue("fvidnach"));
			if (HVIDNACH.value==200){
				HVDN.value = 2;				
			}else{
				HVDN.value = 1;				
			}
		break;	
	}
	setFocus(COD);
}

function prkSave(m)
{
	m.FVID_PRK = extPar.fvid;
	m.FBDAT = HBDAT.value;
	m.FEDAT = HEDAT.value;
	m.FMN = HMN.value;
	m.FSUM = HSUM.value;	
	m.FSUMN = HSUMN.value;
	m.FSUMOBL = HSUMOBL.value;
	m.FSUMNAL = HSUMNAL.value;
	m.FSUMNALN = HSUMNALN.value;
	m.FVIDNACH = Number(HVIDNACH.value);
    if (HVDN.value ==2)m.FVIDNACH = 200;
	m.FWID_WP = dpShtat.getFwid();
	m.FTABN_ID = dpShtat.getEmployeFwid();
}

function bdat_Valid(obj) 
{
   	if (differ(toScriptDate(obj.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	return true;
}

function edat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	return true;
}