include("l_eprkekz.js");
var mFvid, dat1, dat2, edmode;

function prkLoad()
{
	mFvid = extPar.fvid;
	edmode = extPar.mode;
	dat1 = extPar.dat1;
	dat2 = extPar.dat2;

	FSUM1.setMask("##");
	FSUM2.setMask("###.##");
	FPROC.setMask("##.##");
	FNOM_PRIK.setMask("#####");
	HSHPZ.setMask("&&&&&&&&&&&&&&&");	
	
    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }
	
	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);

	switch (edmode) 
	{
		case "ADD":
			FSUM1.value = 0;
			FSUM2.value = 0;
			FPROC.value = 0;
			FBDAT.value = d00;
			FEDAT.value = d00;
			FNOM_PRIK.value = 0;
			FDAT_PRIK.value = d00;
			break;
		case "EDIT":
		case "COPY":
		case "VIEW":
			FSUM1.value = Math.floor(Number(table.getValue("Fsum"))/1000);
			FSUM2.value = Number(table.getValue("Fsum"))-(Math.floor(Number(table.getValue("Fsum"))/1000))*1000;
			FPROC.value = table.getValue("Fproc");
			FBDAT.value = table.getValue("Fbdat");
			FEDAT.value = table.getValue("Fedat");
			FNOM_PRIK.value = table.getValue("Fnom_prik");
			FDAT_PRIK.value = table.getValue("Fdat_prik");
			break;
		default:
			return;			
	}
	
	setValid(FSUM1, Fsum_Valid);	
	setValid(FSUM2, Fsum_Valid);
	setFocus(COD);
}

function prkSave(m)
{
	m.Fvid_prk = mFvid;
	m.Fwid_wp = dpShtat.getFwid();
	m.Ftabn_id = dpShtat.getEmployeFwid();
	//m.Fvopl	= otabn.getVopl();
	m.Fbdat	= FBDAT.value;
	m.Fedat	= FEDAT.value;
	m.Fsum	= (Number(FSUM1.value)*1000+Number(FSUM2.value));	
	m.Fproc = FPROC.value;
	m.Fdat_prik = FDAT_PRIK.value;
	m.Fnom_prik = FNOM_PRIK.value;
	
	//m.FSHPZ = hpz;
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;
	
}

function Fsum_Valid() 
{
	if(FSUM1.value==0 && FSUM2.value==0)
	{
		WAIT(ru("Период для оплаты ненулевой!","Період для сплати ненульовий!"));
		return false;
	}
	return true;
}