function prkLoad()
{
	gd = new DpGetDat("dD");
	if (!gd.dat1 || !gd.dat2)
		return false;
}

function prkSrc()
{
	var sOrder = "";
	if (IsSORT)
		sOrder = "c.fcod, p.fbdat, p.fedat";
	
	var sTableName = "^PRK_ALL";
	var sWhere = "p.fvid_prk = " + sqlTo(extPar.fvid) 
		+" AND p.fbdat<=" + sqlTo(gd.dat2) + " AND p.fedat>=" + sqlTo(gd.dat1);
		
	this.qrySet("Fields", "p.Fwid, p.Ftabn_id, p.Fsum, p.Fdat_otp, p.Fbdat, p.Fedat, p.Fshpz, p.Fnom_prik, p.Fwid_wp,"
				+" p.Fproc, p.Fdat_prik, p.Fcalnum, p.Fday_prop, p.Fchas_prop, p.Fwid_prik, w.Fwid_cl, c.Fcod",
				 "From", GLOBAL_TABLE+" AS p INNER JOIN ^work_pers AS w ON p.Fwid_wp=w.Fwid"
					+ " INNER JOIN ^clrelclcl AS c ON w.Fwid_cl=c.Fwid_cl", 
				"Where", sWhere,
				"Order", sOrder);

	//this.subTie(sTableName, "prk", "fwid", "fwid");
	this.subTie("work_pers","wp","fwid","fwid_wp");
	this.subTie("cl", "cl", "fwid", "fwid_cl");
	this.qrySet("Alias", "p");
	//this.subTie("clrelclcl", "rel", "fwid_cl", "wp.fwid_cl");
}

function menuInit(ds)
{
	if(!list.tbl.IsEmpty())
	{
		ds = list.dataSrc;	
		ds.AddMenuItem("OTPPRK", "Друк вiдпускних|Печать отпускных",9);
	    //ds.AddMenuItem("OTPPRN", "Друк вiдпускних|Печать отпускных",9);
	    ds.AddMenuItem("OTPPRNMASS", "Друк вiдпускних списком|Печать отпускных списком",9);
	    ds.AddMenuItem("OTP_SK", "СК:Друк вiдпускних|СК:Печать отпускных",9);
    	ds.AddMenuItem("", "");
    	//ds.AddMenuItem("LISTOP","Виконати спискову операцію|Выполнить списковую операцию");
	    //ds.AddMenuItem("OTPPRNLST", "Друк вiдпускних списком|Печать отпускных списком",9);
		ds.AddMenuItem("ISSHPZ","Масово проставити ШВЗ|Массово проставить ШПЗ");
		ds.AddMenuItem("ISSHP2","Перевірка ШВЗ|Проверка ШПЗ");
//		ds.AddMenuItem("MOVENVK","Проставити ознаку наявності та календарні дні неявок у табелі|Проставить признак наличия и календарные дни неявок в табеле");
//		ds.AddMenuItem("SETWRKDAYS","Проставити календар і кількість робочих днів|Проставить календарь и количество рабочих дней");						    	
		ds.AddMenuItem("", "");
	}
}

function prkDel()
{
	//listDel в l_prkekz.js сам обработает удаление приказа
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
	var srcTbl = "^lnkprktbl"
	if (IsTableEx("zrp_mdb", "ZRP_LNKPRKTBLNVK"))
	{
		srcTbl = "^lnkprktblnvk"
	}
	
	//Tori 26.09.2011: пока оставим для удаления уже заведенных неявок, но в будущем этот код можно будет убрать
	var snap = getSnap("select Ftag,Fnvk,Fbdat from "+srcTbl+" where Fid_prk="+list.tbl.getValue("Fwid"));
	if(snap)
	{
		ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(list.tbl.getValue("Fbdat"),list.tbl.getValue("Fedat"))
				+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+list.tbl.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
		ExecuteSQL("delete from "+srcTbl+" where Fid_prk="+list.tbl.getValue("Fwid"));
	}
}

function prkMassDel()
{
	//Tori 26.09.2011: пока оставим для удаления уже заведенных неявок, но в будущем этот код можно будет убрать
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей
	var t = OpenTable("select * from ^prk_all where Fwid "+list.dataSrc.sqlSelected(true));
	if(t.rowCount>0)
	{
		for(; !t.IsEOF(); t.MoveNext())
		{
			//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
			var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			if(snap)
			{
				ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
						+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
				ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			}
		}
	}
	t.close();
}