include("l_eprkekz.js");
include("Objects/DpCl.js");

var codtarif, dpShtat2;

function prkLoad()
{	
	HPROC.setMask("-######.##");
	HCHAS.setMask("###.##");
	HNORMA_CH.setMask("###.##");
	HOKLAD.setMask("######.##");
	HNOM_PRIK.setMask(strRepl("&", 15));
	HSHPZ.setMask("&&&&&&&&&&&&&&&");

    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null)
      zat = allt(String(Osn2[0]));
    else
      zat = "0";

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);	

	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	
	dpShtat2 = new DpShtat(null, extPar.dat1, extPar.dat2);
	dpShtat2.linkCtrl("fcod", COD2);
	dpShtat2.linkCtrl("wcl.ftxt", TXT2);
	dpShtat2.linkCtrl("d.foklad", HOKLAD);
	
	setValid(HVOPL,slctValid);
	setValid(HNORMA_CH,norma_chValid);
	
	switch (extPar.mode)
	{
		case "ADD":
			HBDAT.value = extPar.dat1;
			HEDAT.value = extPar.dat2;			
			HPROC.value = 100;
			//HNOM_PRIK.value = 0;
			HDAT_PRIK.value = d00;
			HCHAS.value = 0;
			HVOPL.value = Number(ReadParEx("PRK57_SLCT_TYPE"));
		break;
		case "EDIT": 
		case "COPY":
			HBDAT.value 	= table.getValue("fbdat");
			HEDAT.value 	= table.getValue("fedat");
			HPROC.value 	= table.getValue("fproc");
			HNOM_PRIK.value = table.getValue("fnom_prik");
			HDAT_PRIK.value = table.getValue("fdat_prik");
			HCHAS.value		= table.getValue("fchas");
			HNORMA_CH.value = table.getValue("fnorma_ch");
			HVOPL.value	= Number(table.getValue("fvopl"));
			if (dpShtat2 != null && !Number(dpShtat2.getFwid()))
		 	{
				dpShtat2.setPeriod(table.getValue("fbdat"), table.getValue("fedat"));
				dpShtat2.setFwid(table.getValue("fwid_wp2")); 
            }
		break;
	}
	slctValid();
	setFocus(COD);
}

function prkSave(m, n)
{
	m.FVID_PRK 	= extPar.fvid;
	m.FBDAT 	= HBDAT.value;
	m.FEDAT 	= HEDAT.value;
	m.FPROC 	= HPROC.value;
	m.FNOM_PRIK = HNOM_PRIK.value;
	m.FDAT_PRIK = HDAT_PRIK.value;
	//m.FSUM 		= HSUM.value;
	m.FCHAS		= HCHAS.value;
	m.FNORMA_CH = HNORMA_CH.value;
	m.FVOPL	= Number(HVOPL.value);
	
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;	
	m.FWID_WP 	= dpShtat.getFwid();
	m.FTABN_ID  = dpShtat.getEmployeFwid();
	m.FWID_WP2 	= dpShtat2.getFwid();
	m.FTABN_ID2 = dpShtat2.getEmployeFwid();
	WriteParEx("PRK57_SLCT_TYPE",HVOPL.value);
}

function slctValid()
{
	if(HVOPL.value == 0 || HVOPL.value == 3)
	{
		Enable(HCHAS);
		if(HVOPL.value == 3)
			Enable(HNORMA_CH);
		else
		{
			Disable(HNORMA_CH);
			HNORMA_CH.value = 0;
		}
	}
	else
	{
		Disable(HCHAS);
		Disable(HNORMA_CH);
		HCHAS.value = 0;
		HNORMA_CH.value = 0;
	}
}

function norma_chValid()
{
	if(HNORMA_CH.value == 0)
	{
		WAIT(ru("Норма часов не может быть нулевой!","Норма годин не може бути нульовою!"));
		return false;
	}
	if(HNORMA_CH.value < HCHAS.value)
	{
		WAIT(ru("Норма часов не может быть меньше отработанных часов!","Норма годин не може бути меншою за відпрацьовані години!"));
		return false;
	}
	return true;
}