function prkLoad()
{
	gd = new DpGetDat("dD");
	if (!gd.dat1 || !gd.dat2)
		return false;
}

function prkSrc()
{		
	DATB.value = gd.dat1;
	DATE.value = gd.dat2;
	
	var tblName = "^PRK_ALL";
	var sWhere = " p.fvid_prk = " + sqlTo(extPar.fvid) 
	 	+ " AND ((p.fbdat<=" + sqlTo(gd.dat1) + " AND p.fedat>=" + sqlTo(gd.dat2) + ")"
		+ " OR (p.fbdat>=" + sqlTo(gd.dat1) + " AND p.fbdat<=" + sqlTo(gd.dat2) + ")"
		+ " OR (p.fedat>=" + sqlTo(gd.dat1) + " AND p.fedat<=" + sqlTo(gd.dat2) + "))"
		
	var sOrder = "";
	if (IsSORT)
		sOrder = "c.fcod, p.fbdat, p.fedat";
		
	this.qrySet("Fields", "p.*, w.Fwid_cl, c.Fcod", "From", GLOBAL_TABLE+" AS p INNER JOIN ^work_pers AS w ON p.Fwid_wp=w.Fwid"
					+ " INNER JOIN ^clrelclcl AS c ON w.Fwid_cl=c.Fwid_cl", 
				"Where", sWhere,
				"Order", sOrder);

	this.subTie("work_pers","wp","fwid","fwid_wp");
	this.subTie("cl", "cl", "fwid", "fwid_cl");
	this.qrySet("Alias", "p");
	//this.subTie("clrelclcl", "rel", "fwid_cl", "wp.fwid_cl");	
}

function menuInit(ds)
{
	ds = list.dataSrc;	
	ds.AddMenuItem("NEWDAT","Перезапис наказів|Перезапись приказов");
	ds.AddMenuItem("LISTOP","Виконати спискову операцію|Выполнить списковую операцию");
	ds.AddMenuItem("SET_NUM_ZVK", "Проставити № заявки на оплату соцстрахом|Проставить № заявки на оплату соцстрахом");
	ds.AddMenuItem("", "");
	ds.AddMenuItem("BOLPRK", "Розр.лiкарн.по-середньому|Расчет больн.по-среднему");
	ds.AddMenuItem("BOLSVM", "Розр.лiкарн.для сумiсникiв|Расчет больн.для совмест.");
	ds.AddMenuItem("BOLPRN", "Друк лiкарняного|Печать больничного");
	//ds.AddMenuItem("BOLREESPRK", "Розрахунок лiкарняних списком|Расчет больничных списком");
	ds.AddMenuItem("BOLREESPRN", "Розрахунок лiкарняних списком|Расчет больничных списком");
	ds.AddMenuItem("BOL_SK", " СК:Розрахунок лiкарняних(деталізовані)|СК:Расчет больничных(детализированные)");	
	ds.AddMenuItem("ISSHPZ","Масово проставити ШВЗ|Массово проставить ШПЗ");	
	ds.AddMenuItem("ISSHP2","Перевірка ШВЗ|Проверка ШПЗ");	
	ds.AddMenuItem("MOVENVB","Проставити ознаку наявності такалендарні дні неявок у табелі|Проставить признак наличия и календарные дни неявок в табеле");	
	ds.AddMenuItem("", "");
}

function prkDel()
{
	//listDel в l_prkekz.js сам обработает удаление приказа
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
	var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+list.tbl.getValue("Fwid"));
	if(snap)
	{
		ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(list.tbl.getValue("Fbdat"),list.tbl.getValue("Fedat"))
				+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+list.tbl.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
		ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+list.tbl.getValue("Fwid"));
	}
}

function prkMassDel()
{
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей
	var t = OpenTable("select * from ^prk_all where Fwid "+list.dataSrc.sqlSelected(true));
	if(t.rowCount>0)
	{
		for(; !t.IsEOF(); t.MoveNext())
		{
			//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
			var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			if(snap)
			{
				ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
						+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
				ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			}
		}
	}
	t.close();
}