//отличается от _SR текстовками, наличием календаря и автоматическим проставлением кол-ва рабочих дней
include("l_eprkekz.js");

function prkLoad()
{
	HSUM.setMask("######.##");
	HDN.setMask("###");
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
	HCHAS.setMask("###.##");
	
    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }
	
   	dpShtat = new DpShtat(null, null, null);	
 	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);
	
	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);
	
	include("objects/dpCalendar.js");
	oCalend = new dpCalendar();
	if(!extPar.is_clnd)
		oCalend.setMode("0");
	oCalend.linkCtrl(HCALNUM, HREM, HBDAT, HEDAT, COD, TXT);
	
	switch (extPar.mode)
	{
		case "ADD":
         	//HBDAT.value = extPar.dat1;
         	//HEDAT.value = extPar.dat2;
         	HDAT_BOL.value = d00;
         	HMES_VIP.value = d00;
         	HSUM.value  = 100;
         	HDN.value  = 0;
         	HCHAS.value  = 0;
		break;
		case "EDIT":
		case "COPY":
		case "VIEW":
            HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");
			HSUM.value = table.getValue("fproc");
			HDAT_BOL.value = table.getValue("fdat_bol");
			HMES_VIP.value = table.getValue("fmes_vip");
			HDN.value = Number(Math.floor(Number(table.getValue("fsum"))/1000));			
			HCHAS.value = Number(table.getValue("fsum") - (Math.floor(Number(table.getValue("fsum"))/1000)) * 1000);
			if(table.getValue("fcalnum")!=null)
				oCalend.setCod(table.getValue("fcalnum"));
		break;	
	}
	useDefValid = false;
	setValid(HEDAT,edat_Valid);
	setWhen(HDAT_BOL,dat_bol_When);
	setWhen(HCALNUM,calnum_When);
	setWhen(HDN, dn_When);
	setFocus(COD);
}
function prkSave(m)
{
	m.FVID_PRK = extPar.fvid;
	m.FBDAT = HBDAT.value;
	m.FEDAT = HEDAT.value;	
	m.FDAT_BOL = HDAT_BOL.value;
	m.FMES_VIP = HMES_VIP.value;
	m.FSUM	= Number(Number(HDN.value) * 1000 + Number(HCHAS.value));	
	m.FPROC = HSUM.value;
	m.FWID_WP = dpShtat.getFwid();
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;
	m.FTABN_ID = dpShtat.getEmployeFwid();
	m.FCALNUM = HCALNUM.value;
}

function edat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if (differ(HEDAT.value, HBDAT.value) == -1)
	{
		WAIT(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	return true;
}

function dat_bol_When()
{
	if (differ(HDAT_BOL.value, d00obj) == 0)
	{
		HDAT_BOL.value = HBDAT.value;
	}
	return true;
}

function calnum_When()
{
	if(HCALNUM.value == 0)
	{
		if(dpShtat.getCalend()>0)
			oCalend.setCod(dpShtat.getCalend());
		else
		{
			//если календарь один, то выбираем его
			var snap = getSnap("select count(*) as Fcnt, min(Fcod) as Fcod from ^cl_calend");
			if(snap && snap[0]==1)
				oCalend.setCod(snap[1]);
		}
	}
	return true;
}

function dn_When()
{
	if(HDN.value == 0 && HCHAS.value ==0 && oCalend.getCod()>0)
		HDN.value = oCalend.getCalDays("Р", HBDAT.value, HEDAT.value);
	return true;
}