//отдельный расчет, который переносит суммы больничных за счет соцстраха и декретные из основных лицевых счетов
//по соответствующему признаку вхождения в фонд оплаты труда из настроек полей ЛС

function name_blnsoc()
{
	return "Окремий розрахунок лікарняних за рахунок с/с (перенесення сум з основних ОР)|Отдельный расчет больничных за счет с/с (перенос сумм из основных ЛС)";
}

function r_blnsoc(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	if(!svzpName)
	{
		var msg = "Процедура _blnsoc предназначена только для отдельных расчетов и не должен включаться в основной расчет зарплаты!"
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	var szTag = getDateTag(month);
	var sqlTabn = ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"";
	if (IsTableEx("zrp_res", "zrp_svzp"+szTag))
	{
		ExecuteSQL("insert into ^"+svzpName+szTag+" ("+GetPatternIntersection("SVZP","SVZP").replace(/(fwid\s*,)|(\s*fwid\W)/gi,"")+") "
				+" select "+GetPatternIntersection("SVZP","SVZP","s").replace(/(s.fwid\s*,)|(\s*s.fwid\W)/gi,"")
				+" from ^svzp"+szTag+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
				+" where l.Ffzp in ('б','&')"+sqlTabn+" AND NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(month)+")");
	}
	else
	{
 	  	var msg = "Основные лицевые счета еще не расчитаны за "+format("Mmm yyyy",month).toLowerCase();
      	writeToLog(msg,"w",vopl,vidprk,lsfid);
      	return false;
	}
}