//отдельный расчет, который переносит суммы ЕСВ и подоходного налога с больничных за счет соцстраха и декретные из основных лицевых счетов
//коды справочных полей определяем по переданным полям в родных процедурах расчета

function name_blnsocuder()
{
	return "Окремий розрахунок податків з лікарняних за рахунок с/с (перенесення сум з основних ОР)|Отдельный расчет налогов с больничных за счет с/с (перенос сумм из основных ЛС)";
}

function r_blnsocuder(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	if(!svzpName)
	{
		var msg = "Процедура _blnsocuder предназначена только для отдельных расчетов и не должен включаться в основной расчет зарплаты!"
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	var lsidEsvBaseSoc,lsidEsvSoc,lsidNlgSoc,lsidEsvBase,lsidEsv,lsidNlg;
	var snap = getSnap("select v.Flsfid, v.Flsfid2 from ^cl_prik as p inner join ^cl_vopl as v on p.Fvid=v.Fpr "
					+" where v.Fis_slct="+sqlTrue+" and v.Fbdat<="+sqlTo(lastDayMonth(month))
						+" and v.Fedat>="+sqlTo(month)+" and LOWER(p.Fproc)='_edvn'");
	if(snap && snap[0])
	{
		lsidEsvSoc = snap[0];
		lsidEsvBaseSoc = snap[1];
	}
	else
	{
		var msg = "Hельзя идентиф.поле ЛС: ЕСВ больн.СС (первое поле ЛС в расчете удержаний ЕСВ)";
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	var snap = getSnap("select v.Flsfid, v.Flsfid2 from ^cl_prik as p inner join ^cl_vopl as v on p.Fvid=v.Fpr "
					+" where v.Fis_slct="+sqlTrue+" and v.Fbdat<="+sqlTo(lastDayMonth(month))
						+" and v.Fedat>="+sqlTo(month)+" and LOWER(p.Fproc) like '_nlgn%'");
	if(snap && snap[0])
	{
		lsidNlgSoc = snap[0];
	}
	else
	{
		var msg = "Hельзя идентиф.поле ЛС: подоходного налога за счет с/с (первое поле ЛС в расчете подоходного налога)";
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	snap = getSnap("SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='6' AND fis_slct=" + sqlTrue);
	if(snap && snap[0])
	{
		lsidEsvBase = snap[0]
	}
	else
	{
		var msg = "Hельзя идентиф.поле ЛС: база ед.взноса с больн."
		writeToLog(msg,"e",vopl,vidprk,lsfid); 
		return false;
	}
	snap = getSnap("SELECT fid, ffld_num FROM ^lic_fld WHERE fis8='6' AND fis_slct=" + sqlTrue);
	if(snap && snap[0])
	{
		lsidEsv = snap[0]
	}
	else
	{
		var msg = "Hельзя идентиф.поле ЛС: ед.взнос с больн."
		writeToLog(msg,"e",vopl,vidprk,lsfid);
		return false;
	}
	snap = getSnap("SELECT DISTINCT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='п' and FIS_SLCT="+sqlTrue+" ORDER BY Ffld_num");
	if (snap && snap[0])
	{
  		lsidNlg = snap[0];     
	}
	else
	{
 	  	var msg = "Hевозможно идентифицировать поле ЛС: подоходн. налог.";
      	writeToLog(msg,"e",vopl,vidprk,lsfid);
      	return false;
	}
	var szTag = getDateTag(month);
	var flds1 = GetPatternIntersection("SVZP","SVZP").replace(/(fwid\s*,)|(\s*fwid\W)|(flsfid\s*,)|(\s*flsfid\W)|(ffld_num\s*,)|(\s*ffld_num\W)/gi,"");
	var flds2 = GetPatternIntersection("SVZP","SVZP","s").replace(/(s.fwid\s*,)|(\s*s.fwid\W)|(s.flsfid\s*,)|(\s*s.flsfid\W)|(s.ffld_num\s*,)|(\s*s.ffld_num\W)/gi,"");
	var sqlTabn = ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"";
	if (IsTableEx("zrp_res", "zrp_svzp"+szTag))
	{
		//база ЕСВ
		ExecuteSQL("insert into ^"+svzpName+szTag+" ("+flds1+",Flsfid,Ffld_num) "
				+" select "+flds2+","+lsidEsvBase+" as Flsfid,"+getLsNum(lsidEsvBase)+" as Ffld_num"
				+" from ^svzp"+szTag+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
				+" where s.Flsfid="+lsidEsvBaseSoc+sqlTabn+" AND NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(month)+")");
		//ЕСВ
		ExecuteSQL("insert into ^"+svzpName+szTag+" ("+flds1+",Flsfid,Ffld_num) "
				+" select "+flds2+","+lsidEsv+" as Flsfid,"+getLsNum(lsidEsv)+" as Ffld_num"
				+" from ^svzp"+szTag+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
				+" where s.Flsfid="+lsidEsvSoc+sqlTabn+" AND NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(month)+")");
		//подоходный налога
		ExecuteSQL("insert into ^"+svzpName+szTag+" ("+flds1+",Flsfid,Ffld_num) "
				+" select "+flds2+","+lsidNlg+" as Flsfid,"+getLsNum(lsidNlg)+" as Ffld_num"
				+" from ^svzp"+szTag+" as s inner join ^lic_fld as l on s.Flsfid=l.Fid "
				+" where s.Flsfid="+lsidNlgSoc+sqlTabn+" AND NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(month)+")");
	}
	else
	{
 	  	var msg = "Основные лицевые счета еще не расчитаны за "+format("Mmm yyyy",month).toLowerCase();
      	writeToLog(msg,"w",vopl,vidprk,lsfid);
      	return false;
	}
}