//для ЧеркассыТрансгаз переделанная программа из r_na_ud для долгосрочных страховок по "Блак. полiсу". Она в приказе смотрит
// на дату приказа, в которую пишется месяц, за который выплачивается страховка, если эата дата пустая - то текущий месяц
//потом в ЛС пишутся суммы страховки с этими датами и в этой программе добавлен кусок расчета подоходног налога, который
// перерасчитывает сумму подоходного налога за месяцы выплаты страховки без запуска перерасчета за эти месяцы. 
//настройка как в r_na_ud. Только в справочник констант нужно добавить константу codnstr - код поля для выведения суммы
//необлагаемой страховки. При расчете подоходного налога считаем, что в SVZP прописаны суммы по перерасчету из DLT, поэтому
//отдельно добавляем суммы только из DLTU (так ббыстрее будет считать)
// //сумма из приказа пишется одновременно в начисления и удержания с прописыванием из приказа даты, за какой месяц эта сумма
// потом не делается перерасчет, а внутри расчета анализируется сумма подох.налога 
// передаются ДАТА расчета - для использования нужных временных файлов
// vvopl - вид оплаты
// № поля как считать (например, Оклад,совместители), куда передается результат ffld  VVDPL
// код поля ЛС flsfid  VVCSLID 

function r_na_udt (mdat,vvopl,vvprk,mvvcslid,VVLSFID2,ftabn_id,svzpName)
{
	//первая часть для занесения сумм по блакитной магитсрали в SVZP
	
	var Aflsfid= new Array(mvvcslid,VVLSFID2);
	var table,szTag,szName,tblOut,i;
   // достаем цифры к названию файла
      if(mdat.getMonth() < 9)  
         szTag = String(mdat.getFullYear())+"0"+String(mdat.getMonth()+1);
      else
         szTag = String(mdat.getFullYear())+String(mdat.getMonth()+1);        

   // дата начала
    var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1) 
   
   // дата конца
    //var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
    var D2 = lastDayMonth(mdat); 
    
    //if(!IsTableEx("zrp_mdb", "zrp_prk1"))       return;

   // Проверяем существует ли у нас таблица "svzp" + szTag, если нет, то создаем ее
   // по шаблону "svzp"
    tblOut = "zrp_" + ""+(svzpName?svzpName:"svzp") + szTag
    var tblsvzp = "^"+(svzpName?svzpName:"svzp") + szTag    
    if(!IsTableEx("zrp_res", tblOut))  CreateTableEx("zrp_res", tblOut, "svzp", "*")
    CreateTable("t_naud_svzp", "svzp", "*");
    var sqlTabn = ftabn_id?" and A.Ftabn_id in ("+ftabn_id+") ":"";
	for(i=0;i<Aflsfid.length;i++)
	{
		if (Aflsfid[i]!=VVLSFID2)
			strlsfid = "a.fwid_wp"
		else	
			strlsfid = "0"
			
		ExecuteSQL("DELETE FROM t_naud_svzp")
		StrSQL="INSERT INTO t_naud_svzp (Ftabn_id,fwid_wp,FSHPZ,FSUM,FLSFID,FIS_DAY,FDAY,FVP,FMN,FID_PRK,FVID_PRK)"
			+" SELECT W.FWID_CL,"+strlsfid+" as fwid_wp,A.FSHPZ,A.FSUM"
			+","+Aflsfid[i]+" AS FLSFID,0 AS FIS_DAY"
			+",0 AS FDAY,2 AS FVP, FDAT_PRIK AS FMN,A.FWID AS FID_PRK"
			+","+vvprk+" AS FVID_PRK"
			+" FROM ^PRK_ALL AS A INNER JOIN ^WORK_PERS AS W ON W.FWID=A.FWID_WP"
			+" WHERE A.FVID_PRK = " + sqlTo(vvprk)
			+sqlTabn
			+" AND A.FBDAT <= " + sqlTo(D2) + " AND A.FEDAT >= " + sqlTo(D1);
		//	+" AND w.Fwid_cl>0";
		StrSQL+=(vvopl<9000)?" AND W.FVOPL = " + sqlTo(vvopl):"";
		if(Aflsfid[i]>0) ExecuteSQL(StrSQL);

		StrSQL="UPDATE t_naud_svzp "
				+" SET FFLD_NUM= (SELECT FFLD_NUM FROM ^LIC_FLD B WHERE t_naud_svzp.FLSFID=B.FID ) "
				+" WHERE EXISTS (SELECT FFLD_NUM FROM ^LIC_FLD B WHERE t_naud_svzp.FLSFID=B.FID )";
		ExecuteSQL(StrSQL);

		StrSQL="UPDATE t_naud_svzp "
				+" SET FVP=0, FMN="+sqlTo(d00)+" where FMN="+sqlTo(mdat);				
		ExecuteSQL(StrSQL);
		
		StrSQL="INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (Ftabn_id,fwid_wp,FSHPZ,FSUM,FLSFID,FIS_DAY,FDAY,FVP,FMN,FID_PRK,FVID_PRK)" 
			+" SELECT Ftabn_id,fwid_wp,FSHPZ,FSUM,FLSFID,FIS_DAY,FDAY,FVP,FMN,FID_PRK,FVID_PRK"
			+" FROM t_naud_svzp"
		ExecuteSQL(StrSQL);
	}

	//вторая часть - вычисление подоходного налога для балкитной магистрали по перерасчету	
	//код поля для подоходного налога берем по букве, поле для блак,маг,из настройки перечня расчетов "поле 1", код поля
	//для необл, страховки из справочника констант

	var VVLSFIDM = get_cnst("codnstr", mdat)
	
    strSQL = "select * from ^LIC_FLD where Fid="+sqlTo(VVLSFIDM);
    //var tvdpl2 = OpenTable("s", strSQL);
    var gS = getSnap("select Ffld_num from ^LIC_FLD where Fid="+sqlTo(VVLSFIDM));
    var vdpl2 = 0; 
    if (gS != null)
    {
       var vdpl2 = gS[0];
    }
    
	strSQL = "SELECT DISTINCT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='п' and FIS_SLCT="+sqlTrue;
	snap = getSnap(strSQL);
	if(snap==null)
//	if (!Lic_table.FindFirst("Fis1='п'"))
   {
  		var msg_ru= "Ошибка настройки системы.\n"
      		+"Hевозможно идентифицировать поле ЛС: подоходн. налог.\n"
      		+"Укажите нужное поле в настройке полей ЛС или обратитесь к специалисту для устранения" +
      				"расчет налога не производится";
  		var msg_ua= "Помилка налаштування системи.\n"
      		+"Hежливо ідентіфікувати поле особового рахунку: прибутковий податок.\n"
      		+"Вкажіть потрібне поле в налаштуванні полів особових рахунків або зверніться до спеціаліста" +
      				"розрахунок податку не виконано";
      	msg = ru( msg_ua, msg_ua);
      	writeToLog(msg,"e",vvopl,vvprk,mvvcslid);      
      	return;  // если нет поля куда писать налог - дальнейший расчет не имеет смысла - поэтому закончить работу процедуры
	}

   var nach_lsfi1 = snap[0]//Lic_table.getValue("Fid")
   var nach_lsnu1 = snap[1]//Lic_table.getValue("Ffld_num")
    
    CreateTable("t_nu_svzp", "svzp", "*")

	//добавляем  во временный файл записи по бакитной магистрали не по текущим суммам   
	ExecuteSQL("DELETE FROM t_nu_svzp")
	StrSQL="INSERT INTO t_nu_svzp (Ftabn_id,fwid_wp,FSHPZ,FSUM,FLSFID,FIS_DAY,FDAY,FVP,FMN,FID_PRK,FVID_PRK)"
			+" SELECT W.FWID_CL, 0 as fwid_wp,A.FSHPZ,A.FSUM"
			+","+mvvcslid+" AS FLSFID,0 AS FIS_DAY"
			+",0 AS FDAY,0 AS FVP, FDAT_PRIK AS FMN,A.FWID AS FID_PRK"
			+","+vvprk+" AS FVID_PRK"
			+" FROM ^PRK_ALL AS A INNER JOIN ^WORK_PERS AS W ON W.FWID=A.FWID_WP"
			+" WHERE A.FVID_PRK = " + sqlTo(vvprk)
			+sqlTabn
			+" AND A.FBDAT <= " + sqlTo(D2) + " AND A.FEDAT >= " + sqlTo(D1);
		//	+" AND w.Fwid_cl>0";
	StrSQL+=(vvopl<9000)?" AND W.FVOPL = " + sqlTo(vvopl):"";
	ExecuteSQL(StrSQL);
	
	
	//во временный файл в цикле выбирать суммы из лицевых счетов по конкретному человеку и выбирать за период
	// от месяца возникновения до базового месяца по DLT и DLTU и добавлять во временную таблицу с данными
	// из ЛС суммы перерасчета. Затем пускать расчет подоходного налога (взять алгоритм из расчета под.налога)
	// получить сумму подоходного налога с учетов блактиной магистрали и сумму необлагаемой страховки, сравнить
	// с ранее начисленной суммой под.налога и разицу записать в расчетный базовый SVZP. 
	
	strSQL = "select distinct Ftabn_id, Fmn from t_nu_svzp where Fmn<>"+sqlTo(mdat)+" order by Ftabn_id, Fmn"
	var xprk = OpenTable("s", strSQL);
	if (!xprk.IsEmpty()){
		
		xprk.MoveFirst();
		while (!xprk.IsEOF()){
		    if(new Date(xprk.getValue("Fmn")).getMonth() < 9)  
   				__yearz = String(new Date(xprk.getValue("Fmn")).getFullYear())+"0"+String(new Date(xprk.getValue("Fmn")).getMonth()+1);
			else
   				__yearz = String(new Date(xprk.getValue("Fmn")).getFullYear())+String(new Date(xprk.getValue("Fmn")).getMonth()+1);
   				
    		DropTable("VRSVZP"+__yearz)
    		   				
		    var xfilezp= (svzpName?svzpName:"svzp")+__yearz
	    			
    		if(IsTableEx("zrp_res", "zrp_"+xfilezp)){		  
    			//выбрать для конкретного табельного номера лицевой счет
    			//отсекаем записи по перерасчетам, чтобы давжды их не учесть. Идем по DLT на всякий случай, вдруг в SVZP
    			//записи по перерасчету кто-то удалил. Можно сделать наоборот, считать, что в SVZP есть записи по перерасчету из dlt
    			// И ДОБАВЛЯТЬ ТОЛЬКО ИЗ dltu
    			//!!!!!!!!!!!исправить убрать будущие суммы из рассмотрения (только текущие и перерасчет)
    			//strSQL = "select * into VRSVZP from ^"+xfilezp+" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")))+" and not (Fvp=1 and Fmn>"+sqlTo(new Date(xprk.getValue("Fmn")))+")";
    			//strSQL = "select * into VRSVZP from ^"+xfilezp+" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")));
    			//08.06.08 Оставила вариант, когда считаем, что в SVZP есть суммы по перерасчету
    			strSQL = "select * into VRSVZP"+__yearz+ " from ^"+xfilezp+" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")))+" and (Fvp=0 or (Fvp=1 and Fmn>"+sqlTo(new Date(xprk.getValue("Fmn")))+"))";    			     			
    			ExecuteSQL(strSQL)

   				//добавить в ЛС записи по блакитной магистрали за соответствующий месяц
				strSQL = "insert into VRSVZP"+__yearz+" (Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy) select Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy from t_nu_svzp"+
							" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")))+ " and Fmn="+sqlTo(new Date(xprk.getValue("Fmn")))
   				ExecuteSQL(strSQL)   				   
				//количество месяцев,за которые нужно искать суммы перерасчетов, чтобы добавлять в ЛС за месяц Fmn
				kmes = round((mdat-xprk.getValue("Fmn"))/30.4367, 0)-1
				if (kmes>=1){
						/*
		   				i = 1
   						dat_per = new Date(xprk.getValue("Fmn"))
   						for (i=1;i<=kmes; i++){
      						month_per = new Date(dat_per.getFullYear(),dat_per.getMonth()+1,1)   					
						    if(dat_per.getMonth() < 9)  
         						__year = String(dat_per.getFullYear())+"0"+String(dat_per.getMonth()+1);
	      					else
    	     					__year = String(dat_per.getFullYear())+String(dat_per.getMonth()+1);        
			      			var xfile= "DLT"+__year
		    	  		
    						if(IsTableEx("zrp_mdb", "zrp_"+xfile)){
								strSQL = "insert into VRSVZP"+__yearz+" (Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Ffld_num,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy) select Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Ffld_num,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy from ^"+xfile+
										" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")))+ " and Fmn="+sqlTo(new Date(xprk.getValue("Fmn")))
								ExecuteSQL(strSQL)    						
	    					}			      		
    	  					dat_per = month_per        		
      					}
      					*/
	   				i = 1
   					dat_per = new Date(xprk.getValue("Fmn"))
   					for (i=1;i<=kmes; i++){
    					month_per = new Date(dat_per.getFullYear(),dat_per.getMonth()+1,1)   					
					    if(dat_per.getMonth() < 9)  
       						__year = String(dat_per.getFullYear())+"0"+String(dat_per.getMonth()+1);
	   					else
         					__year = String(dat_per.getFullYear())+String(dat_per.getMonth()+1);        
		      			var xfile= "DLTU"+__year
		    	  		
    					if(IsTableEx("zrp_mdb", "zrp_"+xfile)){
							strSQL = "insert into VRSVZP"+__yearz+" (Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy) select Ftabn_id, Fwid_wp,Fsum,Fmn,Fvp,Fday,Fchas,Flsfid,Fid_prk,Fis_day,Fshpz,Fbdy,Fedy from ^"+xfile+
									" where Ftabn_id="+sqlTo(Number(xprk.getValue("Ftabn_id")))+ " and Fmn="+sqlTo(new Date(xprk.getValue("Fmn")))
							ExecuteSQL(strSQL)    						
	   					}			      		
      					dat_per = month_per        		
    				}
				}
				
				
				//добавили все перерасчетные записи, теперь нужно рассчитать необлагаемую сумму страховки для подоходного налога
				//считаем, что страхуют только основных сотрудник
   				minnal = get_cnst ("minnal" , new Date(xprk.getValue("Fmn")))
   				// необлаг.процент по страховке за счет предприятия
   				procsl = get_cnst ("procsl", new Date(xprk.getValue("Fmn")))
   				//процент налога будет брать из константы для налога совм, т,к, проценты сейчас совпадают
   				var proc_s  = get_cnst ("proc_s ", mdat)					
				var ssumdox = 0
			    var ssumsn = 0
			    var ssumso = 0
   				//var uderg_nlg = 0				    
   				
    			var xsvzp = OpenTable("s", "VRSVZP"+__yearz);				    
    			if (!xsvzp.IsEmpty()){				    
				    xsvzp.MoveFirst();
   					var pFtabn    = Number(xsvzp.getValue("Ftabn_id"));
				    while(!xsvzp.IsEOF())
   					{ 
				         mFsum   = Number(xsvzp.getValue("Fsum"))
         				 mFlsfid = xsvzp.getValue("Flsfid")
           
         				 //* проверка входимости в налогооблагаемую сумму
						 strSQL = "SELECT Fis1,Fis5,Fis16,Fis9,Fis26 FROM ^LIC_FLD WHERE Fid="+sqlTo(mFlsfid);
						 gS = getSnap(strSQL);
						 if(gS == null)
						 {
							msg = "Ссылка на неизвестное поле лицевого счета "+String(mFlsfid)+". Пригласите разработчиков для устранения";
							writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
							xprk.close();
							xsvzp.close();
							return;
						 }
				         //* пpизнак входимости в налогооблагаемую сумму определяется по первой
         				 //* колонке (Fis1) файла LIC_FLD
         
				         var fld_mrk  = gS[0]//Lic_table.getValue("Fis1");
         				 var fld_mrk1 = gS[1]//Lic_table.getValue("Fis5");
         				 var fld_mrk2 = gS[2]//Lic_table.getValue("Fis16");
         				 var fld_mrk3 = gS[3]//Lic_table.getValue("Fis9");
         				 var fld_mrk4 = gS[4]//Lic_table.getValue("Fis26");
         				 
			            //* сумма общего дохода
            			ssumdox = (fld_mrk4=="+")? ssumdox + mFsum: ssumdox 
            			//* сумма страховки без учета для льготы
	    				ssumsn = (fld_mrk3=="+")? ssumsn + mFsum:  ssumsn
            			//* сумма страховки c учетом для льготы
	    				//ssumso = (fld_mrk3=="#")? ssumso + mFsum:  ssumso
            			//uderg_nlg = (fld_mrk1=="п")? uderg_nlg + mFsum: uderg_nlg			    				

         			    xsvzp.MoveNext();
      				}
      				xsvzp.close();
			        //*-------- страховка
         			//сумма необлагаемой страховки
         			var ssum_stro = 0;         			
         			var sum_lg = (round(ssumdox*procsl/100,2)>minnal)?minnal:round(ssumdox*procsl/100,2);
         			var ssum_strn = (ssumsn-sum_lg>0)?(ssumsn-sum_lg):0;
         			//var ssum_stro = (ssumso-sum_lg>0)?(ssumso-sum_lg):0;
					//результаты пишем прямо в наш расчетный SVZP
			        //необл.сумма страховки в лицевые счета
			          
         			if (VVLSFIDM!=0)
         			{  
         				c4sum = 0;
		                mFmn = d00obj.getVarDate()
           			    mFvp = 0
            			if ((ssumsn-ssum_strn)+(ssumso-ssum_stro)!=0)
            			{
               				c4sum=(ssumsn-ssum_strn)+(ssumso-ssum_stro);
               			}  
               			//SVZP_table.AddNew();
               			var m = new Object();
               			m.Ftabn_id = pFtabn
               			m.Fwid_wp  = 0               
               			m.Fsum = c4sum
               			m.Flsfid = VVLSFIDM
               			m.Ffld_num = vdpl2
               			m.Fmn = new Date(xprk.getValue("Fmn")).getVarDate()
               			m.Fvp = 2
               			m.Fday = 0
               			m.Fis_day = 2
               			m.Fvid_prk = vvprk
               			m.Favt = false;
               			//SVZP_table.Update()               
               			UpdateTable(tblsvzp,m,true);
            		}
            		//облагаемуб сумму страховки умножаем на 15% и добавляем к сумме подоходного налога
         			var mF_NAL_S = round((ssum_strn+ssum_stro)* proc_s/100,2)
         			
         			if (mF_NAL_S!=0)
         			{  
			           // SVZP_table.AddNew();
			            var m = new Object();
			            m.Ftabn_id = pFtabn
			            m.Fwid_wp  = 0            
			            m.Fsum = mF_NAL_S
			            m.Flsfid = nach_lsfi1
			            m.Ffld_num = nach_lsnu1
               			m.Fmn = new Date(xprk.getValue("Fmn")).getVarDate()
               			m.Fvp = 2
			            m.Fday = 0
			            m.Fis_day = 2
			            m.Fvid_prk = vvprk
            			m.Favt = false;
            			//SVZP_table.Update()      
               			UpdateTable(tblsvzp,m,true);     
         			} 
	         	}
	         	xsvzp.close();
    		}	
			xprk.MoveNext();			
		}
	}
	xprk.close();
    return;
}