//Для Боярки  - копейки при выдаче на карточку, без копеек - при выдаче через ведомость
// расчет сумм: "всего начислено","всего удержано","всего к выдаче"
// и аналогичных сумм по месяцам
// отличается от  R_NACHI1  тем, что  "всего к выдаче" округляется до десятков крб.

//подключаем функцию нахождения суммы для постоянных величин
include("get_cnst.js");

function name_nachi2b()
{
	return "Расчет сумм: \"всего начислено\",\"всего удержано\",\"всего к выдаче\"";
}

function r_nachi2b(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	//----------------------------------------------------------------------------------------------------------
	var is_rasch = 0==differ(base_month, month);
	//----------------------------------------------------------------------------------------------------------
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(lastDayMonth(month));
	//D2.setDate(0);   

	var bez_k=get_cnst("bez_kop", month);
	if (bez_k==0)
		bez_kopeek=false;
	else
	{
		bez_k = Math.pow(10,(bez_k-1));
		bez_kopeek = true;
	}  
 
    var fis_cpr = true;
	if(!IsTableEx("zrp_mdb", "zrp_prk_c_pr"))
		fis_cpr = true;

//   определение полей "начислено"(по месяцам), "всего начислено",
//   "удержано"(по месяцам), "всего удержано", "фактически выдано",
//   "долг за пpошлое", "на будущее"
	var strSQL = "SELECT fid FROM ^lic_fld WHERE fis6="
	var snap = getSnap(strSQL + sqlTo("н"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС: всего начислено \n"
				+ "       Пригласите разработчиков для устранения        ";
		
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return;
	}
	
	var nach_lsfid = snap[0];
	snap = getSnap(strSQL + sqlTo("у"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС : всего удержано \n"
				+ "       Пригласите разработчиков для устранения        ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var uder_lsfid = snap[0];
	var fvid_found=true;
	snap = getSnap(strSQL + sqlTo("ф"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:фактически выдано\n"
				+ "       Пригласите разработчиков для устранения        ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var vidan_lsfid = snap[0];
	var dolg_found=true;
	snap = getSnap(strSQL + sqlTo("з"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС: задолж.за прошл.\n"
				+ "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var dlgPrv_lsfid = snap[0];
	var dlgb_found=true;
	snap = getSnap(strSQL + sqlTo("б"));
	if(null == snap)
	{
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:задолж.на будущее\n"
				+ "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
		return;
	}

	var dlgNxt_lsfid = snap[0];
	
	//сумма больничного соцстраха выплаченного на руки людям, которую будем минусовать от суммы больничного соцстраха к выдаче 
	var vips_lsfid = 0;
	//сумма больничного соцстраха к выдаче
	var dlgs_found=true;
	snap = getSnap("SELECT fid FROM ^lic_fld WHERE fis12=" + sqlTo("i"));
	if(null == snap)
	{
		var dlgs_found=false;
    	var nach_lsfis = 0;				
		msg=" Обнаружена серьезная ошибка функционирования системы \n"
				+ " Hевозможно идентифицировать поле ЛС:больн.с/с к выдаче\n"
				+ "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"e",vopl, vidprk, lsfid);          
	}
	else
	{
    	var nach_lsfis = snap[0];
    	snap = getSnap("SELECT fid FROM ^lic_fld WHERE fis12=" + sqlTo("q"));
		if(snap)
			vips_lsfid = snap[0];
		else
		{
			msg = " Hевозможно идентифицировать поле ЛС:больн.с/с выплачено\n"
				+ " При наличии этого поля сумма больн.с/с к выдаче будет уменьшена на выплаченную сумму"
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		}
    }	
	
    //выделение отдельных больничных из фонда несч сл
    //ЕСВ с больн по несч сл
    cesvnsl = get_cnst ("nslesv", month)
    //ПН с больн по несч сл
    cnlgnsl = get_cnst ("nslnlg", month)

//**********************
//закачать из файлов DLG и NXT нужные записи
//**********************
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	var dlgTable = "dlg" + szTag;
	var svzpTable = (svzpName?svzpName:"svzp") + szTag;

	if (!IsTableEx("zrp_mdb", "zrp_" + dlgTable))
	{
//		var strPath = getPath("zrp_mdb");
		CreateTableEx("zrp_mdb","zrp_" + dlgTable, "dlg", "*");
	}   

	if (!IsTableEx("zrp_res", "zrp_" + svzpTable))
	{
	//	var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svzpTable, "svzp", "*");
	}      

	if (is_rasch)
	{
		ExecuteSQL("DELETE FROM ^" + dlgTable + " WHERE 1=1 " + sqlTabn); 
	} 

//  закачать записи, содержащие задолженность за прошлые месяцы из
//  файла DLG за предыдущий месяц
    var prevMonth = new Date(month.getFullYear(), month.getMonth()-1, 1);
    var dglPrevTable = "dlg" + (prevMonth.getFullYear())
    						 + ((prevMonth.getMonth()< 9)?"0":"") 
    						 + (prevMonth.getMonth()+1);

	if (IsTableEx("zrp_mdb", "zrp_" + dglPrevTable))
	{
		//11.12.07 Исправила shpz на '', вместо 0, т.к. иначе падал расчет		
		strSQL = "INSERT INTO ^" + svzpTable + "(ffld_num,flsfid,fsum,ftabn_id,fwid_wp,fday,fchas,fpr,fmn,fvp,fid_prk,fis_day,fshpz,fvid_prk,fbdy,fedy)" 
				 + " SELECT ffld_num,flsfid,fsum,ftabn_id,0 as fwid_wp,0 as fday,0 as fchas,0 as fpr,"+sqlTo(d00obj)+" as fmn,0 as Fvp,0 as fid_prk,0 as fis_day,'' as fshpz,0 as fvid_prk,0 as fbdy,0 as fedy "
				 + " FROM ^" + dglPrevTable + " WHERE 1=1 " + sqlTabn;
		//05.10.07	
		//var strFieldsList = GetPatternIntersection("DLG%LD", "SVZP%LD");
		//strSQL = "INSERT INTO ^" + svzpTable + "(" + strFieldsList + ")" 
		//		 + " SELECT " + strFieldsList + " FROM ^" + dglPrevTable;

		ExecuteSQL(strSQL);     
	}
	
	//отбираем виды приказов на карточки
	DropTable("vid_prk_cards");
	ExecuteSQL("select distinct p.Fvid_prk into vid_prk_cards from ^prk_all as p inner join ^prk_c_pr as pr on p.fwid=pr.fwid")              

//  только для базового месяца
//  удаление записей, созданных в базовом месяце по предварительным
//  начислениям и удержаниям
	if (is_rasch)
	{
		strSQL="UPDATE ^NXT SET Fmn=" + sqlTo(d00)
							+ ", Fmn1=" + sqlTo(d00)
				+ " WHERE Fmn=" + sqlTo(month) + sqlTabn;

		ExecuteSQL(strSQL);     
	}
	else
	{
		msg = "Месяц не базовый - расчет 'Всего начислено' не производится";
		writeToLog(msg,"m",vopl, vidprk, lsfid);
		return;
	} 
	
	//var strOffset = IIF("s.fvp=0 OR (s.fvp=2 AND ABS("+Convert(SqlDaysBWDates(sqlTo(D1),'s.fmn')+ "/30","INT")+")=0)", 1, 0);
	/*неправильно работает, берет и перерасчеты за прошлое
	var strOffset = IIF("s.fvp=0"
						,1
						,IIF("s.fvp=2"
						,IIF(sqlTo(D1)+">s.fmn"
							,"-"+sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30",0)
							,sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30",0))+"+1"
							, 0));
    */
    var strOffset = IIF("s.fvp=0"
					,1
					,IIF("s.fvp=2 and s.fmn>"+sqlTo(D1)
						,sqlRound(sqlRound(SqlDaysBWDates(sqlTo(D1),"s.fmn"),0) + "/30.0",0)+"+1"
						, 0));
    	
    
	var sumt_nach = "SUM(" + IIF("l.fis6='+'", sqlRound("s.fsum",2), "0") + ")";
	var sumt_uder = "SUM(" + IIF("l.fis6='-'", sqlRound("s.fsum",2), "0") + ")";
	var ssum_dolg = "SUM(" + IIF("l.fis6='з'", sqlRound("s.fsum",2), "0") + ")";
	//сумма больничных из соцстраха
    var sumt_blss = "SUM(" + IIF("(l.fis19='b' or l.fis19='&' or l.fis19='f')", sqlRound("s.fsum",2), "0") + ")";    
    //сумма единого взноса с больничных из соцстраха (берется из настройки перечня расчетов первое поле ЛС) и под,налога (2 поле)
    var sumt_edvn = "SUM(" + IIF("((s.flsfid="+lsfid+" and "+lsfid+">0) or (s.flsfid="+lsfid2+" and "+lsfid2+">0) or (s.flsfid="+cesvnsl+" and "+cesvnsl+">0) or (s.flsfid="+cnlgnsl+" and "+cnlgnsl+">0))", sqlRound("s.fsum",2), "0") + ")";    
    //сумма больничных из соцстраха уже выплаченных
    var sumv_blsv = "SUM(" + IIF("l.fis12='q'", sqlRound("s.fsum",2), "0") + ")";
    //сумма больничных из соцстраха к выдаче
	var sumt_blsv = IIF(sumt_blss +"-"+ sumt_edvn+"-"+sumv_blsv+">0","("+sumt_blss +"-"+ sumt_edvn+"-"+sumv_blsv+")","0");
	//var ssum_dolg = "SUM(" + sqlRound("s.fsum",2) + ")";
	var sumt_kvid = sumt_nach +"-"+ sumt_uder +"+"+ ssum_dolg;
	if (dlgs_found==true){
		//от всего к выдачи отнимаем больничные с/с выплаченные и к выдаче
		var sumt_kvid = sumt_nach +"-"+ sumt_uder +"-"+ sumt_blsv+"-"+sumv_blsv+"+"+ ssum_dolg;		
	}
	//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде
		
	if (bez_kopeek)
	{
		var  _xx_kvid = sumt_kvid;                    		// сумма к выдаче
        //sumt_kvid =sqlRound(sumt_kvid+"/"+bez_k,0)+"*"+bez_k ;// округленная сумма к выдаче
        sumt_kvidb = "floor("+"("+sumt_kvid+")"+"/"+bez_k+")"+"*"+bez_k; // округленная сумма к выдаче
        ssum_dolgb = _xx_kvid +"-" + sumt_kvidb; 				// копейки
	}
//	else
//	{
		//как всегда при переносе с 2000-й версии забыли кусок кода
		ssum_dolg = (sumt_kvid < 0?sumt_kvid:0);//оставшаяся сумма долга по таб.N
		//sumt_kvid = (sumt_kvid > 0?sumt_kvid:0);//фактически выдано по таб.N
//	}
	
	//--------------запись сумм в SVZP "всего начислено"
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(nach_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(nach_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + nach_lsfid + " AS flsfid"
					+ ", " + sumt_nach + " AS fsum"
			+ " FROM ^" + svzpTable + " as s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);          
	//--------------запись сумм в SVZP "всего удержано"
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(uder_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(uder_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + uder_lsfid + " AS flsfid"
					+ ", " + sumt_uder + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE 1=1 " + sqlTabn
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);          
//browse("select fwid_wp,"+sumt_uder+" as sum from ^"+svzpTable+" AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid GROUP BY s.ftabn_id")

	//------- запись сумм в SVZP "фактически выдано"
	/*
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(vidan_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(vidan_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + vidan_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", "0", sumt_kvid) + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);
	*/
    if (dlgs_found==true){
    	strSQL = "INSERT INTO ^"+ svzpTable
		+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
		+ " SELECT s.ftabn_id,0 as fwid_wp"
			+ ", " + IIF(sqlTo(nach_lsfis) + "<>0"
					, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(nach_lsfis)  + ")"
					, 0) + " AS ffld_num" 
			+ ", " + nach_lsfis + " AS flsfid"
			+ ", " + sumt_blsv + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
		+ " WHERE 1=1 " + sqlTabn
		+ " GROUP BY s.ftabn_id";
    	ExecuteSQL(strSQL);          
    }
	
	//если существует в приказе на карточки, то должно быть с копейками
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(vidan_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(vidan_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + vidan_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", "0", sumt_kvid) + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
				+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE pa.fbdat<=" + sqlTo(D2) + " AND pa.fedat>=" + sqlTo(D1) 
				+ " and NOT(pa.Ftabn_id=0  or pa.Ftabn_id is null) "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);

	//если не существует приказ на карточки, то должно быть без копеек
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id, 0 as fwid_wp"
					+ ", " + IIF(sqlTo(vidan_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(vidan_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + vidan_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvidb + "<0", "0", sumt_kvidb) + " AS fsum"
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE NOT EXISTS (select p2.Ftabn_id from ^prk_all as p2 where p2.fvid_prk in (select Fvid_prk from vid_prk_cards) and s.Ftabn_id=p2.Ftabn_id "
				+" and p2.fbdat<=" + sqlTo(D2) + " AND p2.fedat>=" + sqlTo(D1) + ") "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);

	
//browse("select fwid_wp,"+IIF(sumt_kvid + "<0", "0", sumt_kvid)+" as sum from ^"+svzpTable+" AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid GROUP BY s.ftabn_id")
//alert(3)
	//--------запись сумм в SVZP "долг на будущее"
	//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде
/*	
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(dlgNxt_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgNxt_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgNxt_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, ssum_dolg) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);
*/           
	//если существует в приказе на карточки, то должно быть с копейками
	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(dlgNxt_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgNxt_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgNxt_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, "0") + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
				+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE pa.fbdat<=" + sqlTo(D2) + " AND pa.fedat>=" + sqlTo(D1) 
				+ " and NOT(pa.Ftabn_id=0  or pa.Ftabn_id is null) "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id"
	ExecuteSQL(strSQL);

	strSQL = "INSERT INTO ^"+ svzpTable
				+ " (ftabn_id,fwid_wp, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id,0 as fwid_wp"
					+ ", " + IIF(sqlTo(dlgNxt_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgNxt_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgNxt_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvidb + "<0", sumt_kvidb, ssum_dolgb) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
				+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE NOT EXISTS (select p2.Ftabn_id from ^prk_all as p2 where p2.fvid_prk in (select Fvid_prk from vid_prk_cards) and s.Ftabn_id=p2.Ftabn_id "
				+" and p2.fbdat<=" + sqlTo(D2) + " AND p2.fedat>=" + sqlTo(D1) + ") "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id";
	ExecuteSQL(strSQL);

	if (is_rasch)
	{
		//11.12.07 Исправила поле Ftt, т.к. иначе падал расчет		
		//в поле Ftt пишу offset просто для проверки
		//изменила на fncmp=" + sqlFalse, т,к, при true вообще не писалось в NXT
        if(getPar("PRIK_IZD")){
        	strSQL = "INSERT INTO ^nxt (ftabn_id,fwid_wp, flsfid, ffld_num, fshpz, fsum, fis_day, fday, fchas, fmn, fmn1, fid_prk, fvid_prk, ftt, fkodizd, fdnkl)"
    			+ " SELECT s.ftabn_id,s.fwid_wp, s.flsfid, s.ffld_num, s.fshpz, s.fsum, s.fis_day, s.fday, s.fchas"
    				+ ", " + sqlTo(month) + " AS fmn"
    				+ ", " + IIF("s.fvp=2", "s.fmn", sqlTo(month)) + " AS fmn1"
    				+ ", s.fid_prk, s.fvid_prk,"+ strOffset+", s.fkodizd, s.fdnkl "
    			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
    			+ " WHERE (" + strOffset + ")>1"
    				+ " AND l.fncmp=" + sqlFalse + sqlTabn;
        }else{
        	strSQL = "INSERT INTO ^nxt (ftabn_id,fwid_wp, flsfid, ffld_num, fshpz, fsum, fis_day, fday, fchas, fmn, fmn1, fid_prk, fvid_prk, ftt, fdnkl)"
			+ " SELECT s.ftabn_id,s.fwid_wp, s.flsfid, s.ffld_num, s.fshpz, s.fsum, s.fis_day, s.fday, s.fchas"
				+ ", " + sqlTo(month) + " AS fmn"
				+ ", " + IIF("s.fvp=2", "s.fmn", sqlTo(month)) + " AS fmn1"
				+ ", s.fid_prk, s.fvid_prk,"+ strOffset+", s.fdnkl "
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE (" + strOffset + ")>1"
				+ " AND l.fncmp=" + sqlFalse + sqlTabn;
        }
		ExecuteSQL(strSQL);
	}
	
	if (is_rasch)
	{
		//11.12.07 Исправила аналог. r_nachi2, ошибку исправил Олег в Брокарде		
		//05.10.07  Будущие суммы должны записываться и в отдельный файл DLG, иначе в след.мес.будут проблемы
		/*
		strSQL = "INSERT INTO ^"+ dlgTable
				+ " (ftabn_id, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id"
					+ ", " + IIF(sqlTo(dlgPrv_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgPrv_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgPrv_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, ssum_dolg) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " GROUP BY s.ftabn_id";
		ExecuteSQL(strSQL);
		*/
		strSQL = "INSERT INTO ^"+ dlgTable
				+ " (ftabn_id, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id"
					+ ", " + IIF(sqlTo(dlgPrv_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgPrv_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgPrv_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvidb + "<0", sumt_kvid, ssum_dolgb) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
				+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE NOT EXISTS (select p2.Ftabn_id from ^prk_all as p2 where p2.fvid_prk in (select Fvid_prk from vid_prk_cards) and s.Ftabn_id=p2.Ftabn_id "
				+" and p2.fbdat<=" + sqlTo(D2) + " AND p2.fedat>=" + sqlTo(D1) + ") "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO ^"+ dlgTable
				+ " (ftabn_id, ffld_num, flsfid, fsum)"
			+ " SELECT s.ftabn_id"
					+ ", " + IIF(sqlTo(dlgPrv_lsfid) + "<>0"
							, "(SELECT l1.ffld_num FROM ^lic_fld AS l1 WHERE l1.fid=" + sqlTo(dlgPrv_lsfid)  + ")"
							, 0) + " AS ffld_num" 
					+ ", " + dlgPrv_lsfid + " AS flsfid"
					+ ", " + IIF(sumt_kvid + "<0", sumt_kvid, ssum_dolg) + " AS fsum"					
			+ " FROM ^" + svzpTable + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
				+ " left join (^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid) on s.ftabn_id=pa.Ftabn_id "
			+ " WHERE pa.fbdat<=" + sqlTo(D2) + " AND pa.fedat>=" + sqlTo(D1)
				+ " and NOT(pa.Ftabn_id=0  or pa.Ftabn_id is null) "
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id";
		ExecuteSQL(strSQL);
		           
	}
	
	ExecuteSQL("delete from ^" + svzpTable + " where (fsum is null or fsum=0) and (Fdnkl=0 or Fdnkl is null)" + sqlTabn); 
}