//деление командировочных сверх нормы на облагаемые 15% и 17%

include("get_cnst.js")
include("servis\\date.js")

function name_nlgkom()
{
	return "Утримання прибуткового податку з вiдр.|Удержание подоходного налога с команд.";
}

function r_nlgkom (mdat,vvopl,vvprk,mvvcslid,VVLSFID2,ftabn_id,svzpName)
{
	//константа, сколько месяцев нужно не учитывать будущие суммы в текущем месяце
	//по новому закону отпускные будущие за январь, начисленные в декабре, нельзя перерасчитывать.
	dtbotp = get_cnst ("dtbotp", mdat)
	//декабрь 2010 зададим явно в программе
	//по новому закону отпускные будущие за январь, февраль и т.д. начисленные в декабре, нельзя перерасчитывать.
	mnbotp = new Date(2010,11,1)
	   
    var snap;
	var vdpl2=0; 
    strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(VVLSFID2);
    snap = getSnap(strSQL);
    if (snap != null)
       vdpl2 = snap[0];

	var vdpl=0; 
    strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(mvvcslid);
    snap = getSnap(strSQL);
    if (snap != null)
       vdpl = snap[0];

   var Nalog_table, Lic_table, Shtat_table, PSVZP_table, SVZP_table;
   var szTag, szTag1;
   var gS;
   
   // достаем цифры к названию файла
   if (mdat.getMonth() < 9)  
      szTag = String(mdat.getFullYear()) +"0"+String(mdat.getMonth()+1);
   else
      szTag = String(mdat.getFullYear())+String(mdat.getMonth()+1);        

   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1); 
   // дата конца
   var D2 = new Date(lastDayMonth(mdat)); 
   // нулевая дата
   var NulDate = new Date(3000,0,1); 

   // -------- pitan  - сумма на питание, не облагаемая подоходным налогом
   var pitan   = get_cnst ("min_pit", mdat)
   // -------- proc_s - процент ставки налога с совместителей (вместо 2-й таблицы налога)
   var proc_s  = get_cnst ("proc_s ", mdat)
   // сумма социальной льготы
   soc_lgot = get_cnst ("soclgot" , mdat)
   // сумма прож.мин.*1.4, окр.до ближ.10 грн.
   minnal = get_cnst ("minnal" , mdat)
   // необлаг.процент по страховке за счет предприятия
   procsl = get_cnst ("procsl", mdat)
   // необла. сумма на погребение своего сотрудника
   npogr = get_cnst ("npogr", mdat)
   // изменениe льгты на детей - 1 c 01.01.05, 0 - пред.периоды
   izmlg = get_cnst ("izmlg" , mdat)
   // изменениe льгты на буд. периоды
   izmnx = get_cnst ("izmnx" , mdat)

	var sumgran  = 10*get_cnst("progmin",mdat);
	
     //var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
     var sqlTabn2 = ftabn_id?" and a.Ftabn_id in ("+ftabn_id+") ":"";     
     //* информация для расчета налогов будет браться из файла SVZP_TO_RD,
     //* а помещаться в файл SVZP_TO_WR. Для случая "месяц в месяц эти
     //* файлы совпадают.
     
     var  siName = "^"+(svzpName?svzpName:"svzp")+szTag;
     // создается временная таблица, потом она будет уничтожена  
     // создается временная таблица для расчета единого налога
     DropTable("SVZPEDV2")
     ExecuteSQL("select distinct a.Ftabn_id into SVZPEDV2 from "+siName+" a inner join ^LIC_FLD b on a.Flsfid=b.Fid where b.Fis31=118 and 1=1 "+sqlTabn2);
     
     DropTable("SVZPEDV");
     CreateTable("SVZPEDV", "VSP");
     ExecuteSQL("ALTER TABLE SVZPEDV ADD Fproc  "+SqlType("CURRENCY",1))      
      
   	 var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+")":"";
     ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id, Fproc) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id, Fproc FROM "+siName+" where exists(select Ftabn_id from SVZPEDV2 where "+siName+".Ftabn_id=SVZPEDV2.Ftabn_id)");

     //для небазового месяца:если переход на новый налог с 2011, то нужно закачать будущие суммы начислений c минусом
     var is_rasch=(differ(base_month,mdat)==0)
     if (!is_rasch && dtbotp!=0){
   		var sqlTabnnu = ftabn_id?" and nu.Ftabn_id in ("+ftabn_id+")":"";	   
   	    //будущие суммы с минусом с 2010 года берем только по начислениям
   		strSQL =  "INSERT INTO SVZPEDV "
   			+ "( ftabn_id,fwid_wp"
   			+ ", fshpz"
   			+ ", ffld_num"
   			+ ", flsfid"
   			+ ", fsum"
   			+ ", fmn"
   			+ ", fvp )"
   		+ " SELECT nu.ftabn_id, nu.fwid_wp, nu.fshpz, nu.ffld_num, nu.flsfid, (-nu.fsum) as Fsum"
   			+ ",  nu.fmn, 1 AS fvp "
   		+ " FROM ^nxt AS nu "
   		+ " INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid "		 		
   		+ " WHERE l.Fis6='+' and nu.Fmn<="+sqlTo(mnbotp)+" and nu.fmn1=" + sqlTo(D1)+sqlTabnnu;
   		ExecuteSQL(strSQL);
      } 
      
      strSQL = "UPDATE SVZPEDV set Fshpz='0' where Fshpz=' ' or Fshpz is null";
      ExecuteSQL(strSQL);
      
      //без служебных записей
      if (dtbotp!=0 && dtbotp!=null){      
    	  //PSVZP_table = OpenTable("s","SELECT * FROM "+siName+" where NOT(Fvp=1 and Fmn>"+sqlTo(D1)+") and 1=1 "+sqlTabn+" order by FTABN_ID,FWID_WP ");
    	  PSVZP_table = OpenTable("s","SELECT * FROM SVZPEDV where NOT(Fvp=1 and Fmn>"+sqlTo(D1)+") and 1=1 "+sqlTabn+" order by FTABN_ID,FWID_WP ");    	  
      }else{
    	  //PSVZP_table = OpenTable("s","SELECT * FROM "+siName+" where 1=1 "+sqlTabn+" order by FTABN_ID,FWID_WP ");
    	  PSVZP_table = OpenTable("s","SELECT * FROM SVZPEDV where 1=1 "+sqlTabn+" order by FTABN_ID,FWID_WP ");    	  
      }	  

   if (PSVZP_table.IsBOF() && PSVZP_table.IsEOF())   return;
  
   //*----------------------------- PUNKT11 ----------------------------------- 
   var ssumpg = new Array(30)
   var ssummp  = new Array(30)
   var ssummps = new Array(30)
   var ssumdox = new Array(30)
   var ssum = new Array(30)
   var ssum_n = new Array(30)
   var ssumd = new Array(30)
   var ssumsn = new Array(30)
   var ssumso = new Array(30)
   var ssuml = new Array(30)
   var ssum_s = new Array(30)
   var ssum_p = new Array(30)
   var ssum_z = new Array(30)
   var ssumon = new Array(30)   
   var ssumoo = new Array(30)      
   var ssumtr = new Array(30)      
   //var uderg_nlg = new Array(30)
   //var basevzp = new Array(30)
   //var basevbl = new Array(30)
   //var prevzp  = new Array(30)
   //var prevbl  = new Array(30)
   //суммы будущих отпускных
   var ssumotb = new Array(30)
   var ssumkomo = new Array(30)
   var ssumkoms = new Array(30)      
   var ssumpn  = new Array(30)
   var ssumlg  = new Array(30)   
   
   var max_offset = 12   // &&0  &&кол-во месяцев, по которым может идти расчет
   var offset;
   var mn_vip, mn_voz;
     
   for (var iii=0; iii<30; iii++)
   { 
     ssumpg[iii]   = 0
     ssummp[iii]   = 0
     ssummps[iii]   = 0
     ssumdox[iii]   = 0
     ssum[iii]      = 0
     ssum_n[iii]      = 0
     ssumd[iii]     = 0
     ssumsn[iii]    = 0
     ssumso[iii]    = 0
     ssuml[iii]     = 0
     ssum_s[iii]    = 0
     ssum_p[iii]    = 0
     ssum_z[iii]    = 0
     ssumon[iii] = 0   
     ssumoo[iii] = 0      
     ssumtr[iii] = 0      
     //uderg_nlg[iii]    = 0
     //basevzp[iii] = 0
     //basevbl[iii] = 0
     //prevzp[iii]  = 0
     //prevbl[iii]  = 0
     ssumotb[iii] = 0
     ssumkomo[iii] = 0
     ssumkoms[iii] = 0     
     ssumpn[iii] = 0 
     ssumlg[iii] = 0   
   }  
   var pFtabn    = Number(PSVZP_table.getValue("Ftabn_id"));

   PSVZP_table.MoveFirst();
   while(!PSVZP_table.IsEOF())
   { 
      while ((!PSVZP_table.IsEOF()) && (Number(PSVZP_table.getValue("Ftabn_id")) == pFtabn))
      {
         // * поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
         // * поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
         // * поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn
         // * offset = 0 для пpошлых месяцев, 1 для текущего месяца, 2 - для следующего, и т.д.
         switch(Number(PSVZP_table.getValue("Fvp")))
         { 
            case 0:
               mn_vip=mdat
               mn_voz=mdat
               offset = 1
               break;
            case 1:
               mn_vip=new Date(PSVZP_table.getValue("Fmn"))
               mn_voz=mdat
               offset = 0
               break;
            case 2:
               mn_vip=mdat
               mn_voz=new Date(PSVZP_table.getValue("Fmn"))
               offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1   //смещение от базового месяца
               break;
         }
         mFsum   = Number(PSVZP_table.getValue("Fsum"));
         mFlsfid = Number(PSVZP_table.getValue("Flsfid"));
         mFprocev= Number(PSVZP_table.getValue("Fproc"))/100         
         mFday   = Number(PSVZP_table.getValue("Fday"));         
         //* проверка входимости в налогооблагаемую сумму
         strSQL = "SELECT Fis1,Fis5,Fis16,Fis9,Fis6,Fis19,Fis12,Fis8,Fis31 FROM ^LIC_FLD WHERE Fid="+sqlTo(mFlsfid);
			gS = getSnap(strSQL);
         if(gS == null)
         {
            msg = "Ссылка на неизвестное поле лицевого счета "+String(mFlsfid)+". Пригласите разработчиков для устранения";
            writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
            return;
         } 
         //* пpизнак входимости в налогооблагаемую сумму определяется по первой
         //* колонке (Fis1) файла LIC_FLD
         
         var fld_mrk  = gS[0];
         var fld_mrk1 = gS[1];
         var fld_mrk2 = gS[2];
         var fld_mrk3 = gS[3];
         var fld_mrk4 = gS[4];
         var fld_mrk5 = gS[5];
         var fld_mrk6 = gS[6];
         var fld_mrk7 = gS[7];
         var fld_mrk8 = gS[8];         
         //alert(mFlsfid+" "+Lic_table("FID")+"="+fld_mrk+" "+fld_mrk1)
         //* offset = 0 для пpошлых месяцев, 1 для текущего месяца, 2 - для следующего, и т.д.
         if (offset > 0)
         { 
            //* сумма общего дохода
            ssumdox[offset]  = (fld_mrk4=="+")? ssumdox[offset] + mFsum: ssumdox[offset] 
            //* льготы по акциям
            ssuml[offset]    = (fld_mrk=="а")? ssuml[offset] + mFsum: ssuml[offset] 
            //* включение в налогооблагаемую сумму доходов по месту осн. работы и не по месту осн.работы
            ssumd[offset]   = (fld_mrk3=="*")? ssumd[offset] + mFsum:  ssumd[offset]
            //* сумма страховки без учета для льготы
	    	ssumsn[offset]   = (fld_mrk3=="+")? ssumsn[offset] + mFsum:  ssumsn[offset]
            //* сумма страховки c учетом для льготы
	   		ssumso[offset]   = (fld_mrk3=="#")? ssumso[offset] + mFsum:  ssumso[offset]
            //* сумма на погребение
	    	ssumpg[offset]   = (fld_mrk3=="п")? ssumpg[offset] + mFsum:  ssumpg[offset]
            //* сумма на мат.пом. осн.
	    	ssummp[offset]   = (fld_mrk=="+" && fld_mrk3=="м")? ssummp[offset] + mFsum:  ssummp[offset]
            //* сумма на мат.пом. совм.
	    	ssummps[offset]   = (fld_mrk=="#" && fld_mrk3=="м")? ssummps[offset] + mFsum:  ssummps[offset]
            //* включение в налогооблагаемую сумму доходов 
            ssum[offset]   = (fld_mrk=="+" && fld_mrk3!="*" && fld_mrk3!="+" && fld_mrk3!="#"   && fld_mrk3!="п"  && fld_mrk3!="о" && fld_mrk3!="у" && fld_mrk3!="т" && fld_mrk3!="н" && fld_mrk3!="м" && fld_mrk3!="б")? ssum[offset] + mFsum:  ssum[offset]
            //* включение в налогооблагаемую сумму выплат на питание
            ssum_p[offset]   = (fld_mrk=="p")? ssum_p[offset] + mFsum:  ssum_p[offset]
            //* исключение из налогооблагаемой суммы задолженности г-ву для ЗК
            ssum_z[offset]   = (fld_mrk1=="г")? ssum_z[offset] + mFsum:  ssum_z[offset]
            //* включение в налогооблагаемую сумму доходов по совместительству
            ssum_s[offset]   = (fld_mrk=="#" && fld_mrk3!="т" && fld_mrk3!="м")? ssum_s[offset] + mFsum:  ssum_s[offset]
            //* запоминание суммы подоходного налога, удержанного не по месту осн. работы
            //uderg_nlg[offset] = (fld_mrk1=="-" && fld_mrk7!="7")? uderg_nlg[offset] + mFsum: uderg_nlg[offset]
            //* сумма обучения без учета для льготы
     	    ssumon[offset]   = (fld_mrk3=="о")? ssumon[offset] + mFsum:  ssumon[offset]
            //* сумма обучения c учетом для льготы
    	    ssumoo[offset]   = (fld_mrk3=="у")? ssumoo[offset] + mFsum:  ssumoo[offset]
            //* сумма трудового соглашения
    	    ssumtr[offset]   = (fld_mrk=="#" && fld_mrk3=="т")? ssumtr[offset] + mFsum:  ssumtr[offset]
            //* необл.суммы для учета льготы 
	    	ssum_n[offset]   = (fld_mrk3=="н")? ssum_n[offset] + mFsum:  ssum_n[offset]
            //basevzp[offset] = (fld_mrk6=="5")? basevzp[offset]+mFsum: basevzp[offset]
            //basevbl[offset] = (fld_mrk6=="6")? basevbl[offset]+mFsum: basevbl[offset]
            //prevzp[offset] =  (fld_mrk6=="5")? mFprocev: prevzp[offset]
            //prevbl[offset] =  (fld_mrk6=="6")? mFprocev: prevbl[offset]
            ssumkomo[offset]   = (fld_mrk8==118 && fld_mrk=="+")? ssumkomo[offset] + mFsum: ssumkomo[offset]            
            ssumkoms[offset]   = (fld_mrk8==118 && fld_mrk=="#")? ssumkoms[offset] + mFsum: ssumkoms[offset]
            ssumpn[offset]   = (fld_mrk=="п" || fld_mrk=="s")? ssumpn[offset] + mFsum: ssumpn[offset]
            ssumlg[offset]   = ((fld_mrk=="п" || fld_mrk=="s") && mFday!=0)? mFday: ssumlg[offset]
         }
         // суммы будущих отпускных c минусом
         if (dtbotp!=0 && differ(new Date(PSVZP_table.getValue("Fmn")),mnbotp)<=0){         
        	 if (offset == 0){ 
        		 ssumotb[offset]   = (fld_mrk5=="о")? ssumotb[offset] + mFsum:  ssumotb[offset]
        	 }	 
         }
         PSVZP_table.MoveNext();
        
      } // end of while (Ftabn==pFtabn) && (!PSVZP_table.IsEOF())

      gS = getSnap("select Fproc from ^PRK_ALL "
      			   + " WHERE Fin_table="+sqlTo("PRK_DET")+" and ftabn_id=" + pFtabn
                   + " AND FBDAT <= " + sqlTo(D2) + " AND FEDAT >= " + sqlTo(D1));
	  if (gS != null)
         prk_det  = Number(gS[0]);
      else
         prk_det = 0
      
      ii = 1
      while (ii <= max_offset)
      {

    	if (ssumkomo[ii]!=0){
         var prk_proc = 100;
         if (ssumlg[ii]==2) prk_proc=150;
         if (ssumlg[ii]==3) prk_proc=200;
         if (ssumlg[ii]==0) prk_proc=0;         

         //*-------- расчет суммы налога по месяцам ----------------------------
         //*-------- страховка
         //сумма необлагаемой страховки
         
         var sum_lg = (round(ssumdox[ii]*procsl/100,2)>minnal)?minnal:round(ssumdox[ii]*procsl/100,2);
         var ssum_strn = (ssumsn[ii]-sum_lg>0)?(ssumsn[ii]-sum_lg):0;
         var ssum_stro = (ssumso[ii]-sum_lg>0)?(ssumso[ii]-sum_lg):0;
         
         //накопленная сумма МАТ.помощи, чтобы определить необлагаемую сумму
         //начало года расчета мат.помощи 
         begy_mdat = new Date(mdat.getYear()+1900,0,1)
         strSQL = "select sum(Fsum) as Fsumallmp from ^PRK_FMPL where Fvd="+sqlTo("MP")
         			+" and Fwid_wp= (select max(fwid) from ^work_pers where fwid_cl="+sqlTo(pFtabn)
         			 + " AND ((FBDAT <= " + sqlTo(mdat) + " AND FEDAT >= " + sqlTo(mdat) +") " 
                   + " OR (FBDAT >= " + sqlTo(mdat) + " AND FBDAT <= " + sqlTo(mdat) +") " 
                   + " OR (FEDAT >= " + sqlTo(mdat) + " AND FEDAT <= " + sqlTo(mdat) +")))"
                   + " and (Fdat_vp>="+sqlTo(begy_mdat)+" and Fdat_vp<"+sqlTo(begy_mdat)+")";
         tfmpl = getSnap(strSQL);
         sumallmp = 0
         if (tfmpl != null){
            sumallmp = tfmpl[0];
            
         }  
        
         //***************
         //предварительное деление м.пом. на обл.и необл.
         neob_mp = 0   
         ob_mp   = 0   
          
         // если одновременно дали мат.пом. по осн.работе и по совм., то будем добавлять сумму мат.пом. к основной работе
         if (ssummp[ii]!=0 && ssummps[ii]!=0){
            ssummp[ii]  = ssummp[ii]+ssummps[ii]
            ssummps[ii] = 0
         } 

         //мат.пом.по осн.работе  
         if (ssummp[ii]!=0){
            xx1  = (ssummp[ii]+sumallmp-minnal>0)?ssummp[ii]+sumallmp-minnal:0;
            ob_mp  = (ssummp[ii]>xx1)?xx1:ssummp[ii];
            //необлагаемая сумма мат.пом.   
            neob_mp = (ssummp[ii]>ob_mp)?(ssummp[ii]-ob_mp):0;
         }  

         //мат.пом.по совм.  
         if (ssummps[ii]!=0){
            xx1s  = (ssummps[ii]+sumallmp-minnal>0)?ssummps[ii]+sumallmp-minnal:0;
            ob_mp  = (ssummps[ii]>xx1s)?xx1s:ssummps[ii];
            //необлагаемая сумма мат.пом.   
            neob_mp = (ssummps[ii]>ob_mp)?(ssummps[ii]-ob_mp):0;
         }  
         //***************       

         //обучение 
         var ssum_obn = (ssumon[ii]-minnal>0)?(ssumon[ii]-minnal):0;
         var ssum_obo = (ssumoo[ii]-minnal>0)?(ssumoo[ii]-minnal):0;
         
         var ssum_pog = (ssumpg[ii]-npogr>0)?(ssumpg[ii]-npogr):0;
         //*-------- налогооблагаемый остаток выплат на питание
         var ost_na_pit = ssum_p[ii] - (ssum_p[ii])? ssum_p[ii]: pitan
         //*-------- налогообл.сумма по осн.работе
         var mF_SUM_ZP = ssum[ii] + ost_na_pit - ssum_z[ii] -ssuml[ii] + ssum_stro
         var mF_SUM   = ssum[ii]  + ssumd[ii] + ost_na_pit - ssum_z[ii] -ssuml[ii] + ssum_strn + ssum_stro;

         var bPogrOsn = false;
         //пытаемся обойти случай,если по осн.работе нет зарплаты и есть сумма на обучение
         if (mF_SUM != 0 || (mF_SUM==0 && (ssum_s[ii]==0)))
         {
        	 mF_SUM += ssum_pog;
        	 mF_SUM_ZP = mF_SUM_ZP + ssum_obo + ssum_n[ii]
        	 mF_SUM = mF_SUM + ssum_obo+ ssum_obn		
        	 bPogrOsn = true;
         }

         if (((ssum[ii]+ssumd[ii]+ssum_strn+ssum_stro+ ssum_pog + ssum_obo )==0) && ((ssum_s[ii]+ssumtr[ii])==0) && ssummp[ii]==0 && ssummps[ii]==0)
         { 
            ii = ii + 1
            continue;
         }

         //*-------- налогообл.сумма по совместит.
         var mF_SUM_S = ssum_s[ii]+ssumtr[ii]; //&& налогообл.сумма по совместит.
         
         if (!bPogrOsn){
            mF_SUM_S += ssum_pog;
            mF_SUM_S = mF_SUM_S + ssum_obo+ ssum_obn+ ssum_n[ii]		
         }

         var l_xxx = 0
         //если в ранее сделанном расчете подоходного налога льгота не посчиталась, то не высчитываем льготу,  а считаем, что ее нет
         if (ssumlg[ii]!=0){
         	if (mF_SUM_ZP > 0){
	            //* l_xxx - сумма льготы
    	        if (mF_SUM_ZP <= ((prk_det==0)?minnal:minnal*prk_det))
        	    {
            	   // значит, положена льгота
                    if (prk_det==0){
                    	l_xxx = soc_lgot*prk_proc/100                    	
                    }else{    	        	
                    	if (izmlg==1){
                    		l_xxx = soc_lgot*prk_proc/100*prk_det
                    	}else{
                    		l_xxx = soc_lgot*prk_proc/100*prk_det+soc_lgot                                    
                    	}
                    }	
            	}
	            // c 01.01.05 льгота на буд.периоды = 0 
    	        if (izmnx==1 && ii > 1){
            	   l_xxx = 0
            	}
            }	
         }

         //если МП была по осн.работе, то добавляем к обл.сумме по осн.работе
         if (ssummp[ii]!=0){
            obl_mp  = 0; 
            nobl_mp = 0; 
            //если нет соц.льготы, то необл.МП становится облагаемой 
            if (l_xxx==0 && mF_SUM > 0)
            {
               obl_mp = neob_mp+ob_mp;
            }
            else
            {
               //если есть соцльгота или нет зарплаты, чтобы определить размер соцльготы
               obl_mp  = ob_mp;
               nobl_mp = neob_mp; 
            } 
            mF_SUM = mF_SUM+obl_mp
         }

         mF_SUM = (mF_SUM-l_xxx<0)?0:mF_SUM-l_xxx;
         
         //если есть сумма по основной работе, то отпускные отнимаем от этой суммы
         //если есть еще и по совместительству будущие отпускные, то это неберучка.
         //можно только руками исправлять.   
         if (ii == 1 && dtbotp!=0 && ssumotb[0]<0 && mF_SUM>0){
            //нужно отнять будущие отпускные с минусом  
            mF_SUM = mF_SUM+ssumotb[0]
            mF_SUM = (mF_SUM<0)?0:mF_SUM 
         }

         //отнимание ЕСВ от облагаемой суммы - не учитываем, т,к, если есть неденежные выплаты, которые берутся посленими,
         //то ЕСВ точно нельзя высчитать
         /*
         ostbzp = basevzp[ii]        
         ostbbl = basevbl[ii]        

         uevzp = 0   
         uevbl = 0   

         pbasevzp = basevzp[ii]
         pbasevbl = basevbl[ii]
         allbedvn = basevzp[ii]+basevbl[ii]   
         // в uderg_nlg(ii) содержится сумма единого взноса, которая отнимается. Если решат не отнимать, то и базу
         // не надо делить. На всякий случай проверяем, есть ли сама сумма взноса, которая отнмается. Если есть,
         // тогда начинаем делить базу.
         if (uderg_nlg[ii]!=0){
            //если база единого взноса<=границе, то просто отнимаем все без деления  
            if (allbedvn<=sumgran){ 
               evdo = uderg_nlg[ii]
               evpl = 0
            }else{
               //если база единого взноса>границы, то начинаем вычислять вхождение единого взноса
               //по принципу расчета самого единого взноса
               sum_ogrt = sumgran
               //разбить суммы по ограничению
    	          if (basevzp[ii]>sum_ogrt){
	              basevzp[ii]=sum_ogrt
               }
               uevzp = round(basevzp[ii]*prevzp[ii],2)   
               ostbzp = pbasevzp-basevzp[ii]        
               sum_ogrt = sum_ogrt-basevzp[ii] 
               if (basevbl[ii]>sum_ogrt){
	             basevbl[ii]=sum_ogrt
   	          }
               uevbl = round(basevbl[ii]*prevbl[ii],2)   
               ostbbl= pbasevbl-basevbl[ii]         
               evdo = uevzp+uevbl
               evpl = round(ostbzp*prevzp[ii],2) + round(ostbbl*prevbl[ii],2)   
            }    
            if (mF_SUM>0){  
               mFsumdo = ((mF_SUM<=sumgran)?mF_SUM:sumgran)-evdo
               mFsumpl = ((mF_SUM<=sumgran)?0:mF_SUM-sumgran)-evpl
               mF_SUM =  mFsumdo+mFsumpl
            }
         }
         */
         mF_SUM_bk = (mF_SUM-ssumkomo[ii]<0)?0:mF_SUM-ssumkomo[ii];
         
         var kom15 = 0
         var kom17 = 0         
         if (mF_SUM<sumgran){
            kom15 = ssumkomo[ii]
            kom17 = 0         
         }
         if (mF_SUM>=sumgran && mF_SUM_bk>=sumgran){
            kom15 = 0
            kom17 = ssumkomo[ii]         
         }
         if (mF_SUM>=sumgran && mF_SUM_bk<sumgran){
            kom15 = sumgran - mF_SUM_bk
            kom17 = ssumkomo[ii]-kom15         
         }
                  
         var l_xxx_s = 0
         //если МП была по совм., то добавляем к обл.сумме по совм.
         if (ssummps[ii]!=0){
            obl_mps  = 0; 
            nobl_mps = 0; 
            //если нет соц.льготы, то необл.МП становится облагаемой 
            if (l_xxx_s==0  && mF_SUM_S > 0){
               obl_mps = neob_mp+ob_mp;
            }else{
               obl_mps  = ob_mp;
               nobl_mps = neob_mp; 
            } 
            mF_SUM_S = mF_SUM_S+obl_mps
         }
	
         //если есть только сумма по совместительству, то и есть будущие отпускные с минусом,
         //то отнимаем от этой суммы
         if (ii == 1 && dtbotp!=0 && ssumotb[0]<0 && mF_SUM_S>0 && mF_SUM<=0){
            //нужно отнять будущие отпускные с минусом  
            mF_SUM_S = mF_SUM_S+ssumotb[0]
            mF_SUM_S = (mF_SUM_S<0)?0:mF_SUM_S
         }

         mF_SUMS_bk = (mF_SUM_S-ssumkoms[ii]<0)?0:mF_SUM_S-ssumkoms[ii];

         var kom15s = 0
         var kom17s = 0         
         if (mF_SUM_S<sumgran){
            kom15s = ssumkoms[ii]
            kom17s = 0         
         }
         if (mF_SUM_S>=sumgran && mF_SUMS_bk>=sumgran){
            kom15s = 0
            kom17s = ssumkoms[ii]         
         }
         if (mF_SUM_S>=sumgran && mF_SUMS_bk<sumgran){
            kom15s = sumgran - mF_SUMS_bk
            kom17s = ssumkoms[ii]-kom15s         
         }
         
         if ((kom15+kom15s)!=0 && mvvcslid!=0)
         { 
            c4sum=round(kom15+kom15s,2)
            if (ii > 1)
            {
               // достаем даты последующих месяцев
               mFmn = new Date(mdat.getYear()+1900,mdat.getMonth()+ii-1,1);
               mFvp = 2
            }
            else
            { 
               mFmn = d00obj.getVarDate()
               mFvp = 0
            }  
            
          	var m = new Object();
            //SVZP_table.AddNew();
           	m.Ftabn_id = pFtabn
            m.Fwid_wp  = 0            
           	m.Fsum = c4sum
           	m.Flsfid = mvvcslid
           	m.Ffld_num = vdpl
           	m.Fmn = mFmn
           	m.Fvp = mFvp
           	m.Fday = 0
           	m.Fis_day = 0
           	m.Fvid_prk = 0
           	m.Favt = false;
           	UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
         }
                      
         if ((kom17+kom17s)!=0 && VVLSFID2!=0)
         { 
            c4sum=round(kom17+kom17s,2)
            if (ii > 1)
            {
               // достаем даты последующих месяцев
               mFmn = new Date(mdat.getYear()+1900,mdat.getMonth()+ii-1,1);
               mFvp = 2
            }
            else
            { 
               mFmn = d00obj.getVarDate()
               mFvp = 0
            }  
            
          	var m = new Object();
            //SVZP_table.AddNew();
           	m.Ftabn_id = pFtabn
            m.Fwid_wp  = 0            
           	m.Fsum = c4sum
           	m.Flsfid = VVLSFID2
           	m.Ffld_num = vdpl2
           	m.Fmn = mFmn
           	m.Fvp = mFvp
           	m.Fday = 0
           	m.Fis_day = 0
           	m.Fvid_prk = 0
           	m.Favt = false;
           	UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
         }             
    	}
        ii = ii + 1
      } // end of   while (ii <= max_offset)
     
      for (var iii=0; iii<30; iii++)
      {
         ssumpg[iii]   = 0
         ssummp[iii]   = 0
         ssummps[iii]   = 0
         ssumdox[iii]  = 0
         ssum[iii]     = 0
         ssum_n[iii]   = 0
         ssumd[iii]    = 0
         ssumsn[iii]   = 0
         ssumso[iii]   = 0
         ssuml[iii]    = 0
         ssum_s[iii]   = 0
         ssum_p[iii]   = 0
         ssum_z[iii]   = 0
         ssumon[iii]   = 0   
         ssumoo[iii]   = 0      
         ssumtr[iii]   = 0      
         //uderg_nlg[iii]= 0
         //basevzp[iii] = 0
         //basevbl[iii] = 0
         //prevzp[iii]  = 0
         //prevbl[iii]  = 0
         ssumotb[iii] = 0
         ssumkomo[iii] = 0            
         ssumkoms[iii] = 0
         ssumpn[iii] = 0
         ssumlg[iii] = 0
      }  

      if (!PSVZP_table.IsEOF()) pFtabn    = Number(PSVZP_table.getValue("Ftabn_id"));
      
   } // end of while(!PSVZP_table.IsEOF())
    PSVZP_table.close();
   return;
}