//расчет подоходного налога
// передаются ДАТА расчета - для использования нужных временных файлов
// vvopl - вид оплаты
// № поля как считать (например, Оклад,совместители), куда передается результат ffld  VVDPL
// код поля ЛС flsfid  VVCSLID 
// vvprk - номер приказа
// za_tek_mes - за текущий ли месяц расчитывается налог (true, false)

include("get_cnst.js")
//include("servis\\date.js")

function r_nlgn39 (mdat,vvopl,vvprk,mvvcslid,VVLSFID2,ftabn_id,svzpName)
{

   // дата перехода на новый расчет с 2004 г.
   dtnnal = get_cnst("datnal", mdat)
   if (dtnnal==0)
   {
      return;
   }
	var snap;
	var vdpl2=0; 
    strSQL = "select Ffld_num from ^LIC_FLD where Fid="+sqlTo(VVLSFID2);
    snap = getSnap(strSQL);
    if (snap != null)
       vdpl2 = snap[0];
    

   var Nalog_table, Lic_table, PSVZP_table, SVZP_table;
   var szTag, szTag1;
   var NLG_STSUM = Array(60)
   var NLG_BASNLG = Array(60)
   var NLG_PROC = Array(60)
   var NL2_STSUM = Array(60)
   var NL2_BASNLG = Array(60)
   var NL2_PROC = Array(60)

   za_tek_mes = getPar("CUR_PN");
   // достаем цифры к названию файла
   if (mdat.getMonth() < 9)  
      szTag = String(mdat.getFullYear()) + "0"+String(mdat.getMonth()+1);
   else
      szTag = String(mdat.getFullYear()) + String(mdat.getMonth()+1);        

   // достаем цифры к названию файла прошлого месяца
   if (mdat.getMonth() <= 9)  
      szTag1 = String(mdat.getFullYear()) + "0"+String(mdat.getMonth());
   else
      szTag1 = String(mdat.getFullYear()) + String(mdat.getMonth());        

   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1) 
   
   // дата конца
   var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
   var D2 = new Date(mdat.getFullYear(),mdat.getMonth(),DD2) 
   
   // нулевая дата
   var NulDate = new Date(3000,0,1); 

   // -------- pitan  - сумма на питание, не облагаемая подоходным налогом
   var pitan   = get_cnst("min_pit", mdat)
   // -------- proc_s - процент ставки налога с совместителей (вместо 2-й таблицы налога)
   var proc_s  = get_cnst("proc_s ", mdat)
   // сумма социальной льготы
   soc_lgot = get_cnst("soclgot" , mdat)
   // сумма прож.мин.*1.4, окр.до ближ.10 грн.
   minnal = get_cnst("minnal" , mdat)
   // необлаг.процент по страховке за счет предприятия
   procsl = get_cnst("procsl", mdat)
   // необла. сумма на погребение своего сотрудника
   npogr = get_cnst("npogr", mdat)
   // изменениe льготы на детей - 1 c 01.01.05, 0 - пред.периоды
   izmlg = get_cnst("izmlg" , mdat)
   izmnx = get_cnst("izmnx" , mdat)


   strSQL = "SELECT * FROM ^Nalog WHERE f_tbl = 1 "
                     + "AND ((FBDAT <= " + sqlTo(D1) + ")"
                     + " AND ((FEDAT >= " + sqlTo(D2) +") OR (FEDAT = " + sqlTo(NulDate) +")) " 
                     + "OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
                     + "OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +")) order by F_TBL,FBDAT,F_STSUM";
	
   snap = getSnap(strSQL);
   if(snap == null)
   {   
   		msg = "Справочник ставок налога пуст.\nРасчет не может быть выполнен";
   		writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
       	return;
   }

   //* загрузка спр-ка налогов в массив
   Nalog_table.MoveLast();
   i   = 0

   while ((!Nalog_table.IsBOF()) && (i<60))
   { 
   		NLG_STSUM[i] = Nalog_table.getValue("F_STSUM")
     	NLG_BASNLG[i]= Nalog_table.getValue("F_BASNL")
     	NLG_PROC[i]  = Nalog_table.getValue("F_PROC")/100
     	Nalog_table.MovePrev();
     	i = i + 1
   }
   sch = i

   strSQL = "SELECT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='п' and FIS_SLCT="+sqlTrue;
	snap = getSnap(strSQL);
	var nach_lsfi1=0;
	var nach_lsnu1=0;
	var fld_found1 = false;
   if (snap == null)
   {
      msg = "Обнаружена серьезная ошибка функционирования системы.\n"
      		+"Hевозможно идентифицировать поле ЛС: подоходн. налог.\n"
      		+" Пригласите разработчиков для устранения";
      writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
   }
	else
	{
 	  	nach_lsfi1 = snap[0];
   		nach_lsnu1 = snap[1];
   		fld_found1 = true;
	}
   
   strSQL = "SELECT Fid,Ffld_num FROM ^LIC_FLD WHERE Fis1='s' and FIS_SLCT="+sqlTrue;
	snap = getSnap(strSQL);
	var nach_lsfi2=0;
	var nach_lsnu2=0;
	var fld_found2 = false;
  	if (snap == null)
  	{
      msg = "Обнаружена серьезная ошибка функционирования системы.\n"
      		+"Hевозможно идентифицировать поле ЛС: под.налог совм.\n"
      		+"Пригласите разработчиков для устранения";
      writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
  	}
	else
	{
   		nach_lsfi2 = snap[0];
  		nach_lsnu2 = snap[1];
  		fld_found2 = true;
  	}

   /*Shtat_table = OpenTable("s","SELECT * FROM ^SHTAT WHERE "
                   + "((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") " 
                   + "OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
                   + "OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))")
   // --------  льготы по подоходному налогу (в минимумах ЗП)    
   Podn_table = OpenTable("s","SELECT * FROM ^PRK_PODN WHERE Fvid_prk = " + sqlTo(vvprk)
                   + "AND ((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") " 
                   + "OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
                   + "OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))")


   // * --------  льготы по подоходному налогу на детей (в минимумах ЗП)
   Det_table = OpenTable("s","SELECT * FROM ^PRK_DET WHERE "
                   + "((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") " 
                   + "OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
                   + "OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))")*/
                     
   // файлы открываются только если удержание налогов идет за прошлый в текущем месяце
    if (za_tek_mes)
    {
      //* информация для расчета налогов будет браться из файла SVZP_TO_RD,
      //* а помещаться в файл SVZP_TO_WR. Для случая "месяц в месяц эти
      //* файлы совпадают.
     
      var  siName = "^"+(svzpName?svzpName:"svzp")+szTag;
      // создается временная таблица, потом она будет уничтожена  
      CreateTable("tmp_SVZP", "svzpt", "*");
   	}  

  // if (PSVZP_table.IsBOF() && PSVZP_table.IsEOF())   return;
   
   var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
   if(null == getSnap("SELECT COUNT(*) FROM ^" + siName + " WHERE 1=1 " + sqlTabn))
		return true;
  
	var strOffset = IIF("s.fvp=0"
						, 1
						,  IIF("s.fvp=2"
							, "ABS(" + SqlDaysBWDates("s.fmn",sqlTo(D1)) + " DIV 28) + 1"
							, 0));
  
   
   var ssumpg = "SUM(" + IIF("l.fis9='п'", "s.fsum", 0) + ")";
   var ssummp = "SUM(" + IIF("l.fis1='+' AND l.fis9='м'", "s.fsum", 0) + ")";      
   var ssumps = "SUM(" + IIF("l.fis1='#' AND l.fis9='м'", "s.fsum", 0) + ")";      
   var ssumdox = "SUM(" + IIF("l.fis6='+'", "s.fsum", 0) + ")";
   var ssum = "SUM(" + IIF("l.fis1='+' AND not l.fis9 in ('*','+','#','п','о','у','т','н')", "s.fsum", 0) + ")";
   var ssum_n = "SUM(" + IIF("l.fis9='н'", "s.fsum", 0) + ")";
   var ssumd = "SUM(" + IIF("l.fis9='*'", "s.fsum", 0) + ")";
   var ssumsn = "SUM(" + IIF("l.fis9='+'", "s.fsum", 0) + ")";
   var ssumso = "SUM(" + IIF("l.fis9='#'", "s.fsum", 0) + ")";
   var ssuml = "SUM(" + IIF("l.fis1='а'", "s.fsum", 0) + ")";
   var ssum_s = "SUM(" + IIF("l.fis1='#' AND l.fis9<>'т'", "s.fsum", 0) + ")";
   var ssum_p = "SUM(" + IIF("l.fis1='р'", "s.fsum", 0) + ")";
   var ssum_z = "SUM(" + IIF("l.fis5='г'", "s.fsum", 0) + ")";
   var ssumon = "SUM(" + IIF("l.fis9='о'", "s.fsum", 0) + ")";   
   var ssumoo = "SUM(" + IIF("l.fis9='у'", "s.fsum", 0) + ")";      
   var ssumtr = "SUM(" + IIF("l.fis1='#' AND l.fis9='т'", "s.fsum", 0) + ")";      
   var uderg_nlg = "SUM(" + IIF("l.fis5='-'", "s.fsum", 0) + ")";
   
   var strTempTableName = getTmpTableName();
   
   strSQL = "SELECT fwid_wp, fvp, " + strOffset + " AS offset"
				+ ", " + ssumpg + " AS ssumpg"
				+ ", " + ssummp + " AS ssummp"
				+ ", " + ssummps + " AS ssummps"
				+ ", " + ssumdox + " AS ssumdox"
				+ ", " + ssum + " AS ssum"
				+ ", " + ssum_n + " AS ssum_n"
				+ ", " + ssumd + " AS ssumd"
				+ ", " + ssumsn + " AS ssumsn"
				+ ", " + ssumso + " AS ssumso"
				+ ", " + ssuml + " AS ssuml"
				+ ", " + ssum_s + " AS ssum_s"
				+ ", " + ssum_p + " AS ssum_p"
				+ ", " + ssum_z + " AS ssum_z"
				+ ", " + ssumon + " AS ssumon"
				+ ", " + ssumoo + " AS ssumoo"
				+ ", " + ssumtr + " AS ssumtr"
				+ ", " + uderg_nlg + " AS uderg_nlg"
			+ " INTO " + strTempTableName
			+ " FROM ^" + strPrevTabName + " AS s LEFT JOIN ^lic_fld AS l ON s.flsfid=l.fid"
			+ " WHERE " + strOffset + ">=1 " + sqlTabn
			+ " GROUP BY fwid_wp, fvp, " + strOffset;
	ExecuteSQL(strSQL);
	
	var strMn = IIF("t.offset>1", "DATE_ADD(" + sqlTo(month) + ", INTERVAL t.offset MONTH)", sqlTo(d00));
   
   	var sum_lg = IIF(sqlRound("t.ssumdox*" + procsl + "/100",2)+">" + minnal,minnal,"t.ssumdox*" + procsl + "/100",2);
   	var ssum_strn = IIF("t.ssumsn-" + sum_lg + ">0","t.ssumsn-" + sum_lg,"0");
   	var ssum_stro = IIF("t.ssumso-" + sum_lg + ">0","t.ssumso-" + sum_lg,"0");
   	
   	if (VVLSFID2 != null && VVLSFID2 != 0)
	{
			
			var c4sum = sqlRound("(t.ssumsn-" + ssum_strn + ")+(t.ssumso-" + ssum_stro + ")",2);
			strSQL = "INSERT INTO ^" + strMainTabName + " (fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt, fday, fis_day)"
					+ " SELECT t.fwid_wp"
					+ ", " + c4sum+ " AS fsum"
					+ ", " + VVLSFID2 + " AS flsfid"
					+ ", " + IIF(sqlTo(lsfid2) + "<>0"
								, "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid)  + ")"
								, 0) + " AS ffld_num"
					+ ", " + strMn + " AS fmn"
					+ ", t.fvp"
					+ ", " + vvprk + " AS fvid_prk"
					+ ", " + sqlTrue + " AS favt"
					+ ", 0 "
					+ ", 2 "
				+ " FROM " + strTempTableName + " AS t";
				+ " WHERE " + c4sum + "<>0"
			ExecuteSQL(strSQL);
	}
	
	var begy_mdat = new Date(mdat.getFullYear(),0,1);	
  	var sumallmp = "select SUM(fmpl.Fsum) from ^prk_fmpl as fmpl where fmpl.fvd='MP' and fmpl.Fwid_wp=t.fwid_wp and (fmpl.Fdat_vp>=" + sqlTo(begy_mdat) + " and fmpl.Fdat_vp<" + sqlTo(mdat) +")";
  	var xx1 = IIF("(t.ssummp+t.ssummps+" + sumallmp + "-" + minnal + ")>0","t.ssummp+t.ssummps+" + sumallmp + "-" + minnal,"0");
  	var ob_mp = IIF("(t.ssummp+t.ssummps)>"+xx1,xx1,"t.ssummp+t.ssummps");
  	var neob_mp = IIF("(t.ssummp+t.ssummps)>"+ob_mp,"(t.ssummp+t.ssummps)-"+ob_mp,"0");
  	var ssum_obn = IIF("(t.ssumon-"+minnal+")>0","(t.ssumon-"+minnal+")","0");
  	var ssum_obo = IIF("(t.ssumoo"+minnal+")>0","(t.ssumoo-"+minnal+")","0");
  	var ssum_pog = IIF("(t.ssumpg-"+npogr+")>0","t.ssumpg-"+npogr,"0");
  	var ost_na_pit = "t.ssum_p-" + IIF("t.ssum_p<>0","t.ssum_p",pitan);
  	var mF_SUM_ZP = "t.ssum+"+ost_na_pit+"-t.ssum_z-t.ssuml+"+ssum_stro;
  	var mF_SUM = "t.ssum+t.ssumd+" + ost_na_pit+"-t.ssum_z-t.ssuml-t.uderg_nlg+"+ssum_strn+"+"+ssum_stro;
 	var mF_SUMx = mF_SUM;
 	mF_SUM = IIF(mF_SUM +"<>0 or (" + mF_SUM + "=0 and t.ssum_s=0)",mF_SUM+"+"+ssum_pog+"+" +ssum_obo+"+"+ssum_obn,mF_SUM); 	
 	mF_SUM_ZP = IIF(mF_SUM +"<>0 or (" + mF_SUM + "=0 and t.ssum_s=0)",mF_SUM_ZP + "+" + ssum_obo + "+t.ssum_n",mF_SUM_ZP);
 	var mF_SUM_S = IIF("t.sumtr<>0 or " + mFSUM + ">0","t.ssum_s+t.ssumtr","t.ssum_s-t.uderg_nlg+t.ssumtr");
 	mF_SUM_S = IIF(mF_SUM +"=0 and t.ssum_s<>0",mF_SUM_S+"+"+ssum_pog+"+"+ssum_obn+"+"+ssum_obo+"+t.ssum_n",mF_SUM_S);
 	
 	
  	
	strSQL = "INSERT INTO ^" + strMainTabName + " (fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fvid_prk, favt, fday, fis_day)"
				+ " SELECT t.fwid_wp"
				+ ", " + c4sum+ " AS fsum"
				+ ", " + VVLSFID2 + " AS flsfid"
				+ ", " + IIF(sqlTo(lsfid2) + "<>0"
							, "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid)  + ")"
							, 0) + " AS ffld_num"
				+ ", " + strMn + " AS fmn"
				+ ", t.fvp"
				+ ", " + vvprk + " AS fvid_prk"
				+ ", " + sqlTrue + " AS favt"
				+ ", 0 "
				+ ", 2 "
			+ " FROM " + strTempTableName + " AS t";
			+ " WHERE " + c4sum + "<>0"
	ExecuteSQL(strSQL);
   
    
}