/*
Общая процедура для расчета отпукных индекс повышения з/п koef_sr
*/
include("koef_sr.js");
include("koef_otp.js");
include("servis/zrp.js");
function r_otpall(rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, tbl_TIME_KL, tbl_CL_KALEN)
{
   var vid_sred = obj_PRK_B.vid_sred;
   var plusfmp  = obj_PRK_B.plusfmp;

   var arrmes = new Array(d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj,d00obj)
   var arrkoldn  = new Array(0,0,0,0,0,0,0,0,0,0,0,0)
   var arrsum    = new Array(0,0,0,0,0,0,0,0,0,0,0,0)

   var D1,D2;
   var mFtabn,mFdatotp,t_sum,t_time,month_sum,mn_count;
   var fail,pdt,db,db1,dt;
   var fmp_ssum,sredn,ssum,tm;

   //установ. даты на начало и конец расчетного месяца
   var data = new Date(rasch_mes);
   D1 = new Date(firstDayMonth(rasch_mes)); 
 
   D2 = new Date(lastDayMonth(rasch_mes)); 

   DnOtp = get_cnst ("dnotp", rasch_mes);

   rmode = obj_PRK_B.rmode;
   mFtabn = obj_PRK_B.Ftabn_id;
   mFdatotp = obj_PRK_B.Fdat_bol;
   t_sum = 0;
   t_time = 0;
   month_sum = 0;
   fail = false;
	

   dtek = new Date(mFdatotp);
 
   dtek = new Date(dtek.getFullYear(),dtek.getMonth(),1);
  // dtek=dtek.getVarDate();//первый день месяца начало отпуска


   // вычислить первое число отпускного месяца 
   db = new Date(mFdatotp);
   db = new Date(db.getFullYear(),db.getMonth(),1);
   pdt = db;

   fmp_ssum = 0
   if (plusfmp)
   {
   	  //26.05.08  Для Боярки  Если параметр POMOTP, то в r_premblot годовая премия не умножается на повышающий коэффициент	 
   	  if (obj_PRK_B.pomotp=="POMOTP"){	
      	Ok = r_premblot(DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, null, "POMOTP");
   	  }else{	
      	Ok = r_premblot(DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B);
   	  }	        
      if (Ok) fmp_ssum = obj_PRK_B.fmp_ssum
      fmp_ssum = round(fmp_ssum*obj_PRK_B.mFkoef_gp,2)
   }

   dt = pdt;
   
	var dat_prin;
	if(isDateType(obj_PRK_B.dat_prin))
		dat_prin = new Date(obj_PRK_B.dat_prin);
	else
	{   		
		if(isDateType(oCl))
			dat_prin = new Date(oCl);
		else
		{
			if(oCl)
				dat_prin = new Date(oCl.get3("FWRKDAT"));
		}
	}
      		
   if (typeof(dat_prin)=="undefined" || dat_prin==null || differ(d00,dat_prin)==0)
   {
      msg = ru("Отсутствует дата принятия на работу для таб.№ ",
      		"Відсутня дата прийняття на роботу для таб.№ ")+getCodFromID(mFtabn)
      writeToLog(msg,"e",null,obj_PRK_B.fvid_prk);
      var ddt = dt;
      dat_prin = new Date(ddt.getFullYear()-1, ddt.getMonth(),1);
   }

   sredn = 0;

   //super vv 15.10.2001
   // переменная-признак того, что в хотя бы в одном из месяцев была ненулевая
   // статистика
   var isStat = false;

   if (!fail)
   {
      for (var i=0;i<12;i++)
      {
         //установиться на предыдущий месяц
        // dt = new Date(dt);
         dt = new Date(dt.getFullYear(),dt.getMonth()-1,1);
        // dt = dt.getVarDate();
         arrmes[i] = dt;
         gS = getSnap("select Fld_stor" + vid_sred + ", Fld_stor19 "
         		+" from ^SRED_INI "
         		+" where ftabn_id="+ mFtabn 
         			//+" and fvid_sr="+ vid_sred 
         			+" and fld_date=" + sqlTo(dt));
        // OK = tbl_SRED_INI.Seek("=",mFtabn,vid_sred,dt);       
         if (gS != null)
         {
			//Tori 29.07.2010: Шепитовка индексирует отпускные по следующему алгоритму: учитывается коефициент в месяце расчета и применяется для каждого месяца статистики
			if(get_cnst("koef_otp", dtek))
				month_sum = round(Number(gS[0])*koef_otp(dtek),2);
			else
				month_sum = round(Number(gS[0])*koef_sr(dtek,dt),2);
			//чернобыльские доплаты добавляем из отдельной статистики с кодом 19, т.к. они не должны индексироваться согласно
			//"закону України про індексацію доходів громадян №491/4 від 06.02.03"
			if(vid_sred == 1)
				month_sum += round(Number(gS[1]),2);
         }
         else
         {
            month_sum = 0;
            msg = "Нет среднего для таб.№ "+getClcodByID(getPar("CODPERS"),mFtabn)+" за "+format("dd.mm.yyyy",dt);
            //DefVed.write(msg, "", 0);
            writeToLog(msg,"w",null,obj_PRK_B.fvid_prk);
         }
         
         xxxx = "+"; 
         gS = getSnap("select Fld_stor from ^WT_LBL_O "
         			+" where ftabn_id="+ mFtabn 
         				+" and fld_date=" + sqlTo(dt));
         if (gS != null)
            xxxx = gS[0];

         if ((xxxx!="-" || xxxx==null) && (differ(dt,dat_prin)>0 || !differ(dt,dat_prin)))  
         {
            //super vv 15.10.2001 если в статистике не 0, то заменим это
            if(month_sum!=0)
            {
               isStat = true;
            }

            t_sum = t_sum+month_sum+fmp_ssum;
            arrsum[i] = month_sum+fmp_ssum;

            tm = 0;
            if (rmode!="KL")
            {
                gS = getSnap("select FOTP_DAY from ^TIME_KL "
                			+" where FTABN_ID="+ mFtabn 
                				+" and fld_date=" + sqlTo(dt));
                if (gS != null) 
                	tm = gS[0];
               	else tm = 0;
            }  
            //считать время отпуска по справочнику количества календарных дней
            var dtpr =  new Date(dat_prin.getFullYear(),dat_prin.getMonth()+1, 1);
            if ((DnOtp==0) || (round(((pdt-dtpr)/86400000)/30.4367,0)<12))
            {
				 gS = getSnap("select Fkoldn from ^CL_KALEN where fbdat=" + sqlTo(dt));	              	
               if (gS != null)
               {
                  t_time = t_time+Number(gS[0])-tm
                  arrkoldn[i] = Number(gS[0])-tm;
               }
               else
               {
                  msg = ru("Нет информации в списке кол-ва календарных дней для отпускных за ","Немає інформації в списку кількості календарних днів для відпускних за")+format("dd.mm.yy",dt)
                  		+"\n Меню: "+getMenuItemPath("l_kalen.js","l");
                  //DefVed.write(msg,"",0);
                  writeToLog(msg,"e",null,obj_PRK_B.fvid_prk);
               }
            }
            else
            {
               t_time = t_time-tm
            }
         }
         else
         {
            arrmes[i] = d00obj;      
         }
      }
      if ((DnOtp!=0) && (round(((pdt-dtpr)/86400000)/30.4367,0)>=12))
      {
         t_time = DnOtp+t_time
      }
      sredn = (t_time!=0)?round((t_sum/t_time),2):0;
      ssum = obj_PRK_B.Fsum*sredn;
   }
   else
      ssum = 0;   

   obj_PRK_B.Fmestot = 0;
   for (var i=0;i<12;i++)
   {
       if (differ(arrmes[i],d00obj))
       {
          obj_PRK_B.Fmestot = obj_PRK_B.Fmestot + 1
       }
   }

   obj_PRK_B.Fdntot = 0;
   for (var i=0;i<12;i++)
   {
       obj_PRK_B.Fdntot = obj_PRK_B.Fdntot + arrkoldn[i]
   }

   if (obj_PRK_B.vid_sred==1)
   {
      obj_PRK_B.Fsumtot = 0;
      for (var i=0;i<12;i++)
      {
          obj_PRK_B.Fsumtot = obj_PRK_B.Fsumtot + arrsum[i]
      }
      obj_PRK_B.ssum = ssum; //сумма отпускных
      obj_PRK_B.Fsredn    = sredn;             
   }
   else
   {
      obj_PRK_B.Fsumfakp = 0;

      //super vv 15.10.2001
      // Решаем проблему: если у человека не біло статистики ни в одном из
      // месяцев, в arrsum[i] содержится 1/12 13-й зарплаты. При этом если
      // ничего не предпринять, то начислятся отпукные. Поэтому обнулим суммы
      // т.к. отпускные не положены.
     
      if(isStat)
      {
         for (var i=0;i<12;i++)
         {
             obj_PRK_B.Fsumfakp = obj_PRK_B.Fsumfakp + arrsum[i]
         }
         obj_PRK_B.ssump = ssum; //сумма отпускных
         obj_PRK_B.Fsrednp = sredn;
      }
      else
      {
         for (var i=0;i<12;i++)
         {
             arrsum[i] = 0;
         }
         obj_PRK_B.ssump = 0; //сумма отпускных
         obj_PRK_B.Fsrednp = 0;
      }
   }

	//26.05.08  Для Боярки  Записываем сюда результат, на расчет отпускных не влияет, там результаты передаются по своим переменным
   obj_PRK_B.spomotp = round(t_sum/12,2);

   obj_PRK_B.Fstmonth1 = arrmes[0];
   obj_PRK_B.Fstmonth2 = arrmes[1];
   obj_PRK_B.Fstmonth3 = arrmes[2];
   obj_PRK_B.Fstmonth4 = arrmes[3];
   obj_PRK_B.Fstmonth5 = arrmes[4];
   obj_PRK_B.Fstmonth6 = arrmes[5];
   obj_PRK_B.Fstmonth7 = arrmes[6];
   obj_PRK_B.Fstmonth8 = arrmes[7];
   obj_PRK_B.Fstmonth9 = arrmes[8];
   obj_PRK_B.Fstmonth10 = arrmes[9];
   obj_PRK_B.Fstmonth11 = arrmes[10];
   obj_PRK_B.Fstmonth12 = arrmes[11];

   obj_PRK_B.Fkoldn1 = arrkoldn[0];
   obj_PRK_B.Fkoldn2 = arrkoldn[1];
   obj_PRK_B.Fkoldn3 = arrkoldn[2];
   obj_PRK_B.Fkoldn4 = arrkoldn[3];
   obj_PRK_B.Fkoldn5 = arrkoldn[4];
   obj_PRK_B.Fkoldn6 = arrkoldn[5];
   obj_PRK_B.Fkoldn7 = arrkoldn[6];
   obj_PRK_B.Fkoldn8 = arrkoldn[7];
   obj_PRK_B.Fkoldn9 = arrkoldn[8];
   obj_PRK_B.Fkoldn10 = arrkoldn[9];
   obj_PRK_B.Fkoldn11 = arrkoldn[10];
   obj_PRK_B.Fkoldn12 = arrkoldn[11];

   if (obj_PRK_B.vid_sred==1)
   {
      obj_PRK_B.Fsumfakt1 = arrsum[0];
      obj_PRK_B.Fsumfakt2 = arrsum[1];
      obj_PRK_B.Fsumfakt3 = arrsum[2];
      obj_PRK_B.Fsumfakt4 = arrsum[3];
      obj_PRK_B.Fsumfakt5 = arrsum[4];
      obj_PRK_B.Fsumfakt6 = arrsum[5];
      obj_PRK_B.Fsumfakt7 = arrsum[6];
      obj_PRK_B.Fsumfakt8 = arrsum[7];
      obj_PRK_B.Fsumfakt9 = arrsum[8];
      obj_PRK_B.Fsumfakt10 = arrsum[9];
      obj_PRK_B.Fsumfakt11 = arrsum[10];
      obj_PRK_B.Fsumfakt12 = arrsum[11];
   }
   else
   {
      obj_PRK_B.Fsumfakp1 = arrsum[0];
      obj_PRK_B.Fsumfakp2 = arrsum[1];
      obj_PRK_B.Fsumfakp3 = arrsum[2];
      obj_PRK_B.Fsumfakp4 = arrsum[3];
      obj_PRK_B.Fsumfakp5 = arrsum[4];
      obj_PRK_B.Fsumfakp6 = arrsum[5];
      obj_PRK_B.Fsumfakp7 = arrsum[6];
      obj_PRK_B.Fsumfakp8 = arrsum[7];
      obj_PRK_B.Fsumfakp9 = arrsum[8];
      obj_PRK_B.Fsumfakp10 = arrsum[9];
      obj_PRK_B.Fsumfakp11 = arrsum[10];
      obj_PRK_B.Fsumfakp12 = arrsum[11];
   }

   return true;
}
