/*
Расчет матпомощи к отпускам по алгоритму боярской Укргазтехсвязи
*/
include("objects\\DpDefVed.js")
include("objects\\DpCl.js")
include("prik\\calculate\\r_otpall.js")
include("prik\\calculate\\r_premblot.js")
include("get_cnst.js");

var tbl_DTPRKB, tbl_PRK_FMPL, tbl_WT_LBL_O, tbl_WT_LBL_B, tbl_SRED_INI, tbl_CL_KALEN;

function name_pomotp()
{
	return "Матдопомога до відпустки по середньому|Матпомощь к отпуску по среднему";
}
function r_pomotp(rasch_mes,VVOPL,VVPRK,VVLSFID,VVLSFID2,ftabn_id,svzpName)
{ 
   var DefVed = new DpDefVed();
   var D1,D2;
   var mFtabn,mFdatotp,mFvp,mFmn,pdt,db,db1,dt;
   var ssum;
   
    // достаем цифры к названию файла
   if (rasch_mes.getMonth() < 9)  
      szTag = String(rasch_mes.getFullYear()) + "0"+String(rasch_mes.getMonth()+1);
   else
      szTag = String(rasch_mes.getFullYear()) + String(rasch_mes.getMonth()+1);  

   //установ. даты на начало и конец расчетного месяца
   var data = new Date(rasch_mes);
   D1=new Date (data.getFullYear(),data.getMonth(),1); 
   //D1=D1.getVarDate();
   D2=new Date (data.getFullYear(),data.getMonth()+1,0); 
   //D2=D2.getVarDate();
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
    if (VVOPL<9000)
      tbl_PRK_O = OpenTable("s", "SELECT p.*, w.fwid_cl as ftabn_id FROM ^PRK_ALL as p"
      		+" INNER JOIN ^work_pers as w on w.fwid=p.fwid_wp"
            +" WHERE p.FVID_PRK="+sqlTo(VVPRK)
            +" AND w.FVOPL="+sqlTo(VVOPL)
            +" AND ( (p.FBDAT>="+sqlTo(D1)
            +" AND p.FBDAT<="+sqlTo(D2)
            +" AND p.FEDAT>="+sqlTo(D1)
            +" AND p.FEDAT<="+sqlTo(D2)+")"
            +" OR (p.FDAT_PRIK>="+sqlTo(D1)
            +" AND p.FDAT_PRIK<="+sqlTo(D2)+") )" + sqlTabn)
   else //VVOPL>=9000            
      tbl_PRK_O = OpenTable("s", "SELECT p.*, w.fwid_cl as ftabn_id FROM ^PRK_ALL as p"
      		+" INNER JOIN ^work_pers as w on w.fwid=p.fwid_wp"
            +" WHERE p.FVID_PRK="+sqlTo(VVPRK)
            +" AND ( (p.FBDAT>="+sqlTo(D1)
            +" AND p.FBDAT<="+sqlTo(D2)
            +" AND p.FEDAT>="+sqlTo(D1)
            +" AND p.FEDAT<="+sqlTo(D2)+")"
            +" OR (p.FDAT_PRIK>="+sqlTo(D1)
            +" AND p.FDAT_PRIK<="+sqlTo(D2)+") )" + sqlTabn);
	if (tbl_PRK_O.IsEmpty())
	{
		tbl_PRK_O.close();
		return false;
	}
 
   if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
   { 
      msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
      writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
      tbl_PRK_O.close();
      return false;
   }

   var obj_PRK_B = new Object(); 
   obj_PRK_B.vid_sred = 1;

   tbl_PRK_O.MoveFirst();
   while (!tbl_PRK_O.IsEOF())
   {
      mFtabn = tbl_PRK_O.getValue("Ftabn_id");
      //mFdatotp = tbl_PRK_O.getValue("Fdat_otp");
      mFdatotp = tbl_PRK_O.getValue("Fbdat");
      obj_PRK_B.rmode = "K3";
      obj_PRK_B.Fwid_wp = tbl_PRK_O.getValue("Fwid_wp");
      obj_PRK_B.Ftabn_id = mFtabn;
      //obj_PRK_B.Fsht_id = tbl_PRK_O.getValue("Fsht_id");
      //obj_PRK_B.Fdat_bol = tbl_PRK_O.getValue("Fdat_otp");
      obj_PRK_B.Fdat_bol = tbl_PRK_O.getValue("Fbdat");      
      obj_PRK_B.Fsum = tbl_PRK_O.getValue("Fsum");
      obj_PRK_B.plusfmp = false;
      obj_PRK_B.mFkoef_gp = (Number(tbl_PRK_O.getValue("Fkoef")) == 0?1:tbl_PRK_O.getValue("Fkoef"))
      obj_PRK_B.pomotp  = "POMOTP";      
      obj_PRK_B.spomotp = 0;
      //oCl.setFWID(mFtabn);                  
	  var oCL = getSnap("SELECT FWRKDAT "
					+" FROM ^cl_homo"
					+" WHERE fwid_cl=" + mFtabn
					, false);
	  if(oCL)	
			obj_PRK_B.dat_prin = oCL[0];
      
      if ((new Date(tbl_PRK_O.getValue("Fbdat"))>=D1)&&(new Date(tbl_PRK_O.getValue("Fbdat"))<=D2)&&(new Date(tbl_PRK_O.getValue("Fedat"))>=D1)&&(new Date(tbl_PRK_O.getValue("Fedat"))<=D2))
      {
         mFvp = 0;
         mFmn = d00;
      }
      else
      {
         mFvp = 2;
         db = new Date(tbl_PRK_O.getValue("Fbdat"));
         db = new Date(db.getFullYear(),db.getMonth(),1);
         db = db.getVarDate();
         mFmn = db;
      }
      // вычислить первое число отпускного месяца  
      db = new Date(mFdatotp);
      db = new Date(db.getFullYear(),db.getMonth(),1);
      pdt = db.getVarDate();
      obj_PRK_B.fvid_prk = VVPRK;

      Ok = r_otpall(rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B);   //, tbl_WT_LBL_O, tbl_SRED_INI, oCl, tbl_TIME_KL, tbl_CL_KALEN	//e 01.02.2007: нафига так много параметров...
      if (Ok) ssum = obj_PRK_B.spomotp;   

      var m = new Object();
      if (ssum!=0)
      {
         m.Fwid_wp = tbl_PRK_O.getValue("Fwid_wp");
		 var oSnap = getSnap("SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(VVLSFID))
		 if(oSnap!=null)
		 	m.Ffld_num = oSnap[0];
         m.Fvid_prk = VVPRK;
         m.Flsfid = VVLSFID; 
         m.Fsum = round(ssum,0);
         m.Ftabn_id = tbl_PRK_O.getValue("Ftabn_id");
         m.fshpz = tbl_PRK_O.getValue("FSHPZ");
         var gd = new Date(tbl_PRK_O.getValue("Fbdat"));
         gd = gd.getDate();
         m.Fbdy = gd;  
         m.Fday = tbl_PRK_O.getValue("Fsum");  
         m.Fvp = mFvp; 
         m.Fmn = mFmn;
         m.Fis_day = 0;
         m.Fid_prk = tbl_PRK_O.getValue("Fwid");
       UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
      }
      tbl_PRK_O.MoveNext();
   }//while
   tbl_PRK_O.close();
   DefVed.end();
   return true;
}