//расчет командировочных  - время из табелей, сравнение с суммой по колдоговору
include("objects\\DpDefVed.js")
include("prik/calculate/r_srallvs.js")
include("prik/calculate/r_premblot.js")
include("prik/calculate/r_premkm.js")

function name_sr5kis()
{
	return "Розрахунок відрядних з табелів|Расчет командировочных из табелей";
}

function r_sr5kis(rasch_mes,VVOPL,VVPRK,VVLSFID,VVLSFID2,ftabn_id,svzpName)
{
//*********************
   mdat  = new Date(rasch_mes);
   // достаем цифры к названию файла
  
   if (rasch_mes.getMonth() < 9)  
      var szTag = String(rasch_mes.getFullYear()) + "0"+String(rasch_mes.getMonth()+1);
   else
      var szTag = String(rasch_mes.getFullYear()) + String(rasch_mes.getMonth()+1);    

   // дата для фильтрации записей таблицы "TBL_INI"
   var DatePer = new Date(mdat.getFullYear(),mdat.getMonth(),1); 
   
   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1); 
   
   // дата конца
  // var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
   var D2 = new Date(lastDayMonth(mdat)); 

   szName = "zrp_STT1"+szTag;
   tiName = "TBL"+szTag;
   siName = "STT1"+szTag;
   
   
   var strSQL = "SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(VVLSFID);
	var snap = getSnap(strSQL);
	var mvvdpl=0;
  
   if (snap != null)
  	   mvvdpl = snap[0];
      
   if(!IsTableEx("zrp_mdb", szName))
   {
	   msg = "Не заполнены табеля за "+szTag+" для вида оплаты"+ String(VVOPL);
	   writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
       return;
   }
	var sqlTabn = ftabn_id?" and A.Ftabn_id in ("+ftabn_id+") ":"";
	ExecuteSQL("drop table CH_TABK", false);
	var StrInt=" INTO CH_TABK";
	//var StrFrW=" FROM "+tiName +" WHERE FKOD_NVK=7";
    StrSQL="SELECT B.FDAY_NVK,B.FCHASNVK,B.FBDAT,B.FEDAT," + Convert("0","DBL") + " AS FOKLAD"
				+"," + Convert("0","DBL") + " AS FDAY_NORM," + Convert("0","DBL") + " AS FCHAS_NORM," + Convert("0","DBL") + " AS FSUM_D,'0' AS FSHPZ"
				//	+",B.FTABN,A.FID AS FSHT_ID,"+sqlTo(GetUID())+" AS FWID"
				+",A.FTABN_ID,A.FWID_WP, B.FWID AS FWID"
				+ StrInt
			+" FROM ^"+tiName+" AS B,^"+siName+" AS A"
			+" WHERE B.FKOD_NVK=7"
				+" AND A.FWID_WP=B.FWID_WP"
				//+" AND A.FID=B.FID"
				+" AND (B.FCHASNVK>0 OR B.FDAY_NVK>0)"
				+" AND A.FBDAT=B.FBDAT"
				+" AND A.FEDAT=B.FEDAT"
				+sqlTabn
	ExecuteSQL(StrSQL)
//*********************

   var mOkldad,mDays,mChas,mSums;//supercom 12-12-2002
   var DefVed = new DpDefVed();
   var tbl_PRK_B;
   var tbl_PRK_FMPL;
   var tbl_DTPRKB;
   var tbl_TIME_WR2;
   var tbl_WT_LBL_B;
   
   
   var tbl_SHTAT;
   var tbl_SVZP;

   var D1,D2,sfbdat,sfedat;
   var obj_PRK_B = new Object();

   //установ. даты на начало и конец расчетного месяца
   var data = new Date(rasch_mes);
   D1= new Date (data.getFullYear(),data.getMonth(),1);
   D2= new Date(lastDayMonth(data));
   
   datst=new Date (D1.getFullYear(),D1.getMonth-1-2,1);//supercom 12-12-2002
 //  D1=D1.getVarDate();
   //дата начала нужно статистики
   tbl_PRK_B = OpenTable("s", "SELECT * FROM CH_TABK");

   if (tbl_PRK_B.IsEmpty())
   {
      tbl_PRK_B.close();
      return false;
   }
	
		//tbl_DTPRKB = OpenTable("s","DTPRKB");
		//tbl_DTPRKB.index = "FTABN,FBDAT";
		//tbl_PRK_FMPL = OpenTable("s","PRK_FMPL");
		//tbl_PRK_FMPL.index = "FTABN";
		//tbl_WT_LBL_B = OpenTable("s","WT_LBL_B");
		//tbl_WT_LBL_B.index = "FTABN,FLD_DATE";
		
		//tbl_TIME_WR2 = OpenTable("s","TIME_GO"); //TC
		//tbl_TIME_WR2.index = "FTABN, FLD_DATE";
		
		//tbl_SHTAT = OpenTable("s","select wp.*,dol.Foklad as foklad from ^WORK_PERS as wp INNER JOIN ^stru_dol as dol ON dol.fwid=wp.fwid_dol");
		//tbl_SHTAT.index = "Fwid_cl";
	
   if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
   {
      msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
      writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
      tbl_PRK_B.close();
      return false;
   }
   //tbl_SVZP=OpenTable("s",""+(svzpName?svzpName:"svzp")+szTag);

	var tbl_TAB = getSnap("select FID from ^TBL"+ szTag, false);
   obj_PRK_B.isTBL = tbl_TAB!=null;
	
   msg = "расчет командировки по среднему за два предыдущих месяца";
   //DefVed.begin("",msg);
   writeToLog(msg,"m",VVOPL,VVPRK,VVLSFID);
	
	var mDaysIni;
	var mChasIni;
	var TBL_INI = getSnap("SELECT A.FVSEGO_D,A.FVSEGO_CH"
                        +" FROM ^TBL_INI AS A"
                       	+" WHERE A.FVOPL="+ VVOPL
                        	+" AND A.FBDAT="+ sqlTo(data))
	if(TBL_INI)
	{
		mDaysIni = Number(TBL_INI[0]);
		mChasIni = Number(TBL_INI[1]);				
	}
	
   tbl_PRK_B.MoveFirst();
   while (!tbl_PRK_B.IsEOF())
   {
      /*
      Цикл по сегментам отпуска. Сам отпуск задается датами fbdat,fedat
      Он дробится на сегменты sfbdat,sfedat, каждый из которых
      полностью попадает в рамки месяца
      */

      //Начальная установка месяца для расчета отпускных
      //Установить сегмент отпуска, попадающий в месяц (D1,D2)
      //sfbdat = Math.max(D1,tbl_PRK_B("FBDAT"));
      //sfedat = Math.min(D2,tbl_PRK_B("FEDAT"));
      dt_bl  = new Date(rasch_mes.getFullYear(),rasch_mes.getMonth(),Number(tbl_PRK_B.getValue("FBDAT")));
      dt_bl2 = new Date(rasch_mes.getFullYear(),rasch_mes.getMonth(),Number(tbl_PRK_B.getValue("FEDAT")));

      sfbdat = dt_bl;
      sfedat = dt_bl2;

      obj_PRK_B.rmode = "SR5";
      obj_PRK_B.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
      obj_PRK_B.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
      //obj_PRK_B.Fdat_bol = tbl_PRK_B("Fdat_bol");//начало периода наступления нетрудоспособности
      obj_PRK_B.Fdat_bol = dt_bl;//начало периода наступления нетрудоспособности
      obj_PRK_B.ssum = 0;
      //obj_PRK_B.Fsum = tbl_PRK_B("Fsum");
      //obj_PRK_B.Fproc = tbl_PRK_B("Fproc");
      //obj_PRK_B.Fnom_prik = tbl_PRK_B("Fnom_prik");
      //obj_PRK_B.Fdat_prik = tbl_PRK_B("Fdat_prik");
      obj_PRK_B.Fnom_prik = 0;
      obj_PRK_B.Fdat_prik = 0;
      //obj_PRK_B.prk_dy = Math.floor(obj_PRK_B.Fsum/1000);
      //obj_PRK_B.prk_ch = obj_PRK_B.Fsum-obj_PRK_B.prk_dy*1000;
      obj_PRK_B.prk_dy = tbl_PRK_B.getValue("FDAY_NVK");
      obj_PRK_B.prk_ch = tbl_PRK_B.getValue("FCHASNVK");
      obj_PRK_B.TM_IN_DY = (obj_PRK_B.prk_ch==0);
      //obj_PRK_B.dat_vip  = tbl_PRK_B("Fmes_vip")
      obj_PRK_B.dat_vip  = dt_bl;
      obj_PRK_B.Fproc = 100;
      obj_PRK_B.fvid_prk = VVPRK;
      obj_PRK_B.svzpnm = "^"+(svzpName?svzpName:"svzp")+szTag;
      obj_PRK_B.Fisnorm = false;      

      if (obj_PRK_B.isTBL)
      {
         Ok = r_srallvs("",rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B);
      }
      else
      {
         Ok = r_srallvs("",rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B);
      }
      //tbl_DTPRKB.close();
      //tbl_PRK_FMPL.close();
      //tbl_WT_LBL_B.close();
      //tbl_TIME_WR2.close();
      if (Ok)
      {
         //определение, к какому периоду относится больничный
         mFvp = 0;
         mFmn = d00;
         //если начало отпуска и сам отпуск попадают в текущий месяц
         if ((sfbdat>=D1)&&(sfbdat<=D2)&&(sfedat>=D1)&&(sfedat<=D2))
         {
            mFvp = 0
         }
         else
         {
            if (!((sfbdat>=D1 && sfbdat<=D2) && (sfedat>=D1 && sfedat<=D2)) &&
               (obj_PRK_B.dat_vip>=D1 && obj_PRK_B.dat_vip<=D2))
             {
               mFvp = 2;
               db = sfbdat;
               db = new Date (db.getFullYear(),db.getMonth(),1);
               mFmn = db;
            }
         }
		
         //во внутренней процедуре считаем расчет по тому что больше - по-среднему или колдоговор. Если там получился 0 (вообще-то такого
         //не должно быть, оставим со старых времен расчет по окладу.
		//перенес с 2000-й версии исправления, которые внесла Цимбал Т.А.
		if(obj_PRK_B.ssum == 0)
		{
			var D11=new Date(D1.getFullYear(),D1.getMonth()-1,1);
			var D12=new Date(D11.getFullYear(),D11.getMonth()-1,1);
			if(obj_PRK_B.prk_dy>=1)
				str_and=" AND Fgo_day>0";
			else
				str_and=" AND Fgo_time>0";
			var tbl_TIME = OpenTable("SELECT * FROM ^TIME_GO WHERE FTABN_ID="+tbl_PRK_B.getValue("Ftabn_id")+str_and
											+" AND (FLD_DATE="+sqlTo(D11)
											+" OR FLD_DATE="+sqlTo(D12)+")");
        
			if(tbl_TIME.IsEmpty())
			{
				var sSQL = "select dol.FOKLAD, wp.Fvopl "
					+" from ^WORK_PERS as wp "
					+" INNER JOIN ^stru_dol as dol ON dol.fwid=wp.fwid_dol"
					+" where wp.Fwid_cl="+ tbl_PRK_B.getValue("Ftabn_id")
                    	+" AND wp.FEDAT>="+ sqlTo(D1);
				var tbl_SHTAT = getSnap(sSQL);
				if(tbl_SHTAT && Number(tbl_SHTAT[0])!=0)
					mOkldad=Number(tbl_SHTAT[0]);//определяем оклад
				else
				{
					msg = "Не определен оклад для таб.№ "+getCodFromID(tbl_PRK_B.getValue("Ftabn_id"));
					writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
				}
				
				var tbl_TAB_sr5=getSnap("SELECT FDAY_NVK, FCHASNVK "
                                       +" FROM ^TBL"+getDateTag(data)
	                    			   +" WHERE FKOD_NVK=1"
				                       +" AND FWID_WP="+tbl_PRK_B.getValue("Fwid_wp")
				                       +" AND FBDAT="+tbl_PRK_B.getValue("FBDAT")
				                       +" AND FEDAT="+tbl_PRK_B.getValue("FEDAT"));
				if(!tbl_TAB_sr5)
				{
					tbl_TAB_sr5=getSnap("SELECT FNORMA_D,FNORMA_CH"
                                     +" FROM ^TBL_INI "
                                     +" WHERE FVOPL="+(tbl_SHTAT?tbl_SHTAT[1]:VVOPL)
                                     +" AND FBDAT="+sqlTo(data));
		 			if(tbl_TAB_sr5)
		 			{
		 				mChas=tbl_TAB_sr5[1];
						mDays=tbl_TAB_sr5[0];
		 			}
		 			else
		 			{
		 				msg = "Не определена норма дней/часов для таб.№ "+getCodFromID(tbl_PRK_B.getValue("Ftabn_id"));
						writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
						tbl_TIME.close();
						continue;
		 			}
				}
				else
				{
					mDays=tbl_TAB_sr5[0];
					mChas=tbl_TAB_sr5[1];
				}
				if(obj_PRK_B.prk_dy>=1)
				{
					mDays = Number(mDays);
					if (mDays==0)
					{
						msg = "Не удалось определить норму дней для виды оплаты "+(tbl_SHTAT?tbl_SHTAT[1]:VVOPL);
						writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
						tbl_PRK_B.MoveNext();
						continue;
					}
					mSums=obj_PRK_B.prk_dy;
					obj_PRK_B.ssum=round(mOkldad*mSums/mDays,2);
				}
				else
				{
					if (mChas==0)
					{
						msg = "Не удалось определить норму часов для виды оплаты "+(tbl_SHTAT?tbl_SHTAT[1]:VVOPL);
						writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
						tbl_PRK_B.MoveNext();
						continue;
					}
					mChas = Number(mChas);
					mSums=obj_PRK_B.prk_ch;
					obj_PRK_B.ssum=round(mOkldad*mSums/mChas,2);
				}
        		obj_PRK_B.ssum=obj_PRK_B.ssum*obj_PRK_B.Fproc/100;
			}
			tbl_TIME.close();
		}
		if((obj_PRK_B.ssum!=null && obj_PRK_B.ssum!=0)
				&& ((mFvp==0) || ((mFvp==2) 
				&& differ(obj_PRK_B.Fdat_bol,D1)>=0 && differ(obj_PRK_B.Fdat_bol,D2)<=0)) )
		{
           // tbl_SVZP.AddNew();
            var m = new Object();
            m.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
            m.Fid_prk = tbl_PRK_B.getValue("Fwid");
            m.fshpz = tbl_PRK_B.getValue("FSHPZ");
            m.Fvid_prk = VVPRK;
            m.Flsfid = VVLSFID;
            m.Ffld_num = mvvdpl;
            m.Fsum = round(obj_PRK_B.ssum,2);
            m.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
            //var gd = new Date(tbl_PRK_B("Fbdat"));
            var gd = dt_bl;
            //gd = gd.getDate();
            m.Fbdy = gd.getDate();
//            if (obj_PRK_B.TM_IN_DY)
               m.Fday = obj_PRK_B.prk_dy;
//            else
               m.Fchas = obj_PRK_B.prk_ch;
            if (obj_PRK_B.TM_IN_DY)
               m.Fis_day = 0
            else
               m.Fis_day = 1;
            m.Fvp = mFvp;
            m.Fmn = mFmn;
            m.Fisr_nr = obj_PRK_B.Fisnorm;            
            //tbl_SVZP.Update();
            UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
         }
      }
      tbl_PRK_B.MoveNext();
   }
   tbl_PRK_B.close();
   //tbl_SHTAT.close();
   return true;
}