// сброс квартальной и годовой премии в PRK_FMPL

function name_sumpr()
{
	return "Розрахунок статистики премій (річних, піврічних ...)|Расчет статистики премий (годовых, полугодовых...)"
}

function r_sumpr(mdat,mvvopl,mvvprk,mvvlsfid,mvvlsfid2,ftabn_id,svzpName)
{ 	
	var D1 = new Date(mdat.getYear()+1900,mdat.getMonth(),1);
   	var D2 = lastDayMonth(mdat);
	var szTag = (mdat.getYear()+ 1900)+((mdat.getMonth()< 9)?"0":"") + (mdat.getMonth()+1);    
	
    var siName = (svzpName?svzpName:"svzp")+ szTag;
        
    var mFbdat = new Date(mdat.getYear()+1900, 0, 1);
	var mFedat = new Date(mdat.getYear()+1900, 2, 31);
    if (mdat.getMonth()>=0 && mdat.getMonth()<=1)
    {
    	mFbdat = new Date(mdat.getYear()+1900-1, 9, 1)
		mFedat = new Date(mdat.getYear()+1900-1, 11, 1)
    }
    if (mdat.getMonth()>=2 && mdat.getMonth()<=4)
    {
    	mFbdat = new Date(mdat.getYear()+1900, 0, 1)
    	mFedat = new Date(mdat.getYear()+1900, 2, 31)
    }
    if (mdat.getMonth()>=5 && mdat.getMonth()<=7)
    {
    	mFbdat = new Date(mdat.getYear()+1900, 3, 1)
    	mFedat = new Date(mdat.getYear()+1900, 5, 31)
    }
    if (mdat.getMonth()>=8 && mdat.getMonth()<=10)
    {
    	mFbdat = new Date(mdat.getYear()+1900, 6, 1)
    	mFedat = new Date(mdat.getYear()+1900, 8, 31)
    }
    if (mdat.getMonth()>=11)
    {
    	mFbdat = new Date(mdat.getYear()+1900, 9, 1)
    	mFedat = new Date(mdat.getYear()+1900,11, 31)
    }
    var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
    var strSQL = "DELETE from ^PRK_FMPL where Fdat_vp=" + sqlTo(mdat) + sqlTabn
    ExecuteSQL(strSQL);
        
    ExecuteSQL("drop table TMP_PRK_FMPL", false);
    var sSQL = "create table TMP_PRK_FMPL "
    			+"(FSUMKV "+ SqlType("CURRENCY") 
    			+",FSUMPG "+ SqlType("CURRENCY")
    			+",FSUMGOD "+ SqlType("CURRENCY")
    			+",FSUMMP "+ SqlType("CURRENCY")
    			+",FBDAT "+ SqlType("DATE")
    			+",FEDAT "+ SqlType("DATE")
    			+",FDAT_VP "+ SqlType("DATE")
    			+",FWID_WP "+ SqlType("INT")
    			+",FTABN_ID "+ SqlType("INT")
    			+",FWID "+ SqlType("COUNTER")
    			+")";
    ExecuteSQL(sSQL);
    
    var ssum_kv  = "sum("+ IIF("lic.FIS4='к'", "z.FSUM", 0) +")";
    var ssum_pg  = "sum("+ IIF("lic.FIS4='p'", "z.FSUM", 0) +")";
	var ssum_god = "sum("+ IIF("lic.FIS4='г'", "z.FSUM", 0) +")";
	var ssum_mp = "sum("+ IIF("lic.FIS9='м'", "z.FSUM", 0) +")";
       
    sSQL = "insert into TMP_PRK_FMPL (FSUMKV, FSUMPG, FSUMGOD, FSUMMP, FTABN_ID)"
    		+" select "+ ssum_kv +" as FSUMKV"
    				+","+ ssum_pg +" as FSUMPG"
    				+","+ ssum_god +" as FSUMGOD"
    				+","+ ssum_mp +" as FSUMMP"
    				+", z.FTABN_ID as FTABN_ID"
    		+" from ^"+ siName +" as z "
    			+" LEFT JOIN ^LIC_FLD as lic ON lic.fid=z.flsfid"
    		+" where (FVP=0 or (FVP=1 and FMN>"+ sqlTo(mdat.getVarDate()) +"))"
    			+ (ftabn_id?" and z.Ftabn_id in ("+ftabn_id+") ":"")
    		+" group by z.FTABN_ID";
    ExecuteSQL(sSQL);
    
    var fbdat = sqlTo(mFbdat.getVarDate());
    var fedat = sqlTo(mFedat.getVarDate());
    var fdat_vp = sqlTo(mdat.getVarDate());
    var fwid_wp = "(select max(z.FWID_WP) from ^"+ siName +" as z where z.FTABN_ID=tmp.FTABN_ID)";
    
    sSQL = "insert into ^PRK_FMPL (FVD, FSUM, FBDAT, FEDAT, FDAT_VP, FWID_WP, FTABN_ID)"
    		+" select 'KV' as FVD, tmp.FSUMKV as FSUM"
    			+","+ fbdat +" as FBDAT, "+ fedat +" as FEDAT"
    			+","+ fdat_vp +" as FDAT_VP"
    			+","+ fwid_wp +" as FWID_WP "
    			+", tmp.FTABN_ID as FTABN_ID"
    		+" from TMP_PRK_FMPL as tmp "
    		+" where tmp.FSUMKV<>0 and tmp.FSUMKV is not NULL";
    ExecuteSQL(sSQL);
    
    //суммы полугодовой премии
    sSQL = "insert into ^PRK_FMPL (FVD, FSUM, FDAT_VP, FWID_WP, FTABN_ID)"
    		+" select 'PG' as FVD, tmp.FSUMPG as FSUM"
    			//+","+ fbdat +" as FBDAT, "+ fedat +" as FEDAT"
    			+","+ fdat_vp +" as FDAT_VP"
    			+","+ fwid_wp +" as FWID_WP "
    			+", tmp.FTABN_ID as FTABN_ID"
    		+" from TMP_PRK_FMPL as tmp "
    		+" where tmp.FSUMPG<>0 and tmp.FSUMPG is not NULL";
    ExecuteSQL(sSQL);
    
    //суммы мат. помощи
    sSQL = "insert into ^PRK_FMPL (FVD, FSUM, FDAT_VP, FWID_WP, FTABN_ID)"
    		+" select 'MP' as FVD, tmp.FSUMMP as FSUM"
    			+","+ fdat_vp +" as FDAT_VP"
    			+","+ fwid_wp +" as FWID_WP "
    			+", tmp.FTABN_ID as FTABN_ID"
    		+" from TMP_PRK_FMPL as tmp "
    		+" where tmp.FSUMMP<>0 and tmp.FSUMMP is not NULL";
    ExecuteSQL(sSQL);
    
    //суммы годовой премии
    if (mdat.getMonth()>=0 && mdat.getMonth()<=10)
    {
     	mFbdat = new Date(mdat.getYear()+1900-1, 0, 1)
    	mFedat = new Date(mdat.getYear()+1900-1,11, 31)
    }
   	if (mdat.getMonth()==11)
    {
    	mFbdat = new Date(mdat.getYear()+1900, 0, 1)
    	mFedat = new Date(mdat.getYear()+1900,11, 31)
    }
    fbdat = sqlTo(mFbdat.getVarDate());
    fedat = sqlTo(mFedat.getVarDate());
    
    sSQL = "insert into ^PRK_FMPL (FVD, FSUM, FBDAT, FEDAT, FDAT_VP, FWID_WP, FTABN_ID)"
    		+" select 'GO' as FVD, tmp.FSUMGOD as FSUM"
    			+","+ fbdat +" as FBDAT, "+ fedat +" as FEDAT"
    			+","+ fdat_vp +" as FDAT_VP"
    			+","+ fwid_wp +" as FWID_WP "
    			+", tmp.FTABN_ID as FTABN_ID"
    		+" from TMP_PRK_FMPL as tmp "
    		+" where tmp.FSUMGOD<>0 and tmp.FSUMGOD is not NULL";
    ExecuteSQL(sSQL);
        
    return true;
}