//расчет величины % индексации для каждого человека из приказа

include("prik/calculate/r_sind.js")
include("prik/calculate/r_bind.js")

function r_vind (drind, sotrList, result, datbase)
{
 
   iPRIK_table = OpenTable("s","SELECT * FROM ^CL_PRIK")
   var ivvprk = "";
   iPRIK_table.MoveFirst();
   while (!iPRIK_table.IsEOF())
   {
		if (String(iPRIK_table.getValue("Fproc")).indexOf("_ind")!=-1 && String(iPRIK_table.getValue("Fedit")).indexOf("_prk1")!=-1)	   
			ivvprk = iPRIK_table.getValue("Fvid")
        iPRIK_table.MoveNext();
   }
   iPRIK_table.close();	
   if (ivvprk ==""){
	   WAIT("Не найден приказ на фикс.суммы индексации")
	   result.fisres = false;	   
	   return;
   }   
	
   if(isDateType(datbase) && differ(datbase,d00obj)!=0)
      //значит, базовая запись уже известна, ее не нужно переопределять
      var izvbase = true
   else
      var izvbase = false
    
      var indZp = 0;
	//расчет индекса: для окладников берем оклад из штатного расписания, для ЧТС нужно умножить ЧТС на норму времени, чтобы
	//получить оклад и сравнивать,для сдельщиков - в константах нужно прописать количество деталей, по которым сравнивать
	
	var dt_rind  = new Date(firstDayMonth(new Date(drind)))
	var dt_rinde = new Date(lastDayMonth(new Date(drind)))	

	var fwid_shtr = new Object();

	//изменения в индексации с 2012 года
	//значение этой константы - дата перехода на новый расчет индексации, по закону - 01.06.12
	var ind2012 = get_cnst("ind2012", dt_rind)
	
	//*     взять из кл-ра const прожиточный минимум - нужен, чтобы при просчете базового месяца для расчета индексации считать
	//сумму индексации
	
	var prmin = 0

    //для  сдельщиков расценку умножаем на месячную норму выработки. Сейчас делаем в константах. Если окажется, что для разных
    //работников норма разная, то тогда нужно добавить ее в приказ и оттуда как-то доставать. Пока не будем усложнять, т.к.
    //нет реального заказчика.
	var mnorma_v = get_cnst("normavir",drind)
	
	//индексацию начисляют с 1-го числа месяца, следующего за месяцем, в котором был опубликован индекс цен, еси он >101%
	var oBdat = new Date(dt_rind.getFullYear(),dt_rind.getMonth()-2,1)	
	
	if (IsTable("TSHTD"))
		DropTable("TSHTD");
		
	strSQL="CREATE TABLE TSHTD (Ftabn_id"+SqlType("LONG")+", Fwid"+SqlType("LONG")+", Fwid_baze"+SqlType("LONG")+", Fvopl" +SqlType("INTEGER")+",Fprizn"+ SqlType("BYTE")+",Fnorma_ch"+ SqlType("DOUBLE")+", fbdat"+ SqlType("DATE")+",Ftable"+ SqlType("INTEGER")+",Fis_baze"+ SqlType("BIT")+",Fizm_dol"+ SqlType("BYTE")+",Foklad"+ SqlType("CURRENCY")+",Fsind"+ SqlType("CURRENCY")+",Fis_nazn"+ SqlType("BIT")+", fbasemind"+ SqlType("DATE")+",Ffikssum"+ SqlType("CURRENCY")+",Fprewokl"+ SqlType("CURRENCY")+")";
    ExecuteSQL(strSQL);

	DropTable("XX")	
	var strSQL = "SELECT fwid_cl, fwid, fvopl, Fbdat,Fedat INTO XX FROM ^work_pers WHERE fwid IN (" + sotrList + ")";
	ExecuteSQL(strSQL);		
	var tsht = OpenTable("s", "XX");
	var i = 0;
	//идем по отмеченным записям в приказе и для каждой из этой записи ищем базовую запись из штатного расписания, т.е. запись
	// последнего увеличения оклада
	if (!tsht.isEmpty()){
		tsht.MoveFirst();		
		while (!tsht.isEOF()){
			result.fwid_cl[Number(tsht .getValue("fwid"))] = Number(tsht.getValue("fwid_cl"));
			result.fwid[[Number(tsht .getValue("fwid"))]] = tsht.getValue("fwid");			
	    	var pFtabn_id = tsht.getValue("Fwid_cl");
	    	var pFwid     = tsht.getValue("Fwid");	    	
	    	var pFvopl    = tsht.getValue("Fvopl");
	    	//если ЗП подняли в середине месяца, то считаем, что этот месяц является базовым,т.е. повышение приравниваем к 1-му числу месяца.
	    	// Единственное, что будем считать, что последним днем месяца нормальные люди ЗП не повышают. 
	    	//ищем повышение ЗП за расчетный месяц. При этом может быть ситуация, когда ЗП подняли в середине месяца. Без end_per
	    	// получалось, что на предыдущую запись получалось началоп периода то же, что и для последней. 
	    	var end_per = (differ(dt_rinde,new Date(tsht.getValue("Fedat")))>0)?new Date(tsht.getValue("Fedat")):dt_rinde;
	    	//ишем дату последнего повышения ЗП для каждогочеловека по каждому виду оплаты, т.к. он может быть одновременно на
	    	// разных видах оплаты и ему могут повышать ЗП на каждом из видов оплаты. Для основной работы будем потом из разных
	    	// видов оплаты выбирать самую последнюю дату повышения.
    		//это fwid  базовой записи для отобранной в приказе
	    	if (izvbase==false){
	    		//если не передана базовая запись, ищем ее. Если передана, то берем данные из нее, считаем ее окончательной 		    		
	    		fwid_shtr.fwid = 0;
	    		fwid_shtr.izd	 = 0;	
	    		r_bind (end_per, pFtabn_id, pFvopl,fwid_shtr)
	    		var fwid_sh =  fwid_shtr.fwid
	    		var fizm_dl  =  fwid_shtr.izd			
	    		var oSnap = getSnap("select  dol.Foklad,wp.Fwid_cl,wp.Fbdat, wp.Ftable,wp.Fwid, wp.Fvopl, wp.Fis_nazn, wp.Fbasemind,wp.Ffikssum,wp.Fprewokl FROM ^work_pers wp INNER JOIN ^stru_dol dol "+
						" on wp.Fwid_dol=dol.Fwid where wp.Fwid_cl="+sqlTo(pFtabn_id)+" and wp.Fvopl="+sqlTo(pFvopl)+" and wp.Fwid="+sqlTo(fwid_sh))
	    	}else{
	    		var oSnap = getSnap("select  dol.Foklad,wp.Fwid_cl,wp.Fbdat, wp.Ftable,wp.Fwid, wp.Fvopl, wp.Fis_nazn, wp.Fbasemind,wp.Ffikssum,wp.Fprewokl FROM ^work_pers wp INNER JOIN ^stru_dol dol "+
						" on wp.Fwid_dol=dol.Fwid where wp.Fwid_cl="+sqlTo(pFtabn_id)+" and wp.Fvopl="+sqlTo(pFvopl)+" and wp.Fwid="+sqlTo(pFwid))
	    	}
			if (oSnap!=null){
        		var m = new Object();				
        		m.Ftabn_id   =pFtabn_id;
        		m.Fwid       =pFwid;
	    		if (izvbase==false){        		
					m.Fwid_baze  =fwid_sh;
	        		m.Fbdat      =oSnap[2];					
				}else{
					m.Fwid_baze  =pFwid;
	        		m.Fbdat      =datbase.getVarDate();					
				}	        		        		
	    		m.Ftable     =oSnap[3];
        		m.Fvopl      =pFvopl; 
    		    m.Fis_nazn   = false;        		
   		    	m.Fbasemind  =d00;
   		    	m.Ffikssum   =0;
   		    	m.Fprewokl   =0;
        		//если после принятия новой индексации приняли работника, то у него базовый месяц - предыдущий от даты приема на работу
	    		if (ind2012!=0 && oSnap[6] && differ(new Date(oSnap[2]),ind2012)>=0){
    		    	m.Fis_nazn   =oSnap[6];
    		    	m.Fbasemind  =oSnap[7];
    		    	m.Ffikssum   =oSnap[8];
    		    	m.Fprewokl   =Number(oSnap[9]);
	    		}
	    		m.Fis_baze   =true;
	    		if (izvbase==false){	    		
    		    	m.Fizm_dol   =fizm_dl;
        		}else{
        			//если пересчитываем из приказа, то считаем, что ЗП увеличивалась. Если это не так (более сложный случай, то нужно
        			//удалить запись и заново на этого человека создать приказ.
    		    	m.Fizm_dol   =0;        		
        		}
    		    m.Foklad     =Number(oSnap[0]);
    		    m.Fprizn     =1;
        		UpdateTable("TSHTD",m,true);				
	    	}	
    		tsht.MoveNext();        	
		}	
	}		
	tsht.close();

	//нашли по последней записи увеличения оклада для каждого вида оплаты для каждогочеловека, после чего нужно проверить,
	//можно ли это увеличение оклада считать базовым. Для этого нужно для каждой из этих записей просчитать сумму индексации
	//на оклад за месяц расчета. Если индексация окжется выше, то эту запись нельзя считать базовой, нужно брать предыдущую
	//запись. Берем только те записи, где человек не понижался в должности
	//если нашли, что человека понизили в должности и дошли до самой первой записи такой новой должности, то с суммой
	//индексации не сравниваем. Берем эту запись за базовую.
	//чтобы просчитать индексацию для ЧТС, нужно ЧТС, полученную из штатного расписания умножить на норму времени за месяц расчета
	//для сдельщиков будем в норму времени писать количество деталей из константы.
	//1 - признак окладников, 2 - признак ЧТС, 3 - признак сдельщиков
	strSQL = "update TSHTD set Fprizn=(select Fprizn from ^OPL_PRIZ where Fvopl=TSHTD.Fvopl)";
	if(!ExecuteSQL(strSQL))
		alert(ru("Ошибка в списке признаков видов оплаты в меню: ","Помилка в списку ознак видів полати в меню: ")+getMenuItemPath("l_opriz.js","l"));
	strSQL = "update TSHTD set Fnorma_ch=(select Fnorma_ch from ^tbl_ini where Fbdat="+sqlTo(dt_rind)+" and Fvopl=TSHTD.Fvopl) where  Fprizn=2"
	ExecuteSQL(strSQL);
	strSQL = "update TSHTD set Foklad=Foklad*Fnorma_ch where  Fprizn=2"
	ExecuteSQL(strSQL);
	strSQL = "update TSHTD set Fnorma_ch="+sqlTo(mnorma_v)+" where  Fprizn=3"
	ExecuteSQL(strSQL);
	strSQL = "update TSHTD set Foklad=Foklad*Fnorma_ch where  Fprizn=3"
	ExecuteSQL(strSQL);
	
	var baserec = getPar("LAST_BASE_MONTH")
	//если старый расчет и стоит параметр, что всегда брать базовой записью запись с повышением оклада, ничего не делаем
	//если новый расчет и стоит этот параметр, то все равно ничего не делаем
	//если новый расчет и этот параметр не стоит, то нужно анализировать дату повышения оклада. Если оклад повышен после 01,06,12,
	// то искать предыдущую базовую запись не нужно. Если оклад повышен до 01,06,12, то нужно рассчитывать индексацию по старому
	//принципу. 
	var tshtd = OpenTable("s", "select * from TSHTD where Fizm_dol=0 order by Ftabn_id, Ftable,Fvopl,Fbdat")
	//if (!tshtd.IsEmpty() && !getPar("LAST_BASE_MONTH"))//если есть параметр "Дату базовой записи всегда брать по дате последнего повышения оклада", тогда эту ситуацию не анализируем
	//по старому расчету изменяем базовый месяц, если ЗП с индексацией с пред.месяца больше повышенной ЗП по последней найденной записи
	//по новому расчету всегда базовой становится дата повышения ЗП
	//по старому расчету после этого цикла уже известна базовая запись, по которой вычисляется процент индексации и больше ничего делать не надо. По новому расчету
	//нужно искать фиксированные суммы индексации в месяце повышения ЗП.
	//если передана базовая запись, то не перепроверять, правильная она или нет
	if (!tshtd.IsEmpty() && !baserec && izvbase==false)//если есть параметр "Дату базовой записи всегда брать по дате последнего повышения оклада", тогда эту ситуацию не анализируем	
	{
		while (!tshtd.IsEOF())
		{
			//предыдущую запись находим только для старых сотрудников. ЕСли он новый,то никакой предыдущей	 записи у него нет.
			if (tshtd.getValue("Fis_nazn")==false){			
				var ndt    = new Date(tshtd.getValue("Fbdat"))
				var ntn    = tshtd.getValue("Ftabn_id")
				var nfwid  = tshtd.getValue("Fwid")						
				var nokl   = Number(tshtd.getValue("Foklad"))
				var nvopl  = Number(tshtd.getValue("Fvopl"))
				
				prmin = get_cnst("prmin", ndt);
				if(prmin == 0)
				{
					msg = ru("Не определена константа прожиточного минимума prmin!","Не визначена константа прожиткового мінімума prmin!")
				}
				//находим fwid последней записи с увеличением оклада до ранее найденной. Берем из нее все нужные данные и рассчитываем индекс.
				fwid_shtr.fwid = 0;
				fwid_shtr.izd	 = 0;	
				r_bind (ndt, ntn, nvopl,fwid_shtr)
				var fwid_sh =  fwid_shtr.fwid
				var fizm_dl  =  fwid_shtr.izd
				var shokl = 0;
				var oSnap = getSnap("select  dol.Foklad,wp.Fwid_cl,wp.Fbdat, wp.Ftable,wp.Fwid, wp.Fvopl,wp.Fis_nazn FROM ^work_pers wp INNER JOIN ^stru_dol dol "+
						" on wp.Fwid_dol=dol.Fwid where wp.Fwid_cl="+sqlTo(ntn)+" and wp.Fvopl="+sqlTo(nvopl)+" and wp.Fwid="+sqlTo(fwid_sh))
				if (oSnap!=null){
					//с предыдущей записи оклад
					shokl = Number(oSnap[0])
					//проверяем окладников и ЧТС
					if (Number(tshtd.getValue("Fprizn"))==1){
						//	окладники
						var ookl = (Number(oSnap[0])>prmin)?prmin:Number(oSnap[0])
					}else{
						//ЧТС и сдельщики
						var ookl = (round(Number(oSnap[0])*Number(tshtd.getValue("Fnorma_ch")),2)>prmin)?prmin:round(Number(oSnap[0])*Number(tshtd.getValue("Fnorma_ch")),2)
						shokl = round(Number(oSnap[0])*Number(tshtd.getValue("Fnorma_ch")),2)
					}	
					if ((ind2012!=0 && differ(ndt,ind2012)<0) || ind2012==0){
						//старый расчет менять не будем, индексацию сравниваем с повышением оклада				
						//нашли индексацию на предыдущую базовую запись
						var oBdatpr = new Date(ndt.getFullYear(),ndt.getMonth()-2,1)
						var pind = r_sind(new Date(oSnap[2]), oBdatpr, ndt)
						indZp = round(ookl*pind/100,2)+shokl
						
						//если ЗП с индексацией по старой базовой записи > новый оклад, то базовой считаем предыдущую запись
						if (indZp>nokl){
							ExecuteSQL("update TSHTD set Fis_baze="+sqlFalse+" where Ftabn_id="+sqlTo(ntn)+" and Fvopl="+sqlTo(nvopl)+" and Foklad="+sqlTo(nokl))+" and Fbdat="+sqlTo(ndt)
							//старую запись помечаем как неправильную и добавляем новую запись
							//этот расчет делается для тех, кого надо считать по-старому, поэтому всегда ставим признак, то они старые работники
							//новых работников нужно выделять только в новом расчете   
							var m = new Object();				
							m.Ftabn_id   =ntn;
							m.Fwid       =nfwid;        		
							m.Fwid_baze  =fwid_sh;        		
							m.Ftable     =oSnap[3];
							m.Fvopl      =nvopl; 
							m.Fbdat      =oSnap[2];
							m.Fis_baze   =true;
							m.Foklad     =oSnap[0];
							m.Fprizn     =1;
							m.Fis_nazn   =false;
							UpdateTable("TSHTD",m,true);				
						}
					}else{
						//	при новом расчете, если человека перевели на новую должность и не поменялся оклад, то базовая запись
						//	остается со старой должности
						//если ЗП по старой базовой записи >= новый оклад, то базовой считаем предыдущую запись
						if (nokl<=shokl){
							ExecuteSQL("update TSHTD set Fis_baze="+sqlFalse+" where Ftabn_id="+sqlTo(ntn)+" and Fvopl="+sqlTo(nvopl)+" and Foklad="+sqlTo(nokl))+" and Fbdat="+sqlTo(ndt)
							//старую запись помечаем как неправильную и добавляем новую запись
							//этот расчет делается для тех, кого надо считать по-старому, поэтому всегда ставим признак, то они старые работники
							//новых работников нужно выделять только в новом расчете   
							var m = new Object();				
							m.Ftabn_id   =ntn;
							m.Fwid       =nfwid;        		
							m.Fwid_baze  =fwid_sh;        		
							m.Ftable     =oSnap[3];
							m.Fvopl      =nvopl; 
							m.Fbdat      =oSnap[2];
							m.Fis_baze   =true;
							m.Foklad     =oSnap[0];
							m.Fprizn     =1;
							//если предыдущая запись до начала нового расчета, то не проверяем на признак приема на работу 
							if ((ind2012!=0 && differ(new Date(oSnap[2]),ind2012)<0) || ind2012==0){
								m.Fis_nazn   =false;
							}else{
								m.Fis_nazn   =oSnap[6];
							}
							UpdateTable("TSHTD",m,true);				
						}
					}
				}
			}
			tshtd.MoveNext()
		}
	}
	tshtd.close();

	strSQL = "update TSHTD set Fprizn=(select Fprizn from ^OPL_PRIZ where Fvopl=TSHTD.Fvopl)";
	ExecuteSQL(strSQL);

	strSQL = "update TSHTD set Fprewokl=0 where Fprewokl is null";
	ExecuteSQL(strSQL);
	strSQL = "update TSHTD set Fbasemind="+sqlTo(d00obj)+" where Fbasemind is null";
	ExecuteSQL(strSQL);
	strSQL = "update TSHTD set Ffikssum=0 where Ffikssum is null";
	ExecuteSQL(strSQL);


	//убрать из TSHTD небазовые записи по штатному расписанию. После этого нужно еще учесть постоянные надбавки, чтобы вычислить
	//окончательную базовую запись
	ExecuteSQL("delete from TSHTD where Fis_baze="+sqlFalse)

	//с 2012 увеличение дохода считаем по дате изменения оклада. Даты постоянных надбавок будем игнорировать, но теперь
	//прийдется считать разницу между суммой с предыдущего повышения с учетом индексации и суммой повышения. Поэтому нужно теперь
	//рассчитывать оклад+все пост.надбавки по норме, чтобы получить полную сумму дохода повышенного и его сравнивать с суммой
	//с учетом индексации.
		
	//найти приказы на постоянные надбавки, которые нужно учитывать при определении базового месяца для индексации
	//в Fsum_ind будем прописывать 1, если нужно учитывать приказ, чтобы поменьше обновлять структуры. Все равно это поле
	//нигде не используется
	DropTable("TPRKALL")
	strSQL = "select p.Ftabn_id, p.Fwid_wp, p.Fbdat, wp.Fvopl, wp.Ftable into TPRKALL from (^PRK_ALL p inner join ^work_pers wp "
			+" on p.Fwid_wp=wp.Fwid) where p.Fsum_ind=1 "
   			+" AND ((p.fbdat<=" + sqlTo(dt_rind) + " AND p.fedat>=" + sqlTo(dt_rinde) + ")" 
			+" OR (p.fbdat>=" + sqlTo(dt_rind) + " AND p.fbdat<=" + sqlTo(dt_rinde) + ")" 
			+" OR (p.fedat>=" + sqlTo(dt_rind) + " AND p.fedat<=" + sqlTo(dt_rinde) + "))"
		ExecuteSQL(strSQL);

	//для новых сотрудников всегда начинаем базовый месяц с предыдущего. Смотреть на даты увеличения доплат для них не нужно.
	//Поэтому из приказов нужно убрать тех, кто помечен как новый, чтобы не поменялась дата начала.
	//Если новому сотруднику увеличат оклад, то бальше он идет по общему принципу расчета.
	//проверить внимательно !!!!!!!!
	ExecuteSQL("delete from TPRKALL where exists(select Ftabn_id from TSHTD s where TPRKALL.Ftabn_id=s.Ftabn_id and TPRKALL.Fwid_wp=s.Fwid and s.Fis_nazn="+sqlTrue+")")
	// в TSHTD3 должна получиться макс.дата из штатного и приказов на пост.надбавки для каждой записи штатного расписания. Затем
	//уже выбираем max для основной работы и совместительства
	DropTable("TSHTD3")
	strSQL = "select d.Ftabn_id,d.Fbdat,d.Fvopl,d.Ftable,d.Fwid,d.Fwid_baze,p.Fbdat as Fbdatprk,d.Foklad,d.Fsind,d.Fprewokl,d.Ffikssum,d.Fbasemind,d.Fis_nazn,d.Fizm_dol,d.Fprizn,d.Fnorma_ch into TSHTD3 from (TSHTD d left join TPRKALL p "+
    		 " on d.Ftabn_id=p.Ftabn_id and d.Fwid=p.Fwid_wp)"
	ExecuteSQL(strSQL);
	strSQL = "UPDATE TSHTD3 set Fbdat=Fbdatprk where Fbdat<Fbdatprk"
	ExecuteSQL(strSQL);    
	
	// оставляем из таблицы TSHTD по основной работе и по совместительству по одной записи с самой последней датой измеенения оклада
	DropTable("TSHTD2")
	strSQL = "select d.Ftabn_id,d.Fbdat,d.Fvopl,d.Ftable,d.Fwid,d.Fwid_baze,d.Foklad,d.Fsind,d.Fprewokl,d.Ffikssum,d.Fbasemind,d.Fis_nazn,d.Fizm_dol,d.Fprizn,d.Fnorma_ch into TSHTD2 from TSHTD3 d where Fbdat=(select MAX(Fbdat) from TSHTD3 as sh2 where d.Ftabn_id=sh2.Ftabn_id and d.Ftable=sh2.Ftable)"
	ExecuteSQL(strSQL);

	//индексацию начисляют с 1-го числа месяца, следующего за месяцем, в котором был опубликован индекс цен, еси он >101%
	//определили раньше
	//var oBdat = new Date(dt_rind.getFullYear(),dt_rind.getMonth()-2,1)
	if (ind2012!=0){
		prmin = get_cnst("prmin", dt_rind);
		if(prmin == 0)
		{
			msg = ru("Не определена константа прожиточного минимума prmin!","Не визначена константа прожиткового мінімума prmin!")
		}
		//с 2012 базовым месяцем всегда становится месяц повышения оклада, но при этом нужно теперь рассчитать суммы пост.надбавок
		//по норме.Постоянные надбавки берем только те, которые зависят от оклада. Доплаты на перечень полей ЛС игнорируем.
		var tshtd = OpenTable("s", "select * from TSHTD2 where Fizm_dol=0 order by Ftabn_id, Ftable,Fvopl,Fbdat")
		if (!tshtd.IsEmpty())	
		{
			while (!tshtd.IsEOF())
			{
				var ntn     = Number(tshtd.getValue("Ftabn_id"))
				var nfwid  = tshtd.getValue("Fwid")						
				var ndt    = new Date(tshtd.getValue("Fbdat"))
				var nokl   = Number(tshtd.getValue("Foklad"))
				var nvopl = Number(tshtd.getValue("Fvopl"))
		   		var mFuvrazn = 0			
		    	var razn = 0
		    	var curind = 0;

        		//если после принятия новой индексации приняли работника, то у него базовый месяц - предыдущий от даты приема на работу
	    		if (tshtd.getValue("Fis_nazn")==true && differ(new Date(tshtd.getValue("Fbdat")),ind2012)>=0 && differ(new Date(tshtd.getValue("Fbasemind")),d00obj)==0){
	    			//если в штатном расписании в поле базовый месяц для индексации стоит пусто, то это - вновь принятый работник
   		    		//берется базовым предыдущий месяц
	                if (izvbase == false){	    			
	                	ndt = new Date(new Date(tshtd.getValue("Fbdat")).getFullYear(),new Date(tshtd.getValue("Fbdat")).getMonth()-1,1);
	                	ExecuteSQL("update TSHTD2 set Fbdat="+sqlTo(ndt)+" where Ftabn_id="+sqlTo(ntn)+" and Fwid="+sqlTo(nfwid)+" and Fvopl="+sqlTo(nvopl))
	                }else{
	                	ndt = new Date(datbase);
	                	ExecuteSQL("update TSHTD2 set Fbdat="+sqlTo(ndt)+" where Ftabn_id="+sqlTo(ntn)+" and Fwid="+sqlTo(nfwid)+" and Fvopl="+sqlTo(nvopl))
	                }
				}
       			//берем из постоянной таблицы по хвостам индксации все записи по одному человеку и начинаем анализировать суммы. Берем с самого начала.
       			//если нужно обнулить хвосты индексации, когда получится, что повышение больше индексации, то в пост.Таблице в поле
       			//fisnull поставим true.
				//если ЗП с индексацией по старой базовой записи > новый оклад+надбавки, то берем разницу и ее считаем индексацией в базовом месяце
				//для переведенных в месяце перевода должен получиться 0. В следующем месяце получится фикс.сумма
       			//var gs = getSnap("select max(Fbdat) as Fbdat from ^INDUVEL where Ftabn_id="+sqlTo(ntn)+" and Fisnull="+sqlTrue+" and Fbdat<"+sqlTo(dt_rind))
       			//var gs = getSnap("select max(Fbdat) as Fbdat from ^INDUVEL where Ftabn_id="+sqlTo(ntn)+" and Fsumind=0 and Fbdat<"+sqlTo(dt_rind))
       			var gs = getSnap("select max(Fbdat) as Fbdat from ^PRK_ALL where Fvid_prk="+sqlTo(ivvprk)+" and Ftabn_id="+sqlTo(ntn)+" and Fsum=0 and Fbdat<"+sqlTo(dt_rind))				
       			if(gs!=null){       
       				//var gssum = getSnap("select sum(Fsumind) as Foind from ^INDUVEL where Ftabn_id="+sqlTo(ntn)+" and Fbdat>"+sqlTo(new Date(gs[0]))+" and Fbdat<"+sqlTo(dt_rind))
       				var gssum = getSnap("select sum(Fsum) as Foind from ^PRK_ALL where  Fvid_prk="+sqlTo(ivvprk)+" and Ftabn_id="+sqlTo(ntn)+" and Fbdat>"+sqlTo(new Date(gs[0]))+" and Fbdat<"+sqlTo(dt_rind))       				
       			}else{
       				//var gssum = getSnap("select sum(Fsumind) from ^INDUVEL where Ftabn_id="+sqlTo(ntn)+" and Fbdat<"+sqlTo(dt_rind))
       				var gssum = getSnap("select sum(Fsumind) from ^PRK_ALL where  Fvid_prk="+sqlTo(ivvprk)+" and Ftabn_id="+sqlTo(ntn)+" and Fbdat<"+sqlTo(dt_rind))       				
       			}
				//фикс.суммі до начала месяца расчета
				if (gssum!=null){
					var fiksind = Number(gssum[0]) 
				}else{
					var fiksind = 0					
				}
	//alert("fiksind")
	//alert(fiksind)				
				//alert(fiksind)
				//расчет фикс.инд.в месяце повышения
				if (differ(new Date(firstDayMonth(ndt)),new Date(dt_rind))==0){
					//признак,нужно записывать фикс.разницы в приказ или нет. ЕСли нужно, чтобы продолжала начисляться
					//старая разница, то в приказе на фикс. суммы в момент повышения ЗП ничего не надо прописывать.
					//Явно прописанный 0 - признак, что предыдущие суммы фикс.инд.обнуляются
					var fis_fiks = false;
					if (tshtd.getValue("Fis_nazn")==false || (tshtd.getValue("Fis_nazn")==true && Number(tshtd.getValue("Fprewokl"))!=0)){
						//для старых сотрудников или переведенных сотрудников
						//если расчет идет за месяц, в котором повышался оклад, то ищем фикс.сумму индексации
						var sumnad = 0;
						//	фиксированную сумму индексации вычисляем только в месяце повышения. Затем эта сумма тянется по всем месяцам,
						//пока не произойдет следующее повышение.				
						//найти сумму пост.надбавок по увеличенному окладу
						//найти приказы на постоянные надбавки, которые нужно учитывать при определении базового месяца для индексации
						//в Fsum_ind будем прописывать 1, если нужно учитывать приказ, чтобы поменьше обновлять структуры. Все равно это поле
						//	нигде не используется
						//берем перечень приказов на надбавки по человеку и  рассчитываем сумму, которую добавляем к окладу.
				    	var prknad = getSnap("select sum(p.Fsum) as Fsum2  from (^PRK_ALL p inner join ^work_pers wp "
				    			+" on p.Fwid_wp=wp.Fwid) where p.Fsum_ind=1 and p.Fin_table='PRK2' and p.Ftabn_id="+sqlTo(ntn)+" and Fwid_wp="+sqlTo(nfwid)
				    			+" AND ((p.fbdat<=" + sqlTo(dt_rind) + " AND p.fedat>=" + sqlTo(dt_rinde) + ")" 
				    			+" OR (p.fbdat>=" + sqlTo(dt_rind) + " AND p.fbdat<=" + sqlTo(dt_rinde) + ")" 
				    			+" OR (p.fedat>=" + sqlTo(dt_rind) + " AND p.fedat<=" + sqlTo(dt_rinde) + "))")
						if (prknad!=null){
							sumnad = sumnad+Number(prknad[0])							
						}
				    	var prknad = getSnap("select "+sqlRound("sum(p.Fproc/100*"+sqlTo(nokl)+")",2)+" as Fproc2  from (^PRK_ALL p inner join ^work_pers wp "
				    			+" on p.Fwid_wp=wp.Fwid) where p.Fsum_ind=1 and p.Fin_table='PRK4' and p.Ftabn_id="+sqlTo(ntn)+" and Fwid_wp="+sqlTo(nfwid)
				    			+" AND ((p.fbdat<=" + sqlTo(dt_rind) + " AND p.fedat>=" + sqlTo(dt_rinde) + ")" 
				    			+" OR (p.fbdat>=" + sqlTo(dt_rind) + " AND p.fbdat<=" + sqlTo(dt_rinde) + ")" 
				    			+" OR (p.fedat>=" + sqlTo(dt_rind) + " AND p.fedat<=" + sqlTo(dt_rinde) + "))")
						if (prknad!=null){
							sumnad = sumnad+Number(prknad[0])							
						}
						//нашли оклад + надбавки после повышения
						var allokl = nokl+sumnad
//alert("allokl")						
//alert(allokl)
						if (tshtd.getValue("Fis_nazn")==true && tshtd.getValue("Fprewokl")!=0){			
							//для просто новых берется обычный индекс от базовой записи, для них в этом цикле ничего не делаем
							//	для переведенный вычисляем, нужно ли им давать фикс.сумму индексации с предыдущей работы. Причем
							//вычислим мы ее сейчас, а давать будем в следующем месяце. Вычислим и запишем в файл хвостов инд.
							//нашли индексацию на базовую запись с предыдущей работы
							var ookl = Number(tshtd.getValue("Fprewokl"))							
							var pind = r_sind(new Date(tshtd.getValue("Fbasemind")), oBdat, dt_rind)
//alert(pind)							
							if (pind!=0){
								var ooklin = (ookl>prmin)?prmin:ookl	
								//старая сумма оклада +индексация		
								indZp = round(ooklin*pind/100,2)+ookl+Number(tshtd.getValue("Ffikssum"))
							}else{
								indZp = ookl+Number(tshtd.getValue("Ffikssum"))
							}
//alert(indZp)
//alert(allokl)
	   			    		razn = 0		
		   			    	mFuvrazn = 0	   			    		
		   			    	if (indZp!=0){
								fis_fiks = true;		   		    			
								if (indZp>allokl){		   		    			
									//если ЗП со староо места работы с фикс.и тек.инд.больше новой ЗП, то фиксированная инд.сохраняется
									//перебиваем для этого человека базовый месяц на месяц со старой работы
				   			    	mFuvrazn = Number(tshtd.getValue("Ffikssum"))									
									ExecuteSQL("update TSHTD2 set Fbdat="+sqlTo(tshtd.getValue("Fbasemind"))+" where Ftabn_id="+sqlTo(ntn)+" and Fwid="+sqlTo(nfwid)+" and Fvopl="+sqlTo(nvopl))
								}
		   		    		}
//alert(razn)
//alert(mFuvrazn)
						}else{
							//находим fwid последней записи с увеличением оклада до ранее найденной. Берем из нее все нужные данные и рассчитываем индекс.
							//это для тех,кто принят на работу не по переводу. Для переведенных в текущей записи есть все данные
							fwid_shtr.fwid = 0;
							fwid_shtr.izd	 = 0;	
							r_bind (ndt, ntn, nvopl,fwid_shtr)
							var fwid_sh =  fwid_shtr.fwid
							var fizm_dl  =  fwid_shtr.izd
//alert("пред зап")							
//alert(fwid_sh)							
							var oSnap = getSnap("select  dol.Foklad,wp.Fwid_cl,wp.Fbdat, wp.Ftable,wp.Fwid, wp.Fvopl,wp.Fis_nazn,wp.Fbasemind,wp.Fprewokl,wp.Ffikssum FROM ^work_pers wp INNER JOIN ^stru_dol dol "+
									" on wp.Fwid_dol=dol.Fwid where wp.Fwid_cl="+sqlTo(ntn)+" and wp.Fvopl="+sqlTo(nvopl)+" and wp.Fwid="+sqlTo(fwid_sh))
							if (oSnap!=null){
								//alert(oSnap[2])
								//alert(oBdat)
								var osumnad = 0;				    	
								//	проверяем окладников и ЧТС
								if (Number(tshtd.getValue("Fprizn"))==1){
									//	окладники
									var ookl = Number(oSnap[0])
								}else{
									//ЧТС и сдельщики
									var ookl = round(Number(oSnap[0])*Number(tshtd.getValue("Fnorma_ch")),2)
								}	
//alert(ookl)
								//найдем постоянные надбавки на эту запись
								var odt_rind = firstDayMonth(new Date(oSnap[2]))
								var odt_rinde = lastDayMonth(new Date(oSnap[2]))
//alert(odt_rind)
//alert(odt_rinde)
						    	var oprknad = getSnap("select sum(p.Fsum) as Fsum2  from (^PRK_ALL p inner join ^work_pers wp "								
					    			+" on p.Fwid_wp=wp.Fwid) where p.Fsum_ind=1 and p.Fin_table='PRK2' and p.Ftabn_id="+sqlTo(ntn)+" and Fwid_wp="+sqlTo(fwid_sh)
					    			+" AND ((p.fbdat<=" + sqlTo(odt_rind) + " AND p.fedat>=" + sqlTo(odt_rinde) + ")" 
					    			+" OR (p.fbdat>=" + sqlTo(odt_rind) + " AND p.fbdat<=" + sqlTo(odt_rinde) + ")" 
			    					+" OR (p.fedat>=" + sqlTo(odt_rind) + " AND p.fedat<=" + sqlTo(odt_rinde) + "))")
								if (oprknad!=null){
									osumnad = osumnad+Number(oprknad[0])							
								}

						    	var oprknad = getSnap("select "+sqlRound("sum(p.Fproc/100*"+sqlTo(ookl)+")",2)+" as Fproc2  from (^PRK_ALL p inner join ^work_pers wp "								
						    			+" on p.Fwid_wp=wp.Fwid) where p.Fsum_ind=1 and p.Fin_table='PRK4' and p.Ftabn_id="+sqlTo(ntn)+" and Fwid_wp="+sqlTo(fwid_sh)
						    			+" AND ((p.fbdat<=" + sqlTo(odt_rind) + " AND p.fedat>=" + sqlTo(odt_rinde) + ")" 
						    			+" OR (p.fbdat>=" + sqlTo(odt_rind) + " AND p.fbdat<=" + sqlTo(odt_rinde) + ")" 
				    					+" OR (p.fedat>=" + sqlTo(odt_rind) + " AND p.fedat<=" + sqlTo(odt_rinde) + "))")
								if (oprknad!=null){
									osumnad = osumnad+Number(oprknad[0])									
								}
								var oallokl = ookl+osumnad				    
//alert(oallokl)
								
								//нашли индексацию на предыдущую базовую запись
								//предыдущую запись тоже нужно проверять. Если она окажется записью приема на работу, нужно
								//перебивать базовый месяц. При переводе тоже нужно перебивать базовый месяц.
								var bmn = new Date(oSnap[2])
								//если предыдущая запись оказалась принятием на работу	
				    			if (((oSnap[6]==true && differ(bmn,ind2012)>=0) && differ(new Date(oSnap[7]),d00obj)==0)){
					    			//	если предыдущая запись оказалась записью по приему на работу, то базовый месяц - предыдущий от месяца принятия
					    			//если в штатном расписании в поле базовый месяц для индексации стоит пусто, то это - вновь принятый работник
					    			//в противном случае - перевод.
				    				bmn = new Date(new Date(oSnap[2]).getFullYear(),new Date(oSnap[2]).getMonth()-1,1);
				    			}
								if (((oSnap[6]==true && differ(bmn,ind2012)>=0) && differ(new Date(oSnap[7]),d00obj)!=0)){
			    					//	если предыдущая запись оказалась приемом на работу по переводу, то нужно определить 
									//базовый месяц - со старой работы или с новой
			    					var perookl = Number(oSnap[8])							
				    				var perpind = r_sind(new Date(oSnap[7]), oBdat, dt_rind)
				    				if (perpind!=0){
				    					var perooklin = (perookl>prmin)?prmin:perookl	
				    					//старая сумма оклада +индексация		
				    					var perindZp = round(perooklin*perpind/100,2)+perookl+Number(oSnap[9])
				    				}else{
				    					perindZp = perookl+Number(oSnap[9])
									}
				   			    	if (perindZp==0){
										bmn = new Date(oSnap[2])				   			    		
				   		    		}else{
										if (perindZp>Number(oSnap[0])){		   		    			
											//если ЗП со староо места работы с фикс.и тек.инд.больше новой ЗП, то фиксированная инд.сохраняется
											//перебиваем для этого человека базовый месяц на месяц со старой работы
											bmn = new Date(oSnap[7])
										}else{
											//месяц перехода на новую работу берем базовым
											bmn = new Date(oSnap[2])											
										}
				   		    		}
								}
//alert("bmn")
//alert(bmn)
//alert(oBdat)
								var pind = r_sind(bmn, oBdat, dt_rind)
//alert(pind)
								if (pind!=0){
									var ooklin = (oallokl>prmin)?prmin:oallokl
//alert(ooklin)
									//старая сумма оклада с пост.надб.+индексация		
									indZp = round(ooklin*pind/100,2)+oallokl
									curind = round(ooklin*pind/100,2)
								}else{
									//если индексация не положена, то берется повышенная ЗП с текущего месяца+ старые тянущиеся индексации из
									//сохраненной постоянной таблицы
									indZp = oallokl;			
									curind = 0;									
								}
							}else{
								//ошибка в данных?????
								indZp = 0;
							}
//alert("indzp")
//alert(indZp)
//alert(curind)
//alert(allokl-oallokl)
		   			    	if (indZp==0){
		   			    		razn = 0
   		    					mFuvrazn = 0		   			    		
		   		    		}else{
		   		    			//если текущая индексация+фикс.индексация с пред.месяцев меньше суммы повышения, остается только сумма повышения
		   		    			if ((curind+fiksind)<(allokl-oallokl)){
									fis_fiks = true;		   		    				
	   		    					razn = 0				
	   		    					mFuvrazn = 0
		   		    			}else{
			   		    			if (curind<(allokl-oallokl)){
				   		    			//если текущая индексация+фикс.индексация с пред.месяцев больше суммы повышения, и текущая
			   		    				//индексация меньше суммы повышения, остаются только старые фикс.индексации			   		    				
		   		    					razn = fiksind
		   		    					mFuvrazn = 0	
			   		    			}else{
				   		    			//если текущая индексация+фикс.индексация с пред.месяцев больше суммы повышения, и текущая
			   		    				//индексация больше суммы повышения, остаются все индексации
										fis_fiks = true;			   		    				
		   		    					razn = curind-(allokl-oallokl)+fiksind
		   		    					mFuvrazn = curind-(allokl-oallokl)	
			   		    			}	
		   		    			}
		   		    		}
						}
//alert(razn)
//alert(mFuvrazn)						
						var gs = getSnap("select Fwid from ^PRK_ALL where Fvid_prk="+sqlTo(ivvprk)+" and Ftabn_id="+sqlTo(ntn)+" and Fbdat="+sqlTo(dt_rind))						
						if (gs!=null){
							ExecuteSQL("delete from ^PRK_ALL where  Fvid_prk="+sqlTo(ivvprk)+" and Ftabn_id="+sqlTo(ntn)+" and Fbdat="+sqlTo(dt_rind)+" and Fwid="+sqlTo(gs[0]))								
						}
						if (fis_fiks == true){							
							var oPrik = new DpPrik("_PRK1", ivvprk);
							oPrik.clear();
							oPrik.setVar("FWID", GetUID());
							oPrik.setVar("FTABN_ID" , ntn);
							oPrik.setVar("FWID_WP", nfwid);
							oPrik.setVar("FSUM", mFuvrazn);
							oPrik.setVar("FPROC", 0);							
							oPrik.setVar("FBDAT", dt_rind.getVarDate());
							oPrik.setVar("FEDAT", dt_rinde.getVarDate());
							oPrik.setVar("FVID_PRK", ivvprk);
							oPrik.setVar("FIN_TABLE", 'PRK1');
							oPrik.save();
						}
					}
				}else{
					//если расчет не в месяце повышения ЗП, то берем фикс.сумму
					razn = fiksind
				}
				ExecuteSQL("update TSHTD2 set Fsind="+sqlTo(razn)+" where Ftabn_id="+sqlTo(ntn)+" and Fwid="+sqlTo(nfwid))
				
				tshtd.MoveNext()
			}
		}
		tshtd.close();
	}
	
	for (var i in result.fwid_cl)
    {
    	//если не нашли базовую запись, то индекс=0
   		strSQL = "select * from TSHTD2 where Ftabn_id="+sqlTo(result.fwid_cl[i])+" and Fwid="+sqlTo(result.fwid[i])
    	tshtd = OpenTable("s", strSQL);
    	if (!tshtd.IsEmpty()){
    		pFtabn_id =tshtd.getValue("Ftabn_id");
    		//если передана базовая дата, то используем ее
    		if(isDateType(datbase) && differ(datbase,d00)!=0)
    			var pFbdat = new Date(datbase);
    		else
    			var pFbdat = new Date(tshtd.getValue("Fbdat"));
    			
        	result.datbase[i] = pFbdat.getVarDate();
        	//если базовая запись меньше даты перехода на новый расчет, считаем процент индексации
        	//если больше, то высчитываем процент текущей индексации от последного базового месяца + записываем сумму индексации (фикс)
			result.proc[i] = r_sind(pFbdat, oBdat, dt_rind)     
			result.sum[i] = Number(tshtd.getValue("Fsind"))
    	}
    	else
    	{
        	//если передана базовая дата, то используем ее
        	if(isDateType(datbase) && differ(datbase,d00)!=0)
        	{
        		var pFbdat = new Date(datbase);
        		result.datbase[i] = pFbdat.getVarDate();
				result.proc[i] = r_sind(pFbdat, oBdat, dt_rind)
				result.sum[i] = 0			
        	}
        	else
        	{
	        	result.datbase[i] = d00obj.getVarDate();
				result.proc[i] = 0;
				result.sum[i] = 0			
        	}
    	}
    	tshtd.close();
	}
	result.fisres = true;	
	return result;
	
}