//расчет сводов по ШПЗ для Лисок и Линовицы
include("Objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");

var sTitle = UR("Зведення по ШВВ", "Своды по ШПЗ");

function listLoad()
{
   	list.title = sTitle;
   	var objAsk = new DpGetDat("d");
	if(objAsk.escape)
		return false;

	var res_moni = new Date(objAsk.dat1.getYear()+1900, objAsk.dat1.getMonth(), 1);
	
   	r_9t2(res_moni);
   	
   	return false;
}

function r_9t2(mdat)
{
	var nPos = 1;
	var maxPos = 9;
	var sTxt = sTitle +"...";
	
	monthtxt1 = format("yyyymm", mdat);
	
	// Проверяем существует ли у нас таблица "svzp" + monthtxt1 по шаблону "svzp"
	tblOut = "zrp_" + "svzp" + monthtxt1;
	if(!IsTableEx("zrp_res", tblOut))
	{ 
   		alert(ru("Внимание! Перед началом данного рачета проведите\n расчет начислений за выбранный вами месяц"
     			,"Увага! Перед початком даного розрахунку проведіть\n розрахунок нарахувань за вибраний вами місяць"));
       	return false;
	}
	
	setProgressRange(0, maxPos);  
  	setProgressPos(nPos++, sTxt);
  	
	DropTable("SVSH9");
	DropTable("SVSH91");
	DropTable("SVSH92");
	DropTable("SVSH93");
	DropTable("SVSH94");
	DropTable("SVSH95");
	DropTable("SVSH96");
	DropTable("SVSH97");
	DropTable("VSP92T");
	
	setProgressPos(nPos++, sTxt);
	
	strSQL = "create table VSP92T "
			+" (FMN "+SqlType("DATE")
			+", FVP "+SqlType("SHORT")
			+", FDB_SC "+SqlType(sqlTSc)
			+", FDB_SU "+SqlType(sqlTSu)
			+", FDB_ST "+SqlType(sqlTSt)
			+", FDB_COD1 "+SqlType("LONG")
			+", FDB_COD2 "+SqlType("LONG")
			+", FDB_COD3 "+SqlType("LONG")
			+", FSHPZ "+SqlType("TEXT",15)
			+", FLSFID "+SqlType("LONG")
			+", FFLD_NUM "+SqlType("LONG")
			+", FSUM "+SqlType("CURRENCY")
			+", FDAY "+SqlType("LONG")
			+", FCHAS "+SqlType("FLOAT")
			+", FLV1 "+SqlType("SHORT")
			+", FLV2 "+SqlType("SHORT")
			+", FLV3 "+SqlType("SHORT")
			//+", FTABN "+SqlType("LONG")
			+", FWID_WP "+SqlType("LONG")
			+", FWID "+SqlType("COUNTER")
			+", FSHT_ID "+SqlType("SHORT")+")";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	var fwid_wp = "(select MAX(pers.Fwid) from ^WORK_PERS pers "
					+" where pers.FWID_CL=z.FTABN_ID)";
	strSQL = "insert into ^VSP92T "
			+" (Flsfid, Ffld_num, Fsum, Fmn, Fvp, FWID_WP, Fshpz, Fday, Fchas) " //Fsht_id, 
		+" select Flsfid, Ffld_num, Fsum, Fmn, Fvp, "+fwid_wp+" as Fwid_wp, Fshpz, Fday, Fchas "
		+" from ^SVZP"+ monthtxt1 +" z "
			+" left join ^CL cl on cl.FWID=z.FTABN_ID "
			+" left join ^LIC_FLD lic on lic.FID=z.FLSFID "
		//+" where Fsht_id<>0 and not(Fvp=1 and Fmn>="+sqlTo(mdat)+")";
		+" where lic.FIS6='+' and not(z.Fvp=1 and z.Fmn>="+sqlTo(mdat)+")";				
	ExecuteSQL(strSQL);
	
	ExecuteSQL("UPDATE ^VSP92T SET FLV1=0, FLV2=0, FLV3=0")
	setProgressPos(nPos++, sTxt);
	
	VSP_table = OpenTable("s","VSP92T");
	if (VSP_table.IsEmpty())
	{
   		setProgressPos(0);
   		return false;
	}

	var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1) 

	// дата конца
	var DI2 = lastDayMonth(new Date(mdat.getFullYear(),mdat.getMonth(),0)).getDate();   	
	var D2 = new Date(mdat.getFullYear(),mdat.getMonth(),DI2);

	var DD1=D1.getVarDate()
	var DD2=D2.getVarDate()
/*
	Shtat_table = OpenTable("s","SELECT * FROM ^SHTAT WHERE "
                     + "((FBDAT <= " + sqlTo(DD1) + " AND FEDAT >= " + sqlTo(DD2) +") " 
                     + "OR (FBDAT >= " + sqlTo(DD1) + " AND FBDAT <= " + sqlTo(DD2) +") " 
                     + "OR (FEDAT >= " + sqlTo(DD1) + " AND FEDAT <= " + sqlTo(DD2) +"))")

	Lic_table = OpenTable("s", "LIC_FLD", "LIC_FID");
	if (SQL)
		Lic_table.Index = "FID";
	WAIT("шаг 0")
	if (!VSP_table.IsEmpty())
	{
   		VSP_table.MoveFirst();
   		i=0
   		while (!VSP_table.IsEOF())
   		{
      		i = i+1
      		WAIT(String(i));
      		if (Shtat_table.FindFirst("FTABN="+sqlToFind(VSP_table("Ftabn"))))
      		{
         		var xlv1 = Shtat_table("Flv1");
         		var xlv2 = Shtat_table("Flv2");
         		var xlv3 = Shtat_table("Flv3");
         		while ((!Shtat_table.IsEOF()) && (Shtat_table("Ftabn")==VSP_table("Ftabn")))
         		{
            		if (((Shtat_table("fbdat")<=D1)&& (Shtat_table("fedat")>=D2)) ||
               			((Shtat_table("fbdat")>=D1)&& (Shtat_table("fbdat")<=D2)) ||
               			((Shtat_table("fedat")>=D1)&& (Shtat_table("fedat")<=D2)))
               		{
               			xlv1 = Shtat_table("Flv1")
               			xlv2 = Shtat_table("Flv2")
               			xlv3 = Shtat_table("Flv3")
               			break;
            		} 
            		Shtat_table.MoveNext();
         		}
         		mFlv1 = xlv1;
         		mFlv2 = xlv2;
         		mFlv3 = xlv3;
      		}
      		else
      		{
        	 	mFlv1 = 0;
         		mFlv2 = 0;
         		mFlv3 = 0;
         		var mFfld_num;
         		if (Lic_table.FindFirst("fid="+sqlToFind(VSP_table("Flsfid"))))
            		mFfld_num=Lic_table("Ftxt")
         		else
            		mFfld_num=" "
         		//DefVed.write("Hет подр.для таб.N "+VSP_table("Ftabn")+"," ,"" ,"");
         		//DefVed.write("поле ЛС-"+Lic_table("Ftxt")+"," ,"" ,"");
         		//DefVed.write("код записи шт.расп."+VSP_table("Fsht_id") ,"" ,"");
      		} // end of if(Shtat_table.FindFirst("FTABN="+sqlToFind(VSP_table("Ftabn"))))

      		strSQL = "select * from ^RAZNSHPZ where Fshpz="+sqlTo(VSP_table("FSHPZ"))
      		trazn = OpenTable("s", strSQL);
      		if (!trazn.IsEmpty())
      		{
         		trazn.MoveFirst();
         		mFdb_sc   = trazn("Fdb_sc");
         		mFdb_su   = trazn("Fdb_su");
         		mFdb_st   = trazn("Fdb_st");
         		mFdb_cod1 = trazn("Fdb_cod1");
         		mFdb_cod2 = trazn("Fdb_cod2");
         		mFdb_cod3 = trazn("Fdb_cod3");
      		}
      		else
      		{
         		mFdb_sc   = 0;
         		mFdb_su   = 0;
         		mFdb_st   = 0;
         		mFdb_cod1 = 0;
         		mFdb_cod2 = 0;
         		mFdb_cod3 = 0;
      		}	
      		VSP_table.Edit();
      		VSP_table("Flv1")=mFlv1;
      		VSP_table("Flv2")=mFlv2;
      		VSP_table("Flv3")=mFlv3;
      		VSP_table("Fdb_sc")=mFdb_sc;
      		VSP_table("Fdb_su")=mFdb_su;
      		VSP_table("Fdb_st")=mFdb_st;
      		VSP_table("Fdb_cod1")=mFdb_cod1;
      		VSP_table("Fdb_cod2")=mFdb_cod2;
      		VSP_table("Fdb_cod3")=mFdb_cod3;
      		VSP_table.Update();
      		VSP_table.MoveNext();
   		} // end of  while(!VSP_table.IsEOF())
	}
*/	 
	var mLv;
	var mSc;
	var nID;
	for(VSP_table.MoveFirst(); !VSP_table.isEOF(); VSP_table.MoveNext())
	{
		nID = VSP_table.getValue("FWID");
		mLv = getSnap("select org.Flv1,org.Flv2,org.Flv3 "
					+" FROM ^stru_org org "
						+" INNER JOIN ^stru_dol dol ON org.fwid=dol.fwid_org"
						+" INNER JOIN ^work_pers pers ON pers.fwid_dol=dol.fwid "
					+" WHERE pers.fwid="+ VSP_table.getValue("FWID_WP"));
		mSc = getSnap("select Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3 "
					+" from ^RAZNSHPZ "
					+" where Fshpz="+ (VSP_table.getValue("FSHPZ")==""?"0":VSP_table.getValue("FSHPZ")));
		ExecuteSQL("UPDATE ^VSP92T "
				+" SET Flv1="+ (mLv!=null? mLv[0] : 0)
				    +",Flv2="+ (mLv!=null? mLv[1] : 0)
				    +",Flv3="+ (mLv!=null? mLv[2] : 0)
					+",Fdb_sc="+ (mSc!=null? mSc[0] : 0)
					+",Fdb_su="+ (mSc!=null? mSc[1] : 0)
					+",Fdb_st="+ (mSc!=null? mSc[2] : 0)
					+",Fdb_cod1="+ (mSc!=null? mSc[3] : 0)
					+",Fdb_cod2="+ (mSc!=null? mSc[4] : 0)
					+",Fdb_cod3="+ (mSc!=null? mSc[5] : 0)
				+" WHERE FWID="+nID);
	}
	setProgressPos(nPos++, sTxt);
	
	strSQL = "create table SVSH9 "
			+"(FWID " + SqlType("COUNTER") 
			+",Ftt "+SqlType("SHORT")
			+",Ftp "+SqlType("SHORT")
			+",Fts2 "+SqlType("SHORT")
			+",Fts1 "+SqlType("SHORT")
			+",Fts0 "+SqlType("SHORT")
			+",Ftsu "+SqlType(sqlTSu)
			+",Ftsc "+SqlType("SHORT")
			+",Ftl "+SqlType("SHORT")
			+", FDB_SC "+SqlType(sqlTSc)
			+", FDB_SU "+SqlType(sqlTSu)
			+", FDB_ST "+SqlType(sqlTSt)
			+", FDB_COD1 "+SqlType("LONG")
			+", FDB_COD2 "+SqlType("LONG")
			+", FLSFID "+SqlType("LONG")
			+", FFLD_NUM "+SqlType("LONG")
			+", FSUM "+SqlType("CURRENCY")
			+", FDAY "+SqlType("LONG")
			+", FCHAS "+SqlType("FLOAT")
			+", FLV1 "+SqlType("SHORT")
			+", Fshpz "+SqlType("TEXT",15)+")";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "select 0 as Ftt,0 as Ftp, 0 as Ftsu, 0 as Ftsc"
				+", 1 as Ftl, Fdb_sc, Fdb_su, sum(VSP92T.Fsum) as Fsum"
				+", sum(VSP92T.Fday) as Fday, sum(VSP92T.Fchas) as Fchas"
				+", Flsfid, Ffld_num "
			+" into SVSH91 from VSP92T "
			+" group by Fdb_sc, Fdb_su, Flsfid, Ffld_num";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "select 0 as Ftt,0 as Ftp, 1 as Ftsu, 0 as Ftsc, 0 as Ftl"
				+", Fdb_sc, Fdb_su, sum(VSP92T.Fsum) as Fsum"
				+", sum(VSP92T.Fday) as Fday, sum(VSP92T.Fchas) as Fchas"
				+", 0 as Flsfid, 0 as Ffld_num "
			+" into SVSH92 from VSP92T "
			+" group by Fdb_sc,Fdb_su";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "select 0 as Ftt,0 as Ftp, 0 as Ftsu, 1 as Ftsc, 0 as Ftl"
				+",Fdb_sc,0 as Fdb_su,sum(VSP92T.Fsum) as Fsum"
				+",sum(VSP92T.Fday) as Fday,sum(VSP92T.Fchas) as Fchas"
				+",0 as Flsfid, 0 as Ffld_num "
			+" into SVSH93 from VSP92T group by Fdb_sc";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "select 1 as Ftt,0 as Ftp, 0 as Ftsu, 0 as Ftsc, 0 as Ftl"
				+", 0 as Fdb_sc,0 as Fdb_su,sum(VSP92T.Fsum) as Fsum"
				+",sum(VSP92T.Fday) as Fday,sum(VSP92T.Fchas) as Fchas"
				+",0 as Flsfid, 0 as Ffld_num "
			+" into SVSH94 from VSP92T";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "insert into SVSH9 " + getColumn("SVSH91", true) 
			+ " select " + getColumn("SVSH91", false) + " from SVSH91";
	ExecuteSQL(strSQL);
	setProgressPos(nPos++, sTxt);
	
	strSQL = "insert into SVSH9 " + getColumn("SVSH92", true) 
			+ " select " + getColumn("SVSH91", false) + " from SVSH92";
	ExecuteSQL(strSQL);
 	setProgressPos(nPos++, sTxt);
	
	strSQL = "insert into SVSH9 " + getColumn("SVSH93", true) 
			+ " select " + getColumn("SVSH91", false) + " from SVSH93";
	ExecuteSQL(strSQL);
 	setProgressPos(nPos++, sTxt);
	
	strSQL = "insert into SVSH9 " + getColumn("SVSH94", true) 
			+ " select " + getColumn("SVSH91", false) + " from SVSH94";
	ExecuteSQL(strSQL);
	setProgressPos(0);
}

include("sys/DpList.js");