//расчет амортизации по инв.N от перв.стоимости для бюджетных организаций

function r_ambdg (mregim, retcod, os7, matpod, mdat1)
{
   var mFVOST_RATE,mbdat,medat,min_zp,cdat1,fis_inv,mFmol,mFscvn,mFsuvn,mFstvn
   var mFbdat,curbdat,kol_mes,mon_sum
	var m;
   //последнее число предыдущего года
   pdat1 = mdat1;
   var pbd = new Date(pdat1.getFullYear(),0,1);
   var ped = new Date(pdat1.getFullYear(),11,31);      
	
   //первое число года расчета
   cdat1 = sqlTo(pdat1);
	
	strSQL = "select * from ^OS7 where Finv_num=" + retcod.mFinv_num;
	os7 = OpenTable("s",strSQL);
   //n if (os7.Seek("=", retcod.mFinv_num))
   if (!os7.IsEmpty())
   {
      //если найдена инв.карточка, то ищем норму аморт.
      strSQL = "select * from ^NORM_GR where Fbdat<="+cdat1+" and Fedat>="+cdat1+" and Fgroup="+sqlTo(retcod.mFgroup)
      ogr = OpenTable("s", strSQL);
      if (!ogr.IsEmpty())
      {
         mFVOST_RATE = ogr.getValue("FKOEF");
      }
      else
      {
         _alert ("Для инв.N "+String(retcod.mFinv_num)+" нет нормы аморт.");
         mFVOST_RATE = 0;
      }
      if (mregim == "AM")
      {
         if (retcod.rnumtot==1)
         {
            // по счетам для списания затрат
            strSQL = "select * from ^VN_PEREM where Finv_num="+String(retcod.mFinv_num)+" and Fbdat<="+cdat1+" and Fedat>="+cdat1;
            vn = OpenTable("s", strSQL);
            if (vn.IsEmpty())
            {
               mFmol  = 0;
               mFscvn = os7.getValue("Fotn_z_sc");
               mFsuvn = os7.getValue("Fotn_z_su");
               mFstvn = os7.getValue("Fotn_z_st");
               mFclvn1 = os7.getValue("Fotn_c1");
               mFclvn2 = os7.getValue("Fotn_c2");
               mFclvn3 = os7.getValue("Fotn_c3");
               _alert("Нет инф.о закреплении ОС за МОЛ для N "+String(retcod.mFinv_num));
               mFvidos = os7.getValue("Fvidos");               
            }
            else
            {
               mFmol  = vn.getValue("Ftabn");
               mFscvn = vn.getValue("Fsc");
               mFsuvn = vn.getValue("Fsu");
               mFstvn = vn.getValue("Fst");
               mFclvn1 = vn.getValue("Fcl_cod1");
               mFclvn2 = vn.getValue("Fcl_cod2");
               mFclvn3 = vn.getValue("Fcl_cod3");
               mFvidos = os7.getValue("Fvidos");               
            }
         }
         if (retcod.rnumtot==2)
         {
            // по МОЛ
            strSQL = "select * from ^VN_PEREM where Finv_num="+String(retcod.mFinv_num)+" and Fbdat<="+cdat1+" and Fedat>="+cdat1;
            vn = OpenTable("s", strSQL);
            if (vn.IsEmpty())
            {
               mFmol  = os7.getValue("Fcod_mol");
               mFscvn = 0;
               mFsuvn = 0;
               mFstvn = 0;
               mFclvn1 = 0;
               mFclvn2 = 0;
               mFclvn3 = 0;
               _alert("Нет инф.о закреплении ОС за МОЛ для N "+String(retcod.mFinv_num));
               mFvidos = os7.getValue("Fvidos");               
            }
            else
            {
               mFmol  = vn.getValue("Ftabn");
               mFscvn = 0;
               mFsuvn = 0;
               mFstvn = 0;
               mFclvn1 = 0;
               mFclvn2 = 0;
               mFclvn3 = 0;
               mFvidos = os7.getValue("Fvidos");               
            }
         }
         if (retcod.rnumtot==3)
         {
            // по счетам приходования ОС
            mFmol  = 0;
            mFscvn = retcod.mFdb_sc;
            mFsuvn = retcod.mFdb_su;
            mFstvn = retcod.mFdb_st;
            mFclvn1 = retcod.mFdb_cod1;
            mFclvn2 = retcod.mFdb_cod2;
            mFclvn3 = retcod.mFdb_cod3;
            mFvidos = os7.getValue("Fvidos");            
         }
         if (retcod.rnumtot==4)
         {
            // по видам ОС
            mFmol  = 0;
            mFscvn = 0;
            mFsuvn = 0;
            mFstvn = 0;
            mFclvn1 = 0;
            mFclvn2 = 0;
            mFclvn3 = 0;
            mFvidos = os7.getValue("Fvidos");            
         }
        m = new Object();	
        // matpod.AddNew();
         m.FSUM_AM = retcod.rnumtot;
         m.FVIDOS  = mFvidos;         
         m.FDB_SC = mFscvn;
         m.Ftdsc  = 0;
         m.Ftdsu  = 0;
         m.Ftdst  = 0;
         m.Fdatkv = mdat1.getVarDate();
         m.FDB_SU = mFsuvn;
         m.FDAT_POST  = os7.getValue("FDOC_DAT");
         m.FINV_NUM   = os7.getValue("FINV_NUM");
         m.FORIG_PRIC = retcod.mForig_pric;
         m.FKF_ISPOL  = retcod.mFkfisp;
         m.FIZNOS     = retcod.mFiznos;
         m.FVOST_RATE = mFVOST_RATE;
         m.FMOL = mFmol;
         m.FDB_ST = mFstvn;
         m.FDB_COD1 = mFclvn1;
         m.FDB_COD2 = mFclvn2;
         m.FDB_COD3 = mFclvn3;
         m.Fkeyexpr  = String(mFscvn)+String(0)+String(mFsuvn)+String(0)+String(mFstvn)+String(0)+String(mFclvn1)+String(0)+String(mFclvn2)+String(0)+String(mFclvn3)+String(0)+String(mFmol)+String(0)+String(retcod.mFinv_num)
         //matpod.Update();
         UpdateTable(matpod,m,true);
      }
   }
   else
   {
      _alert("Для инв.N "+String(retcod.mFinv_num)+" нет нормы аморт.По ум.-0");
      mFVOST_RATE = 0;
   }

   mFbdat = (new Date(retcod.mFbdat)).getFullYear();
   
   mFpdat = (pdat1).getFullYear();
   
   //если дата расчета меньше или равна параметру изменения учета, то просто берем календарный год
   kol_mes = Number(mFpdat)-Number(mFbdat) //кол-во мес.для расчета износа (без текущего года)   
   mon_sum = round( (Number(mFVOST_RATE)*Number(retcod.mFkfisp)*Number(retcod.mForig_pric))/100, 2 );
   
   retcod.all_am = 0;
   curbdat = new Date(mFbdat,11,31);
      
   for ( var size=1; size<=kol_mes; size++)
   {
       retcod.all_am = Number(retcod.all_am) + round(koef_am(curbdat)*mon_sum,2);
       curbdat =  new Date(curbdat.getFullYear()+1, 11, 31);
   }
   
   mon_sum = round(mon_sum * koef_am(pdat1),2);
   mon_sum = (mon_sum-(retcod.mForig_pric-(retcod.mFiznos+retcod.all_am))<0)?mon_sum:retcod.mForig_pric-(retcod.mFiznos+retcod.all_am);
   if (mon_sum<0) 
       mon_sum = 0;

   retcod.mes_am  = mon_sum;
   retcod.sum_izn = 0;
   if (retcod.mForig_pric>0)
   {
  		retcod.sum_izn = (retcod.mForig_pric>=retcod.mFiznos+retcod.all_am+mon_sum)?retcod.mFiznos+retcod.all_am+mon_sum:retcod.mForig_pric;
   }

   if (mregim=="AM")
   {
      vkey = String(mFscvn)+String(0)+String(mFsuvn)+String(0)+String(mFstvn)+String(0)+String(mFclvn1)+String(0)+String(mFclvn2)+String(0)+String(mFclvn3)+String(0)+String(mFmol)+String(0)+String(retcod.mFinv_num);
   /*n   if (matpod.Seek("=", vkey))
      {
         matpod.Edit();
         matpod("Fsum_pv")  = retcod.mes_am;
         matpod("FSUM_IZN") = retcod.sum_izn;
         matpod.Update();
      }
    */
      strSQL = "update " + matpod+ " set Fsum_pv=" + retcod.mes_am + ", Fsum_izn=" 
      			+ retcod.sum_izn + " where Fkeyexpr=" + sqlTo(vkey);
      ExecuteSQL(strSQL);
   }

    //если расчет за предыдущий от даты перехода год, то нужно сохранить остатки в таблицу
   if (mregim=="AM"){   
    if (differ(fdizmuch, pdat1)==0){
 		var n = new Object();
   		n.Finv_num  = Number(retcod.mFinv_num);
		n.Fgroup    = Number(retcod.mFgroup);
		n.Fdatkv    = pdat1.getVarDate();
		n.Fbalst    = Number(retcod.mForig_pric);
		n.Famort    = Number(retcod.mes_am);
		n.Fiznos    = Number(retcod.sum_izn);
		n.Fkol      = Number(kol_mes);			
		UpdateTable("^RAMORBD", n, true);
    }
   }
   return retcod;
}