include("objects\\DpGetDat.js");
include("objects\\DpSc.js");
include("servis\\date.js");
include("izosdat.js");
include("izosdatb.js");

var rdat1, rnumtot;
var par;
var captDatb, captDate;

function listLoad()
{  	  	
  	this.xmlGridFile = "r_amnemp.xml";
  	//if(list.par.menuMode.substr(0,1)=="R")
  	//	this.par.menuMode = "CALC";		
  	if(list.par.menuMode == "RNEMAT")
  	{
		par = new Object();
		par.escape = true;
		par.rdat1  = getPar("GLOBDAT1");
		par.numtot = 1;
		showWindow("i_amallp.xml",SW_MODAL,par);
		rnumtot = par.numtot;
		rdat1   = new Date(par.rdat1.getYear()+1900, par.rdat1.getMonth(), par.rdat1.getDate()); 
		if(par.escape)
			return false;
		r_amnemp(rdat1, rnumtot, par.sc, par.su, par.st);
  	}
  	else
  	{
  		if (!IsTable("AMORTSR"))
		{
			alert(ru("Амортизация не просчитана. Сначала сделайте расчет","Амортизацiю не розраховано. Спочатку виконайте розрахунок."));
			return false;
		}
  	}
}

function listSrc()
{
	this.qrySet("From", "AMORTSR");
	this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
}

function listTitle()
{
	captDatb = d00;
	captDate = d00;
	var oSnap = getSnap("SELECT Fbdat,Fedat FROM AMORTSR_DT", false);
	if (oSnap!=null)
	{
		captDatb = oSnap[0];
		captDate = oSnap[1]
	}	
	return ru("Амортизация по непроизводственным ОС по сроку службы - "+format("dd-mm-yyyy", captDatb),
			"Амортизацiя по невиробничим ОЗ по терм.викор. - "+format("dd-mm-yyyy", captDatb))

}

function listMenuInit()
{
	if (!list.tbl.IsEOF() && !list.tbl.IsBOF())
	{
		list.dataSrc.AddMenuItem("TODOC", ru("Формирование проводок", "Формування проведень"))
	}
}

function listMenuRun(ID)
{
	var cDoc;
	cDoc = "AB";
	switch(ID)
	{
		case "TODOC":
			include("Objects\\DpDstDoc.js");
			var oDstDoc = new DpDstDoc(cDoc);
			if(oDstDoc.findNop())
			{
				var t2Doc = OpenTable("SELECT * FROM amortsr WHERE " + DataSource().sqlSelected());
				var m = new Object();
				while(!t2Doc.IsEOF())
				{
					m.HDAT = captDate;
					m.HSC = t2Doc.getValue("Fdb_sc");
					m.HSU = t2Doc.getValue("Fdb_su");
					m.HST = t2Doc.getValue("Fdb_st");
					m.HA1 = t2Doc.getValue("Fdb_cod1");
					m.HA2 = t2Doc.getValue("Fdb_cod2");
					m.HA3 = t2Doc.getValue("Fdb_cod3");
					m.HPODR = t2Doc.getValue("Fpodr");
					m.HSUM = t2Doc.getValue("Fsum_pv");
					oDstDoc.append(m);
					t2Doc.MoveNext();
				}
				oDstDoc.done();
				alert(ru("Сформировано ","Сформовано ")+t2Doc.rowCount+ru(" проводок."," проведень."));
				t2Doc.close();
			}
		break;
	}
}

function r_amnemp (parDat, numtot, sc, su, st)
{
	var nschet=sc;

	if(nschet==null)
		return false;

	var nsubschet = su;
	if(nsubschet==null)
		return false;

	tblNameDate = "AMORTSR_DT";
  	DropTable(tblNameDate);
  	strSQL = "CREATE TABLE " + tblNameDate + " (fbdat "+SqlType("DATE")+", fedat "+SqlType("DATE")+")";

  	ExecuteSQL(strSQL);
  	strSQL = "INSERT INTO " + tblNameDate + " (fbdat, fedat) VALUES (" + sqlTo(firstDay(rdat1)) + ", " + sqlTo(lastDay(rdat1)) + ")";
  	ExecuteSQL(strSQL);
		
	DropTable("TAMSR0");
	DropTable("TAMSR01");
	DropTable("TAMSR02");
	DropTable("TAMSR03");
	DropTable("TAMSR1");
	DropTable("TAMSR2");
	DropTable("TAMSR3");
	DropTable("TAMSR4");

	var offset, ostsr;

	dat_am  = parDat;
	new_dat = parDat;
	
	mon_sum= 0;
	all_am = 0;
	
	fis_amexist = true;
	if (!IsTable("AMORTSR"))
		fis_amexist = false;
	//strSQL = "CREATE Index AMORTSR on AMORTSR (Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, Fpodr, Finv_num)";
	
	if (!fis_amexist)
	{
		CreateTable("AMORTSR", "AMORT");
		strSQL = "CREATE Index AMORTSR on AMORTSR (FKEYEXPR)";
		ExecuteSQL(strSQL, true);
	}
	else
	{
  		strSQL = "delete from AMORTSR";
  		ExecuteSQL(strSQL);
	}

    if (nschet==0){
		strSQL = "select * from ^OS0 where Fbdat<="+sqlTo(new_dat)+" and Fedat>="+sqlTo(new_dat)+" and (Fgroup=6 or Fgroup=4) order by Finv_num";
    }else{
    	if (nsubschet==0){    	
			strSQL = "select * from ^OS0 where Fbdat<="+sqlTo(new_dat)+" and Fedat>="+sqlTo(new_dat)+" and (Fgroup=6 or Fgroup=4) and Fdb_sc="+sqlTo(nschet)+" order by Finv_num";
    	}else{
			strSQL = "select * from ^OS0 where Fbdat<="+sqlTo(new_dat)+" and Fedat>="+sqlTo(new_dat)+" and (Fgroup=6 or Fgroup=4) and Fdb_sc="+sqlTo(nschet)+" and Fdb_su="+sqlTo(nsubschet)+" order by Finv_num";    		
    	}	    	
    }	
	os0b = OpenTable("s", strSQL);
	if (os0b.IsEmpty())
	{
   		alert(ru("Список ОС за данный период пуст","Список ОС за даний період пустий"));
   		return false;
	}

	while (!os0b.IsEOF())	
	{
   		WAIT ("N ="+String(os0b.getValue("Finv_num")));
   		os1 = OpenTable("s", "select * from ^OS1 where Finv_num="+sqlTo(os0b.getValue("Finv_num")));
   		if (!os1.IsEmpty())
   		{
      		mFsrok  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "srokadd"));
      		mFkolos = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "kol"));
      		mFiznos = Number(os0b.getValue("Fiznos"));

      		os0b_pric = Number(os0b.getValue("Forig_pric"));
      		os0b_bd   = new Date(os0b.getValue("Fbdat"));
      		//os0b_bd_1 = new Date(new Date(os0b("Fbdat")).getYear(), new Date(os0b("Fbdat")).getMonth(), new Date(os0b("Fbdat")).getDate()-1);
      		os0b_bd_1 = new Date(os0b.getValue("Fbdat").getYear()+1900, os0b.getValue("Fbdat").getMonth(), os0b.getValue("Fbdat").getDate()-1);
      		
      		//if ( new Date(os0b("Fbdat")).getDate()==1 && os0b("Fbdat")!=os1("Fdoc_dat") && (new Date(os0b("Fbdat")).getYear()==new Date(new_dat).getYear() && new Date(os0b("Fbdat")).getMonth()==new Date(new_dat).getMonth() && new Date(os0b("Fbdat")).getDate()==new Date(new_dat).getDate()))
      		if ( os0b.getValue("Fbdat").getDate()==1 && os0b.getValue("Fbdat")!=os1.getValue("Fdoc_dat") && (os0b.getValue("Fbdat").getYear()==new_dat.getYear() && os0b.getValue("Fbdat").getMonth()==new_dat.getMonth() && os0b.getValue("Fbdat").getDate()==new_dat.getDate()))
      		{
         		mFiznos   = Number(izosdat(os0b_bd_1, Number(os0b.getValue("Finv_num")), "iznos"))
        		os0b_pric = Number(izosdat(os0b_bd_1, Number(os0b.getValue("Finv_num")), "orig_pric"))
         		os0b_bd   = new Date(izosdat(os0b_bd_1, Number(os0b.getValue("Finv_num")), "bdat"))
         		mFkolos   = Number(izosdat(os0b_bd_1, Number(os0b.getValue("Finv_num")), "kol"))
         		mFsrok    = Number(izosdat(os0b_bd_1, Number(os0b.getValue("Finv_num")), "srokadd"));
      		}

      		//дата, от которой будет рассчитываться срок эксплуат.ОС
      		if (Number(os1.getValue("Fgod_vip"))!=0)
      		{
         		dat_beg = new Date(os1.getValue("Fgod_vip"), 0, 1);
      		}
      		else	
      		{
      			var vvodDat = new Date(os1.getValue("Fvvod_ecsp"));       		
        		dat_beg = new Date(vvodDat.getYear()+1900, vvodDat.getMonth(), vvodDat.getDate());
         		if (differ(dat_beg, os1.getValue("Fdoc_dat")) > 0)
            		dat_beg = new Date(vvodDat.getYear()+1900, vvodDat.getMonth()+1, 1)
      		}
      		mFlikvst  = Number(os1.getValue("Flikvst"));
      		mFkollikv = Number(os1.getValue("Fkollikv"));
      		mFkollikv = (mFkollikv==0)? 1 : mFkollikv;
      		
      		// дата, до которой будет рассчит.срок ксплуат.ОС 
      		//dat_end = new Date(goMonth(dat_beg, mFsrok));
      		dat_end   = new Date(dat_beg.getYear()+1900, mFsrok, dat_beg.getDate());

      		//найти подр., на которое будут списыв.затраты
      		strSQL = "select * from ^VN_PEREM where Finv_num="+sqlTo(os0b.getValue("Finv_num"))+" and Fbdat<="+sqlTo(new_dat)+" and Fedat>="+sqlTo(new_dat)
      		vnpr = OpenTable("s", strSQL);
     		
      		if (numtot==1)
      		{
         		if (!vnpr.IsEmpty())
         		{
            		mFpodr = Number(vnpr.getValue("Fpodr"));
            		mFscvn = Number(vnpr.getValue("Fsc"));
            		mFsuvn = Number(vnpr.getValue("Fsu"));
            		mFstvn = Number(vnpr.getValue("Fst"));
            		mFclvn1 = Number(vnpr.getValue("Fcl_cod1"));
            		mFclvn2 = Number(vnpr.getValue("Fcl_cod2"));
            		mFclvn3 = Number(vnpr.getValue("Fcl_cod3"));
         		}
         		else
         		{
            		mFpodr = 0;
            		mFscvn = 0;
            		mFsuvn = 0;
            		mFstvn = 0;
            		mFclvn1 = 0;
            		mFclvn2 = 0;
            		mFclvn3 = 0;
         		}	
      		}
      		
      		if (numtot==2)
      		{
         		if (!vnpr.IsEmpty())
            		mFpodr = Number(vnpr.getValue("Fpodr"));
         		else
            		mFpodr = 0;
         		mFscvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_sc"));
         		mFscvn  = (mFscvn==-100)?0:mFscvn;
         		mFsuvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_su"));
         		mFsuvn  = (mFsuvn==-100)?0:mFsuvn;
         		mFstvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_st"));      
         		mFstvn  = (mFstvn==-100)?0:mFstvn;
         		mFclvn1 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_cod1"));      
         		mFclvn1 = (mFclvn1==-100)?0:mFclvn1;
         		mFclvn2 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_cod2"));      
         		mFclvn2 = (mFclvn2==-100)?0:mFclvn2;
         		mFclvn3 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "db_cod2"));      
         		mFclvn3 = (mFclvn3==-100)?0:mFclvn3;
      		}	
      		
      		if (numtot==3)
      		{ 
         		if (!vnpr.IsEmpty())
            		mFpodr = Number(vnpr.getValue("Fpodr"));
         		else	
            		mFpodr = 0;
         		mFscvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_sc"));
         		mFscvn  = (mFscvn==-100)?0:mFscvn;
         		mFsuvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_su"));
         		mFsuvn  = (mFsuvn==-100)?0:mFsuvn;
         		mFstvn  = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_st"));      
         		mFstvn  = (mFstvn==-100)?0:mFstvn;
        		mFclvn1 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_cod1"));      
         		mFclvn1 = (mFclvn1==-100)?0:mFclvn1;
         		mFclvn2 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_cod2"));      
         		mFclvn2 = (mFclvn2==-100)?0:mFclvn2;
         		mFclvn3 = Number(izosdat(new_dat, Number(os0b.getValue("Finv_num")), "cr_cod2"));      
         		mFclvn3 = (mFclvn3==-100)?0:mFclvn3;
      		}
      		vnpr.close();
      		
      		fis_inv = true;

      		//if (!(new_dat<dat_beg))
      		if (differ(new_dat, dat_beg)>=0)
      		{ 
         		var m = new Object()
         		//matpod.AddNew();
        		m.FGROUP = Number(izosdat(new_dat,Number(os0b.getValue("FINV_NUM")),"group"));
         		m.Fdatkv = dat_am.getVarDate();
         		m.FDB_SC = mFscvn;
         		m.FDB_SU = mFsuvn;
         		m.FDB_ST = mFstvn;
         		m.FDB_COD1 = mFclvn1;
         		m.FDB_COD2 = mFclvn2;
         		m.FDB_COD3 = mFclvn3;
         		m.FPODR  = mFpodr;
         		m.FDAT_POST = os1.getValue("FDOC_DAT");
         		m.FINV_NUM  = Number(os1.getValue("FINV_NUM"));
         		m.FORIG_PRIC= Number(os0b.getValue("FORIG_PRIC"));
         		m.FKF_ISPOL = Number(os0b.getValue("FKF_ISPOL"));
         		m.FIZNOS    = Number(os0b.getValue("Fiznos"));
         		m.Fcod_rate = mFsrok;
         		m.Fgod_vip  = Number(os1.getValue("Fgod_vip"));
         		m.Fvvod_ecsp= os1.getValue("Fvvod_ecsp");
         		m.FLIKVST   = mFlikvst;
         		m.FVIDOS    = Number(os1.getValue("FVIDOS"));
         		UpdateTable("AMORTSR", m, true)         		
      		}      		
   		}
   		else
   		{
      		alert(ru("Ошибка в инв. N ", "Помилка в інв. N ")+ String(os0b.getValue("Finv_num")))
      		mFsrok  = 0;
      		fis_inv = false;
      		strSQL = "select min(^OS0B.Fbdat) as Fbdat from ^OS0B where Finv_num="+sqlTo(os0b.getValue("Finv_num"));
      		//os0bi = OpenTable("s", strSQL);
      		var snap = getSnap(strSQL);
      		if(snap!=null)
      			dat_beg = new Date(snap[0]);
      		else
      			dat_beg = d00;
      		os0b_bd   = new Date(os0b.getValue("Fbdat"));
      		os0b_pric = os0b.getValue("Forig_pric");
      		mFiznos   = os0b.getValue("Fiznos");
      		//dat_end   = new Date(goMonth(dat_beg, mFsrok));
      		dat_end   = new Date(dat_beg.getYear()+1900, mFsrok, dat_beg.getDate());
      		mFlikvst  = 0;
			mFkollikv = 0;
	  		mFkolos   = 0;
		}
		os1.close();

		//mFbdat = new Date(new Date(os0b_bd).getYear(),new Date(os0b_bd).getMonth()+1, 1);
		mFbdat = new Date(os0b_bd.getYear()+1900,os0b_bd.getMonth()+1, 1);

   		kol_mes = round((((new_dat - mFbdat)/3600000)/24)/30.4367, 0);
  	
   		kol_mes = Number(kol_mes);
   		mon_sum = Number (mon_sum);
   		os0b_pric = Number(os0b_pric);
   		mFlikvst = Number(mFlikvst);
   		mFkolos = Number(mFkolos);
   		mFkollikv = Number(mFkollikv);
   		mFiznos = Number(mFiznos);

   		mon_sum = round((os0b_pric - (mFlikvst * mFkolos * mFkollikv)) / (mFsrok!=0? mFsrok : 1), 2 )
   		
   		if (mon_sum<0)
   		{
      		WAIT(ru("Ликв.стоим.больше перв.для N ","Лікв.варт.більше перв.для N ") +String(os0b.getValue("Finv_num")));
      		mon_sum = 0;
      		mFiznos = os0b_pric-(mFlikvst*mFkolos*mFkollikv);
   		}
   		
   		if (kol_mes<0)
   		{
      		mon_sum = 0
   		}
   		
   		all_am = 0;
   		curbdat = mFbdat;

   		for ( var i=1; i<=kol_mes; i++)
   		{
       		all_am = all_am + mon_sum;
       		curbdat = new Date(curbdat.getYear()+1900, curbdat.getMonth()+1,1);
   		}
		all_am = Number(all_am);
		
		if (os0b_pric-(mFiznos+all_am)<=0)  
			mes_am = 0;

   		if (os0b_pric-(mFiznos+all_am)>0)
   		{
      		mes_am =(mon_sum-(os0b_pric-(mFiznos+all_am))-(mFlikvst*mFkolos*mFkollikv)<0)?mon_sum:os0b_pric-(mFiznos+all_am)-(mFlikvst*mFkolos*mFkollikv);
      		if (mes_am<0) mes_am = 0;
   			mes_am = Number(mes_am);
   		}
   		
   		var xxiznos = 0;
   		// неизвестно, нужно ли включать в износ амортизацию текущего месяца
   		if (os0b_pric-(mFlikvst*mFkolos*mFkollikv)>0)
   		{
      		xxiznos = (os0b_pric-(mFlikvst*mFkolos*mFkollikv)>=all_am+mFiznos+mes_am)?all_am+mFiznos+mes_am:os0b_pric-(mFlikvst*mFkolos*mFkollikv);
   		}
	
		xxiznos = Number(xxiznos);
   		
   		if (fis_inv)
   		{
      		//if (!(new_dat<dat_beg))
      		if (differ(new_dat, dat_beg)>=0)
      		{
         		var m = new Object()
         		m.FSUM_PV  = mes_am;
         		m.FSUM_IZN = xxiznos;
         		m.Fsum_am  = os0b_pric-xxiznos;
         		_os0b = Number(os0b.getValue("Finv_num"))
         		m.Fkol     = (izosdat(new_dat, Number(os0b.getValue("Finv_num")), "kol"));
         		UpdateTable("AMORTSR", m, false, "Finv_num="+_os0b);
      		}      		
   		}
   		os0b.MoveNext();
	}
	os0b.close();
	//подбивка итогов по индивидуальному расчету
	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, fdb_st, Fdb_cod1, fdb_cod2, fdb_cod3, fpodr, 1 as ftdpodr, "+
         "0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 0 as Ftda2, 0 as Ftda3, 999999 as finv_num into TAMSR0 from AMORTSR "+
         " group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3, Fpodr";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, fdb_st, Fdb_cod1, fdb_cod2, fdb_cod3, "+
         "0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 0 as Ftda2, 1 as Ftda3, 999999 as finv_num into TAMSR01 from AMORTSR "+
         " group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, fdb_st, Fdb_cod1, fdb_cod2, "+
         "0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 0 as Ftda1, 1 as Ftda2, 999999 as finv_num into TAMSR02 from AMORTSR "+
         " group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, fdb_st, Fdb_cod1, "+
         "0 as Ftdst, 0 as Ftdsu, 0 as Ftdsc, 1 as Ftda1, 999999 as finv_num into TAMSR03 from AMORTSR "+
         " group by Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, fdb_st, 1 as ftdst, "+
         "0 as Ftdsu, 0 as Ftdsc, 999999 as finv_num into TAMSR1 from AMORTSR "+
         " group by Fdb_sc, Fdb_su, Fdb_st";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, fdb_su, 0 as fdb_st, 0 as ftdst, "+
         "1 as Ftdsu, 0 as Ftdsc, 999999 as finv_num  into TAMSR2 from AMORTSR "+
         " group by fdb_sc, fdb_su";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
         "0 as Ftdsu, 1 as Ftdsc, 999999 as finv_num into TAMSR3 from AMORTSR "+
         " group by fdb_sc";
	ExecuteSQL(strSQL);

	strSQL = "select sum(AMORTSR.Fsum_pv) as Fsum_pv, sum(AMORTSR.Fsum_izn) as Fsum_izn, "+
         "sum(AMORTSR.Forig_pric) as Forig_pric, sum(AMORTSR.Fsum_am) as Fsum_am, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
         "0 as Ftdsu, 2 as Ftdsc, 0 as finv_num  into TAMSR4 from AMORTSR ";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR0", true) + 
         "select " + getColumn("TAMSR0", false) + "from TAMSR0";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR01", true) + 
         " select " + getColumn("TAMSR01", false) + " from TAMSR01";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR02", true) + 
         " select " + getColumn("TAMSR02", false) + " from TAMSR02";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR03", true) + 
         " select " + getColumn("TAMSR03", false) + " from TAMSR03";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR1", true) + 
         " select " + getColumn("TAMSR1", false) + " from TAMSR1";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR2", true) + 
         " select " + getColumn("TAMSR2", false) + " from TAMSR2";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR3", true) + 
         " select " + getColumn("TAMSR3", false) + " from TAMSR3";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSR " + getColumn("TAMSR4", true) + 
         " select " + getColumn("TAMSR4", false) + " from TAMSR4";
	ExecuteSQL(strSQL);

	strSQL = "UPDATE ^AMORTSR set FKEYEXPR = " + SqlConCat(Convert("FDB_SC", "STR"), Convert("FTDSC", "STR"), Convert("FDB_SU", "STR"), Convert("FTDSU", "STR"), Convert("FDB_ST", "STR"), Convert("FTDST", "STR"), Convert("FDB_COD1", "STR"), Convert("FTDA1", "STR"), Convert("FDB_COD2", "STR"), Convert("FTDA2", "STR"), Convert("FDB_COD3", "STR"), Convert("FTDA3", "STR"), Convert("FPODR", "STR"), Convert("FTDPODR", "STR"), Convert("FINV_NUM", "STR"));
	ExecuteSQL(strSQL);

	CLEARWAIT();
}
include("sys\\DpList.js");