//процедура вычисления балансовой стоимости на дату ликвидации, износа на конец 
//квартала и балансовой стоимости на конец квартала
function r_baliz2( rmode, mFdate, mFinv_num, mFdat_post)
{
   //это упрощенный вариант программы (считается, ято амортизация за прошлый месяц
   //общая и индивидуальная уже  посчитаны

   var balst, am, Iznos, fis_kompl, datcurkv, datcurkve;
   
   datNewAm = new Date(1997,6,1);
   var dt102001 = new Date(2001,9,1)

   //alert("нужен параметр для необлагаемого минимума для 1 группы ОС");
   min_zp = getPar("MINZP");

   balst = 0;
   Iznos = 0;
       
   mFdat_post = new Date(mFdat_post)
   mFdate = new Date(mFdate)
   
   o7  = OpenTable("s", "select * from ^OS7 where Finv_num="+String(mFinv_num));
   Fis_kompl = false;
   if (!o7.IsEmpty())
   {
      if (Number(o7.getValue("Fkompl"))!=0) Fis_kompl = true;
   }

   datcurkv = new Date(firstkv(mFdate));
   datcurkve= new Date(lastkv(mFdate));

   // найти дату начала предыдущего квартала
   curdat = new Date(datcurkv-1);
   datprewkv = new Date(firstkv(curdat));
   datprewkve = new Date(lastkv(datprewkv));
   //если текущий квартал расчета 3.97, то предыдущий квартал для него нужно
   // перебить на текущий и информацию об остатках брать из RAMI
   if (datprewkv<datNewAm)
   {
      datprewkv = datcurkv;
      datprewkve= datcurkve;
   }
   sdatprewkv = sqlTo(datprewkv);

   //проверить, было ли изменение группы на дату начала квартала расчета
   if (!izgr_dat( datcurkv,  datcurkv))   return 0;
   vspx  = OpenTable("s", "select * from VSPX where Finv_num="+String(mFinv_num));
   Fis_izmgr = false;
   if (!vspx.IsEmpty())
   {
      Fis_izmgr = true;
   }   
   //найти балансовую стоимость на конец предыдущего квартала
   Fis_gr7 = false;
   if (datcurkv<=mFdat_post && (mFdat_post>datNewAm || mFdat_post<datNewAm) )
   {
      balst = 0;
      Iznos = 0;
      //если ОС поступило в квартале расчета или в предыдущем квартале, то 
      // балансовая стоимость на начало квартала = 0
      curgroup = Number(izosdat(mFdat_post, mFinv_num, "group"));
      // если группа 0 или 7, то нужно брать баланс.стоимость из OS0
      if (curgroup==0 || curgroup==7)
      {
        Iznos = Number(izosdat(mFdat_post, mFinv_num, "iznos"));
        balst = Number(izosdat(mFdat_post, mFinv_num, "orig_pric"))-Iznos;
        balst = (balst<0)?0:balst;
        if (rmode=="BAL") return balst;
        if (rmode=="IZN") return Iznos;
      }
   }
   else
   {
      //найти группу ОС на начало текущего квартала
      curgroup = Number(izosdat(datcurkv, mFinv_num, "group"));
      if (curgroup==0 || curgroup==7)
      {
         Iznos = Number(izosdat(datcurkv, mFinv_num, "iznos"));
         balst = Number(izosdat(datcurkv, mFinv_num, "orig_pric"))-Iznos;
         balst = (balst<0)?0:balst;
         if (rmode=="BAL") return balst;
         if (rmode=="IZN") return Iznos;
      }
      //найти группу ОС на конец предыдущего квартала
      // если было изменение группы, то взять из файла по изменению группы;
      // если не было изменения группы, то взять из OS0      
      if (Fis_izmgr) prewgroup = Number(vspx.getValue("Fpgroup"));
         else prewgroup = Number(izosdat(new Date(datcurkv-1), mFinv_num, "group"));
      // если было изменение группы,
      // то нужно брать баланс.стоимость на начало из OS0 для любой группы
      if (Fis_izmgr)
      {
         if (prewgroup==0 || prewgroup==7) Fis_gr7 = true;
         Iznos = Number(izosdat(datcurkv, mFinv_num, "iznos"));
         balst = Number(izosdat(datcurkv, mFinv_num, "orig_pric"))-Iznos;
         balst = (balst<0)?0:balst;
      }
      else
      {
         rami  = OpenTable("s", "select * from ^RAMI where Finv_num="+String(mFinv_num)+" and Fgroup="+String(prewgroup)+" and Fdatkv="+sdatprewkv);
         if (rami.IsEmpty())
         {
            if (mFdat_post<datprewkv)
            { 
               _alert("Не был произведен расчет амортизации по каждому ОС за предыдущий квартал");
               balst=0;
               Iznos=0;
               if (rmode=="BAL") return balst;
               if (rmode=="IZN") return Iznos;
            }
            else
            {
               balst=0;
               Iznos=0;
            }
         }
         else
         {
            balst=Number(rami.getValue("Fbalst"))+Number(rami.getValue("Fprib"))-Number(rami.getValue("Fvib"))-Number(rami.getValue("Famort"));
            balst = (balst<0)?0:balst;
            Iznos=toScrObj(rami.getValue("Fiznos"));
         }
         rami.close();
         // если текущая группа=1 и балансовая стоимость на конец предыдущего квартала<=1700,
         // то та балансовая стоимость обнуляется
      }
   }

   //если ОС входит в компелкт для 1 группы, то нужно найти балансовую стоиомость
   // комплекта в квартале выбытия, чтобы узнать, начислять амортизацию на ОС при 
   // вычислении балансовой стоимости или нет
   if (Fis_kompl)
   {
      Fis_zkompl = true;
      ramb = OpenTable("s", "select * from ^RAMORT where Fkompl="+String(o7.getValue("Fkompl"))+" and Fdatkv="+sqlTo(datcurkv) );
      if (ramb.IsEmpty())
      {
        _alert("Нет записи в таблице расчета амортизации за "+StrDat(datcurkv, "DMY")+ " для компл. № "+String(o7.getValue("Fkompl")));
        Fis_zkompl = false;
      }
   }

   if (curgroup==1 && !Fis_kompl)
   {
      if (balst<=100*min_zp)
      {
         balst=0;
         Iznos=Number(izosdat(datcurkv, mFinv_num, "orig_pric"));
      }
   }

   if (curgroup==1 && Fis_kompl)
   {
      if (Fis_zkompl)
      {
         //если найдена запись амортизации по комплекту, то нужно найти балансовую
         //стоимость комплекта и проверить, превышает ли она 100 min zp. Если нет, 
         // то обнулить балансовую стоимость ОС
         if (!ramb.IsEmpty()) balkmpl=Number(ramb.getValue("Fbalst"))+Number(ramb.getValue("Fprib"))-Number(ramb.getValue("Fvib"))-Number(ramb.getValue("Famort"));
         else balkmpl=0;
         if (balkmpl<=100*min_zp)
         {
            balst = 0;
            // изноc равен первоначальной стоимости
            Iznos=Number(izosdat(datcurkv, mFinv_num, "orig_pric"));
         }
      }
      else
      {
         if (balst<=100*min_zp)
         {
            balst=0;
            Iznos=Number(izosdat(datcurkv, mFinv_num, "orig_pric"));
         }
      }
   }

 if (!Fis_izmgr)
 {
   balst_prew = balst;
   kf  = 1;
   //если предыдущая группа не была 0,7, то надо найти стоимость модернизации и
   // выбытия ОС за предыдущий квартал, чтобы найти балансовую стоимость на начало
   // текущего квартала

   if (!Fis_gr7)
   {
         //alert("oss_dati за пред,квартал");
      //найти сумму прибытия, модернизации и выбытия за предыдущий квартал 
      oss_dati(mFinv_num, datprewkv, datprewkve);

      sum_vib =0;
      vib_izn =0;
      sum_prib=0;
      prib_izn=0;
      prib_pric=0;
      sum_izm =0;
      izm_izn =0;
      vspi = OpenTable("s", "VSPI");

      if (!vspi.IsEmpty())
      {
         if (datprewkv.getFullYear()==dt102001.getFullYear() && datprewkv.getMonth()==dt102001.getMonth() && datprewkv.getDate()==dt102001.getDate())
         {
            strSQL = "UPDATE ^VSPI set Fprib=0, Fubil=0, Fizm=0, Fizm_izn=0";
            ExecuteSQL(strSQL);
            vspi.MoveFirst();
         }
         if (Number(vspi.getValue("Fprib"))!=0 && !o7.IsEmpty() && (mFdat_post<datNewAm || mFdat_post>datNewAm))
         {
           sum_prib = Number(vspi.getValue("Fprib"))-Number(o7.getValue("Fiznos"));
           sum_prib = (sum_prib<0)?0:sum_prib;
           prib_izn = o7.getValue("Fiznos");
           prib_pric= o7.getValue("Forig_pric");
         }

         cd2 = sqlTo(datprewkve);
         cmFdate = sqlTo(mFdate);
         //sdat - дата до первого акта ликвидации, на которую вычисляется первоначальная
         // стоимость ОС
         sdat = (datprewkv>mFdat_post)?datprewkv:mFdat_post;
         if (Number(vspi.getValue("Fubil"))!=0)
         {
            //этот цикл нужен для нахождения коеффициента, на который нужно уменьшить
            // износ, если в предыдущем квартале была частичная ликвидация ОС 
            //пройтись по всем актам ликвидации за прошлый квартал, у которых дата меньше
            // даты расчета и собрать балансовую стоимость, на которую уменьшается
            // балансовая стоимость ОС и первоначальную стоимость, на которую выбыло ОС
            // затем находится коеффициент уменьшения
            o4= OpenTable("s", "select * from ^OS4 where Finv_num="+String(mFinv_num)+" and Fdoc_dat>="+sdatprewkv+" and Fdoc_dat<="+cd2+" and Fdoc_dat<"+cmFdate);
            if (!o4.IsEmpty())
            {
              sdat = new Date(new Date(o4.getValue("Fdoc_dat"))-1);
              sdat = (sdat>mFdat_post)?sdat:mFdat_post;
              sum_vib   = 0;
              while (!o4.IsEof() && Number(o4.getValue("Finv_num"))==mFinv_num)
              {
                 doc_dat = new Date(o4.getValue("Fdoc_dat"));
                 if (doc_dat>=datprewkv && doc_dat<=datprewkve && doc_dat<mFdate)
                 {
                    if (prewgroup==1)
                    {
                       sum_vib = sum_vib+Number(o4.getValue("Fsum_bal"));
                    }
                    else
                    {
                       //sum_vib = sum_vib+o4("Fsum_real");
                       //выбытие с амортизацией
                       if (Number(o4.getValue("Fbalstrsch"))!=0 && Number(o4.getValue("Fsum_real"))==0)
                       {
                          sum_vib = sum_vib+Number(o4.getValue("Fbalstrsch"));
                       }
                       else
                       {
                          sum_vib = sum_vib+Number(o4.getValue("Fsum_real"));
                       }
                    }
                 }
                 o4.MoveNext();
               }
            }
            else
            {
              o4.close();
              o4= OpenTable("s", "select * from ^OS4 where Finv_num="+String(mFinv_num)+" and Fdoc_dat>="+sdatprewkv+" and Fdoc_dat<="+cd2+" and Fdoc_dat="+cmFdate);
              if (o4.IsBOF() && o4.IsEOF())
              {
                _alert("Не найден акт ликвидации для № "+String(mFinv_num));            
              }
              else
              {
                sdat = new Date(new Date(o4.getValue("Fdoc_dat"))-1);
                sdat = (sdat> mFdat_post)?sdat:mFdat_post;
              }
            }
            o4.close()
         }

         if (Number(vspi.getValue("Fizm"))!=0 || (Number(vspi.getValue("Fizm"))==0 && Number(vspi.getValue("Fizm_izn"))!=0))
         {
           sum_izm = Number(vspi.getValue("Fizm"))-Number(vspi.getValue("Fizm_izn"));
         }

         //эти вычисления нужны для нахождения коеффициента, на который нужно уменьшить
         // износ, если в предыдущем квартале была частичная ликвидация ОС 
         kf = 1;
         if (sum_vib!=0)
         {
            if (Number(vspi.getValue("Feost"))==0) kf = 0;
            else kf = (Number(vspi.getValue("Fbost"))+Number(vspi.getValue("Fprib"))-Number(vspi.getValue("Fubil")))/(Number(vspi.getValue("Fbost"))+Number(vspi.getValue("Fprib")));
         }
         balst = balst+sum_prib-sum_vib+sum_izm;
         balst = (balst<0)?0:balst;

         // если было выбытие ОС или уменьшение стоимости, то нужно уменьшить
         // износ на коеффициент ликвидации или уменьшения стоимости
         Iznos = round((Iznos+prib_izn)*kf,2);

      }
      if (curgroup==1 && !Fis_kompl)
      {
         if (balst<=100*min_zp)
         {
            balst = 0;
            // изноc равен первоначальной стоимости
            Iznos = Number(izosdat(datcurkve, mFinv_num, "orig_pric"));
         }
      }
      if (curgroup==1 && Fis_kompl)
      {
         if (Fis_zkompl)
         {
            //если найдена запись амортизации по комплекту, то нужно найти балансовую
            //стоимость комплекта и проверить, превышает ли она 100 min zp. Если нет, 
            // то обнулить балансовую стоимость ОС
            if (!ramb.IsEmpty()) balkmpl=Number(ramb.getValue("Fbalst"))+Number(ramb.getValue("Fprib"))-Number(ramb.getValue("Fvib"))-Number(ramb.getValue("Famort"));
            else balkmpl=0;
            if (balkmpl<=100*min_zp)
            {
               balst = 0;
               // изноc равен первоначальной стоимости
               Iznos = Number(izosdat(datcurkve, mFinv_num, "orig_pric"));
            }
         }
         else
         {
            if (balst<=100*min_zp)
            {
               balst = 0;
               // изноc равен первоначальной стоимости
               Iznos = Number(izosdat(datcurkve, mFinv_num, "orig_pric"));
            }
         }
      }
   }   
 }
/*
alert("прибыло в пред.кв."+String(sum_prib));
alert("выбыло в пред.кв."+String(sum_vib));
alert("изменение стоимости в пред.кв."+String(sum_izm));
alert("прибыл износ в пред.кв."+String(prib_izn));
alert("выбыл износ в пред.кв."+String(vib_izn));
alert("изменение износа в пред.кв."+String(izm_izn));
alert("бал.ст."+String(balst));
alert("износ"+String(Iznos))
*/

   //найти сумму амортизации за текущий квартал
   nrm_am = norm_am(datcurkv, curgroup, "");
   kf_am  = koef_am(datcurkv);
/*
закомментарила, т.к., до этого балансовая стоимость уже обнулена, если нужно
и амортизация не насчитается
*/
/*
   if (curgroup==1 && Fis_kompl){
      if (Fis_zkompl){
        //если найдена запись амортизации по комплекту, то нужно найти балансовую
        //стоимость комплекта и проверить, превышает ли она 100 min zp. Если да, 
        // то на ОС насчитывать амортизацию, даже если оно меньше 100 min zp
        if (!ramb.IsEmpty()) balkmpl=ramb("Fbalst")+ramb("Fprib")-ramb("Fvib")-ramb("Famort");
        else balkmpl=0;
        if (balkmpl<=100*min_zp) am = 0;
          else am = round(balst*nrm_am*kf_am,2);
      }else{
        if (balst<=100*min_zp) am = 0;
        else am = round(balst*nrm_am*kf_am,2);
      }
   }
   if (curgroup==1 && !Fis_kompl){
      if (balst<=100*min_zp) am = 0;
      else am = round(balst*nrm_am*kf_am,2);
   }
   if (curgroup!=1){
      am = round(balst*nrm_am*kf_am,2);
   }
*/
   am = round(balst*nrm_am*kf_am,2);
   Iznos = Iznos+am;

//alert("oss_dati за текущий квартал")
   vspi = null;
   oss_dati(mFinv_num, datcurkv, datcurkve);
   sum_vib =0;
   sum_prib=0;
   sum_izm =0;
   prib_price=0;


   vspi = OpenTable("s", "VSPI");
   if (!vspi.IsEmpty())
   {
      if (Number(vspi.getValue("Fprib"))!=0 && (mFdat_post<datNewAm || mFdat_post>datNewAm))
      {
         if (!o7.IsEmpty()) curizn = Number(o7.getValue("Fiznos"));
            else curizn = 0;
         sum_prib = Number(vspi.getValue("Fprib"))-curizn;
         sum_prib = (sum_prib<0)?0:sum_prib;
         if (!o7.IsEmpty()) prib_pric= Number(o7.getValue("Forig_pric"));
            else prib_pric= 0;
      }
      cd1 = sqlTo(datcurkv);
      cd2 = sqlTo(datcurkve);
      cmFdate = sqlTo(mFdate);
      if (Number(vspi.getValue("Fubil"))!=0)
      {
         //этот цикл нужен для нахождения коеффициента, на который нужно уменьшить
         // износ, если в предыдущем квартале была частичная ликвидация ОС 
         //пройтись по всем актам ликвидации за прошлый квартал, у которых дата меньше
         // даты расчета и собрать балансовую стоимость, на которую уменьшается
         // балансовая стоимость ОС и первоначальную стоимость, на которую выбыло ОС
         // затем находится коеффициент уменьшения
         o4= OpenTable("s", "select * from ^OS4 where Finv_num="+String(mFinv_num)+" and Fdoc_dat>="+cd1+" and Fdoc_dat<="+cd2+" and Fdoc_dat<"+cmFdate);
         if (!o4.IsEmpty())
         {
            sdat = new Date(new Date(o4.getValue("Fdoc_dat"))-1);
            sdat = (sdat>mFdat_post)?sdat:mFdat_post;
            sum_vib   = 0;
            while (!o4.IsEof() && Number(o4.getValue("Finv_num"))==mFinv_num)
            {
               doc_dat = new Date(o4.getValue("Fdoc_dat"));
               if (doc_dat>=datcurkv && doc_dat<=datcurkve && doc_dat<mFdate)
               {
                  if (curgroup==1)
                  {
                     sum_vib = sum_vib+Number(o4.getValue("Fsum_bal"));
                  }
                  else
                  {
                     //sum_vib = sum_vib+o4("Fsum_real");
                     //выбытие с амортизацией
                     if (Number(o4.getValue("Fbalstrsch"))!=0 && Number(o4.getValue("Fsum_real"))==0)
                     {
                        sum_vib = sum_vib+Number(o4.getValue("Fbalstrsch"));
                     }
                     else
                     {
                        sum_vib = sum_vib+Number(o4.getValue("Fsum_real"));
                     }
                  }
               }
               o4.MoveNext();
            }
            o4.close()
         }
         else
         {
            //o4=null;
            o4= OpenTable("s", "select * from ^OS4 where Finv_num="+String(mFinv_num)+" and Fdoc_dat>="+sdatprewkv+" and Fdoc_dat<="+cd2+" and Fdoc_dat="+cmFdate);
            if (o4.IsEmpty())
            {
              _alert("Не найден акт ликвидации для № "+String(mFinv_num));            
            }
            else
            {
               sdat = new Date(new Date(o4.getValue("Fdoc_dat"))-1);
               sdat = (sdat> mFdat_post)?sdat:mFdat_post;
            }
            o4.close();
         }
      }

      if (Number(vspi.getValue("Fizm"))!=0 || (Number(vspi.getValue("Fizm"))==0 && Number(vspi.getValue("Fizm_izn"))<0))
      {
         sum_izm = Number(vspi.getValue("Fizm"))-Number(vspi.getValue("Fizm_izn"));
      }

      balst = balst+sum_prib-sum_vib+sum_izm;
   }
   balst = balst-am;

   balst = (balst<0)?0:balst;

/*
alert("прибыло в кв."+String(sum_prib));
alert("выбыло в кв."+String(sum_vib));
alert("изменение стоимости в кв."+String(sum_izm));
alert("бал.ст."+String(balst));
alert("износ"+String(Iznos))
*/

   if (rmode=="BAL") return balst;
   if (rmode=="IZN") return Iznos;
}