/*
	28.10.2003
	SEV Евгений Шатохин
	расчет больничного с разбивкой на 2 части:
		за счет предприятия
		за счет соцстраха
*/

/*
	Расчет больничных и по уходу за больн. по среднему за два предыдущих месяца
	Приказ берется на месяцы
	Расчет с ограничением в 2 тарифных ставки
	Время болезни ставится вручную помесячно
	В расчете не используется справочник коеффициентов для инд. сумм больн.
	Расчет из приказа - аналог r_blnog3
*/

//include("month_txt.js");
include("servis/format.js");
include("Objects/DpDefVed.js")
include("Objects/DpCl.js")
include("servis/date.js");
include("prik/calculate/r_blnall.js")
include("prik/calculate/r_premblot.js")
//include("Objects/dpCalendar.js");

var sPrkTbl = "PRK_ALL";
var tbl_PRK_B;
var fwid_cnt;

function l_ras_boln(strSQL1)
{
	if (!IsTable("BLN_PRT"))
		CreateTable("BLN_PRT", "BLN_PRT", "*");
	else
		ExecuteSQL("DELETE from BLN_PRT");
	if(typeof(Fsredndo)!="undefined")
	{
   		ExecuteSQL("ALTER TABLE BLN_PRT DROP COLUMN Fsredndo");
	}
	ExecuteSQL("ALTER TABLE BLN_PRT ADD Fsredndo "+SqlType("CURRENCY"), false)

	//var strSQL = extPar.strSQL1;
	var tbl_b = OpenTable("s", strSQL1);

	for(tbl_b.MoveFirst(); !tbl_b.IsEOF(); tbl_b.MoveNext() )
	{
		var mFtabn = toScrObj(tbl_b.getValue("FTABN_ID"));
		var mFdat_bol = new Date(tbl_b.getValue("FBDAT"));
		var mFwid = toScrObj(tbl_b.getValue("FWID"));
		var mFcalnum = toScrObj(tbl_b.getValue("FCALNUM"));
		r_bl_pr20(mFtabn, mFdat_bol, mFwid, mFcalnum);
	}
	tbl_b.Close(5652);
}

function r_bl_pr20(mFtabn, mFdat_bol, mFwid, mFcalnum)
{
	var DefVed = new DpDefVed();

	var D1,D2;
	var obj_PRK_B = new Object();

	//установ. даты на начало и конец расчетного месяца
	var data = new Date(mFdat_bol);
	D1 = new Date (data.getYear()+1900,data.getMonth(),1);
	//D1 = D1.getVarDate();
	D2 = new Date (data.getYear()+1900,data.getMonth()+1,0);
	//D2 = D2.getVarDate();

	//SEV 24.10.03 15:54:00
	DropTable("tmp_prk_b");
	strSQL = " SELECT p.*"
			+", B.FBDATP AS FBDATP, B.FEDATP AS FEDATP, B.FBDATS AS FBDATS, B.FEDATS AS FEDATS"
			+", B.FDAY_P AS FDAY_P, B.FCHAS_P AS FCHAS_P, B.FDAY_S AS FDAY_S, B.FCHAS_S AS FCHAS_S"
		+" INTO tmp_prk_b"
		+" FROM ^"+ sPrkTbl +" AS P"
			+" INNER JOIN ^PRK_BLNOBSH AS B ON P.FWID = B.FWID"
		+" WHERE P.FWID = "+ sqlTo(mFwid)
		+" order by p.Fbdat, p.Fedat"
	ExecuteSQL(strSQL);

	tbl_PRK_B = OpenTable("s","tmp_prk_b");

	if (tbl_PRK_B.IsEmpty())
	{
		return false;
	}

	var tbl_DTPRKB		// = OpenTable("s","DTPRKB","dtprkb");
	var tbl_PRK_FMPL	// = OpenTable("s","PRK_FMPL","fmpl_tn");
	var tbl_WT_LBL_B	// = OpenTable("s","WT_LBL_B","tabdate");
	var tbl_SRED_INI	// = OpenTable("s","SRED_INI","tabsrdate");
	var tbl_TIME_WR2	// = OpenTable("s","TIME_WR2","tabdate");
	var tbl_OPL_PRIZ	// = OpenTable("s","OPL_PRIZ","opl_priz");
	var tbl_SHTAT		// = OpenTable("s","SHTAT","sht_tab");
	var tbl_TIME_OTP	// = OpenTable("s","TIME_OTP","tabdate");

	var month_txt = format("yyyymm", data);
	obj_PRK_B.isTBL = false;
   	var tbl_TAB = getSnap("select FID from ^TBL"+ month_txt, false);
   	if (tbl_TAB!=null && tbl_TAB[0]!=null)
      	obj_PRK_B.isTBL = true;

	var tbl_ini		// = OpenTable("s","TBL_INI","tbl_ini");
	var tbl_BLN_PRT	//= OpenTable("m", "BLN_PRT", "BLN_PRT");

	DefVed.begin("", "Проверка правильности расчета больничных и по уходу за больн. по среднему за два предыдущих месяца");

	tbl_PRK_B.MoveFirst();
	var prk_dyo = 0; //дней болезни всего
	var prk_cho = 0; //часов болезни всего
	var ssumo = 0;   //всего к выдаче
	prewdtb = new Date(tbl_PRK_B.getValue("Fbdat"));
	prewdte = new Date(tbl_PRK_B.getValue("Fedat"));
	while (!tbl_PRK_B.IsEOF())
	{
		/*
		Цикл по сегментам больничного. Сам больничный задается датами fbdat,fedat
		Он дробится на сегменты sfbdat,sfedat, каждый из которых
		полностью попадает в рамки месяца
		*/

		//Начальная установка месяца для расчета больничного
		//Установить сегмент больничного, попадающий в месяц (D1,D2)

		//SEV 25.10.03 17:46:03
		//теперь берем весь период больничного
		sfbdat = new Date(tbl_PRK_B.getValue("FBDAT"));
		sfedat = new Date(tbl_PRK_B.getValue("FEDAT"));

		obj_PRK_B.rmode = "OG3";
		obj_PRK_B.Ftabn = toScrObj(tbl_PRK_B.getValue("Ftabn_id"));
		obj_PRK_B.Ftabn_id = toScrObj(tbl_PRK_B.getValue("Ftabn_id"));
		//obj_PRK_B.Fsht_id = tbl_PRK_B.getValue("Fsht_id");
		obj_PRK_B.Fwid_wp = toScrObj(tbl_PRK_B.getValue("Fwid_wp"));
		obj_PRK_B.Fdat_bol = toScrObj(tbl_PRK_B.getValue("Fdat_bol"));//начало периода наступления нетрудоспособности
		obj_PRK_B.prkb_vopl = toScrObj(tbl_PRK_B.getValue("Fvopl"));

		// vvs 28.08.2003
		// В поле Fsum лежат дни и часы в формате ДДДЧЧЧ
		// Дни будем брать не из приказа (там их просто нет),
		// а возьмем из календаря за период sfbdat - sfedat

		var par = new Object();
		par.fstDay = obj_PRK_B.Fdat_bol;
		par.bDat = sfbdat;
		par.eDat = sfedat;

		// Весь расчет дней выполняется здесь:
		var bDays = toScrObj(tbl_PRK_B.getValue("FISDAY"));
		mDaysPidp = Number(tbl_PRK_B.getValue("FDAY_P"));
		mDaysSs = Number(tbl_PRK_B.getValue("FDAY_S"));
		mDaysTot = mDaysPidp + mDaysSs;

		mFtotHoursPr = Number(tbl_PRK_B.getValue("FCHAS_P"));
		mFtotHoursSs = Number(tbl_PRK_B.getValue("FCHAS_S"));
		mFtotHours = mFtotHoursSs + mFtotHoursPr;

		mEdatPidp = javaDate2Script(tbl_PRK_B.getValue("FEDATP"));
		mBdatSs = javaDate2Script(tbl_PRK_B.getValue("FBDATS"));

		// В поле Fsum лежат дни и часы в формате ДДДЧЧЧ
		obj_PRK_B.Fsum = mDaysTot*1000;
		obj_PRK_B.Fproc = Number(tbl_PRK_B.getValue("Fproc"));
		obj_PRK_B.Fnom_prik = toScrObj(tbl_PRK_B.getValue("Fnom_prik"));
		obj_PRK_B.Fdat_prik = javaDate2Script(tbl_PRK_B.getValue("Fdat_prik"));
		obj_PRK_B.Fcalnum = toScrObj(tbl_PRK_B.getValue("Fcalnum"));
		obj_PRK_B.prk_dy = mDaysTot;

		//31.10.07
		obj_PRK_B.Fbdat = javaDate2Script(tbl_PRK_B.getValue("Fbdat"));

		obj_PRK_B.prk_ch = 0;
		if (!toScrObj(tbl_PRK_B.getValue("FISDAY")))
		{
			obj_PRK_B.prk_ch = mFtotHours;
		}
		obj_PRK_B.TM_IN_DY = (obj_PRK_B.prk_ch==0);

		//может быть ситуация, когда и дни и часы нулевые, в этом случае нельзя определить в днях или в часах больничный
     	if(obj_PRK_B.prk_dy+obj_PRK_B.prk_ch==0 && tbl_PRK_B.rowCount>1)
     	{
     		tbl_PRK_B.MoveNext();
     		continue;
     	}

        //27.01.07
        var oCl = new DpCl("");
        oCl.setClcl(getPar("CODPERS"));
        //oCl.setCod(obj_PRK_B.Ftabn);
        oCl.setFWID(obj_PRK_B.Ftabn_id);
        //*********
        //добавлен также пра-р в r_blnall

		if (obj_PRK_B.isTBL)
		{
			Ok = r_blnall("OSN", mFdat_bol, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT, tbl_TIME_OTP, tbl_ini, tbl_TAB, oCl);
		}
		else
		{
			Ok = r_blnall("OSN", mFdat_bol, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT, tbl_TIME_OTP, tbl_ini, null, oCl);
		}
		if (Ok)
		{
			//strSQL = "select * from ^BLN_PRT where Ftabn="+sqlTo(mFtabn)
			//var xtbl = OpenTable("s", strSQL);
			//SEV 27.10.03 12:40:14
			var m = new Object();
			m.Ftabn_id = obj_PRK_B.Ftabn;
			m.Foklad = obj_PRK_B.Foklad;
			m.Fstmonth1 = obj_PRK_B.Fstmonth1;
			m.Fstmonth2 = obj_PRK_B.Fstmonth2;
			m.Fstmonth3 = obj_PRK_B.Fstmonth3;
			m.Fstmonth4 = obj_PRK_B.Fstmonth4;
			m.Fstmonth5 = obj_PRK_B.Fstmonth5;
			m.Fstmonth6 = obj_PRK_B.Fstmonth6;
			m.Fdn1 = obj_PRK_B.Fdn1;
			m.Fdn2 = obj_PRK_B.Fdn2;
			m.Fdn3 = obj_PRK_B.Fdn3;
			m.Fdn4 = obj_PRK_B.Fdn4;
			m.Fdn5 = obj_PRK_B.Fdn5;
			m.Fdn6 = obj_PRK_B.Fdn6;
			m.Fsumfakt1 = obj_PRK_B.Fsumfakt1;
			m.Fsumfakt2 = obj_PRK_B.Fsumfakt2;
			m.Fsumfakt3 = obj_PRK_B.Fsumfakt3;
			m.Fsumfakt4 = obj_PRK_B.Fsumfakt4;
			m.Fsumfakt5 = obj_PRK_B.Fsumfakt5;
			m.Fsumfakt6 = obj_PRK_B.Fsumfakt6;
			m.Fsredn = obj_PRK_B.Fsredn;
			m.Fsredn2 = obj_PRK_B.Fsredn2;
			m.Fsredndo = obj_PRK_B.Fsredndo;
			var fbdat = new Date(tbl_PRK_B.getValue("Fbdat"));
			var fedat = new Date(tbl_PRK_B.getValue("Fedat"));
			m.Fdat_bolb = differ(fbdat,prewdtb)>0? prewdtb : fbdat;
			m.Fdat_bole = differ(fedat,prewdte)>0? fedat : prewdte;
			m.Fproc = obj_PRK_B.Fproc;
			var sumdn = (obj_PRK_B.Fsredn>obj_PRK_B.Fsredn2)? obj_PRK_B.Fsredn2 : obj_PRK_B.Fsredn
			m.Fsumdn = Number(sumdn) * Number(m.Fproc)/100;
			prk_dyo = prk_dyo+obj_PRK_B.prk_dy;
			prk_cho = prk_cho+obj_PRK_B.prk_ch;
			ssumo   = ssumo+obj_PRK_B.ssum;
			m.Fdnbol = (obj_PRK_B.TM_IN_DY)?prk_dyo:prk_cho;
			m.Fsumkvid = ssumo;

			//++SEV 24.10.03 17:38:49
			//Добавим кол-во дней за счет предпр. и соцстраха
			//Добавим дату конца за счет предприятия и дату начала соцстраха
			m.FDAYSPIDP = (obj_PRK_B.TM_IN_DY) ? mDaysPidp : mFtotHoursPr;
			m.FDAYSSS = (obj_PRK_B.TM_IN_DY) ? mDaysSs : mFtotHoursSs;
			m.FEDATPIDP = mEdatPidp;
			m.FBDATSS = mBdatSs;
			//--SEV 24.10.03 17:38:49
			m.FMES_VIP = new Date(tbl_PRK_B.getValue("FMES_VIP"));
			UpdateTable("BLN_PRT", m, true);
		}
		tbl_PRK_B.MoveNext();
	}//end while
	tbl_PRK_B.Close(5652);

	return true;
}