include("Objects/DpGrid.js");

var sCntTbl = "SC_COUNTERS";
var oOrg;
var oNode;
var dat1 = d00;
var dat2 = d00;
var house = 0;
var street = 0;
	    
function listLoad()
{
	this.printLabel = "COUNTERS";
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	if(getPar("VDKORGCAT")!=null)
		FCAT.value = Number(getPar("VDKORGCAT"));
	setValid(FCAT, orgcatValid);
	orgcatValid();
	if(extPar.org)
		oOrg.setCod(extPar.org);
	//oOrg.AfterUpdate = filter;
		
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	//oNode.linkSmartCtrl(FNODE);
	//oNode.setContAssist();
	//oNode.AfterUpdate = filter;
	if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
	
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	if(extPar.street)
		oStreet.setFWID(extPar.street);
	//oStreet.AfterUpdate = filter;
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	if(extPar.house)
		oHouse.setFWID(extPar.house);
	//oHouse.AfterUpdate = filter;
	
	this.filter = filter;
	setButton(BTNFILTER, this, "filter");
	
	dat1 = firstDay(today);
	dat2 = lastDay(today);
	//FBDAT.value = dat1;
	//FEDAT.value = dat2;
}

function orgcatValid()
{
	if(FCAT.value=="0" && getPar("VDKCODORG"))
		oOrg.setClcl(getPar("VDKCODORG"));
	else
		oOrg.setClcl(getPar("CODPLAT"));
}

function listTitle()
{
	return UR("Лічильники|Счетчики");
}
/*
function listAsk()
{
	var p = new Object();
	if(extPar)
		p = extPar;
	p.dat1 = d00;
	p.dat2 = d00;
	p.title = "Параметри відбору|Параметры отбора";
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	dat1 = p.idat1;
	    dat2 = p.idat2;
	    oStreet.setFWID(p.istreet.getFWID());
	    oHouse.setFWID(p.ihouse.getFWID());
	    oOrg.setCod(p.iplat.getCod());
	    oNode.setCod(p.inode.getCod());
	}    
	return p;
}
*/
function listSrc()
{
	this.qrySet("Fields", "s.*, c.FORG, l.FNODE, l.FSTREET, l.FHOUSE, l.FAPMT, l.FOBJECT"
						+", house.FNOM as FHOUSE_NOM, house.FSTREET_TXT"
						+", clorg.FTXT as FORG_TXT, clorg.FWID as FORG_ID"
				, "From", "^SC_COUNTERS s"
						+" inner join ^LICSC l on l.FID_DOG=s.FID_DOG"
						+" inner join ^CONTRACT c on c.FWID=s.FID_DOG"
						+" inner join ^LISTHOUSE as house on l.FHOUSE=house.FWID_CL"
						+" inner join ^LISTCL as clorg on clorg.FCOD=c.FORG and clorg.FCL="+ getPar("CODPLAT")
				, "Where", (extPar.fid_dog? "s.FID_DOG="+ extPar.fid_dog : "1<>1")
				, "Order", "l.FID_DOG, s.FBDAT, s.FEDAT"
				);
	//this.clTie("org", "="+ getPar("CODPLAT") +", FORG");
	this.clTie("obj", "="+ getPar('CODORGOBJECT') +", FOBJECT", "obj");
	this.clTie("node", "="+ getPar("CODNODE") +", FNODE");
	//this.subTie("CL", "str", "FWID", "FSTREET");
	//this.subTie("CL_HOUSE", "house", "FWID_CL", "FHOUSE");
	this.subTie("CL_APARTMENT", "apt", "FWID_CL", "FAPMT");
}

function currWhere()
{
	//dat1 = FBDAT.value;
	//dat2 = FEDAT.value;
	//var sWhere = "(s.FBDAT<="+ sqlTo(dat2) +" and s.FEDAT>="+ sqlTo(dat1) +")";
	var sWhere = "1=1";
	//if(oNode.getCod())
	//	sWhere += " and l.FNODE="+ oNode.getCod();
	if(oStreet.getCod())
		sWhere += " and l.FSTREET="+ oStreet.getFWID();
	if(oHouse.getFWID())
		sWhere += " and l.FHOUSE="+ oHouse.getFWID();
	if(oOrg.getCod())
		sWhere += " and c.FORG="+ oOrg.getCod();
	if(FCAT.value && Number(FCAT.value)!=2)
		sWhere += " and c.FORG in (select FCOD from ^LISTCLORG where FCAT="+ FCAT.value +")";
		
	var cntType = Number(FTYPE.value);
	if(cntType)
		sWhere += " and s.FTYPE="+ cntType;
	var sSerial = String(FSERIAL.value).trim();
	if(sSerial!="")
		sWhere += " and s.FSERIAL="+ sqlTo(sSerial);
	if(FDISABLE.checked)
		sWhere += " and s.FISBREAK="+ sqlTrue;
	if(FISCHECK.checked)
		sWhere += " and s.FISCHECK="+ sqlTrue;
	if(FUNREG.checked)
		sWhere += " and not exists (select c.FCURRENT from ^COUNTERS c"
					+" where c.FCOUNTER=s.FWID"
					+" and c.FDATE>="+ sqlTo(dat1) +" and c.FDATE<="+ sqlTo(dat2) 
					+")";
	return sWhere;
}

function listDpGrid()
{
	grid.build();
}

function filter()
{
	if(Number(FTYPE.value)==2)
	{
		this.qrySet("Fields", "s.*, l.FSTREET, l.FWID_CL"
							+", l.FNOM as FHOUSE_NOM, l.FSTREET_TXT"
					, "From", "^SC_COUNTERS s"
							+" inner join ^LISTHOUSE as l on s.FWID_CL=l.FWID_CL"
					, "Where", "1<>1"
					, "Order", "l.FSTREET, l.FNOM, s.FBDAT, s.FEDAT"
					);
		list.qryWhere = currWhere();
		list.qryOrder = "l.FSTREET, l.FNOM, s.FBDAT, s.FEDAT";
	}
	else
	{
		list.qryWhere = currWhere();
	}
	list.tblInit();
}

function isDisable(d1, d2)
{
	var date = today;
	if(differ(d1, date)>0 || differ(d2, date)<0)
		return true;
	return false;
}

function listMenuInit(oGrid)
{
	if(oGrid.getTable().isEmpty())
		return;
	/*if(IsDblClick())
	{
		listMenuRun("EDIT", oGrid);
		return DpList_exit;
	}*/
	oGrid.AddMenuItem("REGISTRATION", "Показники|Показания");
	//oGrid.AddMenuItem("CALCMIDDLE", "Розрахувати середньодобові витрати|Расчитать среднесуточный расход");
	oGrid.AddMenuItem("", "");
	oGrid.AddMenuItem("LICSC", "Особовий рахунок|Лицевой счет");
	oGrid.AddMenuItem("EDIT", "Редагування|Редактирование");
}

function listMenuRun(sID, oGrid)
{	
	//if(!oGrid || !oGrid.getTable())
	//	return DpList_exit;
	var tbl = list.tbl;
	var dogID = tbl.getValue("FID_DOG");
	var rowID = tbl.getValue("FWID");
	switch(sID)
	{
		case "CALCMIDDLE":
			calcMiddle();
			tbl.requery();
			grid.refresh();
			break;
			
		case "REGISTRATION":
			var par = new Object();
			par.node = tbl.getValue("FNODE");
			par.street = tbl.getValue("FSTREET");
			par.house = tbl.getValue("FHOUSE");
			par.fid_dog = tbl.getValue("FID_DOG");
			par.org = tbl.getValue("FORG");
			par.counter = tbl.getValue("FWID");
			showWindow("l_counters.xml", SW_NOMODAL, par);
			break;
		
		case "EDIT":
		case "VIEW":
			var oDoc = new DpDoc("LICSC", 1);
			if(oDoc.loadByID(dogID))
			{
				var bRet = false;
				var oRow = oDoc.getRow("CNT", rowID);
				if(oRow)
					bRet = oRow.edit(sID);
				if(bRet)
				{
					oDoc.save(true, sID);
					var nRow = grid.getRowSelected();
					tbl.requery();
					grid.setRowSelected(nRow);
					grid.refresh();
				}
			}
			break;
		
		case "LICSC":
			var oDoc = new DpDoc("LICSC", 1);
			if(oDoc.loadByID(dogID))
				oDoc.edit(sID, dogID);
			break;
		
		default:
			return;
	}
	return DpList_exit;
}

function listDelAcc()
{
	return false;
}

function currentVol(counter)
{
	var oSnap = getSnap("select FCURRENT from ^COUNTERS"
						+" where FCOUNTER="+ counter 
							+" and FDATE between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
							+" order by FDATE DESC"
						, false
						);
	if(oSnap)
		return oSnap[0];
	return 0;
}

function calcMiddle()
{
	var date = today;
	var dat1 = firstDay(gomonth(date, -3));
	var dat2 = lastDay(gomonth(date, -1));
	
	var par = new Object();
	par.bdat = dat1;
	par.edat = dat2;
	par.title = UR("Період розрахунку|Период расчета");
	showWindow("e_period.xml", SW_MODAL, par);
	if(par.escape)
		return;
	dat1 = par.bdat;
	dat2 = par.edat;
	var days = day_difference(dat1, dat2);
	WAIT(UR("Розрахунок середніх...|Расчет средних..."));
	var tbl = list.tbl;
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var cntID = tbl.getValue("FWID");
		var bdat = tbl.getValue("FBDAT");
		var d1 = dat1;
		var d2 = dat2;
		if(differ(bdat, d1)==1)
			d1 = bdat;
		days = day_difference(d1, d2);
		if(days<10)
			continue;
		var oSnap = getSnap("select sum(FDIFFERENCE)"
						+" from ^COUNTERS"
						+" where FCOUNTER="+ cntID
							+" and FDATE>="+ sqlTo(dat1)
							+" and FDATE<="+ sqlTo(dat2)
						);
		if(!oSnap || Number(oSnap[0])==0)
			continue;
		var sumDif = Number(oSnap[0]);
		var middle = round(sumDif/days, 4);
		ExecuteSQL("update ^SC_COUNTERS set FMIDDLE="+ middle +" where FWID="+ cntID);
	}
	CLEARWAIT();
}

include("sys/DpList.js");