//расчет дневника для почты

include("Objects/DpGetDat.js");
include("sys/servis.js");

var rsi;
var rs;
var rsr;
var NOMD;
var prnPatt = "DNMON";

function listLoad()
{
	NOMD = extPar.oDoc.getPar("_nomdn");

	if (extPar.mode=="CALC")
	{
		return r_dnmon();
	}

	if (!IsTable("DN_HD") || !IsTable("DN130_C") || !IsTable("DN130_R") || !IsTable("DN130_S"))
	{
		alert(ru("Сначала произведите расчет!","Спочатку проведіть розрахунок!"));
		return false;
	}
}

function listTitle()
{	
	var sTitle = UR("Наявність і рух грошових коштів у касі|Наличие и движение денежных средств в кассе");
	var cap_tbl = getSnap("select fbdat,fedat from ^DN_HD");
	if(cap_tbl)
	{	
		dat1 = cap_tbl[0];
		dat2 = cap_tbl[1];
		sTitle += " за "+ StrDat(dat1,"DMY") +" - "+ StrDat(dat2,"DMY");
	}
	return sTitle;
}

function listSrc()
{	
	this.qrySet("Cross", "DN130", "Order", "FSTAT");
}

function listDpGrid()
{	
	include("Objects/DpGrid.js");
	
	var ColCaptU;
	var ColCaptR;
	var ColId;
	
	rsi = OpenTable( "c", "DN130");
	rs = rsi.GetCol();
	rsr= rsi.GetRow();
	
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	var fstat = "=^FSTAT=="+ cl_sup +"? '"+ ru("Итог","Підсумок") +"'"
				+" : tcl('CL', 'TXT', "+ NOMD +", ^FSTAT)"; 
	gr.FieldEx(fstat, "Найменування статей|Наименование статей", 25);
	
	rs.MoveFirst();	
	while (!rs.IsEOF())
	{
		ColCaptU = rs.getValue("Fsect")==3 ? "Прибуток\n"+ StrDat(rs.getValue("Fdate"), "DMY") 
				 : rs.getValue("Fsect")==5 ? "Видаток\n"+ StrDat(rs.getValue("Fdate"), "DMY") 
				 : (rs.getValue("Fsect")==4 || rs.getValue("Fsect")==6)? "Всього\nза період" 
				 : "";
		ColCaptR = rs.getValue("Fsect")==3 ? "Приход\n"+ StrDat(rs.getValue("Fdate"), "DMY") 
				 : rs.getValue("Fsect")==5 ? "Расход\n"+ StrDat(rs.getValue("Fdate"), "DMY") 
				 : (rs.getValue("Fsect")==4 || rs.getValue("Fsect")==6)? "Итого\nза период" 
				 : "";
		ColId = rs.getValue("fColID");
		gr.FieldEx(ColId, ColCaptU +"|"+ ColCaptR, 14);
       	rs.MoveNext();
	}
	
	oGrid.build();
}

function r_dnmon()
{	
	var gd = new DpGetDat("dD");
	if (gd.escape)
	{
		return false;
	}
	var dat1 = gd.dat1;
	var dat2 = gd.dat2;

	var hdn_tbl = getSnap("select FWID from ^HDN where FWID="+ extPar.fwid);
	if (!hdn_tbl)
	{
		alert(ru("Запись не найдена!", "Запис не знайдено!"));
		return false;
	}
	
	var nPr = 1;
	var sPr = ru("Расчет итогов по месяцам", "Розрахунок підсумків по місяцях");
	setProgressRange(0, 20);
	setProgressPos(nPr++, sPr);
	
	DropTable("DN130");
	DropTable("RDN_TM");
	DropTable("D130TMP");
	DropTable("D2130");
	DropTable("DR130TMP");
	DropTable("DR2130");
	DropTable("TTT");
	
	setProgressPos(nPr++, sPr);	
	strSQL = "create table RDN_TM "
			+"(Fsum "+ SqlType("CURRENCY") 
			+",Fstat "+ SqlType("INT") 
			+",Fval "+ SqlType("INT") 
			+",Fprix "+ SqlType("BYTE") 
			+",Fdate "+ SqlType("DATE") 
			+",Fid_doc "+ SqlType("INT") 
			+")";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);	
	strSQL = "insert into RDN_TM (Fsum,Fstat,Fval,Fprix,Fdate,Fid_doc)"
			+" SELECT r.Fsum,r.Fstat,r.Fval,r.Fprix"
				+",h.Fdoc_dat as Fdate, r.Fid_doc"
			+" FROM ^RDN as r "
				+" left join ^HDN as h on h.FWID=r.FID_DOC"
			+" WHERE r.FNOP=0 OR r.FNOP="+ extPar.Nop;
	ExecuteSQL(strSQL);
		
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT sum(RDN_TM.Fsum) AS Fsum,Fstat,Fdate,'3' AS Fsect"
			+" INTO D130TMP FROM RDN_TM "
			+" WHERE FPRIX="+ SqlTrue 
				+" AND FDATE BETWEEN "+ sqlTo(dat1) +" AND "+ sqlTo(dat2)
			+" GROUP BY FSTAT, FDATE";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL="SELECT * INTO DN130 FROM D130TMP ";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(D130TMP.Fsum) AS Fsum,Fstat,"+ sqlTo(d00) +" AS Fdate,'4' AS Fsect"
			+" INTO D2130 FROM D130TMP "
			+" GROUP BY FSTAT";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DN130(Fsum,Fstat,Fdate,Fsect) SELECT Fsum,Fstat,Fdate,Fsect FROM D2130";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(RDN_TM.Fsum) AS Fsum,Fstat,Fdate,'5' AS Fsect"
			+" INTO DR130TMP FROM RDN_TM "
			+" WHERE FPRIX="+ SqlFalse 
				+" AND FDATE BETWEEN "+ sqlTo(dat1) +" AND "+ sqlTo(dat2)
			+" GROUP BY FSTAT,FDATE";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DN130(Fsum,Fstat,Fdate,Fsect) SELECT Fsum,Fstat,Fdate,Fsect FROM DR130TMP";
	ExecuteSQL(strSQL);

	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(DR130TMP.Fsum) AS Fsum,Fstat,"+ sqlTo(d00) +" AS Fdate,'6' AS Fsect"
			+" INTO DR2130 FROM DR130TMP "
			+" GROUP BY FSTAT";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DN130(Fsum,Fstat,Fdate,Fsect) SELECT Fsum,Fstat,Fdate,Fsect FROM DR2130";
	ExecuteSQL(strSQL);

	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(DN130.Fsum) AS Fsum,"+ sqlTo(cl_sup) +" AS Fstat,Fdate,Fsect"
			+" INTO TTT FROM DN130 "
			+" GROUP BY FSECT,FDATE";
	ExecuteSQL(strSQL);

	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DN130(Fsum,Fstat,Fdate,Fsect) SELECT Fsum,Fstat,Fdate,Fsect FROM TTT";
	ExecuteSQL(strSQL);

	setProgressPos(nPr++, sPr);
	//Создаем шахматные таблицы
	DropTable("DN130_S");
	DropTable("DN130_R");
	DropTable("DN130_C");

	// Выражения, идентифицирующие строку и столбец по основной таблице
	var RowIdExpr, ColIdExpr;
	ColIdExpr = SqlConCat(Convert("FSECT", "STR"), "'@'", Convert("FDATE", "STR"));
	RowIdExpr = Convert("FSTAT", "STR");

	setProgressPos(nPr++, sPr);
	ExecuteSQL("SELECT DISTINCT "
				+" Fsum as Fvalue, "
				+ ColIdExpr + " as FColId, "
				+ RowIdExpr + " as fRowId "
			+" INTO DN130_S "
			+" FROM DN130");
			  
	setProgressPos(nPr++, sPr);
	ExecuteSQL("SELECT DISTINCT "+ RowIdExpr +" as fRowId, Fstat "
	        +" INTO DN130_R FROM DN130 ");
	        
	setProgressPos(nPr++, sPr);
	ExecuteSQL( "SELECT DISTINCT "+ ColIdExpr +" as fColID, Fsect, Fdate "
	        +" INTO DN130_C FROM DN130 ");
	        	
	setProgressPos(nPr++, sPr);
	if (SUBD==ORACLE || SUBD==DERBY)
		ExecuteSQL("DROP INDEX RowCol", false);
	ExecuteSQL("CREATE INDEX RowCol ON DN130_S (FrowId, FcolId)");
	//Шахматные таблицы созданы
	
	setProgressPos(nPr++, sPr);
	//Сохраняем даты в таблице
	DropTable("DN_HD");
	ExecuteSQL("CREATE TABLE DN_HD "
        	+" (fbdat "+ SqlType("DATE")
        	+", fedat "+ SqlType("DATE")
        	+", fnomdn "+ SqlType("INTEGER") +")");
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DN_HD (Fbdat,Fedat,Fnomdn)"
			+" VALUES ("+ sqlTo(dat1) +","+ sqlTo(dat2) +","+ sqlTo(NOMD) +")";
	ExecuteSQL(strSQL);		
	setProgressPos(0);
		
	return true;
}

function unLoad()
{
  	rsi.close();
}

function listMenuInit(ds)
{
    if (!rsi.IsEmpty())
    	ds.AddMenuItem("PRINT", "Друк списку|Печать списка");
}

function listMenuRun(nID)
{
	if (nID=="PRINT")
	{
	    include("Objects/DpTVars.js");
		var tv = new DpTVars(prnPatt);
		var bm = rsi.bookmark;
		tv.setHTbl(cap_tbl);
		tv.setRTbl(rsi);
		tv.print();
		rsi.bookmark = bm;
	}
}

include("sys/DpList.js");