
var tblOut = getTmpTableName();	//таблица с результатами
var tblPriv = "PRIVILEGE";		//льготы
var label = "KU_COMP";
var streetID = 0;
var houseID = 0;
var exemptID = 0;
var exemptType = "";
var rdat1;
var rdat2;
var sumDec = Number(getPar("DECISUM"));

function listLoad()
{
	this.xmlGridFile = "r_exempt.xml";
	this.printLabel = label;
	this.accDel = null;
}

function listSrc()
{	
	this.qrySet("From", tblOut, "Order", "FCOD_EXT");	//FSTREET, FHOUSE, FPLAT
	//this.subTie("cl_house", "hs", "FWID_CL", "FHOUSE");
	//this.subTie("cl_apartment", "apt", "FWID_CL", "FAPMT");
	//this.subTie("cl_exempt", "ex", "FWID_CL", "FID_EXT");
	//this.subTie("CL", "ex", "FWID", "FID_EXT");
	//this.subTie("CLRELCLCL", "rex", "FWID_CL", "FID_EXT");
	this.clTie("ex", "="+ getPar("CODLGT") +", FCOD_EXT");
	//this.subTie("cl", "str", "FWID", "FSTREET");
}

function listAsk()
{
	var p = new Object();
	p.tblName = tblOut;
	p.label = label;
	showWindow("i_exempt.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    exemptID = p.iexempt.getFWID();
	    exemptType = p.iexempt_type;
    } 
	return p;
}

function listTitle()
{
	var sCapt = ru("Расчет возмещения затрат", "Розрахунок відшкодування витрат");
	
	var dat = list.objAsk.rdate;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	
	if(dat!=null)
		sCapt += " за "+ getSDat(dat);
	if(oStreet!=null && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse!=null)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	
	return sCapt;
}

function listMake()
{
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
	
	var d1 = sqlTo(rdat1);
	var d2 = sqlTo(rdat2);
	var sumDec = Number(getPar("DECISUM"));
	
	var sWhere = " l.FBDAT<="+ d2 +" and l.FEDAT>="+ d1;
	if(houseID)			//отбор по дому
		sWhere += " and l.FHOUSE="+ houseID;
	else if(streetID)	//отбор по улице
		sWhere += " and l.FSTREET="+ streetID;	
	if(exemptID)		//отбор по льготе
		sWhere += " and priv.FID_LG="+ exemptID;
	else if(exemptType)	//отбор по типу льгот
		sWhere += " and UPPER(e.FATTR)="+ sqlTo(exemptType);
	
	var sTmpMen = "MEN_"+ getTmpTableName(); 	//льготники
	var sSQL = "create table "+ sTmpMen 
			+" (FWID "+ SqlType("LONG") 
			+", FIDENTCOD "+ SqlType("TEXT")
			+", FDOCKAT "+ SqlType("TEXT")
			+", FID_PRIV "+ SqlType("LONG")
			+", FID_LG "+ SqlType("LONG")  
			+", FMAIN "+ SqlType("BIT") 
			+", FBDAT "+ SqlType("DATE")
			+", FEDAT "+ SqlType("DATE")
			+")"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ sTmpMen 
				+"(FWID, FIDENTCOD, FDOCKAT, FID_PRIV, FID_LG, FMAIN, FBDAT, FEDAT)"
			+" select men.FWID, men.FIDENTCOD, r.FCOD, priv.FWID, priv.FID_LG"
				+", pm.FMAIN, priv.FBDAT, priv.FEDAT"
			+" from ^SC_MEN men"
				+" inner join ^SC_PRIVMEN pm on pm.FID_MEN=men.FWID"
				+" inner join ^SC_PRIV priv on priv.FWID=pm.FID_PRIV"
				+" inner join ^CL_EXEMPT e on e.FWID_CL=priv.FID_LG"
				+" inner join ^CLRELCLCL r on r.FWID_CL=priv.FID_LG"
				+" inner join ^LISTLICSC l on l.FID_DOG=men.FID_DOG"
			+" where priv.FBDAT<="+ d2
				+" and priv.FEDAT>="+ d1
				+" and men.FBDAT<="+ d2
				+" and men.FEDAT>="+ d1
				+" and "+ sWhere
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	var sTmpPriv = "PRIV_"+ getTmpTableName();	//льготы
	CreateTable(sTmpPriv, tblPriv, "*");
	ExecuteSQL("alter table "+ sTmpPriv +" add column FDOG_NUM "+ sqlType("TEXT", 50));
	ExecuteSQL("alter table "+ sTmpPriv +" add column FSTREET_TXT "+ sqlType("TEXT", 255));
	ExecuteSQL("alter table "+ sTmpPriv +" add column FHSNOM "+ sqlType("TEXT", 50));
	ExecuteSQL("alter table "+ sTmpPriv +" add column FAPMTNOM "+ sqlType("TEXT", 50));
	ExecuteSQL("alter table "+ sTmpPriv +" add column FPLAT_TXT "+ sqlType("TEXT", 255));
	ExecuteSQL("alter table "+ sTmpPriv +" add column FCOD_EXT "+ sqlType("LONG"));
	setProgressPos(nPr++, sPrText);
	
	var fld = GetPatternIntersection(tblPriv, tblPriv);
	var sSQL = "insert into "+ sTmpPriv 
					+"(FDOG_NUM,FSTREET_TXT,FHSNOM,FAPMTNOM,FPLAT_TXT,FCOD_EXT,"+ fld +")"
				+" select l.FDOG_NUM,l.FSTREET_TXT,l.FHOUSE_NOM,l.FAPT_NOM,l.FORG_TXT,rex.FCOD"
					+","+ GetPatternIntersection(tblPriv, tblPriv, "priv")
				+" from ^"+ tblPriv +" priv "
				+" inner join ^CL_EXEMPT e on e.FWID_CL=priv.FID_LG"
				+" inner join ^CLRELCLCL rex on rex.FWID_CL=priv.FID_LG"
				//+" inner join ^CONTRACT c on c.FWID=priv.FID_DOG"
				//+" inner join ^LICSC l on l.FID_DOG=priv.FID_DOG"
				+" inner join ^LISTLICSC l on l.FID_DOG=priv.FID_DOG"
				+" where priv.FDATE>="+ d1 +" and priv.FDATE<="+ d2
					+" and "+ sWhere
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	var sTmpTbl = getTmpTableName();
	createOutTable(sTmpTbl);
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ sTmpTbl 
					+"(FMEN,FID_PRIV,FFIO,FIDENTCOD,FDOCKAT,FDATE"
					+",FPLAT,FPLAT_TXT,FID_DOG,FDOG_NUM"
					+",FSTREET,FSTREET_TXT,FHOUSE,FHSNOM,FAPMT,FAPMTNOM"
					+",FAREA,FHEATAREA,FBDAT,FEDAT,FID_EXT,FCOD_EXT,FPERC,FSUM"
					+",FFLAG,FEXMPTKOL,FFAMPART,FRENTTARIF,FAREAEXT"
					+",FRENT,FHEATTARIF,FHEAT,FHEATKOL,FCOOLTARIF,FCOOL,FHOTTARIF,FHOT"
					+",FWREMOVTARIF,FWREMOV,FGASTARIF,FGAS,FELECTRICTARIF,FELECTRIC"
					+",FTRASHTARIF,FTRASH,FOTHERTARIF,FOTHER)"
				+" select FMEN,FID_PRIV, max(FFIO), max(FIDENTCOD), max(FDOCKAT),max(FDATE)"
					+", max(FORG), max(FPLAT_TXT), FID_DOG, max(FDOG_NUM)"
					+", max(FSTREET), max(FSTREET_TXT), max(FHOUSE), max(FHSNOM), max(FAPMT)"
					+", max(FAPMTNOM), max(FAREA), max(FHEATAREA)"
					+", max("+ IIF("FBDAT>=FDATE1", "FBDAT", "FDATE1") +") as FBDAT"
					+", max("+ IIF("FEDAT<=FDATE2", "FEDAT", "FDATE2") +") as FEDAT"
					+", FID_LG, max(FCOD_EXT), max(FPERC), sum(FSUM), FFLAG"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_PRIV="+ sTmpPriv +".FID_PRIV) as FEXMPTKOL"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_PRIV="+ sTmpPriv +".FID_PRIV and men.FWID<>"+ sTmpPriv +".FMEN) as FFAMPART"
					+", max("+ IIF("FSERV='RENT'", "FTARIFF", "0") +") as FRENTTARIF"
					+", sum("+ IIF("FSERV='RENT'", "FFACT", "0") +") as FAREAEXT"
					+", "+ sqlRound("sum("+ IIF("FSERV='RENT'", "FSUM", "0") +")", sumDec) +" as FRENT"
					+", "+ sqlRound("sum("+ IIF("FSERV='HEAT' or FSERVCODE=505", "FTARIFF", "0") +")", sumDec) +" as FHEATTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='HEAT' or FSERVCODE=505", "FSUM", "0") +")", sumDec) +" as FHEAT"
					+", "+ sqlRound("sum("+ IIF("FSERV='HEAT' or FSERVCODE=505", "FFACT", "0") +")", sumDec) +" as FHEATKOL"
					+", "+ sqlRound("sum("+ IIF("FSERV='CWATER'", "FTARIFF", "0") +")", sumDec) +" as FCOOLTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='CWATER'", "FSUM", "0") +")", sumDec) +" as FCOOL"
					+", "+ sqlRound("sum("+ IIF("FSERV='HWATER'", "FTARIFF", "0") +")", sumDec) +" as FHOTTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='HWATER'", "FSUM", "0") +")", sumDec) +" as FHOT"
					+", "+ sqlRound("sum("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FTARIFF", "0") +")", sumDec) +" as FWREMOVTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FSUM", "0") +")", sumDec) +" as FWREMOV"
					+", "+ sqlRound("sum("+ IIF("FSERV='GAS'", "FTARIFF", "0") +")", sumDec) +" as FGASTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='GAS'", "FSUM", "0") +")", sumDec) +" as FGAS"
					+", "+ sqlRound("sum("+ IIF("FSERV='ELECTRIC'", "FTARIFF", "0") +")", sumDec) +" as FELECTRICTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='ELECTRIC'", "FSUM", "0") +")", sumDec) +" as FELECTRIC"
					+", "+ sqlRound("sum("+ IIF("FSERV='TRASH'", "FTARIFF", "0") +")", sumDec) +" as FTRASHTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='TRASH'", "FSUM", "0") +")", sumDec) +" as FTRASH"
					+", "+ sqlRound("sum("+ IIF("FSERV='OTHER'", "FTARIFF", "0") +")", sumDec) +" as FOTHERTARIF"
					+", "+ sqlRound("sum("+ IIF("FSERV='OTHER'", "FSUM", "0") +")", sumDec) +" as FOTHER"
				+" from "+ sTmpPriv
				+" group by FMEN, FID_PRIV, FID_LG, FID_DOG, FFLAG"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();	
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ tblOut 
					+" (FMEN,FID_PRIV,FFIO,FIDENTCOD,FDOCKAT,FDATE"
					+",FPLAT,FPLAT_TXT,FID_DOG,FDOG_NUM,FBDAT,FEDAT"
					+",FSTREET,FSTREET_TXT,FHOUSE,FHSNOM,FAPMT,FAPMTNOM,FFLAG"
					+",FAREA,FHEATAREA,FID_EXT,FCOD_EXT,FPERC,FEXMPTKOL,FFAMPART"
					+",FRENTTARIF,FAREAEXT,FRENT,FHEATTARIF,FCOOLTARIF,FHOTTARIF"
					+",FWREMOVTARIF,FGASTARIF,FELECTRICTARIF,FTRASHTARIF,FOTHERTARIF"
					+",FHEATKOL,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM)"
				+" select FMEN,FID_PRIV,FFIO,FIDENTCOD,FDOCKAT,FDATE"
					+",FPLAT,FPLAT_TXT,FID_DOG,FDOG_NUM"
					+","+ IIF("FBDAT>="+ d1, "FBDAT", d1) +" as FBDAT"
					+","+ IIF("FEDAT<="+ d2, "FEDAT", d2) +" as FEDAT"
					+",FSTREET,FSTREET_TXT,FHOUSE,FHSNOM,FAPMT,FAPMTNOM,FFLAG"
					+",FAREA,FHEATAREA,FID_EXT,FCOD_EXT,FPERC,FEXMPTKOL,FFAMPART"
					+",FRENTTARIF,FAREAEXT,FRENT,FHEATTARIF,FCOOLTARIF,FHOTTARIF"
					+",FWREMOVTARIF,FGASTARIF,FELECTRICTARIF,FTRASHTARIF,FOTHERTARIF"
					+",FHEATKOL,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER"
					+","+ sqlRound("FRENT+FHEAT+FCOOL+FHOT+FWREMOV+FGAS+FELECTRIC+FTRASH+FOTHER", sumDec) +" as FSUM"
				+" from "+ sTmpTbl
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ tblOut 
					+"(FTT,FEXMPTKOL,FFAMPART"
					+",FRENT,FHEATKOL,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM)"
				+" select 'SUM',sum(FEXMPTKOL),sum(FFAMPART)"
					+",sum(FRENT),sum(FHEATKOL),sum(FHEAT),sum(FCOOL),sum(FHOT),sum(FWREMOV)"
					+",sum(FGAS),sum(FELECTRIC),sum(FTRASH),sum(FOTHER)"
					+",sum("+ sqlRound("FRENT+FHEAT+FCOOL+FHOT+FWREMOV+FGAS+FELECTRIC+FTRASH+FOTHER", sumDec) +") as FSUM"
				+" from "+ sTmpTbl
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	/*
	sSQL = "insert into "+ tblOut 
					+"(FTT,FSTREET,FSTREET_TXT,FHOUSE,FHSNOM"
					+",FEXMPTKOL,FFAMPART"
					+",FRENT,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM)"
				+" select 'HS',max(FSTREET),max(FSTREET_TXT),FHOUSE,max(FHSNOM)"
					+",sum(FEXMPTKOL),sum(FFAMPART)"
					+",sum(FRENT),sum(FHEAT),sum(FCOOL),sum(FHOT),sum(FWREMOV)"
					+",sum(FGAS),sum(FELECTRIC),sum(FTRASH),sum(FOTHER)"
					+",sum("+ sqlRound("FRENT+FHEAT+FCOOL+FHOT+FWREMOV+FGAS+FELECTRIC+FTRASH", sumDec) +") as FSUM"
				+" from "+ sTmpTbl
				+" group by FHOUSE"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	*/
	//browse("select * from "+ sTmpPriv)
	//browse("select * from "+ sTmpMen)
	ExecuteSQL("drop table "+ sTmpTbl);
	ExecuteSQL("drop table "+ sTmpPriv);
	ExecuteSQL("drop table "+ sTmpMen);
	
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false);
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FNUM "+ SqlType("INT")		//№ п/п
			+", FWID"+ SqlType("COUNTER")
			+", FCOD_EXT"+ SqlType("LONG")
			+", FID_EXT"+ SqlType("LONG")	//льгота: FWID_CL табл CL_EXEMPT, он же FWID табл CL (справочник clexempt)
			+", FID_DOG"+ SqlType("LONG")	//договор: FID_DOG из табл SC_PRIV, он же FID_DOG табл LICSC, он же FID_DOG табл RAS_SKU, он же FWID табл CONTRACT
			+", FDOG_NUM"+ SqlType("TEXT", 25)
			+", FPLAT "+ SqlType("LONG") 	//плательщик: FORG из табл RAS_SKU, он же FCOD табл CLRELCLCL (справочник аналитики 2-го вида), вытягивается по FID_DOG
			+", FPLAT_TXT "+ SqlType("TEXT")
			+", FAPMT "+ SqlType("LONG")	//квартира: FWID_CL табл CL_APARTMENT, он же FAPMT из табл LICSC. вытягивается по FID_DOG
			+", FHOUSE "+ SqlType("LONG")	//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET "+ SqlType("LONG")	//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FAREA "+ SqlType("DOUBLE")	//жилая площадь: FLIVAREA из табл CL_APARTMENT
			+", FRENTAREA "+ SqlType("DOUBLE")
			+", FHEATAREA "+ SqlType("DOUBLE")
			+", FNORMAREA "+ SqlType("DOUBLE")
			+", FHEATKOL "+ SqlType("DOUBLE")
			+", FID_PRIV"+ SqlType("LONG")
			+", FBDAT"+ SqlType("DATE")
			+", FEDAT"+ SqlType("DATE")
			+", FMEN "+ SqlType("LONG")		//ID жильца
			+", FFIO "+ SqlType("TEXT")		//ФИО
			+", FCERTNUM "+ SqlType("TEXT")	//номер удостоверения: FNOM табл SC_EXEMPTS
			+", FIDENTCOD "+ SqlType("TEXT")//идентификационный номер: FIDENTCOD табл SC_EXEMPTS
			+", FDOCKAT "+ sqlType("TEXT", 15)
			+", FSTREET_TXT "+ SqlType("TEXT")
			+", FHSNOM "+ SqlType("TEXT")	//номер дома: FNOM табл CL_HOUSE
			+", FAPMTNOM "+ SqlType("TEXT")	//номер квартиры: FNOM табл CL_APARTMENT
			+", FPERSKOL "+ SqlType("INT")	//колич. жильцов
			+", FEXMPTKOL "+ SqlType("INT")	//колич. льготников
			+", FFAMPART "+ SqlType("INT")	//в том числе членов семьи
			+", FDATE "+ SqlType("DATE")	//дата
			+", FTT "+ SqlType("TEXT")		//тип итога
			+", FSUM "+ SqlType("CURRENCY")	//общая сумма льгот за мес.
			+", FISNORM "+ SqlType("BIT")
			+", FMAIN "+ SqlType("BIT")
			+", FPERC "+ SqlType("DOUBLE")
			+", FFLAG "+ SqlType("SHORT")
			+", FAREAEXT "+ SqlType("DOUBLE")
			+", FHEATTARIF "+ SqlType("CURRENCY")
			+", FRENTTARIF "+ SqlType("CURRENCY")
			+", FCOOLTARIF "+ SqlType("CURRENCY")
			+", FHOTTARIF "+ SqlType("CURRENCY")
			+", FWREMOVTARIF "+ SqlType("CURRENCY")
			+", FGASTARIF "+ SqlType("CURRENCY")
			+", FELECTRICTARIF "+ SqlType("CURRENCY")
			+", FTRASHTARIF "+ SqlType("CURRENCY")
			+", FOTHERTARIF "+ SqlType("CURRENCY")
			+", FRENT "+ SqlType("CURRENCY")//квартплата FRENTSUM
			+", FHEAT "+ SqlType("CURRENCY")//отопление
			+", FCOOL "+ SqlType("CURRENCY")//хол. вода
			+", FHOT "+ SqlType("CURRENCY")	//гор. вода
			+", FWREMOV "+ SqlType("CURRENCY")//водоотведение
			+", FGAS "+ SqlType("CURRENCY")	//газ (и коню понятно)
			+", FELECTRIC "+ SqlType("CURRENCY")//электроэнергия
			+", FTRASH "+ SqlType("CURRENCY")//вывоз мусора	
			+", FOTHER "+ SqlType("CURRENCY")//другое		
			+")";			
	ExecuteSQL(sSql, false);
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

function getSDat(date)
{	
	if(!date)
	{
		var oSnap = getSnap("select FDATE from "+ tblOut, false);
		if(oSnap!=null)
			date = toScriptDate(oSnap[0]);
	}
	var sMonth = tmonth(date, 3);
	var sYear = new Date(date).getFullYear();
	return sMonth +" "+ sYear;
}

function getAddr()
{
	var sAddr = "";
	var oSnap = getSnap("select r.FSTREET,r.FHOUSE,cl.FTXT "
					+" from "+ tblOut +" r inner join ^CL cl on cl.FWID=r.Fstreet "
					+" where r.Fhouse<>0", false);
	if(oSnap!=null && oSnap[0]!=0)
		sAddr = oSnap[2] +" "+ getHouseNom(oSnap[1]);

	return sAddr;
}

function setNumOrder()
{
	var tOut = OpenTable("m", "select * from "+ tblOut);
	var n = 1;
	for(tOut.MoveFirst(); !tOut.IsEOF(); tOut.MoveNext())
	{
		ExecuteSQL("update "+ tblOut 
					+" set FNUM="+ (n++) 
					+" where FPLAT="+ sqlTo(tOut.getValue("FPLAT"))
					);
	}
}

function listMenuInit()
{
	if(list.tbl.getValue("FID_DOG"))
		grid.AddMenuItem("LICSC", "Особовий рахунок|Лицевой счет");
	grid.AddMenuItem("EXPORT_DBF", "Сформувати DBF-файл (форма 2)|Сформировать DBF-файл (форма 2)");
}

function listMenuRun(sID)
{
	if(sID=="LICSC")
	{
		var fid_dog = list.tbl.getValue("FID_DOG");
		if(!fid_dog)
			return DpList_exit;
		include("doc/DpDoc.js");
		var oDoc = new DpDoc("LICSC", 1);
		oDoc.edit("EDIT", fid_dog);
		return DpList_exit;
	}
	if(sID=="EXPORT_DBF")
	{
		var arrSum = new Array();
		var arrKol = new Array();
		var privSum = 0;
		var privKol = 0;
		
		var sTmpTbl = getTmpTableName();
		ExecuteSQL("select * into "+ sTmpTbl 
					+" from ^"+ tblPriv 
					+" where FID_DOG in (select FID_DOG from "+ tblOut +")"
						+" and FDATE>="+ sqlTo(rdat1)
						+" and FDATE<="+ sqlTo(rdat2)
						+(exemptType!=""? " and UPPER(FATTR)="+ sqlTo(exemptType) : "")
					);
		var tbl = OpenTable("select * from "+ sTmpTbl +" order by FID_DOG, FMEN");
		if(tbl.isEmpty())
		{
			alert(UR("Немає даних для відбору!|Нет данных для отбора!"));
			return false;
		}
		
		var date = list.objAsk.rdate;
		var sFileName = format("yymm", date) +".DBF";
		sFileName = BrowseForFile("*.dbf", "*.dbf", null, "save", sFileName);
		if(!sFileName)
			return;
		var dbfFile = rootDirectoryEx() +"private_modules/hoc/Source/DBF/form2.dbf";
		if(getSystem()=="VDK")
			dbfFile = rootDirectoryEx() +"private_modules/vdk/Source/DBF/form2.dbf";
		copyFile(dbfFile, sFileName);
		var oDBF = lpProxy.getDBManager().getDBFWriter(sFileName);
		if(!oDBF)
		{
			alert(UR("Неможливо створити файл "+ sFileName +"!|Невозможно создать файл "+ sFileName +"!"));
			return;
		}
		oDBF.setCharactersetName("cp866");
		
		var okpo = getPar("OOKPO");
		if(!okpo || String(okpo).trim()=="")
			okpo = tbl.getValue("FOKPO");
		okpo = Number(okpo);
		for(; !tbl.IsEOF(); tbl.MoveNext())
		{
			var menID = tbl.getValue("FMEN");
			var dogID = tbl.getValue("FID_DOG");
			var extID = tbl.getValue("FID_LG");
			var aptID = tbl.getValue("FAPMT");
			var sAddr = taddr(tbl.getValue("FAPMT"));
			
			var serv = String(tbl.getValue("FSERV")).trim();
			var sum = Number(tbl.getValue("FSUM"));
			if(!arrKol[serv])
				arrKol[serv] = 0;
			arrKol[serv] = arrKol[serv]+1;
			privKol++;
			var factor = tserv(dogID, serv, "FFACTOR");
			if(serv=="OTHER" && String(factor).trim()=="AREA")
				serv = "HEAT";
			if(serv=="CDRAIN" || serv=="HDRAIN")
				serv = "DRAIN";
			if(!arrSum[serv])
				arrSum[serv] = 0;
			arrSum[serv] = arrSum[serv]+sum;
			privSum += sum;
			
			var oRow = new Array(
							toScrObj(okpo)							//CDPR 		  - Код  організації за ЄДРПОУ
							,toScrObj(tbl.getValue("FIDENTCOD"))	//IDCODE      - Ідентифікаційний номер пільговика
							,toScrObj(corectDbfTxt(tbl.getValue("FFIO")))	//FIO         - ПІБ пільговика
							,toScrObj(tbl.getValue("FDOCSER") +""+ tbl.getValue("FLGNOM"))	//PPOS        - Серія та номер пільгового посвідчення
							,toScrObj(tbl.getValue("FRS"))			//RS          - Особовий  рахунок власника
							,new Date(rdat1).getFullYear()			//YEARIN      - Рік завантаження пільги
							,new Date(rdat1).getMonth()+1			//MONTHIN     - Місяць завантаження пільги
							,servCode(serv, tbl.getValue("FSERVCODE"))	//LGCODE      - Код послуги
							,datetrans(tbl.getValue("FDATE1"))		//DATA1       - Початок періоду, за який проведено нарахування пільги
							,datetrans(tbl.getValue("FDATE2"))		//DATA2       - Кінець періоду, за який проведено нарахування пільги
							,toScrObj(tbl.getValue("FMENCOUNT"))	//LGKOL       - Кількість осіб, що отримують пільги
							,toScrObj(Number(tbl.getValue("FDOCKAT")))//LGKAT       - Код  категорії  пільговика
							,toScrObj(tbl.getValue("FPERC"))		//LGPRC       - Розмір пільги (у %)
							,toScrObj(tbl.getValue("FSUM"))			//SUMM        - Сума нарахованої пільги
							,toScrObj(tbl.getValue(tfact(serv)))		//FACT        - Обсяг фактичного споживання
							,toScrObj(tbl.getValue("FTARIFF"))		//TARIF       - Тариф на послугу
							,toScrObj(tbl.getValue("FFLAG"))		//FLAG        - Ознака для перерахунків
							,sAddr									//ADR         - Адреса:вулиця, № будинку, № квартири пільговика
							,toScrObj(tbl.getValue("FLIVAREA"))		//OPPL        - Опалювальна площа
							,tapart(aptID, "FAREA")					//ZPL         - Загальна площа
							,0		//DAYHOT      - Кількість днів подачі гарячої води
							,0		//NORMCOLD    - Затверджена норма споживання холодної води
							,0 		//FNORMCOLD   - Фактична норма споживання холодної води 
							,0		//NORMHOT     - Затверджена норма споживання гарячої води
							,0		//FNORMHOT    - Фактична норма споживання гарячої води 
							,""		//RSNEW       - Єдиний загальноміський особовий рахунок споживача
							);
			oDBF.addRecord(oRow);
		}
		oDBF.write();
		
		sFileName = String(sFileName).trim();
		var fileDBF = new DpFile(sFileName);
		if(!fileDBF.isFile())
			return;
		
		var socDepTxt = getPar("HOCSOCDEP_TXT");
		if(!socDepTxt || String(socDepTxt).trim()=="")
		{
			socDepTxt = input(UR(" Відділ соціального захисту | Отдел социальной защиты ")
								, UR("Введіть назву відділу соц. захисту|Введите название отдела соц. защиты")
								, "", 254
								);
			if(socDepTxt)
				setPar("HOCSOCDEP_TXT", socDepTxt);
			else
				socDepTxt = "";
		}
		socDepTxt = String(socDepTxt).trim().toUpperCase();
		
		var socDepCod = getPar("HOCSOCDEP_COD");
		if(!socDepCod || String(socDepCod).trim()=="")
		{
			socDepCod = input(UR(" Код організації у відділі соц. захисту| Код организации в отделе соц. защиты ")
								, UR("Введіть код організації|Введите код организации")
								, "", 15
								);
			if(socDepCod)
				setPar("HOCSOCDEP_COD", socDepCod);
			else
				socDepCod = "";
		}
				
		var date = new Date(fileDBF.lastModified());
		var sumFormat = "#,00";
		var nRecords = tbl.recordCount;
		var reportFile = sFileName.substring(0, sFileName.length-4) +"P.TXT";
		var nl = "\r\n";
		var sReport = nl+"    ПРОТОКОЛ ПЕРЕДАЧІ БАЗИ ДАНИХ З НАДАННЯ ПІЛЬГ НА КВАРТПЛАТУ І КОМУНАЛЬНІ ПОСЛУГИ";
		sReport += nl+"                               У "+ socDepTxt;
		sReport += nl+"                     ВІДДІЛ СОЦІАЛЬНОГО ЗАХИСТУ УПСЗ ДГП ЛМР";
		sReport += nl+nl+nl+ getPar("OFIRM") +nl;
		sReport += nl+"Назва носiя бази даних     -  магнiтна дискета";
		sReport += nl+"Назва файлу бази даних     -      "+ fileDBF.getName();
		sReport += nl+"Дата створення файлу     -      "+ StrDat(date, "DMY");
		sReport += nl+"Час створення файлу     -      "+ format("HH:MM:SS", date);
		sReport += nl+"Розмiр файлу в байтах     -      "+ fileDBF.length();
		sReport += nl+"Кiлькiсть записiв у файлi     -      "+ nRecords;
		sReport += nl+"Код  організації     -      "+ socDepCod;
		sReport += nl+nl+nl+"Структура  DBF-файлу :"+nl;
		sReport += nl+"CDPR        - Код  організації за ЄДРПОУ"
				  +nl+"IDCODE      - Ідентифікаційний номер пільговика"
				  +nl+"FIO         - ПІБ пільговика"
				  +nl+"PPOS        - Серія та номер пільгового посвідчення"
				  +nl+"RS          - Особовий  рахунок власника"
				  +nl+"YEARIN      - Рік завантаження пільги"
				  +nl+"MONTHIN     - Місяць завантаження пільги"
				  +nl+"LGCODE      - Код пільги"
				  +nl+"DATA1       - Початок періоду, за який проведено нарахування пільги"
				  +nl+"DATA2       - Кінець періоду, за який проведено нарахування пільги"
				  +nl+"LGKOL       - Кількість осіб, що отримують пільги"
				  +nl+"LGKAT       - Код  категорії  пільговика"
				  +nl+"LGPRC       - Розмір пільги (у %)"
				  +nl+"SUMM        - Сума нарахованої пільги"
				  +nl+"FACT        - Обсяг фактичного споживання"
				  +nl+"TARIF       - Тариф на послугу"
				  +nl+"FLAG        - Ознака для перерахунків"
				  +nl+"ADR         - Адреса:вулиця, № будинку, № квартири пільговика"
				  +nl+"OPPL        - Опалювальна площа"
				  +nl+"ZPL         - Загальна площа"
				  +nl+"DAYHOT      - Кількість днів подачі гарячої води"
				  +nl+"NORMCOLD    - Затверджена норма споживання холодної води"
				  +nl+"FNORMCOLD   - Фактична норма споживання холодної води "
				  +nl+"NORMHOT     - Затверджена норма споживання гарячої води"
				  +nl+"FNORMHOT    - Фактична норма споживання гарячої води "
				  +nl+"RSNEW       - Єдиний загальноміський особовий рахунок споживача";
		sReport += nl+nl+nl+nl+"                    сума  пільг:     Кількість пільговиків:"+nl;
		var rentSum = arrSum["RENT"]? arrSum["RENT"] : 0;
		var rentKol = arrKol["RENT"]? arrKol["RENT"] : 0;
		sReport += nl+"Квартплата                 "
					+ format(sumFormat, rentSum)
					+"                     "+ rentKol;
		var heatSum = arrSum["HEAT"]? arrSum["HEAT"] : 0;
		var heatKol = arrKol["HEAT"]? arrKol["HEAT"] : 0;
		sReport += nl+"Опалення                 "
					+ format(sumFormat, heatSum)
					+"                     "+ heatKol;
		sReport += nl+"Гаряча  вода                 "
					+ (arrSum["HWATER"]? format(sumFormat, arrSum["HWATER"]) : format(sumFormat, 0)) 
					+"                     "+ (arrKol["HWATER"]? arrKol["HWATER"] : "0");
		sReport += nl+"Холодна  вода                 "
					+ (arrSum["CWATER"]? format(sumFormat, arrSum["CWATER"]) : format(sumFormat, 0)) 
					+"                     "+ (arrKol["CWATER"]? arrKol["CWATER"] : "0");
		sReport += nl+"Водовідведення                 "
					+ (arrSum["DRAIN"]? format(sumFormat, arrSum["DRAIN"]) : format(sumFormat, 0)) 
					+"                     "+ (arrKol["DRAIN"]? arrKol["DRAIN"] : "0");
		sReport += nl+"Електроенергія                 "
					+ (arrSum["ELECTRIC"]? format(sumFormat, arrSum["ELECTRIC"]) : format(sumFormat, 0)) 
					+"                     "+ (arrKol["ELECTRIC"]? arrKol["ELECTRIC"] : "0");
		sReport += nl+"Газ                 "
					+ (arrSum["GAS"]? format(sumFormat, arrSum["GAS"]) : format(sumFormat, 0)) 
					+"                     "+ (arrKol["GAS"]? arrKol["GAS"] : "0");
		
		//var sum = arrSum["RENT"]+arrSum["HEAT"]+arrSum["HWATER"]+arrSum["CWATER"]+arrSum["DRAIN"]+arrSum["ELECTRIC"]+arrSum["GAS"];
		//var kol = arrKol["RENT"]+arrKol["HEAT"]+arrKol["HWATER"]+arrKol["CWATER"]+arrKol["DRAIN"]+arrKol["ELECTRIC"]+arrKol["GAS"];
		var oSnap = getSnap("select count(distinct fmen) as cnt from "+ sTmpTbl);
		if(oSnap)
			privKol = oSnap[0];
		sReport += nl+"Разом                 "
					+ format(sumFormat, privSum)
					+"                     "+ privKol;
		
		sReport += nl+nl+"             Голова ОСББ            		_____________     /____________ /           ";
		sReport += nl+"              \"___\" _____________ "+ format("yyyy", date) +"р. ";
		sReport += nl+"    М.П.";
		sReport += nl+"             Головний бухгалтер         _____________     /____________ /           ";
		sReport += nl+"              \"___\" _____________ "+ format("yyyy", date) +"р. "+nl+nl;
		
		lpProxy.writeToFile(sReport, reportFile, "utf-8");
		
		if(getOS()=="win32")
			Packages.java.lang.Runtime.getRuntime().exec("cmd /c start "+ reportFile);
		
		tbl.close();
		ExecuteSQL("drop table "+ sTmpTbl);
	}
}

function servCode(sServ, sCode)
{
	if(sCode && String(sCode).trim()!="")
		return toScrObj(sCode);
	sServ = String(sServ).trim().toUpperCase();
	switch(sServ)
	{
		case "RENT": return 500;
		case "HWATER": return 501;
		case "CWATER": return 502;
		case "GAS": return 503;
		case "ELECTRIC": return 504;
		case "HEAT": return 505;
		case "TRASH": return 506;
		case "DRAIN": return 507;
		case "CDRAIN": return 507;
		case "HDRAIN": return 507;
	}
	return toScrObj(sCode);
}

function tfact(sServ)
{
	sServ = String(sServ).trim().toUpperCase();
	switch(sServ)
	{
		case "HEAT": return "FHEATAREA";
	}
	return "FFACT";
}

function tserv(fid_dog, sServ, sFld)
{
	var oSnap = getSnap("select "+ sFld +" from ^SC_SERV where FID_DOG="+ fid_dog +" and FSERV="+ sqlTo(sServ), false);
	if(oSnap && oSnap[0])
		return oSnap[0];
	return "";
}

function tmen(nID, sFld)
{
	var oSnap = getSnap("select "+ sFld +" from ^SC_MEN where FWID="+ nID, false);
	if(oSnap && oSnap[0])
		return oSnap[0];
	return "";
}

function tcontr(nID, sFld)
{
	var oSnap = getSnap("select "+ sFld +" from ^CONTRACT where FWID="+ nID, false);
	if(oSnap && oSnap[0])
		return toScrObj(corectDbfTxt(oSnap[0]));
	return "";
}

function texempt(nID, sFld)
{
	var oSnap = getSnap("select "+ sFld +" from ^CL_EXEMPT where FWID="+ nID, false);
	if(oSnap && oSnap[0])
		return toScrObj(corectDbfTxt(oSnap[0]));
	return "";
}

function taddr(nID)
{
	var oSnap = getSnap("select FSTREET_TXT, FHOUSE_NOM, FNOM from ^LISTAPARTMENT where FWID="+ nID, false);
	if(oSnap)
		return toScrObj(corectDbfTxt(oSnap[0] +" "+ oSnap[1] +(oSnap[2]? ", кв."+ oSnap[2] : "")));
	return "";
}

function tapart(nID, sFld)
{
	var oSnap = getSnap("select "+ sFld +" from ^CL_APARTMENT where FWID_CL="+ nID, false);
	if(oSnap)
		return toScrObj(corectDbfTxt(oSnap[0]));
	return "";
}

function tpriv(fid_dog, men, serv, fld, priv)
{
	var oSnap = getSnap("select sum("+ fld +") from ^"+ tblPriv 
						+" where FID_DOG="+ fid_dog
							+(men? " and FMEN="+ sqlTo(men) : "")
							+(priv? " and FID_PRIV="+ sqlTo(priv) : "")
							+(serv=="DRAIN"? " and FSERV like '%DRAIN'" : " and FSERV="+ sqlTo(serv))
							+" and FDATE>="+ sqlTo(rdat1)
							+" and FDATE<="+ sqlTo(rdat2)
						, false
						);
	if(oSnap)
		return oSnap[0];
	return "";
}

function listOnPrnList(tv)
{		
	tv.eval.addVar("BDATE", rdat1);
	tv.eval.addVar("EDATE", rdat2);
	tv.eval.addVar("FDATE", getSDat());
	tv.eval.addVar("FADDR", getAddr());	
	var sFld = "sum(FEXMPTKOL),sum(FFAMPART),sum(FAREAEXT),sum(FRENT),sum(FHEAT),sum(FCOOL),sum(FHOT),sum(FWREMOV),sum(FGAS),sum(FELECTRIC),sum(FTRASH),sum(FSUM)";
	var oSum = getSnap("select "+ sFld +" from "+ tblOut +" where FMEN>0")
	if(!oSum)
		return;
	tv.eval.addVar("FEXMPTKOL_SUM", oSum[0]);	
	tv.eval.addVar("FFAMPART_SUM", oSum[1]);	
	tv.eval.addVar("FAREAEXT_SUM", oSum[2]);	
	tv.eval.addVar("FRENT_SUM", oSum[3]);	
	tv.eval.addVar("FHEAT_SUM", oSum[4]);	
	tv.eval.addVar("FCOOL_SUM", oSum[5]);	
	tv.eval.addVar("FHOT_SUM", oSum[6]);	
	tv.eval.addVar("FWREMOV_SUM", oSum[7]);	
	tv.eval.addVar("FGAS_SUM", oSum[8]);	
	tv.eval.addVar("FELECTRIC_SUM", oSum[9]);
	tv.eval.addVar("FTRASH_SUM", oSum[10]);
	tv.eval.addVar("FSUM_SUM", oSum[11]);
}

include("sys/DpList.js");