
var tblOut = getTmpTableName();		//таблица с результатами
var tblPriv = "PRIVILEGE";			//льготы
var label = "KU_PRIV";
var streetID = 0;
var houseID = 0;
var exemptID = 0;
var exemptType = "";
var rdat1;
var rdat2;

function listLoad()
{
	this.xmlGridFile = "r_extsvd.xml";
	this.printLabel = label;
	this.accDel = null;	
}

function listSrc()
{
	this.qrySet("From", tblOut);
	this.subTie("cl_exempt", "ex", "FWID_CL", "FID_EXT");	
	//this.subTie("cl", "str", "FWID", "FSTREET");
}

function listTitle()
{
	var sCapt = UR("Зведений розрахунок по пільгах|Сводный отчет по льготам");
	var dat = list.objAsk.rdate;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	
	if(dat!=null)
		sCapt += " за "+ getSDat(dat);
	if(oStreet && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	return sCapt;
}

function listAsk()
{
	var p = new Object();
	p.tblName = tblOut;
	p.label = label;
	showWindow("i_exempt.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    exemptID = p.iexempt.getFWID();
	    exemptType = p.iexempt_type;
    } 
	return p;
}

function listMake()
{
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 7);
	setProgressPos(nPr++, sPrText);
		
	var d1 = sqlTo(rdat1);
	var d2 = sqlTo(rdat2);
	
	var sWhere = " c.FBDAT<="+ d2 +" and c.FEDAT>="+ d1;
	if(houseID)			//отбор по дому
		sWhere += " and l.FHOUSE="+ houseID;
	else if(streetID)	//отбор по улице
		sWhere += " and l.FSTREET="+ streetID;	
	if(exemptID)		//отбор по льготе
		sWhere += " and priv.FID_LG="+ exemptID;
	else if(exemptType)	//отбор по типу льгот
		sWhere += " and UPPER(e.FATTR)="+ sqlTo(exemptType);
	
	var sTmpMen = getTmpTableName(); 	//льготники
	var sSQL = "create table "+ sTmpMen 
			+" (FWID "+ SqlType("LONG") 
			+", FID_LG "+ SqlType("LONG") 
			+", FMAIN "+ SqlType("BIT") 
			+")"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ sTmpMen +"(FWID, FID_LG, FMAIN)"
			+" select men.FWID, priv.FID_LG, pm.FMAIN"
			+" from ^SC_MEN men"
				+" inner join ^SC_PRIVMEN pm on pm.FID_MEN=men.FWID"
				+" inner join ^SC_PRIV priv on priv.FWID=pm.FID_PRIV"
				+" inner join ^CL_EXEMPT e on e.FWID_CL=priv.FID_LG"
				+" inner join ^CONTRACT c on c.FWID=priv.FID_DOG"
				+" inner join ^LICSC l on l.FID_DOG=priv.FID_DOG"
			+" where priv.FBDAT<="+ d2
				+" and priv.FEDAT>="+ d1
				+" and men.FBDAT<="+ d2
				+" and men.FEDAT>="+ d1
				+" and "+ sWhere
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	var sTmpPriv = getTmpTableName();
	CreateTable(sTmpPriv, tblPriv, "*");
	setProgressPos(nPr++, sPrText);
	
	var fld = GetPatternIntersection(tblPriv, tblPriv);
	var sSQL = "insert into "+ sTmpPriv +"("+ fld +")"
				+" select "+ GetPatternIntersection(tblPriv, tblPriv, "priv")
				+" from ^"+ tblPriv +" priv "
				+" inner join ^CL_EXEMPT e on e.FWID_CL=priv.FID_LG"
				+" inner join ^CONTRACT c on c.FWID=priv.FID_DOG"
				+" inner join ^LICSC l on l.FID_DOG=priv.FID_DOG"
				+" where priv.FDATE>="+ d1 +" and priv.FDATE<="+ d2
					+" and "+ sWhere
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	var sTmpTbl = getTmpTableName();
	createOutTable(sTmpTbl);
	setProgressPos(nPr++, sPrText);
	
	var sumDec = Number(getPar("DECISUM"));
	/*
	sSQL = "insert into "+ sTmpTbl +"(FID_EXT,FSUM,FEXMPTKOL,FFAMPART"
					+",FRENT,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER)"
				+" select FID_LG, sum(FSUM)"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_LG="+ sTmpPriv +".FID_LG) as FEXMPTKOL"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_LG="+ sTmpPriv +".FID_LG and men.FMAIN="+ sqlFalse +") as FFAMPART"
					+", "+ sqlRound("sum("+ IIF("FSERV='RENT'", "FSUM", "0") +")", sumDec) +" as FRENT"
					+", "+ sqlRound("sum("+ IIF("FSERV='HEAT'", "FSUM", "0") +")", sumDec) +" as FHEAT"
					+", "+ sqlRound("sum("+ IIF("FSERV='CWATER'", "FSUM", "0") +")", sumDec) +" as FCOOL"
					+", "+ sqlRound("sum("+ IIF("FSERV='HWATER'", "FSUM", "0") +")", sumDec) +" as FHOT"
					+", "+ sqlRound("sum("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", "FSUM", "0") +")", sumDec) +" as FWREMOV"
					+", "+ sqlRound("sum("+ IIF("FSERV='GAS'", "FSUM", "0") +")", sumDec) +" as FGAS"
					+", "+ sqlRound("sum("+ IIF("FSERV='ELECTRIC'", "FSUM", "0") +")", sumDec) +" as FELECTRIC"
					+", "+ sqlRound("sum("+ IIF("FSERV='TRASH'", "FSUM", "0") +")", sumDec) +" as FTRASH"
					+", "+ sqlRound("sum("+ IIF("FSERV='OTHER'", "FSUM", "0") +")", sumDec) +" as FOTHER"
				+" from "+ sTmpPriv
				+" group by FID_LG"
	*/
	sSQL = "insert into "+ sTmpTbl +"(FID_EXT,FSUM,FEXMPTKOL,FFAMPART"
					+",FRENT,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER)"
				+" select FID_LG, sum(FSUM)"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_LG="+ sTmpPriv +".FID_LG) as FEXMPTKOL"
					+", (select count(distinct men.FWID) as cnt"
						+" from "+ sTmpMen +" men where men.FID_LG="+ sTmpPriv +".FID_LG and men.FMAIN="+ sqlFalse +") as FFAMPART"
					+", sum("+ IIF("FSERV='RENT'", sqlRound("FSUM", sumDec), "0") +") as FRENT"
					+", sum("+ IIF("FSERV='HEAT'", sqlRound("FSUM", sumDec), "0") +") as FHEAT"
					+", sum("+ IIF("FSERV='CWATER'", sqlRound("FSUM", sumDec), "0") +") as FCOOL"
					+", sum("+ IIF("FSERV='HWATER'", sqlRound("FSUM", sumDec), "0") +") as FHOT"
					+", sum("+ IIF("FSERV='DRAIN' or FSERV='CDRAIN' or FSERV='HDRAIN'", sqlRound("FSUM", sumDec), "0") +") as FWREMOV"
					+", sum("+ IIF("FSERV='GAS'", sqlRound("FSUM", sumDec), "0") +") as FGAS"
					+", sum("+ IIF("FSERV='ELECTRIC'", sqlRound("FSUM", sumDec), "0") +") as FELECTRIC"
					+", sum("+ IIF("FSERV='TRASH'", sqlRound("FSUM", sumDec), "0") +") as FTRASH"
					+", sum("+ IIF("FSERV='OTHER'", sqlRound("FSUM", sumDec), "0") +") as FOTHER"
				+" from "+ sTmpPriv
				+" group by FID_LG"
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();	
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ tblOut +" (FID_EXT,FEXMPTKOL,FFAMPART,FRENT,FHEAT"
					+",FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM)"
				+" select FID_EXT,FEXMPTKOL,FFAMPART,FRENT,FHEAT"
					+",FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER"
					+","+ sqlRound("FRENT+FHEAT+FCOOL+FHOT+FWREMOV+FGAS+FELECTRIC+FTRASH+FOTHER", sumDec) +" as FSUM"
				+" from "+ sTmpTbl
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	sSQL = "insert into "+ tblOut +"(FTT,FEXMPTKOL,FFAMPART,FRENT,FHEAT"
					+",FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM)"
				+" select 'SUM',sum(FEXMPTKOL),sum(FFAMPART)"
					+",sum(FRENT),sum(FHEAT),sum(FCOOL),sum(FHOT),sum(FWREMOV)"
					+",sum(FGAS),sum(FELECTRIC),sum(FTRASH),sum(FOTHER)"
					+",sum("+ sqlRound("FRENT+FHEAT+FCOOL+FHOT+FWREMOV+FGAS+FELECTRIC+FTRASH+FOTHER", sumDec) +") as FSUM"
				+" from "+ sTmpTbl
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPrText);
	
	ExecuteSQL("drop table "+ sTmpTbl);
	ExecuteSQL("drop table "+ sTmpPriv);
	ExecuteSQL("drop table "+ sTmpMen);
	
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false);
	var sSql = "CREATE TABLE "+ sTblName 
			+"(FNUM "+ SqlType("INT")		//№ п/п
			+", FID_EXT"+ SqlType("LONG")	//льгота: FWID_CL табл CL_EXEMPT, он же FID_LG из табл SC_PRIV
			+", FHOUSE "+ SqlType("LONG")	//дом: FWID_CL табл CL_HOUSE
			+", FSTREET "+ SqlType("LONG")	//улица: FSTREET из табл CL_HOUSE
			+", FHSNOM "+ SqlType("TEXT")	//номер дома: FNOM табл CL_HOUSE
			+", FPERSKOL "+ SqlType("INT")	//колич. жильцов
			+", FEXMPTKOL "+ SqlType("INT")	//колич. льготников
			+", FFAMPART "+ SqlType("INT")	//в том числе членов семьи
			+", FDATE "+ SqlType("DATE")	//дата
			+", FTT "+ SqlType("TEXT")		//тип итога
			+", FSUM "+ SqlType("CURRENCY")	//общая сумма льгот за мес.
			//суммы льгот по услугам
			+", FAREAEXT "+ SqlType("CURRENCY")
			+", FRENTTARIF "+ SqlType("CURRENCY")
			+", FRENT "+ SqlType("CURRENCY")//квартплата FRENTSUM
			+", FHEAT "+ SqlType("CURRENCY")//отопление
			+", FCOOL "+ SqlType("CURRENCY")//хол. вода
			+", FHOT "+ SqlType("CURRENCY")	//гор. вода
			+", FWREMOV "+ SqlType("CURRENCY")//водоотведение
			+", FGAS "+ SqlType("CURRENCY")	//газ
			+", FELECTRIC "+ SqlType("CURRENCY")//электроэнергия
			+", FTRASH "+ SqlType("CURRENCY")//вывоз мусора
			+", FOTHER "+ SqlType("CURRENCY")//другое
			+")";			
	ExecuteSQL(sSql, false);
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

function getSDat(date)
{	
	if(!date)
		date = rdat1;
	if(!date)
		return "";
	var sMonth = tmonth(date, 3);
	var sYear = date.getYear() + 1900;
	return sMonth +" "+ sYear;
}

function getAddr()
{
	var sAddr = "";
	var oSnap = getSnap("select r.FSTREET,r.FHOUSE,cl.FTXT "
					+" from "+ tblOut +" r inner join ^CL cl on cl.FWID=r.Fstreet "
					+" where r.Fhouse<>0", false);
	if(oSnap!=null && oSnap[0]!=0)
		sAddr = oSnap[2] +" "+ getHouseNom(oSnap[1]);

	return sAddr;
}

function listOnPrnList(tv)
{		
	tv.eval.addVar("DATE", rdat1);
	tv.eval.addVar("SDAT", getSDat());
	tv.eval.addVar("FADDR", getAddr());	
	
	var sFld = "FEXMPTKOL,FFAMPART,FAREAEXT,FRENT,FHEAT,FCOOL,FHOT,FWREMOV,FGAS,FELECTRIC,FTRASH,FOTHER,FSUM";
	var oSum = getSnap("select "+ sFld +" from "+ tblOut +" where FTT='SUM'")
	if(!oSum)
		return;
	tv.eval.addVar("FEXMPTKOL_SUM", oSum[0]);	
	tv.eval.addVar("FFAMPART_SUM", oSum[1]);	
	tv.eval.addVar("FAREAEXT_SUM", oSum[2]);	
	tv.eval.addVar("FRENT_SUM", oSum[3]);	
	tv.eval.addVar("FHEAT_SUM", oSum[4]);	
	tv.eval.addVar("FCOOL_SUM", oSum[5]);	
	tv.eval.addVar("FHOT_SUM", oSum[6]);	
	tv.eval.addVar("FWREMOV_SUM", oSum[7]);	
	tv.eval.addVar("FGAS_SUM", oSum[8]);	
	tv.eval.addVar("FELECTRIC_SUM", oSum[9]);
	tv.eval.addVar("FTRASH_SUM", oSum[10]);
	tv.eval.addVar("FOTHER_SUM", oSum[11]);
	tv.eval.addVar("FSUM_SUM", oSum[12]);
}

function listMenuInit()
{
	grid.AddMenuItem("LICSC", "Особові рахунки|Лицевые счета");
	grid.AddMenuItem("MEN", "Пільговики|Льготники");
	grid.AddMenuItem("", "");
}

function listMenuRun(sID)
{
	var nID = list.tbl.getValue("FID_EXT");
	switch(sID)
	{
		case "LICSC":
			var par = new Object();
			par.doc = "LICSC";
			par.subWhere = " FID_DOG in (select FID_DOG from ^SC_PRIV where FID_LG="+ nID +")";
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "MEN":
			var par = new Object();
			par.exempt = nID;
			showWindow("l_men.xml", SW_NOMODAL, par);
			break;
	}
}

include("sys/DpList.js");