include("objects\\DpObsl.js")
include("objects\\DpGetDat.js")
include("objects\\DpSc.js")
include("objects\\DpVal.js")

var ds;
var tbody;
var ddopzm;

var editAcc = ""
var delFilter = false;
var prnPatt = "KASSRE";
var gd;

function listLoad()
{
	ddopzm = GetMenuMode();
	this.printLabel = prnPatt;
	
	if(ddopzm == "V")
		this.par.menuMode = "VIEW";
	else
		this.par.menuMode = "CALC";		
}

function listTitle()
{
	return UR("Журнал реєстрації прибуткових і видаткових касових документів|Журнал регистрации приходных и расходных кассовых документов");
}

function listAsk()
{
	return new DpGetDat("dDcutx0v");
}

function listMake()
{
	DropTable("KASSREE");
	if (IsTable("KASSREE"))
	{ alert("Невозможно выполнить расчет."
	  +"\nПроверьте, возможно окно с данным расчетом уже открыто,"
	  +"\nили перезапустите систему.");
	//+ "\nВозможно окно с данным расчетом уже открыто");
		CloseWindow();
		return;
	}
	if (!list.objAsk.escape)
	{
		var par=new Object(),tbl=new Object();
		var zm_sch=new DpSc(list.objAsk.fsc,list.objAsk.fsu,list.objAsk.fst);
		var oop=new DpObsl(zm_sch,list.objAsk.dat1,list.objAsk.dat2,list.objAsk.codv);
		var strSQL;
		var strHSQL;
		var dopStr1="",dopStr2="";

		if (IsTable("KASSREE"))
			DropTable("KASSREE");

		if (list.objAsk.fsu!=0)
		{
			dopStr1+=" AND Fdb_su="+list.objAsk.fsu;
			dopStr2+=" AND Fcr_su="+list.objAsk.fsu;
		}
		if (list.objAsk.fst!=0)
		{
			dopStr1+=" AND Fdb_st="+list.objAsk.fst;
			dopStr2+=" AND Fcr_st="+list.objAsk.fst;
		}
		if (list.objAsk.fcl1!=0)
		{
			dopStr1+=" AND Fdb_cod1="+list.objAsk.fcl1;
			dopStr2+=" AND Fcr_cod1="+list.objAsk.fcl1;
		}

		var Valtxts = new DpVal(list.objAsk.codv).getTxts();

		var tmpTbl = getTmpTableName()
		var tmpPr = getTmpTableName()
		var tmpRas = getTmpTableName()
		strSQL =" SELECT Fdate,s.Fdocnum, Ftxt, s.Fid_doc, s.FDOC"
				+ ", Fcr_sc AS Fsc, Fcr_su AS Fsu, Fcr_st AS Fst"
				+ ", Fsum AS Fprih"
				+ ", " + Convert("0","DBL") + " AS Fras"
				+ ", Fval"
				+ ", 100 AS Fdum"
			+ " INTO "+tmpPr
	  + " FROM ^schet s"
			+ " WHERE fwrk not in (12, 15)"
				+ " AND Fdate>=" + sqlTo(list.objAsk.dat1)
				+ " AND Fdate<=" + sqlTo(list.objAsk.dat2)
				+ " AND Fdb_sc=" + list.objAsk.fsc
				+ dopStr1
				+ " AND Fval=" + list.objAsk.codv;
		ExecuteSQL(strSQL);

		strSQL = " SELECT Fdate,s.Fdocnum"
				+ ",Ftxt,S.Fid_doc, S.FDOC"
				+ ", Fdb_sc AS Fsc,Fdb_su AS Fsu,Fdb_st AS Fst"
				+ ", " + Convert("0","DBL") + " AS fprih"
				+ ", Fsum AS Fras"
				+ ", Fval"
				+ ",100 AS Fdum"
				+" INTO "+tmpRas
	  + " FROM ^SCHET s"
			+ " WHERE fwrk not in (12, 15)"
				+ " AND Fdate>="+sqlTo(list.objAsk.dat1)
				+ " AND Fdate<="+sqlTo(list.objAsk.dat2)
				+ " AND Fcr_sc="+list.objAsk.fsc
				+ dopStr2
				+ " AND Fval="+list.objAsk.codv;

		ExecuteSQL(strSQL);

		if (op_zakr(list.objAsk.dat1,list.objAsk.dat2))
		{
			strSQL=
				"INSERT INTO "+tmpPr+" (Fdate,Fdocnum,Ftxt,Fsc,Fsu,Fst,Fprih,"
					+ "Fras,Fval,Fdum, FID_DOC, FDOC) "
				+ " SELECT Fdate,Fdocnum,Ftxt"
					+ ", Fcr_sc AS Fsc,Fcr_su AS Fsu,Fcr_st AS Fst"
					+ ", Fsum AS Fprih"
					+ ", " + Convert("0","DBL") + " AS Fras"
					+ ", Fval"
					+ ",100 AS Fdum"
					+ ", Fid_doc"
					+ ", Fdoc"
				+ " FROM ^SCHET_ZR"
				+ " WHERE fwrk not in (12, 15)"
					+ " AND Fdate>="+sqlTo(list.objAsk.dat1)
					+ " AND Fdate<="+sqlTo(list.objAsk.dat2)
					+ " AND Fdb_sc="+list.objAsk.fsc
					+ dopStr1
					+ " AND Fval="+list.objAsk.codv;

			ExecuteSQL(strSQL);

			strSQL=
				"INSERT INTO "+tmpRas+" (Fdate,Fdocnum,Ftxt,Fsc,Fsu,Fst,Fras,"
					+ "Fval,Fdum,Fid_doc, FDOC) "
				+" SELECT Fdate,Fdocnum,Ftxt"
					+ ", Fdb_sc AS Fsc,Fdb_su AS Fsu,Fdb_st AS Fst"
					+ ", Fsum AS Fras"
					+ ", Fval"
					+ ",100 AS Fdum"
					+ ", Fid_doc"
					+ ", Fdoc"
				+ " FROM ^SCHET_ZR"
				+ " WHERE Fdate>="+sqlTo(list.objAsk.dat1)
					+ " AND Fdate<="+sqlTo(list.objAsk.dat2)
					+ " AND Fcr_sc="+list.objAsk.fsc
					+ dopStr2
					+ " AND Fval="+list.objAsk.codv;

			ExecuteSQL(strSQL);
		}
		var tmpPr1 = getTmpTableName();
		strSQL = "SELECT * INTO "+tmpPr1+" FROM "+tmpPr+" ORDER BY FDATE, FDOCNUM"
		ExecuteSQL(strSQL);
		DropTable(tmpPr);
		tmpPr = tmpPr1;
		var tmpRas1 = getTmpTableName();
		strSQL = "SELECT * INTO "+tmpRas1+" FROM "+tmpRas+" ORDER BY FDATE, FDOCNUM"
		ExecuteSQL(strSQL);
		DropTable(tmpRas);
		tmpRas = tmpRas1;
		ExecuteSQL("ALTER TABLE "+tmpPr+" ADD COLUMN FWID "+SqlType("COUNTER"))
		ExecuteSQL("ALTER TABLE "+tmpRas+" ADD COLUMN FWID "+SqlType("COUNTER"))
		var tblPr = OpenTable("s", tmpPr)
		var tblRs = OpenTable("s", tmpRas)
		var recPr = tblPr.recordCount
		var recRs = tblRs.recordCount
		tblPr.close(5652);
		tblPr = null;
		tblRs.close(5652);
		tblRs = null;
		var join = (recPr>recRs ? "LEFT" : (recPr<recRs ? "RIGHT" : "INNER"));
		var mFwid = (recPr>recRs ? "P.FWID" : "R.FWID");
		strSQL = "SELECT P.FDATE AS FDATE_P, P.FDOCNUM AS FDOCNUM_P, P.FID_DOC AS FID_DOC_P, P.FDOC AS FDOC_P, P.FPRIH, P.FTXT AS FTXT_P,"
			+" R.FDATE AS FDATE_R, R.FDOCNUM AS FDOCNUM_R, R.FID_DOC AS FID_DOC_R, R.FDOC AS FDOC_R, R.FRAS, R.FTXT AS FTXT_R, "+mFwid
			+" INTO KASSREE"
			+" FROM "+tmpPr+" P "+join+" JOIN "+tmpRas+" R ON R.FWID = P.FWID "
		ExecuteSQL(strSQL);
		strSQL = "UPDATE KASSREE "
			+" SET FTXT_P = (SELECT "+SqlConCat("O.FOSNOV","' '","O.FFIO")+" FROM ^CAS_ORD O "
			+" WHERE KASSREE.FID_DOC_P = O.FWID )"
			+" WHERE EXISTS (SELECT O.FOSNOV FROM ^CAS_ORD O "
			+" WHERE KASSREE.FID_DOC_P = O.FWID )"
		ExecuteSQL(strSQL);
		strSQL = "UPDATE KASSREE "
			+" SET FTXT_R = (SELECT "+SqlConCat("O.FOSNOV","' '","O.FFIO")+" FROM ^CAS_ORD O "
			+" WHERE KASSREE.FID_DOC_R = O.FWID )"
			+" WHERE EXISTS (SELECT O.FOSNOV FROM ^CAS_ORD O "
			+" WHERE KASSREE.FID_DOC_R = O.FWID )"
		ExecuteSQL(strSQL);
		strSQL = "UPDATE KASSREE"
			+" SET FTXT_R = (SELECT O.FTXT FROM ^HVD O"
			+" WHERE KASSREE.FID_DOC_R = O.FWID )"
			+" WHERE EXISTS (SELECT O.FTXT FROM ^HVD O "
			+" WHERE KASSREE.FID_DOC_R = O.FWID )"
		ExecuteSQL(strSQL);
	}
}

function listSrc()
{
	var m_strAlias,gr;
	var sExpr="";

	list.qrySet("From", "KASSREE",
				"Order", "FWID"
				);
	list.qryFields = " * "/* + sExpr*/;
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
		with(page())
		{
			with (group ("Прибутковий документ|Приходный документ"))
			{
				cell( "FDATE_P","Дата", 8);
				cell( "FDOCNUM_P","Номер", 8);
			}
			cell( "FPRIH","Сума|Сумма", 8);
			cell( "FTXT_P","Примітки|Примечания", 25);
			with (group ("Видатковий документ|Расходный документ"))
			{
				cell( "FDATE_R","Дата", 8);
				cell( "FDOCNUM_R","Номер", 8);
			}
			cell( "FRAS","Сума|Сумма", 8);
			cell( "FTXT_R","Примітки|Примечания", 25);
		}
		build();
	}
}

function getTblH()
{
	header = new Object();
	header.FDATBEG = list.objAsk.dat1;
	header.FDATEND = list.objAsk.dat2;
	
	return header;
}

function listMenuInit()
{
	/*list.dataSrc.AddMenuItem("CTRL-PP","Пошук проведення (прибутковий документ)|Поиск проводоки (приходный документ)");
	list.dataSrc.AddMenuItem("CTRL-PR","Пошук проведення (видатковий документ)|Поиск проводоки (расходный документ)");*/
	list.dataSrc.AddMenuItem("CTRL-DP","Пошук документу (прибутковий документ)|Поиск документа (приходный документ)");
	list.dataSrc.AddMenuItem("CTRL-DR","Пошук документу (видатковий документ)|Поиск документа (расходный документ)");
	list.dataSrc.AddMenuItem("","");
}

function listMenuRun(nID)
{
	var par = new empty();
	switch(nID)
	{
		case "CTRL-PP":
			var par     = new Object();
			par.ret = new Object();
//-			par.ret.fwid = DataSource().GetTable()("Fid_prov");
			par.ret.fwid = list.tbl.getValue("Fid_prov");
			if(par.ret.fwid)
				showWindow("l_prov.js", SW_NOMODAL, par);
			break;
		
//-		       stdMenuHandler(nID,tbody);
		case "CTRL-DP":
			if (!isEmpty(list.tbl.getValue("Fdoc_p")) && !isEmpty(list.tbl.getValue("Fid_doc_p")))
			{
				include("doc\\DpDocPtn.js");
				FindDocument(list.tbl.getValue("Fdoc_p"), 0, list.tbl.getValue("Fid_doc_p"));
			}
			break;
		case "CTRL-DR":
			if (!isEmpty(list.tbl.getValue("Fdoc_r")) && !isEmpty(list.tbl.getValue("Fid_doc_r")))
			{
				include("doc\\DpDocPtn.js");
				FindDocument(list.tbl.getValue("Fdoc_r"), 0, list.tbl.getValue("Fid_doc_r"));
			}
			break;
	}
}

include("sys\\DpList.js");