include("Objects/DpGetDat.js");
include("servis/date.js");
include("sys/udfs.js");

var nProgress = 0;

function onLoad()
{
	var objAsk = new DpGetDat("d");
	if(true ==objAsk.escape)
		return false;
	var dat1 = new Date(objAsk.dat1)
	r_obtm(dat1);
	var par = new Object();
	par.dat = dat1;
	par.zaval = true;

	setProgressRange(0, 100);
	setProgressPos(++nProgress, ru("Подготовка списка...", "Підготовка списку..."));
	showWindow("l_obtm.js", SW_NOMODAL, par);
	for(i=2; i<101;i++){
	setProgressPos(++nProgress);
	}
	setProgressPos(0);
	return false;
}

/**
Значения typeRozrah
0 - все
1 - подразделение fwid подразделения
2 - по человеку, fwid - ftabn_id
3 - по группе, fwid массив ftabn_id
*/

function r_obtm(bdat, typeRozrah, fwid)
{
//Подготовка таблицы для расчёта отработанного времени
	var dat1 = new Date(firstDayMonth(bdat))
	var dat2 = new Date(lastDayMonth(bdat))
	bdat.setDate(1);
	var edat = new Date(bdat.getYear()+1900, bdat.getMonth() + 1, 1);
	edat.setDate(0);
	var mainTableName = "OBTM" + (bdat.getYear()+1900)+(((bdat.getMonth() + 1)<10)?"0":"") 
					+ (bdat.getMonth() + 1); 
					
	if(IsTableEx("cdr_res", "cdr_" + mainTableName))
	{
		var strSQL = "DELETE FROM ^" + mainTableName;
		if(1 == typeRozrah)//подразделение
		{
			strSQL = "DELETE FROM ^" + mainTableName
					+ " WHERE fwid_dol IN (SELECT fwid FROM ^stru_dol"
										+ " WHERE fwid_org=" + sqlTo(fwid); 
		}
		else if(2 == typeRozrah)//по человеку
		{
			strSQL = "DELETE FROM ^" + mainTableName + " WHERE ftabn_id=" + sqlTo(fwid);
		}
		else if(3 == typeRozrah)//по группе
		{
			var strList = "";
			for(var i=0; fwid.length; i++)
				strList += (0==i)?fwid[i]:(", " + fwid[i]);
			
			strSQL = "DELETE FROM ^" + mainTableName + " WHERE ftabn_id IN (" + strList + ")";
		}
		
		ExecuteSQL(strSQL);
	}
	else
	{
		strPath = getPath("cdr_res");
		CreateTableEx("cdr_res","cdr_" + mainTableName, "OBTM", "*");
	}
	
//Откроем необходимые записи из штатного расписания
	var strSQL = "SELECT w.fwid_cl, w.fwid_dol, w.fbdat, w.fedat, d.fwid_algo"
				+ " FROM ^work_pers AS w INNER JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid"
				+ " WHERE ((w.fbdat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + ")"
					+ " OR (w.fbdat>=" + sqlTo(bdat) + " AND w.fbdat<=" + sqlTo(edat) + ")"
					+ " OR (w.fedat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + "))"
				+ " ORDER BY d.fwid_algo";
	var tblShtat = OpenTable("s", strSQL);
	if(tblShtat.isEmpty())				
	{
		tblShtat.Close();
		return false;
	}
	
//Справочная таблица праздников
	strSQL = "SELECT * FROM ^hollidays WHERE fmonth=" + sqlTo(bdat.getMonth()+1) 
										+ " AND (fyear=0 OR fyear=" + sqlTo(bdat.getYear()+1900) + ")";
	var tblHDays = OpenTable("s", strSQL);
	if(tblHDays.isEmpty())
	{
		tblHDays.Close();
		tblHDays = null;
	}

//Открыть таблицу с учётом времени за прошлый месяц и взять записи за последнее число (32)
	prevDat = new Date(bdat);
	prevDat.setMonth(prevDat.getMonth()-1);
	prevTabName = "OBTM" + (prevDat.getFullYear())+(((prevDat.getMonth()+1)<10)?"0":"") + (prevDat.getMonth()+1);
	prevDat = null;
	var condition = 1;
	if(!IsTableEx("cdr_res", "cdr_" + prevTabName))
	{
		if(confirm(ru("Отсутствует таблица расчёта\nотработаного времени за прошлый месяц!\nДля заполнения таблицы применять\nпервую запись из алгоритма?"
					, "Відсутня таблиця розрахунку\nвідпрацьованого часу за минулий місяць!\nДля заповнення таблиці застосувати\nперший запис з алгоритму?")))
			condition = 3;
		else
			condition = 2;
	}
	else
	{
		tabPrevValue = OpenTable("s","SELECT * FROM ^" + prevTabName + " WHERE fday=32 ORDER BY fwid_dol, ftabn_id");
		tabPrevValue.MoveFirst();
	}
	
	

//Подготовим значения для уволенных и принятых в этом месяце
	strSQL =  "SELECT fwid FROM ^time WHERE ftxt='ЗВ'";
	var snap = getSnap(strSQL);
	var zvilSotrFWID;
	if(snap!=null)
		zvilSotrFWID = snap[0];

	strSQL =  "SELECT fwid FROM ^time WHERE ftxt='НВ'";
	snap = getSnap(strSQL);
	var prinSotrFWID
	if(snap!=null)
		prinSotrFWID = snap[0];
//Для каждого сотрудника заполним учёт времени по умолчанию.
	var amountDays = edat.getDate();
	var hdayFWID = null;
	var currAlgo = null;
	var algorithm = null;
	setProgressRange(0, tblShtat.getRowCountEx() + 2);
	for(tblShtat.MoveFirst(); !tblShtat.isEOF();  tblShtat.MoveNext())
	{
		setProgressPos(++nProgress, ru("Обрабатывается : ", "Обробляється: ") + getTxtFromID(tblShtat.getValue("fwid_cl")));
		
		if(currAlgo != tblShtat.getValue("fwid_algo"))
		{
			currAlgo = tblShtat.getValue("fwid_algo");
			strSQL = "SELECT b.*, a.ftype"
					+ " FROM ^time AS a RIGHT JOIN ^alg_field AS b ON a.fwid = b.fwid_time"
					+ " WHERE b.fwid_par=(SELECT fwid FROM ^algorithm"
										+ " WHERE fcod=" + sqlTo(tblShtat.getValue("fwid_algo")) + ")"
					+ " ORDER BY b.fnom";
			if(null!=algorithm)
				algorithm.Close();
			algorithm = OpenTable("s", strSQL);
			algorithm.setIdFld("b.fwid");
			if(0 == tblShtat.getValue("fwid_algo"))
			{
				strSQL = "SELECT fwid_time"
						+ " FROM ^alg_field"
						+ " WHERE fwid_par=(SELECT fwid FROM ^algorithm"
											+ " WHERE fcod=" + sqlTo(tblShtat.getValue("fwid_algo")) + ")"
								+ " AND fday=0";
				snap = getSnap(strSQL);
				if(snap!=null)
					hdayFWID = snap[0];
			}
		}
		
		var lastValue;
		switch(condition)
		{
		case 1:
			if(tabPrevValue.FindFirst("fwid_dol =" + sqlTo(tblShtat.getValue("fwid_dol"))
									+ " AND ftabn_id=" + sqlTo(tblShtat.getValue("fwid_cl"))))
			{
				lastValue = tabPrevValue.getValue("falg_fld");
			}
			else
/*временно закоментировал пока не разберусь с getLastValue 
				lastValue = getLastValue( tblShtat.getValue("fwid_algo")
										, tblShtat.getValue("fwid_cl")
										, tblShtat.getValue("fwid_dol")
										, dat1
										, dat2);
				
			algorithm.FindFirst("fwid="+sqlTo(lastValue));*/	
			break;
			
		case 2:
/*временно закоментировал пока не разберусь с getLastValue 
			lastValue = getLastValue( tblShtat.getValue("fwid_algo")
									, tblShtat.getValue("fwid_cl")
									, tblShtat.getValue("fwid_dol")
									, dat1
									, dat2);
			algorithm.FindFirst("fwid="+sqlTo(lastValue));	*/
			break;
			
		case 3:
			if(0==tblShtat.getValue("fwid_algo"))
			{
				var day = ((bdat.getDay()-1)<0)?6:(bdat.getDay()-1);
				algorithm.FindFirst("b.fday="+day);
			}
			else
				algorithm.MoveLast();

			break;
		
		default:
/*временно закоментировал пока не разберусь с getLastValue 
			lastValue = getLastValue( tblShtat.getValue("fwid_algo")
									, tblShtat.getValue("fwid_cl")
									, tblShtat.getValue("fwid_dol")
									, dat1
									, dat2);
			algorithm.FindFirst("fwid="+sqlTo(lastValue));	*/
			break;
		}
		
		for(i=1; i<=amountDays;i++)
		{
			algorithm.MoveNext();
			if(algorithm.isEOF())
				algorithm.MoveFirst();
				
			if(null != tblHDays 
			&& 0 == tblShtat.getValue("fwid_algo"))
			{
				hday = (tblHDays.FindFirst("fday=" + i));
			}
			else
				hday = false;
				
			strSQL = "INSERT INTO ^" + mainTableName + " (ftabn_id, fwid_dol, fday, fvalue, fdefvalue, falg_fld, ftype)"
					+ " VALUES (" + sqlTo(tblShtat.getValue("fwid_cl"))
							+ "," + sqlTo(tblShtat.getValue("fwid_dol"))
							+ "," + sqlTo(i)
							+ "," + sqlTo(hday?hdayFWID:algorithm.getValue("fwid_time"))
							+ "," + sqlTo(hday?hdayFWID:algorithm.getValue("fwid_time"))
							+ "," + sqlTo(algorithm.getValue("fwid"))
							+ "," + (hday?hday:algorithm.getValue("ftype")) + ")";
			ExecuteSQL(strSQL);
		}

		strSQL = "INSERT INTO ^" + mainTableName + " (ftabn_id, fwid_dol, fday, fvalue, falg_fld)"
				+ " VALUES (" + sqlTo(tblShtat.getValue("fwid_cl"))
						+ "," + sqlTo(tblShtat.getValue("fwid_dol"))
						+ ", 32"
						+ "," + sqlTo(algorithm.getValue("fwid_time"))
						+ "," + sqlTo(algorithm.getValue("fwid")) + ")";
		ExecuteSQL(strSQL);

		//Проверим когда пришел или уволился сотрудник, 
		//если в этом месяце то заполним правильно поля
		var bdat_s = /*javaDate2Script(*/tblShtat.getValue("FBDAT")/*)*/;
		var edat_s = /*javaDate2Script(*/tblShtat.getValue("FEDAT")/*)*/;
		var bdat_r = new java.util.Date(bdat.getYear(), bdat.getMonth(), bdat.getDate());
		if(0 > bdat_r.compareTo(bdat_s))
		{
			strSQL = "UPDATE ^" + mainTableName 
				+ " SET fvalue=" + sqlTo(prinSotrFWID) 
				+ " WHERE ftabn_id=" + sqlTo(tblShtat.getValue("fwid_cl"))
				+ " AND fwid_dol=" + sqlTo(tblShtat.getValue("fwid_dol"))
				+ " AND fday<" + bdat_s.getDate();
			ExecuteSQL(strSQL);
		}
		
		var edat_r = new java.util.Date(edat.getYear(), edat.getMonth(), edat.getDate());
//		alert(edat_r);
//		alert(edat_s);
//		alert(edat_r.compareTo(edat_s));
		if(0 < edat_r.compareTo(edat_s))
		{
			strSQL = "UPDATE ^" + mainTableName 
				+ " SET fvalue=" + sqlTo(zvilSotrFWID) 
				+ " WHERE ftabn_id=" + sqlTo(tblShtat.getValue("fwid_cl"))
				+ " AND fwid_dol=" + sqlTo(tblShtat.getValue("fwid_dol"))
				+ " AND (fday>" + edat_s.getDate()
				+ " AND fday<32)";
			ExecuteSQL(strSQL);
		}
	}
	
	
}

onLoad();