include("oblns.js");
include("Objects//DpGetDat.js");

var dat1, dat2;

function listDpGrid()
{
	include("Objects//DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	with (oGrid.page())
	{
		fieldEx("fnazv","Стаття балансу|Статья бланса",40);
		fieldEx("fline","Код рядка|Код строки",8);
		fieldEx("fnsal","На початок|На начало",10,"",DP_FORMAT_SUM);
		fieldEx("fksal","На кiнець|На конец",10,"",DP_FORMAT_SUM);
	}
	oGrid.build();
}

function listLoad()
{	
	if (GetMenuMode() == "VIEW" && !(IsTable("OT_BLN_1") && IsTable("OT_BLN_2")))
	{
		alert(UR("Спочатку виконайте розрахунок звітного балансу." +
					"|Сначала произведите расчет отчётного баланса."), ICON_WARNING);
	  	return false;
	}
	this.printLabel = "otbln";	
}

function listAsk()
{
	ddopzm=GetMenuMode();
	include("objects\\DpAskEx.js");
	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "DAT1", new Date().getVarDate());
	oA.add("D", "Дата кiнця|Дата конца", "DAT2", new Date().getVarDate());
	oA.add("B", "В тисячах|В тысячах", "ISTYS", true);
	oA.add("NUM", "Знаків після коми|Знаков после запятой", "ZN", 2, 2, 0);

	oA.setRel("<=", "DAT1", "DAT2");
	oA.doAsk();
	
	return oA;
}

function listTitle()
{
	if(objTypeOf(this.objAsk) == "DpAskEx")
	{
		dat1 = new Date(this.objAsk.get("DAT1"));
		dat2 = new Date(this.objAsk.get("DAT2"));
		return "Звітний баланс за " + StrDat(dat1, "DMY") + "-" + StrDat(dat2, "DMY") +
			"|Отчетный баланс за " + StrDat(dat1, "DMY") + "-" + StrDat(dat2, "DMY");
	}
	return "Звітний баланс|Отчетный баланс";
}

function listMenuInit()
{
	with (this.dataSrc)
	{
		AddMenuItem("PROTOCOL","Протокол розрахунку|Протокол расчета");
		AddMenuItem("VSCH","Включення рахунків до рядків|Включение счетов в строки");
	}
}

function listMenuRun(ID)
{
	var par = new Object();
	par.nLine = toScrObj(this.tbl.getValue("FLINE"));
	
	switch(ID)
	{
   		case "PROTOCOL":
        	showWindow("r_protras.js", SW_NOMODAL, par);
        break;
		
		case "VSCH":
        	showWindow("l_bsch2.js", SW_NOMODAL, par);
       	break;
	}
}

function listDelAcc()
{
   return false;
}

function listMake()
{
	if (!this.objAsk) 
		return false;
	
	DropTable("OT_BLN_1");
	DropTable("OT_BLN_2");
	if(IsTable("OT_BLN_1") || IsTable("OT_BLN_2"))
	{
		alert("Невозможно выполнить расчет." +
				"\nПроверьте, возможно окно с данным расчетом уже открыто, или перезапустите систему.",
				ICON_ERROR);
		return false;
	}	

	var zm1 = (this.objAsk.get("ISTYS"))? 3 : 0;	// кол-во откидываемых разрядов в конце. Если баланс в тысячах, то 3
	var zm2 = this.objAsk.get("ZN");				// кол-во знаков после запятой

	if ((zm1<0 || zm1>9) || (zm2!=0 && zm2!=1 && zm2!=2))
	{
		alert("Неверно введены параметры округления.Допустимые значения первого параметра:0-9,второго:0-2.Принимаются значения по умолчанию:0 и 2 для первого и второго параметра соответственно.");
		zm1=0;
		zm2=2;
	}
	
	var dopzm1 = Math.pow(10, zm1);
	var dopzm2 = zm2;
	var strSql;
		
	oblns("t", this.objAsk.get("DAT1"), this.objAsk.get("DAT2"), "OT_BLN_PR");
	if(!IsTable("OT_BLN_PR"))
		return false;		
	strSql = "UPDATE OT_BLN_PR " +
			 "SET FSUM1 = " + sqlRound("FSUM1", zm2) + ","
			 	+ " FSUM2 = " + sqlRound("FSUM2", zm2) + ","
				+ " FSUM3 = " + sqlRound("FSUM3", zm2) + ","
			 	+ " FSUM4 = " + sqlRound("FSUM4", zm2) + ","
				+ " FSUM5 = " + sqlRound("FSUM5", zm2) + ","
			 	+ " FSUM6 = " + sqlRound("FSUM6", zm2)
			 	" WHERE FSC <> 0 ";
	//ExecuteSQL(strSql);


	strSQL = "SELECT A.Fact, A.Fsch, A.Fsub, A.Fsta, A.FLINE, A.FIDS, " +
             IIF("A.Fact='+'", "B.FSUM1-B.FSUM2", IIF("A.Fact='-'", 0, "B.FSUM1")) + " AS FSUM1, " +
             IIF("A.Fact='+'", 0, IIF("A.Fact='-'", "B.FSUM2-B.FSUM1", "B.FSUM2")) + " AS FSUM2, " +
             IIF("A.Fact='+'", "B.FSUM3-B.FSUM4", IIF("A.Fact='-'", 0, "B.FSUM3")) + " AS FSUM3, " +
             IIF("A.Fact='+'", 0, IIF("A.Fact='-'", "B.FSUM4-B.FSUM3", "B.FSUM4")) + " AS FSUM4, " +
			 IIF("A.Fact='+' OR A.Fact='#'", 1, 0) + " AS Fkoef1, " +
			 IIF("A.FACT='!'", -1, 0) + " AS Fkoef3, " +
			 IIF("A.Fact='-' OR A.Fact='='", 1, 0) + " AS Fkoef2, " +
			 IIF ("A.FACT='?'", -1, 0) + " AS Fkoef4 " +
			 "INTO OT_BLN_1 " +
			 "FROM ^BALANS_U A , OT_BLN_PR B " +
			 "WHERE A.Fsch=B.Fsc AND A.Fsub=B.Fsu AND A.Fsta=B.Fst";
	ExecuteSQL(strSQL);
	
	strSQL = "SELECT A.FIDS AS FIDS,A.FLINE AS FLINE, " +
			sqlRound("SUM(A.FSUM1*A.Fkoef1+A.FSUM2*A.Fkoef2+A.FSUM2*A.FKOEF3+A.FSUM1*A.FKOEF4)/"+sqlTo(dopzm1), dopzm2)+" AS FNSAL, " +
			sqlRound("SUM(A.FSUM3*A.Fkoef1+A.FSUM4*A.Fkoef2+A.FSUM4*A.FKOEF3+A.FSUM3*A.FKOEF4)/"+sqlTo(dopzm1), dopzm2)+" AS FKSAL, " +
			"B.FNAZV1 AS FNAZV " +
			"INTO OT_BLN_2 FROM OT_BLN_1 A,^BALANS B " +
			"WHERE B.FLINE=A.FLINE GROUP BY A.FLINE,A.FIDS,B.FNAZV1"
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO OT_BLN_2(FNAZV,FLINE,FIDS) " +
		     "SELECT A.FNAZV1 AS FNAZV,A.FLINE AS FLINE,A.FWID AS FIDS " +
           	 "FROM ^BALANS A WHERE NOT EXISTS " +
           	 "(SELECT * FROM OT_BLN_1 B WHERE A.FLINE=B.FLINE)";
	ExecuteSQL(strSQL);

	strSQL = "ALTER TABLE OT_BLN_2 ADD FWID " + SqlType("COUNTER");
	ExecuteSQL(strSQL);
	strSQL="CREATE INDEX fline ON OT_BLN_2(Fline)";
	ExecuteSQL(strSQL);
}

function listSrc()
{
	this.qrySet("From", "OT_BLN_2", "Order", new Array("fline"));
}

function getTblH()
{
	var h = new Object();
	var sysname = getSysName();
	sysname = sysname.substring(sysname.lastIndexOf('|') + 1, sysname.length);
	h.FD1 = getParWithDef("DAT1", sysname, d00);	
	h.FD2 = getParWithDef("DAT2", sysname, d00);
	h.FISTYS = getParWithDef("ISTYS", sysname, d00);
	return h;
}

include("sys\\DpList.js");