//Печатаем выделенные отпуска (DataSource().sqlSelected)
//Расчет отпусков с учетом предварительных начислений и удержаний
//Этот расчет для отпускных, для которых на каждый месяц отпуска заводится свой приказ

include("koef_otp.js");
include("objects\\DpCl.js");
include("objects\\DpClcl.js");
include("prik\\calculate\\r_otpall.js");
include("prik\\calculate\\r_premblot.js");
include("objects\\DpDefVed.js");
include("servis\\date.js");
include("objects\\dpCalendar.js");
include("objects\\DpShtat.js");
include("objects\\DpShifPZ.js");
var tbl_PRK_O, tbl_DTPRKB, tbl_PRK_FMPL, tbl_WT_LBL_O, tbl_WT_LBL_B, tbl_SRED_INI, tbl_CL_KALEN, tbl_TIME_KL;

function l_ras_otp()
{
	CreateTable("OTP_PRT", "OTP_PRT", "*");
	var tbl_o = OpenTable("s","TBL_OTP_PRT");

	for( tbl_o.MoveFirst(); !tbl_o.IsEOF(); tbl_o.MoveNext() )
	{
		var mFtabn = tbl_o.getValue("FTABN_ID");
		var mFbdat = tbl_o.getValue("FBDAT");
		var mFedat = tbl_o.getValue("FEDAT");
		tbl_PRK_O = OpenTable("s","SELECT * from TBL_OTP_PRT"
				+" WHERE FTABN_ID = "+mFtabn
				+" AND FBDAT = "+sqlTo(mFbdat)
				+" AND FEDAT = "+sqlTo(mFedat));
		r_otp_pr_sel(mFtabn, mFbdat, mFedat);
	}
	tbl_o.close();
}

function r_otp_pr_sel(mFtabn, mFbdat, mFedat)
{ 
	var eDatWh = d00;
	var DefVed = new DpDefVed();
	var D1,D2;
	var mFvp,mFmn,pdt,db,db1,dt;
	var ssum;
	DefVed.begin("",ru("расчет отпускных","розрахунок відпускних"));

	//установ. даты на начало и конец расчетного месяца
	var data = new Date(mFbdat);
	D1=new Date (data.getFullYear(),data.getMonth(),1); 
	//D1=D1.getVarDate();
	D2=new Date (data.getFullYear(),data.getMonth()+1,0); 
	//D2=D2.getVarDate();

	var bDatOtp = new Date(mFbdat);//начало отпуска
	var eDatOtp = new Date(mFedat);//конец отпуска
	var eDat,bDat;
	
	var obj_PRK_B = new Object(); 
	obj_PRK_B.vid_sred = 1;
	var oCl = new DpCl("");
	codpers  = getPar("CODPERS");

	while (!tbl_PRK_O.IsEOF())
	{
		mFtabn = tbl_PRK_O.getValue("Ftabn_id");
		mFbdat = tbl_PRK_O.getValue("Fbdat");
		mFedat = tbl_PRK_O.getValue("Fedat");
		mFdatotp = tbl_PRK_O.getValue("Fdat_otp");
		obj_PRK_B.rmode = "K3";
		obj_PRK_B.plusfmp = true;
		obj_PRK_B.Ftabn_id = tbl_PRK_O.getValue("Ftabn_id");
		//obj_PRK_B.Fsht_id = tbl_PRK_O.getValue("Fsht_id");
		obj_PRK_B.Fdat_bol = tbl_PRK_O.getValue("Fdat_otp");
		obj_PRK_B.Fsum = tbl_PRK_O.getValue("Fsum");
		obj_PRK_B.mFkoef_gp = (tbl_PRK_O.getValue("Fkoef")==0?1:tbl_PRK_O.getValue("Fkoef"))
		obj_PRK_B.Fwid_wp = tbl_PRK_O.getValue("Fwid_wp");
		var fis_prkf = get_cnst("prkf", D1)		
		if (fis_prkf==1){		
      		obj_PRK_B.pomotp  = "POMOTP";
		}			
		oCl.setClcl(codpers);      
		oCl.setFWID(mFtabn);
		if ((new Date(tbl_PRK_O.getValue("Fbdat"))>=D1)&&(new Date(tbl_PRK_O.getValue("Fbdat"))<=D2)&&(new Date(tbl_PRK_O.getValue("Fedat"))>=D1)&&(new Date(tbl_PRK_O.getValue("Fedat"))<=D2))
		{
			mFvp = 0;
			mFmn = d00;
		}
		else
		{
			mFvp = 2;
			db = new Date(tbl_PRK_O.getValue("Fbdat"));
			db = new Date(db.getFullYear(),db.getMonth(),1);
			db = db.getVarDate();
			mFmn = db;
		}

		// вычислить первое число отпускного месяца  
		db = new Date(mFdatotp);
		db = new Date(db.getFullYear(),db.getMonth(),1);
		pdt = db.getVarDate();

		Ok = r_otpall(mFbdat, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, tbl_TIME_KL, tbl_CL_KALEN);   
	  
		if (Ok)
		{
			//tbl_OTP_PRT.AddNew();
			var m = new Object();
			m.FBDAT = tbl_PRK_O.getValue("FBDAT")
			m.FEDAT = tbl_PRK_O.getValue("FEDAT")
			m.Ftabn = tbl_PRK_O.getValue("Ftabn_id");
/*для ниже описанных случаев месяцы без начислений необходимо отключать из статистики отпускных иначе будет расхождение в ЛС и форме печати
			//в приказе компенсация за отпуск могут быть месяца с нулевыми суммами
			//соответственно дни этих месяцев не должны учитываться при расчёте средней оплаты 
			//m.Fsredn = obj_PRK_B.Fsredn;
			var sF = "Fsumfakt";
			var kol = 0;
			for(var i in obj_PRK_B)
			{
				if(i.indexOf(sF)!=-1 && obj_PRK_B[i]!=0)
				{
					kol += eval("obj_PRK_B.Fkoldn"+i.substr(sF.length))	
				}
			}
			//почему бы при нулевом кол-ве дней не выводить среднюю из поля объекта
			m.Fsredn = kol==0?obj_PRK_B.Fsredn:round(obj_PRK_B.Fsumtot/kol,2);*/
			m.Fsredn = obj_PRK_B.Fsredn;
			m.FSUMOTP = obj_PRK_B.ssum;  
			m.FDNOTP = obj_PRK_B.Fsum;  
			var objdat_otp = new Date(tbl_PRK_O.getValue("Fbdat"));
			m.FMSOTP = String(objdat_otp.getMonth()+1)+"/"+String(objdat_otp.getFullYear());  

			m.FSTMONTH1 = obj_PRK_B.Fstmonth1;
			m.FSTMONTH2 = obj_PRK_B.Fstmonth2;
			m.FSTMONTH3 = obj_PRK_B.Fstmonth3;
			m.FSTMONTH4 = obj_PRK_B.Fstmonth4;
			m.FSTMONTH5 = obj_PRK_B.Fstmonth5;
			m.FSTMONTH6 = obj_PRK_B.Fstmonth6;
			m.FSTMONTH7 = obj_PRK_B.Fstmonth7;
			m.FSTMONTH8 = obj_PRK_B.Fstmonth8;
			m.FSTMONTH9 = obj_PRK_B.Fstmonth9;
			m.FSTMONTH10 = obj_PRK_B.Fstmonth10;
			m.FSTMONTH11 = obj_PRK_B.Fstmonth11;
			m.FSTMONTH12 = obj_PRK_B.Fstmonth12;

			m.FSUMFAKT1 = obj_PRK_B.Fsumfakt1;
			m.FSUMFAKT2 = obj_PRK_B.Fsumfakt2;
			m.FSUMFAKT3 = obj_PRK_B.Fsumfakt3;
			m.FSUMFAKT4 = obj_PRK_B.Fsumfakt4;
			m.FSUMFAKT5 = obj_PRK_B.Fsumfakt5;
			m.FSUMFAKT6 = obj_PRK_B.Fsumfakt6;
			m.FSUMFAKT7 = obj_PRK_B.Fsumfakt7;
			m.FSUMFAKT8 = obj_PRK_B.Fsumfakt8;
			m.FSUMFAKT9 = obj_PRK_B.Fsumfakt9;
			m.FSUMFAKT10 = obj_PRK_B.Fsumfakt10;
			m.FSUMFAKT11 = obj_PRK_B.Fsumfakt11;
			m.FSUMFAKT12 = obj_PRK_B.Fsumfakt12;

			/*m.FKOLDN1 = m.FSUMFAKT1==0?0:obj_PRK_B.Fkoldn1;
			m.FKOLDN2 = m.FSUMFAKT2==0?0:obj_PRK_B.Fkoldn2;
			m.FKOLDN3 = m.FSUMFAKT3==0?0:obj_PRK_B.Fkoldn3;
			m.FKOLDN4 = m.FSUMFAKT4==0?0:obj_PRK_B.Fkoldn4;
			m.FKOLDN5 = m.FSUMFAKT5==0?0:obj_PRK_B.Fkoldn5;
			m.FKOLDN6 = m.FSUMFAKT6==0?0:obj_PRK_B.Fkoldn6;
			m.FKOLDN7 = m.FSUMFAKT7==0?0:obj_PRK_B.Fkoldn7;
			m.FKOLDN8 = m.FSUMFAKT8==0?0:obj_PRK_B.Fkoldn8;
			m.FKOLDN9 = m.FSUMFAKT9==0?0:obj_PRK_B.Fkoldn9;
			m.FKOLDN10 = m.FSUMFAKT10==0?0:obj_PRK_B.Fkoldn10;
			m.FKOLDN11 = m.FSUMFAKT11==0?0:obj_PRK_B.Fkoldn11;
			m.FKOLDN12 = m.FSUMFAKT12==0?0:obj_PRK_B.Fkoldn12;*/
			m.FKOLDN1 = obj_PRK_B.Fkoldn1;
			m.FKOLDN2 = obj_PRK_B.Fkoldn2;
			m.FKOLDN3 = obj_PRK_B.Fkoldn3;
			m.FKOLDN4 = obj_PRK_B.Fkoldn4;
			m.FKOLDN5 = obj_PRK_B.Fkoldn5;
			m.FKOLDN6 = obj_PRK_B.Fkoldn6;
			m.FKOLDN7 = obj_PRK_B.Fkoldn7;
			m.FKOLDN8 = obj_PRK_B.Fkoldn8;
			m.FKOLDN9 = obj_PRK_B.Fkoldn9;
			m.FKOLDN10 = obj_PRK_B.Fkoldn10;
			m.FKOLDN11 = obj_PRK_B.Fkoldn11;
			m.FKOLDN12 = obj_PRK_B.Fkoldn12;

			m.FSUMFAKTT = obj_PRK_B.Fsumtot;
			m.FKOLMES = obj_PRK_B.Fmestot;
			m.FTT = '';
			UpdateTable("OTP_PRT", m, true);
		}
		tbl_PRK_O.MoveNext();
	}//while

	//Добавим в tbl_OTP_PRT записи для разбивки по месяцам
	tbl_PRK_O.MoveFirst();
	var bDat = new Date(tbl_PRK_O.getValue("FBDAT"));//дата начала отпуска
	var eDat = new Date(tbl_PRK_O.getValue("FEDAT"));//дата конца отпуска
	var vopl = tbl_PRK_O.getValue("FVOPL");
	var mFcalnum = tbl_PRK_O.getValue("FCALNUM");
	
	var bmDat = bDat;//первое число сегмента
	var emDat = bDat;//последнее число сегмента
	
	//ставим флаг того, что заходим не первый раз
	//для того, что если отпуск не переходящий, 
	//то записи добавлять не будем
	var isZav = 0;
	var days;
	var oCalend = new dpCalendar();
	oCalend.setCod(mFcalnum);
	
	//debug();	
	while(eDat>emDat)
	{
		//ставим последнее число месяца сегмента
		emDat = new Date(bmDat.getFullYear(),bmDat.getMonth()+1,0);
		//если месяц emDat и месяц конца отпуска совпадают, 
		//то emDat ставим не последним числом, а концом отпуска
		if(emDat.getMonth() == eDat.getMonth() && isZav != 0)
		{
			emDat = eDat;
			days = oCalend.getCalDays("В|Р", bmDat.getVarDate(), emDat.getVarDate());
			//tbl_OTP_PRT.AddNew();
			var m = new Object();
			m.FTABN = mFtabn;
			m.FBDAT = bmDat.getVarDate();
			m.FEDAT = emDat.getVarDate();
			m.FTT = 'MN';
			m.FDNOTP = days;
			m.FSUMOTP = round(days*obj_PRK_B.Fsredn,2);
			UpdateTable("OTP_PRT", m, true);
		}
		else 
			if(isZav!=0)
			{
				days = oCalend.getCalDays("В|Р", bmDat.getVarDate(), emDat.getVarDate());
				//tbl_OTP_PRT.AddNew();
				var m = new Object();
				m.FTABN = mFtabn;
				m.FBDAT = bmDat.getVarDate();
				m.FEDAT = emDat.getVarDate();
				m.FTT = 'MN';
				m.FDNOTP = days;
				m.FSUMOTP = round(days*obj_PRK_B.Fsredn,2);
				UpdateTable("OTP_PRT", m, true);
				bmDat = new Date(goDay(emDat, 1));
			}
		isZav++;
	}
	tbl_PRK_O.Close();
	DefVed.end();
	return true;
}