// передаются 
// res_mon - місяць отримання результатів

include("objects/DpDefVed.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");
include("sys/udfs.js");
include("get_cnst.js");

var sTitle = UR("Рознесення по рахунках з 1000 грн.", "Разноска по счетам с 1000 грн.");
var sFtabn = "FTABN_ID";
var is_izmfond;
var VSP_table;
var sum_ogr;
var DD1;
var DD2;  	
var D1;
var s1;

var nPos = 1;
var maxPos = 50;
var sTxt = sTitle +"...";
var baseOrg;

function listLoad()
{   	
    list.title = sTitle;
    
    var objAsk = new DpGetDat("d");
	if(objAsk.escape)
		return false;

	var res_moni = new Date(objAsk.dat1.getYear()+1900, objAsk.dat1.getMonth(), 1);
		
   	if(!r_razn2b(res_moni))
   		return false;
    var par = new Object();
    par.objAsk = objAsk;
    par.menuMode = "RAZN2B";
    showWindow("l_rezraz.js",SW_NOMODAL,par);
    return false;
}

function r_razn2b (res_mon)
{
   	var oSnap = getSnap("SELECT Fwid FROM ^stru_org WHERE Fwid_par=0");
   	if(oSnap!=null)
   		baseOrg = oSnap[0];
   	else
   	{
   		alert(ru("Невозможно найти корневое подразделение!",
   				"Неможливо знайти корневий пірозділ!"));
   		return false;
   	}
   	var DefVed = new DpDefVed();
   	var monthtxt1;
   	var _rez_dt = res_mon;
  	var VSP11_table, SCHR_table, VSP5_table, Shtat_table, Lic_table, RAZN_table;
   	var VSP12_table, VSP14_table, VSP15_table, VSP16_table, VSP17_table, VSP19_table, VSP20_table, VSP21_table;
    
   	// достаем цифры к названию файла   	
  	monthtxt1 = format("yyyymm", res_mon);
  	
   	// Проверяем существует ли у нас таблица "svzp" + monthtxt1 по шаблону "svzp"
   	tblOut  = "zrp_" + "svzp" + monthtxt1;
   	if(!IsTableEx("zrp_res", tblOut))
   	{
       	alert(ru("Внимание! Перед началом данного рачета проведите\n расчет начислений за выбранный вами месяц"
     			,"Увага! Перед початком даного розрахунку проведіть\n розрахунок нарахувань за вибраний вами місяць"));
       	return false;
   	}
   	
   	//делаем проверку на коректность категорий в ШР
    include("servis/zrp.js");
    if(!isCorectKat(false,res_mon))
    	return false;

  	setProgressRange(0, maxPos);  
  	setProgressPos(nPos++, sTxt);
  	
   	DefVed.begin("", ru("Проверка различий между таблицами","Перевірка розбіжностей між таблицями"));
  
   	CreateTable("VSPZ", "VSP", "*");  	
  	CreateTable("VSP5", "VSP_N", "*");
  	CreateTable("schr"+monthtxt1, "SCHR", "*");
   	setProgressPos(nPos++, sTxt);
	   
   	var DDD = d00;

    // дата начала
  	D1 = new Date(res_mon.getFullYear(),res_mon.getMonth(),1);

    // дата конца
   	var D2 = new Date(lastDayMonth(D1));

   	DD1 = D1.getVarDate();
   	DD2 = D2.getVarDate();

    mdt1 = sqlTo(D1);
	mdt2 = sqlTo(D2);

	//var sWhereDat = "((FBDAT <= " + sqlTo(DD1) + " AND FEDAT >= " + sqlTo(DD2) +")" 
    //           	+" OR (FBDAT >= " + sqlTo(DD1) + " AND FBDAT <= " + sqlTo(DD2) +")" 
    //          	+" OR (FEDAT >= " + sqlTo(DD1) + " AND FEDAT <= " + sqlTo(DD2) +"))";
   	    
   	//**********************************************************
   	//* шаг 1 - проставить коды подр. и МОЛ для записей из SVZP
   	//**********************************************************
   	WAIT(ru("шаг 1","крок 1"));
	
   	for (var i=1;i<=3;i++)	//& отдельные проходы по текущим, прошлым и будущим записям   	
   	{   		
   		ExecuteSQL("DELETE from VSPZ");
   	
   		//***************************
		//20.07.07  Yana
		
     	var sWhere = "";
     	if (i==1)
     	{        	
        	sWhere = " WHERE (zp.Fvp=0 OR (zp.Fvp=2 AND zp.Fmn <"+sqlTo(D1)+"))";        	
     	}
     	else if (i==2)
     	{            
            sWhere = " WHERE (zp.Fvp=2 AND zp.Fmn >"+sqlTo(D1)+")";            
       	}
       	else if (i==3)
       	{       		
            sWhere = " WHERE  (zp.Fvp=1 AND zp.Fmn <"+sqlTo(D1)+")";            
		}
		
	   	DropTable("TZWSVOD");	
		strSQL = "SELECT zp.Flsfid, zp.Ftabn_id as Ftabn, zp.Fwid_wp, zp.Fmn, zp.Fvp, zp.Fsum, zp.Fshpz "
				//+ "0 as Fwid_kat, 0 as Fwid_dol, 0 as Fwid_org, 0 as Flv1, 0 as Flv2, 0 as Flv3, "
				//+ " 0 as Fkod_kat,"+sqlFalse+" as Finval "
				+ " INTO TZWSVOD FROM "
	     		+ " ^SVZP"+ monthtxt1+" zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid"
    	 		+ sWhere;
		ExecuteSQL(strSQL);
		
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_kat "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_dol "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_org "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Forg0 "+sqlType("INT"));
		//ExecuteSQL("ALTER TABLE TZWSVOD ADD Flv1 "+sqlType("INT"));
		//ExecuteSQL("ALTER TABLE TZWSVOD ADD Flv2 "+sqlType("INT"));
		//ExecuteSQL("ALTER TABLE TZWSVOD ADD Flv3 "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fkod_kat "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Finval "+sqlType("BIT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fbdat_per "+sqlType("DATE"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fedat_per "+sqlType("DATE"));		
		ExecuteSQL("UPDATE TZWSVOD SET Fwid_kat=0, Fwid_dol=0, "
					+" Fwid_org=0, Forg0=0, Fkod_kat=0, Finval="+sqlFalse+", Fbdat_per="+sqlTo(d00obj)+", Fedat_per="+sqlTo(d00obj))

		//текущий месяц проставляем везде, кроме прошлых сумм
		//будущие суммы и юудущие суммы с минусом ставим на текущий месяц, чтобы они не разошлись по разным Fwid_wp			
		ExecuteSQL("update TZWSVOD set Fbdat_per="+sqlTo(D1)+" where not( Fvp=2 and Fmn<"+sqlTo(D1)+")");
		ExecuteSQL("update TZWSVOD set Fedat_per="+sqlTo(D2)+" where not( Fvp=2 and Fmn<"+sqlTo(D1)+")");
		
		ExecuteSQL("update TZWSVOD set Fbdat_per=Fmn where (Fvp=2 and Fmn<"+sqlTo(D1)+")");
		var ts = OpenTable("select distinct Fmn from TZWSVOD where (Fvp=2 and Fmn<"+sqlTo(D1)+") group by Fmn order by Fmn");
		if (!ts.IsEmpty()){
			while (!ts.IsEOF()){
				ExecuteSQL("update TZWSVOD set Fedat_per="+sqlTo(new Date(lastDayMonth(new Date(ts.getValue("Fmn")))))+" where (Fvp=2 and Fmn="+sqlTo(new Date(ts.getValue("Fmn")))+")");
				ts.MoveNext();
			}
		}
		ts.close();

		//прописать для разных Fmn и Fvp правильные на тот период даты, чтобы найти Fwid_wp		
		var ts = OpenTable("select distinct Fbdat_per,Fedat_per,Fmn,Fvp from TZWSVOD group by Fmn,Fvp order by Fbdat_per");
		if (!ts.IsEmpty()){
			while (!ts.IsEOF()){
				tmdt1 = sqlTo(new Date(ts.getValue("Fbdat_per")))
				tmdt2 = sqlTo(new Date(ts.getValue("Fbdat_per")))				
				//20.07.07  Yana  сначала нужно найти катег.на код ШР.Если не найден, тогда на таб.N
				ExecuteSQL("update TZWSVOD set fwid_wp=(select max(Fwid) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     +  "AND ((wp.FBDAT <= " + tmdt1 + " AND wp.FEDAT >= " + tmdt2 +") " 
                     + " OR (wp.FBDAT >= " + tmdt1 + " AND wp.FBDAT <= " + tmdt2 +") " 
                     + " OR (wp.FEDAT >= " + tmdt1 + " AND wp.FEDAT <= " + tmdt2 +"))  ) where (TZWSVOD.Fwid_wp=0 or TZWSVOD.Fwid_wp is null) "
                     + " and TZWSVOD.Fvp="+sqlTo(ts.getValue("Fvp"))+" and TZWSVOD.Fmn="+sqlTo(ts.getValue("Fmn")) ) 
				ts.MoveNext();
			}
		}
		ts.close();
		   			
		strSQL = "update TZWSVOD set fwid_wp=0 where Fwid_wp is null";
		ExecuteSQL(strSQL);

		strSQL = "update TZWSVOD set fwid_wp=(select max(Fwid) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn)"+
					 " where (TZWSVOD.Fwid_wp=0)"
		ExecuteSQL(strSQL);   				 
   					  	
		strSQL = "update TZWSVOD set fwid_kat=(select Fwid_kat from ^work_pers where Fwid=TZWSVOD.Fwid_wp) where Fwid_wp<>0 and EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)";
		ExecuteSQL(strSQL);   

		strSQL = "update TZWSVOD set fwid_kat=(select max(Fwid_kat) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     + " AND wp.FBDAT <= " + mdt2 + " AND wp.FEDAT >= " + mdt1 +"  )  where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" 
		ExecuteSQL(strSQL);   				 

		ExecuteSQL("update TZWSVOD set fkod_kat=(SELECT max(Fcod) "
			+ " FROM ^clrelclcl where TZWSVOD.Fwid_kat=Fwid_cl)")
  
   			//20.07.07  Yana  сначала нужно найти код должности на код ШР.Если не найден, тогда на таб.N
   		ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT wp.Fwid_dol FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Fwid_wp = wp.Fwid)"
			+"  where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );
   
   		ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Ftabn = wp.Fwid_cl"
			+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
            + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
            + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))"
			+" where NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );        	           
   
   			//20.07.07  Yana  найти код подразделения
   		strSQL = "update TZWSVOD set fwid_org=(select Fwid_org from ^stru_dol where Fwid=TZWSVOD.Fwid_dol)";
   		ExecuteSQL(strSQL);
      
   		//strSQL = "update TZWSVOD set flv1=(select Flv1 from ^stru_org where Fwid=TZWSVOD.Fwid_org)";
   		//ExecuteSQL(strSQL);   
				
   		//strSQL = "update TZWSVOD set flv2=(select Flv2 from ^stru_org where Fwid=TZWSVOD.Fwid_org)";
   		//ExecuteSQL(strSQL);   

   		//strSQL = "update TZWSVOD set flv3=(select Flv3 from ^stru_org where Fwid=TZWSVOD.Fwid_org)";
   		//ExecuteSQL(strSQL);   

   			//14.07.07  Yana  сначала нужно найти инвал.на код ШР.Если не найден, тогда на таб.N
	   	strSQL = "update TZWSVOD set finval=(select "+First(Convert("finval", "INT"))+" from ^work_pers where Fwid=TZWSVOD.Fwid_wp) where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)";
		ExecuteSQL(strSQL);   

   		strSQL = "update TZWSVOD set finval=(select "+First(Convert("wp.finval", "INT"))+" from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     +  "AND ((wp.FBDAT <= " + sqlTo(D1) + " AND wp.FEDAT >= " + sqlTo(D2) +") " 
                     + "OR (wp.FBDAT >= " + sqlTo(D1) + " AND wp.FBDAT <= " + sqlTo(D2) +") " 
                     + "OR (wp.FEDAT >= " + sqlTo(D1) + " AND wp.FEDAT <= " + sqlTo(D2) +"))  ) where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" 
		ExecuteSQL(strSQL);   				 

        var sSql = "INSERT INTO VSPZ(FLSFID, FMN, FSUM, FVP, FSHPZ"
        			+", FWID_WP, FKOD_KAT, FINVAL, FWID_ORG, Ftabn) "	
        			+" SELECT FLSFID, FMN, FSUM, FVP, FSHPZ, FWID_WP,fkod_kat, FINVAL, "
        			+" FWID_ORG, Ftabn from TZWSVOD";     	
		ExecuteSQL(sSql);
		//}	   		
   		//***************************

		/*   		
   		var fwid_wp = "(select max(pers.Fwid) from ^work_pers pers "
     				+" where pers.Fwid_cl=z.Ftabn_id and "+ sWhereDat +")";
     	//надо переделывать сначала на запись ШР, а потом на таб.N			
     	var fkod_kat = "(select max(pers.Fwid_kat) from ^WORK_PERS pers "
            		+" where pers.Fwid_cl=z.Ftabn_id and "+ sWhereDat +")";
     	//надо переделывать сначала на запись ШР, а потом на таб.N            		
        var finval = "(select max(pers.Finval) from ^WORK_PERS pers "
            		+" where pers.Fwid_cl=z.Ftabn_id and "+ sWhereDat +")";
        var sFlvSel = "^stru_org org "
            		+" inner join ^stru_dol dol on dol.fwid_org=org.fwid "
            		+" where dol.fwid =(select max(pers.fwid_dol)"
            			+" from ^work_pers pers "
            			+" where pers.fwid_cl=z.Ftabn_id and "+ sWhereDat +")";
        //var flv1 = "(select max(org.Flv1) from "+ sFlvSel +")";
        //var flv2 = "(select max(org.Flv2) from "+ sFlvSel +")";
        //var flv3 = "(select max(org.Flv3) from "+ sFlvSel +")";
        //var flv4 = "(select max(org.Flv4) from "+ sFlvSel +")";
        
        //var sSql = "INSERT INTO VSPZ(FLSFID, FMN, FSUM, FVP, FSHPZ"
        //			+", FWID_WP, FKOD_KAT, FINVAL, Flv1, Flv2, Flv3) "	
        //		+" SELECT FLSFID, FMN, FSUM, FVP, FSHPZ, "+fwid_wp+" as FWID_WP "
        //			+","+fkod_kat+" as FKOD_KAT,"+finval+" as FINVAL "
        //			+","+flv1+" as Flv1,"+flv2+" as Flv2,"+flv3+" as Flv3 ";     	
        var sSql = "INSERT INTO VSPZ(FLSFID, FMN, FSUM, FVP, FSHPZ"
        			+", FWID_WP, FKOD_KAT, FINVAL, FWID_ORG, Ftabn) "	
        		+" SELECT FLSFID, FMN, FSUM, FVP, FSHPZ, FWID_WP "
        			+","+fkod_kat+" as FKOD_KAT,"+finval+" as FINVAL "
        			+", FWID_ORG, Ftabn_id ";     	

     	var sWhere = "";
     	if (i==1)
     	{        	
        	sWhere = " WHERE Fvp=0 OR (Fvp=2 AND Fmn <"+sqlTo(DD1)+")";        	
     	}
     	else if (i==2)
     	{            
            sWhere = " WHERE Fvp=2 AND Fmn >"+sqlTo(DD1);            
       	}
       	else if (i==3)
       	{       		
            sWhere = " WHERE  Fvp=1 AND Fmn <"+sqlTo(DD1);            
		}
		
		ExecuteSQL(sSql +" FROM ^SVZP"+ monthtxt1 +" z "+ sWhere);
		*/
		
		
        if(IsTableEx("zrp_res", "zrp_svpf"+ monthtxt1)==true)
        {
        	//**********
		   	DropTable("TZWSVODF");	
			strSQL = "SELECT zp.Flsfid, zp.Ftabn_id as Ftabn, zp.Fwid_wp, zp.Fmn, zp.Fvp, zp.Fsum,"
				+ " zp.Fshpz INTO TZWSVODF"
	     		+ " FROM ^SVPF"+ monthtxt1+" as zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid"
    	 		+ sWhere;
			ExecuteSQL(strSQL);
			ExecuteSQL("ALTER TABLE TZWSVODF ADD Fwid_kat "+sqlType("INT"));
			ExecuteSQL("ALTER TABLE TZWSVODF ADD Fwid_dol "+sqlType("INT"));
			ExecuteSQL("ALTER TABLE TZWSVODF ADD Fwid_org "+sqlType("LONG"));
			//ExecuteSQL("ALTER TABLE TZWSVODF ADD Flv1 "+sqlType("INT"));
			//ExecuteSQL("ALTER TABLE TZWSVODF ADD Flv2 "+sqlType("INT"));
			//ExecuteSQL("ALTER TABLE TZWSVODF ADD Flv3 "+sqlType("INT"));
			ExecuteSQL("ALTER TABLE TZWSVODF ADD Fkod_kat "+sqlType("INT"));
			ExecuteSQL("ALTER TABLE TZWSVODF ADD Finval "+sqlType("BIT"));
			ExecuteSQL("UPDATE TZWSVODF SET Fwid_kat=0, Fwid_dol=0, Fwid_org=0, "
					+" Fkod_kat=0, Finval="+sqlFalse)

   			//20.07.07  Yana  сначала нужно найти катег.на код ШР.Если не найден, тогда на таб.N
  	
	   		strSQL = "update TZWSVODF set fwid_kat=(select Fwid_kat from ^work_pers where Fwid=TZWSVODF.Fwid_wp) where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)";
   			ExecuteSQL(strSQL);   

   			strSQL = "update TZWSVODF set fwid_kat=(select max(Fwid_kat) from ^work_pers as wp where wp.Fwid_cl=TZWSVODF.Ftabn "
                     +  "AND ((wp.FBDAT <= " + mdt1 + " AND wp.FEDAT >= " + mdt2 +") " 
                     + "OR (wp.FBDAT >= " + mdt1 + " AND wp.FBDAT <= " + mdt2 +") " 
                     + "OR (wp.FEDAT >= " + mdt1 + " AND wp.FEDAT <= " + mdt2 +"))  ) where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)" 
   			ExecuteSQL(strSQL);   				 

			ExecuteSQL("update TZWSVODF set fkod_kat=(SELECT Fcod "
			+ " FROM ^clrelclcl where TZWSVODF.Fwid_kat=Fwid_cl)")
  
   			//20.07.07  Yana  сначала нужно найти код должности на код ШР.Если не найден, тогда на таб.N
   			ExecuteSQL("UPDATE TZWSVODF SET Fwid_dol="
   			+ " (SELECT wp.Fwid_dol FROM ^work_pers wp"
   			+ " WHERE TZWSVODF.Fwid_wp = wp.Fwid)"
			+"  where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)" );
   
   			ExecuteSQL("UPDATE TZWSVODF SET Fwid_dol="
   			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
   			+ " WHERE TZWSVODF.Ftabn = wp.Fwid_cl"
			+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
            + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
            + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))"
			+" where NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)" );        	           
   
	   		//20.07.07  Yana  найти код подразделения
   			strSQL = "update TZWSVODF set fwid_org=(select Fwid_org from ^stru_dol where Fwid=TZWSVODF.Fwid_dol)";
   			ExecuteSQL(strSQL);
      
   			//strSQL = "update TZWSVODF set flv1=(select Flv1 from ^stru_org where Fwid=TZWSVODF.Fwid_org)";
   			//ExecuteSQL(strSQL);   
				
   			//strSQL = "update TZWSVODF set flv2=(select Flv2 from ^stru_org where Fwid=TZWSVODF.Fwid_org)";
   			//ExecuteSQL(strSQL);   

   			//strSQL = "update TZWSVODF set flv3=(select Flv3 from ^stru_org where Fwid=TZWSVODF.Fwid_org)";
   			//ExecuteSQL(strSQL);   

   			//14.07.07  Yana  сначала нужно найти инвал.на код ШР.Если не найден, тогда на таб.N
	    	strSQL = "update TZWSVODF set finval=(select "+First(Convert("finval", "INT"))+" from ^work_pers where Fwid=TZWSVODF.Fwid_wp) where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)";
   			ExecuteSQL(strSQL);   

   			strSQL = "update TZWSVODF set finval=(select "+First(Convert("wp.finval", "INT"))+" from ^work_pers as wp where wp.Fwid_cl=TZWSVODF.Ftabn "
                     +  "AND ((wp.FBDAT <= " + sqlTo(D1) + " AND wp.FEDAT >= " + sqlTo(D2) +") " 
                     + "OR (wp.FBDAT >= " + sqlTo(D1) + " AND wp.FBDAT <= " + sqlTo(D2) +") " 
                     + "OR (wp.FEDAT >= " + sqlTo(D1) + " AND wp.FEDAT <= " + sqlTo(D2) +"))  ) where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVODF.Fwid_wp)" 
   			ExecuteSQL(strSQL);   				 

        	var sSql = "INSERT INTO VSPZ(FLSFID, FMN, FSUM, FVP, FSHPZ"
        			+", FWID_WP, FKOD_KAT, FINVAL, Fwid_org, Ftabn) "	
        			+" SELECT FLSFID, FMN, FSUM, FVP, FSHPZ, FWID_WP,fkod_kat, FINVAL, "
        			+" Fwid_org, Ftabn from TZWSVODF";     	
   			ExecuteSQL(sSql);   		
        	
        	//**********
        	//ExecuteSQL(sSql +" FROM ^SVPF"+ monthtxt1 +" z "+ sWhere);
        }
     	setProgressPos(nPos++, sTxt);
     	
     	//ExecuteSQL("UPDATE vspz SET FLV1 = 0, FLV2 = 0, FLV3 = 0");
     	ExecuteSQL("UPDATE VSPZ SET Finval="+SqlFalse+" WHERE Finval IS NULL");
     	setProgressPos(nPos++, sTxt);
     	
     	WAIT(ru("шаг 0","крок 0"));		
		     	
     	VSP_table = getSnap("select Fwid_wp from VSPZ");    	
     	
     	if (VSP_table!=null)
     	{
        	/*
        	sSql = "UPDATE ^VSPZ z SET "
        		+" z.Finval=(select distinct cl.Finval from ^CL cl "
        			+" left join ^WORK_PERS pers on cl.fwid=pers.Fwid_kat "
        			+" where pers.Fwid=z.Fwid_wp and "+ sWhereDat +")"
                +",z.Fkod_kat=(select distinct pers.Fwid_kat from ^WORK_PERS pers "
                	+" where pers.Fwid=z.Fwid_wp and "+ sWhereDat +")";
            ExecuteSQL(sSql);
        	*/        	
        	/*
        	VSP_table.MoveFirst();
        	while (!VSP_table.IsEOF())
        	{
           		var shtID = 0;
           		var sSql = "select pers.fid from ^work_pers pers "
           					+" where pers.fwid="+ VSP_table.getValue("fwid_wp");
           		var oPers = getSnap(sSql);
           		if(oPers)
           			shtID = oPers[0];     		
           		
           		if(shtID != 0)
           		{
              		strSQL = "select org.Fwid,cl.Finval,pers.Fwid_kat "
              			+" from ^WORK_PERS pers "
              				+" inner join ^stru_dol dol on pers.fwid_dol=dol.fwid "
              				+" inner join ^stru_org org on dol.fwid_org=org.fwid "
              				+" left join ^cl cl on cl.fwid=pers.fwid_kat "
              			+" where pers.Fwid="+ VSP_table.getValue("Fwid_wp")
              				//+" and Fid="+ VSP_table.getValue("Fsht_id")
              				+" and (((pers.FBDAT <= " + sqlTo(DD1) + " AND pers.FEDAT >= " + sqlTo(DD2) +") " 
                     		   + "OR (pers.FBDAT >= " + sqlTo(DD1) + " AND pers.FBDAT <= " + sqlTo(DD2) +") " 
                     		   + "OR (pers.FEDAT >= " + sqlTo(DD1) + " AND pers.FEDAT <= " + sqlTo(DD2) +")))";										
              		
              		tsh = getSnap(strSQL); 		
              		if(tsh!=null)
              		{
              			//var xlv1 = tsh[0];
                 		//var xlv2 = tsh[1];
                 		//var xlv3 = tsh[2];
                 		var xinval = tsh[1];
                 		var c_kat = tsh[2];                		
                 		
                 		ExecuteSQL("UPDATE ^VSPZ SET Finval="+ sqlTo(xinval)
                 								  +",Fkod_kat="+ c_kat
                 					+" WHERE FWID="+ VSP_table.getValue("fwid"));
              		}
              		else
              		{
                 		strSQL = "select pers.fbdat,pers.fedat,org.Fwid,cl.Finval,pers.Fwid_kat "
              				+" from ^WORK_PERS pers "
              					+" inner join ^stru_dol dol on pers.fwid_dol=dol.fwid "
              					+" inner join ^stru_org org on dol.fwid_org=org.fwid "
              					+" left join ^cl cl on cl.fwid=pers.fwid_kat "
              				+" where pers.Fwid="+ VSP_table.getValue("Fwid_wp")
              					+" and "+ sWhereDat;
                 		Shtat_table = OpenTable("s", strSQL); 
                 		
                 		if(!Shtat_table.isEmpty())
                 		{
                    		//var xlv1 = Shtat_table.getValue("Flv1");
                    		//var xlv2 = Shtat_table.getValue("Flv2");
                    		//var xlv3 = Shtat_table.getValue("Flv3");
                    		var xinval = Shtat_table.getValue("Finval");
                    		var c_kat = Shtat_table.getValue("Fwid_kat");
                    		while (!Shtat_table.IsEOF())	//&& (Shtat_table.getValue("Ftabn")==VSP_table("Ftabn"))
                    		{
                       			if ((differ(Shtat_table.getValue("fbdat"),D1)<=0 && differ(Shtat_table.getValue("fedat"),D2)>=0) 
                       			 || (differ(Shtat_table.getValue("fbdat"),D1)>=0 && differ(Shtat_table.getValue("fbdat"),D2)<=0) 
                       			 || (differ(Shtat_table.getValue("fedat"),D1)>=0 && differ(Shtat_table.getValue("fedat"),D2)<=0))
                       			{
                          			//xlv1 = Shtat_table.getValue("Flv1");
                          			//xlv2 = Shtat_table.getValue("Flv2");
                          			//xlv3 = Shtat_table.getValue("Flv3");
                          			xinval = Shtat_table.getValue("Finval");
                          			c_kat = Shtat_table.getValue("Fwid_kat");
                          			break;
                       			} 
                       			Shtat_table.MoveNext();
		                    }
		                    ExecuteSQL("UPDATE ^VSPZ SET Finval="+ sqlTo(xinval)
                 								   	  +",Fkod_kat="+ c_kat
                 					+" WHERE FWID="+ VSP_table.getValue("fwid"));
		             	}
		                else
		                {		                    
		                    var mFfld_num=" ";
		                    //if (Lic_table.FindFirst("fid="+sqlTo(VSP_table.getValue("Flsfid"))))
		                    //   mFfld_num = Lic_table.getValue("Ftxt");	                    
		
		                	DefVed.write("Hет подр.для таб.N "+VSP_table.getValue("Ftabn")+"," ,"" ,"");
		                    DefVed.write("поле ЛС-"+Lic_table.getValue("Ftxt")+"," ,"" ,"");
		                    DefVed.write("код записи шт.расп."+VSP_table.getValue("Fsht_id")+" для TN "+VSP_table.getValue("Fwid_wp"),"" ,"");                   
		              	}              
		    		}   
		    	}
		    	else
		    	{                 		
              		strSQL = "select pers.fbdat,pers.fedat,org.Fwid_org,cl.Finval,pers.Fwid_kat "
              				+" from ^WORK_PERS pers "
              					+" inner join ^stru_dol dol on pers.fwid_dol=dol.fwid "
              					+" inner join ^stru_org org on dol.fwid_org=org.fwid "
              					+" left join ^cl cl on cl.fwid=pers.fwid_kat "
              				+" where pers.Fwid="+ VSP_table.getValue("Fwid_wp")
              					+" and "+ sWhereDat;
                 	Shtat_table = OpenTable("s", strSQL);
              		//if (Shtat_table.FindFirst("FTABN="+sqlTo(VSP_table("Ftabn"))))
              		
              		if(!Shtat_table.isEmpty())
              		{
                 		//var xlv1 = Shtat_table.getValue("Flv1");
                 		//var xlv2 = Shtat_table.getValue("Flv2");
		                //var xlv3 = Shtat_table.getValue("Flv3");
		                var xinval = Shtat_table.getValue("Finval");
		                var c_kat = Shtat_table.getValue("Fwid_kat")
		                while (!Shtat_table.IsEOF())// && (Shtat_table.getValue("Ftabn")==VSP_table("Ftabn"))
		                {
		                	bDat = Shtat_table.getValue("fbdat");
		                	eDat = Shtat_table.getValue("fedat");
		                	if ((differ(bDat,D1)<=0 && differ(eDat,D2)>=0) 
		                	  ||(differ(bDat,D1)>=0 && differ(bDat,D2)<=0) 
		                	  ||(differ(eDat,D1)>=0 && differ(eDat,D2)<=0))
		                	{
		                       	//xlv1 = Shtat_table.getValue("Flv1");
		                       	//xlv2 = Shtat_table.getValue("Flv2");
		                       	//xlv3 = Shtat_table.getValue("Flv3");
		                       	xinval = Shtat_table.getValue("Finval");
		                       	c_kat = Shtat_table.getValue("Fwid_kat");
                       			break;
                    		} 
                    		Shtat_table.MoveNext();
                 		}
                 		ExecuteSQL("UPDATE ^VSPZ SET Finval="+ sqlTo(xinval)
                 								  +",Fkod_kat="+ c_kat
                 					+" WHERE FWID="+ VSP_table.getValue("fwid"));
              		}
              		else
              		{                 		
                 		var mFfld_num=" ";
                 		//if (Lic_table.FindFirst("fid="+sqlTo(VSP_table.getValue("Flsfid"))))
                    		//mFfld_num = Lic_table.getValue("Ftxt");

                 		DefVed.write("Hет подр.для таб.N "+VSP_table.getValue("Ftabn")+"," ,"" ,"");
                 		DefVed.write("поле ЛС-"+Lic_table.getValue("Ftxt")+"," ,"" ,"");
                 		DefVed.write("код записи шт.расп."+VSP_table.getValue("Fsht_id")+" для TN "+VSP_table.getValue("Ftabn"),"" ,"");
						
              		}          
           		} 
           		VSP_table.MoveNext();
        	} // end of  while(!VSP_table.IsEOF())
        	*/
			setProgressPos(nPos++, sTxt);
			
			if(!getSum(i))
			{
				setProgressPos(0);
				return false;
			}
			
	       	//**********************************************************
	       	//* шаг 7 нужен для тех типов разноски, где не выделены группы записей
	       	//* и где надо обрезать суммы до 1000 грн только по одной корреспонденции
	       	//* в разноске
	       	//**********************************************************
			
	       	//**********************************************************
	       	//* шаг 71 - собрать суммы по табельным номерам, корреспонденция, подр., кат., проценту
	       	//* (по проценту нужно для тех, кто неправильно ставил процент в разноске -
	       	//* по одной корреспонденции разные величины % - для совместимости с предыдущими
	       	//* расчетами разноски, которые тупо умножали сумму на процент из строки)
	       	//**********************************************************
     		setProgressPos(nPos++, sTxt);
   			WAIT (ru("шаг 5","крок 5"))
       		
       		ExecuteSQL("UPDATE VSP14 SET FGR_B = " +
				  SqlConCat(Convert("FWID_WP", "NVC"),	"'+'",
							Convert("FID", "NVC"),		"'+'",
							Convert("FDB_SC", "NVC", 7),	"'+'",
							Convert("FDB_SU", "NVC", 7),	"'+'",
							Convert("FDB_ST", "NVC", 7),	"'+'",
							Convert("FDB_COD1", "NVC", 7),	"'+'",
							Convert("FDB_COD2", "NVC", 7),	"'+'",
							Convert("FDB_COD2", "NVC", 7),	"'+'",
							Convert("FCR_SC", "NVC", 7),	"'+'",
							Convert("FCR_SU", "NVC", 7),	"'+'",
							Convert("FCR_ST", "NVC", 7),	"'+'",
							Convert("FCR_COD1", "NVC", 7),	"'+'",
							Convert("FCR_COD2", "NVC", 7),	"'+'",
							Convert("FCR_COD3", "NVC", 7),	"'+'",
							Convert("FWID_ORG", "NVC", 12),	"'+'",
           					//Convert("FPODR2", "NVC", 7),	"'+'",
           					//Convert("FPODR3", "NVC", 7),	"'+'",
							Convert("FKOD_KAT", "NVC", 7),	"'+'",
							Convert("FINVAL", "NVC", 7),	"'+'",
							Convert("FPROC", "NVC"),	"'+'",
							Convert("FMN", "NVC"),		"'+'",
							Convert("FVP", "NVC"),		"'+'",
							Convert("F1000", "NVC"),	"'+'",
							Convert(allt("FNAZV_OP"), "NVC", 255),	"'+'",
							Convert("FORG0", "NVC"),	"'+'")							
						);
       
       		CreateTable("VSP15", "VSP_P", "*");
       			
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP15 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP15 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP15 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP15 ADD Fpodr3 "+SqlType("LONG"), false)*/
			setProgressPos(nPos++, sTxt);
       		
       		ExecuteSQL("INSERT INTO VSP15(Fsum,Fgr_b,Fid,Fwid_wp,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
			   		+ "Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,"
			   		+ "Fwid_org,Fkod_kat,Finval,Fproc,Fmn,"
			   		+ "Fvp,Fnazv_op,F1000,Forg0) "
			   	+" SELECT SUM(a.FSUM) as Fsum, "
               		+ First("a.Fgr_b") + ", "			   	
               		+ First("a.Fid") + ", "
               		+ First("a.Fwid_wp") + ", "
               		+ First("a.Fdb_sc") + ", "
               		+ First("a.Fdb_su") + ", "
               		+ First("a.Fdb_st") + ", "
        	       	+ First("a.Fdb_cod1") + ", "
      	         	+ First("a.Fdb_cod2") + ", "
       	        	+ First("a.Fdb_cod3") + ", "
      	         	+ First("a.Fcr_sc") + ", "
      	         	+ First("a.Fcr_su") + ", "
	               	+ First("a.Fcr_st") + ", "
    	           	+ First("a.Fcr_cod1") + ", "
            	   	+ First("a.Fcr_cod2") + ", "
        	       	+ First("a.Fcr_cod3") + ", "
               		+ First("a.Fwid_org") + ", "
	               	//+ First("a.Fpodr2") + ", "
    	           	//+ First("a.Fpodr3") + ", "
        	       	+ First("a.Fkod_kat") + ", "
            	   	+ First(Convert("a.Finval", "INT")) + ", "
               		+ First("a.Fproc") + ", "
               		+ First("a.Fmn") + ", "
               		+ First("a.Fvp") + ", "
               		+ First("a.Fnazv_op") + ", "
               		+ First(Convert("a.F1000", "INT")) + ", "
               		+ First("a.Forg0")
               	+ "FROM VSP14 a "
               	+ "group by Fgr_b ");
     
       		//**********************************************************
       		//* шаг 72 - ограничить суммы 1000 грн - в данном случае получится по строке разноски
       		//**********************************************************
			setProgressPos(nPos++, sTxt);
       		DropTable("VSP25");
       		/* пока не актуально
       		if (is_izmfond)
       		{
          		if (!s1.IsEmpty())
          		{
             		s1.MoveFirst();
             		mFprocfzn = s1.getValue("Fprocfzn");
             		mFprocpfn = s1.getValue("Fprocpfn");
          		}
          		strSQL = "select sum(VSP14.Fsum) as Fsum, sum(VSP14.Fsum) as Fsum2,"
                			+" FWID_WP, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc "
                		+" into VSP25 from VSP14 "
                		+" where F1000="+SqlTrue+" and Fproc<>"+sqlTo(mFprocfzn)
                			+" and Fproc<>"+sqlTo(mFprocpfn)
                		+" group by FWID_WP, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc";
          		ExecuteSQL(strSQL);

       		}
       		else
       		{
       		*/ 
          		strSQL = "select sum(VSP14.Fsum) as Fsum, sum(VSP14.Fsum) as Fsum2,"+
                			" Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st,fproc,forg0 "+
                		" into VSP25 from VSP14 where F1000="+SqlTrue+
                		" group by Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st,fproc,forg0";
          		ExecuteSQL(strSQL);
       		//}
       		if (i==3)
       		{
          		ExecuteSQL("UPDATE VSP25 SET Fsum2 = "+ (-1*sum_ogr)
               		+" WHERE abs(Fsum)>"+ sum_ogr);
       		}
       		else
       		{
          		ExecuteSQL("UPDATE VSP25 SET Fsum2 = "+ sum_ogr
               			+" WHERE Fsum>"+ sum_ogr);
       		}
			setProgressPos(nPos++, sTxt);
       		
       		TVSP25 = OpenTable("s", "select* from VSP25 where abs(Fsum)>"+sqlTo(sum_ogr));       
       		if (!TVSP25.IsEmpty())
       		{  
          		TVSP25.MoveFirst();  
          		while (!TVSP25.IsEOF())
          		{
             		setProgressPos(nPos++, sTxt);
             		/* пока не актуально
             		if (is_izmfond)
             		{
                		strSQL = "select Fpnsizm,Fzanizm,Fprocpfo,Fprocfzo,Fprocpfn,Fprocfzn "
                				+" from ^SUM1DAY "
                				+" where Fwid_wp="+ sqlTo(TVSP25.getValue("Fwid_wp"))
                					  +" and Fmn="+ sqlTo(TVSP25.getValue("Fmn")) 
                					  +" and Fvp="+ sqlTo(TVSP25.getValue("Fvp"));
                		tsum1 = getSnap(strSQL);
                		sumdayp = 0;
                		sumdayz = 0;
                		sumpropo  = 0;
                		sumprozo = 0;
                		sumpropn  = 0;
                		sumprozn = 0;
                		if (tsum1!=null)
                		{
                   			sumdayp = tsum1[0];
                   			sumdayz = tsum1[1];
                   			sumpropo = tsum1[2];
                   			sumprozo = tsum1[3];
                   			sumpropn = tsum1[4];
                   			sumprozn = tsum1[5];
                		} 
                		strSQL = "select * from VSP15 "
                			+" where Fwid_wp="+ sqlTo(TVSP25.getValue("Fwid_wp"))
                				  +" and Fmn="+ sqlTo(TVSP25.getValue("Fmn"))
                				  +" and Fvp="+ sqlTo(TVSP25.getValue("Fvp"))
                				  +" and F1000="+ SqlTrue 
                				  +" and Fcr_sc="+ sqlTo(TVSP25.getValue("Fcr_sc"))
                				  +" and Fcr_su="+ sqlTo(TVSP25.getValue("Fcr_su"))
                				  +" and Fcr_st="+ sqlTo(TVSP25.getValue("Fcr_st"))
                				  +" and Fproc="+ sqlTo(TVSP25.getValue("Fproc"))
                			+"order by Fproc desc";                		
                		TVSP15 = OpenTable("s", strSQL);
						setProgressPos(nPos++, sTxt);
						
                		if (!TVSP15.IsEmpty())
                		{
                   			TVSP15.MoveFirst();  
                   			while (!TVSP15.IsEOF())
                   			{
                     			mFsum15  = Number(TVSP15.getValue("Fsum"));
                     			mFsum25  = Number(TVSP25.getValue("Fsum2"));
                     			mFsum25p = Number(TVSP25.getValue("Fsum2"))-Number(sumdayp)
                     			mFsum25z = Number(TVSP25.getValue("Fsum2"))-Number(sumdayz)
                     			var nSum;                     			
                     			if (Number(TVSP15.getValue("Fproc"))==Number(sumpropo))
                     			{
                        			nSum = round(mFsum15 / (Number(TVSP25.getValue("Fsum"))) * mFsum25p, 2);
                        			ExecuteSQL("UPDATE VSP15 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP15.getValue("Fwid"));
                     			} 
                     			if (Number(TVSP15.getValue("Fproc"))==Number(sumprozo))
                     			{
                        			nSum = round(mFsum15 / (Number(TVSP25.getValue("Fsum"))) * mFsum25z, 2);
                        			ExecuteSQL("UPDATE VSP15 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP15.getValue("Fwid"));
                     			}
                     			if (Number(TVSP15.getValue("Fproc"))!=Number(sumpropo) 
                     			 && Number(TVSP15.getValue("Fproc"))!=Number(sumprozo)
                     			 && Number(TVSP15.getValue("Fproc"))!=Number(sumpropn)
                     			 && Number(TVSP15.getValue("Fproc"))!=Number(sumprozn))
                     			{
                        			nSum = round(mFsum15/Number(TVSP25.getValue("Fsum")) * mFsum25, 2);
                        			ExecuteSQL("UPDATE VSP15 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP15.getValue("Fwid"));
                     			}                     			
                     			TVSP15.MoveNext();  
                   			}
                		}  
             		}
             		else
             		{
             		*/ 
                		strSQL = "select * from VSP15 "
                			+" where Fwid_wp="+sqlTo(TVSP25.getValue("Fwid_wp"))
                				+" and Fmn="+sqlTo(TVSP25.getValue("Fmn"))
                				+" and Fvp="+sqlTo(TVSP25.getValue("Fvp"))
                				+" and F1000="+SqlTrue
                				+" and Fcr_sc="+sqlTo(TVSP25.getValue("Fcr_sc"))
                				+" and Fcr_su="+sqlTo(TVSP25.getValue("Fcr_su"))
                				+" and Fcr_st="+sqlTo(TVSP25.getValue("Fcr_st"))
                				+" and Fproc="+sqlTo(TVSP25.getValue("Fproc"));
                		TVSP15 = OpenTable("s", strSQL);
                		
                		TVSP15.MoveFirst();  
                   		while (!TVSP15.IsEOF())
                   		{
                     		mFsum15 = Number(TVSP15.getValue("Fsum"));                     			
                     		nSum = round(mFsum15 / Number(TVSP25.getValue("Fsum")) * Number(TVSP25.getValue("Fsum2")), 2);
                     		ExecuteSQL("UPDATE VSP15 SET Fsum="+ nSum +" WHERE Fgr_b="+sqlTo(TVSP15.getValue("Fgr_b")));
                     		TVSP15.MoveNext();
                   		}  
             		//} 
             		TVSP15.Close();
             		TVSP25.MoveNext();  
          		}
       		}
       		TVSP25.Close();

       		//**********************************************************
       		//* шаг 73 - собрать суммы по корреспонденция, подр., кат., процентам после того
       		//* как они были обрезаны до ограничения
       		//**********************************************************
			setProgressPos(nPos++, sTxt);
       		ExecuteSQL("UPDATE VSP15 SET FGR_B = " +
					SqlConCat(	Convert("FID", "NVC"), "'+'",
								Convert("FDB_SC", "NVC", 7), "'+'",
								Convert("FDB_SU", "NVC", 7), "'+'",
								Convert("FDB_ST", "NVC", 7), "'+'",
								Convert("FDB_COD1", "NVC", 7), "'+'",
								Convert("FDB_COD2", "NVC", 7), "'+'",
								Convert("FDB_COD3", "NVC", 7), "'+'",
								Convert("FCR_SC", "NVC", 7), "'+'",
								Convert("FCR_SU", "NVC", 7), "'+'",
								Convert("FCR_ST", "NVC", 7), "'+'",
								Convert("FCR_COD1", "NVC", 7), "'+'",
								Convert("FCR_COD2", "NVC", 7), "'+'",
								Convert("FCR_COD3", "NVC", 7), "'+'",
								Convert("FWID_ORG", "NVC", 12), "'+'",
								//Convert("FPODR2", "NVC", 7), "'+'",
								//Convert("FPODR3", "NVC", 7), "'+'",
								Convert("FKOD_KAT", "NVC", 7), "'+'",
								Convert("FINVAL", "NVC", 7), "'+'",
								Convert("FPROC", "NVC"), "'+'",
								Convert("F1000", "NVC"), "'+'",
								Convert(allt("FNAZV_OP"), "NVC",255),
								Convert("FORG0", "NVC"), "'+'")								
						);

       		CreateTable("VSP16", "VSP_P", "*");
       		
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP16 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP16 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP16 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP16 ADD Fpodr3 "+SqlType("LONG"), false)*/
			setProgressPos(nPos++, sTxt);
       		ExecuteSQL("INSERT INTO VSP16(Fsum,Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
					   + "Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,"
					   + "Fwid_org,Fkod_kat,Finval,Fproc,"
					   + "Fnazv_op,F1000,Forg0) "
					+" SELECT SUM(a.FSUM) as Fsum, "
		               + First("a.Fid") + ", "
		               + First("a.Fdb_sc") + ", "
		               + First("a.Fdb_su") + ", "
		               + First("a.Fdb_st") + ", "
		               + First("a.Fdb_cod1") + ", "
		               + First("a.Fdb_cod2") + ", "
		               + First("a.Fdb_cod3") + ", "
		               + First("a.Fcr_sc") + ", "
		               + First("a.Fcr_su") + ", "
		               + First("a.Fcr_st") + ", "
		               + First("a.Fcr_cod1") + ", "
		               + First("a.Fcr_cod2") + ", "
		               + First("a.Fcr_cod3") + ", "
		               + First("a.Fwid_org") + ", "
		               //+ First("a.Fpodr2") + ", "
		               //+ First("a.Fpodr3") + ", "
		               + First("a.Fkod_kat") + ", "
		               + First(Convert("a.Finval", "INT")) + ", "
		               + First("a.Fproc") + ", "
		               + First("a.Fnazv_op") + ", "
		               + First(Convert("a.F1000", "INT")) + ", "
		               + First("a.Forg0")
	               +" FROM VSP15 a "
	               +" group by Fgr_b ");
 
	       	//**********************************************************
	       	//* шаг 8  - нужен для разносок, где проставлены номера групп (т.е. ограничение
	       	//* в 1000 грн. вешается не на строку разноски, а на группу строк)
	       	//**********************************************************
	
	       	//**********************************************************
	       	//* шаг 81 - собрать суммы по табельным номерам и группам, подразделениям и категориям
	       	//**********************************************************
            
            CreateTable("VSP19", "VSP_P", "*");
       		
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP19 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP19 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP19 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP19 ADD Fpodr3 "+SqlType("LONG"), false)*/
			setProgressPos(nPos++, sTxt);
			
       		ExecuteSQL("INSERT INTO VSP19(Fsum,Fgr_b,Fid,Fwid_wp,Fwid_org"
		       			+",Fkod_kat,fdb_sc,fdb_su,fdb_st,fdb_cod1,fdb_cod2,fdb_cod3"
		       			+",fcr_sc,fcr_su,fcr_st,Finval,Fproc,Fmn,Fvp,"
					   	+"F1000,Fnazv_op,Forg0) "
					+" SELECT SUM(a.FSUM), "
		               	+ First("a.Fgr_b")+","					
		               	+"a.Fid, "
		               	+"a.Fwid_wp , "
		               	+"a.Fwid_org, "
		               	//+"a.Fpodr2, "
		               	//+"a.Fpodr3, "
		               	+"a.Fkod_kat, "
		               	+"a.Fdb_sc, "
		               	+"a.Fdb_su, "
		               	+"a.Fdb_st, "
		               	+"a.Fdb_cod1, "
		               	+"a.Fdb_cod2, "
		               	+"a.Fdb_cod3, "
		               	+"a.Fcr_sc, "
		               	+"a.Fcr_su, "
		               	+"a.Fcr_st, "
		               	+"a.Finval, "
		               	+"a.Fproc, "
		               	+"a.Fmn, "
		               	+"a.Fvp, "
		               	+"a.F1000, "
		               	+ First("a.Fnazv_op") + ", "
		               	+"a.Forg0 "
               		+" FROM VSP14 a "
               		+" group by Fwid_wp, Fid, Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3"
               			+", Fwid_org, Fkod_kat, Finval, Fcr_sc, Fcr_su, Fcr_st"
               			+", Fproc, Fmn, Fvp, F1000, Forg0");
 
        		ExecuteSQL("UPDATE VSP19 SET FGR_B = " +
					SqlConCat(	
								Convert("FWID_WP", "NVC"), "'+'",					
								Convert("FID", "NVC"), "'+'",
								Convert("FDB_SC", "NVC", 7), "'+'",
								Convert("FDB_SU", "NVC", 7), "'+'",
								Convert("FDB_ST", "NVC", 7), "'+'",
								Convert("FDB_COD1", "NVC", 7), "'+'",
								Convert("FDB_COD2", "NVC", 7), "'+'",
								Convert("FDB_COD3", "NVC", 7), "'+'",
								Convert("Fwid_org", "NVC", 12), "'+'",
								//Convert("FPODR2", "NVC", 7), "'+'",
								//Convert("FPODR3", "NVC", 7), "'+'",
								Convert("FKOD_KAT", "NVC", 7), "'+'",
								Convert("FINVAL", "NVC", 7), "'+'",
								Convert("FCR_SC", "NVC", 7), "'+'",
								Convert("FCR_SU", "NVC", 7), "'+'",
								Convert("FCR_ST", "NVC", 7), "'+'",
								Convert("FPROC", "NVC"), "'+'",
								Convert("FMN", "NVC"), "'+'",
								Convert("FVP", "NVC"), "'+'",
								Convert("F1000", "NVC"), "'+'",
								Convert(allt("FNAZV_OP"), "NVC", 255), "'+'",
								Convert("Forg0", "NVC"), "'+'")								
						);
 
 
	       	//**********************************************************
	       	//* шаг 82 - собрать суммы по группам, подразделениям и категориям
	       	//**********************************************************
     		setProgressPos(nPos++, sTxt);
       		          		 
       		CreateTable("VSP20", "VSP_P", "*");
       		
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP20 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP20 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP20 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP20 ADD Fpodr3 "+SqlType("LONG"), false)*/
     		setProgressPos(nPos++, sTxt);
       		ExecuteSQL("INSERT INTO VSP20(Fsum,Fid,fdb_sc,fdb_su,fdb_st"
		       		   +",fdb_cod1,fdb_cod2,fdb_cod3,Fwid_org,Fkod_kat,Finval,Fproc,"
					   +"Fnazv_op,F1000,Forg0) "
					+" SELECT SUM(a.FSUM), "
		               +"a.Fid, "
		               +"a.Fdb_sc, "
		               +"a.Fdb_su, "
		               +"a.Fdb_st, "
		               +"a.Fdb_cod1, "
		               +"a.Fdb_cod2, "
		               +"a.Fdb_cod3, "
		               +"a.Fwid_org, "
		               //+"a.Fpodr2, "
		               //+"a.Fpodr3, "
		               +"a.Fkod_kat, "
		               +"a.Finval, "
		               +"a.Fproc, "
		               +"a.Fnazv_op, "
		               +"a.F1000, "
		               +"a.Forg0 "
               		+" FROM VSP19 a "
               		+" group by Fid, Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3"
               			+", Fwid_org, Fkod_kat, Finval, Fproc, F1000, Fnazv_op, Forg0");
 
       		//**********************************************************
       		//* шаг 83 - ограничить суммы 1000 грн - в данном случае получится по группе строк
       		//**********************************************************

       		DropTable("VSP26");
       		setProgressPos(nPos++, sTxt);
       		/* пока не актуально
       		if (is_izmfond)
       		{
          		if (!s1.IsEmpty())
          		{
             		s1.MoveFirst();
             		mFprocfzn = s1.getValue("Fprocfzn");
             		mFprocpfn = s1.getValue("Fprocpfn");
          		}
          		strSQL = "select sum(VSP19.Fsum) as Fsum, sum(VSP19.Fsum) as Fsum2,"+
                			" Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc "+
                		" into VSP26 from VSP19 "+
                		" where F1000="+ SqlTrue +
                			" and Fproc<>"+sqlTo(mFprocfzn)+
                			" and Fproc<>"+sqlTo(mFprocpfn)+
                		" group by Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc";
          		ExecuteSQL(strSQL);

       		}
       		else
       		{
       		*/ 
          		strSQL = "select sum(VSP19.Fsum) as Fsum, sum(VSP19.Fsum) as Fsum2,"+
                			" Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc, Forg0 "+
                		" into VSP26 from VSP19 "+
                		" where F1000="+ SqlTrue +
                		" group by Fwid_wp, Fmn, Fvp, fcr_sc, fcr_su, fcr_st, fproc, Forg0";
          		ExecuteSQL(strSQL);
       		//}
			setProgressPos(nPos++, sTxt);
       		if (i==3)
       		{
          		ExecuteSQL("UPDATE VSP26 SET Fsum2 = "+ sqlTo((-1*sum_ogr))
               		+" WHERE abs(Fsum)>"+sqlTo(sum_ogr));
       		}
       		else
       		{
          		ExecuteSQL("UPDATE VSP26 SET Fsum2 = "+ sqlTo(sum_ogr)
               		+" WHERE Fsum>"+sqlTo(sum_ogr));
       		}
			setProgressPos(nPos++, sTxt);
       		TVSP26 = OpenTable("s", "select * from VSP26 where abs(Fsum)>"+sqlTo(sum_ogr));       
       		if (!TVSP26.IsEmpty())
       		{  
          		TVSP26.MoveFirst();  
          		while (!TVSP26.IsEOF())
          		{
             		setProgressPos(nPos++, sTxt);
             		/* пока не актуально
             		if (is_izmfond)
             		{
                		strSQL = "select Fpnsizm,Fzanizm,Fprocpfo,Fprocfzo,Fprocpfn,Fprocfzn"
                			+" from ^SUM1DAY "
                			+" where Fwid_wp="+ sqlTo(TVSP26.getValue("Fwid_wp"))
                				  +" and Fmn="+ sqlTo(TVSP26.getValue("Fmn"))
                				  +" and Fvp="+ sqlTo(TVSP26.getValue("Fvp"));
                		tsum1 = getSnap(strSQL);
                		sumdayp = 0;
                		sumdayz = 0;
                		sumpropo  = 0;
                		sumprozo = 0;
                		sumpropn  = 0;
                		sumprozn = 0;
                		if (tsum1!=null)
                		{
                   			sumdayp = tsum1[0];
                   			sumdayz = tsum1[1];
                   			sumpropo = tsum1[2];
                   			sumprozo = tsum1[3];
                   			sumpropn = tsum1[4];
                   			sumprozn = tsum1[5];
                		} 
                		strSQL = "select * from VSP19 "
                			+" where Fwid_wp="+sqlTo(TVSP26.getValue("Fwid_wp"))
                				+" and Fmn="+sqlTo(TVSP26.getValue("Fmn"))
                				+" and Fvp="+sqlTo(TVSP26.getValue("Fvp"))
                				+" and F1000="+SqlTrue
                				+" and Fcr_sc="+sqlTo(TVSP26.getValue("Fcr_sc"))
                				+" and Fcr_su="+sqlTo(TVSP26.getValue("Fcr_su"))
                				+" and Fcr_st="+sqlTo(TVSP26.getValue("Fcr_st"))
                				+" and Fproc="+sqlTo(TVSP25.getValue("Fproc"))
                			+"order by Fproc desc"
                		TVSP19 = OpenTable("s", strSQL);

                		if (!TVSP19.IsEmpty())
                		{
                   			TVSP19.MoveFirst();  
                   			while (!TVSP19.IsEOF())
                   			{
                     			mFsum15  = Number(TVSP19.getValue("Fsum"));
                     			mFsum25  = Number(TVSP26.getValue("Fsum2"));
                     			mFsum25p = Number(TVSP26.getValue("Fsum2"))-Number(sumdayp);
                     			mFsum25z = Number(TVSP26.getValue("Fsum2"))-Number(sumdayz);
                     			TVSP19.Edit();
                     			if (Number(TVSP19.getValue("Fproc"))==Number(sumpropo))
                     			{
                        			nSum = round(mFsum15/(Number(TVSP26.getValue("Fsum"))) * mFsum25p, 2);
                        			ExecuteSQL("UPDATE VSP19 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP19.getValue("Fwid"));
                     			} 
                     			if (Number(TVSP19.getValue("Fproc"))==Number(sumprozo))
                     			{
                        			nSum = round(mFsum15/(Number(TVSP26.getValue("Fsum"))) * mFsum25z, 2);
                        			ExecuteSQL("UPDATE VSP19 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP19.getValue("Fwid"));                        
                     			}
                     			if (Number(TVSP19.getValue("Fproc"))!=Number(sumpropo)
                     			 && Number(TVSP19.getValue("Fproc"))!=Number(sumprozo) 
                     			 && Number(TVSP19.getValue("Fproc"))!=Number(sumpropn) 
                     			 && Number(TVSP19.getValue("Fproc"))!=Number(sumprozn))
                     			{
                        			nSum = round(mFsum15/Number(TVSP26.getValue("Fsum")) * mFsum25, 2);
                        			ExecuteSQL("UPDATE VSP19 SET Fsum="+ nSum +" WHERE Fwid="+ TVSP19.getValue("Fwid"));
                     			}                     			                     			
                     			TVSP19.MoveNext();  
                   			}
                		}  
            		}
            		else
            		{
            		*/ 
                		strSQL = "select * from VSP19 "
                				+" where Fwid_wp="+ sqlTo(TVSP26.getValue("Fwid_wp"))
                					  +" and Fmn="+ sqlTo(TVSP26.getValue("Fmn"))
                					  +" and Fvp="+ sqlTo(TVSP26.getValue("Fvp"))
                					  +" and F1000="+ SqlTrue
                					  +" and Fcr_sc="+ sqlTo(TVSP26.getValue("Fcr_sc"))
                					  +" and Fcr_su="+ sqlTo(TVSP26.getValue("Fcr_su"))
                					  +" and Fcr_st="+ sqlTo(TVSP26.getValue("Fcr_st"))
                					  +" and Fproc="+ sqlTo(TVSP25.getValue("Fproc"));
                		TVSP19 = OpenTable("s", strSQL);
                		if (!TVSP19.IsEmpty())
                		{
                   			TVSP19.MoveFirst();  
                   			while (!TVSP19.IsEOF())
                   			{
                     			mFsum25 = TVSP19.getValue("Fsum");                     			
                     			nSum = round(mFsum25/Number(TVSP26.getValue("Fsum")) * Number(TVSP26.getValue("Fsum2")), 2);
                     			ExecuteSQL("UPDATE VSP19 SET Fsum="+ nSum +" WHERE Fgr_b="+ TVSP19.getValue("Fgr_b"));
                     			TVSP19.MoveNext();  
                   			}
                		}
             		//} 
	     			TVSP19.Close(5652);
             		TVSP26.MoveNext();  
          		}
       		}
       		TVSP26.Close(5652);

       		//**********************************************************
       		//* шаг 84 - собрать суммы по группам, подр., кат. после того
       		//* как они были обрезаны до ограничения
       		//**********************************************************
  			setProgressPos(nPos++, sTxt);       		
       		
       		CreateTable("VSP21", "VSP_P", "*");
       			
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP21 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP21 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP21 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP21 ADD Fpodr3 "+SqlType("LONG"), false)*/

     		setProgressPos(nPos++, sTxt);
       		ExecuteSQL("INSERT INTO VSP21(Fsum,Fid,fdb_sc,fdb_su,fdb_st,"
		       			+"fdb_cod1,fdb_cod2,fdb_cod3,Fwid_org, Fkod_kat, "
		       			+"Finval, Fproc, Fnazv_op, F1000, Forg0)"
					+" SELECT SUM(a.FSUM), "
		               	+"a.Fid, "
		               	+"a.Fdb_sc, "
		               	+"a.Fdb_su, "
		               	+"a.Fdb_st, "
		               	+"a.Fdb_cod1, "
		               	+"a.Fdb_cod2, "
		               	+"a.Fdb_cod3, "
		               	+"a.Fwid_org, "
		               	//+"a.Fpodr2, "
		               	//+"a.Fpodr3, "
		               	+"a.Fkod_kat, "
		               	+"a.Finval, "
		               	+"a.Fproc, "
		               	+"a.Fnazv_op, "
		               	+"a.F1000, "
		               	+"a.Forg0 "
               		+" FROM VSP19 a "
               		+" group by Fid, Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3"
               			+", Fwid_org, Fkod_kat, Finval, Fproc, F1000, Fnazv_op, Forg0 ");


	       	//**********************************************************
	       	//* шаг 9 - собрать суммы по группам, корресп., подр., кат., проц. без
	       	//* ограничения в 1000 грн
	       	//**********************************************************
  			setProgressPos(nPos++, sTxt);
       		ExecuteSQL("UPDATE VSP14 SET FGR_B = " +
					SqlConCat(	Convert("FID", "NVC"), "'+'",
								Convert("FDB_SC", "NVC", 7), "'+'",
								Convert("FDB_SU", "NVC", 7), "'+'",
								Convert("FDB_ST", "NVC", 7), "'+'",
								Convert("FDB_COD1", "NVC", 7), "'+'",
								Convert("FDB_COD2", "NVC", 7), "'+'",
								Convert("FDB_COD3", "NVC", 7), "'+'",
								Convert("FCR_SC", "NVC", 7), "'+'",
								Convert("FCR_SU", "NVC", 7), "'+'",
								Convert("FCR_ST", "NVC", 7), "'+'",
								Convert("FCR_COD1", "NVC", 7), "'+'",
								Convert("FCR_COD2", "NVC", 7), "'+'",
								Convert("FCR_COD3", "NVC", 7), "'+'",
								Convert("Fwid_org", "NVC", 12), "'+'",
								//Convert("FPODR2", "NVC", 7), "'+'",
								//Convert("FPODR3", "NVC", 7), "'+'",
								Convert("FKOD_KAT", "NVC", 7), "'+'",
								Convert("FINVAL", "NVC", 7), "'+'",
								Convert("FPROC", "NVC"), "'+'",
								Convert("FIS_TABN", "NVC"), "'+'",
								Convert("F1000", "NVC"), "'+'",
								Convert(allt("FNAZV_OP"), "NVC", 255), "'+'",
								Convert("Forg0", "NVC"), "'+'")								
						);

       		if (i>1)
       		{
          		VSP17_table.Close();
       		}  
       		
       		CreateTable("VSP17", "VSP_P", "*");
       		
       		/*if(typeof(Fpodr2)!="undefined")
       		{
          		ExecuteSQL("ALTER TABLE VSP17 DROP COLUMN Fpodr2");
          		ExecuteSQL("ALTER TABLE VSP17 DROP COLUMN Fpodr3");
       		}
       		ExecuteSQL("ALTER TABLE VSP17 ADD Fpodr2 "+SqlType("LONG"), false)
       		ExecuteSQL("ALTER TABLE VSP17 ADD Fpodr3 "+SqlType("LONG"), false)*/
			setProgressPos(nPos++, sTxt);
       		ExecuteSQL( "INSERT INTO VSP17 (Fsum,Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
						+ "Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,"
						+ "Fcr_cod3,Fwid_org,Fkod_kat,Finval,Fproc,Fis_tabn,Fnazv_op,F1000,Forg0)"
					+ " SELECT SUM(a.FSUM), "
		               	//+ GetUID() +", "
		               	+ First("a.Fid") + ", "
		               	+ First("a.Fdb_sc") + ", "
		               	+ First("a.Fdb_su") + ", "
		               	+ First("a.Fdb_st") + ", "
		               	+ First("a.Fdb_cod1") + ", "
		               	+ First("a.Fdb_cod2") + ", "
		               	+ First("a.Fdb_cod3") + ", "
		               	+ First("a.Fcr_sc") + ", "
		               	+ First("a.Fcr_su") + ", "
		               	+ First("a.Fcr_st") + ", "
		               	+ First("a.Fcr_cod1") + ", "
		               	+ First("a.Fcr_cod2") + ", "
		               	+ First("a.Fcr_cod3") + ", "
		               	+ First("a.Fwid_org") + ", "
		               	//+ First("a.Fpodr2") + ", "
		               	//+ First("a.Fpodr3") + ", "
		               	+ First("a.Fkod_kat") + ", "
		               	+ First(Convert("a.Finval", "INT")) + ", "
		               	+ First("a.Fproc") + ", "
		               	+ First(Convert("a.Fis_tabn", "INT")) + ", "
		               	+ First("a.Fnazv_op") + ", "
		               	+ First(Convert("a.F1000", "INT")) + ", "
		                + First("a.Forg0")
               		+ " FROM VSP14 a "
               		+ " WHERE a.Fis_tabn=" + SqlFalse
               		+ " group by a.Fgr_b ");
     		setProgressPos(nPos++, sTxt);
       		ExecuteSQL("UPDATE VSP17 SET FGR_B = " +
					SqlConCat(	Convert("FID", "NVC"), "'+'",
								Convert("FDB_SC", "NVC", 7), "'+'",
								Convert("FDB_SU", "NVC", 7), "'+'",
								Convert("FDB_ST", "NVC", 7), "'+'",
								Convert("FDB_COD1", "NVC", 7), "'+'",
								Convert("FDB_COD2", "NVC", 7), "'+'",
								Convert("FDB_COD3", "NVC", 7), "'+'",
								Convert("FCR_SC", "NVC", 7), "'+'",
								Convert("FCR_SU", "NVC", 7), "'+'",
								Convert("FCR_ST", "NVC", 7), "'+'",
								Convert("FCR_COD1", "NVC", 7), "'+'",
								Convert("FCR_COD2", "NVC", 7), "'+'",
								Convert("FCR_COD3", "NVC", 7), "'+'",
								Convert("Fwid_org", "NVC", 12), "'+'",
								//Convert("FPODR2", "NVC", 7), "'+'",
								//Convert("FPODR3", "NVC", 7), "'+'",
								Convert("FKOD_KAT", "NVC", 7), "'+'",
								Convert("FINVAL", "NVC", 7), "'+'",
								Convert("FPROC", "NVC"), "'+'",
								Convert(allt("FNAZV_OP"), "NVC",255), "'+'",
								Convert("Forg0", "NVC"), "'+'")								
						);
     		setProgressPos(nPos++, sTxt);
       		ExecuteSQL("UPDATE VSP16 SET FGR_B = " +
					SqlConCat(	Convert("FID", "NVC"), "'+'",
								Convert("FDB_SC", "NVC", 7), "'+'",
								Convert("FDB_SU", "NVC", 7), "'+'",
								Convert("FDB_ST", "NVC", 7), "'+'",
								Convert("FDB_COD1", "NVC", 7), "'+'",
								Convert("FDB_COD2", "NVC", 7), "'+'",
								Convert("FDB_COD3", "NVC", 7), "'+'",
								Convert("FCR_SC", "NVC", 7), "'+'",
								Convert("FCR_SU", "NVC", 7), "'+'",
								Convert("FCR_ST", "NVC", 7), "'+'",
								Convert("FCR_COD1", "NVC", 7), "'+'",
								Convert("FCR_COD2", "NVC", 7), "'+'",
								Convert("FCR_COD3", "NVC", 7), "'+'",
								Convert("Fwid_org", "NVC", 12), "'+'",
								//Convert("FPODR2", "NVC", 7), "'+'",
								//Convert("FPODR3", "NVC", 7), "'+'",
								Convert("FKOD_KAT", "NVC", 7), "'+'",
								Convert("FINVAL", "NVC", 7), "'+'",
								Convert("FPROC", "NVC"), "'+'",
								Convert(allt("FNAZV_OP"), "NVC", 255), "'+'",
								Convert("Forg0", "NVC"), "'+'")								
						);
               

	       	//**********************************************************
	       	//* шаг 10 - пройти по файлу из шага 9 и разбросать суммы по фондам
	       	//**********************************************************
     		setProgressPos(nPos++, sTxt);
     		//этот кусок не соответствует тексту из 2000 версии, если код группы !=0
     		// при желании потом переписать на SQL, сейчас просто повторю 2000, чтобы
     		//хоть что-то заработало
     		/*
       		VSP17_table = OpenTable("s","select * from VSP17 "
       					+" where Fis_tabn="+SqlFalse+" order by Fid ");
            
     		setProgressPos(nPos++, sTxt);       		
       		
       		var sWhere = " where  Fid="+VSP17_table.getValue("Fid")+
                     	  " and Fdb_sc="+VSP17_table.getValue("Fdb_sc")+
                          " and Fdb_su="+VSP17_table.getValue("Fdb_su")+
                          " and Fdb_st="+VSP17_table.getValue("Fdb_st")+
                          " and Fdb_cod1="+VSP17_table.getValue("Fdb_cod1")+
                          " and Fdb_cod2="+VSP17_table.getValue("Fdb_cod2")+
                          " and Fdb_cod3="+VSP17_table.getValue("Fdb_cod3")+
                          " and Fwid_org="+VSP17_table.getValue("Fwid_org")+
                          //" and Fpodr2="+VSP17_table.getValue("Fpodr2")+
                          //" and Fpodr3="+VSP17_table.getValue("Fpodr3")+
                          " and Fkod_kat="+VSP17_table.getValue("Fkod_kat")+
                          " and Finval="+sqlTo(VSP17_table.getValue("Finval"))+
                          " and Fproc="+VSP17_table.getValue("Fproc");
            VSP20 = getSnap("select Fsum from VSP20 "+ sWhere);
            VSP21 = getSnap("select Fsum from VSP21 "+ sWhere);
         
            var SUM = 0;
            if (VSP20!=null && VSP21!=null)
            {
            	var sum1 = sqlRound(Number(VSP21[0]) +"*Fsum/"+ Number(VSP20[0]) +"*Fproc",0);
    
            	*         	var sum2 = "0";
            	SUM = IIF("F1000="+SqlTrue, sum1+"/100", sum2);
            }					
          
            var orgSum1 = sqlRound("(select v16.Fsum from VSP16 v16 where v16.Fgr_b=VSP17.Fgr_b)*VSP17.Fproc", 0);
            var orgSum2 = sqlRound("Fsum*Fproc", 0);
            var orgSUM = IIF("F1000="+SqlTrue, orgSum1+"/100", orgSum2+"/100");
                        
            var SUMM = IIF("Fid=0", orgSUM, SUM);
            //ExecuteSQL("UPDATE VSP17 v17 SET Fsum="+ SUMM);
            ExecuteSQL("UPDATE VSP17 SET Fsum="+ SUMM);            
            VSP17_table.requery();
            */
            
	        VSP17_table = OpenTable("s","select * from VSP17 where "
                                +"Fis_tabn="+SqlFalse+" order by Fid ");

    	    if (!VSP17_table.IsEOF())
        	  VSP17_table.MoveFirst();
     
	        while (!VSP17_table.IsEOF()){
	        	var locstr = VSP17_table.getValue("Fgr_b");
	        	var nzvop  = VSP17_table.getValue("Fnazv_op");	        	
         		if (VSP17_table.getValue("Fid")==0){
            		if (VSP17_table.getValue("F1000")==true){
               			strSQL = "select * from VSP16 where Fgr_b="+sqlTo(locstr);
               			tv16 = OpenTable("s", strSQL);
               			if (!tv16.IsEmpty()){
                  			//VSP17_table("Fsum") = Math.round(VSP16_table("Fsum")*VSP17_table("Fproc"))/100;               				
               				ExecuteSQL("UPDATE VSP17 set Fsum="+sqlRound("Fproc*"+tv16.getValue("Fsum")+"/100",2)+" where Fgr_b="+sqlTo(locstr)) 
               			}
               			tv16.Close()
            		}else{
               			//VSP17_table("Fsum") = Math.round(VSP17_table("Fsum")*VSP17_table("Fproc"))/100;
           				ExecuteSQL("UPDATE VSP17 set Fsum="+sqlRound("(Fproc*Fsum)/100",2)+" where Fgr_b="+sqlTo(locstr))               			
            		}
         		}else{  
            		strSQL = "select * from VSP20 where Fid="+sqlTo(VSP17_table.getValue("Fid"))+
                                     " and Fdb_sc="+sqlTo(VSP17_table.getValue("Fdb_sc"))+
                                      " and Fdb_su="+sqlTo(VSP17_table.getValue("Fdb_su"))+
                                      " and Fdb_st="+sqlTo(VSP17_table.getValue("Fdb_st"))+
                                      " and Fdb_cod1="+sqlTo(VSP17_table.getValue("Fdb_cod1"))+
                                      " and Fdb_cod2="+sqlTo(VSP17_table.getValue("Fdb_cod2"))+
                                      " and Fdb_cod3="+sqlTo(VSP17_table.getValue("Fdb_cod3"))+
                                      " and Fwid_org="+sqlTo(VSP17_table.getValue("Fwid_org"))+
                                      //" and Fpodr2="+sqlTo(VSP17_table.getValue("Fpodr2"))+
                                      //" and Fpodr3="+sqlTo(VSP17_table.getValue("Fpodr3"))+
                                      " and Fkod_kat="+sqlTo(VSP17_table.getValue("Fkod_kat"))+
                                      " and Finval="+sqlTo(VSP17_table.getValue("Finval"))+
                                      " and Fproc="+sqlTo(VSP17_table.getValue("Fproc"))+
                                      " and Fnazv_op="+sqlTo(VSP17_table.getValue("Fnazv_op"))                                      
               		tv20 = OpenTable("s", strSQL);                                      
               		strSQL = "select * from VSP21 where Fid="+sqlTo(VSP17_table.getValue("Fid"))+
                                      " and Fdb_sc="+sqlTo(VSP17_table.getValue("Fdb_sc"))+
                                      " and Fdb_su="+sqlTo(VSP17_table.getValue("Fdb_su"))+
                                      " and Fdb_st="+sqlTo(VSP17_table.getValue("Fdb_st"))+
                                      " and Fdb_cod1="+sqlTo(VSP17_table.getValue("Fdb_cod1"))+
                                      " and Fdb_cod2="+sqlTo(VSP17_table.getValue("Fdb_cod2"))+
                                      " and Fdb_cod3="+sqlTo(VSP17_table.getValue("Fdb_cod3"))+
                                      " and Fwid_org="+sqlTo(VSP17_table.getValue("Fwid_org"))+
                                      //" and Fpodr2="+sqlTo(VSP17_table.getValue("Fpodr2"))+
                                      //" and Fpodr3="+sqlTo(VSP17_table.getValue("Fpodr3"))+
                                      " and Fkod_kat="+sqlTo(VSP17_table.getValue("Fkod_kat"))+
                                      " and Finval="+sqlTo(VSP17_table.getValue("Finval"))+
                                      " and Fproc="+sqlTo(VSP17_table.getValue("Fproc"))+
                                      " and Fnazv_op="+sqlTo(VSP17_table.getValue("Fnazv_op"))                                      
               		tv21 = OpenTable("s", strSQL);                                      
                  	if (VSP17_table.getValue("F1000")==true){
                     	if (!tv20.IsEmpty() && tv20.getValue("Fsum")!=0){
                     		if (!tv21.IsEmpty()){
               					ExecuteSQL("UPDATE VSP17 set Fsum="+sqlRound("Fproc*"+tv21.getValue("Fsum")+"*Fsum"+"/100",2)+" where Fgr_b="+sqlTo(locstr))                     		
    	                    	//VSP17_table("Fsum") = Math.round(VSP21_table("Fsum")*VSP17_table("Fsum")/VSP20_table("Fsum")*VSP17_table("Fproc"))/100;
                     		}	
            	        }else{
	                   	    //VSP17_table("Fsum") = 0;
               				ExecuteSQL("UPDATE VSP17 set Fsum=0 where Fgr_b="+sqlTo(locstr))
    	                 } 
        	        }else{
           				ExecuteSQL("UPDATE VSP17 set Fsum="+sqlRound("Fproc*Fsum/100",2)+" where Fgr_b="+sqlTo(locstr))        	        	  
                     	//VSP17_table("Fsum") = Math.round(VSP17_table("Fsum")*VSP17_table("Fproc"))/100;
                  	} 
                  	tv20.Close()                  	
                  	tv21.Close()
               	}
	         	VSP17_table.MoveNext();
       		}            
            
            setProgressPos(nPos++, sTxt);

	       	//**********************************************************
	       	//* шаг 11  - окончательная группировка данных по корреспонденциям счетов
	       	//**********************************************************
  			
       		VSP17_table = OpenTable("s", "VSP17");   
       		VSP17_table.index = "VSP_PI";
       		if (SQL)
				VSP17_table.index = "FDB_SC,FDB_SU,FDB_ST,FCR_SC,FCR_SU,FCR_ST";
     
       		var no_empty = false;
  			var mFdoc_num = '1';
       		if (!VSP17_table.IsEOF())
       		{ 
          		prew1 = VSP17_table.getValue("Fdb_sc");
          		prew2 = VSP17_table.getValue("Fdb_su");
          		prew6 = VSP17_table.getValue("Fdb_st");
          		prew8 = VSP17_table.getValue("Fdb_cod1");
          		prew10 = VSP17_table.getValue("Fdb_cod2");
          		prew11 = VSP17_table.getValue("Fdb_cod2");
          		prew3 = VSP17_table.getValue("Fcr_sc");
          		prew4 = VSP17_table.getValue("Fcr_su");
          		prew7 = VSP17_table.getValue("Fcr_st");
          		prew9 = VSP17_table.getValue("Fcr_cod1");
          		prew12 = VSP17_table.getValue("Fcr_cod2");
          		prew14 = VSP17_table.getValue("Fcr_cod3");
          		//var prew5 = "разноска по счетам"
          		prew5 = VSP17_table.getValue("Fnazv_op");
          		prew15 = VSP17_table.getValue("Forg0");
          		ssum  = VSP17_table.getValue("Fsum");      
          		
          		var stop = false;
          		no_empty = true;
          		VSP17_table.MoveNext();
       		}    
			setProgressPos(nPos++, sTxt);
       		if (!VSP17_table.IsEOF())
       		{  
          		while (true)
          		{ 
             		if (VSP17_table.IsEOF()
             		 ||(Number(prew1)!=Number(VSP17_table.getValue("Fdb_sc")))
             		 ||(Number(prew2)!=Number(VSP17_table.getValue("Fdb_su")))
             		 ||(Number(prew6)!=Number(VSP17_table.getValue("Fdb_st")))
             		 ||(Number(prew3)!=Number(VSP17_table.getValue("Fcr_sc")))
             		 ||(Number(prew4)!=Number(VSP17_table.getValue("Fcr_su")))
             		 ||(Number(prew7)!=Number(VSP17_table.getValue("Fcr_st")))
             		 ||(Number(prew8)!=Number(VSP17_table.getValue("Fdb_cod1")))
             		 ||(Number(prew9)!=Number(VSP17_table.getValue("Fcr_cod1")))
                	 ||(Number(prew10)!=Number(VSP17_table.getValue("Fdb_cod2")))
                	 ||(Number(prew12)!=Number(VSP17_table.getValue("Fcr_cod2"))) 
                	 ||(Number(prew11)!=Number(VSP17_table.getValue("Fdb_cod3")))
                	 ||(Number(prew14)!=Number(VSP17_table.getValue("Fcr_cod3")))
                	 ||(Number(prew15)!=Number(VSP17_table.getValue("Forg0")))
                	 ||(prew5!=VSP17_table.getValue("Fnazv_op")))                	 
                	{
                		//var _fid = GetUID();
                		newN = true;                		
                		//Файл результатов разноски
                		strSQL = "select Fnum from ^RAZN "
                			+" where Fdb_sc="+prew1
                			  +" and Fdb_su="+prew2
                         	  +" and Fdb_st="+prew6
                         	  +" and Fdb_cod1="+prew8
                         	  +" and Fdb_cod2="+prew10
                         	  +" and Fdb_cod3="+prew11
                         	  +" and Fcr_sc="+prew3
                         	  +" and Fcr_su="+prew4
                         	  +" and Fcr_st="+prew7
                         	  +" and Fcr_cod1="+prew9
                         	  +" and Fcr_cod2="+prew12
                         	  +" and Fcr_cod3="+prew14
                         	  +" and Fnazv_op="+sqlTo(prew5)
                         	  +" and Forg0="+prew15;                         	  

                		gnum = 0;
                		trz = getSnap(strSQL);                		
                		if (trz!=null)
                		{
                   			gnum = trz[0];
                		}

		                sSql = "INSERT INTO ^SCHR"+ monthtxt1 
		                		+"(Fnum,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
		                		+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
		                		+",Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num,Forg0) "
		                	+" VALUES ("+gnum+", "+prew1+", "+prew2+", "+prew6+", "
		                		+prew8+", "+prew10+", "+prew11+", "+prew3+", "+prew4+", "
		                		+prew7+", "+prew9+", "+prew12+", "+prew14+", "+ssum+", "
		                		+sqlTo(prew5)+", 5, "+sqlTo(DD2)+", "+sqlTo(mFdoc_num)+", "+prew15+")";
		                ExecuteSQL(sSql);
		                ssum = 0;
             		}
             		else
                		newN = false;
        
             		if (stop) 
             			break;
        
             		ssum  = Number(ssum) + Number(VSP17_table.getValue("Fsum"));

	             	prew1 = VSP17_table.getValue("Fdb_sc");
	             	prew2 = VSP17_table.getValue("Fdb_su");
	             	prew6 = VSP17_table.getValue("Fdb_st");
	             	prew8 = VSP17_table.getValue("Fdb_cod1");
	             	prew10 = VSP17_table.getValue("Fdb_cod2");
	             	prew11 = VSP17_table.getValue("Fdb_cod3");
	             	prew3 = VSP17_table.getValue("Fcr_sc");
	             	prew4 = VSP17_table.getValue("Fcr_su");
	             	prew7 = VSP17_table.getValue("Fcr_st");
	             	prew9 = VSP17_table.getValue("Fcr_cod1");
	             	prew12 = VSP17_table.getValue("Fcr_cod2");
	             	prew14 = VSP17_table.getValue("Fcr_cod3");
	             	//prew5 = "разноска по счетам";
	             	prew5 = VSP17_table.getValue("Fnazv_op");
	             	prew15 = VSP17_table.getValue("Forg0");
	             	
	             	VSP17_table.MoveNext()
	        
	             	if (VSP17_table.IsEOF())
	               		stop = true;
          		}
       		}
       		else if (no_empty)
       		{
          		//var _fid = GetUID();
          		//Файл результатов разноски       	
	          	sSql = "INSERT INTO ^SCHR"+ monthtxt1 
		           		+"(Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
		                +",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
		                +",Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num,Forg0) "
		          	+" VALUES ("+prew1+", "+prew2+", "+prew6+", "
		            	+prew8+", "+prew10+", "+prew11+", "+prew3+", "+prew4+", "
		                +prew7+", "+prew9+", "+prew12+", "+prew14+", "+ssum+", "
		                +sqlTo(prew5)+", 5, "+sqlTo(DD2)+", "+sqlTo(mFdoc_num)+", "+prew15+")";
		      	ExecuteSQL(sSql);
       		}
       		setProgressPos(nPos++, sTxt);    
     	}
  	}

  	//**********************************************************
  	//*кусок по разноске сумм к выплате по табельным номерам
  	//**********************************************************
     
  	RAZN_table = OpenTable("SELECT r.*,so.Fleftkey,so.Frightkey "
  						+" FROM ^RAZN as r INNER JOIN ^STRU_ORG as so ON r.Fwid_org=so.Fwid "
			  			+" WHERE r.Fis_tabn="+sqlTrue
  						+" ORDER BY FLSFID");

	setProgressPos(nPos++, sTxt);
/*
  	sSql = "INSERT INTO VSPTN v (FSUM, Fwid_wp, FLSFID, FFLD_NUM, FVP, FMN)"
  		+" SELECT FSUM, "+ Fwid_wp +" as Fwid_wp, FLSFID, FFLD_NUM, FVP, FMN "
  		+" FROM ^SVZP"+ monthtxt1 +" z "
  			+" INNER JOIN ^RAZN r on r.Flsfid=z.Flsfid "
  		+" WHERE r.Fis_tabn="+sqlTrue;
  	ExecuteSQL(sSql);
*/  	
/*  	var Fwid_wp = "(select MAX(pers.Fwid) from ^WORK_PERS pers where pers.Fwid_cl=z."+sFtabn+")";
  	var Fdb_cod1 = IIF("r.Fdbcr<>"+SqlTrue, "r.Fdb_cod1", Fwid_wp);
    var Fcr_cod1 = IIF("r.Fdbcr<>"+SqlTrue, Fwid_wp, "r.Fcr_cod1");
  	
  	sSql = "INSERT INTO VSP5"
			+"(Fdb_sc,Fdb_su,Fdb_st,Fcr_sc,Fcr_su,Fcr_st,Fdb_cod1,Fcr_cod1,Fsum,Fnazv_op,Fwid) "
		+" SELECT r.Fdb_sc,r.Fdb_su,r.Fdb_st,r.Fcr_sc,r.Fcr_su,r.Fcr_st"
			+","+Fdb_cod1+" as Fdb_cod1, "+Fcr_cod1+" as Fcr_cod1,z.Fsum,r.Fnazv_op,z.Fwid"
		+" FROM ^SVZP"+ monthtxt1 +" z "
  			+" INNER JOIN ^RAZN r on r.Flsfid=z.Flsfid "
  		+" WHERE z.Fsum<>0 AND r.Fis_tabn="+sqlTrue;
	ExecuteSQL(sSql);
*/
  	CreateTable("VSPTN", "VSP", "*");
  	while (!RAZN_table.IsEOF())
  	{
     	//для ускорения лучше в цикле не создавать таблицу, а удалять записи
     	ExecuteSQL("delete from VSPTN");     	
     	//Из SVZP нужно брать Ftabn_id и Fwid_wp, потом для нулевых Fwid_wp (не начислений) находить максимальный на месяц расчета, чтобы определить их подразделение
     	//Т.к. Fwid_wp проставляется в SVZP только для начислений, то для полей ЛС удержаний из настройки не коректно будет расчитываться разноска в разрезе таб.№ для подразделений,
     	//в которых были переводы из одного подразделения в другое 
     	var mFlsfid = RAZN_table.getValue("Flsfid");
     	var proc = toScrObj(RAZN_table.getValue("Fproc"));
     	var isInval = toScrObj(RAZN_table.getValue("Finval"));
     	var kodKat = toScrObj(RAZN_table.getValue("Fkod_kat"));

     	ExecuteSQL("INSERT INTO VSPTN(FSUM, FTABN_ID, FWID_WP, FLSFID, FFLD_NUM, FVP, FMN) "
     				+" SELECT FSUM, Ftabn_id, Fwid_wp, FLSFID, FFLD_NUM, FVP, FMN "
               		+" FROM ^SVZP"+ monthtxt1 
               		+" WHERE Flsfid="+sqlTo(mFlsfid)); 
		ExecuteSQL("UPDATE VSPTN SET Ftabn=(SELECT Fcod FROM ^clrelclcl as r WHERE r.Fwid_cl=VSPTN.Ftabn_id)");
		var dat1 = firstDayMonth(res_mon);
		var dat2 = lastDayMonth(res_mon);
		ExecuteSQL("UPDATE VSPTN SET Fwid_wp=(SELECT MAX(Fwid) FROM ^work_pers as wp "
					+" WHERE wp.Fwid_cl=VSPTN.Ftabn_id AND wp.Fbdat<="+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1)+") "
				+" WHERE Fwid_wp=0 OR Fwid_wp is null");
     	//отбираем по всем вложеным подразделениям из настройки и по признаку инвалидности
     	var leftkey = RAZN_table.getValue("Fleftkey");
     	var rightkey = RAZN_table.getValue("Frightkey");
     	var VSPTN_table = OpenTable("select v.* from VSPTN as v inner join ^full_pers as f ON v.Fwid_wp=f.Fwid "
     						+" where f.Fleftkey>="+leftkey+" and f.Frightkey<="+rightkey+" and f.Finval="+(isInval?sqlTrue:sqlFalse)
     							+(kodKat?" and f.Fcodkat="+kodKat:"")
     						+" order by v.Ftabn");

     	VSPTN_table.MoveFirst();
        while (!VSPTN_table.IsEOF())
        {
           	ssum = round(Number(VSPTN_table.getValue("Fsum"))*proc/100,2);
           	if(ssum!=0)
           	{              	
              	var Fdb_sc = RAZN_table.getValue("Fdb_sc");
              	var Fdb_su = RAZN_table.getValue("Fdb_su");
              	var Fdb_st = RAZN_table.getValue("Fdb_st");
              	var Fcr_sc = RAZN_table.getValue("Fcr_sc");
              	var Fcr_su = RAZN_table.getValue("Fcr_su");
              	var Fcr_st = RAZN_table.getValue("Fcr_st");
              	//var Fsum = VSPTN_table.getValue("Fsum")*proc/100;
              	var Fnazv_op = RAZN_table.getValue("Fnazv_op");
              	var Forg0 = RAZN_table.getValue("Forg0");
              	              	
              	if (RAZN_table.getValue("Fdbcr")==false)
              	{  
                 	var Fdb_cod1 = RAZN_table.getValue("Fdb_cod1");
					var	Fcr_cod1 = VSPTN_table.getValue("Ftabn");
				                 	
                 	if (Number(RAZN_table.getValue("Ffld_num"))==1)
                 	{
               		
                    	//Fcr_cod1 = xcl(getPar("CODPERS"), VSPTN_table.getValue("Ftabn"), "TABN2");
                    	/* пока не работает

                    	   	oCl = getSnap("select FTABN2 from ^CL_"+getPar("CODPERS")
               				+" WHERE FMAINWID=(select max(pers.FWID_CL) "
               					+" from ^WORK_PERS pers where pers.FWID=V.Ftabn)");
               			if(oCl!=null)
               				Fcr_cod1 = oCl[0];
               		    */
                 	}                 	
              	}
              	else
              	{
                 	var Fcr_cod1 = RAZN_table.getValue("Fcr_cod1");
                  	var Fdb_cod1 = VSPTN_table.getValue("Ftabn");                 	
                 	if (Number(RAZN_table.getValue("Ffld_num"))==1)
                 	{
                    	//Fdb_cod1 = xcl(getPar("CODPERS"), VSPTN_table.getValue("Ftabn"), "TABN2");
                    	/*
                    	oCl = getSnap("select FTABN2 from ^CL_"+getPar("CODPERS")
               				+" WHERE FMAINWID=(select max(pers.FWID_CL) "
               					+" from ^WORK_PERS pers where pers.FWID=V.Ftabn)");
               			if(oCl!=null)
               				Fdb_cod1 = oCl[0];
               			*/
                 	}                 	
              	}              
              	sSql = "INSERT INTO VSP5"
		           		+"(Fdb_sc,Fdb_su,Fdb_st,Fcr_sc,Fcr_su,Fcr_st,Fdb_cod1,Fcr_cod1,Fsum,Fnazv_op,Forg0) "
		          	+" VALUES ("+Fdb_sc+", "+Fdb_su+", "+Fdb_st+", "+Fcr_sc+", "+Fcr_su+", "+Fcr_st
		          		+", "+Fdb_cod1+", "+Fcr_cod1+", "+ssum+", "+sqlTo(Fnazv_op)+", "+Forg0+")";
		      	ExecuteSQL(sSql);
           	}
           	VSPTN_table.MoveNext();
        }
        VSPTN_table.close();
        RAZN_table.MoveNext();
     }
     setProgressPos(nPos++, sTxt);  
	
	 var mFdoc_num = '1';     
     var fnum = "(select r.Fnum from ^RAZN r "
     		  +" where r.Fdb_sc	= v.Fdb_sc"
        	  	+" and r.Fdb_su	= v.Fdb_su"
        	  	+" and r.Fdb_st	= v.Fdb_st"
        	  	+" and r.Fdb_cod1 = v.Fdb_cod1"
        	  	+" and r.Fcr_sc	= v.Fcr_sc"
        	  	+" and r.Fcr_su = v.Fcr_su"
        	  	+" and r.Fcr_st = v.Fcr_st"
        	  	+" and r.Forg0 = v.Forg0"
        	  	+" and r.Fcr_cod1 = v.Fcr_cod1)";        
     sSql = "INSERT INTO ^SCHR"+ monthtxt1 
				+"(Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
		        +",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
		        +",Fnum,Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num,Forg0) "
		 	+" SELECT "
		 		+" Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,0 as Fdb_cod2,0 as Fdb_cod3"
		 		+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,0 as Fcr_cod2,0 as Fcr_cod3"
		 		+","+ fnum +" as Fnum, Fsum, Fnazv_op"
		 		+",5 as Fwrk, "+ sqlTo(DD2) +" as Fdate,"+ sqlTo(mFdoc_num) +" as Fdoc_num, Forg0 "
		 	+" FROM VSP5 v";
	ExecuteSQL(sSql);
  	
	setProgressPos(nPos++, sTxt);

	DropTable("tschr");
	strSQL = "select Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
  				+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
  			  	+",Fnazv_op,Fdate,Fdoc_num"
  				+", sum(schr.Fsum) as Fsum, Forg0 "
  			+" into tschr "
  			+" from ^schr"+monthtxt1 +" schr "
  			+" group by Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
  				+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
  				+",Fdate,Fdoc_num,Fnazv_op,Forg0";  			
  	ExecuteSQL(strSQL);
  	
  	strSQL = "DELETE from ^schr"+monthtxt1;
  	ExecuteSQL(strSQL); 	
	setProgressPos(nPos++, sTxt);
	
	var sFlds = "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
			  +",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
			  +",Fsum,Fnazv_op,Fdate,Fdoc_num,Forg0";
	sSql = "INSERT INTO schr"+monthtxt1+"("+ sFlds +",Fwrk) "
		+" SELECT "+ sFlds +", 5 as Fwrk FROM ^tschr"
		+" WHERE FSUM<>0";
	ExecuteSQL(sSql);
	
	//результат каждой разноски будем записывать в свою таблицу
	var tblName = "razn2b"+monthtxt1;
	DropTable(tblName)
	ExecuteSQL("select * into "+tblName+" from schr"+monthtxt1);
    
    setProgressPos(0);
    DefVed.end();    
    return true;
}

function getSum(i)
{  
    //*********************************************************************
    //* шаг 2 - проставить код фонда и корресп.счетов  для записей из SVZP
    //*********************************************************************
    
    CreateTable("VSP11", "VSP_P", "*");                          
            
    //**********************************************************
    //* шаг 3 - пройти по записям разноски по счетам и для каждой
    //* строки вытащить из VSP суммы по сотрудникам, которые
    //* соответствуют строке разноски по полю ЛС, подр. и категории 
	//**********************************************************    

    //strSQL = "Update VSPZ "
    //		+" set Flv2=(select max(r.Fpodr2) from ^RAZN r where r.Fpodr=VSPZ.Flv1)"
    //			+",Flv3=(select max(r.Fpodr3) from ^RAZN r where r.Fpodr=VSPZ.Flv1)";
    //ExecuteSQL(strSQL);       		
	setProgressPos(nPos++, sTxt);
	
	var sFld = "Fwid_wp,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
				+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
				+",Fid,Fproc,Fsum,Flsfid,Fvp,Fmn"
       			+",Fprizn,Fis_tabn,F1000,Fnazv_op,Finval"
       			+",Fznak,Fkod_kat,Fwid_org,Forg0";
	var sSel = " SELECT z.Ftabn,r.Fdb_sc,r.Fdb_su,r.Fdb_st,r.Fdb_cod1,r.Fdb_cod2,r.Fdb_cod3"
				+",r.Fcr_sc,r.Fcr_su,r.Fcr_st,r.Fcr_cod1,r.Fcr_cod2,r.Fcr_cod3"
				+",r.Fid,r.Fproc,z.Fsum,z.Flsfid,z.Fvp,z.Fmn"
       			+",r.Fprizn,r.Fis_tabn,r.F1000,r.Fnazv_op,z.Finval"
       			//+",0 as Fznak,0 as Fkod_kat,0 as Flv1,0 as Flv2,0 as Flv3"
	
	var Fznak = IIF("r.Fproc<0", -1, 1);
	//var Fkod_kat = 0;
    //var Flv1 = 0;
    //var Flv2 = 0;
    //var Flv3 = 0;	
	
	sSql = "INSERT INTO VSP11 ("+ sFld +") "       		
       		+ sSel +","+ Fznak +" as Fznak, 0 as Fkod_kat, z.Fwid_org, r.Forg0"
       		//+" 0 as Flv1, 0 as Flv2, 0 as Flv3 "
       		+" FROM ^RAZN r "
       			+" INNER JOIN VSPZ z "
       				+" ON z.Flsfid=r.Flsfid "
       				+" AND z.Finval=r.Finval"
       		+" WHERE r.Fwid_org="+sqlTo(baseOrg)+" AND r.Fkod_kat=0" ;
    ExecuteSQL(sSql);
    setProgressPos(nPos++, sTxt);
    
    sSql = "INSERT INTO VSP11 ("+ sFld +") "
       		+ sSel +","+ Fznak +" as Fznak, z.Fkod_kat as Fkod_kat, z.Fwid_org, r.Forg0"
       		//+ " 0 as Flv1, 0 as Flv2, 0 as Flv3 "
       		+" FROM ^RAZN r "
       			+" INNER JOIN VSPZ z "
       				+" ON z.Flsfid=r.Flsfid "
       				+" AND z.Finval=r.Finval "
       				+" AND z.Fkod_kat=r.Fkod_kat "
       		+" WHERE r.Fwid_org="+sqlTo(baseOrg)+" AND r.Fkod_kat<>0" ;
    ExecuteSQL(sSql);
    setProgressPos(nPos++, sTxt);
    
    //нужно выбирать и все вложенные подразделения по левым и правым ключам
    sSql = "INSERT INTO VSP11 ("+ sFld +") "
       		+ sSel +","+ Fznak +" as Fznak, 0 as Fkod_kat, z.Fwid_org, r.Forg0"
       		+" FROM ^RAZN r "
       			+" LEFT JOIN ^STRU_ORG as sr ON r.Fwid_org=sr.Fwid "
       			+" INNER JOIN VSPZ z "
       				+" ON z.Flsfid=r.Flsfid "
       				+" AND z.Finval=r.Finval "
       			+" LEFT JOIN ^STRU_ORG as sz ON z.Fwid_org=sz.Fwid "
       				//+" AND z.Fwid_org=r.Fwid_org "
       		+" WHERE r.Fwid_org<>"+sqlTo(baseOrg)+" AND r.Fkod_kat=0"
       			+" AND sr.Fleftkey<=sz.Fleftkey AND sr.Frightkey>=sz.Frightkey ";
    ExecuteSQL(sSql);
    setProgressPos(nPos++, sTxt);
    
    //нужно выбирать и все вложенные подразделения по левым и правым ключам
    sSql = "INSERT INTO VSP11 ("+ sFld +") "
       		+ sSel +","+ Fznak +" as Fznak, z.Fkod_kat as Fkod_kat, z.Fwid_org, r.Forg0"
       		+" FROM ^RAZN r "       			
       			+" LEFT JOIN ^STRU_ORG as sr ON r.Fwid_org=sr.Fwid "
       			+" INNER JOIN VSPZ z "
       				+" ON z.Flsfid=r.Flsfid "
       				+" AND z.Finval=r.Finval "
       				+" AND z.Fkod_kat=r.Fkod_kat "
       			+" LEFT JOIN ^STRU_ORG as sz ON z.Fwid_org=sz.Fwid "
       				//+" AND z.Fwid_org=r.Fwid_org "
       		+" WHERE r.Fwid_org<>"+sqlTo(baseOrg)+" AND r.Fkod_kat<>0"
       			+" AND sr.Fleftkey<=sz.Fleftkey AND sr.Frightkey>=sz.Frightkey ";
    ExecuteSQL(sSql);           
 
	WAIT (ru("шаг 2","крок 2"));
	//*************************************************************************************
    //* шаг 4 - собрать суммы по корресп.счетов внутри таб.N с учетом Fmn, Fvp  и признака
    //* с учетом знака в проценте (если процент с минусом, то сумма отнимается)
    //*************************************************************************************
    setProgressPos(nPos++, sTxt);

	CreateTable("VSP12", "VSP_P", "*");
    
	/*if(typeof(Fpodr2)!="undefined")
	{
     	ExecuteSQL("ALTER TABLE VSP12 DROP COLUMN Fpodr2");
     	ExecuteSQL("ALTER TABLE VSP12 DROP COLUMN Fpodr3");
    }
	ExecuteSQL("ALTER TABLE VSP12 ADD Fpodr2 "+ SqlType("LONG"), false);
    ExecuteSQL("ALTER TABLE VSP12 ADD Fpodr3 "+ SqlType("LONG"), false);*/
    setProgressPos(nPos++, sTxt);
    ExecuteSQL("INSERT INTO VSP12(Fsum,Fid,Fwid_wp,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
			  	+ "Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,"
				+ "Fwid_org,Fkod_kat,F1000,Flsfid,Fproc,Fznak,"
				+ "Fprizn,Fis_tabn,Fnazv_op,Fmn,"
				+ "Fvp,Finval,Forg0) "
			+" SELECT SUM(a.FSUM), "
		        + First("a.Fid") + ", "
		    	+ First("a.FWID_WP") + ", "		    	
		        + First("a.Fdb_sc") + ", "
		        + First("a.Fdb_su") + ", "
		        + First("a.Fdb_st") + ", "
		        + First("a.Fdb_cod1") + ", "
		        + First("a.Fdb_cod2") + ", "
		        + First("a.Fdb_cod3") + ", "
		        + First("a.Fcr_sc") + ", "
		        + First("a.Fcr_su") + ", "
		        + First("a.Fcr_st") + ", "
		        + First("a.Fcr_cod1") + ", "
		        + First("a.Fcr_cod2") + ", "
		        + First("a.Fcr_cod3") + ", "
		        //+ First("a.Flv1") + ", "
		        //+ First("a.Flv2") + ", "
		        //+ First("a.Flv3") + ", "
		        + First("a.Fwid_org") + ", "
		        + First("a.Fkod_kat") + ", "
		        + First(Convert("a.F1000", "INT")) + ", "
		        + First("a.Flsfid") + ", "
		        + First("a.Fproc") + ", "
		        + First("a.Fznak") + ", "
		        + First("a.Fprizn") + ", "
		        + First(Convert("a.Fis_tabn", "INT")) + ", "
		        + First("a.Fnazv_op") + ", "
		        + First("a.Fmn") + ", "
		        + First("a.Fvp") + ", "
		        + First(Convert("a.Finval", "INT")) + ", "
		        + First("a.Forg0")
	      	+ " FROM VSP11 a "
	        + " group by Fwid_wp,Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
	          	+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
	          	+",Fwid_org,Fkod_kat,Finval,Flsfid,Fmn,Fvp,Fproc,F1000"
	          	+",Fznak,Fprizn,Fis_tabn,Fnazv_op,Forg0");
	          
	WAIT(ru("шаг 3","крок 3"));
    //**********************************************************
    //* шаг 5 - умножить сумму на знак и заменить знак для процента
    //**********************************************************
    setProgressPos(nPos++, sTxt);
    ExecuteSQL("UPDATE VSP12 SET Fsum = Fsum*Fznak, "
    						 +" Fproc = abs(Fproc), "
    						 +" Ftabnn = FWID_WP ");	  
    
  	CreateTable("VSP14", "VSP_P", "*");                          
    
    setProgressPos(nPos++, sTxt);
	/*if(typeof(Fpodr2)!="undefined")
	{
		ExecuteSQL("ALTER TABLE VSP14 DROP COLUMN Fpodr2");
		ExecuteSQL("ALTER TABLE VSP14 DROP COLUMN Fpodr3");
	}
	ExecuteSQL("ALTER TABLE VSP14 ADD Fpodr2 "+ SqlType("LONG"), false)
	ExecuteSQL("ALTER TABLE VSP14 ADD Fpodr3 "+ SqlType("LONG"), false)*/

	//**********************************************************
	//* шаг 6 - просуммировать для каждого табельного номера
	//* суммы, которые относятся к одной строке разноски
	//**********************************************************
    setProgressPos(nPos++, sTxt);
   	WAIT (ru("шаг 4","крок 4"));
	
	var sFld  = "Fwid_wp,Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
				+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
				+",Fwid_org,Fkod_kat,Finval,Fproc,Fmn,Fvp,Fnazv_op,Forg0";	

	var sumT = IIF("Fvp=0", "Fsum", 0);
	var sumB = IIF("Fvp=2 AND Fmn>"+ sqlTo(DD1), "Fsum", 0);
	var sumP = IIF("Fvp=1 AND Fmn<"+ sqlTo(DD1), "Fsum", 0);
	var fsum = IIF("Fprizn='т'", sumT, IIF("Fprizn='б'", sumB, IIF("Fprizn='п'", sumP, "Fsum")));
	sSql = "INSERT INTO VSP14 ("+ sFld +", Fsum, F1000, Fis_tabn) "
			+" SELECT "+ sFld +", SUM("+ fsum +") as Fsum, "+First(Convert("F1000", "INT"))+" as F1000," +sqlFalse+ " as Fis_tabn "
			+" FROM VSP12 WHERE Fis_tabn=" + SqlFalse +" GROUP BY "+ sFld;
	ExecuteSQL(sSql);
	
	sum_ogr = get_cnst("sum_ogr", D1);
	if(!sum_ogr)
	{
		alert(ru("Не найдена константа суммы ограничения sum_ogr за",
				"Не знайдено константу граничної суми sum_ogr за")+format(" dd.mm.yyyy",D1).toLowerCase());
		return false;
	}
	setProgressPos(nPos++, sTxt);
    
    //кусок для ухода за ребенком
    sum_ux = get_cnst("sum_ux", D1);
    
    strSQL = "UPDATE VSP14 set Fsum="+ sqlTo(sum_ux) +" where Fproc=999";
    ExecuteSQL(strSQL);
    
    strSQL = "UPDATE VSP14 set Fproc=100 where Fproc=999";
    ExecuteSQL(strSQL);

	/* пока не актуально, тратить время на проверку не будем
    //кусок для определения суммы за 1 отраб.день для расчета фондов за 1 день для месяца начисления
    sum1day = get_cnst ("sum1day" , D1);
    is_izmfond = false;
    if(IsTable("sum1day") && Number(sum1day)==1) 
    	is_izmfond = true;
    
    setProgressPos(nPos++, sTxt);
    if (is_izmfond)
    {
    	//закачать записи из изменений для фондов  
        s1 = OpenTable("s", "SUM1DAY");
        if (!s1.IsEmpty())
        {
           	mFprocfzo = s1.getValue("Fprocfzo");
           	mFprocpfo = s1.getValue("Fprocpfo");

           	fis_foundf = false; 
           	strSQL = "select distinct fkod_kat, fwid_org"
           			+",fdb_sc,fdb_su,fdb_st,fdb_cod1,fdb_cod2,fdb_cod3"
           			+",fcr_sc,fcr_su,fcr_st,fcr_cod1,fcr_cod2,fcr_cod3 "
                  +" from ^RAZN where Fproc="+ mFprocpfo;
           	
           	tv14 = OpenTable("s", strSQL);
           	if (!tv14.IsEmpty())
           	{
              	fis_foundf = true; 
           	}    

          	fis_foundz = false; 
          	strSQL = "select distinct fkod_kat, Fwid_org"
          				+",fdb_sc,fdb_su,fdb_st,fdb_cod1,fdb_cod2,fdb_cod3"
          				+",fcr_sc,fcr_su,fcr_st,fcr_cod1,fcr_cod2,fcr_cod3 "
                  	+" from ^RAZN where Fproc="+ sqlTo(mFprocfzo);           
           	tvz14 = OpenTable("s", strSQL);
           	if (!tvz14.IsEmpty())
           	{
            	fis_foundz = true; 
            }    
    	}
		setProgressPos(nPos++, sTxt);   
		
		while (!s1.IsEOF())
		{
			mFprocfzo = s1.getValue("Fprocfzo");
			mFprocpfo = s1.getValue("Fprocpfo");
			mFprocfzn = s1.getValue("Fprocfzn");
			mFprocpfn = s1.getValue("Fprocpfn");
			s1Ftabn   = s1.getValue("FWID_WP");
			sFmn      = s1.getValue("Fmn");
			sFvp      = s1.getValue("Fvp");					
			
		    strSQL = "select Fkod_kat,Fwid_org from ^FWID_WP "
		         	+" where FWID="+ s1Ftabn
		            	+" and ((fbdat <="+sqlTo(D1)+" and fedat >="+sqlTo(D2)+" ) "
		             	  +" or (fbdat >="+sqlTo(D1)+" and fbdat <="+sqlTo(D2)+" )"
		               	  +" or (fedat >="+sqlTo(D1)+" and fedat <="+sqlTo(D2)+" ))";
		 	tsht = getSnap(strSQL);
            if (tsht != null)
            {
               	sFkod_kat = tsht[0];
               	sFpodr    = tsht[1];
               	//sFpodr2   = tsht[2];
               	//sFpodr3   = tsht[3];
            }
            else
            {
		    	strSQL = "select Fkod_kat,Fwid_org "
		           		+" from ^FWID_WP where Fwid="+ s1Ftabn;
		        tsht2 = getSnap(strSQL);
		        if (tsht2!=null)
		        {
		        	sFkod_kat = tsht2[0];
		            sFpodr    = tsht2[1];
		            //sFpodr2   = tsht2[2];
		            //sFpodr3   = tsht2[3];
		      	}
		        else
		        {
		        	sFkod_kat = 0;
		            sFpodr    = 0;
		            //sFpodr2   = 0;
		            //sFpodr3   = 0;
		  		}
			}

			sFkod_katd = sFkod_kat;
		    sFpodrd    = sFpodr;
		    //sFpodr2d   = sFpodr2;
		    //sFpodr3d   = sFpodr3;
		
		    kol_rec = 0;
		    DropTable("tvz");		    
		    strSQL = "select distinct p.Fid as Fsht_id "
		    		+" into tvz "
		    		+" from ^WORK_PERS p, VSPZ z "
		    		+" where p.Fwid=z.Fwid_wp "
		    			+" and z.FWID_WP="+ s1Ftabn +" and p.Fid<>0 ";		
		    ExecuteSQL(strSQL);
		    
		    strSQL = "select count(Fsht_id) as kol_rec from ^tvz"    
		    tvz = getSnap(strSQL);
		    if (tvz!=null)
		    { 
		       	kol_rec = tvz[0];
			}
			setProgressPos(nPos++, sTxt);	
		    
		    if (fis_foundf)
		    {
		       	tv14.MoveFirst();  
		       	while (!tv14.IsEOF())
		       	{
		 			if (Number(tv14.getValue("Fkod_kat"))==0)
		 			{
		            	sFkod_kat = 0;
		            } 
		            if (Number(tv14.getValue("Fwid_org"))==0)
		            {
		            	sFpodr = 0;
		                //sFpodr2 = 0;
		                //sFpodr3 = 0;
		        	} 
		            var isKat = Number(tv14.getValue("Fkod_kat"))!=0;
		            var isPodr = Number(tv14.getValue("Fwid_org"))!=0;
		            if (isKat && isPodr)
		            {
		            	if (Number(kol_rec)<=1)
		                {
		                	sFkod_kat = sFkod_katd;
		                    sFpodr    = sFpodrd;
		                    //sFpodr2   = sFpodr2d;
		                    //sFpodr3   = sFpodr3d;
		
		                    if (Number(tv14.getValue("Fkod_kat"))!=Number(sFkod_kat))
		                    {
		                 		sFkod_kat = Number(tv14.getValue("Fkod_kat"));
		                    }
		                    if (Number(tv14.getValue("Fwid_org"))!=Number(sFpodr))
		                    {
		                       	sFpodr  = Number(tv14.getValue("Fwid_org"));
		                       	//sFpodr2 = Number(tv14.getValue("Fpodr2")); 
		                       	//sFpodr3 = Number(tv14.getValue("Fpodr3"));
		                    }
		     			}
		                else
		                {
		                	nKat = Number(tv14.getValue("Fkod_kat"));
		                   	nPodr = Number(tv14.getValue("Fwid_org"));
		                    if (nKat!=0 && nPodr==0)
		                    {
		                    	sFkod_kat = sFkod_katd;
		                        sFpodr = 0;
		                        //sFpodr2 = 0;
		                        //sFpodr3 = 0;
		                 	} 
		                    if (nKat==0 && nPodr!=0)
		                    {
		                    	sFkod_kat = 0;
		                        sFpodr    = sFpodrd;
		                        //sFpodr2   = sFpodr2d;
		                        //sFpodr3   = sFpodr3d;		
		                  	} 
		                    if (nKat!=0 && nPodr!=0)
		                    {
		                     	sFkod_kat = sFkod_katd;
								sFpodr    = sFpodrd;
		                        //sFpodr2   = sFpodr2d;
		                        //sFpodr3   = sFpodr3d;
		                	} 
		           		}
		      		} 
		
		            sFdb_sc   = tv14.getValue("Fdb_sc");
		     		sFdb_su   = tv14.getValue("Fdb_su");
		     		sFdb_st   = tv14.getValue("Fdb_st");
		            sFdb_cod1 = tv14.getValue("Fdb_cod1");
		            sFdb_cod2 = tv14.getValue("Fdb_cod2");
		            sFdb_cod3 = tv14.getValue("Fdb_cod3");
		            sFcr_sc   = tv14.getValue("Fcr_sc");
		            sFcr_su   = tv14.getValue("Fcr_su");
		            sFcr_st   = tv14.getValue("Fcr_st");
		            sFcr_cod1 = tv14.getValue("Fcr_cod1");
		            sFcr_cod2 = tv14.getValue("Fcr_cod2");
		            sFcr_cod3 = tv14.getValue("Fcr_cod3");
		
		            strSQL = "select * from VSP14 "
		            		+" where FWID_WP="+ s1Ftabn +" and Fproc="+ sqlTo(mFprocpfo)
		            			+" and Fmn="+sqlTo(sFmn)+" and Fvp="+sqlTo(sFvp)
		                      	+" and Fkod_kat="+sqlTo(sFkod_kat)+" and Fwid_org="+sqlTo(sFpodr)
		                      	//+" and Fpodr2="+sqlTo(sFpodr2)+" and Fpodr3="+sqlTo(sFpodr3)
		                      	+" and Fdb_sc="+sqlTo(sFdb_sc)+" and Fdb_su="+sqlTo(sFdb_su)
		                      	+" and Fdb_st="+sqlTo(sFdb_st)+" and Fdb_cod1="+sqlTo(sFdb_cod1)
		                      	+" and Fdb_cod2="+sqlTo(sFdb_cod2)+" and Fdb_cod3="+sqlTo(sFdb_cod3)
		                      	+" and Fcr_sc="+sqlTo(sFcr_sc)+" and Fcr_su="+sqlTo(sFcr_su)
		                      	+" and Fcr_st="+sqlTo(sFcr_st)+" and Fcr_cod1="+sqlTo(sFcr_cod1)
		                      	+" and Fcr_cod2="+sqlTo(sFcr_cod2)+" and Fcr_cod3="+sqlTo(sFcr_cod3);
		         
		            tvps14_1 = OpenTable("s", strSQL);
		            if (!tvps14_1.IsEmpty())
		            {
		            	s1Fid =  tvps14_1.getValue("Fid")
		                s1Fdb_sc = tvps14_1.getValue("Fdb_sc");
		                s1Fdb_su = tvps14_1.getValue("Fdb_su");
		                s1Fdb_st = tvps14_1.getValue("Fdb_st");
		                s1Fdb_cod1 = tvps14_1.getValue("Fdb_cod1");
		                s1Fdb_cod2 = tvps14_1.getValue("Fdb_cod2");
						s1Fdb_cod3 = tvps14_1.getValue("Fdb_cod3"); 
						s1Fcr_sc = tvps14_1.getValue("Fcr_sc");
						s1Fcr_su = tvps14_1.getValue("Fcr_su");
						s1Fcr_st = tvps14_1.getValue("Fcr_st");
						s1Fcr_cod1 = tvps14_1.getValue("Fcr_cod1");
						s1Fcr_cod2 = tvps14_1.getValue("Fcr_cod2");
		                s1Fcr_cod3 = tvps14_1.getValue("Fcr_cod3");
		                s1Fsum = s1.getValue("Fpnsizm");
		                s1Ftabn = tvps14_1.getValue("FWID_WP");
		                s1Fpodr = sFpodr;
		                //s1Fpodr2 = sFpodr2;
		                //s1Fpodr3 = sFpodr3;
		                s1Fkod_kat = sFkod_kat;
		                s1Finval = tvps14_1.getValue("Finval"); 
		                s1Fproc = mFprocpfn;
		                s1Fmn = s1.getValue("Fmn");
		                s1Fvp = s1.getValue("Fvp");
		                s1Fis_tabn = tvps14_1.getValue("Fis_tabn");
		                s1F1000 = tvps14_1.getValue("F1000");
		                s1Fnazv_op = tvps14_1.getValue("Fnazv_op");
		         
		                var nSum = Number(tvps14_1.getValue("Fsum")) - Number(s1.getValue("Fpnsizm"));		                
		                ExecuteSQL("UPDATE VSP14 SET Fsum="+ nSum +" WHERE fwid="+ tvps14_1.getValue("Fwid"));
						
						setProgressPos(nPos++, sTxt);
		                strSQL = "select * from VSP14 where FWID_WP="+ s1Ftabn +" and Fproc="+sqlTo(mFprocpfo)+
		                				" and Fmn="+sqlTo(sFmn)+" and Fvp="+sqlTo(sFvp)+
		                        		" and Fkod_kat="+sqlTo(sFkod_kat)+" and Fwid_org="+sqlTo(sFpodr)+" and "+           
		                           		//" Fpodr2="+sqlTo(sFpodr2)+" and Fpodr3="+sqlTo(sFpodr3)+" and "+
		                           		" Fdb_sc="+sqlTo(sFdb_sc)+" and Fdb_su="+sqlTo(sFdb_su)+" and "+
		                           		" Fdb_st="+sqlTo(sFdb_st)+" and Fdb_cod1="+sqlTo(sFdb_cod1)+" and "+
		                           		" Fdb_cod2="+sqlTo(sFdb_cod2)+" and Fdb_cod3="+sqlTo(sFdb_cod3)+" and "+
		                           		" Fcr_sc="+sqlTo(sFcr_sc)+" and Fcr_su="+sqlTo(sFcr_su)+" and "+
		                           		" Fcr_st="+sqlTo(sFcr_st)+" and Fcr_cod1="+sqlTo(sFcr_cod1)+" and "+
		                           		" Fcr_cod2="+sqlTo(sFcr_cod2)+" and Fcr_cod3="+sqlTo(sFcr_cod3);		                        
		               	tvps14_3 = getSnap(strSQL);
		                if (tvps14_3!=null)
		                {
		                	sSql = "INSERT INTO VSP14 "
		                    		+"(Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
		                           		+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
		                           		+",Fsum,FWID_WP,Fwid_org,Fkod_kat,Finval"
		                           		+",Fproc,Fmn,Fvp,Fis_tabn,F1000,Fnazv_op) "
		                           	+" VALUES ("+s1Fid+", "+s1Fdb_sc+", "+s1Fdb_su+", "+s1Fdb_st
		                           		+", "+s1Fdb_cod1+", "+s1Fdb_cod2+", "+s1Fdb_cod3
		                           		+", "+s1Fcr_sc+", "+s1Fcr_su+", "+s1Fcr_st
		                           		+", "+s1Fcr_cod1+", "+s1Fcr_cod2+", "+s1Fcr_cod3
		                           		+", "+s1Fsum+", "+s1Ftabn+", "+s1Fpodr
		                           		+", "+s1Fkod_kat+", "+sqlTo(s1Finval)+", "+s1Fproc
		                           		+", "+sqlTo(s1Fmn)+", "+s1Fvp+", "+sqlTo(s1Fis_tabn)
		                           		+", "+sqlTo(s1F1000)+", "+sqlTo(s1Fnazv_op)+")";
		               		ExecuteSQL(sSql);		                           	
		            	}		                        		                         
		        	}
		        	tvps14_1.close(); 
		            tv14.MoveNext();		            
		     	}
		 	}
             
            if (fis_foundz)
            {
            	tvz14.MoveFirst();  
                while (!tvz14.IsEOF())
                {
                	if (Number(tvz14.getValue("Fkod_kat"))==0)
                   	{
                     	sFkod_kat = 0;
                   	} 
                   	if (Number(tvz14.getValue("Fwid_org"))==0)
                   	{
                    	sFpodr = 0;
                      	//sFpodr2 = 0;
                      	//sFpodr3 = 0;
                  	} 
                   	if (!(Number(tvz14.getValue("Fkod_kat"))==0 && Number(tvz14.getValue("Fwid_org"))==0))
                   	{
		            	sFkod_kat = sFkod_katd;
		                sFpodr    = sFpodrd;
		                //sFpodr2   = sFpodr2d;
		                //sFpodr3   = sFpodr3d;
		                if (kol_rec<=1)
		                {
		                 	sFkod_kat = sFkod_katd;
							sFpodr    = sFpodrd;
		                    //sFpodr2   = sFpodr2d;
							//sFpodr3   = sFpodr3d;
		
							if (Number(tvz14.getValue("Fkod_kat"))!=Number(sFkod_kat))
		                    {
		                    	sFkod_kat = Number(tvz14.getValue("Fkod_kat"));
		                   	}
		                    if (Number(tvz14.getValue("Fwid_org"))!=Number(sFpodr))
		                    {
		                    	sFpodr    = Number(tvz14.getValue("Fwid_org"));
		                        //sFpodr2   = Number(tvz14.getValue("Fpodr2")); 
		                        //sFpodr3   = Number(tvz14.getValue("Fpodr3"));
		                  	}
		            	}
		                else
		                {
		                 	if (Number(tvz14.getValue("Fkod_kat"))!=0 && Number(tvz14.getValue("Fwid_org"))==0)
		                    {
		                    	sFkod_kat = sFkod_katd;
		                        sFpodr 	  = 0;
		                        //sFpodr2   = 0;
		                        //sFpodr3   = 0;
		                    } 
		                    if (Number(tvz14.getValue("Fkod_kat"))==0 && Number(tvz14.getValue("Fwid_org"))!=0)
		                    {
		                    	sFkod_kat = 0;
		                        sFpodr    = sFpodrd;
		                        //sFpodr2   = sFpodr2d;
		                        //sFpodr3   = sFpodr3d;
		                  	} 
		                    if (Number(tvz14.getValue("Fkod_kat"))!=0 && Number(tvz14.getValue("Fwid_org"))!=0)
		                    {
		                    	sFkod_kat = sFkod_katd;
		                        sFpodr    = sFpodrd;
		                        //sFpodr2   = sFpodr2d;
		                        //sFpodr3   = sFpodr3d;
		                  	} 
		              	}
		      		}
		            sFdb_sc   = tv14z.getValue("Fdb_sc");
		            sFdb_su   = tv14z.getValue("Fdb_su");
		            sFdb_st   = tv14z.getValue("Fdb_st");
		            sFdb_cod1 = tv14z.getValue("Fdb_cod1");
		            sFdb_cod2 = tv14z.getValue("Fdb_cod2");
		            sFdb_cod3 = tv14z.getValue("Fdb_cod3");
		            sFcr_sc   = tv14z.getValue("Fcr_sc");
		            sFcr_su   = tv14z.getValue("Fcr_su");
		            sFcr_st   = tv14z.getValue("Fcr_st");
		            sFcr_cod1 = tv14z.getValue("Fcr_cod1");
		            sFcr_cod2 = tv14z.getValue("Fcr_cod2");
		            sFcr_cod3 = tv14z.getValue("Fcr_cod3");
					setProgressPos(nPos++, sTxt);
		            strSQL = "select * from VSP14 where FWID_WP="+ s1Ftabn +" and Fproc="+sqlTo(mFprocfzo)+
		            			" and Fmn="+sqlTo(s1.getValue("Fmn"))+" and Fvp="+sqlTo(s1.getValue("Fvp"))+
		                    	" and Fkod_kat="+sqlTo(sFkod_kat)+" and Fwid_org="+sqlTo(sFpodr)+" and "+           
		                    	//" Fpodr2="+sqlTo(sFpodr2)+" and Fpodr3="+sqlTo(sFpodr3)+" and "+
		                      	" Fdb_sc="+sqlTo(sFdb_sc)+" and Fdb_su="+sqlTo(sFdb_su)+" and "+
		                      	" Fdb_st="+sqlTo(sFdb_st)+" and Fdb_cod1="+sqlTo(sFdb_cod1)+" and "+
		                      	" Fdb_cod2="+sqlTo(sFdb_cod2)+" and Fdb_cod3="+sqlTo(sFdb_cod3)+" and "+
		                      	" Fcr_sc="+sqlTo(sFcr_sc)+" and Fcr_su="+sqlTo(sFcr_su)+" and "+
		                      	" Fcr_st="+sqlTo(sFcr_st)+" and Fcr_cod1="+sqlTo(sFcr_cod1)+" and "+
		                      	" Fcr_cod2="+sqlTo(sFcr_cod2)+" and Fcr_cod3="+sqlTo(sFcr_cod3)
					tvps14_2 = OpenTable("s", strSQL);
		            
		            if (!tvps14_2.IsEmpty())
		            {
		            	s1Fid =  tvps14_2.getValue("Fid");
		                s1Fdb_sc = tvps14_2.getValue("Fdb_sc");
		                s1Fdb_su = tvps14_2.getValue("Fdb_su");
		                s1Fdb_st = tvps14_2.getValue("Fdb_st");
		                s1Fdb_cod1 = tvps14_2.getValue("Fdb_cod1");
		                s1Fdb_cod2 = tvps14_2.getValue("Fdb_cod2");
						s1Fdb_cod3 = tvps14_2.getValue("Fdb_cod3"); 
						s1Fcr_sc = tvps14_2.getValue("Fcr_sc");
		                s1Fcr_su = tvps14_2.getValue("Fcr_su");
		                s1Fcr_st = tvps14_2.getValue("Fcr_st");
		                s1Fcr_cod1 = tvps14_2.getValue("Fcr_cod1");
		                s1Fcr_cod2 = tvps14_2.getValue("Fcr_cod2");
		                s1Fcr_cod3 = tvps14_2.getValue("Fcr_cod3");
		                s1Fsum = s1.getValue("Fzanizm");
		                s1Ftabn = tvps14_2.getValue("FWID_WP");
		                s1Fpodr = sFpodr;
		                //s1Fpodr2 = sFpodr2;
		                //s1Fpodr3 = sFpodr3;
		                s1Fkod_kat = sFkod_kat;
		                s1Finval = tvps14_2.getValue("Finval"); 
		                s1Fproc = mFprocfzn;
		                s1Fmn = s1.getValue("Fmn");
		                s1Fvp = s1.getValue("Fvp");
		                s1Fis_tabn = tvps14_2.getValue("Fis_tabn");
		                s1F1000 = tvps14_2.getValue("F1000");
		                s1Fnazv_op = tvps14_2.getValue("Fnazv_op");
		              
		                var nSum = Number(tvps14_2.getValue("Fsum")) - Number(s1.getValue("Fzanizm"));		                		                      	
		                ExecuteSQL("UPDATE VSP14 SET Fsum="+ nSum +" WHERE Fwid="+tvps14_2.getValue("Fwid"));
						setProgressPos(nPos++, sTxt);
		                
		                strSQL = "select * from VSP14 where FWID_WP="+ s1Ftabn +" and Fproc="+sqlTo(mFprocfzo)+
		                			" and Fmn="+sqlTo(s1.getValue("Fmn"))+" and Fvp="+sqlTo(s1.getValue("Fvp"))+
		                      		" and Fkod_kat="+sqlTo(sFkod_kat)+" and Fwid_org="+sqlTo(sFpodr)+" and "+           
		                      		//" Fpodr2="+sqlTo(sFpodr2)+" and Fpodr3="+sqlTo(sFpodr3)+" and "+
		                      		" Fdb_sc="+sqlTo(sFdb_sc)+" and Fdb_su="+sqlTo(sFdb_su)+" and "+
		                      		" Fdb_st="+sqlTo(sFdb_st)+" and Fdb_cod1="+sqlTo(sFdb_cod1)+" and "+
		                      		" Fdb_cod2="+sqlTo(sFdb_cod2)+" and Fdb_cod3="+sqlTo(sFdb_cod3)+" and "+
		                      		" Fcr_sc="+sqlTo(sFcr_sc)+" and Fcr_su="+sqlTo(sFcr_su)+" and "+
		                      		" Fcr_st="+sqlTo(sFcr_st)+" and Fcr_cod1="+sqlTo(sFcr_cod1)+" and "+
		                      		" Fcr_cod2="+sqlTo(sFcr_cod2)+" and Fcr_cod3="+sqlTo(sFcr_cod3)
		              	tvps14_4 = getSnap(strSQL);
		               	if (tvps14_4!=null)
		                {
		                	sSql = "INSERT INTO VSP14 "
		                    			+"(Fid,Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3"
		                           		+",Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
		                           		+",Fsum,FWID_WP,Fwid_org,Fkod_kat,Finval"
		                           		+",Fproc,Fmn,Fvp,Fis_tabn,F1000,Fnazv_op) "
		                           	+" VALUES ("+s1Fid+", "+s1Fdb_sc+", "+s1Fdb_su+", "+s1Fdb_st
		                           	 	+", "+s1Fdb_cod1+", "+s1Fdb_cod2+", "+s1Fdb_cod3
		                           		+", "+s1Fcr_sc+", "+s1Fcr_su+", "+s1Fcr_st
		                           		+", "+s1Fcr_cod1+", "+s1Fcr_cod2+", "+s1Fcr_cod3
		                           		+", "+s1Fsum+", "+s1Ftabn+", "+s1Fpodr
		                           		+", "+s1Fkod_kat+", "+sqlTo(s1Finval)
		                           		+", "+s1Fproc+", "+sqlTo(s1Fmn)+", "+s1Fvp+", "+sqlTo(s1Fis_tabn)
		                           		+", "+sqlTo(s1F1000)+", "+sqlTo(s1Fnazv_op)+", )";
		               		ExecuteSQL(sSql);		                         	
		               	}
		         	}
		         	tvps14_2.close();
		            tvz14.MoveNext();
		     	}
		  	} 
            s1.MoveNext();
     	}          
	}
	if(typeof tv14!="undefined")
		tv14.close();
	if(typeof tvz14!="undefined")
		tvz14.close();
	*/
	return true;
} 

include("sys/DpList.js");