//сформировать список ОС для индексации по налоговому учету
//перед формированием списка нужно рассчитать амортизацию на ту дату, на которую проводится индексация - 
//если, например, на 01.01.09, то нужно рассчитать (для налогового учета) амортизацию за 01.01.09, затем
// запустить формирование индексации. Без этого не покажется правильный износ.
// перезаписываем список изменений стоимости для данной даты - 30.12.08, чтобы расчет амортизации смог
// учесть результаты индексации в расчете амортизации за 01.01.09 
//в поле Fnotprivat пишу признак, что ОС ликвидировано до даты индексации
//в поле Ftexusl пришу признак, что ОС выбыло из группы
//для ОС, выбывающих из группы и ОС 5 группы коэффициент ставится 0 принудительно
//При записи в список изменений стоимости  выделены 2 пункта - запись по имеющимся в наличии ОС (т,е, по тем
//где не стоит признак ликвидации. Второй пункт записывает по ликвидированным ОС на указываемый при запросе
//инвентарный номер общую сумму изменения стоимости по группе
function r_refresh(prizn, dat1){

   WAIT(ru("Производится формирование списка ОС для индексации окончена","Виконується формування переліку ОЗ для індексації завершено"))

   if (prizn=="PRO"){
	  min_zp  = getPar("MINZP");

	  
      //для налогового учета дата всегда 1 апреля
      var dat2011  = new Date(2011,3,1)		
	  var is_nkod = false;
	  if (differ(dat1,dat2011)>0){
		   var is_nkod = true;	   
	  }
	  
    if (is_nkod == false){	  
		  var is_rrami = true;	
		  var isminzp=input("Формировать список ОС по таблице расчета индивидуальной амортизации? (+,-)", "", "+",1,-10);
		  if (!isminzp || isminzp=="-")
		  {
			  var is_rrami = false;
		  }
	  
	 if(is_rrami == false){	     	
      strSQL = "select * from ^OS7 where Fdoc_dat<="+sqlTo(dat1)+" and (Fdat_vib>="+sqlTo(dat1)+" or Fdat_vib="+sqlTo(d00obj)+") order by Finv_num";
      os7 = OpenTable("s", strSQL);

      strSQL = "DELETE from ^INDEXN";
      ExecuteSQL(strSQL);

      if (!os7.IsEmpty()){
         os7.MoveFirst();
         step = 0;
         setProgressRange(step, os7.rowCount);
         while (!os7.IsEOF())
         {
         	setProgressPos(++step, ru("Формирование списка ОС: ","Формування переліку ОЗ: ")+step+"/"+os7.rowCount);
         	//зачем делать проверку, если в инвентарных карточках Finv_num уникальный
//         	var oSn = getSnap("select Finv_num from ^INDEXN where Finv_num="+sqlTo(os7.getValue("Finv_num")))
//         	var fis_add = false;
//            if (oSn==null)
         	   var fis_add = true;            	
            var m = new Object();
            m.Finv_num   = Number(os7.getValue("Finv_num"));
            m.Forig_pric = Number(os7.getValue("Forig_pric"));
            m.Fiznos     = Number(os7.getValue("Fiznos"));
            m.Fbdat      = new Date(os7.getValue("Fdoc_dat"));
            m.Fdat_post  = new Date(os7.getValue("Fdoc_dat"));
            m.Fbalst  = Number(os7.getValue("Forig_pric"))-Number(os7.getValue("Fiznos"));            
            if (fis_add==true)
            {
				m.Fwid = GetUID();
				UpdateTable("^INDEXN",m,true);            	
            }
            else
            {
				UpdateTable("^INDEXN",m,false, " Finv_num=" + sqlTo(Number(os7.getValue("Finv_num"))));
            }
            os7.MoveNext();
         }
         setProgressPos(0);
      }
      
      //если ошибки в данных и есть акт выбытия, но нет даты выбытия в инв.карточке, то пытаемся отследить эти случаи.
      //делаем двойную проверку, т.к. может быть частичное выбытие, акт ликвидации есть на часть стоимости, а в списке
      //изменений стоимости ОС все еще числится по оставшейся части стоимости.
      
      //сначала отбираем из актов ликвидации те ОС, которые попали в INDEXN из инвентарных карточек 
      DropTable("VVIB")
	  ExecuteSQL("select * into VVIB from ^OS4 as a where exists (select Finv_num from ^INDEXN as b where a.Finv_num=b.Finv_num and a.Fdoc_dat<"+sqlTo(dat1)+")")
	  //здесь должны отсеяться записи по частичной ликвидации. ЕСли есть акт ликвидации, но в списке изменений стоимости с датой
	  //начала больше или равной дате акта ликвидации есть запись, то считаем, чо ОС полностью не ликвидировано и должно
	  //попадать в список для индексации
	  DropTable("VVIB2")      
      ExecuteSQL("select * into VVIB2 from VVIB as a where not exists (select Finv_num from ^OS0 as b where a.Finv_num=b.Finv_num and a.Fdoc_dat<=b.Fbdat) order by a.Finv_num")
      //удаляем записи, по которым ошибочно в инвентарных карточках не прописалась дата выбытия, а акты ликвидации на все ОС есть.
      ExecuteSQL("delete from ^INDEXN where exists (select Finv_num from VVIB2 where Finv_num=^INDEXN.Finv_num)")
      
      WAIT(ru("Формирование списка ОС для инексации окончена","Формування переліку ОЗ для індексації завершено"))
   
      strSQL = "select * from ^OS0 where Fbdat<="+sqlTo(dat1)+" and (Fedat>="+sqlTo(dat1)+" or Fedat="+sqlTo(d00obj)+")";
      os0 = OpenTable("s", strSQL);
      var i=0;
      if (!os0.IsEmpty())
      {
         step = 0;
         setProgressRange(step, os0.rowCount);
         while (!os0.IsEOF())
         {
            setProgressPos(++step, ru("Обновление данных : ","Оновлення даних: ")+step+"/"+os0.rowCount);
            mFbalst = 0;
            mFiznos = 0;
            if (Number(os0.getValue("fgroup"))!=7 && Number(os0.getValue("fgroup"))!=6){
               //остаточную стоимость лучше брать из таблицы расчета амортизации, чтоб не нужно было расчитывать амортизацию
		//при этом нужно учитывать наличие комплектов для 1 группы. Если балансовая стоимость комплекта <1700 грн.
		// то нужно обнулиь балансовую стоиомость всех частей комплекта.
               //var oSnap = getSnap("select Forig_pric from AMORTI where Finv_num="+sqlTo(os0.getValue("Finv_num")));
               var oSnap = getSnap("select Fbalst,Fprib,Fvib from ^RAMORTI "
               			+" where Finv_num="+sqlTo(os0.getValue("Finv_num"))+" and Fgroup="+sqlTo(os0.getValue("Fgroup"))+" and Fdatkv="+sqlTo(quarter_begin(dat1)));
               if (oSnap!=null)
                  mFbalst = round(Number(oSnap[0])+Number(oSnap[1])-Number(oSnap[2]),2);
               if(mFbalst<0)
               	  mFbalst = 0;
    	       if ((Number(os0.getValue("Fgroup"))==1 || Number(os0.getValue("Fgroup"))==11) && (Number(oSnap[0])+Number(oSnap[1])-Number(oSnap[2]))<=100*min_zp)
 		   	   {	
		      		sSql = "select Fkompl from ^OS7 where Finv_num="+sqlTo(os0.getValue("Finv_num"));
		      	 	gSk = getSnap(sSql);
		      	 	if (gSk !=null && Number(gSk[0])==0) 
		      	 		mFbalst = 0;
	
  			 		if (gSk !=null && Number(gSk[0])!=0)
	  		 		{
			            var fis_ram  = false;
			            var is_rkmpl = true;
				        gSr = getSnap("select Fbalst, Fprib, Fvib from ^RAMORT where Fkompl="+sqlTo(Number(gSk[0]))
            				+" and Finv_num=0 and Fgroup="+sqlTo(os0.getValue("Fgroup"))
							+" and Fdatkv="+sqlTo(quarter_begin(dat1)));
		            	if (gSr !=null)
		            	{
		              		fis_ram  = true;
		              		if (round(Number(gSr[0])+Number(gSr[1])-Number(gSr[2]),2)<=100*min_zp) 
		              	 		is_rkmpl = false;
			      		}
			      		if (fis_ram && !is_rkmpl) 
           					mFbalst = 0;
			      		if (!fis_ram)
			      		{
			            	if (round(Number(oSnap[0])+Number(oSnap[1])-Number(oSnap[2]),2)<=100*min_zp) 
	           					mFbalst = 0;
			      		}
		         	}
               }
            }  
//if (Number(os0.getValue("Finv_num"))==40518) alert(mFbalst)
            var oSnapi = getSnap("select Finv_num from ^INDEXN where Finv_num="+sqlTo(os0.getValue("Finv_num")));
            if (oSnapi!=null){   
            	var m = new Object();            	         
                //m.Fwid       = GetUID();
               	m.Forig_pric = Number(os0.getValue("Forig_pric"));
               	m.Fiznos     = round(Number(os0.getValue("Forig_pric"))-mFbalst,2)
               	m.Fgroup     = Number(os0.getValue("Fgroup"))
               	m.Fbdat      = dat1.getVarDate();
               	m.Fbalst     = mFbalst
				UpdateTable("^INDEXN",m,false, " Finv_num=" + sqlTo(os0.getValue("Finv_num")));               	
            }
            os0.MoveNext();
         }
         setProgressPos(0);
      }
      os0.close();
	 }else{
	  //кусок для ОС, имеющихся в наличии. Для остальных нужна 	
	  DropTable("VOS7")	
      strSQL = "select * into VOS7 from ^OS7 where Fdoc_dat<="+sqlTo(dat1)+" and (Fdat_vib>="+sqlTo(dat1)+" or Fdat_vib="+sqlTo(d00obj)+") order by Finv_num";
	  ExecuteSQL(strSQL); 	
      //если ошибки в данных и есть акт выбытия, но нет даты выбытия в инв.карточке, то пытаемся отследить эти случаи.
      //делаем двойную проверку, т.к. может быть частичное выбытие, акт ликвидации есть на часть стоимости, а в списке
      //изменений стоимости ОС все еще числится по оставшейся части стоимости.
      
      //сначала отбираем из актов ликвидации те ОС, которые попали в INDEXN из инвентарных карточек 
      DropTable("VVIB")
	  ExecuteSQL("select * into VVIB from ^OS4 as a where exists (select Finv_num from VOS7 as b where a.Finv_num=b.Finv_num and a.Fdoc_dat<"+sqlTo(dat1)+")")
	  //здесь должны отсеяться записи по частичной ликвидации. ЕСли есть акт ликвидации, но в списке изменений стоимости с датой
	  //начала больше или равной дате акта ликвидации есть запись, то считаем, чо ОС полностью не ликвидировано и должно
	  //попадать в список для индексации
	  DropTable("VVIB2")      
      ExecuteSQL("select * into VVIB2 from VVIB as a where not exists (select Finv_num from ^OS0 as b where a.Finv_num=b.Finv_num and a.Fdoc_dat<=b.Fbdat) order by a.Finv_num")
      //удаляем записи, по которым ошибочно в инвентарных карточках не прописалась дата выбытия, а акты ликвидации на все ОС есть.
      ExecuteSQL("delete from VOS7 where exists (select Finv_num from VVIB2 where Finv_num=VOS7.Finv_num)")

	 	
      strSQL = "DELETE from ^INDEXN";
      ExecuteSQL(strSQL);
	 	
      strSQL = "select * from ^RAMORTI where Fdatkv="+sqlTo(quarter_begin(dat1))+" order by Finv_num, Fgroup";
      var rami = OpenTable("s", strSQL);
      var i=0;
      if (!rami.IsEmpty())
      {
         step = 0;
         setProgressRange(step, rami.rowCount);
         while (!rami.IsEOF())
         {
            setProgressPos(++step, ru("Обновление данных : ","Оновлення даних: ")+step+"/"+rami.rowCount);
            mFbalst = 0;
            mFiznos = 0;
            if (Number(rami.getValue("fgroup"))!=7 && Number(rami.getValue("fgroup"))!=6){
               //остаточную стоимость лучше брать из таблицы расчета амортизации, чтоб не нужно было расчитывать амортизацию
		//при этом нужно учитывать наличие комплектов для 1 группы. Если балансовая стоимость комплекта <1700 грн.
		// то нужно обнулиь балансовую стоиомость всех частей комплекта.
		       mFbst  = round(Number(rami.getValue("Fbalst")),2)
		       mFprib = round(Number(rami.getValue("Fprib")),2)
		       mFvib  = round(Number(rami.getValue("Fvib")),2)		       
               mFbalst = round(mFbst+mFprib-mFvib,2);
               //if(mFbalst<=0)
               //	  mFbalst = 0;
    	       if ((Number(rami.getValue("Fgroup"))==1 || Number(rami.getValue("Fgroup"))==11) && (Number(rami.getValue("Fbalst"))+Number(rami.getValue("Fprib"))-Number(rami.getValue("Fvib")))<=100*min_zp)
 		   	   {	
		      		sSql = "select Fkompl from ^OS7 where Finv_num="+sqlTo(rami.getValue("Finv_num"));
		      	 	gSk = getSnap(sSql);
		      	 	if (gSk !=null && Number(gSk[0])==0) 
		      	 		mFbalst = 0;
	
  			 		if (gSk !=null && Number(gSk[0])!=0)
	  		 		{
			            var fis_ram  = false;
			            var is_rkmpl = true;
				        gSr = getSnap("select Fbalst, Fprib, Fvib from ^RAMORT where Fkompl="+sqlTo(Number(gSk[0]))
            				+" and Finv_num=0 and Fgroup="+sqlTo(rami.getValue("Fgroup"))
							+" and Fdatkv="+sqlTo(quarter_begin(dat1)));
		            	if (gSr !=null)
		            	{
		              		fis_ram  = true;
		              		if (round(Number(gSr[0])+Number(gSr[1])-Number(gSr[2]),2)<=100*min_zp) 
		              	 		is_rkmpl = false;
			      		}
			      		if (fis_ram && !is_rkmpl) 
           					mFbalst = 0;
			      		if (!fis_ram)
			      		{
			            	if (round(Number(rami.getValue("Fbalst"))+Number(rami.getValue("Fprib"))-Number(rami.getValue("Fvib")),2)<=100*min_zp) 
	           					mFbalst = 0;
			      		}
		         	}
               }
            }
                var m = new Object();
                //если есть в списке VOS7, то есть в наличии. Нет - значит, это ликвидированные хвосты, их индексировать не надо
   	      		sSql = "select Fdoc_dat from VOS7 where Finv_num="+sqlTo(rami.getValue("Finv_num"));
   		      	gSp = getSnap(sSql);
   		      	m.Fnotprivat = false;   		      	
   		      	if (gSp ==null){
   		      	    m.Fnotprivat = true; 
               	}
               	//дата поступления 
   	      		sSql = "select Fdoc_dat, Fdat_vib from ^OS7 where Finv_num="+sqlTo(rami.getValue("Finv_num"));
   		      	gSp = getSnap(sSql);
   		      	if (gSp !=null){
   		      	    m.Fdat_post = new Date(gSp[0]).getVarDate()
   		      	    m.Fdat_vib  = new Date(gSp[1]).getVarDate()   		      	     
               	} 
            //var oSnapi = getSnap("select Finv_num from ^INDEXN where Fgroup="+sqlTo(rami.getValue("Fgroup"))+" and Finv_num="+sqlTo(rami.getValue("Finv_num")));
            //if (oSnapi!=null){   
                m.Fwid       = GetUID();
                m.Finv_num   = Number(rami.getValue("Finv_num"));                
               	m.Forig_pric = izosdat(dat1, Number(rami.getValue("Finv_num")),"orig_pric");
               	m.Fiznos     = m.Forig_pric-mFbalst
               	m.Fgroup     = Number(rami.getValue("Fgroup"))
               	m.Fbdat      = dat1.getVarDate();
               	m.Fbalst     = mFbalst
               	
               	if (mFbalst<=0 && Number(rami.getValue("Fvib"))!=0){
	   	      		sSql = "select Finv_num from ^RAMORTI where Finv_num="+sqlTo(rami.getValue("Finv_num"))+" and Fdatkv="+sqlTo(quarter_begin(dat1))+" and Fgroup<>"+sqlTo(rami.getValue("Fgroup"));
   			      	gSp = getSnap(sSql);
   			      	if (gSp !=null){
   			      		m.Ftexusl = true;
               		}else {
   			      		m.Ftexusl = false;              			
               		}
               	}
				//UpdateTable("^INDEXN",m,false, " Finv_num=" + sqlTo(rami.getValue("Finv_num")));
				UpdateTable("^INDEXN",m,true);				//                
            //}
            rami.MoveNext();
         }
         setProgressPos(0);
      }
      rami.close();
	 } 
	 
      strSQL = "UPDATE ^INDEXN set Fbdat ="+sqlTo(dat1);
      ExecuteSQL(strSQL); 

      strSQL = "DELETE from ^INDEXN where Fgroup=6 OR Fgroup=7"
      ExecuteSQL(strSQL); 
      
      //временная таблица пока просто для сверки полученного износа здесь с таблицей расчета амортизации
      // раньше требовалось рассчитать амортизацию, а затем индексацию, и таких проблем, какие вылезли сейчас,
      // не было, теперь нужно отслеживать много ситуаций. 
	DropTable("BB")
	ExecuteSQL("select a.Finv_num, a.Fbalst+a.Fprib-a.Fvib as Fbalr, b.Fbalst into BB  from ^RAMORTI as a, ^INDEXN as b  where a.Finv_num=b.Finv_num and a.Fgroup=b.Fgroup and a.Fdatkv="+sqlTo(quarter_begin(dat1))+" and  exists (select Finv_num from ^INDEXN as b where a.finv_num=b.Finv_num and a.Fgroup=b.Fgroup) order by a.Finv_num ")
	ExecuteSQL("update BB set Fbalr="+sqlRound("Fbalr",2))	
	ExecuteSQL("update BB set Fbalst="+sqlRound("Fbalst",2))
	//ExecuteSQL("select a.Finv_num, a.Fiznos-a.Famort  as Fizng,b.Fiznos into BB  from ^RAMORTI as a, ^INDEXN as b  where a.Finv_num=b.Finv_num  and a.Fdatkv="+sqlTo(quarter_begin(dat1))+" and  exists (select Finv_num from ^INDEXN as b where a.finv_num=b.Finv_num and a.Fgroup=b.Fgroup) order by a.Finv_num ")
	//ExecuteSQL("update BB set Fizng="+sqlRound("Fizng",2))	
	//ExecuteSQL("update BB set Fiznos="+sqlRound("Fiznos",2))
    }else{
    	//список ОС по налоговому учету с 2011 года
        dat1 = new Date(dat1.getFullYear(),dat1.getMonth(),dat1.getDate()-1);

        strSQL = "select * from ^OS7 where Fdoc_dat<="+sqlTo(dat1)+" and (Fdat_vib>="+sqlTo(dat1)+" or Fdat_vib="+sqlTo(d00obj)+") order by Finv_num";
        os7 = OpenTable("s", strSQL);
  	  
        strSQL = "DELETE from ^INDEXN";
        ExecuteSQL(strSQL);

        if (!os7.IsEmpty()){
           os7.MoveFirst();
           step = 0;
           setProgressRange(step, os7.rowCount);
           while (!os7.IsEOF())
           {
              setProgressPos(++step, ru("Формирование списка ОС: ","Формування переліку ОЗ: ")+step+"/"+os7.rowCount);
       	   		var fis_add = true;            	
              	var m = new Object();
              	m.Finv_num   = Number(os7.getValue("Finv_num"));
              	m.Forig_pric = Number(os7.getValue("Forig_pric"));
              	m.Fiznos     = Number(os7.getValue("Fiznos"));
              	m.Fbdat      = new Date(os7.getValue("Fdoc_dat"));
              	m.Fdat_post  = new Date(os7.getValue("Fdoc_dat"));
              	if (fis_add==true)
              	{
  					m.Fwid = GetUID();
  					UpdateTable("^INDEXN",m,true);            	
              	}
              	else
              	{
  					UpdateTable("^INDEXN",m,false, " Finv_num=" + sqlTo(os7.getValue("Finv_num")));
  	            }
              os7.MoveNext();
        	}   
           setProgressPos(0);
        }
        os7.close();
        
        WAIT(ru("Формирование списка ОС для индексации окончена","Формування переліку ОЗ для індексації завершено"))

        strSQL = "select * from ^OS0 where Fbdat<="+sqlTo(dat1)+" and (Fedat>="+sqlTo(dat1)+" or Fedat="+sqlTo(d00obj)+") ORDER BY Finv_num";
        var os0 = OpenTable("s", strSQL);
        var i=0;
        if (!os0.IsEmpty())
        {
  		step = 0;
          setProgressRange(step, os0.rowCount);
           while (!os0.IsEOF())
           {
              setProgressPos(++step, ru("Обновление данных из списка изменения стоимости по н/у: ","Оновлення даних зі списка змін вартості по п/о: ")+step+"/"+os0.rowCount);
     			Iznos = 0;

                 var oS = getSnap("select Fdoc_dat from ^OS1 where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))));
                 if (oS!=null){ 
                    mFdat_post = new Date(oS[0]);
                 }else{
                    mFdat_post = null;
                 }
              	
                 dt_prx = dat2011;
                 nummet = Number(izosdat(dat1, os0.getValue("Finv_num"), "buhmetod"));

                 mes_am = 0;
                 if (differ(dat1,dt_prx)==0){
                    iznbuh  = Number(izosdat(dat1, os0.getValue("Finv_num"), "iznos"));
                    Iznos = iznbuh
                 }else{
                    var new_dat_1 = new Date(dat1.getFullYear(),dat1.getMonth(),dat1.getDate()+1);
                    //var gs = getSnap("select Fiznos,Famort from ^RAMORIB where Finv_num="+sqlTo(os0.getValue("Finv_num"))+" and Fdatkv="+sqlTo(new_dat_1))
                    //if (gs!=null){
                    //	Iznos = Number(gs[0])-Number(gs[1])
                    //}else{
                    //	if differ(mFdat_post,new_dat_1)<
                    //}
                    if (nummet==8 && Number(os0.getValue("Ftypersc"))==1){
                        Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "NP"))
                        mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "NP"))
                        Iznos = Iznos - mes_am
                     }
                    if (nummet==8 && Number(os0.getValue("Ftypersc"))==2){
                        Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "NB"))
                        mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "NB"))
                        Iznos = Iznos - mes_am
                     }
                    if (nummet==8 && Number(os0.getValue("Ftypersc"))==3){
                        Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "NS"))
                        mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "NS"))
                        Iznos = Iznos - mes_am
                     }
                 }
   

  	         	var oSn = getSnap("select Finv_num from ^INDEXN where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))))
          	    if (oSn!==null){
  	            	var m = new Object();
  	                //m.Fwid       = GetUID();
                      //m.Fsrokadd   = Number(os0.getValue("Fsrokadd"));
                      m.Forig_pric = Number(os0.getValue("Forig_pric"))
                      m.Fiznos     = Iznos;
                      m.Fbalst     = Number(os0.getValue("Forig_pric"))-Iznos;
                      m.Fdb_sc     = Number(os0.getValue("Fdb_sc"));
                      m.Fdb_su     = Number(os0.getValue("Fdb_su"));
                      m.Fdb_st     = Number(os0.getValue("Fdb_st"));
                      m.Fbdat      = dat1.getVarDate();
  					UpdateTable("^INDEXN",m,false, " Finv_num=" + sqlTo(Number(os0.getValue("Finv_num"))));
  	            }
              os0.MoveNext();
           }
           setProgressPos(0);
        }
        os0.close();
    }
   }

   if (prizn=="BUH"){

      dat1 = new Date(dat1.getFullYear(),dat1.getMonth(),dat1.getDate()-1);
      fis_all = true;
      if (!confirm("Расчет будет проводиться по всем ОС")){
         fis_all = false;
         fis_priv = false;
         if (confirm("Расчет будет пров.по ОС для приватизации")){
            fis_priv = true;
         }
      } 

      strSQL = "select * from ^OS7 where Fdoc_dat<="+sqlTo(dat1)+" and (Fdat_vib>="+sqlTo(dat1)+" or Fdat_vib="+sqlTo(d00obj)+") order by Finv_num";
      os7 = OpenTable("s", strSQL);
	  
      strSQL = "DELETE from ^INDEXB";
      ExecuteSQL(strSQL);

      if (!os7.IsEmpty()){
         os7.MoveFirst();
         step = 0;
         setProgressRange(step, os7.rowCount);
         while (!os7.IsEOF())
         {
            setProgressPos(++step, ru("Формирование списка ОС: ","Формування переліку ОЗ: ")+step+"/"+os7.rowCount);
            fis_rash = true;
            if (fis_all==false){
            	var oS = getSnap("select Fnotprivat from ^OS1 where Finv_num="+sqlTo(os7.getValue("Finv_num")));
            	if (oS!=null){ 
                  mFpriv = oS[0];
               }else{
                  mFpriv = null;
               }
               if (mFpriv == null){ 
                  fis_rash = true;
               }else{
                  if (fis_priv==false && mFpriv==false){
                     fis_rash = false;
                  }
                  if (fis_priv==true && mFpriv==true){
                     fis_rash = false;
                  }
               }
            }
            if (fis_rash==true){
	         	//зачем делать проверку, если в инвентарных карточках Finv_num уникальный
//	         	var oSn = getSnap("select Finv_num from ^INDEXB where Finv_num="+sqlTo(os7.getValue("Finv_num")))
//    	     	var fis_add = false;
//        	    if (oSn==null)
         	   		var fis_add = true;            	
            	var m = new Object();
            	m.Finv_num   = Number(os7.getValue("Finv_num"));
            	m.Forig_pric = Number(os7.getValue("Forig_pric"));
            	m.Fiznos     = Number(os7.getValue("Fiznos"));
            	m.Fbdat      = new Date(os7.getValue("Fdoc_dat"));
            	m.Fdat_post  = new Date(os7.getValue("Fdoc_dat"));
            	if (fis_add==true)
            	{
					m.Fwid = GetUID();
					UpdateTable("^INDEXB",m,true);            	
            	}
            	else
            	{
					UpdateTable("^INDEXB",m,false, " Finv_num=" + sqlTo(os7.getValue("Finv_num")));
	            }
            }
            os7.MoveNext();
         }
         setProgressPos(0);
      }
      os7.close();
      
      WAIT(ru("Формирование списка ОС для индексации окончена","Формування переліку ОЗ для індексації завершено"))

      strSQL = "select * from ^OS0B where Fbdat<="+sqlTo(dat1)+" and (Fedat>="+sqlTo(dat1)+" or Fedat="+sqlTo(d00obj)+") ORDER BY Finv_num";
      var os0 = OpenTable("s", strSQL);
      var i=0;
      if (!os0.IsEmpty())
      {
		step = 0;
        setProgressRange(step, os0.rowCount);
         while (!os0.IsEOF())
         {
            setProgressPos(++step, ru("Обновление данных из списка изменения стоимости по б/у: ","Оновлення даних зі списка змін вартості по б/о: ")+step+"/"+os0.rowCount);
   			Iznos = 0;
            fis_rash = true;
            if (fis_all==false){
               var oS = getSnap("select Fnotprivat from ^OS1 where Finv_num="+sqlTo(os0.getValue("Finv_num")));
               if (oS!=null){ 
                  mFpriv = oS[0];
               }else{
                  mFpriv = null;
               }
               if (mFpriv == null){ 
                  fis_rash = true;
               }else{
                  if (fis_priv==false && mFpriv==false){
                     fis_rash = false;
                  }
                  if (fis_priv==true && mFpriv==true){
                     fis_rash = false;
                  }
               }
            }
            
            if (fis_rash==true){
               var oS = getSnap("select Fdoc_dat from ^OS1 where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))));
               if (oS!=null){ 
                  mFdat_post = oS[0];
               }else{
                  mFdat_post = null;
               }
            	
               dt_prx = new Date(getPar("__DATPER"));

               nummet = Number(izosdatb(dat1, os0.getValue("Finv_num"), "buhmetod"));
               if (nummet==0 || nummet==null){
                  numbuh  = getPar("NUMBUH");
               }else{
                  numbuh  =  Number(izosdatb(dat1, os0.getValue("Finv_num"), "buhmetod"));
               }

               if (numbuh==5 || numbuh==6 || numbuh==7){
                  dt_prx = d00obj;
               }

               mes_am = 0;
               if (differ(dat1,dt_prx)==0){
                  iznbuh  = Number(izosdatb(dat1, os0.getValue("Finv_num"), "iznos"));
                  Iznos = iznbuh
               }else{
                  var new_dat_1 = new Date(dat1.getFullYear(),dat1.getMonth(),dat1.getDate()+1);
                  if (numbuh==1 || numbuh==5 || numbuh==6 || numbuh==7){
                     Iznos  = Number(riznosb(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN"))
                     mes_am = Number(riznosb(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM"))
                     Iznos = Iznos - mes_am
                  }
                  if (numbuh==2){
                     Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN"))
                     mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM"))
                     Iznos = Iznos - mes_am
                  }
                  if (numbuh==8 && Number(os0.getValue("Ftypersc"))==1){
                      Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "BP"))
                      mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "BP"))
                      Iznos = Iznos - mes_am
                   }
                  if (numbuh==8 && Number(os0.getValue("Ftypersc"))==2){
                      Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "BB"))
                      mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "BB"))
                      Iznos = Iznos - mes_am
                   }
                  if (numbuh==8 && Number(os0.getValue("Ftypersc"))==3){
                      Iznos  = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "IZN", "BS"))
                      mes_am = Number(riznosbp(new_dat_1, os0.getValue("Finv_num"), mFdat_post, "AM", "BS"))
                      Iznos = Iznos - mes_am
                   }
               }
 
               if (numbuh==3){
                  iznbuh  = 0;               	
                  mes_am = 0;
                  n_d  = new Date(dat1.getFullYear(), dat1.getMonth(), dat1.getDate()-1);
                  firstnnd = new Date(n_d.getFullYear(),n_d.getMonth(),1)

                  if (mFdat_post > firstnnd){
                     iznbuh = Number(izosdatb(mFdat_post, Number(os0.getValue("Finv_num")), "iznos"));
                  }else{
                     if (differ(dat1,dt_prx)==0){
                        iznbuh = Number(izosdatb(dat1, Number(os0.getValue("Finv_num")), "iznos"));
                     }else{
                        mes_am  = 0;
                        var osnap = getSnap("select Fiznos, Famort from ^RAMORIB where Finv_num="+sqlTo(Number(os0.getValue("Finv_num")))+" and Fgroup="+sqlTo(Number(os0.getValue("Fgroup")))+" and Fdatkv="+sqlTo(firstnnd))
                        if (osnap!=null){
                           iznbuh = Number(osnap[0]);
                           mes_am = Number(osnap[1]);
                        }else{
                           //найти первоначальный износ, если нет в таблице расчета амортизации
                           iznbuh = Number(izosdatb(firstnnd, Number(os0.getValue("Finv_num")), "iznos"));
                           if (iznbuh==-100) iznbuh = 0;
                           mes_am  = 0;
                        }
                     }  
                  }
                  Iznos = iznbuh;
               }   
      
               // налоговый метод для Брокарда
               if (numbuh==4){
                  iznbuh  = 0;               	
                  n_d  = new Date(dat1.getFullYear(), dat1.getMonth(), dat1.getDate()-1);
                  firstnnd = new Date(n_d.getFullYear(),n_d.getMonth(),1)
                  if (mFdat_post > firstnnd){
                     iznbuh = Number(izosdatb(mFdat_post, os0.getValue("Finv_num"), "iznos"));
                  }else{
                     if (differ(dat1,dt_prx)==0){
                        iznbuh = Number(izosdatb(dat1, os0.getValue("Finv_num"), "iznos"));
                     }else{
                        mes_am  = 0;
                        var osnap = getSnap("select Fiznos, Famort from ^RAMORIB where Finv_num="+sqlTo(os0.getValue("Finv_num"))+" and Fgroup="+sqlTo(os0.getValue("Fgroup"))+" and Fdatkv="+sqlTo(firstnnd))
                        if (osnap!=null){
                           iznbuh = Number(osnap[0]);
                           mes_am = Number(osnap[1]);
                        }else{
                           //найти первоначальный износ, если нет в таблице расчета амортизации
                           iznbuh = Number(izosdatb(firstnnd, os0.getValue("Finv_num"), "iznos"));
                           if (iznbuh==-100) iznbuh = 0;
                           mes_am  = 0;
                        }
                     }  
                  }
                  Iznos = iznbuh;
               }

	         	var oSn = getSnap("select Finv_num from ^INDEXB where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))))
        	    if (oSn!==null){
	            	var m = new Object();
	                //m.Fwid       = GetUID();
                    m.Fsrokadd   = Number(os0.getValue("Fsrokadd"));
                    m.Forig_pric = Number(os0.getValue("Forig_pric"))
                    m.Fiznos     = Iznos;
                    m.Fbalst     = Number(os0.getValue("Forig_pric"))-Iznos;
                    m.Fdb_sc     = Number(os0.getValue("Fdb_sc"));
                    m.Fdb_su     = Number(os0.getValue("Fdb_su"));
                    m.Fdb_st     = Number(os0.getValue("Fdb_st"));
                    m.Fbdat      = dat1.getVarDate();
					UpdateTable("^INDEXB",m,false, " Finv_num=" + sqlTo(Number(os0.getValue("Finv_num"))));
	            }
            }
            os0.MoveNext();
         }
         setProgressPos(0);
      }
      os0.close();
    }
    
   if (prizn=="BUD"){
      dat1_1 = new Date(dat1.getFullYear(),dat1.getMonth(),dat1.getDate()-1);
      fis_all = true;
      if (!confirm("Расчет будет проводиться по всем ОС")){
         fis_all = false;
         fis_priv = false;
         if (confirm("Расчет будет пров.по ОС для приватизации")){
            fis_priv = true;
         }
      } 

      strSQL = "select * from ^OS7 where Fdoc_dat<="+sqlTo(dat1)+" and (Fdat_vib>="+sqlTo(dat1)+" or Fdat_vib="+sqlTo(d00obj)+") order by Finv_num";
      os7 = OpenTable("s", strSQL);
	  
      strSQL = "DELETE from ^INDEXB";
      ExecuteSQL(strSQL);
      
      if (!os7.IsEmpty()){
         os7.MoveFirst();
         step = 0;
         setProgressRange(step, os7.rowCount);
         while (!os7.IsEOF())
         {
            setProgressPos(++step, ru("Формирование списка ОС: ","Формування переліку ОЗ: ")+step+"/"+os7.rowCount);
            fis_rash = true;
            if (fis_all==false){
            	var oS = getSnap("select Fnotprivat from ^OS1 where Finv_num="+sqlTo(os7.getValue("Finv_num")));
            	if (oS!=null){ 
                  mFpriv = oS[0];
               }else{
                  mFpriv = null;
               }
               if (mFpriv == null){ 
                  fis_rash = true;
               }else{
                  if (fis_priv==false && mFpriv==false){
                     fis_rash = false;
                  }
                  if (fis_priv==true && mFpriv==true){
                     fis_rash = false;
                  }
               }
            }
            if (fis_rash==true){
	         	//зачем делать проверку, если в инвентарных карточках Finv_num уникальный
//	         	var oSn = getSnap("select Finv_num from ^INDEXB where Finv_num="+sqlTo(os7.getValue("Finv_num")))
//    	     	var fis_add = false;
//        	    if (oSn==null)
         	   		var fis_add = true;            	
            	var m = new Object();
            	m.Finv_num   = Number(os7.getValue("Finv_num"));
            	m.Forig_pric = Number(os7.getValue("Forig_pric"));
            	m.Fiznos     = Number(os7.getValue("Fiznos"));
            	m.Fbdat      = new Date(os7.getValue("Fdoc_dat"));
            	m.Fdat_post  = new Date(os7.getValue("Fdoc_dat"));
            	if (fis_add==true)
            	{
					m.Fwid = GetUID();
					UpdateTable("^INDEXB",m,true);            	
            	}
            	else
            	{
					UpdateTable("^INDEXB",m,false, " Finv_num=" + sqlTo(os7.getValue("Finv_num")));
	            }
            }
            os7.MoveNext();
         }
         setProgressPos(0);
      }
      os7.close();
      
      WAIT(ru("Формирование списка ОС для индексации окончена","Формування переліку ОЗ для індексації завершено"))

      strSQL = "select * from ^OS0B where Fbdat<="+sqlTo(dat1)+" and (Fedat>="+sqlTo(dat1)+" or Fedat="+sqlTo(d00obj)+") ORDER BY Finv_num";
      var os0 = OpenTable("s", strSQL);
      var i=0;
      if (!os0.IsEmpty())
      {
		step = 0;
        setProgressRange(step, os0.rowCount);
         while (!os0.IsEOF())
         {
            setProgressPos(++step, ru("Обновление данных из списка изменения стоимости по б/у: ","Оновлення даних зі списка змін вартості по б/о: ")+step+"/"+os0.rowCount);
   			Iznos = 0;
            fis_rash = true;
            if (fis_all==false){
               var oS = getSnap("select Fnotprivat from ^OS1 where Finv_num="+sqlTo(os0.getValue("Finv_num")));
               if (oS!=null){ 
                  mFpriv = oS[0];
               }else{
                  mFpriv = null;
               }
               if (mFpriv == null){ 
                  fis_rash = true;
               }else{
                  if (fis_priv==false && mFpriv==false){
                     fis_rash = false;
                  }
                  if (fis_priv==true && mFpriv==true){
                     fis_rash = false;
                  }
               }
            }
            
            if (fis_rash==true){
               var oS = getSnap("select Fdoc_dat from ^OS1 where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))));
               if (oS!=null){ 
                  mFdat_post = oS[0];
               }else{
                  mFdat_post = null;
               }
               var osn = getSnap("select Fiznos  from ^RAMORBD where Finv_num="+sqlTo(Number(os0.getValue("Finv_num")))+" and Fdatkv="+sqlTo(dat1))
               if (osn!=null){
               		var Iznos = osn[0]
               }else{
               		var Iznos = 0               	
               }	 	
	         	var oSn = getSnap("select Finv_num from ^INDEXB where Finv_num="+sqlTo(Number(os0.getValue("Finv_num"))))
        	    if (oSn!==null){
	            	var m = new Object();
	                //m.Fwid       = GetUID();
                    m.Fsrokadd   = Number(os0.getValue("Fsrokadd"));
                    m.Forig_pric = Number(os0.getValue("Forig_pric"))
                    m.Fiznos     = Iznos;
                    m.Fbalst     = Number(os0.getValue("Forig_pric"))-Iznos;
                    m.Fdb_sc     = Number(os0.getValue("Fdb_sc"));
                    m.Fdb_su     = Number(os0.getValue("Fdb_su"));
                    m.Fdb_st     = Number(os0.getValue("Fdb_st"));
                    m.Fcod_podr  = izvnprdt(dat1,Number(os0.getValue("Finv_num")),"podr");
                    m.Fcod_mol   = izvnprdt(dat1,Number(os0.getValue("Finv_num")),"tabn");                                        
                    m.Fbdat      = dat1.getVarDate();
					UpdateTable("^INDEXB",m,false, " Finv_num=" + sqlTo(Number(os0.getValue("Finv_num"))));
	            }
            }
            os0.MoveNext();
         }
         setProgressPos(0);
      }
      os0.close();
    }
    
}