function  r_shxmsu_z(gdescape,dat1,dat2) {
    //шахматный баланс по субсчетам

    if(gdescape){
      return false;
    }else{
       var cdat1 = sqlTo(dat1);
       var cdat2 = sqlTo(dat2);
    }
	
	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;
	
	if (!gdescape){
		DropTable("SHAXM_Z");
		DropTable("SHAXM_Z1");
		DropTable("SHAXM_Z2");
		DropTable("SHAXM_Z3");
		DropTable("SHAXM_Z4");
		DropTable("SHAXM_Z5");
		DropTable("SHAXM_Z6");
		DropTable("SHAXM_Z_s");
		DropTable("SHAXM_Z_r");
		DropTable("SHAXM_Z_c");
		DropTable("SHAXM_Z_H"); 
		
	var parZabalB = Number(getPar("ZABALB")),
		parZabalE = Number(getPar("ZABALE")),
		parNZabalB = Number(getPar("NZABALB")),
		parNZabalE = Number(getPar("NZABALE"));

//		"(fsc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND " +
//		"(fsc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
		        
		strSQL = "CREATE TABLE SHAXM_Z_H"+
		    " (fbdat "+SqlType("date")+", fedat "+SqlType("date")+")";
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO SHAXM_Z_H"+
		    " (fbdat, fedat) VALUES ("+
		    sqlTo(dat1)+","+sqlTo(dat2)+")";
		ExecuteSQL(strSQL);

		// Отбираем проводки в иностранной валюте
		strSQL=
			"SELECT Fdb_sc as fsc1, Fdb_su as fsu1"
				+ ", Fcr_sc as fsc_corr1, Fcr_su as fsu_corr1"
				+ ", "+emptySc+" as fsc_corr, "+emptySu+" as fsu_corr"
				+ ", 1 as find, Fval"
				+ ", ^SCHET.Fsum*"+sqlRate("^SCHET","Fval","Fdate")+" as Fsum"
				+ ", "+emptySc+" as Fsc, "+emptySu+" as Fsu"
			+ " INTO SHAXM_Z1"
			+ " FROM ^schet "
			+ " WHERE (Fdate >="+cdat1+" and Fdate<="+cdat2+")"
				+ " AND Fwrk<>16"
				+ " AND Fval<>0"
				+ " AND Fval Is NOT Null"
				+ " AND (Fdb_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
				+ "(Fdb_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
				+ " AND (Fcr_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
				+ "(Fcr_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
				+ orgCond;
		
		ExecuteSQL(strSQL);

		// Отбираем проводки в национальной валюте
      strSQL=
			"SELECT Fdb_sc as fsc1, Fdb_su as fsu1"
				+ ", Fcr_sc as fsc_corr1, Fcr_su as fsu_corr1"
				+ ", "+emptySc+" as fsc_corr, "+emptySu+" as fsu_corr"
				+ ", 1 as find"
				+ ", 0 as Fval"
				+ ", ^SCHET.Fsum as Fsum"
				+ ", "+emptySc+" as Fsc, "+emptySu+" as Fsu"
			+ " INTO SHAXM_Z2"
			+ " FROM ^schet "
			+ " WHERE (Fdate >="+cdat1+" and Fdate<="+cdat2+")"
				+ " AND Fwrk<>16"
				+ " AND (Fval=0 OR Fval Is Null)"
				+ " AND (Fdb_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
				+ "(Fdb_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
				+ " AND (Fcr_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
				+ "(Fcr_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
				+ orgCond;
				
			
		ExecuteSQL(strSQL);

		// Сгруппируем суммы
		strSQL=
			"SELECT fsc1, fsu1"
				+ ", fsc_corr1, fsu_corr1"
				+ ", "+emptySc+" as fsc_corr, "+emptySu+" as fsu_corr"
				+ ", 1 as find"
				+ ", sum(SHAXM_Z1.Fsum) as Fsum"
				+ ", "+emptySc+" as Fsc, "+emptySu+" as Fsu "
			+ " INTO SHAXM_Z"
			+ " FROM SHAXM_Z1"
			+ " GROUP BY Fsc_corr1, Fsu_corr1, Fsc1, Fsu1";
			
		ExecuteSQL(strSQL);

		strSQL =
			"INSERT INTO SHAXM_Z(fsc1,fsu1,fsc_corr1,fsu_corr1,fsc_corr,fsu_corr,find,Fsum,Fsc,Fsu) "
			+ " SELECT fsc1, fsu1"
				+ ", fsc_corr1, fsu_corr1"
				+ ", "+emptySc+" as fsc_corr, "+emptySu+" as fsu_corr"
				+ ", 1 as find"
				+ ", SUM(SHAXM_Z2.Fsum) AS Fsum"
				+ ", "+emptySc+" as Fsc, "+emptySu+" as Fsu "
			+ " FROM SHAXM_Z2 "
			+ " GROUP BY Fsc_corr1, Fsu_corr1, Fsc1, Fsu1";
		
		ExecuteSQL(strSQL);

		//выборка закрывающих проводок
		if( op_zakr(dat1, dat2) )
		{
			strSQL =
				"INSERT INTO SHAXM_Z(fsc1,fsu1,fsc_corr1,fsu_corr1,fsc_corr,fsu_corr,find,Fsum,Fsc,Fsu) "
				+ " SELECT Fdb_sc as fsc1, Fdb_su as fsu1"
					+ ", Fcr_sc as fsc_corr1, Fcr_su as fsu_corr1"
					+ ", "+emptySc+" as fsc_corr, "+emptySu+" as fsu_corr"
					+ ", 1 as find"
					+ ", SUM(^schet_zr.Fsum) AS Fsum"
					+ ", "+emptySc+" AS Fsc, "+emptySu+" AS Fsu "
				+ " FROM ^schet_zr "
				+ " WHERE (Fdate >="+cdat1+" and Fdate<="+cdat2+")"
					+ " AND Fwrk<>16"
					+ " AND (Fdb_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
					+ "(Fdb_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
					+ " AND (Fcr_sc NOT BETWEEN " + parZabalB + " AND " + parZabalE + ") AND "
					+ "(Fcr_sc NOT BETWEEN " + parNZabalB + " AND " + parNZabalE + ")"
					+ orgCond
				+ " GROUP BY Fcr_sc, Fcr_su, Fdb_sc, Fdb_su";
			ExecuteSQL(strSQL);
		}

		strSQL=
			"UPDATE SHAXM_Z"
			+ " SET Fsc=Fsc1"
				+ ", Fsu=Fsu1"
				+ ", Fsc_corr=Fsc_corr1"
				+ ", Fsu_corr=Fsu_corr1";
		ExecuteSQL(strSQL);


		strSQL ="select "+sqlTo(sc_sup)+" as fsc, "+sqlTo(su_sup)+" as fsu, fsc_corr, fsu_corr, 1 as find,  "+
		                "sum(SHAXM_Z.Fsum) as Fsum into SHAXM_Z3 from SHAXM_Z WHERE find=1 group by  Fsc_corr, Fsu_corr ";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO SHAXM_Z(fsc, fsu, fsc_corr, fsu_corr, find,Fsum) select fsc, fsu, fsc_corr, fsu_corr, find,Fsum from SHAXM_Z3 ";
		ExecuteSQL(strSQL);

		strSQL ="select fsc, fsu, "+sqlTo(sc_sup)+" as fsc_corr, "+sqlTo(su_sup)+" as fsu_corr, 1 as find,  "+
		        "sum(SHAXM_Z.Fsum) as Fsum into SHAXM_Z4 from SHAXM_Z WHERE find=1 group by  Fsc, Fsu ";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO SHAXM_Z(fsc, fsu, fsc_corr, fsu_corr, find,Fsum) select fsc, fsu, fsc_corr, fsu_corr, find,Fsum from SHAXM_Z4 ";
		ExecuteSQL(strSQL);

		strSQL =
			"SELECT fsc"
				+ ", " + sqlTo(su_sup) + " as fsu"
				+ ", fsc_corr, fsu_corr"
				+ ", 1 as find"
				+ ", sum(SHAXM_Z.Fsum) as Fsum"
			+ " INTO SHAXM_Z5"
			+ " FROM SHAXM_Z"
			+ " WHERE find=1"
				//+ " AND Fsu_corr<>0"
//				+ " AND Fsu<>0"
			+ " GROUP BY Fsc, Fsc_corr, Fsu_corr ";
		ExecuteSQL(strSQL);

		strSQL =
			"SELECT fsc, fsu, fsc_corr"
				+ ", " + sqlTo(su_sup) + " as fsu_corr"
				+ ", 1 as find"
				+ ", sum(SHAXM_Z.Fsum) as Fsum"
			+ " INTO SHAXM_Z6"
			+ " FROM SHAXM_Z"
			+ " WHERE find=1"
				//+ " AND Fsu<>0"
//				+ " AND Fsu_corr<>0"
			+ " GROUP BY Fsc, Fsu, Fsc_corr ";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO SHAXM_Z(fsc,fsu,fsc_corr, fsu_corr,find,Fsum) select fsc,fsu,fsc_corr, fsu_corr,find,Fsum from SHAXM_Z5 ";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO SHAXM_Z(fsc, fsu, fsc_corr,fsu_corr,find,Fsum) select fsc, fsu, fsc_corr,fsu_corr,find,Fsum from SHAXM_Z6 ";
		ExecuteSQL(strSQL);
		strSQL =
				"SELECT Fsum AS Fvalue"
					+ ", "+SqlConCat(Convert("Fsc","NVC"),"'@'",Convert("Fsu","NVC"))+" AS FROWID"
					+ ", "+SqlConCat(Convert("Fsc_corr","NVC"),"'@'",Convert("Fsu_corr","NVC"))+" AS FCOLID"
					+ ", fsc, fsu, fsc_corr, fsu_corr "
				+ "INTO SHAXM_Z_s "
				+ "FROM SHAXM_Z";
		
		
			
		ExecuteSQL(strSQL);
		
		
		createIndex("SHAXM_Z_s", "RowCol", "FROWID, FCOLID");
//		ExecuteSQL("CREATE INDEX RowCol ON SHAXM_Z_s (FROWID, FCOLID)");
		ExecuteSQL(
				"SELECT DISTINCT FROWID, fsc, fsu"
					+ ", "+IIF("fsc=" + sql_sc_sup, 
								"'Итого'", 
								IIF("fsu="+sqlTo(su_sup),
									SqlConCat("'По сч.'",Convert("fsc","NVC")), 
									SqlConCat(Convert("fsc","NVC"),"'/'",Convert("fsu","NVC"))))
							+" as Ftxt "
				+ " INTO SHAXM_Z_r"
				+ " FROM SHAXM_Z_S"				
				);

		ExecuteSQL(
				"SELECT DISTINCT FCOLID, fsc_corr, fsu_corr"
					+ ", "+IIF("fsc_corr="+sql_sc_sup,
								"'Итого'",
								IIF("fsu_corr="+sqlTo(su_sup),
									SqlConCat("'По сч.'",Convert("fsc_corr","NVC")), 
									SqlConCat(Convert("fsc_corr","NVC"),"'/'",Convert("fsu_corr","NVC"))
									)
								 )+" AS Ftxt "
				+ " INTO SHAXM_Z_c FROM SHAXM_Z_s"				
				);		
		

	}

  return true;
}