//выгрузка данных из SVZP в приказ для формирования формы 1ДФ с 2011
//введены новые коды начислений, разбивка по всем облагаемым кодам, можно изменять порядок разбивки
//алгоритм разбивки такой: СОБИРАЕМ суммы по кодам начислений. Эти суммы в порядке возрастания кодов (по умолчанию такой,
//в настройке можно поменять) делим с учетом границы 10 минимальных зарплат. Находим для тех, у кого есть льгота,
//сумму льготы и отнимаем ее от базы, оставшуюся сумму бьем с учетом границы (15 и 17%), умножаем на
//соответстующие проценты. Полученную сумму сравниваем с суммой ПН,начисленного в ЛС. Разницу сбрасываем на
//минимальный код.
//include("firstkv.js")
//include("lastkv.js")
include("get_cnst.js")
include("servis\\format.js");

function svz8dr3(dateb,datee,vidprk,fis_vipl)
{
   var vid_zp = 101

   fis_udn = false;
   if (confirm(ru("Подоходный налог перечислен в квартале расчета?","Прибутковий податок перерахований в кварталі розрахунку?")))
      fis_udn = true;

   var TMPSVZP = getTmpTableName();
   
   DropTable(TMPSVZP);
	var snap = getSnap("SELECT F_proc FROM ^nalog WHERE Fbdat<="+sqlTo(dateb)+" AND Fedat>="+sqlTo(dateb))
	if(snap!=null)
		var proc_pn = snap[0];

   var __year, D1, D2, datbeg, datend;
   var ZPK_table, SVZP_table, PRK_table;
  
   dateb = new Date(dateb);
   datee = new Date(datee);   
   //первое число месяца начисления
   D1 = new Date(dateb.getFullYear(),dateb.getMonth(),1);
   //последнее число месяца начисления
   D2 = new Date(dateb.getFullYear(),dateb.getMonth()+1,0);
   //если есть параметр, то не считать 133 код (ЕСВ)
   fis_r27 = get_cnst ("df27", D1)

    __year = (dateb.getFullYear()) + ((dateb.getMonth()<9)?"0":"") + (dateb.getMonth()+1);
    datbeg = D2.getVarDate();//месяц начисления
    datend = datee.getVarDate();//месяц выплаты
    if(!IsTableEx("zrp_res", "zrp_svzp" + __year))
	{ 
      _alert(ru("Не рассчитана заработная плата за указанный месяц",
         "Не розраховано заробітну платню за вказаний місяць"));
      return;
	}

    var fis_rfnd = true;
    if(!IsTableEx("zrp_res", "zrp_svpf" + __year))
    { 
       fis_rfnd = false;
    }
    
/*    if(!IsTableEx("zrp_res", "zrp_prk8dr"))
    { 
      _alert(ru("Не найдена таблица PRK8DR",
         "Не знайдено таблицю PRK8DR"));
      return;
	}*/

    // изменениe льгты на буд. периоды
	izmnx = get_cnst ("izmnx" , D1)
    
   is_rsc_pd = false;
   //var mFlv1pd = 0;
   //var mFlv2pd = 0;
   //var mFlv3pd = 0;
   //var mFlv4pd = 0;
   
   if (confirm(ru("Расчет будет проводиться по конкретным подразделениям?","Розрахунок буде проводитись по конкретним підрозділам?")))
   {
      /*var parpd = new Object();
      parpd.isZaval = true;
      parpd.Zavalmode = "VIBMAS";
      parpd.dat1 = D1;
      parpd.dat2 = D2;
      parpd.escape = false;
      showWindow("l_shtat.xml",SW_MODAL,parpd);
      if(parpd.escape == false)
         is_rsc_pd = true;*/
		//теперь можно отметить несколько подразделений
		var parpd = new Object();
		parpd.zaval = true;
		parpd.escape = false;
		parpd.ret = new Object();
		parpd.ret.fwid = 0;
		parpd.ret.fleftkey = 0;
		parpd.ret.frightkey = 0;
		parpd.dat = D1;
		showWindow("l_struOrg.js",SW_MODAL,parpd);
		if(!parpd.escape)
		{
			is_rsc_pd = true;
			if(parpd.retArray.length==0)
			{
				fleftkeys = parpd.ret.fleftkey;
				frightkeys = parpd.ret.frightkey;
				sWhere = " so.Fleftkey>="+fleftkeys+" AND so.Frightkey<="+frightkeys+" ";
			}
			else
			{
				fleftkeys = new Array();
				frightkeys = new Array();
				for(var i=0; i<parpd.retArray.length; i++)
				{
					for(var j in parpd.retArray[i])
					{
						if(j=="fleftkey")
							fleftkeys[i] = parpd.retArray[i][j];
						else
							if(j=="frightkey")
								frightkeys[i] = parpd.retArray[i][j];
					}
				}
				for(var i=0; i<fleftkeys.length; i++)
				{
					if(i==0)
						sWhere = "((so.Fleftkey>="+fleftkeys[i]+" AND so.Frightkey<="+frightkeys[i]+") "
					else
						sWhere += "OR (so.Fleftkey>="+fleftkeys[i]+" AND so.Frightkey<="+frightkeys[i]+") "
				}
				sWhere += ") ";
			}
		}
   }
   //если месяц начисления ЗП попадает в квартал выплаты, то начисл.и выпл.суммы
   //совпадают. Если месяц начисл.меньше, то прописываем только суммы к выплате,
   // суммы начисл. - 0
   var fis_regvip = false;
   if (dateb>=firstkv(datee) && dateb<=lastkv(datee))
      fis_regvip = true;
	if(is_rsc_pd)
		strSQL = "select sv.* into "+TMPSVZP+" from ^svzp"+__year+" as sv inner join ^work_pers as wp "
			+" on sv.ftabn_id=wp.fwid_cl inner join ^stru_dol as sd on wp.fwid_dol=sd.fwid inner join "
			+" ^stru_org as so on sd.fwid_org=so.fwid where "+sWhere+" and not (sv.Fvp=1 AND sv.Fmn>"
			+sqlTo(D1)+") and wp.Fwid=(select MAX(fwid) from ^work_pers as wp2 where wp.Fwid_cl=wp2.Fwid_cl and wp2.Fbdat<="+sqlTo(D2)+" and wp2.Fedat>="+sqlTo(D1)+")"
			+" order by sv.Ftabn_id,sv.Fmn,sv.Fvp,sv.Fday,sv.Ffld_num";
	else
		strSQL = "select * into "+TMPSVZP+" from ^svzp"+__year+" where not (Fvp=1 AND Fmn>"+sqlTo(D1)+") order by Ftabn_id,Fmn,Fvp,Fday,Ffld_num";
   ExecuteSQL(strSQL);
   ExecuteSQL("ALTER TABLE "+TMPSVZP+" ADD Fcod_kzo "+SqlType("LONG"))   
   strSQL = "UPDATE "+TMPSVZP+" set Fcod_kzo=Fday where Fwid_wp=0 and Fis_day<>2"
   ExecuteSQL(strSQL);
   strSQL = "UPDATE "+TMPSVZP+" set Fday=0 where (Fwid_wp<>0 or (Fwid_wp=0 and Fis_day<>2))"
   ExecuteSQL(strSQL);

	/*if (is_rsc_pd)//оставляем только выбранное подразделение
	{
		//12,10,07 падает
		//strSQL = "DELETE FROM "+TMPSVZP+" WHERE Fwid=(SELECT t.Fwid FROM ((("
		//			+TMPSVZP+" t INNER JOIN ^work_pers wp ON t.Fwid_wp=wp.Fwid) "
		//			+"INNER JOIN ^stru_dol sd ON wp.Fwid_dol=sd.Fwid) "
		//			+"INNER JOIN ^stru_org so ON sd.Fwid_org=so.Fwid) "
		//			+"WHERE so.Fwid<>"+sqlTo(parpd.pFwid_org)+")";
 		DropTable("VRPODR")
        strSQL = " select t.*, so.Fwid as Fwid_org into VRPODR FROM "+TMPSVZP+" t INNER JOIN "
        	+" ( ^work_pers wp INNER JOIN ^stru_dol sd ON wp.Fwid_dol=sd.Fwid "
        	+" INNER JOIN ^stru_org so ON  sd.Fwid_org=so.Fwid) "
        	+" ON t.fwid_wp=wp.fwid WHERE so.Fwid<>"+sqlTo(parpd.pFwid_org)	
		ExecuteSQL(strSQL);
        
		strSQL = "UPDATE "+TMPSVZP+" set Ftabn_id=0 where EXISTS (select Fwid_org "
		+" from VRPODR where Ftabn_id="+TMPSVZP+".Ftabn_id)"
		ExecuteSQL(strSQL);
		
		strSQL = "DELETE from "+TMPSVZP+" where Ftabn_id=0"
		ExecuteSQL(strSQL);							

	}*/

   SVZP_table = OpenTable("s", "select * from "+TMPSVZP+" order by Ftabn_id,Fmn,Fvp,Fday,Ffld_num");

   CreateTable("TPRK8DR", "PRK8DR","*");
   ExecuteSQL("ALTER TABLE TPRK8DR ADD FISNOB "+ SqlType("BYTE"));   
   pn_fido = 0;
   pn_fids = 0;
   //Lic_table=OpenTable("s", "LIC_FLD", "LIC_FID");
    
   var snap = getSnap("SELECT Fid FROM ^LIC_FLD WHERE Fis1='п'");
   if(snap==null)
   {
      str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
                " Hевозможно идентифицировать поле ЛС: под.налог       \n"+
                "       Пригласите разработчиков для устранения        "
      _alert(str_alert);          
      return;
   }
   else
     pn_fido = snap[0];

   //if (!Lic_table.FindFirst("Fis1='s'"))
   var snap = getSnap("SELECT Fid FROM ^LIC_FLD WHERE Fis1='s'");
   if(snap==null)
   {
      str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
                " Hевозможно идентифицировать поле ЛС: под.налог совм. \n"+
                "       Пригласите разработчиков для устранения        "
      _alert(str_alert);          
      return;
   }
   else
     pn_fids = snap[0]

   PRIK_table = OpenTable("s","SELECT * FROM ^CL_PRIK")
   var VVPRK = "";
   var VVPRKDET = "";
   PRIK_table.MoveFirst();
   while (!PRIK_table.IsEOF())
   {
      if (String(PRIK_table.getValue("Fproc")).indexOf("_nlgn39")!=-1 || String(PRIK_table.getValue("Fproc")).indexOf("_nlgn39n")!=-1|| String(PRIK_table.getValue("Fproc")).indexOf("_nlgn40n")!=-1)
      {
         VVPRK = PRIK_table.getValue("Fvid");
      }
      if (String(PRIK_table.getValue("Fedit")).indexOf("_det")!=-1 )
      {
         VVPRKDET = PRIK_table.getValue("Fvid");
      }
      PRIK_table.MoveNext();
   }
   PRIK_table.close();
   if (VVPRK =="")
      WAIT("ошибка - не найдена запись с под.налогом в CL_PRIK")

   //прописать код льготы 0 для будущих записей (убрала 06.10.2004)
   //ExecuteSQL("UPDATE "+TMPSVZP+" set Fday=0 WHERE Fvp=2 AND Fmn>"+sqlTo(D1));

   //прописать код льготы по будущим суммам, пришедшим из прошлого месяца
   //svz1 = OpenTable("s","select * from ^SVZP"+__year
   //   + " WHERE Fis_day=2 and Fvp=0");
   svz1 = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fvp=0");
   if (!svz1.IsEmpty())
   {
      svz1.MoveFirst();
      while (!svz1.IsEOF())
      {
   		 strSQL = "UPDATE "+TMPSVZP+" set Fday="+sqlTo(svz1.getValue("Fday"))+" where  Ftabn_id="+sqlTo(svz1.getValue("Ftabn_id"))+" and Fvp=1 AND Fmn<"+sqlTo(D1);
   		 ExecuteSQL(strSQL);
   		 //strSQL = "UPDATE "+TMPSVZP+" set Fday="+sqlTo(svz1.getValue("Fday"))+" where Ftabn_id="+sqlTo(svz1.getValue("Ftabn_id"))+" and Fvp=2 AND Fmn>"+sqlTo(D1);
   		 //ExecuteSQL(strSQL);
         strSQL = "UPDATE "+TMPSVZP+" set Fday="+sqlTo(svz1.getValue("Fday"))+", Fchas=0, Fmn="+sqlTo(d00obj)+" where Ftabn_id="+sqlTo(svz1.getValue("Ftabn_id"))+" and Fvp=0";
         ExecuteSQL(strSQL);
         svz1.MoveNext();
      }
   }
   svz1.close();
   SVZP_table.requery();

   //прописать код льготы по будущим месяцам
   svz1 = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fvp=2 AND Fmn>"+sqlTo(D1));
   if (!svz1.IsEmpty())
   {
      svz1.MoveFirst();
      while (!svz1.IsEOF())
      {
    	 if (izmnx!=1){    	  
    		 strSQL = "UPDATE "+TMPSVZP+" set Fday="+sqlTo(svz1.getValue("Fday"))+" where Ftabn_id="+sqlTo(svz1.getValue("Ftabn_id"))+" and Fvp=2 AND Fmn="+sqlTo(svz1.getValue("Fmn"));
    		 ExecuteSQL(strSQL);
    	 }	 
         svz1.MoveNext();
      }
   }
   svz1.close();
   SVZP_table.requery();
   
   //прописать код льготы по записям по перерасчету за прошлые месяцы
   svzp1 = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fvp=2 and Fmn<"+sqlTo(D1))
   if (!svzp1.IsEmpty())
   {
      svzp1.MoveFirst();
      while (!svzp1.IsEOF())
      {
         strSQL = "UPDATE "+TMPSVZP+" set Fday="+sqlTo(svzp1.getValue("Fday"))+" where Ftabn_id="+sqlTo(svzp1.getValue("Ftabn_id"))+" and Fvp=2 AND Fmn="+sqlTo(svzp1.getValue("Fmn"));
         ExecuteSQL(strSQL);
         svzp1.MoveNext();
      }
   }
   svzp1.close();
   SVZP_table.requery();

   //прописать код льготы в прошлых месяцах по будущим суммам
   //на основании текущего месяца
   svz11 = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fvp=1 AND Fmn<"+sqlTo(D1));
   if (!svz11.IsEmpty())
   {
      svz11.MoveFirst();
      while (!svz11.IsEOF())
      {
            dtsvz11 = new Date(new Date(svz11.getValue("Fmn")).getFullYear(),new Date(svz11.getValue("Fmn")).getMonth()+1,0);
            //ExecuteSQL("UPDATE ^PRK_ALL SET Fsumobl="+sqlTo(svz11.getValue("Fday"))
            //			+" WHERE Fvid_prk="+sqlTo(vidprk)+" AND Fbdat="+sqlTo(dtsvz11)
            //			+" AND Ftabn_id="+sqlTo(svz11.getValue("Ftabn_id"))
            //			+" AND Fmn="+sqlTo(D1)+" AND Fvp=2 AND Fvidnach<200")
            //12.10.07 падал на прошл.записях, пробую переделать ЯНА
            //ExecuteSQL("UPDATE ^PRK8DR SET Fsumobl="+sqlTo(svz11.getValue("Fday"))
            //			+" WHERE Fwid=(SELECT Fwid FROM ^PRK_ALL WHERE Fvid_prk="+sqlTo(vidprk)
            //						+" AND Fbdat="+sqlTo(dtsvz11)+" AND Ftabn_id="
            //						+sqlTo(svz11.getValue("Ftabn_id"))
            //			+") AND Fmn="+sqlTo(D1)+" AND Fvp=2 AND Fvidnach<200");
            ExecuteSQL("UPDATE ^PRK8DR SET Fsumobl="+sqlTo(svz11.getValue("Fday"))
            			+" WHERE Fwid=(SELECT Fwid FROM ^PRK_ALL WHERE ^PRK_ALL.FWID=^PRK8DR.FWID AND Fvid_prk="+sqlTo(vidprk)
            						+" AND Fbdat="+sqlTo(dtsvz11)+" AND Ftabn_id="
            						+sqlTo(svz11.getValue("Ftabn_id"))
            			+") AND Fmn="+sqlTo(D1)+" AND Fvp=2 AND Fvidnach<200");

            svz11.MoveNext();
      }
   }
   svz11.close();

   //18.10.11
   //прописать код льготы в прошлых месяцах по будущим суммам
   //на основании текущего месяца если нет налога с минусом (сумма такая маленькая, что налог не начислился
   svz11 = OpenTable("s","select distinct a.Ftabn_id, a.Fmn, a.Fvp, a.Fday, a.Fis_day,a.Fsum,a.Fwid_wp  from ("+TMPSVZP+" as a inner join ^LIC_FLD as l on a.Flsfid=l.Fid) WHERE (l.Fis1='+' or l.Fis1='#') and a.Fvp=1 AND a.Fmn<"+sqlTo(D1)+" and a.Fsum<0 and a.Fwid_wp<>0"
           + " and  not EXISTS (select  *  from  "+TMPSVZP+" as b where b.Ftabn_id=a.Ftabn_id and a.Fmn=b.Fmn and a.Fvp=b.Fvp and b.Fis_day=2)")           
   if (!svz11.IsEmpty())
   {
      svz11.MoveFirst();
      while (!svz11.IsEOF())
      {
            dtsvz11 = new Date(new Date(svz11.getValue("Fmn")).getFullYear(),new Date(svz11.getValue("Fmn")).getMonth()+1,0);
            ExecuteSQL("UPDATE ^PRK8DR SET Fsumobl="+sqlTo(svz11.getValue("Fday"))
            			+" WHERE Fwid=(SELECT Fwid FROM ^PRK_ALL WHERE ^PRK_ALL.FWID=^PRK8DR.FWID AND Fvid_prk="+sqlTo(vidprk)
            						+" AND Fbdat="+sqlTo(dtsvz11)+" AND Ftabn_id="
            						+sqlTo(svz11.getValue("Ftabn_id"))
            			+") AND Fmn="+sqlTo(D1)+" AND Fvp=2 AND Fvidnach<200");

            svz11.MoveNext();
      }
   }
   svz11.close();
   
   //прописать код льготы в прошлых месяцах по перерасчетам
   //в текущем месяце за прошлые
   //svz2 = OpenTable("s","select * from ^SVZP"+__year
   //   + " WHERE Fis_day=2 and Fvp=2 AND Fmn<"+sqlTo(D1));
   svz2 = OpenTable("s","select * from "+TMPSVZP+" WHERE (Flsfid="+sqlTo(pn_fido)+" or Flsfid="+sqlTo(pn_fids)+") and Fvp=2 AND Fmn<"+sqlTo(D1));
   if (!svz2.IsEmpty())
   {
      svz2.MoveFirst();
      while (!svz2.IsEOF())
      {
            dtsvz2 = new Date(new Date(svz2.getValue("Fmn")).getFullYear(),new Date(svz2.getValue("Fmn")).getMonth()+1,0);
			//ExecuteSQL("UPDATE ^PRK_ALL SET Fsumobl="+sqlTo(svz2.getValue("Fday"))
            //			+" WHERE Fvid_prk="+sqlTo(vidprk)+" AND Fbdat="+sqlTo(dtsvz2)
            //			+" AND Ftabn_id="+sqlTo(svz2.getValue("Ftabn_id"))
            //			+" AND Fvp=0 AND Fvidnach<200")
            //12.10.07 падал ЯНА
            //ExecuteSQL("UPDATE ^PRK8DR SET Fsumobl="+sqlTo(svz2.getValue("Fday"))
            //			+" WHERE Fwid=(SELECT Fwid FROM ^PRK_ALL WHERE Fvid_prk="
            //						+sqlTo(vidprk)+" AND Fbdat="+sqlTo(dtsvz2)
            //						+" AND Ftabn_id="+sqlTo(svz2.getValue("Ftabn_id"))
            //			+") AND Fvp=0 AND Fvidnach<200")
            ExecuteSQL("UPDATE ^PRK8DR SET Fsumobl="+sqlTo(svz2.getValue("Fday"))
            			+" WHERE Fwid=(SELECT Fwid FROM ^PRK_ALL WHERE ^PRK_ALL.FWID=^PRK8DR.FWID AND Fvid_prk="
            						+sqlTo(vidprk)+" AND Fbdat="+sqlTo(dtsvz2)
            						+" AND Ftabn_id="+sqlTo(svz2.getValue("Ftabn_id"))
            			+") AND Fvp=0 AND Fvidnach<200")

            svz2.MoveNext();
      }
   }
   svz2.close();

   // необлаг.процент по страховке за счет предприятия
   procsl = get_cnst("procsl", D1)

   // необла. сумма на погребение своего сотрудника
   npogr = get_cnst("npogr", D1)

   // сумма прож.мин.*1.4, окр.до ближ.10 грн.
   minnal = get_cnst ("minnal", D1)

   
   //с 2011 есть база для фондов и сама сумма ЕСВ, их и нужно искать для таб.N

   //напротив каждого поля ЛС в формировании перечня ЛС стоит код вида начисления. Загоняем
   //все имеющиеся коды в массив кодов видов начислений. Соответсвенно этим кодам собираем суммы 
   //отдельно обрабатываем случаи с налогом на страховки, обучение, погребение, мат.помощь, распределяемую 
   //в системе
   //коды видов начислений засунем в массив
   var lsf = Array(50)
   //откуда выделять подоходный налог
   //var vdn = Array(50)
   var ssum = Array(50)
   var ssumn = Array(50)
   var ssump = Array(50)
   var ssumsn = Array(50)
   var ssumon = Array(50)
   var ssum_pg = Array(50)
   var ssum_strn = Array(50)
   var ssum_obn = Array(50)
   var ssumps = Array(50)
   var ssumsns = Array(50)
   var ssumons = Array(50)
   var ssumpo =  Array(50)
   var ssumsno = Array(50)
   var ssumono = Array(50)
   var ssum_pgo = Array(50)
   var ssum_strno = Array(50)
   var ssum_obno = Array(50)
   var ssum_pgs = Array(50)
   var ssum_strns = Array(50)
   var ssum_obns = Array(50)

   for (var iii=0; iii<50; iii++)
   { 
      lsf[iii]    = 0;
   }  

   var nm = 0;
   var strSQL = "select distinct Fis31 from ^LIC_FLD where Fis_slct="+sqlTrue+" and Fis31<>0 order by Fis31"
   var tl = OpenTable("s", strSQL);
   if (!tl.IsEmpty()){
      tl.MoveFirst();
      while (!tl.IsEOF()){ 
         lsf[nm] = Number(tl.getValue("Fis31"))
         tl.MoveNext()
         if (!tl.IsEOF()){
            nm = nm+1;
         }  
      }
   }
   tl.close();
   
   //в nm должны получиь количество кодов начислений
   
   var ozn_pilg = 0
   var ssum27fp = 0          
   var nach27fp = 0         
   var nalog1 = 0          

   var pFtabn_id;
   var pFtabn;   
   var pFday;
   var pFmn;
   var pFvp;
   var mFsum;
   var mFlsfid;
   var fld_mrk;
   var fld_mrk1;
   var fld_mrk2;

	SVZP_table.MoveFirst();    
	while(!SVZP_table.IsEOF())
	{
		var oSnap = getSnap("SELECT Fcod FROM ^clrelclcl WHERE Fwid_cl="+sqlTo(SVZP_table.getValue("Ftabn_id")));
		if(oSnap!=null)
			pFtabn = oSnap[0];
		else
			Ftabn = 0;
		pFwid_wp = toScrObj(SVZP_table.getValue("Fwid_wp"));
		pFtabn_id = toScrObj(SVZP_table.getValue("Ftabn_id"));
		pFday = toScrObj(SVZP_table.getValue("Fday"));
		pFmn = toScrObj(SVZP_table.getValue("Fmn"));
		pFvp = toScrObj(SVZP_table.getValue("Fvp"));
		//if(typeof(pFtabn)=="unknown")
		//	debug("unknown");
		WAIT("Рассчит.таб.N "+ pFtabn);
			
	    var ozn_pilg = 0

	    var ssum27   = 0          
	    var ssum27fp = 0          
	    var nach27fp = 0          

	    var nalog1  = 0          

	    var ssumdox  = 0
		
	    for (var iii=0; iii<=nm; iii++)
	    { 
	         ssum[iii]   = 0;
	         ssumn[iii]  = 0;
	         ssump[iii]  = 0;
	         ssumsn[iii] = 0;
	         ssumon[iii] = 0;
	    }  

		while((!SVZP_table.IsEOF()) && (Number(SVZP_table.getValue("Ftabn_id"))==pFtabn_id) && (SVZP_table.getValue("Fday")==pFday) && (!differ(SVZP_table.getValue("Fmn"),pFmn)) && (Number(SVZP_table.getValue("Fvp"))==pFvp))
	    {    
	         var mFsum   = toScrObj(SVZP_table.getValue("Fsum"));
	         var mFlsfid = toScrObj(SVZP_table.getValue("Flsfid"));
	         // проверка входимости в налогооблагаемую сумму
	         var snap = getSnap("SELECT Fis1,Fis5,Fis14,Fis9,Fis26,Fis31,Fis12 FROM ^LIC_FLD WHERE Fid="+sqlTo(mFlsfid));
	         //if(!Lic_table.FindFirst("fid="+sqlTo(mFlsfid)))
	         if(snap==null)
	         { 
	            alert(ru("Обнаружена серьезная ошибка функционирования системы. "
	               + "\nСсылка на неизвестное поле лицевого счета " + mFlsfid
	               + "\nПригласите разработчиков для устранения.",
	                  "Виявлена серйозна помилка функціонування системи. "
	               + "\nПосилання на невідоме поле особистого рахунку " + mFlsfid
	               + "\nЗапросіть розробників для виправлення."));
	            continue;
	         }

	         //* пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
	         //* колонке (Fis1) файла LIC_FLD
	         var fld_mrk  = snap[0]//toScrObj(Lic_table.getValue("Fis1"));
	         var fld_mrk1 = snap[1]//toScrObj(Lic_table.getValue("Fis5"));
	         var fld_mrk2 = snap[2]//toScrObj(Lic_table.getValue("Fis14"));
	         var fld_mrk3 = snap[3]//toScrObj(Lic_table.getValue("Fis9"));
	         var fld_mrk4 = snap[4]//toScrObj(Lic_table.getValue("Fis26"));
	         //fld_mrk4 = Lic_table("Fis6");
	         fld_mrk5 = snap[5]//toScrObj(Lic_table.getValue("Fis20"));
	         //начисл.на ЗП 
	         fld_mrk10 = snap[6]//toScrObj(Lic_table.getValue("Fsoc"));

	         //* облагаемые суммы из прочих удержаний и потери кормильца по основному месту работы
	         ozn_pilg = (fld_mrk=="п" || fld_mrk=="s")? Number(SVZP_table.getValue("Fday")): ozn_pilg;

	         ssumdox = (fld_mrk4=="+")? ssumdox + mFsum: ssumdox 

	         for (var iii=0; iii<=nm; iii++)
	         {
	        	 //начисления ЗП с разбивкой по кодам
	            ssum[iii]   = (lsf[iii]==fld_mrk5 && fld_mrk3!="п" && fld_mrk3!="+" && fld_mrk3!="#" && fld_mrk3!="о" && fld_mrk3!="у" && fld_mrk3!="м" && fld_mrk3!="t")? ssum[iii] + mFsum: ssum[iii]
	            ssumn[iii]  = (lsf[iii]==fld_mrk5 && fld_mrk3!="п" && fld_mrk3!="+" && fld_mrk3!="#" && fld_mrk3!="о" && fld_mrk3!="у" && fld_mrk3!="м" && fld_mrk3!="t" && fld_mrk!="+" && fld_mrk!="#")? ssumn[iii] + mFsum: ssumn[iii]
	            //сумма погребения
	            ssump[iii]  = (lsf[iii]==fld_mrk5 && fld_mrk3=="п")? ssump[iii] + mFsum: ssump[iii]
	            //* сумма страховки общая 
	            ssumsn[iii] = (lsf[iii]==fld_mrk5 && (fld_mrk3=="+" || fld_mrk3=="#"))? ssumsn[iii] + mFsum:  ssumsn[iii]
	            //* сумма обучения 
	            ssumon[iii] = (lsf[iii]==fld_mrk5 && (fld_mrk3=="о" || fld_mrk3=="у"))? ssumon[iii] + mFsum:  ssumon[iii]
	         }  
	         //* удеpжаный подоходный налог
	         //if (fis_udn){
	            nalog1 = ( fld_mrk=="п" || fld_mrk=="s")? nalog1 +mFsum: nalog1
	         //}
	         SVZP_table.MoveNext();
	    }//while((!SVZP_table.IsEOF()) && (SVZP_table("Ftabn_id")==pFtabn))
		
		//суммы начисления ЕСВ на зарплату
		if (fis_r27!=1){
	          if (fis_rfnd ==false){
	             //взять из SVZP суммы начислений
	             strSQL = "select *  from "+TMPSVZP+" a inner join ^LIC_FLD b on a.Flsfid=b.Fid where Ftabn_id="+sqlTo(pFtabn_id)+" and Fvp="+sqlTo(pFvp)+" and Fmn="+sqlTo(pFmn)+" and (b.Fis12='5' or b.Fis12='6' or b.Fis12='7')"
	             var tf = OpenTable("s", strSQL);
	             if (!tf.IsEmpty()){
	                tf.MoveFirst();
	                while (!tf.IsEOF()){  
	                    var xgs = getSnap("select Fproc_n from ^NALOG_ESV where Fcod_kzo="+sqlTo(Number(tf.getValue("Fcod_kzo"))))  
	                    var proc_n = 0;
	                    if (xgs!=null){
	                       proc_n = Number(xgs[0])/100;                    
	                    }    
	                    ssum27 = ssum27 +round(Number(tf.getValue("Fsum"))*proc_n,2)
	                    tf.MoveNext();
	                }  
	             }
	             tf.close(); 
	          } 

	          if (fis_rfnd ==true){
	             //взять из SVPF суммы начислений
	             var xgs = getSnap("select sum(a.Fsum) as Fsum  from ^svpf"+__year+" a inner join ^LIC_FLD b on a.Flsfid=b.Fid where Ftabn_id="+sqlTo(pFtabn_id)+" and Fvp="+sqlTo(pFvp)+" and Fmn="+sqlTo(pFmn)+" and (b.Fis12='0' or b.Fis12='k' or b.Fis12='h')")
	             if (xgs!=null){	             
	                ssum27 = Number(xgs[0]);
	             }
	          } 
	    }
		
		//так как страховка, обучение и погребение делится на облагаемую и необлагаемую суммы, при перерасчете
		//за прошлое эти суммы достаточно сложно выделять, они имеют особенность. Нужно найти сумму
		//по этим начислениям в том месяце, за который делался перерасчет, добавить к ней сумму перерасчета,
		//выделить облагаемую и необлагаемую сумму и на основе этого посчитать, какая часть из суммы
		//по перерасчету относится к облагаемой части, а какая - к необлагаемой.
	    for (var iii=0; iii<=nm; iii++)
	    { 
	         ssum_pg[iii] = 0;
	         ssum_strn[iii] = 0;
	         ssum_obn[iii] = 0;
	    }  
		
	    //*********************** 
	    // если идем по записям по перерасчету за прошлые месяцы, то нужна
	    // эта вставка  
	    if (pFvp==2 && differ(new Date(pFmn),new Date(D1))<0 && differ(new Date(pFmn),new Date(2011,0,1))>=0)
	    {
	         //открыть SVZP  с pFmn и накопить там суммы страховки и т.д.
	         mFmnmonth = new Date(pFmn).getMonth()+1;
	         mFmnyear  = new Date(pFmn).getFullYear();

	         if (mFmnmonth<10) 
	         	svzpmonth = "0" + mFmnmonth
	         else 
	         	svzpmonth = mFmnmonth
	         svzpyear = ""+mFmnyear

	         var tblsvzp = "zrp_" + "svzp" + svzpyear +  svzpmonth;  
	         var svzpnm  = "svzp" + svzpyear +  svzpmonth;  
	         if(IsTableEx("zrp_res", tblsvzp))
	         {
	            //открыли svzp
	            svzpnm = OpenTable("s", "select * from ^svzp" + svzpyear+  svzpmonth  +" where Ftabn_id="+sqlTo(pFtabn_id)+" and FVP=0");
	            if (!svzpnm.IsEmpty())
	            {
	               svzpnm.MoveFirst();
	               var ssum27s   = 0          
	               var ssum27fps = 0          

	               for (var iii=0; iii<=nm; iii++)
	               { 
	                   ssumps[iii] = 0;
	                   ssumsns[iii] = 0;
	                   ssumons[iii] = 0;
	                   ssumpo[iii] = 0;
	                   ssumsno[iii] = 0;
	                   ssumono[iii] = 0;
	                   ssum_pgo[iii] = 0;
	                   ssum_strno[iii] = 0;
	                   ssum_obno[iii] = 0;
	                   ssum_pgs[iii] = 0;
	                   ssum_strns[iii] = 0;
	                   ssum_obns[iii] = 0;
	               }  

	               ssumdoxs =0
	               
	               while (!svzpnm.IsEOF())
	               {
	                  mFsum   = toScrObj(svzpnm.getValue("Fsum"));
	                  mFlsfid = toScrObj(svzpnm.getValue("Flsfid"));
	                  mFday   = toScrObj(svzpnm.getValue("Fday"));	                  
	                  // проверка входимости в налогооблагаемую сумму
	                  var snap = getSnap("SELECT Fis1,Fis5,Fis14,Fis9,Fis26,Fis31,Fis12 FROM ^LIC_FLD WHERE Fid="+sqlTo(mFlsfid));
	                  //if(!Lic_table.FindFirst("fid="+sqlTo(mFlsfid)))
	                  if(snap==null)
	                  { 
	                    alert(ru("Обнаружена серьезная ошибка функционирования системы. "
	                    + "\nСсылка на неизвестное поле лицевого счета " + mFlsfid
	                    + "\nПригласите разработчиков для устранения.",
	                    "Виявлена серйозна помилка функц_онування системи. "
	                    + "\nПосилання на нев_доме поле особистого рахунку " + mFlsfid
	                    + "\nЗапрос_ть розробник_в для виправлення."));
	                    continue;
	                  }
	    
	                  //* пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
	                  //* колонке (Fis1) файла LIC_FLD
	                  fld_mrk = snap[0]//toScrObj(Lic_table.getValue("Fis1"));
	                  fld_mrk1 = snap[1]//toScrObj(Lic_table.getValue("Fis5"));
	                  fld_mrk2 = snap[2]//toScrObj(Lic_table.getValue("Fis14"));
	                  fld_mrk3 = snap[3]//toScrObj(Lic_table.getValue("Fis9"));
	                  fld_mrk4 = snap[4]//toScrObj(Lic_table.getValue("Fis26"));
	                  fld_mrk5 = snap[5]//toScrObj(Lic_table.getValue("Fis20"));
	                  //начисл.на ЗП 
	                  fld_mrk10 = snap[6]//toScrObj(Lic_table.getValue("Fsoc"));
	                  //накопить суммы по страховке, обучению, погребению
	                  for (var iii=0; iii<=nm; iii++)
	                  { 
	                      ssumps[iii] = (lsf[iii]==fld_mrk5 && fld_mrk3=="п")? ssumps[iii] + mFsum: ssumps[iii]
	                      //* сумма страховки 
	                      ssumsns[iii] = (lsf[iii]==fld_mrk5 && (fld_mrk3=="+" || fld_mrk3=="#"))? ssumsns[iii] + mFsum:  ssumsns[iii]
	                      //* сумма обучения 
	                      ssumons[iii] = (lsf[iii]==fld_mrk5 && (fld_mrk3=="о" || fld_mrk3=="у"))? ssumsns[iii] + mFsum:  ssumsns[iii]
	                  }  

	                  ssumdoxs = (fld_mrk4=="+")? ssumdoxs + mFsum: ssumdoxs 

	                  svzpnm.MoveNext(); 
	               }
	               
	               // получить суммы со всеми ограничениями по ЛС до перерасчета
	               //сумма страховки по месяцу перерасчета без данных перерасчета
	               //сумма необлагаемой страховки
	               var sum_lg = (round(ssumdoxs*procsl/100,2)>minnal)?minnal:round(ssumdoxs*procsl/100,2);

	               for (var iii=0; iii<=nm; iii++)
	               { 
	                   if (ssumps[iii]!=0){      
	                      ssum_pgs[iii] = (ssumps[iii]-npogr>0)?(ssumps[iii]-npogr):0;
	                   }else{
	                      ssum_pgs[iii] = 0;
	                   } 
	                   if (ssumsns[iii]!=0){      
	                      ssum_strns[iii] = (ssumsns[iii]-sum_lg>0)?(ssumsns[iii]-sum_lg):0;
	                   }else{
	                      ssum_strns[iii] = 0;
	                   }  
	                   if (ssumons[iii]!=0){      
	                      ssum_obns[iii] = (ssumons[iii]-minnal>0)?(ssumons[iii]-minnal):0;
	                   }else{
	                      ssum_obns[iii] = 0;
	                   }
	               }  

	               // сумма до ограничения с учетом svzp и перерасчета
	               ssumdoxo =ssumdox+ssumdoxs
	               for (var iii=0; iii<=nm; iii++)
	               { 
	                   ssumpo[iii] = ssump[iii]+ssumps[iii]
	                   //* сумма страховки 
	                   ssumsno[iii] = ssumsn[iii]+ssumsns[iii]
	                   //* сумма обучения 
	                   ssumono[iii] = ssumon[iii]+ssumons[iii]
	               }  


	               //сумма страховки общая
	               var sum_lgo = (round(ssumdoxo*procsl/100,2)>minnal)?minnal:round(ssumdoxo*procsl/100,2);
	               for (var iii=0; iii<=nm; iii++)
	               { 
	                   if (ssumpo[iii]!=0){      
	                      ssum_pgo[iii] = (ssumpo[iii]-npogr>0)?(ssumpo[iii]-npogr):0;
	                   }else{
	                      ssum_pgo[iii] = 0;
	                   }    
	                   //* сумма страховки 
	                   if (ssumsno[iii]!=0){      
	                      ssum_strno[iii] = (ssumsno[iii]-sum_lgo>0)?(ssumsno[iii]-sum_lgo):0;
	                   }else{
	                      ssum_strno[iii] = 0;
	                   }  
	                   //* сумма обучения 
	                   if (ssumono[iii]!=0){      
	                      ssum_obno[iii] = (ssumono[iii]-minnal>0)?(ssumono[iii]-minnal):0;
	                   }else{
	                      ssum_obno[iii] = 0;
	                   }  
	               }  


	               // получить разницу и записать в 1 ДФ
	               for (var iii=0; iii<=nm; iii++)
	               { 
	                   ssum_pg[iii] = ssum_pgo[iii]-ssum_pgs[iii]
	                   //общая сумма погребения
	                   ssump[iii] = ssumpo[iii]-ssumps[iii]
	                   //сумма необлагаемой страховки
	                   ssum_strn[iii] = ssum_strno[iii]-ssum_strns[iii]
	                   //общая сумма страховки  
	                   ssumsn[iii] = ssumsno[iii]-ssumsns[iii]
	                   //* сумма обучения 
	                   ssum_obn[iii] = ssum_obno[iii]-ssum_obns[iii]
	                   //общая сумма обучения
	                   ssumon[iii] = ssumono[iii]-ssumons[iii]
	               }  
	            }   
	            svzpnm.close();
	         }
	    }
	    else
	    {
	    	//суммы по страховке, обучению, погребению за текущий месяц (деление делается проще, чем при
	    	//перерасчете.
	          var sum_lg = (round(ssumdox*procsl/100,2)>minnal)?minnal:round(ssumdox*procsl/100,2);
	          for (var iii=0; iii<=nm; iii++)
	          { 
	             if (ssump[iii]!=0){      
	                 ssum_pg[iii] = (ssump[iii]-npogr>0)?(ssump[iii]-npogr):0;
	             }
	             if (ssumsn[iii]!=0){      
	                ssum_strn[iii] = (ssumsn[iii]-sum_lg>0)?(ssumsn[iii]-sum_lg):0;
	             }
	             if (ssumon[iii]!=0){      
	                ssum_obn[iii] = (ssumon[iii]-minnal>0)?(ssumon[iii]-minnal):0;
	             }
	          }  
	    	  
	    }	    

	      //сумму nalog1 будем прописывать в наименьший код начисления
	    //записываем суммы по видам начислений
	      for (var iii=0; iii<=nm; iii++)
	      {
				var m = new Object();
	            if ((ssum[iii]+ssum_pg[iii]+ssum_strn[iii]+ssum_obn[iii])){
					m.Fwid = GetUID();
					m.Fwid_wp =  pFwid_wp;
					m.Ftabn = pFtabn_id;
	                m.Fsum = ssum[iii]+ssum_pg[iii]+ssum_strn[iii]+ssum_obn[iii];
	                if (fis_regvip == true){
	                   m.Fsumn = ssum[iii]+ssum_pg[iii]+ssum_strn[iii]+ssum_obn[iii];
	               }else{
	            	   m.Fsumn = 0;
	               }
                   m.Fsumnal = 0;
	               m.Fsumnaln = 0
	               m.Fvidnach = lsf[iii];
	               m.Fbdat = datbeg;
	               m.Fedat = datend;
	               m.FMN   = pFmn;
	               m.FVP   = pFvp;
	               m.Fvid_prk = vidprk;
	               m.Fsumobl  = pFday;
     			   //если в необл. коде 1-ДФ ссылка на самого себя, тогда это поле не облагаем подоходным налогом
     			   var gsn = getSnap("select Fis33, Fis9 from ^LIC_FLD where Fis33=Fid and Fis_slct="+sqlTrue+" and Fis31="+sqlTo(Number(lsf[iii])))
     			   if(gsn)
						m.Fisnob   = 1;
     			   else
						m.Fisnob   = 0;	               
				   UpdateTable("TPRK8DR", m, true);
				   
		          //прописать необлагаемые суммы по страховке, обучению, погребению
				   //для этих сумм в настройке выделены 2 колонке. В стандартной колонке для 1ДФ Fis31
				   //прописываются коды видов начислений для облагаемых частей суммы, в колонке Fis33
				   //прописываются коды видов начислений для наоблагаемых частей суммы.
				   //Ищем для кода вида начислений,есть ли для него пара. Если есть, определяем, какого
				   //типа начисление, в зависимости от этого пропиываем суммы (суммы рассчитали выше).
	         	   var gsn = getSnap("select Fis33, Fis9 from ^LIC_FLD where Fis33<>0 and Fis_slct="+sqlTrue+" and Fis31="+sqlTo(Number(lsf[iii])))
	         	   if (gsn!=null){
	         		   //значит есть пара и нужно прописывать необлагаемые суммы
	         		   if (gsn[1]=="+" || gsn[1]=="#"){
	         			   //страховка
	         			   m.Fwid = GetUID();
	         			   m.Fwid_wp =  pFwid_wp;
	         			   m.Ftabn = pFtabn_id;
	         			   m.Fsum = ssumsn[iii]-ssum_strn[iii];
	         			   if (fis_regvip == true){
	         				   m.Fsumn = ssumsn[iii]-ssum_strn[iii];
	         			   }else{
	         				   m.Fsumn = 0;
	         			   }
	         			   m.Fsumnal = 0;
	         			   m.Fsumnaln = 0
	         			   m.Fvidnach = Number(gsn[0]);
	    	               m.Fbdat = datbeg;
	    	               m.Fedat = datend;
	         			   m.FMN   = pFmn;
	         			   m.FVP   = pFvp;
	         			   m.Fvid_prk = vidprk;
	         			   m.Fsumobl  = pFday;
	         			   m.Fisnob   = 1;	         			   
	         			   UpdateTable("TPRK8DR", m, true);
	         		  }
      	    		  if (gsn[1]=="п"){
      	    			  //погребение
	         			   m.Fwid = GetUID();
	         			   m.Fwid_wp =  pFwid_wp;
	         			   m.Ftabn = pFtabn_id;
	         			   m.Fsum = ssump[iii]-ssum_pg[iii];
	         			   if (fis_regvip == true){
	         				   m.Fsumn = ssump[iii]-ssum_pg[iii];
	         			   }else{
	         				   m.Fsumn = 0;
	         			   }
	         			   m.Fsumnal = 0;
	         			   m.Fsumnaln = 0
	         			   m.Fvidnach = Number(gsn[0]);
	    	               m.Fbdat = datbeg;
	    	               m.Fedat = datend;
	         			   m.FMN   = pFmn;
	         			   m.FVP   = pFvp;
	         			   m.Fvid_prk = vidprk;
	         			   m.Fsumobl  = pFday;
	         			   m.Fisnob   = 1;	         			   
	         			   UpdateTable("TPRK8DR", m, true);
      	    		  } 
     	    		  if (gsn[1]=="о" || gsn[1]=="у"){
     	    			  //обучение
	         			   m.Fwid = GetUID();
	         			   m.Fwid_wp =  pFwid_wp;
	         			   m.Ftabn = pFtabn_id;
	         			   m.Fsum = ssumon[iii]-ssum_obn[iii];
	         			   if (fis_regvip == true){
	         				   m.Fsumn = ssumon[iii]-ssum_obn[iii];
	         			   }else{
	         				   m.Fsumn = 0;
	         			   }
	         			   m.Fsumnal = 0;
	         			   m.Fsumnaln = 0
	         			   m.Fvidnach = Number(gsn[0]);
	    	               m.Fbdat = datbeg;
	    	               m.Fedat = datend;
	         			   m.FMN   = pFmn;
	         			   m.FVP   = pFvp;
	         			   m.Fvid_prk = vidprk;
	         			   m.Fsumobl  = pFday;
	         			   m.Fisnob   = 1;	         			   
	         			   UpdateTable("TPRK8DR", m, true);
     	    		  }	  
	         	   }
	            }
	    }  

      	  //прописать суммы по  матпомощи
	      //матпомощь распределяемая имеет свои особенности. В ЛС прописываеся справочно сумма необлагаемой
	      //части матпомощи, и есть общая сумма матпомощи. Их можно найти по буквам в колонке Fis9.
	      //В колонке Fis31 в настройке полей ЛС нужно для общей матпомощи прописать код для облагаемойъ
	      //части, для необлагаемой помощи - соотв.код. В программе из-за деления сумм по подразделениям
	      //справочная сумма не попадает в таблицу (для нее не прописывает в ЛС fwid_wp), по которой делаются расчеты. Поэтому приходится ее 
	      //обрабатывать отдельно и лезть непосредственно в лицевые счета, чтобы достать оттуда суммы.
    	   var gsn = getSnap("select Fis31, Fis9, Fid from ^LIC_FLD where Fis31<>0 and Fis_slct="+sqlTrue+" and Fis9='м'")
    	   if (gsn!=null){
    		      m = new Object();    		   
	    		  //мат.помощь облагаемая
    	    	  var gsn2 = getSnap("select Fis31, Fis9, Fid from ^LIC_FLD where Fis31<>0 and Fis_slct="+sqlTrue+" and Fis9='t'")

    	    	  var smnobl = 0;
    	    	  if(gsn2)
    	    	  {
	    	    	  var gs2 = getSnap("select sum(a.Fsum) as Fsum from ^svzp"+__year+" a  where a.Ftabn_id="+sqlTo(pFtabn_id)+" and a.Fvp="+sqlTo(pFvp)+" and a.Fmn="+sqlTo(pFmn)+" and a.Flsfid="+sqlTo(gsn2[2]));
	    	    	  if (gs2!=null){
	        	    	  smnobl = Number(gs2[0]);    	    		  
	    	    	  }
    	    	  }
	    		  var gs = getSnap("select sum(a.Fsum) as Fsum from ^svzp"+__year+" a  where a.Ftabn_id="+sqlTo(pFtabn_id)+" and a.Fvp="+sqlTo(pFvp)+" and a.Fmn="+sqlTo(pFmn)+" and a.Flsfid="+sqlTo(gsn[2]));
	    		  if (gs!=null){
	    			  if (Number(gs[0])!=0){
	    				  m.Fwid = GetUID();
	    				  m.Fwid_wp =  pFwid_wp;
	    				  m.Ftabn = pFtabn_id;
	    				  m.Fsum = Number(gs[0])-smnobl;
	    				  if (fis_regvip == true){
	    					  m.Fsumn = Number(gs[0])-smnobl;
	    				  }else{
	    					  m.Fsumn = 0;
	    				  }
	    				  m.Fsumnal = 0;
	    				  m.Fsumnaln = 0
	    				  m.Fvidnach = Number(gsn[0]);
	    				  m.Fbdat = datbeg;
	    				  m.Fedat = datend;
	    				  m.FMN   = pFmn;
	    				  m.FVP   = pFvp;
	    				  m.Fvid_prk = vidprk;
	    				  m.Fsumobl  = pFday;
	    				  m.Fisnob   = 0;	         			   
	    				  UpdateTable("TPRK8DR", m, true);
	    			  }
    	    		  //мат.помощь необлагаемая
	    			  if (smnobl!=0){
	    				  m.Fwid = GetUID();
	    				  m.Fwid_wp =  pFwid_wp;
	    				  m.Ftabn = pFtabn_id;
	    				  m.Fsum = smnobl;
	    				  if (fis_regvip == true){
	    					  m.Fsumn = smnobl;
	    				  }else{
	    					  m.Fsumn = 0;
	    				  }
	    				  m.Fsumnal = 0;
	    				  m.Fsumnaln = 0
	    				  m.Fvidnach = Number(gsn2[0]);
	    				  m.Fbdat = datbeg;
	    				  m.Fedat = datend;
	    				  m.FMN   = pFmn;
	    				  m.FVP   = pFvp;
	    				  m.Fvid_prk = vidprk;
	    				  m.Fsumobl  = pFday;
	    				  m.Fisnob   = 1;	         			   
	    				  UpdateTable("TPRK8DR", m, true);
	    			  }	  
	    		  }
    	   }
    	   //прописываем подоходный налог в минимальный код вида начислений
		if (nalog1!=0)
		{
	        strSQL = "select * from TPRK8DR where Ftabn="+sqlTo(pFtabn_id)+" and FMN="+sqlTo(pFmn)+" and FVP="+sqlTo(pFvp)+" and Fsumobl="+sqlTo(pFday)+" order by Fvidnach";
    	    var ttt  = OpenTable("s",strSQL);
        	if (!ttt.IsEmpty()){
        		var vrfwid = ttt.getValue("Fwid") 
				var m = new Object();
            	if (fis_udn){				
					m.Fsumnal = Number(ttt.getValue("Fsumnal"))+nalog1;
				}	
				if (fis_regvip == true)
					m.Fsumnaln = Number(ttt.getValue("Fsumnaln"))+nalog1;
			    UpdateTable("TPRK8DR", m, false, "Fwid="+sqlTo(vrfwid));        	 	
			}
			else
			{ 
				//alert("Не найдена запись дохода для сотрудника с ТN "+pFtabn);
				var m = new Object();
				m.Fwid = GetUID();
				m.Fwid_wp = pFwid_wp;     
				m.Ftabn = pFtabn_id;
				m.Fsum = 0;
				m.Fsumn = 0;
            	if (fis_udn){				
					m.Fsumnal = nalog1;
				}	
				if (fis_regvip == true)
					m.Fsumnaln = nalog1;
				m.Fvidnach = vid_zp;
				m.Fbdat = datbeg;
				m.Fedat = datend;
				m.Fmn = pFmn;
				m.Fvp = pFvp;
				m.Fvid_prk = vidprk;
  			    m.Fisnob   = 0;				
				UpdateTable("TPRK8DR", m, true);
			}
        	ttt.close();
		}
		else
		{
			//прописываем коды льгот
          if (pFvp==0){
        	  var fis_0 = false;
        	  for (var iii=0; iii<=nm; iii++)
        	  { 
        		  if ((ssum[iii]+ssum_pg[iii]+ssum_strn[iii]+ssum_obn[iii])!=0 && ssumn[iii]==0){     
        			  fis_0 = true;
        		  }
        	  }  

        	  if (fis_0 == true){
        		  var is_plg = false;
        		  for (var iii=0; iii<=nm; iii++)
        		  { 
        			  if ((ssum[iii]+ssum_pg[iii]+ssum_strn[iii]+ssum_obn[iii])>minnal){     
        				  is_plg = true;
        			  }
        		  }  
        		  if (is_plg == true){
        			  ozn_pilg = 0;
        		  }else{
        			  ozn_pilg = 1;
        			  Podn_table = getSnap("SELECT Fproc FROM ^PRK_ALL WHERE Fvid_prk = " + sqlTo(VVPRK)
							+ " AND Fin_table='PRK_PODN' AND Ftabn_id="+sqlTo(pFtabn_id)
							+ " AND ((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") " 
							+ " OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
							+ " OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))")
					  if(Podn_table!=null)
						  prk_proc = toScrObj(Podn_table[0])
					  else
						prk_proc = 0
					  if (prk_proc==150) 
						ozn_pilg = 2;
        			  if (prk_proc==200) 
						ozn_pilg = 3;
						// если 2 и больше детей
        			  Det_table = getSnap("SELECT Fproc FROM ^PRK_ALL WHERE Fvid_prk = " + sqlTo(VVPRKDET)
							+ " AND Fproc > 1"
							+ " AND Fin_table='PRK_DET' AND Ftabn_id="+sqlTo(pFtabn_id)
							+ " AND ((FBDAT <= " + sqlTo(D1) + " AND FEDAT >= " + sqlTo(D2) +") " 
							+ " OR (FBDAT >= " + sqlTo(D1) + " AND FBDAT <= " + sqlTo(D2) +") " 
							+ " OR (FEDAT >= " + sqlTo(D1) + " AND FEDAT <= " + sqlTo(D2) +"))")

					  if(Det_table!=null)
						  ozn_pilg = 4;
                 }
              }
          } 
        }  

		
		if (ozn_pilg!=0)
		{  
			strSQL = "select Fwid from TPRK8DR where Ftabn="+sqlTo(pFtabn_id)+" and FMN="+sqlTo(pFmn)+" and FVP="+sqlTo(pFvp);
			var oSnap = getSnap(strSQL);
			if(oSnap!=null)
			{
				ExecuteSQL("update TPRK8DR set Fsumobl="+sqlTo(ozn_pilg)+" where Ftabn="+sqlTo(pFtabn_id)
					+"and FMN="+sqlTo(pFmn)+" and FVP="+sqlTo(pFvp));
			} 
			else
			{
				/*
				//alert("Не найдена запись дохода для сотрудника с ТN "+pFtabn);
				var m = new Object();
				m.Fwid = GetUID();
				m.Fwid_wp = pFwid_wp;           
				m.Ftabn = pFtabn_id;
				m.Fsumobl = ozn_pilg;
				m.Fsum = 0;             
				m.Fsumnal = 0;
				m.Fsumn = 0;
				m.Fsumnaln = 0;
				m.Fvidnach = 0;
				m.Fbdat = datbeg;
				m.Fedat = datend;
				m.Fmn = pFmn;
				m.Fvp = pFvp;
				m.Fvid_prk = vidprk;             
				UpdateTable("TPRK8DR", m, true);
				*/
			}
		}
		//прописываем начисления ЕСВ
	    if (fis_r27!=1){
	        if (ssum27!=0)
	        {    
	        	var m = new Object();
				m.Fwid = GetUID();
				m.Fwid_wp =  pFwid_wp;
				m.Ftabn = pFtabn_id;
	         	m.Fsum  = ssum27;
	         	if (fis_regvip == true){
	            		m.Fsumn = ssum27;
	         	}else{            
	            		m.Fsumn = 0;
	         	}
	         	m.Fsumnal = 0;
	         	m.Fsumnaln = 0;
	         	m.Fvidnach = 133;
	         	m.Fbdat = datbeg;
	         	m.Fedat = datend;
	         	m.FMN = pFmn;
	         	m.FVP = pFvp;
	         	m.Fvid_prk = vidprk;  
	         	m.Fsumobl = 0;           
  			   	m.Fisnob   = 1;	         	
			   	UpdateTable("TPRK8DR", m, true);            
	        }
	    }
		
	}//while(!SVZP_table.IsEOF())

	if (!fis_vipl)
    {
		strSQL = "UPDATE TPRK8DR set Fsum=0";
		ExecuteSQL(strSQL);
	}
	//********************************
	  //*********************
	//Разбивка подоходного налога между видами начислений.
	  //бьем только начисленную сумму. Перечисленную не трогаем
	  //создать временную талицу
	  DropTable("TMPDF")
	  strSQL = "create table TMPDF ("+
	           " Ftabn_id  "+SqlType("LONG")+",Fmn  "+SqlType("DATE")+", Fvp "+SqlType("BYTE")+", OZN_PILG "+SqlType("BYTE")+
	           ", FSUM "+SqlType("CURRENCY")+", Fvidnach "+SqlType("BYTE")+", Fvidnachin "+SqlType("LONG")+", FSUM15 "+SqlType("CURRENCY")+", FSUM17 "+SqlType("CURRENCY")+
	           ", Fsumnaln "+SqlType("CURRENCY")+", FNAL15 "+SqlType("CURRENCY")+
	           ", FNAL17 "+SqlType("CURRENCY")+", FNALR "+SqlType("CURRENCY")+", FWID "+SqlType("COUNTER")+")";
	  ExecuteSQL(strSQL);
	  //добавляем записи без необлагаемых частей страховки, погребения, обучения, матпомощи
	  //strSQL = "INSERT INTO TMPDF (Ftabn_id,Fmn,Fvp,Fsum,Fsumnaln,Fvidnach) select Ftabn,Fmn,Fvp,Fsum,Fsumnaln,Fvidnach from TPRK8DR where Fvidnach<>133 "
	  strSQL = "INSERT INTO TMPDF (Ftabn_id,Fmn,Fvp,Fsum,Fsumnaln,Fvidnach) select Ftabn,Fmn,Fvp,Fsum,Fsumnaln,Fvidnach from TPRK8DR where Fisnob<>1 "	  
	  ExecuteSQL(strSQL);
	  
	  //сделать упорядочение полей по кодам начислений или по порядку, который прописан в колонке Fis34 в LIC_FLD.
	  tdfnn = OpenTable("s","select * from TMPDF")	  
	  if (!tdfnn.IsEmpty()){
	     tdfnn.MoveFirst();
	     while (!tdfnn.IsEOF()){
	    	 var gs = getSnap("select MAX(Fis34) as Fis34 from ^LIC_FLD where Fis31="+sqlTo(tdfnn.getValue("Fvidnach"))+" and not Fis34 is null and Fis34<>0")
	    	 if (gs!=null){
	    		 ExecuteSQL("update TMPDF set Fvidnachin=Fvidnach+"+sqlTo(Number(gs[0])*1000)+" where Fwid="+sqlTo(tdfnn.getValue("Fwid")))
	    	 }else{
	    		 ExecuteSQL("update TMPDF set Fvidnachin=Fvidnach where Fwid="+sqlTo(tdfnn.getValue("Fwid")))	    		 
	    	 }
		     tdfnn.MoveNext();	    	 
	     }
	  }   
	  tdfnn.close();
	  
	  //таблица для суммы льготы по каждому человеку
	  DropTable("TMPDFN")
	  strSQL = "create table TMPDFN ( Ftabn_id  "+SqlType("LONG")+",Fmn  "+SqlType("DATE")+", Fvp "+SqlType("BYTE")+",FSUM_LG "+SqlType("CURRENCY")+",FISLG "+SqlType("BYTE")+", FWID "+SqlType("COUNTER")+")";
	  ExecuteSQL(strSQL);

	  var sumgr = get_cnst("minimum", D1)*10
	  var soc_lgot = get_cnst("soclgot", D1)
	  izmlg = get_cnst ("izmlg" , D1)
	  // изменениe льгты на буд. периоды
	  izmnx = get_cnst ("izmnx" , D1)

	  //найти сумму льготы и прописать ее в отдельной таблице
	 //tdfnn = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fday<>0 order by Ftabn_id,Fmn,Fvp")
	  tdfnn = OpenTable("s","select distinct Ftabn_id, Fmn, Fvp from "+TMPSVZP+" WHERE Fis_day=2 and Fday<>0 order by Ftabn_id,Fmn,Fvp")	  
	  if (!tdfnn.IsEmpty()){
	     tdfnn.MoveFirst();
	     pFtabn = Number(tdfnn.getValue("Ftabn_id"))
	     pFmn   = new Date(tdfnn.getValue("Fmn"))
	     pFvp   = Number(tdfnn.getValue("Fvp"))
		 //Если льгота дается в месяце расчета то тогда tdfnn("Fmn") = d00 т условие не отработало
		 if(pFvp == 0)
		 {
			pFmnb  = new Date(firstDayMonth(datbeg))
			pFmne  = new Date(lastDayMonth(datbeg))
		 }
		 else
		 {
			 pFmnb  = new Date(firstDayMonth(pFmn))
			 pFmne  = new Date(lastDayMonth(pFmn))
		}
	     while (!tdfnn.IsEOF() && Number(tdfnn.getValue("Ftabn_id"))==pFtabn && differ(new Date(tdfnn.getValue("Fmn")),pFmn)==0 && Number(tdfnn.getValue("Fvp"))==pFvp){
	        //найти сумму соцльготы
	        Ful_mes = true;
	    	  
	        Shtat_table = OpenTable("s","SELECT * FROM ^WORK_PERS WHERE Fwid_cl="+sqlTo(pFtabn)+" and Fnazn="+sqlTrue+" and "
	                      + "((FBDAT <= " + sqlTo(pFmnb) + " AND FEDAT >= " + sqlTo(pFmne) +") " 
	                      + "OR (FBDAT >= " + sqlTo(pFmnb) + " AND FBDAT <= " + sqlTo(pFmne) +") " 
	                      + "OR (FEDAT >= " + sqlTo(pFmnb) + " AND FEDAT <= " + sqlTo(pFmne) +"))")
	   	  	
	   	    if (!Shtat_table.isEOF()){
	   	    	Shtat_table.MoveFirst();
	   	    	while (!Shtat_table.isEOF()){
	   	    		if ((differ(new Date(Shtat_table.getValue("Fedat")),d00)!=0 && new Date(Shtat_table.getValue("Fedat")).getMonth()==pFmnb.getMonth()) && toScrObj(Shtat_table.getValue("Fnazn"))==true)
	   	    			Ful_mes =  false  //налог не по полному месяцу

	   	    		if ((new Date(Shtat_table.getValue("Fbdat")).getDate()!=1 && new Date(Shtat_table.getValue("Fbdat")).getMonth()==pFmnb.getMonth()) && toScrObj(Shtat_table.getValue("Fnazn"))==true)
	   	    			Ful_mes =  false  //налог не по полному месяцу
	   	  		
	   	    		Shtat_table.MoveNext();
	   	    	}	
	   	    }		
	        Shtat_table.close()
	        
	        fis_prik = false;
	        gS = getSnap("select Fproc from ^PRK_ALL "
      			   + " WHERE Fin_table='PRK_PODN' AND Fvid_prk = " + sqlTo(VVPRK ) + " AND Ftabn_id=" + pFtabn
                   + " AND FBDAT <= " + sqlTo(pFmne) + " AND FEDAT >= " + sqlTo(pFmnb));
	        if (gS !=  null)
	        {
	        	fis_prik = true;
	        	prk_proc = Number(gS[0]);         
	        }
	        else
	        {
	        	prk_proc = 0
	        }

	        if (!Ful_mes)
	        { 
	        	fis_prik = true;
	        	prk_proc = 0
	        }  

	        gS = getSnap("select Fproc,Fsum,Fnom_prik from ^PRK_ALL "
	      			   + " WHERE Fin_table="+sqlTo("PRK_DET")+" and ftabn_id=" + pFtabn
	                   + " AND FBDAT <= " + sqlTo(pFmne) + " AND FEDAT >= " + sqlTo(pFmnb));
	        if (gS != null){
	        	prk_det  = Number(gS[0]);
	        	prk_indet  = Number(gS[1]);
	        	kol_indet  = Number(gS[2]);	        	
	        }else{
	        	prk_det = 0
	        	prk_indet  = 0;
	        	kol_indet  = 0;	        	
	        }	

	        if (prk_proc==0 && fis_prik==false){
	               l_xxx = soc_lgot
	        }else{
	               if (prk_det==0){
	                  l_xxx = soc_lgot*prk_proc/100                  
	               }else{   
	                  if (izmlg==1){
	                     l_xxx = soc_lgot*prk_proc/100*prk_det
	                  }else{
		                  if (izmlg==2){	                	  
			                 l_xxx = soc_lgot*prk_proc/100*prk_det+soc_lgot*prk_indet/100*kol_indet
		                  }else{ 
		                	  l_xxx = soc_lgot*prk_proc/100*prk_det+soc_lgot
		                  }	  
	                  }
	               }   
	        }

	        //будущие периоды 
	        if (izmnx==1 && differ(new Date(tdfnn.getValue("Fmn")),pFmnb)>0 && Number(tdfnn.getValue("Fvp"))==2){
	               l_xxx = 0
	        }

	        m = new Object();
	        m.Ftabn_id = pFtabn;
	        m.Fmn = pFmn;
	        m.Fvp=pFvp;
	        m.Fsum_lg = l_xxx;
	        m.Fislg = 0;
		   	UpdateTable("TMPDFN", m, true);	        

	        tdfnn.MoveNext();
	        if (!tdfnn.IsEOF()){
	   	     	pFtabn = Number(tdfnn.getValue("Ftabn_id"))
	   	     	pFmn   = new Date(tdfnn.getValue("Fmn"))
	   	     	pFvp   = Number(tdfnn.getValue("Fvp"))
	   	     	if(pFvp == 0)
	   	     	{
	   	     		pFmnb  = new Date(firstDayMonth(datbeg))
	   	     		pFmne  = new Date(lastDayMonth(datbeg))
	   	     	}
	   	     	else
	   	     	{
	   	     		pFmnb  = new Date(firstDayMonth(pFmn))
	   	     		pFmne  = new Date(lastDayMonth(pFmn))
	   	     	}
	        }else{
	        	break;
	        }   
	     }
	  }
	  tdfnn.close();


	  //распеделяем суммы с учетом границы.
	  var tdfn = OpenTable("s", "select * from TMPDF order by Ftabn_id,Fmn,Fvp,Fvidnachin")
	  if (!tdfn.IsEmpty()){
	     tdfn.MoveFirst();
	     while (!tdfn.IsEOF()){
		     pFtabn = Number(tdfn.getValue("Ftabn_id"))
		     pFmn   = new Date(tdfn.getValue("Fmn"))
		     pFvp   = Number(tdfn.getValue("Fvp"))
		     tsumgr   = sumgr
		     while (!tdfn.IsEOF() && Number(tdfn.getValue("Ftabn_id"))==pFtabn && differ(new Date(tdfn.getValue("Fmn")),pFmn)==0 && Number(tdfn.getValue("Fvp"))==pFvp){
	            fis_min = false;  
	            //будущие суммы с минусом
	            //для них соцльготы не бывает
	            if (Number(tdfn.getValue("Fvp"))==1 && differ(new Date(tdfn.getValue("Fmn")),D1)<0){
	               fis_min = true;  
	            }else{
	               //найти сумму соцльготы
	            	//отнять ее нужно один раз. Поэтому прописываем признак Fislg=1 после первого захода.
	               var l_xxx = 0;
	               var gs = getSnap("select Fwid, Fsum_lg from TMPDFN where Ftabn_id="+sqlTo(pFtabn)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp)+" and Fislg=0");
	               if (gs!=null){
	            	  l_xxx = Number(gs[1]);
	            	  ExecuteSQL("update TMPDFN set Fislg=1 where Fwid="+sqlTo(gs[0]))
	               }
	            } 
	            //проверяем код вида начислений на признак, нужно ли на него делать распределение. 
	            //Если код для необлагаемых сумм (например, код 128 - пособие по беременности и родам и т.д)
	            //то на него распределение делать не нужно.
	            var fis_raspr = true;
                var gst = getSnap("select Fis32 from ^LIC_FLD where Fis31="+sqlTo(Number(tdfn.getValue("Fvidnach"))))
                if (gst!=null){
                	if (gst[0]=='-'){
                		fis_raspr = false;
                	}	
                }
	            var snalog = 0; 
	            var gs = getSnap("select Fsumnaln from TPRK8DR where Fsumnaln<>0 and Ftabn="+sqlTo(pFtabn)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp));
	            if (gs!=null){	            
	               snalog = Number(gs[0]); 
	            }
	            
	            //разбить базы для разбиения подоходного налога
	            //берем самый маленький код начисления. Если он не 101 и есть льгота, отнимаем ее от первого попавшегося.
	            //разбиваем суммы на базы начисления 15 и 17 %
			    pFwid  = tdfn.getValue("Fwid")
	            if (fis_raspr == true){			    
	            	if (!fis_min){
	            		base1 = Number(tdfn.getValue("Fsum"))-l_xxx
	            		if (base1<tsumgr){
	            			ExecuteSQL("update TMPDF set Fsum15="+sqlTo(base1)+",Fsum17=0 where Fwid="+sqlTo(pFwid))	            	   
	            			tsumgr = tsumgr-base1
	            		}else{
	            			ExecuteSQL("update TMPDF set Fsum15="+sqlTo(tsumgr)+",Fsum17="+sqlTo(base1-tsumgr)+" where Fwid="+sqlTo(pFwid))	            	   
	            			tsumgr = 0;
	            		} 
	            	}else{
	            		base1 = -Number(tdfn.getValue("Fsum"))
	            		if (base1<tsumgr){
	            			ExecuteSQL("update TMPDF set Fsum15="+sqlTo(-base1)+",Fsum17=0 where Fwid="+sqlTo(pFwid))	            	   
	            			tsumgr = tsumgr-base1
	            		}else{
	            			ExecuteSQL("update TMPDF set Fsum15="+sqlTo(-tsumgr)+",Fsum17="+sqlTo(-(base1-tsumgr))+" where Fwid="+sqlTo(pFwid))	            	   
	            			tsumgr = 0;
	            		}
	            	}
	            }	
			    //прописываем общую сумму налога для каждого кода начислений
	            ExecuteSQL("update TMPDF set Fsumnaln="+sqlTo(snalog)+" where Fwid="+sqlTo(pFwid))

	            tdfn.MoveNext();
	         } 
	     } 
	  } 
	  tdfn.close();

	  //разбиваем налог. Идем только по начислениям
	  ExecuteSQL("update TMPDF set Fnal15="+sqlRound("Fsum15*0.15",2)+", Fnal17="+sqlRound("Fsum17*0.17",2))
	  
	  //находим разницы и сбрасываем их на миниамльный код в порядке распределения.
	  DropTable("T1")
	  strSQL = "select sum(a.Fnal15) as Fnal15, sum(a.Fnal17) as Fnal17, a.Ftabn_id, a.Fmn,a.Fvp into T1 from TMPDF a group by a.Ftabn_id,a.Fmn,a.Fvp"
	  ExecuteSQL(strSQL);

	  var tt = OpenTable("s", "select * from T1 order by Ftabn_id,Fmn,Fvp")        
	  if (!tt.IsEmpty()){
	     while (!tt.IsEOF()){
	        snalo = Number(tt.getValue("Fnal15"))+Number(tt.getValue("Fnal17"))
	        var gs = getSnap("select Fsumnaln from TPRK8DR where Fsumnaln<>0 and  Ftabn="+sqlTo(Number(tt.getValue("Ftabn_id")))+" and Fmn="+sqlTo(new Date(tt.getValue("Fmn")))+" and Fvp="+sqlTo(Number(tt.getValue("Fvp"))))
	        snal = 0
	        if (gs!=null){
	           snal = Number(gs[0])
	        }

	        if (snalo!=snal){
	           var gs = getSnap("select MIN(Fvidnachin) as Fvidnach from TMPDF where Ftabn_id="+sqlTo(Number(tt.getValue("Ftabn_id")))+" and Fmn="+sqlTo(new Date(tt.getValue("Fmn")))+" and Fvp="+sqlTo(Number(tt.getValue("Fvp"))))
	           if (gs!=null){
	        	   var gs2 = getSnap("select Fwid from TMPDF where Ftabn_id="+sqlTo(Number(tt.getValue("Ftabn_id")))+" and Fmn="+sqlTo(new Date(tt.getValue("Fmn")))+" and Fvp="+sqlTo(Number(tt.getValue("Fvp")))+" and Fvidnachin="+sqlTo(Number(gs[0])))
	        	   if (gs2!=null){
	        			  ExecuteSQL("update TMPDF set Fnalr="+sqlTo(snal-snalo)+" where Fwid="+sqlTo(gs2[0]))	        		   
	        	   }
	           }   
	        }
	        tt.MoveNext();  
	     }
	  } 
	  tt.close();

	  ExecuteSQL("update TMPDF set Fnalr=0 where Fnalr is null");
	  ExecuteSQL("update TMPDF set Fnal15=0 where Fnal15 is null");
	  ExecuteSQL("update TMPDF set Fnal17=0 where Fnal17 is null");	  
	  
	  //var tt = OpenTable("s", "select * from TPRK8DR where Fvidnach<>133 order by Ftabn,Fmn,Fvp,Fvidnach ")
	  //из временной таблицы распределения TMPDF переносим суммы ПН по кодам начислений в таблицу закачки
	  //1ДФ из ЛС TPRK8DR
	  var tt = OpenTable("s", "select * from TPRK8DR where Fisnob<>1 order by Ftabn,Fmn,Fvp,Fvidnach ")	  
	  if (!tt.IsEmpty()){
	     while (!tt.IsEOF()){
	    	 var xFwid = tt.getValue("Fwid")
	    	 var gss = getSnap("select Fnal15,Fnal17,Fnalr from TMPDF where Ftabn_id="+sqlTo(Number(tt.getValue("Ftabn")))+" and Fmn="+sqlTo(new Date(tt.getValue("Fmn")))+" and Fvp="+sqlTo(Number(tt.getValue("Fvp")))+" and Fvidnach="+sqlTo(Number(tt.getValue("Fvidnach"))))
	    	 if (gss!=null){
                 if (fis_udn){
   			  		ExecuteSQL("update TPRK8DR set Fsumnal="+sqlTo(Number(gss[0])+Number(gss[1])+Number(gss[2]))+" where Fwid="+sqlTo(xFwid))
                 }		
  	           	 if (fis_regvip == true){
    			  		ExecuteSQL("update TPRK8DR set Fsumnaln="+sqlTo(Number(gss[0])+Number(gss[1])+Number(gss[2]))+" where Fwid="+sqlTo(xFwid))  	           		 
  	           	 }	 
	    	 }
	    	 tt.MoveNext();  
	     }
	  } 
	  tt.close();
	  //*******************************

	  //найти льготы по детям и проверить, нет ли по ним дополнительных льгот. Если есть,добавить в tprk8dr дополнительную запись
	 //tdfnn = OpenTable("s","select * from "+TMPSVZP+" WHERE Fis_day=2 and Fday<>0 order by Ftabn_id,Fmn,Fvp")
	  tdfnn = OpenTable("s","select distinct Ftabn,Fmn,Fvp from TPRK8DR where Fsumobl=4")	  
	  if (!tdfnn.IsEmpty()){
		     tdfnn.MoveFirst();
		     pFtabn = Number(tdfnn.getValue("Ftabn"))
		     pFmn   = new Date(tdfnn.getValue("Fmn"))
		     pFvp   = Number(tdfnn.getValue("Fvp"))
			 if(pFvp == 0)
			 {
				pFmnb  = new Date(firstDayMonth(datbeg))
				pFmne  = new Date(lastDayMonth(datbeg))
			 }
			 else
			 {
				 pFmnb  = new Date(firstDayMonth(pFmn))
				 pFmne  = new Date(lastDayMonth(pFmn))
			}
		     while (!tdfnn.IsEOF() && Number(tdfnn.getValue("Ftabn"))==pFtabn  && differ(new Date(tdfnn.getValue("Fmn")),pFmn)==0 && Number(tdfnn.getValue("Fvp"))==pFvp){
		        gS = getSnap("select Fproc,Fsum,Fnom_prik from ^PRK_ALL "
		      			   + " WHERE Fin_table="+sqlTo("PRK_DET")+" and ftabn_id=" + pFtabn
		                   + " AND FBDAT <= " + sqlTo(pFmne) + " AND FEDAT >= " + sqlTo(pFmnb));
		        if (gS != null){
		        	prk_det  = Number(gS[0]);
		        	prk_indet  = Number(gS[1]);
		        	kol_indet  = Number(gS[2]);	        	
		        }else{
		        	prk_det = 0
		        	prk_indet  = 0;
		        	kol_indet  = 0;	        	
		        }	
				if (kol_indet!=0 && prk_det>kol_indet){
					var m = new Object();
					m.Fwid = GetUID();
					var gf = getSnap("select max(Fwid_wp) as Fwid_wp from TPRK8DR where Ftabn="+sqlTo(pFtabn)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp)+" and Fsumobl=4")
					if (gf!=null){
						m.Fwid_wp = gf[0];
					}else{
						alert("ошибка при поиске доп.льготы для ID="+sqlTo(pFtabn))
					}	     
					
					m.Ftabn = pFtabn;
					m.Fsum = 0;
					m.Fsumn = 0;
					m.Fsumnal = 0;
					m.Fsumnaln = 0;
					m.Fvidnach = 0;
					m.Fbdat = datbeg;
					m.Fedat = datend;
					m.Fmn = pFmn;
					m.Fvp = pFvp;
					m.Fvid_prk = vidprk;
  			    	m.Fisnob   = 0;
  			    	m.Fsumobl   = 2;  			    					
					UpdateTable("TPRK8DR", m, true);
		        }
		        tdfnn.MoveNext();
		        if (!tdfnn.IsEOF()){
		   	     	pFtabn = Number(tdfnn.getValue("Ftabn"))
		   	     	pFmn   = new Date(tdfnn.getValue("Fmn"))
		   	     	pFvp   = Number(tdfnn.getValue("Fvp"))
		   	     	if(pFvp == 0)
		   	     	{
		   	     		pFmnb  = new Date(firstDayMonth(datbeg))
		   	     		pFmne  = new Date(lastDayMonth(datbeg))
		   	     	}
		   	     	else
		   	     	{
		   	     		pFmnb  = new Date(firstDayMonth(pFmn))
		   	     		pFmne  = new Date(lastDayMonth(pFmn))
		   	     	}
		        }else{
		        	break;
		        }   
		     }
	  }
	  tdfnn.close();
	  
	  
	//********************************
	//переносим результаты в приказ на 1ДФ.
	var tprk = OpenTable("TPRK8DR");
	if(tprk.IsEmpty())
		return false;
	var oPrik = new DpPrik("_DF1", vidprk);
	for(tprk.MoveFirst();!tprk.IsEOF();tprk.MoveNext())
	{
		if(tprk.getValue("Fsum")==0 && tprk.getValue("Fsumnal")==0 && tprk.getValue("Fsumn")==0 && tprk.getValue("Fsumnaln")==0 && tprk.getValue("Fsumobl")==0)
			continue;
		oPrik.clear();
		oPrik.setVar("FWID", GetUID());
		oPrik.setVar("FTABN_ID" , tprk.getValue("Ftabn"));
		oPrik.setVar("FWID_WP", tprk.getValue("Fwid_wp"));
		oPrik.setVar("FSUMOBL", tprk.getValue("Fsumobl"));
		oPrik.setVar("FSUM", round(tprk.getValue("Fsum"),2));
		oPrik.setVar("FSUMNAL", round(tprk.getValue("Fsumnal"),2));
		oPrik.setVar("FSUMN", round(tprk.getValue("Fsumn"),2));
		oPrik.setVar("FSUMNALN", round(tprk.getValue("Fsumnaln"),2));
		oPrik.setVar("FVIDNACH", tprk.getValue("Fvidnach"));
		oPrik.setVar("FBDAT", tprk.getValue("Fbdat"));
		oPrik.setVar("FEDAT", tprk.getValue("Fedat"));
		oPrik.setVar("FMN", tprk.getValue("Fmn"));
		oPrik.setVar("FVP", tprk.getValue("Fvp"));
		oPrik.setVar("FVID_PRK", tprk.getValue("Fvid_prk"));
		oPrik.setVar("FIN_TABLE", 'PRK8DR');
		oPrik.save();
	}
	tprk.close();
	//strSQL = "INSERT INTO ^PRK_ALL "+ getColumn("TPRK8DR",true) +
	//		" select " + getColumn("TPRK8DR",false) + " from TPRK8DR";
	//ExecuteSQL(strSQL);
	SVZP_table.close();
	DropTable(TMPSVZP);
	return;
}