//расчет по таб.N за год
include("sys\\DpSql.js");
include("sys\\udfs.js");
include("get_cnst.js");

var mode;
var tblOut = "SVZPALLM3";
var sTitle = "Суми по таб.N";
var mFtabn_id = 0;  
var mdat1  = d00obj;
var mdat2  = d00obj;
var mdolgn = "";
var moklad = 0;
var mFio;
var mCod;
var mPrin;
listPrnForm = "svzpall";

function listLoad()
{
   	this.title = sTitle;

   	if (extPar.mode=="CALC")
   	{
      	r_svzpall();
   	}   	

	if (!IsTable(tblOut))
	{
  		alert(ru("Сначала произведите расчет","Спочатку виконайте розрахунок"));
  		return false;
	}
}

function listSrc()
{
	this.qrySet("From", tblOut, "Order", "Ffld_num,Ftt");
	this.subTie("LIC_FLD", "lic", "FID", "Flsfid");
}

function listDpGrid()
{
	include("objects/DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
   	
   	oGrid.defCond("=^Ftt==0", "FTT0");
   	oGrid.defCond("=^Ftt==1", "FTT1");
   	oGrid.defCond("=^Ftt==2", "FTT2");
   	oGrid.defCond("=^Ftt==3", "FTT3");
	oGrid.color(0, "FTT0");
	oGrid.color(1, "FTT1");
	oGrid.color(1, "FTT2");
	oGrid.color(1, "FTT3");
      
	gr.FieldEx("Flsfid","",5);
	gr.FieldEx("lic.FTxt", "Поле особист.рахунк|Поле лицевого счета", 20);  
	gr.FieldEx("Fsum1","Мiсяць 1|Месяц 1",7,"e","%5.2f");
	gr.FieldEx("Fmn1","За|За",3,"e");
	gr.FieldEx("Fsum2","Мiсяць 2|Месяц 2",7,"e","%5.2f");
	gr.FieldEx("Fmn2","За|За",3,"e");
	gr.FieldEx("Fsum3","Мiсяць 3|Месяц 3",7,"e","%5.2f");
	gr.FieldEx("Fmn3","За|За",3,"e");
	gr.FieldEx("Fsum4","Мiсяць 4|Месяц 4",7,"e","%5.2f");
	gr.FieldEx("Fmn4","За|За",3,"e");
	gr.FieldEx("Fsum5","Мiсяць 5|Месяц 5",7,"e","%5.2f");
	gr.FieldEx("Fmn5","За|За",3,"e");
	gr.FieldEx("Fsum6","Мiсяць 6|Месяц 6",7,"e","%5.2f");
	gr.FieldEx("Fmn6","За|За",3,"e");
	gr.FieldEx("Fsum7","Мiсяць 7|Месяц 7",7,"e","%5.2f");
	gr.FieldEx("Fmn7","За|За",3,"e");
	gr.FieldEx("Fsum8","Мiсяць 8|Месяц 8",7,"e","%5.2f");
	gr.FieldEx("Fmn8","За|За",3,"e");
	gr.FieldEx("Fsum9","Мiсяць 9|Месяц 9",7,"e","%5.2f");
	gr.FieldEx("Fmn9","За|За",3,"e");
	gr.FieldEx("Fsum10","Мiсяць 10|Месяц 10",7,"e","%5.2f");
	gr.FieldEx("Fmn10","За|За",3,"e");
	gr.FieldEx("Fsum11","Мiсяць 11|Месяц 11",7,"e","%5.2f");
	gr.FieldEx("Fmn11","За|За",3,"e");
	gr.FieldEx("Fsum12","Мiсяць 12|Месяц 12",7,"e","%5.2f");
	gr.FieldEx("Fmn12","За|За",3,"e");
	gr.FieldEx("Fsum14","Разом|Итого",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
   	
   	oGrid.build();   
}


function listMenuInit(ds)
{
	ds = DataSource();
	if (list.tbl.recordCount>0)
	{
		ds.AddMenuItem("PRINT","Друк |Печать ",9);
	}
}

function listMenuRun(ID)
{
	var par = new Object();
	switch(ID)
	{
  	case "PRINT":
      	include("objects\\DpTVars.js");
        var tv = new DpTVars(listPrnForm);
        var bm = list.tbl.bookmark;
        var h = new Object();
        h.FNAM_LEV  = extPar.fio;	//ФИО
        h.FOKLAD    = extPar.oklad;	//оклад
        h.FNAM_LEVS = extPar.dolname;	//должность
        h.FCOD      = tcl('HOMO','INDNUM',getPar('CODPERS'),Number(extPar.tabn));
        h.FPRIN     = tcl('HOMO','WRKDAT',getPar('CODPERS'),Number(extPar.tabn));
        tv.setHTbl(h);
        tv.setRTbl(list.tbl);
      	tv.print();
        list.tbl.bookmark = bm;

    	break;
	}
}

function r_svzpall()
{
	var mFtabn_id = 0;
	var form = createForm(ru("Введите табельный номер сотрудника ","Введіть табельний номер спiвробiника "));
	pers = form.addCodPers(false,true);
	if(extPar.tabn>0)
		pers.setCod(extPar.tabn);
	form.show()
	if(form.escape)
		return false;
	tabn = pers.getCod();
	oSnap = getSnap("SELECT Fwid_cl FROM ^clrelclcl WHERE Fcod="+tabn+" AND Fcl="+getPar("CODPERS"));
	if(oSnap!=null)
		mFtabn_id = oSnap[0];
	else
	{
		alert(ru("Работника с табельным номером "+tabn+" не существует","Робітника з табельним номером "+tabn+" не існує"));
		return false;
	}

           
	var year = (extPar.year>0?extPar.year:today.getFullYear());
	var p_year = input("Введiть рiк, за який робиться розрахунок", "Розрахунок", year,4,0)
	if(p_year == null)
		return false;

           mdat1 = new Date(p_year,0,1)
           mdat2 = new Date(p_year,11,1)


/*
//как сохранять суммы - сумма+месяц выплаты+месяц возн.
a = 1440000.56*1000000+12*100+11
//(1211)
b = a-Math.floor(a/10000)*10000  

alert(a)
alert((Math.floor(a/10000))/100)
alert((Math.floor(a/10000)))
alert(a-Math.floor(a/10000)*10000)
alert(Math.floor(b/100))                
alert(b-Math.floor(b/100)*100)
alert(round(-0.8799,2)*1000000-12*100-11)
*/

           //mFtabn_id=87;

           okl  = get_cnst("okl",mdat1)
           otpt = get_cnst("otpt",mdat1)
           otpb = get_cnst("otpb",mdat1)

//           okl  = 2
//           otpt = 50
//           otpb = 420
           
           DropTable("SVZPALLM")
           strSQL="CREATE TABLE SVZPALLM (FTABN_ID " + SqlType("INTEGER") 
			  + ",FLSFID " + SqlType("LONG")+ ",FFLD_NUM " + SqlType("LONG")
                          + ",FSUM1 " + SqlType("CURRENCY") + ",FSUM2 " + SqlType("CURRENCY")  
                          + ",FSUM3 " + SqlType("CURRENCY") + ",FSUM4 " + SqlType("CURRENCY")  
                          + ",FSUM5 " + SqlType("CURRENCY") + ",FSUM6 " + SqlType("CURRENCY")  
                          + ",FSUM7 " + SqlType("CURRENCY") + ",FSUM8 " + SqlType("CURRENCY")  
                          + ",FSUM9 " + SqlType("CURRENCY") + ",FSUM10 " + SqlType("CURRENCY")  
                          + ",FSUM11 " + SqlType("CURRENCY") + ",FSUM12 " + SqlType("CURRENCY") + ",FSUM14 " + SqlType("CURRENCY")  
                          + ",FMN " + SqlType("DATE")+ ",FMF " + SqlType("DATE") + ",FVP " + SqlType("BYTE") + ",FTT " + SqlType("BYTE")  
			  +",FWID " + SqlType("COUNTER") + ")"
           ExecuteSQL(strSQL);   

           strSQL="CREATE INDEX SVZPALLM ON SVZPALLM (Flsfid, Ftt)";
           ExecuteSQL(strSQL);
	   

           xyear = mdat1.getVarDate();
		   __year = format("yyyymm", mdat1);
           
           kk = 12;
           var bkv = new Date(xyear);
   
           var i=1; 
           while (i<=kk)
           {
              var xfile = "SVZP"+__year;
              if (IsTableEx("ZRP_RES","zrp_"+xfile))
              {
                 DropTable("TSVZP"+String(i))  
                 DropTable("TSVZPT"+String(i))  
                 DropTable("TSVZPO"+String(i))  
                 DropTable("TSVZPB"+String(i))  

                 strsum1 = "";
                 for (g=i+1;g<=kk;g++){
                    strsum1 = strsum1+", 0 as Fsum"+String(g)
                 }  

                 strsum2 = "";
                 if (i>1){
                    for (h=1;h<=i-1;h++){
                       strsum2 = strsum2+", 0 as Fsum"+String(h)
                    }  
                 }

                 //             суммы по лицевым счетам помесячно
                 //выбираем суммы из лицевых счетов     
                 strSQL = "select FTABN_ID, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 0 as Ftt,"
                      +" sum(^"+xfile+".FSUM) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZP"+String(i)
                      +" FROM ^"+xfile+" "
                      +" WHERE FTABN_ID="+sqlTo(mFtabn_id)+" and not (FVP=1 and FMN>"+sqlTo(bkv)+") group by FTABN_ID, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);

                 // складываем суммы начил.за месяц с суммами пришедшими из буд.периодов прошлых месяцев
                 strSQL = "UPDATE TSVZP"+String(i)+" set Fvp=0, Fmn="+sqlTo(d00obj)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZP"+String(i)+" set Fmn=Fmf where Fvp=0"
                 ExecuteSQL(strSQL);

                 //запоминаем месяц начисления для сумм будущих и прошлых периодов и текущих
                 //strSQL = "UPDATE TSVZP"+String(i)+" set Fsum"+String(i)+"="+sqlRound("Fsum"+String(i),2)+"*1000000+"+SqlMonth("Fmf")+"*100+"+SqlMonth("Fmn")
                 strSQL = "UPDATE TSVZP"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000+"+SqlMonth("Fmf")+"*100+"+SqlMonth("Fmn")+" where Fsum"+String(i)+">=0"
                 ExecuteSQL(strSQL);
                 strSQL = "UPDATE TSVZP"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000-"+SqlMonth("Fmf")+"*100-"+SqlMonth("Fmn")+" where Fsum"+String(i)+"<0"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZP"+String(i)+" set Fmn="+sqlTo(d00obj)+" where Fvp=0"
                 ExecuteSQL(strSQL);

                 strSQL = "insert into SVZPALLM " + getColumn("TSVZP"+String(i),true) 
					+ " select " + getColumn("TSVZP"+String(i),false) + " from TSVZP"+String(i)
                 ExecuteSQL(strSQL);

                 //             время по окладам по лицевым счетам помесячно

                 DropTable("TSVZPV")
                 strSQL = "select FTABN_ID, FLSFID, FCHAS, Fmn, Fvp,"+sqlTo(bkv)+" as FMF "
                          +" into TSVZPV FROM ^"+xfile+" "
                          +" WHERE FTABN_ID="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(okl)
                 ExecuteSQL(strSQL);

                 // меняем знак во времени для буд.сумм из прошлых периодов
                 strSQL = "UPDATE TSVZPV set Fchas=-1*Fchas where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 strSQL = "select FTABN_ID, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 1 as Ftt,"
                      +" sum(FCHAS) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPT"+String(i)
                      +" FROM TSVZPV "
                      +" WHERE FTABN_ID="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(okl)+" group by FTABN_ID, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);

/*
                 strSQL = "select FTABN_ID, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 1 as Ftt,"
                      +" sum(FCHAS) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPT"+String(i)
                      +" FROM ^"+xfile+" "
                      +" WHERE FTABN_ID="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(okl)+" group by Ftabn_id, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);
*/

                 // складываем время за месяц со временем пришедшим из буд.периодов прошлых месяцев
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fvp=0, Fmn="+sqlTo(d00obj)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fmn=Fmf where Fvp=0"
                 ExecuteSQL(strSQL);

                 //запоминаем месяц начисления для времени будущих и прошлых перодов и текущих
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000+"+SqlMonth("Fmf")+"*100+"+SqlMonth("Fmn")+" where Fsum"+String(i)+">=0"
                 ExecuteSQL(strSQL);
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000-"+SqlMonth("Fmf")+"*100-"+SqlMonth("Fmn")+" where Fsum"+String(i)+"<0"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fmn="+sqlTo(d00obj)+" where Fvp=0"
                 ExecuteSQL(strSQL);

                 strSQL = "insert into SVZPALLM " + getColumn("TSVZPT"+String(i),true) 
					+ " select " + getColumn("TSVZPT"+String(i),false) + " from TSVZPT"+String(i)
                 ExecuteSQL(strSQL);


                 //время по отпускам по лицевым счетам помесячно

                 DropTable("TSVZPV2")
                 strSQL = "select Ftabn_id, FLSFID, FDAY, Fmn, Fvp,"+sqlTo(bkv)+" as FMF "
                          +" into TSVZPV2 FROM ^"+xfile+" "
                          +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpt)
                 ExecuteSQL(strSQL);

                 // меняем знак во времени для буд.сумм из прошлых периодов
                 strSQL = "UPDATE TSVZPV2 set Fday=-1*Fday where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 strSQL = "select Ftabn_id, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 2 as Ftt,"
                      +" sum(FDAY) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPO"+String(i)
                      +" FROM TSVZPV2 "
                      +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpt)+" group by Ftabn_id, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);

/*
                 strSQL = "select Ftabn_id, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 2 as Ftt,"
                      +" sum(FDAY) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPO"+String(i)
                      +" FROM ^"+xfile+" "
                      +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpt)+" group by Ftabn_id, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);
*/

                 // меняем знак во времени для буд.сумм из прошлых периодов
                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fsum"+String(i)+"=-1*Fsum"+String(i)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // складываем время за месяц со временем пришедшим из буд.периодов прошлых месяцев
                 strSQL = "UPDATE TSVZPO"+String(i)+" set Fvp=0, Fmn="+sqlTo(d00obj)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPO"+String(i)+" set Fmn=Fmf where Fvp=0"
                 ExecuteSQL(strSQL);

                 //запоминаем месяц начисления для времени будущих и прошлых перодов и текущих
                 strSQL = "UPDATE TSVZPO"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000+"+SqlMonth("Fmf")+"*100+"+SqlMonth("Fmn")+" where Fsum"+String(i)+">=0"
                 ExecuteSQL(strSQL);
                 strSQL = "UPDATE TSVZPO"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000-"+SqlMonth("Fmf")+"*100-"+SqlMonth("Fmn")+" where Fsum"+String(i)+"<0"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPO"+String(i)+" set Fmn="+sqlTo(d00obj)+" where Fvp=0"
                 ExecuteSQL(strSQL);

				 fields = GetPatternIntersection("TSVZPO"+String(i),"TSVZPO"+String(i)).replace(/(fwid\s*,)|(\s*fwid\W)/gi,"")
                 strSQL = "insert into SVZPALLM " + getColumn("TSVZPO"+String(i),true) 
					+ "select " + getColumn("TSVZPO"+String(i),false) + " from TSVZPO"+String(i)
                 ExecuteSQL(strSQL);

                 //             время по отпускам будущим по лицевым счетам помесячно

                 DropTable("TSVZPV3")
                 strSQL = "select Ftabn_id, FLSFID, FDAY, Fmn, Fvp,"+sqlTo(bkv)+" as FMF "
                          +" into TSVZPV3 FROM ^"+xfile+" "
                          +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpb)
                 ExecuteSQL(strSQL);

                 // меняем знак во времени для буд.сумм из прошлых периодов
                 strSQL = "UPDATE TSVZPV3 set Fday=-1*Fday where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 strSQL = "select Ftabn_id, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 3 as Ftt,"
                      +" sum(FDAY) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPB"+String(i)
                      +" FROM TSVZPV3 "
                      +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpb)+" group by Ftabn_id, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);


/*
                 strSQL = "select Ftabn_id, FLSFID, Fmn, Fvp,"+sqlTo(bkv)+" as FMF, 3 as Ftt,"
                      +" sum(FDAY) as Fsum"+String(i)+strsum1+strsum2
                      +" into TSVZPB"+String(i)
                      +" FROM ^"+xfile+" "
                      +" WHERE Ftabn_id="+sqlTo(mFtabn_id)+" and Flsfid="+sqlTo(otpb)+" group by Ftabn_id, Flsfid, Fmn, Fvp"
                 ExecuteSQL(strSQL);
*/

                 strSQL = "UPDATE TSVZPT"+String(i)+" set Fsum"+String(i)+"=-1*Fsum"+String(i)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // складываем время за месяц со временем пришедшим из буд.периодов прошлых месяцев
                 strSQL = "UPDATE TSVZPB"+String(i)+" set Fvp=0, Fmn="+sqlTo(d00obj)+" where Fvp=1 and Fmn<Fmf"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPB"+String(i)+" set Fmn=Fmf where Fvp=0"
                 ExecuteSQL(strSQL);

                 //запоминаем месяц начисления для времени будущих и прошлых перодов и текущих
                 strSQL = "UPDATE TSVZPB"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000+"+SqlMonth("Fmf")+"*100+"+SqlMonth("Fmn")+" where Fsum"+String(i)+">=0"
                 ExecuteSQL(strSQL);
                 strSQL = "UPDATE TSVZPB"+String(i)+" set Fsum"+String(i)+"=Fsum"+String(i)+"*1000000-"+SqlMonth("Fmf")+"*100-"+SqlMonth("Fmn")+" where Fsum"+String(i)+"<0"
                 ExecuteSQL(strSQL);

                 // Fmn
                 strSQL = "UPDATE TSVZPB"+String(i)+" set Fmn="+sqlTo(d00obj)+" where Fvp=0"
                 ExecuteSQL(strSQL);

				 fields = GetPatternIntersection("TSVZPB"+String(i),"TSVZPB"+String(i)).replace(/(fwid\s*,)|(\s*fwid\W)/gi,"")
                 strSQL = "insert into SVZPALLM " + getColumn("TSVZPB"+String(i),true) 
					+ " select " + getColumn("TSVZPB"+String(i),false) + " from TSVZPB"+String(i)
                 ExecuteSQL(strSQL);

              }              
              bkv.setMonth(bkv.getMonth()+1);
              __year = month_txt(bkv);
              i=i+1;
           }   

           //сбор сумм по месяцам в виде шахматки
           DropTable("SVZPALLM2")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt, sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          "  into  SVZPALLM2 from SVZPALLM as a where Ftt=0 group by Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt"
           ExecuteSQL(strSQL);

           DropTable("TT")  
           DropTable("TT2") 
 
           strSQL = "select Ftabn_id, flsfid, " + First("SVZPALLM2.Fmn") + " as Fmn, max(SVZPALLM2.Fvp) as Fvp, Fmf, 1 as Fcol  into TT from SVZPALLM2 where Ftt=0 group by Ftabn_id, Flsfid, Fmf";
           ExecuteSQL(strSQL);                                   

           strSQL =  "SELECT A.*, B.FCOL INTO TT2 FROM SVZPALLM2 A LEFT JOIN TT B "
               +" ON A.Ftabn_id=B.Ftabn_id and a.Flsfid=b.Flsfid and a.Fmf=b.Fmf and a.Fmn=b.Fmn and a.Fvp=b.Fvp"
              +" ORDER BY a.Flsfid";
           ExecuteSQL(strSQL);                                   
			
           strSQL = "UPDATE TT2 set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fcol=1" 
           ExecuteSQL(strSQL);                                   

           //сбор времени по окладам по месяцам в виде шахматки

           DropTable("SVZPALLMT")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt, sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          "  into  SVZPALLMT from SVZPALLM as a where Ftt=1 group by Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt"
           ExecuteSQL(strSQL);

           DropTable("TTT")  
           DropTable("TTT2") 
 
           strSQL = "select Ftabn_id, flsfid, " + First("SVZPALLMT.Fmn") + " as Fmn, max(SVZPALLMT.Fvp) as Fvp, Fmf, 1 as Fcol  into TTT from SVZPALLMT where Ftt=1 group by Ftabn_id, Flsfid, Fmf";
           ExecuteSQL(strSQL);                                   

           strSQL =  "SELECT A.*, B.FCOL INTO TTT2 FROM SVZPALLMT A LEFT JOIN TTT B "
               +" ON A.Ftabn_id=B.Ftabn_id and a.Flsfid=b.Flsfid and a.Fmf=b.Fmf and a.Fmn=b.Fmn and a.Fvp=b.Fvp"
              +" ORDER BY a.Flsfid";
           ExecuteSQL(strSQL);                                   
			
           strSQL = "UPDATE TTT2 set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fcol=1" 
           ExecuteSQL(strSQL);                                   

           //сбор времени по отпускам по месяцам в виде шахматки

           DropTable("SVZPALLMO")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt, sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          "  into  SVZPALLMO from SVZPALLM as a where Ftt=2 group by Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt"
           ExecuteSQL(strSQL);

           DropTable("TTO")  
           DropTable("TTO2") 
 
           strSQL = "select Ftabn_id, flsfid, " + First("SVZPALLMO.Fmn") + " as Fmn, max(SVZPALLMO.Fvp) as Fvp, Fmf, 1 as Fcol  into TTO from SVZPALLMO where Ftt=2 group by Ftabn_id, Flsfid, Fmf";
           ExecuteSQL(strSQL);                                   

           strSQL =  "SELECT A.*, B.FCOL INTO TTO2 FROM SVZPALLMO A LEFT JOIN TTO B "
               +" ON A.Ftabn_id=B.Ftabn_id and a.Flsfid=b.Flsfid and a.Fmf=b.Fmf and a.Fmn=b.Fmn and a.Fvp=b.Fvp"
              +" ORDER BY a.Flsfid";
           ExecuteSQL(strSQL);                                   
			
           strSQL = "UPDATE TTO2 set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fcol=1" 
           ExecuteSQL(strSQL);                                   

           //сбор времени по отпускам будущим по месяцам в виде шахматки

           DropTable("SVZPALLMB")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt, sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          "  into  SVZPALLMB from SVZPALLM as a where Ftt=3 group by Ftabn_id, Flsfid, Fmn, Fvp, Fmf, Ftt"
           ExecuteSQL(strSQL);

           DropTable("TTB")  
           DropTable("TTB2") 
 
           strSQL = "select Ftabn_id, flsfid, " + First("SVZPALLMB.Fmn") + " as Fmn, max(SVZPALLMB.Fvp) as Fvp, Fmf, 1 as Fcol  into TTB from SVZPALLMB where Ftt=3 group by Ftabn_id, Flsfid, Fmf";
           ExecuteSQL(strSQL);                                   

           strSQL =  "SELECT A.*, B.FCOL INTO TTB2 FROM SVZPALLMB A LEFT JOIN TTB B "
               +" ON A.Ftabn_id=B.Ftabn_id and a.Flsfid=b.Flsfid and a.Fmf=b.Fmf and a.Fmn=b.Fmn and a.Fvp=b.Fvp"
              +" ORDER BY a.Flsfid";
           ExecuteSQL(strSQL);                                   
			
           strSQL = "UPDATE TTB2 set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fcol=1" 
           ExecuteSQL(strSQL);                                   

           DropTable("SVZPALLM3")  
           DropTable("SVZPALLM9")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Ftt, Fcol,sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          ", sum(a.Fsum1) as Fsum21,sum(a.Fsum2) as Fsum22,sum(a.Fsum3) as Fsum23"+
                          ", sum(a.Fsum4) as Fsum24,sum(a.Fsum5) as Fsum25,sum(a.Fsum6) as Fsum26"+
                          ", sum(a.Fsum7) as Fsum27,sum(a.Fsum8) as Fsum28,sum(a.Fsum9) as Fsum29"+
                          ", sum(a.Fsum10) as Fsum30, sum(a.Fsum11) as Fsum31, sum(a.Fsum12) as Fsum32, sum(a.Fsum14) as Fsum34"+
                          ", 0 as Fmn1,0 as Fmn2,0 as Fmn3,0 as Fmn4,0 as Fmn5,0 as Fmn6,0 as Fmn7,0 as Fmn8,0 as Fmn9,0 as Fmn10,0 as Fmn11,0 as Fmn12,0 as Fmn14 "+
                          "  into  SVZPALLM9 from TT2 as a group by Ftabn_id, Flsfid, Fmn, Fvp, Fcol, Ftt "
           ExecuteSQL(strSQL);

           strSQL =  "SELECT A.*, B.FFLD_NUM INTO SVZPALLM3 FROM SVZPALLM9 A LEFT JOIN ^LIC_FLD B "
               +" ON A.FLSFID=B.FID "
              +" ORDER BY b.Ffld_num, a.Ftt";
           ExecuteSQL(strSQL);
           ExecuteSQL("ALTER TABLE SVZPALLM3 ADD FWID "+ SqlType("COUNTER"));                                              

           SVZPALLM3 = OpenTable("s", "SVZPALLM3");
           if (!SVZPALLM3.IsEmpty()){
              while (!SVZPALLM3.IsEOF()){
                 aFsum1 = Math.abs(Number(SVZPALLM3.getValue("Fsum1")))
                 nFsum1 = (Number(SVZPALLM3.getValue("Fsum1"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum1"))):0
                 aFsum2 = Math.abs(Number(SVZPALLM3.getValue("Fsum2")))
                 nFsum2 = (Number(SVZPALLM3.getValue("Fsum2"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum2"))):0
                 aFsum3 = Math.abs(SVZPALLM3.getValue("Fsum3"))
                 nFsum3 = (Number(SVZPALLM3.getValue("Fsum3"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum3"))):0
                 aFsum4 = Math.abs(Number(SVZPALLM3.getValue("Fsum4")))
                 nFsum4 = (Number(SVZPALLM3.getValue("Fsum4"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum4"))):0
                 aFsum5 = Math.abs(Number(SVZPALLM3.getValue("Fsum5")))
                 nFsum5 = (Number(SVZPALLM3.getValue("Fsum5"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum5"))):0
                 aFsum6 = Math.abs(Number(SVZPALLM3.getValue("Fsum6")))
                 nFsum6 = (Number(SVZPALLM3.getValue("Fsum6"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum6"))):0
                 aFsum7 = Math.abs(Number(SVZPALLM3.getValue("Fsum7")))
                 nFsum7 = (Number(SVZPALLM3.getValue("Fsum7"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum7"))):0
                 aFsum8 = Math.abs(Number(SVZPALLM3.getValue("Fsum8")))
                 nFsum8 = (Number(SVZPALLM3.getValue("Fsum8"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum8"))):0
                 aFsum9 = Math.abs(Number(SVZPALLM3.getValue("Fsum9")))
                 nFsum9 = (Number(SVZPALLM3.getValue("Fsum9"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum9"))):0
                 aFsum10= Math.abs(Number(SVZPALLM3.getValue("Fsum10")))
                 nFsum10 = (Number(SVZPALLM3.getValue("Fsum10"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum10"))):0
                 aFsum11= Math.abs(Number(SVZPALLM3.getValue("Fsum11")))
                 nFsum11 = (Number(SVZPALLM3.getValue("Fsum11"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum12"))):0
                 aFsum12= Math.abs(Number(SVZPALLM3.getValue("Fsum12")))
                 nFsum12 = (Number(SVZPALLM3.getValue("Fsum12"))<0)?Math.abs(Number(SVZPALLM3.getValue("Fsum12"))):0

                 mFsum1 = (nFsum1!=0)?(-1*((Math.floor(aFsum1/10000))/100)):(Math.floor(aFsum1/10000))/100
                 mFsum2 = (nFsum2!=0)?(-1*((Math.floor(aFsum2/10000))/100)):(Math.floor(aFsum2/10000))/100
                 mFsum3 = (nFsum3!=0)?(-1*((Math.floor(aFsum3/10000))/100)):(Math.floor(aFsum3/10000))/100
                 mFsum4 = (nFsum4!=0)?(-1*((Math.floor(aFsum4/10000))/100)):(Math.floor(aFsum4/10000))/100
                 mFsum5 = (nFsum5!=0)?(-1*((Math.floor(aFsum5/10000))/100)):(Math.floor(aFsum5/10000))/100
                 mFsum6 = (nFsum6!=0)?(-1*((Math.floor(aFsum6/10000))/100)):(Math.floor(aFsum6/10000))/100
                 mFsum7 = (nFsum7!=0)?(-1*((Math.floor(aFsum7/10000))/100)):(Math.floor(aFsum7/10000))/100
                 mFsum8 = (nFsum8!=0)?(-1*((Math.floor(aFsum8/10000))/100)):(Math.floor(aFsum8/10000))/100
                 mFsum9 = (nFsum9!=0)?(-1*((Math.floor(aFsum9/10000))/100)):(Math.floor(aFsum9/10000))/100
                 mFsum10= (nFsum10!=0)?(-1*((Math.floor(aFsum10/10000))/100)):(Math.floor(aFsum10/10000))/100
                 mFsum11= (nFsum11!=0)?(-1*((Math.floor(aFsum11/10000))/100)):(Math.floor(aFsum11/10000))/100
                 mFsum12= (nFsum12!=0)?(-1*((Math.floor(aFsum12/10000))/100)):(Math.floor(aFsum12/10000))/100

                 bFsum1 = aFsum1 -Math.floor(aFsum1/10000)*10000  
                 bFsum2 = aFsum2 -Math.floor(aFsum2/10000)*10000  
                 bFsum3 = aFsum3 -Math.floor(aFsum3/10000)*10000  
                 bFsum4 = aFsum4 -Math.floor(aFsum4/10000)*10000  
                 bFsum5 = aFsum5 -Math.floor(aFsum5/10000)*10000  
                 bFsum6 = aFsum6 -Math.floor(aFsum6/10000)*10000  
                 bFsum7 = aFsum7 -Math.floor(aFsum7/10000)*10000  
                 bFsum8 = aFsum8 -Math.floor(aFsum8/10000)*10000  
                 bFsum9 = aFsum9 -Math.floor(aFsum9/10000)*10000  
                 bFsum10= aFsum10-Math.floor(aFsum10/10000)*10000  
                 bFsum11= aFsum11-Math.floor(aFsum11/10000)*10000  
                 bFsum12= aFsum12-Math.floor(aFsum12/10000)*10000  

                 mFmf1 = Math.floor(bFsum1/100)  
                 mFmf2 = Math.floor(bFsum2/100)    
                 mFmf3 = Math.floor(bFsum3/100)  
                 mFmf4 = Math.floor(bFsum4/100)  
                 mFmf5 = Math.floor(bFsum5/100)  
                 mFmf6 = Math.floor(bFsum6/100)  
                 mFmf7 = Math.floor(bFsum7/100)  
                 mFmf8 = Math.floor(bFsum8/100)  
                 mFmf9 = Math.floor(bFsum9/100)  
                 mFmf10= Math.floor(bFsum10/100)  
                 mFmf11= Math.floor(bFsum11/100)  
                 mFmf12= Math.floor(bFsum12/100)  

                 mFmn1 = bFsum1 -Math.floor(bFsum1/100)*100
                 mFmn2 = bFsum2 -Math.floor(bFsum2/100)*100    
                 mFmn3 = bFsum3 -Math.floor(bFsum3/100)*100  
                 mFmn4 = bFsum4 -Math.floor(bFsum4/100)*100  
                 mFmn5 = bFsum5 -Math.floor(bFsum5/100)*100  
                 mFmn6 = bFsum6 -Math.floor(bFsum6/100)*100  
                 mFmn7 = bFsum7 -Math.floor(bFsum7/100)*100  
                 mFmn8 = bFsum8 -Math.floor(bFsum8/100)*100  
                 mFmn9 = bFsum9 -Math.floor(bFsum9/100)*100  
                 mFmn10= bFsum10-Math.floor(bFsum10/100)*100  
                 mFmn11= bFsum11-Math.floor(bFsum11/100)*100  
                 mFmn12= bFsum12-Math.floor(bFsum12/100)*100  

                 mFmn1 = (mFmf1==mFmn1)?0:mFmn1
                 mFmn2 = (mFmf2==mFmn2)?0:mFmn2
                 mFmn3 = (mFmf3==mFmn3)?0:mFmn3
                 mFmn4 = (mFmf4==mFmn4)?0:mFmn4
                 mFmn5 = (mFmf5==mFmn5)?0:mFmn5
                 mFmn6 = (mFmf6==mFmn6)?0:mFmn6
                 mFmn7 = (mFmf7==mFmn7)?0:mFmn7
                 mFmn8 = (mFmf8==mFmn8)?0:mFmn8
                 mFmn9 = (mFmf9==mFmn9)?0:mFmn9
                 mFmn10= (mFmf10==mFmn10)?0:mFmn10
                 mFmn11= (mFmf11==mFmn11)?0:mFmn11
                 mFmn12= (mFmf12==mFmn12)?0:mFmn12

                 var m = new Object();
                 m.Fsum1 = mFsum1;
                 m.Fsum2 = mFsum2;
                 m.Fsum3 = mFsum3;
                 m.Fsum4 = mFsum4;
                 m.Fsum5 = mFsum5;
                 m.Fsum6 = mFsum6;
                 m.Fsum7 = mFsum7;
                 m.Fsum8 = mFsum8;
                 m.Fsum9 = mFsum9;
                 m.Fsum10 = mFsum10;
                 m.Fsum11 = mFsum11;
                 m.Fsum12 = mFsum12;

                 m.Fmn1 = mFmn1;
                 m.Fmn2 = mFmn2;
                 m.Fmn3 = mFmn3;
                 m.Fmn4 = mFmn4;
                 m.Fmn5 = mFmn5;
                 m.Fmn6 = mFmn6;
                 m.Fmn7 = mFmn7;
                 m.Fmn8 = mFmn8;
                 m.Fmn9 = mFmn9;
                 m.Fmn10 = mFmn10;
                 m.Fmn11 = mFmn11;
                 m.Fmn12 = mFmn12;
                 UpdateTable("SVZPALLM3", m, false, "Fwid="+SVZPALLM3.getValue("Fwid"));

                 SVZPALLM3.MoveNext();
              }   
           }                  

           strSQL = "UPDATE SVZPALLM3 set Fsum14=Fsum1+Fsum2+Fsum3+Fsum4+Fsum5+Fsum6+Fsum7+Fsum8+Fsum9+Fsum10+Fsum11+Fsum12"
           ExecuteSQL(strSQL);

           strSQL = "UPDATE SVZPALLM3 set FMN14=FMN1+FMN2+FMN3+FMN4+FMN5+FMN6+FMN7+FMN8+FMN9+FMN10+FMN11+FMN12"
           ExecuteSQL(strSQL);

           DropTable("SVZPALLM14")  
           DropTable("SVZPALLM4")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Ftt, Fcol,sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          ", sum(a.Fsum1) as Fsum21,sum(a.Fsum2) as Fsum22,sum(a.Fsum3) as Fsum23"+
                          ", sum(a.Fsum4) as Fsum24,sum(a.Fsum5) as Fsum25,sum(a.Fsum6) as Fsum26"+
                          ", sum(a.Fsum7) as Fsum27,sum(a.Fsum8) as Fsum28,sum(a.Fsum9) as Fsum29"+
                          ", sum(a.Fsum10) as Fsum30, sum(a.Fsum11) as Fsum31, sum(a.Fsum12) as Fsum32, sum(a.Fsum14) as Fsum34"+
                          ", 0 as Fmn1,0 as Fmn2,0 as Fmn3,0 as Fmn4,0 as Fmn5,0 as Fmn6,0 as Fmn7,0 as Fmn8,0 as Fmn9,0 as Fmn10,0 as Fmn11,0 as Fmn12,0 as Fmn14 "+
                          "  into  SVZPALLM14 from TTT2 as a group by Ftabn_id, Flsfid, Fmn, Fvp, Fcol, Ftt"
           ExecuteSQL(strSQL);

           strSQL =  "SELECT A.*, B.FFLD_NUM INTO SVZPALLM4 FROM SVZPALLM14 A LEFT JOIN ^LIC_FLD B "
               +" ON A.FLSFID=B.FID "
              +" ORDER BY b.Ffld_num, a.Ftt";
           ExecuteSQL(strSQL);                                   
           ExecuteSQL("ALTER TABLE SVZPALLM4 ADD FWID "+ SqlType("COUNTER"));                                              

           SVZPALLM4 = OpenTable("s", "SVZPALLM4");
           if (!SVZPALLM4.IsEmpty()){
              while (!SVZPALLM4.IsEOF()){
                 aFsum1 = Number(SVZPALLM4.getValue("Fsum1"))
                 aFsum2 = Number(SVZPALLM4.getValue("Fsum2"))
                 aFsum3 = Number(SVZPALLM4.getValue("Fsum3"))
                 aFsum4 = Number(SVZPALLM4.getValue("Fsum4"))
                 aFsum5 = Number(SVZPALLM4.getValue("Fsum5"))
                 aFsum6 = Number(SVZPALLM4.getValue("Fsum6"))
                 aFsum7 = Number(SVZPALLM4.getValue("Fsum7"))
                 aFsum8 = Number(SVZPALLM4.getValue("Fsum8"))
                 aFsum9 = Number(SVZPALLM4.getValue("Fsum9"))
                 aFsum10= Number(SVZPALLM4.getValue("Fsum10"))
                 aFsum11= Number(SVZPALLM4.getValue("Fsum11"))
                 aFsum12= Number(SVZPALLM4.getValue("Fsum12"))

                 mFsum1 = (Math.floor(aFsum1/10000))/100
                 mFsum2 = (Math.floor(aFsum2/10000))/100
                 mFsum3 = (Math.floor(aFsum3/10000))/100
                 mFsum4 = (Math.floor(aFsum4/10000))/100
                 mFsum5 = (Math.floor(aFsum5/10000))/100
                 mFsum6 = (Math.floor(aFsum6/10000))/100
                 mFsum7 = (Math.floor(aFsum7/10000))/100
                 mFsum8 = (Math.floor(aFsum8/10000))/100
                 mFsum9 = (Math.floor(aFsum9/10000))/100
                 mFsum10= (Math.floor(aFsum10/10000))/100
                 mFsum11= (Math.floor(aFsum11/10000))/100
                 mFsum12= (Math.floor(aFsum12/10000))/100

                 bFsum1 = aFsum1 -Math.floor(aFsum1/10000)*10000  
                 bFsum2 = aFsum2 -Math.floor(aFsum2/10000)*10000  
                 bFsum3 = aFsum3 -Math.floor(aFsum3/10000)*10000  
                 bFsum4 = aFsum4 -Math.floor(aFsum4/10000)*10000  
                 bFsum5 = aFsum5 -Math.floor(aFsum5/10000)*10000  
                 bFsum6 = aFsum6 -Math.floor(aFsum6/10000)*10000  
                 bFsum7 = aFsum7 -Math.floor(aFsum7/10000)*10000  
                 bFsum8 = aFsum8 -Math.floor(aFsum8/10000)*10000  
                 bFsum9 = aFsum9 -Math.floor(aFsum9/10000)*10000  
                 bFsum10= aFsum10-Math.floor(aFsum10/10000)*10000  
                 bFsum11= aFsum11-Math.floor(aFsum11/10000)*10000  
                 bFsum12= aFsum12-Math.floor(aFsum12/10000)*10000  

                 mFmf1 = Math.floor(bFsum1/100)  
                 mFmf2 = Math.floor(bFsum2/100)    
                 mFmf3 = Math.floor(bFsum3/100)  
                 mFmf4 = Math.floor(bFsum4/100)  
                 mFmf5 = Math.floor(bFsum5/100)  
                 mFmf6 = Math.floor(bFsum6/100)  
                 mFmf7 = Math.floor(bFsum7/100)  
                 mFmf8 = Math.floor(bFsum8/100)  
                 mFmf9 = Math.floor(bFsum9/100)  
                 mFmf10= Math.floor(bFsum10/100)  
                 mFmf11= Math.floor(bFsum11/100)  
                 mFmf12= Math.floor(bFsum12/100)  

                 mFmn1 = bFsum1 -Math.floor(bFsum1/100)*100
                 mFmn2 = bFsum2 -Math.floor(bFsum2/100)*100    
                 mFmn3 = bFsum3 -Math.floor(bFsum3/100)*100  
                 mFmn4 = bFsum4 -Math.floor(bFsum4/100)*100  
                 mFmn5 = bFsum5 -Math.floor(bFsum5/100)*100  
                 mFmn6 = bFsum6 -Math.floor(bFsum6/100)*100  
                 mFmn7 = bFsum7 -Math.floor(bFsum7/100)*100  
                 mFmn8 = bFsum8 -Math.floor(bFsum8/100)*100  
                 mFmn9 = bFsum9 -Math.floor(bFsum9/100)*100  
                 mFmn10= bFsum10-Math.floor(bFsum10/100)*100  
                 mFmn11= bFsum11-Math.floor(bFsum11/100)*100  
                 mFmn12= bFsum12-Math.floor(bFsum12/100)*100  

                 mFmn1 = (mFmf1==mFmn1)?0:mFmn1
                 mFmn2 = (mFmf2==mFmn2)?0:mFmn2
                 mFmn3 = (mFmf3==mFmn3)?0:mFmn3
                 mFmn4 = (mFmf4==mFmn4)?0:mFmn4
                 mFmn5 = (mFmf5==mFmn5)?0:mFmn5
                 mFmn6 = (mFmf6==mFmn6)?0:mFmn6
                 mFmn7 = (mFmf7==mFmn7)?0:mFmn7
                 mFmn8 = (mFmf8==mFmn8)?0:mFmn8
                 mFmn9 = (mFmf9==mFmn9)?0:mFmn9
                 mFmn10= (mFmf10==mFmn10)?0:mFmn10
                 mFmn11= (mFmf11==mFmn11)?0:mFmn11
                 mFmn12= (mFmf12==mFmn12)?0:mFmn12

                 var m = new Object();
                 m.Fsum1=mFsum1;
                 m.Fsum2=mFsum2;
                 m.Fsum3=mFsum3;
                 m.Fsum4=mFsum4;
                 m.Fsum5=mFsum5;
                 m.Fsum6=mFsum6;
                 m.Fsum7=mFsum7;
                 m.Fsum8=mFsum8;
                 m.Fsum9=mFsum9;
                 m.Fsum10=mFsum10;
                 m.Fsum11=mFsum11;
                 m.Fsum12=mFsum12;

                 m.Fmn1=mFmn1;
                 m.Fmn2=mFmn2;
                 m.Fmn3=mFmn3;
                 m.Fmn4=mFmn4;
                 m.Fmn5=mFmn5;
                 m.Fmn6=mFmn6;
                 m.Fmn7=mFmn7;
                 m.Fmn8=mFmn8;
                 m.Fmn9=mFmn9;
                 m.Fmn10=mFmn10;
                 m.Fmn11=mFmn11;
                 m.Fmn12=mFmn12;
                 UpdateTable("SVZPALLM4", m, false, "Fwid="+SVZPALLM4.getValue("Fwid"));

                 SVZPALLM4.MoveNext();
              }   
           }                  


           strSQL = "UPDATE SVZPALLM4 set Fsum14=Fsum1+Fsum2+Fsum3+Fsum4+Fsum5+Fsum6+Fsum7+Fsum8+Fsum9+Fsum10+Fsum11+Fsum12"
           ExecuteSQL(strSQL);

           strSQL = "UPDATE SVZPALLM4 set FMN14=FMN1+FMN2+FMN3+FMN4+FMN5+FMN6+FMN7+FMN8+FMN9+FMN10+FMN11+FMN12"
           ExecuteSQL(strSQL);

           DropTable("SVZPALLM15")  
           DropTable("SVZPALLM5")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Ftt, Fcol,sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          ", sum(a.Fsum1) as Fsum21,sum(a.Fsum2) as Fsum22,sum(a.Fsum3) as Fsum23"+
                          ", sum(a.Fsum4) as Fsum24,sum(a.Fsum5) as Fsum25,sum(a.Fsum6) as Fsum26"+
                          ", sum(a.Fsum7) as Fsum27,sum(a.Fsum8) as Fsum28,sum(a.Fsum9) as Fsum29"+
                          ", sum(a.Fsum10) as Fsum30, sum(a.Fsum11) as Fsum31, sum(a.Fsum12) as Fsum32, sum(a.Fsum14) as Fsum34"+
                          ", 0 as Fmn1,0 as Fmn2,0 as Fmn3,0 as Fmn4,0 as Fmn5,0 as Fmn6,0 as Fmn7,0 as Fmn8,0 as Fmn9,0 as Fmn10,0 as Fmn11,0 as Fmn12,0 as Fmn14 "+
                          "  into  SVZPALLM15 from TTO2 as a group by Ftabn_id, Flsfid, Fmn, Fvp, Fcol, Ftt"
           ExecuteSQL(strSQL);

           strSQL =  "SELECT A.*, B.FFLD_NUM INTO SVZPALLM5 FROM SVZPALLM15 A LEFT JOIN ^LIC_FLD B "
               +" ON A.FLSFID=B.FID "
              +" ORDER BY b.Ffld_num, a.Ftt";
           ExecuteSQL(strSQL);                                   
           ExecuteSQL("ALTER TABLE SVZPALLM5 ADD FWID "+ SqlType("COUNTER"));                                              

           SVZPALLM5 = OpenTable("s", "SVZPALLM5");
           if (!SVZPALLM5.IsEmpty()){
              while (!SVZPALLM5.IsEOF()){
                 aFsum1 = Number(SVZPALLM5.getValue("Fsum1"))
                 aFsum2 = Number(SVZPALLM5.getValue("Fsum2"))
                 aFsum3 = Number(SVZPALLM5.getValue("Fsum3"))
                 aFsum4 = Number(SVZPALLM5.getValue("Fsum4"))
                 aFsum5 = Number(SVZPALLM5.getValue("Fsum5"))
                 aFsum6 = Number(SVZPALLM5.getValue("Fsum6"))
                 aFsum7 = Number(SVZPALLM5.getValue("Fsum7"))
                 aFsum8 = Number(SVZPALLM5.getValue("Fsum8"))
                 aFsum9 = Number(SVZPALLM5.getValue("Fsum9"))
                 aFsum10= Number(SVZPALLM5.getValue("Fsum10"))
                 aFsum11= Number(SVZPALLM5.getValue("Fsum11"))
                 aFsum12= Number(SVZPALLM5.getValue("Fsum12"))

                 mFsum1 = (Math.floor(aFsum1/10000))/100
                 mFsum2 = (Math.floor(aFsum2/10000))/100
                 mFsum3 = (Math.floor(aFsum3/10000))/100
                 mFsum4 = (Math.floor(aFsum4/10000))/100
                 mFsum5 = (Math.floor(aFsum5/10000))/100
                 mFsum6 = (Math.floor(aFsum6/10000))/100
                 mFsum7 = (Math.floor(aFsum7/10000))/100
                 mFsum8 = (Math.floor(aFsum8/10000))/100
                 mFsum9 = (Math.floor(aFsum9/10000))/100
                 mFsum10= (Math.floor(aFsum10/10000))/100
                 mFsum11= (Math.floor(aFsum11/10000))/100
                 mFsum12= (Math.floor(aFsum12/10000))/100

                 bFsum1 = aFsum1 -Math.floor(aFsum1/10000)*10000  
                 bFsum2 = aFsum2 -Math.floor(aFsum2/10000)*10000  
                 bFsum3 = aFsum3 -Math.floor(aFsum3/10000)*10000  
                 bFsum4 = aFsum4 -Math.floor(aFsum4/10000)*10000  
                 bFsum5 = aFsum5 -Math.floor(aFsum5/10000)*10000  
                 bFsum6 = aFsum6 -Math.floor(aFsum6/10000)*10000  
                 bFsum7 = aFsum7 -Math.floor(aFsum7/10000)*10000  
                 bFsum8 = aFsum8 -Math.floor(aFsum8/10000)*10000  
                 bFsum9 = aFsum9 -Math.floor(aFsum9/10000)*10000  
                 bFsum10= aFsum10-Math.floor(aFsum10/10000)*10000  
                 bFsum11= aFsum11-Math.floor(aFsum11/10000)*10000  
                 bFsum12= aFsum12-Math.floor(aFsum12/10000)*10000  

                 mFmf1 = Math.floor(bFsum1/100)  
                 mFmf2 = Math.floor(bFsum2/100)    
                 mFmf3 = Math.floor(bFsum3/100)  
                 mFmf4 = Math.floor(bFsum4/100)  
                 mFmf5 = Math.floor(bFsum5/100)  
                 mFmf6 = Math.floor(bFsum6/100)  
                 mFmf7 = Math.floor(bFsum7/100)  
                 mFmf8 = Math.floor(bFsum8/100)  
                 mFmf9 = Math.floor(bFsum9/100)  
                 mFmf10= Math.floor(bFsum10/100)  
                 mFmf11= Math.floor(bFsum11/100)  
                 mFmf12= Math.floor(bFsum12/100)  

                 mFmn1 = bFsum1 -Math.floor(bFsum1/100)*100
                 mFmn2 = bFsum2 -Math.floor(bFsum2/100)*100    
                 mFmn3 = bFsum3 -Math.floor(bFsum3/100)*100  
                 mFmn4 = bFsum4 -Math.floor(bFsum4/100)*100  
                 mFmn5 = bFsum5 -Math.floor(bFsum5/100)*100  
                 mFmn6 = bFsum6 -Math.floor(bFsum6/100)*100  
                 mFmn7 = bFsum7 -Math.floor(bFsum7/100)*100  
                 mFmn8 = bFsum8 -Math.floor(bFsum8/100)*100  
                 mFmn9 = bFsum9 -Math.floor(bFsum9/100)*100  
                 mFmn10= bFsum10-Math.floor(bFsum10/100)*100  
                 mFmn11= bFsum11-Math.floor(bFsum11/100)*100  
                 mFmn12= bFsum12-Math.floor(bFsum12/100)*100  

                 mFmn1 = (mFmf1==mFmn1)?0:mFmn1
                 mFmn2 = (mFmf2==mFmn2)?0:mFmn2
                 mFmn3 = (mFmf3==mFmn3)?0:mFmn3
                 mFmn4 = (mFmf4==mFmn4)?0:mFmn4
                 mFmn5 = (mFmf5==mFmn5)?0:mFmn5
                 mFmn6 = (mFmf6==mFmn6)?0:mFmn6
                 mFmn7 = (mFmf7==mFmn7)?0:mFmn7
                 mFmn8 = (mFmf8==mFmn8)?0:mFmn8
                 mFmn9 = (mFmf9==mFmn9)?0:mFmn9
                 mFmn10= (mFmf10==mFmn10)?0:mFmn10
                 mFmn11= (mFmf11==mFmn11)?0:mFmn11
                 mFmn12= (mFmf12==mFmn12)?0:mFmn12

                 var m = new Object();
                 m.Fsum1=mFsum1;
                 m.Fsum2=mFsum2;
                 m.Fsum3=mFsum3;
                 m.Fsum4=mFsum4;
                 m.Fsum5=mFsum5;
                 m.Fsum6=mFsum6;
                 m.Fsum7=mFsum7;
                 m.Fsum8=mFsum8;
                 m.Fsum9=mFsum9;
                 m.Fsum10=mFsum10;
                 m.Fsum11=mFsum11;
                 m.Fsum12=mFsum12;

                 m.Fmn1=mFmn1;
                 m.Fmn2=mFmn2;
                 m.Fmn3=mFmn3;
                 m.Fmn4=mFmn4;
                 m.Fmn5=mFmn5;
                 m.Fmn6=mFmn6;
                 m.Fmn7=mFmn7;
                 m.Fmn8=mFmn8;
                 m.Fmn9=mFmn9;
                 m.Fmn10=mFmn10;
                 m.Fmn11=mFmn11;
                 m.Fmn12=mFmn12;
                 UpdateTable("^SVZPALLM5", m, false, "Fwid="+SVZPALLM5.getValue("Fwid"));

                 SVZPALLM5.MoveNext();
              }   
           }                  


           strSQL = "UPDATE SVZPALLM5 set Fsum14=Fsum1+Fsum2+Fsum3+Fsum4+Fsum5+Fsum6+Fsum7+Fsum8+Fsum9+Fsum10+Fsum11+Fsum12"
           ExecuteSQL(strSQL);

           strSQL = "UPDATE SVZPALLM5 set FMN14=FMN1+FMN2+FMN3+FMN4+FMN5+FMN6+FMN7+FMN8+FMN9+FMN10+FMN11+FMN12"
           ExecuteSQL(strSQL);

           DropTable("SVZPALLM16")  
           DropTable("SVZPALLM6")  
           strSQL = "select Ftabn_id, Flsfid, Fmn, Fvp, Ftt, Fcol,sum(a.Fsum1) as Fsum1,sum(a.Fsum2) as Fsum2,sum(a.Fsum3) as Fsum3"+
                          ", sum(a.Fsum4) as Fsum4,sum(a.Fsum5) as Fsum5,sum(a.Fsum6) as Fsum6"+
                          ", sum(a.Fsum7) as Fsum7,sum(a.Fsum8) as Fsum8,sum(a.Fsum9) as Fsum9"+
                          ", sum(a.Fsum10) as Fsum10, sum(a.Fsum11) as Fsum11, sum(a.Fsum12) as Fsum12, sum(a.Fsum14) as Fsum14"+
                          ", sum(a.Fsum1) as Fsum21,sum(a.Fsum2) as Fsum22,sum(a.Fsum3) as Fsum23"+
                          ", sum(a.Fsum4) as Fsum24,sum(a.Fsum5) as Fsum25,sum(a.Fsum6) as Fsum26"+
                          ", sum(a.Fsum7) as Fsum27,sum(a.Fsum8) as Fsum28,sum(a.Fsum9) as Fsum29"+
                          ", sum(a.Fsum10) as Fsum30, sum(a.Fsum11) as Fsum31, sum(a.Fsum12) as Fsum32, sum(a.Fsum14) as Fsum34"+
                          ", 0 as Fmn1,0 as Fmn2,0 as Fmn3,0 as Fmn4,0 as Fmn5,0 as Fmn6,0 as Fmn7,0 as Fmn8,0 as Fmn9,0 as Fmn10,0 as Fmn11,0 as Fmn12,0 as Fmn14 "+
                          "  into  SVZPALLM16 from TTB2 as a group by Ftabn_id, Flsfid, Fmn, Fvp, Fcol, Ftt"
           ExecuteSQL(strSQL);

           strSQL =  "SELECT A.*, B.FFLD_NUM INTO SVZPALLM6 FROM SVZPALLM16 A LEFT JOIN ^LIC_FLD B "
               +" ON A.FLSFID=B.FID "
              +" ORDER BY b.Ffld_num, a.Ftt";
           ExecuteSQL(strSQL);                                   
           ExecuteSQL("ALTER TABLE SVZPALLM6 ADD FWID "+ SqlType("COUNTER"));                                              

           SVZPALLM6 = OpenTable("s", "SVZPALLM6");
           if (!SVZPALLM6.IsEmpty()){
              while (!SVZPALLM6.IsEOF()){
                 aFsum1 = Number(SVZPALLM6.getValue("Fsum1"))
                 aFsum2 = Number(SVZPALLM6.getValue("Fsum2"))
                 aFsum3 = Number(SVZPALLM6.getValue("Fsum3"))
                 aFsum4 = Number(SVZPALLM6.getValue("Fsum4"))
                 aFsum5 = Number(SVZPALLM6.getValue("Fsum5"))
                 aFsum6 = Number(SVZPALLM6.getValue("Fsum6"))
                 aFsum7 = Number(SVZPALLM6.getValue("Fsum7"))
                 aFsum8 = Number(SVZPALLM6.getValue("Fsum8"))
                 aFsum9 = Number(SVZPALLM6.getValue("Fsum9"))
                 aFsum10= Number(SVZPALLM6.getValue("Fsum10"))
                 aFsum11= Number(SVZPALLM6.getValue("Fsum11"))
                 aFsum12= Number(SVZPALLM6.getValue("Fsum12"))

                 mFsum1 = (Math.floor(aFsum1/10000))/100
                 mFsum2 = (Math.floor(aFsum2/10000))/100
                 mFsum3 = (Math.floor(aFsum3/10000))/100
                 mFsum4 = (Math.floor(aFsum4/10000))/100
                 mFsum5 = (Math.floor(aFsum5/10000))/100
                 mFsum6 = (Math.floor(aFsum6/10000))/100
                 mFsum7 = (Math.floor(aFsum7/10000))/100
                 mFsum8 = (Math.floor(aFsum8/10000))/100
                 mFsum9 = (Math.floor(aFsum9/10000))/100
                 mFsum10= (Math.floor(aFsum10/10000))/100
                 mFsum11= (Math.floor(aFsum11/10000))/100
                 mFsum12= (Math.floor(aFsum12/10000))/100

                 bFsum1 = aFsum1 -Math.floor(aFsum1/10000)*10000  
                 bFsum2 = aFsum2 -Math.floor(aFsum2/10000)*10000  
                 bFsum3 = aFsum3 -Math.floor(aFsum3/10000)*10000  
                 bFsum4 = aFsum4 -Math.floor(aFsum4/10000)*10000  
                 bFsum5 = aFsum5 -Math.floor(aFsum5/10000)*10000  
                 bFsum6 = aFsum6 -Math.floor(aFsum6/10000)*10000  
                 bFsum7 = aFsum7 -Math.floor(aFsum7/10000)*10000  
                 bFsum8 = aFsum8 -Math.floor(aFsum8/10000)*10000  
                 bFsum9 = aFsum9 -Math.floor(aFsum9/10000)*10000  
                 bFsum10= aFsum10-Math.floor(aFsum10/10000)*10000  
                 bFsum11= aFsum11-Math.floor(aFsum11/10000)*10000  
                 bFsum12= aFsum12-Math.floor(aFsum12/10000)*10000  

                 mFmf1 = Math.floor(bFsum1/100)  
                 mFmf2 = Math.floor(bFsum2/100)    
                 mFmf3 = Math.floor(bFsum3/100)  
                 mFmf4 = Math.floor(bFsum4/100)  
                 mFmf5 = Math.floor(bFsum5/100)  
                 mFmf6 = Math.floor(bFsum6/100)  
                 mFmf7 = Math.floor(bFsum7/100)  
                 mFmf8 = Math.floor(bFsum8/100)  
                 mFmf9 = Math.floor(bFsum9/100)  
                 mFmf10= Math.floor(bFsum10/100)  
                 mFmf11= Math.floor(bFsum11/100)  
                 mFmf12= Math.floor(bFsum12/100)  

                 mFmn1 = bFsum1 -Math.floor(bFsum1/100)*100
                 mFmn2 = bFsum2 -Math.floor(bFsum2/100)*100   
                 mFmn3 = bFsum3 -Math.floor(bFsum3/100)*100  
                 mFmn4 = bFsum4 -Math.floor(bFsum4/100)*100  
                 mFmn5 = bFsum5 -Math.floor(bFsum5/100)*100  
                 mFmn6 = bFsum6 -Math.floor(bFsum6/100)*100  
                 mFmn7 = bFsum7 -Math.floor(bFsum7/100)*100  
                 mFmn8 = bFsum8 -Math.floor(bFsum8/100)*100  
                 mFmn9 = bFsum9 -Math.floor(bFsum9/100)*100  
                 mFmn10= bFsum10-Math.floor(bFsum10/100)*100  
                 mFmn11= bFsum11-Math.floor(bFsum11/100)*100  
                 mFmn12= bFsum12-Math.floor(bFsum12/100)*100 

                 mFmn1 = (mFmf1==mFmn1)?0:mFmn1
                 mFmn2 = (mFmf2==mFmn2)?0:mFmn2
                 mFmn3 = (mFmf3==mFmn3)?0:mFmn3
                 mFmn4 = (mFmf4==mFmn4)?0:mFmn4
                 mFmn5 = (mFmf5==mFmn5)?0:mFmn5
                 mFmn6 = (mFmf6==mFmn6)?0:mFmn6
                 mFmn7 = (mFmf7==mFmn7)?0:mFmn7
                 mFmn8 = (mFmf8==mFmn8)?0:mFmn8
                 mFmn9 = (mFmf9==mFmn9)?0:mFmn9
                 mFmn10= (mFmf10==mFmn10)?0:mFmn10
                 mFmn11= (mFmf11==mFmn11)?0:mFmn11
                 mFmn12= (mFmf12==mFmn12)?0:mFmn12

                 var m = new Object();
                 m.Fsum1=mFsum1;
                 m.Fsum2=mFsum2;
                 m.Fsum3=mFsum3;
                 m.Fsum4=mFsum4;
                 m.Fsum5=mFsum5;
                 m.Fsum6=mFsum6;
                 m.Fsum7=mFsum7;
                 m.Fsum8=mFsum8;
                 m.Fsum9=mFsum9;
                 m.Fsum10=mFsum10;
                 m.Fsum11=mFsum11;
                 m.Fsum12=mFsum12;

                 m.Fmn1=mFmn1;
                 m.Fmn2=mFmn2;
                 m.Fmn3=mFmn3;
                 m.Fmn4=mFmn4;
                 m.Fmn5=mFmn5;
                 m.Fmn6=mFmn6;
                 m.Fmn7=mFmn7;
                 m.Fmn8=mFmn8;
                 m.Fmn9=mFmn9;
                 m.Fmn10=mFmn10;
                 m.Fmn11=mFmn11;
                 m.Fmn12=mFmn12;
                 UpdateTable("SVZPALLM6", m, false, "Fwid="+SVZPALLM6.getValue("Fwid"));

                 SVZPALLM6.MoveNext();
              }   
           }                  


           strSQL = "UPDATE SVZPALLM6 set Fsum14=Fsum1+Fsum2+Fsum3+Fsum4+Fsum5+Fsum6+Fsum7+Fsum8+Fsum9+Fsum10+Fsum11+Fsum12"
           ExecuteSQL(strSQL);

           strSQL = "UPDATE SVZPALLM6 set FMN14=FMN1+FMN2+FMN3+FMN4+FMN5+FMN6+FMN7+FMN8+FMN9+FMN10+FMN11+FMN12"
           ExecuteSQL(strSQL);

           strSQL = "INSERT INTO SVZPALLM3 (" + removeFieldFromList(getColumn("SVZPALLM4",false))+") select " + removeFieldFromList(getColumn("SVZPALLM4",false)) + " FROM SVZPALLM4"  ;
           ExecuteSQL(strSQL);

           //strSQL = "INSERT INTO SVZPALLM3 select * from SVZPALLM5" 
           //ExecuteSQL(strSQL);
           strSQL = "INSERT INTO SVZPALLM3 (" + removeFieldFromList(getColumn("SVZPALLM5",false))+") select " + removeFieldFromList(getColumn("SVZPALLM5",false)) + " FROM SVZPALLM5";
           ExecuteSQL(strSQL);

           //strSQL = "INSERT INTO SVZPALLM3 select * from SVZPALLM6" 
           //ExecuteSQL(strSQL);
           strSQL = "INSERT INTO SVZPALLM3 (" + removeFieldFromList(getColumn("SVZPALLM6",false))+") select " + removeFieldFromList(getColumn("SVZPALLM6",false)) + " FROM SVZPALLM6";
           ExecuteSQL(strSQL);

           SVZPALLM3.Close(5652);

           DropTable("SVZPALLMF")
           strSQL="CREATE TABLE SVZPALLMF (Ftabn_id " + SqlType("INTEGER") 
			  + ",FDAT1 " + SqlType("DATE")+ ",FDAT2 " + SqlType("DATE")
			  +",FWID "+SqlType("COUNTER") + ")"
           ExecuteSQL(strSQL);   
           tsvz = OpenTable("s", "SVZPALLMF");
           tsvz.AddNew();
           tsvz.setValue("Ftabn_id", mFtabn_id);
           tsvz.setValue("Fdat1", mdat1.getVarDate());
           tsvz.setValue("Fdat2", mdat2.getVarDate());
           tsvz.Update();

           tsvz.Close(5652);
}

include("sys/DpList.js");