//include("Objects\\DpPnExt.js");
include("Objects\\DpGetDat.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\udfs.js");
include("sub\\mtr.js");

var label="vbgp";
var tblOut="tmp_"+label;

function listLoad()
{
	with( list )
	{
		title = ru("Выборка по готовой продукции","Вибірка по готовій продукції");
		subAsk = askParam;
		subMake = tbl_refresh;
		subSrc = infSrc;
		//subGrid = gridInit;
		//subPageAgrHead = ttlGridRowPrefix;
		printLabel = "vbgp";
	}

	with (list.objTotal)
	{
		init(label);
	}
	 DataSource().addAccel(GA_CTRL, "D", "FINDDOC");
}

function listMenuInit()
{
	if(list.tbl.getValue("FTT")=="" || list.tbl.getValue("FTT")==null)
	{
		DataSource().AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
		DataSource().AddMenuItem("","");
	}
}

function listMenuRun(cID)
{
	switch(cID)
	{
	case "FINDDOC":
		include("doc\\DpDocPtn.js");
		var t = DataSource().getTable();
		if(t.isRecord())
			FindDocument(t.getValue("fdoc"), t.getValue("fnop"), t.getValue("fwid_h"));
		break;
	case "EDIT":
		include("doc\\DpDoc.js");
		var t = DataSource().getTable();
		if(t.isRecord() && (t.getValue("FTT")=="" || t.getValue("FTT")==null))
		{
			var oDoc = new DpDoc(t.getValue("fdoc"), t.getValue("fnop"));
			oDoc.edit("EDIT",t.getValue("fwid_h"))			
		}
		break;
	}
}

function infSrc()
{
	with( list )
	{
		qrySet( "From", tblOut, "Ptn", "VBGP" );
	}
	addTtlTbl();
	addPnTbl();
}

function askParam()
{
	var gd, arrVariants;
    arrVariants = list.getVariantsArr();
    gd = new DpGetDat(new Array("b","r","T0","N0","p0","m0","s:c0ut","o0","tdnop0"),arrVariants);
    DropTable(tblOut);
	//vlad 06.06.12
	//добавили возможность явно указать (см. listInitGetDatParam())
	/*
    if (extPar && extPar.frtype)
    	gd.frtype = String(extPar.frtype);
    else
    	gd.frtype = null;
    */
	switch (gd.KIND)
	{
		case "1":	//Сырье
			gd.frtype = RTYPE_RS;
			break;
		case "2":	//Готовая продукция
			gd.frtype = RTYPE_PR;
			break;
		case "0":	//Все
		default:
			gd.frtype = null;
			break;
	}
	
	if(IsTable(tblOut))
	{
		 alert(ru("Невозможно выполнить расчет."
				+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 		+"\nили перезапустите систему.",
		 		 "Неможливо виконати розрахунок."
		 		+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
		 		+"\nабо перезапустіть систему."));
		gd.escape = true;
	}
    return gd;
}

//vlad 06.06.12
//Добавим возможность спросить вид строк документа GP
//Ф-ция вызывается, как метод DpGetDat
function listInitGetDatParam()
{
	this.add("RADIO", "Рядки для розрахунку|Строки для расчета", "KIND", 0, ru("Все", "Всі")+"|"+ru("Сырье", "Сировина")+"|"+ru("Готовая продукция", "Готова продукція"));
}


function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix();
	var itogGrp = oPrefix.group()
	var nazv_group = itogGrp.cell("=^Fnmkl?^NM.Fcod +': '  + ^NM.Ftxts:''", "Номенклатура", sizeNmk);		
	list.GroupPage(oGrid, itogGrp, 0, false, nazv_group);
	with (oGrid)
	{
		/*
		with (prefix())
		{
			cell("NM.Ftxts","Наименование",sizeNmk);
		}
		*/
		with(page())
		{
			cell("fcena","Ціна|Цена",GRID_PRI_WDT,null,DP_FORMAT_PRI);
			cell("ffkol","Кількість|Количество",GRID_QNT_WDT,null,DP_FORMAT_KOL);
			cell("ffsumu","Сума|Сумма",GRID_SUM_WDT,null,DP_FORMAT_SUM);
		}
		with(page())
		{
			cell("NM.Fcod","Номенклатура",15);
			cell("Fdate","Дата",12);
			cell("Fcena","Обл. ціна|Уч. цена",GRID_PRI_WDT,null,DP_FORMAT_PRI);
			cell("Fcenapr0","Відп. ціна|Отп. цена",GRID_PRI_WDT,null,DP_FORMAT_PRI);
			cell("Fpok","Пок-к|Пок-ль",6);
			cell("Fpodr","Підр.|Подр.",6);
			cell("Fmol","МВО|МОЛ.",6);
			cell("Fsc","Рах.|Сч.",4);
			cell("Fsu","С/рах.|С/cч.",4);
			cell("Fst","Стат|Стат",4);
			cell("Fio_pol","Хто пер.|Кто пер.",10);
		}
	}
//?	(new DpPnExt()).Load2Grid(oGrid, list.tbl);
	oGrid.build();
}

function tbl_refresh()
{
// - is 7
// + is 5
	var strSql1, mwhere;
	with( list.objAsk )
	{
		mwhere =
			"A.Fdate BETWEEN " + sqlTo(dat1)+ " AND "+sqlTo(dat2)
			+ " AND S.Fdoc='GP' "
			+ sqlw0And("a.fpodr=", fpodr)
			+ sqlw0And("a.fmol=",  fmol)
			+ sqlw0And("a.fsc=",   fsc)
			+ sqlw0And("a.fsu=",   fsu)
			+ sqlw0And("a.fst=",   fst)
			+ sqlw0And("a.Fdoc=", (fdoc!=null && fdoc!=0 && fdoc!="")? fdoc : null)
			// eugene. Нельзя ставить знак ";" в запросах, т.к. тот кто добавляет строки ниже этого не видит
			// а ты потом сидишь в отладке по пол-часа...
			+ sqlw0And("a.Frtype=", frtype)
			+ sqlw0And("s.fnop=", (fnop!=null && fnop!=0 && fnop!="")? fnop : null)
			+ sqlwNmk("A.Fnmkl",   fnmk)
		//NI: Следуя сложившемуся стилю, пришлось переменную sel_fldGroupKey, ...
		//		добавить в mtr.js, как fldGroupKey и т.д.

			strSql1 = "(" + sel_fldGroupKey + "," + sel_fldDocHR + ",Fdate,ffkol,frtype,ffsumu) " +
			"SELECT " + fldGroupKey + "," + fldDocHR
				+ ",A.Fdate as Fdate"
				+ ",a.fkol AS ffkol"
				+ ",A.frtype AS frtype"
				+ ",a.fcena * a.fkol AS ffsumu"
      	var sFrom = " FROM ^ANLTK A INNER JOIN ^SCH_ZAG S ON A.Fid_doc=S.Fwid"
		var sWhere = " WHERE " + mwhere;
		
		if(SUBD==DERBY)
		{
			sFrom = " FROM ^ANLTK a, ^SCH_ZAG s ";
			sWhere += " AND a.Fid_doc=s.Fwid ";			
		}
		strSql1 += sFrom + sWhere;
	}
	
   	CreateTable(tblOut, "VBGP", "fwid");
   	ExecuteSQL("INSERT INTO " + tblOut + " " + strSql1);
}

function objPn_run(isRefExist)
{
	var k = this.tbl.getValue("ffsumU")<0? -1 : 1;
	var fincomu = this.tbl.getValue("ffincomO") / this.tbl.getValue("ffsumU") * 100 * k;
	
	this.tbl.setValue("Fsumnk_pn", 	this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcena_pn"));
	this.tbl.setValue("Fsumsf_pn", 	this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcena_pn"));
    this.tbl.setValue("Fsumnk", 	this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("Fsumsf", 	this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("Fsumprnk", 	this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("Fsumprsf", 	this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("ffkol",	 	this.tbl.getValue("fkolnk")+this.tbl.getValue("fkolsf"));
    this.tbl.setValue("ffsumO", 	this.tbl.getValue("ffkol")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("ffsumU", 	this.tbl.getValue("ffkol")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("ffincomO", 	this.tbl.getValue("ffsumO")-this.tbl.getValue("ffsumU"));
    this.tbl.setValue("ffincomU",	this.tbl.getValue("ffsumU")==0? 0 : fincomu);
}

function listOnPrnList(tv)
{
    var h = new Object();
    h.FD1  = list.objAsk.dat1;
    h.FD2  = list.objAsk.dat2;
    h.FNMKL = list.objAsk.fnmk;
    h.FPODR = list.objAsk.fpodr;
    h.FMOL = list.objAsk.fmol;
    h.FSC = list.objAsk.fsc;
    h.FSU = list.objAsk.fsu;
    h.FST = list.objAsk.fst;
    h.FORG = list.objAsk.forg;
    h.FPOK = list.objAsk.fpok;
    h.FVAL = list.objAsk.fval;
    tv.setHTbl(h);
}

include("sys\\DpList.js");