include("sys\\dplist.js");
include("objects\\DpGetDat.js");
include("objects\\DpGrid.js")

var tblName = "vddb8"

function listAsk()
{
	gd = new DpGetDat(new Array("r", "s:c0ut"));
	
	return gd;
}
 
function listSrc()
{
	this.qrySet( "Cross", tblName
		, "Order", "fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
		);
}

function listMenuInit(ds)
{
	ds.AddMenuItem("OBR", "Раскрыть оборот");
}

function listMenuRun(menuID)
{
	switch(menuID)
	{
		case "OBR":
			var oPar = new Object();
			oPar.dat1 = list.objAsk.dat1;
			oPar.dat2 = list.objAsk.dat2;
			oPar.fdb_sc = list.objAsk.fsc;
			oPar.fdb_su = list.objAsk.fsu;
			oPar.fdb_st = list.objAsk.fst;
			oPar.fcr_sc = Number(list.tbl.getValue("fcr_sc"))
			oPar.fcr_su = Number(list.tbl.getValue("fcr_su"))
			oPar.fcr_st = Number(list.tbl.getValue("fcr_st"))
			oPar.fcr_cod1 = Number(list.tbl.getValue("fcr_cod1"))
			oPar.fcr_cod2 = Number(list.tbl.getValue("fcr_cod2"))
			oPar.fcr_cod3 = Number(list.tbl.getValue("fcr_cod3"))
			showWindow("l_prov.js", SW_NOMODAL, oPar)
			break;
	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	
	//oGrid.defCond("=^fttlevel==1", "tt1")
	//oGrid.color(1, "tt1")
	grid.setColorField("fttlevel")
	
	var oPage = oGrid.page("");


	oPage.fieldEx("=^fcr_sc==9999? 0: ^fcr_sc", "Рах.|Счет", 2, "zn", "%1d")
	oPage.fieldEx("fcr_su", "С/р|С/с", 3, "zn")
	oPage.fieldEx("fcr_st", "Стаття|Статья", 4, "zn")
	oPage.fieldEx("fcr_cod1", "Ан. 1", 5, "zn")
	oPage.fieldEx("fcr_cod2", "Ан. 2", 5, "zn")
	oPage.fieldEx("fcr_cod3", "Ан. 3", 5, "zn")
	oPage.fieldEx("=^fcr_sc==9999? 'РАЗОМ': tfsc('', ^fcr_sc, ^fcr_su, ^fcr_st, ^fcr_cod1, ^fcr_cod2, ^fcr_cod3)", "Найменування|Наименование", 20)
	
	var tCols = OpenTable(
		"SELECT *"
		+ " FROM " + tblName + "_C"
		+ " ORDER BY fquarter, fmonth"
		)
		
	for (; !tCols.IsEOF(); tCols.MoveNext())
	{
		if (tCols.getValue("fquarter")==9)
			oPage.fieldEx(String(tCols.getValue("fcolid")), ru("Итого ", "Разом "), 10, "", DP_FORMAT_SUM)
		else if (tCols.getValue("fmonth")==99)
			oPage.fieldEx(String(tCols.getValue("fcolid")), ru("Итого ", "Разом ") + tCols.getValue("fquarter") + " кв.", 10, "", DP_FORMAT_SUM)
		else 
			oPage.fieldEx(String(tCols.getValue("fcolid")), String(tCols.getValue("fmonth")), 10, "", DP_FORMAT_SUM)
	}
	
	oGrid.build();
}

function listMake()
{
	DropTable(tblName + "_S");

	CreateTable(tblName + "_S", {fvalue: "MONEY"
		, fmonth: "INT", fquarter: "INT"
		, fcr_sc: "INT", fcr_su: "INT", fcr_st: "INT", fcr_cod1: "INT", fcr_cod2: "INT", fcr_cod3: "INT"
		, frowid: "TEXT", fcolid: "TEXT"
		, fttlevel: "INT"
			})
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(s.fsum), " + sqlMonth("fdate") + " AS fmonth "
			+ ", " + Convert("(" + sqlMonth("fdate")+ "-1)/3 + 1", "INT") + " AS fquarter"  // квартал
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", 0"
		+ " FROM ^schet s"
		+ " WHERE fdate BETWEEN " + sqlTo(list.objAsk.dat1) + " AND " + sqlTo(list.objAsk.dat2)
			+ " AND fdb_sc=" + list.objAsk.fsc
			+ sqlw0And("fdb_su=", list.objAsk.fsu)
			+ sqlw0And("fdb_st=", list.objAsk.fst)
			+ " AND fcr_sc BETWEEN 80 AND 89" // 8-й класс
		+ " GROUP BY " + sqlMonth("fdate")
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
		);
	
	
	// Итого по кварталу
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", 99 AS fmonth"
			+ ", fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", 0"
		+ " FROM " + tblName + "_S"
		+ " GROUP BY fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
		)

	// Итого по году
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", 99 AS fmonth"
			+ ", 9 AS fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
			+ ", 0"
		+ " FROM " + tblName + "_S"
		+ " WHERE fmonth<>99"
		+ " GROUP BY fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3"
		)

	// Итоги по аналитие 2
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, 0"
			+ ", 5"
		+ " FROM " + tblName + "_S"
		+ " WHERE fcr_cod1<>0"
		+ " GROUP BY fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2"
		)
		
		
	// Итоги по аналитие 1
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1, 0, 0"
			+ ", 4"
		+ " FROM " + tblName + "_S"
		+ " WHERE fcr_cod1<>0"
		+ " GROUP BY fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, fcr_cod1"
		)
		
		
	// Итоги по статье
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st, 0, 0, 0"
			+ ", 3"
		+ " FROM " + tblName + "_S"
		+ " WHERE fcr_cod1<>0"
		+ " GROUP BY fmonth, fquarter"
			+ ", fcr_sc, fcr_su, fcr_st"
		)
		
	// Итоги по субсчету
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", fcr_sc, fcr_su, 0, 0, 0, 0"
			+ ", 2"
		+ " FROM " + tblName + "_S"
		+ " WHERE fttlevel=0 AND (fcr_st<>0 OR fcr_cod1<>0)"
		+ " GROUP BY fmonth, fquarter"
			+ ", fcr_sc, fcr_su"
		)		
		
	// Итоги по счету
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", fcr_sc, 0, 0, 0, 0, 0"
			+ ", 1"
		+ " FROM " + tblName + "_S"
		+ " WHERE fttlevel=0 AND (fcr_su<>0 OR fcr_cod1<>0)"
		+ " GROUP BY fmonth, fquarter"
			+ ", fcr_sc"
		)			
		
	// Общие итоги 
	ExecuteSQL(
		"INSERT INTO " + tblName + "_S"
			+ "(fvalue, fmonth, fquarter, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel)"
		+ " SELECT SUM(fvalue)"
			+ ", fmonth, fquarter"
			+ ", 9999, 0, 0, 0, 0, 0"
			+ ", 1"
		+ " FROM " + tblName + "_S"
		+ " WHERE fttlevel=0 AND (fcr_su<>0 OR fcr_cod1<>0)"
		+ " GROUP BY fmonth, fquarter"
		)			
		
	ExecuteSQL(
		"UPDATE " + tblName + "_S"
		+ " SET fcolid = " + SqlConCat("'f'", Convert("fquarter*100 + fmonth", "NVC"))
			+ ", frowid = "
				+ SqlConCat(Convert("fcr_sc", "NVC"), sqlTo("/")
						, Convert("fcr_su", "NVC"), sqlTo("/")
						, Convert("fcr_st", "NVC"), sqlTo("/")
						, Convert("fcr_cod1", "NVC"), sqlTo("/")
						, Convert("fcr_cod2", "NVC"), sqlTo("/")
						, Convert("fcr_cod3", "NVC")
						)
		)
		
	DropTable(tblName + "_C")
	ExecuteSQL(
		"SELECT DISTINCT fcolId, fmonth, fquarter"
		+ " INTO " + tblName + "_C"
		+ " FROM " + tblName + "_S"
		)

	DropTable(tblName + "_R")
	ExecuteSQL(
		"SELECT DISTINCT frowid, fcr_sc, fcr_su, fcr_st, fcr_cod1, fcr_cod2, fcr_cod3, fttlevel"
			+ " INTO " + tblName + "_R"
			+ " FROM " + tblName + "_S"
		)
	
}