/*** Формирование вкладышей по пенсионному фонду ***/

include("objects\\DpDefVed.js")
include("objects\\DpGetDat.js");
include("servis\\date.js");

function Raschet()
{
	var DefVed = new DpDefVed();
	var dgd = new DpGetDat("d");
	if (dgd.escape== true)
	{
		return false;
	}
	
	date = sqlTo(firstDayMonth(dgd.dat1));
	
	oSnap = getSnap("SELECT * FROM ^SRED_INI");
	if(oSnap== null)
	{
		alert(ru("Таблица SRED_INI пуста.","Таблиця SRED_INI порожня."));
		return false;
	}

	DefVed.begin("?",ru("Проверка Формирования вкладышей по пенсионному фонду.",
						"Перевірка формування вкладишів по пенсійному фонду."));
	
	DropTable("VKL");
	CreateTable("VKL","VKL_ETA","*");
	
	ExecuteSQL("INSERT INTO VKL (Fwid, Ftabn_id, Fsum, Fdate, Fisall)"
				+ " SELECT "+GetUID()+" as Fwid, Ftabn_id, Fld_stor8 as Fsum,"
					+ date+" as Fdate, "+sqlTrue+" as Fisall"
				+ " FROM ^SRED_INI"
				+ " WHERE"					
					+ " Fld_date="+ date
					//+ " AND Fvid_sr=8"
				);
					
	ExecuteSQL("INSERT INTO VKL (Fwid, Ftabn_id, Fsum, Fdate, Fisall)"
				+ " SELECT "+GetUID()+" as Fwid, Ftabn_id, SUM(Fld_stor8) as Fsum,"
					+ date+" as Fdate,"
					+ sqlFalse+" as Fisall"
				+ " FROM ^SRED_INI"
				+ " WHERE"
					+ " Fld_date="+date
					//+ " AND Fvid_sr=8"
				+ " GROUP BY Ftabn_id");

	DefVed.end();
}

Raschet();