// перенести время из табеля в наряд
include("servis/date.js");

function r_vrtab(fid_nar)
{
	var oSnap = getSnap("SELECT Fbdat FROM ^NAR_KTU WHERE Fwid="+sqlTo(fid_nar));
	if(oSnap!=null)
	{
		mfbdat = new Date(new Date(oSnap[0]).getFullYear(), new Date(oSnap[0]).getMonth(),1 );
		var szTag = getDateTag(mfbdat);
		szName = "zrp_STT1"+szTag;
		siName = "^STT1"+szTag;
		tiName = "^TBL"+szTag;

		if (!IsTableEx("zrp_mdb", szName))
		{
			alert(ru("Не заполнены табеля за ","Не заповнені табеля за ")+szTag)
			return;
		}
		
		//отработанное время
		//обходим ситуацию, когда на 1 запись штатного расписания может быть несколько записей в табелях		
		DropTable("TBLNAR")
		ExecuteSQL("SELECT ki.*, sd.Foklad, ti.Fvsego_ch as Fvsego_cht,"
				+" st.Fis_tabel, tb.Fchasnvk, tb.Fday_nvk into TBLNAR from ^KTU_ISP AS ki "
				+" INNER JOIN ^WORK_PERS AS wp ON ki.Fwid_wp=wp.Fwid"
				+" INNER JOIN ^STRU_DOL AS sd ON wp.Fwid_dol=sd.Fwid"
				+" left JOIN "+siName+" AS st ON ki.Fwid_wp=st.Fwid_wp"
				+" left JOIN "+tiName+" AS tb ON st.Fwid_wp=tb.Fwid_wp"
				+" AND st.Fbdat=tb.Fbdat AND st.Fedat=tb.Fedat AND tb.Fkod_nvk=2"
				+" INNER JOIN ^TBL_INI AS ti ON wp.Fvopl=ti.Fvopl AND ti.Fbdat="+sqlTo(mfbdat)
				+" WHERE ki.Fid="+sqlTo(fid_nar));
	
		ExecuteSQL("update TBLNAR set Fchasnvk=0 where Fchasnvk is null")
		ExecuteSQL("update TBLNAR set Fday_nvk=0 where Fday_nvk is null")
		ExecuteSQL("update TBLNAR set Fday=0 where Fday is null")
		ExecuteSQL("update TBLNAR set Fvsego_ch=0 where Fvsego_ch is null")		
		ExecuteSQL("update TBLNAR set Fvsego_ch=Fvsego_cht where Fis_tabel='*'")
		ExecuteSQL("update TBLNAR set Fvsego_ch=Fchasnvk, Fday=Fday_nvk where Fis_tabel='+'")
		//получить общее отработанное время по табелю на запись штатного расписания (в табеле на нее может быть несколько записей)
		DropTable("TBLNARO")
		ExecuteSQL("SELECT a.Ftabn_id,a.Fwid_wp, "+First("a.Foklad")+" as Foklad, sum(a.Fvsego_ch) as Fvsego_ch, sum(a.Fday) as Fday, sum(a.Fday) as Fnormday, sum(a.Fvsego_ch) as Fnormch"
				+" into TBLNARO from TBLNAR AS a group by a.Ftabn_id, a.Fwid_wp")
		ExecuteSQL("update TBLNARO set Fnormch=0,Fnormday=0")

		//норма времени
		DropTable("TBLNARN")
		ExecuteSQL("SELECT ki.*, sd.Foklad, ti.Fvsego_ch as Fvsego_cht,"
				+" st.Fis_tabel, tb.Fchasnvk, tb.Fday_nvk into TBLNARN from ^KTU_ISP AS ki "
				+" INNER JOIN ^WORK_PERS AS wp ON ki.Fwid_wp=wp.Fwid"
				+" INNER JOIN ^STRU_DOL AS sd ON wp.Fwid_dol=sd.Fwid"
				+" left JOIN "+siName+" AS st ON ki.Fwid_wp=st.Fwid_wp"
				+" left JOIN "+tiName+" AS tb ON st.Fwid_wp=tb.Fwid_wp"
				+" AND st.Fbdat=tb.Fbdat AND st.Fedat=tb.Fedat AND tb.Fkod_nvk=1"
				+" INNER JOIN ^TBL_INI AS ti ON wp.Fvopl=ti.Fvopl AND ti.Fbdat="+sqlTo(mfbdat)
				+" WHERE ki.Fid="+sqlTo(fid_nar));
		
		ExecuteSQL("update TBLNARN set Fvsego_ch=Fvsego_cht where Fis_tabel='*'")
		ExecuteSQL("update TBLNARN set Fvsego_ch=Fchasnvk, Fday=Fday_nvk where Fis_tabel='+'")
		//получить общую норму времени по табелю на запись штатного расписания (в табеле на нее может быть несколько записей)
		DropTable("TBLNARNO")
		ExecuteSQL("SELECT a.Ftabn_id,a.Fwid_wp, "+First("a.Foklad")+" as Foklad, sum(a.Fvsego_ch) as Fvsego_ch, sum(a.Fday) as Fday"
				+" into TBLNARNO from TBLNARN AS a group by a.Ftabn_id, a.Fwid_wp")
				
		ExecuteSQL("update TBLNARO set Fnormday=(select Fday from TBLNARNO where TBLNARO.Ftabn_id=TBLNARNO.Ftabn_id and TBLNARO.Fwid_wp=TBLNARNO.Fwid_wp) where Fvsego_ch=0 and Fday<>0")
		ExecuteSQL("update TBLNARO set Fnormch=(select Fvsego_ch from TBLNARNO where TBLNARO.Ftabn_id=TBLNARNO.Ftabn_id and TBLNARO.Fwid_wp=TBLNARNO.Fwid_wp) where Fvsego_ch=0 and Fday<>0")
		ExecuteSQL("update TBLNARO set Fvsego_ch=Fday/Fnormday*Fnormch where Fvsego_ch=0 and Fday<>0")		

		ExecuteSQL("update ^KTU_ISP set Fvsego_ch=(select "+First("Fvsego_ch")+" from TBLNARO where ^KTU_ISP.Ftabn_id=TBLNARO.Ftabn_id and ^KTU_ISP.Fwid_wp=TBLNARO.Fwid_wp) where Fid="+sqlTo(fid_nar))
	}
	return;
}