include("objects\\DpGetDat.js");
include("get_cnst.js");
include("servis\\format.js");

var dateBegin;
var sum_ogr;
var proc_pns;	
var proc_pns1;	
var gr_pns;
var proc_soc;
var proc_soc1;
var gr_soc;
var proc_zan;
var ds;
var cWhere;
var cField;
var cWhere1;
var cField1;
var cWhere2;
var cField2;
var prnPatt = "ZVZP";
var editAcc = "";
var delFilter = false;
//var oWrap;
var agdMmode;
var tblOut = "TBL";
var sFields;
var t;
var dat1;
var otstup = 6;

//vvs
var isPF = true;
var isFSS = true;
var isFZ = true;
var isFSNV = true;

//vvs !!!
// константа для проставления значения FTTLEVEL
// в ф-циях инкрементируется автоматически.
// Объявлена глобально
var nTTLevel = 0;

// FVP:
// 0 - в текущем за текущий
// 1 - в FMN хранится месяц в каком выплачено
// 2 - в FMN хранится месяц за какой выплачено
// Fis6 - нач./уд.

function listLoad()
{
	with(this)
	{
		title = ru("Выборка по полям лицевого счета","Выборка по полям лицевого счета");
		xmlGridFile = "r_zrpfnds.xml";
		htmlPrnList = "zrpfnds";
		par.menuMode = "CALC";
	}					
}

function listAsk()
{
	var form = createForm(UR("Введіть дані для відбору інформації|Введите данные для отбора информации"));
	var ctrldat1 = form.addObj("dat1","date", "Місяць розрахунку|Месяц расчета");
	ctrldat1.setValue(getPar("GLOBDAT1"));
	var oCheck = form.addObj("ISPF","bool", "Пенсійний фонд|Пенсионный фонд");
	oCheck.setValue(true);
	oCheck = form.addObj("ISFSS","bool", "Фонд соціального страхування|Фонд социального страхования");
	oCheck.setValue(true);
	oCheck = form.addObj("ISFZ","bool", "Фонд страхування на випадок безробіття|Фонд страхования на случай безработицы");
	oCheck.setValue(true);
	oCheck = form.addObj("ISFSNV","bool", "Фонд страхування від нещасного випадку|Фонд страхования от несчастного случая");
	oCheck.setValue(true);
	form.show();

	if (form.escape == true)
		return false;

	dat1 = new Date(form.dat1);
	isPF = form.ISPF;
	isFSS = form.ISFSS;
	isFZ = form.ISFZ;
	isFSNV = form.ISFSNV;

	return form;
}

function listSrc()
{
	with(list)
	{
		qrySet("From","TBLRES","Order","FTTLEVEL, FORDER");
	}	
}

function listMenuInit(obj)
{
}

function listMenuRun(ID)
{
}

function listMake()
{
	if(dat1==null)
		return false;
	// дата начала
	var D1 = new Date(dat1.getFullYear(),dat1.getMonth(),1) 
	// дата конца
	var DD2 = new Date(dat1.getFullYear(),dat1.getMonth()+1,0).getDate() 
	var D2 = new Date(dat1.getFullYear(),dat1.getMonth(),DD2);
	nameSvzp="^SVZP"+month_txt(dat1);
	
	//mode = "PF";
	
	dateBegin = dat1;
	
	tbl_lic=OpenTable("s", "LIC_FLD", "LIC_FID");
	// проинициализируем константы
	sum_ogr		= get_cnst("sum_ogr",dateBegin);
	if(!sum_ogr)
	{
		alert(ru("Не найдена константа суммы ограничения sum_ogr за",
				"Не знайдено константу граничної суми sum_ogr за")+format(" dd.mm.yyyy",dateBegin).toLowerCase());
	}
	proc_pns	= get_cnst("proc_pns",dateBegin);
	proc_pns1	= get_cnst("proc_pns1",dateBegin);
	gr_pns		= get_cnst("gr_pns",dateBegin);
	proc_soc	= get_cnst("proc_soc",dateBegin);
	proc_soc1	= get_cnst("proc_soc1",dateBegin);
	gr_soc		= get_cnst("gr_soc",dateBegin);
	proc_zan	= get_cnst("proc_zan",dateBegin);

	Caption("Звіт по заробітній платні за "+(dat1.getMonth()+1)+"."+dat1.getYear());

	cWhere = "'+','*','&','?'";
	cField = "FIS8";
	cWhere1 = "'+'";
	cField1 = "FIS17";
	cWhere2 = "'+','*','$','%'";
	cField2 = "FIS8";
	cSumOgr = "sum_ogr";
	cProc = "proc_pns";
	cProc1 = "proc_pns1";
	cGran = "gr_pns";
	cIsogr = "pns1000";
	cFldFond = "FIS8";
	cFond = "п";
	nRound = 0;
	
	//vvs 11.05.2004
	// Это константы для Пенсионного с людей
	cWherePFL = "'+','*','&','?'";
	cFieldPFL = "FIS8";
	// Это константы для Пенсионного с предприятия
	cWherePFP = "'+'";
	cFieldPFP = "FIS20";

	// Это константы для ФСС с людей
	var cWhereSSL = "'+'";
	var cFieldSSL = "FIS17";
	// Это константы для ФСС с предприятия
	var cWhereSSP = "'+'";
	var cFieldSSP = "FSOC";

	//vvs 11.05.2004
	// Это константы для ФЗ с людей
	var cWhereFzl = "'+','*','$','%'";
	var cFieldFzl = "FIS8";
	// Это константы для ФЗ с предприятия
	var cWhereFzp = "'+'";
	var cFieldFzp = "FIS23";

	// Это константы для ФСНВ с предприятия
	var cWhereFNP = "'+'";
	var cFieldFNP = "FNSL";
	
	//результирующая таблица
	DropTable("TBLRES");
	strSQL = "CREATE TABLE TBLRES ("
	+" FTTLEVEL " + SqlType("LONG") + ","
	+" FORDER " + SqlType("LONG") + ","	// Для упорядочивания в пределах одного FTTLEVEL'а
	+" FTXT " + SqlType("TEXT", 250) + ","
	+" FTABN " + SqlType("LONG") + ","
	+" FTABN_ID " + SqlType("LONG") + ","
	+" FIO " + SqlType("TEXT", 250) + ","
	+" FLSFID " + SqlType("LONG") + ","
	+" FSUM " + SqlType("CURRENCY") + ","
	+" FTT " + SqlType("TEXT", 4) + ","
	+" FWID " + SqlType("TEXT", 12) + ""
	+" )"
	ExecuteSQL(strSQL);
	
	//всего начислено
	nTTLevel++;
	strSQL = "INSERT INTO TBLRES(FTTLEVEL,FORDER,FTXT,FSUM,FTT)"
	+" SELECT "
		+sqlTo(nTTLevel)+" AS FTTLEVEL,"
		+" 0 AS FORDER,"
		+" 'Всього нараховано' as FTXT,"
		+" SUM(S.FSUM) AS FSUM,"
		+" 'VNTT' AS FTT"
	+" FROM "
		+nameSvzp+" S,"
		+" ^LIC_FLD L"
	+" WHERE"
		+" S.FLSFID = L.FID"
		+" AND L.FIS6='н'"
	ExecuteSQL(strSQL);

	if(isPF)
	{
		// Для пенсионного фонда
		//Зарплата инвалидов
		DropTable("INVAL");
		strSQL = "SELECT DISTINCT"
		+" crc.fcod AS FTABN,"
		+" wp.fwid_cl AS FTABN_ID,"
		+" wp_cl.ftxt AS FNAM_LEV"
		+" INTO INVAL"
		+" FROM ((^work_pers AS wp "
			+ " LEFT JOIN ^cl AS wp_cl ON wp.fwid_cl=wp_cl.fwid) "
			+ " LEFT JOIN ^clrelclcl AS crc ON wp.fwid_cl=crc.fwid_cl)"
		+" WHERE wp.FINVAL = " + sqlTrue
        +" AND "
        +" ("
            +" wp.FBDAT <= "+sqlTo(D1)
            +" AND wp.FEDAT >= "+sqlTo(D2)
            +" OR "
            +" ("
            	+" wp.FBDAT <= "+sqlTo(D1)
            	+" AND wp.FEDAT Between "+sqlTo(D1)+" AND "+sqlTo(D2)
            +" )"
            +" OR"
            +" ("
            	+" wp.FBDAT Between "+sqlTo(D1)+" AND "+sqlTo(D2)
            	+" AND wp.FEDAT >= "+sqlTo(D2)
            +" )"
        +" )"
		ExecuteSQL(strSQL);
		
		// ЗП інвалідів
		AddExtraSums("T:INVAL", 0, "INTT", "IN", cFieldPFP, cWherePFP, "ЗП інвалідів (база обкл. пенс.фондом)");

		//превышение 2660
		AddExtraSums("-", sum_ogr, "PRTT", "PR", cFieldPFP, cWherePFP, "Суми перевищення бази обкл. пенс.фондом межі "+sum_ogr+" грн.");
		//превышение 2660 в т.ч. Инвалидов инвалидов
		AddExtraSums("-T:INVAL", sum_ogr, "PRIT", "PRI", cFieldPFP, cWherePFP, "В т.ч. для інвалідів суми перевищення бази обкл. пенс.фондом межі "+sum_ogr+" грн.");

		//Суммы входящие в базу обложения пенсионным фондом
		AddRows("", "PFTT", "PF", cFieldPFP, cWherePFP, "Суми (ФЗП) які входять в базу обкладення ПФ")
		//Суммы не входящие в базу обложения пенсионным фондом
		AddRows("N", "PFTT", "PF", cFieldPFP, cWherePFP, "Суми (ФЗП) які не входять в базу обкладення ПФ")
	}	// end of if(isPF)

	if(isFSS){
		// фонд социального страхования
		//Суммы (работники) входящие в базу обложения фондом социального страхования
		AddRows("", "SLTT", "SL", cFieldSSL, cWhereSSL, "Суми (працівники) які входять в базу обкладення соцстрахом")

		//Суммы ФЗП входящие в базу обложения фондом социального страхования
		AddRows("", "SPTT", "SP", cFieldSSP, cWhereSSP, "Суми (ФЗП) які входять в базу обкладення соцстрахом")

		//превышение 2660
		AddExtraSums("-", sum_ogr, "SPPT", "SPP", cFieldFzp, cWhereFzp, "Суми перевищення бази обкл.ф.соц.страху межі "+sum_ogr+" грн.");

		//Суммы (работники) не входящие в базу обложения фондом социального страхования
		AddRows("N", "SLNT", "SLN", cFieldSSL, cWhereSSL, "Суми (працівники) які не входять в базу обкладення соцстрахом")
		//Суммы ФЗП невходящие в базу обложения фондом социального страхования
		AddRows("N", "SPNT", "SPN", cFieldSSP, cWhereSSP, "Суми (ФЗП) які не входять в базу обкладення соцстрахом")
	}	// end of if(isFSS)

	if(isFZ){
		// фонд занятости
		//Суммы входящие в базу обложения фондом занятости с Предприятия
		AddRows("", "ZPTT", "ZP", cFieldFzp, cWhereFzp, "Суми (ФЗП) які входять в базу обкл.ф.зайн.")
		//превышение 2660
		AddExtraSums("-", sum_ogr, "ZPNT", "ZPN", cFieldFzp, cWhereFzp, "Суми перевищення бази обкл.ф.зайн. межі "+sum_ogr+" грн.");

		//Суммы входящие в базу обложения фондом занятости с работников
		AddRows("", "ZLTT", "ZL", cFieldFzl, cWhereFzl, "Суми (працівники) які входять в базу обкл.ф.зайн.")
		//Суммы НЕ входящие в базу обложения фондом занятости с Предприятия
		AddRows("N", "ZPNT", "ZPN", cFieldFzp, cWhereFzp, "Суми (ФЗП) які не входять в базу обкл.ф.зайн.")
		//Суммы НЕ входящие в базу обложения фондом занятости с работников
		AddRows("N", "ZLNT", "ZLN", cFieldFzl, cWhereFzl, "Суми (працівники) які не входять в базу обкл.ф.зайн.")
	}	//end of if(isFZ)

	if(isFSNV){
		// фонд страхования от несчастного случая
		//Суммы входящие в базу обложения ФСНВ с Предприятия
		AddRows("", "NPTT", "NP", cFieldFNP, cWhereFNP, "Суми (ФЗП) які входять в базу обкл. ФСНВ")
		//превышение 2660
		AddExtraSums("-", sum_ogr, "NPPT", "NPP", cFieldFNP, cWhereFNP, "Суми перевищення бази обкл. ФСНВ межі "+sum_ogr+" грн.");
		//Суммы НЕ входящие в базу обложения ФСНВ с Предприятия
		AddRows("N", "NPNT", "NPN", cFieldFNP, cWhereFNP, "Суми (ФЗП) які не входять в базу обкл. ФСНВ")
	}	//end of if(isFSNV)
/*
	var t = OpenTable("s","TBLRES");
	
	if(!t.isEmpty())
		t.MoveFirst();
	
	for(; !t.IsEOF(); t.MoveNext()){
		t.Edit();
		t.setValue("FWID", GetUID());
		t.Update();
	}
	t.Close(5652);
*/	
}

// стандартное добавление строк.
// mode "N" - Значит сумммы НЕ входящие
// sttt - значение для поля FTT в строке итого
// sttr - значение для поля FTT в строках сум по ЛС
function AddRows(mode, sttt, sttr, sField, sValList, sTTTxt)
{
	var isNot = mode=="N";
	
	nTTLevel++;
		
	strSQL = "INSERT INTO TBLRES(FTTLEVEL,FORDER,FTXT,FSUM,FTT)"
	+" SELECT "
		+sqlTo(nTTLevel)+" AS FTTLEVEL,"
		+" 0 AS FORDER,"
		+sqlTo(sTTTxt)+" AS FTXT,"
		+" SUM(S.FSUM) AS FSUM,"
		+sqlTo(sttt)+" AS FTT"
	+" FROM "
		+nameSvzp+" S,"
		+" ^LIC_FLD L"
	+" WHERE"
		+" L."+sField+(isNot? " NOT ": "")+" IN("+sValList+")"
		+" AND L.FID = S.FLSFID"
		+" AND L.FIS6 = '+'"
	ExecuteSQL(strSQL);

	strSQL = "INSERT INTO TBLRES(FTTLEVEL,FORDER,FTXT,FLSFID,FSUM,FTT)"
	+" SELECT "
		+sqlTo(nTTLevel)+" AS FTTLEVEL,"
		+" L.FFLD_NUM AS FORDER,"
		+SqlConCat(sqlTo(strRepl(" ", otstup)),Convert("L.FTXT", "STR")) + " AS FTXT,"
		+" L.FID AS FLSFID,"
		+" SUM(S.FSUM) AS FSUM,"
		+sqlTo(sttr)+" AS FTT"
	+" FROM "
		+nameSvzp+" S,"
		+" ^LIC_FLD L"
	+" WHERE"
		+" L."+sField+(isNot? " NOT ": "")+" IN("+sValList+")"
		+" AND L.FID = S.FLSFID"
		+" AND L.FIS6 = '+'"
	+" GROUP BY "
		+" L.FID,"
		+" L.FTXT,"
		+" L.FFLD_NUM"
	ExecuteSQL(strSQL);
}

// mode "-" - Значит сумммы превышения
// mode "T:TABLE" - Значит сумммы превышения только для людей,
// табельные номера к-х находятся в т-це TABLE
// стандартное добавление строк по людям с превышениями.
// mode - не задействован
// sumOgr - сумма-порог
// sttt - значение для поля FTT в строке итого
// sttr - значение для поля FTT в строках сум по ЛС
// sField	Имя поля из ^LIC_FLD, в котором будем проверять условие вхождения суммы
// sValList	Список значений из поля sField, для которых накопим сумму
// sTTTxt - текстовка в итоговой строке с FTT==sttt
// В неитоговых строках добавляем людей
function AddExtraSums(mode, sumOgr, sttt, sttr, sField, sValList, sTTTxt)
{
	nTTLevel++;

	var sTblName = "";
	var isTbl = false;
	var isPrev = strIn("-", mode);
	
	mode = mode.replace(/\-/gi,"");
	
	if(mode.substr(0, 2).toUpperCase()=="T:"){
		isTbl = true;
		// Имя т-цы с табельными номерами людей
		sTblName = mode.substr(2);
	}


	// По людям
	strSQL = "INSERT INTO TBLRES(FTTLEVEL,FORDER,FTXT,FSUM,FTT)"
	+" SELECT "
		+sqlTo(nTTLevel)+" AS FTTLEVEL,"
		+" R.fcod AS FORDER,"
		+SqlConCat(sqlTo(strRepl(" ", otstup)), Convert("R.fcod", "STR", 7), sqlTo(":"), "C.FTXT")
		+", ( SUM(S.FSUM)-"+sqlTo(sumOgr)+") AS FSUM,"
		+sqlTo(sttr)+" AS FTT"
	+" FROM "
		+(isTbl? "(" : "")
		+" ((("+nameSvzp+" S "
		+(isTbl? " INNER JOIN "+sTblName+" ttttt ON S.ftabn_id=ttttt.FTABN_ID)" : "")
		+" LEFT JOIN ^CLRELCLCL R ON S.FTABN_ID=R.FWID_CL)"
		+" LEFT JOIN ^CL C ON R.FWID_CL = C.FWID )"
		+" LEFT JOIN ^LIC_FLD L ON L.FID = S.FLSFID"
		+")"
	+" WHERE"
		+" L."+sField+" IN("+sValList+")"
		+" AND L.FIS6 = '+'"
		+" AND R.FCL="+sqlTo(getPar("CODPERS"))
	+" GROUP BY "
		+" R.fcod,"
		+" C.FTXT"
	+(isPrev ?  " HAVING SUM(S.FSUM) > " + sqlTo(sumOgr) : "")
	ExecuteSQL(strSQL);
	
	// Итого
	strSQL = "INSERT INTO TBLRES(FTTLEVEL,FORDER,FTXT,FSUM,FTT)"
	+" SELECT "
		+sqlTo(nTTLevel)+" AS FTTLEVEL,"
		+" 0 AS FORDER,"
		+sqlTo(sTTTxt)+" AS FTXT,"
		+" SUM(S.FSUM) AS FSUM,"
		+sqlTo(sttt)+" AS FTT"
	+" FROM "
		+"TBLRES S"
	+" WHERE"
		+" S.FTT="+sqlTo(sttr)
	ExecuteSQL(strSQL);
}

include("sys\\DpList.js");