﻿function r_zrrsp(par, dat1, dat2)
{
	mmFsc     = par.mmFsc;
	mmFsu     = par.mmFsu;
	mmFst     = par.mmFst;
	mmFcl1    = par.mmFcl1;
	mmFcl2    = par.mmFcl2;
	mmFcl3    = par.mmFcl3;
	mmFsc_to  = par.mmFsc_to;
	mmFsu_to  = par.mmFsu_to;
	mmFst_to  = par.mmFst_to;
	mmFcl1_to = par.mmFcl1_to;
	mmFcl2_to = par.mmFcl2_to;
	mmFcl3_to = par.mmFcl3_to;
	mmFnom    = par.mmFnom;
	
	israsch = true;

	//////////////////////////////////////////////////////////
	//super vv 21.12.01
	// теперь смотрим на номер аналитик
	tcl_schet = OpenTable("m", "CL_SCHET","U0");

	// номера спр-ков аналитик счета, к-й закрываем
	var mCl1=0, mCl2=0, mCl3=0;
	// номера спр-ков аналитик счета, на к-й закрываем
	var mCl1_to=0, mCl2_to=0, mCl3_to=0;

	// выберем из плана счетов
	var oSnap = getSnap(
				"SELECT Fcl1,Fcl2,Fcl3 FROM ^cl_schet WHERE"
				+ " Fschet=" + sqlTo(mmFsc)
				+ " AND Fsubschet=" + sqlTo(mmFsu)
				+ " AND Fstat=" + sqlTo(mmFst));
	if (oSnap != null)
	{
		mCl1 = oSnap[0];
		mCl2 = oSnap[1];
		mCl3 = oSnap[2];
	}
	oSnap = null;
	
	oSnap = getSnap(
			"SELECT Fcl1, Fcl2, Fcl3 FROM ^cl_schet WHERE"
			+ " Fschet=" + sqlTo(mmFsc_to)
			+ " AND Fsubschet=" + sqlTo(mmFsu_to)
			+ " AND Fstat=" + sqlTo(mmFst_to));
	if (oSnap != null)
	{
		mCl1_to = oSnap[0];
		mCl2_to = oSnap[1];
		mCl3_to = oSnap[2];
	}
	oSnap = null;

	// номер спр-ка аналитики счета, к-й закрываем, соответствующий
	// номеру спр-ка 1-й аналитики, на к-й закрываем
	//var nCl1 = (mCl1_to == 0 ? 0 : (mCl1_to == mCl1 ? 1 : (mCl1_to == mCl2 ? 2 : (mCl1_to == mCl3 ? 3 : 0))));
	var nCl1 = (mCl1_to == mCl1) ? 1 : ((mCl1_to == mCl2) ? 2 : ((mCl1_to == mCl3) ? 3 : 0));
	
	// номер спр-ка аналитики счета, к-й закрываем, соответствующий
	// номеру спр-ка 2-й аналитики, на к-й закрываем
	//var nCl2 = (mCl2_to == 0 ? 0 : (mCl2_to == mCl1 ? 1 : (mCl2_to == mCl2 ? 2 : (mCl2_to == mCl3 ? 3 : 0))));
	var nCl2 = (mCl2_to == mCl1) ? 1 : ((mCl2_to == mCl2) ? 2 : ((mCl2_to == mCl3) ? 3 : 0));
	
	// номер спр-ка аналитики счета, к-й закрываем, соответствующий
	// номеру спр-ка 1-й аналитики, на к-й закрываем
	//var nCl3 = (mCl3_to == 0 ? 0 : (mCl3_to == mCl1 ? 1 : (mCl3_to == mCl2 ? 2 : (mCl3_to == mCl3 ? 3 : 0))));
	var nCl3= (mCl3_to == mCl1)? 1 :((mCl3_to == mCl2) ? 2 :((mCl3_to == mCl3) ? 3 : 0));

	//////////////////////////////////////////////////////////
	
	//вопрос с запросом кода аналитического учета
	TrnNBln("3n", "ZRSC_", dat1, dat2, new DpSc(mmFsc,mmFsu,mmFst, mmFcl1));
	TrnNBln("3n", "ZRTO_", dat1, dat2, new DpSc(mmFsc_to,mmFsu_to,mmFst_to, mmFcl1_to));
	
	var cdt1 = StrDat(dat1, "DMY");
	var cdt2 = StrDat(dat2, "DMY");
	
	tz    = OpenTable("SCHET_ZR");
	tsc   = OpenTable("ZRSC_");   // счет откуда 

	for( tsc.MoveFirst(); !tsc.IsEOF(); tsc.MoveNext())
	{
		sum_db = toScrObj(tsc.getValue("FSUM3"));
		
		mmFsc = toScrObj(tsc.getValue("FSC"));
		mmFsu = toScrObj(tsc.getValue("FSU"));
		mmFst = toScrObj(tsc.getValue("FST"));
		mmFcl1= toScrObj(tsc.getValue("FCL_COD1"));
		mmFcl2= toScrObj(tsc.getValue("FCL_COD2"));
		mmFcl3= toScrObj(tsc.getValue("FCL_COD3"));
		
		sum_ = toScrObj(tsc.getValue("FSUM3"));
		
		toFsc = mmFsc_to;
		toFsu = mmFsu_to;
		toFst = mmFst_to;
		
		toFcl1= nCl1==1 ? mmFcl1 :(nCl1==2 ? mmFcl2 :(nCl1==3 ? mmFcl3 : mmFcl1_to));
		toFcl2= nCl2==1 ? mmFcl1 :(nCl2==2 ? mmFcl2 :(nCl2==3 ? mmFcl3 : 0));
		toFcl3= nCl3==1 ? mmFcl1 :(nCl3==2 ? mmFcl2 :(nCl3==3 ? mmFcl3 : 0));

		strWait = mmFsc+"/"+mmFsu+"/"+mmFst+"/"+mmFcl1+"/"+mmFcl2+"/"+mmFcl3
		+" --> "+toFsc+"/"+toFsu+"/"+toFst+"/"+toFcl1+"/"+toFcl2+"/"+toFcl3;
		WAIT(strWait)

		var m = new Object();
		m.FWID = GetUID();
		m.Ftxt = 'Закрывающая проводка RASP'+String(mmFnom);
		m.Fdb_sc = toFsc;
		m.Fdb_su = toFsu;
		m.Fdb_st = toFst;
		m.Fdb_cod1 = toFcl1;
		m.Fdb_cod2 = toFcl2;
		m.Fdb_cod3 = toFcl3;
		m.Fcr_sc = mmFsc;
		m.Fcr_su = mmFsu;
		m.Fcr_st = mmFst;
		m.Fcr_cod1 = mmFcl1;
		m.Fcr_cod2 = mmFcl2;
		m.Fcr_cod3 = mmFcl3;
		m.Fsum = sum_;
		m.Fdate = dat2;
		m.Fval = 0;
		m.Fsumspr = 0;
		m.Fvalspr = 0;
		m.Fdocvid = 'закр.';
		m.Fdocnum = "12345";
		m.Fwrk = 15;
		m.Fuser = 0;
		m.Fvkurs = 0;
		m.Forg0 = Number(CURRENT_ORG);
		
		UpdateTable("^SCHET_ZR", m, true);
	}
	
	tcl_schet.close(5652);
	tcl_schet = null;
	
	tz.close(5652);
	tz = null;
	
	tsc.close(5652);
	tsc = null;
	
	CLEARWAIT();
}