//Расценивание отрицательных остатков

include("objects\\DpDefVed.js")
include("sys\\kolr.js")
include("sys\\dbase.js")
include("servis\\date.js")
include("objects\\DpGetDat.js")
include("objects\\DpNmkl.js")
include("mtr_ost.js")
include("sys\\servis.js")
include("doc\\nakl\\DpHonr.js")
include("sys\\udfs.js");

/* ES, description
1. tbl - таблица с остатками на день расчета (положит и отрицат)
2. OTR_ANLTK_table - SELECT * FROM tbl WHERE FEKOL<0 and AND FBKOL>=0
	(записи из таблицы с остатками(tbl), которые ушли в минус)
	fekol = OTR_ANLTK_table.getValue("Fekol")
3. tmp_tbl - расходные записи из таблицы anltk на текущий день
4. ANLTK_table - tmp_tbl, отсортированная по количеству DESC
	kol = ANLTK_table.getValue("Fkol")
	kol2rasc = min(kol, -fekol);
5. ADD_ANLTK_table = "SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(ANLTK_table.getValue("Fwid"))
6. POL_ANLTK_table - записи из  таблицы tbl по цепочке ANLTK_table(fnmkl, fpodr, fmol...) где fekol>0
	pol_kol = POL_ANLTK_table.getValue("Fekol")
7. COUNT_POL_ANLTK_table - SUM(FEKOL) из POL_ANLTK_table (исспользуется для проверки)
*/

var nTraysCount = 5;
var rows4gpArray = new Array();

function onLoad()
{
	var objAsk = new DpGetDat(new Array("N0","p0","m0","s:c0ut","r","rsplit","fast","samecena", "tdnop0")); //Еще добавить "Разбивать расходы?"
	if (true == objAsk.escape)
		return false;

	rascost(objAsk);
	return false;
}

function rascost(par)
{
	rows4gpArray = new Array();
	
	var extraWhereExpr = "";
	var str_fid_doc = "";
	var DefVed = new DpDefVed();
	var gd;
	var bIsImportFromTetra = false;
	var isCreateGP = true;
	if (typeof(par)!="undefined" && par!=null)
	{
		gd = new Object();
		if(typeof(par.fnmk)!="undefined")
			gd.fnmk = par.fnmk;
		if(typeof(par.fpodr)!="undefined")
			gd.fpodr = par.fpodr;
		if(typeof(par.fmol)!="undefined")
			gd.fmol = par.fmol;
		if(typeof(par.fsc)!="undefined")
			gd.fsc = par.fsc;
		if(typeof(par.fsu)!="undefined")
			gd.fsu = par.fsu;
		if(typeof(par.fst)!="undefined")
			gd.fst = par.fst;
		if(typeof(par.dat1)!="undefined")
			gd.dat1 = par.dat1;
		if(typeof(par.dat2)!="undefined")
			gd.dat2 = par.dat2;
		if(typeof(par.rsplit)!="undefined")
			gd.rsplit = par.rsplit;
		if(typeof(par.rsfast)!="undefined")
			gd.rsfast = par.rsfast;
		if(typeof(par.rssamecena)!="undefined")
			gd.rssamecena = par.rssamecena;
		if(typeof(par.extraWhere)!="undefined")
			extraWhereExpr = par.extraWhere;
		if(typeof(par.fid_doc)!="undefined")
			str_fid_doc = par.fid_doc;
		if(typeof(par.nTraysCount)!="undefined")
			nTraysCount = par.nTraysCount;
		if(typeof(par.bImportFromTetra)!="undefined")
			bIsImportFromTetra = par.bImportFromTetra;
		if(typeof(par.fdoc)!="undefined")
			gd.fdoc = par.fdoc;
		if(typeof(par.fnop)!="undefined")
			gd.fnop = par.fnop;
	}
	else
	{
		gd = new DpGetDat(new Array("N0","p0","m0","s:c0ut","r","rsplit","fast","samecena", "tdnop0")); //Еще добавить "Разбивать расходы?"
		if (gd.escape)
			return;
	}

	var honr;
	if (typeof(par)!="undefined" && par!=null)
		if(typeof(par.honr)!="undefined")
			honr = par.honr;
	else
		honr = new DpHonr()

	var nmk  = gd.fnmk;
	var podr = gd.fpodr;
	var mol  = gd.fmol;
	var sc   = gd.fsc;
	var su   = gd.fsu;
	var st   = gd.fst;
	var dat1 = gd.dat1;
	var dat2 = gd.dat2;
	var razbiv  = gd.rsplit;
	var isLight = gd.fast;
	
  	if (gd.fdoc != null && String(gd.fdoc) != "")
  	{
  		extraWhereExpr += (extraWhereExpr? " AND": "")
  			+ "(a.fdate<" + sqlTo(dat2)
  				+ " OR (a.fdoc=" + sqlTo(gd.fdoc)
  					//+ sqlw0And("a.fnop=", Number(gd.fnop))
			+ "))"  				
  	}
  
	var msg00 = ru("Расценивание отрицательных остатков","Розцінення від'ємних залишків");
	msg00 += format(" началось dd-mm-yyyy th:tm:ts", Date());
	DefVed.begin("",msg00);

	var honr = new DpHonr()

	// Кол-во попыток рассчитать одно и то-же число
	var nTrays=0;

	var step = 0;

	var repeatDay = true;

	var nSteps = day_difference(new Date(dat2),new Date(dat1))+2;
	var nStep = 0;
	
	//setProgressRange(0, nSteps);	
	//Идем циклом по датам
	for(var curDate = new Date(isLight? dat2: dat1);differ(curDate,dat2) <= 0; curDate = goDay(curDate,1))   
	{
		cMsg = format("dd.mm.yyyy", curDate)+ (nTrays? " шаг " + (nTrays+1): "");
		DefVed.write(cMsg);
//		setProgressPos(++nStep, cMsg)
		repeatDay = false;

		//WAITTIMER(format("dd.mm.yyyy", curDate))
		__noWait = true;
		var tbl;
		// рассчитываем остатки на день расчета
		with(o=new DpMtrOb())
		{
			if(!isLight)
				date1   = curDate;
			else
				date1	= dat1;
			pattern = "obr";
			date2   = curDate;
			fnmkl   = nmk;
			fpodr   = podr;
			fmol    = mol;
			fsc     = sc;
			fsu     = su;
			fst     = st;
			fis_otl = false;
			extraWhere = extraWhereExpr;// + " (fid_pn=0 or fid_pn is null)";
			doCalc();
			tbl = tblName;
		}

		//browse("select fnmkl, fpodr, fmol, fsc, fsu, fid_pn, fpost, fekol, fcena from " + tbl + " order by fnmkl, fpodr, fmol, fsc, fsu")
		//return;

		DefVed.write("рассчитались обороты по дню");
		ExecuteSQL("CREATE INDEX chain on " + tbl + " (FNMKL, FPODR, FMOL, FSC, FSU)")
		ExecuteSQL("CREATE INDEX fekol on " + tbl + " (FEKOL)")

		//ExecuteSQL("ALTER TABLE " + tbl +" ADD FWID "+ SqlType("COUNTER"));

		var OTR_ANLTK_table = OpenTable("s",
			s="SELECT *"
			+ " FROM " + tbl
			+ " WHERE FEKOL<0"
				//+ " AND FBKOL>=0"
			+ " ORDER BY FEKOL DESC"
			);
		var recc = Number(OTR_ANLTK_table.recordCount);
		
		var OTR_ANLTK_table_array = new Array();
		var idx = 0;
		for(;!OTR_ANLTK_table.IsEOF() && recc != 0;OTR_ANLTK_table.MoveNext(), idx++)
		{
		    var obj = new Object();
			obj.Fnmkl = toScrObj(OTR_ANLTK_table.getValue("Fnmkl"));
			obj.Fcena = toScrObj(OTR_ANLTK_table.getValue("Fcena"));
			obj.Fpodr = toScrObj(OTR_ANLTK_table.getValue("Fpodr"));
			obj.Fmol = toScrObj(OTR_ANLTK_table.getValue("Fmol"));
			obj.Fsc = toScrObj(OTR_ANLTK_table.getValue("Fsc"));
			obj.Fsu = toScrObj(OTR_ANLTK_table.getValue("Fsu"));
			obj.Fst = toScrObj(OTR_ANLTK_table.getValue("Fst"));
		    obj.Fpost = toScrObj(OTR_ANLTK_table.getValue("Fpost"));
			obj.Fid_pn = toScrObj(OTR_ANLTK_table.getValue("Fid_pn"));
			obj.Fekol = toScrObj(OTR_ANLTK_table.getValue("Fekol"));			
		    
    		OTR_ANLTK_table_array[idx] = obj;
    	}
		
		step = 0;
		setProgressRange(0, recc);
		DefVed.write("Необходимо расценить " + recc + " отрицательных остатков");
		for(idx = 0; idx < recc; idx++)
		{
			step++;
			if (step %10 == 0)
			{
    			//WAIT(step + "/" + recc);
			    setProgressPos(step, cMsg + ": " + step + "/" + recc)
			}
			if (step>recc)
			{
			    alert("OTR_ANLTK_table!!!!!!!!!!!!!!!");
			    return;			    			
			}
			
			var fekol = round(Number(OTR_ANLTK_table_array[idx].Fekol),prmDecKol)
			
			//DefVed.write("Шаг " + step + " Остаток=" + fekol + ":" + showChain(OTR_ANLTK_table));
			
			// Выбираем из ANLTK цепочку по которой был перерасход на дату расчета
			var tmp_tbl = getTmpTableName();			
			
			var ANLTK_table = OpenTable(s="SELECT *"
			+ " FROM ^anltk"
			+ " WHERE (Frtype=" + sqlTo(RTYPE_RS)
					+" OR Frtype=" + sqlTo(RTYPE_PMR)
					+ ")"
				+ " AND Fnmkl="+sqlTo(OTR_ANLTK_table_array[idx].Fnmkl)
				+ " AND fcena="+sqlTo(OTR_ANLTK_table_array[idx].Fcena)
				+ " AND fpodr="+sqlTo(OTR_ANLTK_table_array[idx].Fpodr)
				+ " AND fmol="+sqlTo(OTR_ANLTK_table_array[idx].Fmol)
				+ " AND fsc="+sqlTo(OTR_ANLTK_table_array[idx].Fsc)
				+ " AND fsu="+sqlTo(OTR_ANLTK_table_array[idx].Fsu)
				+ " AND fst="+sqlTo(OTR_ANLTK_table_array[idx].Fst)
				+ " AND fpost="+sqlTo(OTR_ANLTK_table_array[idx].Fpost)
				+ (OTR_ANLTK_table_array[idx].Fid_pn == null
					? " AND fid_pn is null"
					: " AND fid_pn="+sqlTo(OTR_ANLTK_table_array[idx].Fid_pn) 
					)
				+ (isLight
					? " AND Fdate>=" + sqlTo(dat1) + " AND Fdate<="+sqlTo(curDate)
					: " AND Fdate="+sqlTo(curDate))
//					+ " AND fdoc <> 'VP' AND fdoc<>'VM'"
				+ str_fid_doc
				+ (gd.fdoc != null ? sqlw0And("fdoc=", String(gd.fdoc)) : "")
			+ " ORDER BY " + IIF("fdoc='VP' or fdoc='VM'","0","1")
				+ (isLight?  ", fdate DESC": ", fkol DESC")
			);
					
			var ADD_ANLTK_table;

			var t = OpenTable("s",
		 		s="SELECT SUM(FEKOL) AS SUMMA"
				+ " FROM " + tbl
				+ " WHERE fnmkl="+sqlTo(ANLTK_table.getValue("Fnmkl"))
					+ " AND fpodr="+sqlTo(ANLTK_table.getValue("Fpodr"))
					+ " AND fmol="+sqlTo(ANLTK_table.getValue("Fmol"))
					+ " AND fsc ="+sqlTo(ANLTK_table.getValue("Fsc"))
					+ " AND fsu ="+sqlTo(ANLTK_table.getValue("Fsu"))
					+ " AND fst ="+sqlTo(ANLTK_table.getValue("Fst"))
					+ " AND fekol>0"
//				+ " HAVING SUM(fekol)>="+sqlTo((kol2rasc))
				);
						
			// Пока количество перерасхода <0 будем брать этот расход и переносить его в
			// другие цепочки
			for(; (!ANLTK_table.IsEOF()) && (fekol < 0); ANLTK_table.MoveNext())
			{
				DefVed.write("Нашли "+ showAnltk(ANLTK_table));

				//Количество перерасхода которое нужно переразнести
				var kol = round(Number(ANLTK_table.getValue("Fkol")),prmDecKol)  
				
				// Если отрицательный остаток больше расхода в этой строке - расцениваем количество из строки,
				// иначе расцениваем весь остаток
				var kol2rasc = Math.min(kol, -fekol);
				DefVed.write("Расценивам кол-во " + kol2rasc);

				/*
				if(t.getValue("summa")==null || t.getValue("summa") < kol2rasc)
				{
 		 			er_str1 = ru("Не удастся перенести расход: ","Не можна перенести витрати: ");
 					er_str2 = ru("Суммарный приход: ","Сумарні прибутки: ");
					DefVed.write(er_str1+(-fekol),"ANLTK",ANLTK_table.getValue("Fwid"))
					continue;  //Данную цепочку разнести не удалось
				}
				*/

				/*
				if(t==null || t.getValue("summa")==null || t.getValue("summa") < kol2rasc)  //Разнести остаток не удастся (сумма всех приходов не может покрыть отрицательный остаток)
 				{
 		   			er_str1 = ru("Не удастся разбить расход: ","Не можна розбити витрати: ");
 					er_str2 = ru("Суммарный приход: ","Сумарні прибутки: ");
					//DefVed.write(er_str1+(kol + fekol)+er_str2+t.getValue("summa"),"ANLTK",ANLTK_table.getValue("Fwid"))

					// подключаем Готовую Продукцию... попытаемся сделать рецепт если есть описание в справочнике рецептов
					var objGP = scatter(ANLTK_table);
					objGP.FKOL = kol2rasc - ((t==null || t.getValue("summa")==null)?0:t.getValue("summa"));
					objGP.F1KOL = objGP.FKOL;
					addRow2GPifReceptExists(objGP);
 					continue;  //Данную цепочку разнести не удалось
				}
				else 
				*/
				if((kol > -fekol) && (razbiv))  //Если можно разбивать и можно перенести часть количества
				{
					//Надо разбить запись в ANLTK на две записи, в одной уменьшить количество
					// а оставшееся количество перенести в другую цeпочку

					er_str = ru("Разбивается расход ","Розбиваються витрати ");
					DefVed.write(er_str+kol+"="+(-fekol)+"+"+(kol+fekol),"ANLTK",ANLTK_table.getValue("Fwid"))

					var m = scatter(ANLTK_table);
   
					ADD_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(ANLTK_table.getValue("Fwid")));
	
					DefVed.write("Установим кол="+(kol+fekol)+ showAnltk(ADD_ANLTK_table));
					
					ADD_ANLTK_table.Edit()
					ADD_ANLTK_table.setValue("F1kol", kol+fekol);     //Остаток 0
					ADD_ANLTK_table.setValue("Fkol", kol+fekol);      //Остаток 0
					SafeUpdate(ADD_ANLTK_table);
					
					// Подкорректируем парную строку для двустрочечных документов
					var PAIR_ANLTK_table;
					if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
					{
						PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(GetNextUID(ANLTK_table.getValue("Fwid"))));
						PAIR_ANLTK_table.Edit()
						PAIR_ANLTK_table.setValue("F1kol", kol+fekol);     //Остаток 0
						PAIR_ANLTK_table.setValue("Fkol", kol+fekol);      //Остаток 0
						SafeUpdate(PAIR_ANLTK_table);
		
						DefVed.write("Установим кол="+(kol+fekol)+ " для парной строки " + showAnltk(PAIR_ANLTK_table));
					}
					
					//kolr("EDIT", ADD_ANLTK_table);
					honr.Add(ANLTK_table.getValue("Fid_doc"))
					repeatDay = true;

					m.FWID = GetUID(true);
					m.FKOL = -fekol;
					m.F1KOL = m.FKOL;
				
					append("N",ADD_ANLTK_table, m) 
					ADD_ANLTK_table.Close();
					ADD_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(m.FWID));
					DefVed.write("Создаем новую строку "+ showAnltk(ADD_ANLTK_table));
					
					// Добавилась новая строка, добавим парную строку для двустрочечных документов
					if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
					{
						var m_pair = scatter(PAIR_ANLTK_table);
						m_pair.FWID = GetNextUID(m.FWID);
						m_pair.FKOL = m.FKOL;
						m_pair.F1KOL = m.F1KOL;					
						append("N",PAIR_ANLTK_table, m_pair) 
						PAIR_ANLTK_table.Close();
						PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(m_pair.FWID));
						DefVed.write("Создаем новую парную строку для двустрочечных документов"+ showAnltk(PAIR_ANLTK_table));
						PAIR_ANLTK_table.Close();
					}
					
					POL_ANLTK_table = null;
				}
				else   
				{   //Количество переносим полностью
					ADD_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(ANLTK_table.getValue("Fwid")));
					//DefVed.write("Количество переносим полностью из цепочки "+ showChain(ADD_ANLTK_table));
				}
				
				if(!ANLTK_table.getValue("Fnmkl"))
					debug("null!!!!!!!!!!!!!!!!!!!!");
				// Нашли количество которое нужно переразнести,
				// теперь попытаемся его переразнести
				// в те цепочки, где остатки на заданный день больше чем наш перерасход
								
				var zagTbl  = OpenTable("m","SELECT * FROM ^SCH_ZAG WHERE Fwid="+ sqlTo(ANLTK_table.getValue("Fid_doc")));
				zagTbl.tie("cl_lnk","lnk","CL_LNK","FDOC,FNOP");	
				if (zagTbl.recordCount == 0)			
				{
					alert("Ошибка: Лишняя строка");
				}
				
				var bIsSameCena = false;
				if (gd.rssamecena)
				{
					bIsSameCena = true;
				}
				else
				{
					bIsSameCena = (zagTbl.getValue("lnk.fnocenacng") ? true : false);

					if(bIsSameCena == false && !bIsImportFromTetra)
					{
						if (gd.fdoc != null && ANLTK_table.getValue("Fdoc") == String(gd.fdoc) && String(gd.fdoc) == "VM")
							bIsSameCena = false;
						else
							bIsSameCena = (inList(ANLTK_table.getValue("Fdoc"), "VP","VM") ? true : false);
					}
				}
				zagTbl.Close();
				
				//var oSnap = getSnap("select l.fnocenacng from ^cl_lnk l , ^sch_zag s where s.fdoc = ")
				//
				var POL_ANLTK_table = OpenTable("SELECT * FROM " + tbl + " a left join ^anltk pn on a.fnmkl = pn.fwid"
					+ " WHERE a.fnmkl="+sqlTo(ANLTK_table.getValue("Fnmkl"))
					+ " AND a.fpodr="+sqlTo(ANLTK_table.getValue("Fpodr"))
					+ " AND a.fmol="+sqlTo(ANLTK_table.getValue("Fmol"))
					+ " AND a.fsc ="+sqlTo(ANLTK_table.getValue("Fsc"))
					+ " AND a.fsu ="+sqlTo(ANLTK_table.getValue("Fsu"))
					+ " AND a.fst ="+sqlTo(ANLTK_table.getValue("Fst"))
					+ " AND " + (razbiv? "a.fekol>0": "a.fekol>=" + ADD_ANLTK_table.getValue("Fkol"))
					+ (bIsSameCena?" AND a.fcena="+sqlTo(ANLTK_table.getValue("Fcena")):"")
					+ " ORDER BY " + IIF(sqlRound("a.fcena",2)+"="+sqlTo(round(Number(ANLTK_table.getValue("Fcena")), 2)),"0","1")
						+", pn.fdate, a.FEKOL DESC"
						); 
						
				var COUNT_POL_ANLTK_table = OpenTable("s",
					s = "SELECT SUM(FEKOL) AS SUMMA"
					+ " FROM " + tbl
					+ " WHERE  fnmkl="+sqlTo(ANLTK_table.getValue("Fnmkl"))
						+ " AND fpodr="+sqlTo(ANLTK_table.getValue("Fpodr"))
						+ " AND fmol="+sqlTo(ANLTK_table.getValue("Fmol"))
						+ " AND fsc ="+sqlTo(ANLTK_table.getValue("Fsc"))
						+ " AND fsu ="+sqlTo(ANLTK_table.getValue("Fsu"))
						+ " AND fst ="+sqlTo(ANLTK_table.getValue("Fst"))
						//+ " AND fekol>0"
						+ " AND " + (razbiv? "fekol>0": "fekol>=" + ADD_ANLTK_table.getValue("Fkol"))
//						+ (inList(ANLTK_table.getValue("Fdoc"), "VP","VM")?" AND fcena="+sqlTo(ANLTK_table.getValue("Fcena")):"")
						+ (bIsSameCena?" AND fcena="+sqlTo(ANLTK_table.getValue("Fcena")):"")
					+ " HAVING SUM(FEKOL)>="+sqlTo(round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol))
					) 
				 //Можно ли разнести все количество?
				var count_sum = COUNT_POL_ANLTK_table.IsEmpty()? 0: COUNT_POL_ANLTK_table.getValue("summa");
				DefVed.write("Итоговое кол-во положительных остатков "+count_sum);
					
				if(!POL_ANLTK_table.IsEmpty())
					pol_kol  = round(Number(POL_ANLTK_table.getValue("Fekol")), prmDecKol)
				else	                       
					pol_kol =0;
					
				/*
				//Весь перерасход разнести не удастся, какая-то ошибка данных
				if(count_sum < round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol)) 
				{
					//alert(count_sum + " | " + Number(ADD_ANLTK_table.getValue("Fkol")));
 					er_str1 = ru("Не удастся разбить расход: ","Не можна розбити витрати: ");
 					er_str2 = ru("Суммарный приход: ","Сумарні прибутки: ");
					DefVed.write(er_str1+round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol)+er_str2+count_sum,"ANLTK",ANLTK_table.getValue("Fwid"))
					
					// подключаем Готовую Продукцию... попытаемся сделать рецепт если есть описание в справочнике рецептов
					var objGP = scatter(ANLTK_table);
					objGP.FKOL = round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol) - count_sum;
					objGP.F1KOL = objGP.FKOL;					
					addRow2GPifReceptExists(objGP);
					continue;  //Данную цепочку разнести не удалось
				}
				else //Разносим все количество
				*/
				if(pol_kol < round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol)) //Если ся полностью занести весь перерасход в положительный остаток
				{
					
					if(!razbiv)
					{
 						er_str = ru("Не удалось разбить расход ","Не вдалося розбити витрати ");
						DefVed.write(er_str+kol,"ANLTK",ANLTK_table.getValue("Fwid"))
						// подключаем Готовую Продукцию... попытаемся сделать рецепт если есть описание в справочнике рецептов
						var objGP = scatter(ANLTK_table);
						objGP.FKOL = round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol) - pol_kol;
						objGP.F1KOL = objGP.FKOL;
						addRow2GPifReceptExists(objGP);
						break;  //Данную цепочку разнести не удалось
					} 
					else
					{
						// Подправляем остатoк в таблице остатков:
						//OTR_ANLTK_table.Edit();
						//OTR_ANLTK_table.setValue("Fekol", OTR_ANLTK_table.getValue("Fekol") + round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol));
						//SafeUpdate(OTR_ANLTK_table, true);
						OTR_ANLTK_table_array[idx].Fekol = Number(OTR_ANLTK_table_array[idx].Fekol) + round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol);

						var koll = round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol);
						while(koll > 0) 
						{						
							pol_kol = Number(POL_ANLTK_table.getValue("Fekol"));
							if (pol_kol <= 0)
							{
								var objGP = scatter(ANLTK_table);
								objGP.FKOL = koll;
								objGP.F1KOL = objGP.FKOL;
								addRow2GPifReceptExists(objGP);
								break;
							}
							if(pol_kol < koll)  //Если не удается перенести сразу весь перерасход
		      				{
								//er_str = ru("Был перенесен расход ","Було перенесено витрати ");
								//DefVed.write(er_str+pol_kol,"ANLTK",ADD_ANLTK_table.getValue("Fwid"))
								DefVed.write("Не ся перенести сразу весь перерасход")
											       				  
								var m = scatter(ADD_ANLTK_table);
																	    
								var fwid = ADD_ANLTK_table.getValue("Fwid")

								if(POL_ANLTK_table.IsEOF || POL_ANLTK_table.IsBOF)
									debug("ошибка");

								check_internal_move(fwid,toScrObj(POL_ANLTK_table.getValue("Fcena"))) //Перенаправляем на данную цепочку внутреннее перемещение
                   
								DefVed.write("Строка до редактирования "+ showAnltk(ADD_ANLTK_table));
								ADD_ANLTK_table.Edit()
								ADD_ANLTK_table.setValue("F1kol", toScrObj(POL_ANLTK_table.getValue("Fekol")));
								ADD_ANLTK_table.setValue("Fkol", toScrObj(POL_ANLTK_table.getValue("Fekol"))); 
								ADD_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
								ADD_ANLTK_table.setValue("Fcena", toScrObj(POL_ANLTK_table.getValue("Fcena")));
								ADD_ANLTK_table.setValue("Fcena_ord", toScrObj(POL_ANLTK_table.getValue("Fcena")));
								if (String(ANLTK_table.getValue("Fdoc")) == "GP")
									ADD_ANLTK_table.setValue("F1cena", toScrObj(POL_ANLTK_table.getValue("Fcena")));								
								ADD_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
								preUpdate(ADD_ANLTK_table, DefVed);
								ADD_ANLTK_table.setValue("Fis_otl", false);
								SafeUpdate(ADD_ANLTK_table);
								//ADD_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(fwid));								
								DefVed.write("Строка после редактирования "+ showAnltk(ADD_ANLTK_table));
							
								//kolr("EDIT", ADD_ANLTK_table); //Делаем данную часть расхода, принадлежащей текущей цепочке
								honr.Add(ADD_ANLTK_table.getValue("Fid_doc"))

								// Подкорректируем парную строку для двустрочечных документов
								var PAIR_ANLTK_table;
								if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
								{
									PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(GetNextUID(ADD_ANLTK_table.getValue("Fwid"))));

									DefVed.write("Парная строка до редактирования "+ showAnltk(PAIR_ANLTK_table));
									PAIR_ANLTK_table.Edit()
									PAIR_ANLTK_table.setValue("F1kol", toScrObj(POL_ANLTK_table.getValue("Fekol")));
									PAIR_ANLTK_table.setValue("Fkol", toScrObj(POL_ANLTK_table.getValue("Fekol"))); 
									PAIR_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
									PAIR_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
									preUpdate(PAIR_ANLTK_table, DefVed);
									PAIR_ANLTK_table.setValue("Fis_otl", false);
									SafeUpdate(PAIR_ANLTK_table);
									//kolr("EDIT", PAIR_ANLTK_table); 
									DefVed.write("Парная строка редактирования "+ showAnltk(PAIR_ANLTK_table));
								}

								// Подправляем остатoк в таблице остатков:
								POL_ANLTK_table.Edit();
								POL_ANLTK_table.setValue("Fekol", 0); //По данной цепочке положительный остаток стал равным 0
								SafeUpdate(POL_ANLTK_table);
								DefVed.write("Остаток=0 по цепочке "+ showChain(ADD_ANLTK_table));

								honr.Add(ANLTK_table.getValue("Fid_doc"))
								repeatDay = true;

								m.FWID = GetUID(true);
								m.F1KOL = m.FKOL = koll - pol_kol;
				
								append("N",ADD_ANLTK_table, m) 
								ADD_ANLTK_table.Close();
								ADD_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(m.FWID));
								
								DefVed.write("Создаем новую строку "+ showAnltk(ADD_ANLTK_table));
								
								// Добавилась новая строка, добавим парную строку для двустрочечных документов
								if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
								{
									var m_pair = scatter(PAIR_ANLTK_table);
									m_pair.FWID = GetNextUID(m.FWID);
									m_pair.FKOL = m.FKOL;
									m_pair.F1KOL = m.F1KOL;					
									append("N",PAIR_ANLTK_table, m_pair) 
									PAIR_ANLTK_table.Close();
									PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(m_pair.FWID));
									DefVed.write("Создаем новую парную строку для двустрочечных документов"+ showAnltk(PAIR_ANLTK_table));
									PAIR_ANLTK_table.Close();
								}

								koll = koll - pol_kol; 
							}
							else
							{
								//er_str = ru("Был перенесен расход ","Було перенесено витрати ");
								//DefVed.write(er_str+koll,"ANLTK",ADD_ANLTK_table.getValue("Fwid"))
								DefVed.write("Удается перенести сразу весь перерасход")
																			       	  
								var fwid = ADD_ANLTK_table.getValue("Fwid")

								check_internal_move(fwid,toScrObj(POL_ANLTK_table.getValue("Fcena"))) //Перенаправляем на данную цепочку внутреннее перемещение
								                   
								DefVed.write("Строка до редактирования "+ showAnltk(ADD_ANLTK_table));
								ADD_ANLTK_table.Edit()
								ADD_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
								ADD_ANLTK_table.setValue("Fcena", toScrObj(POL_ANLTK_table.getValue("Fcena")));
								ADD_ANLTK_table.setValue("Fcena_ord", toScrObj(POL_ANLTK_table.getValue("Fcena")));
								if (String(ANLTK_table.getValue("Fdoc")) == "GP")
									ADD_ANLTK_table.setValue("F1cena", toScrObj(POL_ANLTK_table.getValue("Fcena")));								
								ADD_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
								ADD_ANLTK_table.setValue("Fis_otl", false);
								preUpdate(ADD_ANLTK_table, DefVed);
								SafeUpdate(ADD_ANLTK_table);
								DefVed.write("Строка после редактирования "+ showAnltk(ADD_ANLTK_table));
								
								// Подкорректируем парную строку для двустрочечных документов
								var PAIR_ANLTK_table;
								if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
								{
									PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(GetNextUID(ADD_ANLTK_table.getValue("Fwid"))));
									PAIR_ANLTK_table.Edit()
									PAIR_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
									PAIR_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
									preUpdate(PAIR_ANLTK_table, DefVed);
									PAIR_ANLTK_table.setValue("Fis_otl", false);
									SafeUpdate(PAIR_ANLTK_table);
								}
								
								//kolr("EDIT", ADD_ANLTK_table); //Делаем данную часть расхода, принадлежащей текущей цепочке
								honr.Add(ADD_ANLTK_table.getValue("Fid_doc"))
		                        repeatDay = true;
												   
								// Подправляем остатoк в таблице остатков:
								POL_ANLTK_table.Edit();
								POL_ANLTK_table.setValue("Fekol", pol_kol - koll); 
								SafeUpdate(POL_ANLTK_table);
								DefVed.write("Остаток="+(pol_kol - koll)+" по цепочке "+ showChain(ADD_ANLTK_table));
								koll = 0; 
							}
							
							//Берем положительный остаток по следующей цепочке
							//if(!POL_ANLTK_table.IsEOF())
							//	pol_kol  = round(Number(POL_ANLTK_table.getValue("Fekol")),prmDecKol)
							
							
							
							if(!POL_ANLTK_table.IsEOF() && POL_ANLTK_table.recordCount >0)
								POL_ANLTK_table.MoveNext();
						} //end of while(koll > 0) 
					}	// end of if(!razbiv)
				}
				else //Если удается полностью занести весь перерасход в положительный остаток
				{
					//er_str = ru("Был перенесен расход ","Було перенесено витрати ");
					//DefVed.write(er_str+round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol),"ANLTK",ADD_ANLTK_table.getValue("Fwid"))
					DefVed.write("удается полностью занести весь перерасход в положительный остаток");
					
					// Подправляем остатoк в таблице остатков:
					//OTR_ANLTK_table.Edit();
					//OTR_ANLTK_table.setValue("Fekol", (Number(OTR_ANLTK_table.getValue("Fekol")) + round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol)));
					//SafeUpdate(OTR_ANLTK_table, true);
					//DefVed.write("Остаток="+(OTR_ANLTK_table.getValue("Fekol"))+" по цепочке "+ showChain(ADD_ANLTK_table));
					OTR_ANLTK_table_array[idx].Fekol = 
						Number(OTR_ANLTK_table_array[idx].Fekol) + round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol);
					
					var fwid = ADD_ANLTK_table.getValue("Fwid")

					check_internal_move(fwid,toScrObj(POL_ANLTK_table.getValue("Fcena"))) //Перенаправляем на данную цепочку внутреннее перемещение
									       
					DefVed.write("Строка до редактирования "+ showAnltk(ADD_ANLTK_table));
					ADD_ANLTK_table.Edit()
					ADD_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
					ADD_ANLTK_table.setValue("Fcena", toScrObj(POL_ANLTK_table.getValue("Fcena")));
					ADD_ANLTK_table.setValue("Fcena_ord", toScrObj(POL_ANLTK_table.getValue("Fcena")));
					if (String(ANLTK_table.getValue("Fdoc")) == "GP")
						ADD_ANLTK_table.setValue("F1cena", toScrObj(POL_ANLTK_table.getValue("Fcena")));								
					ADD_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
					ADD_ANLTK_table.setValue("Fis_otl", false);
					preUpdate(ADD_ANLTK_table, DefVed);
					SafeUpdate(ADD_ANLTK_table);
					DefVed.write("Строка после редактирования "+ showAnltk(ADD_ANLTK_table), "ANLTK", ADD_ANLTK_table.getValue("Fwid"));
								
					// Подкорректируем парную строку для двустрочечных документов
					var PAIR_ANLTK_table;
					if (docinfo("RCNT",ANLTK_table.getValue("Fdoc")) == 2)
					{
						PAIR_ANLTK_table = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid = " + sqlTo(GetNextUID(ADD_ANLTK_table.getValue("Fwid"))));
						PAIR_ANLTK_table.Edit()
						PAIR_ANLTK_table.setValue("Fpost", toScrObj(POL_ANLTK_table.getValue("Fpost")));
						PAIR_ANLTK_table.setValue("Fid_pn", toScrObj(POL_ANLTK_table.getValue("Fid_pn")));
						preUpdate(PAIR_ANLTK_table, DefVed);
						PAIR_ANLTK_table.setValue("Fis_otl", false);
						SafeUpdate(PAIR_ANLTK_table);
					}
					
					//kolr("EDIT", ADD_ANLTK_table); //Делаем данную часть расхода, принадлежащей текущей цепочке
					honr.Add(ADD_ANLTK_table.getValue("Fid_doc"))
					repeatDay = true;
					
					// Подправляем остатoк в таблице остатков:
					POL_ANLTK_table.Edit();
					POL_ANLTK_table.setValue("Fekol", pol_kol - round(Number(ADD_ANLTK_table.getValue("Fkol")),prmDecKol)); 
					SafeUpdate(POL_ANLTK_table);
					DefVed.write("Остаток POL_ANLTK_table="+(POL_ANLTK_table.getValue("Fekol"))+" по цепочке "+ showChain(ADD_ANLTK_table));
				} // end of if(pol_kol < ADD_ANLTK_table.getValue("Fkol"))
				fekol = round(Number(OTR_ANLTK_table_array[idx].Fekol),prmDecKol)
				
				if(t)
				{
					t.Close(5652);
					t = null;
				}
				
				POL_ANLTK_table.Close(5652);
				POL_ANLTK_table = null;
				
				COUNT_POL_ANLTK_table.Close(5652);
				COUNT_POL_ANLTK_table = null;
				
				if (ADD_ANLTK_table)
				    ADD_ANLTK_table.Close();
				    
			}
			if(t)
			{
				t.Close(5652);
				t = null;
			}
			if(POL_ANLTK_table)
			{
				POL_ANLTK_table.Close(5652);
				POL_ANLTK_table = null;
			}
			if(COUNT_POL_ANLTK_table)
			{
				COUNT_POL_ANLTK_table.Close(5652);
				COUNT_POL_ANLTK_table = null;
			}
			if (ANLTK_table)
			{
			    ANLTK_table.Close();
			    ANLTK_table = null;
			}
			// Пересчитать нужно остатки все равно по всем счетам, так как для двустрочечных документов
			// у парных строк другие счета и т.д.
			
			//end of while(fekol < 0)
		} 
		setProgressPos(0);		
		OTR_ANLTK_table.Close(5652);

		if (isCreateGP && rows4gpArray.length > 0)
		{
			if (createGP())
			{
				repeatDay = true;
				isCreateGP = false;
			}
		}

		if(repeatDay && nTrays < nTraysCount)
		{
			curDate = goDay(curDate,-1);  // Проверим еще раз
			nTrays++;
			nSteps++;
			setProgressRange(0, nSteps);	
		}
		else
			nTrays = 0;

		honr.Done(DefVed);
		
		/*
		if (differ(curDate,dat2) > 0)
		{
			if (createGP())
			{
				// Проверим еще раз после того как создали блюдо по рецепту
				curDate = goDay(curDate,-1); 
				nTrays++;
				nSteps++;
				setProgressRange(0, nSteps);	
			}
		}
		*/
/*
		if(honr.Done(DefVed)!=0 && nTrays < 0)
		{
			curDate = goDay(curDate,-1);  // Проверим еще раз
			nTrays++
		}
		else
			nTrays = 0;
*/
	
//		if(Pump())
//			break;
	
	} // end of for(var curDate = new Date(dat1);differ(curDate,dat2) <= 0; curDate = goDay(curDate,1))     
	honr.noPump = true;
	DefVed.end();
	
	return;
}

//В функцию передается fwid записи и новая цена
//Делается проверка, была ли это переоценка, либо внутреннеe перемещение
function check_internal_move(fwid,fcena)
{
    var tbl1 = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid="+sqlTo(fwid))
    if(tbl1.getValue("Frtype") != RTYPE_PMR) 
    {
        tbl1.Close();
        return;
    }
    tbl1.Close();
    
  var next = GetNextUID(fwid)
  var tbl2 = OpenTable("s","SELECT * FROM ^ANLTK WHERE fwid="+sqlTo(next))
  
  if(!tbl2.IsEmpty() && tbl1.getValue("Fcena") == tbl2.getValue("Fcena")) //Было внутреннее перемещение 
   {
     tbl2.Edit();
     tbl2.setValue("Fcena", fcena);
     tbl2.setValue("Fcena_ord", fcena);
     tbl2.Update();
   }
   tbl2.Close();
 }
 
 function testError()
 {
	var t = OpenTable('s', 'SELECT * FROM ^anltk_ost WHERE fdate<=#5/5/2003# AND fdateost>=#5/5/2003# AND fnmkl="6.40.EO005" AND fekol<0');
	if(!t.IsEmpty())
		debug("");
		
	t.Close();
 }
 
 function showChain(tbl)
 {
	return tbl.getValue("Fnmkl")+"(" + tbl.getValue("Fcena")+") Подр="+tbl.getValue("Fpodr")+" МОЛ="+tbl.getValue("Fmol")+" Сч"+tbl.getValue("Fsc")+"/"+tbl.getValue("Fsu")+"/"+tbl.getValue("Fst")+" Пост="+tbl.getValue("Fpost")+" " + tbl.getValue("Fid_pn");
 }
 
 function showAnltk(tbl)
 {
	return tbl.getValue("Fdoc")+format(" dd-mm-yy",tbl.getValue("Fdate"))
		+" Кол="+tbl.getValue("Fkol")+ " цепочка=" + showChain(tbl);
 }
 
 function preUpdate(tbl, DefVed)
 {
	if(String(tbl.getValue("Fdoc"))=="VM" || String(tbl.getValue("Fdoc"))=="PM")
	{
		if(Number(tbl.getValue("Fid_pn")) != 0)
		{
			var newCenapr = tanf(Number(tbl.getValue("Fid_pn")), "cena");
			//if(confirm("Изменить " + tbl.getValue("Fid_pn") + " " + tbl.getValue("Fcenapr") + " на " + newCenapr))
			{
				tbl.setValue("Fcenapr", newCenapr);
				if (String(tbl.getValue("frtype")) == "6")
				{
					tbl.setValue("Fcena", newCenapr);
					tbl.setValue("Fcena_ord", newCenapr);
				}
				DefVed.write("Изменим fcenapr="+newCenapr+"(VR only)");
			}
		}
	}
 }
 
 function SafeUpdate(tbl, useBookmark)
 {
    var bk = 0;
	if (useBookmark)
        tbl.absolute;
	
	tbl.Update();
	
	if (useBookmark)
	{
    	tbl.requery();
	    tbl.absolute = bk;
	}
}

function addRow2GPifReceptExists(obj)
{	
	var oSnap = getSnap("select * from ^cl_rrec " +
			" where frtype = " + sqlTo(RTYPE_PR)
			+ " AND fnmkl = " + sqlTo(obj.FNMKL));
	if (oSnap != null)
		rows4gpArray[obj.FWID] = obj;
}
 
function createGP()
{
	var bReturn = false;
//	if (rows4gpArray.length && confirm("Сделать недостающие блюда по рецептам?"))
	
	if (rows4gpArray.length)
	{
		var oGpDoc = new DpDoc("GP", 1);
		var bFirstRow = true;
		var fid_doc;
		var fdoc;
		for (var i in rows4gpArray)
		{	
			if (bFirstRow)
			{
				fid_doc = rows4gpArray[i].FID_DOC;
				
				fdoc = rows4gpArray[i].FDOC;

				bFirstRow = false;
				oGpDoc.setVar("HDAT", rows4gpArray[i].FDATE);
				if (fdoc == "NK" || fdoc == "PZ")
				{
					var oSnap = getSnap("SELECT fdoc_num from ^sch_zag WHERE fwid = " + sqlTo(Number(fid_doc)))
					if (oSnap != null)
					{
						var sNum = String(oSnap[0]).trim();
						if(sNum.length<6)	//поле fdoc_num вмещает 25 символов
							oGpDoc.setVar("HNOM", "Доб. для " + (fdoc == "NK" ? "реализ. " : "списания ") + sNum);
					}
					else
					{
						oGpDoc.setVar("HNOM", "Доб. при расц.");
					}
				}
				else
				{
					var oSnap = getSnap("SELECT fdoc_num from ^sch_zag WHERE fwid = " + sqlTo(Number(fid_doc)))
					if (oSnap != null)
					{
						var sNum = String(oSnap[0]).trim();
						if(sNum.length<10)	//поле fdoc_num вмещает 25 символов
							oGpDoc.setVar("HNOM", "Доб. при расц. " + sNum);
					}
					else
					{
						oGpDoc.setVar("HNOM", "Доб. при расц.");
					}
				}
				oGpDoc.setVar("HSCRS", rows4gpArray[i].FSC);
				oGpDoc.setVar("HSURS", rows4gpArray[i].FSU);
				oGpDoc.setVar("HSTRS", rows4gpArray[i].FST);
				oGpDoc.setVar("HSCPR", rows4gpArray[i].FSC);
				oGpDoc.setVar("HSUPR", rows4gpArray[i].FSU);
				oGpDoc.setVar("HSTPR", rows4gpArray[i].FST);
				oGpDoc.setVar("HMOLRS", rows4gpArray[i].FMOL);
				oGpDoc.setVar("HPODRRS", rows4gpArray[i].FPODR);
				oGpDoc.setVar("HMOLPR", rows4gpArray[i].FMOL);
				oGpDoc.setVar("HPODRPR", rows4gpArray[i].FPODR);
				oGpDoc.setVar("HISBAD", true);
			}
			oDocRow = oGpDoc.createRow("ROW");
			oDocRow.setVar("RTNMK", rows4gpArray[i].FNMKL);
			oDocRow.setVar("RKOL", round(rows4gpArray[i].FKOL, 5));
//			oDocRow.setVar("RKOLSPR", rows4gpArray[i].FKOL);
			oDocRow.setVar("R1ID", 0);
			oDocRow.setVar("REDI", rows4gpArray[i].FEDI);
			oDocRow.setVar("RSC", rows4gpArray[i].FSC);
			oDocRow.setVar("RSU", rows4gpArray[i].FSU);
			oDocRow.setVar("RST", rows4gpArray[i].FST);
			oDocRow.setVar("RMOL", rows4gpArray[i].FMOL);
			oDocRow.setVar("RPODR", rows4gpArray[i].FPODR);
			oDocRow.setVar("RPOST", rows4gpArray[i].FPOST);
			oDocRow.setVar("RTYPE", RTYPE_PR);
			
			oGpDoc.appendRow(oDocRow.sClassId, oDocRow);
//			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, null);
		}
	
		oGpDoc.simpleMode2Rasc = true;
		if (oGpDoc.edit("ADD",-1, {save_after_load:true}))
		{
			include("doc\\Nakl\\DpDocRasc.js")
			var oRasc = new DpDocRasc(oGpDoc);
			oRasc.rasc();

			var oSnap = getSnap("SELECT fnop from ^sch_zag WHERE fwid = " + sqlTo(Number(fid_doc)))
			if (oSnap != null)
			{
				var fnop = oSnap[0];
				
				var m = new Object(); 
				m.FMAINWID = fid_doc;
				m.FDOCWID = oGpDoc.getID();
				m.Fdoc = "GP";
				m.Fnop = 1;
				m.FISPARENT = true;
				m.FWID = GetUID();
				updateTable("^doc_links", m, true);
				
				var m = new Object(); 
				m.FMAINWID = oGpDoc.getID();
				m.FDOCWID = fid_doc;
				m.Fdoc = fdoc;
				m.Fnop = fnop;
				m.FISPARENT = false;
				m.FWID = GetUID();
				updateTable("^doc_links", m, true);
			}
			
			bReturn = true;
		}		
			
		rows4gpArray = new Array();
	}
	
	return bReturn;
}
//alert(GetMenuMode() + "GetMenuMode()");

if(GetMenuMode() == "RUN")
	onLoad();
 