include("Objects/DpCl.js");
include("gridedit.js");

var sTbl = "COUNTERS";
var sTmpTbl = getTmpTableName();
var oOrg;
var oNode;
var oStreet;
var oHouse;

function listLoad()
{
	this.title = UR("Показники лічильників|Показания счетчиков");
	if(extPar.mode=="RECALC")
		this.title = UR("Корегування показників лічильників|Корректировка показаний счетчиков");
	if(extPar.mode=="BALANCE")
		this.title = UR("Баланс витрат|Баланс расходов");
	/*
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	oNode.linkSmartCtrl(FNODE);
	oNode.setContAssist();
	if(extPar.node)
		oNode.setCod(extPar.node);
	if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
	//oNode.AfterUpdate = filter;
	*/
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	if(extPar.street)
		oStreet.setFWID(extPar.street);
	//oStreet.AfterUpdate = filter;
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	if(extPar.house)
		oHouse.setFWID(extPar.house);
	//oHouse.AfterUpdate = filter;
			
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	if(getPar("VDKORGCAT")!=null)
		FCAT.value = Number(getPar("VDKORGCAT"));
	setValid(FCAT, orgcatValid);
	orgcatValid();
	if(extPar.org)
		oOrg.setCod(extPar.org);
	//oOrg.AfterUpdate = filter;
		
	this.loadCounters = loadCounters;
	setButton(BTNFILTER, this, "loadCounters");
	
	this.save = onSave;
	this.escape = onCancel;
	
	//FDATE.value = lastDay(goMonth(today, -1));
	FDATE.value = today;
	FREGDATE.value = today;
	
	CreateTable(sTmpTbl, sTbl, "*");
	ExecuteSQL("alter table "+ sTmpTbl +" add column FBUG "+ sqlType("BIT"));
	ExecuteSQL("alter table "+ sTmpTbl +" add column FLAST "+ sqlType("BIT"));
	
	if(extPar.date)
	{
		FDATE.value = extPar.date;
		FREGDATE.value = extPar.date;
	}
	//if(extPar.rdate)
	//	FREGDATE.value = extPar.rdate;
	if(extPar.serv)
		FSERV.value = extPar.serv;
		
	FCOUNTER1.mask = MASK_KOL;
	FCOUNTER2.mask = MASK_KOL;
	//FCOUNTER3.mask = MASK_KOL;
	//FCOUNTER4.mask = MASK_KOL;
	FCOUNTER5.mask = MASK_KOL;
	Disable(FCOUNTER1);
	Disable(FCOUNTER2);
	//Disable(FCOUNTER3);
	//Disable(FCOUNTER4);
	Disable(FCOUNTER5);
	
	//GRBALANCE.setVisible(true);
	if(extPar.mode=="BALANCE")
	{	
		//GRMENBIL.setVisible(true);
		Disable(btnOK);
	}
	if(extPar.mode=="RECALC")
	{
		//Disable(FORG);
		if(extPar.tbl)
		{
			var tbl = extPar.tbl;
			FMENKOL.value = tbl.getValue("FMENKOL");
			FNORM.value = tbl.getValue("FNORM");
			oStreet.setFWID(tbl.getValue("FSTREET"));
			oHouse.setFWID(tbl.getValue("FHOUSE"));
			oOrg.setCod(tbl.getValue("FORG"));
			setValid(FNORM2, norm2Valid);
			//GRNORM2.setVisible(true);
			Disable(FNORM);
		}
	}
	
	FBALANCE.mask = MASK_KOL;
	FRECALC.mask = MASK_KOL;
	FMENKOL.mask = MASK_KOL;
	FMENBIL.mask = MASK_KOL;
	FMENCOUNT.mask = MASK_KOL;
	FNORM.mask = MASK_KOL;
	FNORM2.mask = MASK_KOL;
	Disable(FBALANCE);
	Disable(FRECALC);
	Disable(FMENCOUNT);
	Disable(FMENBIL);
	Disable(FMENKOL);
	Disable(FNORM);
	
	this.showLicWithoutCnt = showLicWithoutCnt;
	setButton(FMENCOUNT, this, "showLicWithoutCnt");
	
	setValid(FDATE, date_valid);
	//setValid(FSERV, filter);
	//setValid(FCOUNTER, filter);
	//setValid(FCAT, filter);
}

function orgcatValid()
{
	if(FCAT.value=="0" && getPar("VDKCODORG"))
		oOrg.setClcl(getPar("VDKCODORG"));
	else
		oOrg.setClcl(getPar("CODPLAT"));
}

function norm2Valid()
{
	var norm = Number(FNORM.value);
	if(extPar.tbl)
		norm = Number(extPar.tbl.getValue("FNORM"));
	var oSnap = getSnap("select FNORM from ^COUNTERS"
						+" where FHOUSE="+ oHouse.getFWID() 
							+(FSERV.value? " and FSERV="+ sqlTo(FSERV.value) : "")
							+(FCOUNTER.value? " and FCOUNTER="+ sqlTo(FCOUNTER.value) : "")
						+" order by FDATE desc"
						);
	if(oSnap && oSnap[0])
		norm = Number(oSnap[0]);
	var norm2 = Number(FNORM2.value);
	if(norm2)
		FNORM.value = norm2-norm;
}

function showLicWithoutCnt()
{
	var par = new Object();
	par.doc = "LICSC";
	par.nop = getPar("HOC_LICSC");
	var d1 = firstDay(today);
	par.subWhere = " FHOUSE="+ oHouse.getFWID() 
					+" and not exists (select cnt.FID_DOG"
						+" from ^SC_COUNTERS cnt"
						+" where cnt.FID_DOG=^listlicsc.FID_DOG"
							+" and cnt.FSERV="+ sqlTo(FSERV.value)
							+" and cnt.FBDAT<="+ sqlTo(d1)
							+" and cnt.FEDAT>="+ sqlTo(d1)
						+")";
	showWindow("l_docekz.xml", SW_MODAL, par);
}

function date_valid()
{
	var date = FDATE.value;
	var days = day_difference(today, date);
	if(differ(date, d00)==0 || days>60 || days<-700)
	{
		var sMsg = UR("Не коректна дата!|Не корректная дата!");
		FDATE.showErr(sMsg);
		//setFocus(FDATE);
		//return false;
	}
	return true;
}

function listAfterLoad()
{
	if(extPar.mode=="RECALC" || extPar.mode=="BALANCE" || oOrg.getCod())
	{
		loadCounters();
	}
}

function listSrc()
{
	this.qrySet("From", sTmpTbl
				, "Order", "FDATE, FSTREET, FHOUSE, FORG, FID_DOG, FSERV, FCOUNTER, FWID"
				);
	this.clTie("org", "="+ getPar("CODPLAT") +", FORG");
	this.clTie("node", "="+ getPar("CODNODE") +", FNODE");
	this.subTie("CL", "str", "FWID", "FSTREET");
	this.subTie("CL_HOUSE", "house", "FWID_CL", "FHOUSE");
	this.subTie("CL_APARTMENT", "apt", "FWID_CL", "FAPMT");
	this.clTie("source", "="+ getPar("CODREGSOURCE") +", FSOURCE");
}

function filter()
{
	if(!date_valid() || !grid.getTable())
		return;
	list.qryWhere = currWhere();
	list.tblInit();
}

function currWhere()
{
	var sWhere = "1=1";
	//if(oNode.getCod())
	//	sWhere += " and FNODE="+ oNode.getCod();
	if(oOrg && oOrg.getCod())
		sWhere += " and FORG="+ oOrg.getCod();
	if(oStreet.getCod())
		sWhere += " and FSTREET="+ oStreet.getFWID();
	if(oHouse.getFWID())
		sWhere += " and FHOUSE="+ oHouse.getFWID();
	if(FSERV.value && String(FSERV.value).trim()!="")
		sWhere += " and FSERV="+ sqlTo(FSERV.value);
	if(Number(FCOUNTER.value))
		sWhere += " and FTYPE="+ FCOUNTER.value;
	if(!oOrg.getCod() && FCAT.value && Number(FCAT.value)!=2)
		sWhere += " and FORG in (select FCOD from ^LISTCLORG where FCAT="+ FCAT.value +")";
	return sWhere;
}

function listDpGrid()
{
	this.accEdit = new Function("return 'E'");
	grid.build();
}

function listMenuInit(oGrid)
{		
	grid.setCycleEdit(false);
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		if(oGrid.getMouseAction()==mReturn)	//редактирование по ENTERu
		{
			//oGrid.runGridMenu("EDIT");
			list.mnuHandler("CEDIT");
			return false;
		}
		grid.AddMenuItem("LICSC", "Особовий рахунок|Лицевой счет");
		grid.AddMenuItem("LOADPREVIOUS", "Завантажити попередні показники|Загрузить предыдущие показания");
		grid.AddMenuItem("SETCURRENT", "Встановити поточні показники|Установить текущие показания");
		grid.AddMenuItem("DELEMPTY", "Вилучити нульові показники|Удалить нулевые показания");
		if(tbl.getValue("FBUG")==false)
			grid.AddMenuItem("CALCMIDDLE", "Розрахувати за середньодобовими|Расчитать по среднесуточному");
	}
	grid.AddMenuItem("IMPORTHEAT", "Імпорт показників тепломережі|Импорт показаний теплосети");
	if(!tbl.isEmpty())
		grid.AddMenuItem("CEDIT", "Циклічне редагування \tEnter|Циклическое редактирование \tEnter");
}

function listMenuRun(sMenuID)
{
	var sTblName = list.tbl.getTableName();
	var rowID = list.tbl.getValue("FWID");
	var counter = list.tbl.getValue("FCOUNTER");
	var date = list.tbl.getValue("FDATE");
	grid.setCycleEdit(false);
	if(sMenuID=="LOADPREVIOUS")
	{
		loadPreviousReg();
		grid.getTable().requery();
		grid.refresh();
	}
	if(sMenuID=="SETCURRENT")
	{
		ExecuteSQL("update "+ sTmpTbl +" set FCURRENT=FPREVIOUS where FCURRENT=0");
		grid.getTable().requery();
		grid.refresh();
	}
	if(sMenuID=="DELEMPTY")
	{
		ExecuteSQL("delete from "+ sTmpTbl +" where FCURRENT=0 and FDIFFERENCE=0");
		grid.getTable().requery();
		grid.refresh();
	}
	if(sMenuID=="CEDIT")
	{
		var tbl = list.tbl;
		var par = new Object();
		par.mode = "EDIT";
		par.cyclic = true;
		while(!tbl.isEOF())
		{
			par.m_pTable = tbl;
			showWindow("e_counter.xml", SW_MODAL, par);
			if(par.escape)
			{
				break;
			}
			else
			{
				tbl.MoveNext();
				calcTotals();
			}
		}
		grid.getTable().requery();
		grid.refresh();
	}
	if(sMenuID=="EDIT")
	{
		var par = new Object();
		par.mode = sMenuID;
		par.m_pTable = list.tbl;
		par.recalc = extPar.mode=="RECALC";
		//par.date = FDATE.value;
		//par.isApplyBtn = true;
		showWindow("e_counter.xml", SW_MODAL, par);
		if(par.escape)
			return DpList_exit;
		
		if(extPar.mode=="RECALC" && Number(par.FCURRENT))
		{
			var prev = "FCURRENT_OLD+"+ Number(par.FDIFFERENCE);
			var oSnap = getSnap("select FWID from "+ sTmpTbl +" where FCOUNTER="+ counter +" and FDATE>"+ sqlTo(date) +" order by FDATE");
			if(oSnap)
			{
				if(confirm(UR("Змінити наступні показники?|Изменить следующие показания?")))
				{
					ExecuteSQL("update "+ sTmpTbl 
								+" set FPREVIOUS=("+ prev +")"
								+" where FWID="+ oSnap[0]
								);
					ExecuteSQL("update "+ sTmpTbl +" set FDIFFERENCE=(FCURRENT-FPREVIOUS)");
					ExecuteSQL("update "+ sTmpTbl +" set FKOL=FDIFFERENCE");
				}
			}
		}
		calcTotals();
	}
	if(sMenuID=="ADDCOMMENT")
	{
		var par = new Object();
		par.mode = sMenuID;
		par.m_pTable = list.tbl;
		par.date = FDATE.value;
		showWindow("e_counter.xml", SW_MODAL, par);
		if(par.escape)
			return DpList_exit;
		if(grid.getSelectedCount()>0)
		{
			var sSource = par.FSOURCE;
			var sComment = par.FCOMMENT;
			ExecuteSQL("update "+ sTblName 
						+" set FSOURCE="+ sqlTo(sSource) 
							+", FCOMMENT="+ sqlTo(sComment) 
						+" where "+ grid.sqlSelected()
						);
		}
	}
	else if(sMenuID=="LICSC")
	{
		var fid_dog = list.tbl.getValue("FID_DOG");
		if(!fid_dog)
			return DpList_exit;
		var oDoc = new DpDoc("LICSC", 1);
		oDoc.edit("EDIT", fid_dog);
		return DpList_exit;
	}
	else if(sMenuID=="IMPORTHEAT")
	{
		importHeat();
	}
	else if(sMenuID=="CALCMIDDLE")
	{
		calcMiddle();
		grid.getTable().requery();
		grid.refresh();
		calcTotals();
	}
}

function calcMiddle()
{
	var date = new Date(FDATE.value);
	var dat1 = firstDay(gomonth(date, -3));
	var dat2 = lastDay(gomonth(date, -1));
	
	var par = new Object();
	par.bdat = dat1;
	par.edat = dat2;
	par.title = UR("Період розрахунку|Период расчета");
	showWindow("e_period.xml", SW_MODAL, par);
	if(par.escape)
		return;
	dat1 = par.bdat;
	dat2 = par.edat;
	var days = day_difference(dat1, dat2);
	WAIT(UR("Розрахунок середніх...|Расчет средних..."));
	var tbl = list.tbl;
	if(grid.getSelectedCount()>0)
		tbl = OpenTable("select * from "+ sTmpTbl +" where "+ grid.getSqlSelected());
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var d1 = dat1;
		var d2 = dat2;
		var cntID = tbl.getValue("FCOUNTER");
		//var bdat = tbl.getValue("FBDAT");
		var calcDate = firstDay(date);
		if(tbl.getValue("FBUG")==true)
			continue;
		if(tbl.getValue("FISCHECK")==true)
		{
			var bdatcheck = tbl.getValue("FBDATCHECK");
			var edatcheck = tbl.getValue("FEDATCHECK");
			//для счетчиков снятых на поверку больше месяца не считать
			if(differ(bdatcheck, goMonth(calcDate, -1))<=0 && differ(edatcheck, calcDate)>0)
				continue;
			d1 = firstDay(gomonth(bdatcheck, -2));
			d2 = lastDay(gomonth(bdatcheck, -1));
		}
		//if(differ(bdat, d1)==1)
		//	d1 = bdat;
		days = day_difference(d1, d2);
		if(days<10)
			continue;
		var oSnap = getSnap("select sum(FDIFFERENCE)"
						+" from ^COUNTERS"
						+" where FCOUNTER="+ cntID
							+" and FDATE>="+ sqlTo(dat1)
							+" and FDATE<="+ sqlTo(dat2)
						);
		if(!oSnap || Number(oSnap[0])==0)
			continue;
		var sumDif = Number(oSnap[0]);
		var middle = round(sumDif/days, 4);
		var checkMiddle = 0;
		if(tbl.getValue("FISCHECK")==true)
			checkMiddle = middle;
		var nDays = getDaysInMonth(date);
		var nVol = round(middle*nDays, 2);
		ExecuteSQL("update "+ sTmpTbl 
					+" set FMIDDLE="+ middle 
						+", FCHECKMIDDLE="+ checkMiddle
						+", FDIFFERENCE="+ nVol 
						+", FCURRENT=(FPREVIOUS+"+ nVol +")"
						+", FISAVERAGE="+ sqlTrue
						+" where FCOUNTER="+ cntID
					);
	}
	CLEARWAIT();
}

function importHeat()
{
	var sFileName = BrowseForFile("*.dbf;*.DBF|*.*", "DBF|"+ UR("Усі файли|Все файлы"), null, "open", "");
	if(!sFileName)
		return false;
	var tbl = OpenTable("f", sFileName, "cp866");
	var recordCnt = tbl.recordCount;
	var licsc = tbl.getValue("ACCNUMB");
	var serial = tbl.getValue("SERIALNUMB");
	if(!licsc || !serial || recordCnt==0)
	{
		alert(UR("Немає даних для імпорту!|Нет данных для импорта!"));
		return false;
	}
	//WAIT(UR("Імпорт: |Импорт: ") + "1/"+ recordCnt);
	setProgressRange(0, recordCnt);
	setProgressPos(1, UR("Імпорт: |Импорт: ") + "1/"+ recordCnt);
	
	var sImportTbl = getTmpTableName();
	ExecuteSQL("create table "+ sImportTbl 
				+" (ACCNUMB "+ SqlType("TEXT", 25) 
				+", STREET "+ SqlType("TEXT", 254) 
				+", HOUSE "+ SqlType("TEXT", 254) 
				+", KVART "+ SqlType("TEXT", 25) 
				+", FIO "+ SqlType("LONGTEXT")
				+", TELEFON "+ SqlType("TEXT", 254)
				+", SERIALNUMB "+ SqlType("TEXT", 254) 
				+", COUNT_BEGI "+ SqlType("DOUBLE")
				+", COUNT_END "+ SqlType("DOUBLE")
				+", EXPENS "+ SqlType("DOUBLE")
				+", DATE "+ SqlType("DATE")
				+", PERIOD "+ SqlType("LONG")
				//+", ACCNUM "+ SqlType("TEXT", 25)
				+")");
	//CreateTable(sImportTbl, sTbl, "*");
	var date = new Date(FDATE.value);
	var nRow = 0;
	var nPr = 1;
	
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		if(nPr%10==0)
			setProgressPos(nPr, UR("Імпорт: |Импорт: ") + nPr +"/"+ recordCnt);
		nPr++;
			
		var heatnum = tbl.getValue("ACCNUMB");
		var serial = tbl.getValue("SERIALNUMB");
		if(!licsc || !serial)
			continue;
		
		heatnum = String(heatnum).replace("-", "").trim();
		serial = String(serial).trim();
		if(tbl.getValue("DATE"))
			date = new Date(tbl.getValue("DATE"));
		var period = tbl.getValue("PERIOD");
		
		var oSnap = getSnap("select sc.FID_DOG,sc.FWID,sc.FNUM,sc.FSERIAL,sc.FTYPE,sc.FPLACE,sc.FSERV"
							+",sc.FISCHECK,sc.FBDATCHECK,sc.FEDATCHECK,sc.FCHECKMIDDLE,sc.FMIDDLE"
							+",l.FGRPID,c.FORG,l.FNODE,l.FSTREET,l.FHOUSE,l.FAPMT"
						+" from ^SC_COUNTERS sc"
							+" inner join ^LICSC l on l.FID_DOG=sc.FID_DOG"
							+" inner join ^CONTRACT c on c.FWID=sc.FID_DOG"
						+" where l.FHEATNUM="+ sqlTo(heatnum) 
							+" and sc.FSERIAL="+ sqlTo(serial)
						,false
						);
		if(!oSnap)
		{
			oSnap = getSnap("select sc.FID_DOG,sc.FWID,sc.FNUM,sc.FSERIAL,sc.FTYPE,sc.FPLACE,sc.FSERV"
							+",sc.FISCHECK,sc.FBDATCHECK,sc.FEDATCHECK,sc.FCHECKMIDDLE,sc.FMIDDLE"
							+",l.FGRPID,c.FORG,l.FNODE,l.FSTREET,l.FHOUSE,l.FAPMT"
						+" from ^SC_COUNTERS sc"
							+" inner join ^LICSC l on l.FID_DOG=sc.FID_DOG"
							+" inner join ^CONTRACT c on c.FWID=sc.FID_DOG"
						+" where (l.FHEATNUM='0' or l.FHEATNUM="+ sqlEmpStr +")"
							+" and sc.FSERIAL="+ sqlTo(serial)
						,false
						);
		}
		if(!oSnap)
		{
			var m = new Object();
			m.ACCNUMB = tbl.getValue("ACCNUMB");
			m.STREET = tbl.getValue("STREET");
			m.HOUSE = tbl.getValue("HOUSE");
			m.KVART = tbl.getValue("KVART");
			m.FIO = tbl.getValue("FIO");
			m.TELEFON = tbl.getValue("TELEFON");
			m.SERIALNUMB = serial;
			m.COUNT_BEGI = tbl.getValue("COUNT_BEGI");
			m.COUNT_END = tbl.getValue("COUNT_END");
			m.EXPENS = tbl.getValue("EXPENS");
			m.DATE = date;
			m.PERIOD = tbl.getValue("PERIOD");
			//m.ACCNUM = heatnum;
			UpdateTable(sImportTbl, m, true);
			continue;
		}
		var m = new Object();
		m.FWID = GetUID();
		m.FID_DOG = oSnap[0];
		m.FCOUNTER = oSnap[1];
		m.FNUM = oSnap[2];
		m.FSERIAL = oSnap[3];
		m.FTYPE = oSnap[4];
		m.FPLACE = oSnap[5];
		m.FSERV = oSnap[6];
		m.FISCHECK = oSnap[7];
		m.FBDATCHECK = oSnap[8];
		m.FEDATCHECK = oSnap[9];
		m.FCHECKMIDDLE = oSnap[10];
		m.FMIDDLE = oSnap[11];
		m.FID_PAR = oSnap[12];
		m.FORG = oSnap[13];
		m.FNODE = oSnap[14];
		m.FSTREET = oSnap[15];
		m.FHOUSE = oSnap[16];
		m.FAPMT = oSnap[17];
		m.FYEAR = date.getFullYear();
		m.FMONTH = date.getMonth();
		m.FDATE = date;
		m.FREGDATE = FREGDATE.value;
		m.FCURRENT = Number(tbl.getValue("COUNT_END"));
		m.FPREVIOUS = Number(tbl.getValue("COUNT_BEGI"));
		m.FDIFFERENCE = Number(tbl.getValue("EXPENS"));
		var bRet = UpdateTable(sTmpTbl, m, true);
		if(bRet)
		{
			nRow++;
		}
		else
		{
			var cnt = confirm(UR("Продовжити імпорт?|Продолжить импорт?"), "", "IMPORTHEAT");
			if(!cnt)
				return;
		}
		//if(nRow>10)
		//	break;
	}
	setProgressPos(0);
	
	grid.getTable().requery();
	grid.refresh();
	calcTotals();
	
	alert(UR("Завантажено рядків: |Загружено строк: ") + nRow +"/"+ recordCnt);
	
	var oSnap = getSnap("select count(*) as cnt from "+ sImportTbl);
	if(oSnap && Number(oSnap[0])>0)
	{
		alert(UR("Не знайдено лічильників: |Не найдено счетчиков: ") + oSnap[0]);
		var p = new Object();
		p.caption = UR("Не знайдені лічильники|Не найденные счетчики");
		browse("select * from "+ sImportTbl, p, SW_MODAL);
	}
}

function calcTotals()
{
	var date = FDATE.value;
	var d1 = firstDay(date);
	var d2 = lastDay(date);
	var oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF from "+ sTmpTbl +" where FTYPE=1 or FTYPE=0");
	if(oSnap)
	{
		LCOUNTER1.setText(UR(" Квартирні | Квартирные ") + "("+ oSnap[0] +")");
		FCOUNTER1.value = oSnap[1];
	}
	if(!oSnap || oSnap[0]==0)
	{
		oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF"
						+" from ^COUNTERS"
						+" where FHOUSE="+ oHouse.getFWID() 
							+" and (FTYPE=1 or FTYPE=0 or FTYPE=3)"
							+" and FSERV="+ sqlTo(FSERV.value)
							+" and FID_DOG>0"
							+" and FDATE between "+ sqlTo(d1) +" and "+ sqlTo(d2) 
						);
		if(oSnap)
		{
			LCOUNTER1.setText(UR(" Квартирні | Квартирные ") + "("+ oSnap[0] +")");
			FCOUNTER1.value = oSnap[1];
		}
	}
	oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF from "+ sTmpTbl +" where FTYPE=2 or FID_DOG=0");
	if(oSnap && Number(oSnap[0])>0)
	{
		LCOUNTER2.setText(UR(" Домові | Домовые ") + "("+ oSnap[0] +")");
		FCOUNTER2.value = oSnap[1];
	}
	else
	{
		oSnap = getSnap("select sum(FKOL), sum(FNORM)"
						+" from ^WATER"
						+" where FHOUSE="+ oHouse.getFWID() 
							+" and FSERV="+ sqlTo(FSERV.value)
							+" and FDATE between "+ sqlTo(d1) +" and "+ sqlTo(d2) 
						, false
						);
		if(oSnap)
		{
			FCOUNTER2.value = oSnap[0];
			FNORM.value = oSnap[1];
		}
	}
	/*
	oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF from "+ sTmpTbl +" where FTYPE=3");
	if(oSnap)
	{
		LCOUNTER3.setText(UR(" Комунальні | Коммунальные ") + "("+ oSnap[0] +")");
		FCOUNTER3.value = oSnap[1];
	}*/
	/*
	oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF from "+ sTmpTbl +" where FTYPE=4");
	if(oSnap)
	{
		LCOUNTER4.setText(UR(" Контрольні | Контрольные ") + "("+ oSnap[0] +")");
		FCOUNTER4.value = oSnap[1];
	}*/
	
	oSnap = getSnap("select count(*) as cnt, sum(FDIFFERENCE) as FDIF"
					+" from "+ sTmpTbl +" t"
						+" inner join ^LISTCL c on c.FCOD=t.FORG and c.FCL="+ getPar("CODPLAT")
						+" inner join ^CL_POST p on p.FWID_CL=c.FWID"
					+" where p.FCAT=0"
					);
	if(oSnap)
	{
		LCOUNTER5.setText(UR(" Споживачі | Потребители ") + "("+ oSnap[0] +")");
		FCOUNTER5.value = oSnap[1];
		if(Number(FCOUNTER1.value)>oSnap[1])
			FCOUNTER1.value = Number(FCOUNTER1.value)-oSnap[1];
		else
			FCOUNTER1.value = 0;
	}
	
	FBALANCE.value = 0;
	if(Number(FCOUNTER2.value)>0)
		FBALANCE.value = Number(FCOUNTER2.value)-Number(FCOUNTER1.value)-Number(FCOUNTER5.value);	//-Number(FCOUNTER3.value)
	
	var days = getDaysInMonth(date);
	var serv = String(FSERV.value).trim();
	var sTmpCnt = getTmpTableName();
	ExecuteSQL("select c.* into "+ sTmpCnt 
				+" from ^SC_COUNTERS c"
					+" inner join ^LICSC l on c.FID_DOG=l.FID_DOG"
				+" where l.FHOUSE="+ oHouse.getFWID()
					+" and c.FSERV="+ sqlTo(serv)
					+" and c.FBDAT<="+ sqlTo(d2)
					+" and c.FEDAT>="+ sqlTo(d1)
				);
	ExecuteSQL("alter table "+ sTmpCnt +" add FDAYS "+ sqlType("DOUBLE"), false);
	ExecuteSQL("update "+ sTmpCnt 
						+" set FDAYS="
							+ IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT>="+ sqlTo(d2), SqlDaysBWDates("FBDAT", sqlTo(d2)) +"+1"
							, IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates("FBDAT", "FEDAT") +"+1"
							, IIF("FBDAT<="+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates(sqlTo(d1), "FEDAT") +"+1"
							, days)))
						);
	/*
	oSnap = getSnap("select count(*) as cnt"
					+" from ^SC_MEN m"
						+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
					+" where m.FBDAT<="+ sqlTo(d2)
						+" and m.FEDAT>="+ sqlTo(d1)
						+" and l.FHOUSE="+ oHouse.getFWID()
						//+" and m.FID_DOG not in (select FID_DOG from "+ sTmpTbl +")"
						//+" and l.FGRPID in (select FID_PAR from "+ sTmpTbl +" where FID_PAR<>0)"
						+" and not exists (select FID_DOG c from "+ sTmpCnt +" c"
										+" where c.FID_DOG=l.FID_DOG"
											//+" and c.FSERV in (select FSERV from "+ sTmpTbl +")"
											+" and c.FBDAT<="+ sqlTo(d1)
											+" and c.FEDAT>="+ sqlTo(d2)
											+")"
					);
	*/
	var sTmpMen = getTmpTableName();
	var sSQL = "select m.* into "+ sTmpMen
			+" from ^SC_MEN m"
			+" inner join ^LICSC l on m.FID_DOG=l.FID_DOG"
			+" inner join ^CONTRACT contr on contr.FWID=l.FID_DOG"
			+" where m.FBDAT<="+ sqlTo(d2)
				+" and m.FEDAT>="+ sqlTo(d1)
				+" and contr.FBDAT<="+ sqlTo(d2)
				+" and contr.FEDAT>="+ sqlTo(d1)
				+" and l.FHOUSE="+ oHouse.getFWID()
				+" and exists (select s.FID_DOG from ^SC_SERV s"
								+" where s.FID_DOG=l.FID_DOG"
									+" and s.FBDAT<="+ sqlTo(d2) 
									+" and s.FEDAT>="+ sqlTo(d1) 
									+" and s.FSERV in (select FSERV from "+ sTmpTbl +"))"
				+" and not exists (select c.FID_DOG from "+ sTmpCnt +" c"
								+" where c.FID_DOG=l.FID_DOG"
									//+" and c.FSERV in (select FSERV from "+ sTmpTbl +")"
									+" and c.FBDAT<="+ sqlTo(d1)
									+" and c.FEDAT>="+ sqlTo(d2)
									+")"
	ExecuteSQL(sSQL);
	
	ExecuteSQL("alter table "+ sTmpMen +" add FDAYS "+ sqlType("DOUBLE"), false);
	ExecuteSQL("update "+ sTmpMen 
						+" set FDAYS="
							+ IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT>="+ sqlTo(d2), SqlDaysBWDates("FBDAT", sqlTo(d2)) +"+1"
							, IIF("FBDAT>"+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates("FBDAT", "FEDAT") +"+1"
							, IIF("FBDAT<="+ sqlTo(d1) +" and FEDAT<"+ sqlTo(d2), SqlDaysBWDates(sqlTo(d1), "FEDAT") +"+1"
							, days)))
						);
	oSnap = getSnap("select "+ sqlRound("sum(FDAYS/"+ Convert(days, "DBL") +")", 3)+" from "+ sTmpMen);
	var menCount = Number(oSnap[0]);
		
	oSnap = getSnap("select "+ sqlRound("sum(c.FDAYS/"+ Convert(days, "DBL") +")", 3)+" from "+ sTmpCnt +" c inner join "+ sTmpMen +" m on m.FID_DOG=c.FID_DOG where c.FDAYS<"+ days);
	var cntCount = Number(oSnap[0]);
	
	//browse("select FID_DOG,FBDAT,FEDAT,FDAYS from "+ sTmpMen +" order by FID_DOG");
	//browse("select FID_DOG,FBDAT,FEDAT,FDAYS from "+ sTmpCnt +" order by FID_DOG");
	menCount -= cntCount;
	
	
	FMENKOL.value = 0;
	FMENBIL.value = 0;
	FMENCOUNT.value = menCount;
		
	FRECALC.value = 0;
	/*
	oSnap = getSnap("select sum(s.FKOL) as FKOL"
					+" from ^SKU_SERV s"
						+" inner join ^RAS_SKU h on h.FWID=s.FID_DOC"
						+" inner join ^LICSC l on l.FID_DOG=s.FID_DOG"
						+" inner join "+ sTmpTbl +" t on t.FID_DOG=s.FID_DOG"
						+" where h.FISRECALC="+ sqlTrue 
							+" and h.FBIL_DAT between "+ sqlTo(d1) +" and "+ sqlTo(d2) 
							+" and s.FSERV in (select FSERV from "+ sTmpTbl +")"
					);
	if(oSnap)
		FRECALC.value = -oSnap[0];
	oSnap = getSnap("select sum(s.FKOL) as FKOL"
					+" from ^SKU_SERV s"
						+" inner join ^RAS_SKU h on h.FWID=s.FID_DOC"
						+" inner join ^LICSC l on l.FID_DOG=s.FID_DOG"
						+" where h.FISRECALC="+ sqlTrue 
							+" and h.FBIL_DAT between "+ sqlTo(d1) +" and "+ sqlTo(d2) 
							+" and s.FSERV in (select FSERV from "+ sTmpTbl +")"
							+" and l.FHOUSE in (select FHOUSE from "+ sTmpTbl +")"
							+" and not exists (select c.FID_DOG from "+ sTmpCnt +" c where c.FID_DOG=s.FID_DOG)"
					);
	if(oSnap)
		FRECALC.value = Number(FRECALC.value)+oSnap[0];
	oSnap = getSnap("select sum(s.FKOL) as FKOL"
					+" from ^SKU_SERV s"
						+" inner join ^RAS_SKU h on h.FWID=s.FID_DOC"
						+" inner join ^LICSC l on l.FID_DOG=s.FID_DOG"
						//+" inner join "+ sTmpTbl +" t on t.FID_DOG=s.FID_DOG"
						+" where s.FDATE between "+ sqlTo(d1) +" and "+ sqlTo(d2) 
							+" and s.FSERV in (select FSERV from "+ sTmpTbl +")"
							+" and l.FHOUSE in (select FHOUSE from "+ sTmpTbl +")"
							+" and not exists (select c.FID_DOG from "+ sTmpCnt +" c where c.FID_DOG=s.FID_DOG)"
					);
	*/
	if(Number(FMENCOUNT.value)!=0)
	{
		//if(oSnap && Number(oSnap[0]))
		//	FMENBIL.value = Number(oSnap[0])/Number(FMENCOUNT.value);
		FMENKOL.value = (Number(FBALANCE.value)+Number(FRECALC.value))/Number(FMENCOUNT.value);
	}
	ExecuteSQL("drop table"+ sTmpCnt, false);
}



function saveRecord(sMode, sCol, oCtrl)
{
	if(sMode=="ADD")
		return false;
	var tbl = grid.getTable();
	var curr = Number(tbl.getValue("FCURRENT"));
	var prev = Number(tbl.getValue("FPREVIOUS"));
	if(curr!=0 && curr<prev)
	{
		WAIT(UR("Не коректне значення|Не корректное значение"));
		var nRow = grid.getRowSelected();
		grid.setRowSelected(nRow-1);
		return false;
	}
	if(curr>prev && prev>0)
		tbl.setValue("FDIFFERENCE", curr-prev);
	return true;
}

function afterEditHandler()
{
	var rowID = grid.getTable().getRowID();
	ExecuteSQL("update "+ sTmpTbl +" set FDIFFERENCE=(FCURRENT-FPREVIOUS)");
	var nRow = grid.getRowSelected();
	grid.getTable().requery();
	grid.setRowSelected(nRow);
	grid.refresh();
}

function loadCounters()
{
	WAIT(UR("Завантаження даних . . .|Загрузка данных . . ."));
	ExecuteSQL("delete from "+ sTmpTbl);
	var date = new Date(FREGDATE.value);
	var dat1 = firstDay(date);
	var dat2 = lastDay(date);
	var cnt = Number(FCOUNTER.value);
	var serv = "";
	if(FSERV.value)
		serv = String(FSERV.value).trim().toUpperCase();
	var orgCat = Number(FCAT.value);
	if(extPar.mode=="BALANCE")
	{
		var fld = GetPatternIntersection("COUNTERS", "COUNTERS");
		ExecuteSQL("insert into "+ sTmpTbl +"("+ fld +")"
					+" select "+ fld
					+" from ^COUNTERS"
					+" where FREGDATE>="+ sqlTo(dat1)
						+" and FREGDATE<="+ sqlTo(dat2)
						//+(oNode.getCod()? " and FNODE="+ oNode.getCod(): "")
						+(orgCat<2? " and FORG in (select FCOD from ^LISTCLORG where FCAT="+ orgCat +")" : "")
						+(oOrg.getCod()? " and FORG="+ oOrg.getCod() : "")
						+(oStreet.getCod()? " and FSTREET="+ oStreet.getFWID() : "")
						+(oHouse.getFWID()?" and FHOUSE="+ oHouse.getFWID() : "")
						+(serv!=""? " and FSERV="+ sqlTo(serv) : "")
						+(cnt? " and FTYPE="+ sqlTo(cnt) : "")
						+(extPar.counter? " and FCOUNTER="+ extPar.counter : "")
						+(extPar.fid_dog? " and (FID_DOG="+ extPar.fid_dog 
							+" or FID_PAR="+ extPar.fid_dog 
							+(extPar.fid_par? " or FID_DOG="+ extPar.fid_par 
								+" or FID_PAR="+ extPar.fid_par : "")
								+")" : "")
					);
	}
	else if(extPar.mode=="RECALC")
	{
		//date = extPar.date;
		var fld = GetPatternIntersection("COUNTERS", "COUNTERS");
		var tmpTbl = getTmpTableName();
		ExecuteSQL("select FCOUNTER into "+ tmpTbl +" from ^COUNTERS where "+ extPar.where);
		ExecuteSQL("insert into "+ sTmpTbl +"("+ fld +")"
					+" select "+ fld
					+" from ^COUNTERS"
					+" where FDATE>="+ sqlTo(date)
						+(serv!=""? " and FSERV="+ sqlTo(serv) : "")
						+(cnt? " and FTYPE="+ sqlTo(cnt) : "")
						+" and FCOUNTER in (select FCOUNTER from "+ tmpTbl +")"
					);
		ExecuteSQL("drop table "+ tmpTbl, false);
		//loadPreviousReg(date);
		ExecuteSQL("alter table "+ sTmpTbl +" add FCURRENT_OLD "+ sqlType("DOUBLE"), false);
		ExecuteSQL("alter table "+ sTmpTbl +" add FPREVIOUS_OLD "+ sqlType("DOUBLE"), false);
		ExecuteSQL("alter table "+ sTmpTbl +" add FDIFFERENCE_OLD "+ sqlType("DOUBLE"), false);
		ExecuteSQL("update "+ sTmpTbl 
					+" set FISRECALC="+ sqlTrue 
						+", FCURRENT_OLD=FCURRENT"
						+", FPREVIOUS_OLD=FPREVIOUS"
						+", FDIFFERENCE_OLD=FDIFFERENCE"
					);
		ExecuteSQL("update "+ sTmpTbl +" set FPREVIOUS=FCURRENT, FDIFFERENCE=0, FREGDATE="+ sqlTo(FREGDATE.value));
		
		var tmp2 = getTmpTableName();
		ExecuteSQL("select FCOUNTER, max(FWID) as FWID, max(FDATE) as FDATE"
					+" into "+ tmp2 +" from "+ sTmpTbl +" group by FCOUNTER, FDATE"
					);
		ExecuteSQL("update "+ sTmpTbl +" set FLAST="+ sqlTrue
				+" where exists (select s.FCOUNTER"
					+" from "+ tmp2 +" s"
					+" where s.FWID="+ sTmpTbl +".FWID"
					+")"
				);
	}
	else
	{
		var sSQL = "insert into "+ sTmpTbl 
				+" (FCOUNTER,FNUM,FSERIAL,FTYPE,FPLACE,FSERV,FID_DOG,FINPUT,FPOINT"
				+",FISCHECK,FBDATCHECK,FEDATCHECK,FCHECKMIDDLE,FMIDDLE"
				+",FID_PAR,FORG,FNODE,FSTREET,FHOUSE,FAPMT"
				+",FYEAR,FMONTH,FDATE,FREGDATE,FISRECALC"
				+")"
			+" select sc.FWID,sc.FNUM,sc.FSERIAL,sc.FTYPE,sc.FPLACE,sc.FSERV,sc.FID_DOG,sc.FINPUT,sc.FPOINT"
				+",sc.FISCHECK,sc.FBDATCHECK,sc.FEDATCHECK,sc.FCHECKMIDDLE,sc.FMIDDLE"
				+",l.FGRPID,c.FORG,l.FNODE,l.FSTREET,l.FHOUSE,l.FAPMT"
				+","+ sqlTo(date.getFullYear()) 
				+","+ sqlTo(date.getMonth()+1) 
				+","+ sqlTo(date) +","+ sqlTo(FREGDATE.value)
				+","+ sqlTo(extPar.mode=="RECALC")
			+" from ^SC_COUNTERS sc "
				+" inner join ^LICSC l on l.FID_DOG=sc.FID_DOG"
				+" inner join ^CONTRACT c on c.FWID=sc.FID_DOG"
			+" where sc.FBDAT<="+ sqlTo(dat2) +" and sc.FEDAT>="+ sqlTo(dat1)
				+" and c.FBDAT<="+ sqlTo(dat2) +" and c.FEDAT>="+ sqlTo(dat1)
				+" and sc.FID_CNT=0"
				//+(oNode.getCod()? " and l.FNODE="+ oNode.getCod(): "")
				+(oOrg.getCod()? " and c.FORG="+ oOrg.getCod() : "")
				+(orgCat<2? " and FORG in (select FCOD from ^LISTCLORG where FCAT="+ orgCat +")" : "")
				+(oStreet.getCod()? " and l.FSTREET="+ oStreet.getFWID() : "")
				+(oHouse.getFWID()? " and l.FHOUSE="+ oHouse.getFWID() : "")
				+(serv!=""? " and sc.FSERV="+ sqlTo(serv) : "")
				+(cnt? " and sc.FTYPE="+ sqlTo(cnt) : "")
		ExecuteSQL(sSQL);
		
		if(!oOrg.getCod())
		{
			sSQL = "insert into "+ sTmpTbl 
					+" (FCOUNTER,FNUM,FSERIAL,FTYPE,FPLACE,FSERV,FID_DOG,FINPUT,FPOINT"
					+",FISCHECK,FBDATCHECK,FEDATCHECK,FCHECKMIDDLE,FMIDDLE"
					+",FSTREET,FHOUSE,FYEAR,FMONTH,FDATE,FREGDATE,FISRECALC)"
				+" select sc.FWID,sc.FNUM,sc.FSERIAL,sc.FTYPE,sc.FPLACE,sc.FSERV,sc.FID_DOG,sc.FINPUT,sc.FPOINT"
					+",sc.FISCHECK,sc.FBDATCHECK,sc.FEDATCHECK,sc.FCHECKMIDDLE,sc.FMIDDLE"
					+", h.FSTREET, sc.FWID_CL"
					+","+ sqlTo(date.getFullYear()) 
					+","+ sqlTo(date.getMonth()+1) 
					+","+ sqlTo(date) +","+ sqlTo(FREGDATE.value)
					+","+ sqlTo(extPar.mode=="RECALC")
				+" from ^SC_COUNTERS sc "
					+" inner join ^CL_HOUSE h on h.FWID_CL=sc.FWID_CL"
				+" where sc.FID_DOG=0"
					+" and sc.FBDAT<="+ sqlTo(dat2) +" and sc.FEDAT>="+ sqlTo(dat1)
					+(oHouse.getFWID()? " and sc.FWID_CL="+ oHouse.getFWID() : "")
					+(serv!=""? " and sc.FSERV="+ sqlTo(serv) : "")
					+(cnt? " and sc.FTYPE="+ sqlTo(cnt) : "")
			ExecuteSQL(sSQL);
		}
		
		ExecuteSQL("update "+ sTmpTbl +" set FBUG="+ sqlTrue
				+" where exists (select s.FCOUNTER"
				+" from ^COUNTERS s where s.FCOUNTER="+ sTmpTbl +".FCOUNTER"
					+" and s.FISRECALC="+ sqlFalse
					+" and s.FKOL<>0"
					+" and s.FDATE>="+ sqlTo(dat1) 
					+" and s.FDATE<="+ sqlTo(dat2) 
					+")"
				);
		
		loadPreviousReg(date);
	}
	
	grid.getTable().requery();
	grid.refresh();
	grid.setFocus();
	
	calcTotals();
	
	CLEARWAIT();
}

function loadPreviousReg(date)
{
	WAIT(UR("Завантаження даних . . .|Загрузка данных . . ."));
	var sSQL = "update "+ sTmpTbl +" set FPREVIOUS=("
				+" select c.FCURRENT from ^COUNTERS c"
				+" where c.FCOUNTER="+ sTmpTbl +".FCOUNTER"
					+" and c.FDATE<="+ sTmpTbl +".FDATE"
					+" and c.FCURRENT>0"
				+" order by c.FDATE desc, c.FWID desc limit 1)"
			+" where exists (select c.FCURRENT from ^COUNTERS c"
					+" where c.FCOUNTER="+ sTmpTbl +".FCOUNTER"
						+" and c.FDATE<="+ sTmpTbl +".FDATE"
						+" and c.FCURRENT>0"
						+")";
	ExecuteSQL(sSQL);
	CLEARWAIT();
}

function onSave()
{
	var oSnap = getSnap("select FKOL from "+ sTmpTbl +" where FDIFFERENCE=0");
	if(oSnap)
	{
		if(!confirm(UR("Зберегти нульові показники?|Сохранить нулевые показания?")))
			ExecuteSQL("delete from "+ sTmpTbl +" where FDIFFERENCE=0");
	}
	WAIT(UR("Збереження даних . . .|Сохранение данных . . ."));
	var oSnap = getSnap("select max(FWID) as FWID from "+ sTmpTbl);
	if(oSnap)
		GetUID(false, oSnap[0]);
	var oSnap = getSnap("select max(FWID) as FWID from ^COUNTERS");
	if(oSnap && Number(oSnap[0]))
	{
		ExecuteSQL("alter table "+ sTmpTbl +" add FWID2 "+ sqlType("LONG"));
		ExecuteSQL("update "+ sTmpTbl +" set FWID2=FWID+"+ oSnap[0]);
		ExecuteSQL("alter table "+ sTmpTbl +" drop FWID ");
		ExecuteSQL("alter table "+ sTmpTbl +" add FWID "+ sqlType("LONG"));
		ExecuteSQL("update "+ sTmpTbl +" set FWID=FWID2");
	}
	var date = new Date(FDATE.value);
	ExecuteSQL("update "+ sTmpTbl +" set FBILDATE="+ sqlTo(date));
	ExecuteSQL("update "+ sTmpTbl 
				+" set FMENKOL="+ FMENKOL.value 
					+", FNORM="+ FNORM.value
					+", FNORM2="+ FNORM2.value
					+", FMUSER="+ sqlTo(getUserName())
					+", FMHOST="+ sqlTo(getHostName())
					+", FMDATE="+ sqlTo(new Date())
				);
	var fld = GetPatternIntersection("COUNTERS", "COUNTERS");
	var sSQL = "insert into ^COUNTERS ("+ fld +")"
				+" select "+ fld 
				+" from "+ sTmpTbl
	ExecuteSQL(sSQL);
	/*
	var m = new Object();
	m.FWID = GetUID();
	m.FNODE = oNode.getCod();
	m.FSTREET = oStreet.getFWID();
	m.FHOUSE = oHouse.getFWID();
	m.FORG = oOrg.getCod();
	m.FDATE = FDATE.value;
	m.FREGDATE = FREGDATE.value;
	m.FSERV = FSERV.value;
	m.FTYPE = Number(FCOUNTER.value);
	m.FMENKOL = Number(FMENKOL.value);
	m.FNORM = Number(FNORM.value);
	if(m.FNORM>0)
		UpdateTable("^COUNTERS", m, true);
	*/
	if(oOrg.getCod() || extPar.mode=="RECALC")
		formSku();
	
	extPar.escape = false;
	exit();
}

function formSku()
{
	var oSnap = getSnap("select count(*) as cnt from "+ sTmpTbl);
	if(!oSnap || Number(oSnap[0])==0)
		return;
	var sMsg = UR("Сформувати нарахування?|Сформировать начисления?");
	if(!confirm(sMsg))
		return;
	
	var par = new Object();
	par.date = FDATE.value;
	par.street = oStreet.getFWID();
	par.house = oHouse.getFWID();
	par.org = oOrg.getCod();
	par.mode = extPar.mode;
	if(par.mode=="RECALC" && par.org)
	{
		par.cntRecalc = true;
		par.tCounters = sTmpTbl;
	}
	showWindow("e_sku.xml", SW_MODAL, par);
}

function onCancel()
{
	exit();
}

function exit()
{
	grid.getTable().close();
	ExecuteSQL("drop table "+ sTmpTbl, false);
	CloseWindow();
}

include("sys/DpList.js");