include("servis/dump.js");

var sTxt = UR("Імпорт даних з архіву|Импорт данных из архива");
var sDumpDir = DpFile(dumpDir()).getAbsolutePath();
var tmpTblDump = "TMP_RESTORE_TABLES";
var tmpTblFiles = "TMP_RESTORE_FILES";
var sAllBaseTxt = UR("усі|все");
var arrThread = new Array();
var oThread = null;
var oExec = null;
var sInfo = "";
var sError = "";
var startTime;
var divider = "";
var inZip = true;
var zip = false;
var source = "";
var sArchExt = "zip";

function listLoad()
{		
	FORM.setImage(rootDirectoryEx() +"/icons/imp.gif");
	
	FLOGIN.value = getDBUserName();
	DIR.value = sDumpDir;
	
	createTmpTbl();
	fillDBCombo(FBASE);
	loadParam();
	
	if(extPar)
	{		
		if(extPar.login)
			FLOGIN.value = extPar.login;
		if(extPar.password)
			FPASSWORD.value = extPar.password;
		if(extPar.path)
			DIR.value = sDumpDir = extPar.path;
		if(extPar.base)
			FBASE.value = extPar.base;
		if(extPar.isAdmin)
			GRPASSWORD.setVisible(false);
	}
	
	this.subUnLoad = onStop;
	this.title = sTxt;
		
	this.selectTables = selectTables;
	this.check_password = check_password;
	
	FSYSPASS.setModifyHandler(this, "check_password");
		
	setButton(BTN_SAVE, onSave);
	setButton(BTN_CANCEL, onCancel);
	setButton(BTN_STOP, onStop);
	setButton(BTN_SEARCH, loadFiles);
	
	setValid(FBASE, base_valid);
	//setValid(DIR, dir_valid);
	//setValid(ZIP, zip_valid);
	
	GRPROGRESS.setVisible(false);
		
	//Disable(FILE);
	Disable(BTN_STOP);
	Disable(FCONSOLE);
	
	EXT.value = sArchExt = archExt();
	
	if(!isDir(sDumpDir))
		createDirectory(sDumpDir);
	FILE.setFilterPath(sDumpDir);
	DIR.setFilterPath(sDumpDir);
	FILE.setFilterExtensions(new Array("*."+ sArchExt +";*.zip", "*."+ sArchExt, "*.*"));
	
	BTN_STOP.setImage(lpProxy.getWrkDir() +"/icons/Brown Square Button.gif");
	BTN_STOP.getCtrl().setToolTipText(UR("Зупинити пошук|Остановить поиск"));
	
	if(SUBD==DERBY)
	{
		alert(UR("Для DERBY іимпорт виконується вручну|Для DERBY импорт выплняется вручную"));
		return false;
	}
	else if(SUBD==ORACLE)
	{	
		setButton(FTABLES, this, "selectTables");
		LBASE.setText(UR("Схема-приймач: |Схема-приемник: "));		
		GRTABLES.setVisible(true);		
	}
		
	check_password();
	
	loadHistoryGrid();
}

function onSave()
{	
	if(isWin())
	{
		if(SUBD==POSTGRE)
		{
			var pgPath = postgreSQLPath();
			if(!pgPath || !isDir(pgPath))
			{
				var sMsg = UR(" Для імпорту в Postgre необхідно вказати шлях до системної папки PostgreSQL,"
								+"\n наприклад \"C:\\Program Files\\PostgreSQL\\9.0\""
							+"| Для импорта в Postgre необходимо указать путь к системной папке PostgreSQL,"
								+"\n например \"C:\\Program Files\\PostgreSQL\\9.0\""
							);
				pgPath = askDirectory(null, sMsg, UR("Вкажіть шлях до папки PostgreSQL|Укажите путь к папке PostgreSQL"));
				if(!pgPath)
					return false;
				setPar("POSTGRESQL_PATH", pgPath);
			}
		}
		if(SUBD==MYSQL)
		{
			var mySqlExe = exeDir() +"mysql.exe";
			if(!isFile(mySqlExe))
			{
				var mySqlPath = String(getPar("MYSQL_SERVER_PATH")).trim();
				if(!mySqlPath || mySqlPath=="" || !isFile(mySqlPath +"/bin/mysql.exe"))
				{
					var sMsg = UR(" Для імпорту в MySQL необхідно вказати шлях до MySQL Server,"
									+"\n наприклад \"C:\\Program Files\\MySQL\\MySQL Server 5.0\""
								+"| Для импорта в MySQL необходимо указать путь к MySQL Server,"
									+"\n например \"C:\\Program Files\\MySQL\\MySQL Server 5.0\""
								);
					mySqlPath = askDirectory(null, sMsg, UR("Вкажіть шлях до MySQL Server|Укажите путь к MySQL Server"));
					if(!mySqlPath)
					{				
						var sMsg = UR("	Для імпорту в MySQL необхідний файл "+ mySqlExe +"."
										+"\nЙого можна знайти у каталозі \\Program Files\\MySQL\\MySQL Server 5.0\\bin"
										+"\nі скопіювати у папку "+ exeDir() +"." 
										+"\n	Якщо Дебет запускається з ярлика на робочому столі,"
										+"\nпотрібно у властивостях ярлика для робочої папки прописати шлях "+ exeDir()
										+"\nі перезапустити Дебет."
										+"\n	Якщо не вдається знайти папку MySQL Server 5.0, значить потрібно установити MySQL."
										+"\n	Продовжити імпорт?"
									+"|	Для импорта в MySQL необходим файл "+ mySqlExe +"."
										+"\nЕго можно найти в каталоге \\Program Files\\MySQL\\MySQL Server 5.0\\bin"
										+"\nи скопировать в папку "+ exeDir() +"." 
										+"\n	Если Дебет запускается с ярлыка на рабочем столе,"
										+"\nнужно в свойствах ярлыка для рабочей папки прописать путь "+ exeDir()
										+"\nи перезапустить Дебет."
										+"\n	Если не удается найти папку MySQL Server 5.0, значит нужно установить MySQL."
										+"\n	Продолжить импорт?"
									);
						if(!confirm(sMsg))
							return false;
					}
					setPar("MYSQL_SERVER_PATH", mySqlPath);
				}
			}
		}
	}
	
	sArchExt = EXT.value;
	var file = FILE.value;
	//if(sDumpPath)
	//	file = sDumpPath +"/"+ FILE.value;
	
	if(!file || String(file).trim()=="")
	{
		alert(UR("Не вказаний архів|Не указан архив"));
		return false;
	}
		
	var path = new DpFile(file).getParent();
	if(isZip(path))
	{
		var sMsg = UR("Розпакування архіву . . .|Распаковка архива . . .");	
		INFO.setText(sMsg);
		WAIT(sMsg);
				
		var zipName = path;
		var sPath = new DpFile(zipName).getParent();
		var archName = new DpFile(file).getName();
		var sFile = sPath +"/"+ archName;
		if(isFile(zipName) && isFile(sFile))
		{
			deleteFile(sFile);
		}				
		
		extract(zipName, sPath, archName, false);
		
		if(isFile(sFile))
		{
			zip = true;
			file = sFile;
		}
		INFO.setText("");
		CLEARWAIT();	
	}
	
	if(isZip(file))
	{
		var sMsg = UR("Розпакування архіву . . .|Распаковка архива . . .");	
		INFO.setText(sMsg);
		
		var zipName = file;
		var sPath = new DpFile(file).getParent();
		var arrFile = lpProxy.searchInZip(zipName, "", sArchExt);
		if(!arrFile || arrFile.length==0)
		{
			var sMsg = UR("У архіві "+ zipName 
							+"\nне знайдено відповідних файлів типу *."+ sArchExt +"."
							+"\nНеобхідно спочатку розпакувати zip-архів,"
							+"\nа потім виконати імпорт."
						+"|В архиве "+ zipName 
							+"\nне найдены соответствующие файлы типа *."+ sArchExt +"."
							+"\nНеобходимо сначала распаковать zip-архив,"
							+"\nа затем выполнить импорт."
						);
			alert(sMsg);
			return false;
		}
		
		if(arrFile.length>1)
		{
			var sMsg = UR("У архіві "+ zipName 
							+"\nзнайдено декілька файлів типу *."+ sArchExt +" ("+ arrFile.length +")."
							+"\nНеобхідно спочатку розпакувати zip-архів,"
							+"\nа потім виконати імпорт, вказавши конкретний файл-джерело."
						+"|В архиве "+ zipName 
							+"\nнайдено несколько файлов типа *."+ sArchExt +" ("+ arrFile.length +")."
							+"\nНеобходимо сначала распаковать zip-архив,"
							+"\nа затем выполнить импорт, указав конкретный файл-источник."
						);
			alert(sMsg);
			return false;
		}
		
		var archName = new DpFile(arrFile[0]).getName();
		var sFile = sPath +"/"+ archName;
		if(isFile(zipName) && isFile(sFile))
		{
			deleteFile(sFile);
		}
		
		extract(zipName, sPath, archName, false);
		
		if(isFile(sFile))
		{
			zip = true;
			file = sFile;
		}
		
		INFO.setText("");
		CLEARWAIT();
	}
	
	if(!isFile(file))
	{
		alert(UR("Не знайдено файл |Не найден файл ") + file);
		return false;
	}
	
	source = file;
	
	var login = FLOGIN.value;
	var password = FPASSWORD.value;
	var baseTo = String(FBASE.value).replace(sAllBaseTxt, "").trim();
	var baseFrom = String(FBASE_SOURCE.value).trim();
	var tables = String(FTABLES.value).trim();
	var sServer = lpProxy.getOrgManager().getServer();
	if(SUBD==POSTGRE)
		sServer = lpProxy.getOrgManager().getComp();
		
	var connect = checkDBConnection(login, password);
	if(!connect)
	{
		alert(UR("Не вдалося встановити з'єднання.\nПеревірте логін і пароль."
				+"|Не удалось установить соединение.\nПроверте логин и пароль."));
		setFocus(FLOGIN);
		FLOGIN.getCtrl().setSelection(0, login.length());
		return false;
	}
	
	if((!baseFrom || baseFrom=="") && (baseTo && baseTo!=""))
	{
		baseFrom = baseTo;
	}
	
	if(!baseTo || baseTo=="")
	{
		if(SUBD==MSSQL)
		{
			setFocus(FBASE);
			return false;
		}
		var sMsg = UR("Не вказано схему!"
						+"\nБуде виконано імпорт усього файлу."												
						+"\nМожливе пошкодження існуючих схем."
						+"\nРекомендується спочатку виконати архівацію."						
					+"|Не указана схема!"						
						+"\nБудет выполнен импорт всего файла."
						+"\nВозможно повреждение существующих схем."
						+"\nРекомендуется сначала выполнить архивацию."						
					);
		var ret = msgBox("oc", sMsg, "Debet Plus");
		if(ret=="c")
		{
			setFocus(FBASE);
			return false;
		}
	}
	
	if(SUBD==MYSQL)
	{
		ExecuteSQL("UNLOCK TABLES");
	}
	
	var bDrop = false;
	if(baseTo && baseTo!="" && SUBD!=DERBY)
	{
		if(FBASE.getCtrl().indexOf(baseTo)!=-1)
		{
			var sMsg = UR("УВАГА! Схема '"+ baseTo +"' існує!"
							+"\nРекомендується спочатку виконати архівацію."												
							+"\nДля знищення схеми натисніть 'Так'."
							+"\nДля продовження імпорту без знищення схеми натисніть 'Продовжити'."
							+(SUBD==MYSQL? "\nТаблиці, що імпортуються будуть замінені. " : "")
							+"\nЗнищити схему?"
						+"|ВНИМАНИЕ! Схема '"+ baseTo +"' существует!"						
							+"\nРекомендуется сначала выполнить архивацию."
							+"\nДля уничтожения схемы нажмите 'Да'."
							+"\nДля продолжения импорта без уничтожения схемы нажмите 'Продолжить'."
							+(SUBD==MYSQL? "\nИмпортируемые таблицы будут заменены. " : "")
							+"\nУничтожить схему?"
						);
			var ret = msgBox("yoc", sMsg, "Debet Plus");
			if(ret=="c")
			{
				return false;
			}
			if(ret=="y")
			{				
				INFO.setText(UR("Вилучення |Удаление ") + baseTo);				
				bDrop = dropDatabase(baseTo, true, connect);
				if(!bDrop)
				{
					sMsg = UR("Не вдалося знищити схему |Не удалось уничтожить схему ") + baseTo 
						+"!\n"+ UR("Продовжити імпорт? |Продолжить импорт? ");
					ret = confirm(sMsg, "Debet Plus");
					if(!ret)
						return false;
				}
			}
		}
				
		createDatabase(baseTo, false, connect);				
	}
	
	//Enable(BTN_STOP);
	Disable(BTN_SAVE);
	
	if(oThread)
		oThread.stop();
	
	CLEARWAIT();
	
	var sMsg = UR("Виконується імпорт . . .|Выполняется импорт . . .");	
	INFO.setText(sMsg);
	//WAIT(sMsg);
	
	startTime = new Date();
	
	sError = "";
	sInfo = FCONSOLE.value;
	divider = "----------------------------------------------------";
	if(sInfo!="")
		sInfo += "\r\n\r\n";
	sInfo += "\r\n"+ divider +" "+ format("dd.mm.yyyy   HH:MM", startTime) +" "+ divider;
	if(bDrop)
		sInfo += "\r\n\r\n"+ UR("Вилучення|Удаление") +" \t"+ baseTo +"\r\n";
	sInfo += "\r\n"+ UR("Імпорт|Импорт") +" \t"+ file;
	if(sServer!="")
		sInfo += "\r\n"+ UR("Сервер|Сервер") +" \t"+ sServer;
	if(baseFrom && baseFrom!="" && baseFrom!=baseTo)
	{
		sInfo += "\r\n"+ UR("Схема-джерело|Схема-источник") +" \t"+ baseFrom;
		if(baseTo)
			sInfo += "\r\n"+ UR("Схема-приймач|Схема-приемник") +" \t"+ baseTo;
	}
	else if(baseTo)
	{
		sInfo += "\r\n"+ UR("Схема|Схема") +" \t\t"+ baseTo;
	}
	if(tables)
		sInfo += "\r\n"+ UR("Таблиці|Таблицы") +" \t"+ tables;	
	sInfo += "\r\n";
	
	FTAB.setSelection(1);
	
	FCONSOLE.value = sInfo;
	setFocus(FCONSOLE);
	FCONSOLE.getCtrl().setSelection(sInfo.length);
	saveImportLog(sInfo);
	
	GRPROGRESS.setVisible(true);
	PROGRESSBAR.setMinimum(0);
	PROGRESSBAR.setMaximum(100);
	PROGRESSBAR.setSelection(1);
		
	oExec = runDBImport(login, password, baseFrom, baseTo, tables, file);
	if(oExec)	
	{
		if(SUBD==MYSQL || SUBD==ORACLE)
		{	
			oThread = runInThread(waitImport, oExec);
			var execThread = runInThread(readExec, oExec);
			arrThread[arrThread.length+1] = execThread;
		}
		else
		{
			stopImport();
		}
		saveRegistration(baseTo);	
	}
	else
	{		
		sInfo += "\r\n"+ UR("Імпорт завершився невдало|Импорт завершился неудачно");
		sInfo += "\r\n"+ divider +" "+ format("dd.mm.yyyy   HH:MM", new Date()) +" "+ divider;
		FCONSOLE.value = sInfo;
		check_password();
		if(zip)
		{
			deleteFile(file);
		}
	}
	loadHistoryGrid();
}

function readExec()
{	
	try
	{		
		sError = getErrors();
		oExec.waitFor();
		oExec = null;
	}
	catch(e)
	{
		
	}
}

function waitImport()
{		
	var sMsg = UR("Виконується імпорт|Выполняется импорт");	
	var stt = "";	
	while(oExec && !isExit(oExec) && oThread)
	{		
		display.asyncExec
		(
			function runWait()
			{						
				try
				{		
					var nPr = PROGRESSBAR.getSelection()+1;
					if(nPr>100)
						nPr = 1;
					PROGRESSBAR.setSelection(nPr);
					
					var time = new Date(new Date()-startTime);	
					var stt = ": "+ format("00:MM:SS", time);
					//stt = (stt.length>5? "" : stt +" .");
					INFO.setText(sMsg + stt);
					WAIT(sMsg + stt);				
				}
				catch(e)
				{
					//trace(e)
				}				
			}
		);
				
		oThread.sleep(500);		
	}
	
	display.asyncExec
	(
		function end()
		{
			try
			{
				stopImport();
			}
			catch(e)
			{
				
			}			
		}
	);	
}

function isExit(oExec)
{
	try
	{
		var exitVal = oExec.exitValue();
		//return exitVal==1;
		return true;
	}
	catch(e)
	{
		return false;
	}
}

function getErrors()
{
	if(oExec)
	{
		var charset = "cp1251";
		if(SUBD==MYSQL)
			charset = "cp866";			
		return getExecError(oExec, charset);			
	}
	return "";
}

function stopImport()
{	
	try
	{		
		if(oExec)
			sError = getErrors();
		printInfo(sError);
		
		oExec = null;
		oThread = null;
		
		Enable(BTN_STOP, false);
		check_password();
		
		var sMsg = UR("Імпорт "+ source +" виконано|Импорт "+ source +" выполнен");
		if(sError && sError!="" && SUBD!=ORACLE)
			sMsg += UR(" з помилками| с ошибками");
				
		CLEARWAIT();	
		PROGRESSBAR.setSelection(0);
		INFO.setText(UR("Імпорт виконано|Импорт выполнен"));
		
		sInfo = FCONSOLE.value;
		if(SUBD!=ORACLE)
		{
			sInfo += "\r\n"+ UR("Імпорт виконано|Импорт выполнен");
			if(sError && sError!="")
				sInfo += UR(" з помилками| с ошибками");
		}
		
		var time = new Date(new Date()-startTime);	
		var sTime = format("00:MM:SS", time);
				
		sInfo += "\r\n"+ UR("Час виконання: |Время выполнения: ") + sTime;
		
		sInfo += "\r\n"+ divider +" "+ format("dd.mm.yyyy   HH:MM", new Date()) +" "+ divider +"\r\n";
		FCONSOLE.value = sInfo;
		FCONSOLE.getCtrl().setSelection(sInfo.length);
		
		saveImportLog(sInfo);				
		
		var base = String(FBASE.value).replace(sAllBaseTxt, "").trim();
			
		if(SUBD==MYSQL && base)
		{
			var sUser = getDBUserName();
			sMsg += "\n"+ UR("Встановити права на схему "+ base +" для користувача "+ sUser +"?"
							+"|Установить права на схему "+ base +" для пользователя "+ sUser +"?");
			if(confirm(sMsg))
			{
				var arrBase = base.split(",");
				for(var i=0; i<arrBase.length; i++)
				{
					var sBase = String(arrBase[i]).trim();
					setDBPrivileges(sUser, sBase);
				}
			}
		}
		else
		{
			alert(sMsg);
		}
		
		loadRegistration(base);
		importRegistration(FLOGIN.value, FBASE.value, FTABLES.value, source, "");
		loadHistory();
		
		if(zip)
		{
			deleteFile(source);
		}
	}
	catch(e)
	{
		
	}
}

function printInfo(sError)
{
	if(!sError)
		return;
	try
	{					
		trace(sError);
		var str = sInfo +"\r\n"+ sError;
		FCONSOLE.value = str;
		FCONSOLE.getCtrl().setSelection(str.length);
		saveImportLog(FCONSOLE.value);
	}
	catch(e)
	{
		
	}	
}

function onStop()
{
	try
	{
		if(oThread)
			oThread.stop();
		oThread = null;
		
		if(oExec)
			oExec.destroy();
		oExec = null;
		
		for(var i=0; i<arrThread.length; i++)
		{
			var subThread = arrThread[i];
			if(subThread)
				subThread.stop();
		}
		
		INFO.setText("");
		PROGRESSBAR.setSelection(0);
		CLEARWAIT();
		
		check_password();	
	}
	catch(e)
	{
		
	}
}

function check_password()
{
	if(!FSYSPASS || FSYSPASS.isDisposed() || !FSYSPASS.isVisible())
	{
		Enable(BTN_SAVE);
		return true;
	}
	var pass = String(FSYSPASS.value);
	if(pass=="150301")
	{
		Enable(BTN_SAVE);
		return true;
	}
	else
	{
		Enable(BTN_SAVE, false);
	}
	return false;	
}

function onCancel()
{
	onStop();
	CloseWindow();
}

function loadParam()
{
	var sTbl = dumpTblName(FBASE.value);
	var oSnap = getSnap("select FLOGIN,FPASSWORD,FBASE,FPATH "
						+" from "+ sTbl
						+" order by FDATE desc"
						, false
					);
	if(!oSnap)
		return false;
	
	if(oSnap[0])
		FLOGIN.value = oSnap[0];	
	if(oSnap[3] && isDir(oSnap[3]))
		DIR.value = oSnap[3];	
}

function fillDBCombo(oCtrl)
{
	if(SUBD==MYSQL || SUBD==ORACLE)
		oCtrl.addItem("", "");
	var arrBase = lpProxy.getDBManager().getDatabases();
	for (var nB = 0; nB < arrBase.length; nB++)
	{
		var sBase = String(arrBase[nB]).toLowerCase();
		oCtrl.addItem(sBase, arrBase[nB]);		
	}
	oCtrl.value = "";	
}

function selectTables()
{
	if(!IsTable(tmpTblDump))
	{
		var sSQL = "CREATE TABLE " + tmpTblDump
				 + "("
				 	+ " FWID "+ SqlType("LONG")
				 	+ ",FNAME"+ SqlType("TEXT",254)
				 + ")";
		ExecuteSQL(sSQL);
		fillTables(FBASE.value);		
	}
	
	var par = new Object();
	par.ret = new Object();
	par.ret.FNAME = "";
	
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FNAME";
	par.cells[1].width = 15;
	par.cells[1].text = UR("Таблиця|Таблица");
	
	par.caption = UR("Таблиці|Таблицы");
	var tbl = OpenTable("select * from "+ tmpTblDump +" order by FNAME");
	browse(tbl, par, SW_MODAL);
	tbl.close();
	
	if(par.ret.FNAME)
	{
		var sTbl = String(FTABLES.value).trim();
		if(sTbl)
			sTbl += ", ";
		FTABLES.value = sTbl + par.ret.FNAME;
	}
}

function fillTables(sBase)
{
	ExecuteSQL("DELETE FROM "+ tmpTblDump, false);
	if (sBase == null || sBase == "")
		sBase = getPath("ALL_MDB");
	var tblArr = lpProxy.getDBManager().getTables(sBase, "TABLE");
	var batch = createBatch();
	for (var nTbl = 0; nTbl < tblArr.length; nTbl++)
	{
		var insSQL = "INSERT INTO "+ tmpTblDump
				   	+ " VALUES ("
				   		+ sqlTo(nTbl)
				   		+ "," + sqlTo(tblArr[nTbl])
				   	+ ")";
		batch.addBatch(insSQL);
	}
	batch.execute(false);
}

function dir_valid()
{
	if(DIR.value==sDumpDir)
		return true;
	loadFiles();
}

function loadFiles()
{			
	sArchExt = EXT.value;
	sDumpDir = DIR.value;
	FILE.setFilterPath(sDumpDir);
	DIR.setFilterPath(sDumpDir);
	
	ExecuteSQL("delete from "+ tmpTblFiles, false);
	grid.getTable().requery();
	grid.refresh();
	
	var sPath = DIR.value;
	if(!isDir(sPath))
	{
		DIR.setBackground(0xFFAAAA);
		grid.getTable().requery();
		grid.refresh();
		return false;
	}
	DIR.setBackground(0xFFFFFF);
		
	var mainList = DpFile(sPath).listFiles();
	if(!mainList)
		return false;
		
	INFO.setText(UR("Пошук архівів|Поиск архивов"));
	GRPROGRESS.setVisible(true);
	PROGRESSBAR.setMinimum(0);
	PROGRESSBAR.setMaximum(mainList.length);
	PROGRESSBAR.setSelection(0);
	
	Enable(BTN_STOP);
	
	CLEARWAIT();
	if(oThread)
		oThread.stop();
	
	//inZip = String(EXT.value).indexOf("zip")!=-1;
	
	oThread = runInThread(searchArch, sPath);	

	grid.getTable().requery();
	grid.refresh();
}

function searchArch(sPath)
{
	var mainList = DpFile(sPath).listFiles();
	if(!mainList)
		return false;
	
	for (var n=0; n<mainList.length; n++)
	{
		var file = mainList[n];
		if (file.isDirectory())
		{
			var nThread = arrThread.length+1;
			var par = new Array(nThread, file.getAbsolutePath());
			var newThread = runInThread(search, par);
			arrThread[nThread] = newThread;
			//searchProgress(nArch);
			continue;
		}		
		
		var sName = String(file.getName());		
		if(isArch(sName))
		{
			insertFile(file);			
			searchProgress();
		}
		if(inZip && isZip(sName))
		{
			searchInZip(file);
			searchProgress();
		}
	}
	
	for(var i=0; i<arrThread.length; i++)
	{
		if(!oThread)
			break;		
		var subThread = arrThread[i];		
		if(subThread && subThread.isAlive())
		{		
			while(arrThread[i] && arrThread[i].isAlive() && oThread)
			{
				oThread.sleep(500);
			}
		}		
	}
	stopProgress();
}

function search(oPar)
{	
	try
	{
		fillFiles(oPar[1]);
		searchProgress(oPar[1]);	
		if(arrThread[oPar[0]])
		{
			arrThread[oPar[0]].stop();
			arrThread[oPar[0]] = null;
		}
	}
	catch(e)
	{
		
	}		 
}

function fillFiles(sPath)
{	
	try
	{
		var fileList = DpFile(sPath).listFiles();
		if(!fileList)
		{		
			return false;
		}
		
		for (var n=0; n<fileList.length; n++)
		{
			var file = fileList[n];
			if (file.isDirectory())
			{
				if(arrThread.length>10000)
				{
					fillFiles(file.getAbsolutePath());
					continue;
				}
				var newThread = runInThread(fillFiles, file.getAbsolutePath());
				arrThread[arrThread.length+1] = newThread;
				continue;			
			}
			var sName = String(file.getName());		
			if(isArch(sName))
			{
				insertFile(file);			
			}
			if(inZip && isZip(sName))
			{
				searchInZip(file);
			}
		}
	}
	catch(e)
	{
		
	}
}

function searchInZip(zipFile)
{
	var sZip = zipFile.getAbsolutePath();
	var arrFile = lpProxy.searchInZip(sZip, "", sArchExt);
	if(!arrFile || arrFile.length<=0)
		return;
	for(var n=0; n<arrFile.length; n++)
	{
		var file = arrFile[n];
		var m = new Object();
		m.FWID = GetUID();	
		m.FNAME = new DpFile(file).getName();
		m.FDATE = new Date(zipFile.lastModified());
		m.FSIZE = round(file.getSize()/1000000, 3);
		m.FPATH = zipFile.getAbsolutePath();
		m.FTYPE = "ZIP";				
		UpdateTable(tmpTblFiles, m, true);
	}
}

function searchProgress(sPath)
{		
	display.asyncExec
	(
		function runProg()
		{
			try
			{
				grid.getTable().requery();
				grid.getTable().setAbsolute(1);
				grid.refresh();
				
				var nArch = grid.getTable().recordCount;
				var nPr = PROGRESSBAR.getSelection()+1;
				PROGRESSBAR.setSelection(nPr);
				
				var sMsg = UR("Пошук архівів: |Поиск архивов: ") + nArch;			
				if(sPath)
					sMsg += " 		"+ sPath;
				INFO.setText(sMsg);
			}
			catch(e)
			{
				
			}
		}
	);	
}

function stopProgress()
{
	var sMsg = UR("Знайдено архівів: |Найдено архивов: ");
	display.asyncExec
	(
		function stopProg()
		{
			try
			{
				grid.getTable().requery();
				grid.getTable().setAbsolute(1);
				grid.refresh();
				
				var nArch = grid.getTable().recordCount;
				PROGRESSBAR.setSelection(0);
				INFO.setText(sMsg + nArch);
				
				Enable(BTN_STOP, false);
			}
			catch(e)
			{
				
			}
		}
	);
}

function isArch(sName)
{
	if(!sName)
		return false;
	var ext = "."+ sArchExt;
	sName = sName.toLowerCase();	
	return sName.endsWith(ext);	
}

function isZip(sName)
{
	if(!sName)
		return false;
	sName = sName.toLowerCase();
	return sName.endsWith(".zip");
}

function insertFile(file)
{
	var path = file.getParent();
	var sName = file.getName();
	var date = new Date(file.lastModified());
	var size = round(file.length()/1000000, 3);
		
	var m = new Object();
	m.FWID = GetUID();	
	m.FNAME = sName;
	m.FDATE = date;
	m.FSIZE = size;
	m.FPATH = path;
	m.FTYPE = "";
	if(isZip(sName))
		m.FTYPE = "ZIP";
	
	UpdateTable(tmpTblFiles, m, true);	
}

function createTmpTbl()
{
	if(!ExecuteSQL("drop table "+ tmpTblFiles, false))
		ExecuteSQL("delete from "+ tmpTblFiles, false);
		
	var sSQL = "create table "+ tmpTblFiles 
				+" (FDATE "+ sqlType("DATE") 
				+", FNAME "+ sqlType("TEXT", 250)
				+", FTYPE "+ sqlType("TEXT", 25)
				+", FSIZE "+ sqlType("DOUBLE")
				+", FPATH "+ sqlType("LONGTEXT")
				+", FWID "+ sqlType("LONG")
				+", FNUM "+ sqlType("INT")
				+")";
	ExecuteSQL(sSQL, false);
}

function listSrc()
{
	this.qrySet("From", tmpTblFiles, "Order", "FDATE desc, FNAME desc, FPATH");
}

function listDpGrid()
{
	grid.FieldEx("FDATE", "Дата|Дата", 12);
	grid.FieldEx("FNAME", "Назва|Название", 20);	
	grid.FieldEx("FSIZE", "Розмір, Мб|Размер, Мб", 12, "", DP_FORMAT_KOL);
	grid.FieldEx("FPATH", "Шлях|Путь", 20);
	/*
	var tbl = OpenTable("select * from "+ tmpTblFiles 
						+" order by FDATE desc, FNAME, FPATH"
						);
	grid.setTable(tbl);	
	*/
	grid.build();
	
	this.gridSel = gridSel;
	grid.setSelHandler(this, "gridSel");
	
	loadFiles();	
}

function gridSel()
{
	var tbl = grid.getTable();
	//FILE.value = tbl.getValue("FNAME");
	//sDumpPath = tbl.getValue("FPATH");
	if(tbl.getValue("FNAME"))
		FILE.value = tbl.getValue("FPATH") +"/"+ tbl.getValue("FNAME");
}

function base_valid()
{
	var sBase = String(FBASE.value).replace(sAllBaseTxt, "").trim();
	var sSource = String(FBASE_SOURCE.value).trim();
	if(!sSource || sSource=="" || !FBASE_SOURCE.isEnabled())
		FBASE_SOURCE.value = sBase;
	loadHistory();
}

function zip_valid()
{
	var sWhere = "1=1";
	if(ZIP.checked==false)
		sWhere = " UPPER(FTYPE)<>'ZIP'";
	list.qryWhere = sWhere;
	list.tblInit();
	stopProgress();
}

function setDBPrivileges(sUser, sBase)
{
	if(!sUser)
		sUser = getDBUserName();
	if(!sBase)
		sBase = getPath("ALL_MDB");
	if(SUBD==MYSQL)
	{
		var conn = checkDBConnection(FLOGIN.value, FPASSWORD.value);
		grantPrivileges("ALL", sUser, sBase, conn);		
	}
}

//история
function loadHistory()
{
	try
	{
		var sBase = String(FBASE.value).replace(sAllBaseTxt, "").trim();
		if(sBase.indexOf(",")!=-1 || sBase.indexOf(" ")!=-1)
			sBase = getPath("ALL_MDB");
		var sTbl = dumpTblName(sBase);
		if(!lpProxy.getDBManager().testSQL("select FDATE from "+ sTbl +" where 1<>1"))
			return false;
		var tbl = OpenTable("select * from "+ sTbl 
						+" where FEXPORT<>"+ sqlTrue
						+" order by FDATE desc"
						);
		grid_history.setTable(tbl);
		grid_history.refresh();
		return true;
	}
	catch(e)
	{
		return false;
	}
}

function loadHistoryGrid()
{
	try
	{
		if(!loadHistory())
			return;
		
		grid_history.DeletePages();
		
		grid_history.FieldEx("FDATE", "Дата|Дата", 12);
		grid_history.FieldEx("FTIME", "Час|Время", 8);
		grid_history.FieldEx("FBASE", "Схема|Схема", 10);
		grid_history.FieldEx("FPATH", "Шлях|Путь", 15);
		grid_history.FieldEx("FARCH", "Архів|Архив", 15);	
		grid_history.FieldEx("FUSER", "USER|USER", 8);
		grid_history.FieldEx("FHOST", "HOST|HOST", 8);
		
		grid_history.build();
	}
	catch(e)
	{
		
	}
}