//сервисные функции для учета банковских опреаций
include("Objects/DpClEx.js");

//добавляет новый расчетный счет контрагенту
function addRscToOrg(org, rsc, mfo, bnk, valut)
{
	if(!org || !rsc || !mfo)
		return false;
	rsc = allt(rsc);
	mfo = allt(mfo);
	if(!bnk)
		bnk = "";
	else
		bnk = allt(bnk);
	if(!valut)
		valut = 0;
	var snap = getSnap("select r.Fwid_cl "
						+" from ^clrelclcl as r inner join ^cl_orgrs as o on r.Fwid_cl=o.Fwid_cl and o.Fras_sch="
								+sqlTo(rsc)+" and o.Fmfo="+sqlTo(mfo)
						+" where r.Fcl="+getPar("CODPLAT")+" and r.Fcod="+org);
	if(snap)
		return false;
	else
	{
		var snap = getSnap("select r.Fwid_cl, MAX(o.Fnomrr) as Fnomrr, count(o.Fnomrr) as Fcnt "
						+" from ^clrelclcl as r left join ^cl_orgrs as o on r.Fwid_cl=o.Fwid_cl"
						+" where r.Fcl="+getPar("CODPLAT")+" and r.Fcod="+org
						+" group by r.Fcl, r.Fcod, r.Fwid_cl");
		if(snap && snap[0])
		{
			var oCl = new DpClEx("CL2", getPar("CODPLAT"));
			oCl.loadByID(snap[0]);
			var row = oCl.createRow("ORS");
	        row.setVar("HNAZVBNK",bnk);
	        row.setVar("HRASSCH",rsc);
	        row.setVar("HMFO",mfo);
	        row.setVar("HCL", 0);
	        row.setVar("HNUM", Number(snap[1])+1);
	        if(snap[2]>0)
	        	row.setVar("HMAIN",false);
	        else
	        	row.setVar("HMAIN",true);
	        row.setVar("HVAL",valut);
	        oCl.appendRow("ORS", row);
	        oCl.saveRows();
	        //oCl.save();
	        return true;
		}
		else
			return false;
	}
	return false;
}