// Получить по полному ФИО фамилию и инциалы
// initials("Кукушкин Кирилл Ульянович") == "Кукушкин К.У."

//21.04.2011 olya
//добавился режим mode "f" или "b" для получения инициалов спереди или сзади фамилии
// где "f" - инициалы перед фамилией "К.У. Кукушкин"
//		 "b" - инициалы после фамилии ( используется по умолчанию ) "Кукушкин К.У."
function initials(fullName, mode)
{
	if (isEmpty(mode))
	{
		mode = "b";
	}
		// Может быть, что fullName уже есть фамилия и инциалы
		// Тогда получится initials("Кукушкин К.У.") == "Кукушкин К."
		// чтобы этого не было я вставил следующую строку
	if (!fullName)
		return "";

	fullName = allt(fullName);

	var tmpName = fullName.replace(/\./g, ". ");
	var aWords = tmpName.split(" ");
	
	switch (mode)
	{
		case "f":
			var retStr = "";
			for(var i=1; i<aWords.length; i++)
				switch(aWords[i].length)
				{
				case 0:
					break;
				case 1:
					retStr += aWords[i] + " ";
					break;
				default:
					retStr += aWords[i].substr(0, 1) + "."
				}
			retStr = (!isEmpty(retStr) ? retStr+" "+aWords[0] : aWords[0]);
			break;
		case "b":
		default:
			var retStr = aWords[0] + " ";
			for(var i=1; i<aWords.length; i++)
				switch(aWords[i].length)
				{
				case 0:
					break;
				case 1:
					retStr += aWords[i] + " ";
					break;
				default:
					retStr += aWords[i].substr(0, 1) + "."
				}
			break;
	}

	return retStr;			
}