include("Objects/DpXMLDomDocument.js");
include("Objects/DpJRegistrator.js");

var sSettingsPath = getOrgPath() +"settings/";
var sRegDir = sSettingsPath +"journals/register";
var sOperDir = sSettingsPath +"operations";
var sExtDir = sSettingsPath +"extentions/docs";
var sVarsDir = sSettingsPath +"docvars";
var sCalcDir = sSettingsPath +"calculations";
var sDefDir = sSettingsPath +"vardef";
var sRegFile = "register.xml";

var arrJournalCtrl = new Array();
var listJournals;
var doc = "";
var nop = 0;
var toDoc = "";
var toNop = 0;
var calc = 0;
var noAsk = false;
var oReg;

function Load()
{
	doc = extPar.doc;
	nop = extPar.nop;
	toDoc = extPar.toDoc;
	toNop = extPar.toNop;
	calc = extPar.calc;
	noAsk = extPar.noAsk;
	if(!toDoc)
		toDoc = doc;
	
	var sDoc = (doc!=toDoc? doc +":" : "") + nop;
	var sToDoc = (doc!=toDoc? toDoc +":" : "") + toNop;
	var txt = UR("Копіювання налагоджень з папки "+ sDoc +" до "+ sToDoc 
				+"|Копирование настроек из папки "+ sDoc +" в "+ sToDoc
				);
	Caption(txt);
	
	oReg = new DpJRegistrator(null, null, "US");
	var xmlDom = new DpXMLDOMDocument();
	
	if(isFile(sRegDir +"/"+ doc +"/"+ nop))
	{
		REG.value = true;
		setFocus(REG);	
	}
	else
	{
		Disable(REG);
	}
	
	
	Disable(VARS);
	sFile = sVarsDir +"/"+ doc +"/"+ nop +".xml";
	if(isFile(sFile))
	{
		xmlDom.load(sFile);
		var root = xmlDom.getDocumentElement();
		var header = root.getElementsByTagName("header")[0];
		if(header)
		{
			var kol = header.getChildNodes().length;
			if(kol>0)
			{
				FVARS.value = kol +" шт.";
				VARS.value = true;
				setFocus(VARS);
				Enable(VARS);
			}
		}
	}
	
	
	Disable(DEF);
	var sFile = sDefDir +"/"+ doc +"/"+ nop +"/vardef.xml";
	if(isFile(sFile))
	{
		xmlDom.load(sFile);
		var root = xmlDom.getDocumentElement();
		if(root)
		{
			var kol = root.getChildNodes().length;
			if(kol>0)
			{
				FDEF.value = kol +" шт.";
				DEF.value = true;
				setFocus(DEF);
				Enable(DEF);
			}
		}
	}
	
		
	Disable(OPER);
	sFile = sOperDir +"/"+ doc +"/"+ nop +".xml";
	if(isFile(sFile))
	{
		var sOper = "";
		xmlDom.load(sFile);
		var root = xmlDom.getDocumentElement();
		var kol = root.getChildNodes().length;
		sOper = UR("секцій - |секций - ") + kol;
		var header = root.getElementsByTagName("prov");
		if(header)
		{
			var kol = header.length;
			sOper += UR(", проведень - |, проводок - ") + kol;
			if(kol>0)
			{				
				OPER.value = true;
				setFocus(OPER);
				Enable(OPER);
			}
		}
		FOPER.value = sOper;
	}
	
	
	Disable(CALC);
	if(doc==toDoc)
	{
		sFile = sCalcDir +"/"+ doc +"/entry.xml";
		if(Number(calc) && isFile(sFile))
		{
			xmlDom.load(sFile);
			var root = xmlDom.getDocumentElement();
			var kol = root.getChildNodes().length;		
			var header = root.getElementsByTagName("DpCalculation");
			if(header)
			{			
				if(header.length>0)
				{
					FCALC.value = "N "+ java.lang.Integer(calc);
					//CALC.value = true;
					setFocus(CALC);
					Enable(CALC);
				}
			}
		}
	}
	
	Disable(EXT);
	sFile = sExtDir +"/"+ doc +"/"+ nop +".xml";
	if(isFile(sExtDir +"/"+ doc +"/"+ nop +".xml"))
	{
		xmlDom.load(sFile);
		var root = xmlDom.getDocumentElement();
		var header = root.getElementsByTagName("header")[0];
		var sExt = "";
		if(header && header.getChildNodes())
			sExt += "загол. - "+ header.getChildNodes().length +" шт.";		
		var row = root.getElementsByTagName("ROW")[0];
		if(row && row.getChildNodes())
		{
			if(sExt!="")
				sExt += ", "
			sExt += UR("рядки - |строки - ") + row.getChildNodes().length +" шт.";
		}
		if(sExt!="")
		{
			FEXT.value = sExt;
			EXT.value = true;
			setFocus(EXT);
			Enable(EXT);
		}
	}
		
	Disable(FOPER);
	Disable(FEXT);
	Disable(FVARS);
	Disable(FCALC);
	Disable(FDEF);
	Disable(FREG);
	
	fillJournals();
	setValid(REG, reg_valid);	
	reg_valid();
	
	if(!doc || !nop || !toDoc || !toNop)
	{
		alert(UR("Не коректні параметри!|Не корректные параметры!"));
		return false;
	}
}

function fillJournals()
{
	var sReg = "";
	FREG.value = "";
	listJournals = oReg.listJournals();
	REG.value = false;

	var sPath = sRegDir +"/"+ doc +"/"+ nop;
	if(!isDir(sPath) || !listJournals)
	{
		Disable(REG);
		return;
	}

	var listReg = new DpFile(sPath).listFiles();
	if(listReg.length==0)
	{
		Disable(REG);
		return;
	}
	
	var nJournal = 1;
	for(var nReg=0; nReg<listReg.length; nReg++)
	{
		var jID = String(listReg[nReg].getName()).toUpperCase();
		var sPath = listReg[nReg].getAbsolutePath();
		var oJournal = null;
		for(j in listJournals)
		{
			var id = String(j).toUpperCase();
			if(jID && jID.toUpperCase().indexOf(id)!=-1)
			{
				oJournal = listJournals[j];
				break;
			}
		}

		if(isFile(sPath +"/register.xml") && oJournal)
		{
			var ctrlID = String(jID);
			if(sReg!="")
				sReg += ", ";
			sReg += jID;
			var txt = "   "+ (nJournal++) +"."+ oJournal.getName();
			FORM.AddCheckBox(txt, ctrlID);
			FORM.AddTextField("", "F"+ ctrlID, 150);
			eval(ctrlID).value = true;
			eval("F"+ jID).value = jID;
			Disable(eval("F"+ jID));
			arrJournalCtrl[ctrlID] = eval(ctrlID);
			setValid(eval(ctrlID), journal_valid);
		}
	}
	
	FORM.Refresh();
	REG.value = true;
	if(sReg)
		FREG.value = sReg;
}

function journal_valid()
{
	var sReg = "";
	for(var jID in arrJournalCtrl)
	{
		if(arrJournalCtrl[jID].value==true)
		{
			if(sReg!="")
				sReg += ", ";
			sReg += jID;
		}
	}
	FREG.value = sReg;
	if(sReg=="")
		REG.value = false;
	else
		REG.value = true;
}

function reg_valid()
{
	if(REG.checked == true)
	{
		for(var jID in arrJournalCtrl)
			Enable(arrJournalCtrl[jID]);
	}
	else
	{
		for(var jID in arrJournalCtrl)
			Disable(arrJournalCtrl[jID]);
	}
}

function onSave()
{	
	if(EXT.checked==true)
		copyExt(doc, nop, toDoc, toNop, noAsk);
	
	if(CALC.checked==true)
		calc = copyCalc(doc, calc);
	extPar.calc = calc;
	
	if(OPER.checked==true)
		copyOper(doc, nop, toDoc, toNop, noAsk);
	
	if(DEF.checked==true)
		copyDef(doc, nop, toDoc, toNop, noAsk);
		
	if(VARS.checked==true)
		copyVars(doc, nop, toDoc, toNop, noAsk);
	
	if(REG.checked==true)
	{
		for(var jID in arrJournalCtrl)
		{
			if(arrJournalCtrl[jID].value==true)
				copyReg(doc, nop, toDoc, toNop, jID, noAsk);
		}
	}
}

function copyOper(doc, nop, toDoc, toNop, bNoAsk)
{
	var sFile = sOperDir +"/"+ toDoc +"/"+ toNop +".xml";
	var sFileSource = sOperDir +"/"+ doc +"/"+ nop +".xml";
	if(!isFile(sFileSource))
		return;	
	
	if(!isDir(sOperDir +"/"+ toDoc))
		createDirectory(sOperDir +"/"+ toDoc);
	
	if(isFile(sFile))
	{
		if(bNoAsk)
		{
			deleteFile(sFile);
		}
		else
		{
			var sMsg = UR("У папці "+ toDoc +":"+ toNop 
							+" вже є Налаштування проведень."
							+"\nЗамінити?"
						+"|В папке "+ toDoc +":"+ toNop 
							+" уже есть Настройки проводок."
							+"\nЗаменить?"
						);
			if(!confirm(sMsg))
				return;
			deleteFile(sFile);
		}
	}
	
	if(!isFile(sFile))
		return copyFile(sFileSource, sFile);
}

function copyExt(doc, nop, toDoc, toNop, bNoAsk)
{
	var sFile = sExtDir +"/"+ toDoc +"/"+ toNop +".xml";
	var sFileSource = sExtDir +"/"+ doc +"/"+ nop +".xml";	
	if(!isFile(sFileSource))
		return;	
		
	include("Objects\\DpExtentionBuilder.js");	
	if(!isDir(sExtDir +"/"+ toDoc))
		createDirectory(sExtDir +"/"+ toDoc);
	
	if(isFile(sFile))
	{
		if(bNoAsk)
		{
			deleteFile(sFile);
		}
		else
		{
			var sMsg = UR("У папці "+ toDoc +":"+ toNop 
							+" вже є Розширення."
							+"\nЗамінити?"
						+"|В папке "+ toDoc +":"+ toNop 
							+" уже есть Расширения."
							+"\nЗаменить?"
						);
			if(!confirm(sMsg))
				return;
			deleteFile(sFile);
		}
	}
	
	if(!isFile(sFile))
	{
		copyFile(sFileSource, sFile);
		extBuilder = new DpExtentionBuilder("H", toDoc, toNop);
		extBuilder.load(true);
		extBuilder.commitStructure();
		
		extBuilder = new DpExtentionBuilder("R", toDoc, toNop);
		extBuilder.load(true);
		extBuilder.commitStructure();
		return true;
	}	
}

function copyVars(doc, nop, toDoc, toNop, bNoAsk)
{
	var sFile = sVarsDir +"/"+ toDoc +"/"+ toNop +".xml";
	var sFileSource = sVarsDir +"/"+ doc +"/"+ nop +".xml";
	if(!isFile(sFileSource))
		return;
	
	if(!isDir(sVarsDir +"/"+ toDoc))
		createDirectory(sVarsDir +"/"+ toDoc);
	
	if(isFile(sFile))
	{
		if(bNoAsk)
		{
			deleteFile(sFile);
		}
		else
		{
			var sMsg = UR("У папці "+ toDoc +":"+ toNop 
							+" вже є Користувальницькі змінні."
							+"\nЗамінити?"
						+"|В папке "+ toDoc +":"+ toNop 
							+" уже есть Пользовательские переменные."
							+"\nЗаменить?"
						);
			if(!confirm(sMsg))
				return;
			deleteFile(sFile);
		}
	}	
	
	if(!isFile(sFile))
		return copyFile(sFileSource, sFile);
}

function copyDef(doc, nop, toDoc, toNop, bNoAsk)
{
	var sFile = sDefDir +"/"+ toDoc +"/"+ toNop +"/vardef.xml";
	var sFileSource = sDefDir +"/"+ doc +"/"+ nop +"/vardef.xml";
	if(!isFile(sFileSource))
		return;	
	
	if(!isDir(sDefDir +"/"+ toDoc +"/"+ toNop))
		createDirectory(sDefDir +"/"+ toDoc +"/"+ toNop);
	
	if(isFile(sFile))
	{
		if(bNoAsk)
		{
			deleteFile(sFile);
		}
		else
		{
			var sMsg = UR("У папці "+ toDoc +":"+ toNop 
							+" вже є Значення за замовченням."
							+"\nЗамінити?"
						+"|В папке "+ toDoc +":"+ toNop 
							+" уже есть Значения по умолчанию."
							+"\nЗаменить?"
						);
			if(!confirm(sMsg))
				return;
			deleteFile(sFile);
		}
	}
	
	if(!isFile(sFile))
		return copyFile(sFileSource, sFile);
}

function copyReg(doc, nop, toDoc, toNop, jID, bNoAsk)
{
	if(!isDir(sRegDir +"/"+ doc +"/"+ nop) || !jID || String(jID).trim()=="")
		return;	
	
	jID = String(jID).trim();
	var sRegPath = sRegDir +"/"+ toDoc +"/"+ toNop +"/"+ jID;
	var sSourceFile = sRegDir +"/"+ doc +"/"+ nop +"/"+ jID +"/"+ sRegFile;
	if(!isFile(sSourceFile))
		return;
	
	if(isFile(sRegPath +"/"+ sRegFile))
	{
		if(bNoAsk)
		{
			deleteFile(sRegPath +"/"+ sRegFile);
		}
		else
		{
			var sMsg = UR("Для журналу "+ jID +" у папці "+ toDoc +":"+ toNop 
							+" вже є реєстраційний запис."
							+"\nЗамінити?"
						+"|Для журнала "+ jID +" в папке "+ toDoc +":"+ toNop 
							+" уже есть регистрационная запись."
							+"\nЗаменить?"
						);
			if(!confirm(sMsg))
				return;
			deleteFile(sRegPath +"/"+ sRegFile);
		}					
	}
	if(!isDir(sRegPath))
		createDirectory(sRegPath);		
	copyFile(sSourceFile, sRegPath +"/"+ sRegFile);				
}

function copyCalc(doc, calc)
{
	var sFile = sCalcDir +"/"+ doc +"/entry.xml";
	if(!isFile(sFile))
		return calc;
		
	var num = 1;
	var txt = "";
	var variable = "";
	var condition = "";
	var action = "";
	var value = "";
	var proportion = "";
	var filter = "";
	var sign = "";
			
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(sFile);
	var root = xmlDom.getDocumentElement();
	var groupSource = root.getElementsByTagName("DpCalculationGroup");
	if(!groupSource)
		return calc;
	
	var eGroup = null;
	for(var nGroup=0; nGroup<groupSource.length; nGroup++)
	{
		var el = groupSource[nGroup];
		nCalc = Number(el.getAttribute("num"));
		if(nCalc>=num)
			num = nCalc+1;
		if(nCalc!=Number(calc))
			continue;
		eGroup = el;
	}
	
	if(!eGroup)
		return calc;
	
	var group = xmlDom.createElement("DpCalculationGroup");	
	root.appendChild(group);
	group.setAttribute("txt", eGroup.getAttribute("txt"));
	group.setAttribute("num", num);
					
	var calcList = eGroup.getElementsByTagName("DpCalculation");	
	for(var i=0; i<calcList.length; i++)
	{
		var eSource = calcList[i];
					
		var eCalc = xmlDom.createElement("DpCalculation");
		eCalc.setAttribute("txt", eSource.getAttribute("txt"));
		eCalc.setAttribute("num", Number(eSource.getAttribute("num")));		
					
		txt = eSource.getAttribute("txt");
		var el = eSource.getElementsByTagName("variable")[0];	
		if(el)
			variable = el.getText();
		
		el = eSource.getElementsByTagName("condition")[0];
		if(el)
			condition = el.getText();
		
		el = eSource.getElementsByTagName("action")[0];
		if(el)
			action = el.getText();
		
		el = eSource.getElementsByTagName("value")[0];
		if(value && value.getCDATASection())
			value = xmlDom.createCDATASection(el.getCDATASection().getData());
		
		el = eSource.getElementsByTagName("proportion")[0];
		if(el)
			proportion = el.getText();
		
		el = eSource.getElementsByTagName("filter")[0];
		if(el)
			filter = el.getText();
		
		el = eSource.getElementsByTagName("sign")[0];
		if(el)
			sign = el.getText();
		
		e = xmlDom.createElement("variable");
		e.setText(variable);
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("condition");
		e.setText(condition);
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("action");
		e.setText(action);
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("value");
		e.appendChild(xmlDom.createCDATASection(value));
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("proportion");
		e.setText(proportion);
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("filter");
		e.setText(filter);
		eCalc.appendChild(e);
		
		e = xmlDom.createElement("sign");
		e.setText(sign);
		eCalc.appendChild(e);
		
		group.appendChild(eCalc);
	}
		
	if(xmlDom.save(sFile));
		return num;
	return 0;
}