include("Objects/DpXMLDomDocument.js");
include("Objects/DpzDoc.js");

var sDocoperPath = rootDirectoryEx() +"Source/docoper";
var sOperFile = "operations.xml";
var sExtFile = "extentions.xml";
var sVarsFile = "docvars.xml";
var sCalcFile = "calculations.xml";
var sDefFile = "vardef.xml";
var sRegFile = "register.xml";
var sRegDir = "register";
var sInfoFile = "info.xml";
var sPatternID = "";

function Load()
{
	Caption(UR("Імпорт налаштувань|Импорт настроек"));
	
	DIR.setFilterPath(rootDirectoryEx());
	DIR.value = sDocoperPath;
		
	//dpzDoc = new DpzDoc(extPar.doc, 0);		 
	//dpzDoc.linkCtrl(DOC);
	//dpzDoc.linkCtrlNop(NOP);
	//dpzDoc.setCod(extPar.doc);
	//dpzDoc.setDocNop(extPar.nop);
	
	NOP.mask = "###########";
	DOC.value = extPar.doc;	
	Disable(DOC);
	fill_op(DOC.value);
	
	this.loadPath = loadPath;
	setButton(BTNLOAD, loadPath);
	
	setValid(OPER, oper_valid);
	setValid(EXT, ext_valid);
	setValid(VARS, vars_valid);
	setValid(CALC, calc_valid);
	setValid(DEF, def_valid);
	setValid(REG, reg_valid);
	setValid(NOP, nop_valid);
	setValid(PATTERN, pattern_valid);
	setValid(REG_DIR, fillRegNames);
	
	Disable(OPER_FILE);	
	Disable(EXT_FILE);	
	Disable(VARS_FILE);
	Disable(CALC_FILE);
	Disable(DEF_FILE);
	Disable(REG_DIR);
	//Disable(MODE);
	REG_NAME.setVisible(false);
	
	if(isDir(sDocoperPath))
		loadPath();
	setFocus(TXT);
}

function fill_op(doc)
{
	var tblOP = OpenTable("select FNOP,FTXT from ^CL_LNK where FDOC='"+ doc +"' and FNOP>0 order by FNOP");
	for(; !tblOP.isEOF(); tblOP.MoveNext())
	{
		var nNop = tblOP.getValue("FNOP");
		var sTxt = tblOP.getValue("FTXT");
		NOP.addItem(nNop, nNop);
	}
	tblOP.close();
	//nNop = nextNop(doc);
	//NOP.addItem(nNop, nNop);
	//NOP.value = nNop;
	if(extPar.nop)
		NOP.value = extPar.nop;
}

function pattern_valid()
{
	if(String(sPatternID)==String(PATTERN.value))
		return;
	sPatternID = PATTERN.value;
	
	var impPath = DIR.value;
	impPath += "/"+ String(DOC.value).toUpperCase();
	impPath += "/"+ PATTERN.value;
	if(!isDir(impPath))
		return false;
	
	Disable(OPER_FILE);	
	OPER.checked = false;
	OPER_FILE.value = "";
	OPER_FILE.setFilterPath(impPath);
	if(isFile(impPath +"/"+ sOperFile))
	{
		Enable(OPER_FILE);	
		OPER.checked = true;
		OPER_FILE.value = impPath +"/"+ sOperFile;
	}
	
	Disable(EXT_FILE);	
	EXT.checked = false;
	EXT_FILE.value = "";
	EXT_FILE.setFilterPath(impPath);
	if(isFile(impPath +"/"+ sExtFile))
	{
		Enable(EXT_FILE);	
		EXT.checked = true;
		EXT_FILE.value = impPath +"/"+ sExtFile;
	}
	
	Disable(VARS_FILE);	
	VARS.checked = false;
	VARS_FILE.value = "";
	VARS_FILE.setFilterPath(impPath);
	if(isFile(impPath +"/"+ sVarsFile))
	{
		Enable(VARS_FILE);	
		VARS.checked = true;
		VARS_FILE.value = impPath +"/"+ sVarsFile;
	}
	
	Disable(CALC_FILE);	
	CALC.checked = false;
	CALC_FILE.value = "";
	CALC_FILE.setFilterPath(impPath);
	if(isFile(impPath +"/"+ sCalcFile))
	{
		Enable(CALC_FILE);	
		CALC.checked = true;
		CALC_FILE.value = impPath +"/"+ sCalcFile;
	}
	
	Disable(DEF_FILE);	
	DEF.checked = false;
	DEF_FILE.value = "";
	DEF_FILE.setFilterPath(impPath);
	if(isFile(impPath +"/"+ sDefFile))
	{
		Enable(DEF_FILE);	
		DEF.checked = true;
		DEF_FILE.value = impPath +"/"+ sDefFile;
	}
	
	Disable(REG_DIR);	
	REG.checked = false;
	REG_NAME.setVisible(false);
	REG_DIR.value = "";
	REG_DIR.setFilterPath(impPath);
	if(isDir(impPath +"/"+ sRegDir))
	{
		Enable(REG_DIR);	
		REG.checked = true;
		REG_DIR.value = impPath +"/"+ sRegDir;
		REG_NAME.setVisible(true);
	}
	fillRegNames();	
}

function fillRegNames()
{
	var currReg = REG_NAME.value;
	var sPath = REG_DIR.value;
	REG_NAME.clear();
	if(!isDir(sPath))
		return;
	var listReg = new DpFile(sPath).listFiles();
	if(listReg.length==0)
		return;
	REG_NAME.addItem("", UR("усі журнали|все журналы"));
	for(var nReg=0; nReg<listReg.length; nReg++)
	{
		var sReg = listReg[nReg].getName();
		var sPath = listReg[nReg].getAbsolutePath();
		if(isDir(sPath))
		{
			REG_NAME.addItem(sReg, sReg);
		}
	}
	REG_NAME.setValue("");
	if(currReg && REG_NAME.getCtrl().indexOf(currReg)!=-1)
		REG_NAME.setValue(currReg);
}

function nop_valid()
{
	var oSnap = getSnap("select FTXT from ^CL_LNK "
						+" where FDOC="+ sqlTo(DOC.value)
							+" and FNOP="+ sqlTo(Number(NOP.value)));
	if(oSnap)
	{
		TXT.value = UR(oSnap[0]);
		Enable(MODE);
	}
	else
	{
		Disable(MODE);
		MODE.value = "ADD";		
	}
}

function nextNop(doc)
{
	var oSnap = getSnap("select max(FNOP) from ^CL_LNK where FDOC="+ sqlTo(doc));
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
} 

function loadPath()
{
	var impPath = DIR.value;
	if(!isDir(impPath))
	{
		var sMsg = UR("Виберіть каталог з налагодженнями|Выберите каталог с настройками");
		var sCapt = UR("Імпорт налагоджень|Импорт настроек"); 
		impPath = askDirectory(getOrgPath(), sMsg, sCapt);
		if(!impPath)
			return false;
		DIR.value = impPath;
	}	
	impPath += "/"+ String(DOC.value).toUpperCase();
	
	fillPatterns(impPath);
	pattern_valid();
}

function fillPatterns(impPath)
{
	PATTERN.clear();
	if(!isDir(impPath))
		return;
	var dir = new DpFile(impPath);
	var listPatterns = dir.listFiles();	
	for(var n=0; n<listPatterns.length; n++)
	{
		var sName = listPatterns[n].getName();
		var sPath = listPatterns[n].getAbsolutePath();
		var oPattern = getPattern(sPath);		
		if(oPattern)
		{
			sName = oPattern.name;
			var txt = sName +": "+ oPattern.txt;
			PATTERN.addItem(sName, txt);			
		}		
	}
	if(listPatterns.length>0)
		PATTERN.setSelectedIndex(0);	
}

function oper_valid()
{
	if(OPER.checked == true)
		Enable(OPER_FILE);
	else
		Disable(OPER_FILE);
}

function ext_valid()
{
	if(EXT.checked == true)
		Enable(EXT_FILE);
	else
		Disable(EXT_FILE);
}

function vars_valid()
{
	if(VARS.checked == true)
		Enable(VARS_FILE);
	else
		Disable(VARS_FILE);
}

function calc_valid()
{
	if(CALC.checked == true)
		Enable(CALC_FILE);
	else
		Disable(CALC_FILE);
}

function def_valid()
{
	if(DEF.checked == true)
		Enable(DEF_FILE);
	else
		Disable(DEF_FILE);
}

function reg_valid()
{
	if(REG.checked == true)
	{
		REG_NAME.setVisible(true);
		Enable(REG_DIR);
	}
	else
	{
		REG_NAME.setVisible(false);
		Disable(REG_DIR);
	}
}

function onSave()
{
	var doc = DOC.value;
	var nop = NOP.value;
	var impPath = DIR.value;
	//var bReplace = false;
	var sMode = String(MODE.value);
	var bReplace = sMode=="REPALCE";
	var bExist = isFile(OPER_FILE.value) 
			  || isFile(VARS_FILE.value) 
			  || isFile(EXT_FILE.value) 
			  || isFile(CALC_FILE.value) 
			  || isFile(DEF_FILE.value) 
			  || isDir(REG_DIR.value);
	if(!bExist)
		return false;
			
	if(OPER.checked==true)
		importOper(doc, nop, OPER_FILE.value, bReplace);
		
	if(VARS.checked==true)
		importVars(doc, nop, VARS_FILE.value, bReplace);
	
	if(EXT.checked==true)
		importExt(doc, nop, EXT_FILE.value, bReplace);
	
	if(DEF.checked==true)
		importDef(doc, nop, DEF_FILE.value, bReplace);
		
	if(REG.checked==true)
		importReg(doc, nop, REG_DIR.value, bReplace, REG_NAME.value);
	
	var nCalc = 0;	
	if(CALC.checked==true)
		nCalc = importCalc(doc, nCalc, CALC_FILE.value, bReplace);
	
	if(sMode=="UPDATE")
		return;

	var m = new Object();
	m.FTXT = TXT.value;
	m.FDOC = DOC.value;
	m.FNOP = Number(NOP.value);
	m.FCALC = nCalc;
	m.FSORTNO = getSortNum(DOC.value);
	if(sMode=="ADD")
	{
		m.FWID = GetUID();
	}
	else
	{
		var oSnap = getSnap("select FWID,FTXT from ^CL_LNK "
					+" where FDOC="+ sqlTo(m.FDOC) 
						+" and FNOP="+ sqlTo(m.FNOP));
		if(oSnap)
		{
			m.FWID = oSnap[0];
			if(m.FTXT=="" || m.FTXT==null)
				m.FTXT = oSnap[1];
		}
	}	
	updateTable("^CL_LNK", m, sMode=="ADD");
}

function getSortNum(doc)
{
	var oSnap = getSnap("select FSORTNO "
						+" from ^CL_LNK "
						+" where UPPER(FDOC)="+ sqlTo(doc.toUpperCase()) 
							+" and FSORTNO>0"
						);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0]);
	return 0;
}

function importOper(doc, nop, sFileSource, bReplace)
{
	if(!isFile(sFileSource))
		return;
	var dir = getOrgPath() +"settings/operations/"+ doc +"/";
	var xml = dir + nop +".xml";
	if(!isDir(dir))
		createDirectory(dir);
	if(bReplace)
		deleteFile(xml);	
	if(!isFile(xml))
		return copyFile(sFileSource, xml);
}

function importExt(doc, nop, sFileSource, bReplace)
{
	if(!isFile(sFileSource))
		return;	
		
	include("Objects\\DpExtentionBuilder.js");	
	var dir = getOrgPath() +"settings/extentions/docs/"+ doc +"/";
	var xml = dir + nop +".xml";	
	if(!isDir(dir))
		createDirectory(dir);
	if(bReplace)
		deleteFile(xml);
	if(!isFile(xml))
	{
		copyFile(sFileSource, xml);
		extBuilder = new DpExtentionBuilder("H", doc, nop);
		extBuilder.load(true);
		extBuilder.commitStructure();
		
		extBuilder = new DpExtentionBuilder("R", doc, nop);
		extBuilder.load(true);
		extBuilder.commitStructure();
		return true;
	}
		
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(xml);
	var root = xmlDom.getDocumentElement();
	var header = root.getElementsByTagName("header")[0];
	if(!header)
	{
		header = xmlDom.createElement("header");
		root.appendChild(header);
	}
	
	var xmlDomSource = new DpXMLDOMDocument();
	xmlDomSource.load(sFileSource);
	var rootSource = xmlDomSource.getDocumentElement();
	var headerSource = rootSource.getElementsByTagName("header")[0];
	if(headerSource)
	{
		var extList = headerSource.getChildNodes();
		for(var i=0; i<extList.length; i++)
		{
			var eSource = extList[i];
			var eVar = header.getElementsByTagName(eSource.getNodeName())[0];
			if(eVar!=null)
				header.removeChild(eVar);
			eVar = xmlDom.createElement(eSource.getNodeName());		
			eVar.setText(eSource.getText());
			eVar.setAttribute("comment", eSource.getAttribute("comment"));
			eVar.setAttribute("width", eSource.getAttribute("width"));
			eVar.setAttribute("pos", eSource.getAttribute("pos"));
			eVar.setAttribute("used", eSource.getAttribute("used"));
			eVar.setAttribute("ischeck", eSource.getAttribute("ischeck"));
			eVar.setAttribute("type", eSource.getAttribute("type"));
			eVar.setAttribute("isculc", eSource.getAttribute("isculc"));
			eVar.setAttribute("format", eSource.getAttribute("format"));
			eVar.setAttribute("default", eSource.getAttribute("default"));
							
			header.appendChild(eVar);
		}		
	}
	
	var rows = root.getElementsByTagName("rows")[0];
	if(!rows)
	{
		rows = xmlDom.createElement("rows");
		root.appendChild(rows);
	}
		
	var rowsSource = rootSource.getElementsByTagName("rows")[0];
	if(rowsSource)
	{
		var rowList = rowsSource.getChildNodes();
		for(var n=0; n<rowList.length; n++)
		{
			var rowSource = rowList[n];
			if(!rowSource)
				continue;
			
			var sRow = rowSource.getNodeName();
			var row = rows.getElementsByTagName(sRow)[0];
			if(!row)
			{
				row = xmlDom.createElement(sRow);
				rows.appendChild(row);
			}		
			
			var extList = rowSource.getChildNodes();
			for(var i=0; i<extList.length; i++)
			{
				var eSource = extList[i];
				var eVar = row.getElementsByTagName(eSource.getNodeName())[0];
				if(eVar!=null)
					row.removeChild(eVar);
				eVar = xmlDom.createElement(eSource.getNodeName());		
				eVar.setText(eSource.getText());
				eVar.setAttribute("comment", eSource.getAttribute("comment"));
				eVar.setAttribute("width", eSource.getAttribute("width"));
				eVar.setAttribute("pos", eSource.getAttribute("pos"));
				eVar.setAttribute("used", eSource.getAttribute("used"));
				eVar.setAttribute("ischeck", eSource.getAttribute("ischeck"));
				eVar.setAttribute("type", eSource.getAttribute("type"));
				eVar.setAttribute("isculc", eSource.getAttribute("isculc"));
				eVar.setAttribute("format", eSource.getAttribute("format"));
				eVar.setAttribute("default", eSource.getAttribute("default"));
								
				row.appendChild(eVar);
			}
		}
	}
		
	var bSave = xmlDom.save(xml);
	if(bSave)
	{
		if(headerSource)
		{
			extBuilder = new DpExtentionBuilder("H", doc, nop);
			extBuilder.load(true);
			extBuilder.commitStructure();
		}
		
		if(rowsSource)
		{
			extBuilder = new DpExtentionBuilder("R", doc, nop);
			extBuilder.load(true);
			extBuilder.commitStructure();
		}
	}
	return bSave;
}

function importVars(doc, nop, sFileSource, bReplace)
{
	if(!isFile(sFileSource))
		return;
	var dir = getOrgPath() +"settings/docvars/"+ doc +"/";
	var xml = dir + nop +".xml";
	if(!isDir(dir))
		createDirectory(dir);
	if(bReplace)
		deleteFile(xml);	
	if(!isFile(xml))
		return copyFile(sFileSource, xml);
}

function importDef(doc, nop, sFileSource, bReplace)
{
	if(!isFile(sFileSource))
		return;
	var dir = getOrgPath() +"settings/vardef/"+ doc +"/"+ nop +"/";
	var xml = dir +"vardef.xml";
	if(!isDir(dir))
		createDirectory(dir);
	if(bReplace)
		deleteFile(xml);	
	if(!isFile(xml))
		return copyFile(sFileSource, xml);
}

function importReg(doc, nop, sDirSource, bReplace, sRegName)
{
	var sRegPath = getOrgPath() +"settings/journals/register/"+ doc +"/"+ nop;
	if(!isDir(sDirSource))
		return;	
	
	//импорт одного журнала
	if(sRegName && String(sRegName).trim()!="")
	{
		sRegName = String(sRegName).trim();
		var sRegDir = sRegPath +"/"+ sRegName;
		var sSourceFile = sDirSource +"/"+ sRegName +"/"+ sRegFile;
		if(isFile(sSourceFile))
		{
			if(isFile(sRegDir +"/"+ sRegFile))
			{
				//if(bReplace)
					deleteFile(sRegDir +"/"+ sRegFile);
				//else
					//return;
			}
			if(!isDir(sRegDir))
				createDirectory(sRegDir);		
			copyFile(sSourceFile, sRegDir +"/"+ sRegFile);				
		}
		return;		
	}
	
	//импорт всех журналов
	var dir = new DpFile(sDirSource);
	var listReg = dir.listFiles();	
	for(var n=0; n<listReg.length; n++)
	{
		var sName = listReg[n].getName();
		var sPath = listReg[n].getAbsolutePath();
		var sRegDir = sRegPath +"/"+ sName;		
		if(isDir(sPath))
		{	
			var sFile = sPath +"/"+ sRegFile;
			if(isFile(sFile))
			{				
				if(isFile(sRegDir +"/"+ sRegFile))
				{
					if(bReplace)
						deleteFile(sRegDir +"/"+ sRegFile);
					else
						continue;
				}
				if(!isDir(sRegDir))
					createDirectory(sRegDir);		
				copyFile(sFile, sRegDir +"/"+ sRegFile);
			}
		}
	}	
}

function importCalc(doc, calc, sFileSource, bReplace)
{
	var sCalc = "";
	var nCalc = 0;
	if(!isFile(sFileSource))
		return 0;
	
	var dir = getOrgPath() +"settings/calculations/"+ doc +"/";
	var xml = dir +"entry.xml";
	if(!isDir(dir))
		createDirectory(dir);
		
	if(!isFile(xml))
	{
		copyFile(sFileSource, xml);
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(xml);
		var eCalc = xmlDom.getElementsByTagName("DpCalculationGroup")[0];
		if(eCalc)
			nCalc = eCalc.getAttribute("num");
		return nCalc;
	}
	
	var xmlDomSource = new DpXMLDOMDocument();
	xmlDomSource.load(sFileSource);
	var rootSource = xmlDomSource.getDocumentElement();
	var eSource = xmlDomSource.getElementsByTagName("DpCalculationGroup")[0];
	if(eSource)
	{
		nCalc = eSource.getAttribute("num");
		sCalc = eSource.getAttribute("txt");
	}
		
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(xml);
	var root = xmlDom.getDocumentElement();
	var group = root.getElementsByTagName("DpCalculationGroup");
	if(group)
	{
		for(var nGroup=0; nGroup<group.length; nGroup++)
		{
			var el = group[nGroup];
			var num = Number(el.getAttribute("num"));
			if(num>=Number(nCalc))
				nCalc = num+1;			
		}
	}
	
	var eGroup = xmlDom.createElement("DpCalculationGroup");
	eGroup.setAttribute("txt", sCalc);
	eGroup.setAttribute("num", nCalc);
	root.appendChild(eGroup);
	
	var calcList = rootSource.getElementsByTagName("DpCalculation");	
	for(var i=0; i<calcList.length; i++)
	{
		var eSource = calcList[i];				
		var eCalc = xmlDom.createElement("DpCalculation");
		
		eCalc.setAttribute("txt", eSource.getAttribute("txt"));
		eCalc.setAttribute("num", eSource.getAttribute("num"));
		
		var variable = eSource.getElementsByTagName("variable")[0];
		var e = xmlDom.createElement("variable");
		if(variable)
			e.setText(variable.getText());
		eCalc.appendChild(e);
		
		var condition = eSource.getElementsByTagName("condition")[0];
		e = xmlDom.createElement("condition");		
		if(condition)
			e.setText(condition.getText());
		eCalc.appendChild(e);
		
		var action = eSource.getElementsByTagName("action")[0];
		e = xmlDom.createElement("action");
		if(action)
			e.setText(action.getText());
		eCalc.appendChild(e);
		
		var value = eSource.getElementsByTagName("value")[0];
		e = xmlDom.createElement("value");
		if(value && value.getCDATASection())
			e.appendChild(xmlDom.createCDATASection(value.getCDATASection().getData()));
		eCalc.appendChild(e);
		
		var proportion = eSource.getElementsByTagName("proportion")[0];
		e = xmlDom.createElement("proportion");
		if(proportion)
			e.setText(proportion.getText());
		eCalc.appendChild(e);
		
		var filter = eSource.getElementsByTagName("filter")[0];
		e = xmlDom.createElement("filter");
		if(filter)
			e.setText(filter.getText());
		eCalc.appendChild(e);
		
		var sign = eSource.getElementsByTagName("sign")[0];
		e = xmlDom.createElement("sign");
		if(sign)
			e.setText(sign.getText());
		eCalc.appendChild(e);
		
		eGroup.appendChild(eCalc);
	}
		
	if(xmlDom.save(xml));
		return nCalc;
	return 0;
}

function select_pattern(doc, path)
{
	if(!path)
		path = sDocoperPath;
	
	var par = new Object()
	par.doc = doc;
	par.path = path;
	par.ret = new Object();
	par.ret.FPATTERN = null;
	par.ret.FTXT = null;
	par.ret.FCALC = null;
	
	var dir = new DpFile(path +"/"+ doc);
	var listPatterns = dir.listFiles();
	if(!listPatterns || listPatterns.length==0)
	{
		var sMsg = UR("Для даного типу документів шаблонів не знайдено!\nЗнайти шаблони вручну?"
					+"|Для данного типа документов шаблонов не найдено!\nНайти шаблоны вручную?");
		if(confirm(sMsg))
		{
			sMsg = UR("Вкажіть папку з шаблонами|Укажите папку с шаблонами")
			path = askDirectory(rootDirectoryEx() +"Source", sMsg);
			if(path)
				import_pattern(doc, path);
			else
				return false;		
		}
		else
		{
			return false;
		}
	}
	if(!listPatterns)
		return false;	
	if(listPatterns && listPatterns.length==1)
	{
		var sName = listPatterns[0].getName();
		var sPath = listPatterns[0].getAbsolutePath();
		var oPattern = getPattern(sPath);		
		if(oPattern)
		{
			par.ret.FPATTERN = oPattern.name;
			par.ret.FPATH = oPattern.path;			
			par.ret.FTXT = oPattern.txt;
			par.ret.FCALC = oPattern.calc;
		}		
	}
	else
	{
		showWindow("l_patterns.xml", SW_MODAL, par);
		if(par.escape)
			return false;
	}
	return par;
}

function import_pattern(doc, path)
{
	if(!path)
		path = sDocoperPath;
	var par = select_pattern(doc, path);
	if(!par)
		return false;
	
	var sPattern = par.ret.FPATTERN;
	var sDir = path +"/"+ doc +"/"+ sPattern +"/";
	if(par.ret.FPATH && isDir(par.ret.FPATH))
		sDir = par.ret.FPATH +"/";
	if(!isDir(sDir))
		return false;
	
	var nop = nextNop(doc);
	nop = input(UR("№ операції |№ операции "), UR("Імпорт|Импорт"), nop, 10);
	if(nop==null)
		return false;
		
	var m = new Object();
	m.FWID = GetUID();	
	m.FTXT = par.ret.FTXT;
	m.FDOC = doc;
	m.FNOP = nop;
	m.FCALC = Number(par.ret.FCALC);
	m.FSORTNO = getSortNum(doc);
	m.FUSED = true;
	updateTable("^CL_LNK", m, true);
		
	importOper(doc, nop, sDir + sOperFile, true);
	importVars(doc, nop, sDir + sVarsFile, true);
	importExt(doc, nop, sDir + sExtFile, true);
	importDef(doc, nop, sDir + sDefFile, true);
	importReg(doc, nop, sDir + sRegDir, true);
	importCalc(doc, m.FCALC, sDir + sCalcFile, true);
	
	return true;
}

function getPattern(sPath, sName)
{
	var oPattern = new Object();
	var sTxt = "";
	var nCalc = 0;
	if(!sName)
		sName = DpFile(sPath).getName();	
	if(isFile(sPath) && sPath.indexOf(".zip")!=-1)
	{
		sName = sName.substring(0, sName.indexOf(".zip"));
		var sZipName = sPath;						
		sPath = DpFile(sPath).getParent();
		if(isDir(sPath +"/"+ sName))
			return null;		
		extract(sZipName, sPath);
		sPath += "/"+ sName;
	}
	
	var infoXml = sPath + "/"+ sInfoFile;
	if(isFile(infoXml))
	{
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(infoXml);
		var root = xmlDom.getDocumentElement();
		var eTxt = root.getElementsByTagName("txt")[0];
		if(eTxt)
			sTxt = UR(eTxt.getText());
		var eCalc = root.getElementsByTagName("calc")[0];
		if(eCalc)
			nCalc = eCalc.getText();
		var ePattern = root.getElementsByTagName("pattern")[0];
		if(ePattern)
			sName = ePattern.getText();				
	}			
		
	oPattern.name = sName;
	oPattern.txt = sTxt;
	oPattern.calc = nCalc;
	oPattern.path = sPath;
	return oPattern;
}

function getInfoTxt(infoXml)
{
	var txt = "";
	var xmlDom = new DpXMLDOMDocument();
	xmlDom.load(infoXml);
	var root = xmlDom.getDocumentElement();
	var eTxt = root.getElementsByTagName("txt")[0];
	if(eTxt)
		txt = UR(eTxt.getText());
	return txt;	
}
