function buildPanel()
{
	loadBLNDocsPanel();
	loadBLNProvPanel();
	loadBLNCalcPanel();
	
	//PANELBAR.getCtrl().setWeights(new Array(110, 250, 500));	
}

function loadBLNDocsPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Первинні документи|Первичные документы"));
		
	panel.addItem("PROV", UR("Журнал реєстрацiї проведень|Журнал регистрации проводок"), true);	
			
	this.selBLNHandler = selBLNHandler;
	panel.setSelectHandler(this, "selBLNHandler");
}

function loadBLNProvPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Вiдбiр проведень|Отбор проводок"));
		
	panel.addItem("COR", UR("По кореспонденцiї рахункiв|По корреспонденции счетов"), true);
	panel.addItem("SCH", UR("По рахунку/субрах./статтi|По счету/субсч./статье"), true);
	panel.addItem("SUM", UR("По № документа/сумi|По № документа/сумме"), true);	
	panel.addItem("NOP", UR("Проведення без документiв|Проводки без документов"), true);	
	panel.addItem("KRS", UR("По курсових рiзницях|По курсовым разницам"), true);	
	panel.addItem("ZKR", UR("Закриваючi проведення|Закрывающие проводки"), true);	
			
	this.provHandler = provHandler;
	panel.setSelectHandler(this, "provHandler");
}

function loadBLNCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Баланс|Баланс"));
	var imgFile = lpProxy.getAppPlugLoc() + "icons/finplan.gif";	
	panel.addItem("OBSCH",	UR("Обiги та залишки по рахунку|Обороты и остатки по счету"), imgFile);	
	panel.addItem("ANALIT", UR("Обіги та залишки по аналітиці|Обороты и остатки по аналитике"), true);	
	panel.addItem("VIP", 	UR("Аналiз рахунку, субрахунку, статтi|Анализ счета, субсчета, статьи"), true);	
	panel.addItem("",		UR("Обiгово-сальдова вiдомiсть:|Оборотно-сальдовая ведомость:"), true);
		panel.addItem("OBSLVA",	"    "+ UR("По аналiтицi|По аналитике"), true);
		panel.addItem("OBSLVS", "    "+ UR("По рахунках|По счетам"), true);
		panel.addItem("OBSLVM", "    "+ UR("По матер. рахунках|По матер.счетам"), true);
		panel.addItem("OBSLVD", "    "+ UR("По датах|По датам"), true);		
	var imgFile = lpProxy.getAppPlugLoc() + "icons/balance.gif";
	panel.addItem("OBLNS", 	UR("Обіговий баланс|Оборотный баланс"), imgFile);
	panel.addItem("OTBLNPR",UR("Звітний баланс|Отчетный баланс"), true);
	panel.addItem("", 	UR("Шаховий баланс:|Шахматный баланс:"), true);
		panel.addItem("SHXALL_RSC", "    "+ UR("В розрiзi рахункiв|В разрезе счетов"), true);
		panel.addItem("SHXALL_RSC_Z", "    "+ UR("В розрiзi рахункiв (без забалансових)|В разрезе счетов (без забалансовых)"), true);
		panel.addItem("SHXALL_RSU", "    "+ UR("В розрiзi субрахункiв|В разрезе субсчетов"), true);
		panel.addItem("SHXALL_RSU_Z", "    "+ UR("В розрiзi субрахункiв (без забалансових)|В разрезе субсчетов (без забалансовых)"), true);
	panel.addItem("", 	UR("Головна книга:|Главная книга:"), true);
		panel.addItem("GLAVSC", "    "+ UR("В розрiзi рахункiв|В разрезе счетов"), true);
		panel.addItem("GLAVSU", "    "+ UR("В розрiзi субрахункiв|В разрезе субсчетов"), true);
		panel.addItem("GLAVSU_RST", "    "+ UR("В розрiзi статей|В разрезе статей"), true);
		panel.addItem("GLVMES", "    "+ UR("В розрiзi місяців|В разрезе месяцев"), true);
	//panel.addItem("SERVBLNK", 	UR("Баланс по коду|Баланс по коду"), true);
			
	this.selBLNHandler = selBLNHandler;
	panel.setSelectHandler(this, "selBLNHandler");
}

function selBLNHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "PROV":		
			sDlg = "l_prov.js";
			break;
		
		case "OBSCH":
			sDlg = "l_obsch.js";
			break;
		
		case "ANALIT":
			sDlg = "l_analit.js";
			break;
		
		case "VIP":
			include("Objects/DpGetDat.js");
			var gd = new DpGetDat("dDcutx0");
			if(gd.escape)
				return;			
			par.psc = gd.fsc;
			par.psu = gd.fsu;
			par.pst = gd.fst;
			par.pcl1 = gd.fcl1;
			par.pcl2 = 0;
			par.pdat = gd.dat1;
			par.pdat2 = gd.dat2;
			sDlg = "r_vip.js";
			break;
		
		case "OBSLVA":
			sDlg = "l_obslva.js";
			break;
		
		case "OBSLVS":
			sDlg = "l_obslvs.js";
			break;
		
		case "OBSLVM":
			sDlg = "l_obslvm.js";
			break;
			
		case "OBSLVD":
			sDlg = "l_obslvd.js";
			break;
			
		case "OBLNS":
			sDlg = "l_oblns.js";
			break;
			
		case "OTBLNPR":
			sDlg = "r_otblnpr.js";
			break;
			
		case "SHXALL_RSC":
			par.menuMode = "RSC";
			sDlg = "r_shxall.js";
			break;
			
		case "SHXALL_RSC_Z":
			par.menuMode = "RSC_Z";
			sDlg = "r_shxall.js";
			break;
			
		case "SHXALL_RSU":
			par.menuMode = "RSU";
			sDlg = "r_shxall.js";
			break;
			
		case "SHXALL_RSU_Z":
			par.menuMode = "RSU_Z";
			sDlg = "r_shxall.js";
			break;
			
		case "GLAVSC":
			par.menuMode = "R";
			sDlg = "r_glavsc.js";
			break;
			
		case "GLAVSU":
			par.menuMode = "R";
			sDlg = "r_glavsu.js";
			break;
			
		case "GLAVSU_RST":
			par.menuMode = "RST";
			sDlg = "r_glavsu.js";
			break;
			
		case "GLVMES":
			par.menuMode = "R";
			sDlg = "r_glvmes.js";
			break;
		
		case "SERVBLNK":
			sDlg = "l_servblnk.js";
			break;			
								
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}

function provHandler(sID, oPanel)
{
	var par = new Object();	
	par.menuMode = sID;
	showWindow("l_prov.js", SW_NOMODAL, par);
}
