function buildPanel()
{
	loadUOSDocsPanel();	
	loadUOSCalcPanel();
	loadUOSClPanel();	
}

function loadUOSDocsPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Первинні документи|Первичные документы"));
		
	var imgFile = lpProxy.getAppPlugLoc() + "icons/note_list.gif";	
	panel.addItem("O1", UR("Акти прийняття ОЗ1 (O1)|Акты приемки ОС1 (O1)"), imgFile);
	panel.addItem("O4", UR("Акти ліквідації ОЗ4 (O4)|Акты ликвидации ОС4 (O4)"), true);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/note_list 2.gif";	
	panel.addItem("O7", UR("Інв.карт.ОЗ7 (O7)|Инв.карт.ОС7 (O7)"), imgFile);
	panel.addItem("AB", UR("Амортизація по б/о (AB)|Амортизация по б/у (AB)"), true);
	panel.addItem("DOCS", UR("Інші документи|Другие документы"), true);	
	this.selUOSHandler = selUOSHandler;
	panel.setSelectHandler(this, "selUOSHandler");
}

function loadUOSCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Вихiднi документи|Выходные документы"));
		
	panel.addItem("AMIND", 	UR("Амортизацiя по податковому облiку|Амортизация по налоговому учету"), true);
	panel.addItem("AMALLP",	UR("Амортизацiя прямолiн.вiд перв.варт.|Амортизация прямолин.от перв.ст-ти"), true);
	panel.addItem("AMNALM", UR("Амортизацiя по податк.методиці|Амортизация по налоговому методу"), true);	
		
	this.selUOSHandler = selUOSHandler;
	panel.setSelectHandler(this, "selUOSHandler");
}

function loadUOSClPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Довідники|Справочники"));
		
	panel.addItem("NORMGR",	UR("Норми аморт.по групах|Нормы аморт.по группам"), true);
	panel.addItem("CLOV", 	UR("Норми аморт.по н/активах|Нормы аморт.по н/активам"), true);	
		
	this.selUOSHandler = selUOSHandler;
	panel.setSelectHandler(this, "selUOSHandler");
}

function selUOSHandler(sID, oPanel)
{
	if (String(lpProxy.getSystem()) != "UOS")
		lpProxy.getOrgManager().setSys("UOS", false);
	
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "AB":
		case "O1":
		case "O4":
		case "O7":
		case "DOCS":
			var oPar = new Object();		
			oPar.ret = new Object();
			oPar.isZaval = true;
			if(sID!="DOCS")
			{
				oPar.simple = true;
				oPar.onlyDoc = sID;				
			}	
			oPar.ret.fdoc = sID;
			oPar.ret.fnop = 0;
			oPar.title = UR("Виберіть папку|Выберите папку");
			showWindow("l_cl_lnk.xml", SW_MODAL, oPar);		
			if (oPar.escape)
				return false;				
			par.nop = oPar.ret.fnop;
			par.doc = oPar.ret.fdoc;
			sDlg = "l_docekz.xml";
			break;
		
		case "NORMGR":
			par.zaval = false;
			sDlg = "l_normgr.js";
			break;
		
		case "CLOV":
			par.zaval = false;
			sDlg = "l_clov.js";
			break;
			
		case "AMIND":
			sDlg = "r_amind.js";
			break;
			
		case "AMALLP":
			par.menuMode = "CALCP";
			sDlg = "l_amallp.js";
			break;		
				
		case "AMNALM":
			par.menuMode = "CALCM";
			sDlg = "l_amnalm.js";
			break;	
				
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}