//после перекодировки с 2000-й версии нужно по всем SVZP таблицам обнулить поле Fwid_wp 
//для полей ЛС удержаний, всего начислено, всего ударжано...
//алгоритм тупой: берём большой отрезок времени и проходимся во всем существующим таблицам за этот период
include("servis/date.js")
var d = new Date(1900,0,1)

function runSVZPUpdate(dat1, dat2)
{
	var D1 = new Date(2000,0,1).getVarDate();
	var D2 = firstDayMonth(today);
	if(typeOf(dat1)=="Date")
		D1 = firstDayMonth(dat1);
	if(typeOf(dat2)=="Date")
		D2 = firstDayMonth(dat2);
	var d = new Date(D1).getVarDate();
	var md = month_difference(new Date(D1),new Date(D2));
	var step = 1;
	var tblCount = 0;
	setProgressRange(step, md);
	while(differ(d,D2)<=0)
	{
		tblName = "SVZP"+getDateTag(d);
		setProgressPos(step++, tblName);
		if(IsTableEx("ZRP_RES", "ZRP_"+tblName))
		{
			tblName = "^"+tblName;
			trace("TRACE >>>> UPDATE "+tblName)
			ExecuteSQL("UPDATE "+tblName+" SET Fwid_wp = 0 WHERE EXISTS (SELECT * FROM ^lic_fld "
						+" WHERE Fid = "+tblName+".Flsfid AND Fis6 IN ('-','н','у','ф','б'))");
			//на телекомах был баг когда после перекодировки в Fmn попадала дата 01.01.1900 
			ExecuteSQL("UPDATE "+tblName+" SET Fmn="+sqlTo(d00)+" WHERE Fmn="+sqlTo(d))
			tblCount++;
		}
		d = goMonth(d, 1);
	}
	setProgressPos(0);
	alert("Обновлено "+tblCount+" таблиц");
}