include("servis\\format.js");
include("objects/DpSynchroSetting.js");

var synchroRegistry;

function onLoad()
{
	Caption(UR("Синхронізація|Синхронизация"));
	if (!lpProxy.testDocServerConnection())
	{
		alert(UR("Немає зв'язку з сервером|Отсутствует связь с сервером"));
		return false;
	}
	synchroRegistry = lpProxy.getSyncronizeRegistry();
	
	Tree.addColumn("class",UR("Клас|Класс"),250);
	Tree.addColumn("text","",250);
//-	Tree.addColumn("date",UR("Дата синхр.|Дата синхр."),150);
	
	this.canEdit = function(){return false;}
	this.onTreeSelected = function(){sSelID = String(Tree.getSelected());}
	this.Tree_mnuInit = Tree_mnuInit;
	this.Tree_mnuHandler = Tree_mnuHandler;
	
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	Tree.setCanEditHandler(this,"canEdit");
	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	Tree.loadMenuHandler(this, "Tree_mnuInit");
	
	fillTree();
}

function fillTree()
{
	fillDocs();
	fillCL();
	fillOther();
}

function fillCL()
{
	Tree.addItem(0,"CLS",UR("Довідники аналітики|Справочники аналитики"));
	Tree.setItemBold("CLS","class",true);
	
	var tFillCls = new java.lang.Thread(function run()
	{
		var clTbl = OpenTable("s","SELECT fcod,ftxt,fvid FROM ^clcl where fvid <> '2' Order By fcod,fvid");
		for (clTbl.MoveFirst();!clTbl.isEOF();clTbl.MoveNext())
		{
			var sTxt = clTbl.getValue("ftxt");
			var nCl = parseInt(clTbl.getValue("fcod"));
			var sFvid = clTbl.getValue("fvid");
			if (isNaN(nCl))
				continue;
			var sClassID = (isNaN(parseInt(sFvid))?sFvid:"CL" + parseInt(sFvid));
			var itmID = "CLS#" + sClassID + "#" + nCl;
			var isSynchronized = synchroRegistry.isSynchronized("CLS." + sClassID,nCl);
			if (!isSynchronized)
				continue;
			var itmID = "CLS#" + sClassID + "#" + nCl;
			Packages.org.eclipse.swt.widgets.Display
				.getDefault().syncExec(function()
			{
				Tree.addItem("CLS",itmID,"CL : " + nCl,3);
				Tree.setValue(itmID,"text",sTxt);
			});
		}
		
		Packages.org.eclipse.swt.widgets.Display
			.getDefault().syncExec(function()
		{
			var ti = Tree.getItem("CLS");
			if (ti.getItemCount() <= 0)
				Tree.removeItem("CLS");
		});
	});
	tFillCls.setPriority(1);
	tFillCls.start();
}

function fillDocs()
{
	Tree.addItem("0","DOCS",UR("Документи|Документы"))
	Tree.setItemBold("DOCS","class",true);
	
	var tFillDocs = new java.lang.Thread( function run()
	{
		var docTbl = OpenTable("s","SELECT fdoc,fnop,ftxt"
						  + " FROM ^cl_lnk"
						  + " ORDER BY fdoc,fnop");
		var prevClass = "";
		while(!docTbl.isEOF())
		{
			var sDoc = String(docTbl.getValue("Fdoc"));
			var sNop = String(parseInt(docTbl.getValue("Fnop")));
			var isSynchronized = synchroRegistry.isSynchronized("DOC." + sDoc,parseInt(sNop));
			if (!isSynchronized)
			{
				docTbl.MoveNext();
				continue;
			}
/*
			var syncDate = synchroRegistry.getLastSynchroDate(sDoc,parseInt(sNop));
			if (syncDate == null)
				syncDate = UR("невідомо|неизвестно");
			else
				syncDate = format("dd.mm.yyyy th:tm:ts",syncDate);
*/
			var itmID = "DOC#" + sDoc + "#" + sNop;
			var sText = UR(docTbl.getValue("Ftxt"));
			Packages.org.eclipse.swt.widgets.Display
				.getDefault().syncExec(function()
			{
				Tree.addItem("DOCS",itmID,sDoc + " : " + sNop,3);
				Tree.setValue(itmID,"text",sText);
				//Tree.setValue(itmID,"date",syncDate);
			});
			docTbl.MoveNext();
		}
	}
	);
	tFillDocs.setPriority(1);
	tFillDocs.start();
}


function fillOther()
{
	Tree.addItem(0,"OTHER",UR("Додатково|Дополнительно"));
	Tree.setItemBold("OTHER","class",true);
	
	
	if (synchroRegistry.isSynchronized("CLS.CL2", 0))
	{
		var itmID = "CLS#CL2#0";
		Tree.addItem("OTHER", itmID,"CLS.CL2",3);	
		Tree.setValue(itmID,"text","Справочник юридических лиц");
	}
	//Tree.setChecked(itmID,"synchro",synchroRegistry.isSynchronized("CLS.CL2", 0));
	
	if (synchroRegistry.isSynchronized("CLS.nmkl", 0))
	{
		var itmID = "CLS#nmkl#0";
		Tree.addItem("OTHER", itmID,"CLS.nmkl",3);	
		Tree.setValue(itmID,"text","Справочник номенклатуры");
	}
	//Tree.setChecked(itmID,"synchro",synchroRegistry.isSynchronized("CLS.nmkl", 0));
}


function Tree_mnuInit(toObject)
{
	if (sSelID == "DOCS"
	|| sSelID == "CLS"
	|| sSelID == "OTHER" 
	|| sSelID.indexOf("#") < 0)
		return;
	var sType = sSelID.substring(0,sSelID.indexOf("#"))
	var sClassID = sSelID.substring(sSelID.indexOf("#") + 1,sSelID.lastIndexOf("#"));
	var sNop = sSelID.substr(sSelID.lastIndexOf("#") + 1);
	if (sType == "DOCS")
		return;
	if (sNop == "")
		sNop = null;
	else
		sNop = parseInt(sNop);
/*	
	toObject.AddMenuItem("AUTO","Синхронізувати автоматично|Синхронизировать автоматически");
	toObject.AddMenuItem("MANUAL","Синхронізувати вручну|Синхронизировать вручную");
*/
	toObject.AddMenuItem("START","Синхронізувати|Синхронизировать");
	toObject.AddMenuItem("SYNCHRO","Налагодити та синхронізувати|Настроить и синхронизировать");
	toObject.AddMenuItem("SETTING","Налагодження|Настройка");
}

function Tree_mnuHandler(sID)
{
	if (sSelID == "DOCS" 
	|| sSelID.indexOf("#") < 0)
		return;
	var sType = sSelID.substring(0,sSelID.indexOf("#"))
	var sClassID = sSelID.substring(sSelID.indexOf("#") + 1,sSelID.lastIndexOf("#"));
	var sNop = sSelID.substr(sSelID.lastIndexOf("#") + 1);
	if (sType == "DOCS")
		return;
	if (sNop == "")
		sNop = null;
	else
		sNop = parseInt(sNop);
		
	if (sType == "CLS")
		sClassID = "CLS." + sClassID;

	var dpss = null;
	if (sID == "START")
		dpss = new DpSynchroSetting("LOAD");
	else
		dpss = new DpSynchroSetting("EDIT");
	if (sID != "SYNCHRO" && !dpss.loadBy(sClassID, sNop, sType))
		return;
	switch (sID)
	{
		case "START":
			var oPar = dpss.getSetting();	
			oPar.menumode = "CALC";
			showWindow("l_synchro.js", SW_NOMODAL, oPar);
		break;
		case "SYNCHRO":
			if (!lpProxy.testDocServerConnection())
			{
				alert(UR("Немає зв'язку з сервером|Отсутствует связь с сервером"));
				return;
			}
			if (!dpss.loadBy(sClassID, sNop, sType))
				return;
			var oPar = dpss.getSetting();			
			oPar.menumode = "CALC";
			showWindow("l_synchro.js", SW_NOMODAL, oPar);	
		break;
	}
}