include("servis/format.js")
var tbl = null;
var arrValues = null;
var arrCheckFormat = null;
include("Objects\\DpGrid.js");
include("gridedit.js");
var gridArray = new Array();

function Load()
{
	if(typeof extPar != "undefined")
		tbl = OpenTable(extPar.sTbl);
	else
		return;

	// values
	arrValues = new Array();
	arrCheckFormat = new Array();
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		var strVar = String(tbl.getValue("FVAR"));
		arrValues[strVar] = String(tbl.getValue("FVAL"));

		if (strVar == "C_DOC_STAN")
		{
			var obj1 = FORM.getDialogBuilder().getControl("DOC_STAN1");		
			var obj2 = FORM.getDialogBuilder().getControl("DOC_STAN2");		
			var obj3 = FORM.getDialogBuilder().getControl("DOC_STAN3");		
			if (obj1 != null && obj2 != null && obj3 != null)
			{
				var strVal = String(tbl.getValue("FVAL"));
				obj1.setValue(strVal == "1");							
				obj2.setValue(strVal == "2");
				obj3.setValue(strVal == "3");
			}							
		}
		else
		{
			var obj = FORM.getDialogBuilder().getControl(strVar);		
			if (obj != null)
			{
				var strVal = String(tbl.getValue("FVAL"));
				
				switch (String(typeOf(obj)).toUpperCase())
				{
					case "DPDATETIME":
					case "DPDATE":
						if (strVal)
						{
							/*
							if (strVal.lastIndexOf(".") == -1)
							{
								alert(strVal)
								strVal = strVal.substr(0,2) + "." + strVal.substr(2,2) + "." + strVal.substr(4); 
								alert(strVal)
							}
							*/
							//alert(new Date(strVal).getVarDate());
							obj.setValue(strVal);
						}
					break;
					
					case "DPGRID":		
						if (String(tbl.getValue("FTMPTABLE")) != "")
						{
							dpGridEdit = new DpGridEdit(obj);
							LoadGrid(obj, strVar, String(tbl.getValue("FTMPTABLE")));
							gridArray[strVar] = dpGridEdit; 
						}
					break;
					
					case "DPCHECK":
						// bool type format
						if (strVal.toUpperCase() == "TRUE" || strVal.toUpperCase() == "FALSE")
							arrCheckFormat[strVar] = 1;
						else if (strVal == "+" || strVal == "-")
							arrCheckFormat[strVar] = 2;
						else 
							arrCheckFormat[strVar] = 0;
							
						// bool type value
						if (strVal.toUpperCase() == "TRUE" || strVal == "+" || strVal == "1")
							obj.setValue(true);							
						else
							obj.setValue(false);							
					break;
					
					default:
						obj.setValue(strVal);
					break;
				}
			}
		}
	}

	if (typeof("subLoadList") != "undefined")
		subLoadList(this);
}

function LoadGrid(obj, sLabel, strSQL)
{
	var rsTbl = OpenTable(strSQL);
	obj.setTable(rsTbl);	
	
	var gridXml = extPar.sFullDir + "/" + sLabel + ".xml"; 
	if (new DpFile(gridXml).exists())
	{
		obj.setXMLDir(extPar.sFullDir);
		obj.setXMLFile("/" + sLabel + ".xml");
		obj.build();
	}
	else
	{
		var oGrid = new DpGrid("", obj);
		with(oGrid)
		{	
			with(page())
			{	
				var nFld = rsTbl.fieldCount();			
				for (var i = 1;i < nFld + 1;i++)
				{
					var fld = rsTbl.getFieldInfo(i);
					if (fld == null)
						continue;
					if (String(fld.getName()).toUpperCase() == "FWID")
						continue;				
					var sFormat = getGridFormat(fld.getType());
					cell(new String(fld.getName()), new String(fld.getName()), 10, "e", sFormat);
				}
			}
			build();
		}
	}

	obj.saveFormat(false);
}

function getGridFormat(sType)
{
	switch(String(sType))
	{
		case "DOUBLE":
			//return DP_FORMAT_SUM;
			return "%10.5f";
		default:
			return null;
	}	
}

function onSave()
{	
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		tbl.Edit();
	
		if (String(tbl.getValue("FVAR")) == "C_DOC_STAN")
		{
			var obj1 = FORM.getDialogBuilder().getControl("DOC_STAN1");		
			var obj2 = FORM.getDialogBuilder().getControl("DOC_STAN2");		
			var obj3 = FORM.getDialogBuilder().getControl("DOC_STAN3");		
			if (obj1 != null && obj2 != null && obj3 != null)
			{
				if (obj1.checked)
					tbl.setValue("FVAL", "1");
				else if (obj2.checked)
					tbl.setValue("FVAL", "2");
				else
					tbl.setValue("FVAL", "3");
			}							
		}
		else
		{
			var obj = FORM.getDialogBuilder().getControl(String(tbl.getValue("FVAR")));
			if (obj != null)
			{
				switch (String(typeOf(obj)).toUpperCase())
				{
					case "DPDATETIME":
					case "DPDATE":
	//						tbl.setValue("FVAL", format("dd.mm.yyyy",obj.getValue()));
						tbl.setValue("FVAL", String(Date(obj.getValue())));
					break;
					
					case "DPGRID":		
					break;
	
					case "DPCHECK":
						if (arrCheckFormat[String(tbl.getValue("FVAR"))] == 1)
						{
							if (obj.checked == true)
								tbl.setValue("FVAL", "True");
							else
								tbl.setValue("FVAL", "False");
						}
						else if (arrCheckFormat[String(tbl.getValue("FVAR"))] == 2)
						{
							if (obj.checked == true)
								tbl.setValue("FVAL", "+");
							else
								tbl.setValue("FVAL", "-");
						}
						else 
						{
							if (obj.checked == true)
								tbl.setValue("FVAL", "1");
							else
								tbl.setValue("FVAL", "0");
						}
					break;
					
					default:
						tbl.setValue("FVAL", String(obj.getValue()));
					break;
				}
			}
		}
		tbl.Update();
	}
}

include("sys\\DpBaseDlg.js");