// JScript source code
function DpWizard()
{
	FORM.setScriptHandler(this);
	
	this.validOnlyVisibleCtrls = true;
	this.validateAll = DpWizard_validateAll;	
	
	this.performFinish = DpWizard_performFinish; 
	
	if(typeof(onFinish)=="function")
		this.onFinish = onFinish;
	else
		this.onFinish = new Function("return true");
		
	//Доступность кнопки FINISH нужно вернуть true или false
	if (typeof(wizardCanFinish) == "function")
		this.canFinish = wizardCanFinish;
	
	//Оброботчик отмены
	if (typeof(wizardPerformCancel) == "function")
		this.performCancel = wizardPerformCancel;
	
	//Событие после создания страниц
	//Тут можно проинициализировать элем. управления, маски
	if (typeof(wizardPageCreated) == "function")
		this.onPageCreated = wizardPageCreated;
		
	//Событие перед сменой страгицы
	if (typeof(wizardPageChanging) == "function")
		this.handlePageChanging = wizardPageChanging;
	
	//Событие после смены страгицы
	if (typeof(wizardPageChanged) == "function")
		this.pageChanged = wizardPageChanged;
	
	//Доступность кнопки NEXT нужно вернуть true или false
	if (typeof(wizardСanFlipToNextPage) == "function")
		this.canFlipToNextPage = wizardСanFlipToNextPage;
	
	if (typeof(wizardGetStartingPage) == "function")
		this.getStartingPage = wizardGetStartingPage;	
	
	if (typeof(wizardGetNextPage) == "function")
		this.getNextPage = wizardGetNextPage;	
	
	if (typeof(wizardGetPreviousPage) == "function")
		this.getPreviousPage = wizardGetPreviousPage;	
	
	//Тут можно переопределить функции и установить заголовок.
	//Но элементы управления еще НЕ СОЗДАНЫ!!!
	if(typeof(wizardInit)=="function")
	{
		this.init = wizardInit;
		this.init();
	}
		
}


function DpWizard_performFinish()
{
	softInvalid = false;
	
	var valid = this.validateAll()
	
	softInvalid = true;
	
	if (!valid)
	{
		return false;
	}
	
	
	if (this.onFinish()===false)
		return false;	
	
	return true;
}

function DpWizard_validateAll()
{
	var ctrls = new Array();
	if (typeof(FORM.getControls) == "function")
	{
		ctrls = FORM.getControls(); 
	}
	for (var i = 0; i < ctrls.length; i++)
	{
		var oCtrl = null;
		var e;
		try
		{
			oCtrl = eval(String(ctrls[i]));
		}
		catch(e)
		{
		}	
		
		if (typeof(oCtrl) == "undefined" || !oCtrl)
			continue;
	
		if (typeof(oCtrl.isDisposed)!="undefined")
		{
			if (oCtrl.isDisposed())
				continue;
		}
		
		if (typeof(oCtrl.isEnabled) != "undefined")
		{
			if (!oCtrl.isEnabled())
				continue;
		}
		
		if (this.validOnlyVisibleCtrls)
		{
			if (typeof(oCtrl.isVisible) != "undefined")
			{
				if (!oCtrl.isVisible())
					continue;
			}
		}
		
		if (runValid(oCtrl) == false)
		{
			setFocus(oCtrl);			
			this.bSaving = false;
			return false;
		}		
	}
	return true;
}



if (typeOf(FORM) == "DpWizard")
{
	new DpWizard();
}