
function DpTestSuite(oClass)
{
	include("testApi\\DpTestResult.js");
	this.result = new DpTestResult();
	this.arrTest = new Array();
	this.addTest = DpTestSuite_addTest;
	this.run = DpTestSuite_run;
	this.getTestResult = DpTestSuite_getTestResult;
	this.addTests =  DpTestSuite_addTests;	
	if( typeof(oClass) == "function")
	{
		this.addTests(oClass);
	}		
}

function DpTestSuite_addTest(oTest)
{
	this.arrTest[this.arrTest.length] = oTest;
}

function DpTestSuite_addTests(oClass)
{
	var oTestMain = new oClass();
	for(var func in oTestMain)
	{
		if (typeof(oTestMain[func]) == "function" && func.substr(0,4) == "test")
		{
			var oTest = new oClass(func);
		 	oTest.setFuncName(func);
		 	this.addTest(oTest);
		}
	}
}

function DpTestSuite_run(testName)
{		
	for (var i = 0; i < this.arrTest.length; i++)
	{
		var oTest = this.arrTest[i];
				
		oTest.runTest(testName);					
		this.result.addResult(oTest.getTestResult());		
	}
}

function DpTestSuite_getTestResult()
{
	return this.result;
}