
include("sys\\dpsql.js");
include("objects\\DpGrid.js");
include("objects\\DpTotals.js");
include("objects\\DpGetDat.js");
include("r_vporvd.js");
include("sys\\dplist.js");

var editAcc = ""
//__CreateGrid();
var gd_view;

var ds,rs, OutTable, OutTableS, existTable;
var prnPatt = "VPCD";
var capt, capt1, capt2, capt3;

var menuMode;
var parzarp;
var isVal;

function listLoad()
{
	menuMode = GetMenuMode();
	isVal = strIn("VAL", menuMode);
   
	var arrVariants = list.getVariantsArr()
   
	with ( list.objTotal )
	{
		init("VP_CD")
	}
	
	with( list )
	{
		subTitle = _listTitle;
		subMenuInit = menuInit;
		subMenuRun = menuRun;
		printLabel = "VPCD";
//-		xmlGridFile = "vp_cd.xml";
	}
}

function listSrc()
{
	var prefix = "";
	if(isVal)
		prefix = "val"
	
	if(strIn("CALC", menuMode))
	{	
		OutTable  = "C" + prefix + String(list.objAsk.fsc)+"_"+String(list.objAsk.fsu);
		OutTableS = "S" + prefix + String(list.objAsk.fsc)+"_"+String(list.objAsk.fsu);
	}
	else if (strIn("VIEW", menuMode))
	{
		gd_view = new DpGetDat(new Array("s:cu0"));
	    OutTable  = "C" + prefix + gd_view.fsc+"_"+gd_view.fsu;
		OutTableS = "S" + prefix + gd_view.fsc+"_"+gd_view.fsu;
	}
	else // заходим из  других док-тов
	{
		OutTable  = "C" + prefix + String(list.objAsk.fsc)+"_"+String(list.objAsk.fsu);
		OutTableS = "S" + prefix + String(list.objAsk.fsc)+"_"+String(list.objAsk.fsu);
	}

	with( list )
	{
		qrySet( "From", "tbl24",//OutTable,
				"Ptn", "creddeb");
		if (SQL)
			subTie("cl_valut", "valname", "fkod", "Fval",null,TIE_NOSEARCH);	
		else
			subTie("cl_valut", "valname", "fkod", "Fval",null,TIE_NOSEARCH);	
	}
	grid.setSQLQueryCount(true);	
}

function listInitTotals4Ext()
{
	var fsc;
	var fsu;
	var fst;
	if (strIn("VIEW", menuMode))
	{
	    fsc = gd_view.fsc;
	    fsu = gd_view.fsu;
	    fst = 0;
	}
	else
	{
	    fsc = list.objAsk.fsc;
	    fsu = list.objAsk.fsu;
	    fst = list.objAsk.fst;
	}

	if (fsc)
	{
		sWhere = " WHERE fschet = " + fsc
					+ " and fsubschet<>0 " // не учитываем корневую запись
					+ " and (fstat <> 0 or NOT EXISTS "
						+ " (SELECT * FROM ^cl_schet where a.fschet=fschet and a.fsubschet=fsubschet and fstat<>0)) " 
					+ ( fsu ? " and fsubschet = " + fsu : " ")
					+ ( fst ? " and fstat = " + fst : " ")
		var tmp_cl = OpenTable("s","SELECT * from ^cl_schet a " + sWhere);
		if (!tmp_cl.IsEmpty())
		{
			tmp_cl.MoveFirst();
			var_cl1 = Number(tmp_cl.getValue("FCL1"));
			var_cl2 = Number(tmp_cl.getValue("FCL2"));
			var_cl3 = Number(tmp_cl.getValue("FCL3"));
			for (tmp_cl.MoveFirst(); !tmp_cl.IsEOF(); tmp_cl.MoveNext())
			{
				if (var_cl1 != tmp_cl.getValue("FCL1"))
					var_cl1 = -1;
				if (var_cl2 != tmp_cl.getValue("FCL2"))
					var_cl2 = -1;
				if (var_cl3 != tmp_cl.getValue("FCL3"))
					var_cl3 = -1;
			}
			list.objTotal.makeTotal.Add2ItogExtMap("ext_fcr_cod1", (var_cl1 ? var_cl1 : -1));
			list.objTotal.makeTotal.Add2ItogExtMap("ext_fcr_cod2", (var_cl2 ? var_cl2 : -1));
			list.objTotal.makeTotal.Add2ItogExtMap("ext_fcr_cod3", (var_cl3 ? var_cl3 : -1));
		}
	}
}

function listAsk()
{ 
  	arrVariants = list.getVariantsArr()
  	
  	var parzapr;
  	var gd = new Object();
	if(isVal)
		parzapr = new Array("b0", "r", "s:cutx0", "v0");
	else
		parzapr = new Array("b0", "r", "s:cutx0");
		
	if(strIn("CALC", menuMode) || menuMode=="")
	{
		if(extPar==null) isRaskr=false;
		else isRaskr = extPar.isRaskr;
		if(extPar==null) tdt=new Date();
		else gd.dat1 = toScriptDate(extPar.pdat);
		if(extPar==null) tdt2=new Date();
		else gd.dat2 = toScriptDate(extPar.pdat2);
		if(extPar==null) tsc=0;
		else gd.fsc = extPar.psc;
		if(extPar==null) tsu=0;
		else gd.fsu = extPar.psu;
		if(extPar==null) tst=0;
		else gd.fst = extPar.pst;
		if(extPar==null) tcl1=0;
		else gd.fcl1 = extPar.pcl1;
		if(extPar==null || !extPar.pcl2) tcl2=0;
		else gd.fcl2 = extPar.pcl2;
		if(extPar==null || !extPar.pcl3) tcl3=0;
		else gd.fcl3 = extPar.pcl3;
		if(extPar==null) tval=0;
		else gd.codv = extPar.val;
		if(extPar==null) tval_nzv="";
		else gd.fval = extPar.val_nzv;

		if(extPar!=null && extPar.val!=0) 
			isVal=true;
	
		if (!isRaskr)
		{
			gd =  new DpGetDat(parzapr, arrVariants);
			if (gd.escape)
				return gd;
			var dat1 = gd.dat1;
			var dat2 = gd.dat2;
			var sch_num = gd.fsc;
			var sub_num = gd.fsu;
			var sta_num = (gd.fst ? gd.fst : 0);;
			var cl1_num = (gd.fcl1 ? gd.fcl1 : 0);
			var cl2_num = (gd.fcl2 ? gd.fcl2 : 0);
			var cl3_num = (gd.fcl3 ? gd.fcl3 : 0);
			var val_cod = (gd.codv ? gd.codv : "");
			var val_nzv = (gd.fval ? gd.fval : "");
		}
		else
		{
			var dat1 = gd.dat1;
			var dat2 = gd.dat2;
			var sch_num = gd.fsc;
			var sub_num = gd.fsu;
			var sta_num = (gd.fst ? gd.fst : 0);;
			var cl1_num = (gd.fcl1 ? gd.fcl1 : 0);
			var cl2_num = (gd.fcl2 ? gd.fcl2 : 0);
			var cl3_num = (gd.fcl3 ? gd.fcl3 : 0);
			var val_cod = (gd.codv ? gd.codv : "");
			var val_nzv = (gd.fval ? gd.fval : "");
			gd.fitog = getParWithDef("CR_ITOG", getSysName(), 50);
			gd.escape = false;
		}
	}
	
	if (OutTableS==null)
	{
		prefix = "";
		if(isVal)
			prefix = "val"
		OutTable  = "C" + prefix + String(gd.fsc)+"_"+String(gd.fsu);
		OutTableS = "S" + prefix + String(gd.fsc)+"_"+String(gd.fsu);
	}
	DropTable(OutTable);
	DropTable(OutTableS);
	if(IsTable(OutTable) || IsTable(OutTableS))
	{ 
		alert("Невозможно выполнить расчет."+"\nПроверьте, возможно окно с данным расчетом уже открыто,"+"\nили перезапустите систему.");
		gd.escape = true;
	}
	if(strIn("CALC", menuMode)  || menuMode=="")
	{	
		strSQL = "CREATE TABLE "+OutTableS+" (fsch "+SqlType(sqlTSc)+", fsub "+SqlType(sqlTSu)+", fsta "+SqlType(sqlTSt)
				+", fcl1 "+SqlType("INTEGER")+", fcl2 "+SqlType("INTEGER")+", fcl3 "+SqlType("INTEGER")
				+", fval "+SqlType("CHAR",3)+", fbdat "+SqlType("DATE")+", fedat "+SqlType("DATE")+")";
		ExecuteSQL(strSQL);
		
		var m = new Object();		
		m.fsch = sch_num;
		m.fsub = sub_num;
		m.fsta = sta_num;
		m.fcl1 = cl1_num;
		m.fcl2 = cl2_num;
		m.fcl3 = cl3_num;
		m.fval = val_nzv;
		m.fbdat = dat1;
		m.fedat = dat2;
		updateTable(OutTableS,m,true);
	}

	return gd;
}

function _listTitle()
{
	if (IsTable(OutTableS))
	{
		var ts = OpenTable("s", OutTableS);
		var sch_num = ts.getValue("fsch");
		var sub_num = ts.getValue("fsub");
		var sta_num = ts.getValue("fsta");
		var cl1_num = ts.getValue("fcl1");
		var cl2_num = ts.getValue("fcl2");
		var cl3_num = ts.getValue("fcl3");
		var val_nzv = ts.getValue("fval");
		var dat1    = toScriptDate(ts.getValue("fbdat"));
		var dat2    = toScriptDate(ts.getValue("fedat"));
	}

	capt3 = " в дебет рахунків | в дебет счетов ";
	if (menuMode.substr(1,1)=="G") //AL: 10.07.2003 Сейчас не выполняется 
	{
		if (captmenuMode.substr(1,1)=="O")
		{
			capt1 = "Журнал-ордер N 13 по рахунку "+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" "
					+"|Журнал-ордер N 13 по счету "+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" ";
			capt2 = " за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+"| за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY");
			capt = "Журнал-ордер N 13 по рахунку "+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
					+" за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+" в дебет рахунків "
					+"|Журнал-ордер N 13 по счету "+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
					+" за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+" в дебет счетов ";
		}
		else
		{
			capt1 = "Виписка до журналу-ордеру з кредита рах."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" "
					+"|Выписка к журналу-ордеру с кредита сч."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" ";
			capt2 = " за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+"| за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY");
			capt = "Виписка до журналу-ордеру з кредита рах."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
					+" за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+" в дебет рахунків "
					+"|Выписка к журналу-ордеру с кредита сч."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
					+" за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
					+" в дебет счетов ";
		}
	}
	else
	{
		capt1 = "Виписка до журналу-ордеру з кредита рах."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" "
				+"|Выписка к журналу-ордеру с кредита сч."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)+" ";
		capt2 = " за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
				+"| за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY");
		capt3 = " в дебет рахунків у "+val_nzv
				+"| в дебет счетов  в "+val_nzv;
		capt = "Виписка до журналу-ордеру з кредита рах."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
				+" за період з "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
				+" в дебет рахунків у "+val_nzv
				+"|Выписка к журналу-ордеру с кредита сч."+String(sch_num)+"/"+String(sub_num)+"/"+String(sta_num)+"/"+String(cl1_num)
				+" за период с "+StrDat(dat1, "DMY")+ " по "+StrDat(dat2, "DMY")
				+" в дебет счетов  в "+val_nzv;
	}
	return capt;
}


function listMake()
{
	var parras;
	
	if (isVal)
		parras = "CDV";
	else
		parras = "CD";
	
	r_vpov (parras , OutTable, list.objAsk.dat1, list.objAsk.dat2
		, list.objAsk.fsc, list.objAsk.fsu, list.objAsk.fst
		, list.objAsk.fcl1, list.objAsk.fcl2, list.objAsk.fcl3
		, list.objAsk.codv);
	
	
	include("doc\\DpDoc.js");
	include("Objects\\DpJRegistrator.js");
	var oDoc = new DpDoc("TD",0);
	var jID = oDoc.getPar("__jrn");
	var oReg = new DpJRegistrator(null,null);
	var journal = oReg.listJournals()[jID];
	tbl_j=journal.getFullTableName();
	
	include ("Objects\\DpExtentionBuilder.js");
	var oExt = new DpExtentionBuilder("CL","0",null);
	if(oExt.exist())
	{
		var extTblName = oExt.getValueTableName();
		DropTable("tbl24");
		ExecuteSQL("SELECT t.*,j.Forg,j.Fdog"
					+",o.F_budjet,o.Fvidd,h.Flpu,p.Fcodarea,p.Fcodregion "
					+" INTO tbl24 "
					+" FROM "+OutTable+" AS t "
					+" INNER JOIN "+tbl_j+" AS j ON t.Fid_doc=j.Hid_doc "
					+" INNER JOIN ^clrelclcl AS cl ON j.Forg=cl.Fcod "
					+" INNER JOIN "+extTblName+" AS o ON cl.Fwid_cl=o.Fmainwid "
					+" INNER JOIN ^contract AS c ON j.Fdog=c.Fwid "
					+" INNER JOIN ^htd AS h ON c.Fwid=h.Fid_dog "
					+" INNER JOIN ^cl_post as p ON p.Fwid_cl=cl.Fwid_cl"
				+" WHERE c.Fdoc='TD' and cl.Fcl=12 ");
	}
}

function listDpGridEx(oGrid)
{
	oGrid.setXMLFile("vp_cd24.xml");
	var oPrefix = oGrid.prefix().group();
	list.GroupPage(oGrid, oPrefix);
/*
	var isAnalit = (menuMode.substr(menuMode.length-1,1)=="A");
	var numAn = (isAnalit ? 6 : 4);
	var wnazv = (isAnalit ? 13 : 13);
	
	var oGrid = new DpGrid("NOCREATE");
	var nazv_group;
	
	with(oGrid)
	{
		with(prefix())
		{
			cell("fdocnum","№\nДок.|№\nДок.",5);
			cell("fdate","Дата|Дата",8);

			nazv_group = group();
			with(nazv_group)
			{
				cell("FTxt","Зміст операції|Содержание операции",wnazv,"w");
			}
			with(group("Дебет|Дебет"))
			{
				with(group("Рах.|Сч."))
				{
					cell("=CStr(nvl(^Fdb_sc, 0))+chr(10)+iif(nvl(^fdb_cod1, 0)=0, \"\", CStr(nvl(^fdb_cod1, \"\")))", "Ан.1", 4, "w");
				}
				with(group("С/р|С/с"))
				{
					cell("=CStr(nvl(^Fdb_su, 0))+chr(10)+iif(nvl(^fdb_cod2, 0)=0, \"\", CStr(nvl(^fdb_cod2, \"\")))", "Ан.2", 4, "w");
				}
				with(group("Ст.|Ст."))
				{
					cell("=CStr(nvl(^Fdb_st, 0))+chr(10)+iif(nvl(^fdb_cod3, 0)=0, \"\", CStr(nvl(^fdb_cod3, \"\")))", "Ан.3", 4, "w");
				}

				cell("=sccltxt(CByte(int(nvl(^Fdb_sc, 0)/10)),nvl(^Fdb_sc, 0),nvl(^Fdb_su, 0),nvl(^Fdb_st, 0), nvl(^Fdb_cod1, 0), nvl(^Fdb_cod2, 0), nvl(^Fdb_cod3, 0))", "Назва|Название", 12, "w");
			}
			with(group("Кредит|Кредит"))
			{
				with(group("Рах.|Сч."))
				{
					cell("=CStr(nvl(^Fcr_sc, 0))+chr(10)+iif(nvl(^fcr_cod1, 0)=0, \"\", CStr(nvl(^fcr_cod1, \"\")))", "Ан.1", 4, "w");
				}
				with(group("С/р|С/с"))
				{
					cell("=CStr(nvl(^Fcr_su, 0))+chr(10)+iif(nvl(^fcr_cod2, 0)=0, \"\", CStr(nvl(^fcr_cod2, \"\")))", "Ан.2", 4, "w");
				}
				with(group("Ст.|Ст."))
				{
					cell("=CStr(nvl(^Fcr_st, 0))+chr(10)+iif(nvl(^fcr_cod3, 0)=0, \"\", CStr(nvl(^fcr_cod3, \"\")))", "Ан.3", 4, "w");
				}

				cell("=sccltxt(CByte(int(nvl(^Fcr_sc, 0)/10)),nvl(^Fcr_sc, 0),nvl(^Fcr_su, 0),nvl(^Fcr_st, 0), nvl(^Fcr_cod1, 0), nvl(^Fcr_cod2, 0), nvl(^Fcr_cod3, 0))", "Назва|Название", 12, "w");
			}
		}
		with(page())
		{
			if (!isVal)
			{
				cell( "fsum", "Сума|Сумма", 8, "zn");
				sz = "=iif(Cstr(^valname.fnazvs)<>\"\",CStr(nvl(^FSUMVAL, 0))+\" \"+Cstr(^valname.fnazvs),\"\")";
				cell(sz, "Сума исх.|Сумма исх.",8,"w");
			}
			else
			{
				sz = "=CStr(nvl(^FSUM, 0))+\" \"+Cstr(^valname.fnazvs)";
				cell(sz, "Сума|Сумма",8);
				cell( "=nvl(^FSUMSPRVAL, 0)", "Сума дов.|Сумма спр.", 8, "zn");
 			}
		}
		with(page())
		{
			cell( "=nvl(^FSUMSPRVAL, 0)","Сума у\nдов.вал.|Сумма в\nспр.вал.", 8, "zn");
		}
		if (menuMode.substr(1,1)!="V")
			with(page())
			{
				cell( "=nvl(^FSUMSPR, 0)","", 8, "zn");
			}
		var oExtPage = page("Итоги");
		list.GroupPage(oGrid, oExtPage.group(), 8, false, nazv_group, wnazv, "w");

		onePageMode(false);
		build();
	}
	addDsAccel(GA_CTRL, "D", "CTRL-D");
	addDsAccel(GA_CTRL, "P", "CTRL-P");
*/
}

function getTblH()
{
	var hrs = new Object();
	
	hrs.FCAPTION1 = capt1;
	hrs.FCAPTION3 = capt3;
	hrs.FCAPTION2 = capt2;
	
	return hrs;
}


function menuInit()
{
	if(!list.tbl.IsEmpty() && list.tbl.getValue("fwid")!=null)
	{
		list.dataSrc.AddMenuItem(
			"CTRL-D",
			"Пошук документа за проведенням|"+
			"Поиск документа по проводке");
		list.dataSrc.AddMenuItem(
			"CTRL-P",
			"Знайти проведення в списку|"+
			"Найти проводку в списке");
	}
}

function menuRun(ID)
{
	with(list)
	{
		switch(ID)
		{
		case "CTRL-D":
			if(!list.tbl.IsEmpty())
			{
				include("doc\\dpdocptn.js");
				FindDocument(list.tbl.getValue("Fdoc"), list.tbl.getValue("Fnop"), list.tbl.getValue("Fid_doc"));
			}
			break;
		case "CTRL-P":
			if(!list.tbl.IsEmpty() && list.tbl.getValue("Fwid_sch"))
			{
				include("doc\\dpdocptn.js");
				FindProvInList(list.tbl.getValue("Fwid_sch"));
			}
			break;
/*			
		case "PRINT":
		    include("objects\\DpTVars.js");
			var tv = new DpTVars(prnPatt);
			var bm = list.tbl.bookmark;
			tv.setRTbl(list.tbl);
			var hrs = new Object();
			hrs.FCAPTION1 = capt1;
			hrs.FCAPTION3 = capt3;
			hrs.FCAPTION2 = capt2;
			tv.setHTbl(hrs);
			tv.print();
			list.tbl.bookmark = list.tbl;
			break;
*/
		}
	}
}
function listChangeTotals()
{
	if (list.objTotal)
		setParWithDef("CR_ITOG", list.objTotal.variantCur, getSysName());	
}
