
function userMenuLoad()
{
	DataSource().AddMenuItem("+++", "Експорт в M.E.DOC|Экспорт в M.E.DOC");
	if (list.m_Doclabel.toUpperCase() == "BS")
	{
		DataSource().AddMenuItem("EXPORT_TO_MEDOC","Експорт в M.E.DOC (видані п.н.)|Экспорт в M.E.DOC (выданные н.н.)");
		DataSource().AddMenuItem("EXPORT_TO_MEDOC2","Експорт в M.E.DOC (отримані п.н.)|Экспорт в M.E.DOC (полученные н.н.)");
	}
	else
	{
		DataSource().AddMenuItem("EXPORT_TO_MEDOC","Виконати експорт в M.E.DOC|Выполнить экспорт в M.E.DOC");
		if (list.m_Doclabel.toUpperCase() == "NV")
			DataSource().AddMenuItem("EXPORT_TO_MEDOC3","Експорт коригування в M.E.DOC|Экспорт корректировки в M.E.DOC");
	}
	DataSource().AddMenuItem("RESET_FERPN","Зняти ознаку експорта в M.E.DOC|Снять признак экспорта в M.E.DOC");
	DataSource().AddMenuItem("EXPORT_TO_MEDOC4","Запит відомостей з ЄР в M.E.DOC|Запрос ведомостей из ЕР в M.E.DOC");
	DataSource().AddMenuItem("EXPORT_TO_MEDOC5","Запит відомостей з ЄР в M.E.DOC (Кориг.)|Запрос ведомостей из ЕР в M.E.DOC (Кор.)");
	DataSource().AddMenuItem("---", "Експорт в M.E.DOC|Экспорт в M.E.DOC");
}

function userMenuRun(nID)
{
	if (nID == "RESET_FERPN")
	{
		var oDoc = new DpDoc(list.m_Doclabel,list.m_Nop,list.docList);
		ExecuteSQL("UPDATE ^" + oDoc.getTableName() + " SET FERPN=0 WHERE " + list.dataSrc.sqlSelected() )
		
		list.tbl.requery();
		grid.RefreshGrid(RG_SAVEROW);
	
	}
	if (nID == "EXPORT_TO_MEDOC" || nID == "EXPORT_TO_MEDOC2" || nID == "EXPORT_TO_MEDOC3")
	{
		// delete old medoc files
		if (getPar("EXPDIR") || getPar("MEDOC_DIR_NAKL"))
		{
			var medocDir = getPar("EXPDIR");
			medocDir += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
			medocDir += "to_MEDOC/";
			if(getPar("MEDOC_DIR_NAKL"))//если указана конкретная директория для экспорта накладных, то используем ее
				medocDir = getPar("MEDOC_DIR_NAKL");
			
			var dir = DpFile(medocDir);
			//var dir = new java.io.File(medocDir);
			if(dir.isDirectory())
			{
				var files = dir.listFiles();				
				for(i=0; i<files.length; i++)
				{
					var docFile = files[i];
					deleteFile(docFile.getAbsoluteFile());
				}
			}
			else
				createDirectory(medocDir);			
		}
		else
		{
			alert(ru("Не установлен параметр: ","Не встановлено параметр: ")+getParItemPath("MEDOC_DIR_NAKL", true),1)
			return false;
		}
		
		var oDoc = new DpDoc(list.m_Doclabel,list.m_Nop,list.docList);
		
		var selIDs = list.dataSrc.getSelectedIDs();
		if (selIDs.length == 0)
			selIDs = new Array(list.tbl.getRowID());
		var progress = getProgressMonitor();
		progress.beginTask("Export to M.E.DOC",selIDs.length);
		for (var n = 0; n < selIDs.length; n++)
		{
			if (oDoc.loadByID(selIDs[n],false,true))
			{
				ExportDocsToMedoc(oDoc, list.m_Doclabel, nID);
				oDoc.clear();
			}
			progress.worked(1);
		}
		progress.done();

		list.tbl.requery();
		grid.RefreshGrid(RG_SAVEROW);
		
		alert("Выгрузка окончена - " + (getPar("MEDOC_DIR_NAKL")?getPar("MEDOC_DIR_NAKL"):getPar("EXPDIR") + "/to_MEDOC"));
	}	
	else if (nID == "EXPORT_TO_MEDOC4" || nID == "EXPORT_TO_MEDOC5")
	{
		var xml = new DpXMLDOMDocument();
		with(xml)
		{
			with( createChild("DECLAR"))
			{
				setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
				setAttribute("xsi:noNamespaceSchemaLocation", "J1300101.xsd");
	
				with (createChild("DECLARHEAD"))
				{
					createChild("TIN", getPar("OOKPO"));
					createChild("C_DOC", "J13");
					createChild("C_DOC_SUB", "001");
					createChild("C_DOC_VER", "1");
					createChild("C_DOC_TYPE", "0");
					createChild("C_DOC_CNT", "1");
					createChild("C_REG", "23");
					createChild("C_RAJ", "1");                  //Район
					createChild("PERIOD_MONTH", format("m", list.tbl.getValue("FDOC_DAT")))
					createChild("PERIOD_TYPE", "1");
					createChild("PERIOD_YEAR", format("yyyy", list.tbl.getValue("FDOC_DAT")))
					createChild("D_FILL", format("ddmmyyyy", new Date()));
					createChild("SOFTWARE", "DPA");
				}
				with (createChild("DECLARBODY"))
				{
					createChild("HFILL", format("ddmmyyyy", today));
					createChild("HDATE", format("ddmmyyyy", today));
					createChild("HNUM", 0);
					createChild("HNUM1", 0);
					createChild("HTIN", getPar("OOKPO"));
					createChild("HEMAIL", "");
//					createChild("HKSTI", 2665);
//					createChild("HSTI", "СДПI ПО РОБОТI З ВПП У М.КИЄВI");
					createChild("HNPDV", getPar("OKODNDS"));
					createChild("HNAME", getPar("OFIRM"));

					var nRow = 0;
					var oDoc = new DpDoc(list.m_Doclabel,list.m_Nop,list.docList);
					var selIDs = list.dataSrc.getSelectedIDs();
					if (selIDs.length == 0)
						selIDs = new Array(list.tbl.getRowID());
					var progress = getProgressMonitor();
					progress.beginTask("Export to M.E.DOC",selIDs.length);
					for (var n = 0; n < selIDs.length; n++)
					{
						if (!oDoc.loadByID(selIDs[n],false,true))
							continue;
							
						var nom = oDoc.getVar("EXT.NK_NUM");
						if (!nom)
							nom = oDoc.getVar("HTAXNOM");
						if (!nom)
							nom = oDoc.getVar("HNOM");
						var dat = oDoc.getVar("EXT.NK_DAT");
						if (!differ(dat, d00))
							dat = oDoc.getVar("HTAXDAT")							
						if (!differ(dat, d00))
							dat = oDoc.getVar("HDAT")							
					
						forg = oDoc.getVar(oDoc.getVar("ATTR.FLDORG"));			
						nRow++;		
						var aAttrRow = {"ROWNUM": nRow};
						
						createChild("T1RXXXXG11", nRow, aAttrRow);
						createChild("T1RXXXXG21", nom, aAttrRow);
						createChild("T1RXXXXG3D", format("ddmmyyyy", dat), aAttrRow);
						if (nID == "EXPORT_TO_MEDOC4")
							createChild("T1RXXXXG4S", "ПН", aAttrRow);
						else
							createChild("T1RXXXXG4S", "РК", aAttrRow);
						createChild("T1RXXXXG5", tforg('CODNDS',forg), aAttrRow);

						progress.worked(1);
						oDoc.clear();
					}
				}
			}
	
			var xmlName = getPar("EXPDIR");
			xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
			if(getPar("MEDOC_DIR_NAKL"))//если указана конкретная директория для экспорта накладных, то используем ее
			{
				xmlName = getPar("MEDOC_DIR_NAKL");
				xmlName += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
			}
			xmlName += "zapit_do_reesrta.xml";
			xml.save(xmlName, "windows-1251");
			progress.done();
			alert("Выгрузка окончена - " + xmlName);
		}
	}
}

//перенес функцию в модульный udfs.js для возможности обращения из других списков
//function ExportDocsToMedoc(oDoc, docLabel, nID)