include("avto:AVTO_const.js");

function clAfterLoad()
{
	this.addTies = clAddTies;
}

function clAddTies()
{	
	var tmpZakrepl = getTmpTableName("", true);
	strSQL = " SELECT FWID_CL, MAX(FDRIVER) AS FDRIVER, MAX(FDATE) AS FDATE "
			+" INTO "+tmpZakrepl
			+" FROM ^CL_AVTO_ZAKREPL "
			+" WHERE FDATE <= "+sqlTo(new Date())
			+" GROUP BY FWID_CL "
	ExecuteSQL(strSQL);

	createIndex(tmpZakrepl, "IX_"+tmpZakrepl+"_FWID_CL", "FWID_CL");

	this.extTie("CL",Fcl);
	this.extTieEx("ext0","fwid","CL","0");

	this.subTie("CL_AVTO", "avto", "FWID_CL", "Fwid");

	this.subTie("OS1", "OS1", "INV_NUM", "avto.Finv_num");
	this.subTie("OSNAZV", "OSNAZV", "OSNAZV", "avto.Finv_num");
	this.subTie("CL_AVTO2FUEL_RATE", "CL_AVTO2FUEL_RATE", "COD", "avto.Fmodel");
	
	//модель
	this.subTie("CLRELCLCL", "CLRELMODEL", "CLCOD", "="+sqlTo(getPar(const_GETPAR_MODEL))+",AVTO.FMODEL");
	this.subTie("CL", "MODEL", "FWID", "CLRELMODEL.FWID_CL");
	
	//группа
	this.subTie("CLRELCLCL", "CLRELGROUP", "CLCOD", "="+sqlTo(getPar(const_GETPAR_GROUPTS))+",AVTO.FGROUP");
	this.subTie("CL", "GROUP", "FWID", "CLRELGROUP.FWID_CL");

	//водитель
	this.subTie(tmpZakrepl, "ZAKREPL", "FWID_CL", "FWID_CL");
	this.subTie("CLRELCLCL", "CLRELDRIVER", "CLCOD", "="+sqlTo(getPar("CODPERS"))+",ZAKREPL.FDRIVER");
	this.subTie("CL", "DRIVER", "FWID", "CLRELDRIVER.FWID_CL");
}

function clMenuHandler(sID)
{
	switch (sID)
	{
		case "DEL":
			del_(grid.getTable().getRowID());
			break;
		
		case "__XDEL":
			var selIds = grid.getSelectedIDs();
			for (var nRow = 0; nRow < selIds.length; nRow++)
			{
				del_(selIds[nRow]);
			}
			break;
		default:
	}
}

function del_(id)
{
	id = Number(id);
	//удаляем все строки по пробегах шин
	strSQL = "SELECT DISTINCT T.FWID" 
				+" FROM ^CL_AVTO_TIRES T LEFT JOIN ^CL_AVTO_TIRES_RUNS R ON T.FWID = R.FWID_CL"
				+" WHERE 1=1"
					+" AND T.FWID_CL = "+sqlTo(id)
	ExecuteSQL("DELETE FROM ^CL_AVTO_TIRES_RUNS WHERE FWID_CL IN ("+strSQL+")");
	
	//удаляем строку тр. средства
	ExecuteSQL("DELETE FROM ^CL_AVTO WHERE FWID_CL = "+sqlTo(id));
	
	//удаляем строки с шинами 
	ExecuteSQL("DELETE FROM ^CL_AVTO_TIRES WHERE FWID_CL = "+sqlTo(id));
	
	//удаляем строки с закреплением авто за видителем и автопарком
	ExecuteSQL("DELETE FROM ^CL_AVTO_ZAKREPL WHERE FWID_CL = "+sqlTo(id));
	
	//удаляем строки с аккумуляторами
	ExecuteSQL("DELETE FROM ^CL_AVTO_ACCUM WHERE FWID_CL = "+sqlTo(id));
	
	//удаляем строки с видами работ 
	ExecuteSQL("DELETE FROM ^CL_AVTO_WORK WHERE FWID_CL = "+sqlTo(id));

	return true;
}