include("objects/DpCl.js");
include("avto:AVTO_const.js");
include("servis/date.js");

var obj = extPar.dpObj;
var mode = extPar.mode;

function onLoad()
{
	Caption(ru("Пробег за месяц", "Пробіг за місяць")	+": "+ modeName(mode));
	FMILEAGE.setMask("##########.###");
	FMOTOCH.setMask("##########.###");
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RDAT", FDAT);
	ctrlLinker.addLink("RMILEAGE", FMILEAGE);
	ctrlLinker.addLink("RMOTOCH", FMOTOCH);

	ctrlLinker.toControls();
	setValid(FDAT, FDAT_Valid);
	FDAT_Valid();
}

function FDAT_Valid()
{
	FDAT.value = firstDay(FDAT.value);

	var retVal = true;
	if (extPar.mode != "EDIT")
	{
		srtSQL = "SELECT FDAT"
				+" FROM "+extPar.tblName
				+" WHERE 1=1"
					+" AND FWID_CL="+sqlTo(obj.getVar("HID"))
					+" AND FDAT="+sqlTo(FDAT.value)
		sn = getSnap(srtSQL);
		if (sn != null)
		{
			if (differ(new Date(sn[0]),new Date(FDAT.value))==0)
			{
				WAIT(ru("На введенную дату уже существует запись.","На вказану дату вже існує запис."));
				retVal = softInvalid;
			}
		}
		sn = null;
	}
	return retVal;
}

function onSave()
{
	ctrlLinker.toVars();
}

include("sys/DpBaseDlg.js");