var objCl = extPar.dpObj;
var ctrlLinker;

include("sys/mask.js");
include("Objects/DpCl.js");
include("Objects/DpClCl.js");
include("Objects/DpNmkl.js");
//include("avto:servis/avto_tools.js");

var Validation = true;
var strFwid;
var strMode;
var bReady=false;
var oNmklFuel;
var oNmklMotor_oil;
var oNmklTransmission_oil;
var oNmklSpecial_oil;
var oNmklPlastic_lubrication;
var oType;

function Load()
{
	Caption(ru("Справочник аналитики", "Довідник аналітики")
			+ ": " + modeName(this.sMode));
			
	var tbl = extPar.m_pTable;
	FCOD.mask="###############";
	FCOD.setFocus();

	// топливо
	oNmklFuel = new DpNmkl();
	//oNmklFuel.linkCtrl(Ffuel, Ffuel_txt);
	oNmklFuel.linkSmartCtrl(Ffuel_txt);
	oNmklFuel.CanEmpty = true;

	/// масло моторное
	oNmklMotor_oil = new DpNmkl();
	//oNmklMotor_oil.linkCtrl(Fmotor_oil, Fmotor_oil_txt);
	oNmklMotor_oil.linkSmartCtrl(Fmotor_oil_txt);
	oNmklMotor_oil.CanEmpty = true;

	// масло трансмиссионное
	oNmklTransmission_oil = new DpNmkl();
	//oNmklTransmission_oil.linkCtrl(Ftransmission_oil, Ftransmission_oil_txt);
	oNmklTransmission_oil.linkSmartCtrl(Ftransmission_oil_txt);
	oNmklTransmission_oil.CanEmpty = true;

	// масло специализированное
	oNmklSpecial_oil = new DpNmkl();
	//oNmklSpecial_oil.linkCtrl(Fspecial_oil, Fspecial_oil_txt);
	oNmklSpecial_oil.linkSmartCtrl(Fspecial_oil_txt);
	oNmklSpecial_oil.CanEmpty = true;

	// смазка пластичная
	oNmklPlastic_lubrication = new DpNmkl();
	//oNmklPlastic_lubrication.linkCtrl(Fplastic_lubrication, Fplastic_lubrication_txt);
	oNmklPlastic_lubrication.linkSmartCtrl(Fplastic_lubrication_txt);
	oNmklPlastic_lubrication.CanEmpty = true;;

	ctrlLinker = new DpCtrlLinker(objCl);
	ctrlLinker.addLink("HCOD",  FCOD);
	ctrlLinker.addLink("HTXT",  FTXT);
	
	oType = new DpCl("",getPar("AVTO_GSMTYPE"),0);
	oType.linkSmartCtrl(FTYPE);
	ctrlLinker.addClLink("HTYPE",oType);
	
	ctrlLinker.addClLink("HFUEL", oNmklFuel);
	ctrlLinker.addClLink("HMOTOR_OIL", oNmklMotor_oil);
	ctrlLinker.addClLink("HTRANSMISSION_OIL", oNmklTransmission_oil);
	ctrlLinker.addClLink("HSPECIAL_OIL", oNmklSpecial_oil);
	ctrlLinker.addClLink("HPLASTIC_LUBRICATION", oNmklPlastic_lubrication);

	ctrlLinker.toControls();
	
	if (extPar.mode == "EDIT")
		setFocus(FTXT);
	else
		setFocus(FCOD);

	setValid(FCOD, FCOD_Valid);

}

function onSave()
{
	if("EDIT"!=extPar.mode)
	{
		var oSnap = getSnap("SELECT b.* FROM ^clrelclcl b"
							+ " WHERE b.Fcod=" + FCOD.getValue()
							+ " AND b.Fcl=" + objCl.getVar("HCL"));
		if(null!= oSnap)
		{			
			setFocus(FCOD);
			WAIT(ru("Запись с таким кодом уже существует.", "Запис з таким кодом вже існує."));
			return false;
		}
	}	
	ctrlLinker.toVars();
}

function FCOD_Valid()
{
	var strSQL = " SELECT B.*"
				+" FROM ^CLRELCLCL B"
				+" WHERE 1=1"
					+" AND B.FCOD=" + FCOD.getValue()
					+" AND B.FCL=" + objCl.getVar("HCL")
					+" AND B.FWID_CL<>" + objCl.getVar("HID")
	var oSnap = getSnap(strSQL);
	if(null != oSnap)
	{
		setFocus(FCOD);
		WAIT(ru("Запись с таким кодом уже существует.", "Запис з таким кодом вже існує."));
		return false;
	}

	return true;
}

include("sys\\DpBaseDlg.js");