include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("avto:AVTO_const.js");	// Константы справочников
include("getParam.js");
include("objects\\DpEdi.js");

var ctrlLinker;
var sprWorkType, sprMod, sprZatr, sprMarsh;
var oWorkType, oMod;
var noCalcKl;
var oldValofKl;
var oAvto = extPar.oAvto;
var oFrom, oTo;

function Load()
{
	Caption(ru("Строки путевого листа","Рядки шляхового листа"),extPar.mode);
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprMod = getPar(const_GETPAR_MODEL);
	sprZatr = getPar(const_GETPAR_ZATR);
	sprMarsh = getPar(const_GETPAR_PUNKT);
	sprUser = (extPar.mode=="ADD" ? extPar.obj.parent.getPar("_codconsumer") : extPar.obj.getVar("RUSER_CL"));
	oWorkType = new DpCl("", sprWorkType, 0);
	oWorkType.linkSmartCtrl(FWORKTYPE);
	//oWorkType.listCond = listCondWorkType;
	oUser = new DpCl("", sprUser, 0);
	if (sprUser == 0)
	{
		oUser.setMode("0");
	}
	oUser.linkSmartCtrl(FUSER);
	
	oMod = new DpCl("", sprMod, 0);

	oEdi = new DpEdi();

	Enable(FPROB, false);
	Enable(FEDOBL, false);
	Enable(FNOBL, false);
	Enable(FKOLF, false);
	Enable(FCTOT, false);
	Enable(FMTOT, false);
	Enable(FDTOT, false);
	Enable(FKOLVYD, false);

	ctrlLinker = new DpCtrlLinker(extPar.obj);
	if (extPar.obj.parent.getPar("_beg_tour")==1)
	{
		oFrom = new DpCl("", sprMarsh, 0);
		oFrom.linkSmartCtrl(FFROM);		
		ctrlLinker.addClLink("RFROMCOD", oFrom);
	}
	else
	{
		ctrlLinker.addLink("RFROM", FFROM);
	}
	if (extPar.obj.parent.getPar("_end_tour")==1)
	{
		oTo = new DpCl("", sprMarsh, 0);
		oTo.linkSmartCtrl(FTO);		
		ctrlLinker.addClLink("RTOCOD", oTo);
	}
	else
	{
		ctrlLinker.addLink("RTO", FTO);
	}
	
	if (extPar.mode == "ADD")
	{
		extPar.obj.setVar("RBDATE", new Date());
		extPar.obj.setVar("REDATE", new Date());
		FBDATE.value = new Date();
		FEDATE.value = new Date();
	}
	ctrlLinker.addClLink("RUSER", oUser);
	ctrlLinker.addLink("RNOM",FNOM_STR);
	ctrlLinker.addLink("RGRDOR", FGRDOR);
	ctrlLinker.addLink("RHOD", FHOD);
	ctrlLinker.addLink("RGRUZ", FGRUZ);
	ctrlLinker.addLink("RGRKL", FGRKL);
	ctrlLinker.addLink("RPROBG", FPROBG);
	ctrlLinker.addLink("RPROB0", FPROB0);
	ctrlLinker.addLink("RPROB", FPROB);
	ctrlLinker.addLink("RDDV", FDDV);
	ctrlLinker.addLink("RMDV", FMDV);
	ctrlLinker.addLink("RCDV", FCDV);
	ctrlLinker.addLink("RDTOT", FDTOT);
	ctrlLinker.addLink("RMTOT", FMTOT);
	ctrlLinker.addLink("RCTOT", FCTOT);
	ctrlLinker.addLink("RDREM", FDREM);
	ctrlLinker.addLink("RMREM", FMREM);
	ctrlLinker.addLink("RCREM", FCREM);
	ctrlLinker.addLink("RDBOPL", FDBOPL);
	ctrlLinker.addLink("RMBOPL", FMBOPL);
	ctrlLinker.addLink("RCBOPL", FCBOPL);
	ctrlLinker.addLink("RDLIN", FDLIN);
	ctrlLinker.addLink("RMLIN", FMLIN);
	ctrlLinker.addLink("RCLIN", FCLIN);
	ctrlLinker.addLink("RKOLF", FKOLF);
	ctrlLinker.addLink("RKOLVYD", FKOLVYD);
	ctrlLinker.addLink("RPROCDOP", FPROCDOP);
	ctrlLinker.addLink("RKOLVYDDOP", FKOLVYDDOP);
	ctrlLinker.addLink("RPROCTIMELIN", FPROCTIMELIN);
	ctrlLinker.addLink("RPROCTIMEREM", FPROCTIMEREM);
	ctrlLinker.addClLink("RWORKTYPE", oWorkType);
	ctrlLinker.addDateTimeLink("RBDATE",FBDATE,FBTIME);
	ctrlLinker.addDateTimeLink("REDATE",FEDATE,FETIME);
	ctrlLinker.updateData(false);
	setMasks();
	
	if(extPar.mode == "ADD")
	{
		FBDATE.setValue(new Date().getVarDate())
		FEDATE.setValue(new Date().getVarDate())
		FBTIME.setTime(8.00);
		FETIME.setTime(17.00);
	}
	
	//если подняли на редактирование то клас груза не пересчитываем
	noCalcKl = extPar.mode == "EDIT" ? true : false;
	FWORKTYPE_Valid();
	Fwork_Valid();
	//проконтролируем введение класса груза руками
	setValid(FGRKL		, FGRKL_Valid);
	setValid(FWORKTYPE	, FWORKTYPE_Valid);
	setValid(FGRDOR	, FGRDOR_Valid);
	setValid(FHOD		, FHOD_Valid);
	setValid(FGRUZ		, calcAll);
	setValid(FPROBG	, calcAll);
	setValid(FPROB0		, calcAll);
	setValid(FKOLOBL	, calcAll);
	setValid(FDDV		, calcAll);
	setValid(FCDV		, calcAll);
	setValid(FMDV		, calcAll);
	setValid(FDLIN		, calcAll);
	setValid(FCLIN		, calcAll);
	setValid(FMLIN		, calcAll);
	setValid(FDBOPL		, calcAll);
	setValid(FCBOPL		, calcAll);
	setValid(FMBOPL		, calcAll);
	setValid(FDREM		, calcAll);
	setValid(FCREM		, calcAll);
	setValid(FMREM		, calcAll);
	
	setValid(FPROCTIMELIN	, calcAll);
	setValid(FPROCTIMEREM	, calcAll);
	
	setValid(FPROCDOP		, FPROCDOP_Valid);
	setValid(FKOLVYDDOP	, FKOLVYDDOP_Valid);

	setValid(FEDATE, Fwork_Valid);
	setValid(FETIME, Fwork_Valid);	
}

function listCondWorkType()
{
	var strSQL = "FCOD IN("
								+"SELECT W.FCOD"
									+" FROM (^CL_AVTO_WORK W LEFT JOIN ^CL_AVTO A ON W.FWID_CL = A.FWID_CL)"
												+" LEFT JOIN ^CLRELCLCL REL ON A.FWID_CL = REL.FWID_CL"
									+" WHERE 1=1"
										+" AND REL.FCL = "+sqlTo(getPar("AVTOTRANSPORT"))
										+" AND REL.FCOD = "+sqlTo(oAvto.getVar("FAVTO"))
									+")";
	return strSQL;
}

function FGRDOR_Valid()
{
	var retval = true;

	if ((Number(FGRDOR.value) < 1 || Number(FGRDOR.value) > 3) && Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_RUN )
	{
		WAIT(ru("Введите значение от 1 до 3", "Введiть значення вiд 1 до 3"));
		retval = false;
	}
	else
	{
		//FGRDOR1.value = FGRDOR.value;
		calcAll();
	}

	return retval;
}

function FHOD_Valid()
{
	var retval = true;

	if (Number(FHOD.value) < 1 && Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_RUN)
	{
		WAIT(ru("Введите значение > 0", "Введiть значення > 0"));
		retval = false;
	}
	else
	{
		calcAll();
	}

	return retval;
}

function Fwork_Valid()
{
	var date = new Date();
	date.setDate(toScriptDate(FBDATE.value).getDate());
	date.setMonth(toScriptDate(FBDATE.value).getMonth());
	date.setFullYear(toScriptDate(FBDATE.value).getFullYear());
	date.setHours(FBTIME.getHours());
	date.setMinutes(FBTIME.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(FEDATE.value).getDate());
	date2.setMonth(toScriptDate(FEDATE.value).getMonth());
	date2.setFullYear(toScriptDate(FEDATE.value).getFullYear());
	date2.setHours(FETIME.getHours());
	date2.setMinutes(FETIME.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	FDATDIFF.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";

	return true;
}

function FPROCDOP_Valid()
{	
	var proc = Number(FPROCDOP.getValue());
	if(!isEmpty(proc))
	{
		kolDop = Number(FKOLF.getValue())*proc/100;
		FKOLVYDDOP.setValue(kolDop);
		Disable(FKOLVYDDOP);
	}
	else
	{
		kolDop = 0;
		FKOLVYDDOP.setValue(kolDop);
		Enable(FKOLVYDDOP)
	}
	FKOLVYD.setValue(kolDop+Number(FKOLF.getValue()));
	return true;
}

function FKOLVYDDOP_Valid()
{
	FKOLVYD.setValue(Number(FKOLF.getValue()) + Number(FKOLVYDDOP.getValue()));
	return true;
}

function FWORKTYPE_Valid()
{
	if (Number(oWorkType.get("FWORK")) == AVTO_WORKTYPE_TRACTOR)
	{
		FWORKTYPE.showErr(ru("Укажите вид работы для пробега или спецоборудования", "Вкажіть вид роботи для пробігу чи спецобладнання"));
		return false;
	}
	switch(Number(oWorkType.get("FWORK")))
	{
		case AVTO_WORKTYPE_RUN:
			SPEC.setVisible(false);
			PROB.setVisible(true);
			break;
		case AVTO_WORKTYPE_SPEC:
			SPEC.setVisible(true);
			PROB.setVisible(false);
			break;
	}
	var shell = FORM.ctrlComp.getShell();
	shell.pack();
	//Перерисуем окно
	var pnt = WT;
	pnt.redraw();
	pnt.layout(true);
	calcAll();
	
	return true;
}

function FGRKL_Valid()
{
	//если изменили значение руками - дальше это поле не меняем
	if (FGRKL.value != oldValofKl)
	{
		noCalcKl = true;
	}
	return true;
}

function setMasks()
{
	FNOM_STR.mask = "#####";
	FGRDOR.mask = "######";
	FHOD.mask = MASK_KOL;
	FGRUZ.mask = MASK_KOL;
	FGRKL.mask = "######";
	FPROBG.mask = MASK_KOL;
	FPROB0.mask = MASK_KOL;
	FPROB.mask = MASK_KOL;
	FDDV.mask = "#####";
	FMDV.mask = "#####";
	FCDV.mask = "#####";
	FDLIN.mask = "#####";
	FMLIN.mask = "#####";
	FCLIN.mask = "#####";
	FDBOPL.mask = "#####";
	FMBOPL.mask = "#####";
	FCBOPL.mask = "#####";
	FDREM.mask = "#####";
	FMREM.mask = "#####";
	FCREM.mask = "#####";
	FDTOT.mask = "#####";
	FMTOT.mask = "#####";
	FCTOT.mask = "#####";
	FKOLF.mask = MASK_KOL;
	FNOBL.mask = MASK_KOL;
	FKOLOBL.mask = MASK_KOL;
	FPROCDOP.mask = "#####.##";
	FPROCTIMELIN.mask = "#####.##";
	FPROCTIMEREM.mask = "#####.##";
	FKOLVYDDOP.mask = MASK_KOL;
	FKOLVYD.mask = MASK_KOL;
}

function calcAll()
{
	switch (oWorkType.get("FWORK"))
	{
		case AVTO_WORKTYPE_RUN:
			oMod.setCod(oWorkType.get("FMODEL"));
			// кол-во ходок
			var mFhod		= FHOD.value;
			var mFgrdor	= FGRDOR.value;
			var mFcargo	= oMod.get("FGRUZPOD");
			//var mFsppogr	= oAvto.getSposobPogr();
			//var mFrab		= oAvto.getDopRab();
			var mFgruz		= FGRUZ.value;

			//1) Класс груза
			//если ввели значение вручную то не пересчитываем
			if (!noCalcKl)
			{
				var mFgrkl		= 0;
				if (mFgruz != 0)
				{
					// Грузоподъемность
					if (mFcargo != 0)
					{
						var koef = mFcargo / (mFgruz / mFhod);
						if (koef < AVTO_KLASKOEF_GRUZ2)
						{
							mFgrkl = 1;
						}
						else
						{
							if (koef < AVTO_KLASKOEF_GRUZ3)
							{
								mFgrkl = 2;
							}
							else
							{
								if (koef < AVTO_KLASKOEF_GRUZ4)
								{
									mFgrkl = 3;
								}
								else
								{
									mFgrkl = 4;
								}
							}
						}
					}
				} //if(mFgruz!=0)
				FGRKL.value		= mFgrkl;

				//запомним последнее расчитаное значение
				oldValofKl = FGRKL.value;
			}
			else
			{
				mFgrkl = FGRKL.value;
			}

			//2) Пробег всего
			mFprobg	= Number(FPROBG.value);
			mFprob0	= Number(FPROB0.value);
			mFprob		= mFprobg + mFprob0;
			FPROB.value	= mFprob;
			// Перевезено тонно-километров
			tkm	= mFprobg / mFhod * mFgruz;
			npr	= oWorkType.get("FNORM_100KM");	//Норма на 100 км пробiгу, л
			ntkm	= oWorkType.get("FNORM_100TKM");	//Норма на 100 т/км, л
			//3) Топливо по норме
			//3.1) на линейные нормы
			mFkolf_km		= mFprob / 100 * npr;
			//3.2) на тонно-километры
			mFkolf_tkm		= tkm / 100 * ntkm;
			mFkolf			= mFkolf_km + mFkolf_tkm;
			FKOLF.value		= mFkolf;
			break;
		case AVTO_WORKTYPE_SPEC:
			//3) Спецоборуд
			oEdi.setCod(oWorkType.get("FEDI"));
			oEdi.assocDpText(FEDOBL);
			mFkolobl	= FKOLOBL.value;
			// Нормы
			mFnobl	= oWorkType.get("FNORM_FUEL");	//Норма на роботу спецобл., л
			FNOBL.value	= mFnobl;
			//3) Топливо по норме
			//3.1) на работу спецоборудования
			mFkolf_ob		= mFnobl * mFkolobl;
			mFkolf			= mFkolf_ob;
			FKOLF.value		= mFkolf;
			break;
	}

	//4) Время
	//4.1) в движении
	mTdv				= Number(FCDV.value) * 60 + Number(FMDV.value);
	//4.2) простой на линии
	mTlin				= Number(FCLIN.value) * 60 + Number(FMLIN.value);
	mTlinWithProc		= mTlin*Number(FPROCTIMELIN.value)/100;
	//4.3) простой без оплаты
	mTbopl			= Number(FCBOPL.value) * 60 + Number(FMBOPL.value);
	//4.4) простой на ремонте
	mTrem				= Number(FCREM.value) * 60 + Number(FMREM.value);
	mTremWithProc		= mTrem*Number(FPROCTIMEREM.value)/100;
	//4.5) Время всего
	mTtot				= mTdv + mTlin + mTbopl + mTrem;
	mFctot			= Math.floor(mTtot / 60);
	mFmtot			= mTtot - mFctot * 60;

	FDTOT.value		= Number(FDDV.value) + Number(FDLIN.value) + Number(FDBOPL.value) + Number(FDREM.value);
	FCTOT.value		= mFctot;
	FMTOT.value		= mFmtot;
	return true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	extPar.obj.setVar("RTYPE", AVTO_WAYBILL_TYPE_TASK);
	extPar.obj.setVar("RUSER_CL", sprUser);
	if(oFrom)
		extPar.obj.setVar("RFROM", oFrom.getTxt());
	if(oTo)
		extPar.obj.setVar("RTO", oTo.getTxt());
}
include("sys\\DpBaseDlg.js");