include("doc/DpDoc.js");
include("Objects/DpCl.js");		// для таб.номера
include("sys/mask.js");
include("sys/udfs.js");
include("Objects/DpClcl.js");
include("Objects/DpShtat.js");
include("avto:servis/avto_tools.js");
include("avto:AVTO_const.js");
include("avto:Objects/DpAvto.js");
include("gridedit.js");

var strFwid;
var strMode;
var Hs;
var Hob;

//var bDist = 0;
var gsm_tbl_name; // имя для временной таблицы для грида с израсходованными ГСМ

var bOneFuelType = true;
var bCreateGrid = true;

var oSc;
var objPodr;
var objMol;

var oPers;		//объект - справочник персонала
var objAvto;
var objTrailer1;
var objTrailer2;
var objDoc;

var tblRow = "RWAYBILL";
var sTmpTbl = getTmpTableName();
var clasRow = "ROW";

var sTmpTblTask = getTmpTableName();
var clasTask = "ROWTASK";

var sTmpTblFuel = "TMP_RFUEL";
var sprAvto, sprWorkType, sprFuelType, sprAvtopark, sprPers;
var oAvto;
var oldAvtoCod;

//таблицы доплат 
var tmpTblDopl = getTmpTableName();
var tblDopl = "ROWS_DOPL";

//таблицы помощников 
var tmpTblHelp = getTmpTableName();
var tblHelp = "ROWS_HELP";
var clasHelp = "HELP";

//параметры папки
var _pers_zaval = extPar.doc.getPar("_pers_zaval");
var sprPers = extPar.doc.getPar("_codpers");
var sprUser = extPar.doc.getPar("_codconsumer");
var useTask = extPar.doc.getPar("_use_task");

var bReady = false;
var Validation = true;

function Load()
{
	CreateTable(sTmpTblFuel,"RFUEL","FWID");

	Caption(ru("Путевой лист", "Шляховий лист") + ": " + modeName(extPar.mode));
	strFwid = extPar.fwid;
	strMode = extPar.mode;
	strMode.toUpperCase();

	oAvto = new DpAvto("");

	sprAvtopark = Number(getPar(const_GETPAR_KOLON));
	sprAvto = getPar("AVTOTRANSPORT");
	sprWorkType = getPar(const_GETPAR_WORKTYPE);
	sprFuelType = getPar(const_GETPAR_FUELTYPE);
	
	bReady=true;
	ctrlLinker = new DpCtrlLinker(extPar.doc);

	// водитель (какой объект смотрим в настр. папки)
	switch (_pers_zaval)
	{	
		case 0:
			oPers = new DpShtat("");
			if(inList(strMode, "COPY", "EDIT"))
			{
				oPers.setPeriod(extPar.doc.getVar("HDAT"), extPar.doc.getVar("HDAT"));
			}
			else
			{
				oPers.setPeriod(new Date(), new Date());
			}
			oPers.zavalInAllShtat = true;
			oPers.linkCtrl("fcod", Fshtat);
			PERS.setVisible(false);
		break;
		case 1:
			oPers = new DpCl("", sprPers, 0);
			oPers.linkSmartCtrl(Fdriver);
			oPers.setContAssist();
			SHTAT.setVisible(false);
		break;
		default: 
			alert(ru("Этот режим справочника персонала не предусмотрен!"
					, "Цей режим довідника персоналу не передбачено!"));
	}	
	ctrlLinker.addClLink("HDRIVER", oPers);
	
	//Колона (подр.)
	oAvtopark = new DpCl("", sprAvtopark, 0);
	oAvtopark.linkSmartCtrl(Favtopark);
	ctrlLinker.addClLink("HPODR",oAvtopark);

	oSc = new DpSc();	
	oSc.setMode("c0utxyz");	//c0utxyz456
	oSc.linkCtrl(FSC, FSU, FST, CL1, CL2, CL3);	
	ctrlLinker.addScLink("HPZ_SC","HPZ_SU","HPZ_ST","HPZ_CL1","HPZ_CL2","HPZ_CL3",oSc);
		
	objPodr = new DpCl();
   	objPodr.linkCtrl(FPODR,FPODR_TXT);
	objPodr.setClcl(sprPodr);
	ctrlLinker.addClLink("HPZ_PODR",objPodr);
	
	objMol = new DpCl();
   	objMol.linkCtrl(FMOL,FMOL_TXT);
	//fruckt
	//если мы находимся не в подсистеме MTR - этот параметр определяется неправильно
	//objMol.setClcl(sprMol);
	objMol.setClcl(getPar("CODMOL", "MTR"));
	ctrlLinker.addClLink("HPZ_MOL",objMol);

	objAvto = new DpCl();
   	objAvto.linkSmartCtrl(Favto);
	objAvto.setClcl(sprAvto);
	ctrlLinker.addClLink("HAVTO",objAvto);

	objTrailer1 = new DpCl("0");
   	objTrailer1.linkSmartCtrl(Ftrailer1);
	objTrailer1.setClcl(getPar(const_GETPAR_TRAILER));
	ctrlLinker.addClLink("HTRAILER1",objTrailer1);

	objTrailer2 = new DpCl("0");
   	objTrailer2.linkSmartCtrl(Ftrailer2);
	objTrailer2.setClcl(getPar(const_GETPAR_TRAILER));
	ctrlLinker.addClLink("HTRAILER2",objTrailer2);

	ctrlLinker.addLink("HNOM",HNOM);
	ctrlLinker.addLink("HDAT",Fdoc_dat);
	ctrlLinker.addLink("HDOC_SER",FDOC_SER);
	ctrlLinker.addLink("HSMENA",FSMENA);
	ctrlLinker.addDateTimeLink("HBDATE",FBDATE,FBTIME);
	ctrlLinker.addDateTimeLink("HEDATE",FEDATE,FETIME);
	ctrlLinker.addLink("HBDISTANCE",FBDISTANCE);
	ctrlLinker.addLink("HEDISTANCE",FEDISTANCE);
	ctrlLinker.addLink("HCALC_KSUM",ksum);
	ctrlLinker.addLink("HCALC_KOB",kob);
	ctrlLinker.addLink("HCALC_KOIL",koil);
	ctrlLinker.addLink("HPZ_NUM",PZ_NUM);
	
   	ctrlLinker.updateData(false);
	
	//если используем штатное то сами устанавливаем текстовку и дизейблим поле 
	if(oPers instanceof DpShtat == true)
	{
		//fruckt
		Disable(Fshtat_txt);
		Fshtat_txt.setValue(oPers.getEmployeSurname());
	}
	
	oldAvtoCod = objAvto.getCod();
	tbl_name = getTmpTableName();

	PZ_NUM.mask = MASK_DOCNUM;
	HNOM.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
	FEDISTANCE.mask = "##########.##";
	FBDISTANCE.mask = "##########.##";
	ksum.setMask("-#####.#####");
	koil.setMask("-#####.#####");
	kob.setMask("-#####.#####");
	FSMENA.setMask("###");

	//----загрузка значений
	Disable(calc_value);
	Disable(PZ_DATE);
	if (strMode == "ADD")
	{
		koil.value = 100;
	}

	if (strMode=="EDIT" || strMode=="COPY")
	{
		oPers.setCod(extPar.doc.getVar("HDRIVER"));
  		objPodr.setCod(extPar.doc.getVar("HPZ_PODR"));  
		objMol.setCod(extPar.doc.getVar("HPZ_MOL"));
		oSc.set(extPar.doc.getVar("HPZ_SC"),
		extPar.doc.getVar("HPZ_SU"),
		extPar.doc.getVar("HPZ_ST"),
		extPar.doc.getVar("HPZ_CL1"),
		extPar.doc.getVar("HPZ_CL2"),
		extPar.doc.getVar("HPZ_CL3"));

   		objAvto.setCod(extPar.doc.getVar("HAVTO"));
   		objTrailer1.setCod(extPar.doc.getVar("HTRAILER1"));
   		objTrailer2.setCod(extPar.doc.getVar("Htrailer2"));
			
		if(searchPZ())
		{
			var sTxt = create_doc.getText() +" (УЖЕ СОЗДАН)";
			create_doc.setText(sTxt);
		}
	}
	else
	{
		// при добавлении параметры накладной берем с значений по умолчанию в папке документов 
		if (getPar("AVTO_PZ_NOP","AVTO") != 0)
		{
			objDoc = new DpDoc("PZ", getPar("AVTO_PZ_NOP","AVTO"));
  			objPodr.setCod(objDoc.getVar("HPODR"));   		
   			objMol.setCod(objDoc.getVar("HMOL"));	
			oSc.set(objDoc.getVar("HSC"),
   					objDoc.getVar("HSU"),
   					objDoc.getVar("HST"),
					objDoc.getVar("HA1"),
   					objDoc.getVar("HA2"),
   					objDoc.getVar("HA3"));
		}
	}
	Fdoc_dat_Valid();		
	
	setValid(Favto, Favto_Valid);
	setValid(FBDATE, Fwork_Valid);
	setValid(FEDATE, Fwork_Valid);
	setValid(FBTIME, Fwork_Valid);
	setValid(FETIME, Fwork_Valid);
	setValid(koil, updNorm);
	setValid(Fdoc_dat, Fdoc_dat_Valid);
	
	switch (_pers_zaval)
	{	
		case 0:
			setValid(Fshtat, Fdriver_Valid);
		break;
		default:
			setValid(Fdriver, Fdriver_Valid);
		break;
	}
	setValid(Favtopark, Favtopark_Valid);
	setValid(HNOM, HNOM_Valid);
		
	// calc
	setButton(calc, OnCalculate);
	setButton(refresh_grid, updNorm);
	setButton(create_doc, OnCreateDoc);

	CreateTable(tmpTblDopl, tblDopl,"*");
	
	//loadGridSM(false);
	loadGrid(clasTask);
	loadGrid(clasRow);
	loadGrid(clasHelp);

	dpGridEdit = new DpGridEdit(gridFuel);
	loadGridFuel();
	dpGridEdit.init = addRecord;
	dpGridEdit.canEdit = canEditRecord;

	this.listMenuInitFuel = listMenuInitFuel;
	this.onSelectRowMenuFuel = onSelectRowMenuFuel;
	gridFuel.loadMenuHandler(this,"listMenuInitFuel");
	gridFuel.selectMenuHandler(this,"onSelectRowMenuFuel");

	dpGridEdit.addValidField("FFUEL_DESK", startEdit_fefuel, endEdit_fefuel);

	if (strMode != "ADD")
		Favto_Valid();
	if (strMode=="COPY")
	{
		/*
		var mFid = extPar.doc.getID();
		var mOldFid = extPar.doc.nOldID;
		var sFLD = GetPatternIntersection("RFUEL", "RFUEL");
		
		strSQL = "INSERT INTO "+sTmpTblFuel+"("+sFLD+")"
			+" SELECT "+sFLD+" FROM ^RFUEL WHERE FID_DOC = " + sqlTo(mOldFid)
		ExecuteSQL(strSQL);
		ExecuteSQL("UPDATE " + sTmpTblFuel+" SET FID_DOC = " + sqlTo(mFid))
		*/
		updNorm();
	}

	calcSalary();
	Favto_Valid();
	
	if (inList(strMode, "ADD", "COPY"))
	{
		getMaxSmena();
	}	
	
	//fruckt
	TASK.setVisible(useTask);
	
	setFocus(HNOM);

	return true
}

function getMaxSmena()
{
	strSQL = " SELECT MAX(FSMENA) "
			+" FROM ^WAYBILL "
			+" WHERE 1 = 1 "
				+" AND FDOC_DAT = "+sqlTo(Fdoc_dat.value)
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		FSMENA.value = sn[0]+1;
	}
	else
	{
		FSMENA.value = 1;
	}
	sn = null;
}

function UnLoad()
{
   if(!bReady)return;
}

function saveRows(clas)
{
	var ID = extPar.doc.getVar("ID");
	var sWhere = "";
	
	switch (clas)
	{
		case clasRow:
			workTbl  = tblRow;
			tmpTbl = sTmpTbl;
			sWhere = " AND FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT);
			break;
		case clasTask:
			workTbl  = tblRow;
			tmpTbl = sTmpTblTask;
			sWhere = " AND FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_TASK);
			break;
		case "FUEL":
			workTbl  = "RFUEL";
			tmpTbl = sTmpTblFuel;
			break;
		case clasHelp:
			workTbl  = tblHelp;
			tmpTbl = tmpTblHelp;
			break;
		default:
			alert("Ошибка при сохранени строк!")
			break;
	}
	
	ExecuteSQL("DELETE FROM ^"+workTbl+" WHERE FID_DOC = "+sqlTo(ID)+sWhere);
	var sFLD = GetPatternIntersection(workTbl, workTbl);
	ExecuteSQL("INSERT INTO ^"+workTbl+"(" + sFLD + ")"+" SELECT "+sFLD+" FROM " + tmpTbl);
}

function onSave()
{
	//Fdistance_Valid();
	ctrlLinker.updateData(true);

	//сохраним строки всех гридов
	saveRows(clasTask);
	saveRows(clasRow);
	saveRows("FUEL");
	saveRows(clasHelp);
	saveRowsActs("DOPL");

	// Обновим показание спидометра у машини
	saveDistance();
	saveFuel();
}

function saveFuel()
{
	var oSnap = getSnap("select sum(FBFUEL), sum(FEFUEL), sum(FFUEL_DESK), sum(FFUEL_NORM), sum(FFUEL_FACT)"
						+" from "+ sTmpTblFuel 
						+" where FTYPE="+ sqlTo(AVTO_NMK_FUEL)
						);
	if(!oSnap)
		return;
	var dec = getPar("DECIKOL");
	extPar.doc.setVar("HBFUEL", round(oSnap[0], dec));
	extPar.doc.setVar("HEFUEL", round(oSnap[1], dec));
	extPar.doc.setVar("HFUEL_DESK", round(oSnap[2], dec));
	extPar.doc.setVar("HFUEL_NORM", round(oSnap[3], dec));
	extPar.doc.setVar("HFUEL_FACT", round(oSnap[4], dec));
}

function saveRowsActs(clas)
{
	var workTbl	= "";
	var tmpTbl	= "";
	switch (clas)
	{
		case "DOPL":
			workTbl = tblDopl;
			tmpTbl = tmpTblDopl;
			break;
	}
	
	//выберем все FWID строк 
	var strSQL = "SELECT T.FWID" 
				+" FROM ^RWAYBILL T"
				+" WHERE 1=1"
					+" AND T.FID_DOC = "+sqlTo(extPar.doc.getID())

	//удалим из таблицы все строки по нашему наряду
	//а потом востановим с изменениями из темпа
	ExecuteSQL("DELETE FROM ^"+ workTbl +" WHERE FID_DOC IN ("+strSQL+")");
	ExecuteSQL("INSERT INTO ^"+ workTbl + " SELECT * FROM " + tmpTbl);
	return true;
}

function saveDistance()
{
	var edistance = Number(FEDISTANCE.getValue());
	if(strMode == "EDIT" && oAvto.getVar("FDISTANCE") >= edistance)
	{
		return;
	}
	
	//проверяем есть ли значение больше текущего
	var oSnap = getSnap("SELECT FEDISTANCE, FDOC_NUM, FDOC_DAT, FDOC, FNOP, FWID "
						+" FROM ^WAYBILL "
						+" WHERE FAVTO="+ objAvto.getCod()
						+" ORDER by FEDISTANCE DESC"
						);
	if(oSnap && Number(oSnap[0])>edistance)
	{
		var sMsg = UR("Знайдено шляховий лист з більшим показанням спідометра: "
						+"\n"+ oSnap[0]
						+"\n№ "+ oSnap[1] +" за "+ StrDat(oSnap[2], "DMY") 
						+"\nПерейти до знайденного листа? "
					+"|Найден путевой лист с бо'льшим показанием спидометра: "
						+"\n"+ oSnap[0]
						+"\n№ "+ oSnap[1] +" за "+ StrDat(oSnap[2], "DMY") 
						+"\nПерейти к найденному листу? "
					);
		if(confirm(sMsg))
		{
			include("doc/DpDocPtn.js");		
			FindDocument(oSnap[3], oSnap[4], oSnap[5]);
		}
		if(!confirm(UR("Зберегти поточне показання "+ edistance +"?|Сохранить текущее показание "+ edistance +"?")))
			return;
	}
	oSnap = null;
	
	ExecuteSQL("UPDATE ^CL_AVTO SET FDISTANCE = "+ edistance
			+ " WHERE FCOD = " + sqlTo(objAvto.getCod()));
}

function calcSalary()
{
	strSQL = "SELECT SUM(FSUM) FROM "+sTmpTbl
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		Fsalary_calc.text = sn[0]+" грн."
	}
	sn = null;
}

//функция сумирует пробег по строкам и устанавливает его на соответствующий контрол
//также устанавливает значения контрола показатели спидометри при приезде 
function calcRuns()
{
	var sumProb = 0;
	var edist = Number(FBDISTANCE.getValue());
	strSQL = "SELECT SUM(FPROB) FROM "+sTmpTbl
	
	var sn = getSnap(strSQL);
	if (sn != null && !isEmpty(sn[0]))
	{
		sumProb = sn[0];
		edist += sumProb;
	}
	
	FEDISTANCE.setValue(edist);
	FDISTANCE_CALC.text = sumProb+" км.";
	return true;
}

function Favto_Valid()
{
	var ret = false;
	oAvto.setVar("FAVTO", objAvto.getCod());
	
	if (!isEmpty(objAvto.getCod()))
	{
		AvtoFnum.text = oAvto.getVar("FNUM");
		AvtoFgarage_num.text = oAvto.getVar("FGARAGE_NUM");
		AvtoFlicense.text = oAvto.getVar("FLICENSE");
		AvtoFdistance.text = oAvto.getVar("FDISTANCE");
	
		refreshAvtoInfo();
		Fwork_Valid();
		
		if(inList(strMode, "ADD", "COPY"))
		{
			//установим показатели спидометра при отъезде
			FBDISTANCE.setValue(oAvto.getVar("FDISTANCE"));
		}
		calcRuns();
		
		if (objAvto.getCod() != oldAvtoCod)
		{
			ExecuteSQL("DELETE FROM " + sTmpTblFuel);
			makeFuelTbl();
			oldAvtoCod = objAvto.getCod();
		}
		ret = true;
	}
	return ret;
}

function ostUpdate()
{
	if (isEmpty(objMol.getCod()) || isEmpty(objPodr.getCod()))
	{
		return true;
	}
	
	oAvto.setVar("FPODR", objPodr.getCod());
	oAvto.setVar("FMOL", objMol.getCod());
	
	var tFuel = OpenTable("s",sTmpTblFuel);
	for(; !tFuel.IsEOF(); tFuel.MoveNext())
	{
		//Провери есть ли в справочнике такая номенклатура иначе потом завалится
		// при расчетет остатков
		tNmkl = OpenTable("SELECT * FROM ^CL_NMK WHERE FWID = " + toScrObj(tFuel.getValue("FFUEL")));
		if (tNmkl.IsEmpty())
		{
			tNmkl.Close();
			tNmkl = null;
			continue;
		}
		tNmkl.Close();
		tNmkl = null;			
		
		oAvto.setVar("FNMKL", toScrObj(tFuel.getValue("FFUEL")));

		var mFost = 0;
		var mFcena = 0;
		switch(extPar.doc.getPar("_ost_fuel"))
		{
			case 0://считать по учету ТМЦ
				var ret = oAvto.getFuelTMC("nmk");
				if (!isEmpty(ret))
				{
					mFost = ret.fost;
					mFcena = ret.fcena;
				}
			break;
			case 1://считать по путевым листам
				mFost = oAvto.getFuelWB("nmk");
			break;
			case 3://считать по путевым листам, а потом добавлять все, что было до нашей даты по учету ТМЦ
				oAvto.setVar("FSMENA", Number(FSMENA.value))
				oAvto.setVar("FID_DOC", extPar.doc.getID())
				if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
				{
					var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
					oAvto.setVar("FPODR", mFpodr);
				}
				if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
				{
					var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
					oAvto.setVar("FMOL", mFmol);
				}
				mFost = oAvto.getFuelWBTMC("nmk");
			break;
			case 2://не считать
			break;
		}
		switch(extPar.doc.getPar("_load_fuel"))
		{
			case 0://считать по учету ТМЦ
				oAvto.setVar("FSMENA", Number(FSMENA.value))
				oAvto.setVar("FID_DOC", extPar.doc.getID())
				if (!isEmpty(extPar.doc.getPar("_load_fuel_podrexpr")))
				{
					var mFpodr = eval(String(extPar.doc.getPar("_load_fuel_podrexpr")));
					oAvto.setVar("FPODR", mFpodr);
				}
				if (!isEmpty(extPar.doc.getPar("_load_fuel_molexpr")))
				{
					var mFmol = eval(String(extPar.doc.getPar("_load_fuel_molexpr")));
					oAvto.setVar("FMOL", mFmol);
				}
				var mFload = oAvto.getLoadFuelTMC("nmk");
				break;
			case 1://не считать
				var mFload = 0;
				break;
		}
		
		var m = new Object();
		m.FWID = GetUID();
		m.FBFUEL = mFost;
		m.FFUEL_DESK = mFload;
		m.FCENA = mFcena;
		
		updateTable(sTmpTblFuel, m, false, "FFUEL = " + toScrObj(tFuel.getValue("FFUEL"))
									+" AND FTYPE = " + sqlTo(tFuel.getValue("FTYPE")));
	}
	tFuel.Close();
	tFuel = null;
	
	if (gridFuel.getTable() != null)
	{
		gridFuel.getTable().requery();
		gridFuel.refresh();
	}
	
	return true;
}

function Fwork_Valid()
{
	var date = new Date();
	date.setDate(toScriptDate(FBDATE.value).getDate());
	date.setMonth(toScriptDate(FBDATE.value).getMonth());
	date.setFullYear(toScriptDate(FBDATE.value).getFullYear());
	date.setHours(FBTIME.getHours());
	date.setMinutes(FBTIME.getMinutes());
	var date2 = new Date();
	date2.setDate(toScriptDate(FEDATE.value).getDate());
	date2.setMonth(toScriptDate(FEDATE.value).getMonth());
	date2.setFullYear(toScriptDate(FEDATE.value).getFullYear());
	date2.setHours(FETIME.getHours());
	date2.setMinutes(FETIME.getMinutes());

	var diff = day_differencemin(date, date2);
	// shift 1 day
	var diff_min = diff % 60;
	var diff_hours = ((diff - diff_min) / 60) % 24;
	var diff_days = Math.round(diff / (60 * 24) - 0.5);
	
	Fwork_calc.text = diff_days + " д. " +
		diff_hours + " ч. " + 
		diff_min + " мин. ";
	Fsalary_calc.text = Fsalary_calc.text=="" ? "???" + " грн." : Fsalary_calc.text;

	return true;
}

function OnCalculate()
{
	// Сначала возьмем кол-во топлива по норме для спецоборудования
	// это было раньше Hob*tob
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOLVYD FROM "+sTmpTbl+" T INNER JOIN "
			+" (^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
	var sn = getSnap(strSQL);
	var Hob = 0;
	if (sn != null && sn[0] != null)
	{
		Hob = sn[0];
	}
	sn = null;
	// Спецоборудование может использовать то же топливо что и машина
	// Потому узнаем количество топлива, которое использовалось для езды
	var tblTmp = getTmpTableName();
	var tblTmpOb = getTmpTableName();
	strSQL = "SELECT SUM(T.FKOLVYD) AS FKOL, FT.FFUEL, 0 AS FKOLOB "
			+" INTO " + tblTmp
			+" FROM "+sTmpTbl+" T INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_RUN)
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL =" SELECT SUM(T.FKOLVYD) AS FKOLOB, FT.FFUEL"
			+" INTO " + tblTmpOb
			+" FROM "+sTmpTbl+" T INNER JOIN "
			+" ((^CLRELCLCL REL INNER JOIN ^CL_WORKTYPE WT ON (REL.FWID_CL = WT.FWID_CL AND REL.FCL = "+sqlTo(sprWorkType)+"))"
			+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
				+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
					+" ON REL2.FCOD = WT.FFUEL)"
			+" ON T.FWORKTYPE = REL.FCOD "
			+" WHERE WT.FWORK = " + sqlTo(AVTO_WORKTYPE_SPEC)
			+" GROUP BY FT.FFUEL"
	ExecuteSQL(strSQL);
	strSQL = "UPDATE "+tblTmp+" T "
			+" SET FKOLOB = (SELECT FKOLOB FROM "+tblTmpOb+" T1"
			+" WHERE T.FFUEL = T1.FFUEL)"
			+" WHERE FFUEL IN (SELECT FFUEL FROM "+tblTmpOb+" )"
	ExecuteSQL(strSQL);
	var tSum = OpenTable("s", tblTmp);
	var Hs = 0;
	var Qn;
	var fuelQty = 0;
	var fuelQtyAll = 0;
	var overrun_value;
	for(; !tSum.IsEOF(); tSum.MoveNext())
	{
		strSQL = "SELECT SUM(FBFUEL+FFUEL_DESK-FEFUEL)"
			+" FROM "+sTmpTblFuel+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
			+" AND FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
			fuelQty += sn[0]*koef;
		}	
		sn = null;		
	}
	if (fuelQty == 0)
	{
		return;
	}
	strSQL = "SELECT SUM(FBFUEL+FFUEL_DESK-FEFUEL)"
			+" FROM "+sTmpTblFuel+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		fuelQtyAll = sn[0];
	}
	sn = null;
	if (!tSum.IsEmpty())
	{
		for(tSum.MoveFirst(); !tSum.IsEOF(); tSum.MoveNext())
		{
			strSQL = "SELECT FBFUEL+FFUEL_DESK-FEFUEL FROM "+sTmpTblFuel
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
					+" AND FFUEL = " + sqlTo(tSum.getValue("FFUEL"))
			var sn = getSnap(strSQL);
			if (sn != null && sn[0] != null)
			{
				var koef = tSum.getValue("FKOL")/(tSum.getValue("FKOL")+tSum.getValue("FKOLOB"));
				Hs += tSum.getValue("FKOL")*sn[0]*koef/fuelQty;
			}
			sn = null;
		}
	}
	Qn = Hs * (1 + 0.01 * Number(ksum.value)) + Hob * (1 + 0.01 * Number(kob.value));
	overrun_value = Math.round((fuelQtyAll - Qn) * 1000) / 1000;
	
	calc_value.value = Qn;
	overrun.text = overrun_value + " л.";
}

function refreshAvtoInfo()
{
	var oSnap = getSnap("select b.FWORKING_PETROL"
		+ " from ^CL_AVTO a LEFT JOIN ^CL_AVTO2FUEL_RATE b on a.fmodel = b.fcod"
		+ " where a.FCOD = " + sqlTo(objAvto.getCod()));

	if (oSnap != null)
	{
		Hs = 0;//getFuelNorma(objAvto.getCod());
		Hob = oSnap[0];
		
		HsLabel.text = "Hs = " + Hs;
		HobLabel.text = "Hоб = " + Hob;
	}
}

function updNorm()
{
	// посчитаем расход топлива по норме
	strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = 0";
	ExecuteSQL(strSQL);
	var tWorks = OpenTable("s", sTmpTbl);
	for (; !tWorks.IsEOF(); tWorks.MoveNext())
	{
		var mFnorm = tWorks.getValue("FKOLVYD");
		var strFrom = " FROM (^CLRELCLCL REL1 INNER JOIN ^CL_WORKTYPE WT "
									+" ON (REL1.FWID_CL=WT.FWID_CL AND REL1.FCL = "+sqlTo(sprWorkType)+"))"
											+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
												+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
													+" ON REL2.FCOD = WT.FFUEL"
		var strSQL = "SELECT FT.FFUEL, FT.FMOTOR_OIL, FT.FTRANSMISSION_OIL, FT.FSPECIAL_OIL, FT.FPLASTIC_LUBRICATION, "
				+" WT.FMOTOR_OIL, WT.FTRANSMISSION_OIL, WT.FSPECIAL_OIL, WT.FPLASTIC_LUBRICATION"
				+ strFrom
				+" WHERE REL1.FCOD = " + sqlTo(tWorks.getValue("FWORKTYPE"));
		var sn = getSnap(strSQL);
		if (sn != null && sn[0] != null)
		{
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(mFnorm)
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_FUEL)
					+" AND FFUEL = " + sqlTo(sn[0])
			ExecuteSQL(strSQL);
			// Расход масел и смазки
			// Расход в нормах на 100 литров горючего
			var koeff = (mFnorm / 100)*(Number(koil.value)/100);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[5])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_MOTOR)
					+" AND FFUEL = " + sqlTo(sn[1])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[6])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_TRMIS)
					+" AND FFUEL = " + sqlTo(sn[2])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[7])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_SPEC)
					+" AND FFUEL = " + sqlTo(sn[3])
			ExecuteSQL(strSQL);
			strSQL = "UPDATE "+sTmpTblFuel+" SET FFUEL_NORM = FFUEL_NORM + "+sqlTo(koeff*sn[8])
					+" WHERE FTYPE = " + sqlTo(AVTO_NMK_PLLUB)
					+" AND FFUEL = " + sqlTo(sn[4])
			ExecuteSQL(strSQL);			
		}
		sn = null;
	}
	tWorks.close(5652);
	tWorks = null;
	switch(extPar.doc.getPar("_modekolfuel"))
	{
		case 0://совпадает с нормой
			strSQL = "UPDATE "+sTmpTblFuel+" SET FEFUEL = FBFUEL + FFUEL_DESK - FFUEL_NORM "
			ExecuteSQL(strSQL);
			break;
		case 1://вводится вручную
			break;
	}
	if (gridFuel.getTable() != null)
	{
		gridFuel.getTable().requery();
		gridFuel.refresh();
	}	
}

function makeFuelTbl()
{
	//var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var nId = extPar.doc.getID();
	var sFLD = GetPatternIntersection("RFUEL","RFUEL");
	oAvto.setVar("FDAT", new Date(Fdoc_dat.value));
	oAvto.setVar("FMOL", oPers.getCod());
	oAvto.setVar("FPODR", oAvtopark.getCod());
	oAvto.setVar("FDOC", extPar.doc.sDocLbl);
	oAvto.setVar("FAVTO", objAvto.getCod());
	strSQL = " SELECT FWID "
				   + " FROM ^RFUEL"
				   + " WHERE fid_doc = " + nId
				   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl)
	var sn = getSnap(strSQL);
	if (extPar.mode == "EDIT" && sn != null)
	{
		var sSQL = "INSERT INTO " + sTmpTblFuel + "(" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM ^RFUEL"
				   + " WHERE fid_doc = " + nId
				   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl);
		ExecuteSQL(sSQL);
		
		ostUpdate();
	}
	else
	{
		// соберем виды топлива
		var strFrom = " FROM ((^CL_AVTO_WORK AW INNER JOIN ^CLRELCLCL REL "
							+" ON (REL.FWID_CL=AW.FWID_CL AND REL.FCL = "+sqlTo(sprAvto)+"))"
								+" LEFT JOIN (^CLRELCLCL REL1 INNER JOIN ^CL_WORKTYPE WT "
									+" ON (REL1.FWID_CL=WT.FWID_CL AND REL1.FCL = "+sqlTo(sprWorkType)+"))"
										+" ON AW.FCOD = REL1.FCOD )"
											+" LEFT JOIN (^CLRELCLCL REL2 INNER JOIN ^CL_FUELTYPE FT "
												+" ON (REL2.FWID_CL=FT.FWID_CL AND REL2.FCL = "+sqlTo(sprFuelType)+"))"
													+" ON REL2.FCOD = WT.FFUEL"
								
		var tmpNmk = getTmpTableName();
		// топливо
		strSQL = " SELECT Distinct FT.FFUEL AS FNMKL, "+sqlTo(AVTO_NMK_FUEL)+" AS FTYPE "
					+" INTO "+tmpNmk
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
		ExecuteSQL(strSQL);
		// масло моторное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FMOTOR_OIL AS FNMKL, "+sqlTo(AVTO_NMK_MOTOR)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
		ExecuteSQL(strSQL);
		// масло трансмиссионное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FTRANSMISSION_OIL AS FNMKL, "+sqlTo(AVTO_NMK_TRMIS)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
		ExecuteSQL(strSQL);
		// масло специальное
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FSPECIAL_OIL AS FNMKL, "+sqlTo(AVTO_NMK_SPEC)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
		ExecuteSQL(strSQL);
		// смазка пластичная
		strSQL = "INSERT INTO "+tmpNmk
					+" SELECT Distinct FT.FPLASTIC_LUBRICATION AS FNMKL, "+sqlTo(AVTO_NMK_PLLUB)+" AS FTYPE "
					+strFrom
						+" WHERE REL.FCOD = "+sqlTo(objAvto.getCod())
		ExecuteSQL(strSQL);
		
		strSQL = "INSERT INTO " + sTmpTblFuel + "(FFUEL, FID_DOC, FDOC, FTYPE)"
					+" SELECT DISTINCT FNMKL AS FFUEL, "+sqlTo(nId)+" AS FID_DOC, "+sqlTo(extPar.doc.sDocLbl)+" AS FDOC, FTYPE "
					+" FROM "+tmpNmk
		ExecuteSQL(strSQL);			

		ostUpdate();
	}
	sn = null;
	
	updNorm();
	
	if (gridFuel.getTable() != null)
	{
		gridFuel.getTable().requery();
		gridFuel.refresh();
	}
	
	return sTmpTblFuel;
}

function loadGridFuel()
{
	var n = extPar.doc.sDocLbl.indexOf(":");
	if (n != -1)
	{
		var moduleID = extPar.doc.sDocLbl.substr(0, n);
		this.sDocSourceDir = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + extPar.doc.sDocLbl.substr(n + 1)+ "/";
	}
	else
	{
		this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl+ "/";
	}

	makeFuelTbl();

	gridFuel.setXMLDir(this.sDocSourceDir);
	//gridFuel.setXMLFile("fuellist.xml");
	tblFuel = OpenTable("m", sTmpTblFuel);
	tblFuel.tie("cl_nmk", "fuel_nmk", "fwid", "FFUEL");
	gridFuel.setTable(tblFuel);
	//gridFuel.build();
	loadDpGridDefs(gridFuel);
}

function loadDpGridDefs(gridFuel)
{
	include("objects\\DpGrid.js")
	gridFuel = new DpGrid("NOCREATE", gridFuel);

	with(gridFuel)
	{
		with(page())
		{
			cell("fuel_nmk.ftxts", "ПММ|ГСМ", 15);
			cell("=getAvtoNmk(^FTYPE)", "Тип ПММ|Тип ГСМ", 15);
			switch(extPar.doc.getPar("_ost_fuel"))
			{
				case 0://считать по учету ТМЦ
					cell("FCENA", "Ціна|Цена", 8, "e");
				case 2://не считать
					cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9, "e");
				break;
				case 1://считать по путевым листам
				case 3://считать по путевым листам, а потом добавлять все, что было до нашей даты по учету ТМЦ
					strSQL = "SELECT COUNT(FWID) FROM ^WAYBILL "
							+" WHERE FAVTO = "+objAvto.getCod()
							+" AND FDOC_DAT< "+sqlTo(Fdoc_dat.getValue())
					var sn = getSnap(strSQL);
					if (sn != null)
					{
						if (sn[0] != 0)
						{
							cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9);
						}
						else
						{
							cell("FBFUEL", "Зал. пал.\nна поч.|Ост. топл.\nна нач.", 9, "e");
						}
					}
					sn = null;
				break;
			}
			switch(extPar.doc.getPar("_load_fuel"))
			{
				case 0:
					cell("FFUEL_DESK", "Заправлено|Заправлено", 9);
					break;
				case 1:
				default:
					cell("FFUEL_DESK", "Заправлено|Заправлено", 9, "e");
			}
			cell("FFUEL_NORM", "Кіл-ть пал.\nза нормою|Кол-во топл.\nпо норме", 9);
			cell("=^FBFUEL + ^FFUEL_DESK - ^FEFUEL", "Кіл-ть пал.\nфакт.|Кол-во топл.\nфакт.", 9);
			switch(extPar.doc.getPar("_modekolfuel"))
			{
				case 0://совпадает с нормой
					cell("FEFUEL", "Зал. пал.\nна кін.|Ост. топл.\nна кон.", 9);
					break;
				case 1://вводится вручную
					cell("FEFUEL", "Зал. пал.\nна кін.|Ост. топл.\nна кон.", 9, "e");
					break;
			}
		}
		build();
	}
}


function addRecord()
{
	return false;
}

function canEditRecord(sMode)
{
	if(!dpGridEdit || sMode == "ADD")
	{
		return false;
	}
	return true;
}

function startEdit_fefuel(oCtrl)
{
}

function endEdit_fefuel(oCtrl)
{
	var num = Number(gridFuel.getTable().getValue("FBFUEL"))+Number(gridFuel.getTable().getValue("FFUEL_DESK"))-Number(gridFuel.getTable().getValue("FFUEL_NORM"));
	dpGridEdit.setValue("FEFUEL", num, true);
}

function listMenuInitFuel()
{
	if (!gridFuel.getTable().isEmpty())
	{
		gridFuel.AddMenuItem("EDIT","Редагування | Редактирование");
	}
}

function onSelectRowMenuFuel(sID)
{
}

//по переданому класу загрузим грид 
function loadGrid(clas)
{
	var workTbl = "";
	var tmpTbl = "";
	var sWhere = "";
	var XMLName = "";
	var gridName = "";
	
	var n = extPar.doc.sDocLbl.indexOf(":");
	if (n != -1)
	{
		var moduleID = extPar.doc.sDocLbl.substr(0, n);
		this.sDocSourceDir = lpProxy.getModulePath(moduleID) + "/scripts/docs/" + extPar.doc.sDocLbl.substr(n + 1)+ "/";
	}
	else
	{
		this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl+ "/";
	}
	
	switch (clas)
	{
		case clasRow:
			workTbl = tblRow;
			tmpTbl = sTmpTbl;
			sWhere = " AND FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT);
			XMLName = "rowlist.xml";
			gridName = "GRIDROW";
			break;
		case clasTask:
			workTbl = tblRow;
			tmpTbl = sTmpTblTask;
			sWhere = " AND FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_TASK);
			XMLName = "tasklist.xml";
			gridName = "GRIDTASK";
			break;
		case clasHelp:
			workTbl = tblHelp;
			tmpTbl = tmpTblHelp;		
			XMLName = "GRIDHELPER.xml";
			gridName = "GRIDHELPER"
			break;
	}

	CreateTable(tmpTbl, workTbl, "FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection(workTbl, workTbl);
	var sSQL = "INSERT INTO " + tmpTbl + "(" + sFLD + ")"
							+ " SELECT " + sFLD
					   + " FROM ^"+workTbl
					   + " WHERE FID_DOC = " + nId
						   + " AND FDOC = " + sqlTo(extPar.doc.sDocLbl)
						   +sWhere
	ExecuteSQL(sSQL);
	
	
	var tblGrid = OpenTable("m","SELECT * FROM " + tmpTbl + " ORDER BY FNOM_STR");
	
	switch (clas)
	{
		case clasRow:
			if(strMode == "EDIT")
			{
				if(!IsTable(tmpTblDopl))
				{
					CreateTable(tmpTblDopl, tblDopl, "*");
				}
				//подтянем доплаты по строкам которые загрузились на грид
				var sFLDDOPL = GetPatternIntersection(tblDopl, tblDopl);
				strSQL = "INSERT INTO "+tmpTblDopl+"("+sFLDDOPL+")"
							+" SELECT "+sFLDDOPL	
							+" FROM ^"+tblDopl
							+" WHERE 1=1"
								+" AND FID_DOC IN (SELECT FWID FROM "+tmpTbl+" "
													+" WHERE 1=1"
														+" AND FTYPE = "+sqlTo(AVTO_WAYBILL_TYPE_FACT)
														+" AND FDOC = "+sqlTo(extPar.doc.sDocLbl)
													+")"
				ExecuteSQL(strSQL);
			}
						
			tblGrid.clTie("WT", "="+sprWorkType+",FWORKTYPE");
			tblGrid.clTie("US", "="+sprUser+",FUSER");
			sprMarsh = getPar(const_GETPAR_PUNKT);
			tblGrid.clTie("BEG", "="+ sprMarsh +",FFROMCOD");
			tblGrid.clTie("END", "="+ sprMarsh +",FTOCOD");
			break;
		case clasTask:
			tblGrid.clTie("WT", "="+sprWorkType+",FWORKTYPE");
			tblGrid.clTie("US", "="+sprUser+",FUSER");
			sprMarsh = getPar(const_GETPAR_PUNKT);
			tblGrid.clTie("BEG", "="+ sprMarsh +",FFROMCOD");
			tblGrid.clTie("END", "="+ sprMarsh +",FTOCOD");
			break
		case clasHelp:
			tblGrid.clTie("TABN", "="+sqlTo(sprPers)+", FTABN");
			break
		default:
			break
	}
	
	//парметры загрузки грида
	eval(gridName+".setXMLDir(this.sDocSourceDir)");
	eval(gridName+".setXMLFile(XMLName)");
	eval(gridName+".setTable(tblGrid)");
	eval(gridName+".build()");
	eval(gridName+".setData(clas)");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tblGrid, clas, extPar.doc);
	
	//меню грида
	eval(gridName+".loadMenuHandler(this,'listMenuInit')");
	eval(gridName+".selectMenuHandler(this,'onSelectRowMenu')");
}

function listMenuInit(grid)
{
	var clas = String(grid.getData());
	switch (clas)
	{
		case clasRow:
			grid.AddMenuItem("TASK","Завантажити із завдань водія|Загрузить из заданий водителю");
		case clasHelp:
		case clasTask:
		default:
			grid.AddMenuItem("ADD","Додавання | Добавление");
			if (!grid.getTable().isEmpty())
			{
				grid.AddMenuItem("EDIT","Редагування | Редактирование");
				grid.AddMenuItem("COPY","Копіювання | Копирование");
				grid.AddMenuItem("DEL","Видалення | Удаление");
			}
		break;
	}
}


function onSelectRowMenu(sID, grid)
{
	var par = new Object();
	var tbl = grid.getTable();
	var tmpTbl = tbl.getTableName();
	var clas = String(grid.getData());
	var rowID = Number(tbl.getRowID());
	
	par.oAvto = oAvto;
	par.objAvto = objAvto;
	par.oPers = oPers;
	par.tblDopl = tmpTblDopl;
	
	if(sID == "DEL")
	{
		var msg = ru("Подтвердите удаление записи", "Підтвердіть вилучення запису");
		var ret = msgBox("^c-", msg, ru("Подтверждение удаления","Підтвердження вилучення"));
		switch(ret)
		{
			case 'c':
				break;
			case '-':
				extPar.doc.deleteRow(clas, rowID);
				tbl.Delete();
				tbl.requery();
				grid.refresh();
			break;
		}		
	}
	else if (inList(sID, "ADD", "COPY", "EDIT"))
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow(clas);
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow(clas, rowID);
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow(clas, rowID);			
			var oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)		
		}
		
		if(clas == clasHelp)
		{
			par.dpObj = oDocRow; 
			
			//что брать для расчета при ЧТС (дни, часы)
			//параметр из настройки папки 
			par.time = extPar.doc.getPar("_gts_pom");
			
			//от какой сумы считать процент начисления (сумма тракториста)
			strSQL = "SELECT SUM("
										+"FSTKM"		//сума за т/км
										+"+FST"		//сума за груз	
										+"+FSSD"	//сума за сдельную работу 
										+") AS FLD" 
						+" FROM "+sTmpTbl
			var sn = getSnap(strSQL);
			par.bsum = (sn && sn[0] ? Number(sn[0]) : 0);
			par.doc_dat = Fdoc_dat.getValue();
		}
		var bOK = oDocRow.edit(sID, par)

		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}	
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow(clas, oDocRow)
			
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, tmpTbl);
			tbl.requery();
			grid.refresh();
			updNorm();
		}
	}
	else if (sID == "__XDEL")
	{
		var delRowCount = DataSource().getSelectedCount();
		
		if (delRowCount <= 0)
		{
			return;
		}
		var selIds = DataSource().getSelectedIDs();
		
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
		if("c"==msgBox("c-", sMsg, sCapt))
		{
			return;
		}

		setProgressRange(0, delRowCount);
		for (var nRow = 0; nRow < selIds.length; nRow++)
		{
			setProgressPos(nRow + 1, sCapt +": "+ (nRow + 1) +"/"+ delRowCount);
			extPar.doc.deleteRow(clas, Number(selIds[nRow]));
		}
		ExecuteSQL("DELETE FROM " + tmpTbl+ " WHERE " + grid.sqlSelected());

		grid.clearSelected();
		setProgressPos(0);
		tbl.requery();
		grid.refresh();		
	}
	else if (sID == "TASK")
	{
		var tmpTbl = sTmpTbl;
		if (!grid.getTable().IsEmpty())
		{
			if(!confirm(UR("Таблиця не пуста. Видалити введені рядки?|Таблица не пустая. Удалить введенные строки?")))
			{
				return;
			}
			else
			{
				ExecuteSQL("DELETE FROM "+tmpTbl);
			}
		}
		
		var oDocRow;
		//список полей для копирования из заданий в работу 
		var strFLD = "USER,WORKTYPE,FROM,TO,FROMCOD,TOCOD,GRDOR,HOD,GRUZ,GRKL,PROBG,PROB0,PROB,NOBL,EDOBL,KOLOBL"
						+",KOLF,PROCDOP,KOLVYDDOP,KOLVYD,BDATE,BTIME,EDATE,ETIME,DDV,CDV,MDV"
						+",DLIN,DLIN,MLIN,PROCTIMELIN,DBOPL,CBOPL,MBOPL,DREM,CREM,MREM,PROCTIMEREM,"
						+",DTOT,CTOT,MTOT";
		var arrFLD = strFLD.split(",");
		
		var opTbl = OpenTable("s", sTmpTblTask);
		for(; !opTbl.IsEOF(); opTbl.MoveNext())
		{
			oDocRow = extPar.doc.createRow(clas);
			oSnap = getSnap("SELECT MAX(FNOM_STR) AS NOM FROM " + tmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			
			oDocRow.setVar("RNOM", nNom);
			oDocRow.setVar("par.HDOC", opTbl.getValue("FDOC"));
			oDocRow.setVar("par.ID", opTbl.getValue("FID_DOC"));
			oDocRow.setVar("RTYPE", AVTO_WAYBILL_TYPE_FACT);
			oDocRow.setVar("RKLPROC", xcl(sprPers, oPers.getCod(), "PRKL"));
			
			for(var i=0 in arrFLD)
			{
				eval("oDocRow.setVar('R'+arrFLD[i], opTbl.getValue('F'+arrFLD[i]))");
				i++;
			}
			
			extPar.doc.appendRow(clas, oDocRow);
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,tmpTbl);
		}
		
		grid.getTable().requery();
		grid.refresh();	
		updNorm();
	}
	
	if(clas == clasRow)
	{
		calcSalary();
		calcRuns();
	}
}

function Fdoc_dat_Valid()
{
	PZ_DATE.value = Fdoc_dat.value;
	
	//при изменении даты нужно заново установить период для штатного расписания
	if(oPers instanceof DpShtat == true)
	{
		if(isEmpty(Fdoc_dat.getValue()))
			oPers.setPeriod(new Date(), new Date());
	else
			oPers.setPeriod(new Date(Fdoc_dat.getValue()), new Date(Fdoc_dat.getValue()));
	}
	return true;
}

function Fdriver_Valid()
{
	var ret = true;
	if (sprPers == oSc.getClcl1())
	{
		oSc._setCl(1, oPers.getCod());
	}
	else if (sprPers == oSc.getClcl2())
	{
		oSc._setCl(2, oPers.getCod());
	}
	else if (sprPers == oSc.getClcl3())
	{
		oSc._setCl(3, oPers.getCod());
	}
	
	//если oPers это штатное расписание то сами опдейтим текстовое поле
	if(oPers instanceof DpShtat == true)
	{
		//fruckt
		Fshtat_txt.setValue(oPers.getEmployeSurname());
	}
	
	//МОЛ на списание
	if (isEmpty(objMol.getCod()))
	{
		objMol.setCod(oPers.getCod());
	}
	
	ostUpdate();
	
	return ret;
}

function Favtopark_Valid()
{
	if (isEmpty(objPodr.getCod()) && !isEmpty(oAvtopark.getCod()))
	{
		objPodr.setCod(oAvtopark.getCod());
	}
	
	ostUpdate();
	
	return true;
}

function HNOM_Valid()
{
	if (isEmpty(toScrObj(PZ_NUM.getValue())) && !isEmpty(toScrObj(HNOM.getValue())))
	{
		PZ_NUM.setValue(toScrObj(HNOM.getValue()));
	}
	
	return true;
}

function OnCreateDoc()
{
	if (getPar("AVTO_PZ_NOP","AVTO") != 0)
	{
		if(searchPZ())
		{
			if(!confirm(UR("Документ уже створено. Створити ще один?|Документ уже создан. Создать еще один?")))
				return;
		}
		
		objDoc = new DpDoc("PZ", getPar("AVTO_PZ_NOP","AVTO"));
		
		var pzpar = new Object();		
		pzpar.escape = false;
		pzpar.Fdate = PZ_DATE.value;
		pzpar.Fdoc  = "PZ";
		pzpar.Fnop  = getPar("AVTO_PZ_NOP","AVTO");
		pzpar.Fcalc = 0;
		pzpar.Fdoc_num = String(PZ_NUM.value);
		pzpar.Fpodr = Number(objPodr.getCod());
		pzpar.Fmol = Number(objMol.getCod());
		pzpar.Fsc = Number(oSc.getSc());
		pzpar.Fsu = Number(oSc.getSu());
		pzpar.Fst = Number(oSc.getSt());
		pzpar.Fcl1 = Number(oSc.getCl1());
		pzpar.Fcl2 = Number(oSc.getCl2());
		pzpar.Fcl3 = Number(oSc.getCl3());

		pzpar.escape = true;
		pzpar.submode = "GETORDER";				
		
//		makeFuelTbl();
		pzpar.tblFrom = OpenTable("s","select * from " + sTmpTblFuel);

	    if (savePZ(objDoc, pzpar))
	    {
	    	alert("Документ создан!");
	    	create_doc.setText(UR("Создать документ на списание ГСМ (УЖЕ СОЗДАН)"));
	    }
	    else
	    	alert("Ошибка при создании документа!");
	}
	else
	{
	   	alert("Установите папку назначения!");
	}
}

function savePZ(oDoc, par)
{
	with(oDoc)
	{
		sDocLbl = 'PZ';
		setVar("HDOC", "PZ")
		setVar("HOP", Number(par.Fnop))
		setVar("HNOM", par.Fdoc_num);
		setVar("HDAT", par.Fdate);
		setVar("HPODR", par.Fpodr);
		setVar("HMOL", par.Fmol);
		setVar("HSC", par.Fsc);
		setVar("HSU", par.Fsu);
		setVar("HST", par.Fst);
		setVar("HA1", par.Fcl1);
		setVar("HA2", par.Fcl2);
		setVar("HA3", par.Fcl3);
		setVar("HP", oDoc.getPar("_pricetyp"));	
		setVar("HPN",oDoc.getPar("_priceuse"));	
	}
	var fnom = 0;
	var fkol = 0;
	var fsum = 0;	
	var oRow;	

	for(par.tblFrom.moveFirst(); !par.tblFrom.isEOF(); par.tblFrom.MoveNext())
	{	
		var mFkol = Number(par.tblFrom.getValue("FBFUEL"))
			+Number(par.tblFrom.getValue("FFUEL_DESK"))
			-Number(par.tblFrom.getValue("FEFUEL"));
		
		if (isEmpty(mFkol))
			continue;
		
		var mFsum = round(mFkol * Number(par.tblFrom.getValue("Fcena")),2);
		fsum += mFsum;	
		fkol += mFkol;
		fnom++;
		
		oRow = oDoc.createRow("ROW");
		oDoc.appendRow("ROW", oRow);

		with(oRow)
		{
			setVar("R1ID",	 0);	
			setVar("RNOM",	 fnom);		
			setVar("RTYPE",	 RTYPE_RS);							
			setVar("RKOL",	 mFkol);
			setVar("R1DAT",	 par.Fdate);
			setVar("RSUM",	 mFsum);
			
			setVar("R1OCENA",par.tblFrom.getValue("Fcena"));		
			setVar("RPCENE", par.tblFrom.getValue("Fcena"));
			setVar("RUCENA", par.tblFrom.getValue("Fcena"));		
			setVar("ROCENA", par.tblFrom.getValue("Fcena"));		
			setVar("RFOCENA",par.tblFrom.getValue("Fcena"));		
			setVar("RTNMK",	 par.tblFrom.getValue("FFUEL"));
			setVar("RPODR",	 oDoc.getVar("HPODR"));		
			setVar("RMOL",	 oDoc.getVar("HMOL"));
			setVar("RPOST",	 oDoc.getVar("HPOST"));	
			
			/*			
			setVar("RSC",	 oDoc.getVar("HSC"));
			setVar("RSU",	 oDoc.getVar("HSU"));
			setVar("RST",	 oDoc.getVar("HST"));
			*/			
			setVar("RSC",	 20);
			setVar("RSU",	 203);
			setVar("RST",	 0);
			
			setVar("RSC1",	 oDoc.getVar("HSC"));
			setVar("RSU1",	 oDoc.getVar("HSU"));
			setVar("RST1",	 oDoc.getVar("HST"));			
			setVar("RA1",	 oDoc.getVar("HA1"));
			setVar("RA2", 	 oDoc.getVar("HA2"));
			setVar("RA3", 	 oDoc.getVar("HA3"));
			
			setVar("REDI",	 0);
			setVar("RKOLSPR",0);			
		}	
		obj2DB(oRow.getID(), oRow.jDocRow, null, "ANLTK");
	}
	
	var fnds = 20;
	var fsnds = round(fsum*fnds/100,2);
	oDoc.setVar("HPNDS", fnds);	
	oDoc.setVar("HSNDS", fsnds);
	oDoc.setVar("HPSUM", fsum);
	oDoc.setVar("HSUM", fsum);
	oDoc.setVar("HKOL", fkol);	
	oDoc.setVar("HNR", fnom);	
	
	var bRet = oDoc.save(false, "ADD");
	oDoc.saveExtToDB();

	return bRet;
}

function searchPZ()
{
	var oSnap = getSnap("select FWID from ^SCH_ZAG"
						+" where UPPER(FDOC)='PZ'"
							+" and FNOP="+ sqlTo(getPar("AVTO_PZ_NOP","AVTO"))
							+" and FDOC_DAT="+ sqlTo(Fdoc_dat.value)
							+" and FDOC_NUM="+ sqlTo(PZ_NUM.value)
							+" and FPODR="+ sqlTo(objPodr.getCod())
							+" and FMOL="+ sqlTo(objMol.getCod())
							+" and FSC="+ sqlTo(oSc.getSc())
							+" and FSU="+ sqlTo(oSc.getSu())
							+" and FST="+ sqlTo(oSc.getSt())
							+" and FCL_COD1="+ sqlTo(oSc.getCl1())
							+" and FCL_COD2="+ sqlTo(oSc.getCl2())
							+" and FCL_COD3="+ sqlTo(oSc.getCl3())
						);
	if(oSnap && oSnap[0])
		return oSnap[0];
	return 0;
}

include("sys\\DpBaseDlg.js");