include("sys/mask.js");
include("Objects/DpAskEx.js");
include("servis/date.js");
include("avto:AVTO_const.js");

//20.10.2009 Олег
//проставление пробега для шин 
//из листов TL
function setRun()
{
	var sprAvto = getPar(const_AVTOTRANSPORT);
	
	oA = new DpAskEx();
	oA.add("D", "Місяць|Месяц", "MONTH", lastDay(new Date()));

	oA.doAsk();
	
	if(oA.escape)
	{
		CloseWindow();
		return;
	}
	
	var firstDat = firstDay(oA.get("MONTH"));
	var lastDat = lastDay(firstDat);
	var tmpTblTires = getTmpTableName();
	var tmpTblRuns = getTmpTableName();
		
	strSQL = "CREATE TABLE "+tmpTblTires
				+" ("
					+" FWID "+SqlType("INT")
				+" )"
	ExecuteSQL(strSQL);
		
	CreateTable(tmpTblRuns, "CL_AVTO_TIRES_RUNS", "*"); 
	
	//проверка
	//сначала находим все актуальные шини (действующие в даном месяце)
	strSQL = "SELECT COUNT(DISTINCT T.FWID)" 
					+" FROM ((^CL CL LEFT JOIN ^CLRELCLCL REL ON CL.FWID = REL.FWID_CL)"
							+" LEFT JOIN ^CL_AVTO A ON CL.FWID = A.FWID_CL)"
								+" LEFT JOIN ^CL_AVTO_TIRES T ON CL.FWID = T.FWID_CL"
					+" WHERE 1=1"
						+" AND REL.FCL = "+sqlTo(sprAvto)
						+" AND T.FBDAT <= "+sqlTo(lastDat)
						+" AND T.FEDAT > "+sqlTo(firstDat)
						+" AND T.FISZAPAS = "+sqlTo(false)
	var snAll = getSnap(strSQL);
	if(snAll == null || isEmpty(snAll[0]))
	{
		msg = ru("Не найдено установленых шин в этом месяце!"
					, "Не знайдено встановлених шин за вибраний місяць!");
		alert(msg);
		return;
	}
	
	//после находим все установленные пробеги по шинам в этом месяце 
	strSQL = "SELECT COUNT(DISTINCT T.FWID)" 
				+" FROM (((^CL CL LEFT JOIN ^CLRELCLCL REL ON CL.FWID = REL.FWID_CL)"
						+" LEFT JOIN ^CL_AVTO A ON CL.FWID = A.FWID_CL)"
							+" LEFT JOIN ^CL_AVTO_TIRES T ON CL.FWID = T.FWID_CL)"
								+" LEFT JOIN ^CL_AVTO_TIRES_RUNS R ON T.FWID = R.FWID_CL"
				+" WHERE 1=1"
					+" AND REL.FCL = "+sqlTo(sprAvto)
					+" AND T.FBDAT <= "+sqlTo(lastDat)
					+" AND T.FEDAT > "+sqlTo(firstDat)
					+" AND R.FMONTH >= "+sqlTo(firstDat)
					+" AND R.FMONTH <= "+sqlTo(lastDat)
	var sn = getSnap(strSQL);
	if(sn != null && !isEmpty(sn[0]))
	{
		msg = ru("В этом месяце найдены установленные пробеги для "
					, "У вибраному періоді знайдено встановлених пробігів для ")
		msg +=sn[0]
		msg +=ru(" шин из ", " шин з ")
		msg +=snAll[0]+"\n";
		msg +=ru("Продолжить запись пробегов в карточки шин?"
					, "Продовжити запис пробігів в карточки шин?");
		
		if(!confirm(msg))
		{
			alert(ru("Запись пробегов не выполнена.", "Запис пробігів не виконано."))
			return;
		}
	}
	sn	= null;
	snAll	= null;
	
	//данные берутся за месяц 
	//поэтому выберем суму пробега по каждом авто 
	strSQL = "SELECT " 
					+" SUM(FEDISTANCE - FBDISTANCE) AS FDISTANCE"
					+", FAVTO"
				+" FROM ^WAYBILL"
				+" WHERE 1=1"
					+" AND FDOC_DAT >= "+sqlTo(firstDat)
					+" AND FDOC_DAT <= "+sqlTo(lastDat)
				+"GROUP BY"
					+" FAVTO"
	var rsTbl = OpenTable("s", strSQL);
			
	var sPr = ru("Проставление пробега для шин: ","Встановлення пробігу по шинам: ");
	var maxPr = rsTbl.recordCount;
	var nPr = 1;
	
	if(maxPr == 0)
	{
		alert(ru("Не найдено путевых листов за этот месяц."
					, "Не знайдено шляхових листів за вибраний місяць."))
		return;
	}
	
	setProgressRange(0, maxPr);
	
	for(; !rsTbl.IsEOF(); rsTbl.MoveNext())
	{
		ExecuteSQL("DELETE FROM "+tmpTblTires);
		
		//1. количество всех шын(с запасками)
		strSQL = "SELECT T.FWID" 
					+" FROM ((^CL CL LEFT JOIN ^CLRELCLCL REL ON CL.FWID = REL.FWID_CL)"
							+" LEFT JOIN ^CL_AVTO A ON CL.FWID = A.FWID_CL)"
								+" LEFT JOIN ^CL_AVTO_TIRES T ON CL.FWID = T.FWID_CL"
					+" WHERE 1=1"
						+" AND REL.FCL = "+sqlTo(sprAvto)
						+" AND REL.FCOD = "+sqlTo(rsTbl.getValue("FAVTO"))
						+" AND T.FBDAT <= "+sqlTo(lastDat)
						+" AND T.FEDAT >= "+sqlTo(lastDat)
		var rs = OpenTable(strSQL);
		
		//если у авто нету шин то пропускаем его  
		if(rs.recordCount == 0)
		{
			rs.Close();
			continue;
		}
				
		//2. количество действующих шын(все установленные кроме запасок)
		var rs2 = OpenTable(strSQL+" AND T.FISZAPAS = "+sqlTo(false));
		var runsCount = rs2.recordCount;
		rs2.Close();
		
		//если у авто нету действующих(не запасок) шин  то пропускаем его  
		if(runsCount == 0)
		{
			continue;
		}
		
		//3.создаем таблицу со всеми колесами и сумой пробега (км)
		//пишем для каждой шины пробег
		//ПА - пробег Авто
		//ККБЗ - кол. колес без запасок
		//ВК - всего колес (с запасками)
		//пробег считаем по формуле пробег = ПА*ККБЗ/ВК
		//пример  4000*4/5 = 3200
		var distance = rsTbl.getValue("FDISTANCE") * runsCount / rs.recordCount;
		for(; !rs.IsEOF(); rs.MoveNext())
		{
			m = {};
			m.FRUN = round(distance, 2);
			m.FMONTH = lastDat;
			m.FISHANDEDIT = false;
			m.FWID = GetUID();
			m.FWID_CL = rs.getValue("FWID");
			updateTable(tmpTblRuns, m, true);
		}
		rs.Close();
		rs = null;
		setProgressPos(nPr++, sPr + (nPr-1) +"/"+ maxPr);
	}
		
	//пишем из темпа в базу 
	strSQL = "INSERT INTO ^CL_AVTO_TIRES_RUNS (FRUN, FMONTH, FISHANDEDIT, FWID, FWID_CL)"
				+" SELECT FRUN, FMONTH, FISHANDEDIT, FWID, FWID_CL" 
				+" FROM "+tmpTblRuns
				+" WHERE 1=1"
	ExecuteSQL(strSQL);
	
	DropTable(tmpTblRuns);
	DropTable(tmpTblTires);
	
	msg = ru("Запись сум пробегов в карточки шин завершена."
				,"Запис сум пробігів в картки шин завершений.");
	alert(msg);
	
	setProgressPos(0);
	return true;
}

include("sys\\DpBaseDlg.js");