function getDiscountProc(org, classOrg, classNmkl, dat, idDoc)
{
	var nSum = getCumulativeDiscountSum(org, dat, idDoc);
	return getDiscountProcBySum(classOrg, classNmkl, nSum);
}

function getDiscountProcBySum(classOrg, classNmkl, nSum)
{
	var sql = "select FPROC from ^listcldiscount where fcl = " + getPar("COD_CL_DISCOUNT")
	+ " and FCOD1 = " + sqlTo(classOrg) + " and FNMKLCLASS = " + sqlTo(classNmkl) 
	+ " and FSUM <= " + nSum + " order by fsum desc";
	var ret = 0;
	var oSnap = getSnap(sql);
	if (oSnap && oSnap[0])
		ret = oSnap[0];
	return ret;
}

function getCumulativeDiscountSum(org, dat, idDoc)
{
	var sSQL = "select SUM(HSUM) as FRET from ^UJ_DISCOUNT where HORG = " + sqlTo(org);
	
	if(dat && idDoc)
	{
		sSQL += " AND ((HDAT < " + sqlTo(dat) + " AND HID_DOC <> " + sqlTo(idDoc) + ")  or (" 
		+ " HDAT = " + sqlTo(dat) + " AND HID_DOC < " + sqlTo(idDoc) + " ))";
	}
	else if (dat)
		sSQL += " AND HDAT <= " + sqlTo(dat);
	else if (idDoc)
		sSQL += " AND HID_DOC <> " + sqlTo(idDoc);
	var nSum = 0;
	var oSnap = getSnap(sSQL);
	if (oSnap && oSnap[0])
		nSum = oSnap[0];
	
	return nSum;
}