
var arrTestTbl = new Array();
var iterations = 20;

function onLoad()
{
	FORM.setImage(rootDirectoryEx() +"/icons/Disaster.gif");
	setButton(BTNRUN, runSpeedTest);
	setButton(BTNEXIT, onExit);
	initSpeedTest();
	var curStatus = ReadParameter("SPEEDTEST_STATUS");
	if(curStatus)
		FSTATUS.value = curStatus;
	var curTime = ReadParameter("SPEEDTEST_TIME");
	if(curTime && Number(curTime)>0)
		FTIMESUM.value = curTime;
	setFocus(BTNRUN);
}

function initSpeedTest()
{
	FSTEP1.value = "1.";
	FTIME1.value = "";
	FNORM1.value = "";
	Disable(FSTEP1);
	Disable(FTIME1);
	Disable(FNORM1);
	
	FSTEP2.value = "2.";
	FTIME2.value = "";
	FNORM2.value = "";
	Disable(FSTEP2);
	Disable(FTIME2);
	Disable(FNORM2);
	
	FSTEP3.value = "3.";
	FTIME3.value = "";
	FNORM3.value = "";
	Disable(FSTEP3);
	Disable(FTIME3);
	Disable(FNORM3);
	
	FSTEPSUM.value = UR("РАЗОМ:|ИТОГО:");
	FTIMESUM.value = "";
	FNORMSUM.value = "";
	Disable(FSTEPSUM);
	Disable(FTIMESUM);
	Disable(FNORMSUM);
	
	FSTATUS.value = "0";
	FCOMMENT.value = "";
	Disable(FCOMMENT);
	//Disable(FSTATUS);
	
	initTestNorm();
	arrTestTbl = new Array();
	
	PROGRESS.setMinimum(0);
	PROGRESS.setMaximum(10);
	PROGRESS.setSelection(0);
	
	display.update();
}

function runSpeedTest()
{
	initSpeedTest();
	
	testCreateTable();
	testInsertRows();
	testEditTable();
	//testCreateOrg();
	
	endSpeedTest();
}

function initTestNorm()
{
	iterations = 20;
	if(SUBD==DERBY)
	{
		iterations = 10;
		FNORM1.value = 10;
		FNORM2.value = 10;
		FNORM3.value = 10;
	}
	else if(SUBD==MYSQL)
	{
		FNORM1.value = 10;
		FNORM2.value = 10;
		FNORM3.value = 10;
	}
	else
	{
		FNORM1.value = 2;
		FNORM2.value = 2;
		FNORM3.value = 2;
	}
	var nNorm = Number(FNORM1.value) + Number(FNORM2.value) + Number(FNORM3.value);
	FNORMSUM.value = round(nNorm, 2);
}

function endSpeedTest()
{
	LSTATUS.setText("");
	PROGRESS.setSelection(10);
	
	var nNorm = Number(FNORMSUM.value);
	var nTime = Number(FTIME1.value) + Number(FTIME2.value) + Number(FTIME3.value);
	FTIMESUM.value = round(nTime, 2);
	FSTATUS.value = 0;
	FCOMMENT.value = "";
	
	if(!nNorm || !nTime)
		return;
	
	var nStatus = 0;
	var nDiff = nTime/nNorm*100;
	if(nDiff<10)
		nStatus = 1;
	else if(nDiff<40)
		nStatus = 2;
	else if(nDiff<80)
		nStatus = 3;
	else if(nDiff<120)
		nStatus = 4;
	else if(nDiff<160)
		nStatus = 5;
	else if(nDiff<200)
		nStatus = 6;
	else if(nDiff<240)
		nStatus = 7;
	else
		nStatus = 8;
		
	FSTATUS.value = nStatus;
	printComment();
	
	WriteParameter("SPEEDTEST_STATUS", FSTATUS.value);
	WriteParameter("SPEEDTEST_TIME", FTIMESUM.value);
}

function printComment()
{
	var sComment = "";
	FCOMMENT.value = "";
	var nStatus = Number(FSTATUS.value);
	var curTime = Number(FTIMESUM.value);
	var oldTime = ReadParameter("SPEEDTEST_TIME");
	//alert(curTime +" - "+ oldTime)
	if(curTime && oldTime && Number(oldTime)>0)
	{
		if(curTime>oldTime)
			sComment += UR("Швидкість погіршилася на |Скорость ухудшилась на ") + round((1-(oldTime/curTime))*100, 2) +" %";
		else if(curTime<oldTime)
			sComment += UR("Швидкість покращилась на |Скорость улучшилась на ") + round((1-(curTime/oldTime))*100, 2) +" %";
		else
			sComment += UR("Швидкість не змінилась|Скорость не изменилась");
	}
	FCOMMENT.value = sComment;
	if(nStatus<5)
		return;
	sComment += "\n\n"+ UR("Можливі причини повільної роботи системи:"
					+"\n  - потрібна очистка тимчасової бази"	// (Администрування Сервіс/Очистка тимчасової бази)
					+"\n  - перевантажений сервер"
					+"\n  - працює антивірус"
					+"\n  - не вистачає пам'яті"
				+"|Возможные причины медленной работы системы:"
					+"\n  - требуется очистка временной базы"	// (Администрирование Сервис/Очистка временной базы)
					+"\n  - перегружен сервер"
					+"\n  - работает антивирус"
					+"\n  - не хватает памяти"
					);
	if(SUBD==DERBY)
	{
		sComment += "\n\n"+ UR("РЕКОМЕНДАЦІЇ:|РЕКОМЕНДАЦИИ:");
		sComment += "\n"+ UR("Варто перейти на MySQL або Postgre!|Следует перейти на MySQL или Postgre!");
	}
	FCOMMENT.value = sComment;
}

function progressWorked(nStep, sText, nTime)
{
	display.update();
	display.syncExec
	(
		function worked()
		{			
			try
			{
				var nPr = PROGRESS.getSelection()+1;
				PROGRESS.setSelection(nPr);
				//PROGRESS.setToolTipText(String(nPr));
				if(!nStep)
					return;
				LSTATUS.setText(nStep +". "+ sText);
				trace(nStep +". "+ sText +" - "+ nTime)
				if(sText)
					eval("FSTEP"+ nStep +".value='"+ nStep +". "+ sText +"'");
				if(nTime)
					eval("FTIME"+ nStep +".value="+ nTime);
			}
			catch(ex)
			{
				//alert(ex);
			}
		}
	);
	display.update();
}

function testCreateTable()
{
	var sText = UR("Створення таблиць|Создание таблиц");
	progressWorked(1, sText);
	var nStart = new Date().getTime();
	
	for(i=0; i<iterations; i++)
	{
		var testTableName = "TEST_"+ i +"_"+ getTmpTableName();
		arrTestTbl[arrTestTbl.length] = testTableName;
		var sSQL = "create table "+ testTableName 
				+" (FWID "+ sqlType("COUNTER")
				+", FCOD "+ sqlType("INT") 
				+", FDATE "+ sqlType("DATETIME") 
				+", FTEXT "+ sqlType("TEXT")
				+")";
		var bRet = ExecuteSQL(sSQL, false);
		if(!bRet)
			break;
		createIndex(testTableName, "FWID", "FWID");
		createIndex(testTableName, "FDATE", "FDATE");
	}
	
	var nTime = round((new Date().getTime()-nStart)/1000, 2);
	progressWorked(1, sText, nTime);
}

function testInsertRows()
{
	var sText = UR("Вставка рядків|Вставка строк");
	progressWorked(2, sText);
	var nStart = new Date().getTime();
	var i=1;
	for(i=1; i<=iterations; i++)
	{
		for(j=0; j<arrTestTbl.length; j++)
		{
			var testTableName = arrTestTbl[j];
			var sSQL = "insert into "+ testTableName 
						+" (FCOD, FDATE, FTEXT)"
						+" values ("+ i +","+ sqlTo(new Date()) +","+ sqlTo("TEST "+ i) +")";
			var bRet = ExecuteSQL(sSQL, false);
			if(!bRet)
				break;
		}
	}
	//sText += " ("+ (i-1) +")";
	var nTime = round((new Date().getTime()-nStart)/1000, 2);
	progressWorked(2, sText, nTime);
}

function testEditTable()
{
	var sText = UR("Редагування таблиць|Редактирование таблиц");
	progressWorked(3, sText);
	var nStart = new Date().getTime();
	
	//testSelectRows();
	//progressWorked();
	testUpdateRows();
	progressWorked();
	testDeleteRows();
	progressWorked();
	testDropTable();
	
	var nTime = round((new Date().getTime()-nStart)/1000, 2);
	progressWorked(3, sText, nTime);
}

function testSelectRows()
{
	for(i=1; i<=iterations; i++)
	{
		for(j=0; j<arrTestTbl.length; j++)
		{
			var testTableName = arrTestTbl[j];
			var tbl = OpenTable("select * from "+ testTableName 
								+" where FCOD="+ i
									+" and FDATE<="+ sqlTo(new Date(), false, true)
									+" and FTEXT like '%"+ i +"%'"
								+" order by FCOD, FDATE, FTEXT desc"
								);
			//sText += " ("+ tbl.recordCount +")";
			tbl.close();
		}
	}
}

function testUpdateRows()
{
	for(i=1; i<=iterations; i++)
	{
		for(j=0; j<arrTestTbl.length; j++)
		{
			var testTableName = arrTestTbl[j];
			var sSQL = "update "+ testTableName 
						+" set FDATE="+ sqlTo(new Date(), false, true)
						+" where FCOD="+ i
							+" and FDATE<="+ sqlTo(new Date())
							+" and FTEXT like '%"+ i +"%'";
			ExecuteSQL(sSQL, false);
		}
	}
}

function testDeleteRows()
{
	for(i=0; i<arrTestTbl.length; i++)
	{
		var testTableName = arrTestTbl[i];
		var sSQL = "delete from "+ testTableName 
					+" where FCOD="+ i
						+" and FDATE<="+ sqlTo(new Date())
						+" and FTEXT like '%"+ i +"%'";
		ExecuteSQL(sSQL, false);
	}
}

function testDropTable()
{
	for(i=0; i<arrTestTbl.length; i++)
	{
		var testTableName = arrTestTbl[i];
		ExecuteSQL("drop table "+ testTableName, false);
	}
}

function testCreateOrg()
{
	var sText = UR("Додавання контрагентів|Добавление контрагентов");
	progressWorked(3, sText);
	include("Objects/DpClEx.js");
	var nStart = new Date().getTime();
	
	var sVid = "CL2";
	var nCl = Number(getPar("CODPLAT"));
	var oCL = new DpClEx("CL2", Number(nCl));
	var nCod = 999999999999;
	var oSnap = getSnap("select max(r.FCOD) as FCOD"		
						+ " from ^CL c"
						+ " inner join ^CLRELCLCL r on c.FWID=r.FWID_CL"
						+ " where r.FCL=0"
						);
	if(oSnap)
		nCod = Number(oSnap[0])+1;
	oCL.setVar("HCOD", nCod);
	oCL.setVar("HTXT", UR("ТЕСТ НА ШВИДКІСТЬ|ТЕСТ НА СКОРОСТЬ"));
	var oRow = oCL.createRow("OCP");
	oCL.appendRow("OCP", oRow);
	oRow.setVar("HFIO", UR("ТЕСТ НА ШВИДКІСТЬ|ТЕСТ НА СКОРОСТЬ"));
	obj2DB(oRow.getID(), oRow.jObj, null, "^CL_ORGCP");
	var oRow = oCL.createRow("ORS");
	oCL.appendRow("ORS", oRow);
	oRow.setVar("HNUM", 1);
	oRow.setVar("HRASSCH", "0101010101");
	obj2DB(oRow.getID(), oRow.jObj, null, "^CL_ORGRS");
	bRet = oCL.save("ADD", true);
	oCL.del(oCL.getID(), true);
	
	var nTime = round((new Date().getTime()-nStart)/1000, 2);
	progressWorked(3, sText, nTime);
}

function onExit()
{
	CloseWindow();
}

include("sys/DpBaseDlg.js");