include("Objects/DpXMLDomDocument.js");

var nPodr=0;
var nPodr1=0;
var nMol = 0;
var nMol1 = 0;
var nSc = 28;
var nSu = 0;
var nSt = 0;
var nSc1 = 28;
var nSu1 = 0;
var nSt1 = 0;
var nSpr = 250;

var ArrObjects = new Array();

var ArrTetraPodr = new Array();
var ArrDocPN = new Array();
var ArrDocNK = new Array();
var ArrDocSM = new Array();
var ArrOrder = new Array("cls.edi","DpVal1","DpVal2","DpCountry","DpPodr1","DpNmkl1","DpNmkl2","DpNmkl3","DpNmkl4","DpNmkl5","DpNmkl6","DpOrg1","DpOrg2","DpOrg3","DpOrg4");
var XMLDocR = new DpXMLDOMDocument();


include("ConvXmlTetra.js");
include("sys\\udfs.js");
var bIsNmkl = false;

var arrTemplate = new Array();

function Load()
{
	
	var sStartDir = userDirectory();
	
	var sLastFile = String(ReadParEx("LASTIMPORTFILE"));
		
	
	if (sLastFile)
	{
		var oFile = new DpFile(sLastFile);
		
		var sStartDir = String(oFile.getParent()); 
	}
	
	var sFileName = BrowseForFile("*.xml", "Файлы XML (*.xml)|*.xml|", sStartDir);
	
	if(!sFileName)
	{
		return;	
	}
	WriteParEx("LASTIMPORTFILE", sFileName);
	
		
	arrTemplate["60000335"] = 130;
    arrTemplate["30050426"] = 30048748;
	arrTemplate["30050429"] = 128;
	arrTemplate["30082787"] = 30048748;
	var ttt = new Date().getTime();
	fillPodrMap();
	
	
	WAITTIMER("Конвертация экспорта Тетры");
	if(!XMLDocR.load(sFileName))
	{
		alert("Ошибка открытия xml файла");
		return;
	}
	
	//alert(XMLDocR.xml);
var ttt = new Date().getTime();
	/*
	if(XMLDocR.parseError!=0)
	{
		alert("Ошибка чтения XML:\n "+XMLDocR.parseError.reason);
		CloseWindow();
		return;
	}
	*/
	docEl = XMLDocR.getDocumentElement();
	xmlClass = docEl.getElementsByTagName("Class");		
	var resArr = new Array();
	for (i = 0; i < xmlClass.length; i++)
		switch (xmlClass[i].getAttribute("ClassID"))
		{
			case "2200":
				ArrObjects["DpOrg1"] = ParseOrg(xmlClass[i]);
				break;
			case "2300":
				ArrObjects["DpOrg2"] = ParseOrg(xmlClass[i]);
				break;
			case "2491":
				//ArrObjects["DpOrg3"] = ParseOrg(xmlClass[i]);
				break;
			case "2582":
				//ArrObjects["DpOrg4"] = ParseOrg(xmlClass[i]);
				break;				
			case "3101":
				ArrObjects["DpNmkl1"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "3121":
				ArrObjects["DpNmkl2"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "3122":
				ArrObjects["DpNmkl3"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "3123":
				ArrObjects["DpNmkl4"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "3124":
				ArrObjects["DpNmkl5"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "3130":
				ArrObjects["DpNmkl6"] = ParseNmkl(xmlClass[i]);
				bIsNmkl = true;
				break;
			case "5140":
				ArrObjects["cls.edi"] = ParseEdi(xmlClass[i]);
				break;
			case "5171":
				ArrObjects["DpVal1"] = ParseVal(xmlClass[i]);
				break;
			case "5172":
				ArrObjects["DpVal2"] = ParseVal(xmlClass[i]);
				break;
			case "5200":
				ArrObjects["DpCountry"] = ParseCountry(xmlClass[i]);
				break;
			case "4351":case "4360":
			case "4370":
				ParseDoc(xmlClass[i],xmlClass[i].getAttribute("ClassID"));
				break;							
				
		}
	var xmlConverted = createXml(ArrObjects,ArrOrder);
	
	
	if(!bIsNmkl)
	{
		alert("Из Тетры не выгружены номенклатуры");		
		return;	
	}
	
	WAIT("Конвертация завершена");
	
	//xmlConverted.getOwnerDocument().save("C:/Valia/BrokImp.xml")	
	//return;
	

	include ("import.js")
	
	var oPar = new Object();
	
	if (GetMenuMode() == "NORASCOST")
	{
	    oPar.NO_RASCOST = true;
	}
	
	// delete old medoc files
	if (getPar("EXPDIR"))
	{
		var medocDir = getPar("EXPDIR");
		medocDir += (getPar("EXPDIR").right(1) == "\\" || getPar("EXPDIR").right(1) == "/" ? "" : "\\");
		medocDir += "to_MEDOC\\";
		
		var dir = DpFile(medocDir);
		if(dir.isDirectory())
		{
			var files = dir.listFiles();				
			for(i=0; i<files.length; i++)
			{
				var docFile = files[i];
				deleteFile(docFile.getAbsoluteFile());
			}
		}			
	}		
		
	//without DLG
	
    var oImp = new DpXMLImport(oPar);
    var ttt = new Date().getTime();
    oImp.bConvertToMedoc = true;
    oImp.ImportObject(xmlConverted);
    /* 
   var par = new Object();
   par.impObj = xmlConverted;
   showWindow("import.xml", SW_MODAL, par);
   */ 
   
	ArrObjects = null;	
	XMLDocR = null;
	gc();	

}

function fillPodrMap()
{
	var sSQL = "select fcod, fpodr, fmol, fsu, fsc, fcontr from  ^clrelclcl r left join " 
		+ getPath("EXT") + "..CL_250 e on r.fwid_cl = e.fmainwid " 
		+ " where r.fcl = 250  order by fcod";
	var tbl = OpenTable(sSQL);
	while (!tbl.isEOF())
	{
		var sCod = Number(tbl.getValue("FCOD"));
		var nPodr = Number(tbl.getValue("FPODR"));
		var nMol = Number(tbl.getValue("FMOL"));
		var nSu = Number(tbl.getValue("FSU"));
		var nSc = Number(tbl.getValue("FSC"));
		if (!nSc) 
			nSc = 28;
		var nContr = Number(tbl.getValue("FCONTR"));
		var o = new Object();
		o.PODR = nPodr;
		o.MOL =nMol;
		o.SU = nSu;
		o.SC = nSc;
		o.CONTR = nContr;
		ArrTetraPodr[sCod] = o;		
		tbl.moveNext();		
	}	
}

function XCLT(nCl,nCod, sPar)
{
	sPar = String(sPar).toUpperCase();
	
	var o = ArrTetraPodr[nCod];
	
	if (o == null)
	{
		if (sPar == "SC")
		{
			return 28;		
		}
		return 0;
	}
	
	return o[sPar];
			
}
Load();