include("get_cnst.js");
include("servis\\date.js");
include("servis\\format.js");
include("sys\\main.js");

var CALENDTYPE_ISCALEND = 1;	// существует календарь
var CALENDTYPE_ISTABN 	 = 2;	// ведется по табельным
var CALENDTYPE_ISHOURS	 = 4;	// ведется по часам

var Validation = true;

//function dpCalendar(mode, regim){
function dpCalendar(regim){
	RO("dpCalendar", this);

        this.setMode = dpCalendar_setMode;
        this.getMode = dpCalendar_getMode;
	
	this.setCod 		= dpCalendar_setCod;		//установить номер календаря
	this.getCod 		= dpCalendar_getCod;		//получить номер календаря

	this.getTxt 		= dpCalendar_getTxt;
	this.setTxt 		= dpCalendar_setTxt;

	this.setBDat 		= dpCalendar_setBDat;
	this.getBDat 		= dpCalendar_getBDat;

	this.setEDat 		= dpCalendar_setEDat;
	this.getEDat 		= dpCalendar_getEDat;

	this.setTabn 		= dpCalendar_setTabn;
	this.getTabn 		= dpCalendar_getTabn;

	this.getFisTabn		= dpCalendar_getFisTabn;	// ведется ли календарь по людям
	this.getFisHours	= dpCalendar_getFisHours;	// расчет больничных по часам
	this.getCalDays		= dpCalendar_getCalDays;
	this.getCalHours	= dpCalendar_getCalHours;
	this.getTime4Bol	= dpCalendar_getTime4Bol;
	this.getDate4Otp	= dpCalendar_getDate4Otp;

	this.linkCtrl 		= dpCalendar_linkCtrl;		//связать с контролами

	this.valid 			= dpCalendar_valid;			//
	this.validCtrlCod	= dpCalendar_validCtrlCod;
	this.validCtrlBDat	= dpCalendar_validCtrlBDat;
	this.validCtrlEDat	= dpCalendar_validCtrlEDat;
	this.validCtrlTabn	= dpCalendar_validCtrlTabn;
	this.updateCtrl		= dpCalendar_updateCtrl;

	this.zaval			= dpCalendar_zaval;			//завал в справочник календарей


	this.getCalendType	= dpCalendar_getCalendType;	// вид календаря
	this.isCalend 		= dpCalendar_isCalend;		// проверка существования календаря на дату
	this.showMsg 		= dpCalendar_showMsg;		// alert о том, что календаря нету
	this.getKoef		= dpCalendar_getKoef;
	
	//private:
	this.isValid		= false;
	this.fcod 			= 0;
	this.ftxt 			= "";
	this.ftabn 			= 0;
	this.fistabn 		= false;
	this.fishours 		= false;
	
	this.ctrlCod		= null;
	this.ctrlTxt		= null;
	this.ctrlBDat		= null;
	this.ctrlEDat		= null;
	this.ctrlTabn		= null;
	this.setMode(regim)
	//this.regim = "";
}

// Установить режим
function dpCalendar_setMode(regim)
{
	if(regim != null)
		this.regim = regim;
	else
		this.regim = "";
	//если режим не позволяет заносить нулевой код, тогда делаем проверку и если календарь в справочнике единственный, тогда выбираем его
	if(this.regim.indexOf("0")==-1)
	{
		var snap = getSnap("select count(*),max(Fcod) from ^cl_calend");
		if(snap && snap[0]==1)
			this.setCod(snap[0]);
	}
}

// Получить режим
function dpCalendar_getMode(regim)
{
	return this.regim;
}

function dpCalendar_setCod(nCod){

        //if(this.regim.indexOf("0")!=-1){  // допустим ноль
        //  if (this.cod==0){
        //     this.isValid = true
        //  } 
        //}else{
          if(nCod!=this.fcod){
		this.isValid = false;
          }
          this.fcod = nCod;
          // Достанем текстовку
          strSQL = "SELECT FREM"
          +" FROM ^CL_CALEND"
          +" WHERE FCOD="+sqlTo(nCod)
          var sn = getSnap(strSQL);
          if(sn)
			this.setTxt(sn[0]);
          else
			this.setTxt("???");
	
          sn = null;
trace(">>> setCod="+this.fcod)
          this.updateCtrl();
       //}  
}

function dpCalendar_getCod(){
	return this.fcod;
}

function dpCalendar_setTxt(txt){
	this.ftxt = txt;
	this.updateCtrl();
}

function dpCalendar_getTxt(){
	return 	this.ftxt;
}

function dpCalendar_setBDat(dat){
	if( dat<this.fbdat || dat>this.fbdat){
		this.isValid = false;
	}
	this.fbdat = dat;
	this.updateCtrl();
}

function dpCalendar_getBDat(){
	return this.fbdat;
}

function dpCalendar_setEDat(dat){
	if( dat<this.fedat || dat>this.fedat){
		this.isValid = false;
	}
	this.fedat = dat;
	this.updateCtrl();
}

function dpCalendar_getEDat(){
	return this.fedat;
}

function dpCalendar_setTabn(tabn){
	if(tabn!=this.ftabn){
		this.isValid = false;
	}
	this.ftabn = tabn;
	this.updateCtrl();
}

function dpCalendar_getTabn(){
	return this.ftabn;
}

function dpCalendar_validCtrlCod(){
	this.setCod(this.ctrlCod.value);
	
	if (!this.valid()){
		return this.zaval()
	}
	return true;
}

function dpCalendar_validCtrlBDat(){
	var mBDat = this.ctrlBDat.value;
	var mEDat = this.ctrlEDat.value;
	
	if(mBDat<=d00 && mBDat>=d00){
		var strMsg = ru("Пустая дата недопустима","Порожня дата неприпустима");
		WAIT(strMsg);
		return softInvalid;
	}

	if(differ(mBDat, mEDat)==1){
		var strMsg = ru("Дата начала не может быть больше даты конца","Дата початку не може бути більшою за дату кінця");
		WAIT(strMsg)
		return softInvalid;
	}
	
	this.setBDat(mBDat);
	return this.valid() ? true : softInvalid;
}

function dpCalendar_validCtrlEDat(){
	var mBDat = this.ctrlBDat.value;
	var mEDat = this.ctrlEDat.value;
	
	if(mEDat<=d00 && mEDat>=d00){
		var strMsg = ru("Пустая дата недопустима","Порожня дата неприпустима")
		WAIT(strMsg);
		return false;
	}

	if(differ(mEDat, mBDat)==-1){
		var strMsg = ru("Дата конца не может быть меньше даты начала","Дата кінця не може бути меншою за дату початку");
		WAIT(strMsg)
		return softInvalid;
	}
	this.setEDat(mEDat) ;
	return this.valid() ? true : softInvalid;
}

function dpCalendar_validCtrlTabn(){
	if (this.ctrlTabn){
		this.setTabn(this.ctrlTabn.value) ;
	}
	return true;
}


function dpCalendar_zaval(){
	var par = new Object();
	par.mode = "dist";
	par.cod = this.getCod();
	par.isZaval = true;
	par.escape  = true;
	showWindow("l_cl_calendar.js", SW_MODAL, par);
	if (!par.escape){
		this.setCod(par.FCOD);
		this.setTxt(par.FREM);
		return true;
	}
	return false;
}

function dpCalendar_linkCtrl(ctrlCod, ctrlTxt,  ctrlBDat, ctrlEDat, ctrlTabn, ctrlTabnTxt){
	if(ctrlCod!=null){
		this.ctrlCod = ctrlCod;
		this.ctrlCod.mask ="####";

		if(typeOf(this.ctrlCod) == "DpTextEx"){
			this.ctrlCod.isButton = true;
			setButton(this.ctrlCod, this, "zaval");
			//this.ctrlCod.ButtonHandler(this, "zaval");
			
		}
		setValid(this.ctrlCod, this, "validCtrlCod");
	}
	
	if(ctrlTxt!=null){
		this.ctrlTxt= ctrlTxt;
		Enable(this.ctrlTxt,false)
		this.ctrlTxt.mask =strRepl("&",255);
	}

	if(ctrlBDat!=null){
		this.ctrlBDat = ctrlBDat;
		setValid(this.ctrlBDat, this, "validCtrlBDat");
		this.fbdat = ctrlBDat.value;
	}

	if(ctrlEDat!=null){
		this.ctrlEDat = ctrlEDat;
		setValid(this.ctrlEDat, this, "validCtrlEDat");
		this.fedat = ctrlEDat.value;
	}

	if(ctrlTabn!=null){
		this.ctrlTabn = ctrlTabn;
		setValid(this.ctrlTabn, this, "validCtrlTabn");
		this.ftabn = ctrlTabn.value;
	}
	
	this.updateCtrl();	
}

function dpCalendar_getCalDays(mode, dat1, dat2, tabn, isSilent)
{
	//Функция getCalDays находит количество
	//дней между двумя датами, подсматривая в календарь
	//В - выходные
	//П - праздничные
	//Р - рабочие
	//mode вида "В|П|Р" или комбинации из этих символов

	var mode4alert = isSilent ? "" : "S";
	var sMod = "'" + mode.replace(/\|/g,"','") + "'";
	var nKolDays = 0;
	var strSQL = " SELECT "
					+" COUNT(*) AS FCOUNT"
				+" FROM "
					+" ^RCALEND R "
					+" , ^HCALEND H "
				+" WHERE R.FATTR IN (" + sMod + ")"
					+" AND R.FDATE >= " + sqlTo(dat1)
					+" AND R.FDATE <= " + sqlTo(dat2)
					+" AND R.FID_CAL = H.FWID"
					+" AND H.FCOD = " + sqlTo(this.getCod())
					+sqlw0And("H.FTABN = ", tabn);
	var s = getSnap(strSQL);
	if (s==null)
	{
		return 0;
		this.showMsg(mode4alert, dat, tabn);
	}
	else
	if(s)
		nKolDays = s[0];
	return nKolDays;
}

function dpCalendar_getCalHours(mode, dat1, dat2, tabn)
{
	//Функция getCalHours находит количество
	//часов между двумя датами, подсматривая в календарь
	//В - выходные
	//- праздничные
	//Р - рабочие
	//mode вида "В|П|Р" или комбинации из этих символов

	var sMod = "'"+mode.replace(/\|/g,"','")+"'";
	var nKolDays = 0;
	var strSQL = "SELECT "
					+" SUM(R.FKOLCHAS) AS FCOUNT"
				+" FROM "
					+" ^RCALEND R "
					+" , ^HCALEND H "
				+" WHERE R.FATTR IN ("+sMod+")"
					+" AND R.FDATE >="+sqlTo(dat1)
					+" AND R.FDATE <="+sqlTo(dat2)
					+" AND R.FID_CAL = H.FWID"
					+" AND H.FCOD = "+sqlTo(this.getCod())
					+sqlw0And("H.FTABN = ", tabn);
	var s = getSnap(strSQL);
	if (s==null)
	{
		return 0;
	}
	else
	{
		if (s)
			nKolHours = s[0];
	}
	return nKolHours;
}


function dpCalendar_getTime4Bol(par)
{
	//Функция getTime4Bol находит
	//количество оплачиваемых дней больничного,
	//из них в том числе:
	//количество оплачиваемых дней за счет предприятия
	//количество оплачиваемых дней за счет соцстраха
	//par - что будем возвращать
	//firstDay - тип Date
	//bBoln - тип Date
	//eBoln - тип Date

	var d1 = par.fstDay;//первый день нетрудоспособности
	var db = par.bDat;	//начало больничного
	var de = par.eDat;	//конец больничного
	var daysTot	= 0;	//кол-во дней больничного
	var daysPr 	= 0;	//кол-во дней за счет предприятия
	var daysSs 	= 0;	//кол-во дней за счет соцстраха
	var hoursTot= 0;	//кол-во часов больничного
	var hoursPr = 0;	//кол-во часов за счет предприятия
	var hoursSs = 0;	//кол-во часов за счет соцстраха
	var dbss;			//число, с которого будет платиться соцстрах
	var dess			//число, до которого будет платиться соцстрах
	var dbpr;			//дата с которой плат. за счет предпр
	var depr;			//дата до которой плат. за счет предпр
	var dayspidp = get_cnst("dayspidp",db);	//количество дней за счет предприятия
	var firstDb = firstDay(db);	// первый день месяца начала больничного
	// если календарь ведется по табельным, то передаем табельный номер
	// если нет, то не передаем
	var tabn = null;
	if (this.getFisTabn("S")){
		tabn = par.tabn;
	}

	var daysp_prev = par.daysp_prev?par.daysp_prev:0;//кол-во дней за счет предприятия у первичного больничного
	depr = goDay(d1,dayspidp-daysp_prev-1);
	//if(depr<db)
	if(differ(depr,db)<0)
	{
		daysPr = 0;
		dbpr = d00;
		depr = d00;
		dbss = db;
		dess = de;
	}
	else
	{
		depr = differ(de,depr)>0 ? depr : de;	//если больничный меньше 5-ти дней
		//daysTot = this.getCalDays("Р", db, de, tabn);
		//hoursTot = this.getCalHours("Р", db, de, tabn);
		dbpr = differ(db,d1)>0 ? db : d1;
		//если передан признак, то для беременных дни берем календарные
		if(par.isBerem)
		{
			daysPr = day_difference(dbpr, depr);
			hoursPr = 0;
		}
		else
		{
			daysPr = this.getCalDays("Р",dbpr, depr, tabn);
			hoursPr = this.getCalHours("Р",dbpr, depr, tabn);
		}
		dbss = differ(de,depr)>0 ? goDay(depr,1) : d00;//дата начала больн. за счет соцстраха
		dess = differ(de,depr)>0 ? de : d00;//дата конца больн. за счет соцстраха
	}
	//eсли передан признак, то для беременных дни берем календарные
	if(par.isBerem)
	{
		daysTot = day_difference(db, de);
		hoursTot = 0;
		daysSs = day_difference(dbss, dess);
		hoursSs = 0;
	}
	else
	{
		daysTot = this.getCalDays("Р", db, de, tabn);
		hoursTot = this.getCalHours("Р", db, de, tabn);
		daysSs = this.getCalDays("Р", dbss, dess, tabn);
		hoursSs = this.getCalHours("Р", dbss, dess, tabn);
	}

	par.daysTot = daysTot;
	par.daysPr = daysPr;
	par.daysSs = daysSs;

	par.hoursTot = hoursTot;
	par.hoursPr = hoursPr;
	par.hoursSs = hoursSs;

	par.dbpr = dbpr;
	par.depr = depr;
	par.dbss = dbss;
	par.dess = dess;
	
	return par;
}

//Функция находит дату конца отпуска по кол-ву дней отпуска
function dpCalendar_getDate4Otp(par){
	var db = par.bDat;
	var de = par.eDat;
	var nKolDays = par.nKolDays;

	strSQL = null;
	strSQL = " SELECT"
				+" R.FATTR,"
				+" R.FDATE"
			+" FROM ^HCALEND H,"
				+" ^RCALEND R"
			+" WHERE "
				+" H.FCOD = "+sqlTo(this.getCod())
				+" AND H.FWID = R.FID_CAL"
				+" AND R.FDATE >= "+sqlTo(db)
				+" ORDER BY R.FDATE";
	var tblCal = OpenTable("s",strSQL);
	var nKol=0;
	var eDat;

	for(tblCal.MoveFirst(); nKol <= nKolDays && !tblCal.IsEOF(); tblCal.MoveNext()){
		if(tblCal.getValue("FATTR")!='П'){
			nKol++;
			eDat = tblCal.getValue("FDATE");
		}
		if(nKol>=nKolDays){
			break;
		}
	}
	par.eDat = eDat;
	return par;
}

function dpCalendar_getFisHours(mode, dat, tabn){

	var fishours = false;
	strSQL = " SELECT C.FISHOURS"
			+" FROM ^CL_CALEND C,"
				+" ^HCALEND H"
			+" WHERE C.FCOD = "+sqlTo(this.getCod())
				+(isEmpty(dat) ? "" : 
				" AND C.FCOD = H.FCOD AND H.FDATE = "+sqlTo(firstDay(dat)))
				+ sqlw0And("H.FTABN = ", tabn);
				+" AND H.FCOD = C.FCOD"

	var s = getSnap(strSQL);
	if (s == null){
		fishours = false;
	}else{
		fishours = s[0];
	}
	return fishours;
}

function dpCalendar_getFisTabn(mode, dat, tabn){

	var fistabn = false;
	strSQL = " SELECT C.FISTABN"
			+" FROM ^HCALEND H"
				+" , ^CL_CALEND C"
			+" WHERE H.FCOD = "+sqlTo(this.getCod())
				+(isEmpty(dat) ? "" : " AND H.FDATE = "+sqlTo(firstDay(dat)))
				+sqlw0And("H.FTABN = ", tabn)
				+" AND C.FISTABN = "+sqlTrue
				+" AND H.FCOD = C.FCOD";

	var s = getSnap(strSQL);
	if (s == null){
		fistabn = false;
	}else{
		fistabn = s[0];
	}
	return fistabn;
}


function dpCalendar_isCalend(mode, dat, tabn){
	// если mode содержит "S", значит режим silent (тихий) и ругаться при
	// отсутствии искомого календаря не будет
	var isSilent = (mode.toUpperCase()).indexOf("S") == -1 ? true : false;

	var isCalend = false;
	var strSQL = " SELECT FCOD"
				+" FROM ^HCALEND"
				+" WHERE "
					+" FCOD = " + sqlTo(this.getCod())
					+(isEmpty(dat) ? "" : " AND FDATE = "+sqlTo(firstDay(dat)))
					+ (this.getFisTabn() ? sqlw0And("FTABN = ", tabn) : "")
	var s = getSnap(strSQL);
	if (s == null){
		isCalend = false;
	} else {
		isCalend = true;
	}
	return isCalend;
}

function dpCalendar_showMsg(mode, dat, tabn){
	// если mode содержит "S", значит режим silent (тихий) и ругаться при
	// отсутствии искомого календаря не будет
	var isSilent = (mode.toUpperCase()).indexOf("S") == -1 ? false : true;
	var typeOfMsg = (mode.toUpperCase()).indexOf("A") == -1 ? "W" : "A";
	dat = firstDay(dat);

	// если календаря нет и нужно ругаться - ругаемся
	if (!isSilent){
		var strMsg = UR("Календарь №"+this.getCod()+" на |Календарь №"+this.getCod()+" на ") + format("dd.mm.yyyy",dat);
		if (typeof(tabn) == "number" && tabn > 0){
			strMsg += UR(" для таб.номеру | для таб.номера ") + tabn;
		}
		strMsg += UR(" не існує!| не существует!");
		if (typeOfMsg == "A"){
			alert(strMsg);
		}else{
			WAIT(strMsg);
		}
	}

	return true;
}

function dpCalendar_valid(){
	mCod = this.getCod();
        if (mCod==0 && this.regim.indexOf("0")!=-1){
           this.isValid = true;
           return true;
        } 
	mBDat = this.getBDat();
	mEDat = this.getEDat();
	mTabn = this.getTabn();
	this.isValid = false;

	// наличие дат в контролах
	var isBDat = (differ(new Date(mBDat),d00obj) == 0) ? false : true;
	var isEDat = (differ(new Date(mEDat),d00obj) == 0) ? false : true;
	
	// проверяем просто наличие календаря без даты
	var calendType = this.getCalendType("", "", mTabn);

	if (!isBDat){
		if(calendType & CALENDTYPE_ISCALEND){	// есть календарь
	
			this.fistabn = Boolean(calendType & CALENDTYPE_ISTABN);
			this.fishours = Boolean(calendType & CALENDTYPE_ISHOURS);
	
			if(this.fistabn){	// НЕ стоят даты и по таб.
				this.isValid = true;
			}else{
				calendType = this.getCalendType("", "");
				this.fistabn = Boolean(calendType & CALENDTYPE_ISTABN);
				this.fishours = Boolean(calendType & CALENDTYPE_ISHOURS);
				if (!this.fistabn){
					this.isValid = true;
				}
			}
		}else{
			this.isValid = false;
		}
	}else{
		// когда стоят даты
		// Первые числа месяцев начала и конца
		mBDat1 = firstDay(mBDat);
		mEDat1 = firstDay(mEDat);
		
		// для случая, когда только поставили дату начала, а дата конца - пустая
		if (!isEDat){
			mEDat1 = mBDat1;
		}
		this.isValid = true;

		// Пройдемся по всем первым числам месяцев за период
		// и проверим, чтобы для данного табельного номера имелись
		// все календари
		//debug();
		for(var dat = mBDat1; this.isValid && differ(dat,mEDat1)<=0; dat = goMonth(dat, 1)){
			calendType = this.getCalendType("", dat);
			if(calendType & CALENDTYPE_ISCALEND){	// есть календарь
		
				this.fistabn = Boolean(calendType & CALENDTYPE_ISTABN);
				this.fishours = Boolean(calendType & CALENDTYPE_ISHOURS);
		
				if(this.fistabn){
					if(this.isCalend("", dat, mTabn)){
						this.isValid = this.fistabn;
					}else{
						this.isValid = false;
					}
				}else{
					this.isValid = true;
				}
			}else{
				this.isValid = false;
			}
		}// end of for(var dat = mBDat1; this.isValid && dat<=mEDat1; dat = goMonth(dat, 1)){
	}
	
	if (!this.isValid && !isEmpty(dat)){
			this.showMsg("W", goMonth(dat, -1) , mTabn)
	}
	return this.isValid;
}

// Обновить связанные поля ввода
function dpCalendar_updateCtrl(){
	if (this.ctrlCod){
		this.ctrlCod.value = this.getCod();
	}
	if (this.ctrlTxt){
		this.ctrlTxt.value = this.getTxt();
	}
	if (this.ctrlTabn){
		this.ctrlTabn.value = this.getTabn();
	}
}

function dpCalendar_getCalendType(mode, dat, tabn){

	this.calType = 0;

	if (this.isCalend("", dat)){
		this.calType |= CALENDTYPE_ISCALEND;
		if (this.getFisHours("", dat)){
			this.calType |= CALENDTYPE_ISHOURS;
		}
		if (this.getFisTabn("", dat, tabn)){
			this.calType |= CALENDTYPE_ISTABN;
		}
	}
	return this.calType;
}

function dpCalendar_getKoef(mode, dat, tabn)
{
	this.calKoef = 1;

	strSQL = " SELECT"
				+" FFULLTIME"
				+", FHALFTIME"
			+" FROM ^HCALEND"
			+" WHERE "
				+" FCOD = " + sqlTo(this.getCod())
				+(isEmpty(dat) ? "" : " AND FDATE = "+sqlTo(firstDay(dat)))
				+sqlw0And("FTABN = ", tabn)
	var s = getSnap(strSQL);

	if (s)
	{
		if (s[0] != 0 && s[1] != 0)
		{
			this.calKoef = s[1]/s[0];
		}
	}
	s = null;

	return this.calKoef;
}