//============================================
//Объект для сравнения двух таблиц.
function DpCmp(mode)
{
	RO("DpCmp",this);
	//Установить таблицы  для сравнения
	this.setTbl			= DpCmp_setTbl;
	//Ключевые поля 
	this.setKeyFields	= DpCmp_setKeyFields;
	//Поля в которых содержатся значения
	this.setValueFields	= DpCmp_setValueFields;
	// установить поле FWID
	//this.addUniqueField	= DpCmp_addUniqueField;
	this.addKeyField	= DpCmp_addKeyField;
	
	//Начать сравнение
	this.doCmp			= DpCmp_doCmp;
	//Выполняет добавление 
	this.doInsert		= DpCmp_doInsert;
	this.tblLeft		= null;
	this.tblRight		= null;
	this.keyFields		= null;
	this.tblDstName		= null;
	//this.uniqueField	= "FWID_UNIQUE";
	this.nameKeyField	= "FKEY";
	this.keyStr 		= "";
}
//============================================
// type  - DEBET своя таблица 
//		 - MDB из левой базы
function DpCmp_setTbl(mode,type,tblName,basePath)
{
	switch (type)
	{
		case "DEBET":
			break;
		case "MDB":
		/*
			//Пробуем открыть базу.
			if (!OpenDatabaseEx(basePath))
			{
				return false;
			}
			create_table(tblName,basePath,mode+"_MDB");
			//теперь работаем с этой таблицей
			tblName += mode+"_MDB"
		*/
			break;
		
	}
	//Зпоминаем таблицы
	if (mode == "LEFT")
	{
		this.tblLeft = tblName;
	}
	else
	{
		this.tblRight = tblName;
	}
	return true;
}

//============================================
function DpCmp_setKeyFields(mode,strKey)
{
	this.keyFields = strKey;
}

//============================================
function DpCmp_setValueFields(mode,strValue)
{
	this.strValue = strValue;
}

//============================================
function DpCmp_doCmp(mode,rezultTblSufix)
{
	if (isEmpty(this.tblLeft) || isEmpty(this.tblRight) || isEmpty(this.keyFields) )
	{
		return false;
	}
	if (isEmpty(this.tblDstName))
	{
		this.tblDstName = getTmpTableName("", true);	
	}
	var aKey = String(this.keyFields).split(",")
	//Определимся с ключем
	
	var pref="";
	var suff="";
	if (SUBD == MSSQL)
	{
		pref = "LTRIM(RTRIM(";
		suff = "))";
	}
	for (var sStr in aKey)
	{
		//alert(this.keyStr+"  "+String(aKey[sStr]))
		this.keyStr = SqlConCat(String(this.keyStr),"'@'",pref+Convert(aKey[sStr],"STR")+suff);
	}
	this.keyStr = this.keyStr.substr(this.keyStr.indexOf('@')-1);

	// добавляем поле, по которому будем сравнивать и проставим ключ
	this.addKeyField("", this.nameKeyField);
	
	//Определимся с значениями
	var CmpStr = "";
	
	//Есть в левом нет в правом
	this.doInsert("",this.tblDstName+"_RIGHT",this.tblRight,this.tblLeft,this.keyStr)
	
	//Есть в левом нет в правом
	this.doInsert("",this.tblDstName+"_LEFT",this.tblLeft,this.tblRight,this.keyStr)
//browse(this.tblDstName+"_RIGHT");
//browse(this.tblDstName+"_LEFT");
	//Разные
	//this.doInsert("",this.tblDstName+"_DIFF",this.tblRight,this.tblLeft,keyStr)
}

//============================================
function DpCmp_doInsert(mode,tblInto,tblRight,tblLeft,KeyStr)
{
	DropTable(tblInto);
	strSQL = " SELECT N.* "
			+" INTO "+tblInto
			+" FROM "
				+tblRight+" N "
					+" LEFT JOIN "+tblLeft+" O"
						+" ON N."+this.nameKeyField+" = O."+this.nameKeyField
			+" WHERE 1=1 "
				+" AND O."+this.nameKeyField+" IS NULL"
	ExecuteSQL(strSQL);
}
/*
//	открывает базу данных и проверяет на наличие файла
//	если файла нет - OpenDatabase сама выводит message
function OpenDatabaseEx(fPth)
{
	var dbRes = OpenDatabase(fPth, false);
	if (!dbRes){
		//alert("Ошибка открытия или создания файла "+fPth);
		return false;
	}
	return dbRes;
}

function create_table(sName, fPath, str)
{
	var tblName = sName+str;
	var strSQL;
	
	DropTable(tblName);
	strSQL="SELECT T.* "
			+" INTO "+tblName
			+" FROM "
				+" "+sName+" T "
			+" IN '"+fPath+"'";
	ExecuteSQL(strSQL, true, ru("Формируется таблица "
		+tblName+". Ждите...", "Формується таблиця "+tblName+". Чекайте..."));
}
*/
//	замена null-поля значением value в зависимости от mode
//	если mode == str -> ""
//	если mode == num -> 0
//	если mode == bool -> "FALSE"
function change_ifNULL(field, mode)
{
	var value;
	switch (mode.toLowerCase()){
		case "str":
			value = "''";
			break;
		case "num":
			value = 0;
			break;
		case "bool":
			value = "FALSE";
			break;
		default:
			alert ("mode "+mode+" нет");
	}
	return IIF(field+" IS NULL", value , Convert(field, "STR"));
}

// добавляем поле, по которому будем сравнивать и проставим ключ
function DpCmp_addKeyField(mode, nameKeyField)
{
	strSQL = " ALTER TABLE "+this.tblLeft
			+" ADD  "+this.nameKeyField+" "+SqlType("TEXT")
	ExecuteSQL(strSQL);
	
	strSQL = " UPDATE "+this.tblLeft
			+" SET "
				+this.nameKeyField+" = "+this.keyStr
	ExecuteSQL(strSQL);

	strSQL = " ALTER TABLE "+this.tblRight
			+" ADD COLUMN "+this.nameKeyField+" "+SqlType("TEXT")
	ExecuteSQL(strSQL);
	
	strSQL = " UPDATE "+this.tblRight
			+" SET "
				+this.nameKeyField+" = "+this.keyStr
	ExecuteSQL(strSQL);
}