// JScript source code
include ("objects\\DpXMLDomDocument.js");

function DpDocPar(sDoc,iNop)
{
	if (typeof(sDoc) != "string")
		return null;
	else
		this.doc = sDoc;
		
	if (!iNop)
		this.nop = 0;
	else
		this.nop = Number(iNop);
	
	var sSQL = "Select fispfolder,fispuser from ^cl_lnk where fdoc=" + sqlTo(this.doc) + "and fnop=" + sqlTo(this.nop);
	var tbl = OpenTable("s",sSQL);
	this.fispfolder = false;
	this.fispuser = false;
	if (!tbl.isEmpty())
	{
		this.fispfolder = eval(tbl.getValue("fispfolder"));
		this.fispuser = eval(tbl.getValue("fispuser"));
	}
	tbl.close();

	if (this.fispfolder == false)
	{
		this.nop = 0;
	}
	this.user = getUser();
	if (this.fispuser == false)
	{
		this.user = 0;
	}
	
	this.parList = new Array();
	this.parMap = null;
//-	this.sFile = getOrgPath() + "docpar.xml";
	this.sFile = getOrgPath() + "data\\docs\\" + this.doc + "\\docpar.xml";
	if (!isFile(this.sFile))
		createDirectory(getOrgPath() + "data\\docs\\" + this.doc + "\\");
	this.createXMLDummy = DpDocPar_createXMLDummy;	// ??????? ?????? docpar.xml
	this.Edit = DpDocPar_Edit;						// ???????? ?????? ?????????????? ?????????? ?????????
	this.getPar = DpDocPar_getPar;					// ???????? ???????? ????????? (?? ??? ??)
	this.setPar = DpDocPar_setPar;					// ?????????? ???????? ????????? (????? ?????? - ???? ??? ?? ????)
	this.loadXML = DpDocPar_loadXML;				// ?????????\??????????? ???
	this.getParEl = DpDocPar_getParEl;				// ???????? ???????-???????? ?? ??? ?? (??? null - ???? ?????? ???)
	
	this.ParseDefXML = DpDocPar_ParseDefXML;
	this.fillList = DpDocPar_fillList;
	this.fillMap = DpDocPar_fillMap;
	this.getDefault = DpDocPar_getDefault;
	this.getDefaultForType = DpDocPar_getDefaultForType;
	this.getValForType = DpDocPar_getValForType;
	
	this.edit = this.Edit;
	this.loading = false;
	if (!isFile(rootDirectory() + "DOCS\\" + this.doc + "\\")
		|| !isFile(rootDirectory() + "DOCS\\" + this.doc + "\\param.xml"))
	{
		this.xmlDom = null;
//-		alert(rootDirectory() + "DOCS\\" + this.doc + "\\param.xml");
		return this;
	}
	this.loadXML();
	this.ParseDefXML();
	return this;
}

function DpDocPar_ParseDefXML()
{
	var xmlDom = new DpXMLDOMDocument();
//-	xmlDom.load(rootDirectory() + "DocParPar.xml");
	xmlDom.load(rootDirectory() + "DOCS\\" + this.doc + "\\param.xml");
	this.xmlDefRoot = xmlDom.getDocumentElement();
	this.xmlEditEl = this.xmlDefRoot;
//-	this.xmlEditEl = this.xmlDefRoot.selectSingleNode(this.doc);
	if (this.xmlEditEl == null)
	{
		if (this.doc == "TX" || this.doc == "SZ" || this.doc == "SP" 
			|| this.doc == "O1" || this.doc == "O4" || this.doc == "O7")
		{
//-			this.xmlEditEl = this.xmlDefRoot.selectSingleNode("DOC0");
			xmlDom.load(rootDirectory() + "DOCS\\" + this.doc + "\\param.xml");
			this.xmlDefRoot = xmlDom.getDocumentElement();
			this.xmlEditEl = this.xmlDefRoot;
		}
	}
	if (this.xmlEditEl != null)
	{
		this.fillList(this.xmlEditEl);
		this.fillMap();
		return true;
	}
	return true;
}

function DpDocPar_fillList(xmlEl)
{
	var xmlPars = xmlEl.selectSingleNode("Params");
	if (xmlPars != null)
	{
		var xmlParamList = xmlPars.selectNodes("Param");
		for(var i = 0; i < xmlParamList.length; i++)
		{
			this.parList.push(xmlParamList[i]);
		}
	}
	var xmlParents = xmlEl.selectSingleNode("Parents");
	if (xmlParents != null)
	{
		var xmlParentsList = xmlParents.selectNodes("Parent");
		for (var i = 0; i < xmlParentsList.length; i++)
		{
//-			var tmpParent = this.xmlDefRoot.selectSingleNode(xmlParentsList[i].getAttribute("name"));
			var parName = xmlParentsList[i].getAttribute("name");
			var tDom = new DpXMLDOMDocument();
			tDom.load(rootDirectory() + "DOCS\\" + parName + "\\param.xml");
			var tmpParent = tDom.getDocumentElement();
			if (tmpParent != null)
			{
				this.fillList(tmpParent);
			}
		}
	}
}

function DpDocPar_getDefault(sPar)
{	
	if (sPar in this.parMap)
	{
		return this.parMap[sPar];
	}
	return null;
}

function DpDocPar_fillMap()
{	
	if (this.parList == null)
	{
		return;
	}
	this.parMap = new Array();
	for (var i = 0; i < this.parList.length; i++)
	{
		var sPar = String(this.parList[i].getAttribute("name"));
		var dflt = String(this.parList[i].getAttribute("default"));
		if (!dflt || dflt == null)
		{
			var type = String(this.parList[i].getAttribute("type"));
			if (type && type != null)
				this.parMap[sPar] = this.getDefaultForType(type);
		}
		else
			this.parMap[sPar] = dflt;
	}
}

function DpDocPar_getValForType(sType,objVal)
{
	switch(sType)
	{
	case "bool":
		return objVal == "true";
	case "number":
	case "int":
		return parseInt(objVal);
	case "date":
		return new Date(objVal);
	case "text":
	case "string":
	default:
		return String(objVal);
	}
}

function DpDocPar_getDefaultForType(sType)
{
	switch(sType)
	{
	case "text":
	case "string":
		return "";
	case "date":
		return new Date("01/01/3000");
	case "bool":
		return false;
	case "number":
	case "int":
	default:
		return 0;
	}
}

function DpDocPar_loadXML()
{
	if (!isFile(this.sFile))
	{
		if (this.loading)
			return null;
		this.loading = true;
		this.createXMLDummy(this.sFile);
		this.loadXML();
		this.loading = false;
		return null;
	}
	this.xmlDom = new DpXMLDOMDocument();
	this.xmlDom.load(this.sFile);
	this.xmlRoot = this.xmlDom.getDocumentElement();
}

function DpDocPar_getParEl(sPar,doc,nop,user)
{
	var parEl = null;
	if (nop != 0)
	{
		if (user != 0)
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + doc + "']"
												  + "/nop[@num='" + nop + "']"
												  + "/user[@id='" + user + "']"
												  + "/param[@name='" + sPar + "']");
			if (parEl == null)
				return this.getParEl(sPar,doc,nop,0);
			return parEl;
		}
		else
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + doc + "']"
												  + "/nop[@num='" + nop + "']"
												  + "/param[@name='" + sPar + "']");
			if (parEl == null)
			{
				parEl = this.getParEl(sPar,doc,0,this.user);
				if (parEl == null)
					return this.getParEl(sPar,doc,0,0);
				return parEl;
			}
			return parEl;
		}
	}
	else
	{
		if (user == 0)
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + doc + "']"
												  + "/param[@name='" + sPar + "']");
			return parEl;
		}
		else
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + doc + "']"
													+ "/user[@id='" + user + "']"
													+ "/param[@name='" + sPar + "']");
			if (parEl == null)
				return this.getParEl(sPar,doc,0,0);
			return parEl;
		}
	}
}

function DpDocPar_getPar(sPar)
{
	var parEl = this.getParEl(sPar,this.doc,this.nop,this.user);
	if (parEl != null)
	{
		return this.getValForType(String(parEl.getAttribute("type")),parEl.getText());
	}
	return this.getDefault(sPar);
}

function DpDocPar_setPar(sPar,sVal)
{
	var parEl = null;
	if (this.nop == 0)
	{
		if (this.user == 0)
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc + "']"
											  + "/param[@name='" + sPar + "']");
		}
		else
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc + "']"
											  + "/user[@id='" + this.user + "']"
											  + "/param[@name='" + sPar + "']");
		}
	}
	else
	{
		if (this.user == 0)
		{
			parEl = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc + "']"
											  + "/nop[@num='" + this.nop + "']"
											  + "/param[@name='" + sPar + "']");
		}
		else
		{
			parEl =	parEl = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc + "']"
											  + "/nop[@num='" + this.nop + "']"
											  + "/user[@id='" + this.user + "']"
											  + "/param[@name='" + sPar + "']");

		}
	}
	
	if (parEl != null)
	{
		parEl.setText(sVal);
		this.xmlDom.save(this.sFile);
		this.loadXML();
	}
	else
	{	
		var xmlDocNop = null;
		if (this.nop != 0)
		{
			xmlDocNop = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc 
														+ "']/nop[@num='" + this.nop
														+ "']");
		}
		
		if (xmlDocNop != null)
		{
			if (this.user != 0)
			{
				var xmlUser = xmlDocNop.selectSingleNode("user[@id='" + this.user + "']");
				if ( xmlUser == null)
				{
					xmlUser = this.xmlDom.createElement("user");
					xmlUser.setAttribute("id",this.user);
					xmlDocNop.appendChild(xmlUser);
				}
				xmlDocNop = xmlUser;
			}
			var parEl = this.xmlDom.createElement("param");
			parEl.setAttribute("name",sPar);
			xmlDocNop.appendChild(parEl);
			this.setPar(sPar,sVal);
		}
		else
		{
			var xmlDoc = this.xmlRoot.selectSingleNode("doc[@name='" + this.doc + "']");
			if (xmlDoc == null)
			{
				var parDoc = this.xmlDom.createElement("doc");
				parDoc.setAttribute("name",this.doc);
				this.xmlRoot.appendChild(parDoc);
				this.setPar(sPar,sVal);
			}
			else
			{
				if (this.nop == 0)
				{
					if (this.user != 0)
					{
						var xmlUser = xmlDoc.selectSingleNode("user[@id='" + this.user + "']");
						if ( xmlUser == null)
						{
							xmlUser = this.xmlDom.createElement("user");
							xmlUser.setAttribute("id",this.user);
							xmlDoc.appendChild(xmlUser);
						}
						xmlDoc = xmlUser;
					}
					var xmlPar = this.xmlDom.createElement("param");
					xmlPar.setAttribute("name",sPar);
					xmlDoc.appendChild(xmlPar);
				}
				else
				{
					var xmlNop = this.xmlDom.createElement("nop");
					xmlNop.setAttribute("num",this.nop);
					xmlDoc.appendChild(xmlNop);
				}
				this.setPar(sPar,sVal);
			}
		}
	}
}

function DpDocPar_createXMLDummy(sFile)
{
	var xmlDom = new DpXMLDOMDocument();
	var xmlRoot = xmlDom.createElement("Root");
	xmlDom.appendChild(xmlRoot);
	var xmlDoc = xmlDom.createElement("doc");
	xmlRoot.appendChild(xmlDoc);
	xmlDoc.setAttribute("name",this.doc);
	var xmlNop = xmlDom.createElement("nop");
	xmlDoc.appendChild(xmlNop);
	xmlNop.setAttribute("num",this.nop);
	xmlDom.save(this.sFile);
}

function DpDocPar_Edit()
{
		var oPar = new Object();
		oPar.doc = this.doc;
		oPar.nop = this.nop;
		oPar.parList = this.parList;
		oPar.docPar = this;
		showWindow("e_docPar.xml",SW_MODAL,oPar,"");
}