function DpFwidModer()
{
	this.arTbl = new Array();					//- тут лежат таблицы, содержащие поля СИД

	//this.fidTbl = "fidtable";
	this.path = "ALL_MDB";
	this.fidTblName = "FIDTABLE";
	
	this.sPoint = ".";
	if (SUBD == MSSQL)
		this.sPoint  = "..";
	
	this.fidTbl = getPath(this.path)+this.sPoint+this.fidTblName;
	this.InitArrTbl = DpFwidModer_InitArrTbl;
	this.getTname = DpFwidModer_getTname;
	this.FillFidMap = DpFwidModer_FillFidMap;
	this.ModTables = DpFwidModer_ModTables;
	this.ModTable = DpFwidModer_ModTable;
	this.doModForFields = DpFwidModer_doModForFields;
	this.Run  = DpFwidModer_Run;
	this.putLogMessage = DpFwidModer_putLogMessage;
	
	this.modTableByName = DpFwidModer_modTableByName;
	this.createFidTable = createFidTable;
	
	this.showErr = false;
	
	this.bTblArrFilled = false;
	this.bFidMapFilled = false;
}

function DpFwidModer_modTableByName(sTblName)
{
	if (!this.bTblArrFilled)
		this.InitArrTbl();
	if (!this.bFidMapFilled)
		this.FillFidMap();

	sTblName = String(sTblName).toUpperCase();
	for(var nTbl = 0; nTbl < this.arTbl.length; nTbl++)
	{
//-		trace(">>  " + this.arTbl[nTbl].tblName.toUpperCase() + " " + sTblName);
		if (this.arTbl[nTbl].tblName.toUpperCase() == sTblName)
		{
//-			trace(">> !!");
			this.ModTable(nTbl);
			return;
		}
	}
}

function DpFwidModer_putLogMessage(sMsg)
{
	trace("FwidModer:" + sMsg);
}

function DpFwidModer_Run(nStartID)
{
	this.putLogMessage("FM: Собирается информация о таблицах");
	this.InitArrTbl();	
	this.putLogMessage("FM: Создаётся таблица идентификаторов");
	this.FillFidMap(nStartID);
	this.putLogMessage("FM: Идёт замена идентификаторов");
	this.ModTables();
	this.putLogMessage("FM: Перекодировка завершена");
}

function DpFwidModer_ModTables()
{
	if (!this.bTblArrFilled)
		this.InitArrTbl();
	if (!this.bFidMapFilled)
		this.FillFidMap();
//-	var progress = createProgress(this.arTbl.length);
	for (var nTbl = 0; nTbl < this.arTbl.length; nTbl++)
	{
//-		progress.getProgressMonitor().worked(1);
//-		progress.getProgressMonitor().setTaskName("проход таблицы " + this.arTbl[nTbl].tblName);
		this.putLogMessage("FM: проход таблицы " + this.arTbl[nTbl].tblName);
		this.ModTable(nTbl);
	}
//-	progress.close();
}

function DpFwidModer_doModForFields(sTblName, sField, sRefFld)
{
	var isOk = true;
	if (SUBD == MSSQL)
		mssqlDropDefaultForField(sTblName, sField);
	BeginTransaction();
//-	добавим поле - fold_field
	this.putLogMessage("FW:		добавляем временное поле");
	var sSQL = "ALTER TABLE " + sTblName
			   + " ADD" + (SUBD==MYSQL || SUBD==POSTGRE?" COLUMN ":" ") 
			   + "FOLD_" + sField + " " + SqlType("TEXT",12);
	isOk = isOk && ExecuteSQL(sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("FW: ошибка замены ИД");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
		RollbackTrans();
	}
	else
		this.putLogMessage("FW:		Ok");
//-	сохраним старое значение
	this.putLogMessage("FW:		обновляем временное поле");
	sSQL = "UPDATE " + sTblName
		   + " SET FOLD_" + sField + "=" + sField;
	isOk = isOk && ExecuteSQL(sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("FW: ошибка замены ИД");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
		RollbackTrans();
	}
	else
		this.putLogMessage("FW:		Ok");
//- снесём и снова добавим новое поле с другим типом		
	if (SUBD != DERBY)
	{
		this.putLogMessage("FW:		удаляем старое поле");

		sSQL = "ALTER TABLE " + sTblName + " DROP COLUMN " + sField;
		isOk = isOk && ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка замены ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
			this.putLogMessage("FW:		Ok");
			
		this.putLogMessage("FW:		добавляем новое поле");
		sSQL = "ALTER TABLE " + sTblName
				   + " ADD" + (SUBD==MYSQL || SUBD==POSTGRE?" COLUMN ":" ")
				   + sField + " " + SqlType("LONG");
		isOk = isOk && ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка замены ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
			this.putLogMessage("FW:		Ok");
	}
	else
	{
		this.putLogMessage("FW: замена типа поля");
		var tbl = OpenTable("s","SELECT * FROM " + sTblName + " WHERE 1<>1");
		var nFld = tbl.fieldCount();
		var Fields = new Array();
		for (var i = 1; i < nFld + 1; i++)
		{
			Fields[i - 1] = tbl.getFieldInfo(i);
		}
		tbl.close();
		var sFields = "";
		var createFlds = "";
		for (var nFld = 0; nFld < Fields.length; nFld++)
		{
			if (String(Fields[nFld].getName()).toUpperCase()
				 == String(sField).toUpperCase())
			continue;
			sFields = sFields + (sFields==""?"":",") + Fields[nFld].getName();
			createFlds = createFlds + (createFlds==""?"":",") + Fields[nFld].getName()
				+ " " + Fields[nFld].getType();
		}
		ExecuteSQL("DROP TABLE " + String(sTblName) + "_OLD",false);
		var sSQL = "RENAME TABLE " + sTblName
				 + " TO " + String(sTblName).substr(sTblName.lastIndexOf(".") + 1)
				 + "_OLD";
		var isOk = ExecuteSQL(sSQL,false);
		if (!isOk)
		{
			this.putLogMessage("FW: Ошибка при переименовании таблицы");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
		{
			this.putLogMessage("FW: таблица переименована");
		}
		sSQL = "CREATE TABLE " + sTblName
			 + "(" + createFlds
			 + "," + sField + " " + SqlType("LONG") + ")";
		isOk = ExecuteSQL(sSQL,false);
		if (!isOk)
		{
			this.putLogMessage("FW: Ошибка при создании таблицы");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
		{
			this.putLogMessage("FW: таблица создана");
		}
		sSQL = "INSERT INTO " + sTblName
			 + "(" + sFields + ")"
			 + " SELECT " + sFields
			 + " FROM " + sTblName + "_OLD";
		isOk = ExecuteSQL(sSQL,false);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при перенесении данных");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
		{
			this.putLogMessage("FW: данные перенесены");
			ExecuteSQL("DROP TABLE " + String(sTblName) + "_OLD",false);
		}
	}
//- проапдейтим поле
	if (SUBD == DERBY)
	{
		/*sSQL = "UPDATE " + sTblName
			 + " SET " + sField + "=(SELECT MAX(FNID) FROM " + this.fidTbl
			 + " WHERE " + sTblName + ".FOLD_" + sField + "=FWID)"
			 + (sRefFld?", " + sRefFld + "=" + sField:"");*/
		sSQL = "UPDATE " + sTblName
			 + " SET " + sField + "="+IIF("FOLD_" + sField + "=''",0,
			 				"(SELECT MAX(FNID) FROM " + this.fidTbl
			 					+ " WHERE " + sTblName + ".FOLD_" + sField + "=FWID)")
			 + (sRefFld?", " + sRefFld + "=" + sField:"");
	}
	else if (SUBD != MSSQL)
	{
		if (SUBD == ORACLE)
			sSQL = "UPDATE " + sTblName + " a"
			   + " SET " + sField + "=(SELECT MAX(FNID) FROM " + this.fidTbl 
			   			    + " WHERE a.FOLD_" + sField + "=FWID)"
			   + (sRefFld?", " + sRefFld + "=" + sField:"");
		else
			sSQL = "UPDATE " + sTblName + " a"
			   + " SET " + sField + "="+IIF("FOLD_" + sField + "=''",0,
			   					"(SELECT MAX(FNID) FROM " + this.fidTbl 
			   			    		+ " WHERE a.FOLD_" + sField + "=FWID)")
			   + (sRefFld?", " + sRefFld + "=" + sField:"");
	}
	else
	{
	//-ExecuteSQL("update ^cl_ext set fnid=(SELECT MAX(b.FNID) FROM fidtable b where ^cl_ext.fwid=b.fwid)");
		sSQL = "UPDATE " + sTblName
			 + " SET " + sField + "="+IIF("FOLD_" + sField + "=''",0,
			 				"(SELECT MAX(FNID) FROM " + this.fidTbl + " b"
			 					+ " WHERE " + sTblName + "." + "FOLD_" + sField + "=b.FWID)")
			 + (sRefFld?", " + sTblName + "." + sRefFld + "=" + sTblName + "." + sField:"");
	}
	this.putLogMessage("FW:		обновляем новое поле");
	isOk = isOk && ExecuteSQL(sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("FW: ошибка замены ИД");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
		RollbackTrans();
	}
	else
		this.putLogMessage("FW:		Ok");
//- снесём ненужное поле
	this.putLogMessage("FW:		удаляем временное поле");
	if (SUBD != DERBY)
	{
		sSQL = "ALTER TABLE " + sTblName
			   + " DROP COLUMN FOLD_" + sField;
		isOk = isOk && ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка замены ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
			RollbackTrans();
		}
		else
		{
			this.putLogMessage("FW:		Ok");
			CommitTrans();
		}
	}
	return isOk;
}

function DpFwidModer_ModTable(iTbl)
{
	if (!this.bTblArrFilled)
		this.InitArrTbl();
	if (!this.bFidMapFilled)
		this.FillFidMap();

	var curTbl = this.arTbl[iTbl];
	this.putLogMessage("FW: замены в таблице " + this.arTbl[iTbl].tblName);
	if (curTbl.hasFwid)
	{
		if (curTbl.hasFnid)
			this.doModForFields(curTbl.tblName,"FWID","FNID");
		else
			this.doModForFields(curTbl.tblName,"FWID");
	}
	for (var nFld = 0; nFld < curTbl.refFields.length; nFld++)
	{
		this.doModForFields(curTbl.tblName,curTbl.refFields[nFld]);
	}
}

function DpFwidModer_getTname(sSystem,sTblName)
{
	return String((sSystem == ""?"":sSystem + "_") + sTblName).toUpperCase();
}

function createFidTable()
{
	DropTableEx(this.path,this.fidTblName);
	this.putLogMessage("FW: сбор таблицы ИД");
	if (SUBD == MYSQL)
	{
		var sSQL = "CREATE TABLE " + this.fidTbl
					+ "( FWID " + SqlType("TEXT",12)
					+ " ,FNID INT AUTO_INCREMENT PRIMARY KEY"
					+ ")";
		var isOk = ExecuteSQL(sSQL,this.showErr)
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе иаблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
		sSQL = "INSERT INTO " + this.fidTbl
				+ "(FWID,FNID) VALUES ("
				+ "'start_point'," + sqlTo(GetUID())
				+ ")";
		isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе иаблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
	}
	if (SUBD == MSSQL)
	{
		var sSQL = "CREATE TABLE " + this.fidTblName
					+ "( FWID " + SqlType("TEXT",12)
					+ " ,FNID NUMERIC IDENTITY(" + sqlTo(GetUID()) + ",1)"
					+ ")";
		var isOk = ExecuteSQLEx(this.path,sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе иаблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
		return;
	}
	if (SUBD == ORACLE)
	{
		sSQL = "CREATE TABLE " + this.fidTbl
					+ "( FWID " + SqlType("TEXT",12)
					+ " ,FNID " + SqlType("LONG")
					+ ")";
		var isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе иаблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
	}
	if (SUBD == DERBY || SUBD == POSTGRE)
	{
		sSQL = "CREATE TABLE " + this.fidTbl
					+ "( FWID " + SqlType("TEXT",12)
					+ " ,FNID " + SqlType("COUNTER")
					+ ")";
		var isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе иаблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		}
	}
	if(SUBD == MSSQL)
	{
		sSQL = "CREATE INDEX FWID ON "+this.fidTblName+" (FWID)";
		ExecuteSQLEx(this.path, sSQL, false);
	}
	else
	{
		if (SUBD == ORACLE || SUBD == DERBY || SUBD == POSTGRE)
		{
			ExecuteSQL("DROP INDEX I_" + this.fidTblName + "_FWID",false);
			ExecuteSQL("CREATE INDEX I_" + this.fidTblName + "_FWID ON " + this.fidTbl + "(FWID)");
		}
		else
		{
			if (SUBD == DB2)
			{
				ExecuteSQL("DROP INDEX " + sInd,false);
				ExecuteSQL("CREATE INDEX FWID ON "+this.fidTbl+" (FWID)", false);
			}
			else
			{
				ExecuteSQL("CREATE INDEX FWID ON "+this.fidTbl+" (FWID)", false);
			}
		}
	}
	//createIndex(this.fidTbl,"FWID","FWID");
}

function setUIDGenValue(nNewVal)
{
	include("objects\\DpDbMod.js");
	var dbm = new DpDbMod();
	dbm.CreateTUID();
	if (SUBD != ORACLE)
	{
		var sUIDSys = "UID";
		var sUIDPath = getPath(sUIDSys);
		if(!sUIDPath || sUIDPath=="")
			sUIDSys = "ALL_MDB";
		var sSQL = "UPDATE " + getPath(sUIDSys) + ((SUBD == MSSQL)?".":"") +".TUID"
				 + " SET FUID=" + sqlTo(nNewVal);
		ExecuteSQL(sSQL,this.showErr);
		return;
	}
	/*
	if (SUBD == MSSQL)
	{
		var sSQL = "UPDATE " + getPath("ALL_MDB") + "..UIDGEN"
				 + " SET FCOUNTER=" + sqlTo(nNewVal);
		ExecuteSQL(sSQL,this.showErr);
	}
	*/
}

function DpFwidModer_FillFidMap(nStartUId)
{
	if(!nStartUId)
		nStartUId = 1;
	//nStartUId = 200000001;
	
	if (SUBD == ORACLE)
	{
		sSQL = "SELECT SEQUENCE_NAME FROM ALL_SEQUENCES "
	                + " WHERE SEQUENCE_OWNER = '" + String(getPath("ALL_MDB")).toUpperCase() + "' "
	                + " AND SEQUENCE_NAME='SEQ_UID'";
	    var tbl = OpenTable("s",sSQL);
	    if (tbl.isEmpty())
	    {
	    	var bRet = ExecuteSQL("CREATE SEQUENCE " + getPath("ALL_MDB") + ".SEQ_UID INCREMENT BY 1 START WITH "+ nStartUId);
	    	if (!bRet)
	    		return false;
	    }
	   
	}


	//-1. создать таблицу fidtable с автоинкрементовым полем FNID
	//-1.1 задать начальное значение для автоинкремента	
	this.createFidTable();
	
	var sSQL = "INSERT INTO " + this.fidTbl + "(FWID)"
						 + " SELECT DISTINCT FIDDEAL  FROM ^DOCREG ";						 
	
	var isOk = ExecuteSQL(sSQL,this.showErr);
	if (!isOk)
	{
		this.putLogMessage("FW: ошибка при сборе таблицы ИД");
		this.putLogMessage(sSQL);
		this.putLogMessage(lpProxy.getLastDBErrorMessage());
	} 
	else if (SUBD == ORACLE)
	{
		sSQL = "UPDATE " + this.fidTbl
						 + " SET FNID = " + getPath("ALL_MDB") + ".SEQ_UID.Nextval ";
		isOk = ExecuteSQL(sSQL,this.showErr);
		if (!isOk)
		{
			this.putLogMessage("FW: ошибка при сборе таблицы ИД");
			this.putLogMessage(sSQL);
			this.putLogMessage(lpProxy.getLastDBErrorMessage());
		} 						 
	}
	
	//-2. пройтись по всем таблицам
//-	var progress = createProgress(this.arTbl.length);
	this.putLogMessage("FW: ------------- сбор таблицы ИД ---------");
	for(var nTbl = 0; nTbl < this.arTbl.length; nTbl++)
	{
//-		progress.getProgressMonitor().worked(1);
//-		progress.getProgressMonitor().setTaskName("проход таблицы " + this.arTbl[nTbl].tblName);
		this.putLogMessage("FW:		проход таблицы " + this.arTbl[nTbl].tblName);
		var curTbl = this.arTbl[nTbl];
		
		//-	3.проапдейтить FWID, если есть ФНИД и ФВИД нулевой
		if (curTbl.hasFwid && curTbl.hasFnid)
		{
			var sSQL = "UPDATE " + curTbl.tblName
					 + " SET FWID=" + Convert("FNID","NVC",12)
					 + " WHERE "
					 + " FNID<>0 "
					 + " AND FNID IS NOT NULL "
					 + " AND ( FWID='' OR FWID IS NULL OR FWID='0')";
			var isOk = ExecuteSQL(sSQL,this.showErr);
			if (!isOk)
			{
				this.putLogMessage("FW: ошибка при сборе таблицы ИД");
				this.putLogMessage(sSQL);
				this.putLogMessage(lpProxy.getLastDBErrorMessage());
			}
		}
		//-	4.заинсертить в fidtable FWID
		if (curTbl.hasFwid && !curTbl.isExtTable)
		{
			if (SUBD != ORACLE)
			{
				var sSQL = "INSERT INTO " + this.fidTbl + "(FWID)"
						 + " SELECT FWID FROM " + curTbl.tblName;
				var isOk = ExecuteSQL(sSQL,this.showErr);
				if (!isOk)
				{
					this.putLogMessage("FW: ошибка при сборе таблицы ИД");
					this.putLogMessage(sSQL);
					this.putLogMessage(lpProxy.getLastDBErrorMessage());
				}
			}
			else
			{
				var sSQL = "INSERT INTO " + this.fidTbl
						 + " SELECT FWID," + getPath("ALL_MDB") + ".SEQ_UID.Nextval "
						 + " FROM " + curTbl.tblName;
				var isOk = ExecuteSQL(sSQL,this.showErr);
				if (!isOk)
				{
					this.putLogMessage("FW: ошибка при сборе таблицы ИД");
					this.putLogMessage(sSQL);
					this.putLogMessage(lpProxy.getLastDBErrorMessage());
				}
			}
		}
/*		
		//- 4.1 проапдейтить fidtable для уже существующих ФНИДОВ
		if (curTbl.hasFwid && curTbl.hasFnid)
		{
			var sSQL = "SELECT FWID FROM " + curTbl.tblName
					 + " WHERE FNID<>0 AND FNID IS NOT NULL";
					 
			sSQL = "UPDATE " + this.fidTbl + " ftbl "
					 + " SET FNID="
					 + "(SELECT FNID "
					 + " FROM " + curTbl.tblName + " ctbl "
					 + " WHERE ftbl.FWID=ctbl.FWID"
					 + ")"
					 + " WHERE ftbl.FWID IN (" + sSQL + ")";
			
			ExecuteSQL(sSQL,this.showErr);
		}
*/
	}
	//-5. установить значение для получалки ФНИДОВ
	if (SUBD != ORACLE)
	{
		var oSnap = getSnap("SELECT max(FNID) FROM " + this.fidTbl);
		var nVal = Number(oSnap[0]) + 1;
		setUIDGenValue(nVal);
	}
	this.bFidMapFilled = true;
//-	progress.close();
	this.putLogMessage("FW:		OK");
}

function DpFwidModer_FillFidMap1()
{
	DropTableEx(this.path,this.fidTblName);
	if (SUBD == MSSQL)
		ExecuteSQLEx(this.path,"CREATE TABLE " + this.fidTblName
			   + "( FWID " + SqlType("TEXT",12)
			   + " ,FNID" + SqlType("LONG")
			   + ")",this.showErr);
	else
		ExecuteSQL("CREATE TABLE " + this.fidTbl
			   + "( FWID " + SqlType("TEXT",12)
			   + " ,FNID" + SqlType("LONG")
			   + ")",this.showErr);
	var progress = createProgress(this.arTbl.length);
	for(var nTbl = 0; nTbl < this.arTbl.length; nTbl++)
	{
		progress.getProgressMonitor().worked(1);
		progress.getProgressMonitor().setTaskName("проход таблицы " + this.arTbl[nTbl].tblName);
		if (!this.arTbl[nTbl].hasFwid)
			continue;
		this.putLogMessage("проход таблицы " + this.arTbl[nTbl].tblName);
		var tbl = OpenTable("s","SELECT Fwid" + (this.arTbl[nTbl].hasFnid?",Fnid":"")
							+ " FROM " + this.arTbl[nTbl].tblName);
		for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		{
			var fwid = tbl.getValue("Fwid");
			if ((!fwid) || fwid == null || fwid == '' || fwid == 0 || fwid == "0")
			{
				if (this.arTbl[nTbl].hasFnid)
				{
					fwid = tbl.getValue("Fnid");
					if ((!fwid) || fwid == null || fwid == '' || fwid == 0 || fwid == "0")
						continue;
					else
					{
						ExecuteSQL("UPDATE " + this.arTbl[nTbl].tblName + " SET FWID=" + sqlTo(String(fwid)),this.showErr);
					}
				}
				else
					continue;
			}
			fwid = String(fwid);
			var fnid = null;
			if (this.arTbl[nTbl].hasFnid)
			{
				fnid = tbl.getValue("Fnid");
			}
			if (!fnid || fnid == null || fnid == 0)
				fnid = GetNID();
			var oSnap = getSnap("SELECT FNID FROM " + this.fidTbl 
								+ " WHERE FWID=" + sqlTo(fwid));
			var sSQL = "";
			if (oSnap == null)
			{
				sSQL = "INSERT INTO " + this.fidTbl
					   + " VALUES(" + sqlTo(fwid) + "," + sqlTo(fnid) + ")";
			}
			else
			{
				sSQL = "UPDATE " + this.fidTbl
					   + " SET FNID=" + sqlTo(fnid)
					   + " WHERE FWID=" + sqlTo(fwid);
			}
			ExecuteSQL(sSQL,this.showErr);
		}
		tbl.Close();
	}
	this.bFidMapFilled = true;
	progress.close();
}

function DpFwidModer_InitArrTbl()
{
	var tables = getStruTables();	
//-	пройдёмся по струшным таблицам и соберём свой мэп
//- таблиц, содержащих СИД - поля	
	for (var nTbl = 0; nTbl < tables.length; nTbl++)
	{
		var base = tables[nTbl].base;
		var database = getPath(base);
		if (!database || database == null)
			continue;
		var tblName = this.getTname(tables[nTbl].sys,tables[nTbl].table);
		this.putLogMessage("FW: анализ таблицы " + tblName);
		
		if (! IsTableEx(base,tblName) && tblName.indexOf("%") == -1)
			continue;
		var fullName = String(database) + this.sPoint + String(tblName);
		var newTbl = new TableInfo();
		if (inList(tblName.toUpperCase(),"COM_EXT", "MTR_EXT_NMK", "COM_EXT_CL"))
			newTbl.isExtTable = true;
		newTbl.tblName = fullName;
		var fieldInfos = getStruFields(tables[nTbl].table);
//-	пройдёмся по стру-полям таблицы	
	    if (fieldInfos == null)
	    	continue;
		if (newTbl.tblName.indexOf("%") == -1)
		{
			testTbl(newTbl,fieldInfos);
			if (newTbl.hasFwid == false && newTbl.refFields.length == 0)
				continue;
			else	
			{
				if (SUBD == MSSQL)
				{
					dropIndexesMSSQL(newTbl.tblName);
				}
				this.arTbl.push(newTbl);
			}
		}
		else
		{
			var pattern = tblName.substring(0,tblName.indexOf("%")) + "%";
			var tablesEx = getTablesForPattern(database,pattern);
			for (var nTblEx = 0; nTblEx < tablesEx.length; nTblEx++)
			{
				if (!IsTableEx(base,tablesEx[nTblEx]))
					continue;
				var newTblEx = new TableInfo();
				newTblEx.tblName = database + this.sPoint + tablesEx[nTblEx];
				this.putLogMessage("FW: анализ таблицы " + newTblEx.tblName);
				testTbl(newTblEx,fieldInfos);
				if (newTblEx.hasFwid == false && newTblEx.refFields.length == 0)
				{
					continue;
				}
				else
				{	
					if (SUBD == MSSQL)
					{					
						dropIndexesMSSQL(newTblEx.tblName);
					}
					this.arTbl.push(newTblEx);					
				}
			}
		}
	}
	this.bTblArrFilled = true;
}

function dropIndexesMSSQL(sTable)
{
	var sTable = String(sTable);
	var n = sTable.indexOf("..");
	if (n == -1) return;
	var sBase = sTable.substr(0, n);
	sTable = sTable.substr(n + 2);
	var indexes = getIndexes(sBase, sTable);
	if (indexes != null)
	{
		var sUserName = getUserName();
		ExecuteSQL("use " + sBase, false);
		for (var i = 0; i < indexes.length; i++ )
		{			
			var idx = String(indexes[i]);
			ExecuteSQL(" drop index " + sTable + "." + idx , false);			
		}
		
		ExecuteSQL("use " + sUserName);
	}	
	
}
function testTbl(oTI,fieldInfos)
{
	for (var nFld = 0; nFld < fieldInfos.length; nFld++)
	{
		var FI = fieldInfos[nFld];
		var name = String(FI.getName()).toUpperCase();
		var type = String(FI.getDpType()).toUpperCase();
		if (name == "FWID" && (type == "CID" || type == "TEXT(12)"))
		{
			oTI.hasFwid = true && lpProxy.getDBManager().testSQL("SELECT FWID FROM " + oTI.tblName + " WHERE 1<>1");
			trace ("tbl " + oTI.tblName + " do not have fwid");
			continue;
		}
		if (name == "FNID")
		{
			oTI.hasFnid = true && lpProxy.getDBManager().testSQL("SELECT FNID FROM " + oTI.tblName + " WHERE 1<>1");
			continue;
		}
		if (type == "CID")
		{
			if (lpProxy.getDBManager().testSQL("SELECT " + name + " FROM " + oTI.tblName + " WHERE 1<>1"))
				oTI.refFields.push(name);
		}
	}
	
/*	if (oTI.hasFwid == false)
		oTI.hasFwid = ExecuteSQL("SELECT FWID FROM " + oTI.tblName + " WHERE 1<>1",false);
	if (oTI.hasFnid == false)
		oTI.hasFnid = ExecuteSQL("SELECT FNID FROM " + oTI.tblName + " WHERE 1<>1",false);
*/
}

function TableInfo()
{
	this.tblName = "";
	this.hasFwid = false;
	this.hasFnid = false;
	this.isExtTable = false;
	this.refFields = new Array();
	return this;
}

function createProgress(nLength)
{
	var progress = new Packages.org.eclipse.jface.dialogs.ProgressMonitorDialog(Packages.org.eclipse.swt.widgets.Display.getCurrent().getActiveShell());
    progress.open();
    progress.getShell().setText("Сбор карты идентификаторов...");
    progress.getProgressMonitor().beginTask("", nLength);
    return progress;
}