/*
	Класс DpGetDat
	(c) ДЕБЕТ Плюс, 1998-1999
*/

include("GetParam.js")

function DpGetDat(mode, combo)
{
	RO("DpGetDat", this);
	this.mode = mode;
	this.combo = combo;
	this.aExtraCtrls = new Array();	//массив дополнительных контролов; по образу DpAskEx
	this.add = DpGetDat_add;

	this.initGetDatParam = null;
	if(typeof listInitGetDatParam=="function")
		this.initGetDatParam = listInitGetDatParam;
	if (this.initGetDatParam)
		this.initGetDatParam(this);

	// Заглушка для определения размеров окна
	var w, h;
	w = 300;
	h = 300;
	this.sysname=getSysName();
	this.sysname=this.sysname.substring(this.sysname.lastIndexOf('|')+1, this.sysname.length);
	
	//isdat1=((extPar.mode.indexOf('d')>-1) && (!getParSysOne("NODATE", false) || isEmpty(extPar.dat1=getParSysOne("GLOBDAT1", d00))));
	
	var bIsDat = 
		(typeof(mode)=="string")?(mode.search(/[^dD]/)!=-1):!(mode.length==1 && mode[0]=="r"); 
	this.escape = false;
	if (!getParSysOne("NODATE", false) || bIsDat ||
		 (isEmpty(this.dat1=getParSysOne("GLOBDAT1", d00))) ||
		 (isEmpty(this.dat2=getParSysOne("GLOBDAT2", d00))) 
		)
	{
		this.escape = null;
		showWindow( "getdatr.xml", "XMLDLG", this);
	}
	
		
	if(this.escape==null)
		this.escape = true;
	
	// Перевод счета в объект счет
	if(this.fsc!=null && typeof(DpSc)=="function")
	{
		/*
			добавлено закрытие таблицы, т.к. она не закрывалась
		*/
		
		if(this.sc){
			this.sc.tblCl_schet=null;
			this.sc=null;
		}
		if(this.fcl3!=null)
			this.sc = new DpSc(this.fsc, this.fsu, this.fst,/* this.fst2, this.fst3, this.fst4,*/
				this.fcl1, this.fcl2, this.fcl3);
		else if(this.fcl1!=null)
			this.sc = new DpSc(this.fsc, this.fsu, this.fst,/* this.fst2, this.fst3, this.fst4,*/
				this.fcl1);
		else
			this.sc = new DpSc(this.fsc, this.fsu, this.fst /*, this.fst2, this.fst3, this.fst4*/);
	}
}

/**
	SAM 14.02.2012
	возможность расширить имеющийся функционал DpGetDat
	функционалом DpAskEx

	Пример использования:
	в рабочем файле, где используется DpGetDat
	что-то типа такого 
		gd = new DpGetDat(new Array("b","r","T0","N0","p0","m0","s:c0ut","o0","tdnop0","v0"),arrVariants);
	добавляем ф-ию listInitGetDatParam(), в которой добавляем все нужные параметры по образу и подобию DpAskEx

	function listInitGetDatParam()
	{
		this.add("RADIO","test","TEST",0,"Вариант 1|Вариант 2|Вариант 3");
	}

	Подробное описание параметров метода add см. в DpAskEx
*/
function DpGetDat_add(mode, descr, name, defVal, par1, par2, par3)
{
	mode = mode.toUpperCase();
	
	// создаем объект, который будет владеть всем, что касается добавляемого
	// элемента, и добавляем его в массив
	var obj = {
		mode:mode
		,descr:descr
		,rname:name
		,name:"gd_"+name
		,defVal:defVal
		,par1:par1
		,par2:par2
		,par3:par3
		// выделим из режима тип - удалим нули, точки и минусы
		,type:String(mode).replace(/-|0|\./gi, "").toUpperCase()
	}
	this.aExtraCtrls[this.aExtraCtrls.length] = obj;	//массив дополнительных контролов
	
	return true;
}