/* Объект для работы с Grid'ом */
//include("objects\\DpXmlGrid.js");
function DpGrid(mode, objGrid)
{
	RO("DpGrid", this);
	this.mode = String(mode);
	this.aPages = new Array();
	this.oConditions = new Object();
	this.oColors = new Object();
	this.oBgColors = new Object();
	this.oBolds = new Object();
	this.oConds = new DpCondGroup();
			
	include("sys\\ListApi.js");

	if(!strIn(mode, "NOCREATE"))
		__CreateGrid();
	
	if("object"==typeof(objGrid))
		this.objGrid = objGrid;
	else
		if("object"==typeof(grid))
			this.objGrid = grid;

	this.isOnePageMode = true;
	this.isInPlaceEdition = false;

	if (false)
	{
		this.oConditions["FISDEL#_"] = "=^fisdel#_=1";
		this.oColors["FISDEL#_"] = 9;
		this.oBgColors["FISDEL#_"] = 1;
		this.oBolds["FISDEL#_"] = true;
	}
	if (this.objGrid && this.objGrid.getViewerID() == "")
		this.objGrid.setViewerID(Task.getTaskName());
}

DpGrid.prototype.page = DpGrid_page;
DpGrid.prototype.build = DpGrid_build;
DpGrid.prototype.defCond = DpGrid_defCond;
DpGrid.prototype.color = DpGrid_color;
DpGrid.prototype.bgcolor = DpGrid_bgcolor;
DpGrid.prototype.bold = DpGrid_bold;
DpGrid.prototype._showRow = DpGrid__showRow;
DpGrid.prototype.setViewerID = DpGrid_setViewerID;
DpGrid.prototype.setFinderID = DpGrid_setFinderID;
DpGrid.prototype.setTable = DpGrid_setTable;
DpGrid.prototype.loadExt = DpGrid_loadExt;
DpGrid.prototype.getDS = DpGrid_getDS;
DpGrid.prototype.getTable = DpGrid_getTable;
DpGrid.prototype.prefix = DpGrid_prefix;
DpGrid.prototype.addObject = DpGrid_addObject;
DpGrid.prototype.onePageMode = DpGrid_onePageMode;
DpGrid.prototype.filing = DpGrid_filing;
DpGrid.prototype.inPlaceEdition = DpGrid_inPlaceEdition;
DpGrid.prototype.conds = DpGrid_conds;
DpGrid.prototype.storeAsXML = DpGrid_storeAsXML;
DpGrid.prototype.loadFromXML = DpGrid_loadFromXML;
DpGrid.prototype.buildFromXML = DpGrid_buildFromXML;
DpGrid.prototype.setColorField = DpGrid_setColorField;
DpGrid.prototype.setBoldField = DpGrid_setBoldField;
DpGrid.prototype.setXMLFile = DpGrid_setXMLFile;
DpGrid.prototype.DeletePages = DpGrid_DeletePages;
DpGrid.prototype.setFixColCount = DpGrid_setFixColCount;

function DpGrid_DeletePages()
{
	this.objGrid.DeletePages();
}
// Добавить страницу в Grid
function DpGrid_page(cCaption, toSave)
{
	var oPage = new Object()
	oPage.cCaption = cCaption;
	oPage.toSave = toSave;
	oPage.oGroup = new DpGridGroup(this.objGrid);
	this.aPages[this.aPages.length] = oPage;
	return oPage.oGroup;
}

function DpGrid_setFixColCount(nCol)
{
	this.objGrid.setFixColCount(java.lang.Integer(nCol));
}

function DpGrid_setColorField(sField)
{
	if (sField)
		this.objGrid.setColorField(sField);
}

function DpGrid_setBoldField(sField)
{
	if (sField)
		this.objGrid.setBoldField(sField);
}

function DpGrid_setXMLFile(sFile)
{
	if (sFile)
		this.objGrid.setXMLFile(sFile);
}

function DpGrid_build()
{
	// replace tie fields with static ones if exists
	var cols = this.objGrid.getColumnsArray();
	for (var i = 0; i < cols.length; i++)
	{
		var sField = String(cols[i].getField());
		if (sField.indexOf(".") != -1)
		{
			sField = String(sField.replace(".", "_"));
			if (this.objGrid.getTable().isField(sField))
				cols[i].setField(sField);
		}
	}

	this.objGrid.build();
	return;
	var iPage, oPage, iCell, oCell, h;
	
	//if(this.cFilingExpr)
	//	this.objGrid.filing(this.cFilingExpr);
	this.objGrid.setInPlaceEdition(this.isInPlaceEdition);
	
	this.nHeaderHeight = 0;
	if(this.oPrefix)
		this.nHeaderHeight = this.oPrefix.getHeaderHeight();
	for(iPage=0; iPage<this.aPages.length; iPage++)
	{
		oPage = this.aPages[iPage];
		this.nHeaderHeight = Math.max(this.nHeaderHeight
				, oPage.oGroup.getHeaderHeight());
		
	}
	//
	//	Sergey: только так, сначала DataSource
	//		потом поля, иначе полетят списки
	//
	this.dataSource = grid;
	/*
	if(""==this.objGrid.name)
		this.dataSource = DataSource(this.viewerID);
	else
		this.dataSource = DataSource(this.viewerID, this.objGrid.name);
		*/
	var oConds;	
	if(!this.isOnePageMode)
	{
		// Выберем все условия, встречающиеся во всех страницах
		var oConds = new Object();
		oConds[""] = true;
		for(iPage=0; iPage<this.aPages.length; iPage++)
		{
			oPage = this.aPages[iPage];
		
			oPage.oGroup.getCondList(oConds);
			for(var cond in this.oColors)
				oConds[cond] = true;
			for(var cond in this.oBgColors)
				oConds[cond] = true;
			for(var cond in this.oBolds)
				oConds[cond] = true;
		}
	}
	
	for(iPage=0; iPage<this.aPages.length; iPage++)
	{
		oPage = this.aPages[iPage];
		//var page = this.objGrid.Page(oPage.toSave);
		//if(oPage.cCaption)
		//	page.Uho = UR(oPage.cCaption);
		
		if(this.isOnePageMode)
		{
			// Выберем все условия, встречающиеся в данной странице
			var oConds = new Object();
			oConds[""] = true;
			oPage.oGroup.getCondList(oConds);
			for(var cond in this.oColors)
				oConds[cond] = true;
			for(var cond in this.oBgColors)
				oConds[cond] = true;
			for(var cond in this.oBolds)
				oConds[cond] = true;
		}
		
		//var aConds = this.oConds.getConds();
		
		for(var cond in this.oConditions)
			grid.defCond(cond,this.oConditions[cond])
		
		for(var color in this.oColors)
			grid.color(this.oColors[color],color)
			
		for(var bold in this.oBolds)
			grid.bold(bold)
			
		
		
		//for(var cond in oConds)
		this._showRow(iPage, cond, this.oColors[cond], this.oBolds[cond], this.oBgColors[cond]);
		
		/*
		this._showRow(iPage);
		for(var cColCond in this.oColors)
			this._showRow(iPage, this.oConditions[cColCond]
				, this.oColors[cColCond]);
		*/
	}
	
	//this.dataSource.grid = this.objGrid;
		
	if(this.tbl)
		this.dataSource.setTable(this.tbl);
	else if(!strIn(this.mode, "NOCREATE"))
		debug("Установите таблицу методом .setTable() до вызова метода .build()")

//	this.dataSource.grid = this.objGrid;

	this.objGrid.onePageMode(this.isOnePageMode);
	grid.build();
	
}

function DpGrid__showRow(iPage, condRow, color, bold, bgcolor)
{
	
	
	//var row = this.objGrid.Row(this.oConditions[condRow]);
	var oPage = this.aPages[iPage];
	/*
	if(color)
		row.TextColor(colorLevel(color));
		
	if(bgcolor)
		row.SetColors(bgcolor);
		
	if(typeof bold=="boolean" && bold)
		row.FontBold();
	*/
	if(this.oPrefix && oPage.oGroup.oProperties["NOPREFIX"]!==true)
		this.oPrefix.buildRow(this.nHeaderHeight, this.nHeaderHeight, condRow);
	
	oPage.oGroup.buildRow(this.nHeaderHeight, this.nHeaderHeight, condRow);
	for(var iRow=this.nHeaderHeight-1; iRow>=1; iRow--)
	{
		//this.objGrid.HeaderRow(this.oConditions[condRow]);
		if(this.oPrefix && oPage.oGroup.oProperties["NOPREFIX"]!==true)
			this.oPrefix.buildRow(iRow, this.nHeaderHeight, condRow);
		oPage.oGroup.buildRow(iRow, this.nHeaderHeight, condRow);
	}
	//return row;
}

function DpGrid_defCond(cond, alias)
{
	if(!alias)
		alias = cond;
//-	this.oConditions[alias] = cond;
	this.objGrid.defCond(alias,cond);
}

// Задать цвет для строки по условию.
// Цвет задается номером, который будет переведен ф-й colorLevel
function DpGrid_color(color, cond)
{
/*
	if(!this.oConditions[cond])
		debug("Условие должно быть объявлено методом defCond");
	else
		this.oColors[cond] = color;
*/
	this.objGrid.color(color,cond);
}

function DpGrid_bgcolor(bgcolor, cond)
{
	if(!this.oConditions[cond])
		debug("Условие должно быть объявлено методом defCond");
	else
		this.oBgColors[cond] = bgcolor;
}

function DpGrid_bold(cond, isBold)
{
	this.objGrid.bold(cond);
	//this.oBolds[cond] = typeof(isBold)=="undefined"? true: false;
}

function DpGrid_setTable(tbl)
{
	if(this.dataSource)
		this.dataSource.setTable(tbl);
	else
		this.tbl = tbl;
}

function DpGrid_setViewerID(viewerID)
{
//-	this.viewerID = viewerID;
	this.objGrid.setViewerID(viewerID);
}

function DpGrid_getDS()
{
	return this.dataSource;
}

function DpGrid_getTable()
{
	if(this.dataSource)
		return this.dataSource.getTable();
	else
		return this.tbl;
}

function DpGrid_setFinderID(finderID)
{
	this.getDS().finderID = finderID;
}

function DpGrid_loadExt(pExt, szAlias, szTitle)
{
	//LoadExt2Grid(grid,pExt);
	if(!pExt)
		return;
		
	var pTbl;
	if(typeof pExt.GetTie!="undefined")
	{
		pTbl = pExt;
		pExt = pTbl.GetTie(szAlias? szAlias: "#");
	}
		
	szTitle = szTitle? szTitle: ru("Расширения", "Розширення");
	szAlias = szAlias? szAlias + ".": "#";
	
//-	pExt.topField();
	var nEflds = pExt.fieldCount();
	var nCurFld = 0;
	var oFis = pExt.getFieldsInfo();
//-	if(pExt.IsField())
	if (nEflds > 0)
		var oPage= this.page(szTitle, false);

//-	while(pExt.IsField())
	while (nCurFld < nEflds)
	{
//-		var oFI = pExt.getFieldInfo(nCurFld);
		var oFI = oFis[nCurFld];
		var iWdt = oFI.E_Width;
		if(iWdt<2)
			iWdt = 10;
		var cDate = oFI.E_Date;
		if(cDate)
			cDate = " от " + cDate
		
		var cExpr = szAlias + oFI.E_Label;
		var cType = oFI.getType();
		if(pTbl && cType.charAt(0)=="A")
		{
			var cTieAlias = "x" + oFI.E_Label;
			if (SQL)
			{
				pTbl.Tie("clrelclcl", cTieAlias + "_rel"
//-					, "FCL,FCOD"
					, "CLCOD"
					, "=" + cType.substr(1)
//-						+ ", " + szAlias + pExt.GetInfo("NAME")
						+ ", " + szAlias + oFI.E_Label
					);
			}
			pTbl.Tie("cl", cTieAlias, "fwid"
				, cTieAlias + "_rel.fwid_cl");
//-			cExpr = "=CStr(^" + cExpr + ") + \": \"+ ^" + cTieAlias + ".ftxt";
			cExpr = "=String(^" + cExpr + ") + ':' + ^" + cTieAlias + ".ftxt";
			iWdt += 15;
		}

//-		oPage.cell(cExpr
//-				, pExt.GetInfo("TXT") + cDate
//-				, iWdt, null
//-				, pExt.GetInfo("FORMAT")
//-				);
		
		oPage.cell(cExpr
				   , oFI.E_FieldText
				   , iWdt, null
				   , oFI.E_Format
				   );
				
		// Если для расширения установлен атрибут "Выводить на первой странице" - выводим его на первую страницу
//-		if(pExt.GetInfo("ISFIRSTPAGE")=="+")
//-			this.aPages[0].oGroup.cell(cExpr
//-				, pExt.GetInfo("TXT") + cDate
//-				, iWdt, null
//-				, pExt.GetInfo("FORMAT")
//-				);
		
//-		pExt.NextField();
		nCurFld++;
	}
}

function DpGrid_prefix()
{
	this.oPrefix = new DpGridGroup(this.objGrid);
	return this.oPrefix;
}

function DpGrid_addObject(obj, alias)
{
	this.objGrid.addObject(obj, alias);
}

function DpGrid_onePageMode(is)
{
	this.isOnePageMode = is;
}

function DpGrid_filing(cExpr)
{
	this.cFilingExpr = cExpr;
}

function DpGrid_inPlaceEdition(is)
{
	this.isInPlaceEdition = is;
}

function DpGrid_conds()
{
	return this.oConds;
}

//------------------------------------------
// Описание объекта группы

function DpGridGroup(objGrid)
{
	this.aSubGroups = new Array();
	this.aAlternates = new Array();
	this.oProperties = new Object();
	this.oCells = new Array();

	if("object"==typeof(objGrid))
		this.objGrid = objGrid;
	else
		if("object"==typeof(grid))
			this.objGrid = grid;
}
DpGridGroup.prototype.setCaption = DpGridGroup_setCaption;

DpGridGroup.prototype.cell = DpGridGroup_cell;
DpGridGroup.prototype.FieldEx = DpGridGroup_cell;
DpGridGroup.prototype.fieldEx = DpGridGroup_cell;
DpGridGroup.prototype.fieldex = DpGridGroup_cell;

DpGridGroup.prototype.group = DpGridGroup_group;
DpGridGroup.prototype.getHeaderHeight = DpGridGroup_getHeaderHeight;
DpGridGroup.prototype.getCondList = DpGridGroup_getCondList
DpGridGroup.prototype.buildRow = DpGridGroup_buildRow;
DpGridGroup.prototype.alternate = DpGridGroup_alternate;
DpGridGroup.prototype.getWidth = DpGridGroup_getWidth;
DpGridGroup.prototype.setProperties = DpGridGroup_setProperties;
DpGridGroup.prototype.getColCount = DpGridGroup_getColCount;
DpGridGroup.prototype.subCaption = DpGridGroup_subCaption;
DpGridGroup.prototype.textColor = DpGridGroup_textColor;

// Установить заголовок группы
function DpGridGroup_setCaption(cCaption)
{
	// Вместо \n можно использовать !
	cCaption = cCaption.replace(/!/g, "\n"); 
	var divPos = cCaption.indexOf("|");
	this.sFullCaption = cCaption;
	if(divPos!=-1 && cCaption.indexOf("\n")!=-1)
	{
		var aUCaption = cCaption.substr(0, divPos).split("\n");
		var aRCaption = cCaption.substr(divPos+1).split("\n");
		var l = Math.max(aUCaption.length, aRCaption.length);
		this.aCaption = new Array(l);
		for(var i=0; i<l; i++)
			this.aCaption[i] = (aUCaption[i]? aUCaption[i]: "")
				+ "|" + (aRCaption[i]? aRCaption[i]: "");
	}
	else 
		this.aCaption = cCaption.split("\n");
}

// добавить новую группу
function DpGridGroup_group(cCaption,nRowCount)
{
	var oNewGroup = new DpGridGroup(this.objGrid);
	if(cCaption)
	{
		oNewGroup.setCaption(cCaption);
		oNewGroup.objGroup = this.objGrid.addGroup(UR(cCaption));
		if (this.objGroup)
			this.objGroup.addGroup(oNewGroup.objGroup);
		if (nRowCount)
			oNewGroup.objGroup.setRowCount(nRowCount);
	}
	this.aSubGroups[this.aSubGroups.length] = oNewGroup;
	return oNewGroup;
}

// Добавить новую ячейку в группу
function DpGridGroup_cell(cField, cCaption, nWidth, cAttr, cFormat, sRowSpan, sDpObject, sDpObjField, cAggregate)
{
/*	var oGroup = this.group(cCaption);
	oGroup.oCell = new Object;
	oGroup.oCell.cField = cField;
	oGroup.oCell.nWidth = nWidth;
	oGroup.oCell.cAttr = cAttr;
	oGroup.oCell.cFormat = cFormat;
	return oGroup;
*/
/*	var oCell = new Object();
	oCell.cCaption = UR(cCaption);
	oCell.cField = cField;
	oCell.nWidth = nWidth;
	oCell.cAttr = cAttr;
	oCell.cFormat = cFormat;
	this.oCells.push(oCell);
	return oCell;
*/
	var Attr = (cAttr?cAttr:"");
	var Format = (cFormat?cFormat:"");
	var Aggregate = (cAggregate?cAggregate:"");

	var RowSpan = "";
	if (typeof(sRowSpan) == "string")
		RowSpan = sRowSpan;
	if(!sDpObject)
		sDpObject = "";
	if(!sDpObjField)
		sDpObjField = "";
	var nField = this.objGrid.FieldEx(cField,cCaption,nWidth,Attr,Format,RowSpan, sDpObject, sDpObjField, Aggregate);
	var oCell = new Object();
	oCell.field = cField;
	oCell.caption = cCaption;
	oCell.width = nWidth;
	oCell.attr = Attr;
	oCell.format = Format;
	oCell.RowSpan = RowSpan;
	this.oCells[this.oCells.length] = oCell;
	if (this.objGroup)
	{
		this.objGroup.addField(nField);
	}
	return nField;
}

// Установить указанной группу альтернативную группу (по условию)
function DpGridGroup_alternate(cond)
{
	var oAlternate = new Object();
	this.aAlternates[this.aAlternates.length] = oAlternate;
	oAlternate.cond = cond;
	oAlternate.oGroup = new DpGridGroup(this.objGrid);
	return oAlternate.oGroup;
}

// Установить подзаголовок для ячейки (выводится ПОД названием ячейки)
// На сегодня возможен только однострочный подзаголовок
function DpGridGroup_subCaption(cSubCaption)
{
	this.cSubCaption = cSubCaption;
}

// Возвращает высоту шапки, требуемой для указанной группы
function DpGridGroup_getHeaderHeight()
{
	var h = 0;
	for(var i=0; i<this.aSubGroups.length; i++)
		h = Math.max(h, this.aSubGroups[i].getHeaderHeight());
		
	for(i=0; i<this.aAlternates.length; i++)
		h = Math.max(h, this.aAlternates[i].oGroup.getHeaderHeight());
	
	if(this.aCaption)
		h += this.aCaption.length;

	if(this.cSubCaption)
		h++;
		
	return h;
}

function DpGridGroup_getCondList(oConds)
{
	for(var i=0; i<this.aSubGroups.length; i++)
		this.aSubGroups[i].getCondList(oConds);
		
	for(var i=0; i<this.aAlternates.length; i++)
	{
		oConds[this.aAlternates[i].cond] = true;
		this.aAlternates[i].oGroup.getCondList(oConds);
	}
}

function DpGridGroup_buildRow(nRow, nTotalRows, cond)
{
	var nAlt = -1;
	if(cond)
		for(var nAlt=this.aAlternates.length-1; nAlt>=0; nAlt--)
			if(this.aAlternates[nAlt].cond==cond)
				break;

	if(this.aCaption && nRow<this.aCaption.length)
	{
		//this.objGrid.FieldEx("", this.aCaption[nRow-1], this.getColCount()).Empty();
	}
	else if(this.oCells.length > 0)
	{   
//-		for(var nCell = 0; nCell < this.oCells.length; nCell++)
		for(var nCell in this.oCells)
		{
			var oCell = this.oCells[nCell];
			var cField="", cAttr="", cFormat="", nWidth=1;
			var isEmpty = false;
//-			if(nRow==nTotalRows)
//-			{
				cField = oCell.cField;
				cAttr = oCell.cAttr;
				cFormat = oCell.cFormat;
				nWidth = oCell.nWidth;
//-				cField = this.oCell.cField;
//-				cAttr = this.oCell.cAttr;
//-				cFormat = this.oCell.cFormat;
//-				nWidth = this.oCell.nWidth;
//-			}
//-			else
//-				isEmpty = true;
			
			if(nRow==nTotalRows-1 && this.cSubCaption)
				isEmpty = false;
			
			var cCaption;
			if(nRow==nTotalRows && this.cSubCaption)
				cCaption = this.cSubCaption;
			else
				cCaption = this.aCaption && nRow==this.aCaption.length?
					this.aCaption[nRow-1]: "";
			cCaption = oCell.cCaption;
//-			var cell = this.objGrid.FieldEx(cField, cCaption, nWidth, cAttr, cFormat);
			if(this.objGroup != null)
				this.objGroup.addField(cell);
			/*
			if(isEmpty)
				cell.empty();
			if(this.color)
				cell.textColor(this.color);
				*/
		}
			
	}
	else if(this.aCaption && nRow==this.aCaption.length)
	{
		/*
		if(nAlt==-1)
			this.objGrid.FieldEx("", this.aCaption[nRow-1], this.getColCount());
		else
			this.objGrid.FieldEx("", this.aCaption[nRow-1]
					, this.aAlternates[nAlt].oGroup.getColCount()
					);
					*/
	}
	else
	{
		var nCaptHeigth = this.aCaption? this.aCaption.length: 0;
		if(nAlt==-1)
			for(var i=0; i<this.aSubGroups.length; i++)
				this.aSubGroups[i].buildRow(nRow-nCaptHeigth
						, nTotalRows-nCaptHeigth, cond);
		else
			this.aAlternates[nAlt].oGroup.buildRow(
					nRow-nCaptHeigth
					, nTotalRows-nCaptHeigth, cond);
	}
}

function DpGridGroup_getWidth()
{
	if(this.oCell)
		return this.oCell.nWidth;
	
	var nWidth = 0;
	for(var i=0; i<this.aSubGroups.length; i++)
		nWidth += this.aSubGroups[i].getWidth();
		
	for(var i=0; i<this.aAlternates.length; i++)
		nWidth = Math.max(nWidth, this.aAlternates[i].oGroup.getWidth());
	
	return nWidth;
}

function DpGridGroup_setProperties(cName, uValue)
{
	cName = cName.toUpperCase();
	this.oProperties[cName] = uValue;
}

function DpGridGroup_getColCount()
{
	if(this.oCell)
		return 1;
	
	var nCount = 0;
	for(var i=0; i<this.aSubGroups.length; i++)
		nCount += this.aSubGroups[i].getColCount();
		
	for(var i=0; i<this.aAlternates.length; i++)
		nCount = Math.max(nCount, this.aAlternates[i].oGroup.getColCount());
	
	return nCount;
}

function DpGridGroup_textColor(color)
{
	this.color = color;
}

//----------------------------------------
// Объект-условие
function DpCondGroup(type)
{
	this.type = type;
	this.aGroups = new Array();
	this.aConds = new Array();
	this.oCond = null;
}
DpCondGroup.prototype.cond = DpCondGroup_cond
DpCondGroup.prototype.group = DpCondGroup_group
DpCondGroup.prototype.getConds = DpCondGroup_getConds

function DpCondGroup_cond(cond, alias)
{
	var oCondGroup = new DpCondGroup();
	this.aGroups[this.aGroups.length] = oCondGroup;
	oCondGroup.oCond = new DpCond(cond, alias);
}

function DpCondGroup_group(type)
{
	var oCondGroup = new DpCondGroup(type)
	this.aGroups[this.aGroups.length] = oCondGroup
	return oCondGroup;
}

function DpCondGroup_getConds()
{
	var aRetConds = new Array();
	var i;
	
	if(this.oCond)
	{
		aRetConds[0] = "";
		aRetConds[1] = "{"+this.oCond.alias+"}";
	}
	// Тип условия = CASE
	// Это значит, что условия взаимо исключающие, т.е. если выполняется одно условие, то остальние - нет!
	else if(this.type=="CASE")
	{
		for(i=0; i<aGroups.length; i++)
		{
			aRetConds.concat(aGroups[i].getConds().slice(1));
		}
	}
	else
	{
		var a1LevelConds = new Array()
		a1LevelConds[0] = "";
			
		for(i=0; i<this.aGroups.length; i++)
		{
			var aGroupConds = this.aGroups[i].getConds();
			var a2LevelConds = new Array();
					
			for(i1=0; i1<a1LevelConds.length; i1++)
				for(i2=0; i2<aGroupConds.length; i2++)
					a2LevelConds[a2LevelConds.length] = a1LevelConds[i1]+aGroupConds[i2]
					
			a1LevelConds = a2LevelConds;
		}
		aRetConds = a1LevelConds;
	}
	return aRetConds;
}

function DpCond(cond, alias)
{
	this.cond = cond
	this.alias = alias? alias: cond;
}

DpCond.prototype.and = DpCond_and;

function DpCond_and(cond)
{
}

function DpGrid_storeAsXML(sFileName)
{	
	var oXmlGrid = new DpXmlGrid();
	oXmlGrid.save(this,sFileName);	
}

function DpGrid_loadFromXML(sLbl)
{
	
	var oXmlGrid = new DpXmlGrid();
	oXmlGrid.load(this,sLbl);	
}

function DpGrid_buildFromXML(sLbl)
{
	
	this.loadFromXML(sLbl);
	this.build();
}
