
function DpLNop()
{
	this.fnop = 0;
	this.fwid = 0;
	this.fdoc = "";
	this.ftxt = "";
	
	this.flag = "";	
	
	this.setCod = DpLNop_setCod;
	this.setFWID = DpLNop_setFWID;
	this.setDoc = DpLNop_setDoc;
	
	this.getCod = DpLNop_getCod;
	this.getFWID = DpLNop_getFWID;
	this.getDoc = DpLNop_getDoc;
	this.getText = DpLNop_getText;
	
	this.validCtrl = DpLNop_validCtrl;
	this.zaval = DpLNop_zaval;
	
	this.updateCtrl = DpLNop_updateCtrl;
	this.linkCtrl = DpLNop_linkCtrl;

}

function DpLNop_setCod(nop)
{
	if (typeof nop == "undefined")
		nop = 0;
	this.fnop = Number(nop);
	this.flag = "fnop";
	return this.updateCtrl();		
}

function DpLNop_getCod()
{
	return this.fnop;
}

function DpLNop_setFWID(fwid)
{
	if (typeof fwid == "undefined")
		fwid = 0;
	this.fwid = Number(fwid);
	this.flag = "fwid";
	return this.updateCtrl();		
}

function DpLNop_getFWID()
{
	return this.fwid;
}

function DpLNop_setDoc(doc)
{
	if (typeof doc == "undefined")
		doc = "";
	this.fdoc = String(doc);
	return this.updateCtrl();		
}

function DpLNop_getDoc()
{
	return this.fdoc;
}

function DpLNop_getText()
{
	return this.ftxt;
}

function DpLNop_linkCtrl(ctrlNop, ctrlTxt)
{
	if (ctrlNop == null)
		return false;
	this.nopObj = ctrlNop;
	this.nopObj.setMask("########");
	this.nopObj.isButton = true;
	setValid(this.nopObj, this, "validCtrl");	
	setButton(this.nopObj, this, "zaval");
	if (ctrlTxt != null)
	{
		this.txtObj = ctrlTxt;
		this.txtObj.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"); // много :)
		Disable(this.txtObj);
	}
	return this.updateCtrl();	
}


function DpLNop_updateCtrl()
{
	var strSQL = "SELECT fnop, fwid, ftxt FROM ^cl_lnk WHERE fnop <> 0 ";
	switch (this.flag)
	{
		case "fnop":
			strSQL += " AND fnop=" + sqlTo(this.fnop);
			break;
		case "fwid":
			strSQL += " AND fwid=" + sqlTo(this.fwid);
			break;				
	}
	if (this.fdoc != "")
		strSQL += " AND fdoc=" + sqlTo(this.fdoc);
	var snap = getSnap(strSQL);
	if (snap == null)
	{
		this.fnop = 0;
		this.fwid = 0;
		this.ftxt = "";
		if (this.nopObj)
			this.nopObj.setValue(this.fnop);
		if (this.txtObj)
			this.txtObj.setValue(this.ftxt);
		return false;
	}
	else
	{
		this.fnop = snap[0];
		this.fwid = snap[1];
		this.ftxt = snap[2];
		if (this.nopObj)
			this.nopObj.setValue(this.fnop);
		if (this.txtObj)
			this.txtObj.setValue(this.ftxt);
		return true;						
	}	
}

function DpLNop_validCtrl()
{	
	if (!this.setCod(this.nopObj.getValue()))
		return this.zaval();
	return true;
}

function DpLNop_zaval()
{
	var par = new Object();
	par.escape = true;
	par.doc = this.getDoc();
	par.fwid = this.getFWID();
	par.ret = new Object();
	par.ret.fnop = 0;
	showWindow("l_lclop.js", SW_MODAL, par);
	if (!par.escape)
		return this.setCod(par.ret.fnop);
	return false;
}
