//----------------------------------------------
//Описание объекта "лицевой счет"("ЛС")
//----------------------------------------------
 
//коструктор
function DpLicfld(fd)
{
	RO("DpLicfld", this);
    this.empty = DpLicfld_empty;
    this.setCod = DpLicfld_setCod;
    this.getCod = DpLicfld_getCod;
    this.zSetCod = DpLicfld_zSetCod;
	this.zValid = DpLicfld_zValid;
    this.linkCtrl = DpLicfld_linkCtrl;
    this.validCtrl = DpLicfld_validCtrl;
    this.updateCtrl = DpLicfld_updateCtrl;
    this.zaval = DpLicfld_zaval;
    this.fillUp = DpLicfld_fillUp;
    this.zavalOk = DpLicfld_zavalOk;
    this.empty();
    this.zOk = true;
    this.htm = "r_licfld.js";
    this.mindex = "lic_fid";
    if (SQL)
		this.mindex = "FID";
    if (fd=="0")
    {
    	this.allow0 = true;
    }  
    this.tblWrkLS = OpenTable("s","LIC_FLD");        
}

function DpLicfld_empty()
{
	this.cod = null;
}

function DpLicfld_setCod(newcod)
{
	this.empty();
    this.cod = newcod;
    this.updateCtrl();
}

function DpLicfld_getCod()
{
	return this.cod;
}

function DpLicfld_zSetCod(newcod)
{
	var mcod = this.cod;
    this.zOk = true;
    this.cod = newcod;
    if(!this.fillUp())
		this.zaval(this.cod);
	if(this.zOk)
    	this.updateCtrl();
	return this.zOk;
}

function DpLicfld_fillUp()
{
    var fl;
    this.tblWrkLS.index = this.mindex;
    if (!this.cod && this.allow0) 
    	return true;
	var strSQL = "select * from ^LIC_FLD where fid="+ sqlTo(this.cod);
    var fl = OpenTable("s", strSQL);
    if (fl.IsEmpty())
    {
    	DpLicfld_FillError();
        return false;
	}
	else
	{
    	return true;
	}
}

function DpLicfld_FillError()
{
	this.cod=null;
}

function DpLicfld_updateCtrl()
{
	if (this.ctrlCod)
    	this.ctrlCod.value = this.cod;
}

function DpLicfld_zaval(ncod)
{
   	ncod = this.ctrlCod.value;
	if (ncod==null)
		ncod = 0;

	par = new Object();
   	par.isZaval = true;
    par.fcod = ncod;
    par.find = this.mindex;
    
    par.ret = new Object();
    par.ret.fid = ncod;
    
    showWindow(this.htm, SW_MODAL, par, "");
    if(!par.escape)
    {
    	this.cod = par.ret.fid;
		this.zOk = true;
	}
    else
    {
    	//this.cod = mcod;
        this.zOk = false;
	}

	if (this.zOk)
    	this.updateCtrl();
	return this.zOk;
}

function DpLicfld_linkCtrl(newctrl)
{
	this.ctrlCod = newctrl;
    newctrl.mask = "#####";
	//if(this.ctrlCod.DpType=="DpGet")
	if(typeOf(this.ctrlCod)=="DpTextEx")
	{
		//this.ctrlCod.isButton = true;
		this.ctrlCod.setButton(true);
		this.ctrlCod.buttonHandler(this, "zaval");
	}	
	setValid(this.ctrlCod, this, "validCtrl");
	this.updateCtrl();
}

function DpLicfld_validCtrl()
{
	return this.zSetCod(this.ctrlCod.value);
}

function DpLicfld_zavalOk()
{
	return this.zOk;
}

function DpLicfld_zValid()
{
	return this.zSetCod(this.ctrlCod.value);
}