/*
	Объект для отображения расширений для приходных документов
*/

var DpPnExt_instance;

function DpPnExt(list)
{
	this.Load2Grid		= DpPnExt_Load2Grid;
	this.getValue		= DpPnExt_GetValue;
	
	DpPnExt_instance = this;
}

function DpPnExt_Load2Grid(grid, tbl)
{	
	this.tbl = tbl;
	this.grid = grid;
	
	var tPnExtList = OpenTable("SELECT e.*"
			+ " FROM ^PNEXTLST l "
				+ " LEFT JOIN ^cl_ext e"
					+ " ON l.flabel = e.flabel"
						+ " AND e.fclass='R.PN.ROW'"
			+ " ORDER BY forder"
			);
	
	if (!tPnExtList.recordCount)
		return;
	
	var oGrigGroup = grid.page().group("Расширения первого прихода");
	
	for (tPnExtList.MoveFirst(); !tPnExtList.IsEOF(); tPnExtList.MoveNext())
	{
		oGrigGroup.cell("=DpPnExt_instance.getValue('" + tPnExtList.getValue("flabel") + "')", tPnExtList.getValue("ftxt"), 10);
	}
}

function DpPnExt_GetValue(cLabel)
{
	var tbl = list.tbl;
	if (!tbl)
		return '';

	var fid_pn = Number(tbl.getValue("fid_pn"));
	
	var oSnap = getSnap(
			"select a.fdoc, s.fnop"
			+ " from ^anltk a left join ^sch_zag s on a.fid_doc = s.fwid"
			+ " where a.fwid = " + tbl.getValue("fid_pn"));
	
	if (!oSnap || !oSnap[0])
		return null;
	
	var doc = String(oSnap[0]) + ".ROW";
	var nop = Number(oSnap[1]);
	
	var xTable    = OpenTable("eR", doc, nop);     
	var ret = toScrObj(xTable.getValue(fid_pn, cLabel));
	xTable.close();
	
	if (ret == null && nop != 0)
	{
		xTable    = OpenTable("eR", doc, 0);     
		ret = toScrObj(xTable.getValue(fid_pn, cLabel));
		xTable.close();
	}
	return ret; 
}

