/// Протоколирование

var DpProt_this;

function restoreData()
{
	DpProt_this.Restore();
}

function DpProt_initProt()
{
}

function DpProt(fwid, mode)
{
	RO("DpProt", this);
	if (!DpProt_this)
		DpProt_this     = this;
	else
	{
		debug("Может быть только один объект DpProt.");
		return;
	}
	this.fwid       = fwid;
	if (mode)
		this.mode = mode;
	this.tblAttr    = new Array();
	
	this.protPar    = getPar("Protocol");
	this.setFWid	= DpProt_setFWid;
	this.setTblAttr = DpProt_setTblAttr;
	this.SaveAll    = DpProt_SaveAll;
	this.Save       = DpProt_Save;
	this.startView  = startOpening;
	this.endView    = endOpening; 
	this.Restore    = DpProt_Restore;
	
	DpProt_this     = this;
	
	if (SQL)
		return;
	if (!disableAll)
		if (typeof(initProtocol) == "function")
			initProtocol();
		else
			DpProt_initProt();
}

function DpProt_setFWid(fwid){
	this.fwid	= fwid;
}

function DpProt_setTblAttr(tblName, mode, field, source, cond, restore)
{	
	if (SQL)
		return;
	var otblAttr     = new Object();
	otblAttr.name    = tblName;
	otblAttr.mode    = (typeof(mode) != "undefined")? mode: p_no;
	otblAttr.field   = field;
	otblAttr.source  = source;
	otblAttr.cond    = (cond)?cond: true;
	otblAttr.restore = (typeof(restore) == "boolean")?restore: true;
	this.tblAttr[this.tblAttr.length] = otblAttr;
}

function DpProt_Save(mode, tblName, fwid, iMode, field, source, cond)
{
	if (SQL)
		return;
	cond = (typeof(cond) == "undefined" || typeof(cond) == "unknown")? true: eval(cond);
	if (cond !== false && openProtocolWrite(fwid, mode))
	{		
		writeProtocol(tblName, fwid, iMode, field, source);
		closeProtocol();
	}
}
function DpProt_SaveAll(mode, fwid)
{
	if (SQL)
		return;

	if (!fwid)
		fwid = this.fwid;
	if (!mode)
		mode = this.mode;
timeBegin("openProtocolWrite");
	if (openProtocolWrite(fwid, mode))
	{
timeEnd("openProtocolWrite");
		for (var i = 0; i < this.tblAttr.length; i++)
			if (eval(this.tblAttr[i].cond))
			{
timeBegin("writeProtocol " + this.tblAttr[i].name);			
				writeProtocol(this.tblAttr[i].name, fwid, this.tblAttr[i].mode, this.tblAttr[i].field, this.tblAttr[i].source);
timeEnd("writeProtocol " + this.tblAttr[i].name);			
			}
timeBegin("closeProtocol");
		closeProtocol();
timeEnd("closeProtocol");
	}
	else
timeEnd("openProtocolWrite");
}

function DpProt_Restore()
{
	if (SQL)
		return;
	for (var i = 0; i < this.tblAttr.length; i++)
		if (this.tblAttr[i].restore)
			readProtocol(this.tblAttr[i].name, this.tblAttr[i].mode, this.tblAttr[i].field);	
}
