// объект структуры организаций
include("Objects/DpGetDat.js");

function DpStruOrg(checkValid, dt)
{
	RO("DpStruOrg", this);
	this.setCod = this.setID = DpStruOrg_setID;
	this.getCod = this.getID = DpStruOrg_getID;
	this.getNazv = DpStruOrg_getNazv;
	this.linkCtrl = DpStruOrg_linkCtrl;
	this.validCtrl = DpStruOrg_validCtrl;
	this.zaval = DpStruOrg_zaval;
	this.updateCtrl = DpStruOrg_updateCtrl;
	this.valid = DpStruOrg_valid;
	this.setDat = DpStruOrg_setDat;
	this.getDat = DpStruOrg_getDat;
	this.ID = 0;
	//this.parentID = 0;
	this.nazv = "???";
	if(typeOf(checkValid)=="boolean")
		this.checkValid = checkValid;
	else
		this.checkValid = false;
	this.dat = dt?new Date(dt).getVarDate():null;
}

function DpStruOrg_setID(ID)
{
	var oSnap = getSnap("SELECT Ftxt FROM ^stru_org WHERE Fwid="+sqlTo(ID));
	if(oSnap!=null)
	{
		this.nazv = oSnap[0];
		this.ID = ID;
	}
	else
	{
		this.nazv = "???";
	}
	this.updateCtrl();
}

function DpStruOrg_getID()
{
	return this.ID;
}

function DpStruOrg_getNazv()
{
	return this.nazv;
}

function DpStruOrg_linkCtrl(nazv_ctrl)
{
	if (typeof(nazv_ctrl) == "object")
	{
		this.nazv_ctrl = nazv_ctrl;
		this.nazv_ctrl.isButton = true;
		this.nazv_ctrl.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&"); // 60
		//Disable(this.nazv_ctrl);
		setValid(this.nazv_ctrl, this, "validCtrl");
		setButton(this.nazv_ctrl, this, "zaval");
	}	
	this.updateCtrl();
}

function DpStruOrg_updateCtrl()
{
	this.nazv_ctrl.value = this.getNazv();
}

function DpStruOrg_zaval()
{
	var par = new Object();
	par.zaval = true;
	par.escape = false;
	par.ret = new Object();
	par.ret.fwid = 0;
	par.ret.fboss = 0;
	if(this.dat!=null)
		par.dat = this.dat;
	else
	{
		var dt = new DpGetDat("d");
		if(dt.escape)
			return false;
		par.dat = dt.dat1;
	}
	showWindow("l_struOrg.js",SW_MODAL,par);

	if( !par.escape )
	{
		this.setID(par.ret.fwid);
	}
	return this.valid();
}

function DpStruOrg_validCtrl()
{
	if (!this.valid())
		return this.zaval();
	return true;
}

function DpStruOrg_valid()
{
	if(this.nazv_ctrl.value=="")
	{
		this.setID(0);
		return false;
	}
	if(this.checkValid)
		return (this.getID()!=0);
	else
		return true;
}

function DpStruOrg_setDat(dt)
{
	this.dat = new Date(dt).getVarDate();
}

function DpStruOrg_getDat()
{
	return this.dat;
}