
function DpXMLImport(oPar, oDlg)
{
	include("objects\\DpMsgBox.js");
	this.XMLImp = null;		//XML импорта
	//if(sFile) this.sImpFile = sFile;
	this.bStatus = true;
	this.isBuildNmklTree = true;
	this.isReplaceExists = false;
	this.importPar = new Object();
	this.silentMode = false;
	this.waitSuffix = "";
    this.bConvertToMedoc = false;
	
	this.oDlg = oDlg;
	
	if (oPar)
	    this.importPar = oPar;
	    
	if (oPar && typeof(oPar.isBuildNmklTree) != "undefined")
	{
		this.isBuildNmklTree = oPar.isBuildNmklTree; 
	}    
	include("Objects/DpXMLDomDocument.js");
	
	//Функции начальной загрузки и инициализации
	this.ArrObjData = new Array();
	this.InitImport = DpXMLImp_InitImport;
	this.ImportFile = DpXMLImp_ImportFile;
	this.ImportObject = DpXMLImp_ImportObject;
	this.getImpFunc = DpXMLImp_getImpFunc;
	this.importCL = DpXMLImp_importCL;
	this.importNmkl = DpXMLImp_importNmkl;
	this.importChilds = DpXMLImp_importChilds;
	this.importDocRows = DpXMLImp_importDocRows;
	this.importRegAttrs = DpXMLImp_importRegAttrs;
	this.setDefaultValueRows = DpXMLImp_setDefaultValueRows;
	this.afterSetValueRows = DpXMLImp_afterSetValueRows;
	this.importDoc = DpXMLImp_importDoc;
	this.importDogovor = DpXMLImp_importDogovor;
	this.createDocItog = DpXMLImp_createDocItog;
	this.getPn1 = DpXMLImp_getPn1;
	this.getObject = DpXMLImp_getObject;
	this.fillHeaderVars = DpXMLImp_fillHeaderVars
	this.compareHeaderVars = DpXMLImp_compareHeaderVars;
	this.searchExistingObject = DpXMLImp_searchExistingObject;
	this.searchExistingCl = DpXMLImp_searchExistingCL;
	this.searchExistingVal = DpXMLImp_searchExistingVal;
	this.fillExt = DpXMLImp_fillExt;
	this.compareExt = DpXMLImp_compareExt;
	this.arrRassDoc = new Array();
	this.rascostDoc = DpXMLImp_rascostDoc;
	this.oDocExists = new DpMsgBox("y!", "Документ уже существует","Найден документ");
	this.InitImport();
	this.logFileName = "import.log";
	this.appendLog = DpXMLImp_appendLog;
	this.cntCl = 0;//кол-во симпортированных записей справочников
	this.cntDoc = 0;//кол-во симпортированных документов
	this.cntNmkl = 0;//кол-во симпортированных номенклатур
	this.cntExistsCl = 0;//кол-во существующих записей справочников
	this.cntExistsDoc = 0;//кол-во существующих документов
	this.cntExistsNmkl = 0;//кол-во существующих номенклатур
}

function DpXMLImp_InitImport()
{
	include("objects\\DpDefVed.js")
	this.DefVed = new DpDefVed();
	this.dpApi =lpProxy.getDpAPI()	
}

function DpXMLImp_ImportFile(sFileName)
{	
	if(!this.bStatus) return;	
	if(sFileName)this.sImpFile = sFileName;	
	
	if(!this.sImpFile)
	{
		var msg = "Не получен файл для импорта";
		alert(msg,2);
		this.appendLog("ERROR: "+msg);
		return false;
	}
	var XMLDoc =  new DpXMLDOMDocument();
	
	var bLoad = XMLDoc.load(sFileName);
	if(!bLoad)
	{
		var msg = "Ошибка при чтении файла импорта "+sFileName;
		alert("ERROR: "+msg,2);
		return false;
	}
	
	return this.ImportObject(XMLDoc.getDocumentElement());	
}

function DpXMLImp_ImportObject(xmlObj)
{	
	this.logFileName = "import"+format("yyyymmdd_HHMM",new Date())+".log";
	this.arrRassDoc = new Array();
	this.XMLImp = xmlObj;
	if(!this.XMLImp)
		return false;
	WAIT("Импорт начат" + this.waitSuffix);
	this.appendLog("Импорт начат " + format("dd.mm.yyyy в HH:MM:SS",new Date()));
	
	if(xmlObj.getAttribute("type")=="deb")
		this.isDeb = true;
	if(xmlObj.getAttribute("scaleCena"))
	{
		this.nScaleCena = Number(xmlObj.getAttribute("scaleCena"));
		//this.GetPn1 = DpXMLImp_GetPn1_SQL;
	}
	

	this.DefVed.begin("","Импорт объектов");
	__noWait = true;
	var childs = this.XMLImp.getChildNodes();
	var nCount = childs.length;
	var oTime = new Date();
	if (this.oDlg)
	{
			prObj.setMinimum(0);
			prObj.setMaximum(nCount);
	}
	else
	{
		setProgressRange(0, nCount);
	}
	
	for(var n = 0;n < nCount; n++)
	{
		
		var XMlElement = childs[n];
		var sObj = XMlElement.getAttribute("type");				
		
		if(!sObj) continue;
		
		//Получаем функцию импорта для даного объекта
		var impFunc = this.getImpFunc(sObj);
		if(!impFunc) continue;
			
		//Вызываем полученую функцию и передаем ей елемент XML
		if (typeof(this[impFunc]) != "function")
			continue;
		this[impFunc](XMlElement,sObj);
		var oCurrTime = new Date();
		if(oCurrTime.getTime() - oTime.getTime() > 1000 || sObj.startsWith("docs."))
		{
			if (this.oDlg)
			{
				prObj.setSelection(n+1);
			}
			else
			{
				setProgressPos(n+1, "ИМПОРТИРОВАНО ОБЪЕКТОВ - "+(n+1)+" из "+ nCount);
			}
			oTime = oCurrTime;
		}
					
	}
	if (!this.oDlg)
		setProgressPos(0);
	CLEARWAIT();
	__noWait = false;
	this.DefVed.end();

	if (!this.importPar.NO_RASCOST)
	   this.rascostDoc();

	this.appendLog("Кол-во cимпортированных записей справочников: " + this.cntCl);
	this.appendLog("Кол-во пропущенных (уже существующих) записей справочников: " + this.cntExistsCl);
	this.appendLog("Кол-во cимпортированных документов: " + this.cntDoc);
	this.appendLog("Кол-во пропущенных (уже существующих) документов: " + this.cntExistsDoc);
	this.appendLog("Кол-во cимпортированных номенклатур: " + this.cntNmkl);
	this.appendLog("Кол-во пропущенных (уже существующих) номенклатур: " + this.cntExistsNmkl);
	this.appendLog("Импорт закончен " + format("dd.mm.yyyy в HH:MM:SS",new Date()));
	if (!this.silentMode)
		alert("Импорт закончен.\nЛог сохранен в : "+lpProxy.getInstallDirectory()+this.logFileName);	
	
	this.arrRassDoc = new Array();
}



function DpXMLImp_getImpFunc(sType)
{
	sType = String(sType);	
		
	if (sType.startsWith("IDPN"))
		return "getPN1";
	if (sType.startsWith("cls.nmkl"))
		return "importNmkl";
	if (sType.startsWith("cls."))
		return "importCL";
	if (sType.startsWith("docs."))
		return "importDoc";
	if (sType.startsWith("dogovor"))
		return "importDogovor";
			
	return null; 
}

function DpXMLImp_getPn1(XMLPn1, obj)
{
	xmlId = XMLPn1.getElementsByTagName("ID");
	if(xmlId && xmlId.length > 0 && xmlId[0])
	{
		var sID = xmlId[0].getText();
		if (sID && !isNaN(sID) )
		{
			obj.setVar("R1ID", Number(sID));
			return true;
		}		
		
	}
	
	if(this.isDeb)
	{
		obj.setVar("R1ID", 0);
		return false;		
	}
	
	xmlOutId = XMLPn1.getElementsByTagName("HOUTID");
	
	if (!xmlOutId && xmlOutId.length == 0 )
		return false;
		
	xmlOutId = xmlOutId[0];
	
	var sOutId = xmlOutId.getText();
	if (!sOutId) return false;
	
	var sSQL = "select fwid, fpost, fcena from ^anltk where foutid = " + sqlTo(sOutId);
	var oSnap = getSnap(sSQL)
	
	if (oSnap && oSnap[0])
	{
		if (obj.getVar("par.HDOC") == "VM")
		{
		    if (obj.getVar("RUCENA") != 0 &&  round(obj.getVar("RUCENA"),4) != round(oSnap[2], 4))
		    {
		        return;
		    }
		}
		obj.setVar("R1ID", oSnap[0]);
		obj.setVar("RPOST", oSnap[1]);
		obj.setVar("RUCENA", round(oSnap[2], 4));
		obj.setVar("RCENAORD", round(oSnap[2], 4))
		trace ("PN1 FOUNDED")
		
	} 
	
	if(obj.getVar("par.HDOC") == "VM")
	{
		if(obj.getVar("R1ID"))
		{
			//ES Если первый приход в валюте, то тогда тогда позиция ставится на учет по валютной цене
			//а нужно по учетной, потому выбираем поле 	"cena"
			obj.setVar("ROCENA", tanf(obj.getVar("R1ID"),"cena"));			
		//	ArrFullTbl[nR]["FCENAPR"] = tanf(ArrFullTbl[nR]["FID_PN"],"cenapr");		
		}
		else
		{
			var sSQL = "select fcenapr from ^anltk where "
					+" frtype ='6' and fdoc = 'SM' "
					+ " and fnmkl = " + sqlTo(obj.getVar("RTNMK"))
					+ " and fpodr = " + sqlTo(obj.getVar("RPODR"))
					+ " and fmol = " + sqlTo(obj.getVar("RMOL"))
					+ " and fsc = " + sqlTo(obj.getVar("RSC"))
					+ " and fsu = " + sqlTo(obj.getVar("RSU"))
					+ " and fst = " + sqlTo(obj.getVar("RST"))
					+ " and fcena = " + sqlTo(obj.getVar("RUCENA"))
					+ " and fdate <= " + sqlTo(obj.getVar("par.HDAT"))
						+ " and fcenapr>0"
			var oSnapVM = getSnap(sSQL);
			if(oSnapVM && oSnap[0])
				obj.setVar("ROCENA", oSnapVM[0]);	
				
		}
	}
			
	
	return oSnap != null;
	
}

function DpXMLImp_rascostDoc()
{
	if (!this.arrRassDoc || this.arrRassDoc.length == 0) return;
	include("doc/nakl/DpDocRasc.js") 
	if (this.oDlg)
	{
			prRasCostDoc.setMinimum(0);
			prRasCostDoc.setMaximum(this.arrRassDoc.length);
	}
	else
	{
		setProgressRange(0, this.arrRassDoc.length);
	}	
	for (var i = 0; i < this.arrRassDoc.length; i++ )
	{
		if (this.oDlg)
		{
			prRasCostDoc.setSelection(i + 1);
		}
		else
		{
			setProgressPos(i+1, "Расценивание - "+(i+1)+" из "+ this.arrRassDoc.length);
		}
		var oRasc = new DpDocRasc(this.arrRassDoc[i]);
		oRasc.bImportFromTetra = true;
		oRasc.rasc();
	}
	if (!this.oDlg)
		setProgressPos(0);
}

function DpXMLImp_importCL(xmlImp, sType, sSubType)
{
	var obj = this.getObject(sType, sSubType);
	
	this.fillHeaderVars(xmlImp, obj);
	
	var sObjectTbl = "^" +String(obj.getTableName()).trim();	
	var nRet = 0;
	
	var sCodRetFld = "FCOD";
		
	if (obj.instanceOf("CL1"))
	{
		nRet = this.searchExistingCl(obj);
	}
	else if (String(obj.sClassId) == "valut")
	{
		
		sCodRetFld = "FKOD";
		nRet = this.searchExistingVal(obj);
	}
	else if (String(obj.sClassId)=="osnazv")
	{
		sCodRetFld = "FINV_NUM";
		nRet = this.searchExistingObject(obj,sCodRetFld);
	}
	else if (String(obj.sClassId)=="naktos")
	{
		sCodRetFld = "FFCOD_VID";
		nRet = this.searchExistingObject(obj,sCodRetFld,"FVID_NAZV");
	}
	else
		nRet = this.searchExistingObject(obj);
	
	if (nRet != -1 
		&& String(obj.sClassId)!="metals" 
		&& String(obj.sClassId)!="naktos"
		&& String(obj.sClassId)!="os0b"
		&& String(obj.sClassId)!="os0"
		&& String(obj.sClassId)!="vn_perem"
		&& String(obj.sClassId)!="vn_perem_all"
		)
	{ 
		this.cntExistsCl++;
		return nRet;
	}
	
	if (obj.instanceOf("CL1"))
	{
		//Не записывать контрагентов без текстовки
		if(obj.instanceOf("CL2") && !obj.getVar("HTXT"))
		{ 
			this.appendLog("WARNING: контрагент с кодом "+obj.getVar("HCOD")+" не будет импортирован, т.к. отсутствует название");
			this.cntExistsCl++;
			return null;
		}
		if(!obj.getVar("HCOD"))
		{
			var oSnap = getSnap("SELECT MAX(FCOD) FROM ^CLRELCLCL WHERE FCL = " + obj.getVar("HCL"));
			obj.setVar("HCOD", oSnap[0] + 1);
		}
	}
	else
	{	
		if(!((String(obj.sClassId) == "osnazv" 
			|| String(obj.sClassId) == "metals" 
			|| String(obj.sClassId)=="os0b"
			|| String(obj.sClassId)=="os0"
			|| String(obj.sClassId)=="vn_perem"
			|| String(obj.sClassId)=="vn_perem_all"
			) && obj.getVar("HCOD")))
		{
			var oSnap = getSnap("SELECT MAX(" + sCodRetFld + ") FROM " + sObjectTbl);
			obj.setVar("HCOD", oSnap[0] + 1)
		}
	}
	
	var rows = xmlImp.getElementsByTagName("rows");
	for (var i = 0; i < rows.length; i++)
	{
		this.importChilds(obj, rows[i]);
	}
	var isExt = this.fillExt(xmlImp, obj)
	obj.save();
	obj.saveRows();
	if (isExt)
		obj.saveExtToDB();
	//TODO - проблема с fcl - для нулевого справочника
	//obj.saveRows(true);
	
	this.cntCl++;
	return obj.getVar("HCOD");
}

function DpXMLImp_importDogovor(xmlImp)
{
	var obj = new DpDoc("com.debet.dogovor", 0);
	this.fillHeaderVars(xmlImp, obj);
	if(obj.getVar("HOUTID"))
	{
		var oSnap = getSnap("select fwid from ^contract where foutid = "+sqlTo(obj.getVar("HOUTID")));
		if(oSnap)
		{
			return oSnap[0];
		}
	}
	
	return null;
}

function DpXMLImp_importDoc(xmlImp, sType)
{
	var t = new Date().getTime();
	var obj = this.getObject(sType);
	this.fillHeaderVars(xmlImp, obj);
	if (obj.getVar("HOP"))
	{
		obj.nNop = obj.getVar("HOP");
	}
	var sObjectTbl = "^" +String(obj.getTableName()).trim();
	//showObject(obj);
	obj.setVar("HVER", 0);
	obj.setVar("HORG0", CURRENT_ORG);
	
	if(obj.getVar("HOUTID"))
	{
		var oSnap = getSnap("select fwid, FDOC, FNOP, FDOC_DAT, FDOC_NUM from " 
			+ sObjectTbl + " where foutid = "+sqlTo(obj.getVar("HOUTID")));
		if(oSnap)
		{
			if (this.isReplaceExists == true)
			{
				//if (!this.compareHeaderVars(xmlImp, obj))// || !this.compareExt(xmlImp, obj))
				{
					// загружаем существующий документ если нужно обновить суммы
					if (!obj.loadByID(oSnap[0], true))
					{
						this.cntExistsDoc++;
						this.appendLog("WARNING: Не удалось загрузить существующий документ "+obj.getVar("HDOC")+"("+obj.getVar("HOP")+") с идентификтором "+oSnap[0]);
						return oSnap[0];
					}
					else
					{
						this.fillHeaderVars(xmlImp, obj);
					}
				}			
			}
			else
			{
				sMsg = "Найден документ "+oSnap[1]+":"+oSnap[2]
					+"\n c номером "+oSnap[4]+" на "+ format("dd.mm.yyyy", oSnap[3]);
				this.oDocExists.txt = sMsg;
				this.oDocExists.ask();
				this.appendLog("WARNING: "+sMsg);
				this.cntExistsDoc++;
				//alert(sMsg);
				return oSnap[0];
			}
		}
	}
	
	var t = new Date().getTime();
	var rows = xmlImp.getElementsByTagName("rows");
	for (var i = 0; i < rows.length; i++)
	{
		this.importDocRows(obj, rows[i]);
	}
	
	// reg attributes
	var regAttrs = xmlImp.getElementsByTagName("RegAttrs");
	if (regAttrs != null && regAttrs.length > 0)
		this.importRegAttrs(obj, regAttrs[0]);
		
	this.createDocItog(obj);
	var isExt = this.fillExt(xmlImp, obj)
	
	if (this.bConvertToMedoc)
	{
		include("..\\userdata\\popupmenu\\l_docekz\\export_docs_to_medoc.js");
		ExportDocsToMedoc(obj, obj.getVar("HDOC"));
		return;
	}
	
	obj.save(true);
	this.cntDoc++;
	if (isExt)
		obj.saveExtToDB();
	if (obj.instanceOf("NAKL"))
	{
		if (!inList(String(obj.getVar("HDOC")), "PN", "SA", "VR"))
		{
			this.arrRassDoc[this.arrRassDoc.length] = obj;
		}
	}	
}

//TODO: переделать на xml
function DpXMLImp_createDocItog(obj)
{
	var sLblDoc = obj.getVar("HDOC");
	if (!obj.instanceOf("NAKL")) return;
	
	var sHSUMExpr = "0";
	var sHKOLExpr = "SUMR(RKOL)";
	var sHSMTOVExpr = "0";
	var sHSBTOVExpr = "0";
	var sHUSUMExpr = "0";
	
	if (sLblDoc == "PN" || sLblDoc == "SA")
	{
		var sHSUMExpr = "SUMR(RPCENE*RKOL)";		
		var sHSMTOVExpr = "SUMR(R1OCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RPCENE*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";	
	} 
	
	else if (sLblDoc == "NK" || sLblDoc == "VP")
	{
		var sHSUMExpr = "SUMR(RFOCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(RFOCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";	
	}
	
	else if (sLblDoc == "VR")
	{
		var sHSUMExpr = "SUMR(ROCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(ROCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";	
	}
	
	else if (sLblDoc == "SM")
	{
		var sHSUMExpr = "SUMR(R0OCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(R0OCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";	
	}
	else if (sLblDoc == "VM")
	{
		/*
		
		var sHSUMExpr = "SUMR(RUCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(ROCENA*RKOL)";
		var sHUSUMExpr = "SUMR(ROCENA*RKOL)";		
		*/
		
		var sHSUMExpr = "SUMR(ROCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(ROCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";	
		
		
	}
	else if (sLblDoc == "PM")
	{
		var sHSUMExpr = "SUMR(RUCENA*RKOL)";		
		var sHSMTOVExpr = "SUMR(R1OCENA*RKOL)";
		var sHSBTOVExpr = "SUMR(RUCENA*RKOL)";
		var sHUSUMExpr = "SUMR(RUCENA*RKOL)";
	}
	else
	{
		return;
	}
	obj.setVar(sLblDoc == "VM"?"HOSUM":"HSUM", obj.eval(sHSUMExpr));
	obj.setVar("HKOL", obj.eval(sHKOLExpr));
	obj.setVar("HSMTOV", obj.eval(sHSMTOVExpr));
	obj.setVar("HSBTOV", obj.eval(sHSBTOVExpr));
	obj.setVar("HUSUM", obj.eval(sHUSUMExpr));
	
	if (sLblDoc == "NK" )
	{
	    obj.setVar("HPSUM", obj.getVar("HUSUM"));
	}
	else if (sLblDoc == "PM" )
	{
	    obj.setVar("HPSUM", obj.getVar("HSBTOV"));
	}
	else if (sLblDoc == "SM" )
	{
	    obj.setVar("HOSUM", obj.getVar("HSUM"));
	}

	 
}

function DpXMLImp_importChilds(obj, xmlRows)
{
	var sChildID = xmlRows.getAttribute("ID");
	var objects = xmlRows.getElementsByTagName("object");
	for (var i = 0; i < objects.length; i++)
	{
		var objRow = obj.createRow(sChildID);
		this.fillHeaderVars(objects[i], objRow)
		obj.appendRow(sChildID, objRow);
	}
	
}

function DpXMLImp_importDocRows(obj, xmlRows)
{
	var sChildID = xmlRows.getAttribute("ID");
	var objects = xmlRows.getElementsByTagName("object");
	if (this.oDlg)
	{
			prRowObj.setMinimum(0);
			prRowObj.setMaximum(objects.length);
	}
	for (var i = 0; i < objects.length; i++)
	{
		var objRow = obj.createRow(sChildID);
		this.setDefaultValueRows(objRow, obj);
		this.fillHeaderVars(objects[i], objRow);
		this.afterSetValueRows(objRow, obj);
		objRow.setVar("RNOM", i + 1 )
		obj.appendRow(sChildID, objRow);
		if (this.oDlg)
		{
			prRowObj.setSelection(i);
		}
	}
	
}

function DpXMLImp_setDefaultValueRows(objRow, parentObj)
{
	if (!parentObj.instanceOf("NAKL")) return;
	var sDocLbl = parentObj.getVar("HDOC");
	if(inList(sDocLbl, "SM", "PU", "PM", "VM"
						,"MT", "OC",  "MP", "MV" ))
	{
		objRow.setVar("RPODR", parentObj.getVar("HPODROT"));
		objRow.setVar("RMOL", parentObj.getVar("HMOLOT"));
	}
	else
	{
		objRow.setVar("RPODR", parentObj.getVar("HPODR"));
		objRow.setVar("RMOL", parentObj.getVar("HMOL"));
		
		if (inList(sDocLbl, "PN", "SA"))
		{
			objRow.setVar("RSC", parentObj.getVar("HSC"));
			objRow.setVar("RSU", parentObj.getVar("HSU"));	
			objRow.setVar("RST", parentObj.getVar("HST"));
		}		
	}	
	
	
}

var scCtypeMap  = new Array();
var arrNMKl  = new Array();

function getNMKLAttr(nId)
{
	if (arrNMKl[nId])
	{
		return arrNMKl[nId];
	}
	
	var o = new Object();	
	var oSnapPn = getSnap("select fis_pn1, fis_post, fvid from ^cl_nmk where fwid = " + nId);
	if(!oSnapPn)
		return null;
		
	o.IS_PN1 = oSnapPn[0]	 
	o.IS_POST = oSnapPn[1]
	o.VID = oSnapPn[2];
	arrNMKl[nId] = o;
	
	return o;
}

function DpXMLImp_afterSetValueRows(objRow, parentObj)
{
	if (!parentObj.instanceOf("NAKL")) return;
	var sLblDoc = parentObj.getVar("HDOC");	
	if(objRow.getVar("RUCENA"))
	{
		objRow.setVar("RUCENA", round(Number(objRow.getVar("RUCENA")), 4));
		objRow.setVar("RCENAORD", objRow.getVar("RUCENA"))
	}
	
	if (!objRow.getVar("RTNMK"))
		return;
	
	var oSnapPn = getNMKLAttr(objRow.getVar("RTNMK"));
	if(!oSnapPn)
	{
		if(objRow.getVar("R1ID"))
			objRow.setVar("R1ID", 0);		
		return;
	}

	var sNmklVid = oSnapPn.VID;
	if (!sNmklVid)
		sNmklVid = "";
	
	objRow.setVar("RNMKVID", sNmklVid);
	
	if(sLblDoc=="PN" || sLblDoc=="SA")
	{
		if(oSnapPn.IS_PN1=='+')
		{
			objRow.setVar("R1ID", objRow.getID());			
		}
		else
		{
			objRow.setVar("R1ID", 0);
		}
		
		if(oSnapPn.IS_POST && parentObj.getVar("HPOST"))
			objRow.setVar("RPOST", parentObj.getVar("HPOST"));
			
		//if(!ArrRTbl[k]["FCENA"])	
		
		//if(!ArrRTbl[k]["FCENA"])
		//	ArrRTbl[k]["FCENA"] = _nv2nv("", ArrRTbl[k]["FDATE"], 0, ArrRTbl[k]["FCENA"], ArrHTbl["FVAL"]);									
	}	
	
				
	
	if(!objRow.getVar("R1KOL") &&  objRow.getVar("RKOL"))
		objRow.setVar("R1KOL", objRow.getVar("RKOL"))
				
	
	if(objRow.getVar("RSC"))
	{	
		
		var sKey = objRow.getVar("RSC") + "|" + objRow.getVar("RSU") + "|" +  objRow.getVar("RST");  
		
		if (scCtypeMap[sKey])
		{
			objRow.setVar("RCTYPE", scCtypeMap[sKey]);
		}
		else
		{
			var strSql =" select fctype from ^cl_schet where fschet = "
			+ objRow.getVar("RSC") + sqlw0And("fsubschet = ", Number(objRow.getVar("RSU")))
			+ sqlw0And("fstat = ", objRow.getVar("RST"));
			var oSnapSc = getSnap(strSql);
			if(oSnapSc && oSnapSc[0])
			{
				objRow.setVar("RCTYPE", oSnapSc[0]);
				scCtypeMap[sKey] = oSnapSc[0];
			}
		}			
	}
	
	if(sLblDoc != "PN" && sLblDoc != "SA")
	{
		if(oSnapPn.IS_PN1=='+')
		{
			if(sLblDoc=="VR")
			{
				objRow.setVar("R1ID", 0);
			}
		}
		else
		{
			objRow.setVar("R1ID", 0);
		}
			
	   objRow.setVar("R2ID",objRow.getVar("R1ID"));
				
	}	
	
}

function DpXMLImp_searchExistingCL(obj)
{
	var nCl = obj.getVar("HCL");
	var outID = obj.getVar("HOUTID");
	var nCod = 	obj.getVar("HCOD");

	if(outID)
	{
		var oSnap = getSnap("SELECT FCOD FROM ^CLRELCLCL r, ^cl c  WHERE c.fwid = r.fwid_cl and foutid = "+sqlTo(outID)+" AND FCL = "+nCl);
		if(oSnap)
			return oSnap[0];
	}
	
	var nSearchFcl  = nCl;

	if(nCod)
	{
		var oSnap = getSnap("SELECT FCOD, fwid_cl FROM ^CLRELCLCL WHERE fcod = "
			+ nCod + " AND FCL = " + nSearchFcl);
		if(oSnap)
		{
			if(outID)
			{
					
					ExecuteSQL("UPDATE ^CL SET FOUTID = " + sqlTo(outID)
							+" WHERE FWID = "+sqlTo(oSnap[1]));
			}
			return oSnap[0];
		}
	}
	
	if(!(obj.getVar("HTXT") && obj.getVar("HOUTID")) && obj.getVar("HCOD_ST"))
	{
		var oSnap = getSnap("SELECT FCOD, c.FWID, c.foutid FROM  ^cl c, ^CL_POST p, ^CLRELCLCL r  WHERE c.fwid = p.fwid_cl AND c.fwid = r.fwid_cl and p.FCOD_ST ="
              + sqlTo(obj.getVar("HCOD_ST"))+" AND FCL = "+nCl);
		if(oSnap)
		{
             if(outID && outID != oSnap[2])
                 ExecuteSQL("UPDATE ^CL SET FOUTID = "+sqlTo(outID)+" WHERE FWID = "+sqlTo(oSnap[1]));
             return oSnap[0];
		}
	}
	
	/*	
	if(nVid == 2 && false)
	{
		var nodes  = XMLCl.selectNodes("rassch/ras_sch");
		for(var n = 0; n < nodes.length; n++)
		{
			var sRAsSc = nodes(n).text;
			if(!sRAsSc) continue;
			var sSQL = "select min(FCOD) from ^cl_orgrs o, ^clrelclcl r where r.fwid_cl = o.fwid_cl"
				+" o.fras_sch = "+sqlTo(sRAsSc);
			var oSnap = getSnap(sSQL);
			if(oSnap && oSnap[0])
				return oSnap[0];
		}
		
	}
	*/ 

	//Для справочника второго вида при наличии вн. ид. поиск по тексту не исп.
	if(!(outID && obj.sClassId == "CL2"))
		if(obj.getVar("HTXT"))
		{	
			var oSnap = getSnap("SELECT FCOD, r.FWID_CL , c.FOUTID FROM ^CLRELCLCL r, ^cl c  WHERE c.fwid = r.fwid_cl and FTXT = "
				+ sqlTo(obj.getVar("HTXT")) + " AND FCL = " + nCl);
			if(oSnap)
			{
				if(outID && outID != oSnap[2])
					ExecuteSQL("UPDATE ^CL SET FOUTID = "+sqlTo(outID)+" WHERE FWID = "+sqlTo(oSnap[1]));
				return oSnap[0];
			}
		}
		
	if(!outID && !obj.getVar("HTXT")
		&& nCod)
	{
		return nCod;
	}
	
	return -1;
		
}

function DpXMLImp_searchExistingObject(obj,codFld,txt)
{
	var sObjectTbl = "^" +String(obj.getTableName()).trim();	
	
	if(codFld)
		sCodRetFld = codFld;
	else
		sCodRetFld = "FCOD";
	
	if( obj.getVar("HCOD") && !obj.getVar("HOUTID"))
		return obj.getVar("HCOD");
	
	var outId = obj.getVar("HOUTID");
	
	if(outId)
	{
		var oSnap = getSnap("SELECT " + sCodRetFld + " FROM " + sObjectTbl 
				+ " WHERE FOUTID = "+sqlTo(outId));
		if(oSnap)
			return oSnap[0];
		 			
	}
	
	if (obj.getVar("HTXTS"))
	{
		var oSnap = getSnap("SELECT " + sCodRetFld + ", FOUTID FROM " + sObjectTbl 
			+ " WHERE "+(txt!=null?txt+"S":"FTXTS")+" = "+sqlTo(obj.getVar("HTXTS")));
		
		if(oSnap)
		{
			if(outId && oSnap[1] != outId)
			{
				ExecuteSQL("UPDATE ^"+ sObjectTbl + " SET FOUTID = "
					+sqlTo(outId)+" WHERE "+(txt!=null?txt+"S":"FTXTS")+" = "+sqlTo(obj.getVar("HTXTS")) );
			}
			return oSnap[0];			
		}
	}
	
	if (obj.getVar("HTXT"))
	{
		var oSnap = getSnap("SELECT " + sCodRetFld + ", FOUTID FROM " + sObjectTbl 
			+ " WHERE "+(txt!=null?txt:"FTXT")+" = "+sqlTo(obj.getVar("HTXT")));
		
		if(oSnap)
		{
			if(outId & oSnap[1] != outId)
			{
				ExecuteSQL("UPDATE ^"+ sObjectTbl + " SET FOUTID = "
					+sqlTo(outId)+" WHERE "+(txt!=null?txt:"FTXT")+" = "+sqlTo(obj.getVar("HTXT")) );
			}
			return oSnap[0];			
		}
	}
	return -1;	
}

function DpXMLImp_searchExistingVal(obj)
{
	var sCodRetFld = "FKOD";
	
	if( obj.getVar("HCOD") && !obj.getVar("HOUTID"))
		return obj.getVar("HCOD");
	
	var outId = obj.getVar("HOUTID");
	
	if(obj.getVar("HCOD") == 0)
	{
		if(outId)
			ExecuteSQL("UPDATE ^CL_VALUT SET FOUTID = "+sqlTo(outId)+" WHERE FKOD = 0");
		return 0;
	}
	
	if(obj.getVar("HNAZVS"))
	{
		var oSnap = getSnap("SELECT FKOD, FOUTID  FROM ^CL_VALUT WHERE FNAZVS = "+sqlTo(obj.getVar("HNAZVS")));
		if(oSnap)
		{
			if(outId & oSnap[1] != outId)
			{
					ExecuteSQL("UPDATE ^CL_VALUT SET FOUTID = "
						+ sqlTo(outId) + " WHERE FNAZVS = "
						+ sqlTo(obj.getVar("HNAZVS")));
			}
			return oSnap[0];
		}
	}
	
	if(outId)
	{
		var oSnap = getSnap("SELECT FKOD FROM ^CL_VALUT WHERE FOUTID = "+sqlTo(outId));
		if(oSnap)
			return oSnap[0];
	}
	
	if(obj.getVar("HCOD"))
	{
		var oSnap = getSnap("SELECT FKOD, FOUTID FROM ^CL_VALUT WHERE FKOD = "+sqlTo(obj.getVar("HCOD")));
		if(oSnap)
		{
			if(outId & oSnap[1] != outId)
					ExecuteSQL("UPDATE ^CL_VALUT SET FOUTID = "+sqlTo(outId)+" WHERE FKOD="+obj.getVar("HCOD"));
			return oSnap[0];
		}
	}			
}

var arrNmklOutId = new Array();

function DpXMLImp_importNmkl(xmlImp, sType)
{
	var obj = this.getObject(sType);
	this.fillHeaderVars(xmlImp, obj);
	
	if(!obj.getVar("HTXT0") && obj.getVar("HTXTS"))
			obj.setVar("HTXT0", obj.getVar("HTXTS"));
	
	if(obj.getVar("HCOD"))
	{
		//if(!obj.getVar("HTXT0") && !obj.getVar("HOUTID"))
		//	return obj.getVar("HCOD");
		var oSnap = getSnap("SELECT FCOD, FWID, fis_pn1, fis_post, fvid, foutid FROM ^CL_NMK WHERE FCOD = "+sqlTo(obj.getVar("HCOD")));
		if(oSnap)
		{
			if(obj.getVar("HOUTID"))
			{
				//ExecuteSQL("UPDATE ^CL_NMK SET FOUTID = "+sqlTo(obj.getVar("HOUTID"))+" WHERE FCOD = "+sqlTo(obj.getVar("HCOD")));
				
				var o = new Object();	
				o.IS_PN1 = oSnap[2]	 
				o.IS_POST = oSnap[3]
				o.VID = oSnap[4];
				arrNMKl[oSnap[1]] = o;
				arrNmklOutId[String(obj.getVar("HOUTID"))] = oSnap[1];  
				if (!oSnap[5] || String(obj.getVar("HOUTID")) != oSnap[5])
				{
					ExecuteSQL("UPDATE ^CL_NMK SET FOUTID = " 
							+ sqlTo(obj.getVar("HOUTID")) 
							+ " WHERE FCOD = "+sqlTo(obj.getVar("HCOD")));
				}
				// Проставляем артикул
				/*
				var cArt = '';
				xmlArt = XMLNmk.selectSingleNode("EXTENSIONS/ART");
				if(xmlArt)
					cArt = xmlArt.text;
				//alert(cArt);
				if (false && cArt)
				{
					var tNmkl = OpenTable('m',
						'SELECT *'
						+ ' FROM ^cl_nmk'
						+ ' WHERE fcod=' + sqlTo(ArrTbl["CL_NMK"]["FCOD"])
						);
					tNmkl.ExtTie("CL_NMK");
					if (false && tNmkl("#_ARTIKUL")!=cArt
							// 	&& confirm("Заменять " + tNmkl("#_ARTIKUL") + " на " + cArt + "?")
						)
					{
						tNmkl.Edit();
						tNmkl("#_ARTIKUL") = cArt;
						tNmkl.Update();
					}
					tNmkl.Close(5652);
				} 
				*/  
            
			}
			this.cntExistsNmkl++;
			return oSnap[1]; 		
		}
	}
	if(obj.getVar("HOUTID"))
	{
		if (arrNmklOutId[String(obj.getVar("HOUTID"))])
		{
			this.cntExistsNmkl++;
			return arrNmklOutId[String(obj.getVar("HOUTID"))];
		}
		
		var oSnap = getSnap("SELECT FWID, fis_pn1, fis_post, fvid FROM ^CL_NMK WHERE FOUTID = "+sqlTo(obj.getVar("HOUTID")));
		if(oSnap)
		{
			var o = new Object();	
			o.IS_PN1 = oSnap[1]	 
			o.IS_POST = oSnap[2]
			o.VID = oSnap[3];
			arrNMKl[oSnap[0]] = o;			
			this.cntExistsNmkl++;
			return oSnap[0];
		}
		
		if(!obj.getVar("HCOD"))
			obj.setVar("HCOD", obj.getVar("HOUTID"));	
	}	
	
	
	if(obj.getVar("HTXT0"))
	{
		var sNmkl = obj.getVar("HTXT0");
		sArt = obj.getVar("HARTICUL");
		if(sArt)
			sNmkl=sArt + ":" + sNmkl;
		obj.setVar("HTXTS", sNmkl);				
	}
	 
		
	//Не записывать номенклатуру без текстовки
	if(!obj.getVar("HTXT0") && !obj.getVar("HTXT0"))
	{
		//if(obj.getVar("HOUTID"))
		//	return obj.getVar("HOUTID");
		this.appendLog("WARNING: номенклатура с кодом "+obj.getVar("HCOD")+" не будет импортирована, т.к. отсутствует название");
		return null;
	}
	
	if (!obj.getVar("HISPOST"))
	{
		obj.setVar("HISPOST", getPar("def_post"));		
	}
	
	if (!obj.getVar("HISPN1"))
	{
		obj.setVar("HISPN1", getPar("def_pn1")?"+":"-");		
	}
	
	if (!obj.getVar("HNDS"))
	{
		obj.setVar("HNDS", getPar("NDSPROC"));		
	}
	
	
	var sCod = obj.getVar("HCOD");
	var n = sCod.lastIndexOf(".");
	
	if (n != -1)
	{
		var sParCod = sCod.substr(0, n + 1);
		var oSnap = getSnap("SELECT FWID FROM ^CL_NMK WHERE FCOD = "+sqlTo(sParCod));
		if (oSnap)
		{
			obj.setVar("HGRPID", oSnap[0]);
		} 												
	}
	
	var isExt = this.fillExt(xmlImp, obj)
	obj.save();
	this.cntNmkl++;
	if (this.isBuildNmklTree)
		updateTreeKeys("^cl_nmk", obj.getID(), new Array("fcod", "ftxts"));
	if (isExt)
		obj.saveExtToDB();
	var nID =  obj.getID();
	obj = null;
	return nID;
}

var arrObjs = new Array();

function DpXMLImp_getObject(sType, sSubType)
{
	var sKey = String(sType.toUpperCase());
	if (false && arrObjs[sKey] && !sType.startsWith("docs."))
	{
		arrObjs[sKey].clear()
		return arrObjs[sKey];
	}
		
	sType = String(sType)	
	if (sType.startsWith("cls."))
	{
		include ("Objects/DpClEx.js");		
		var nCl = 0;
		
		if (sType.startsWith("cls.CL1."))
		{
			var sCl = sType.substr(8);			
			if (isNaN(sCl))
			{
				var sCl = getPar(sCl);
				if 	(sCl)
				{
					nCl = Number(sCl);
				}
				sType = "CL1";
			}
			else
			{
				sType = "CL1";
				nCl = Number(sCl);
			}
		}
		else
		{
			sType = sType.substr(4)
		}
		
		return new DpClEx(sType, nCl);
		//arrObjs[sKey] = new DpClEx(sType, nCl);
		//return arrObjs[sKey];
	}
	else if (sType.startsWith("docs."))
	{
		include ("doc/DpDoc.js")
		return new DpDoc(sType.substr(5), 0);
		//arrObjs[sKey] = new DpDoc(sType.substr(5), 0);
		//return arrObjs[sKey];
	}
		
	return null;		
}

function DpXMLImp_fillHeaderVars(xmlObj, obj)
{
	var xmlHead = xmlObj.getElementsByTagName("Header")
	if (!xmlHead || xmlHead.length == 0)
		return
		
	xmlHead = xmlHead[0];
	var childs = xmlHead.getChildNodes();
	var nCount = childs.length;
	for(var n = 0;n < nCount; n++)
	{
		var xmlElement = childs[n];
		var sVar = xmlElement.getNodeName();			
		var vi = obj.getVarInfo(sVar);
		if (vi == null || vi.isCalc)
			continue;
		if (String(vi.objectType))
		{
			if (String(vi.objectType) == "IDPN")
			{
				this.getPn1(xmlElement, obj);
				continue;
			}
			var sImpFunc = this.getImpFunc(String(vi.objectType));
			if(!sImpFunc) continue;	
			
			if (typeof(this[sImpFunc]) != "function")
				continue;
			oVal = this[sImpFunc](xmlElement,String(vi.objectType));	
			//Вызываем полученую функцию и передаем ей елемент XML
			obj.setVar(sVar, oVal);			
		}
		else
		{	
			var sValue = xmlElement.getText();
			obj.setVar(sVar, this.dpApi.str2Obj(sValue,vi.dataType));
		}
	}
	
	return obj;
}

function DpXMLImp_compareHeaderVars(xmlObj, obj)
{
	var xmlHead = xmlObj.getElementsByTagName("Header")
	if (xmlHead && xmlHead.lengtn > 0)
		return true;
		
	xmlHead = xmlHead[0];
	var childs = xmlHead.getChildNodes();
	var nCount = childs.length;
	for(var n = 0;n < nCount; n++)
	{
		var xmlElement = childs[n];
		var sVar = xmlElement.getNodeName();			
		var vi = obj.getVarInfo(sVar);
		if (vi == null || vi.isCalc)
			continue;
		if (String(vi.objectType))
		{
			if (String(vi.objectType) == "IDPN")
				continue;

			var sImpFunc = this.getImpFunc(String(vi.objectType));
			if(!sImpFunc) continue;	
			
			if (typeof(this[sImpFunc]) != "function")
				continue;
			oVal = this[sImpFunc](xmlElement,String(vi.objectType));	
			//Вызываем полученую функцию и передаем ей елемент XML
			if (toScrObj(obj.getVar(sVar)) != toScrObj(oVal))
			{
				return false;
			}			
		}
		else
		{	
			var sValue = xmlElement.getText();
			if (toScrObj(obj.getVar(sVar)) != toScrObj(this.dpApi.str2Obj(sValue,vi.dataType)))
			{
				return false;
			}			
		}
	}
	
	return true;
}

function DpXMLImp_fillExt(xmlObj, obj)
{
	
	var xmlExt = xmlObj.getElementsByTagName("Extentions")
	if (xmlExt == null || xmlExt.length == 0)
		return false;
	
	var exts = xmlExt[0].getElementsByTagName("ext");
	var bRet = false;
	for (var i = 0; i < exts.length; i++)
	{
		var xmlExt = exts[i];
		var sLbl = xmlExt.getAttribute("name");
		var sType = xmlExt.getAttribute("type");		
		var sValue =  xmlExt.getText();
		obj.setExt(sLbl, this.dpApi.str2Obj(sValue, getDataType(sType)));
		bRet = true;
	}
	
	return bRet;	
}

function DpXMLImp_compareExt(xmlObj, obj)
{	
	var xmlExt = xmlObj.getElementsByTagName("Extentions")
	if (xmlExt == null || xmlExt.length == 0)
		return true;
	
	var exts = xmlExt[0].getElementsByTagName("ext");
	for (var i = 0; i < exts.length; i++)
	{
		var xmlExt = exts[i];
		var sLbl = xmlExt.getAttribute("name");
		var sType = xmlExt.getAttribute("type");		
		var sValue =  xmlExt.getText();
		if (obj.getExt(sLbl) == this.dpApi.str2Obj(sValue, getDataType(sType)));
			return false;
	}
	
	return true;	
}

function getDataType(sDT)
{
   switch (String(sDT)) 
   {
   	case "number":   		
   		return 2;
   	case "date":   		
   		return 3;
  	case "boolean":   		
   		return 5;

   	default:
   		return 1;
   	}

   return 1;
}

function DpXMLImp_importRegAttrs(obj, xmlObj)
{
	var regs = xmlObj.getElementsByTagName("reg");

	for (var i = 0; i < regs.length; i++)
	{
		var xmlReg = regs[i];
		var sReg = xmlReg.getAttribute("reg");		
		
		var childs = xmlReg.getChildNodes();
		var nCount = childs.length;
		for(var n = 0; n < nCount; n++)
		{
			var sVar = childs[n].getNodeName();
			var sVal = childs[n].getText();

			switch (sVar)
			{
				case "MNG":
				case "ZONE":
					obj.setRegAttr(sReg, sVar, this.dpApi.str2Obj(sVal, getDataType("number")));
					break;
				case "ISNOV1":
					obj.setRegAttr(sReg, sVar, this.dpApi.str2Obj(sVal, getDataType("boolean")));
					break;
				case "NK_DAT":
					obj.setRegAttr(sReg, sVar, this.dpApi.str2Obj(sVal, getDataType("date")));
					break;
				default:
					obj.setRegAttr(sReg, sVar, sVal);
					break;
			}					
		}
	}	
}

function DpXMLImp_appendLog(msg)
{
	var file = lpProxy.getInstallDirectory()+this.logFileName;
	if(isFile(file))
		msg = lpProxy.readFile(file,"utf8").replaceAll("\n", "\r\n")+"\r\n"+msg;
	lpProxy.writeToFile(msg,file,"utf8");
}