/*Описание объекта для выбора папки документов
 */
include("sys\\servis.js");
include("Objects/DpDocEx.js");

function DpzDoc (mdoc, mnop, docsAr, massSel)
{
	RO("DpzDoc", this);
   this.setCod  = DpzDoc_setCod;
   this.setDocNop = DpzDoc_setDocNop;
   this.zSetCod = DpzDoc_zSetCod;
   this.zSetDocEkz= DpzDoc_zSetDocEkz;
   this.getCod  = DpzDoc_getCod;
   this.getNop = DpzDoc_getNop;
   this.getDocEkz = DpzDoc_getDocEkz;
   this.linkCtrl = DpzDoc_linkCtrl;
   this.linkCtrlNop = DpzDoc_linkCtrlNop;
   this.linkCtrlDoc = DpzDoc_linkCtrlDoc;
   this.validCtrl = DpzDoc_validCtrl;
   this.updateCtrl = DpzDoc_updateCtrl;
   this.updateCtrlNop = DpzDoc_updateCtrlNop;
   this.updateCtrlDoc = DpzDoc_updateCtrlDoc;
   this.setZeroIsValid = DpzDoc_setZeroIsValid;
   this.setMode = DpzDoc_setMode;
   this.zeroIsValid = false;
   this.zaval = DpzDoc_zaval;
   this.getTxt = DpzDoc_getTxt;
   this.fillNopCombo = DpzDoc_fillNopCombo;
   this.linkSmartCtrl = DpzDoc_linkSmartCtrl;
   this.setContAssist = DpzDoc_setContAssist;
   this.fillContAssist = DpzDoc_fillContAssist;
   this.contAssistHandler = DpzDoc_contAssistHandler;
   
//   this.pFdoc   = null;
//   this.pFnop   = null;
//   this.ctrlCod = null;
//   this.ctrlNop = null;
   this.setCod(mnop);
   this.sMode = "";
   this.onlyDoc = null;
   this.canEmpty = false;
   this.docEx = new DpDocEx(mdoc, mnop);
   this.docsAr = docsAr;//в этот массив можно передать только те метки док-в, которые мы хотим видеть в дереве
   this.massSel = massSel;
   this.allTxt = UR("усі|все");
   this.arrNop = new Array();
   this.arrID = new Array();
}


function DpzDoc_setZeroIsValid(zeroIsValid)
{
   this.zeroIsValid = zeroIsValid!=false;
}

function DpzDoc_linkCtrl(newctrl, newTxtCtrl)
{
   	this.ctrlCod=newctrl;
   	this.ctrlTxt=newTxtCtrl;
   	if(newTxtCtrl)
   		Disable(this.ctrlTxt);
	this.ctrlCod.isButton = true;   
	if( typeof(this.ctrlCod)!= "object" )
		return false;
   	this.ctrlCod.mask = MASK_DOC;
	if(this.ctrlCod.DpType=="DpGet" || (JAVA && typeOf(this.ctrlCod) == "DpTextEx"))
		setButton(this.ctrlCod, this, "zaval");
   setValid(this.ctrlCod, this, "validCtrl");
}

function DpzDoc_validCtrl()
{
	isValid = this.zSetCod(this.ctrlCod.value,this.ctrlNop? this.ctrlNop.value: 0);
	if(this.ctrlNom)
	{
		if(isValid && this.pFdoc)
			Enable(this.ctrlNom);
		else
			Disable(this.ctrlNom);
	} 
	return isValid;
}

function DpzDoc_linkCtrlNop(newctrl2)
{   
   	this.ctrlNop=newctrl2;
   	//this.ctrlNop.mask = "######";
   	//if(this.massSel)
   	//	this.ctrlNop.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&";
   	setValid(this.ctrlNop, this, "validCtrl");
}

function DpzDoc_linkCtrlDoc(ctrlNom,ctrlDat)
{
	this.ctrlNom = ctrlNom;
	this.ctrlDat = ctrlDat;
   	this.docEx.linkCtrl(this.ctrlNom,this.ctrlDat);
   	Disable(this.ctrlNom);
}

function DpzDoc_updateCtrl()
{
  if(this.ctrlCod) this.ctrlCod.value = this.pFdoc;
  if(this.ctrlTxt) this.ctrlTxt.value = this.getTxt();
  if(typeOf(this.ctrlNop)=="DpCombo")	
   		this.fillNopCombo(this.ctrlNop);
  
  if(typeof this.subUpdate=="function")
  		this.subUpdate();
}

function DpzDoc_updateCtrlNop()
{
  	if(Number(this.pFnop))
  		this.pFnop = java.lang.Integer(this.pFnop);
  	if(this.ctrlNop)
  		this.ctrlNop.value = toScrObj(this.pFnop);
  	if(this.ctrlTxt)
  		this.ctrlTxt.value = this.getTxt();
}

function DpzDoc_updateCtrlDoc()
{
	this.docEx.setDoc(this.pFdoc);
	this.docEx.setNop(this.pFnop);
	if(this.docEx.getFwid()==0)
   		Disable(this.ctrlNom);
   	else
   		Enable(this.ctrlNom);
}

function DpzDoc_setCod(mdoc)
{
   this.pFdoc = mdoc;
   this.updateCtrl();
}

function DpzDoc_setDocNop(pnop)
{
   	//if (!isNaN(pnop))
	//	mnop = Number(pnop);
   	this.pFnop = pnop;
   	this.updateCtrlNop();
   	this.updateCtrlDoc();
}

function DpzDoc_zSetCod(mdoc, mnop)
{
	var strSQL, pFnop, pFdoc, tdoc;
	this.pFdoc = allt(mdoc);
	if (!isNaN(mnop))
		mnop = Number(mnop);
	this.pFnop = mnop;
	this.ok = true;
	this.isZaval = false;
	if (this.zeroIsValid && this.pFdoc == "")
		return this.ok;
	if (this.pFdoc != "null")
	{
		if(mnop==this.allTxt)
			mnop = "null";
		if (mnop == "null")
			strSQL = "select * from ^CL_LNK where Fdoc='"+ this.pFdoc +"'";
		else
			strSQL = "select * from ^CL_LNK where Fdoc=" + "'" + this.pFdoc	+"'"
					+ " and Fnop in (" + mnop +")";
		tdoc = OpenTable("s", strSQL);
		if (this.pFnop == "null")
			this.pFnop = 0;
		if (tdoc.IsEOF() && tdoc.IsBOF())
		{
			this.isZaval = true;
		}
	}
	else
		this.isZaval = true;
	if (this.isZaval && !this.canEmpty)
		this.ok = this.zaval()
	else
		this.ok = true;
	tdoc.Close();
	this.updateCtrl();
	this.updateCtrlNop();
	this.updateCtrlDoc();
	return this.ok;
}

function DpzDoc_getCod()
{
   return this.pFdoc;
}

function DpzDoc_getNop()
{
   	if(!this.pFnop)
   		return 0;
   	if(this.pFnop==this.allTxt)
   	{
   		if(this.arrNop.length>0)
   			return this.arrNop.toString();
   		return 0;
   	}
   	return this.pFnop;
}

function DpzDoc_zSetDocEkz (par){
    //завал
     this.makeZaval = false;
     this.ok = true;
     var tt;
     if (allt(par.docvid)=="") this.makeZaval = true;
        else {
           tt = OpenTable("s", "select * from ^CL_LNK where Ftxts="+"'"+par.docvid+"'");
           if (tt.IsEOF() && tt.IsBOF()) this.makeZaval = true;
           tt.Close();
      }

      if (!this.makeZaval){
          this.docName = allt(par.owndoc);
          this.fileName="";
          if (this.docName!=""){
             if (this.docName=="PP" || this.docName=="PV" || this.docName=="TR" || this.docName=="TP") this.fileName = "^RAS_SCH";
             if (this.docName=="BS") this.fileName = "^HBS";
             if (this.docName=="O1") this.fileName = "^O1";
             if (this.docName=="O7") this.fileName = "^O7";
             if (this.docName=="O4") this.fileName = "^O4";
             if (this.fileName!=""){
             tt = OpenTable("s", "select * from "+this.fileName+" where Fdoc="+"'"+par.owndoc+"'"+" and Fnop="+String(par.ownnop)+" and Fwid="+"'"+par.ownfid+"'");
             if (tt.IsEOF() && tt.IsBOF()) this.makeZaval = true;
             tt.Close();
          }
          if (this.fileName=="") this.makeZaval = true;
          }else this.makeZaval = true;
      }

      if (!this.makeZaval) {
              return this.ok;
      }

      var pr = new Object();
      pr.isZaval=true;
      pr.Zavaltype="zsys";
      pr.Zavalmode="zbv";
      if(this.docsAr)
      	pr.docsAr = this.docsAr;
      showWindow("l_cl_lnk.xml",SW_MODAL,pr,"");
      if ( typeof(pr.escape)!="undefined" && !pr.escape){
          this.owndoc = pr.owndoc;
          this.ownnop = pr.ownnop;
          this.owncalc = pr.owncalc;
          this.ownfid = pr.ownfid;
          this.org  = pr.org;
          this.sum  = pr.sum;
          this.nds  = pr.nds;
          this.sumtype  = pr.sumtype;
          this.dvid = pr.dvid;
          this.dnom = pr.dnom;
          this.comment = pr.comment;
          this.ok = true;
          var t = OpenTable("s", "CL_POST");
          t.Index = "CL_POST";
          if (t.seek("=", this.org)){		//-
             this.rassch = t.getValue("Fras_sch");
             this.mfo    = t.getValue("Fmfo");
             this.txt    = t.getValue("Ftxt");
             this.okpo   = t.getValue("Fcod_st");
          }else{
             this.rassch = "";
             this.mfo    = "";
             this.txt    = "";
             this.okpo   = 0;
          }
      }else{
          this.ok = false;
      }
      return this.ok;
}

function DpzDoc_getDocEkz()
{
   var oDoc = new Object();
   oDoc.org  = this.org;
   oDoc.dvid = this.dvid;
   oDoc.dnom = this.dnom;
   oDoc.rassch = this.rassch;
   oDoc.sumtype= this.sumtype;
   oDoc.sum  = this.sum;
   oDoc.nds  = this.nds;
   oDoc.mfo  = this.mfo;
   oDoc.owndoc = this.owndoc;
   oDoc.ownnop = this.ownnop;
   oDoc.ownfid = this.ownfid;
   oDoc.comment= this.comment;
   oDoc.ok     = this.ok;
   oDoc.makezaval = this.makeZaval;
   return oDoc;
}

function DpzDoc_zaval()
{
	var pr = new Object();
	pr.isZaval=true;
	pr.onlyDoc = this.onlyDoc;
	pr.ret = new Object();
	pr.ret.fwid = null;
	pr.ret.fdoc = this.pFdoc;
	pr.ret.fnop = this.pFnop;
	pr.menuMode = "SIMPLE";
	
	if (this.sMode == "allsys")
	{
		pr.allSys = true;
	}
	if(this.docsAr)
      	pr.docsAr = this.docsAr;
	showWindow("l_cl_lnk.xml",SW_MODAL,pr,"");
	
	if ( typeof(pr.escape)!="undefined" && !pr.escape)
	{
		this.pFdoc = pr.ret.fdoc;
		this.pFnop = pr.ret.fnop;
		this.arrNop = new Array();
		this.arrID = new Array();
		if(pr.retArray)
		{
			for(var i in pr.retArray)
			{
				this.arrNop[this.arrNop.length] = pr.retArray[i].fnop;
				this.arrID[this.arrID.length] = pr.retArray[i].fwid;
			}
		}
		else if(pr.ret.arrNop)
		{
			this.arrNop = pr.ret.arrNop;
		}

		if(this.arrNop && this.arrNop.length>0)
			this.pFnop = this.arrNop.toString();			
		if(pr.bAll)
			this.pFnop = this.allTxt;
		if(!this.pFnop)
			this.pFnop = 0;
		this.updateCtrl();
		this.updateCtrlNop();
		this.updateCtrlDoc();
		if(this.ctrlNop)
  			setFocus(this.ctrlNop);
	}
	return !pr.escape;
}

function DpzDoc_setMode(sMode)
{
	this.sMode = sMode;	
}   

function DpzDoc_getTxt()
{
	var sTxt = "";
	var sLbl = this.pFdoc;
	var nNop = this.pFnop;
	
	if(!sLbl || sLbl==null)
		return sTxt;
	if(!nNop || nNop==null || String(nNop).indexOf(",")!=-1 || !Number(nNop))
		nNop = 0;	
	
	var oDoc = getSnap("select ftxt from ^cl_lnk "
					+" where FDOC="+ sqlTo(sLbl)
						+" and FNOP="+ nNop, false);
	if(oDoc!=null)
		sTxt = oDoc[0];
	return UR(sTxt);
}

function DpzDoc_fillNopCombo(oCtrl)
{
	oCtrl.clear();

	if(!this.pFdoc || this.pFdoc==null || this.pFdoc=="")
	{
		oCtrl.addItem(0, "");
		oCtrl.value = java.lang.Integer(0);		
		return;
	}
	
	var tDoc = OpenTable("m", "select * from ^cl_lnk "
						+" where FDOC="+ sqlTo(this.pFdoc)
							+" and FNOP>0 "
						+" ORDER BY FNOP");	
	for(tDoc.MoveFirst(); !tDoc.isEOF(); tDoc.MoveNext())
	{
		var nop = toScrObj(tDoc.getValue("FNOP"));
		var txt = UR(tDoc.getValue("FTXT"));
		oCtrl.addItem(nop, nop +": "+ txt);
	}
	tDoc.close();

	if (!isEmpty(this.pFnop))
	{
		oCtrl.setValue(this.pFnop);
	}
}


function DpzDoc_linkSmartCtrl(oCtrl)
{
	smartCtrl = oCtrl;
	this.ctrlCod = oCtrl;	
	setButton(this.ctrlCod, this, "zaval");	
	this.updateCtrl();
}

function DpzDoc_setContAssist()
{
	if(!this.ctrlCod)
		return;
	this.ctrlCod.setContentAssistHandler(this, "fillContAssist", "contAssistHandler");
	this.showContentAssist = showContentAssist;
	//this.ctrlCod.setModifyHandler(this, "showContentAssist");
	this.isContAssist = true;
	Enable(this.ctrlCod, true);
}

function showContentAssist()
{
	if(smartCtrl && smartCtrl.getCtrl().isFocusControl())
		smartCtrl.showContentAssist();
}

function DpzDoc_contAssistHandler(str)
{
	var doc = str.substring(0, str.indexOf(":"));
	var nop = Number(str.substring(str.indexOf(":")+1));	
	this.setDocNop(nop);
	this.setCod(doc);
	this.ctrlCod.getCtrl().forceFocus();
}

function DpzDoc_fillContAssist(ca)
{
	if(!this.ctrlCod)
		return;
	var str = String(this.ctrlCod.value).trim();
	var sSQL = "select FDOC, FNOP, FTXT from ^cl_lnk where FNOP>0"
	if (str && str!="0" && str!="???")
	{
		sSQL += " and ("+ Convert("FTXT", "NVC") +" like "+ sqlTo(str +"%")
				+" or "+ Convert("FDOC", "NVC") +" like "+ sqlTo(str +"%")
				+")";
	}
	sSQL += " order by FDOC, FNOP, FTXT ";
	var tbl = OpenTable("s", sSQL);	
	while (!tbl.isEOF())
	{
		var doc = tbl.getValue("FDOC");
		var nop = tbl.getValue("FNOP");
		var txt = tbl.getValue("FTXT");
		ca.addItem(doc +":"+ nop, doc +":"+ nop +" - "+ txt);
		tbl.MoveNext();
	}
	tbl.close();
}