﻿/*
	Расчет баланса по коду
	(C) ДЕБЕТ Плюс, 1999-2000
*/

include("Oblns.js");
include("TrnNBln.js");

//vlad 03.02.2012
//Для возможности расчета акта сверки по конкретному договору добавили
//параметр dog
//function oblcod(dat1, dat2, nClcl, nCl, fnum) 
function oblcod(dat1, dat2, nClcl, nCl, fnum, dog)
// fnum - номер в настройке баланса по коду
// nClcl - номер справочника
// nCl - номер контрагента в справочнике
{
	DropTable("tmp_oblcod_cl_schet");
	
	var strNum = "";
	var isNum = false;
	var isDog = !isEmpty(dog);	//true, если расчет по конкретному договору
	if (fnum)
	{
		var tbl_num = OpenTable("SELECT * FROM ^KOD_SCH WHERE FNUM = " + fnum);
		if (!tbl_num.IsEmpty())
		{
			isNum = true;
			strNum = " AND exists (select * from ^KOD_SCH where FNUM = " + fnum
					+ " AND ^KOD_SCH.FSC = ^CL_schet.FSCHET "
					+ " AND ^KOD_SCH.FSU = ^CL_schet.FSUBSCHET "
					+ " AND ^KOD_SCH.FST = ^CL_schet.FSTAT )";
		}
		else
		{
			alert(ru("Список включенных счетов пуст!!!","Список включених рахунків пустий!!!"));
			return false;
		}
	}

	nClcl = String(nClcl);
	var sqlIn = " ( " + sqlTo(nClcl) + " ) ";
	if (nClcl == 0)
	{
		var tbl = OpenTable("SELECT * FROM ^CLCL WHERE FVID = '2'");
		if (tbl.IsEmpty())
			return;
			
		tbl.MoveFirst();
		sqlIn = "(" + sqlTo(toScrObj(tbl.getValue("FCOD")));
		tbl.MoveNext()
		while (!tbl.IsEOF())
		{
			sqlIn += "," + sqlTo(toScrObj(tbl.getValue("FCOD")));
			tbl.MoveNext();
		}
		sqlIn += ")"
		
		tbl.Close();
		tbl = null;
	}

	// выберем все счета, где встречается справочник nClcl
	strSQL = "SELECT"
				+" FVID, FSCHET, FSUBSCHET, FSTAT"
				+ ", FCL1 AS FCOD1"
				+ ", FCL2 AS FCOD2"
				+ ", FCL3 AS FCOD3"
				+ ", "+IIF("FCL1 IN " + sqlIn,"1", IIF("FCL2 IN " + sqlIn , "2", "3"))+" AS FCOL"
				+ ", "+(isDog? IIF("FCL1_TYPE=" + sqlTo("cntrct"),"1", IIF("FCL2_TYPE=" + sqlTo("cntrct"), "2", IIF("FCL3_TYPE=" + sqlTo("cntrct"),"3", "0")))
				:sqlTo(0))+" AS FCOL_DOG"
			+ " INTO tmp_oblcod_cl_schet"
			+ " FROM ^CL_schet"
			+ " WHERE (FCL1 IN " + sqlIn 
				 + " OR FCL2 IN " + sqlIn 
				 + " OR FCL3 IN " + sqlIn  + " ) "
				 + (isNum ? strNum:"")
	ExecuteSQL(strSQL);
	
	// создаем таблицу с результатами...
	DropTable("TMP_OBLCOD_RES");
	
	ExecuteSQL("CREATE TABLE TMP_OBLCOD_RES"
			+" ("
				+" fclass "+SqlType("LONG")
				+", fsc "+SqlType("LONG")
				+", fsu "+SqlType("LONG")
				+", fst "+SqlType("LONG")
				+", fcol "+SqlType("LONG")
				+", fcl_cod1 "+SqlType("LONG")
				+", fdog "+SqlType("LONG")	//Здесь будет ID договора
				+", fsum1 "+SqlType("DOUBLE")
				+", fsum2 "+SqlType("DOUBLE")
				+", fsum3 "+SqlType("DOUBLE")
				+", fsum4 "+SqlType("DOUBLE")
				+", fsum5 "+SqlType("DOUBLE")
				+", fsum6 "+SqlType("DOUBLE")
				+", fwid "+SqlType("COUNTER")
			+" )"
	);
	
	// ...и наполним её только НУЖНЫМИ записями
	if (!tbl_num.IsEmpty())
	{
		// проходим циклически по всем выбранным счетам
		for (tbl_num.MoveFirst(); !tbl_num.IsEOF(); tbl_num.MoveNext())
		{
			mFsc = toScrObj(tbl_num.getValue("FSC"));
			mFsu = toScrObj(tbl_num.getValue("FSU"));
			mFst = toScrObj(tbl_num.getValue("FST"));
			
			// рассчитаем обороты и остатки по счету
			objSc = new DpSc(mFsc, mFsu, mFst);
			DropTable("tmp_TrnNBln");
			TrnNBln("n3", "tmp_TrnNBln", dat1, dat2, objSc);

			// определим, какая аналитика нам нужна
			strSQL = "SELECT"
						+" FCOL"
						+", FCOL_DOG"
					+" FROM tmp_oblcod_cl_schet"
					+" WHERE 1=1"
						+" AND FSCHET="+sqlTo(mFsc)
						+" AND FSUBSCHET="+sqlTo(mFsu)
						+" AND FSTAT="+sqlTo(mFst)
			var s = getSnap(strSQL);
			if (s)
			{
				mFcol = s[0];
				mFcol_dog = s[1];
			}

			var isNCl = !isEmpty(nCl);

			// запишем отобранные данные в результатирующую таблицу
			strSQL = "INSERT INTO tmp_oblcod_res (fclass,fsc,fsu,fst,fcol,fcl_cod1,fdog,fsum1,fsum2,fsum3,fsum4,fsum5,fsum6)"
					+" SELECT t.fclass, t.fsc, t.fsu, t.fst"
							+(isNCl ? ", "+sqlTo(nCl)+" AS fcol" : ", fcl_cod"+mFcol+" AS fcol")
							+(isNCl ? ", "+sqlTo(nCl)+" AS fcl_cod1" : ", fcl_cod"+mFcol)
							+", "+((isDog && (mFcol_dog!=0)) ? "fcl_cod"+mFcol_dog:sqlTo(0))+" AS fdog"
							+ ", sum(t.fsum1) as fsum1"
							+ ", sum(t.fsum2) as fsum2"
							+ ", sum(t.fsum3) as fsum3"
							+ ", sum(t.fsum4) as fsum4"
							+ ", sum(t.fsum5) as fsum5"
							+ ", sum(t.fsum6) as fsum6"
					+" FROM tmp_TrnNBln t"
					+" WHERE 1=1"
							+(isNCl ? " AND fcl_cod"+mFcol+"="+sqlTo(nCl) : "")
							//Фильтр по договору
							+((isDog && (mFcol_dog!=0)) ? " AND  fcl_cod"+mFcol_dog+"="+sqlTo(dog):"")
					+" GROUP BY"
						+" fclass,fsc,fsu,fst"
						+(isNCl ? " " : ", fcl_cod"+mFcol)
						+((isDog && (mFcol_dog!=0)) ? ", fcl_cod"+mFcol_dog:"")
			ExecuteSQL(strSQL);
		}
	}
	tbl_num.Close();
	tbl_num = null;
	
	//fruckt
	ExecuteSQL("ALTER TABLE TMP_OBLCOD_RES ADD COLUMN FBDAT "+SqlType("DATETIME"));
	ExecuteSQL("ALTER TABLE TMP_OBLCOD_RES ADD COLUMN FEDAT "+SqlType("DATETIME"));
	
	strSQL = " UPDATE"
				+" TMP_OBLCOD_RES"
			+" SET"
				+" FBDAT = "+sqlTo(dat1)
				+", FEDAT = "+sqlTo(dat2)
	ExecuteSQL(strSQL);
	
	return true;
}