/**JScript source code 4 TXT_InterKonBank.js
*@author Sandy
*/
/**TF_GetExtention() не вызывается. Но если она есть и вызвана, то вернёт 
* маску экспорта. 
*/
function TF_GetExtention()
{
	return "*.txt";
}
/**ReadImpFile вызывается из DpCLB.js и создаёт документы типа DpDoc.
При отсутствии ошибок возвращает true.
@param sFilePath - полный путь к файлу с платёжками.
@param Noper - номер операции для папки, в которой стоим.
@param cimportpppv - отдельно или вместе закачивать документы типов PP PV.
@param cduplic - сообщать или нет о дублирующих документах. 
*/
function ReadImpFile(sFilePath, Noper, cimportpppv, cduplic)
{
	var sFile	= String(ReadTxtFile(sFilePath,"cp1251"));	
		nNewLine	= 0,
		nBlank		= 0,
		sLine		= "";
	//переменные для разбора файла
	//префиксы
	//s - sender
	//r - receiver
	var	sDocType,DOC_DAT,DOC_NUM,
		sNAME, sOKPO, sMFO, sACCOUNT,   
        rNAME, rOKPO, rMFO, rACCOUNT,
        TOVAR,SUM_UAH,FVAL,MYokpo,SUMMAstr,SUMMA;       	
	    	
	var	nIndex,year,month,day;
	MYokpo = getPar("OOKPO");
	while(sFile.length>0)
	{
		nNewLine	= sFile.indexOf('\n');
		if(-1 == nNewLine){
			sLine	= sFile;
			sFile	= "";
		}else{
			sLine	= sFile.substr(0, nNewLine);
			sFile	= sFile.substr(nNewLine+1);
		}
		//пропускаем пустые строки и && (allt(sLine.substring(0,8)!='Dtpd')
		if ((sLine.length != 0) && (allt(sLine.substring(0,8))!='Dtpd'))
		{	
		
			strArray = sLine.split("|");  
			strDATA = strArray[3].split(".");
			day   =   allt(strDATA[0]);
			month =   allt(strDATA[1]);
			year  =   allt(strDATA[2]);
			DOC_DAT = day+"/"+month+"/"+year;
			DOC_DATOBJ = Dp_DATEfromDMYm1(DOC_DAT);			
			SUMMA = "";			
			//berem по позиции элементов в строке между разделителями'|'.Рассматриваем строку,как элементы между'|' .			
			DOC_NUM = allt(strArray[1]); //Npd Номер документа  
			sMFO= allt(strArray[4]); //Dmfo МФО плательщика                                         
			sACCOUNT  = allt(strArray[5]); //Dacc Р/с плательщика с точками	
			sOKPO = allt(strArray[6]); //Dokpo Код ОКПО плательщика                                                                                
			sNAME	 = allt(strArray[8]); //Dpayname Название плательщика                                                               
			rMFO= allt(strArray[9]); //Cmfo МФО получателя          
			rACCOUNT  = allt(strArray[10]);//Cacc Р/с получателя                             
			rOKPO = allt(strArray[11]);//Cokpo Код ОКПО получателя             
			rNAME	 = allt(strArray[13]);//Cpayname Название получателя  
			SUMMAstr = (allt(strArray[14]));//Ammount Сумма # 0 в валюте
			SUMMAstrarr= SUMMAstr.split(String.fromCharCode(160));
			SUMMA=SUMMAstrarr.join("");
			SUMMA=SUMMA.replace(/ /gi,"");
			SUMMA=SUMMA.replace(/,/gi,".");
			FVAL     = DpValuta(allt(strArray[15]));//Currencu Валюта			
			if(SUMMA == "")
				SUMMA	= 0;
			else
				SUMMA	= 0 + SUMMA;
			SUM_UAH	= 0 + SUMMA;					
			TOVAR     = allt(strArray[17]);//Remark Назначение платежа  
			if(MYokpo==sACCOUNT)  
				sDocType = "PP";//мы платим.
			else 
				sDocType = "PV";   				                                                       
			//здесь из переменных переносим все в запись
			if (!cimportpppv || (cimportpppv == true && DocType == sDocType))	
			{			
				var platDoc = new DpDoc(sDocType, Noper);						
				platDoc.setVar("HNOM", DOC_NUM);
				platDoc.setVar("HTOT", sNAME);
				platDoc.setVar("HCOT", sOKPO);
				platDoc.setVar("HMFOOT", sMFO);					
				platDoc.setVar("HDBSC", sACCOUNT);
					
				platDoc.setVar("HTTO", rNAME);			
				platDoc.setVar("HCTO", rOKPO);
				platDoc.setVar("HMFOTO", rMFO);				
				platDoc.setVar("HCRSC", rACCOUNT);
	
				platDoc.setVar("HVAL", FVAL);
				platDoc.setVar("HTOVAR", TOVAR);
				platDoc.setVar("HSUM", SUM_UAH);
				platDoc.setVar("HNDS", round((SUM_UAH/6),2));   			
				platDoc.setVar("HDAT", DOC_DATOBJ);					

				if (cduplic)//proverka dyblei
				{
					if(platDoc.getVar("HDAT")!=null && platDoc.getVar("HNOM")!=null && platDoc.getVar("HSUM")!=null)
					{
						var sqlStr = "SELECT * from ^RAS_SCH WHERE FDOC_NUM = "
							+sqlTo(platDoc.getVar("HNOM"))+" AND FDOC_DAT = "+sqlTo(platDoc.getVar("HDAT"))
							+" AND FDOC = " + sqlTo(sDocType)
							+" AND FFCR_SC = "+sqlTo(platDoc.getVar("HCRSC"))+" AND FFDB_SC = "+sqlTo(platDoc.getVar("HDBSC"))
							+" AND FSUM = "+sqlTo(platDoc.getVar("HSUM"))+" AND FTOVAR = "+sqlTo(platDoc.getVar("HTOVAR"));
						var tdup = OpenTable("s",sqlStr);								
						if (tdup.recordCount > 0)
						{										
							alertStr1 = UR("ОБНАРУЖЕНО "+tdup.recordCount+" ДОКУМЕНТОВ С ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
							+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
							+"\nСУММA "+platDoc.getVar("HSUM")+", ТИП ДОКУМЕНТА "+sDocType
							+"\nИ НАЗНАЧЕНИЕ ПЛАТЕЖА-"+platDoc.getVar("HTOVAR") 
							+"|ЗНАЙДЕНО "+tdup.recordCount+" ДОКУМЕНТІВ З ПАРАМЕТРАМИ: НОМЕР "+allt(platDoc.getVar("HNOM"))+","
							+" ДАТA "+format("dd.mm.yyyy",tdup.getValue("FDOC_DAT"))+","
							+"\nСУМA "+platDoc.getVar("HSUM")+", ВИД ДОКУМЕНТУ "+sDocType
							+"\nТА ПРИЗНАЧЕННЯМ ПЛАТІЖНОГО ДОКУМЕНТУ-"+allt(platDoc.getVar("HTOVAR")));
							alertStr2 = UR("ДОКУМЕНТ С ТАКИМИ САМЫМИ ПАРАМЕТРАМИ ВЫ ИМПОРТИРУЕТЕ.|ДОКУМЕНТ З ТАКИМИ САМИМИ ПАРАМЕТРАМИ ВИ ІМПОРТУЄТЕ.");
							alertStr3 = "\n\n"+UR("ИМПОРТИРОВАТЬ ДОКУМЕНТ?|ІМПОРТУВАТИ ДОКУМЕНТ?");
							alertStr = alertStr1+"\n"+alertStr2+alertStr3+tdup.getValue("FDOC_DAT");
							var bAnswer = confirm(alertStr)
							if (!bAnswer)//importirovat6
							{
								continue;
							}
						}
					}
				}											
				var HORG = 0;
				if (sDocType == "PP")
				{
					HORG = getOrgNum(platDoc.getVar("HCTO"),platDoc.getVar("HMFOTO"),platDoc.getVar("HCRSC"));//(OKPO,MFO,RSCH)
				}
				else
				{
					HORG = getOrgNum(platDoc.getVar("HCOT"),platDoc.getVar("HMFOOT"),platDoc.getVar("HDBSC"));
				}
				if (HORG == null)
					HORG = 0;	
				platDoc.setVar("HORG", HORG);	
				platDoc.save();	
			}			
			
		}	
	}
	return true;
}