include("gridedit.js");
var defDBName = "dpbase";
var selectedTemplate = null;
var oldSUBD = "DERBY";
var isEmbedded = false;

function wizardInit()
{
	this.isEditMode = String(Task.getMenuMode()) == "EDIT";
	if(this.isEditMode)
		Caption("Редагування з’єднання|Редактирование соединения");
	else
		Caption("Створення з’єднання|Создание соединения");
	FORM.getContainer().setMinimumPageSize(200, 350);
}

function onSUBDValid()
{
	if (comboSUBD.value == "DERBY" || comboSUBD.value == "H2" || comboSUBD.value == "HSQLDB")
	{
		DERBYGRP.visible = true;
		SETTINGSGRP.visible = false;
		isEmbedded = true;
	}
	else
	{
		DERBYGRP.visible = false;
		SETTINGSGRP.visible = true;
		isEmbedded = false;
		
		//lblBaseName.text=(comboSUBD.value != "MSSQL" && comboSUBD.value != "MYSQL")?UR("Ім’я схеми данних|Имя схемы данных"):UR("Ім’я бази данних|Имя базы данных");
	}
	
	//if (FORM.getCurrentPage() && FORM.getCurrentPage().getName() == settingsPage.getName())
	//	FORM.getContainer().updateButtons();
	
	DBPORT.mask = "######";
	
	var nDefPort = 0;
	switch(String(comboSUBD.value))
	{
		case "ORACLE":
			nDefPort = 1521;
			break;
		case "MSSQL":
			nDefPort = 1433;
			break;
		case "POSTGRE":
			nDefPort = 5432;
			break;
		case "MYSQL":
			nDefPort = 3306;
			break;
	}
	
	var defBaseName = "";
	switch(String(comboSUBD.value))
	{
		case "ORACLE":
			defBaseName = "ORCL";
			break;
		case "MSSQL":
			defBaseName = defDBName;
			break;
		case "POSTGRE":
			defBaseName = "postgres";
			break;
		case "MYSQL":
			defBaseName = defDBName;
			break;
	}
	
	var defSchemaName = "";
	switch(String(comboSUBD.value))
	{
		case "ORACLE":
			defSchemaName = defDBName.toUpperCase();
			break;
		case "MSSQL":
			defSchemaName = "";
			break;
		case "POSTGRE":
			defSchemaName = defDBName;
			break;
		case "MYSQL":
			defSchemaName = "";
			break;
	}
	
	if(DBPORT.value == 0 || oldSUBD != String(comboSUBD.value))
		DBPORT.value = nDefPort;

	DBSCHEMA.value = defSchemaName;
	var isSchema = !inList(String(comboSUBD.value) , "MSSQL", "MYSQL");
	DBSCHEMA.setEnabled(isSchema);
	
	if(!isSchema && DBBASE.value == "")
		DBBASE.value = defBaseName;
	
	
	DERBYGRP.getParent().layout(true, true);
	
	onUseMultiBase();
	oldSUBD = comboSUBD.value;
}

function onBaseSetValid()
{
	if (USEBASESETTING.checked)
	{
		SETTINGSPATH.setEnabled(false);
	}
	else
	{
		SETTINGSPATH.setEnabled(true);
	}
	
}

function onUseMultiBase()
{
	var currentPage = FORM.getCurrentPage();
	if (currentPage && currentPage.getName() == settingsPage.getName())
		FORM.getContainer().updateButtons();
	
	var isSchema = !inList(String(comboSUBD.value) , "MSSQL", "MYSQL");
	DBSCHEMA.setEnabled(isSchema && !USEMULTYBASE.checked);	
	DBBASE.setEnabled(isSchema || !USEMULTYBASE.checked);
}

function wizardPageCreated()
{
	radio.value = 0;
	DBHOST.value="localhost";
	setValid(comboSUBD, onSUBDValid);
	setValid(USEMULTYBASE, onUseMultiBase);
	setValid(DBPATH, onDERBYPathValid);
	setValid(USEBASESETTING, onBaseSetValid)
	
	
	var bases = ["ALL_MDB","CL_MDB","MTR","MTR_OST","PR_MDB","ZRPU_MDB","ZRP_MDB","ZRP_RES","CDR","CDR_RES","UJ","EXT","UID"];
	this.baseTbl = createObjectTable();
	this.baseTbl.setIdFld("FLABEL");
	for (var i = 0; i < bases.length; i++)
	{
		this.baseTbl.AddNew();
		this.baseTbl.setValue("FLABEL", bases[i]);
		this.baseTbl.setValue("FBASE", "");
		this.baseTbl.Update();
	}
	
	this.gridBaseMenuInit = baseGridMenuInit;	
	gridBase.loadMenuHandler(this,"gridBaseMenuInit");
	gridBase.setCycleEdit(true);
	dpGridEdit = new DpGridEdit(gridBase);
	gridBase.setTable(this.baseTbl);
	
	
	
	if (!this.isEditMode)
	{
		this.fillTemplateBase = fillTemplateBase;
		this.fillTemplateBase();
	}
	
	this.fillParam = fillParam;
	if (this.isEditMode)
	{
		this.fillParam();	
		comboSUBD.value = String(BASEXML.getAttribute("SUBD"));
		oldSUBD = String(comboSUBD.value);		
	}
	gridBase._build();
	onSUBDValid();
	onBaseSetValid();
	
}

function fillParam()
{
	NAMECONN.value =  String(BASEXML.getAttribute("TEXT")); 
    //var serverName =  COMPNAME
    comboSUBD.value = BASEXML.getAttribute("SUBD");
    
    var settingsPath = BASEXML.getAttribute("DOCPARPATH");
    if (String(settingsPath).startsWith("dborg:"))
    {
    	USEBASESETTING.checked = true;
    	SETTINGSPATH.value = "";
    }
    else
    	SETTINGSPATH.value = BASEXML.getAttribute("DOCPARPATH");
    
    isEmbedded = inList(String(comboSUBD.value), "DERBY", "HSQLDB", "H2");
    
    
    if (isEmbedded)
    {
    	DBPATH.value = BASEXML.getAttribute("SERVER");    	
    }
    else  if (comboSUBD.value == "ORACLE" || comboSUBD.value == "POSTGRE")
    {
    	var serverHOST =  String(BASEXML.getAttribute("COMPNAME"));
    	if(!serverHOST)
    		serverHOST = "localhost";
    	DBHOST.value = serverHOST;
    	DBBASE.value = BASEXML.getAttribute("SERVER");
    }
    else
    	DBHOST.value = BASEXML.getAttribute("SERVER"); 
    
    var nPort = parseInt(BASEXML.getAttribute("PORT"));
    if(isNaN(nPort))
    	nPort = 0;
    DBPORT.value = nPort; 
        
    var sUseForAll = String(BASEXML.getAttribute("USEFORALL"));
    
    if (sUseForAll)
    {
    	defDBName = sUseForAll; 
        USEMULTYBASE.value = false;
    }
    else
    {
    	defDBName = "";
    	USEMULTYBASE.value = true;
    }
    
    var sUseAuthorize = String(BASEXML.getAttribute("USEAUTHORIZE"));
    if (sUseAuthorize) //$NON-NLS-1$
    {
    	USEDPAUTOR.checked = true;
    }
    else
    	USEDPAUTOR.checked = false;
    
    
    if(!isEmbedded)
    {
    	CONNPARAM.value = BASEXML.getAttribute("OTHERPARAMS");  
    }
    
    
    if(!USEMULTYBASE.checked)
    	return;
    
    var nodes = BASEXML.getChildNodes();
    var arrBases = new Array();
    for (var i = 0; i < Number(nodes.getLength()); i++)
    {
         var tmpNod = nodes.item(i);
         if (tmpNod.getNodeName().charAt(0) != '#' && !tmpNod.getNodeName().equals("STRU")) //$NON-NLS-1$
         {
             arrBases[String(tmpNod.getNodeName()).toUpperCase()] = allt(String(tmpNod.getTextContent()));
         }
    }
    
    this.baseTbl.moveFirst();
	while (!this.baseTbl.isEOF())
	{
		
		var lbl = this.baseTbl.getValue("FLABEL");
		if (lbl && arrBases[String(lbl).toUpperCase()])
		{
			this.baseTbl.Edit();
			this.baseTbl.setValue("FBASE", arrBases[String(lbl).toUpperCase()]);
			this.baseTbl.Update();
		}
		this.baseTbl.moveNext();
	}
    
}

function wizardGetStartingPage()
{
	if(this.isEditMode)
	{
		return settingsPage;
	}
	else
	{
		return startPage;
	}
		
}

function onDERBYPathValid()
{
	if (DBPATH.value && !String(SETTINGSPATH.value))
		SETTINGSPATH.value = DBPATH.value; 
		 
}

function fillTemplateBase()
{
	this.templateTbl = createObjectTable();
	this.templateTbl.setIdFld("FLABEL");
	
	var dir = new DpFile(rootDirectoryEx() + "Source/dbtempl");
	if (dir.exists() && dir.isDirectory())
	{
		var files = dir.listFiles();
		for (var i = 0; i< files.length; i++)
		{
			if (!files[i].isDirectory())
			{
				var name = String(files[i].getName());				
				if (name.endsWith(".zip"))
				{
					var lbl = name.substring(0, name.length - 4);
					this.templateTbl.AddNew();
					this.templateTbl.setValue("FLABEL", lbl);
					this.templateTbl.setValue("FTEXT", getTemplateInfo(lbl));
					this.templateTbl.Update();
				}
			}
			
		}		
	}
	this.templateTbl.MoveFirst();
	
	
	gridTemblate.setTable(this.templateTbl);
	gridTemblate._build();	
}

function getTemplateInfo(lbl)
{
	var ret = lbl;
	var fileZip = rootDirectoryEx() + "Source/dbtempl/" + lbl + ".zip";
	if(isFile(fileZip))
	{
		var tmpFile = tempDirectory();
		if(lpProxy.extractTo(fileZip, tmpFile ,"info.txt", false))
		{
			
			var str = lpProxy.readFile(tmpFile + "info.txt", "utf8");
			if (str)
				ret = str;
		}
	}
	return ret;
}

function baseGridMenuInit()
{
	if(IsDblClick(gridBase))
	{
		gridBase.runGridMenu("EDIT");
		return;
	}
	
	gridBase.AddMenuItem("EDIT","Редагувати|Редактировать");	
}
function wizardСanFlipToNextPage(currentPage)
{
	var currentPage = FORM.getCurrentPage();
	
	if (String(currentPage.getName()) == String(settingsPage.getName()))
	{
		return USEMULTYBASE.checked && !isEmbedded;
	}
	else if (String(currentPage.getName()) == String(basesPage.getName()))
	{
		return false;
	}
	return true;
}

function wizardСanFlipToNextPage(currentPage)
{
	var currentPage = FORM.getCurrentPage();
	
	if (String(currentPage.getName()) == String(settingsPage.getName()))
	{
		return USEMULTYBASE.checked && !isEmbedded;
	}
	else if (String(currentPage.getName()) == String(basesPage.getName()))
	{
		return false;
	}
	return true;
}

function wizardGetNextPage(currentPage)
{
	if (String(currentPage.getName()) == String(startPage.getName()))
	{
		if (radio.value == 1)
			return templatePage;
		return settingsPage;
	}
	else if (String(currentPage.getName()) == String(templatePage.getName()))
	{
		return settingsPage;
	}
	else if (String(settingsPage.getName()) == String(settingsPage.getName()))
	{
		return basesPage;
	}
	
}

function wizardGetPreviousPage()
{
	if(this.isEditMode && String(settingsPage.getName()) == String(settingsPage.getName()))
		return null;
}

function wizardPageChanging(ev)
{
	if(String(ev.getTargetPage().getName()) == String(settingsPage.getName())
			&& String(ev.getCurrentPage().getName()) == String(templatePage.getName()))
	{
		gridTemblate.syncRecordset();
 		var lbl = String(gridTemblate.getTable().getValue("FLABEL"));
 		var name = String(gridTemblate.getTable().getValue("FTEXT"));
 		
		if (String(NAMECONN.value) == "")
		{
			NAMECONN.value = name;
		}
		
		if (String(SETTINGSPATH.value) == "")
		{
			var dirName = lpProxy.getInstallDirectory() + "base/" + lbl;
			SETTINGSPATH.value = dirName; 
		}
		
		if (String(DBPATH.value) == "")
		{
			var dirName = lpProxy.getInstallDirectory() + "base/" + lbl;
			DBPATH.value = dirName; 
		}
		defDBName = lbl;
			
	}
			
}

function onFinish()
{
	var doc = BASEXML.getOwnerDocument();
     var tmpN;
     while((tmpN = BASEXML.getFirstChild()) != null)
     {
    	 BASEXML.removeChild(tmpN);
     }
     
     var isSchema = !inList(String(comboSUBD.value) , "MSSQL", "MYSQL");
     
     if(isEmbedded)
     {
    	 BASEXML.setAttribute("SERVER",DBPATH.value); //$NON-NLS-1$
     }
     else
     {
    	 BASEXML.setAttribute("SERVER", isSchema?DBBASE.value:DBHOST.value); //$NON-NLS-1$
     }
     
     
     if(inList(String(comboSUBD.value) , "ORACLE", "POSTGRE"))
     {
    	 BASEXML.setAttribute("COMPNAME", DBHOST.value);    	 
     }
     
     BASEXML.setAttribute("PORT", DBPORT.value); //$NON-NLS-1$
     
     BASEXML.setAttribute("SUBD",comboSUBD.value); 
     BASEXML.setAttribute("TEXT",NAMECONN.value); 
     if (USEBASESETTING.checked && !isEmbedded)
    	 BASEXML.setAttribute("DOCPARPATH","dborg:/");    	 
     else
    	 BASEXML.setAttribute("DOCPARPATH",isEmbedded?DBPATH.value:SETTINGSPATH.value);
    	 
     
     if (isEmbedded)
     {
    	 BASEXML.setAttribute("USEFORALL", "DPBASE");
     }
     else if (!USEMULTYBASE.checked)
     {
    	 BASEXML.setAttribute("USEFORALL",isSchema?DBSCHEMA.value:DBBASE.value); 
     }
     else
     {
    	 BASEXML.setAttribute("USEFORALL",""); 
     }
     
     if (USEDPAUTOR.checked || isEmbedded)
    	 BASEXML.setAttribute("USEAUTHORIZE","1"); 
     else
    	 BASEXML.setAttribute("USEAUTHORIZE",""); 
     
     if(!isEmbedded)
     {
    	 BASEXML.setAttribute("OTHERPARAMS",CONNPARAM.value);  
     }
     
     gridBase.Lock();
     
     this.baseTbl.moveFirst();
 	 while (!this.baseTbl.isEOF())
 	 {
 		
 		 var lbl = String(this.baseTbl.getValue("FLABEL")).toUpperCase();
 		 var base = String(this.baseTbl.getValue("FBASE")).toLowerCase();
 		 var newNod = doc.createElement(lbl);
 		 newNod.setTextContent(base);
 		 if (!lbl.equals("SYS") && !lbl.equals("SPAR")) //$NON-NLS-1$ //$NON-NLS-2$
 		 {
 			 newNod.setAttribute("MODE",""); //$NON-NLS-1$ //$NON-NLS-2$
 		 }
 		 BASEXML.appendChild(newNod);
 		 this.baseTbl.moveNext();
 	 }
 	
 	 
 	 if(Number(radio.value) == 1)
 	 {
 		gridTemblate.syncRecordset();
 		var lbl = gridTemblate.getTable().getValue("FLABEL");
 		var ret = runImportBase(lbl);
 		if(!ret)
 			return false;
 	 }
 	 
 	 var orgMngr = lpProxy.getOrgManager();
	 if (orgMngr == null)
		 return;
	 
	 if(!this.isEditMode && ROOTXML)
		ROOTXML.appendChild(BASEXML);
	 orgMngr.saveOrgs();
 	 
}

function runImportBase(lbl)
{
	var ret = lbl;
	var fileZip = rootDirectoryEx() + "Source/dbtempl/" + lbl + ".zip";
	if(!isFile(fileZip))
		return false;
	
	var connection = base_wizard_getConnection();
	if(connection == null)
		return false;
	
	var tmpDir = tempDirectory() + lbl;
	deleteDir(tmpDir);
	createDirectory(tmpDir);
	
	if(!lpProxy.extractTo(fileZip, tmpDir ,null, true))
	{
		alert("Ошибка при распаковке шаблона");
		connection.close();
		return false;
	}
	
	var par = new Object();
	par.importer = lpProxy.getUtils().getMDBImporter();
	par.importer.setConnection(connection);
	par.tables = null;
	par.sFile = tmpDir + "/base.mdb";
	par.otherBase = true;
	par.actionType = "IMPORT";
	par.sBase = "DPBASE";
	if (inList(String(comboSUBD.value), "MYSQL", "MSSQL"))
		par.sBase = DBBASE.value;
	else if (isEmbedded)
		par.sBase = "DPBASE";
	else
		par.sBase = DBSCHEMA.value;
	showWindow("export_progress.xml", SW_MODAL, par);
	connection.close();
	var settingsDir = isEmbedded?DBPATH.value:SETTINGSPATH.value;
	createDirectory(settingsDir);
	deleteFile(par.sFile);
	copyDir(tmpDir, settingsDir);	
	return true;
	
	
}

function base_wizard_getConnection()
{
	var connectionString = getConnectionString();
	var user = getUserName();
	var password = "";
	if (String(comboSUBD.value) != "DERBY")
	{
		var dlg = lpProxy.getLoginDialog();
		if (dlg.open(UR("Підключення до СКБД|Подключение к СУБД")) != dlg.OK)
            return false;
		user = dlg.getLogin();
		password = dlg.getPass();
	}
	else
	{
		if(String(comboSUBD.value) == "DERBY")
			checkDerbyDir(DBPATH.value);
	}
	
	var connection = null; 
	try
	{
		connection = getDBConnectionEx(connectionString, user, password);
		if (inList(String(comboSUBD.value), "DERBY", "POSTGRE", "H2"))
		{
			var schemaName = isEmbedded?"DPBASE":String(DBSCHEMA.value).toLowerCase(); 
			ExecSQL(connection, "CREATE SCHEMA " + schemaName, false);
		}
	}
	catch(ex)
	{
		alert(ex);
	}
	return connection;
}

function checkDerbyDir(dir)
{
	if(!isDir(dir))
		return;
	
	var oDir = new DpFile(dir);
	var isEmptyDir = true;
	var files = oDir.listFiles();
	if(files.length == 0)
		deleteDir(dir);
}


function getConnectionString()
{
	var strConn = "";
	switch(String(comboSUBD.value))
	{
		case "ORACLE":
			strConn = "jdbc:oracle:thin:@" + DBHOST.value + ":" + DBPORT.value 
				+ ":" + DBBASE.value;
            return strConn;
		case "DERBY":		 
            strConn = "jdbc:derby:" + DBPATH.value + ";create=true";
			break;
		case "MSSQL":
			strConn = "jdbc:sqlserver://" + DBHOST.value + ":" + DBPORT.value 
				+ ";selectMethod=cursor";
            return strConn;
		case "POSTGRE":
			strConn = "jdbc:postgresql://"+ DBHOST.value + ":" + DBPORT.value + "/" + DBBASE.value;
			break;
		case "MYSQL":
			strConn = "jdbc:mysql://" +DBHOST.value + ":" + DBPORT.value + "/"
            	+ DBBASE.value + "?useUnicode=true&characterEncoding=utf8";
			break;
		case "H2":
			strConn = "jdbc:h2:" + DBPATH.value + "/dpbase";
			break;
	}
	return strConn;
}