include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("servis/date.js");

var nMonths = 6;

var label = "bdeb";
var tblOut = "tmp_debtors";
var sHomoTbl = "CL_HOMO";

function listLoad()
{
	with( list )
	{
		title = ru("Долги", "Борги");
		subMake = tbl_refresh;
		printLabel = "BDEB";
		editTask = "bill_e_rem.xml";
		accDel = acceptDel;
		accEdit = acceptEdit;
	}
}

function acceptDel()
{
	return false;
}

function acceptEdit()
{
	return "E";
}

function listSrc()
{
	var sFamSort = ru("Сортировка по фамилии","Сортування за прізвищем");
	var sAdrSort = ru("Сортировка по адресу","Сортування за адресою");
	/*
	with(list)
	{
		qryAlias = "a";
		qrySet("Fields" , "a.*"
			, "From", tblOut + " a, ^CLRELCLCL b, ^CL c, ^"+ sHomoTbl +" d"
			, "Ptn", "BILL_DEBTORS"
			, "Where", " a.FCLIENT = b.FWID_CL "
				//+" AND b.FCL = "+getPar("bill_cl")
				+" AND c.FWID = b.FWID_CL"
				+" AND d.FWID_CL = b.FWID_CL "				
			, "Order", Array("c.FTXT, d.FSTREET, d.FBLD, d.FLETTER, d.FCORP, d.FAPART, d.FOWNER",
							   "d.FSTREET, d.FBLD, d.FLETTER, d.FCORP, d.FAPART, d.FOWNER, c.FTXT") 
			, "OrderName", Array(sFamSort, sAdrSort)
			);
		
		subTie("CLRELCLCL", "CLREL", "FWID_CL", "Fclient");
		subTie("CL", "x_cl", "FWID", "Fclient");
		subTie(sHomoTbl, "homo", "FWID_CL", "Fclient");		
	}
	*/
	this.qryAlias = "a";
	this.qrySet("Fields" , "*"
			, "From", tblOut + " a inner join ^LISTCL3 as homo on homo.FWID=a.FCLIENT "
			, "Ptn", "BILL_DEBTORS"
			, "Where", " homo.FCL="+ getPar("bill_cl")
			, "Order", Array("homo.FADDR, homo.FBLD, homo.FLETTER, homo.FCORP, homo.FAPART, homo.FOWNER"
				 ,"homo.FTXT, homo.FADDR, homo.FBLD, homo.FLETTER, homo.FCORP, homo.FAPART, homo.FOWNER") 
			, "OrderName", Array(sAdrSort, sFamSort)
			);
}

var ls = 13;
var ps = 10;
var ts = ps+5+5+3+3+5;
var qs = 10;
var ss = 10;
function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	
	with(oGrid)
	{
		defCond("=^fsls==1", "DISCON_BY_WILL");
		defCond("=^fsls==2", "DISCON_FOR_DEBT");
		defCond("=^fsls==3", "DISCON_OUT");

		color(15, "DISCON_BY_WILL");
		color(10, "DISCON_FOR_DEBT");
		color(1,  "DISCON_OUT");
	}
	
	with(oGrid.page())
	{	
		with(group("Клієнт|Клиент"))
		{
			cell("FCOD", "№", 5, "", "", "", "CLS.CL2", "FCOD", "");
			cell("FTXT", "Назва|Название", 14);
			with(group("Адреса|Адрес"))
			{
				cell("FADDR", "Вулиця|Улица", 10);
				cell("FBLD", "Будинок|Дом", 5, "!zn0", "%5d");
				cell("FLETTER", "Буква|Буква", 5);
				cell("FCORP", "Корпус|Корпус", 5, "!zn0", "%5d");
				cell("FAPART", "Квартира|Квартира", 5, "!zn0", "%5d");
				cell("FOWNER", "Власн.|Влад.", 5, "!zn0", "%5d");
				cell("FZIP", "Індекс|Индекс", 6);
			}
			cell("Fphone", "Телефон", 8);
		}
		
		with(group("На сьогодні|На сегодня"))
		{
			cell("fsum0", "Загальний борг|Общий долг", 10);
			with(group("Замісяць|За месяц"))
			{
				cell("fbsum0", "Борг на початок|Долг на начало", 10, "", DP_FORMAT_SUM);
				cell("foosum0", "Оплата|Оплата", 10, "", DP_FORMAT_SUM)
				cell("fousum0", "Послуги|Услуги", 10, "", DP_FORMAT_SUM)
				cell("fesum0", "Борг на кінець|Долг на конец", 10, "", DP_FORMAT_SUM);
			}
			with(group("Взаєморозрахунок|Взаиморасчет"))
			{
				cell("fusum0", "Послуги|Услуги", 10, "", DP_FORMAT_SUM)
				cell("fosum0", "Оплата|Оплата", 10, "", DP_FORMAT_SUM)
			}
			cell("foversum", "Переплата|Переплата", 10, "", DP_FORMAT_SUM);
			cell("FREM", "Коментар|Комментарий", 15, "w");
			with(group())
			{
				cell("FDISCONDATE", "Дата відключення|Дата отключения", 7);
				//alternate("DISCON_BY_WILL").cell("fdiscondate", "Дата\nотключения", 7);
				//alternate("DISCON_FOR_DEBT").cell("fdiscondate", "Дата\nотключения", 7);
			}
		}
		if(extPar && extPar.mode=="ALL")
		{
			for(i=1; i<=nMonths; i++)
			{
				with(group("Місяць - |Месяц -"+ i))
				{
					cell("fsum"+i, "До сплати|К оплате", 10);
					with(group("За місяць|За месяц"))
					{
						cell("fbsum"+i, "Борг на початок|Долг на начало", 10, "", DP_FORMAT_SUM);
						cell("foosum"+i, "Оплата|Оплата", 10, "", DP_FORMAT_SUM)
						cell("fousum"+i, "Послуги|Услуги", 10, "", DP_FORMAT_SUM)
						cell("fesum"+i, "Борг на кінець|Долг на конец", 10, "", DP_FORMAT_SUM);
					}
					with(group("Взаєморозрахунок|Взаиморасчет"))
					{
						cell("fusum"+i, "Послуги|Услуги", 10, "", DP_FORMAT_SUM)
						cell("fosum"+i, "Оплата|Оплата", 10, "", DP_FORMAT_SUM)
					}
					cell("FREM", "Коментар|Комментарий", 15, "w");
					with(group())
					{
						cell("FDISCONDATE", "Дата відключення|Дата отключения", 7);
						cell("fsls", "Статус|Статус", 7);
						//alternate("DISCON_BY_WILL").cell("fdiscondate", "Дата\nотключения", 7);
						//alternate("DISCON_FOR_DEBT").cell("fdiscondate", "Дата\nотключения", 7);
					}
				}
			}
		}
		//DataSource().finderID="BILL_DEBT";		
	}
	oGrid.build();
}

function listMenuInit(ds)
{
   	with(ds)
   	{
      	var t = getTable();
      	if(t.IsEmpty())
			return;
		    
      	AddMenuItem("SHOW_HISTORY", ru("Карточка клиента", "Картка кліента"));
      	AddMenuItem("SHOW_ALL_MONTH", ru("Данные за 6 месяцев", "Дані за 6 місяців"));
      	if(Number(t.getValue("fsls")) == 0)
      	{
			AddMenuItem("");
			AddMenuItem("DISCONNECT_FOR_DEBT", "Відключити за несплату|Отключить за неуплату");
	  	}
   	}
}

function listMenuRun(ID)
{
	var d = DataSource();
	var t = d.getTable();
	switch(ID)
	{
		case "SHOW_HISTORY":
			oPar = new Object();
			oPar.fclient = t.getValue("FCLIENT");
			showWindow("bill_history.xml", SW_MODAL, oPar);
			break;
		
		case "SHOW_ALL_MONTH":
			oPar = new Object();
			oPar.mode = "ALL";
			showWindow("bill_debtors.js", SW_NOMODAL, oPar);
			break;
			
		case "DISCONNECT_FOR_DEBT":
			var gd = new DpGetDat("D");
			if (gd.escape)
				break;
					
			ExecuteSQL("UPDATE ^"+ sHomoTbl
				+ " SET fsls=2"	//за неуплату
				+ " WHERE fwid_cl="+ t.getValue("FCLIENT")				
				);
			/*
			ExecuteSQL("UPDATE ^bill_tariff "
				+ " SET fedate = " + sqlTo(gd.dat2)
				+ " WHERE fclient = " + t.getValue("FCLIENT")
					);
			*/	
			ExecuteSQL("UPDATE ^bill_iterated"
				+ " SET fedate = " + sqlTo(gd.dat2)
				+ " WHERE fclient = " + t.getValue("FCLIENT")
					+ " AND fedate>" + sqlTo(gd.dat2)
				);				
			break;
			
		default:
			break;
	}
}	

function listAsk()
{
	if(extPar && extPar.mode=="ALL")
		return true;
	gd = new DpGetDat(new Array("dat"));	
	return gd;
}

function tbl_refresh()
{	
	if(extPar && extPar.mode=="ALL")
		return true;
	
	var sMsg = UR("Виконується розрахунок...|Выполняется расчет...");
	WAIT(sMsg);
	
	if(IsTable(tblOut) && !ExecuteSQL("drop table "+ tblOut, false))
	{
		 alert("Невозможно выполнить расчет."
		 	+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 	+"\nили перезапустите систему.");
		 return false;	 
	}
	
	var s0 = Convert(0, "MONEY");
	var sOsum = sqlIIF("fdoc='BO'", "fsum", s0)
	var sUsum = sqlIIF("fdoc='BU'", "fsum", s0)
	
	var sMonths = "";
		
	// fsum1 = долг на последний месяц
	// fusm2 = долг на предпоследний месяц
	// и т.д.
	for(var i=0; i<=nMonths; i++)
	{ 
		dMDate = goMonth(list.objAsk.fdat, -i);
		
		dUDate = firstDay(dMDate);
		dODate = lastDay(dMDate);
		 
		var sFusum = "SUM("+ sqlIIF("fdate" + (i==0?"<=":"<=") + sqlTo(dUDate), sUsum, s0) +")";
		var sFosum = "SUM("+ sqlIIF("fdate" + (i==0?"<=":"<=") + sqlTo(dODate), sOsum, s0) +")";
		if(i==0)
			sMonths = ", "+ sqlIIF(sFosum +"-"+ sFusum +">0", sFosum +"-"+ sFusum, 0) +" AS foversum";
		sMonths += ", "+ sFusum +" AS fusum"+ i
			+", "+ sFosum +" AS fosum"+ i
			+", "+ sqlIIF(sFusum +"-"+ sFosum +">0", sFusum +"-"+ sFosum, 0) +" AS fsum"+ i
			+", SUM("+ sqlIIF("fdate BETWEEN "+ sqlTo(dUDate) +" AND "+ sqlTo(dODate), sOsum, "0")+ ") AS foosum"+ i
			+", SUM("+ sqlIIF("fdate BETWEEN "+ sqlTo(dUDate) +" AND "+ sqlTo(dODate), sUsum, "0")+ ") AS fousum"+ i
			+", SUM("+sqlIIF("fdate<" + sqlTo(dUDate), sUsum + "-" + sOsum, 0) +") AS fbsum"+ i
			+", SUM("+sqlIIF("fdate<="+ sqlTo(dODate), sUsum + "-" + sOsum, 0) +") AS fesum"+ i
	}	
	
	var sFld = " FCLIENT, FDISCONDATE, FOVERSUM";
	var sSQL = "create table "+ tblOut 
			+" (FCLIENT "+ SqlType("INT") 
			+", FDISCONDATE "+ SqlType("DATE")
			+", FOVERSUM "+ SqlType("CURRENCY")
			+", FWID "+ SqlType("COUNTER");
	for(i=0; i<=nMonths; i++)
	{
		sSQL += ", FUSUM"+ i + SqlType("CURRENCY")
			   +", FOSUM"+ i + SqlType("CURRENCY")
			   +", FSUM"+ i + SqlType("CURRENCY")
			   +", FOOSUM"+ i + SqlType("CURRENCY")
			   +", FOUSUM"+ i + SqlType("CURRENCY")
			   +", FBSUM"+ i + SqlType("CURRENCY")
			   +", FESUM"+ i + SqlType("CURRENCY")
		sFld += ", FUSUM"+ i +", FOSUM"+ i +", FSUM"+ i
			   +", FOOSUM"+ i +", FOUSUM"+ i +", FBSUM"+ i 
			   +", FESUM"+ i;	   
	}
	sSQL += ")";	
	ExecuteSQL(sSQL);
	createIndex(tblOut, "FCLIENT", "FCLIENT");
	WAIT(sMsg);
	
	// временная таблица для присоединения к расчетной таблице
	// последних дат отключения
	var sTmpTbl = "tmp_deb_disconn_date2";	
	DropTable(sTmpTbl);	
	ExecuteSQL("SELECT fclient, MAX(fedate) AS fdiscondate"
			   + " INTO "+ sTmpTbl
			   + " FROM ^bill_iterated"
			   + " GROUP BY fclient"
			   );
	createIndex(sTmpTbl, "FCLIENT", "FCLIENT");
	createIndex(sTmpTbl, "FDISCONDATE", "FDISCONDATE");
	WAIT(sMsg);
	
	// расчетная таблица	
	ExecuteSQL("insert into "+ tblOut +"("+ sFld +")"
			+" select a.fclient, b.fdiscondate"+ sMonths
			+" from ^rbill a"
				+" LEFT JOIN "+ sTmpTbl +" b "
						+ " ON a.fclient = b.fclient"
			+" GROUP BY a.fclient, b.fdiscondate");
	/*
	ExecuteSQL("SELECT a.fclient, fdiscondate "
				+ sMonths
				+ " INTO "+ tblOut
				+ " FROM ^rbill a"
					+ " LEFT JOIN tmp_deb_disconn_date b"
						+ " ON a.fclient = b.fclient"
				+ " GROUP BY a.fclient, fdiscondate"
				//+ " HAVING fsum0>0"
				);				
	ExecuteSQL("alter table "+ tblOut +" add fwid "+ SqlType("COUNTER"));			
	*/
	CLEARWAIT();
}

function getConDate(fclient)
{
	var date = "";
	var oSnap = getSnap("select FDATE from ^RBILL "
			+" where FCLIENT="+ fclient 
				+" and fdoc='BU' order by FDATE", false);
	if(oSnap)
		date = StrDat(oSnap[0], "DMY");		
	return date;	
}

function getStatus(nCod)
{
	var sText = "п";	//ru("Подключен","Підключений");
	switch(Number(nCod))
	{	
	case 1:
		sText = "з";	//ru("Отключен по заявлению","Відключений по заяві");
		break;
	case 2:
		sText = "н";	//ru("Отключен за неуплату","Відключений за несплату");
		break;
	case 3:
		sText = "в";	//ru("Съехал","Виїхав");
		break;
	default:
		//sText = ru("Подключен","Підключений");
		break;
	}
	return sText;
}

function getPackName(orgID)
{
	var oSnap = getSnap("select FTXTS from ^CL_NMK n "
				+" inner join ^BILL_ITERATED b on b.FNMKL=n.FWID "
				+" where b.FCLIENT="+ orgID
			, false);
	if(oSnap)
		return oSnap[0];
	return "";
}

function listOnPrnList(tv)
{			
	tv.eval.addVar("DATE", list.objAsk.fdat);
}

include("sys/DpList.js");