//импорт основных средств для Боярки

include("objects/DpXMLDomDocument.js");
include("servis/format.js");
include("servis/date.js");

var k;
var baseDat = new Date(2009,0,1);

function importCls(path)
{
	//k = 1;
	var xmlDom = new DpXMLDOMDocument();
	if(path)
		var sPath = path;
	else
		var sPath = "F:\\Boyarka\\Tori\\Uos";
	url = "jdbc:odbc:DRIVER=Microsoft Visual FoxPro Driver;SourceType=DBF;SourceDB=" + sPath;
	connUOS = getDBConnection(url, "", "")
	var root = xmlDom.createChild("root");
	
//	clearAll();
	//if(!importOSMetals(root, connUOS))
	//	return false;
	//importOSNazv(root, connUOS);//лучше использовать importOSNAZV()
	//importOSNAZV()
	importIzmBuhNal(root, connUOS);
//	importOS(root, connUOS);
//	
	xmlDom.save(sPath+"\\import.xml");
//alert("save xml end")
	include("import.js");
	var impPar = new Object();
	var oImp = new DpXMLImport(impPar);
    oImp.ImportObject(root);
//	updateCls(root, connUOS);
}

function importOSNazv(root, conn)
{
	var tbl  = OpenExtTable(conn, "SELECT * FROM OSNSR  ORDER BY n_invent");
	
	var i = 0;
	while (!tbl.isEOF())
	{
		i++;
		var xmlObj = root.createChild("object", null, {type:"cls.osnazv"});
		var header = xmlObj.createChild("Header");
		header.createChild("HCOD", Number(String(tbl.getValue("N_INVENT")).trim()));		//инв.номер
		header.createChild("HTXT", String(tbl.getValue("NAME")).trim());	//название ОС
		header.createChild("HOUTID", String(tbl.getValue("N_INVENT")).trim());
		tbl.moveNext();
		//if (k!=null && i>k)
		//	break;
	}
	tbl.close();
}

function importOSMetals(root, conn)
{
	include("objects/DpCl.js")
	var tbl  = OpenExtTable(conn, "SELECT * FROM OSNSR ORDER BY n_invent");
	var oCl = new DpCl();
	if(getPar("CODMET")==0)
	{
		alert("В установке параметров УОС установите код справочника металлов." +
				"\nЕсли такого справочника аналитики не существует, то создайте простой справочник." +
				"\nВ справочнике должно быть 4 записи со следующими кодами:" +
				"\n1 - золото\n2 - платина\n3 - серебро\n4 - др.металлы");
		return false;
	}
	oCl.setClcl(getPar("CODMET"));
	var i = 0;
	while (!tbl.isEOF())
	{
		i++;
		invnum = Number(tbl.getValue("N_INVENT"));
		zol = Number(tbl.getValue("ZOLOTO"));
		plat = Number(tbl.getValue("PLATINA"));
		ser = Number(tbl.getValue("CEREBRO"));
		dr = Number(tbl.getValue("KAMNI"));
		if(zol>0)
		{
			var xmlObj = root.createChild("object", null, {type:"cls.metals"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", invnum);	//инв.номер
			header.createChild("HNUM", 1);		//код металла
			header.createChild("HKOL", zol);	//количество
			oCl.setCod(1);
			header.createChild("HTXT", oCl.getTxt());//текстовка
		}
		if(plat>0)
		{
			var xmlObj = root.createChild("object", null, {type:"cls.metals"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", invnum);	//инв.номер
			header.createChild("HNUM", 2);		//код металла
			header.createChild("HKOL", plat);	//количество
			oCl.setCod(2);
			header.createChild("HTXT", oCl.getTxt());//текстовка
		}
		if(ser>0)
		{
			var xmlObj = root.createChild("object", null, {type:"cls.metals"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", invnum);	//инв.номер
			header.createChild("HNUM", 3);		//код металла
			header.createChild("HKOL", ser);	//количество
			oCl.setCod(3);
			header.createChild("HTXT", oCl.getTxt());//текстовка
		}
		if(dr>0)
		{
			var xmlObj = root.createChild("object", null, {type:"cls.metals"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", invnum);	//инв.номер
			header.createChild("HNUM", 4);		//код металла
			header.createChild("HKOL", dr);		//количество
			oCl.setCod(4);
			header.createChild("HTXT", oCl.getTxt());//текстовка
		}
		tbl.moveNext();
		if (k!=null && i>k)
			break;
	}
	tbl.close();
	return true;
}

/*function importEdi(root, conn)
{
	var tbl  = OpenExtTable(conn, "SELECT * FROM N_EDIZM");
	while (!tbl.isEOF())
	{
		var sOutID = String(tbl.getValue("SK_ЕДИЗМ"));
		if (sOutID && sOutID != "" && sOutID.trim() != "")
		{
			var xmlObj = root.createChild("object", null, {type:"cls.edi"});
			var header = xmlObj.createChild("Header");
			header.createChild("HOUTID", sOutID);
			header.createChild("HTXTF", String(tbl.getValue("И_ЕДИЗМ")).trim());	
			header.createChild("HTXTS", String(tbl.getValue("Ш_ЕДИЗМ")).trim());			
		}
		tbl.moveNext();
	}
	tbl.close();
}*/

/*function importNemakt(root, conn)//справочник норм амортизации по н/активам
{
	var tbl  = OpenExtTable(conn, "SELECT * FROM N_GRUPOS");
	var i = 0;
	while(!tbl.isEOF())
	{
		i++;
		var xmlObj = root.createChild("object", null, {type:"cls.naktos"});
		var header = xmlObj.createChild("Header");
		header.createChild("HFCOD_VID", String(tbl.getValue("GROUP")));
		header.createChild("HCOD_VID", Number(tbl.getValue("SUBGROUP")));	
		header.createChild("HCOD_PVID", Number(tbl.getValue("CLASS")));
		header.createChild("HGROUP", Number(tbl.getValue("TYPE")));
		header.createChild("HTXT", String(tbl.getValue("NAME")).trim());
		header.createChild("HTXTS", String(tbl.getValue("NAME_K")).trim());
		//для нашего справочника поле Fcod_norm 
		header.createChild("HCOD_NORM", 0);
		//связь OSNSR с N_GRUPOS осуществляется по полю Kod_os, которое состоит из склеиных попорядку 4 полей
		header.createChild("HOUTID", String(tbl.getValue("GROUP"))+String(tbl.getValue("SUBGROUP"))+String(tbl.getValue("CLASS"))+String(tbl.getValue("TYPE")));
		tbl.moveNext();
		//if (k!=null && i>k)
		//	break;
	}
	tbl.close();
}*/

function importIzmBuhNal(root, conn)
{
	/*var tbl  = OpenExtTable(conn, "SELECT d.*,p.dt,p.kt,z.ш_стзатр,o.n_invent,o.pol_is,n.k_grup,n.pr_buh "
									+" FROM DVIG AS d LEFT JOIN PROV AS p ON d.sk_dvig=p.sk_dvig "
										+" LEFT JOIN OSNSR AS o ON d.sk_os=o.sk_os "
										+" LEFT JOIN N_VIDOSN AS n ON o.sk_vidosn=n.sk_vidosn "
										+" LEFT JOIN N_STZATR AS z ON p.sk_stzatr=z.sk_stzatr ORDER BY n_invent");*/
	var tbl  = OpenExtTable(conn, "SELECT d.*,np.dt,np.kt,o.n_invent,o.pol_is,o.k_zatrat,n.k_grup,n.pr_buh "
									+" FROM DVIG AS d LEFT JOIN OSNSR AS o ON d.sk_os=o.sk_os "
										+" LEFT JOIN N_PROV AS np ON d.sk_oper=np.sk_oper "
										+" LEFT JOIN N_VIDOSN AS n ON o.sk_vidosn=n.sk_vidosn "
										//+" LEFT JOIN PROV AS p ON p.sk_dvig=d.sk_dvig "
										//+" LEFT JOIN N_STZATR AS z ON p.sk_stzatr=z.sk_stzatr "
										+" ORDER BY n_invent");
	var i = 0;
	while(!tbl.isEOF())
	{
		i++;
		//в VN_PEREM_ALL запишем все записи, которые не относятся к внутренним перемещениям, чтобы в последствии дополнить справочник внутренних перемещений
		//if(String(tbl.getValue("PR_IST")).trim()!='3' && String(tbl.getValue("PR_IST")).trim()!='2')
		if(String(tbl.getValue("PR_IST")).trim()=='1')
		{
			//>>>VN_PEREM
			var xmlObj = root.createChild("object", null, {type:"cls.vn_perem_all"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", Number(tbl.getValue("N_INVENT")));
			
			var xmlMol = header.createChild("HMOL");								//МОЛ
			var headMol = xmlMol.createChild("Header");
			headMol.createChild("HOUTID", String(tbl.getValue("K_FIO")));
			
			var xmlPodr = header.createChild("HPODR");								//подразделение приёмник
			var headPodr = xmlPodr.createChild("Header");
			headPodr.createChild("HOUTID", String(tbl.getValue("K_STPODR")));
			
			var xmlPodro = header.createChild("HPODRO");							//подразделение источник
			var headPodro = xmlPodro.createChild("Header");
			headPodro.createChild("HOUTID", String(tbl.getValue("K_IST")));
			
			header.createChild("HBDAT", format("dd.mm.yyyy",tbl.getValue("D_DVIG")));//дата начала (дату конца прийдется потом апдейтить днем раньше от даты начала следующей записи)
			header.createChild("HEDAT", "01.01.3000");
			header.createChild("HAREND", "-");
			var oSc = new Object();
			oSc.schet = String(tbl.getValue("K_ZATRAT"));
			if(parseSchet(oSc,"/"))													//затратный счёт
			{
				header.createChild("HSC", oSc.sc);			
				header.createChild("HSU", oSc.su);
				header.createChild("HST", oSc.st);
			}
			//<<<VN_PEREM
		}
		/*if(String(tbl.getValue("PR_IST")).trim()!='3')//не внутреннее перемещение
		{
			//>>>OS0B
			var xmlObj = root.createChild("object", null, {type:"cls.os0b"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", Number(tbl.getValue("N_INVENT")));
			header.createChild("HORIG_PRIC", Number(tbl.getValue("BALSTOIM")));		//первоначальная стоимость
			header.createChild("HIZM_IZN", Number(tbl.getValue("IZMIZN")));			//изменение износа по б/у
			header.createChild("HBDAT", format("dd.mm.yyyy",tbl.getValue("D_DVIG")));//дата начала (дату конца прийдется потом апдейтить днем раньше от даты начала следующей записи)
			header.createChild("HEDAT", "01.01.3000")
			header.createChild("HGROUP", Number(tbl.getValue("K_GRUP")));			//група
			header.createChild("HSROKADD", Number(tbl.getValue("POL_IS")));			//срок использования
			header.createChild("FCOD_RATE", getSrokCod(Number(tbl.getValue("POL_IS"))));//код срока использования
			header.createChild("HBUHMETOD", Number(tbl.getValue("PR_BUH")));		//метод расч.аморт.по б/у
			header.createChild("HKF_ISPOL", 1);										//коэф.использования
			header.createChild("HKOL", Number(tbl.getValue("KOL")));				//количество
			header.createChild("HAREND", "-");										//признак аренды
		
			var oSc = new Object();
			oSc.schet = String(tbl.getValue("DT"));
			if(parseSchet(oSc,"/"))													//дебет счёт
			{
				header.createChild("HDB_SC", oSc.sc);			
				header.createChild("HDB_SU", oSc.su);
				header.createChild("HDB_ST", oSc.st);
			}
			oSc.schet = String(tbl.getValue("KT"));
			if(parseSchet(oSc,"/"))													//кредит счёт
			{
				header.createChild("HCR_SC", oSc.sc);			
				header.createChild("HCR_SU", oSc.su);
				header.createChild("HCR_ST", oSc.st);
			}
			var oSc = new Object();
			oSc.schet = String(tbl.getValue("K_ZATRAT"));
			if(parseSchet(oSc,"/"))													//затратный счёт
			{
				header.createChild("HZC", oSc.sc);			
				header.createChild("HZU", oSc.su);
				header.createChild("HZT", oSc.st);
			}
			//>>>>>>>>>
			var xmlMol = header.createChild("HMOL");								//МОЛ
			var headMol = xmlMol.createChild("Header");
			headMol.createChild("HOUTID", String(tbl.getValue("K_FIO")));
			
			var xmlPodr = header.createChild("HPODR");								//подразделение приёмник
			var headPodr = xmlPodr.createChild("Header");
			headPodr.createChild("HOUTID", String(tbl.getValue("K_STPODR")));
			
			var xmlPodro = header.createChild("HPODRO");							//подразделение источник
			var headPodro = xmlPodro.createChild("Header");
			headPodro.createChild("HOUTID", String(tbl.getValue("K_IST")));
			//<<<<<<<<<
			//<<<OS0B
			//>>>OS0
			var xmlObj = root.createChild("object", null, {type:"cls.os0"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", Number(tbl.getValue("N_INVENT")));
			header.createChild("HORIG_PRIC", Number(tbl.getValue("BALSTOIM")));		//первоначальная стоимость
			header.createChild("HIZM_IZN", Number(tbl.getValue("IZMIZN_N")));		//изменение износа по н/у
			header.createChild("HBDAT", format("dd.mm.yyyy",tbl.getValue("D_DVIG")));//дата начала (дату конца прийдется потом апдейтить днем раньше от даты начала следующей записи)
			header.createChild("HEDAT", "01.01.3000")
			header.createChild("HGROUP", Number(tbl.getValue("K_GRUP")));			//група
			header.createChild("HSROKADD", Number(tbl.getValue("POL_IS")));			//срок использования
			header.createChild("FCOD_RATE", getSrokCod(Number(tbl.getValue("POL_IS"))));//код срока использования
			header.createChild("HKF_ISPOL", 1);										//коэф.использования
			header.createChild("HKOL", Number(tbl.getValue("KOL")));				//количество
			header.createChild("HAREND", "-");										//признак аренды
		
			var oSc = new Object();
			oSc.schet = String(tbl.getValue("DT"));
			if(parseSchet(oSc,"/"))													//дебет счёт
			{
				header.createChild("HDB_SC", oSc.sc);			
				header.createChild("HDB_SU", oSc.su);
				header.createChild("HDB_ST", oSc.st);
			}
			oSc.schet = String(tbl.getValue("KT"));
			if(parseSchet(oSc,"/"))													//кредит счёт
			{
				header.createChild("HCR_SC", oSc.sc);			
				header.createChild("HCR_SU", oSc.su);
				header.createChild("HCR_ST", oSc.st);
			}
			//<<<OS0
		}
		if(String(tbl.getValue("PR_IST")).trim()=='3' || String(tbl.getValue("PR_IST")).trim()=='2')
		{
			//>>>VN_PEREM
			var xmlObj = root.createChild("object", null, {type:"cls.vn_perem"});
			var header = xmlObj.createChild("Header");
			header.createChild("HCOD", Number(tbl.getValue("N_INVENT")));
			
			var xmlMol = header.createChild("HMOL");								//МОЛ
			var headMol = xmlMol.createChild("Header");
			headMol.createChild("HOUTID", String(tbl.getValue("K_FIO")));
			
			var xmlPodr = header.createChild("HPODR");								//подразделение приёмник
			var headPodr = xmlPodr.createChild("Header");
			headPodr.createChild("HOUTID", String(tbl.getValue("K_STPODR")));
			
			var xmlPodro = header.createChild("HPODRO");							//подразделение источник
			var headPodro = xmlPodro.createChild("Header");
			headPodro.createChild("HOUTID", String(tbl.getValue("K_IST")));
			
			header.createChild("HBDAT", format("dd.mm.yyyy",tbl.getValue("D_DVIG")));//дата начала (дату конца прийдется потом апдейтить днем раньше от даты начала следующей записи)
			header.createChild("HEDAT", "01.01.3000");
			header.createChild("HAREND", "-");
			var oSc = new Object();
			oSc.schet = String(tbl.getValue("K_ZATRAT"));
			if(parseSchet(oSc,"/"))													//затратный счёт
			{
				header.createChild("HSC", oSc.sc);			
				header.createChild("HSU", oSc.su);
				header.createChild("HST", oSc.st);
			}
			//<<<VN_PEREM
		}*/
		tbl.moveNext();
		if (k!=null && i>k)
			break;
	}
	tbl.close();
}

function importOS(root, conn)
{
	var tbl  = OpenExtTable(conn, "SELECT s.*, z.и_стзатр, z.ш_стзатр, n.k_grup, n.k_vid, n.k_otr, "
								+" n.name AS vidname, n.norm_am, n.norm_am1, n.pr_buh "
								//+", p.dt, p.kt, p.k_fio, p.k_stpodr"
								+" FROM OSNSR AS s "
								+" LEFT JOIN N_STZATR AS z ON s.sk_stzatr=z.sk_stzatr "
								+" LEFT JOIN N_VIDOSN AS n ON s.sk_vidosn=n.sk_vidosn "
								//+" LEFT JOIN PROV AS p ON s.sk_vidosn=p.sk_vidosn"
								+" ORDER BY n_invent");

	var i = 0;
	while (!tbl.isEOF())
	{
		var sOutID = String(tbl.getValue("SK_OS"));
		if (sOutID && sOutID != "" && sOutID.trim() != "")
		{
			i++;
			/* OS1 begin*/
			var xmlObj = root.createChild("object", null, {type:"docs.O1"});
			var header = xmlObj.createChild("Header");
			//OSNSR>>>
			header.createChild("HOUTID", sOutID);
			header.createChild("HOP", 1001);
			header.createChild("HNOM", String(tbl.getValue("N_INVENT")).trim());
			header.createChild("HDAT", format("dd.mm.yyyy",tbl.getValue("D_POSTUPL")));	//дата поступления (у нас есть отдельная переменная HDPOST, но при формировании акта приёмки она не используется, поэтому пишем в дату документа)
			if(differ(tbl.getValue("D_LIKVID"),tbl.getValue("D_POSTUPL"))>=0)
				header.createChild("HDVIB", format("dd.mm.yyyy",tbl.getValue("D_LIKVID")));	//дата выбытия
			header.createChild("HVVOD", format("dd.mm.yyyy",tbl.getValue("D_VVEKSPL")));//дата ввода в эксплуатацию
			header.createChild("HNACHPL", format("dd.mm.yyyy",baseDat));				//дата начала расчета амортизации
			header.createChild("HGOD", Number(tbl.getValue("G_VIP")));					//год выпуска
			header.createChild("HINVN", Number(tbl.getValue("N_INVENT")));				//инвентарный номер
			header.createChild("HNOTPRIV", !toScrObj(tbl.getValue("PR_NACH")));			//признак не подлежит приватизации
			header.createChild("HXAR", String(tbl.getValue("CHAR")).trim());			//характеристика ОС
			header.createChild("HSROC", Number(tbl.getValue("POL_IS")));				//срок службы в месяцах
			header.createChild("HCODSROK", getSrokCod(Number(tbl.getValue("POL_IS"))));	//код срока службы 
			
			zol = Number(tbl.getValue("ZOLOTO"));
			plat = Number(tbl.getValue("PLATINA"));
			ser = Number(tbl.getValue("CEREBRO"));
			dr = Number(tbl.getValue("KAMNI"));
			if(zol+plat+ser+dr>0) //проставляем признак наличия драг.металлов
				header.createChild("HMETAL", "+");
			else
				header.createChild("HMETAL", "-");
			
			var sEdi = String(tbl.getValue("ED_IZM"));
			if (sEdi)
			{
				var xmlEdi = header.createChild("HEDIZM");
				headerEDI = xmlEdi.createChild("Header");				
				headerEDI.createChild("HOUTID", sEdi);
			}
			
			var xmlNazv = header.createChild("HNAZV");
			headerNazv = xmlNazv.createChild("Header");				
			headerNazv.createChild("HCOD", Number(tbl.getValue("N_INVENT")));
			//OSNSR<<<
			//N_STZATR>>>
			//zatrat = String(tbl.getValue("K_ZATRAT")).trim();
			s_zatrat = String(tbl.getValue("ш_стзатр")).trim();
			//i_zatrat = String(tbl.getValue("и_стзатр")).trim();
			var oSc = new Object();
			oSc.schet = s_zatrat;
			if(parseSchet(oSc,"-"))
			{
				//затратный счёт
				header.createChild("HZC", oSc.sc);			
				header.createChild("HZU", oSc.su);
				header.createChild("HZT", oSc.st);
			}
			//N_STZATR<<<
			//N_VIDOSN>>>
			var vid = Number(tbl.getValue("K_VID"));			
			switch(vid)
			{
				case 1:
					header.createChild("HNEPR", "+");
					header.createChild("HNEM", "-");
				break;
				case 2:
					header.createChild("HNEPR", "-");
					header.createChild("HNEM", "-");
				break;
				default:
					header.createChild("HNEPR", "-");
					header.createChild("HNEM", "+");
				break;
			}
			header.createChild("HGROUP", Number(tbl.getValue("K_GRUP")));				//группа
			header.createChild("HBMET", Number(tbl.getValue("PR_BUH")));				//метод для бухгалтерского расчета
			//N_VIDOSN<<<
			/* OS1 end*/
			
			/* OS7 begin*/
			var xmlObj = root.createChild("object", null, {type:"docs.O7"});
			var header = xmlObj.createChild("Header");
			//OSNSR>>>
			header.createChild("HOUTID", sOutID);
			header.createChild("HOP", 1);
			header.createChild("HNOM", String(tbl.getValue("N_INVENT")).trim());
			header.createChild("HDAT", format("dd.mm.yyyy",tbl.getValue("D_POSTUPL")));	//дата поступления (у нас есть отдельная переменная HDPOST, но при формировании акта приёмки она не используется, поэтому пишем в дату документа)
			if(differ(tbl.getValue("D_LIKVID"),tbl.getValue("D_POSTUPL"))>=0)
				header.createChild("HDVIB", format("dd.mm.yyyy",tbl.getValue("D_LIKVID")));	//дата выбытия
			header.createChild("HVVOD", format("dd.mm.yyyy",tbl.getValue("D_VVEKSPL")));//дата ввода в эксплуатацию
			header.createChild("HNACHPL", format("dd.mm.yyyy",baseDat));				//дата начала расчета амортизации
			header.createChild("HGOD", Number(tbl.getValue("G_VIP")));					//год выпуска
			header.createChild("HINVN", Number(tbl.getValue("N_INVENT")));				//инвентарный номер
			header.createChild("HNOTPRIV", !toScrObj(tbl.getValue("PR_NACH")));			//признак не подлежит приватизации
			header.createChild("HXAR", String(tbl.getValue("CHAR")).trim());			//характеристика ОС
			header.createChild("HSROC", Number(tbl.getValue("POL_IS")));				//срок службы в месяцах
			header.createChild("HCODSROK", getSrokCod(Number(tbl.getValue("POL_IS"))));	//код срока службы
			if(zol+plat+ser+dr>0) //проставляем признак наличия драг.металлов
				header.createChild("HMETAL", "+");
			else
				header.createChild("HMETAL", "-");
			var sEdi = String(tbl.getValue("ED_IZM"));
			if (sEdi)
			{
				var xmlEdi = header.createChild("HEDIZM");
				headerEDI = xmlEdi.createChild("Header");				
				headerEDI.createChild("HOUTID", sEdi);
			}
			//OSNSR<<<
			//N_STZATR>>>
			if(parseSchet(oSc,"-"))
			{
				//затратный счёт
				header.createChild("HZC", oSc.sc);			
				header.createChild("HZU", oSc.su);
				header.createChild("HZT", oSc.st);
			}
			var xmlExt = xmlObj.createChild("Extentions");
			/*//заносим в расширения
			if(zatrat)//затратный счёт
				xmlExt.createChild("ext", zatrat, {type:"text", name:"K_ZATRAT"});
			if(s_zatrat)//шифр статьи затрат
				xmlExt.createChild("ext", s_zatrat, {type:"text", name:"S_ZATRAT"});
			if(i_zatrat)//название статьи затрат
				xmlExt.createChild("ext", i_zatrat, {type:"text", name:"I_ZATRAT"});*/
			//N_STZATR<<<
			//N_VIDOSN>>>
			var vid = Number(tbl.getValue("K_VID"));			
			switch(vid)
			{
				case 1:
					header.createChild("HNEPR", "+");
					header.createChild("HNEM", "-");
				break;
				case 2:
					header.createChild("HNEPR", "-");
					header.createChild("HNEM", "-");
				break;
				default:
					header.createChild("HNEPR", "-");
					header.createChild("HNEM", "+");
				break;
			}
			header.createChild("HGROUP", Number(tbl.getValue("K_GRUP")));				//группа
			header.createChild("HBMET", Number(tbl.getValue("PR_BUH")));				//метод для бухгалтерского расчета
			if(vid)//название вида основого средства 
				xmlExt.createChild("ext", vid, {type:"text", name:"VIDNAME"});
			//N_VIDOSN<<<
			/* OS7 end*/
			/* OS4 begin*/
			if(differ(new Date(tbl.getValue("d_likvid")),new Date(1899,11,30))>0)
			{
				var xmlObj = root.createChild("object", null, {type:"docs.O4"});
				var header = xmlObj.createChild("Header");
				//OSNSR>>>
				header.createChild("HOUTID", sOutID);
				header.createChild("HOP", 4300);
				header.createChild("HNOM", String(tbl.getValue("N_INVENT")).trim());
				header.createChild("HDAT", format("dd.mm.yyyy",tbl.getValue("D_POSTUPL")));	//дата документа
				header.createChild("HDPOST", format("dd.mm.yyyy",tbl.getValue("D_POSTUPL")));	//дата поступления (у нас есть отдельная переменная HDPOST, но при формировании акта приёмки она не используется, поэтому пишем в дату документа)
				if(differ(tbl.getValue("D_LIKVID"),tbl.getValue("D_POSTUPL"))>=0)
					header.createChild("HDVIB", format("dd.mm.yyyy",tbl.getValue("D_LIKVID")));	//дата выбытия
				header.createChild("HVVOD", format("dd.mm.yyyy",tbl.getValue("D_VVEKSPL")));//дата ввода в эксплуатацию
				header.createChild("HNACHPL", format("dd.mm.yyyy",baseDat));				//дата начала расчета амортизации
				header.createChild("HGOD", Number(tbl.getValue("G_VIP")));					//год выпуска
				header.createChild("HINVN", Number(tbl.getValue("N_INVENT")));				//инвентарный номер
				header.createChild("HXAR", String(tbl.getValue("CHAR")).trim());			//характеристика ОС
				
				zol = Number(tbl.getValue("ZOLOTO"));
				plat = Number(tbl.getValue("PLATINA"));
				ser = Number(tbl.getValue("CEREBRO"));
				dr = Number(tbl.getValue("KAMNI"));
				if(zol+plat+ser+dr>0) //проставляем признак наличия драг.металлов
					header.createChild("HMETAL", "+");
				else
					header.createChild("HMETAL", "-");			
				//OSNSR<<<
				//N_STZATR>>>
				s_zatrat = String(tbl.getValue("ш_стзатр")).trim();
				var oSc = new Object();
				oSc.schet = s_zatrat;
				if(parseSchet(oSc,"-"))
				{
					//затратный счёт
					header.createChild("HZC", oSc.sc);			
					header.createChild("HZU", oSc.su);
					header.createChild("HZT", oSc.st);
				}
				//N_STZATR<<<
			}
			/* OS4 end*/
		}
		tbl.moveNext();
		if (k!=null && i>k)
			break;
	}
	tbl.close();
}

function parseSchet(oSc,split)
{
	if(!split)
		split = "/";
	if(typeOf(oSc)!="object")
		return false;
	var s = oSc.schet.trim();
	if(s.length<2)
		return false;
	var j = s.indexOf(split);
	if(j!=-1)//обрезаем до разделителя
		s = s.substr(0,j);
	if(s.length==3)
	{
		oSc.sc = s.substr(0,2);
		oSc.su = s;
	}
	else
	{
		oSc.sc = s;
		oSc.su = 0;
	}
	oSc.st = 0;
	return true;
}

function getSrokCod(srok)
{
	var snap = getSnap("select Fcod_norm from ^cl_osv where Fcod_vid=0 and Fsrok="+srok);
	if(snap)
		return snap[0];
	else
		return 0;	
}

function updateCls()
{
	//удаляем записи до 01.04.2008 если они не последние
	ExecuteSQL("delete from ^os0 as o1 where Fbdat<"+sqlTo(baseDat)+" and exists(select * from ^os0 as o2 where o2.finv_num=o1.finv_num and o2.fbdat>o1.fbdat)");
	ExecuteSQL("delete from ^os0 as o1 where Fdb_sc=0 and Fcr_sc=0 and exists(select * from ^os0 as o2 where o2.finv_num=o1.finv_num and o2.fdb_sc<>0 and o2.fcr_sc<>0)");
	ExecuteSQL("delete from ^os0b as o1 where Fbdat<"+sqlTo(baseDat)+" and exists(select * from ^os0b as o2 where o2.finv_num=o1.finv_num and o2.fbdat>o1.fbdat)");
	ExecuteSQL("delete from ^os0b as o1 where Fdb_sc=0 and Fcr_sc=0 and exists(select * from ^os0b as o2 where o2.finv_num=o1.finv_num and o2.fdb_sc<>0 and o2.fcr_sc<>0)");
	//для движений на одну и ту же дату меняем дату для 10 счета на день раньше
	var tos0 = OpenTable("select * from ^os0b order by finv_num, fbdat, fdb_sc desc");
	prev_inv = tos0.getValue("finv_num");
	prev_bd = tos0.getValue("fbdat");
	for(; !tos0.IsEOF(); tos0.MoveNext())
	{
		if(prev_inv==tos0.getValue("finv_num"))
		{
			if(differ(prev_bd,tos0.getValue("fbdat"))==0)
			{
				ExecuteSQL("update ^os0b set fbdat="+sqlTo(goDay(tos0.getValue("fbdat"),-1))+" where fwid="+tos0.getValue("fwid"));
			}
		}
		prev_inv = tos0.getValue("finv_num");
		prev_bd = tos0.getValue("fbdat");
	}
	tos0.close();
	
	tos0 = OpenTable("select * from ^os0 order by finv_num, fbdat, fdb_sc desc");
	prev_inv = tos0.getValue("finv_num");
	prev_bd = tos0.getValue("fbdat");
	for(; !tos0.IsEOF(); tos0.MoveNext())
	{
		if(prev_inv==tos0.getValue("finv_num"))
		{
			if(differ(prev_bd,tos0.getValue("fbdat"))==0)
			{
				ExecuteSQL("update ^os0 set fbdat="+sqlTo(goDay(tos0.getValue("fbdat"),-1))+" where fwid="+tos0.getValue("fwid"));
			}
		}
		prev_inv = tos0.getValue("finv_num");
		prev_bd = tos0.getValue("fbdat");
	}
	tos0.close();
	//проставляем коректную дату окончания в справочниках изм.стоимости и внутреннего перемещения
	WAIT("Обновление даты окончания в справочниках os0, os0b и vn_perem");
	tos0 = OpenTable("select * from ^os0 order by finv_num, fbdat desc");
	prev_inv = tos0.getValue("finv_num");
	prev_bd = tos0.getValue("fbdat");
	tos0.MoveNext();
	for(; !tos0.IsEOF(); tos0.MoveNext())
	{
		if(prev_inv==tos0.getValue("finv_num"))
		{
			if(differ(prev_bd,tos0.getValue("fbdat"))!=0)
			{
				ExecuteSQL("update ^os0 set fedat="+sqlTo(goDay(prev_bd,-1))+" where fwid="+tos0.getValue("fwid"));
			}
		}
		prev_inv = tos0.getValue("finv_num");
		prev_bd = tos0.getValue("fbdat");
	}
	tos0.close();
	
	tos0b = OpenTable("select * from ^os0b order by finv_num, fbdat desc");
	prev_inv = tos0b.getValue("finv_num");
	prev_bd = tos0b.getValue("fbdat");
	tos0b.MoveNext();
	for(; !tos0b.IsEOF(); tos0b.MoveNext())
	{
		if(prev_inv==tos0b.getValue("finv_num"))
		{
			if(differ(prev_bd,tos0b.getValue("fbdat"))!=0)
			{
				ExecuteSQL("update ^os0b set fedat="+sqlTo(goDay(prev_bd,-1))+" where fwid="+tos0b.getValue("fwid"));
			}
		}
		prev_inv = tos0b.getValue("finv_num");
		prev_bd = tos0b.getValue("fbdat");
	}
	tos0b.close();
	
	vn_perem = OpenTable("select * from ^vn_perem order by finv_num, fbdat desc");
	prev_inv = vn_perem.getValue("finv_num");
	prev_bd = vn_perem.getValue("fbdat");
	vn_perem.MoveNext();
	for(; !vn_perem.IsEOF(); vn_perem.MoveNext())
	{
		if(prev_inv==vn_perem.getValue("finv_num"))
		{
			if(differ(prev_bd,vn_perem.getValue("fbdat"))!=0)
			{
				ExecuteSQL("update ^vn_perem set fedat="+sqlTo(goDay(prev_bd,-1))+" where fwid="+vn_perem.getValue("fwid"));
			}
		}
		prev_inv = vn_perem.getValue("finv_num");
		prev_bd = vn_perem.getValue("fbdat");
	}
	vn_perem.close();
/*	//создаем в тех справочниках, где нет записей на существующие ОС по одной записи
	WAIT("Генерируем недостающие записи в справочниках по инвентарной карточке...");
	tos0 = OpenTable("select * from ^os7 as s where not exists(select * from ^os0b as b where s.Finv_num=b.Finv_num)")
	for(;!tos0.IsEOF(); tos0.MoveNext())
	{
		var m = new Object();
		m.Finv_num = tos0.getValue("Finv_num");
		m.Forig_pric = tos0.getValue("Forig_pric");
		m.Fiznos = tos0.getValue("Fiznos");
		m.Fbdat = tos0.getValue("Fdoc_dat");
		m.Fedat = d00;
		m.Fgroup = tos0.getValue("Fgroup");
		m.Fsrokadd = tos0.getValue("Fcod_rate");
		m.Fkf_ispol = 1;
		m.Fkol = tos0.getValue("Fkol");
		m.Farend = "-";
		m.Fdb_sc = tos0.getValue("Fdb_sc");
		m.Fdb_su = tos0.getValue("Fdb_su");
		m.Fdb_st = tos0.getValue("Fdb_st");
		m.Fcr_sc = tos0.getValue("Fcr_sc");
		m.Fcr_su = tos0.getValue("Fcr_su");
		m.Fcr_st = tos0.getValue("Fcr_st");
		UpdateTable("^os0", m, true);
		m.Fgroup = tos0.getValue("Fgroupb");
		m.Fbuhmetod = tos0.getValue("Fbuhmetod");
		UpdateTable("^os0b", m, true);
	}
	tos0.close();
	tosvn = OpenTable("select * from ^os7 as s where not exists(select * from ^vn_perem as v where s.Finv_num=v.Finv_num)")
	var m = new Object();
	for(;!tosvn.IsEOF(); tosvn.MoveNext())
	{
		m.Finv_num = tosvn.getValue("Finv_num");
		m.Fbdat = tosvn.getValue("Fdoc_dat");
		m.Fedat = d00;
		m.Fmol = tosvn.getValue("Fcod_mol");
		m.Fpodr = tosvn.getValue("Fcod_podr");
		m.Farend = "-";
		m.Fsc = tosvn.getValue("Fotn_z_sc");
		m.Fsu = tosvn.getValue("Fotn_z_su");
		m.Fst = tosvn.getValue("Fotn_z_st");
		UpdateTable("^vn_perem", m, true);
	}
	tosvn.close();*/
	//скопируем первоначальную стоимость в учетную перв.стоимость
	ExecuteSQL("update ^os0 set Forig_all=Forig_pric")
	ExecuteSQL("update ^os0b set Forig_all=Forig_pric")
	//проставляем износ
	WAIT("Обновление износа в справочниках os0, os0b");
	var tbl  = OpenExtTable(conn, "select o.n_invent,a.* from AMORT as a inner join OSNSR as o ON a.sk_os=o.sk_os where a.god=2008 order by n_invent");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		if(Number(tbl.getValue("god"))==2008)
		{
			//т.к. амортизацию по н/у расчитывается вконце квартала, остаточную стоимость будем брать из первого квартала (ost_1), а не из второго (ost_4)
			ExecuteSQL("update ^os0 set fiznos=forig_pric-"+Number(tbl.getValue("ost_1"))+" where Finv_num="+Number(tbl.getValue("n_invent"))+" and fedat="+sqlTo(d00))
		}
	}
	tbl  = OpenExtTable(conn, "select o.n_invent,a.* from AMORT_B as a inner join OSNSR as o ON a.sk_os=o.sk_os order by n_invent");
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		if(Number(tbl.getValue("god"))==2008)
		{
			ExecuteSQL("update ^os0b set fiznos=forig_pric-"+Number(tbl.getValue("ost_4"))+" where Finv_num="+Number(tbl.getValue("n_invent"))+" and fedat="+sqlTo(d00))
		}
	}
	/*//копируем данные из списка изм.стоимости во бух.учету во внутренние премещения
	 var t = OpenTable("select * from ^os0b as b where not exists(select * from ^vn_perem as v where b.finv_num=v.finv_num) and fedat="+sqlTo(d00)+" order by finv_num")
for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
{
	var m = new Object();
	m.fbdat = t.getValue("fbdat")
	m.fedat=t.getValue("fedat")
	m.fwid=GetUID();
	m.finv_num=t.getValue("finv_num")
	m.ftabn = t.getValue("ftabn")
	m.fpodr=t.getValue("fpodr")
	m.fpodro=t.getValue("fpodro")
	m.fsc=t.getValue("fzc")
	m.fst=t.getValue("fzt")
	m.fsu=t.getValue("fzu")
	UpdateTable("^vn_perem", m, true);
}*/
	alert("Справочники изменений стоимости и внутреннего перемещения модифицированы.")
}

function clearAll()
{
	ExecuteSQL("delete from ^os1");
	ExecuteSQL("delete from ^os4");
	ExecuteSQL("delete from ^os7");
	ExecuteSQL("delete from ^os0");
	ExecuteSQL("delete from ^os0b");
	ExecuteSQL("delete from ^os0nds");
	ExecuteSQL("delete from ^vn_perem");
	ExecuteSQL("delete from ^osnazv");
	//ExecuteSQL("delete from ^metal");
	//ExecuteSQL("delete from ^norm_gr");
	alert("CLEAR ALL END")
}

function setOSNazv(conn)
{
	var tbl = OpenExtTable(conn, "select * from OSNSR order by n_invent");
	var m = new Object();
	for(; !tbl.IsEOF(); tbl.MoveNext())
	{
		m.Fwid = GetUID();
		m.Finv_num = Number(tbl.getValue("N_INVENT"));
		m.Ftxt = tbl.getValue("NAME").trim();
		m.Foutid = tbl.getValue("N_INVENT").trim();
		if(!UpdateTable("^osnazv", m, true))
			break;
	}
	tbl.close();
	/*var t = OpenTable("select Finv_num from ^os1 as o1 where not exists "
				+" (select * from ^osnazv as n where n.finv_num=o1.finv_num)");
	for(; !t.IsEOF(); t.MoveNext())
	{
		
	}
	t.close();*/
}

function setExtOldNmk()
{
	t=OpenTable("eCL_NMK",null)
	tbl=OpenTable("select * from ^cl_nmk order by ftxts")
	for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		if(String(tbl.getValue("ftxts"))[0]=='%')
			t.setValue(Number(tbl.getValue("fwid")), "NMK_OLD",sqlFalse)
		else
			t.setValue(Number(tbl.getValue("fwid")), "NMK_OLD",sqlTrue)
	}
}

function importOSNAZV()//втупую переносит названия ОС, т.к. импорт из xml некоторые не перенес 
{
	var tbl  = OpenExtTable(conn, "SELECT * FROM OSNSR  ORDER BY n_invent");
	for(tbl.MoveFirst();!tbl.IsEOF(); tbl.MoveNext())
	{
		var m = new Object();
		m.Fwid=GetUID();
		m.Ftxt = String(tbl.getValue("Name")).trim();
		m.Finv_num=Number(String(tbl.getValue("N_invent")).trim());
		UpdateTable("^osnazv",m,true);
	}
}

function OS_CLS_HANDS_UPD()
{
//	t=OpenExtTable(conn,"select o.n_invent,a.* from AMORT as a inner join OSNSR as o ON a.sk_os=o.sk_os where a.god=2008 order by n_invent")
//t=OpenExtTable(conn,"select o.n_invent,a.* from AMORT_B as a inner join OSNSR as o ON a.sk_os=o.sk_os where a.god=2008 order by n_invent")
	
	//удаляем задвоенные записи
	delDubles("^os0");
	delDubles("^os0b");
	delDubles("^vn_perem");
	
	d = new Date(2008,11,31);
	ExecuteSQL("update ^os0 set Fbdat="+sqlTo(d)+" where fedat="+sqlTo(d00));
	ExecuteSQL("update ^os0b set Fbdat="+sqlTo(d)+" where fedat="+sqlTo(d00));
	ExecuteSQL("update ^vn_perem set Fbdat="+sqlTo(d)+" where fedat="+sqlTo(d00));
	
	//проставляем износс в н/у
	t=OpenExtTable(conn,"select o.n_invent,a.* from AMORT as a inner join OSNSR as o ON a.sk_os=o.sk_os where a.god=2008 order by n_invent");
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		var snap = getSnap("select Fwid,Forig_all from ^os0 "
				+" where Finv_num="+t.getValue("n_invent")+" and Fedat="+sqlTo(d00));
		if(snap)
		{
			iznos = Number(snap[1]-t.getValue("ost_10"));
			ExecuteSQL("update ^os0 set Fiznos="+sqlTo(iznos)+" where Fwid="+snap[0]);
		}
	}
	//проставляем износс в б/у
	t=OpenExtTable(conn,"select o.n_invent,a.* from AMORT_B as a inner join OSNSR as o ON a.sk_os=o.sk_os where a.god=2008 order by n_invent")
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		var snap = getSnap("select Fwid,Forig_all from ^os0b "
				+" where Finv_num="+t.getValue("n_invent")+" and Fedat="+sqlTo(d00));
		if(snap)
		{
			iznos = Number(snap[1]-t.getValue("ost_12"));
			ExecuteSQL("update ^os0b set Fiznos="+sqlTo(iznos)+" where Fwid="+snap[0]);
		}
	}
	
	//добавляем недостающие записи в справочник внутренних перемещений
	t = OpenTable("select Finv_num,Fwid from ^os1 as o where not exists(select fwid from ^vn_perem as v where v.Finv_num=o.Finv_num) order by finv_num");
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		var m = new Object();
		m.Fwid = GetUID();
		m.Finv_num = t.getValue("Finv_num");
		m.Fbdat = d.getVarDate();
		m.Fedat = d00;
		UpdateTable("^vn_perem", m, true);
	}
}

function delDubles(tblName)
{
	//удаляем задвоенные записи
	t = OpenTable("select * from "+tblName+" order by finv_num")
	inv=0;
	bdat = d00;
	edat = d00;
	fwid = 0;
	for(;!t.IsEOF(); t.MoveNext())
	{
		if(inv==t.getValue("Finv_num") && differ(bdat,t.getValue("Fbdat"))==0 && differ(edat,t.getValue("Fedat"))==0)
		{
			ExecuteSQL("delete from "+tblName+" where fwid="+fwid);
		}
		inv = t.getValue("Finv_num");
		bdat = t.getValue("Fbdat");
		edat = t.getValue("Fedat");
		fwid = t.getValue("Fwid");
	}
	t.close();
}