include("objects/DpCl.js");
include("sys/udfs.js");

var obj = extPar.dpObj;
var ctrlLinker = null;
var oTLink = null;

function Load()
{
	Caption(ru("Повышение квалификации","Підвищення кваліфікації"));
	var oPodr = new DpCl("0", typeof CDR_ORG_CL_PERS_PODR_CL != 'undefined'?CDR_ORG_CL_PERS_PODR_CL:getPar('CDRPODR'), 0);
	oPodr.linkCtrl(RPODR, RTPODR);
	if(oPodr.getClcl()==0)
		Disable(RPODR);

	var oObVid = new DpCl("0", getPar(typeof const_GETPAR_OBVID != 'undefined'?const_GETPAR_OBVID:'CDRTPTRNG'), 0);
	oObVid.linkCtrl(ROBVID, RTOBVID);
	if(oObVid.getClcl()==0)
		Disable(ROBVID);

	var oObForm = new DpCl("0", getPar(typeof const_GETPAR_OBFORM != 'undefined'?const_GETPAR_OBFORM:'CDRFRMTRNG'), 0);
	oObForm.linkCtrl(ROBFORM, RTOBFORM);
	if(oObForm.getClcl()==0)
		Disable(ROBFORM);

	var oProfForm = new DpCl("0", getPar(typeof const_GETPAR_PROFFORM != 'undefined'?const_GETPAR_PROFFORM:'CDRCRSTRNG'), 0);
	oProfForm.linkCtrl(RPROFFORM, RTPROFFORM);
	if(oProfForm.getClcl()==0)
		Disable(RPROFFORM);
	
	var oSpecVuz = new DpCl("0", getPar(typeof const_GETPAR_SPECVUZ != 'undefined'?const_GETPAR_SPECVUZ:'CDRSPCSCHL'), 0);
	oSpecVuz.linkCtrl(RSPECVUZ, RTSPECVUZ);
	if(oSpecVuz.getClcl()==0)
		Disable(RSPECVUZ);

	var oPodVid = new DpCl("0", getPar(typeof const_GETPAR_PODVID != 'undefined'?const_GETPAR_PODVID:'CDRTPPODG'), 0);
	oPodVid.linkCtrl(RPODVID, RTPODVID);
	if(oPodVid.getClcl()==0)
		Disable(RPODVID);

	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RPROT_DAT", RPROT_DAT);
	ctrlLinker.addLink("RBDAT", RBDAT);
	ctrlLinker.addLink("REDAT", REDAT);
	ctrlLinker.addClLink("RPODVID", oPodVid);
	ctrlLinker.addClLink("RPODR", oPodr);
	ctrlLinker.addClLink("ROBVID", oObVid);
	ctrlLinker.addClLink("ROBFORM", oObForm);
	ctrlLinker.addLink("ROBDOC", ROBDOC);
	ctrlLinker.addLink("RPROM", RPROM);
	ctrlLinker.addLink("RFOREIGN", RFOREIGN);
	ctrlLinker.addLink("RISUPRAZR", RISUPRAZR);
	ctrlLinker.addClLink("RPROFFORM", oProfForm);
	ctrlLinker.addClLink("RSPECVUZ", oSpecVuz);
	ctrlLinker.updateData(false);
}

function onSave()
{
	if (extPar.mode == "COPY")
	{
		obj.setVar("RWID", GetUID());
	}
	ctrlLinker.updateData(true);
}

include("sys\\DpBaseDlg.js");