include("Objects\\DpCl.js");

var obj = extPar.dpObj; 
var ctrlLinker = null;
var oTLink, oPers;

function Load() 
{
	ctrlLinker = new DpCtrlLinker(obj);
	oTLink = new DpCl("");
	oTLink.setClcl(getPar("CDRFTIE"));
	//oTLink.linkCtrl(RID_TLINK, RID_TLINKTXT);
	oTLink.linkSmartCtrl(RID_TLINKTXT);
	oTLink.setContAssist();
	
	oPers = new DpCl("0",getPar("CODPERS"),0);
	oPers.linkCtrl(RTABN);
	
	ctrlLinker.addLink("RSURNAME", RSURNAME);
	ctrlLinker.addLink("RFNAME", RFNAME);
	ctrlLinker.addLink("RSNAME", RSNAME);
	ctrlLinker.addLink("RWORKPLACE", RWORKPLACE);
	ctrlLinker.addLink("RRANG", RRANG);
	ctrlLinker.addLink("RBIRTHDAY", RBIRTHDAY);
	ctrlLinker.addLink("RIS_PERS", RIS_PERS);
	ctrlLinker.addClLink("RID_TLINK", oTLink);
	ctrlLinker.addClLink("RID_PERS", oPers);
	ctrlLinker.updateData(false);

    if (extPar.mode != "ADD")
   		oTLink.setCod(obj.getVar("RID_TLINK"));
   	setValid(RIS_PERS,persValid);
   	setValid(RTABN,tabnValid);
   	persValid();
}

function onSave()
{
	if (extPar.mode == "COPY")
		obj.setVar("nID", GetUID());
	ctrlLinker.updateData(true);
   	obj.setVar("RID_TLINK", oTLink.getCod()); 
}

function persValid()
{
	if(toScrObj(RIS_PERS.value))
	{
		LBL_TABN.visible = true;
		RTABN.visible = true;
		Disable(RSURNAME);
		Disable(RFNAME);
		Disable(RSNAME);
		Disable(RBIRTHDAY);
	}
	else
	{
		LBL_TABN.visible = false;
		RTABN.visible = false;
		Enable(RSURNAME);
		Enable(RFNAME);
		Enable(RSNAME);
		Enable(RBIRTHDAY);
		oPers.setCod(0);
	}
	return true;
}

function tabnValid()
{
	if(RTABN.value>0 && RTABN.visible)
	{
		var snap = getSnap("select Ftxt, Forigdat,Fisotch from ^LISTCL3 where Fcl="+getPar("CODPERS")+" and Fcod="+RTABN.value);
		if(snap)
		{
			RSURNAME.value = fio("F",snap[0],snap[2]);
			RFNAME.value = fio("I",snap[0],snap[2]);
			RSNAME.value = fio("O",snap[0],snap[2]);
			RBIRTHDAY.value = snap[1];
			if(allt(RWORKPLACE.value)=="")
				RWORKPLACE.value = getPar("OFIRM");
			if(allt(RRANG.value)=="" && getCurDol(RTABN.value, today)!="???")
				RRANG.value = getCurDol(RTABN.value, today);
		}
		else
		{
			RSURNAME.value = "";
			RFNAME.value = "";
			RSNAME.value = "";
			RBIRTHDAY.value = d00;
			RWORKPLACE.value = "";
			RRANG.value = "";
		}
	}
	return true;
}

include("sys\\DpBaseDlg.js");