include("Objects/DpCl.js");
include("sys/udfs.js");

var obj = extPar.dpObj;
var ctrlLinker = null;
var oTLink = null;

function Load()
{
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RTYPE", RTYPE);
	ctrlLinker.addLink("RBPERIOD", RBPERIOD);
	ctrlLinker.addLink("REPERIOD", REPERIOD);
	ctrlLinker.addLink("RBDAT", RBDAT);
	ctrlLinker.addLink("REDAT", REDAT);
	ctrlLinker.addLink("RPRKTXT", RPRKTXT);
	ctrlLinker.updateData(false);

	for (var i=1; i < CDR_OTP.length; i++)
	{
		RTYPE.addItem(i, CDR_OTP[i]);
	}

	if (extPar.mode == "ADD")
	{
		RTYPE.value = CDR_OTP_OSN;
		RBPERIOD.value = d00;
		REPERIOD.value = d00;
		RBDAT.value = d00;
		REDAT.value = d00;
	}
	else
	{
		RTYPE.value = Number(obj.getVar("RTYPE"));
	}
}

function onSave()
{
	if (extPar.mode == "COPY")
		obj.setVar("RWID", GetUID());
	ctrlLinker.updateData(true);
}

include("sys\\DpBaseDlg.js");