include("Objects/DpNmkl.js");
include("Objects/DpCl.js");

var objCl = extPar.dpObj;
var ctrlLinker;
var oHouse;
var oProp;
var codHouse = objCl.getVar("HIDPAR");
var houseID = extPar.Fwid;
var sServTbl = "CL_SERV";
var sTmpTbl = getTmpTableName();
var sOwnerTbl = "CL_OWNER";
var sTmpOwner = getTmpTableName();

function Load()
{	
	Caption(ru("Квартиры", "Квартири") + ": " + modeName(this.sMode))
	
	oProp = new DpCl("0");
	oProp.setClcl(getPar("CODPROP"));
	oProp.linkSmartCtrl(FPROPERTY);
	oProp.setContAssist();
		
	oStreet = new DpCl();
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	//setValid(FSTREET, setHouse);
	oStreet.setFWID(getStreet(houseID, codHouse));
			
	oHouse = new DpCl("", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.AfterLoad = loadHouse;
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	//setValid(FHOUSE, setHouse);
	if(codHouse)
		oHouse.setCod(codHouse);

	fillWaterCombo();
	//loadRents();
	loadServ();
	loadOwner();
			
	ctrlLinker = new DpCtrlLinker(objCl);	

	FNOM.mask = replicate("&", 50);
	FPORCH.mask = "#";
	FFLOOR.mask = "##";
	FROOMKOL.mask = "##";
	FLIVAREA.mask = MASK_KOL;
	FLOGAREA.mask = MASK_KOL;
	FBALAREA.mask = MASK_KOL;
	FAREA.mask = MASK_KOL;		
			
	ctrlLinker.addLink("HNOM", FNOM);
	ctrlLinker.addLink("HCOMMENT", FCOMMENT);		
	ctrlLinker.addLink("HPORCH", FPORCH);	
	ctrlLinker.addLink("HFLOOR", FFLOOR);	
	ctrlLinker.addLink("HROOMKOL", FROOMKOL);
	ctrlLinker.addLink("HWATERSERV", FWATERSERV);	
	ctrlLinker.addLink("HWCOUNTER", FWCOUNTER);	
	ctrlLinker.addLink("HGCOUNTER", FGCOUNTER);	
	ctrlLinker.addLink("HPHONE", FPHONE);	
	ctrlLinker.addLink("HAREA", FAREA);
	ctrlLinker.addLink("HLIVAREA", FLIVAREA);	
	ctrlLinker.addLink("HLOGAREA", FLOGAREA);	
	ctrlLinker.addLink("HBALAREA", FBALAREA);
	ctrlLinker.addLink("HBALHEAT", FBALHEAT);
	ctrlLinker.addLink("HCOOKER", FCOOKER);
	ctrlLinker.addLink("HPRIVAT", FPRIVAT);
	ctrlLinker.addLink("HDRAINTYPE", FDRAINTYPE);
	ctrlLinker.addClLink("HPROPERTY", oProp);
					
	ctrlLinker.toControls();
			
	if(extPar.mode=="ADD")
	{
		loadHouse();
		FNOM.value = nextNum();
		//FPORCH.value = 1;
	}
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{		
		oStreet.setFWID(getStreet(objCl.getVar("HHOUSE")));
		oHouse.setFWID(objCl.getVar("HHOUSE"));
	}
	
	this.areaCalc = areaCalc;
    setButton(FAREA, this, "areaCalc");
    
    this.heatAreaCalc = heatAreaCalc;
    setButton(FLIVAREA, this, "heatAreaCalc");
	
	//setValid(FLIVAREA, area_valid);
	//setValid(FROOMKOL, room_valid);
	
	if(getSystem()=="HOC")
	{
		LAREA.setVisible(true);
		GRAREA.setVisible(true);
	}
	
	FNOM.setFocus();
}

function areaCalc()
{
	var livArea = Number(FLIVAREA.value);
	var balArea = Number(FBALAREA.value);
	var logArea = Number(FLOGAREA.value);
	FAREA.value = livArea+balArea+logArea;
	if(getPar("HOCAREACOEF")==false)
		FAREA.value = (livArea + (logArea*0.5) + (balArea*0.3));
	if(Number(FAREA.value)==0)
		FAREA.value = objCl.getVar("HAREA");
}

function heatAreaCalc()
{
	var fullArea = Number(FAREA.value);
	var balArea = Number(FBALAREA.value);
	var logArea = Number(FLOGAREA.value);
	if(getPar("HOCAREACOEF")==false)
		fullArea = fullArea - (logArea*0.5) - (balArea*0.3) + logArea + balArea
	FLIVAREA.value = fullArea-balArea-logArea;
	if(FBALHEAT.checked==true)
		FLIVAREA.value = fullArea-logArea;
	if(Number(FLIVAREA.value)==0)
		FLIVAREA.value = objCl.getVar("HLIVAREA");
}

function nextNum()
{
	var num = "";
	var oSnap = getSnap("select max("+ Convert("FNOM", "DBL") +")"
						+" from ^CL_APARTMENT"
						+" where FHOUSE="+ oHouse.getFWID()
						, false
						);
	if(oSnap && Number(oSnap[0]))
		num = Number(oSnap[0])+1;
	return String(num);
}

function fillWaterCombo()
{
	FWATERSERV.addItem(1, ru("с горячим водосн.","з гарячим водопост."));
	FWATERSERV.addItem(2, ru("без горячего водосн.","без гарячого водопост."));
	FWATERSERV.addItem(3, ru("с водопроводом и канализацией","з водопроводом і каналізацією"));
	FWATERSERV.addItem(4, ru("с газовыми колонками","з газовими колонками"));
	FWATERSERV.addItem(5, ru("с дровяными колонками","з дров'яними колонками"));
	FWATERSERV.addItem(6, ru("скважина","свердловина"));
	
	var type = objCl.getVar("HWATERSERV");
	if(type!=null)
		FWATERSERV.setValue(Number(type));
}

function area_valid()
{
	if(Number(FLIVAREA.value)==0)
	{
		WAIT(UR("Уведіть площу|Введите площадь"));
		setFocus(FLIVAREA);
		return false;
	}
}

function room_valid()
{
	if(Number(FROOMKOL.value)==0)
	{
		WAIT(UR("Уведіть кількість кімнат|Введите количество комнат"));
		setFocus(FROOMKOL);
		return false;
	}
}

function loadHouse()
{
	var oHs = getSnap("select FWATERSERV, FDRAINTYPE"
					+" from ^CL_HOUSE where FWID_CL="+ oHouse.getFWID()
					, false
					);
	if(extPar.mode=="ADD")
	{
		loadHouseServ();
		if(oHs)
		{
			FWATERSERV.value = Number(oHs[0]);
			FDRAINTYPE.value = Number(oHs[1]);
		}
	}
}

function loadHouseServ()
{
	var sTbl = sServTbl;
	var tbl = grid.getTable();
	var sTmpTbl = tbl.getTableName();
	var sFld = GetPatternIntersection(sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTmpTbl);
	ExecuteSQL("INSERT INTO ^"+ sTmpTbl +" ("+ sFld +")"
				+" SELECT "+ sFld 
				+" FROM ^"+ sTbl 
				+" WHERE FWID_CL="+ oHouse.getFWID()
				);
	tbl.requery();
	grid.refresh();
}

function onSave()
{		
	objCl.setVar("HIDPAR", oHouse.getCod());
	
	var sTxt = oStreet.getTxt() +", "+ oHouse.getTxt();
	objCl.setVar("HTXT",	sTxt);	
	objCl.setVar("HHOUSE", 	oHouse.getFWID());
	objCl.setVar("HIND", 	convertStrNum(FNOM.value));
	
	ctrlLinker.toVars();
	saveRows();
	exit();
}

function saveRows()
{
	var sTbl = sServTbl;
	var tmpTbl = grid.getTable().getTableName();
	var sFld = GetPatternIntersection (sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FWID_CL="+ sqlTo(objCl.getID()));
	ExecuteSQL("UPDATE "+ tmpTbl +" SET Fwid_cl="+ sqlTo(objCl.getID()));
	ExecuteSQL("INSERT INTO ^"+ sTbl +" ("+ sFld +") SELECT "+ sFld +" FROM "+ tmpTbl);
	
	sFld = GetPatternIntersection (sOwnerTbl, sOwnerTbl);
	ExecuteSQL("DELETE FROM ^"+ sOwnerTbl +" WHERE FWID_CL="+ sqlTo(objCl.getID()));
	ExecuteSQL("UPDATE "+ sTmpOwner +" SET Fwid_cl="+ sqlTo(objCl.getID()));
	ExecuteSQL("INSERT INTO ^"+ sOwnerTbl +" ("+ sFld +") SELECT "+ sFld +" FROM "+ sTmpOwner);
}

function exit()
{
	var sTmpTbl = grid.getTable().getTableName();
	grid.getTable().close();	
	DropTable(sTmpTbl);
	
	gridOWNER.getTable().close();	
	DropTable(sTmpOwner);
}

function getStreet(houseID, codHouse)
{
	if(!houseID && codHouse)
	{
		var oSnap = getSnap("select FWID_CL "
						+" from ^CLRELCLCL "
						+" where FCL="+ getPar("CODHOUSE")
							+" and FCOD="+ sqlTo(codHouse));
		if(oSnap)
			houseID = oSnap[0];
	}
	if(!houseID && oHouse)
		houseID = oHouse.getFWID();
	var streetID = 0;
	var sSql = "select FSTREET from ^CL_HOUSE where FWID_CL="+ houseID;
	var oHs = getSnap(sSql, false);
	if(oHs!=null)
		streetID = oHs[0];
	return streetID;
}

//отбор домов по указанной улице
function getWhereStreet()
{
	var sWhere = "";
	var streerID = oStreet.getFWID();
	if(streerID!=0 && streerID!=null)
		sWhere = "FWID_CL in (select fwid_cl from ^cl_house "
						+" where fstreet="+ streerID +")";
	return sWhere;
}


function loadServ()
{
	sRowClass = "SERV";
	sRowTbl = sServTbl;	
	DropTable(sTmpTbl);	
	var sSQL = "SELECT * "
			+" INTO " + sTmpTbl
			+" FROM ^"+ sRowTbl
			+" WHERE FWID_CL="+ sqlTo(objCl.getID());	
	ExecuteSQL(sSQL);	
	gridTbl = OpenTable("m", "SELECT * FROM "+ sTmpTbl +" ORDER BY FNUM");
	gridTbl.tie("cl_nmk", "nmk", "FWID", "FNMKL");	
	grid.setTable(gridTbl);
	grid.build();
	grid.setData(sRowClass);
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRun");	
}

function gridMenuInit(grid)
{
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("COPY", "Копіювати|Копировать");
		grid.AddMenuItem("DEL", "Видалити|Удалить");		
	}	
}

function gridMenuRun(sID, grid)
{	
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = tbl.getValue("FWID");
	var sRowClass = "SERV";
			
	switch(sID)
	{
		case "DEL":
			var nGridPos = grid.getRowSelected();
			ExecuteSQL("delete From "+ tName +" where Fwid="+ sqlTo(rowID));
			objCl.deleteRow(sRowClass, rowID);		
			tbl.requery();
			tbl.setAbsolute(nGridPos-1);
			grid.refresh();			
			break;
			
		case "ADD": case "EDIT": case "COPY":
			var oRow;						
			if(sID == "ADD")
				oRow = objCl.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = objCl.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = objCl.copyRow(sRowClass, rowID);
			if(!oRow)
				break;			
			if (!rowEdit(sID, oRow))
				break;			
			tbl.requery();
			grid.refresh();			
			break;
	}	
	return true;	
}

function rowEdit(sMode, oRow)
{	
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = sTmpTbl;
	par.formFile = "cls/"+ objCl.sClassId +"/SERV/form.xml"; 	
	par.dpObj.hasExt = hasExt;
	par.nCl = objCl.getVar("HCL");	
	showWindow(par.formFile, "XMLDLG", par);		
	if(par.escape)
		return false;	
	if(inList(sMode, "ADD", "COPY"))
		objCl.appendRow(sRowClass, oRow);	
	obj2DB(oRow.getID(), oRow.jObj, null, sTmpTbl);	
	return true;
}

function hasExt()
{
	return false;
}

function loadOwner()
{
	DropTable(sTmpOwner);	
	var sSQL = "SELECT * "
			+" INTO " + sTmpOwner
			+" FROM ^"+ sOwnerTbl
			+" WHERE FWID_CL="+ sqlTo(objCl.getID());	
	ExecuteSQL(sSQL);	
	var tbl = OpenTable("m", "SELECT * FROM "+ sTmpOwner +" ORDER BY FBDAT, FEDAT, FORG");
	tbl.tie("CONTRACT", "contr", "FWID", "FID_DOG");
	tbl.clTie("org", "=0, FORG");
	gridOWNER.setTable(tbl);
	gridOWNER.build();
	gridOWNER.setData("OWNER");
		
	this.gridOwnerMenuInit = gridOwnerMenuInit;
	this.gridOwnerMenuRun = gridOwnerMenuRun;
	gridOWNER.loadMenuHandler(this, "gridOwnerMenuInit");
	gridOWNER.selectMenuHandler(this, "gridOwnerMenuRun");
}

function gridOwnerMenuInit()
{
	gridOWNER.AddMenuItem("ADD", "Додати|Добавить");
	if(!gridOWNER.getTable().isEmpty())
	{
		gridOWNER.AddMenuItem("EDIT", "Редагувати|Редактировать");
		gridOWNER.AddMenuItem("COPY", "Копіювати|Копировать");
		gridOWNER.AddMenuItem("DEL", "Видалити|Удалить");		
	}
}

function gridOwnerMenuRun(sID)
{
	var tbl = gridOWNER.getTable();
	var tName = tbl.getTableName();	
	var rowID = tbl.getValue("FWID");
	var sRowClass = "OWNER";
			
	switch(sID)
	{
		case "DEL":
			var nGridPos = gridOWNER.getRowSelected();
			ExecuteSQL("delete From "+ tName +" where Fwid="+ sqlTo(rowID));
			objCl.deleteRow(sRowClass, rowID);		
			tbl.requery();
			tbl.setAbsolute(nGridPos-1);
			gridOWNER.refresh();			
			break;
			
		case "ADD": case "EDIT": case "COPY":
			var oRow;						
			if(sID == "ADD")
				oRow = objCl.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = objCl.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = objCl.copyRow(sRowClass, rowID);
			if(!oRow)
				break;			
			var par = new Object();
			par.obj = oRow;
			par.mode = sID;
			par.tblName = tName;
			par.formFile = "cls/"+ objCl.sClassId +"/OWNER/form.xml"; 	
			par.obj.hasExt = hasExt;
			par.nCl = objCl.getVar("HCL");	
			showWindow(par.formFile, "XMLDLG", par);		
			if(par.escape)
				break;
			if(inList(sID, "ADD", "COPY"))
				objCl.appendRow(sRowClass, oRow);	
			obj2DB(oRow.getID(), oRow.jObj, null, tName);
			tbl.requery();
			gridOWNER.refresh();			
			break;
	}	
	return true;
}

include("sys/DpBaseDlg.js");