include("Objects/DpNmkl.js");
include("gridedit.js");

var priType = getPar("BILL_PRI");
var sDir = rootDirectory() + "cls/clpack/";
var objCl = extPar.dpObj;
var sTmpTbl = "TMP_SERV";
var sRowTbl = "CL_SERV";
var sRowClass = "SERV";
var ctrlLinker;
var gridTbl;
var oGridEdit;
var objNmkl = new DpNmkl();

function onLoad()
{	
	this.onEscape = exit;
	
	ctrlLinker = new DpCtrlLinker(objCl);
	
	Caption(ru("Пакеты", "Пакети") +": "+ modeName(this.sMode));
	
	FCENA.mask = MASK_SUM;
	FCOD.setMask("######");
	FCOD.setFocus();	
	
	ctrlLinker.addLink("HCOD", FCOD);
	ctrlLinker.addLink("HTXT", FTXT);	
	ctrlLinker.addLink("HCENA", FCENA);
	//ctrlLinker.addLink("HCENAOVER", FCENAOVER);
	ctrlLinker.addLink("HBDAT", FBDAT);
	ctrlLinker.addLink("HEDAT", FEDAT);
		
	ctrlLinker.toControls();	
	
	if(this.sMode=="ADD")
	{
		FBDAT.value = null;
		FEDAT.value = null;
	}
		
	loadGrid(this.sMode);
	recalcSum();
}

function loadGrid(sMode)
{
	DropTable(sTmpTbl);	
	var sSQL = "SELECT * "
			+ " INTO " + sTmpTbl
			+ " FROM ^"+ sRowTbl;			
	var sWhere = " WHERE 1<>1 ";
	if (sMode != "ADD")
		sWhere = " WHERE FWID_CL="+ sqlTo(objCl.getID());
	sSQL += sWhere;	
	ExecuteSQL(sSQL);
	
	gridTbl = OpenTable("m", "SELECT * FROM "+ sTmpTbl +" ORDER BY FNUM");
	gridTbl.tie("cl_nmk", "nmk", "FWID", "FNMKL");
	gridTbl.tie("cl_edi", "edi", "FCOD", "nmk.FCEDIB");
	grid.setXMLDir(sDir);
	grid.setXMLFile("gridserv.xml");
	grid.setTable(gridTbl);
	grid.build();		
	grid.setData(sRowClass);
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRum = gridMenuRum;
	grid.loadMenuHandler(this,"gridMenuInit");
	grid.selectMenuHandler(this,"gridMenuRum");

	oGridEdit = new DpGridEdit(grid);
	oGridEdit.init = addRecord;
	oGridEdit.canEdit = canEditRecord;
	oGridEdit.saveRecord = saveRecord;
	oGridEdit.addValidField("nmk.fcod", startEdit_fnmkl, endEdit_fnmkl);
}

function startEdit_fnmkl(oCtrl)
{
	this.ctrlCod = oCtrl;
	objNmkl.setCod(oCtrl.getValue());	
   	//objNmkl.linkCtrl(oCtrl);
   	this.showPri = showPri;
   	setButton(oCtrl, this, "showPri");
}

function endEdit_fnmkl(oCtrl)
{
	if (!objNmkl.setCod(oCtrl.getValue()))
	{	
		if (!showPri())
			return false;			
	}	
	oCtrl.setValue(objNmkl.getCod("c"));
	oGridEdit.setValue("FNMKL", objNmkl.getFwid());
	oGridEdit.setValue("nmk.FTXT0", objNmkl.getTCod());
	var oPri = getPriCena(objNmkl.getFwid());
	if(oPri)
	{
		oGridEdit.setValue("FCENA", oPri[0]);
		oGridEdit.setValue("FCENAOVER", oPri[1]);
	}
	return true;
}

function getPriCena(fnmkl)
{
	var oPri = getPri();
	if(!oPri)
		return null;
	include("sub/mtr.js")
	var sName = pName(oPri[2], oPri[1]);
	oPri = getSnap("select FCENA, FCENA1 from "+ sName 
			+" where FNMKL="+ fnmkl);
	return oPri;				
}

function setNmk(ID)
{
	if(!ID)
		ID = gridTbl.getValue("FNMKL");
	var oSnap = getSnap("select FCOD from ^CL_NMK "
				+" where FWID="+ ID);
	if(oSnap)
		objNmkl.setCod(oSnap[0]);
	
	oGridEdit.setValue("nmk.fcod", objNmkl.getCod("c"));
	oGridEdit.setValue("nmk.ftxt0", objNmkl.getTCod());	
}

function showPri()
{
	var oPri = getPri();
	if(!oPri)
		return null;
	
	var par = new Object();
	par.ret = new Object();
	par.ret.Fnmkl = 0;
	par.ret.Fcena = 0;
	par.ret.Fcena1 = 0;
	par.cenaNo = 0;	
	par.fwid = oPri[0];
	showWindow("l_price.js", SW_MODAL, par);
	if(par.escape)
		return null;
	
	oGridEdit.setValue("FNMKL", par.ret.Fnmkl);
	oGridEdit.setValue("FCENA", par.ret.Fcena);
	oGridEdit.setValue("FCENAOVER", par.ret.Fcena1);
	setNmk(par.ret.Fnmkl);
	if(this.ctrlCod)
		this.ctrlCod.value = objNmkl.getCod("c");		
	
	return par.ret;
}

function addRecord()
{
	with (this)
	{	
		initValue("FKOL", 0);
		initValue("FCENA", 0);				
	}
}

function saveRecord()
{
	var rowID = parseInt(grid.getTable().getValue("fwid"));
	var oRow =  objCl.getRow(sRowClass, rowID);
	if (oRow == null)
	{
		oRow = objCl.createRow(sRowClass);
		oRow.setID(rowID);
		objCl.appendRow(sRowClass, oRow);
	}
	with (oRow)
	{
		setVar("RNMKL",	gridTbl.getValue("fnmkl"));
		setVar("RKOL",	gridTbl.getValue("fkol"));
		setVar("RCENA",	gridTbl.getValue("FCENA"));
		setVar("RCENAOVER",	gridTbl.getValue("FCENAOVER"));
	}
	recalcSum();
	return true;
}

function canEditRecord()
{	
	return true;
}

function getNextRowNum()
{
	var num = 1;
	var tNum = getSnap("select max(FNUM) from "+ sTmpTbl);
	if(tNum!=null)
		num = Number(tNum[0])+1;
	return num;
}
	
function gridMenuInit(grid)
{
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Видалити|Удалить");		
	}	
}

function gridMenuRum(sID, grid)
{	
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = tbl.getValue("FWID");
			
	switch(sID)
	{
		case "DEL":
			var nGridPos = grid.getRowSelected();
			ExecuteSQL("delete From "+ tName 
					+" where Fwid="+ sqlTo(rowID));
			objCl.deleteRow(sRowClass, rowID);		
			tbl.requery();
			tbl.setAbsolute(nGridPos-1);
			grid.refresh();
			recalcSum();	
			break;
			
		case "ADD": case "EDIT": case "COPY":
			var oRow;						
			if(sID == "ADD")
				oRow = objCl.createRow(sRowClass);
			else if(sID == "EDIT")
				oRow = objCl.getRow(sRowClass, rowID);
			else if(sID == "COPY")
				oRow = objCl.copyRow(sRowClass, rowID);
			if(!oRow)
				break;			
			if (!rowEdit(sID, oRow))
				break;			
			
			tbl.requery();
			grid.refresh();			
			break;
	}
	recalcSum();	
	return true;	
}

function onSave()
{	
	recalcSum();
	ctrlLinker.toVars();	
	storeToDb(sRowTbl, sTmpTbl);			
	exit();
}

function storeToDb(sTbl, tmpTbl)
{
	var sFld = GetPatternIntersection (sTbl, sTbl);
	ExecuteSQL("DELETE FROM ^"+ sTbl +" WHERE FWID_CL="+ sqlTo(objCl.getID()));
	ExecuteSQL("UPDATE "+ tmpTbl +" SET Fwid_cl="+ sqlTo(objCl.getID()));
	ExecuteSQL("INSERT INTO ^"+ sTbl +" ("+ sFld +")"
		+" SELECT "+ sFld +" FROM "+ tmpTbl);
}

function exit()
{
	gridTbl.close();	
	DropTable(sTmpTbl);	
}

function _rowEdit(sMode, oRow)
{	
	var oPri = getPri();
	if(!oPri)
		return false;
	var par = new Object();
	par.ret = new Object();
	par.ret.Fnmkl = 0;
	par.ret.Fcena = 0;
	par.ret.Fcena1 = 0;
	par.cenaNo = 0;	
	par.fwid = oPri[0];
	showWindow("l_price.js", SW_MODAL, par);
	if(par.escape)
		return false;
	
	oRow.setVar("RNMKL", par.ret.Fnmkl);
	oRow.setVar("RCENA", par.ret.Fcena);
	oRow.setVar("RCENAOVER", par.ret.Fcena1);
			
	if(inList(sMode, "ADD", "COPY"))
	{
		oRow.setVar("RNUM", getNextRowNum());
		objCl.appendRow(sRowClass, oRow);			
	}
	obj2DB(oRow.getID(), oRow.jObj, null, sTmpTbl);
	recalcSum();	
	return true;
}

function rowEdit(sMode, oRow)
{	
	var par = new Object();
	par.dpObj = oRow;
	par.mode = sMode;
	par.tblName = sTmpTbl;
	par.formFile = "cls/"+ objCl.sClassId +"/SERV/form.xml"; 	
	par.dpObj.hasExt = hasExt;
	par.nCl = objCl.getVar("HCL");
	
	showWindow(par.formFile, "XMLDLG", par);
		
	if(par.escape)
		return false;
	
	var id = oRow.getID();	
	if(inList(sMode, "ADD", "COPY"))
		objCl.appendRow(sRowClass, oRow);
	
	obj2DB(id, oRow.jObj, null, sTmpTbl);
	
	recalcSum();
	return true;
}

function hasExt()
{
	return false;
}

function recalcSum()
{
	var sum = 0;
	//var ssum = "sum("+ IIF("FVID=3 or FVID=5", "FCENA*FKOL", "FCENA") +") as FSUM";
	//var sover = "max("+ IIF("FVID=1 or FVID=2", "FCENAOVER", 0) +") as FOVER";	
	var ssum = "sum("+ IIF("FLIMIT!="+ sqlTrue, "FCENA*FKOL", 0) +") as FSUM";
	var sover = "max("+ IIF("FLIMIT="+ sqlTrue, "FCENA", 0) +") as FOVER";
	var oSnap = getSnap("select "+ ssum +","+ sover +" from "+ sTmpTbl);
	if(oSnap)
	{
		sum = Number(oSnap[0]);
		objCl.setVar("HCENAOVER", Number(oSnap[1]));
	}
	FCENA.value = sum;
}

function getPri()
{
	if(!corectPriType())	
		return null;		
	var mFbdate = new Date(FBDAT.value);
	var mFedate = new Date(FEDAT.value);
	
	var sSql = "select FWID, FDAT, FCOD from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue
						+" and fdat>="+ sqlTo(mFbdate) 
						+" and fdat<="+ sqlTo(mFedate) 
					+" order by FDAT desc"
	var oPri = getSnap(sSql);
	if(!oPri)
	{	
		sSql = "select FWID, FDAT, FCOD from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue						 
					+" order by FDAT desc"
		oPri = getSnap(sSql);
		if(!oPri)
		{
			return null;
			showWindow("bill_tariff.js", SW_NOMODAL, new Object());		
			oPri = getSnap(sSql);
			if(!oPri)
				return null;
		}	
	}
	return oPri;
}

function corectPriType()
{
	if(priType)
		priType = priType.toUpperCase();
	var s = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";	
	if(priType==null || s.indexOf(priType)==-1 || priType=="")
	{
		var sMsg = ru("Не установлен параметр 'Тип прайс-листа для тарифов'"
					 ,"Не встановлений параметр 'Тип прайс-листа для тарифів'");
		if(s.indexOf(priType)==-1)
			sMsg = ru("Не корректное значение параметра 'Тип прайс-листа для тарифов'"
					 ,"Не коректне значення параметру 'Тип прайс-листа для тарифов'");
		sMsg += ru("\nОткрыть окно для настройки параметров?"
				  ,"\nВідкрити вікно для налагодження параметрів?");			
		var ret = msgBox("yn", sMsg, ru("Тарифы","Тарифи"));
		
		var par = new Object();
		par.sel = "BILNET";
		if(ret=="y")	
			showWindow("e_param.xml", SW_MODAL, par);
		else
			return false;	
		priType = getPar("BILL_PRI");
		return corectPriType();
	}
	return true;
}

include("sys/DpBaseDlg.js");