include("sys/udfs.js");
include("Objects/DpGetDat.js");

function clMenuInit()
{
	this.dataSrc.AddMenuItem("CALCMO","Розрахунок меморіального-одреру|Расчет мемориального ордера");
}

function clMenuHandler(ID)
{
	switch(ID)
	{
	case "CALCMO":
		var oPar = new Object;
		oPar.fno = this.tbl.getValue("FNO")
		oPar.fsubno = this.tbl.getValue("FSUBNO")
		oPar.fsc = this.tbl.getValue("FSC")
		oPar.fsu = this.tbl.getValue("FSU")
		oPar.fst = this.tbl.getValue("FST")
		
		switch(String(this.tbl.getValue("FCALC")))
		{
		case "obsldat":
			showWindow("l_obslvd_mo.js", SW_NOMODAL, oPar)
			break;
		case "obslan":
			showWindow("l_obslva_mo.js", SW_NOMODAL, oPar)
			break;	
		case "jolink":
			var par = new Object;
			
			var tbl = OpenTable("SELECT *"
				+ " FROM ^servord"
				+ " WHERE fnum=" + this.tbl.getValue("FORDNUM")
				);
			
			if (tbl.IsEmpty())
			{
				alert("Не найден жунал-ордер связь № " + this.tbl.getValue("FORDNUM"))
				break;
			}
			
			par.numord = Number(tbl.getValue("Fnum"));
			par.type   = tbl.getValue("Ftype");
			par.text   = tbl.getValue("Ftxt");
			par.fwid   = tbl.getValue("FWID");
			par.mode = 2;
			par.rmode  = "R";
			
			showWindow("r_ordsv.js", SW_NOMODAL, par);
			break;
		case "vedan":
			var gd = new DpGetDat("dD");
			if(gd.escape)
				return false;
			var par = oPar;
			par.objAsk = gd;
			par.objAsk.fno = this.tbl.getValue("FNO");
			par.objAsk.fsc = this.tbl.getValue("FSC");
			par.objAsk.fsu = this.tbl.getValue("FSU");
			par.objAsk.fst = this.tbl.getValue("FST");
			par.objAsk.fcl1 = 0;
			par.objAsk.tblName = par.qryFrom = "tmp_mem_vedan";
			par.objAsk.isSilentMode = true;//флаг, чтоб не запрашивать подтверждение расчета оборотов и остатков по аналитике, а расчитывать сразу с параметрами по умолчанию
			showWindow("analit.xml", SW_MODAL, par.objAsk);
			if(!par.objAsk.escape)
				doMo4(par);
			break;
		}
		break;
	}
}