
function clAfterLoad()
{
	this.isGrp = true;
	this.grpClassID = this.classID;
}

function clMenuInit(sMenuID)
{
	this.dataSrc.AddMenuItem("IMPORT_XLS", "Імпорт з Excel|Импорт из Excel");
	this.dataSrc.AddMenuItem("SET_GROUPS", "Проставити групи|Проставить группы");
	this.dataSrc.AddMenuItem("", "");
}

function clMenuHandler(sMenuID)
{
	if(sMenuID=="IMPORT_XLS")
	{
		include("Objects/DpClEx.js");
		var sText = UR("Виберіть файл-джерело|Выберите файл-источник");
		var arrFilterExt = new Array("*.xls");
		var sFile = askFile("OPEN", "", arrFilterExt, null, sText);
		if(!sFile)
			return false;
		var exldoc = lpProxy.openExcelWorkbook(sFile);
		if(!exldoc)
			return false;
		var nRowCount = exldoc.getSheet(exldoc.getSheetName(0)).getLastRowNum();
		var nRow = 0;
		
		var sPr = UR("Імпорт ТН ЗЕД: |Импорт ТН ВЕД: ");
		WAIT(sPr + "1/"+ nRowCount);
		
		while(nRow<=nRowCount)
		{
			var oRow = exldoc.getSheet(exldoc.getSheetName(0)).getRow(nRow++);		
			if(!oRow)
				continue;
			if(nRow%10==0)
				WAIT(sPr + (nRow) +"/"+ nRowCount);
			
			var cCod = oRow.getCell(0);
			var cTxt = oRow.getCell(1);
			if(!cCod)
				continue;
			var sCod = "";
			if(cCod.getCellType()==0)
				sCod = String(cCod.getNumericCellValue()).trim();
			else
				sCod = String(cCod.getStringCellValue()).trim();
			if(sCod=="")
				continue;
			var sTxt = String(cTxt.getStringCellValue()).trim();
			var isGrp = false;
			if(sCod.length<9)
				isGrp = true;
			var grpID = findGroup(sCod);
			var nCl = this.Fcl;
			var oCL = new DpClEx(this.classID, nCl);
			var codCL = oCL.nextcod(nCl);
			oCL.setVar("HCOD", codCL);
			oCL.setVar("HTCOD", sCod);
			oCL.setVar("HOUTID", sCod);
			oCL.setVar("HTXT", sTxt);
			oCL.setVar("HISGRP", isGrp);
			oCL.setVar("HGRPCOD", grpID);
			
			var noXML = oCL.getVar("ATTR.NOXML");
			oCL.setAttr("NOXML", true);
			oCL.save("ADD", true);
			oCL.setAttr("NOXML", noXML);
			
			updateTreeKeys("^CLRELCLCL", codCL, "fcod", {extraWhere: " AND fcl="+ nCl, fwidField: "fcod"});
		}
		
		this.tbl.requery();
		this.grid.refresh();
		CLEARWAIT();
	}
	if(sMenuID=="SET_GROUPS")
	{
		var nCl = this.Fcl;
		var tbl = OpenTable("select * from ^LISTCL where FCL="+ nCl +" order by FCOD");
		var nRow = 0;
		var nRowCount = tbl.recordCount;
		var sPr = UR("Оновлення груп: |Обновление групп: ");
		WAIT(sPr + "1/"+ nRowCount);
		for(; !tbl.isEOF(); tbl.MoveNext())
		{
			if(nRow%10==0)
				WAIT(sPr + (nRow) +"/"+ nRowCount);
			nRow++;
			var sCod = String(tbl.getValue("FTCOD")).trim();
			var isGrp = false;
			if(sCod.length<9)
				isGrp = true;
			var grpID = findGroup(sCod);
			var nID = Number(tbl.getValue("FWID"));
			var nCOD = Number(tbl.getValue("FCOD"));
			ExecuteSQL("update ^CLRELCLCL set FISGRP="+ sqlTo(isGrp) +", FGRPID="+ grpID +" where FWID_CL="+ nID);
			updateTreeKeys("^CLRELCLCL", nCOD, "fcod", {extraWhere: " AND fcl="+ nCl, fwidField: "fcod"});
		}
		tbl.close();
		this.tbl.requery();
		this.grid.refresh();
		CLEARWAIT();
	}
}

function findGroup(sCod)
{
	var grpID = 0;
	var grpCod = "";
	if(sCod.length>2)
		grpCod = sCod.substring(0, sCod.length-2);
	if(grpCod!="")
	{
		var oSnap = getSnap("select FCOD from ^LISTCL"
							+" where FCL="+ list.Fcl 
								+" and FTCOD="+ sqlTo(grpCod)
							);
		if(oSnap && oSnap[0])
			grpID = Number(oSnap[0]);
		else if(grpCod.length>1)
			return findGroup(grpCod);
	}
	return grpID;
}
