include("Objects/DpGrid.js");

var tblName = "tmp_colors_rgb";
var oGrid;

function listLoad()
{
	this.title = UR("Кольори|Цвета");
	
	ExecuteSQL("drop table "+ tblName, false);
	ExecuteSQL("create table "+ tblName 
			+" (FNUM "+ SqlType("INT") 
			+", FRED "+ SqlType("INT") 
			+", FGREEN "+ SqlType("INT") 
			+", FBLUE "+ SqlType("INT") 
			+", FTXT "+ SqlType("TEXT") 
			+")");
	
	var num = 1;
	for(var r=0; r<=255; r+=50)
	{
		for(var g=0; g<=255; g+=50)
		{
			for(var b=0; b<=255; b+=50)
			{
				var txt = r+","+g+","+b;
				ExecuteSQL("INSERT INTO "+ tblName +" (FNUM,FRED,FGREEN,FBLUE,FTXT)"
							+" values ("+ num++ +","+r+","+g+","+b+","+ sqlTo(txt) +")"
							, false
							);
			}
		}
	}
	ExecuteSQL("INSERT INTO "+ tblName +" (FNUM,FRED,FGREEN,FBLUE) values (999999,255,255,255)");
}	

function listSrc()
{
	this.qrySet("From", tblName
				, "Order", "FRED, FGREEN, FBLUE"
				);	
}

function listDpGrid()
{
	oGrid = new DpGrid("NOCREATE");
	loadCond();
	with(oGrid.page())
	{	
		//cell("FNUM", "N", 10);
		cell("FRED", "R", 10);
		cell("FGREEN", "G", 10);
		cell("FBLUE", "B", 10);
		//cell("=^FRED+','+^FGREEN+','+^FBLUE", "", 10);
	}
	oGrid.build();
}

function loadCond()
{
	var tbl = OpenTable(tblName);
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		var r = tbl.getValue("FRED");
		var g = tbl.getValue("FGREEN");
		var b = tbl.getValue("FBLUE");
		var sColor = r +","+ g +","+ b;
		var nType = tbl.getValue("FNUM");
		gridCond(sColor, nType);
	}
}

function gridCond(sColor, nType)
{
	with(oGrid)
	{
		var sCond = String(nType);
		defCond("=^FNUM=="+ nType, sCond);
		objGrid.setBackground(sColor, sCond, 1);
		bold(sCond);		
	}
}

include("sys/DpList.js");