include("Objects\\DpJRegistrator.js");
include("Objects\\DpGetDat.js");
include("sub/bil.js");

var tblOut = "BILDOG";
var oDoc = new DpDoc(extPar.doc,extPar.nop);
var fl = true;
var jID = oDoc.getPar("__jrn");
var j_fwid = 0;
var nSumOpl = 0;
var nSumVik = 0;
var tbl_j;
var journal;
var oReg; 
var objDoc = extPar.doc;
var objNop = extPar.nop;

function docSrc()
{
	if ((jID != "0") && (jID != null) && (jID != "undefined") && (jID != ""))
	{
		oReg = new DpJRegistrator(null,null);
		journal = oReg.listJournals()[jID];
		tbl_j=journal.getFullTableName();
	}
	else
	{
		fl = false;		
	}
	dat1 = getPar("GLOBDAT1");
	dat2 = getPar("GLOBDAT2");
	
	if(extPar.bdat)
		dat1 = extPar.bdat;
	if(extPar.edat)
		dat2 = extPar.edat;	
	
	//gd = new DpGetDat("dD");	
	//if (gd.escape) 
	//	return false;
	
	var sWhere = " C.FDOC='BILDOG' ";
	if (list.m_Nop != 0)
		sWhere += " AND C.FNOP="+ sqlTo(list.m_Nop);
	if(extPar.Forg && this.oOrg)
		this.oOrg.setCod(extPar.Forg);
	if(extPar.Forg)
		sWhere += " AND C.FORG="+ sqlTo(extPar.Forg)
	if(this.oOrg && this.oOrg.getCod())
		sWhere += " AND C.FORG="+ sqlTo(this.oOrg.getCod())
	if(extPar.Fphone)
	{
		var fwids = "";
		var tbl = OpenTable("s", "select FID_DOG from ^BIL_PACK "
					+" where FPHONE="+ extPar.Fphone);		
		for(; !tbl.isEOF(); tbl.MoveNext())
			fwids += ","+ tbl.getValue("FID_DOG");
		
		if(fwids.trim()!="")
			fwids = fwids.substr(1)
		else
			fwids = "0";
		
		sWhere += " AND C.FWID in ("+ fwids +")";			
	}
	if(extPar.packID)
	{
		sWhere += " AND H.FID_DOG in (select b.FID_DOG from ^"+ tblOut +" b inner join ^BIL_PACK p on p.FID_DOG=b.FID_DOG where p.FWID_CL="+ sqlTo(extPar.packID) +")";
	}
	if(extPar.fid_doc)
		sWhere += " AND H.FID_DOG in ("+ extPar.fid_doc +")";
	if(extPar.fid_dog)
		sWhere += " AND H.FID_DOG in ("+ extPar.fid_dog +")";
	if(extPar.end)
		sWhere += " AND (C.FEDAT<="+ sqlTo(goMonth(today,2)) +" and C.FEDAT>"+ sqlTo(today) +")";
	/*
	sWhere += " AND ((C.FBDAT <= "+ sqlTo(dat1) +" AND C.FEDAT >= "+ sqlTo(dat2) +") " 
				+" OR (C.FBDAT >= "+ sqlTo(dat1) +" AND C.FBDAT <= "+ sqlTo(dat2) +") " 
				+" OR (C.FEDAT >= "+ sqlTo(dat1) +" AND C.FEDAT <= "+ sqlTo(dat2) +"))";
	*/
	//sWhere += " AND (C.FDOC_DAT >= "+ sqlTo(dat1) +" AND C.FDOC_DAT <= "+ sqlTo(dat2) +") " 
				
	this.qryAlias = "c";
	this.qrySet("Fields", "h.*,c.FDOC_DAT,c.FDOG_NUM,c.FBDAT,c.FEDAT,c.FORG,c.FTXT"
					+",c.FSUM_DOG,c.FWID,c.FNOP,cl.FTXT as FORGTXT,cl.FTXTS,post.FCOD_ST"
				,"From", "^"+ tblOut +" H "
						+" INNER JOIN ^CONTRACT C ON C.FWID=H.FID_DOG "
						+" inner join ^CLRELCLCL rel on rel.FCOD=c.FORG and rel.FCL="+ getPar("CODPLAT") 
						+" inner join ^CL cl on cl.FWID=rel.FWID_CL "
						+" inner join ^CL_POST post on post.FWID_CL=cl.FWID"
			,"Where", sWhere
			,"Order", "C.FDOC_DAT,C.FDOC_NUM"
			,"WhereArr", new Array("C.FCLOSE="+ sqlFalse, "C.FCLOSE<>"+ sqlFalse)
			,"WhereArrName", new Array("Відкриті|Окрытые", "Закриті|Закрытые")
			//,"WhereArrI", 0
			);
	this.showDocView = showDocView;
	//this.tm = null;
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
	
	if(extPar.checkEndDog)
	{
		var endDog = endDogCount();
		if(endDog>0)
		{
			WAIT(UR("Знайдено угоди у яких спливає термін дії: "
					+"|Найдены договора у которых истекает срок действия: ")
					+ endDog);
		}
	}
}

function onMessage(sType, oPar)
{
	extPar.doc = oPar.doc;
	extPar.nop = oPar.nop;
	extPar.Fcl = oPar.Fcl;
	extPar.Forg = oPar.Forg;
	extPar.Fphone = oPar.Fphone;
	list.reLoad();	
	//if(oPar && !oPar.grid)
	//	oPar.grid = grid;
		
	if(typeof runViews=="function")
		runViews(oPar);	
	docRunViews(oPar);
	
	if(oPar.grid)
		oPar.grid.setFocus();
}

function listInitEditParam(oPar)
{
	oPar.Forg = extPar.Forg;
}

function docMenuInit()
{
	if(this.tbl.isEmpty())
		return;
	this.dataSrc.AddMenuItem("BILCARD", "Картка|Карточка");	
	this.dataSrc.AddMenuItem("BILAKT", "Акт звірення|Акт сверки");
	this.dataSrc.AddMenuItem("STATISTIC", "Статистика|Статистика");
	this.dataSrc.AddMenuItem("", "");
	this.dataSrc.AddMenuItem("DOCS", "Документи по договору|Документы по договору");
	this.dataSrc.AddMenuItem("BILL", "Сформувати нарахування|Сформировать начисления");
	this.dataSrc.AddMenuItem("DOGEND", "Список угод що спливають|Список истекающих договоров");
	this.dataSrc.AddMenuItem("", "");
/*
	this.dataSrc.AddMenuItem("AKT","Акт звіряння за контрагентом|Акт сверки по контрагенту");
	this.dataSrc.AddMenuItem("+++","Документи|Документы");
	this.dataSrc.AddMenuItem("DOC_CN","По договору|По договору");
	this.dataSrc.AddMenuItem("ALL_DOC_ORG","По контрагенту|По контрагенту");
	this.dataSrc.AddMenuItem("ALL_DOC","Всі|Все");
	this.dataSrc.AddMenuItem("---");
	this.dataSrc.AddMenuItem("SUM_CN", "Проставити суму виконаного\\оплаченого|Проставить сумму выполненного\\оплаченного");
	if (list.tbl.getValue("FCLOSE") == false)
		this.dataSrc.AddMenuItem("CLOSE","Закрити договір|Закрыть договор");
	else
		this.dataSrc.AddMenuItem("OPEN","Відкрити договір|Открыть договор");
	
	this.dataSrc.AddMenuItem("PRINT_DOG","Надрукувати договір|Напечатать договор");
*/
}

function docMenuHandler(nID)
{		
	if (nID == "DOGEND")
	{
		var par = new Object();
		par.doc = "BILDOG"
		par.nop = this.oDoc.getVar("HOP");
		par.end = true;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
		return;
	}
	
	if (nID == "DOCS")
	{
		this.showDocView();
		return;
	}
		
	if(nID=="STATISTIC")
	{
		var par = new Object();
		par.Forg = this.tbl.getValue("FORG");
		showWindow("bill_statistic.js", SW_MODAL, par);
	}
	
	if(nID=="BILCARD")
	{
		var par = new Object();
		par.org = this.tbl.getValue("FORG");
		par.dog = this.tbl.getValue("FID_DOG");
		par.dat = new Date();
		showWindow("bill_card.js", SW_NOMODAL, par);
	}
	
	if(nID=="BILAKT")
	{
		var par = new Object();
		par.org = this.tbl.getValue("FORG");
		par.dog = this.tbl.getValue("FID_DOG");
		par.dat = new Date();
		showWindow("bill_akt.js", SW_NOMODAL, par);
	}
	
	if(nID=="BILL")
	{
		formBill(list.tbl.getValue("FWID"));
	}	
}

function docDel(fid_doc)
{
	if(getSystem()=="BIL2")
	{
		closeBillDog(fid_doc, true);
	}
	return true;
}

function onAfterMenuRun(mnuID)
{	
	if(mnuID=="ADD" || mnuID=="EDIT" || mnuID=="COPY" || mnuID=="DEL")
	{
		if(typeof runViews=="function")
			runViews();
		docRunViews();
	}	
}

function onAfterEdit(oDoc, mnuID)
{
	if(mnuID=="ADD" || mnuID=="EDIT" || mnuID=="COPY")
	{		
		var bCredit = Number(oDoc.getVar("HBILSYS"))==1;
		var _formBill = oDoc.getPar("_form_bill");
		var _formSF = oDoc.getPar("_formsf");
		var _formNK = oDoc.getPar("_formnk");
		if(!bCredit && (_formBill==true || _formBill=="true"))
			formBill(oDoc.getID(), true, _formSF, _formNK);
	}
	if(mnuID=="ADD" || mnuID=="COPY")
	{
		var _print = oDoc.getPar("_print");
		if(_print==true || _print=="true")
		{
			include("objects\\DpTVars.js");
			var vars = new DpTVars("DOC", this.m_Doclabel);
			vars.setDoc(this.m_Doclabel, this.m_Nop);
			vars.eval.setJDoc(oDoc);
			vars.eval.setRowTable(oDoc.jDoc.getRowTable("PACK"));
			docPrint(vars);
			vars.print();
		}
	}
}

function showDocView()
{		
	jID = this.oDoc.getPar("__jrn");
	if(!jID)
		jID = "CRM";

	var par = new Object();	
	par.jID = jID;
	par.dog = Number(this.tbl.getValue("FWID"));
	par.org = Number(list.tbl.getValue("FORG"));	
	var view = lpProxy.getView("doc" + objDoc+objNop);
	if (view == null)
	{
		
		this.docSelRecordHandler = docSelRecordHandler;
		grid.setSelHandler(this, "docSelRecordHandler"); 
		lpProxy.showView("doc" + objDoc+objNop, "l_crm.xml", par)
	}
	else
	{
		view.sendMessage("doc", par);	
	}
}

function docSelRecordHandler()
{
	if (this.tm == null)
	{
		this.tm = runTimer(docRunViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
	
}

function docRunViews(oPar)
{
	var par = new Object();	
	par.jID = jID;
	if(oPar)
		par.grid = oPar.grid;
	par.dog = Number(list.tbl.getValue("FWID"));
	par.org = Number(list.tbl.getValue("FORG"));	
	if(!par.org)
		par.org = 0;
	if(!par.dog)
		par.dog = 0;	
	var view = lpProxy.getView("doc" + objDoc+objNop);
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("doc", par);	
		}
	}
	//grid.setFocus();
	//if(oPar && oPar.grid)
	//	oPar.grid.setFocus();	
}

function docPrint(oVars)
{
	var path = oDoc.getPar("_print_path");
	if(path==null || path=="")
		path = lpProxy.tempDirectory();
	var dogNum = oVars.getVar("HDOG_NUM");
	var orgTxt = tforg("TXT", oVars.getVar("HORG"));
	orgTxt = java.lang.String(orgTxt).replaceAll("\"|'", "");
	orgTxt = orgTxt.replace("\u002E", "");	
	dogNum = java.lang.String(dogNum).replaceAll("(/KI)|(/КІ)|(/КI)|(/KІ)", "");
	path += "/"+ dogNum +"_"+ orgTxt;
			
	oVars.setSavePath(path);
}

function endDat(edat)
{
	var dif = month_difference(new Date(), new Date(edat));
	return dif<=2 && dif>0;
}

function offDat(edat)
{
	var dif = month_difference(new Date(), new Date(edat));
	return dif<0;
}

function difDat(edat)
{
	return month_difference(new Date(), new Date(edat));
}

function endDogCount()
{
	var oSnap = getSnap("select count(*) from ^CONTRACT "
				+" where FEDAT<="+ sqlTo(goMonth(today, 2)) 
					+" and FEDAT>"+ sqlTo(today));
	if(!oSnap)
		return 0;
	return Number(oSnap[0]);
}