include("Objects/DpCl.js");
include("Objects/DpNmkl.js");
include("Objects/DpCntrct.js");
include("servis/date.js");
include("sub/bil.js");

var sTmpTbl = "RBILLTMP";
var ctrlLinker;
var obj;
var oNmkl;
var oClient;
var oCntr;
var priType;
var codPack;
var codPlat;
var vidDog;
var bdat;
var edat;
var bLimit = false;
var datEdit = false;
var bCorrect;

function Load()
{
	Caption(ru("Счета", "Рахунки"), extPar.mode);
	
	edMode = extPar.mode;
	mFwid  = extPar.fwid;
	
	obj = extPar.obj;
	vidDog = obj.parent.getPar("_viddog");
	codPack = obj.parent.getPar("_codpack");
	codPlat = obj.parent.getPar("_codplat");
	priType = getPar("BILL_PRI");
	if(vidDog==1)
		priType = getPar("BILTEL_PRI");	
	if(!codPack && vidDog==0)
		codPack = getPar("BILL_PACK");
	else if(!codPack && vidDog==1)
		codPack = getPar("BILTEL_PACK");		
	if(!codPlat && vidDog==0)
		codPlat = getPar("BILL_CL");
	else if(!codPlat && vidDog==1)		
		codPlat = getPar("BILTEL_CL");
	
	bdat = new Date(obj.parent.getVar("HDAT"));
	edat = new Date(obj.parent.getVar("HEDAT"));
	
	oNmkl = new DpNmkl();
	oNmkl.linkCtrl(Fnmkl, tFnmkl);
	//oNmkl.CanEmpty = true;
	oNmkl.afterLoad = recalcSum2;
	setValid(Fnmkl, loadNmk);
	
	oClient = new DpCl("", codPlat, 0);
	oClient.linkSmartCtrl(Fclient);
	oClient.setContAssist();
	oClient.AfterUpdate = setOrg;
		
	oCntr = new DpCntrct("+");
	oCntr.linkCtrl(Fdog, Fdog_txt);
	oCntr.subUpdate = loadCntr;
	
	oPack = new DpCl("0!", codPack, 0);
	oPack.linkCtrl(Fpack, Fpack_txt);
	oPack.AfterUpdate = loadPack;
	
	Fkol.mask = MASK_KOL;
	Fusekol.mask = MASK_KOL;
	Fcena.mask = MASK_SUM;
	Fsum.mask = MASK_SUM;
	//Fcenaover.mask = MASK_SUM;
	Fincr.mask = MASK_SUM;
	
	loadVid();
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RPAYDAT", FPAYDAT);		
	ctrlLinker.addLink("RSUM", Fsum);
	ctrlLinker.addLink("RCENA", Fcena);	
	//ctrlLinker.addLink("RCENAOVER", Fcenaover);	
	ctrlLinker.addLink("RKOL", Fkol);	
	ctrlLinker.addLink("RUSEKOL", Fusekol);
	ctrlLinker.addLink("RVID", FVID);
	ctrlLinker.addLink("RINCR", Fincr);
	ctrlLinker.updateData(false);
	
	var tbl = extPar.tbl;		
	if (extPar.mode == "EDIT" || extPar.mode == "COPY")
	{
		oClient.setCod(obj.getVar("RCLIENT"));
		oNmkl.setCod(obj.getVar("RNMKL"));
		oCntr.setOrg(obj.getVar("RCLIENT"));
		oCntr.setID(obj.getVar("RDOGID"));
		oPack.setFWID(obj.getVar("RPACKID"));				
		//setAddr();		
	}
	
	if (extPar.mode == "ADD")
	{			
		oClient.setCod(obj.parent.getVar("HCLIENT"));
		oNmkl.setCod(obj.parent.getVar("HNMKL"));
		oCntr.setOrg(oClient.getCod(), true);
		if(obj.parent.getVar("HID_DOG"))
			oCntr.setID(obj.parent.getVar("HID_DOG"));				
	}
		
	setWhen(Fsum, whenSum);
	this.recalcSum2 = recalcSum2;
	setButton(Fsum, this, "recalcSum2");
		
	Disable(Fincr);
	if (extPar.mode=="EDIT")
	{
		Disable(Fcena);
		Disable(Fkol);
		Disable(Fusekol);
		dat_valid();
	}
	
	setValid(FVID, check_date);	
	setValid(FPAYDAT, dat_valid);
	
	bCorrect = isCorNakl(obj.parent.getID(), sTmpTbl);
	//recalcSum2();
	check_date();
}

//устанавливает дату оказания услуги
function check_date(ctrt)
{
	if(datEdit)	//если дата редактировалась не изменяем
		return;
	var date = new Date(obj.parent.getVar("HDAT"));
	var bCredit = isCreditSystem(oCntr.getID());
	var payDat = billDate(date, FVID.value, bLimit, bCredit);
	if(bCorrect)
		FPAYDAT.value = date.getVarDate();
	else
		FPAYDAT.value = payDat.getVarDate();
}

function dat_valid()
{
	datEdit = true;
}

function onSave()
{
	ctrlLinker.updateData(true);
	obj.setVar("RCLIENT", oClient.getCod());
	obj.setVar("RNMKL", oNmkl.getCod());
	obj.setVar("RDOGID", oCntr.getID());
	obj.setVar("RPACKID", oPack.getFWID());
	
	//var payDat = obj.parent.getVar("HDAT");
	//payDat = billDate(payDat, FVID.value, bLimit);
	//obj.setVar("RPAYDAT", payDat);
	
	var eDat = obj.parent.getVar("HEDAT");
	obj.setVar("REDAT", eDat);	
}

function loadVid()
{
	FVID.addItem("1", UR("Щомісячна|Ежемесячная"));
	FVID.addItem("2", UR("Додаткова|Дополнительная"));
	FVID.addItem("3", UR("Разова|Разовая"));
	FVID.addItem("4", UR("Товар|Товар"));
	
	//FVID.value = "1";
}

function setOrg()
{
	oCntr.setOrg(oClient.getCod(), true);	
}

function getUseKol()
{
	var kol = 0;
	var dogID = oCntr.getID();
	if(!dogID)
		return kol;
	
	var nmk = oNmkl.getCod();	
	var bDat = new Date(goMonth(bdat, -1));
	var eDat = new Date(lastDay(bDat));
	bDat = new Date(firstDay(bDat));
	var oSnap = getSnap("select FKOL from ^RRU "
					+" where FID_DOG="+ dogID
						+" and FNMKL="+ sqlTo(nmk)
						+" and FDATE>="+ sqlTo(bDat)
						+" and FDATE<="+ sqlTo(eDat)
					+" order by FDATE desc"
					, false);
	if(oSnap)
		kol = oSnap[0];
	return kol;
}

function whenSum()
{
	if(Fsum.value==0)
		recalcSum2()
}

function loadCntr()
{
	var dogID = oCntr.getID();
	if(!dogID || oPack.getFWID())
		return true;
	var oSnap = getSnap("select FINCR "
						+" from ^BILDOG "
						+" where FID_DOG="+ dogID
					, false);
	if(!oSnap)
		return true;
	
	Fincr.value = oSnap[0];
}

function loadPack()
{
	var nmk = oNmkl.getCod();
	if(nmk)
		return true;
	
	var oSnap = getSnap("select count(*) as cnt "
						+" from ^CL_SERV "
						+" where FWID_CL="+ oPack.getFWID()
					, false);
	if(!oSnap)
		return true;
	
	if(Number(oSnap[0])==1)
	{
		oSnap = getSnap("select FNMKL, FVID "
						+" from ^CL_SERV "
						+" where FWID_CL="+ oPack.getFWID()
					, false);
		oNmkl.setCod(Number(oSnap[0]));
		loadNmk();
	}
}

function loadNmk(oCtrl)
{
	Fusekol.value = getUseKol();
	
	bLimit = false;
	//Fkol.value = 0;
		
	var nmk = oNmkl.getCod();
	var oSnap = getSnap("select FCENA, FKOL, FEKOL, FLIMIT, FVID "
					+" from ^CL_SERV "
					+" where FWID_CL="+ oPack.getFWID()
						+" and FNMKL="+ nmk
					, false);
	if(!oSnap)
		return;
		
	Fcena.value = oSnap[0];
	if(!oCtrl)
	{
		Fkol.value = oSnap[1];
		FVID.value = oSnap[4];
	}
	bLimit = oSnap[3];
	
	check_date();
}

function recalcSum2()
{	
	loadNmk();
	Fsum.value = 0;
	
	var nmk = oNmkl.getCod();
	if(!nmk || nmk==0)
		return;
		
	Fsum.value = getSumBill(nmk, bdat, edat);
}

function getSumBill(nmk, mFbdate, mFedate)
{
	//loadPack()
	
	var oBDate = new Date(mFbdate);
	var oEDate = new Date(mFedate);
	
	var fcena = Number(Fcena.value);			
	var fusekol = Number(Fusekol.value);
	var fkol = Number(Fkol.value);
	var fincr = Number(Fincr.value);		//скидка
	
	var edatPack = new Date(d00);
	var oSnap = getSnap("select p.FEDAT, d.FINCR from ^BIL_PACK p "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" where p.FID_DOG="+ sqlTo(oCntr.getID())
					+" and p.FWID_CL="+ sqlTo(oPack.getFWID())
					+" and p.FBDAT<="+ sqlTo(oBDate));
	if(oSnap)
	{
		edatPack = new Date(oSnap[0]);		
	}
	//если пакет закрыт, абонплата начисляется по новому пакету	
	if(differ(edatPack, new Date(d00))<0)
	{
		fcena = 0;
		var sSQL = " select s.FCENA from ^CL_SERV s "
					+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
					+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
					+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
				+" where d.FID_DOG="+ sqlTo(oCntr.getID())
					+" and p.FBDAT>="+ sqlTo(edatPack)
					+" and p.FEDAT="+ sqlD00;
		var oSnap = getSnap(sSQL);
		if(oSnap)
			fcena = oSnap[0];
	}
		
	var nSum = fcena*fkol;
	if(bLimit==true || bLimit=="true")
	{
		nSum = 0;
		if(fusekol>fkol)
			nSum = (fusekol-fkol)*fcena;
	}	
	Fcena.value = fcena;
	
	if(fincr)	
		nSum += nSum*fincr/100;
		
	return nSum;
}

include("sys/DpBaseDlg.js");