include("Objects/DpGetDat.js");
include("doc/DpDocPtn.js");
include("servis/date.js");
include("sub/bil.js");

var sRowTbl = "RBILL";		
var sBillTbl = "TMP_BILL";
var sRClass = "ROW";
var datBill = new Date();
var objDoc;
var oBDate;
var oEDate;
list.accDel = accDel;

function docMenuInit(ds)
{
	ds = grid;
	//ds.AddMenuItem("", "");
	//ds.AddMenuItem("BILL","Сформувати нарахування|Сформировать начисления");
	ds.AddMenuItem("", "");
	if(!this.tbl.isEmpty())
	{
		ds.AddMenuItem("", "");
		ds.AddMenuItem("FIND_SF", "Знайти рахунки-фактури|Найти счета-фактуры", !findSF());		
		var isFullSF = isSF(list.tbl.getValue("FWID"));
		ds.AddMenuItem("FORM_SF","Cформувати рахунки-фактури|Сформировать счета-фактуры", isFullSF);		
		ds.AddMenuItem("FORM_SFALL","Cформувати рахунки-фактури за період|Сформировать счета-фактуры за период");
		
		ds.AddMenuItem("", "");
		ds.AddMenuItem("FIND_NK", "Знайти видатковi накладні|Найти расходные накладные", !findNK());
		var isFullNK = isNK(list.tbl.getValue("FWID"));
		ds.AddMenuItem("FORM_NK","Cформувати видатковi накладні|Сформировать расходные накладные", isFullNK);
		ds.AddMenuItem("FORM_NKALL","Cформувати видатковi накладні за період|Сформировать расходные накладные за период");
		ds.AddMenuItem("", "");	
		ds.AddMenuItem("FIND_FAIL","Знайти помилкові нарахування|Найти ошибочные начисления");
		ds.AddMenuItem("BIL_CHECK","Перевірка нарахувань за період|Проверка начислений за период");
		ds.AddMenuItem("", "");		
	}	
}

function listInitEditParam(oPar)
{
	oPar.grid = this.grid;
}

function docMenuHandler(sID)
{		
	var _nopSF = this.oDoc.getPar("_nopsf");
	if (sID == "FIND_SF" || sID == "FIND_NK")
	{
		var fid_doc = this.tbl.getValue("FWID");
		var par = new Object();
		par.doc = "SF";
		par.nop = Number(_nopSF);
		if(sID == "FIND_NK")
		{
			par.doc = "NK";
			par.nop = Number(getPar("BILL_NK"));
			if(isCorNakl(fid_doc, "RBILL"))
				par.nop = Number(getPar("BILL_COR"));
		}
		par.bdat = d00min;
		par.FORG = this.tbl.getValue("FCLIENT");
		par.subWhere = " FWID in (select rel.FID_DOC "
							+" from ^RELBILL rel "
							+" where rel.FID_BIL="+ fid_doc +")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);		
	}
	
	if (sID == "FORM_SF")
	{
		var nNop = Number(_nopSF);
		var date = this.tbl.getValue("FDOC_DAT");
		var fid_doc = this.tbl.getValue("FWID");
		formSF(nNop, date, 0, 0, fid_doc);	//sub/bil.js
		grid.refresh();	
	}
	
	if (sID == "FORM_SFALL")
	{
		var nNop = Number(_nopSF);
		formSF(nNop);	//sub/bil.js
		grid.refresh();	
	}
	
	if (sID == "FORM_NK")
	{
		var date = new Date(list.tbl.getValue("FDOC_DAT"));
		//date = lastDay(goMonth(date, -1));
		var nClient = list.tbl.getValue("FCLIENT");
		var fid_doc = list.tbl.getValue("FWID");
		//formNK(date, nClient);
		formNK(date, nClient, 0, 0, 0, fid_doc);	//sub/bil.js
		grid.refresh();	
	}
	
	if (sID == "FORM_NKALL")
	{
		var date = lastDay(goMonth(new Date(), -1));
		formNK(date);	//sub/bil.js
		grid.refresh();	
	}	
	
	if(sID == "FIND_FAIL")
	{
		include("bill_trans.js");
		showFailBill();		
	}
	
	if(sID == "BIL_CHECK")
	{
		showWindow("bill_check.js");
	}
	
	if(sID == "DEL")
	{
		var fid_doc = list.tbl.getValue("FWID");
		var bFindNK = findNK(fid_doc);
		var bFindSF = findSF(fid_doc);
		if(bFindNK || bFindSF)
		{
			var sMsg = UR("УВАГА!\nЗа даними нарахуваннями знайдені документи: "
							+(bFindNK? "\n	видаткові накладні" : "")
							+(bFindSF? "\n	рахунки-фактури" : "") 
							+"\nПотрібно спочатку вилучити ці документи."
							+"\nДля пошуку документів можна скористатися контекстним меню: "
							+ (bFindNK? "\n	\"Знайти видаткові накладні\"" : "") 
							+(bFindSF? "\n	\"Знайти рахунки-фактури\"" : "")
							+"\nВідкрити список знайдених документів?"
						+"|ВНИМАНИЕ!\nПо данным начислениям найдены документы:"
							+(bFindNK? "\n	расходные накладные" : "")
							+(bFindSF? "\n	счета-фактуры" : "") 
							+"\nНужно сначала удалить эти документы."
							+"\nДля поиска документов можно воспользоваться контекстным меню: "
							+(bFindNK? "\n	\"Найти расходные накладные\"" : "")
							+(bFindSF? "\n	\"Найти счета-фактуры\"" : "")						
							+"\nОткрыть список найденных документов?"
						);
			if(confirm(sMsg))
			{
				if(bFindNK)
					this.mnuHandler("FIND_NK");
				if(bFindSF)
					this.mnuHandler("FIND_SF");
			}		
			return DpList_exit;
		}
	}
}

function accDel()
{	
	if(findSF() || findNK())
		return false;
	return true;
}

function filterMode(sID)
{
	if(sID == "__XDEL")
		return false;
	return true;
}

function findSF(billID)
{		
	if(!billID)
		billID = list.tbl.getValue("FWID");
	var oSnap = getSnap("select FID_DOC from ^RELBILL"
					+" where FID_BIL="+ billID
						+" and FDOC='SF'"
					, false);
	return oSnap!=null;
}

function findNK(billID)
{
	if(!billID)
		billID = list.tbl.getValue("FWID");
	var oSnap = getSnap("select FID_DOC from ^RELBILL"
					+" where FID_BIL="+ billID
						+" and FDOC='NK'"
					, false);
	return oSnap!=null;
}

function docDel(fid_doc)
{	
	if(findSF() || findNK())
		return false;
	//ExecuteSQL("delete from ^RELBILL where FID_DOC="+ fid_doc, false);
	return true;
}

function onAfterEdit(oDoc, mnuID)
{
	if(mnuID=="VIEW")
		return;
			
	makeDocs(oDoc);
}

function makeDocs(objDoc)
{
	var date = new Date(objDoc.getVar("HDAT"));
	var org = objDoc.getVar("HCLIENT");	
	var dog = objDoc.getVar("HID_DOG");
	var nmk = objDoc.getVar("HNMKL");
		
	var bPrintSF = false;
	var bPrintNK = false;
	var bFormDebtSF = true;
	if(org)
	{
		bPrintSF = true;
		bPrintNK = true;
		bFormDebtSF = false;
	}
		
	makeSF(objDoc, null, sRowTbl, null, bPrintSF, true, bFormDebtSF);	//sub/bil.js
	
	var _formNK = objDoc.getPar("_formnk");
	if(!_formNK)
		return true;
	
	var bCorrect = isCorNakl(objDoc.getID(), sRowTbl);
				
	var sMsg = UR("Сформувати видаткові накладні|Сформировать расходные накладные");
	if(org)
		sMsg += "\nдля "+ tcl("CL", "TXT", getPar("BILL_CL"), org);
	
	//для корректировки формируем накладную только по этому начислению.
	if(bCorrect)
	{
		if(!isNK(objDoc.getID(), vid, date, org, dog, sRowTbl, bCorrect))
		{ 
			if(confirm(sMsg))
				formNK(date, org, dog, vid, nmk, objDoc.getID(), true, bCorrect, bPrintNK);
		}				
		return true;
	}
	
	//формирование накладных по одному контрагенту: только по этому начислению, по выбранной услуге	
	if(org!=0 && nmk!=0)
	{				
		var oSnap = getSnap("select FVID from ^"+ sRowTbl 
							+" where FID_DOC="+ objDoc.getID()
								+" and FNMKL="+ sqlTo(nmk));
		if(oSnap)
		{
			var vid = oSnap[0];					
			if(!isNK(objDoc.getID(), vid, date, org, dog, sRowTbl))
			{ 
				sMsg += "\nпо '"+ tfnmk("TXT",nmk) +"'"
						+"\nна "+ tmonth(date, 1) +"?";	
				if(confirm(sMsg))
					formNK(date, org, dog, vid, nmk, objDoc.getID(), true, bCorrect, bPrintNK);
			}				
			return true;	
		}
	}	
	
	//формирование накладных по начислениям за прошлый месяц (кроме корректировок)
	var payDat = lastDay(goMonth(date, -1));		
	if(!bCorrect && !isNK(null, null, payDat, org, dog))
	{
		if(confirm(sMsg +"\nна "+ tmonth(payDat, 1) +"?"))
			formNK(payDat, org, dog, 0, 0, 0, true, false, bPrintNK);			
	}
		
	//формирование накладных по начислениям за текущий месяц
	if(!isNK(null, null, date, org, dog))
	{			
		if(confirm(sMsg +"\nна "+ tmonth(date, 1) +"?"))
			formNK(date, org, dog, 0, 0, 0, true, bCorrect, bPrintNK);					
	}
}

if(typeof GRORG!="undefined")
	GRORG.setVisible(true);
	