include("doc\\DpDocList.js");
include("objects\\DpVal.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("Tmoney.js");
include("sys\\udfs.js")

var objDoc = extPar.doc;
var sTmpTbl = "TMP_RBRNK";
var ctrlLinker;
var oVal;
var tbl;

function Load()
{
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;
	
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	HTN.setMask(MASK_DOCNUM);
	HBSUM.setMask(MASK_SUM);
	HESUM.setMask(MASK_SUM);
//	Disable(HESUM, true);
	HSUM_POL.setMask(MASK_SUM);
	HSUM_VSKLAD.setMask(MASK_SUM);
	HSUM_FVSKLAD.setMask(MASK_SUM);
	HSUM_VPOK.setMask(MASK_SUM);
	HSUM_REAL.setMask(MASK_SUM);
	HSUM_DISCOUNT.setMask(MASK_SUM);
	HSUM_VITORG.setMask(MASK_SUM);
	HSUM_V2POK.setMask(MASK_SUM);
	HSUM_CRED.setMask(MASK_SUM);
	HSUM_VCRED.setMask(MASK_SUM);
	HSUM_RRO.setMask(MASK_SUM);
	HSUM_KRK.setMask(MASK_SUM);
	HSUM_KRK2.setMask(MASK_SUM);
	HSUM_KRK_ALL.setMask(MASK_SUM);
	HSUM_2BNK.setMask(MASK_SUM);
	INKAS.setMask(MASK_SUM);
	Disable(HSUM_POL, true);
	Disable(HSUM_VSKLAD, true);
	Disable(HSUM_VPOK, true);
	Disable(HSUM_REAL, true);
	Disable(HSUM_DISCOUNT, true);
	Disable(HSUM_VITORG, true);
	Disable(HSUM_V2POK, true);
	Disable(HSUM_CRED, true);
	Disable(HSUM_VCRED, true);
	Disable(HSUM_RRO, true);
	Disable(HSUM_KRK, true);
	Disable(HSUM_KRK2, true);
	Disable(HSUM_KRK_ALL, true);
	Disable(HSUM_2BNK, true);
	Disable(INKAS, true);
	
//	oVal = new DpVal();
	//oVal.linkCtrl(HVAL);
	
	objPodr = new DpCl();
   	objPodr.linkSmartCtrl(HPODR);
	objPodr.setClcl(sprPodr);
	objPodr.setContAssist();
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",HTN);
	//ctrlLinker.addClLink("HVAL",oVal);
	//ctrlLinker.addLink("HSUM",HSUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HBSUM",HBSUM);
	ctrlLinker.addLink("HESUM",HESUM);
	ctrlLinker.addLink("HSUM_POL",HSUM_POL);
	ctrlLinker.addLink("HSUM_VSKLAD",HSUM_VSKLAD);
	ctrlLinker.addLink("HSUM_FVSKLAD",HSUM_FVSKLAD);
	ctrlLinker.addLink("HSUM_VPOK",HSUM_VPOK);
	ctrlLinker.addLink("HSUM_REAL",HSUM_REAL);
	ctrlLinker.addLink("HSUM_DISCOUNT",HSUM_DISCOUNT);
	ctrlLinker.addLink("HSUM_VITORG",HSUM_VITORG);
	ctrlLinker.addLink("HSUM_V2POK",HSUM_V2POK);
	ctrlLinker.addLink("HSUM_CRED",HSUM_CRED);
	ctrlLinker.addLink("HSUM_VCRED",HSUM_VCRED);
	ctrlLinker.addLink("HSUM_RRO",HSUM_RRO);
	ctrlLinker.addLink("HSUM_KRK",HSUM_KRK);
	ctrlLinker.addLink("HSUM_KRK2",HSUM_KRK2);
	ctrlLinker.addLink("HSUM_KRK_ALL",HSUM_KRK_ALL);
	ctrlLinker.addLink("HSUM_2BNK",HSUM_2BNK);
	
	if (extPar.mode != "ADD")
	{
		//oVal.setCod(objDoc.getVar("HVAL"));
		//oVal.setKurs(objDoc.getVar("HVKURS"));	
		
   		objPodr.setCod(objDoc.getVar("HPODR"));   		
	}
	ctrlLinker.updateData(false);
	setValid(HBSUM, checkEsumm);
	
	checkEsumm();
	updateInkasSumm();
	updateRROSumm();
}

function checkEsumm()
{
//	HESUM.value = round(Number(HBSUM.value) + Number(HSUM_POL.value) + Number(HSUM_VPOK.value) - Number(HSUM_VSKLAD.value) - Number(HSUM_REAL.value), 5);
}

function listMenuInit()
{
	grid.AddMenuItem("MASS_FILL","Продублировать первое число во всем месяце (с обнулением сумм)");
	grid.AddMenuItem("MASS_FILL2","Продублировать текущее число во всем месяце (с обнулением сумм)");
	grid.AddMenuItem("MASS_FILL3","Продублировать текущую запись с текущей даты во всем месяце");

	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}

function _initGrid()
{
   	this.sDocSourceDir = rootDirectory() + "docs/" + objDoc.sDocLbl + "/";
	CreateTable(sTmpTbl,"RBRNK","FWID");
	var nId = (extPar.mode == "COPY") ? objDoc.nOldID : objDoc.getID();
	var sFLD = GetPatternIntersection("RBRNK","RBRNK");
	var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^RBRNK"
			   + " WHERE fid_doc = " + nId;
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");
	tbl = OpenTable("m","select * from " + sTmpTbl + " order by fdate, ftt desc");
	tbl.tie("cl_valut","x_cl_valut","fkod","fvald");
	
	if(extPar.mode=="COPY")
		objDoc.resetFnids(tbl, "RBRNK", objDoc);
	
	grid.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	grid.build();
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function onSelectRowMenu(sID)
{
	if (sID == "MASS_FILL" || sID == "MASS_FILL2" || sID == "MASS_FILL3")
	{
		// получаем след. порядковый номер
		var oSnap = getSnap("select max(fnom_str) as nom from " + sTmpTbl);
		var nNom = 1;
		if (oSnap && oSnap[0])
			nNom = Number(oSnap[0]) + 1;

		// запоминаем строки, которые есть в док-те
		var arrRows = new Array();
		strSQL = "";
		if (sID == "MASS_FILL")
			strSQL = "select * from " + sTmpTbl;
		else if (sID == "MASS_FILL2")
			strSQL = "select * from " + sTmpTbl 
				+ " WHERE FDATE = (SELEct max(Fdate) from " + sTmpTbl + " WHERE FWID = " + grid.getTable().getRowID() + ")";
		else if (sID == "MASS_FILL3")
			strSQL = "select * from " + sTmpTbl + " WHERE FWID = " + grid.getTable().getRowID();
		var tblRow = OpenTable(strSQL);
		if (!tblRow.IsEmpty())
			tblRow.MoveFirst();
		while (!tblRow.IsEOF())
		{
			arrRows[arrRows.length] = objDoc.getRow("RBRNK",Number(tblRow.getRowID()));
			tblRow.MoveNext();
		}

		if (arrRows.length == 0)
			return;

		var dat = new Date(arrRows[0].getVar("RDAT"));
		var dat1 = new Date(arrRows[0].getVar("RDAT"));
		dat = goDay(dat, 1);
		while (dat.getMonth() == dat1.getMonth()) 
		{
			// клонируем строки по всему док-ты
			for (var i = 0; i < arrRows.length; i++)
			{
				var oDocRow = objDoc.copyRow("RBRNK", arrRows[i].getID());			

				oDocRow.setVar("RDAT", dat.getVarDate());
				oDocRow.setVar("RSUM_POL",0)
				oDocRow.setVar("RSUM_VSKLAD",0)
				oDocRow.setVar("RSUM_VPOK",0)
				oDocRow.setVar("RSUM_REAL",0)
				oDocRow.setVar("RSUM_DISCOUNT",0)
				oDocRow.setVar("RSUM_VITORG",0)
				oDocRow.setVar("RSUM_V2POK",0)
				oDocRow.setVar("RSUM_CRED",0)
				oDocRow.setVar("RSUM_VCRED",0)
				oDocRow.setVar("RSUM_RRO",0)
				oDocRow.setVar("RSUM_KRK",0)
				oDocRow.setVar("RSUM_KRK2",0)
				oDocRow.setVar("RSUM_2BNK",0)
				oDocRow.setVar("RNOM",nNom++)
			
				objDoc.appendRow("RBRNK",oDocRow)
				obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			}

			dat = goDay(dat, 1);
		}

		grid.getTable().requery();
		grid.refresh();

	}
	else if(sID == "DEL")
	{
		objDoc.deleteRow("RBRNK",
				Number(grid.getTable().getRowID()));
		updateTotalSumm();
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else if(sID == "__XDEL")
	{
		var delRowCount = DataSource().getSelectedCount();
		if (delRowCount <= 0)
			return;
		var selIds = DataSource().getSelectedIDs();
		var sCapt = ru("Удаление записей", "Видалення записів");
		var sMsg = ru("Подтвердите удаление записей", "Підтвердіть вилучення записів")+" (" + DataSource().getSelectedCount() + ").";
		if("c"==msgBox("c-", sMsg, sCapt))
			return;
		for (var nRow = 0; nRow < selIds.length; nRow++)
		{
			objDoc.deleteRow("RBRNK", Number(selIds[nRow]));
		} 		

		updateTotalSumm();
		ExecuteSQL("DELETE FROM "+ sTmpTbl +" WHERE "+ grid.sqlSelected());			
		grid.clearSelected();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = objDoc.createRow("RBRNK");
			var oSnap = getSnap("select max(fnom_str) as nom from " + sTmpTbl);
			var nNom = 1;
			if (oSnap && oSnap[0])
				nNom = Number(oSnap[0]) + 1;
			oDocRow.setVar("RNOM",nNom)
				
		}
		else if(sID == "EDIT")
		{
			oDocRow = objDoc.getRow("RBRNK",Number(grid.getTable().getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = objDoc.copyRow("RBRNK", 
						Number(grid.getTable().getRowID()));			
		}
		
		var bOK = oDocRow.edit(sID)
		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}
		
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				objDoc.appendRow("RBRNK",oDocRow)

			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);		
			
			if (oDocRow.getVar("RSUM_2BNK") != 0)
			{
				ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_2BNK = " + sqlTo(oDocRow.getVar("RSUM_2BNK"))
			  		+ " WHERE FDATE = " + sqlTo(oDocRow.getVar("RDAT")));
			  		
			  	var tblUpd = OpenTable("select * from " + sTmpTbl + " WHERE FDATE = " + sqlTo(oDocRow.getVar("RDAT")));
			  	for (tblUpd.MoveFirst(); !tblUpd.IsEOF(); tblUpd.MoveNext())
			  	{
			  		var oUpdRow = objDoc.getRow("RBRNK",Number(tblUpd.getRowID()));
			  		oUpdRow.setVar("RSUM_2BNK", oDocRow.getVar("RSUM_2BNK"));
			  	}
			}
			UpdateFttSumm();
			updateTotalSumm();
			  	
			grid.getTable().requery();
			grid.refresh();
		}
	}
}

function saveRows()
{
	UpdateFttSumm();
	ExecuteSQL("DELETE FROM ^RBRNK WHERE fid_doc=" + sqlTo(objDoc.getVar("ID")));
	var sFLD = GetPatternIntersection("RBRNK","RBRNK");
	ExecuteSQL("INSERT INTO ^RBRNK(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl);
}

function onSave()
{
	updateTotalSumm();
	
	ctrlLinker.updateData(true);
	objDoc.setVar("HPODR", objPodr.getCod());

	saveRows();
	tbl.close();
}

function UpdateFttSumm()
{
	var strVitorg = "(SELECT SUM(FSUM_VITORG) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_VITORG = " + strVitorg
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");

	var strV2POK = "(SELECT SUM(FSUM_V2POK) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_V2POK = " + strV2POK
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");

	var strCRED = "(SELECT SUM(FSUM_CRED) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_CRED = " + strCRED
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");

	var strCRED = "(SELECT SUM(FSUM_VCRED) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_VCRED = " + strCRED
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");

	var strKRK = "(SELECT SUM(FSUM_KRK) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_KRK = " + strKRK
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");

	var strKRK2 = "(SELECT SUM(FSUM_KRK2) FROM " + sTmpTbl + " b "
		+ " WHERE " + sTmpTbl + ".fdate=b.fdate and b.FTT=0)" 
	ExecuteSQL("UPDATE " + sTmpTbl + " set FSUM_KRK2 = " + strKRK2
	  	+ " WHERE " + sTmpTbl + ".FTT = 1");
}

function updateTotalSumm()
{
	var strSnap = "SELECT SUM(FSUM_POL), SUM(FSUM_VSKLAD), SUM(FSUM_VPOK), SUM(FSUM_REAL), SUM(FSUM_DISCOUNT)"
		+ ", SUM(FSUM_VITORG), SUM(FSUM_V2POK), SUM(FSUM_CRED), SUM(FSUM_RRO), SUM(FSUM_KRK), SUM(FSUM_KRK2), SUM(FSUM_2BNK), SUM(FSUM_VCRED)"
		+ " FROM " + sTmpTbl + " WHERE ftt = 1 and fid_doc=" + sqlTo(objDoc.getVar("ID"));
	var oSnap = getSnap(strSnap);
	if (oSnap != null)
	{
		HSUM_POL.value = Number(oSnap[0]);
		HSUM_VSKLAD.value = Number(oSnap[1]);
		HSUM_VPOK.value = Number(oSnap[2]);
		HSUM_REAL.value = Number(oSnap[3]);
		HSUM_DISCOUNT.value = Number(oSnap[4]);
		HSUM_VITORG.value = Number(oSnap[5]);
		HSUM_V2POK.value = Number(oSnap[6]);
		HSUM_CRED.value = Number(oSnap[7]);
		HSUM_RRO.value = Number(oSnap[8]);
		HSUM_KRK.value = Number(oSnap[9]);
		HSUM_KRK2.value = Number(oSnap[10]);
		HSUM_KRK_ALL.value = Number(oSnap[9]) + Number(oSnap[10]);
		HSUM_2BNK.value = Number(oSnap[11]);
		HSUM_VCRED.value = Number(oSnap[12]);
	}
	
	updateInkasSumm();
	updateRROSumm();
}

function updateInkasSumm()
{
	INKAS.value = HSUM_VITORG.value - HSUM_V2POK.value - HSUM_CRED.value + Number(HSUM_VCRED.value);
}

function updateRROSumm()
{
	var tbl = OpenTable("SELECT FCAS_COD, "
		+ " sum(FSUM_VITORG) FSUM_VITORG_S, sum(FSUM_V2POK) as FSUM_V2POK_S, sum(FSUM_CRED) as FSUM_CRED_S, sum(FSUM_VCRED) as FSUM_VCRED_S, sum(FSUM_KRK) as FSUM_KRK_S, sum(FSUM_KRK2) as FSUM_KRK2_S "
		+ " FROM " + sTmpTbl + " WHERE ftt = 0 and fid_doc=" + sqlTo(objDoc.getVar("ID"))
		+ " GROUP BY FCAS_COD");

	var nIndex = 1;
	if (!tbl.IsEmpty())
		tbl.MoveFirst();
	while (!tbl.IsEOF())
	{
/*			cell("FSUM_VITORG_S", "Выторг (Обіг А)", 11);
			cell("FSUM_V2POK_S", "Возврат д. покупат.", 11);
			cell("=^FSUM_VITORG_S - ^FSUM_V2POK_S - ^FSUM_CRED_S + ^FSUM_VCRED_S", "Инкасация (Гроші)", 11);
			cell("FSUM_CRED_S", "Кредитные карточки", 11);
			cell("FSUM_KRK_S", "Показ. термин. по кр/к Приватбанк", 11);
			cell("FSUM_KRK2_S", "Показ. термин. по кр/к Райффайзенбанк", 11);
	*/		
		if (nIndex == 1)
		{
			RRO1_TXT.text = "РРО 1:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO1_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO1_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO1_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO1_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO1_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO1_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 2)
		{		
			RRO2_TXT.text = "РРО 2:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO2_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO2_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO2_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO2_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO2_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO2_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 3)
		{		
			RRO3_TXT.text = "РРО 3:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO3_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO3_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO3_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO3_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO3_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO3_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 4)
		{		
			RRO4_TXT.text = "РРО 4:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO4_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO4_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO4_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO4_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO4_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO4_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 5)
		{		
			RRO5_TXT.text = "РРО 5:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO5_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO5_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO5_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO5_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO5_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO5_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 6)
		{		
			RRO6_TXT.text = "РРО 6:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO6_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO6_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO6_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO6_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO6_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO6_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		else if (nIndex == 7)
		{		
			RRO7_TXT.text = "РРО 7:" + tfcl("TXT", objDoc.getPar("_brnk_codmag"), Number(tbl.getValue("FCAS_COD")));
			RRO7_VITORG_S.value = tbl.getValue("FSUM_VITORG_S");
			RRO7_V2POK_S.value = tbl.getValue("FSUM_V2POK_S");
			RRO7_MONEY.value = Number(tbl.getValue("FSUM_VITORG_S")) - 
				Number(tbl.getValue("FSUM_V2POK_S")) -
				Number(tbl.getValue("FSUM_CRED_S")) +
				Number(tbl.getValue("FSUM_VCRED_S"));
			RRO7_CRED_S.value = tbl.getValue("FSUM_CRED_S");
			RRO7_KRK_S.value = tbl.getValue("FSUM_KRK_S");
			RRO7_KRK2_S.value = tbl.getValue("FSUM_KRK2_S");
		}
		
		nIndex++;
		tbl.MoveNext();
	}
}

function onEscape()
{
	tbl.close();
}

include("sys\\DpBaseDlg.js");