include("Objects\\DpVal.js");
include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");



var edmode, t;
var cod_plat;
var oVal, oVal_spr, oOrg, oSc;
var objDoc = extPar.doc; 
var ctrlLinker = null;
var oCntr;
var ndsproc = 0;

function Load() 
{ 
  	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
   
   	ctrlLinker = new DpCtrlLinker(objDoc);
   	HSUM.mask      = MASK_SUM;
   	HSUMI.mask  = MASK_SUM;
   	
   	ndsproc = Number(objDoc.getPar("__ndsproc"));
   	
   	var texthsum = String(objDoc.getPar("texthsum")).trim();
   	if (texthsum)
   		TEXT_HSUM.text = texthsum;
   	
   	var texthsumi = String(objDoc.getPar("texthsumi")).trim();
   	if (texthsumi)
   			TEXT_HSUMI.text = texthsumi;
   	
   	if (isNaN(ndsproc))
   		ndsproc = 0;
   	if(!objDoc.getPar("showSc"))
		GroupSC.setVisible(false);
   	
   	cod_plat = objDoc.getPar("__nsan"); 
   	oOrg = new DpCl("0");
   	oOrg.setClcl(cod_plat);     
   	//oOrg.linkS Ctrl(HORG, HORG_TXT);
   	oOrg.linkSmartCtrl(HORG);
   	oOrg.setContAssist();
		
	oSc = new DpSc("c0utxyz");
	oSc.linkCtrl(HSC, HSU, HST, HCL1, HCL2, HCL3);
	
	oVal = new DpVal();
	oVal.linkCtrl(HVAL);
   	oVal.linkCtrlKurs(HVKURS);
   	oVal_spr = new DpVal();
   	oVal_spr.linkCtrl(HVALI);
   	
   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT); 
 	ctrlLinker.addClLink("HORG",oOrg);   
 	ctrlLinker.addLink("HSUM",HSUM); 
 	ctrlLinker.addLink("HSUMI",HSUMI);
 	//objDoc.addLink("HVAL",HVAL); 
 	//objDoc.addLink("HVALI",HVALI);   
 	ctrlLinker.addLink("HVKURS",HVKURS); 
 	ctrlLinker.addLink("HBDAT",HBDAT);      
 	ctrlLinker.addLink("HOPLDAT",HOPLDAT);      
 	ctrlLinker.addLink("HEDAT",HEDAT);      
 	ctrlLinker.addLink("HCTLDAT",HCTLDAT);      
 	ctrlLinker.addLink("HREM",HREM);
/*
 	ctrlLinker.addLink("HSC",HSC);
 	ctrlLinker.addLink("HSU",HSU);
 	ctrlLinker.addLink("HST",HST);     
 	ctrlLinker.addLink("HCL1",HCL1);     
 	ctrlLinker.addLink("HCL2",HCL2);     
 	ctrlLinker.addLink("HCL3",HCL3);  
*/
	ctrlLinker.addScLink("HSC","HSU","HST","HCL1","HCL2","HCL3",oSc);
 	ctrlLinker.addClLink("HVALI",oVal_spr);      
   
   	ctrlLinker.updateData(false);
   
   
   	
   	if (extPar.mode != "ADD")
   	{
   		oVal.setCod(objDoc.getVar("HVAL"));
   		oVal.setKurs(objDoc.getVar("HVKURS"));
   		//oVal_spr.setCod(objDoc.getVar("HVALI"));   
   		oOrg.setCod(objDoc.getVar("HORG"));
   		
   		oSc.set(objDoc.getVar("HSC"),
   				objDoc.getVar("HSU"),
   				objDoc.getVar("HST"),
   				objDoc.getVar("HCL1"),
   				objDoc.getVar("HCL2"),
   				objDoc.getVar("HCL3"));	
   		
   	}
   	else
   	{
   		objDoc.setVar("HAN", cod_plat);
   	}
   	if (extPar.mode == "COPY")
   	    setFocus(HNOM);
   	
   	setValid(HDAT, mHDAT_Valid); 
   	
   	if (ndsproc != 0)
   	{
   		Disable(HSUMI);
   		setValid(HSUM, calcNDS);
   		calcNDS();
   	}
}

function calcNDS()
{
	HSUMI.value = round(Number(HSUM.value)*ndsproc/(100+ndsproc),2);
}

var escape;


function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());
	//objDoc.setVar("HVALI",oVal_spr.getCod());   		
   	
}

function mHDAT_Valid() {
   return differ(HDAT.value, d00);
}
include("sys\\DpBaseDlg.js");
