﻿function docMenuInit()
{
	if(!this.dataSrc.getTable().isEmpty())
	{
		this.dataSrc.AddMenuItem("NN", "Отримані податкові накладні|Полученные налоговые накладные");
		this.dataSrc.AddMenuItem("DEBET2XSD",
			"Подготовить к выгрузке корректировок в xml формат для налоговой|"+
			"Подготовить к выгрузке корректировок в xml формат для налоговой");
	}
}

function docMenuHandler(nID)
{		
	var tbl = this.dataSrc.getTable();
	var ds1 = this.dataSrc;		
	
	if (nID == "NN")
	{
		extPar.forg = tbl.getValue("FORG");
		extPar.fdat = tbl.getValue("FDOC_DAT");
	}
	else if(nID=="DEBET2XSD")
	{
		strName = "NDS_CORRECT";
		DropTable(strName);
		
		strSQL = "CREATE TABLE " + strName
				+ " ( FNDS1 "+SqlType("CURRENCY")
				+ " , FNDS2 "+SqlType("CURRENCY")
				+ " , FDATE "+SqlType("DATE")
				+ " , FNUM "+SqlType("TEXT", 100)
				+ " , FINDNUM "+SqlType("TEXT", 20)
				+ " , FNAZV "+SqlType("TEXT", 250)
				+ " , FTXT "+SqlType("TEXT", 250)
				+ " , FDOC_DAT "+SqlType("DATE")
				+ " , FDOC_NUM "+SqlType("TEXT", 100)
				+ " , FWID " + SqlType("COUNTER") + ")";
		ExecuteSQL(strSQL); 			
	
		var tbl_Sch_zag = OpenTable("s", "SELECT * FROM ^HBS WHERE " + grid.sqlSelected());
		for (tbl_Sch_zag.MoveFirst(); !tbl_Sch_zag.IsEOF(); tbl_Sch_zag.MoveNext())
		{
			var sDoc = toScrObj(tbl_Sch_zag.getValue("fdoc"));
			var nNop = toScrObj(tbl_Sch_zag.getValue("fnop"));
			oDoc = new DpDoc(sDoc, nNop);
			if (oDoc.loadByID(tbl_Sch_zag.getValue("fwid")))
			{
				var m = new Object()
		
				m.FNAZV = tcl("ORG", "TXT", tbl_Sch_zag.getValue("FORG"));
				m.FINDNUM = tcl("ORG", "CODNDS", tbl_Sch_zag.getValue("FORG"));
				if (Number(m.FINDNUM) == 0)
					m.FINDNUM = "X";			
				m.FDATE = oDoc.getExt("DOCDAT");
				m.FNUM = oDoc.getExt("DOCNUM");
				m.FDOC_NUM = tbl_Sch_zag.getValue("FDOC_NUM") //+ "/" + oDoc.getExt("DOCNUM");
				m.FDOC_DAT = tbl_Sch_zag.getValue("FDOC_DAT");
				m.FTXT = "те саме";
				m.FNDS1 = 0;
				m.FNDS2 = -1 * round(tbl_Sch_zag.getValue("Fsum1"), 2);
				
				updateTable(strName, m, true);
			}
		}
		alert(ru("Расчет окончен.", "Розрахунок завершено."))
	}
}

function nomDogToXML(idDog)
{
	var snap = getSnap("SELECT Fdog_num FROM ^contract WHERE fwid="+sqlTo(idDog))
	if(snap!=null)
		return snap[0];
	else
		return null;
}

function MergeDateBS(strWhere, dat, org)
{
	var fwid = 0;
	var tblDocs = OpenTable("s", "SELECT fwid, fdoc, fnop FROM ^HBS " 
									+" WHERE " + strWhere 
									+" AND Fdoc_dat = " + sqlTo(dat)
									+" AND Forg = " + sqlTo(org)
									);
	if (tblDocs.IsEOF())
		return;

	var nop = 203;
	
	var oSnap = getSnap("SELECT fwid FROM ^HBS " 
		+" WHERE FNOP = " + nop 
		+" AND Fdoc_dat = " + sqlTo(dat)
		+" AND Forg = " + sqlTo(org)
		);
	if (oSnap != null)
	{
		new_fiddoc = oSnap[0];
		var newDoc = new DpDoc("BS", nop);		
		newDoc.loadByID(new_fiddoc);			

		newDoc.setVar("HSUM", 0);
		newDoc.setVar("HSUMI", 0);
		newDoc.setExt("USUM", 0);
		newDoc.setExt("SUM1", 0);
		newDoc.setExt("SUM2", 0);
		newDoc.setExt("SUM3", 0);
	}
	else
	{
		new_fiddoc = Number(tblDocs.getValue("FWID"));
		var newDoc = new DpDoc("BS", nop);		
		newDoc.loadByID(new_fiddoc);			
		newDoc.jDoc = newDoc.jDoc.clone();
		var eval = new DpEval();
		newDoc.jDoc.setEvaluator(eval);			
		newDoc.setVar("HOP", nop);
		newDoc.setVar("HOUTID", 0);
		newDoc.setVar("HORG", org);
	}

	var oDocRow;
	for(;!tblDocs.IsEOF();tblDocs.MoveNext())
	{
		fwid = Number(tblDocs.getValue("FWID"));
			
		if(Number(fwid) == Number(new_fiddoc))
			continue;

		var oldDoc = new DpDoc("BS", tblDocs.getValue("FNOP"));
		oldDoc.loadByID(fwid);			
		
		newDoc.setVar("HSUM", newDoc.getVar("HSUM") + oldDoc.getVar("HSUM"));
		newDoc.setVar("HSUMI", newDoc.getVar("HSUMI") + oldDoc.getVar("HSUMI"));
		newDoc.setExt("USUM", Number(newDoc.getExt("USUM")) + Number(oldDoc.getExt("USUM")));
		newDoc.setExt("SUM1", Number(newDoc.getExt("SUM1")) + Number(oldDoc.getExt("SUM1")));
		newDoc.setExt("SUM2", Number(newDoc.getExt("SUM2")) + Number(oldDoc.getExt("SUM2")));
		newDoc.setExt("SUM3", Number(newDoc.getExt("SUM3")) + Number(oldDoc.getExt("SUM3")));
	}			
	newDoc.save(true, "EDIT");
	newDoc.saveExtToDB();

	//Точка видалення проводок
	ExecuteSQL("DELETE FROM ^schet"
		 + " WHERE FDOC <> '_R' AND FID_DOC =" + Number(newDoc.getID()));
	
}

function MergeDateBS2(strWhere, dat, org, num)
{
	var fwid = 0;
	var tblDocs = OpenTable("s", "SELECT fwid, fdoc, fnop FROM ^HBS " 
									+" WHERE " + strWhere 
									+" AND Fdoc_dat = " + sqlTo(dat)
									);
	if (tblDocs.IsEOF())
		return;

	var nop = 210;	
	var oSnap = getSnap("SELECT fwid FROM ^HBS " 
		+" WHERE FNOP = " + nop 
		+" AND Fdoc_dat = " + sqlTo(dat)
		+" AND Fdoc_num = " + sqlTo(num)
		);
	if (oSnap != null)
	{
		new_fiddoc = oSnap[0];
		var newDoc = new DpDoc("BS", nop);		
		newDoc.loadByID(new_fiddoc);			

		newDoc.setVar("HSUM", 0);
		newDoc.setVar("HSUMI", 0);
		newDoc.setExt("USUM", 0);
		newDoc.setExt("SUM1", 0);
		newDoc.setExt("SUM2", 0);
		newDoc.setExt("SUM3", 0);
	}
	else
	{
		new_fiddoc = Number(tblDocs.getValue("FWID"));
		var newDoc = new DpDoc("BS", nop);		
		newDoc.loadByID(new_fiddoc);			
		newDoc.jDoc = newDoc.jDoc.clone();
		var eval = new DpEval();
		newDoc.jDoc.setEvaluator(eval);			
		newDoc.setVar("HOP", nop);
		newDoc.setVar("HOUTID", 0);
		newDoc.setVar("HORG", org);
	}

	var oDocRow;
	for(;!tblDocs.IsEOF();tblDocs.MoveNext())
	{
		fwid = Number(tblDocs.getValue("FWID"));
			
		if(Number(fwid) == Number(new_fiddoc))
			continue;

		var oldDoc = new DpDoc("BS", tblDocs.getValue("FNOP"));
		oldDoc.loadByID(fwid);			
		
		newDoc.setVar("HSUM", newDoc.getVar("HSUM") + oldDoc.getVar("HSUM"));
		newDoc.setVar("HSUMI", newDoc.getVar("HSUMI") + oldDoc.getVar("HSUMI"));
		newDoc.setExt("USUM", Number(newDoc.getExt("USUM")) + Number(oldDoc.getExt("USUM")));
		newDoc.setExt("SUM1", Number(newDoc.getExt("SUM1")) + Number(oldDoc.getExt("SUM1")));
		newDoc.setExt("SUM2", Number(newDoc.getExt("SUM2")) + Number(oldDoc.getExt("SUM2")));
		newDoc.setExt("SUM3", Number(newDoc.getExt("SUM3")) + Number(oldDoc.getExt("SUM3")));
	}			
	newDoc.save(true, "EDIT");
	newDoc.saveExtToDB();

	//Точка видалення проводок
	ExecuteSQL("DELETE FROM ^schet"
		 + " WHERE FDOC <> '_R' AND FID_DOC =" + Number(newDoc.getID()));
}