include("servis/zrp.js");
include("Objects/dpCalendar.js");
include("prik/calculate/r_mnvk.js");

var objDoc = extPar.doc; 
var ctrlLinker = null;
var strTempTableName = getTmpTableName("", true);
var strSubRowsTableName = getTmpTableName("", true);
var tblRow = null;
var oldDat = d00obj;
var isFirstEdit = true;
var nID;

function Load()
{
	//для коректной взаимоработы двух подсистем делаем проверку
	if(getSystem()!="ZRP" && getSystem()!="CDR")
	{
		alert(ru("Для работы с этим приказом перейдите в подсистему учета кадров либо з/п!",
				"Для роботи з цим наказом перейдіть в підсистему обліку кадрів або з/п!"),ICON_WARNING)
		return false;
	}
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
   	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM", HNUMBER);
	ctrlLinker.addLink("HDAT", HBDAT);
	ctrlLinker.updateData(false);
	oldDat = new Date(HBDAT.value);
	HBDAT_valid();
   	this.sDocSourceDir = rootDirectory() + "docs//" + objDoc.sDocLbl + "//";
	this.initGrid = initGrid;
	this.initGrid(grRows, "grOtp.xml");
	this.listMenuInit = listMenuInit;
	this.listMenuHandler = listMenuHandler;
	setValid(HBDAT, HBDAT_valid);
	HNUMBER.mask = strRepl("&", 15);
}

function onSave()
{
	//из подсистемы кадров в случае редактирования приказа с существующими дочерними приказами 
	//и включенном режиме "сохранения через контекстное меню" родительский приказ не редактируем
	if(getSystem()=="CDR" && extPar.mode=="EDIT" && getPar("SAVEOTPINZRP")=="menu" && isExistsDaughterPrk(objDoc.getVar("ID")))
	{
		var kol = getZrpPrkCount(objDoc.getVar("ID"));
		alert(ru("Приказ сохранен не будет, т.к. данный приказ имеет дочерние приказы ("+kol+" шт.) и \n"
					+"в параметре '"+getParItemPath("SAVEOTPINZRP")+"'\nвыбран режим 'из контекстного меню'"
					+"\nИзменения для таких случаев доступны лишь из подсистемы учета з/п!",
				"Наказ збережений не буде, тому що даний наказ має дочірні накази ("+kol+" шт.) та \n"
					+"в параметрі '"+getParItemPath("SAVEOTPINZRP")+"'\nобрано режим 'з контекстного меню'"
					+"\nЗміни для таких випадків доступні лише з підсистеми обліку з/п!"));
		return false;
	}
	ctrlLinker.updateData(true);
	saveRows();
	//в з/п сохраняем только при наличии соответсвующего параметра, также из подсистемы з/п при наличии кадрового режима "сохранения по контекстному меню"
	if(getPar("SAVEOTPINZRP")=="save" || (getSystem()=="ZRP" && getPar("SAVEOTPINZRP")=="menu"))
		saveOptInZrp(nID);
	if(tblRow)
		tblRow.Close();
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^prk_otp WHERE Fwid_prk=" + sqlTo(objDoc.getVar("ID")));
	var sFLD = GetPatternIntersection("PRK_OTP","PRK_OTP");
	ExecuteSQL("INSERT INTO ^prk_otp(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + strTempTableName);
	ExecuteSQL("DELETE FROM ^otp_type WHERE Fid_doc IN (select Fwid from ^prk_otp where Fwid_prk=" + sqlTo(objDoc.getVar("ID"))+")");
	sFLD = GetPatternIntersection("otp_type","otp_type");
	ExecuteSQL("INSERT INTO ^otp_type(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + strSubRowsTableName);
}

function onEscape()
{
	if(tblRow)
		tblRow.Close();
}

function initGrid(gridCtrl, strFileName)
{
	nID = (extPar.mode == "COPY")?objDoc.nOldID : objDoc.getID();

	CreateTable(strTempTableName,"PRK_OTP","*");
	var sFLD = GetPatternIntersection("PRK_OTP","PRK_OTP");
	var strSQL = "INSERT INTO " + strTempTableName + "(" + sFLD + ")"
			   + " SELECT " + java.lang.String(sFLD).trim().replaceAll("FTXT", "'' as FTXT")
			   + " FROM ^PRK_OTP"
			   + " WHERE Fwid_prk = " + sqlTo(nID);
	ExecuteSQL(strSQL);

	ExecuteSQL("UPDATE " + strTempTableName + " SET FTXT = (SELECT MAX(b.ftxt) FROM ^clrelclcl a left join ^cl b on a.fwid_cl=b.fwid where a.fcl=" 
			+ getPar("CODPERS") + " and a.fcod=" + strTempTableName + ".fcod )");
	
	if(extPar.mode != "ADD")
	{
		CreateTable(strSubRowsTableName,"OTP_TYPE","*");
		var sFLD = GetPatternIntersection("OTP_TYPE","OTP_TYPE");
		var strSQL = "INSERT INTO " + strSubRowsTableName + "(" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM ^OTP_TYPE"
				   + " WHERE Fid_doc in (select Fwid from "+strTempTableName+")";
		ExecuteSQL(strSQL);
		isFirstEdit = false;
	}
	
	tblRow = OpenTable("select * from "+strTempTableName + " ORDER BY FTXT");
	//tblRow.tie("stru_dol", "d", "fwid", "fwid_dol");
	clTie(tblRow, "pers", "=" + getPar("CODPERS") + ", Fcod", "cl_pers");
	clTie(tblRow, "otp", "=" + getPar("CODOTP") + ", Ftype", "cl_otp");
	
	gridCtrl.setXMLDir(this.sDocSourceDir);
	gridCtrl.setXMLFile(strFileName);
	gridCtrl.setTable(tblRow);
	gridCtrl.setData("prk_otp");
	gridCtrl.build();
	gridCtrl.loadMenuHandler(this,"listMenuInit");	
	gridCtrl.selectMenuHandler(this, "listMenuHandler");
}

function listMenuInit(grid)
{
	var tbl = grid.getTable();
	grid.AddMenuItem("ADD","Додати|Добавить");
	if (!tbl.isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагувати|Редактировать");
		grid.AddMenuItem("COPY","Копіювати|Копировать");
		grid.AddMenuItem("DEL","Вилучити|Удалить");
	}
}

function listMenuHandler(sID, grid)
{
	if("DEL" ==sID)
	{
		var otpID = Number(grid.getTable().getRowID());
		objDoc.deleteRow("prk_otp", otpID);
		ExecuteSQL("delete from "+strSubRowsTableName+" where Fid_doc="+otpID)
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{
		var oDocRow;
		switch(sID)
		{
			case "ADD":
				oDocRow = objDoc.createRow("prk_otp");
			break;
			case "EDIT":
				oDocRow = objDoc.getRow("prk_otp", Number(grid.getTable().getRowID()));
			break;
			case "COPY":
				oDocRow = objDoc.copyRow("prk_otp", Number(grid.getTable().getRowID()));
			break;
			default:
				return false;
		}
		var par = new Object();
		if(extPar.prk_fwid_cl)
			par.prk_fwid_cl = extPar.prk_fwid_cl;
		par.sDocSourceDir = this.sDocSourceDir;
		par.strSubRowsTableName = strSubRowsTableName;
		par.strTempTableName = strTempTableName;
		par.isFirstEdit = isFirstEdit;
		var bOK = oDocRow.edit(sID, par);
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				objDoc.appendRow("prk_otp", oDocRow);
			obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, strTempTableName);
			grid.getTable().requery();
			grid.refresh();
		}
		isFirstEdit = par.isFirstEdit;
	}
}

function HBDAT_valid()
{
	objDoc.setVar("HDAT",HBDAT.value);//чтобы коректно работала валидность на дату принятия
	var newDat = new Date(HBDAT.value);
	if(differ(oldDat,newDat)!=0)
	{
		oldDat = newDat;
		var t = OpenTable("select * from "+strTempTableName);
		for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
		{
			if(differ(new Date(HBDAT.value),new Date(t.getValue("Fbdat")))>0)
			{
				var msg = UR("Дата початку відпустки таб.№ "+t.getValue("Fcod")+" менша за дату документа!"
							+ "|Дата начала отпуска таб.№ "+t.getValue("Fcod")+" меньше чем дата документа!");
				cnfrm = msgBox("&*^ki", msg);
				if("*" == cnfrm)
				{
					oDocRow = objDoc.getRow("prk_otp", t.getValue("Fwid"));
					var bOK = oDocRow.edit("EDIT");
					if (bOK)
					{
						obj2DB(oDocRow.getID(), oDocRow.jDocRow, null, strTempTableName);
						grRows.getTable().requery();
						grRows.refresh();
					}
				}
				else if("i" == cnfrm)
				{
					break;
				}
			}
		}
		t.close();
		return true;
	}
	return true;
}

function getDolTxt(fwid_cl,bdat,edat)
{
	if(fwid_cl)
	{
		var snap = getSnap("select Ftxtdol from ^full_pers where Fwid_cl="+fwid_cl+" and Fbdat<="+sqlTo(edat)+" and Fedat>="+sqlTo(bdat),true)
		if(snap && snap[0] && fwid_cl)
			return snap[0];
		else
			return "???";
	}
	else
		return "???";
}

function getTypeTblName()
{
	return strSubRowsTableName;
}
include("sys\\DpBaseDlg.js");