include("Objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");
include("servis/cdr.js");
include("prik/DpPrik.js")
var Fdoc = extPar.Fdoc;
var gd;

this.isHistory = false;	
function docSrc()
{
	gd = new Object;	
	if (typeof(DOC) != "undefined" && typeOf(DOC) == "DpTextEx")
	{
		gd.dat1 = DATB.value;
		gd.dat2 = DATE.value;
	}
	else
	{
		gd = new DpGetDat("dD");	
		if (gd.escape)
			return false;
		
	}
	this.qrySet("From","^cdr_prk",
				"Where","Fdoc="+sqlTo(Fdoc)+" AND Fdoc_dat>="+sqlTo(gd.dat1)+" AND Fdoc_dat<="+sqlTo(gd.dat2),
				"Order","Fdoc_dat,Fdoc_num");
	this.showDocView = showDocView;
	list.AfterLoad = this.showDocView;
	if(this.docList.buildQuery())
	{
		this.docList.subTie();			
		return true;
	}
}

function docTitle()
{
	if(this.docList && gd)
		return this.docList.getCaption()+format(" (dd.mm.yy-",gd.dat1)+format("dd.mm.yy)",gd.dat2);
}

function docMenuInit()
{
	if(this.tbl.isEmpty())
		return false;
	if(getSystem()=="ZRP")
		this.dataSrc.AddMenuItem("SHOW_PERS", "Показати дочірні накази|Показать дочерние приказы");
	else
		this.dataSrc.AddMenuItem("SHOW_PERS", "Показати співробітників по наказу|Показать сотрудников по приказу");
	if(getPar("SAVEOTPINZRP")!="no")
	{
		if(getAccess("RESAVE_OTP")!="R")
			this.dataSrc.AddMenuItem("SAVEINZRP","Зберегти в обліку заробітньої платні|Сохранить в учете заработной платы");
		this.dataSrc.AddMenuItem("SETNVK","Проставити ознаку наявності такалендарні дні неявок у табелі|Проставить признак наличия и календарные дни неявок в табеле");
	}
	this.dataSrc.AddMenuItem("", "");
}

function docMenuHandler(nID)
{
	switch(nID)
	{
		case "SHOW_PERS":
			this.showDocView();
		break;
		case "SAVEINZRP":
			//для коректной взаимоработы двух подсистем делаем проверку
			if(getSystem()!="ZRP" && getSystem()!="CDR")
			{
				alert(ru("Для работы с этим приказом перейдите в подсистему учета з/п либо кадров!",
						"Для роботи з цим наказом перейдіть в підсистему обліку з/п або кадрів!"),ICON_WARNING)
				return false;
			}
			var snap = getSnap("select count(*) from ^prk_all where Fwid_prik "+grid.sqlSelected(true));
			if(getSystem()=="CDR" && getPar("SAVEOTPINZRP")=="menu" && snap && snap[0]>0)
			{
				alert(ru("У отмеченных приказов существуют дочерние приказы ("+snap[0]+" шт.) и \n"
							+"в параметре '"+getParItemPath("SAVEOTPINZRP")+"'\nвыбран режим 'из контекстного меню'"
							+"\nЭто действие для таких приказов доступно лишь из подсистемы учета з/п!",
						"У відмічених наказів існують дочірні накази ("+snap[0]+" шт.) та \n"
							+"в параметрі '"+getParItemPath("SAVEOTPINZRP")+"'\nобрано режим 'з контекстного меню'"
							+"\nЦя дія для таких наказів доступна лише з підсистеми обліку з/п!"));
				return false;
			}
			var msg = ru("У отмеченных приказов существуют дочерние приказы ("+snap[0]+" шт.)\nВы уверены, что хотите продолжить?",
						"У відмічених наказів існують дочірні накази ("+snap[0]+" шт.)\nВи впевнені, що бажаєте продовжити?");
			if(snap && snap[0]>0 && !confirm(msg))
				return false;
			var t = OpenTable("SELECT * FROM ^cdr_prk WHERE "+DataSource().sqlSelected());
			setProgressRange(1, t.rowCount);
			for(; !t.IsEOF(); t.MoveNext())
			{
				setProgressPos(t.bookmark, ru("Пересохранение приказов: ","Перезбереження наказів: ")+t.bookmark+"/"+t.rowCount);
				saveOptInZrp(t.getValue("Fwid"));
			}
			setProgressPos(0);
			t.close();
			grid.clearSelected();
    		list.tbl.requery();
    		grid.RefreshGrid();
		break;
		case "SETNVK":
			var FileName = "^PRK_ALL";
        	include("prik\\calculate\\r_mnvk.js");
            var kodnvk=0;
            var oSnap = getSnap("select Fkod_nvk from ^cl_nvk where Frblnall='*'")
            if (oSnap!=null)
            	kodnvk = Number(oSnap[0])
            if (kodnvk==0)
            {
            	alert(ru("Не найдено ниодной записи, относящейся к отпускным в справочнике неявок для табелей!",
            			"Не знайдено жодного запису, який би відносився до відпусток в довіднику нез'явлень для табелів!"));
            	return;
            }
            
    		strSQL = "SELECT * FROM "+FileName+" WHERE Fwid_prik "+DataSource().sqlSelected(true);
    		masot = OpenTable(strSQL);
    		while (!masot.IsEOF())
       		{
          	    WAIT(masot.bookmark+"/"+masot.rowCount);
          	    var oldnvk = kodnvk;
				var snap = getSnap("select Fz13 from ^cl_prik where Fvid="+masot.getValue("Fvid_prk"));
				if(snap && snap[0]>0)
					kodnvk = snap[0];
          	    r_mnvk(Number(masot.getValue("Ftabn_id")), Number(masot.getValue("Fwid_wp")), 0, 0, day_difference(masot.getValue("Fbdat"),masot.getValue("Fedat")), 0, kodnvk, masot.getValue("Fbdat"), masot.getValue("Fwid"));
          		kodnvk = oldnvk;
          		masot.MoveNext();
       		}
       		masot.close();
       		grid.clearSelected();
    		list.tbl.requery();
    		grid.RefreshGrid();
    		alert(ru("Неявки проставлены.","Неявки проставлено."));
		break;
	}	
}

function showDocView()
{		
	var par = new Object();
	if(grid.getSelectedCount()>0)
		par.IDs = copyArray(grid.getSelectedIDs(true));
	else	
		par.IDs = list.tbl.getValue("FWID");
	par.fdoc = Fdoc;
	par.dat1 = gd.dat1;
	par.dat2 = gd.dat2; 
	if(getSystem()=="ZRP")
		var view = lpProxy.getView("OTP_SUB_PRK");
	else
		var view = lpProxy.getView("CDR_PRK_PERS");
	if (view == null)
	{
		if(getSystem()=="ZRP")
			lpProxy.showView("OTP_SUB_PRK", "l_otp_sub.xml", par);
		else
			lpProxy.showView("CDR_PRK_PERS", "l_cdr_prk.xml", par);
	}
	else
	{
		view.sendMessage("doc", par);	
	}
}

function docRunViews(oPar)
{
	var par = new Object();	
	if(oPar)
		par.grid = oPar.grid;
	if(grid.getSelectedCount()>0)
		par.IDs = copyArray(grid.getSelectedIDs(true));
	else	
		par.IDs = list.tbl.getValue("FWID");
	par.fdoc = Fdoc;
	par.dat1 = gd.dat1;
	par.dat2 = gd.dat2;
	if(getSystem()=="ZRP")
		var view = lpProxy.getView("OTP_SUB_PRK");
	else
		var view = lpProxy.getView("CDR_PRK_PERS");
	if (view != null)
	{
		if(view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("doc", par);	
		}
	}
}

function copyArray(ar)
{
	var ret = new Array();
	for(var i=0; i<ar.length; i++)
		ret[i] = ar[i];
	return ret;
}

function docDel(idDoc)
{
	//для коректной взаимоработы двух подсистем делаем проверку
	if(getSystem()!="ZRP" && getSystem()!="CDR")
	{
		alert(ru("Для работы с этим приказом перейдите в подсистему учета кадров либо з/п!",
				"Для роботи з цим наказом перейдіть в підсистему обліку кадрів або з/п!"),ICON_WARNING)
		return false;
	}
	//из подсистемы кадров в случае удаления приказа с существующими дочерними приказами 
	//и включенном режиме "сохранения через контекстное меню" родительский приказ не удаляем
	if(getSystem()=="CDR" && getPar("SAVEOTPINZRP")=="menu" && isExistsDaughterPrk(idDoc))
	{
		var kol = getZrpPrkCount(idDoc);
		alert(ru("Приказ с идентификтором "+idDoc+" удален не будет, т.к. данный приказ имеет дочерние приказы ("+kol+" шт.) и \n"
					+"в параметре '"+getParItemPath("SAVEOTPINZRP")+"'\nвыбран режим 'из контекстного меню'"
					+"\nИзменения для таких случаев доступны лишь из подсистемы учета з/п!",
				"Наказ з ідентифікатором "+idDoc+" видалено не буде, тому що даний наказ має дочірні накази ("+kol+" шт.) та \n"
					+"в параметрі '"+getParItemPath("SAVEOTPINZRP")+"'\nобрано режим 'з контекстного меню'"
					+"\nЗміни для таких випадків доступні лише з підсистеми обліку з/п!"));
		return false;
	}
	var t = OpenTable("select * from ^prk_all where Fwid_prik="+idDoc);
	//если не указан режим сохранения, то дочерние приказы не трогаем
	if(t.rowCount>0 && getPar("SAVEOTPINZRP")!="no")
	{
		var oPrik = new DpPrik("_OTP",0);
		for(; !t.IsEOF(); t.MoveNext())
		{
			//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
			var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			if(snap)
			{
				ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
						+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
				ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			}
			oPrik.del(t.getValue("Fwid"));
		}
	}
	t.close();
	return true;
}

function filterMode(mnuID)
{
	if(mnuID=="__XDEL" || mnuID=="COPY")
		return false;
	else
		return true;
}

function getPrkCount(docID)
{
	if(docID)
	{
		var snap = getSnap("select count(fwid) from ^prk_otp where Fwid_prk="+docID);
		if(snap)
			return snap[0];
		else
			return 0;
	}
	else
		return 0;
}