include("Objects/DpCl.js");

var objDoc;
var oCat;
var nomClCategor = getPar("CRM_EVENT_CAT");
var sTmpTbl = getTmpTableName();
var sTmpTblAlarm = getTmpTableName();
var enumRole =  lpProxy.getEnum("ical_role");
var enumAction =  lpProxy.getEnum("ical_action");
var oOrg;

function Load()
{
	this.dataFormatValue = new java.text.SimpleDateFormat()
	this.dataFormatValue.applyPattern("yyyyMMdd");
	this.dataFormatText = new java.text.SimpleDateFormat();
	this.dataFormatText.applyPattern("yyyy.MM.dd");
	
	Caption(UR("Подія|Событие"), extPar.mode);
	
	objDoc = extPar.doc;
	
	fillCategories()
	FCOLOR.mask = "###";
	
	oOrg = new DpCl("0");
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkSmartCtrl(FORG);
	
	/*
	oCat = new DpCl("0", getPar("CRM_EVENT_CAT"), 0);
	oCat.linkSmartCtrl(FCAT);
	oCat.setContAssist();
	*/
	
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HSUBJECT", FSUBJECT);
	ctrlLinker.addLink("HPLACE", FPLACE);
	ctrlLinker.addLink("HPRIORITY", FPRIORITY);
	ctrlLinker.addLink("HFULLDAY", FFULLDAY);
	ctrlLinker.addLink("HBDATE", FBDATE);
	ctrlLinker.addLink("HEDATE", FEDATE);	
	//ctrlLinker.addLink("HREPIT", FREPIT);
	ctrlLinker.addLink("HCONFIDENCE", FCONFIDENCE);
	ctrlLinker.addLink("HCONTENT", FCONTENT);	
	ctrlLinker.addLink("HCOLOR", FCOLOR);
	ctrlLinker.addLink("HSTATE", FSTATE);
	//ctrlLinker.addClLink("HCAT", oCat);
	ctrlLinker.addClLink("HORG", oOrg);	
	ctrlLinker.updateData(false);
	if (extPar && extPar.iCalArr)
	{
		filliCalArr();
	}
	fillCombos();
	loadCategoryDB();
	loadFreq();
	valid_FFULLDAY();
	
	if(extPar.mode=="ADD")
	{
		var dat = new Date();
		if (differ(FBDATE.value,d00) == 0)
			FEDATE.value = FBDATE.value = today.getVarDate();		
		var hours = dat.getHours();
		FBTIME.setTime(hours + 1);
		FETIME.setTime(hours + 2);
		if(extPar.org)
			oOrg.setCod(extPar.org);
	}
	else
	{
		FBTIME.value = objDoc.getVar("HBDATE");
		FETIME.value = objDoc.getVar("HEDATE");
	}
	
	this.setExDate = e_event_setExDate;
	this.setExDate(objDoc.getVar("HEXDATES"));
	this.initAttendeeGrid = _initAttendeeGrid;
	this.initAttendeeGrid();
	
	this.initAlarmGrid = _initAlarmGrid;
	this.initAlarmGrid();
	
	
	
	this.color_valid = color_valid;
	this.color_select = color_select;
	FCOLOR.setModifyHandler(this, "color_valid");		
	setButton(FCOLOR, this, "color_select");
	setButton(BTNCLCATEGOR, cl_categor);
	//setValid(FSTATE, setColor);
	setValid(ISREPEAT, is_repeat_valid);
	setValid(FFULLDAY, valid_FFULLDAY);
	
	
	color_valid();
	setValid(FREQ, freq_valid)
	freq_valid();
	is_repeat_valid();
	
	this.addExpDate = e_event_addExpDate;
	setButton(BTNADDEXDATE, this, "addExpDate");
	this.editExpDate = e_event_editExpDate;
	setButton(BTNEDITEXDATE, this, "editExpDate");
	this.delExpDate = e_event_delExpDate;
	setButton(BTNDELEXDATE, this, "delExpDate");
}

function valid_FFULLDAY()
{
	if (FFULLDAY.checked)
	{
		FBTIME.setTime(0);
		FETIME.setTime(0);
	}
	FBTIME.setEnabled(FFULLDAY.checked == false);
	FETIME.setEnabled(FFULLDAY.checked == false);
	return true;
}

function filliCalArr()
{
	list.nop_combo_valid = new Function("return true");
	
	NOP_COMBO.clear();
	for (var i = 0; i < extPar.iCalArr.length; i++)
	{
		NOP_COMBO.addItem(extPar.iCalArr[i], extPar.iCalArr[i]);
	}
	if (extPar.iCalName)
		NOP_COMBO.value = extPar.iCalName;
}

function fillCategories()
{
	if (!nomClCategor)
		return;
	include ("objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	var dlgBuilder = FORM.getDialogBuilder();
	
	
	var lblComp = FORM.addScrolledComposite(categorCtrl);
	var tbl = OpenTable ("select fcod , ftxt from ^listcl where fcl = " + nomClCategor);		
	while (!tbl.isEOF())
	{
		var xmlCheck = xmlDom.createElement("CheckBox");
		var ctrlId = "CATEGOR_" + String(Number(tbl.getValue("fcod")));
		xmlCheck.setAttribute("ID", ctrlId);
		xmlCheck.setAttribute("text", tbl.getValue("ftxt"));
			
			//var gd = new Packages.org.eclipse.swt.layout.GridData();
			//FORM.AddCheckBox(txt, ctrlId);
		var ctrl = dlgBuilder.addCheckBox(lblComp, xmlCheck.xmlNode);
			
			
		tbl.moveNext();
	}
	lblComp.pack();	
	tbl.close();
	
}

function _initAttendeeGrid()
{  	
	include ("sys/ListApi.js");
	initGridVars(gridAttendee);
	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTbl,"CAL_ATTENDEE","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	
	if (extPar && (extPar.idtmpl || extPar.isTransform))
	{
		objDoc.gotoFirstRow(); //загружаем все строки в объект
		
		do
		{
			var currChild = objDoc.getCurrRow();
			if (currChild == null || currChild.sClassId != "ATTENDEE")
				continue;
				
			obj2DB(currChild.jDoc.getObjectID(),currChild.jDoc, null, sTmpTbl);
			currChild.saveExtToDB();
		}
		while(objDoc.gotoNextRow())
	}
	else
	{
	
		var sFLD = GetPatternIntersection("CAL_ATTENDEE","CAL_ATTENDEE");
		var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
				   + " SELECT " + sFLD
				   + " FROM ^CAL_ATTENDEE"
				   + " WHERE fid_doc = " + nId;
		ExecuteSQL(sSQL);
	}
	gridAttendee.setXMLDir(this.sDocSourceDir);
	gridAttendee.setXMLFile("attendeegrid.xml");
	var tbl = OpenTable("m","select  * FROM " + sTmpTbl);
	tbl.clTie("pers", "=" + getPar("CODPERS") + ",fcodpers");
	
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tbl, "ROW", extPar.doc);
	
	gridAttendee.setTable(tbl);
//-	grid.getTable().setIdFld("FNID");
	
	this.getRoleText = e_event_getRoleText;
	gridAttendee.build();
	this.listAttendeeMenuInit = listAttendeeMenuInit;
	this.listAttendeeMenuRun = listAttendeeMenuRun;
	gridAttendee.loadMenuHandler(this,"listAttendeeMenuInit");
	gridAttendee.selectMenuHandler(this,"listAttendeeMenuRun");
	
}

function _initAlarmGrid()
{  	
	include ("sys/ListApi.js");
	initGridVars(gridAlarm);
	this.sDocSourceDir = rootDirectory() + "docs/" + extPar.doc.sDocLbl + "/";
	CreateTable(sTmpTblAlarm,"CAL_ALARM","FWID");
	var nId = (extPar.mode == "COPY") ? extPar.doc.nOldID : extPar.doc.getID();
	var sFLD = GetPatternIntersection("CAL_ALARM","CAL_ALARM");
	
	if (extPar && (extPar.idtmpl || extPar.isTransform))
	{
		objDoc.gotoFirstRow(); //загружаем все строки в объект
		
		do
		{
			var currChild = objDoc.getCurrRow();
			if (currChild == null || currChild.sClassId != "ALARM")
				continue;				
			obj2DB(currChild.jDoc.getObjectID(),currChild.jDoc, null, sTmpTblAlarm);
			currChild.saveExtToDB();
		}
		while(objDoc.gotoNextRow())
	}
	else
	{
		var sSQL = "INSERT INTO " + sTmpTblAlarm + "(" + sFLD + ")"
				+ " SELECT " + sFLD
			   + " FROM ^CAL_ALARM"
			   + " WHERE fid_doc = " + nId;
		ExecuteSQL(sSQL);
	}
	
	gridAlarm.setXMLDir(this.sDocSourceDir);
	gridAlarm.setXMLFile("alarmgrid.xml");
	var tbl = OpenTable("m","select  * FROM " + sTmpTblAlarm + " order by fwid ");
	
	if(extPar.mode=="COPY")
		extPar.doc.resetFnids(tbl, "ROW", extPar.doc);
	
	gridAlarm.setTable(tbl);
	
	this.getAlertTypeText = e_event_getAlertTypeText;
	this.getAlertText = e_event_getAlertText;
	this.getAlarmRepeatText = e_event_getAlarmRepeatText;
	
	gridAlarm.build();
	gridAlarm.loadMenuHandler(this,"listAttendeeMenuInit");
	gridAlarm.selectMenuHandler(this,"listAttendeeMenuRun");
	
}

function saveRows()
{
	ExecuteSQL("DELETE FROM ^CAL_ATTENDEE WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID")));
	var sFLD = GetPatternIntersection("CAL_ATTENDEE","CAL_ATTENDEE");
	ExecuteSQL("INSERT INTO ^CAL_ATTENDEE(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTbl);
	
	ExecuteSQL("DELETE FROM ^CAL_ALARM WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID")));
	var sFLD = GetPatternIntersection("CAL_ALARM","CAL_ALARM");
	ExecuteSQL("INSERT INTO ^CAL_ALARM(" + sFLD + ")"
			  + " SELECT " + sFLD + " FROM " + sTmpTblAlarm);
}

function e_event_getRoleText(roleID)
{
	var e;
	try
	{
		return UR(enumRole.getItemByValue(roleID).text);
	}
	catch(e)
	{
		return "";
	}
	
}

function e_event_getAlertTypeText(typeID)
{
	var e;
	try
	{
		return UR(enumAction.getItemByValue(typeID).text);
	}
	catch(e)
	{
		return "";
	}
	
}

function e_event_getAlertText(trigger, rel)
{
	
	var ret = "";
	trigger = String(trigger);
	var isBefore = true;
	
	if (trigger && trigger != "")
	{
		
		if(trigger.startsWith("-"))
		{
			trigger = trigger.substr(3);
		}
		else
		{
			isBefore = false;
			trigger = trigger.substr(2);
		}
		
		var n = parseInt(trigger);
		if(!isNaN(n))
		{
			ret += " " +  n + " ";
		}
		
		var str = trigger.right(1);
		
		switch(str)
		{
			case "M":
				ret += UR("хвилин|минут");
				break;
			case "H":
				ret += UR("годин|часов");
				break;
			case "D":
				ret += UR("днiв|дней");
				break;			
		}
			
	}
	
	if (isBefore)
		ret += " до";
	else
		ret += UR(" пiсля| после");
	
	if(rel == "END")
		ret += UR(" кiнця| конца");
	else
		ret += UR(" початку| начала");
			
		
	return ret;
	
}

function e_event_getAlarmRepeatText(nRep, durat)
{
	if(nRep == 0)
		return UR("Нi|Нет");
	
	var ret = String(nRep);
	if (durat && String(durat).startsWith('PT'))
	{
		var n = parseInt(String(durat).substr(2));
		if(!isNaN(n))
			ret += " " + UR(" разiв кожнi | раз каждые ") + n + UR(" хвилин| минут"); 
	}
	
	return ret;
	
}

function listAttendeeMenuInit(grid)
{
	if(IsDblClick(grid))
	{
		grid.runGridMenu("EDIT");
		return;
	}
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
	grid.AddMenuItem("","");
	grid.AddMenuItem("+++","Експорт|Экспорт");
		grid.AddMenuItem("EXPORTCALC","Open Calc");
		grid.AddMenuItem("EXPORTXLS","Формат xls");
	grid.AddMenuItem("---","");
	grid.AddMenuItem("","");
	grid.AddMenuItem("FIND", "Пошук|Поиск");
	grid.AddMenuItem("SELECT", "Відбір|Отбор");
	
}

function listAttendeeMenuRun(sID, grid)
{
	var idClassRow = grid.getData("ID") == "gridAttendee"? "ATTENDEE":"ALARM";
	if(sID == "DEL")
	{
		extPar.doc.deleteRow(idClassRow,
				Number(grid.getTable().getRowID()));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else if (sID == "EXPORTCALC")
	{
		var oPar = new Object();
		oPar.grid = grid;
		showWindow("grid_to_scalc.xml", SW_MODAL, oPar);
	}
	else if (sID == "EXPORTXLS")
	{
		var sFile = BrowseForFile("*.xls", "Файлы XLS (*.xls)|*.xls|", null, "SAVE");
		if (sFile)
		{
			if (!sFile.endsWith(".xls"))
				sFile = sFile + ".xls";
			grid.exportToXLS(sFile);
		}
	}
	else if (sID == "FIND")
	{
		grid.runSelection(8);
	}
	else if (sID == "SELECT")
	{
		grid.runSelection(2);
	}
	else
	{
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = extPar.doc.createRow(idClassRow);					
				
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow(idClassRow,Number(grid.getTable().getRowID()));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow(idClassRow, 
						Number(grid.getTable().getRowID()));			
		}
		
		var bOK = oDocRow.edit(sID)
		if (typeOf(FORM) == "DpXMLDialog")
		{		
			FORM.setActive();
		}	
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow(idClassRow,oDocRow);
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,idClassRow== "ATTENDEE"?sTmpTbl:sTmpTblAlarm);
			grid.getTable().requery();
			grid.refresh();			
		}
	}
}

function loadFreq()
{
	var strFreq = String(objDoc.getVar("HREPIT"));
	if (!strFreq)
		return;
	ISREPEAT.checked = true;
	var objFreq = parseFreq(strFreq);
	
	if(objFreq.FREQ)
		FREQ.value = objFreq.FREQ; 
	
	if(objFreq.INTERVAL)
		INTERVAL.value = Number(objFreq.INTERVAL); 
	if(objFreq.FREQ == "WEEKLY")
	{
		var arrID =  ["SU","MO","TU","WE","TH","FR","SA"];
		for (var i = 0; i < arrID.length; i++)
		{
			var e;
			try
			{
				document[arrID[i]].value = false;
			}
			catch(e)
			{
			}
		}
		
		if(objFreq.BYDAY)
		{
			var strBYDAY = String(objFreq.BYDAY);
			var arr = strBYDAY.split(",");
			for (var i = 0; i < arr.length; i++)
			{
				var day = allt(String(arr[i]));
				document[day].checked = true;
			}
			
		}
		else
		{
			var day = FBDATE.value.getDay();
			switch(day)
			{
			case 0:
				SU.checked = true;
				break;
			case 1:
				MO.checked = true;
				break;
			case 2:
				TU.checked = true;
				break;
			case 3:
				WE.checked = true;
				break;
			case 4:
				TH.checked = true;
				break;
			case 5:
				FR.checked = true;
				break;
			case 6:
				SA.checked = true;
				break;
			}
		}
	}
	else if(objFreq.FREQ == "MONTHLY")
	{
		if(objFreq.BYMONTHDAY)
		{
		    BYMONTHDAY.value = objFreq.BYMONTHDAY;
		    MONTHTYPE.value = 0;
		}
		if(objFreq.BYDAY)
		{
			NOMDAYWEEK.value = parseInt(objFreq.BYDAY);
			
			var sDay = objFreq.BYDAY.substr(objFreq.BYDAY.left(1) == '-'?2:1);
			var i = 0;
			switch(sDay)
			{
			    case "SU":
			    	i=0;
			    	break;
			    case "MO":
			    	i=1;
			    	break;
			    case "TU":
			    	i=2;
			    	break;
			    case "WE":
			    	i=3;
			    	break;
			    case "TH":
			    	i=4;
			    	break;
			    case "FR":
			    	i=5;
			    	break;
			    case "SA":
			    	i=6;
			    	break;
			}
			DAYWEEK.value = i;
			BYMONTHDAY.value = objFreq.BYMONTHDAY;
		    MONTHTYPE.value = 1;
		}
		
	}
	else if(objFreq.FREQ == "YEARLY")
	{
		if(objFreq.BYMONTHDAY)
		{
			YEARTYPE.value = 0;
			SPINMONTH.value = Number(objFreq.BYMONTHDAY);
			MONTH1.value = Number(objFreq.BYMONTH);
		}
		else if (objFreq.BYDAY)
		{
			YEARTYPE.value = 1;
			NOMDAYWEEKY.value = parseInt(String(objFreq.BYDAY));
			var sDay = objFreq.BYDAY.substr(objFreq.BYDAY.left(1) == '-'?2:1);
			var i = 0;
			switch(sDay)
			{
			    case "SU":
			    	i=0;
			    	break;
			    case "MO":
			    	i=1;
			    	break;
			    case "TU":
			    	i=2;
			    	break;
			    case "WE":
			    	i=3;
			    	break;
			    case "TH":
			    	i=4;
			    	break;
			    case "FR":
			    	i=5;
			    	break;
			    case "SA":
			    	i=6;
			    	break;
			}
			DAYWEEKY.value = i;
			MONTH2.value = Number(objFreq.BYMONTH);
		}
		else if (objFreq.BYYEARDAY)
		{
			YEARTYPE.value = 2;
			SPINDAY.value = objFreq.BYYEARDAY;
		}
	}
	
	if(objFreq.COUNT)
	{
		ENDTYPE.value = 1;
		COUNT.value = Number(objFreq.COUNT);
	}
	if(objFreq.UNTIL)
	{
		ENDTYPE.value = 2;
		var untilDate = new Date();
		untilDate.year = Number(substr(objFreq.UNTIL,1,4))
		untilDate.month = Number(substr(objFreq.UNTIL,5,2)) - 1; 
		untilDate.date = Number(substr(objFreq.UNTIL,7,2))
		if(FFULLDAY.checked)
		{
			untilDate.setMinutes(FBTIME.value.getMinutes() + untilDate.getTimezoneOffset());
		}
		
		UNTIL.value = untilDate.getVarDate();
	}
	
	
}

function parseFreq(str)
{
	var ret = new Object();
	var arr = str.split(";")
	for (var i = 0; i < arr.length; i++)
	{
		var s = arr[i].split("=");
		if(s.length = 2)
			ret[s[0]] = s[1];
		else
			ret[s[0]] = true;
			
	}
	
	return ret;
	
}

function e_event_getFreq()
{
	var ret = "";
	if(ISREPEAT.checked == false)
		return "";
	
	ret ="FREQ=" + FREQ.value + ";INTERVAL=" + INTERVAL.value;
	if(FREQ.value == "WEEKLY")
	{
		ret+= ";BYDAY=";
		if(MO.checked)
			ret+= "MO,";
		if(TU.checked)
			ret+= "TU,";
		if(WE.checked)
			ret+= "WE,";
		if(TH.checked)
			ret+= "TH,";
		if(FR.checked)
			ret+= "FR,";
		if(SA.checked)
			ret+= "SA,";
		if(SU.checked)
			ret+= "SU,";
		
		if(ret.right(1) == ',')
			ret = ret.substr(0,ret.length - 1);
			
	}
	else if(FREQ.value == "MONTHLY")
	{
	    if(MONTHTYPE.value == 0)
	    {
	    	ret += ";BYMONTHDAY=" + Number(BYMONTHDAY.value);
	    }
	    if(MONTHTYPE.value == 1)
	    {
	    	ret += ";BYDAY=" + Number(NOMDAYWEEK.value);
	        ret += ["SU","MO","TU","WE","TH","FR","SA"][Number(DAYWEEK.value)];
	    }
	}
	else if(FREQ.value == "YEARLY")
	{
	    
		if(YEARTYPE.value == 0)
	    {
	    	ret += ";BYMONTHDAY=" + Number(SPINMONTH.value);
	    	ret += ";BYMONTH=" + Number(MONTH1.value);	    	
	    }
	    if(YEARTYPE.value == 1)
	    {
	    	ret += ";BYDAY=" + Number(NOMDAYWEEKY.value);
	        ret += ["SU","MO","TU","WE","TH","FR","SA"][Number(DAYWEEKY.value)];
	        ret += ";BYMONTH=" + Number(MONTH2.value);
	    }
	    if(YEARTYPE.value == 2)
	    {
	    	ret += ";BYYEARDAY=" + Number(SPINDAY.value);	        
	    }
	}
	
	if(ENDTYPE.value == 1)
	{
		ret += ";COUNT=" + Number(COUNT.value);
	}
	else if(ENDTYPE.value == 2)
	{
		var untilDat  = UNTIL.value;
		if(FFULLDAY.checked)
		{
			ret += ";UNTIL=" + format("yyyymmdd",untilDat);
		}
		else
		{
			untilDat.setHours(FBTIME.value.getHours()); 
			untilDat.setMinutes(FBTIME.value.getMinutes() + untilDat.getTimezoneOffset());
			ret += ";UNTIL=" + format("yyyymmddTHHmm00Z",untilDat);
		}
		
	}
	
	return ret;
}

function e_event_setExDate(strDates)
{
	if (strDates == null || allt(strDates)  == "")
		return;
	var arrDates = String(strDates).split(",");
	for (var i = 0; i< arrDates.length; i++)
	{
		var e;
		var strDat = allt(arrDates[i]);
		try
		{
			var dat = this.dataFormatValue.parse(strDat);
			var text = this.dataFormatText.format(dat);
			EXDATELIST.addItem(strDat, text);			
		}
		catch(e)
		{
			alert(e)
		}
	}
}


function is_repeat_valid()
{
	grpRepeatType.setEnabledAllChildren(ISREPEAT.checked);
	
}

function loadCategoryDB()
{
	if (!nomClCategor)
		return;
	
	objDoc.gotoFirstRow(); //загружаем все строки в объект
	
	do
	{
		var currChild = objDoc.getCurrRow();
		if (currChild == null || currChild.sClassId != "CATEGORY")
			continue;
			
		var ctrlId = "CATEGOR_" + String(Number(currChild.getVar("rcategory")));
		if (document[ctrlId])
			document[ctrlId].checked = true;	
	}
	while(objDoc.gotoNextRow())
}

function saveCategoryDB()
{
	if (!nomClCategor)
		return;
	var arrOldCat = new Array();
	var arrNewCat = new Array();
	var tbl = OpenTable ("select fcategory from ^revcateg where fid_doc = " + objDoc.getID());		
	while (!tbl.isEOF())
	{
		arrOldCat[String(Number(tbl.getValue("fcategory")))] = true;
		tbl.moveNext();
	}
	tbl.close();
	
	
	var tbl = OpenTable ("select fcod , ftxt from ^listcl where fcl = " + nomClCategor);
	
	while (!tbl.isEOF())
	{
		
		var ctrlId = "CATEGOR_" + String(Number(tbl.getValue("fcod")));			
		if (document[ctrlId] && document[ctrlId].checked)
		{
			var nCod = Number(tbl.getValue("fcod"));
			arrNewCat[arrNewCat.length] = nCod;
			if(!arrOldCat[nCod])
			{
				var oRow = objDoc.createRow("CATEGORY");	
				oRow.setVar("RCATEGORY", nCod);
				objDoc.appendRow("CATEGORY", oRow);
				obj2DB(oRow.getID(), oRow.jDocRow);
			}
		}
		
		tbl.moveNext();
	}
	
	tbl.close();
	
	if(arrNewCat.length == 0)
		arrNewCat[0] = -1;
	
	var tbl = OpenTable ("select fwid from ^revcateg where fid_doc = " 
			+ objDoc.getID() + " and FCATEGORY not in (" + arrNewCat.toString()+ ") ");		
	while (!tbl.isEOF())
	{
		objDoc.deleteRow("CATEGORY", tbl.getValue("FWID"));	
		tbl.moveNext();
	}
	tbl.close();
	ExecuteSQL("delete from ^revcateg where fid_doc = " 
			+ objDoc.getID() + " and FCATEGORY not in (" + arrNewCat.toString()+ ") ");
}

function saveCategoryObj()
{
	if (!nomClCategor)
		return;
	
	
	objDoc.gotoFirstRow(); //загружаем все строки в объект
	
	do
	{
		var currChild = objDoc.getCurrRow();
		if (currChild == null || currChild.sClassId != "CATEGORY")
			continue;				
		
		objDoc.deleteRow("CATEGORY", currChild.jDoc.getObjectID());
	}
	while(objDoc.gotoNextRow())
	
	
	var tbl = OpenTable ("select fcod , ftxt from ^listcl where fcl = " + nomClCategor);	
	while (!tbl.isEOF())
	{
		
		var ctrlId = "CATEGOR_" + String(Number(tbl.getValue("fcod")));			
		if (document[ctrlId] && document[ctrlId].checked)
		{
			var nCod = Number(tbl.getValue("fcod"));
			var oRow = objDoc.createRow("CATEGORY");	
			oRow.setVar("RCATEGORY", nCod);
			objDoc.appendRow("CATEGORY", oRow);			
		}
		
		tbl.moveNext();
	}
	
	tbl.close();
}

function cl_categor()
{
	if (!nomClCategor)
	{
		alert(UR("Вкажіть довідник категорій в параметрах системи|Укажите справочник категорий в параметрах системы"));
		return;
	}
	var par = new Object();
	par.Fcl = nomClCategor;
	showWindow("l_cl.xml",SW_MODAL, par);
}

function fillCombos()
{
	/*
	for (var i = 0; i < 12; i++)
	{
		var monthName = tmonth(i+1, "mt");
		MONTH1.addItem(i, monthName);
		MONTH2.addItem(i, monthName);
	}
	*/
	var startDay = FBDATE.value;
	var cal = java.util.Calendar.getInstance();
	cal.setTime(startDay);
	var dayOfYear = Number(cal.get(cal.DAY_OF_YEAR));
	
	
	var dat = goDay(startDay, (-1)*startDay.getDay());
	var textDay = ""
	for (var i =1 ; i <=7; i++)
	{
		dat = goDay(dat, 1);
		textDay = getDayAsWeekName(dat);
		DAYWEEK.addItem(i%7, textDay);
		DAYWEEKY.addItem(i%7, textDay);
	}
	DAYWEEK.setValue(startDay.getDay());
	DAYWEEKY.setValue(startDay.getDay());
	
	for (var i = 1; i <= 12; i++)
	{
		var monthName = tmonth(i, "mt");
		MONTH1.addItem(i, monthName);
		MONTH2.addItem(i, monthName);
	}
	MONTH1.setValue(startDay.getMonth()+ 1);
	MONTH2.setValue(startDay.getMonth()+ 1);
	
	for (var i = 1; i <= 5; i++)
	{
		var value = i;
		var text = i;
		NOMDAYWEEK.addItem(value, text);
		NOMDAYWEEKY.addItem(value, text);
	}
	
	var value = "-1";
	var text = UR("Останнiй|Последний");
	NOMDAYWEEK.addItem(value, text);	
	NOMDAYWEEKY.addItem(value, text);
	
	var text2 = UR(" останнiй| последний");
	for (var i = 2; i <= 5; i++)
	{
		var value = "-" + i;
		var text = i + text2;
		NOMDAYWEEK.addItem(value, text);
		NOMDAYWEEKY.addItem(value, text);
	}
	
	var weekOfMonth = 0;
	var tmpDate = new Date(startDay)
	
	while(tmpDate.getMonth() == startDay.getMonth())
	{
		tmpDate = goDay(tmpDate, -7);
		weekOfMonth++;
	}
	
	NOMDAYWEEK.setValue(weekOfMonth);
	NOMDAYWEEKY.setValue(weekOfMonth);
	

	for (var i = 1; i <= 31; i++)
	{
		var value = i;
		var text = i;
		BYMONTHDAY.addItem(value, text);		
	}
	
	
	var value = "-1";
	var text = UR("Останнiй|Последний");
	BYMONTHDAY.addItem(value, text);
	var text2 = UR(" останнiй| последний");
	for (var i = 2; i <= 5; i++)
	{
		var value = "-" + i;
		var text = i + text2;
		BYMONTHDAY.addItem(value, text);		
	}
	
	BYMONTHDAY.setValue(startDay.getDate());
	SPINDAY.value = dayOfYear;
	SPINMONTH.value = startDay.getDate();
	
	var sID =  ["SU","MO","TU","WE","TH","FR","SA"][Number(startDay.getDay())];
	var e;
	try
	{
		document[sID].value = true;
	}
	catch(e)
	{
	}
	
}

function e_event_addExpDate()
{
	var dat =  EXDATE.value; 
	if(differ(dat, d00) >= 0)
		return;
	
	var key = this.dataFormatValue.format(dat);
	if (EXDATELIST.hasKey(key))
	{
		return;
	}
	var text = this.dataFormatText.format(dat);
	EXDATELIST.addItem(key, text);
	
}

function e_event_editExpDate()
{
	if(this.delExpDate())
	{
		this.addExpDate();
	}
}

function e_event_delExpDate()
{
	var key = EXDATELIST.getSelectValue();
	if(key)
	{
		
		EXDATELIST.deleteItem(key);
		return true;
	}
	else
	{
		return false;
	}
	
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HEXDATES", EXDATELIST.getValue());
	var repit = e_event_getFreq();
	objDoc.setVar("HREPIT", repit);	
	var date = getVarTime(FBDATE.value, FBTIME.value);
	objDoc.setVar("HBDATE", date.getVarDate());
	date = getVarTime(FEDATE.value, FETIME.value);
	objDoc.setVar("HEDATE", date.getVarDate());
	if (extPar.isiCal)
	{
		extPar.iCalName = NOP_COMBO.value;
		saveCategoryObj();
		return;
	}
	saveCategoryDB();
	saveRows();
}

function freq_valid()
{
	grpWeek.setVisible(FREQ.value == "WEEKLY");
	grpMonth.setVisible(FREQ.value == "MONTHLY");
	grpYear.setVisible(FREQ.value == "YEARLY");
	if(FREQ.value == "WEEKLY")
		FREQLBL.text = UR("тижднiв|недель");
	else if(FREQ.value == "MONTHLY")
		FREQLBL.text = UR("мiсяцiв|месяцев");
	else if(FREQ.value == "YEARLY")
		FREQLBL.text = UR("рокiв|лет");
	else
		FREQLBL.text = UR("днiв|дней");
	
	grpRepeatType.layout(true, true);
	
}

function getVarTime(oDat, oTime)
{
	var date = new Date();	
	if(!oDat || !oTime)
		return date;
	
	date = new Date(oDat);	
	date.setHours(0);
	date.setMinutes(0);
	
	var hours = oTime.getHours();
	var minutes = oTime.getMinutes();
	if(hours)
		date.setHours(hours);
	if(minutes)
		date.setMinutes(minutes);
	return date;
}

function setColor()
{	
	var oSnap = getSnap("select FCOLOR from ^EVENT "
						+" where FSTATE="+ sqlTo(FSTATE.value)
						+" order by FDOC_DAT desc"
					, false);
	if(oSnap)
		FCOLOR.value = Number(oSnap[0]);		
	color_valid();
}

function color_valid()
{
	try
	{
		var nColor = java.lang.Integer(FCOLOR.value);
		var rgb = extPar.grid.colorLevel(nColor, false);		
		var color = org.eclipse.swt.graphics.Color(null, rgb);
		FCOLOR.setBackground(color);		
	}
	catch(e)
	{
		trace(e)
	}
}

function color_select()
{
	var par = new Object();
	par.maxCol = 26;
	par.ret = new Object();
	par.ret.FTYPE = 0;
	showWindow("colors.js", SW_MODAL, par);
	if(par.escape)
		return false;
	FCOLOR.value = Number(par.ret.FTYPE);
	color_valid();
}

include("sys/DpBaseDlg.js");