include("doc\\nakl\\DpNkRow.js");

var obj = extPar.obj;
obj.mode = extPar.mode;
F1cena = Fcena;
var otpcena = F1cena;
//var otpcena = Fcenapr;
var nk_issch = obj.parent.getPar("nk_issch");

function Load()
{			
	//Caption(ru("Редактирование расходной накладной","Редагування видаткової накладної"));
	
	rnk = new DpNkRow(obj);
	//rnk.load();
	
	Fkol.mask = MASK_KOL;
	Fkol_spr.mask = MASK_KOL;
	Fcenapr.mask = MASK_CENA;		
	Fvcena.mask = MASK_CENA;
	F1cena.mask = MASK_CENA;
	Fsum.mask = MASK_SUM;	
	
	rnk.oNmkl = new DpNmkl();	
	rnk.oNmkl.linkCtrl(Fnmkl,tFnmkl,tFedi, null, rnk, null, "zaval_Fnmkl");
	rnk.oNmkl.SetNakl(obj.parent);
	
	oCena = new DpUCena(obj);	
	oCena.linkCtrl(F1cena);
			
	rnk.oSc   = new DpSc("cut");
	rnk.oSc1  = new DpSc("cut");
	rnk.oSc.linkCtrl(Fsc, Fsu, Fst);
	
	oVal = new DpVal();
	oVal.linkCtrl(tFvcod);	
	objVal = new DpVal();
	
	rnk.oPost = new DpCl("0");
	rnk.oPodr = new DpCl("0");
	rnk.oMol  = new DpCl("0");
	rnk.oPost.setClcl(getPar("CODPLAT"));
	rnk.oPodr.setClcl(sprPodr);	
	rnk.oMol.setClcl(sprMol);
	rnk.oPost.setCod(obj.parent.getVar("HPOST"));
	rnk.oPodr.setCod(obj.parent.getVar("HPODR"));
	rnk.oMol.setCod(obj.parent.getVar("HMOL"));
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RKOL",Fkol);		
	ctrlLinker.addLink("RVCENA",Fvcena);
	ctrlLinker.addLink("RUCENA",F1cena);	
	ctrlLinker.addLink("RSCENA",Fcenapr);
	ctrlLinker.addLink("RKOLSPR",Fkol_spr);
	ctrlLinker.addLink("RTYPE",FRTYPE);		
	ctrlLinker.addLink("RSUM",Fsum);	
	ctrlLinker.updateData(false);
	
	if (extPar.mode != "ADD")
	{
		oVal.setCod(obj.getVar("R1SVAL"));
		rnk.oNmkl.setCod(obj.getVar("RTNMK"));
		rnk.oSc.set(obj.getVar("RSC"),
				obj.getVar("RSU"),
				obj.getVar("RST"));
	}
	else
	{
		rnk.oSc.set(obj.parent.getVar("HSC"),
				obj.parent.getVar("HSU"),
				obj.parent.getVar("HST"));
	}
		
	setValid(FRTYPE, onFRTYPEChange);
	
	Disable(Fkol_spr);
	if(!nk_issch)
	{
		Disable(Fsc);
		Disable(Fsu);
		Disable(Fst);
	}
	
	setValid(Fnmkl, rnk.Fnmkl_valid);
	
	setValid(Fkol, rnk.check_Fsum);
	setValid(F1cena, rnk.check_Fsum);

	//vlad 29.12.2011
	//Надо, чтобы в приходных строках при вводе 
	//суммы и кол-ва само рассчитало цену
	setValid(Fsum, check_cena);
	
	setValid(tFedi, rnk.check_Fedi);		
	
	rnk.parChange();
	rnk.check_Fedi();
	rnk.check_Fsum();	
}

function onFRTYPEChange()
{
	//if(nk_issch)
	//	return;
	if(FRTYPE.value == "5")
	{
		if(obj.parent.getVar("HSC1") && (!nk_issch || !rnk.oSc.getSc()))
			rnk.oSc.set(obj.parent.getVar("HSC1"),
						obj.parent.getVar("HSU1"),
						obj.parent.getVar("HST1")
						);
	} 
	else 
	{
		if(obj.parent.getVar("HSC") && (!nk_issch || !rnk.oSc.getSc()))
			rnk.oSc.set(obj.parent.getVar("HSC"),
						obj.parent.getVar("HSU"),
						obj.parent.getVar("HST")
						);
	}
}

function onSave()
{		
	var Fctype = rnk.oSc.getType();	
	if(FRTYPE.value == "5")
	{	 
		if(rnk.oNmkl.Fis_pn1 == '+')
			Fid_pn = obj.getID();
		oCena.isValid = true;
		Fctype = rnk.oSc1.getType();		
	}	
	var bRet = rnk.save();	
	obj.setVar("RCTYPE", Fctype);	
		
	return bRet;
}

//Надо, чтобы в приходных строках при вводе 
//суммы и кол-ва само рассчитало цену
function check_cena()
{
	if(FRTYPE.value == RTYPE_PR)	//'5'
	{	 
		var sum = Number(Fsum.value);
		var kol = Number(Fkol.value);
		var cena = Number(F1cena.value);
		
		if (cena==0 && sum!=0 && kol!=0)
		{
			var dec = Number(getPar("DECIPRI"));
			F1cena.value = round(sum/kol, dec);
		}
	}
	return true;
}

include("sys\\DpBaseDlg.js");