include("Objects\\DpCl.js");
include("Objects\\DpPostRs.js");
include("Objects\\DpClcl.js");
include("Objects\\DpCtrlLinker.js");
include("Objects\\DpDocPar.js");
include("Objects\\DpSbcs.js");
//include("doc\\DpAutoNo.js");
include("doc\\DpDocList.js");
include("doc\\DpDoc.js");
include("sys\\mask.js");
include("Tmoney.js");
include("gridedit.js");

var sTmpTbl = "CHEKTMP";
var objPlat; 
var objPlatSbcs;
var NextNum;
var objDoc = extPar.doc; 
var dp = new DpDocPar(objDoc.sDocLbl,objDoc.nNop);
var Validation = true;
var ds;
var tableR;

function Load()
{	
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;

    gridedit	= new DpGridEdit();
	//ds = DataSource();    
    
    if (IsTable("CHEKTMP"))
		DropTable("CHEKTMP");
  	var strSQL="CREATE TABLE CHEKTMP (Fsch_fact "+SqlType("TEXT",15)+",Fsum "+SqlType("MONEY")+",Ffdb_sc "+SqlType("TEXT",18)+",Fwid "+SqlType("TEXT",15)+")";
	ExecuteSQL(strSQL);
		
    objPlat = new DpCl();
   	objPlat.linkCtrl(HORG,HTOT);
   	objPlat.linkCtrl2("Fcod_st", HCOT);   
   	objPlat.setClcl(extPar.codplat);
	
// 	objPlatSbcs = new DpSbcs();
//   	objPlatSbcs.linkCtrl(HTOTP, HBNKOT, HDBSC, HMFOOT);    

   	DOC_NUM.mask = MASK_DOCNUM;
	setValid(FDOC_DAT, FDOC_DAT_Valid);
   	
	ctrlLinker = new DpCtrlLinker(objDoc);
/*
	ctrlLinker.addLink("HNOM",DOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	
	
	ctrlLinker.addLink("HORG",HORG);
	ctrlLinker.addLink("HCOT",HCOT);	
	ctrlLinker.addLink("HTOT",HTOT);
	ctrlLinker.addLink("HMFOOT",HMFOOT);
	ctrlLinker.addLink("HBNKOT",HBNKOT);	
	ctrlLinker.addLink("HDBSC",HDBSC);
	
	ctrlLinker.addLink("HTTO",HTTO);
	ctrlLinker.addLink("HCTO",HCTO);
	ctrlLinker.addLink("HBNKTO",HBNKTO);
	ctrlLinker.addLink("HMFOTO",HMFOTO);
	ctrlLinker.addLink("HCRSC",HCRSC);	
	
	ctrlLinker.addLink("HSF",RSCH_F);
	//ctrlLinker.addLink("HRDBN",RDB_SC);	
		
	ctrlLinker.addLink("HSUM",HSUM);
	ctrlLinker.addLink("HNDS",HSNDS);	
	ctrlLinker.addLink("HTOVAR",HTPL);
*/
	ctrlLinker.updateData(false);
/*		
	if (extPar.mode == "COPY" || extPar.mode == "EDIT")
   	{   		
   		strSQL="INSERT INTO CHEKTMP(Fsch_fact, Fsum, Fwid,Ffdb_sc)"+
			" SELECT Fsch_fact, Fsum, Fwid, "+sqlTo(HDBSC.Value)+" AS Ffdb_sc "+
			" FROM ^CHEK "+
			"WHERE Fdoc='IC' and Fid_doc="+sqlTo(extPar.fwid);
		ExecuteSQL(strSQL);
		   		  		
   		objPlat.setCod(objDoc.getVar("HORG"));
   		HORG_Valid();   		 
	}   	  	   		
*/	
	HCTO.value = getPar("OOKPO");
	HTTO.value = getPar("OFIRM");
	HMFOTO.value = getPar("CUR_RSC_MFO");
	HBNKTO.value = getPar("CUR_RSC_BANK");
	HCRSC.value = getPar("CUR_RSC");
	Disable(HCTO);
	Disable(HTTO);
	Disable(HMFOTO);
	Disable(HBNKTO);
	Disable(HCRSC);
	
	setFocus(DOC_NUM);
	
	tableR = OpenTable("m","SELECT * FROM CHEKTMP ORDER BY FSCH_FACT");
	//ds.Source(tableR);	
}

function _initGrid()
{
   	this.sDocSourceDir = rootDirectory() + "docs\\" + extPar.doc.sDocLbl + "\\";

	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");

	var tbl = OpenTable("m","select * from " + sTmpTbl + " order by Fsch_fact");
	grid.setTable(tbl);
	grid.build();
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");	
}

function listMenuInit()
{
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("COPY","Копіювання | Копирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}

function gridChanged()
{
	SaveRecordSum();
}

function gridAdd()
{
   NextNum="0"
   tableR.AddNew();
   //NextNum = strNoInc(NextNum);
   tableR.setValue("Fsch_fact",NextNum);
   tableR.setValue("Ffdb_sc",HDBSC.value);
   tableR.setValue("Fsum",0);   
   var szLastFwid = GetUID();
   tableR.setValue("FWID",szLastFwid);
   tableR.Update();
   tableR.Requery();
   tableR.FindFirst("fwid=" + sqlToFind(szLastFwid));
}

function onSelectRowMenu(sID)
{
	OnChangeRecord(gridChanged);
    OnAddRecord(gridAdd);
/*	if(sID == "DEL")
	{
		extPar.doc.deleteRow("ICROW",
				Number(grid.getTable().getValue("FNID")));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{
		var oDocRow;
		if(sID == "ADD")
		{			
			oDocRow = extPar.doc.createRow("ICROW");
		}
		else if(sID == "EDIT")
		{
			oDocRow = extPar.doc.getRow("ICROW",Number(grid.getTable().getValue("FNID")));
		}
		else if(sID == "COPY")
		{
			oDocRow = extPar.doc.copyRow("ICROW", 
						Number(grid.getTable().getValue("FNID")));			
		}
		
		var bOK = oDocRow.edit(sID)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow("ICROW",oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();
			//refreshSUMK();
		}
	}
*/
}

function FDOC_DAT_Valid()
{
/*	if (FDOC_DAT.value <= d00 && FDOC_DAT.value >= d00)	
	{		
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
*/	
	if (differ(FDOC_DAT.value,d00)<0 || differ(FDOC_DAT.value,d00)>0)
	{
		WAIT(ru("Дата за пределами рабочего периода", 
			"Дата за межами робочого перiоду"));
	}
	return true;
}

function SaveRecordSum()
{	
	var sumP;
	sumP = 0;
	if (!tableR.IsEmpty())
	{
		var bm = tableR.bookmark;
		tableR.MoveFirst();
		while (!tableR.IsEOF())
		{
			sumP+=tableR.getValue("Fsum")
			tableR.MoveNext();
		}
		tableR.bookmark = bm;
	}
   HSUM.value = sumP;
   return true;
}

/*
function HORG_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}

function HDBSC_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}
function HMFOOT_Valid()
{
	RDB_SC.value = HDBSC.value;
	return true;
}

function HSUM_Valid()
{
	RSUM.value = HSUM.value;
	//var ndsProc = objDoc.getPar("__ndsproc");		
	var ndsProc = dp.getPar("__ndsproc");
	SUM = Number(HSUM.value)
	NDS = Number(ndsProc)
	if(ndsProc)
	{
		HSNDS.value = SUM * NDS / (100 + NDS);
		HSNDS_Valid();
	}
	HTSUM.value = TMoney(HSUM.value,0);
	return true;
}
*/

function onSave()
{
	ctrlLinker.updateData(true);	
}

include("sys\\DpBaseDlg.js");