include("Objects/DpEdi.js");
include("Objects/DpCl.js");
include("servis/date.js");

var obj = extPar.obj;
var ctrlLinker;

function onLoad()
{		
	Caption(UR("Лічильник|Счетчик") +": "+ modeName(this.sMode));
	
	FNUM.mask = "##";
	FCAPACITY.mask = MASK_KOL;
	FINDICE.mask = MASK_KOL;
	FACT.mask = replicate("&", 50);
	FSERIAL.mask = replicate("&", 50);
	FMARK.mask = replicate("&", 250);
	FPLACE.mask = replicate("&", 250);
	FCOMMENT.mask = replicate("&", 250);
	FSTAMPNUM.mask = replicate("&", 50);
	FCHECKINTERVAL.mask = "######";
	FDIAMETER.mask = MASK_KOL;
	FMIDDLE.mask = MASK_KOL;
	FCHECKMIDDLE.mask = MASK_KOL;
	
	var oUnit = new DpEdi("0");
	oUnit.assocDpText(FUNIT);
	
	var oPoint = new DpCl("0");
	oPoint.setClcl(getPar("CODPOINT"));
	oPoint.linkSmartCtrl(FPOINT);
	if(!getPar("CODPOINT"))
		GRPOINT.setVisible(false);
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RSERV", FSERV);
	ctrlLinker.addLink("RBDAT", FBDAT);
	ctrlLinker.addLink("REDAT", FEDAT);
	ctrlLinker.addLink("RNUM", FNUM);
	ctrlLinker.addLink("RRELEASEDATE", FRELEASEDATE);
	ctrlLinker.addLink("RNEXTCHECK", FNEXTCHECK);
	ctrlLinker.addLink("RINDICE", FINDICE);
	ctrlLinker.addLink("RACT", FACT);
	ctrlLinker.addLink("RCAPACITY", FCAPACITY);
	ctrlLinker.addLink("RSERIAL", FSERIAL);
	ctrlLinker.addLink("RMARK", FMARK);
	ctrlLinker.addLink("RPLACE", FPLACE);
	ctrlLinker.addLink("RTYPE", FTYPE);
	ctrlLinker.addLink("RDIAMETER", FDIAMETER);
	ctrlLinker.addLink("RFACTORY", FFACTORY);
	ctrlLinker.addLink("RSTAMPNUM", FSTAMPNUM);
	ctrlLinker.addLink("RSTAMPDATE", FSTAMPDATE);
	ctrlLinker.addLink("RCHECKDATE", FCHECKDATE);
	ctrlLinker.addLink("RCHECKINTERVAL", FCHECKINTERVAL);
	ctrlLinker.addLink("RISBREAK", FISBREAK);
	ctrlLinker.addLink("RBDATBREAK", FBDATBREAK);
	ctrlLinker.addLink("REDATBREAK", FEDATBREAK);
	ctrlLinker.addLink("RISCHECK", FISCHECK);
	ctrlLinker.addLink("RBDATCHECK", FBDATCHECK);
	ctrlLinker.addLink("REDATCHECK", FEDATCHECK);
	ctrlLinker.addLink("RCHECKMIDDLE", FCHECKMIDDLE);
	ctrlLinker.addLink("RMIDDLE", FMIDDLE);
	ctrlLinker.addLink("RINPUT", FINPUT);
	ctrlLinker.addLink("RISNEW", FISNEW);
	ctrlLinker.addLink("RISINSPECT", FISINSPECT);
	ctrlLinker.addLink("RCOMMENT", FCOMMENT);
	ctrlLinker.addClLink("RUNIT", oUnit);
	ctrlLinker.addClLink("RPOINT", oPoint);
	ctrlLinker.toControls();
	
	loadInputs();
	if(extPar.mode=="ADD")
	{
		FNUM.value = nextCntNum();
		FBDAT.value = new Date(obj.parent.getVar("HBDAT")).getVarDate();
		//FBDAT.value = d00;
		FRELEASEDATE.value = d00;
		FBDATCHECK.value = d00;
		FEDATCHECK.value = d00;
		FNEXTCHECK.value = d00;
		FBDATBREAK.value = d00;
		FEDATBREAK.value = d00;
	}
	else
	{
		FINPUT.value = Number(obj.getVar("RINPUT"));
	}
	
	this.calcMiddle = calcMiddle;
	setButton(FMIDDLE, this, "calcMiddle");
	this.calcCheckMiddle = calcCheckMiddle;
	setButton(FCHECKMIDDLE, this, "calcCheckMiddle");
	
	this.selectCnt = selectCnt;
	setButton(FSERIAL, this, "selectCnt");
	
	setValid(FISCHECK, ischeckValid);
	setValid(FISBREAK, breakValid);
	//setValid(FBDATCHECK, checkDateValid);
	//setValid(FEDATCHECK, checkDateValid);
	ischeckValid();
	breakValid();
}

function onSave()
{		
	if(!checkDateValid())
		return false;
	if(Number(FTYPE.value)!=3)
		obj.setVar("RID_CNT", 0);
	ctrlLinker.toVars();	
}

function nextCntNum()
{
	var oSnap = getSnap("select max(FNUM) from "+ extPar.tblName);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

function loadInputs()
{
	FINPUT.clear();
	var nObj = obj.parent.getVar("HOBJECT");
	if(nObj)
	{
		GRINPUT.setVisible(true);
		var tbl = OpenTable("select l.* from ^CL_INPUT l"
							+" inner join ^CLRELCLCL r on r.FWID_CL=l.FWID_CL"
							+" where r.FCOD="+ nObj +" and l.FISCOUNTER="+ sqlTrue
							);
		if(tbl.isEmpty())
			alert(UR("Обєкт не має вводу з лічильником!|Объект не имеет ввода со счетчиком!"));
		for(; !tbl.isEOF(); tbl.MoveNext())
		{
			var inputID = tbl.getValue("FWID");
			var txt = tbl.getValue("FCOD") +" - "+ tbl.getValue("FPLACE");
			FINPUT.addItem(inputID, txt);
		}
		tbl.close();
	}
	else
	{
		GRINPUT.setVisible(false);
	}
}

function calcMiddle()
{
	FMIDDLE.value = 0;
	
	var dat1 = firstDay(gomonth(today, -3));
	var dat2 = lastDay(gomonth(today, -1));
	var oSnap = getSnap("select sum(FDIFFERENCE), count(*) as cnt"
							+", min(FDATE) as FMINDATE"
							+", max(FDATE) as FMAXDATE"
						+" from ^COUNTERS"
						+" where FCOUNTER="+ obj.getID()
							+" and FDATE>="+ sqlTo(dat1)
							+" and FDATE<="+ sqlTo(dat2)
						);
	if(oSnap && Number(oSnap[0]))
	{
		dat1 = firstDay(oSnap[2]);
		dat2 = lastDay(oSnap[3]);
		var days = day_difference(dat1, dat2);
		FMIDDLE.value = round(Number(oSnap[0])/days, 4);
	}
}

function calcCheckMiddle()
{	
	FCHECKMIDDLE.value = 0;
	var dat1 = firstDay(gomonth(FBDATCHECK.value, -2));
	var dat2 = lastDay(gomonth(FBDATCHECK.value, -1));
	oSnap = getSnap("select sum(FDIFFERENCE), count(*) as cnt"
							+", min(FDATE) as FMINDATE"
							+", max(FDATE) as FMAXDATE"
						+" from ^COUNTERS"
						+" where FCOUNTER="+ obj.getID()
							+" and FDATE>="+ sqlTo(dat1)
							+" and FDATE<="+ sqlTo(dat2)
						);
	if(oSnap && Number(oSnap[0]))
	{
		dat1 = firstDay(oSnap[2]);
		dat2 = lastDay(oSnap[3]);
		var days = day_difference(dat1, dat2);
		FCHECKMIDDLE.value = round(Number(oSnap[0])/days, 4);
	}
}

function breakValid()
{
	if(FISBREAK.value==true)
	{
		Enable(FBDATBREAK);
		Enable(FEDATBREAK);
	}
	else
	{
		Enable(FBDATBREAK, false);
		Enable(FEDATBREAK, false);
	}
}

function ischeckValid()
{
	if(FISCHECK.value==true)
	{
		Enable(FBDATCHECK);
		Enable(FEDATCHECK);
		Enable(FCHECKMIDDLE);
	}
	else
	{
		Enable(FBDATCHECK, false);
		Enable(FEDATCHECK, false);
		Enable(FCHECKMIDDLE, false);
	}
}

function checkDateValid()
{
	if(FISCHECK.value==false)
		return true;
	var bdat = FBDATCHECK.value;
	var edat = FEDATCHECK.value;
	if(differ(bdat, d00)==0 && differ(edat, d00)==0)
	{
		alert(UR("Введіть дату повірки!|Введите дату поверки!"));
		setFocus(FBDATCHECK);
		return false;
	}
	var sMsg = "";
	if(differ(bdat, d00)<0)
	{
		if(differ(edat, d00)<0)
		{
			sMsg = UR("В період з "+ StrDat(bdat, "DMY") +" по "+ StrDat(edat, "DMY") 
					+"|В период с "+ StrDat(bdat, "DMY") +" по "+ StrDat(edat, "DMY")
					)
		}
		else
		{
			sMsg = UR("З "+ StrDat(bdat, "DMY") +"|С "+ StrDat(bdat, "DMY"));
		}
	}
	else if(differ(edat, d00)<0)
	{
		sMsg = UR("По "+ StrDat(edat, "DMY") +"|До "+ StrDat(edat, "DMY"));
	}
	sMsg += "\n"+ UR("нарахування по лічильнику будуть проводитись за середньодобовими витратами "+ FCHECKMIDDLE.value 
					+"|начисления по счетчику будут проводиться по среднесуточным расходам "+ FCHECKMIDDLE.value);
	var ret = msgBox("oc", sMsg);
	return ret=="o";
}

function selectCnt()
{
	var type = Number(FTYPE.value);
	var house = obj.parent.getVar("HHOUSE");
	if(type==3)	//коммунальный
	{
		var par = new Object();
		par.ret = new Object();
		par.ret.FSERIAL = "";
		par.ret.FSERV = "";
		par.ret.FMARK = "";
		par.ret.FCAPACITY = "";
		par.ret.FPLACE = "";
		par.ret.FBDAT = "";
		par.ret.FEDAT = "";
		par.ret.FINDICE = "";
		par.ret.FID_DOG = "";
		par.ret.FWID = "";
		par.ret.FAPART = "";
		
		par.cells = new Object();
		par.cells[1] = new Object();
		par.cells[1].name = "FAPART";
		par.cells[1].width = 8;
		par.cells[1].text = UR("Квартира|Квартира");
		
		par.cells[2] = new Object();
		par.cells[2].name = "FDOG_NUM";
		par.cells[2].width = 10;
		par.cells[2].text = UR("Особ.рахунок|Лицевой счет");
		
		par.cells[3] = new Object();
		par.cells[3].name = "=^FSERV=='RENT'? UR('Квартплата|Квартплата')"
							 +" : ^FSERV=='HEAT'? UR('Опалення|Отопление')"
							 +" : ^FSERV=='CWATER'? UR('Холодна вода|Холодная вода')"
							 +" : ^FSERV=='HWATER'? UR('Гаряча вода|Горячая вода')"
							 +" : ^FSERV=='GAS'? UR('Газ|Газ')"
							 +" : ^FSERV=='ELECTRIC'? UR('Електроенергія|Электроэнергия')"
							 +" : ^FSERV=='OTHER'? UR('Інше|Другое')"
							 +" : ^FSERV=='FULL'? UR('Загальна|Общая')"
							 +" : ''";
		par.cells[3].width = 15;
		par.cells[3].text = UR("Послуга|Услуга");
		
		par.cells[4] = new Object();
		par.cells[4].name = "FSERIAL";
		par.cells[4].width = 15;
		par.cells[4].text = UR("Лічильник|Счетчик");
		
		var d1 = FBDAT.value;
		var d2 = FEDAT.value;
		var title = UR("Комунальні лічильники|Коммунальные счетчики");
		var tbl = OpenTable("select c.*, a.FNOM as FAPART, cont.FDOG_NUM"
							+" from ^SC_COUNTERS c"
								+" inner join ^CONTRACT cont on cont.FWID=c.FID_DOG"
								+" inner join ^LICSC l on l.FID_DOG=c.FID_DOG"
								+" inner join ^CL_APARTMENT a on l.FAPMT=a.FWID_CL"
							+" where c.FTYPE=3 and FID_CNT=0"
								+" and l.FHOUSE="+ house
								+" and c.FBDAT<="+ sqlTo(d2)
								+" and c.FEDAT>="+ sqlTo(d1)
								+" and cont.FBDAT<="+ sqlTo(d2)
								+" and cont.FEDAT>="+ sqlTo(d1)
							+" order by l.FAPMT"
							);
		par = selection(tbl, title, par);
		tbl.close();	
		if(par.escape)
			return;
		
		obj.setVar("RID_CNT", par.ret.FWID);
		FSERIAL.value = par.ret.FSERIAL;
		FSERV.value = par.ret.FSERV;
		FMARK.value = par.ret.FMARK;
		FCAPACITY.value = par.ret.FCAPACITY;
		FBDAT.value = par.ret.FBDAT;
		FEDAT.value = par.ret.FEDAT;
		FINDICE.value = par.ret.FINDICE;
		FPLACE.value = par.ret.FPLACE;
		if(par.ret.FAPART)
			FPLACE.value = "кв. "+ par.ret.FAPART +", "+ par.ret.FPLACE;
	}
}

include("sys/DpBaseDlg.js");