include("Objects/DpCl.js");

var tbl = extPar.m_pTable;

function onLoad()
{		
	Caption(UR("Пільговик|Льготник")	+": "+ modeName(this.sMode));
	
	if(!fillMen())
		return false;
		
	oExempt = new DpCl("", getPar("CODLGT"), 0);
	oExempt.linkSmartCtrl(FEXEMPT);
	oExempt.setContAssist();
	oExempt.setFWID(extPar.fid_lg);
	
	if(extPar.mode!="ADD")
	{
		FMEN.value = tbl.getValue("FID_MEN");
		oExempt.setFWID(tbl.getValue("FID_LG"));
		FELECTRICPRIVILEGE.checked = tbl.getValue("FELECTRICPRIVILEGE")==true;
		FFAMILYPRIVILEGE.checked = tbl.getValue("FFAMILYPRIVILEGE")==true;
		FMAIN.checked = tbl.getValue("FMAIN")==true;
	}
	if(getSystem()=="VDK")
		GRGEK.setVisible(false);
	
	setValid(FMEN, menValid);
	Disable(FEXEMPT);
	
	setFocus(FMEN);
}

function onSave()
{		
	var m = new Object();
	if(extPar.mode=="EDIT")
	{
		m.FWID = tbl.getValue("FWID");
	}
	else
	{
		m.FWID = GetUID();
		m.FCOD = nextPrivCod();
	}
	m.FID_DOG = extPar.oPriv.parent.getID();
	m.FID_PRIV = extPar.oPriv.getID();
	m.FID_LG = oExempt.getFWID();
	m.FID_MEN = FMEN.value;
	m.FMAIN = FMAIN.checked;
	m.FELECTRICPRIVILEGE = FELECTRICPRIVILEGE.checked;
	m.FFAMILYPRIVILEGE = FFAMILYPRIVILEGE.checked;
	UpdateTable(tbl.getTableName(), m, extPar.mode!="EDIT");
}

function fillMen()
{
	var men = Number(FMEN.value);
	FMEN.clear();
	var sWhere = "";
	if(extPar.mode=="ADD")
		sWhere = " where FEDAT>"+ sqlTo(today);
	var tbl = OpenTable("select * from "+ extPar.tblMen + sWhere +" order by FCOD");
	if(tbl.isEmpty())
	{
		alert(UR("Спочатку треба додати мешканця!|Сначала нужно добавить жильца!"));
		return false;
	}
	var menID = 0;
	for(; !tbl.isEOF(); tbl.MoveNext())
	{
		menID = tbl.getValue("FWID");
		var txt = tbl.getValue("FCOD") +" - "+ tbl.getValue("FFIO");
		FMEN.addItem(menID, txt);
	}
	if(tbl.recordCount==1)
		FMEN.value = menID;
	if(men)
		FMEN.value = men;
	tbl.close();
	return true;
}

function menValid()
{
	var men = Number(FMEN.value);
	if(!men)
	{
		WAIT(UR("Необхідно вказати мешканця!|Нужно выбрать жильца!"));
		return false;		
	}
	return true;
}

function nextPrivCod()
{
	var oSnap = getSnap("select max(FCOD) from "+ extPar.tblName);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0])+1;
	return 1;
}

include("sys/DpBaseDlg.js");