include ("Objects\\DpClcl.js");
include ("Objects\\DpCl.js");
include ("Objects\\DpSc.js");
include ("Objects\\DpGr.js");
include ("Objects\\DpKompl.js");
include ("Objects\\DpAm.js");
include ("Objects\\DpInv.js");
include ("Objects\\DpEval.js");
include ("izosdatb.js");
include ("Objects\\dpNop.js");
include ("doc\\DpDoc.js");
include ("sys\\mask.js");
include("Objects\\DpCtrlLinker.js");

var param;
var objDoc = extPar.doc;
var ctrlLinker = null;

var buhnds  = getPar("BUHNDS");
var procnds = getPar("PROCNDS");

cod_mol  = getPar("CODMOL");
cod_podr = getPar("CODPODR");
cod_plat = getPar("CODPLAT");
var numbuh  = getPar("NUMBUH");
var dprx = javaDate2Script(getPar("__DATPER"));

datEmpt = javaDate2Script(new Date(3000,0,1));

var dat2011  = getPar("UOSDAT2011");
var dtn2011  = new Date(2011,3,1);

var tbl,tbl0,tblnazv,tblinv,tbl7,tblperem, mfsch;
var ocrsc,odbsc,ootnsc,osdav,opost,ocod_podr,ocod_mol,ogroup,ogroupb,ocodvid,okompl,omam,oinvnum,znop, osrok;
var nop;
var gS;
var dt = javaDate2Script(new Date(1997,6,1));

var dt_view  = javaDate2Script(getPar("GLOBDAT2"));
var prevddat = d00obj;

//var dt_view2  = extPar.dat2;
 
function Load ()
{
	Caption(ru("Акт приемки-передачи основных средств","Акт здачі-прийняття основних засобів"));
	odbsc=new DpSc("cutxyz");
    ocrsc=new DpSc("cutxyz");
    ootnsc=new DpSc("cutxyz");
    //ootnsc=new DpSc("cutx");
    znop = new DpNop();
    znop.setCod(0);
 
	ocod_podr=new DpCl();
	ocod_podr.setClcl(cod_podr);
    ocod_mol=new DpCl();
    ocod_mol.setClcl(cod_mol);
    osdav=new DpCl("0");
    osdav.setClcl(cod_plat);
    opost=new DpCl();
    opost.setClcl(cod_plat);
    

    ocod_podr.linkCtrl(HPDR);
    ocod_mol.linkCtrl(HMOL);

    osdav.linkCtrl(HSDAV);
    opost.linkCtrl(HORG);
    
   // tbl=OpenTable("m","OS1");
  //  tbl0=OpenTable("s","OS0");
  //  tbl0b=OpenTable("s","OS0B");
  //  tbl7=OpenTable("s","OS7");
  //  tblperem=OpenTable("s","VN_PEREM");
  //  tblnazv=OpenTable("s","OSNAZV");
  //  tblinv=OpenTable("s","INV_NUM");

    ogroup=new DpGr("0", dt_view, dt_view);
    ogroupb=new DpGr("0", dt_view, dt_view);
    omam=new DpAm("0");
    osrok=new DpAm("0");
    oinvnum=new DpInv();
    ocodvid=new DpKompl(0, false);
    okompl=new DpKompl(0, true);

	var oSnap = getSnap("select Fdoc_dat from ^OS1");
	if (extPar.mode=="EDIT")
		if (oSnap!=null)
	    	prevddat = oSnap[0];
	HNOM.mask=MASK_DOCNUM;
    HZNOM.mask=strRepl("&",255);
    HPRICE.mask="################.##";
    HPRICEB.mask="################.##";
    HPRICEAL.mask="################.##";
    HNDS.mask="################.##";
    HKOL.mask="#####.###";
    HPNOM.mask=strRepl("&",255);
    HKISP.mask="#.##";
    HIZNOS.mask="################.##";
    HIZNOSB.mask="################.##";
    HGOD.mask="####";
    HINVOLD.mask=MASK_INV;
    HLIKVST.mask="######.##";
    HKOLLIKV.mask="####.###";
    HBMET.mask="#";
    HIZN_NDS.mask="################.##";
    HISP.mask="&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
    HINVNAK.mask="&&&&&&&&&&&&&&&&&&&&";
    HPD3NAK.mask="&&&";
    HGRS.mask="###";    
    
    if(!getPar("USENDSAM"))
    	HIZN_NDS.enabled = false;
    
    ogroup.linkCtrl(HGR);
    ogroupb.linkCtrl(HGRB);
    omam.linkCtrl(HNRATE, HGR);
    osrok.linkCtrl2(HCODSROK, HSROC, HGRS);
    ocodvid.linkCtrl(HVIDOS);
    okompl.linkCtrl(HKOMPL);
    oinvnum.linkCtrl(HINVN);
    oinvnum.setInitCod(0);
   
   	ctrlLinker = new DpCtrlLinker(objDoc);
  
    ctrlLinker.addLink("HNOM",HNOM);
    ctrlLinker.addLink("HDAT",HDAT);
    ctrlLinker.addLink("HORG",HORG);
    ctrlLinker.addLink("HPDR",HPDR);
    ctrlLinker.addLink("HSDAV",HSDAV);
    ctrlLinker.addLink("HMOL",HMOL);
    ctrlLinker.addLink("HGRB",HGRB);
    
	odbsc.linkCtrl(HDS, HDU, HDT, HDCOD1, HDCOD2, HDCOD3);
	ctrlLinker.addScLink("HDS","HDU","HDT","HDCOD1","HDCOD2","HDCOD3",odbsc);
	ocrsc.linkCtrl(HCS, HCU, HCT, HCCOD1, HCCOD2, HCCOD3);
	ctrlLinker.addScLink("HCS","HCU","HCT","HCCOD1","HCCOD2","HCCOD3",ocrsc);
	ootnsc.linkCtrl(HZC, HZU, HZT, HZCOD1, HZCOD2, HZCOD3);
	ctrlLinker.addScLink("HZC","HZU","HZT","HZCOD1","HZCOD2","HZCOD3",ootnsc);
    
    ctrlLinker.addLink("HINVN",HINVN);
    ctrlLinker.addLink("HNRATE",HNRATE);
    ctrlLinker.addLink("HNDS",HNDS);
    ctrlLinker.addLink("HINVOLD",HINVOLD);
    ctrlLinker.addLink("HPRICEAL",HPRICEAL);
    ctrlLinker.addLink("HIZNOS",HIZNOS);
    ctrlLinker.addLink("HKOMPL",HKOMPL);
    ctrlLinker.addLink("HPRICE",HPRICE);
    ctrlLinker.addLink("HIZNOSB",HIZNOSB);
    ctrlLinker.addLink("HGR",HGR);
    ctrlLinker.addLink("HPRICEB",HPRICEB);
    ctrlLinker.addLink("HKOL",HKOL);
    ctrlLinker.addLink("HZNOM",HZNOM);
    ctrlLinker.addLink("HGOD",HGOD);
    ctrlLinker.addLink("HPNOM",HPNOM);
    ctrlLinker.addLink("HVVOD",HVVOD);
    ctrlLinker.addLink("HNACHPL",HNACHPL);
    ctrlLinker.addLink("HCODSROK",HCODSROK);
    ctrlLinker.addLink("HSROC",HSROC);
    ctrlLinker.addLink("HGRS",HGRS);    
    ctrlLinker.addLink("HVIDOS",HVIDOS);
    ctrlLinker.addLink("HLIKVST",HLIKVST);
    ctrlLinker.addLink("HKOLLIKV",HKOLLIKV);
    ctrlLinker.addLink("HKISP",HKISP);
    ctrlLinker.addLink("HTEXUSL2",HTEXUSL2);
    ctrlLinker.addLink("HPLACE",HPLACE);
    ctrlLinker.addLink("HISP",HISP);
    ctrlLinker.addLink("HXAR",HXAR);
    ctrlLinker.addLink("HBMET",HBMET);
  //  ctrlLinker.addLink("HNAZV",HNAZV);
 	ctrlLinker.addLink("HDORAB",HDORAB);
    ctrlLinker.addLink("HOST",HOST);
    ctrlLinker.addLink("HOSTLICV",HOSTLICV);
   	ctrlLinker.addLink("HNOTPRIV",HNOTPRIV);
//	ctrlLinker.addLink("HNAZV",HNAZV);
	ctrlLinker.addLink("HIZN_NDS",HIZN_NDS);
	ctrlLinker.addLink("HTYPERS",HTYPERS);
	ctrlLinker.addLink("HIS_BUHONLY",HIS_BUHONLY);
	
    ctrlLinker.updateData(false);
    
    
    if (extPar.mode != "ADD")
    {
    	
    	if (objDoc.getVar("HNEM") == "+")
    		if (objDoc.getVar("HNEPR") == "-")
    			FNEM.setValue("nemat");
    		else 
    			FNEM.setValue("nemat4");
    	else
    		if (objDoc.getVar("HNEPR") == "-")
    			FNEM.setValue("neproizv");
    		else 
    			FNEM.setValue("proizv");
    			
    	HAREND.checked = (objDoc.getVar("HAREND")=="+");
    	HDETAL.checked = (objDoc.getVar("HDETAL")=="+");
       	HMETAL.checked = (objDoc.getVar("HMETAL")=="+");
       	HNOTPRIV.checked = (objDoc.getVar("HNOTPRIV")==true);
       
		gS = getSnap("select Ftxt,Finv_nak,Fpd3_nak from ^OSNAZV where Finv_num =" + sqlTo(HINVN.value));
		if (gS != null)
		{
			HNAZV.value = gS[0];
			HINVNAK.value = allt(gS[1]);
			HPD3NAK.value = allt(gS[2]);
		}
				
       	if (extPar.mode == "COPY")
       	{
       		HINVN.value++;
       		
       	}
       	else
       	{
       		oinvnum.setCod(objDoc.getVar("HINVN"));
       	}
       	
       	if(extPar.mode=="EDIT")
    	{
       		Disable(HINVN);
       		//if (tbl7.Seek("=",minvnum.value)) 
       		gS = getSnap("select Fnop, FWID from ^OS7 where Finv_num=" + sqlTo(HINVN.value));
       		if (gS !=null)
			{
                   nop = gS[0];
                   znop.setCod(nop);
                   
			}
		}
     	
		mfsch = objDoc.getVar("HSCH");
		
		odbsc.set(objDoc.getVar("HDS"),
   				objDoc.getVar("HDU"),
   				objDoc.getVar("HDT"),
   				objDoc.getVar("HDCOD1"),
   				objDoc.getVar("HDCOD2"),
   				objDoc.getVar("HDCOD3"));	
		ocrsc.set(objDoc.getVar("HCS"),
   				objDoc.getVar("HCU"),
   				objDoc.getVar("HCT"),
   				objDoc.getVar("HCCOD1"),
   				objDoc.getVar("HCCOD2"),
   				objDoc.getVar("HCCOD3"));	
   		ootnsc.set(objDoc.getVar("HZC"),
   				objDoc.getVar("HZU"),
   				objDoc.getVar("HZT"),
   				objDoc.getVar("HZCOD1"),
   				objDoc.getVar("HZCOD2"),
   				objDoc.getVar("HZCOD3"));
   		ocod_podr.setVar(objDoc.getVar("HPDR"));
   		ocod_mol.setVar(objDoc.getVar("HMOL"));
        osdav.setVar(objDoc.getVar("HSDAV"));
    	opost.setVar(objDoc.getVar("HORG"));
    	ogroup.setCod(objDoc.getVar("HGR"), HDAT.value, HDAT.value);
    	ogroupb.setCod(objDoc.getVar("HGRB"), HDAT.value, HDAT.value);
    	//omam.setCodSrok(objDoc.getVar("HNRATE", "HGR"));
     	ocodvid.setCod(objDoc.getVar("HVIDOS"));
    	okompl.setCod(objDoc.getVar("HKOMPL"));
    	osrok.setCodSrok(objDoc.getVar("HCODSROK"));
    	osrok.setSrok(objDoc.getVar("HSROC"));
    	osrok.setGroup(objDoc.getVar("HGRS"));
		HTYPERS.value = objDoc.getVar("HTYPERS");
		if (HTYPERS.value==0 || HTYPERS.value==null){
			HTYPERS.value = 1;			
		}
    }
    else
    {
    	mfsch=false;
    	FNEM.setValue("proizv");
    	HKISP.value = 1;
    	HDORAB.checked = true;
    	nop=0;
    	HBMET.value = numbuh;
    	HNOTPRIV.checked = false;
		HTYPERS.value = 1;    	
    }
    if(getPar("AMORT2011TYPE")>0)
	{
		Disable(HTYPERS);
		HTYPERS.value = getPar("AMORT2011TYPE");
	}
   
    setValid(HNRATE, mam_valid);
    setValid(HCODSROK, mFcodsrok_valid);
    setValid(HGR, mgroup_valid);
    setValid(HGRB, mgroupb_valid);
    setValid(HDAT, FDOC_DAT_valid);
    //setValid(HPRICE,  mFnds_valid);    
    //setValid(HPRICEB,  mFnds_valid);
   	setValid(FNEM, FNEM_valid);   
   	
    setWhen(HNDS,  mFnds_valid);

   	
   	FNEM_valid();
   	
    if (differ(new Date(objDoc.getVar("HDAT")),dtn2011)>=0){
        //Disable(HCODSROK);
     	//Disable(HSROC);
     	Disable(HGR);
     	Disable(HNRATE);
    }else{
        Enable(HCODSROK);
        Enable(HSROC);
        Enable(HGRS);        
        Enable(HGR);
        Enable(HNRATE);
    }   
    if (differ(new Date(objDoc.getVar("HDAT")),dat2011)>=0){   	
     	Disable(HGRB);
    }else{
        Enable(HGRB);    	
    }
    setValid(HSROC,sroc_Valid);
    setValid(HGRS,grs_Valid) 	
}

function sroc_Valid()
{
	if(HSROC.value>0)
		osrok.setSrok(HSROC.value);
	return true;
}

function grs_Valid()
{
	if(HGRS.value>0)
		osrok.setGroup(HGRS.value);
	return true;
}

function onSave()
{
	
	objDoc.setVar("HAREND",(HAREND.checked)?"+":"-");
	objDoc.setVar("HDETAL",(HDETAL.checked)?"+":"-");
	objDoc.setVar("HMETAL",(HMETAL.checked)?"+":"-");
	objDoc.setVar("HNEM",(FNEM.getValue() == "nemat" || FNEM.getValue() == "nemat4")?"+":"-");
	objDoc.setVar("HNEPR",(FNEM.getValue() == "proizv" || FNEM.getValue() == "nemat4")?"+":"-");
	objDoc.setVar("HNOTPRIV",(HNOTPRIV.checked)?true:false);
	if (differ(new Date(objDoc.getVar("HDAT")),dat2011)>=0){
		objDoc.setVar("HGRS",HGRS.value);
	}	
	
	if(extPar.mode !="EDIT")  
   		objDoc.setVar("HSCH",false);
   	else 
		objDoc.setVar("HSCH",mfsch);

	ctrlLinker.updateData(true);
	
	o7nop = Number(znop.getCod());
   	znop.zSetCod(o7nop,"O7");
   	
   	doc7 = new DpDoc("O7",o7nop);
   
  	
  	var wid;

    gS = getSnap("select Fwid from ^OSNAZV where Finv_num=" + sqlTo(HINVN.value));
	var m = new Object();
	var str = new java.lang.String(String(HNAZV.value));
	str = str.replaceAll("\n", " ");
	str = str.replaceAll("\r", " ");
	str = str.replaceAll("\t", " ");
	m.Ftxt = allt(str);
	m.Finv_nak = HINVNAK.value;
	m.Fpd3_nak = HPD3NAK.value;
	if (gS == null)
   	{
      	m.Fwid = GetUID();
      	m.Finv_num = HINVN.value;
      	UpdateTable("^OSNAZV", m, true)
   	}
   	else
   	{ 
   	 	UpdateTable("^OSNAZV", m, false, "Fwid=" + sqlTo(gS[0]))
   	}
	
    if (differ(new Date(objDoc.getVar("HDAT")),dtn2011)>=0){
    	HGR.value = HGRB.value
	}

  	strSQL="";
  	var flag = true;
  	var m = new Object();
   	if (extPar.mode=="EDIT")
   	{
  	  	gS = getSnap("select Fwid from ^OS7 where Finv_num=" + sqlTo(HINVN.value)); 
    	if (gS != null)
    	{
    		flag = false;
    		strSQL=" Fwid=" + sqlTo(gS[0]);
    		doc7.loadByID(gS[0]);
    		
    	}
   		else
   		{
   			
   			//m.Fnid = GetNID();
   			//doc7.setVar("Fwid",GetUID());
   		}
   	}
   	else
   	{
   		//m.Fnid = GetNID();
   		//m.Fwid = GetUID();
   	}

  		doc7.setVar("HCALC",0);
   		doc7.setVar("HDOC","O7");
   		doc7.setVar("HOP",Number(znop.getCod()));
		doc7.setVar("HNOM",HNOM.value);
   		doc7.setVar("HDAT",HDAT.value);
   		doc7.setVar("HNEM",(FNEM.getValue() == "nemat") || FNEM.getValue() == "nemat4"?"+":"-");
   		doc7.setVar("HAREND",(HAREND.checked)?"+":"-");
		doc7.setVar("HNEPR",(FNEM.getValue() == "proizv") || FNEM.getValue() == "nemat4"?"+":"-");
   		doc7.setVar("HDETAL",(HDETAL.checked)?"+":"-");
		doc7.setVar("HMETAL",(HMETAL.checked)?"+":"-");
		doc7.setVar("HNOTPRIV",(HNOTPRIV.checked)?true:false);
		doc7.setVar("HCS",ocrsc.getSc());
   		doc7.setVar("HCU",ocrsc.getSu());
		doc7.setVar("HCT",ocrsc.getSt());
   		doc7.setVar("HCCOD1",ocrsc.getCl1());
   		doc7.setVar("HCCOD2",ocrsc.getCl2());
   		doc7.setVar("HCCOD3",ocrsc.getCl3());
	   	doc7.setVar("HDS",odbsc.getSc());
   		doc7.setVar("HDU",odbsc.getSu());
   		doc7.setVar("HDT",odbsc.getSt());
   		doc7.setVar("HDCOD1",odbsc.getCl1());
   		doc7.setVar("HDCOD2",odbsc.getCl2());
   		doc7.setVar("HDCOD3",odbsc.getCl3());
		doc7.setVar("HZC",ootnsc.getSc());
   		doc7.setVar("HZU",ootnsc.getSu());
   		doc7.setVar("HZT",ootnsc.getSt());
   		doc7.setVar("HZCOD1",ootnsc.getCl1());
   		doc7.setVar("HZCOD2",ootnsc.getCl2());
		doc7.setVar("HZCOD3",ootnsc.getCl3());
	   	doc7.setVar("HPDR",ocod_podr.getCod()) ;
  		doc7.setVar("HMOL",ocod_mol.getCod());
  		doc7.setVar("HIS_BUHONLY",toScrObj(HIS_BUHONLY.value));
	   	
	   	//var nSrok = osrok.getCodSrok();	   	
	   	//if (typeof(nSrok) == "undefined" || nSrok == null)
	   	//	nSrok = 0;
  		nSrok = HSROC.value;
  		
	   	doc7.setVar("HCODSROK",nSrok);
   		doc7.setVar("HSROC",HSROC.value);
   		doc7.setVar("HLIKVST",HLIKVST.value);
   		doc7.setVar("HKOLLIKV",HKOLLIKV.value);
		doc7.setVar("HINVN",HINVN.value);
   		doc7.setVar("HINVOLD",HINVOLD.value);
		doc7.setVar("HKOMPL",HKOMPL.value);
   		doc7.setVar("HNRATE",HNRATE.value);
   		if (FNEM.getValue() == "proizv")
      		doc7.setVar("HNRATE",0);
   		doc7.setVar("HGR",HGR.value);
   	    if (differ(new Date(objDoc.getVar("HDAT")),dat2011)>=0){
   		   	doc7.setVar("HGRS",HGRS.value);
   	    }else{   	
   	    	doc7.setVar("HGRB",HGRB.value);
   	    }	
  	   	//if (FNEM.getValue() == "nemat")
      		//m.FGROUP     =6;
   //if (FNEM.getValue() == "neproizv")
     // m.FGROUP     =7;
	   	doc7.setVar("HPRICE",HPRICE.value);
   		doc7.setVar("HPRICEB",HPRICEB.value);
   		doc7.setVar("HPRICEAL",HPRICEAL.value);
   		doc7.setVar("HKOL",HKOL.value);
   		doc7.setVar("HNDS",HNDS.value);
   		doc7.setVar("HIZN_NDS",HIZN_NDS.value);
   		doc7.setVar("HIZNOS",HIZNOS.value);
   		doc7.setVar("HIZNOSB",HIZNOSB.value);
   		doc7.setVar("HVIDOS",HVIDOS.value);
   		doc7.setVar("HKISP",HKISP.value);
	   	doc7.setVar("HPNOM",HPNOM.value);
   		doc7.setVar("HZNOM",HZNOM.value);
   		doc7.setVar("HGOD",HGOD.value);
	   	doc7.setVar("HVVOD",HVVOD.value);
		doc7.setVar("HNACHPL",HNACHPL.value);
   		doc7.setVar("HDVIB",d00obj.getVarDate());
	   	doc7.setVar("HDORAB",HDORAB.checked);
   		doc7.setVar("HTEXUSL2",HTEXUSL2.value);
   		doc7.setVar("HISP",HISP.value);
   		doc7.setVar("HXAR",HXAR.value);
   		doc7.setVar("HPLACE",HPLACE.value);
   		doc7.setVar("HBMET",HBMET.value);
		doc7.setVar("HTYPERS",HTYPERS.value);   		
   		if ( extPar.mode !="EDIT")  
   				doc7.setVar("HSCH",false);
   		else 
   				doc7.setVar("HSCH",mfsch);   		
   		doc7.save();
   	//  UpdateTable("^OS7",m,flag,strSQL);

   if(extPar.mode!="EDIT")
   	if (getSnap("select * from ^INV_NUM where Finv_num=" + sqlTo(HINVN.value)) == null)
   	//if (!tblinv.Seek("=",minvnum.value))
   	{
      //tblinv.AddNew();
     // tblinv("fwid")=GetUID();
     // tblinv("finv_num")=minvnum.value;
     // tblinv.Update();
     ExecuteSQL("insert into ^INV_NUM (Fwid,Finv_num) values ( " +sqlTo(GetUID()) +"," + sqlTo(HINVN.value) + ")");
   	}


 //  tbl0.Index = "INUM";
 //  if (SQL)
	//	tbl0.Index = "FINV_NUM";
   var m0 = new Object();
   fis_updos0 = true;
   gS = getSnap("select Fedat, Fwid from ^OS0 where Finv_num =" + sqlTo(HINVN.value)+" order by fbdat");
 	if (gS == null)
   	{
  
   		flagos0 = true;
		strSQL1="";
		m0.fwid=GetUID();
	
	    m0.fbdat=HDAT.value;
	    m0.fedat=datEmpt.getVarDate();
	
	    m0.finv_num = HINVN.value;
	    m0.forig_pric = HPRICE.value;
	    m0.forig_all = HPRICEAL.value;
	    m0.fkol = HKOL.value;
	    m0.fiznos = HIZNOS.value;
	
	    m0.fcod_rate = HCODSROK.value;
    	m0.fgroup = HGR.value;
	
	      //if (FNEM.getValue() == "nemat") m0.fgroup = 6;
	      //if (FNEM.getValue() == "neproizv") m0.fgroup = 7;
	    //if (FNEM.getValue() == "proizv") m0.fcod_rate = HGR.value;
			
	    m0.fkf_ispol = HKISP.value;
	
	    m0.fcr_sc  = ocrsc.getSc();
	    m0.fcr_su  = ocrsc.getSu();
	    m0.fcr_st  = ocrsc.getSt();
      m0.fcr_cod1 = ocrsc.getCl1();
      m0.fcr_cod2 = ocrsc.getCl2();
      m0.fcr_cod3 = ocrsc.getCl3();

      m0.fdb_sc = odbsc.getSc();
      m0.fdb_su = odbsc.getSu();
      m0.fdb_st = odbsc.getSt();
      m0.fdb_cod1 = odbsc.getCl1();
      m0.fdb_cod2 = odbsc.getCl2();
      m0.fdb_cod3 = odbsc.getCl3();
      
      m0.fsrokadd = osrok.getSrok();
     
      if (differ(new Date(objDoc.getVar("HDAT")),dtn2011)>=0){
  	    m0.fgroup = HGRS.value;
        m0.fsrokadd = HSROC.value;
        m0.ftypersc  = HTYPERS.value;        
      }  

      m0.farend=(toScrObj(HAREND.checked))?"+":"-";
      m0.FBUHMETOD = HBMET.value;      
      m0.Ftypeiz = 0;      
      }
      else
      {
	      edat = javaDate2Script(gS[0]);
	   
	      if ( (edat.getYear()==datEmpt.getYear() && edat.getMonth()==datEmpt.getMonth() && edat.getDate()==datEmpt.getDate()) || javaDate2Script(HDAT.value) < javaDate2Script(gS[0]))
	      {
	
	        flagos0 = false;
	        strSQL1 = " Fwid=" + sqlTo(gS[1]);	       
	        m0.fbdat = HDAT.value;
	
	        m0.finv_num = HINVN.value;
	        m0.forig_pric = HPRICE.value;
	        m0.forig_all = HPRICEAL.value;
	        m0.fkol = HKOL.value;
	        m0.fiznos = HIZNOS.value;
	
	        m0.fcod_rate = HCODSROK.value;

	        m0.fgroup = HGR.value;
	        //if (mnemat.checked) tbl0("fgroup")=6;
	        //if (mneproizv.checked) tbl0("fgroup")=7;
	
	        m0.fkf_ispol = HKISP.value;
	
	        m0.fcr_sc  =ocrsc.getSc();
	        
	        m0.fcr_su  = ocrsc.getSu();
	        m0.fcr_st  = ocrsc.getSt();
	        m0.fcr_cod1 = ocrsc.getCl1();
	        m0.fcr_cod2 = ocrsc.getCl2();
	        m0.fcr_cod3 = ocrsc.getCl3();
	
	        m0.fdb_sc  = odbsc.getSc();
	        m0.fdb_su  = odbsc.getSu();
	        m0.fdb_st  = odbsc.getSt();
	        m0.fdb_cod1 = odbsc.getCl1();
	        m0.fdb_cod2 = odbsc.getCl2();
	        m0.fdb_cod3 = odbsc.getCl3();
	
	        m0.fsrokadd = osrok.getSrok();

	        if (differ(new Date(objDoc.getVar("HDAT")),dtn2011)>=0){
	      	    m0.fgroup = HGRS.value;
	            m0.fsrokadd = HSROC.value;
	            m0.ftypersc  = HTYPERS.value;	            
	          }  
	        
	        m0.farend=(HAREND.checked)?"+":"-";
	        m0.FBUHMETOD = HBMET.value;
	        m0.Ftypeiz = 0;	        
	      }
	      else
	      {
	      	
	        alert("Невозможно исправить данные в справочн.измен.перв.стоимости по н/у для инв.№"+ HINVN.value + "\nПроизведите данные изменения вручную");
	        fis_updos0 = false;
	      }
   	}
	

  // tbl0b.Index = "INUM";
  // if (SQL)
	//	tbl0b.Index = "FINV_NUM";
   var m0b = new Object();
   fis_updos0b = true;
   gS = getSnap("select Fedat, Fwid from ^OS0b where Finv_num=" + sqlTo(HINVN.value)+" order by fbdat");
   if (gS == null)
   {

      strSQL2 = "";
      flagos0b = true;
      m0b.fwid = GetUID();
      m0b.fbdat = HDAT.value;
      m0b.fedat = datEmpt.getVarDate();

      m0b.finv_num = HINVN.value;
      m0b.forig_pric = HPRICEB.value;
      m0b.forig_all = HPRICEB.value;
      m0b.fkol = HKOL.value;
      m0b.fiznos = HIZNOSB.value;

      m0b.fcod_rate = HCODSROK.value;
      //if (mgroupb.value!=0)
      m0b.fgroup = HGRB.value;
      //else
      //   tbl0b("fgroup")=mgroup.value;
      if (FNEM.getValue() == "nemat" || FNEM.getValue() == "nemat4") m0b.fgroup = 6;
      if (HGRB.value==0)
      {
         if (FNEM.getValue() == "neproizv") m0b.fgroup = 7;
      }

      m0b.fkf_ispol = HKISP.value;

      m0b.fcr_sc  = ocrsc.getSc();
      m0b.fcr_su  = ocrsc.getSu();
      m0b.fcr_st  = ocrsc.getSt();
      m0b.fcr_cod1= ocrsc.getCl1();
      m0b.fcr_cod2= ocrsc.getCl2();
      m0b.fcr_cod3= ocrsc.getCl3();

      m0b.fdb_sc  =odbsc.getSc();
      m0b.fdb_su  =odbsc.getSu();
      m0b.fdb_st  =odbsc.getSt();
      m0b.fdb_cod1=odbsc.getCl1();
      m0b.fdb_cod2=odbsc.getCl2();
      m0b.fdb_cod3=odbsc.getCl3();

      m0b.fsrokadd = osrok.getSrok();

      if (differ(new Date(objDoc.getVar("HDAT")),dat2011)>=0){
    	  m0b.fgroup = HGRS.value;
          m0b.fsrokadd = HSROC.value;  	    
          m0b.ftypersc  = HTYPERS.value;          
        }  
      
      m0b.farend = (HAREND.checked)?"+":"-";
      //if (typeof(tbl0b("Fbuhmetod"))!="unknown"){
         m0b.FBUHMETOD = HBMET.value;
         m0b.Ftypeiz = 0;         
      //}
   }
   else
   {
      edat = javaDate2Script(gS[0]);
      
      //if(tbl0b("fedat")==null || FDOC_DAT.value < tbl0b("fedat"))
      if ( (edat.getYear()==datEmpt.getYear() && edat.getMonth()==datEmpt.getMonth() && edat.getDate()==datEmpt.getDate()) || javaDate2Script(HDAT.value) < javaDate2Script(gS[0]))
      {
        //  tbl0b.Edit();
        flagos0b = false;
        strSQL2 = " Fwid=" + sqlTo(gS[1]);
        m0b.fbdat = HDAT.value;

        m0b.finv_num = HINVN.value;
        m0b.forig_pric = HPRICEB.value;
        m0b.forig_all = HPRICEB.value;
        m0b.fkol = HKOL.value;
        m0b.fiznos = HIZNOSB.value;

        m0b.fcod_rate = HCODSROK.value;
        //if (mgroupb.value!=0)
           m0b.fgroup = HGRB.value;
        //else
        //   tbl0b("fgroup")=mgroup.value;
        if (FNEM.getValue() == "nemat" || FNEM.getValue()== "nemat4") m0b.fgroup = 6;
        if (HGRB.value==0)
        {
           if (FNEM.getValue() == "neproizv") m0b.fgroup = 7;
        }   

        m0b.fkf_ispol = HKISP.value;

        m0b.fcr_sc  =ocrsc.getSc();
        m0b.fcr_su  =ocrsc.getSu();
        m0b.fcr_st  =ocrsc.getSt();
        m0b.fcr_cod1=ocrsc.getCl1();
        m0b.fcr_cod2=ocrsc.getCl2();
        m0b.fcr_cod3=ocrsc.getCl3();

        m0b.fdb_sc  =odbsc.getSc();
        m0b.fdb_su  =odbsc.getSu();
        m0b.fdb_st  =odbsc.getSt();
        m0b.fdb_cod1=odbsc.getCl1();
        m0b.fdb_cod2=odbsc.getCl2();
        m0b.fdb_cod3=odbsc.getCl3();

        m0b.fsrokadd=osrok.getSrok();

        if (differ(new Date(objDoc.getVar("HDAT")),dat2011)>=0){
      	    m0b.fgroup = HGRS.value;
            m0b.fsrokadd = HSROC.value;
            m0.ftypersc  = HTYPERS.value;            
          }  
        
        m0b.farend=(HAREND.checked)?"+":"-";
        m0b.FBUHMETOD = HBMET.value;
        m0b.Ftypeiz = 0;        
        
      }
      else
      {
      	
        alert("Невозможно исправить данные в справочн.измен.перв.стоимости по б/у для инв.№" + HINVN.value + "\nПроизведите данные изменения вручную");
        fis_updos0b = false;
      }
   }

 //  tblperem.Index = "INUM";
 //  if (SQL)
//		tblperem.Index = "FINV_NUM";
	var perem = new Object();
   fis_updper = true;
	gS = getSnap("select Fedat,Fwid from ^VN_PEREM where Finv_num=" + sqlTo(HINVN.value)+" order by fbdat");
	if ( gS == null)	   
//   if (!tblperem.Seek("=",minvnum.value)){
    {
      //tblperem.AddNew();
      flagperem = true,
      strSQL3="";
//-      perem.FNID = GetNID();
      perem.fwid=GetUID();
      perem.fbdat = HDAT.value;
      perem.fedat = datEmpt.getVarDate();
      perem.finv_num = HINVN.value;
      perem.fpodr = ocod_podr.getCod();
      perem.fpodro = 0;
      perem.ftabn = ocod_mol.getCod();
      perem.fsc = ootnsc.getSc();
      perem.fsu = ootnsc.getSu();
      perem.fst = ootnsc.getSt();
      perem.fcl_cod1 = ootnsc.getCl1();
     //++
     perem.fcl_cod2 = ootnsc.getCl2();
     perem.fcl_cod3 = ootnsc.getCl3();
     //--
      perem.farend = (HAREND.checked)?"+":"-";
   }
   else
   {
      //if (!tblperem("fedat") || FDOC_DAT.value < tblperem("fedat"))
      edat = javaDate2Script(gS[0]);
      if ( (edat.getYear()==datEmpt.getYear() && edat.getMonth()==datEmpt.getMonth() && edat.getDate()==datEmpt.getDate()) || javaDate2Script(HDAT.value) < javaDate2Script(gS[0]))
      {
        // tblperem.Edit();
        flagperem = false;
        strSQL3 = " Fwid= " + sqlTo(gS[1]);
         perem.fbdat=HDAT.value;

         perem.finv_num = HINVN.value;
         perem.fpodr = ocod_podr.getCod();
         perem.fpodro = 0;
         perem.ftabn = ocod_mol.getCod();
         perem.fsc = ootnsc.getSc()
         perem.fsu = ootnsc.getSu()
         perem.fst = ootnsc.getSt()
         perem.fcl_cod1 = ootnsc.getCl1()
       //++
       perem.fcl_cod2 = ootnsc.getCl2()
       perem.fcl_cod3 = ootnsc.getCl3()
       //--
         perem.farend = (HAREND.checked)?"+":"-";
      }
      else
      {
        
        alert("Невозможно исправить дату приемки в справочн.внутр.перемещений для инв.№" + HINVN.value + "\nПроизведите данные изменения вручную");
        fis_updper = false;
      }
   }
   
  /* tbl0n.Index = "INUM";
   if (SQL)
		tbl0n.Index = "FINV_NUM";
*/
	tbl0n = new Object();
   fis_updos0n = true;
   gS = getSnap("select Fedat,Fwid,fgroup from ^OS0NDS where Finv_num=" + sqlTo(HINVN.value));
  // if (!tbl0n.Seek("=",minvnum.value)){
   if (gS == null)
   {
      //tbl0n.AddNew();
      tbl0n.fwid = GetUID();
      tbl0n.fbdat = HDAT.value;
      tbl0n.fedat = datEmpt.getVarDate();

      tbl0n.finv_num = HINVN.value;
      tbl0n.forig_pric = HNDS.value;
      tbl0n.fkol = HKOL.value;
      tbl0n.fiznos = HIZN_NDS.value;
      
      //tbl0n.fgroup = HGRB.value;
      //вместо бухгалтерского проставляем код группы по налоговому учёту
      tbl0n.fgroup = HGR.value;
      if (FNEM.getValue() == "nemat" || FNEM.getValue()== "nemat4") tbl0n.fgroup = 6;
      //if (Number(HGRB.value) == 0)
      if (Number(HGR.value) == 0)
      {
         if (FNEM.getValue() == "neproizv") tbl0n.fgroup = 7;
      }
      UpdateTable("^OS0NDS",tbl0n,true);
   }
   else
   {
      strSQL = "select * from ^OS0NDS where Finv_num="+sqlTo(HINVN.value)+" and (Fedat>"+sqlTo(HDAT.value)+" or Fedat="+sqlTo(d00obj)+") order by Finv_num, Fbdat";
      tbl0n1 = OpenTable("s", strSQL);
      t = new Object();
      if (!tbl0n1.IsEmpty())
      {
         tbl0n1.MoveFirst(); 
         if ((extPar.mode=="EDIT" && !differ(prevddat, tbl0n1.getValue("fbdat"))) || extPar.mode!="EDIT")
         {
           // tbl0n1.Edit();
            t.fbdat = HDAT.value;
            t.finv_num = HINVN.value;
            t.forig_pric = HNDS.value;
            t.fkol = HKOL.value;
            t.fiznos = HIZN_NDS.value;
            //t.fgroup = HGRB.value;
            t.fgroup = HGR.value;
            if (FNEM.getValue() == "nemat" || FNEM.getValue()== "nemat4") t.fgroup = 6;
            //if (Number(HGRB.value) == 0)
            if (Number(HGR.value) == 0)
            {
               if (FNEM.getValue() == "neproizv") t.fgroup = 7;
            }
            //tbl0n1.Update();
            UpdateTable("^OS0NDS",t,false," FWID=" + sqlTo(tbl0n1.getValue("FWID")));
         }
      }
      else
      {
        alert("Невозможно исправить дату приемки в справочн.измен.НДС для инв.№" + HINVN.value + "\nПроизведите данные изменения вручную");
        fis_updos0n = false;
      }
      tbl0n1.close();
   }
   
  	if (fis_updos0)
  	{
  		//если есть признак исключения из налогового учета, то проставляем нулевую группу
	    if(toScrObj(HIS_BUHONLY.value))
	    	m0.fgroup = 0;
  		UpdateTable("^OS0",m0,flagos0,strSQL1);
  	}
	if (fis_updos0b) UpdateTable("^OS0b",m0b,flagos0b,strSQL2);
	if (fis_updper)  UpdateTable("^VN_PEREM",perem,flagperem,strSQL3);	   	  		
}

function mam_valid() 
{
	if(dt > HDAT.value || FNEM.getValue() == "nemat" || FNEM.getValue() == "neproizv")
        omam.blurCtrl();
}

function mFcodsrok_valid() 
{
   osrok.blurCtrl2();
   if (differ(new Date(HDAT.value),dat2011)>=0){   
   		HSROC.value = osrok.getSrok();
   		HGRS.value = osrok.getGroup();   		
	}	   
}

function mgroup_valid() 
{
   if (differ(new Date(dt),new Date(HDAT.value))<=0 && FNEM.getValue() == "proizv")
   {
      ogroup.setCod(HGR.value, javaDate2Script(HDAT.value),javaDate2Script(HDAT.value));
      ogroup.blurCtrl();
   }
}

function mgroupb_valid()
{
    ogroupb.setCod(HGRB.value, javaDate2Script(HDAT.value),javaDate2Script(HDAT.value));	
	ogroupb.blurCtrl();
	
}

function FDOC_DAT_valid() 
{
    var docdt = javaDate2Script(HDAT.value);
    if (docdt.getYear()==d00obj.getYear() && docdt.getMonth()==d00obj.getMonth() && docdt.getDate()==d00obj.getDate())
       return false;

    if (differ(new Date(HDAT.value),new Date(dtn2011))<0){
    	Enable(HCODSROK);
    	Enable(HSROC);
       	Enable(HGRS);    	
    	if(javaDate2Script(HDAT.value) <dt || FNEM.getValue() == "nemat" || FNEM.getValue() == "neproizv")
    	{
    		Disable(HGR);
    		Enable(HNRATE);
    	}
    	else
    	{
    		Enable(HGR);
    		Disable(HNRATE);
    	}	
    }else{
    	//Disable(HCODSROK);
    	//Disable(HSROC);
		Disable(HGR);    
		Disable(HNRATE);		
    }
    if (differ(new Date(HDAT.value),new Date(dat2011))>=0){
		Disable(HGRB);    	
    }else{
		Enable(HGRB);    	
    }	
    return true;
}

function mFnds_valid()
{
   if (buhnds==false)
   {
      HNDS.value = round(Number(HPRICE.value)*Number(procnds)/100,2)
   }
   else
   {
      HNDS.value = round(Number(HPRICEB.value)*Number(procnds)/100,2)
   }
}

function FNEM_valid() 
{
   if (differ(new Date(objDoc.getVar("HDAT")),dtn2011)<0){	
	   if (FNEM.getValue() == "proizv" || FNEM.getValue() == "nemat4")
	   {
		   Enable(HGR);
		   Disable(HNRATE);
		   //HNRATE.value=0;
	   }
	   else
	   {
		   Disable(HGR);
		   Enable(HNRATE);
		   if (FNEM.getValue() == "nemat")
			   HGR.value = 6;
		   else
			   HGR.value = 7;
		   //HNRATE.value = objDoc.getVar("HNRATE")
	   }   
   }
}



include("sys\\DpBaseDlg.js");