include("Objects/DpGetDat.js");
include("Objects/DpAskEx.js");
include("doc/DpDoc.js");
include("servis/date.js");

include ("izosdat.js");
include ("izvnprdt.js");
include ("izosdatb.js");
include ("riznosb.js");
include ("riznosbp.js");
include ("r_baliz2.js");
include ("r_balizn.js");
include ("r_balnac.js");
include ("r_balnam.js");
include ("firstkv.js");
include ("lastkv.js");
include ("izgr_dat.js");
include ("oss_dati.js");
include ("calc_os.js");
include ("riznos.js");
include ("riznnds.js");
include ("r_balnds.js");

var objDoc = extPar.doc;
var dat;
var m_Nop;
var oSnap;
var cdat2;
var sWhere

var tblSrcName = (getPar("__BUHUCH")?"^LISTDOCSO7B":"^LISTDOCSO7");

function docSrc()
{
	gd = new Object;	
	if (typeof(DOC) != "undefined" && typeOf(DOC) == "DpTextEx")
	{
		DATB.value = d00min;
		DATB.setEnabled(false);
		gd.dat2 = DATE.value;
	}
	else
	{
		gd = new DpGetDat("D");	
		if (gd.escape) return false;
		dat = gd.dat2;
	}
	
	
	
	cdat2 = sqlTo(gd.dat2);
	cd00 = sqlTo(d00);
	
	m_Nop = extPar.nop;
	
	/*
	if (!getPar("__BUHUCH"))
				{
					
					strSQL = "^OS7 a "
								+ ", ^OS0 as b"
								+ ", ^VN_PEREM as c";
									
				}
				else
				{
					strSQL = "^OS7 a "
								+ ", ^OS0b as b"
								+ ", ^VN_PEREM as c";
					
					
					
					}                           
					
	var sWhere = "a.Fdoc= 'O7'"
								+ sqlw0And("a.Fnop=", m_Nop)
								+ " AND a.Fdoc_dat<=" + cdat2
									+ " and ((a.Fdat_vib>="+cdat2
										+ " and a.Fdat_vib<>"+cd00+")"
									+ " or a.Fdat_vib="+cd00
									+ ")"
								+ " AND (a.Finv_num=b.Finv_num"
									+ " AND a.Finv_num=c.Finv_num"
									+ " AND (b.Fbdat<="+cdat2
										+ "and b.Fedat>="+cdat2
									+ ")"
									+ " AND (c.Fbdat<="+cdat2
									+ " AND c.Fedat>="+cdat2+"))"
	if (extPar && extPar.fid_doc)
	{
		sWhere += "  AND a.FWID = " + extPar.fid_doc;
	}
	
	this.qrySet(	"Fields", "a.*"
								+ ", b.Forig_pric AS Fcurpric"
								+ ", b.Fgroup as Fcurgroup"
								+ ", b.Farend as Fcurarend"
								+ ", b.Fiznos as Fcuriznos"
								+ ", b.Fdb_sc as Fcurdsc"
								+ ", b.Fdb_su as Fcurdsu"
								+ ", b.Fdb_st as Fcurdst"
								+ ", b.Fdb_cod1 as Fcurdan1"
								+ ", b.Fdb_cod2 as Fcurdan2"
								+ ", b.Fdb_cod3 as Fcurdan3"
								+ ", b.Fcr_sc as Fcurcsc"
								+ ", b.Fcr_su as Fcurcsu"
								+ ", b.Fcr_st as Fcurcst"
								+ ", b.Fcr_cod1 as Fcurcan1"
								+ ", b.Fcr_cod2 as Fcurcan2"
								+ ", b.Fcr_cod3 as Fcurcan3"
								+ ", b.Fcod_rate as Fcurcrate"
								+ ", b.Fkol as Fcurkol"
								+ ", b.Forig_all as Fcurorigall"
								+ ", c.Fpodr, c.Ftabn"
								+ ", c.Fsc, c.Fsu, c.Fst"
								+ ", c.Fcl_cod1",
					"From",strSQL,
					"Order", "a.Finv_num",
					"Where", sWhere,
					"Alias", "a"
					);
	this.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	*/
		
	sWhere = "Fdoc= 'O7'"
				+ sqlw0And("Fnop=", m_Nop)
				+ " AND Fdoc_dat<=" + cdat2
					+ " and ((Fdat_vib>="+cdat2
						+ " and Fdat_vib<>"+cd00+")"
					+ " or Fdat_vib="+cd00
					+ ")"
					+ " AND (Fbdat1<="+cdat2
						+ "and Fedat1>="+cdat2
						+ " AND (Fbdat2<="+cdat2
						+ " AND Fedat2>="+cdat2
					+"))";
	
	if(extPar && extPar.fid_doc)
	{
		sWhere += " AND FWID = " + extPar.fid_doc;
	}
	
	this.qrySet("From", tblSrcName
				, "Order", "Finv_num"
				, "Where", sWhere
				);	
	
}

function docInit()
{
	//групируем визуально комплекты
	grid.setFilling("=^FKOMPL>0?^FKOMPL:^FWID");
}

function docMenuInit()
{
	this.dataSrc.AddMenuItem("", "");
	this.dataSrc.AddMenuItem(18,"Зміни вартості по п/о|Изменение стоимости по н/у");
	this.dataSrc.AddMenuItem(40,"Зміни вартості по б/о|Изменение стоимости по б/у");
	this.dataSrc.AddMenuItem(19,"Внутрішні переміщення|Внутренние перемещения");
	if(this.tbl.getValue("Finv_num")!=this.tbl.getValue("Fkompl"))
	{
		this.dataSrc.AddMenuItem(12,"Складові частини|Составные части");
		this.dataSrc.AddMenuItem(13,"Дорог.метали|Драг.металлы ");
		this.dataSrc.AddMenuItem(45,"Ремонти по б/о|Ремонты по б/у");
		this.dataSrc.AddMenuItem(46,"Змiни ПДВ для амортиз.ПДВ|Изменения НДС для аморт.НДС");
		this.dataSrc.AddMenuItem(24,"Ліквідація|Ликвидация");
		this.dataSrc.AddMenuItem("LIKV_MASS","Ліквідація (за відміченими записами)|Ликвидация (по отмеченным записям)");
	   	this.dataSrc.AddMenuItem("MPEREM","Масове перемiщення ОЗ|Массовое перемещение ОС");
	   	this.dataSrc.AddMenuItem("PRTREM","Друк списку з ремонтами|Печать списка с ремонтами");
	}
   	if(grid.selectedCount>1)
		this.dataSrc.AddMenuItem("GROUP_KMPL","Об'єднати в комплект|Объеденить в комплект");
	if(this.tbl.getValue("Fkompl")>0)
		this.dataSrc.AddMenuItem("UNGROUP_KMPL","Вилучити комплект|Удалить комплект");
	this.dataSrc.AddMenuItem("","");
	if(tblSrcName != "TMP_OS7_SRC")
		this.dataSrc.AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты");
	else
		this.dataSrc.AddMenuItem("MIN_KMPL", "Згорнути комплекти|Свернуть комплекты",ICON_RADIO);
	if(tblSrcName == "TMP_OS7_SRC")
		this.dataSrc.AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты");
	else
		this.dataSrc.AddMenuItem("MAX_KMPL", "Розгорнути комплекти|Развернуть комплекты",ICON_RADIO);
	this.dataSrc.AddMenuItem(47,"Масова замiна груп та терм.вик.в б/о|Мас.замена групп и сроков службы в б/у");
	this.dataSrc.AddMenuItem(49,"Масове проставл.лікв.варт.|Мас.прост.ликв.стоим.");	
	this.dataSrc.AddMenuItem("","");
}

function docMenuHandler(nID)
{
	var par = new Object();
	if(nID==12)
	{
		par.Inv_num = this.tbl.getValue("Finv_num");
		showWindow("l_detali.js",SW_NOMODAL,par,"");
	}
	if(nID==13)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		showWindow("l_metali.js",SW_NOMODAL,par,"");
	}
	if(nID==18)
	{
		par.Inv_num = this.tbl.getValue("Finv_num");
		if(this.tbl.getValue("Finv_num")==this.tbl.getValue("Fkompl"))
			par.isKompl = true;
		else
			par.isKompl = false;
		showWindow("l_os0i.js",SW_NOMODAL,par,"");
	}
	if(nID==40)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		if(this.tbl.getValue("Finv_num")==this.tbl.getValue("Fkompl"))
			par.isKompl = true;
		else
			par.isKompl = false;
		showWindow("l_os0ib.js",SW_NOMODAL,par,"");
	}
	if (nID == 45)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		showWindow("l_sremi.js",SW_NOMODAL,par,"");
	}
	if (nID == 46)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		showWindow("l_sndsi.js",SW_NOMODAL,par,"");
	}
	if (nID == 47)
	{
		var dt2011  = getPar("UOSDAT2011");
		
		var codm=0;
		codm = input("Введите номер группы для отмеч.записей", "", 0, 3);
		if (codm==null)
				return false;

		var tsrok=0;
		tsrok = input("Введите срок службы для указанной ранее группы в месяцах", "", 0, 6,2);
		if (tsrok==null)
   				return false;
		
		var xos7 = OpenTable("s", "select * from ^OS7 where Fwid "+grid.sqlSelected(true))  
		while (!xos7.IsEOF()){
			  ExecuteSQL("update ^OS0B set Fgroup="+sqlTo(codm)+", Fsrokadd="+sqlTo(tsrok )+" where Fbuhmetod=8 and Finv_num="+sqlTo(Number(xos7.getValue("Finv_num")))+" and Fbdat>="+sqlTo(new Date(dt2011)))
		      xos7.MoveNext();
		}
	    xos7.close();
	}

	if (nID == 49)
	{
		var codm=0;
		codm = input("Введите ликвидационную стоимость", "", 0, 12,2);
		if (codm==null)
				return false;

		var xos7 = OpenTable("s", "select * from ^OS7 where Fwid "+grid.sqlSelected(true))  
		while (!xos7.IsEOF()){
			  ExecuteSQL("update ^OS1 set Flikvst="+sqlTo(codm)+", Fkollikv=Fkol where Finv_num="+sqlTo(Number(xos7.getValue("Finv_num"))))
			  ExecuteSQL("update ^OS7 set Flikvst="+sqlTo(codm)+", Fkollikv=Fkol where Finv_num="+sqlTo(Number(xos7.getValue("Finv_num"))))			  
		      xos7.MoveNext();
		}
	    xos7.close();
	}
	
	if(nID==19)
	{
		par.Inv_num=this.tbl.getValue("Finv_num");
		if(this.tbl.getValue("Finv_num")==this.tbl.getValue("Fkompl"))
			par.isKompl = true;
		else
			par.isKompl = false;
		showWindow("l_vnpri.js",SW_NOMODAL,par,"");		
	}
	if(nID==24)
	{	
		//par.mode = "ADD";
	//	par.doc = extPar.doc;
	//	par.nop      = extPar.nop;
		par.fwid = this.tbl.getValue("Fwid");
		//par.dat1 = dat;
		//par.dat2 = null;
		//par.Fpost    = this.tbl.getValue("Fpost")
		//par.Fdoc_dat = this.tbl.getValue("Fdoc_dat")
		include("doc\\DpDoc.js");
		include("Objects\\dpNop.js");
		var znop = new DpNop(0,"O4");
		//znop.setCod(0);
       	o4nop = znop.getCod();
       
       	znop.zSetCod(o4nop,"O4");
       	o4nop = znop.getCod();
       	      	
       	var doc4  = new DpDoc("O4",o4nop);
		
		doc4.edit("ADD",null,par);
		this.tbl.requery();
		grid.refresh();
		
		
		
		//FindFwidForDelete(this.tbl);
		//showWindow( "docs\\O4\\form.xml",SW_MODAL,par);
	/*	t1.requery();
		if(!t1.findFirst("Fwid=" + sqlToFind(par.fwid)) &&
			!t1.findFirst("Fwid=" + sqlToFind(_retArray["FWID"])) &&
			!t1.isEmpty())
			t1.moveFirst();
		
		return;*/
	}
	if(nID == "LIKV_MASS")
	{
		var oAsk = new DpAskEx();
		oAsk.add("D","Дата ліквідації|Дата ликвидации","dat",today);
		oAsk.add("CL_LNK", "Папка ліквідації|Папка ликвидации", "nop", "O4", "'O4'");
		oAsk.add("COMBO", "Причина ліквідації|Причина ликвидации", "reason", 1, "Реализация|Ликв.,кап.рем.,рек., консерв.|Вын.замена без комп.|Вын.замена с комп.");
		oAsk.doAsk();
		if(oAsk.escape)
			return false;
		var dat = oAsk.get("dat");
		var nop = oAsk.get("nop");
		var reason = oAsk.get("reason");
		var buhuch = getPar("__BUHUCH");
		var tbl7 = OpenTable("select * from ^os7 where Fwid "+DataSource().sqlSelected(true));
		setProgressRange(1, tbl7.rowCount);
		for(; !tbl7.IsEOF(); tbl7.MoveNext())
		{
			var finv_num = Number(tbl7.getValue("Finv_num"));
			setProgressPos(tbl7.bookmark, ru("Ликвидация инвентарного номера ","Ліквідація інвентарного номера ")+finv_num);
			var oDoc = new DpDoc("O4",nop.getNop());
			oDoc.setVar("HDAT", dat);
			oDoc.setVar("HNOP", nop.getNop());
			oDoc.setVar("HPR_V", reason);
			oDoc.setVar("HINVN", finv_num);
			
			var mFdat_post = new Date(tbl7.getValue("Fdoc_dat"));
			oDoc.setVar("HDPOST",mFdat_post.getVarDate());
			//oDoc.setVar("HKOL", buhuch?Number(izosdatb(new Date(dat), finv_num, "kol")):Number(izosdat(new Date(dat), finv_num, "kol")));
			oDoc.setVar("HPRICE", Number(izosdat(new Date(dat), finv_num, "orig_pric")));
			oDoc.setVar("HPRICEB", Number(izosdatb(new Date(dat), finv_num, "orig_pric")));
			oDoc.setVar("HDS", buhuch?izosdatb(new Date(dat), finv_num, "db_sc"):izosdat(new Date(dat), finv_num, "db_sc"));
			oDoc.setVar("HDU", buhuch?izosdatb(new Date(dat), finv_num, "db_su"):izosdat(new Date(dat), finv_num, "db_su"));
			oDoc.setVar("HDT", buhuch?izosdatb(new Date(dat), finv_num, "db_st"):izosdat(new Date(dat), finv_num, "db_st"));
			oDoc.setVar("HDCOD1", buhuch?izosdatb(new Date(dat), finv_num, "db_cod1"):izosdat(new Date(dat), finv_num, "db_cod1"));
			oDoc.setVar("HDCOD2", buhuch?izosdatb(new Date(dat), finv_num, "db_cod2"):izosdat(new Date(dat), finv_num, "db_cod2"));
			oDoc.setVar("HDCOD3", buhuch?izosdatb(new Date(dat), finv_num, "db_cod3"):izosdat(new Date(dat), finv_num, "db_cod3"));
			oDoc.setVar("HCS", buhuch?izosdatb(new Date(dat), finv_num, "cr_sc"):izosdat(new Date(dat), finv_num, "cr_sc"));
			oDoc.setVar("HCU", buhuch?izosdatb(new Date(dat), finv_num, "cr_su"):izosdat(new Date(dat), finv_num, "cr_su"));
			oDoc.setVar("HCT", buhuch?izosdatb(new Date(dat), finv_num, "cr_st"):izosdat(new Date(dat), finv_num, "cr_st"));
			oDoc.setVar("HCCOD1", buhuch?izosdatb(new Date(dat), finv_num, "cr_cod1"):izosdat(new Date(dat), finv_num, "cr_cod1"));
			oDoc.setVar("HCCOD2", buhuch?izosdatb(new Date(dat), finv_num, "cr_cod2"):izosdat(new Date(dat), finv_num, "cr_cod2"));
			oDoc.setVar("HCCOD3", buhuch?izosdatb(new Date(dat), finv_num, "cr_cod3"):izosdat(new Date(dat), finv_num, "cr_cod3"));
			oDoc.setVar("HZC", izvnprdt(new Date(dat), finv_num, "sc"));
			oDoc.setVar("HZU", izvnprdt(new Date(dat), finv_num, "su"));
			oDoc.setVar("HZT", izvnprdt(new Date(dat), finv_num, "st"));
			oDoc.setVar("HZCOD1", izvnprdt(new Date(dat), finv_num, "cl_cod1"));
			oDoc.setVar("HZCOD2", izvnprdt(new Date(dat), finv_num, "cl_cod2"));
			oDoc.setVar("HZCOD3", izvnprdt(new Date(dat), finv_num, "cl_cod3"));
			oDoc.setVar("HPDR", izvnprdt(new Date(dat), finv_num, "podr"));
			oDoc.setVar("HMOL", izvnprdt(new Date(dat), finv_num, "tabn"));
			oDoc.setVar("HAREND", tbl7.getValue("Farend"));
			oDoc.setVar("HNEM", tbl7.getValue("Fnemat"));
			oDoc.setVar("HNEPR", tbl7.getValue("Fneproizv"));
			var mnemat   = tbl7.getValue("Fnemat")=="+";
			var mproizv  = tbl7.getValue("Fneproizv")=="+";
			var mneproizv= tbl7.getValue("Fneproizv")!="+";
			oDoc.setVar("HGR", Number(izosdat(new Date(dat), finv_num, "group")));
			oDoc.setVar("HGRB", Number(izosdatb(new Date(dat), finv_num, "group")));
			oDoc.setVar("HNRATE", izosdat(new Date(dat), finv_num, "cod_rate"));
			oDoc.setVar("HVIDOS", tbl7.getValue("Fvidos"));
			oDoc.setVar("HVVOD", tbl7.getValue("Fvvod_ecsp"));
			oDoc.setVar("HGOD", tbl7.getValue("Fgod_vip"));
			oDoc.setVar("HNDSAM", Number(izosdatb(new Date(dat), finv_num, "orig_pric", "OS0NDS")));
			oDoc.setVar("HSTORNO","-");
			var pFall_licv  = "+";
			oDoc.setVar("HALL_LIK",pFall_licv);
			var dtn2011  = new Date(2011,3,1);
			var dat2011  = getPar("UOSDAT2011");
			var datNewAm = new Date(1997,6,1);
			var m__datper = new Date(getPar("__DATPER"));
			var nummet = izosdatb(new Date(dat), finv_num, "buhmetod")
			if (nummet==0 || nummet==null)
				var numbuh = Number(getPar("NUMBUH"));
			else
				var numbuh = Number(izosdatb(new Date(dat), finv_num, "buhmetod"));
			
			//>>>>mFkol_onblur
			var HDAT1 = new Date(dat);
			var HDAT_1 = goDay(HDAT1, -1);
			var tdt = differ(HDAT_1,mFdat_post)<0?HDAT1:HDAT_1;
			if (buhuch==false)
				oDoc.setVar("HKOL", Number(izosdat(tdt, finv_num, "kol")));
			else
				oDoc.setVar("HKOL", Number(izosdatb(tdt, finv_num, "kol")));
			var firstdat = new Date(new Date(HDAT1.getFullYear(),HDAT1.getMonth(),1));
			var firstdat_1 = goDay(firstdat, -1);
			if (differ(firstdat,m__datper)==0)
				var rxFkolb = Number(izosdatb(firstdat, finv_num, "kol"))
			else
				var rxFkolb = Number(izosdatb(firstdat_1, finv_num, "kol"))
			rFkolb = Number(izosdatb(tdt, finv_num, "kol"));  
			rFkol = oDoc.getVar("HKOL");
			//<<<<mFkol_onblur
			
			//>>>>mFkolvl_onblur
	 		if (oDoc.getVar("HKOL") == 0)
	 		{
	 			var rForig_pric = Number(izosdat(HDAT_1, finv_num, "orig_pric"))
	 			var rForig_buh  = Number(izosdatb(HDAT_1, finv_num, "orig_pric"))
	 			var rFndsam			 = Number(izosdatb(HDAT_1, finv_num, "orig_pric", "OS0NDS"))									
	 		}
	 		else
	 		{
	 			oDoc.setVar("HPRICE",Number(izosdat(HDAT_1, finv_num, "orig_pric")));
	 			var rForig_pric	= Number(izosdat(HDAT_1, finv_num, "orig_pric"))
	 			oDoc.setVar("HPRICEB",Number(izosdatb(HDAT_1, finv_num, "orig_pric")));
	 			var rForig_buh	= Number(izosdatb(HDAT_1, finv_num, "orig_pric"))
	 			oDoc.setVar("HNDSAM",Number(izosdatb(dat, finv_num, "orig_pric", "OS0NDS")));
	 			var rFndsam		= Number(izosdatb(dat, finv_num, "orig_pric", "OS0NDS"))
	 		}
			//<<<<mFkolvl_onblur
			
			//>>>>mFsum_real_onblur
			var dFdoc_dat = new Date(dat);
			var dfFdoc_dat =  new Date(new Date(dFdoc_dat.getFullYear(), dFdoc_dat.getMonth(), 1));
			var dfFdoc_dat_1 =  new Date(goDay(dFdoc_dat,-1));
			if (differ(dfFdoc_dat,m__datper)==0)
			{
				var rForig_prb = Number(izosdatb(dfFdoc_dat, finv_num, "orig_pric"))
				var rFkolb = Number(izosdat (dfFdoc_dat, finv_num, "kol"))
				var rFndsb = Number(izosdat (dfFdoc_dat, finv_num, "orig_pric", "OS0NDS"))			  
			}
			else
			{
				var rForig_prb = Number(izosdatb(dfFdoc_dat_1, finv_num, "orig_pric"))
				var rFkolb = Number(izosdat (dfFdoc_dat_1, finv_num, "kol"))
				var rFndsb = Number(izosdat (dfFdoc_dat_1, finv_num, "orig_pric", "OS0NDS"))			  
			}
			var pHDAT_1 = new Date(goDay(d00obj,-1));
			
			if (differ(new Date(dat),dtn2011)<0)
			{	
				if (differ(new Date(dat),datNewAm)<0 || (mnemat==true && mneproizv==true) || mneproizv==true)
				{
					oDoc.setVar("HSREAL",0);
					oDoc.setVar("HBALRSCH",0);
				}
				else
				{
					var mgroup = izosdat(new Date(dat), finv_num, "group");
					mFbdat  = new Date(izosdat(new Date(today), finv_num, "bdat"));
					mFbdat_1 = new Date(goDay(mFbdat,-1));
					pFgroup = izosdat(mFbdat_1, finv_num, "group");
					if (mgroup==0 && pFgroup!=2 && pFgroup!=3 && pFgroup!=4 && pFgroup!=5  && pFgroup!=12 && pFgroup!=13 && pFgroup!=14 && pFgroup!=15)
					{
						//return true;
					}
					else
					{
						if (mgroup == 0 && (pFgroup==2 || pFgroup==3 || pFgroup==4 || pFgroup==5 || pFgroup==12 || pFgroup==13 || pFgroup==14 || pFgroup==15))
						{
							oDoc.setVar("HSREAL",izosdat(new Date(dat), finv_num, "orig_pric")-izosdat(new Date(dat), finv_num, "iznos"));
						}
						if (mgroup==-100)
						{
							WAIT(ru("Нет записи в списке изм.стоим.для инв.№","Немає запису в списку змін варт.для інв.№")+finv_num);
							mgroup = 0;
						}
						if (mgroup!=6 && mgroup!=1 && mgroup!=11 && mgroup!=0 && mgroup!=7)
						{
							oDoc.setVar("HSREAL",r_balizn("BAL",new Date(dat), finv_num, mFdat_post));
							oDoc.setVar("HBALRSCH", oDoc.getVar("HSREAL"));
						}
					}
				}
			}
			//<<<<mFsum_real_onblur
			
			//>>>>mFizn_likv_onblur
			var Iznforwrite = 0;
			if (differ(new Date(dat),dtn2011)<0)
			{	
				var	mdat_am = new Date(new Date(dat).getFullYear(),new Date(dat).getMonth(),1)
				if (differ(new Date(dat),datNewAm)<0 || (mnemat==true && mneproizv==true)|| mneproizv==true)
					oDoc.setVar("HLIZN",riznos(mdat_am, finv_num));						 
				else
					oDoc.setVar("HLIZN",0);
				var pFLIZN = oDoc.getVar("HLIZN");
				if (oDoc.getVar("HKOL")!=rxFkolb && oDoc.getVar("HKOL")!=0)
					oDoc.setVar("HLIZN",round((pFLIZN*oDoc.getVar("HKOL"))/rFkol,2));
				Iznforwrite = pFLIZN - oDoc.getVar("HLIZN");
			}
			else
			{
				dFdoc_dat = new Date(dat);
				dfFdoc_dat =  new Date(dFdoc_dat.getFullYear(), dFdoc_dat.getMonth(), 1);
				nnummet = izosdat(dfFdoc_dat, finv_num, "buhmetod")
				if (nnummet==0 || nnummet==null)
					nnumbuh = getPar("NUMBUH");
				else
					nnumbuh = izosdat(dfFdoc_dat, finv_num, "buhmetod");
				if (nnumbuh==8)
				{
					var xFtypersc = izosdat(dfFdoc_dat, finv_num, "typersc")  
					if (xFtypersc==1)
							  			oDoc.setVar("HLIZN",riznosbp(dfFdoc_dat, finv_num, mFdat_post,"IZN","NP"));
					if (xFtypersc==2)
						oDoc.setVar("HLIZN",riznosbp(dfFdoc_dat, finv_num, mFdat_post,"IZN","NB"));
					if (xFtypersc==3)
						oDoc.setVar("HLIZN",riznosbp(dfFdoc_dat, finv_num, mFdat_post,"IZN","NS"));							  
				}
			}
			//<<<<mFizn_likv_onblur
			
			//>>>>mFsum_bal_onblur
			if (differ(new Date(dat),dtn2011)<0)
			{	
				if (new Date(dat) < datNewAm || mnemat==true || mneproizv==true)
					oDoc.setVar("HSBAL",0);
				else
				{
					var mgroup = izosdat(new Date(dat), finv_num, "group");
					mFbdat  = new Date(izosdat(new Date(today), finv_num, "bdat"));
					mFbdat_1 = goDay(mFbdat, -1);
					pFgroup = izosdat(mFbdat_1, finv_num, "group");
					if (mgroup==0 && pFgroup!=1 && pFgroup!=11)
					{
						//return true;
					}
					else
					{
						if (mgroup==0 && (pFgroup==1 || pFgroup==11))
						{
							oDoc.setVar("HSBAL",izosdat(new Date(dat), finv_num, "orig_pric")-izosdat(new Date(dat), finv_num, "iznos"));
						}
						if (mgroup==-100)
						{
							WAIT(ru("Нет записи в списке изм.стоим.для инв.№","Немає запису в списку змін варт.для інв.№")+finv_num);
							mgroup = 0;
						}
						if (mgroup==1 || mgroup==11)
							oDoc.setVar("HSBAL",r_balizn("BAL",new Date(dat), finv_num, mFdat_post));
						else
							oDoc.setVar("HSBAL",0);
					}
				}
			}
			//<<<<mFsum_bal_onblur
			
			//>>>>mFizn_buh_onblur
			dFdoc_dat =  new Date(dat);
			dfFdoc_dat =  new Date(new Date(dFdoc_dat.getFullYear(), dFdoc_dat.getMonth(), 1));
			if (numbuh==1 || numbuh==5 || numbuh==6 || numbuh==7)
				oDoc.setVar("HIZNBUH",riznosb(dfFdoc_dat, finv_num, mFdat_post, "IZN"));
			if (numbuh==2)
				oDoc.setVar("HIZNBUH",riznosbp(dfFdoc_dat, finv_num, mFdat_post, "IZN"));
			if (numbuh==8)
			{
				var xFtypersc = izosdatb(dfFdoc_dat, finv_num, "typersc");
				if (xFtypersc==1)
					oDoc.setVar("HIZNBUH",riznosbp(dfFdoc_dat, finv_num, mFdat_post, "IZN", "BP"));
				if (xFtypersc==2)
					oDoc.setVar("HIZNBUH",riznosbp(dfFdoc_dat, finv_num, mFdat_post, "IZN", "BB"));
				if (xFtypersc==3)
					oDoc.setVar("HIZNBUH",riznosbp(dfFdoc_dat, finv_num, mFdat_post, "IZN", "BS"));
			}
			if (numbuh==3)
				oDoc.setVar("HIZNBUH",r_balnam("BAL",new Date(dat), finv_num, mFdat_post));
			if (numbuh==4)
				oDoc.setVar("HIZNBUH",r_balnac("BAL",new Date(dat), finv_num, mFdat_post));
			pFizn_buh = oDoc.getVar("HIZNBUH");
			if (numbuh==1 || numbuh==2 || numbuh==8 || numbuh==5 || numbuh==6 || numbuh==7)
			{
				if (Number(oDoc.getVar("HKOL")) != rxFkolb && Number(oDoc.getVar("HKOL")) != 0)
					oDoc.setVar("HIZNBUH",round(pFizn_buh*round(Number(oDoc.getVar("HKOL"))/rxFkolb,5),2));
			}
			else
			{   	
				if (Number(oDoc.getVar("HKOL")) != rFkolb && Number(oDoc.getVar("HKOL")) != 0)
					oDoc.setVar("HIZNBUH",round(pFizn_buh*round(Number(oDoc.getVar("HKOL"))/rFkolb,5),2));
			}   
			if ((numbuh==3) || (numbuh==4))
			{
				if (numbuh==3)
				{   	
					var mFlikvst  = 0;
					var mFkollikv = 0;
					var mFkolos   = 0;			  		
					gS = getSnap("select Flikvst, Fkollikv from ^OS1 where Finv_num=" + sqlTo(finv_num)); 
					if (gS != null)
					{
						mFlikvst  = Number(gS[0]);
						mFkollikv = Number(gS[1]);
						mFkollikv = (mFkollikv==0)?1:mFkollikv;
						mFkolos   = Number(izosdatb(new Date(dat), finv_num, "kol"));
						mFkolos =  (mFkolos==0)?1:mFkolos			  	
					}
					oDoc.setVar("HIZNBUH",(Number(oDoc.getVar("HPRICEB"))-(mFlikvst*mFkollikv*mFkolos))-Number(oDoc.getVar("HIZNBUH")));   	  	 	
				}
				else
					oDoc.setVar("HIZNBUH",Number(oDoc.getVar("HPRICEB"))-Number(oDoc.getVar("HIZNBUH")));
			}
			if (numbuh==0)
			{
				pFizn_buh = 0;
				oDoc.setVar("HIZNBUH",0);   	
			}
			var Iznforwriteb = 0;
			if (numbuh==1 || numbuh==2 || numbuh==5 || numbuh==6 || numbuh==7  || numbuh==8)   
				Iznforwriteb = pFizn_buh - oDoc.getVar("HIZNBUH");
			//<<<<mFizn_buh_onblur
			var buhnds  = getPar("BUHNDS");
			var procnds = Number(getPar("PROCNDS"));
			//>>>>mFnds_onblur
			var bst = 0;
			if (buhnds==false)
			{
				if (differ(dat,dtn2011)<0)
				{	   
					if (oDoc.getVar("HGR")==1 || oDoc.getVar("HGR")==11)
						bst =  Number(oDoc.getVar("HSBAL"));
					if ((Number(oDoc.getVar("HGR")) >= 2 && Number(oDoc.getVar("HGR")) <= 5) || Number(oDoc.getVar("HGR")) >=9)
						bst = toScrObj((oDoc.getVar("HSREAL")==0)? oDoc.getVar("HBALRSCH") : oDoc.getVar("HSREAL"));
				}
				else
					bst = Number(oDoc.getVar("HPRICE"))-Number(oDoc.getVar("HLIZN"));		   
			}
			else
				bst = Number(oDoc.getVar("HPRICEB")) - Number(oDoc.getVar("HIZNBUH"));
			oDoc.setVar("HNDS",round(bst*procnds/100,2));
			//<<<<mFnds_onblur
			
			//>>>>mFiznnds_onblur
			dFdoc_dat =  new Date(dat);
			dfFdoc_dat =  new Date(dFdoc_dat.getFullYear(), dFdoc_dat.getMonth(), 1);
			if (mnemat==true)
			{
				oDoc.setVar("HIZN_NDS",riznnds(new Date(dat), finv_num, mFdat_post, "IZN"));			  
			}
			else
			{
				var mFgroupn=izosdatb(new Date(dat), finv_num, "group", "OS0NDS");
				oDoc.setVar("HIZN_NDS",r_balnds("IZN", new Date(dat), finv_num, mFdat_post, mFgroupn));
			}
			var pFizn_nds = oDoc.getVar("HIZN_NDS");
			if (mnemat==true)
			{   	
				if (oDoc.getVar("HKOL")!=rxFkolb && oDoc.getVar("HKOL")!=0)
					oDoc.setVar("HIZN_NDS",round((pFizn_nds*oDoc.getVar("HKOL"))/rxFkolb,2));
			}
			else
			{
				if (oDoc.getVar("HKOL")!=rFkolb && oDoc.getVar("HKOL")!=0)
					oDoc.setVar("HIZN_NDS",round((pFizn_nds*oDoc.getVar("HKOL"))/rFkolb,2));
			}   
			var Iznforwriten = 0;
			if (mnemat==true)
				Iznforwriten = pFizn_nds - oDoc.getVar("HIZN_NDS");
			//<<<<mFiznnds_onblur
			
			//>>>>onSave
			HDAT1 = new Date(dat);
			HDAT_1 = goDay(HDAT1,-1);
			var doc7 = new DpDoc("O7",0);
			var gS = getSnap("select Fwid from ^OS7 where Finv_num=" + finv_num);
			if (gS != null)
			{
				doc7.loadByID(gS[0]);	
				doc7.setVar("HDVIB",dat);
				doc7.save(); 
			}
			// Записываем в изменения стоимости
			var strSQL = "select * from ^OS0 where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
			var t = new Object();
			tos0 = OpenTable(strSQL);
			dFdoc_dat = new Date(dat);
			if (!tos0.IsEmpty())
			{
				t.Fedat = dat;
				if ((oDoc.getVar("HBALRSCH")!=0 && oDoc.getVar("HSREAL")==0) || (oDoc.getVar("HBALRSCH")>oDoc.getVar("HSREAL")) )
				{
					t.Forig_pri1 = oDoc.getVar("HPRICE");
					t.Fkol1 = oDoc.getVar("HKOL");
				}
				UpdateTable("^OS0",t,false," Fwid=" + sqlTo(tos0.getValue("Fwid")));
			}
			tos0.close();
			// Записываем в изменения стоимости для бух.учета
			t = new Object();
			if (numbuh!=3 && numbuh!=4)
			{
				strSQL = "select * from ^OS0B where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
				tos0b = OpenTable(strSQL);
				dFdoc_dat = new Date(dat);
				if (!tos0b.IsEmpty())
				{
					t.Fedat = dat;
					UpdateTable("^OS0B",t,false," Fwid="+sqlTo(tos0b.getValue("Fwid")));
				}
				tos0b.close();
			}
			else
			{
				strSQL = "select * from ^OS0B where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
				tos0b = OpenTable(strSQL);
				dFdoc_dat = new Date(dat);
				if (!tos0b.IsEmpty())
				{
					t.Fedat = dat;
					UpdateTable("^OS0B",t,false," Fwid="+sqlTo(tos0b.getValue("Fwid")));
				}
				tos0b.close();
			}
			// Записываем в изменения стоимости для НДС
			// 6 группа по сроку службы, остальные - налоговый метод
			if (Number(oDoc.getVar("HGRB")) == 6)
			{
				strSQL = "select * from ^OS0NDS where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
				t = new Object();
				tos0n = OpenTable(strSQL);
				dFdoc_dat = new Date(dat);
				if (!tos0n.IsEmpty())
				{
				   	t.Fedat = dat;
					UpdateTable("^OS0NDS",t,false," Fwid="+sqlTo(tos0n.getValue("Fwid")));
				}
				tos0n.close();
			}
			else
			{
				strSQL = "select * from ^OS0NDS where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
				t = new Object();
				tos0n = OpenTable(strSQL);
				dFdoc_dat = new Date(dat);
				if (!tos0n.IsEmpty())
				{
					t.Fedat = dat;
					UpdateTable("^OS0NDS",t,false," Fwid="+sqlTo(tos0n.getValue("Fwid")));
				}
				tos0n.close();
			}
			//Записываем в перемещения
			t = new Object();
			strSQL = "select * from ^VN_PEREM where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
			tvn = OpenTable(strSQL);
			if (!tvn.IsEmpty())
			{
				t.Fedat = HDAT1.getVarDate();
				UpdateTable("^VN_PEREM",t,false," Fwid = " + sqlTo(tvn.getValue("Fwid")));
			}
			tvn.close();
			//Записываем в OS0BREM
			t = new Object();
			strSQL = "select * from ^OS0BREM where Finv_num="+finv_num+" and Fedat="+sqlTo(d00);
			trem = OpenTable(strSQL);
			if (!trem.IsEmpty())
			{
				t.Fedat = HDAT1.getVarDate();
				UpdateTable("^OS0BREM",t,false," Fwid=" + sqlTo(trem.getValue("Fwid")));
			}
			trem.close();
			//<<<<onSave
			oDoc.save();
		}
		setProgressPos(0);
		tbl7.close();
		this.tbl.requery();
		grid.refresh();
		grid.clearSelected();
	}
	if (nID == "MPEREM")
	{
		showWindow("r_osperem.js",SW_NOMODAL);
/*		var D_perem = input(ru("Введите дату передачи ОС","Введіть дату передачі ОЗ"), null, new Date().getVarDate());
		if(D_perem == null)
			return false;
		var nmol = input(ru("Введите таб.№ МОЛ","Введіть таб.№ МВО"), "", 0, 5);
    	if(nmol == null)
			return false;
		var npodr = input(ru("Введите код подр.","Введіть код підр."), "", 0, 5);		
    	if(npodr==null)
			return false;
		var m = new Object();
		var tinvkart = OpenTable("s", " SELECT *"
							+ " FROM ^OS7"
							+ " WHERE " + this.dataSrc.sqlSelected(false));
		if (!tinvkart.IsEmpty())
			tinvkart.MoveFirst();
		while(!tinvkart.IsEOF())
		{
	       	strSQL = "select * from ^VN_PEREM where Finv_num="+sqlTo(tinvkart.getValue("Finv_num"))+" order by Fedat";
    	   	var tvnp  = OpenTable("s",strSQL);
			if (!tvnp.IsEmpty())
			{
				tvnp.MoveFirst();
				mFedat = tvnp.getValue("Fedat");
         
				if (javaDate2Script(mFedat)>=javaDate2Script(D_perem))
				{   
					mFinv_num = tvnp.getValue("Finv_num");   
					mFpodr    = tvnp.getValue("Fpodr");   
					mFsc      = tvnp.getValue("Fsc");   
					mFsu      = tvnp.getValue("Fsu");   
					mFst      = tvnp.getValue("Fst");   
					mFcl1      = tvnp.getValue("Fcl_cod1");   
					mFcl2      = tvnp.getValue("Fcl_cod2");   
					mFcl3      = tvnp.getValue("Fcl_cod3");   
          
					ExecuteSQL("update ^VN_PEREM set Fedat=" + sqlTo(javaDate2Script(javaDate2Script(D_perem)-1).getVarDate()) + " where Fwid =" + sqlTo(tvnp.getValue("Fwid")));
        
					m.Fwid = GetUID();
					m.Finv_num=mFinv_num;
					m.Fpodro=mFpodr;
					m.Fpodr=npodr;
					m.Ftabn=nmol;
					m.Fbdat=javaDate2Script(D_perem).getVarDate();
					m.Fedat=mFedat;
					m.Fsc=mFsc;
					m.Fsu=mFsu;
					m.Fst=mFst;
					m.Fcl_cod1=mFcl1;
					m.Fcl_cod2=mFcl2;
					m.Fcl_cod3=mFcl3;
					//  tvnp.Update();
           
					UpdateTable("^VN_PEREM",m,true);
				} 
			}
			tvnp.close(); 
			tinvkart.MoveNext();
		}
		tinvkart.close()*/
	}
    if (nID == "PRTREM")
    {
		prnName = list.m_Doclabel.toUpperCase();
		include("objects\\DpTVars.js");
		var tv1 = new DpTVars(prnName);

		dat1=javaDate2Script(this.docList.dat1);
		dat2=javaDate2Script(this.docList.dat2);

		tv1.setVar("data", dat1);
		tv1.setVar("bdat", javaDate2Script(new Date(dat1)));
		tv1.setVar("edat", javaDate2Script(new Date(dat2)));
		tv1.setVar("ewrkdat", javaDate2Script(new Date(dat1.getFullYear(), dat1.getMonth()+1, 20)));

		var tabl = OpenTable("s","select * from ^CL_LNK where fdoc = "+sqlTo(list.m_Doclabel)+" and Fnop="+m_Nop);
		var tmp_rem = new Date();
		var beg_rem = input(ru("Введите начало периода","Введіть початок періоду"), null, javaDate2Script(tmp_rem));
		if (!beg_rem)
			return;
		var end_rem = input(ru("Введите конец периода","Введіть кінець періоду"), null, javaDate2Script(tmp_rem));
		if (!end_rem)
			return;
		tblHN = getTmpTableName();
		tblHN2 = getTmpTableName();
		tblHN3 = getTmpTableName();
		strSQL = "SELECT Finv_num, Fvvod_ecsp, Forig_pric, Forig_buh into "+tblHN
				+ " FROM  ^OS7 a WHERE " + DataSource().sqlSelected() + " ORDER BY a.Finv_num, a.Fdoc_dat, a.fdoc_num"  
		ExecuteSQL(strSQL);                                                                   

		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fdtos0b "+SqlType("DATE"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fvdos0b "+SqlType("LONG"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fsmos0b "+SqlType("CURRENCY"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fdtos0r "+SqlType("DATE"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fvdos0r "+SqlType("LONG"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Fsmos0r "+SqlType("CURRENCY"), false);
		ExecuteSQL("ALTER TABLE " + tblHN + " ADD Ftt "+SqlType("LONG"), false);

		strSQL = "select * from ^OS0B where Finv_num in "
					+"(select Finv_num from "+tblHN+") and (Fbdat>="
					+sqlTo(beg_rem)+" and Fbdat<="+sqlTo(end_rem)
					+") order by Finv_num, Fbdat, Fedat";
		tos0b = OpenTable("s", strSQL);

		if (!tos0b.IsEmpty())
		{
			tos0b.MoveFirst();
			while (!tos0b.IsEOF())
			{
				var oSnap = getSnap("SELECT Finv_num FROM "+tblHN+" WHERE Finv_num="+sqlTo(tos0b.getValue("Finv_num"))+" and Fdtos0b is null");
				var m = new Object();
				if (oSnap!=null)
				{
					m.Ftt = 0;
					m.Fdtos0r = javaDate2Script(d00obj);
					m.Fvdos0r = 0;
					m.Fsmos0r = 0;
					prew_dt = new Date(new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getYear()+1900,
								new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getMonth(),
								new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getDate()-1);

					strSQL = "select * from ^OS0B where Finv_num="+sqlTo(tos0b.getValue("Finv_num"))+" and Fedat="+sqlTo(prew_dt);
					tos0b3 = OpenTable("s", strSQL);
					if (!tos0b3.IsEmpty())
					{
						m.Fdtos0b = tos0b.getValue("Fbdat");
						m.Fvdos0b = tos0b.getValue("Ftypeiz");
						m.Fsmos0b = tos0b.getValue("Forig_pric")-tos0b3.getValue("Forig_pric");
					}  
					UpdateTable(tblHN,m,false,"Finv_num="+oSnap[0]);
					tos0b3.close();
				}
				else
				{
					prew_dt = new Date(new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getYear(),
									new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getMonth(),
									new Date(javaDate2Script(tos0b.getValue("Fbdat"))).getDate()-1);
					strSQL = "select * from ^OS0B where Finv_num="+sqlTo(tos0b.getValue("Finv_num"))+" and Fedat="+sqlTo(prew_dt);
					tos0b3 = OpenTable("s", strSQL);

					if (!tos0b3.IsEmpty())
					{
						m.Finv_num = tos0b.getValue("Finv_num");
						m.Ftt = 0;
						m.Fvvod_ecsp = javaDate2Script(d00obj);
						m.Fdtos0b = tos0b.getValue("Fbdat");
						m.Fvdos0b = tos0b.getValue("Ftypeiz");
						m.Fsmos0b = tos0b.getValue("Forig_pric")-tos0b3.getValue("Forig_pric");
						m.Fdtos0r = javaDate2Script(d00obj);
						m.Fvdos0r = 0;
						m.Fsmos0r = 0;
						UpdateTable(tblHN, m, true);
					}
					tos0b3.close();
				}
				tos0b.MoveNext()
			}
		}
		tos0b.close();
		strSQL = "UPDATE "+ tblHN+" set Fdtos0b="+sqlTo(d00obj)+" where Fdtos0b is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Fvdos0b=0 where Fvdos0b is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Fsmos0b=0 where Fsmos0b is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Fdtos0r="+sqlTo(d00obj)+" where Fdtos0r is null";
		ExecuteSQL(strSQL);
		
		strSQL = "select * from ^OS0BREM where Finv_num in (select Finv_num from "
				+tblHN+") and (Fbdat>="+sqlTo(beg_rem)+" and Fbdat<="
				+sqlTo(end_rem)+") order by Finv_num, Fbdat, Fedat";
		tos0r  = OpenTable("s", strSQL);

		if (!tos0r.IsEmpty())
		{
			tos0r.MoveFirst();
			while (!tos0r.IsEOF())
			{
				var oSnap = getSnap("SELECT Finv_num FROM "+tblHN+" WHERE Finv_num="
						+sqlTo(tos0r.getValue("Finv_num"))+" and Fdtos0r="+sqlTo(d00obj));
				var m = new Object();
				if (oSnap!=null)
				{
					m.Fdtos0r = tos0r.getValue("Fbdat");
					m.Fvdos0r = tos0r.getValue("Ftypeiz");
					m.Fsmos0r = tos0r.getValue("Fsum");
					UpdateTable(tblHN, m, false, "Finv_num="+oSnap[0]);
				}
				else
				{
					m.Finv_num = tos0r.getValue("Finv_num");
					m.Fvvod_ecsp = javaDate2Script(d00obj);
					m.Ftt = 0;
					m.Fdtos0r = tos0r.getValue("Fbdat");
					m.Fvdos0r = tos0r.getValue("Ftypeiz");
					m.Fsmos0r = tos0r.getValue("Fsum");
					UpdateTable(tblHN, m, true);
				}
				tos0r.MoveNext();
			}
		}
		tos0r.close();
		strSQL = "UPDATE "+ tblHN+" set Fdtos0r="+sqlTo(d00obj)+" where Fdtos0r is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Fvdos0r=0 where Fvdos0r is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Fsmos0r=0 where Fsmos0r is null";
		ExecuteSQL(strSQL);
		strSQL = "UPDATE "+ tblHN+" set Ftt=0";
		ExecuteSQL(strSQL);

		strSQL = "select Finv_num, "+sqlTo(d00obj)+" as Fvvod_ecsp, Forig_pric, "
				+"Forig_buh, Fdtos0r, Fvdos0r, Fsmos0r, Fdtos0b, "
				+"Fvdos0b, Fsmos0b, 1 as Ftt into "+tblHN2+" from "+tblHN;
		ExecuteSQL(strSQL);

		strSQL = "select 999999 as Finv_num, "+sqlTo(d00obj)+" as Fvvod_ecsp, "
				+"Forig_pric, Forig_buh, Fdtos0r, Fvdos0r, Fsmos0r, Fdtos0b, "
				+"Fvdos0b, Fsmos0b, 2 as Ftt into "+tblHN3+" from "+tblHN;
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO "+tblHN+"  select * from "+tblHN2;
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO "+tblHN+"  select * from "+tblHN3;
		ExecuteSQL(strSQL);

		tos7 = OpenTable("m", "select * from "+tblHN+" order by Finv_num, Ftt, Fdtos0b, Fdtos0r");

		tv1.setHTbl(tabl);
		tabl.close();
		tv1.setRTbl(tos7);
		tos7.close();
		tv1.print();
	}
	if(nID=="GROUP_KMPL")
	{
		t = OpenTable("select s7.Finv_num,n.Finv_nak, s7.Fwid, s1.Fwid as Fwid1, s4.Fwid as Fwid4 "
				+" from ^os1 as s1 inner join ^os7 as s7 on s1.Finv_num=s7.Finv_num "
				+" left join ^os4 as s4 on s4.Finv_num=s1.Finv_num "
				+" left join ^osnazv as n on n.Finv_num=s1.Finv_num "
				+" where s7.Fwid "+grid.sqlSelected(true));
		par = new Object();
		par.tbl = t;
		par.fkompl = 0;
		par.mode = "ADD";
		showWindow("e_kompl.xml",SW_MODAL, par);
		if(par.escape)
			return false;
		fkompl = par.fkompl;
		var o1 = new DpDoc("O1",0);
		var o7 = new DpDoc("O7",0);
		var o4 = new DpDoc("O4",0);
		for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
		{
			o1.clear();
			if(o1.loadByID(t.getValue("Fwid1")))
			{
				o1.setVar("HKOMPL",fkompl);
				o1.save();
				o7.clear();
				if(o7.loadByID(t.getValue("Fwid")))
				{
					o7.setVar("HKOMPL",fkompl);
					o7.save();
				}
				o4.clear();
				if(o4.loadByID(t.getValue("Fwid4")))
				{
					o4.setVar("HKOMPL",fkompl);
					o4.save();
				}
			}
		}
		t.close();
		this.tbl.requery();
		grid.clearSelected();
		grid.refresh();
	}
	if(nID=="UNGROUP_KMPL")
	{
		t1 = OpenTable("select Fwid from ^os1 where Fkompl="+this.tbl.getValue("Fkompl"));
		t4 = OpenTable("select Fwid from ^os4 where Fkompl="+this.tbl.getValue("Fkompl"));
		t7 = OpenTable("select Fwid from ^os7 where Fkompl="+this.tbl.getValue("Fkompl"));
		var o1 = new DpDoc("O1",0);
		var o4 = new DpDoc("O4",0);
		var o7 = new DpDoc("O7",0);
		for(; !t1.IsEOF(); t1.MoveNext())
		{
			o1.clear();
			if(o1.loadByID(t1.getValue("Fwid")))
			{
				o1.setVar("HKOMPL",0);
				o1.save();
			}
		}
		for(; !t4.IsEOF(); t4.MoveNext())
		{
			o4.clear();
			if(o4.loadByID(t4.getValue("Fwid")))
			{
				o4.setVar("HKOMPL",0);
				o4.save();
			}
		}
		for(; !t7.IsEOF(); t7.MoveNext())
		{
			o7.clear();
			if(o7.loadByID(t7.getValue("Fwid")))
			{
				o7.setVar("HKOMPL",0);
				o7.save();
			}
		}
		ExecuteSQL("delete from ^kompl where Fkompl="+this.tbl.getValue("Fkompl"));
		t1.close();
		t4.close();
		t7.close();
		this.tbl.requery();
		grid.clearSelected();
		grid.refresh();
	}
	if(nID == "MIN_KMPL" && tblSrcName != "TMP_OS7_SRC")
	{
		DropTable("TMP_OS7_SRC");
		ExecuteSQL("select * into TMP_OS7_SRC from "+tblSrcName+" where "+this.qryWhere+" and Fkompl=0");
		
		ExecuteSQL("insert into TMP_OS7_SRC (Fwid,Finv_num,Fkompl,Fvvod_ecsp,Fnach_plat,Fdoc_dat,"
					+"Fdat_vib,Fiznos,Forig_all,Forig_pric,Forig_buh,Fiznosb,Fnop,Ftabn,Fpodr,"
					+"Fcurdsc,Fcurdsu,Fcurdst,Fcurdan1,Fcurdan2,Fcurdan3,Fcurcsc,Fcurcsu,Fcurcst,Fcurcan1,"
					+"Fcurcan2,Fcurcan3,Fsc,Fsu,Fst,Fcl_cod1,Fdoc,"
					+"Fbdat1,Fedat1,Fbdat2,Fedat2,Fcurpric,Fcuriznos,Fcurorigall,Fcurkol) "
				+" select MIN(Fwid),Fkompl,Fkompl,MIN(Fvvod_ecsp),MIN(Fnach_plat),MIN(Fdoc_dat),"
					+"MAX(Fdat_vib),SUM(Fiznos),SUM(Forig_all),SUM(Forig_pric),SUM(Forig_buh),SUM(Fiznosb),"
					+"MIN(Fnop),MIN(Ftabn),MIN(Fpodr),MIN(Fcurdsc),MIN(Fcurdsu),MIN(Fcurdst),"
					+"MIN(Fcurdan1),MIN(Fcurdan2),MIN(Fcurdan3),MIN(Fcurcsc),MIN(Fcurcsu),MIN(Fcurcst),"
					+"MIN(Fcurcan1),MIN(Fcurcan2),MIN(Fcurcan3),MIN(Fsc),MIN(Fsu),"
					+"MIN(Fst),MIN(Fcl_cod1),'O7',MIN(Fbdat1),"
					+"MAX(Fedat1),MIN(Fbdat2),MAX(Fedat2),SUM(Fcurpric),SUM(Fcuriznos),SUM(Fcurorigall),MIN(Fcurkol) "
				+" from "+tblSrcName+" where Fkompl>0 group by Fkompl");
		ExecuteSQL("update TMP_OS7_SRC set Ftxt=(select Fnazv from ^kompl as k where TMP_OS7_SRC.Fkompl=k.Fkompl),"
						+" Finv_nak=(select Finv_nak from ^kompl as k where TMP_OS7_SRC.Fkompl=k.Fkompl)"
					+" where Fkompl>0");
		tblSrcName = "TMP_OS7_SRC";
		grid.DeletePages();
		list.init();
	} else
	if(nID == "MAX_KMPL" && tblSrcName == "TMP_OS7_SRC")
	{
		tblSrcName = (getPar("__BUHUCH")?"^LISTDOCSO7B":"^LISTDOCSO7");
		grid.DeletePages();
		list.init();
	}
}

function filterMode(mode)
{
	if(mode == "ADD" || mode == "COPY" || mode == "DEL")
		return false;
	if(list.tbl.getValue("Finv_num") == list.tbl.getValue("Fkompl") && (mode == "EDIT" || mode == "COPY"))
		return false;
	return true;	
}

function getGroupConcat(kompl)
{
	var ret = "";
	var t = OpenTable("select Fcurgroup from "+(getPar("__BUHUCH")?"^LISTDOCSO7B":"^LISTDOCSO7")+" where Fkompl="+kompl+" and "+sWhere);
	for(; !t.IsEOF(); t.MoveNext())
		ret += (t.absolute==1?"":"+")+t.getValue("Fcurgroup");
	t.close();
	return ret;
}