include("Objects/DpDocEx.js");
include("Objects/DpCl.js");

var oRec = null;
var oSender = null;
var objParDocEx;
var objDoc;
var dlg;
var nType = 0;

function Load()
{
	objDoc = extPar.doc;	
	dlg = this;
	nType = Number(objDoc.getPar("_type"));
	
	Caption(UR("Почтова кореспонденція|Почтовая корреспонденция") + ": " + modeName(this.sMode));
				
	objParDocEx = new DpDocEx(objDoc.sDocLbl, objDoc.nNop);
	objParDocEx.linkCtrl(FPARNUM);
	
	oStatus = new DpCl("0", objDoc.getPar("_codstatus"), 0);
	oStatus.linkSmartCtrl(FSTATUS);
	oStatus.setContAssist();
			
	oSender = new DpCl("0", getPar("CODPLAT"), 0);
	oSender.linkSmartCtrl(FSENDER);
	oSender.setContAssist();
	oSender.contact_combo = FCONT_SEND;
	oSender.AfterUpdate = setOrg;
		
	oRec = new DpCl("0", getPar("CODPLAT"), 0);
	oRec.linkSmartCtrl(FRECIPIENT);
	oRec.setContAssist();	
	oRec.contact_combo = FCONT_REC;
	oRec.AfterUpdate = setOrg;
	
	if(nType==0)
		oRec.setClcl(getPar("CODMYORG"));
	else
		oSender.setClcl(getPar("CODMYORG"));
	
	ctrlLinker = new DpCtrlLinker(objDoc);	
	ctrlLinker.addLink("HNOM", FNUM);
	ctrlLinker.addLink("HDAT", FDATE);
	ctrlLinker.addLink("HSENDDATE", FSENDDATE);
	ctrlLinker.addLink("HGAINDATE", FGAINDATE);
	ctrlLinker.addLink("HCAPTION", FCAPTION);	
	ctrlLinker.addLink("HCONT_SEND", FCONT_SEND);
	ctrlLinker.addLink("HCONT_REC", FCONT_REC);
	ctrlLinker.addLink("HCONTENT", FCONTENT);
	ctrlLinker.addLink("HCOMMENT", FCOMMENT);	
	ctrlLinker.addClLink("HSENDER", oSender);
	ctrlLinker.addClLink("HRECIPIENT", oRec);
	ctrlLinker.addClLink("HSTATUS", oStatus);
		
	ctrlLinker.updateData(false);
	
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		oRec.AfterUpdate();
		oSender.AfterUpdate();
		FCONT_SEND.value = objDoc.getVar("HCONT_SEND");
		FCONT_REC.value = objDoc.getVar("HCONT_REC");
		objParDocEx.setFwid(objDoc.getVar("HGRPID"));		
	}
	
	if(nType==0)
	{
		if(extPar.mode=="ADD")
			oRec.setCod(getPar("ORGNOM"));		
		FORG = FSENDER;
		FSENDDATE.value = d00;
		FGAINDATE.value = d00;
	}
	else
	{
		if(extPar.mode=="ADD")
			oSender.setCod(getPar("ORGNOM"));
		FORG = FRECIPIENT;
	}
}

function setOrg()
{
	this.fillContacts = fillContacts;
	this.fillContacts();
	if(dlg.oCntr)
	{
		if(nType==0)
			dlg.oCntr.setOrg(oSender.getCod());
		else
			dlg.oCntr.setOrg(oRec.getCod());
	}
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HGRPID", objParDocEx.fwid);
}

function fillContacts()
{
	var oCtrl = this.contact_combo;
	if(!oCtrl)
		return;
	var cont = Number(oCtrl.value);
	oCtrl.clear();
	oCtrl.addItem("0", "");
	if(!this.getFWID())
		return;
	var tblCont = OpenTable("select * from ^CL_ORGCP where FWID_CL="+ this.getFWID());
	for(; !tblCont.isEOF(); tblCont.MoveNext())
	{
		var contID = tblCont.getValue("FWID");
		var contTxt = tblCont.getValue("FFIO");
		var sPost = tblCont.getValue("FPOST");
		if(String(sPost).trim()!="")
			contTxt += " ("+ sPost +")";
		if(contID && contTxt)
			oCtrl.addItem(contID, contTxt);
	}
	tblCont.close();
	oCtrl.setValue(cont);
}

include("sys/DpBaseDlg.js");