include("Objects\\DpVal.js");
include("Objects\\DpCl.js");
include("sys\\mask.js");
include("Objects\\DpSc.js");
include("Objects\\DpCtrlLinker.js");
include("Objects\\DpRasSc.js");
include("Tmoney.js");
include("doc\\DpDoc.js");
include("Objects\\DpPostRs.js");
include("docs/BNKDC/kekv.js");

var objDoc = extPar.doc;
var param;
var ctrLinker = null;
var oRasSc;
var oRasSc0;
var oVal;
var oOrg;
var oOrg0;
var oSc;
var oSch;
var oSch0;
var m_zntbl;
var ndsproc;
var old_nds;


function Load()
{
	Caption(objDoc.getCaption() + ": " + modeName(extPar.mode));
	
	if(!getPar("SHOW_BNK_COR_SC"))
	{
		LCOR_SCOT.visible = false;
		HCOR_SCOT.visible = false;
		LCOR_SCTO.visible = false;
		HCOR_SCTO.visible = false;
	}
	if(!objDoc.getPar("showSc"))
		GroupSC.setVisible(false);
	
	param = objDoc;
    
   	m_zntbl = extPar.mode=="EDIT" || extPar.mode=="COPY";	
   
   	ctrlLinker = new DpCtrlLinker(objDoc);
   
    ndsproc = Number(objDoc.getPar("__ndsproc"));
    
    HNOM.mask = MASK_DOCNUM;
    HCOT.mask    = MASK_OKPO;
   	HCTO.mask   = MASK_OKPO;
  	HSUM.mask     = MASK_SUM;
   	HNDS.mask     = MASK_SUM;
    
    

	//oRasSc = new DpRasSc(param);
	//oRasSc.linkCtrl(HDBSC, HMFOOT, HBNKOT);
	
	oVal = new DpVal();
   	oVal.linkCtrl(HVAL);

	oOrg = new DpCl("");
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkSmartCtrl(HORG);
	//oOrg.linkCtrl2("Ftxt", HTOT);
	oOrg.linkCtrl2("Fcod_st", HCOT);

	oOrg0 = new DpCl("");
	oOrg0.setClcl(getPar("CODMYORG"));
	oOrg0.linkSmartCtrl(HORG0);
	//oOrg0.linkCtrl2("Ftxt", HTTO);
	oOrg0.linkCtrl2("Fcod_st", HCTO);
	
	
   	oSc = new DpSc("c0utxyz");
   	oSc.linkCtrl(HSC, HSU, HST, HCL1, HCL2, HCL3);
   	
    setValid(HDAT, mFdoc_dat_Valid); 
   	setValid(HNOM, mFdoc_dat_Valid);   
  	setValid(HSUM, FSUM_onblur);
  	setValid(HNDS, FNDS_onblur);
   	
   	
   	ctrlLinker.addLink("HNOM",HNOM);
 	ctrlLinker.addLink("HDAT",HDAT); 
 	//ctrlLinker.addLink("HORG0",HORG0);
 	ctrlLinker.addClLink("HORG",oOrg);
 	ctrlLinker.addClLink("HORG0",oOrg0);
 	ctrlLinker.addClLink("HVAL",oVal);  
 	//ctrlLinker.addLink("HTOT",HTOT); 
 	ctrlLinker.addLink("HCOT",HCOT);
 	ctrlLinker.addLink("HBNKOT",HBNKOT);
 	ctrlLinker.addLink("HDBSC",HDBSC);
 	//ctrlLinker.addLink("HTTO",HTTO);
 	ctrlLinker.addLink("HCTO",HCTO);
 	ctrlLinker.addLink("HBNKTO",HBNKTO);
 	ctrlLinker.addLink("HTOVAR",HTOVAR);            
  	ctrlLinker.addLink("HSUM",HSUM); 
 	ctrlLinker.addLink("HNDS",HNDS);
 	ctrlLinker.addLink("HCRSC",HCRSC);
   	ctrlLinker.addLink("HSC",HSC);
 	ctrlLinker.addLink("HSU",HSU);
 	ctrlLinker.addLink("HST",HST);     
 	ctrlLinker.addLink("HCL1",HCL1);     
 	ctrlLinker.addLink("HCL2",HCL2);     
 	ctrlLinker.addLink("HCL3",HCL3);  
 	ctrlLinker.addLink("HMFOOT",HMFOOT);
 	ctrlLinker.addLink("HMFOTO",HMFOTO);
 	if(getPar("SHOW_BNK_COR_SC"))
	{
		ctrlLinker.addLink("HCOR_SCOT",HCOR_SCOT);
 		ctrlLinker.addLink("HCOR_SCTO",HCOR_SCTO);
	}
 	ctrlLinker.addScLink("HSC", "HSU", "HST", "HCL1", "HCL2", "HCL3", oSc);
 	ctrlLinker.updateData(false);
 		
	Fsum_prop.value=TMoney(HSUM.value);
	FNDS_onblur();
	Disable(Fsum_prop);
   	setValid(HDAT, mHDAT_Valid); 
   	
    if (extPar.mode != "ADD")
   	{
   		oVal.setKurs(objDoc.getVar("HVKURS"));   		
   	}
   	else
   	{
   		if(extPar.org)
   			oOrg.setCod(extPar.org);
   	}
   	
   	oSch = new DpPostRs();
  	oSch.setDpCl(oOrg, true);
   	oSch.linkCtrl(HDBSC, HMFOOT, HBNKOT, HCOR_SCOT);  

 	oSch0 = new DpPostRs();
   	oSch0.setDpCl(oOrg0, true);
    oSch0.linkCtrl(HCRSC, HMFOTO, HBNKTO, HCOR_SCTO);  	
   	
   	if(extPar.mode == "ADD")
	{
		var rsc = objDoc.getPar("__rscnom");
		if(!rsc || rsc==0)
			rsc = getPar("ORSC");
		oOrg0.setCod(getPar("ORGNOM"));				
		oSch0.validCl();
		HCRSC.value = String(rsc);		
	}
	loadKekv();
   	old_nds = Number(HNDS.value);	
}

function mHDAT_Valid() 
{
   return differ(HDAT.value, d00);
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",oVal.getCod());	

	objDoc.setVar("HORG", oOrg.getCod());	   	  		
	objDoc.setVar("HTOT", oOrg.getTxt());	
	objDoc.setVar("HORG0", oOrg0.getCod());	      	  		
	objDoc.setVar("HTTO", oOrg0.getTxt());
	if(extPar.mode == "COPY")
		objDoc.setVar("HID_BV",0);
	saveRows();
}

function checkRowSum()
{
	var retVal = true;
	var hsum = toScrObj(HSUM.getValue());
	var hsum_pdv = toScrObj(HNDS.getValue());
	var rsum = 0;
	var rsum_pdv = 0;
		
	//проверка на наличие грида и на viewerID
	//чтобы удостоверится что это грид строк документа
	if(objTypeOf(grid) == "DpGrid" && /BNKDC_ROW/gi.test(grid.getViewerID()))
	{
		var gridTbl = grid.getTable();
		if(gridTbl.getRowCount() > 0)
		{
			var oSn = getSnap("SELECT SUM(FSUM), SUM(FSUM_PDV) FROM "+gridTbl.getTableName());
			if(oSn && !isEmpty(oSn[0]))
			{
				rsum = toScrObj(oSn[0]);
			}
			
			if(oSn && !isEmpty(oSn[1]))
			{
				rsum_pdv = toScrObj(oSn[1]);
			}			
			
			oSn = null;
			
			retVal = (hsum == rsum && hsum_pdv == rsum_pdv);
		}
	}
	
	if(isSaving() && !retVal)
	{
		var msg = ru("Суммы по документу отличаются от сумм по строкам "
					, "Суми за документом відрізняєтсья від сум по рядкам ");
		msg += hsum!=rsum ? "\n"+ru("СУММА: док. = ", "СУМА: док. = ")+hsum+ru(" итого по строкам = ", " всього по рядкам = ")+rsum:"";
		msg += hsum_pdv!=rsum_pdv ? "\n"+ru("НДС: док. = ", "ПДВ: док. = ")+hsum_pdv+ru(" итого по строкам = ", " всього по рядкам = ")+rsum_pdv:"";
		//HSUM.showErr(msg);
		alert(msg);
	}
	else
	{
		retVal = true;
	}
	
	return retVal;
}

/*
function FNDS_onblur() 
{
	if(ndsproc)
    {
       HNDS.value = round(Number(HSUM.value)*ndsproc/(100+ndsproc),2);
       Disable(HNDS);
    }
    
	if (extPar.mode=="ADD" || extPar.mode=="COPY")
	{
      
      if(HTOVAR.value == "" || HTOVAR.value == ru("Без НДС","Без ПДВ"))
      {
         if (HNDS.value==0)
            HTOVAR.value = ru("Без НДС","Без ПДВ");
         else
            HTOVAR.value = ru("В том числе НДС -" + HNDS.value + " грн.",
               "В тому числi ПДВ -" + HNDS.value + " грн.");
      }
   }
   return true;
}
*/

function FNDS_onactivate()
{
	sHTOVARValue = String(HTOVAR.value);
	old_nds = Number(HNDS.value);
}

 
function FNDS_onblur() 
{
		if(ndsproc)
		{
			//alert(Number(HSUM.value)*ndsproc/(100+ndsproc))
			HNDS.value = round(Number(HSUM.value)*ndsproc/(100+ndsproc),2);
			Disable(HNDS);
		}	
			

		if((!HTOVAR.value || HTOVAR.value=="" || HTOVAR.value == getDefaultTovarText(old_nds)))
		{
			HTOVAR.value = getDefaultTovarText(HNDS.value);
		}
		else if(Number(HNDS.value) != Number(old_nds))
		{
			HTOVAR.value = HTOVAR.value.replace(format("#.00",Number(old_nds)),format("#.00",Number(HNDS.value))).replace(format("#,00",Number(old_nds)),format("#,00",Number(HNDS.value)));
		}
		old_nds = Number(HNDS.value);
		return true;
}

function getDefaultTovarText(nds)
{
	nds == Number(nds);
	var ret = "";
	if (nds==0)
		ret =ru("Без НДС","Без ПДВ");
	else
		ret = ru("В том числе НДС " + format("#,00", nds) + " грн.",
			"В тому числi ПДВ " + format("#,00", Number(nds)) + " грн.");
	return ret;
}

function FSUM_onblur() 
{
   Fsum_prop.value=TMoney(HSUM.value);
   FNDS_onblur();
   
   return checkRowSum();
}

function mFdoc_dat_Valid() 
{
   var docdt = new Date(HDAT.value);
   if (docdt.getFullYear()==d00obj.getFullYear() && docdt.getMonth()==d00obj.getMonth() && docdt.getDate()==d00obj.getDate())
      return false;
   else
      return true;
}

function onChangeNop()
{
	objDoc = extPar.doc;
	
	ndsproc = Number(objDoc.getPar("__ndsproc"));
	FNDS_onblur();
	
	if(extPar.mode == "ADD")
	{
		var rsc = objDoc.getPar("__rscnom");
		if(!rsc || rsc==0)
			rsc = getPar("ORSC");
		oOrg0.setCod(getPar("ORGNOM"));				
		oSch0.validCl();
		old_nds = Number(HNDS.value);
		HCRSC.value = String(rsc);		
	}	
}

include("sys\\DpBaseDlg.js");