include("objects\\DpVal.js");
include("doc\\DpDocList.js");
include("objects\\DpSc.js");
include("sys\\mask.js");
include("sys\\udfs.js");
include("servis\\date.js");
include("doc\\DpDoc.js");
include("sys\\dbase.js");
include("Objects\\DpDocPar.js");
include("objects\\DpClNo.js");

var sTmpTbl = "RRKTMP";
var table, tableR, NOMRK;
var Validation = true;
var ds,isFwid;
var objDoc = extPar.doc;
var par = new Object();

function Load()
{	
	this.initGrid = _initGrid;
	this.initGrid();
	this.listMenuInit = listMenuInit;
	this.onSelectRowMenu = onSelectRowMenu;	
	
	//NOMRK = objDoc.getPar("__nomrk");
	
	HTN.mask = MASK_DOCNUM;
	setValid(FDOC_DAT, FDOC_DAT_Valid);
	setValid(HEDAT, HEDAT_Valid);
	
	ctrlLinker = new DpCtrlLinker(extPar.doc);
	ctrlLinker.addLink("HNOM",HTN);
	ctrlLinker.addLink("HDAT",FDOC_DAT);
	ctrlLinker.addLink("HEDAT",HEDAT);	
			
	ctrlLinker.updateData(false);
	
	setFocus(HTN);		
}

function _initGrid()
{      	
   	this.sDocSourceDir = rootDirectory() + "docs\\" + extPar.doc.sDocLbl + "\\";	
	CreateTable(sTmpTbl,"RRK","*");
	var sFLD = GetPatternIntersection("RRK","RRK");
	var nId = (extPar.mode == "COPY") ? objDoc.nOldID : objDoc.getID();

	var sSQL = "INSERT INTO " + sTmpTbl + "(" + sFLD + ")"
			   + " SELECT " + sFLD
			   + " FROM ^RRK"
			   + " WHERE fid_doc="+ nId;
	ExecuteSQL(sSQL);
	grid.setXMLDir(this.sDocSourceDir);
	grid.setXMLFile("rowlist.xml");	
	
	var t = OpenTable("s","SELECT * FROM "+ sTmpTbl +" ORDER BY FNOM_STR");
//-	t.setIdFld("FNID");
	if(extPar.mode == "COPY")
	{			
		objDoc.resetFnids(t,"RKROW"); 
	}
	grid.setTable(t);	
	//grid.getTable().setIdFld("FNID");
	grid.build();
	grid.setData("RKROW");
	grid.loadMenuHandler(this,"listMenuInit");
	grid.selectMenuHandler(this,"onSelectRowMenu");
}

function listMenuInit()
{
	grid.AddMenuItem("ADD","Додавання | Добавление");
	if (!grid.getTable().isEmpty())
	{
		grid.AddMenuItem("EDIT","Редагування | Редактирование");
		grid.AddMenuItem("DEL","Видалення | Удаление");
	}
}		

function onSelectRowMenu(sID)
{	
	ctrlLinker.updateData(true);	
	
	if(sID == "DEL")
	{
		extPar.doc.deleteRow("RKROW", Number(grid.getTable().getRowID()));
		grid.getTable().Delete();
		grid.getTable().requery();
		grid.refresh();
	}
	else
	{		
		var oDocRow;
		if(sID == "ADD")
		{
			oDocRow = objDoc.createRow("RKROW");							
		}
		else if(sID == "EDIT")
		{
			var a = Number(grid.getTable().getRowID());			
			oDocRow = objDoc.getRow("RKROW", 
				Number(grid.getTable().getRowID()));
		}
						
		var bOK = oDocRow.edit(sID)
		if (bOK)
		{
			if(inList(sID,"ADD","COPY"))
				extPar.doc.appendRow("RKROW",oDocRow)
				
			obj2DB(oDocRow.getID(),oDocRow.jDocRow,null,sTmpTbl);
			grid.getTable().requery();
			grid.refresh();			
		}
	}
}

function FDOC_DAT_Valid() 
{
	if ((FDOC_DAT.value<=d00) && (FDOC_DAT.value>=d00))
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
  	return true;
}	

function HEDAT_Valid() 
{
	if ((HEDAT.value<=d00) && (HEDAT.value>=d00))
	{
		WAIT(ru("Пустая дата недопустима!","Порожня дата неприпустима!"));
		return false;
	}
	
	if (differ(HEDAT.value, FDOC_DAT.value) < 0)
	{
		WAIT(ru("Дата конца должна быть не меньше даты начала!","Дата кінця має бути не меншою за дату початку!"));
		return false;
	}
  	return true;
}	

function saveRows()
{	
	ExecuteSQL("DELETE FROM ^RRK WHERE fid_doc=" + sqlTo(extPar.doc.getVar("ID")));
	ExecuteSQL("INSERT INTO ^RRK(Fnop,Ftxt,Fwid,Fdoc,Fnom_str,Fdate,Fsum,Forg,Fid_doc)"
			  + " SELECT Fnop,Ftxt,Fwid,Fdoc,Fnom_str,Fdate,Fsum,Forg, "
			  + sqlTo(extPar.doc.getVar("ID"))+" as Fid_doc FROM RRKTMP");		
}

function onSave()
{
	ctrlLinker.updateData(true);
	saveRows();
}

include("sys\\DpBaseDlg.js");