include("Objects/DpExtentionBuilder.js");
include("doc\\nakl\\DpNkRow.js");
include("Objects\\DpCl.js");
include("Objects/DpCntrct.js");
include("doc/DpDoc.js");

var obj = extPar.obj;
obj.mode = extPar.mode;
var _tarif = obj.parent.getPar("_tarif");

function Load()
{			
	var _editprice = obj.parent.getPar("_editprice")//Редактировать цену
	
	Caption(ru("Редактирование расходной накладной","Редагування видаткової накладної"));
	
	rnk = new DpNkRow(obj);
	//rnk.load();
	
	rnk.oPost = new DpCl("0");
	rnk.oPodr = new DpCl("0");
	rnk.oMol  = new DpCl("0");
	rnk.oSc = new DpSc();
	rnk.oSc1 = new DpSc();
	
	//rnk.oNmkl = new DpNmkl(null, null, "S");	
	//rnk.oNmkl.linkCtrl(Fnmkl,tFnmkl,tFedi);
	rnk.oNmkl.linkSmartCtrl(Fnmkl,tFedi);
	//rnk.oNmkl.SetNakl(obj.parent);
	
	oClient = new DpCl();
	oClient.linkCtrl(Fclient,tFclient);
	oClient.setClcl(sprOrg);
	
	codPhone = getPar("bill_phone");
	oPhone = new DpCl("0");
   	oPhone.setClcl(codPhone);
   	oPhone.linkSmartCtrl(Fphone);
	oPhone.setContAssist();
					
	Fkol.mask  = MASK_KOL;
	Fcena.mask = Fsum.mask = MASK_SUM;
	Fnom_str.mask = "######";	
		
	//oCena = new DpUCena(obj);
	//oCena.linkCtrl(Fcena);
	
	ctrlLinker = new DpCtrlLinker(obj);
	ctrlLinker.addLink("RNOM",	 Fnom_str);		
	ctrlLinker.addLink("RKOL",	 Fkol);	
	ctrlLinker.addLink("RUCENA", Fcena);
	//ctrlLinker.addLink("RPHONE", Fphone);	
			
	ctrlLinker.updateData(false);
	
	oCntr = new DpCntrct("+");
	oCntr.linkCtrl(Fid_dog);
	
	var dogVid = obj.parent.getPar("_cntrct_vid");
	if(dogVid)
		oCntr.setVid(dogVid);
	
	if (extPar.mode != "ADD")
	{		
		rnk.oNmkl.setCod(obj.getVar("RTNMK"));
		oClient.setCod(obj.getVar("RORG"));		
		oCntr.setOrg(obj.getVar("RORG"));
		oCntr.setID(obj.getVar("RDOG"));
		oPhone.setFWID(obj.getVar("RPHONE"));
	}
	else
	{
		rnk.oNmkl.setCod(obj.parent.getVar("HNMK"));
	}
	
	if (extPar.mode == "ADD" || extPar.mode == "COPY")
		rnk.getNextRowNum();
	
	if (extPar.mode == "EDIT")
	{
		if(!_editprice)
			Disable(Fcena);
		//Disable(Fclient);
		//Disable(Fnmkl);
		//Disable(tFedi);
		//Disable(Fid_dog);
		setFocus(Fkol);	
	}
	setValid(Fkol,ru_check_Fsum);
	setValid(Fcena,ru_check_Fsum);
	setValid(Fsum,ru_check_Fsum);
	setValid(tFedi, rnk.check_Fedi);	
	setValid(Fclient,forg);	
	setValid(Fid_dog,tarif);
	
	rnk.parChange();
	rnk.check_Fedi();
	ru_check_Fsum();
}

function ru_check_Fsum()
{		
	XCena = Fcena;
	if(Fkol.value!=0)
		if(XCena.value == 0)
			XCena.value = round(Number(Fsum.value)/Number(Fkol.value), 2);
		else			
			Fsum.value = round(Number(XCena.value) * Number(Fkol.value), 2);
	else
		Fsum.value=0;
}

function onSave()
{	
	if(obj.parent.getPar("_check_dual_row"))
	{
		var oSnap = getSnap( "SELECT * FROM " + obj.parent.bufName 
							+ " WHERE FNMKL = " + sqlTo(rnk.oNmkl.getCod())
							+ " AND FCLIENT = " + sqlTo(oClient.getCod())
							+ " AND FCENA = " + sqlTo(Fcena.value)
							+ " AND FWID <> " + sqlTo(obj.getID())
							);
		if (oSnap != null)
		{
			alert(ru("Запись для данного контрагента, номенклатуры и цены уже существует",
					 "Запис для даного контрагента, номенклатури та ціни вже існує"));
			return false;
		}
	}

	Fnom = findFreeClNo(obj.parent.bufName, "fnom_str");
	obj.setVar("RNOM", Fnom);
	obj.setVar("RTNMK", rnk.oNmkl.getCod());
	obj.setVar("RORG", oClient.getCod());
	obj.setVar("RDOG",oCntr.getID());
	obj.setVar("RPHONE", oPhone.getFWID());
	ctrlLinker.updateData(true);
	//return rnk.save();	
}

function forg()
{
	if (Fid_dog.value == "")
		oCntr.setOrg(Fclient.value);
	
	return;
}

function tarif()
{
	Fcena.value = 0;
	if(getSystem()=="BIL2")
	{
		Fcena.value = getBillTarif();
		oPhone.setFWID(getBillPhone());
		return;
	}	
	if(_tarif==1)
		Fcena.value = getZonTarif();			
	if(_tarif==2)
		Fcena.value = getPriceTarif();
}

function getBillTarif()
{
	var tarif = 0;
	var codPack = getPar("BILL_PACK");
	var sSql = "select s.FCENA from ^CL_SERV s "
				+" inner join ^CL_PACK p on p.FWID_CL=s.FWID_CL"
				+" inner join ^BIL_PACK b on b.FWID_CL=p.FWID_CL"
				+" where s.FNMKL="+ rnk.oNmkl.getCod()
					+" and b.FID_DOG="+ oCntr.getID()
	var oPri = getSnap(sSql, false);
	if(oPri)
		tarif = oPri[0];
	return tarif;
}

function getPriceTarif()
{	
	var tarif = 0;
	var priType = getPar("BILL_PRI");
	var sSql = "select FWID, FDAT, FCOD from ^CL_PRI"
					+" where FCOD="+ sqlTo(priType)
						+" and FISGRP<>"+ SqlTrue						 
					+" order by FDAT desc"
	var oPri = getSnap(sSql, false);
	if(!oPri)
		return tarif;	
	include("sub/mtr.js");
	var fnmkl = rnk.oNmkl.getCod();
	var sName = pName(oPri[2], oPri[1]);
	oPri = getSnap("select FCENA, FCENA1 from "+ sName 
			+" where FNMKL="+ fnmkl, false);
	if(oPri)
		tarif = oPri[0];
	return tarif;
}

function getZonTarif()
{
	var tarif = 0;
	if (Fid_dog.value == "")
		return;
	var strSQL = "select fzone from ^HTD where fid_dog=" + sqlTo(oCntr.getID());
	var gS = getSnap(strSQL, false);
	var zona = 0;
	if (gS != null)
	{
		zona = Number(gS[0]);
	}
	var oDoc = new DpDoc("TD",0);
	var tf = oDoc.getPar("__tarif");
	var oExt = new DpExtentionBuilder("CL",tf,null);
	var tblName = oExt.getValueTableName();
	
//	в таблице расширений могут быть записи относящиеся к удаленным записям справочника тарифов, поэтому будем джоинить с CL
//	strSQL = "select FTARIF from " + tblName + " where FBDAT = (select MAX(FBDAT) from " + tblName
//			 + " where fzona = " + sqlTo(zona) +
//				" and FBDAT<=" + sqlTo(obj.parent.getVar("HDAT")) + ") and fzona = " + sqlTo(zona);
	strSQL = "select e.FTARIF from " + tblName + " as e inner join ^cl as cl on cl.Fwid=e.Fmainwid where e.FBDAT = (select MAX(e2.FBDAT) from " + tblName
			 + " as e2 inner join ^cl as cl2 on cl2.Fwid=e2.Fmainwid where e2.fzona = " + sqlTo(zona) +
				" and e2.FBDAT<=" + sqlTo(obj.parent.getVar("HDAT")) + ") and e.fzona = " + sqlTo(zona);
	gS = getSnap(strSQL, false);
			
	
	if (gS != null)
		tarif = gS[0];
	else
		alert("В справочнике тарифов\nне задан тариф для выбраной зоны");		
	
	return tarif;
}

function getBillPhone()
{
	var phoneID = 0;
	var curSys = lpProxy.getOrgManager().getSys();
	if(curSys!="BIL2")
		return phoneID;
	
	var oSnap = getSnap("select p.FPHONE from ^BIL_PACK p "
					+" inner join ^CL_SERV s on s.FWID_CL=p.FWID_CL "
					+" where p.FID_DOG="+ oCntr.getID()
						+" and p.FEDAT<="+ sqlD00
						+" and s.FNMKL="+ rnk.oNmkl.getCod()
					, false);
	if(oSnap)
		phoneID = oSnap[0];
	return Number(phoneID);
}

include("sys\\DpBaseDlg.js");