include("servis/date.js");

var date = extPar.date;
var dat1 = firstDay(date);
var dat2 = lastDay(date);

function onLoad()
{
	Caption(UR("Перерахунок|Перерасчет"));
	
	FSUM.mask = MASK_SUM;
	FPERC.mask = MASK_SUM;
		
	FBDAT.value = dat1;
	FEDAT.value = dat2;
	
	this.sumEdit = sumEdit;
	FSUM.setModifyHandler(this, "sumEdit");
	FPERC.setModifyHandler(this, "sumEdit");
	
	setValid(FBDAT, datValid);
	setValid(FEDAT, datValid);
	setValid(FSERV, servValid);
	servValid();
}

function sumEdit()
{
	if(Number(FSUM.value)==0)
		Enable(FPERC);
	else
		Disable(FPERC);
	if(Number(FPERC.value)==0)
		Enable(FSUM);
	else
		Disable(FSUM);
}

function servValid()
{
	var sServ = String(FSERV.value).trim();
	if(FSERV.value==null || sServ=="")
	{
		Disable(FBDAT);
		Disable(FEDAT);
		Disable(FDAYS);
	}
	else
	{
		Enable(FBDAT);
		Enable(FEDAT);
		Enable(FDAYS);
	}
}

function datValid()
{
	var bdat = new Date(FBDAT.value);
	var edat = new Date(FEDAT.value);
	var sServ = String(FSERV.value).trim();
	if(FSERV.value==null || sServ=="")
		return true;
	if(differ(bdat, dat1)<0 || differ(bdat, dat2)>0)
	{
		setFocus(FBDAT);
		return false;
	}
	if(differ(edat, dat2)>0 || differ(edat, dat1)<0)
	{
		setFocus(FEDAT);
		return false;
	}
	var days = getDaysInMonth(date);
	var diff = day_difference(bdat, edat);
	if(diff<days)
	{
		FDAYS.value = diff;
		Disable(FDAYS);
	}
	else
	{
		Enable(FDAYS);
	}
}

function onSave()
{
	var sIDs = "";
	var arrID = extPar.arrID;
	if(!arrID || arrID.length==0)
		return;
	for(var i=0; i<arrID.length; i++)
		sIDs += ","+ arrID[i];
	sIDs = sIDs.substring(1);
	
	var nSum = Number(FSUM.value);
	var nPerc = Number(FPERC.value)/100;
	var sServ = FSERV.value;
	var sTxtServ = FSERV.getStringValue();
	var sRem = String(FREM.value);
	if(sRem=="" && String(sServ).trim()!="")
		sRem = sTxtServ;
	if(!sServ || String(sServ).trim()=="")
	{
		var sMsg = UR("Буде виконано перерахунок для відмічених документів ("+ arrID.length +")"
						+(nPerc==0? "\nна суму "+ nSum +"." : "\nна "+ FPERC.value +" % від суми нарахування.")
						+"\nКоментар: '"+ sRem +"'"
						+"\nПродовжити збереження?"
					+"|Будет выполнен перерасчет для отмеченных документов ("+ arrID.length +")"
						+(nPerc==0? "\nна сумму "+ nSum +"." : "\nна "+ FPERC.value +" % от суммы начислений.")
						+"\nКомментарий: '"+ sRem +"'"
						+"\nПродолжить сохранение?"
						);
		
		if(!confirm(sMsg))
			return false;
		
		if(nSum==0 && nPerc!=0)
		{
			ExecuteSQL("update ^RAS_SKU set FSUM=(FSUM-FRECALC) where FWID in ("+ sIDs +")");
			ExecuteSQL("update ^RAS_SKU"
						+" set FRECALC="+ sqlRound("FSUM*"+ nPerc, 2)
							+",FSUM=(FSUM+"+ sqlRound("FSUM*"+ nPerc, 2) +")"
						+" where FWID in ("+ sIDs +")"
						);
		}
		else
		{
			ExecuteSQL("update ^RAS_SKU"
						+" set FSUM=(FSUM-FRECALC+"+ nSum +")"
							+", FRECALC="+ nSum
						+" where FWID in ("+ sIDs +")"
						);
		}
	}
	else
	{
		var bdat = new Date(FBDAT.value);
		var edat = new Date(FEDAT.value);
		var days = getDaysInMonth(date);
		var diff = Number(FDAYS.value);
		
		var sTbl = getTmpTableName();
		var bRet = ExecuteSQL("select * into "+ sTbl 
							+" from ^SKU_SERV"
							+" where FID_DOC in ("+ sIDs +")"
								+" and FSERV="+ sqlTo(sServ)
							);
		if(!bRet)
			return false;
		var oSnap = getSnap("select count(*) as cnt from "+ sTbl);
		if(oSnap && Number(oSnap[0])==0)
		{
			var sMsg = UR("Серед відмічених документів немає нарахувань з послугою '"+ sTxtServ +"'"
						+"|Среди отмеченных документов нет начислений с услугой '"+ sTxtServ +"'"
						);
			alert(sMsg);
			return false;
		}
		if(diff==0 && nSum==0 && nPerc==0)
		{
			var sMsg = UR("Необхідно ввести суму або вказати кількість днів для перерахунку!"
						+"|Нужно ввести сумму или указать количество дней для перерасчета!"
						);
			alert(sMsg);
			return false;
		}
		
		var sMsg = UR("Буде виконано перерахунок для відмічених документів ("+ arrID.length +")"
						+"\nпо послузі '"+ sTxtServ +"'"
						+(diff>0? "  за "+ diff +" дн." : "")
						+(nSum==0? (nPerc==0? "" : "\nна "+ FPERC.value +" % від суми нарахування.") 
							: "\nна суму "+ nSum +".")
						+"\nКоментар: '"+ sRem +"'."
						+"\nПродовжити збереження?"
					+"|Будет выполнен перерасчет для отмеченных документов ("+ arrID.length +")"
						+"\nпо услуге '"+ sTxtServ +"'"
						+(diff>0? "  за "+ diff +" дн." : "")
						+(nSum==0? (nPerc==0? "" : "\nна "+ FPERC.value +" % от суммы начислений.") 
							: "\nна сумму "+ nSum +".")
						+"\nКомментарий: '"+ sRem +"'."
						+"\nПродолжить сохранение?"
						);
		if(!confirm(sMsg))
			return false;
		
		ExecuteSQL("alter table "+ sTbl +" add FSUM0 "+ sqlType("CURRENCY"));
		ExecuteSQL("update "+ sTbl +" set FSUM0=FSUM");
		
		if(diff>0 && diff<days)
			sSQL = "update "+ sTbl +" set FSUM=(FSUM-"+ sqlRound("FSUM/"+ days +"*"+ diff, 2) +"+"+ nSum +")";
		else if(nSum==0 && nPerc!=0)
			sSQL = "update "+ sTbl +" set FSUM="+ sqlRound("FSUM*"+ nPerc, 2);
		else
			sSQL = "update "+ sTbl +" set FSUM="+ nSum;
		bRet = ExecuteSQL(sSQL);
		if(!bRet)
			return false;
		/*
		switch(sServ)
		{
			case "RENT":
				ExecuteSQL("update ^RAS_SKU"
							+" set FRENTSUM="+ nSum
							+" where FWID in ("+ sIDs +")"
							);
				break;
			case "HEAT":
				
				break;
			case "CWATER":
				
				break;
			case "HWATER":
				
				break;
			case "GAS":
				
				break;
			case "ELECTRIC":
				
				break;
			case "OTHER":
				
				break;
		}
		*/
		ExecuteSQL("update ^RAS_SKU s set s.FSUM=s.FSUM-s.FRECALC"
						+"+(select sum(t.FSUM-t.FSUM0)"
						+" from "+ sTbl +" t where t.FID_DOC=s.FWID)"
					+" where exists (select t.FSUM from "+ sTbl +" t where t.FID_DOC=s.FWID)"
					);
		
		ExecuteSQL("update ^RAS_SKU s set s.FRECALC="
						+"(select sum(t.FSUM-t.FSUM0)"
						+" from "+ sTbl +" t where t.FID_DOC=s.FWID)"
					+" where exists (select t.FSUM from "+ sTbl +" t where t.FID_DOC=s.FWID)"
					);
	}
	
	ExecuteSQL("update ^RAS_SKU"
				+" set FRECALC_REM="+ sqlTo(sRem)
				+" where FWID in ("+ sIDs +")"
				);
	
}

include("sys/DpBaseDlg.js");