include("Objects/DpDocEx.js");
include("Objects/DpCl.js");

var objDoc;
var oTopic;
var oCat;
var oOrg;
var oManager;
var oParDoc;
var nPriority;

function Load()
{
	Caption(UR("Тема|Тема"), extPar.mode);
	
	objDoc = extPar.doc;
	
	FCOLOR.mask = "###";
	
	oParDoc = new DpDocEx(objDoc.sDocLbl, 0);
	oParDoc.linkCtrl(FGRPTOPIC);
	
	oTopic = new DpCl("!", getPar("CL_TOPIC"), 0);
	oTopic.linkSmartCtrl(FTOPIC);
	oTopic.setContAssist();
	
	oCat = new DpCl("0", getPar("CL_TOPIC_CAT"), 0);
	oCat.linkSmartCtrl(FCAT);
	oCat.setContAssist();
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	
	oManager = new DpCl("0", getPar("CODPERS"), 0);
	oManager.linkSmartCtrl(FMANAGER);
	oManager.setContAssist();
		
	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM", FDOC_NUM);
	ctrlLinker.addLink("HPRIORITY", FPRIORITY);
	ctrlLinker.addLink("HBDAT", FBDAT);
	ctrlLinker.addLink("HEDAT", FEDAT);
	ctrlLinker.addLink("HCONTENT", FCONTENT);	
	ctrlLinker.addLink("HCOLOR", FCOLOR);
	ctrlLinker.addClLink("HTOPIC", oTopic);
	ctrlLinker.addClLink("HCAT", oCat);
	ctrlLinker.addClLink("HORG", oOrg);
	ctrlLinker.addClLink("HMANAGER", oManager);
	ctrlLinker.updateData(false);
		
	if(extPar.mode=="ADD")
	{
		FEDAT.value = d00;
	}
	else
	{
		oParDoc.setFwid(objDoc.getVar("HGRPID"));
	}
	
	this.color_valid = color_valid;
	this.color_select = color_select;
	FCOLOR.setModifyHandler(this, "color_valid");		
	setButton(FCOLOR, this, "color_select");
	
	setValid(FPRIORITY, priority_valid);
	nPriority = Number(FPRIORITY.value);
		
	if(extPar.mode=="ADD")
		setColor();
	color_valid();
	
	loadLinkDocs();
}

function loadLinkDocs()
{
	var tLinks = OpenTable("select * from ^DOC_LINKS where FMAINWID="+ objDoc.getID());
	grid.setTable(tLinks);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function gridMenuInit(oGrid)
{
	var tbl = oGrid.getTable();	
	if(IsDblClick(oGrid))
	{
		if(tbl.getValue("FDOC"))
			gridMenuRun("VIEW", oGrid);
		return true;
	}		
	if(tbl.getValue("FDOC"))
	{
		oGrid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
		oGrid.AddMenuItem("", "");		
	}
	oGrid.AddMenuItem("ADD", "Додати|Добавить");
	if(tbl.getValue("FDOC"))
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр", 1002);
}

function gridMenuRun(sID, oGrid)
{	
	switch(sID)
	{
		case "ADD":			
			var par = new Object();
			par.ret = new Object();
			par.zaval = true;
			showWindow("docfdr.xml", SW_MODAL, par);
			if(par.escape)
				break;
			var doc = par.ret.doc;
			var nop = par.ret.nop;			
			var oDoc = new DpDoc(doc, nop);
			var par = new Object();
			par.org = oOrg.getCod();
			par.FORG = oOrg.getCod();
			par.nOrg = oOrg.getCod();
			par.topic = objDoc;
			var bRet = oDoc.edit("ADD", 0, par);
			if(bRet)
			{
				var m = new Object(); 
				m.FMAINWID = oDoc.getID();
				m.FDOCWID = objDoc.getID();
				m.FDOC = objDoc.sDocLbl;
				m.FNOP = objDoc.nNop;
				m.FISPARENT = true;
				m.FWID = GetUID();
				updateTable("^DOC_LINKS", m, true);
				
				var m = new Object(); 
				m.FMAINWID = objDoc.getID();
				m.FDOCWID = oDoc.getID();
				m.FDOC = oDoc.sDocLbl;
				m.FNOP = oDoc.nNop;
				m.FISPARENT = false;
				m.FWID = GetUID();
				updateTable("^DOC_LINKS", m, true);				
				
				oGrid.getTable().requery();
				oGrid.refresh();
			}
			break;
		
		case "FINDDOC":			
			var tbl = oGrid.getTable();
			var par = new Object();			
			par.doc = tbl.getValue("FDOC");
			par.nop = tbl.getValue("FNOP");
			par.fid_doc = tbl.getValue("FDOCWID");
			showWindow("l_docekz.xml", SW_NOMODAL, par);
			break;
			
		case "VIEW":			
			var tbl = oGrid.getTable();
			var doc = tbl.getValue("FDOC");
			var nop = Number(tbl.getValue("FNOP"));
			var id = Number(tbl.getValue("FDOCWID"));
			if(!doc)
				return true;
			var oDoc = new DpDoc(doc, nop);
			var bRet = oDoc.edit(sID, id);
			if(bRet)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
			
		case "FIND":
			oGrid.runSelection(8);
			break;
	
		case "SELECT":
			oGrid.runSelection(2);	
			break;
	}
}

function tdoc(sDoc, nNop)
{
	var sName = "";	
	if(!nNop)
		nNop = 0;
	if(!sDoc)
		sDoc = "";
	var oSnap = getSnap("select FTXT from ^cl_lnk "
					+" where FDOC="+ sqlTo(sDoc)
						+" and FNOP="+ sqlTo(nNop)
				, false);
	if(oSnap)
		sName = oSnap[0];	
	return UR(sName);
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HGRPID", oParDoc.fwid);	
}

function priority_valid()
{
	if(nPriority==Number(FPRIORITY.value))
		return;
	nPriority = Number(FPRIORITY.value);	
	setColor();
}

function setColor()
{	
	FCOLOR.value = 0;
	var oSnap = getSnap("select FCOLOR from ^TOPICS "
						+" where FPRIORITY="+ sqlTo(FPRIORITY.value)
						+" order by FDOC_DAT desc"
					, false);
	if(oSnap)
		FCOLOR.value = Number(oSnap[0]);
	color_valid();
}

function color_valid()
{
	try
	{
		var nColor = java.lang.Integer(FCOLOR.value);
		var rgb = extPar.grid.colorLevel(nColor, false);		
		var color = org.eclipse.swt.graphics.Color(null, rgb);
		FCOLOR.setBackground(color);		
	}
	catch(e)
	{
		trace(e)
	}
}

function color_select()
{
	var par = new Object();
	par.maxCol = 26;
	par.ret = new Object();
	par.ret.FTYPE = 0;
	showWindow("colors.js", SW_MODAL, par);
	if(par.escape)
		return false;
	FCOLOR.value = Number(par.ret.FTYPE);
	color_valid();
}

include("sys/DpBaseDlg.js");