include("Objects\\DpVal.js");
include("Objects\\DpCl.js");
include("Objects\\DpRasSc.js");
include("Objects\\DpPostRs.js");
include("Objects\\DpClcl.js");
include("doc\\DpDoc.js");
include("sys\\mask.js");
include("Objects\\DpCtrlLinker.js");
include("Objects\\DpDocPar.js");

var cl, val, oSch, oRasSc;
var objDoc = extPar.doc; 
var Validation = true;

function Load()
{
	MFDOC_NUM.mask=MASK_DOCNUM;
	MFCOD_PR1.mask=MASK_OKPO;
	MFCOD_PR2.mask=MASK_OKPO;
//	MFFDB_SC.mask=MASK_RS;
//	MFFCR_SC.mask=MASK_RS;
//	MFCOD_BNK1.mask=MASK_MFO;
//	MFCOD_BNK2.mask=MASK_MFO;
	MFSUM.mask=MASK_SUM;
	MFNDS.mask=MASK_SUM;
	MFCOD_GR_OT.mask="#######";
	MFCOD_GR_PO.mask="#######";
	MFZAK_NUM.mask="&&&&&&&";
	MFSCH_FACT.mask="&&&&&&&&&&&&&&&";
	MFGR_OTP1.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	MFGR_OTP2.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	MFGR_POL1.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	MFGR_POL2.mask="&&&&&&&&&&&&&&&&&&&&&&&&&";
	MFDOGOVOR.mask="&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";

	//oRasSc = new DpRasSc(extPar.doc, extPar.nop);
	oRasSc = new DpRasSc(objDoc.sDocLbl,objDoc.nNop);
    oRasSc.linkCtrl(MFFCR_SC, MFCOD_BNK2, MFBNK2);	
	  
	val=new DpVal();	
	val.assocDpText(MFVAL);
	
	cl=new DpCl();	
	cl.linkCtrl(MFORG);
	cl.setClcl();
	cl.linkCtrl2("Ftxt", MFPR1);
	cl.linkCtrl2("Fcod_st", MFCOD_PR1);

	ctrlLinker = new DpCtrlLinker(objDoc);
	ctrlLinker.addLink("HNOM",MFDOC_NUM);
	ctrlLinker.addLink("HDAT",FDOC_DAT);	
	
	ctrlLinker.addLink("HORG",MFORG);	
	ctrlLinker.addLink("HTOT",MFPR1);
	ctrlLinker.addLink("HBNKOT",MFBNK1);
	ctrlLinker.addLink("HCOT",MFCOD_PR1);
	ctrlLinker.addLink("HMFOOT",MFCOD_BNK1);
	
	ctrlLinker.addLink("HTTO",MFPR2);
	ctrlLinker.addLink("HCTO",MFCOD_PR2);
	ctrlLinker.addLink("HBNKTO",MFBNK2);
	ctrlLinker.addLink("HMFOTO",MFCOD_BNK2);
	
	ctrlLinker.addLink("HDBSC",MFFDB_SC);
	ctrlLinker.addLink("HSUM",MFSUM);
	ctrlLinker.addLink("HNDS",MFNDS);	
	ctrlLinker.addLink("HCRSC",MFFCR_SC);
	
	ctrlLinker.addLink("HCOTP",MFCOD_GR_OT);
	ctrlLinker.addLink("HGROT",MFGR_OTP1);
	ctrlLinker.addLink("HGROT2",MFGR_OTP2);
	ctrlLinker.addLink("HDOG",MFDOGOVOR);
	ctrlLinker.addLink("HNZAK",MFZAK_NUM);
	ctrlLinker.addLink("HDZAK",MFZAK_DAT);
	
	ctrlLinker.addLink("HCPOL",MFCOD_GR_PO);
	ctrlLinker.addLink("HGRPO",MFGR_POL1);
	ctrlLinker.addLink("HGRPO2",MFGR_POL2);
	ctrlLinker.addLink("HDATOT",MFOTGR_DAT);
	ctrlLinker.addLink("HSF",MFSCH_FACT);
	
	ctrlLinker.addLink("HTOVAR",MFTOVAR);
	
	if (extPar.mode != "ADD")
   	{
   		val.setCod(objDoc.getVar("HVAL"));
   		cl.setCod(objDoc.getVar("HORG"));   				 		
   	}
	oSch = new DpPostRs();
	oSch.setDpCl(cl, cl.getCod() != 0);
	oSch.linkCtrl(MFFDB_SC, MFCOD_BNK1, MFBNK1);
	
	ctrlLinker.updateData(false);
	
	setFocus(MFDOC_NUM);	

	setValid(MFSUM, MFSUM_valid);
	
	//objDoc = new dpDoc(tbl,null,extPar.doc,extPar.nop,extPar.fwid)
	//objDoc.editInit(edmode, MFDOC_NUM)
}

function MFSUM_valid()
{
	var dp = new DpDocPar(objDoc.sDocLbl,objDoc.nNop);
	var ndsproc = dp.getPar("__ndsproc");
	SUM = Number(MFSUM.value)
	nds = Number(ndsproc)
	if(ndsproc)
		MFNDS.value = round(SUM*nds/(100+nds), 2);
}

function onSave()
{
	ctrlLinker.updateData(true);
	objDoc.setVar("HVAL",val.getCod());
}

include("sys\\DpBaseDlg.js");