include("objects/DpCl.js");
include("objects/DpVopl.js");
include("Objects/DpShifPZ.js");
include("Objects/DpPost.js");
include("sys/udfs.js");

var obj = extPar.doc; 
var param = extPar.param;
var lowDat = null;
var tmpLowDat = null;
var ctrlLinker = null;
var dpPers = null;
var dpDol = null;
var dpVopl = null;
var dpKodKat = null;
var oldDol = null;
var dpShifPZ = null;

var codDol = 0;
var codPers = 0;
var codKat = 0;
var codProf = 0;

var DOL_FWID = 0;
var isnew = false;

function Load() 
{
   	Caption(UR("Наказ: призначення на посаду |Приказ: назначение на должность ")
   					+ (extPar.mode == "EDIT" ? "(редагування)|(редактирование)" : ""));
   	
   	//реализована возможность ручной простановки fwid-а в work_pers
   	//при назначении на должность, сделано с целью востановления целосности данных 
   	//при случайном удалении записи из штатного расписания, которая уже была 
   	//связана с приказами, табелями или лицевыми счетами
   	/*if(extPar.mode == "ADD")
   	{
   		Enable(RESTORE);
   		Disable(FWID_WP);
   	}
   	else
   	{
   		Disable(RESTORE);
   		Disable(FWID_WP);
   	}
   	setValid(RESTORE,restore_Valid);
   	setValid(FWID_WP,fwid_wp_Valid);
   	FWID_WP.setMask("######");*/
   	
   	ctrlLinker = new DpCtrlLinker(obj);
 	ctrlLinker.addLink("RBDAT", RBDAT);
 	ctrlLinker.addLink("REDAT", REDAT);
 	ctrlLinker.addLink("RTERM", RTERM);
 	ctrlLinker.addLink("RREASON", RREASON);
 	ctrlLinker.addLink("RAVANS", RAVANS);
 	ctrlLinker.addLink("RTABLE", RTABLE);
 	ctrlLinker.addLink("RNAZN", RNAZN);
 	ctrlLinker.addLink("RINVAL", RINVAL);
 	ctrlLinker.addLink("RPRIEM", RPRIEM);
 	ctrlLinker.addLink("RUVOL", RUVOL);
 	ctrlLinker.addLink("RZAPIS", RZAPIS);
  	ctrlLinker.updateData(false);
   	if(extPar.mode == "EDIT")
   	{
   		var snap = getSnap("SELECT Fedat,Fnazn,Fis_uv,Fis_serv FROM ^work_pers WHERE Fwid="+sqlTo(param.fwid))
   		if(snap!=null)
   		{
   			REDAT.value = snap[0];
   			RNAZN.value = snap[1]==1?true:false;
   			RUVOL.value = snap[2]==1?true:false;
   			RZAPIS.value = snap[3]==1?true:false;
   		}
   	}
   	else
   		REDAT.value = d00;
  	
	NEWDOL.setValue(extPar.mode != "EDIT");
	
	dpShifPZ = new DpShifPZ();
	dpShifPZ.setUseZiro(true);
	dpShifPZ.linkCtrl(RSHPZ, RSHPZ_TXT);
	dpShifPZ.setFshpz(0);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof CDR_ORG_CL_POSAD_AUX != "undefined")
		codDol = getPar(CDR_ORG_CL_POSAD_AUX);
	else
		codDol = getPar("CODDOL");

	dpDol = new DpPost(extPar.mode, NEWDOL.getValue() == true);
	dpDol.linkCtrl("fcod", FCOD);
	dpDol.linkCtrl("dol_ftxt", FTXT, true);
	dpDol.linkCtrl("foklad", ROKLAD);
	dpDol.linkCtrl("fshpz", dpShifPZ);
	dpDol.setFWID_ORG(param.fwid_podr);
	dpDol.setDate(RBDAT.getValue());	
	dpDol.setFWID_DOL(obj.getVar("RWID_DOL"));
	setValid(FCOD, FCODDOL_valid);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_PERSONAL != "undefined")
		codPers = getPar(const_GETPAR_PERSONAL);
	else
		codPers = getPar("CODPERS");
	dpPers = new DpCl("", codPers, 0);
	dpPers.linkCtrl(RTABN, RTABNTXT);
	dpPers.addCondition("condition");
	Enable(RINVAL, false);
	setValid(RTABN, RTABN_valid);
	
	dpVopl = new DpVopl();
	dpVopl.linkCtrl(RVOPL, RVOPLTXT);
	
	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_VIDPOSAD != "undefined")
		codKat = getPar(const_GETPAR_VIDPOSAD);
	else
		codKat = getPar("CODKAT");
	dpKodKat = new DpCl("0", codKat, 0);
	dpKodKat.linkCtrl(RKODKAT, RKODKATTXT);

	Enable(RKODKAT, false);

	//для совместимости с диллерским модулем кадрового планирования CDRP
	if(typeof const_GETPAR_PROF != "undefined")
		codProf = getPar(const_GETPAR_PROF);
	
	if (extPar.mode == "EDIT")
	{
		/*var snap = getSnap("SELECT fwid_cl, foklad, fshpz FROM ^stru_dol WHERE fwid=" + sqlTo(obj.getVar("RWID_DOL")));
		if (snap != null)
		{
			dpDol.setFWID(snap[0]);
			oldDol = snap[0];
			ROKLAD.setValue(snap[1]);
			dpShifPZ.setFshpz(snap[2]);
		}*/
		dpPers.setFWID(obj.getVar("RWID_CL"));
		dpVopl.setVopl(obj.getVar("RVOPL"));
/*
		if(obj.getVar("RWID_KAT")!=0)
			dpKodKat.setFWID(obj.getVar("RWID_KAT"));
		else
			RKODKAT.value = 0;
*/

		if (obj.getVar("RWID_DOL") != 0)
		{
			dpKodKat.setFWID(getKodKatFwid(dpDol.getCod()));
		}
		RTABN_valid();

		setLowDate(obj.getVar("RWID_DOL"));
	}
	else if (extPar.mode == "ADD")
	{
		RTABLE.value = 1;
	}
	
  	ROKLAD.setMask("########.##");
  	RAVANS.setMask("########.##");
  	RTABLE.setMask("#");
  	RTERM.setMask("###");	

	setValid(RBDAT, bdatValid);
	setValid(REDAT, edatValid);
	setValid(NEWDOL, checkValid);
		
	DOL_FWID = Number(obj.getVar("RWID_DOL"));
	setValid(FCOD, fcod_Valid);
	if(param.disableDol)
		Disable(NEWDOL);
	if(param.disablePriem)
		Disable(RPRIEM);
}

function onSave()
{
	/*if (extPar.mode == "EDIT" && dpDol.getFWID() == oldDol && NEWDOL.value == false)
	{
		fwid_dol = obj.getVar("RWID_DOL");
		var edat = getSnap("SELECT fedat FROM ^work_pers WHERE fwid=" + sqlTo(obj.getVar("RWID_WP")))[0];
		if (differ(toScriptDate(d00), toScriptDate(edat)) == 1
			&& differ(toScriptDate(RBDAT.value), toScriptDate(edat)) == 1)
		{
			WAIT(UR("Дата наказу не може бути більша |Дата приказа не может быть больше ") + StrDat(edat, "DMY"));
			setFocus(RBDAT);
			return false;
		}
	}
	else
	{
		fwid_dol = findFreeDol();
		if (fwid_dol == null)
			return false;
	}*/

	if (!validAvans())
		return false;
	
	var fwid_dol = dpDol.getFWID_DOL();	
	var isNewPost = false;
	if (fwid_dol == -1)
	{
		isNewPost = true;
		fwid_dol = GetUID();
	}

	ctrlLinker.updateData(true);
	
	var l = new Object();
	l.FWID = fwid_dol;
	l.FOKLAD = ROKLAD.getValue();
	l.FSHPZ = dpShifPZ.getFshpz();
//	if (isNewPost)
//	{
		l.FWID_ORG = param.fwid_podr;
		l.FWID_CL = dpDol.getFWID_CL();
		l.FCOD = dpDol.getCod();
		l.FBDAT = obj.getVar("RBDAT");
		l.FEDAT = obj.getVar("REDAT");
		//l.FEDAT = d00;
//	}
	UpdateTable("^stru_dol", l, isNewPost);	

	obj.setVar("RWID_CL", dpPers.getFWID());
	obj.setVar("HNOM", String(dpPers.getCod()));
	obj.setVar("RWID_KAT", dpKodKat.getFWID());
	obj.setVar("RWID_DOL", fwid_dol);
	obj.setVar("RVOPL", dpVopl.getVopl());
		
    if (extPar.mode == "ADD")
    {
		var snap = getSnap("SELECT MAX(fid) FROM ^work_pers WHERE fwid_cl=" + sqlTo(obj.getVar("RWID_CL")));
		if (snap != null)
			obj.setVar("RID", snap[0] + 1);
		else
			obj.setVar("RID", 1);	
		//obj.setVar("RWID_WP", GetUID());
		obj.setID(GetUID());
    }
    //obj.setID(obj.getVar("RWID_WP"));
    
	//ctrlLinker.updateData(true);
	//obj.save();
	//var m = new Object();
	//if(RESTORE.checked==true)
	//	m.FWID = FWID_WP.value;
	//else
	
	/*в work_pers теперь сохраняем через dbmapping
	m.FWID = obj.getVar("RWID_WP");
	m.FWID_CL = obj.getVar("RWID_CL");
	m.FWID_DOL = obj.getVar("RWID_DOL");
	m.FWID_KAT = obj.getVar("RWID_KAT");
	m.FID = obj.getVar("RID");
	m.FBDAT =  obj.getVar("RBDAT");
	m.FEDAT =  obj.getVar("REDAT");
	m.FVOPL = obj.getVar("RVOPL");
	m.FAVANS = obj.getVar("RAVANS");
	m.FTABLE = obj.getVar("RTABLE");
	m.FNAZN = obj.getVar("RNAZN");
	m.FINVAL = obj.getVar("RINVAL");
	m.FIS_NAZN = obj.getVar("RPRIEM");
	m.FIS_UV = obj.getVar("RUVOL");
	m.FIS_SERV = obj.getVar("RZAPIS");

	updateTable("^work_pers", m, extPar.mode != "EDIT");*/
}

function FCODDOL_valid()
{
	dpKodKat.setFWID(getKodKatFwid(dpDol.getCod()));
}

function RTABN_valid()
{
	strSQL = "SELECT FINVAL "
			+" FROM ^PERSFILE PF INNER JOIN "
				+" (^CL CL INNER JOIN ^CLRELCLCL REL "
				+" ON (CL.FWID = REL.FWID_CL "
				+" AND REL.FCL = "+sqlTo(codPers)
				+"))"
			+" ON CL.FWID = PF.FWID_CL "
			+" WHERE REL.FCOD = "+sqlTo(RTABN.value)
	var sn = getSnap(strSQL);
	if (sn != null && sn[0] != null)
	{
		RINVAL.value = sn[0]==SqlTrue ? true : false;
	}
	else
	{
		RINVAL.value = false;
	}
	sn = null;
}

function bdatValid()
{
	return dpDol.setDate(RBDAT.getValue());
	/*if (lowDat == null)
		return true;
	var newdat = toScriptDate(RBDAT.value)
	if (differ(lowDat, newdat) == 1)
	{
		WAIT(UR("Дата наказу не може бути менша |Дата приказа не может быть меньше ") + StrDat(lowDat, "DMY"));
		return false;
	}
	return true;*/
}

function edatValid()
{
	if(differ(new Date(REDAT.getValue()),new Date(RBDAT.getValue()))>0)
		return true;
	else
	{
		alert(ru("Дата ліквідації повинна бути більшею за дату призначення!",
				"Дата ликвидации должна быть больше даты назначения!"));
		return false;
	}
}

function checkValid()
{
	dpDol.setIsNewPost(NEWDOL.getValue());
	/*
	if (!list.isSaving())
	{
		Enable(ROKLAD, true);
		Enable(RSHPZ, true);
		ROKLAD.setValue(0);
		dpShifPZ.setFshpz(0);
	}
	
	
	if (dpDol.getCod() == 0)
		lowDat = null;
	else
	{
		if (NEWDOL.value == true)
		{
			if (lowDat != null)
			{
				tmpLowDat = lowDat;
				lowDat = null;
			}
		}
		else
		{
			lowDat = tmpLowDat;
			tmpLowDat = null;
		}
	}*/
}

function condition(cod)
{
	var strSQL = "SELECT MAX(fedat)"
				+ " FROM ^work_pers"
				+ " WHERE fwid_cl=(SELECT MAX(fwid_cl) FROM ^clrelclcl"
								+ " WHERE fcod=" + sqlTo(cod) 
									+  " AND fcl=" + sqlTo(codPers) + ")";
	var snap = getSnap(strSQL);
	if (snap == null || snap[0] == null || snap[0] != d00)
		return true;		
	return false;
}

function createNewDol()
{
	return -1;
	var par = new Object();
	par.outValue = true;
	par.sMode = "ADD";
	par.fwid = param.fwid_podr;
	par.bdat = RBDAT.value;
	par.cod = dpDol.getCod();
	showWindow("e_dol.xml", SW_MODAL, par);
	if (!par.escape)
	{
		lowDat = RBDAT.value;
		if (bdatValid())
			return par.fwid;
	}
	return null;
}

function findFreeDol()
{
	if (NEWDOL.value == true)
		return createNewDol();
	var table = OpenTable("m", "SELECT dol.fwid AS fwid FROM ^stru_dol AS dol WHERE dol.fwid_cl=" + sqlTo(dpDol.getFWID())
					+ " AND dol.fedat=" + SqlMaxDate
					+ " AND dol.fwid_org=" + sqlTo(Number(param.fwid_podr))
					+ " AND (((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid) IS NULL)"
					+ " OR (((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)<>" + SqlMaxDate + ")"
					+ " AND ((SELECT MAX(fedat) FROM ^work_pers WHERE fwid_dol=dol.fwid)<" + sqlTo(RBDAT.value) + ")))");
	if (table.getRecordCount() <= 0)
		return createNewDol();
	table.MoveFirst();
	var fwid = null;
	if (table.getRecordCount() == 1)
	{
		fwid = table.getValue("fwid");
	}
	else
	{
		fwid = table.getValue("fwid");
		/*var par = new Object();
		par.codDol = dpDol.getCod();
		par.fwid_org = Number(param.fwid_podr);
		par.ret = new Object();
		par.ret.fwid = null;
		showWindow("l_free_dol.xml", SW_MODAL, par);
		if (!par.escape)
			fwid = par.ret.fwid;*/
	}
	if (fwid == null || !setLowDate(fwid))
		return null;
	return fwid;		
}

function validAvans(fwid_dol)
{
	//var snap = getSnap("SELECT foklad FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
	var snap = new Object();
	snap[0] = ROKLAD.getValue();
	if (snap == null)
	{
		alert(UR("Помилка даних. Не знайдено запису!|Ошибка данных. Запись не найдена!"), ICON_ERROR);
		return false;
	}

	if (Number(RAVANS.value) > Number(snap[0]))
	{
		alert(UR("Оклад складає " + snap[0] + " грн.\nАванс не може бути більшим за оклад!|"
			+ "Оклад составляет " + snap[0] + " грн.\nАванс не может быть больше оклада!"), ICON_WARNING);
		setFocus(RAVANS);
		return false;
	}
	return true;
}

function setLowDate(fwid_dol)
{
	isnew = false;
	var snap = null;
	if (extPar.mode == "EDIT")
	{
		var count = getSnap("SELECT COUNT(*) FROM ^work_pers WHERE fwid_dol=" + sqlTo(Number(fwid_dol)))[0];
		if (count <= 1)
		{
			//snap = getSnap("SELECT fbdat FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
			snap = getSnap("SELECT fbdat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol"
								+ " WHERE fwid=" + sqlTo(Number(fwid_dol)) + ")");
			isnew = true;
		}		
	}
	if (snap == null)
	{	
		var snap = getSnap("SELECT MAX(fedat) AS fedat FROM ^work_pers WHERE fwid_dol=" + sqlTo(Number(fwid_dol)));
		if (snap == null)
		{
			alert(UR("Помилка даних. Не знайдено запису!|Ошибка данных. Запись не найдена!"), ICON_ERROR);
			return false;
		}
		
		if (snap[0] == null || differ(toScriptDate(d00), toScriptDate(snap[0])) == 0)
		{
			//snap = getSnap("SELECT fbdat FROM ^stru_dol WHERE fwid=" + sqlTo(Number(fwid_dol)));
			snap = getSnap("SELECT fbdat FROM ^stru_org"
							+ " WHERE fwid=(SELECT fwid_org FROM ^stru_dol"
								+ " WHERE fwid=" + sqlTo(Number(fwid_dol)) + ")");
			isnew = true;
		}
	}


	if(snap!=null)
	{
		var tmp = toScriptDate(snap[0]);
		var year = tmp.getFullYear();
		var month = tmp.getMonth();	
		var date = tmp.getDate() + (isnew ? 0 : 1);
		lowDat = new Date(year, month, date);
	}	
	return bdatValid();
}

function resetLowDat()
{
	lowDat = null;
}

function fcod_Valid()
{
	/*if (extPar.mode == "EDIT" && NEWDOL.value == false)
		return true;
	var dolFWID = findFreeDol(false);
	if (dolFWID == null || dolFWID == -1)
		return true;
	var snap = getSnap("SELECT foklad, fshpz FROM ^stru_dol WHERE fwid=" + sqlTo(dolFWID));
	if (snap == null)
		return true;
	ROKLAD.setValue(snap[0]);
	dpShifPZ.setFshpz(snap[1]);
	Disable(ROKLAD, RSHPZ);*/
	return true;		
}

/*function restore_Valid()
{
	if(RESTORE.checked==true)
		Enable(FWID_WP);
	else
		Disable(FWID_WP);
	return true;
}*/

function fwid_wp_Valid()
{
	if(FWID_WP.value == 0)
	{
		alert(ru("Fwid не может быть нулевым!","Fwid не може бути нульовим!"))
		return false;
	}
	var snap = getSnap("SELECT * FROM ^work_pers WHERE fwid="+sqlTo(FWID_WP.value));
	if(snap==null)
		return true;
	else
	{
		alert(ru("Такой fwid уже существует!","Такий fwid вже існує!"));
		return false;
	}
}

include("sys\\DpBaseDlg.js");