// java main DpAdministration*
include ("sys/udfs.js")
var ArrObj = new Array();
var arrItems = null;
var root = null;
var struct = null;
var selectNode = null;
var xmlStructFilePath = rootDirectoryEx() + "admin_struct.xml";
var useInputPassword = false;
var editLoadedUser = false;


function onLoad()
{
	this.dataFormatText = new java.text.SimpleDateFormat();
	this.dataFormatText.applyPattern("dd.MM.yyyy");
	
	var xmldoc = openXmlFile(admin.getAdminFile());
	root = xmldoc.getDocumentElement();	
	var xmldoc = openXmlFile(xmlStructFilePath);
	struct = xmldoc.getDocumentElement();
	this.onSelPar = OnSelPar;	
	admin.treeHandler(this,"onSelPar");	
	this.onDelPar = OnDelPar;
	admin.treeMenuHandler(this,"onDelPar");		
	Caption(getCaption(root));
	admin.setXml(root);
	setButton(cancel, exit);		
}

function exit()
{
	lpProxy.getUserAccess().loadAdministrationFile();
	this.CloseWindow();
}

function OnSelPar(xmlGroup,form)
{	
	selectNode = xmlGroup;
	
	var nodes = xmlGroup.getChildNodes();
	addTitles(form, "HEADER");
	arrItems = admin.createContainer();
	editLoadedUser = false;
	for(var i = 0; i < nodes.getLength(); i++)
	{
		var node = nodes.item(i);
		if(!inList(typeOf(node),"DeferredElementImpl","ElementNode","ElementImpl")) continue;
		if (node.getAttribute("type") == "group") continue;
		if (node.getNodeName().substring(0,1) != "h" && !node.getNodeName().startsWith("DAT"))
		{
			var sParName = node.getNodeName();			
			var sValue = UR(node.getAttribute("value"));
			var fullNode = getNodeStructByTagName(struct, sParName);
			var ctrl = form.addCtrl(fullNode);			
			prepareList(ctrl, fullNode, sValue);
			prepareTextField(ctrl, fullNode, sValue);
			if (sValue != "" && ctrl!=null)
				ctrl.setValue(sValue);
			if (sParName == "LOGIN")
			{
				editLoadedUser = sValue.equalsIgnoreCase(lpProxy.getUserName());
				if (editLoadedUser)
					Disable(ctrl);
			}				
		}
		arrItems.put(node.getNodeName(), node.getAttribute("value"));	
	}
	if (accessToAddButton(selectNode.getNodeName(),
						"GROUP", new Array("GROUPS","GROUP0")))
	{
		node = getNodeStructByTagName(struct, "DATBGRP");
		var ctrl = form.addCtrl(node);
		var dat = arrItems.get("DATBGRP");
		if (dat != null && dat != "")
			ctrl.setValue(this.dataFormatText.parse(dat));
		
		node = getNodeStructByTagName(struct, "DATEGRP");
		var dat = arrItems.get("DATEGRP");
		var ctrl = form.addCtrl(node);		
		if (dat != null && dat != "")
			ctrl.setValue(this.dataFormatText.parse(dat));
		
		node = getNodeStructByTagName(struct, "PROXY_BUTT");
		var ctrl = form.addCtrl(node);		
		addActionListener(ctrl, node);
	}	
	addTitles(form, "BOTTOM");
}

function OnDelPar()
{
	if("c" == msgBox("c-"
			, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
			, ru("Удаление записи", "Вилучання запису")))
	{
		return false;	
	}
	if(!getAccessOnChange("DEL"))
		return false;

	var eLogin = null;
	if(selectNode.getElementsByTagName("DBLOGIN"))
		eLogin = selectNode.getElementsByTagName("DBLOGIN").item(0);
	else if(selectNode.getElementsByTagName("LOGIN"))
		eLogin = selectNode.getElementsByTagName("LOGIN").item(0);
	if(eLogin)
	{
		var sLogin = eLogin.getAttribute("value");
		var sMsg = UR("Видалити користувача '"+ sLogin +"' з СКБД|Удалить пользователя '"+ sLogin +"' из СУБД");
		if(confirm(sMsg))
			deleteDBUser(sLogin);		
	}
	
	return true;
}

function prepareTextField(ctrl, node, sValue)
{
	if (typeOf(ctrl) == "DpTextEx")
	{
		if (String(node.getNodeName()) == "GIDENT")
		{
			setValid(ctrl,listChar);
		}
		if (String(node.getNodeName()) == "LOGIN")
			setValid(ctrl, valid_Login);
		if (String(node.getNodeName()) == "PASS1")
			setValid(ctrl, valid_Password);		
	}
}

function listChar(obj)
{	
	var value = obj.getValue();	
	var result = "";	
	var isLatin = true;
	for (var i = 0; i < value.length(); i++)
	{
		if (value.charAt(i) >= 48 && value.charAt(i) <= 57
			|| value.charAt(i) >= 65 && value.charAt(i) <= 90
			|| value.charAt(i) >= 97 && value.charAt(i) <= 122)
		{
			result += value.substring(i, i + 1);
		}
		else
		{
			isLatin = false;
		}
	}
	if (!isLatin)
	{
		alert(UR("Индификатор должен содержать только латинские символы или цифры!|" 
			+ "Индификатор должен содержать только латинские символы или цифры!"));
	}	
	result = firstChars(result);		
	obj.setValue(result);	
}

function firstChars(value)
{
	var tmp = parseInt(value);
	if (!isNaN(tmp))
	{
		tmp = String(tmp);
		if (tmp.length != value.length)
		{
			tmp = value.substring(tmp.length);
		}
		else
		{
			tmp = "";
		}
		alert(UR("Індифікатор має починатися з літери!|Индификатор должен начинаться с буквы!"));
	}
	else
	{
		tmp = value;
	}
	return tmp;
}

// === заполнение списка групп пользователя ===
function prepareList(ctrl,node, sValue)
{
	if (typeOf(ctrl) == "DpList")
	{
		fillList(ctrl, node, sValue);
		setButton(ctrl.getButton(0),addItem);
		setButton(ctrl.getButton(1),delItem);
	}
}

function fillList(ctrl,node, sValue)
{
	var n = -1;
	while ((n = sValue.indexOf(",")) != -1)
	{
		var tmp = sValue.substring(0,n);
		ACCESS.addItem(tmp,admin.listGroup.get(tmp));
		sValue = sValue.substring(n + 1);
	}
	if (String(sValue) != "")
	{
		ACCESS.addItem(sValue,admin.listGroup.get(sValue));
	}
}

function addItem()
{
	var tmp = admin.listGroup;
	var ppar = new Object();
	ppar.arrayKey = new Array();
	ppar.arrayValue = new Array();
	
	var presentAccess = ACCESS.getKeySet();
	var k = 0;
	if (presentAccess != null)
	{
		var keys = tmp.keySet().toArray();		
		for (var i = 0; i < keys.length; i++)
		{
			var is = false;
			for (var j = 0; j < presentAccess.length; j++)
			{
				if (String(keys[i]) == String(presentAccess[j]))
				{
					is = true;
					break;					
				}
			}
			if (!is)
			{
				ppar.arrayKey[k] = keys[i];
				ppar.arrayValue[k++] = tmp.get(keys[i]);
			}
		}
	}
	else
	{
		ppar.arrayKey = tmp.keySet().toArray();
		ppar.arrayValue = tmp.values().toArray();
	}
		
	showWindow("e_admin_access.xml", SW_MODAL, ppar);
	if (ppar.arrayKey != null)
	{
		for (var i = 0; i < ppar.arrayKey.length; i++)
		{
			ACCESS.addItem(ppar.arrayKey[i],ppar.arrayValue[i]);
		}
	}
}

function delItem()
{
	ACCESS.deleteItem();
}

function addTitles(form, sType)
{
	var header, name = selectNode.getNodeName();
	var listMN = struct.getElementsByTagName("MAIN_NODE").item(0).getAttribute("value");	
	if (listMN.indexOf(selectNode.getNodeName()) != -1)
		header = struct.getElementsByTagName("MN").item(0);
	else
	{
		header = struct.getElementsByTagName("CN").item(0);
		var j = 1;	
		while (!isNaN(parseInt(name.substring(name.length() - j))))
		{
			j++;					
		}
		name = name.substring(0, name.length() - j + 1);
		header = struct.getElementsByTagName(name).item(0);			
	}	
	
	header = header.getElementsByTagName(sType).item(0);	
	var nodes = header.getChildNodes();
	for(var i = 0; i < nodes.getLength(); i++)
	{
		var node = nodes.item(i);
		if(!inList(typeOf(node),"DeferredElementImpl","ElementNode","ElementImpl")) continue;

		var sParName = node.getNodeName();
		if (sParName.substring(0,1) == "x")
			sParName = name + "_" + sParName.substring(1);
		if (node.getAttribute("ban").indexOf(selectNode.getNodeName()) == -1)
		{
			node = getNodeStructByTagName(struct, sParName);
			var ctrl = form.addCtrl(node);
			if (sParName == "PASS1" || sParName == "PASS2" || sParName == "DBPASS")
				Disable(ctrl);	
			addActionListener(ctrl, node);
		}
	}
}

function addActionListener(ctrl, node)
{
	var nodeName = node.getNodeName();
	var i = node.getNodeName().indexOf('_');
	if (i != -1)
	{
		if (nodeName.substring(i + 1) == "BUTT")
		{
			if (nodeName.substring(i - 1,i) == "S")
			{
				setButton(ctrl,addClick);
			}
			else if (nodeName.substring(0,i) == "LIST")
			{
				setButton(ctrl,showList);		
			}
			else if (nodeName.substring(0,i) == "PROXY")
			{
				setButton(ctrl,openProxy);
			}
			else if (nodeName.substring(0,i) == "DEL")
			{
				setButton(ctrl,deleteClick);
			}
			else
			{
				setButton(ctrl,editClick);
			}
		}
	}
	else
	{
		switch (String(nodeName))
		{
			case "CHPASS":
				setValid(ctrl, valid_ChangePassword);
			break;			
		}
	}
}

function valid_Login(ctrl)
{
	if(typeof(DBLOGIN)!="undefined" && DBLOGIN.value=="")
		DBLOGIN.value = ctrl.value;
	valid_dbLogin(ctrl);
}

function valid_dbLogin(ctrl)
{
	if(typeof(DBTEMP)!="undefined" && DBTEMP.value=="")
		DBTEMP.value = ctrl.value;
}

function valid_Password(ctrl)
{
	if(typeof(DBPASS)!="undefined" && DBPASS.value=="")
		DBPASS.value = ctrl.value;
}

function valid_ChangePassword(ctrl)
{
	if (ctrl.getValue() == true)
	{
		Enable(eval("PASS1"), true);
		Enable(eval("PASS2"), true);
		Enable(eval("DBPASS"), true);
	}
	else
		Disable(eval("PASS1"), eval("PASS2"), eval("DBPASS"));
}

function openProxy()
{
	var node = selectNode;
	var ppar = new Object();            
    var ident = node.getElementsByTagName("hGIDENT").item(0);
	ppar.ident = ident.getAttribute("value");
	ident = node.getElementsByTagName("GNAME").item(0);
	ppar.name = ident.getAttribute("value");
	showWindow("e_proxy.xml", SW_MODAL, ppar);
}

function showList()
{
	var gname = selectNode.getElementsByTagName("GNAME").item(0).getAttribute("value");
    var ident = selectNode.getElementsByTagName("hGIDENT").item(0).getAttribute("value");
	var nodes = root.getElementsByTagName("ACCESS");
	var length = nodes.getLength(); 
    var ppar = new Object();
    ppar.groupName = gname;
    ppar.arrayLogin = new Array();
    ppar.arrayFIO = new Array();
    var n = 0;
    for (var i = 0; i < length; i++)
    {
    	var parametr = nodes.item(i);
        var value = parametr.getAttribute("value");
        if (userInGroup(String(value), String(ident)))
        {
        	var parent = parametr.getParentNode();
        	var tmp = parent.getElementsByTagName("LOGIN").item(0);
        	ppar.arrayLogin[n] = tmp.getAttribute("value");
        	tmp = parent.getElementsByTagName("FIO").item(0); 
        	ppar.arrayFIO[n++] = tmp.getAttribute("value");
        }
    }    
	showWindow("e_admin_list_user.xml", SW_MODAL, ppar);	
	if (ppar.findLogin != null && typeof ppar.findLogin != "undefined")
	{
		admin.setSelectionTree(ppar.findLogin);
	}
}

function userInGroup(groups, group)
{
	return admin.isSubStrInStr(groups, group);
}

function addClick()
{
	var obj = admin.getformMap().get(selectNode.getNodeName()).getCtrlMap();
	var keys = obj.keySet().toArray();
	var newNodeName = getNewNodeName(root, selectNode);
	var saveMap = admin.createSaveMap();
	var sLogin = "";
	var sPassw = "";
	
	for (var i = 0; i < keys.length; i++)
	{		
		if (typeOf(obj.get(keys[i])) != "DpButton")
		{			
			saveMap.put(keys[i], obj.get(keys[i]).getValue());
			var s = obj.get(keys[i]).getValue();			
		}
	}
	if (!savingChange(newNodeName, saveMap, "ADD"))
	{
		// ОШИБКА ПРИ СОХРАНЕНИИ
	}
}

function getAccessOnChange(mode)
{
	if (!useInputPassword)
		return true;
	var adminPassword = admin.getUsePassword();
	if (adminPassword != "")
	{		
		var isOk = false;
		do
		{
			isOk = false;
			var caption = "";
			switch (mode)
			{
				case "ADD":
					caption = UR("Додавання|Добавление");
					break;
				case "EDIT":
					caption = UR("Збереження|Сохранение");
					break;
				case "DEL":
					caption = UR("Вилучення|Удаление");
					break;
				default:
					caption = "ERROR MODE";
			}
			var askFrm = createForm(caption);
			var tf = askFrm.addObj("PASS", "string", UR("Введіть пароль:|Введите пароль:"), null, 100);
			tf.setEchoChar('*');
			tf.setMask("&&&&&&&&&&&&&&");						
			if (!askFrm.show())
				return false;
			if (String(adminPassword) == String(askFrm.PASS))
				isOk = true;
			if (!isOk)
				alert(ru("Нет прав на изменение!","Нема прав на змінення!"), ICON_ERROR);							
		}
		while (!isOk);
	}
	return true;	
}

function editClick()
{
	var obj = admin.getformMap().get(selectNode.getNodeName()).getCtrlMap();
	var keys = obj.keySet().toArray();	
	var nodeName = selectNode.getNodeName();
	var saveMap = admin.createSaveMap();
	
	for (var i = 0; i < keys.length; i++)
	{
		
		if (typeOf(obj.get(keys[i])) != "DpButton")
		{
			var value = obj.get(keys[i]).getValue();
			if (isDateType(value))
				value = format("dd.mm.yyyy", value);
			saveMap.put(keys[i], value);
			var s = obj.get(keys[i]).getValue();			
		}
	}
	if (selectNode.getNodeName().indexOf("USER") != -1)
	{
		var oldPass = admin.encode(arrItems.get("hPASS"));

		if (eval("CHPASS.value") == false)
		{
			saveMap.put("PASS1", oldPass);
			saveMap.put("PASS2", oldPass);
			saveMap.put("DBPASS", oldPass);
			saveMap.remove("CHPASS");			
		}
	}
	savingChange(nodeName, saveMap, "EDIT");
}

function deleteClick()
{	
	if (editLoadedUser)
	{
		alert(UR("Дана операція заборонена!|Данная операция запрещена!"), ICON_WARNING);
		return;
	}
	admin.onDelParam();
}

function addResult(result, data)
{
	for (var i = 0; i < result[0].length; i++)
	{
		data.put(result[i][0],result[i][1]);
	}
}

function savingChange(nodeName, data, mode)
{
	if (data != null)
	{
		if (data.containsKey("PASS1"))
		{			
			if (data.get("LOGIN").equals(""))
			{
				alert(UR("Логін не може бути порожнім!|Логин не может быть пустым!"), ICON_WARNING);
				return false;
			}
			if (String(arrItems.get("LOGIN")) != data.get("LOGIN")
				&& admin.controlNames("USERS", "LOGIN", data.get("LOGIN")))
			{
				alert(UR("Такий логін вже використовується!|Такой логин уже используется!"), ICON_WARNING);
				return false;
			}
			
			if (String(data.get("PASS1")) != String(data.get("PASS2")))
			{
				alert(UR("Паролі не співпадають!|Пароли не совпадают!"), ICON_WARNING);
				setFocus(eval("PASS1"));
				return false;
			}
			var pass = admin.code(data.get("PASS1"));
			arrItems.put("hPASS",pass);
			data.put("hPASS", pass);
			
			var sPass = data.get("PASS1");
			if(data.get("DBPASS"))
			{
				sPass = data.get("DBPASS");
				var pass = admin.code(sPass);
				arrItems.put("hDBPASS",pass);
				data.put("hDBPASS", pass);
				data.remove("DBPASS");
			}			
			
			data.remove("PASS1")
			data.remove("PASS2");			
			
			if (String(data.get("ACCESS")) == "")
			{
				alert(UR("Не встановлено жодної групи!|Не установлено ни одной группы!"), ICON_WARNING);
				return false;
			}
			
			if (!getAccessOnChange(mode))
				return false;
						
			if (!admin.saveChanges(nodeName, data)) 
			{
				return false;
			}
			try
			{
				eval("CHPASS").value = false;
				eval("PASS1").value = "";
				eval("PASS2").value = "";
				eval("DBPASS").value = "";
				if (equalsIgnoreCase(data.get("LOGIN"), lpProxy.getUserName()))
					lpProxy.loadAccess(data.get("LOGIN"), admin.encode(data.get("hPASS")));					
			}	
			catch(x)
			{}
			
			if(mode=="ADD")
			{
				var dbUser = data.get("DBLOGIN");
				if(!dbUser || dbUser=="")
					dbUser = data.get("LOGIN");
				createUser(dbUser, sPass);			
			}		
			return true;								
		}
		else
		{		
			if (data.containsKey("GIDENT"))
			{
				data.put("hGIDENT", data.get("GIDENT"));
				data.remove("GIDENT");
			}
			else
			{
				data.put("hGIDENT", String(arrItems.get("hGIDENT")));
			}
			if (data.get("GNAME").equals(""))
			{
				alert(UR("Назва не може бути порожня!|Название не может быть пустым!"), ICON_WARNING);
				return false;
			}
			if (String(arrItems.get("GNAME")) != data.get("GNAME")
				&& admin.controlNames("GROUPS", "GNAME", data.get("GNAME")))
			{
				alert(UR("Така назва вже використовуэться!|Такое название уже используется!"), ICON_WARNING);
				return false;
			}
			if (data.get("hGIDENT").equals(""))
			{
				alert(UR("Ідентифікатор не може бути порожнім!|Идентификатор не может быть пустым!"), ICON_WARNING);
				return false;
			}
			if (String(arrItems.get("hGIDENT")) != data.get("hGIDENT")
				&& admin.controlNames("GROUPS", "hGIDENT", data.get("hGIDENT")))
			{
				alert(UR("Такий ідентифікатор вже використовуэться!|Такой идентификатор уже используется!"), ICON_WARNING);
				return false;
			}
			
			if (!getAccessOnChange(mode))
				return false;
							
			if (!admin.saveChanges(nodeName, data))
			{
				return false;
			}
			return true;	
		}
	}
}

// вспомогательные функции

function accessToAddButton(nodeName, mask, arg)
{
	var nName = String(nodeName);
	var nMask = nName.substring(0, mask.length);	
	if (nMask == mask)
	{
		if (typeof arg == "object")
		{
			for (var i = 0; i < arg.length; i++)
			{
				if (nName == arg[i])
				{
					return false;
				}
			}
			return true;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}

function getNewNodeName(root, parentNode)
{
	var nodeName = parentNode.getNodeName().
					substring(0, selectNode.getNodeName().length() - 1);
	if (nodeName == "USER")
	{
		return nodeName + root.getAttribute("counterUser");
	}
	else
	{
		return nodeName + root.getAttribute("counterGroup");	
	}
}

function getNodeStructByTagName(root, tagName)
{
	var sector = root.getElementsByTagName("STRUCT").item(0);
	return sector.getElementsByTagName(tagName).item(0);		
}

function getCaption(root)
{
	return UR(root.getAttribute("text"));
}

function createUser(login, password)
{
	var sMsg = UR("Додати користувача до СКБД?|Добавить пользователя в СУБД?");
	if(SUBD==POSTGRE || SUBD==MYSQL || SUBD==MSSQL || SUBD==ORACLE || SUBD==H2)
	{
		if(confirm(sMsg))
			return createDBUser(login, password);
	}	
}