include("objects/DpCl.js");		// для таб.номера
include("servis/date.js");
include("servis/format.js");

var weekday = new Array();
	weekday[1] = "Пн"
	weekday[2] = "Вт"
	weekday[3] = "Ср"
	weekday[4] = "Чт"
	weekday[5] = "Пт"
	weekday[6] = "Сб"
	weekday[7] = ru("Вс","Нд")
	
// массив праздников, год не имеет значение
var aHoliday = new Array();
	aHoliday[0] = new Date(2005, 0, 1);
	aHoliday[1] = new Date(2005, 0, 7);
	aHoliday[2] = new Date(2005, 2, 8);
	aHoliday[3] = new Date(2005, 4, 1);
	aHoliday[4] = new Date(2005, 4, 2);
	aHoliday[5] = new Date(2005, 4, 9);
	aHoliday[6] = new Date(2005, 5, 28);
	aHoliday[7] = new Date(2005, 7, 24);

var attr = new Array();// = "Р,В,П";
var aDay = new Array();
var dat1;

var numDay = 0;
var offset;
var mFwid;
var edmode;
var tblR, tblH;
var edCapt = '';

var sprPers = typeof(getPar("CODPERS")) == "number" ? getPar("CODPERS") : 2;

var tblCal, tblHc;
var oPers;		//объект - справочник персонала

function Load()
{
	oPers = new DpCl(sprPers, 0);
	oPers.linkCtrl(FTABN, tFTABN);

	FFULLTIME.mask = "###.##"
	FHALFTIME.mask = "###.##"
	edmode = extPar.mode;
	mFwid = edmode == "EDIT" ? extPar.fwid : GetUID();
	tblCal = extPar.tbl_cl_cal;
	mFnum.mask = "####";
	mFnum.value = extPar.fcod;

	if(edmode=="COPY")
	{
		tblHc = extPar.tbl_hc;
		FREM.value = tblHc.getValue("FREM");
		FFULLTIME.value = tblHc.getValue("FFULLTIME");
		FHALFTIME.value = tblHc.getValue("FHALFTIME");
	}
	//установим фокус на дату
	setFocus(FDOC_DAT);
	var dt = new Date();
	dat = firstDay(dt);
	FDOC_DAT.value = dat;
	strSQL = "SELECT FNAMS_NVK FROM ^CL_NVK";

	attr[0] = "Р";
	attr[1] = "В";
	attr[2] = "П";
	
	switchMode(edmode);
	setValid(FDOC_DAT, FDOC_DAT_Valid);
	setValid(mFnum, mFnum_valid);
	setValid(FREM, FREM_valid);
	setWhen(FREM, FREM_when);

	//var msg = "Вийти без збереження змін?"
	//setOnEscapeMsg(msg);
	Caption(ru("Календарь на ","Календар на ") + StrDat(dat, "DMY") + edCapt);
	if(edmode!="EDIT")
	{
		strSQL = "SELECT MAX(FDATE) as Fdat, count(*) as Fcnt FROM ^HCALEND WHERE FCOD = " + sqlTo(mFnum.value)
				+(tblCal.getValue("FISTABN")==true ? " AND FTABN = " + FTABN.value : "");
		var snap = getSnap(strSQL);
		if(snap && snap[1])
		{
			FDOC_DAT.value = goMonth(snap[0],1);
			FREM_when();
		}
	}
}

function switchMode(edmode)
{
	Disable(mFnum);
	Disable(FISHOURS);
	FISHOURS.checked = tblCal.getValue("FISHOURS")==true;
	oPers.setCod(extPar.ftabn);
	FTABN.setEnabled(false);
/*	if (edmode != "ADD" && toScrObj(tblCal.getValue("FISTABN")))
		FTABN.setEnabled(false);
	else
		FTABN.setEnabled(toScrObj(tblCal.getValue("FISTABN")));*/
	
	switch (edmode)
	{
		case "EDIT":
			getHValToCtrl();
			fireControls("", FDOC_DAT.value);
			getRValToCtrl();
			edCapt = " - редактирование";
			break;
		case "COPY":
			getHValToCtrl();
			fireControls("NEW", FDOC_DAT.value);
			getRValToCtrl();
			edCapt = " - копирование";
			break;
		case "ADD":
			fireControls("NEW", FDOC_DAT.value);
			//FREM.value = tblCal.getValue("FREM");
			edCapt = " - добавление";
			break;
	}
}

// "Зажигает контролы" для м-ца
// mode=="new" - Заполняет контролы значениями по умолчанию
function fireControls(mode, dt)
{
	if (typeof(mode)!="string")
		mode = "NEW";
	mode = mode.toUpperCase();

	dat1 = new Date(dt);

	var D1 = firstDay(dat1);
	var D2 = lastDay(dat1);
	
	numDay = D2.getDate();
	
	offset = new Date(D1).getDay();
	//var nDat = 1;
	
	if (offset == 0)
		offset = 7;
	var full_hours = Number(getPar("FULL_DAY_HOURS"))+Number(getPar("FULL_DAY_MINUTES"))/60;
	var short_hours = Number(getPar("SHORT_DAY_HOURS"))+Number(getPar("SHORT_DAY_MINUTES"))/60;
	for(var i=1; i<=37; i++)
	{
		if(i<offset || i>numDay+offset-1)
		{
			document["L"+i].setVisible(false);
			document["T"+i].setVisible(false);
			document["C"+i].setVisible(false);
		}
		else
		{
			nDay = i-offset+1;
			// проставим праздничные дни
			if (mode == "NEW")
			{
				curMonth = D1.getMonth();
				nDayOfWeek = new Date(D1.getYear()+1900,D1.getMonth(),nDay).getDay();
				document["C"+i].value = (nDayOfWeek>0 && nDayOfWeek<6)?"Р":"В";
				for (var j = 0; j < aHoliday.length; j++)
				{
					if (aHoliday[j].getMonth()==curMonth && aHoliday[j].getDate()==nDay)
						document["C"+i].value = "П";
				}
			}
			document["L"+i].text = nDay;
			document["L"+i].setVisible(true);
			document["T"+i].setVisible(true);
			document["T"+i].mask = "##.##";
			document["C"+i].setVisible(true);
			//по умолчанию инициализируем часы в обычных рабочих днях и в неполных рабочих днях (пятницах) исходя из параметров
			if(edmode == "ADD")
			{
				if(nDayOfWeek>0 && nDayOfWeek<5)
					document["T"+i].value = full_hours;
				if(nDayOfWeek==5)
					document["T"+i].value = short_hours;
			}
		}
//пероначально галочка расчета по часам относилась только к больничным, часы в календаре должны указываться всегда
//		if(tblCal.getValue("FISHOURS")==false)
//			document["T"+i].setEnabled(false);
		
	}
	DAYSGRP.layout(true, true);
}

function getHValToCtrl()
{
	//проставим дату и номер календаря
	strSQL = " SELECT FDATE, FREM, FCOD, FFULLTIME, FHALFTIME "
			+" FROM ^HCALEND"
			+" WHERE FWID = " + sqlTo(mFwid)
	var oSnap = getSnap(strSQL);
	if (oSnap!=null)
	{
		var fdoc_dat = oSnap[0];
		var frem = oSnap[1];
		var fnum = oSnap[2];
		var ffulltime = oSnap[3];
		var fhalftime = oSnap[4];
		FDOC_DAT.value = fdoc_dat;
		mFnum.value	 = fnum;
		FREM.value = frem;
		FFULLTIME.value = Number(ffulltime);
		FHALFTIME.value = Number(fhalftime);
	}
}

function getRValToCtrl()
{
	var offset = new Date(FDOC_DAT.value).getDay();
	offset=(offset==0?7:offset);
	//Подтянем строки 
	strSQL = "SELECT *"
			+" FROM ^RCALEND"
			+" WHERE FID_CAL = " + sqlTo(mFwid)
	tblR = OpenTable("s", strSQL);
	for (tblR.MoveFirst(); !tblR.IsEOF(); tblR.MoveNext())
	{
		// Число
		nDay = new Date(tblR.getValue("FDATE")).getDate();
		nIndex = nDay + offset-1;
		document["T"+nIndex].value = tblR.getValue("FKOLCHAS");
		document["C"+nIndex].value = tblR.getValue("FATTR");
	}
}

function onSave()
{
	switch (edmode)
	{
		case "ADD": 
		case "COPY":
			saveTables();
		break;
		case "EDIT":
			strSQL = "DELETE FROM ^HCALEND"
				+" WHERE FWID = " + sqlTo(mFwid);
			ExecuteSQL(strSQL);

			strSQL = "DELETE FROM ^RCALEND"
				+" WHERE FID_CAL = " + sqlTo(mFwid)
			ExecuteSQL(strSQL);
			saveTables("", mFwid);
		break;
	}
}

function saveTables(mode, szFwid)
{
	if (typeof(szFwid) == 'undefined')
		szFwid = GetUID();
	var m = new Object();
	m.Fdate = FDOC_DAT.value;
	m.Fcod = mFnum.value;
	m.Frem = FREM.value;
	m.Ftabn = FTABN.value;
	m.Ffulltime = FFULLTIME.value;
	m.Fhalftime = FHALFTIME.value;
	m.Fwid = szFwid;
	UpdateTable("^HCALEND", m, true);

	var offset = new Date(FDOC_DAT.value).getDay();
	offset = (offset == 0 ? 7 : offset);

	for(var i = 1; i <= numDay; i++)
	{
		nIndex = i + offset-1;
		var m = new Object();
		m.Fattr = document["C"+nIndex].value;
		dat1 = new Date(FDOC_DAT.value);
		m.Fdate = (new Date(dat1.getFullYear(), dat1.getMonth(), i)).getVarDate();
		m.Fid_cal = szFwid;
		m.Fkolchas = document["T"+nIndex].value;
		m.Fwid = GetUID();
		UpdateTable("^RCALEND", m, true);
	}
}

function FDOC_DAT_Valid()
{
	var retval = true;
	dt1 = new Date(FDOC_DAT.value);
	//Защита от дурака (если введено 15,01,2004 то нам нужно 01,01,2004)
	dat1 = new Date(firstDay(dt1));
	FDOC_DAT.value = dat1.getVarDate();
	if (dat1.getFullYear() == d00obj.getFullYear() 
		&& dat1.getMonth() == d00obj.getMonth() 
		&& dat1.getDate() == d00obj.getDate()
	)
	{
		WAIT("Пустая дата недопустима")
		return false;
	}

	strSQL = "SELECT * FROM ^HCALEND WHERE "
				+" FDATE = " + sqlTo(FDOC_DAT.value)
				+" AND FCOD = " + sqlTo(mFnum.value)
				+" AND FWID <> " + sqlTo(mFwid)
				+(tblCal.getValue("FISTABN")==true? " AND FTABN = " + FTABN.value : "");

	var sn = getSnap(strSQL);
	if (sn!=null)
	{
		WAIT(ru("Календарь на эту дату уже существует", "Календар на цю дату вже існує"));
		retval = false;
	}
	else
	{
		if (!isSaving())
		{
			//Если зашли на редактирование или копирование, то обновляем по умному.
			fireControls((edmode=="ADD"||edmode=="COPY"?"NEW":""), FDOC_DAT.value);
		}
	}
	return retval;
}

function mFnum_valid()
{
	var retval = true;
	var oSnap = getSnap("select fwid from ^HCALEND where Fdate="
			+sqlTo(FDOC_DAT.value)+" and Ftabn="+sqlTo(mFnum.value))
	if(oSnap!=null)
	{
		WAIT(UR("Календар з таким номером вже існує|Календарь с таким номером уже существует"));
		retval = false;
	}
	return retval;
}

function FREM_valid()
{
	if(FREM.value == "" || FREM.value == null)
	{
		WAIT("Пустое значение недопустимо");
		return false;
	}
	return true;
}

function FREM_when()
{
	if(FREM.value == "")
		FREM.value = format("Mmm yyyy",FDOC_DAT.value); 
}

function FFULLTIME_Valid()
{
	if (FFULLTIME.value == 0)
	{
		WAIT(ru("Нулевое значение недопустимо", "Нульове значення неприпустиме"));
		return false;
	}
	return true;
}

function FHALFTIME_Valid()
{
	if (FHALFTIME.value == 0)
	{
		WAIT(ru("Нулевое значение недопустимо", "Нульове значення неприпустиме"));
		return false;
	}
	return true;
}