//"JAVA compatible[Sandy]"
include ("objects/DpXMLDomDocument.js")

var edmode,m_fwid,tbl = new Object();
var strVar = "";
var strFfile = "";
var bnkconfpath = "\clbank\bnkconf.xml";
var bnkconffileis = false;//true? esli est file clbank/bnkconf.xml
var bnkconfis = false;//true? esli est yzel "BANKCONFIG"
var root = null;//root of bnkconf.xml = BANKCONFIG.
var clbSetting = null;
var bnkConfObj = null;
var isTxtJS = false;

function bnkParams()
{
	this.cFformat = "";	
	this.clbdir = "";
	this.debdir = "";
	this.clbmask = "";
	this.debmask = "";
	this.clbclean = false;
	this.olddelete = false;
	this.tryshow = false;
	this.cduplic = false;
	this.cimportpppv = false;
	this.clbdebug = false;
	this.rename = false;
	this.arhiv = true;
	this.impalrimp = 0;
	this.dformat = "";
	this.period = false;
	this.bvo = false;
	this.setDocDatByFormat = false;
}

function Load()
{
	Caption(ru("Редактирование параметров импорта из к-б","Редагування параметрів імпорту з к-б"),	extPar.mode);
		   
	bnkconfpath = getOrgPath() + "clbank/bnkconf.xml";
	var confFile = new DpFile(bnkconfpath);
	var alertStr = "";
	if (!confFile.exists())
	{
		var alertStr = UR('Файл "' + bnkconfpath + '" не існує.|Файл "' + bnkconfpath + '" не существует.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}
	
	fill_dformat();
	var xmlDoc = new DpXMLDOMDocument();
	xmlDoc.load(bnkconfpath);
	var root = xmlDoc.getDocumentElement();
	if (!root.getNodeName().equalsIgnoreCase("BANKCONFIG"))
	{
		alertStr = UR('Файл "' + bnkconfpath + '" зіпсовано. Вузол BANKCONFIG не існує.'
							+ '|Файл "' + bnkconfpath + '" испорчен. Нет узла BANKCONFIG.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}
	
	bnkConfObj = new bnkParams();
	bnkConfObj.cFformat = extPar.bnkLbl;
	var bnkconfnode = root.getElementsByTagName(extPar.bnkLbl)[0];
	if (bnkconfnode != null)
		bnkConfObj = initObjFromAttr(bnkConfObj, bnkconfnode);			
	setValueOn("CONTROL");
    Disable(cFformat);
    
    //определяем является ли настройка импорта текстового файла импортируемого с помощью отдельного скрипта
	var xmlBnk = new DpXMLDOMDocument();
	var bnkPath = getOrgPath() + "clbank/"+extPar.bnkLbl+".xml";
	if(!isFile(bnkPath))
	{
		bnkPath = getOrgPath() + "clbank/"+extPar.bnkLbl+".XML";
		if(!isFile(bnkPath))
		{
			alertStr = UR('Файл "' + bnkPath + '" не знайдено. Скоріш за все помилка в регістрі імені або розширення файлу.'
							+ '|Файл "' + bnkPath + '" не найден. Скорей всего ошибка в регистре имени или расширения файла.');		
			alert(alertStr, ICON_ERROR);
			return false;
		}
	}
	xmlBnk.load(bnkPath);
	bnkRoot = xmlBnk.getDocumentElement();
	var typeAttr = bnkRoot.getAttribute("type").toUpperCase();
	var rowAttr = bnkRoot.getAttribute("row").toUpperCase();
	if(typeAttr=="TXT" && rowAttr.length==0)
		isTxtJS = true;
	
    jsValid();
	setFocus(clbdir);
	setValid(bvo,bvo_Valid);
	setValid(dformat,dformat_Valid);
	setValid(setDocDatByFormat,setDocDatByFormat_Valid);
	setValid(period,period_Valid);
	setValid(clbmask,clbmask_Valid);
	dformat_Valid();
}

function setValueOn(key)
{
	for (var i in bnkConfObj)
	{
		try
		{
			var oCtrl = eval(i);
			if (typeof oCtrl == "object")
			{
				if (key == "CONTROL")
					oCtrl.value = bnkConfObj[i];
				else if (key == "PARAMETR")
					 bnkConfObj[i] = oCtrl.value;
			}
		}
		catch(x){}
	}
}

//function rename_Valid()
//{
//	if (rename.getValue() == false)
//		debmask.setReadOnly(true);
//	else
//		debmask.setReadOnly(false);
//}

function cFformatValid()
{
/*
	var res = false;
	var b	= getSnap("SELECT * FROM ^U_IMPFMT WHERE FFORMAT=" + sqlTo(cFformat.value));
	if(edmode != "EDIT")//в "EDIT" это поле disabled.
	{
		if(cFformat.value == "")
		{
			alert(UR("Введіть назву формату.|Введите название формата."));			
			return res;
		}		
		if(cFformat.value.substring(0, 2).toUpperCase() != "U_")
		{
			alert(UR("Назва формату мусить починатися з 'U_'.|Название формата должно начинаться с 'U_'."));
			return res;
		}
		//проверим, чтобы формат не повторился
		if(b)
		{
			alert(UR("Формат з такою назвою вже існує.|Формат с таким именем уже существует."));
			return res;
		}
	}
	else if(!b)
	{
		//редактирование становимся на запись
		alert(UR("Помилка, формат не знайдено.|Ошибка, формат не найден."));
		return res;
	}
	res = true;
	return res;
	*/
}

function onSave()
{
	var obj = new Object();	
	var xmlDoc = new DpXMLDOMDocument();
	xmlDoc.load(bnkconfpath);
	root = xmlDoc.getDocumentElement();
	if (!root.getNodeName().equalsIgnoreCase("BANKCONFIG"))
	{
		alertStr = UR('Файл "' + bnkconfpath + '" зіпсовано. Вузол BANKCONFIG не існує.'
							+ '|Файл "' + bnkconfpath + '" испорчен. Нет узла BANKCONFIG.');		
		alert(alertStr, ICON_ERROR);
		return false;	
	}	
	setValueOn("PARAMETR");
	var bnkconfnode = root.getElementsByTagName(extPar.bnkLbl)[0];
	var BNKLblEl = null;
	var create = (bnkconfnode == null || bnkconfnode == undefined);
	if (create == true)
		BNKLblEl = xmlDoc.createElement(extPar.bnkLbl);
	else
		BNKLblEl = root.getElementsByTagName(extPar.bnkLbl)[0];
	loadObjToAttr(BNKLblEl, bnkConfObj, "cFformat");
	if (create == true)
		root.appendChild(BNKLblEl);
	xmlDoc.save(bnkconfpath);
}

function jsValid()
{
	if(!isTxtJS)
	{
		period.enabled = true;
		bvo.enabled = true;
	}
	else
	{
		period.enabled = false;
		bvo.enabled = false;
		period.value = false;
		bvo.value = false;
	}
}

function bvo_Valid()
{
	if(bvo.value == true)
		WAIT(ru("Платежи будут связаны с док-м BVO, который будет контролировать их дебетовую и кредитовую суммы",
				"Платежі будуть зв'язані з док-м BVO, який буде контролювати їх дебетову та кредитову суми"));
}

function dformat_Valid()
{
	if(Array.every(String(dformat.value), isCorectDForamt) && String(dformat.value).length>0)
	{
		setDocDatByFormat.enabled = true;
		return true;
	}
	else
	{
		setDocDatByFormat.enabled = false;
		setDocDatByFormat.value = false;
		if(String(dformat.value).length>0)
		{
			WAIT(ru("Некоректний формат дати в імені файлу!","Некоректный формат даты в имени файла!"))
			return false;
		}
		else
			return true;		
	}
}

function setDocDatByFormat_Valid()
{
	if(setDocDatByFormat.value==true)
		period.value = false;
}

function period_Valid()
{
	if(period.value==true)
		setDocDatByFormat.value = false;
}

function clbmask_Valid()
{
	if(clbmask.value.indexOf("*")==-1)
	{
		dformat.value = "";
		dformat.enabled = false;
	}
	else
		dformat.enabled = true;
}

function fill_dformat()
{
	dformat.addItem("0", "yy|mm|dd");
	dformat.addItem("1", "yyyy|mm|dd");
	dformat.addItem("2", "dd|mm|yy");
	dformat.addItem("3", "dd|mm|yyyy");
	dformat.addItem("4", "yy-mm-dd");
	dformat.addItem("5", "yyyy-mm-dd");
	dformat.addItem("6", "dd-mm-yy");
	dformat.addItem("7", "dd-mm-yyyy");
	dformat.addItem("8", "yy.mm.dd");
	dformat.addItem("9", "yyyy.mm.dd");
	dformat.addItem("10", "dd.mm.yy");
	dformat.addItem("11", "dd.mm.yyyy");
	dformat.addItem("12", "yy_mm_dd");
	dformat.addItem("13", "yyyy_mm_dd");
	dformat.addItem("14", "dd_mm_yy");
	dformat.addItem("15", "dd_mm_yyyy");
}

function isCorectDForamt(ch)
{
	return (ch=="d" || ch=="m" || ch== "y" || ch=="|" || ch=="-" || ch=="." || ch=="_");
}

include("sys/DpBaseDlg.js");