include("Objects/DpExtentionBuilder.js");

var tbl = extPar.m_pTable;
var oImporter = extPar.importer;
var objType = extPar.objType;
var sVarsTbl = null;
var nLength = 0;
var param = "";

function onLoad()
{
	Caption(UR("Імпорт: змінні|Импорт: переменные"));
	
	if(objType=="cl" || objType=="doc" || objType=="docrow")
		loadRowsClass();	
	fillVarsType();
		
	if(extPar.mode=="EDIT" || extPar.mode=="COPY")
	{
		FSOURCE.value = tbl.getValue("FSOURCE");
		FVAR.value = tbl.getValue("FREC");
		if(tbl.getValue("FROW")==true)
			FROW.checked = true;
		FROWCLASS.value = tbl.getValue("FROWCLASS");
		if(tbl.getValue("FNEWSOURCE")==true)
			FNEWSOURCE.checked = true;
		FOBJSOURCE.value = tbl.getValue("FOBJSOURCE");
		FOBJCOD.value = tbl.getValue("FOBJCOD");
		FLINK.value = tbl.getValue("FLINK");
		FTXT.value = tbl.getValue("FTXT");
		FTYPE.value = tbl.getValue("FTYPE");
		nLength = tbl.getValue("FLENGTH");
		if(!Number(nLength))
			nLength = oImporter.getVarLength(FVAR.value, tbl.getValue("FTYPE"));
		param = tbl.getValue("FPARAM");
	}
	if(!FOBJSOURCE.value || FOBJSOURCE.value=="null")
		FOBJSOURCE.value = "";
	
	FVAR.setButton(true);
	this.varSelect = varSelect;
	setButton(FVAR, this, "varSelect");
	
	FSOURCE.setButton(true);
	this.sourceSelect = sourceSelect;
	setButton(FSOURCE, this, "sourceSelect");
	
	FOBJSOURCE.setButton(true);
	this.createObject = createObject;
	setButton(FOBJSOURCE, this, "createObject");
		
	setValid(FNEWSOURCE, new_source_valid);	
	setValid(FTYPE, var_type_valid);
	setValid(FROW, row_valid);
		
	Disable(FOBJTXT);
	this.rec_selected = rec_selected;	
	setButton(FOBJCOD, this, "rec_selected");
			
	new_source_valid();	
	var_type_valid();
	row_valid();
}

function onSave()
{
	var m = new Object();
	if(extPar.mode!="EDIT")
		m.FWID = GetUID();
	m.FSOURCE = FSOURCE.value;
	m.FREC = FVAR.value;
	m.FTXT = FTXT.value;
	m.FTYPE = FTYPE.value;
	m.FNEWSOURCE = FNEWSOURCE.checked;
	m.FOBJSOURCE = "";
	if(FNEWSOURCE.checked==true)
		m.FOBJSOURCE = FOBJSOURCE.value;
	m.FLINK = FLINK.value;
	if(Number(nLength))
		m.FLENGTH = nLength;
	m.FOBJCOD = FOBJCOD.value;
	if(param)
		m.FPARAM = param;
	m.FROW = false;
	m.FROWCLASS = "";
	if(FROW.checked==true)
	{
		m.FROW = FROW.value;
		m.FROWCLASS = FROWCLASS.value;
	}
	UpdateTable(tbl.getTableName(), m, extPar.mode!="EDIT");
}

function fillSourceCombo(oCtrl)
{
	if(!oImporter)
		return;
	for(fld in oImporter.fldMap)
		oCtrl.addItem(fld, fld);
}

function fillVarsType()
{
	FTYPE.addItem("text", UR("Текст|Текст"));
	FTYPE.addItem("longtext", UR("Довгий текст|Длинный текст"));
	FTYPE.addItem("short", UR("Ціле число|Целое число"));
	FTYPE.addItem("long", UR("Велике ціле число|Большое целое число"));
	FTYPE.addItem("double", UR("Число з плав. точкою|Число с плав. точкой"));
	FTYPE.addItem("currency", UR("Грошовий|Денежный"));		
	FTYPE.addItem("date", UR("Дата|Дата"));
	FTYPE.addItem("bit", UR("так/ні|да/нет"));
	//FTYPE.addItem("cls.cl.12", UR("Контрагенти|Контрагенты"));
	FTYPE.addItem("cls.cl", UR("Аналітика|Аналитика"));
	FTYPE.addItem("nmk", UR("Номенклатура|Номенклатура"));	
	FTYPE.addItem("cls.edi", UR("Одиниці виміру|Единицы измерения"));
	FTYPE.addItem("cls.cntrct", UR("Угода|Договор"));
	
	FTYPE.value = "text";
}

function loadRowsClass()
{
	if(!extPar.obj)
		return;
		
	GRROW.setVisible(true);
	
	var obj = extPar.obj.jObj;
	if(objType=="doc" || objType=="docrow")
		obj = extPar.obj.jDoc;
	if(!obj || !obj.hasChilds())
		return;
	var arrClass = obj.getChildIDs();
	if(!arrClass || Number(arrClass.length)<1)
		return;
	for(var i=0; i<arrClass.length; i++)
	{
		var sRowClass = arrClass[i];
		if(!sRowClass || sRowClass=="CLNUM")
			continue;
		FROWCLASS.addItem(arrClass[i], arrClass[i]);
	}
	FROWCLASS.value = arrClass[0];
}

function row_valid()
{
	sVarsTbl = null;
	if(FROW.value==true)
		Enable(FROWCLASS);
	else
		Disable(FROWCLASS);
}

function new_source_valid()
{
	if(FNEWSOURCE.checked==true)
	{
		Enable(FOBJSOURCE);
		Enable(FLINK);
	}
	else
	{
		Disable(FOBJSOURCE);
		Disable(FLINK);
	}
}

function var_type_valid()
{
	var sType = String(FTYPE.value);	
	if(oImporter.isObject(sType))
	{		
		if(sType.indexOf("cls.")!=-1)
			sType = sType.substring(4);
		GRSOURCE.setVisible(true);
		if(sType=="nmk" || sType=="cl" || sType=="cntrct")
		{
			LOBJCOD.setText(UR("       Довідник:|       Справочник:"));
			if(sType=="nmk")
				LOBJCOD.setText(UR("       Група:|       Группа:"));
			else if(sType=="cntrct")
				LOBJCOD.setText(UR("       Документ:|       Документ:"));
			GROBJ.setVisible(true);
		}
		else
		{
			GROBJ.setVisible(false);
		}		
	}
	else
	{
		GRSOURCE.setVisible(false);
		GROBJ.setVisible(false);
	}
}

function varSelect()
{
	if(!sVarsTbl)
	{
		sVarsTbl = "TMP_REC_VARS";
		if(!fillVars(sVarsTbl))
			return false;
	}
	if(!IsTable(sVarsTbl))
		return false;
		
	var par = new Object();
	par.ret = new Object();
	par.ret.FREC = "";
	par.ret.FTYPE = "";
	par.ret.FTXT = "";
	par.ret.FLENGTH = 0;
	
	par.cells = new Object();
	par.cells[1] = new Object();
	par.cells[1].name = "FREC";
	par.cells[1].width = 15;
	par.cells[1].text = UR("Поле|Поле");
	
	par.cells[2] = new Object();
	par.cells[2].name = "FTYPE";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Тип|Тип");
		
	par.cells[3] = new Object();
	par.cells[3].name = "FTXT";
	par.cells[3].width = 10;
	par.cells[3].text = UR("Примітка|Примечание");
	
	par.caption = UR("Приймач|Приемник");
	var tbl = OpenTable("select * from "+ sVarsTbl +" order by FREC");
	browse(tbl, par, SW_MODAL);
	
	if(par.ret.FREC)
		FVAR.value = par.ret.FREC;
	if(par.ret.FTYPE)
		FTYPE.value = oImporter.getDpType(par.ret.FTYPE);
	if(par.ret.FTXT && String(FTXT.value).trim()=="")
		FTXT.value = par.ret.FTXT;
	if(par.ret.FLENGTH)
		nLength = par.ret.FLENGTH;
	else
		nLength = oImporter.getVarLength(par.ret.FREC, par.ret.FTYPE);
}

function fillVars(sVarsTbl)
{
	ExecuteSQL("drop table "+ sVarsTbl, false);
	var base = extPar.base;
	var sTblName = extPar.rec;
	if(objType=="tbl" || objType=="nmk" || objType=="pri")
	{
		if(!IsTableEx(base, sTblName))
			return false;		
		oImporter.createVarsTbl(sVarsTbl);
		if(base)
		{
			if(SUBD==MSSQL)
				sTblName = base +".."+ sTblName;
			else
				sTblName = base +"."+ sTblName;
		}
		
		include("objects/DpXMLDomDocument.js");
		var xmlDom = new DpXMLDOMDocument();
		xmlDom.load(rootDirectoryEx() + "dbstru.xml");
		var listInfo = xmlDom.getDocumentElement();
		var struTbl = sTblName;
		if(struTbl.indexOf("_")!=-1)
			struTbl = struTbl.substring(struTbl.indexOf("_")+1);
		if(objType=="pri")
			struTbl = "PRICE";
		var xmlTbl = listInfo.getElementsByTagName(struTbl)[0];
		
		var tbl = OpenTable(sTblName);	
		var i=1;
		for(i=1; i<=tbl.fieldCount(); i++)
		{
			var fInfo = tbl.getFieldInfo(i);
			if(!fInfo)
				continue;
			var m = new Object();
			m.FCOD = String(i);			
			m.FREC = fInfo.getName();
			m.FTYPE = fInfo.getDpType();
			m.FLENGTH = oImporter.getVarLength(m.FREC, m.FTYPE);
			if(xmlTbl)
			{
				var xmlFld = xmlTbl.getElementsByTagName(m.FREC)[0];
				if(xmlFld)
					m.FTXT = UR(xmlFld.getText());
			}
			UpdateTable(sVarsTbl, m, true);
		}
		if(objType=="nmk")
		{
			var extBuilder = new DpExtentionBuilder("CL_NMK");
			extBuilder.load();			
			for(sLabel in extBuilder.arrExt)
			{
				var m = new Object();
				m.FCOD = String(++i);			
				m.FREC = "X_F"+ sLabel;
				m.FTYPE = oImporter.getDpType(extBuilder.arrExt[sLabel].FTYPE);
				m.FLENGTH = extLength(extBuilder.arrExt[sLabel].FFORMAT, m.FTYPE);
				m.FTXT = extBuilder.arrExt[sLabel].FTXT;
				m.FTXT = UR("Розширення: |Расширение: ") + m.FTXT;
				UpdateTable(sVarsTbl, m, true);
			}
		}		
	}
	
	if(objType=="doc" || objType=="cl")
	{
		oImporter.createVarsTbl(sVarsTbl);		
		if(extPar.obj)
		{
			if(FROW.checked==true && FROWCLASS.value)
			{
				var oRow = extPar.obj.createRow(FROWCLASS.value);
				if(!oRow)
					return false;
				var varsInfo = oRow.getVarsInfo();
				for(var i=0; i<varsInfo.length; i++)
				{
					var m = new Object();
					m.FCOD = String(i+1);			
					m.FREC = varsInfo[i].name;
					m.FTYPE = oImporter.getDpType(varsInfo[i].dataType);
					m.FLENGTH = oImporter.getVarLength(m.FREC, m.FTYPE);
					m.FTXT = varsInfo[i].rem;
					UpdateTable(sVarsTbl, m, true);
				}
				return true;
			}
			
			var varsInfo = extPar.obj.getVarsInfo();
			for(var i=0; i<varsInfo.length; i++)
			{
				var m = new Object();
				m.FCOD = String(i+1);			
				m.FREC = varsInfo[i].name;
				m.FTYPE = oImporter.getDpType(varsInfo[i].dataType);
				m.FLENGTH = oImporter.getVarLength(m.FREC, m.FTYPE);
				m.FTXT = varsInfo[i].rem;
				UpdateTable(sVarsTbl, m, true);
			}
						
			var extInfo = extPar.obj.getExtInfo();
			for(var sExt in extInfo)
			{
				var m = new Object();
				m.FCOD = String(sExt);			
				m.FREC = "X_"+ sExt;
				m.FTYPE = oImporter.getDpType(extInfo[sExt].getType());
				m.FLENGTH = extLength(extInfo[sExt].E_Format, m.FTYPE);
				m.FTXT = UR("Розширення: |Расширение: ") + extInfo[sExt].E_FieldText;
				UpdateTable(sVarsTbl, m, true);
			}	
		}
	}
	return true;
}

function extLength(sFormat, sType)
{
	var nLength = 0;
	if(!sFormat)
		return nLength;
	sFormat = String(sFormat);
	if(sFormat && sType && sType.toLowerCase()=="text")
		nLength = Number(sFormat.substring(1, sFormat.length-1));
	return nLength;
}

function sourceSelect()
{
	var arrVars = new Object();
	var sTmpTbl = "TMP_SOURCE_VARS";
	oImporter.createVarsTbl(sTmpTbl);
	oImporter.fillVars(arrVars, sTmpTbl);
	var par = new Object();
	par.ret = new Object();
	par.ret.FSOURCE = "";
	par.ret.FTXT = "";
	par.ret.FNUM = "";
	
	par.cells = new Object();
	if(oImporter.type=="DBF")
	{
		par.cells[1] = new Object();
		par.cells[1].name = "FNUM";
		par.cells[1].width = 10;
		par.cells[1].text = UR("№|№");
	}	
	par.cells[2] = new Object();
	par.cells[2].name = "FSOURCE";
	par.cells[2].width = 10;
	par.cells[2].text = UR("Стовпчик|Столбик");	
	
	par.cells[3] = new Object();
	par.cells[3].name = "FTXT";
	par.cells[3].width = 15;
	par.cells[3].text = UR("Примітка|Примечание");
		
	par.caption = UR("Джерело|Источник");
	browse(sTmpTbl, par, SW_MODAL);
	if(par.ret.FSOURCE)
	{
		var str = String(FSOURCE.value);
		if(oImporter.isExpr(str))
			FSOURCE.getCtrl().insert(String(par.ret.FSOURCE));
		else
			FSOURCE.value = String(par.ret.FSOURCE);	
	}
	if(!String(FTXT.value).trim())
	{
		FTXT.value = par.ret.FTXT;
	}
}

function createObject()
{
	var par = new Object();
	par.mode = "option";
	par.base = extPar.base;
	par.source = tbl.getValue("FPARAM");
	if(!par.source || par.source=="null")
		par.source = " ";
	par.param = par.source;	
	showWindow("dbimport.xml", SW_MODAL, par);
	if(par.escape)
		return;
	param = par.param;
	if(par.oImporter)
		FOBJSOURCE.value = par.oImporter.source;	
}

function rec_selected()
{
	var type = String(FTYPE.value);
	if(type.indexOf("cls.")!=-1)
		type = type.substring(4);
	if(!type)
		return;
	switch(String(type).toLowerCase())
	{		
		case "cl":
			cl_selected();
			break;
			
		case "cntrct":
			doc_selected();
			break;
					
		case "nmk":
			nmk_selected();	
			break;		
	}
}

function doc_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	showWindow("docfdr.xml", SW_MODAL, par)
	if(par.escape)
		return;	
	FOBJCOD.value = par.ret.doc;
	FOBJTXT.value = par.ret.nop;	
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FVID = 0;
	par.ret.FTXT = "";
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	FOBJCOD.value = String(par.ret.FCOD);
	FOBJTXT.value = par.ret.FTXT;	
}

function nmk_selected()
{
	var oGroup = new DpNmkl();			
	oGroup.GroupOnly = true;
	oGroup.CanEmpty = true;
	oGroup.zaval();
	
	FOBJCOD.value = oGroup.getCod("c");
	FOBJTXT.value = oGroup.getTCod();
}