include("objects\\DpExtentionBuilder.js");
include("objects\\DpClNo.js");
include("sys\\dbase.js");
include("sub\\mtr.js");

var tabl;
var noValid = "";
var next_no; 
var total = extPar
var group_tbl;

var NSTaskGroup = new Array();

var Validation = true;

function btnUp_click()
{
	var sID = TableTO.getSelectedIDs();
	var arrSelected = TableTO.getRowIDs();
	if (sID.length <= 0)
		return;

	sID = sID[0];
	var idx = arrSelected.indexOf(sID);
	if (idx == 0)
		return;

	var temp = arrSelected[idx-1];
	arrSelected[idx-1] = arrSelected[idx];
	arrSelected[idx] = temp;
	
	TableTO.removeAll();
	for (var i in arrSelected)
	{
		var fld = NSTaskGroup[arrSelected[i]];
		AddToNSTask(fld.text, fld.field, fld.itog);
	}
	TableTO.setSelection(idx-1);
}

function btnDown_click()
{
	var sID = TableTO.getSelectedIDs();
	var arrSelected = TableTO.getRowIDs();
	if (sID.length <= 0)
		return;

	sID = sID[0];
	var idx = arrSelected.indexOf(sID);
	if (idx == arrSelected.length-1)
		return;

	var temp = arrSelected[idx+1];
	arrSelected[idx+1] = arrSelected[idx];
	arrSelected[idx] = temp;
	
	TableTO.removeAll();
	for (var i in arrSelected)
	{
		var fld = NSTaskGroup[arrSelected[i]];
		AddToNSTask(fld.text, fld.field, fld.itog);
	}
	TableTO.setSelection(idx+1);
}

function btnTO_move()
{
	var sID = TableFROM.getSelectedIDs();
	if (sID.length <= 0)
		return;
	sID = String(sID[0]);
	var fld = NSTaskGroup[sID];
	if (!fld)
		return;
	AddToNSTask(fld.text,fld.field,fld.itog);
}

function getTextForTotalsView(sTxt)
{
	var str = new java.lang.String(sTxt);
	str = str.replaceAll("\n", " ");
	str = str.replaceAll("\r", " ");
	return String(str);
}

function btnFROM_move()
{
	var sID = TableTO.getSelectedIDs();
	if (sID.length <= 0)
		return;
	sID = String(sID[0]);
	var fld = NSTaskGroup[sID];
	if (!fld)
		return;
	TableTO.delItem(sID);
	TableFROM.addItem(sID);
	TableFROM.setValue(sID,"text",getTextForTotalsView(fld.text));
}

function TableTO_menuInit(toObject)
{
	var sID = TableTO.getSelectedIDs();
	if (sID.length <= 0)
		return;
	sID = String(sID[0]);
	var fld = NSTaskGroup[sID];
	if (!fld)
		return;
	toObject.AddMenuItem("UP",UR("Підсумок зверху|Итог сверху"));
	toObject.AddMenuItem("DOWN",UR("Підсумок знизу|Итог снизу"));
	toObject.AddMenuItem("NONE",UR("Без підсумку|Без итога"));
	if (fld.options == "YM")
	{
		toObject.AddMenuItem("UP_YM",UR("Підсумок зверху (Рік+Місяць)|Итог сверху (Год+Месяц)"));
		toObject.AddMenuItem("DOWN_YM",UR("Підсумок знизу (Рік+Місяць)|Итог снизу (Год+Месяц)"));
	}
}

function TableTO_menuRun(sID)
{
	var ID = TableTO.getSelectedIDs();
	if (ID.length <= 0)
		return;
	ID = String(ID[0]);
	var fld = NSTaskGroup[ID];
	if (!fld)
		return;
	fld.options_value = "";
	if (sID == "UP")
		fld.itog = "+";
	else if (sID == "DOWN")
		fld.itog = "_";
	else if (sID == "NONE")
		fld.itog = "-";
	else if (sID == "UP_YM")
	{
		fld.itog = "+";
		fld.options_value = "YM";
	}
	else if (sID == "DOWN_YM")
	{
		fld.itog = "_";
		fld.options_value = "YM";
	}
	TableTO.setValue(ID,"itog",getTextForItog(fld.itog));
	TableTO.setValue(ID,"options",getTextForOptions(fld.options_value));
}

function Load()
{
	Caption(ru("Сортування та підсумки",
	        "Сортировка и итоги"), extPar.mode);
	extPar.listPar.callerName = extPar.listPar.callerName.toUpperCase();
	
	TableFROM.addColumn("text",UR("Список полів|Список полей"),200);
	TableTO.addColumn("text",UR("Порядок сортування|Порядок сортировки"),200);
	TableTO.addColumn("itog",UR("Підсумок|Итог"),100);
	TableTO.addColumn("options",UR("Опції групування|Опции группировк"),100);
	
	var menuHandler = new Object();
	menuHandler.mnuInit = TableTO_menuInit;
	menuHandler.mnuRun = TableTO_menuRun;
	TableTO.setMenuFillHandler(menuHandler,"mnuInit");
	TableTO.setMenuRunHandler(menuHandler,"mnuRun");
	
	setButton(btnTo,btnTO_move);
	setButton(btnFrom,btnFROM_move);
	setButton(btnUp,btnUp_click);
	setButton(btnDown,btnDown_click);
	
	tabl = extPar.m_pTable;
	
	var_num.setMask("###");
	var_text.setMask("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
	
	oNo = new DpClNo(extPar.mode,
	        var_num, "CL_TT", "fno",extPar.fwid,
	        "UPPER(flist)="+sqlTo(extPar.listPar.callerName.toUpperCase())
	                + " and fno<50");
	
	setValid(var_text, var_text_Valid);
	setValid(var_num,var_num_Valid);

	group_tbl = OpenTable("s",
	        "SELECT *"
	        + " FROM ^CL_TTFLD"
	        + " WHERE UPPER(flist)="+sqlTo(extPar.listPar.callerName.toUpperCase())
	        + " ORDER BY FNO"
	        );
	        
	var extTbl = null;   
	if(!group_tbl.IsEmpty())
		group_tbl.MoveFirst();
	for (;!group_tbl.IsEOF(); group_tbl.MoveNext())
	{
		var strCL = "";
		var str = String(group_tbl.getValue("ffield"));
		if (str.substring(0,6) == "?xxcl(")
		{
			str = str.toLowerCase();
			strCL = getFCL(str);
			valCL = getFCL_value(str);
			strField = str.substring(str.lastIndexOf('(')+1, str.lastIndexOf(','));
			
	//NI: Для расширения контрагента
			var isOrg = false;
			
			if (valCL == 0)
			{
				var pSnap = getSnap("SELECT ffield"
						+ " FROM ^CL_TTFLD"
						+ " WHERE UPPER(flist)="+sqlTo(extPar.listPar.callerName.toUpperCase())
						+ " AND ffield like '?xxcl(" + strField + sqlStr4Like + "'"
						+ " AND ffield <> " + sqlTo(str));
				
				var sMainField= "";
					
				if (pSnap && pSnap[0])
					sMainField = pSnap[0];
					
				if (getFCL_value(sMainField) != sprOrg)
					continue;
				else
					isOrg = true;
			}
	//END NI
			/*
			extTbl = OpenTable("s","SELECT FLABEL,FTXT"
							+ " FROM ^cl_ext"
							+ " WHERE FCLASS=" + sqlTo("CL." + parseInt(valCL))
							  );
			for(; !extTbl.IsEOF(); extTbl.MoveNext())
			{
				AddToArr(
					group_tbl.getValue("ftxt") + " " + (!isOrg ? valCL : "") + " : " + extTbl.getValue("ftxt")
					,"xxcl__"+strField + "__" + strCL + "__" + extTbl.getValue("flabel")+"");
			}
			*/
			extBuilder = new DpExtentionBuilder("CL", valCL);
   			extBuilder.load();
   			for(sLabel in extBuilder.arrExt)
   			{
   				var txt = group_tbl.getValue("ftxt") +" "+ (!isOrg ? valCL : "") + " : " + extBuilder.getTxt(sLabel);
   				var ext = "xxcl__"+ strField +"__"+ strCL +"__" + sLabel;
   				AddToArr(txt, ext);
   			}
		}
		else if(str.substring(0,5) != "XNMK_")
		{
			var arrExt = new Object();
			switch(String(group_tbl.getValue("ffield")))
			{
	            case "?xnmk":
	           		extBuilder = new DpExtentionBuilder("CL_NMK");
   					extBuilder.load();
   					arrExt = extBuilder.arrExt;
					//AddToArr("Номенклатура: Код", "cl_nmk__fcod");
					//AddToArr("Номенклатура: Наименование", "cl_nmk__ftxts");
					break;
				case "?xcl":
            		extBuilder = new DpExtentionBuilder("CL", "0");
   					extBuilder.load();
   					arrExt = extBuilder.arrExt;
                    break;
	            case "?xppn":
					extBuilder = new DpExtentionBuilder("R", "PN.ROW");
   					extBuilder.load();
   					arrExt = extBuilder.arrExt;
   					extBuilder = new DpExtentionBuilder("R", "SA.ROW");
   					extBuilder.load();
   					for(var s in extBuilder.arrExt)
   						arrExt[s] = extBuilder.getTxt(s);
                    break;
	            default:
					AddToArr(group_tbl.getValue("ftxt"),group_tbl.getValue("ffield"));
                    continue;
	        }
	        /*
			for(; !extTbl.IsEOF(); extTbl.MoveNext())
			{
				AddToArr(group_tbl.getValue("ftxt") + ": " + extTbl.getValue("ftxt")
						,String(group_tbl.getValue("ffield")).substr(1) + "_" + extTbl.getValue("flabel"));
			}
			*/
			for(var sLabel in arrExt)
			{
				var txt = group_tbl.getValue("ftxt") +": "+ extBuilder.getTxt(sLabel);
				var ext = String(group_tbl.getValue("ffield")).substr(1) +"_"+ sLabel;
				AddToArr(txt, ext);
			}
	    }
	}

	var summFields = 0;
	var cols = extPar.listPar.objList.grid.getColumnsArray();
	for (var i = 0; i < cols.length; i++)
	{
		if (!cols[i].getField().startsWith("="))
		{
			var sOptions = "";
			if (cols[i].isDate && cols[i].isDate == true)
				sOptions = "YM";
			AddToArr(cols[i].getFullCaption(), cols[i].getField(), sOptions);
		}
		AddToArr(UR("Загальний підсумок|Общий итог"), "!");
	}
	
	switch (extPar.mode)
	{
	case "ADD":
	        var_text.setValue("");
	        break;
	case "EDIT":
	case "COPY":
	        var_text.setValue(tabl.getValue("ftxt"));
	        var_num.setValue(tabl.getValue("fno"));
	        var nom = tabl.getValue("fno");
	        var tbl = OpenTable("s",
	                "SELECT *"
	                + " FROM ^CL_TTR"
	                + " WHERE fhno="+sqlTo(nom)
					+ " AND UPPER(flist)="+sqlTo(String(extPar.listPar.callerName).toUpperCase())
					+ " ORDER BY fno"
	                );
	        while(!tbl.IsEOF())
	        {
				var sID = String(tbl.getValue("ffield")).toUpperCase();
				var fld = NSTaskGroup[sID];
				if (fld)
				{
					fld.itog = String(tbl.getValue("fitog"));
					fld.options_value = String(tbl.getValue("foptions"));
					AddToNSTask(fld.text,fld.field,tbl.getValue("fitog"), fld.options_value);
				}
	            tbl.MoveNext();
	        }
	}
	setFocus(var_num);
}
/*
function FindInArr(field, txt, arr)
{
        field = field.toLowerCase();
        txt = txt.toUpperCase();
        if (!arr)
                arr = NSTaskGroup;
        for (var i = 0; i < arr.length && txt != arr[i][field].toUpperCase(); i++);
        return (i < arr.length)? i: -1;
}
*/

function AddToArr(sText,sField,sOptions)
{
	if (!sOptions)
		sOptions = "";
	var sID = String(sField).toUpperCase();
	if (NSTaskGroup[sID])
		return;
	NSTaskGroup[sID] = new Object();
	NSTaskGroup[sID].text = sText;
	NSTaskGroup[sID].field = sField;
	NSTaskGroup[sID].itog = "+";
	NSTaskGroup[sID].options = sOptions;
	
	TableFROM.addItem(sID);
	TableFROM.setValue(sID,"text",getTextForTotalsView(sText));
}

function AddToNSTask(sText,sField,sItog, sOptions_value)
{
	if (!sOptions_value)
		sOptions_value = "";
	var sID = String(sField).toUpperCase();
	if (!sItog)
		sItog = "+";
	TableTO.addItem(sID);
	TableTO.setValue(sID,"text",getTextForTotalsView(sText));
	TableTO.setValue(sID,"itog",getTextForItog(sItog));
	TableTO.setValue(sID,"options",getTextForOptions(sOptions_value));
	TableFROM.delItem(sID);
}

function getTextForItog(sItog)
{
	sItog = allt(String(sItog));
	switch(sItog)
	{
		case "+":
			return UR("Підсумок зверху|Итог сверху");
		case "-":
			return UR("Без підсумку|Без итога");
		case "_":
			return UR("Підсумок знизу|Итог снизу");
	}
}

function getTextForOptions(sOption)
{
	sOption = allt(String(sOption));
	switch(sOption)
	{
		case "YM":
			return UR("Рік+Місяць|Год+Месяц");
	}
	return "";
}
/*
function AddToArr()
{
        var arg = AddToArr.arguments;
        if (arg.length < 2)
                return false;
        var ffind = (typeof(arg[0]) == "object")? 1: 0;
        var arr = (ffind && arg[0])? arg[0]: NSTaskGroup;
        var ind = arr.length;
        arr[ind] = new Object();
        while (ffind < arg.length)
                arr[ind][arg[ffind++].toString()] = arg[ffind++];
        return true;
}
*/

function onSave()
{
    if(extPar.mode == "EDIT")
    {
        ExecuteSQL("DELETE FROM ^CL_TTR WHERE UPPER(flist) = "+sqlTo(extPar.listPar.callerName.toUpperCase())
        	+" AND fhno="+sqlTo(tabl.getValue("fno")));
    }
    var Flist = String(extPar.listPar.callerName).toUpperCase();
    var Fhno = Number(var_num.getValue());

   	var m   = new Object();
    m.FLIST = Flist;
    m.FHNO  = Fhno;
    
	var arrSelected = TableTO.getRowIDs();
    nFNO = 0;
    for(var j = 0;j< arrSelected.length; j++ )
    {
    	var fld = NSTaskGroup[String(arrSelected[j])];
    	if (!fld)
    		continue;
		m.FWID = GetUID();
    	m.FFIELD = fld.field;
    	m.FOPTIONS = fld.options_value;
    	m.FNO = j;
    	m.FITOG = fld.itog;
    	UpdateTable("^cl_ttr",m,true);
    }
        
    var mVar = new Object();
    mVar.FWID = this.sFWID;
    mVar.FLIST = Flist;
    mVar.FNO = Fhno;
    mVar.FTXT = String(var_text.getValue());
    UpdateTable("^CL_TT",mVar,extPar.mode != "EDIT");
}

function var_text_Valid()
{
        if(String(var_text.getValue()) == "")
        {
                var str = ru("Название варианта не может быть пустым","Назва варіанту не може бути порожньою");
                var_text.showErr(str);
                return false;
        }
        return true;
        if((extPar.mode == "COPY") || (extPar.mode == "ADD"))
        { 
                var tmp_tbl = OpenTable("s","SELECT * FROM ^CL_TT "
                			+" WHERE UPPER(FLIST)="+sqlTo(extPar.listPar.callerName.toUpperCase()))
                while(!tmp_tbl.IsEOF())
                {
                        if(var_text.Value == tmp_tbl("ftxt"))
                        {
                                WAIT(ru("Такое название варианта уже существует",
                                        "Така назва варіанту вже існує"));
                                return softInvalid;
                        }
                        tmp_tbl.MoveNext();
                }
        } 
        return true;  
}

function var_num_Valid()
{
	var val = Number(var_num.getValue());
	if (val >= 50 || val <= 0)
	{
		var_num.showErr("Значення має бути між 1-49|значение должно быть между 1-49");
		return false;
	}
	if (extPar.mode == "EDIT")
	{
		var oldVal = Number(extPar.m_pTable.getValue("fno"));
		if (val == oldVal)
			return true;
	}
	var oSnap = getSnap("SELECT fno FROM ^cl_tt WHERE"
				+ " UPPER(flist)=" + sqlTo(extPar.listPar.callerName.toUpperCase())
				+ " AND fno=" + sqlTo(val));
	if (oSnap != null)
	{
		var_num.showErr("Такий запис вже існує|Такая запись уже существует");
		return false;
	}
	return true;
}
