include("objects/DpNop.js");
include("objects/DpDcExpr.js");

var objFref = null;
var objCond = null;

function onLoad()
{
	var capt = UR("Операція для документа | Операция для документа ")
			   + extPar.operList.doc;
	Caption(capt + ": " + modeName(extPar.sMode));

//-------- ссылка
	objFref = new DpNop(0,extPar.operList.doc);
	DOC.setValue(extPar.operList.doc);
	DOC.setEnabled(false);
	objFref.linkCtrl(REF,DOC);
	objFref.zeroIsValid = true;
	
	setValid(REF,check_ref);
	setValid(NOP,check_nop);
//-------- название	
//-	objFtxt = new DpDcExpr("R", extPar.operList.doc,0,NAZV);  

	objCond = new DpDcExpr("R",extPar.operList.doc,extPar.operList.doc=="_R"?extPar.nop:0,COND);
	objMO = new DpDcExpr("R",extPar.operList.doc,extPar.operList.doc=="_R"?extPar.nop:0,MO);
	
	if (extPar.sMode == "ADD")
	{
		var lastNop = 0;
		var arrOp = extPar.operList.listOperations();
		for (var nOp in arrOp)
		{
			var tmp = parseInt(arrOp[nOp].nop);
			if (lastNop < tmp)
				lastNop = tmp;
		}
		NOP.setValue(String((++lastNop)));
	}
	else
	{
		var oOp = extPar.operList.listOperations()[extPar.nop];
		var nNop = oOp.nop;
		if (!isNaN(nNop))
			nNop = Number(nNop);
		NOP.setValue(String(oOp.nop));
		DOC.setValue(oOp.doc);
		objFref.setCod(oOp.getVar("ref"));
		NAZV.setValue(oOp.getVar("txt"));
		COND.setValue(oOp.getVar("cond"));
		MO.setValue(oOp.getVar("mo"));
		DESCRIPTION.value = oOp.getVar("description");
	}
}

function check_ref()
{
	var oOp = extPar.operList.listOperations()[extPar.nop];
	if (objFref.getCod() == 0)
		return true;
	if (NOP.getValue() == objFref.getCod() /* || objFref.getCod() == oOp.getVar("ref")*/)
	{
		REF.showErr(UR("Циклічне посилання|Циклическая ссылка"));
		return false;
	}
}

function check_nop()
{
	if (NOP.getValue() == "0")
	{
		NOP.showErr(UR("Введіть номер операції|Введите номер операции"));
		return false;
	}
	if (extPar.sMode == "EDIT")
	{
		if (NOP.getValue() == extPar.nop)
			return true;
	}
	if (extPar.operList.listOperations()[NOP.getValue()])
	{
		NOP.showErr(UR("Такий запис вже існує|Такая запись уже существует"));
		return false;
	}
}

function onSave()
{
	var Nop = NOP.getValue();
	if (!isNaN(Nop))
	{
		Nop = Number(Nop);
	}
	
	if (extPar.sMode != "EDIT")
	{
		extPar.operList.addOperation(Nop);
	}
	extPar.operList.listOperations()[Nop].setVar("ref",REF.getValue());
	extPar.operList.listOperations()[Nop].setVar("txt",NAZV.getValue());
	extPar.operList.listOperations()[Nop].setVar("cond",COND.getValue());
	extPar.operList.listOperations()[Nop].setVar("mo",MO.getValue());
	extPar.operList.listOperations()[Nop].setVar("description",DESCRIPTION.getValue());
	extPar.operList.listOperations()[Nop].save();
	
	extPar.ret = new Object();
	extPar.ret.nop = Nop;
}