// JScript source code
include("servis/date.js")
include("sys/DpParArchive.js")

var ArrObj = new Array();
var mapCl = new Array();
var ctrl_zrdat, ctrl_zrday, ctrl_bln;
var bufDay;
var oldLang = Number(getPar("language"));
var oArch;

function onLoad()
{
	Caption("Параметри системи|Параметры системы");
	var xmldoc = openXmlFile(rootDirectoryEx()+"syspar.xml");
	var root = xmldoc.getDocumentElement();
	this.onSelPar = OnSelPar;
	param.treeHandler(this,"onSelPar");	
	param.setXml(root);
	
	var arrModules = lpProxy.getModules();
	for (var i = 0; i < arrModules.length; i++)
	{
		var sPath = lpProxy.getModulePath(arrModules[i]) + "/syspar.xml";		
		var xmlDoc = openXmlFile(sPath, false);
		if (xmlDoc == null)
			continue;
		var root = xmlDoc.getDocumentElement();
		param.setXml(root);
	}
	
	//param.setXml(root);
	GetMenuMode()
	if(extPar && extPar.sel)
		param.setGroup(extPar.sel);
	else if(GetMenuMode())
		param.setGroup(GetMenuMode());
	else
		param.setGroup("COMMON2");

	oArch = new DpParArchive();
}


function OnSelPar(xmlGroup,form)
{
	var grpArr = new Array()
	
	var nodes = xmlGroup.getChildNodes();
	//alert(xmlGroup.getNodeName())
	for(var i = 0; i< nodes.getLength(); i++)
	{
		var node = nodes.item(i);
		//alert(typeOf(node));
		if(!inList(typeOf(node),"DeferredElementImpl","ElementNode")) continue;
		
		var sSubd = node.getAttribute("subd");
		if(sSubd && String(sSubd).trim()!="")
		{
			var equalSubd = false;
			var curSUBD = lpProxy.getOrgManager().getSUBD();
			var arrSubd = String(sSubd).trim().toUpperCase().split("_");
			for(var nSubd=0; nSubd<arrSubd.length; nSubd++)
			{
				if(arrSubd[nSubd]==curSUBD)
					equalSubd = true;
			}
			if(!equalSubd)
				continue;
		}
		
		if(node.getAttribute("type") == "group")
		{
			var oGrp = new Object();
			oGrp.ID = node.getNodeName();
			oGrp.text = UR(node.getAttribute("text"));
			var sSys = node.getAttribute("sys");
			if(sSys && allt(sSys)!="")
			{
				sSys = sSys.toUpperCase();
				var curSys = getSystem().toUpperCase();
				if(sSys.indexOf(curSys)!=-1)
					grpArr[grpArr.length] = oGrp;
			}
			else
			{
				grpArr[grpArr.length] = oGrp;
			}
		}
		
		if(node.getAttribute("type")!="param") continue;
		
		var sType = node.getAttribute("partype");
		var dataType = node.getAttribute("datatype");
		//parsubtype введен для работы с объектом DpSc
		//потому как при указании partype="DpSc" при сохранении параметров
		//SetPar ругался на попытку преобразовать значение в числовой тип
		var sTypeSub = node.getAttribute("parsubtype");
		var sText = node.getAttribute("text");
		var sWidth = node.getAttribute("width");
		var nWidth = 0;
		if (sWidth && sWidth != "" && !isNaN(String(sWidth)) )
			nWidth = Number(sWidth);
		if (!nWidth && dataType!="N" && (sType=="text" || sType=="file" || sType=="dir"))
			nWidth = 250;
		var sParName = node.getNodeName();
		var sCtrlType = sType;

		if (sType == "text" && sTypeSub == "DpSc")
		{
			var sMode = node.getAttribute("mode");
			sCtrlType = "text";

			var ctrlC = null;
			var ctrlU = null;
			var ctrlT = null;
			var ctrlX = null;
			var ctrlY = null;
			var ctrlZ = null;

			// счет
			ctrlC = form.addCtrl(sParName,sCtrlType,sText);

			// субсчет
			if(strIn("U", sMode))
			{
				ctrlU = form.addCtrl(sParName+"U",sCtrlType,"   ");
			}

			// статья
			if( strIn("T", sMode) )
			{
				ctrlT = form.addCtrl(sParName+"T",sCtrlType,"   ");
			}

			// аналитика 1
			if( strIn("X", sMode) )
			{
				ctrlX = form.addCtrl(sParName+"X",sCtrlType,"   ");
			}

			// аналитика 2
			if( strIn("Y", sMode) )
			{
				ctrlY = form.addCtrl(sParName+"Y",sCtrlType,"   ");
			}
			
			// аналитика 3
			if(strIn("Z", sMode))
			{
				ctrlZ = form.addCtrl(sParName+"Z",sCtrlType,"   ");
			}

			include("Objects/DpSc.js");
			var obj = new DpSc(toScrObj(sMode));
			obj.linkCtrl(ctrlC, ctrlU, ctrlT, ctrlX, ctrlY, ctrlZ);

			ArrObj[sParName] = obj;

			if (getPar(sParName) != null)
			{
				aTxt = String(getPar(sParName)).split("|");
				obj.set(aTxt[0],aTxt[1],aTxt[2],aTxt[3],aTxt[4],aTxt[5]);
			}
		}
		else
		{
			if (sType.substring(0,2) == "Dp")
				sCtrlType = "text";	
			var ctrl = null;
			if (nWidth != 0)
				ctrl = form.addCtrl(sParName,sCtrlType,sText, nWidth);
			else
				ctrl = form.addCtrl(sParName,sCtrlType,sText);
			if(String(node.getAttribute("ispassword"))=="true")
				ctrl.setEchoChar('*');
			if (sType.substring(0,2)=="Dp")
				ctrl.setButton();
				
			if (String(node.getAttribute("datatype")) == "N")
				ctrl.mask = "########";
			
			if (sType == "spin")
			{
				var sMax = node.getAttribute("maximum");
				if (sMax!="")
					ctrl.setMaximum(Number(sMax));
				
				sMax = node.getAttribute("minimum");
				if (sMax!="")
					ctrl.setMinimum(Number(sMax));

				sMax = node.getAttribute("default");
				if (sMax!="")
					ctrl.setValue(Number(sMax));
			}
			if (sType=="DpClcl" || sType=="DpVal" || sType=="DpNmkl" || sType=="DpCl")
			{
				include("Objects\\"+sType+".js");
				var obj = eval("new "+sType+"(\"0\")");
				obj.linkCtrl(ctrl);
				ArrObj[sParName] = obj ; 
				if(sType=="DpCl")
				{
					var sCl = node.getAttribute("cl");
					var nCl = Number(getPar(sCl));
					obj.setClcl(nCl);
				}
			}		
			
			if (sType=="DpCntrct")
			{
				include("Objects\\"+sType+".js");
				dog = new DpCntrct("+");
				dog.linkCtrl(ctrl);
				dog.setOrg(CURRENT_ORG);
				ArrObj[sParName] = dog ; 
				ArrObj[sParName].setID(getPar(sParName));
			}
			
			if(sType=="select")
				fillCombo(ctrl,node);
			
			if (sType=="DpNop")
			{					
				include("Objects\\"+ sType +".js");
				var sDoc = node.getAttribute("doc");
				if(sDoc)
				{
					var obj = eval("new "+ sType +"(\"0\", '"+ sDoc +"')");
					obj.linkCtrl(ctrl, sDoc);
					ArrObj[sParName] = obj; 
				}
			}
			
			/*if (sType=="DpClOrg")
			{					
				include("Objects/DpCl.js");
				var obj = new DpCl("2", getPar("CODMYORG"), 0);			
				obj.linkCtrl(ctrl);
				obj.setContAssist();
				ArrObj[sParName] = obj; 
			}*/
				
			if (ArrObj[sParName] && typeof(ArrObj[sParName].setCod) == "function" && getPar(sParName)!=null)
			{
				ArrObj[sParName].setCod(getPar(sParName));
			}
			else if(ctrl)
				ctrl.setValue(getPar(sParName));
			
			var srel = node.getAttribute("rel");
			if(srel!=null && srel!="" && srel!=0)
			{
				var relCod = getPar(String(srel))
				if(relCod && typeof(ArrObj[sParName].setRel) == "function")
					ArrObj[sParName].setRel(Number(relCod));
			}
			if(sParName.toUpperCase()=="ZR_DAY")
			{
				ctrl_zrday = ctrl;
				bufDay = ctrl_zrday.value;
				setValid(ctrl_zrday,valid_zr_day);
			}
			if(sParName.toUpperCase()=="ZR_DAT")
			{
				ctrl_zrdat = ctrl;
				ctrl_zrdat.value = base_month.getVarDate();
				setValid(ctrl_zrdat,valid_zr_dat);
			}
			//параметр подсчета открытых курсоров делаем активным только для оракла
			if(sParName.toUpperCase()=="CALC_OPEN_CURSORS" && SUBD!=ORACLE)
				ctrl.setEnabled(false);
			if(sParName.toUpperCase()=="SAVEBLNINZRP")
			{
				ctrl_bln = ctrl;
			}
		}
	}
	if (grpArr.length > 0)
		form.addHR();
	for (var i = 0; i < grpArr.length; i++)
	{
		form.addLink(grpArr[i].ID, grpArr[i].text);
	}
	var sXml = xmlGroup.toString();
	
}

function fillCombo(ctrl,node)
{
	var optns = node.getElementsByTagName("option");
	for(var k = 0; k< optns.getLength(); k++)
	{
		opt = optns.item(k);		
		var sValue = opt.getAttribute("value");
		var sText = opt.getFirstChild().getData();
		ctrl.addItem(sValue,UR(sText));		
	}
}

function onSave()
{
	var obj = param.getformMap();
	var keys = obj.keySet().toArray();
	for(var i = 0; i < keys.length; i++)
		saveForm(keys[i],obj.get(keys[i]));
	
	updateOrgList();
	if(oldLang != getPar("language"))
	{
		lpProxy.getOrgManager().setSys(getSystem(), true);
	}
	if(ctrl_bln)
		useBlnInCdr(ctrl_bln.value);

	var mFdate = new Date().getVarDate();
	oArch.toArchive("org", mFdate);
	oArch.toArchive("user", mFdate);
}

function saveForm(sID, sFORM)
{
	var ctrlMap = sFORM.getCtrlMap();
	var sParms = ctrlMap.keySet().toArray();
	for(var i = 0; i < sParms.length; i++)
	{
		var sPar = sParms[i];
		var oValue = ctrlMap.get(sPar).getValue();
		if (ArrObj[sPar] && objTypeOf(ArrObj[sPar]) == "DpSc")
		{
			var oSc = ArrObj[sPar];
			oValue = String(oSc.getSc())
				+ "|" + String(oSc.getSu())
				+ "|" + String(oSc.getSt())
				+ "|" + String(oSc.getCl1())
				+ "|" + String(oSc.getCl2())
				+ "|" + String(oSc.getCl3())
		}
		else if (ArrObj[sPar] && objTypeOf(ArrObj[sPar]) == "DpCntrct")
		{
			oValue = ArrObj[sPar].getID();
		}
		else if (ArrObj[sPar] && typeof(ArrObj[sPar].getCod) == "function")
		{
			oValue = ArrObj[sPar].getCod();
			if(oValue==null)
				oValue = 0;
		}
		//alert(sPar+"\n"+oValue);
		if (getPar(sPar) != oValue)
			setPar(sPar,oValue);
	}
}

function valid_zr_dat(obj)
{
	var dat = new Date(firstDayMonth(ctrl_zrdat.value));
	if(differ(base_month,new Date(firstDayMonth(ctrl_zrdat.value))))
	{
		if(differ(dat,new Date(firstDayMonth(today)))==1)
		{
			alert(ru("Расчетный месяц не может быть больше системной даты!",
					"Розрахунковий місяць не может бути більше системної дати!"));
			return false;
		}
		else
		{
			var days = day_difference(dat,today)-1;
			if(differ(getBaseMonth(ctrl_zrday.value),dat)!=0)
				ctrl_zrday.value = days;
			return true;
		}
	}
	else
	{
		if(differ(getBaseMonth(ctrl_zrday.value),dat)!=0)		
			ctrl_zrday.value = bufDay;
		return true;
	}
}

function valid_zr_day(obj)
{
	var dt = new Date(today);
	dt.setDate(dt.getDate()-ctrl_zrday.value);
	dt.setDate(1);
	ctrl_zrdat.value = dt.getVarDate();
	return true;
}

function useBlnInCdr(val)
{
	var snap = getSnap("select Fvid from ^cl_prik where Fis_slct="+sqlTrue+" and LOWER(Fedit)="+sqlTo("_blnobsh"));
	if(snap && snap[0])
	{
		var fvid = snap[0];
		switch(String(val).toLowerCase())
		{
			case "save":
			case "menu":
				ExecuteSQL("update ^cl_prik set Fuse_cdr="+sqlTrue+" where Fvid="+fvid);
			break;
			default:
				ExecuteSQL("update ^cl_prik set Fuse_cdr="+sqlFalse+" where Fvid="+fvid);
			break;
		}
	}
}