include("sub\\mtr.js");
include("Objects\\DpCl.js");
include("Objects\\DpNmkl.js");
include("Objects\\DpPrList.js");

var Validation = true;
var edmode = extPar.mode;
var m_fwid = extPar.fwid;
var grpId  = extPar.listPar.grpId;
var fcod = extPar.fcod, 
	fdat = extPar.fdat;

cod_mol =11;
cod_podr =10;
var MASK_NMKL = MASK_NMKL;

var t, ofnmkl, oOrg;
var tblName;
var nmklID = -1;

function onLoad()
{
	if(!fcod)
	{		
		//grpId  = extPar.listPar.oTree.getSelected();
		fcod = extPar.listPar.fcod;
		fdat = extPar.listPar.fdat;
	}	

	tblName = pName(fcod, fdat, m_fwid);
	
	if(!tblName)
		return false;
		
	var sWhere = "";
	if(m_fwid && m_fwid!="")
		sWhere = " where fwid ="+ Number(m_fwid);
	
	t = OpenTable("m", "select * from "+ tblName + sWhere);
	t.tie("cl_nmk", "nmk", "fwid", "Fnmkl");	

	//if(t.getValue("ftt")!="NM" && (edmode=="EDIT" || edmode=="COPY"))
		//return false;	
	
	var titleR = "Прайс-лист типа " + fcod
			+ " на дату " + StrDat(fdat,"DMY");
	
	var titleU = "Прайс-лист типу " + fcod
			+ " на дату " + StrDat(fdat,"DMY");
		
	Caption(ru(titleR, titleU), extPar.mode);
	
	oPri = new DpPrList(); 	
	 
	oOrg = new DpCl("0");
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkCtrl(FORG, FORG_TXT);
	
	oPodr = new DpCl("0");
	oPodr.setClcl(getPar("CODPODR"));
	oPodr.linkCtrl(FPODR, FPODR_TXT);
	
	ofnmkl = new DpNmkl();
	ofnmkl.linkCtrl(mfnmkl,mtext);
	
	if (edmode == "ADD")
		setValid(mfnmkl, validNmkl);
	
	mfcena0.mask = MASK_CENA;
	mfcena1.mask = MASK_CENA;
	mfcena2.mask = MASK_CENA;
	mfcena3.mask = MASK_CENA;
	mfcena4.mask = MASK_CENA;
	mfcena5.mask = MASK_CENA;
	mfcena6.mask = MASK_CENA;
	mfcena7.mask = MASK_CENA;
	mfcena8.mask = MASK_CENA;
	mfcena9.mask = MASK_CENA;
	most.mask	 = MASK_KOL;
		
	switch(edmode)
	{
		case "EDIT":
		case "COPY":
				ofnmkl.setCod(String(t.getValue("nmk.fcod")), false, "c");
				oOrg.setCod(t.getValue("Forg"));
				oPodr.setCod(t.getValue("FPODR"));
				mfcena0.value = t.getValue("fcena");
				mfcena1.value = t.getValue("fcena1");
				mfcena2.value = t.getValue("fcena2");
				mfcena3.value = t.getValue("fcena3");
				mfcena4.value = t.getValue("fcena4");
				mfcena5.value = t.getValue("fcena5");
				mfcena6.value = t.getValue("fcena6");
				mfcena7.value = t.getValue("fcena7");
				mfcena8.value = t.getValue("fcena8");
				mfcena9.value = t.getValue("fcena9");
				most.value	  = t.getValue("fost");				
				setFocus(FORG);
				break;
		case "ADD":
			
			/* AL: ЭТО КУХНЯ НЕ ПОДРАЗДЕЛЕНИЕ
			var clPri = getSnap("select fpodr from ^CL_PRI "
				  				+" where fwid="+ grpId
				  				, false
				  				);
			if(clPri!=null && clPri[0])
			{
				oPodr.setCod(clPri[0]);
			}
			*/
			break;
		
		/*case "ADD":
				mfnmkl.value="";
				mfcena0.value=0;
				mfcena1.value=0;
				mfcena2.value=0;
				mfcena3.value=0;
				mfcena4.value=0;
				mfcena5.value=0;
				mfcena6.value=0;
				mfcena7.value=0;
				mfcena8.value=0;
				mfcena9.value=0;
				most.value=0;
				oOrg.setCod(0);
				break;
		*/
	}
	if (edmode=="EDIT")
	{	
		Disable(mfnmkl);
		Disable(mtext);
	}
	loadTCena();
	if (edmode == "ADD")
		validNmkl();
	t.close();
}

function validNmkl()
{
	var newID = ofnmkl.Fwid;
	if (nmklID == newID && mfcena0.value != 0)
		return;
	mfcena0.value = ofnmkl.Fcenapr;
	nmklID = newID;
}

function loadTCena()
{
	var	m = oPri.getTCen(grpId);
	for(var n=0; n<10; n++)
	{
		if(m[n]=="" || m[n]==" " || m[n]==null)
		{
			eval("tfcena"+ n +".text = ''");
			Disable(eval("mfcena"+ n));
		}		
		else
			eval("tfcena"+ n +".text = m[n]");					
	}
	//а теперь надо перерисовать диалог, иначе длинные названия просто обрезаются
	var pnt = tfcena1.getParent().getParent().getParent();
	pnt.redraw();
	pnt.layout(true);
}

function onSave()
{		
	var clPri = getSnap("select fnmkl,fpodr,fmol,fsc,fsu from ^CL_PRI "
					  	+" where fwid="+ grpId
					  	, false
					  	);
	var m = new Object();
	switch(edmode)
	{
		case "EDIT":
			m.FWID = m_fwid;
			break;
		case "ADD":
		case "COPY":
			m.FWID = this.sFWID;
			m.ftt  = "NM";
			break;
	}	
	
	m.fcena  = mfcena0.value;
	m.fcena1 = mfcena1.value;
	m.fcena2 = mfcena2.value;
	m.fcena3 = mfcena3.value;
	m.fcena4 = mfcena4.value;
	m.fcena5 = mfcena5.value;
	m.fcena6 = mfcena6.value;
	m.fcena7 = mfcena7.value;
	m.fcena8 = mfcena8.value;
	m.fcena9 = mfcena9.value;
	m.fost   = most.value;
	m.fnmkl  = ofnmkl.getCod();
	m.forg   = oOrg.getCod();
	m.fpodr   = oPodr.getCod();	
	if(clPri!=null)
	{
		if (!m.fpodr)
			m.fpodr  = clPri[1];
		m.fmol   = clPri[2];
		m.fsc    = clPri[3];
		m.fsu    = clPri[4];
		if(grpId)
			m.fgrpid = Number(grpId);
	}
		
	UpdateTable(tblName, m, edmode != "EDIT");	
}