include ("Objects/DpClNo.js");
include ("Objects/DpCl.js");

var edmode,fwid,oCl;
function Load()
{
    Caption(ru("Шифры производственных затрат",
				"Шифри виробничих витрат"),
         extPar.mode);

    FCOD.setMask("####");
    FSHIFR.setMask("&&&&&&&&&&&&&&");
    FTXT.setMask(replicate("&", 255));
    FCLCOD.mask="###";
    Disable(FCLTXT);
    
    if(!getPar("PRIK_IZD"))
    	GIZD.visible = false;
    oCl = new DpCl("0");
	oCl.linkCtrl(FIZDCOD,FIZDTXT);
	
    set_FCOD();
    setValid(FCOD, FCOD_Valid);
    setValid(FTXT, FTXT_Valid);
    
    this.tbl = extPar.tblSrc;

	fwid = this.tbl.getValue("Fwid");
    edmode = extPar.mode;
    oNo = new DpClNo(extPar.mode,FSHIFR,"shifrpz","Fshpz",this.tbl.getValue("Fwid"), null, "s");

	oSc = new DpSc();
	oSc.setMode("c0utxyz");
	oSc.linkCtrl(FSC, FSU, FST, FCOD1, FCOD2, FCOD3);

    switch(edmode)
    {
		case "EDIT":
		case "COPY":
            FCOD.value = this.tbl.getValue("fcod");
            FSHIFR.value = this.tbl.getValue("fshpz");
         	FTXT.value = this.tbl.getValue("fshpz_txt");
			oSc.set(this.tbl.getValue("FSC"), this.tbl.getValue("FSU"), this.tbl.getValue("FST"), this.tbl.getValue("FCOD1"), this.tbl.getValue("FCOD2"), this.tbl.getValue("FCOD3"));
			oCl.setClcl(this.tbl.getValue("Fnsprizd"));
			oCl.setCod(this.tbl.getValue("Fksprizd"));
			FCLCOD.value = this.tbl.getValue("Fnsprizd");
		break;
		case "ADD":
         	FTXT.value = "";
            break;
    }
    setValid(FCLCOD,fclValid);
    fclValid();
    this.cl_selected = cl_selected;
    setButton(FCLCOD, this, "cl_selected");
}
			
function FTXT_Valid()
{
	if (FTXT.value=="")
	{
		WAIT(ru("Пустое значение недопустимо!","Порожнє значення неприпустиме!"));
		return false;
	}
	return true;
}

function set_FCOD()
{
	if(extPar.mode != "EDIT")
	{
		var snap = getSnap("select MAX(Fcod)+1 from ^SHIFRPZ");
		if(snap)
			FCOD.value = snap[0];
	}
}

function FCOD_Valid()
{
	var snap = getSnap("select * from ^SHIFRPZ where Fcod="+FCOD.value+" and Fwid<>"+fwid);
	if(snap)
	{
		WAIT(ru("Такой код уже существует!","Такий код вже існує!"));
		return false;
	}
	else
		return true;
}

function onSave()
{
   var m = new Object();
	if(extPar.mode != "EDIT")
	{
		m.Fwid = GetUID();
	}
	__SaveFWID(this.tbl);
	m.Fcod = FCOD.value;
	m.Fshpz = FSHIFR.value;
	m.Fshpz_txt = FTXT.value;
	m.FSC	= 	oSc.getSc();
	m.FSU	= 	oSc.getSu();
	m.FST	= 	oSc.getSt();
	m.FCOD1	= 	oSc.getCl1();
	m.FCOD2	= 	oSc.getCl2();
	m.FCOD3	= 	oSc.getCl3();
	m.FNSPRIZD = FCLCOD.value;
	m.FKSPRIZD = oCl.getCod();
	UpdateTable("^SHIFRPZ",m);
}

function fclValid()
{
	var fcod = Number(FIZDCOD.value);
	oCl.setClcl(FCLCOD.value);
	if(FCLCOD.value == 0)
	{
		FIZDCOD.value = fcod = 0;
		FCLTXT.value = "???";
		Disable(FIZDCOD);
	}
	else
	{
		var oSnap = getSnap("select Ftxt from ^CLCL where FCOD="+FCLCOD.value);
		if(oSnap && oSnap[0])
			FCLTXT.value = UR(oSnap[0]);
		Enable(FIZDCOD);
	}
	oCl.setCod(fcod);
	return true;
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FTXT = 0;
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	FCLCOD.value = par.ret.FCOD;
	FCLTXT.value = UR(par.ret.FTXT);
}