include("sys/DpBaseDlg.js");
include ("Objects/DpGetDat.js");

var selectID = 0;
var mainChild = null;
var dat1 = dat2 = null;

function Load()
{
	Caption(UR("Структура організації|Структура организации"));
	
	dat1 = (typeof extPar.dat1 == "undefined" ? null : extPar.dat1);
	dat2 = (typeof extPar.dat2 == "undefined" ? null : extPar.dat2);
	if (dat1 == null || dat2 == null)
	{
		var gd = new DpGetDat("dD");
		if (!gd.dat1 || !gd.dat2)
			return false;
		dat1 = gd.dat1;
		dat2 = gd.dat2;
	}
	
	fillTree(0, null);
	
	mainChild = tree.getChildsOf("0");
	for (var i in mainChild)
		tree.expand(mainChild[i]);
	if (extPar.fwid != 0)
		tree.setSelected(String(extPar.fwid));
	else if (mainChild.length > 0)
		tree.setSelected(mainChild[0]);
	
	this.onDblClickItem = onDblClickItem;
	tree.selectMenuHandler(this, "onDblClickItem");
	this.onSelItem = onSelItem;
	tree.setTreeSelHandler(this, "onSelItem");
}

function _getWhereClause(arg)
{
	var result = "";
	for (var i = 0; i < arg.length; i++)
	{
		if (i == 0)
			result += " fwid_par " + (arg[i] == null ? " IS NULL " : "=" + sqlTo(arg[i]));
		else
			result += "OR fwid_par " + (arg[i] == null ? " IS NULL " : "=" + sqlTo(arg[i]));
	}
	if (result)
		result = " WHERE " + result	+ " AND fbdat<=" + sqlTo(dat2) + " AND fedat>=" + sqlTo(dat1);
	return result;
}

function getFwid(fwid)
{
	if (fwid == null)
		return "0";
	return String(fwid);
}

function fillTree()
{
	var tbl = OpenTable("SELECT * FROM ^stru_org "
			+ _getWhereClause(fillTree.arguments) + " ORDER BY fleftkey");
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		tree.addItem(getFwid(tbl.getValue("fwid_par")), getFwid(tbl.getValue("fwid")), getLvls(tbl.getValue("flv1"),tbl.getValue("flv2"),tbl.getValue("flv3"),tbl.getValue("flv4"))+":"+tbl.getValue("ftxt"));
		fillTree(tbl.getValue("fwid"));
	}
	tbl.close;
}

function getLvls(Flv1,Flv2,Flv3,Flv4,Flv5)
{
	return String(Flv1)+(!isEmpty(Flv2)?("/"+Flv2+(!isEmpty(Flv3)?("/"+Flv3+(!isEmpty(Flv4)?"/"+Flv4+(!isEmpty(Flv5)?"/"+Flv5:""):"")):"")):"");
}

function onDblClickItem(ID)
{
	if (String(ID) == "DOUBLECLICK")
	{
		mainChild = tree.getChildsOf("0");
		for (var i in mainChild)
			if (String(mainChild[i]) == String(selectID))
				return;
		extPar.fwid = Number(selectID);
		extPar.escape = false;
		CloseWindow();
	}
}

function onSelItem(ID)
{
	selectID = String(ID);
}