include("sys//main.js");
include("sys//cbox.js");
include("sys//ListApi.js");
include("servis//date.js");
include("sys\\udfs.js")

var table;
var wdb,wde;
var sqlvix = "";


function Load()
{
	table = extPar.m_pTable;
	var bookmark = table.getValue("FDAY");	
	table.MoveFirst();
	while (!table.IsEOF())
	{
		if (getTimeAsString(table.getValue("FDB")) == "00 : 00" 
			&& getTimeAsString(table.getValue("FDE")) == "00 : 00" 
			&& getTimeAsString(table.getValue("FOB")) == "00 : 00"
			&& getTimeAsString(table.getValue("FOE")) == "00 : 00")
		{
			if (table.getValue("FDB").getYear() + 1900 == 3000)
			{
				sqlvix += table.getValue("FDATE").getDay() + ",";
			}
		}		
		table.MoveNext();
	}
	if (sqlvix != "")
		sqlvix = sqlvix.substring(0,sqlvix.length-1);

	table.MoveFirst();
	while (String(bookmark) != String(table.getValue("FDAY")))
	{
		table.MoveNext();
	}

	Caption(ru("Параметры регистратора ",
				"Параметри реєстратора ") + 
				"(" + getDayAsWeekName(table.getValue("fdate"))
				 +"  [" +  format("dd/mm/yyyy",table.getValue("fdate")) + "] )",
				extPar.mode);

	
	dbh.setMask("##");
	dbm.setMask("##");
	deh.setMask("##");
	dem.setMask("##");
	obh.setMask("##");
	obm.setMask("##");
	oeh.setMask("##");
	oem.setMask("##");
	
	dbh.value = table.getValue("fdb").getHours();
	dbm.value = table.getValue("fdb").getMinutes();
	deh.value = table.getValue("fde").getHours();
	dem.value = table.getValue("fde").getMinutes();
	obh.value = table.getValue("fob").getHours();
	obm.value = table.getValue("fob").getMinutes();
	oeh.value = table.getValue("foe").getHours();
	oem.value = table.getValue("foe").getMinutes();
	
	setRange(dbh,0,23);
	setRange(deh,0,23);
	setRange(obh,0,23);
	setRange(oeh,0,23);
	setRange(dbm,0,59);
	setRange(dem,0,59);
	setRange(obm,0,59);
	setRange(oem,0,59);
	
	ComboBox_AddItem(cb,"день",0);
	ComboBox_AddItem(cb,ru("неделя","тиждень"),1);
	ComboBox_AddItem(cb,ru("месяц","місяць"),2);
	ComboBox_AddItem(cb,ru("год","рік"),3);
	ComboBox_SetIndex(cb,0);
	
	setButton(adv,BUTT_VALID);
}

function onSave()
{
	var result = true;
	var err = ru("Внимание!","Увага!") ;
	if (dbh.getValue() == 0 && dbm.getValue() == 0)
	{
		err += "\n" + ru(" - не установлено время начала рабочего дня.",
					" - не встановлений час початку робочого дня");
	}
	if (deh.getValue() == 0 && dem.getValue() == 0)
	{
		err += "\n" + ru(" - не установлено время окончания рабочего дня.",
					" - не встановлений час закінчення робочого дня");
	}
	if (obh.getValue() == 0 && obm.getValue() == 0)
	{
		err += "\n" + ru(" - не установлено время начала перерыва.",
					" - не встановлений час початку перерви");
	}
	if (oeh.getValue() == 0 && oem.getValue() == 0)
	{
		err += "\n" + ru(" - не установлено время окончания перерыва.",
					" - не встановлений час закінчення перерви");
	}
	
	if (err.length > 10 && "n" == msgBox("yn", err, ru("Продолжить?", "Продовжити?"))) 
	{
		result = false;
	}
	if (result)
	{
		result = timeIsOk();
		if (result)
			result = addDataToTable(ComboBox_GetIndex(cb));
	}	
	return result;	
}

function addDataToTable(param)
{
	var isUser =  table.getValue("FIDUSER");
	var result = true;
	switch (param)
	{
		case 0:
			{				
				wdb = table.getValue("FDATE");
				wde = table.getValue("FDATE");
				setTime(wdb,0,0,0);
				setTime(wde,23,59,59);
				
				ExecuteSQL(getSQLV(isUser,wdb,wde));
				if (getTimeAsString(getTimeFromObjectVar(dbh,dbm)) != "00 : 00" 
					|| getTimeAsString(getTimeFromObjectVar(deh,dem)) != "00 : 00" 
					|| getTimeAsString(getTimeFromObjectVar(obh,obm)) != "00 : 00"
					|| getTimeAsString(getTimeFromObjectVar(oeh,oem)) != "00 : 00")
					{
						ExecuteSQL(getSQLUp(isUser,wdb,wde));
					}	
			}
			break;
		case 1:
			{
				wdb = getWeekBE(table.getValue("FDATE"))[0];
				wde = getWeekBE(table.getValue("FDATE"))[1];
				
				ExecuteSQL(getSQLV(isUser,wdb,wde));								
				ExecuteSQL(getSQLUp(isUser,wdb,wde));
			}
			break;
		case 2:
			{
				wdb = table.getValue("FDATE");
				wdb.setDate(1);
				wde = table.getValue("FDATE");
				var col = getDaysInMonth(new Date().setMonth(wde.getMonth()));
				wde.setDate(col);
				setTime(wdb,0,0,0);
				setTime(wde,23,59,59);
				
				if (new Date > toScriptDate(wdb) && 
					"n" == msgBox("yn",ErrorDiapDate(wdb,new Date),ru("Продолжить?", "Продовжити?")))				
				{
					result = false;
				}
				else
				{
					ExecuteSQL(getSQLV(isUser,wdb,wde));
					ExecuteSQL(getSQLUp(isUser,wdb,wde));
				}
			}				
			break;
		case 3:	
			{
				wdb = table.getValue("FDATE");
				wdb.setMonth(0);
				wdb.setDate(1);
				wde = table.getValue("FDATE");
				wde.setMonth(11);
				wde.setDate(31);
				setTime(wdb,0,0,0);
				setTime(wde,23,59,59);
				
				if (new Date > toScriptDate(wdb) && 
					"n" == msgBox("yn",ErrorDiapDate(wdb,new Date),ru("Продолжить?", "Продовжити?")))				
				{
					result = false;
				}
				else
				{
					ExecuteSQL(getSQLV(isUser,wdb,wde));
					ExecuteSQL(getSQLUp(isUser,wdb,wde));
				}
			}
			break;
		default:
			result = false;								
	}
	return result;	
}

function getTimeFromObjectVar(tbegin,tend)
{
	var date = new Date();
	if (typeof tbegin == "object") date.setHours(tbegin.getValue())
	else date.setHours(tbegin);
	if (typeof tend == "object") date.setMinutes(tend.getValue())
	else date.setMinutes(tend);
	date.setSeconds(0);	
	return date;
}

function getSQLV(user,date0,date1)
{
	var d = new Date(3000,0,1,0,0,0);
	return "UPDATE ^par_stuff SET"
		 + "  fdb = " + sqlTo(d,null,true)
		 + ", fde = " + sqlTo(d,null,true)
		 + ", fob = " + sqlTo(d,null,true)
		 + ", foe = " + sqlTo(d,null,true)
		 + " WHERE fiduser = " + sqlTo(user)
		 + " AND fdate BETWEEN " + sqlTo(date0,null,true) + " AND " + sqlTo(date1,null,true)
		 + " AND fdb <> " + sqlTo(new Date(3001,0,1,0,0,0),null,true);		 
}

function getSQLUp(user,date0,date1)
{
	var SQL = "UPDATE ^par_stuff SET "
			+ "  fdb = " + sqlTo(getTimeFromObjectVar(dbh,dbm),null,true)
			+ ", fde = " + sqlTo(getTimeFromObjectVar(deh,dem),null,true)
			+ ", fob = " + sqlTo(getTimeFromObjectVar(obh,obm),null,true)
			+ ", foe = " + sqlTo(getTimeFromObjectVar(oeh,oem),null,true)
			+ " WHERE fiduser = " + sqlTo(user)
			+ " AND fdate BETWEEN " + sqlTo(date0,null,true) + " AND " + sqlTo(date1,null,true)
			+ " AND fdb <> " + sqlTo(new Date(3001,0,1,0,0,0),null,true);
	var sqladd = "";
	if (sqlvix != "")
	{
		sqladd = " AND fday not in (" + sqlvix + ")";
	}
	SQL += sqladd;
	return SQL;
}

function ErrorDiapDate(date0,date1)
{
	var err = ru(
	    "Внимание!\nВозможна потеря информации за период:\n"
	  + "с " + getShortNameVsDate(date0) 
	  + " по " + getShortNameVsDate(date1),
		"Увага!\nМожлива втрата інформації за період:\n"
	  + "з " + getShortNameVsDate(date0)
	  + " по " + getShortNameVsDate(date1));	

	return err;
}

function getNFD(date)
{
	var result = 1;
	result += date.getDate() * 1;
	result += date.getMonth() * 10;
	result += date.getYear() * 100;
	return result;	
}

function timeIsOk()
{
	var msg_err = new Array(ru("Время начала и окончания рабочего дня заданы некорректно!",
				  "Час початку та закінчення робочого дня задани некоректно!") + "\n",
				  ru("Время начала и окончания перерыва заданы некорректно!",
				  "Час початку та закінчення перерви задани некоректно!") + "\n");
	result = true;
	var err = "";
	var index;
	if (getNfromObj(dbh,dbm) >= getNfromObj(deh,dem))
	{
		err += msg_err[0];
		index = 0;
	}
	if (getNfromObj(obh,obm) >= getNfromObj(oeh,oem) && err == "")
	{
		err += msg_err[1];
		index = 1;
	}
	else
	if (err == "")
	{
		if (getNfromObj(dbh,dbm) >= getNfromObj(obh,obm)
			 || getNfromObj(obh,obm) >= getNfromObj(deh,dem))
		{
			err += msg_err[1];
			index = 2;
		}
		else
			if (getNfromObj(dbh,dbm) >= getNfromObj(oeh,oem)
			 		|| getNfromObj(oeh,oem) >= getNfromObj(deh,dem))
			{
				err += msg_err[1];
				index = 1;			
			}	
	}
	if (err != "")
	{
		alert(ru("Внимание!","Увага!") + "\n" + err);
		result = false;
		switch (index)
		{
			case 0: 
				setFocus(deh);
				break;
			case 1:
				setFocus(oeh);
				break;
			case 2:
				setFocus(obh);
				break;				
		}
	}
	return result;
}

function getNfromObj(h,m)
{
	return Number(h.getValue())*60 + Number(m.getValue());
}

function BUTT_VALID()
{
	var ppar = new Object ;
	ppar.vix = sqlvix;
	ppar.cbindex = ComboBox_GetIndex(cb);
	ppar.day = table.getValue("FDAY");
	showWindow("e_stuff_eegparams.xml", SW_MODAL, ppar);
	sqlvix = ppar.vix;
}

include("sys\\DpBaseDlg.js");