include("objects\\DpNop.js");
include("objects\\DpzDoc.js");
include("Objects\\DpDcExpr.js");

var Validation = true;
var edmode,t, mFdoc, mFnop, zdoc, znop, objFcond;

function Load() 
{
	this.tbl = extPar.tblSrc;
	var i;
	zdoc = new DpzDoc();
	znop = new DpNop();
	t = extPar.m_pTable;
	edmode = extPar.mode;
	Caption(ru("Переменные документа","Змінні документа"),extPar.mode)
	m_zntbl = false;
	mFdoc = extPar.doc;
	if (edmode=="EDIT" || edmode=="COPY")
	{
		/*
		var sSnap = "select * from ^VARDOC where Fwid=" + sqlToFind(extPar.fid);
		var oSnap = getSnap(sSnap);
		if (oSnap != null)
		*/ 
			m_zntbl = true;
	}
	znop.linkCtrl(Fnop, Fdoc);
	zdoc.linkCtrl(Fdoc);
	objFcond = new DpDcExpr("R", extPar.doc, extPar.nop, Fexpr);
	if (m_zntbl)
	{
		mFdoc = this.tbl.getValue("Fdoc");
		mFnop = extPar.nop;       
		znop.setCod(this.tbl.getValue("Fnop"));
		objFcond.setValue(this.tbl.getValue("Fexpr"));
		//Fnom.value = this.tbl.getValue("Fnom");	    
		Fvar.value  = this.tbl.getValue("Fvar");
		Ftype.value = this.tbl.getValue("Ftype");
		Frem.value  = this.tbl.getValue("Frem");
		if(this.tbl.getValue("FATTR")=="R")
			ROWVAR.checked = true;		
	}
	else
	{
		if (extPar.extnop)
			mFnop = extPar.extnop;
		else
			mFnop = 0;
		znop.setCod(mFnop);
		//Fnom.value = 0;	    
		Fvar.value  = "";
		Frem.value  = "";
		objFcond.setValue("");	    
	}
	
	znop.setZeroIsValid();
	znop.getCod();
	zdoc.setCod(mFdoc);
	zdoc.getCod();
	zdoc.setCod(Fdoc.value);
	zdoc.linkCtrlNop(Fnop);

	setValid(Fvar, Fvar_Valid);
	setValid(Fexpr, Fexpr_Valid);

	setFocus(Fnop);
	
	if(edmode=="EDIT")
	{
		//Disable(ROWVAR);
		Disable(Fdoc);
		Disable(Fnop);
		setFocus(Fvar);		
	}   
}

function UnLoad()
{
        t.Close();
}


function Fexpr_Valid()
{
	if(Fexpr.text == "")
	{
		WAIT("Пустое значение выражения недопустимо");
		return false;
	}
}
function onSave()
{
	  var m = new Object();
	  var flag = true;	  
	  if (edmode=="EDIT")
      {
      	 /*
      	 var sSnap = "select Fwid from ^VARDOC where Fwid=" + sqlToFind(extPar.fid);
      	 var oSnap = getSnap(sSnap);
   	     if (oSnap == null)
			m.Fwid = GetUID();
		*/
		flag = false;
      }
      else
      {
		m.Fwid = GetUID();
      }
	  m.Fdoc = Fdoc.value;
	  
	  nNop = Fnop.value;
	  if (!isNaN(nNop))
	  	nNop = Number(nNop);
	  m.Fnop = Fnop.value;
	  m.Ftype = Ftype.value;
	  //m.Fnom = Number(Fnom.value)
	  m.Fvar = allt(Fvar.value).toUpperCase();
	  m.Frem = Frem.value;
	  m.Fexpr = objFcond.getValue();
	  m.fdefa = 0;
	  if(ROWVAR.checked==true)
	  	m.FATTR = "R";
	  else
	    m.FATTR = "";
      extPar.fid = this.tbl.getValue("fwid");
      UpdateTable("^VARDOC",m,flag," Fwid=" + sqlTo(extPar.fid) );
      UpdateTable(extPar.tblname,m,flag," Fwid=" + sqlTo(extPar.fid));
   	
 
	varToXML(m);
}

function varToXML(m)
{
	include ("objects/DpXMLDomDocument.js");
	var sPath = getOrgPath() +"settings/docvars/"+ String(m.Fdoc).toUpperCase().replace(":", "_") +"/";
	if(!isDir(sPath))
		createDirectory(sPath);
	var sFile =  sPath + m.Fnop +".xml";
	
	var xmlDom = new DpXMLDOMDocument();
	var root = xmlDom.createElement("uservars");
	var header = null;
	var eVar = null;
	if(isFile(sFile))
	{
		xmlDom.load(sFile);
		root = xmlDom.getDocumentElement();
		header = root.getElementsByTagName("header")[0];

		eVar = header.getElementsByTagName(m.Fvar)[0];
		if(eVar!=null)						
			header.removeChild(eVar);
					
		row = root.getElementsByTagName("row")[0];
		if(!row)
		{
			row = xmlDom.createElement("row");
			root.appendChild(row);
		}
		eVar = row.getElementsByTagName(m.Fvar)[0];
		if(eVar!=null)						
			row.removeChild(eVar);		
	}
	else
	{
		header = xmlDom.createElement("header");
		root.appendChild(header);
		
		row = xmlDom.createElement("row");
		root.appendChild(row);
	}		
	eVar = xmlDom.createElement(m.Fvar);
	eVar.setText(m.Frem);
	eVar.setAttribute("expr", m.Fexpr);
	eVar.setAttribute("type", m.Ftype);
	
	if (m.FATTR == "R")
		row.appendChild(eVar);
	else
		header.appendChild(eVar);
	
	if(!isFile(sFile))
		xmlDom.appendChild(root);
	xmlDom.save(sFile);
}

function Fvar_Valid()
{
	  var locdoc, locnop, locvar, fsymb;
	      Fvar.value = Fvar.value.toUpperCase();
	      fsymb = allt(Fvar.value).substring(0,1);
	      if (fsymb=="F" || fsymb=="R" || fsymb=="H" || fsymb=="X"){
	   WAIT("Имя переменной не должно начинаться с букв F,H,X,R");
	       return false;
	  }
	
	  if (allt(Fvar.value)==""){
	   WAIT("Введите имя переменной");
	       return false;
	      }
	
	      locdoc = Fdoc.value;
	      locnop = Fnop.value;
	      locvar = Fvar.value;
	   this.tbl = extPar.tblSrc;
	  var sSnap = "select Fwid from "+ this.tbl.getTableName() 
	  				+" where Fdoc=" + sqlToFind(locdoc) 
	  					+ " and Fnop=" + String(locnop) 
	  					+ " and Fvar=" + sqlToFind(locvar);
	  var oSnap = getSnap(sSnap);
	if (oSnap != null)
	{
    	if ( (edmode=="ADD" ||edmode=="COPY") ||( edmode=="EDIT" && oSnap[0]!=extPar.fid))
        {
            WAIT("Такая переменная уже существует");
        	return false;
    	}
    }
	return true;
}