/*этот расчёт был написан ещё Вероникой, расчёт вёлся по договорам, 
 *но Черкассы требуют сделать его как 2000-й по счетам
 *разница между 16 и 24 ведомостью только в наличии в 16-й оборотов по газу
 *поэтому расчёт был тупо скопирован с 24-й и добавлено поле fgas, 
 *которое считаем из таблицы rru по контрагенту
include ("Objects/DpGetDat.js");
include ("doc/DpDoc.js");
include ("Objects\\DpJRegistrator.js");
include ("Objects\\DpExtentionBuilder.js");

var tmpTbl = "VED_16";
var par = Object();
var sWhere;

function listAsk()
{
	return new DpGetDat("dD");
}

function listLoad()
{
	with(this)
	{
		xmlGridFile = "f16_full.xml";
		printLabel = "OBSCH";
	}
}

function listTitle()
{
	return  "Обіги за період|Обороти за период" 
			+ format("dd.mm.yyyy",list.objAsk.dat1) + " - "
			+ format("dd.mm.yyyy",list.objAsk.dat2);
}

function listSrc()
{
	sWhere = "1 = 1";
	showWindow("i_filter.xml",SW_MODAL,par);
	
	if (par.oLpu != null && par.oLpu != 0)
		sWhere += " AND FLPU=" + sqlTo(par.oLpu);
	if (par.oObl != null && par.oObl != 0)
		sWhere += " AND FREGION=" + sqlTo(par.oObl);
	if (par.oArea != null && par.oArea != 0)
		sWhere += " AND FAREA=" + sqlTo(par.oArea);
	if (par.oNas == true)
		sWhere += " AND FBUDJET=8";
	else
		sWhere += " AND FBUDJET<>8"
	if (par.oNak == true)
		sWhere += " AND FNAK<>" + sqlFalse;
	else
		sWhere += " AND (FNAK=" + sqlFalse + " OR FNAK is null)"; 
	
	this.qrySet("From",tmpTbl
				,"Where", sWhere
				,"Order","flpu,fregion,farea,fbudjet,ftt,forg");
}

function listMake()
{
	
	DropTable("VED_16");
		
	ExecuteSQL("CREATE TABLE " + tmpTbl + "("
					+ "FORG " + SqlType("LONG") + " DEFAULT 0, "
					+ "FREGION " + SqlType("LONG") + " DEFAULT 0, "
					+ "FAREA " + SqlType("LONG") + " DEFAULT 0, "
					+ "FLOCATE " + SqlType("LONG") + " DEFAULT 0, " 
					+ "FDOG_NUM " + SqlType("TEXT",25)+ ", "
					+ "FWID " + SqlType("COUNTER")+ ", "
					+ "FWID_DOG" + SqlType("LONG") + ", "
					+ "FLPU " + SqlType("LONG") + ", "
					+ "FDBN " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FCRN " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FDBO " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FCRO " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FDBK " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FCRK " + SqlType("CURRENCY") + " DEFAULT 0, "
					+ "FGAZ " + SqlType("DOUBLE",8) + " DEFAULT 0, "
					+ "FBUDJET " + SqlType("LONG") +", "
					+ "FNAK" + SqlType("LOGICAL") + ", "
					+ "FTT " + SqlType("INT")
					+ ")"
				);
					
	ExecuteSQL("create index FWID on " + tmpTbl + " (FWID)");
	
	var strSQL;
	
	var dt1 = new Date(list.objAsk.dat1.getYear() +1900,0,1);
	var dt2 = new Date(list.objAsk.dat1.getYear() +1900,11,31);
	
	var oExt = new DpExtentionBuilder("CL","0",null);
	var tblEName = oExt.getValueTableName();
	
	strSQL = "INSERT INTO " + tmpTbl + "(FORG,FDOG_NUM,FREGION,FAREA,FLOCATE,FLPU,FBUDJET,fnak,ftt,fwid_dog)"
			+ " (SELECT c.FORG as FORG,c.FDOG_NUM as FDOG_NUM,h.FREGION as FREGION,h.FAREA as FAREA,h.FLOCATE as FLOSATE,h.FLPU as FLPU, " 
			+  " ext.f_budjet as FBUDJET, ext.fotn_nak as fnak, 4 as ftt, c.fwid as fwid_dog FROM "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12)";
	ExecuteSQL(strSQL);
		
	ExecuteSQL("UPDATE " + tmpTbl + " set FBUDJET=1 WHERE FBUDJET IS NULL");		
	var oDoc = new DpDoc("TD","0");
	
	var tbl_j = "";
	var jID = oDoc.getPar("__jrn");
	if ((jID != "0") && (jID != null) && (jID != "undefined") && (jID != ""))
	{
		oReg = new DpJRegistrator(null,null);
		journal = oReg.listJournals()[jID];
		tbl_j=journal.getFullTableName();
		
		strSQL = "UPDATE " + tmpTbl + " set FDBN =(SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j + " WHERE FDAT<"
			 + sqlTo(list.objAsk.dat1) + " AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tmpTbl + " set FCRN = (SELECT SUM(FSUM_OPL)-SUM(FSUM_VYK) from " + tbl_j + " WHERE FDAT<"
			 + sqlTo(list.objAsk.dat1) + " AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tmpTbl + " set FDBO = (SELECT SUM(FSUM_VYK) from " + tbl_j + " WHERE FDAT>="
			 + sqlTo(list.objAsk.dat1) + " AND FDAT<=" + sqlTo(list.objAsk.dat2) +" AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
	
		strSQL = "UPDATE " + tmpTbl + " set FCRO = (SELECT SUM(FSUM_OPL) from " + tbl_j + " WHERE FDAT>="
			 + sqlTo(list.objAsk.dat1) + " AND FDAT<=" + sqlTo(list.objAsk.dat2) +" AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tmpTbl + " set FDBK = (SELECT SUM(FSUM_VYK)-SUM(FSUM_OPL) from " + tbl_j + " WHERE " 
				 + " FDAT<=" + sqlTo(list.objAsk.dat2) +" AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
	
		strSQL = "UPDATE " + tmpTbl + " set FCRK = (SELECT SUM(FSUM_OPL)-SUM(FSUM_VYK) from " + tbl_j + " WHERE"
				 + " FDAT<=" + sqlTo(list.objAsk.dat2) +" AND FDOG=" + tmpTbl + ".FWID_DOG)";
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE " + tmpTbl + " set FDBN=" + IIF("FDBN<0","0","FDBN") + ", "
				 + " FCRN=" + IIF("FCRN<0","0","FCRN") + ", "
				 + " FDBK=" + IIF("FDBK<0","0","FDBK") + ", "
				 + " FCRK=" + IIF("FCRK<0","0","FCRK");
		ExecuteSQL(strSQL);
	}
	else
	{
		fl = false;
		alert(ru("Не задан журнал регистрации договоров","Не заданий журнал реєстрації договорів"));		
	}	
	
	strSQL = "UPDATE " + tmpTbl +" set FGAZ=(SELECT  SUM(b.FKOL)  FROM ^RRU as b WHERE "
				+" b.FDATE>=" + sqlTo(list.objAsk.dat1) + " AND b.FDATE<=" + sqlTo(list.objAsk.dat2)
				+" AND b.FID_DOG=" + tmpTbl + ".FWID_DOG)";
	ExecuteSQL(strSQL);
	
	var sNak = sqlFalse;
	
	
	if (par.oNak == true)
		sNak = sqlTrue;
	
	var sNas = "<>8";
	var bud = "0";
	if (par.oNas == true)
	{
		sNas = "=8";
		bud = "8";
	}
	
	strSQL = "INSERT INTO " + tmpTbl + "(FAREA,FDBN,FCRN,FDBO,FCRO,FDBK,FCRK,FGAZ,Ftt,FLPU,FREGION,Forg,fnak,fbudjet) (SELECT FAREA,SUM(FDBN),SUM(FCRN),SUM(FDBO),SUM(FCRO),SUM(FDBK),SUM(FCRK),SUM(FGAZ),3 as Ftt, FLPU,FREGION, 0 as Forg, " + sNak + ",fbudjet FROM " 
			+ tmpTbl + " WHERE " + sWhere + " AND forg>0 GROUP BY fbudjet,FAREA,FREGION,FLPU)"
	ExecuteSQL(strSQL);

	strSQL = "INSERT INTO " + tmpTbl + "(FAREA,FDBN,FCRN,FDBO,FCRO,FDBK,FCRK,FGAZ,Ftt,FLPU,FREGION,Forg,fnak,fbudjet) (SELECT FAREA,SUM(FDBN),SUM(FCRN),SUM(FDBO),SUM(FCRO),SUM(FDBK),SUM(FCRK),SUM(FGAZ),2 as Ftt, FLPU,FREGION, 0 as Forg, " + sNak + "," + bud +" FROM " 
			+ tmpTbl + " WHERE ftt=3  GROUP BY FAREA,FREGION,FLPU)"
	ExecuteSQL(strSQL);

	strSQL = "INSERT INTO " + tmpTbl + "(FREGION,FDBN,FCRN,FDBO,FCRO,FDBK,FCRK,FGAZ,Ftt,FLPU,FAREA,fnak,fbudjet) (SELECT FREGION,SUM(FDBN),SUM(FCRN),SUM(FDBO),SUM(FCRO),SUM(FDBK),SUM(FCRK),SUM(FGAZ), 1 as Ftt,FLPU, 0 as Farea, " + sNak + "," + bud + " FROM "
			 + tmpTbl + " WHERE ftt=2 GROUP BY FREGION,FLPU)"
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO " + tmpTbl + "(FLPU,FDBN,FCRN,FDBO,FCRO,FDBK,FCRK,FGAZ,Ftt,Farea,Fregion,fnak,fbudjet) (SELECT FLPU,SUM(FDBN),SUM(FCRN),SUM(FDBO),SUM(FCRO),SUM(FDBK),SUM(FCRK),SUM(FGAZ), 0 as Ftt, 0 as Farea, 0 as Fregion, " + sNak + "," + bud + " FROM " 
			+ tmpTbl + " where  ftt=1 GROUP BY FLPU)"
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO " + tmpTbl + "(FDBN,FCRN,FDBO,FCRO,FDBK,FCRK, FGAZ,Ftt,FLPU,FREGION,Forg,fnak, fbudjet) (SELECT SUM(FDBN),SUM(FCRN),SUM(FDBO),SUM(FCRO),SUM(FDBK),SUM(FCRK),SUM(FGAZ),-1 as Ftt,0 as FLPU,0 as FREGION, 0 as Forg, " + sNak + "," + bud +" FROM " 
			+ tmpTbl + " where fbudjet" + sNas + " and ftt=0)";
			
	ExecuteSQL(strSQL);
	
	
}*/

include("Objects\\DpGrid.js");
include("lst_12.js");
//include("objects\\DpGetDat_16.js");
include("TrnNBln.js");
include("objects\\DpTVars.js");
   
var label = "f16";
var cnd="",ptumg=0,ptmin=0,ptobl=0,ptray=0,ptbdj=0,x_umgf,x_umgg,x_oblf,x_oblg,x_rayf,x_rayg,x_bdjf,x_bdjg,x_minf,x_ming;
var rc,outTbl,frtb,pr,kodumg1,kodobl1,kodray1,kodbdj1,kodmin1,wh_clause,x_sort= new Array(5);
var listPrnForm = "obsch";
var tblName = "my_tmp_obsch24";
var dat1;
var dat2;
var oGrid;
var oItog;

// 22.03.02 внесенi змiни, викликанi замiною текстового поля "Мiнiстерство"
// в 12-му довiднику на код органу управлiння з 15-го довiдника
// Шевченко Л.А.

function listLoad()
{
	this.title = ru("В е д о м о с т ь  № 16","В і д о м і с т ь  № 16"); 
	
	close_t_tab_ext();
	if (IsTable("t_f_24"))
		ExecuteSQL("Drop Table t_f_24");
    if (IsTable("t_f_24_1"))
		ExecuteSQL("Drop Table t_f_24_1");

	create_sporg();

	if (!zapros(1))
	{
		if (IsTable("t_f_24"))
			ExecuteSQL("Drop Table t_f_24");
		if (IsTable("t_f_24_1"))
			ExecuteSQL("Drop Table t_f_24_1");
		return false;
	}
   	
}

function makemySum(mode, tblInto, tblFrom)
{
	mode = mode.toUpperCase();
	var flds, flds0As, tLevel, having, groupBy, tType,fblank;
	tLevel=0;
	var isTotal = mode.charAt(0) == "!";
	if(isTotal)
	{
		mode = mode.substr(1);
		tType = "'" + mode + "'";
	}

	switch(mode)
	{
		case "UMG":
			flds = "'"+space(ptumg)+"'"+x_umgf;
			having = "HAVING t.fcl_cod1>0 and not t.fistotal";
			groupBy = x_umgg;
			tLevel = ptumg+3;
		break;
		case "OBL":
			flds = "'"+space(ptobl)+"'"+x_oblf;
			groupBy = x_oblg;
			tLevel = ptobl+3;
		break;
		case "RAY":
			flds = "'"+space(ptray)+"'"+x_rayf;
			groupBy = x_rayg;
			tLevel = ptray+3;
		break;
		case "MIN":
			flds = "'"+space(ptmin)+"'"+x_minf;
			groupBy =x_ming;
			tLevel = ptmin+3;
		break;
		case "BDJ":
			flds = "'"+space(ptbdj)+"'"+x_bdjf;
			groupBy =x_bdjg;
			tLevel = ptbdj+3;
		break;
	}

	if(!isTotal)
	{
		having = "";
		tLevel = 0;
		tType = "null";
	}

	DropTable(tblInto);
	ExecuteSQL(
		"SELECT "+flds
			+ " sum(t.fsum1) as fsum1,"
			+ " sum(t.fsum2) as fsum2,"
			+ " sum(t.fsum3) as fsum3,"
			+ " sum(t.fsum4) as fsum4,"
			+ " sum(t.fsum5) as fsum5,"
			+ " sum(t.fsum6) as fsum6,"
                  + " sum(t.fgas) as fgas,"
			+ isTotal?sqlTrue:sqlFalse + " as fistotal,"
			+ tType + " as ftt,"
			+ " " + tLevel + " as fttlevel"
			+ " INTO " + tblInto
			+ " FROM " + tblFrom + " AS t"
			+ " where t.fcl_cod1>0 and t.fistotal=" + SqlFalse
			+ " " + groupBy 
//      + "" + having
// Предыдущая строка была закомментирована, но без нее
// формируются лишние итоги
	);
}

function insertmyTbl(mode, tblInto, tblFrom)
{
	ExecuteSQL("INSERT INTO " + tblInto + " " + getColumn(tblInto,true)
				+ " SELECT " + getColumn(tblFrom,false)
				+ " FROM " + tblFrom );
}

function space(scount)
{
	var retstr="";
	for (i=1;i<=scount;i++)
	{
		retstr+=" ";
	}
	return retstr;
}

function close_t_tab_ext()
{
	cls_t_comtab_ext();
	if (IsTable("tmp_obsch_ext"))
		ExecuteSQL("Drop Table tmp_obsch_ext");
	if (IsTable("t_f_16_1"))
		ExecuteSQL("Drop Table t_f_16_1");
	return true;
}

function close_t_tab()
{
	if (IsTable("x_bdj"))
		ExecuteSQL("Drop Table x_bdj");
	if (IsTable("x_map"))
		ExecuteSQL("Drop Table x_map");
	if (IsTable("t_16_itog_obl"))
		ExecuteSQL("Drop Table t_16_itog_obl");
	if (IsTable("t_16_itog_umg"))
		ExecuteSQL("Drop Table t_16_itog_umg");
	if (IsTable("t_16_itog_ray"))
		ExecuteSQL("Drop Table t_16_itog_ray");
	if (IsTable("t_16_itog_min"))
		ExecuteSQL("Drop Table t_16_itog_min");
	if (IsTable("t_16_itog_bdj"))
		ExecuteSQL("Drop Table t_16_itog_bdj");
	return true;
}

function listAsk()
{
	var gd = new Object();
	gd.escape = false;
	gd.fitog = oItog.getCod();
	return gd;
}

function listMake()
{
	//в таблице tmp_obsch_ext код области и района перепутан местами, 
	//как это получилось разбираться не стал, просто поменял их метсами при создании таблицы t_f_24_1
	ExecuteSQL("select naz_org,kodumg,kodobl as kodray,kodray as kodobl,kodmin,kodbdj,fsum1,fsum2,fsum3,fsum4,fsum5,fsum6,"+
				" fistotal,ftt,fttlevel,kod_org,zndog,fsc,fsu,fst,kodOKPO,dog_dat,fgas into t_f_24_1 from  tmp_obsch_ext ");
	rpl_txt();
	
	//Итоги
	//itogy();
	
	ExecuteSQL("select naz_org,kodumg,kodobl,kodray,kodmin,kodbdj,fsum1,fsum2,fsum3,fsum4,fsum5,fsum6,"+
				" fistotal,ftt,fttlevel,kod_org,zndog,fsc,fsu,fst,kodOKPO,dog_dat,fgas into t_f_24 from  t_f_24_1 order by "+x_ind);
	
	if (IsTable("tmp_obsch_ext"))
		ExecuteSQL("Drop Table tmp_obsch_ext");

	ExecuteSQL("alter table t_f_24 add fwid " + SqlType("counter"));
	ExecuteSQL("alter table t_f_24 drop column ftt", false);
	ExecuteSQL("alter table t_f_24 add ftt " + SqlType("TEXT", 10), false);
	
	list.objTotal.init(label);
	return true;
}

function zapros(m)
{
	if (m==1)
	{
		//pr= new DpGetDat16("BORUMB1O1R1U1M1dDcutx0");
		var form = createForm(UR("Введіть дані для відбору інформації|Введите данные для отбора информации"));
		oItog = form.addItog(label);
		var ctrldat1 = form.addObj("dat1","date",UR("Дата початку|Дата начала"));
		ctrldat1.setValue(getPar("GLOBDAT1"));
		var ctrldat2 = form.addObj("dat2","date",UR("Дата кінця|Дата конца"));
		ctrldat2.setValue(getPar("GLOBDAT2"));
		var oSc = form.addSchet(true,true,true,true,true);
		var pbdj = form.addKatPotr(true);
		var fobl = form.addRegion(true);
		var pray = form.addArea(true);
		var min = form.addEconomy(true);
		var umg = form.addObj("umg","combo",UR("В розрізі по УМГ|В разрезе по УМГ"));
		umg.addItem(0, UR("Усі УМГ|Все УМГ"));
		umg.addItem(360, UR("360 Первомайськ|360 Первомайск"));
		umg.addItem(380, UR("380 Кременчук|380 Кременчуг"));
		umg.addItem(400, UR("400 Золотоноша|400 Золотоноша"));
		umg.addItem(420, UR("420 Олександрівка|420 Александровка"));
		umg.addItem(440, UR("440 Гайсин|440 Гайсин"));
		umg.addItem(460, UR("460 Бар|460 Бар"));
		umg.addItem(350, UR("Інші ЛВУМГ|Другие ЛВУМГ"));
		umg.setValue(0);
		form.show();
		if(form.escape == true)
		{
			close_t_tab_ext();
			return false;
		}
		setPar("GLOBDAT1", form.ctrldat1);
		setPar("GLOBDAT2", form.ctrldat2);
		pr = new Object()
		dat1=form.dat1;
		dat2=form.dat2;
					
		pr.dat1 = dat1;
		pr.dat2 = dat2;
		pr.sc = form.SC;
		pr.pbdj = 0;
		pr.bdj = pbdj.getCod();
		pr.fobl = 0;
		pr.pobl = pray.getCod()
		pr.pray = 0;
		pr.ray = fobl.getCod();
		pr.pmin = 0;
		pr.min = min.getCod();
		pr.pumg = 0;
		pr.umg = form.umg;
		
		if (IsTable(tblName))
			ExecuteSQL("Drop Table "+ tblName);
		TrnNBln("", tblName, dat1, dat2, oSc);
		//ExecuteSQL("update "+ tblName +" set FTT=trim(FTT)");
		
		if (IsTable("my_tmp_obsch_1"))
			ExecuteSQL("Drop Table my_tmp_obsch_1");

		if (IsTable("my_tmp_obsch_2"))
			ExecuteSQL("Drop Table my_tmp_obsch_2");

		if (IsTable("my_tmp_obsch_sc"))
			ExecuteSQL("Drop Table my_tmp_obsch_sc");

		if (IsTable("my_tmp_obsch_st"))
			ExecuteSQL("Drop Table my_tmp_obsch_st");

		if (IsTable("my_tmp_obsch_su"))
			ExecuteSQL("Drop Table my_tmp_obsch_su");
	}
	else
	{
    	pr = new DpGetDat16("BORUMB1O1R1U1M1");
		if (pr.ob==0)
		{
			close_t_tab_ext();
			return false;
		}
	}
	x_sort[0]="";
	x_sort[1]="";
	x_sort[2]="";
	x_sort[3]="";
	x_sort[4]="";
	x_sort[5]="";

	if ((pr.pbdj-0)>0)
		x_sort[pr.pbdj-0]='kodbdj,';
	ptbdj=pr.pbdj-0;
	kodbdj1=pr.bdj;
	if ((pr.pobl-0)>0)	
		x_sort[pr.pobl-0]='kodobl,' ;
	ptobl=pr.pobl-0;
	kodobl1=pr.obl;
	if ((pr.pray-0)>0)
		x_sort[pr.pray-0]='kodray,';
	ptray=pr.pray-0;
	kodray1=pr.ray;
	if ((pr.pumg-0)>0)
		x_sort[pr.pumg-0]='kodumg,';
	ptumg=pr.pumg-0;
	kodumg1=pr.umg;
	if ((pr.pmin-0)>0)
		x_sort[pr.pmin-0]='kodmin,';
	ptmin=pr.pmin-0;
	kodmin1=pr.min;

//	x_ind="("+x_sort[0]+x_sort[1]+x_sort[2]+x_sort[3]+x_sort[4]+x_sort[5]+"fistotal, fttlevel)"
	x_ind=x_sort[0]+x_sort[1]+x_sort[2]+x_sort[3]+x_sort[4]+x_sort[5]+"fistotal, fttlevel,kod_org";

// Подг-ка списка полей и Group by для make_sum
////////////////////////////////

	x_umgf="'Всего по УМГ : '+t.znumg as naz_org,t.kodumg,";


	if (ptumg>ptobl)
		x_umgf +=(ptobl==0)? " 0 as kodobl,":" t.kodobl,";
	else
		x_umgf +=" 0 as kodobl,";

	if (ptumg>ptray)
		x_umgf +=(ptray==0)? " 0 as kodray,":" t.kodray,";
	else
		x_umgf +=" 0 as kodray,";

	if (ptumg>ptmin)
		x_umgf +=(ptmin==0)? " null as kodmin,":" t.kodmin,";
	else
		x_umgf +=" null as kodmin,";

	if (ptumg>ptbdj)
		x_umgf +=(ptbdj==0)? " null as kodbdj,":" t.kodbdj,";
	else
		x_umgf +=" null as kodbdj,";

	x_umgg="GROUP BY ";

	for (i=0;i<ptumg;i++)
		x_umgg +=(x_sort[i]=="")? "":("t."+x_sort[i]);
	x_umgg +="t.znumg,t.kodumg";

/////////////////////////

	x_bdjf="'Всего по БЮДЖЕТУ : '+t.znbdj as naz_org,";
	if (ptbdj>ptumg && ptumg>0)
		x_bdjf +=" t.kodumg,";
	else
		x_bdjf +=" null as kodumg,";

	if (ptbdj>ptobl && ptobl>0)
		x_bdjf +=" t.kodobl,";
	else
		x_bdjf +=" 0 as kodobl,";

	if (ptbdj>ptray && ptray>0)
		x_bdjf +=" t.kodray,";
	else
		x_bdjf +=" 0 as kodray,";

	if (ptbdj>ptmin && ptmin>0)
		x_bdjf +=" t.kodmin,";
	else
		x_bdjf +=" null as kodmin,";

	x_bdjf+="t.kodbdj,"
	x_bdjg="GROUP BY ";
	for (i=0;i<ptbdj;i++)
		x_bdjg +=(x_sort[i]=="")? "":("t."+x_sort[i]);
	x_bdjg +="t.znbdj,t.kodbdj";

/////////////////////////

	x_minf="'Всего по '+t.znmin as naz_org,";

	if (ptmin>ptumg && ptumg>0)
		x_minf+=" t.kodumg,";
	else
		x_minf+=" null as kodumg,";

	if (ptmin>ptobl && ptobl>0)
		x_minf+=" t.kodobl,";
	else
		x_minf+=" 0 as kodobl,";

	if (ptmin>ptray && ptray>0)
		x_minf+=" t.kodray,";
	else
		x_minf+=" 0 as kodray,";

	x_minf+=" t.kodmin,";

	if (ptmin>ptbdj && ptbdj>0)
		x_minf+=" t.kodbdj,";
	else
		x_minf+=" null as kodbdj,";

	x_ming="GROUP BY ";
	for (i=0;i<ptmin;i++)
		x_ming +=(x_sort[i]=="")? "":("t."+x_sort[i]);
	x_ming +="t.znmin,t.kodmin";

/////////////////////////

	x_oblf="'Всего по ОБЛАСТИ : '+t.znobl as naz_org,";

	if (ptobl>ptumg && ptumg>0)
		x_oblf+=" t.kodumg,";
	else
		x_oblf+=" null as kodumg,";

	x_oblf+=" t.kodobl,";

	if (ptobl>ptray && ptray>0)
		x_oblf+=" t.kodray,";
	else
		x_oblf+=" 0 as kodray,";

	if (ptobl>ptmin && ptmin>0)
		x_oblf+=" t.kodmin,";
	else
		x_oblf+=" null as kodmin,";

	if (ptobl>ptbdj && ptbdj>0)
		x_oblf+=" t.kodbdj,";
	else
		x_oblf+=" null as kodbdj,";

	x_oblg="GROUP BY ";
	for (i=0;i<ptobl;i++)
		x_oblg +=(x_sort[i]=="")? "":("t."+x_sort[i]);
	x_oblg +="t.znobl,t.kodobl";

/////////////////////////

	x_rayf="'Всего по РАЙОНУ : '+t.znray as naz_org,";

	if (ptray>ptumg && ptumg>0)
		x_rayf+=" t.kodumg,";
	else
		x_rayf+=" null as kodumg,";

	if (ptray>ptobl && ptobl>0)
		x_rayf+=" t.kodobl,";
	else
		x_rayf+=" 0 as kodobl,";

	x_rayf+=" t.kodray,";

	if (ptray>ptmin && ptmin>0)
		x_rayf +=" t.kodmin,";
	else
		x_rayf +=" null as kodmin,";

	if (ptray>ptbdj && ptbdj>0)
		x_rayf +=" t.kodbdj,";
	else
		x_rayf +=" null as kodbdj,";

	x_rayg="GROUP BY ";
	for (i=0;i<ptray;i++)
		x_rayg +=(x_sort[i]=="")? "":("t."+x_sort[i]);
	x_rayg +="t.znray,t.kodray";

	//к различным счетам относятся договора за разные года
	var year;
	var su = Number(oSc.getSu());
	var st = Number(oSc.getSt());
	switch(su)
	{
		case 361:
			switch(st)
			{
				case 1,2:
					year = 2007;
				break;
				case 6,11:
					year = 2006;
				break;
				case 5,15:
					year = 2005;
				break;
				case 14:
					year = 2004;
				break
				case 13:
					year = 2003;
				break;
				default:
					year = new Date(dat1).getFullYear();
			}
		break;
		case 682:
			switch(st)
			{
				case 3,4:
					year = 2007;
				break;
				case 5,6:
					year = 2006;
				break;
				case 1,2:
					year = 2005;
				break;
				case 9:
					year = 2004;
				break
				default:
					year = new Date(dat1).getFullYear();
			}
		break;
		default:
			year = new Date(dat1).getFullYear();
	}
	
	var dat_now1 = new Date(year,0,1);
	var dat_now2 = new Date(year,11,31);

	//wh_clause=" where (a.fistotal=-1) or (b.fbdat>="+sqlTo(dat_now1)+" and b.fedat<="+sqlTo(dat_now2);
	wh_clause=" where (a.fistotal=-1) or (1=1 ";

	if (kodbdj1>0)
		wh_clause +=" and b.kodbdj="+kodbdj1;
	if (kodobl1>0)
		wh_clause +=" and b.kodobl=" +kodobl1;
	if (kodray1>0)
		wh_clause +=" and b.kodray="+kodray1;
	if (kodumg1!=0)
		wh_clause +=" and b.kodumg="+parseInt(kodumg1);
	else
		wh_clause +=" and b.kodumg is not null"
	if (kodmin1>0)
		wh_clause +=" and b.kodmin="+kodmin1;
	wh_clause +=")";
	
	ExecuteSQL("alter table xorg_prop add fgas "+sqlType("DOUBLE"))
	
	ExecuteSQL("select a.fcl_cod1 as kod_org,a.fsc,a.fsu,a.fst,a.fsum1,a.fsum2,a.fsum3,a.fsum4,"+
		" a.fsum5,a.fsum6,a.fistotal,a.ftt,a.fttlevel,"+
		SqlConCat(SqlSpace(6),"b.naz_org") + " as naz_org,b.kodmin,b.znmin,b.kodumg,b.znumg,b.kodbdj,b.znbdj,"+
		" b.kodobl,b.znobl,b.kodray,b.znray,b.zndog,b.kodOKPO,b.dog_dat,b.fgas "+
		" into tmp_obsch_ext "+
		" from "+tblName+" a left join xorg_prop b"+
		" on a.fcl_cod1=b.kod_org and b.fbdat>="+sqlTo(dat_now1)+" and b.fedat<="+sqlTo(dat_now2)+
		//чтобы отловить контрагентов без договоров добавляем следуещее условие
		wh_clause+" or (b.kod_org is null and a.fcl_cod1<>0)"+
		" order by fistotal,fttlevel" );
		
		/*считать объёмы будем по NK, т.к. в RU, SU заносятся только объёмы из умгов и не попадают объёмы от населения и т.д.
		ExecuteSQL("UPDATE tmp_obsch_ext set fgas=(select sum(fkol) from "
			+" ^rru where fclient=tmp_obsch_ext.kod_org and fdate>="
				+sqlTo(dat1)+" and fdate<="+sqlTo(dat2)+")")*/
		ExecuteSQL("UPDATE tmp_obsch_ext set fgas=(select sum(fkol) from "
			+" ^sch_zag where fdoc='NK' and fdbkr=tmp_obsch_ext.kod_org and fdoc_dat>="
				+sqlTo(dat1)+" and fdoc_dat<="+sqlTo(dat2)+")")
	
	return true;
}

function itogy()
{
	outTbl="t_16_itog";
	frtb="tmp_obsch_ext";
	res_tb="t_f_24_1";

	if (ptumg>0)	makemySum("!umg", outTbl + "_umg", frtb);
	if (ptobl>0)    makemySum("!obl", outTbl + "_obl", frtb);
	if (ptray>0)    makemySum("!ray", outTbl + "_ray", frtb);
	if (ptmin>0)    makemySum("!min", outTbl + "_min", frtb);
	if (ptbdj>0)    makemySum("!bdj", outTbl + "_bdj", frtb);
	if (ptumg>0)    insertmyTbl("umg", res_tb, outTbl + "_umg");
	if (ptobl>0)    insertmyTbl("obl", res_tb, outTbl + "_obl");
	if (ptray>0)    insertmyTbl("ray", res_tb, outTbl + "_ray");
	if (ptmin>0)    insertmyTbl("min", res_tb, outTbl + "_min");
	if (ptbdj>0)    insertmyTbl("bdj", res_tb, outTbl + "_bdj");
	close_t_tab();
}

function rpl_txt()
{
	xt=OpenTable("s","select fsc,fsu,fst from "+tblName+" where fistotal=-1");
	//xt.MoveFirst();
	while (!xt.IsEOF())
	{
		switch(String(xt.getValue("ftt")))
		{
			case "SC" :
    	    	znorg="'По счету "+xt("fsc")+"'";
        		ExecuteSQL("update t_f_24_1 set naz_org="+znorg+" where ftt='SC'");
			break;
			case "SU" :
				znorg="'По счету "+xt("fsc")+"/"+xt("fsu")+"'";
				ExecuteSQL("update t_f_24_1 set naz_org="+znorg+" where ftt='SU'");
			break;
			case "ST" :
				znorg="'По счету "+xt("fsc")+"/"+xt("fsu")+"/"+xt("fst")+"'";
				ExecuteSQL("update t_f_24_1 set naz_org="+znorg+" where ftt='ST'");
		}
		xt.MoveNext();
	}
}

function listSrc()
{
	var strOrder;
	switch(Number(oItog.getCod()))
	{
		case 45:
			strOrder = "kodumg,kod_org"; 
		break;
		case 46:
			strOrder = "kodumg,kodobl,kod_org";
		break;
		case 47:
			strOrder = "kodumg,kodobl,kodray,kod_org";
		break;
		case 48:
			strOrder = "kodumg,kodobl,kodray,kodbdj,kod_org";
		break;
		case 49:
			strOrder = "kodumg,kodobl,kodbdj,kod_org";
		break;
	}
	this.qrySet("From", "t_f_24", "Order", strOrder)
}

function listGrid()
{
	oGrid = new DpGrid();

	with(oGrid)
	{	
		with(page("money"))
		{
			cell("kod_org","Код",4);			
			cell("=^FTT=='!!'? 'Общий итог' "
				+" : ^FTT=='UMG'? 'Всего по '+ tforg('TXT', ^KODUMG)"
				+" : ^FTT=='BDJ'? 'Всего по бюджету: '+ tfcl('TXT',93,^KODBDJ).toLowerCase()"
			//код области и района перепутаны местами
				+" : ^FTT=='OBL'? 'Всего по области: '+ tfcl('TXT',getPar('CODREGION'),^KODOBL)"
				+" : ^FTT=='RAY'? 'Всего по району: '+ tfcl('TXT',getPar('CODAREA'),^KODRAY)"
				+" : ^FTT=='MIN'? 'Всего по виду экономич. деятельности: '+ ^KODMIN"
				+" : ^FTT=='ORG'? 'Всего по '+ tforg('TXT', ^KOD_ORG)"
				+" : ^FTT=='SC_'? 'Всего по счету: '+ ^FSC"
				+" : ^FTT=='SU_'? 'Всего по счету: '+ ^FSC +'/'+ ^FSU"
				+" : ^FTT=='ST_'? 'Всего по счету: '+ ^FSC +'/'+ ^FSU +'/'+ ^FST"
				+" : ^NAZ_ORG", "Название", 20);			
			
			cell("kodOKPO","ЄДРПО|ОКПО",8);
			cell("zndog","Договор",8);
			cell("dog_dat","Дата укладення|Дата заключения",8);
			
			with(group("Сальдо на начало"))
			{
				cell("fsum1","Дебет",6, "", DP_FORMAT_SUM);
				cell("fsum2","Кредит",6, "", DP_FORMAT_SUM);
			}
			with(group("Обороты"))
			{
				cell("fsum5","Дебет",6, "", DP_FORMAT_SUM);
				cell("fgas","Газ",6, "", DP_FORMAT_SUM);
				cell("fsum6","Кредит",6, "", DP_FORMAT_SUM);
			}
			with(group("Сальдо на конец"))
			{
				cell("fsum3","Дебет",6, "", DP_FORMAT_SUM);
				cell("fsum4","Кредит",6, "", DP_FORMAT_SUM);
			}
			cell("kodumg", "Код УМГ", 6)
			cell("kodobl", "Код области", 6)
			cell("kodray", "Код района", 6)
			cell("kodbdj", "Код бюджета", 6)
			cell("kodmin", "Код эк.деят.", 6)
		}
		
		defCond("=^Fttlevel==1","cnd1")
		defCond("=^Fttlevel==2","cnd2")
		defCond("=^Fttlevel==3","cnd3")
		defCond("=^Fttlevel==4","cnd4")
		defCond("=^Fttlevel==5","cnd5")
		defCond("=^Fttlevel==6","cnd6")
		defCond("=^Fttlevel==7","cnd7")
		defCond("=^Fttlevel==8","cnd8")

		color(1,"cnd1");
		color(1,"cnd2");
		color(1,"cnd3");
		color(4-2,"cnd4");
		color(5-2,"cnd5");
		color(6-2,"cnd6");
		color(7-2,"cnd7");
		color(8-2,"cnd8");
		bold("cnd1");		
		bold("cnd2");
		bold("cnd3");
		bold("cnd4");
		bold("cnd5");
		bold("cnd6");
		bold("cnd7");
		bold("cnd8");
		
		build();
	}
}

function listMenuInit()
{
	ds = DataSource();
	if (list.tbl.recordCount>0)
	{
		ds.AddMenuItem("PRINT","Друк |Печать ",9);
		ds.AddMenuItem("CHANG","Змінити параметри|Изменить параметры ");
		ds.AddMenuItem("sver","Згорнути|Свернуть ");
		ds.AddMenuItem("razver","Розгорнути|Развернуть ");
		ds.AddMenuItem("EXP","Експорт|Экспорт ");   
	}
}

function listMenuRun(nID)
{
	var par = Object(),lpTbl,prnPatt;
	switch(nID)
	{
		case "sver":
			t=OpenTable("s","select * from t_f_24 where fistotal=-1");
			oGrid.setTable(t);
			grid.refresh();		
		break;
		case "razver":
			t=OpenTable("s","t_f_24");
			oGrid.setTable(t);
			grid.refresh();		
		break;
		case "EXP":
			_export();
		break;
		case "PRINT":
         	prnPatt="OBSCH";
			lpTbl=DataSource().getTable();
			var tv= new DpTVars(prnPatt);
			tv.setRTbl(lpTbl);
			tv.eval.addVar("dat1",dat1 );
			tv.eval.addVar("dat2",dat2 );
			Form.print(tv);
		break; 
		case "CHANG":
			if (zapros(0))
			{
				if (IsTable("t_f_24"))
				{
					ExecuteSQL ("delete from t_f_24 ");
					ExecuteSQL ("delete from t_f_24_1 ");
					ExecuteSQL("insert into t_f_24_1 (naz_org,kodumg,kodobl,kodray,kodmin,kodbdj,fsum1,fsum2," +
							"fsum3,fsum4,fsum5,fsum6,fistotal,ftt,fttlevel,kod_org,zndog,fgas) " +
							"select naz_org,kodumg,kodobl,kodray,kodmin,kodbdj,fsum1,fsum2," +
							"fsum3,fsum4,fsum5,fsum6,fistotal,ftt,fttlevel,kod_org,zndog,fgas,kodOKPO,dog_dat " +
							"from  tmp_obsch_ext ");
					rpl_txt();
					itogy();		
					ExecuteSQL("insert into t_f_24 (naz_org,kodumg,kodobl,kodray,kodmin,kodbdj,fsum1,fsum2," +
							"fsum3,fsum4,fsum5,fsum6,fistotal,ftt,fttlevel,kod_org,zndog,fgas) " +
							"select naz_org,kodumg,kodobl,kodray,kodmin,kodbdj,fsum1,fsum2," +
							"fsum3,fsum4,fsum5,fsum6,fistotal,ftt,fttlevel,kod_org,zndog,fgas,kodOKPO,dog_dat "+
							" from  t_f_24_1 order by "+x_ind);
					if (IsTable("tmp_obsch_ext"))
					{
						ExecuteSQL("Drop Table tmp_obsch_ext");
					}	
					list.tbl.requery();
	    			grid.refresh();
				}
				else
				{
					alert("STOP");
				}
			}
		break;
	}
	if (!par.escape)
	{
		//oGrid.IsInPlaceEdition=true;
		//t.Requery();
	}
}
include ("sys/DpList.js");	