include("objects/DpCl.js");
include("objects/DpGrid.js");
include("objects/DpClEx.js");
include("servis/date.js");
include("servis/format.js");

var bdat, edat, szTag, fwid_wp, fwid_cl, tblTabel;
var cntsr, cntdat, dte, tdte, dteo, nVidSred, ArNDat, ArNSum, table;
var ArNDatB, ArNormD, ArVsegoD, ArGoD, ArNormCh, ArVsegoCh, ArGoCh;
var ArNDatOS, ArNSumOS, tableOS, cntsrOS, nVidSredOS, dteOS, tdteOS, cntdatOS;
var ArNDatO, ArNormDO, ArVsegoDO, ArGoDO, ArNormChO, ArVsegoChO, ArGoChO;

function onLoad()
{
	if(extPar==null)
		return false;
	if(extPar.dat1==null)
		bdat = new Date(firstDayMonth(today));
	else
		bdat = new Date(firstDayMonth(extPar.dat1));
	edat = new Date(lastDayMonth(bdat));
	Caption(UR("Повна інформація по співробітнику за |Полная информация по сотруднику за ") + StrDat(bdat, "MY"));
	if(extPar.fwid_wp==null)
		fwid_wp = 0;
	else
		fwid_wp = extPar.fwid_wp;
	fwid_cl = getFwid_cl(fwid_wp);
	HDAT.value = bdat.getVarDate();	
	szTag = getDateTag(bdat);
	dteo = getPar("GLOBDAT2");
	
	//инициализируем все вкладки
	setInfoCntrols();
	loadFormInfo();
	loadGridSVZP();
	loadGridSVPF();
	loadGridPRK();
	loadGridTabel();
	loadGridHistory();
	loadFormBS();
	include("l_zotrvr.js");
	loadFormBOV(true);
	loadFormOOV(true);
	loadFormOS();

	this.persValid = persValid;

	oPers = new DpCl();   	
	oPers.setClcl(getPar("CODPERS"));
	oPers.linkSmartCtrl(HPERSON);
	oPers.setFWID(fwid_cl);
	setValid(HPERSON, this, "persValid");
	setValid(HDAT,HDAT_valid);
}

function HDAT_valid()
{
	//обновляем гриды только в случае изменения даты
	if(differ(bdat,new Date(HDAT.value))!=0)
	{
		szTag = getDateTag(HDAT.value);
		bdat = new Date(HDAT.value);
		edat = new Date(lastDayMonth(HDAT.value));
		loadGridSVZP();
		loadGridSVPF();
		//loadGridPRK();
		loadGridTabel();
		loadFormBS();
		loadFormBOV(false);
		loadFormOOV(false);
		loadFormOS();
		Caption(UR("Повна інформація по співробітнику за |Полная информация по сотруднику за ") + StrDat(bdat, "MY"));
	}
}

function persValid()
{
	//обновляем гриды только при выборе другого сотрудника
	if(fwid_cl!=oPers.getFWID())
	{
		fwid_cl = oPers.getFWID();
		fwid_wp = getFwid_wp(fwid_cl);
		loadFormInfo();
		loadGridSVZP();
		loadGridSVPF();
		loadGridPRK();
		loadGridTabel();
		loadGridHistory();
		setInfoCntrols();
		loadFormBS();
		loadFormBOV(false);
		loadFormOOV(false);
		loadFormOS();
	}
}

//личная информация
function loadFormInfo()
{
	var snap = getSnap("SELECT MAX(Fcl) FROM ^clrelclcl WHERE Fwid_cl="+sqlTo(fwid_cl))
	if(snap!=null)
	{
		FCOD.setMask("###########");
	   	FPHONE.mask = "&&&&&&&&&&";
	   	FWRKPHONE.mask = "&&&&&&&&&&";
	   	FDOCSER.mask = "&&&&&&&&&&";
	   	FDOCNOM.mask = "&&&&&&&&&&";
	   	FINDNUM.mask = "&&&&&&&&&&";
	   	FBLD.mask = "######";
	   	FLETTER.mask = "&&";
	   	FCORP.mask = "#####";
	   	FAPART.mask = "#####";
	   	FOWNER.mask = "#####";
	   	FZIP.mask = "&&&&&&";
		var oCl = new DpClEx("CL3", snap[0]);
		oCl.loadByID(fwid_cl);
		FCOD.value = oCl.getVar("HCOD");
		FTXT.value = oCl.getVar("HTXT");
		FTXT_INITIALS.value = getSmallFIO(oCl.getVar("HTXT"));
		FINDNUM.value = oCl.getVar("HINDNUM");
		FWRKDAT.value = oCl.getVar("HWRKDAT");
		FVISLDAT.value = oCl.getVar("HVISLDAT");
		FADDR.value = oCl.getVar("HADDR");
		FWRKPHONE.value = oCl.getVar("HWRKPHONE");
		FPHONE.value = oCl.getVar("HPHONE");
		FORIGDAT.value = oCl.getVar("HORIGDAT");
		FORIGADDR.value = oCl.getVar("HORIGADDR");
		FDOCSER.value = oCl.getVar("HDOCSER");
		FDOCNOM.value = oCl.getVar("HDOCNOM");
		FDOCDAT.value = oCl.getVar("HDOCDAT");
		FDOCOWN.value = oCl.getVar("HDOCOWN");
		FREM.value = oCl.getVar("HREM");
		FSEX.value = (oCl.getVar("HSEX") == true)?1:0;
		FBLD.value = oCl.getVar("HBLD");
		FLETTER.value = oCl.getVar("HLETTER");
		FCORP.value = oCl.getVar("HCORP");
		FAPART.value = oCl.getVar("HAPART");
		FOWNER.value = oCl.getVar("HOWNER");
		FZIP.value = oCl.getVar("HZIP");
	}
}

//лицевые счета
function loadGridSVZP()
{
	var svzpTblName = "^svzp"+szTag;
	if (IsTableEx("ZRP_RES","zrp_svzp"+szTag))
	{
		svzpTbl = OpenTable("m", "SELECT * FROM " + svzpTblName 
					+" WHERE Ftabn_id="+sqlTo(fwid_cl)+" ORDER BY ffld_num");
		svzpTbl.tie("lic_fld", "ls", "lic_fid", "flsfid");
		var oGrid = new DpGrid("NOCREATE", gridSVZP);
		gridSVZP.DeletePages();
		gridSVZP.setTable(svzpTbl);
		gridSVZP.setVisible(true);
		listGridSvzp(oGrid); 
	}
	else
	{
		alert(ru("За заданный месяц зарплата не рассчитана!",
				"За даний місяць заробітна платня не розрахована"));
		gridSVZP.setVisible(false);
	}
}

function listGridSvzp(oGridSvzp)
{
	with(oGridSvzp)
	{
		onePageMode(false);

		defCond("=(^LS.Fid==80||^LS.Fid==102)", "ITOG_ALL");
		color(26, "ITOG_ALL");
		
		defCond("=(^LS.Fid==173)", "ITOG_GET");
		bold("ITOG_GET");
		color(25, "ITOG_GET");

		with(page())
		{
			cell("ls.ftxt", "Поле\nособистого рахунку|Поле\nлицевого счета", 13);
			cell("fsum", "Сума|Сумма", 6, "", DP_FORMAT_SUM);
			cell("Fpr", "Збiр|Сбор", 5);
			cell("fday", "днів|дней", 5);
			cell("fchas", "годин|часов", 5);
			cell("=(^Fis_day==2?'л':'')", "", 2);
			with (group("Сплачено|Выплачено"))
			{
				var str = "=(^Fvp==1? format('mm/yy', ^Fmn):"+
							"(^Fvp==2? format('mm/yy',HDAT.value): ''))";
				cell(str, "в", 5, "r");
				str = "=(^Fvp==1?format('mm/yy', HDAT.value):"+
							"(^Fvp==2? format('mm/yy', ^Fmn): ''))";
				cell(str, "за", 5, "r");
				str = "=((^Fvid_prk!=0) && (^Fid_prk!=0))?'+':''";
				cell(str, "", 2);
			}
			cell("fshpz", "ШВВ|ШПЗ", 4);
			cell("Fvid_prk", "Код\nПриказу|Код\nПриказа", 6);
		}
		build(); 
	}
}

//
function loadGridSVPF()
{
	var svpfTblName = "^svpf"+szTag;
	if (IsTableEx("ZRP_RES","zrp_svpf"+szTag))
	{
		svpfTbl = OpenTable("m", "SELECT * FROM " + svpfTblName 
					+" WHERE Ftabn_id="+sqlTo(fwid_cl)+"AND  NOT (Fvp=1 AND Fmn>=" + sqlTo(bdat)+") ORDER BY ffld_num");
		svpfTbl.tie("lic_fld", "ls", "lic_fid", "flsfid");
		var oGrid = new DpGrid("NOCREATE", gridSVPF);
		gridSVPF.DeletePages();
		gridSVPF.setTable(svpfTbl);
		gridSVPF.setVisible(true);
		//listGridSvzp(oGrid); 
		with(oGrid)
		{
			onePageMode(false);
			defCond("=(^Ffld_num==80||^Ffld_num==107)", "ITOG_ALL");
			color(26, "ITOG_ALL");
			defCond("=(^Ffld_num==112)", "ITOG_GET");
			bold("ITOG_GET");
			color(25, "ITOG_GET");

			with(page())
			{
				cell("ls.ftxt", "Поле\nособистого рахунку|Поле\nлицевого счета", 18);
				cell("fsum", "Сума|Сумма", GRID_SUM_WDT, "", DP_FORMAT_SUM);
				cell("Fpr", "Збiр|Сбор", 8);
				cell("fday", "днів|дней", 5);
				cell("fchas", "годин|часов", 5);
				cell("=(^Fis_day==2?'л':'')", "", 2);
				with (group("Сплачено|Выплачено"))
				{
					var str = "=(^Fvp==1? format('mm/yy', ^Fmn):"+
								"(^Fvp==2? format('mm/yy',HDAT.value): ''))";
					cell(str, "в", 5, "r");
					str = "=(^Fvp==1?format('mm/yy', HDAT.value):"+
								"(^Fvp==2? format('mm/yy', ^Fmn): ''))";
					cell(str, "за", 5, "r");
					str = "=((^Fvid_prk!=0) && (^Fid_prk!=0))?'+':''";
					cell(str, "", 2);
				}
				cell("fshpz", "ШВВ|ШПЗ", 15);
				cell("Fvid_prk", "Код\nПриказу|Код\nПриказа", 8);
			}
			build(); 
		}
	}
	else
	{
		alert(ru("За заданный месяц зарплата по фондам не рассчитана!",
				"За даний місяць заробітна платня по фондах не розрахована!"));
		gridSVPF.setVisible(false);
	}
}

//приказы
function loadGridPRK()
{
	prkTbl = OpenTable("m", "SELECT DISTINCT Fwid, Fwid_wp, Fbdat, Fedat, Fsum, Fproc, Fvid_prk FROM ^prk_all " +
				//" INNER JOIN ^clrelclcl AS crc ON crc.fwid_cl=listprk.ftabn_id" +
				" WHERE Fwid_wp=" + sqlTo(fwid_wp) +
				" ORDER BY fvid_prk, fbdat, fedat");
	prkTbl.tie("cl_prik", "prik", "fvid", "fvid_prk");
	gridPRK.DeletePages();
	gridPRK.setTable(prkTbl);
	gridPRK.setXMLFile("f_liccsPrk.xml");
	gridPRK.setFilling("Fvid_prk");
	gridPRK.build();
	
	this.prkGridMenuInit = prkGridMenuInit;
	this.prkGridMenuRun = prkGridMenuRun;
	gridPRK.loadMenuHandler(this, "prkGridMenuInit");
	gridPRK.selectMenuHandler(this, "prkGridMenuRun");	
}

function prkGridMenuInit(oGrid)
{
	oGrid.AddMenuItem("ADDPRK", "Додати інший|Добавить другой");
	oGrid.AddMenuItem("ADD", "Додати|Добавить");
	oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
	oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
	oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр");
	oGrid.AddMenuItem("DEL", "Вилучити|Удалить");
}

function prkGridMenuRun(sID, oGrid)
{
	var tbl = oGrid.getTable();
	switch(sID)
	{
		case "ADDPRK":
			var p = new Object();
			p.ret = new Object();
			p.ret.fvid = 0;
			p.ret.fedit = "";
			showWindow("l_clprik.js",SW_MODAL,p);
			if(p.escape || p.ret.fedit.length==0)
				break;
		case "ADD":
		case "EDIT":
		case "COPY":
		case "VIEW":
		case "DEL":
			include("prik/DpPrik.js");
			var GLOBAL_TABLE = "^PRK_ALL";
			var par = new Object();
			if(p && sID=="ADDPRK")
			{
				var fvid_prk = p.ret.fvid;
				var FWID_WP = fwid_wp;
				par.dat1 = bdat;
				par.dat2 = edat;
				par.mode = "ADD";
				par.id = 0;
			}
			else
			{
				var fvid_prk = tbl.getValue("FVID_PRK");
				var FWID_WP = tbl.getValue("FWID_WP");
				par.dat1 = new Date(tbl.getValue("FBDAT"));
				par.dat2 = new Date(tbl.getValue("FEDAT"));
				par.id = tbl.getValue("FWID");
				par.mode = sID;
			}
			
			var oSnap = getSnap("select FEDIT,FNAZV from ^CL_PRIK where FVID="+ sqlTo(fvid_prk));
			var fproc = oSnap[0];			
			var oPrik = new DpPrik(fproc, fvid_prk, list);
			if(sID=="DEL")
			{
				if("-"==msgBox("c-"
					, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
					, ru("Удаление записи", "Вилучення запису")))
				{
					oPrik.del(Number(tbl.getValue("FWID")));
					tbl.requery();
					oGrid.refresh();
				}
				break;
			}
			
			par.fvid = Number(fvid_prk); 
			par.tblName = oPrik.tblName;
			par.priklbl = fproc;
			par.GLOBAL_TABLE = GLOBAL_TABLE;
			par.sTableName = oPrik.tblName;			
			par.fwid_wp = FWID_WP;			
			par.fnazv = oSnap[1];
			par.m_pTable = OpenTable(s="select * from "+ GLOBAL_TABLE +" as pall "
							+(!oPrik.tblName? "" : 
								" left join "+ oPrik.tblName +" as p on p.FWID=pall.FWID")
							+" inner join ^WORK_PERS as wp on wp.FWID=pall.FWID_WP "
							+" inner join ^CLRELCLCL as c on wp.FWID_CL=c.FWID_CL"
							+" where pall.FWID="+ par.id);
			par.ffld_num = par.m_pTable.getValue("FFLD_NUM");
			if(sID == "VIEW")
				par.isView = true;
			//oPrik.edit(sID, fwid_wp, par, par.m_pTable);
			CallEditTask(oPrik.editXML, par, par.m_pTable);
			if(!par.escape)
			{
				tbl.requery();
				oGrid.refresh();
			}
			break;
	}
}

//табеля
function loadGridTabel()
{
	if(null!=tblTabel)
	{
		tblTabel.Close();
	}
	var cldol = getPar("CODDOL");
	var ret = DropTable("TABEL");
	if (!ret) return false;
	var sttTableName = "stt1"+szTag;
	var tblTableName = "tbl"+szTag;
	
	if(IsTableEx("ZRP_MDB","ZRP_"+sttTableName)&&IsTableEx("ZRP_MDB","ZRP_"+tblTableName))
	{
		
		var strSQL = "SELECT w.fwid, cl_dol.ftxts as ftxt, org.ftxt as fpodr, rel.fcod as fcod, cl.ftxt as ftxts, w.fvopl, d.foklad, st.fis_tabel, st.fbdat, st.fedat"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_d", IIF("tb.fday_nvk IS NULL", "ti.fnorma_d", "tb.fday_nvk")) + " AS fnorma_d"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_ch", IIF("tb.fchasnvk IS NULL", "ti.fnorma_ch", "tb.fchasnvk")) + " AS fnorma_ch"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_d", "tb2.fday_nvk") + " AS fvsego_d"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "ti.fnorma_ch", "tb2.fchasnvk") + " AS fvsego_ch"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb3.fday_nvk") + " AS FNOCH_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb3.fchasnvk") + " AS FNOCH_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb4.fday_nvk") + " AS FKLASS_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb4.fchasnvk") + " AS FKLASS_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb5.fday_nvk") + " AS FPRAZN_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb5.fchasnvk") + " AS FPRAZN_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb6.fday_nvk") + " AS FVRED_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb6.fchasnvk") + " AS FVRED_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb7.fday_nvk") + " AS FKOM_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb7.fchasnvk") + " AS FKOM_CH"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb8.fday_nvk") + " AS FVECH_DN"
					+ ", " + IIF("st.fis_tabel=" + sqlTo("*"), "0", "tb8.fchasnvk") + " AS FVECH_CH"
				+ " INTO TABEL FROM (((((((((^work_pers AS w INNER JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid)"
					+ " INNER JOIN ^cl AS cl ON w.fwid_cl=cl.fwid)"
					+ " INNER JOIN ^clrelclcl AS rel ON w.fwid_cl=rel.fwid_cl)"
					+ " INNER JOIN ^clrelclcl AS rel_dol ON d.fcod=rel_dol.fcod)"
					+ " INNER JOIN ^cl AS cl_dol ON cl_dol.fwid=rel_dol.fwid_cl)"
					+ " RIGHT JOIN ^" + sttTableName + " AS st ON w.fwid=st.fwid_wp)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb ON (w.fwid=tb.fwid_wp AND st.fbdat=tb.fbdat AND st.fedat=tb.fedat AND tb.fkod_nvk=1)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb2 ON (w.fwid=tb2.fwid_wp AND st.fbdat=tb2.fbdat AND st.fedat=tb2.fedat AND tb2.fkod_nvk=2)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb3 ON (w.fwid=tb3.fwid_wp AND st.fbdat=tb3.fbdat AND st.fedat=tb3.fedat AND tb3.fkod_nvk=3)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb4 ON (w.fwid=tb4.fwid_wp AND st.fbdat=tb4.fbdat AND st.fedat=tb4.fedat AND tb4.fkod_nvk=4)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb5 ON (w.fwid=tb5.fwid_wp AND st.fbdat=tb5.fbdat AND st.fedat=tb5.fedat AND tb5.fkod_nvk=5)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb6 ON (w.fwid=tb6.fwid_wp AND st.fbdat=tb6.fbdat AND st.fedat=tb6.fedat AND tb6.fkod_nvk=6)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb7 ON (w.fwid=tb7.fwid_wp AND st.fbdat=tb7.fbdat AND st.fedat=tb7.fedat AND tb7.fkod_nvk=7)"
					+ " LEFT JOIN ^" + tblTableName + " AS tb8 ON (w.fwid=tb8.fwid_wp AND st.fbdat=tb8.fbdat AND st.fedat=tb8.fedat AND tb8.fkod_nvk=8))"
					+ " LEFT JOIN ^tbl_ini AS ti ON w.fvopl=ti.fvopl)"
					+ " LEFT JOIN ^stru_org AS org ON d.fwid_org=org.fwid) "
				+ " WHERE w.fbdat<=" + sqlTo(edat) + " AND w.fedat>=" + sqlTo(bdat)
					//+ " AND (d.fwid_org = " + sqlTo(podrValue)
					//+ " OR (org.fleftkey BETWEEN " + sqlTo(leftkey)
					//	+ " AND " + sqlTo(rightkey) + ") AND org.fwid<>0 ) "					
					+ " AND w.fwid_cl="+sqlTo(fwid_cl)
					+ " AND rel_dol.fcl=" + sqlTo(cldol)
					+ " AND ti.fbdat=" + sqlTo(bdat);
				+ " GROUP BY w.fwid";
		ExecuteSQL(strSQL);
	
		tblTabel = OpenTable("s", "select * from TABEL order by Fcod, Fbdat, Fedat");
		gridTabel.DeletePages();
		//gridTabel.setXMLDir(rootDirectory());
		gridTabel.setXMLFile("grTabelInfo.xml");
		gridTabel.setTable(tblTabel);
		gridTabel.setVisible(true);
		gridTabel.build();
		
		this.tabGridMenuInit = tabGridMenuInit;
		this.tabGridMenuRun = tabGridMenuRun;
		gridTabel.loadMenuHandler(this, "tabGridMenuInit");
		gridTabel.selectMenuHandler(this, "tabGridMenuRun");	
	}
	else
	{
		alert(ru("Табеля на данный месяц не существует!"
				,"Табеля на даний місяць не існує!"));
		gridTabel.setVisible(false);
	}
}

function tabGridMenuInit(oGrid)
{
	//oGrid.AddMenuItem("ADD", "Додати|Добавить");
	if(!oGrid.getTable().isEmpty())
	{
		//oGrid.AddMenuItem("COPY", "Скопіювати|Копировать");
		oGrid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		oGrid.AddMenuItem("VIEW", "Перегляд|Просмотр");
		//oGrid.AddMenuItem("DEL", "Вилучити|Удалить");
	}
}

function tabGridMenuRun(sID, oGrid)
{
	var tbl = oGrid.getTable();
	switch(sID)
	{
		case "ADD":
		case "EDIT":
		case "COPY":
		case "VIEW":		
			var par = new Object();
			par.tbl = tbl;
			par.bdat = bdat;
			par.escape = true;
			showWindow("e_tabtime.xml", SW_MODAL, par);
			if(false == par.escape)
			{
				refreshGrid(toObject);
			}
			break;		
	}
}

//история
function loadGridHistory()
{
	var codPers = getPar("CODPERS");
	var tblInfo = OpenTable("m","SELECT "+GetPatternIntersection("work_pers", "work_pers", "wp") //+ ",wp_crc.fcod,wp_cl.ftxt "
						+ " FROM (^work_pers AS wp "
							+ " LEFT JOIN ^clrelclcl AS wp_crc ON wp_crc.fwid_cl=wp.fwid_cl) "
							//+ " LEFT JOIN ^cl AS wp_cl ON wp_cl.fwid=wp.fwid_cl "
						+ " WHERE " + (fwid_cl == 0 ? "wp.fwid_cl > 0" : "wp.fwid_cl=" + sqlTo(fwid_cl))
							+ " AND wp_crc.fcl=" + sqlTo(codPers)
						+ " ORDER BY wp_crc.fcod, wp.fid, wp.fbdat, wp.fedat");
	tblInfo.tie("clrelclcl", "kod_crc", "fwid_cl", "fwid_kat");
	tblInfo.tie("stru_dol", "dol", "fwid", "fwid_dol");
	tblInfo.tie("cl", "dol_cl", "fwid", "dol.fwid_cl");
	tblInfo.tie("stru_org", "org", "fwid", "dol.fwid_ogr");
	
	gridHistory.DeletePages();
	gridHistory.setXMLFile("grPersInfo.xml");
	gridHistory.setTable(tblInfo);
	gridHistory.build();
}

//больничные, статистика по суммам
function loadFormBS()
{
	ArNSum = new Array(16);
	ArNSum[0]=FSUM1;	ArNSum[1]=FSUM2;	ArNSum[2]=FSUM3;	ArNSum[3]=FSUM4;
	ArNSum[4]=FSUM5;	ArNSum[5]=FSUM6;	ArNSum[6]=FSUM7;	ArNSum[7]=FSUM8;
	ArNSum[8]=FSUM9;	ArNSum[9]=FSUM10;	ArNSum[10]=FSUM11;	ArNSum[11]=FSUM12;
	ArNSum[12]=FSUM13;	ArNSum[13]=FSUM14;	ArNSum[14]=FSUM15;	ArNSum[15]=FSUM16;
	for(var i=0; i<16; i++)
		ArNSum[i].mask = "-######.##";
	
	ArNDat = new Array(16);
	ArNDat[0]=FDAT1;	ArNDat[1]=FDAT2;	ArNDat[2]=FDAT3;	ArNDat[3]=FDAT4;
	ArNDat[4]=FDAT5;	ArNDat[5]=FDAT6;	ArNDat[6]=FDAT7;	ArNDat[7]=FDAT8;
	ArNDat[8]=FDAT9;	ArNDat[9]=FDAT10;	ArNDat[10]=FDAT11;	ArNDat[11]=FDAT12;
	ArNDat[12]=FDAT13;	ArNDat[13]=FDAT14;	ArNDat[14]=FDAT15;	ArNDat[15]=FDAT16;
	
	setValid(FSRED,FSRED_Valid);
	
	NewTabIni(true);
	takeSred();
	FDAT1.value = bdat.getVarDate();
	FDAT1_Valid();
}

function FDAT1_Valid()
{
	/*if ((FDAT1.value<=d00) && (FDAT1.value>=d00))
	{
		WAIT("Пустая дата недопустима!");
		return false;
	}*/
	var dat = new Date(FDAT1.value);
	if (!(differ(dat,cntdat)>=0 && differ(dat,cntdat)<=0))
	{
		dte = dat;
		tdte = dte.getVarDate();
		cntdat = dte;
		dcur = dte;
		tdcur = tdte;
		if (!table || table.IsEmpty())
			PutDatEm(dcur,tdcur)
		else
			PutDat(dcur,tdcur);
	}
	return true;
}

function FSRED_Valid()
{
   if (FSRED.value=="0")
   {
      WAIT("Пустой код среднего недопустим!");
      return false;
   }
   takeSred();
   return true;
}

function takeSred()
{
	var dcur, tdcur;
	nVidSred = Number(FSRED.value);
	if (FSRED.value!=cntsr)
	{
		cntsr = FSRED.value;
		table = OpenTable("s","SELECT * FROM ^SRED_INI"
			+" WHERE (FTABN_ID="+ sqlTo(fwid_cl)+")"
			+" ORDER BY FLD_DATE DESC");
		if (table.IsEmpty())
		{
			dcur = dte;
			tdcur = tdte;
			PutDatEm(dcur,tdcur);
		}
		else 
		{
			table.MoveFirst();
			tdte=table.getValue("FLD_DATE");
			dte = new Date(tdte);
			cntdat = dte;
			dcur = dte;
			tdcur = new Date(tdte);
			PutDat(dcur,tdcur);
		}
		//FDAT1.setEnabled(true);
		//for (var i=0;i<16;i++)
		//	ArNSum[i].setEnabled(true);
	}
	return true;
}

function PutDatEm(dcur,tdcur)
{
   for (var i=0; i<16; i++)
   {        
      ArNSum[i].value = 0;
      ArNDat[i].value = dcur.getVarDate();
      dcur = new Date(dcur.getYear()+1900,dcur.getMonth()-1,1);      
      tdcur = dcur.getVarDate();
   }
}

function PutDat(dcur,tdcur)
{
	PutDatEm(dcur,tdcur);
	var OK = true;
	var i=0;
	table.MoveFirst();
	while (OK)
	{
		if((new Date(ArNDat[i].value)<=new Date(table.getValue("FLD_DATE")))&&(new Date(ArNDat[i].value)>=new Date(table.getValue("FLD_DATE"))))
		{
			ArNSum[i].value=table.getValue("FLD_STOR"+nVidSred);
			i++;
			table.MoveNext();
			if ((table.IsEOF())||(i>15))
				OK = false;
		}
		else
		{
			if (new Date(ArNDat[i].value)>new Date(table.getValue("FLD_DATE")))
			{
				i++;
				if (i>15)
				OK = false;
			}
			else
			{
				table.MoveNext();
				if (table.IsEOF())
					OK = false;
			}
		}
	}//while (OK)
}

function NewTabIni(istab)
{
	dte = new Date(dteo);
	dte = new Date(new Date(dte.getYear()+1900,dte.getMonth(),1));//на первое число месяца
	tdte = dte.getVarDate();
	cntdat = dte;

	cntsr = "0";
	if (istab)
	{
		//for (var i=0;i<16;i++)
		//	ArNSum[i].setEnabled(false);
		for (var i=0;i<16;i++)
			ArNSum[i].value = 0;
		for (var i=0;i<16;i++)
			ArNDat[i].value = d00;
		//FDAT1.setEnabled(false);
	}
}

//больничные, статистика по отработанному времени
function loadFormBOV(bInit)
{
	if(bInit)
	{
		ArNDatB = new Array(16);
		ArNDatB[0]=FDATOV1;		ArNDatB[1]=FDATOV2;		ArNDatB[2]=FDATOV3;		ArNDatB[3]=FDATOV4;     
		ArNDatB[4]=FDATOV5;		ArNDatB[5]=FDATOV6;		ArNDatB[6]=FDATOV7;		ArNDatB[7]=FDATOV8;     
		ArNDatB[8]=FDATOV9;		ArNDatB[9]=FDATOV10;	ArNDatB[10]=FDATOV11;	ArNDatB[11]=FDATOV12;      
		ArNDatB[12]=FDATOV13;	ArNDatB[13]=FDATOV14;	ArNDatB[14]=FDATOV15;	ArNDatB[15]=FDATOV16;   

		ArNormD = new Array(16);
		ArNormD[0]=FNORMD1;		ArNormD[1]=FNORMD2;		ArNormD[2]=FNORMD3;		ArNormD[3]=FNORMD4;  
		ArNormD[4]=FNORMD5;		ArNormD[5]=FNORMD6;		ArNormD[6]=FNORMD7;		ArNormD[7]=FNORMD8;  
		ArNormD[8]=FNORMD9;		ArNormD[9]=FNORMD10;	ArNormD[10]=FNORMD11;	ArNormD[11]=FNORMD12;	
		ArNormD[12]=FNORMD13;	ArNormD[13]=FNORMD14;	ArNormD[14]=FNORMD15;	ArNormD[15]=FNORMD16;	
	
		ArVsegoD = new Array(16);
		ArVsegoD[0]=FVSEGOD1;	ArVsegoD[1]=FVSEGOD2;	ArVsegoD[2]=FVSEGOD3;	ArVsegoD[3]=FVSEGOD4;	
		ArVsegoD[4]=FVSEGOD5;	ArVsegoD[5]=FVSEGOD6;	ArVsegoD[6]=FVSEGOD7;	ArVsegoD[7]=FVSEGOD8;	
		ArVsegoD[8]=FVSEGOD9;	ArVsegoD[9]=FVSEGOD10;  ArVsegoD[10]=FVSEGOD11; ArVsegoD[11]=FVSEGOD12; 
		ArVsegoD[12]=FVSEGOD13; ArVsegoD[13]=FVSEGOD14; ArVsegoD[14]=FVSEGOD15; ArVsegoD[15]=FVSEGOD16; 

		ArGoD = new Array(16);
		ArGoD[0]=FGOD1;		ArGoD[1]=FGOD2;		ArGoD[2]=FGOD3;		ArGoD[3]=FGOD4;	
		ArGoD[4]=FGOD5;		ArGoD[5]=FGOD6;		ArGoD[6]=FGOD7; 	ArGoD[7]=FGOD8;	
		ArGoD[8]=FGOD9;		ArGoD[9]=FGOD10;  	ArGoD[10]=FGOD11; 	ArGoD[11]=FGOD12; 
		ArGoD[12]=FGOD13; 	ArGoD[13]=FGOD14; 	ArGoD[14]=FGOD15; 	ArGoD[15]=FGOD16; 

		ArNormCh = new Array(16);
		ArNormCh[0]=FNORMCH1;	ArNormCh[1]=FNORMCH2;	ArNormCh[2]=FNORMCH3;	ArNormCh[3]=FNORMCH4;	
		ArNormCh[4]=FNORMCH5;	ArNormCh[5]=FNORMCH6;	ArNormCh[6]=FNORMCH7;	ArNormCh[7]=FNORMCH8;	
		ArNormCh[8]=FNORMCH9;	ArNormCh[9]=FNORMCH10;  ArNormCh[10]=FNORMCH11; ArNormCh[11]=FNORMCH12; 
		ArNormCh[12]=FNORMCH13; ArNormCh[13]=FNORMCH14; ArNormCh[14]=FNORMCH15; ArNormCh[15]=FNORMCH16; 

		ArVsegoCh = new Array(16);
		ArVsegoCh[0]=FVSEGOCH1; 	ArVsegoCh[1]=FVSEGOCH2;		ArVsegoCh[2]=FVSEGOCH3;		ArVsegoCh[3]=FVSEGOCH4; 
		ArVsegoCh[4]=FVSEGOCH5;		ArVsegoCh[5]=FVSEGOCH6; 	ArVsegoCh[6]=FVSEGOCH7;		ArVsegoCh[7]=FVSEGOCH8; 
		ArVsegoCh[8]=FVSEGOCH9;		ArVsegoCh[9]=FVSEGOCH10;	ArVsegoCh[10]=FVSEGOCH11;	ArVsegoCh[11]=FVSEGOCH12;  
		ArVsegoCh[12]=FVSEGOCH13;	ArVsegoCh[13]=FVSEGOCH14;	ArVsegoCh[14]=FVSEGOCH15;	ArVsegoCh[15]=FVSEGOCH16;  

		ArGoCh = new Array(16);
		ArGoCh[0]=FGOCH1;	ArGoCh[1]=FGOCH2;	ArGoCh[2]=FGOCH3;	ArGoCh[3]=FGOCH4;
		ArGoCh[4]=FGOCH5;	ArGoCh[5]=FGOCH6;	ArGoCh[6]=FGOCH7;	ArGoCh[7]=FGOCH8; 
		ArGoCh[8]=FGOCH9;	ArGoCh[9]=FGOCH10;	ArGoCh[10]=FGOCH11;	ArGoCh[11]=FGOCH12;  
		ArGoCh[12]=FGOCH13;	ArGoCh[13]=FGOCH14;	ArGoCh[14]=FGOCH15;	ArGoCh[15]=FGOCH16;  
		for (var i=0;i<16;i++)
		{
			ArNormD[i].mask = "##.#";
			ArVsegoD[i].mask = "##.#";
			ArGoD[i].mask = "##.#";
			ArNormCh[i].mask = "###.##";
			ArVsegoCh[i].mask = "###.##";
			ArGoCh[i].mask = "###.##";
		}
	}
	l_zotrvr(true, fwid_cl, bdat, dteo, ArNDatB, ArNormD, ArVsegoD, ArGoD, ArNormCh, ArVsegoCh, ArGoCh);
}

//отпускные, статистика по суммам
function loadFormOS()
{
	ArNSumOS = new Array(16);
	ArNSumOS[0]=FSUMOS1;	ArNSumOS[1]=FSUMOS2;	ArNSumOS[2]=FSUMOS3;	ArNSumOS[3]=FSUMOS4;
	ArNSumOS[4]=FSUMOS5;	ArNSumOS[5]=FSUMOS6;	ArNSumOS[6]=FSUMOS7;	ArNSumOS[7]=FSUMOS8;
	ArNSumOS[8]=FSUMOS9;	ArNSumOS[9]=FSUMOS10;	ArNSumOS[10]=FSUMOS11;	ArNSumOS[11]=FSUMOS12;
	ArNSumOS[12]=FSUMOS13;	ArNSumOS[13]=FSUMOS14;	ArNSumOS[14]=FSUMOS15;	ArNSumOS[15]=FSUMOS16;
	for (var i=0;i<16;i++)
		ArNSumOS[i].mask = "-######.##";
	ArNDatOS = new Array(16);
	ArNDatOS[0]=FDATOS1;	ArNDatOS[1]=FDATOS2;	ArNDatOS[2]=FDATOS3;	ArNDatOS[3]=FDATOS4;
	ArNDatOS[4]=FDATOS5;	ArNDatOS[5]=FDATOS6;	ArNDatOS[6]=FDATOS7;	ArNDatOS[7]=FDATOS8;
	ArNDatOS[8]=FDATOS9;	ArNDatOS[9]=FDATOS10;	ArNDatOS[10]=FDATOS11;	ArNDatOS[11]=FDATOS12;
	ArNDatOS[12]=FDATOS13;	ArNDatOS[13]=FDATOS14;	ArNDatOS[14]=FDATOS15;	ArNDatOS[15]=FDATOS16;
	
	setValid(FSREDOS,FSREDOS_Valid);
	NewTabIniOS(true);
	takeSredOS();
	FDATOS1.value = bdat.getVarDate();
	FDATOS1_Valid();
}

function FSREDOS_Valid()
{
	if (FSREDOS.value=="0")
	{
		WAIT("Пустой код среднего недопустим!");
		return false;
	}
	takeSredOS();
	return true;
}

function takeSredOS()
{
	var dcur, tdcur;
	nVidSredOS = Number(FSREDOS.value);
	if (FSREDOS.value!=cntsrOS)
	{
		cntsrOS = FSREDOS.value;
		tableOS = OpenTable("s","SELECT * FROM ^SRED_INI"
				+" WHERE (FTABN_ID="+ sqlTo(fwid_cl)+")"
				+" ORDER BY FLD_DATE DESC");

		if (tableOS.IsEmpty())
		{
			dcur = dteOS;
			tdcur = tdteOS;
			PutDatEmOS(dcur,tdcur);
		}
		else
		{
			tableOS.MoveFirst();
			tdteOS=tableOS.getValue("FLD_DATE");
			dteOS = new Date(tdteOS);
			cntdatOS = dteOS;
			dcur = dteOS;
			tdcur = new Date(tdteOS);
			PutDatOS(dcur,tdcur);
		}
	}
	return true;
}

function PutDatEmOS(dcur,tdcur)
{
	for (var i=0; i<16; i++)
	{		  
		ArNSumOS[i].value = 0;
		ArNDatOS[i].value = dcur.getVarDate();
		dcur = new Date(dcur.getYear()+1900,dcur.getMonth()-1,1);		
		tdcur = dcur.getVarDate();
	}
}

function PutDatOS(dcur,tdcur)
{
	PutDatEmOS(dcur,tdcur);
	var OK = true;
	var i=0;
	tableOS.MoveFirst();
	while (OK)
	{
		if ((new Date(ArNDatOS[i].value)<=new Date(tableOS.getValue("FLD_DATE")))&&(new Date(ArNDatOS[i].value)>=new Date(tableOS.getValue("FLD_DATE"))))
		{
			ArNSumOS[i].value=tableOS.getValue("FLD_STOR"+ nVidSredOS);
			i++;
			tableOS.MoveNext();
			if ((tableOS.IsEOF())||(i>15))
				OK = false;
		}
		else
		{
			if (new Date(ArNDatOS[i].value)>new Date(tableOS.getValue("FLD_DATE")))
			{
				i++;
				if (i>15)
					OK = false;
			}
			else
			{
				tableOS.MoveNext();
				if (tableOS.IsEOF())
					OK = false;
			}
		}
	}  //while (OK)
}

function NewTabIniOS(istab)
{
	dteOS = new Date(dteo);
	dteOS = new Date(dteOS.getYear()+1900,dteOS.getMonth(),1);//на первое число месяца
	tdteOS = dteOS.getVarDate();
	cntdatOS = dteOS;
	cntsrOS = "0";
	if (istab)
	{
		for (var i=0;i<16;i++)
		{
			ArNSumOS[i].value = 0;
			ArNDatOS[i].value = d00;
		}
	}
}

function FDATOS1_Valid()
{
	/*if ((ArNDatOS1.value<=d00) && (ArNDatOS1.value>=d00))
	{
		WAIT("Пустая дата недопустима!");
		return false;
	}*/
	var dat = new Date(FDATOS1.value);
	if (!(differ(dat,cntdatOS)>=0 && differ(dat,cntdatOS)<=0))
	{
		dteOS = dat;
		tdteOS = dteOS.getVarDate();
		cntdatOS = dteOS;
		dcur = dteOS;
		tdcur = tdteOS;
		if (!tableOS || tableOS.IsEmpty())
			PutDatEmOS(dcur,tdcur);
		else
			PutDatOS(dcur,tdcur);
	}
	return true;
}

//отпускные, статистика по отработанному времени
function loadFormOOV(bInit)
{
	if(bInit)
	{
		ArNDatO = new Array(16);
		ArNDatO[0]=FDATV1;		ArNDatO[1]=FDATV2;		ArNDatO[2]=FDATV3;		ArNDatO[3]=FDATV4;  
		ArNDatO[4]=FDATV5;		ArNDatO[5]=FDATV6;		ArNDatO[6]=FDATV7;		ArNDatO[7]=FDATV8;  
		ArNDatO[8]=FDATV9;		ArNDatO[9]=FDATV10;		ArNDatO[10]=FDATV11;	ArNDatO[11]=FDATV12;
		ArNDatO[12]=FDATV13;	ArNDatO[13]=FDATV14;	ArNDatO[14]=FDATV15;	ArNDatO[15]=FDATV16;

		ArNormDO = new Array(16);
		ArNormDO[0]=FNORMDO1;		ArNormDO[1]=FNORMDO2;		ArNormDO[2]=FNORMDO3;		ArNormDO[3]=FNORMDO4;  
		ArNormDO[4]=FNORMDO5;		ArNormDO[5]=FNORMDO6;		ArNormDO[6]=FNORMDO7;		ArNormDO[7]=FNORMDO8;  
		ArNormDO[8]=FNORMDO9;		ArNormDO[9]=FNORMDO10;		ArNormDO[10]=FNORMDO11;		ArNormDO[11]=FNORMDO12;	
		ArNormDO[12]=FNORMDO13;		ArNormDO[13]=FNORMDO14;		ArNormDO[14]=FNORMDO15;		ArNormDO[15]=FNORMDO16;	
	
		ArVsegoDO = new Array(16);
		ArVsegoDO[0]=FVSEGODO1;		ArVsegoDO[1]=FVSEGODO2;		ArVsegoDO[2]=FVSEGODO3;		ArVsegoDO[3]=FVSEGODO4;	
		ArVsegoDO[4]=FVSEGODO5;		ArVsegoDO[5]=FVSEGODO6;		ArVsegoDO[6]=FVSEGODO7;		ArVsegoDO[7]=FVSEGODO8;	
		ArVsegoDO[8]=FVSEGODO9;		ArVsegoDO[9]=FVSEGODO10;	ArVsegoDO[10]=FVSEGODO11;	ArVsegoDO[11]=FVSEGODO12; 
		ArVsegoDO[12]=FVSEGODO13;	ArVsegoDO[13]=FVSEGODO14;	ArVsegoDO[14]=FVSEGODO15;	ArVsegoDO[15]=FVSEGODO16; 

		ArGoDO = new Array(16);
		ArGoDO[0]=FGODO1;	ArGoDO[1]=FGODO2;	ArGoDO[2]=FGODO3;	ArGoDO[3]=FGODO4;	
		ArGoDO[4]=FGODO5;	ArGoDO[5]=FGODO6;	ArGoDO[6]=FGODO7; 	ArGoDO[7]=FGODO8;	
		ArGoDO[8]=FGODO9;	ArGoDO[9]=FGODO10;  ArGoDO[10]=FGODO11;	ArGoDO[11]=FGODO12; 
		ArGoDO[12]=FGODO13; ArGoDO[13]=FGODO14; ArGoDO[14]=FGODO15;	ArGoDO[15]=FGODO16; 

		ArNormChO = new Array(16);
		ArNormChO[0]=FNORMCHO1;		ArNormChO[1]=FNORMCHO2;		ArNormChO[2]=FNORMCHO3;		ArNormChO[3]=FNORMCHO4;	
		ArNormChO[4]=FNORMCHO5;		ArNormChO[5]=FNORMCHO6;		ArNormChO[6]=FNORMCHO7;		ArNormChO[7]=FNORMCHO8;	
		ArNormChO[8]=FNORMCHO9;		ArNormChO[9]=FNORMCHO10;	ArNormChO[10]=FNORMCHO11;	ArNormChO[11]=FNORMCHO12; 
		ArNormChO[12]=FNORMCHO13;	ArNormChO[13]=FNORMCHO14;	ArNormChO[14]=FNORMCHO15;	ArNormChO[15]=FNORMCHO16; 

		ArVsegoChO = new Array(16);
		ArVsegoChO[0]=FVSEGOCHO1; 	ArVsegoChO[1]=FVSEGOCHO2;	ArVsegoChO[2]=FVSEGOCHO3;	ArVsegoChO[3]=FVSEGOCHO4; 
		ArVsegoChO[4]=FVSEGOCHO5;	ArVsegoChO[5]=FVSEGOCHO6; 	ArVsegoChO[6]=FVSEGOCHO7;	ArVsegoChO[7]=FVSEGOCHO8; 
		ArVsegoChO[8]=FVSEGOCHO9;	ArVsegoChO[9]=FVSEGOCHO10;	ArVsegoChO[10]=FVSEGOCHO11;	ArVsegoChO[11]=FVSEGOCHO12;  
		ArVsegoChO[12]=FVSEGOCHO13;	ArVsegoChO[13]=FVSEGOCHO14;	ArVsegoChO[14]=FVSEGOCHO15;	ArVsegoChO[15]=FVSEGOCHO16;  

		ArGoChO = new Array(16);
		ArGoChO[0]=FGOCHO1;		ArGoChO[1]=FGOCHO2;		ArGoChO[2]=FGOCHO3;		ArGoChO[3]=FGOCHO4;
		ArGoChO[4]=FGOCHO5;		ArGoChO[5]=FGOCHO6;		ArGoChO[6]=FGOCHO7;		ArGoChO[7]=FGOCHO8; 
		ArGoChO[8]=FGOCHO9;		ArGoChO[9]=FGOCHO10;	ArGoChO[10]=FGOCHO11;	ArGoChO[11]=FGOCHO12;  
		ArGoChO[12]=FGOCHO13;	ArGoChO[13]=FGOCHO14;	ArGoChO[14]=FGOCHO15;	ArGoChO[15]=FGOCHO16;  
		for (var i=0;i<16;i++)
		{
			ArNormDO[i].mask = "##.#";
			ArVsegoDO[i].mask = "##.#";
			ArGoDO[i].mask = "##.#";
			ArNormChO[i].mask = "###.##";
			ArVsegoChO[i].mask = "###.##";
			ArGoChO[i].mask = "###.##";
		}
	}
	l_zotrvr(false, fwid_cl, bdat, dteo, ArNDatO, ArNormDO, ArVsegoDO, ArGoDO, ArNormChO, ArVsegoChO, ArGoChO);
}

function getFwid_cl(Fwid_wp)
{
	var snap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+sqlTo(Fwid_wp));
	if(snap!=null)
		return snap[0];
	else
		return 0;
}

function getFwid_wp(Fwid_cl)
{
	var snap = getSnap("SELECT Fwid FROM ^work_pers WHERE Fwid_cl="+sqlTo(Fwid_cl)+" AND Fedat="+sqlTo(d00));
	if(snap!=null)
		return snap[0];
	else
		return 0;
}

function setInfoCntrols()
{
	var oSnap = getSnap("SELECT sd.Foklad, cv.Fvopl, cv.Fnzv_vopl FROM ^work_pers AS wp "
				+ "INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
				+ "INNER JOIN ^cl_vopl AS cv ON wp.Fvopl=cv.Fvopl"
			+" WHERE wp.Fwid="+sqlTo(fwid_wp)+" AND cv.Fgroup="+sqlTrue);
	if(oSnap!=null)
	{
		HOKLAD.text = " Оклад: " + oSnap[0];
		HVOPL.text = ru("Вид оплаты: ","Вид оплати: ") + oSnap[1] + "(" + oSnap[2] + ")";
		//HFWID_WP.text = "Fwid_wp: "+fwid_wp;
	}
}

include("sys/DpBaseDlg.js");