var ICO_XL = 10;
var ICO_WD = 11;
var ICO_JR = 12;
var currPath = null;
var iconsDir = rootDirectoryEx() + "/icons/";

function onLoad()
{
	Caption(UR("Файловий менеджер|Файловый менеджер"));
	this.rootDir = "dborg://";
	//this.rootDir = getOrgPath(); //"dborg://"; //getOrgPath(); 
	//FORM.setImage(rootDirectoryEx() + "icons/bug_yellow.gif");
	
	//this.Tree_mnuHandler = Tree_mnuHandler;
	//this.Tree_mnuInit = Tree_mnuInit;
	this.onTreeSelected = onTreeSelected;
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	//this.onExpand = Tree_expand;
	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	//Tree.loadMenuHandler(this, "Tree_mnuInit");	
	//Tree.setExpandHandler(this,"onExpand");
	this.filesTbl = createObjectTable();
	grid.setTable(this.filesTbl);
	grid.build();
	
	this.preFillTree = preFillTree;
	var file = new DpFile(this.rootDir);
	Tree.addItem("0",String(file.getPath()), file.getName());
	this.preFillTree(file);
	
}

function preFillTree(file)
{
	var parId = String(file.getPath());	
	var arrFiles = file.listFiles();
	for (var i = 0; i < arrFiles.length; i++)
	{
		if(!arrFiles[i].isDirectory())
			continue;
		var id = arrFiles[i].getPath();
		var name = arrFiles[i].getName();
		Tree.addItem(parId,id, name);
		this.preFillTree(arrFiles[i]);
	}
}

function onTreeSelected(path)
{
	if(String(path) == currPath)
		return;
	currPath = String(path);
	refreshFilesTable();
}

function refreshFilesTable()
{
	var tbl = createObjectTable();
	tbl.setIdFld("FPATH");
	var file = new DpFile(currPath);
	var arrFiles = file.listFiles();
	for (var i = 0; i < arrFiles.length; i++)
	{
		tbl.AddNew();
		var fileIsDir = toScrObj(arrFiles[i].isDirectory());		
		var imgFile  = fileIsDir?(iconsDir + "Folder.gif"):fe_getDocTypeImageFile(arrFiles[i].getPath());		
		tbl.setValue("FPATH", arrFiles[i].getPath());
		tbl.setValue("FNAME", arrFiles[i].getName());
		tbl.setValue("FISDIR", fileIsDir);
		tbl.setValue("FDATE", new Date(arrFiles[i].lastModified()).getVarDate() );
		tbl.setValue("FSIZE", fe_getFileSize(arrFiles[i].length()));		
		tbl.setValue("FIMG", imgFile);
		tbl.setValue("FTYPE", fe_getDocTypeRem(arrFiles[i]));
		tbl.Update();
	}
	var arrFiles = file.listFiles();
	
	
	grid.setTable(tbl);
	grid.refresh();
}

function fe_getFileSize(nSize)
{
	if (!nSize)
		return "0 Б";
	if(nSize >= 1024*1024)
	{
		nSize = nSize/(1024*1024);
		return round(nSize, 1) + " МиБ";
	}
	if(nSize >= 1024)
	{
		nSize = nSize/1024;
		return round(nSize, 1) + " КиБ";
	}
	
	return nSize + " Б";
		
}

function fe_getDocType(sFile)
{
	sFile = String(sFile)
	var n = sFile.lastIndexOf(".");
	var ext = sFile.substring(n+1);
	return ext.toLowerCase();
}

function fe_getDocTypeImageFile(sFile)
{
	var ext = fe_getDocType(sFile);
	switch(ext)
	{
	case "xls":
		return iconsDir + "XL.gif";
	case "xml":
	case "xsd":
		return iconsDir + "xml.gif";
	case "jrxml":
		return iconsDir + "JR.gif";
	case "doc":
		return iconsDir + "WD.gif";
	case "pdf":
		return iconsDir + "PDF.gif";
	case "txt":
		return iconsDir + "txt.gif";
	case "zip":
		return iconsDir + "zip.gif";
	case "dbf":
	case "db":
		return iconsDir + "base.gif";
	case "odt":
		return iconsDir + "ooo-writer.gif";
	}
	return "";
}

function fe_getDocTypeRem(file)
{
	if(file.isDirectory())
		return "каталог";
	return "";
}
