include("servis/date.js");
include("doc/DpDoc.js");

var doc = "CRM.TR";
var nop = 0;

function gadgetLoad()
{
	if(Task.getMenuMode())
		nop = Number(Task.getMenuMode());
	var d1 = new Date(today);
	var d2 = new Date(today);
	d2.setHours(23);
	d2.setMinutes(59);
	var tbl = OpenTable("select * from ^CRM_TELRAZG"
						+" where (FDOC_DAT>="+ sqlTo(today)
							+" or (FCTRLDAT>="+ sqlTo(d1) +" and FCTRLDAT<="+ sqlDateTo(d2) +"))"
							+(nop? " and FNOP="+ nop : "")
						+" order by FDOC_DAT"
						);
	tbl.clTie("x_cl_post", "="+ getPar("CODPLAT")+",FORG");
	tbl.clTie("x_cl_pers", "="+ getPar("CODPERS")+",FMANAGER");
	grid.setTable(tbl);
	grid.build();
	
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	grid.loadMenuHandler(this, "gridMenuInit");
	grid.selectMenuHandler(this, "gridMenuRun");
}

function gadgetRefresh()
{
	var nGridPos = grid.getRowSelected();
	grid.getTable().requery();
	grid.getTable().setAbsolute(nGridPos);
	grid.refresh();	
}

function gadgetExpand()
{
	var par = new Object();
	par.isFull = true;
	showWindow("gadgets/CRM.TR/full.xml", SW_MODAL, par);
}

function gridMenuInit()
{
	grid.AddMenuItem("FULL", "Перейти до списку телефонних розмов|Перейти к списку телефонных разговоров");
	grid.AddMenuItem("", "");
	grid.AddMenuItem("ADD", "Додати|Добавить");
	if(!grid.getTable().isEmpty())
	{
		if(IsDblClick())
		{
			gridMenuRun("VIEW", grid);
			return false;
		}
		grid.AddMenuItem("EDIT", "Редагувати|Редактировать");
		grid.AddMenuItem("VIEW", "Перегляд|Просмотр");
	}	
}

function gridMenuRun(sID)
{
	var tbl = grid.getTable();
	var tName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="ADD" || sID=="EDIT")
	{
		if(sID=="ADD")
			rowID = null;
		var oDoc = new DpDoc(doc, nop);
		var bRet = oDoc.edit(sID, rowID);
		if(bRet)
		{
			tbl.requery();
			tbl.FindFirst("FWID="+ oDoc.getID());
			grid.refresh();
		}
	}
	else if(sID=="VIEW")
	{
		var oDoc = new DpDoc(doc, nop);
		oDoc.edit(sID, rowID);
	}
	if(sID=="FULL")
	{
		var par = new Object();
		par.doc = doc;
		par.nop = nop;		
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
}

function isEndTime(ctlDate)
{
	if(!ctlDate)
		return false;
	
	var difTime = getDifTime(ctlDate);
	if(difTime>0)
		return true;

	return false;
}

function getDifDate(ctlDate, curDate)
{
	if(!ctlDate)
		return 0;
		
	ctlDate = new Date(ctlDate);
	if(curDate)
		curDate = new Date(curDate);
	else
		curDate = new Date();
			
	ctlDate = new Date(ctlDate.getFullYear(), ctlDate.getMonth(), ctlDate.getDate());	
	curDate = new Date(curDate.getFullYear(), curDate.getMonth(), curDate.getDate());
	
	return differ(ctlDate, curDate);
}

//разница времени(Тконтр - Ттекущее) в минутах
function getDifTime(ctlDate, curDate)
{
	var difTime = 0;	
	if(!ctlDate)
		return difTime;
	if(!curDate)
		curDate = new Date();
		
	ctlDate = new Date(ctlDate);
	
	var h = ctlDate.getHours();
	var m = ctlDate.getMinutes();
	if(!h && !m)
		return difTime;
	
	if(getDifDate(ctlDate, curDate)>0)
		return difTime;
		
	difTime = (ctlDate.getTime() - curDate.getTime())/60000;

	return difTime;
}

include("gadgets/DpGadget.js");