include ("doc/DpDoc.js");

function hd()
{
	var strSQL = "select d.fdoc as fdoc, d.fnop as fnop,d.fid_doc " 
				 + " as fid_doc,d.forg as forg,d.fgroup as fdog_num,"
				 +" c.fwid as fid from ^docreg as d inner join "
				 + "^contract as c on d.fgroup=c.fdog_num where "
				 + "  d.forg=c.forg "
				 + "  order by fdoc,fnop"
				 
	var tbl = OpenTable("s",strSQL);
	tbl.MoveFirst();
	while (!tbl.IsEOF())
	{
		var doc = new DpDoc(tbl.getValue("Fdoc"),tbl.getValue("Fnop"));
		var id = Number(tbl.getValue("Fid_doc"));
		if(doc.loadByID(id))
		{
			doc.setVar("HID_DOG",tbl.getValue("Fid"));
			doc.save();
		}
		tbl.MoveNext();
	}
}

function hozdog()
{
	var sWhere = " where exists (select MAX(c.Fwid) from ^contract as c "
									+ " inner join ^docreg as d on d.fgroup=c.fdog_num "
									+ " where d.forg=c.forg and d.fid_doc=m.fwid  and c.fdoc='HOZDOG')" 					

	var strSQL = "update ^SCH_ZAG as m "
				+ " set m.Fid_dog=(select MAX(c.Fwid) from ^contract as c "
									+ " inner join ^docreg as d on d.fgroup=c.fdog_num "
									+ " where d.forg=c.forg and d.fid_doc=m.fwid and c.fdoc='HOZDOG')" + sWhere;

	
	ExecuteSQL(strSQL);
	
	var strSQL = " update ^RAS_SCH as m set m.fid_dog=(select MAX(c.fwid) from ^docreg as d inner join "
				 + "^contract as c on d.fgroup=c.fdog_num where "
				 + "  d.forg=c.forg and m.fwid=d.fid_doc and c.fdoc='HOZDOG'"
				 + "  )" + sWhere;
	
	ExecuteSQL(strSQL);
	
	var strSQL = " update ^HBS as m set m.fid_dog=(select MAX(c.fwid) from ^docreg as d inner join "
				 + "^contract as c on d.fgroup=c.fdog_num where "
				 + "  d.forg=c.forg and m.fwid=d.fid_doc and c.fdoc='HOZDOG'"
				 + "  )" + sWhere ;
	
	ExecuteSQL(strSQL);
	
	var base = getPath("UJ");
	ExecuteSQL("insert into " + base + ".UJ_HD (Fsum_opl,Fdat,Fdoc_num,Forg,Fdog,Hdoc,Hnop,Hid_doc,Fwid)" +
				" select Fsum,Fdoc_dat,Fdoc_num,Forg,Fid_dog,Fdoc,Fnop,Fwid,"+ base + ".SEQ_UID.Nextval" +
				" FROM ^RAS_SCH where fdoc='PP' and fnop in(4005,4006,4012,4013,4015) AND fid_dog>0");
	
	ExecuteSQL("insert into " + base + ".UJ_HD (Fsum_vyk,Fdat,Fdoc_num,Forg,Fdog,Hdoc,Hnop,Hid_doc,Fwid)" +
				" select Fsum+Fnds,Fdoc_dat,Fdoc_num,Fdbkr,Fid_dog,Fdoc,Fnop,Fwid,"+ base + ".SEQ_UID.Nextval" +
				" FROM ^SCH_ZAG where fdoc='PN' and fnop in(5208,5211,5219) AND fid_dog>0");			
				
}

var tmpTableName = "tmp_contract";

function prepareConvert()
{
	DropTable(tmpTableName);
	var exec = ExecuteSQL("SELECT * INTO " + tmpTableName + " FROM ^contract");
	if (exec)
		ExecuteSQL("DELETE FROM ^contract");
	return exec;	
}

function hd_convert()
{	
	
	var tbl = OpenTable("s","select * from " + tmpTableName);
	var oDoc = new DpDoc("HOZDOG","0");
	var i = 1;
	if (!tbl.isEmpty())
	{
		tbl.MoveFirst();
		while (!tbl.isEOF())
		{
			oDoc.setVar("HDOC","HOZDOG");
			oDoc.setVar("HOP",0);
			oDoc.setVar("HDAT",tbl.getValue("Fbdat"));
			oDoc.setVar("HNOM",i++);
			oDoc.setVar("HSUM_DOG",tbl.getValue("Fsum_dog"));
			oDoc.setVar("HORG",tbl.getValue("Forg"));
			oDoc.setVar("HTXT",tbl.getValue("Ftxt"));
			oDoc.setVar("HBDAT",tbl.getValue("Fbdat"));
			oDoc.setVar("HEDAT",tbl.getValue("Fedat"));
			oDoc.setVar("HDOG_NUM",tbl.getValue("Fdog_num"));
			oDoc.setVar("HPREM",tbl.getValue("Fprem"));
			oDoc.setVar("HSHV",tbl.getValue("Fshv"));
			oDoc.setVar("HTYPE_DOG",tbl.getValue("Ftype_dog"));
			oDoc.setVar("HVID_DOG",tbl.getValue("Fvid_dog"));
			oDoc.setVar("HCLOSE",tbl.getValue("Fclose"));
			oDoc.setVar("HDAT_OPL",tbl.getValue("Fdat_opl"));
			oDoc.setVar("HDAT_VYK",tbl.getValue("Fdat_vyk"));
			oDoc.setVar("HSUM_OPL",tbl.getValue("Fsum_opl"));
			oDoc.setVar("HSUM_VYK",tbl.getValue("Fsum_vyk"));
			oDoc.setVar("HCOD",tbl.getValue("Fcod"));
			oDoc.setVar("HOL",tbl.getValue("Fol"));
			oDoc.setVar("HFX",tbl.getValue("Fwid_fx"));
			oDoc.setVar("HDAT_SAL",tbl.getValue("Fdat_sal"));
			oDoc.setVar("HSAL_OPL",tbl.getValue("Fsal_opl"));
			oDoc.setVar("HSAL_VYK",tbl.getValue("Fsal_vyk"));
			oDoc.save();
			oDoc.clear();
			tbl.MoveNext();	
		}
	}
	tbl.close();
	//DropTable(tmpTableName);
}
