
function Load()
{
	if(getSystem()=="VDK")
	{
		Caption(ru("Водоканал", "Водоканал"));
		FORM.setImage(rootDirectoryEx() +"/icons/water_pipe.gif");
	}
	else
	{
		Caption(ru("ЖЭК", "ЖЕК"));
		FORM.setImage(rootDirectoryEx() +"/icons/house.gif");
	}
	
	fillSysCombo(SYSCOMBO);
	setValid(SYSCOMBO, selSysCombo);
	
	loadServisPanel();
	loadVedPanel();
	loadClPanel();	
	loadParamPanel();
	
	PANELBAR.getCtrl().setWeights(new Array(11, 12, 11, 7));
}

function loadServisPanel()
{
	pServis = PANELBAR.createPanel();
	pServis.setCaption(ru("Услуги","Послуги"));
		
	pServis.addItem("TSERV", ru("Номенклатура","Номенклатура"), true);	
	pServis.addItem("TARIFF",ru("Тарифы","Тарифи"), true);	
	pServis.addItem("LICSC", ru("Лицевые счета","Особові рахунки"), true);	
	pServis.addItem("SKU", 	 ru("Счета за коммунальные услуги","Рахунки за комунальні послуги"), true);	
	pServis.addItem("PV", 	 ru("Оплаты","Оплати"), true);
	pServis.addItem("CP", 	 ru("Кассовые ордера","Касові ордери"), true);
		
	this.selHandler = selHandler;
	pServis.setSelectHandler(this, "selHandler");
}

function loadVedPanel()
{
	pServis = PANELBAR.createPanel();
	pServis.setCaption(ru("Отчеты","Звіти"));
		
	pServis.addItem("VEDKU", ru("Сальдовая ведомость","Сальдова вiдомiсть"), true);
	pServis.addItem("DEBT", ru("Отчет по задолженности","Звіт по заборгованості"), true);
	pServis.addItem("EXTSVD", ru("Сводный отчет по льготам","Зведений звіт по пільгах"), true);	
	pServis.addItem("EXEMPT", ru("Расчет возмещения затрат","Розрахунок відшкодування витрат"), true);
	pServis.addItem("TOTAL", ru("Итоги по нормам потребления", "Підсумки по нормах споживання"), true);	
	pServis.addItem("CARD", ru("Карточка счета","Картка рахунку"), true);
	pServis.addItem("AKT", ru("Акт сверки","Акт звірення"), true);		
		
	this.selHandler = selHandler;
	pServis.setSelectHandler(this, "selHandler");
}

function loadClPanel()
{
	pCl = PANELBAR.createPanel();
	pCl.setCaption(ru("Справочники","Довідники"));
		
	pCl.addItem("PLAT",		ru("Плательщики","Платники"), true);	
	pCl.addItem("STREET", 	ru("Улицы","Вулиці"), true);
	pCl.addItem("HOUSE", 	ru("Дома","Будинки"), true);
	pCl.addItem("APART", 	ru("Квартиры","Квартири"), true);
	pCl.addItem("MEN", 		ru("Жильцы","Мешканці"), true);
	pCl.addItem("CLEXEMPT", ru("Льготы","Пільги"), true);	
		
	this.selHandler = selHandler;
	pCl.setSelectHandler(this, "selHandler");
}

function loadParamPanel()
{
	pCl = PANELBAR.createPanel();
	pCl.setCaption(ru("Настройки","Налагодження"));
	
	pCl.addItem("PRICE", 	ru("Прайс-листы","Прайс-листи"), true);	
	pCl.addItem("PARAMS", 	ru("Параметры","Параметри"), true);
	pCl.addItem("NORM", 	ru("Нормы","Норми"), true);	
			
	this.selHandler = selHandler;
	pCl.setSelectHandler(this, "selHandler");
}

function selHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	//var sys = getSystem();
	//if(sys!="HOC")
	//	lpProxy.getOrgManager().setSys("HOC");
	switch(sID)
	{
		case "TARIFF":
			par.sParName = "HOCPRI";
			sDlg = "tariff.js";
			break;
		
		case "TSERV":
			sDlg = "l_clnmktree.xml";
			break;	
		
		case "LICSC":
			sDlg = "bill_servis.js";
			par.nop = getPar("HOC_LICSC");
			par.doc = sID;			
			break;
		case "SKU":
			sDlg = "bill_servis.js";
			par.nop = getPar("HOC_SKU");
			par.doc = sID;
			break;
		case "PV":
			sDlg = "bill_servis.js";
			par.nop = getPar("HOCPAYNOP");
			par.doc = sID;						
			break;
		case "CP":
			sDlg = "bill_servis.js";
			par.nop = getPar("HOC_CP");
			par.doc = sID;						
			break;
			
		case "VEDKU":
			sDlg = "r_vedku.js";
			break;
			
		case "DEBT":
			sDlg = "r_kudebt.js";			
			break;
			
		case "EXTSVD":
			sDlg = "r_extsvd.js";
			break;		
		
		case "EXEMPT":
			sDlg = "r_exempt.js";
			break;
			
		case "TOTAL":
			sDlg = "r_vedku_norm.js";
			break;
		
		case "CARD":
			include("Objects/DpGetDat.js");
			var gd = new DpGetDat(new Array("r", "o", "dog"));
			if (gd.escape) 
				return false;		
			par.dat1 = gd.dat1;
			par.dat2 = gd.dat2;
			par.org = par.FORG = gd.forg;
			par.dogID = gd.fdog;
			sDlg = "r_sku_card.xml";
			break;
			
		case "AKT":
			var sDocregTbl = getPath("ALL_MDB") + "." + (SUBD==MSSQL?".":"") + "MDOCREG";
			par.fvid = "-";
			//par.freg = "S1_DEC";
			par.freg = "CRM";
			par.tblName = sDocregTbl;
			par.menuMode = "CALC";
			sDlg = "r_actcmp.js";
			break;
		
		case "PLAT":
			par.Fvid = 2;
			par.Fcl = getPar("CODPLAT");			
			sDlg = "l_cl.xml";
			break;
		case "STREET":
			par.Fvid = 1;
			par.Fcl = getPar("CODSTREET");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника улиц"
					 	,"Не встановлений параметр довідника вулиць");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для встановлення параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}
			sDlg = "l_cl.xml";
			break;
		case "HOUSE":
			par.Fvid = "clhouse";
			par.Fcl1 = getPar("CODSTREET");
			par.Fcl = getPar("CODHOUSE");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника домов"
					 	,"Не встановлений параметр довідника будинків");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для встановлення параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}			
			sDlg = "l_cl.xml";
			break;
		case "APART":
			par.Fvid = "clapartment";
			par.Fcl1 = getPar("CODHOUSE");	
			//par.Fcod1 = getPar("CODHOUSE");	
			par.Fcl = getPar("CODAPT");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника квартир"
					 	,"Не встановлений параметр довідника квартир");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для встановлення параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}
			sDlg = "l_cl.xml";
			break;
		case "CLEXEMPT":
			par.Fvid = "clexempt";
			par.Fcl = getPar("CODLGT");
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника льгот"
					 	,"Не встановлений параметр довідника пільг");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для встановлення параметрів?");
				if(confirm(sMsg))
					selHandler("PARAMS");
				return;
			}
			sDlg = "l_cl.xml";
			break;
		
		case "MEN":
			sDlg = "l_men.js";
			break;
		
		case "PARAMS":
			sType = SW_MODAL;
			par.sel = "HOC";
			sDlg = "e_param.xml";
			break;	
		
		case "PRICE":
			sDlg = "l_cl_pri.xml";
			break;
				
		case "NORM":
			sDlg = "l_orgvars.js";
			break;	
					
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}

include("sys/DpBaseDlg.js");