include("Objects/DpCl.js");
include("Objects/DpVal.js")

var oOrg, oVal;
function onLoad()
{
	extPar.escape = true;
	Caption("Параметри розрахунку|Параметры расчета");
	
	oOrg = new DpCl("");
	oOrg.setClcl(getPar("CODPLAT"));
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	
	oVal = new DpVal();
	oVal.linkCtrl(FVAL);
	
	FBDAT.value = getPar("GLOBDAT1");
	FEDAT.value = getPar("GLOBDAT2");
	
	loadJournals();
	
	if(extPar)
	{
		if(extPar.org)
			oOrg.setCod(extPar.org);
		if(extPar.forg)
			oOrg.setCod(extPar.forg);
		if(extPar.dat1)
			FBDAT.value = extPar.dat1;
		if(extPar.dat2)
			FEDAT.value = extPar.dat2;
		if(extPar.journal)
			FJOURNAL.value = extPar.journal;
	}
}

function loadJournals()
{
	include("objects/DpJRegistrator.js");	
	var oReg = new DpJRegistrator(null, null, "S");
	var listJornals = oReg.listJournals();
	FJOURNAL.clear();
	FJOURNAL.addItem("CRM", "CRM");
	for (var jID in listJornals)
	{
		var oJournal = oReg.listJournals()[jID];
		if(!oJournal)
			continue;
		FJOURNAL.addItem(jID +"_"+ oJournal.getType(), jID +" - "+ oJournal.getName());
	}
	FJOURNAL.setSelectedIndex(0);
}

function onSave()
{
	var sReg = String(FJOURNAL.value).trim();
	if(sReg=="CRM")
	{
		extPar.tblName = "^UJ_CRM";
		extPar.fvid = "+";
	}
	else
	{
		var sType = sReg.substring(sReg.length-1);
		sReg = sReg.substring(0, sReg.lastIndexOf("_"));
		var sVid = "+";
		if(sType=="M")
			sVid = "-";
		extPar.tblName = getPath("ALL_MDB") + "." + (SUBD==MSSQL?".":"") + sType +"DOCREG";
		extPar.fvid = sVid;
	}	
		
	extPar.freg = sReg;	
	extPar.dat1 = FBDAT.getValue();
	extPar.dat2 = FEDAT.getValue();
	extPar.org = extPar.forg = oOrg.getCod();
	extPar.journal = FJOURNAL.value;
	extPar.fval = oVal.getCod();
	extPar.escape = false;
	return true;
}

include("sys/DpBaseDlg.js");