//перенесла из БЦ версии 13.11.12 Яна
function journalMenuInit(toObject)
{
	toObject.AddMenuItem("DEBET2XSD",  "Підготувати для електронної звітності (Додаток 5)|Подготовить для электронной отчетности (Приложение 5)");
	toObject.AddMenuItem("REESTR2XSD", "Підготувати для електронної звітності (Реєстр податкових накладних)|Подготовить для электронной отчетности (Реестр налоговых накладных)");
	toObject.AddMenuItem("PRINT_DODATOK5",  "Друк додатку №5|Печать приложения №5", 9);
}

function journalQrySet()
{
	this.qrySet("Order","HDAT, " + SqlRight(SqlConCat("'              '","HNOM"),14));
}

function journalMenuRun(sID)
{
	switch(sID)
	{
	case "DEBET2XSD":
		strName = "DODATOK5_DB";
		DropTable(strName);
		strSQL = "CREATE TABLE " + strName
				+ " ( FSUM "+SqlType("CURRENCY")
				+ " , FNDS "+SqlType("CURRENCY")
				+ " , FINDNUM "+SqlType("TEXT", 20)
				+ " , FDATE "+SqlType("DATE")
				+ " , FORG "+SqlType("LONG")
				+ " , FPLATNDS "+SqlType("BIT")
				+ " , fiscor" + SqlType("INT")
				+ " , FWID " + SqlType("COUNTER") + ")";
		ExecuteSQL(strSQL); 			
		for(list.tbl.MoveFirst(); !list.tbl.IsEOF(); list.tbl.MoveNext())
		{
			var m = new Object()
			m.FNDS = round(list.tbl.getValue("FNDS"), 2);
			m.FSUM = round(list.tbl.getValue("FSUM_20"), 2);
			m.FORG = list.tbl.getValue("HORG");
			m.FINDNUM = tcl("ORG", "CODNDS", m.FORG);
			if (Number(m.FINDNUM) == 0)
				m.FINDNUM = "X";
			m.FPLATNDS = tcl("ORG", "FPLATNDS", m.FORG);
			
			updateTable(strName, m, true);
		}
		alert(ru("Расчет окончен.", "Розрахунок завершено."))
		break;
	
	case "REESTR2XSD":
		strName = "REESTR_DB_NV";
		DropTable(strName);
		ExecuteSQL(
			" select *" 
			+ " INTO " + strName
			+ " FROM " + this.qryFrom
			+ " WHERE " + this.qryWhere
			);
		// ikos
		ExecuteSQL("ALTER TABLE " + strName +" ADD COLUMN Ftxt1 " + SqlType("TEXT",201));
		//ExecuteSQL(strSQL);		
				strSQL = " UPDATE "
						+" " + strName
   						+" SET FTXT1 = "
						+"("
							+" SELECT DISTINCT substr(CL.FTXT,1,200)"
								+" FROM "
							+" ^CLRELCLCL AS REL, "
							+" ^CL AS CL"
							+" WHERE "
							+strName+".HORG = REL.FCOD "
							+" AND REL.FCL = 12" //+ nCl
							+" AND CL.FWID = REL.FWID_CL "
						+")"                                         //, FTXT1 = 'CL.FTXT'"						

				ExecuteSQL(strSQL);
			
		alert(ru("Расчет окончен.", "Розрахунок завершено."))
		break;
		
		
	case "RENUM":
		include("doc\\DpDoc.js");
	
		var tDocs = OpenTable(
			"SELECT *"
			+ " FROM " + this.qryFrom
			+ " WHERE " + list.dataSrc.sqlSelected()
			+ " ORDER BY HDAT, HNOM"
			)
			
		var nn = input("Начальный номер", "Введите целое число", 1, 6, 0);

		if (!nn)
			break;
		
		var aDocs = new Array();
		var oDoc;
		
		for (; !tDocs.IsEOF(); tDocs.MoveNext())
		{
			var sDoc = toScrObj(tDocs.getValue("hdoc"));
			var nNop = toScrObj(tDocs.getValue("hnop"));
			
			if (!aDocs[sDoc + "-" + nNop])
			{
				aDocs[sDoc + "-" + nNop] = new DpDoc(sDoc, nNop);
			}
			oDoc = aDocs[sDoc + "-" + nNop];
						
			oDoc.loadByID(tDocs.getValue("hid_doc"));
			oDoc.setVar("HNOM", String(nn));
			oDoc.save();
			
			nn++;
		}
		
		list.tbl.requery();
		this.grid.refresh();
	break;
	//Tori 08.06.2011: отдельная печать додатку 5 из NV_DODATOK5 без учета отрицательных сумм и с группировкой плательщиков НДС по ИНН
	case "PRINT_DODATOK5":
		var fld = new Object();
		fld.FWID = "LONG";
		fld.FSUM = "CURRENCY";
		fld.FNDS = "CURRENCY";
		fld.FCOD_NDS = "TEXT";
		fld.FPLATNDS = "BIT";
		fld.FORG = "LONG";
		var ind = new Object();
		ind.FORG = "FORG";
		ind.FCOD_NDS = "FCOD_NDS";
		var tblName = "prn_dodatok5";
		CreateTable(tblName, fld, ind);
		ExecuteSQL("insert into "+tblName+" (Forg, Fcod_nds, Fplatnds, Fsum, Fnds, Fwid) "
				+" select MIN(j.Horg), j.Finn, org.Fplatnds, SUM(j.Fsum_20), SUM(j.Fnds), MAX(j.Fwid)"
				+" from " + this.qryFrom + " as j left join ^listclorg as org on j.Horg=org.Fcod and org.Fcl=0"
				+" where " + this.qryWhere + " and j.FSUM_20>0"
				+" group by j.Finn, org.Fplatnds");
		//свои организации должны попадать в строку "інші", поэтому уберем признак плательщиков НДС для своих организаций
		ExecuteSQL("update "+tblName+" set Fplatnds="+sqlFalse+" where Fcod_nds in (select Fcod_nds from ^listclorg where Fcl=0 and Fcod="+getPar("ORGNOM")+")");
		include("Objects/DpTVars.js");
		var tv = new DpTVars("NV_DODATOK5");
		var tbl = OpenTable("select * from "+tblName+" order by fwid");
		tv.setRTbl(tbl);
		tv.print();
		tbl.close();
	break;
	}
}