include("objects/DpGrid.js");
include("sys/servis.js");
include("r_actsv.js");

var dat1;
var dat2;
var codspr;
var dog;
var isOblcod;	//Если true, то берем обороты из результатов расчета баланса по коду

var isCntrct = false; //Если true, то считаем по договорам

var tmp = getTmpTableName("", true);

var delFilter = false;
var prnPatt = "PRVIP";
var sysname;

function listLoad()
{   	
	with(this)
	{
		printLabel = prnPatt;
	}
	
	//это надо для записи/чтения параметров
	sysname = getSysName();
	//Для возможности вызвать расчет акта сверки напосредственно с "рабочего стола"
	//предусмотрим передачу
	// this.par.Fnum
	// this.par.Fcl
	//через menuMode в виде "CALC|1|12"
	//где 1 станет this.par.Fnum, а 12 - this.par.Fcl
	var aPars = this.par.menuMode.split("|");
	this.par.menuMode = aPars[0];
	if (aPars.length==3 && typeof(aPars[1])!="undefined" && typeof(aPars[2])!="undefined")
	{
		this.par.Fnum = parseInt(aPars[1]);
		this.par.Fcl = parseInt(aPars[2]);
	}
}

function listTitle()
{
	return UR("Акт звiрки за "+StrDat(dat1, "DMY")+"-"+StrDat(dat2, "DMY")
			   , "Акт сверки за "+StrDat(dat1, "DMY")+"-"+StrDat(dat2, "DMY"))
			+ " по " +codspr + ": " + tcl("CL", "TXT", this.par.Fcl, codspr);
}

function listAsk()
{
	var strScNoDog = ""
	//vlad 16.01.2012
	//Если расчет выполняется по списку счетов, хотя бы к одному из которых
	//привязан справочник договоров, то спросим еще и номер договора
   	var strSQL = "SELECT "
		+"S.FSCHET"
		+" ,S.FSUBSCHET"
		+" ,S.FSTAT"
	+" FROM "
		+" ^CL_SCHET S"
		+" , ^KOD_SCH B"
	+" WHERE "
		+" B.FNUM = "+sqlTo(this.par.Fnum)
		+" AND ("
			+" S.FCL1_TYPE="+sqlTo("cntrct")
			+" OR S.FCL2_TYPE="+sqlTo("cntrct")
			+" OR S.FCL3_TYPE="+sqlTo("cntrct")
		+")"
		+" AND "+SqlTrue+"="+IIF("B.FSU=0", SqlTrue, IIF("B.FSU=S.FSUBSCHET", SqlTrue, SqlFalse))
		+" AND "+SqlTrue+"="+IIF("B.FST=0", SqlTrue, IIF("B.FST=S.FSTAT", SqlTrue, SqlFalse))
   	
	var tSc = OpenTable(strSQL);

	var strSc = "";
   if (!tSc.IsEmpty())
   {
		isCntrct = true;

		for (tSc.MoveFirst(); !tSc.IsEOF(); tSc.MoveNext())
		{
			strSc += ", "+toScrObj(tSc.getValue("FSCHET"))+"/"
				+toScrObj(tSc.getValue("FSUBSCHET"))+"/"
				+toScrObj(tSc.getValue("FSTAT"))
		}
		//обрежем впереди идущую запятую
		strSc = strSc.substr(2);
		//могут быть счета без договоров, предупредим, что по ним считать не будем
		strSQL = "SELECT S.FSCHET, S.FSUBSCHET, S.FSTAT"
			+" FROM "
				+" ^CL_SCHET S"
				+" , ^KOD_SCH B"
			+" WHERE "
				+" B.FNUM = "+sqlTo(this.par.Fnum)
				+" AND NOT ("
					+" S.FCL1_TYPE="+sqlTo("cntrct")
					+" OR S.FCL2_TYPE="+sqlTo("cntrct")
					+" OR S.FCL3_TYPE="+sqlTo("cntrct")
				+")"
				+" AND B.FSC = S.FSCHET"
				+" AND "+SqlTrue+"="+IIF("B.FSU=0", SqlTrue, IIF("B.FSU=S.FSUBSCHET", SqlTrue, SqlFalse))
				+" AND "+SqlTrue+"="+IIF("B.FST=0", SqlTrue, IIF("B.FST=S.FSTAT", SqlTrue, SqlFalse))
			+" ORDER BY S.FSCHET, S.FSUBSCHET, S.FSTAT"
		var tblScNoDog = OpenTable(strSQL);
		for (; !tblScNoDog.IsEOF(); tblScNoDog.MoveNext())
		{
			strScNoDog += toScrObj(tblScNoDog.getValue("FSCHET"))+"/"
				+toScrObj(tblScNoDog.getValue("FSUBSCHET"))+"/"
				+toScrObj(tblScNoDog.getValue("FSTAT"))+", "
		}
		tblScNoDog.close();
		tblScNoDog = null;
		if (strScNoDog != "")
		{
			strScNoDog = strScNoDog.substr(0,strScNoDog.length-2);
		}
   }
	tSc.close();
	tSc = null;
	
	include("objects\\DpAskEx.js");
	var oA = new DpAskEx();
	oA.notClearCtrl = true;	//Не очищать задизейбленные контролы
	oA.add("B", "Брати дані з розрахованого балансу по коду?|Брать данные из рассчитанного баланса по коду?", "ISOBLCOD", false);
	oA.add("D", "Дата початку|Дата начала", "FBDAT", firstDay(new Date()).getVarDate());
	oA.add("D", "Дата закінчення|Дата окончания", "FEDAT", lastDay(new Date()).getVarDate());
	oA.add("CL", "Код з довідника|Код из справочника", "COD", 0, this.par.Fcl);
	if (isCntrct)
	{
		var maxLen = 20;
		var strScDisp = strSc.length>maxLen ? strSc.substr(0, maxLen)+"..." : strSc
		//oA.add("CNTRCT", "Договір по рах."+strSc+"|Договор по рах."+strSc, "DOG", 0, "COD");
		oA.add("CNTRCT0", "Договір по рах."+strScDisp+"|Договор по рах."+strScDisp, "DOG", 0, "COD");
	}
	oA.add("B", "Показувати всі проведення по документу одним рядком|Показывать все проводки по документу одной строкой", "ISGRPDOC", false);
	
	oA.dates_values = dates_values;
	oA.cod_values = cod_values;
	
	oA.defCond("IsTable(\"TMP_OBLCOD_RES\")", "COND_ISOBLCOD_ENABLE");
	oA.defCond("this.dates_values(\"FBDAT\")", "COND_ENABLE_FBDAT")
	oA.defCond("this.dates_values(\"FEDAT\")", "COND_ENABLE_FEDAT")
	oA.defCond("this.cod_values(\"COD\")", "COND_ENABLE_COD")
	
	oA.enable("ISOBLCOD", "COND_ISOBLCOD_ENABLE");
	oA.enable("FBDAT", "COND_ENABLE_FBDAT");
	oA.enable("FEDAT", "COND_ENABLE_FEDAT");
	oA.enable("COD", "COND_ENABLE_COD");
	
	
	oA.setRel(">=", "FEDAT", "FBDAT");

	if (oA.doAsk())
	{
		dat1 = new Date(oA.get("FBDAT"));
		dat2 = new Date(oA.get("FEDAT"));
		codspr = oA.get("COD").getCod();
		isOblcod = oA.get("ISOBLCOD");

		setParWithDef("FBDAT", dat1.getVarDate(), sysname);
		setParWithDef("FEDAT", dat2.getVarDate(), sysname);
		setParWithDef("COD", codspr, sysname);
		if (isCntrct)
		{
			dog = oA.get("DOG").getID();
		}
		setParWithDef("DOG", dog, sysname);
		if (strScNoDog != "" && !isEmpty(dog))
		{
			alert(ru("Внимание! К счетам \n"+strScNoDog+"\nне привязан договор. По ним расчет проводиться не будет.",
				"Увага! До рахунків \n"+strScNoDog+"\nне прив'язаний договір. По них розрахунок проводитися не буде."))
		}	
	}
	
	return oA;
}

//валидация галочки "Брати дані з розрахованого балансу по коду"
//Если ее не отмечаем, то просто производим расчет акта сверки "с нуля"
//Если же ее ставим, то у нас в т-це "TMP_OBLCOD_RES" уже выбраны результаты расчета баланса по коду
//Если там данные только по одной организации, то 


//Будет методом oA, будет в defCond
function cod_values(sName)
{
	var retVal = !this.immediate("ISOBLCOD");
	if (!retVal)
	{
		//Стоит галочка - поставим орг из данных последнего расчета баланса по коду
		if (!IsTable("TMP_OBLCOD_RES"))
		{
			this.aQryList["ISOBLCOD"].value = false; 
			this.aQryList["ISOBLCOD"].controls[0].checked = false; 

			//alert(ru("Произведите расчет баланса по коду","Виконайте розрахунок баланса по коду"));
			return true;
		}
		
		strSQL = " SELECT count(*) AS CNT, MAX(P.FCOL) AS FMAX FROM (SELECT DISTINCT "
					+" T.FCOL AS FCOL"
				+" FROM"
					+" TMP_OBLCOD_RES T) P"
		var sn = getSnap(strSQL);
		if (sn)
		{
			if(sn[0]==1)
			{
				retVal = false;
			}
			
			this.aQryList[sName].value.setCod(sn[1]); 
			this.aQryList[sName].controls[0].setValue(sn[1]); 
		}
		sn = null;
	}
	return retVal;
}


//Будет методом oA, будет в defCond вместо выр-я
//"!this.aQryList[\"ISOBLCOD\"].controls[0].checked"
function dates_values(sName)
{
	var retVal = !this.immediate("ISOBLCOD");
	if (!retVal)
	{
		//Стоит галочка - поставим дату из данных последнего расчета баланса по коду
		if (!IsTable("TMP_OBLCOD_RES"))
		{
			this.aQryList["ISOBLCOD"].value = false; 
			this.aQryList["ISOBLCOD"].controls[0].checked = false; 
			//alert(ru("Произведите расчет баланса по коду","Виконайте розрахунок баланса по коду"));
			return true;
		}
		
		strSQL = " SELECT DISTINCT "
					+sName
				+" FROM"
					+" TMP_OBLCOD_RES"
		var sn = getSnap(strSQL);
		if (sn && sn[0])
		{
			var dDate = new Date(toScrObj(sn[0]));
			this.aQryList[sName].value = dDate; 
			this.aQryList[sName].controls[0].setValue(dDate); 
		}
		sn = null;
	}
	return retVal;
}

function listMake()
{
	dat1 = getParWithDef("FBDAT", sysname, d00);
	dat2 = getParWithDef("FEDAT", sysname, d00);
	codspr = Number(getParWithDef("COD", sysname, ""));
	isOblcod = getParWithDef("ISOBLCOD", sysname, true);
	dog = Number(getParWithDef("DOG", sysname, 0));
	
	var mFnumr = this.par.Fnum;
	var mFcl   = this.par.Fcl;
	
	if (!isOblcod)
	{
		//Здесь выполним расчет баланса по коду
		include("oblcod.js");
		oblcod(dat1, dat2, mFcl, codspr, mFnumr, dog);
	}

	//теперь рассчитаем акт сверки
	bGrpByDoc = list.objAsk.get("ISGRPDOC");
	r_actsv(mFnumr, mFcl, codspr, bGrpByDoc, dog);
	
	if (IsTable("curoblob"))
	{
		strSQL = "SELECT "
					+" SUM(T.FSUM) AS FSUM"
					+", T.FID_DOC"
					+", T.FDATE"
					+", T.FDOCNUM"
					+", T.FDOC"
					+", T.FNOP"
					+", T.FWRK"			
					+", T.FDB_SC"			
					+", T.FDB_SU"			
					+", T.FDB_ST"			
					+", T.FCR_SC"			
					+", T.FCR_SU"			
					+", T.FCR_ST"			
					+", T.FPRIZN"			
				+" INTO"
					+" "+tmp
				+" FROM"
					+" ^curoblob T"
				+" WHERE 1 = 1"
				+" GROUP BY"
					+" T.FID_DOC"
					+", T.FDATE"
					+", T.FDOCNUM"
					+", T.FDOC"
					+", T.FNOP"
					+", T.FWRK"			
					+", T.FPRIZN"			
					+", T.FDB_SC"			
					+", T.FDB_SU"			
					+", T.FDB_ST"			
					+", T.FCR_SC"			
					+", T.FCR_SU"			
					+", T.FCR_ST"			
					+", T.FPRIZN"			
				+" ORDER BY"
					+" T.FWRK, T.FDATE"
		ExecuteSQL(strSQL)

		ExecuteSQL("ALTER TABLE "+tmp+" ADD COLUMN FTXT "+SqlType("TEXT"))
		ExecuteSQL("ALTER TABLE "+tmp+" ADD COLUMN FWID "+SqlType("COUNTER"))

		strSQL = "UPDATE "
						+" "+tmp
					+" SET "
						+" FTXT = ("
								+" SELECT"
									+" "+sqlToolkit.sqlFirst("FTXT")
								+" FROM"
									+" CUROBLOB"
								+" WHERE 1 = 1"
									+" AND FID_DOC = "+tmp+".FID_DOC"
								+")"
					+" WHERE 1 = 1"
						+" AND FDOC NOT IN ('PN','NK')"
						+" AND FWRK = 5"
		ExecuteSQL(strSQL);				

		strSQL = "UPDATE "
						+" "+tmp
					+" SET "
						+" FTXT = (SELECT FTXT FROM ^CL_LNK WHERE FDOC = "+tmp+".FDOC AND FNOP = "+tmp+".FNOP)" 
					+" WHERE 1 = 1"
						+" AND FDOC IN ('PN','NK')"
						+" AND FWRK = 5"
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE "
						+" "+tmp
					+" SET "
						+" FTXT = (SELECT FTXT FROM CUROBLOB WHERE FWRK = "+tmp+".FWRK)" 
					+" WHERE 1 = 1"
						+" AND FWRK <> 5"
		ExecuteSQL(strSQL);
	}                    
}

function listSrc()
{
	if(this.par.mode == "VIEW")
   	{
		if (!IsTable("curoblob"))
		{
			alert(ru("Выполните расчет","Виконайте розрахунок"));        
			return false;
		}
		else
		{
			this.subMake();
		}
   	}
	
	this.qrySet("From", tmp, "Order", "Fwrk, Fdate, FDOCNUM");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var page = oGrid.page();
	
   	oGrid.defCond("=inList(^Fwrk, 1, 3, 209, 210)", "ITOG");
	oGrid.color(1, "ITOG");
   	
	oGrid.defCond("=inList(^Fwrk, 101, 102)", "OB");
	oGrid.color(2, "OB");
   	
    var expr = "="+sqlSwitch("^Fwrk"
			, 1, "Початкове сальдо <Дб>|Начальное сальдо <Дб>"
			, 3, "Початкове сальдо <Кр>|Начальное сальдо <Кр>"
			, 101, "Обiг по <Дб>|Оборот по <Дб>"
			, 102, "Обiг по <Кр>|Оборот по <Кр>"
			, 209, "Сальдо на кiнець <Дб>|Сальдо на конец <Дб>"
			, 210, "Сальдо на кiнець <Кр>|Сальдо на конец <Кр>"
			);
	
	with(page)
	{	      	
     	FieldEx("FDATE", "Дата|Дата", 12);
      	FieldEx("FDOCNUM", "№|№", 8);
      	FieldEx("FDOC", "Док.", 8);
      	FieldEx("FNOP", "Папка", 8);
      	
		//FieldEx(expr, "Зміст|Содержание", 16);
		FieldEx("FTXT", "Зміст|Содержание", 16, "w");

/*		
		with(group("Дебет|Дебет"))
      	{
      		FieldEx("Fdb_sc",	"Рах.|Сч.", 3);
      		FieldEx("Fdb_su",	"С/р|С/Сч", 4);
      		FieldEx("Fdb_st",	"Ст.|Ст.", 4);
      		FieldEx("Fdb_cod1",	"Ан.1|Ан.1", 3);
      		FieldEx("Fdb_cod2",	"Ан.2|Ан.2", 3);
      		FieldEx("Fdb_cod3",	"Ан.3|Ан.3", 3);
      	}
      	with(group("Кредит|Кредит"))
      	{
      		FieldEx("Fcr_sc",  	"Рах.|Сч.", 3);
      		FieldEx("Fcr_su",  	"С/Р|С/Сч", 4);
      		FieldEx("Fcr_st",  	"Ст.|Ст.", 4);
      		FieldEx("Fcr_cod1",	"Ан.1|Ан.1", 3);
      		FieldEx("Fcr_cod2",	"Ан.2|Ан.2", 3);
      		FieldEx("Fcr_cod3",	"Ан.3|Ан.3", 3);
   		}
*/
		
		FieldEx("=retSum(^FWRK, ^FPRIZN, ^FSUM, 0)", "Дебет", 12, null, DP_FORMAT_SUM);
		FieldEx("=retSum(^FWRK, ^FPRIZN, 0, ^FSUM)", "Кредит", 12, null, DP_FORMAT_SUM);
      	
		//FieldEx("Fsum", "Сума|Сумма", 14, null, DP_FORMAT_SUM);
	}
	oGrid.build();
}

function retSum(wrk, prizn, sum, def)
{
	var ret = toScrObj(def);
	if (inList(toScrObj(wrk), 1, 101, 209) || toScrObj(prizn) == "DB")
	{
		ret = toScrObj(sum);
	}
	
	return ret;
}

function getTblH()
{
	var h = new Object();
	h.FCL1 = codspr;
	h.FD1 = dat1;
	h.FD2 = dat2;
	h.FCL2 = dog;
	
	return h;
}

function listMenuInit()
{
	if (this.tbl.getValue("Fid_doc") != null)
	{
		this.dataSrc.AddMenuItem("FIND_DOC","Пошук документа|Поиск документа");
	}
}

function listMenuRun(szID)
{
	if (szID == "FIND_DOC")
	{
		if(this.tbl.getValue("Fid_doc") != null)
		{
			include("doc\\DpDocPtn.js");
			FindDocument(this.tbl.getValue("Fdoc"), Number(this.tbl.getValue("Fnop")), this.tbl.getValue("Fid_doc"));
		}
		return
	}
}



include("sys/DpList.js");