var sWhere,objClassId;

function listLoad()
{
	if(null == extPar.fnop)
		 extPar.fnop = 0;
	objClassId = String(extPar.fdoc);
	with (this)
	{
		if (objClassId.startsWith("CLS."))
		{
			if(extPar.mode == "DOCARCH")
				title = "История довідника|Історія справочника";
			else
			{
				var captRU = "Архив справочника (" + extPar.fdoc + ": " + extPar.fnop + ")";
				var captUA = "Архів довідника (" + extPar.fdoc + ": " + extPar.fnop + ")";
				title = captUA + "|" + captRU;
			}
			xmlGridFile = "l_archiveCl.xml";
		}
		else if(objClassId.startsWith("_"))
		{
			if(extPar.mode == "DOCARCH")
				title = "Історія наказа|История приказа";
			else
			{
				var captRU = "Архив приказа (" + extPar.fdoc + ": " + extPar.fnop + ")";
				var captUA = "Архів наказа (" + extPar.fdoc + ": " + extPar.fnop + ")";
				title = captUA + "|" + captRU;
			}
			xmlGridFile = "l_archivePrik.xml";
		}
		else
		{
			if(extPar.mode == "DOCARCH")
				title = "Історія документа|История документа";
			else
			{
				var captRU = "Архив папки (" + extPar.fdoc + " - " + extPar.fnop + ")";
				var captUA = "Архів папки (" + extPar.fdoc + " - " + extPar.fnop + ")";
				title = captUA + "|" + captRU;
			}
			xmlGridFile = "l_archiveDoc.xml";
		}
		accDel==null;
	}
}

function listSrc()
{
	var arrOrder = new Array("FMDATE DESC, FVER DESC, FNOP, FNUM");
	sWhere = " 1=1";
	if(extPar)
	{
		sWhere += " AND fdoc=" + sqlTo(extPar.fdoc);
		if(0!=extPar.fnop)
			sWhere += " AND fnop=" + sqlTo(extPar.fnop);
				
		if(extPar.mode == "DOCARCH")
		{
			sWhere += " AND fid_doc=" + sqlTo(extPar.fid);
			arrOrder = new Array("FMDATE DESC, FVER DESC");
		}
		else
		{
			sWhere += " AND (FMDATE BETWEEN " + sqlTo(list.objAsk.get("BDAT"))
				+" AND "+sqlTo(list.objAsk.get("EDAT"))+")" ;
		}
	}
	
	
	
	this.qrySet("From", "^archive",
				"Where", sWhere,
				"Order", arrOrder,
				"Ptn", "archive"
				);
}

function listAsk()
{
	if(extPar.mode != "DOCARCH")
	{
		include("objects\\DpAskEx.js");

		var oA = new DpAskEx();
		oA.add("D", "Дата початку|Дата начала", "BDAT", new Date().getVarDate());
		oA.add("D", "Дата закінчення|Дата окончания", "EDAT", new Date().getVarDate());
		oA.doAsk();
		if(oA.escape)
		{
			CloseWindow();
			return oA;
		}
	}
	else
	{
		var oA = new Object();
		oA.escape = false;
	}
	return oA;
}

function listMenuInit()
{
	if (this.tbl.IsRecord())
	{
		this.dataSrc.AddMenuItem("UNERASE","Відновити|Восстановить");
		this.dataSrc.AddMenuItem("COMPARE","Порівняти|Сравнить");
		this.dataSrc.AddMenuItem("VIEW_OBJ","Перегляд|Просмотр","VIEW");
	}
}

function listMenuRun(nID)
{
	if(nID == "UNERASE")
	{
		var isCl = false;
		var isPrik = false;
		
		if (objClassId.startsWith("CLS."))
		{
			isCl = true;
			include ("Objects/DpClEx.js")
			oObj = new DpClEx(objClassId.substr(4), this.tbl.getValue("fnop"));
		}
		else if(objClassId.startsWith("_"))
		{
			isPrik = true;
			include("prik/DpPrik.js");
			oObj = new DpPrik(objClassId,this.tbl.getValue("fnop"));
		}
		else
		{
			include ("doc/DpDoc.js")
			oObj = new DpDoc(objClassId, this.tbl.getValue("fnop"));
		}
		
		var t = OpenTable("select * from ^archive where "+grid.sqlSelected());
		var i = 1;
		if(t.rowCount>1 && !confirm(ru("Кол-во отмеченных записей для востановления: ","Кіл-сть відмічених записів для відновлення: ")+t.rowCount+"\n"+ru("Продолжить?","Продовжити?")))
			return false;
		setProgressRange(i, t.rowCount);
		for(; !t.IsEOF(); t.MoveNext())
		{
			oObj.clear();
			setProgressPos(i, ru("Востановление: ","Відновлення: ")+i+"/"+t.rowCount);
			//oObj.clear();
			oObj.fromArchive(t.getValue("fid_doc"),t.getValue("fwid"));
			if(isCl)
			{
				oObj.save("EDIT");
				oObj.saveRows();
				oObj.saveExtToDB();
			}
			else if(isPrik)
				oObj.save("EDIT",false,extPar.dat1);
			else
				oObj.save(true,"EDIT");
			i++;
		}
		setProgressPos(0);
		alert(ru("Кол-во востановленных объектов: ","Кіл-сть відновлених об'єктів: ")+t.rowCount);
		t.close();
	}
	else if (nID == "COMPARE")
	{
		if (this.dataSrc.getSelectedCount() != 2)
		{
			alert(UR("Потрібно вибрати два записи|Необходимо выбрать две записи"));
			return;
		}
		var obj1 = null;
		var obj2 = null;
		var selIDList = this.dataSrc.getSelectedIDs();
		
		var oSnap1 = getSnap("SELECT fdoc,fnop,fwid,fid_doc FROM ^archive"
						   + " WHERE fwid=" + sqlTo(selIDList[0]));
		var oSnap2 = getSnap("SELECT fdoc,fnop,fwid,fid_doc FROM ^archive"
						   + " WHERE fwid=" + sqlTo(selIDList[1]));
		
		objClassId = String(oSnap1[0]);
		if (objClassId.startsWith("CLS."))
		{
			include ("Objects/DpClEx.js")
			obj1 = new DpClEx(objClassId.substr(4),oSnap1[1]);
			obj2 = new DpClEx(objClassId.substr(4),oSnap2[1]);
		}
		else if(objClassId.startsWith("_"))
		{
			include("prik/DpPrik.js");
			obj1 = new DpPrik(objClassId,oSnap1[1]);
			obj2 = new DpPrik(objClassId,oSnap2[1]);
		}
		else
		{
			include ("doc/DpDoc.js")
			obj1 = new DpDoc(objClassId,oSnap1[1]);
			obj2 = new DpDoc(objClassId,oSnap2[1]);
		}
		
		if (obj1.fromArchive(oSnap1[3],oSnap1[2]) == null
			||obj2.fromArchive(oSnap2[3],oSnap2[2]) == null)
		{
			alert(UR("Не можу загрузити об'єкт з архіву|Не могу загрузить объект из архива"));
			return;
		}
		
		var lastSnap = getSnap("SELECT MAX(fwid) FROM ^archive"
							 + " WHERE " + sWhere);
		var oPar = new Object();
		oPar.obj1 = obj1;
		oPar.obj2 = obj2;
		oPar.canWriteLeft = false;
		oPar.canWriteRight = false;
		if (lastSnap != null && lastSnap[0] == oSnap1[2])
			oPar.canWriteLeft = true;
		if (lastSnap != null && lastSnap[0] == oSnap2[2])
			oPar.canWriteRight = true;
		showWindow("e_object_compare.xml",SW_NOMODAL,oPar);
	}
	else if (nID == "VIEW_OBJ")
	{
		objClassId = String(this.tbl.getValue("fdoc"));
		var oObj;

		if (objClassId.startsWith("CLS."))
		{
			include ("Objects/DpClEx.js")
			oObj = new DpClEx(objClassId.substr(4), this.tbl.getValue("fnop"));
		}
		else if(objClassId.startsWith("_"))
		{
			include("prik/DpPrik.js");
			oObj = new DpPrik(objClassId,this.tbl.getValue("fnop"));
		}
		else
		{
			include ("doc/DpDoc.js")
			oObj = new DpDoc(objClassId, this.tbl.getValue("fnop"));
		}
		
		oObj.fromArchive(this.tbl.getValue("fid_doc"),
					 this.tbl.getValue("fwid"));
	
		var oPar = new Object();
		oPar.obj = oObj;
		
		showWindow("e_object.xml",SW_NOMODAL,oPar);
	}
}

function listDelAcc()
{
	return false;
}

include("sys\\DpList.js");