function listLoad()
{
	this.title = "Історія формування проведень|История формирования проводок";
	SASH.setWeights(new Array(100,300));
	this.xmlGridFile = "l_archiveProv.xml";
	gridProv.setXMLFile("l_provfromarch.xml");
	var tbl = OpenTable("xml", "NOFILE");
	tbl.tie("cl_valut", "xclv", "FKod", "Fval");
	tbl.tie("cl_valut", "xclvs", "FKod", "Fvalspr");
	tbl.tie("sch_zag", "zag", "Fwid", "Fid_doc");
	tbl.clTie("org0", "="+ getPar("CODMYORG") +",FORG0");
	gridProv.setTable(tbl);
	gridProv.build();
	this.selRecordHandler = selRecordHandler;
	grid.setSelHandler(this, "selRecordHandler");
	grid.setWhen(this, "selRecordHandler");
}

function listSrc()
{
	var arrOrder = new Array("FMDATE DESC");
	sWhere = " 1=1";
	if(extPar)
	{
		sWhere += " AND fid_doc=" + sqlTo(extPar.fid);		
	}
	
	this.qrySet("From", "^provarchive",
				"Where", sWhere,
				"Order", arrOrder
				);
	
}

function listMenuInit()
{
	if (this.tbl.IsRecord())
	{
		this.dataSrc.AddMenuItem("UNERASE","Відновити|Восстановить");		
	}
}

function listMenuRun(nID)
{
	if(nID == "UNERASE")
	{
		var id = Number(list.tbl.getValue("fid_doc"));
		var is = list.tbl.getValue("fdata");
		var xmlDoc = null;
		if(is != null)
		{
			if(typeOf(is) == "String")
				xmlDoc = lpProxy.getXMLFromStr(is);
			else
				xmlDoc = lpProxy.getXMLFromReader(is);
		}
		if(xmlDoc == null)
		{
			alert("Не удалось сформировать xml по идентификатору "+id,2);
			return false;
		}
		
		var tbl = OpenTable("xml", "NOFILE");
		tbl.open(xmlDoc.getDocumentElement(), true);
		var tblName = "tmp_tschet";
		CreateTable(tblName, "TAGSCHET");
		xmlTableToDBTable(tbl, tblName);
		
		//удаляем только при наличии идентификатора, т.к. если идентификатор отсутствовал, то улетали все зарплатные проводки
		if(id)
		{
			ExecuteSQL("DELETE FROM ^schet WHERE fdoc <> '_R' and fid_doc = " + sqlTo(id));			
			
			ExecuteSQL(
				"INSERT INTO ^schet(" + GetPatternIntersection("TAGSCHET", "TAGSCHET") + ")"
				+ " SELECT " + GetPatternIntersection("TAGSCHET", "TAGSCHET")
				+ " FROM " + tblName
				);
			
			provToArhive("R",id,false);
			alert(ru("Кол-во відновленних проведень: ","Кіл-сть відновлених проводок: ")+tbl.recordCount);
		}
		else
			alert(ru("Не возможно востановить проводки, т.к. отсутствует идентификатор.",
					"Не можливо відновити проводки, тому що відсутній ідентифікатор."),1);
		tbl.close();
	}
}

function listDelAcc()
{
	return false;
}

function selRecordHandler()
{
	if (!list || !list.tbl || typeof(list.tbl) == "undefined" || list.tbl.isBOF() || list.tbl.isEOF())
	{
		return;
	}
	
	var is = list.tbl.getValue("fdata");
	var xmlDoc = null;
	if(is != null)
	{
		if(typeOf(is) == "String")
			xmlDoc = lpProxy.getXMLFromStr(is);
		else
			xmlDoc = lpProxy.getXMLFromReader(is);
	}
	if(xmlDoc != null)
		gridProv.getTable().open(xmlDoc.getDocumentElement(), true);
	else
		gridProv.getTable().open("NOFILE", null);
	
	gridProv.refresh();
		
	
}

include("sys\\DpList.js");

