//список дочерних больничных
include("Objects/DpGrid.js");
var sWhere;

function listLoad()
{
	if(extPar.IDs)
		this.title = UR("Список дочірніх лікарняних|Список дочерних больничных");
	else
		return false;
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
}

function listSrc()
{
	if(typeOf(extPar.IDs)=="object")
		this.title = UR("Список дочірніх лікарняних по відміченим наказам|Список дочерних больничных по отмеченным приказам");
	else
		this.title = UR("Список дочірніх лікарняних|Список дочерних больничных");
	sWhere = extPar.IDs?"p.Fwid_prik in ("+extPar.IDs+")":" 1<>1 ";	
	this.qrySet("Fields", "p.*, w.Fwid_cl, w.Fid as Fid_wp, c.Fcod", 
				"From", "^prk_all AS p INNER JOIN ^work_pers AS w ON p.Fwid_wp=w.Fwid"
						+ " INNER JOIN ^clrelclcl AS c ON w.Fwid_cl=c.Fwid_cl",
				"Where", sWhere,
				"Order", "c.Fcod, p.Fbdat");
	this.subTie("cl_prik", "prk", "Fvid", "Fvid_prk");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
//	oGrid.defCond("=^Ftxtpers==null", "err")
//	oGrid.color(17, "err");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fcod", "Таб №|Таб №", 4);
		FieldEx("Fid_wp", "Код ШР|Код ШР", 2);
		FieldEx("=getSmallFIO(^cl.Ftxt)", "ПІБ|ФИО", 15);
		FieldEx("=Math.floor(^Fsum/1000)", "Днiв до сплати|Дней к опл.", 4);
		FieldEx("=^Fsum-Math.floor(^Fsum/1000)*1000", "Годин до сплати|Часов к опл.", 5);
		FieldEx("Fproc", "% сплати|% оплаты", 4);
		FieldEx("Fbdat", "Дата поч.|Дата нач.", 8);
		FieldEx("Fedat", "Дата зак.|Дата конца", 8);
		FieldEx("Fnum", "№ лік.\nлиста|№ больн.\nлиста", 4);
		FieldEx("Fdat_bol", "1-й день непрац.|1-й день нетруд.", 8);
		FieldEx("Fshpz", "ШВЗ|ШПЗ", 10);
		with(group("Наказ|Приказ"))
		{
			FieldEx("Fvid_prk", "Код", 4);
			FieldEx("prk.Fnazv", "Назва|Название", 15);
		}
		FieldEx("Fwid_prik", "ID батька|ID родителя", 6);
	}
	oGrid.build();   		
}

function listMenuInit(ds)
{
	if(this.tbl.isEmpty())
		return;
	if(getSystem()=="ZRP")
	{
		ds.AddMenuItem("FIND_PRIK","Знайти наказ|Найти приказ");
		ds.AddMenuItem("FIND_ALLPRIK","Знайти всі накази даного виду|Найти все приказы данного вида");
	}
}

function listMenuRun(sID)
{
	switch(sID)
	{
		case "FIND_PRIK":
		case "FIND_ALLPRIK":
			if(sID=="FIND_PRIK" && !this.tbl.getValue("Fwid"))
			{
				WAIT(ru("Не определен идентификатор записи приказа!","Не визначений ідентифікатор запису наказу!"));
				return false;
			}
			var par = new Object();
			var snap = getSnap("select Fvid_prk from ^prk_all where Fwid="+this.tbl.getValue("Fwid"));
			if(!snap)
			{
				alert(ru("Не возможно найти приказ с идентификатором ","Не можливо знайти наказ з ідентифікатором ")+this.tbl.getValue("Fwid"))
				return false;
			}
			var t = OpenTable("select * from ^cl_prik where Fvid="+snap[0]);
			if(!t.rowCount)
			{
				WAIT(ru("Не возможно определить приказ!","Не можливо визначити наказ!"));
				return false;
			}
			par.fnazv = t.getValue("Fnazv");
			par.is_clnd = toScrObj(t.getValue("Fis_clnd"));
			par.fvid = Number(t.getValue("fvid"));
			nzvproc  = t.getValue("fproc");
			par.fz2 = t.getValue("fz2");
			par.fz6 = t.getValue("fz6");
			par.priklbl = par.edit = t.getValue("fedit").toUpperCase();
			par.GLOBAL_TABLE = "^PRK_ALL";
			par.dat1 = firstDayMonth(this.tbl.getValue("Fbdat"));
			par.dat2 = lastDayMonth(this.tbl.getValue("Fedat"));
			par.notLoad = true;
			if(sID=="FIND_PRIK")
			{
				par.fid_prk = this.tbl.getValue("Fwid");
				par.title = ru("Приказ на ","Наказ на ")+getSmallFIO(getTxtFromID(this.tbl.getValue("Ftabn_id")))+" - "+par.fnazv;
			}
			t.close();
			var xmlPrik = new DpXMLDOMDocument();
			if (xmlPrik.load(rootDirectory() + "prik/" + par.edit + "/prik.xml", false))
			{
				var xmlEl = xmlPrik.getDocumentElement();
				loadSettingToObj(par, xmlEl, new Array("list"));
				if (!spLoad(par, "list"))
					showWindow("l_prkekz.xml", SW_NOMODAL, par);
			}
			else
				showWindow("l_prkekz.xml", SW_NOMODAL, par);
		break;
	}
}

function filterMode(s)
{
	if(s == "DEL")
		return false;
	else
		return true;		
}

function reloadList()
{
	list.tbl.clearQuery();
	list.tblSrc[list.tblSrcNo] = "";
	list.reLoad();
}

function onMessage(sType, oPar)
{
	extPar = oPar;	
	list.isSetFocusOnGrid = false;
	grid.DeletePages();
	listDpGrid();
	list.reLoad();
	list.isSetFocusOnGrid = true;
}


include("sys/DpList.js");