function listDpGrid()
{
	include("Objects//DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	with (oGrid.page())
	{
		fieldEx("fline", "№ рядка|№ рядка", 10);
		fieldEx("fnazv1", "Рядок балансу|Рядка баланса", 20);
	}	
	oGrid.build();
}

function listLoad()
{
	this.title = "Редагування форми звітного балансу|Редатирование формы отчетного баланса";
	this.subUnLoad = exit;
}

function listSrc()
{
	this.qrySet("From", "^BALANS", "Order", new Array("fline"));
}

function listMenuInit()
{
	with (this.dataSrc)
	{
		 AddMenuItem("ADD", "Додавання текстової частини|Добавление текстовой части");
         if (!(this.tbl.IsEOF() || this.tbl.IsBOF()))
           {
         		AddMenuItem("VSCH","Включення рахунків до рядків|Включение счетов в строки");
              	AddMenuItem("OBN","Поновити номера рядків(х10)|Обновить номера строк(х10)");
              	AddMenuItem("COPY", "Копіювання текстової частини|Копирование текстовой части");
          		AddMenuItem("EDIT", "Редагування текстової частини|Редактирование текстовой части");       		
          		if(!CanDeleteRecord(this.tbl))
            		this.accDel = new Function("return true");
            	else
            		this.accDel = new Function("return false");
          }	
	}
}

function listMenuRun(ID)
{
	var par = new Object();
	par.nLine = toScrObj(this.tbl.getValue("FLINE"));
	
	switch(ID)
	{
   		case "VSCH":
        	showWindow("l_bsch2.js",SW_NOMODAL,par);
        	break;
   		case "OBN":
        	PerNum();
			break;
	   case "EDIT":
	   case "ADD":
	   case "COPY":
			par.m_pTable = this.tbl;
			par.mode = ID;
			par.fwid = this.tbl.getValue("fwid");
			showWindow("e_blns.xml",SW_MODAL,par);
			this.tbl.Requery();
			break;
	}
}

//-приведение в соответсвие связаной с таблицей BALANS таблицы BALANS_U ---
function exit()
{
    var strSQL = "DELETE FROM ^BALANS_U WHERE NOT (FIDS IN (SELECT B.FWID FROM ^BALANS B))";
    ExecuteSQL(strSQL);

	if (SQL) 
	{
		if (SUBD == ORACLE)
		{
			strSQL = "UPDATE ^BALANS_U " +
					 "SET FLINE = (SELECT  " +
					 "FLINE FROM ^BALANS " +
					 "WHERE ROWNUM = 1 AND ^BALANS_U.FIDS = ^BALANS.FWID) "+
					 "WHERE EXISTS (SELECT  " +
					 "FLINE FROM ^BALANS " +
					 "WHERE ROWNUM = 1 AND ^BALANS_U.FIDS = ^BALANS.FWID)";
		}
		else
		{
			strSQL = "UPDATE ^BALANS_U SET FLINE = (SELECT MAX(FLINE) FROM ^BALANS " +
					 "WHERE ^BALANS_U.FIDS = ^BALANS.FWID) " +
					 "WHERE EXISTS (SELECT MAX(FLINE) FROM ^BALANS " +
					 "WHERE ^BALANS_U.FIDS = ^BALANS.FWID)";
		}
	}
	else
		strSQL = "UPDATE ^BALANS_U INNER JOIN ^BALANS " +
	 			 "ON ^BALANS_U.FIDS=^BALANS.FWID " +
				 "SET ^BALANS_U.FLINE=^BALANS.FLINE";
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO ^balans_u (fids, fline, fkd_str) " +
			 "SELECT a.fwid AS fids, a.fline AS fline, a.fkd_str AS fkd_str " +
			 "FROM ^BALANS a WHERE NOT (a.fwid IN (SELECT b.fids FROM ^balans_u b))"
    ExecuteSQL(strSQL);
     
    var doptab = OpenTable("s", "SELECT fwid, fids, fsch, fsta, fsub FROM ^balans_u WHERE fwid is null");
   	if (!doptab.IsEmpty)
   	{ 
   		doptab.MoveFirst();  	
   		while (!doptab.IsEOF())
   		{   		
   			ExecuteSQL("UPDATE ^balans_u SET fwid=" + sqlTo(GetUID()) + 
   				" WHERE fids=" + sqlTo(doptab.getValue("fids")) +
	   			" AND fsch=" + sqlTo(doptab.getValue("fsch")) + 
	   			" AND fsta=" + sqlTo(doptab.getValue("fsta")) +
	   		   	" AND fsub=" + sqlTo(doptab.getValue("fsub")));
			doptab.MoveNext();
		}
	}
	doptab.Close(); 
}
//------------------------------------------------------------------


//--перенумерация строк баланса------------------------------
var dopzm2 = true;

function PerNum()
{
 	if (IsTable("DOP_LINE") && dopzm2)
         DropTable("DOP_LINE");
	var strSQL;
	if (dopzm2)
	{
    	strSQL = "SELECT fline, fline AS fdopf, fwid INTO dop_line FROM ^balans";
        ExecuteSQL(strSQL);
        strSQL = "CREATE INDEX fdopf ON dop_line(fdopf)";
        ExecuteSQL(strSQL);
        dopzm2 = false;
    }
	else
    {       
       strSQL = "DELETE FROM dop_line WHERE NOT (fwid IN (SELECT b.fwid FROM ^balans b))";
       ExecuteSQL(strSQL);
       strSQL = "INSERT INTO dop_line (fwid, fline, fdopf) " +
              	"SELECT a.fwid AS fwid,a.fline AS fline, a.fline AS fdopf " +
              	"FROM ^balans a WHERE NOT (a.fwid IN (SELECT b.fwid FROM dop_line b))";
       ExecuteSQL(strSQL);

		if (SQL)
		{
			if (SUBD == ORACLE)
			{
				strSQL = "UPDATE DOP_LINE " + 
					"SET FDOPF = (SELECT  " +
					"FLINE FROM ^BALANS " +
					"WHERE ROWNUM = 1 AND ^BALANS.FWID = DOP_LINE.FWID) " +
					"WHERE EXISTS (SELECT  " +
					"FLINE FROM ^BALANS " +
					"WHERE ROWNUM = 1 AND ^BALANS.FWID = DOP_LINE.FWID)";
			}
			else
			{
				strSQL = "UPDATE dop_line SET fdopf = " +
						 "(SELECT MAX(fline) FROM ^balans WHERE ^balans.fwid = dop_line.fwid) " +
						 "WHERE EXISTS (SELECT MAX(FLINE) FROM ^BALANS WHERE ^BALANS.FWID = DOP_LINE.FWID)";
			}
		}
		else
			strSQL = "UPDATE DOP_LINE " + 
					"INNER JOIN ^BALANS " +
					"ON ^BALANS.FWID = DOP_LINE.FWID " +
					"SET DOP_LINE.FDOPF = ^BALANS.FLINE";
       ExecuteSQL(strSQL);
    }

	var tab=OpenTable("s","SELECT * FROM dop_line ORDER BY fdopf");
	tab.MoveFirst();
	var i=0;
    while (!tab.IsEOF())
    {
      i += 10;
      ExecuteSQL("UPDATE DOP_LINE SET fline = " + sqlTo(i) + " WHERE fwid= " + tab.getValue("fwid")); 
      tab.MoveNext();    
    }    
    tab.Close();

	if (SQL)
	{
		if (SUBD == ORACLE)
		{		
			strSQL = "UPDATE ^BALANS " +
					"SET FLINE = (SELECT  " +
				"FLINE FROM DOP_LINE " +
				"WHERE ROWNUM = 1 AND ^BALANS.FWID = DOP_LINE.FWID) " +
				"WHERE EXISTS (SELECT  " +
				"FLINE FROM DOP_LINE " +
				"WHERE ROWNUM = 1 AND ^BALANS.FWID = DOP_LINE.FWID)";
		}
		else
		{
			strSQL = "UPDATE ^balans SET fline = " +
					 "(SELECT MAX(fline) FROM dop_line WHERE ^balans.fwid = dop_line.fwid) " +
					 "WHERE EXISTS (SELECT MAX(fline) FROM dop_line WHERE ^balans.fwid = dop_line.fwid)";
		}
	}
	else
		strSQL = "UPDATE ^BALANS " +
		"INNER JOIN DOP_LINE " +
		"ON ^BALANS.FWID = DOP_LINE.FWID " +
		"SET ^BALANS.FLINE = DOP_LINE.FLINE";
    ExecuteSQL(strSQL);
}


include("sys\\DpList.js");