// JScript source code
include("sys/DpList.js");
include("Objects/DpBProcess.js");
include("gridedit.js");

var currBPM = ""
function listLoad()
{
	with( this )
	{
		title = "Бизнес процессы";
		editTask = "e_list.xml";
		printLabel = "BPMKEKZ";		
	}
	
	this.buildBPMGrid = buildBPMGrid;
	this.onSelBPM = onSelBPM;
	//setSelHandler
	this.buildBPMGrid();
	
	grid.addImage(1,lpProxy.getAppPlugLoc() + "icons/bpmn/start16.gif");
	grid.addImage(2,lpProxy.getAppPlugLoc() + "icons/bpmn/stop16.gif");	
	grid.setImageField("FSTATE");
}

function listSrc()
{
	var sWhere = " FCLASS = " + sqlTo(currBPM)
	
	this.qrySet	(
					"From", "^BPM_EKZ",
					"Where", sWhere
				);
}

function onEditObject(mnuID)
{
	var oProcess = new DpBProcess(currBPM);
	if (mnuID != "ADD")
	{
		oProcess.load(this.tbl.getRowID());
	}
	
	var isEdit = oProcess.edit();
	
	if (isEdit)
		oProcess.save();
	
	return isEdit;
	
}

function listMenuInit()
{
	grid.AddMenuItem("RUN", "Запустити|Запустить");
	grid.AddMenuItem("EXECUTE", "Виконати|Выполнить");
	grid.AddMenuItem("SHOWSTATE", "Показати виконання|Показать выполнение");
}

function listMenuRun(ID)
{
	if (ID == "RUN")
	{
		var oProcess = new DpBProcess(currBPM);
		oProcess.load(this.tbl.getRowID());
		oProcess.start();
		
		this.tbl.Requery();
		this.grid.RefreshGrid();
		
		
	}
	if (ID == "EXECUTE")
	{
		var oProcess = new DpBProcess(currBPM);
		oProcess.load(this.tbl.getRowID());
		oProcess.execute();		
		this.tbl.Requery();
		this.grid.RefreshGrid();
	}
	if (ID == "SHOWSTATE")
	{
		var oProcess = new DpBProcess(currBPM);
		oProcess.load(this.tbl.getRowID());
		oProcess.showState();		
		
	}
}

function filterMode(s)
{
	return true; //inList(s, "ADD", "EDIT");		
}

function buildBPMGrid()
{
	include("Objects/DpBProcess.js");
	tblBPM = createObjectTable();
	tblBPM.setIdFld("FWID"); 
	var sFile = rootDirectoryEx()+"scripts/BPM/";
	
	var file = new DpFile(sFile);
	
	if (!file.exists()) return;
	
	if(file.isDirectory())
	{
		var files = file.listFiles();		
				
		for(var i=0; i<files.length; i++)
		{
			var bpFile = files[i];
			if(!bpFile.isDirectory() || bpFile.isHidden())
				continue;
			
			var bpmnFile = bpFile.getAbsolutePath() + "/" + bpFile.getName() + ".dpbpmn";
			if (!isFile(bpmnFile))
				continue;
			
			var sBPID = String(bpFile.getName());
			var doc = new DpBProcess(sBPID);
			
			tblBPM.AddNew();
			tblBPM.setValue("FWID", sBPID);
			tblBPM.setValue("FTXT", "");
			//var text = doc.getRem();			
			tblBPM.Update();
						

		}
	}
	tblBPM.moveFirst(); 
	currBPM = String(tblBPM.getValue("FWID"));
	gridbpm.setTable(tblBPM);
	gridbpm._build();
	gridbpm.setSelHandler(this, "onSelBPM");
}

function onSelBPM()
{
	currBPM = String(gridbpm.getTable().getValue("FWID"))
	
	list.subSrc();
	list.tblInit();
}

function getBProcessState(n)
{
	switch(n)
	{
	case 1:
		return "Запущен";
	case 2:
		return "Завершен";
	}		
	return "";
	
}