include("Objects\\DpEval.js");
include("Objects\\DpGetDat.js");

var sTblName = "TMP_BPN";

function listTitle()
{
	return ru("Книга покупок", "Книга придбання");
}

function listLoad()
{			
	var gd = new DpGetDat("dD");
	if(gd.escape)
		return false;

	tblHnn = OpenTable("s", 
				"SELECT *"
			+ " FROM ^hnn h"	
			+ " WHERE h.fdoc_dat BETWEEN " + sqlTo(gd.dat1) + " AND " + sqlTo(gd.dat2)
				+ sqlw0And("h.fdoc=", extPar.fdoc)
				+ sqlw0And("h.fnop=", extPar.fnop)+" order by Fdoc_dat"
		);
	
	tblTune = OpenTable("s", "tune_bpn");
	//if (SQL)
	//	tblTune.index = "fdoc,fnop";
	
	CreateTable("tmp_bpn", "bpn", "*");	
	var tblBpn = OpenTable("s", "tmp_bpn");
	var m = new Object;
	var nn = 0;
	var oEval = new DpEval();
	//oEval.setTable(tblHnn);
	var hDoc, hNop;
	var findDoc, findNop;
	
	for(; !tblHnn.IsEOF(); tblHnn.MoveNext())
	{		
		hDoc = tblHnn.getValue("fdoc");
		hNop = tblHnn.getValue("fnop");
		findDoc = tblTune.FindFirst("Fdoc="+ sqlTo(hDoc));
		findNop = tblTune.FindFirst("Fnop="+ sqlTo(hNop));
		
		if(findDoc && findNop)
		{
			var tHnn1 = OpenTable("m",
					"SELECT *"
				+ " FROM ^hnn"
				+ " WHERE fwid=" + sqlTo(tblHnn.getValue("Fwid"))
				+ " ORDER BY fdoc_dat, fwid"
				);
			
			tHnn1.ExtTie("H", "NN", tblHnn.getValue("fnop"));
			oEval.setTable(tHnn1);
		
			m.FDOC = tblHnn.getValue("fdoc");
			m.FNOP = tblHnn.getValue("fnop");
			oEval.setDoc(m.FDOC, m.FNOP);
			
			m.FDOC_DAT = tblHnn.getValue("fdoc_dat");
			m.FID_DOC = tblHnn.getValue("fwid");
			m.FORG = tblHnn.getValue("forg");
			m.F_01 = ++nn;
			m.F_02 = oEval.tEval("date", tblTune.getValue("F_02"));
			m.F_03 = oEval.tEval("str", tblTune.getValue("F_03"));
			m.F_04 = oEval.tEval("str", tblTune.getValue("F_04"));
			m.F_05 = oEval.tEval("str", tblTune.getValue("F_05"));
			m.F_06 = oEval.tEval("num", tblTune.getValue("F_06"));
			m.F_07 = oEval.tEval("num", tblTune.getValue("F_07"));
			m.F_08 = oEval.tEval("num", tblTune.getValue("F_08"));
			m.F_09 = oEval.tEval("num", tblTune.getValue("F_09"));
			m.F_10 = oEval.tEval("num", tblTune.getValue("F_10"));
			m.F_11 = oEval.tEval("num", tblTune.getValue("F_11"));
			m.F_12 = oEval.tEval("num", tblTune.getValue("F_12"));
			m.F_13 = oEval.tEval("num", tblTune.getValue("F_13"));
			m.F_14 = oEval.tEval("num", tblTune.getValue("F_14"));
			m.F_15 = oEval.tEval("num", tblTune.getValue("F_15"));
			m.F_16 = oEval.tEval("num", tblTune.getValue("F_16"));
			m.F_17 = oEval.tEval("num", tblTune.getValue("F_17"));
			m.F_18 = oEval.tEval("num", tblTune.getValue("F_18"));
			m.F_19 = oEval.tEval("num", tblTune.getValue("F_19"));
			m.F_20 = oEval.tEval("num", tblTune.getValue("F_20"));
			m.F_21 = oEval.tEval("num", tblTune.getValue("F_21"));
			m.F_22 = oEval.tEval("num", tblTune.getValue("F_22"));
			m.F_23 = oEval.tEval("num", tblTune.getValue("F_23"));
			m.F_24 = oEval.tEval("num", tblTune.getValue("F_24"));
			m.F_25 = oEval.tEval("num", tblTune.getValue("F_25"));
			m.F_26 = oEval.tEval("str", tblTune.getValue("F_26"));
			m.F_27 = oEval.tEval("date", tblTune.getValue("F_27"));
			m.F_28 = oEval.tEval("date", tblTune.getValue("F_28"));
			m.F_29 = oEval.tEval("date", tblTune.getValue("F_29"));
			m.F_30 = oEval.tEval("date", tblTune.getValue("F_30"));
			m.F_31 = oEval.tEval("date", tblTune.getValue("F_31"));
			append("N", tblBpn, m);	
		}
		else
		{
			alert(ru("Не настроена книга покупок для полученных налоговых накладных",
					 "Не налагоджена книга придбання для отриманих податкових накладних")
				+ "\n Папка " + tblHnn.getValue("fdoc") + " " + tblHnn.getValue("fnop")
				);
			break;
		}
	}
	
	ExecuteSQL(
		"INSERT INTO tmp_bpn("
			+ "f_04,f_06,f_07,f_08,f_09,f_10,"
			+ "f_11,f_12,f_13,f_14,f_15,f_16,"
			+ "f_17,f_18,f_19,f_20,f_21,f_22,f_23,f_24,f_25)"
		+ " SELECT 'ВСЬОГО' AS f_04"
			+ ", SUM(a.f_06) AS f_06"
			+ ", SUM(a.f_07) AS f_07"
			+ ", SUM(a.f_08) AS f_08"
			+ ", SUM(a.f_09) AS f_09"
			+ ", SUM(a.f_10) AS f_10"
			+ ", SUM(a.f_11) AS f_11"
			+ ", SUM(a.f_12) AS f_12"
			+ ", SUM(a.f_13) AS f_13"
			+ ", SUM(a.f_14) AS f_14"
			+ ", SUM(a.f_15) AS f_15"
			+ ", SUM(a.f_16) AS f_16"
			+ ", SUM(a.f_17) AS f_17"
			+ ", SUM(a.f_18) AS f_18"
			+ ", SUM(a.f_19) AS f_19"
			+ ", SUM(a.f_20) AS f_20"
			+ ", SUM(a.f_21) AS f_21"
			+ ", SUM(a.f_22) AS f_22"
			+ ", SUM(a.f_23) AS f_23"
			+ ", SUM(a.f_24) AS f_24"
			+ ", SUM(a.f_25) AS f_25"
		+ " FROM tmp_bpn a"
		);	
}

function listSrc()
{			
	this.qrySet("From", sTblName /*, "Order", IIF("f_01=0", "99999", "f_01")*/);		
}

function listDpGrid()
{
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
//		defCond("=^F_01=0", "TOT");
//		color(1, "TOT");
		with(page())
		{
			cell("F_01", "№\nп/п", 3)//.subCaption("1");
			with(group("Податкова накладна (вантажна митна декларація, чек, тощо)|"
					  +"Налоговая накладная (грузовая таможенная декларация, чек и т.п.)"))
			{
				cell("F_02", "\n\n\nДата\nотримання\n\n\n|\n\nДата получения", 12)//.subCaption("2");
				cell("F_03", "\n\n\n\nНомер\n\n\n\n", 10)//.subCaption("3");
				with(group("Постачальник|Поставщик"))
				{
					cell("FORG", "\n\n\nКод\n\n\n", 5);
					cell("F_04", "\n\n\nНазва\n\n\n|Название", 20)//.subCaption("4");
					cell("F_05", "Індиві-\nдуальний\nподатковий\nномер|Индиви-\nдуальный\nналоговый\nномер"
						, 10)//.subCaption("5");
				}
			}
			cell("F_06", "Сума\nпога-\nшеного\nподат-\nкового\nвекселя|"
						+"Сумма\nпога-\nшенного\nнало-\nгового\nвекселя", 8, "", DP_FORMAT_SUM)//.subCaption("6");
			with(group("Імпорт товарів,\nна які оформлено\nподатковий\nвексель|"
					  +"Импорт товаров,\nна которые оформлен\nналоговый\nвексель"))
			{
				cell("F_07", "Вартість\n(без ПДВ)|Стоимость\n(без НДС)", 8, "", DP_FORMAT_SUM)//.subCaption("7");
				cell("F_08", "Сума ПДВ|Сумма НДС", 8, "", DP_FORMAT_SUM)//.subCaption("8");
			}
			with(group("Роботи, отримані\nвід нерезидента|Работы, полученные\nот нерезидента"))
			{
				cell("F_09", "Вартість\n(без ПДВ)|Стоимость\n(без НДС)", 8, "", DP_FORMAT_SUM)//.subCaption("9");
				cell("F_10", "Сума ПДВ|Сумма НДС", 8, "", DP_FORMAT_SUM)//.subCaption("10");
			}
			with(group("Придбання товарів (на митній теріторії України та імпортних)|"))
			{
				cell("F_11", "Вартість\n(без ПДВ)|Стоимость\n(без НДС)", 8, "", DP_FORMAT_SUM)//.subCaption("11");
				cell("F_12", "Сума ПДВ|Сумма НДС", 8, "", DP_FORMAT_SUM)//.subCaption("12");
				with(group("з правом включення до податкового кредиту|с правом включения в налоговый кредит"))
				{
					with(group("база оподаткування|база налогообложения"))
					{
						cell("F_13", "на\nтериторії\nУкраїни|на\nтеритории\nУкраины", 8, "", DP_FORMAT_SUM)//.subCaption("13");
						cell("F_14", "імпортовані\nз оплатою\nПДВ при\nмитному\nофор-\nмленні|"
									+"импортированные\nс оплатой\nНДС при\nтаможенном\nофор-\nмлении", 8, "", DP_FORMAT_SUM)//.subCaption("14");
						cell("F_15", "вексель,\nпогашений\nу поперед-\nньому\nперіоді|"
								 	+"вексель,\nпогашенный\nв предыду-\nщем\nпериоде", 8, "", DP_FORMAT_SUM)//.subCaption("15");
						cell("F_16", "корегу-\nвання\nвартості|коректи-\nровка\nстоимости", 8, "", DP_FORMAT_SUM)//.subCaption("16");
					}
					with(group("ПДВ|НДС"))
					{
						cell("F_17", "за ставкою\n20%\nдо бази\nоподаткування|"
									+"по ставке\n20%\nв базу\nналогообложения", 8, "", DP_FORMAT_SUM)//.subCaption("17");
					}
				}
				with(group("без права включення до податкового кредиту|без права включения в налоговый кредит"))
				{
					with(group("товари, що відносяться до складу валових витрат та підлягають амортизації|"
							  +"товары, относящиеся к составу валовых затрат и подлежат аммортизации"))
					{
						with(group("на митній території України|на таможенной територии Украины"))
						{
							with(group())
							{
								cell("F_18", "з ПДВ для\nздійснення\nнеоподаткова-\nних операцій\n(п.3.2,ст.3,ст.5)|"
											+"с НДС для\nпроведения\nне облагаемых\nналогом\nопераций\n(п.3.2,ст.3,ст.5)"
											, 9, "", DP_FORMAT_SUM)//.subCaption("18");
								with(group("без ПДВ|без НДС"))
								{	
									cell("F_19", "для здійснення\nоподатковуваних\nоперацій|"
												+"для проведения\nоблагаемых\nналогом\nопераций", 9, "", DP_FORMAT_SUM)//.subCaption("19");
									cell("F_20", "для здійснення\nнеоподатковува-\nних операцій\n(п.3.2, ст.3, ст.5)|"
												+"для\nпроведения\nне облагаемых\nналогом\nопераций\n(п.3.2,ст.3,ст.5)"
												, 9, "", DP_FORMAT_SUM)//.subCaption("20");
								}
							}
						}
						with(group("імпортні"))
						{
							cell("F_21", "ПДВ спла-\nчено при\nмитному\nофор-\nмленні|"
										+"НДС опла-\nчено при\nтаможенном\nофор-\nмленнии", 8, "", DP_FORMAT_SUM)//.subCaption("21");
							cell("F_22", "ПДВ\nсплачено\nвекселем|НДС\nоплачено\nвекселем", 8, "", DP_FORMAT_SUM)//.subCaption("22");
							cell("F_23", "звільнено\nвід\nоподаткування|снято\nот\nналогообложения", 8, "", DP_FORMAT_SUM)//.subCaption("23");
						}
						with(group("товари, що не відносяться\nдо складу валових витрат\nта не підлягають амортизації|"
								  +"товары, не относящиеся\nк составу валовых затрат\nи не подежащие амортизации"))
						{
							cell("F_24", "на митній\nтериторії\nУкраїни|на таможенной\nтеритории\nУкраины", 9, "", DP_FORMAT_SUM)//.subCaption("24");
							cell("F_25", "імпорт-\nовані|импортир-\nованные", 9, "", DP_FORMAT_SUM)//.subCaption("25");
						}
					}
				}
			}
			with(group("Проведення рахунків за придбані товари|Проведение счетов за преобретенные товары"))
			{
				with(group("на митній\nтериторії України|на таможенной\nтеритории\nУкраины"))
				{
					cell("F_26", "форма оплати|форма оплаты", 10)//.subCaption("26");
					cell("F_27", "Дата\nоплати|Дата\nоплаты", 8)//.subCaption("27");
				}
				with(group("імпортовані (дані про оплату ПДВ)|импортированные (данные об оплате НДС)"))
				{
					cell("F_28", "дата\nоплати\nз р/р|дата\nоплаты\nс р/р", 8)//.subCaption("28");
					with(group("оформлення оплати векселем:|оформление оплаты векселем:"))
					{
						cell("F_29", "дата\nвидачі\nвекселя|дата\nвыдачи\nвекселя", 8)//.subCaption("29");
						with(group("дата\nпогашення\nвекселя|дата\nпогашения\nвекселя"))
						{
							cell("F_30", "вказана\nу\nвекселі|указана\nв\nвекселе", 8)//.subCaption("30");
							cell("F_31", "фактична|фактическая", 8)//.subCaption("31");
						}
					}
				}
			}
		}
		build();
	}
}

include("sys\\DpList.js")	