include("Objects\\DpGetDat.js");
include("doc\\dpDocPtn.js");
include("objects\\DpGrid.js");
include("sys\\udfs.js");

//__CreateGrid();
var gr;

var ds,t;
var zmbDate;
var zmeDate;
var nPodr;

function listAsk()
{
	var gd=new DpGetDat(new Array("r","p0"));
	zmbDate = gd.dat1;
	zmeDate = gd.dat2;
	nPodr = gd.fpodr;
	
	return gd;
}

function listDpGrid()
{
	with(new DpGrid("NOCREATE"))
	{
		with(page())
		{
			cell("=xcl(" + sprPodr +", ^fpodr, 'TOWN')", "Город", 7);
/*			with(group("Подразделение"))
			{
				cell("fpodr", "Код", 5);
				cell("=^PD.FTXT", "Наименование", 9);
			}
*/			
			cell("fsum_month", "Текущий месяц", 11, "", DP_FORMAT_SUM);
			cell("=^fsum_all - ^fsum_month", "За N мес", 11, "", DP_FORMAT_SUM);
			cell("fsum_all", "с начала года", 11, "", DP_FORMAT_SUM);
			cell("fesum", "Остаток", 11, "", DP_FORMAT_SUM);
		}
		build();
	}
}

function listTitle()
{
	return "Продажи по маг. по городам с нараст. итогом";
}

function listSrc()
{
	var D1 = new Date(firstDayMonth(zmeDate));
	var cWhere;
	var cWhere2;	
	if(zmbDate && zmeDate)
	{
		cWhere = "b.FDOC_DAT BETWEEN "
			+ sqlTo(zmbDate)+" AND "+sqlTo(zmeDate);
		cWhere2 = "b.FDOC_DAT BETWEEN "
			+ sqlTo(D1)+" AND "+sqlTo(zmeDate);
	}
	else
	{
		cWhere = sqlCmpTrue;
	}
	cWhere += sqlw0And("b.fpodr=", nPodr);

	var tblSource = getTmpTableName();
	var tbltmp = getTmpTableName();
	
	// получаем полную сумму
	ExecuteSQL("SELECT FPODR, SUM(b.FSUM_VITORG - b.FSUM_V2POK) as fsum_all, "
		+ Convert("0","DBL") + " AS fsum_month, "
		+ Convert("0","DBL") + " AS fesum, "
		+ Convert("''", "STR", 30) + " AS FCITY "		
		+ "INTO " + tbltmp + " FROM ^HBRNK b WHERE "
			+ cWhere
		+ " group by FPODR")

	// получаем сумму по последнему месяцу
	ExecuteSQL("UPDATE " + tbltmp + 
		" SET fsum_month = "
			+ "(SELECT SUM(b.FSUM_VITORG - b.FSUM_V2POK) from ^HBRNK b " +
				" WHERE b.fpodr = " + tbltmp + ".fpodr AND " + cWhere2 + ")"
		)

	// получаем сальдо на конец
	ExecuteSQL("UPDATE " + tbltmp + 
		" SET fesum = "
			+ "(SELECT SUM(b.FBSUM + b.FSUM_POL + b.FSUM_VPOK - b.FSUM_VSKLAD - b.FSUM_REAL) from ^HBRNK b " +
				" WHERE b.fpodr = " + tbltmp + ".fpodr AND " + cWhere2 + ")"
		)
	ExecuteSQL("ALTER TABLE " + tbltmp +" ADD FWID "+ SqlType("COUNTER"));
		
	var tbl = OpenTable("SELECT * FROM " + tbltmp);
	while (!tbl.IsEOF())
	{
		m = new Object();
		m.Fwid = Number(tbl.getValue("Fwid"));
		m.FCITY = xcl(sprPodr, Number(tbl.getValue("Fpodr")), "TOWN");
	   	UpdateTable(tbltmp, m, false);
	   	
	    tbl.MoveNext();
	}
	tbl.close();
		
	// Группируем по городам
	ExecuteSQL("SELECT " + First("FPODR") + " as FPODR, SUM(fsum_all) as fsum_all, "
		+ "SUM(fsum_month) as fsum_month, "
		+ "SUM(fesum) as fesum "
		+ " INTO " + tblSource + " FROM " + tbltmp  
		+ " group by FCITY")

	ExecuteSQL("ALTER TABLE " + tblSource +" ADD FWID "+ SqlType("COUNTER"));
	this.qrySet("From", tblSource,
   				"Order", new Array("FPODR")
   				);
	// подр
	this.subTie("clrelclcl","CLRELPD","CLCOD","="+sqlTo(sprPodr)+",FPODR");
	this.subTie("cl","PD","FWID","CLRELPD.FWID_CL",null,TIE_NOSEARCH);
	
	this.printLabel = "brnk_rows"; 
}


function getTblH()
{
	var obj = new Object();
	
    obj.FD1  = zmbDate;
    obj.FD2  = zmeDate;
	obj.FCAPTION1 = "Продажи по городам с нараст. итогом" + String(nPodr == 0 ? "" : tcl("CL", "TXT", sprPodr, nPodr));
	return obj;
}

include("sys\\DpList.js");