//список кадровых приказов
include("Objects/DpGrid.js");
var sWhere;

function listLoad()
{
//	DATB.value = getPar("GLOBDAT1");
//	DATE.value = getPar("GLOBDAT2");
//	setButton(butt, reloadList);
//	setValid(TYPEPER, onChangePeriod);
	if(!extPar.fdoc)
	{
		alert(ru("Невозможно определить тип приказов!","Неможливо визначити тип наказів!"));
		return false;
	}
	if(extPar.IDs)
		this.title = UR("Список співробітників по відміченим наказам|Список сотрудников по отмеченным приказам");
	else
		return false;
		
	this.printLabel = "CDR_PRK";
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
}

function listSrc()
{
	if(typeOf(extPar.IDs)=="object")
		this.title = UR("Список співробітників по відміченим наказам|Список сотрудников по отмеченным приказам");
	else
		this.title = UR("Список співробітників|Список сотрудников");
//	var dat1 = DATB.value;
//	var dat2 = DATE.value;
	var sFrom;
	switch(extPar.fdoc)
	{
		case "CDR_IN":
			sFields = "p.Fnom_str,p.Fcod,p.Fwid_prk,p.Fdatz,f.*";
			sFrom = "^prk_in as p left join ^full_pers as f on f.fwid = p.Fwid_wp";
			this.title += UR(" на призначення| на назначение");
		break;
		case "CDR_OI":
			sFields = "p.Fnom_str,p.Fcod,p.Fwid_in,p.Fwid_out,p.Fwid_prk,p.Fdatz,f.*";
			sFrom = "^prk_outin as p left join ^full_pers as f on f.fwid = p.Fwid_in";
			this.title += UR(" на переведення| на перевод");
		break;
		case "CDR_OUT":
			sFields = "p.Fnom_str,p.Fcod,p.Fwid_prk,p.Fdays_otp,p.Fdatz,p.Freason_stcod,f.*";
			sFrom = "^prk_out as p left join ^full_pers as f on f.fwid = p.Fwid_wp";
			this.title += UR(" на звільнення| на увольнение");
		break;
		case "CDR_OTP":
			sFields = "p.*,cl.Ftxt as Ftxtpers";
			sFrom = "^prk_otp as p left join ^cl as cl on cl.Fwid = p.Fwid_cl ";
			this.title += UR(" на відпустку| на отпуск");
		break;
	}
	if(!sFrom)
	{
		alert(ru("Невозможно определить таблицу приказов!","Неможливо визначити таблицю наказів!"));
		return false;
	}
	sFields += ",c.Fdoc_num as Fnom_prk, c.Fdoc_dat as Fdat_prk"
	sFrom += " left join ^cdr_prk as c on p.Fwid_prk=c.Fwid "
	sWhere = extPar.IDs?"p.Fwid_prk in ("+extPar.IDs+")":" 1=1 ";	
	this.qrySet("Fields", sFields,
				"From", sFrom,
				"Where", sWhere,
				"Order", "Fnom_str,Fcod");
//	if(extPar.fdoc=="CDR_OTP")
//		this.clTie("otp", "=" + getPar("CODOTP") + ", Ftype");
	if(extPar.fdoc=="CDR_OUT")
	{
		//для совместимости с диллерским модулем кадрового планирования CDRP
		if(typeof const_GETPAR_DISMOTIVE != "undefined")
			var codDisMotive = getPar(const_GETPAR_DISMOTIVE);
		else
			var codDisMotive = getPar("CDRSTATUV");
		this.clTie("stat", "=" + codDisMotive + ", Freason_stcod");
	}
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	oGrid.defCond("=^Ftxtpers==null", "err")
	oGrid.color(17, "err");
	var gr = oGrid.page();
	with(gr)
	{
		FieldEx("Fnom_str", "№ п/п|№ п/п", 2);
		FieldEx("Fcod", "Таб №|Таб №", 3);
		FieldEx("=^Ftxtpers==null?UR('Запис відсутній в ШР|Запись отсутствует в ШР'):getSmallFIO(^Ftxtpers)", "ПІБ|ФИО", 15);
		switch(extPar.fdoc)
		{
			case "CDR_IN":
				FieldEx("Fbdat", "Дата прийому|Дата приема", 10);
				FieldEx("Ftxtorg", "Підрозділ|Подразделение", 15);
				FieldEx("Ftxtdol", "Посада|Должность", 15);
				FieldEx("Foklad", "Оклад|Оклад", 5);
				FieldEx("Fterm", "Випр.термін|Исп.срок", 5);
				FieldEx("Fdatz", "Дата заяви|Дата заявления", 10);
				FieldEx("Freason", "Підстава|Основание", 15, "w");
			break;
			case "CDR_OI":
				FieldEx("Fbdat", "Дата\nпереведення|Дата\nперевода", 10);
				with(group("Звідки|Откуда"))
				{	
					FieldEx("=getTxtOrg(^Fwid_out)", "Підрозділ|Подразделение", 15);
					FieldEx("=getTxtDol(^Fwid_out)", "Посада|Должность", 15);
				}
				with(group("Куди|Куда"))
				{	
					FieldEx("Ftxtorg", "Підрозділ|Подразделение", 15);
					FieldEx("Ftxtdol", "Посада|Должность", 15);
				}
				FieldEx("Fterm", "Випр.термін|Исп.срок", 5);
				FieldEx("Fdatz", "Дата заяви|Дата заявления", 10);
				FieldEx("Freason", "Підстава|Основание", 15, "w");
			break;
			case "CDR_OUT":
				FieldEx("Fedat", "Дата\nзвільнення|Дата\nувольнения", 10);
				FieldEx("Ftxtorg", "Підрозділ|Подразделение", 15);
				FieldEx("Ftxtdol", "Посада|Должность", 15);
				FieldEx("Fdays_otp", "Днів комп.\nвідпустки|Дней комп.\nотпуска", 5);
				with(group("Підстава|Основание"))
				{
					FieldEx("Fdatz", "Дата заяви|Дата заявления", 10);
					FieldEx("Freason_uv", "Загальна|Общее", 15, "w");
					with(group("Стаття|Статья"))
					{
						FieldEx("Freason_stcod", "Код", 4);
						FieldEx("stat.Ftxt", "Назва|Название", 12, "w");
					}
				}
			break;
			case "CDR_OTP":
				FieldEx("=getTxtDol(^Fwid_cl,^Fbdat,^Fedat)", "Посада|Должность", 15);
				FieldEx("Fbdat", "Дата початку|Дата начала", 10);
				FieldEx("Fedat", "Дата кінця|Дата конца", 10);
				with(group("За період|За период"))
				{
					FieldEx("=gridOtpBPeriod(^Fwid,^Fbperiod)", "Дата початку|Дата начала", 10);
					FieldEx("=gridOtpEPeriod(^Fwid,^Feperiod)", "Дата кінця|Дата конца", 10);
				}
				FieldEx("Fwrkdat", "Вийти на\nроботу|Выйти на\nработу", 10);
				FieldEx("Fdatz", "Дата\nзаяви|Дата\nзаявления", 10);
				if(getPar("SAVEOTPINZRP"))
					FieldEx("=format('Mmm yyyy',^Fdat_prik)", "Місяць\nвиплати|Месяц\nвыплаты", 10);
				FieldEx("Freason", "Підстава|Основание", 20, "w");
				with(group("Тип відпустки|Тип отпуска"))
				{
					var t = OpenTable("select * from ^nast_otp where Fvid_n>0 order by Fnom");
					for(; !t.IsEOF(); t.MoveNext())
					{
						with(group(String(t.getValue("Fnazv")+UR("(днів)|(дней)"))))
						{
							FieldEx("=gridOtpDays(^Fwid,"+t.getValue("Fwid")+")", "Заг.|Осн.", 3, "", "%10d");
							FieldEx("=gridOtpDays(^Fwid,"+t.getValue("Fwid")+",true)", "Святк.|Праздн.", 3, "", "%10d");
						}
					}
					t.close();
				}
				FieldEx("Fis_matpom", "Наявність\nматдопомоги|Наличие\nматпомощи", 5);
			break;
		}
		with(group("Наказ|Приказ"))
		{
			FieldEx("Fnom_prk", "№", 4);
			FieldEx("Fdat_prk", "Дата", 5);
			FieldEx("Fwid_prk", "ID|ID", 3);
		}
	}
	oGrid.build();   		
}

function gridOtpDays(fwid,fwid_type,isPrazdn)
{
	var res = 0;
	var snap = getSnap("select SUM(Fdays),SUM(Fpdays) from ^otp_type where Fid_doc = "+fwid+" and Fwid_type="+fwid_type);
	if(snap)
		res = (isPrazdn==true?snap[1]:snap[0]);
	return Number(res);
}

function gridOtpBPeriod(fwid,fbperiod)
{
	var res = d00;
	var snap = getSnap("select MIN(Fbperiod) from ^otp_type where Fid_doc = "+fwid);
	if(snap)
		res = snap[0];
	if(!res || differ(res,d00)==0)
		res = fbperiod;
	return res;
}

function gridOtpEPeriod(fwid,feperiod)
{
	var res = d00;
	var snap = getSnap("select MAX(Feperiod) from ^otp_type where Fid_doc = "+fwid+" and Feperiod<>"+sqlTo(d00));
	if(snap)
		res = snap[0];
	if(!res || differ(res,d00)==0)
		res = feperiod;
	return res;
}

function listMenuInit(ds)
{
	if(this.tbl.isEmpty())
		return;

//	ds.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
//	ds.AddMenuItem("VIEWDOC","Перегляд документу|Просмотр документа", "view");
}

function listMenuRun(sID)
{
	switch(sID)
	{
		
	}
}

function filterMode(s)
{
	if(s == "DEL")
		return false;
	else
		return true;		
}

function reloadList()
{
	list.tbl.clearQuery();
	list.tblSrc[list.tblSrcNo] = "";
	list.reLoad();
}

//function onChangePeriod()
//{
//	var per = String(TYPEPER.value);
//	switch (per)
//	{
//		case "TD":
//			DATB.value = today.getVarDate();
//			DATE.value = today.getVarDate();
//			break;
//		case "YTD":
//			DATB.value = goDay(today, -1);
//			DATE.value = goDay(today, -1);
//			break;
//		case "TW":
//			DATB.value = goDay(today, -today.getDay());
//			DATE.value = goDay(today,6 - today.getDay());
//			break;
//		case "TM":
//			DATB.value = firstDayMonth(today);
//			DATE.value = lastDayMonth(today);
//			break;
//		case "LM":
//			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
//			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
//			break;
//		case "2M":
//			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
//			DATE.value = lastDayMonth(today);
//			break;		
//		case "TY":
//			DATB.value = jan01(today);
//			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
//			break;
//		case "2Y":
//			var bdat = new Date(today.getFullYear()-1, today.getMonth());
//			DATB.value = jan01(bdat);
//			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
//			break;
//		case "ALL":
//			DATB.value = d00min;
//			DATE.value = d00;
//			break;
//		default:
//			break;
//	}
//}

function onMessage(sType, oPar)
{
	extPar = oPar;	
	list.isSetFocusOnGrid = false;
	grid.DeletePages();
	listDpGrid();
	list.reLoad();
	list.isSetFocusOnGrid = true;
}

function getTxtDol(fwid,bdat,edat)
{
	if(bdat && edat)
		snap = getSnap("select Ftxtdol from ^full_pers where Fwid_cl="+fwid+" and Fbdat<="+sqlTo(edat)+" and Fedat>="+sqlTo(bdat));
	else
		snap = getSnap("select Ftxtdol from ^full_pers where Fwid="+fwid);
	if(snap && snap[0])
		return snap[0];
	else
		"???";
}

function getTxtOrg(fwid_wp)
{
	var snap = getSnap("select Ftxtorg from ^full_pers where Fwid="+fwid_wp);
	if(snap && snap[0])
		return snap[0];
	else
		"???";
}

function getTblH()
{
	var h = new Object();
	h.HBDAT = extPar.dat1;
	h.HEDAT = extPar.dat2;
	h.HDOC = extPar.fdoc;
	return h;
}

include("sys/DpList.js");