include("Objects\\DpPrList.js");

var isTree   = false;	
var isGroup  = false;
var isPrice  = false;
var firstGrp = false;
var priName  = null;

function listLoad()
{	
	list.title = ru("Перечень прайс-листов","Перелік прайс-листів");	
	list.buildNode = buildNode_PRI;
	list.onTreeSel = priTreeSel;
	list.accEdit = accEdit_pri;	
	list.subAfterMenuHandler = priMenuRun;	
	list.subTreeDel = priDel;
	list.par.priMenuRun = priMenuRun;
	//list.subGrid	= priInitGrid;
	list.buildTree = pri_buildTree
	firstGrp = groupEmpty();
	
	oPri = new DpPrList(); 	
	setParam();		
}

function pri_buildTree()
{		
	list.oTree.setExpandHandler(this,"buildNode");
	list.oTree.setTreeSelHandler(list,"onTreeSel");	
	list.oTree.addItem("","0",UR(list.subTitle()));
	
	//list.buildNode(0, list.oTree);
	list.oTree.setSelected("0");
}

function accEdit_pri()
{
/*	isGroup = list.oTree.getSelected()==0;	
	if(isPrice)
		return "EVF";
	else
*/		return "AEVF";
}

function setParam(id)
{
	include("sub\\mtr.js");
	var oSnap = null;
	if(id)
	{
		oSnap = getSnap("SELECT FGRPID,Fcod,fdat FROM " + list.treeTbl 
						+ " WHERE FWID=" + sqlTo(Number(id))
					, false);
	}
	if (oSnap != null)
	{
		list.sParID = oSnap[0];	
		var fcod = list.par.fcod = oSnap[1];
		var	fdat = list.par.fdat = oSnap[2];		
		list.par.grpId = id;
		oPri.load(id);
		//isGroup = list.oTree.getSelected()==0;	
	}
			
	if (oSnap != null && oSnap[0]!=0)//параметры прайса 
	{					
		priName = pName(fcod, fdat, id);
		//list.xmlGridFile = "l_price.xml";
		list.recordModXml = "e_price.xml";
		list.editTask = "e_price.xml";		
		isPrice = true;		
		return;
	}	
	else//параметры группы
	{		
		list.editTask="e_cl_pri.xml";		
		list.xmlGridFile = "l_cl_pri.xml";		
		list.treeModXml = "e_cl_pri.xml";
		list.initTree(Tree, "FTXT", "^CL_PRI", sash);
		isPrice = false;
		isGroup = (list.oTree.getSelected()!=0 && list.oTree.getSelected()!=null);	
	}	
}

function priTreeSel(sCod, mode)
{
	if (!this.isTree)
		return;
	if ("ENTER" != mode && this.sFolderID == this.oTree.getSelected())
		return;

	setParam(sCod);		
	//listSrc();	
	list.subSrc();
	
	if (this.isTree)
	{
		this.sFolderID = sCod;
		if (!mode)
			this.tblInit(true);
	}
	
	this.oTree.setSelected(sCod);
	this.sFolderID = sCod;	
	
	//var itm = Tree.getItem(sCod);
	//this.nFolderLeftKey = itm.getData("fleftkey");
	//this.nFolderRightKey = itm.getData("frightkey");
	
	priInitGrid();
}

function priInitGrid()
{	
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	oGrid.DeletePages();
	
	if(isPrice)
	{
		oPri.initGrid(list.sFolderID);
		return;
	}
	
	oGrid.setXMLFile(list.xmlGridFile);
/*	with(oGrid.page())
	{
		FieldEx("fcod","Тип", 4, null);
		FieldEx("fdat","На дату", 12, null);
		FieldEx("ftxt","Назва\nпрайс-листа|Наименование\nпрайс-листа", 15, null);
		FieldEx("Fsc","Рах.|Сч.", 6, null);
		FieldEx("Fsu","Суб\nрах.|Суб\nсч.", 6, null);
		FieldEx("=^nmk.Fcod","№\nноменкл.", 8, null);
		FieldEx("=^nmk.ftxts","Назва\nноменклатури|Наименование\nноменклатуры", 10, null);
		FieldEx("Fpodr","Підр.|Подр.", 6, null);
		FieldEx("FMOL","МВО|МОЛ", 6, null);
		FieldEx("FPressed","Чернетка|Черновик", 5, null);
		FieldEx("Fdat_r","Розраховано|Расчитан", 12, null);
	}
*/
	oGrid.build();
}

function buildNode_PRI(id, toObject)
{
	var bIsBuilt = false;	
	var item = list.oTree.getItem(id);
	if (item != null)
		bIsBuilt = item.getData("ISBUILT");

	if (bIsBuilt || firstGrp)
		return;

	list.oTree.removeItem(id + "STUB");

	var tbl;
	var sSQL = "SELECT maintbl.FCOD, maintbl.FWID, maintbl.FTXT, tblc.FGRPID "
			 + " FROM ^cl_pri maintbl "
				+" LEFT JOIN  ^cl_pri tblc ON  tblc.FGRPID=maintbl.FWID "
			 + " WHERE maintbl.FGRPID=" + sqlTo(Number(id))
			 + " GROUP BY maintbl.FCOD, maintbl.FWID, maintbl.FTXT, tblc.FGRPID "
			 + " ORDER BY maintbl.FCOD DESC";
	tbl = OpenTable("s",sSQL);
	if (tbl.isEmpty())
		return;
	
	var txt = '';
	var icon = '';
	tbl.MoveLast();
	
	while(!tbl.isBOF())
	{
		txt = nvl(tbl.getValue(list.sTtxtFld));
		if(id!=0)
		{			
			icon = TREE_ITEM;
			date = getSnap("select fdat from ^CL_PRI where fwid="+ tbl.getValue("FWID"))
			if(date!=null)
				txt = nvl(StrDat(date[0],"DMY")) + ((txt!="" && txt!=null)? " - "+txt : "");
		}

		var Fwid = tbl.getValue("Fwid");
		list.oTree.addItem(id, Fwid, txt, icon);
		var itm = list.oTree.getItem(Fwid);
		var oSnap = tbl.getValue("FGRPID");

		if (oSnap != null)				
			list.oTree.addItem(Fwid, Fwid + "STUB", "", TREE_ITEM);			
		else
			itm.setData("ISBUILT",true);

		tbl.MovePrev();
	}
	tbl.close();
	if (item != null)
		item.setData("ISBUILT",true);
	
	list.oTree.showItem(Fwid);
}

function listSrc()
{	
	list.qryWhere = null;	
	if(isPrice)
	{			
		oPri.src(list);		
		return;
	}
	
	if(isGroup)
	{
		list.qrySet(
		"From", "^cl_pri"
		,"Where", "FGRPID="+ list.par.grpId
		,"Order", new Array("Fcod, Fdat DESC")
		,"WhereArr", new Array("FISGRP<>"+ sqlFalse +" OR FISGRP<>"+ sqlTrue)			
		);
	}
	else	
	{
		list.qrySet(
		"From", "^cl_pri"
		,"Order", new Array("Fcod, Fdat DESC")		
		,"WhereArr", new Array("FISGRP<>"+ sqlFalse)		
		);
	}

	list.subTie("cl_nmk", "nmk", "FWID", "Fnmkl", null, TIE_NOSEARCH);
	list.subTie("cl_edi", "ed", "fcod", "nmk.Fcedib");
}

function listMenuInit(toObject)
{	
	var ds = list.dataSrc;
	
	if(isPrice)
		oPri.menuInit();
	
	var grpId = list.tbl.getValue("FGRPID"); 
	if(!list.tbl.IsEmpty() && grpId!=0 && !isPrice)
	{
		if(IsDblClick())
		{
			listMenuRun("PRICE");
			return false;
		}		
		ds.AddMenuItem("PRICE", "Відкрити прайс-лист|Открыть прайс-лист", ICON_VIEW);		
	}
}

function listMenuRun(ID)
{
	var tbl = list.tbl;
	var isMainGroup = list.oTree.getSelected()==0;
	//setParam(tbl.getValue("FWID"))

	//vvs 09.10.2007
	//Если мы в дереве слева стоим на корне, то в гриде нам видны
	//все группы и прайсы.
	//Поэтому надо корректно определить
	//	list.sParID	
	//	list.par.fcod;
	//	list.par.fdat;		
	//	list.par.grpId
	if(tbl.IsRecord())
	{		
		var mfcod = tbl.getValue("fcod");
		//Снимем информацию с заголовка группы
		var strSQL = "select fwid "
				+" from ^cl_pri"
				+" where fisgrp=" + sqlTrue
					+" and fcod=" + sqlTo(mfcod)
		var oGroup = getSnap(strSQL, false);
		if(oGroup!=null)
		{
			list.sParID = oGroup[0]; 	
			list.par.fcod = mfcod;
			//list.par.fdat;		
			list.par.grpId = oGroup[0]
		}
		oGroup = null;
	}
			
	switch(ID)
	{		
		case "PRICE":
			if(differ(tbl.getValue("fdat"),d00)< 0 || differ(tbl.getValue("fdat"),d00)> 0)
			{
				objParMenu = new Object();
				objParMenu.fwid = tbl.getValue("FWID");				
				objParMenu.fpressed = tbl.getValue("fpressed");
		    	showWindow("l_price.js", SW_NOMODAL, objParMenu, "");
			}			
			break;
					
		case "ADDFLD":	
			list.sFolderID = 0;
			break;		
		
		case "ADD":	
			list.par.sFolderID = 0;
			break;	
		
		case "COPY":	
			if(!isPrice)
			{
				var priName = pName(null, null, list.tbl.getValue("FWID"));
				ExecuteSQL("drop table TMP_PRI_COPY", false);
				ExecuteSQL("select * into TMP_PRI_COPY from "+ priName, false);
			}
			break;
		
		case "DEL":
			if(!isPrice)	
			{			
				delId = Number(list.tbl.getValue("FWID"));				
				delPri = pName(null, null, list.tbl.getValue("FWID"));
			}
			break;				
	}
	if(isPrice && ID!="DEL")
	{
		return oPri.menuRun(ID);
	}
}

function priMenuRun(mnuID, addGrp)
{
	if(addGrp)
		list.objParMenu.escape = false;
		
	if(isPrice || list.objParMenu.escape)
		return;	
	isMainGroup = list.oTree.getSelected()==0;
	if(!isPrice && mnuID=="DEL" && delId!=Number(list.tbl.getValue("FWID")))			
		priDel(delId);
	
	if(mnuID=="DEL")
		return;
				
	if (mnuID == "EDIT")
		list.oTree.modifyItem(list.objParMenu.treePar.addFwid, list.objParMenu.treePar.addTxt);
	
	if(mnuID!="ADD" && mnuID!="COPY" && mnuID!="EDIT")
		return;
			
	var gId = list.par.sFolderID;
	var pId = list.objParMenu.treePar.addFwid;
	var txt = list.objParMenu.treePar.addTxt;
	var icon = TREE_ITEM;
	
	ExecuteSQL("UPDATE ^CL_PRI SET FGRPID="+ gId +" WHERE FWID="+ pId, false);
	ExecuteSQL("UPDATE ^CL_PRI SET FGRPID=0 WHERE FISGRP<>"+ sqlTo(false));
			
	if(gId==0)
		icon = '';		
	
	if(mnuID!="EDIT")
		list.oTree.addItem(gId, pId, txt, icon);
	var itm = list.oTree.getItem(pId);
	if (itm != null)
		itm.setData("ISBUILT", true);
	
	if(mnuID=="COPY" && !isPrice)
	{
		var sMsg = UR("Копіювати вміст прайсу?|Копировать содержимое прайса?");
		if(IsTable("TMP_PRI_COPY") && confirm(sMsg))
		{
			var priName = pName(null, null, pId);
			var fld = GetPatternIntersection("PRICE", "PRICE");
			fld = fld.replace(",FWID_CH", "");
			//fld = fld.replace(",FWID", "");
			//fld = fld.replace("FWID,", "");
			
			//Проставим FGRPID
			updateTable("^TMP_PRI_COPY", {FGRPID:pId}, false, "1=1");
			
			//Проставим FWID'ы
			strSQL = " ALTER TABLE TMP_PRI_COPY ADD FWID_CTR "+SqlType("COUNTER")
			ExecuteSQL(strSQL);			
			var tBuff = OpenTable("TMP_PRI_COPY");
			if(!tBuff.IsEmpty())
			{
				var firstFwid = GetUID();
				var lastFwid = GetUID(false, Number(tBuff.recordCount));

				strSQL = " UPDATE TMP_PRI_COPY"
						+" SET FWID = FWID_CTR + "+sqlTo(firstFwid)
				ExecuteSQL(strSQL);
			}
			tBuff.Close();
			tBuff = null;
			
			strSQL = " ALTER TABLE TMP_PRI_COPY DROP COLUMN FWID_CTR "
			ExecuteSQL(strSQL);
			ExecuteSQL("insert into "+ priName +"("+ fld +") select "+ fld +" from TMP_PRI_COPY", false);
		}
	}
}

function priDel(id)
{	
	var tbl = list.tbl;		
	var sPath = getPath("PR_MDB") + (SUBD==MSSQL? "." : "") +".mtr_";
	var tt,mname,sName;
	if(!id)
		id = tbl.getValue("fwid");
		
	isMainGroup = list.oTree.getSelected()==0;
	if(!isPrice)
	{
		//mname = pName(tbl.getValue("fcod"), tbl.getValue("fdat"), id);
		mname = delPri;
		sName = sPath + mname.substr(1);		
		ExecuteSQL("DROP TABLE "+ sName, false);
	}
	if(isMainGroup)
	{
		tt = OpenTable("s","SELECT * from "+ list.qryFrom +" where fgrpid="+ id);
		for(tt.MoveFirst(); !tt.isEOF(); tt.MoveNext())
		{
			mname = pName(tt.getValue("fcod"),tt.getValue("fdat"),tt.getValue("fwid"));
			sName = sPath + mname.substr(1);			
			ExecuteSQL("DROP TABLE "+ sName, false);
		}
		tt.Close();
		ExecuteSQL("DELETE FROM ^cl_pri where fgrpid="+ id +" OR fwid="+ id);
		
		list.tbl.Requery();		
		list.oTree.removeItem(id);
		return false;
	}
	return true;
}

function groupEmpty()
{	
	var sWhere = "";
	if(grid.getTable()!=null)
	{
		var fwid = grid.getTable().getValue("FWID");
		sWhere = "where fgrpid="+ sqlTo(Number(fwid));
	}
	var oSnap = getSnap("select fcod from ^cl_pri "+ sWhere);
	return oSnap==null;
}

include("sys\\DpList.js")