var listPrnForm = "CLREC";
//var prnPatt = "CLRCEX";
var isClAnalog = false;

function listLoad()
{
	with(this)
	{
		if (extPar && extPar.isAnalog)
		{
			title = "Типи Аналогiв|Типи Аналогов";
			isClAnalog = true;
		}
		else
			title = "Довідник рецептів|Справочник рецептов";
		subDel = delRows;
		//printRowLabel = prnPatt;	//раньше для печати строк использовалось отдельное меню, теперь строки можно напечатать с обычной формой CLREC.
		editTask = "e_cl_rec";
		xmlGridFile = "l_cl_rec.xml";
		subMenuRun = menuRun;
	}
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
	
	
	this.selRecordHandler = selRecordHandler;
	this.showRecView = showRecView;
	grid.setSelHandler(this, "selRecordHandler");
	grid.setWhen(this, "selRecordHandler");  	
}

function selRecordHandler()
{
	if (this.tm == null)
	{
		this.tm = runTimer(runViews, 100)	
	}
	else
	{
		this.tm.stop();
		this.tm.start();
	}
	
}

function runViews()
{
	var par = new Object();	
	if (!list.tbl || list.tbl.isBOF() || list.tbl.isEOF())
	{
		par.fno = -1;
	}
	else	
		par.fno = list.tbl.getValue("fno");
		
	par.isAnalog = 	isClAnalog;
	var view = lpProxy.getView(isClAnalog?"l_analog":"l_ingredient");	
	if (view != null)
	{
		if (view.getViewSite().getPage().isPartVisible(view))
		{
			view.sendMessage("ing", par);	
		}
	}
	
}

function showRecView()
{
	
	var par = new Object();	
	par.fno = list.tbl.getValue("fno");
	par.isAnalog = 	isClAnalog;
	var view = lpProxy.getView(isClAnalog?"l_analog":"l_ingredient");
	if (view == null)
	{
		
		lpProxy.showView(isClAnalog?"l_analog":"l_ingredient", "l_ingredient.js", par);
	}
	else
	{
		view.sendMessage("ing", par);	
	}
}

function onMessage(sType, oPar)
{
	extPar = oPar;
	this.isSetFocusOnGrid = false;
	this.reLoad();
	this.isSetFocusOnGrid = true;
}

function listSrc()
{
	
	this.qrySet("From", "^CL_REC",
				"Order", "fno, ftext",
				"Ptn", "CL_REC"
				);
				
	if (extPar && extPar.fnmkl)
	{
		where = " exists (select fwid from ^cl_rrec where fhno = ^CL_REC.fno " 
				+ "and fnmkl = " + sqlTo(extPar.fnmkl) 
				+ "and fmain = " + sqlTrue
				+ " )";
				
		if (extPar.isAnalog)
		{
			where += " and fisreplacemap = 1";
		}
		else
		{
			where += " and fisreplacemap = 0";
		}		
				
		this.qrySet("Where", where);		
	}			
}

function delRows()
{
	ExecuteSQL("DELETE FROM ^CL_RREC WHERE FHNO="+list.tbl.getValue("FNO"));
	//ExecuteSQL("DELETE FROM ^CL_REC WHERE FNID=0");
	return true;
}

function listMenuInit()
{
	grid.AddMenuItem("SHOWINGRED",isClAnalog?"Показати аналоги|Показать аналоги":"Показати iнгредiенти|Показать ингредиенты");
}  

function menuRun(ID)
{
	switch(ID)
	{
		case "PRNROW":
		/* 25.11.2011
		 * Для печати строк используются обычные формы печати со строками (шаблон CLREC)
		 * таблица со строками грузится ниже в getTblR()
		if (list.tbl("FNO")) 
		{
			tabl = OpenTable("m",
				"SELECT * FROM ^CL_RREC "
				+ " WHERE FHNO="+list.tbl("FNO")
					+ " ORDER BY FHNO,FNOM_STR,FRTYPE,FNMKL");
			if (SQL) {
    			tabl.Tie("cl_nmk","tblnmk","FWID","Fnmkl");
				tabl.Tie("cl_edi","osedi","FCOD","tblnmk.Fcedib");
				tabl.Tie("cl_edi","dopedi","FCOD","tblnmk.Fedi1");          
			}
			else {
	    		tabl.Tie("cl_nmk","tblnmk","FWID","Fnmkl");
				tabl.Tie("cl_edi","osedi","COD","tblnmk.Fcedib");
				tabl.Tie("cl_edi","dopedi","COD","tblnmk.Fedi1");          
			}
			include("objects\\DpTVars.js");
			var tv = new DpTVars(prnPatt);
			tv.setHTbl(list.tbl);
			tv.setRTbl(tabl);			
			tv.print();
		}*/
		break;
		
		case "SHOWINGRED":	
			this.showRecView();
			break;
	}  
}

function getTblH(ID)
{
	var sNo = list.tbl.getValue("FNO");
	strSQL = "SELECT R.FNMKL, R.FKOL"
			+" FROM ^CL_RREC r"
				+" INNER JOIN ^CL_REC H ON H.FNO=R.FHNO"
			+" WHERE R.FHNO IN ("+ sNo +")"
				+" AND R.FRTYPE = "+sqlTo(RTYPE_PR)
	
	var sn = getSnap(strSQL);
	var nmkl = 0, kol = 0;
	if (sn != null && !isEmpty(sn[0]))
	{
		nmkl = sn[0];
		kol = sn[1]
	}
	var h = new Object();
	h.FNMKL = nmkl;
	h.FKOL = round(kol, getPar("DECIKOL"));
	h.FYEAR = new Date().getFullYear();
	return h;
}


function getTblR(tv)
{
	var sNo = list.tbl.getValue("FNO");
	if(list.grid.getSelectedCount()>1)
	{
		var tblNo = OpenTable("select FNO from ^CL_REC where "+ list.grid.getSqlSelected());
		sNo = "";
		for(; !tblNo.isEOF(); tblNo.MoveNext())
			sNo += (sNo==""? "" : ",") + tblNo.getValue("FNO");
		tblNo.close();
	}
	var tblR = OpenTable("SELECT h.FNO, h.FTEXT, h.FISREPLACEMAP, h.FTYPE, h.FVALID, r.*"
							+", n.FCOD as FNMK_COD, n.FTXTS as FNMK_TXT, e.FTXTS as FEDI_TXT"
							+","+ IIF("FRTYPE='"+ RTYPE_PR +"'", "'+'", "'-'") +" as FTT"
						+" FROM ^CL_RREC r"
							+" inner join ^CL_REC h on h.FNO=r.FHNO"
							+" left join ^CL_NMK n on n.FWID=r.FNMKL"
							+" left join ^CL_EDI e on e.FCOD=n.FCEDIB"
						+" WHERE r.FHNO in ("+ sNo +")"
						+" ORDER BY r.FHNO,r.FNOM_STR,r.FRTYPE,r.FNMKL"
						);
	//browse(tblR)
	return tblR;
}

include("sys\\DpList.js");