function listLoad()
{
	with(this)
	{
		title = "Довідник видів валют|Справочник видов валют";
		editTask = "e_cl_val.xml";
		printLabel = "CLVAL";
		xmlGridFile = "l_cl_val.xml";
		initTree(Tree,"FNAZV","^CL_VALUT",sash);
		helpID = "cl_val";
	}
}

function listSrc()
{
	
	this.qrySet	(
					"From", "^CL_VALUT",
					"Order", new Array("FKOD"),
					"Ptn", "CL_VALUT"
				);
	
}


function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		with(page())
		{
			cell( "Fkod","Код|Код",3);
			cell( "Fnazv", "Назва|Название",15);
			cell( "Fnazvs","Скор.|Сокр",5);
			with(group("Назва основноі валюти|Название основной валюты"))
			{
				cell( "Frub0","1 | 1",6);
				cell( "Frub1","2,3,4 | 2,3,4",7);
				cell( "Frub2","інш.|.др.",7);
			}
			with(group("Назва дрібної монети |Название разменной монеты"))
			{
				cell( "Fkop0","1 | 1",6);
				cell( "Fkop1","2,3,4 | 2,3,4",7);
				cell( "Fkop2","інш.|.др.",7);
			}
			cell( '=iif(CBool(^Frubsex),"жен","муж")', "Род|Род",5);
			cell( "Fcomcod", "Межд.\nкод", 5);
		}
		build();
	}
}

function listMenuInit()
{
	if(list.tbl.isRecord() && list.tbl.getValue("FKOD") != 0)
	{
		grid.AddMenuItem("+++", "Курси|Курсы")
		grid.AddMenuItem("KURS", "Перегляд|Просмотр")
		grid.AddMenuItem("LOADKURS", "Завантажити|Загрузить")
		grid.AddMenuItem("---", "Курси|Курсы")
	}
}

function listMenuRun(sID)
{
	if (sID == "KURS")
	{
		var par = new Object();
		par.fkod = Number(list.tbl.getValue("FKOD"));
		showWindow("l_kursvl.xml", SW_NOMODAL,par);
	}
	if (sID == "LOADKURS")
	{
		include ("importKursValWeb.js");
		include ("objects/DpGetDat.js");
		var gd = new DpGetDat(new Array("r"));
		
		if (!gd.escape)
		{
			importKursValWeb(list.tbl.getValue("FNAZVS"), gd.dat1, gd.dat2);
		}
	}
}

include ("sys\\DpList.js");