//Справочник процедур расчетов, который формируется с помощью сверки с эталоном
include("Objects/DpGrid.js");

var showNoUsed = false;
var KEYPAR = "SHOWNOUSECALCS";
var sWhere = " 1=1 ";

function listLoad()
{
	this.title = UR("Довідник процедур розрахунків|Справочник процедур расчетов");
	this.editTask = "e_cl_zrp_calcs.xml";
	var par = ReadParEx(KEYPAR);
	if(Number(par) == 1)
		showNoUsed = true;
	if(showNoUsed)
		sWhere = " 1=1 ";
	else
		sWhere = " Fnouse="+sqlFalse;
}

function listSrc()
{
	this.qrySet("From","^cl_zrp_calcs",
				"Where", sWhere,
				"Order", "Fnum, Flabel");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	oGrid.defCond("=^fnouse==true", "nouse");
	oGrid.color(14, "nouse")
	grid.setColorField("nouse")
	
	var oPage = oGrid.page();
	oPage.fieldEx("fnum", "№ з/п|№ п/п", 5);
	oPage.fieldEx("flabel", "Мітка|Метка", 10);
	oPage.fieldEx("=UR(^fname)", "Назва|Название", 25);
	oPage.fieldEx("=getTypeCalcName(^ftype)", "Тип|Тип", 10);
	oPage.fieldEx("fnouse", "Не вик.|Не исп.", 5);
	oPage.fieldEx("fcomments", "Коментарі|Комментарии", 20);
	oGrid.build();
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("SYNCHRONIZE","Виконати звіряння з еталоном|Выполнить сверку с эталоном");
	this.dataSrc.AddMenuItem("CHGSHOWUSE", showNoUsed?("Сховати невикористовуванi|Скрыть неиспользуемые"):"Показати невикористовуванi|Показать неиспользуемые");
	this.dataSrc.AddMenuItem("CHGUSE",toScrObj(this.tbl.getValue("Fnouse"))?"Використовувати|Использовать":"Не використовувати|Не использовать");
	if (getPar("is_debug") && this.tbl.getValue("Ftype")=="s")
		this.dataSrc.AddMenuItem("OPENSOURCESCRIPT","Вихідний код скрипта|Исходный код скрипта");
}

function listMenuRun(sID)
{
	switch(sID)
	{
		case "SYNCHRONIZE":
			if(!confirm(ru("Выполнить сверку справочника с эталоном?","Виконати звіряння довідника з еталоном?")))
				return false;
			include("Objects/DpZrpCalc.js");
			var oZrpCalc = new DpZrpCalc();
			oZrpCalc.synchronize();
			list.tbl.requery();
   			grid.RefreshGrid();
		break;
		case "CHGSHOWUSE":
			showNoUsed = !showNoUsed;
			if(showNoUsed)
				sWhere = " 1=1 ";
			else
				sWhere = " Fnouse="+sqlFalse;
			WriteParEx(KEYPAR, showNoUsed?1:0);
			list.reLoad();
		break;
		case "CHGUSE":
			ExecuteSQL("update ^cl_zrp_calcs set Fnouse="+(toScrObj(this.tbl.getValue("Fnouse"))?sqlFalse:sqlTrue)+" where "+DataSource().sqlSelected());
			list.tbl.requery();
   			grid.RefreshGrid();
		break;
		case "OPENSOURCESCRIPT":
			var sPath = this.tbl.getValue("Fpath");
			var ind = sPath.indexOf("JDebet");
			if(ind != -1)
			{
				lpProxy.openSourse(sPath);
			}
			else
			{
				alert(ru("Некорректный путь скрипта\n","Некоректний шлях скрипта\n")+sPath, 2);
				return false;
			}
		break;
	}
}

function getTypeCalcName(type)
{
	switch(String(type))
	{
		case "d":
			return UR("парний розрахунок|парный расчет");
		case "o":
			return UR("об'єкт статистики|объект статистики");
		case "s":
		default:
			return UR("скрипт|скрипт");
	}
}

function filterMode(mnuID)
{
	if(mnuID.indexOf("DEL")!=-1 || mnuID=="ADD" || mnuID=="COPY" || mnuID=="EDIT")
		return false;
	else
		return true;
}
include("sys/DpList.js");