//Взяла из БЦ Яна 13.11.12
include("objects/DpOperation.js");

var doc = null;
var operList = null;

var OPER = 1;
var SECT = 4;
var PROV = 3;

var isZaval = (extPar && (extPar.isZaval || extPar.zaval));
var fromPatt = (extPar && extPar)

var strSelectID = 0;
var strCopy = null;

function onLoad()
{
	if (!extPar || !extPar.doc)
	{
		alert("недостаточно параметров");
		return false;
	}
	
	doc = extPar.doc;
	operList = new DpOperationList(doc);
	
	var capt = UR("Довідник госп.операцій для документа "
				+ "|Справочник хоз. операций для документа ");
	Caption(capt + doc);
	
	Tree.addColumn("head",UR("        "),150);
	Tree.addColumn("text",UR("Назва|Название"),200);
	Tree.addColumn("bdate",UR("Початок|Начало"),80);
	Tree.addColumn("edate",UR("Кінець|Конец"),80);
	Tree.addColumn("dbsc",UR("Дт. Рах.|Дт. Счет"),60);
	Tree.addColumn("dbsu",UR("Дт. С.рах.|Дт. С. сч."),60);
	Tree.addColumn("dbst",UR("Дт. Ст.|Дт. Ст."),60);
	Tree.addColumn("dbcod1",UR("Дт. Ан1"),50);
	Tree.addColumn("dbcod2",UR("Дт. Ан2"),50);
	Tree.addColumn("dbcod3",UR("Дт. Ан3"),50);
	Tree.addColumn("crsc",UR("Кт. Рах.|Кт. Счет"),60);
	Tree.addColumn("crsu",UR("Кт. С.рах.|Кт. С. сч."),60);
	Tree.addColumn("crst",UR("Кт. Ст.|Кт. Ст."),60);
	Tree.addColumn("crcod1",UR("Кт. Ан1"),50);
	Tree.addColumn("crcod2",UR("Кт. Ан2"),50);
	Tree.addColumn("crcod3",UR("Кт. Ан3"),50);
	Tree.addColumn("sum",UR("Сума|Сумма"),70);
	Tree.addColumn("cond",UR("Умова|Условие"),170);
	Tree.addColumn("filter",UR("Фільтр|Фильтр"),170);
	
	Tree.setItemImage(SECT,rootDirectoryEx() + "/icons/section.gif");

	fillTree();
	
	this.canEdit = tree_canEdit;
	this.Tree_mnuHandler = Tree_mnuHandler;
	this.Tree_mnuInit = Tree_mnuInit;
	this.onTreeSelected = onTreeSelected;
	Tree.setCanEditHandler(this,"canEdit");
	Tree.selectMenuHandler(this, "Tree_mnuHandler");
	Tree.loadMenuHandler(this, "Tree_mnuInit");
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	
	this.treeDrop = treeDrop;
	this.treeDrag = treeDrag;
	
	Tree.setDropHandler(this,"treeDrop");
	Tree.setDragHandler(this,"treeDrag");
	if (extPar.nop)
	{
		var s = "OP" + String(extPar.nop);
		Tree.showItem(s);
		Tree.setSelected(s);
		Tree.expand(s);
	}
	
	if(lpProxy.isTest())
	{
		include("testApi/DpTestCase.js");
		testList(list);
	}
	setHelp(Tree, "clop");
}

function treeDrag(sFnk,evnt)
{
	if (sFnk == "dragStart")
	{
		var sType = strSelectID.substring(0,2);
		if (sType != "SN" && sType != "PR")
		{
			evnt.doit = false;
			return;
		}
		evnt.data = strSelectID;
	}
	if (sFnk == "dragSetData")
	{
		trace("SD " + strSelectID);
		evnt.data = strSelectID;
	}
}

function treeDrop(sFnk,evnt)
{
	if (sFnk == "drop" && evnt.data && evnt.item)
	{
		var cpyID = String(evnt.data);
		if (cpyID.length < 5)
			return;
		var toID = String(evnt.item.getData());
		var toType = toID.substring(0,2);
		var toNop = 0;
		var toSect = 0;
		if (toType == "SN")
		{
			var psect = parseSectID(toID);
			toNop = psect.nop;
			toSect = psect.sect;
		}
		else if (toType == "PR")
		{
			var pprov = parseProvID(toID);
			toNop = pprov.nop;
			toSect = pprov.sect;			
		}
		else if (toType == "OP")
		{
			toNop = toID.substr(2);
		}
		else
			return;
		
		
		var sType = cpyID.substring(0,2);
		if (sType == "SN")
		{
			var psect = parseSectID(cpyID);
			var oPar = new Object();
			oPar.sMode = "COPY";
			oPar.operList = operList;
			oPar.doc = operList.doc;
			oPar.oSection = psect.oOp.getSection(psect.sect);

			oPar.nop = toNop;
			oPar.sect = 0;
			showWindow("e_section.xml",SW_MODAL,oPar);
			if (!oPar.escape)
			{
				oPar.ret.section.refresh();
				fillSect(oPar.ret.section);
			}
		}
		else if (sType == "PR")
		{
			var pprov = parseProvID(cpyID);
			
			pprov.oSect.gotoProv(pprov.prov);
			var tbl = pprov.oSect.provTbl;
			var oPar = new Object();
			oPar.sMode = "COPY";
			oPar.operList = operList;
			oPar.doc = operList.doc;
			oPar.nop = toNop;
			oPar.section = toSect;
			oPar.tbl = tbl;

			showWindow("e_provodka.xml",SW_MODAL,oPar);
			if (!oPar.escape)
			{
				var oOp = operList.listOperations()[oPar.nop];
				var opId = "OP" + toNop;
				Tree.removeAllIn(opId);
				fillOp(oOp);
				Tree.expand(opId,true);
				/*
				if (toID.substr(0,2) == "OP")
				{
					Tree.removeAllIn(toID);
					fillOp(oOp);
				}
				else
				{
					Tree.removeItem(toID);
					var oSect = oOp.getSection(oPar.section);					
					fillSect(oSect);
				}
				*/
			}
		}
		else
			return;
	}
}

function tree_canEdit(){return false;}

function onTreeSelected(sCod,sMode)
{
	if("ENTER" != sMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = sCod;
}

function Tree_mnuInit(toObject)
{
	if (!strSelectID)
		strSelectID = "";
	var sType = strSelectID.substr(0,2);
	var isNop = sType == "OP";
	var isSect = sType == "SN";
	var isProv = sType == "PR";

	include ("doc/DpDoc.js")
	var oDoc = new DpDoc(doc, 0);
	if (oDoc)
	{
		var childsId = oDoc.getChildIDs();
		var arrRow = new Array(childsId.length);
		var arrName = new Array(childsId.length);
				
		toObject.AddMenuItem("+++", "Змінні|Переменные");
		toObject.AddMenuItem("HPER","Змінні заголовку|Переменные заголовка");
		if (childsId.length == 1)
		{
			arrRow[0] = "RPER_" + childsId[0];
			arrName[0] = "Змінні строк|Переменные строк";
			toObject.AddMenuItem(arrRow[0],arrName[0]);
		}
		else
		{
			for(var j = 0; j < childsId.length; j++)
			{
				arrRow[j] = "RPER_"+childsId[j];
				arrName[j] = "Змінні строк "+childsId[j] + "|Переменные строк " + childsId[j];
				toObject.AddMenuItem(arrRow[j],arrName[j]);
			}
		}
		toObject.AddMenuItem("PPER", "Змінні користувача|Пользовательские переменные");
		toObject.AddMenuItem("---","")
	}
	if(filterMode("ADD"))
	{
		toObject.AddMenuItem("+++","Додати|Добавить","ADD");
		toObject.AddMenuItem("ADD_NOP","Додати операцію|Добавить операцию");
		toObject.AddMenuItem("ADD_SECT","Додати секцію|Добавить секцию");
		toObject.AddMenuItem("ADD_PROV","Додати проводку|Добавить проводку");
		toObject.AddMenuItem("---","");
	}
	
	filterMode("EDIT") && (isNop || isSect || isProv) && toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
	filterMode("ADD") && (isNop || isSect || isProv) && toObject.AddMenuItem("COPY","Копіювати|Копировать");
	filterMode("ADD") && (isNop || isSect || isProv) && strCopy && toObject.AddMenuItem("PASTE","Вставити|Вставить");
	filterMode("DEL") && (isNop || isSect || isProv) && toObject.AddMenuItem("DEL","Видалити|Удалить");
	
	toObject.AddMenuItem("","");
	toObject.AddMenuItem("EXPANDALL","Розгорнути все|Развернуть всё");
	toObject.AddMenuItem("COLLAPSEALL","Згорнути все|Свернуть всё");
}

function Tree_mnuHandler(sID,toObject)
{
	if(!filterMode(sID))
	{
		alert(UR("У Вас немає прав на цю дію!|У Вас нет прав на это действие!"));
		return false;
	}
	
	var oPar = new Object();
	oPar.operList = operList;
	oPar.doc = operList.doc;
	var sType = strSelectID.substr(0,2);
	if (sType == "OP")
	{
		var nop = strSelectID.substr(2);
		oPar.nop = nop;
	}
	else if (sType == "SN")
	{
		var psect = parseSectID(strSelectID);
		oPar.nop = psect.nop;
	}
	else if (sType == "PR")
	{
		var pprov = parseProvID(strSelectID);
		oPar.nop = pprov.nop;
	}
	else
	{
		oPar.nop = 0;		
	}
	
	//-
	if (sID == "DOUBLECLICK")
	{
		if (isZaval)
		{
			var nop = strSelectID.substr(2);
			if (!extPar.ret)
				extPar.ret = new Object();
			extPar.ret.fnop = nop;
			extPar.escape = false;
			CloseWindow();
		}
		else
		{
			Tree.showMenu();
		}
	}
	if (sID == "ADD_NOP")
	{
		oPar.sMode = "ADD";
		showWindow("e_oper.xml",SW_MODAL,oPar);
		if (!oPar.escape)
		{
			addOper(operList.listOperations()[oPar.ret.nop]);
		}
		return;
	}
	if (sID == "ADD_SECT")
	{
		oPar.sMode = "ADD";
		var toNop = 0;
		if (strSelectID.substring(0,2) == "OP")
			toNop = strSelectID.substr(2);
		else if (strSelectID.substring(0,2) == "SN")
			toNop = parseSectID(strSelectID).nop;
		else
			toNop = parseProvID(strSelectID).nop;
		oPar.nop = toNop;
		showWindow("e_section.xml",SW_MODAL,oPar);
		if (!oPar.escape)
		{
			oPar.ret.section.refresh();
			fillSect(oPar.ret.section);
		}
	}
	if (sID == "ADD_PROV")
	{
		oPar.sMode = "ADD";
		oPar.nop = 0;
		oPar.section = 0;
		if (strSelectID.substr(0,2) == "OP")
		{
			oPar.nop = strSelectID.substr(2);
			oPar.section = 0;
		}
		else if (strSelectID.substr(0,2) == "SN")
		{
			var psect = parseSectID(strSelectID);
			oPar.nop = psect.nop;
			oPar.section = psect.sect;
		}
		else
		{
			var pprov = parseProvID(strSelectID);
			oPar.nop = pprov.nop;
			oPar.section = pprov.sect;
		}
		showWindow("e_provodka.xml",SW_MODAL,oPar);
		if (!oPar.escape)
		{
			var oOp = operList.listOperations()[oPar.nop];
			if (strSelectID.substr(0,2) == "OP")
			{
				Tree.removeAllIn(strSelectID);
				fillOp(oOp);
//-				addOper(oOp);
			}
			else
			{
				Tree.removeItem(strSelectID);
				var oSect = oOp.getSection(oPar.section);
				fillSect(oSect);
			}
		}
		return;
	}
	if (sID == "DEL")
	{
		var ret = msgBox("c-"	
			, ru("Подтвердите удаление записи", "Підтвердіть вилучення запису")
			, ru("Удаление записи", "Вилучення запису"))
		if (ret == "c") return;
		var sType = strSelectID.substr(0,2);
		if (sType == "OP")
		{
			var nop = strSelectID.substr(2);
			var arr = operList.listOperations(false);
			operList.removeOperation(nop);
		}
		if (sType == "SN")
		{
			var psect = parseSectID(strSelectID);
			psect.oOp.removeSection(psect.sect);
			psect.oOp.save();
		}
		if (sType == "PR")
		{
			var pprov = parseProvID(strSelectID);
			pprov.oSect.removeProv(pprov.prov);
			pprov.oOp.save();
		}
		Tree.removeItem(strSelectID);
		return;
	}
	if (sID == "EDIT")
	{
		
		var sType = strSelectID.substr(0,2);
		var isNop = sType == "OP";
		var isSect = sType == "SN";
		var isProv = sType == "PR";
		oPar.sMode = "EDIT";
		
		if (isNop)
		{
			var nop = strSelectID.substr(2);
			oPar.nop = nop;
			showWindow("e_oper.xml",SW_MODAL,oPar);
			if (!oPar.escape)
			{
				//Tree.removeItem(strSelectID);
				//addOper(operList.listOperations()[oPar.ret.nop]);
				setValueOnOper(operList.listOperations()[oPar.ret.nop]);
			}
			return;
		}
		if (isSect)
		{
			var psect = parseSectID(strSelectID);
			oPar.nop = psect.nop;
			oPar.section = psect.sect;
			showWindow("e_section.xml", SW_MODAL, oPar);
			if (!oPar.escape)
			{
				oPar.ret.section.refresh();
				//Tree.removeItem(strSelectID);
				//fillSect(oPar.ret.section);
				setValueOnSect(oPar.ret.section);
			}
		}
		if (isProv)
		{
			var pprov = parseProvID(strSelectID);
			oPar.nop = pprov.nop;
			oPar.section = pprov.sect;
			oPar.prov = pprov.prov;
			
			showWindow("e_provodka.xml", SW_MODAL, oPar);
			if (!oPar.escape)
			{
				//Tree.removeItem(strSelectID);
				pprov.oSect.gotoProv(oPar.prov);
				var parID = "OP" + pprov.nop;
				if (pprov.sect != 0)
					parID = "SN#" + pprov.nop + "#" + pprov.sect;
				//addProv(pprov.oSect,parID);
				setValueOnProv(pprov.oSect)
			}
		}
	}
	else if (sID == "EXPANDALL")
	{
		Tree.expandAll();
		return;
	}
	else if (sID == "COLLAPSEALL")
	{
		Tree.colapseAll();
		return;
	}
	else if (sID == "COPY")
	{
		strCopy = strSelectID;
		return;
	}
	else if (sID == "PASTE")
	{
		var evnt = new Object();
		evnt.data = strCopy;
		evnt.item = Tree.getItem(strSelectID);
		this.treeDrop("drop",evnt);
	}
	else if (sID == "HPER")
	{
		oPar.org = 0;
		oPar.vars = "H";
		showWindow("l_vardoc.js", SW_NOMODAL, oPar,"");
	}
	else if (sID == "PPER")
	{
		oPar.org = 0;
		oPar.vars = "P";
		showWindow("l_vardoc.js", SW_NOMODAL, oPar,"");
	}
	else if (sID.length>5 && sID.substr(0,5) == "RPER_")
	{
		oPar.org = 0;
		oPar.vars = sID.substr(5,sID.length-1);
		showWindow("l_vardoc.js", SW_NOMODAL, oPar,"");
	}
}

function parseSectID(sID)
{
	var lastInd = sID.lastIndexOf("#");
	var frstInd = sID.indexOf("#");
	var nSect = sID.substr(lastInd + 1);
	var nOp = sID.substring(frstInd + 1,lastInd);
	var oOp = operList.listOperations()[nOp];
	
	var ret = new Object();
	ret.nop = nOp;
	ret.sect = nSect;
	ret.oOp = oOp;
	return ret;
}

function parseProvID(sID)
{
//- "PR#OPERNUM#SECTNUM#PROVNUM
	var lastInd = sID.lastIndexOf("#");
	var nProv = sID.substr(lastInd + 1);
	sID = sID.substring(0,lastInd);
	
	lastInd = sID.lastIndexOf("#");
	var nSect = sID.substr(lastInd + 1);
	sID = sID.substring(0,lastInd);
	
	lastInd = sID.lastIndexOf("#");
	var nOp = sID.substr(lastInd + 1);
	
	var ret = new Object();
	ret.prov = nProv;
	ret.sect = nSect;
	ret.nop = nOp;
	ret.oOp = operList.listOperations()[nOp];
	ret.oSect = ret.oOp.getSection(nSect);
	return ret;
}

function fillTree()
{
	Tree.Lock();
	var arrOp = operList.listOperations(true);
	arrOp = operList.sort(arrOp);
	for (var nOp in arrOp)
	{
		addOper(arrOp[nOp]);
	}
	Tree.Unlock();
}

function addOper(oOp)
{
	Tree.addItem("0","OP" + oOp.nop, UR("Операція |Операция ") + oOp.nop, OPER);
	setValueOnOper(oOp);
	//Tree.setValue("OP" + oOp.nop,"text",oOp.getVar("txt"));
	if (!isZaval)
		fillOp(oOp);
}

function fillOp(oOp)
{
	var arrSect = oOp.sectionList;
	
	for (var nSect in arrSect)
	{
		fillSect(arrSect[nSect]);
	}
}

function fillSect(oSect)
{
	var oOp = oSect.oOper;
	var parID = "SN#" + oOp.nop + "#" + oSect.num;
	if (oSect.num == 0)
		parID = "OP" + oSect.oOper.nop;
	if (oSect.num != 0)
	{
		Tree.addItem("OP" + oOp.nop, parID
					,UR("Секція |Секция ") + oSect.num, SECT);
		setValueOnSect(oSect);
		
	}
	for (oSect.provTbl.MoveFirst();!oSect.provTbl.isEOF();oSect.provTbl.MoveNext())
	{
		addProv(oSect,parID);
	}
}

function addProv(oSect,parID)
{
	Tree.addItem(parID, "PR#" + oSect.oOper.nop + "#" + oSect.num + "#" + oSect.provTbl.getValue("num"),
						UR("Проведення |Проводка ") + oSect.provTbl.getValue("num"), PROV);
	setValueOnProv(oSect);				
}

function setValueOnOper(oOp)
{
	var ID = "OP" + oOp.nop;
	Tree.setValue(ID, "text", oOp.getVar("txt"));
	Tree.setValue(ID, "cond", oOp.getVar("cond"));
}

function setValueOnSect(oSect)
{
	var ID = "SN#" + oSect.oOper.nop + "#" + oSect.num;
	Tree.setValue(ID, "text", oSect.txt);	
	Tree.setValue(ID, "cond", oSect.cond);	
	Tree.setValue(ID, "filter", oSect.filter);	
}

function setValueOnProv(oSect)
{
	var ID = "PR#" + oSect.oOper.nop + "#" + oSect.num + "#" + oSect.provTbl.getValue("num");
	Tree.setValue(ID, "text", oSect.provTbl.getValue("txt"));
	Tree.setValue(ID, "bdate", oSect.provTbl.getValue("bdate"));
	Tree.setValue(ID, "edate", oSect.provTbl.getValue("edate"));				 
	Tree.setValue(ID, "dbsc", oSect.provTbl.getValue("db_sc"));
	Tree.setValue(ID, "dbsu", oSect.provTbl.getValue("db_su"));
	Tree.setValue(ID, "dbst", oSect.provTbl.getValue("db_st"));
	Tree.setValue(ID, "dbcod1", oSect.provTbl.getValue("db_cod1"));
	Tree.setValue(ID, "dbcod2", oSect.provTbl.getValue("db_cod2"));
	Tree.setValue(ID, "dbcod3", oSect.provTbl.getValue("db_cod3"));
	Tree.setValue(ID, "crsc", oSect.provTbl.getValue("cr_sc"));
	Tree.setValue(ID, "crsu", oSect.provTbl.getValue("cr_su"));
	Tree.setValue(ID, "crst", oSect.provTbl.getValue("cr_st"));
	Tree.setValue(ID, "crcod1", oSect.provTbl.getValue("cr_cod1"));
	Tree.setValue(ID, "crcod2", oSect.provTbl.getValue("cr_cod2"));
	Tree.setValue(ID, "crcod3", oSect.provTbl.getValue("cr_cod3"));				 
	Tree.setValue(ID, "sum", oSect.provTbl.getValue("sum"));
	Tree.setValue(ID, "cond", oSect.provTbl.getValue("cond"));
	
	//showObject(oSect)
}

function filterMode(sID)
{
	if(sID == "ZAVAL")
	{
		return true;
	}
	
	switch(sID)
	{
	case "ADD": 
	case "COPY":
	case "ADD_NOP":
	case "ADD_SECT":
	case "ADD_PROV":
	case "PASTE":
		return getAccessOnAction("L_CLOP", "A");
	case "EDIT":
		return getAccessOnAction("L_CLOP", "E");
	case "DEL":
		return getAccessOnAction("L_CLOP", "D");		
	case "__XDEL":		
		return getAccessOnAction("L_CLOP","D") && getAccess("XDEL") != "";
	}
	return true;
}

include("sys/DpBaseDlg.js");