include("objects\\DpGrid.js");
include("doc/DpDoc.js");
var strSelectID = "0";
var nDoc;
var nNop = 0;

function listLoad()
{
      this.editTask = "e_cntrct"
      this.printLabel = "cntrct";
      
      if(typeof(Tree) == "undefined") return;
	  Tree.addItem("", "0", ru("Договора", "Договори"));

      Tree.setItemImage(TREE_ITEM, ICON_DOCFOLDER, ICON_DOCFOLDER);
      
      var sSql = "SELECT fdoc, ftxt FROM ^cl_lnk "
					+" WHERE fnop = 0 and Fis_dog <>" + sqlFalse;
						
	  sSql += " ORDER BY FTXT ";
	
	//Tree.addItem("0", "", UR("Усі|Все"), TREE_ITEM);
	
	var tblDoc = OpenTable("s", sSql);
	var sDoc1 = String(tblDoc.getValue("fdoc"));
	while(!tblDoc.isEOF())
	{
		var sDoc = String(tblDoc.getValue("fdoc"));
		Tree.addItem("0",sDoc, UR(tblDoc.getValue("ftxt")), TREE_ITEM);
		 var sSql2 = "SELECT fdoc, ftxt, fnop FROM ^cl_lnk "
				+" WHERE fnop <> 0 and Fdoc = " + sqlTo(sDoc);
					
		sSql += " ORDER BY FTXT ";
		
		var tblNop = OpenTable("s", sSql2);
		while(!tblNop.isEOF())
		{
			Tree.addItem(sDoc,sDoc + "|" + Number(tblNop.getValue("fnop")), UR(tblNop.getValue("ftxt")), TREE_ITEM);
			tblNop.moveNext();
		}
		tblNop.close();
	   	tblDoc.moveNext();
	}
	tblDoc.close();
	Tree.showItem("com.debet.dogovor");
	
	this.onTreeSelected = onTreeSelected;
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	
	if (extPar && extPar.dog != null && extPar.dog!="")
	{
		Tree.setSelected(extPar.dog);
		this.onTreeSelected(extPar.dog);
	}/*
	else if(sDoc1)
	{
		this.onTreeSelected(sDoc1);
		Tree.setSelected(sDoc1);
	}*/
	else
	{
		//список всех договоров
		this.onTreeSelected("0");
		Tree.setSelected("0");
	}
}

function onTreeSelected(strCod, strMode)
{
	if("ENTER" != strMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = strCod;
	list.subSrc();
	if (!strMode)
		list.tblInit();
}

function listAsk()
{
   include ("Objects/DpGetDat.js")
   var gd = new DpGetDat(new Array("r","o0"));
   return gd
}

function listTitle()
{
	var sTitle = UR("Список договорів|Список договоров");
	if(Number(this.objAsk.forg))
		sTitle += ": "+ this.objAsk.forg +" - "+ tcl("CL", "TXT", 0, this.objAsk.forg);
	return sTitle;
}

function listSrc()
{
	var w = "1=1";
	with(this)
	{
		w = (objAsk.dat1 && objAsk.dat2 ? 
			" AND ((FBDAT <= " + sqlTo(objAsk.dat1) + " AND FEDAT >= " + sqlTo(objAsk.dat2) +") " 
			+" OR (FBDAT >= " + sqlTo(objAsk.dat1) + " AND FBDAT <= " + sqlTo(objAsk.dat2) +") " 
			+" OR (FEDAT >= " + sqlTo(objAsk.dat1) + " AND FEDAT <= " + sqlTo(objAsk.dat2) +"))" : "")
			+ (Number(objAsk.forg)? " AND FORG = " + sqlTo(objAsk.forg) : "");
		
		if (this.doc)
		{
			w += " AND Fdoc = "+ sqlTo(this.doc);	
			nDoc = this.doc;
			nNop = 0;	
		}
		else if(strSelectID && strSelectID!="0")
		{
			var n = strSelectID.indexOf("|");
			if (n != -1)
			{
				nDoc = strSelectID.substring(0, n);
				nNop = Number(strSelectID.substring(n+1));
			}
			else
			{
				nDoc = strSelectID;
				nNop = 0;
			}
			w += " AND Fdoc = "+ sqlTo(nDoc);
			if (nNop)
			{
				w += " AND Fnop = "+ sqlTo(nNop);
			}
			
			
			
		}
		else
		{
			//если не выбран вид - показывем список всех договоров
			nDoc = "";
			nNop = 0;		
		}

		var defDog = getPar("DEF_DOG");
		if (!isEmpty(w) && !isEmpty(defDog))
		{
			w += " OR FWID = "+sqlTo(defDog)
		}
		
		qrySet(
			"From", "^CONTRACT",
			"Where", w,
			"WhereArr", new Array("FCLOSE="+ sqlFalse, "FCLOSE<>"+ sqlFalse),
			"WhereArrName", new Array("Відкриті|Окрытые", "Закриті|Закрытые"),
			"WhereArrI", 0,
			"Order", "FDOC, FORG, FDOG_NUM, FBDAT, FEDAT desc",
			"Ptn", "CONTRACT"
			);

		subTie("CLRELCLCL","CLREL","CLCOD","=0,FORG");
		subTie("CL","x_cl","FWID","CLREL.FWID_CL");

	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	
	with(oGrid)
	{
		onePageMode(false);
		
		with(page())
		{
			//контрагент отображается в заголовке окна
			if(!Number(list.objAsk.forg))
			{
				with(group("Контрагент|Контрагент"))
				{
					cell("Forg","№ | №", 4);
					cell( "x_cl.Ftxt","назва|название", 15, "w");
				}
			}
			with(group("Угода|Договор"))
			{
				cell( "Fdog_num","№ | №",15);				
				cell("=tdoc(^FDOC, 0) +' ('+ ^FDOC +')'", "вид|вид", 10);
				cell( "Ftxt","назва|название", 25, "w");								
			}
			with(group("Дата|Дата"))
			{
				cell( "Fbdat","почат.|нач.", 8);
				cell( "Fedat","закін.|оконч.", 8);
			}
            cell("Fprem","Примітки|Примечание", 20, "w");
		}
		build(); 
	}
}

function listMenuInit()
{
	with( list.dataSrc )
	{
		if(nDoc)
		{
			//AddMenuItem ("ADD_DOG", "Додати договір|Добавить договор");
			//AddMenuItem ("VIEW_DOG", "Продивитись договір|Просмотреть договор");
		}
	}
}

function filterMode(mnuID)
{
	if(mnuID == "ADD" && !nDoc)
		return false;
	if(mnuID == "DEL")
		return false;   //TODO:
	
	
	if (inList(mnuID, "ADD", "EDIT", "COPY", "DEL"))
	{
	
		var acc = (mnuID == "ADD")
				? String(getAccess(nDoc, 0))
				: String(getAccess(String(list.tbl.getValue("FDOC")), Number(list.tbl.getValue("FNOP"))));  
		if (mnuID == "ADD" && acc.indexOf("A") == -1 )
			return false;
		
		if (mnuID == "EDIT" && acc.indexOf("E") == -1 )
			return false;	
			
		if (mnuID == "DEL" && acc.indexOf("D") == -1 )
			return false;
			
		if (mnuID == "COPY" && acc.indexOf("A") == -1 )
			return false;				
			
		if (mnuID == "XDEL" && acc.indexOf("D") == -1 )
			return false;		
	
	
	}
	
	return true;
	
}

function onEditObject(ID)
{
	if(ID == "ADD")
	{
		var oDoc = new DpDoc(nDoc,nNop);		
		var par = new Object();
		if(this.objAsk && this.objAsk.forg)
		{
			oDoc.setVar("HORG", this.objAsk.forg);
			par.org = this.objAsk.forg;
		}
		return oDoc.edit("ADD", -1, par);
		
		
	}
	else
	{
		var oDoc = new DpDoc(String(list.tbl.getValue("FDOC")),Number(list.tbl.getValue("FNOP")));		
		return oDoc.edit(ID, Number(list.tbl.getValue("FWID")));
	}	
	
}

function listMenuRun(ID)
{
	if(ID == "ADD_DOG")
	{
		var oDoc = new DpDoc(nDoc,0);
		oDoc.create();
		var par = new Object();
		if(this.objAsk && this.objAsk.forg)
		{
			oDoc.setVar("HORG", this.objAsk.forg);
			par.org = this.objAsk.forg;
		}
		oDoc.edit("ADD", -1, par);
		list.tbl.requery();
		
		grid.refresh();
		
	}
	
}

include("sys\\DpList.js");