//просмотр справки в пенсионный фонд помесячной промежуточный расчет 6 таблицы
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("r_compnm.js");
include("servis/date.js");
include("get_const.js");
include("sys/udfs.js");
var sortMode = "Ftt,FTABNN";
var Ftabn = 0;
var isDblInd = false;
var dblColor = 17;
var gd, szTag;

function listLoad()
{
	this.printLabel = "COMP";
	if (!IsTable("ZPPNS6"))
	{
		return false;
	}
	this.title = UR("Перегляд 6 таблиці - |Просмотр 6 таблицы - ");
	
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("From", "ZPPNS6", "Order", getOrder(sortMode));
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with( oGrid )
	{
		defCond("=^Ftt==1", "ITOG_ALL");
		color(1, "ITOG_ALL");
		bold("ITOG_ALL");
		defCond("=^Fisdblind==true", "DBL_IND");
		color(dblColor, "DBL_IND");
	}
	
	gr.FieldEx("=(^Ftt==0)?^Ftabnn:'Итого'","Таб.№|Таб.№",6,"","%10d");	
	gr.FieldEx("=(^Ftt==1)?'':getSmallFIO(^Fld7)","ПIБ|ФИО",15);	
	gr.FieldEx("=(^Ftt==1)?'':^Fld6","Iдент-й №|Идент-й №",12);
	with(gr.group("Сума|Сумма"))
	{
		FieldEx("FLD10","доходу|дохода",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD11","дох.с огр.|дох.з гран.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD12","податку|налога",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	}
	gr.FieldEx("FLD8","Кат.\nЗО|Кат.\nЗЛ", 3, "e");
	gr.FieldEx("FLD9","Кат.\nс/сб|Кат.\nс/зб", 3, "e");
	gr.FieldEx("FLD13","Тр.\nкн.|Тр.\nкн.",3,"e");
	gr.FieldEx("FLD14","с/стаж|с/стаж",3,"e");
	gr.FieldEx("FDATF","Дата вин.|Дата возн.",10,"e");
	gr.FieldEx("FTYPR","Тип нар.|Тип нач.",5,"e");					
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
			AddMenuItem("PSOG", "Проставить сумму ограничения = сумме дохода");
			AddMenuItem("RIT","Перерахувати пiдсумки|Пересчитать итоги");
			AddMenuItem("SV11","Прост.для вiдмiч.тип нарахув.|Прост.для отмеч.тип начисл.");			
			AddMenuItem("PER7T","Перенести до 7 таблиці вiдмiч.записи|Перенести в 7 таблицу отмеч.записи");
			AddMenuItem("LT7","Переглянути попер. результати по 7 таблицi|Просмотреть предв. результаты по 7 таблице");			
			AddMenuItem("PERITM","Перерахувати кiнцевi результати персон.|Перерасчитать окончат.расчеты персониф.");												
		}
	}
}


function listMenuRun(ID)
{
	switch(ID)
	{
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
	   		var m = new Object()
			m.Fld8   = 0
			m.Fld9   = 0
			m.Fld10  = 0
			m.Fld11  = 0
			m.Fld12  = 0
			m.Fld13  = 0
			m.Fld14  = 0				
			m.Ftabn = tabn_id
			m.Ftabnn= tabn
			m.Ftt = 0
			m.Fld7  = toScrObj(t.getValue("FTXT"))
			
			var tmpName = (toScrObj(t.getValue("FTXT"))).replace("/\./g", ". ");
			var aWords = tmpName.split(" ");
       		var pfam = aWords[0]
       		var pnam = aWords[1]
       		var potch= aWords[2]
       		if (toScrObj(t.getValue("FISOTCH"))==true){
           		var pnam = aWords[1]+" "+aWords[2]
           		var potch= ""
       		}
			m.Fld7f  = toScrObj(pfam)
			m.Fld7i  = toScrObj(pnam)
			m.Fld7o  = toScrObj(potch)
			
			m.Fld6 = toScrObj(t.getValue("FINDNUM"))
			UpdateTable("ZPPNS6", m, true)
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
        case "RIT":
	  		DropTable("ZPPNS63")
	  		ExecuteSQL("delete from ZPPNS6 where Ftt=1");
	  		ExecuteSQL("select sum(a.Fld10) as Fld10, sum(a.Fld11) as Fld11,sum(a.Fld12) as Fld12, 1 as Ftt"
	          	+" into ZPPNS63 from ZPPNS6 as a where Ftt<>1")
	  		ExecuteSQL("insert into ZPPNS6 (Fld10,Fld11,Fld12,Ftt) select Fld10,Fld11,Fld12, Ftt  from ZPPNS63");	          	
			list.tbl.requery();
			grid.RefreshGrid();
	        break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
	    case "PSOG":
		  ExecuteSQL("update ZPPNS6 set Fld11=Fld10 where "+DataSource().sqlSelected());
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
	    case "SV11":
		  var codt=0;
   		  codt = input("Введите тип начисления для переноса в 7 таблицу", "Просмотр промеж.данных по персонификации", 0, 1);
		  ExecuteSQL("update ZPPNS6 set Ftypr="+sqlTo(codt)+" where "+DataSource().sqlSelected());
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
	    case "PER7T":
	      DropTable("ZPPNS7V")
		  ExecuteSQL("select * into ZPPNS7V from ZPPNS6 where "+DataSource().sqlSelected());
	  	  ExecuteSQL("insert into ZPPNS7 (Ftabn, Ftabnn, Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fld10,Fld11,Fld12,Fld13,Fld14,Fld15,Fld16,Ftt,Fmes,Ftypr) select Ftabn,Ftabnn,Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fdatf,Ftypr,Fld10,Fld11,Fld12,Fld13,Fld14,Ftt,Fdatf,1  from ZPPNS7V");
		  ExecuteSQL("delete from ZPPNS6 where "+DataSource().sqlSelected());	  	  		  
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
	    case "PERITM":
	gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm6 = "^ZPPNMVI"+szTag;
	zppnm7 = "^ZPPNMVII"+szTag;
	zppnm7d = "^ZPPNMVIID"+szTag;
	    
    //переделал на постоянные таблицы, чтоб одни и те же пользователи работающие с несколькими базами не затирали результаты предыдущей расчитанной базы
    CreateTableEx("ZRP_RES","ZRP_ZPPNMVI"+szTag, "ZPPNM6", "*");
    var zppnm6 = "^ZPPNMVI"+szTag;
    strSQL = "insert into "+zppnm6+"(Fisdblind,Ftabn,Ftabnn,Fld10,Fld11,Fld12,Ftt,Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fld13,Fld14)"
    		+" select Fisdblind,Ftabn,Ftabnn,sum(Fld10) as Fld10, sum(Fld11) as Fld11,sum(Fld12) as Fld12, 0 as Ftt,"
            	+" Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8, Fld9, Fld13,Fld14 "
            +" from ZPPNS6 "
            +" group by Ftabn,Ftabnn,Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8, Fld9, Fld13,Fld14,Fisdblind"
    ExecuteSQL(strSQL);
    
    //если прописываем дату возникновения в 7 таблице, то используем этот оператор
    //ExecuteSQL("update ZPPNS7 set Fmes="+sqlTo(d00obj)+" where Fmes="+sqlTo(bkv));
    
    //DropTable("ZPPNS71")
    CreateTableEx("ZRP_RES","ZRP_ZPPNMVII"+szTag, "ZPPNM7", "*");
    var zppnm7 = "^ZPPNMVII"+szTag;
	//если делаем дату возникновения пустой всегда в 7 таблице, то используем этот оператор    
    //strSQL ="select Fisdblind,Ftabn, Ftabnn, sum(a.Fld12) as Fld12, sum(a.Fld13) as Fld13,sum(a.Fld14) as Fld14, 0 as Ftt,"
    //        +" Fld6, Fld7, Fld7f, Fld7i, Fld7o, Fld8, Fld9, Fld10, Fld11, Fld15, Fld16 into ZPPNS71 from ZPPNS7 as a group by Ftabn, Ftabnn, Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8,Fld9,Fld10,Fld11,Fld15,Fld16,Fisdblind"
    //если прописываем дату возникновения в 7 таблице, то используем этот оператор
    strSQL ="insert into "+zppnm7+"(Fisdblind,Ftabn,Ftabnn,Fld10,Fld12,Fld13,Fld14,Ftt,Fld6,Fld7,Fld7f,Fld7i,Fld7o,Fld8,Fld9,Fld11,Fld15,Fld16)"
    		+" select Fisdblind,Ftabn, Ftabnn, Fmes as Fld10,sum(a.Fld12) as Fld12, sum(a.Fld13) as Fld13,sum(a.Fld14) as Fld14, 0 as Ftt,"
            	+" Fld6, Fld7, Fld7f, Fld7i, Fld7o, Fld8, Fld9, Fld11, Fld15, Fld16 "
            +" from ZPPNS7 as a "
            +" group by Ftabn, Ftabnn, Fld6, Fld7, Fld7f, Fld7i, Fld7o,Fld8,Fld9,Fmes,Fld11,Fld15,Fld16,Fisdblind"
    ExecuteSQL(strSQL);
    ExecuteSQL("delete from "+zppnm7+" where Fld12+Fld13+Fld14=0");

    DropTable("ZPPNS62")
    ExecuteSQL("select sum(Fld10) as Fld10, sum(Fld11) as Fld11,sum(Fld12) as Fld12, 1 as Ftt"
            +" into ZPPNS62 from "+zppnm6);
    ExecuteSQL("insert into "+zppnm6+" (Ftabn,Ftabnn,Ftt,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Fld12,Fld13,Fld14) select 0,0,Ftt,'','',0,0,Fld10,Fld11,Fld12,0,0 from ZPPNS62");

    DropTable("ZPPNS72")
    ExecuteSQL("select sum(Fld12) as Fld12, sum(Fld13) as Fld13,sum(Fld14) as Fld14, 1 as Ftt"
            +" into ZPPNS72 from "+zppnm7 )
    ExecuteSQL("insert into "+zppnm7+" (Ftabn,Ftabnn,Ftt,Fld6,Fld7,Fld8,Fld9,Fld10,Fld11,Fld12,Fld13,Fld14,Fld15,Fld16)select 0,0,Ftt,'','',0,0,"+sqlTo(d00obj)+",0,Fld12,Fld13,Fld14,0,0 from ZPPNS72");
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
		case "LT7":
		showWindow("l_comp7t.js", SW_NOMODAL);		
		break;				
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	if(list.tbl.getValue("Ftt")==0)
	{
		var n = new Object();
		n.Fld10 = list.tbl.getValue("Fld10");
		n.Fld11 = list.tbl.getValue("Fld11");
		n.Fld12 = list.tbl.getValue("Fld12");			
		n.Fld8  = list.tbl.getValue("Fld8");
		n.Fld9  = list.tbl.getValue("Fld9");
		n.Fld13  = list.tbl.getValue("Fld13");
		n.Fld14  = list.tbl.getValue("Fld14");
		UpdateTable("ZPPNS6", n, false, "Fwid="+list.tbl.getValue("Fwid"));
								
		//апдейтим общий итог
		var snap = getSnap("select SUM(Fld10),SUM(Fld11),SUM(Fld12)"
						+" from ZPPNS6 where Ftt<>1");
		if(snap)
		{
				m.Fld10 = snap[0];
				m.Fld11 = snap[1];
				m.Fld12 = snap[2];
				UpdateTable("ZPPNS6", m, false, "Ftt=1");
		}

	}
	return true;
}

function listDel()
{

	ExecuteSQL("delete from ZPPNa6 where Fwid="+list.tbl.getValue("Fwid"));
	//апдейтим общий итог
	var snap = getSnap("select SUM(Fld10),SUM(Fld11),SUM(Fld12) "
				+" from ZPPNS6 where Ftt=0");
	var m = new Object();				
	if(snap)
	{
		m.Fld10 = snap[0];
		m.Fld11 = snap[1];
		m.Fld12 = snap[2];
		UpdateTable("ZPPNS6", m, false, "Ftt=1");
	}
	return false;
}

function getTblH()
{
}

function getOrder(mode)
{
	var sOrder = "Ftt,Ftabnn";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Ftt,Fld7, Ftabnn";
		break;
		case "IND":
			sOrder = "Ftt,Fld6, Ftabnn";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");	
	