//просмотр справки в пенсионный фонд помесячной
include("gridedit.js");
include("Objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");

var sortMode = "FTT,FTABNN";
var Ftabn = 0;
var isDblInd = false;
var dblColor = 17;
var gd, szTag, zppnm7d;

function listLoad()
{
	var gd = new DpGetDat("d");
	if(gd.escape)
		return false;
	szTag = getDateTag(gd.dat1);
	zppnm7d = "^ZPPNMVIID"+szTag;
	this.printLabel = "COMP";
	if (!IsTableEx("ZRP_RES","ZRP_ZPPNMVIID"+szTag))
	{
		alert(ru("Cначала сделайте расчет таблиц 6 и 7 за ",	"Спочатку виконайте розрахунок таблиць 6 та 7 за ")+format("Mmm yyyy",gd.dat1).toLowerCase());
		return false;
	}
	else
		this.title = UR("Перегляд 7 додатк.таблиці - |Просмотр 7 дополн.таблицы - ")+format("Mmm yyyy",gd.dat1).toLowerCase();
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	var snap = getSnap("select count(*) from "+zppnm7d+" where Fisdblind="+sqlTrue)
	if(snap && snap[0]>0)
	{
		isDblInd = true;
		snap = getSnap("select count(ftabn) from "+zppnm7d+"  where Ftt=0 group by Fld6,Fld10,Fld16 having count(ftabn)>1");
		if(snap && snap[0]>1)
			dblColor = 17;
		else
			dblColor = 2;
	}
}

function listSrc()
{
	this.qrySet("From", zppnm7d, "Order", getOrder(sortMode));
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	with( oGrid )
	{
		defCond("=^Ftt==1", "ITOG_ALL");
		color(1, "ITOG_ALL");
		bold("ITOG_ALL");
		defCond("=^Fisdblind==true", "DBL_IND");
		color(dblColor, "DBL_IND");
	}
	
	gr.FieldEx("=(^Ftt==0)?^Ftabnn:'Итого'","Таб.№|Таб.№",6,"","%10d");
	gr.FieldEx("=(^Ftt==1)?'':getSmallFIO(^Fld7)","ПIБ|ФИО",15);	
	gr.FieldEx("=(^Ftt==1)?'':^Fld6","Iдент-й №|Идент-й №",12);
	if(isDblInd)
		gr.FieldEx("Fisdblind","Задв.\nід.№|Задв.\nид.№",3);
	gr.FieldEx("FLD8","Кат.\nЗО|Кат.\nЗЛ", 3, "e");
	gr.FieldEx("FLD9","Кат.\nс/сб|Кат.\nс/зб", 3, "e");
	gr.FieldEx("FLD11","Тип\nнар.|Тип\nнач.", 3, "e");	
	with(gr.group("Сума|Сумма"))
	{
		FieldEx("FLD12","доходу|дохода",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD13","дох.с огр.|дох.з гран.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
		FieldEx("FLD14","податку|налога",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	}
	gr.FieldEx("FLD10","Дата за яку\n пров.нар.|Дата за кот\n пров.нач.", 10, "e");	
	gr.FieldEx("FLD15","Тр.\nкн.|Тр.\nкн.",3,"e");
	gr.FieldEx("FLD16","с/стаж|с/стаж",3,"e");			
	oGrid.build();
}

function listMenuInit()
{
	with(this.dataSrc)
    {
		if (!list.tbl.IsEmpty())
		{
			//AddMenuItem("MININD", "Згорнути по ідентифікаційному номеру|Свернуть по идентификационному номеру");
			AddMenuItem ("","");
			switch(sortMode)
			{
				case "FIO":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО",ICON_RADIO);
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
				case "IND":
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№");
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№",ICON_RADIO);
				break;
				case "TABN":
				default:
					AddMenuItem("SORTTABN", "Сортувати по таб.№|Сортировать по таб.№",ICON_RADIO);
					AddMenuItem("SORTFIO", "Сортувати по ПІБ|Сортировать по ФИО");
					AddMenuItem("SORTIND", "Сортувати по ідент.№|Сортировать по идент.№");
				break;
			}
			AddMenuItem("","");
			AddMenuItem("ADD", ru("Добавить", "Додати"));
			AddMenuItem("EDIT","Редагувати|Редактировать");
			AddMenuItem("PSOG", "Проставить сумму ограничения = сумме дохода");	
			AddMenuItem("RIT","Перерахувати пiдсумки|Пересчитать итоги");					
			AddMenuItem("DBF_EXP",ru("Экспорт данных персонификации", "Експорт даних персоніфікації"));
		}
	}	
}


function listMenuRun(ID)
{
	switch(ID)
	{
		case "ADD":
			var form = createForm(ru("Введите табельный номер ","Введіть табельний номер "));
			pers = form.addCodPers(false,true);
			form.show();
			if(form.escape)
				return false;
			tabn = pers.getCod();
			tabn_id = pers.getFWID();
			t = OpenTable("Select * from ^listcl3 where Fwid_cl="+tabn_id);
	   		var m = new Object()
			m.Fld8   = 0
			m.Fld9   = 0
			m.Fld10  = d00obj.getVarDate()
			m.Fld11  = 0
			m.Fld12  = 0
			m.Fld13  = 0
			m.Fld14  = 0
			m.Fld15  = 0
			m.Fld16  = 0										
			m.Ftabn = tabn_id
			m.Ftabnn= tabn			
			m.Fld7  = toScrObj(t.getValue("FTXT"))
			
			var tmpName = (toScrObj(t.getValue("FTXT"))).replace("/\./g", ". ");
			var aWords = tmpName.split(" ");
       		var pfam = aWords[0]
       		var pnam = aWords[1]
       		var potch= aWords[2]
       		if (toScrObj(t.getValue("FISOTCH"))==true){
           		var pnam = aWords[1]+" "+aWords[2]
           		var potch= ""
       		}
			m.Fld7f  = toScrObj(pfam)
			m.Fld7i  = toScrObj(pnam)
			m.Fld7o  = toScrObj(potch)
			
			m.Fld6 = toScrObj(t.getValue("FINDNUM"))
			UpdateTable(zppnm7d, m, true)
			t.close();
			list.tbl.requery();
			grid.RefreshGrid();
		break;
        case "RIT":
	  		DropTable("ZPPNS73")
	  		ExecuteSQL("delete from "+zppnm7d+" where Ftt=1");
	  		ExecuteSQL("select sum(Fld12) as Fld12, sum(Fld13) as Fld13,sum(Fld14) as Fld14, 1 as Ftt"
	          	+" into ZPPNS73 from "+zppnm7d+" where Ftt<>1")
	  		ExecuteSQL("insert into "+zppnm7d+" (Fld12,Fld13,Fld14,Ftt) select Fld12,Fld13,Fld14, Ftt  from ZPPNS73");
			list.tbl.requery();
			grid.RefreshGrid();
	        break;
		case "MININD":
			var msg = ru("Данная операция предназначена для сворачивания сумм совместителей заведенных на разные табельные номера " +
					"(удобнее заводить совместителей на тотже табельный номер).\n" +
					"Суммы сворачиваются по идентификационному номеру к минимальному табельному номеру, " +
					"обратно развернуть суммы уже будет невозможно (только расчитав заново).\nПродолжить?",
					"Дана операція призначена для згортання сум сумісників заведених на різні табельні номери " +
					"(зручніше заводити сумісників на той самий табельний номер).\n" +
					"Суми згортаються за ідентифікаційним номером до мінімального табельного номеру, " +
					"назад розгорнути суми вже буде неможливо (тільки розрахував знову).\nПродовжити?");
			if(!confirm(msg))
				break;
			DropTable("dblind_min_tabn");
			//отбираем номера с максимальным табельным номером
			var ok = ExecuteSQL("select Ftabn into dblind_min_tabn from ZPPNS61 as z1 where Fisdblind="+sqlTrue+" and Ftt=0 "
						+" and Ftabn=(select MAX(Ftabn) from ZPPNS61 as z2 where z1.Fld6=z2.Fld6)");
			DropTable("tbl_sum");
			//сумируем
			if(ok)
				ok = ExecuteSQL("update ZPPNS61 as z1 "
					+" set Fld10=(select SUM(Fld10) from ZPPNS61 as z2 where z1.Fld6=z2.Fld6 and z1.Ftt=z2.Ftt), "
						+" Fld11=(select SUM(Fld11) from ZPPNS61 as z2 where z1.Fld6=z2.Fld6 and z1.Ftt=z2.Ftt), "
						+" Fld12=(select SUM(Fld12) from ZPPNS61 as z2 where z1.Fld6=z2.Fld6 and z1.Ftt=z2.Ftt) "
					+" where Fisdblind="+sqlTrue+" and not exists(select Ftabn from dblind_min_tabn as d where z1.Ftabn=d.Ftabn)");
			//удаляем номера с максимальным номером
			if(ok)
				ok = ExecuteSQL("delete from ZPPNS61 where Fisdblind="+sqlTrue+" and Ftabn in (select Ftabn from dblind_min_tabn)");
			if(ok)
			{
				dblColor = 2;
				list.tbl.requery();
				grid.DeletePages();
				list.init();
			}
		break;
		case "SORTTABN":
		case "SORTFIO":
		case "SORTIND":
			sortMode = ID.replace("SORT","");
			grid.DeletePages();
			list.init();
		break;
	    case "PSOG":
		  ExecuteSQL("update "+zppnm7d+" set Fld13=Fld12 where "+DataSource().sqlSelected());
		  list.tbl.requery();
		  grid.RefreshGrid();
          break;
		case "DBF_EXP":
			var sFileName = BrowseForFile("*.dbf",ru("Экспорт в dbf файл дополнительной 7-й таблицы","Експорт в dbf файл додаткову 7-у таблицю"),null,"save","P04t07b.dbf")
			if (sFileName)
				expToDbfMonthPers(zppnm7d, sFileName);
		break;
	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	if(list.tbl.getValue("Ftt")==0)
	{
		var n = new Object();
		n.Fld8  = list.tbl.getValue("Fld8");
		n.Fld9  = list.tbl.getValue("Fld9");
		n.Fld10  = list.tbl.getValue("Fld10");
		n.Fld11  = list.tbl.getValue("Fld11");			
		n.Fld12 = list.tbl.getValue("Fld12");
		n.Fld13 = list.tbl.getValue("Fld13");
		n.Fld14 = list.tbl.getValue("Fld14");			
		n.Fld15  = list.tbl.getValue("Fld15");
		n.Fld16  = list.tbl.getValue("Fld16");
		UpdateTable(zppnm7d, n, false, "Fwid="+list.tbl.getValue("Fwid"));
								
		//апдейтим общий итог
		var snap = getSnap("select SUM(Fld12),SUM(Fld13),SUM(Fld14)"
						+" from "+zppnm7d
						+" where Ftt<>1");
		if(snap)
		{
				m.Fld12 = snap[0];
				m.Fld13 = snap[1];
				m.Fld14 = snap[2];
				UpdateTable(zppnm7d, m, false, "Ftt=1");
		}

	}
	return true;
}

function listDel()
{
	ExecuteSQL("delete from "+zppnm7d+" where Fwid="+list.tbl.getValue("Fwid"));
	//апдейтим общий итог
	var snap = getSnap("select SUM(Fld12),SUM(Fld13),SUM(Fld14) "
				+" from "+zppnm7d+" where Ftt=0");
	var m = new Object();				
	if(snap)
	{
		m.Fld12 = snap[0];
		m.Fld13 = snap[1];
		m.Fld14 = snap[2];
		UpdateTable(zppnm7d, m, false, "Ftt=1");
	}
	return false;
}

function getTblH()
{ 
	var h = new Object();
	h.HDAT1 = gd.dat1;
	return h;
}

function getOrder(mode)
{
	var sOrder = "Ftt,Ftabnn";
	switch(String(mode))
	{
		case "FIO":
			sOrder = "Ftt,Fld7, Ftabnn";
		break;
		case "IND":
			sOrder = "Ftt,Fld6, Ftabnn";
		break;
	}
	return sOrder;
}
include("sys/DpList.js");	
	
