include("objects/DpJRegistrator.js");
include("Objects/DbImporter.js");
include("Objects/DpMsgBox.js");
include("doc/RegXP.js");
include("l_docekz.js");
include("Tmoney.js");

var sTblImp = "TMP_COMPARE_IMP";
var sTblDoc = "TMP_COMPARE_DOC";
var oImporter = null;
var sSource = "";
var sParFile = extPar.param;
var oPar;
var doc;
var nop;
var cat;
var org;
var dat1;
var dat2;
var bItog = false;

function docTitle()
{
	return UR("Звірення|Сверка") +": "+ DOC.value;
}

function docSrc()
{	
	list.subUnLoad = onClose;
	
	sTblDoc = "TMP_COMPARE_DOC";
	sTblImp = "TMP_COMPARE_IMP";
	
	doc = DOC.value;
	nop = NOP.value;
	cat = ORGCAT.value;
	org = list.oOrg.getCod();
		
	var sTblName = list.oDoc.getTableName();
	
	if(!ExecuteSQL("drop table "+ sTblDoc, false))
		ExecuteSQL("delete from "+ sTblDoc, false);
	var sSQL = "select s.*, p.FCAT into "+ sTblDoc 
				+" from ^"+ sTblName +" s "
				+" inner join ^CLRELCLCL r on r.FCOD=s.FORG"
				+" inner join ^CL_POST p on p.FWID_CL=r.FWID_CL"
				+" where s.FDOC="+ sqlTo(doc)
					+" and s.FNOP="+ sqlTo(nop)
					+" and s.FDOC_DAT>="+ sqlTo(DATB.value)
					+" and s.FDOC_DAT<="+ sqlTo(DATE.value)
					+" and r.FCL="+ getPar("CODPLAT")
					+sqlw0And("s.FORG=", org)
					+getWhereCat()					
	ExecuteSQL(sSQL);
	sSQL = "insert into "+ sTblDoc 
				+" (FWID,FDOC_NUM,FDOC_DAT,FSUM,FTOVAR,FDOC,FNOP,FPR1)"
				+" select s.FWID,s.FDOC_NUM,s.FDOC_DAT,s.FSUM,s.FTOVAR,s.FDOC,s.FNOP,s.FPR1"
				+" from ^"+ sTblName +" s " 
				+" where s.FDOC="+ sqlTo(doc)
					+" and s.FNOP="+ sqlTo(nop)
					+" and s.FDOC_DAT>="+ sqlTo(DATB.value)
					+" and s.FDOC_DAT<="+ sqlTo(DATE.value)
					+" and s.FORG=0";	
	ExecuteSQL(sSQL);
	ExecuteSQL("alter table "+ sTblDoc +" add column FTT "+ SqlType("INT") +" default 0", false);
	
	list.qrySet("From", sTblDoc
				/*,"WhereArr", Array("FTT=99"
							, "FTT<>99")							
				,"WhereArrName", Array(UR("Підсумки|Итоги")
							, UR("Без підсумків|Без итогов"))
				*/
				,"Order", "FDOC_DAT,"+ IIF("FTT in (99,999)", 0, 1) +",FSUM");
	
	docGridInit();	
	//docDateValid();
	
	docFilter();
}

function docGridInit()
{
	/*
	var xmlgrid = list.docList.getGrid();
	if(!xmlgrid)
		return;
	grid.DeletePages();
	grid.parseXML(xmlgrid.xmlNode);
	*/
	grid.defCond("1", "=^FTT==1");
	grid.defCond("2", "=^FTT==2");
	grid.defCond("9", "=^FTT==9");
	grid.defCond("99", "=^FTT==99");
	grid.defCond("999", "=^FTT==999");
	grid.color(13, "1");
	grid.color(14, "2");
	grid.color(12, "9");
	grid.color(18, "99");
	grid.color(17, "999");	
	grid.bold("99");
	grid.bold("999");
	
	if(grid.getTable())
	{
		grid.getTable().requery();
		grid.refresh();
	}
	//grid.build();
	selRow(1);
}

function init()
{
	this.option = option;
	setButton(btnOPT, this, "option");	
	this.load = load;
	setButton(btnLOAD, this, "load");	
	this.clear = clear;
	setButton(btnCLEAR, this, "clear");	
	this.compare = compare;
	setButton(btnCOMP, this, "compare");	
	this.select = select;
	setButton(btnSEL, this, "select");	
	this.importSel = importSel;
	setButton(btnIMP, this, "importSel");
	this.copySel = copySel;
	setButton(btnCOPY, this, "copySel");
	this.next = next;
	setButton(btnNEXT, this, "next");	
	this.prev = prev;
	setButton(btnPREV, this, "prev");
	this.filter = filter;
	setButton(btnAPPLY, this, "filter");
	
	btnCOMP.getCtrl().setToolTipText(UR("Порівняти|Сравнить"));
	btnNEXT.getCtrl().setToolTipText(UR("Наступний|Следующий"));
	btnPREV.getCtrl().setToolTipText(UR("Попередній|Предыдущий"));
	btnSEL.getCtrl().setToolTipText(UR("Виділити не знайдені|Выделить не соответствующие"));
	btnCOPY.getCtrl().setToolTipText(UR("Копіювати|Копировать"));
	btnIMP.getCtrl().setToolTipText(UR("Імпортувати|Импортировать"));
	
	btnIMP.getCtrl().setText("<");	
	//btnCOMP.getCtrl().setBackground(new Packages.org.eclipse.swt.graphics.Color(null,255,0,255));
	
	FKOL_DOC.mask = "#########";
	FKOL_IMP.mask = "#########";
	Disable(FKOL_DOC);
	Disable(FSUM_DOC);
	Disable(FKOL_IMP);
	Disable(FSUM_IMP);
	
	Disable(btnCLEAR);
	//Disable(btnLOAD);
	Disable(btnCOMP);
	Disable(btnSEL);
	Disable(btnIMP);
	Disable(btnCOPY);
		
	this.selDocHandler = selDocHandler;
	grid.setSelHandler(this, "selDocHandler");
	/*
	this.docMenuInit = doc_menuInit;
	this.docMenuRun = doc_menuRun;
	grid.loadMenuHandler(this,"docMenuInit");
	grid.selectMenuHandler(this,"docMenuRun");
	*/
	this.selImpHandler = selImpHandler;
	this.gridMenuInit = gridMenuInit;
	this.gridMenuRun = gridMenuRun;
	gridIMP.setSelHandler(this, "selImpHandler");	
	gridIMP.loadMenuHandler(this,"gridMenuInit");
	gridIMP.selectMenuHandler(this,"gridMenuRun");
		
	//setValid(DATB, docDateValid);
	//setValid(DATE, docDateValid);
	
	DATB_IMP.value = new Date(1900, 0, 01).getVarDate();
	DATE_IMP.value = d00;
	
	list.init();
}

function docDateValid()
{	
	DATB_IMP.value = DATB.value;
	DATE_IMP.value = DATE.value;
	
	dat1 = DATB_IMP.value;
	dat2 = DATE_IMP.value;
}

function listAfterLoad()
{
	itog();
}

function option()
{
	var par = new Object();
	par.mode = "option";	
	par.source = FILE.value;	
	par.param = getOrgPath() +"import/PV_U.xml";
	var cat = ORGCAT.value;
	if(cat==1 || cat=="1")
		par.param = getOrgPath() +"import/PV_F.xml";
	par.base = getPath("ALL_MDB");
	showWindow("dbimport.xml", SW_MODAL, par);
	/*
	if(par.escape)
	{
		return false;
	}
	*/
	oImporter = par.oImporter;
	oPar = par.oPar;
	if(oImporter)
	{
		//oImporter.getJSFile(oPar.sParFile);
		Enable(btnLOAD);
		sSource = DpFile(oPar.sFile).getPath();
		sParFile = DpFile(oPar.sParFile).getPath();
		FILE.value = sSource;
		oImporter.init(sSource, oPar.encoding, oPar.delimiter, sParFile);
	}	
}

function loadImporter()
{
	sSource = FILE.value;
	sParFile = getOrgPath() +"import/PV_U.xml";
	cat = ORGCAT.value;
	if(cat==1 || cat=="1")
		sParFile = getOrgPath() +"import/PV_F.xml";
	
	oImporter = new DbImporter();
	oImporter.init(sSource, sParFile, "cp1251", "	");
	//oImporter.loadVars(sParFile);
	
	return oImporter;
}

function load()
{
	var sSource = FILE.value;
	if(!sSource || sSource=="")
	{
		setFocus(FILE);
		return false;
	}
	
	if(!oImporter)
		loadImporter();
	
	var oPar = new Object();
	/*	
	oPar.sParFile = getOrgPath() +"import/PV_U.xml";
	var cat = ORGCAT.value;
	if(cat==1 || cat=="1")
		oPar.sParFile = getOrgPath() +"import/PV_F.xml";
	*/
	//oPar.sParFile = oImporter.sFileParam;
	//oPar.encoding = oImporter.encoding;
	//oPar.delimiter = oImporter.delimiter;
	//oPar.importer = oImporter.xmlImporter;
	//oPar.actionType = "IMPORT";
	//oPar.sFile = oImporter.sFileSource;
	
	oPar.sBase = getPath("ALL_MDB");	
	oPar.sType = "doc";
	oPar.sTblTo = DOC.value;
	oPar.objCod = NOP.value;
	oPar.sParFile = sParFile;
	oImporter.sFileSource = FILE.value;
	
	var sTblSource = oImporter.runCSV(oPar, true);
	if(!sTblSource)
		return false;
	var tbl = OpenTable(sTblSource);
	var bAdd = gridIMP.getTable()!=null;
	
	oImporter.importTbl(sTblImp, tbl, bAdd);
	tbl.close();
	
	gridInit();
	
	Enable(btnCOMP);
	Enable(btnCLEAR);	
}

function clear()
{
	if(gridIMP.getTable()==null)
		return;
	//oImporter.createTbl(sTblImp);
	ExecuteSQL("delete from "+ sTblImp);
	gridIMP.getTable().requery();
	gridIMP.refresh();
	
	ExecuteSQL("delete from "+ sTblDoc +" where FTT in (9,99,999)", false);
	ExecuteSQL("update "+ sTblDoc +" i set i.FTT=0");
	grid.getTable().requery();
	grid.refresh();
}

function gridInit()
{
	gridIMP.DeletePages();
	gridIMP.defCond("1", "=^FTT==1");
	gridIMP.defCond("2", "=^FTT==2");
	gridIMP.defCond("9", "=^FTT==9");
	gridIMP.defCond("99", "=^FTT==99");
	gridIMP.defCond("999", "=^FTT==999");
	gridIMP.color(13, "1");
	gridIMP.color(14, "2");
	gridIMP.color(12, "9");
	gridIMP.color(18, "99");
	gridIMP.color(17, "999");
	gridIMP.bold("99");
	gridIMP.bold("999");
	
	ExecuteSQL("alter table "+ sTblImp +" add column FID_DOC "+ SqlType("LONG"), false);
	ExecuteSQL("alter table "+ sTblImp +" add column FWID "+ SqlType("COUNTER"), false);
	ExecuteSQL("alter table "+ sTblImp +" add column FTT "+ SqlType("INT") +" default 0", false);
	
	dat1 = DATB_IMP.value;
	dat2 = DATE_IMP.value;
		
	tbl = OpenTable("select * from "+ sTblImp
			+" where HDAT>="+ sqlTo(dat1) +" and HDAT<="+ sqlTo(dat2) 
			+" order by HDAT,"+ IIF("FTT in (99,999)", 0, 1) +",HSUM");
	var oFldInfo = tbl.fieldsInfo;
	for(var i=0; i<oFldInfo.length; i++)
	{
		var oFld = oFldInfo[i];
		if(!oFld)
			continue;
		var sFld = oFld.name;
		if(sFld!="FTT" && sFld!="FWID")
		{
			gridIMP.FieldEx("=^FTT==9? '' : ^"+ sFld, sFld, 10);
		}
		if(sFld=="FTT")
		{
			gridIMP.FieldEx("=^FTT==1? 'Дата не совпадает' "
							+":^FTT==2? 'Сумма не совпадает' "
							+":^FTT==9? 'Документ не найден' "
							//+":^FTT==99? 'Совпадают '"
							+":^FTT==999? 'Не совпадают '"
							+":''", sFld, 10);
		}
	}
		
	gridIMP.setTable(tbl);
	gridIMP.build();
	itog();
}

function itog()
{	
	var tblDoc = grid.getTable();
	var tblImp = gridIMP.getTable();
	
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var doc = DOC.value;
	var nop = NOP.value;
	var cat = ORGCAT.value;
		
	var oSnap = getSnap("select count(*) as cnt, sum(FSUM) as FSUM"
					+" from ^"+ sTblDoc 
					+" where FTT in (0,1,2)"
				, false);
	if(oSnap)
	{
		FKOL_DOC.value = oSnap[0];
		FSUM_DOC.value = oSnap[1];				
	}
	
	if(!tblImp)
		return; 
		
	oSnap = getSnap("select count(*) as cnt, sum(HSUM) as FSUM"
					+" from ^"+ sTblImp 
					+" where FTT in (0,1,2)"
						+" and HDAT>="+ sqlTo(dat1) +" and HDAT<="+ sqlTo(dat2)
				, false);
	if(oSnap)
	{
		FKOL_IMP.value = oSnap[0];
		FSUM_IMP.value = oSnap[1];
	}
}

function compare()
{
	var tblDoc = grid.getTable();
	var tblImp = gridIMP.getTable();
	
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	doc = DOC.value;
	nop = NOP.value;
	cat = ORGCAT.value;
	
	var nPr = 1;
	var sTxt = UR("Звірення...|Сверка...");
	setProgressRange(0, 15);
	setProgressPos(nPr++, sTxt);
	
	list.init();
	setProgressPos(nPr++, sTxt);
			
	ExecuteSQL("delete from "+ sTblImp +" where FTT in (9,99,999)", false);
	ExecuteSQL("delete from "+ sTblDoc +" where FTT in (9,99,999)", false);
	setProgressPos(nPr++, sTxt);
	
	ExecuteSQL("alter table "+ sTblDoc +" add column FTT "+ SqlType("INT") +" default 0", false);
	ExecuteSQL("alter table "+ sTblImp +" add column FTT "+ SqlType("INT") +" default 0", false);
	setProgressPos(nPr++, sTxt);
	
	ExecuteSQL("update "+ sTblImp +" i set i.FTT=0");
	ExecuteSQL("update "+ sTblDoc +" i set i.FTT=0");
	setProgressPos(nPr++, sTxt);
	
	sSQL = "update "+ sTblImp +" i set i.FTT=1 "
			+" where i.HDAT not in (select d.FDOC_DAT "
				+" from "+ sTblDoc +" d where d.FSUM=i.HSUM)";
	ExecuteSQL(sSQL);	 
	setProgressPos(nPr++, sTxt);
	
	sSQL = "update "+ sTblImp +" i set i.FTT=2 "
			+" where "+ sqlRound("i.HSUM", 2) +" not in (select "+ sqlRound("d.FSUM", 2)
					+" from "+ sTblDoc +" d) "
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sTxt);
		
	sSQL = "update "+ sTblDoc +" d set d.FTT=1 "
			+" where d.FDOC_DAT not in (select i.HDAT "
				+" from "+ sTblImp +" i where i.HSUM=d.FSUM)";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sTxt);
	
	sSQL = "update "+ sTblDoc +" d set d.FTT=2 "
			+" where "+ sqlRound("d.FSUM", 2) +" not in (select "+ sqlRound("i.HSUM", 2)
					+" from "+ sTblImp +" i "
					+" where i.HDAT>="+ sqlTo(dat1) +" and i.HDAT<="+ sqlTo(dat2) 
					+") "
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sTxt);

	sSQL = "insert into "+ sTblImp +"(FID_DOC,HDAT,HSUM,FTT)"
			+" select FWID as FID_DOC, FDOC_DAT as HDAT, FSUM as HSUM, 9 as FTT "
			+" from "+ sTblDoc 
			+" where FTT in (1,2)";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sTxt);
	
	sSQL = "insert into "+ sTblDoc +"(FWID,FDOC_DAT,FSUM,FTT)"
			+" select FWID, HDAT, HSUM, 9 as FTT "
			+" from "+ sTblImp 
			+" where FTT in (1,2)"
				+" and HDAT>="+ sqlTo(dat1) +" and HDAT<="+ sqlTo(dat2);
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sTxt);
	
	compareTable(sTblDoc, sTblImp);
	setProgressPos(nPr++, sTxt);
		
	gridInit();
	setProgressPos(nPr++, sTxt);
	docGridInit();	
	setProgressPos(nPr++, sTxt);
	
	Enable(btnSEL);
	Enable(btnIMP);
	Enable(btnCOPY);
	
	itog();
	if(bItog)
		gridMenuRun("ITOG");
	
	setProgressPos(0);
}

function compareTable(sTblDoc, sTblImp)
{
	var kolImp = Number(FKOL_IMP.value);
	var kolDoc = Number(FKOL_DOC.value);
	//if(kolImp==kolDoc)
	//	return true;
		
	ExecuteSQL("delete from "+ sTblImp +" where FTT in (99,999)", false);
	ExecuteSQL("delete from "+ sTblDoc +" where FTT in (99,999)", false);
		
	var d1 = new Date(DATB.value);
	var d2 = new Date(DATE.value);
	/*
	if(differ(d1,new Date(1900,0,1))==0)
		d1 = new Date(DATB.value);
	if(differ(d2,new Date(d00))==0)
		d2 = new Date(DATE.value);
	*/
	var nDay = d2.getDate();
	for(var i=d1.getDate(); i<=nDay; i++)
	{
		var date = d1;
		date.setDate(i);
		
		var divKol = 0;
		var divSum = 0;
		var cnt1 = 0;
		var cnt2 = 0;
		var sum1 = 0;
		var sum2 = 0;
		var oSnap = getSnap("select count(*) as cnt, sum(FSUM) as FSUM "
							+" from "+ sTblDoc 
							+" where FDOC_DAT="+ sqlTo(date)
								+" and FTT in (0,1,2)");
		if(oSnap)
		{
			cnt1 = Number(oSnap[0]);
			sum1 = Number(oSnap[1]);
		}
		var oSnap = getSnap("select count(*) as cnt, sum(HSUM) as HSUM "
							+" from "+ sTblImp 
							+" where HDAT="+ sqlTo(date)
								+" and FTT in (0,1,2)");
		if(oSnap)
		{
			cnt2 = Number(oSnap[0]);
			sum2 = Number(oSnap[1]);
		}
		divKol = cnt1-cnt2;
		divSum = sum1-sum2;
		
		var ftt = 99;
		if(cnt1!=cnt2 || sum1!=sum2)
			ftt = 999;
		
		var sTxt = UR("Разом:|Итого:");		
		sSQL = "insert into "+ sTblDoc +"(FDOC_NUM,FPR1,FDOC_DAT,FSUM,FTT)"
					+" values("+ sqlTo(sTxt) +","+ sqlTo(cnt1) +","+ sqlTo(date) +", "+ sqlTo(sum1) +", "+ ftt +")";
		ExecuteSQL(sSQL);
		
		sSQL = "insert into "+ sTblImp +"(HTOVAR,HTOT,HDAT,HSUM,FTT)"
					+" values("+ sqlTo(sTxt) +","+ sqlTo(cnt2) +","+ sqlTo(date) +", "+ sqlTo(sum2) +", "+ ftt +")";
		ExecuteSQL(sSQL);		
		
		/*
		for(var n=0; n<div; n++)		
		{
			sSQL = "insert into "+ sTblImp +"(HDAT,HSUM,FTT)"
					+" values("+ sqlTo(date) +", 0, 9)";
			ExecuteSQL(sSQL);
		}
		
		for(var n=0; n>div; n--)
		{
			sSQL = "insert into "+ sTblDoc +"(FDOC_DAT,FSUM,FTT)"
					+" values("+ sqlTo(date) +", 0, 9)";
			ExecuteSQL(sSQL);
		}
		*/
	}
}

function select()
{	
	var arrSel = new Array();
	var tbl = OpenTable("select FWID from "+ sTblImp 
					+" where FTT=2 "
						+" and HDAT>="+ sqlTo(dat1) +" and HDAT<="+ sqlTo(dat2)
					);
	for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		arrSel[arrSel.length] = Number(tbl.getValue("FWID"));
	}
	tbl.close();
	/*
	var sSel = java.lang.String(grid.sqlSelected());
	if(sSel.indexOf("=")!=-1)
		sSel = sSel.substring(sSel.indexOf("="));
	if(sSel.indexOf(" in ")!=-1)
		sSel = sSel.substring(sSel.indexOf(" in "));
	sSel = sSel.replaceAll(" ", "");
	var arrSel = sSel.split(",");
	*/ 
	gridIMP.setSelectedIDs(arrSel);
	gridIMP.refresh();
}

function importSel(rowID)
{
	oImporter.getJSFile(oImporter.sFileParam);
	var sWhere = " where "+ gridIMP.sqlSelected();
	if(rowID && typeOf(rowID)=="Integer")
		sWhere = " where FWID="+ rowID;
	sWhere += " and FTT<9";
	var tbl = OpenTable("select * from "+ sTblImp + sWhere);
	oImporter.importDoc(DOC.value, NOP.value, tbl);	
	tbl.close();
	
	ExecuteSQL("update "+ sTblImp +" set FTT=0 "+ sWhere);	
	ExecuteSQL("update "+ sTblDoc +" d set d.FTT=0 where d.FWID in (select FWID from "+ sTblImp + sWhere +")");	
	//ExecuteSQL("delete from "+ sTblDoc +" d where d.FWID in (select FWID from "+ sTblImp + sWhere +")");
	
	compareTable(sTblDoc, sTblImp);
	gridIMP.getTable().requery();
	gridIMP.refresh();
	grid.getTable().requery();
	grid.refresh();	
	//compare();
	itog();
}

function copySel()
{
	if(Number(grid.getTable().getValue("FTT"))>9)
		return;	
	var sSQL = "insert into "+ sTblImp +" (HDAT,HSUM,FTT)"
				+" select FDOC_DAT, FSUM, 9 as FTT "
				+" from "+ sTblDoc
				+" where "+ grid.sqlSelected();
	ExecuteSQL(sSQL);
	compareTable(sTblDoc, sTblImp);
	gridIMP.getTable().requery();
	gridIMP.refresh();	
	//compare();
	itog();
}

function next()
{
	//findRow(grid, true);
	findRow(gridIMP, true);
}

function prev()
{
	//findRow(grid, false);
	findRow(gridIMP, false);
}

function findRow(oGrid, bNext)
{
	if(!oGrid)
		return;
		
	var tbl = oGrid.getTable();
	if(tbl!=null)
	{
		//var pos = tbl.getAbsolute();
		var nSel = Number(oGrid.getRowSelected());
		tbl.setAbsolute(nSel);
		//pos = Number(pos)+1;
		if(bNext)
		{
			tbl.MoveNext();
			nSel++;
		}
		else
		{
			tbl.MovePrev();
			nSel--;
		}
		
		while(Number(tbl.getValue("FTT"))==0 && !tbl.isEOF() && !tbl.isBOF())
		{			
			if(bNext && !tbl.isEOF())
			{
				tbl.MoveNext();
				nSel++;
			}
			else if(!tbl.isBOF())
			{
				tbl.MovePrev();
				nSel--;
			}
			else
			{
				return;
			}
		}
		
		//tbl.setAbsolute(pos); 
		selRow(nSel, oGrid);			
	}
}

function selRow(nSel, oGrid)
{
	if(!oGrid)
		oGrid = grid;
	if(!oGrid.getTable() || !oGrid.getTableControl())
		return;	
	if(!nSel)
		nSel = 1;
	//tbl.setAbsolute(nSel);
	//tbl.bookmark = nSel;
	oGrid.getTableControl().setSelection(1, nSel, true);
	//oGrid.RefreshGrid();
	//oGrid.setFocus();	
}

function selDocHandler()
{		
	var nSel = Number(grid.getRowSelected());
	selRow(nSel, gridIMP);
	if(Number(grid.getTable().getValue("FTT"))<9)
		Enable(btnCOPY);
	else
		Disable(btnCOPY);
}

function selImpHandler()
{	
	var nSel = Number(gridIMP.getRowSelected());
	selRow(nSel, grid);
	if(Number(gridIMP.getTable().getValue("FTT"))<9)
		Enable(btnIMP);
	else
		Disable(btnIMP);
}

function gridMenuInit(ds)
{
	var tbl = gridIMP.getTable();
	if(tbl.isEmpty())
		return false;
	
	if(Number(tbl.getValue("FTT"))==99 || Number(tbl.getValue("FTT"))==999)
	{
		if(IsDblClick(gridIMP))
		{
			gridMenuRun("OPEN");
			return true;
		}
		ds.AddMenuItem("OPEN", "Розкрити|Раскрыть");
		ds.AddMenuItem("OPEN_ALL", "Розкрити усі|Раскрыть все");
	}
	ds.AddMenuItem("ITOG", "Підсумки|Итоги");
	if(Number(tbl.getValue("FTT"))<9)
		ds.AddMenuItem("IMPORT", "Імпорт|Импорт");		
	if(Number(tbl.getValue("FTT"))<=9)
		ds.AddMenuItem("DEL", "Видалити|Удалить");
}

function gridMenuRun(sID)
{
	var tbl = gridIMP.getTable();
	var rowID = tbl.getValue("FWID");
	if(sID=="IMPORT")
	{
		importSel(rowID);
	}
	else if(sID=="DEL")
	{
		if(Number(tbl.getValue("FTT"))>9)
			return;
		ExecuteSQL("delete from "+ sTblImp +" where FWID="+ rowID);
		compare();
	}
	else if(sID=="ITOG")
	{
		bItog = true;
		filter("FTT in (99,999)");
		docFilter("FTT in (99,999)");		
	}
	else if(sID=="OPEN")
	{
		bItog = true;
		var date = tbl.getValue("HDAT");
		filter("(FTT in (99,999) or HDAT="+ sqlTo(date) +")");
		docFilter("(FTT in (99,999) or FDOC_DAT="+ sqlTo(date) +")");
	}
	else if(sID=="OPEN_ALL")
	{
		bItog = false;
		filter();
		docFilter();		
	}
}

function filter(subWhere)
{
	dat1 = DATB_IMP.value;
	dat2 = DATE_IMP.value;
	doc = DOC.value;
	nop = NOP.value;
	cat = ORGCAT.value;
	org = list.oOrg.getCod();
	
	if(gridIMP.getTable())
		gridIMP.getTable().close();
	
	var sWhere = " where HDAT>="+ sqlTo(dat1) +" and HDAT<="+ sqlTo(dat2);
	if(typeOf(subWhere)=="string" || typeOf(subWhere)=="String")
		sWhere += " and "+ subWhere;
	tbl = OpenTable("select * from "+ sTblImp 
			+ sWhere
			+" order by HDAT,"+ IIF("FTT in (99,999)", 0, 1) +",HSUM");
	gridIMP.setTable(tbl);
	gridIMP.refresh();
}

function docFilter(subWhere)
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var doc = DOC.value;
	var nop = NOP.value;
	var cat = ORGCAT.value;
	var org = list.oOrg.getCod();
	
	//if(grid.getTable())
	//	grid.getTable().close();
	
	var sWhere = " where FDOC_DAT>="+ sqlTo(dat1) +" and FDOC_DAT<="+ sqlTo(dat2);
	if(typeOf(subWhere)=="string" || typeOf(subWhere)=="String")
		sWhere += " and "+ subWhere;
	var tbl = OpenTable("select * from "+ sTblDoc
			+ sWhere
			+" order by FDOC_DAT,"+ IIF("FTT in (99,999)", 0, 1) +",FSUM");
	grid.setTable(tbl);
	grid.refresh();
}

function getWhereCat()
{
	var sWhere = "";
	cat = ORGCAT.value;
	if(cat && cat!="")
		sWhere = " and (p.FCAT="+ sqlTo(cat) +" or p.FCAT is NULL)";
	return sWhere;
}

function onClose()
{
	if(grid && grid.getTable())
		grid.getTable().close();
	if(gridIMP && gridIMP.getTable())
		gridIMP.getTable().close();
		
	ExecuteSQL("drop table "+ sTblImp, false);
	ExecuteSQL("drop table "+ sTblDoc, false);		
}

function onAfterMenuRun(sID)
{
	//compare();
}

function doc_menuInit()
{
	var tbl = grid.getTable();
	if(tbl && !tbl.isEmpty())
	{
		if(IsDblClick())
		{
			//docMenuRun("FINDDOC");
			return true;
		}
		grid.AddMenuItem("","");
		grid.AddMenuItem("FINDDOC", "Знайти документ|Найти документ");
	}	
}

function doc_menuRun(sID)
{
	var tbl = grid.getTable();
	if(sID=="FINDDOC")
	{
		var m = new Object();
		m.doc = tbl.getValue("FDOC");
		m.nop = tbl.getValue("FNOP");
		m.dat = tbl.getValue("FDOC_DAT");
		m.org = tbl.getValue("FORG");
		m.fid_doc = tbl.getValue("FWID");
		
		showWindow("l_docekz.xml", SW_NOMODAL, m);
	}
}

include("sys/DpList.js");
init();