//просмотр формы 3
include("objects\\DpTVars.js");
include("objects\\DpGrid.js");
include("objects\\DpGetDat.js");
include("gridedit.js");
include("r_comsbc.js");
include("sys/DpList.js");

var mode;
var dpGridEdit = null;

function listLoad()
{
	this.title = ru("Просмотр формы 3","Перегляд форми 3");
	this.printLabel = "EDGN_T";
	//this.xmlGridFile = "l_comsum.xml";	
	mode=GetMenuMode();
	if (mode=="R")
	{
		var par=new Object();
		par.sysname=getSysName();
		par.escape=false;
		par.xyear = getParWithDef("DAT1_P", par.sysname, d00);
		par.xyeare = getParWithDef("DAT2_P", par.sysname, d00);
		par.zeroMode = true;
		par.KLS = 0;		
		showWindow( "i_comsum.xml", SW_MODAL, par);	
		setParWithDef("DAT1_P", par.xyear, par.sysname);
		setParWithDef("DAT2_P", par.xyeare, par.sysname);
		
		//var oGD = new DpGetDat("dD");
		//par.xyear = oGD.dat1;
		//par.xyeare = oGD.dat2;
		if (par.escape)
			return false;
		
	   PRIK_table = OpenTable("s","SELECT * FROM ^CL_PRIK")
	   var vvprk = "";
	   PRIK_table.MoveFirst();
	   while (!PRIK_table.IsEOF())
	   {
			if (String(PRIK_table.getValue("Fproc")).indexOf("_nlgn")!=-1)
				vvprk = PRIK_table.getValue("Fvid")
	        PRIK_table.MoveNext();
	   }
	   PRIK_table.close();	   
	   if (vvprk ==""){
		   WAIT("ошибка - не найдена запись с под.налогом в CL_PRIK")
		   return false;
	   }   
		
	   r_comsbc(par, vvprk);
	}
	else
	{
		if (!IsTable("PNALGOD"))
	    { 
   		    alert(ru("Произведите сначала расчёт формы 3",
   		    		"Спершу виконайте розрахунок форми 3"));
        	return false;
    	}
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
	
}

function listSrc()
{
	this.qrySet("From", "PNALGOD", "Order", "Fcod",
			"WhereArr", new Array("^Fis_uv="+sqlTrue, 
					"^Fis_uv="+sqlFalse));
	this.subTie("cl","cl","Fwid","Ftabn_id");
}

function gridEdit(modeID)
{
	if(modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsumall = list.tbl.getValue("Fsumall");
	m.Fsumzp = list.tbl.getValue("Fsumzp");
	m.Fsumlg = list.tbl.getValue("Fsumlg");
	m.Fvznos = list.tbl.getValue("Fvznos");
	m.Fsumzp_s = list.tbl.getValue("Fsumzp_s");	
	m.Fnalo = list.tbl.getValue("Fnalo");
	m.Fraznn = list.tbl.getValue("Fraznn");	
	m.Flen_per = list.tbl.getValue("Flen_per");	
	UpdateTable("PNALGOD", m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	gr.FieldEx("Fcod","Таб.№|Таб.№",5,"e","%10d");
	gr.FieldEx("=getSmallFIO(^cl.Ftxt)","ПIБ|ФИО",15);
	gr.FieldEx("Fsumall","Заг.сума|Общая сумма",GRID_SUM_WDT, "e",DP_FORMAT_SUM);	
	gr.FieldEx("Fsumzp","Заг.оподатк.сума|Общая облаг.сумма",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsumlg","Сума пiльг|Сумма льгот",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fvznos","Сума фондiв|Сумма фондов",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsumzp_s","ЗП сум.|ЗП совм.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);	
	gr.FieldEx("Fnalo","Утрим.податок|Удерж.налог",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fbdat","Початок роботи у роцi|Начало работы в году",10, "e");
	gr.FieldEx("Fedat","Кiнець роботи у роцi|Конец работы в году",10, "e");
	gr.FieldEx("Flen_per","Кiльк.мiс.роботи|Колич.мес.работы",10, "e");
	gr.FieldEx("Fis_uv","Звiльн.|Уволен.",5, "e");	
	//gr.FieldEx("Fnaln","Нарах.податок|Начисл.налог",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	oGrid.build();
}

function listMenuInit()
{
	DataSource().AddMenuItem("PRTRSH","Печать формы 4 (форма 3 с расшифровкой)");	
}

function listMenuRun(ID)
{
	switch(ID)
	{
	
		case "PRTRSH":
			tv = new DpTVars(this.printLabel);
			tbl = OpenTable("Select * From PNAL_PER where Ftabn_id=" + sqlTo(list.tbl.getValue("Ftabn_id")));
			h = new Object();
			h.FTABN_ID = list.tbl.getValue("Ftabn_id");
			h.FCOD     = list.tbl.getValue("Fcod");
			h.FBDAT    = list.tbl.getValue("Fbdat");
			h.FEDAT    = list.tbl.getValue("Fedat");			
			h.FLEN_PER = list.tbl.getValue("Flen_per");
			h.FSUMALL  = list.tbl.getValue("Fsumall");
			h.FSUMZP   = list.tbl.getValue("Fsumzp");
			h.FSUMLG   = list.tbl.getValue("Fsumlg");			
			h.FVZNOS   = list.tbl.getValue("Fvznos");
			h.FNALO    = list.tbl.getValue("Fnalo");			
			tv.setHTbl(h);
			tv.setRTbl(tbl);
			tv.print();
			break;
	}	
}
