include("objects/DpGrid.js");
include("servis/date.js");
include("servis/format.js");
include("GetParam.js");

var menuMode;

function listLoad()
{
	this.printLabel = "COMSRFZ";
	this.title = UR("Довiдка про середню ЗП до фонду зайнятості|Справка о средней ЗП в фонд занятости");
	menuMode = GetMenuMode();

	if (!IsTable("ZPSRFZ") && menuMode == "VIEW")
	{
		alert(ru("Сперва выполните расчет справки!","Спочатку зробiть розрахунок довідки!"));
		return false;
	}
}

function listAsk()
{
	include("objects\\DpAskEx.js");

	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "BDAT", new Date().getVarDate());
	oA.add("D", "Дата кінця|Дата конца", "EDAT", new Date().getVarDate());
	oA.add("CL", "Таб. №", "TABN", "1", getPar("CODPERS"));
	oA.add("CALEND", "№ календаря|№ календаря", "CAL_NUM", "1000");
	oA.setRel(">=", "EDAT1", "BDAT1");
	oA.doAsk();
	if(oA.escape)
	{
		CloseWindow();
	}
	return oA;
}

function listSrc()
{
	this.qrySet("From","ZPSRFZ");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	gr.FieldEx("=^Ftt==0?^Ftabn:UR('Всього|Итого')","Таб.№|Таб.№",5,"","%10d");
	gr.FieldEx("Fmes","Мiсяць|Месяц",8);
	//gr.FieldEx("Fdn_tot","Днiв|Дней",3);
	//gr.FieldEx("Fdn","Днiв|Дней",3);
	gr.FieldEx("FDAYS_TXT","Днiв|Дней", 3);
	gr.FieldEx("Fsum_zp","Сума нарах.ЗП|Сумма начисл.ЗП",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsum_st","ЗП,з якої спл.внески|ЗП,с кот.упл.взносы",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsum_pf","Сума пенс.фонду|Сумма пенс.фонда",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsum_bz","Сума по безр.|Сумма по безр.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	gr.FieldEx("Fsum_ss","Сума тимч.непр.|Сумма врем.нетр.",GRID_SUM_WDT, "e",DP_FORMAT_SUM);
	oGrid.build();
}

function listMake()
{
	xyear = new Date(this.objAsk.get("BDAT"))
	xyeare = new Date(this.objAsk.get("EDAT"))
	fwid_cl = this.objAsk.get("TABN").getFWID();
	tabn = this.objAsk.get("TABN").getCod();

	xyear = firstDayMonth(xyear);
	xyeare = lastDayMonth(xyeare);

	var SALL_table;
	var kk;

	kk = Math.round(day_difference(xyear,xyeare)/30);

	WAIT(ru("Проводится расчет за "+xyear.getYear()+" год","Проводиться розрахунок за "+xyear.getYear()+" рік"));

	CreateTableEx("ZRP_RES", "ZRP_SVZP_ALL1", "SVZP_ALL", "*");

	DropTable("ZPSRFZ2");

	var m = new Object();
	m.FWID = "COUNTER";
	m.FTABN = "LONG";
	m.FTABN_ID = "LONG";
	m.FCOD = "TEXT(10)";
	m.FMES = "DATE";
	m.FDN = "INTEGER";
	m.FDN_TOT = "INTEGER";
	m.FTT = "INTEGER";
	m.FSUM_ZP = "MONEY";
	m.FSUM_ST = "MONEY";
	m.FSUM_PF = "MONEY";
	m.FSUM_BZ = "MONEY";
	m.FSUM_SS = "MONEY";
	m.FSREND = "MONEY";
	m.FBLNDAYS = "LONG";
	m.FDAYS_TXT = "TEXT";
	CreateTable("ZPSRFZ",m);

	WAIT(ru("Шаг 1 - формирование сводного файла","Крок 1 - формування зведеного файлу"));

	var bkv = new Date(xyear);

	var i=1;
	while (i<=kk)
	{
		var xfile = "SVZP"+getDateTag(bkv);
		if (IsTableEx("ZRP_RES","zrp_"+xfile))
		{
			ExecuteSQL(" INSERT INTO ^svzp_all1(FTABN_ID, FWID_WP, FLSFID, "
							+"FFLD_NUM, FSUM, FBDY, FEDY, "
							+"FDAY, FIS_DAY, FMN, FVP, FMF, FMES) SELECT "
							+"FTABN_ID, FWID_WP, FLSFID, "
							+"FFLD_NUM, FSUM, FBDY, FEDY, "
							+"FDAY, FIS_DAY, FMN, FVP, "
							+sqlTo(bkv)+" as FMF, "
							+sqlTo(bkv)+" as FMES "
						+" FROM ^"+xfile+" "
						+" WHERE (FVP<>1 OR FMN<="+sqlTo(bkv)+")"+(fwid_cl?" and Ftabn_id="+fwid_cl:""));
		}
		bkv = goMonth(bkv,1);
		i++;
	}

	SALL_table = OpenTable("select * from ^SVZP_ALL1 order by Fmes");
	WAIT("Шаг 2 - вычисление сводных сумм");

	var pFmes;
	var pFtabn;

	if (!SALL_table.IsEOF())
	{
		pFmes = SALL_table.getValue("Fmes");
		pFtabn = SALL_table.getValue("Ftabn_id");
	}

	while (!SALL_table.IsEOF())
	{
		while (!SALL_table.IsEOF() && differ(new Date(pFmes),new Date(SALL_table.getValue("Fmes")))==0)
		{
			var ssum_zp = 0;	// Сумма начислений
			var ssum_st = 0;	// Сумма начислений, с кот.плат.соцстрах
			var ssum_pf = 0;	// сумма пенс.фонда
			var ssum_bz = 0;	// сумма фонда занятости
			var ssum_ss = 0;	// Сумма соцстраха
			var dn      = 0;	// дней работы

			while (!SALL_table.IsEOF() && differ(new Date(pFmes),new Date(SALL_table.getValue("Fmes")))==0 && SALL_table.getValue("Ftabn_id")==pFtabn)
			{
				var mFsum = Number(SALL_table.getValue("Fsum"));
				var mFmf = SALL_table.getValue("Fmf");
				var mFlsfid = SALL_table.getValue("Flsfid");
				var mFmes = SALL_table.getValue("Fmes");
				// проверка входимости в налогооблагаемую сумму
				Lic_table = getSnap("select Fis17,Fis8,Fis1,Fis6 from ^LIC_FLD "
							  +"where Fis_slct="+sqlTrue+" and Fid="+mFlsfid);
				if (!Lic_table)
				{
					alert("Обнаружена серьезная ошибка функционирования системы\n      Ссылка на неизвестное поле лицевого счета     \n      Пригласите разработчиков для устранения       ");
					return;
				}
				else
				{
					var fld_mrk  = Lic_table[0];
					var fld_mrk1 = Lic_table[1];
					var fld_mrk2 = Lic_table[2];
					var fld_mrk3 = Lic_table[3];

					ssum_zp = (fld_mrk3=="н"?ssum_zp+mFsum:ssum_zp);
					ssum_st = (fld_mrk3=="н"?ssum_st+mFsum:ssum_st);
					ssum_pf = (fld_mrk1=="п"?ssum_pf+mFsum:ssum_pf);
					//ssum_bz = (fld_mrk2=="з"?ssum_bz+mFsum:ssum_bz);
					ssum_bz = (inList(fld_mrk1,"5","6","7") || fld_mrk2=="з"?ssum_bz+mFsum:ssum_bz);
					ssum_ss = (fld_mrk1=="с"?ssum_ss+mFsum:ssum_ss);
				}
				SALL_table.MoveNext();
			}

			var nFtabn = pFtabn;
			var nFwid_cl, nFcod;

/*
			var mFvsego_d = 0;
			var snap = getSnap("select Fkoldn from ^cl_kalen where Fbdat="+sqlTo(firstDayMonth(pFmes)));
			if (snap && snap[0])
				mFvsego_d = snap[0];
			else
				alert(ru("Нет инф-ии в справочнике кол-ва календарных дней для отпускных за ",
					"Немає інф-ії в довіднику кількості календарних днів для відпускних за ")+format("Mmm yyyy",pFmes).toLowerCase()+"\n"+
					ru("Занесите данные в меню: ","Занесіть данні в меню: ")+getMenuItemPath("l_kalen.js","l"));
*/
			//*************************************************************
			var m = new Object();
			m.Ftabn_id = pFtabn;
			m.Ftt = 0;
			m.Fsum_zp = ssum_zp;
			m.Fsum_st = ssum_st;
			m.Fsum_pf = ssum_pf;
			m.Fsum_bz = ssum_bz;
			m.Fsum_ss = ssum_ss;
			m.Fmes = pFmes;
			// с 2006 года надо все календарные дни
			kolDays = lastDay(new Date(pFmes)).getDate();
			var blnDays = getDaysBln("", firstDayMonth(pFmes), pFtabn, this.objAsk.get("CAL_NUM"), xfile);
			m.FBLNDAYS = blnDays;
			m.Fdn_tot = kolDays;
			m.Fdn = kolDays - blnDays;
			UpdateTable("ZPSRFZ", m, true);

			if (!SALL_table.IsEOF())
			{
				pFtabn = SALL_table.getValue("Ftabn_id");
				pFmes = SALL_table.getValue("Fmes");
			}
		}
	}

	// подбивка итогов по табельному номеру по ZPSRFZ
	ExecuteSQL("select "
				+" Ftabn_id as Ftabn_id, "
				+" sum(FBLNDAYS) as FBLNDAYS, "
				+" sum(Fdn_tot) as Fdn_tot, "
				+" sum(Fdn) as Fdn, "
				+" sum(Fsum_zp) as Fsum_zp, "
				+" sum(Fsum_st) as Fsum_st, "
				+" sum(Fsum_pf) as Fsum_pf, "
				+" sum(Fsum_bz) as Fsum_bz, "
				+" sum(Fsum_ss) as Fsum_ss, "
				+" 1 as FTT, "
				+sqlTo(d00)+" as Fmes "
				+" into ZPSRFZ2 FROM ZPSRFZ "
				+" group by Ftabn_id");

	ExecuteSQL("INSERT INTO ZPSRFZ " + getColumn("ZPSRFZ2", true) + " SELECT " + getColumn("ZPSRFZ2", false) + " FROM ZPSRFZ2");
	ExecuteSQL("update ZPSRFZ set Fcod=(select Findnum from ^cl_homo as h where h.Fwid_cl=ZPSRFZ.Ftabn_id)");
	ExecuteSQL("update ZPSRFZ set Ftabn=(select Fcod from ^clrelclcl as r where r.Fwid_cl=ZPSRFZ.Ftabn_id)");
	
	
	strSQL = "UPDATE "
				+" ZPSRFZ"
			+" SET "
				+" FDAYS_TXT = "+IIF("FBLNDAYS=0", "RTrim("+Convert("FDN", "STR")+")", SqlConCat("RTrim("+Convert("FDN", "STR")+")", SqlConCat(sqlTo(" + "), "RTrim("+Convert("FBLNDAYS", "STR")+")", sqlTo(ru(" больн.", " лік.")))))
	ExecuteSQL(strSQL);
	
}

function getTblH()
{
	var obj = new Object();
	obj.FTABN = this.tbl.getValue("FTABN");
	obj.FCOD  = this.tbl.getValue("FCOD");
	var snap = getSnap("select Fdn,Fsum_st from ZPSRFZ where Ftabn_id="+this.tbl.getValue("Ftabn_id")+" and Ftt=1");
	if(snap && snap[0])
		obj.FSRED = round(snap[1]/snap[0], 2);
	else
		obj.FSRED = 0;
	return obj;
}

function listMenuInit()
{
	var ds = DataSource();
}

function listMenuRun(ID)
{
	switch (ID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":
			break;
		case "PRITS":
			break;
		case "EXPNF":
			r_imppns();
			break;
	}
}

function getDaysBln(mode, dat, tabn_id, oCalend, SVZPFILE)
{
	// выберем приказы по больничным, которые попадают в расчетный период
	var D1 = firstDay(dat);
	var D2 = lastDay(dat);
	strSQL = " SELECT "
				+" P.FTABN_ID"
				+", "+IIF("P.FBDAT < "+sqlTo(D1), Convert(sqlTo(D1),"DATE"), " P.FBDAT")+" AS FBDAT"
				+", "+IIF("P.FEDAT > "+sqlTo(D2), Convert(sqlTo(D2),"DATE"), " P.FEDAT")+" AS FEDAT"
			+" FROM "
				+" ^PRK_ALL P"
			+" WHERE 1=1"
				+" AND P.FTABN_ID = "+sqlTo(tabn_id)
				+" AND ((P.FBDAT <= " + sqlTo(D1) + " AND P.FEDAT >= " + sqlTo(D2) +") "
				+" OR (P.FBDAT >= " + sqlTo(D1) + " AND P.FBDAT <= " + sqlTo(D2) +") "
				+" OR (P.FEDAT >= " + sqlTo(D1) + " AND P.FEDAT <= " + sqlTo(D2) +"))"
				+" AND P.FIN_TABLE = 'PRK_BLNOBSH'"
	var t = OpenTable("s", strSQL);

	var daysBol = 0;
	for (; !t.IsEOF(); t.MoveNext())
	{
		// количество дней больничных, кроме праздничных
		var dat1 = new Date(t.getValue("FBDAT"));
		var dat2 = new Date(t.getValue("FEDAT"));
		daysBol += oCalend.getCalDays("В|Р|П", dat1, dat2);
	}

	if(isEmpty(daysBol))
	{
		strSQL = " SELECT"
						+" sum(S.FDAY) AS FDAY"
						+", sum(S.FCHAS) AS FCHAS"
					+" FROM"
						+" ^"+SVZPFILE+" S"
						+", ^LIC_FLD L"
					+" WHERE 1 = 1"
						+" AND S.FLSFID = L.FID"
						+" AND L.FIS19 = 'б'"
						+" AND S.FTABN_ID = "+sqlTo(tabn_id)
		var s = getSnap(strSQL);
		if (s != null)
		{
			if(!isEmpty(s[0]))
			{
				daysBol = s[0];
			}
		}
	}

	return daysBol;
}
include("sys/DpList.js");