include("objects\\DpGrid.js");
include("objects\\DpGetDat.js");
include("Objects/DpAskEx.js");

var strSelectID = "0";
var oDat;
var oYear;
var oMonth;
var tblName;
var tblOldName;
var button=true;
var dat1;
var dat2;
var sID;
var tblPers;
var prevDat;
var calcNum = 0;
var isDrb = SUBD==DERBY //на дерби запрос с предаставлением может выполняться очень долго

function listAsk()
{
	if(getPar("ZRP_PRIVAT_CALCS"))
	{
		var oAsk = new DpAskEx();
		oAsk.add("D","Дата початку|Дата начала","DAT1", getPar("GLOBDAT1"));
		oAsk.add("B","Основні особові рахунки по фондам|Основные лицевые счета по фондам","ISBASE", true);
		oAsk.add("CL","ОР за окремим розрахунком|ЛС по отдельному расчету","CALC", 0, getPar("ZRP_PRIVAT_CALCS"));
		oAsk.defCond("this.aQryList['ISBASE'].controls[0].checked == false", "COND_IS_PRIVAT");
		oAsk.enable("CALC", "COND_IS_PRIVAT");
		oAsk.doAsk();
		var gd = new Object();
		gd.escape = oAsk.escape;
		if(!oAsk.escape)
		{	
			gd.dat1 = oAsk.get("DAT1"); 
			if(!oAsk.get("ISBASE"))
			{
				gd.calcNum = oAsk.get("CALC").getCod();
				list.title = UR("Особисті рахунки по фондам|Лицевые счета по фондам")+" ("+UR(oAsk.get("CALC").getTxt())+")";
			}
			else
				gd.calcNum = 0;			
		}
		list.objAskIs = true;
	}
	else
	{
		var	gd = new DpGetDat("d");
	}
	return gd;
}

function listLoad()
{
	if(typeof(Tree) == "undefined")
		return false;
	this.onTreeSelected = onTreeSelected;
	Tree.setTreeSelHandler(this, "onTreeSelected");	
	this.loadTreeMenu = loadTreeMenu;
	Tree.loadMenuHandler(this, "loadTreeMenu");
	this.runTreeMenu = runTreeMenu;
	Tree.selectMenuHandler(this, "runTreeMenu");
	
	HDAT.setSelectionHandler(HDAT_change);
	setValid(HDAT,HDAT_valid);
	Tree.addAccel(0, ".", "NEXT_DAT");
	Tree.addAccel(0, ",", "PREV_DAT");
	grid.addAccel(0, ".", "NEXT_DAT");
	grid.addAccel(0, ",", "PREV_DAT");
	NEXT_DAT.getCtrl().setToolTipText(UR("Наступний місяць|Следующий месяц"));
	PREV_DAT.getCtrl().setToolTipText(UR("Попередній місяць|Предыдущий месяц"));
	setButton(PREV_DAT, prev);
	setButton(NEXT_DAT, next);
	list.title = UR("Особисті рахунки по фондам|Лицевые счета по фондам");
}

function HDAT_valid()
{
//	Tree.removeAll();
//	tblPers.close();
//	listMake();
//	list.subSrc();
//	list.tblInit();
	prevDat = HDAT.value;
}

function HDAT_change()
{
	if(differ(HDAT.value,prevDat)!=0)
	{
		Tree.removeAll();
		tblPers.close();
		listMake();
		list.subSrc();
		list.tblInit();
	}
}

function next()
{
	HDAT_valid();
	var dat = new Date(HDAT.value);
	dat = new Date(dat.getFullYear(), dat.getMonth()+1, 1);
	if (!IsTableEx("ZRP_RES","zrp_svpf"+(calcNum>0?calcNum:"")+getDateTag(dat)))
	{
		alert("За заданный период зарплата по фондам не расчитана!");
		return false;
	}
	HDAT.value = dat.getVarDate();
	list.subSrc();
	list.tblInit();
	if(list.tbl)
		list.tbl.addQuery();
	buildTree();
}

function prev()
{
	HDAT_valid();
	var dat = new Date(HDAT.value);
	dat = new Date(dat.getFullYear(), dat.getMonth()-1, 1);
	if (!IsTableEx("ZRP_RES","zrp_svpf"+(calcNum>0?calcNum:"")+getDateTag(dat)))
	{
		alert("За заданный период зарплата по фондам не расчитана!");
		return false;
	}
	HDAT.value = dat.getVarDate();
	list.subSrc();
	list.tblInit();
	if(list.tbl)
		list.tbl.addQuery();
	buildTree()
}

function onTreeSelected(strCod, strMode)
{
	if("ENTER" != strMode 
	&& strSelectID == Tree.getSelected())
		return;

	strSelectID = strCod;
	list.subSrc();
	if (!strMode)
		list.tblInit();
}

function listSrc()
{
	if (HDAT.isNull())
		HDAT.value = list.objAsk.dat1;
	prevDat = HDAT.value;
	if(list.objAsk.calcNum)
		calcNum = list.objAsk.calcNum;
	var oSnap = getSnap("SELECT sd.Foklad, cv.Fvopl, cv.Fnzv_vopl FROM ^work_pers AS wp "
				+ "INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
				+ "INNER JOIN ^cl_vopl AS cv ON wp.Fvopl=cv.Fvopl"
			+" WHERE wp.Fwid_cl="+sqlTo(Number(strSelectID))+" AND cv.Fgroup="+sqlTrue);
	if(oSnap!=null)
	{
		HOKLAD.text = " Оклад: " + oSnap[0];
		HVOPL.text = ru("Вид оплаты: ","Вид оплати: ") + oSnap[1] + "(" + oSnap[2] + ")";
	}
	
	oDat = dat1;
	oYear = String(HDAT.getYear());
	oMonth = String(HDAT.getMonth());
	tblOldName = tblName;
	
	if (oMonth<10)
		tblName ="svpf"+(calcNum>0?calcNum:"") + oYear+"0"+oMonth;
	else
		tblName ="svpf"+(calcNum>0?calcNum:"") + oYear+oMonth;	
	
	var sWhere = "Ftabn_id=" + strSelectID + (getPar("SHOW_PAST_LS")?"":" AND  NOT (Fvp=1 AND Fmn>=" + sqlTo(HDAT.value)+")");
	
	if (!IsTableEx("ZRP_RES","zrp_"+tblName))
	{
		alert("За заданный период зарплата не расчитана!");
		tblName = tblOldName;
		if(!IsTableEx("ZRP_RES","zrp_"+tblName))
		{
			CloseWindow();
			return false;	
		}
	
		sWhere = "1<>1";	
	}
	with(list)
		{
			qrySet(
					"From","^"+tblName
					,"Where",sWhere
					,"Order","ffld_num,fpr,fmn,fsum"	
				);
		 	subTie("lic_fld", "ls", "lic_fid", "flsfid");
		 	subTie("work_pers", "wp", "fwid", "fwid_wp");
		}
}

function listMake()
{
	if(typeof(Tree) == "undefined")
		return;
	buildTree();
}

function buildTree()
{
	dat1 = toScriptDate(firstDayMonth(HDAT.value));
	dat2 = toScriptDate(lastDayMonth(HDAT.value));
	DropTable("tmp_work_pers");
	ExecuteSQL("SELECT * INTO tmp_work_pers FROM ^work_pers");
	DropTable("TABN_BUF");
	ExecuteSQL("select DISTINCT Ftabn_id into TABN_BUF from ^"+tblName);
	if(Number(ReadParEx("MINLS"))==1 || isDrb)//если есть параметр, то не выводим отсутствующих
	{
		var sSql = "SELECT rel.fcod,cl.ftxt as ftxt,wp.fwid as fid_wp,wp.fwid_cl as ftabn_id,cl_2.ftxt as fdol "
	      			+ " FROM ^work_pers as wp inner join ^stru_dol as dol on wp.fwid_dol=dol.fwid "
	      			+ " inner join ^clrelclcl as rel_2 on dol.fcod=rel_2.fcod and rel_2.fcl=" + getPar("CODDOL")
	      			+ " inner join ^cl as cl_2 on cl_2.fwid=rel_2.fwid_cl"
	      			+ " inner join ^clrelclcl as rel on wp.fwid_cl=rel.fwid_cl "
	      			+ " inner join ^cl as cl on cl.fwid=rel.fwid_cl"
	      			+ " inner join TABN_BUF as s on s.Ftabn_id=wp.Fwid_cl ";
	      
		sSql += " WHERE (wp.Fbdat<="+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ")"
				+ " AND wp.Fwid=(SELECT MIN(Fwid) FROM tmp_work_pers AS wp2 WHERE wp2.Fwid_cl=wp.Fwid_cl AND wp2.Fbdat<="+sqlTo(dat2)+" AND wp2.Fedat>="+sqlTo(dat1)+")"
							
		sSql += " ORDER BY rel.fcod ";
	}
	else
	{
		
		sSql = "SELECT  DISTINCT s.Ftabn_id, r.Fcod, f.Ftxtpers as Ftxt, f.Ftxtdol as Fdol"
			//джоинить с clrelclcl все-равно прийдётся чтобы выводить и те табельные номера, которых уже нет в ШР
			+" FROM TABN_BUF as s LEFT JOIN ^clrelclcl as r ON s.Ftabn_id=r.Fwid_cl "
			+" LEFT JOIN ^full_pers as f ON s.Ftabn_id=f.Fwid_cl "
			+" WHERE f.Fwid=(SELECT MIN(Fwid) FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl AND wp.Fbdat<="
							+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ") "
						+" OR (NOT EXISTS(SELECT Fwid FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl AND wp.Fbdat<="
							+sqlTo(dat2)+" AND wp.Fedat>="+sqlTo(dat1) + ") "
							+" AND f.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp WHERE s.Ftabn_id=wp.Fwid_cl ))"
			//+" ORDER BY r.Fcod ";
		sSql += " ORDER BY r.fcod ";
	}
	
	Tree.removeAll();
	tblPers = OpenTable(sSql);
	tblPers.MoveFirst();
	while(!tblPers.isEOF())
	{
		var cod = String(tblPers.getValue("ftabn_id"));
		Tree.addItem("0",cod, tblPers.getValue("fcod")+"." + getSmallFIO(String(tblPers.getValue("ftxt"))) + "(" + tblPers.getValue("fdol")+")", TREE_ITEM);
	   	tblPers.moveNext();
	}
	
	if (strSelectID != 0)
		Tree.setSelected(strSelectID);
	else
	{
		tblPers.MoveFirst();
		strSelectID = String(tblPers.getValue("Ftabn_id"));
		Tree.setSelected(strSelectID);
		list.subSrc();
	}
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");

	with(oGrid)
	{
		onePageMode(false);

		defCond("=(^Ffld_num==80||^Ffld_num==107)", "ITOG_ALL");
		color(26, "ITOG_ALL");
		
		defCond("=(^Ffld_num==112)", "ITOG_GET");
		bold("ITOG_GET");
		color(25, "ITOG_GET");
		
		defCond("=isLastLS(^Fvp,^Fmn)", "PAST_LS");
		color(12, "PAST_LS");

		with(page())
		{
			cell("ls.ftxt", "Поле\nособистого рахунку|Поле\nлицевого счета", 18);
			cell("fsum", "Сума|Сумма", GRID_SUM_WDT, "", DP_FORMAT_SUM);
			cell("fproc", "%", 4, "", DP_FORMAT_SUM);
			//cell("Fpr", "Збiр|Сбор", 8);
			cell("fday", "днів|дней", 5, "", "%3");
			cell("fchas", "годин|часов", 5, "", "%3");
			cell("=(^Fis_day==2?'л':'')", "", 2);
			with (group("Сплачено|Выплачено"))
			{
				var str = "=(^Fvp==1? format('mm/yy', ^Fmn):"+
							"(^Fvp==2? format('mm/yy',HDAT.value): ''))";
				cell(str, "в", 5, "r");
				str = "=(^Fvp==1?format('mm/yy', HDAT.value):"+
							"(^Fvp==2? format('mm/yy', ^Fmn): ''))";
				cell(str, "за", 5, "r");
				str = "=((^Fvid_prk!=0) && (^Fid_prk!=0))?'+':''";
				cell(str, "", 2);
			}
			cell("fshpz", "ШВВ|ШПЗ", 10);
			cell("wp.Fid", "Код ШР|Код ШР", 5);
			cell("Fvid_prk", "Код\nПриказу|Код\nПриказа", 8);
		}
		build(); 
	}
}

function listMenuInit()
{
	with( list.dataSrc )
	{
		
	}
}

function filterMode(mode)
{
	if(mode.indexOf("DEL")!=-1)
		return false;
	return true;
}

function listMenuRun(ID)
{
	switch(ID)
	{
		
	}
}

function loadTreeMenu(oTree)
{	
	oTree.AddMenuItem("NEXT_DAT", "Наступний місяць|Следующий месяц");
	oTree.AddMenuItem("PREV_DAT", "Попередній місяць|Предыдущий месяц");
	if(!isDrb)
	{
		if(Number(ReadParEx("MINLS"))==1)
			oTree.AddMenuItem("MAXIMIZE", "Відображати усі записи|Отображать все записи");
		else
			oTree.AddMenuItem("MINIMIZE", "Відображати тільки коректні записи|Отображать только коректные записи");
	}
}

function runTreeMenu(sID)
{
	switch(String(sID))
	{
		case "NEXT_DAT":
			next();
			break;
		case "PREV_DAT":
			prev();
			break;
		case "MINIMIZE":
			WriteParEx("MINLS",1)
			buildTree();
			break;
		case "MAXIMIZE":
			WriteParEx("MINLS",0)
			buildTree();
			break;
	}	
}

function isLastLS(Fvp,Fmn)
{
	if(Fvp==1 && differ(new Date(Fmn),new Date(HDAT.value))>=0)
		return true;
	else
		return false;
}
include("sys\\DpList.js");