// JScript source code
include("objects/DpJournal.js");
include("sys\\DpList.js");


function listLoad()
{
	with( this )
	{
		title = UR("CRM: Робота з клієнтами|CRM: работа с клиентами");
		//editTask = "e_list.xml";
		printLabel = "LIST";
		xmlGridFile = "l_crm.xml";
	}
	journal = new DpJournal("U", "CRM")
	
	include ("objects/DpCl.js");		
	this.dpOrg = new DpCl("0");
	this.dpOrg.setClcl(getPar("CODPLAT"))
	this.dpOrg.linkSmartCtrl(ORG);
	this.dpOrg.setContAssist();	
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	setButton(butt, reloadList);
	setValid(TYPEPER, onChangePeriod);
	
	if (typeOf(FORM) == "DpViewPart")
	{
		this.onMessage = onMessage;
		FORM.setMessageHandler(this, "onMessage")
	}
	
	this.clearFilter = clearFilter;
	grid.setClearFilterHandler(this, "clearFilter");
}

function listSrc()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	if(extPar && extPar.org!=null)
		this.dpOrg.setCod(extPar.org);
		
	var sWhere = "1=1";	
	if(differ(dat1, d00)<0)
		sWhere = " HDAT >= "+ sqlTo(dat1);
	if(differ(dat2, d00)<0)
		sWhere += " and HDAT <= "+ sqlTo(dat2);	
	if (this.dpOrg.getCod())
		sWhere += " and HORG = " + this.dpOrg.getCod();
	if(extPar && extPar.dog!=null)
		sWhere += " and HDOG = " + extPar.dog;
	if(extPar && extPar.subWhere)
		sWhere += " and ("+ extPar.subWhere +")";
	
	this.qrySet("From", "^LISTDOCCRM"
				, "Where", sWhere
				, "Order", "HDAT desc");
	/*
	var sTblName = journal.getFullTableName();
	//this.qrySet("From", sTblName, "Where", sWhere);	
	this.qrySet("Fields", "j.*, cl.FTXT, lnk.FTXT as FDOC_TXT"
				, "From", sTblName +" as j "
					+" inner join ^CLRELCLCL rel on rel.FCOD=j.HORG and rel.FCL="+ getPar("CODPLAT")
					+" inner join ^CL cl on cl.FWID=rel.FWID_CL "
					+" inner join ^CL_LNK lnk on lnk.FDOC=j.HDOC and lnk.FNOP=j.HNOP"
				, "Where", sWhere);
	*/
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
}

function listMenuInit(ds)
{
	if(this.tbl.isEmpty())
		return;

	if(IsDblClick())
	{
		listMenuRun("FINDDOC");
		return true;
	}
	ds.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
	ds.AddMenuItem("VIEWDOC","Перегляд документу|Просмотр документа", "view");	
}

function listMenuRun(sID)
{
	if(sID=="FINDDOC")
	{
		var m = new Object();
		m.doc = list.tbl.getValue("HDOC");
		m.nop = list.tbl.getValue("HNOP");
		m.dat = list.tbl.getValue("HDAT");
		m.org = list.tbl.getValue("HORG");
		m.fid_doc = list.tbl.getValue("HID_DOC");	
		
		showWindow("l_docekz.xml", SW_NOMODAL, m);
	}
	if (sID == "VIEWDOC")
	{
		include("doc/DpDoc.js");
		var doc = String(this.tbl.getValue("HDOC"));
		var nop = this.tbl.getValue("HNOP");
		var fid_doc = this.tbl.getValue("HID_DOC");
		
		var oDoc = new DpDoc(doc,nop,this);
		oDoc.edit("VIEW",fid_doc);		
	}	
}

function filterMode(s)
{
	return true;		
}

function onMessage(sType, oPar)
{
	extPar.dat = oPar.dat;
	extPar.jID = oPar.jID;
	extPar.org = oPar.org;
	extPar.dog = oPar.dog;
	list.reLoad();
}

function reloadList()
{
	list.tbl.clearQuery();
	list.tblSrc[list.tblSrcNo] = "";
	list.reLoad();
}

function clearFilter()
{
	if(list.dpOrg!=null)
	{
		list.dpOrg.setCod("");
		list.reLoad();
	}
}