//Редактирование задолженостей за будущие периоды
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");

var szTag;
var dpGridEdit = null;

function listLoad()
{
	var gd = new DpGetDat("d");
	if (gd.escape)
		return false;
	this.title = "Список заборгованостей на майбутні періоди |Список задолженностей за будущие периоды "+format("dd.mm.yyyy",gd.dat1);
	this.xmlGridFile = "l_dlg.xml";
	szTag = getDateTag(gd.dat1);

	if (!IsTableEx("ZRP_MDB","ZRP_DLG"+szTag))
	{
		alert(ru("Произведите сначала расчет!","Виконайте спершу розрахунок!"));
		return false;
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("Fields", "s.*, rel.Fcod",
				"From", "^dlg"+szTag+" AS s LEFT JOIN ^clrelclcl AS rel ON s.Ftabn_id=rel.Fwid_cl",
				"Order", "rel.Fcod");
	this.subTie("LIC_FLD","LCFLD","FID","FLSFID");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
	this.qrySet("Alias", "s");
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^dlg"+szTag+" WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
}

function gridEdit(modeID)
{
	if(modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	UpdateTable("^dlg"+szTag, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

include("sys/DpList.js");