include("sys/mask.js");
include("Objects/DpLabel.js");

var mode;
var labels;

function Load()
{
	Caption( ru("Метки", "Мiтки"));
	mode = extPar.mode;
	var dlgBuilder = FORM.getDialogBuilder();
	var ctrlComp = FORM.getControlComposite();
	
	include ("objects/DpXMLDomDocument.js");
	var xmlDom = new DpXMLDOMDocument();
	
	
	labels = new DpLabel().getAllLabels();
	if (labels.length == 0)
	{
		return false;
	}
	
	for (var i = 0; i < labels.length; i++)
	{
		var ctrlId = labels[i].getID();
		var txt = labels[i].getName();
		if (txt)
			txt = ctrlId + ": " + txt;
		else
			txt = ctrlId;
		
		var xmlCheck = xmlDom.createElement("CheckBox");
		xmlCheck.setAttribute("ID", ctrlId);
		xmlCheck.setAttribute("text", txt);
		
		//var gd = new Packages.org.eclipse.swt.layout.GridData();
		//FORM.AddCheckBox(txt, ctrlId);
		var ctrl = dlgBuilder.addCheckBox(ctrlComp, xmlCheck.xmlNode);
		if (extPar && extPar.doc && extPar.nop != null)
		{
			if (labels[i].usedForDoc(extPar.doc, extPar.nop))
			{
				ctrl.checked = true;
			}
		}
	}
	
	
	
}

function onSave()
{
	for (var i = 0; i < labels.length; i++)
	{
		var ctrlId = labels[i].getID();
		if (document[ctrlId].checked)
		{
			if (extPar && extPar.doc && extPar.nop != null)
			{
				labels[i].addToDoc(extPar.doc, extPar.nop);
			}
		}
		
	}
}