include ("Objects\\DpExtentionBuilder.js");
include ("Objects\\DpGetDat.js");


function listLoad()
{
	with(this)
	{
		title = "Інформація про стан заключення договорів";
		xmlGridFile = "l_dogovora.xml";
	}
}


function listAsk()
{
	return new DpGetDat("dD");
}

function listSrc()
{
	this.qrySet("From","VED_DOG"
				,"Order","Flpu,Fregion"
				);
	this.clTie("lpu","=" + sqlTo(getPar("CODPLAT"))+", FLPU", "a1");
	this.clTie("reg","=" + sqlTo(getPar("CODREGION"))+", FREGION","a2");
}

function listMake()
{
	DropTable("VED_DOG");
		
	ExecuteSQL("CREATE TABLE VED_DOG ("
					+ "FREGION " + SqlType("LONG") + ", "
					+ "FLPU " + SqlType("LONG") + ", "
					+ "FBUD_1 " +SqlType("INT") + ", "
					+ "FBUD_2 " +SqlType("INT") + ", "
					+ "FBUD_3 " +SqlType("INT") + ", "
					+ "FBUD_4 " +SqlType("INT") + ", "
					+ "FBUD_5 " +SqlType("INT") + ", "
					+ "FBUD_6 " +SqlType("INT") + ", "
					+ "FBUD_7 " +SqlType("INT") + ", "
					+ "FBUD_8 " +SqlType("INT") + ", "
					+ "FBUD " +SqlType("INT")
					+ ")"
				);	

	var strSQL;
	
	var dt1 = new Date(list.objAsk.dat1.getYear() + 1900,0,1);
	var dt2 = new Date(list.objAsk.dat1.getYear() + 1900,11,31);
	
	var oExt = new DpExtentionBuilder("CL","0",null);
	var tblEName = oExt.getValueTableName();
	
	strSQL="INSERT INTO VED_DOG (FREGION, FLPU,FBUD_1)"
			+ "(SELECT h.FREGION,h.FLPU, count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 AND ext.F_budjet is null GROUP BY h.FREGION,h.FLPU)";
	
	ExecuteSQL(strSQL);
	
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_4 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=4)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_2 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=2)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_3 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=3)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_5 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=5)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_6 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=6)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_7 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=7)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG as ved set ved.FBUD_8 ="
			+ " (SELECT count(h.FREGION) from "
			+ " ^CONTRACT as c INNER JOIN ^HTD as h ON c.FWID=h.FID_DOG "
			+ " INNER JOIN ^CLRELCLCL as cl ON c.Forg=cl.Fcod LEFT JOIN " +tblEName 
			+ " as ext ON ext.Fmainwid=cl.fwid_cl "  
			+ " WHERE c.FBDAT>=" + sqlTo(dt1) + " AND c.FEDAT<=" + sqlTo(dt2) 
			+ " AND cl.Fcl=12 and ved.fregion=h.fregion AND ext.F_budjet=8)";
			
	ExecuteSQL(strSQL);
	
	strSQL = "UPDATE VED_DOG set FBUD=FBUD_1+FBUD_2+FBUD_3+FBUD_4+FBUD_5+FBUD_6+FBUD_7+FBUD_8";
	
	ExecuteSQL(strSQL);
	
	
	strSQL = "INSERT INTO VED_DOG (FLPU,FREGION,FBUD_1,FBUD_2,FBUD_3,FBUD_4,FBUD_5,FBUD_6,FBUD_7,FBUD_8,FBUD)"
			+ " SELECT FLPU,0 as FREGION,SUM(FBUD_1),SUM(FBUD_2),SUM(FBUD_3),SUM(FBUD_4),SUM(FBUD_5),SUM(FBUD_6),SUM(FBUD_7),SUM(FBUD_8),SUM(FBUD)"
			+ " FROM VED_DOG"
			+ " GROUP BY FLPU";
	
	ExecuteSQL(strSQL);
	
	strSQL = "INSERT INTO VED_DOG (FLPU,FREGION,FBUD_1,FBUD_2,FBUD_3,FBUD_4,FBUD_5,FBUD_6,FBUD_7,FBUD_8,FBUD)"
			+ " SELECT -1 as FLPU,0 as FREGION,SUM(FBUD_1),SUM(FBUD_2),SUM(FBUD_3),SUM(FBUD_4),SUM(FBUD_5),SUM(FBUD_6),SUM(FBUD_7),SUM(FBUD_8),SUM(FBUD)"
			+ " FROM VED_DOG WHERE FREGION=0";
				
	ExecuteSQL(strSQL);
}

include ("sys/DpList.js");