//расчётные листки
include("Objects/DpGetDat.js");
include("servis/date.js");
include("servis/format.js");
include("Objects/DpTVars.js");

var dat1, dat2, fleftkeys, frightkeys, sWhere;
var TblName=new Array();
TblName[0] = "CH_TEMP";
TblName[1] = "CH_CL_N";
TblName[2] = "CH_COUNT";
var pref=new Array();
pref[0]="N";
pref[1]="U";
pref[2]="V";
var nameT=new Array();
nameT[0]=pref[0]+"ACH_T";
nameT[1]=pref[1]+"D_T";
nameT[2]=pref[2]+"ID_T";

function listLoad()
{
	with( this )
	{
		title = "Розрахункові листи|Расчетные листы";
		xmlGridFile = "l_homlist.xml";
	}
	gd = new DpGetDat("dD");      
    if (gd.escape)
		return;
	dat1 = new Date(firstDayMonth(gd.dat1));
	dat2 = new Date(lastDayMonth(gd.dat2));
	var p= new Object() ,i=0;
	//выберем подразделения
	var par = new Object();
	par.zaval = true;
	par.escape = false;
	par.ret = new Object();
	par.ret.fwid = 0;
	par.ret.fleftkey = 0;
	par.ret.frightkey = 0;
	par.dat = dat1;
	showWindow("l_struOrg.js",SW_MODAL,par);
	if(!par.escape)
	{
		is_rsc_pd = true;
		if(par.retArray.length==0)
		{
			fleftkeys = par.ret.fleftkey;
			frightkeys = par.ret.frightkey;
			sWhere = " o.Fleftkey>="+fleftkeys+" AND o.Frightkey<="+frightkeys+" ";
		}
		else
		{
			fleftkeys = new Array();
			frightkeys = new Array();
			for(var i=0; i<par.retArray.length; i++)
			{
				for(var j in par.retArray[i])
				{
					if(j=="fleftkey")
						fleftkeys[i] = par.retArray[i][j];
					else
						if(j=="frightkey")
							frightkeys[i] = par.retArray[i][j];
				}
				
			}
			for(var i=0; i<fleftkeys.length; i++)
			{
				if(i==0)
					sWhere = "((o.Fleftkey>="+fleftkeys[i]+" AND o.Frightkey<="+frightkeys[i]+") "
				else
					sWhere += "OR (o.Fleftkey>="+fleftkeys[i]+" AND o.Frightkey<="+frightkeys[i]+") "
			}
			sWhere += ") ";
		}
	}
	if(IsTable("CH_CL_N"))
		DropTable("CH_CL_N");
	StrSQL="CREATE TABLE CH_CL_N " +
				"(FTXT " + SqlType("TEXT",255) + "," +
				"FCOD " + SqlType("INT") + "," +
				"FID " + SqlType("BYTE") + "," +
				"FWID_CL " + SqlType("LONG") + "," +
				"FWID " + SqlType("LONG") + ")"
	ExecuteSQL(StrSQL);
	
	//Записываем данные из таблиц по зарплате за указанный период
	StrSQL=" INSERT INTO CH_CL_N (Ftxt,Fcod,Fwid_cl,Fwid,Fid)"
			+" SELECT c.Ftxt,r.Fcod,w.Fwid_cl,w.Fwid,w.Fid"
			+" FROM ^work_pers AS w INNER JOIN ^cl AS c ON w.Fwid_cl=c.Fwid "
				+" INNER JOIN ^clrelclcl AS r ON w.Fwid_cl=r.Fwid_cl "
				+" INNER JOIN ^stru_dol AS d ON w.Fwid_dol=d.Fwid "
				+" INNER JOIN ^stru_org AS o ON d.Fwid_org=o.Fwid "
			+" WHERE r.Fcl="+getPar("CODPERS")+" AND (w.Fbdat<="+sqlTo(dat2)+" AND w.Fedat>="+sqlTo(dat1)+") "
				+" AND "+sWhere
			+" ORDER BY r.Fcod"
	ExecuteSQL(StrSQL);
}

function listSrc()
{
	this.qrySet	("From", "CH_CL_N", "Order", "Fcod");
}

function listMenuInit()
{
	DataSource().AddMenuItem("PRINT_P","Печать расчётных листов");
    DataSource().AddMenuItem("PRINT_S","Печать сокращённых расчётных листов");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "PRINT_P":
			printRLists("POL")//Полный вариант выделяем переходящие начисления и удержания
		break;
		case "PRINT_S":
			printRLists("SOK")//Сокращённый вариант не выделяем переходящие начисления и удержания
		break;
	}
}

function max_num()
{
	//первый параметр режим
	//"arg"-макисмум
	//"num"-номер максимального єлемента
	var maxArg,maxnum=1;
	for(var i = 2, maxArg = max_num.arguments[1]; i < max_num.arguments.length; i++)
		if(maxArg < max_num.arguments[i])
			if(typeof max_num.arguments[i]!="date" || !isEmpty(max_num.arguments[i]))
			{
				maxArg = max_num.arguments[i];
				maxnum=i;
			}
	maxArg=(max_num.arguments[0]=="arg")?maxArg:maxnum;
	return maxArg;
}

function setNum(tblName,numFld)
{
	if(numFld==null)
		numFld = "Fnum";
	var tnum=OpenTable("SELECT * FROM "+tblName
					+" order by ftabn_id,fnum desc,ffld_num,fvp");
	var mtabn=0;
	var k=1;
	if(!tnum.IsEmpty())
	{ 
		for(tnum.MoveFirst();!tnum.IsEOF();tnum.MoveNext())
		{
			if(Number(tnum.getValue("FTABN_ID"))!=mtabn)
			{
				mtabn=Number(tnum.getValue("FTABN_ID"));
				k=1;
			}
			if(tnum.getValue("FNUM")==0)
			{
				ExecuteSQL("UPDATE "+tblName+" SET "+numFld+"="+k+" WHERE FWID="+sqlTo(tnum.getValue("FWID")));
			}
			k++;
		}
		tnum.close();
		return true;
	}
	else
		return false;
}

function printRLists(mParam)
{
	D1=dat1;
	var i,main,k;
	//Определяем расчитана ли зарплата за указанный месяц
	if(IsTableEx("ZRP_RES","ZRP_SVZP"+getDateTag(D1))) 
		var TabSvzp="SVZP"+getDateTag(D1);
	else
	{
		alert("Произведите расчёт зарплаты за "+format("Mmm yyyy",D1).toLowerCase())
		return;
	}
	//Найдём номер и код ЛС (Всего начислено,всего удержания,к выдаче)
	//tbl_lic=OpenTable("LIC_FLD");
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6='н'");
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: Всего начислено\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var nach_lsfid = tbl_lic[0];
	var nach_lsnum = tbl_lic[1];
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6='у'");
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: Всего удержано\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var uder_lsfid = tbl_lic[0];
	var uder_lsnum = tbl_lic[1];
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6='ф'");
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: К выдаче\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
		return;
	}
	var vyd_lsfid = tbl_lic[0];
	var vyd_lsnum = tbl_lic[1];
	var dolg_lsfid = 0;
	var dolg_lsnum = 0;
	tbl_lic=getSnap("select Fid,Ffld_num from ^LIC_FLD where Fis6='б'");
	if (tbl_lic==null)
	{
		str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
				" Hевозможно идентифицировать поле ЛС: задолженность на буд.период\n"+
				"       Пригласите разработчиков для устранения        "
		_alert(str_alert);
	}
	else
	{
		dolg_lsfid = tbl_lic[0];
		dolg_lsnum = tbl_lic[1];
	}
	if(IsTable(TblName[0])) 
		DropTable(TblName[0])
	ExecuteSQL("CREATE TABLE " + TblName[0]
			+" (FNUM " + SqlType("INT") +
			", FFLD_NUM " + SqlType("INT") +
			",FLSFID " + SqlType("INT") +
			",FSUM " + SqlType("DOUBLE") +
			",FCOD " + SqlType("INT") +
			",FWID " + SqlType("LONG") +
			",FTABN_ID " + SqlType("LONG") +
			",FNACH " + SqlType("INT") +
			",FUDER " + SqlType("INT") +
			",FVYD " + SqlType("INT") + ")");
	//Собираем отмеченные записи
	StrSQL="INSERT INTO " + TblName[0] + " (FCOD,FWID,FTABN_ID)"
		+" SELECT FCOD,FWID,FWID_Cl FROM " + TblName[1]
		+" WHERE "+(DataSource().selectedCount>0?DataSource().sqlSelected():" 1=1 ");
	ExecuteSQL(StrSQL);
	//Создаём Таблицы для начисления, удержаний и к выдаче отдельно
	for(i=0;i<nameT.length;i++)
	{
		DropTable(nameT[i])
		StrSQL="CREATE TABLE "+ nameT[i]
						+" (FNUM " + SqlType("INTEGER") +
						", FFLD_NUM " + SqlType("INTEGER") +
						",FLSFID " + SqlType("INTEGER") +
						",FSUM " + SqlType("DOUBLE") +
						",FTABN_ID " + SqlType("LONG") +
						",FCOD " + SqlType("INTEGER") +
						",FLEVEL " + SqlType("BYTE") +
						",FVP " + SqlType("BYTE") +
						",FMN " + SqlType("DATE") +
						",FDAY_N " + SqlType("INTEGER") +
						",FCHAS_N " + SqlType("DOUBLE") +
						",FWID" + SqlType("COUNTER") + ")"
		ExecuteSQL(StrSQL);
		
		var field4update1 = "";
		var field4update2 = "";
		StrTab=" A.FTABN_ID=B.FTABN_ID"
		//записываем по каждому табелю (всего начислено, всего удержано, к выдаче)
		StrSQL="INSERT INTO "+nameT[i] + " (FLSFID,FFLD_NUM,FSUM,FNUM,FLEVEL,FTABN_ID)"
					+" SELECT A.FLSFID,c.FFLD_NUM,A.FSUM,1 AS FNUM,2 AS FLEVEL,A.FTABN_ID"
					+" FROM ^"+TabSvzp+" AS A, " + TblName[0] + " AS B, ^lic_fld as c";
		switch (i)
		{
			case 0:
				StrSQL+=" WHERE A.FLSFID="+sqlTo(nach_lsfid)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrSQL1=" WHERE c.FFLD_NUM<"+sqlTo(nach_lsnum)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FNACH=B.FNACH"
				field4update1 = "FNACH";
				field4update2 = "FNACH";
			break;
			case 1:
				StrSQL+=" WHERE A.FLSFID="+sqlTo(uder_lsfid)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrSQL1=" WHERE c.FFLD_NUM>"+sqlTo(nach_lsnum)
				   +" AND c.FFLD_NUM<"+sqlTo(uder_lsnum)+" AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FUDER=B.FNACH"
				field4update1 = "FUDER";
				field4update2 = "FNACH";
			break;
			case 2:
				StrSQL+=" WHERE (A.FLSFID="+sqlTo(vyd_lsfid)+
							" OR (A.FLSFID="+sqlTo(dolg_lsfid)+ " and A.FSUM<=-1/100)) AND "+StrTab+" and a.FLSFID=c.fid ";
				StrSQL1=" WHERE ((c.FFLD_NUM>"+sqlTo(vyd_lsnum)+" and c.FFLD_NUM<>"+sqlTo(dolg_lsnum)+
							") or (c.FFLD_NUM>"+sqlTo(dolg_lsnum)+" and c.FFLD_NUM<>"+sqlTo(vyd_lsnum)+")) AND "+StrTab+" and a.FLSFID=c.fid ";
				StrUp=" SET A.FVYD=B.FNACH"
				field4update1 = "FVYD";
				field4update2 = "FNACH";
			break;
		}
		ExecuteSQL(StrSQL);
		//записываем все остальные лицевые поля				
		StrSQL = "INSERT INTO " + nameT[i] + " (FLSFID,FFLD_NUM,FSUM";
		if(mParam=="SOK")
			StrSQL+=",FNUM,FLEVEL,FVP,FMN,FTABN_ID,FDAY_N,FCHAS_N) ";
		else
	 		StrSQL+=",FNUM,FLEVEL,FVP,FMN,FTABN_ID,FDAY_N,FCHAS_N) ";
		if(mParam=="SOK")
		{
			StrSQL += " SELECT A.FLSFID,MAX(c.FFLD_NUM) AS FFLD_NUM,SUM(A.FSUM) AS FSUM";
			StrSQL+=",0 AS FNUM,3 AS FLEVEL,0 AS FVP," + sqlTo(d00)
							+ " AS FMN,A.FTABN_ID"
							+",SUM(A.FDAY*A.FSUM/ABS(A.FSUM)) AS FDAY_N"
							+",SUM(A.FCHAS*A.FSUM/ABS(A.FSUM)) AS FCHAS_N"
		}
		else
		{
			StrSQL += " SELECT A.FLSFID,c.FFLD_NUM AS FFLD_NUM,A.FSUM";
			StrSQL+=",0 AS FNUM,3 AS FLEVEL,A.FVP,A.FMN,A.FTABN_ID"
							+",(A.FDAY) AS FDAY_N"
							+",(A.FCHAS) AS FCHAS_N"
		}
		StrSQL+=" FROM ^"+TabSvzp+" AS A, " + TblName[0] + " AS B, ^lic_fld as c "+StrSQL1+" AND A.FSUM<>0";
		//NI:
		StrSQL += " AND not (a.fvp = 1 AND a.FMN >="+sqlTo(D1)+")";
		//END NI

		if(mParam=="SOK")
			StrSQL+=" GROUP BY A.FLSFID,A.FTABN_ID HAVING SUM(A.FSUM)<>0";
		else			  //StrSQL+=" GROUP BY A.FFLD_NUM,A.FLSFID,A.FVP,A.FMN,A.FTABN"
			StrSQL+=" ORDER BY A.FTABN_ID,c.FFLD_NUM"
		ExecuteSQL(StrSQL);
		//Подсчитываем количество строк в разрезе 
		//табель, (всего начислено или всего удержано или всего к выдаче)
		if(IsTable(TblName[2])) 
	 		ExecuteSQL("DELETE FROM " + TblName[2]);
		else
			ExecuteSQL("CREATE TABLE " + TblName[2] + " (FNACH " + SqlType("INTEGER") 
				+",FTABN_ID " + SqlType("LONG") + ")");
		StrSQL="INSERT INTO " + TblName[2] + " (FNACH,FTABN_ID) "
			+" SELECT COUNT(A.FFLD_NUM) AS FNACH,A.FTABN_ID"
			+" FROM "+nameT[i]+" AS A"
			+" GROUP BY A.FTABN_ID"
		ExecuteSQL(StrSQL);
				
		//SqlUpdate4Join("inner", TblName[0], TblName[2], "A", "B", field4update1, field4update2, StrTab)
		ExecuteSQL("UPDATE "+TblName[0]+" AS a SET "+field4update1
				+"=(SELECT "+field4update2+" FROM "+TblName[2]+" AS b WHERE "+StrTab+")");
	}
	//Проставляем номера строк для Начислений,удержаний, к выдаче
	var flg_num=true;
	for(i=0;i<nameT.length;i++)
	{
		flg_num=setNum(nameT[i],"Fnum")
	}
	if(!flg_num)
	{
		alert("Данных по указанным табелям нет");
		return;
	}
	//Записывем взависимости от количества строк попорядку 
	//начисления, удержания, к выдаче
	//Добавляем тот вид, у которого больше строк, остальные абдейтим
	var crstr="(FTABN_ID " + SqlType("LONG") +
				",FTABN " + SqlType("LONG") +
				",FNUM " + SqlType("INTEGER") +
				",FFLD_NUM_N " + SqlType("INTEGER") +
				",FLSFID_N " + SqlType("INTEGER") +
				",FSUM_N " + SqlType("Currency") +
				",FVP_N " + SqlType("BYTE") +
				",FMN_N " + SqlType("DATE") +
				",FFLD_NUM_U " + SqlType("INTEGER") +
				",FLSFID_U " + SqlType("INTEGER") +
				",FSUM_U " + SqlType("Currency") +
				",FVP_U " + SqlType("BYTE") +
				",FMN_U " + SqlType("DATE") +
				",FFLD_NUM_V " + SqlType("INTEGER") +
				",FLSFID_V " + SqlType("INTEGER") +
				",FSUM_V " + SqlType("Currency") +
				",FVP_V " + SqlType("BYTE") +
				",FMN_V " + SqlType("DATE") +
				",FLEVEL " + SqlType("BYTE") +
				",FRAZR " + SqlType("BIT") +
				",FDAY_N " + SqlType("INTEGER") +
				",FCHAS_N " + SqlType("DOUBLE");
	if(IsTable("CH_MAIN")) 
		//ExecuteSQL("DELETE FROM CH_MAIN");
		DropTable("CH_MAIN");
	ExecuteSQL("CREATE TABLE CH_MAIN "+crstr+")");
	var tcount=OpenTable(TblName[0]);	
	for(tcount.MoveFirst();!tcount.IsEOF();tcount.MoveNext())
	{
		for(i=0;i<nameT.length;i++)
		{
			//main=Number(max_num("num",tcount.getValue("FNACH"),tcount.getValue("FUDER"),tcount.getValue("FVYD")))-1;
			snap = getSnap("select Fnach, Fuder, Fvyd from "+TblName[0]+" where Fwid="+sqlTo(tcount.getValue("FWID")));
			main=Number(max_num("num",snap[0],snap[1],snap[2]))-1;
			//tcount.Edit();
			switch (main)
			{
				case 0:
					//tcount("FNACH")=0;//ОБНУЛЯЕМ МАКСИМУМ, ЧТОБЫ НАЙТИ СЛЕДЮЩИЙ ПО ВЕЛИЧЕНЕ МАКСИМУМ
					ExecuteSQL("UPDATE "+TblName[0]+" SET FNACH=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
				break;
				case 1:
					//tcount("FUDER")=0;
					ExecuteSQL("UPDATE "+TblName[0]+" SET FUDER=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
	  			break;
	  			case 2:
					//tcount("FVYD")=0;
					ExecuteSQL("UPDATE "+TblName[0]+" SET FVYD=0 WHERE FWID="+sqlTo(tcount.getValue("FWID")))
	  			break;
			}
			//tcount.Update();
			//Добавляем основную запись по табелю
			if(i==0)
			{ //ЕСЛИ ПЕРВЫЙ МАКСИМУМ(МАКС. КОЛИЧ. СТРОК НАЧИСЛЕНИЙ) ТО ДОБАВЛЯЕМ
				StrSQL="INSERT INTO CH_MAIN (FMN_"+pref[main]+",FVP_"+pref[main]+",FTABN_ID,FNUM,FFLD_NUM_"+pref[main]+
					",FLSFID_"+pref[main]+",FSUM_"+pref[main];
				if(main==0)
					StrSQL+=",FDAY_N,FCHAS_N) ";
				else
					StrSQL+=") ";
				StrSQL+=" SELECT FMN AS FMN_"+pref[main]+",FVP AS FVP_"+pref[main]
					+",FTABN_ID,FNUM,FFLD_NUM AS FFLD_NUM_"+pref[main]
					+",FLSFID AS FLSFID_"+pref[main]+",FSUM AS FSUM_"+pref[main]
				if(main==0)
					StrSQL+=",FDAY_N,FCHAS_N"
				StrSQL+=" FROM "+nameT[main]+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID");
				ExecuteSQL(StrSQL);
			}
			else
			{
				//абдейтим остальные виды "начислений"
				if(!ExecuteSQL("UPDATE CH_MAIN AS A SET "
							+" FMN_"+pref[main]+"=(SELECT FMN FROM "+nameT[main]+" AS B WHERE "
							+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID")))
				{
							browse("SELECT * FROM "+nameT[main]+" WHERE ftabn_id="+tcount.getValue("FTABN_ID")+" order by fnum");
							return false;
				}
				ExecuteSQL("UPDATE CH_MAIN AS A SET "
							+" FVP_"+pref[main]+"=(SELECT FVP FROM "+nameT[main]+" AS B WHERE "
							+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN AS A SET "
							+" FFLD_NUM_"+pref[main]+"=(SELECT FFLD_NUM FROM "+nameT[main]+" AS B WHERE "
							+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN AS A SET "
							+" FLSFID_"+pref[main]+"=(SELECT FLSFID FROM "+nameT[main]+" AS B WHERE "
							+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				ExecuteSQL("UPDATE CH_MAIN AS A SET "
							+" FSUM_"+pref[main]+"=(SELECT FSUM FROM "+nameT[main]+" AS B WHERE "
							+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
							+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				if(main==0)
				{
					ExecuteSQL("UPDATE CH_MAIN AS A SET "
								+" FDAY_N=(SELECT FDAY_N FROM "+nameT[main]+" AS B WHERE "
								+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
								+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
					ExecuteSQL("UPDATE CH_MAIN AS A SET "
								+" FCHAS_N=(SELECT FCHAS_N FROM "+nameT[main]+" AS B WHERE "
								+" A.FTABN_ID=B.FTABN_ID AND A.FNUM=B.FNUM) "
								+" WHERE FTABN_ID="+tcount.getValue("FTABN_ID"));
				}
			}
		}//	end	for(i=1;i<4;i++)
	}//	end for(tcount.MoveFirst();!tcount.IsEOF();tcount.MoveNext())
	//Добавляем строку  табельного номера, чтобы далее по нему вытянуть данные
	tcount.close();
	//ДОБАВЛЯТЬ ТОЛЬКО ДЛЯ ТЕХ У КОГО ЕСТЬ ИНФОРМАЦИЯ В РАСЧЕТНОМ ЛИСТЕ
	if(IsTable("CH_TEMP1"))
		DropTable("CH_TEMP1");
	ExecuteSQL("SELECT DISTINCT FTABN_ID INTO CH_TEMP1 FROM CH_MAIN ")
	StrSQL="INSERT INTO CH_MAIN (FTABN_ID,FLEVEL,FNUM)"
				+" SELECT DISTINCT FTABN_ID,1 AS FLEVEL,0 AS FNUM"
				+" FROM CH_TEMP1";
	ExecuteSQL(StrSQL);
	StrSQL="INSERT INTO CH_MAIN (FTABN_ID,FLEVEL,FNUM)"
				+" SELECT DISTINCT FTABN_ID,2 AS FLEVEL,0 AS FNUM"
				+" FROM CH_TEMP1" ;
	ExecuteSQL(StrSQL);
	//проставим табельный номер
	ExecuteSQL("UPDATE CH_MAIN SET Ftabn=(SELECT Fcod FROM ^clrelclcl AS r WHERE CH_MAIN.Ftabn_id=r.Fwid_cl)");

	//Устанавливаем левелы для "всего начисленно и удержанои к выдаче"
	ExecuteSQL("UPDATE CH_MAIN SET FLEVEL=2 WHERE FNUM=1");
	//Устанавливаем левелы для остальнх ""
	ExecuteSQL("UPDATE CH_MAIN SET FLEVEL=3 WHERE FNUM>1");
	if(IsTable("CH_MAIN_PRN")) 
		//ExecuteSQL("DELETE FROM CH_MAIN_PRN");
		DropTable("CH_MAIN_PRN")
	ExecuteSQL("CREATE TABLE CH_MAIN_PRN "+crstr +
						",FID " + SqlType("LONG") + //поле для сквозной нумерации
						",FWID" + SqlType("COUNTER") +
						",FNAZV_N " + SqlType("TEXT") +
						",FNAZV_U " + SqlType("TEXT") +
						",FNAZV_V " + SqlType("TEXT") +
						",FNAZV_PODR " + SqlType("TEXT") +
						",FNAZV_DOL " + SqlType("TEXT") +
						",FOKLAD " + SqlType("MONEY") +
						",FNAM_LEVS " + SqlType("TEXT") +
						",FWID_ORG " + SqlType("LONG") +
						",FPEREX_N " + SqlType("TEXT") +
						",FPEREX_U " + SqlType("TEXT") + ")");

	//ПОДТЯГИВАЕМ ФИО, ОКЛАД, 
	/*ExecuteSQL("INSERT INTO CH_MAIN_PRN (" + getColumn("CH_MAIN",false) + ",FOKLAD,FNAM_LEVS,FWID_ORG)"
					+" SELECT A.*,B.FOKLAD,B.FNAM_LEVS,B.FLV1,B.FLV2,B.FLV3,B.FLV4"
					+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^SHTAT AS B  ON B.FTABN=D.FCOD and B.FID=D.FID)  "
					+" ON A.FTABN=D.FCOD"
					+" ORDER BY A.FTABN_ID,A.FNUM,A.FLEVEL,A.FFLD_NUM_N");*/
	ExecuteSQL("INSERT INTO CH_MAIN_PRN (" + getColumn("CH_MAIN",false) + ",FOKLAD,FNAM_LEVS,FWID_ORG)"
					+" SELECT "+getColumn("CH_MAIN",false,"A")+",SD.FOKLAD,CL.FTXT,SD.FWID_ORG"
					//+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^SHTAT AS B  ON B.FTABN=D.FCOD and B.FID=D.FID)  "
					+" FROM CH_MAIN AS A LEFT JOIN (CH_CL_N AS D LEFT JOIN ^work_pers AS WP ON D.Fwid=WP.Fwid "
							+" INNER JOIN ^stru_dol AS SD ON WP.Fwid_dol=SD.Fwid "
							+" INNER JOIN ^cl AS CL ON CL.Fwid=WP.Fwid_cl) ON A.FTABN_ID=D.FWID_CL "
					+" ORDER BY A.FTABN_ID,A.FNUM,A.FLEVEL,A.FFLD_NUM_N");
	//ПОДТЯГИВАЕМ НАЗВАНИЕ ПОДРАЗДЕЛЕНИЯ
	ExecuteSQL("UPDATE CH_MAIN_PRN AS c SET FNAZV_PODR=(SELECT Ftxt FROM ^stru_org WHERE Fwid=c.Fwid_org) WHERE Flevel=2");
	//ПОДТЯГИВАЕМ НАЗВАНИЕ ДОЛЖНОСТИ
	ExecuteSQL("UPDATE CH_MAIN_PRN AS c SET FNAZV_DOL=(SELECT cl.Ftxt "
								+" FROM ^cl AS cl INNER JOIN ^stru_dol AS sd ON cl.Fwid=sd.Fwid_cl "
									+" INNER JOIN ^work_pers AS wp ON sd.Fwid=wp.Fwid_dol "
										+" WHERE wp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers WHERE "
														+" Fwid_cl=c.Ftabn_id AND Fbdat<="
														+sqlTo(D1)+" AND Fedat>="+sqlTo(D1)+")) "
								+" WHERE Flevel=2");
	//проставим название лицевых полей
	for(i=0;i<nameT.length;i++)
	{
		ExecuteSQL("UPDATE CH_MAIN_PRN AS A SET FNAZV_"+pref[i]
			+"=(SELECT FTXT FROM ^LIC_FLD AS B WHERE A.FLSFID_"+pref[i]+"=B.FID)");
		ExecuteSQL("UPDATE CH_MAIN_PRN AS A SET FFLD_NUM_"+pref[i]
			+"=(SELECT FFLD_NUM FROM ^LIC_FLD AS B WHERE A.FLSFID_"+pref[i]+"=B.FID)");
		if(i<2)
		{//Проставляем данные о переходящих суммах
					// !!!!!!!!!!!!! ES НЕ РААЛИЗОВАНО !!!!!!!!!!!!
					/*if (SQL)
						ExecuteSQL("UPDATE CH_MAIN_PRN AS A "
							+" SET FPEREX_"+pref[i]+"=" + sqlTo("ORACLE - NOT IMPLEMENTED")
							+" WHERE A.FMN_"+pref[i]+"<>"+SqlMaxDate
							+" AND  A.FMN_"+pref[i]+"IS NOT NULL");
					else
						ExecuteSQL("UPDATE CH_MAIN_PRN AS A "
		                	+" SET FPEREX_"+pref[i]+"= IIF((FMN_"+pref[i]+"<"+sqlTo(D1)
							+") AND (FVP_"+pref[i]+"=1),'в '+Cstr(Month(FMN_"+pref[i]
							+"))+'/'+Right(Cstr(Year(FMN_"+pref[i]+")),2) +' за '+Cstr(Month("+sqlTo(D1)
							+"))+'/'+Right(Cstr(Year("+sqlTo(D1)+")),2),"
							+"'в '+Cstr(Month("+sqlTo(D1)+"))"
							+"+'/'+Right(Cstr(Year("+sqlTo(D1)+")),2)+' за '+Cstr(Month(FMN_"+pref[i]+"))"
							+"+'/'+Right(Cstr(Year(FMN_"+pref[i]+")),2)"
							+")"
							+" WHERE A.FMN_"+pref[i]+"<>"+SqlMaxDate
							+" AND  A.FMN_"+pref[i]+" IS NOT NULL");*/
		}
	}
	var maxRowCount = input(ru("Введите максимальное кол-во строк на странице печати ",
								"Введіть максимальну кількість рядків на сторінці друку ")
        			  		, ru("Параметры печати", "Параметри друку"), 50, 2);
    //проставим признак последней записи по каждому сотруднику Flevel=4 
    ExecuteSQL("update CH_MAIN_PRN as p1 set Flevel=4 where "
    		+" Fnum=(select MAX(Fnum) from CH_MAIN_PRN as p2 where p1.Ftabn_id=p2.Ftabn_id)")
    
    //проставим признак (Flevel=5), по которому потом в печатной форме будем устанавливать разрыв страницы печати (PAGE BREAK=*RFLEVEL==5)
    t2=OpenTable("select * from CH_MAIN_PRN order by ftabn,fnum,flevel");
    var nRow = 1;
    var snap = getSnap("select MAX(count(Ftabn_id)) from CH_MAIN_PRN group by ftabn_id");
    var maxTabnCount = snap[0];//максимальное кол-во строк по сотруднику
    for(t2.MoveFirst(); !t2.IsEOF(); t2.MoveNext())
    {
    	if(t2.getValue("Flevel")==4 && nRow<=maxRowCount && (maxRowCount-nRow<=maxTabnCount))
    	{
    		ExecuteSQL("update CH_MAIN_PRN set Flevel=5 where Fwid="+t2.getValue("Fwid"));
    		nRow = 0;
    	}
    	nRow++;
    }
    t2.requery();
     
	shabl = "CIKLIC";
	var tv = new DpTVars(shabl);
	var h = new Object();
	tv.setHTbl(h);
	tv.setVar("BDAT",D1)
	tv.setRTbl(t2);
	tv.print();
}
include("sys\\DpList.js");