include("Objects\\DpGrid.js");
include("sys\\docinfo.js"); 
include("Objects/DpXMLDomDocument.js");
include("objects\\DpExtentionBuilder.js");
include("objects/DpGetDat.js");

var ArrTetraPodr = new Array();
var label = "import_summ";
var tblOut = "tmp_"+ label;

function listLoad()
{
	with( list )
	{
        title = "Сеансы загрузки документов";
		subMake = tbl_refresh;
	}
}

function listSrc()
{
   	with( list )
	{
		qrySet( "From", tblOut, "Order", new Array("ID DESC"))
	}
}

function tbl_refresh()
{
// - is 7
// + is 5
	var strSql1,strSql2;

	with( list.objAsk )
	{
		strSql1 = "SELECT top 50 a.*, " 
			+ IIF("EXISTS(SELECT * FROM ^IMPORT_TETRA_SUMM WHERE ^IMPORT_TETRA_SUMM.TL_START=a.TL_START AND ^IMPORT_TETRA_SUMM.TL_END=a.TL_END)", 
				sqlTrue, sqlFalse) + " AS FIS_DONE "
			+ ", (SELECT COUNT(*) FROM Debet..acc_doc_good_v WHERE Debet..acc_doc_good_v.TL between a.TL_START AND a.TL_END) AS DOC_COUNT "
			+ " INTO " + tblOut
	      	+ " from Debet..acc_history_calc_v a"
	      	+ " ORDER BY ID desc"		
		strSql2 = "ALTER TABLE "+tblOut +" ADD FWID "+ SqlType("COUNTER");
	}
	DropTable(tblOut);
	ExecuteSQL(strSql1);
    ExecuteSQL(strSql2);
/*
	var tbl = OpenTable("SELECT * FROM " + tblOut);
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
        var doc = String(tbl.getValue("Fdoc"));
        var nop = Number(tbl.getValue("Fnop"));
        var fid = Number(tbl.getValue("Fid_doc"));
        
		var oDoc = new DpDoc(doc, nop);
		if (oDoc.loadByID(fid))
		{
			tbl.Edit()
			tbl.setValue("FSUM_BOOK", Number(oDoc.getVar("CHECKPROV")));
			tbl.Update();
		}
	}
*/
}

function listGrid()
{	
	var gr = new DpGrid("NOCREATE");
	gr.defCond("=^FIS_DONE==1","DT");
	gr.color(1, "DT");
	gr.bold("DT");
	
   	with(gr.page())
   	{
		fieldEx("DATECALC", "Дата",6);
		fieldEx("TL_START",  "Точка начала", 12);
		fieldEx("TL_END",	 "Точка конца", 12);
		fieldEx("DOCID_START", "1-й документ", 12);
		fieldEx("DOCID_END", "последний док-т", 12);
		fieldEx("DOC_COUNT", "кол-во документов", 12);
		fieldEx("ID", "ID", 5);
	}
	gr.build();
}


function listMenuInit()
{
	if(!list.tbl.IsEmpty())
	{
		list.dataSrc.AddMenuItem("LOAD_DOCS3", "Загрузить документы из сеанса");
		list.dataSrc.AddMenuItem("LOAD_DOCS2", "Загрузить документы из сеанса(дозагрузка)");
		list.dataSrc.AddMenuItem("LOAD_DOCS", "Перезагрузить документы (долго)");
		list.dataSrc.AddMenuItem("SHOW_DOCS", "Показать документы из сеанса");
		list.dataSrc.AddMenuItem("SHOW_DOCS2", "Показать разницу по документам из сеанса");
		list.dataSrc.AddMenuItem("LOAD_DOCS4", "Загрузить разницу по документам из сеанса");
		list.dataSrc.AddMenuItem("DEL_DOCS", "Синхронизировать удаленные документы");
		list.dataSrc.AddMenuItem("INIT_SEANS", "Инициализация сеанса после сбоя");
	}
}

function listMenuRun(ID)
{
	var ppar;
	switch(ID)
	{
	case "INIT_SEANS":
		var id = Number(list.tbl.getValue("ID"));
		var tl_start = "(SELECT TL_START FROM Debet..acc_history_calc_v WHERE id = " + id + ")";
		var tl_end = "(SELECT TL_END FROM Debet..acc_history_calc_v WHERE id = " + id + ")";
		
		// Обновляем таблицу загрузок
		ExecuteSQL("DELETE FROM Debet..tbl_acc_doc_good where id = " + sqlTo(id));
		ExecuteSQL("INSERT INTO Debet..tbl_acc_doc_good "
			+ " SELECT *, " + sqlTo(id) + " as id from Debet..acc_doc_good_v WHERE TL between "
			+ tl_start + " and " + tl_end
			+ " AND CLASSID_ACC <> 8192 AND CLASSID_ACC <> 8187"
			+ " ORDER BY DATEOD");
		break
	case "LOAD_DOCS":
	case "LOAD_DOCS2":
	case "LOAD_DOCS3":
	case "LOAD_DOCS4":
	
		include("objects\\DpGetDat.js");
		var gd = new DpGetDat("dD");
		if (gd.escape == true)
			break;
			
		include ("import.js")
		include ("l_docekz.js")
		var ArrNkOrgs = new Array();
		var id = Number(list.tbl.getValue("ID"));
		fillPodrMap();
	
		var tl_start = "(SELECT TL_START FROM Debet..acc_history_calc_v WHERE id = " + id + ")";
		var tl_end = "(SELECT TL_END FROM Debet..acc_history_calc_v WHERE id = " + id + ")";;

		// Обновляем таблицу загрузок
		ExecuteSQL("DELETE FROM Debet..tbl_acc_doc_good where id = " + sqlTo(id));
		ExecuteSQL("INSERT INTO Debet..tbl_acc_doc_good "
			+ " SELECT *, " + sqlTo(id) + " as id from Debet..acc_doc_good_v WHERE TL between "
			+ tl_start + " and " + tl_end
			+ " AND CLASSID_ACC <> 8192 AND CLASSID_ACC <> 8187"
			+ " ORDER BY DATEOD");
			
		var strSQL = "SELECT * from Debet..acc_doc_good_v a WHERE TL between "
			+ tl_start + " and " + tl_end
			+ " AND CLASSID_ACC <> 8192 AND CLASSID_ACC <> 8187"
	    if (ID == "LOAD_DOCS3")
	    {
			var nSeans = input("Номер предыдущего расчета", "Номер предыдущего расчета", String(id - 1), 5, 3);
			if(nSeans != null)
				nSeans = Number(nSeans);
			else
				nSeans = id - 1;
				
			strSQL += " AND NOT EXISTS (SELECT * FROM Debet..tbl_acc_doc_good b" 
			+ " 	where id = " + sqlTo(nSeans) + " and" 
//			+ " 	where id = 16 and" 
			+ " 	("
			+ " 		a.GroupStockID = b.GroupStockID"
			+ " 		and a.docid = b.docid"
			+ " 		and a.classid_acc = b.classid_acc"
			+ " 		and a.DateOD = b.DateOD"
			+ " 		and a.TL = b.TL"
			+ " 		and a.contragentid = b.contragentid"
			+ " 		and a.currencyid = b.currencyid"
			+ " 		and a.sumdoc = b.sumdoc"
			+ " 		and a.classid = b.classid"
			+ " 		and a.debetid = b.debetid"
			+ " 		and a.creditid = b.creditid"
			+ " 		and a.ndoc = b.ndoc"
			+ " 		and a.SumNoNDS = b.SumNoNDS"
			+ " 		and a.NDS = b.NDS"
			+ " 		and a.costacc = b.costacc"
			+ " 		and (a.duty = b.duty or (a.duty is NULL and b.duty is NULL))"
			+ " 		and (a.excise = b.excise or (a.excise is NULL and b.excise is NULL))"
			+ " 		and (a.ndoc23 = b.ndoc23 or (a.ndoc23 is NULL and b.ndoc23 is NULL))"
			+ " 		and (a.ndoc44 = b.ndoc44 or (a.ndoc44 is NULL and b.ndoc44 is NULL))"
			+ " 	)"
			+ ")";		
	    }
	    else if (ID == "LOAD_DOCS2")
	    {
			strSQL += " AND NOT EXISTS (SELECT * FROM ^HBS b WHERE a.docid=b.foutid) " 
	    }
	    else if (ID == "LOAD_DOCS4")
	    {
			strSQL = "SELECT * from Debet..acc_doc_good_v a"
				+ " LEFT JOIN ^HBS b on a.docid=b.foutid "		
				+ " WHERE a.TL between "	+ tl_start + " and " + tl_end
				+ " and a.classid_acc<>8199 AND a.CLASSID_ACC <> 8192 AND a.CLASSID_ACC <> 8187"			
				+ " AND b.fwid is not null"
				+ " AND (" + IIF("b.fnop = 207 or b.fnop = 208 or b.fnop = 209","abs(a.costacc)","a.sumdoc") + " <> " + IIF("b.fnop = 207 or b.fnop = 208 or b.fnop = 209","b.fsum","b.fsum+b.fsum1") + " "
				+ "		or a.dateod<>b.fdoc_dat "
				+ "		or (a.NDOC<>b.fdoc_num and a.NDOC44<>b.fdoc_num)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_200 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_202 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_204 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_205 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_206 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_207 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_208 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_209 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_210 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_211 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_219 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_220 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_200 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_202 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_204 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_205 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_206 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_207 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_208 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_209 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_210 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_211 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_219 bs_ext where bs_ext.fmainwid = b.fwid)"
				+ "		or classid_acc <> (select fclassid from Debet..H_BS_220 bs_ext where bs_ext.fmainwid = b.fwid)	"
				+ "		)";
	    }
	    strSQL += " ORDER BY DATEOD";
			
		var tbl = OpenTable(strSQL);
		
//		browse(tbl)
//		return;
			
//		var tbl = OpenTable("SELECT * from Debet..acc_doc_good_v WHERE TL between "
//			+ tl_start + " and " + tl_end
//			+ " AND CLASSID_ACC <> 8192 AND CLASSID_ACC <> 8187"
//			+ " ORDER BY DATEOD"
//			);			
//		var tbl = OpenTable("SELECT * from Debet..acc_doc_good_v WHERE " +
//				" contragentid = 30295276");

		var XMLDoc = new DpXMLDOMDocument();
		var root = XMLDoc.createElement("root");	
		XMLDoc.appendChild(root);

		var oPar = new Object();
	    oPar.NO_RASCOST = true;		
	    var oImp = new DpXMLImport(oPar);
	    oImp.isReplaceExists = true;
	    oImp.silentMode = true;
		
		var nCount = 0;
		var nCount0 = 0;
		for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		{
			nCount++;
			
		    if (ID == "LOAD_DOCS2")
		    {
				var oSnap = getSnap("select fwid from ^HBS where foutid = "+sqlTo(tbl.getValue("DOCID")));
				if (oSnap != null)
					continue;								
		    }
			
			// 220/203 Папку надо обрабатывать отдельно, там нельзя по FWID-e документа искать проводки
			// так как документы попадают в паку 220, потом группируются в папку 203 и уже в 203-ей папке
			// формируются проводки. Потому просто будем ругаться что пытаются сохранить файл в 220-ой папки за нерабочий период 			
			if (ArrTetraPodr[Number(tbl.getValue("CREDITID"))] &&
				(ArrTetraPodr[Number(tbl.getValue("DEBETID"))] || ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))])
				)
			{
				sc1 = 0;
				su1 = 0;
				sc2 = ArrTetraPodr[Number(tbl.getValue("CREDITID"))].SC;
				su2 = ArrTetraPodr[Number(tbl.getValue("CREDITID"))].SU;
				if (ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))])
				{
					sc1 = ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))].SC;
					su1 = ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))].SU;
				}
				else
				{
					sc1 = ArrTetraPodr[Number(tbl.getValue("DEBETID"))].SC;
					su1 = ArrTetraPodr[Number(tbl.getValue("DEBETID"))].SU;
				}

				if (su1 == 0 && su2 == 282 && differ(toScrObj(tbl.getValue("DATEOD")), toScrObj(gd.dat1)) == -1)
				{
					// 220
					alert("Очень опастная ошибка. Попытка сохранить документ в раннем периоде, папка 220. Срочно сообщите Администратору - " + format("dd.mm.yyyy", toScrObj(tbl.getValue("DATEOD"))) + " | " + tbl.getValue("NDOC") + " | " + Number(tbl.getValue("DOCID")),1);
					continue;
				}					
			}			

			var oSnap = getSnap("SELECT FNOP, fid_doc, fdate FROM ^schet where fdoc<> '_R' and fid_doc = (select max(fwid) from ^HBS where foutid = " + sqlTo(tbl.getValue("DOCID")) + ")")
			if (oSnap != null)
			{
				if (ID == "LOAD_DOCS4" && Number(oSnap[0]) != 200 && Number(oSnap[0]) != 201 && Number(oSnap[0]) != 202)
				{
					if (differ(toScrObj(oSnap[2]), toScrObj(gd.dat1)) == -1)
					{
						alert("Очень опастная ошибка. Попытка удалить проводку в раннем периоде. Срочно сообщите Администратору - " + oSnap[1]);
					}
					else
					{
						ExecuteSQL("DELETE FROM ^SCHET WHERE FDOC <> '_R' AND fid_doc = " + sqlTo(oSnap[1]));
					}
				}
				else if (Number(oSnap[0]) != 202)
				{
					var oDoc = new DpDoc("BS", Number(oSnap[0]));
					if (oDoc.loadByID(Number(oSnap[1])))
					{
						if (differ(toScrObj(oDoc.getVar("HDAT")), toScrObj(gd.dat1)) == -1)
						{
							alert("Очень опастная ошибка. Попытка сохранить документ в раннем периоде. Срочно сообщите Администратору - " + oSnap[1] + "\nHDAT=" +toScrObj(oDoc.getVar("HDAT")) + "\ndat1=" + toScrObj(gd.dat1) +"\ndocid="+Number(tbl.getValue("DOCID")) +"\nNOP="+oSnap[0]);
						}
						else
						{
							oDoc.setExt("SUM1", Math.abs(Number(tbl.getValue("COSTACC"))));
//							oDoc.save(false, "EDIT");
							oDoc.saveExtToDB();
						}
					}										
					continue;
				}
				else
				{
					continue;
				}
			}
			
			/*
			// создание контрагента
			var docEl = XMLDoc.createElement("object");
			docEl.setAttribute("type", "cls.CL2")
			//docEl.setAttribute("OutObjectID", String(Number(tbl.getValue("CONTRAGENTID"))))
			root.appendChild(docEl);
			var xmlHeader = XMLDoc.createElement("Header");
			docEl.appendChild(xmlHeader);
			 
			var ArrOrg = new Array();
			var oSnap  = getSnap("SELECT SUBJECTNAME from Debet..acc_subject_v where contragentid = " + Number(tbl.getValue("CONTRAGENTID")))
			if (oSnap != null)
			{
				ArrOrg["HOUTID"] = String(Number(tbl.getValue("CONTRAGENTID")));
				ArrOrg["HTXT"] = oSnap[0];
				 
				//ArrOrg["HADDR"] = "";
				//ArrOrg["HCODCOUNTRY"] = "";
				//ArrOrg["HPHONE"] = "";
				//ArrOrg["HFAX"] = "";
				//ArrOrg["HCOD_ST"] = "";
				//ArrOrg["HCOD_NDS"] = "";
				//ArrOrg["HREM"] = "";
							  
				for(sEl in ArrOrg)
				{
					var xmlProp = XMLDoc.createElement(sEl);
					xmlProp.setText(ArrOrg[sEl]);				
					xmlHeader.appendChild(xmlProp);
				}
			}
			var xmlRows = XMLDoc.createElement("rows");
			xmlRows.setAttribute("ID", "CLNUM")
			docEl.appendChild(xmlRows);
			var xmlRow = XMLDoc.createElement("object");
			xmlRow.setAttribute("type", "CLNUM")
			xmlRows.appendChild(xmlRow);
			var xmlHeader = XMLDoc.createElement("Header");
			xmlRow.appendChild(xmlHeader);
			var xmlProp = XMLDoc.createElement("HCL");
			xmlProp.setText("12");				
			xmlHeader.appendChild(xmlProp);
			*/			
			
			var docEl = XMLDoc.createElement("object");
			docEl.setAttribute("type", "docs.BS")
			docEl.setAttribute("OutObjectID", String(Number(tbl.getValue("DOCID"))))
			root.appendChild(docEl);
			var xmlHeader = XMLDoc.createElement("Header");
			docEl.appendChild(xmlHeader);

			/*
			var HPLCH = XMLDoc.createElement("HPLCH");
			xmlHeader.appendChild(HPLCH);
			var xmlHeader2 = XMLDoc.createElement("Header");
			HPLCH.appendChild(xmlHeader2);
			var xmlProp = XMLDoc.createElement("HOUTID");
			xmlProp.setText(String(Number(tbl.getValue("CONTRAGENTID"))));				
			xmlHeader2.appendChild(xmlProp);
			*/
			
			// doc header
			var ArrObj = new Array();
			ArrObj["HSUMI"] = round(Math.abs(Number(tbl.getValue("SUMDOC"))) / 6, 2);
			ArrObj["HSUM"] = Math.abs(Number(tbl.getValue("SUMDOC"))) - ArrObj["HSUMI"];
			ArrObj["HDAT"] = format("dd.mm.yyyy", toScrObj(tbl.getValue("DATEOD")));
			ArrObj["HNOM"] = tbl.getValue("NDOC");
			ArrObj["HVAL"] = 0;
			ArrObj["HOUTID"] = Number(tbl.getValue("DOCID"));
			ArrObj["HOP"] = 0;

			var xmlExtAttr = XMLDoc.createElement("Extentions");
			docEl.appendChild(xmlExtAttr);
			
			//ArrObj["HORG"] = 0;
			sc1 = 0;
			su1 = 0;
			sc2 = 0;
			su2 = 0;
			if (ArrTetraPodr[Number(tbl.getValue("DEBETID"))] ||
				ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))])
			{
				var o;
				if (ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))])
					o = ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))];
				else
					o = ArrTetraPodr[Number(tbl.getValue("DEBETID"))];

				sc1 = o.SC;
				su1 = o.SU;
				ArrObj["HSC"] = o.SC;
				ArrObj["HSU"] = o.SU;
				ArrObj["HST"] = 0;
				if (o.CONTR != 0)
					ArrObj["HORG"] = o.CONTR;

				var xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "PODR1");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.PODR);
				xmlExtAttr.appendChild(xmlExt);
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "MOL1");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.MOL);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "SC1");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.SC);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "SU1");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.SU);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "HORG1");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.CONTR);
				xmlExtAttr.appendChild(xmlExt);			
			}
			if (ArrTetraPodr[Number(tbl.getValue("CREDITID"))])
			{
				var o = ArrTetraPodr[Number(tbl.getValue("CREDITID"))];
				if ((!ArrObj["HORG"] || ArrObj["HORG"] == 0) && o.CONTR != 0)
					ArrObj["HORG"] = o.CONTR;

				sc2 = o.SC;
				su2 = o.SU;
				
				if (su1 == 281 && su2 == 282 && o.CONTR != 0)
					ArrObj["HORG"] = o.CONTR;				

				var xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "PODR2");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.PODR);
				xmlExtAttr.appendChild(xmlExt);
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "MOL2");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.MOL);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "SC2");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.SC);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "SU2");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.SU);
				xmlExtAttr.appendChild(xmlExt);			
	
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "HORG2");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(o.CONTR);
				xmlExtAttr.appendChild(xmlExt);			
			}
	
			xmlExt = XMLDoc.createElement("ext");
			xmlExt.setAttribute("name", "NOP");
			xmlExt.setAttribute("type", "number");
			xmlExt.setText(String(tbl.getValue("CLASSID")));
			xmlExtAttr.appendChild(xmlExt);			
	
			xmlExt = XMLDoc.createElement("ext");
			xmlExt.setAttribute("name", "CLASSID");
			xmlExt.setAttribute("type", "number");
			xmlExt.setText(String(tbl.getValue("CLASSID_ACC")));
			xmlExtAttr.appendChild(xmlExt);			
	
			xmlExt = XMLDoc.createElement("ext");
			xmlExt.setAttribute("name", "SUM1");
			xmlExt.setAttribute("type", "number");
			xmlExt.setText(String(Math.abs(Number(tbl.getValue("COSTACC")))));
			xmlExtAttr.appendChild(xmlExt);			
	
			xmlExt = XMLDoc.createElement("ext");
			xmlExt.setAttribute("name", "SUM2");
			xmlExt.setAttribute("type", "number");
			xmlExt.setText(String(Math.abs(Number(tbl.getValue("DUTY")))));
			xmlExtAttr.appendChild(xmlExt);			
	
			xmlExt = XMLDoc.createElement("ext");
			xmlExt.setAttribute("name", "SUM3");
			xmlExt.setAttribute("type", "number");
			xmlExt.setText(String(Math.abs(Number(tbl.getValue("EXCISE")))));
			xmlExtAttr.appendChild(xmlExt);			
			
			if (String(tbl.getValue("CLASSID_ACC")) == "8187" ||
				String(tbl.getValue("CLASSID_ACC")) == "8188" ||
				String(tbl.getValue("CLASSID_ACC")) == "8196" ||
				String(tbl.getValue("CLASSID_ACC")) == "8190"
				)
			{
				if (sc2 == 20)
				{
					ArrObj["HOP"] = 5000;
				}
				else
				{
					ArrObj["HOP"] = 207;
					ArrObj["HORG"] = 103;				
					ArrObj["HSUMI"] = round(Math.abs(Number(tbl.getValue("COSTACC"))) / 5, 2);
					ArrObj["HSUM"] = Math.abs(Number(tbl.getValue("COSTACC")));
					
					var oSnap = getSnap("select fdoc_num from ^HBS where foutid = "+sqlTo(tbl.getValue("DOCID")));
					if (oSnap != null)
						ArrObj["HNOM"] = String(oSnap[0]);
				}
			}
			else if (String(tbl.getValue("contragentid")) == "31278060")
			{
				ArrObj["HOP"] = 214;
			}	
			else if (String(tbl.getValue("CLASSID_ACC")) == "8152")
			{
				ArrObj["HOP"] = 212;
			}
			else if (String(tbl.getValue("CLASSID_ACC")) == "8198")
			{
				if (sc2 == 20)
				{
					ArrObj["HOP"] = 5000;
				}
				else
				{
					ArrObj["HOP"] = 208;
					ArrObj["HORG"] = 1077;				
					ArrObj["HSUMI"] = round(Math.abs(Number(tbl.getValue("COSTACC"))) / 5, 2);
					ArrObj["HSUM"] = Math.abs(Number(tbl.getValue("COSTACC")));
				}
			}
			else if (String(tbl.getValue("CLASSID_ACC")) == "8197")
			{
				if (sc2 == 20)
				{
					ArrObj["HOP"] = 5000;
				}
				else
				{
					ArrObj["HOP"] = 209;
					ArrObj["HORG"] = 103;				
					ArrObj["HSUMI"] = round(Math.abs(Number(tbl.getValue("COSTACC"))) / 5, 2);
					ArrObj["HSUM"] = Math.abs(Number(tbl.getValue("COSTACC")));
					
					var oSnap = getSnap("select fdoc_num from ^HBS where foutid = "+sqlTo(tbl.getValue("DOCID")));
					if (oSnap != null)
						ArrObj["HNOM"] = String(oSnap[0]);
				}
			}
			else if (ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))] &&
				ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))].NOP != 0)			
			{
				ArrObj["HOP"] = ArrTetraPodr[Number(tbl.getValue("CLASSID_ACC"))].NOP;				
			}
			else if (String(tbl.getValue("CLASSID_ACC")) == "8151")
			{
				// расход с оптового склада
				var oSnap = getSnap("select rel.fcod from ^cl left join ^clrelclcl rel on ^cl.fwid = rel.fwid_cl where foutid = " + sqlTo(Number(tbl.getValue("CONTRAGENTID"))))
				if (oSnap && oSnap[0])
					ArrObj["HORG"] = oSnap[0];
				ArrObj["HOP"] = 211;
			}
			else if (String(tbl.getValue("CLASSID_ACC")) == "8132")
			{
				if (sc2 == 20)
				{
					ArrObj["HOP"] = 5000;
				}
				else
				{
					ArrObj["HOP"] = 202;
					var oSnap = getSnap("select rel.fcod from ^cl left join ^clrelclcl rel on ^cl.fwid = rel.fwid_cl where foutid = " + sqlTo(Number(tbl.getValue("CONTRAGENTID"))))
					if (oSnap && oSnap[0])
						ArrObj["HORG"] = oSnap[0];
				}
			}
			else if (String(tbl.getValue("CLASSID_ACC")) == "8199")
			{
				ArrObj["HOP"] = 201;
				var oSnap = getSnap("select rel.fcod from ^cl left join ^clrelclcl rel on ^cl.fwid = rel.fwid_cl where foutid = " + sqlTo(Number(tbl.getValue("CONTRAGENTID"))))
				if (oSnap && oSnap[0])
					ArrObj["HORG"] = oSnap[0];
					
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "TAMPOSH");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(String(Math.abs(Number(tbl.getValue("DUTY")))));
				xmlExtAttr.appendChild(xmlExt);
					
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "SUMTOVP");
				xmlExt.setAttribute("type", "number");
				xmlExt.setText(String(Math.abs(Number(tbl.getValue("SumNoNDS")))));
				xmlExtAttr.appendChild(xmlExt);
				
				ArrObj["HSUMI"] = Math.abs(Number(tbl.getValue("NDS")));
				ArrObj["HSUM"] = Math.abs(Number(tbl.getValue("SUMDOC")));
			}
			else if (su1 == 281 && su2 == 282)
			{
//				if (String(tbl.getValue("CLASSID_ACC")) == "8182")
//					ArrObj["HOP"] = 208;
				
				ArrObj["HOP"] = 206;
			}	
			else if (su1 == 282 && su2 == 281)
			{
				if (String(tbl.getValue("NDOC44")) != "" && String(tbl.getValue("NDOC44")) != "null")
					ArrObj["HNOM"] = tbl.getValue("NDOC44");
				ArrObj["HOP"] = 205;
			}	
			else if (su1 == 0 && su2 == 282)
			{
				ArrObj["HOP"] = 220;
			}	
			else if (su1 == 282 && su2 == 0)
			{
				ArrObj["HOP"] = 204;
			}	
			else if (su1 == 281 && su2 == 0)
			{
				ArrObj["HOP"] = 200;
				
				if (String(tbl.getValue("CLASSID_ACC")) == "8185")
				{
					ArrObj["HOP"] = 219;
					
					var oSnap = getSnap("select fdoc_num from ^HBS where foutid = "+sqlTo(tbl.getValue("DOCID")));
					if (oSnap != null)
						ArrObj["HNOM"] = String(oSnap[0]);
				}
				
				var oSnap = getSnap("select rel.fcod from ^cl left join ^clrelclcl rel on ^cl.fwid = rel.fwid_cl where foutid = " + sqlTo(Number(tbl.getValue("CONTRAGENTID"))))
				if (oSnap && oSnap[0])
					ArrObj["HORG"] = oSnap[0];					
	
				/*
				xmlExt = XMLDoc.createElement("ext");
				xmlExt.setAttribute("name", "LOCK");
				xmlExt.setAttribute("type", "boolean");
				xmlExt.setText("false");
				xmlExtAttr.appendChild(xmlExt);
				*/
			}	
			else if (su1 == 0 && su2 == 281)
			{
				ArrObj["HOP"] = 202;
				var oSnap = getSnap("select rel.fcod from ^cl left join ^clrelclcl rel on ^cl.fwid = rel.fwid_cl where foutid = " + sqlTo(Number(tbl.getValue("CONTRAGENTID"))))
				if (oSnap && oSnap[0])
					ArrObj["HORG"] = oSnap[0];
			}	
			else
			{		
				ArrObj["HOP"] = 5000;
			}
			
			if (ArrObj["HOP"] == 0)
				ArrObj["HOP"] = 5000;
						
			for(sEl in ArrObj)
			{
				var xmlProp = XMLDoc.createElement(sEl);
				if (sEl == "HORG")
				{
					var xmlHeader1 = XMLDoc.createElement("Header");
						var xmlHcod = XMLDoc.createElement("HCOD");
						xmlHcod.setText(ArrObj[sEl]);
						xmlHeader1.appendChild(xmlHcod);
					xmlProp.appendChild(xmlHeader1);
				}
				else
					xmlProp.setText(ArrObj[sEl]);
				xmlHeader.appendChild(xmlProp);
			}
			
			if (ArrObj["HOP"] == 220)
			{
				var o = new Object;
				o.org = ArrObj["HORG"]; 
				o.dat = toScrObj(tbl.getValue("DATEOD")); 
				ArrNkOrgs[String(o.org) + String(o.dat)] = o;
			}				
		
			nCount0++;
			
			if (nCount0 % 100 == 0)
			{
				nCount0 = 1;
				
			    oImp.waitSuffix = " " + nCount + " из " + tbl.recordCount;

				var xmlHead = root.getElementsByTagName("Header")
			    if (xmlHead[0] != null)
			    	oImp.ImportObject(root);
			    else
			    	alert(1111)
				gc();			

				XMLDoc = new DpXMLDOMDocument();
				root = XMLDoc.createElement("root");	
				XMLDoc.appendChild(root);
			}			
		}
		
		// debug info 
		//showObject(arrData)
		//XMLDoc.getOwnerDocument().save("C:/BrokImp2.xml")	
		//return;	
		
		// import xml
		
	    oImp.ImportObject(root);
		gc();			
			
        ExecuteSQL("DELETE FROM ^IMPORT_TETRA_SUMM " 
        	+ " WHERE TL_START = (SELECT TL_START FROM Debet..acc_history_calc_v WHERE ID = " + id + " )" 
        	+ " AND TL_END = (SELECT TL_END FROM Debet..acc_history_calc_v WHERE ID = " + id + " )"
 		);
        ExecuteSQL("INSERT INTO ^IMPORT_TETRA_SUMM (TL_START, TL_END) " 
        	+ " (SELECT TL_START, TL_END FROM Debet..acc_history_calc_v WHERE ID = " + id + " )"
        	);
        	
        // обновляем продажи
		for(sEl in ArrNkOrgs)
		{
			if (differ(toScrObj(ArrNkOrgs[sEl].dat), toScrObj(gd.dat1)) == -1)
			{
				// не пересоздаем документы в раннем периоде
				continue;
			}
			MergeDateBS(" FNOP = 220 ", ArrNkOrgs[sEl].dat, ArrNkOrgs[sEl].org);
		}

		break;
	case "SHOW_DOCS":
		var id = Number(list.tbl.getValue("ID"));
		var tl_start = "(SELECT TL_START FROM Debet..acc_history_calc_v WHERE id = " + id + ")";
		var tl_end = "(SELECT TL_END FROM Debet..acc_history_calc_v WHERE id = " + id + ")";;
		browse("SELECT * from Debet..acc_doc_good_v WHERE TL between "
			+ tl_start + " and " + tl_end);
		break;
		
	case "SHOW_DOCS2":
		var id = Number(list.tbl.getValue("ID"));
		var tl_start = "(SELECT TL_START FROM Debet..acc_history_calc_v WHERE id = " + id + ")";
		var tl_end = "(SELECT TL_END FROM Debet..acc_history_calc_v WHERE id = " + id + ")";;
		browse("SELECT a.sumdoc as sum_tetra, b.fsum+b.fsum1 as sum_debet, a.dateod as dat_tetra, b.fdoc_dat as dat_debet, a.NDOC, a.NDOC44, b.fdoc_num as num_debet, * from Debet..acc_doc_good_v a"
			+ " LEFT JOIN ^HBS b on a.docid=b.foutid "		
			+ " WHERE a.TL between "	+ tl_start + " and " + tl_end
			+ " and a.classid_acc<>8199 AND a.CLASSID_ACC <> 8192 AND a.CLASSID_ACC <> 8187"			
			+ " AND b.fwid is not null"
				+ " AND (" + IIF("b.fnop = 207 or b.fnop = 208 or b.fnop = 209","abs(a.costacc)","a.sumdoc") + " <> " + IIF("b.fnop = 207 or b.fnop = 208 or b.fnop = 209","b.fsum","b.fsum+b.fsum1") + " "
			+ "		or a.dateod<>b.fdoc_dat "
//			+ "		or (a.NDOC<>b.fdoc_num and a.NDOC44<>b.fdoc_num)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_200 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_202 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_204 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_205 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_206 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_207 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_208 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_209 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_210 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_211 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_219 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or abs(a.costacc) <> (select fsum1 from Debet..H_BS_220 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_200 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_202 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_204 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_205 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_206 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_207 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_208 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_209 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_210 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_211 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_219 bs_ext where bs_ext.fmainwid = b.fwid)"
			+ "		or classid_acc <> (select fclassid from Debet..H_BS_220 bs_ext where bs_ext.fmainwid = b.fwid)	"
			+ "		)"
			);
		break;
		
	case "DEL_DOCS":
		var gd = new DpGetDat(new Array("dat"));
		if (gd.escape == true)
			return;
		var tbl = OpenTable("select * from ^HBS where FDOC_DAT >= " + sqlTo(new Date(gd.fdat))
			+ " and foutid IN (SELECT DocGoodid from Debet..acc_doc_good_out_v) "
			+ " AND NOT ("
			+" 		(FNOP = 200 or FNOP = 201 or FNOP = 202 or FNOP = 211 )" 
			+ " 	AND EXISTS(SELECT FWID FROM ^schet where ^schet.fdoc<> '_R' and ^schet.fid_doc = ^HBS.fwid)"
			+ " )"			
			);
		var delCount = tbl.recordCount;

		var conf = msgBox("c-",UR("Підтвердіть вилучення записів "
								+ "| Подтвердите удаление записей ") + delCount, UR("Вилучення|Удаление"));
		if (conf != "-")
			return;

		var oDoc = new DpDoc("BS", 0);
		setProgressRange(1, delCount);
		var nCount = 0;
		
		//browse(tbl);
		//return;
		
		for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
		{
			setProgressPos(nCount++, nCount+"/"+delCount);
			oDoc.clear();
			oDoc.setVar("HOP", Number(tbl.getValue("FNOP")));
			oDoc.setVar("HDOC", String(tbl.getValue("FDOC")));
			oDoc.del(Number(tbl.getValue("FWID")));
			oDoc.oReg == null;	
			oDoc.delRegistration();			
			oDoc.oReg == null;	
				
			//Точка видалення проводок
			ExecuteSQL("DELETE FROM ^schet"
				 + " WHERE FDOC <> '_R' AND FID_DOC =" + Number(tbl.getValue("FWID")));
		}
											
		break;
		
	default:
		break;
	}
}

function fillPodrMap()
{
	var sSQL = "select fcod, fpodr, fmol, fsu, fsc, fcontr, fBS_NUM from  ^clrelclcl r left join " 
		+ getPath("EXT") + "..CL_250 e on r.fwid_cl = e.fmainwid " 
		+ " where r.fcl = 250  order by fcod";
	var tbl = OpenTable(sSQL);
	while (!tbl.isEOF())
	{
		var sCod = Number(tbl.getValue("FCOD"));
		var nPodr = Number(tbl.getValue("FPODR"));
		var nMol = Number(tbl.getValue("FMOL"));
		var nSu = Number(tbl.getValue("FSU"));
		var nSc = Number(tbl.getValue("FSC"));
		var nNop = Number(tbl.getValue("FBS_NUM"));		
		if (!nSc) 
			nSc = 28;
		var nContr = Number(tbl.getValue("FCONTR"));
		var o = new Object();
		o.PODR = nPodr;
		o.MOL =nMol;
		o.SU = nSu;
		o.SC = nSc;
		o.CONTR = nContr;
		o.NOP = nNop;
		if (o.NOP > 10000)
		{
			alert("error in CL 250: " + sCod);
			o.NOP = 0;			
		}
		ArrTetraPodr[sCod] = o;		
		tbl.moveNext();		
	}	
}

include("sys\\DpList.js");