//"Завантаження даних по кореспонденцiї в довідку 1-ДФ
include("sys\\main.js");
include("sys\\servis.js");
include("servis\\date.js");
include("Objects\\DpGrid.js");
include("Objects\\DpAskEx.js");

var oA;
var ds;
var nCl;
var tblOut = getTmpTableName("", true);
var nType;
var nKod;
var	isDohNar;
var	isDohVypl;
var	isPodNar;
var	isPodVypl;	

var	bDat;
var eDat;
var oScDt;
var	oScCr;
var	nProc;
var grpByFld;
var condDt;
var condCr;
var ret = true;
function listLoad()
{
	dsSaveFormat(false);

	with( list )
	{
		title = "Завантаження даних по кореспонденцiї в довідку 1-ДФ|Загрузка данных по кореспонденции в справку 1ДФ";
	}
}

function listAsk()
{
	ds = DataSource();
	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "FBDAT", new Date().getVarDate());
	oA.add("D", "Дата закінчення|Дата окончания", "FEDAT", new Date().getVarDate());
	oA.add("NUM", "Ознака доходу для 1-ДФ|Признак дохода для 1-ДФ", "FKOD", 0, 3);
	oA.add("NUM", "Відсоток|Процент", "FPROC", 100, 8, 5);
	oA.add("REM", "Суму записати в колонки:|Сумму записать в колонки:", "MREM2");
	oA.add("B", "Дохiд нарахований|Доход начисленный", "ISDOHNAR", false);
	oA.add("B", "Дохiд виплачений|Доход выплаченный", "ISDOHVYPL", false);
	oA.add("B", "Податок нарахований|Налог начисленный", "ISPODNAR", false);
	oA.add("B", "Податок виплачений|Налог выплаченный", "ISPODVYPL", false);

	oA.setRel(">=", "FEDAT", "FBDAT");
	oA.doAsk();
	//Если Escape - закрываем расчёт
	if (oA.escape)
	{
		CloseWindow();
		return oA;
	}

	bDat = new Date(oA.get("FBDAT"));
	eDat = new Date(oA.get("FEDAT"));
	nKod = oA.get("FKOD");
	nProc = oA.get("FPROC");
	isDohNar = oA.get("ISDOHNAR");
	isDohVypl = oA.get("ISDOHVYPL");
	isPodNar = oA.get("ISPODNAR");
	isPodVypl = oA.get("ISPODVYPL");	
	nType = extPar.priklbl.toUpperCase() == "_DF2" ? 1 : 0;

	if (nKod == 0)
	{
		alert(ru("Признак дохода не может быть равен нулю","Ознака доходу не може бути рівною нулю"));
		CloseWindow();
		return false;
	}	

	
	//Формируем заголовок окна
	list.title = ru(" Данные ", " Дані ")
		+ ru("за период с ","за період з ") + d_m_y(new Date(oA.get("FBDAT")))
		+ " по " + d_m_y(new Date(oA.get("FEDAT")));
	return oA;
}

function listMake()
{
	if(!ret)
	{
		CloseWindow();
		return false;		
	}
	
	var fld = new Object();
	fld.FFIO = "TEXT(255)";
	fld.FINDNUM = "TEXT(10)";
	fld.FSUM = "MONEY";
	fld.FWID = "COUNTER";
	CreateTable(tblOut, fld);
	
	cDate = bDat;
	while(cDate <= eDat)
	{
		r_sum_alim("", cDate);
		cDate = goMonth(cDate, 1);
	}
}


function r_sum_alim(mode, dat)
{
	SVZPFILE = "SVZP"+month_txt(dat);
	
	if (!IsTableEx("ZRP_RES","ZRP_"+SVZPFILE))
	{
		WAIT("Отсутствуют результаты расчета зарплаты за "+d_m_y(dat))
		return false;
	}
	
	strSQL = " INSERT INTO "+tblOut+" (FFIO, FINDNUM, FSUM)"
			+" SELECT TR.FFIO AS FFIO"
				+", TR.FINDNUM AS FINDNUM"
				+", SUM(S.FSUM) AS FSUM"
			+" FROM (((^"+SVZPFILE+" S"
				+" INNER JOIN ^PRK_AL P ON S.FID_PRK = P.FWID AND S.FTABN_ID = P.FTABN_ID)"
					+" INNER JOIN ^CL_TRPLACE TR ON P.FWIDTR = TR.FWID_CL)"
						+" INNER JOIN ^LIC_FLD L ON S.FLSFID = L.FID)"
			+" WHERE L.FIS5 = 'а'"
			+" GROUP BY TR.FFIO, TR.FINDNUM"
	ExecuteSQL(strSQL);
	return true;
}

function listSrc()
{
	with( list )
	{
		qrySet("From", tblOut);
	}
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix()
	list.GroupPage(oGrid, oPrefix);            
	with (oGrid)
	{
		with(oPrefix)
		{
		}

		with (page("1ДФ"))
		{
			with (group("1ДФ"))
			{
				cell("FFIO", "ПІБ|ФИО", 25);
				cell("FINDNUM", "ІПН|ИНН", 10);
				cell("FSUM", "Сума", 9);
			}
		}
	}
	oGrid.build();
}

function listMenuInit(ds)
{
	if(!grid.getTable().IsEmpty())
	{
		ds.AddMenuItem("LDSOTR", "Завантажити відмічені записи в наказ|Загрузить отмеченные записи в приказ");
	}
}

function listMenuRun(szID)
{
	var  t = grid.getTable();
	switch(szID)
	{
		case "LDSOTR":
			if (r_imp2prk(new Date(oA.get("FBDAT")), extPar.fvid, tblOut, nType, nKod))
			{
				alert(ru("Перенос данных завершено.","Перенесення даних закінчено."));
				grid.getTable().requery();
		    	grid.refresh();
			}
		break;
	}
}

function r_imp2prk(dat, vidprk, tbl, nType, nKod)
{
	include("sys/udfs.js");
	var isPer = false;
	var D1 = firstday(new Date(dat)).getVarDate();
	var mFin_Table;
	mFin_Table = nType == 0 ? "PRK8DR" : "PRK8DRD";

	strSQL = " SELECT * "
					+" FROM " + tbl
				+" WHERE " +DataSource().sqlSelected()
	tbl_svwr = OpenTable(strSQL);

	if (tbl_svwr.IsEmpty())
	{
		strMsg = "Відсутні дані для переносу"
		alert(strMsg);
		return false;
	}

	var oPrik = new DpPrik("_DF2", vidprk);
	for(tbl_svwr.MoveFirst(); !tbl_svwr.IsEOF(); tbl_svwr.MoveNext())
	{
		switch (nType)
		{
			case 1: // ЧП или Орендодатели
				okpo = tbl_svwr.getValue("FINDNUM");
				if (!isEmpty(okpo))
				{
					WAIT(okpo);
					oPrik.clear();
					
					oPrik.setVar("FVID_PRK", vidprk);
					oPrik.setVar("TIN", okpo);
					oPrik.setVar("FBDAT", D1) ;
					oPrik.setVar("FSUM", (isDohVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMN", (isDohNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNAL", (isPodVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNALN", (isPodNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FVIDNACH" ,Number(nKod)) ;					
					oPrik.setVar("FWID", GetUID());		
					oPrik.setVar("FIN_TABLE", mFin_Table);
					
					oPrik.save();

					strSQL = "DELETE FROM "+tbl
							+" WHERE 1=1"
							+" AND FWID = "+sqlTo(tbl_svwr.getValue("FWID"))
					ExecuteSQL(strSQL);
					
					isPer = true;
				}
			break;
		}
	}

	CLEARWAIT();
	tbl_svwr.close();
	tbl_svwr = null;

	return isPer;
}
include("sys\\DpList.js");