//"Завантаження даних по кореспонденцiї в довідку 1-ДФ
include("sys\\main.js");
include("sys\\servis.js");
include("servis\\date.js");
include("Objects\\DpGrid.js");
include("Objects\\DpAskEx.js");
include("mtr_ost.js");

var oA;
var ds;
var nCl;
var tblOut = getTmpTableName("", true);
var nType;
var nKod;
var	isDohNar;
var	isDohVypl;
var	isPodNar;
var	isPodVypl;	

var	bDat;
var eDat;
var oSc;
var	nProc;
var nObor;
var ret = true;
function listLoad()
{
	dsSaveFormat(false);

	with( list )
	{
		title = "Завантаження даних по кореспонденцiї в довідку 1-ДФ|Загрузка данных по кореспонденции в справку 1ДФ";
	}
}

function listAsk()
{
	ds = DataSource();
	oA = new DpAskEx();
	oA.add("D", "Дата початку|Дата начала", "FBDAT2", new Date().getVarDate());
	oA.add("D", "Дата закінчення|Дата окончания", "FEDAT2", new Date().getVarDate());
	oA.add("C0UTXYZ", "Рахунок|Счет", "SC2", "200|0|4");
	oA.add("RADIO", "Тип:|Тип:", "FOBOR2", 0, ru("получение", "отримання")+"|"+ru("списание", "списання"));
	oA.add("NUM", "Ознака доходу для 1-ДФ|Признак дохода для 1-ДФ", "FKOD2", 0, 3);
	oA.add("REM", "Суму записати в колонки:|Сумму записать в колонки:", "MREM2");
	oA.add("B", "Дохiд нарахований|Доход начисленный", "ISDOHNAR", false);
	oA.add("B", "Дохiд виплачений|Доход выплаченный", "ISDOHVYPL", false);
	oA.add("B", "Податок нарахований|Налог начисленный", "ISPODNAR", false);
	oA.add("B", "Податок виплачений|Налог выплаченный", "ISPODVYPL", false);

	oA.setRel(">=", "FEDAT2", "FBDAT2");
	oA.doAsk();
	//Если Escape - закрываем расчёт
	if (oA.escape)
	{
		CloseWindow();
		return oA;
	}

	bDat = new Date(oA.get("FBDAT2"));
	eDat = new Date(oA.get("FEDAT2"));
	oSc = oA.get("SC2");
	nObor = oA.get("FOBOR2");
	nKod = oA.get("FKOD2");
	isDohNar = oA.get("ISDOHNAR");
	isDohVypl = oA.get("ISDOHVYPL");
	isPodNar = oA.get("ISPODNAR");
	isPodVypl = oA.get("ISPODVYPL");	
	nType = extPar.priklbl.toUpperCase() == "_DF2" ? 1 : 0;
	nCl = getPar("CODPERS");

	if (nKod == 0)
	{
		alert(ru("Признак дохода не может быть равен нулю","Ознака доходу не може бути рівною нулю"));
		CloseWindow();
		return false;
	}	

	//Формируем заголовок окна
	list.title = ru(" Данные ", " Дані ")
		+ ru("за период с ","за період з ") + d_m_y(new Date(oA.get("FBDAT2")))
		+ " по " + d_m_y(new Date(oA.get("FEDAT2")));
	return oA;
}


function listMake()
{
	if(!ret)
	{
		CloseWindow();
		return false;		
	}

	// выполним расчет оборотной ведомости по ТМЦ
	with(new DpMtrOb())
	{
		date1 = bDat;
		date2 = eDat;
		fsc   = oSc.getSc();
		fsu   = oSc.getSu();
		fst   = oSc.getSt();
		pattern = "obr";
		tblName = "TBL_OBOR_1DF";
		isSprKol = true;
		doCalc();
	}

	DropTable(tblOut);
	strSQL = " SELECT "
		+" T.FMOL AS FCOD"

		// приход
		+", SUM(T.FPSUMR) AS FPSUMR"
		+", SUM(T.FPSUMV) AS FPSUMV"

		// расход
		+", SUM(T.FRSUMR) AS FRSUMR"
		+", SUM(T.FRSUMV) AS FRSUMV"
	+" INTO "+ tblOut
	+" FROM TBL_OBOR_1DF T"
	+" GROUP BY "
		+" T.FMOL"
	ExecuteSQL(strSQL);

	ExecuteSQL("ALTER TABLE " + tblOut + " ADD COLUMN FSUM " + sqlType("MONEY"));

	strSQL = " UPDATE "+ tblOut
			+" SET "
				+" FSUM = "+sqlRound((nObor==0 ? " FPSUMR + FPSUMV" : " FRSUMR + FRSUMV"), 2)
	ExecuteSQL(strSQL);

	strSQL = " DELETE FROM "+ tblOut
			+" WHERE "
				+" FSUM = 0"
	ExecuteSQL(strSQL);

	if(nCl == sprOrg)
	{
		//проставляем ОКПО
		ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FOKPO " + SqlType("TEXT", 12));
		strSQL = " UPDATE "
				+" " + tblOut
			+" SET FOKPO = "
				+"("
					+" SELECT DISTINCT POST.FCOD_ST"
						+" FROM "
					+" ^CLRELCLCL REL, "
					+" ^CL_POST POST"
				+" WHERE "
					+ tblOut + ".FCOD = REL.FCOD "
					+" AND REL.FCL = "+nCl
					+" AND POST.FWID_CL = REL.FWID_CL "
				+")"
		ExecuteSQL(strSQL);

		//Удаляем не нужные записи
		strSQL = " DELETE "
			+" FROM "
				+" " + tblOut
			+" WHERE "
				+" LEN(FOKPO)<10 "
				+" OR FOKPO IS NULL"
		ExecuteSQL(strSQL);
	}
	else if(nCl == 2)
	{
		if (nType==1)
		{
			//проставляем идент.код
			ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FOKPO " + SqlType("TEXT", 12));
			strSQL = " UPDATE "
					+" " + tblOut
				+" SET FOKPO = "
					+"("
						+" SELECT DISTINCT HOMO.FINDNUM"
							+" FROM "
						+" ^CLRELCLCL AS REL, "
						+" ^CL_HOMO AS HOMO"
					+" WHERE "
						+tblOut+".FCOD = REL.FCOD "
						+" AND REL.FCL = " + nCl
						+" AND HOMO.FWID_CL = REL.FWID_CL "
					+")"						
			ExecuteSQL(strSQL);
		}
		else
		{
			//проставляем id табельного номера
			ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FTABN_ID " + SqlType("LONG"));
			strSQL = " UPDATE "
					+" " + tblOut
				+" SET FTABN_ID = "
					+"("
						+" SELECT DISTINCT REL.FWID_CL"
							+" FROM "
						+" ^CLRELCLCL AS REL "
					+" WHERE "
						+tblOut+".FCOD = REL.FCOD "
						+" AND REL.FCL = " + nCl
					+")"						
			ExecuteSQL(strSQL);

			//проставляем id табельного номера
			ExecuteSQL("ALTER TABLE " + tblOut +" ADD COLUMN FWID_WP " + SqlType("LONG"));
			strSQL = " UPDATE "
					+" " + tblOut
				+" SET FWID_WP = "
					+"("
						+" SELECT MIN(WP.FWID)"
							+" FROM "
						+" ^WORK_PERS AS WP "
					+" WHERE "
						+tblOut+".FTABN_ID = WP.FWID_CL "
						+" AND "
						+"(WP.FBDAT <= " + sqlTo(bDat)
						+" AND WP.FEDAT >= " + sqlTo(bDat)
						+" OR "
						+" WP.FBDAT <= " + sqlTo(eDat)
						+" AND WP.FEDAT >= " + sqlTo(eDat)
						+" )"
					+")"						
			ExecuteSQL(strSQL);
		}
	}
	ExecuteSQL("ALTER TABLE " + tblOut + " ADD COLUMN FWID " + sqlType("COUNTER"));
	
}

function listSrc()
{
	with( list )
	{
		qrySet("From", tblOut);
		qrySet("Order", "FCOD");
		//clTie("cl", "="+ (extPar.priklbl.toUpperCase() == "_DF2" ? 12 : 2) +", FCOD");
		clTie("cl", "="+ nCl +", FCOD");
	}
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix()
	list.GroupPage(oGrid, oPrefix);            
	with (oGrid)
	{
		with(oPrefix)
		{
		}

		with (page("1ДФ"))
		{
			with (group("1ДФ"))
			{
				cell("FCOD", "код", 5);
				cell("CL.FTXT", "ПІБ", 25);
				cell("FSUM", "Сума", 9);
				cell("FOKPO", "ІПН", 10);
			}
		}
	}
	oGrid.build();
}

function listMenuInit(ds)
{
	if(!grid.getTable().IsEmpty())
	{
		ds.AddMenuItem("LDSOTR", "Завантажити відмічені записи в наказ|Загрузить отмеченные записи в приказ");
	}
}

function listMenuRun(szID)
{
	var  t = grid.getTable();
	switch(szID)
	{
		case "LDSOTR":
			if (r_imp2prk(new Date(oA.get("FBDAT2")), extPar.fvid, tblOut, nType, nKod))
			{
				alert(ru("Перенос данных завершен","Перенесення даних закінчено"));
				grid.getTable().requery();
		    	grid.refresh();
			}
		break;
	}
}

function r_imp2prk(dat, vidprk, tbl, nType, nKod)
{
	include("sys/udfs.js");
	var isPer = false;
	var D1 = firstday(new Date(dat)).getVarDate();
	var mFin_Table;
	mFin_Table = nType == 0 ? "PRK8DR" : "PRK8DRD";

	strSQL = " SELECT * "
					+" FROM " + tbl
				+" WHERE " +DataSource().sqlSelected()
	tbl_svwr = OpenTable(strSQL);

	if (tbl_svwr.IsEmpty())
	{
		strMsg = "Відсутні дані для переносу"
		alert(strMsg);
		return false;
	}

	var oPrik = new DpPrik(nType == 0 ? "_DF1" : "_DF2", vidprk);
	for(tbl_svwr.MoveFirst(); !tbl_svwr.IsEOF(); tbl_svwr.MoveNext())
	{
		switch (nType)
		{
			//Для обычного приказа 1 ДФ
			case 0:
				mFtabn = tbl_svwr.getValue("FCOD");
				if (!isEmpty(mFtabn))
				{
					WAIT(mFtabn);
					oPrik.clear();
					
					oPrik.setVar("FVID_PRK", vidprk);
					oPrik.setVar("FTABN_ID", tbl_svwr.getValue("FTABN_ID"));
					oPrik.setVar("FWID_WP", tbl_svwr.getValue("FWID_WP"));
					oPrik.setVar("FEDAT", D1);	//Нач. квартала
					oPrik.setVar("FBDAT", D1);	//М-ц выплаты
					oPrik.setVar("FMN", D1);	//М-ц начисления
					oPrik.setVar("FSUM", (isDohVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMN", (isDohNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNAL", (isPodVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNALN", (isPodNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FVIDNACH" ,Number(nKod)) ;					
					oPrik.setVar("FWID", GetUID());		
					oPrik.setVar("FIN_TABLE", mFin_Table);
					
					oPrik.save();

					strSQL = "DELETE FROM "+tbl
							+" WHERE 1=1"
							+" AND FWID = "+sqlTo(tbl_svwr.getValue("FWID"))
					ExecuteSQL(strSQL);
					
					isPer = true;
				}
			break;
			case 1: // ЧП или Орендодатели
				okpo = tbl_svwr.getValue("FOKPO");
				if (!isEmpty(okpo))
				{
					WAIT(okpo);
					oPrik.clear();
					
					oPrik.setVar("FVID_PRK", vidprk);
					oPrik.setVar("TIN", okpo);
					oPrik.setVar("FBDAT", D1) ;
					oPrik.setVar("FSUM", (isDohVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMN", (isDohNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNAL", (isPodVypl ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FSUMNALN", (isPodNar ? round(tbl_svwr.getValue("FSUM"), 2) : 0));
					oPrik.setVar("FVIDNACH" ,Number(nKod)) ;					
					oPrik.setVar("FWID", GetUID());		
					oPrik.setVar("FIN_TABLE", mFin_Table);
					
					oPrik.save();

					strSQL = "DELETE FROM "+tbl
							+" WHERE 1=1"
							+" AND FWID = "+sqlTo(tbl_svwr.getValue("FWID"))
					ExecuteSQL(strSQL);
					
					isPer = true;
				}
			break;
		}
	}

	CLEARWAIT();
	tbl_svwr.close();
	tbl_svwr = null;

	return isPer;
}
include("sys\\DpList.js");