include("sys/DpList.js");

var dpListMaker = null;

function listLoad()
{
	dpListMaker = extPar.dpListMaker;
	this.localTableName = getTmpTableName();
	this.title = dpListMaker.title;
	this.accDel = new Function("return false");
	var strSQL = "";
	for (var i = 0; i < dpListMaker.columnCount; i++)
	{
		var fieldName = (dpListMaker.id == null) ? "f" + i : dpListMaker.id[i];
		if (i == 0)
			strSQL += fieldName + " " + SqlType("text");
		else
			strSQL += "," + fieldName + " " + SqlType("text");
	}
	if (strSQL.equals(""))
		strSQL = "f0 " + SqlType("text");
	strSQL = "CREATE TABLE " + this.localTableName + " (" + strSQL + ")";
	ExecuteSQL(strSQL);
	if (dpListMaker.data != null)
	{
		for (var i in dpListMaker.data)
		{
			var m = new Object();
			for (var j in dpListMaker.data[i])
				m[(dpListMaker.id == null) ? "f" + j : dpListMaker.id[j]] = dpListMaker.data[i][j];
			UpdateTable(this.localTableName, m, true);
		}
	}
	this.subUnLoad = listUnload;				 
}

function listSrc()
{
	this.qrySet("From", this.localTableName);
}

function listDpGrid()
{
	with (grid)
	{
		for (var i = 0; i < dpListMaker.columnCount; i++)
			FieldEx
			(
				(dpListMaker.id == null) ? "f" + i : dpListMaker.id[i],
				(dpListMaker.head == null) ? "field" + i : dpListMaker.head[i],
				(dpListMaker.columnWidth == null) ? 10 : dpListMaker.columnWidth[i]
			);
	}
	grid.build();
}

function listUnload()
{
	ExecuteSQL("DROP TABLE " + this.localTableName, false);
}	