function listLoad()
{
	with(this)
	{
		title="Дорог.метали (загальний список)|Драг. металлы (общий список)";
		editTask = "e_sdrmet.xml";
		xmlGridFile = "l_metal.xml";
	}
}

function listSrc()
{
	this.qrySet	(
					"From", "^METAL",
					"Order","Finv_num,Fnum"
				);	
}

function listMenuInit()
{
	if(list.tbl.rowCount>0)
	{
		list.dataSrc.AddMenuItem("MASS_COPY","Масове копіювання|Массовое копирование");
		list.dataSrc.AddMenuItem("SET_PRIZN","Проставити ознаку наявності драгметалів в інвентарних картках|Проставить признак наличия драгметаллов в инвентарных карточках");
	}
}

function listMenuRun(sID)
{
	switch(sID)
	{
		case "MASS_COPY":
			var snap = getSnap("select count(distinct Finv_num) from ^metal where "+grid.sqlSelected())
			if(snap && snap[0]>1)
			{
				alert(ru("Копировать записи можно только с одного инвентарного номера.",
						"Копіювати записи можна тільки з одного інвентарного номера."),1);
				return false;
			}
			var oPar = new Object;
			oPar.doc = "O7";
			oPar.zaval = true;
			oPar.escape = false;
			oPar.ret = new Object();
			oPar.ret.finv_num = 0;
			showWindow("l_docekz.xml",SW_MODAL,oPar);
			if(oPar.escape)
				return false;
			var invAr = new Array();
			if(oPar.retArray.length==0)
				invAr[0] = oPar.ret.finv_num;
			else
			{
				for(var i=0; i<oPar.retArray.length; i++)
				{
					//исключаем лишние элементы массива, т.к. в представлении инв.карточек на один Fwid может быть несколько записей по кол-ву записей в списке изменений
					if(!invAr.some( function(item){ return item==oPar.retArray[i].finv_num; }))
						invAr[invAr.length] = oPar.retArray[i].finv_num;
				}
			}
			setProgressRange(1, invAr.length);
			for(var i=0; i<invAr.length; i++)
			{
				setProgressPos(i+1, ru("Копирование инв.№ ","Копіювання інв.№ ")+invAr[i]);
				var tbl = OpenTable("select * from ^metal where "+grid.sqlSelected());
				if(tbl.rowCount==0)
					break;
				for(; !tbl.IsEOF(); tbl.MoveNext())
				{
					m = scatter(tbl);
					m.FWID = GetUID();
					m.FINV_NUM = invAr[i];
					UpdateTable("^metal", m, true);
				}
				tbl.close();
				ExecuteSQL("update ^os7 set Fmetal="+sqlTo("+")+" where finv_num="+invAr[i]);
			}
			setProgressPos(0);
			list.tbl.requery();
			grid.RefreshGrid();
		break;
		case "SET_PRIZN":
			ExecuteSQL("update ^os7 set Fmetal="+sqlTo("+")+" where Finv_num in (select distinct Finv_num from ^metal where "+grid.sqlSelected()+")");
			grid.clearSelected();
			grid.RefreshGrid();
		break;
	}
}

function listDel()
{
	ExecuteSQL("delete from ^metal where Fwid="+list.tbl.getValue("Fwid"));
	var snap = getSnap("select Fwid from ^metal where Finv_num="+list.tbl.getValue("Finv_num"));
	if(!snap)
		ExecuteSQL("update ^os7 set Fmetal="+sqlTo("-")+" where Finv_num="+list.tbl.getValue("Finv_num"));
	return false;
}

function listMassDel()
{
	var tbl = OpenTable("select distinct Finv_num from ^metal where "+grid.sqlSelected());
	var invAr = new Array();
	for(; !tbl.IsEOF(); tbl.MoveNext())
		invAr[invAr.length] = Number(tbl.getValue("Finv_num"));
	tbl.close();
	ExecuteSQL("delete from ^metal where "+grid.sqlSelected());
	ExecuteSQL("update ^os7 set Fmetal="+sqlTo("-")+" where Finv_num in ("+invAr+") and not exists(select Fwid from ^metal as m where m.Finv_num=^os7.Finv_num)");
}
include("sys\\DpList.js")