//Редактирование справочных сумм переносимых из отдельных расчетов
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");
include("Objects/DpGrid.js");

var szTag;
var dpGridEdit = null;
var dpShifPZ = null;

function listLoad()
{
	var gd = new DpGetDat("d");
	if (gd.escape)
		return false;
	this.title = "Список довідкових сум з окремих розрахунків за |Список справочных сумм из отдельных расчетов за "+format("dd.mm.yyyy",gd.dat1);
	szTag = getDateTag(gd.dat1);

	if (!IsTableEx("ZRP_MDB","ZRP_MVLS"+szTag))
	{
		alert(ru("Произведите сначала отдельный расчет!","Виконайте спершу окремий розрахунок!"));
		return false;
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("Fields", "s.*, rel.Fcod",
				"From", "^mvls"+szTag+" AS s LEFT JOIN ^clrelclcl AS rel ON s.Ftabn_id=rel.Fwid_cl",
				"Order", "rel.Fcod, ffld_num");
	this.subTie("LIC_FLD","LCFLD","FID","FLSFID");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
	this.qrySet("Alias", "s");
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
//	oGrid.defCond("=^Ftxtpers==null", "err")
//	oGrid.color(17, "err");
	var gr = oGrid.page();
	with(gr)
	{
		with(group("Поле ОР|Поле ЛС"))
		{
			FieldEx("lcfld.ffld_num", "№", 4);
			FieldEx("lcfld.ftxt", "Назва|Название", 10);
			FieldEx("flsfid", "Код", 4);
		}
		FieldEx("fcod", "Таб №|Таб №", 5);
		FieldEx("=getSmallFIO(^cl.ftxt)", "ПІБ|ФИО", 15);
		FieldEx("fsum", "Сума|Сумма", 8, "e", "%10.2f");
		FieldEx("fproc", "%", 4, null, "%10.2f");
		FieldEx("fmn", "Дата виникн.|Дата возникнов.", 8);
		FieldEx("fday", "Днiв|Дней", 5);
		FieldEx("fchas", "Годин|Часов", 5);
		FieldEx("fshpz", "ШВЗ|ШПЗ", 5);
	}
	oGrid.build();   		
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^mvls"+szTag+" WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
}

function listMassDel()
{
	ExecuteSQL("DELETE FROM ^mvls"+szTag+" WHERE Fwid "+DataSource().sqlSelected(true));
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	UpdateTable("^mvls"+szTag, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}
include("sys/DpList.js");