var strSelectID = "";
var tbl = null;
var tblRow = null;
var arrMonth = new Array( ru("Январь   ", "Січень   ")
						, ru("Февраль  ", "Лютий    ")
						, ru("Март     ", "Березень ")
						, ru("Апрель   ", "Квітень  ")
						, ru("Май      ", "Травень  ")
						, ru("Июнь     ", "Червень  ")
						, ru("Июль     ", "Липень   ")
						, ru("Август   ", "Серпень  ")
						, ru("Сентябрь ", "Вересень ")
						, ru("Октябрь  ", "Жовтень  ")
						, ru("Ноябрь   ", "Листопад ")
						, ru("Декабрь  ", "Грудень  "));

var isSubtract = getPar("NVK_SUBTRACT");

function onLoad()
{
	Caption("Норми часу|Нормы времени")
	oTree.addColumn("txt", ru("Название","Назва"), 250);
	oTree.addColumn("nd", ru("Норма дни","Норма дні"), 75);
	oTree.addColumn("nt", ru("Норма часы","Норма години"), 75);
	oTree.addColumn("vd", ru("Всего дни","Всього дні"), 75);
	oTree.addColumn("vt", ru("Всего часы","Всього години"), 75);
	if (isSubtract)
	{
		oTree.addColumn("cal", ru("Календарь","Календар"), 75);
	}
	
	this.onMenuRun = onMenuRun;
	this.onMenuInit = onMenuInit;
	this.onSelected = onSelected;
	this.canEdit = tree_canEdit;
	oTree.selectMenuHandler(this, "onMenuRun");
	oTree.loadMenuHandler(this, "onMenuInit");
	oTree.setTreeSelHandler(this, "onSelected");	
	oTree.setCanEditHandler(this,"canEdit");
	fillTree();
}

function tree_canEdit()
{
	return false;
}

function fillTree()
{
	if(null==tbl)
	{
		var strSQL = "SELECT * FROM ^cl_vopl"
			+ " WHERE fvopl>=1000 AND fvopl<9000"
				+ " AND fgroup=" + SqlTrue 
				+ " AND fserv=" + SqlFalse 
			+ " ORDER BY fvopl";
		tbl = OpenTable("s", strSQL);
		
	}
	else
	{
		tbl.Requery();
	}

	if(null==tblRow)
	{
		strSQL = "SELECT * FROM ^tbl_ini ORDER BY fvopl, fbdat desc";
		tblRow = OpenTable("s", strSQL);
	}
	else
	{
		tblRow.Requery();
	}
	
	if(tbl.isEmpty())
		return;

	var parentID = "";
	for(tbl.MoveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{
		var nodeID = "o" + String(tbl.getValue("fvopl"));
		var nodeTXT = String(tbl.getValue("fvopl"));
		nodeTXT += "(" + String(tbl.getValue("fnzv_vopl")) + ")";
		oTree.addItem(parentID, nodeID, nodeTXT);
	}
	
	if(tblRow.isEmpty())
		return;
		
	for(tblRow.MoveFirst(); !tblRow.IsEOF(); tblRow.MoveNext())
	{
		var parentID = "o" + String(tblRow.getValue("fvopl"));
		var bdat = tblRow.getValue("fbdat");
		var nodeID = "y" + parentID + "_" + (bdat.getYear() + 1900);
		if(null==oTree.getItem(nodeID))
		{
			oTree.addItem(parentID, nodeID, (bdat.getYear() + 1900));
		}
		
		parentID = nodeID;
		nodeID = String(tblRow.getValue("fwid"));
	
		var nodeTXT = arrMonth[bdat.getMonth()];
		oTree.addItem(parentID, nodeID, nodeTXT, 3);
		oTree.setValue(nodeID, "nd", String(tblRow.getValue("fnorma_d")));
		oTree.setValue(nodeID, "nt", String(tblRow.getValue("fnorma_ch")));
		oTree.setValue(nodeID, "vd", String(tblRow.getValue("fvsego_d")));
		oTree.setValue(nodeID, "vt", String(tblRow.getValue("fvsego_ch")));
		if (isSubtract)
		{
			oTree.setValue(nodeID, "cal", String(tblRow.getValue("fcalnum")));
		}
	}	
}

function onMenuInit(toObject)
{
	var parentID = String(oTree.getParentCod());
	if("o" == strSelectID[0])
	{
		toObject.AddMenuItem("ADD", "Додати|Добавить");
	}
	else if("o" == parentID[0])
	{
		if(oTree.getChildsOf(strSelectID).length < 12)
			toObject.AddMenuItem("ADD", "Додати|Добавить");
	}
	else if("y" == parentID[0])
	{ 
		if(oTree.getChildsOf(parentID).length < 12)
		{
			toObject.AddMenuItem("ADD", "Додати|Добавить");
			toObject.AddMenuItem("COPY", "Скопіювати|Копировать");
		}
		
		toObject.AddMenuItem("EDIT", "Редагувати|Редактировать");
		toObject.AddMenuItem("DEL", "Вилучити|Удалить");
	}
}

function onMenuRun(sID, toObject)
{
	if("DEL" == sID)
	{
		if(strSelectID[0]!="o" && strSelectID[0]!="y")
		{
			var conf = msgBox("ny",ru("Вы действительно хотите удалить запись?","Ви дійсно бажаєте видалити запис?"));
			if (conf != "y")
				return false;
			strSQL = "DELETE FROM ^tbl_ini WHERE fwid=" + strSelectID;
			ExecuteSQL(strSQL);
			oTree.removeItem(strSelectID);
		}
		return;
	}
	
	var par = new Object();
	par.escape = true;
	par.mode = sID;
	if("o" == strSelectID[0])
		par.fvopl = Number(strSelectID.substr(1));
	else if("y" == strSelectID[0])
		par.fvopl = Number(strSelectID.substr(2, strSelectID.indexOf("_") - 2));
	else
	{
		var parentID = String(oTree.getParentCod());
		par.fvopl = Number(parentID.substr(2, parentID.indexOf("_") - 2));
	}
	
	if("EDIT" == sID
	|| "COPY" == sID)
	{
		if(!Number(strSelectID))
			return false;
		par.fwid = strSelectID;
	}
	
	if(sID!="DOUBLECLICK")
		showWindow("e_normTime.xml", SW_MODAL, par);
	if(false==par.escape)
	{
		if("EDIT" == sID)
			oTree.removeItem(strSelectID);

		var strSQL = "SELECT fvopl, fnorma_d, fnorma_ch, fvsego_d, fvsego_ch, fbdat, fwid "+(isSubtract ? ", fcalnum" : "")
					+ " FROM ^tbl_ini WHERE fwid=" + sqlTo(Number(par.fwid));
		var snap = getSnap(strSQL);
		if(snap!=null)
		{
			var parentID = "o" + String(snap[0]);
			var bdat = snap[5];
			var nodeID = "y" + parentID + "_" + (bdat.getYear() + 1900);
			if(null==oTree.getItem(nodeID))
			{
				oTree.addItem(parentID, nodeID, (bdat.getYear() + 1900));
			}

			parentID = nodeID;
			nodeID = String(snap[6]);
			var nodeTXT = arrMonth[bdat.getMonth()];
			oTree.addItem(parentID, nodeID, nodeTXT, 3);
			oTree.setValue(nodeID, "nd", String(snap[1]));
			oTree.setValue(nodeID, "nt", String(snap[2]));
			oTree.setValue(nodeID, "vd", String(snap[3]));
			oTree.setValue(nodeID, "vt", String(snap[4]));
			if (isSubtract)
			{
				oTree.setValue(nodeID, "cal", String(snap[7]));
			}
		}
	}
}

function onSelected(sCod, sMode)
{
	if("ENTER" != sMode 
	&& strSelectID == oTree.getSelected())
		return;

	strSelectID = sCod;

}

include("sys/DpBaseDlg.js");