//опись инвертарных карточек
//для Черкасс
include ("Objects\\DpExtentionBuilder.js");
include("sys\\DpList.js");

var listPrnForm = "OPIS";
var tblName;
var label;
var editAcc;

function listLoad()
{
	this.xmlGridFile = "l_os_opis.xml";
	this.printLabel = "OPIS";
	this.title = ru("Опись инв. карточек","Опис інв. карток");
	tblName = "CTG_OPIS"
	label = "OSOPIS";
	editAcc = ""
	dsSaveFormat(false);
	list.par.menuMode = "CALC";
	checkTTFLD(false);
	checkTTSUM();
	list.objTotal.init(label);
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem("UPDATE_ITOG", "Обновить варианты упорядочивания");
	this.dataSrc.AddMenuItem("", "");
}

function listMenuRun(ID)
{
	if (ID == "UPDATE_ITOG")
	{
		checkTTFLD(true);
	}
}

function listMake()
{
/*	if(IsTable(tblName))
		DropTable(tblName);*/

	if(IsTable(tblName))
		return false;

	if(!IsTable("AMORTIN"))
	{
		alert(ru("Сначала рассчитайте амортизацию по налоговому методу!","Спершу розрахуйте амортизацію по податковому методу!"))
		return false;
	}
	//Переносим расчет амортизации		
	//ExecuteSQL("SELECT * INTO " + tblName + " FROM AMORTIN "
	//			+ "WHERE FTDSC = 0 AND FTDSU = 0 AND FTDST = 0 AND FTDA1 = 0 "
	//				+ "AND FTDA2 = 0 AND FTDA3 = 0 AND FTDPODR = 0");
	CreateTable(tblName, "AMORT");
	ExecuteSQL("ALTER TABLE "+tblName+" ADD Fkatos "+SqlType("LONG"), false)
	ExecuteSQL("ALTER TABLE "+tblName+" ADD FtypeOS "+SqlType("LONG"), false)
	
	fields = GetPatternIntersection("AMORT","AMORT").replace(/(fwid\s*,)|(\s*fwid\W)/gi,"")+",Fkatos,Ftypeos"
	ExecuteSQL("INSERT INTO "+tblName+" ("+fields+") select "+fields+" FROM AMORTIN "
				+ "WHERE FTDSC = 0 AND FTDSU = 0 AND FTDST = 0 AND FTDA1 = 0 "
				+ "AND FTDA2 = 0 AND FTDA3 = 0 AND FTDPODR = 0");
					
	//Удаляем лишние колонки
	//ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDSC,FTDSU,FTDST,FTDA1,FTDA2,FTDA3,FTDPODR,FKEYEXPR");
/*	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDSC");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDSU");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDST");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDA1");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDA2");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDA3");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FTDPODR");
	ExecuteSQL("ALTER TABLE " + tblName + " DROP COLUMN FKEYEXPR");*/
	
	//Добавляем новые колонки
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FMOL " + SqlType("LONG"));
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FLPU " + SqlType("LONG"));
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FCR_SC " + SqlType("INTEGER"));// Счет Кт
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FCR_SU " + SqlType("INTEGER"));// Субсчет Кт
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FCR_ST " + SqlType("INTEGER"));// Ст Кт
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FPRIZN " + SqlType("INTEGER"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FTYPOS " + SqlType("INTEGER"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FXAROS " + SqlType("INTEGER"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FPRIVATIZ " + SqlType("INTEGER"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FXARAKT " + SqlType("MEMO"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FMAGTR " + SqlType("MEMO"));// Расширение док-та O7
	ExecuteSQL("ALTER TABLE " + tblName + " ADD "
					+ "FLENTR " + SqlType("MONEY"));// Расширение док-та O7
	

	//Прописываем мол
	strSQL = "UPDATE " + tblName + " SET "
					+ tblName + ".FMOL = (select "+First("V.FTABN")+" from ^VN_PEREM V where "+ tblName + ".FINV_NUM = V.FINV_NUM "
						+ " and V.FBDAT<="+ tblName + ".FDATKV and V.FEDAT>="+ tblName + ".FDATKV), "
					+ tblName + ".FLPU = " + Convert("(select "+First("V.FPODR")+" from ^VN_PEREM V where "+ tblName + ".FINV_NUM = V.FINV_NUM "
						+ " and V.FBDAT<="+ tblName + ".FDATKV and V.FEDAT>="+ tblName + ".FDATKV)/100", "INT");
	ExecuteSQL(strSQL);

    // теперь проставим код УМГ
    // система такая смотрим на первые 2 цифры кода подр:
	// 3 - ЧТГ		(2)
	// 10 - Первом.	(360)
	// 14 - Крем.	(380)
	// 16 - Зол.	(400)
	// 18 - Алекс.	(420)
	// 22 - Гайс.	(440)
	// 26 - Бар		(460)
	ExecuteSQL("UPDATE " + tblName + " SET FLPU = " 
		+ IIF("FLPU=3", 2,
			IIF("FLPU=10", 360,
			IIF("FLPU=14", 380,
			IIF("FLPU=16", 400,
			IIF("FLPU=18", 420,
			IIF("FLPU=22", 440,
			IIF("FLPU=26", 460, "FLPU"))))))));

	// проставим код вида ОС, дату акта приемки и ввода в экспл.
	// (достанем из акта приемки)
	strSQL = "UPDATE " + tblName + " SET "
				+ "FVIDOS = (select O.FVIDOS from ^OS1 O where " + tblName + ".FINV_NUM = O.FINV_NUM)"
	ExecuteSQL(strSQL);

	strSQL = "UPDATE " + tblName + " SET "
				+ "FXARAKT = (select O.FXARAKT from ^OS7 O where " + tblName + ".FINV_NUM = O.FINV_NUM)"
	ExecuteSQL(strSQL);

	//дебет счёт, субсчёт... должно брать по последней записи в изм. стоимости по б/у
	//затратный счёт... из списка внутренних перемещений
	strSQL = "UPDATE " + tblName + " SET "
				+ tblName + ".FCOD_RATE = (select max(O.FCOD_RATE) from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
				+" O.FBDAT<="+ tblName + ".FDATKV AND O.FEDAT>="+ tblName + ".FDATKV),"
				+ tblName + ".FZT_SC = (select MAX(O.FSC) from ^vn_perem O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^vn_perem O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV)),"
				+ tblName + ".FZT_SU = (select MAX(O.FSU) from ^vn_perem O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^vn_perem O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV)),"
				+ tblName + ".FZT_ST = (select MAX(O.FST) from ^vn_perem O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^vn_perem O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV)),"
				+ tblName + ".FCR_SC = (select max(O.FCR_SC) from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
				+" O.FBDAT<="+ tblName + ".FDATKV AND O.FEDAT>="+ tblName + ".FDATKV),"
				+ tblName + ".FCR_SU = (select max(O.FCR_SU) from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
				+" O.FBDAT<="+ tblName + ".FDATKV AND O.FEDAT>="+ tblName + ".FDATKV),"
				+ tblName + ".FCR_ST = (select max(O.FCR_ST) from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
				+" O.FBDAT<="+ tblName + ".FDATKV AND O.FEDAT>="+ tblName + ".FDATKV),"
				+ tblName + ".FDB_SC = (select distinct O.FDB_SC from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^OS0B O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV)),"
				+ tblName + ".FDB_SU = (select distinct O.FDB_SU from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^OS0B O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV)),"
				+ tblName + ".FDB_ST = (select distinct O.FDB_ST from ^OS0B O where "+ tblName + ".FINV_NUM = O.FINV_NUM AND "
					+" O.FBDAT=(SELECT MAX(O2.Fbdat) FROM ^OS0B O2 WHERE O2.Finv_num="+ tblName + ".FINV_NUM AND O2.FBDAT<="+ tblName 
					+".FDATKV AND O2.FEDAT>="+ tblName + ".FDATKV))";
	ExecuteSQL(strSQL);
	//var tmpTblName = getTmpTableName();
	var ext = new DpExtentionBuilder("H","O7",null);
	var tblExtName = ext.getValueTableName();
	
	ExecuteSQL("UPDATE " + tblName + " SET Fprizn = "
					+ "(SELECT d.Fprizn FROM "
						+ "(SELECT b.Fprizn, c.Finv_num FROM " + tblExtName + " b "
							+ "INNER JOIN ^OS7 c ON c.Fwid = b.Fmainwid) d "
					+ "WHERE "+ tblName + ".Finv_num = d.Finv_num)");
			
	ExecuteSQL("UPDATE " + tblName + " SET "+ tblName + ".Fprivatiz = "
					+ "(SELECT d.Fprivatiz FROM "
						+ "(SELECT b. Fprivatiz, c.Finv_num FROM " + tblExtName + " b "
							+ "INNER JOIN ^OS7 c ON c.Fwid = b.Fmainwid) d "
					+ "WHERE "+ tblName + ".Finv_num = d.Finv_num)");

    //проставить для расширений PRIVATIZ значение по умолчанию для тех, у кого null
	ExecuteSQL("UPDATE " + tblName + " SET "+ tblName + ".Fprivatiz = "
						+ "(SELECT Fprivatiz FROM " + tblExtName 
							+ " where Fmainwid=0 or fmainwid is null) "
					     + "WHERE "+ tblName + ".Fprivatiz is null");
					
	ExecuteSQL("UPDATE " + tblName + " SET "+ tblName + ".Fmagtr = "
					+ "(SELECT d.Fmagtr FROM "
						+ "(SELECT b. Fmagtr, c.Finv_num FROM " + tblExtName + " b "
							+ "INNER JOIN ^OS7 c ON c.Fwid = b.Fmainwid) d "
					+ "WHERE "+ tblName + ".Finv_num = d.Finv_num)");
					
	ExecuteSQL("UPDATE " + tblName + " SET "+ tblName + ".FLENTR = "
					+ "(SELECT d.FLENTR FROM "
						+ "(SELECT b.FLENTR, c.Finv_num FROM " + tblExtName + " b "
							+ "INNER JOIN ^OS7 c ON c.Fwid = b.Fmainwid) d "
					+ "WHERE "+ tblName + ".Finv_num = d.Finv_num)");

	ExecuteSQL("UPDATE " + tblName + " SET Fxaros = Fkatos, Ftypos=Ftypeos")

}

function listSrc()
{
	with(this)
	{
		qrySet("From",tblName,"Order","FINV_NUM, FPODR, FMOL, FGROUP","Prn", listPrnForm);
		subTie("OSNAZV", "x_osnazv", "FINV_NUM", "Finv_num");
	//не пдолежит приватизации
		subTie("OS7", "os7", "FINV_NUM", "Finv_num");
	// подр
		subTie("clrelclcl","CLRELPD","CLCOD","="+sqlTo(sprPodr)+",FPODR");
		subTie("cl","PD","FWID","CLRELPD.FWID_CL",null,TIE_NOSEARCH);
	// МОЛ
		subTie("clrelclcl","CLRELML","CLCOD","="+sqlTo(sprMol)+",FMOL");
		subTie("cl","ML","FWID","CLRELML.FWID_CL",null,TIE_NOSEARCH);
    // LPU
    	subTie("clrelclcl","CLRELLP","CLCOD","="+sqlTo(sprOrg)+",FLPU");
    	subTie("cl","LP","FWID","CLRELLP.FWID_CL",null,TIE_NOSEARCH);
    // PRIZN
    	subTie("clrelclcl","CLRELPRZN","CLCOD","=109,FPRIZN");
    	subTie("cl","PRZN","FWID","CLRELPRZN.FWID_CL",null,TIE_NOSEARCH);
    // XAROS
    	subTie("clrelclcl","CLRELXAROS","CLCOD","=110,FXAROS");
    	subTie("cl","XAROS","FWID","CLRELXAROS.FWID_CL",null,TIE_NOSEARCH);
    // TYPOS
    	subTie("clrelclcl","CLRELTYPOS","CLCOD","=111,FTYPOS");
    	subTie("cl","TYPOS","FWID","CLRELTYPOS.FWID_CL",null,TIE_NOSEARCH);
    // PRIVATIZ
    	subTie("clrelclcl","CLRELPRIV","CLCOD","=210,FPRIVATIZ");
    	subTie("cl","PRIV","FWID","CLRELPRIV.FWID_CL",null,TIE_NOSEARCH);
    }
}

//----------------------------------------------------------------
function checkTTFLD(bWithDel)
{
	if (bWithDel == true)
		ExecuteSQL("DELETE FROM ^CL_TTFLD WHERE FLIST="+sqlTo(label));
	var pSnap = getSnap("SELECT count(*) FROM ^CL_TTFLD WHERE FLIST="+sqlTo(label));
	// есть строки - ничего делать не будем
	if(pSnap && pSnap[0] > 0)
		return;

	ExecuteSQL("delete from ^cl_ttfld where FLIST="+sqlTo(label));
	var tbl_TTFLD = OpenTable("s", "CL_TTFLD");
	// прийдется добавлять строки
	var mfwid;
	var m = new Object();
	//1) МОЛ
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FMOL";
	m.Flist = label;
	m.Fno = 1;
	m.Ftt = "ML";
	m.Ftxt = "МОЛ";
	UpdateTable("^CL_TTFLD", m, true);
	//2) Подр.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FPODR";
	m.Flist = label;
	m.Fno = 2;
	m.Ftt = "PD";
	m.Ftxt = "Подразделение";
	UpdateTable("^CL_TTFLD", m, true);
	//3) УМГ
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FLPU";
	m.Flist = label;
	m.Fno = 3;
	m.Ftt = "LP";
	m.Ftxt = "УМГ";
	UpdateTable("^CL_TTFLD", m, true);
	//4) Группа
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FGROUP";
	m.Flist = label;
	m.Fno = 4;
	m.Ftt = "GR";
	m.Ftxt = "Группа";
	UpdateTable("^CL_TTFLD", m, true);
	//5) Код КОФ
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FVIDOS";
	m.Flist = label;
	m.Fno = 5;
	m.Ftt = "VD";
	m.Ftxt = "Вид ОС (код КОФ)";
	UpdateTable("^CL_TTFLD", m, true);
	//6) Код нормы аморт
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FCOD_RATE";
	m.Flist = label;
	m.Fno = 6;
	m.Ftt = "RT";
	m.Ftxt = "Код нормы аморт.";
	UpdateTable("^CL_TTFLD", m, true);
	//7) Дт сч.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FDB_SC";
	m.Flist = label;
	m.Fno = 7;
	m.Ftt = "DS";
	m.Ftxt = "Дб. Счет";
	UpdateTable("^CL_TTFLD", m, true);
	//8) Дт субсч.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FDB_SU";
	m.Flist = label;
	m.Fno = 8;
	m.Ftt = "DU";
	m.Ftxt = "Дб. Субсчет";
	UpdateTable("^CL_TTFLD", m, true);
	//9) Дт ст.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FDB_ST";
	m.Flist = label;
	m.Fno = 9;
	m.Ftt = "DT";
	m.Ftxt = "Дб. Статья";
	UpdateTable("^CL_TTFLD", m, true);
	//10) Кт сч.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FCR_SC";
	m.Flist = label;
	m.Fno = 10;
	m.Ftt = "CS";
	m.Ftxt = "Кт. счет";
	UpdateTable("^CL_TTFLD", m, true);
	//11) Кт субсч.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FCR_SU";
	m.Flist = label;
	m.Fno = 11;
	m.Ftt = "CU";
	m.Ftxt = "Кт. субсчет";
	UpdateTable("^CL_TTFLD", m, true);
	//12) Кт ст.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FCR_ST";
	m.Flist = label;
	m.Fno = 12;
	m.Ftt = "CT";
	m.Ftxt = "Кт. статья";
	UpdateTable("^CL_TTFLD", m, true);
	//13) Затр. счет
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FZT_SC";
	m.Flist = label;
	m.Fno = 13;
	m.Ftt = "ZS";
	m.Ftxt = "Затр. счет";
	UpdateTable("^CL_TTFLD", m, true);
	//14) Затр. субсчет
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FZT_SU";
	m.Flist = label;
	m.Fno = 14;
	m.Ftt = "ZU";
	m.Ftxt = "Затр. субсчет";
	UpdateTable("^CL_TTFLD", m, true);
	//15) Затр. статья
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FZT_ST";
	m.Flist = label;
	m.Fno = 15;
	m.Ftt = "ZT";
	m.Ftxt = "Затр. статья";
	UpdateTable("^CL_TTFLD", m, true);
	//16) PRIZN
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FPRIZN";
	m.Flist = label;
	m.Fno = 16;
	m.Ftt = "PR";
	m.Ftxt = "Признак ОС";
	UpdateTable("^CL_TTFLD", m, true);
	//17) PRIVATIZ
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FPRIVATIZ";
	m.Flist = label;
	m.Fno = 17;
	m.Ftt = "PV";
	m.Ftxt = "Подлежит приватиз.";
	UpdateTable("^CL_TTFLD", m, true);
	//18) Общий итог
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "!";
	m.Flist = label;
	m.Fno = 18;
	m.Ftt = "!!";
	m.Ftxt = "Общий итог";
	UpdateTable("^CL_TTFLD", m, true);
	//19) TYPOS
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FTYPOS";
	m.Flist = label;
	m.Fno = 19;
	m.Ftt = "TO";
	m.Ftxt = "Тип ОЗ";
	UpdateTable("^CL_TTFLD", m, true);
	//20) XAROS
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FXAROS";
	m.Flist = label;
	m.Fno = 20;
	m.Ftt = "XO";
	m.Ftxt = "Кат. ОЗ";
	UpdateTable("^CL_TTFLD", m, true);
	//21) XARAKT
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FXARAKT";
	m.Flist = label;
	m.Fno = 21;
	m.Ftt = "XS";
	m.Ftxt = "Хар-ка ОЗ";
	UpdateTable("^CL_TTFLD", m, true);
	//22) MAGTR
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Fcond = "";
	m.Fdefa = "0";
	m.Ffield = "FMAGTR";
	m.Flist = label;
	m.Fno = 22;
	m.Ftt = "MG";
	m.Ftxt = "ГАЗОПРОВІД";
	UpdateTable("^CL_TTFLD", m, true);

	return;
}

function checkTTSUM()
{
	tbl_TTSUM = OpenTable("s", "SELECT * FROM ^CL_TTSUM WHERE FLIST=" + sqlTo(label));
	if(!tbl_TTSUM.IsEmpty())
	{
		// есть строки - ничего делать не будем
		tbl_TTSUM.Close();
		return;
	}
	// прийдется добавлять строки
	var mfwid;
	var m = new Object();
	//1) перв. стоим.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Ffield = "FORIG_PRIC";
	m.Ffunc = "sum";
	m.Flist = label;
	m.Fno = 1;
	m.Ftxt = "";
	UpdateTable("^CL_TTSUM", m, true);
	//2) перв. износ.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Ffield = "FSUM_IZN";
	m.Ffunc = "sum";
	m.Flist = label;
	m.Fno = 2;
	m.Ftxt = "";
	UpdateTable("^CL_TTSUM", m, true);
	//3) Ост. стоим.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Ffield = "FSUM_PV";
	m.Ffunc = "sum";
	m.Flist = label;
	m.Fno = 3;
	m.Ftxt = "";
	UpdateTable("^CL_TTSUM", m, true);
	//4) тек. изн.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Ffield = "FSUM_AM";
	m.Ffunc = "sum";
	m.Flist = label;
	m.Fno = 4;
	m.Ftxt = "";
	UpdateTable("^CL_TTSUM", m, true);
	//5) ликв. стоим.
	mfwid = GetUID();
	m.Fwid = mfwid;
	m.Ffield = "FLIKVST";
	m.Ffunc = "sum";
	m.Flist = label;
	m.Fno = 5;
	m.Ftxt = "";
	UpdateTable("^CL_TTSUM", m, true);
	
	tbl_TTSUM.Close();
	return;
}