//Редактирование доплат за прошлые периоды по фондам
include("servis/date.js");
include("objects/DpGetDat.js");
include("gridedit.js");
include("Objects/DpShifPZ.js");

var szTag;
var dpGridEdit = null;
var gd;

function listLoad()
{
	gd = new DpGetDat("d");
	if (gd.escape)
		return false;
	this.title = "Список доплат по фондах за попередні періоди |Список доплат по фондам за прошлые периоды "+format("dd.mm.yyyy",gd.dat1);
	this.xmlGridFile = "l_pererpf.xml";
	this.editTask = "e_pererpf.xml";
	szTag = getDateTag(gd.dat1);

	if (!IsTableEx("ZRP_MDB","ZRP_DLTF"+szTag))
	{
		alert(ru("Произведите сначала расчет!","Виконайте спершу розрахунок!"));
		return false;
	}
	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
}

function listSrc()
{
	this.qrySet("Fields", "s.*, rel.Fcod",
				"From", "^dltf"+szTag+" AS s LEFT JOIN ^clrelclcl AS rel ON s.Ftabn_id=rel.Fwid_cl",
				"Order", "rel.Fcod, ffld_num");
	this.subTie("LIC_FLD","LCFLD","FID","FLSFID");
	this.subTie("cl", "cl", "Fwid", "Ftabn_id");
	this.qrySet("Alias", "s");
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^dltf"+szTag+" WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
}

function listMassDel()
{
	ExecuteSQL("DELETE FROM ^dltf"+szTag+" WHERE Fwid "+this.dataSrc.getSqlSelected(true));
}

function gridEdit(modeID)
{
	if(modeID=="COPY" || modeID=="ADD")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	UpdateTable("^dltf"+szTag, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function listInitEditParam(par)
{
	par.bdat = goMonth(new Date(gd.dat1),-1);
	par.edat = gd.dat1;
	par.tblName = "^dltf"+szTag;
}
include("sys/DpList.js");