include("objects/DpTVars.js");
include("objects/DpCl.js");
include("objects/DpGetDat.js");
include("objects/DpProt.js");
include("doc/DpDocPtn.js");
include("sys/servis.js");
include("otbprov.js");

var par = new Object;
var p = new Object;
var t17;
var t14;
var gr;
var ds;

function listTitle()
{
	//return ru("Журнал регистрации проводок", "Журнал реєстрації проведень");
	return ru("Дебет 7 класса", "Дебет 7 класу");
}

function listLoad()
{
	this.editTask = "e_provav.xml";
	
	par.fid_doc = extPar.fid_doc;
	t17 = extPar.tbl;
	t17.MoveFirst();
}

function listSrc()
{	
	this.qrySet("From", "^SCHETAV" 
				,"Where", "(FID_DOC="+ extPar.fid_doc +" AND FDB_SC>68 AND FDB_SC<89) OR FUSER=255"
				,"Order", "FDB_SU,FDB_ST,"+ IIF("FNOP=0 OR FNOP IS NULL", 0, 1) +",FDB_COD1");
}

function listDpGrid()
{	
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	oGrid.defCond("=^FUSER==253", "253");
	oGrid.defCond("=^FUSER==254 || ^FUSER==255 || ^FUSER==256", "254");
	oGrid.color(2, "253");	
	oGrid.color(1, "254");

	gr.FieldEx("FTXT", "Види\nРах.|Виды\nСч.", 25);
	with(gr.group("Дебет|Дебет"))
	{
		FieldEx("Fdb_sc", "Рах.|Сч.", 5);
		FieldEx("Fdb_su", "С/р|С/с", 5);
		FieldEx("Fdb_st", "Ст.|Ст.", 5); 
		FieldEx("FDB_COD1", "Ан.1|Ан.1", 5);
		FieldEx("FDB_COD2", "Ан.2|Ан.2", 5);
	}
	with(gr.group("Кредит|Кредит"))
	{
		FieldEx("", "Рах.|Сч.", 5);
		FieldEx("", "С/р|С/c", 5);
		FieldEx("", "Ст.|Ст.", 5);
		FieldEx("", "Ан.1|Ан.1", 5);
	}
	gr.fieldEx("FSUM", "Сума|Сумма", 12, "r", DP_FORMAT_SUM);

	oGrid.build();	
}

function listMenuInit(ds)
{
	//if(t17.IsRecord())
	if(!t17.IsEmpty())
	{
		ds.AddMenuItem("CTRL-D", "Пошук документа за проведенням|Поиск документа по проводке");
		ds.AddMenuItem("","");
		ds.AddMenuItem("1111",  "Формування проведень|Формирование проводок");
		ds.AddMenuItem("CRED",  "Кредит рахунку 7 класу|Кредит счета 7 класса");
		ds.AddMenuItem("PRINT", "Друк списку|Печать списка");
	}
}

function listMenuRun(szID)
{	
	var t = list.tbl;	
	if(extPar)
		list.objParMenu.fid_doc = extPar.fid_doc;
	switch(szID)
	{
	case "CTRL-D"://поиск документа по проводке		
		FindDocument(t.getValue("Fdoc"), t.getValue("Fnop"), t.getValue("Fid_doc"));
	break;
	
	case "1111": 
		include("avizo.js");
		exeAvOp(t.getValue("Fid_doc"));
	break;
	case "CRED":
		p.fid_doc = extPar.fid_doc;
		t14 = extPar.tbl1;
		p.tbl = t14;
		p.nomav1 = extPar.nomav1;
		p.komu = extPar.komu;
		p.otkogo = extPar.otkogo;
		p.dat = extPar.dat;
		showWindow("l_prova2.js",SW_NOMODAL,p);
	break;
	
	case "PRINT": 
		printsp();
	break;
	}
}

function printsp()
{
	var h = new Object();
	var tv = new DpTVars();
	
	tv.setPatt(lpProxy.getWrkDir()+ "listPrintForms/AVIZO/USMOE08.jrxml", true);
		
	include("sys/udfs.js");
	var dat = extPar.dat;
	var month = tmonth(dat.getMonth()+1, 1);

	tv.setVar("NOMAV",	extPar.nomav1);
	tv.setVar("KOMU",	extPar.komu);
	tv.setVar("OTKOGO",	extPar.otkogo);
	tv.setVar("YEAR",	year(dat));
	tv.setVar("MONTH",	month);

	tv.setHTbl(h);
	tv.setRTbl(t17);

	tv.print();
}

include("sys/DpList.js");