include("Objects/DpGetDat.js");
include("servis/format.js");
include("sys/dbase.js")
include("gridedit.js");
include("Objects/DpExtentionBuilder.js");

var editAcc = "E"
var prnPatt = "rezraz";
var delFilter = false;
var tblName;
var tbl;
var gr;
var ds;
var res_moni;
var objAsk;

function listLoad()
{ 
	ds = DataSource();
   	this.printLabel = "REZRAZ";
   	
   	dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.canEdit = gridEdit;
	dpGridEdit.saveRecord = saveRecord;
 	
  	if(extPar && extPar.objAsk)
  		objAsk = extPar.objAsk;
  	else
  		objAsk = new DpGetDat("d");
	if(objAsk.escape)
		return false;

	if(extPar)
		extPar.dat1 = objAsk.dat1;
	res_moni = new Date(objAsk.dat1.getYear()+1900, objAsk.dat1.getMonth(), 1);
	//чтоб можно потом было считать дату в скриптах из popupmenu
	list.objAsk = objAsk;
	var res_mon = res_moni;
	monthtxt1 = format("yyyymm", res_mon);
	menuMode = GetMenuMode();
	if(extPar && extPar.menuMode)
		menuMode = extPar.menuMode;
	if(menuMode.length>0)
		tblName = menuMode+monthtxt1;
	else
		tblName = "schr"+monthtxt1;
	
	switch(String(menuMode))
	{
		case "RZSHPB":
			this.title = ru("Просмотр разнесения по счетам (ШПЗ) за ","Перегляд рознесення по рахунках (ШВВ) за ")+format("dd.mm.yy",objAsk.dat1);
		break;
		case "RZSHPT":
			this.title = ru("Просмотр разнесения по счетам (ШПЗ + поля ЛС) за ","Перегляд рознесення по рахунках (ШВВ + поля ОР) за ")+format("dd.mm.yy",objAsk.dat1);
		break;
		case "RAZN2B":
		default:
			this.title = ru("Просмотр разнесения по счетам за ","Перегляд рознесення по рахунках за ")+format("dd.mm.yy",objAsk.dat1);
		break;
	}
	if (!IsTable(tblName))
    { 
   	    alert(ru("Выполните разнесение по счетам за выбранный месяц","Виконайте рознесення по рахункам за обраний місяць"));
       	return false;
   	}  
}

function listSrc()
{
	this.qrySet("From", tblName
				//,"Order", "FNAZV_OP");
				//,"Order", "FDB_SC,FDB_SU,FCR_SC,FCR_SU");
				//,"Order", "Fdoc_num,FDB_SC,FDB_SU,FDB_ST,FDB_COD1,FCR_SC,FCR_SU,FCR_ST,FCR_COD1,FNAZV_OP");
				,"Order", "FDB_SC,FDB_SU,FDB_ST,FDB_COD1,FCR_SC,FCR_SU,FCR_ST,FCR_COD1,FNAZV_OP");
	this.clTie("org0", "="+ getPar("CODMYORG") +",FORG0", "clorg0");
}

function listDpGrid()
{
	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	gr.FieldEx("Fdoc_num","№\nдок.|№\nдок.",5);
    gr.FieldEx("FNAZV_OP","Змiст  операцiї\n(пiдстава)|Содержание операции\n(основания)",20);
    with(gr.group("Дебет|Дебет"))
    {
    	FieldEx("Fdb_sc","Рах.|Сч.",7);
    	FieldEx("Fdb_su","С/рах.|С/сч.",7);
    	FieldEx("Fdb_st","Ст.|Ст.",7);
    	FieldEx("Fdb_cod1","Ан.1|Ан.1",7);
    	FieldEx("Fdb_cod2","Ан.2|Ан.2",7);
    	FieldEx("Fdb_cod3","Ан.3|Ан.3",7);
    }
    with(gr.group("Кредит|Кредит"))
    {
    	FieldEx("Fcr_sc","Рах.|Сч.",7);
    	FieldEx("Fcr_su","С/рах.|С/сч.",7);
    	FieldEx("Fcr_st","Ст.|Ст.",7);
    	FieldEx("Fcr_cod1","Ан.1|Ан.1",7);
        FieldEx("Fcr_cod2","Ан.2|Ан.2",7);
    	FieldEx("Fcr_cod3","Ан.3|Ан.3",7);
    }
    gr.FieldEx("Fsum","Сума|Сумма", GRID_SUM_WDT, "e", DP_FORMAT_SUM);
    gr.FieldEx("Fdate","Дата|Дата", 12);
	gr.FieldEx("=!^Forg0? '' : ^Forg0 +': '+ ^org0.Ftxt", "Організація|Организация", 6);
   	oGrid.build();   
}

function listMenuInit(ds)
{
	if(!list.tbl.isEmpty())
	{
		//ds.AddMenuItem("1","Перегляд списку платiжних доручень|Просмотр списока платежных поручений");   
    	//ds.AddMenuItem("2","Додавання платiжного доручення|Добавление платежного поручения");   
    	//ds.AddMenuItem("MOVE_PROV","Перенести проведення в список|Перенести проводки в список");   
    	ds.AddMenuItem("4","Округлити суми|Округлить суммы");   
		ds.AddMenuItem("PRNLIST2","Друк|Печать");
		ds.AddMenuItem("PRNLIST2TOTALS","Друк тільки підсумків|Печать только итоговых строк");
		ds.AddMenuItem("PRNLIST2NOTOTALS","Друк без підсумків|Печать без итоговых строк");
		ds.AddMenuItem("RBAZNACH","Показати базу та нарах.ЄСВ для розр.з кодами вир.|Показать базу и нач.ЕСВ для расч.с кодами изд.");		
    }
}


function listMenuRun(nID)
{
	switch (nID)
   	{
		case "PRNLIST2":
		case "PRNLIST2TOTALS":
		case "PRNLIST2NOTOTALS":
			include("objects\\DpTVars.js");
			var tv = new DpTVars("NDFL");
			var h = new Object();
			h.FDATE = new Date(objAsk.dat1);
			
			tmpName = getTmpTableName();
       		ExecuteSQL("SELECT a.fdb_cod1 as fpodr, 0 as fcfz, 0 as fpodr2, a.fdb_st as ftotal, max(a.fwid) as fwid, min(Fext) as Fpodrlist, 0 as FGROUP_FLD, 0 as fkol "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='Аванс текущего месяц' ) as FSUM_AVANS "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='ЗП предидущего месяца' ) as FSUM_ZP "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='ЗП текущего месяца' ) as FSUM_ZP2 "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='К выдаче по соцстраху' ) as FSUM_SOC "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='Пособия по беременности и родам' ) as FSUM_BEREM "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='Текущая касса' ) as FSUM_CASSA "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='На карточку' ) as FSUM_CARD "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='Итого текущего месяца' ) as FSUM_ITOGO "    

				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='больничные предидущего месяца' ) as FSUM1 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='окдад' ) as FSUM2 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='премия' ) as FSUM3 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='проф. отп.' ) as FSUM4 "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='НДФЛ' ) as FSUM5 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='Итого предидущего месяца' ) as FSUM6  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='бол.с.с' ) as FSUM7  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='больн. предпр.' ) as FSUM8  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_cod1=a.fdb_cod1 and b.fdb_st=a.fdb_st and b.fnazv_op='ЕСВ' ) as FSUM9  "			    


 				+ " INTO " + tmpName    
       			+ " FROM " + tblName + " a WHERE "
       			+ (nID == "PRNLIST2TOTALS" ? " a.fdb_st = 1 AND " : " ")
       			+ (nID == "PRNLIST2NOTOTALS" ? " a.fdb_st = 0 AND " : " ")
       			+ " a.fdb_cod2 = 1"
       			+ " GROUP BY fdb_cod1, fdb_cod2, fdb_st"
       			+ " ORDER BY fdb_cod1, fdb_cod2, fdb_st");
       			
       		ExecuteSQL("INSERT INTO " + tmpName + " SELECT 0 as fpodr, a.fdb_cod2 as fcfz, 0 as fpodr2, a.fdb_st as ftotal, max(a.fwid) as fwid, min(Fext) as Fpodrlist, 0 as FGROUP_FLD, 0 as fkol "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='Аванс текущего месяц' ) as FSUM_AVANS "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='ЗП предидущего месяца' ) as FSUM_ZP "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='ЗП текущего месяца' ) as FSUM_ZP2 "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='К выдаче по соцстраху' ) as FSUM_SOC "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='Пособия по беременности и родам' ) as FSUM_BEREM "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='Текущая касса' ) as FSUM_CASSA "       		 
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='На карточку' ) as FSUM_CARD "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='Итого текущего месяца' ) as FSUM_ITOGO "    

				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='больничные предидущего месяца' ) as FSUM1 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='окдад' ) as FSUM2 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='премия' ) as FSUM3 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='проф. отп.' ) as FSUM4 "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='НДФЛ' ) as FSUM5 "    
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='Итого предидущего месяца' ) as FSUM6  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='бол.с.с' ) as FSUM7  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='больн. предпр.' ) as FSUM8  "
				+ ", (select sum(fsum) from " + tblName + " b where b.fdb_cod2=a.fdb_cod2 and b.fdb_st=a.fdb_st and b.fnazv_op='ЕСВ' ) as FSUM9  "			    

       			+ " FROM " + tblName + " a WHERE "
       			+ (nID == "PRNLIST2TOTALS" ? " a.fdb_st = 1 AND " : " ")
       			+ (nID == "PRNLIST2NOTOTALS" ? " a.fdb_st = 0 AND " : " ")
       			+ " a.fdb_cod2 <> 1"
       			+ " GROUP BY fdb_cod2, fdb_st"
       			+ " ORDER BY fdb_cod2, fdb_st");
       			
			var ext = new DpExtentionBuilder("CL", String(sprPodr), null);
       		var t = OpenTable("SELECT * FROM " + tmpName)
			t.MoveFirst();
			while (!t.isEOF())
			{
				if (t.getValue("Fpodr") != 0)
				{
					var oSnap = getSnap("SELECT max(b.fcod) from ^cl a left join ^clrelclcl b on a.fwid = b.fwid_cl left join " + ext.getValueTableName() + " c on c.fmainwid=b.fwid_cl where fzrppodr=" + sqlTo(t.getValue("Fpodr")));
					if (oSnap != null && oSnap[0] != null)
					{
						ExecuteSQL("UPDATE " + tmpName + " SET fpodr2 = " + sqlTo(oSnap[0]) 
							+ " WHERE FWID = " + sqlTo(Number(t.getValue("Fwid"))));
					}
				}
				
				if (t.getValue("Fpodrlist") != "")
				{
					ExecuteSQL("UPDATE " + tmpName + " SET FGROUP_FLD = (select min(fpodr) from " 
						+ tmpName + " b where b.fpodr in (" + t.getValue("Fpodrlist") + "))" 
						+ " where fpodr in (" + t.getValue("Fpodrlist") + ") ");
				}
				
				// проставляем количество людей
				var nCount = 0;
				bdat = firstDayMonth(objAsk.dat1);
				edat = lastDayMonth(objAsk.dat1);
				if (String(t.getValue("Fpodrlist")) == "")
					arrPodr = String(t.getValue("Fpodr")).split(",");
				else
					arrPodr = String(t.getValue("Fpodrlist")).split(",");
				for(var i=0; i<arrPodr.length; i++)
				{
					var snap1 = getSnap("SELECT Fleftkey, Frightkey FROM ^stru_org WHERE FLV1=" + sqlTo(Number(arrPodr[i])));
					if (snap1 != null)
					{
						var snap = getSnap("select count(wp.Fwid) as Fkol " +
								"from ^stru_org so inner join ^stru_dol sd on so.fwid = sd.fwid_org inner join  ^work_pers wp on sd.fwid = wp.fwid_dol  " +
								"where (Fleftkey between "+sqlTo(snap1[0])
							+" and "+sqlTo(snap1[1])+") and wp.Fbdat<="+sqlTo(edat)+" and wp.Fedat>="+sqlTo(bdat));
						if (snap != null)
							nCount = nCount + snap[0]; 
					}
				}								
				ExecuteSQL("UPDATE " + tmpName + " SET FKOL = " + sqlTo(nCount) 
					+ " WHERE FWID = " + sqlTo(Number(t.getValue("Fwid"))));
				
				t.MoveNext();
			}

       		var t2print = OpenTable("SELECT * FROM " + tmpName + " ORDER BY fpodr, fcfz, FGROUP_FLD, ftotal")
       		//browse(t2print);
			tv.setHTbl(h);
			tv.setRTbl(t2print);
			tv.print();
		break;
    	case "MOVE_PROV":	//просто переносим все в список проводок
    		var sFields = GetPatternIntersection("schr", "schet").replace(/(fwrk\s*,)|(,\s*fwrk)/gi,"")
       		var t = OpenTable("SELECT " + sFields + ", 5 as Fwrk, Fnazv_op as Ftxt, Fdoc_num as Fdocnum "
        		+" FROM "+tblName+" WHERE "+ds.sqlSelected());
    		
        	var k = 0;
        	if (!t.IsEmpty())
			{
				t.MoveFirst();
				while (!t.isEOF())
				{
					var m = scatter(t);
					delete(m.FNAZV_OP);
					delete(m.FDOC_NUM);
					m.FTXT = t.getValue("Ftxt")+" ("+t.getValue("Fdocvid")+")";
					m.FSUMSPR = 0;
					m.FVAL = 0;
					m.FVKURS = 0;
					m.FVALSPR = 0;
					m.FDOC = "";
					m.FNOP = 0;
					m.FID_DOC = 0;
					m.FWID = GetUID();
					UpdateTable("^schet", m, true);

					t.MoveNext();
					k++;
				}
			}
			t.close();
    		
       		alert(ru("Проводки перенесены в список.","Проведення перенесени до списку.")+" ("+k+" штук)");
      		break;
      		
    	case "4":  
       		var tabn = 0
       		var p_tabn = input(ru("Введите знак, до которого округлять суммы","Введіть знак, до якого округляти суми")
       						 , ru("Округление","Округлення"), tabn,2,0)
        	if(!p_tabn || p_tabn<0)
            	return;
        	var bm = list.tbl.bookmark;
        	
        	for(list.tbl.MoveFirst(); !list.tbl.IsEOF(); list.tbl.MoveNext())
            {
            	mFsum = list.tbl.getValue("Fsum");
                if (mFsum%(10*p_tabn)!=0)
                {	
                    ExecuteSQL("UPDATE ^"+ tblName +" SET FSUM="+ round(mFsum,p_tabn) +" WHERE FSUM="+ mFsum);
               	}
          	}
         	list.tbl.bookmark = bm;
         	grid.RefreshGrid(RG_SAVEROW);        
         	break;
		case "RBAZNACH":
	         par = new Object();
	         showWindow("l_fndev.js", SW_NOMODAL, par);
         	break;
        /* 	
      	case "PRINT":
        	include("objects\\DpTVars.js");
      		var tv = new DpTVars(prnPatt);
      		tv.setRTbl(tbl);
      		tv.print();
        	break;    
      	*/
      	//default:
         	//stdMenuHandler(nID, tbl);
   	}
}

function gridEdit(modeID)
{
	if(modeID=="ADD" || modeID=="COPY")
		return false;
	return true;
}

function saveRecord()
{
	var m = new Object();
	m.Fsum = list.tbl.getValue("Fsum");
	UpdateTable(tblName, m, false, "Fwid="+sqlTo(list.tbl.getValue("Fwid")));
	return true;
}

function getTblH()
{
	var h = new Object();
	h.HFD1 = res_moni.getVarDate();
	h.HFD2 = lastDayMonth(res_moni);
	return h;
}
include("sys/DpList.js");