include("Objects\\DpEval.js");
include("Objects\\DpGetDat.js");

var sTblName = "tmp_rnnp";

function listTitle()
{
	return ru("Полученные налоговые накладные", "Отримані податкові накладні");
}

function listLoad()
{
	if(!IsTable("tune_rnnp"))
		CreateTable("tune_rnnp", "tune_bpn", "*");	
		
	var gd = new DpGetDat("dD");
	if(gd.escape)	
		return false;
		
	tblHnn = OpenTable("s", 
				"SELECT *"
			+ " FROM ^hnn h"	
			+ " WHERE h.fdoc_dat BETWEEN " + sqlTo(gd.dat1) + " AND " + sqlTo(gd.dat2)
				+ sqlw0And("h.fdoc=", extPar.fdoc)
				+ sqlw0And("h.fnop=", extPar.fnop)+" order by Fdoc_dat"
		);
	
	tblTune = OpenTable("s", "select * from tune_rnnp");
	//if (SQL)
	//	tblTune.index = "fdoc,fnop";
	
	CreateTable("tmp_rnnp", "bpn", "*");	
	var tblBpn = OpenTable("s", "tmp_rnnp");
	var m = new Object;
	var nn = 0;
	var oEval = new DpEval();
	//oEval.setTable(tblHnn);

	//setProgressRange(0, tblHnn.RecordCount());
	var hDoc, hNop;
	var findDoc, findNop;
	
	for(; !tblHnn.IsEOF(); tblHnn.MoveNext())
	{
		hDoc = toScrObj(tblHnn.getValue("fdoc"));
		hNop = toScrObj(tblHnn.getValue("fnop"));
		findDoc = tblTune.FindFirst("Fdoc="+ sqlTo(hDoc));
		findNop = tblTune.FindFirst("Fnop="+ sqlTo(hNop));
		//if(tblTune.Seek("=", tblHnn("fdoc"), tblHnn("fnop")))
		if(findDoc && findNop)
		{
			var tHnn1 = OpenTable("m",
				"SELECT *"
				+ " FROM ^hnn"
				+ " WHERE fwid=" + sqlTo(tblHnn.getValue("Fwid"))
				+ " ORDER BY fdoc_dat, fwid"
				);
		
			m.FDOC = toScrObj(tblHnn.getValue("fdoc"));
			m.FNOP = toScrObj(tblHnn.getValue("fnop"));
			
			tHnn1.ExtTie("H", "NN", tblHnn.getValue("fnop"));
			oEval.setTable(tHnn1);			
			oEval.setDoc(m.FDOC, m.FNOP);
			
			m.FDOC_DAT = tblHnn.getValue("fdoc_dat");
			m.FID_DOC = tblHnn.getValue("fwid");
			m.FORG = tblHnn.getValue("forg");
			m.F_01 = ++nn;
			m.F_02 = oEval.tEval("date", tblTune.getValue("F_02"));
			m.F_03 = oEval.tEval("str", tblTune.getValue("F_03"));
			m.F_04 = oEval.tEval("str", tblTune.getValue("F_04"));
			m.F_05 = oEval.tEval("str", tblTune.getValue("F_05"));
			m.F_06 = oEval.tEval("num", tblTune.getValue("F_06"));
			m.F_07 = oEval.tEval("num", tblTune.getValue("F_07"));
			m.F_08 = oEval.tEval("num", tblTune.getValue("F_08"));
			m.F_09 = oEval.tEval("num", tblTune.getValue("F_09"));
			m.F_10 = oEval.tEval("num", tblTune.getValue("F_10"));
			m.F_11 = oEval.tEval("num", tblTune.getValue("F_11"));
			m.F_12 = oEval.tEval("num", tblTune.getValue("F_12"));
			m.F_13 = oEval.tEval("num", tblTune.getValue("F_13"));
			m.F_14 = oEval.tEval("num", tblTune.getValue("F_14"));
			append("N", tblBpn, m);	
		}
		else
		{
			alert(ru("Не настроена книга покупок для полученных налоговых накладных",
					 "Не налагоджена книга придбання для отриманих податкових накладних")
					+ "\n Папка " + tblHnn.getValue("fdoc") + " " + tblHnn.getValue("fnop")
					);
			break;
		}
		//setProgressPos(nn);
	}
	
	ExecuteSQL(
		"INSERT INTO tmp_rnnp("
			+ "f_04,f_06,f_07,f_08,f_09,f_10,"
			+ "f_11,f_12,f_13,f_14,f_15,f_16,"
			+ "f_17,f_18,f_19,f_20,f_21,f_22,f_23,f_24,f_25)"
		+ " SELECT 'ВСЬОГО' AS f_04"
			+ ", SUM(a.f_06) AS f_06"
			+ ", SUM(a.f_07) AS f_07"
			+ ", SUM(a.f_08) AS f_08"
			+ ", SUM(a.f_09) AS f_09"
			+ ", SUM(a.f_10) AS f_10"
			+ ", SUM(a.f_11) AS f_11"
			+ ", SUM(a.f_12) AS f_12"
			+ ", SUM(a.f_13) AS f_13"
			+ ", SUM(a.f_14) AS f_14"
			+ ", SUM(a.f_15) AS f_15"
			+ ", SUM(a.f_16) AS f_16"
			+ ", SUM(a.f_17) AS f_17"
			+ ", SUM(a.f_18) AS f_18"
			+ ", SUM(a.f_19) AS f_19"
			+ ", SUM(a.f_20) AS f_20"
			+ ", SUM(a.f_21) AS f_21"
			+ ", SUM(a.f_22) AS f_22"
			+ ", SUM(a.f_23) AS f_23"
			+ ", SUM(a.f_24) AS f_24"
			+ ", SUM(a.f_25) AS f_25"
		+ " FROM tmp_rnnp a"
		);	
	
//	setProgressPos(0);	
}

function listSrc()
{			
	this.qrySet("From", sTblName/*, "Order", IIF("f_01=0", "99999", "f_01")*/);		
}

function listDpGrid()
{
	include("Objects\\DpGrid.js");	
	var oGrid = new DpGrid("NOCREATE");
	with(oGrid)
	{
//		defCond("=^F_01=0", "TOT");
//		color(1, "TOT");
		with(page())
		{
			cell("F_01", "№\nп/п", 3)//.subCaption("1");
			with(group("Податкова накладна (вантажна митна декларація, чек, тощо)|"
					  +"Налоговая накладная (грузовая таможенная декларация, чек и т.п.)"))
			{
				cell("F_02", "\n\n\nДата\nотримання\n\n\n|\n\nДата получения", 12)//.subCaption("2");
				cell("F_03", "\n\n\n\nНомер\n\n\n\n", 10)//.subCaption("3");
				with(group("Постачальник|Поставщик"))
				{
					cell("FORG", "\n\n\nКод\n\n\n", 5);
					cell("F_04", "\n\n\nНазва\n\n\n|Название", 20)//.subCaption("4");
					cell("F_05", "Індивідуальний!подат.номер|Индивидуальный!налог.номер"
						, 10)//.subCaption("5");
				}
			}
			cell("F_06", "Загальна сума,!включаючи!ПДВ|Общая сумма,!включая!НДС", 8, "", DP_FORMAT_SUM)//.subCaption("6");
			with(group("Придбання, імпорт товарів (послуг, включаючи одержання від нерезидента)|"
					  +"Приобретение, импорт товаров (услуг, включая получение от нерезидента)"))
			{
				with(group("з метою їх використання у межах господарської діяльності|"
						  +"с цельлю их использования в пределах хозяйственной деятельности"))
				{
					with(group("підляг.оподат.за ставкою 20%,0%|подлежат налогообл.по ставке 20%,0%"))
					{
						fieldEx("F_07", "вартість без ПДВ|стоимость (без НДС)", 12,"we",DP_FORMAT_SUM)//.subCaption("7");
						fieldEx("F_08", "сума ПДВ|сумма НДС", 12,"we",DP_FORMAT_SUM)//.subCaption("8");
					}
					with(group("звільнені від оподаткування|освобождены от налогообложения"))
					{
						fieldEx("F_09","вартість без ПДВ|стоимость (без НДС)",12,"we",DP_FORMAT_SUM)//.subCaption("9");
						fieldEx("F_10","сума ПДВ|сумма НДС",12,"we",DP_FORMAT_SUM)//.subCaption("10");
					}					
				}
				with(group("не призначаються для їх використ.!у господарській діяльності|"
						  +"не предназначены для их использ.!в хозяйственной деятельности"))
				{
					fieldEx("F_11","вартість без ПДВ|стоимость (без НДС)",12,"we",DP_FORMAT_SUM)//.subCaption("11");
					fieldEx("F_12","сума ПДВ|сумма НДС",12,"we",DP_FORMAT_SUM)//.subCaption("12");
				}
				
				with(group("для поставки послуг,місце поставки!визнач. відпов.до п.6.5 ст.6 Закону|"
						  +"для поставки услуг,место поставки!опред. в соотв.с п.6.5 ст.6 Закона"))
				{
					fieldEx("F_13","вартість без ПДВ|стоимость (без НДС)",12,"we",DP_FORMAT_SUM)//.subCaption("13");
					fieldEx("F_14","сума ПДВ|сумма НДС",12,"we",DP_FORMAT_SUM)//.subCaption("14");
				}								
			}	
		}			
		build();
	}
}

function listMenuInit()
{
	list.dataSrc.AddMenuItem("DEBET2XSD",
			"Подготовить к выгрузке в xml формат для налоговой|"+
			"Подготовить к выгрузке в xml формат для налоговой");
	list.dataSrc.AddMenuItem("PRINT_DODATOK5_1", "Друк Додатку № 5 (II - 1)")
	list.dataSrc.AddMenuItem("PRINT_DODATOK5_2", "Друк Додатку № 5 (II - 2)")
			
}

function listMenuRun(ID)
{
	if (nID == "DEBET2XSD")
	{
			strName = "DODATOK5_CR";
			DropTable(strName);
			strSQL = "CREATE TABLE " + strName
					+ " ( FSUM "+SqlType("CURRENCY")
					+ " , FNDS "+SqlType("CURRENCY")
					+ " , FDATE "+SqlType("DATE")
					+ " , FINDNUM "+SqlType("TEXT", 20)
					+ " , FORG "+SqlType("LONG")
					+ " , FWID " + SqlType("COUNTER") + ")";
			ExecuteSQL(strSQL); 			

			// copy data to tmp table and set date			
			var tblName = getTmpTableName();
			ExecuteSQL("SELECT f_07, f_08, FORG, F_02 as FDATE, FWID, FID_DOC, FNOP INTO " + tblName
				+ " FROM tmp_rnnp WHERE F_01<>0 and " + DataSource().sqlSelected());
			var tbl = OpenTable("s", tblName);
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var dat = xh_("NALDAT", null, "NN", tbl.getValue("FNOP"), tbl.getValue("FID_DOC"));
				if (isEmpty(dat))
					dat = tbl.getValue("FDATE");
				dat = firstDay(dat);

				ExecuteSQL("UPDATE " + tblName 
					+ " SET FDATE = " + sqlTo(dat) 
					+ " WHERE fwid = " + sqlTo(tbl.getValue("FWID")));
			}
			
			// Сгруппируем суммы по организации и дате
			var tbl = OpenTable("s", "SELECT "
				+ "SUM(f_07) as FSUM, SUM(f_08) as FNDS, FORG, FDATE"
					+ " FROM " + tblName
					+ " GROUP BY FORG, FDATE"
					+ " ORDER BY FORG, FDATE")
			//----------------
			//кто хочет ехать в БОН-АПЕТИТ - может удалить!			
			//кто знает нафига здесь дата - пусть напишет нормальный запрос, работающий на всех СУБД.
			if(SUBD==MYSQL)
			{
				tbl = OpenTable("s", "SELECT "
					+ "SUM(f_07) as FSUM, SUM(f_08) as FNDS, FORG, FDATE"
					+ " FROM " + tblName
					+ " GROUP BY FORG "
					+ " ORDER BY FORG")
			}
			//кто хочет ехать в БОН-АПЕТИТ - может удалить!
			//---------------
			
			for(tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
			{
				var m = new Object()
				m.FNDS = round(tbl.getValue("FNDS"), 0);
				m.FSUM = round(tbl.getValue("FSUM"), 0);
				m.FORG = tbl.getValue("FORG");
				m.FDATE = tbl.getValue("FDATE");
				m.FINDNUM = tcl("ORG", "CODNDS", m.FORG);
				if (Number(m.FINDNUM) == 0)
					m.FINDNUM = "X";
				
				updateTable(strName, m, true);
			}
			
			alert(ru("Расчет окончен.", "Розрахунок завершено."))
	}
	else if(nID=="PRINT_DODATOK5_1")
	{
		createD5();

		var tDodatok5 = OpenTable("s",
			"SELECT F_04, F_05"
				+ ", SUM(t.F_07) AS F_07"
				+ ", SUM(t.F_08) AS F_08"
				+ ", MAX(t.FWID) AS FWID"
				+ ", fdatnal"
			+ " FROM tmp_d5 t"
			+ " WHERE F_01<>0"
				//+ " AND F_05<>''"
				+ " AND F_07>0"
				+ " AND F_08>0"
			+ " GROUP BY F_04, F_05, fDatNal"
			);

		stdMenuHandler("PRINT", tDodatok5);
	}
	else if(nID=="PRINT_DODATOK5_2")
	{
		createD5();

		var tDodatok5 = OpenTable("s",
			"SELECT F_04, F_05"
				+ ", SUM(t.F_09) AS F_09"
				+ ", SUM(t.F_10) AS F_10"
				+ ", SUM(t.F_11) AS F_11"
				+ ", SUM(t.F_12) AS F_12"
				+ ", SUM(t.F_13) AS F_13"
				+ ", SUM(t.F_14) AS F_14"
				+ ", MAX(t.FWID) AS FWID"
				+ ", fdatnal"
			+ " FROM tmp_d5 t"
			+ " WHERE F_01<>0"
				+ " AND ( F_10>0"
					+ " OR F_12>0"
					+ " OR F_14>0"
					+ ")"
			+ " GROUP BY F_04, F_05, fdatnal"
			);

		stdMenuHandler("PRINT", tDodatok5);
	}
}


function createD5()
{
		DropTable("tmp_d5")
	
		ExecuteSQL(
			"SELECT f_01, f_02, f_04, f_05, f_07, f_08"
				+ ", f_09, f_10, f_11, f_12, f_13, f_14"
				+ ", Fwid,"
				+ fldDatNal + " as fdatnal"
			+ " INTO tmp_d5"
			+ " FROM tmp_rnnp t"
			+ " WHERE F_01<>0"
			)
		var t5 = OpenTable("s", "tmp_d5")
		for(; !t5.IsEOF(); t5.MoveNext())
		{
			t5.Edit();
			if (!isEmpty(t5("fdatnal")))
			{
				t5("fdatnal") = firstDay(t5("fdatnal"))
			}
			else
				t5("fdatnal") = firstDay(t5("f_02"));
			t5.Update();
		}

		t5.Close(5652);

}
include("sys\\DpList.js")	