include("Objects/DpXMLDOMDocument.js");

var tmpTblName = getTmpTableName();

var sTaskDir = getUserDirectory() +"tasks";
var sTaskFile = sTaskDir +"/scheduledTask.xml";
var xmlTasks = null
var xmlDom = null

function listLoad()
{
	FORM.setImage(rootDirectoryEx() +"/icons/taskmngr.gif");
	
	with (this)
	{
		title = UR("Перегляд задач |Просмотр задач");		
		editTask = "e_scheduledtask.xml";
		xmlGridFile = "l_scheduledtask.xml";	
		subUnLoad = listUnLoad;			
	}
	
	if(!DpFile(sTaskDir).isDirectory())
		createDirectory(sTaskDir);
	
	xmlDom = new DpXMLDOMDocument();
	if(!xmlDom.load(sTaskFile, false))
	{
		xmlDom.createChild("Tasks");
	}
		
	
	if (!createTmpTable())
		return false;
		
	
	fillTable();	
}

function listUnLoad()
{	
	try
	{
		list.tbl.close();
		DropTable(tmpTblName);
	}
	catch(x){}
}

function listSrc()
{
	this.qrySet(
			"From", tmpTblName,			
			"Order", "fwid"
			);
}

function listInitEditParam(par)
{
	par.tableName = tmpTblName;
	par.xmlDom = xmlDom;
	par.taskFileName = sTaskFile;
}


function fillTable()
{
	var nodes = xmlDom.getDocumentElement().getElementsByTagName("task");
	for (var i in nodes)
	{
		insertRecord(nodes[i]);
	}
}


function insertRecord(task)
{	
	var m = new Object();
	m.FWID = task.getAttribute("ID");
	m.FCOMMAND = task.getAttribute("command");
	m.FTYPE = task.getAttribute("type");
	m.FPARAM = task.getAttribute("param");
	m.FCRONPATTERN = task.getAttribute("cronPattern");
	m.FNAME = UR(task.getText());
	
	updateTable(tmpTblName, m, true);	
}


function createTmpTable()
{
	if (IsTable(tmpTblName))
	{
		if (!ExecuteSQL("DROP TABLE " + tmpTblName, false))
		{
			alert(UR("Перегляд задач вже відкритий!|Просмотр задач уже открыт!"), ICON_WARNING);
			return false;
		}
	}
	return ExecuteSQL("CREATE TABLE " + tmpTblName + "("
		+ "fwid " + SqlType("text", 100) + ","
		+ "fname " + SqlType("longtext") + ","
		+ "fcommand " + SqlType("text", 50) + ","		
		+ "ftype " + SqlType("text", 1) + ","
		+ "fparam " + SqlType("text", 50) + ","
		+ "fcronpattern " + SqlType("text", 50) + ")"	
		);
}

function getScheduledTaskElement(ID)
{
	var arr = xmlDom.getDocumentElement().getElementsByTagName("task");
	for (var i = 0; i < arr.length; i++ )
	{
		if (String(arr[i].getAttribute("ID")) == ID)
		{
			return arr[i];			
		}
				
	}
	return null;
}

function listDel()
{
	var ID = list.tbl.getValue("FWID");
	if (ID != null)
	{
		var el = getScheduledTaskElement(ID);
		if (el != null)
		{
			xmlDom.getDocumentElement().removeChild(el);
			xmlDom.save(sTaskFile);
			lpProxy.getTaskScheduler().deleteTask(ID);
		}
	}
	
	return true;
}





include("sys/DpList.js");