﻿include("objects\\DpGetDat.js");

var prnPatt="sczak";

var ds,t;
var dat1, dat2;

function listLoad()
{
	this.xmlGridFile = "l_sczakr.xml";
	this.editTask = "e_zak";
	var gd = new DpGetDat("dD");
	if (gd.escape){
		CloseWindow();
		return false;
	}
	dat1 = gd.dat1;
	dat2 = gd.dat2;
}

function listTitle()
{
	return "Порядок закриття рахунків|Порядок закрытия счетов";
}

function listSrc()
{
	list.qrySet("From","^ZAKRSC"
				,"Where","((Fbdat<="+sqlTo(dat1)+" and Fedat>="+sqlTo(dat1) + ")"
						  + " OR (Fbdat>="+sqlTo(dat1)+" and Fbdat<="+sqlTo(dat2) +")"
						  + " OR (Fedat>="+sqlTo(dat1)+" and Fedat<="+sqlTo(dat2)+"))"
				,"Order",new Array("FNOM")
				);
}

function listUnLoad()
{
	//t.Close();
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^ZAKRSC_R_DISTR WHERE FID_DOC = " + sqlTo(this.tbl.getValue("fwid")));
	ExecuteSQL("DELETE FROM ^ZAKRSC WHERE Fwid=" + sqlTo(this.tbl.getValue("fwid")));
	
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem ("MKZAKR","Виконати закриття|Произвести закрытие");
	this.dataSrc.AddMenuItem ("VIEWSC","Поточні закриваючі проведення|Текущие закрывающие проводки");
	this.dataSrc.AddMenuItem ("+++","Сервіс|Сервис");
	this.dataSrc.AddMenuItem ("CONVERTDISTR","Конвертація рядків за способом DISTR, TRANSF з формату 2000|Конвертация строк по способу DISTR, TRANSF из формата 2000");
	this.dataSrc.AddMenuItem ("---","");
	
 // 	this.dataSrc.AddMenuItem ("1","Включить строку в расчет");
 // 	this.dataSrc.AddMenuItem ("2","Исключить строку из расчета");
}

		
function listMenuRun(ID)
{
	var ds = DataSource();
	if(ID=="1")
	{
		var m = new Object();
		m.Fis_slct = true;
		m.FWID = this.tbl.getValue("Fwid");
		UpdateTable("^ZAKRSC",m,false);
		bm = list.tbl.bookmark;
		list.tbl.Requery();
		list.tbl.bookmark = bm;
		grid.RefreshGrid(RG_SAVEROW);
	}
	else if(ID=="2")
	{
		var m = new Object();
		m.FWID = this.tbl.getValue("FWID");
		m.Fis_slct = false;
		UpdateTable("^ZAKRSC",m,false);
		bm = list.tbl.bookmark;
		list.tbl.Requery();
		list.tbl.bookmark = bm;
		grid.RefreshGrid(RG_SAVEROW);
	}
	else if(ID=="MKZAKR")
	{
		
		// Произвести закрытие
		// Закрывать будем то что отмечено "галочками"
		// или текущую запись в случае их отсутствия
		
		// Для начала снимем крыжи от предыдущего раза
		strSQL = "UPDATE ^ZAKRSC SET Fis_slct=" + SqlFalse
		ExecuteSQL(strSQL);
		
		// Проставим крыжи в отмеченных записях
		strSQL = "UPDATE ^ZAKRSC SET "
		+" Fis_slct="+SqlTrue
		+" WHERE "+ds.sqlSelected();
		ExecuteSQL(strSQL);
		
		// Для красоты покажем, что получилось...
		grid.RefreshGrid(RG_SAVEROW);
		// ...и произведем закрытие
		var par = new Object();
		par.menuMode = "R"
		showWindow("r_zakrsc.js", SW_NOMODAL, par);

	}
	else if(ID=="SELZAKR")
	{
		var par = new Object();
		par.menuMode = "R"
		par.selected = grid.sqlSelected();
		showWindow("r_zakrsc.js", SW_NOMODAL, par);
		
	}
	else if(ID=="VIEWSC")
	{
		var par = new Object();
		par.menuMode = "V"
		showWindow("r_zakrsc.js", SW_NOMODAL, par);
	}
	else if(ID=="CONVERTDISTR")
	{
		//Конвертация строк по способу DISTR или TRANSF из формата 2000
		//Суть проблемы: в 2000-й версии каждая корреспонденция счетов по способу DISTR или TRANSF
		//заводилась в настройке закрытия отдельной строкой. Логически эти строки связывались по полю "Группа"
		//т.е. строки, у которых номер группы совпадал, обрабатывались вместе.
		//Теперь в настройке закрытия заводится одна строка, но у нее есть грид, в котором 
		//перечисляются корреспондирующие счета.
		//Наша задача:
		//Среди отмеченных строк оставляем по одной с уникальным НЕНУЛЕВЫМ кодом группы, а в табличную часть к ней
		//вписываем все найденные среди отмеченных строк корреспондирующие счета с процентами, выражениями и т.п.
		//Лишние строки из настройки удаляем.
		//В оставшихся строках (тех, к которым вписали таблицу) обнуляем номер группы.
		
		//Список групп, которые у нас имеются
		strSQL = " SELECT"
					+" MIN(Z.FWID) AS FWID"
					+", Z.FGROUP"
				+" FROM "
					+" ^ZAKRSC Z"
				+" WHERE "
					+ds.sqlSelected()
					+" AND Z.FSPOSOB IN ('DISTR', 'TRANSF')"
					+" AND Z.FGROUP<>0"
				+" GROUP BY "
					+" Z.FGROUP"
		var tGroups = OpenTable("s", strSQL);

		if(tGroups.IsEmpty())
		{
			var strMsg = UR("Рядки для конвертації серед відмічених відсутні|Строки для конвертации среди отмеченных отутствуют");
			alert(strMsg);
		}
		else
		{
			for(tGroups.MoveFirst(); !tGroups.IsEOF(); tGroups.MoveNext())
			{
				var m = new Object();
				m.FWID = toScrObj(tGroups.getValue("FWID"));
				mFGROUP = toScrObj(tGroups.getValue("FGROUP"));
				//Отберем строки, входящие в нашу группу
				strSQL = " SELECT"
							+" *"
						+" FROM "
							+" ^ZAKRSC "
						+" WHERE "+SqlCmpTrue
							+" AND "+ds.sqlSelected()
							+" AND FSPOSOB IN ('DISTR', 'TRANSF')"
							+" AND FGROUP = "+sqlTo(mFGROUP)
				var tRows = OpenTable("s", strSQL);
				
				//хотя бы одна строка у нас есть по любому, поэтому цикл без проверок
				for(tRows.MoveFirst(); !tRows.IsEOF(); tRows.MoveNext())
				{
					var mr = new Object();
					mr.FWID = GetUID();
					mr.FID_DOC = m.FWID;
					
					switch (toScrObj(tRows.getValue("FSPOSOB")))
					{
						case "TRANSF":
							mr.FSC_TO = toScrObj(tRows.getValue("FSC"));
							mr.FSU_TO = toScrObj(tRows.getValue("FSU"));
							mr.FST_TO = toScrObj(tRows.getValue("FST"));
							mr.FCOD1_TO = toScrObj(tRows.getValue("FCOD1"));
							mr.FCOD2_TO = toScrObj(tRows.getValue("FCOD2"));
							mr.FCOD3_TO = toScrObj(tRows.getValue("FCOD3"));
							mr.FBDAT = d00;
							mr.FEDAT = d00;
						break;
						default:
							mr.FSC_TO = toScrObj(tRows.getValue("FSC_TO"));
							mr.FSU_TO = toScrObj(tRows.getValue("FSU_TO"));
							mr.FST_TO = toScrObj(tRows.getValue("FST_TO"));
							mr.FCOD1_TO = toScrObj(tRows.getValue("FCOD1_TO"));
							mr.FCOD2_TO = toScrObj(tRows.getValue("FCOD2_TO"));
							mr.FCOD3_TO = toScrObj(tRows.getValue("FCOD3_TO"));
							mr.FBDAT = toScrObj(tRows.getValue("FBDAT"));
							mr.FEDAT = toScrObj(tRows.getValue("FEDAT"));
						break;
					}
				
					mr.FEXPR = toScrObj(tRows.getValue("FEXPR"));
					UpdateTable("^ZAKRSC_R_DISTR", mr, true);
				}
				tRows.Close();
				tRows = null;

				//Теперь в основной строке обнулим группу, выражение и счет "куда"
				m.FGROUP = 0;
				m.FEXPR = "";
				m.FSC_TO = 0;
				m.FSU_TO = 0;
				m.FST_TO = 0;
				m.FCOD1_TO = 0;
				m.FCOD2_TO = 0;
				m.FCOD3_TO = 0;
				UpdateTable("^ZAKRSC", m, false);
				
				//И под конец удалим "лишние" строки в порядке закрытия
				strSQL = "DELETE"
				+" FROM "
					+" ^ZAKRSC"
				+" WHERE "
					+ds.sqlSelected()
					+" AND FSPOSOB IN ('DISTR', 'TRANSF')"
					+" AND FGROUP="+sqlTo(mFGROUP)
				ExecuteSQL(strSQL)
			}
		}
		tGroups.Close();
		tGroups = null;
	}
}

include("sys\\DpList.js");