include("Objects/DpGetDat.js");
var bdat;
var edat;
var mass = false;
var podrValue = 0;
var selectID = 0;
var tblWorks = null;
var arrResult = new Array();

function Load()
{
	btnOK.setText("      OK      ");
	if (extPar == null || extPar.dat1 == null || extPar.dat2 == null)
	{
		gd = new DpGetDat("dD");
		if (gd.escape == true)
			return false;
		bdat = gd.dat1;
		edat = gd.dat2;
	}
	else
	{
		bdat = extPar.dat1;
		edat = extPar.dat2;
		if (extPar.bMass != null)
			mass = extPar.bMass;	
	}			
	
	Caption(UR("Штатний розклад з |Штатное расписание с ")
	 + StrDat(bdat, "DMY") + UR(" до | по ") + StrDat(edat, "DMY"));
	
	fillPodr();
	fillGrid();
	grWorks.setXMLDir(rootDirectory());
	grWorks.setXMLFile("grWorks.xml");
	grWorks.setTable(tblWorks);
	grWorks.build();
	this.grid_MenuInit = grid_MenuInit;
	grWorks.loadMenuHandler(this, "grid_MenuInit");
	
	this.onSelTreeItem = onSelTreeItem;
	tree.setTreeSelHandler(this, "onSelTreeItem");
	
	tree.setSelected(selectID);
	podr_valid();
	
	//setValid(PODR, podr_valid);
}

function onSave()
{
	if (0 != podrValue)
		arrResult[podrValue] = grWorks.getSelectedIDs();
	
	var ret = new Array();
	for(var podr in arrResult)
		ret = concatArray(ret, arrResult[podr]);
		
	if (mass && ret.length == 0)
	{
		alert(UR("Нема вибраних записів!|Нет выбраных записей!"));
		return false;
	}
		
	if (extPar != null)
	{
		extPar.escape = false;
		if (mass)
			extPar.ret = ret;
		else 
		{
			if (ret.length == 0)
				extPar.ret = grWorks.getTable().getRowID();
			else
				extPar.ret = ret[0];
		}
	}
	if(extPar.Zavalmode == "VIBMAS")
	{
		extPar.pFwid_org = podrValue;
	}
	exit();
}

function onEscape()
{
	exit();
	if(null!=extPar)
		extPar.escape = true;
}

function exit()
{
	if(null!=tblWorks)
	{
		tblWorks.Close();
		tblWorks = null;
	}
}

function podr_valid()
{
	if(podrValue != 0)
		arrResult[podrValue] = grWorks.getSelectedIDs();
	
	if (selectID != podrValue)
	{
		podrValue = selectID;
		fillGrid();
		grWorks.setTable(tblWorks);
		grWorks.build();	
		if (arrResult[podrValue] != null && arrResult[podrValue].length != 0)
			grWorks.setSelectedIDs(arrResult[podrValue], podrValue);		
		grWorks.refresh();
	}
}

function fillExtParObj()
{
	if (extPar.shtat == null || !extPar.shtat || (typeof extPar.shtat != "object"))
		return;
	var strSQL = getFillGridSQL();
	var tmpTbl = OpenTable("s", strSQL);
	if (!tmpTbl.IsEmpty())
	{
		for(tblPodr.MoveFirst(); !tblPodr.isEOF(); tblPodr.MoveNext())
		{
		
		}
	}
	tmpTbl.close();
}

function fillPodr()
{
	var result = false;
	var tbdat = sqlTo(bdat);
	var tedat = sqlTo(edat);
	
	var strSQL = "SELECT o.fwid, o.ftxt FROM ^stru_org AS o"
				+ " WHERE o.fwid IN (SELECT DISTINCT d.fwid_org"
									+ " FROM ^work_pers AS w LEFT JOIN ^stru_dol AS d"
										+ " ON (w.FWID_DOL=d.FWID)"
									+ " WHERE (w.Fbdat<=" + tbdat + " AND w.Fedat>=" + tedat + ")"
										+ " OR (w.Fbdat>=" + tbdat + " AND w.Fbdat<=" + tedat + ")"
										+ " OR (w.Fedat>=" + tbdat + " AND w.Fedat<=" + tedat + "))"
	var tblPodr = OpenTable("s", strSQL);
	if(!tblPodr.isEmpty())
	{
		//PODR.clear();
		tree.removeAll();
		//tree.addItem("", "0", UR("Штат|Штат"));
		for(tblPodr.MoveFirst(); !tblPodr.isEOF(); tblPodr.MoveNext())
		{
			if (selectID == 0)
				selectID = String(tblPodr.getValue("fwid"));
			tree.addItem("", String(tblPodr.getValue("fwid")), tblPodr.getValue("ftxt"));
			//PODR.addItem(Number(tblPodr.getValue("fwid")), tblPodr.getValue("ftxt"));
		}
		
		result = true;
	}
	tblPodr.Close();
	return result;
}

function getFillGridSQL()
{
	var cldol = getPar("CODDOL");
	return "SELECT w.fwid, cl_dol.ftxt, rel.fcod, cl.ftxt as ftxts, w.fbdat, w.fedat"
				+ " FROM (((((^work_pers AS w LEFT JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid)"
					+ " INNER JOIN ^cl AS cl ON w.fwid_cl=cl.fwid)"
					+ " INNER JOIN ^clrelclcl AS rel ON w.fwid_cl=rel.fwid_cl)"
					+ " INNER JOIN ^clrelclcl AS rel_dol ON d.fcod=rel_dol.fcod)"
					+ " INNER JOIN ^cl AS cl_dol ON cl_dol.fwid=rel_dol.fwid_cl)"
				+ " WHERE ((w.fbdat<=" + sqlTo(bdat) + " AND w.fedat>=" + sqlTo(edat) + ")"
					+ " OR (w.fbdat>=" + sqlTo(bdat) + " AND w.fbdat<=" + sqlTo(edat) + ")"
					+ " OR (w.fedat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + "))"
					+ " AND d.fwid_org = " + sqlTo(podrValue)
					+ " AND rel_dol.fcl=" + sqlTo(cldol)
				+ " ORDER BY rel_dol.fcod, rel.fcod";
}

function fillGrid()
{
	if(null!=tblWorks)
	{
		tblWorks.Close();
	}
	
	var strSQL = getFillGridSQL();
	tblWorks = OpenTable("s", strSQL);
}

function grid_MenuInit()
{
	if(false == mass 
	&& grWorks.getMouseAction() != mRBtnClk
	&& null != grWorks.getTable().getRowID())
	{
		if(null!=extPar)
		{
			extPar.escape = false;
			extPar.ret = grWorks.getTable().getRowID();
		}
		
//		CloseWindow();
		return false;
	}
}

function onSelTreeItem(sID)
{
	selectID = parseInt(sID);
	podr_valid();		
}

include("sys/DpBaseDlg.js");