include ("sys/DpList.js");
include ("Objects/DpGetDat.js");

var dat1 = dat2 = null;

function listLoad()
{
	dat1 = (typeof extPar.dat1 == "undefined" ? null : extPar.dat1);
	dat2 = (typeof extPar.dat2 == "undefined" ? null : extPar.dat2);
	if (dat1 == null || dat2 == null)
	{
		var gd = new DpGetDat("dD");
		if (!gd.dat1 || !gd.dat2)
			return false;
		dat1 = gd.dat1;
		dat2 = gd.dat2;
	}
	extPar.fwidOrg = (extPar.fwidOrg ? extPar.fwidOrg : 0);
	
	with(this)
	{
		title = UR("Список вільных посад на період з |Список свободных должностей на период с ")
			 + StrDat(dat1, "DMY") + " по " + StrDat(dat2, "DMY")
			 + (extPar.fwidOrg > 0 ? (UR(" по підрозділу | по подразделению ")
			 + getSnap("SELECT ftxt FROM ^stru_org WHERE fwid=" + sqlTo(Number(extPar.fwidOrg)))[0]) : "");
		xmlGridFile = "l_stru_dol.xml";
		//printLabel = "XXXXXX";
	}
}

function listSrc()
{	
	this.qrySet("Fields", "cl.ftxt AS ftxt, cl.ftxts AS ftxts, dol.fwid AS fwid",
				"From", "^stru_dol AS dol, ^cl AS cl ",
				"Where", "dol.fedat=" + SqlMaxDate + (extPar.fwidOrg > 0 ? " AND dol.fwid_org=" + sqlTo(Number(extPar.fwidOrg)) + " AND " : " AND ")	
				+ " (((SELECT MAX(wp.fedat) FROM ^work_pers AS wp WHERE wp.fwid_dol=dol.fwid)<>" + SqlMaxDate + ") "
				+ " OR ((SELECT MAX(wp.fedat) FROM ^work_pers AS wp WHERE wp.fwid_dol=dol.fwid) IS NULL)) "		
				+ " AND ((dol.fbdat<=" + sqlTo(dat1) + " AND dol.fedat>=" + sqlTo(dat2) + ")"
				+ " OR (dol.fbdat>=" + sqlTo(dat1) + " AND dol.fbdat<=" + sqlTo(dat2) + ")"
				+ " OR (dol.fedat>=" + sqlTo(dat1) + " AND dol.fedat<=" + sqlTo(dat2) + "))"
				+ " AND dol.fwid_cl=cl.fwid");
}