include("sys//main.js");
include("servis//date.js");
include("objects\\DpCl.js");

var ID = 0;
var bookmark,GLOBAL_DATE;

function listLoad()
{
	dat1.value = new Date().getVarDate();
	GLOBAL_DATE = dat1.getValue();
	with(this)
	{
		title = "Реєстрація робочого часу|Регистрация рабочего времени";
		subMenuInit = menuInit;
		subMenuRun = menuRun;
		accDel = new Function("return false");	
		xmlGridFile = "l_stuff_rreg.xml";
	}
	setButton(butt,BUTT_VALID);
	var spers = new DpCl("0", getPar("CODPERS"), 0);
	spers.linkCtrl(user,fuser);
	var currUser = Number(ReadParEx("CURUSER"));
	this.editTask = "e_stuff_ereg";
	if (!isNaN(currUser))
	{
		spers.setCod(currUser);
		ID = currUser;
	}
	else
	{
		spers.setCod(0);	
	}
	setValid(user,EDIT_VALID);
}

function listSrc()
{
	this.qrySet("From", "^STUFF_REG",
		"Where", "fdate BETWEEN " + sqlTo(setTime(dat1.getValue(),0,0,0),null,true)
		+ " AND " + sqlTo(setTime(dat1.getValue(),23,59,59),null,true)
		+ " AND femployee = " + sqlTo(ID),  
		"Order", new Array("fbegtime,fendtime")
	 );
	 
}

function listAfterLoad()
{
	setFocus(user);
}

function menuInit()
{	
	with (this.dataSrc)
	{	
		if (ID != 0)
		{
			AddMenuItem("REGISTER", "Реєстрація робочого часу|Регистрация рабочего времени");
			AddMenuItem("","");
		}
		AddMenuItem("CHUSER", "Зміна користвуча|Смена пользователя");
		AddMenuItem("","");		
		if (ID != 0 && isAdministrator())
		{
			var par = getParamSave(false)[0];
			if (par == "+" || par == "-")
			{
				list.tbl.FindFirst("FWID = " + sqlToFind(bookmark));
				if (par == "+")
				{
					this.editTask = "e_stuff_ereg";
					this.accEdit = new Function ("return 'E'");
					this.accDel = new Function("return true");	
				}
				else
				{
					this.accEdit = new Function ("return ''");
					this.accDel = new Function("return false");					
				}					
			}
			else
			{
				list.tbl.FindFirst("FWID = " + sqlToFind(bookmark));
				this.editTask = "e_stuff_ereg";
				this.accEdit = new Function ("return 'AE'");
				this.accDel = new Function("return true");	
			}
		}
	}
}

function menuRun(nID)
{
	switch(nID)
	{
		case "REGISTER":
			dat1.value = new Date().getVarDate();
			onRefreshDate();			
			oPar = new Object();
			oPar.date = dat1.getValue();
			oPar.user = ID;
			oPar.tblName = "^STUFF_REG";
			oPar.param = getParamSave(true)[0];
			if (oPar.param == "2")
			{
				this.tbl.MoveLast();
				oPar.isFwid = this.tbl.getValue("FWID");
				oPar.frem = this.tbl.getValue("FREM");
			}
			if (oPar.param != "+" && oPar.param != "-")
			{
				showWindow("e_stuff_reg.xml", SW_MODAL, oPar);
			}
			this.isRefresh = true;
			break;
		case "CHUSER":
			var ppar = new Object();
			ppar.id = ID;
			ppar.text = fuser.getValue();
			showWindow("e_stuff_chreg.xml", SW_MODAL, ppar);	
			ID = ppar.id;
			if (ID != 0)
			{
				this.editTask = "e_stuff_ereg";
				this.accEdit = new Function ("return 'AE'");
				this.accDel = new Function("return true");
			}
			else
			{
				this.editTask = null;
				ppar.text = null;
			}
			user.value = ID;
			fuser.value = ppar.text; 
			this.qryOrder = "";
			this.reLoad();
			break;		
		case "ADD":
			this.objParMenu.paramSave = getParamSave(false)[0];
			if (this.objParMenu.paramSave == "2")
			{
				this.tbl.MoveLast();
				this.objParMenu.frem = this.tbl.getValue("FREM");
			}			
		case "EDIT":
			this.objParMenu.timeSave = getParamSave(false)[1];
			this.tbl.FindFirst("FWID = " + sqlToFind(bookmark));
			this.objParMenu.userID = ID;
			this.objParMenu.tblName = "^STUFF_REG";	
		case "DEL":
			this.objParMenu.date = GLOBAL_DATE;			
			if (GLOBAL_DATE != dat1.getValue())
				dat1.value = GLOBAL_DATE;						
	}
}

function onRefreshDate()
{
	list.tbl.Requery("SELECT *"
		+ " FROM ^stuff_reg"
		+ " WHERE fdate BETWEEN " + sqlTo(setTime(dat1.getValue(),0,0,0),null,true)
		+ " AND " + sqlTo(setTime(dat1.getValue(),23,59,59),null,true)
		+ " AND femployee = " + sqlTo(ID)
		+ " ORDER BY fbegtime, fendtime");
	GLOBAL_DATE = dat1.getValue();
	grid.RefreshGrid();
}

function filterMode(ID)
{
	if(inList(ID, "ADD", "COPY", "EDIT", "DEL"))
		return isAdministrator();
	return true;
}

function getParamSave(isAlert)
{
	bookmark = list.tbl.getValue("FWID");
	var result = "";
	if (list.tbl.IsEmpty())
	{
		var resultAll = new Array("0", GLOBAL_DATE);		
	}
	else
	{
		var str = "";
		var time = new Array();	
		var i = 0;	
		list.tbl.MoveFirst();
		while (!list.tbl.isEOF())
		{
			str += list.tbl.getValue("FEVENT");
			time[i] = list.tbl.getValue("FENDTIME");
			list.tbl.MoveNext();
			i++;
		}
		if (str[str.length - 1] == "3" 
				|| str[str.length - 1] == "4"
					|| str[str.length - 1] == "5")
		{
			if (isAlert)
			alert(ru("Регистрация рабочего дня завершена!"
					,"Реєстрація робочого дня закінчена!"));
			if (str[str.length - 1] == "4")
				result = "-"
			else
				result = "+";
		}
		if (str[str.length - 1] == "2")
		{
			result = "13";
		}
		if (str[str.length - 1] == "1")
		{
			result = "2";
		}
		if (str[str.length - 1] == "0")
		{
			result = "13";
		}
		var resultAll = new Array(result,time[time.length -1]);			
	}
	return resultAll;
}

function BUTT_VALID()
{
	onRefreshDate();	
}

function EDIT_VALID()
{
	ID = parseInt(user.getValue());
	WriteParEx("CURUSER", ID);
	list.qryOrder = "";
	list.reLoad();
}

// только для таблицы l_stuff_rreg.xml : получение полного комментария
function getFullComment(event,reason)
{
	result = "";
	switch (event) 
	{
		case 0: result += ru("[Начало работы]","[Початок роботи]");
				break;
		case 1: result += ru("[Отсутствует]","[Відсутній]");
				break;
		case 2: result += ru("[Отсутствовал]","[Відсутній]");
				break;
		case 3: result += ru("[Окончание работы]","[Закінчення роботи]");
				break;
		case 4: result += ru("[Отпуск]","[Відпустка]");
				break;
		case 5: result += ru("[Болезнь]","[Хвороба]");
				break;
	}
	if (event == 1 || event == 2)
		switch(reason)
		{
			case 0: result += ru("[Обед]","[Обід]");
				break;
			case 1: result += ru("[По делам фирмы]","[По справам фірми]");
					break;
			case 2: result += ru("[Личные дела]","[Особисті справи]");
					break;
			case 3: result += ru("[Болезнь]","[Хвороба]");
		}
	return result;
}

include("sys\\DpList.js");