include("objects\\DpDefVed.js");

var mdt1, mdt2;
var fwid;
var szTag;
var tbl_svzp, tbl_svsv;

function listLoad()
{
	if(extPar!=null)
	{
		date1 = extPar.dat1;
		date2 = extPar.dat2;
		fwid = extPar.fwid;
	}
	else
   		return false;
	with(this)
	{
		title = ru("Категории работ за ","Категорії робіт за ")+format("Mmm yyyy", date1).toLowerCase()+" по '"+getTxtOrgByID(fwid)+"'";
		printLabel = "3SVOD";	
		xmlGridFile = "l_svod3.xml";		
	}
   
    szTag = (date1.getYear()+1900) + ((date1.getMonth()<9)?"0":"") + (date1.getMonth()+1);
	tbl_svzp = "SVZP" + szTag;
    tbl_svsv = "SVOD" + szTag;
    
    mdt1 = sqlTo(date1);
	mdt2 = sqlTo(date2);
}

function listSrc()
{	
//	this.qrySet("From", tbl_svsv, "Order", "FTT, FFZP, FTF, FKOD_KAT, FTK, FLSFID, FTL ");
	this.qrySet("From", tbl_svsv, "Order", "FKOD_KAT, FSEX, FTT, " + IIF("FTK=2", "1", "0") + " , FFZP, FTK, FTF, FT1, FT2, FT3, FLSFID, FTL");
	this.subTie("LIC_FLD", "lic", "Fid", "Flsfid");
	//this.subTie("CLRELCLCL","clrel","Fcod, Fcl","Fkod_kat, "+getPar("CODKAT"));
	this.subTie("CLRELCLCL","clrel","CLCOD","="+getPar("CODKAT")+", Fkod_kat");
	this.subTie("CL","cl","Fwid","clrel.Fwid_cl");
}

function listMake()
{
	var DefVed = new DpDefVed();
	
	if (!IsTableEx("ZRP_RES", "ZRP_"+tbl_svzp))
    {
    	alert(ru("Внимание!/nПеред началом данного расчета проведите расчет начислений за выбранный вами месяц",
    		"Увага!/nПеред початком данного розрахунка проведить розрахунок нарахувань за вибраний вами місяць"));
    	return false;
    }
    
	//делаем проверку на коректность категорий в ШР
	include("servis/zrp.js");
	if(!isCorectKat())
		return false;
    
    DropTable(tbl_svsv);    
    CreateTable(tbl_svsv, "SVKT");
    DefVed.begin("",ru("Проверка правильности расчета итогов по видам начислений",
    				   "Перевірка вірності розрахунку підсумуів по видам нарахувань"));
    				  
    DropTable("TSVOD");
	CreateTable("TSVOD","SVKT");
    				    				
	DropTable("FSVOD"); // временные, вспомогательные таблицы; 
	ExecuteSQL("SELECT Fwid, Fwid_par INTO FSVOD"
				+ " FROM ^stru_org"
				+ " WHERE Fbdat <= "+mdt1);		

   	// вибираю во временную т. всю инфу по организации;
/*   	DropTable("ZPSVOD");   	
	ExecuteSQL("SELECT zp.Flsfid, zp.Ftabn_id, zp.Fsum, zp.Fday as Fdn, zp.Fchas"
				+ " INTO ZPSVOD"
	     		+ " FROM"
	     			+ " ^"+tbl_svzp+" zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid"
    	 		+ " WHERE NOT (zp.Fvp=1 AND zp.Fmn>="+mdt1+")"
					+ " AND lc.Fis6='+'");*/
					
	// выгружаю дистинктом данные во вторую вспомогательную таблицу;
	// -[причина]- ::: задваивание на ^work_pers'е;
/*   	DropTable("WPSVOD");   	   	
   	ExecuteSQL("SELECT DISTINCT tz.Flsfid, tz.Ftabn_id,"
	   				+ " 0 as Fwid_dol, tz.Fsum, tz.Fdn, tz.Fchas"
				+ " INTO WPSVOD"
	     		+ " FROM"
	     			+ " ZPSVOD tz INNER JOIN ^work_pers wp ON tz.Ftabn_id=wp.Fwid_cl"		     		
    	 		+ " WHERE ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
    	               + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
        	           + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+"))");    
        	           
    ExecuteSQL("UPDATE WPSVOD ws SET ws.Fwid_dol="
    			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
    			+ " WHERE ws.Ftabn_id = wp.Fwid_cl"
    				+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
    	               + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
        	           + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))");*/
		
		/*
		DropTable("TZWSVOD");
   		ExecuteSQL("SELECT zp.Flsfid, zp.Fwid_wp, 0 as Fwid_dol, cr.Fcod as Fkod_kat,"
   						+ " zp.Fsum, zp.Fday as Fdn, zp.Fchas"
   					+ " INTO TZWSVOD"
   					+ " FROM ((^"+tbl_svzp+" zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid)"
   						+ " INNER JOIN ^work_pers wp ON zp.Fwid_wp=wp.Fwid)"
   							+ " INNER JOIN ^clrelclcl cr ON wp.Fwid_kat= cr.Fwid_cl"
   					+ " WHERE NOT (zp.Fvp=1 AND zp.Fmn>="+mdt1+")"
						+ " AND lc.Fis6='+'"
						+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
	   	                	+ " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
        	          		+ " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+"))");
	ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
    			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
    			+ " WHERE TZWSVOD.Fwid_wp = wp.Fwid"
    				+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
    	               + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
        	           + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))");
	
	DropTable("TSVOD");
	CreateTable("TSVOD","SVKT");
	
   	Mrekurs(fwid);
        	    
    ExecuteSQL("UPDATE TSVOD SET Ffzp='+' WHERE '+'="
				+ " (SELECT l.Ffzp FROM ^LIC_FLD l WHERE l.Fid= TSVOD.Flsfid)");
	ExecuteSQL("UPDATE TSVOD SET Ffzp='-' WHERE '+'<>"
				+ " (SELECT l.Ffzp FROM ^LIC_FLD l WHERE l.Fid= TSVOD.Flsfid)");
				
	*/			
				
	//20.07.07  Yana
   	DropTable("TZWSVOD");	
	strSQL = "SELECT zp.Flsfid, zp.Ftabn_id, zp.Fwid_wp, zp.Fmn, zp.Fvp, zp.Fsum, zp.Fday as Fdn, zp.Fchas,"
				+ Convert(0,"LONG") + " as Fwid_kat, " + Convert(0,"LONG") + " as Fwid_dol, " 
				+ Convert(0,"LONG") + " as Fwid_org, " + Convert(0,"LONG") + " as Fwid_par, " 
				+ Convert(0,"LONG") + " as Fwid_par2, " + Convert(0,"LONG") + " as Fwid_par3, "
				+ "' ' as Ffzp, lc.Ffld_num as Ffld_num, "
				+ Convert(0,"LONG") + " as Fkod_kat INTO TZWSVOD"
	     		+ " FROM ^"+tbl_svzp+" zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid"
    	 		+ " WHERE NOT (zp.Fvp=1 AND zp.Fmn>="+mdt1+")"
					+ " AND zp.Fwid_wp<>0 AND lc.Fis6='+'";
	ExecuteSQL(strSQL);					

   //20.07.07  Yana  сначала нужно найти катег.на код ШР.Если не найден, тогда на таб.N
  
   strSQL = "update TZWSVOD set fwid_kat=(select Fwid_kat from ^work_pers where Fwid=TZWSVOD.Fwid_wp) where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)";
   ExecuteSQL(strSQL);   

   strSQL = "update TZWSVOD set fwid_kat=(select max(Fwid_kat) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn_id "
					+" AND wp.Fbdat<="+mdt2+" AND wp.Fedat>="+mdt1+")"
					+" where Fwid_kat=0" 
   ExecuteSQL(strSQL);   				 

	ExecuteSQL("update TZWSVOD set fkod_kat=(SELECT Fcod "
		+ " FROM ^clrelclcl where TZWSVOD.Fwid_kat=Fwid_cl)")

  
   //20.07.07  Yana  сначала нужно найти код должности на код ШР.Если не найден, тогда на таб.N
   ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT wp.Fwid_dol FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Fwid_wp = wp.Fwid)"
			+"  where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );
   
   ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Ftabn_id = wp.Fwid_cl"
			+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
            + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
            + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))"
			+" where NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );        	           
   
   //20.07.07  Yana  найти код подразделения
   strSQL = "update TZWSVOD set fwid_org=(select Fwid_org from ^stru_dol where Fwid=TZWSVOD.Fwid_dol)";
   ExecuteSQL(strSQL);
      
   strSQL = "update TZWSVOD set fwid_par=(select Fwid_par from ^stru_org where Fwid=TZWSVOD.Fwid_org)";
   ExecuteSQL(strSQL);   
				
   strSQL = "update TZWSVOD set fwid_par2=(select Fwid_par from ^stru_org where Fwid=TZWSVOD.Fwid_par)";
   ExecuteSQL(strSQL);   

   strSQL = "update TZWSVOD set fwid_par3=(select Fwid_par from ^stru_org where Fwid=TZWSVOD.Fwid_par2)"
   		+ " WHERE EXISTS (select Fwid_par from ^stru_org where Fwid=TZWSVOD.Fwid_par2)";
   ExecuteSQL(strSQL);   
				
	//20.07.07 смотрим, по всей организации своды или по конкр.подр.
	fis_allorg = true;
	osnap = getSnap("select Fwid_par from ^stru_org where Fwid="+fwid)
	if(osnap!= null && osnap[0]!=0){
		fis_allorg = false;		
	}		
   	Mrekurs(fwid, fis_allorg);   	   	
/*        	    
    ExecuteSQL("UPDATE TSVOD SET Ffzp= "
				+ " (SELECT l.Ffzp FROM ^LIC_FLD l WHERE l.Fid= TSVOD.Flsfid)");

	ExecuteSQL("UPDATE TSVOD SET Ffzp='+'"				
				+" WHERE Ffzp='+' or Ffzp='к' or Ffzp='*' or Ffzp='д' or Ffzp='п' or Ffzp='и' or Ffzp='i' or Ffzp='о' or Ffzp='в' or Ffzp='н' or Ffzp='#' or Ffzp='m' or Ffzp='т'")
				
	ExecuteSQL("UPDATE TSVOD SET Ffzp=' '"				
				+" WHERE Ffzp is null ")

	ExecuteSQL("UPDATE TSVOD SET Ffzp='-'"				
				+" WHERE Ffzp<>'+'")
*/
    ExecuteSQL("UPDATE TSVOD SET Ffzp='+' WHERE "
				+ " (SELECT l.Ffzp FROM ^LIC_FLD l WHERE l.Fid= TSVOD.Flsfid) IN ('+', 'о')");
	ExecuteSQL("UPDATE TSVOD SET Ffzp='-' WHERE "
				+ " (SELECT l.Ffzp FROM ^LIC_FLD l WHERE l.Fid= TSVOD.Flsfid) NOT IN ('+', 'о')");
	//по ФЗП			
	ExecuteSQL("INSERT INTO "+tbl_svsv+" (Fsum, Fdn, Fchas, Flsfid, Fkod_kat, Ffzp, Ftt, Ftf, Ftk, Ftl, Fmn, Fvp, Fsex)"
				+ " SELECT SUM(S.Fsum) AS Fsum, SUM(S.Fdn) AS Fdn, SUM(S.Fchas) AS Fchas,"
					+ " 0 as Flsfid, S.Fkod_kat, '' as Ffzp, 1 as Ftt, 0 as Ftf, 2 as Ftk, 0 as Ftl, S.Fmn, S.Fvp, H.Fsex "
				+ " FROM TSVOD S "
					+" LEFT JOIN ^CL_HOMO H ON S.FTABN_ID = H.FWID_CL "
				+ " GROUP BY S.Fkod_kat, H.Fsex, S.Fmn, S.Fvp");
		
	// по категориям+ФЗП+поля ЛС
	ExecuteSQL("INSERT INTO "+tbl_svsv+" (Fsum, Fdn, Fchas, Flsfid, Fkod_kat, Ffzp, Ftt, Ftl, Ftf, Ftk, Fmn, Fvp, Fsex)"
				+ " SELECT SUM(S.Fsum) AS Fsum, SUM(S.Fdn) AS Fdn, SUM(S.Fchas) AS Fchas,"
					+ " S.Flsfid, S.Fkod_kat, S.Ffzp, 1 as Ftt, 1 as Ftl, 0 as Ftf, 0 as Ftk, S.Fmn, S.Fvp, H.Fsex "
				+ " FROM TSVOD S "
					+" LEFT JOIN ^CL_HOMO H ON S.FTABN_ID = H.FWID_CL "
				+ " GROUP BY S.Ffzp, S.Fkod_kat, S.Flsfid, H.Fsex, S.Fmn, S.Fvp");
	
	// по категории+ФЗП;
	ExecuteSQL("INSERT INTO "+tbl_svsv+" (Fsum, Fkod_kat, Ffzp, Ftt, Ftk, Ftl, Ftf, Fmn, Fvp, Fsex)"
				+ " SELECT SUM(S.Fsum) as Fsum, S.Fkod_kat, S.Ffzp, 1 as Ftt, 1 as Ftk, 0 as Ftl, 0 as Ftf, S.Fmn, S.Fvp, H.Fsex "
				+ " FROM TSVOD S "
					+" LEFT JOIN ^CL_HOMO H ON S.FTABN_ID = H.FWID_CL "
				+ " GROUP BY S.Ffzp, S.Fkod_kat, H.Fsex, S.Fmn, S.Fvp ");
	
	// общая сумма по категориям;
	ExecuteSQL("INSERT INTO "+tbl_svsv+" (Fsum, Ftt, Ftk, Ftl, Ftf, Fkod_kat, Fsex)"
				+ " SELECT SUM(S.Fsum) as Fsum, 2 as Ftt, 0 as Ftk, 0 as Ftl, 0 as Ftf, S.Fkod_kat, H.Fsex "
				+ " FROM TSVOD S "
					+" LEFT JOIN ^CL_HOMO H ON S.FTABN_ID = H.FWID_CL "
				+ " GROUP BY S.Fkod_kat, H.Fsex");
	
	// общая сумма;
	ExecuteSQL("INSERT INTO "+tbl_svsv+" (Fsum, Ftt, Ftk, Ftl, Ftf, Fkod_kat)"
				+ " SELECT SUM(Fsum) as Fsum, 3 as Ftt, 0 as Ftk, 0 as Ftl, 0 as Ftf, 99999 as Fkod_kat"
				+ " FROM TSVOD");
				
	
}

function Mrekurs(tfwid, tfis_allorg)
{				    					
	/*ExecuteSQL("INSERT INTO TSVOD (Flsfid, Fsum, Fdn, Fchas, Ffzp)"
				+ " SELECT ws.Flsfid, ws.Fsum, ws.Fdn, ws.Fchas, '-' as Ffzp"
					+ " FROM ((WPSVOD ws INNER JOIN ^stru_dol sd ON ws.Fwid_dol=sd.Fwid)"
						+ "INNER JOIN ^stru_org so ON sd.Fwid_org=so.Fwid)"
				+ " WHERE so.Fwid="+tfwid);*/
				
	/*			
    ExecuteSQL("INSERT INTO TSVOD (Flsfid, Fkod_kat, Fsum, Fdn, Fchas, Ffzp)"
				+ " SELECT zw.Flsfid, zw.Fkod_kat, zw.Fsum,"
					+ " zw.Fdn, zw.Fchas, '-' as Ffzp"
				+ " FROM ((TZWSVOD zw INNER JOIN ^stru_dol sd ON zw.Fwid_dol=sd.Fwid)"
					+ "INNER JOIN ^stru_org so ON sd.Fwid_org=so.Fwid)"
				+ " WHERE so.Fwid="+tfwid);
				
    oSnap = getSnap("SELECT COUNT(Fwid) FROM FSVOD WHERE Fwid_par="+tfwid);
   	if(oSnap[0]!=0)
   	{
   		kol = oSnap[0]; // количество дочерних fwid-ов;
	   	for(count=1; count <= kol; count++)
    	{
 	  		oSnap = getSnap("SELECT MIN(Fwid) FROM FSVOD WHERE Fwid_par="+tfwid);
 	  									// первый попавшийся минимальный fwid;
   			ExecuteSQL("DELETE FROM FSVOD WHERE Fwid="+oSnap[0]);
	   		Mrekurs(oSnap[0]);
		}
   	}
   	else
   	{ return } // выход из функции;
 */  
 if (tfis_allorg==false){
	   //подразделение и все в него вложенные					
	   ExecuteSQL("insert into TSVOD (Flsfid, Ftabn_id, Fmn, Fvp, Fsum, Fdn, Fchas,"
				+ " Fwid_org, Ffzp, Ffld_num, fkod_kat ) select Flsfid, Ftabn_id, Fmn, Fvp, Fsum, Fdn, Fchas,"
				+ " Fwid_org, Ffzp, ffld_num, fkod_kat from TZWSVOD "
				+ " WHERE Fwid_org="+tfwid+" or Fwid_par="+tfwid+" or Fwid_par2="+tfwid+" or Fwid_par3="+tfwid);
	}else{
	   ExecuteSQL("insert into TSVOD (Flsfid, Ftabn_id, Fmn, Fvp, Fsum, Fdn, Fchas,"
				+ " Fwid_org, Ffzp, ffld_num, fkod_kat ) select Flsfid, Ftabn_id, Fmn, Fvp, Fsum, Fdn, Fchas,"
				+ " Fwid_org, Ffzp, ffld_num, fkod_kat from TZWSVOD ")
	}	
}

function getSexName(mFsex)
{
	switch (mFsex)
	{
		case false:
			return ru("женщины", "жінки");
		case true:
			return ru("мужчины", "чоловіки");
		default:
			return "";
	}
}

function xmlFieldPost(lctxt)
{
	var str = "";
	var sexName = getSexName(toScrObj(list.tbl.getValue("FSEX")));

	switch(Number(list.tbl.getValue("Ftt")))
	{
		case 1:
		  	if(Number(list.tbl.getValue("Ftl"))==1)
			{
		  		str = lctxt + '-' + sexName;
			}

		  	if(Number(list.tbl.getValue("Ftk"))==2)
		  	{
				str = ru("Итого по категории - ", "Всього по категорії - ") + lctxt + '-' + sexName;
/*		  	 	if(list.tbl.getValue("Ffzp")=='+')
				{ 
					str = ru("Итого по ФЗП - ","Всього по ФЗП - ");
				}
				else
				{
					str = ru("Итого не входящие в ФЗП - ",
						 "Всьго, що не входить в ФЗП - ");
				}
*/				
				break;
		  	}
			else if (Number(list.tbl.getValue("Ftk"))==1)
		  	{
				if(list.tbl.getValue("Ffzp")=='+')
				{ 
					strfzp = ru(", входящие в ФЗП",", що входять в ФЗП");
				}
				else
				{	
					strfzp = ru(", не входящие в ФЗП",
							 ", що не входять в ФЗП");
				} 
				str = ru("Итого по категории - "+lctxt,
					 "Всього по категорії - "+lctxt) + '-' + sexName + strfzp;
		  	}		 
		  	break;
		case 2: 
			str = ru("ИТОГО ПО КАТЕГОРИИ - ","ВСЬОГО ПО КАТЕГОРІЇ - ")+lctxt + '-' + sexName; 
			break;
		case 3:
			str = ru("ИТОГО","ВСЬОГО");
			break;
		default: 
			break;
	} 	
 	
 	return str;
}

function getDat1Month()
{
	return format("mm/yyyy", date1);
}

include("sys\\DpList.js");