//расчёт расчётно-платёжной ведомости
include("objects/DpGetDat.js");
include("objects/DpAskEx.js");
include("servis/format.js");
include("servis/date.js");
include("get_cnst.js");
include("objects/DpGrid.js");

//var par = new Object();
var szTag;
var fwid;
var D1;
var D2;
var tblOut,tblName;
var siName, Shtat_table, Lic_table, WRAP1_table, WRAP2_table;
var pFtabn;
var id=0;
var col, row, tbl, sum_vip;
var keySnap
var sOrder = "";
//var one_of_meny = ((typeof(extPar)).toUpperCase()=="OBJECT");

function listLoad()
{
	with(this)
	{
   		title = ru("Просмотр расчетно-платежной ведомости","Перегляд розрахунково-платіжної відомості");
   		//printLabel = "RPLVED"; 
   		printLabel = "L_WRAP";
   	}
	
	menuMode = GetMenuMode();
	if(menuMode.toUpperCase() == "VIEW")
	{
		var gd = new DpGetDat("dD");
		D1 = new Date(firstDay(gd.dat1));
		D2 = new Date(lastDay(gd.dat2));
	}
	else
	{
		D1 = new Date(extPar.dat1); // дата начала
		D2 = new Date(extPar.dat2); // дата конца
	}
	this.title += ru(" за период с "+format("dd.mm.yyyy",D1)+" по "+format("dd.mm.yyyy",D2)+(extPar && extPar.fwid?" по '"+getTxtOrgByID(extPar.fwid)+"'":"")
		," за період з "+format("dd.mm.yyyy",D1)+" по "+format("dd.mm.yyyy",D2)+(extPar && extPar.fwid?" по '"+getTxtOrgByID(extPar.fwid)+"'":""));
	
	tblName="WRAP"+getDateTag(D1)+"_"+getDateTag(D2);

	for (var dd = D1; differ(dd, firstDay(D2))<=0; dd = goMonth(dd,1))
	{
		// достаем цифры к названию файла
		szTag = getDateTag(dd);
		siName = "^svzp"+szTag;
		if(!IsTableEx("zrp_res", "zrp_svzp"+szTag))
		{
			alert(ru("Сперва выполните расчет заработной платы за ","Спочатку виконайте розрахунок заробітної платні за ")+format("mm/yyyy",dd));
			return false;
		}
	}
}

function listAsk()
{
	var oA = new DpAskEx();
	oA.add("B", "Групувати по місяцям виникнення|Группировать по месяцам возникновения", "IS_MNVP", true);
	oA.add("B", "Групувати по виду наказу|Группировать по виду приказа", "IS_VIDPRK", true);
	oA.add("COMBO", "Підсумки|Итоги", "TOTPDR", 2, ru("итоги по подразделениям","підсумки по підрозділах")+"|"
			+ru("с итогами по подразделениям","з підсумками по підрозділах")+"|"
			+ru("без итогов по подразделениям","без підсумків по підрозділах"));
	oA.doAsk();
	
	return oA;
}

function listSrc()
{
	var totpdr = list.objAsk.get("TOTPDR");
	sOrder = (totpdr==2 ? "Ftt, Fcod" : "Fleftkey, Fcod")
	this.qrySet("Cross",tblName,"Order",sOrder/*"Ftt, Fcod"*/);

	this.setFwidSrc("FROWID");
}

function listDpGrid()
{
	if (IsTable(tblName+"_S") && IsTable(tblName+"_R") && IsTable(tblName+"_C"))
	{
		tbl = OpenTable( "c", tblName);
		col = tbl.GetCol();
		col.requery("select * from "+tblName+"_C order by fwid")
		row = tbl.GetRow();
		
		var oGrid = new DpGrid("NOCREATE");
		oGrid.defCond("=(^FCOD==0)", "ORG");	
		oGrid.color(3, "ORG");
		oGrid.bold("ORG");
		var gr = oGrid.page();
	
		//статичные поля таблицы
		gr.FieldEx("=getFioTbl(^Ffio, ^FRowid)", "П.І.П.|Ф.И.О.", 15);
		gr.FieldEx("Fdol", "Посада|Должность", 15);
		gr.FieldEx("=getPodrTxt(^Fpodr,^Fgrpdeep,^FRowid)", "Підрозділ|Подразделение", 15);
		gr.FieldEx("Fcod", "Таб №|Таб №", 10);
		gr.FieldEx("FKAT", "Кат. перс.|Кат. перс.", 15);
		gr.FieldEx("Fshpz", "ШВЗ|ШПЗ", 10);
		gr.FieldEx("Fday", "Днiв|Дней", 5, "", "%3");
		gr.FieldEx("Fchas", "Годин|Часов", 8, "", "%3");
		//подгружаем динамически поля используя шахматку
		col.MoveFirst();
		while (!col.IsEOF())
		{
			var ColTxt = toScrObj(col.getValue("FTXT"));
			var ColId = toScrObj(col.getValue("FCOLID"));
			gr.FieldEx(ColId, ColTxt, 10, null, DP_FORMAT_SUM);
			col.MoveNext();
		}
		oGrid.build();   		
	}
}

function getFioTbl(mfio, mRowid)
{
	if (mRowid.indexOf("ORG")==-1)
	{
		return getSmallFIO(mfio)
	}
	else
	{
		return mfio
	}
}

function getPodrTxt(podr, deep, rowid)
{
	if (deep == 0)
	{
		return podr
	}
	else
	{
		var retVal = podr
		for (var i=1;i<=deep;i++)
		{
			if (rowid.indexOf("ORG")==-1)
			{
				retVal = "    "+retVal
			}
			else
			{
				retVal = "  "+retVal
			}
		}
		return retVal
	}
}

function listMake()
{
	if(extPar.fwid!=null)
	{
   		fwid = extPar.fwid;
		WriteParEx("fwid",fwid);
	}
   	else
		return false;
	
	tblOut="TOUT";
	DropTable(tblOut);
	CreateTable(tblOut, "svzp", "*");
	
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD FCOD "+ SqlType("INT"));
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD FFIO "+ SqlType("VARCHAR",250));

	CreateTable(tblOut+"_TMP", "svzp", "*");
	
	ExecuteSQL("ALTER TABLE "+tblOut+"_TMP ADD FCOD "+ SqlType("INT"));
	ExecuteSQL("ALTER TABLE "+tblOut+"_TMP ADD FFIO "+ SqlType("VARCHAR",250));
		
	if (IsTable("WRAP1")) DropTable("WRAP1");
	
	keySnap = getSnap("SELECT Fleftkey,Frightkey FROM ^stru_org WHERE Fwid="+sqlTo(fwid));
	if(!keySnap)
		return false;

	var is_mnvp = list.objAsk.get("IS_MNVP");
	var is_vidprk = list.objAsk.get("IS_VIDPRK");
	var totpdr = list.objAsk.get("TOTPDR");

	for (var dd = D1; differ(dd, firstDay(D2))<=0; dd = goMonth(dd,1))
	{
		// достаем цифры к названию файла
		szTag = getDateTag(dd);
		siName = "^svzp"+szTag;
		if (IsTable("WRAP1_TMP"))
		{
			strSQL = "INSERT INTO WRAP1_TMP (FID, FFLD_NUM, FVID_PRK, FTABN_ID, FCOL, FDAY, FCHAS, FSUM, FMN, FVP)"
					+" SELECT a.flsfid AS fid, a.ffld_num, "+(is_vidprk ? "A.FVID_PRK" : "0 AS FVID_PRK")+", a.FTABN_ID,"
						+ " 0 AS Fcol, 0 as Fday, 0 as Fchas,"
						+ " Sum(a.FSUM) AS Fsum, "+(is_mnvp ? "a.FMN, a.FVP" : (sqlTo(d00)+" AS FMN, 0 AS FVP"))
		}
		else
		{
			strSQL = " SELECT a.flsfid AS fid, a.ffld_num, "+(is_vidprk ? "A.FVID_PRK" : "0 AS FVID_PRK")+", a.FTABN_ID,"
						+ " 0 AS Fcol, 0 as Fday, 0 as Fchas,"
						+ " Sum(a.FSUM) AS Fsum, "+(is_mnvp ? "a.FMN, a.FVP" : (sqlTo(d00)+" AS FMN, 0 AS FVP"))
					+ " INTO WRAP1_TMP"
		}
		strSQL += " FROM " + siName +" AS a "
			+ " LEFT JOIN ^work_pers AS wp ON (a.Ftabn_id=wp.Fwid_cl "
					+ " AND wp.Fbdat <="+sqlTo(D2)+" AND wp.Fedat >= "+sqlTo(D1)
					+ " AND wp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp2 WHERE wp.Fwid_cl=wp2.Fwid_cl "
									+" AND wp2.Fbdat<="+sqlTo(D2)+" AND wp2.Fedat>="+sqlTo(D1)+"))"
				+" LEFT JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid "
				+" LEFT JOIN ^stru_org so ON (sd.Fwid_org=so.Fwid "
					+" AND so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])+")"
				+" INNER JOIN ^lic_fld l ON l.Fid=a.Flsfid "
			+" WHERE NOT(a.Fvp=1 AND a.Fmn>"+sqlTo(D2)+") "
					+ " AND (l.Fis12 not in ("+sqlTo("1")+","+sqlTo("2")+","+sqlTo("3")+","+sqlTo("4")+","+sqlTo("5")+","+sqlTo("6")+","+sqlTo("7")+") or l.Fis12 is null)"//отсекаем базы удержаний
			+ " GROUP BY a.FLSFID, a.ffld_num, "+(is_vidprk ? "A.FVID_PRK," : "")+" a.FTABN_ID "+(is_mnvp ? ", a.FMN, a.FVP" : "")
		ExecuteSQL(strSQL);
	}

	strSQL = " SELECT fid, ffld_num, FVID_PRK, FTABN_ID, Fcol, Fday, Fchas,"
				+ " Sum(T.FSUM) AS Fsum, FMN, FVP "
			+ " INTO WRAP1"
			+ " FROM WRAP1_TMP AS T "
			+ " GROUP BY fid, ffld_num, FVID_PRK, FTABN_ID, Fcol, Fday, Fchas, FMN, FVP "
	ExecuteSQL(strSQL);
	DropTable("WRAP1_TMP")

	WRAPP1_table = getSnap("select * from WRAP1");
	if(!WRAPP1_table)
	{
		alert(ru("Расчетно-платежная ведомость пуста","Розрахунково-платіжна відомість порожня"));
		return;
	}
	   
	//переделал цикл на один запросс
	DropTable("WRAP11");
	ExecuteSQL("select distinct Ftabn_id into WRAP11 from WRAP1");
	createIndex("WRAP11", "FTABN_ID", "FTABN_ID");

	for (var dd = D1; differ(dd, firstDay(D2))<=0; dd = goMonth(dd,1))
	{
		//************************
		szTag = getDateTag(dd);
		//проставление времени по табелю		     
		tiName = "TBL"+szTag;
		siName = "STT1"+szTag;
		//***********************
		strSQL = "INSERT INTO "+tblOut+"_TMP (Ftabn_id,Fcod,Ffio,Fday,Fchas) "
				+" SELECT w.Ftabn_id,cl.Fcod,cl.Ftxt as Ffio,"
					+IIF("s.Fis_tabel="+sqlTo("*"),"SUM(ti.Fnorma_d)",IIF("s.Fis_tabel="+sqlTo("+"),"SUM(tbl.Fday_nvk)","0"))+" as Fday,"
					+IIF("s.Fis_tabel="+sqlTo("*"),"SUM(ti.Fnorma_ch)",IIF("s.Fis_tabel="+sqlTo("+"),"SUM(tbl.Fchasnvk)","0"))+" as Fchas"
				+" FROM WRAP11 as w "
					+" LEFT JOIN ^"+siName+" as s ON w.Ftabn_id=s.Ftabn_id "
						//+" and s.Fis_tabel in ('+','*','-')"//отсекаем некоректные табеля
					+" LEFT JOIN ^"+tiName+" as tbl ON s.Fwid_wp=tbl.Fwid_wp and s.fbdat=tbl.fbdat and s.fedat=tbl.fedat and tbl.Fkod_nvk=2"
					+" LEFT JOIN ^work_pers as wp ON (s.Fwid_wp=wp.Fwid "
						+" AND WP.FID = (SELECT MAX(FID) FROM ^WORK_PERS WP1 WHERE WP1.FWID_CL = WP.FWID_CL AND WP1.FBDAT<="+sqlTo(D2)
						//+" AND WP1.FEDAT>="+sqlTo(D1)
						+"))"
					+" LEFT JOIN ^tbl_ini as ti ON wp.Fvopl=ti.Fvopl and ti.Fbdat="+sqlTo(D1)
					+" INNER JOIN ^listcl as cl ON w.Ftabn_id=cl.Fwid"
				+" WHERE 1 = 1 "
				+" GROUP BY w.Ftabn_id,cl.Fcod,cl.Ftxt,s.Fis_tabel "
		ExecuteSQL(strSQL);
		
	}
	strSQL = "INSERT INTO "+tblOut+" (Ftabn_id,Fcod,Ffio,Fday,Fchas) "
			+" SELECT Ftabn_id,Fcod,Ffio,"
				+" SUM(T.FDAY) as Fday,"
				+" SUM(T.FCHAS) as Fchas"
			+" FROM "+tblOut+"_TMP as T "
			+" GROUP BY Ftabn_id,Fcod,Ffio "
	ExecuteSQL(strSQL);
	DropTable(tblOut+"_TMP")

	DropTable("REKT");	
	ExecuteSQL("SELECT Fwid, Fwid_par INTO REKT "
			+ " FROM ^stru_org WHERE Fbdat <= " + sqlTo(D1)
			+ " ORDER BY Fwid_par ");
			
	//получение массива всех дочерних fwid-ов и передача их в подстроку SQL запроса 
	//var substrSQL = GetArSQL(GetSubFwid(fwid));	
	//если текущий отдел не имеет подотделов, то возвращаем его же fwid
	//if (FwidAr.length==0) substrSQL = "("+fwid+")"; 
	DropTable(tblName);
	
	strSQL = " SELECT DISTINCT tb.Ftabn_id, tb.Fday, tb.Fchas, tb.Fsum, tb.Fcod, "
		+ " tb.Ffio, ct.Ftxts as Fdol, CLKAT.FTXT AS FKAT, so.Ftxt as Fpodr, sd.Fwid_cl as Fwid_dol, wp.Fbdat, wp.Fedat, wp.Fid, wp.Fismain, sd.Fshpz  "
   		+ " INTO "+tblName+" FROM "
   		+ " " + tblOut + " AS tb INNER JOIN ^work_pers wp ON tb.Ftabn_id=wp.Fwid_cl "
   		+ " INNER JOIN ^stru_dol sd ON wp.Fwid_dol=sd.Fwid "
   		+ " INNER JOIN ^stru_org so ON sd.Fwid_org=so.Fwid "
   		+ " INNER JOIN ^cl ct ON ct.Fwid=sd.Fwid_cl "
			+ " LEFT JOIN ^CL CLKAT ON CLKAT.FWID = WP.FWID_KAT "
   		+ " WHERE so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
			+ " AND wp.Fbdat <= " + sqlTo(D2) 
			// иначе не берет уволенных
			//+ " AND wp.Fedat >= " + sqlTo(D1)
			+ " AND WP.FID = (SELECT MAX(FID) FROM ^WORK_PERS WP1 WHERE WP1.FWID_CL = WP.FWID_CL AND WP1.FBDAT<="+sqlTo(D2)+" AND WP1.FEDAT>="+sqlTo(D1)+") "
	ExecuteSQL(strSQL);

	createIndex(tblName, "FCOD", "FCOD");
	createIndex(tblName, "FID", "FID");

	WriteParEx("flefkey",keySnap[0]);
	WriteParEx("frightkey",keySnap[1]);
    
    //так как один и тот же человек может находится в течении месяца на разных должностях
    //в разных отделах, то создадим таблицу по всем отделам 
    DropTable("OUTALL");
    //ищем корневой Fwid организации и составляем строку, содержащую все 
    //вложенные Fwid-ы
   	//var substrSQL2 = GetArSQL(GetSubFwid(GetBaseParFwid(fwid)));
    
    //if (FwidAr.length!=0)
    //{
	    ExecuteSQL(" SELECT DISTINCT tb.Ftabn_id, tb.Fday, tb.Fchas, tb.Fsum, tb.Fcod, "
			+ " tb.Ffio, ct.Ftxts as Fdol, CLKAT.FTXT AS FKAT, so.Ftxt as Fpodr, sd.Fwid_cl as Fwid_dol, wp.Fbdat, wp.Fedat, wp.Fid, wp.Fismain, sd.Fshpz "
			+ " INTO OUTALL FROM "
	   		+ " " + tblOut + " tb INNER JOIN ^work_pers wp ON tb.Ftabn_id=wp.Fwid_cl "
   			+ " INNER JOIN ^stru_dol sd ON wp.Fwid_dol=sd.Fwid "
	   		+ " INNER JOIN ^stru_org so ON sd.Fwid_org=so.Fwid "
   			+ " INNER JOIN ^cl ct ON ct.Fwid=sd.Fwid_cl "
				+ " LEFT JOIN ^CL CLKAT ON CLKAT.FWID = WP.FWID_KAT "
	   		+ " WHERE so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
				+" AND wp.Fbdat <= " + sqlTo(D2) 
				// иначе не берет уволенных
				//+ " AND wp.Fedat >= " + sqlTo(D1)
       		+ " ORDER BY tb.Fcod ");
	    //в таблицу не включаем записи персонала, который в течении месяца работал 
    	//на нескольких должностях, оставляем только последнюю должность
    	DropTable(tblOut);

    	ExecuteSQL("SELECT tf.* "
    		+ " INTO "+tblOut+" FROM "+tblName+" as tf"
    		+ " WHERE tf.Fid=(SELECT MAX(a2.Fid) "
    					+" FROM "+tblName+" as a2 "
						+" WHERE tf.Fcod=a2.Fcod) "
	   		+ " AND tf.Fid=(SELECT MAX(ta.Fid) "
    					+" FROM OUTALL as ta "
						+" WHERE tf.Fcod=ta.Fcod) "
    		+ " ORDER BY tf.Fcod");
	
	//расчёт таблиц для шахматки

	// Условие, максимизируя которое получаем запись из штатного расписания,
	// с максимальной fedat для ftable=1 или с максимальной fedat для ftable=2
	// (если нет записей для ftable=1)
	//var cExprA = "-100000*a.ftable + DateDiff('d', a.fedat, " + sqlTo(D2) + ")";
	var cExprA = /*"-1000000*a.ftable -" + */SqlDaysBWDates("a.fedat",sqlTo(d00));

	// По каждому табельному номеру находим нужную запись в штатном расписании
	DropTable("tmp_shtatcond1");
	ExecuteSQL(
		"SELECT a.Fwid_cl as ftabn_id"
		+ ", MAX(" + cExprA + ") AS fshtatcond"
		+ " INTO tmp_shtatcond1"
		+ " FROM ^work_pers a"
		+ " WHERE a.FBDAT<="+sqlTo(D2)
			// иначе не берет уволенных
		  /*+ "((a.FBDAT <= " + sqlTo(D1) + " AND a.FEDAT >= " + sqlTo(D2) +") " 
        + " OR (a.FBDAT >= " + sqlTo(D1) + " AND a.FBDAT <= " + sqlTo(D2) +") " 
        + " OR (a.FEDAT >= " + sqlTo(D1) + " AND a.FEDAT <= " + sqlTo(D2) +")) "*/
		+ " GROUP BY fwid_cl");
	
	DropTable("tmp_shtatcond2");
	ExecuteSQL(
		"SELECT 0 as Ftot, a.*"
		+ " INTO tmp_shtatcond2"
		+ " FROM tmp_shtatcond1 b"
		+ " INNER JOIN ^work_pers a"
		+ " ON a.fwid_cl=b.ftabn_id"
		+ " WHERE " + cExprA + "=b.fshtatcond"
	);

	if(SUBD == MYSQL)
	{
		DropTable("TMP_SHTATCOND3");
		ExecuteSQL("select * from TMP_SHTATCOND2 into TMP_SHTATCOND3");
		createIndex("TMP_SHTATCOND3", "FWID", "FWID");
		DropTable("TMP_SHTATCOND2");
		ExecuteSQL("select * into TMP_SHTATCOND2 from TMP_SHTATCOND3 as a where a.FWID="
					+"(SELECT MAX(b.FWID) FROM TMP_SHTATCOND3 as b WHERE b.FWID_CL = a.FWID_CL )");
		createIndex("TMP_SHTATCOND2", "FWID", "FWID");
		createIndex("TMP_SHTATCOND2", "FWID_CL", "FWID_CL");
	}
	else
	ExecuteSQL("DELETE FROM TMP_SHTATCOND2 "
			+ " WHERE FWID <> (SELECT MAX(FWID) "
							+ " FROM TMP_SHTATCOND2 b "
							+ " WHERE TMP_SHTATCOND2.FWID_CL = b.FWID_CL)");
	
	DropTable("WRAP1_TBL");
	ExecuteSQL("SELECT a.Ftot, a.Fvopl, b.*"
		+ " INTO WRAP1_TBL"
		+ " FROM ^tmp_shtatcond2 a, WRAP1 b"
		+ " WHERE "
		+ " a.Fwid_cl=b.Ftabn_id"
		+ " ORDER BY b.Ftabn_id, b.fid, b.FVID_PRK, b.fmn, b.fvp");
	
	DropTable("WRAP2_TBL");// подсчёт итоговых сумм "Всего"
	ExecuteSQL("SELECT 99999 as Ftabn, 1 as Ftot, wt.Fid, wt.FVID_PRK, "
			+" wt.Fmn, wt.Fvp, sum("+sqlRound("wt.Fsum",2)+") as Fsum "
			+" INTO WRAP2_TBL "
			+" FROM WRAP1_TBL wt, "+tblOut+" tt "
			+" WHERE wt.Ftabn_id=tt.Ftabn_id "
			+" GROUP BY wt.Fid, wt.FVID_PRK, wt.Fmn, wt.Fvp");
	createIndex("WRAP2", "FTABN_ID", "FTABN_ID");

	DropTable("XXX");
	ExecuteSQL("SELECT A.FID, B.Fis6 INTO XXX "
		+"FROM WRAP2_TBL A INNER JOIN ^LIC_FLD B "
		+"ON (A.FID = B.FID)");

	DropTable("XXX1");
	ExecuteSQL("select * into XXX1 from XXX WHERE Fis6='ф'");

	var strField = SqlConCat(Convert("FID", "NVC"), "'@'", Convert("FVID_PRK", "NVC"), "'@'", sqlDatToStr("FMN"), "'@'", Convert("FVP", "NVC"));
	var strField2 = SqlConCat(Convert("FTOT", "NVC"), "'@'", Convert("FTABN", "NVC"));
	DropTable("WRAP22");
	ExecuteSQL("SELECT Ftot, Fid, FVID_PRK, FMN, FVP, "+strField+"  AS fcolid, "
		+ "FTABN, "+strField2+" AS frowid, "
		+ "Fsum INTO WRAP22 FROM WRAP2_TBL ");

	WRAP1_table = getSnap("select * from WRAP1_TBL");
	if(!WRAP1_table)
	{
		alert(ru("Расчетно-платежная ведомость пуста","Розрахунково-платіжна відомість порожня"));
		return;
	}

	Lic_table = getSnap("SELECT * FROM ^LIC_FLD WHERE Fis6='ф'");
	if(!Lic_table)
	{
		WAIT(ru("Hевозможно идентифицировать поле ЛС: всего в выдаче","Неможливо ідентифікувати поле ОР: всього в наданні"));
        return;
	}

	// Из таблицы WRAP1_table создается дополнительная табличка WRAP2_table
	DropTable("WRAP2");
	strField = SqlConCat(Convert("FID", "NVC"), "'@'", Convert("FVID_PRK", "NVC"), "'@'", sqlDatToStr("FMN"), "'@'", Convert("FVP", "NVC"));
	strField2 = SqlConCat(Convert("FTOT", "NVC"), "'@'", Convert("FTABN_ID", "NVC"));
	ExecuteSQL(
		"SELECT ftot, fid, FVID_PRK, fmn, fvp"
		+ ", "+strField+" AS fcolid"
		+ ", FTABN_ID"
		+ ", "+strField2+" AS frowid"
		+ ", Fsum, Fday, Fchas "
		+ " INTO wrap2"
		+ " FROM WRAP1_TBL "
	);

	ExecuteSQL("INSERT INTO WRAP2(Ftot, Fid, FVID_PRK, FMN, FVP, fcolid,FTABN_ID, frowid, Fsum, Fday, Fchas) "
		+ " SELECT Ftot, Fid, FVID_PRK, FMN, FVP, fcolid, FTABN, frowid, Fsum, 0 as Fday, 0 as Fchas FROM WRAP22");

	DropTable(tblName+"_R2");
	ExecuteSQL("SELECT DISTINCT frowid, '"+ru("Всего","Всього")+"' as Ffio INTO "+tblName+"_R2 "
		+"FROM WRAP22 ");
	
	if (inList(totpdr,0,1))
	{
		ExecuteSQL("ALTER TABLE WRAP2 ADD COLUMN FWID_ORG "+SqlType("LONG"))
		strSQL = "UPDATE WRAP2 SET FWID_ORG = (SELECT SO.FWID "
				+" FROM ^STRU_ORG SO INNER JOIN ^STRU_DOL S ON SO.FWID = S.FWID_ORG"
				+" INNER JOIN ^WORK_PERS WP ON S.FWID = WP.FWID_DOL"
				+" WHERE WP.FWID_CL = WRAP2.Ftabn_ID "
				//+" AND WP.FID = WRAP2.FID"
	   		+" AND so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
				+" AND wp.Fbdat <= " + sqlTo(D2)
				// иначе не берет уволенных
				//+ " AND wp.Fedat >= " + sqlTo(D1)
				+" AND wp.fid = (SELECT MAX(WP1.FID) AS FID "
				+" FROM ^STRU_ORG SO INNER JOIN ^STRU_DOL S ON SO.FWID = S.FWID_ORG"
				+" INNER JOIN ^WORK_PERS WP1 ON S.FWID = WP1.FWID_DOL"
				+" WHERE WP1.FWID_CL = WRAP2.Ftabn_ID "
	   		//+" AND so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
				+" AND wp1.Fbdat <= " + sqlTo(D2)
				// иначе не берет уволенных
				//+ " AND wp1.Fedat >= " + sqlTo(D1)
				+")"				
				+")"
			+" WHERE EXISTS (SELECT SO.FWID "
				+" FROM ^STRU_ORG SO INNER JOIN ^STRU_DOL S ON SO.FWID = S.FWID_ORG"
				+" INNER JOIN ^WORK_PERS WP ON S.FWID = WP.FWID_DOL"
				+" WHERE WP.FWID_CL = WRAP2.Ftabn_ID"
				//+" AND WP.FID = WRAP2.FID"
	   		+" AND so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
				+" AND wp.Fbdat <= " + sqlTo(D2)
				// иначе не берет уволенных
				//+ " AND wp.Fedat >= " + sqlTo(D1)				
				+" AND wp.fid = (SELECT MAX(WP1.FID) AS FID "
				+" FROM ^STRU_ORG SO INNER JOIN ^STRU_DOL S ON SO.FWID = S.FWID_ORG"
				+" INNER JOIN ^WORK_PERS WP1 ON S.FWID = WP1.FWID_DOL"
				+" WHERE WP1.FWID_CL = WRAP2.Ftabn_ID "
	   		//+" AND so.Fleftkey >="+sqlTo(keySnap[0])+" AND so.Frightkey<="+sqlTo(keySnap[1])
				+" AND wp1.Fbdat <= " + sqlTo(D2)
				// иначе не берет уволенных
				//+" AND wp1.Fedat >= " + sqlTo(D1)
				+")"				
				+")"
		ExecuteSQL(strSQL);
	}
	// На основе WRAP2_table создаются таблицы: ..._S,..._R,..._C
	DropTable(tblName+"_S");
    ExecuteSQL("SELECT frowid, fcolid, Fsum AS fvalue "
		+ "INTO "+tblName+"_S FROM WRAP2");
		
	if (inList(totpdr,0,1))
	{
		//уберем лишнее, так как будем дальше привязывать LEFT JOIN-ом
		strSQL = "DELETE FROM WRAP2 WHERE NOT FTABN_ID IN (SELECT FTABN_ID FROM tmp_shtatcond1)"
		ExecuteSQL(strSQL);
		//добавим итоги
		//1) по подразделениям из WRAP2
		strSQL = " INSERT INTO "+tblName+"_S"
			+" SELECT "+SqlConCat(Convert("0","NVC"), "'@'", Convert("O.FWID","NVC"), "'@ORG'")+" AS FROWID"
			+", W.FCOLID, SUM(W.FSUM) AS FVALUE "
			+" FROM ^STRU_ORG O "
			+" LEFT JOIN WRAP2 W ON W.FWID_ORG = O.FWID"
   		+" WHERE o.Fleftkey >="+sqlTo(keySnap[0])+" AND o.Frightkey<="+sqlTo(keySnap[1])
			+" GROUP BY O.FWID, W.FCOLID"
		ExecuteSQL(strSQL);
		//2) по итоговым подразделениям
		strSQL = " INSERT INTO "+tblName+"_S"
			+" SELECT "+SqlConCat(Convert("0","NVC"), "'@'", Convert("O.FWID","NVC"), "'@ORG'")+" AS FROWID"
			+", W.FCOLID, SUM(W.FSUM) AS FVALUE "
			+" FROM ^STRU_ORG O "
			+" LEFT JOIN ^STRU_ORG O1 ON (O.FLEFTKEY < O1.FLEFTKEY AND O.FRIGHTKEY > O1.FRIGHTKEY)"
			//+" LEFT JOIN ^STRU_DOL D ON O.FWID = D.FWID_ORG"
			//+" LEFT JOIN ^WORK_PERS WP D.FWID = WP.FWID_DOL"
			+" LEFT JOIN WRAP2 W ON W.FWID_ORG = O1.FWID"
			//+" ON (W.Ftabn_ID = WP.FWID_CL AND W.FID = WP.FID)"
   		+" WHERE o.Fleftkey >="+sqlTo(keySnap[0])+" AND o.Frightkey<="+sqlTo(keySnap[1])
			+" GROUP BY O.FWID, W.FCOLID"
		ExecuteSQL(strSQL);
	}

    DropTable(tblName+"_R");
    DropTable(tblName+"_R3");
    DropTable(tblName+"_R4");
	ExecuteSQL("SELECT DISTINCT a.frowid, c.Fday, c.Fchas, b.FTABN_ID, c.Fcod, c.Ffio, c.Fdol, c.Fshpz, c.FKAT, c.Fpodr, 0 as Ftt "
		+(totpdr == 2 ? ", 0 AS FLEFTKEY, 0 AS FGRPDEEP " : ", O.FLEFTKEY, O.FGRPDEEP ")
		+"INTO "+tblName+"_R "
		+"FROM ((WRAP2 a "
		+"INNER JOIN ^tmp_shtatcond1 b "
		+"ON a.Ftabn_id = b.Ftabn_id) "
		+"INNER JOIN "+tblOut+" c ON c.Ftabn_id = a.Ftabn_id) "
		+(totpdr == 2 ? "" : "INNER JOIN ^STRU_ORG O ON O.FWID = A.FWID_ORG")
		+" order by b.Ftabn_ID "
		);
	//всего нет смысла добавлять, если есть итоги по подразделениям
	if (totpdr == 2)
	{
		 strField = SqlConCat(Convert("1","NVC"), "'@'", Convert("99999","NVC"));

		 ExecuteSQL("SELECT "+strField+" AS frowid, sum("+tblName+"_R.Fday) as Fday, "
				+" sum("+tblName+"_R.Fchas) as Fchas "
				+" INTO "+tblName+"_R3 FROM "+tblName+"_R");

		 ExecuteSQL("SELECT a.frowid, a.Ffio, b.Fday, b.Fchas, 0 as Ftabn_id "
				+" INTO "+tblName+"_R4 FROM "+tblName+"_R2 a, "+tblName+"_R3 b WHERE a.frowid=b.frowid");

		 ExecuteSQL("INSERT INTO "+tblName+"_R(frowid, Ffio, Fday, Fchas, Ftabn_id, Ftt) "
				+" SELECT frowid, Ffio, Fday, Fchas, Ftabn_id, 1 FROM "+tblName+"_R4");		
	}
   if (inList(totpdr,0,1))
	{
		strSQL = "INSERT INTO "+tblName+"_R (frowid, FTABN_ID, FCOD, Ffio, Fpodr, Ftt, FLEFTKEY, FGRPDEEP)"
			+" SELECT "+SqlConCat(Convert("0","NVC"), "'@'", Convert("O.FWID","NVC"), "'@ORG'")+" AS FROWID"
			+", O.FWID AS Ftabn_ID, 0 AS FCOD, '' AS FFIO, O.FTXT AS FPODR, 0 AS FTT, O.FLEFTKEY, O.FGRPDEEP "
			+" FROM ^STRU_ORG O "
			+" LEFT JOIN ^STRU_ORG O1 ON (O.FLEFTKEY < O1.FLEFTKEY AND O.FRIGHTKEY > O1.FRIGHTKEY)"
			+" LEFT JOIN WRAP2 A ON A.FWID_ORG = O1.FWID"
			+" LEFT JOIN ^tmp_shtatcond1 b "
			+" ON a.Ftabn_id = b.Ftabn_id "
			+" LEFT JOIN "+tblOut+" c ON c.Ftabn_id = a.Ftabn_id "
   		+" WHERE o.Fleftkey >="+sqlTo(keySnap[0])+" AND o.Frightkey<="+sqlTo(keySnap[1])
			+" GROUP BY O.FWID, O.FTXT, O.FLEFTKEY, O.FGRPDEEP"
		ExecuteSQL(strSQL);
		if (totpdr == 0)
		{
			ExecuteSQL("DELETE FROM "+tblName+"_R WHERE NOT FROWID LIKE '"+SqlStr4Like+"ORG'")
		}
	}
	//удалим из WRAP2, тех людей, которые не входят в наши подразделения
	strSQL = "DELETE FROM WRAP2 WHERE NOT FTABN_ID IN (SELECT FTABN_ID FROM "+tblOut+")"
	ExecuteSQL(strSQL);
    DropTable(tblName+"_C");
	ExecuteSQL(
	"SELECT DISTINCT A.fcolid, A.FVID_PRK, A.FMN, A.FVP, "+Convert("B.FTXT", "NVC", 255)+" AS FTXT, B.ffld_num"	// конвертируется FTXT в nvc(255)
		+ " INTO "+tblName+"_C"
		+ " FROM WRAP2 A"
		+ " LEFT JOIN ^LIC_FLD B"
		+ " ON (A.Fid = B.FID)"
		+ " ORDER BY B.ffld_num, A.fmn, A.fvp");

	strSQL = " ALTER TABLE "+tblName+"_C ADD FWID "+SqlType("COUNTER")
	ExecuteSQL(strSQL);

	// Net  не отходя от кассы проставим в FTXT полную текстовку с "в ... за ...",
	// чтобы на форме печати мегавыражения не было
	var tblCol = OpenTable(tblName+"_C");
	for (; !tblCol.IsEOF(); tblCol.MoveNext())
	{
		var fvp = toScrObj(tblCol.getValue("FVP"));
		var fmn = toScrObj(tblCol.getValue("FMN"));
		var ftxt = toScrObj(tblCol.getValue("FTXT"));
		var MnVoz = "";
		var MnVip = "";
		var ColTxt = "";
		switch (fvp)
		{
			case 1:
				MnVoz = String(new Date(fmn).getMonth()+1)+"/"+String(new Date(fmn).getFullYear());
				MnVip = String(D1.getMonth()+1)+"/"+String(D1.getFullYear());
				ColTxt = ftxt + " в " + MnVoz + " за " + MnVip;
				break;
			case 2:
				MnVip = String(new Date(fmn).getMonth()+1)+"/"+String(new Date(fmn).getFullYear());
				MnVoz = String(D1.getMonth()+1)+"/"+String(D1.getFullYear());
				ColTxt = ftxt + " в " + MnVoz + " за " + MnVip;
				break;
			default:
				ColTxt = ftxt;
				break;
		}

		var m = {};
		m.FWID = toScrObj(tblCol.getValue("FWID"));
		m.FTXT = ColTxt;
		updateTable(tblName+"_C", m, false);
	}
	tblCol.close();
	tblCol = null;

	return;
}

function getTblH()
{
	var h = new Object();
	if(getPar("ASK_RPV_DATA"))
	{
		var oA = new DpAskEx();
		oA.add("NUM", "Номер відомості|Номер ведомости", "NOM", 0);
		oA.add("D0", "Початок видачі зарплати|Начало выдачи зарплаты", "BDAT", getPar("GLOBDAT1"));
		oA.add("D0", "Закінчення видачі зарплати|Окончание выдачи зарплаты", "EDAT", getPar("GLOBDAT2"));
		oA.doAsk();
		if (oA.escape)
		{
			// умолчания
			h.HFNUM = "";
			h.HBD_ZP = D1.getVarDate(); 
			h.HED_ZP = D2.getVarDate();
		}
		num = oA.get("NOM");
		bd = oA.get("BDAT");
		ed = oA.get("EDAT");
		h.HFNUM = num;
		h.HBD_ZP = bd; 
		h.HED_ZP = ed;
	}
	else
	{
		h.HFNUM = "";
		h.HBD_ZP = D1.getVarDate(); 
		h.HED_ZP = D2.getVarDate();
	}
	txxx = getSnap("select Fid from XXX1");
	if (txxx!=null)
		num_vip = Number(txxx[0]);
	else
		num_vip=0;
	sum_vip = 0;
	txxx2 = getSnap("select Fsum from WRAP2_TBL where Fid="+String(num_vip));
	if (txxx2!=null) sum_vip = Number(txxx2[0]);
	h.HSUM_KVIP = sum_vip;
	h.HFD1 = D1.getVarDate();
	h.HFD2 = D2.getVarDate();
	return h;	
}

function listMenuInit()
{
	list.dataSrc.AddMenuItem("TOT","Підсумки по підрозділам першого рівня|Итоги по подразделениям первого уровня");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "TOT":
			var par = new Object();
			par.dat1=D1;
			if(fwid)
				par.fwid = fwid;
			else
				par.fwid = Number(ReadParEx("fwid"))
			if(keySnap)
			{
				par.leftkey = keySnap[0];
				par.rightkey = keySnap[1];
			}
			else
			{
				par.leftkey = Number(ReadParEx("fleftkey"));
				par.rightkey = Number(ReadParEx("frightkey"));
			}
			showWindow("l_wrapp.js",SW_NOMODAL,par);
		break;
	}
}
include("sys/DpList.js");