include("objects/DpGetDat.js");
include("servis/format.js");
include("servis/date.js");
include("get_cnst.js");
include("objects/DpGrid.js");

var szTag;
var fwid;
var D1;
var D2;
var tblOut,tblName;
var siName, Shtat_table, Lic_table, WRAPP1_table;
var fwid_org;
var id=0;
var col, row, tbl, sum_vip;

function listLoad()
{
	with(this)
	{
   		title = ru("Просмотр итогов расчетно-платежной ведомости","Перегляд пісумків розрахунково-платіжної відомості");
   		printLabel = "L_WRAPP";
   	}
	
	D1 = new Date(extPar.dat1);
	D2 = new Date(lastDayMonth(D1));
	this.title += " за "+format("dd.mm.yyyy",D1)+" по '"+getTxtOrgByID(extPar.fwid)+"'";
	
	tblName="WRAPP"+getDateTag(D1);

	// достаем цифры к названию файла
	szTag = getDateTag(D1);
	siName = "^svzp"+szTag;
	if(!IsTableEx("zrp_res", "zrp_svzp"+szTag))
	{
		alert(ru("Сперва выполните расчет заработной платы за ","Спочатку виконайте розрахунок заробітної платні за ")+format("mm/yyyy",D1));
		return false;
	}
}

function listSrc()
{
	this.qrySet("Cross",tblName,"Order","Frowid,Fleftkey");
}

function listDpGrid()
{
	if (IsTable(tblName+"_S") && IsTable(tblName+"_R") && IsTable(tblName+"_C"))
	{
		tbl = OpenTable( "c", tblName);
		col = tbl.GetCol();
		row = tbl.GetRow();
		
		var oGrid = new DpGrid("NOCREATE");
		var gr = oGrid.page();
		//статичные поля таблицы
		gr.FieldEx("Ftxtorg", "Підрозділ|Подразделение", 15);
		gr.FieldEx("Fday", "Днiв|Дней", 5, "", "%3");
		gr.FieldEx("Fchas", "Годин|Часов", 8, "", "%3");
		//подгружаем динамически поля используя шахматку
		col.MoveFirst();
		while (!col.IsEOF())
		{
			if (Number(col.getValue("Fvp"))!=0)
			{
				if (Number(col.getValue("Fvp"))==1)
				{
					MnVoz = String(new Date(Date(col.getValue("Fmn"))).getMonth()+1)+"/"
							+String(new Date(Date(col.getValue("Fmn"))).getFullYear());
					MnVip = String(D1.getMonth()+1)+"/"+String(D1.getFullYear());
				}
				if (Number(col.getValue("Fvp"))==2)
				{
					MnVip = String(new Date(Date(col.getValue("Fmn"))).getMonth()+1)+"/"
							+String(new Date(Date(col.getValue("Fmn"))).getFullYear());
					MnVoz = String(D1.getMonth()+1)+"/"+String(D1.getFullYear());
				}
				var ColTxt = String(col.getValue("FTXT"))+ " в "+ MnVoz+" за "+ MnVip
			}else
				var ColTxt = String(col.getValue("FTXT"));
			var ColId = String(col.getValue("fcolid"));
			gr.FieldEx(ColId, typeof(ColTxt)=="string"? ColTxt: "???",10);
			col.MoveNext();
		}
		oGrid.build();   		
	}
}

function listMake()
{
	if(extPar.fwid!=null)
   		fwid = extPar.fwid;
   	else
		return false;
	
	tblOut="TOUTP";
	DropTable(tblOut);
	CreateTable(tblOut, "svzp", "*");
	
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD FWID_ORG "+ SqlType("INT"));
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD FLEFTKEY "+ SqlType("INT"));
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD FRIGHTKEY "+ SqlType("INT"));
	ExecuteSQL("ALTER TABLE "+tblOut+" ADD Ftxtorg "+ SqlType("VARCHAR",250));
		
	if(IsTable("WRAPP1"))
		DropTable("WRAPP1");
	//групируем по подразделениям первого уровня
	ExecuteSQL("SELECT w1.fid, w1.FFLD_NUM,"
				+ Convert("0","INT") + " AS Fcol, "//+ Convert("0","DBL") + " as Fday, "+ Convert("0","DBL") + " as Fchas,"
				+ " Sum(w1.FSUM) AS Fsum, w1.FMN, w1.FVP, sd.Fwid as Fwid_org, sd.Ftxt as Ftxtorg, sd.Fleftkey, sd.Frightkey "
			+ " INTO WRAPP1"
			+ " FROM WRAP1 AS w1 "
				+ " INNER JOIN ^full_pers AS fp ON w1.Ftabn_id=fp.Fwid_cl "
				+ " INNER JOIN ^stru_org as sd ON sd.Fleftkey<=fp.Fleftkey AND sd.Frightkey>=fp.Frightkey AND sd.Fgrpdeep=1 "
			+" WHERE fp.Fleftkey >="+sqlTo(extPar.leftkey)+" AND fp.Frightkey<="+sqlTo(extPar.rightkey)
					+ " AND fp.Fbdat <="+sqlTo(D2)+" AND fp.Fedat >= "+sqlTo(D1)
					+ " AND fp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp2 WHERE fp.Fwid_cl=wp2.Fwid_cl "
									+" AND wp2.Fbdat<="+sqlTo(D2)+" AND wp2.Fedat>="+sqlTo(D1)+")"
			+ " GROUP BY w1.FID, w1.FFLD_NUM, sd.FWID, sd.Ftxt, sd.Fleftkey, sd.Frightkey, w1.FMN, w1.FVP");
			
	DropTable(tblName);
	ExecuteSQL(" SELECT sd.Fwid as Fwid_org, sd.Fleftkey, sd.Frightkey, SUM(w.Fday) as Fday, SUM(w.Fchas) as Fchas, SUM(w.Fsum) as Fsum "
		+" INTO "+tblName
		+" FROM WRAP"+getDateTag(D1)+" as w INNER JOIN ^full_pers as fp ON w.Ftabn_id=fp.Fwid_cl"
			+ " INNER JOIN ^stru_org as sd ON sd.Fleftkey<=fp.Fleftkey AND sd.Frightkey>=fp.Frightkey AND sd.Fgrpdeep=1 "
				+" WHERE fp.Fleftkey >="+sqlTo(extPar.leftkey)+" AND fp.Frightkey<="+sqlTo(extPar.rightkey)
					+ " AND fp.Fbdat <="+sqlTo(D2)+" AND fp.Fedat >= "+sqlTo(D1)
					+ " AND fp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp2 WHERE fp.Fwid_cl=wp2.Fwid_cl "
									+" AND wp2.Fbdat<="+sqlTo(D2)+" AND wp2.Fedat>="+sqlTo(D1)+")"
		+" GROUP BY sd.FWID, sd.Fleftkey, sd.Frightkey");
    
	DropTable("WRAPP1_TBL");
	ExecuteSQL("SELECT "+Convert("0","INT")+" as Ftot, b.*"
		+ " INTO WRAPP1_TBL"
		+ " FROM WRAPP1 b"
		+ " ORDER BY Fleftkey, ffld_num, fmn, fvp");
	
	DropTable("WRAPP2_TBL");// подсчёт итоговых сумм "Всего"
	ExecuteSQL("SELECT 99999 as Ftabn, 1 as Ftot, Fid, Ffld_num, "
				+" Fmn, Fvp, sum("+sqlRound("Fsum",2)+") as Fsum "
			+" INTO WRAPP2_TBL "
			+" FROM WRAPP1_TBL "
			+" GROUP BY Fid, FFld_num, Fmn, Fvp");

	DropTable("XXX");
	ExecuteSQL("SELECT A.FID, B.Fis6 INTO XXX "
		+"FROM WRAPP2_TBL A INNER JOIN ^LIC_FLD B "
		+"ON (A.FID = B.FID)");

	DropTable("XXX1");
	ExecuteSQL("select * into XXX1 from XXX WHERE Fis6='ф'");

	txxx = getSnap("select Fid from XXX1");
	if (txxx!=null)
		num_vip = Number(txxx[0]);
	else
		num_vip=0;

	sum_vip = 0;
	txxx2 = getSnap("select Fsum from WRAPP2_TBL where Fid="+String(num_vip));
	if (txxx2!=null) sum_vip = Number(txxx2[0]);
	var strField = SqlConCat(Convert("FID", "NVC"), "'@'", Convert("FFLD_NUM", "NVC"), "'@'", sqlDatToStr("FMN"), "'@'", Convert("FVP", "NVC"));
	var strField2 = SqlConCat(Convert("FTOT", "NVC"), "'@'", Convert("FTABN", "NVC"));
	DropTable("WRAPP22");
	ExecuteSQL("SELECT Ftot, Fid, FFLD_NUM, FMN, FVP, "+strField+"  AS fcolid, "
		+ "Ftabn, "+strField2+" AS frowid, "
		+ "Fsum INTO WRAPP22 FROM WRAPP2_TBL ");

	WRAPP1_table = getSnap("select * from WRAPP1_TBL");
	if(!WRAPP1_table)
	{
		alert(ru("Расчетно-платежная ведомость пуста","Розрахунково-платіжна відомість порожня"));
		return;
	}

	Lic_table = getSnap("SELECT * FROM ^LIC_FLD WHERE Fis6='ф'");
	if(!Lic_table)
	{
		WAIT(ru("Hевозможно идентифицировать поле ЛС: всего в выдаче","Неможливо ідентифікувати поле ОР: всього в наданні"));
        return;
	}

	// Из таблицы WRAPP1_table создается дополнительная табличка WRAPP2_table
	DropTable("WRAPP2");
	strField = SqlConCat(Convert("FID", "NVC"), "'@'", Convert("FFLD_NUM", "NVC"), "'@'", sqlDatToStr("FMN"), "'@'", Convert("FVP", "NVC"));
	strField2 = SqlConCat(Convert("FTOT", "NVC"), "'@'", Convert("FWID_ORG", "NVC"));
	ExecuteSQL(
		"SELECT ftot, fid, ffld_num, fmn, fvp"
		+ ", "+strField+" AS fcolid"
		+ ", Fwid_org, Ftxtorg, Fleftkey, Frightkey"
		+ ", "+strField2+" AS frowid"
		+ ", Fsum "
		+ " INTO WRAPP2"
		+ " FROM WRAPP1_TBL "
	);

	ExecuteSQL("INSERT INTO WRAPP2(Ftot, Fid, FFLD_NUM, FMN, FVP, fcolid,Fwid_org, frowid, Fsum) "
		+ " SELECT Ftot, Fid, FFLD_NUM, FMN, FVP, fcolid, FTABN, frowid, Fsum "
			//+", "+ Convert("0","DBL") + " as Fday, "+ Convert("0","DBL") + " as Fchas "
		+ " FROM WRAPP22");
	ExecuteSQL("alter table WRAPP2 add Fday "+sqlType("double"))
	ExecuteSQL("alter table WRAPP2 add Fchas "+sqlType("double"))

	// На основе WRAPP2_table создаются таблицы: ..._S,..._R,..._C
	DropTable(tblName+"_S");
    ExecuteSQL("SELECT frowid, fcolid, Fsum AS fvalue "
		+ "INTO "+tblName+"_S FROM WRAPP2");

    DropTable(tblName+"_R");
    DropTable(tblName+"_R3");
    DropTable(tblName+"_R4");
    ExecuteSQL("SELECT DISTINCT frowid, Fday, Fchas, Fwid_org, Fleftkey, Frightkey, Ftxtorg "
    	+"INTO "+tblName+"_R "
		+"FROM WRAPP2 order by Fleftkey");
    
    ExecuteSQL("update "+tblName+"_R set Fday=(select SUM(Fday) from TOUT as t INNER JOIN ^full_pers as fp ON t.Ftabn_id=fp.Fwid_cl "
    				+" WHERE fp.Fleftkey >="+tblName+"_R.Fleftkey AND fp.Frightkey<="+tblName+"_R.Frightkey"
						+ " AND fp.Fbdat <="+sqlTo(D2)+" AND fp.Fedat >= "+sqlTo(D1)
						+ " AND fp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp2 WHERE fp.Fwid_cl=wp2.Fwid_cl "
									+" AND wp2.Fbdat<="+sqlTo(D2)+" AND wp2.Fedat>="+sqlTo(D1)+"))"
				+" WHERE Fleftkey is not null");
	ExecuteSQL("update "+tblName+"_R set Fchas=(select SUM(Fchas) from TOUT as t INNER JOIN ^full_pers as fp ON t.Ftabn_id=fp.Fwid_cl "
    				+" WHERE fp.Fleftkey >="+tblName+"_R.Fleftkey AND fp.Frightkey<="+tblName+"_R.Frightkey"
						+ " AND fp.Fbdat <="+sqlTo(D2)+" AND fp.Fedat >= "+sqlTo(D1)
						+ " AND fp.Fwid=(SELECT MAX(Fwid) FROM ^work_pers as wp2 WHERE fp.Fwid_cl=wp2.Fwid_cl "
									+" AND wp2.Fbdat<="+sqlTo(D2)+" AND wp2.Fedat>="+sqlTo(D1)+"))"
				+" WHERE Fleftkey is not null");
	var totalSn = getSnap("select SUM(Fday),SUM(Fchas) from "+tblName+"_R WHERE Fleftkey is not null")
	if(totalSn)
		ExecuteSQL("update "+tblName+"_R set Fday="+totalSn[0]+", Fchas="+totalSn[1]+", Ftxtorg="+sqlTo(ru("Всего","Всього"))
			+" where Fleftkey is null or Fleftkey=0");

    DropTable(tblName+"_C");
	ExecuteSQL(
	"SELECT DISTINCT A.fcolid, A.Ffld_num, A.FMN, A.FVP, B.FTXT"
		+ " INTO "+tblName+"_C"
		+ " FROM WRAPP2 A"
		+ " LEFT JOIN ^LIC_FLD B"
		+ " ON (A.Fid = B.FID)"
		+ " ORDER BY A.ffld_num, A.fmn, A.fvp");
	return;
}

function getTblH()
{
	num = input(ru("Введите номер ведомости: ","Введіть номер відомості"),ru("Ввод информации","Введення інформації"),0,4);
	bd = input(ru("Начало выдачи зарплаты: ","Початок виплати зарплати"),ru("Ввод информации","Введення інформації"),getPar("GLOBDAT1"))
	ed = input(ru("Окончание выдачи зарплаты: ","Закінчення виплати зарплати"),ru("Ввод информации","Введення інформації"),getPar("GLOBDAT2"))
	var h = new Object();
	h.HFNUM = num;
	h.HSUM_KVIP = sum_vip;
	h.HFD1 = D1.getVarDate();
	h.HFD2 = D2.getVarDate();
	h.HBD_ZP = bd; 
	h.HED_ZP = ed;
	return h;	
}

include("sys/DpList.js");