include ("Objects\\DpGetDat.js");
var mm = GetMenuMode();

function listAsk()
{
	return new DpGetDat("dD");
}
function listLoad()
{
	with(this)
	{
		if(mm)
		{
			editTask = "e_zcpnv_n.xml";
			xmlGridFile = "l_zcpnv_n.xml";
			printLabel = "ZNPNV";
		}
		else
		{
			editTask = "e_zcpnv.xml";
			xmlGridFile = "l_zcpnv.xml";
			printLabel = "CNTVAL";
		}	
		
	}
}
function listSrc()
{
	this.qrySet("From","^CONST"
				,"Where", "FBDAT<="+sqlTo(list.objAsk.dat2)+" AND FEDAT>="+sqlTo(list.objAsk.dat1)
				,"Order","FCONST_NAM,FBDAT"
				);
}
function listTitle()
{
	var dat1 = javaDate2Script(list.objAsk.dat1);
	var dat2 = javaDate2Script(list.objAsk.dat2);
	return UR("Таблица постоянных величин за период "+
             StrDat(dat1,"DMY")+"-"+StrDat(dat2,"DMY"),
            "Таблиця постiйних величин за період "+
             StrDat(dat1,"DMY")+"-"+StrDat(dat2,"DMY"));
}

function filterMode(mode)
{
	if(!mm)
	{
		switch(mode)
		{
			case "ADD":
				WAIT(ru("Для добавления используйте меню ","Для додавання використовуйте меню ")+getMenuItemPath("l_zcpnv.js","l","N"));
				return false;
			break;
			case "EDIT":
			case "COPY":
				if(allt(list.tbl.getValue("Fexpr")).length>0)
				{
					WAIT(ru("Эта константа расчитывается с помощью выражения. Для редактирования используйте меню ","Ця константа розраховується за допомогою виразу. Для редагування використовуйте меню ")+getMenuItemPath("l_zcpnv.js","l","N"));
					return false;
				}
			break;
		}
	}
	return true;
}

function getValByType(type,sum,date,bool,text,bdat,edat,expr)
{
	var evalExpr;
	if(differ(bdat,list.objAsk.dat1)<0)
		bdat = list.objAsk.dat1;
	if(differ(edat,list.objAsk.dat2)>0)
		edat = list.objAsk.dat2;
	if(allt(expr).length>0)
	{
		var dat = today;
		if(differ(dat,edat)>0)
			dat = edat;
		if(differ(dat,bdat)<0)
			dat = bdat;
		evalExpr = constEval(expr, dat);	 
	}
	switch(String(type).toUpperCase())
	{
		case "DATE":
			return format("dd.mm.yyyy",allt(expr).length>0?evalExpr:date);
		break;
		case "BOOL":
			if(allt(expr).length>0)
				return evalExpr;
			else
				return bool==true?"true":"false";
		break;
		case "TEXT":
			return text;
		case "INT":
			return format("#",allt(expr).length>0?evalExpr:sum);
		break;
	}
	return format("#.00",allt(expr).length>0?evalExpr:sum);
}
include ("sys\\DpList.js");