include("objects/DpGrid.js");
include("servis/date.js");
include("gridedit.js");

function listLoad()
{
	this.title = ru("Суммы удержаний по задолж.по алиментам","Суми утримань по заборг.по аліментам");
	this.printLabel = "prk_dolg";
	var dpGridEdit = new DpGridEdit(grid);
	dpGridEdit.saveRecord = saveRecord;
	dpGridEdit.canEdit = gridEdit;
}

function listSrc()
{
	this.qrySet("Fields", "p.*, g.Ftabn_id,c.Fcod", 
				"From", "(^DLG_AL_U"+" AS p INNER JOIN ^PRK_ALL AS g ON p.Fid=g.Fwid) "
						+ " INNER JOIN ^clrelclcl AS c ON g.Ftabn_id=c.Fwid_cl", 
				"Where", "g.Fin_table='PRK_DOLG'"+(extPar && extPar.fbdat && extPar.fedat?" and g.Fbdat<="+sqlTo(extPar.fedat)+" and g.Fedat>="+sqlTo(extPar.fbdat):""),
				"Order", "c.fcod, p.fbdat");
	this.qrySet("Alias","p");
	//this.qrySet("From","^DLG_AL_U");
	//this.subTie("prk_dolg","pd","Fwid","Fid")
	//this.subTie("clrelclcl","clr","Fwid_cl","pd.Fwid_cl");
	//this.subTie("cl","x_cl","Fwid","pd.Fwid_cl");
	this.subTie("clrelclcl","clr","Fwid_cl","Ftabn_id");
	this.subTie("cl","x_cl","Fwid","Ftabn_id");	 	
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	//gr.FieldEx("clr.Fcod", "Таб №|Таб №", 5);
	gr.FieldEx("Fcod", "Таб №|Таб №", 5);	
	gr.FieldEx("=getSmallFIO(^x_cl.Ftxt)", "Ф.И.О.|П.І.П.", 15);
	gr.FieldEx("Fnach_sum", "Сума позики|Сумма ссуды", 10, "e", DP_FORMAT_SUM);
	gr.FieldEx("Fnach_dat", "Поч.утр.|Нач.уд.", 10, "e");
	gr.FieldEx("=(^Fsum_do-^Fsum_ud)", "Зал.заборг.|Ост.задолж.", 10);
	gr.FieldEx("=goDay(^Fedat,1)", "Дата зал.|Дата ост.", 10);
	gr.FieldEx("Fsum_ud", "Сума утрим.|Сумма удерж.", 10, "e", DP_FORMAT_SUM);
	oGrid.build();
}

function gridEdit(sMode)
{
	mode = sMode;
	if (mode == "EDIT")
		return true;
	return false;
}

function saveRecord()
{
	tbl = list.tbl;
	var m = new Object();
	m.Fnach_sum = tbl.getValue("Fnach_sum");
	m.Fnach_dat = tbl.getValue("Fnach_dat");
	m.Fsum_ud = tbl.getValue("Fsum_ud");
	UpdateTable("^DLG_AL_U", m, false, "Fwid="+sqlTo(tbl.getValue("Fwid")));
	return true;
}

function listDel()
{
	ExecuteSQL("DELETE FROM ^DLG_AL_U WHERE Fwid="+sqlTo(this.tbl.getValue("Fwid")));
	return false;
}

function listMassDel()
{
	ExecuteSQL("DELETE FROM ^DLG_AL_U WHERE Fwid "+this.dataSrc.getSqlSelected(true));
	return false;
}

function listMenuInit()
{
	if(!list.tbl.IsEmpty())
	{
		list.dataSrc.AddMenuItem("EDIT","Редагування|Редактирование");
	}
}
include("sys\\DpList.js");