var strStop = "*****";
function Office_printExcel()
{
	this.isEditMode = false;
	this.printRows	= Office_printRows;
	//this.makeCross	= Office_makeCross;
	this.setField	= POI_stdSetField;
	this.printSheet	= POI_printSheet;
	this.getCellValue = POI_getCellValue;
	
	this.workBook = lpProxy.openExcelWorkbook(this.file);
	if(this.workBook == null)
	{
		alert("Файл имеет неправильный формат");
		return;
	}
	var sheetCount = Number(this.workBook.getNumberOfSheets());
	
	for (var i = 0; i < sheetCount; i++)
	{
		var workSheet = this.workBook.getSheetAt(i);
		this.printSheet(workSheet);
		
	}
	
	var os = new DpFileOutputStream(this.file);
	this.workBook.write(os);
	os.close();
    if (this.isEditMode)
	{
    	Packages.org.eclipse.swt.program.Program.launch(this.file);
    	//java.awt.Desktop.getDesktop().open(new DpFile(this.file));
		return;
	}

	var	bPreview	= getPar("PrtPreview");
	var exl = null;
	if(Packages.org.eclipse.core.runtime.Platform.getWS() == "win32")
	{
		include ("Objects/DpCOMObject.js");
		var e;
		try
		{
			exl = new DpCOMObject("Excel.Application");			
		}
		catch(e)
		{
		}
	}
	
	if (exl)
	{
		var doc = exl.Workbooks.Open(this.file);
		exl.visible = true;
		if(bPreview)
		{
			doc.printPreview();			
		}
		else
			doc.printOut();
		
		exl.release();
		
	}
	else
	{
		var oCalcPrinter = lpProxy.getOfficePrinter("scalc");
		oCalcPrinter.setFormFile(this.file);
		var xSpreadsheetComponent = oCalcPrinter.getDocument(this.file);
		if (bPreview)
        {
        	oCalcPrinter.printPreview(xSpreadsheetComponent);
        }
        else
        {
        	oCalcPrinter.quickPrint(xSpreadsheetComponent);
        	oCalcPrinter.close(xSpreadsheetComponent);            	
        }
		
		//java.awt.Desktop.getDesktop().open(new DpFile(this.file));
		return;
	}
	return;	
}

function POI_printSheet(workSheet)
{
	var iY =  Number(workSheet.getLastRowNum());
	var iX = 100;
	this.iDstY = 0;
	var maDst = null;
    var nRowOnPage = 0;
	rTbl	= this.vars.getRTbl();
	//this.iDstY	= 1;
	
	var	iMax	= rTbl?rTbl.recordCount:0;
	var bmrk	= null;
	
	if(rTbl && rTbl.isRecord())
	{
		bmrk	= rTbl.bookmark;
		rTbl.moveFirst();
	}

	//if(this.beginPrint)
	//	this.beginPrint(doc, this.vars);
	
	//сразу делаем расчет числа строк для прогресса
	for(var i=0; i<iY; i++)
	{
	    var row = workSheet.getRow(i);
	    if (row == null)
	    	continue;
	    maDst = row.getCell(0);
	    if (maDst == null)
	    	continue;
	    		    
	    var sValue = this.getCellValue(maDst);
	    if (sValue == (strStop))
	    {
	   		iY	= i;
           //----- Определяем PAGE BREAK
           for (var k = 1; k <= 5; k++)
           {
                var rowB = workSheet.getRow(i + k);
                if (rowB == null)
                	continue;
                maDst = rowB.getCell(0);
                if (maDst == null)
                	continue;
                var sFormula = this.getCellValue(maDst);
                if (sFormula == null || sFormula.length < 11)
                    continue;
                 if (sFormula.substring(0, 11) == "PAGE BREAK=")
                 {
                    nRowOnPage = Number(sFormula.substring(11));     
                    
                    if (isNaN(nRowOnPage))
                     	nRowOnPage = 0;
                    maDst.setCellValue("");
                 }
       		}
            //------
	    	break;
	   	}	    	    
	}
	
	var nUsedRows	= iY;	
	
	iY =  Number(workSheet.getLastRowNum()) + 1;	
	var deletedRow = 0;    	
	for (var i = 0; i < iY; i++)
    {
    	var row = workSheet.getRow(i);    	
        if (row == null)
        {
        	continue;
        }
    	
    	for (var j = 0; j < iX; j++)
        {
            maDst = row.getCell(j);
           	if (maDst == null) continue;
           	
           	var sVal = this.getCellValue(maDst);           	
           	if ((0 == i || 0 == j) && sVal == strStop)
            {
        		if (i == 0)
               	{
                	maDst.setCellValue("");
                	row.removeCell(maDst);
                   	iX = j;
             	}
               	else
               	{
                	workSheet.removeRow(row);
                	if (i < workSheet.getLastRowNum())
                		workSheet.shiftRows(i + 1, workSheet.getLastRowNum(), -1, true, true);
                	iY = i;
                	//alert("aaa " + i);
              	}

               	break;
         	}

             // if(maDst.MergeCells)
             // j += maDst.Cells.Count-1;
			
          	if (sVal.length > 1 && sVal.charAt(0) == '*')
            {
             	if (sVal.length >= 7
                               && sVal.substring(1, 7) == "CROSSH")
               	{
                         // iX += this.makeCross(exl, rTbl, maDst);
               	}
             	else if (sVal.length >= 2
                            && sVal.substring(1, 2).equals("+"))
               	{

                	
                	var sRowID = sVal.substring(2);                   	
                   	rTbl = this.vars.getRTbl(sRowID);
                   	
                    
                               
                    var iOld = i;
                    i = this.printRows(workSheet, rTbl, j, i, iX,nRowOnPage, "");                    
                    iY =  Number(workSheet.getLastRowNum()) + 1;
                    j = iX;
                   	break;
                    //i+=300; 	    						

               	}
               	else
               	{
               		var sValue = this.setField(sVal.substring(1));
                   	/*
                   	if (sValue != null && !(sValue == ""))
                   		&& sValue.charAt(0) == '0')
                   	{
                        	sValue = "'" + sValue;
                   	}
                   	 
                   	if (sValue == null)
                   		sValue = "";
                   	*/	
                   	maDst.setCellValue(sValue); 
                }
           	}          	
           	
    	}

   	}
	
	var row = workSheet.getRow(iY);
	if (row != null)
    {
    	maDst = row.getCell(0);
	    if (maDst != null)
	    {
	    	
	    	if(this.getCellValue(maDst) == "EDIT DOCUMENT")
	    	{
	    		this.isEditMode = true;
	    		workSheet.removeRow(row);
	    	}
	    }
    }
	/*
	var nMerge = workSheet.getNumMergedRegions()
	
	for (var i = 0; i < nMerge; i++)
	{
		var region = workSheet.getMergedRegionAt(i);
		workSheetDst.addMergedRegion(region);
	}
	
	for (var j = 0; j < iX; j++)
    {
    	var n = workSheet.getColumnWidth(j);
    	
		workSheetDst.setColumnWidth(j,n);
		var n1 = workSheetDst.getColumnWidth(j);
		alert(j + " - " + n + " - " + n1);
   	}
   	*/
	
	
}

function POI_getCellValue(cell)
{
	if (cell.getCellType() == cell.CELL_TYPE_BLANK)
		return "";
	else if(cell.getCellType() == cell.CELL_TYPE_BOOLEAN)
		return cell.getBooleanCellValue();
	else if(cell.getCellType() == cell.CELL_TYPE_ERROR)
		return "";
	else if(cell.getCellType() == cell.CELL_TYPE_FORMULA)
		return String(cell.getCellFormula());
	else if(cell.getCellType() == cell.CELL_TYPE_NUMERIC)
		return Number(cell.getNumericCellValue());
	else if(cell.getCellType() == cell.CELL_TYPE_STRING)
		return String(cell.getStringCellValue());
	else 
		return "";
}

function Office_printRows(workSheet, rTbl, nStartCol, nStartRow,  nEndCol, nRowOnPage)
{
		var nRowHeight = 0;
		var rowArray = new Array();
        var nRowSrc = nStartRow + 1;
        var nColSrc = nStartCol;
        //alert(nStartCol);
        do
        {
        	var row = workSheet.getRow(nRowSrc);
        	var cell = row.getCell(nStartCol);
           	var sVal = "";
           	if (cell != null) 
           	{
           		var sVal = this.getCellValue(cell);
           		if (sVal != "*-")
           		{
           			nRowHeight ++;
           			var oRow = new Object();
           			oRow.exprArr = new Array(); 
           			oRow.styleArr = new Array();
           			oRow.mergeArr = new Array();
           			oRow.cond = "";
           			for (var j = 0; j < nEndCol - nStartCol; j++)
           			{
           				var cell = row.getCell(j + nStartCol);
           				if (cell != null) 
           				{
           					oRow.exprArr[j] = this.getCellValue(cell); 
           					oRow.styleArr[j] = cell.getCellStyle();
           								
           					if (j + nStartCol == nEndCol - 1)
           					{
           						oRow.cond = oRow.exprArr[j]; 
           					}			
           				}
           				else
           				{
           					oRow.exprArr[j] = ""; 
           					oRow.styleArr[j] = null;
           				}
           				var numRegions = workSheet.getNumMergedRegions();
           				for (var i = numRegions - 1; i >= 0; i--)
           		        {
           		        	
           		        	var region = workSheet.getMergedRegion(i);
           		        	var x =  region.getFirstColumn();
           		        	var x1 = region.getLastColumn();
           		        	var y = region.getFirstRow();
           		        	var y1 = region.getLastRow();
           		        	if (x >= nStartCol && x1 <= nEndCol && y == nRowSrc &&  y1 == nRowSrc)
           		        			
           		        	{        		
           		        		oRow.mergeArr[oRow.mergeArr.length] = region;
           		        	}
           		        }
           			}
           			
           			rowArray[rowArray.length] = oRow;
           			nRowSrc++;
           		}
           		
           	}
           	workSheet.removeRow(row);
        }
        while (sVal != "*-");
        var numRegions = workSheet.getNumMergedRegions();
        for (var i = numRegions - 1; i >= 0; i--)
        {
        	
        	var region = workSheet.getMergedRegion(i);
        	var x =  region.getFirstColumn();
        	var x1 = region.getLastColumn();
        	var y = region.getFirstRow();
        	var y1 = region.getLastRow();
        	if (x >= nStartCol && x1 <= nEndCol && y >= nStartRow && y1 <= nStartRow + 1 + nRowHeight + 1)
        			
        	{        		
        		workSheet.removeMergedRegion(i);
        	}
        }
        var nRecords = (rTbl != null ? rTbl.getRowCount()
                : 0);
        var monitor;
        if (nRecords > 10)
        {
        	monitor = getProgressMonitor();
        	monitor.beginTask(UR("Перевірка проведень|Проверка проводок"), nRecords);
        }
        while(!rTbl.isEOF())
        {
        	var row = null;
        	for (var i = 0; i < rowArray.length; i++)
        	{
        		var oRow = rowArray[i];
        		var isExpr = false;
        		if (oRow.cond != "")
        		{
        			var exprValue = String(oRow.cond); 
        			if (exprValue.startsWith("*"))
        			{
        				exprValue = this.setField(exprValue.substr(1));
        			}
        			if (exprValue == null)
        				exprValue = "";
        			
        			if (exprValue === false)
        				continue;
        			else if (exprValue === true)
        				isExpr = true;
        		}
        		workSheet.shiftRows(nRowSrc + 1, workSheet.getLastRowNum(), 1, true, true);
        		nRowSrc = nRowSrc + 1;
        		row = workSheet.getRow(nRowSrc);
        		if (row == null)
        			row = workSheet.createRow(nRowSrc);        		
        		
        		for(var j = 0; j < oRow.mergeArr.length; j++)
        		{
        			var region = oRow.mergeArr[j];
        			var newRegion = oRow.mergeArr[j].copy();
        			newRegion.setFirstRow(nRowSrc);
        			newRegion.setLastRow(nRowSrc);
        			workSheet.addMergedRegion(newRegion);
        			
        		}
        		for (var j = 0; j < oRow.exprArr.length; j++)
        		{
        			if (j + nStartCol == nEndCol - 1 && isExpr)
   					{
   						oRow.cond = oRow.exprArr[j]; 
   						continue;
   					}
        			
        			var cell = row.getCell(j + nStartCol);
        			if (cell == null)
        				cell = row.createCell(j + nStartCol);
        			if (oRow.styleArr[j])
        				cell.setCellStyle(oRow.styleArr[j]);
        			var exprValue = String(oRow.exprArr[j]); 
        			
        			if (exprValue.startsWith("*"))
        			{
        				exprValue = this.setField(exprValue.substr(1));
        			}
        			if (exprValue == null)
        				exprValue = "";
        			cell.setCellValue(exprValue);
        			
        		}
        		
        	}
        	var nAbs = Number(rTbl.absolute);
        	if (nRowOnPage > 0 && nAbs % nRowOnPage == 0)
            {
        		workSheet.setRowBreak(nRowSrc);
            }
        	
        	rTbl.moveNext();
        	if(Number(rTbl.bookmark)%10 ==0 && monitor) 
        		monitor.worked(10);
        }
        if (nRecords > 10)
        	monitor.done();
        workSheet.shiftRows(nStartRow + 1 + nRowHeight + 1, workSheet.getLastRowNum(), -(nRowHeight + 2), true, true);
        return nRowSrc - (nRowHeight + 2);
}

function POI_getCellRangeAddress(firstRow, lastRow,firstCol, lastCol)
{
	return null;
}

function copyCellStyle(workBookSrc,workBook, srcCell, dstCell)
{
	var srcStyle = srcCell.getCellStyle();
	dstCell.setCellStyle(cloneCellStyle(workBookSrc, workBook, srcStyle));
}	
	
	
function cloneCellStyle(workBookSrc, workBook, srcStyle)
{
	var style = workBook.createCellStyle();
	
	style.setAlignment(srcStyle.getAlignment());
	style.setBorderBottom(srcStyle.getBorderBottom());
	style.setBorderTop(srcStyle.getBorderTop());
	style.setBorderLeft(srcStyle.getBorderLeft());
	style.setBorderRight(srcStyle.getBorderRight());
	style.setBottomBorderColor(srcStyle.getBottomBorderColor())
	style.setDataFormat(srcStyle.getDataFormat());
	style.setFillBackgroundColor(srcStyle.getFillBackgroundColor());
	style.setFillForegroundColor(srcStyle.getFillForegroundColor());
	style.setFillPattern(srcStyle.getFillPattern());
	style.setFont(cloneFont(workBook, workBookSrc.getFontAt(srcStyle.getFontIndex())));
	style.setHidden(srcStyle.getHidden());
	style.setIndention(srcStyle.getIndention());
	
	style.setLeftBorderColor(srcStyle.getLeftBorderColor());
	style.setLocked(srcStyle.getLocked())
	style.setRightBorderColor(srcStyle.getRightBorderColor());
	style.setRotation(srcStyle.getRotation())
	style.setTopBorderColor(srcStyle.getTopBorderColor());
	style.setVerticalAlignment(srcStyle.getVerticalAlignment());
	
	style.setWrapText(srcStyle.getWrapText());

	//style.setFillBackgroundColor(HSSFColor.AQUA.index);
	//style.setFillPattern(HSSFCellStyle.BIG_SPOTS);
	//style.setDataFormat(HSSFDataFormat.getBuiltinFormat("@"));
	
	return style;
}

function cloneFont(workBook, srcFont)
{
	var font = workBook.createFont();
	
	font.setBoldweight(srcFont.getBoldweight())
	font.setCharSet(srcFont.getCharSet());
	font.setColor(srcFont.getColor());
	font.setFontHeight(srcFont.getFontHeight());
	font.setFontHeightInPoints(srcFont.getFontHeightInPoints());
	font.setFontName(srcFont.getFontName());
	font.setItalic(srcFont.getItalic());
	font.setStrikeout(srcFont.getStrikeout());
	font.setTypeOffset(srcFont.getTypeOffset());
	font.setUnderline(srcFont.getUnderline());
	
	return font;
}


function POI_stdSetField(fld, t)
{
	
	var res = fld;

	if(this.vars)
	{
		//must be DpTVars
		res =  this.vars.getVar(String(fld));
	}
	trace(fld+ " = "+ res);
	
	if (res == null)
		res = "";
	
	if (typeof(res) != "string")
		return res;

	var pos = res.indexOf("|");

	if (pos == -1)
		return res;

	if (this.prtLang == 0)
		res = res.left(pos);
	else
		res = res.right(res.length - pos - 1);

	return res;	

}