include("Objects/DpXMLDomDocument.js");
include("Objects/DpOwnList.js");
include("sys/ListApi.js");

var ownList;

function Load()
{
	Caption("Обране|Избранное");
	FORM.setImage(rootDirectoryEx() +"/icons/index.gif");
	
	loadTree();
	loadHistoryTree();
			
	ownList = new DpOwnList();
	ownList.loadXml();
	ownList.fillTree(null, null, Tree);
	Tree.setExpanded(true);
	
	this.closeInfo = closeInfo;
	this.closeHistory = closeHistory;
	FORM.getDialogBuilder().setToolItemSelection(BTNCLOSEHISTORY, this, "closeHistory");
	FORM.getDialogBuilder().setToolItemSelection(BTNCLOSEINFO, this, "closeInfo");
	
	sash.setWeights(new Array(100, 0));
	if(getPar("OWNLIST_SHOW_HISTORY"))
		showHistory();
			
	if(ownList.empty)
		loadEmpty();
		
	if(lpProxy.isTest())
		runDebTest(this);
	
	Tree.getCtrl().setFocus();
}

function loadTree()
{
	this.treeMenuInit = treeMenuInit;
	this.treeMenuRun = treeMenuRun;
	this.mouseDown = treeMouseDown;
	Tree.loadMenuHandler(this, "treeMenuInit");
	Tree.selectMenuHandler(this, "treeMenuRun");
	if(toScrObj(getPar("OWNLIST_RUNBYONECLICK")))
		Tree.setMouseHandler(this);	
	Tree.setSettingsMenuHandler(this, "treeMenuRun");
	Tree.addSettingsMenuItem("ADD", "Створити папку|Создать папку");
	Tree.addSettingsMenuItem("ADD_CL", "Додати довідник аналітики|Добавить справочник аналитики");
	Tree.addSettingsMenuItem("ADD_DOC", "Додати папку документів|Добавить папку документов");
	Tree.addSettingsMenuItem("ADD_MENU", "Додати команду з головного меню|Добавить команду из главного меню");
	Tree.addSettingsMenuItem("", "");
	Tree.addSettingsMenuItem("SHOW_HISTORY", "Показати популярні|Показать популярные");	
	Tree.addSettingsMenuItem("SETTINGS", "Параметри системи|Параметры системы");
	Tree.addSettingsMenuItem("SHOW_INFO", "Довідка|Справка");
	
	this.saveTreeItem = saveTreeItem;
	Tree.setSaveHandler(this, "saveTreeItem");
	
	this.treeDrop = treeDrop;
	this.treeDrag = treeDrag;
	Tree.setDropHandler(this, "treeDrop");
	Tree.setDragHandler(this, "treeDrag");
	
	Tree.addColumn("name", "", 200);
	Tree.getCtrl().setHeaderVisible(false);
	Tree.getCtrl().setLinesVisible(false);
}

function treeMenuInit()
{
	var treeItem = Tree.getItem(Tree.getSelected());
	Tree.AddMenuItem("RUN", "Відкрити\tEnter|Открыть\tEnter", !Tree.getSelected());
	Tree.AddMenuItem("", "");
	Tree.AddMenuItem("+++", "Додати|Добавить");		
		Tree.AddMenuItem("ADD_CL", "довідник аналітики|справочник аналитики");
		Tree.AddMenuItem("ADD_DOC", "папку документів|папку документов");	
		Tree.AddMenuItem("ADD_MENU", "команду з головного меню|команду из главного меню");
	Tree.AddMenuItem("---", "");
	//Tree.AddMenuItem("", "");
	Tree.AddMenuItem("ADD", "Створити папку|Создать папку");
	if (Tree.getSelected())
	{
		Tree.AddMenuItem("EDIT", "Редагувати|Редактировать");
		Tree.AddMenuItem("DEL", "Вилучити|Удалить");
		Tree.AddMenuItem("CLEAR", "Очистити|Очистить");
	}	
	Tree.AddMenuItem("", "");
	Tree.AddMenuItem("SHOW_HISTORY", "Показати популярні|Показать популярные");
	Tree.AddMenuItem("SETTINGS", "Параметри системи|Параметры системы", "sys_param");
	if(treeItem)
	{
		var isGroup = treeItem.getData("name")=="grp";
		Tree.AddMenuItem("PROPERTY", "Властивості|Свойства", isGroup);
	}	
}

function openItem(treeItem)
{
	if(!treeItem)
		return false;
	if(String(treeItem.getData("name"))=="grp")
	{
		treeItem.setExpanded(true);
		return false;
	}	
	var xmlDoc = treeItem.getData("xml");
	ownList.load(xmlDoc);
	ownList.run();	
	saveHistory(treeItem);
	loadHistory();
	return true;
}

function treeMouseDown(me)
{
	if (!me || me.button != 1)
		return;
	
	var itemId = Tree.getSelected();
	if(!itemId)
		return;
	var item = Tree.getItem(itemId);
	if (item == null || String(item.getData("name")) =="grp")
		return;
	return treeMenuRun("DOUBLECLICK");
}

function treeMenuRun(sMenuID, obj)
{
	var sItemID = Tree.getSelected();
	var treeItem = Tree.getItem(sItemID);
	switch(sMenuID)
	{
	case "RUN":
	case "DOUBLECLICK":	
		openItem(treeItem);
		loadHistory();
		break;
	
	case "ADD_CL":
	case "ADD_DOC":		
	case "ADD_MENU":
		var type = "";
		var task = "";
		var par = "";
		var txt = "";		
		var name = "list";
		var icon = 3;
		var image = "";
		var system = getSystem();
		var newID = String(GetUID());
		var xmlDoc = ownList.xmlDom.createElement(name);
		var parentID = "";
		var parentItem = getGroupItem(sItemID);		
		if(parentItem)
			parentID = parentItem.getData("ID");
		var xmlParDoc = ownList.xmlDom.getDocumentElement();
		if(parentID!="" && parentItem)
			xmlParDoc = parentItem.getData("xml");
		
		if(sMenuID=="ADD_CL")
		{
			var oPar = new Object();
			oPar.zaval = true;
			oPar.ret = new Object();
			oPar.ret.FCOD = 0;
			oPar.ret.FVID = "";
			oPar.ret.FTXT = "";
			oPar.ret.FSYSTEMS = "";
			showWindow("l_clcl.js", SW_MODAL, oPar);
			if(oPar.escape)
				return;
			
			type = "cl";
			task = "l_cl.xml";
			txt = oPar.ret.FTXT;
			var vid = oPar.ret.FVID;
			var cod = oPar.ret.FCOD;
			system = oPar.ret.FSYSTEMS;
			
			var xmlGrp = ownList.getXmlGrp(type);
			if(xmlGrp && !parentItem)
			{
				xmlParDoc = xmlGrp;
				parentID = xmlGrp.getAttribute("ID");
			}
			
			var xmlExtPar = ownList.xmlDom.createElement("extPar");
			xmlExtPar.setAttribute("text", UR("Програмні параметри|Программные параметры"));
			xmlDoc.appendChild(xmlExtPar);
			
			xmlPar = ownList.xmlDom.createElement("par");
			xmlPar.setAttribute("text", UR("Вид довідника|Вид справочника"));
			xmlPar.setAttribute("ID", "Fvid");
			xmlPar.setText(vid);
			xmlExtPar.appendChild(xmlPar);
			
			xmlPar = ownList.xmlDom.createElement("par");
			xmlPar.setAttribute("text", UR("Код довідника|Код справочника"));
			xmlPar.setAttribute("ID", "Fcl");
			xmlPar.setText(cod);
			xmlExtPar.appendChild(xmlPar);
		}
		else if(sMenuID=="ADD_DOC")
		{
			var oPar = new Object();
			oPar.zaval = true;
			oPar.ret = new Object();
			showWindow("docfdr.xml", SW_MODAL, oPar)
			if(oPar.escape)
				return;
			
			type = "doc";
			task = "l_docekz.xml";
			txt = oPar.ret.txt;
			var doc = String(oPar.ret.doc);
			var nop = Number(oPar.ret.nop);
			var oSnap = getSnap("select FSYS from ^CL_LNK where UPPER(FDOC)="+ sqlTo(doc.toUpperCase()))
			if(oSnap)
				system = String(oSnap[0]).trim();
						
			var xmlGrp = ownList.getXmlGrp(type);
			if(xmlGrp && !parentItem)
			{
				xmlParDoc = xmlGrp;
				parentID = xmlGrp.getAttribute("ID");
			}
			
			var xmlExtPar = ownList.xmlDom.createElement("extPar");
			xmlExtPar.setAttribute("text", UR("Програмні параметри|Программные параметры"));
			xmlDoc.appendChild(xmlExtPar);
			
			xmlPar = ownList.xmlDom.createElement("par");
			xmlPar.setAttribute("text", UR("Мітка документа|Метка документа"));
			xmlPar.setAttribute("ID", "doc");
			xmlPar.setText(doc);
			xmlExtPar.appendChild(xmlPar);
			
			xmlPar = ownList.xmlDom.createElement("par");
			xmlPar.setAttribute("text", UR("№ операції|№ операции"));
			xmlPar.setAttribute("ID", "nop");
			xmlPar.setText(nop);
			xmlExtPar.appendChild(xmlPar);
			
		}
		else if(sMenuID=="ADD_MENU")
		{
			var menuElement = lpProxy.showDebetMenu(Tree.getCtrl().getShell());
			if (menuElement == null)
				return;		
			name = "menu";
			xmlDoc = ownList.xmlDom.createElement(name);
			type = menuElement.getAttribute("type");
			task = menuElement.getAttribute("command");
			par = menuElement.getAttribute("par");
			txt = menuElement.getAttribute("ua") + "|" + menuElement.getAttribute("ru");
			image = String(menuElement.getAttribute("image"));
			if(image && image!="" && image.indexOf(".")==-1)
				image += ".gif";
			var filter = menuElement.getAttribute("filter");
			if(filter && String(filter).trim()!="")
			{
				filter = String(filter).trim().toUpperCase();
				if(filter.indexOf("!")==-1)
				{
					system = filter;
				}
				else if(filter.indexOf(system)!=-1)
				{
					system = "";
					/*
					var sysList = lpProxy.getOrgManager().getSysList();
					for(var i=0; i<sysList.size(); i++)
					{
						var oSys = sysList.get(i);
						if(oSys)
						{
							 var sys = String(oSys.label).toUpperCase();
							 if(filter.indexOf(sys)==-1)
							 {
							 	system = sys;
							 	break;
							 }
						}
					}
					*/ 
				}
			}
			var xmlGrp = ownList.getXmlGrp("calc");
			if((par=="CALC" || par=="VIEW") && xmlGrp && !parentItem)
			{
				xmlParDoc = xmlGrp;
				parentID = xmlGrp.getAttribute("ID");
			}
		}
		
		if(!xmlParDoc)
			xmlParDoc = ownList.xmlDom.getDocumentElement();		
		
		xmlDoc.setAttribute("ID", newID);
		xmlDoc.setAttribute("task", task);
		xmlDoc.setAttribute("type", type);
		xmlDoc.setAttribute("par", par);		
		xmlDoc.setAttribute("txt", txt);
		xmlDoc.setAttribute("image", image);
		xmlDoc.setAttribute("system", system);
		xmlParDoc.appendChild(xmlDoc);
		ownList.saveXml();
		
		Tree.addItem(parentID, newID, UR(txt), icon);
		var ti = Tree.getItem(newID);		
		ti.setData("name", name);
		ti.setData("type", type);
		ti.setData("xml", xmlDoc);	
		ti.setData("ID", newID);
		ti.setData("image", image);
		if(image!="")
			Tree.setImage(newID, image);
		
		Tree.showItem(newID);
		Tree.setSelected(newID);		
		Tree.getCtrl().setFocus();
		break;
		
	case "ADD":
		var parentID = "";
		var parentItem = getGroupItem(sItemID);		
		if(parentItem)
			parentID = parentItem.getData();				
		var xmlParDoc = ownList.xmlDom.getDocumentElement();
		if(parentID!="" && parentItem && parentItem.getData("xml"))
			xmlParDoc = parentItem.getData("xml");
		
		var newID = String(GetUID());
		var xmlDoc = ownList.xmlDom.createElement("grp");		
		xmlDoc.setAttribute("ID", newID);
		xmlParDoc.appendChild(xmlDoc);
		ownList.saveXml();
		
		Tree.addItem(parentID, newID, "");
		var ti = Tree.getItem(newID);		
		ti.setData("canAdd", true);
		ti.setData("name", "grp");
		ti.setData("type", "grp");
		ti.setData("xml", xmlDoc);	
		ti.setData("ID", newID);		
		
		Tree.showItem(newID);
		Tree.setSelected(newID);
		Tree.doEdit(newID, "name");
		Tree.getCtrl().setFocus();
		break;
	
	case "EDIT":
		Tree.doEdit(Tree.getSelected(), "name");
		Tree.getCtrl().setFocus();
		break;
	
	case "DEL":
		var treeItem = Tree.getItem(sItemID);
		if(!treeItem)
			return;
		var sMsg = UR("Видалити елемент?|Удалить элемент?");
		if(treeItem.getText())
			sMsg = UR("Видалити |Удалить '") + treeItem.getText() +"'?";
		if(treeItem.getData("name")=="grp")
		{
			sMsg = UR("Видалити папку |Удалить папку '") + treeItem.getText() +"'?";
			if(treeItem.getItemCount()>0)
				sMsg = UR("Папка не пуста!|Папка не пустая!") +" "+ sMsg;
		}
		if(!confirm(sMsg, UR("Видалення|Удаление")))
			return;
		var parItem = treeItem.getParent();
		var xmlDoc = treeItem.getData("xml");				
		xmlDoc.getParentNode().removeChild(xmlDoc);
		ownList.saveXml();
		Tree.removeItem(Tree.getSelected());
		if(parItem)
			Tree.setSelected(parItem);
		Tree.getCtrl().setFocus();
		loadHistory();
		break;
		
	case "CLEAR":
		var sMsg = UR("Усі команди і папки будуть видалені! Очистити обране?"
					+"|Все команды и папки будут удалены! Очистить избранное?");
		if(!confirm(sMsg, UR("Очистка|Очистка")))
			return;		
		Tree.removeAll();
		var xmlDoc = ownList.xmlDom.getDocumentElement();
		var arrList = xmlDoc.getChildNodes();
		for(var i=0; i<arrList.length; i++)
			xmlDoc.removeChild(arrList[i]);		
		clearHistory();
		ownList.saveXml();
		break;
		
	case "SHOW_HISTORY":
		showHistory();
		break;
	
	case "SHOW_INFO":
		showInfo();
		break;
		
	case "SETTINGS":
		var oPar = new Object();
		oPar.sel = "OWNLIST";
		showWindow("e_param.xml", SW_MODAL, oPar);
		break;
		
	case "PROPERTY":
		var sItemID = Tree.getSelected();
		var treeItem = Tree.getItem(sItemID);
		if(!treeItem || !treeItem.getData("xml"))
			return;
		var xmlDoc = treeItem.getData("xml");
		//ownList.loadXml();
		ownList.load(xmlDoc);
		var oPar = new Object();		
		oPar.ownList = ownList;
		oPar.treeItem = treeItem;
		oPar.image = treeItem.getImage();
		showWindow("ownlist_prop.xml", SW_MODAL, oPar);		
		if(!oPar.escape && oPar.isEdit)
		{
			xmlDoc = treeItem.getData("xml");
			xmlDoc.setAttribute("txt", oPar.txt);
			xmlDoc.setAttribute("task", oPar.task);
			xmlDoc.setAttribute("type", oPar.type);
			xmlDoc.setAttribute("par", oPar.par);
			xmlDoc.setAttribute("rate", oPar.rate);
			xmlDoc.setAttribute("system", oPar.system);
			xmlDoc.setAttribute("color", oPar.color);
			xmlDoc.setAttribute("image", oPar.image);
			xmlDoc.setAttribute("base", oPar.base);
			ownList.saveXml();
			
			treeItem.setText(UR(oPar.txt));
			treeItem.setData("task", oPar.task);
			treeItem.setData("type", oPar.type);
			treeItem.setData("par", oPar.par);
			ownList.setTreeItemColor(sItemID, oPar.color);
			if(oPar.image)
				Tree.setImage(sItemID, oPar.image);
			if(Number(oPar.rate)!=Number(treeItem.getData("rate")))
			{
				treeItem.setData("rate", oPar.rate);
				saveHistory(treeItem, Number(oPar.rate));
				loadHistory();
			}
			
			Tree.showItem(sItemID);
			Tree.setSelected(sItemID);			
			Tree.getCtrl().setFocus();
		}
		break;
	}	
}

function getGroupItem(sID)
{
	if(!Tree.getItemSel())
		return null;
	var treeItem = Tree.getItem(sID);
	if(treeItem)
	{
		if(treeItem.getData("canAdd")==true || treeItem.getData("name")=="grp")
			return treeItem;
	}
	else
	{
		return null;
	}
	var parentItem = treeItem.getParentItem();
	if(!parentItem)
		parentItem = treeItem.getParent();		
	return parentItem;
}

function saveTreeItem(sItemID, sCol, oVal)
{
	var treeItem = Tree.getItem(sItemID);
	var xmlDoc = treeItem.getData("xml");
	if(xmlDoc!=null)
	{
		xmlDoc.setAttribute("txt", String(oVal));		
		ownList.saveXml();
		Tree.setSelected(Tree.getItem(sItemID));
		Tree.getCtrl().setFocus();
		Tree.showItem(sItemID);
	}
	return true;
}

function treeDrag(sFunc, obj)
{
	if (sFunc == "dragSetData")
	{		
		obj.data = Tree.getSelected();
	}
}

function treeDrop(sFunc, obj)
{
	if(!obj.item || sFunc == "dragEnter")
		return;
	
	var sParID = "";
	if(obj.item.getData("canAdd")==true || obj.item.getData("name")=="grp")
		sParID = obj.item.getData();
	else if(obj.item.getParentItem())
		sParID = obj.item.getParentItem().getData();
	var sItemID = obj.data;
	
	if(sFunc == "drop")
	{		
		var treeItem = Tree.getItem(sItemID);		
		var xmlDoc = treeItem.getData("xml");
		var newXml = xmlDoc.cloneNode(true);
		var xmlTo = obj.item.getData("xml");
		var parXml = xmlTo.getParentNode();
		if(obj.item.getData("canAdd")==true || obj.item.getData("name")=="grp")
			parXml = xmlTo;
		xmlDoc.getParentNode().removeChild(xmlDoc);
		if(obj.item.getData("canAdd")==true || obj.item.getData("name")=="grp")
			parXml.appendChild(newXml);
		else
			parXml.insertBefore(newXml, xmlTo);
		ownList.saveXml();
		var txt = String(newXml.getAttribute("txt"));
		var sID = String(newXml.getAttribute("ID"));
		var icon = 3;
		if(treeItem.getData("canAdd")==true || treeItem.getData("name")=="grp")
			icon = 1;
		Tree.removeItem(sID);		
		Tree.addItem(sParID, sID, UR(txt), icon);		
		treeItem = Tree.getItem(sID);
		treeItem.setData("xml", newXml);
		treeItem.setData("ID", sID);
		treeItem.setData("name", newXml.getNodeName());
		treeItem.setData("type", newXml.getAttribute("type"));
		treeItem.setData("rate", newXml.getAttribute("rate"));
		treeItem.setData("image", newXml.getAttribute("image"));
		treeItem.setData("color", newXml.getAttribute("color"));
		var image = newXml.getAttribute("image");
		if(image)
			Tree.setImage(sID, image);
		ownList.setTreeItemColor(sID, newXml.getAttribute("color"));
		Tree.showItem(sID);
		return;
	}
	
	if(sFunc=="dragOver")
	{
		if(!obj.item)
		{
			obj.detail = 0;
			return;
		}
		obj.detail = 1;
		/*
		if (parItem && parItem.getData("canAdd")==true)
			obj.detail = 1;
		else
			obj.detail = 0;
		*/
		return;
	}
}

function loadEmpty()
{
	var count = 1;
	var par = ReadParameter("OWNLISTS_EMPTY_LOAD");
	if(par && Number(par)>0)
		count = Number(par)+1;
	WriteParameter("OWNLISTS_EMPTY_LOAD", count);
	if(count>2)
	{
		setButton(BTNKILL, killWindow);
		HELP.setText(UR("Якщо набридло читати цю муру, "
						+"\nнатисніть наступну кнопку:"
					+"|Если надоело читать эту муру, "
						+"\nнажмите следующую кнопку:")
					);
		GRKILL.setVisible(true);
	}
	
	showInfo();
}

function killWindow()
{
	WriteParameter("OWNLISTS_EMPTY_LOAD", 0);
	setPar("SHOW_MY_LISTS", false);
	CloseWindow();
}

function showInfo()
{
	var sInfo = UR("Додати команду у обране можна за допомогою правої клавіші миші"
						+" або кнопки 'Налаштування' біля пошуку у верхній частині вікна."
					+"\nСюди також можна додати будь-який список." 
					+" Для цього потрібно у відкритому списку викликати"
						+" контекстне меню 'Зберегти список'"
						+" або використати комбінацію клавіш 'CTRL+S'."
					+"\nДля кожного списку зберігається"
						+" перелік колонок, сортування, відбір, підсумки і т.і."
					+"\nАктивувати збережену команду та відкрити список з обраного"
						+" можна подвійним клацанням лівої клавіші миші"
						+" або за допомогою кнопки 'Enter'"
						+", встановивши курсор на відповідному елементі у дереві."
					+"\nПри цьому автоматично увімкнеться підсистема"
						+", яка закріплена за активованою командою."
					+"\nЗмінити підсистему можна у властивостях команди."
					+"\nАвтоматичне перемикання підсистем відключається у параметрах системи."
  				+"|Добавить комманду в избранное можно с помощью правой клавиши мыши"
  						+" или кнопки 'Настройки' возле поиска в верхней части окна."
  					+"\nСюда также можно добавить любой список."
  					+" Для этого нужно в открытом списке вызвать"
  						+" контекстное меню 'Сохранить список'"
  						+" или использовать комбинацию клавиш 'CTRL+S'."
  					+"\nДля каждого списка сохраняется"
  						+" перечень колонок, сортировка, отбор, итоги и т.п."
  					+"\nАктивировать сохранённую комманду или открыть список из избранного"
  						+" можно двойным щелчком левой клавиши мыши"
  						+" или с помощью кнопки 'Enter'"
  						+", установив курсор на нужном элементе в дереве."
  					+"\nПри этом автоматически включится подсистема"
  						+", которая закреплена за активированной коммандой."
  					+"\nИзменить подсистему можно в свойствах команды."
  					+"\nАвтоматическое переключение подсистем отключается в параметрах системы."
  				);
	INFO.setText(sInfo);	
	GRHISTORY.setVisible(false);
	sash.setWeights(new Array(100, 0));
	GRINFO.setVisible(true);	
}

function closeInfo()
{
	GRINFO.setVisible(false);
}

function showHistory()
{
	closeInfo();
	GRHISTORY.setVisible(true);
	sash.setWeights(new Array(100, 35));
	setPar("OWNLIST_SHOW_HISTORY", true);
	loadHistory();
}

function loadHistoryTree()
{
	this.historyTreeMenuInit = historyTreeMenuInit;
	this.historyTreeMenuRun = historyTreeMenuRun;
	historyTree.loadMenuHandler(this, "historyTreeMenuInit");
	historyTree.selectMenuHandler(this, "historyTreeMenuRun");
}

function historyTreeMenuInit()
{
	historyTree.AddMenuItem("RUN", "Відкрити\tEnter|Открыть\tEnter");
	historyTree.AddMenuItem("DEL", "Вилучити|Удалить");
	historyTree.AddMenuItem("CLEAR", "Очистити|Очистить");
	historyTree.AddMenuItem("CLOSE", "Закрити популярні|Закрыть популярные");
}

function historyTreeMenuRun(sMenuID)
{
	var sItemID = historyTree.getSelected();
	var treeItem = historyTree.getItem(sItemID);
	switch(sMenuID)
	{
		case "RUN":
		case "DOUBLECLICK":
			openItem(treeItem);
			break;
		
		case "DEL":
			deleteHistoryItem(treeItem);			
			break;
		
		case "CLEAR":
			clearHistory();			
			break;
		
		case "CLOSE":
			closeHistory();
			break;
	}
}

function loadHistory()
{
	if(!GRHISTORY.isVisible() || historyTree.getCtrl().isDisposed())
		return false;
	
	historyTree.removeAll();
	
	var historyList = ownList.xmlHistory.getChildNodes();
	for(var i=0; i<historyList.length; i++)
	{		
		var oRate = historyList[i];
		var nRate = Number(oRate.getText());
		var sItemID = oRate.getAttribute("ID");
		if(historyTree.getItem(sItemID))
			continue;
		var treeItem = Tree.getItem(sItemID);
		if(treeItem)
		{			
			var xml = treeItem.getData("xml");
			var txt = xml.getAttribute("txt");
			historyTree.addItem("", sItemID, UR(txt), 3);
			var historyItem = historyTree.getItem(sItemID);
			historyItem.setData("xml", xml);
			historyItem.setData("name", xml.getNodeName());
			historyItem.setData("ID", xml.getAttribute("ID"));
			historyItem.setData("type", xml.getAttribute("type"));
		}
	}
	return;	
}

function saveHistory(treeItem, nListRate)
{
	if(!treeItem)
		return;
	var xmlDoc = treeItem.getData("xml");
	if(!nListRate)
	{
		nListRate = 1;
		if(treeItem.getData("rate"))
			nListRate = Number(treeItem.getData("rate"))+1;		
	}
	treeItem.setData("rate", nListRate);
	xmlDoc.setAttribute("rate", nListRate);
	var sName = xmlDoc.getNodeName();
	var sItemID = xmlDoc.getAttribute("ID");
	var xmlHistory = ownList.xmlHistory;
	if(!xmlHistory)
		return;
	var arrList = new Array();
	var arrRate = new Array();
	var historyList = xmlHistory.getChildNodes();
	for(var i=0; i<historyList.length; i++)
	{		
		var oList = historyList[i];
		var nRate = Number(oList.getText());
		var sID = oList.getAttribute("ID");
		if(nListRate>=nRate && !arrRate[sItemID])
		{
			arrList[arrList.length] = sItemID;
			arrRate[sItemID] = nListRate;
		}
		if(!arrRate[sID])
		{
			arrList[arrList.length] = sID;
			arrRate[sID] = nRate;
		}
		xmlHistory.removeChild(oList);
	}
	if(!arrRate[sItemID] && arrList.length<5)
	{
		arrList[arrList.length] = sItemID;
		arrRate[sItemID] = nListRate;
	}
		
	for(var nList=0; nList<arrList.length; nList++)
	{
		if(nList>4)
			break;
		var sID = arrList[nList];
		var nRate = arrRate[sID];
		if(!nRate)
			nRate = 1;
		var oList = ownList.xmlDom.createElement("list");
		oList.setText(nRate);
		oList.setAttribute("ID", sID);
		xmlHistory.appendChild(oList);
	}
	ownList.saveXml();
}

function deleteHistoryItem(treeItem)
{
	var sItemID = treeItem.getData("ID");
	var xml = treeItem.getData("xml");	
	historyTree.removeItem(sItemID);
	historyTree.getCtrl().setFocus();
	var xmlHistory = ownList.xmlHistory;
	if(!xmlHistory)
		return;
	var historyList = xmlHistory.getChildNodes();
	for(var i=0; i<historyList.length; i++)
	{		
		var oList = historyList[i];
		if(sItemID==oList.getAttribute("ID"))
		{
			xmlHistory.removeChild(oList);
		}
	}
	ownList.saveXml();
}

function clearHistory()
{
	historyTree.removeAll();
	var xmlHistory = ownList.xmlHistory;
	if(!xmlHistory)
		return;	
	var historyList = xmlHistory.getChildNodes();
	for(var i=0; i<historyList.length; i++)
	{		
		var oList = historyList[i];
		xmlHistory.removeChild(oList);		
	}
	ownList.saveXml();
}

function closeHistory()
{
	GRHISTORY.setVisible(false);
	sash.setWeights(new Array(100, 0));
	setPar("OWNLIST_SHOW_HISTORY", false);
}
