include ("Objects/DpXMLDomDocument.js");
include ("Objects/DpObject.js");
include ("AttrToObj.js");
include ("sys/udfs.js");

function DpPrik(sPrikLbl,nVidPrk, list)
{
	derive(this, DpObject);
	this.list = list;
	var k = sPrikLbl.indexOf(":");//обрабатываем приказы из модулей
	this.sClassId = sPrikLbl;
	this.sPrikLbl = String(k==-1?sPrikLbl:sPrikLbl.substr(k+1)).toUpperCase();
	this.moduleName = (k==-1?null:sPrikLbl.substr(0,k).toLowerCase());
	this.nVidPrk = nVidPrk;
	//this.sPrikEdit = sPrikEdit;
	this.prikList = null;
	this.tblName = null;
	this.getPrikList = DpPrik_getPrikList;	
	this.create = DpPrik_create;
	this.toArchive = DpPrik_toArchive;
	this.fromArchive = DpPrik_fromArchive;
	this.loadByID = DpPrik_loadByID;
	this.clear = DpPrik_clear;
	this.save = DpPrik_save;
	this.clone = DpPrik_clone;
	this.del = DpPrik_del;
	this.edit = DpPrik_edit;
	this.getExtInfo = DpPrik_getExtInfo;//заглушка
	this.getAction = DpPrikList_getAction;
	this.create();
	
	if(this.moduleName)
		this.editXML = this.moduleName + ":prik/"+ this.sPrikLbl +"/form2.xml";
	else
		this.editXML = "prik/"+ this.sPrikLbl +"/form2.xml";
	var xmlPrik = new DpXMLDOMDocument();
	if(this.moduleName)
		var pathPrikXML = lpProxy.getModulePath(this.moduleName) + "/scripts/prik/"+ this.sPrikLbl +"/prik.xml";
	else
		var pathPrikXML = rootDirectory() + "prik/"+ this.sPrikLbl +"/prik.xml";
	if (xmlPrik.load(pathPrikXML))
	{
		var xmlEl = xmlPrik.getDocumentElement();
		var xmlNode = xmlEl.selectSingleNode("form2");
		if (xmlNode != null)
		{
			if(this.moduleName)
				this.editXML = lpProxy.getModulePath(this.moduleName) + "/scripts/prik/"+ xmlNode.getText() +"/form2.xml";
			else
				this.editXML = "prik/"+ xmlNode.getText() +"/form2.xml";
		}
		xmlNode = xmlEl.getElementsByTagName("global")[0];
		if (xmlNode != null)
			this.tblName = allt(xmlNode.getAttribute("tblname"));
	}
}

function DpPrik_create()
{
	this.jObj = lpProxy.createObject("prk." + this.sClassId);	
	this.jObj.setVar("FVID_PRK",this.nVidPrk);	
	include("objects/DpEval.js");
	var eval = new DpEval();
	this.jObj.setEvaluator(eval);
	this.param = null;
	this.bNew = true;
}

function DpPrik_del(nID,dTblDat)
{
	var objID = nID;
	if ((dTblDat?this.jObj.loadFromDB(Number(nID),dTblDat):this.jObj.loadFromDB(Number(nID))))
	{
    	objID = this.jObj.getObjectID();
   	 	this.nVidPrk = this.jObj.getVar("FVID_PRK");
   	}
   	else
   	{
   		this.jObj.setObjectID(nID);
   	}   	 	
	this.toArchive("DEL",objID);
	this.jObj.del();
	delObjFromDB(nID,this.jObj,null,dTblDat);
}

function DpPrik_loadByID(nID,bNoErr,bNoBlock,tagDat)
{
	this.clear();	
	if(this.nVidPrk)
		this.jObj.setVar("FVID_PRK",this.nVidPrk);	
	this.bNew = false;
	
	if(tagDat==null)
		isLoad = this.jObj.loadFromDB(Number(nID))
	else
		isLoad = this.jObj.loadFromDB(Number(nID),tagDat)
	if (!isLoad)
	{
		var archDat = null;
		
		var sSQL = "SELECT COUNT(*) cnt from ^archive WHERE FDOC = "
				+ sqlTo(this.sClassId) + " AND FID_DOC = " + Number(nID);
				
		var oSnap = getSnap(sSQL);
		if (!oSnap || oSnap[0] != 0)
		{
			var conf = msgBox("yn",UR("Не можу загрузити документ."
								+ "\nСпробувати підняти документ з архіву?|"
								+ "Не могу загрузить документ."
								+ "\nПопытаться поднять документ из истории?"),
								UR("Попередження.|Предупреждение."));
			if (conf == "n")
				return false;
			archDat = this.fromArchive(Number(nID));
		
		}
		
		if (archDat == null)
		{
			/*
			include("objects\\DpDocumentDecoder.js");
			var oDec = new DpDocumentDecoder();
			var oPar = new Object();
			oPar.doc = this.sPrikLbl;
			oPar.fiddoc = Number(nID);
			oPar.notRegister = true;
			//if (!oDec.runForCDR(this.sPrikLbl, oPar))
			oDec.runForPrik(this.sPrikLbl, oPar);
			var ret = this.jObj.loadFromXML(getOrgPath()
				   + "data/prik/" + this.sPrikLbl + "/" + String(parseInt(nID) + ".xml"));
			return ret;
			*/
			return false; 
		}
		else
		{
			var conf = msgBox("yn"
					,UR("Знайдено документ за |Найден документ за ")
					+ format("dd.mm.yyyy th:tm:ts", archDat) + "\n"
					+ UR("Продовжити?|Продолжить?"),
					UR("Редагування документу|Редактирование документа"));
			if (conf == "n")
				return false;
		}
	}
	return true;
}

function DpPrik_save(sMode,bNoErr,dTblDat)
{
	var isOk = this.jObj.storeToXML();
	if (!isOk)
	{
		if (bNoErr)
			return false;
		var conf = msgBox("ync"
						 ,UR("Не можу зберегти документ."
						 + "\nПомістити його до списку синхронізації?|"
						 + "Не могу сохранить документ."
						 + "\nПоместить его в список синхронизации?")
						 ,UR("Збереження|Сохранение"));
		if (conf == "c")
			return false;
		if (conf == "y")
		{
			include("objects\\DpSynchronizer.js");
			var oSync = new DpSynchronizer();
			oSync.putObjectForSynchronize(this.sPrikLbl,this.jObj.getObjectID());
		}
		this.toArchive(sMode);
	}
	else
	{
		this.toArchive(sMode);
	}
	var nVer = Number(this.jObj.getVar("HVER"));
	this.jObj.setVar("HVER",nVer + 1);
	if(allt(this.jObj.getVar("FIN_TABLE"))=="" && this.tblName)
	{
		var ind = this.tblName.indexOf("^");
		var tblName = ind!=-1?this.tblName.substr(ind+1):this.tblName;
		this.jObj.setVar("FIN_TABLE",tblName.toUpperCase());
	}
	obj2DB(this.jObj.getObjectID(),this.jObj,null,dTblDat);
	return true;
}

function DpPrik_clone()
{
	this.bNew = true;
	this.nOldID = this.getID();
	this.jObj = this.jObj.clone();
	var eval = new DpEval();
	this.jObj.setEvaluator(eval);	
}


function DpPrik_clear()
{
	this.bNew = true;
	if (this.jObj != null)
		this.jObj.Clear();
}

function DpPrik_getPrikList()
{
	if (this.prikList == null)
		this.prikList = new DpPrikList(this.sPrikLbl, this.nVidPrk, this.list, this.moduleName, this.sClassId);
	return this.prikList;
}



function DpPrikList(sPrikLbl, nVidPrk, list, moduleName, sClassId)
{
	this.list = list;
	this.sClassId = sClassId;
	if(moduleName)
		this.sPrikPath = lpProxy.getModulePath(moduleName) + "/scripts/prik/" + sPrikLbl;
	else
		this.sPrikPath = rootDirectory() + "prik/" + sPrikLbl;
	var xmlPrik = new DpXMLDOMDocument();
	this.setting = new Object();
	this.loadSetting = DpPrikList_loadSetting;
	if (xmlPrik.load(this.sPrikPath + "/prik.xml", false))
	{
		var xmlEl = xmlPrik.getDocumentElement();
		var xmlNode = xmlEl.selectSingleNode("listxml");
		if (xmlNode != null)
		{
			if(moduleName)
				this.listInfoFile = lpProxy.getModulePath(moduleName) + "/scripts/prik/" + xmlNode.getText() + "/list.xml";
			else
				this.listInfoFile = rootDirectory() + "prik/" + xmlNode.getText() + "/list.xml";
		}
		else
			this.listInfoFile = this.sPrikPath + "/list.xml";	
		xmlNode = xmlEl.selectSingleNode("listjs");
		if (xmlNode != null)
		{
			if(moduleName)
				this.sScriptFile = lpProxy.getModulePath(moduleName) + "/scripts/prik/" + xmlNode.getText() + "/list.js";
			else
				this.sScriptFile = rootDirectory() + "prik/" + xmlNode.getText() + "/list.js";	
		}
		else	
			this.sScriptFile = this.sPrikPath + "/list.js";
		this.loadSetting(xmlEl);
	}
	else
	{
		this.listInfoFile = this.sPrikPath + "/list.xml";
		this.sScriptFile = this.sPrikPath + "/list.js";
	}
	
	if (isFile(this.sScriptFile))
		include(this.sScriptFile);
			
	this.load = DpPrikList_load;
	this.buildQuery = DpPrikList_buildQuery;
	this.getCaption = DpPrikList_getCaption;
	this.subTie = DpPrikList_subTie;
	this.getGrid = DpPrikList_getGrid;
}


function DpPrikList_load()
{
	this.prikDataDir = getOrgPath() + "data/prik/" + this.sClassId.replace(':', '_');
	
	if(!isFile(this.prikDataDir))
	{
		createDirectory(this.prikDataDir)
	}
	
	var xmlDom = new DpXMLDOMDocument();
	if (xmlDom.load(this.listInfoFile, false))
	{	
		this.listInfo = xmlDom.getDocumentElement();
		return true;
	}
	return false;
}

function DpPrikList_buildQuery()
{
	var xmlq = this.listInfo.getElementsByTagName("query")[0];
	if (!xmlq)
		return false;
		
	var xmlfrom = xmlq.selectSingleNode("from");
	var sHTbl = xmlfrom.getText();
	var sFields = "*"; 
	xmlFields = xmlq.selectSingleNode("fields");
	if (xmlFields)
	{
		sFields = xmlFields.getText();
	}
	
	
	var sOrder = "FWID_WP, FBDAT, FEDAT"; 
	xmlOrder = xmlq.selectSingleNode("order");
	if (xmlOrder)
	{
		sOrder = xmlOrder.getText();
	}
	
	
	/*
	var sWhere = "FDOC = " + sqlTo(this.sPrikLbl);
	
	if (this.nNop)	
	{
		sWhere += " AND FNOP = " + this.nNop;
	}
		
	if (this.list.par.fid_doc)
	{
		sWhere += " AND FWID = " + this.list.par.fid_doc;
	}
	else
	{
	
		include ("objects\\DpGetDat.js");
		var gd = new DpGetDat("dD");
		if (gd.escape) return false;	
		
		
		sWhere += " AND FBDAT <= " +sqlTo(gd.dat1)
					+" AND FEDAT >= " +sqlTo(gd.dat2); 
	}
				
	
	this.list.qryFields = sFields;
	this.list.qrySet(
					"From", "^" + sHTbl,
					"Order", new Array(sOrder),
					"Where",sWhere
				);
	*/			
	return true;
	 
}

function DpPrikList_getCaption()
{
	return "Список співробітників по виду приказу|Список сотрудников по виду приказа";
}

function DpPrikList_subTie()
{
	
	var xmlTies = this.listInfo.getElementsByTagName("ties")[0];

	if(!xmlTies) return;

	var ties = xmlTies.getChildNodes();
	
	for(var i = 0; i < ties.length; i++)
	{
		var tie = ties[i];
		if (tie.getNodeName() == "cltie")
		{
			var sAlias = tie.getAttribute("alias");
			var sFields = tie.getAttribute("fields");
			var sVspAlias = tie.getAttribute("vspalias");
			if (sVspAlias)
			{
				this.list.clTie(sAlias, sFields, sVspAlias);
			}
			else
			{
				this.list.clTie(sAlias,sFields);
			}
			
		}
		
		if (tie.getNodeName() == "tie")
		{
			var sTable = tie.getAttribute("table");
			var sAlias = tie.getAttribute("alias");
			var sIndex = tie.getAttribute("index");
			var sFields = tie.getAttribute("fields");
			
			this.list.subTie(sTable,sAlias,sIndex,sFields);
		}
	}  
}

function DpPrikList_getGrid()
{
	var xmlGrid = this.listInfo.getElementsByTagName("grid")[0];
	var xmlDom = xmlGrid.getOwnerDocument();
	var xmlFirstEl = xmlGrid.getFirstChild();
	
	//если в ШР табельные номера ведутся в разрезе подразделений, то выводим в первой колонке табельный номер по подразделению  
	if (getPar("TABNORG"))
	{
		var xmlFldTabnOrgl = xmlDom.createElement("field");
		xmlFldTabnOrgl.setAttribute("text", "Таб.№\nпо підр.|Таб.№\nпо подр.");	
		xmlFldTabnOrgl.setAttribute("width", "5");
		xmlFldTabnOrgl.setAttribute("field", "=getTabnOrg(^Fwid_wp)");
		xmlFldTabnOrgl.setAttribute("format", "%10d");	
		xmlGrid.appendChild(xmlFldTabnOrgl);
		xmlGrid.insertBefore(xmlFldTabnOrgl,xmlFirstEl)
	}
	
	var xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Корист.|Польз.");	
	xmlFldAction.setAttribute("width", "7");
	xmlFldAction.setAttribute("field", "=DpPrikList_getAction('Fmuser')");	
	xmlGrid.appendChild(xmlFldAction);
	
	xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Дiя|Действ.");	
	xmlFldAction.setAttribute("width", "3");	
	xmlFldAction.setAttribute("field", "=DpPrikList_getAction('Fmaction')");	
	xmlGrid.appendChild(xmlFldAction);
	
	xmlFldAction = xmlDom.createElement("field");
	xmlFldAction.setAttribute("text", "Дата дії|Дата действ.");	
	xmlFldAction.setAttribute("width", "7");	
	xmlFldAction.setAttribute("field", "=DpPrikList_getAction('Fmdate')");	
	xmlGrid.appendChild(xmlFldAction);
	
	//при наличии параметра выводим в списке приказов код изделия
	if(getPar("PRIK_IZD"))
	{
		xmlFldAction = xmlDom.createElement("field");
		xmlFldAction.setAttribute("text", "Код виробу|Код изделия");	
		xmlFldAction.setAttribute("width", "7");	
		xmlFldAction.setAttribute("field", "Fkodizd");
		xmlFldAction.setAttribute("attr", "e");		
		xmlGrid.appendChild(xmlFldAction);
	}
	
	var xmlFldExt = xmlDom.createElement("extention");	
	xmlGrid.appendChild(xmlFldExt);
	if (this.nNop != 0)
	{
		xmlFldExt = xmlDom.createElement("extention");
		xmlFldExt.setAttribute("alias","ext0");
		xmlGrid.appendChild(xmlFldExt);
	}
	return xmlGrid;
}

function DpPrikList_loadSetting(xmlEl)
{	
	var xmlNode = xmlEl.selectSingleNode("setting");
	if (xmlNode == null)
		return;
	loadSetting(this.setting, xmlNode, new Array("global", "list", "form2"));
}

function DpPrik_toArchive(sMode,nID)
{
	if(bCreateArchive)
	{
		if (!sMode)
		{
			sMode = this.bNew?"ADD":"EDIT";
		}
		
		var m = new Object();
		m.FWID = GetNID();
		m.FDOC = this.sClassId;
		//в номер операции будем сохранять код приказа
		m.FNOP = this.jObj.getVar("FVID_PRK");
		m.FNUM = String(getCodFromID(this.jObj.getVar("FTABN_ID")));
		m.FDAT = this.jObj.getVar("FBDAT");
		m.FMACTION = sMode.charAt(0);
		m.FMDATE = (this.getVar("SYNC_DATE")
					?javaDate2Script(this.getVar("SYNC_DATE"),true)
					:new Date().getVarDate());
		m.FMUSER = (this.getVar("SYNC_USER")
					?this.getVar("SYNC_USER")
					:getUserName());
		m.FMHOST = (this.getVar("SYNC_HOST")
					?this.getVar("SYNC_HOST")
					:getHostName());
		m.FID_DOC = (nID?nID:this.jObj.getObjectID());
		m.FVER = this.jObj.getVar("HVER");
		
		var oDomDoc = this.jObj.toXML().getOwnerDocument();
		lpProxy.getDBManager().saveXMLToDB("^archive", "fdata", m.FWID, oDomDoc);
		updateTable("^archive", m, false,"",true,false);
		/*
		updateTable("^archive", m, true,"",true);
		var archDir = getOrgPath() + "archive/" + this.sClassId.replace(':', '_') + "/" + parseInt(this.nVidPrk);
		createDirectory(archDir);
		this.jObj.storeToXML(archDir + "/" + m.FWID + ".xml");
		*/
	}
}

function DpPrik_fromArchive(nID, nIDArch)
{
	var oSnap = getSnap("SELECT FWID,FMDATE,FNOP FROM ^archive"
					  + " WHERE FID_DOC=" + sqlTo(nID)
					  + " AND FDOC=" + sqlTo(this.sPrikLbl)
					  + (nIDArch? (" AND FWID = " + nIDArch):"")
					  + " ORDER BY FMDATE DESC");
	if (oSnap == null)
		return null;
	var fwid = oSnap[0];
	var fnop = Number(oSnap[2]);
	
	var isLoaded= false;	
	var oDomDoc = lpProxy.getDBManager().getXMLFromDB("^archive", "fdata", fwid);
	if (oDomDoc)
	{
		isLoaded = this.jObj.fromXML(oDomDoc.getDocumentElement());   
	}
	
	if(!isLoaded)
	{
		var archDir = getOrgPath() + "archive/" + this.sClassId.replace(':', '_') + "/" + fnop;
		if (!this.jObj.loadFromXML(archDir + "/" + fwid + ".xml"))
		{
			return null;
		}
	}
	
	this.nVidPrk = fnop;
	return javaDate2Script(oSnap[1],true);	
}

function DpPrik_edit(sMode, nID, par, tbl)
{
	CallEditTask(this.editXML, par, tbl);
}

function DpPrik_getExtInfo()
{
	return;
}

function DpPrikList_getAction(action)
{
	if (this.list.dataSrc.getTable().getValue("Fwid") == null)
		return "";
	if (SUBD == MSSQL)
	{
		var tbl = OpenTable("EXEC "+ getPath("ALL_MDB") + "..GET_DOC_HISTORY " 
			+ sqlTo(this.list.dataSrc.getTable().getValue("Fwid")));
		if (!tbl.isEmpty())
		{
			return toScrObj(tbl.getValue(action));
		}
		return "";	
	}
	
	var oSnap = getSnap("SELECT " + action + " FROM ^archive WHERE fid_doc=" 
		+ sqlTo(this.list.dataSrc.getTable().getValue("Fwid"))
		+ " ORDER BY FMDATE DESC");
	if (oSnap != null)
		return oSnap[0]
	else
		return "";
}