include("Objects/DpGetDat.js");
include("doc/DpDoc.js");
include("servis/date.js");
include("prik/DpPrik.js");
include("Objects\\DpTVars.js");
include("transf:Objects/DpTransfer.js");

var avnsTblName = "";
var strSelectID = "";
var tbl = null;
var bdat;
var edat;
var zero = false;
var arrResult = new Array();
var sDir = rootDirectory() + "prik/_AVNS/";
var podrValue = 0;
var selectID = 0;
var tblAvns = null;
var leftkey = 0;
var rightkey = 0;
var zrp_mnu_proc;

function onLoad()
{
	var gd = new DpGetDat("d");
	if (gd.escape == true)
		return false;	
	bdat = new Date(firstDayMonth(gd.dat1));
	if (!existsAvnsTable(bdat))
	{
		alert(UR("Розрахуйте аванс на |Рассчитайте аванс на ") + StrDat(bdat, "MY"));
		return false;
	}
	Caption(UR(extPar.fnazv)+" за " + StrDat(bdat, "MY"));	
	edat = new Date(lastDayMonth(bdat));		
	
	/*Tree.setItemImage(ICON_MAN, rootDirectoryEx() + "/icons/men.gif");
	Tree.setItemImage(ICON_WOMAN, rootDirectoryEx() + "/icons/women.gif");
	Tree.addColumn("txts",UR("ПІБ|ФИО"),300);
	Tree.addColumn("sum",UR("Сума|Сумма"),110);
	Tree.addColumn("proc",UR("% перерах.|% переч."),110);
	this.onTreeSelectMenuHandler = onTreeSelectMenuHandler;
	this.onTreeMenuInit = onTreeMenuInit;
	this.onTreeSelected = onTreeSelected;
	this.canEditTree = new Function("return false");
	Tree.selectMenuHandler(this, "onTreeSelectMenuHandler");
	Tree.loadMenuHandler(this, "onTreeMenuInit");
	Tree.setTreeSelHandler(this, "onTreeSelected");		
	Tree.setCanEditHandler(this, "canEditTree");
	fillTree();*/
	
	if(!fillPodr())
		return false;
	this.onSelTreeItem = onSelTreeItem;
	Tree.setTreeSelHandler(this, "onSelTreeItem");
	Tree.setSelected(selectID);
	if(!loadGrid())
		return false;
	podr_valid();
}

function onSelTreeItem(sID)
{
	selectID = parseInt(sID);
	var treeItem = Tree.getItem(sID);
	rightkey = leftkey = -1;
	if (treeItem != null)
	{
		leftkey = treeItem.getData("LEFTKEY");
		rightkey = treeItem.getData("RIGHTKEY");
	}
	podr_valid();		
}

function loadGrid()
{
	//tblAvns = OpenTable("m", "SELECT * FROM "+avnsTblName+" ORDER BY Ftabn_id");
	var ret = fillGrid();
	if (ret == false)
	{
		alert(ru("Невозможно просмотреть список приказов по авансам!\nВозможно список уже открыт на просмотр.",
				"Неможлива переглянути список наказів по авансам!\nМожливо список вже відкритий."));
		return false;
	}
	avnsGrid.setXMLDir(sDir);
	avnsGrid.setXMLFile("avnsGrid.xml");
	avnsGrid.setTable(tblAvns);
	avnsGrid.build();
	this.grid_MenuInit = grid_MenuInit;
	this.grid_MenuHandler = grid_MenuHandler;
	avnsGrid.loadMenuHandler(this, "grid_MenuInit");	
	avnsGrid.selectMenuHandler(this, "grid_MenuHandler");
	return true;
}

function podr_valid()
{
	if(podrValue != 0)
		arrResult[podrValue] = avnsGrid.getSelectedIDs();
	
	if (selectID != podrValue)
	{
		podrValue = selectID;
		fillGrid();
		avnsGrid.setTable(tblAvns);
		avnsGrid.build();	
		if (arrResult[podrValue] != null && arrResult[podrValue].length != 0)
			avnsGrid.setSelectedIDs(arrResult[podrValue], podrValue);		
		avnsGrid.refresh();
	}
}

function fillGrid()
{
	if(null!=tblAvns)
	{
		tblAvns.Close();
	}
	var cldol = getPar("CODDOL");
	var ret = DropTable("AVANS");
	if (!ret)
		return false;
		/*
	var strSQL = "SELECT rel.Fcod, pa.*, av.Fprocp, av.Fprocokl, c.Fnum AS Fnumb, cl.Ftxt"
				+ " INTO AVANS FROM ((((((^work_pers AS w INNER JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid)"
					+ " RIGHT JOIN ^prk_all AS pa ON w.fwid=pa.fwid_wp)"
					+ " INNER JOIN " + avnsTblName + " AS av ON av.Fwid = pa.Fwid "
					+ " INNER JOIN ^clrelclcl AS rel_dol ON d.fcod=rel_dol.fcod)"
					//+ " INNER JOIN ^cl AS cl_dol ON cl_dol.fwid=rel_dol.fwid_cl)"
					+ " LEFT JOIN ^stru_org AS org ON d.fwid_org=org.fwid)"
					+ " INNER JOIN ^clrelclcl AS rel ON rel.Fwid_cl=w.Fwid_cl)"
					+ " INNER JOIN ^cl AS cl ON cl.Fwid=rel.Fwid_cl)"
					+ " LEFT JOIN (^prk_all AS p INNER JOIN ^prk_c_pr as c ON p.Fwid=c.Fwid) ON p.Ftabn_id=pa.Ftabn_id"
				+ " WHERE "
					//+ " ((w.fbdat<=" + sqlTo(bdat) + " AND w.fedat>=" + sqlTo(edat) + ")"
					//+ " OR (w.fbdat>=" + sqlTo(bdat) + " AND w.fbdat<=" + sqlTo(edat) + ")"
					//+ " OR (w.fedat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + "))"
					+ " (d.fwid_org = " + sqlTo(podrValue)
					+ " OR (org.fleftkey BETWEEN " + sqlTo(leftkey)
						+ " AND " + sqlTo(rightkey) + ") AND org.fwid<>0 ) "					
					+ " AND rel_dol.fcl=" + sqlTo(cldol)
					+ " AND p.Fedat>="+sqlTo(bdat)+" AND p.Fbdat<="+sqlTo(edat)
			*/
	//15.12.07
	//Предыдущий просмотр аванса закомментарила. Получалось, если нет приказов
	//на процентную сберкассу, то аванс вообще не просматривался. Это неправильно,
	// т.к. приказ на сберкассу бывает не всегда. 
	DropTable("VRCAS")
	strSQL = "select p.*,c.Fnum as Fnumb into VRCAS from ^prk_all AS p INNER JOIN ^prk_c_pr as c ON p.Fwid=c.Fwid where p.Fedat>="+sqlTo(bdat)+" AND p.Fbdat<="+sqlTo(edat)
	ExecuteSQL(strSQL);

	var strSQL = "SELECT rel.Fcod, pa.*, av.Fprocp, av.Fprocokl, p.Fnumb, cl.Ftxt, w.Fvopl as Fvidopl,cld.Ftxt as Ftxtdol"
				+ " INTO AVANS FROM ((((((^work_pers AS w INNER JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid)"
					+ " RIGHT JOIN ^prk_all AS pa ON w.fwid=pa.fwid_wp)"
					+ " INNER JOIN " + avnsTblName + " AS av ON av.Fwid = pa.Fwid "
					+ " INNER JOIN ^clrelclcl AS rel_dol ON d.fcod=rel_dol.fcod)"
					//+ " INNER JOIN ^cl AS cl_dol ON cl_dol.fwid=rel_dol.fwid_cl)"
					+ " LEFT JOIN ^stru_org AS org ON d.fwid_org=org.fwid)"
					+ " INNER JOIN ^clrelclcl AS rel ON rel.Fwid_cl=w.Fwid_cl)"
					+ " INNER JOIN ^cl AS cl ON cl.Fwid=rel.Fwid_cl)"
					+ " LEFT JOIN VRCAS as p ON p.Ftabn_id=pa.Ftabn_id "
					+ " INNER JOIN ^stru_dol as sd ON sd.Fwid=w.Fwid_dol "
					+ " INNER JOIN ^cl AS cld ON cld.Fwid=sd.Fwid_cl "
				+ " WHERE "
					//+ " ((w.fbdat<=" + sqlTo(bdat) + " AND w.fedat>=" + sqlTo(edat) + ")"
					//+ " OR (w.fbdat>=" + sqlTo(bdat) + " AND w.fbdat<=" + sqlTo(edat) + ")"
					//+ " OR (w.fedat>=" + sqlTo(bdat) + " AND w.fedat<=" + sqlTo(edat) + "))"
					+ " pa.Fvid_prk="+extPar.fvid
					+ " AND (d.fwid_org = " + sqlTo(podrValue)
					+ " OR (org.fleftkey BETWEEN " + sqlTo(leftkey)
						+ " AND " + sqlTo(rightkey) + ") AND org.fwid<>0 ) "					
					+ " AND rel_dol.fcl=" + sqlTo(cldol)
					//+ " AND p.Fedat>="+sqlTo(bdat)+" AND p.Fbdat<="+sqlTo(edat)
					//+ " AND pa.fedat=" + sqlTo(bdat);
				//+ " GROUP BY w.fwid";
	ExecuteSQL(strSQL);
	tblAvns = OpenTable("select * from AVANS order by Fcod, Fbdat, Fedat");
	tblAvns.tie("work_pers", "wp", "Fwid", "Fwid_wp");
	tblAvns.tie("cl", "cl", "Fwid", "wp.Fwid_cl");
	tblAvns.tie("clrelclcl", "rel", "Fwid_cl", "wp.Fwid_cl");
	//tblAvns.tie("prk_c_pr","pr","Ftabn_id","Ftabn_id");
}

function fillPodr()
{
	var result = false;
	var strSQL = "SELECT fwid,fwid_par,ftxts,fleftkey,frightkey from ^stru_org where "
					+ "(fbdat<=" + sqlTo(bdat) + " AND fedat>=" + sqlTo(edat) + ")"
					+ " OR (fbdat>=" + sqlTo(bdat) + " AND fbdat<=" + sqlTo(edat) + ")"
					+ " OR (fedat>=" + sqlTo(bdat) + " AND fedat<=" + sqlTo(edat) + ")"
					+ " ORDER BY FLEFTKEY";
	var tblPodr = OpenTable("s", strSQL);
	var parent;
	var nodeID;
	if(!tblPodr.isEmpty())
	{
		Tree.removeAll();
		for(tblPodr.MoveFirst(); !tblPodr.isEOF(); tblPodr.MoveNext())
		{
			parent = String(tblPodr.getValue("fwid_par"));
			nodeID = String(tblPodr.getValue("fwid"));
			Tree.expand(parent);			
			Tree.addItem(parent, nodeID, (tblPodr.getValue("ftxts") != null ? tblPodr.getValue("ftxts") : ""));
			var treeItem = Tree.getItem(nodeID);
			treeItem.setData("LEFTKEY", tblPodr.getValue("fleftkey"));
			treeItem.setData("RIGHTKEY", tblPodr.getValue("frightkey"));
			if (parent == null || parent == 0)
			{
				leftkey = treeItem.getData("LEFTKEY");
				rightkey = treeItem.getData("RIGHTKEY");
			}
		}
		
		result = true;
	}
	tblPodr.Close();
	return result;
}

function onUnLoad()
{
	if (tbl != null)
		tbl.close();
}

function onExit()
{
	if(null!=tblAvns)
		tblAvns.Close();
}

function onTreeSelectMenuHandler(sID, toObject)
{
/*	switch (sID)
	{
		case "DOUBLECLICK":			
			Tree.reExpand(Tree.getSelected());
			break;
		case "ADD":
		case "EDIT":
		case "COPY":
			var isLast = isLastItem(Tree.getSelected());
			if (sID != "ADD" && !isLast)
				return;
			var selectID = Tree.getSelected();
			var parentID = (Tree.getParentCod() == null ? 0 : Tree.getParentCod());			
			var changeID = (isLast ? parentID : selectID);
			var editForm = "prik/" + extPar.edit + "/";			
			var multiCase = (!isLast && Tree.getData(changeID, "fwid_wp") == null);
			
			var par = new Object();
			par.mode = sID;
			par.dat1 = bdat;
			par.dat2 = edat;
			
			if (!multiCase && sID != "COPY")
			{
				par.txt = Tree.getValue(changeID, "txts");
				par.sum =  Number(Tree.getValue(selectID, "sum"));
				par.proc =  Number(Tree.getValue(selectID, "proc"));
				editForm += "singleCase.xml";
			}
			else if (parentID == 0 || sID == "COPY")
			{
				if (sID == "COPY")
				{
					par.sum =  Number(Tree.getValue(selectID, "sum"));
					par.proc =  Number(Tree.getValue(selectID, "proc"));
				}
				editForm += "multiCaseAll.xml";
			}
			else			
				//editForm += "multiCase.xml";
				editForm += "multiCaseAll.xml";
				
			par.escape = true;
						
			showWindow(editForm, SW_MODAL, par);
			
			if (!par.escape)
			{
				var m = new  Object();
				if (!multiCase)
					m.FWID_WP = Tree.getData(changeID, "fwid_wp");
				else
					m.FWID_WP = par.fwid_wp;								
				if (sID != "EDIT")
				{
					m.FWID = GetUID();
					m.FIS_MAVANS = false; //par.isMain;
				}
				else
				{				
					m.FWID = Number(selectID);
					m.FIS_MAVANS = Tree.getData(selectID, "isMainAvans");	
				}
				var spArr = getSumProcAvansL(par.sum, par.proc, getOklad(m.FWID_WP));
				m.FSUM = spArr["sum"];	
				m.FPROCP = spArr["proc"];
				if (!zero && m.FSUM == 0)
				{
					if (sID == "EDIT")
					{
						ExecuteSQL("DELETE FROM " + avnsTblName + " WHERE fwid = " + sqlTo(Number(selectID)));
						Tree.removeItem(selectID);
					}
					else
						changeID = getChangeID(m.FWID_WP);
				}
				else
				{				
					m.FVID_PRK = extPar.fvid;	
					m.FBDAT = bdat;
					m.FEDAT = edat;	
					UpdateTable(avnsTblName, m, sID != "EDIT");
					
					if (sID != "EDIT")
					{
						selectID = GetUID();
						changeID = getChangeID(m.FWID_WP);
						Tree.addItem(changeID, selectID, LAST_ITEM_NAME, 3);
						Tree.setData(selectID, "isMainAvans", m.FIS_MAVANS);
						Tree.setItemColor(selectID, 0);
					}
					
					setTreeItemValue(selectID, spArr);	
				}				

				setTreeItemValue(changeID, getFullSumProcAvans(changeID));			
				
				if (sID == "EDIT" && Tree.getData(selectID, "isMainAvans"))
				{					
					ExecuteSQL("UPDATE ^work_pers SET favans = " + sqlTo(spArr["sum"])
							+ " WHERE fwid = " + sqlTo(m.FWID_WP));	
				}
				tbl.requery();
			}
			break;	
		case "DEL":
			if (strSelectID == "")
				return;
			if ("-" == msgBox("c-"
				, UR("Підтвердіть вилучення запису|Подтвердите удаление записи")
				, UR("Вилучення запису|Удаление записи")))
			{
				var selectID = Tree.getSelected();
				var parentID = Tree.getParentCod();
				var strSQL = "";
				if (Tree.getData(selectID, "isMainAvans") == true && zero)
					strSQL = "UPDATE " + avnsTblName + " SET fsum = 0 WHERE fwid = ";
				else
					strSQL = "DELETE FROM " + avnsTblName + " WHERE fwid = ";
				var modify = ExecuteSQL(strSQL + sqlTo(Number(selectID)));
				if (modify)
				{
					if (Tree.getData(selectID, "isMainAvans") == true)
					{
						ExecuteSQL("UPDATE ^work_pers SET favans = 0 WHERE fwid = "
												+ sqlTo(Tree.getData(parentID, "fwid_wp")));						
					}
					if (Tree.getData(selectID, "isMainAvans") == true && zero)
						setTreeItemValue(selectID, getSumProcAvansL(0, 0, 0));
					else
						Tree.removeItem(selectID);
					setTreeItemValue(parentID, getFullSumProcAvans(parentID));
					tbl.requery();
				}
				else
					alert(UR("Помилка при видаленні(модифікуванні) запису з таблиці поточних авансів!|"
								+ "Ошибка при удалении(модифицировании) записи из таблицы текущих авансов!"), ICON_ERROR);
			}
			break;
			
	}*/
}

/*function modifyTables(fwid_wp, isMain)
{

}

function onTreeMenuInit(toObject)
{
	toObject.AddMenuItem("ADD","Додати|Добавить");
	if (strSelectID != "")
	{
		toObject.AddMenuItem("EDIT","Редагувати|Редактировать");
		toObject.AddMenuItem("COPY","Копіювати|Копировать");
		toObject.AddMenuItem("DEL","Вилучити|Удалить");
	}
}

function onTreeSelected(sCod, sMode)
{
	if (!isLastItem(sCod))
		strSelectID = "";
	else
		strSelectID = sCod;
}

function fillTree()
{
	if (tbl == null)
	{
		var strSQL = "SELECT " + IIF("d.fcod<>0", sqlTrue, sqlFalse) + " AS fisdol"
				+ ", " + IIF("d.fcod<>0","d.fwid", "o.fwid") + " AS fwid"				
				+ ", " + IIF("d.fcod<>0","d.fwid_org", "o.fwid_par") + " AS fwid_par"
				+ ", wp.fwid AS fwid_wp"
				+ ", o.ftxt AS ftxts"
				+ ", homo.fsex AS fsex"
				+ ", cl.ftxt AS fhtxt"
				+ ", avns.fsum AS fsum"
				+ ", avns.fprocp AS fproc"
				+ ", avns.fis_mavans AS fis_mavans"
				+ ", avns.fwid AS avns_fwid"
				+ ", avns.fzero AS fzero"
				+ ", d.foklad AS foklad"
				+ " FROM ^stru_org AS o LEFT JOIN"
					+ " (^stru_dol AS d LEFT JOIN"
					+ " ((^work_pers AS wp LEFT JOIN ^cl AS cl ON wp.fwid_cl = cl.fwid" 
					+ " LEFT JOIN ^cl_homo AS homo ON wp.fwid_cl = homo.fwid_cl)"
					+ " LEFT JOIN " + avnsTblName + " AS avns ON wp.fwid = avns.fwid_wp)"
					+ " ON d.fwid = wp.fwid_dol)"
					+ " ON o.FWID = d.FWID_ORG"
				+ " WHERE (d.fcod=0 AND ((o.fbdat<=" + sqlTo(bdat) + " AND o.fedat>=" + sqlTo(edat) + ")"
					+ " OR (o.fbdat>=" + sqlTo(bdat) + " AND o.fbdat<=" + sqlTo(edat) + ")"
					+ " OR (o.fedat>=" + sqlTo(bdat) + " AND o.fedat<=" + sqlTo(edat) + ")))"
					+ " OR (d.fcod<>0 AND ((d.fbdat<=" + sqlTo(bdat) + " AND d.fedat>=" + sqlTo(edat) + ")"
					+ " OR (d.fbdat>=" + sqlTo(bdat) + " AND d.fbdat<=" + sqlTo(edat) + ")"
					+ " OR (d.fedat>=" + sqlTo(bdat) + " AND d.fedat<=" + sqlTo(edat) + ")))"
					+ " AND ((wp.fbdat<=" + sqlTo(bdat) + " AND wp.fedat>=" + sqlTo(edat) + ")"
					+ " OR (wp.fbdat>=" + sqlTo(bdat) + " AND wp.fbdat<=" + sqlTo(edat) + ")"
					+ " OR (wp.fedat>=" + sqlTo(bdat) + " AND wp.fedat<=" + sqlTo(edat) + "))" 
				+ " ORDER BY d.fcod, fwid, fwid_par, avns.fis_mavans DESC, avns.fsum DESC";
		tbl = OpenTable("m", strSQL);
		if (tbl.isEmpty())
			return false;	
	}

	Tree.removeAll();
	
	var parent = null;
	var nodeID = null;
	var lastNodeID = null;
	var mainElement = null;
	var sum = 0;
	var useZero = false;
	
	for (tbl.MoveFirst(); !tbl.IsEOF(); tbl.MoveNext())
	{
		parent = String(tbl.getValue("fwid_par"));
		nodeID = String(tbl.getValue("fwid"));
		
		if (tbl.getValue("fisdol") == false)
		{
			Tree.addItem(parent, nodeID, tbl.getValue("ftxts"));			
			if (parent == 0)
				mainElement = nodeID;
		}
		else
		{
			if (lastNodeID == null || lastNodeID != nodeID)
			{
				if (lastNodeID != null)
					setTreeItemValue(lastNodeID, getFullSumProcAvans(lastNodeID));
				if (tbl.getValue("fsex") == true)
					Tree.addItem(parent, nodeID, tbl.getValue("fhtxt"), ICON_MAN);
				else
					Tree.addItem(parent, nodeID, tbl.getValue("fhtxt"), ICON_WOMAN);
				Tree.setData(nodeID, "fwid_wp", tbl.getValue("fwid_wp"));
				arrFWID_WP[tbl.getValue("fwid_wp")] = nodeID;
				sum = 0;
			}			
			var id = tbl.getValue("avns_fwid");
			if (id != null)	
			{	
				var isMainAvans = tbl.getValue("fis_mavans") == true;
				Tree.addItem(nodeID, id, (isMainAvans ? LAST_ITEM_MNAME : LAST_ITEM_NAME), 3);
				Tree.setData(id, "isMainAvans", isMainAvans);
				var arrSP = getSumProcAvansT(tbl);
				setTreeItemValue(id, arrSP);
				Tree.setItemColor(id, 0);
				if (!useZero)
				{
					zero = (tbl.getValue("fzero") == true);
					useZero = true;
				}			
			}
			lastNodeID = nodeID;
		}
	}
	if (lastNodeID != null)
	{
		tbl.MoveLast();
		if (tbl.getValue("fisdol") == true)
			setTreeItemValue(lastNodeID, getFullSumProcAvans(lastNodeID));
	}
	Tree.expandAll();
	if (mainElement != null)
		Tree.setSelected(mainElement);
}*/

function setTreeItemValue(sID, arr)
{
	if (typeof arr != "object")
		return;
	for (var i in arr)
		Tree.setValue(sID, String(i), arr[i]);	
}

function existsAvnsTable(dat)
{
	avnsTblName = getTableNameByDate("avns", dat);
	var tblFullName =  "zrp_" + avnsTblName;
	avnsTblName = "^" + avnsTblName;
	return IsTableEx(getPath("zrp_mdb"), tblFullName);	
}

function grid_MenuInit(toObject)
{
	toObject.AddMenuItem("ADD", "Додати|Добавить");
	if(!tblAvns.isEmpty())
	{
		toObject.AddMenuItem("COPY", "Копіювати|Копировать");
		toObject.AddMenuItem("EDIT", "Редагувати|Редактировать");
		toObject.AddMenuItem("DEL","Вилучити|Удалить");
		toObject.AddMenuItem("PRNLIST","Друк|Печать");
		
		toObject.AddMenuItem("PRSBAV","Перегляд сум утримань авансу|Просмотр сумм удержаний аванса");
		toObject.AddMenuItem("ESUM","Проставити суму авансу|Проставить сумму аванса");
		toObject.AddMenuItem("EPROC","Проставити % від окладу з урахуванням коефіцієнта|Проставить % от оклада с учетом коэффициента");
		toObject.AddMenuItem("+++","Проставити % від полів ОР|Проставить % от полей ЛС");
		toObject.AddMenuItem("SETBYLS","Проставити %|Проставить %");
		toObject.AddMenuItem("LSSETTINGS","Налагодження полів ОР|Настройка полей ЛС");
		toObject.AddMenuItem("---","");
		//toObject.AddMenuItem("AVAN_SK","Однаковий аванс для відміч. людей|Одинак. аванс для отмеч. людей");
		toObject.AddMenuItem("SBKA","Експорт перечислень|Экспорт перечислений");
		toObject.AddMenuItem("VIEW_TRANSF", "Перегляд сум перерахувань|Просмотр сум перечислений");
		toObject.AddMenuItem("","");
		//округление добавлено в общий пункт простановки процента от оклада
		//toObject.AddMenuItem("PROCOKL","Проставити % вiд окладу для ЧТГ|Проставить % от оклада для ЧТГ");
		toObject.AddMenuItem("","");
		toObject.AddMenuItem("+++","Експорт|Экспорт");
		toObject.AddMenuItem("EXPORTCALC","Calc");
		toObject.AddMenuItem("EXPORTXLS","Формат xls");
		toObject.AddMenuItem("---","");
		if (getPar("is_debug"))
		{
			toObject.AddMenuItem("DEBUG_BROWSE","BROWSE");
		}
		toObject.AddMenuItem("","");
		//для Брокарда
		toObject.AddMenuItem("SBKXLS", ru("Экспорт перечислений в Excel","Експорт перерахуваннь в Excel")+" (Брокард)");
		toObject.AddMenuItem("SBKDBF2", ru("Экспорт перечислений в DBF Новый","Експорт перерахуваннь в DBF Новий")+" (Брокард)");
		toObject.AddMenuItem("SBKDBF", ru("Экспорт перечислений в DBF","Експорт перерахуваннь в DBF")+" (Брокард)");
		toObject.AddMenuItem("EXPTEL","Експорт перечислень (Укртелеком)|Экспорт перечислений (Укртелеком)");
	}
}

function grid_MenuHandler(ID, toObject)
{
	switch(ID)
	{
		case "ADD":
		case "COPY":
		case "EDIT":
			var editForm = "prik/" + extPar.edit + "/form2.xml";
			if(ID=="EDIT")
				var nRow = tblAvns.absolute;
			var par = new Object();
			par.mode = ID;
			par.dat1 = bdat;
			par.dat2 = edat;
			par.fvid = extPar.fvid;
			par.tbl = toObject.getTable();
			//par.m_pTable = toObject.getTable();
			par.priklbl = extPar.priklbl;
			par.tblName = getTableNameByDate("AVNS", bdat);
			par.escape = true;
			showWindow(editForm, SW_MODAL, par);
			if (!par.escape)
			{
				fillGrid();
				avnsGrid.setTable(tblAvns);
				tblAvns.requery();
				if(ID=="EDIT")
					tblAvns.absolute = nRow;
				avnsGrid.build();
			}
		break;
		case "DEL":
			if ("-" == msgBox("c-"
				, UR("Підтвердіть вилучення запису|Подтвердите удаление записи")
				, UR("Вилучення запису|Удаление записи")))
			{
				ExecuteSQL("DELETE FROM ^prk_all WHERE Fwid="+sqlTo(tblAvns.getValue("Fwid")))
				ExecuteSQL("DELETE FROM "+avnsTblName+" WHERE Fwid="+sqlTo(tblAvns.getValue("Fwid")))
				fillGrid();
				avnsGrid.setTable(tblAvns);
				tblAvns.requery();
				avnsGrid.build();
			}
		break;
		case "__XDEL":
			var delCount = avnsGrid.getSelectedCount();
			if (delCount <= 0)
				return true;
			if ("-" == msgBox("c-",UR("Підтвердіть вилучення записів "
				+ "| Подтвердите удаление записей ") + delCount, UR("Видалення|Удаление")))
			{
				ExecuteSQL("DELETE FROM ^prk_all WHERE "+avnsGrid.sqlSelected())
				ExecuteSQL("DELETE FROM "+avnsTblName+" WHERE "+avnsGrid.sqlSelected())
				fillGrid();
				avnsGrid.setTable(tblAvns);
				tblAvns.requery();
				avnsGrid.build();
			}
		break;
		case "PRNLIST":
			var obj = new Object();
			obj.FBDAT = firstDay(bdat);
			obj.FEDAT = lastDay(bdat);
			obj.FNOMPL = input("Введите номер платежной ведомости", "Дебет Плюс", 0, 6);
			if(obj.FNOMPL==null)
				return false;
			obj.FBDATCAS = input("Введите дату начала выплаты", "Дебет Плюс", d00);
			if(obj.FBDATCAS==null)
				return false;
			obj.FEDATCAS = input("Введите дату конца выплаты", "Дебет Плюс", d00);
			if(obj.FEDATCAS==null)
				return false;
			var oSnap = getSnap("SELECT Ftxts FROM ^stru_org WHERE Fwid_par=0");
			if(oSnap!=null)
				obj.FTORG = oSnap[0];
			else
				obj.FTORG = " ";
			oSnap = getSnap("SELECT Ftxts FROM ^stru_org WHERE Fwid="+sqlTo(podrValue))
			if(oSnap!=null)
				obj.FTPODR = oSnap[0];
			else
				obj.FTPODR = " ";
			var tv = new DpTVars("AVNS");
			tv.setHTbl(obj);
			tv.setRTbl(tblAvns);
			tv.print();
		break;
		case "SBKA":
			DropTable("TMP_AVN");
			CreateTable("TMP_AVN", "AVNS", "*");
			//ExecuteSQL("SELECT * INTO TMP_AVN FROM AVANS")
			/*ExecuteSQL("INSERT INTO TMP_AVN ("+ GetPatternIntersection("AVNS","AVNS")
						+") SELECT"+ GetPatternIntersection("AVNS","AVNS")
						+"  FROM "+FileName+" WHERE "+this.DataSrc.sqlSelected(false));*/
			showWindow("l_clexpn.js", SW_NOMODAL);
		break;
		case "ESUM":
			var pokl = 0;
			pokl = input(ru("Сумма","Сума"),null, pokl, 5, 2);
			if(pokl == null)
				return;

			var t = OpenTable("s","SELECT Fwid, Fwid_wp FROM ^prk_all WHERE "+avnsGrid.sqlSelected())
			if(!t.isEmpty())
			{
				var oPrik = new DpPrik(extPar.priklbl, extPar.fvid);
				for (t.MoveFirst(); !t.IsEOF(); t.MoveNext())
				{
					oPrik.clear();
					oPrik.loadByID(t.getValue("Fwid"),null,null,bdat);
					oPrik.setVar("FSUM", pokl);
					oPrik.save(null,null,bdat.getVarDate());
				}
			}
			t.close();

			fillGrid();
			avnsGrid.setTable(tblAvns);
			tblAvns.requery();
			avnsGrid.build();
		break;
		case "EPROC":
/*			var pokl = 0;
			pokl = input(ru("Процент от оклада","Відсоток від окладу"),null, pokl, 5, 2);
			if(pokl == null)
				return;
*/				
			var p=new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(!p.escape)
			{
				zrp_mnu_proc=p.mProc;
				zrp_mnu_round=p.mRound;
			}
			else
				return false;

			var t = OpenTable("SELECT * FROM ^prk_all WHERE "+avnsGrid.sqlSelected())
			if(!t.isEmpty())
			{
				var oPrik = new DpPrik(extPar.priklbl, extPar.fvid);
				for (t.MoveFirst(); !t.IsEOF(); t.MoveNext())
				{
					oPrik.clear();
					oPrik.loadByID(t.getValue("Fwid"),null,null,bdat);
					oPrik.setVar("FSUM", proc_okl(t.getValue("Fwid_wp"),new Date(bdat),null,t.getValue("Fkoef")));
					oPrik.setVar("FPROCOKL", zrp_mnu_proc);
					oPrik.save(null,null,bdat.getVarDate());
				}
			}
			t.close();

			fillGrid();
			avnsGrid.setTable(tblAvns);
			tblAvns.requery();
			avnsGrid.build();
		break;
		case "SETBYLS":
			var snap = getSnap("select count(*) from ^avns_ls")
			if(!snap || snap[0]==0)
			{
				alert(ru("Сперва занесите поля ЛС, по которым нужно формировать аванс в настройку в контекстном меню:\n 'Проставить % от полей ЛС -> Настройка полей ЛС'",
						"Спершу занесіть поля ОР, по котрим треба формувати аванс в налагодження в контекстному меню:\n 'Проставити % від полів ОР -> Налагодження полів ОР'"))
				return false;
			}
			var p=new Object();
			p.escape=true;
			p.mProc=100;
			p.mRound=0;
			showWindow("g_round500.xml",SW_MODAL,p);
			if(p.escape)
				return false;
			var oAsk = new DpAskEx();
			oAsk.add("B","Основні особові рахунки|Основные лицевые счета","ISBASE", true);
			oAsk.add("CL","ОР за окремим розрахунком|ЛС по отдельному расчету","CALC", 0, getPar("ZRP_PRIVAT_CALCS"));
			oAsk.defCond("this.aQryList['ISBASE'].controls[0].checked == false", "COND_IS_PRIVAT");
			oAsk.enable("CALC", "COND_IS_PRIVAT");
			oAsk.doAsk();
			var calcNum = 0;
			if(oAsk.escape)
			 return false;
			if(!oAsk.get("ISBASE"))
				calcNum = oAsk.get("CALC").getCod();
			var m = new Object();
			m.FWID = "COUNTER";
			m.FTABN_ID = "LONG";
			m.FSUM = "DOUBLE";
			m.FSIGN = "INT";
			CreateTable("tmp_avns_sum", m);
			//var sqlSum = (p.mRound==-500?"FLOOR(SUM(s.Fsum)*"+p.mProc+"/50000)*500":sqlRound("SUM(s.Fsum)*"+p.mProc+"/100",p.mRound));
			ExecuteSQL("insert into tmp_avns_sum (Ftabn_id, Fsum, Fsign) "
					+" SELECT p.Ftabn_id, "+IIF("SUM(s.Fsum) is null","0","SUM(s.Fsum)")+" as Fsum, "+IIF("a.Fminus="+sqlTrue,"-1","1")+" as Fsign "
					+" FROM ^svzp"+(calcNum?calcNum:"")+getDateTag(bdat)+" as s INNER JOIN ^avns_ls as a ON s.Flsfid=a.Flsfid "
						+" INNER JOIN ^prk_all as p ON p.Ftabn_id=s.Ftabn_id"
					+" WHERE p.Fwid "+avnsGrid.sqlSelected(true)+" and NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(bdat)+")"
					+" GROUP BY p.Ftabn_id, a.Fminus");
			var sqlSum = (p.mRound==-500?"FLOOR(SUM(Fsum*Fsign)*"+p.mProc+"/50000)*500":sqlRound("SUM(Fsum*Fsign)*"+p.mProc+"/100",p.mRound));
			ExecuteSQL("UPDATE ^prk_all SET Fsum=(select "+sqlSum+" from tmp_avns_sum as a "
						+" WHERE ^prk_all.Ftabn_id=a.Ftabn_id)"
					+" WHERE "+avnsGrid.sqlSelected()+" and EXISTS(select Fwid from tmp_avns_sum as a "
						+" WHERE ^prk_all.Ftabn_id=a.Ftabn_id)");
			/*ExecuteSQL("UPDATE ^prk_all SET Fsum=(select "+IIF(sqlSum+" is null","0",sqlSum)+" from ^svzp"+getDateTag(bdat)+" as s "
						+" WHERE EXISTS(select * from ^avns_ls as a where a.Flsfid=s.Flsfid) and ^prk_all.Ftabn_id=s.Ftabn_id "
							+" and NOT (s.Fvp=1 AND s.Fmn>=" + sqlTo(bdat)+"))"
					+" WHERE "+avnsGrid.sqlSelected());*/
			var nRow = tblAvns.absolute;
			fillGrid();
			avnsGrid.setTable(tblAvns);
			tblAvns.requery();
			tblAvns.absolute = nRow;
			avnsGrid.build();
		break;
		case "LSSETTINGS":
			showWindow("l_avnsSetLs.js", SW_NOMODAL);
		break;
		case "PRSBAV":
			var par = new Object();
			par.dat1 = bdat;
			par.dat2 = edat;
			par.fvid = extPar.fvid;
			showWindow("le_c_pr_avns.js",SW_NOMODAL, par);
		break;
		// проставление процента от оклада в авансовой ведомости для ЧТГ
		case "PROCOKL":
			var p=new Object();
			p.escape=true;
			p.mProc=0;
			p.mRound=0;
			p.mSum_val=true;
			showWindow("g_round.xml",SW_MODAL,p)
			if(!p.escape)
			{
				zrp_mnu_proc=p.mProc;
				zrp_mnu_round=p.mRound;
			}
			else
				return false;
			var msg = msgBox("yn", UR("Давати аванс тим, у кого буде відпуска?|Давать аванс тем, у кого будет отпуск?"), UR("Аванс|Аванс"))
			if(msg==null)
				return false;
			t = OpenTable("SELECT Fwid, Fwid_wp FROM ^prk_all WHERE "+avnsGrid.sqlSelected());
        	if(zrp_mnu_proc>0 && !t.isEmpty())
        	{
				/* 
				var oPrik = new DpPrik(extPar.priklbl, extPar.fvid);
				for (t.MoveFirst(); !t.IsEOF(); t.MoveNext())
				{
					oPrik.clear();
					oPrik.loadByID(t.getValue("Fwid"));
					oPrik.setVar("FSUM", Number(proc_okl(t.getValue("Fwid_wp"), new Date(bdat))));
					oPrik.save(null,null,bdat.getVarDate());
				}*/
				//если не существует XML файла, то при вызове loadByID валится в DpDocumentDecoder.js,
				//т.к. this.parseFrom(tblMap) для аванса возвращает AVNS%LD
				//поэтому будем апдейтить непосредственно таблицу
				for (t.MoveFirst(); !t.IsEOF(); t.MoveNext())
				{
					ExecuteSQL("UPDATE ^prk_all SET Fsum="+sqlTo(proc_okl(t.getValue("Fwid_wp"),new Date(bdat),msg))
									+" WHERE Fwid="+sqlTo(t.getValue("Fwid")));
					ExecuteSQL("UPDATE "+avnsTblName+" SET Fprocokl="+sqlTo(zrp_mnu_proc)+" WHERE Fwid="+sqlTo(t.getValue("Fwid")));
				}
			}
			t.close();
			
			fillGrid();
			avnsGrid.setTable(tblAvns);
			tblAvns.requery();
			avnsGrid.build();
		break;
		case "AVAN_SK":
			
		break;
		case "EXPORTCALC":
			var oPar = new Object();
			oPar.grid = avnsGrid;
			showWindow("grid_to_scalc.xml",SW_MODAL,oPar);
		break;
		case "EXPORTXLS":
			var sFile = BrowseForFile("*.xls", "Файлы XLS (*.xls)", null, "SAVE");
			if (sFile)
			{
				if (!sFile.endsWith(".xls"))
					sFile = sFile + ".xls";
				avnsGrid.exportToXLS(sFile);
			} 
		break;
		case "SBKXLS":
		case "SBKDBF2":
			var tr_excel	= null;			
			if(IsTable("avanstmpo")) 		
				DropTable("avanstmpo");		
			strSql = "select *  INTO avanstmpo from "+avnsTblName+"  where "+avnsGrid.sqlSelected();
			ExecuteSQL(strSql);
			if(IsTable("avansschet")) 		
				DropTable("avansschet");		
			strSql = "SELECT pa.Ftabn_id, c.FL_SCH,  pa.Fsum, pa.Fwid INTO avansschet "
					+" from ^prk_c_pr c INNER JOIN ^prk_all p ON c.Fwid=p.Fwid "
					+" INNER JOIN (^prk_all as pa"
					+" INNER JOIN avanstmpo r ON r.Fwid = pa.Fwid) ON pa.Ftabn_id = p.Ftabn_id"
					+" WHERE p.Fedat>="+sqlTo(bdat)+" AND p.Fbdat<="+sqlTo(edat);
			ExecuteSQL(strSql);
			if(IsTable("avansnames")) 		
				DropTable("avansnames");		
			strSql = "SELECT r.* into  avansnames from ^cl c "
					+" inner join ^clrelclcl r on c.Fwid=r.fwid_cl "
					+" inner join ^cl_homo h on c.fwid = h.fwid_cl"
					+" where r.fcl = "+getPar("CodPers");
			ExecuteSQL(strSql);	
			if(IsTable("avansALL")) 		
				DropTable("avansALL");		
			strSql = "SELECT r.* into  avansALL from avansnames c "
					+" inner join avansschet r on c.fwid_cl = r.Ftabn_id";			
			ExecuteSQL(strSql);	
			WAIT(ru("Начало импорта","Початок імпорту"));
					
			if(IsTable("cassaTBL")) 		
				DropTable("cassaTBL");			
			strSql = "SELECT FL_SCH as lstbl, "
							+ "FTABN_ID as TN,"
							+ "9000000000 as FINDNUM,"					
							+ "'????????????????????' as FAM, "
							+ "'????????????????????' as NAME, "
							+ "'?????????????????????????' as OT, "
							+ "Fsum as rlsum, "				
							+ "'Z' as rlkod "
							+" INTO cassaTBL FROM  avansALL";// WHERE Fsum <> 0";
			ExecuteSQL(strSql);

			var tbl = OpenTable("cassaTBL");
			var m = new Object();
			while (!tbl.isEOF())
				{
					var nTn = tbl.getValue("TN");		
					var sSQL = "SELECT FTXT, FINDNUM FROM ^cl c INNER JOIN ^clrelclcl r ON c.fwid = r.fwid_cl" +
							" INNER JOIN ^cl_homo h ON h.fwid_cl = c.fwid"
						+ " where r.fcl = " + getPar("CODPERS") + " and r.fwid_cl = " + sqlTo(nTn);
					var oSnap = getSnap(sSQL);
					if (oSnap != null)
					{
						var sFIO = String(oSnap[0]);
						sFIO = sFIO.trim();
						var ArrFio = sFIO.split(' ');
						m.FAM = ArrFio[0].trim();
						m.NAME = ArrFio[1].trim();
						if (ArrFio.length > 2)
							m.OT = ArrFio[2].trim();
						else
							m.OT = "";
						m.FINDNUM = oSnap[1] == "" ? 0 : oSnap[1];
						UpdateTable("cassaTBL", m, false, "TN="+sqlTo(tbl.getValue("TN")))			
					}		
					tbl.MoveNext();		
				}		
			if(IsTable("sqlTbl")) 		
				DropTable("sqlTbl");	
			var sSrcSQL = "select lstbl, FAM, NAME, OT, rlsum, rlkod, FINDNUM into sqlTbl from cassaTBL order by " + IIF("lstbl = '48'",0,1);
			ExecuteSQL(sSrcSQL);
			var sqlTbl = OpenTable("sqlTbl");
			if(sqlTbl.isEmpty())
			{
				alert(ru("Нет данных!","Немає даних!"));
				return false;
			}
			WAIT(ru("Количество импортируемых записей: ","Кількість імпортованих записів: ")+sqlTbl.rowCount);
			
			if (ID == "SBKXLS")
			{
				var prnPat = "EXPORTXLS";
				tv = new DpTVars("LIST",prnPat);
				tv.setRTbl(sqlTbl);
				tv.print();
			}
			else if (ID == "SBKDBF2")
			{
				sFileName = BrowseForFile("*.dbf", "DBase *.dbf", "C://");				
				if (sFileName)
				{
					copyFile(rootDirectoryEx()+"Source/dbftemplate/avns_pechersk_etl.DBF", sFileName);
				
					oDDBF = lpProxy.getDBManager().getDBFWriter(sFileName);
					oDDBF.setCharactersetName("cp866")

					var tbl = OpenTable("SELECT * FROM sqlTbl WHERE RLSUM <> 0");
					for(; !tbl.IsEOF(); tbl.MoveNext())
					{
						var LSTBL = String(tbl.getValue("LSTBL"));
//						var addZero = replicate('0', 10 - LSTBL.length);
//						LSTBL = addZero + LSTBL   
						oDDBF.addRecord(new Array(
							"289"
							,"355"						
							,"0"						
							, LSTBL
							,toScrObj(tbl.getValue("FAM"))
							,toScrObj(tbl.getValue("NAME"))
							,toScrObj(tbl.getValue("OT"))
							,toScrObj(tbl.getValue("RLSUM"))
							,String(tbl.getValue("FINDNUM"))
							,String(tbl.getValue("RLKOD"))
						));
					}
					oDDBF.write()
				}	
			}
			/*var  page=null;//pages = grid.pages,;			
			var iCt0 = 2;//ctranicu
			if(tr_excel!=null)
			{
				tr_excel.application.quit();
				tr_excel=null;
			}			
			var exl	= createObject("Excel.Application");
			if(!exl)
			{
				alert("Ошибка при создании сервера.");
				return;
			
			}
			exl.visible	= true;					
			tr_excel	= exl.Workbooks.Add();			
			//tr_excel = createObject("Excel.Sheet");
			var es = tr_excel;
			if(es==null)
			{
				alert(ru("Ошибка при создании файла.","Помилка при створенні файлу."));
				return;
			}
			es.Application.Visible = true;			
			var str = 1, stb = 1;			
			es.Sheets(1).Columns("A:A").NumberFormat = "0";			
			es.Sheets(1).Cells(str,stb++).value = "lstbl";					
			es.Sheets(1).Cells(str,stb++).value = "FAM";
			es.Sheets(1).Cells(str,stb++).value = "NAME";
			es.Sheets(1).Cells(str,stb++).value = "OT";
			es.Sheets(1).Cells(str,stb++).value = "RLSUM";
			es.Sheets(1).Cells(str,stb++).value = "RLKOD";							
			var str = 2, stb = 1;
			while (!sqlTbl.isEOF())
			{				
				var sFrSc = String(sqlTbl("lstbl"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;
				sFrSc = String(sqlTbl("FAM"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;
				sFrSc = String(sqlTbl("NAME"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;
				sFrSc = String(sqlTbl("OT"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;
				sFrSc = String(sqlTbl("RLSUM"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;
				sFrSc = String(sqlTbl("RLKOD"));
				es.Sheets(1).Cells(str,stb++).value = sFrSc;					
				str++;
				stb = 1;
				sqlTbl.MoveNext();			
			}			
			es.Application.Visible = true;					*/
			//WAITTIMEOUT(ru("Импорт окончен","Імпорт закінчено"),1000);				
			//es = null;
		break;
		case "SBKDBF":
			sFileName = BrowseForFile("*.", ru("Експорт перерахуваннь на картки в КАСУ у dbf файл|Экспорт перечислений в КАССУ в dbf файл"), "C://");
			if (sFileName)
			{
				copyFile(rootDirectoryEx()+"Source/dbftemplate/avns_etl.DBF", sFileName);
			
				oDDBF = lpProxy.getDBManager().getDBFWriter(sFileName);
				oDDBF.setCharactersetName("cp866")
				
//>>>>>>>>>
				if(IsTable("avanstmpo")) 		
					DropTable("avanstmpo");		
				strSql = "select *  INTO avanstmpo from "+avnsTblName+"  where "+avnsGrid.sqlSelected();
				ExecuteSQL(strSql);
				if(IsTable("avansschet")) 		
					DropTable("avansschet");		
				//strSql = "SELECT c.Ftabn, c.FL_SCH,  r.Fsum, r.Fwid INTO avansschet from ^prk_c_pr c, avanstmpo r where c.Ftabn = r.Ftabn";
				strSql = "SELECT pa.Ftabn_id, c.FL_SCH,  pa.Fsum, pa.Fwid INTO avansschet "
					+" from ^prk_c_pr c INNER JOIN ^prk_all p ON c.Fwid=p.Fwid "
					+" INNER JOIN (^prk_all as pa"
					+" INNER JOIN avanstmpo r ON r.Fwid = pa.Fwid) ON pa.Ftabn_id = p.Ftabn_id";
				ExecuteSQL(strSql);		
				if(IsTable("avansnames")) 		
					DropTable("avansnames");		
				strSql = "SELECT r.* into  avansnames from ^cl c "
					+" inner join ^clrelclcl r on c.Fwid=r.fwid_cl "
					+" inner join ^cl_homo h on c.fwid = h.fwid_cl"
					+" where r.fcl = "+getPar("CodPers");
				ExecuteSQL(strSql);	
				if(IsTable("avansALL")) 		
					DropTable("avansALL");
				strSql = "SELECT r.* into  avansALL from avansnames c "
					+" inner join avansschet r on c.fwid_cl = r.Ftabn_id";			
				ExecuteSQL(strSql);
				var okword = new String("");
				var filename = new String("");
				d = new Date();
				dat = new String(d.getDate());
				month = new String(d.getMonth()+1);
				god = new String(d.getFullYear());
				year = god.substr(2,2);
				okword = dat+"."+ month+"."+ year;
				WAIT("Экспорт начат");

/*				imyaFile = new String("z2830");
				text = ru("Введите вторую часть имени файла. Сегодня "+okword,"Введіть другу частину імені файлу. Сьогодні "+okword);
				caption = ru("Ввод части имени файла","Введення частини імені файлу");	
				nextPartFile = input(text,caption,"V");
				if (nextPartFile == undefined || nextPartFile == "")
					imyaFile += dat+month;
				else
					imyaFile += nextPartFile;
				imyaFile += ".dbf";*/	
				if(IsTable("cassaTBL")) 		
					DropTable("cassaTBL");		
				strSql = "SELECT FL_SCH as LSTBL, "
					+ "Fsum as RLSUM, "				
					+ "'z' as RLKOD "
					+" INTO cassaTBL FROM  avansALL"
				ExecuteSQL(strSql);	
		
				var tbl = OpenTable("cassaTBL");
				for(; !tbl.IsEOF(); tbl.MoveNext())
				{
					var LSTBL = String(tbl.getValue("LSTBL"));
					var addZero = replicate('0', 10 - LSTBL.length);
					LSTBL = addZero + LSTBL   
					oDDBF.addRecord(new Array(
							LSTBL
						,toScrObj(tbl.getValue("RLSUM"))
						,toScrObj(tbl.getValue("RLKOD"))
					));
				}
				oDDBF.write()
				/*while (!tbl.isEOF())
				{			
					tbl.Edit();
					var realstbl = tbl("LSTBL");
					ilen = realstbl.length;
					if (ilen < 10)
					{
						dif = 10 - ilen;
						zstr = new String("");
						for(i = 0; i < dif;i++)
							zstr = "0" + zstr;
						realstbl = zstr + realstbl;
					}
					tbl("LSTBL") = realstbl;	
					var longNomer = tbl("RLSUM");
					longNomer = longNomer.replace(/,/g,".");//longNomer.split(",");
					longNomer = format("#.00",Number(longNomer));
					realNomer = new Number(longNomer);
					tbl("RLSUM") = realNomer;				
					tbl.Update();
					tbl.MoveNext();		
				}
				if(IsTable("sqlTbl")) 		
					DropTable("sqlTbl");	
				var sSrcSQL = "select * into sqlTbl from cassaTBL order by LSTBL";
				ExecuteSQL(sSrcSQL);
				filename = imyaFile;		
				expDir = getPar("EXPDIR");	
				if(expDir.substr(expDir.length-1)!="\\")
      				expDir += "\\";	
				RD = "c:\\debetplus\\exportkarta";
				if (expDir == "" || expDir == " " || expDir == null)
				{	//RD = rootDirectory();
					alert("ВНИМАНИЕ. Не установлена директория экспорта."
						+"\n Установите директорию экспорта в установках параметров системы ДЕБЕТ ПЛЮС."
						+"\n В данном случае Файл :"+filename+" будет сохранён в папке :"+RD);
					filename = RD + "\\" + filename;								
				}
				else
				{
					filename = expDir + "\\" + filename;//filename = RD + "\\" + filename;						
				}		
				copyFile(expDir + "z2830ET.dbf", filename, false);
				if(!isFile(filename))
				{
      				alert("Невозможно создать файл " + filename);
					return;
				}
				DirectExportToDbf(imyaFile, "z2830ET.dbf","sqlTbl", "Експорт перерахуваннь на картки в КАСУ у dbf файл|Экспорт перечислений в КАССУ в dbf файл");*/
				WAITTIMEOUT(ru("Экспорт окончен","Експорт закінчено"),40);	
//<<<<<<<<<
				/*var tZPKVART = OpenTable("s", 
					"SELECT *"
					+ " FROM ZPKVART"
					+ " ORDER BY NP, Fcod, OZN_DOX"
					);
				for (; !tZPKVART.IsEOF(); tZPKVART.MoveNext())
				{
					oDDBF.addRecord(new Array(
						toScrObj(tZPKVART.getValue("NP"))
						,toScrObj(tZPKVART.getValue("PERIOD"))
						,toScrObj(tZPKVART.getValue("RIK"))
						,toScrObj(tZPKVART.getValue("KOD"))
						,toScrObj(tZPKVART.getValue("TYP"))
						,toScrObj(tZPKVART.getValue("TIN"))
						,Number(String(tZPKVART.getValue("S_NAR")))
						,Number(tZPKVART.getValue("S_DOX"))
						,Number(tZPKVART.getValue("S_TAXN"))
						,Number(tZPKVART.getValue("S_TAXP"))
						,toScrObj(tZPKVART.getValue("OZN_DOX")) 
						,differ(new Date(tZPKVART.getValue("D_PRIYN")), d00obj)==0? null: toScrObj(tZPKVART.getValue("D_PRIYN")) 
						,differ(new Date(tZPKVART.getValue("D_ZVILN")), d00obj)==0? null: toScrObj(tZPKVART.getValue("D_ZVILN")) 
						,toScrObj(tZPKVART.getValue("OZN_PILG"))
						,toScrObj(tZPKVART.getValue("OZNAKA"))
						));
				}
				oDDBF.write()*/
			}
		break;
		case "EXPTEL":
			include("telecom:telecomExp.js");
			var title = ru("Экспорт аванса за ","Експорт авансу за ")+format("dd.mm.yy",bdat);
			telecomExp("avans as a","AVNS",avnsGrid,bdat,title,"a.Ftxt,a.Fsum,"+sqlTo(d00));
		break;
		case "DEBUG_BROWSE":
			browse(tblAvns);		
		break;
		
		case "VIEW_TRANSF":
			var oTransf = new DpTransfer();
			var TBL_4GRID = "TBL4GRID";
			var TBL_AVNS = getTableNameByDate("avns", bdat);
			var TBL4TRANSF = getTmpTableName("", true);
				
			strSQL = "SELECT PA.*"
					+" INTO "+TBL4TRANSF
					+" FROM ^"+TBL_AVNS+" A INNER JOIN ^PRK_ALL PA ON A.FWID = PA.FWID"
			ExecuteSQL(strSQL);
			ExecuteSQL("ALTER TABLE "+TBL4TRANSF+" ADD FTABN "+SqlType("LONG"));

			var opTbl = OpenTable(TBL4TRANSF)			
			for(opTbl.MoveFirst(); !opTbl.IsEOF(); opTbl.MoveNext())
			{
				opTbl.Edit();
				opTbl.setValue("FTABN", getClcodByID(getPar("CODPERS"), opTbl.getValue("FTABN_ID")));
				opTbl.Update();
			}
			opTbl.close();
			
			with(oTransf)
			{
				dPrdate = bdat;
				setTable(TBL_4GRID);
				setField("FTRSUM", "FSUM");
				setField("FTABN", "FTABN");

				//Тип перечисления
				setAttr("trType","ZP");
				
				//Таблица с данными
				setAttr("tblFrom", TBL4TRANSF);				
				showTrSum("TRTYPE");
			}		
		break;
	}
}

function proc_okl(mFwid_wp, mFdate, msg, koef)
{
	var mSum = 0;
	// последнее число предыдущего месяца
	var D1 = new Date(mFdate.getFullYear(), mFdate.getMonth(), 0);
	// Проверим, чтобы не было приказа на отпуск этого
	// месяца, выплаченного в предыдущих месяцах
	/*var strSQL = "SELECT * FROM ^PRK_ALL AS p INNER JOIN ^PRK_O AS o ON p.Fwid=o.Fwid "
			+" WHERE p.Fwid_wp="+sqlTo(mFwid_wp)
			+" AND (p.FBDAT<="+sqlTo(mFdate)+") AND (p.FEDAT>="+sqlTo(mFdate)+")"
			+" AND (o.FDAT_PRIK<="+sqlTo(D1)+")";*/
	if(msg=="y")
	{
		var strSQL = "SELECT * FROM ^PRK_ALL   "
				+" WHERE Fin_table='PRK_O' AND Fwid_wp="+sqlTo(mFwid_wp)+" AND FBDAT>="+sqlTo(mFdate);

		var tbl_PRK_O = getSnap(strSQL);
		if(tbl_PRK_O!=null)
		{
			// есть отпуск - аванса не даем
			return 0;
		}
	}

	// достанем из штатного запись на дату mFdate
	strSQL=" SELECT sd.foklad "
		+" FROM ^work_pers AS wp INNER JOIN ^stru_dol AS sd ON wp.Fwid_dol=sd.Fwid WHERE wp.fwid="+sqlTo(mFwid_wp)
		+" AND (wp.FBDAT<="+sqlTo(mFdate)+") AND (wp.FEDAT>="+sqlTo(mFdate)+")"

	var snap = getSnap(strSQL);
	if(snap!=null)
	{
		// super vv 05.02.2002
		// если 100%, то не округляем
		if (zrp_mnu_proc==100)
			mSum = round(snap[0]*(koef?koef:1),zrp_mnu_round);
		else
			mSum = round(snap[0]*(koef?koef:1)*zrp_mnu_proc/100,zrp_mnu_round);
	}
	return mSum;
}

function getOklad(arg)
{	
	var snap = getSnap("SELECT d.foklad AS foklad FROM ^stru_dol AS d"
					+" LEFT JOIN ^work_pers AS wp ON d.fwid = wp.fwid_dol"
					+" WHERE wp.fwid = " + sqlTo(Number(arg)));
	if (snap == null)	
		return 0;
	else
		return snap[0];
}

//проверяем на соответствие кода ШР в приказе от оклада коду ШР в штатном расписании на период приказа
function isChanged(fwid_wp,sum)
{
	var snap = getSnap("SELECT Favans FROM ^WORK_PERS WHERE Fwid="+fwid_wp);
	if(snap && snap[0]==sum)
		return true;
	else
		return false;
}

include("sys/DpBaseDlg.js");