function prkLoad()
{
	gd = new DpGetDat("dD");
	if (!gd.dat1 || !gd.dat2)
		return false;
}

function prkSrc()
{
	var sOrder = "";
	if (IsSORT)
		sOrder = "c.fcod, p.fbdat, p.fedat";
	
	var sTableName = "^PRK_ALL";
	var sWhere = "p.fvid_prk = " + sqlTo(extPar.fvid) 
		+" AND p.fbdat<=" + sqlTo(gd.dat2) + " AND p.fedat>=" + sqlTo(gd.dat1);
		
	var skizd = ""
		if( getPar("PRIK_IZD") ){
			skizd = ",p.fkodizd "
		}
	
	this.qrySet("Fields", "p.Fwid, p.Ftabn_id, p.Fsum, p.Fdat_otp, p.Fbdat, p.Fedat, p.Fshpz, p.Fnom_prik, p.Fwid_wp,"
				+" p.Fproc, p.Fdat_prik, p.Fcalnum, p.Fday_prop, p.Fchas_prop, p.Fwid_prik, w.Fwid_cl, c.Fcod"+skizd,
				 "From", GLOBAL_TABLE+" AS p INNER JOIN ^work_pers AS w ON p.Fwid_wp=w.Fwid"
					+ " INNER JOIN ^clrelclcl AS c ON w.Fwid_cl=c.Fwid_cl", 
				"Where", sWhere,
				"Order", sOrder);

	//this.subTie(sTableName, "prk", "fwid", "fwid");
	this.subTie("work_pers","wp","fwid","fwid_wp");
	this.subTie("cl", "cl", "fwid", "fwid_cl");
	this.qrySet("Alias", "p");
	//this.subTie("clrelclcl", "rel", "fwid_cl", "wp.fwid_cl");
}

function menuInit(ds)
{
	if(!list.tbl.IsEmpty())
	{
		ds = list.dataSrc;	
		ds.AddMenuItem("OTPPRK", "Друк вiдпускних|Печать отпускных",9);
	    //ds.AddMenuItem("OTPPRN", "Друк вiдпускних|Печать отпускных",9);
	    ds.AddMenuItem("OTPPRNMASS", "Друк вiдпускних списком|Печать отпускных списком",9);
	    ds.AddMenuItem("OTP_SK", "Друк вiдпускних (деталізовано)|Печать отпускных (детализированно)",9);
	    ds.AddMenuItem("OTP_SK_MASS", "Друк вiдпускних списком (деталізовано)|Печать отпускных списком (детализированно)",9);
    	ds.AddMenuItem("", "");
    	//ds.AddMenuItem("LISTOP","Виконати спискову операцію|Выполнить списковую операцию");
	    //ds.AddMenuItem("OTPPRNLST", "Друк вiдпускних списком|Печать отпускных списком",9);
		ds.AddMenuItem("ISSHPZ","Масово проставити ШВЗ|Массово проставить ШПЗ");
		ds.AddMenuItem("ISSHP2","Перевірка ШВЗ|Проверка ШПЗ");
		ds.AddMenuItem("MOVENVK","Проставити ознаку наявності такалендарні дні неявок у табелі|Проставить признак наличия и календарные дни неявок в табеле");
		ds.AddMenuItem("SETWRKDAYS","Проставити календар і кількість робочих днів|Проставить календарь и количество рабочих дней");
		ds.AddMenuItem("MAKE_CDR_OTP","Створити кадрові накази|Создать кадровые приказы");						    	
		ds.AddMenuItem("", "");
	}
}

function menuRun(sID)
{
	switch(sID)
	{
		case "MAKE_CDR_OTP":
			var msg = ru("Вы уверены, что хотите создать по отмеченным приказам приказы отпускных в учете кадров?",
						"Ви впевнені, що бажаєте створити по відміченим наказам накази відпускних в обліку кадрів?");
			if(!confirm(msg))
				return false;
			if(SUBD==MYSQL)
			{
				var tmpTblName = "tmp_prk_all";
				CreateTable(tmpTblName,"PRK_ALL");
				var flds = GetPatternIntersection("PRK_ALL","PRK_ALL");
				ExecuteSQL("insert into "+tmpTblName+"("+flds+") select "+flds+" from ^prk_all where UPPER(Fin_table)="+sqlTo("PRK_O"));
			}
			else
				var tmpTblName = "^prk_all";
			//сгрузим в отдельную таблицу все возможные коды текущих и будущих отпускных из таблицы настройки
			var f = new Object();
			f.FWID_TYPE = "INT";
			f.FVID_PRK = "INT";
			CreateTable("tmp_nast_otp", f);
			ExecuteSQL("insert into tmp_nast_otp (Fwid_type, Fvid_prk) "
					+" select Fwid, Fvid_n as Fvid from ^nast_otp where Fvid_n>0 union "
					+" select Fwid, Fvid_m as Fvid from ^nast_otp where Fvid_n>0");
			//группируем отпускные сотрудников по строкам настройки
			var tbl = OpenTable("SELECT MIN(p1.Fbdat) as Fbdat, MAX(p1.Fedat) as Fedat, MAX(p1.Fnom_prik) as Fnom_prik, "
									+" MIN(tn.Fvid_prk) as Fvid_min, MAX(tn.Fvid_prk) as Fvid_max, MAX(p1.Fcalnum) as Fcalnum, "
									+" p1.Ftabn_id, p1.Fdat_otp, p1.Fdat_prik, tn.Fwid_type "
								+" FROM ^prk_all as p1 INNER JOIN tmp_nast_otp as tn ON tn.Fvid_prk=p1.Fvid_prk "
								+" WHERE EXISTS (select Fwid from "+tmpTblName+" as p2 "
									+" where p1.Ftabn_id=p2.Ftabn_id and p1.Fdat_otp=p2.Fdat_otp "
										+" and p2.Fwid "+DataSource().sqlSelected(true)+") "
								+" GROUP BY p1.Ftabn_id, p1.Fdat_otp, p1.Fdat_prik, tn.Fwid_type "
								+" ORDER BY Ftabn_id, Fbdat");
			if(tbl.rowCount==0)
			{
				alert(ru("Создание кадровых приказов не возможно, т.к. текущие приказы отсутствуют в настройке упрощенных отпускных.",
						"Створення кадрових наказів не можливо, бо поточні накази відсутні в налаштуванні спрощених відпускних."),1);
				return false;
			}
			var ftabn_id = tbl.getValue("Ftabn_id");
			var fdat_otp = tbl.getValue("Fdat_otp");
			var fnom_prik = tbl.getValue("Fnom_prik");
			var snap = getSnap("select MIN(Fcod) from ^cl_calend");
			if(snap && snap[0])
				var mincalend = snap[0];
			else
			{
				alert(ru("Не найдено ни одного календаря!","Не знайдено жодного календаря!"),1);
				return false;
			}
			include("objects/dpCalendar.js");
			var oCalend = new dpCalendar();
			//если в приказе проставлен календарь, то используем его
			if(tbl.getValue("Fcalnum")>0)
				var calend = tbl.getValue("Fcalnum");
			else
				var calend = mincalend;
			oCalend.setCod(calend);
			include("doc/DpDoc.js");
			var oDoc = new DpDoc("CDR_OTP",0);
			oDoc.setVar("HNOM",fnom_prik);
			oDoc.setVar("HDAT",fdat_otp);
			//объект для запроса подтверждения и сохранения уже существующих приказов в кадрах
			var exist = new Object();
			exist.toAsk = true;
			exist.toSave = true;
			
			//соотношение строк в документе 1:1
			var row = oDoc.createRow("prk_otp");
	        row.setVar("RNOM", 1);
	        row.setVar("RWID_CL", ftabn_id);
	        row.setVar("RCOD", getCodByID(tbl.getValue("Ftabn_id")));
	        row.setVar("RBDAT",tbl.getValue("Fbdat"));
	        row.setVar("REDAT",tbl.getValue("Fedat"));
	        var bperiod = new Date(getBeginPeroidOtp(ftabn_id, tbl.getValue("Fbdat"))).getVarDate();
	        row.setVar("RBPERIOD",bperiod);
	        if(differ(bperiod,d00)!=0)
	        	row.setVar("REPERIOD",new Date(new Date(bperiod).getFullYear()+1,bperiod.getMonth(),bperiod.getDate()-1).getVarDate());
	        row.setVar("RDAT_PRIK",tbl.getValue("Fdat_prik"));
	        row.setVar("RREASON","Заява "+getSmallFIO(getTxtFromID(ftabn_id)));
	        row.setVar("RCALEND",calend);
			//кол-во подстрок будет зависеть от типов отпускных
			var subrow = row.createRow("otp_type");
			var prDays = oCalend.getCalDays("П", tbl.getValue("Fbdat"), tbl.getValue("Fedat"));
			var otpDays = day_difference(tbl.getValue("Fbdat"), tbl.getValue("Fedat")) - prDays;
			subrow.setVar("RDAYS",otpDays);
			subrow.setVar("RWID_TYPE",tbl.getValue("Fwid_type"));
			row.appendRow("otp_type", subrow);
			var cnt = 0;
			setProgressRange(tbl.bookmark, tbl.rowCount);
			//первую итерацию в цикле пропускаем, т.к. выполнили ее вне цикла
			for(tbl.MoveNext(); !tbl.IsEOF(); tbl.MoveNext())
			{
				setProgressPos(tbl.bookmark, tbl.bookmark+"/"+tbl.rowCount);
				
				//если в приказе проставлен календарь, то используем его
				if(tbl.getValue("Fcalnum")>0)
					calend = tbl.getValue("Fcalnum");
				else
					calend = mincalend;
				oCalend.setCod(calend);
				//если это продолжение тогоже отпуска, то добавляем строки в тот же приказ, в противном случае сохраняем старый и создаем новый
				if(ftabn_id == tbl.getValue("Ftabn_id") && differ(fdat_otp, tbl.getValue("fdat_otp"))==0)
				{
					//переопределяем дату окончания
					row.setVar("REDAT",tbl.getValue("Fedat"));
					var subrow = row.createRow("otp_type");
					var prDays = oCalend.getCalDays("П", tbl.getValue("Fbdat"), tbl.getValue("Fedat"));
					var otpDays = day_difference(tbl.getValue("Fbdat"), tbl.getValue("Fedat")) - prDays;
					subrow.setVar("RDAYS",otpDays);
					subrow.setVar("RWID_TYPE",tbl.getValue("Fwid_type"));
					row.appendRow("otp_type", subrow);
				}
				else
				{
					//проверяем существование отпускного в кадрах
					if(!checkExist(exist, row, tbl))
						return false;
					if(exist.toSave)
					{
						row.saveRows();
				        oDoc.appendRow("prk_otp", row);
				        oDoc.saveRows();
				        oDoc.save();
				        //проставляем родительский идентификатор зарплатных отпусках по идентификатору сотрудника и первому дню отпуска
						ExecuteSQL("update ^prk_all set Fwid_prik="+oDoc.getID()+" where Ftabn_id="+ftabn_id+" and UPPER(Fin_table)="+sqlTo("PRK_O")+" and Fdat_otp="+sqlTo(fdat_otp));
						cnt++;
					}
					//создаем новый
					oDoc = new DpDoc("CDR_OTP",0);
					var ftabn_id = tbl.getValue("Ftabn_id");
					var fdat_otp = tbl.getValue("Fdat_otp");
					var fnom_prik = tbl.getValue("Fnom_prik");
					oDoc.setVar("HNOM",fnom_prik);
					oDoc.setVar("HDAT",fdat_otp);
					var row = oDoc.createRow("prk_otp");
			        row.setVar("RNOM", 1);
			        row.setVar("RWID_CL", ftabn_id);
			        row.setVar("RCOD", getCodByID(tbl.getValue("Ftabn_id")));
			        row.setVar("RBDAT",tbl.getValue("Fbdat"));
			        row.setVar("REDAT",tbl.getValue("Fedat"));
			        var bperiod = new Date(getBeginPeroidOtp(ftabn_id, tbl.getValue("Fbdat"))).getVarDate();
			        row.setVar("RBPERIOD",bperiod);
			        if(differ(bperiod,d00)!=0)
			        	row.setVar("REPERIOD",new Date(new Date(bperiod).getFullYear()+1,bperiod.getMonth(),bperiod.getDate()-1).getVarDate());
			        row.setVar("RDAT_PRIK",tbl.getValue("Fdat_prik"));
			        row.setVar("RREASON","Заява "+getSmallFIO(getTxtFromID(ftabn_id)));
			        row.setVar("RCALEND",calend);
					//кол-во подстрок будет зависеть от типов отпускных
					var subrow = row.createRow("otp_type");
					var prDays = oCalend.getCalDays("П", tbl.getValue("Fbdat"), tbl.getValue("Fedat"));
					var otpDays = day_difference(tbl.getValue("Fbdat"), tbl.getValue("Fedat")) - prDays;
					subrow.setVar("RDAYS",otpDays);
					subrow.setVar("RWID_TYPE",tbl.getValue("Fwid_type"));
					row.appendRow("otp_type", subrow);
				}
			}
			//проверяем существование отпускного в кадрах
			if(!checkExist(exist, row, tbl))
				return false;
			if(exist.toSave)
			{
				//сохраняем последний приказ
				row.saveRows()
		        oDoc.appendRow("prk_otp", row);
		        oDoc.saveRows();
		        oDoc.save();
		        //проставляем родительский идентификатор зарплатных отпусках по идентификатору сотрудника и первому дню отпуска
				ExecuteSQL("update ^prk_all set Fwid_prik="+oDoc.getID()+" where Ftabn_id="+ftabn_id+" and UPPER(Fin_table)="+sqlTo("PRK_O")+" and Fdat_otp="+sqlTo(fdat_otp));
		        cnt++;
			}
			setProgressPos(0);
			tbl.close();
	        list.tbl.requery();
   			grid.RefreshGrid();
	        alert(ru("Кол-во созданных приказов в учете кадров: ","Кількість створених наказів в обліку кадрів: ")+cnt);
		break;
	}
}

function prkDel()
{
	//listDel в l_prkekz.js сам обработает удаление приказа
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
	var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+list.tbl.getValue("Fwid"));
	if(snap)
	{
		ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(list.tbl.getValue("Fbdat"),list.tbl.getValue("Fedat"))
				+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+list.tbl.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
		ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+list.tbl.getValue("Fwid"));
	}
}

function prkMassDel()
{
	//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей
	var t = OpenTable("select * from ^prk_all where Fwid "+list.dataSrc.sqlSelected(true));
	if(t.rowCount>0)
	{
		for(; !t.IsEOF(); t.MoveNext())
		{
			//уменьшаем кол-во календарных дней неявки в табеле и удаляем запись из таблицы связей 
			var snap = getSnap("select Ftag,Fnvk,Fbdat from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			if(snap)
			{
				ExecuteSQL("update ^tbl"+snap[0]+" set Fnorma_d=Fnorma_d-"+day_difference(t.getValue("Fbdat"),t.getValue("Fedat"))
						+" where Fwid_wp in (select Fwid from ^work_pers where Fwid_cl="+t.getValue("Ftabn_id")+") and Fkod_nvk="+snap[1]+" and Fbdat="+snap[2]);
				ExecuteSQL("delete from ^lnkprktbl where Fid_prk="+t.getValue("Fwid"));
			}
		}
	}
	t.close();
}

function checkExist(obj, row, tbl)
{
	var snap = getSnap("select p.Fdoc_num, p.Fdoc_dat from ^prk_otp as o inner join ^cdr_prk as p on o.Fwid_prk=p.Fwid where o.Fwid_cl="+row.getVar("RWID_CL")+" and o.Fbdat="+sqlTo(row.getVar("RBDAT"))+" and o.Fedat="+sqlTo(row.getVar("REDAT")));
	if(snap)
	{
		if(obj.toAsk)
		{
			var tabn = getCodFromID(row.getVar("RWID_CL"));
			setProgressPos(0);
			var mb = msgBox("ynaic",ru("Приказ №"+snap[0]+" от "+format("dd.mm.yy",snap[1])+" для таб.№"+tabn+" за период с "+format("dd.mm.yy",row.getVar("RBDAT"))+" по "+format("dd.mm.yy",row.getVar("REDAT"))+" уже существует.\nСоздать новый приказ?",
									"Наказ №"+snap[0]+" від "+format("dd.mm.yy",snap[1])+" для таб.№"+tabn+" за період з "+format("dd.mm.yy",row.getVar("RBDAT"))+" по "+format("dd.mm.yy",row.getVar("REDAT"))+" вже існує.\nСтворити новий наказ?"),
				ru("Проверка существования приказов","Перевірка існування наказів"));
			setProgressPos(tbl.bookmark, tbl.bookmark+"/"+tbl.rowCount);
			switch(mb)
			{
				case "y":
					obj.toSave = true;
				break;
				case "n":
					obj.toSave = false;
				break;
				case "a":
					obj.toAsk = false;
					obj.toSave = true;
				break;
				case "i":
					obj.toAsk = false;
					obj.toSave = false;
				break;
				case "c":
				default:
					return false;
				break;
			}
		}
	}
	else//несуществющие сохраняем всегда
		obj.toSave = true;
	return true;
} 