include("l_eprkekz.js");

function prkLoad()
{
	HSUM.setMask("######.##");
	HDN.setMask("###");
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
	//HDN_KF.setMask("##");
	HKF.setMask("######");
	//HKF.setMask("###.###");	
	HCHAS.setMask("###.##");
	HNUM.setMask("&&&&&&&&&&&&");	
	HDNKL.setMask("###");
	
    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }
	
   	dpShtat = new DpShtat(null, null, null);	
 	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);
	
	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT); 
	
	switch (extPar.mode)
	{
		case "ADD":
         	//HBDAT.value = extPar.dat1;
         	//HEDAT.value = extPar.dat2;
         	HDAT_BOL.value = d00;
         	HMES_VIP.value = d00;
         	HSUM.value  = 100;
         	HDN.value  = 0;
         	HCHAS.value  = 0;
         	//HDN_KF.value  = 0;
         	HKF.value  = 0;
         	HNUM.value = "";
         	HDNKL.value  = 0;
         	Disable(HDNKL)
		break;
		case "EDIT":
			//при попытке редактировать больничный созданный на основе упрощенного больничного, 
			//будем давать возможность редактировать общий приказ
			var idParent = table.getValue("Fwid_prik");
			HNUM.value = table.getValue("FNUM");
			if(Number(idParent)!=0
				&& confirm(ru("У данного приказа есть родительский (общий) приказ.\nПоднять его на редактирование?",
							"У даного наказу є батьківський (загальний) наказ.\nПодняти його на редагування?")))
			{
				include("prik/DpPrik.js");
				var snap = getSnap("select Fvid_prk,Fwid_wp,Fbdat,Fedat from ^prk_all where fwid="+idParent);
				if(snap==null)
				{
					alert(ru("Упрощённый больничный не найден!",
							"Зпрощений лікарняний не знайдено!"));
					return false;
				}
				var GLOBAL_TABLE = "^PRK_ALL";
				var fvid_prk = snap[0];//FVID_PRK
				var fwid_wp = snap[1];//FWID_WP
				var oSnap = getSnap("select FEDIT from ^CL_PRIK where FVID="+ sqlTo(fvid_prk));
				if(oSnap==null)
				{
					alert(ru("В списке приказов отсутствует приказ с кодом ",
							"В списку наказів відсутній наказ з кодом ")+fvid_prk);
					return false;
				}
				var fproc = oSnap[0];			
				var oPrik = new DpPrik(fproc, fvid_prk);
				oPrik.loadByID(idParent);
				var par = new Object();			
				par.dat1 = new Date(snap[2]);//FBDAT
				par.dat2 = new Date(snap[3]);//FEDAT
				par.fvid = Number(fvid_prk); 
				par.tblName = oPrik.tblName;
				par.priklbl = fproc;
				par.GLOBAL_TABLE = GLOBAL_TABLE;
				par.sTableName = oPrik.tblName;			
				par.id = idParent;
				par.fwid_wp = fwid_wp;			
				par.mode = "EDIT";			
				par.m_pTable = OpenTable("select * from "+ GLOBAL_TABLE +" as pall "
							+(!oPrik.tblName? "" : 
								" inner join "+ oPrik.tblName +" as p on p.FWID=pall.FWID")
							+" inner join ^WORK_PERS as wp on wp.FWID=pall.FWID_WP "
							+" inner join ^CLRELCLCL as c on wp.FWID_CL=c.FWID_CL"
							+" where pall.FWID="+ par.id);
				par.ffld_num = par.m_pTable.getValue("FFLD_NUM");
				include("sys/ListApi.js");
				CallEditTask(oPrik.editXML, par, par.m_pTable);
				/*if(!par.escape)
				{
					table.requery();
					list.dataSrc.refresh();
				}*/
				//CloseWindow();
				return false;
			}
		case "COPY":
		case "VIEW":
            HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");
			HSUM.value = table.getValue("fproc");
			HMES_VIP.value = table.getValue("fmes_vip");
			HDAT_BOL.value = table.getValue("fdat_bol");
			//HDN_KF.value  = table.getValue("fnom_prik");
			HDN.value = Number(Math.floor(Number(table.getValue("fsum"))/1000));			
			HCHAS.value = Number(table.getValue("fsum") - (Math.floor(Number(table.getValue("fsum"))/1000)) * 1000);
			HKF.value  = Number(table.getValue("fcalnum"));
			HNUM.value = table.getValue("FNUM");
			HDNKL.value  = Number(table.getValue("fdnkl"));			
		break;	
	}
	useDefValid = false;
	setValid(HEDAT,edat_Valid);
	setValid(HDAT_BOL,dat_bol_Valid);
	setWhen(HDNKL,dnkl_When);
	setValid(HDNKL,dnkl_Valid);
	setFocus(COD);
}
function prkSave(m)
{
	m.FVID_PRK = extPar.fvid;
	m.FBDAT = HBDAT.value;
	m.FEDAT = HEDAT.value;	
	m.FDAT_BOL = HDAT_BOL.value;
	m.FMES_VIP = HMES_VIP.value;
	m.FSUM	= Number(Number(HDN.value) * 1000 + Number(HCHAS.value));	
	//m.FNOM_PRIK = HDN_KF.value;
	m.FCALNUM = HKF.value;	
	m.FPROC = HSUM.value;
	m.FWID_WP = dpShtat.getFwid();
	
	//m.FSHPZ = hpz;
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;

	m.FTABN_ID = dpShtat.getEmployeFwid();
	m.FNUM = HNUM.value;
	//if (extPar.mode!="EDIT"){	
		m.FDNKL	= day_difference(HBDAT.value,HEDAT.value);
	//}	
	//если есть параметр, то пытаемся проставить признак неявки в табеле
	if(getPar("NVK_PRIK"))
	{
		var kodnvk=0;
	    var oSnap = getSnap("select Fkod_nvk from ^cl_nvk where Frblnall='+'");
	    if (oSnap!=null)
	    	var kodnvk=Number(oSnap[0])
	    if (kodnvk==0)
	    {
	    	alert(ru("Не найдено ниодной записи, относящейся к больничным в настрйоках для табелей",
	    			"Не знайдено жодного запису, який би відносився до лікарняних в налаштуванні для табелів!"));
	    }
	    else
	    {
	    	include("prik\\calculate\\r_mnvk.js");
	    	r_mnvk(m.FTABN_ID, m.FWID_WP, 0, 0, day_difference(m.FBDAT,m.FEDAT), 0, kodnvk, m.FBDAT, this.oPrik.getID());
	    }
	}
	
	//при копировании идентификатор упрощенного больничного обнуляем
	if(extPar.mode == "COPY")
		m.FWID_PRIK = 0;
}

function edat_Valid()
{
	if (differ(toScriptDate(HBDAT.getValue()), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата неприпустима!|Пустая дата недопустима!"));
		return false;
	}
	if (differ(HEDAT.value, HBDAT.value) == -1)
	{
		WAIT(UR("Дата закінчення не може бути менша за дату початку!|Дата конца не может быть меньше даты начала"));
		return false;
	}
	return true;
}

function dat_bol_Valid()
{
	if (differ(toScriptDate(HDAT_BOL.value), toScriptDate(d00)) == 0)
	{
		WAIT(UR("Порожня дата першого дня непрацездатності неприпустима!|Пустая дата первого дня нетрудоспособности недопустима!"));
		return false;
	}
	if (differ(HDAT_BOL.value, HBDAT.value) > 0)
	{
		WAIT(UR("Дата першого дня непрацездатності не може бути більшою за дату початку!|Дата первого дня нетрудоспособности не может быть больше даты начала"));
		return false;
	}
	return true;
}

function dnkl_When()
{
	if(HDNKL.value == 0)
		HDNKL.value = day_difference(HBDAT.value,HEDAT.value);
}

function dnkl_Valid()
{
	HDNKL.value = day_difference(HBDAT.value,HEDAT.value);
	return true;
}