include("l_eprkekz.js");
include("servis/date.js");

function prkLoad()
{
	TAB_ZRP.setMask("-#########.##");
	NUMER.setMask("-###");
	FCHAS.setMask("-####.##");
	FDNKL.setMask("-###");	
	mFlgot.setMask("#"); 

	dpLicf = new DpLicf();
	dpLicf.linkCtrl(LC_NUM, LC_TXT);
	
	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", TAB_N);
	dpShtat.linkCtrl("wcl.ftxt", TAB_NAME);

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(mFshpz, mFshpz_txt);

   switch(extPar.mode)
   {
   	case "ADD":
		include("servis/date.js");
		HBDAT.value = extPar.dat1;
		HEDAT.value = lastDay(extPar.dat1);
		TAB_ZRP.value = 0;
		NUMER.value = 0;
		FCHAS.value = 0;
		FDNKL.value = 0;		
		mFlgot.value = 0;
		break;
	case "VIEW":
	case "EDIT":
	case "COPY":
		HBDAT.value = table.getValue("fbdat");
		HEDAT.value = table.getValue("fedat");     
		NUMER.value = table.getValue("fday");
		FCHAS.value = table.getValue("fchas");
		FDNKL.value = table.getValue("fdnkl");		
		TAB_ZRP.value = table.getValue("fsum");
		mFlgot.value = 0;
		dpShtat.setPeriod(extPar.dat1, extPar.dat2);
		dpShtat.setFwid(table.getValue("fwid_wp"));	
		if (dpShtat.getEmployeShtatID() == 0)
			mFlgot.value = table.getValue("fday");
	}
		
	setValid(TAB_ZRP, TAB_ZRP_Valid);
	setValid(HEDAT, HEDAT_Valid());
	
	setFocus(LC_NUM); 
}

function prkSave(m) 
{
	var is_nachis = (dpLicf.getFis6() == "+");
	m.FFLD_NUM = LC_NUM.getValue();
	m.FWID_WP = dpShtat.getFwid();
	m.FTABN_ID = dpShtat.getEmployeFwid();
	m.FLSFID = Number(dpLicf.getFid());
		
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(m.FLSFID));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;
	
	m.FSUM = TAB_ZRP.getValue();	
	m.FBDAT = HBDAT.getValue();
	m.FEDAT = HEDAT.getValue();  
	m.FDAY = NUMER.getValue();
	m.FCHAS = FCHAS.getValue();
	m.FDNKL = FDNKL.getValue();	
	//m.FSHPZ = hpz;
	m.FIS_DAY = 0;
	var snap = getSnap("SELECT fis1 FROM ^lic_fld WHERE fid = " + sqlTo(m.FLSFID));
	if (is_nachis && snap != null && (snap[0] == "п" || snap[0] == "s"))
	{
		m.FDAY = mFlgot.getValue();
		m.FIS_DAY = 2;
	}
}


function TAB_ZRP_Valid()
{
   if (TAB_ZRP.getValue() == 0)
   {
      WAIT(UR("Нульове значення неприпустиме!|Нулевое значение недопустимо!"));
      return false;
   }  
   return true;
}

function HEDAT_Valid()
{
   if (toScriptDate(HBDAT.getValue()).getMonth() != toScriptDate(HEDAT.getValue()).getMonth())
   {
      WAIT(UR("Місяць дати закінчення повинен співпадати з місяцем дати початку!|Месяц даты конца должен совпадать с месяцем даты начала!"));
      return false;
   }  
   return true;
}