include("l_eprkekz.js");
include("Objects/DpCl.js");

var oVisl;

function prkLoad()
{
	HNOM_PRIK.setMask(strRepl("&", 15));
	HSHPZ.setMask("&&&&&&&&&&&&&&&");
	HCLVISL.setMask("###");
	Disable(HCLVISLTXT);

    var Osn = getSnap("select FLSFID from ^CL_PRIK where Fvid="+sqlTo(extPar.fvid));
    if (Osn!=null){
       var lic_fid = Osn[0];
    }else{
       var lic_fid = 0;
    }
    var Osn2 = getSnap("select FAN from ^LIC_FLD where Fid="+sqlTo(lic_fid));
    if (Osn2!=null){    
      zat = allt(String(Osn2[0]));
    }else{
      zat = "0";
    }

	dpShifPZ = new DpShifPZ();
	dpShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);
	
	dpShtat = new DpShtat(null, null, null);
	dpShtat.linkCtrl("fcod", COD);
	dpShtat.linkCtrl("wcl.ftxt", TXT);
	dpShtat.linkCtrl("o.ftxt", PODR);
	dpShtat.linkCtrl("dcl.ftxt", DOL);
	
	setValid(HCLVISL,fclValid);
    this.cl_selected = cl_selected;
    setButton(HCLVISL, this, "cl_selected");
	
	switch (extPar.mode)
	{
		case "ADD":
			HBDAT.value = extPar.dat1;
			HEDAT.value = extPar.dat2;
//			var snap = getSnap("SELECT MAX(fnom_prik) FROM " + extPar.tblName);
//			HNOM_PRIK.value  = (null == snap) ? 1 : ((null == snap[0]) ? 1 : (snap[0] + 1));
			HDAT_PRIK.value = d00;
		break;
		case "EDIT": 
		case "COPY":
		case "VIEW":
			HBDAT.value = table.getValue("fbdat");
			HEDAT.value = table.getValue("fedat");
			HNOM_PRIK.value  = table.getValue("fnom_prik");
			HDAT_PRIK.value  = table.getValue("fdat_prik");
			HCLVISL.value = table.getValue("fsum");
			fclValid();
		break;	
	}
	setFocus(COD);
}

function prkSave(m)
{
	m.FVID_PRK 	= extPar.fvid;
	m.FBDAT 	= HBDAT.value;
	m.FEDAT 	= HEDAT.value;
	m.FNOM_PRIK = HNOM_PRIK.value;
	m.FDAT_PRIK = HDAT_PRIK.value;
	//m.FSHPZ = hpz;
	//03.04.08  Если не входим в поле ШПЗ,то должен проставить код автоматом из штатного расписания+замена последней цифры 
	cFshpz = hpz;
    if (hpz=="" || hpz=="0" || hpz==0 || (zat!="0" && hpz==zat)){
    	cFshpz = dpShtat.getFshpz()
        if (zat!="0"){
      		//*заменить последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
      		cFshpz = allt(cFshpz).substring(0,allt(cFshpz).length-1)+allt(String(zat))
    	}
    } 
    m.FSHPZ = cFshpz;
	
	m.FWID_WP 	= dpShtat.getFwid();
	m.FTABN_ID  = dpShtat.getEmployeFwid();
	m.HCLVISL = HCLVISL.value;
}

function cl_selected()
{
	var par = new Object();
	par.zaval = true;
	par.ret = new Object();
	par.ret.FCOD = 0;
	par.ret.FTXT = 0;
	par.sWhere = "Fvid="+sqlTo("clvisl");
	showWindow("l_clcl.js", SW_MODAL, par);
	if(par.escape)
		return;
	
	HCLVISL.value = par.ret.FCOD;
	HCLVISLTXT.value = UR(par.ret.FTXT);
}

function fclValid()
{
	if(HCLVISL.value == 0)
	{
		var sMsg = UR("Не вказаний довідник!|Не указан справочник!");
		setFocus(HCLVISL);
		HCLVISL.showErr(sMsg);
		return false;
	}
	var oSnap = getSnap("select Ftxt from ^CLCL where FCOD="+HCLVISL.value);
	if(oSnap && oSnap[0])
		HCLVISLTXT.value = UR(oSnap[0]);
	return true;
}