//почтовый сбор в отдельном поле ЛС (mvvlsfid), код поля ЛС алиментов определяем по настройкам либо передаем в VVLSFID2
//***   а)если сумма % для таб.N >100, то выдается сообщение в деф.вед.;
//***   б)если сумма % для таб.N <=100, то вычисляется по файлу SVZP сумма,
//***     по которой начисляются алименты
//***3. Если сумма з/п<=0,то сообщ. в деф.вед. В противном случае вычисл.
//***   алименты по каждому исполнит.листу для данного таб.N.
//***   В файле SV_ALIM - поля Fsum, Fsbor - C4
//***   В файле DLG_AL  - поля Fsum, Fsbor - C4
//************************************************************************
// передаются ДАТА расчета - для использования нужных временных файлов
// mvvopl - вид оплаты
// № поля как считать (например, Оклад,совместители), куда передается результат ffld  mvvdpl
// код поля ЛС flsfid  mvvlsfid


//подключаем функцию нахождения суммы для постоянных величин
include("get_cnst.js");
include("objects/DpDefVed.js");
include("objects/DpCalendar.js");
//include("sys\\DpSql.js");
//super vv 07.03.2001 Испр. ошибка - было "function r_alim6 (..."
function name_alim10()
{
	return "Аліменти (поштовий збір в окремому полі ОР)|Алименты (почтовый сбор в отдельном поле ЛС)"
}

function r_alim10(mdat,mvvopl,mvvprk,mvvlsfid,VVLSFID2,ftabn_id, svzpName)
{
	var isCalend = true;
   var base_month1=base_month;
   var ls_sbor=mvvlsfid;//Код поля почтового сбора
   var gS = getSnap("select ffld_num from ^lic_fld where fid="+sqlTo(mvvlsfid))
   if(gS!=null)
   		num_sbor=gS[0];//Номер поля почтового сбора
   else
   		num_sbor=0;
   var DefVed = new DpDefVed();
   var strSQL,str_alert;

   var C9000 = 9000;
   var C8999 = 8999;

   var tbl_prk=new Object();
   var tbl_lic=new Object();
   var tbl_svzp=new Object();

   var min_zp  = get_cnst("minimum" , mdat);

   var mas = new Array();
   mas[0] = "CH_ALIM10";
   mas[1] = "CH_ALIM11";

   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1)

   // дата конца
 //  var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate()
   var D2 = new Date(lastDayMonth(mdat));


   var alim_table=OpenTable("SELECT * FROM ^PROC_AL WHERE FBDAT <= " + sqlTo(D2) + " AND FEDAT >= " + sqlTo(D1) 
   							+" order by F_STSUM DESC,F_BASNL")
	if(alim_table.IsBOF() && alim_table.IsEOF())
	{
		msg = ru("Справочник ставок пуст. Расчет не может быть выполнен!","Довідник ставок порожній. Розрахунок не може бути виконаний!");
		writeToLog(msg,"e",mvvopl,mvvprk,mvvlsfid);
		alim_table.close();
		return;
	}
	
	//26.12.07 Электронный сбор при ЗП на карточках
    var el_table=OpenTable("s","SELECT * FROM ^NALOG_MS WHERE FBDAT <= " + sqlTo(D2) + " AND FEDAT >= " + sqlTo(D1) 
   							+" order by F_STSUM DESC,F_BASNL")
    var fis_elspr = true;                 
	if(el_table.IsBOF() && el_table.IsEOF())
	{
    	var fis_elspr = false;		
	}

	var D1 = new Date(firstDayMonth(mdat));
	var D2 = new Date(lastDayMonth(mdat));
	var sqlTabn = "";
	if(ftabn_id)
		sqlTabn = " and p.Ftabn_id in ("+ftabn_id+")";
      
	if (mvvopl < C9000)
		strSQL="select "+GetPatternIntersection("PRK_ALL","PRK_ALL","p").replace(/p.FVOPL,/g,"")+",w.fvopl from ^PRK_ALL as p inner join ^work_pers as w on w.fwid=p.fwid_wp"
			+ " where p.Fvid_prk="+ mvvprk+
				" and w.Fvopl="+ mvvopl+
				" and p.fbdat<="+ sqlTo(D2)+
				" and p.fedat>="+ sqlTo(D1)+sqlTabn+
				" order by p.Ftabn_id";
	else
		strSQL="select "+GetPatternIntersection("PRK_ALL","PRK_ALL","p").replace(/p.FVOPL,/g,"")+",w.fvopl from ^PRK_ALL as p inner join ^work_pers as w on w.fwid=p.fwid_wp"
			+ " where p.Fvid_prk="+mvvprk+" and p.fbdat<="+
				sqlTo(D2)+" and p.fedat>="+
				sqlTo(D1)+sqlTabn+
				" order by p.Ftabn_id";

	tbl_prk=OpenTable("s",strSQL);

	if (tbl_prk.IsBOF() && tbl_prk.IsEOF())
	{
		tbl_prk.Close();
		return;
	}

	tbl_lic=OpenTable("s", "LIC_FLD");
	//var gS = getSnap("SELECT Fid, Ffld_num FROM ^LIC_FLD WHERE Fis5='а'");

   if (!tbl_lic.FindFirst("Fis5='а'"))
   {
      str_alert=" Обнаружена серьезная ошибка функционирования системы \n"+
                " Hевозможно идентифицировать поле ЛС: алименты        \n"+
                "       Пригласите разработчиков для устранения        "
      writeToLog(str_alert,"e",mvvopl,mvvprk,mvvlsfid);

      tbl_prk.Close();
      return;
   }
   DefVed.begin("","Проверка расчетa алиментов");

	var nach_lsfid = (VVLSFID2>0)?VVLSFID2:tbl_lic.getValue("Fid");
	if (VVLSFID2>0)
		var nach_lsnum = getLsNum(VVLSFID2);
	else
		var nach_lsnum = tbl_lic.getValue("Ffld_num");
   tbl_lic.close();
   var szTag = (mdat.getFullYear())+((mdat.getMonth()< 9)?"0":"") + (mdat.getMonth()+1); 
   var monthtxt=szTag;
   var SVZPFILE=(svzpName?svzpName:"svzp")+monthtxt;

   if (!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE))   
   {
      CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");
   }

   var max_offset = 12
   var ssum=new Array(max_offset);
   var ssum_nlg  =new Array(max_offset);
   var ssum_minus=new Array(max_offset);   
   var sum_proc;


   //---------------------- полный пересчет --------------------------------
//        tbl_sv_alim=OpenTable("s","SV_ALIM","SV_ALIM");

   tbl_prk.MoveFirst();
	BeginTransaction(4);
   while (!tbl_prk.IsEOF())
   {
		// накопление алиментооблагаемой суммы ЗП
		var prew     = tbl_prk.getValue("Ftabn_id");
		sum_proc=0;

		for (j=0;j<max_offset;++j)
		{
			ssum[j]=0;
			ssum_nlg[j]=0;
			ssum_minus[j]=0;        
		}

		var mn_vip;
		var mn_voz;
		var offset;

		strSQL="select * from ^"+
             SVZPFILE+" where Ftabn_id="+
             prew+" order by Flsfid";

		tbl_svzp=OpenTable("s",strSQL);

		while (!tbl_svzp.IsEOF())
		{
			// поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
			// поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
			// поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn

			switch(Number(tbl_svzp.getValue("Fvp")))
			{
				case 0:
					mn_vip=new Date(mdat);
					mn_voz=new Date(mdat);
					offset = 1;
				break;
				case 1:
					mn_vip=new Date(tbl_svzp.getValue("Fmn"));
					mn_voz=new Date(mdat);
					offset = 0;
				break;
				case 2:
					mn_vip=new Date(mdat);
					mn_voz=new Date(tbl_svzp.getValue("Fmn"));
            //     offset = (12*(mn_voz.getYear()-mn_vip.getYear())-(mn_voz.getMonth()-mn_vip.getMonth()));
					offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1   //смещение от базового месяца
				break;
				default:
					msg = "Ошибка поля Fvp таблицы "+SVZPFILE;
					writeToLog(msg,"e",mvvopl,mvvprk,mvvlsfid);
					tbl_prk.Close();
					tbl_svzp.Close();
					RollbackTrans();
					return;
				break;
			}
		 
			var gS = getSnap("select Fis5,Fis1,Fis8 from ^LIC_FLD where fid=" + sqlTo(tbl_svzp.getValue("Flsfid")));
			if (gS == null)
			//if (!tbl_lic.Seek("=",tbl_svzp("Flsfid")))
			{
				msg = "Ссылка на неизвестное поле лицевого счета "+String(tbl_svzp.getValue("flsfid"))+". Пригласите разработчиков для устранения";
				writeToLog(msg,"w",mvvopl,mvvprk,mvvlsfid);
			}
			else if (offset>=1)
			{
				ssum[offset] = (gS[0]=="+" ? ssum[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum[offset]);
				//помимо отдельных фондов вычитаем также ЕСВ
				ssum_nlg[offset] = (gS[1]=="п" || gS[1]=="s" || gS[1]=="з" || gS[2]=="п" || gS[2]=="с" || gS[2]=="5" || gS[2]=="6"? ssum_nlg[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum_nlg[offset]);
				/*ssum_nlg[offset] = (gS[1]=="s" ? ssum_nlg[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum_nlg[offset]);
				ssum_nlg[offset] = ( (gS[1]=="з" || gS[2]=="п") ? ssum_nlg[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum_nlg[offset]);
				ssum_nlg[offset] = (gS[2]=="с" ? ssum_nlg[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum_nlg[offset]);*/
				//12.06.09
				ssum_minus[offset] = (gS[0]=="*" ? ssum_minus[offset]+Number(tbl_svzp.getValue("Fsum")) : ssum_minus[offset]);            
			}
			tbl_svzp.MoveNext();
		}
		tbl_svzp.Close();
		// перебор приказов на алименты
		// на каждый приказ  набор записей в соответствии с offset
		sum_proc=0;
		while (!tbl_prk.IsEOF() && Number(tbl_prk.getValue("Ftabn_id"))==prew)
		{      
			sum_proc = sum_proc + Number(tbl_prk.getValue("Fproc"));
			if (sum_proc > 100)
			{
				str_alert = "Алименты для таб.N"+getCodFromID(tbl_prk.getValue("Ftabn_id"))+" превышают з/п";
				DefVed.write(str_alert,"","");
				writeToLog(str_alert,"w",mvvopl,mvvprk,mvvlsfid);
			}

			var ii=1;
			while (ii < max_offset)
			{
				var v_dat;
				var mFmn,mFvp;

				if (ii > 1)
				{
					v_dat = new Date(mdat);
					v_dat.setMonth(v_dat.getMonth()+ii-1);
					v_dat.setDate(1);
					mFmn = new Date(v_dat);
					mFvp = 2
				}
				else
				{
					mFmn = new Date(mdat);
					mFvp = 0
				}
				//чтоб исключить уд.с отпуска буд.периода если закончен срок по исп.листу
				if (differ(new Date(tbl_prk.getValue("FEDAT")),mFmn)>=0) //if (new Date(tbl_prk.getValue("FEDAT"))>=mFmn)
				{
					//что бы алименты брались вплоть до дня закрытия алиментов
					//новый алгоритм (расчет рабочих дней по календарю)
					var calend = 0;
					var n_Day = 0;
					var sum_k_w_d = 0;
					var oCalend = new dpCalendar();
					var tabn = getCodFromID(tbl_prk.getValue("Ftabn_id"));
					var pbdat = new Date(tbl_prk.getValue("Fbdat"));
					var pedat = new Date(tbl_prk.getValue("Fedat"));
					var mbdat = new Date(firstDayMonth(mFmn));
					var medat = new Date(lastDayMonth(mFmn));
					//если приказ не полностью охватывает месяц расчета
					if(differ(pbdat,mbdat)>0 || differ(pedat,medat)<0)
					{
						//находим пересечение периода алиментов с месяцем расчета
						var bdat = differ(pbdat,mbdat)>0?pbdat:mbdat;
						var edat = differ(pedat,medat)<0?pedat:medat;
						
						//сперва ищем календарь по табельному номеру
						var snap = getSnap("select MAX(Fcod) from ^hcalend where Ftabn="+tabn);
						if(snap && snap[0])
						{
							calend = snap[0];
							oCalend.setCod(calend);
							n_Day = oCalend.getCalDays("Р", D1, D2, 0, true);
							sum_k_w_d = oCalend.getCalDays("Р", bdat, edat, tabn, true);
						}
						if(!calend)
						{
							//ищем календарь в ШР
							snap = getSnap("select Fcalend from ^work_pers where Fwid="+tbl_prk.getValue("Fwid_wp"));
							if(snap && snap[0])
							{
								calend = snap[0];
								oCalend.setCod(calend);
								n_Day = oCalend.getCalDays("Р", D1, D2, 0, true);
								sum_k_w_d = oCalend.getCalDays("Р", bdat, edat, 0, true);
							}
						}
						if(!calend)
						{
							//берем первый попавшийся календарь по дням и не в разрезе табельных номеров
							snap = getSnap("select MIN(Fcod) from ^cl_calend where Fishours="+sqlFalse+" and Fistabn="+sqlFalse);
							if(snap && snap[0])
							{
								calend = snap[0];
								oCalend.setCod(calend);
								n_Day = oCalend.getCalDays("Р", D1, D2, 0, true);
								sum_k_w_d = oCalend.getCalDays("Р", bdat, edat, 0, true);
							}
							else
							{
								if(isCalend)
								{
									isCalend = false;
									msg = ru("В справочнике календарей отсутствует календарь по дням не ведущийся по табельным номерам!",
											"У довіднику календарів відсутній календар по днях, що не ведеться по табельним номерам!");
									writeToLog(msg,"w",mvvopl,mvvprk,mvvlsfid);
								}
							}
						}
					}
					if(n_Day == 0)//старый алгоритм из 2000-й версии, но без учета праздничных дней
					{
						var snap =getSnap("SELECT DISTINCT FNORMA_D"
								+" FROM ^TBL_INI WHERE FBDAT<="+sqlTo(mFmn)
								+" AND FEDAT>="+sqlTo(mFmn)
								+" AND FVOPL="+sqlTo(tbl_prk.getValue("FVOPL")))
						if(snap && snap[0])
							var n_Day=snap[0];
						else
							var n_Day=1;
						//Считаем количество оплачиваемых дней в месяце
						var tMonth=mFmn.getMonth();
						var tYear=mFmn.getFullYear();
						var medat=new Date(lastDayMonth(mFmn));
		
						if(differ(new Date(tbl_prk.getValue("FEDAT")),medat)<0)//if(new Date(tbl_prk.getValue("FEDAT"))<=medat)
						{
							var tDay=new Date(tbl_prk.getValue("FEDAT")).getDate();
							var i;
							sum_k_w_d=0
							for(i=1;i<=tDay;i++)
							{
								var nDate=new Date(tYear,tMonth,i);
								if ((nDate.getDay()>0)&&(nDate.getDay()<6))
								{
									sum_k_w_d++;
								}
							}
							//если были праздничные, то кол-во дней может получиться больше нормы
							if(sum_k_w_d>n_Day)
								sum_k_w_d=n_Day;
						}
						else
							sum_k_w_d=n_Day;
						//если норма дней в будущем месяце не проставлена, тогда переопределяем sum_k_w_d, чтоб наша сумма не увеличилась в sum_k_w_d раз 
						if(n_Day==1)
							sum_k_w_d = 1;
					}
					mFsum   = 0
					mFsbor  = 0
	
					var sum_obl = ssum[ii]-ssum_nlg[ii]				
				
					if (sum_obl > 0)
					{
						//mFsum = round(((ssum[ii]-ssum_nlg[ii])*sum_k_w_d/n_Day*Number(tbl_prk.getValue("Fproc")))/100+Number(tbl_prk.getValue("Fsum")),2);
						mFsum = round((sum_obl*sum_k_w_d/n_Day*Number(tbl_prk.getValue("Fproc")))/100+Number(tbl_prk.getValue("Fsum")),2);               
						if (ii==0)
							mFsum = (mFsum<min_zp/2 ? min_zp/2 : mFsum); // НИКОГДА  НЕ РАБОТАЕТ!!!!!
						if (!mFsum==0)  
						{  
							// tbl_svzp=OpenTable("s",SVZPFILE);
							// tbl_svzp.AddNew();
							var m = new Object();
							m.Ftabn_id = tbl_prk.getValue("Ftabn_id");
							m.Fwid_wp = 0;
							m.Flsfid = nach_lsfid;
							m.Ffld_num = nach_lsnum;
							m.Fsum = (num_sbor*ls_sbor==0)?mFsum + mFsbor:mFsum;
							m.Fpr = 0;
							m.Fbdy = 0;
							m.Fedy = 0;
							m.Fid_prk = tbl_prk.getValue("Fwid");
							m.Fvid_prk = tbl_prk.getValue("Fvid_prk");
							if (mFvp>0)
								m.Fmn = mFmn;
							m.Fvp = mFvp;
							m.Fday = 0;
							m.Fproc = tbl_prk.getValue("Fproc");
							UpdateTable("^" + SVZPFILE,m,true);
							// контрольная печать
							str_alert="---"+monthtxt+"---\n"+
	                            " Алим.: Т.н.="+tbl_prk.getValue("Ftabn_id")+"\n"+
	                            " ЗП="+(ssum[ii]-ssum_nlg[ii])+"\n %="+tbl_prk.getValue("Fproc")+
								"\n алим.="+mFsum+"           сбор="+mFsbor+"\n Итого="+(mFsum+mFsbor);
							WAIT(str_alert);
						}
					}
				}
				ii = ii+1
			}
			tbl_prk.MoveNext();
		}
	}
	tbl_prk.Close();
	//Чтобы нормально записывало после запятой
	StrSQL="UPDATE ^"+SVZPFILE+" SET FSUM=" + Convert(sqlRound("FSUM",2)+"*100","INT") + "/100"
				+",FPR=" + Convert(sqlRound("FPR",2)+"*100","INT") + "/100 WHERE FLSFID="+sqlTo(nach_lsfid)+(ftabn_id?" and Ftabn_id in("+ftabn_id+")":"");
   ExecuteSQL(StrSQL);
   if(ls_sbor!=0)
   {
	      StrSQL="UPDATE ^"+SVZPFILE+" SET FSUM=" + Convert(sqlRound("FSUM",2)+"*100","INT") + "/100 WHERE FLSFID="+sqlTo(ls_sbor)+(ftabn_id?" and Ftabn_id in("+ftabn_id+")":"");
	      ExecuteSQL(StrSQL)
		  //гРУПИРУЕМ ПОЧТОВІЙ СБОР ПО НОМЕРУ ДЕЛА
		  if(IsTable(mas[0])) DropTable(mas[0])
 		  if(IsTable(mas[1])) DropTable(mas[1])
		   //mdat=new Date(mdat);
	//?????	   ExecuteSQL("DELETE FROM ^"+SVZPFILE+" WHERE FLSFID="+ls_sbor)
//ПОДБИВАЕМ АЛИМЕНТЫ В РАЗРЕЗЕ ЧЕЛОВЕКА И ПРИКАЗА 01.08.02		
		  //26.12.07	
		  StrSQL="SELECT A.FSUM AS FSUM,A.FTABN_ID,A.FLSFID"
					+",A.FFLD_NUM,"+sqlD00+" as Fmn,0 as Fvp,0 as fday,0 as fbdy,0 as fedy,0 as Fwid_wp,0 as fpr"
					+" ,B.FID,P.FSBOR,P.FNUM,a.Fid_prk,P.FNOM_PRIK "
					+" INTO " + mas[0]
					+" FROM ^"+SVZPFILE+" AS A INNER JOIN ^PRK_ALL AS P ON A.FID_PRK=P.FWID AND A.FTABN_ID=P.FTABN_ID"
						+" INNER JOIN ^PRK_AL AS B ON P.FWID=B.FWID "
					//+" WHERE A.FID_PRK=B.FWID"
					//+" AND A.FTABN_id=W.FWID_CL"
					+" WHERE A.FLSFID="+sqlTo(nach_lsfid)+" AND P.FIN_TABLE='PRK_AL' "+sqlTabn
//					+" AND ((MONTH(B.FEDAT)="+(mdat.getMonth()+1)
//					+" AND YEAR(B.FEDAT)="+mdat.getFullYear()
//					+") OR B.FEDAT>="+sqlTo(new Date(mdat.getFullYear(),mdat.getMonth()+1,0))+")"
					+" order BY A.FTABN_ID,A.FLSFID,A.FFLD_NUM,B.FNUM,B.FID,B.FSBOR,a.Fid_prk"
		  ExecuteSQL(StrSQL);
//ПОДБИВАЕМ АЛИМЕНТЫ В РАЗРЕЗЕ ЧЕЛОВЕКА И НОМЕРА ДЕЛА 		
		  StrSQL="SELECT SUM(A.FSUM) AS FSUM,A.FTABN_ID,A.FLSFID"
					+",A.Fid_prk,"+sqlD00+" as Fmn,0 as Fvp,0 as fday,0 as fbdy,0 as fedy,0 as Fwid_wp,0 as fpr"
					+",A.FID,A.FSBOR,A.FNUM,A.FNOM_PRIK"
					+" INTO " + mas[1]
					+" FROM " + mas[0] + " AS A "
					+" WHERE A.FLSFID="+sqlTo(nach_lsfid)
					+" AND A.FID=" + SqlFalse
					+" GROUP BY A.FTABN_ID,A.FLSFID,A.FNUM,A.FID,A.FID_PRK,A.FSBOR,A.FNOM_PRIK"//A.FFLD_NUM
	      ExecuteSQL(StrSQL);
	      
	      //для совместимости информации. Если fsbor=0 и Fid=false и FNOM_PRIK=0 or null, то Fnom_prik=1, т.е. почтовый сбор
	      strSQL = "UPDATE " + mas[1]+" set Fnom_prik='1' where Fsbor=0 and Fid="+sqlFalse+" and Fnom_prik='0'";
	      ExecuteSQL(strSQL);
	      	      
		  //Вычисляем сбор у тех, у кого фиксированиый почтовый сбор 
		  StrSQL="UPDATE " + mas[1]
						+" SET FSUM=" + Convert(sqlRound("FSUM*FSBOR",2),"INT") + "/100 "
						+" WHERE FSBOR>0"
						+" AND FID=" + sqlFalse;
	      ExecuteSQL(StrSQL);
//Вычисляем почтовый сбор у тех, у кого он берётся по шкале
		  StrSQL="UPDATE " + mas[1]
					+" SET FSUM="
			//Формируем таблицу почтового сбора для SQL запрос
			if(!alim_table.IsEmpty())
			{
				for(alim_table.MoveFirst();!alim_table.IsEOF();alim_table.MoveNext())
				{
//					StrSQL += IIF("A.FSUM > " + alim_table.getValue("F_STSUM"),
//								IIF(alim_table.getValue("F_PROC") + " > 0",
//										sqlRound("0.01*A.FSUM*" + alim_table.getValue("F_PROC"),"2"),
//										alim_table.getValue("FSUM")),"0");
					StrSQL += "(CASE WHEN "+"FSUM > " + alim_table.getValue("F_STSUM")+
							" THEN "+IIF(alim_table.getValue("F_PROC") + " > 0",
									sqlRound("0.01*FSUM*" + alim_table.getValue("F_PROC"),"2"),
									alim_table.getValue("F_BASNL"))+" ELSE ";
				}
				StrSQL+="0";
				for(alim_table.MoveFirst();!alim_table.IsEOF();alim_table.MoveNext()) 
						StrSQL+=" END)";
			}
			else
		  //if (alim_table.recordCount() == 0)
				StrSQL+="0";
		  //26.12.07		 
		  StrSQL+=" WHERE FSBOR=0 AND FNOM_PRIK='1' "
			  	       +" AND FID=" + SqlFalse;
		  ExecuteSQL(StrSQL);

	      //26.12.07
	      if (fis_elspr){
		  	//Вычисляем электронный сбор у тех, у кого он берётся по шкале
		  	StrSQL="UPDATE " + mas[1]
					+" SET FSUM="
			//Формируем таблицу электронного сбора для SQL запрос
			if(!el_table.IsEmpty())
			{
				for(el_table.MoveFirst();!el_table.IsEOF();el_table.MoveNext())
				{
//					StrSQL += IIF("A.FSUM > " + alim_table.getValue("F_STSUM"),
//								IIF(alim_table.getValue("F_PROC") + " > 0",
//										sqlRound("0.01*A.FSUM*" + alim_table.getValue("F_PROC"),"2"),
//										alim_table.getValue("FSUM")),"0");
					StrSQL += "(CASE WHEN "+"FSUM > " + el_table.getValue("F_STSUM")+
							" THEN "+IIF(el_table.getValue("F_PROC") + " > 0",
									sqlRound("0.01*FSUM*" + el_table.getValue("F_PROC"),"2"),
									el_table.getValue("F_BASNL"))+" ELSE ";
				}
				StrSQL+="0";
				for(el_table.MoveFirst();!el_table.IsEOF();el_table.MoveNext()) 
						StrSQL+=" END)";
			}
			else
		  //if (alim_table.recordCount() == 0)
				StrSQL+="0";
		 
		  	StrSQL+=" WHERE FSBOR=0 AND FNOM_PRIK='2' "
			  	       +" AND FID=" + SqlFalse;
		  	ExecuteSQL(StrSQL);
	      }	

 	      StrSQL=" insert into ^"+SVZPFILE + " (FSUM,FTABN_ID,FWID_WP,FID_PRK,FMN,FVP,FBDY,FEDY,FPR,FLSFID,FFLD_NUM)"
						+" SELECT  A.FSUM,A.FTABN_ID,A.FWID_WP,A.FID_PRK,A.FMN,A.FVP"
						+",A.FBDY,A.FEDY,A.FPR,"+ls_sbor+" AS FLSFID"
						+","+num_sbor+" AS FFLD_NUM"
						+" from " + mas[1] + " AS A"
						+" WHERE A.FSUM>0"
		  ExecuteSQL(StrSQL)
		  //Убираем с поля SHPZ служебную информацию
		  StrSQL="UPDATE ^"+SVZPFILE+" SET FSHPZ='0' WHERE FLSFID="+sqlTo(nach_lsfid);
		  ExecuteSQL(StrSQL);
//		  if(IsTable(mas[0])) DropTable(mas[0]);
//          if(IsTable(mas[1])) DropTable(mas[1]);
   }
   CommitTrans();
alim_table.close();
el_table.close();
tbl_svzp.close();
   return;
}
