//расчет аванса
// ***********************************************************************
// расчет единовpеменных доплат для заданного в R_ALL типа оплаты
// ***********************************************************************
function name_avns()
{
	return "Аванс";
}

function r_avns(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);
	
	if (!IsTableEx("ZRP_MDB", "ZRP_AVNS" + szTag))
		return false;
	
	if (!IsTableEx("ZRP_RES", "ZRP_"+(svzpName?svzpName:"svzp") + szTag))
	{
		var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + (svzpName?svzpName:"svzp") + szTag, "svzp");
	}

	strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag 
				+ "(Ftabn_id, fwid_wp, ffld_num, flsfid, fsum, fday, fis_day, fid_prk, fvid_prk)"
			+ " SELECT pa.Ftabn_id, " + (svzpName?"pa.Fwid_wp":"0") + " as Fwid_wp"
	 			+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
	 			+ ", " + sqlTo(lsfid) + " as flsfid"
				+ ", pa.fsum"
				+ ", 0 as fday"
				+ ", 0 as fis_day"
				+ ", pa.fwid as fid_prk"
				+ ", pa.fvid_prk"
			+ " FROM ^prk_all AS pa RIGHT JOIN ^avns" + szTag + " AS av ON pa.Fwid=av.Fwid"
			+ " WHERE pa.Fvid_prk="+sqlTo(vidprk)+" AND pa.Fsum > 0 "
				+(ftabn_id?" AND pa.Ftabn_id in ("+ftabn_id+")":""); 

	ExecuteSQL(strSQL);
	return true;
}