//расчет величины % индексации для каждого человека из приказа
function r_bind (dat_rasch, tabn, vopl,fwid_shtr)
{
	//ищем ближайшую к дате dat_rasch запись штатного расписания, в которой менялся оклад и возвращаем fwid этой записи
	// поиск идет по табельному номеру и виду оплаты 
	var izm_dol = 0;
	
	//изменения в индексации с 2012 года
	//значение этой константы - дата перехода на новый расчет индексации, по закону - 01.06.12
	var ind2012 = new Date(get_cnst("ind2012", dat_rasch))	
	
	//определяем дату последнего принятия на работу, чтобы исключить предыдущие записи до увольнения
	var snap = getSnap("select MAX(Fbdat) from ^work_pers where Fwid_cl="+tabn+" and Fis_nazn="+sqlTrue);
	var lastDatNazn = d00;
	if(snap)
		lastDatNazn = snap[0];
	//расчет последней записи по изменению оклада
	// передается дата, до которой нужно найти последнюю дату изменения оклада
	var strSQL = "SELECT wp.fwid_cl, wp.fwid, wp.Fvopl, wp.Ftable, wp.Fbdat, wp.Fedat, dol.Foklad, wp.Fwid_dol, dol.Fwid_cl as Fwid_cl_dol  FROM ^work_pers wp INNER JOIN ^stru_dol dol "+
						" on wp.Fwid_dol=dol.Fwid WHERE wp.fwid_cl=" + sqlTo(tabn)+ " and wp.Fvopl="+sqlTo(vopl)
						+" and wp.Fbdat<"+sqlTo(dat_rasch)
						+(differ(lastDatNazn,d00)!=0?" and wp.Fbdat>="+sqlTo(lastDatNazn):"")
						+" order by wp.Fwid_cl,wp.Fvopl,wp.Fbdat desc";
						//+" order by wp.Fwid_cl,wp.Ftable,wp.Fvopl,wp.Fbdat desc";						
	var tsht2 = OpenTable("s", strSQL);
	if (!tsht2.IsEmpty()){
		var pFvopl         = Number(tsht2.getValue("Fvopl"));
		var pFwid          =  tsht2.getValue("Fwid");	
		var pFwid_dol    =  tsht2.getValue("Fwid_cl_dol");				
    	//будем считать индекс для по человеку по основной работе и по совместительству отдельно. При этом будем смотреть на 
    	// таблицу подоходного налога в штатном (1 и 2). Если один человек по основной работе на нескльних видах оплаты, то
    	// будем брать по всем видам оплаты дату последнего изменения оклада.
		var pFbdat  = new Date(tsht2.getValue("Fbdat"));
		var pFoklad = Number(tsht2.getValue("Foklad"));
    	while (!tsht2.IsEOF() && tabn==tsht2.getValue("Fwid_cl")  && pFvopl==tsht2.getValue("Fvopl")){	
	    	//if (differ(new Date(tsht2.getValue("Fbdat")),pFbdat)>0 && Number(tsht2.getValue("Foklad"))>pFoklad){
			//		pFbdat  = new Date(tsht2.getValue("Fbdat"));
			//		pFoklad = Number(tsht2.getValue("Foklad"));
			//		pFwid    = tsht2.getValue("Fwid");				
   			//}	 
	    	if (differ(new Date(tsht2.getValue("Fbdat")),pFbdat)<0 && Number(tsht2.getValue("Foklad"))<pFoklad){
	    		break;
	    	}else{	
	    		//если оклад уменьшился и при этом другой код должности, то считаем, что его понизили в должности и
	    		//базовый месяц для индексации будем брать только в рамках этой последней должности. Если его повысили в должности
	    		//и оклад увеличился, то его доходы возрасли и в этом случае не смотрим на код должности.
    			if (ind2012==0 && (tsht2.getValue("Fwid_cl_dol")!=pFwid_dol)){
    				izm_dol = 1;
	    			break;	    			
    			}else{
    				//если оклад не изменился,то всегда берем предыдущую запись.Даже если изменилась должность, но оклад не
    				//изменился, берем предыдущую запись - по новому.
					pFbdat  = new Date(tsht2.getValue("Fbdat"));
					pFoklad = Number(tsht2.getValue("Foklad"));
					pFwid    = tsht2.getValue("Fwid");
					pFwid_dol    =  tsht2.getValue("Fwid_cl_dol");					
    			}
   			}	 
			tsht2.MoveNext();    		
    	}
		fwid_shtr.fwid = pFwid;
		fwid_shtr.izd   = izm_dol;
	}	
//alert(pFbdat)	
    return;
}