/*
Расчет больничных и по уходу за больн. по среднему за 6 предыдущих месяца
*/

include("objects\\DpDefVed.js")
include("prik\\calculate\\r_blnall.js")
include("prik\\calculate\\r_premblot.js")
include("objects\\DpCl.js")

function name_blnog3()
{
	return "Лікарняні|Больничные"
}
function r_blnog3(rasch_mes,VVOPL,VVPRK,VVLSFID,VVDPL,ftabn_id,svzpName)
{ 
   var sPrikTbl = "PRK_ALL";
   
   var DefVed = new DpDefVed();
   var tbl_PRK_B;
   var tbl_PRK_FMPL;
   var tbl_DTPRKB;
   var tbl_TIME_WR2;
   var tbl_WT_LBL_B;
   var tbl_SRED_INI;
   var tbl_OPL_PRIZ;
   var tbl_SHTAT;
   var tbl_SVZP;
   var tbl_TIME_OTP;
   var tbl_TAB;
   var tbl_ini;

   var D1,D2,sfbdat,sfedat;
   var obj_PRK_B = new Object(); 

   //установ. даты на начало и конец расчетного месяца
   //var data = new Date(rasch_mes);
   D1 =  javaDate2Script(new Date(rasch_mes.getFullYear(),rasch_mes.getMonth(),1)); 
  // D1=D1.getVarDate();

   D2 = javaDate2Script(lastDayMonth(rasch_mes)); 
   //D2=D2.getVarDate();
	sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
   if (VVOPL<9000)
      tbl_PRK_B = OpenTable("s", "SELECT p.*,w.fwid_cl as ftabn_id "
      		+" FROM ^"+ sPrikTbl +" as p inner join ^work_pers as w on w.fwid=p.fwid_wp"
            +" WHERE p.FVID_PRK="+sqlTo(VVPRK)
            	+sqlTabn
            	+" AND w.FVOPL="+sqlTo(VVOPL)
            	+" AND ((p.FBDAT>="+sqlTo(D1)
            	+" AND p.FBDAT<="+sqlTo(D2)
            	+" AND p.FEDAT>="+sqlTo(D1)
            	+" AND p.FEDAT<="+sqlTo(D2)+")"
            	+" OR (p.FDAT_BOL>="+sqlTo(D1)
            		+" AND p.FDAT_BOL<="+sqlTo(D2)+") "
            	+" OR (p.FMES_VIP>="+sqlTo(D1)
            		+" AND p.FMES_VIP<="+sqlTo(D2)+"))")
   else //VVOPL>=9000            
    tbl_PRK_B = OpenTable("s", "SELECT p.*,w.fwid_cl as ftabn_id "
    		+" FROM ^"+ sPrikTbl +" as p inner join ^work_pers as w on w.fwid=p.fwid_wp"
            +" WHERE p.FVID_PRK="+sqlTo(VVPRK)
            	+sqlTabn
            	+" AND ((p.FBDAT>="+sqlTo(D1)
            	+" AND p.FBDAT<="+sqlTo(D2)
            	+" AND p.FEDAT>="+sqlTo(D1)
            	+" AND p.FEDAT<="+sqlTo(D2)+")"
            	+" OR (p.FDAT_BOL>="+sqlTo(D1)
            		+" AND p.FDAT_BOL<="+sqlTo(D2)+") "
            	+" OR (p.FMES_VIP>="+sqlTo(D1)
            		+" AND p.FMES_VIP<="+sqlTo(D2)+"))");

   if (tbl_PRK_B.IsEmpty())
   {
      //_alert("В таблице PRK_B нет искомых данных!");
      tbl_PRK_B.close();
      return false;
   }

  if (rasch_mes.getMonth() < 9)  
      var szTag = String(rasch_mes.getFullYear()) + "0"+String(rasch_mes.getMonth()+1);
   else
      var szTag = String(rasch_mes.getFullYear()) + String(rasch_mes.getMonth()+1);  

   if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
   {
      msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
      writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
      tbl_PRK_B.close();
      return false;
   }     

   tbl_TAB = getSnap("select FID from ^ZRP_TBL"+ szTag, false);
   obj_PRK_B.isTBL = tbl_TAB!=null;
   msg = "Проверка правильности расчета больничных и по уходу за больн. по среднему за два предыдущих месяца";
   //DefVed.begin("",msg);
   writeToLog(msg,"m",VVOPL,VVPRK,VVLSFID);
 
 	var strSQL = "SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(VVLSFID);
	var snap = getSnap(strSQL);
	var mvvdpl=0;
   if (snap != null)
  	   mvvdpl = snap[0]; 
 
   //tbl_PRK_B.MoveFirst();
	var oCl = new DpCl("");
	oCl.setClcl(getPar("CODPERS"));
   while (!tbl_PRK_B.IsEOF())
   {
      /*
      Цикл по сегментам больничного. Сам больничный задается датами fbdat,fedat
      Он дробится на сегменты sfbdat,sfedat, каждый из которых 
      полностью попадает в рамки месяца
      */
   
      //Начальная установка месяца для расчета больничного
      //Установить сегмент больничного, попадающий в месяц (D1,D2)
      sfbdat = javaDate2Script(new Date(Math.max(D1,javaDate2Script(tbl_PRK_B.getValue("FBDAT")))));
      sfedat = javaDate2Script(new Date(Math.min(D2,javaDate2Script(tbl_PRK_B.getValue("FEDAT")))));

      obj_PRK_B.rmode = "OG3";
      obj_PRK_B.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
      obj_PRK_B.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
      obj_PRK_B.Fdat_bol = javaDate2Script(tbl_PRK_B.getValue("Fdat_bol"));//начало периода наступления нетрудоспособности
      obj_PRK_B.Fsum = Number(tbl_PRK_B.getValue("Fsum"));
      obj_PRK_B.Fproc = Number(tbl_PRK_B.getValue("Fproc"));
      obj_PRK_B.Fnom_prik = tbl_PRK_B.getValue("Fnom_prik");
      obj_PRK_B.Fdat_prik = tbl_PRK_B.getValue("Fdat_prik");
      obj_PRK_B.Fcalnum = tbl_PRK_B.getValue("Fcalnum");
      obj_PRK_B.prk_dy = Math.floor(obj_PRK_B.Fsum/1000);
      obj_PRK_B.prk_ch = obj_PRK_B.Fsum-obj_PRK_B.prk_dy*1000;
      obj_PRK_B.TM_IN_DY = (obj_PRK_B.prk_ch==0);
      obj_PRK_B.prkb_vopl = tbl_PRK_B.getValue("Fvopl");
      obj_PRK_B.Fbdat = tbl_PRK_B.getValue("Fbdat");
      obj_PRK_B.fvid_prk = VVPRK;
      obj_PRK_B.dat_vip  = new Date(tbl_PRK_B.getValue("Fmes_vip"));
      obj_PRK_B.Fdnkl = tbl_PRK_B.getValue("Fdnkl");
            
      mFtabn_id = obj_PRK_B.Ftabn_id;
	  
	  Ok = false;
      
		oCl.setFWID(mFtabn_id);
      if (obj_PRK_B.isTBL)
      {
         Ok = r_blnall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT, tbl_TIME_OTP, tbl_ini, tbl_TAB, oCl);   
      }
      else
      {
         Ok = r_blnall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT, tbl_TIME_OTP, tbl_ini, null, oCl);   
      }      
      
      if (Ok)
      {
         //определение, к какому периоду относится больничный
         mFvp = 0;
         mFmn = d00;
         //если начало отпуска и сам отпуск попадают в текущий месяц
         if (differ(sfbdat,D1)>=0 && differ(sfbdat,D2)<=0 
          && differ(sfedat,D1)>=0 && differ(sfedat,D2)<=0)
         {
            mFvp = 0
         }
         else
         {
            if (!(differ(sfbdat,D1)>=0 && differ(sfbdat,D2)<=0 
               && differ(sfedat,D1)>=0 && differ(sfedat,D2)<=0 
               && differ(obj_PRK_B.Fdat_bol,D1)>=0 && differ(obj_PRK_B.Fdat_bol,D2)<=0))
            {
               mFvp = 2;
               //db = new Date(sfbdat);
//               db = javaDate2Script(new Date (sfbdat.getYear()+1900,sfbdat.getMonth(),1));
//               mFmn = db;
               db = new Date (firstDayMonth(sfbdat));
               mFmn = db.getVarDate();
            }
         }  
         
         var m = new Object();

//         if ( (obj_PRK_B.ssum!=0) && ((mFvp==0) || ((mFvp==2) 
//         		&& differ(obj_PRK_B.Fdat_bol,D1)>=0 && differ(obj_PRK_B.Fdat_bol,D2)<=0)) )
         //if ( (obj_PRK_B.ssum!=0)&&((mFvp==0)||((mFvp==2)&&(differ(obj_PRK_B.Fdat_bol,D1)>=0)&&(differ(obj_PRK_B.Fdat_bol,D2)<=0)) ||((mFvp==2)&&(differ(obj_PRK_B.dat_vip,D1)>=0)&&(differ(obj_PRK_B.dat_vip,D2)<=0))) )
         if (((mFvp==0)||((mFvp==2)&&(differ(obj_PRK_B.Fdat_bol,D1)>=0)&&(differ(obj_PRK_B.Fdat_bol,D2)<=0)) ||((mFvp==2)&&(differ(obj_PRK_B.dat_vip,D1)>=0)&&(differ(obj_PRK_B.dat_vip,D2)<=0))) )         
         {
         //   tbl_SVZP.AddNew();
        	 if (obj_PRK_B.ssum!=0 || (obj_PRK_B.Fdnkl!=0 && obj_PRK_B.ssum==0)){
        		 m.Ftabn_id = mFtabn_id;
        		 m.Fid_prk = tbl_PRK_B.getValue("Fwid");
        		 m.fshpz = tbl_PRK_B.getValue("FSHPZ");
        		 m.Fvid_prk = VVPRK;             
        		 m.Flsfid = VVLSFID; 
        		 m.Ffld_num = mvvdpl; 
        		 m.Fsum = round(obj_PRK_B.ssum,2);
        		 m.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
        		 var gd = javaDate2Script(tbl_PRK_B.getValue("Fbdat"));
        		 //gd = gd.getDate();
        		 m.Fbdy = gd.getDate();  
        		 m.Fday = obj_PRK_B.prk_dy;
        		 m.Fchas = obj_PRK_B.prk_ch;                
        		 m.Fis_day = 0
        		 m.Fvp = mFvp; 
        		 m.Fmn = mFmn;
        		 m.Fproc = tbl_PRK_B.getValue("Fproc");
        		 m.Fdnkl = tbl_PRK_B.getValue("Fdnkl");            
        		 // tbl_SVZP.Update();   
        		 UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
        	 }	 
         }
      }
      tbl_PRK_B.MoveNext();
   }
   tbl_PRK_B.close();   
   
   return true;
}