/*
Расчет по берем. по среднему за 6 предыд. мес.
с изменениями с 15,12,09, Если есть константа br2010 cо значением 1 с даты 15,12,09, то начинает
считаться новый расчет,иначе - старый. В новом расчете для среднестатистической зарплаты сделала
константу zp_stat, а не отдельный справочник, т.к. эта ЗП нужна только для месяца из статистики перед
датой больничного и только, если человек отработал меньше месяца. Такая ситуация маловероятна и
может не понадобиться вообще. ЕСли понадобится, то можно будет когда-нибудь добавить и справочник
Приказ берется на месяцы
Без ограничения в 2 тарифных ставки
Время ставится вручную помесячно
В расчете не используется справочник коеффициентов для инд. сумм больн.
*/

//include("month_txt.js");
include("objects\\DpDefVed.js")
include("prik\\calculate\\r_blnall.js")
include("prik\\calculate\\r_premblot.js")
include("objects\\DpCl.js")
include("prik\\calculate\\r_brall.js")

function name_blnsr5()
{
	return "Доплата по вагітності та пологах|Доплата по беременности и родам"
}
function r_blnsr5(rasch_mes,VVOPL,VVPRK,VVLSFID,VVLSFID2,ftabn_id,svzpName)
{ 
   var sPrikTbl = "PRK_ALL";
   
   var DefVed = new DpDefVed();
   var tbl_PRK_B;
   var tbl_PRK_FMPL;
   var tbl_DTPRKB;
   var tbl_TIME_WR2;
   var tbl_WT_LBL_B;
   var tbl_SRED_INI;
   var tbl_OPL_PRIZ;
   var tbl_SHTAT;
   var tbl_SVZP;
   var tbl_TIME_OTP;
   var tbl_TAB;
   var tbl_ini;

   var D1,D2,sfbdat,sfedat;
   var obj_PRK_B = new Object(); 
   
   if (rasch_mes.getMonth() < 9)  
      var szTag = String(rasch_mes.getFullYear()) + "0"+String(rasch_mes.getMonth()+1);
   else
      var szTag = String(rasch_mes.getFullYear()) + String(rasch_mes.getMonth()+1);  
 

   //установ. даты на начало и конец расчетного месяца
   var data = new Date(rasch_mes);
   D1=new Date (data.getFullYear(),data.getMonth(),1); 
   D2=new Date (data.getFullYear(),data.getMonth()+1,0); 
	sqlTabn = ftabn_id?" and prk.Ftabn_id in ("+ftabn_id+") ":"";
   if (VVOPL<9000)
   		tbl_PRK_B = OpenTable("s", "SELECT prk.*, w.fwid_cl as ftabn_id"
      		+" FROM ^"+ sPrikTbl +" as prk "      			
      			+" inner join ^work_pers as w on w.fwid=prk.fwid_wp"
            +" WHERE prk.FVID_PRK="+sqlTo(VVPRK)
            	+sqlTabn
            	+" AND w.FVOPL="+sqlTo(VVOPL)
            	+" AND ((prk.FBDAT>="+ sqlTo(D1) 
            	+" AND prk.FBDAT<="+sqlTo(D2)
            	+" AND prk.FEDAT>="+sqlTo(D1)
            	+" AND prk.FEDAT<="+sqlTo(D2)+")"
            	+" OR (prk.FMES_VIP>="+sqlTo(D1)
            		+" AND prk.FMES_VIP<="+sqlTo(D2)+") )")   
	else //VVOPL>=9000            
   		tbl_PRK_B = OpenTable("s", "SELECT prk.*, w.fwid_cl as ftabn_id "
    		+" FROM ^"+ sPrikTbl +" as prk "
    			+" inner join ^work_pers as w on w.fwid=prk.fwid_wp"
            +" WHERE prk.FVID_PRK="+sqlTo(VVPRK)
            	+sqlTabn
            	+" AND ((prk.FBDAT>="+sqlTo(D1)
            	+" AND prk.FBDAT<="+sqlTo(D2)
            	+" AND prk.FEDAT>="+sqlTo(D1)
            	+" AND prk.FEDAT<="+sqlTo(D2)+")"
            	+" OR (prk.FMES_VIP>="+sqlTo(D1)
            		+" AND prk.FMES_VIP<="+sqlTo(D2)+") )");   
            		
   if (tbl_PRK_B.IsEmpty())
   {
      tbl_PRK_B.close();
      return false;
   }

/*   tbl_DTPRKB = OpenTable("s","DTPRKB","dtprkb");
   if (SQL)
		tbl_DTPRKB.index = "FTABN,FBDAT";
   tbl_PRK_FMPL = OpenTable("s","PRK_FMPL","fmpl_tn");
	if (SQL)
		tbl_PRK_FMPL.index = "FTABN";
   tbl_WT_LBL_B = OpenTable("s","WT_LBL_B","tabdate");
   if (SQL)
		tbl_WT_LBL_B.index = "FTABN,FLD_DATE";
   tbl_SRED_INI = OpenTable("s","SRED_INI","tabsrdate");
	if (SQL)
		tbl_SRED_INI.index = "FTABN,FVID_SR,FLD_DATE";
   tbl_TIME_WR2 = OpenTable("s","TIME_WR2","tabdate"); 
   if (SQL)
		tbl_TIME_WR2.index = "FTABN,FLD_DATE";
   tbl_OPL_PRIZ = OpenTable("s","OPL_PRIZ","opl_priz");
   if (SQL)
		tbl_OPL_PRIZ.index = "FVOPL";
   tbl_TIME_OTP = OpenTable("s","TIME_OTP","tabdate"); 
   if (SQL)
		tbl_TIME_OTP.index = "FTABN,FLD_DATE";*/
   if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
   { 
      msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
      writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
      return false;
   }     
  // tbl_SVZP=OpenTable("s",""+(svzpName?svzpName:"svzp")+szTag);
   obj_PRK_B.isTBL = false;
   if (IsTableEx("ZRP_MDB","ZRP_TBL"+szTag))
   {
      tbl_TAB = OpenTable("s","TBL"+szTag);
      if (SQL)
			tbl_TAB.index = "FTABN,FID,FBD,FED,FKOD_NVK";
      if (!tbl_TAB.IsEmpty()) obj_PRK_B.isTBL = true;
   }
	else
	{
		msg = "Не найдено табеля за "+format("mm/yyyy",rasch_mes);
		writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
		return false;
	}
   /*tbl_ini = OpenTable("s","TBL_INI","tbl_ini");
   if (SQL)
		tbl_ini.index = "FVOPL,FBDAT"; */
		
	var strSQL = "SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(VVLSFID);
	var snap = getSnap(strSQL);
	var mvvdpl=0;
  
   if (snap != null)
  	   mvvdpl = snap[0]; 

   msg = "Проверка правильности расчета травм и по берем. по среднему за два предыдущих месяца";
   //DefVed.begin("",msg);
   writeToLog(msg,"m",VVOPL,VVPRK,VVLSFID);

   //tbl_PRK_B.MoveFirst();
	var oCl = new DpCl("");
	oCl.setClcl(getPar("CODPERS"));
   while (!tbl_PRK_B.IsEOF())
   {
      /*
      Цикл по сегментам отпуска. Сам отпуск задается датами fbdat,fedat
      Он дробится на сегменты sfbdat,sfedat, каждый из которых 
      полностью попадает в рамки месяца
      */
   
      //Начальная установка месяца для расчета отпускных
      //Установить сегмент отпуска, попадающий в месяц (D1,D2)
      //sfbdat = Math.max(D1,tbl_PRK_B("FBDAT"));
      //sfedat = Math.min(D2,tbl_PRK_B("FEDAT"));
      sfbdat = new Date(tbl_PRK_B.getValue("FBDAT"));
      sfedat = new Date(tbl_PRK_B.getValue("FEDAT"));

      obj_PRK_B.rmode = "SR5";
      obj_PRK_B.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
      obj_PRK_B.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
      //obj_PRK_B.Fsht_id = tbl_PRK_B.getValue("Fsht_id");
      obj_PRK_B.Fdat_bol = new Date(tbl_PRK_B.getValue("Fdat_bol"));//начало периода наступления нетрудоспособности
      obj_PRK_B.Fsum = tbl_PRK_B.getValue("Fsum");
      obj_PRK_B.Fproc = tbl_PRK_B.getValue("Fproc");
      obj_PRK_B.Fnom_prik = tbl_PRK_B.getValue("Fnom_prik");
      obj_PRK_B.Fdat_prik = tbl_PRK_B.getValue("Fdat_prik");
      obj_PRK_B.Fcalnum = tbl_PRK_B.getValue("Fcalnum");
      obj_PRK_B.prk_dy = Math.floor(obj_PRK_B.Fsum/1000);
      obj_PRK_B.prk_ch = obj_PRK_B.Fsum-obj_PRK_B.prk_dy*1000;
      obj_PRK_B.TM_IN_DY = (obj_PRK_B.prk_ch==0);
      obj_PRK_B.dat_vip  = new Date(tbl_PRK_B.getValue("Fmes_vip"))
      obj_PRK_B.Fbdat = tbl_PRK_B.getValue("Fbdat");
      obj_PRK_B.fvid_prk = VVPRK;      
      oCl.setFWID(obj_PRK_B.Ftabn_id);
      
 	//c 15.12.09
   //сравнение даты перехода на новую статистику и первого дня декретного - нужно уточнить !!!!
   //если первый день болезни больше даты перехода, то брать стат.по 18 коду, если нет - по старому считать
	strSQL = "select * from ^const "
   			+" where Fsum=1 "
   				+" and (Fbdat<="+ sqlTo(lastDay(rasch_mes))
          		+" and Fedat>="+ sqlTo(rasch_mes) +")"
      		+" order by Fconst_nam, Fbdat";
   	tcnst = OpenTable("s", strSQL);

   	var dat_bl10f   = new Date(1900,0,1);
   	var dat_bl2010  = dat_bl10f

   	if (!tcnst.IsEmpty())
   	{
    		while (!tcnst.IsEOF())
      		{
         		var bdat = new Date(tcnst.getValue("Fbdat"));
         		var sCnst = allt(tcnst.getValue("Fconst_nam"));
         		if (sCnst=="br2010" && differ(dat_bl2010,bdat)<0)
         		{
            		dat_bl2010 = bdat;
            	}
         		tcnst.MoveNext();
      		}
   	} 
   	tcnst.close();
   		
   	//c 15.12.09 поменялся код средного для расчета декретных
    var br2010 = false;   	
	if (differ(dat_bl2010, dat_bl10f)>0 && differ(obj_PRK_B.Fdat_bol,dat_bl2010)>=0)
	{
      		var br2010 = true; 
   	}
      
      
      if (obj_PRK_B.isTBL)
      {
      		if (br2010 == false){      	
         		Ok = r_blnall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT,tbl_TIME_OTP, tbl_ini, tbl_TAB, oCl);
      		}else{
         		Ok = r_brall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT,tbl_TIME_OTP, tbl_ini, tbl_TAB, oCl);      			
      		}	   
      }
      else
      {
      		if (br2010 == false){      	
         		Ok = r_blnall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT,tbl_TIME_OTP, tbl_ini, null, oCl);
      		}else{
         		Ok = r_brall("OSN", rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT,tbl_TIME_OTP, tbl_ini, null, oCl);      			
      		}	   
      }
      if (Ok)
      {
         //определение, к какому периоду относится больничный
         mFvp = 0;
         mFmn = d00;
         //если начало отпуска и сам отпуск попадают в текущий месяц
        if ((differ(sfbdat,D1)>=0)&&(differ(sfbdat,D2)<=0)&&(differ(sfedat,D1)>=0)&&(differ(sfedat,D2)<=0))
        {
            mFvp = 0
         }
         else
         {
            if (!((differ(sfbdat,D1)>=0)&&(differ(sfbdat,D2)<=0)&&(differ(sfedat,D1)>=0)&&(differ(sfedat,D2)<=0)&&(differ(obj_PRK_B.Fdat_bol,D1)>=0)&&(differ(obj_PRK_B.Fdat_bol,D2)<=0))){            
            //if (!((sfbdat>=D1 && sfbdat<=D2) && (sfedat>=D1 && sfedat<=D2)) &&
            //   (obj_PRK_B.dat_vip>=D1 && obj_PRK_B.dat_vip<=D2)
            //   && (new Date(obj_PRK_B.dat_vip).getMonth() < new Date(sfbdat).getMonth())){
               mFvp = 2;
               db = new Date(sfbdat);
               db = new Date (db.getFullYear(),db.getMonth(),1);
               mFmn = db.getVarDate();
            }
         } 
         var m = new Object(); 
         if ( (obj_PRK_B.ssum!=0)&&((mFvp==0)||((mFvp==2)&&(differ(obj_PRK_B.Fdat_bol,D1)>=0)&&(differ(obj_PRK_B.Fdat_bol,D2)<=0)) ||((mFvp==2)&&(differ(obj_PRK_B.dat_vip,D1)>=0)&&(differ(obj_PRK_B.dat_vip,D2)<=0))) )         
         //if ( (obj_PRK_B.ssum!=0)&&((mFvp==0)||((mFvp==2)&&(obj_PRK_B.Fdat_bol>=D1)&&(obj_PRK_B.Fdat_bol<=D2))) )
         {
         //   tbl_SVZP.AddNew();
            m.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
            m.Fid_prk = tbl_PRK_B.getValue("Fwid");
            m.fshpz = tbl_PRK_B.getValue("FSHPZ");
            m.Fvid_prk = VVPRK;             
            m.Flsfid = VVLSFID; 
            m.Ffld_num =  mvvdpl; 
            m.Fsum = round(obj_PRK_B.ssum,2);
            m.Fwid_wp= tbl_PRK_B.getValue("Fwid_wp");
            var gd = new Date(tbl_PRK_B.getValue("Fbdat"));
            gd = gd.getDate();
            m.Fbdy = gd;  
            m.Fday = obj_PRK_B.prk_dy;
            m.Fchas = obj_PRK_B.prk_ch;                
            m.Fis_day = 0;
            m.Fvp = mFvp; 
            m.Fmn = mFmn;
            m.Fproc = tbl_PRK_B.getValue("Fproc");
          //  tbl_SVZP.Update();   
          UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
         }
      }
      tbl_PRK_B.MoveNext();
   }
   tbl_PRK_B.close();
   //tbl_DTPRKB.close();
   //tbl_PRK_FMPL.close();
   //tbl_WT_LBL_B.close();
   //tbl_SRED_INI.close();
   //tbl_TIME_WR2.close();
   //tbl_OPL_PRIZ.close();
   //tbl_TIME_OTP.close();
   	tbl_TAB.close();
   //tbl_ini.close();
   return true;
}