//Удержания на карточки для МВД, переделан с r_casprl.js, отличие в том, что на карточку идет лишь основная зарплата

function name_casprlmvd()
{
	return "Перерахування в ощадкасу (%)|Перечисления в сберкассу(%)";;
}

function r_casprlmvd(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = getDateTag(month);
	
	// дата начала
	var D1 = new Date(firstDayMonth(month));
	// дата конца
	var D2 = new Date(lastDayMonth(month));

	if(!IsTableEx("zrp_mdb", "zrp_prk_c_pr"))
		return false;
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	var base_m = new Date(base_month)
	var rasch_m = new Date(D1);
	
    //удалять и добавлять записи в список сумм удержаний будем только в расчетном месяце
	if(!differ(base_m,rasch_m))
    {
	    var strSQL = "DELETE FROM ^cas_pr_u WHERE fbdat=" + sqlTo(D1) + " and fedat=" + sqlTo(D2)
	    			+(ftabn_id?" and Fwid_wp in (select fwid from ^work_pers where Fwid_cl in ("+ftabn_id+"))":"");
    	ExecuteSQL(strSQL);
    }
    
    strSQL = "SELECT COUNT(*) FROM ^prk_all"
    			+ " WHERE fvid_prk=" + sqlTo(vidprk)
    				+ " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1)
    				+ sqlTabn;
    var snap = getSnap(strSQL);
    if(null==snap || 0==snap[0])
    	return true;

	//проставляем в лицевых счетах код категории
	if(getPar("LS_KAT"))
	{
		var tblKat = OpenTable("select * from ^listcl where Fcl="+getPar("LS_KAT")+" order by Fcod");
		if(tblKat.IsEmpty())
		{
			msg = "Справочник "+getPar("LS_KAT")+" категорий лицевых счетов пустой!\nЗаполните данные.";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
			tblKat.close();
			return false;
		}
//код категории проставляется в r_nachi2mvd.js
//		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
//		{
//			if(tblKat.bookmark == 1)
//			{
//				ExecuteSQL("update ^"+(svzpName?svzpName:"svzp")+szTag+" set Fls_kat="+tblKat.getValue("Fcod")+" where Fls_kat=0 "+sqlTabn
//					+" and exists(select Fwid from ^lic_fld as l where l.Fid=^"+(svzpName?svzpName:"svzp")+szTag+".Flsfid "
//						+" and (l.Fls_kat=0 or l.Fls_kat="+sqlTo(String(tblKat.getValue("Fcod")))+")"
//						+ " AND (l.Fis12 not in ("+sqlTo("1")+","+sqlTo("2")+","+sqlTo("3")+","+sqlTo("4")
//							+","+sqlTo("н")+","+sqlTo("у")+","+sqlTo("ф")+","+sqlTo("з")+","+sqlTo("б")+") OR l.Fis12 is null))");//отсекаем базы удержаний и итоги
//			}
//			else
//			{
//				ExecuteSQL("update ^"+(svzpName?svzpName:"svzp")+szTag+" set Fls_kat="+tblKat.getValue("Fcod")+" where Fls_kat=0 "+sqlTabn
//					+" and exists(select Fwid from ^lic_fld as l where l.Fid=^"+(svzpName?svzpName:"svzp")+szTag+".Flsfid "
//						+" and l.Fls_kat="+sqlTo(String(tblKat.getValue("Fcod")))+")");
//						//+ " AND (l.Fis12 not in ("+sqlTo("1")+","+sqlTo("2")+","+sqlTo("3")+","+sqlTo("4")+","+sqlTo("н")+","+sqlTo("у")+","+sqlTo("ф")+","+sqlTo("з")+","+sqlTo("б")+") OR l.Fis12 is null))");//отсекаем базы удержаний и итоги
//			}
//		}
	}

//поле ЛС:фактич.выдано 
	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis";
	snap = getSnap(strSQL + "6=" + sqlTo("ф"));
	if(null==snap)
	{
		msg = "Обнаружена серьезная ошибка функционирования системы \n"+
			"Hевозможно идентифицировать поле ЛС:фактич.выдано\n "+
			"Пригласите разработчиков для устранения\n ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		if(getPar("LS_KAT"))
			tblKat.close();
		return false;
	}
	
	var t = OpenTable("select count(s.Ftabn_id) as Fcnt, s.Ftabn_id,r.Fcod "
				+" from ^"+(svzpName?svzpName:"svzp")+szTag+" as s inner join ^clrelclcl as r on s.Ftabn_id=r.Fwid_cl "
				+" where s.Flsfid="+sqlTo(snap[0])+sqlTabn+" group by s.Ftabn_id,r.Fcod having count(s.Ftabn_id)>1 order by r.Fcod");
	if(t.rowCount>0)
	{
		msg = "Как минимум у одного сотрудника таб.№"+t.getValue("Fcod")+" задвоено поле ЛС:фактич.выдано"
			+"\nСмотри открывшийся список 'Табельные номера с задвоенным полем ЛС фактически выдано'"
			+"\nВозможно у этих номеров несколько приказов с пересекающимися периодами";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		var par = new Object();
		par.cells = new Object();
		par.caption = "Табельные номера с задвоенным полем ЛС фактически выдано";
	
		par.cells[1] = new Object();
		par.cells[1].name = "Fcod";
		par.cells[1].width = 3;
		par.cells[1].text = UR("Таб.№|Таб.№");
		
		par.cells[2] = new Object();
		par.cells[2].name = "Fcnt";
		par.cells[2].width = 3;
		par.cells[2].text = UR("К-сть записів|Кол-во записей");
	
		browse(t, par, SW_NOMODAL);
	}
	t.close();
	//если используются категории, то ищем фактически к выдачи по первой категории
	if(getPar("LS_KAT"))
	{
		var tblKat = OpenTable("select * from ^listcl where Fcl="+getPar("LS_KAT")+" order by Fcod");
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis";
			snapKat = getSnap(strSQL + "6=" + sqlTo("ф"+tblKat.getValue("Fcod")));
			if(!snapKat)
			{
				msg = "Обнаружена серьезная ошибка функционирования системы \n"+
					"Hевозможно идентифицировать поле ЛС:фактич.выдано для категории "+tblKat.getValue("Fcod")+"\n "+
					"Пригласите разработчиков для устранения\n ";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
				tblKat.close();
				return false;
			}
			var strNach = "(SELECT n.fsum FROM ^"+(svzpName?svzpName:"svzp") + szTag + " AS n"
				+ " WHERE n.ftabn_id=p.ftabn_id AND n.flsfid=" + sqlTo(snapKat[0]) + ")";
			break;
		}
	}
	else
	{
		var strNach = "(SELECT n.fsum FROM ^"+(svzpName?svzpName:"svzp") + szTag + " AS n"
				+ " WHERE n.ftabn_id=p.ftabn_id AND n.flsfid=" + sqlTo(snap[0]) + ")";
	}

	var nach_lsfi1 = snap[0];
	var nach_lsnu1 = snap[1];
//поле ЛС:всего удержано
	snap = getSnap(strSQL + "6=" + sqlTo("у"));
	if(null==snap)
	{
		msg = "Обнаружена серьезная ошибка функционирования системы \n"+
			"Hевозможно идентифицировать поле ЛС:всего удержано\n "+
			"Пригласите разработчиков для устранения\n ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		if(getPar("LS_KAT"))
			tblKat.close();
		return false;
	}
	
	var strUder = "(SELECT u.fsum FROM ^"+(svzpName?svzpName:"svzp") + szTag + " AS u"
				+ " WHERE u.fwid_wp=p.fwid_wp AND u.flsfid=" + sqlTo(snap[0]) + ")";
	var nach_lsfi2 = snap[0];
	var nach_lsnu2 = snap[1];
	//поле ЛС:на сберкаcсу
	var nach_lsfi3 = lsfid;
	var snap = getSnap("SELECT ffld_num FROM ^lic_fld WHERE fid=" + sqlTo(lsfid));
	if(null==snap)
	{
		msg = "Обнаружена серьезная ошибка функционирования системы \n"+
			"Hевозможно идентифицировать поле ЛС:на сберкаcсу  с кодом "+lsfid+"\n "+
			"Пригласите разработчиков для устранения\n ";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		if(getPar("LS_KAT"))
			tblKat.close();
		return false;
	}
	var nach_lsnu3 =  snap[0];
	
	for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
	{
		var codKat = tblKat.getValue("Fcod");
		var txtKat = tblKat.getValue("Ftxt");
		var strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis6="

		snap = getSnap(strSQL + sqlTo("у"+codKat));
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'всего удержано' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения        ";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
			if(getPar("LS_KAT"))
				tblKat.close();          
			return;
		}	
		eval('var uder_lsfid'+codKat+' = snap[0];');
		eval('var uder_lsnum'+codKat+' = snap[1];');
		
		snap = getSnap(strSQL + sqlTo("ф"+codKat));
		if(null == snap)
		{
			msg="Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: 'фактически выдано' для категории "+codKat+":"+txtKat+"\n"
					+ "Пригласите разработчиков для устранения";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
			if(getPar("LS_KAT"))
				tblKat.close();          
			return;
		}
		eval('var vidan_lsfid'+codKat+' = snap[0];');
		eval('var vidan_lsnum'+codKat+' = snap[1];');
		eval('var strNach_kat'+codKat+' = "(SELECT n.fsum FROM ^"+(svzpName?svzpName:"svzp") + szTag + " AS n WHERE n.ftabn_id=^p.ftabn_id AND n.flsfid=" + sqlTo(vidan_lsfid'+codKat+') + ")";');
	}
	
	var strPosob = "(SELECT SUM(ps.fsum) FROM ^"+(svzpName?svzpName:"svzp") + szTag + " AS ps LEFT JOIN ^lic_fld AS lf"
				+ " ON ps.flsfid=lf.fid"
				+ " WHERE lf.fis12='-' AND ps.ftabn_id=^p.ftabn_id AND ps.flsfid=" + sqlTo(nach_lsfi3) + ")";
	strPosob = IIF(strPosob + ">0", strPosob, 0)
	var strSum = "(" + strNach + "-" + strPosob + ")";
	strSum = IIF(strSum + ">0", strSum, 0) + "*p.fsum/100";
// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_"+(svzpName?svzpName:"svzp") + szTag))
	{ 
		var strPath = getPath("zrp_res");
		CreateTable(strPath + ".zrp_"+(svzpName?svzpName:"svzp") + szTag, "svzp", "*");
	}
	
	//отбираем суммы по справочнику категорий ЛС для последующего формирования пропорции
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//будем проходить только одну итерацию, т.к. на карточку перечисляется только первая (основная) часть з/п, остальные части выдаются на руки
			eval('var strSum_kat'+tblKat.getValue("Fcod")+' = "(" + strNach_kat'+tblKat.getValue("Fcod")+' + "-" + strPosob + ")";');
			eval('strSum_kat'+tblKat.getValue("Fcod")+' = IIF(strSum_kat'+tblKat.getValue("Fcod")+' + ">0", strSum_kat'+tblKat.getValue("Fcod")+', 0) + "*p.fsum/100";');
			break;
		}
	}

//Добавим поля фактически выдано, если их нет
	strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy)"
			+ " SELECT ftabn_id, 0 as fwid_wp"
					+ ", " + sqlTo(nach_lsnu1) + " AS ffld_num"
					+ ", " + sqlTo(nach_lsfi1) + " AS flsfid"
					+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
					+ ", " + sqlTo(D2.getDate()) + " AS fedy"
					//+ ", " + sqlTo(vidprk) + " AS fvid_prk"
			+ " FROM ^prk_all as p"
			+ " WHERE fvid_prk=" + sqlTo(vidprk)
				   + " AND "+ strSum+"<>0 "			
                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1)
                   + sqlTabn 
                   + " AND NOT ftabn_id IN (SELECT DISTINCT ftabn_id FROM ^"+(svzpName?svzpName:"svzp") + szTag 
                   						+ " WHERE flsfid=" + sqlTo(nach_lsfi1) + ")";
	b=ExecuteSQL(strSQL,false);
	if(!b)
	{
		msg = "Не удалось добавить поля ЛС фактически выдано, если их нет!";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
	}
	
	//Добавим поля фактически выдано по первой категории ЛС, если их нет
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//будем проходить только одну итерацию, т.к. на карточку перечисляется только первая (основная) часть з/п, остальные части выдаются на руки
			eval('var strSum_kat = strSum_kat'+tblKat.getValue("Fcod"));
			eval('var vidan_lsfid = vidan_lsfid'+tblKat.getValue("Fcod"));
			eval('var vidan_lsnum = vidan_lsnum'+tblKat.getValue("Fcod"));
			
			strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy, fls_kat)"
					+ " SELECT ftabn_id, 0 as fwid_wp"
							+ ", " + sqlTo(vidan_lsnum) + " AS ffld_num"
							+ ", " + sqlTo(vidan_lsfid) + " AS flsfid"
							+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
							+ ", " + sqlTo(D2.getDate()) + " AS fedy"
							+ ", " + sqlTo(tblKat.getValue("Fcod")) + " AS fls_kat"
					+ " FROM ^prk_all as p"
					+ " WHERE fvid_prk=" + sqlTo(vidprk)
						   + " AND "+ strSum_kat+"<>0 "			
		                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1)
		                   + sqlTabn 
		                   + " AND NOT ftabn_id IN (SELECT DISTINCT ftabn_id FROM ^"+(svzpName?svzpName:"svzp") + szTag 
		                   						+ " WHERE ffld_num=" + sqlTo(vidan_lsnum) + ")";
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось добавить поля ЛС фактически выдано по категории ЛС "+tblKat.getValue("Fcod")+", если их нет!";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}
			break;
		}
	}
	
	//Добавим поля всего удержано, если их нет
	strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy)"
			+ " SELECT ftabn_id, 0 as fwid_wp"
					+ ", " + sqlTo(nach_lsnu2) + " AS ffld_num"
					+ ", " + sqlTo(nach_lsfi2) + " AS flsfid"
					+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
					+ ", " + sqlTo(D2.getDate()) + " AS fedy"
					//+ ", " + sqlTo(vidprk) + " AS fvid_prk"
			+ " FROM ^prk_all as p"
			+ " WHERE fvid_prk=" + sqlTo(vidprk)
				   + " AND "+ strSum+"<>0 "			
                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1)
                   + sqlTabn
                   + " AND NOT ftabn_id IN (SELECT DISTINCT ftabn_id FROM ^"+(svzpName?svzpName:"svzp") + szTag 
                   						+ " WHERE flsfid=" + sqlTo(nach_lsfi2) + ")";
	b=ExecuteSQL(strSQL,false);
	if(!b)
	{
		msg = "Не удалось добавить поля ЛС всего удержано, если их нет!";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
	}
	
	//Добавим поля всего удержано по первой категории ЛС, если их нет
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//будем проходить только одну итерацию, т.к. на карточку перечисляется только первая (основная) часть з/п, остальные части выдаются на руки
			eval('var strSum_kat = strSum_kat'+tblKat.getValue("Fcod"));
			eval('var uder_lsfid = uder_lsfid'+tblKat.getValue("Fcod"));
			eval('var uder_lsnum = uder_lsnum'+tblKat.getValue("Fcod"));
			
			strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy, fls_kat)"
			+ " SELECT ftabn_id, 0 as fwid_wp"
					+ ", " + sqlTo(uder_lsnum) + " AS ffld_num"
					+ ", " + sqlTo(uder_lsfid) + " AS flsfid"
					+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
					+ ", " + sqlTo(D2.getDate()) + " AS fedy"
					+ ", " + sqlTo(tblKat.getValue("Fcod")) + " AS fls_kat"
			+ " FROM ^prk_all as p"
			+ " WHERE fvid_prk=" + sqlTo(vidprk)
				   + " AND "+ strSum_kat+"<>0 "			
                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1)
                   + sqlTabn
                   + " AND NOT ftabn_id IN (SELECT DISTINCT ftabn_id FROM ^"+(svzpName?svzpName:"svzp") + szTag 
                   						+ " WHERE ffld_num=" + sqlTo(uder_lsnum) + ")";
			
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось добавить поля ЛС всего удержано по категории ЛС "+tblKat.getValue("Fcod")+", если их нет!";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}
			break;
		}
	}

	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//Добавим суммы перечисления по первой категории
			strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy, fsum, fid_prk, fvid_prk, fls_kat)"
					+ " SELECT ftabn_id, 0 as fwid_wp"
							+ ", " + sqlTo(nach_lsnu3) + " AS ffld_num"
							+ ", " + sqlTo(nach_lsfi3) + " AS flsfid"
							+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
							+ ", " + sqlTo(D2.getDate()) + " AS fedy"
							+ ", " + strSum + " AS fsum"
							+ ", fwid AS fid_prk"
							+ ", " + sqlTo(vidprk) + " AS fvid_prk"
							+ ", " + tblKat.getValue("Fcod") + " AS fls_kat"
					+ " FROM ^prk_all as p"
					+ " WHERE fvid_prk=" + sqlTo(vidprk)
						   + sqlTabn
						   + " AND "+ strSum+"<>0 "			
		                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1) 
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось добавить суммы перечислений!";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
				if(getPar("LS_KAT"))
					tblKat.close();
				return false;
			}
			break;
		}
	}
	else
	{
		//Добавим суммы перечисления
		strSQL = "INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag + " (ftabn_id,fwid_wp, ffld_num, flsfid, fbdy, fedy, fsum, fid_prk, fvid_prk)"
				+ " SELECT ftabn_id, 0 as fwid_wp"
						+ ", " + sqlTo(nach_lsnu3) + " AS ffld_num"
						+ ", " + sqlTo(nach_lsfi3) + " AS flsfid"
						+ ", " + sqlTo(D1.getDate()) + " AS fbdy"
						+ ", " + sqlTo(D2.getDate()) + " AS fedy"
						+ ", " + strSum + " AS fsum"
						+ ", fwid AS fid_prk"
						+ ", " + sqlTo(vidprk) + " AS fvid_prk"
				+ " FROM ^prk_all as p"
				+ " WHERE fvid_prk=" + sqlTo(vidprk)
					   + sqlTabn
					   + " AND "+ strSum+"<>0 "			
	                   + " AND fbdat<=" + sqlTo(D2) + " AND fedat>=" + sqlTo(D1) 
		b=ExecuteSQL(strSQL,false);
		if(!b)
		{
			msg = "Не удалось добавить суммы перечислений!";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
			if(getPar("LS_KAT"))
				tblKat.close();
			return false;
		}
	}
	
	//просто апдейтим вышедобавленные записи сумм перечислений кодом категории первой записи в справочнике
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			ExecuteSQL(" update ^"+(svzpName?svzpName:"svzp") + szTag + " set Fls_kat="+tblKat.getValue("Fcod")+" where Flsfid="+nach_lsfi3);
			break;
		}
	}
	
	if(SUBD==MYSQL)
	{
		var svzpTmp = "SVZPTMP"+szTag;
		CreateTable(svzpTmp, "svzp", "*");
		sFlds = GetPatternIntersection("SVZP","SVZP").replace(/(fwid\s*,)|(\s*fwid\W)/gi,"");
		ExecuteSQL("insert into "+svzpTmp+" ("+sFlds+") select "+sFlds+" from ^"+(svzpName?svzpName:"svzp")+szTag);
	}
	else
		var svzpTmp = "^"+(svzpName?svzpName:"svzp")+szTag;
	
	//Изменим поля фактически выдано основные и по первой категории ЛС
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//Изменим поля фактически выдано
			subStrSQL = "(SELECT SUM(s1.fsum) FROM " + svzpTmp + " AS s1 WHERE s1.flsfid=" 
							+ sqlTo(nach_lsfi3) + " AND s1.ftabn_id=^"+(svzpName?svzpName:"svzp") + szTag + ".ftabn_id)"
			strSQL = "UPDATE ^"+(svzpName?svzpName:"svzp") + szTag + " SET fsum="+sqlRound("fsum-"
							+ IIF(subStrSQL+" IS NULL", 0, subStrSQL),2)
						+ " WHERE flsfid=" + sqlTo(nach_lsfi1)
							+ sqlTabn;
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось обновить поля фактически выдано!";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}
			
			eval('var vidan_lsfid = vidan_lsfid'+tblKat.getValue("Fcod"));
			subStrSQL = "(SELECT SUM(s1.fsum) FROM " + svzpTmp + " AS s1 WHERE s1.flsfid=" 
							+ sqlTo(nach_lsfi3) + " AND s1.ftabn_id=^"+(svzpName?svzpName:"svzp") + szTag + ".ftabn_id)"
			strSQL = "UPDATE ^"+(svzpName?svzpName:"svzp") + szTag + " SET fsum="+sqlRound("fsum-"
							+ IIF(subStrSQL+" IS NULL", 0, subStrSQL),2)
						+ " WHERE flsfid=" + sqlTo(vidan_lsfid)
							+ sqlTabn;
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось обновить поля фактически выдано по категории "+tblKat.getValue("Fcod");
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}
			break;
		}
	}
	
	//Изменим поля всего удержано основные и по первой категории ЛС
	if(getPar("LS_KAT"))
	{
		for(tblKat.MoveFirst(); !tblKat.IsEOF(); tblKat.MoveNext())
		{
			//Изменим поля всего удержано
			//когда сберкасса заведена готовыми суммами, то она уже учтена во всего начислено, 
			//т.к. расчитывалась ранее процедурой r_sum, поэтому считаем только по нашему коду приказа vidprk
			subStrSQL = "(SELECT SUM(s1.fsum) FROM " + svzpTmp + " AS s1 WHERE s1.flsfid=" 
						+ sqlTo(nach_lsfi3) + " AND s1.ftabn_id=^"+(svzpName?svzpName:"svzp") + szTag + ".ftabn_id and s1.Fvid_prk="+vidprk+")";
			strSQL = "UPDATE ^"+(svzpName?svzpName:"svzp") + szTag + " SET fsum=fsum+"
							+ IIF(subStrSQL+" IS NULL", 0, subStrSQL)
						+ " WHERE flsfid=" + sqlTo(nach_lsfi2)
							+ sqlTabn;
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось обновить поля всего удержано!";
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}
			
			eval('var uder_lsfid = uder_lsfid'+tblKat.getValue("Fcod"));
			subStrSQL = "(SELECT SUM(s1.fsum) FROM " + svzpTmp + " AS s1 WHERE s1.flsfid=" 
						+ sqlTo(nach_lsfi3) + " AND s1.ftabn_id=^"+(svzpName?svzpName:"svzp") + szTag + ".ftabn_id and s1.Fvid_prk="+vidprk+")";
			strSQL = "UPDATE ^"+(svzpName?svzpName:"svzp") + szTag + " SET fsum=fsum+"
							+ IIF(subStrSQL+" IS NULL", 0, subStrSQL)
						+ " WHERE flsfid=" + sqlTo(uder_lsfid)
							+ sqlTabn;
			b=ExecuteSQL(strSQL,false);
			if(!b)
			{
				msg = "Не удалось обновить поля всего удержано по категории "+tblKat.getValue("Fcod");
				writeToLog(msg,"e",vopl, vidprk, lsfid);
			}			
			break;
		}
	}

	//добавлять записи в список сумм удержаний будем только в расчетном месяце
	if(!differ(base_m,rasch_m))
	{
		strSQL = "INSERT INTO ^cas_pr_u (fwid_wp, fid, fsum, fbdat, fedat, fnum)"
				+ " SELECT pa.fwid_wp, pa.fwid AS fid, s.fsum"
					+ ", " + sqlTo(D1) + " AS fbdat"
					+ ", " + sqlTo(D2) + " AS fedat"
					+ ", p.fnum"
				+ " FROM ^prk_all AS pa INNER JOIN ^prk_c_pr AS p ON pa.Fwid=p.Fwid"
									+ " INNER JOIN ^work_pers as wp ON wp.fwid=pa.fwid_wp"
									+ " INNER JOIN ^"+(svzpName?svzpName:"svzp") + szTag + " AS s"
									+ " ON wp.fwid_cl=s.ftabn_id AND pa.fwid=s.fid_prk"
				+ " WHERE pa.fvid_prk=" + sqlTo(vidprk) + " AND s.flsfid=" + sqlTo(nach_lsfi3)
		                + " AND pa.fbdat<=" + sqlTo(D2) + " AND pa.fedat>=" + sqlTo(D1)
		                + (ftabn_id?" and pa.Ftabn_id in ("+ftabn_id+") ":""); 
		b=ExecuteSQL(strSQL,false);
		if(!b)
		{
			msg = "Не удалось добавить записи в список сумм удержаний!";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
		}
	}
	if(getPar("LS_KAT"))
		tblKat.close();
	return;
}