//Расчет перечислений в сберкассу  (%)   Fis12 - "к" 
// передаются ДАТА расчета - для использования нужных временных файлов
// vvopl - вид оплаты
// № поля как считать (например, Оклад,совместители), куда передается результат ffld  VVDPL
// код поля ЛС flsfid  VVCSLID

include("Objects/DpDefVed.js");
include("transf:Objects/DpTransfer.js");
include("servis/date.js");
var JSName = "r_castr: ";

function name_castr()
{
	return "Перерахування в ощадкасу прив'язані до довідника місць перерахувань|Перечисления в сберкассу привязанные к справочнику мест перечислений";
}

function r_castr(mdat, vvopl, vvprk, mvvlsfid, mvvlsfid2, ftabn_id, svzpName)
{
	var DefVed = new DpDefVed();
	var szName;

	var base_m = javaDate2Script(firstDay(base_month));
	var rasch_m = javaDate2Script(firstDay(mdat));
	if (month_difference(base_m, rasch_m) != 1)
	{
		return;
	}
	
	var SVZPFILE=(svzpName?svzpName:"svzp")+month_txt(mdat);

	// дата начала
	var D1 = rasch_m
	// дата конца
	var D2 = goMonth(rasch_m,1);

	var oSnap;

	//Проверим есть ли таблица с данными приказа.
	if(!IsTableEx("ZRP_MDB", "COM_"+TBL_TRPRIK))
	{
		var txt = ru("Отсутствует таблица ","Відсутня таблиця " )+TBL_TRPRIK;
		writeToLog(txt, "e", vvopl, vvprk, mvvlsfid);
		return;
	}
	//Выбираем данные по данному приказу.
	strSQL = "SELECT p.*"
			+" FROM ^prk_all as p inner join ^"+TBL_TRPRIK+" as c on p.Fwid=c.Fwid "
			+" WHERE p.FVID_PRK = " +sqlTo(vvprk)
				+" AND p.FBDAT <= "+sqlTo(D2)+" AND p.FEDAT >= "+sqlTo(D1)
				+(ftabn_id?" and p.Ftabn_id in ("+ftabn_id+")":"")
	var tblPrk = OpenTable(strSQL);
		
	if (!tblPrk || tblPrk.IsEmpty())
	{
		var txt = ru("Приказы отсутствуют.","Накази відсутні." );
		writeToLog(txt, "w", vvopl, vvprk, mvvlsfid);
		return;
	}	
	
	//Найдем поле фактически выдано. (поле должно быть включено тоисть FIS_SLCT = sqlTrue)
	var snLIC_FLD = getSnap("SELECT FID, FFLD_NUM "
						+" FROM ^LIC_FLD "
						+"WHERE 1=1"
							+" AND FIS6 = "+sqlTo("ф")
							+" AND FIS_SLCT = "+sqlTrue);
	if(snLIC_FLD == null)
	{		
		var txt = ru("Обнаружена серьезная ошибка функционирования системы"
						, "Виявлена серйозна помилка функціонування системи" );
		txt += ru("Hевозможно идентифицировать поле ЛС:фактич.выдано"
					, "неможливо ідентифікувати поле ОР:фактично видано");
		
		writeToLog(txt, "e", vvopl, vvprk, mvvlsfid);
		return;
	}

	var fVudLsFid = snLIC_FLD[0];
	var fVudLsNum = snLIC_FLD[1];
	snLIC_FLD = null;

	//Найдем всего удержано (поле должно быть включено тоисть FIS_SLCT = sqlTrue)
	var snLIC_FLD2 = getSnap("SELECT FID, FFLD_NUM "
						+" FROM ^LIC_FLD "
						+"WHERE 1=1"
							+" AND FIS6 = "+sqlTo("у")
							+" AND FIS_SLCT = "+sqlTrue);
	if(snLIC_FLD2 == null)
	{
		var txt = ru("Обнаружена серьезная ошибка функционирования системы"
						, "Виявлена серйозна помилка функціонування системи" );
		txt += ru("Hевозможно идентифицировать поле ЛС:всего удержано"
					, "неможливо ідентифікувати поле ОР:всього утримано");		
		
		writeToLog(txt, "e", vvopl, vvprk, mvvlsfid);
		return;
	}
	
	var fUdLsFid = snLIC_FLD2[0];
	var fUdLsNum = snLIC_FLD2[1];
	snLIC_FLD2 = null;

	//Найдем поле "на сберкассу" (поле должно быть включено тоисть FIS_SLCT = sqlTrue)
	var snLIC_FLD3 = getSnap("SELECT FID, FFLD_NUM "
						+" FROM ^LIC_FLD "
						+"WHERE 1=1"
							+" AND FIS12 = "+sqlTo("к")
							+" AND FIS_SLCT = "+sqlTrue);
	if(snLIC_FLD3 == null)
	{
		var txt = ru("Обнаружена серьезная ошибка функционирования системы"
						, "Виявлена серйозна помилка функціонування системи" );
		txt += ru("Hевозможно идентифицировать поле ЛС:на сберкаcсу"
					, "неможливо ідентифікувати поле ОР:на ощадну касу");		
		
		writeToLog(txt, "e", vvopl, vvprk, mvvlsfid);
		return;
	}
	
	var toSberLsFid = snLIC_FLD3[0];
	var toSberLsNum = snLIC_FLD3[1];
	snLIC_FLD3 = null;

	var msg = ru("Проверка правильности расчета перечислений в сберкассу"
				,"Перевірка правильності розрахунку перерахувань в ощадкасу");
	writeToLog(msg,"m",vvopl,vvprk,mvvlsfid);
	//DefVed.begin("", msg);

	// Проверяем таблицу "ZRP_" + SVZPFILE, если ее нет, то создаем по шаблону "SVZP"	
	if(!IsTableEx("ZRP_RES", "ZRP_" + SVZPFILE))
	{
		CreateTableEx("ZRP_RES", "ZRP_" + SVZPFILE, "SVZP", "*");
	}
	
	//Проходим по таблице tblPrk
	tblPrk.MoveFirst();
	while(!tblPrk.IsEOF())
	{		
		var mFtabn_id   = tblPrk.getValue("FTABN_ID");
		var mFwid_wp = tblPrk.getValue("FWID_WP");
		var mFwid    = tblPrk.getValue("FWID");
		var sum_proc	= prk_proc = Number(tblPrk.getValue("FPROC"));
		var sum_sum	= prk_sum = Number(tblPrk.getValue("FSUM"));


		// поиск суммы всего к выдаче (это остаток к выдаче + выдано через сберкассу)
		strSQL = "SELECT SUM(FSUM)"
				+" FROM ^"+SVZPFILE
				+" WHERE FTABN_ID = "+sqlTo(mFtabn_id)
					+" AND FLSFID IN("+sqlTo(fVudLsFid)+", "+sqlTo(toSberLsFid)+")"
		oSnap = getSnap(strSQL);
			
		var summTrAll = (oSnap!=null && !isEmpty(Number(oSnap[0])) ? Number(oSnap[0]) : 0);
		oSnap = null;
		
		// поиск суммы которую осталось выдать
		strSQL = "SELECT SUM(FSUM)"
				+" FROM ^"+SVZPFILE
				+" WHERE 1=1"
					+" AND FTABN_ID = "+sqlTo(mFtabn_id)
					+" AND FLSFID = "+sqlTo(fVudLsFid)
		oSnap = getSnap(strSQL);
			
		var ost2Vud = (oSnap!=null && !isEmpty(Number(oSnap[0])) ? Number(oSnap[0]) : 0);
		oSnap = null;		
				
		//Если есть конкретная сумма то на процент ложем болт.
		prk_proc = prk_sum ? 0 : prk_proc;			
		
		//Сумма которую необходимо перечислить на сберкассу
		var summTr = 0;
		if (ost2Vud > 0)
		{
			// расчет суммы перечисления с учетом процента
			summTr = prk_sum+round(summTrAll * prk_proc /100, 2);
			
			//также смотрим чтобы сума к перечислению не превышала суму остатка
			summTr = (ost2Vud < summTr ? ost2Vud : summTr);
		}
		
		var csum = 0;
		
		//Уменьшем остаток к выдаче.
		ost2Vud -= summTr;
		if (summTr > 0)
		{
			//Добавляем сумму перечисления на сберкассу.
			var m = new Object();
			m.FTABN_ID = mFtabn_id;
			m.FFLD_NUM = toSberLsNum;
			m.FLSFID =  toSberLsFid;
			m.FBDY = D1.getDate();
			m.FEDY = D2.getDate();
			m.FSUM = summTr;
			m.FWID_WP = mFwid_wp;
			m.FDAY = 0;
			m.FIS_DAY = 0;
			m.FVID_PRK = vvprk;
			m.FID_PRK = tblPrk.getValue("FWID");
			UpdateTable("^"+SVZPFILE, m, true);
			
			//ищем такую строку 
			var snSVZPFILE = getSnap("SELECT *"
								+"FROM ^"+SVZPFILE
								+" WHERE 1=1"
									+" AND FTABN_ID = "+sqlTo(mFtabn_id)
									+" AND FLSFID = "+sqlTo(fVudLsFid));
			
			//если ее нету нужно создать 
			if(snSVZPFILE == null)
			{
				//нет поля Фактич.выдано - надо сначала добавить строку
				//с нулевой суммой
				var m = new Object();
				m.FTABN_ID = mFtabn_id;
				m.FFLD_NUM = fVudLsNum;
				m.FLSFID = fVudLsFid;
				m.FBDY = D1.getDate();
				m.FEDY = D2.getDate();
				m.FSUM = 0;
				m.FWID_WP = mFwid_wp;
				m.FDAY = 0;
				m.FIS_DAY = 0;
				m.FVID_PRK = 0;
				UpdateTable("^"+SVZPFILE, m, true);					
			}
			snSVZPFILE = null;	
			
			//изменим суму в этой строке 
			strSQL = "UPDATE ^"+SVZPFILE
						+" SET FSUM = "+sqlRound(Convert("FSUM - "+sqlTo(summTr), "MONEY"), 2)
					+" WHERE 1=1"
						+" AND FTABN_ID = "+sqlTo(mFtabn_id)
						+" AND FLSFID = "+sqlTo(fVudLsFid)
			ExecuteSQL(strSQL);

			//ищем такую строку 
			var snSVZPFILE = getSnap("SELECT * "
								+"FROM ^"+SVZPFILE
								+" WHERE 1=1"
									+" AND FTABN_ID = "+sqlTo(mFtabn_id)
									+" AND FLSFID = "+sqlTo(fUdLsFid));

			//если ее нету нужно создать 
			if(snSVZPFILE == null)
			{
				//нет поля Фактич.выдано - надо сначала добавить строку
				//с нулевой суммой
				var m = new Object();
				m.FTABN_ID = mFtabn_id;
				m.FFLD_NUM = fUdLsNum;
				m.FLSFID = fUdLsFid;
				m.FBDY = D1.getDate();
				m.FEDY = D2.getDate();
				m.FSUM = 0;
				m.FWID_WP = mFwid_wp;
				m.FDAY = 0;
				m.FIS_DAY = 0;
				m.FVID_PRK = 0;
				UpdateTable("^"+SVZPFILE, m, true);					
			}				
			snSVZPFILE = null;		
			
			//изменим суму в этой строке 
			strSQL = "UPDATE ^"+SVZPFILE
						+" SET FSUM = "+sqlRound(Convert("FSUM + "+sqlTo(summTr), "MONEY"), 2)
					+" WHERE 1=1"
						+" AND FTABN_ID = "+sqlTo(mFtabn_id)
						+" AND FLSFID = "+sqlTo(fUdLsFid)
			ExecuteSQL(strSQL);
		}
		
		if(!tblPrk.IsEOF())
		{
			prk_proc = Number(tblPrk.getValue("FPROC"));
			prk_sum = Number(tblPrk.getValue("FSUM"));
		}
		sum_proc = sum_proc + prk_proc;
		tblPrk.MoveNext();
	}
	tblPrk.close();	
	DefVed.end();

	//чистим строки с нулевыми сумами
	ExecuteSQL("delete from ^" + SVZPFILE + " where (fsum is null or fsum=0) and (fdnkl is null or fdnkl=0) "+(ftabn_id?" and Ftabn_id in ("+ftabn_id+")":""));
	ExecuteSQL("UPDATE ^" + SVZPFILE + " set Fwid_wp=0 where fwid_wp is null"+(ftabn_id?" and Ftabn_id in ("+ftabn_id+")":""));
	return;
}