//актуальней использовать _compal
function name_compar()
{
	return "Перерахунок зарплати (застарів)|Перерасчет зарплаты (устарел)"
}
function r_compar (mdat_rasch,mvvopl,mvvprk,mvvlsfid,mvvlsfid2,ftabn_id,svzpName)
{
   var SVZP_table, SVZO_table, DLT_table;
   var next_month = new Date(mdat_rasch.getFullYear(),mdat_rasch.getMonth()+1,1)
   var rebuild_fl = 100;
   var mFday = mFchas = mFproc = 0;
   // процедура для сравнения старого и нового SVZP может работать в четырех
   // режимах:
   //  1.  полной     перезаписи (расчет за базовый месяц и rebuild=100)
   //  3.  полного    сравнения (расчет за не базовый месяц и rebuild=100)

   //  1. режим полной перезаписи (ничего не надо делать т.к. новый SVZP
   //  будет оставлен в качестве SVZO при переименовании в R_ALL)
   //  процедура для сравнения старого и нового SVZP (только для небаз.месяцев)

	  if (!differ(mdat_rasch,base_month) && (rebuild_fl==100))
   	 return;

   // если ключи совпадают, то произв-ся суммир-е по полю ЛС, и, если суммы не
   //   равны, то в SVZO записывается разность c датой = базовому месяцу
   // если не совпадают, то
   //   а) ст.> нового - суммируем по новому и добавляем разность в старый
   //   б) ст.< нового - суммируем по старому и добавляем разность в старый

   // достаем цифры к названию файла для базового месяца
   if (base_month.getMonth() < 9)
      bas_m = String(base_month.getFullYear())+"0"+String(base_month.getMonth()+1);
   else
      bas_m = String(base_month.getFullYear())+String(base_month.getMonth()+1);

   // достаем цифры к названию файла для расчетного месяца
   if (mdat_rasch.getMonth() < 9)
      ras_m = String(mdat_rasch.getFullYear())+"0"+String(mdat_rasch.getMonth()+1);
   else
      ras_m = String(mdat_rasch.getFullYear())+String(mdat_rasch.getMonth()+1);

   // достаем цифры к названию файла для следующего за расчетным месяцем
   if (next_month.getMonth() < 9)
      nxt_m = String(next_month.getFullYear())+"0"+String(next_month.getMonth()+1);
   else
      nxt_m = String(next_month.getFullYear())+String(next_month.getMonth()+1);

   var cbas_m = base_month.getVarDate()
   var cras_m = mdat_rasch.getVarDate()
   var cnxt_m = next_month.getVarDate()

   var tblOut = "zrp_" + ""+(svzpName?svzpName:"svzp") + ras_m;
   if(!IsTableEx("zrp_res", tblOut))
   	 return;
   	 
   var strW=" where not (fvp=2  and Fmn<"+sqlTo(cras_m)+") and not (fvp=2 and  Fmn >" +sqlTo(cras_m)+" ) and not (fvp=1  and Fmn<"+sqlTo(cras_m)+") "   	 

   //SVZP_table    = OpenTable("s",""+(svzpName?svzpName:"svzp")+ras_m,"SVTN");
   var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
   var strSQL = "select * from " + "^"+(svzpName?svzpName:"svzp") + ras_m + strW + sqlTabn + " order by Ftabn_id, Flsfid, Fwid_wp, fid_prk"
   SVZP_table    = OpenTable("s", strSQL);

   var calcNum = svzpName?svzpName.replace(/svzp/i,""):"";
   siName = "^svzo"+calcNum+ras_m;
   var tblOut = "zrp_" + "svzo"+calcNum + ras_m;
   if(!IsTableEx("zrp_res", tblOut))
   	  return;

   //вставляем этот кусок из-за перекодировки, т,к, fwid_wp=0 для удержаний при расчете,
   //а перекодировка проставила там fwid_wp. потом этот кусок можно будет убрать.
   //скопируем старый svzp во временную таблицу, чтобы восстановить, если понадобится.
   //сейчас для проверки. Кроме того, если сбой при перерасчете, то отсюда всегда можно
   //восстановить переименованную при перерасчете таблицу svzp, и не нужно лезть в архив.
   // так что пусть пока побудет.
   DropTable("svzc"+ras_m)
   if (!IsTable("svzc"+ras_m)){
   		var strSQL = "select * into svzc"+ras_m+" from " + "^svzo"+calcNum + ras_m
   		ExecuteSQL(strSQL);
   }	
   //сделала, чтобы увидеть, прописались авансы или нет в SVZP. После отладки авансов
   // таблицу svzn можно не создавать
//   DropTable("svzn"+ras_m)
//   if (!IsTable("svzn"+ras_m)){   
//        var strSQL = "select * into svzn"+ras_m+" from " + "^"+(svzpName?svzpName:"svzp") + ras_m
//   		ExecuteSQL(strSQL);
//   }	
   //**************
   
   //кусок из-за разных данных в этих полях после перекодировки и расчетов. 
   strSQL = "UPDATE ^svzo"+calcNum+ras_m+" set Fid_prk=0 where Fid_prk is null"+sqlTabn
   ExecuteSQL(strSQL);   
   strSQL = "UPDATE ^svzo"+calcNum+ras_m+" set Fwid_wp=0 where (select Fis6 from ^lic_fld where Fid=^svzo"+calcNum+ras_m+".Flsfid)='-'"+sqlTabn
   ExecuteSQL(strSQL);

   strSQL = "UPDATE ^"+(svzpName?svzpName:"svzp")+ras_m+" set Fid_prk=0 where Fid_prk is null"+sqlTabn
   ExecuteSQL(strSQL);   
   //***************
        	  
   //SVZO_table    = OpenTable("s","svzo"+calcNum+ras_m,"SVTN");
   var strSQL = "delete from " + "^svzo"+calcNum + ras_m+ " where Fmn="+sqlTo(base_month)+" and Fvp=1"+sqlTabn;
   ExecuteSQL(strSQL);
   var strSQL = "select * from " + "^svzo"+calcNum + ras_m+ strW + sqlTabn + " order by Ftabn_id, Flsfid, Fwid_wp, fid_prk"
   SVZO_table    = OpenTable("s", strSQL);

   //Lic_table   = OpenTable("s","SELECT * FROM ^LIC_FLD")

   var tblOut = "zrp_" + "dlt" + bas_m;
   if (!IsTableEx("zrp_mdb", tblOut))
   	 CreateTableEx("zrp_mdb", tblOut, "dlt", "*")

   siName = "^dlt"+bas_m;
   ExecuteSQL("DELETE from "+siName+" where Fmn="+sqlTo(mdat_rasch)+sqlTabn);

   DLT_table    = OpenTable("s","SELECT * FROM " + siName+" where Fmn="+sqlTo(mdat_rasch)+sqlTabn+" order by Ftabn_id, Flsfid, fwid_wp, fid_prk");

   // режим полного сравнения SVZO с SVZP
   if (differ(mdat_rasch,base_month) && (rebuild_fl==100))
   {
      var svzp_eof = SVZP_table.IsEOF()
      var svzo_eof = SVZO_table.IsEOF()
      var stop = svzp_eof && svzo_eof
      while (!stop)
      {
         if (!svzo_eof)
         {
            //var o_key = SVZO_table("Ftabn") + SVZO_table("Flsfid") + SVZO_table("Fsht_id")
            //super vv 31.05 складывались числа!!!
            //var o_key = SVZO_table("Ftabn") + SVZO_table("Flsfid") + SVZO_table("Fsht_id")

            //super vv 18.10.2001 Поля ключа должны иметь фиксированную длину
            //var o_key = sqlTo(SVZO_table("Ftabn")) + sqlTo(SVZO_table("Flsfid")) + sqlTo(SVZO_table("Fsht_id"))
	          //var o_key = padl(getClcodByID(getPar("CODPERS"),SVZO_table.getValue("Ftabn_id")),6) + padl(SVZO_table.getValue("Flsfid"),6) + padl(SVZO_table.getValue("Fwid_wp"),12)+padl(SVZO_table.getValue("Fid_prk"),12)
	          var o_key = padl(SVZO_table.getValue("Ftabn_id"),12) + padl(SVZO_table.getValue("Flsfid"),6) + padl(SVZO_table.getValue("Fwid_wp"),12)+padl(SVZO_table.getValue("Fid_prk"),12)
         }
         if (!svzp_eof)
         {
           //var n_key = SVZP_table("Ftabn") + SVZP_table("Flsfid") + SVZP_table("Fsht_id")
           //super vv 31.05 складывались числа!!!
           //var n_key = SVZP_table("Ftabn") + SVZP_table("Flsfid") + SVZP_table("Fsht_id")
          //var n_key = padl(getClcodByID(getPar("CODPERS"),SVZP_table.getValue("Ftabn_id")),6) + padl(SVZP_table.getValue("Flsfid"),6)+padl(SVZP_table.getValue("Fid_prk"),12)
              var n_key = padl(SVZP_table.getValue("Ftabn_id"),12) + padl(SVZP_table.getValue("Flsfid"),6) + padl(SVZP_table.getValue("Fwid_wp"),12)+padl(SVZP_table.getValue("Fid_prk"),12)         
         }
         var min_key,minFtabn_id,minFlsfid,minFfld_n,minFshtid,minFidprk

         if ((!svzp_eof) && (!svzo_eof))
         {
            min_key   = (n_key > o_key)? o_key: n_key
            minFtabn_id  = (n_key > o_key)? SVZO_table.getValue("Ftabn_id"): SVZP_table.getValue("Ftabn_id")
            minFlsfid = (n_key > o_key)? SVZO_table.getValue("Flsfid"): SVZP_table.getValue("Flsfid")
            minFfld_n = (n_key > o_key)? SVZO_table.getValue("Ffld_num"): SVZP_table.getValue("Ffld_num")
            minFshtid = (n_key > o_key)? SVZO_table.getValue("Fwid_wp"): SVZP_table.getValue("Fwid_wp")
            minFshpz  = (n_key > o_key)? SVZO_table.getValue("Fshpz"): SVZP_table.getValue("Fshpz")
            minFidprk = (n_key > o_key)? SVZO_table.getValue("Fid_prk"): SVZP_table.getValue("Fid_prk")
            if(getPar("PRIK_IZD")){
                minFkizd = (n_key > o_key)? SVZO_table.getValue("Fkodizd"): SVZP_table.getValue("Fkodizd")            	
            }            		
         }
         else
         {
            if ((svzp_eof) && (!svzo_eof))
            {
               min_key   = o_key
               minFtabn_id  = SVZO_table.getValue("Ftabn_id")
               minFlsfid = SVZO_table.getValue("Flsfid")
               minFfld_n = SVZO_table.getValue("Ffld_num")
               minFshtid = SVZO_table.getValue("Fwid_wp")
               minFshpz  = SVZO_table.getValue("Fshpz")
               minFidprk = SVZO_table.getValue("Fid_prk")
               if(getPar("PRIK_IZD")){
                   minFkizd = SVZO_table.getValue("Fkodizd")            	
               }            		               
            }
            else
            {
               if ((!svzp_eof) && (svzo_eof))
               {
                  min_key   = n_key
                  minFtabn_id  = SVZP_table.getValue("Ftabn_id")
                  minFlsfid = SVZP_table.getValue("Flsfid")
                  minFfld_n = SVZP_table.getValue("Ffld_num")
                  minFshtid = SVZP_table.getValue("Fwid_wp")
                  minFshpz  = SVZP_table.getValue("Fshpz")
                  minFidprk = SVZP_table.getValue("Fid_prk")
                  if(getPar("PRIK_IZD")){
                      minFkizd = SVZP_table.getValue("Fkodizd")            	
                  }            		               
               }
            }
         }
         var osum_dy=osum_ch=osum_xx=oproc=nsum_dy=nsum_ch=nsum_xx=nproc=0;
         var otm_in_dy=otm_in_ch=otm_in_xx=ntm_in_dy=ntm_in_ch=ntm_in_xx=false

         // накопление сумм по полю ЛС для данного табельного номера
         var n_sum = 0;
         //while ((!SVZP_table.IsEOF()) && (SVZP_table("Ftabn")==minFtabn) &&
         //      (SVZP_table("Flsfid")==minFlsfid) && (SVZP_table("Fsht_id")==minFshtid)){

         //vvs 15.06.2004
         nFlgot   = 0
         oFlgot   = 0
         mFis_day = 0

         nFkatzo   = 0
         oFkatzo   = 0
         //nFproczo   = 0
         //oFproczo   = 0
         
         while ((!SVZP_table.IsEOF()) && (Number(SVZP_table.getValue("Ftabn_id"))==Number(minFtabn_id)) &&
               (Number(SVZP_table.getValue("Flsfid"))==Number(minFlsfid)) &&
               (Number(SVZP_table.getValue("Fwid_wp"))==Number(minFshtid))&&
               (Number(SVZP_table.getValue("Fid_prk"))==Number(minFidprk)))
         {
            //super vv 16.10.2001
            /*
            // исключаются из рассмотрения записи по предв. расчетам
            // за будущие месяцы произведенные в расчетном месяце
            if (!((SVZP_table("fvp")==2) && (SVZP_table("Fmn")>cras_m))){
            */
            // исключаются из рассмотрения записи по предв. расчетам за будущие
            // месяцы произведенные в расчетном месяце, а также
            // исключаются из рассмотрения записи по расчетам за прошлые
            // месяцы произведенные в расчетном месяце
            // исключаются из рассмотрения записи по предварит. расчетам за
            // расчетный месяц выплаты по которым были произведены ранее
            // (эти записи со знаком - как бы анулируют начисления)
             fmn = new Date(SVZP_table.getValue("Fmn")).getVarDate();
             if ((!((Number(SVZP_table.getValue("fvp")) == 2) && (differ(fmn,cras_m)==-1))) &&
               (!((Number(SVZP_table.getValue("fvp")) == 2) && (differ(fmn,cras_m)==1))) &&
               (!((Number(SVZP_table.getValue("fvp")) == 1) && (differ(fmn,cras_m)==-1))))
            {

               if (Number(SVZP_table.getValue("Fis_day"))==2)
               {
                  nFlgot   = Number(SVZP_table.getValue("Fday"))
                  mFis_day =  2
               }
               
               if (Number(SVZP_table.getValue("Fis_day"))==3){
                   nFkatzo   = Number(SVZP_table.getValue("Fday"))
                   //nFproczo  = Number(SVZP_table.getValue("Fchas"))
                   mFis_day =  3
                }
                nproc = Number(SVZP_table.getValue("Fproc"));

               if (Number(SVZP_table.getValue("Fday"))!=0)
               {
                  ntm_in_dy=true
                  nsum_dy = nsum_dy + Number(SVZP_table.getValue("Fday"));
               }
               else
               {
                  if (Number(SVZP_table.getValue("Fchas"))!=0)
                  {
                     ntm_in_ch=true
                     nsum_ch = nsum_ch + Number(SVZP_table.getValue("Fchas")) ///???????????
                  }
                  else
                  {
                     ntm_in_xx=true
                     nsum_xx = nsum_xx + Number(SVZP_table.getValue("Fday")) ///???????
                  }
               }
               n_sum = n_sum + Number(SVZP_table.getValue("Fsum"));
            }
            if (!SVZP_table.isEOF()) 
            	SVZP_table.MoveNext();
         }

         var o_sum   = 0
         var o_sum_b = 0
         var b_rec_exist = false
         //while ((!SVZO_table.IsEOF()) && (SVZO_table("Ftabn")==minFtabn) &&
         //      (SVZO_table("Flsfid")==minFlsfid) && (SVZO_table("Fsht_id")==minFshtid)){

         while ((!SVZO_table.IsEOF()) && (Number(SVZO_table.getValue("Ftabn_id")) == Number(minFtabn_id)) &&
               (Number(SVZO_table.getValue("Flsfid")) == Number(minFlsfid)) &&
               (Number(SVZO_table.getValue("Fwid_wp")) == Number(minFshtid))&&
               (Number(SVZO_table.getValue("Fid_prk")) == Number(minFidprk)))
         {
           // исключаются из рассмотрения записи по предв. расчетам за будущие
           // месяцы произведенные в расчетном месяце, а также
           // исключаются из рассмотрения записи по расчетам за прошлые
           // месяцы произведенные в расчетном месяце
           // исключаются из рассмотрения записи по предварит. расчетам за
           // расчетный месяц выплаты по которым были произведены ранее
           // (эти записи со знаком - как бы анулируют начисления)
             fmn = new Date(SVZO_table.getValue("Fmn")).getVarDate();
             if ((!((Number(SVZO_table.getValue("fvp")) == 2) && (differ(fmn,cras_m)==-1))) &&
                (!((Number(SVZO_table.getValue("fvp")) == 2) && (differ(fmn,cras_m)==1))) &&
                (!((Number(SVZO_table.getValue("fvp")) == 1) && (differ(fmn,cras_m)==-1))))
           {
              //- устранение ранее допущенных ошибок ---------------------------
              // если по каким либо причинам (ошибки в версиях r_compar до 25.06.92)
              // существует более одной записи за базовый месяц, то они удаляются.
              // b_rec_exist=.T.  если уже была обнаружена запись за базовый месяц

              if (b_rec_exist)
              {
                 ExecuteSQL("DELETE FROM ^svzo"+calcNum + ras_m + " WHERE FWID=" + sqlTo(SVZO_table.getValue("FWID")));	
                 SVZO_table.MoveNext();
                 break;
              }
              //----------------------------------------------------------------
              

              if (Number(SVZO_table.getValue("Fis_day"))==2 && !((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp"))==1)))
              {
                 oFlgot   = SVZO_table.getValue("Fday")
                 mFis_day =  2
              }
              
              if (Number(SVZO_table.getValue("Fis_day"))==3 && !((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp"))==1))){              
                  oFkatzo   = Number(SVZO_table.getValue("Fday"))
                  //oFproczo  = Number(SVZO_table.getValue("Fchas"))
                  mFis_day =  3
               }
               oproc = Number(SVZO_table.getValue("Fproc"));
              
         		//старые дни и часы считаем в любом случае
               osum_dy = ((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp"))==1))? osum_dy: osum_dy + ((Number(SVZO_table.getValue("Fsum"))<0)?Number(SVZO_table.getValue("Fday"))*(-1):Number(SVZO_table.getValue("Fday")));
               osum_ch = ((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp")) == 1))? osum_ch: osum_ch + ((Number(SVZO_table.getValue("Fsum"))<0)?Number(SVZO_table.getValue("Fchas"))*(-1):Number(SVZO_table.getValue("Fchas")));

              if (Number(SVZO_table.getValue("Fday"))!=0)
              {
                 otm_in_dy=true
                 //osum_dy = ((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp"))==1))? osum_dy: osum_dy + Number(SVZO_table.getValue("Fday"));
              }
              else
              {
                 if (Number(SVZO_table.getValue("Fchas")) != 0)
                 {
                    otm_in_ch=true
                    //osum_ch = ((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp")) == 1))? osum_ch: osum_ch + Number(SVZO_table.getValue("Fchas"));
                 }
                 else
                 {
                    otm_in_xx=true
                    //osum_xx = ((SVZO_table.getValue("Fmn") == cbas_m) && (Number(SVZO_table.getValue("Fvp")) == 1))? osum_xx: osum_xx + Number(SVZO_table.getValue("Fday"));
              		osum_xx = ((SVZO_table.getValue("Fmn") == cbas_m) && (Number(SVZO_table.getValue("Fvp")) ==1 ))? osum_xx: osum_xx + ((Number(SVZO_table.getValue("Fsum"))<0)?Number(SVZO_table.getValue("Fday"))*(-1):Number(SVZO_table.getValue("Fday")));                    
                 }
              }
              o_sum   = o_sum + Number(SVZO_table.getValue("Fsum"));
           }
           o_sum_b = ((SVZO_table.getValue("Fmn")==cbas_m) && (Number(SVZO_table.getValue("Fvp")) == 1))? o_sum_b+Number(SVZO_table.getValue("Fsum")): o_sum_b
           b_rec_exist = ((SVZO_table.getValue("Fmn") == cbas_m) && (Number(SVZO_table.getValue("Fvp")) == 1))? true: b_rec_exist
           // удаление нулевых записей на всякий случай
         
       			
           SVZO_table.MoveNext();
         }
         
		//ExecuteSQL("DELETE FROM ^svzo"+calcNum + ras_m + " WHERE FSUM=0");		
         // запись разности сумм по новому и старому файлам
        //дополнительные обработки случаев определения дней/часов
		if(ntm_in_dy && otm_in_xx)
		{
			otm_in_dy = true;
		}
		else
		{
			if(ntm_in_ch && otm_in_xx)
			{
				otm_in_ch = true;
			}
			else
			{
				if(otm_in_dy && ntm_in_xx)
				{
					ntm_in_dy = true;
				}
				else
				{
					if(otm_in_ch && ntm_in_xx)
						ntm_in_ch = true;
					else
						ntm_in_dy = true;
				}
			}
		}
         if ((o_sum != n_sum) || (o_sum_b != 0))
         {
            // определение числа дней/часов для некоторых случаев
            if (ntm_in_dy && otm_in_dy)
            {
               mFday    =  Math.abs(nsum_dy - osum_dy)
               mFchas   =  Math.abs(nsum_ch - osum_ch)
               //если сначала проставили дни и часы, а потом исправили только на дни, то часы обнуляем
	           //наоборот тоже обнулим, т,к, правильно разницу все равно нельзя взять
    	       if ((nsum_ch==0 && osum_ch!=0) || (nsum_ch!=0 && osum_ch==0)){
        	       mFchas   =  0            	   
    	       }               
               mFis_day =  0
            }
            else
            {
               if (ntm_in_ch && otm_in_ch)
               {
                  mFday    =  Math.abs(nsum_dy - osum_dy)
                  mFchas   =  Math.abs(nsum_ch - osum_ch)
                  mFis_day =  1
               }
               else
               {
                  if ((o_sum==0) || (o_sum==o_sum_b) && (ntm_in_dy))
                  {
                     mFday    =  Math.abs(nsum_dy)
                     mFchas   =  Math.abs(nsum_ch)
                     mFis_day =  0
                  }
                  else
                  {
                     if ((o_sum==0) || (o_sum==o_sum_b) && (ntm_in_ch))
                     {
                        mFday    =  Math.abs(nsum_dy)
                        mFchas   =  Math.abs(nsum_ch)
                        mFis_day =  1
                     }
                     else
                     {
                        mFday    =  0
                        mFchas   =  0
                        mFis_day =  0
                     }
                  }
               }
            }

            if (oFlgot!=nFlgot || oFlgot!=0 || nFlgot!=0)
            {
               mFday    =  nFlgot
               mFchas   =  0
               mFis_day =  2
            }      

            mFproc = Math.abs(nproc - oproc);            
            if (oFkatzo!=nFkatzo || oFkatzo!=0 || nFkatzo!=0){
                mFday    =  nFkatzo
                mFproc   =  nproc;                
                mFis_day =  3
             }
      
             if (oFkatzo!=0 && nFkatzo==0){
                 mFday    =  oFkatzo
                 mFproc   =  oproc;                
                 mFis_day =  3
              }      
             
            
            var oSnap = getSnap("SELECT Fncmp, ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(minFlsfid));
            if(oSnap!=null){            
				minFfld_n=oSnap[1]; 
			}else {  
				minFfld_n=0;
			} 
            
            //Lic_table.FindFirst("fid="+sqlTo(minFlsfid))
            var DLT = new Object();
            //if (Lic_table.getValue("Fncmp") == false)
            if(oSnap!=null && !oSnap[0])
            {
               // нужно записать n_sum-o_sum в DLT

               //super vv 18.10.2001
               // Надо редактировать запись в DLT_table только при совпадении
               // ключей
               //if ( (!DLT_table.IsEOF() && DLT_table("Ftabn")+DLT_table("Flsfid")+DLT_table("Fsht_id") > min_key) || DLT_table.IsEOF()){
               //if ( (!DLT_table.IsEOF() && ( padl(getClcodByID(getPar("CODPERS"),DLT_table.getValue("Ftabn_id")),6)+padl(DLT_table.getValue("Flsfid"),6)+padl(DLT_table.getValue("Fid_prk"),12)!= min_key )) || DLT_table.IsEOF())
               if ( (!DLT_table.IsEOF() && ( padl(DLT_table.getValue("Ftabn_id"),12)+padl(DLT_table.getValue("Flsfid"),6)+padl(DLT_table.getValue("Fwid_wp"),12)+padl(DLT_table.getValue("Fid_prk"),12)!= min_key )) || DLT_table.IsEOF())
               {
                  var edit = false;
                  //DLT.Fwid = GetUID();
               }
               else
               {
                  var edit = true;
               }

               DLT.Ftabn_id = minFtabn_id
               DLT.Flsfid = minFlsfid
               DLT.Ffld_num = minFfld_n
               DLT.Fwid_wp = minFshtid
               DLT.Fshpz = minFshpz
               DLT.Fid_prk = minFidprk
               DLT.Fsum = round(n_sum-(o_sum-o_sum_b),2);
               DLT.Fis_day = mFis_day
               DLT.Fday = mFday
               DLT.Fchas = mFchas
               DLT.Fvp = 2
               DLT.Fmn = cras_m
               DLT.Fmrk = " "
               DLT.Fproc = mFproc;
               if(getPar("PRIK_IZD")){               
            	   DLT.Fkodizd  = minFkizd
               }   
            //   DLT_table.Update();
               UpdateTable(siName,DLT,!edit," Fwid=" + sqlTo(DLT_table.getValue("FWID")));
               //super vv 16.10.2001
               // Надо стать на добавленную запись, чтобы для такого же
               // ключа не добавляло новую
               DLT_table.requery();
               DLT_table.FindFirst("FTABN_ID="+sqlTo(minFtabn_id)
                  +" AND FLSFID="+sqlTo(minFlsfid)
                  +" AND FWID_WP="+sqlTo(minFshtid)                  
                  +" AND FID_PRK="+sqlTo(minFidprk));
            }
         }
         svzp_eof=SVZP_table.IsEOF()
         svzo_eof=SVZO_table.IsEOF()
         stop = svzp_eof && svzo_eof
/*
//super vv
if(SVZP_table("FTABN")==30082||SVZO_table("FTABN")==30082){
xxx
}
*/
      }
   }
   SVZO_table.close();
   SVZP_table.close();
   //Lic_table.close();
   DLT_table.close();
   
   ExecuteSQL("DELETE from ^dlt"+bas_m+" where Fsum=0  and (Fdnkl=0 or Fdnkl is null) "+sqlTabn);   
   
   DropTable("TMPSVZO");
   //вставляем в TMPSVZO поля из dlt... не исключая поля FMRK,FTT,FIS_SLCT
   strSQL = "select " + GetPatternIntersection("dlt", "dlt").replace(/(fmrk\s*,)|(,\s*fmrk)|(ftt\s*,)|(,\s*ftt)|(fis_slct\s*,)|(,\s*fis_slct)/gi,"")
   			+ " into TMPSVZO from ^"+"dlt"+bas_m+" where Fmn="+sqlTo(mdat_rasch)+sqlTabn;
   //strSQL = "select * into TMPSVZO from ^"+"dlt"+bas_m+" where Fmn="+sqlTo(mdat_rasch);
   ExecuteSQL(strSQL);
	//strSQL = "update TMPSVZO set Fmn="+sqlTo(mdat_base)+", Fvp=1";
   strSQL = "update TMPSVZO set Fmn="+sqlTo(base_month)+", Fvp=1";
   ExecuteSQL(strSQL);
   //ExecuteSQL("ALTER TABLE TMPSVZO DROP COLUMN FMRK");
   //ExecuteSQL("ALTER TABLE TMPSVZO DROP COLUMN FTT");
   //ExecuteSQL("ALTER TABLE TMPSVZO DROP COLUMN FIS_SLCT");
   
   strSQL = "insert into ^"+"svzo"+calcNum+ras_m+"(" + removeFieldFromList(getColumn("TMPSVZO", false)) + ") select " + removeFieldFromList(getColumn("TMPSVZO", false)) + " from TMPSVZO";
   //strSQL = "insert into ^"+"svzo"+calcNum+ras_m+" select * from TMPSVZO";
   ExecuteSQL(strSQL);
   return;

}

//super vv 18.10.2001
// Вспомогательная ф-ция для формирования из числа строки фиксированной
// длины путем дополнения слева пробелами. Аналог padl() в Fox'е
// Если переданное число длиннее, чем требуемая длина, то не обрезаем
function padl(nWhat, nLength)
{
   var str = String(nWhat);
   var len = str.length;
   var sPrefix = "";
   for(; len<nLength; len++)
   {
      sPrefix += ' ';
   }
   return sPrefix + str;
}