// расчет єдиного социального взноса (начисление)

include("get_cnst.js")
include("servis\\date.js")

function name_fndev()
{
	return "Розрахунок нарахувань єдиного соціального внеску|Расчет начислений единого социального взноса";
}

function r_fndev (mdat,vvopl,vvprk,mvvcslid,mvvcslid2,ftabn_id,svpfName)
{ 
	
   //константа, сколько месяцев нужно не учитывать будущие суммы в текущем месяце
   //по новому закону отпускные будущие за январь, начисленные в декабре, нельзя перерасчитывать.
   dtbotp = get_cnst ("dtbotp", mdat)

   //декабрь 2010 зададим явно в программе
   //по новому закону отпускные будущие за январь, февраль и т.д. начисленные в декабре, нельзя перерасчитывать.
   mnbotp = new Date(2010,11,1)
   
   var calcNum = svpfName?svpfName.replace(/svpf/i,""):"";
   var szTag = getDateTag(mdat);       
   var siName = "^svzp"+calcNum+szTag;

   // нулевая дата
   var NulDate = new Date(3000,0,1); 

   //учитывать ограничение
   //var edv1000  = get_cnst("edv1000",mdat);
   var edv1000 = get_cnst("edv1000",mdat);
   var sum_ogr = get_cnst("sum_ogr",mdat);

   //если =0, то как раньше по месяцу возникновения
   //если =1,cчитаем по месяцу начисления (текущие и перерасчеты за прошл.)
   bln_mes_nach = get_cnst("evnach", mdat)
   
   //временно до модификации Winstru
   sfName = "^"+(svpfName?svpfName:"svpf")+szTag;
   
   var DD1=mdat;
   var DDD = DD1.getVarDate();
   var monthtxt1 = getDateTag(DD1);

   var monthtxt  = getDateTag(base_month);

   var SVZPFILE   = "svzp"+calcNum +monthtxt

   if (!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE))
   {
      alert("Внимание ! Перед началом данного рачета проведите расчет з/п за выбранный вами месяц");
      return;
   }

   //временно до изменения Winstru
   var tblOut = "zrp_" + "nxtf";
   if (!IsTableEx("zrp_mdb", tblOut)) CreateTableEx("zrp_mdb", tblOut, "nxtf", "*")


   snName = "^nxtf";
   is_rasch=(base_month.getYear()==mdat.getYear() && base_month.getMonth()==mdat.getMonth() && base_month.getDate()==mdat.getDate());
   var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
   if (is_rasch)
   {
      ExecuteSQL("DELETE from "+snName+" where Fmn="+sqlTo(mdat) + sqlTabn);
   }
      
   DropTable("SVZPEDV");

   var DDD = DD1.getVarDate();

   CreateTable("SVZPEDV", "VSP");
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_kzsht "+SqlType("LONG"))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_kzo "+SqlType("LONG"))
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fproc_edv "+SqlType("CURRENCY"))
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fzatr  "+SqlType("TEXT",1))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fpr "+SqlType("CURRENCY"))
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Ffot  "+SqlType("TEXT",1))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fkatesv  "+SqlType("INT"))
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis30  "+SqlType("TEXT",1))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis19  "+SqlType("TEXT",1))
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis9  "+SqlType("TEXT",1))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fcod_bln "+SqlType("LONG"))   
   ExecuteSQL("ALTER TABLE SVZPEDV ADD Fproc_edb "+SqlType("CURRENCY"))   

	var tbnl = OpenTable("s", "select * from ^NALOG_ESV")
	var fis_36 = false;	
	//если есть 36 категория, проверяем,чтобы была сделана настройка на работу в этой 36 категории. Если ее нет, работаем по-старому
	if (tbnl.isField("Fcod_bln")==true){
		var gs = getSnap("select Fcod_bln from ^NALOG_ESV where (Fcod_bln<>0 and not Fcod_bln is null)")
		if (gs!=null){
			fis_36 = true;
		}	
	}
	tbnl.close();
   
   if (bln_mes_nach==0){
	   //20.12.11 исправила ветку, когда перерасчет индет по месяцу возникновения
      //без прошлых и без будущих с минусами для базового месяца
      if (!differ(base_month, mdat)){
          if (dtbotp!=0){
              //оставляем только текущие,будущие и будущие с минусом с 2010
              //                                                                                                                                                                      без служ.пер..                        без  перер.за прошл.                  буд.отп.с минусом с 2010          
              ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^SVZP"+calcNum+monthtxt1+" WHERE NOT (Fvp=1 and Fmn>="+sqlTo(DD1)+") and NOT (Fvp=2 and Fmn<"+sqlTo(DD1)+") and NOT(Fmn<="+sqlTo(DD1)+" and Fmn>"+sqlTo(mnbotp)+" and Fvp=1)"+ sqlTabn);
           }else{
              //убираем отпускные будущие с минусом и перерасчеты за прошлое и служебные записи
              ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^SVZP"+calcNum+monthtxt1+" WHERE NOT (Fvp=1) and NOT (Fvp=2 and Fmn<"+sqlTo(DD1)+")"+ sqlTabn);
           }  
    	  
	      //ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^svzp"+calcNum+monthtxt1
    	  //	+" WHERE NOT (Fvp=1 and Fmn>="+sqlTo(DDD)+") and NOT (Fvp=2 and Fmn<"+sqlTo(DDD)+")" + sqlTabn);
      }else{
	      //записи с перерасчетами, но без перер.,когда этот месяц был базовым
    	  //ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^svzp"+calcNum+monthtxt1
	      //	+" WHERE (Fvp=0 or (Fvp=1 and Fmn="+sqlTo(base_month)+")) and NOT (Fvp=2 and Fmn<"+sqlTo(DDD)+")" + sqlTabn);
    	  
          if (dtbotp!=0){                                                     
              //оставляем только текущие,будущие с минусом с 2010 и служебные по перерасчету с базового месяца
              ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^SVZP"+calcNum+monthtxt1+" WHERE (Fvp=0 or (Fvp=1 and Fmn<="+sqlTo(base_month)+" and Fmn>"+sqlTo(DD1)+")) or (Fmn<"+sqlTo(DD1)+" and Fmn<="+sqlTo(mnbotp)+" and Fvp=1)"+ sqlTabn);
           }else{
              //оставляем только текущие и служебные по перерасчету с базового месяца
              ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^SVZP"+calcNum+monthtxt1+" WHERE (Fvp=0 or (Fvp=1 and Fmn<="+sqlTo(base_month)+" and Fmn>"+sqlTo(DD1)+"))"+ sqlTabn);
           } 
    	  //с прошлыми для небазового месяца
          //из ввода готовых сумм за прошлые периоды брать все записи до базового месяца включительно
          var sec_mnth = new Date(mdat.getFullYear(),mdat.getMonth()+1,1)  
          kk = Math.round(day_difference(sec_mnth,new Date(lastDayMonth(base_month)))/30);
          var bkv = sec_mnth;	//xyear????? 
      	  var i=1; 
      	  while (i<=kk)
      	  {
       	   	  szTagd = getDateTag(bkv);    		
          	  var DLTUFILE = "dltu" +szTagd;
           	  if (IsTableEx("ZRP_MDB", "ZRP_"+DLTUFILE))
           	  {
                	     strSQL="INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id ) "
                    	        + " SELECT d.Flsfid, p.Fsum, p.Fwid_wp, p.Fshpz, d.Fmn, d.Fvp, p.Ftabn_id "
                        	    + " FROM (^PRK_ALL as p INNER JOIN ^"+DLTUFILE+" as d ON p.Fwid=d.Fwid) WHERE p.Ftabn_id<>0 and d.Fmn="+sqlTo(DD1)+(ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
                     	 ExecuteSQL(strSQL);
           	  }  
           	  bkv.setMonth(bkv.getMonth()+1);
           	  szTagd = getDateTag(bkv)
           	  i=i+1;
       	  }
/*          
      	  var DLTUFILE = "dltu" +monthtxt;
      	  if (IsTableEx("ZRP_MDB", "ZRP_"+DLTUFILE))
      	  {
    	     strSQL="INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id ) "
        	        + " SELECT d.Flsfid, p.Fsum, p.Fwid_wp, p.Fshpz, d.Fmn, d.Fvp, p.Ftabn_id "
            	    + " FROM (^PRK_ALL as p INNER JOIN ^"+DLTUFILE+" as d ON p.Fwid=d.Fwid) WHERE p.Ftabn_id<>0 and d.Fmn="+sqlTo(DD1)+(ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
         	 ExecuteSQL(strSQL);
      	  }
  */
      	  ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fmn="+sqlTo(DD1));
      	  ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fvp=1");
	  }

   }else{
      if (!differ(base_month, mdat)){
          if (dtbotp!=0){
             //если месяц базовый и есть переходящие будущие отпускные и перерасчет не стандартный, а на переходный период
             //убираем только служебные перерасчеты
   		   //без служебных записей
    		  ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^svzp"+calcNum+monthtxt1
    			      +" WHERE NOT (Fvp=1 and Fmn>"+sqlTo(mdat)+")" + sqlTabn);			  
          }else{
             //убираем только служебные перерасчеты и будущие отпускные с минусом
    		  ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^svzp"+calcNum+monthtxt1
    			      +" WHERE NOT (Fvp=1)" + sqlTabn);			  
          } 
      }else{
          //записи с перерасчетами, но без перер.,когда этот месяц был базовым
          ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id) SELECT Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id FROM ^SVZP"+calcNum+monthtxt1+" WHERE 1=1"+ sqlTabn);    	  
          if (dtbotp!=0){
             //оставили служебные с базового месяца, текущие и больн.с минусом будущие с 2010
             //если месяц базовый и есть переходящие будущие отпускные и перерасчет не стандартный, а на переходный период
             ExecuteSQL("delete from SVZPEDV where Fvp=2 or (Fvp=1 and Fmn<>"+sqlTo(base_month)+") and (Fmn<="+sqlTo(DD1)+" and Fmn>"+sqlTo(mnbotp)+" and Fvp=1)")
          }else{
             //оставили служебные с базового месяца и текущие 
             ExecuteSQL("delete from SVZPEDV where Fvp=2 or (Fvp=1 and Fmn<>"+sqlTo(base_month)+")")
          }
    	  //с прошлыми для небазового месяца
    	var DLTUFILE = "dltu" +monthtxt;
      	if (IsTableEx("ZRP_MDB", "ZRP_"+DLTUFILE))
      	{
    	     strSQL="INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id ) "
        	        + " SELECT d.Flsfid, p.Fsum, p.Fwid_wp, p.Fshpz, d.Fmn, d.Fvp, p.Ftabn_id "
            	    + " FROM (^PRK_ALL as p INNER JOIN ^"+DLTUFILE+" as d ON p.Fwid=d.Fwid) WHERE p.Ftabn_id<>0 and d.Fmn="+sqlTo(DD1)+(ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
         	 ExecuteSQL(strSQL);
         	 ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fmn="+sqlTo(DD1));
      	} 
 
      	ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fmn="+sqlTo(DD1));
      	ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fvp=1");
	  }
	  //ExecuteSQL("update SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fmn<="+sqlTo(mdat)+" and Fvp=2")	  
   }
   strSQL = "UPDATE SVZPEDV set Fshpz='0' where Fshpz=' ' or Fshpz is null";
   ExecuteSQL(strSQL);      

   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1) 

    // дата конца
   var DI2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
   var D2 = new Date(mdat.getFullYear(),mdat.getMonth(),DI2) 

   var tDD1=D1.getVarDate()
   var tDD2=D2.getVarDate()


    // дата начала
    var D1prk = new Date(mdat.getFullYear(),mdat.getMonth(),1) 
   
    // дата конца
    var DD2prk = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
    var D2prk = new Date(mdat.getFullYear(),mdat.getMonth(),DD2prk)

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='v' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f3 = false	
	if(null == snap)
	{
	     msg ="Hельзя идентиф.поле ЛС: ЕВ на затраты"+"\n"+
             "Если есть необх.в расчете, "+"\n"+
             "поставьте <v> в 12-ю колонку таблицы вхожд-я полей"
	}
	else
	{
      fld_f3 = true
	  var nach_lsfi3 = snap[0]
      var nach_lsnu3 = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='w' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f4 = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ  из прибыли"+"\n"+
             "Если есть необх.в расчете, "+"\n"+
             "поставьте <w> в 12-ю колонку таблицы вхожд-я полей"
    }else{
       fld_f4 = true
          
   	   var nach_lsfi4 = snap[0]
       var nach_lsnu4 = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='8' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ по комп."+"\n"+
             "Если есть необх.в расчете, "+"\n"+
             "поставьте <8> в 12-ю колонку таблицы вхожд-я полей"
      fld_f8 = false
    }else{
      fld_f8 = true
      var nach_lsfi8 = snap[0]
      var nach_lsnu8 = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='9' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ по комп.ликв."+"\n"+
             "Если есть необх.в расчете, "+"\n"+
             "поставьте <9> в 12-ю колонку таблицы вхожд-я полей"
      fld_f9 = false
   }else{
      fld_f9 = true
          
   	  var nach_lsfi9 = snap[0]
      var nach_lsnu9 = snap[1]
    }

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='5' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f5 = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с зарплаты.\n"
			+ "Если есть необх.в расч.базы ед.взноса с зарплаты,\n"
			+ "поставьте <5> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
	    fld_f5 = true
	    var nach_lsfi5 = snap[0]
   		var nach_lsnu5 = snap[1]
	}

   
	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='6' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f6 = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с больн.\n"
			+ "Если есть необх.в расч.базы ед.взноса с больн.,\n"
			+ "поставьте <6> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
	    fld_f6 = true
	    var nach_lsfi6 = snap[0]
   		var nach_lsnu6 = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='7' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f7 = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: база ед.взноса с тр.согл.\n"
			+ "Если есть необх.в расч.базы ед.взноса с тр.согл.,\n"
			+ "поставьте <7> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl,vvprk,mvvcslid);
	}
	else
	{
	    fld_f7 = true
	    var nach_lsfi7 = snap[0]
   		var nach_lsnu7 = snap[1]
	}

   
	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='0' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_f0 = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ по ЗП"+"\n"+
             "Если есть необх.в расчете, "+"\n"+
             "поставьте  <0> в 12-ю колонку таблицы вхожд-я полей"
    }else{
      fld_f0 = true
          
  	  var nach_lsfi0 = snap[0]
   	  var nach_lsnu0 = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='k' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_fk = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ по труд.согл."+"\n"+
        "Если есть необх.в расчете, "+"\n"+
        "поставьте букву <k> в 12-ю колонку таблицы вхожд-я полей"
	}else{
		fld_fk = true
     
		var nach_lsfik = snap[0]
		var nach_lsnuk = snap[1]
	}

	strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='h' AND fis_slct=" + sqlTrue;
	snap = getSnap(strSQL);
    fld_fx = false	
	if(null == snap)
	{
		msg = "Hельзя идентиф.поле ЛС: нач.на ЕВ по больн."+"\n"+
        "Если есть необх.в расчете, "+"\n"+
        "поставьте <x> в 12-ю колонку таблицы вхожд-я полей"
	}else{
		fld_fx = true
     
		var nach_lsfi2 = snap[0]
		var nach_lsnu2 = snap[1]
	}

   var gs = getSnap("select Fshpz from SVZPEDV where Fshpz<>'0' and not Fshpz is null")
   if (gs==null){
	   var is_shpz = false;	   
   }else{
	   is_shpz = true;	   
   }   

   DropTable("TEDNV2")
   //создать врем.таблицу
   //вытянуть в строку зарплату для единого взноса
   strSQL = "CREATE TABLE TEDNV2 (Ftabn_id "+SqlType("DOUBLE")+", fcod_kzo "+SqlType("INTEGER")+", fwid "+SqlType("COUNTER")+", fsumzp1 "+SqlType("CURRENCY")+", fcod_kzo1 "+SqlType("INTEGER")+", fproc_ed1 "+SqlType("CURRENCY")
            +", fsumotb "+SqlType("CURRENCY")+", fcod_kzot "+SqlType("INTEGER")+", fproc_edot "+SqlType("CURRENCY")   
            +", fsumbl "+SqlType("CURRENCY")+", fcod_kzb "+SqlType("INTEGER")+", fproc_edb "+SqlType("CURRENCY")
            +", fsumtr "+SqlType("CURRENCY")+", fcod_kzt "+SqlType("INTEGER")+", fproc_edt "+SqlType("CURRENCY")
            +", fsumzpo "+SqlType("CURRENCY")+", fnalzpo "+SqlType("CURRENCY")+", fsumtro "+SqlType("CURRENCY")
            +", fnaltro "+SqlType("CURRENCY")+", fsumblo "+SqlType("CURRENCY")+", fnalblo "+SqlType("CURRENCY")
            +", fmn "+SqlType("DATE")+", fvp "+SqlType("INTEGER")+", foffset "+SqlType("INTEGER")
            +")";
   ExecuteSQL(strSQL);


   //проставляем категорию ЗЛ из штатного расписания 
   ExecuteSQL("UPDATE SVZPEDV set Fcod_kzsht=(select B.Fcod_kzo from ^work_pers as b WHERE SVZPEDV.FTABN_ID=B.FWID_CL "
			+" AND SVZPEDV.FWID_WP=B.FWID)")
   ExecuteSQL("UPDATE SVZPEDV set Fcod_kzsht=0 where Fcod_kzsht is null")
   
   ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=(select B.Fcod_kzo from ^work_pers as b WHERE SVZPEDV.FTABN_ID=B.FWID_CL "
				+" AND SVZPEDV.FWID_WP=B.FWID)")
   ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=0 where Fcod_kzo is null")

   if (fis_36 == false){   
      ExecuteSQL("UPDATE SVZPEDV SET Fkatesv=(SELECT MAX(Fkatesv) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");

      ExecuteSQL("UPDATE SVZPEDV set Fcod_kzo=Fkatesv where Fkatesv<>0 and not Fkatesv is null")

      ExecuteSQL("UPDATE SVZPEDV SET Fis30=(SELECT MAX(Fis30) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");
      ExecuteSQL("DELETE FROM SVZPEDV where Fis30<>'+'")				
      
      ExecuteSQL("UPDATE SVZPEDV SET Fis19=(SELECT MAX(Fis19) FROM ^LIC_FLD AS B "
				+" WHERE SVZPEDV.FLSFID=B.FID)");

      DropTable("TNALESV")
      ExecuteSQL("select * into TNALESV from ^NALOG_ESV where Fbdat<="+sqlTo(mdat)+" and Fedat>="+sqlTo(mdat));

      ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_n) FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");

      ExecuteSQL("UPDATE SVZPEDV SET Ffot=(SELECT Fvidnach FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");
   }else{
	   DropTable("TNALESV")
	   ExecuteSQL("select * into TNALESV from ^NALOG_ESV where Fbdat<="+sqlTo(mdat)+" and Fedat>="+sqlTo(mdat));

	   ExecuteSQL("UPDATE SVZPEDV SET Ffot=(SELECT Fvidnach FROM ^TNALESV AS B "
			+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");

	   ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_n) FROM ^TNALESV AS B "
			+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo)");

	   //остается для трудовых соглашений
	   ExecuteSQL("UPDATE SVZPEDV SET Fis9=(SELECT MAX(Fis9) FROM ^LIC_FLD AS B "
			+" WHERE SVZPEDV.FLSFID=B.FID)");
	   ExecuteSQL("UPDATE SVZPEDV SET Ffot='t' where Fis9='т'")
	   ExecuteSQL("UPDATE SVZPEDV SET Fcod_kzo=(SELECT MAX(Fcod_kzo) FROM ^TNALESV AS B "
					+" WHERE SVZPEDV.Ffot=B.Fvidnach) where SVZPEDV.Ffot='t'");
	   ExecuteSQL("UPDATE SVZPEDV SET Fproc_edv=(SELECT MAX(Fproc_n) FROM ^TNALESV AS B "
			+" WHERE SVZPEDV.Fcod_kzo=B.Fcod_kzo) where SVZPEDV.Ffot='t'");
	
	   //заменить выбор процента из лицевых счетов на выбор категории из справочника шкал единого налога   
	  
	   ExecuteSQL("UPDATE SVZPEDV SET Fis30=(SELECT MAX(Fis30) FROM ^LIC_FLD AS B "
					+" WHERE SVZPEDV.FLSFID=B.FID)");
	   ExecuteSQL("DELETE FROM SVZPEDV where Fis30<>'+'")				

	   ExecuteSQL("UPDATE SVZPEDV SET Fis19=(SELECT MAX(Fis19) FROM ^LIC_FLD AS B "
					+" WHERE SVZPEDV.FLSFID=B.FID)");

	   ExecuteSQL("UPDATE SVZPEDV SET Ffot='b' where Fis19='b' or Fis19='б' or Fis19='f'")

	   ExecuteSQL("UPDATE SVZPEDV SET Fcod_bln=(SELECT MAX(Fcod_bln) FROM ^TNALESV AS B "
					+" WHERE SVZPEDV.FCOD_KZO=B.FCOD_KZO) where SVZPEDV.Ffot='b'");

	   ExecuteSQL("UPDATE SVZPEDV SET Fproc_edb=(SELECT MAX(Fproc_n) FROM ^TNALESV AS B "
				+" WHERE SVZPEDV.Fcod_bln=B.Fcod_kzo) where SVZPEDV.Ffot='b'");
   }
   //проставляем деление зарплаты, больничных и трудовых соглашений на затраты, прибыль и т.д.
   ExecuteSQL("UPDATE SVZPEDV SET Fzatr=(SELECT MAX(Fesv) FROM ^LIC_FLD AS B "
			+" WHERE SVZPEDV.FLSFID=B.FID)");
				
			
   var ssumzp1 = new Array(30)
   var ssumotb = new Array(30)   
   var ssumtr = new Array(30)
   var ssumbl = new Array(30)
   var ssumblpr = new Array(30)   
   var ssumzppr = new Array(30)
   var ssumtrpr = new Array(30)   
   var zppr1 = new Array(30)
   var trpr = new Array(30)
   var blpr = new Array(30)

   var max_offset = 12 

   var offset;
   var mn_vip, mn_voz;

   PSVZP_table = OpenTable("SELECT * FROM SVZPEDV as t "
   							//исключаем тех сотрудников, у которых есть приказ не начислять ЕСВ
   							+" WHERE not exists(SELECT p.Ftabn_id FROM ^prk_all as p inner join ^prk_notcalc as c on p.Fwid=c.Fwid"
								+" WHERE t.Ftabn_id=p.Ftabn_id and c.Fnotnach_esv=" + sqlTrue + " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1) +")"
   							+" ORDER BY FTABN_ID, Fcod_kzsht, Fcod_kzo, Fmn, Fvp, Flsfid");
   PSVZP_table.MoveFirst();
   while(!PSVZP_table.IsEOF()){
 	  var fisadd = true;	   
 	  var sumzp1 = 0;
 	  var sumbl  = 0;
 	  var sumtr  = 0;
 	  var sumotb  = 0; 	  
      var gs = getSnap("select Fwid, Fsumzp1, Fsumbl, Fsumtr, Fsumotb from  TEDNV2 where Ftabn_id="+sqlTo(PSVZP_table.getValue("Ftabn_id"))+" and Fcod_kzo="+sqlTo(PSVZP_table.getValue("Fcod_kzsht"))+" and Fmn="+sqlTo(PSVZP_table.getValue("Fmn"))+" and Fvp="+sqlTo(PSVZP_table.getValue("Fvp")))
      if (gs!=null){
    	  fisadd = false
    	  mFwid  = gs[0] 
     	  sumzp1 = Number(gs[1]);
     	  sumbl  = Number(gs[2]);
     	  sumtr  = Number(gs[3]);
     	  sumotb = Number(gs[4]);     	  
      }      
      
      var m = new Object();      
      m.Ftabn_id = Number(PSVZP_table.getValue("Ftabn_id"))
      //m.Fwid_wp  = Number(PSVZP_table.getValue("Fwid_wp"))
      m.Fcod_kzo  = Number(PSVZP_table.getValue("Fcod_kzsht"))      

      if( PSVZP_table.getValue("Ffot")=="z" ){
    	  m.Fsumzp1   = sumzp1+Number(PSVZP_table.getValue("Fsum"))
          m.Fcod_kzo1 = Number(PSVZP_table.getValue("Fcod_kzo"))
          m.Fproc_ed1 = Number(PSVZP_table.getValue("Fproc_edv"))
      }
      //если поле больничного
      if( PSVZP_table.getValue("Ffot")=="b"){
          m.Fsumbl = sumbl+Number(PSVZP_table.getValue("Fsum"))
          if (fis_36 == false){          
        	  m.Fcod_kzb  = Number(PSVZP_table.getValue("Fcod_kzo"))
        	  m.Fproc_edb = Number(PSVZP_table.getValue("Fproc_edv"))
          }else{	  
        	  m.Fcod_kzb  = Number(PSVZP_table.getValue("Fcod_bln"))          
        	  m.Fproc_edb = Number(PSVZP_table.getValue("Fproc_edb"))
          }  
      }
      if( PSVZP_table.getValue("Ffot")=="t"){
          m.Fsumtr = sumtr+Number(PSVZP_table.getValue("Fsum"))
          m.Fcod_kzt  = Number(PSVZP_table.getValue("Fcod_kzo"))
          m.Fproc_edt = Number(PSVZP_table.getValue("Fproc_edv"))
      }
      
      //если переходный период, то прописываем сумму отпускных будущих с минусом, чтобы
      //потом их не учитывать
      if (dtbotp!=0){
          if( PSVZP_table.getValue("Fis19")=="о" && Number(PSVZP_table.getValue("Fvp"))==1 && Number(PSVZP_table.getValue("Fsum"))<0  && differ(mnbotp,new Date(PSVZP_table.getValue("Fmn")))>=0){
        	  m.Fsumotb = sumotb+Number(PSVZP_table.getValue("Fsum"))
              m.Fcod_kzot  = Number(PSVZP_table.getValue("Fcod_kzo"))
              m.Fproc_edot = Number(PSVZP_table.getValue("Fproc_edv"))
          }
       }      
      
      m.Fmn = new Date(PSVZP_table.getValue("Fmn"))
      m.Fvp = Number(PSVZP_table.getValue("Fvp"))
      
 	  if (fisadd){
 		  UpdateTable("TEDNV2", m, true);
 	  }else{
 		  UpdateTable("TEDNV2", m, false, "Fwid="+sqlTo(mFwid)); 		  
 	  }	  
       
      PSVZP_table.MoveNext();             
   }
   
   PSVZP_table.close();

   ExecuteSQL("DELETE from TEDNV2 where (Fcod_kzo1=0 or (Fproc_ed1=0 or Fproc_ed1 is null)) and (Fcod_kzb=0 or (Fproc_edb=0 or Fproc_edb is null)) and (Fcod_kzt=0 or (Fproc_edt=0 or Fproc_edt is null))")
   if (dtbotp!=0){
      DropTable("TEDNV")
      //ИЗ-ЗА переходного периода оставляем только отпускные с минусом, перебиваем для них дату на текущую,
      //чтобы можно было их отнять от базы и не учитывать при расчете налогов. После перебивки даты нужно сделать
      //суммирование, чтобы на каждый месяц получилась одна строка с ограничением   
      ExecuteSQL("UPDATE TEDNV2 set Fmn="+sqlTo(d00obj)+", Fvp=0, Fsumzp1=0 where Fvp=1 and Fmn<"+sqlTo(mdat)+" and Fsumotb<>0")
      ExecuteSQL("select sum(a.Fsumzp1) as Fsumzp1,sum(a.Fsumotb) as Fsumotb, sum(a.Fsumbl) as Fsumbl,sum(a.Fsumtr) as Fsumtr,"
	        +First("a.Fproc_ed1")+" as Fproc_ed1,"+First("a.Fproc_edt")+" as Fproc_edt,"+First("a.Fproc_edb")+" as Fproc_edb, "
	        +First("a.Fcod_kzo1")+" as Fcod_kzo1,"+First("a.Fcod_kzb")+" as Fcod_kzb,"+First("a.Fcod_kzt")+" as Fcod_kzt, "
	        +" sum(a.Fsumzpo) as Fsumzpo,sum(a.Fnalzpo) as Fnalzpo, sum(a.Fsumtro) as Fsumtro,sum(a.Fnaltro) as Fnaltro,"
	        +" sum(a.Fsumblo) as Fsumblo,sum(a.Fnalblo) as Fnalblo,"+First("a.Foffset")+" as Foffset, "
	        +" a.Ftabn_id, a.Fcod_kzo, a.Fmn, a.Fvp into TEDNV from TEDNV2 as a group by a.Ftabn_id, a.Fcod_kzo, a.Fmn, a.Fvp")
   }else{
     DropTable("TEDNV")
	 ExecuteSQL("select Fsumzp1,Fsumotb, Fsumbl, Fsumtr, Fproc_ed1, Fproc_edt, Fproc_edb, "
	        + " Fcod_kzo1, Fcod_kzb, Fcod_kzt, Fsumzpo, Fnalzpo, Fsumtro, Fnaltro,"
	        +"  Fsumblo, Fnalblo, Foffset, Ftabn_id, Fcod_kzo, Fmn, Fvp into TEDNV from TEDNV2")
   } 
   ExecuteSQL("ALTER TABLE TEDNV ADD Fwid "+SqlType("COUNTER"))   

   PSVZP_table = OpenTable("s","SELECT * FROM TEDNV ORDER BY FTABN_ID, FCOD_KZO, FMN, FVP ");
   if (!PSVZP_table.IsEmpty()){

	   for (var iii=0; iii<30; iii++){
		   ssumzp1[iii]  = 0
	       ssumotb[iii]  = 0		   
		   zppr1[iii]    = 0
		   ssumtr[iii]   = 0
		   trpr[iii]     = 0
		   ssumbl[iii]   = 0
	       ssumblpr[iii]    = 0	
	       ssumzppr[iii] = 0
	       ssumtrpr[iii] = 0       
		   blpr[iii]     = 0
	   }  

   		PSVZP_table.MoveFirst();
   		var pFtabn     = Number(PSVZP_table.getValue("Ftabn_id"))
   		var pFsht_id   = Number(PSVZP_table.getValue("Fcod_kzo"))   		
   		var pFmn       = new Date(PSVZP_table.getValue("Fmn"))
   		var pFvp       = Number(PSVZP_table.getValue("Fvp"))
   		var codkzp = Number(PSVZP_table.getValue("Fcod_kzo1"))
   		var codkbl = Number(PSVZP_table.getValue("Fcod_kzb"))
   		var codktr = Number(PSVZP_table.getValue("Fcod_kzt"))
   		while(!PSVZP_table.IsEOF()){ 
   			while ((!PSVZP_table.IsEOF()) && (Number(PSVZP_table.getValue("Ftabn_id"))==pFtabn) && (Number(PSVZP_table.getValue("Fcod_kzo"))==pFsht_id) && (Number(PSVZP_table.getValue("Fvp"))==pFvp) && differ(new Date(PSVZP_table.getValue("Fmn")),pFmn)==0){   			
   				// * поле Fvp=0 если месяц выплаты и если месяц возникн-я равны месяцу файла
   				//* поле Fvp=1 если месяц выплаты=Fmn, а месяц возникн-я равен месяцу файла
   				// 	* поле Fvp=2 если месяц выплаты равен месяцу файла, а месяц возникн-я=Fmn
   				// * offset = 0 для пpошлых месяцев, 1 для текущего месяца, 2 - для следующего, и т.д.
   				switch (Number(PSVZP_table.getValue("Fvp"))){ 
   					case 0:
   						mn_vip=mdat
   						mn_voz=mdat
   						offset = 1
   						break;
   					case 1:
   						mn_vip=new Date(PSVZP_table.getValue("Fmn"))
   						mn_voz=mdat
   						offset = 0
   						break;
   					case 2:
   						mn_vip=mdat
   						mn_voz=new Date(PSVZP_table.getValue("Fmn"))
   						offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1   //смещение от базового месяца
   			            //если прошлые периоды
   			            if (bln_mes_nach!=0 &&  differ(new Date(PSVZP_table.getValue("Fmn")),mnbotp)<=0){   						
   			               offset  = Math.round(day_difference(mn_vip,mn_voz)/30)   //смещение от базового месяца
   			            } 
   						break;
   				}

   				if (offset > 0){
   					ssumotb[offset] = ssumotb[offset] + Number(PSVZP_table.getValue("Fsumotb"))   					
   					ssumzp1[offset] = ssumzp1[offset] + Number(PSVZP_table.getValue("Fsumzp1"))
   					ssumbl[offset] = ssumbl[offset] + Number(PSVZP_table.getValue("Fsumbl"))
   					ssumtr[offset] = ssumtr[offset] + Number(PSVZP_table.getValue("Fsumtr"))
   					zppr1[offset]   = Number(PSVZP_table.getValue("Fproc_ed1"))/100
   					trpr[offset]    = Number(PSVZP_table.getValue("Fproc_edt"))/100
   					blpr[offset]    = Number(PSVZP_table.getValue("Fproc_edb"))/100
   				}
   				
       			if (bln_mes_nach!=0 &&  offset <0){
         			offp = -offset
         			ssumblpr[offp] = ssumblpr[offp] + Number(PSVZP_table.getValue("Fsumbl"))
         			blpr[offp]     = Number(PSVZP_table.getValue("Fproc_edb"))/100
   					ssumzppr[offp] = ssumzppr[offp] + Number(PSVZP_table.getValue("Fsumzp1"))
   					zppr1[offp]   = Number(PSVZP_table.getValue("Fproc_ed1"))/100   		
   					ssumtrpr[offp] = ssumtr[offp] + Number(PSVZP_table.getValue("Fsumtr"))
   					trpr[offp]    = Number(PSVZP_table.getValue("Fproc_edt"))/100   					
       			}else{
         			offp = offset
       			}
   				
   				PSVZP_table.MoveNext();
   			} 
   	      //в данном случае после добавления Fmn, Fvp  можно убрать цикл и делить сумму по offset. Быстрее будет работать
   	      //добавила Fmn, Fvp, чтобы правильно для всех баз прописывался код категории и процент. Без этого вообще
   	      // нельзя понять, что к чему относится.
   			
   			//ii = 1
   			//while (ii <= max_offset){
 				ii = offp        	 
   				xx = ssumzp1[ii]+ssumtr[ii]+ssumbl[ii]
   				if (xx!=0){
   	             ssumotb[ii] = -(ssumotb[ii])
   	             if (dtbotp!=0){
   	   	       //база для расчета налога в переходный период - отнимаем отпускные
   	            	if (edv1000!=0 && xx>sum_ogr){ 
   	            		var sum_ogrt = sum_ogr  
                   //	если ЗП+отп >огр., то от огр.отнять отп.
   	            		if (ssumzp1[ii]>sum_ogrt){
   	            			ssumzp1[ii]=sum_ogrt-ssumotb[ii]
   	            			if (ssumzp1[ii]<0) ssumzp1[ii]=0   	            			
   	            			ssumtr[ii] =0
   	            			ssumbl[ii] =0
   	            		}else{
   	            			sum_ogrt = sum_ogrt-ssumzp1[ii] 
   	            			ssumzp1[ii]=ssumzp1[ii]-ssumotb[ii]
   	            			if (ssumtr[ii]>sum_ogrt){
   	            				ssumtr[ii]=sum_ogrt
   	            			}
   	            			sum_ogrt = sum_ogrt-ssumtr[ii] 
   	            			if (ssumbl[ii]>sum_ogrt){
   	            				ssumbl[ii]=sum_ogrt
   	            			}
   	            		}	
                   }else{
	            		ssumzp1[ii]=ssumzp1[ii]-ssumotb[ii]
	        			if (ssumzp1[ii]<0) ssumzp1[ii]=0	            		
	            		//больничные и отпускные не меняются
                   }   
  	             }else{  
  	            	 //база для расчета налога без переходного периода
  	            	 //если есть ограничение и общая сумма больше ограничения, то разбиваем
  	            	 //в противном случае суммы остаются такими, как собрали выше. 
    	            if (edv1000!=0 && xx>sum_ogr){  	            	 
    	            	var sum_ogrt = sum_ogr  
    	            	if (ssumzp1[ii]+ssumtr[ii]+ssumbl[ii]>sum_ogrt){
   	                   //	разбить суммы по ограничению
    	            		if (ssumzp1[ii]>sum_ogrt){
    	            			ssumzp1[ii]=sum_ogrt
    	            		}
    	            		sum_ogrt = sum_ogrt-ssumzp1[ii] 
    	            		if (ssumtr[ii]>sum_ogrt){
    	            			ssumtr[ii]=sum_ogrt
    	            		}
    	            		sum_ogrt = sum_ogrt-ssumtr[ii] 
    	            		if (ssumbl[ii]>sum_ogrt){
    	            			ssumbl[ii]=sum_ogrt
    	            		}
    	            	}
    	            }	
   	             }	
   	            //nalzp = round(ssumzp1[ii]*zppr1[ii],2)
   	            //naltr = round(ssumtr[ii]*trpr[ii],2)
   	            //nalbl = round(ssumbl[ii]*blpr[ii],2)

   	            var gs = getSnap("select Fwid from  TEDNV where Ftabn_id="+sqlTo(pFtabn)+" and Fcod_kzo="+sqlTo(pFsht_id)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp))   	            
   	            if (gs==null){
   	            	var ad_tednv = true;   	            	
   	            }else{
   	            	var tedFwid = Number(gs[0]);
   	            	var ad_tednv = false;
   	            }	

				var m = new Object();
				m.Ftabn_id = pFtabn
				m.Fcod_kzo  = pFsht_id               
				m.Fsumzpo = ssumzp1[ii]
				m.Fnalzpo = round(ssumzp1[ii]*zppr1[ii],2)
				m.Fsumtro = ssumtr[ii]
				m.Fnaltro = round(ssumtr[ii]*trpr[ii],2)
				m.Fsumblo = ssumbl[ii]
				m.Fnalblo = round(ssumbl[ii]*blpr[ii],2)
				m.Foffset  = offp
				m.Fmn     = pFmn
				m.Fvp     = pFvp
	            if (ad_tednv == true){				
	            	UpdateTable("TEDNV",m,true);
	            }else{
	            	UpdateTable("TEDNV",m,false,"Fwid="+sqlTo(tedFwid));	            	
	            }	

   					if (round(ssumzp1[ii]*zppr1[ii],2)!=0){ 
   						if (fld_f5==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0               
   							m.Fsum  = ssumzp1[ii]               
   							m.Flsfid = nach_lsfi5
   							m.Ffld_num = nach_lsnu5
   							m.Fshpz = "0";               
   							m.Fproc = zppr1[ii]*100
   							m.Fday  = codkzp
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);
   						}	
         
   						if (fld_f0==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumzp1[ii]*zppr1[ii],2)                   
   							m.Flsfid = nach_lsfi0
   							m.Ffld_num = nach_lsnu0
   							m.Fshpz = "0";                   
   							m.Fproc = zppr1[ii]*100
   							m.Fday  = codkzp
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   						//перенести данные в NXTF
            			if (is_rasch && (pFvp==2 && differ(new Date(PSVZP_table.getValue("Fmn")),mdat)>0) ){   						
   	   						if (fld_f5==true){   							
   	   							var m = new Object();
   	   							m.Ftabn_id = pFtabn
   	   							m.Fwid_wp  = 0                   
   	   							m.Fsum  = ssumzp1[ii]
   	   							m.Flsfid = nach_lsfi5
   	   							m.Ffld_num = nach_lsnu5
   	   							m.Fshpz = "0";
   	   							m.Fmn   = mdat.getVarDate();
   	   							m.Fmn1  = pFmn;                   
   	   							m.Fproc = zppr1[ii]*100
   	   							m.Fday  = codkzp
   	   							m.Fis_day = 3
   	   							m.Fvid_prk = 0
   	   							UpdateTable(snName,m,true);                   
   	   						}		
   	   						if (fld_f0==true){   	   						
   	   							var m = new Object();
   	   							m.Ftabn_id = pFtabn
   	   							m.Fwid_wp  = 0                    
   	   							m.Fsum  = round(ssumzp1[ii]*zppr1[ii],2);
   	   							m.Flsfid = nach_lsfi0
   	   							m.Ffld_num = nach_lsnu0
   	   							m.Fshpz = "0";
   	   							m.Fmn   = mdat.getVarDate();
   	   							m.Fmn1  = pFmn;                   
   	   							m.Fproc = zppr1[ii]*100
   	   							m.Fday  = codkzp
   	   							m.Fis_day = 3
   	   							m.Fvid_prk = 0
   	   							UpdateTable(snName,m,true);                   
   	   						}	
   						} 
   					}

   					if (round(ssumbl[ii]*blpr[ii],2)!=0){ 
	   					if (fld_f6==true){   						
	   						var m = new Object();
	   						m.Ftabn_id = pFtabn
	   						m.Fwid_wp  = 0               
	   						m.Fsum  = ssumbl[ii]
	   						m.Flsfid = nach_lsfi6
	   						m.Ffld_num = nach_lsnu6
   							m.Fproc = blpr[ii]*100
   							m.Fday  = codkbl
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
	   						UpdateTable(sfName,m,true);               
	   					}	
   						if (fld_fx==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumbl[ii]*blpr[ii],2)                   
   							m.Flsfid = nach_lsfi2
   							m.Ffld_num = nach_lsnu2
   							m.Fproc = blpr[ii]*100
   							m.Fday  = codkbl
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   						//перенести данные в NXTF
            			if (is_rasch && (pFvp==2 && differ(new Date(PSVZP_table.getValue("Fmn")),mdat)>0) ){   						
   		   					if (fld_f6==true){   							
   		   						var m = new Object();
   		   						m.Ftabn_id = pFtabn
   		   						m.Fwid_wp  = 0                   
   		   						m.Fsum  = ssumbl[ii]
   		   						m.Flsfid = nach_lsfi6
   		   						m.Ffld_num = nach_lsnu6
   		   						m.Fshpz = "0";
   		   						m.Fmn   = mdat.getVarDate();
   		   						m.Fmn1  = pFmn;                   
   		   						m.Fproc = blpr[ii]*100
   		   						m.Fday  = codkbl
   		   						m.Fis_day = 3
   		   						m.Fvid_prk = 0
   		   						UpdateTable(snName,m,true);                   
   		   					}	
   	   						if (fld_fx==true){   		   					
   	   							var m = new Object();
   	   							m.Ftabn_id = pFtabn
   	   							m.Fwid_wp  = 0                   
   	   							m.Fsum  = round(ssumbl[ii]*blpr[ii],2)
   	   							m.Flsfid = nach_lsfi2
   	   							m.Ffld_num = nach_lsnu2
   	   							m.Fshpz = "0";
   	   							m.Fmn   = mdat.getVarDate();
   	   							m.Fmn1  = pFmn;                   
   	   							m.Fproc = blpr[ii]*100
   	   							m.Fday  = codkbl
   	   							m.Fis_day = 3
   	   							m.Fvid_prk = 0
   	   							UpdateTable(snName,m,true);
   	   						}	
   						} 
   					}

   					if (round(ssumtr[ii]*trpr[ii],2)!=0){ 
	   					if (fld_f7==true){   						
	   						var m = new Object();
	   						m.Ftabn_id = pFtabn
	   						m.Fwid_wp  = 0               
	   						m.Fsum  = ssumtr[ii]
	   						m.Flsfid = nach_lsfi7
	   						m.Ffld_num = nach_lsnu7
	   						m.Fproc = trpr[ii]*100
	   						m.Fday  = codktr
	   						m.Fmn = pFmn
	   						m.Fvp = pFvp
	   						m.Fis_day = 3
	   						m.Fvid_prk = vvprk
	   						m.Favt = true;
	   						UpdateTable(sfName,m,true);               
	   					}	
   						if (fld_fk==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumtr[ii]*trpr[ii],2)
   							m.Flsfid = nach_lsfik
   							m.Ffld_num = nach_lsnuk
   							m.Fproc = trpr[ii]*100
   							m.Fday  = codktr
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   						//перенести данные в NXTF
            			if (is_rasch && (pFvp==2 && differ(new Date(PSVZP_table.getValue("Fmn")),mdat)>0) ){   						
   		   					if (fld_f7==true){   							
   		   						var m = new Object();
   		   						m.Ftabn_id = pFtabn
   		   						m.Fwid_wp  = 0                   
   		   						m.Fsum  = ssumtr[ii]
   		   						m.Flsfid = nach_lsfi7
   		   						m.Ffld_num = nach_lsnu7
   		   						m.Fshpz = "0";
   		   						m.Fmn   = mdat.getVarDate();
   		   						m.Fmn1  = pFmn;                   
   		   						m.Fproc = trpr[ii]*100
   		   						m.Fday  = codktr
   		   						m.Fis_day = 3
   		   						m.Fvid_prk = 0
   		   						UpdateTable(snName,m,true);                   
   		   					}	
   	   						if (fld_fk==true){   		   					
   	   							var m = new Object();
   	   							m.Ftabn_id = pFtabn
   	   							m.Fwid_wp  = 0                   
   	   							m.Fsum  = round(ssumtr[ii]*trpr[ii],2)
   	   							m.Flsfid = nach_lsfik
   	   							m.Ffld_num = nach_lsnuk
   	   							m.Fshpz = "0";
   	   							m.Fmn   = mdat.getVarDate();
   	   							m.Fmn1  = pFmn;                   
   	   							m.Fproc = trpr[ii]*100
   	   							m.Fday  = codktr
   	   							m.Fis_day = 3
   	   							m.Fvid_prk = 0
   	   							UpdateTable(snName,m,true);
   	   						}	
   						} 
   					}
   				}
 				
   				xxpr = ssumzppr[ii]+ssumtrpr[ii]+ssumblpr[ii]
   				if (xxpr!=0){
					var gs = getSnap("select Fwid from  TEDNV where Ftabn_id="+sqlTo(pFtabn)+" and Fcod_kzo="+sqlTo(pFsht_id)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp))   	            
					if (gs==null){
						var ad_tednv = true;   	            	
					}else{
						var tedFwid = Number(gs[0]);
						var ad_tednv = false;
					}	

					var m = new Object();
					m.Ftabn_id = pFtabn
					m.Fcod_kzo  = pFsht_id
					m.Fsumzpo = ssumzppr[ii]
					m.Fnalzpo = round(ssumzppr[ii]*zppr1[ii],2)
					m.Fsumtro = ssumtrpr[ii]
					m.Fnaltro = round(ssumtrpr[ii]*trpr[ii],2)
					m.Fsumblo = ssumblpr[ii]
					m.Fnalblo = round(ssumblpr[ii]*blpr[ii],2)
					m.Foffset  = offp
					m.Fmn     = pFmn
					m.Fvp     = pFvp
	            	if (ad_tednv == true){				
		            	UpdateTable("TEDNV",m,true);
	            	}else{
	            		UpdateTable("TEDNV",m,false,"Fwid="+sqlTo(tedFwid));	            	
	            	}	
   					
   					//база налога по больн прошл.     				
   					if (round(ssumblpr[ii]*blpr[ii],2)!=0){
   						//nalbl = round(ssumblpr[ii]*blpr[ii],2)
   						if (fld_f6==true){   						
	   						var m = new Object();
	   						m.Ftabn_id = pFtabn
	   						m.Fwid_wp  = 0               
	   						m.Fsum  = ssumblpr[ii]
	   						m.Flsfid = nach_lsfi6
	   						m.Ffld_num = nach_lsnu6
   							m.Fproc = blpr[ii]*100
   							m.Fday  = codkbl
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
	   						UpdateTable(sfName,m,true);               
   						}	
   						if (fld_fx==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumblpr[ii]*blpr[ii],2)                   
   							m.Flsfid = nach_lsfi2
   							m.Ffld_num = nach_lsnu2
   							m.Fproc = blpr[ii]*100
   							m.Fday  = codkbl
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   					}
   					
   					if (round(ssumzppr[ii]*zppr1[ii],2)!=0){ 
   						if (fld_f5==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0               
   							m.Fsum  = ssumzppr[ii]               
   							m.Flsfid = nach_lsfi5
   							m.Ffld_num = nach_lsnu5
   							m.Fshpz = "0";               
   							m.Fproc = zppr1[ii]*100
   							m.Fday  = codkzp
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);
   						}	
         
   						if (fld_f0==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumzppr[ii]*zppr1[ii],2)                   
   							m.Flsfid = nach_lsfi0
   							m.Ffld_num = nach_lsnu0
   							m.Fshpz = "0";                   
   							m.Fproc = zppr1[ii]*100
   							m.Fday  = codkzp
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   					}
   					if (round(ssumtrpr[ii]*trpr[ii],2)!=0){ 
	   					if (fld_f7==true){   						
	   						var m = new Object();
	   						m.Ftabn_id = pFtabn
	   						m.Fwid_wp  = 0               
	   						m.Fsum  = ssumtrpr[ii]
	   						m.Flsfid = nach_lsfi7
	   						m.Ffld_num = nach_lsnu7
	   						m.Fproc = trpr[ii]*100
	   						m.Fday  = codktr
	   						m.Fmn = pFmn
	   						m.Fvp = pFvp
	   						m.Fis_day = 3
	   						m.Fvid_prk = vvprk
	   						m.Favt = true;
	   						UpdateTable(sfName,m,true);               
	   					}	
   						if (fld_fk==true){
   							var m = new Object();
   							m.Ftabn_id = pFtabn
   							m.Fwid_wp  = 0                   
   							m.Fsum  = round(ssumtrpr[ii]*trpr[ii],2)
   							m.Flsfid = nach_lsfik
   							m.Ffld_num = nach_lsnuk
   							m.Fproc = trpr[ii]*100
   							m.Fday  = codktr
   							m.Fmn = pFmn
   							m.Fvp = pFvp
   							m.Fis_day = 3
   							m.Fvid_prk = vvprk
   							m.Favt = true;
   							UpdateTable(sfName,m,true);               
   						}
   					}
   				}
   				//ii = ii + 1
   			//} // end of   while (ii <= max_offset) 
     
   			for (var iii=0; iii<30; iii++){
   				ssumotb[iii]  = 0   				
   				ssumzp1[iii]    = 0
   				ssumtr[iii]    = 0
   				ssumbl[iii]    = 0
         		ssumblpr[iii]  = 0
     	        ssumzppr[iii] = 0
    	        ssumtrpr[iii] = 0       
   				zppr1[iii]    = 0
   				trpr[iii]    = 0
   				blpr[iii]    = 0
   			}  

   			if (!PSVZP_table.IsEOF()){
   				pFtabn     = Number(PSVZP_table.getValue("Ftabn_id"))
   				pFsht_id   = Number(PSVZP_table.getValue("Fcod_kzo"))   				
   				pFmn       = new Date(PSVZP_table.getValue("Fmn"))
   				pFvp       = Number(PSVZP_table.getValue("Fvp"))
   				codkzp = Number(PSVZP_table.getValue("Fcod_kzo1"))
   				codkbl = Number(PSVZP_table.getValue("Fcod_kzb"))
   				codktr = Number(PSVZP_table.getValue("Fcod_kzt"))
   			}
   		}
   }				
   PSVZP_table.close();

   //для переходного периода для отпускных с минусом ставим текущий месяц
   if (dtbotp!=0){
	      ExecuteSQL("UPDATE SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fsum<0 and Fvp=1 and Fmn<"+sqlTo(mdat))
   } 

   //разделим суммы на затраты, прибыль и т.д.
   DropTable("ZPEDVD") 
   strSQL = "select sum(a.Fsum) as Fsum, sum(a.Fsum) as Fsumuch, sum(a.Fsum) as Fsumnal, "+First("a.Fpr")+" as Fpr, Ftabn_id, Fcod_kzsht, Fzatr, Fmn, Fvp, Ffot into ZPEDVD from SVZPEDV as a where a.Fzatr<>' ' group by a.Ftabn_id, a.Fcod_kzsht, a.Fmn, a.Fvp, a.Fzatr, a.ffot"
   ExecuteSQL(strSQL);
   ExecuteSQL("ALTER TABLE ZPEDVD ADD Fwid "+SqlType("COUNTER"))    

   //разделим суммы на затраты, прибыль и т.д. еще и на ШПЗ
   DropTable("ZPEDVSHPZ") 
   strSQL = "select sum(a.Fsum) as Fsum, sum(a.Fsum) as Fsumuch, sum(a.Fsum) as Fsumnal, "+First("a.Fpr")+" as Fpr, Ftabn_id, Fcod_kzsht, Fzatr, Fmn, Fvp, Fshpz, Ffot into ZPEDVSHPZ from SVZPEDV as a where a.Fzatr<>' ' group by a.Ftabn_id, a.Fcod_kzsht, a.Fmn, a.Fvp, a.Fzatr, a.Fshpz, a.Ffot"
   ExecuteSQL(strSQL);
   ExecuteSQL("ALTER TABLE ZPEDVSHPZ ADD Fwid "+SqlType("COUNTER"))   
				
  
   
//нашли сумму налога. Теперь нужно разбивать по затратам и по ШПЗ
//так как при начислении налога при превышении ограничения нужно брать сначала ЗП, потом трудовые соглашения,
//потом больничные, то на некоторые виды начислений с учетом ограничения налог может не взяться. Если делать
//разбивку по затратам, компенсации и т.д., то тогда будет неправильная пропорция. Поэтому, если какой нибудь из видов
//(ЗП, тр.согл., больн.), не вошел в ограничение, то и при делении не будем их учитывать.
// поэтому обнуляем для соотв.вида(ЗП, тр.согл., больн.) с разбивкой по видам затрат суммы в пределах записи ШР
//проставить 0 для тех начислений которые не вошли в расчет налога чтобы потом по ним не делать разбивку
  sh_table = OpenTable("s","select * from ZPEDVD where Fzatr<>' 'and Fsum<>0 order by Ftabn_id, Fcod_kzsht, Fmn, Fvp, Fzatr, Ffot");
  if (!sh_table.IsEmpty()){
   var pFtabn     = Number(sh_table.getValue("Ftabn_id"))
   var pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
   var pFmn       = new Date(sh_table.getValue("Fmn"))
   var pFvp       = Number(sh_table.getValue("Fvp"))
   var pFfot      = sh_table.getValue("Ffot")
   var pFwid      = sh_table.getValue("Fwid")   
   sh_table.MoveFirst();
   while(!sh_table.IsEOF()){ 
      //нашли ограничение по ФОТ
      sumzpo = 0
      nalzpo = 0
      
      var ed = getSnap("select Fsumzpo,Fnalzpo,Fsumblo,Fnalblo,Fsumtro,Fnaltro,Fcod_kzo1 from TEDNV where Ftabn_id="+sqlTo(pFtabn)+" and Fcod_kzo="+sqlTo(pFsht_id)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp))
      if (ed!=null){
         //сумма ограничения
         if (sh_table.getValue("Ffot")=="z"){
            sumzpo = Number(ed[0])
            nalzpo = Number(ed[1])
         }
         if (sh_table.getValue("Ffot")=="b"){ 
            sumzpo = Number(ed[2])
            nalzpo = Number(ed[3])
         } 
         if (sh_table.getValue("Ffot")=="t"){ 
            sumzpo = Number(ed[4])
            nalzpo = Number(ed[5])
         }
         kodzo  = Number(ed[6])
      }

      if ((sh_table.getValue("Fzatr")=="+" || sh_table.getValue("Fzatr")=="*")){
         sumkomph = 0;
         sumost = 0;
         var ed2 = getSnap("select sum(a.Fsum) as Fsum  from ZPEDVD as a where a.Ftabn_id="+sqlTo(pFtabn)+" and a.Fcod_kzsht="+sqlTo(pFsht_id)+" and a.Fmn="+sqlTo(pFmn)+" and a.Fvp="+sqlTo(pFvp)+" and a.Ffot="+sqlTo(pFfot)+" and (a.Fzatr="+sqlTo("#")+" or a.Fzatr="+sqlTo("&")+")")
         if (ed2!=null){
            sumkomph = Number(ed2[0])
            sumost  = (sumkomph<sumzpo)?sumzpo-sumkomph:0;
         }else{
            sumost  = sumzpo;
         }

         var sumprib = 0
         var sumzat  = 0

         var ed2 = getSnap("select sum(a.Fsum) as Fsum  from ZPEDVD as a where a.Ftabn_id="+sqlTo(pFtabn)+" and a.Fcod_kzsht="+sqlTo(pFsht_id)+" and a.Fmn="+sqlTo(pFmn)+" and a.Fvp="+sqlTo(pFvp)+" and a.Ffot="+sqlTo(pFfot)+" and a.Fzatr="+sqlTo("*") )
         if (ed2!=null){         
            sumprib = Number(ed2[0])
         }

         var ed2 = getSnap("select sum(a.Fsum) as Fsum  from ZPEDVD as a where a.Ftabn_id="+sqlTo(pFtabn)+" and a.Fcod_kzsht="+sqlTo(pFsht_id)+" and a.Fmn="+sqlTo(pFmn)+" and a.Fvp="+sqlTo(pFvp)+" and a.Ffot="+sqlTo(pFfot)+" and a.Fzatr="+sqlTo("+") )
         if (ed2!=null){         
            sumzat = Number(ed2[0])
         }
         
         m = new Object();
         if(sumzat+sumprib==0)
         	m.Fpr = 0;
         else
         	m.Fpr = round((sumost*Number(sh_table.getValue("Fsum"))/(sumzat+sumprib)),2);
         if (sumzpo!=0){      
    	  	m.Fsumnal = round((nalzpo*m.Fpr/sumzpo),2);
      	 }else{	
        	m.Fsumnal = 0;
      	 }  
         UpdateTable("ZPEDVD",m,false, "Fwid="+sqlTo(pFwid));
         
	     if (is_shpz ==false){
	        cFshpzp  = "0"
    	    cFshpzpp = "0"
         	if (m.Fsumnal!=0 && sh_table.getValue("Fzatr")=="+"){
         		if (fld_f3==true){         		
         			var n = new Object();
         			n.Ftabn_id = pFtabn
         			n.Fwid_wp  = 0
         			n.Fsum  = m.Fsumnal                   
         			n.Flsfid = nach_lsfi3
         			n.Ffld_num = nach_lsnu3
         			n.Fshpz = cFshpzp                   
         			n.Fproc = 0
         			n.Fmn = pFmn.getVarDate()
         			n.Fvp = pFvp
         			n.Fis_day = 0
         			n.Fvid_prk = 0
         			n.Favt = true;
         			n.Fpr = 0                   
         			UpdateTable(sfName,n,true);               
         		}           
               if (is_rasch && (pFvp==2 && differ(pFmn,mdat)>0) ){         		
	         		if (fld_f3==true){		    	   
	         			var n = new Object();
	         			n.Ftabn_id = pFtabn
	         			n.Fwid_wp  = 0                   
	         			n.Fsum  = m.Fsumnal
	         			n.Flsfid = nach_lsfi3
	         			n.Ffld_num = nach_lsnu3
	         			n.Fshpz = cFshpzp;
	         			n.Fmn   = mdat.getVarDate();
	         			n.Fmn1  = pFmn.getVarDate();                   
	         			n.Fproc = 0
	         			n.Fday  = 0
	         			n.Fis_day = 0
	         			n.Fvid_prk = 0
	         			UpdateTable(snName,n,true);
	         		}	
    	       }                      
            } 

         	if (m.Fsumnal!=0 && sh_table.getValue("Fzatr")=="*"){
         		if (fld_f4==true){         		
                   var n = new Object();
                   n.Ftabn_id = pFtabn
                   n.Fwid_wp  = 0                   
                   n.Fsum  = m.Fsumnal                   
                   n.Flsfid = nach_lsfi4
                   n.Ffld_num = nach_lsnu4
                   n.Fshpz = cFshpzpp                   
                   n.Fproc = 0
                   n.Fmn = pFmn.getVarDate()
                   n.Fvp = pFvp
                   n.Fis_day = 0
                   n.Fvid_prk = 0
                   n.Favt = true;
                   n.Fpr = 0                   
                   UpdateTable(sfName,n,true);               
         		}           
                if (is_rasch && (pFvp==2 && differ(pFmn,mdat)>0) ){         		
	         		if (fld_f4==true){		        	
	                   var n = new Object();
    	               n.Ftabn_id = pFtabn
        	           n.Fwid_wp  = 0                   
            	       n.Fsum  = m.Fsumnal
                	   n.Flsfid = nach_lsfi4
                   	   n.Ffld_num = nach_lsnu4
	                   n.Fshpz = cFshpzpp;
    	               n.Fmn   = mdat.getVarDate();
        	           n.Fmn1  = pFmn.getVarDate();                   
            	       n.Fproc = 0
                	   n.Fday  = 0
                   	   n.Fis_day = 0
	                   n.Fvid_prk = 0
    	               UpdateTable(snName,n,true);
    	            }
		        }	
			}
         } 
                            
      }

      if (sh_table.getValue("Fzatr")=="#"){
      //комп по таб ном без огран
         sumkomph = 0;
         sumost = 0;
         var ed2 = getSnap("select sum(a.Fsum) as Fsum  from ZPEDVD as a where a.Ftabn_id="+sqlTo(pFtabn)+" and a.Fcod_kzsht="+sqlTo(pFsht_id)+" and a.Fmn="+sqlTo(pFmn)+" and a.Fvp="+sqlTo(pFvp)+" and a.Ffot="+sqlTo(pFfot)+" and a.Fzatr="+sqlTo("&"))
         if (ed2!=null){         
            sumkomph = Number(ed2[0])
            sumostp  = (sumkomph<sumzpo)?sumzpo-sumkomph:0;
            sumost   = (Number(sh_table.getValue("Fsum"))<sumostp)?Number(sh_table.getValue("Fsum")):sumostp;
         }else{
            sumost  = (Number(sh_table.getValue("Fsum"))<sumzpo)?Number(sh_table.getVAlue("Fsum")):sumzpo;
         }

         var m = new Object();
         m.Fpr = round(sumost,2);
         if (sumzpo!=0){      
    	  	m.Fsumnal = round((nalzpo*m.Fpr/sumzpo),2);
      	 }else{	
        	m.Fsumnal = 0;
      	 }  
         UpdateTable("ZPEDVD",m,false, "Fwid="+sqlTo(pFwid));

	     if (is_shpz ==false && m.Fsumnal!=0){
         	 cFshpzpk = "0"
	         if (fld_f8==true){
	        	 var n = new Object();
	        	 n.Ftabn_id = pFtabn
	        	 n.Fwid_wp  = 0                   
	        	 n.Fsum  = m.Fsumnal                   
	        	 n.Flsfid = nach_lsfi8
	        	 n.Ffld_num = nach_lsnu8
	        	 n.Fshpz = cFshpzpk                   
	        	 n.Fproc = 0
	        	 n.Fmn = pFmn.getVarDate()
	        	 n.Fvp = pFvp
	        	 n.Fis_day = 0
	        	 n.Fvid_prk = 0
	        	 n.Favt = true;
	        	 n.Fpr = 0                   
	        	 UpdateTable(sfName,n,true);               
	         }    
	         if (is_rasch && (pFvp==2 && differ(pFmn,mdat)>0) ){
		    	 if (fld_f8==true){		    	 
		    		 var n = new Object();
		    		 n.Ftabn_id = pFtabn
		    		 n.Fwid_wp  = 0                   
		    		 n.Fsum  = m.Fsumnal
		    		 n.Flsfid = nach_lsfi8
		    		 n.Ffld_num = nach_lsnu8
		    		 n.Fshpz = cFshpzpk;
		    		 n.Fmn   = mdat.getVarDate();
		    		 n.Fmn1  = pFmn.getVarDate();                   
		    		 n.Fproc = 0
		    		 n.Fday  = 0
		    		 n.Fis_day = 0
		    		 n.Fvid_prk = 0
		    		 UpdateTable(snName,n,true);
		    	 }	 
    	     }                      
         } 
      }
      //ПЕРВЫМ ОТНИМАЕМ ЧЕРНОБ
      if (sh_table.getValue("Fzatr")=="&"){
         sumkomp = Number(sh_table.getValue("Fsum"))
         sumost  = (sumkomp<sumzpo)?sumzpo-sumkomp:0;
         sumkomp = sumzpo-sumost
         
         var m = new Object();
         m.Fpr = round(sumkomp,2);
         if (sumzpo!=0){      
    	  	m.Fsumnal = round((nalzpo*m.Fpr/sumzpo),2);
      	 }else{	
        	m.Fsumnal = 0;
      	 }  
         UpdateTable("ZPEDVD",m,false, "Fwid="+sqlTo(pFwid));

	     if (is_shpz ==false && m.Fsumnal!=0){
	    	cFshpzpl = "0"
		    if (fld_f9==true){	    		 
		    	var n = new Object();
		    	n.Ftabn_id = pFtabn
		    	n.Fwid_wp  = 0                   
		    	n.Fsum  = m.Fsumnal                   
		    	n.Flsfid = nach_lsfi9
		    	n.Ffld_num = nach_lsnu9
		    	n.Fshpz = cFshpzpl                   
		    	n.Fproc = 0
		    	n.Fmn = pFmn.getVarDate()
		    	n.Fvp = pFvp
		    	n.Fis_day = 0
		    	n.Fvid_prk = 0
		    	n.Favt = true;
		    	n.Fpr = 0                   
		    	UpdateTable(sfName,n,true);               
		    }
		     if (is_rasch && (pFvp==2 && differ(pFmn,mdat)>0) ){
				 if (fld_f9==true){		    	 
					 var n = new Object();
					 n.Ftabn_id = pFtabn
					 n.Fwid_wp  = 0                  
					 n.Fsum  = m.Fsumnal
					 n.Flsfid = nach_lsfi9
					 n.Ffld_num = nach_lsnu9
					 n.Fshpz = cFshpzpl;
					 n.Fmn   = mdat.getVarDate();
					 n.Fmn1  = pFmn.getVarDate();                   
					 n.Fproc = 0
					 n.Fday  = 0
					 n.Fis_day = 0
					 n.Fvid_prk = 0
					 UpdateTable(snName,n,true);
				 }
    	      }                      
    	  }
      }

      sh_table.MoveNext();

      if (!sh_table.IsEOF()){
    	   pFtabn     = Number(sh_table.getValue("Ftabn_id"))
    	   pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
    	   pFmn       = new Date(sh_table.getValue("Fmn"))
    	   pFvp       = Number(sh_table.getValue("Fvp"))
    	   pFfot      = sh_table.getValue("Ffot")
   		   pFwid      = sh_table.getValue("Fwid")    	   
      }
   }
  }
  sh_table.close();

//непосредственно деление затрат по ШПЗ. В рамках тех сумм, которые учиываются (поле Fsumuch) делим сумму ограничения
// и налога. 
 if (is_shpz == true){
   sh_table = OpenTable("s","select * from ZPEDVSHPZ where Fzatr<>' ' and Fsum<>0 order by Ftabn_id, Fcod_kzsht, Fmn, Fvp, Fzatr, Ffot, Fshpz");
   if (!sh_table.IsEmpty()){
	   sh_table.MoveFirst();
	   var pFtabn     = Number(sh_table.getValue("Ftabn_id"))
	   var pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
	   var pFmn       = new Date(sh_table.getValue("Fmn"))
	   var pFvp       = Number(sh_table.getValue("Fvp"))
	   var pFfot      = sh_table.getValue("Ffot")
	   var pFwid      = sh_table.getValue("Fwid")   
	   while(!sh_table.IsEOF()){ 
		   sumzpo  = 0;
		   sumzp   = 0;
		   nalzpo  = 0;
		   var ed = getSnap("select sum(a.Fpr) as Fpr, sum(a.Fsum) as Fsumuch, sum(a.Fsumnal) as Fsumnal, Ftabn_id, Fcod_kzsht, Fmn, Fvp, Fzatr, Ffot from ZPEDVD as a where a.Ftabn_id="+sqlTo(pFtabn)+" and a.Fcod_kzsht="+sqlTo(pFsht_id)+" and a.Fmn="+sqlTo(pFmn)+" and a.Fvp="+sqlTo(pFvp)+" and a.Ffot="+sqlTo(pFfot)+" and a.Fzatr="+sqlTo(sh_table.getValue("Fzatr"))+" group by a.Ftabn_id,a.Fcod_kzsht, a.Fmn, a.Fvp,a.Fzatr, a.Ffot")
		   if (ed!=null){
			   //сумма ограничения
			   sumzpo  = Number(ed[0])
			   //сумма без ограничения
			   sumzp   = Number(ed[1])
			   nalzpo  = Number(ed[2])
		   }

		   var m = new Object();
		   if (sumzp!=0){      
			   m.Fpr = round((Number(sh_table.getValue("Fsum"))/sumzp)*sumzpo,2);
		   }else{
			   m.Fpr = 0;  
		   }	
		   if (sumzpo!=0){      
			   m.Fsumnal = round((nalzpo*m.Fpr/sumzpo),2);
		   }else{	
			   m.Fsumnal = 0;
		   }  
		   UpdateTable("ZPEDVSHPZ",m,false, "Fwid="+sqlTo(pFwid));
      
		   sh_table.MoveNext();

		   if (!sh_table.IsEOF()){
			   pFtabn     = Number(sh_table.getValue("Ftabn_id"))
			   pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
			   pFmn       = new Date(sh_table.getValue("Fmn"))
			   pFvp       = Number(sh_table.getValue("Fvp"))
			   pFfot      = sh_table.getValue("Ffot")
			   pFwid      = sh_table.getValue("Fwid")   
		   }
	   }
   }
   sh_table.close();

//убираем ошибки округления при делении по ШПЗ

   DropTable("TTT");
   strSQL = "select sum(a.Fsumnal) as Fsum, a.Ftabn_id, a.Fcod_kzsht, a.Fmn, a.Fvp into TTT from ZPEDVSHPZ as a where a.Fzatr<>' ' and Fsum<>0 group by Ftabn_id, Fcod_kzsht, a.Fmn, a.Fvp"
   ExecuteSQL(strSQL);

   DropTable("TTT2");
   strSQL = "select sum(a.Fsumnal) as Fsum, a.Ftabn_id, a.Fcod_kzsht, a.Fmn, a.Fvp into TTT2 from ZPEDVD as a where a.Fzatr<>' ' and Fsum<>0 group by Ftabn_id, Fcod_kzsht, a.Fmn, a.Fvp"
   ExecuteSQL(strSQL);

   DropTable("TTT3");
   strSQL = "select a.Ftabn_id, a.Fcod_kzsht, a.Fmn, a.Fvp, a.Fsum as Fsum1, b.Fsum as Fsum2 into TTT3 from TTT as a, TTT2 as b where a.Ftabn_id=b.Ftabn_id and a.Fcod_kzsht=b.Fcod_kzsht and a.Fmn=b.Fmn and a.Fvp=b.Fvp and a.Fsum<>b.Fsum"
   ExecuteSQL(strSQL);

   sh_table = OpenTable("s","select distinct Ftabn_id, Fcod_kzsht, Fmn, Fvp  from ZPEDVSHPZ where Fzatr<>' ' and Fsum<>0 order by Ftabn_id, Fcod_kzsht, Fmn, Fvp");
   if (!sh_table.IsEmpty()){
	   sh_table.MoveFirst();
	   var pFtabn     = Number(sh_table.getValue("Ftabn_id"))
	   var pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
	   var pFmn       = new Date(sh_table.getValue("Fmn"))
	   var pFvp       = Number(sh_table.getValue("Fvp"))
	   var pFfot      = sh_table.getValue("Ffot")
	   var pFwid      = sh_table.getValue("Fwid")   
	   while(!sh_table.IsEOF()){ 
		   sumokr = 0;
		   var ed = getSnap("select Fsum1,Fsum2 from TTT3 where Ftabn_id="+sqlTo(pFtabn)+" and Fcod_kzsht="+sqlTo(pFsht_id)+" and Fmn="+sqlTo(pFmn)+" and Fvp="+sqlTo(pFvp))
		   var sm1 = 0
		   var sm2 = 0
		   if (ed!=null){
			   sm1 = (Number(ed[0])==null)?0:Number(ed[0])
			   sm2 = (Number(ed[1])==null)?0:Number(ed[1])					   
			   //сумма ошибка округления
			   sumokr  = sm2-sm1
		   }

		   if (sumokr!=0){ 
			   ExecuteSQL("update ZPEDVSHPZ set Fsumnal=Fsumnal + "+sqlTo(sumokr)+" where Fwid="+sqlTo(pFwid))			   
		   }
		   
		   sh_table.MoveNext();

		   if (!sh_table.IsEOF()){
	    	   pFtabn     = Number(sh_table.getValue("Ftabn"))
	    	   pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
	    	   pFmn       = new Date(sh_table.getValue("Fmn"))
	    	   pFvp       = Number(sh_table.getValue("Fvp"))
	    	   pFfot      = sh_table.getValue("Ffot")
	    	   pFwid      = sh_table.getValue("Fwid")   
		   }
	   }
   }
   sh_table.close();
   
//прописываем ШПЗ и переносим разбивку по ШПЗ в окончательный файл
   sh_table = OpenTable("s","select * from ZPEDVSHPZ where Fzatr<>' ' and Fsum<>0 order by Ftabn_id, Fcod_kzsht, Fmn, Fvp, Fzatr, Fshpz");
   if (!sh_table.IsEmpty()){
	   sh_table.MoveFirst();
	   var pFtabn     = Number(sh_table.getValue("Ftabn_id"))
	   var pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
	   while(!sh_table.IsEOF()){ 
		   //шифр для EB
	         strSQL = "select FAN from ^LIC_FLD where Fid="+sqlTo(nach_lsfi3);
	         var licpSnap = getSnap(strSQL);
	         zatp = "0";
	         if (licpSnap != null)
	         {
	            zatp = licpSnap[0];
	            if (zatp==null)  zatp = "0";            
	         }
	         cFshpzp = sh_table.getValue("Fshpz");
	         if (zatp!="0")
	         {
	            cFshpzp = allt(sh_table.getValue("Fshpz"))
	            //*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
				switch(getPar("PRK_SHPZ"))
				{
					case 1:
						cFshpzp = cFshpzp+allt(zatp)
					break;
					case 0:
					default:
						cFshpzp = allt(String(cFshpzp)).substring(0, allt(String(cFshpzp)).length - 1) + allt(String(zatp));
					break;
				}
	         }

	         strSQL = "select FAN from ^LIC_FLD where Fid="+sqlTo(nach_lsfi4);
	         var licpSnap = getSnap(strSQL);
	         zatpp = "0";
	         if (licpSnap != null)
	         {
	            zatpp = licpSnap[0];
	            if (zatpp==null)  zatpp = "0";            
	         }
	         cFshpzpp = sh_table.getValue("Fshpz");
	         if (zatpp!="0")
	         {
	            cFshpzpp = allt(sh_table.getValue("Fshpz"))
	            //*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
				switch(getPar("PRK_SHPZ"))
				{
					case 1:
						cFshpzpp = cFshpzpp+allt(zatpp);
					break;
					case 0:
					default:
						cFshpzpp = allt(String(cFshpzpp)).substring(0, allt(String(cFshpzpp)).length - 1) + allt(String(zatpp));
					break;
				}
	         }

	         strSQL = "select FAN from ^LIC_FLD where Fid="+sqlTo(nach_lsfi8);
	         var licpSnap = getSnap(strSQL);
	         zatpk = "0";
	         if (licpSnap != null)
	         {
	            zatpk = licpSnap[0];
	            if (zatpk==null)  zatpk = "0";            
	         }
	         cFshpzpk = sh_table.getValue("Fshpz");
	         if (zatpk!="0")
	         {
	            cFshpzpk = allt(sh_table.getValue("Fshpz"))
	            //*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
				switch(getPar("PRK_SHPZ"))
				{
					case 1:
						cFshpzpk = cFshpzpk+allt(zatpk)
					break;
					case 0:
					default:
						cFshpzpk = allt(String(cFshpzpk)).substring(0, allt(String(cFshpzpk)).length - 1) + allt(String(zatpk));
					break;
				}
	         }

	         strSQL = "select FAN from ^LIC_FLD where Fid="+sqlTo(nach_lsfi9);
	         var licpSnap = getSnap(strSQL);
	         zatpl = "0";
	         if (licpSnap != null)
	         {
	            zatpl = licpSnap[0];
	            if (zatpl==null)  zatpl = "0";            
	         }
	         cFshpzpl = sh_table.getValue("Fshpz");
	         if (zatpl!="0")
	         {
	            cFshpzpl = allt(sh_table.getValue("Fshpz"))
	            //*заменить (или добавить в конец) последнюю цифру из ШПЗ на цифру из поля FAN в LIC_FLD
				switch(getPar("PRK_SHPZ"))
				{
					case 1:
						cFshpzpl = cFshpzpl+allt(zatpl)
					break;
					case 0:
					default:
						cFshpzpl = allt(String(cFshpzpl)).substring(0, allt(String(cFshpzpl)).length - 1) + allt(String(zatpl));
					break;
				}
	         }

	         	if (Number(sh_table.getValue("Fsumnal"))!=0 && sh_table.getValue("Fzatr")=="+"){
					 if (fld_f3==true){
						 var n = new Object();
						 n.Ftabn_id = pFtabn
						 n.Fwid_wp  = 0                   
						 n.Fsum  = Number(sh_table.getValue("Fsumnal"))                   
						 n.Flsfid = nach_lsfi3
						 n.Ffld_num = nach_lsnu3
	                     n.Fshpz = cFshpzp                   
	                     n.Fproc = 0
	                     n.Fmn = new Date(sh_table.getValue("Fmn")).getVarDate()
	                     n.Fvp = Number(sh_table.getValue("Fvp"))
	                     n.Fis_day = 0
	                     n.Fvid_prk = 0
	                     n.Favt = true;
	                     n.Fpr = 0                   
	                     UpdateTable(sfName,n,true);               
					 }          

            		 if (is_rasch && (Number(sh_table.getValue("Fvp"))==2 && differ(new Date(sh_table.getValue("Fmn")),mdat)>0) ){
						 if (fld_f3==true){	 		        	 
	 	                   n = new Object();
	     	               n.Ftabn_id = pFtabn
	         	           n.Fwid_wp  = 0                   
	             	       n.Fsum  = Number(sh_table.getValue("Fsumnal"))
	                 	   n.Flsfid = nach_lsfi3
	                 	   n.Ffld_num = nach_lsnu3
	 	                   n.Fshpz = cFshpzp;
	     	               n.Fmn   = mdat.getVarDate();
	         	           n.Fmn1  = new Date(sh_table.getValue("Fmn")).getVarDate();                   
	             	       n.Fproc = 0
	                 	   n.Fday  = 0
	                       n.Fis_day = 0
	 	                   n.Fvid_prk = 0
	     	               UpdateTable(snName,n,true);
						 }  
	     	         }                      
	             } 


	         	if (Number(sh_table.getValue("Fsumnal"))!=0 && sh_table.getValue("Fzatr")=="*"){
					if (fld_f4==true){	         		
						n = new Object();
						n.Ftabn_id = pFtabn
						n.Fwid_wp  = 0                   
						n.Fsum  = Number(sh_table.getValue("Fsumnal"))                   
						n.Flsfid = nach_lsfi4
						n.Ffld_num = nach_lsnu4
	                    n.Fshpz = cFshpzpp                   
	                    n.Fproc = 0
	                    n.Fmn = new Date(sh_table.getValue("Fmn")).getVarDate()
	                    n.Fvp = Number(sh_table.getValue("Fvp"))
	                    n.Fis_day = 0
	                    n.Fvid_prk = 0
	                    n.Favt = true;
	                    n.Fpr = 0                   
	                    UpdateTable(sfName,n,true);               
					}
					
					if (is_rasch && (Number(sh_table.getValue("Fvp"))==2 && differ(new Date(sh_table.getValue("Fmn")),mdat)>0) ){
						if (fld_f4==true){	 		        	
	 	                   n = new Object();
	     	               n.Ftabn_id = pFtabn
	         	           n.Fwid_wp  = 0                  
	             	       n.Fsum  = Number(sh_table.getValue("Fsumnal"))
	                 	   n.Flsfid = nach_lsfi4
	                 	   n.Ffld_num = nach_lsnu4
	 	                   n.Fshpz = cFshpzpp;
	     	               n.Fmn   = mdat.getVarDate();
	         	           n.Fmn1  = new Date(sh_table.getValue("Fmn")).getVarDate();                   
	             	       n.Fproc = 0
	                 	   n.Fday  = 0
	                       n.Fis_day = 0
	 	                   n.Fvid_prk = 0
	     	               UpdateTable(snName,n,true);
	     	            }
	 		        }	
	             } 

	         	if (Number(sh_table.getValue("Fsumnal"))!=0 && sh_table.getValue("Fzatr")=="#"){
					if (fld_f8==true){	         		
						n = new Object();
						n.Ftabn_id = pFtabn
						n.Fwid_wp  = 0                  
						n.Fsum  = Number(sh_table.getValue("Fsumnal"))                   
						n.Flsfid = nach_lsfi8
						n.Ffld_num = nach_lsnu8
	                    n.Fshpz = cFshpzpk                   
	                    n.Fproc = 0
	                    n.Fmn = new Date(sh_table.getValue("Fmn")).getVarDate()
	                    n.Fvp = Number(sh_table.getValue("Fvp"))
	                    n.Fis_day = 0
	                    n.Fvid_prk = 0
	                    n.Favt = true;
	                    n.Fpr = 0                   
	                    UpdateTable(sfName,n,true);               
					}
					
            		if (is_rasch && (Number(sh_table.getValue("Fvp"))==2 && differ(new Date(sh_table.getValue("Fmn")),mdat)>0) ){					           
	 		        //if (is_rasch && pFvp!=0){
						if (fld_f8==true){	 		        	
	 	                   n = new Object();
	     	               n.Ftabn_id = pFtabn
	         	           n.Fwid_wp  = 0                   
	             	       n.Fsum  = Number(sh_table.getValue("Fsumnal"))
	                 	   n.Flsfid = nach_lsfi8
	                 	   n.Ffld_num = nach_lsnu8
	 	                   n.Fshpz = cFshpzpk;
	     	               n.Fmn   = mdat.getVarDate();
	         	           n.Fmn1  = new Date(sh_table.getValue("Fmn")).getVarDate();                   
	             	       n.Fproc = 0
	                 	   n.Fday  = 0
	                       n.Fis_day = 0
	 	                   n.Fvid_prk = 0
	     	               UpdateTable(snName,n,true);
	     	            }                 
	 		        }	
	             } 

	         	if (Number(sh_table.getValue("Fsumnal"))!=0 && sh_table.getValue("Fzatr")=="&"){
					if (fld_f9==true){	         		
						n = new Object();
						n.Ftabn_id = pFtabn
						n.Fwid_wp  = 0                   
						n.Fsum  = Number(sh_table.getValue("Fsumnal"))                   
						n.Flsfid = nach_lsfi9
						n.Ffld_num = nach_lsnu9
	                    n.Fshpz = cFshpzpl                   
	                    n.Fproc = 0
	                    n.Fmn = new Date(sh_table.getValue("Fmn")).getVarDate()
	                    n.Fvp = Number(sh_table.getValue("Fvp"))
	                    n.Fis_day = 0
	                    n.Fvid_prk = 0
	                    n.Favt = true;
	                    n.Fpr = 0                   
	                    UpdateTable(sfName,n,true);               
					} 
					
            		if (is_rasch && (Number(sh_table.getValue("Fvp"))==2 && differ(new Date(sh_table.getValue("Fmn")),mdat)>0) ){					          
						if (fld_f9==true){	 		        	
	 	                   n = new Object();
	     	               n.Ftabn_id = pFtabn
	         	           n.Fwid_wp  = 0                   
	             	       n.Fsum  = Number(sh_table.getValue("Fsumnal"))
	                 	   n.Flsfid = nach_lsfi9
	                 	   n.Ffld_num = nach_lsnu9
	 	                   n.Fshpz = cFshpzpl;
	     	               n.Fmn   = mdat.getVarDate();
	         	           n.Fmn1  = new Date(sh_table.getValue("Fmn")).getVarDate();                   
	             	       n.Fproc = 0
	                 	   n.Fday  = 0
	                       n.Fis_day = 0
	 	                   n.Fvid_prk = 0
	     	               UpdateTable(snName,n,true);
	     	            }                 
	 		        }	
	             } 

	         sh_table.MoveNext();

	         if (!sh_table.IsEOF()){
	         	pFtabn     = Number(sh_table.getValue("Ftabn_id"))
	         	pFsht_id   = Number(sh_table.getValue("Fcod_kzsht"))
	         }
	   }
   }
   sh_table.close();
 }
 
 return;
 
}


