include("get_const.js");

function name_gosdlP()
{
	return "Удержание задолжености в пользу предприятия";
}

function r_gosdlP(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	var cbas_mbeg = new Date(base_month.getYear() + 1900, base_month.getMonth(), base_month.getDate());
	var cbas_mend = new Date(lastDayMonth(base_month));

	// дата начала
	var D1 = new Date(month.getYear() + 1900, month.getMonth(), 1);
	// дата конца
	var D2 = new Date(lastDayMonth(D1));

	var is_rasch = 0==differ(base_month, month);
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	if (is_rasch)
	{
		strSQL="select  COUNT(*) from ^PRK_ALL where Fvid_prk="+vidprk+" and Fbdat<="+
				sqlTo(cbas_mend.getVarDate())+" and Flast_dat>="+
				sqlTo(cbas_mbeg.getVarDate())+sqlTabn;
		var snap = getSnap(strSQL);
		if(null == snap	|| 0 == snap[0])
			return true;
		strSQL = "SELECT fid, ffld_num FROm ^lic_fld WHERE fid=" + sqlTo(lsfid);
		snap = getSnap(strSQL);
		if(null == snap)
		{
			msg = "Обнаружена серьезная ошибка функционирования системы \n"
					+ "Hевозможно идентифицировать поле ЛС: задолж.предпр.\n"
					+ "Пригласите разработчиков для устранения";
			writeToLog(msg,"e",vopl, vidprk, lsfid);
			return false;
		}

		var nach_lsfid = snap[0];
		var nach_lsnum = snap[1];
		// достаем цифры к названию файла
		var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);
		var mainTableName = (svzpName?svzpName:"svzp") + szTag;
		// Проверка на существование таблицы "svzp%LD"
		if(!IsTableEx("zrp_res", "zrp_" + mainTableName))
		{
		//	var strPath = getPath("zrp_res");
			CreateTableEx("zrp_res","zrp_" + mainTableName, "svzp", "*");
		}
		
		//YANA 27.06.07 Нельзя удалять, т,к, исправленные вручную суммы всегда будут удаляться и задолженность нельзя будет поправить
		// 03.07.08 YANA - вернем удаление, т,к, сейчас нет генерации сумм из приказа и чтобы изменилась сумма удержания при изменившейся
		// суммы начислений, нужно идти в приказ перед каждым расчетом и удалять созданные предыдущим расчетом записи. Это неудобно.
		// Сначала нужно переделать порядок расчетов, а потом  убирать удаление.		
			strSQL = "DELETE FROM ^dlg_al_u"
					+ " WHERE fid in (SELECT fwid FROM ^prk_all WHERE fvid_prk=" + vidprk
						+ " AND fbdat<=" + sqlTo(cbas_mend)
						+ " AND flast_dat>=" + sqlTo(cbas_mbeg) + sqlTabn + ")"
						+ " AND fbdat="+sqlTo(base_month);
			ExecuteSQL(strSQL);

			//Создадим временную таблицу с необходимыми суммами по каждому человеку из начисленной зарплаты
			if(IsTable("tmp_sumSVZP"))
				DropTable("tmp_sumSVZP");
		
			strSQL = "SELECT sv.ftabn_id as fwid_cl"
						+ ", SUM("+IIF("l.fis5='+'", "sv.fsum", 0)+") AS ssum"
						+ ", SUM("+IIF("l.fis1 IN ('s', 'п', 'з') OR l.fis8 IN ('п', 'с')", "sv.fsum", 0)+") AS ssum_nlg"
					+ " INTO tmp_sumSVZP"
					+ " FROM (^" + mainTableName + " AS sv LEFT JOIN ^lic_fld AS l ON sv.flsfid=l.fid)"
					+ " WHERE l.fis5='+' OR l.fis1 IN ('s','п','з') OR l.fis8 IN ('с','п')"
						+(ftabn_id?" and sv.Ftabn_id in ("+ftabn_id+") ":"")						
					+ " GROUP BY sv.ftabn_id";
			ExecuteSQL(strSQL);

			//Расчет суммы долга по каждому человеку
			if(IsTable("TDLGOC"))
 				DropTable("TDLGOC");

			//те, по кот,уже хотя-бы один месяц удерживалась сумма и есть запись в dlg_al_u
			strSQL = "SELECT "+"(u.fsum_do-u.fsum_ud) as Fsum_do,"+sqlRound(" ((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" as Fsum_ud, u.Fid as Fid, "+
			         " u.Fnach_sum as Fnach_sum, u.Fbdat as Fbdat, u.Fedat as Fedat, p.Fproc as Fproc, "+
			         sqlRound(" ((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" as Fsum_ud2 into TDLGOC FROM "+
			         " ^dlg_al_u AS u INNER JOIN ^prk_all AS p ON u.fid=p.fwid  INNER JOIN tmp_sumSVZP AS t "+
			         " ON p.ftabn_id=t.fwid_cl"+
			 	 	 " WHERE p.Fvid_prk="+sqlTo(vidprk)
					 + " AND p.fbdat<=" + sqlTo(cbas_mend)
					 + " AND p.flast_dat>=" + sqlTo(cbas_mbeg)
					 + (ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"")
			 	 	 + " and u.fbdat=(SELECT MAX(fbdat) FROM ^dlg_al_u AS g"+
					 " WHERE g.fbdat<" + sqlTo(base_month) +" AND g.fid=u.fid)"
			ExecuteSQL(strSQL);

			//те, по кот, еще не удерживалась сумма и нет ни одной записи в dlg_al_u
			if(IsTable("TDLGNC"))
 				DropTable("TDLGNC");
			strSQL = "SELECT p.fwid AS fid,"
					+ "p.fproc,"
					+ "p.fsum AS fnach_sum,"					
					+ sqlTo(cbas_mbeg) + " AS fbdat,"
					+ sqlTo(cbas_mend) + " AS fedat,"
					+ "p.fsum AS fsum_do,"										
					+ sqlRound("((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" AS fsum_ud,"															
					+ sqlRound("((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" AS fsum_ud2"
				+ " into TDLGNC FROM ^prk_all AS p INNER JOIN tmp_sumSVZP AS t ON p.ftabn_id=t.fwid_cl" //prk_dolg
				+ " WHERE NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fnach_sum=Fsum_do)"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg)
					+ (ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
			ExecuteSQL(strSQL);
 			//перебивка сумм, чтобы не выйти за границы задолженности
			strSQL = "UPDATE TDLGOC set Fsum_ud=0"
			ExecuteSQL(strSQL);
						
			strSQL = "UPDATE TDLGNC set Fsum_ud=0"
			ExecuteSQL(strSQL);			
 			
			strSQL = "UPDATE TDLGOC set Fsum_ud="+IIF("Fsum_ud2>Fsum_do", "Fsum_do", "Fsum_ud2")
			ExecuteSQL(strSQL);			

			strSQL = "UPDATE TDLGNC set Fsum_ud="+IIF("Fsum_ud2>Fsum_do", "Fsum_do", "Fsum_ud2")
			ExecuteSQL(strSQL);			
		
 			//добавление записей в dlg_al_u		
			strSQL = "INSERT INTO ^dlg_al_u (fid, fsbor, fproc, fnach_dat, fnach_sum, fvid_prk"
					+ ", fbdat, fedat, fsum_do, fsum_ud)"
				+ "SELECT p.fwid AS fid"
					+ ", p.Fsbor AS fsbor"//????
					+ ", p.fproc"
					+ ", p.fbdat AS fnach_dat"
					+ ", p.fsum AS fnach_sum"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
					+ ", " + sqlTo(cbas_mbeg) + " AS fbdat"
					+ ", " + sqlTo(cbas_mend) + " AS fedat"
					+ ", h.Fsum_do AS fsum_do"
					+ ", h.Fsum_ud AS fsum_ud"
				+ " FROM TDLGOC AS h INNER JOIN ^prk_all AS p ON p.fwid=h.fid " //prk_dolg
				+ " WHERE h.Fsum_ud<>0 and NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fbdat="+sqlTo(base_month)+")"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg);
			ExecuteSQL(strSQL);

			strSQL = "INSERT INTO ^dlg_al_u (fid, fsbor, fproc, fnach_dat, fnach_sum, fvid_prk"
					+ ", fbdat, fedat, fsum_do, fsum_ud)"
				+ "SELECT p.fwid AS fid"
					+ ", p.Fsbor AS fsbor"//????
					+ ", p.fproc"
					+ ", p.fbdat AS fnach_dat"
					+ ", p.fsum AS fnach_sum"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
					+ ", " + sqlTo(cbas_mbeg) + " AS fbdat"
					+ ", " + sqlTo(cbas_mend) + " AS fedat"
					+ ", h.Fsum_do AS fsum_do"
					+ ", h.Fsum_ud AS fsum_ud"
				+ " FROM TDLGNC  AS h INNER JOIN ^prk_all AS p ON p.fwid=h.fid  " //prk_dolg
				+ " WHERE h.Fsum_ud<>0 and NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fbdat="+sqlTo(base_month)+")"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg);
			ExecuteSQL(strSQL);
			
			//Создадим временную таблицу с необходимыми суммами по каждому человеку из начисленной зарплаты
			if(IsTable("tmp_sumSVZP"))
				DropTable("tmp_sumSVZP");
		
			strSQL = "SELECT w.fwid_cl"
						+ ", SUM("+IIF("l.fis5='+'", "sv.fsum", 0)+") AS ssum"
						+ ", SUM("+IIF("l.fis1 IN ('s', 'п', 'з') OR l.fis8 IN ('п', 'с')", "sv.fsum", 0)+") AS ssum_nlg"
					+ " INTO tmp_sumSVZP"
					+ " FROM (^" + mainTableName + " AS sv LEFT JOIN ^lic_fld AS l ON sv.flsfid=l.fid)"
						+ " INNER JOIN ^work_pers AS w ON sv.fwid_wp=w.fwid"
					+ " WHERE l.fis5=" +sqlTo("+") + " OR l.fis1 IN (" + sqlTo("s")+ ", " + sqlTo("п")+ ", " + sqlTo("з")+ ")"  + " OR l.fis8 IN (" + sqlTo("с")+ ", " + sqlTo("п")+ ")"
					+ (ftabn_id?" and sv.Ftabn_id in ("+ftabn_id+") ":"")
					+ " GROUP BY w.fwid_cl";
			ExecuteSQL(strSQL);

			//Расчет суммы долга по каждому человеку
			if(IsTable("TDLGO"))
 				DropTable("TDLGO");

			//те, по кот,уже хотя-бы один месяц удерживалась сумма и есть запись в dlg_al_u
			strSQL = "SELECT "+"(u.fsum_do-u.fsum_ud) as Fsum_do,"+" 0 as Fsum_ud, u.Fid as Fid, "+
			         " u.Fnach_sum as Fnach_sum, u.Fbdat as Fbdat, u.Fedat as Fedat, p.Fproc as Fproc, "+
			         sqlRound(" ((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" as Fsum_ud2 into TDLGO FROM "+
			         " ^dlg_al_u AS u INNER JOIN ^prk_all AS p ON u.fid=p.fwid INNER JOIN "+
			         " ^work_pers AS wp ON p.Fwid_wp=wp.Fwid INNER JOIN tmp_sumSVZP AS t "+
			         " ON wp.fwid_cl=t.fwid_cl"+
			 	 	 " WHERE p.Fvid_prk="+sqlTo(vidprk)
					 + " AND p.fbdat<=" + sqlTo(cbas_mend)
					 + " AND p.flast_dat>=" + sqlTo(cbas_mbeg)
			 	 	 + " and u.fbdat=(SELECT MAX(fbdat) FROM ^dlg_al_u AS g"+
					 " WHERE g.fbdat<" + sqlTo(base_month) +" AND g.fid=u.fid)"
			ExecuteSQL(strSQL);

			//те, по кот, еще не удерживалась сумма и нет ни одной записи в dlg_al_u
			if(IsTable("TDLGN"))
 				DropTable("TDLGN");

			strSQL = "SELECT p.fwid AS fid,"
					+ "p.fproc,"
					+ "p.fsum AS fnach_sum,"					
					+ sqlTo(cbas_mbeg) + " AS fbdat,"
					+ sqlTo(cbas_mend) + " AS fedat,"
					+ "p.fsum AS fsum_do,"										
					+ "0 AS fsum_ud,"															
					+ sqlRound("((t.ssum-t.ssum_nlg)*p.fproc/100)",2)+" AS fsum_ud2"
				+ " into TDLGN FROM ^prk_all AS p INNER JOIN ^work_pers AS wp ON p.Fwid_wp=wp.Fwid INNER JOIN tmp_sumSVZP AS t ON wp.fwid_cl=t.fwid_cl" //prk_dolg
				+ " WHERE NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fnach_sum=Fsum_do)"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg);
            ExecuteSQL(strSQL);
	
	/* 
	ExecuteSQL( "SELECT p.fwid AS fid,"
					+ "p.fproc,"
					+ "p.fsum AS "+"fnach_sum,"					
					+ "p.fsum AS fsum_do,"										
					+ "0 AS fsum_ud "															
				+ " into TDLGN FROM "+"^prk_all AS p INNER JOIN ^work_pers "+"AS wp ON p.Fwid_wp=wp.Fwid INNER "+"JOIN tmp_sumSVZP AS t ON "+"wp.fwid_cl=t.fwid_cl" 
				+ " WHERE NOT "+" EXISTS(SELECT * FROM ^dlg_al_u "+" WHERE Fid=p.Fwid AND "+" Fnach_sum=Fsum_do)"
					+ " AND p.fvid_prk=" + sqlTo(702))
   */					
	 
	 
 			//перебивка сумм, чтобы не выйти за границы задолженности
			strSQL = "UPDATE TDLGO set Fsum_ud="+IIF("Fsum_ud2>Fsum_do", "Fsum_do", "Fsum_ud2")
			ExecuteSQL(strSQL);			

			strSQL = "UPDATE TDLGN set Fsum_ud="+IIF("Fsum_ud2>Fsum_do", "Fsum_do", "Fsum_ud2")
			ExecuteSQL(strSQL);			
		
 			//добавление записей в dlg_al_u		
			strSQL = "INSERT INTO ^dlg_al_u (fid, fsbor, fproc, fnach_dat, fnach_sum, fvid_prk"
					+ ", fbdat, fedat, fsum_do, fsum_ud)"
				+ "SELECT p.fwid AS fid"
					+ ", p.Fsbor AS fsbor"//????
					+ ", p.fproc"
					+ ", p.fbdat AS fnach_dat"
					+ ", p.fsum AS fnach_sum"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
					+ ", " + sqlTo(cbas_mbeg) + " AS fbdat"
					+ ", " + sqlTo(cbas_mend) + " AS fedat"
					+ ", h.Fsum_do AS fsum_do"
					+ ", h.Fsum_ud AS fsum_ud"
				+ " FROM TDLGO AS h INNER JOIN ^prk_all AS p ON p.fwid=h.fid INNER JOIN ^work_pers AS wp ON p.Fwid_wp=wp.Fwid " //prk_dolg
				+ " WHERE h.Fsum_ud<>0 and NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fbdat="+sqlTo(base_month)+")"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg)
					+ (ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
			ExecuteSQL(strSQL);

			strSQL = "INSERT INTO ^dlg_al_u (fid, fsbor, fproc, fnach_dat, fnach_sum, fvid_prk"
					+ ", fbdat, fedat, fsum_do, fsum_ud)"
				+ "SELECT p.fwid AS fid"
					+ ", p.Fsbor AS fsbor"//????
					+ ", p.fproc"
					+ ", p.fbdat AS fnach_dat"
					+ ", p.fsum AS fnach_sum"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
					+ ", " + sqlTo(cbas_mbeg) + " AS fbdat"
					+ ", " + sqlTo(cbas_mend) + " AS fedat"
					+ ", h.Fsum_do AS fsum_do"
					+ ", h.Fsum_ud AS fsum_ud"
				+ " FROM TDLGN  AS h INNER JOIN ^prk_all AS p ON p.fwid=h.fid INNER JOIN ^work_pers AS wp ON p.Fwid_wp=wp.Fwid " //prk_dolg
				+ " WHERE h.Fsum_ud<>0 and NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fbdat="+sqlTo(base_month)+")"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg);
			ExecuteSQL(strSQL);

/*			
 
 		    // работал правильно только первый раз, дальше сумма задолженности уменьшается
 		    // на сумму предыдущих удержаний, а это не учитывалось.
			var mfsum = "p.fsum"

			strSQL = "INSERT INTO ^dlg_al_u (fid, fsbor, fproc, fnach_dat, fnach_sum, fvid_prk"
					+ ", fbdat, fedat, fsum_do, fsum_ud)"
				+ "SELECT p.fwid AS fid"
					+ ", 0 AS fsbor"//????
					+ ", p.fproc"
					+ ", p.fbdat AS fnach_dat"
					+ ", p.fsum AS fnach_sum"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
					+ ", " + sqlTo(cbas_mbeg) + " AS fbdat"
					+ ", " + sqlTo(cbas_mend) + " AS fedat"
					+ ", " + mfsum + " AS fsum_do"
					+ " ," + IIF("((t.ssum-t.ssum_nlg)*p.fproc/100)>" + mfsum 
								, mfsum
								, "((t.ssum-t.ssum_nlg)*p.fproc/100)") + " AS fsum_ud"
				+ " FROM ^prk_all AS p INNER JOIN ^work_pers AS wp ON p.Fwid_wp=wp.Fwid INNER JOIN tmp_sumSVZP AS t ON wp.fwid_cl=t.fwid_cl" //prk_dolg
				+ " WHERE NOT EXISTS(SELECT * FROM ^dlg_al_u WHERE Fid=p.Fwid AND Fbdat="+sqlTo(base_month)+")"
					+ " AND p.fvid_prk=" + sqlTo(vidprk)
					+ " AND p.fbdat<=" + sqlTo(cbas_mend)
					+ " AND p.flast_dat>=" + sqlTo(cbas_mbeg);
			ExecuteSQL(strSQL);
			* /

/*
 			// сбор считался, только если в справочнике была только одна шкала. Если были шкалы за разные периоды, то падал 
			strSQL = "UPDATE ^dlg_al_u AS t "
				+ " SET fsbor=(SELECT t.fsum_ud*n.f_proc/100 + n.f_basnl FROM ^proc_al AS n"
							+ " WHERE n.f_stsum = (SELECT MAX(n1.f_stsum) FROM ^proc_al As n1"
								+ " WHERE n1.f_stsum<t.fsum_ud"
									+ " AND ((n1.fbdat<=" + sqlTo(D1) + " AND n1.fedat>=" + sqlTo(D2) + ")"
									+ " OR (n1.fbdat>=" + sqlTo(D1) + " AND n1.fbdat<=" + sqlTo(D2) + ")"
									+ " OR (n1.fedat>=" + sqlTo(D1) + " AND n1.fedat<=" + sqlTo(D1) + "))))"
				+ " WHERE t.fvid_prk=" + sqlTo(vidprk)
					+ " AND t.fbdat=" + sqlTo(cbas_mbeg)
					+ " AND t.fedat=" + sqlTo(cbas_mend);
*/
			//28.12.07
			// переделка расчета почтового сбора на несколько шкал. Вроде, работает
			strSQL = "UPDATE ^dlg_al_u "
				+ " SET fsbor=(SELECT "+sqlRound("^dlg_al_u.fsum_ud*n.f_proc/100 + n.f_basnl",2)+" FROM ^proc_al AS n"
							+ " WHERE " 
							+ " ((n.fbdat<=" + sqlTo(D1) + " AND n.fedat>=" + sqlTo(D2) + ")"
							+ " OR (n.fbdat>=" + sqlTo(D1) + " AND n.fbdat<=" + sqlTo(D2) + ")"
							+ " OR (n.fedat>=" + sqlTo(D1) + " AND n.fedat<=" + sqlTo(D1) + "))"
							+ " AND n.f_stsum = (SELECT MAX(n1.f_stsum) FROM ^proc_al As n1"
								+ " WHERE n1.f_stsum<^dlg_al_u.fsum_ud"
									+ " AND ((n1.fbdat<=" + sqlTo(D1) + " AND n1.fedat>=" + sqlTo(D2) + ")"
									+ " OR (n1.fbdat>=" + sqlTo(D1) + " AND n1.fbdat<=" + sqlTo(D2) + ")"
									+ " OR (n1.fedat>=" + sqlTo(D1) + " AND n1.fedat<=" + sqlTo(D1) + "))))"
				+ " WHERE fvid_prk=" + sqlTo(vidprk)
					+ " AND fsbor<>0 AND fsbor<>999 AND "
					+ " (select Fnom_prik from ^PRK_ALL where FIN_TABLE='PRK_DOLG' and fvid_prk="+sqlTo(vidprk)+" and Fwid=^dlg_al_u.Fid "+sqlTabn+")='1'"													
					+ " AND fbdat=" + sqlTo(cbas_mbeg)
					+ " AND fedat=" + sqlTo(cbas_mend);
									
			ExecuteSQL(strSQL);

			//электронный сбор
			strSQL = "UPDATE ^dlg_al_u "
				+ " SET fsbor=(SELECT "+sqlRound("^dlg_al_u.fsum_ud*n.f_proc/100 + n.f_basnl",2)+" FROM ^nalog_ms AS n"
							+ " WHERE " 
							+ " ((n.fbdat<=" + sqlTo(D1) + " AND n.fedat>=" + sqlTo(D2) + ")"
							+ " OR (n.fbdat>=" + sqlTo(D1) + " AND n.fbdat<=" + sqlTo(D2) + ")"
							+ " OR (n.fedat>=" + sqlTo(D1) + " AND n.fedat<=" + sqlTo(D1) + "))"
							+ " AND n.f_stsum = (SELECT MAX(n1.f_stsum) FROM ^nalog_ms As n1"
								+ " WHERE n1.f_stsum<^dlg_al_u.fsum_ud"
									+ " AND ((n1.fbdat<=" + sqlTo(D1) + " AND n1.fedat>=" + sqlTo(D2) + ")"
									+ " OR (n1.fbdat>=" + sqlTo(D1) + " AND n1.fbdat<=" + sqlTo(D2) + ")"
									+ " OR (n1.fedat>=" + sqlTo(D1) + " AND n1.fedat<=" + sqlTo(D1) + "))))"
				+ " WHERE fvid_prk=" + sqlTo(vidprk)
					+ " AND fsbor<>0 AND fsbor<>999 AND "
					+ " (select Fnom_prik from ^PRK_ALL where FIN_TABLE='PRK_DOLG' and fvid_prk="+sqlTo(vidprk)+" and Fwid=^dlg_al_u.Fid "+sqlTabn+")='2'"									
					+ " AND fbdat=" + sqlTo(cbas_mbeg)
					+ " AND fedat=" + sqlTo(cbas_mend);
									
			ExecuteSQL(strSQL);

			strSQL = "UPDATE ^prk_all " //prk_dolg
					+ " SET fedat=" + sqlTo(base_month)
						+ ", fsum_do=(SELECT fsum_do FROM ^dlg_al_u WHERE fbdat=" + sqlTo(base_month) + " AND fid=^prk_all.fwid)"
						+ ", fsum_posl=(SELECT fsum_do-fsum_ud FROM ^dlg_al_u WHERE fbdat=" + sqlTo(base_month) + " AND fid=^prk_all.fwid)"
					+ " WHERE fvid_prk=" + vidprk
						+ " AND fbdat<=" + sqlTo(cbas_mend)
						+ " AND flast_dat>=" + sqlTo(cbas_mbeg)
						+ sqlTabn;
			ExecuteSQL(strSQL);

			strSQL = "INSERT INTO ^" + mainTableName + " (fwid_wp, ftabn_id, ffld_num, flsfid, fsum, fday, fid_prk, fvid_prk)"
				+ " SELECT  "
					//+ "(SELECT MAX(fwid_wp) FROM ^" + mainTableName + " AS s INNER JOIN ^work_pers AS w"
					//	+ " ON w.fwid=s.fwid_wp WHERE w.fwid=p.fwid_wp) AS fwid_wp"
					+ "0 AS fwid_wp"
					+ ", p.ftabn_id AS ftabn_id"
					+ ", " + nach_lsnum + " AS ffld_num"
					+ ", " + nach_lsfid + " AS flsfid"
					+ ", u.Fsum_ud AS fsum"
					+ ", 0 AS fday"
					+ ", p.fwid AS fid_prk"
					+ ", " + sqlTo(vidprk) + " AS fvid_prk"
				+ " FROM ^dlg_al_u AS u INNER JOIN ^prk_all AS p ON u.fid=p.fwid"	//prk_dolg
				+ " WHERE u.fvid_prk=" + sqlTo(vidprk) 
					+ " AND	u.fbdat>=" + sqlTo(cbas_mbeg) + " AND u.fbdat<=" + sqlTo(cbas_mend)
					+ (ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"");
			ExecuteSQL(strSQL);
  }			 
}