function r_indall(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName, obj_parind)
{
	//изменения в индексации с 2012 года
	//значение этой константы - дата перехода на новый расчет индексации, по закону - 01.06.12
	
	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(lastDayMonth(month));
	//D2.setDate(0);
	
	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	var siName = obj_parind.siName;
	//var sfName = obj_parind.sfName;	
	var kfindall=0;	
	if (obj_parind.regim=="INDEX"){	
		//*     взять из кл-ра const к-т индексации
		//если делаем справочник, то не нужно будет заносить еще и в константы индекс инфляции, чтобы не вносить дважды информацию	
		var kfindall = get_cnst("kfind", month)/100;
		if(kfindall == 0)
		{
			msg = ru("Не определена константа коэф.индексации kfind!","Не визначена константа коеф.індексації kfind!")
			writeToLog(msg,"w",vopl, vidprk, lsfid);
		}
	}	
	
	//эта та же процедура, что и r_indeks, но если ведется справочник индексов инфляции, не нужно делать двойную работу и заносить
	//их еще и в справочник констант. Поэтому этот расчет соотносится с доделанным расчетом % индексации в приказе
	var strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis7=";
	var nach_lsfid = 0;
	var nach_lsnum = 0;
	var snap = getSnap(strSQL + sqlTo("и"));
	if(null != snap)
	{
		nach_lsfid = snap[0];
		nach_lsnum = snap[1];
	}
	else
	{
		msg = " Обнаружена серьезная ошибка функционирования системы \n"+
                " Hевозможно идентифицировать поле ЛС: индекс.(необл.) \n"+
                "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"w",vopl, vidprk, lsfid);
    }
	
	var nach_lsfi2 = 0;
	var nach_lsnu2 = 0;
	snap = getSnap("SELECT fid, ffld_num FROM ^lic_fld WHERE fis9=" + sqlTo("т"));
	if(null != snap)
	{
		nach_lsfi2 = snap[0];
		nach_lsnu2 = snap[1];
	}
	else
	{
		msg = " Обнаружена серьезная ошибка функционирования системы \n"+
                " Hевозможно идентифицировать поле ЛС: индекс.(тр.согл.) \n"+
                "       Пригласите разработчиков для устранения        "
		writeToLog(msg,"w",vopl, vidprk, lsfid);    
     }
     

	var vdpl2 = 0;
	strSQL = "SELECT ffld_num FROM ^lic_fld WHERE Fid=" + sqlTo(lsfid2);
	snap = getSnap(strSQL);
	if (null!= snap)
	{
		var vdpl2 = snap[0];
	}
	
	//*     взять из кл-ра const прожиточный минимум
	var prmin = get_cnst("prmin", month);
	if(prmin == 0)
	{
		msg = ru("Не определена константа прожиточного минимума prmin!","Не визначена константа прожиткового мінімума prmin!")
		writeToLog(msg,"e",vopl, vidprk, lsfid);
	}

	var strSQL = "SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(lsfid);
	var snap = getSnap(strSQL);
	var mvvdpl=0;
  
   	if (snap != null)
  	   mvvdpl = snap[0];


	if (obj_parind.regim=="INDEX"){
	    if(!getPar("KOMKOLD")){
			var sql = "SELECT DISTINCT s.Ftabn_id,s.Fsum,s.fwid_wp,s.Fmn,s.Fvp,lic.* FROM ^"+siName	    	
			+" as s INNER JOIN ^LIC_FLD as lic ON s.flsfid=lic.fid"
			+" WHERE not Fwid_wp is NULL and Fwid_wp<>0 and fis7 is not null "+sqlTabn			
	    }else{	
	    	var sql = "SELECT DISTINCT s.Ftabn_id,s.Fsum,s.fwid_wp,s.Fmn,s.Fvp,s.Fisr_nr,lic.* FROM ^"+siName
			+" as s INNER JOIN ^LIC_FLD as lic ON s.flsfid=lic.fid"
			+" WHERE not Fwid_wp is NULL and Fwid_wp<>0 and fis7 is not null "+sqlTabn			
	    }
	    
		if (kfindall == 0)
		{
			sql += " and exists (SELECT FWID FROM ^prk_all prall WHERE prall.FVID_PRK = " + sqlTo(vidprk)
			+ " AND (prall.FBDAT <= " + sqlTo(D2) + " AND prall.FEDAT >= " + sqlTo(D1) +") and prall.ftabn_id = s.ftabn_id )"
		}

		sql += " order by Ftabn_id"					
	}else{
	    if(!getPar("KOMKOLD")){
	    	var sql = "SELECT DISTINCT s.Ftabn_id,s.Fsum,s.fwid_wp,s.Fmn,s.Fvp,lic.* FROM ^"+siName
			+" as s INNER JOIN ^LIC_FLD as lic ON s.flsfid=lic.fid"
			+" WHERE not Fwid_wp is NULL and Fwid_wp<>0 and fis7 is not null "+sqlTabn
	    }else{
	    	var sql = "SELECT DISTINCT s.Ftabn_id,s.Fsum,s.fwid_wp,s.Fmn,s.Fvp,s.Fisr_nr,lic.* FROM ^"+siName
				+" as s INNER JOIN ^LIC_FLD as lic ON s.flsfid=lic.fid"
				+" WHERE not Fwid_wp is NULL and Fwid_wp<>0 and fis7 is not null "+sqlTabn				
	    }
		sql += " and exists (SELECT FWID FROM ^prk_all prall WHERE prall.FVID_PRK = " + sqlTo(vidprk)
			+ " AND (prall.FBDAT <= " + sqlTo(D2) + " AND prall.FEDAT >= " + sqlTo(D1) +") and prall.ftabn_id = s.ftabn_id )"

		sql += " order by Ftabn_id"
	}
	
	var tbl = OpenTable("SELECT FWID FROM ^prk_all WHERE FVID_PRK = " + sqlTo(vidprk)
                  +" AND FBDAT <= " + sqlTo(D2) + " AND FEDAT >= " + sqlTo(D1) + sqlTabn)
	if (tbl.IsEmpty())
	{
		tbl.close();
		msg = ru("Отсутствуют приказы индексации. Расчет завершен.","Відсутні накази індексації. Розрахунок завершено.")
		writeToLog(msg,"m",vopl, vidprk, lsfid);
		return;
	}
	
	table=OpenTable(sql);
    if (table.IsEmpty())
    {
		tbl.close();
		table.close();
		msg = ru("Отсутствуют начисления в ЛС. Расчет завершен.","Відсутні нарахування в ОР. Розрахунок завершено.")
		writeToLog(msg,"m",vopl, vidprk, lsfid);
		return;
    }
    
	// Проходим по таблице table, а внутри нее по таблице tie
    table.MoveFirst();
    while(!table.IsEOF())
    {  
       ssum_osn = 0
       ssum_svm = 0
       //сумма труд.согл.
       ssum_trs = 0
       //сумма ,необл.под.нал., и индекс.отдельно от ост.начислений
       ssum_neo = 0  
       //сумма ,необл.под.нал., и индекс.по сов.с осн.ЗП
       ssum_noo = 0  
       //сумма ,необл.под.нал., и индекс.по сов.с ЗП по совм.
       ssum_nos = 0  
       pFsht_ido = 0
       pFsht_ids = 0
       pFsht_idn = 0
       //нужно знать, были ли выплачены суммы по отр.времени. Для этого воспользуемся настройкой для персонификации, где выделяются
       //поля ЛС с окладом. Если есть, то по новой индексации платим фикс.суммы. Если нет, то не платим.
       ssum_okl = 0       
       mFtabn = Number(table.getValue("Ftabn_id"));
		mFtabn_id = table.getValue("Ftabn_id");
       
//       if (table.FindFirst("Ftabn_id="+sqlTo(table.getValue("Ftabn_id"))))
       {
          while(!table.IsEOF() && Number(table.getValue("Ftabn_id"))==mFtabn) 
          {
             var ofsetmn_vip,mn_voz;
             switch(Number(table.getValue("FVP")))
             { 
               case 0:
                  mn_vip=month;
                  mn_voz=month;
                  offset = 1
                  break;
               case 1:
                  mn_vip=new Date(table.getValue("Fmn"))
                  mn_voz=month;
                  offset = 0
                  break;
               case 2:
                  mn_vip=month;
                  mn_voz=new Date(table.getValue("Fmn"))
                  offset = Math.round(day_difference(mn_vip,mn_voz)/30) +1   //смещение от базового месяца
                  break;
             }

             if (offset==1)
             { 
            	//в расчет индексации входят суммы, которые помечены как входящие и суммы командировочных, которые рассчитаны по дневному
            	 //заработку по колдоговору - это вопрос, правильно так или нет. По аналогии с вхождением в среднюю для расчета командировок
            	 //по логике такие командировочные должны  и индексироваться, но нигде об этом не написано. Поэтому, делаем настройку в формировании
            	 //перечня полей ЛС. Если не понадобится, просто поставить напротив командировок, что они не индексируются.
            	 
            	 //проверяем, нужно ли начислять фиксированную индексацию, если у человека есть отраб время (сюда включаем и командировки)
            	 //командировки должны стоять до индексации
      	    	if ( (table.getValue("Fis19")=="z") || (table.getValue("Ffzp")=="к"))
     	    	{
      	    		ssum_okl = ssum_okl + Number(table.getValue("Fsum"))
     	    	}
      	    	
         	    if(!getPar("KOMKOLD")){
         	    	if ( (table.getValue("Fis7")=="+") && (table.getValue("Fis1")=="+") )
         	    	{
         	    		ssum_osn = ssum_osn + Number(table.getValue("Fsum"))
         	    		pFsht_ido = table.getValue("Fwid_wp")
         	    	}
            	 
         	    	if ( (table.getValue("Fis7")=="+") && (table.getValue("Fis1")=="#"))
         	    	{
         	    		ssum_svm = ssum_svm + Number(table.getValue("Fsum"))
         	    		pFsht_ids = table.getValue("Fwid_wp")
         	    	}
         	    }else{
         	    	if ( (table.getValue("Fis7")=="+" || (table.getValue("Fis7")=="к" && table.getValue("Fisr_nr")==true)) && (table.getValue("Fis1")=="+") )
         	    	{
         	    		ssum_osn = ssum_osn + Number(table.getValue("Fsum"))
         	    		pFsht_ido = table.getValue("Fwid_wp")
         	    	}
            	 
         	    	if ( (table.getValue("Fis7")=="+" || (table.getValue("Fis7")=="к" && table.getValue("Fisr_nr")==true)) && (table.getValue("Fis1")=="#"))
         	    	{
         	    		ssum_svm = ssum_svm + Number(table.getValue("Fsum"))
         	    		pFsht_ids = table.getValue("Fwid_wp")
         	    	}
         	    }

               if ( (table.getValue("Fis7")=="+") && (table.getValue("Fis1")!="#" && table.getValue("Fis1")!="+"))
               {
                  ssum_neo = ssum_neo + Number(table.getValue("Fsum"))
                  pFsht_idn = table.getValue("Fwid_wp")
               }

               if ( (table.getValue("Fis7")=="!") && (table.getValue("Fis1")!="#" && table.getValue("Fis1")!="+"))
               {
                  ssum_noo = ssum_noo + Number(table.getValue("Fsum"))
                  pFsht_ido = table.getValue("Fwid_wp")
               }

               if ( (table.getValue("Fis7")=="#") && (table.getValue("Fis1")!="#" && table.getValue("Fis1")!="+"))
               {
                  ssum_nos = ssum_nos + Number(table.getValue("Fsum"))
                  pFsht_ids = table.getValue("Fwid_wp")
               }

               if ( (table.getValue("Fis7")=="*"))
               {
                  ssum_trs = ssum_trs + Number(table.getValue("Fsum"))
                  pFsht_ids = table.getValue("Fwid_wp")
               }
             } 
             table.MoveNext();
          }

          strSQL = "select dol.Fshpz from ^work_pers as w inner join ^stru_dol as dol ON w.fwid_dol=dol.fwid where w.Fwid="+sqlTo(pFsht_ido)
          var gS = getSnap(strSQL);
          if (gS != null)
          {
             mFshpzo = gS[0];
          }
          else
          {
             mFshpzo = "";
          }
           
          strSQL = "select dol.Fshpz from ^work_pers as w inner join ^stru_dol as dol ON w.fwid_dol=dol.fwid where w.Fwid="+sqlTo(pFsht_ids)
          
          var gS = getSnap(strSQL);
          if (gS != null)
          {
             mFshpzs = gS[0];
          }
          else
          {
             mFshpzs = "";
          }
          
          strSQL = "select dol.Fshpz from ^work_pers as w inner join ^stru_dol as dol ON w.fwid_dol=dol.fwid where w.Fwid="+sqlTo(pFsht_idn)
          //shpzn = OpenTable("s", strSQL);
          var gS = getSnap(strSQL);
          if (gS != null)
          {
             mFshpzn = gS[0];
          }
          else
          {
             mFshpzn = "";
          }
          
          tbl_prk3=OpenTable("SELECT * FROM ^prk_all as prk INNER JOIN ^work_pers as wp ON prk.fwid_wp=wp.fwid WHERE prk.FVID_PRK = " + sqlTo(vidprk) + " AND wp.Fwid_cl="+sqlTo(mFtabn)+
                  " AND prk.FBDAT <= " + sqlTo(D2) + " AND prk.FEDAT >= " + sqlTo(D1))

          //фикс.сумма индексации; платим, если было отработанное время - считаем отработанное время+время командировки
          //для простоты проверяем, есть ли оклад. Если есть, даем фикс.идексацию.Если нет - ищем командировки.Если есть
          //даем индексацию.
          //время в командировке приравнивается к отработанному (для больничных), поэтому переделаем проверку на тот случай
          //если человек весь месяц был в командировке или был в командировке и болел или был в отпуске
          sumfiks = 0;                  
          var fid_prk = 0;
          if (!tbl_prk3.IsEmpty())
          {
             kfind = Number(tbl_prk3.getValue("Fsum"))/100;
             fid_prk = tbl_prk3.getValue("Fwid");
         	 if (obj_parind.regim  == "INSNN"){
         		 //фикс.сумма индексации
         		 if (tbl_prk3.getValue("Fproc")!=null){
         			 //платим, если есть оклад
         			 if (ssum_okl!=0){
         				 sumfiks = Number(tbl_prk3.getValue("Fproc"));
         		 	 }else{
         		 		 //сделала поиск по сумме командировки; для этого индексация должна стоять после расчета командировочных
         		 		 //для совместимости с 2000 версией. ЕСли понадобится, можно раскомментарить этот кусок, он рабочий
             			 //платим, если нет оклада и есть командировка         		 		 
       	                 // достаем цифры к названию файла для табелей
         		 		 /*
       	                 if (D1.getMonth() < 9)  
       	                    tbszTag = String(D1.getFullYear())+"0"+String(D1.getMonth()+1);
       	                 else
       	                    tbszTag = String(D1.getFullYear())+String(D1.getMonth()+1);
       	                 
       	                 tbszName = "zrp_STT1"+tbszTag;
         	             tbtiName = "TBL"+tbszTag;
         	             tbsiName = "STT1"+tbszTag;
         	                    
         	             if(IsTableEx("zrp_mdb", tbszName))
         	             {
         	                var GSn=getSnap("SELECT B.FDAY_NVK,B.FCHASNVK "
         	          				+" FROM ^"+tbtiName+" AS B,^"+tbsiName+" AS A"
         	          				+" WHERE A.FTABN_ID="+sqlTo(mFtabn)+" AND B.FKOD_NVK=7"
         	          				+" AND A.FWID_WP=B.FWID_WP"
         	          				+" AND (B.FCHASNVK>0 OR B.FDAY_NVK>0)"
         	          				+" AND A.FBDAT=B.FBDAT"
         	          				+" AND A.FEDAT=B.FEDAT")
         	          		if (GSn!=null){
                				 sumfiks = Number(tbl_prk3.getValue("Fproc"));         	          			
         	          		}
         	             }
         	             */
         		 	 }
         		 }
          	 }
          }else{
        	 if (obj_parind.regim == "INDEX"){
                 kfind = kfindall        		 
        	 }else{ 
        		 kfind = 0;
        	 }
          }
          tbl_prk3.close();

    	  //поделить сумму фиксир.доплат между разными видами оплат
          fiks_osn = 0;
          fiks_svm = 0;
          fiks_trs = 0;
          fiks_neo = 0;
          if (sumfiks != 0){
        	  if ((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo==0){
                  fiks_osn = sumfiks;        		  
        	  }else{        	  
        		  fiks_osn = round(sumfiks*((ssum_osn+ssum_noo)/((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo)),2);
        		  fiks_svm = round(sumfiks*((ssum_svm+ssum_nos)/((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo)),2);
        		  fiks_trs = round(sumfiks*(ssum_trs/((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo)),2);
        		  fiks_neo = round(sumfiks*(ssum_neo/((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo)),2);
        		  if ((fiks_osn+fiks_svm+fiks_trs+fiks_neo)!=sumfiks){
        			  if (fiks_osn>0){
        				  fiks_osn = fiks_osn+((fiks_osn+fiks_svm+fiks_trs+fiks_neo)-sumfiks) 
        			  }else{
        				  if (fiks_svm>0){
        					  fiks_svm = fiks_svm+((fiks_osn+fiks_svm+fiks_trs+fiks_neo)-sumfiks) 
        				  }else{
        					  if (fiks_trs>0){
        						  fiks_trs = fiks_trs+((fiks_osn+fiks_svm+fiks_trs+fiks_neo)-sumfiks) 
        					  }else{
        						  fiks_neo = fiks_neo+((fiks_osn+fiks_svm+fiks_trs+fiks_neo)-sumfiks) 
        					  }  
        				  }   
        			  }
        		  }
        	  }
          }
		if (kfind!=0 || sumfiks!=0)
		{
			if((ssum_osn+ssum_noo) > 0)
			{
				var m = new Object();
				sumzp = ((ssum_osn+ssum_noo)<prmin)?(ssum_osn+ssum_noo):prmin;
				csum = round(sumzp*kfind,2)+fiks_osn
				//tbl.AddNew();
				var snap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+pFsht_ido);
				if(snap!=null)
					m.ftabn_id= snap[0];
				m.fwid_wp = pFsht_ido
				m.fshpz = mFshpzo
				m.Fsum = csum
				m.Ffld_num = mvvdpl
				m.FLSFID = lsfid
				m.FID_PRK = fid_prk;
				m.FVID_PRK = vidprk
				m.Fmn  = d00
				m.Fvp  = 0
				m.Fproc = kfind*100;
				//tbl.Update();
				UpdateTable("^" + siName,m,true);
			}
			if((ssum_svm+ssum_nos) > 0)
			{
				m = new Object();
				sumzp = ((ssum_svm+ssum_nos)<prmin)?(ssum_svm+ssum_nos):prmin;
				csum = round(sumzp*kfind,2)+fiks_svm
				// tbl.AddNew();
				var snap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+pFsht_ids);
				if(snap!=null)
					m.ftabn_id = snap[0];
				m.fwid_wp = pFsht_ids
				m.fshpz = mFshpzs
				m.Fsum = csum
				m.Ffld_num = vdpl2
				m.FLSFID = lsfid2
				m.FID_PRK = fid_prk;
				m.FVID_PRK = vidprk
				m.Fmn  = d00
				m.Fvp  = 0
				m.Fproc = kfind*100;
				UpdateTable("^" + siName,m,true);
			}
			if( ssum_neo > 0)
			{
				m = new Object();
				sumzp = (ssum_neo<prmin)?ssum_neo:prmin;
				csum = round(sumzp*kfind,2)+fiks_neo
				// tbl.AddNew();
				var snap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+pFsht_idn);
				if(snap!=null)
					m.ftabn_id=snap[0];
				m.fwid_wp = pFsht_idn
				m.fshpz = mFshpzn
				m.Fsum = csum
				m.Ffld_num = nach_lsnum
				m.FLSFID = nach_lsfid
				m.FID_PRK = fid_prk;
				m.FVID_PRK = vidprk
				m.Fmn  = d00
				m.Fvp  = 0
				m.Fproc = kfind*100;
				UpdateTable("^" + siName,m,true);
			}
			if( ssum_trs > 0)
			{
				m = new Object();
				sumzp = (ssum_trs<prmin)?ssum_trs:prmin;
				csum = round(sumzp*kfind,2)+fiks_trs
				//tbl.AddNew();
				var snap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+pFsht_ids);
				if(snap!=null)
					m.ftabn_id=snap[0];
				m.fwid_wp = pFsht_ids
				m.fshpz = mFshpzs
				m.Fsum = csum
				m.Ffld_num = nach_lsnu2
				m.FLSFID = nach_lsfi2
				m.FID_PRK = fid_prk;
				m.FVID_PRK = vidprk
				m.Fmn  = d00
				m.Fvp  = 0
				m.Fproc = kfind*100;
				UpdateTable("^" + siName,m,true);
			}
			
			if ((ssum_osn+ssum_noo)+(ssum_svm+ssum_nos)+ssum_trs+ssum_neo==0 && fiks_osn!=0)
			{
				var m = new Object();
				csum = fiks_osn
				//tbl.AddNew();
				m.ftabn_id=mFtabn;				
				var snap = getSnap("SELECT "+First("Fwid_wp")+" FROM ^"+siName+" WHERE Ftabn_id="+sqlTo(mFtabn)+" and Fwid_wp<>0 and not Fwid_wp is null");
				if(snap!=null)
					m.fwid_wp = snap[0];
			
		        strSQL = "select dol.Fshpz from ^work_pers as w inner join ^stru_dol as dol ON w.fwid_dol=dol.fwid where w.Fwid="+sqlTo(snap[0])
	            var gS = getSnap(strSQL);
		        if (gS != null){
		             mFshpzo = gS[0];
		        }
		        else
		        {
		            mFshpzo = "";
		        }
				m.fshpz = mFshpzo
				m.Fsum = csum
				m.Ffld_num = mvvdpl
				m.FLSFID = lsfid
				m.FID_PRK = fid_prk;
				m.FVID_PRK = vidprk
				m.Fmn  = d00
				m.Fvp  = 0
				m.Fproc = kfind*100;
				//tbl.Update();
				UpdateTable("^" + siName,m,true);
			}
		}
      }
     //table.MoveNext();
	}
	tbl.close();
	table.close();

	return true;
}