include("get_const.js");

function name_nlgnx9()
{
	return "Розрахунок прибуткового податку (застарів)|Расчет подоходного налога (устарел)";
}

function r_nlgnx9(month, vopl, vidprk, lsfid, lsfid2, ftabn_id)
{
	// дата перехода на новый расчет с 2004 г.
	dtnnal = get_cnst ("datnal", month)
	if (dtnnal!=0)
	{
		return false;
	}
	// -------- min_zp - текущая минимальная ЗП
	var min_zp  = get_cnst ("min_zp" , month);
	// -------- pitan  - сумма на питание, не облагаемая подоходным налогом
	var pitan   = get_cnst ("min_pit", month);
	// -------- kol_min-
	var kol_min = get_cnst ("kol_min", month);
	// -------- proc_s - процент ставки налога с совместителей (вместо 2-й таблицы налога)
	var proc_s  = get_cnst ("proc_s ", month);
	var mnog    = get_cnst ("mnog", month);
	var minimum = get_cnst ("minimum" , month);

	var za_tek_mes = getPar("CUR_PN");
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);	// достаем цифры из прошлого месяца
	var pervMonth = new Date(month.getFullYear(), month.getMonth()-1, 1);
	var szTagPrev = pervMonth.getFullYear()+ ((pervMonth.getMonth()<9)?"0":"") + (pervMonth.getMonth() + 1);        
	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   
	var strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis_slct=" + sqlTrue + " AND fis1=";
	var snap = getSnap(strSQL + sqlTo("п"));
	if(null == snap)
	{
		msg = "Обнаружена серьезная ошибка функционирования системы.\n"
			+ "Hевозможно идентифицировать поле ЛС: подоходн. налог.\n"
			+ "Пригласите разработчиков для устранения";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;
	}
	
	nlgLsfid = snap[0];
	nlgNum = snap[1];
	snap = getSnap(strSQL + sqlTo("s"));
	if(null == snap)
	{
		msg = "Обнаружена серьезная ошибка функционирования системы.\n"
			+ "Hевозможно идентифицировать поле ЛС: под.налог совм.\n"
			+ "Пригласите разработчиков для устранения";
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;
	}
	
	nlgSovLsfid = snap[0];
	nlgSovNum = snap[1];

	var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
	var strPrevTabName = "svzp" + szTagPrev;
	var strMainTabName = "svzp" + szTag;

	if (za_tek_mes)
	{ 
		if(IsTable("tmp_svzp"))
			DropTable("tmp_svzp");
			
		CreateTable("tmp_svzp", "svzpt", "*");
		strPrevTabName = "svzp" + szTag;
		strMainTabName = "tmp_svzp";
	}  

	if(null == getSnap("SELECT COUNT(*) FROM ^" + strPrevTabName + " where 1=1 " + sqlTabn))
		return true;
	var strOffset = IIF("s.fvp=0"
						, 1
						,  IIF("s.fvp=2"
							, "ABS(FLOOR(" +SqlDaysBWDates(sqlTo(D1),"s.fmn")+ "/30.0)) + 1"
							, 0));
	//* включение в налогооблагаемую сумму доходов по месту осн. работы и не по месту осн.работы
	var ssum = "SUM(" + IIF("lf.fis1='+'", "s.fsum", 0) + ")";
	//* включение в налогооблагаемую сумму выплат на питание
	var ssum_p = "SUM(" + IIF("lf.fis1='p'", "s.fsum", 0) + ")";
	//* исключение из налогооблагаемой суммы задолженности г-ву для ЗК
	var ssum_z = "SUM(" + IIF("lf.fis5='г'", "s.fsum", 0) + ")";
	//* включение в налогооблагаемую сумму доходов по совместительству
	var ssum_s = "SUM(" + IIF("lf.fis1='#'", "s.fsum", 0) + ")";
	//* запоминание суммы подоходного налога, удержанного не по месту осн. работы
	var uderg_nlg = "SUM(" + IIF("lf.fis1='-'", "s.fsum", 0) + ")";
	//*--определение, сколько дней раб.в месяце
	var strBDat = "(SELECT MIN(w1.fbdat) FROM ^work_pers AS w1"
				+ " WHERE w1.fwid_cl=w.fwid_cl"
					+ " AND w1.fvopl=w.fvopl)";
	var strEDat = "(SELECT MAX(w2.fedat) FROM ^work_pers AS w2"
				+ " WHERE w2.fwid_cl=w.fwid_cl"
					+ " AND w2.fvopl=w.fvopl)";

	var full_mes = IIF(strBDat + ">" + sqlTo(month) + " OR " + strEDat + "<" + sqlTo(month)
					, sqlFalse
					, sqlTrue);

	//*-------- налогооблагаемый остаток выплат на питание
	var ost_na_pit = IIF(ssum_p + "<>0", 0 ,"-" + sqlTo(pitan));
	//*-------- налогообл.сумма по осн.работе
	var mSUM   = "FLOOR(" + ssum + "+" + ost_na_pit + "-" + ssum_z + ")";
	var prk_proc = IIF("pp.fproc IS NULL OR " + full_mes, 0, "pp.fproc");
	var prk_det = IIF("pd.fproc IS NULL OR " + full_mes, 0, "pd.fproc");
	var l_xxx = IIF(prk_proc + "<>0", prk_proc, prk_det) + "*" + sqlTo(min_zp);
	var mSUM1 = IIF(prk_proc + "<>0"
				, mSUM + "-" + l_xxx
				, IIF(prk_det + "<>0"
					, IIF(mSUM + ">" + sqlTo(kol_min)+"*"+sqlTo(minimum)
						, mSUM
						, mSUM + "-" + l_xxx)
					, mSUM));
	var strTempTableName = getTmpTableName();
	var strSQL = "SELECT s.ftabn_id,pp.fwid_wp, s.fvp"
				+ ", " + mSUM1 + " AS fsum"
				+ ", " + full_mes + " AS full_mes"
				+ ", " + prk_det + " AS prk_det" 
				+ ", " + ssum_s + " AS fsum_s"
				+ ", " + strOffset + " AS offset"
			+ " INTO " + strTempTableName
			+ " FROM (^" + strPrevTabName + " AS s LEFT JOIN ^lic_fld AS lf ON s.flsfid=lf.fid)"
				+ " LEFT JOIN ^work_pers AS w ON s.ftabn_id=w.fwid_cl"
				+ " LEFT JOIN ^prk_all AS pp ON (pp.fwid_wp=w.fwid AND pp.fvid_prk = " + sqlTo(vidprk)
					+ " AND ((pp.fbdat<=" + sqlTo(D1) + " AND pp.fedat>=" + sqlTo(D2) +")" 
					+ " OR (pp.fbdat>=" + sqlTo(D1) + " AND pp.fedat<=" + sqlTo(D2) +")" 
					+ " OR (pp.fedat>=" + sqlTo(D1) + " AND pp.fedat<=" + sqlTo(D2) +")))"
				+ " LEFT JOIN ^prk_det AS pd ON (pd.fwid_wp=w.fwid AND pd.fvid_prk = " + sqlTo(vidprk)
					+ " AND ((pd.fbdat<=" + sqlTo(D1) + " AND pd.fedat>=" + sqlTo(D2) +")" 
					+ " OR (pd.fbdat>=" + sqlTo(D1) + " AND pd.fedat<=" + sqlTo(D2) +")" 
					+ " OR (pd.fedat>=" + sqlTo(D1) + " AND pd.fedat<=" + sqlTo(D2) +")))"
			+ " WHERE " + strOffset + "<>0"
				+ (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
			+ " GROUP BY s.ftabn_id,s.fwid_wp, s.fvp, " + strOffset;
	ExecuteSQL(strSQL);

	strNal = "n.f_basnl + (t.fsum-n.f_stsum)*n.f_proc/100";
	strNal += " + " + IIF("t.full_mes=" + sqlFalse + " AND " +sqlTo(min_zp) + "=n.f_stsum", "n.f_stsum*n.f_proc/100", 0);
	strNal = "(" + strNal + ")/" + IIF("t.prk_det>" + sqlTo(mnog) + " AND t.full_mes=" + sqlFalse, 2, 1);
	strMn = IIF("t.offset>1", "DATE_ADD(" + sqlTo(month) + ", INTERVAL t.offset MONTH)", sqlTo(d00));
	strSQL = "INSERT INTO " + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fday, fis_day, fvid_prk, favt)"
			+ " SELECT t.ftabn_id,t.fwid_wp"
				+ ", " + strNal + " AS fsum"
				+ ", " + nlgLsfid + " AS flsfid"
				+ ", " + nlgNum + " AS ffld_num"
				+ ", " + strMn + " AS fmn"
				+ ", t.fvp"
				+ ", 1 AS fday"
				+ ", 2 as fis_day"
				+ ", " + sqlTo(vidprk) + " AS fvid_prk"
				+ ", " + sqlTrue + " AS favt"
			+ " FROM " + strTempTableName + " AS t LEFT JOIN ^nalog AS n"
				+ " ON n.f_stsum = (SELECT MAX(n1.f_stsum) FROM ^nalog As n1 WHERE n1.f_stsum<t.fsum"
					+ " AND  n1.f_tbl=1 AND ((n1.fbdat<=" + sqlTo(D1) + " AND n1.fedat>=" + sqlTo(D2) + ")" 
									+ " OR (n1.fbdat>=" + sqlTo(D1) + " AND n1.fbdat<=" + sqlTo(D2) +")" 
									+ " OR (n1.fedat>=" + sqlTo(D1) + " AND n1.fedat<=" + sqlTo(D2) +")))"

	ExecuteSQL(strSQL);
	strSQL = "INSERT INTO " + strMainTabName + " (ftabn_id,fwid_wp, fsum, flsfid, ffld_num, fmn, fvp, fday, fis_day, fvid_prk, favt)"
			+ " SELECT t.ftabn_id,t.fwid_wp"
				+ ", "+sqlRound("t.fsum_s*" + proc_s + "/100",2)+" AS fsum"
				+ ", " + nlgSovLsfid + " AS flsfid"
				+ ", " + nlgSovNum + " AS ffld_num"
				+ ", " + strMn + " AS fmn"
				+ ", t.fvp"
				+ ", 2 AS fday"
				+ ", 2 as fis_day"
				+ ", " + sqlTo(vidprk) + " AS fvid_prk"
				+ ", " + sqlTrue + " AS favt"
			+ " FROM " + strTempTableName + " AS t LEFT JOIN ^nalog AS n"
				+ " ON n.f_stsum = (SELECT MAX(n1.f_stsum) FROM ^nalog As n1 WHERE n1.f_stsum<t.fsum"
					+ " AND  n1.f_tbl=1 AND ((n1.fbdat<=" + sqlTo(D1) + " AND n1.fedat>=" + sqlTo(D2) + ")" 
									+ " OR (n1.fbdat>=" + sqlTo(D1) + " AND n1.fbdat<=" + sqlTo(D2) +")" 
									+ " OR (n1.fedat>=" + sqlTo(D1) + " AND n1.fedat<=" + sqlTo(D2) +")))"
	ExecuteSQL(strSQL);
	if (za_tek_mes)
	{ 
		ExecuteSQL("INSERT INTO ^svzp" + szTag + getColumn("tmp_svzp", true) 
				+ " SELECT " + getColumn("tmp_svzp", false) + " FROM tmp_svzp");
				
		DropTable("tmp_svzp");
	}
	 
	return true;
}