//отдельный расчет базы для удержания пенсионного фонда для новой персонификации
//вызывается из r_allst. Нужно указать код статистики любой не равный 0, чтобы r_allst заработала.
include("get_cnst.js")
include("servis\\date.js")

function r_pnfpro (month,vvopl,vvprk)
{ 
   //только для базового месяца считаем
   if (differ(month, base_month)!=0) return;
	
   if (month.getMonth() < 9)  
      szTag = String(month.getFullYear()) + "0"+String(month.getMonth()+1);
   else
      szTag = String(month.getFullYear()) + String(month.getMonth()+1);  
		
   if (!IsTableEx("ZRP_RES", "ZRP_SVZP"+szTag))
		return;
		
   tbl_SVZP = OpenTable("select * from ^SVZP"+szTag+" order by Ftabn_id,Fmn,Fvp");

   var gr_pns = get_cnst("gr_pns", month);
   var proc_pns1 = get_cnst("proc_pns1", month)/100;
   var pns1000 = get_cnst("pns1000", month);
   var sum_ogr = get_cnst("sum_ogr", month);
   if(!sum_ogr)
   {
		msg = ru("Не найдена константа суммы ограничения sum_ogr за",
				"Не знайдено константу граничної суми sum_ogr за")+format(" dd.mm.yyyy",month).toLowerCase();
		writeToLog(msg,"e",vvopl,vvprk);
   }
 
   var D1 = new Date(firstDayMonth(month));
   var D2 = new Date(lastDayMonth(D1));

   fld_founbp = false;
   strSQL = "SELECT fid, ffld_num FROM ^lic_fld WHERE fis12='1' AND fis_slct=" + sqlTrue+" ORDER BY fid";
   snap = getSnap(strSQL);
   if(null == snap)
   { 
		msg = "Hельзя идентиф.поле ЛС: база для пенс.фонда\n"
			+ "Если есть необх.в выведении в ЛС базы ПФ,\n"
			+ "поставьте цифру <1> в 12-ю колонку таблицы вхожд-я полей";
		writeToLog(msg,"w",vvopl, vvprk);
   }
   else
   {
		fld_founbp = true;
		nach_lsfbp = snap[0];
		nach_lsnbp = snap[1];
   }

   if (!fld_founbp) 
 	return false;

   if(IsTable("tmp_svzp"))
		DropTable("tmp_svzp");
   CreateTable("tmp_svzp", "svzpt");
   tbl_SVZPT = OpenTable("s", "tmp_svzp")

   var is_rasch=(differ(base_month,month)==0)
   if (is_rasch){
      ExecuteSQL("DELETE from ^NXT where Fmn="+sqlTo(month)+" and Flsfid="+sqlTo(nach_lsfbp))
   }

   //tbl_nxt = OpenTable("s", "NXT", "NXT_MN"); 

     //*----------------------------- PUNKT11 ----------------------------------- 
   var ssum1 = new Array(12)
   var ssum3 = new Array(12)
   var ssum5 = new Array(12)
   var ssum8 = new Array(12)
   var ssumbon = new Array(12)
   var max_offset = 12  

   var offset;
   var mn_vip, mn_voz;
   var Ful_mes;

   tbl_SVZP.MoveFirst();
   sv_tabn    = Number(tbl_SVZP.getValue("Ftabn_id"))
   while (!tbl_SVZP.IsEOF()){
      for (var iii=0; iii<=12; iii++){ 
         ssum1[iii]    = 0
         ssum3[iii]    = 0
         ssum5[iii]    = 0
         ssum8[iii]    = 0
      }  

      while ((!tbl_SVZP.IsEOF()) && (Number(tbl_SVZP.getValue("Ftabn_id"))==sv_tabn)){ 
            switch(Number(tbl_SVZP.getValue("Fvp"))){
               case 0:
                  mn_vip=month
                  mn_voz=month
                  offset = 1
                  break;
               case 1:
                  mn_vip=new Date(tbl_SVZP.getValue("Fmn"))
                  mn_voz=month
                  offset = 0
                  break;
               case 2:
                  mn_vip=month
                  mn_voz=new Date(tbl_SVZP.getValue("Fmn"))
                  offset = Math.round(day_difference(mn_vip,mn_voz)/30)+1  
                  break;
            }

            mFlsfid = Number(tbl_SVZP.getValue("Flsfid"))
            mFsum   = Number(tbl_SVZP.getValue("Fsum"))

  	        var fld_mrk  = "";
       	    var fld_mrk3 = "";
            strSQL = "SELECT Fis8,Fis9 FROM ^LIC_FLD WHERE Fid="+sqlTo(mFlsfid);
			gS = getSnap(strSQL);
            if(gS != null)
            {
	            //* пpизнак входимости в налогооблагаемую сумму 
    	        var fld_mrk  = gS[0];
        	    var fld_mrk3 = gS[1];
            }
	        if (offset > 0){
               ssum1[offset] = (fld_mrk=="+" && fld_mrk3!="б")? ssum1[offset] + mFsum: ssum1[offset]
               ssum3[offset] = (fld_mrk=="*" && fld_mrk3!="б")? ssum3[offset] + mFsum: ssum3[offset]
               ssum5[offset] = (fld_mrk=="&" && fld_mrk3!="б")? ssum5[offset] + mFsum: ssum5[offset]
               ssum8[offset] = (fld_mrk=="?" && fld_mrk3!="б")? ssum8[offset] + mFsum: ssum8[offset]
            }
//            alert(ssum1[offset])
            tbl_SVZP.MoveNext();
      }

    
      if (fld_founbp){
         ii = 1
         while (ii <= max_offset){
            xx = ssum1[ii]+ssum3[ii]+ssum5[ii]+ssum8[ii]
            if (xx==0 && ssumbon[ii]==0){
               ii = ii+1
               continue
            }
            //не удерживать ПФ 03.02.10 проверить  
			var osn = getSnap("SELECT p.Ftabn_id FROM ^prk_all as p inner join ^prk_notcalc as c on p.Fwid=c.Fwid"
						+" WHERE p.Ftabn_id="+sqlTo(sv_tabn)+" and (c.Fnot_pf=" + sqlTrue + ") "
							+" AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1) )
			//если нет в приказе, то считаем базу				
            if (osn==null){
               if (xx!=0){  
                  if (pns1000 == 1 && sum_ogr>0) xx = (xx>sum_ogr)? sum_ogr: xx
               }
            }else{
            	xx = 0
            }
            
            //09.12.09
            if (xx!=0){
                  if (ii > 1){ 
                     mFmn = new Date(month.getFullYear(),month.getMonth()+ii-1,1).getVarDate() 
                     mFvp = 2
                  }else{ 
                     mFmn = d00obj.getVarDate()
                     mFvp = 0
                  }  
		  		  var m = new Object(); 
                  m.Ftabn_id = sv_tabn
                  m.Fsum = xx
                  m.Flsfid = nach_lsfbp
                  m.Ffld_num = nach_lsnbp
                  m.Fmn = mFmn
                  m.Fvp = mFvp
                  m.Fday = 0
                  m.Fis_day = 0
                  m.Fvid_prk = 0
                  m.Favt = false;
				  UpdateTable("tmp_svzp",m,true)

                  //------запись в NXT--------------------------
                  if (is_rasch && ii>1){
                     if (differ(mFmn,d00obj)!=0){
		        var m = new Object(); 
	                m.Ftabn_id=sv_tabn;
        	        m.Flsfid=nach_lsfbp;
                	m.Ffld_num=nach_lsnbp;
	                m.Fwid_wp=0;
        	        m.Fshpz="";
                	m.Fsum=xx;
	                m.Fis_day=0;
        	        m.Fday=0;
                	m.Fchas=0;
	                m.Fmn=month.getVarDate();
	                m.Fmn1=mFmn;
	                m.Fid_prk=0;
               		UpdateTable("^NXT",m,true)        
        	     }  
              } 
            }

            ii = ii+1
         } // end of   while (ii < max_offset) 
      }  // end of if (fld_founbp) 


      svzp_eof=tbl_SVZP.IsEOF()
      if(!svzp_eof)  sv_tabn    = Number(tbl_SVZP.getValue("Ftabn_id"))

   } 
    
   // выборка из  NXT 
   if (is_rasch){
         tbl_nxt = OpenTable("s", "select * from ^NXT where Fmn1="+sqlTo(month)+" and Flsfid="+sqlTo(nach_lsfbp));
         if (!tbl_nxt.IsEmpty()){ 
            tbl_nxt.MoveFirst(); 
            while (!tbl_nxt.IsEOF()){
                  m = new Object();    
                  m.Ftabn_id   = tbl_nxt.getValue("Ftabn_id");
                  m.Fwid_wp    = 0;                  
                  m.Fsum    = -tbl_nxt.getValue("Fsum");
                  m.Flsfid  = tbl_nxt.getValue("Flsfid")
                  m.Ffld_num= tbl_nxt.getValue("Ffld_num")
                  m.Fmn     = tbl_nxt.getValue("Fmn")
                  m.Fvp = 1
                  m.Fday = tbl_nxt.getValue("Fday")
                  m.Fis_day = 0
                  m.Fvid_prk = 0
                  m.Favt = false;
              	  UpdateTable("tmp_svzp",m,true)        
                  tbl_nxt.MoveNext();
            }
         }
   		 tbl_nxt.close();         
   } 


   // перенос из временной таблицы
   if (fld_founbp){
       //не удалять записи по перерасчету из r_compro
       ExecuteSQL("delete from ^svzp"+szTag+" where Flsfid="+sqlTo(nach_lsfbp)+" and not(Fvp=2 and Fmn<"+sqlTo(month)+")")
   }
   
   ExecuteSQL("INSERT INTO ^svzp" + szTag + getColumn("tmp_svzp",true) + 
		" SELECT " + getColumn("tmp_svzp",false) + " FROM tmp_svzp");
		
   //DropTable("tmp_svzp");

   return;
}