//расчет суммы на месяц, не зависящей от оклада
function name_prk1()
{
	return "Сумова надбавка, яка не залежить від відпрацьованого часу|Суммовая надбавка, не зависящая от отработанного времени";
}

function r_prk1 (month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	var strTabName = (svzpName?svzpName:"svzp") + (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);
	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   
    
	if(!IsTableEx("zrp_mdb", "zrp_prk1"))
	{ 
		return;
	}
    
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
    var strPrk = "^prk_all AS p INNER JOIN ^work_pers AS w ON p.fwid_wp=w.fwid"
    			+ " WHERE p.fvid_prk=" + sqlTo(vidprk) 
    				+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
    				+ sqlTabn;

	if(vopl < 9000)
		strPrk += " AND w.fvopl=" + sqlTo(vopl); 

// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTable(strPath + ".zrp_" + strTabName, "svzp", "*");
	}

//Вставка записей из приказа в таблицу расчета зарплаты. 
	var strSQL  = "insert into ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz, fsum"
		 			+ ", ffld_num, flsfid"
		 			+ ", fis_day, fday"
		 			+ ", fchas, fmn"
		 			+ ", fvp, fid_prk, fvid_prk)"
 				+ " select w.fwid_cl,p.fwid_wp"
		 			+ ", p.fshpz, p.fsum"
		 			+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid)  + ")", 0) + " as ffld_num"
		 			+ ", " + sqlTo(lsfid) + " as flsfid"
		 			+ ",0 as fis_day"
		 			+ ", "+IIF("Fproc>0",sqlRound("Fproc/1000",0),"0")+" as fday"
		 			+ ", "+IIF("Fproc>0","Fproc-"+sqlRound("Fproc/1000",0)+"*1000","0")+" as fchas"
		 			+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
		 			+ ", p.fwid as fid_prk"
		 			+ ", " + sqlTo(vidprk)+ " as fvid_prk"
	 			+ " from " + strPrk;
	ExecuteSQL(strSQL);

    if(!getPar("KOMKOLD")){
    	return true;
    }
	
	var oSnap = getSnap("SELECT Fuse_rkm FROM ^CL_PRIK WHERE Fvid="+sqlTo(vidprk))
	if(oSnap==null || (oSnap!=null && !oSnap[0]))
	{
		return;
	}
	
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);	
	svnrTableName = "svnr" + szTag;
	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
	{
		//var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
	}
	
	var strSQL  = "insert into ^"+svnrTableName
		+ "( ftabn_id,fwid_wp"
		+ ", fsum"
		+ ", ffld_num, flsfid"
		+ ", fmn, fvp)"
	+ " select w.fwid_cl,p.fwid_wp"
		+ ", p.fsum"
		+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid)  + ")", 0) + " as ffld_num"
		+ ", " + sqlTo(lsfid) + " as flsfid"
		+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	+ " from " + strPrk;
	ExecuteSQL(strSQL);

}