//расчет суммовых надбавок на доход, зависящие от отработанного времени
//полный аналог r_prk2 + в поле дней пишется разность дней между датой начала и конца приказа,
//чтоб можно было в лицевых счетах определять это надбавка за полный месяц или за часть
//в случае если дата конца больше чем конец месяца, тогда нужно считать кол-во дней от даты начала до конца месяца
//(реализован по просьбе Укртелекома) 
 
function name_prk2dn()
{
	return "Сумова надбавка, яка залежить від відпрацьованого часу|Суммовая надбавка, зависящая от отработанного времени";
}

function r_prk2dn(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);        

	// дата начала
	var D1 = month;
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   

	var szName = "zrp_stt1" + szTag;
	var siName = "^stt1" + szTag;
	var tiName = "^tbl" + szTag;
	var strTabName = (svzpName?svzpName:"svzp") + szTag;
      
	if(!IsTableEx("zrp_mdb", szName))
	{ 
		msg = "Не введены табеля за " + szTag;
		writeToLog(msg,"e",vopl, vidprk, lsfid);
		return false;
	}

// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
		var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res", "zrp_" + strTabName, "svzp", "*");
	}
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
	var strSQL = "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz, fsum"
		 			+ ", ffld_num, flsfid"
		 			+ ", fbdy, fedy"
		 			+ ", fis_day, fday"
		 			+ ", fchas, fmn"
		 			+ ", fvp, fid_prk, fvid_prk)"
				+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp, p.fshpz AS fshpz"
				+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
							, 1 
							, IIF("st.fis_tabel=" + sqlTo("+")
								, IIF("tb2.fchasnvk=0"
									, "tb2.fday_nvk/tb.fday_nvk"
									, "tb2.fchasnvk/tb.fchasnvk")
									, 0)
								)+ "*p.fsum",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
	 			+ ", " + sqlTo(lsfid) + " as flsfid"
				+ ", st.fbdat AS fbdy, st.fedat AS fedy"
				+ ", " + IIF("ti.fnorma_ch<>0", sqlTrue, sqlFalse) + " AS  fis_day"
				+ ", " + IIF("st.fis_tabel=" +sqlTo("*"),
						"(select count(r.fwid) as wid from ^hcalend as h inner join ^rcalend as r on h.fwid=r.fid_cal " +
							"where r.fdate>=p.fbdat and r.fdate<=p.fedat and r.fdate>="+sqlTo(D1)+" and r.fdate<="+sqlTo(D2)
								+" and r.fattr = 'Р' and h.Fcod=(select MIN(cal.Fcod) from ^cl_calend as cal))"
						,"tb2.fday_nvk") + " as fday"
				+ ", 0 AS fchas"
	 			+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
	 			+ ", p.fwid as fid_prk"
				+ ", " + sqlTo(vidprk)+ " as fvid_prk"
				+ " FROM (((^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid)"
					+ " INNER JOIN ^stru_dol AS d ON d.fwid=w.fwid_dol)"
					+ " INNER JOIN ^tbl_ini AS ti ON ti.fvopl=w.fvopl)"
					+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
								+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') 
								+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') + ")"
					+ " LEFT JOIN " + tiName + " AS tb ON (st.fwid_wp=tb.fwid_wp AND tb.fbdat=st.fbdat AND tb.fedat=st.fedat and tb.fkod_nvk=1)"
					+ " LEFT JOIN " + tiName + " AS tb2 ON (st.fwid_wp=tb2.fwid_wp AND tb2.fbdat=st.fbdat AND tb2.fedat=st.fedat and tb2.fkod_nvk=2)"
				+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
	    			+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
	    			+ sqlTabn
					+ " AND ti.fbdat=" + sqlTo(D1);

	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 

	ExecuteSQL(strSQL);

    if(!getPar("KOMKOLD")){
    	return true;
    }
	
	var oSnap = getSnap("SELECT Fuse_rkm FROM ^CL_PRIK WHERE Fvid="+sqlTo(vidprk))
	if(oSnap==null || (oSnap!=null && !oSnap[0]))
	{
		return;
	}
	
	svnrTableName = "svnr" + szTag;
	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
	{
		//var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
	}
	
	var strSQL = "INSERT INTO ^"+svnrTableName 
		+ "( ftabn_id,fwid_wp"
		+ ", fsum"
		+ ", ffld_num, flsfid"
		+ ", fmn, fvp)"
		+ " SELECT w.fwid_cl as ftabn_id,p.fwid_wp as fwid_wp"
		+ ", " + sqlRound(IIF("st.fis_tabel=" +sqlTo("*")
				, 1 
				, IIF("st.fis_tabel=" + sqlTo("+"),1,0)
					)+ "*p.fsum",2)+" AS fsum"
				+ ", " + IIF(sqlTo(lsfid) + "<>0", "(SELECT l.ffld_num FROM ^lic_fld AS l WHERE l.fid=" + sqlTo(lsfid) + ")", 0) + " as ffld_num"
				+ ", " + sqlTo(lsfid) + " as flsfid"
		+ ", " + sqlTo(d00)+" as fmn, 0 as fvp"
		+ " FROM (^prk_all AS p LEFT JOIN ^work_pers AS w ON p.fwid_wp=w.fwid)"
		+ " LEFT JOIN " + siName + " AS st ON (p.fwid_wp=st.fwid_wp AND p.fbdat<=" 
		+ toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fbdat') 
		+ " AND p.fedat>=" + toSqlDate(month.getFullYear(), month.getMonth()+1,'st.fedat') + ")"
				+ " WHERE p.fvid_prk=" + sqlTo(vidprk)
				+ " AND p.fbdat<=" + sqlTo(D2) + " AND p.fedat>=" + sqlTo(D1)
				+ sqlTabn
	if(vopl < 9000)
		strSQL += " AND w.fvopl=" + sqlTo(vopl); 

ExecuteSQL(strSQL);
	
	return true;
}