//расчет % надбавок за замещение другого сотрудника
//используется с приказом _prk55
//для замещения ЧТСников нужно считать сумму без деления на норму, для определения принадлежности 
//вида оплаты к ЧТС будем использовать список "Признаки видов оплаты для больничных" таблица OPL_PRIZ
//для ЧТС признак должен быть равен 2 и важно чтобы у человека который замещает были проставлены часы в табеле

function name_prk4t()
{
	return "% надбавка за заміщення іншого співробітника|% надбавка за замещение другого сотрудника";
}

function r_prk4t (mdat,vvopl,vvprk,mvvcslid,mvvcslid2,ftabn_id,svzpName)
{ 
   //var DefVed = new DpDefVed();
   var table,szTag,szName,tblOut, prop;
   // достаем цифры к названию файла
   if (mdat.getMonth() < 9)  
      szTag = String(mdat.getFullYear())+"0"+String(mdat.getMonth()+1);
   else
      szTag = String(mdat.getFullYear())+String(mdat.getMonth()+1);        

   // дата для фильтрации записей таблицы "TBL_INI"
   //   var DatePer = new Date(mdat.getFullYear(),mdat.getMonth(),1) 
   
   // дата начала
   var D1 = new Date(mdat.getFullYear(),mdat.getMonth(),1); 
   
   // дата конца
  // var DD2 = new Date(mdat.getFullYear(),mdat.getMonth()+1,0).getDate() 
   var D2 = new Date(lastDayMonth(mdat)); 

   szName = "zrp_STT1"+szTag;
   tiName = "TBL"+szTag;
   siName = "STT1"+szTag;

   var mas = new Array();
   mas[0] = "CH_TBL1_PRK4";
   mas[1] = "CH_TBL2_PRK4";
   mas[2] = "CH_SVZP";
      
   if(!IsTableEx("zrp_mdb", szName))
   { 
	  msg = "Не введены табеля за "+szTag;
	  writeToLog(msg,"e",vvopl,vvprk,mvvcslid);
      return;
   }
   // Проверяем существует ли у нас таблица "svzp" + szTag, если нет, то создаем ее
   // по шаблону "svzp"
   tblOut = "zrp_" + (svzpName?svzpName:"svzp") + szTag
   if (!IsTableEx("zrp_res", tblOut))
	      CreateTableEx("zrp_res", tblOut, "svzp", "*")

	var sqlTabn = ftabn_id?" and A.Ftabn_id in ("+ftabn_id+") ":"";
   if(IsTable(mas[0])) DropTable(mas[0]);
//оТБИРАЕМ С ПРИКАЗА ДАННЫЕ, ПАРАЛЛЕЛЬНО ВЫТЯГИВАЕМ ПРИЗНАК ТАБЕЛЯ
//И ПО НОРМЕ И ФАКТИЧЕСКИ ДЛЯ ВИДА ОПЛАТ
	var StrSQL="SELECT A.*,P.FTABN_ID2,P.FWID_WP2,B.FIS_TABEL as fis_tabel"
					 +" INTO " + mas[0]
					 +" FROM (((^prk_all AS A INNER JOIN ^prk4 AS P ON A.Fwid=P.Fwid) LEFT JOIN ^"+siName+" AS B"
					 +" ON A.FWID_WP=B.FWID_WP) INNER JOIN ^WORK_PERS AS W ON W.FWID=A.FWID_WP)"
					 +" WHERE A.FVID_PRK = " + sqlTo(vvprk)
                     +" AND A.FBDAT <= " + sqlTo(D2) + " AND A.FEDAT >= " + sqlTo(D1) + sqlTabn
	StrSQL+=(vvopl<9000)?" AND W.FVOPL = " + sqlTo(vvopl):"";//Анализ вид оплата
	ExecuteSQL(StrSQL)
	var tempty=OpenTable(mas[0]);
	if(tempty.IsEmpty()){
		tempty.Close(5652);
		return true;
	}else 	tempty.Close(5652);
	if(IsTable(mas[1])) DropTable(mas[1]);
	//Проставляем для вида оплаты по норме
	ExecuteSQL("SELECT A.*"
				 //по часам не учитываем вообще
				 +",C.FNORMA_CH,"
				 //+",0 AS FNORMA_CH,"
				 +"C.FNORMA_D,"
				 +"C.FVSEGO_CH,"
				 //+"0 AS FVSEGO_CH,"
				 +"C.FVSEGO_D,"
				 +"0 AS FTABLE"
				 +" INTO " + mas[1]
				 +" FROM " + mas[0] + " AS A INNER JOIN ^WORK_PERS AS W ON W.FWID=A.FWID_WP2"
				 +" LEFT JOIN ^TBL_INI AS C ON W.FVOPL=C.FVOPL"
				 +" WHERE C.FBDAT="+sqlTo(D1)
			 )
	if(IsTable(mas[0])) DropTable(mas[0]);
	ExecuteSQL("SELECT DISTINCT * INTO " + mas[0] + " FROM " + mas[1])
		//ПРОСТАВЯЕМ ОКЛАД ТАБЕЛЯ ИСТОЧНИКА
	ExecuteSQL("UPDATE " + mas[0]
				+" SET FSUM=(SELECT D.FOKLAD FROM ^WORK_PERS AS B INNER JOIN ^STRU_DOL AS D ON D.FWID=B.FWID_DOL"
					+" WHERE B.FWID=" + mas[0] + ".FWID_WP2),"
				+" FTABLE=(SELECT B.FTABLE FROM ^WORK_PERS AS B "
					+" WHERE B.Fwid=" + mas[0] + ".fwid_wp2)")
		//ТЕХ У КОГО ТАБЕЛЬ НЕ ПОЛНЫЙ ИЛИ РАЗБИТ
	var t_prk4=OpenTable("s","SELECT m.*, o.Fprizn FROM " + mas[0] + " as m INNER JOIN ^work_pers as w ON m.Fwid_wp2=w.Fwid LEFT JOIN ^opl_priz as o ON w.Fvopl=o.Fvopl WHERE FIS_TABEL='+'");
	if(!t_prk4.IsEmpty())
	{
		for(t_prk4.MoveFirst();!t_prk4.IsEOF();t_prk4.MoveNext())
		{
			//пОДБИВАЕМ ДНИ фактически за период
			var StrSQL="SELECT SUM(Fchasnvk) AS FVSEGO_CH,SUM(FDAY_NVK) AS FVSEGO_D"
					 //+",FTABN"
					 +" FROM ^"+tiName
					 +" WHERE FBDAT>="+(new Date(differ(t_prk4.getValue("FBDAT"),D1)>=0?t_prk4.getValue("FBDAT"):D1)).getDate()
					 +" AND FEDAT<="+(new Date(differ(t_prk4.getValue("FEDAT"),D2)<=0?t_prk4.getValue("FEDAT"):D2)).getDate()
					 +" AND FKOD_NVK=2"
					 +" AND Fwid_wp="+t_prk4.getValue("Fwid_wp")
					 //+" GROUP BY FTABN"
			var t_fackt=OpenTable("s",StrSQL);
			if(!t_fackt.IsEmpty())
			{
				var m = new Object();
				m.FVSEGO_D = t_fackt.getValue("FVSEGO_D");
				//если человек, которого замещают ЧТСник, то на норму не делим, для остальных обнуляем часы
				if(t_prk4.getValue("Fprizn") == 2)
				{
					m.FNORMA_CH = 1;
					m.FNORMA_D = 1;
					m.FVSEGO_CH = (t_fackt.getValue("FVSEGO_CH")==null)?0:t_fackt.getValue("FVSEGO_CH");
				}
				else
				{
					m.FNORMA_CH = 0;
					m.FVSEGO_CH = 0;
				}
				UpdateTable(mas[0],m,false," fwid="+ sqlTo(t_prk4.getValue("Fwid")));
			}
			t_fackt.Close();
		}
	}
	
	t_prk4.Close();
    CreateTable(mas[2], "svzp", "*")
    
	StrSQL=" INSERT INTO " + mas[2] + " ( FTABN_ID,FWID_wp,FSHPZ,FFLD_NUM, FLSFID,FBDY, FEDY, FID_PRK, FIS_DAY, FDAY, FCHAS,  FMN, FVP, FSUM, FPR, FVID_PRK, FPROC) "
			+" SELECT A.FTABN_ID,A.Fwid_wp,A.FSHPZ,0 AS FFLD_NUM";
	StrSQL+=(mvvcslid2>0)?","+IIF("A.FTABLE=1",mvvcslid,mvvcslid2):","+mvvcslid;
	StrSQL+=" AS FLSFID,"+SqlDay("A.FBDAT")+" AS FBDY,"+SqlDay("A.FEDAT")+" AS FEDY,A.FWID AS FID_PRK"
			+","+IIF("A.FVSEGO_CH>0","1","0") + " AS FIS_DAY,A.FVSEGO_D AS FDAY,A.FVSEGO_CH AS FCHAS"
			+","+sqlTo(d00)+" AS FMN,0 AS FVP,"
			+sqlRound("A.FSUM*A.FPROC*" + IIF("A.FVSEGO_CH>0","A.FVSEGO_CH","A.FVSEGO_D")
			+"/(" + IIF("A.FVSEGO_CH>0 AND A.FNORMA_CH>0","A.FNORMA_CH","A.FNORMA_D") + "*100)",2)
			+" AS FSUM, 0 as FPR, "
			+" Fvid_prk, Fproc"
			+" FROM " + mas[0] + " AS A"
	ExecuteSQL(StrSQL);
//Проставляем код ЛС
	StrSQL="UPDATE " + mas[2]
				+" SET FFLD_NUM=(SELECT B.FFLD_NUM FROM ^LIC_FLD AS B WHERE " + mas[2] + ".FLSFID=B.FID)"
	ExecuteSQL(StrSQL);
	//ЗАПИСЫВАЕМ В БАЗУ
	StrSQL="INSERT INTO ^"+(svzpName?svzpName:"svzp") + szTag+"(FTABN_ID,FWID_wp,FSHPZ,FFLD_NUM, FLSFID,FBDY, FEDY, FID_PRK, FIS_DAY, FDAY, FCHAS,  FMN, FVP, FSUM, FPR, FVID_PRK, FPROC) "
			+" SELECT FTABN_ID,FWID_wp,FSHPZ,FFLD_NUM, FLSFID,FBDY, FEDY, FID_PRK, FIS_DAY, FDAY, FCHAS,  FMN, FVP, FSUM, FPR, FVID_PRK, FPROC "
			+" FROM " + mas[2] + " WHERE FSUM>0"
	ExecuteSQL(StrSQL);
   return;
}