// контроль правильности и исправление данных по удержаниям за кредит

//Все данные, которые раньше записывались в PRK_ZD_U теперь переносятся и апдейтятся 
//в PRK_ALL с признаком Fin_table='PRK_ZD_U'

function name_prk_zd()
{
	return "Контроль наказів по утриманнях по кредиту|Контроль приказов по удержаниям по кредиту";
}

function r_prk_zd(rasch_mes,opl,prk,lsfid,lsfid2,ftabn_id,svzpName)
{ 
  msg = "Проводится контроль приказов по удержаниям по кредиту";
  writeToLog(msg,"m",opl,prk,lsfid);
  
  var cbas_mbeg = new Date(firstDayMonth(new Date(base_month))); 
  var cbas_mend = new Date(lastDayMonth(new Date(base_month))); 

  var sqlTabn = ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":"";
  //бывшая PRK_ZD
  var ZD_table = OpenTable("SELECT * FROM ^PRK_ALL"
                          //+" WHERE Fvid_prk="+sqlTo(prk)+" AND Fbdat<=" + sqlTo(cbas_mend.getVarDate())
                          +" WHERE Fin_table='PRK_ZD' AND Fbdat<=" + sqlTo(cbas_mend.getVarDate())
                          +" AND Fedat>=" + sqlTo(cbas_mend.getVarDate())
                          +sqlTabn);  
                          
  var ZD = new Object();
  var ZD_U = new Object();                
  if(!ZD_table.IsEOF())
  	 ZD_table.MoveFirst()
  
  //var ZD_U_table = OpenTable("s","SELECT * FROM ^PRK_ZD_U order by Fid,Fbdat")
  //var ZD_U_table = OpenTable("s","SELECT * FROM ^PRK_ALL WHERE Fin_table='PRK_ZD_U' ORDER by Fid,Fbdat")

  while(!ZD_table.IsEOF())
  {
    var mFwid_wp = ZD_table.getValue("Fwid_wp")
    var mFid   = ZD_table.getValue("FWID") // ?? ZD_table("Fid")
    var mFbdat = new Date(ZD_table.getValue("Fbdat"))
    var mFedat = new Date(ZD_table.getValue("Fedat"))
    var mFsum  = Number(ZD_table.getValue("Fsum"))
    var mFproc = Number(ZD_table.getValue("Fproc"))
   
   // ZD_U_table.FindFirst("Fid=" + sqlToFind(mFid));
    strSQL = "SELECT * FROM ^PRK_ALL WHERE Fin_table='PRK_ZD_U' AND Fid="+sqlTo(mFid)+" ORDER by Fid,Fbdat"
    var tzd = OpenTable(strSQL);
    
    //while((!ZD_U_table.IsEOF()) && (ZD_U_table.getValue("Fid") == ZD_table.getValue("FWID")))   //(ZD_U_table("Fid") == ZD_table("Fid")))
    while (!tzd.IsEOF()) 
    {
       if (mFsum != tzd.getValue("Fsum"))
       { 
         	ZD_U = new Object();
          	ZD_U.Fsum = mFsum
			//UpdateTable("^PRK_ZD_U",m,false," fwid=" + sqlTo(ZD_U_table.getValue("FWID")));
			UpdateTable("^PRK_ALL",ZD_U,false," fwid=" + sqlTo(tzd.getValue("FWID")));
       }
       if (Number(tzd.getValue("Fsum")) < Number(tzd.getValue("Fproc")))
       { 
			ZD_U = new Object();
	        ZD_U.Fproc = tzd.getValue("Fsum")
			//UpdateTable("^PRK_ZD_U",m,false," fwid=" + sqlTo(ZD_U_table.getValue("FWID")));
			UpdateTable("^PRK_ALL",ZD_U,false," fwid=" + sqlTo(tzd.getValue("FWID")));
       }
       mFsum = mFsum - Number(tzd.getValue("Fproc"))
       tzd.MoveNext();
    }
     
    var ssum_ud  = (mFsum < mFproc)? mFsum : mFproc
   
    var cdat_ud  = new Date(base_month.getFullYear(),base_month.getMonth(),1) 
    var cdat_chr = cdat_ud.getVarDate();

    tzd.FindFirst("Fid=" + sqlToFind(mFid)+" AND FBDAT="+sqlTo(cdat_chr));

    ssum_ud = (ssum_ud <=0)? 0: ssum_ud

    var m_mFedat = new Date(mFedat.getFullYear(),mFedat.getMonth(),1) 
    var d_d00 = new Date(d00);

    if ((cdat_ud <= m_mFedat) || (!differ(cdat_ud,d_d00)))
    { 
       //если дата генерируемой записи не превышает дату конца
       if (!tzd.FindFirst("Fid=" + sqlToFind(mFid)+" AND FBDAT="+sqlTo(cdat_chr)))
       {
//          ZD_U_table.AddNew();	
			var 	f = true;
          ZD_U = new Object();
          ZD_U.Fin_table = "PRK_ZD_U";
          ZD_U.Ftabn_id  = ZD_table.getValue("Ftabn_id");          
          ZD_U.Fwid = GetUID();
          ZD_U.Fsum = mFsum
          ZD_U.Fproc = ssum_ud
//          ZD_table.Edit();
			ZD = new Object();
          //ZD.Fnom_prik = mFsum - ssum_ud
          ZD.Fnom_prik = String(round(mFsum - ssum_ud,2))
          ZD.Fdat_prik = cbas_mend.getVarDate();
//          ZD_table.Update();
			//бывшая PRK_ZD
			UpdateTable("^PRK_ALL",ZD,false," Fwid=" + sqlTo(ZD_table.getValue("Fwid")));
       }
       else
       {
//          ZD_U_table.Edit();
			var  f = false;
			ZD_U = new Object();
//          ZD_table.Edit();
			ZD = new Object();
          //ZD.Fnom_prik = mFsum
          ZD.Fnom_prik = String(round(mFsum,2))
          ZD.Fdat_prik = cbas_mend.getVarDate();
//          ZD_table.Update();
			//бывшая PRK_ZD
			UpdateTable("^PRK_ALL",ZD,false," fwid="+sqlTo(ZD_table.getValue("Fwid")));
       } 
       ZD_U.Fbdat = cbas_mbeg.getVarDate();
       ZD_U.Fedat = cbas_mend.getVarDate();
       ZD_U.Fwid_wp = ZD_table.getValue("Fwid_wp");
//       var oSnap = getSnap("SELECT Fwid_cl FROM ^work_pers WHERE Fwid="+sqlTo(ZD_table.getValue("Fwid_wp")))
//       if(oSnap!=null)
//       		ZD_U.Fwid_cl = oSnap[0];
//       ZD_U.Flv1 = ZD_table.getValue("Flv1")
//       ZD_U.Flv2 = ZD_table.getValue("Flv2")
//       ZD_U.Flv3 = ZD_table.getValue("Flv3")
//       ZD_U.Flv4 = ZD_table.getValue("Flv4")
    //   ZD_U.Fsht_id = ZD_table.getValue("Fsht_id")
       ZD_U.Fvid_prk = ZD_table.getValue("Fvid_prk")
       ZD_U.Fvopl = ZD_table.getValue("Fvopl")
       ZD_U.Fid = ZD_table.getValue("FWID")         //ZD_U_table("Fid") = ZD_table("Fid")
       //ZD_U.Fkod_dol = ZD_table.getValue("Fkod_dol")
       ZD_U.Fnum = ZD_table.getValue("Fnum")
       //ZD_U.Fnom_prik = ZD_table.getValue("Fsum")
       ZD_U.Fnom_prik = String(round(ZD_table.getValue("Fsum"),2))
       ZD_U.Fdat_prik = ZD_table.getValue("Fbdat")
  		//UpdateTable("^PRK_ZD_U",ZD_U,f," Fwid=" + sqlTo(ZD_U_table.getValue("Fwid")));
  		UpdateTable("^PRK_ALL",ZD_U,f," Fwid=" + sqlTo(tzd.getValue("Fwid")));
      // контрольная печать
      WAIT("Кредит: Т.н.="+ZD_table.getValue("Fwid_wp")
                +" кредит:"+ZD_table.getValue("Fsum")+"удерж.:"+ssum_ud)
    }
    ZD_table.MoveNext();
    tzd.Close();
  }
  return;
}