//расчет выходного пособия по-среднему за 2 месяца с учетом среднедневной нормы и без учета суммы ограничения
//результат равен произведению средней суммы статистики по гособязанностям за 2 месяца по фактически отработанным дням и среднедневной нормы за этот же период
//можно использовать с приказом _prk, т.к. время берется по среднедневной норме  

include("objects\\DpDefVed.js")
include("prik/calculate/r_srallvi.js")
include("prik/calculate/r_premblot.js")
include("prik/calculate/r_premkm.js")

function name_sr5ivp()
{
	return "Розрахунок по середньому за 2 місяці з урахуванням середньоденної норми|Расчет по среднему за 2 месяца с учетом среднедневной нормы";
}

function r_sr5ivp(rasch_mes,VVOPL,VVPRK,VVLSFID,VVLSFID2,ftabn_id,svzpName)
{
	var mOkldad,mDays,mChas,mSums;
	var DefVed = new DpDefVed();
	var tbl_PRK_B;
	var tbl_PRK_FMPL;
	var tbl_DTPRKB;
	var tbl_TIME_WR2;
	var tbl_WT_LBL_B;
	var tbl_SRED_INI;
	var tbl_OPL_PRIZ;
	var tbl_SHTAT;
	var tbl_SVZP;

	var D1,D2,sfbdat,sfedat;
	var obj_PRK_B = new Object();
	
	var szTag = getDateTag(rasch_mes);
	//установ. даты на начало и конец расчетного месяца
	var data = new Date(rasch_mes);
	D1 = new Date(firstDayMonth(data));
	D2 = new Date (lastDayMonth(data));
	
	var strSQL = "SELECT Ffld_num FROM ^LIC_FLD WHERE Fid="+sqlTo(VVLSFID);
	var snap = getSnap(strSQL);
	var mvvdpl=0;
  
	if (snap != null)
  		mvvdpl = snap[0];
	
	var sPrikTbl = "PRK_ALL";
	
	var sqlTabn = ftabn_id?" and p.Ftabn_id in ("+ftabn_id+") ":"";
	if (VVOPL<9000)
		tbl_PRK_B = OpenTable("SELECT p.* "
				+" FROM ^"+ sPrikTbl +" as p "
					+" INNER JOIN ^work_pers as w ON w.fwid=p.fwid_wp"
				+" WHERE p.FVID_PRK="+sqlTo(VVPRK)
					+" AND w.FVOPL="+sqlTo(VVOPL)
					+" AND p.FBDAT<="+sqlTo(D2)
					+" AND p.FEDAT>="+sqlTo(D1)+sqlTabn);
	else //VVOPL>=9000
		tbl_PRK_B = OpenTable("SELECT p.* "
				+" FROM ^"+ sPrikTbl +" as p "
				+" WHERE p.FVID_PRK="+sqlTo(VVPRK)
					+" AND p.FBDAT<="+sqlTo(D2)
					+" AND p.FEDAT>="+sqlTo(D1)+sqlTabn);
	if (tbl_PRK_B.IsEmpty())
	{
		tbl_PRK_B.close();
		return false;
	}

	if (!IsTableEx("ZRP_RES","ZRP_"+(svzpName?svzpName:"svzp")+szTag))
	{
		msg = "Не найдена таблица "+(svzpName?svzpName:"svzp")+szTag;
		writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
		tbl_PRK_B.close();
		return false;
	}

	obj_PRK_B.isTBL = false;
	if (IsTableEx("ZRP_MDB","ZRP_TBL"+szTag))
	{
		var snap = getSnap("SELECT * FROM ^TBL"+szTag)
		if (snap!=null)
			obj_PRK_B.isTBL = true;
	}
	var tbl_ini;

	tbl_PRK_B.MoveFirst();
	while (!tbl_PRK_B.IsEOF())
	{
		sfbdat = new Date(tbl_PRK_B.getValue("FBDAT"));
		sfedat = new Date(tbl_PRK_B.getValue("FEDAT"));
		obj_PRK_B.rmode = "SR5VP";
		obj_PRK_B.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
		obj_PRK_B.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
		obj_PRK_B.Fdat_bol = new Date(tbl_PRK_B.getValue("FBDAT"));
		obj_PRK_B.Fsum = tbl_PRK_B.getValue("Fsum");
		obj_PRK_B.Fproc = Number(tbl_PRK_B.getValue("Fproc"))==0?100:Number(tbl_PRK_B.getValue("Fproc"));
		obj_PRK_B.Fnom_prik = 0;
		obj_PRK_B.Fdat_prik = new Date(tbl_PRK_B.getValue("Fdat_prik"));
		obj_PRK_B.dat_vip  = tbl_PRK_B.getValue("Fmes_vip")
		obj_PRK_B.fvid_prk = VVPRK;
		obj_PRK_B.ssum = 0;
		obj_PRK_B.isNotPrem = true;//пока не учитываем полугодовую премию, если нужно будет, то поменяем флаг
		if (obj_PRK_B.isTBL)
			Ok = r_srallvi("",rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B);
		else
			Ok = r_srallvi("",rasch_mes, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_TIME_WR2, tbl_WT_LBL_B, tbl_SRED_INI, tbl_OPL_PRIZ, tbl_SHTAT, tbl_ini, null);
		if (Ok)
		{
			//данная доплата должна выплачиваться всегда в текущем месяце
			mFvp = 0;
			mFmn = d00;
			if ( (obj_PRK_B.ssum!=0)&&((mFvp==0)||((mFvp==2)&&(obj_PRK_B.Fdat_bol>=D1)&&(obj_PRK_B.Fdat_bol<=D2))) )
			{
		  		var m = new Object();
				m.Ftabn_id = tbl_PRK_B.getValue("Ftabn_id");
				m.Fid_prk = tbl_PRK_B.getValue("Fwid");
				m.fshpz = tbl_PRK_B.getValue("FSHPZ");
				m.Fvid_prk = VVPRK;
				m.Flsfid = VVLSFID;
				m.Ffld_num = mvvdpl;
				m.Fsum = round(obj_PRK_B.ssum,2);
				m.Fwid_wp = tbl_PRK_B.getValue("Fwid_wp");
//				var gd = new Date(tbl_PRK_B.getValue("Fbdat"));
//				m.Fbdy = gd.getDate();
				//в дни записываем среднедневную норму
				m.Fday = obj_PRK_B.sr_dn_nrm;
//				m.Fchas = obj_PRK_B.prk_ch;
//				if (obj_PRK_B.TM_IN_DY)
//					m.Fis_day = 0
//				else
//					m.Fis_day = 1;
				m.Fvp = mFvp;
				m.Fmn = mFmn;
				UpdateTable("^"+(svzpName?svzpName:"svzp")+szTag,m,true);
			}
		}
		tbl_PRK_B.MoveNext();
	}
	tbl_PRK_B.close();
	return true;
}