//расчитывает всю статистику для расчетов по средним (отпускные, больничные, гособязанности...)

include("Objects/DpDefVed.js")
include("get_cnst.js");

function name_st_otp()
{
	return "Розрахунок статистики|Расчет статистики"
}

function r_st_otp(rasch_mes,VVOPL,VVPRK,VVLSFID,VVLSFID2,ftabn_id)
{

   	var vardate = rasch_mes.getVarDate();
   	
   	// достаем цифры к названию файла
   	if (rasch_mes.getMonth() < 9)  
      	szTag = String(rasch_mes.getFullYear()) +"0"+ String(rasch_mes.getMonth()+1);
   	else
      	szTag = String(rasch_mes.getFullYear()) + String(rasch_mes.getMonth()+1);  
    
    if(!IsTableEx("ZRP_MDB", "zrp_SVZP"+ szTag))  
    {
    	msg = ru("Не расчитана ЗП","Не розрахована ЗП");
    	writeToLog(msg,"e",VVOPL,VVPRK,VVLSFID);
    	return false;	
    }   

	//26.02.09
   var prem_ptg = get_cnst("prptg", rasch_mes)
   bln_mes_nach = get_cnst("bstnach", rasch_mes)   
   //*********
   
   //эта константа будет брать разовые выплаты для декретных или по 14 коду, если она =1, или по 17 коду, если ее нет или =0
   //из-за Прикарпаттрансгаза
   var prdekr = get_cnst("prdekr", rasch_mes)

          
   	var strSQL = "select * from ^CL_RSCHT where Fdate="+sqlTo(rasch_mes)
   				+(base_month? " and Fdateb="+sqlTo(base_month) : "");
   	var clrscht = OpenTable("s",strSQL);
   	var fis_rtabn = false;
   	if (!clrscht.IsEmpty())
      	fis_rtabn = true;
   	clrscht.close();
	
   	//super vv 22.02.2001:
   	//var DefVed = new DpDefVed();
   	//DefVed.begin("","Накопление статистики по суммам");
   
   	//если есть этот параметр, то пропорционально отр.времени нужно смотреть разовые выплаты только тем, у кого есть опред.
   	//набор неявок. Если его нет, то всегда брать часть разовой суммы, если отр. время не совпадает с нормой.
   	var uch_nvk = false;
   	if (get_cnst("nvkbln", rasch_mes)==1)    
   		uch_nvk = true;
	
	var StrKodNvk = "1=1";
   	if (uch_nvk == true)
   	{
      	//вытягиваем неявки, КОТ.влияют на сбор статистики по больничным
      	strSQL = "select * from ^CL_NVK where Frblnall="+ sqlTo("+") +" order by Fkod_nvk"
      	tnvk = OpenTable("s", strSQL);
      	i = 1;
      	while (!tnvk.IsEOF())
      	{
      		if(i == 1)
      			StrKodNvk = " Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
      		else
      			StrKodNvk += " or Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
        	i++;
            tnvk.MoveNext();
	  	}
      	tnvk.close();
   	}
   	
   // c 22.05.08	добавлено 03,10,08
   //для кода 17 берем свою константу, чтобы отличать сбор 14 кода от 17 для больничных	
   //если есть этот параметр, то пропорционально отр.времени нужно смотреть разовые выплаты только тем, у кого есть опред.
   //набор неявок. Если его нет, то всегда брать часть разовой суммы, если отр. время не совпадает с нормой.
   uch_n17 = false;
   if (get_cnst("nvkb17", rasch_mes)==1)    uch_n17 = true;

   StrKodN17 = " 1=1 ";
   StrKodO17 = " 1=1 ";
   if (uch_n17 == true){
      //вытягиваем неявки по больничным, КОТ.влияют на сбор статистики по больничным
      strSQL = "select * from ^CL_NVK where Frblnall="+sqlTo("+")+" order by Fkod_nvk"
      tnvk = OpenTable("s", strSQL);
      if (!tnvk.IsEmpty()){
         i = 1;
         while (!tnvk.IsEOF())
         {
         	if (i==1)
         		StrKodN17 = " t.Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
         	else
      			StrKodN17 += " or t.Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
        	i++;
            tnvk.MoveNext();
         } 
      }
      tnvk.close();
      //вытягиваем неявки по отпускным, КОТ.влияют на сбор статистики по больничным
      strSQL = "select * from ^CL_NVK where Frblnall="+sqlTo("*")+" order by Fkod_nvk"
      tnvk = OpenTable("s", strSQL);
      if (!tnvk.IsEmpty()){
         i = 1;
         while (!tnvk.IsEOF()){
         	if (i==1)
      			StrKodO17 = "  t.Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
         	else	        	
      			StrKodO17 += " or t.Fkod_nvk="+ sqlTo(tnvk.getValue("Fkod_nvk"));
        	i++;
            tnvk.MoveNext();
         } 
      }
      tnvk.close();
   }
   StrKodN17 = "("+StrKodN17+")"
   StrKodO17 = "("+StrKodO17+")"
   	//**************************************
   	   	      
	ExecuteSQL("drop table TMP_SVZP_LIC", false);
//	strSQL = "create table TMP_SVZP_LIC "
//			+"(FLSFID "+ SqlType("INT")
//			+",FWID "+ SqlType("INT")
//			+",FMN "+ SqlType("DATE")
//			+",FSUM "+ SqlType("CURRENCY")
//			+",FTABN_ID "+ SqlType("INT")
//			+",FVP "+ SqlType("BYTE")
//			+",FWID_WP "+ SqlType("INT")
//			+",FIS1 "+ SqlType("TEXT", 1)
//			+",FIS2 "+ SqlType("TEXT", 1)
//			+",FIS3 "+ SqlType("TEXT", 1)
//			+",FIS4 "+ SqlType("TEXT", 1)
//			+",FIS5 "+ SqlType("TEXT", 1)
//			+",FIS6 "+ SqlType("TEXT", 1)
//			+",FIS7 "+ SqlType("TEXT", 1)
//			+",FIS8 "+ SqlType("TEXT", 1)
//			+",FIS9 "+ SqlType("TEXT", 1)
//			+",FIS10 "+ SqlType("TEXT", 1)
//			+",FIS11 "+ SqlType("TEXT", 1)
//			+",FIS12 "+ SqlType("TEXT", 1)
//			+",FIS13 "+ SqlType("TEXT", 1)
//			+",FIS14 "+ SqlType("TEXT", 1)
//			+",FIS15 "+ SqlType("TEXT", 1)
//			+",FIS16 "+ SqlType("TEXT", 1)
//			+",FIS17 "+ SqlType("TEXT", 1)
//			+",FIS18 "+ SqlType("TEXT", 1) +")";
//	ExecuteSQL(strSQL);
	var m = new Object();
	m.FLSFID = "INT";
	m.FWID = "INT";
	m.FMN = "DATE";
	m.FSUM = "CURRENCY";
	m.FSUM_NR = "CURRENCY";	
	m.FTABN_ID = "INT";
	m.FVP = "BYTE";
	m.FWID_WP = "INT";
	m.FISR_NR = "BIT";	
	m.FIS1 = "TEXT(2)";
	m.FIS2 = "TEXT(2)";
	m.FIS3 = "TEXT(2)";
	m.FIS4 = "TEXT(2)";
	m.FIS5 = "TEXT(2)";
	m.FIS6 = "TEXT(2)";
	m.FIS7 = "TEXT(2)";
	m.FIS8 = "TEXT(2)";
	m.FIS9 = "TEXT(2)";
	m.FIS10 = "TEXT(2)";
	m.FIS11 = "TEXT(2)";
	m.FIS12 = "TEXT(2)";
	m.FIS13 = "TEXT(2)";
	m.FIS14 = "TEXT(2)";
	m.FIS15 = "TEXT(2)";
	m.FIS16 = "TEXT(2)";
	m.FIS17 = "TEXT(2)";
	m.FIS18 = "TEXT(2)";
	m.FFZP = "TEXT(2)";	
	var ind = new Object();
	ind.FTABN_ID = "FTABN_ID";
	CreateTable("TMP_SVZP_LIC", m, ind);
	
	var sqlTabn = ftabn_id?" and z.Ftabn_id in ("+ftabn_id+") ":"";

    if(!getPar("KOMKOLD")){
    	strSQL = "insert into TMP_SVZP_LIC "
			+"(FLSFID,FWID,FMN,FSUM,FTABN_ID,FVP,FWID_WP"
			+",FIS1,FIS2,FIS3,FIS4,FIS5,FIS6,FIS7,FIS8,FIS9"
			+",FIS10,FIS11,FIS12,FIS13,FIS14,FIS15,FIS16,FIS17,FIS18,FFZP) "
		+" select z.FLSFID,z.FWID,z.FMN,z.FSUM,z.FTABN_ID,z.FVP,z.FWID_WP"
			+",l.FIS1,l.FIS2,l.FIS3,l.FIS4,l.FIS5,l.FIS6,l.FIS7,l.FIS8,l.FIS9"
			+",l.FIS10,l.FIS11,l.FIS12,l.FIS13,l.FIS14,l.FIS15,l.FIS16,l.FIS17,l.FIS18,l.FFZP"
		+" from ^SVZP"+ szTag +" as z "
			+" inner join ^LIC_FLD as l on l.FID=z.FLSFID"
		+" where z.FVP<>2 and not (z.FVP=1 and z.FMN<"+ sqlTo(rasch_mes) + ")" + sqlTabn;
    	ExecuteSQL(strSQL);
    }else{
    	strSQL = "insert into TMP_SVZP_LIC "
			+"(FLSFID,FWID,FMN,FSUM,FTABN_ID,FVP,FWID_WP,FISR_NR"
			+",FIS1,FIS2,FIS3,FIS4,FIS5,FIS6,FIS7,FIS8,FIS9"
			+",FIS10,FIS11,FIS12,FIS13,FIS14,FIS15,FIS16,FIS17,FIS18,FFZP) "
		+" select z.FLSFID,z.FWID,z.FMN,z.FSUM,z.FTABN_ID,z.FVP,z.FWID_WP,z.FISR_NR"
			+",l.FIS1,l.FIS2,l.FIS3,l.FIS4,l.FIS5,l.FIS6,l.FIS7,l.FIS8,l.FIS9"
			+",l.FIS10,l.FIS11,l.FIS12,l.FIS13,l.FIS14,l.FIS15,l.FIS16,l.FIS17,l.FIS18,l.FFZP"
		+" from ^SVZP"+ szTag +" as z "
			+" inner join ^LIC_FLD as l on l.FID=z.FLSFID"
		+" where z.FVP<>2 and not (z.FVP=1 and z.FMN<"+ sqlTo(rasch_mes) + ")" + sqlTabn;
    	ExecuteSQL(strSQL);
    	
    	strSQL = "insert into TMP_SVZP_LIC "
    		+"(FLSFID,FWID,FMN,FSUM_NR,FTABN_ID,FVP,FWID_WP"
    		+",FIS1,FIS2,FIS3,FIS4,FIS5,FIS6,FIS7,FIS8,FIS9"
    		+",FIS10,FIS11,FIS12,FIS13,FIS14,FIS15,FIS16,FIS17,FIS18,FFZP) "
    		+" select z.FLSFID,z.FWID,z.FMN,z.FSUM,z.FTABN_ID,z.FVP,z.FWID_WP"
    		+",l.FIS1,l.FIS2,l.FIS3,l.FIS4,l.FIS5,l.FIS6,l.FIS7,l.FIS8,l.FIS9"
    		+",l.FIS10,l.FIS11,l.FIS12,l.FIS13,l.FIS14,l.FIS15,l.FIS16,l.FIS17,l.FIS18,l.FFZP"
    		+" from ^SVNR"+ szTag +" as z "
    		+" inner join ^LIC_FLD as l on l.FID=z.FLSFID"
    		+" where z.FVP<>2 and not (z.FVP=1 and z.FMN<"+ sqlTo(rasch_mes) + ")" + sqlTabn;
    	ExecuteSQL(strSQL);
    	
    	ExecuteSQL("update TMP_SVZP_LIC set Fsum_nr=0 where Fsum_nr is null")    	
    	ExecuteSQL("update TMP_SVZP_LIC set Fisr_nr="+sqlFalse+" where Fisr_nr is null")    	
    }
	
	ExecuteSQL("update TMP_SVZP_LIC set Fsum=0 where Fsum is null")
	
	
	
//нужно определить базовый месяц
  if ((bln_mes_nach!=0 && !differ(base_month, rasch_mes))){
	ExecuteSQL("drop table TMP_SVZP_LICV", false);
//	strSQL = "create table TMP_SVZP_LICV "
//			+"(FLSFID "+ SqlType("INT")
//			+",FWID "+ SqlType("INT")
//			+",FMN "+ SqlType("DATE")
//			+",FSUM "+ SqlType("CURRENCY")
//			+",FTABN_ID "+ SqlType("INT")
//			+",FVP "+ SqlType("BYTE")
//			+",FWID_WP "+ SqlType("INT")
//			+",FIS1 "+ SqlType("TEXT", 1)
//			+",FIS2 "+ SqlType("TEXT", 1)
//			+",FIS3 "+ SqlType("TEXT", 1)
//			+",FIS4 "+ SqlType("TEXT", 1)
//			+",FIS5 "+ SqlType("TEXT", 1)
//			+",FIS6 "+ SqlType("TEXT", 1)
//			+",FIS7 "+ SqlType("TEXT", 1)
//			+",FIS8 "+ SqlType("TEXT", 1)
//			+",FIS9 "+ SqlType("TEXT", 1)
//			+",FIS10 "+ SqlType("TEXT", 1)
//			+",FIS11 "+ SqlType("TEXT", 1)
//			+",FIS12 "+ SqlType("TEXT", 1)
//			+",FIS13 "+ SqlType("TEXT", 1)
//			+",FIS14 "+ SqlType("TEXT", 1)
//			+",FIS15 "+ SqlType("TEXT", 1)
//			+",FIS16 "+ SqlType("TEXT", 1)
//			+",FIS17 "+ SqlType("TEXT", 1)
//			+",FIS18 "+ SqlType("TEXT", 1) +")";
//	ExecuteSQL(strSQL);
	var m = new Object();
	m.FLSFID = "INT";
	m.FWID = "INT";
	m.FMN = "DATE";
	m.FSUM = "CURRENCY";
	m.FSUM_NR= "CURRENCY";	
	m.FTABN_ID = "INT";
	m.FVP = "BYTE";
	m.FWID_WP = "INT";
	m.FISR_NR = "BIT";	
	m.FIS1 = "TEXT(2)";
	m.FIS2 = "TEXT(2)";
	m.FIS3 = "TEXT(2)";
	m.FIS4 = "TEXT(2)";
	m.FIS5 = "TEXT(2)";
	m.FIS6 = "TEXT(2)";
	m.FIS7 = "TEXT(2)";
	m.FIS8 = "TEXT(2)";
	m.FIS9 = "TEXT(2)";
	m.FIS10 = "TEXT(2)";
	m.FIS11 = "TEXT(2)";
	m.FIS12 = "TEXT(2)";
	m.FIS13 = "TEXT(2)";
	m.FIS14 = "TEXT(2)";
	m.FIS15 = "TEXT(2)";
	m.FIS16 = "TEXT(2)";
	m.FIS17 = "TEXT(2)";
	m.FIS18 = "TEXT(2)";
	m.FFZP = "TEXT(2)";	
	var ind = new Object();
	ind.FTABN_ID = "FTABN_ID";
	CreateTable("TMP_SVZP_LICV", m, ind);
	
    if(!getPar("KOMKOLD")){
    	strSQL = "insert into TMP_SVZP_LICV "
			+"(FLSFID,FWID,FMN,FSUM,FTABN_ID,FVP,FWID_WP"
			+",FIS1,FIS2,FIS3,FIS4,FIS5,FIS6,FIS7,FIS8,FIS9"
			+",FIS10,FIS11,FIS12,FIS13,FIS14,FIS15,FIS16,FIS17,FIS18,FFZP) "
		+" select z.FLSFID,z.FWID,z.FMN,z.FSUM,z.FTABN_ID,z.FVP,z.FWID_WP"
			+",l.FIS1,l.FIS2,l.FIS3,l.FIS4,l.FIS5,l.FIS6,l.FIS7,l.FIS8,l.FIS9"
			+",l.FIS10,l.FIS11,l.FIS12,l.FIS13,l.FIS14,l.FIS15,l.FIS16,l.FIS17,l.FIS18,l.FFZP"
		+" from ^SVZP"+ szTag +" as z "
			+" inner join ^LIC_FLD as l on l.FID=z.FLSFID"
		+" where z.FVP=0 or (z.FVP=2 and z.FMN<"+ sqlTo(rasch_mes) + ")" + sqlTabn;
    	ExecuteSQL(strSQL);    	
    }else{
    	strSQL = "insert into TMP_SVZP_LICV "
				+"(FLSFID,FWID,FMN,FSUM,FTABN_ID,FVP,FWID_WP,FISR_NR"
				+",FIS1,FIS2,FIS3,FIS4,FIS5,FIS6,FIS7,FIS8,FIS9"
				+",FIS10,FIS11,FIS12,FIS13,FIS14,FIS15,FIS16,FIS17,FIS18,FFZP) "
			+" select z.FLSFID,z.FWID,z.FMN,z.FSUM,z.FTABN_ID,z.FVP,z.FWID_WP,z.FISR_NR"
				+",l.FIS1,l.FIS2,l.FIS3,l.FIS4,l.FIS5,l.FIS6,l.FIS7,l.FIS8,l.FIS9"
				+",l.FIS10,l.FIS11,l.FIS12,l.FIS13,l.FIS14,l.FIS15,l.FIS16,l.FIS17,l.FIS18,l.FFZP"
			+" from ^SVZP"+ szTag +" as z "
				+" inner join ^LIC_FLD as l on l.FID=z.FLSFID"
			+" where z.FVP=0 or (z.FVP=2 and z.FMN<"+ sqlTo(rasch_mes) + ")" + sqlTabn;
    	ExecuteSQL(strSQL);
    	
    	ExecuteSQL("update TMP_SVZP_LICV set Fisr_nr="+sqlFalse+" where Fisr_nr is null")    	
    }

	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis1=' ' where Fis1 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis2=' ' where Fis2 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis3=' ' where Fis3 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis4=' ' where Fis4 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis5=' ' where Fis5 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis6=' ' where Fis6 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis7=' ' where Fis7 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis8=' ' where Fis8 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis9=' ' where Fis9 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis10=' ' where Fis10 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis11=' ' where Fis11 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis12=' ' where Fis12 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis13=' ' where Fis13 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis14=' ' where Fis14 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis15=' ' where Fis15 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis16=' ' where Fis16 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis17=' ' where Fis17 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Fis18=' ' where Fis18 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LICV set Ffzp=' ' where Ffzp is null");
	
	ExecuteSQL("update TMP_SVZP_LICV set Fsum=0 where Fsum is null")
  }	
	
	//добавили, т,к, при сравнении <> на неравенство, если в колонке
	//Null, не отрабатывал sql-запрос 	
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis1=' ' where Fis1 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis2=' ' where Fis2 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis3=' ' where Fis3 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis4=' ' where Fis4 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis5=' ' where Fis5 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis6=' ' where Fis6 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis7=' ' where Fis7 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis8=' ' where Fis8 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis9=' ' where Fis9 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis10=' ' where Fis10 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis11=' ' where Fis11 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis12=' ' where Fis12 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis13=' ' where Fis13 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis14=' ' where Fis14 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis15=' ' where Fis15 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis16=' ' where Fis16 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis17=' ' where Fis17 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Fis18=' ' where Fis18 is null");
	ExecuteSQL("UPDATE TMP_SVZP_LIC set Ffzp=' ' where Ffzp is null");	

	//отбираем записи для расчета коэффициента
	var factDay = IIF("FNORM_DAY<FFACT_DAY", "FNORM_DAY", "FFACT_DAY");
	var factTime = IIF("FNORM_TIME<FFACT_TIME", "FNORM_TIME", "FFACT_TIME");
	ExecuteSQL("drop table TMP_TIME_GO", false);	
	strSQL = "select FTABN_ID,FNORM_DAY,FNORM_TIME"
				+","+ factDay +" as FFACT_DAY, "+ factTime +" as FFACT_TIME "
			+" into TMP_TIME_GO  "
			+" from ^TIME_GO "
			+" where FTABN_ID IN (select FTABN_ID from TMP_SVZP_LIC)"
				+" and FLD_DATE=" + sqlTo(vardate)
	ExecuteSQL(strSQL);
	ExecuteSQL("CREATE INDEX FTABN_ID ON TMP_TIME_GO (FTABN_ID)", false);
	
	ExecuteSQL("drop table TMP_TIME_WR2", false);	
	strSQL = "select FTABN_ID,FNORM_DAY,FNORM_TIME "
				+","+ factDay +" as FFACT_DAY, "+ factTime +" as FFACT_TIME "
			+" into TMP_TIME_WR2  "
			+" from ^TIME_WR2 "
			+" where FTABN_ID IN (select FTABN_ID from TMP_SVZP_LIC)"
				+" and FLD_DATE=" + sqlTo(vardate)
	ExecuteSQL(strSQL);
	ExecuteSQL("CREATE INDEX FTABN_ID ON TMP_TIME_WR2 (FTABN_ID)", false);
	
	//суммы	для SRED_INI
	var sum1 = "sum("+ IIF("z.FIS2='+' or z.FIS2='o'", "z.FSUM", 0) +")";	//для отпусков	
	var sum19 = "sum("+ IIF("z.FIS2='#'", "z.FSUM", 0) +")";	//для не индексируемыx сумм 	
	var koefTm = IIF("tg.FNORM_TIME>0 and tg.FFACT_TIME>0", "tg.FFACT_TIME/tg.FNORM_TIME", 0);	
	var koefb = IIF("tg.FNORM_DAY>0 and tg.FFACT_DAY>0", "tg.FFACT_DAY/tg.FNORM_DAY", koefTm);	
	var kSumb = IIF("z.FIS4='z'", "z.FSUM*"+ koefb, 0);
	var sum2 = "sum("+ IIF("z.FIS4='+' or z.FIS4='з'", "z.FSUM", 0) +" + ("+ kSumb +"))";//для больн.-КОМАНДИРОВОК (вид среднего = 2)
	var kSumk = IIF("z.FIS4='z' and z.FIS3<>'+'", "z.FSUM*"+ koefb, 0);		
    
	if(!getPar("KOMKOLD")){	
		var sum3 = "sum("+ IIF("z.FIS3='+'", "z.FSUM", 0) +" + ("+ kSumk +"))";	//для гособяз.	
	}else{
		var sum3 = "sum("+ IIF("((z.FIS3='+' and z.FFZP<>'к') or (z.FIS3='+' and z.FFZP='к' and z.Fisr_nr="+sqlTrue+" ))", "z.FSUM", 0) +" + ("+ kSumk +"))";	//для гособяз.

		var kSumkn = IIF("z.FIS4='z' and z.FIS3<>'+'", "z.FSUM_NR*"+ koefb, 0);	
		var sum20 = "sum("+ IIF("z.FIS3='+'", "z.FSUM_NR", 0) +" + ("+ kSumkn +"))";	//для командировок суммы по колдоговору по норме времени
	}
	//var sum3 = "sum("+ IIF("z.FIS3='+'", "z.FSUM", kSumk )+")";	//для гособяз.	
	var sum4 = "sum("+ IIF("z.FIS11='+'", "z.FSUM", 0) +")";			//для квартальной премии
	var sum5 = "sum("+ IIF("z.FIS15='+'", "z.FSUM", 0) +")";			//для годовой премии
	var sum6 = "sum("+ IIF("z.FIS16='+'", "z.FSUM", 0) +")";			//для ежемесячной премии (если идет по прошлому месяцу)
	var sum8 = "sum("+ IIF("z.FIS18='п'", "z.FSUM", 0) +")";			//пенс.фонд
	var sum10 = "sum("+ IIF("z.FIS2='*'", "z.FSUM", 0) +")";			//для премий из ФМП для отпускных
	//var sum11 = "sum("+ IIF("z.FIS4='p' or z.FIS4='z' or z.FIS4='з' "
	//						+" or z.FIS4='+' or z.FIS4='г' or z.FIS4='v'"
	//					,"z.FSUM", 0) +")";									//для больн. (вид среднего = 11)
	var sum11 = "sum("+ IIF("z.FIS4='z' or z.FIS4='з' or z.FIS4='+' or z.FIS4='v' or z.FIS4='г' or z.FIS4='p'","z.FSUM", 0) +")";									//для больн. (вид среднего = 11)
	var sum12 = "sum("+ IIF("z.FIS10='+'", "z.FSUM", 0) +")";			//для вых.пос. (вид среднего = 12)
	//var sum13 = "sum("+ IIF("z.FIS9='м'", "z.FSUM", 0) +")";			//для мат.помощи (вид среднего = 13)
	var sum13 = "sum("+ IIF("z.FIS9='t'", "z.FSUM", 0) +")";			//для мат.помощи (вид среднего = 13)
	
	//для больн. (вид среднего = 14)  				
	koefTime = IIF("wr.FNORM_TIME>0 and wr.FFACT_TIME>0", "wr.FFACT_TIME/wr.FNORM_TIME", 0);	
	koef = IIF("wr.FNORM_DAY>0 and wr.FFACT_DAY>0", "wr.FFACT_DAY/wr.FNORM_DAY", koefTime);
	var szTNameT = "TBL";
	var stt1NameT = "STT1"
    if(rasch_mes.getMonth() < 9)  
    	szTag = String(rasch_mes.getFullYear()+"0"+String(rasch_mes.getMonth()+1));
    else
    	szTag = String(rasch_mes.getFullYear()+String(rasch_mes.getMonth()+1));
	szTNameT += szTag;
	stt1NameT += szTag;  	
	var kUch = "z.FSUM*"+ koef;
	//03.10.08 Яна - это условие неправильное, будет давать ошибку, если включить неявки.************
	if (IsTableEx("zrp_mdb","ZRP_"+ szTNameT) && uch_nvk)
	{
		/*
		kUch = IIF("(select t.FWID_WP from ^"+ szTNameT +" t "
				//проверяем по табельному номеру, а не по коду штатного
				+" where exists(select * from ^"+stt1NameT+" as s where t.Fwid_wp=s.Fwid_wp and z.Ftabn_id=s.Ftabn_id)"
				+" and ("+ StrKodNvk +")) is null", "z.FSUM", "z.FSUM*"+ koef);
		*/
		kUch = IIF("not exists (select t.FWID_WP from ^"+ szTNameT +" t "
				//проверяем по табельному номеру, а не по коду штатного
				+" where exists(select * from ^"+stt1NameT+" as s where t.Fwid_wp=s.Fwid_wp and z.Ftabn_id=s.Ftabn_id)"
				+" and ("+ StrKodNvk +")) ", "z.FSUM", "z.FSUM*"+ koef);
	}

    //24.06.08 внесено 25.02.09
    if (prem_ptg==0){ 
	   kUch = IIF("z.FIS4='v' or z.FIS4='г' or z.FIS4='p'", kUch, 0);
	   //*************************************************************************************
  	   //kSum = IIF("z.FIS4='z'", "z.FSUM*"+ koef, kUch);	
		var sum14 = "sum("+ IIF("z.FIS4='z' or z.FIS4='+' or z.FIS4='з'", "z.FSUM", 0) +"+("+ kUch +"))";	//14	   
	}else{
	   //	для ПТГ премия по z берется в полном обьеме только если есть отработанное время
	   kUch = IIF("z.FIS4='v' or z.FIS4='г' or z.FIS4='p'", kUch, 0);
	   //*************************************************************************************
  	   //kSum = IIF("z.FIS4='z'", "z.FSUM*"+ koef, kUch);
		var sum14 = "sum("+ IIF("(z.FIS4='z' and "+koef+"<>0) or z.FIS4='+' or z.FIS4='з'", "z.FSUM", 0) +"+("+ kUch +"))";	//14
	}
	//из-за ПТГ добавляем это условие 22,02,10
    if (prdekr!=0){	
		var sum18 = "sum("+ IIF("z.FIS17='+' and z.FIS9<>'б' and not(z.Fis4='z' or z.Fis4='v' or z.Fis4='г' or z.Fis4='p')", "z.FSUM", 0) +"+("+ kUch +"))";	//18    	
    }
    
	var sum15 = "sum("+ IIF("z.FIS17='+'", "z.FSUM", 0) +")";			//27.01.07: для базы необлагаемой по соцстраху

    //c 22.05.08***********
	//для больн. (вид среднего = 17)  				
	koefTime = IIF("wr.FNORM_TIME>0 and wr.FFACT_TIME>0", "wr.FFACT_TIME/wr.FNORM_TIME", 0);	
	koef = IIF("wr.FNORM_DAY>0 and wr.FFACT_DAY>0", "wr.FFACT_DAY/wr.FNORM_DAY", koefTime);
	var szTNameT = "TBL";
	var szSNameT = "STT1";	
    if(rasch_mes.getMonth() < 9)  
    	szTag = String(rasch_mes.getFullYear()+"0"+String(rasch_mes.getMonth()+1));
    else
    	szTag = String(rasch_mes.getFullYear()+String(rasch_mes.getMonth()+1));
	szTNameT += szTag; 
	szSNameT += szTag;	      	
    //разовые выплаты - если есть больничный, то пропорционально отр.времени, иначе - полной суммой	
	var kUch = "z.FSUM*"+ koef;
	var iskUchMS = false;
	if (IsTableEx("zrp_mdb","ZRP_"+ szTNameT) && uch_n17)
	{
		//22.10.08 Яна проверить
		/*
		if(SUBD==MSSQL)
		{
			//MSSQL не поддерживает использование подзапроссов в функциях
			//поэтому скопируем нужных людей в отдельную таблицу, которую потом приджоиним
			iskUchMS = true;
			DropTable("KUCH");
			ExecuteSQL("select "+First("Ftabn_id")+" as Ftabn_id into KUCH from ^"+ szSNameT+" s "
						+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
							+" where t.FWID_WP=s.FWID_WP and (t.Fday_nvk<>0 or t.Fchasnvk<>0) and  "
							+ StrKodN17 +")");
			kUch = IIF("k1.Ftabn_id is null", "z.FSUM", "z.FSUM*"+koef);
		}
		else
		{
			kUch = IIF("(select "+First("Ftabn_id")+" from ^"+ szSNameT+" s where exists(select t.fwid_wp from ^"+ szTNameT
						+ " t where t.FWID_WP=s.FWID_WP and (t.Fday_nvk<>0 or t.Fchasnvk<>0) and  "
						+ StrKodN17 +")) is null", "z.FSUM", "z.FSUM*"+koef);
		}
		*/
		iskUchMS = true;
		
		DropTable("KUCH");
		/*
		ExecuteSQL("select distinct s.Ftabn_id  into KUCH from ^"+ szSNameT+" s "
						+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
							+" where t.FWID_WP=s.FWID_WP and (t.Fday_nvk<>0 or t.Fchasnvk<>0  or t.Fis_nvk="+sqlTrue+") and  "
							+ StrKodN17 + ")" + (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
						+" group by s.Ftabn_id");
		*/
		//22,02,10 с group by не работало
		
		strSQL = "select distinct s.Ftabn_id  into KUCH from ^"+ szSNameT+" s "
						+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
							+" where t.FWID_WP=s.FWID_WP and (t.Fday_nvk<>0 or t.Fchasnvk<>0  or t.Fis_nvk="+sqlTrue+") and  "
							+ StrKodN17 + ")" + (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
		ExecuteSQL(strSQL);
		kUch = IIF("k1.Ftabn_id is null", "z.FSUM", "z.FSUM*"+koef);
	}
	kUch = IIF("z.FIS4='v' or z.FIS4='г' or z.FIS4='p'", kUch, 0);

    //премии - если нет отпуска и отр.дни=0, то не включается, иначе - полной суммой
	var kUchpr = "z.FSUM";
	var iskUchprMS = false;
	if (IsTableEx("zrp_mdb","ZRP_"+ szTNameT) && uch_n17)
	{
		//22.10.08
		/*
		if(SUBD==MSSQL)
		{
			//MSSQL не поддерживает использование подзапроссов в функциях
			//поэтому скопируем нужных людей в отдельную таблицу, которую потом приджоиним
			iskUchprMS = true;
			DropTable("KUCHPR");
			ExecuteSQL("select "+First("Ftabn_id")+" as Ftabn_id into KUCHPR from ^"+ szSNameT+" s "
					+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
						+" where t.FWID_WP=s.FWID_WP  and (t.Fday_nvk<>0 or t.Fchasnvk<>0) and  "
						+ StrKodO17 +")");
			kUchpr = IIF("k2.Ftabn_id is null  and ( "+koef+"=0) ", 0, "z.FSUM");
		}
		else
		{
			kUchpr = IIF("(select "+First("Ftabn_id")+" from ^"+ szSNameT+" s where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
					+" where t.FWID_WP=s.FWID_WP  and (t.Fday_nvk<>0 or t.Fchasnvk<>0) and  "+ StrKodO17 +")) is null  and ( "+koef+"=0) ", 0, "z.FSUM");
		}
		*/
		iskUchprMS = true;
		DropTable("KUCHPR");
		/*
		ExecuteSQL("select distinct s.Ftabn_id  into KUCHPR from ^"+ szSNameT+" s "
					+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
						+" where t.FWID_WP=s.FWID_WP  and (t.Fday_nvk<>0 or t.Fchasnvk<>0 or t.Fis_nvk="+sqlTrue+") and  "
						+ StrKodO17 + ") " + (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":"")
						+"group by s.Ftabn_id");
		*/
		//22.02.10 c GROUP BY НЕ РАБОТАЛО
		ExecuteSQL("select distinct s.Ftabn_id  into KUCHPR from ^"+ szSNameT+" s "
					+" where exists(select t.fwid_wp from ^"+ szTNameT+ " t "
						+" where t.FWID_WP=s.FWID_WP  and (t.Fday_nvk<>0 or t.Fchasnvk<>0 or t.Fis_nvk="+sqlTrue+") and  "
						+ StrKodO17 + ") " + (ftabn_id?" and s.Ftabn_id in ("+ftabn_id+") ":""));
		kUchpr = IIF("k2.Ftabn_id is null  and ( "+koef+"=0) ", 0, "z.FSUM");
	}
	kUchpr = IIF("z.FIS4='z'", kUchpr, 0);

	var sum17 = "sum("+ IIF("z.FIS4='+' or z.FIS4='з'", "z.FSUM", 0) +"+("+ kUch +")"+"+("+ kUchpr +"))";	//17
	//********************
	//27,12,09 Сбор статистики для декретных - пропорции как в 17 коде, а полные суммы - те, которые облагаются соцстрахом
	//22.02.10 добавляем из-за ПТГ
    if (prdekr==0 || prdekr==null){	
		var sum18 = "sum("+ IIF("z.FIS17='+' and z.FIS9<>'б' and not(z.Fis4='z' or z.Fis4='v' or z.Fis4='г' or z.Fis4='p')", "z.FSUM", 0) +"+("+ kUch +")"+"+("+ kUchpr +"))";	//18
    }
     	
	var nDec = Number(getPar("DECISUM"));
			
	ExecuteSQL("drop table TMP_SRED_INI", false);
	CreateTable("TMP_SRED_INI", "SRED_INI", "*");
	if(!getPar("KOMKOLD")){
		strSQL = "insert into TMP_SRED_INI "
			+"(FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
			+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
			+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13"
			+",FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19)"
		+" select "+ sqlTo(vardate) +" as FLD_DATE, z.FTABN_ID"
			+", "+ sqlRound(sum1, nDec) +" as FLD_STOR"
			+", "+ sqlRound(sum1, nDec) +" as FLD_STOR1"
			+", "+ sqlRound(sum2, nDec) +" as FLD_STOR2"
			+", "+ sqlRound(sum3, nDec) +" as FLD_STOR3"
			+", "+ sqlRound(sum4, nDec) +" as FLD_STOR4"
			+", "+ sqlRound(sum5, nDec) +" as FLD_STOR5"
			+", "+ sqlRound(sum6, nDec) +" as FLD_STOR6"
			+", "+ sqlRound(sum8, nDec) +" as FLD_STOR8"
			+", "+ sqlRound(sum10, nDec) +" as FLD_STOR10"
			+", "+ sqlRound(sum11, nDec) +" as FLD_STOR11"
			+", "+ sqlRound(sum12, nDec) +" as FLD_STOR12"
			+", "+ sqlRound(sum13, nDec) +" as FLD_STOR13"
			+", "+ sqlRound(sum14, nDec) +" as FLD_STOR14"
			+", "+ sqlRound(sum15, nDec) +" as FLD_STOR15"
			+", "+ sqlRound(sum17, nDec) +" as FLD_STOR17"
			+", "+ sqlRound(sum18, nDec) +" as FLD_STOR18"
			+", "+ sqlRound(sum19, nDec) +" as FLD_STOR19"
		+" from TMP_SVZP_LIC z "
			+" left join TMP_TIME_GO tg on tg.FTABN_ID=z.FTABN_ID"
			+" left join TMP_TIME_WR2 wr on wr.FTABN_ID=z.FTABN_ID"
			+(iskUchMS?" left join KUCH as k1 on k1.Ftabn_id=z.Ftabn_id":"")
			+(iskUchprMS?" left join KUCHPR as k2 on k2.Ftabn_id=z.Ftabn_id":"")
		+" group by z.FTABN_ID";
		ExecuteSQL(strSQL);
	}else{
		strSQL = "insert into TMP_SRED_INI "
				+"(FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
				+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
				+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13"
				+",FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19,FLD_STOR20)"
			+" select "+ sqlTo(vardate) +" as FLD_DATE, z.FTABN_ID"
				+", "+ sqlRound(sum1, nDec) +" as FLD_STOR"
				+", "+ sqlRound(sum1, nDec) +" as FLD_STOR1"
				+", "+ sqlRound(sum2, nDec) +" as FLD_STOR2"
				+", "+ sqlRound(sum3, nDec) +" as FLD_STOR3"
				+", "+ sqlRound(sum4, nDec) +" as FLD_STOR4"
				+", "+ sqlRound(sum5, nDec) +" as FLD_STOR5"
				+", "+ sqlRound(sum6, nDec) +" as FLD_STOR6"
				+", "+ sqlRound(sum8, nDec) +" as FLD_STOR8"
				+", "+ sqlRound(sum10, nDec) +" as FLD_STOR10"
				+", "+ sqlRound(sum11, nDec) +" as FLD_STOR11"
				+", "+ sqlRound(sum12, nDec) +" as FLD_STOR12"
				+", "+ sqlRound(sum13, nDec) +" as FLD_STOR13"
				+", "+ sqlRound(sum14, nDec) +" as FLD_STOR14"
				+", "+ sqlRound(sum15, nDec) +" as FLD_STOR15"
				+", "+ sqlRound(sum17, nDec) +" as FLD_STOR17"
				+", "+ sqlRound(sum18, nDec) +" as FLD_STOR18"
				+", "+ sqlRound(sum19, nDec) +" as FLD_STOR19"
				+", "+ sqlRound(sum20, nDec) +" as FLD_STOR20"				
			+" from TMP_SVZP_LIC z "
				+" left join TMP_TIME_GO tg on tg.FTABN_ID=z.FTABN_ID"
				+" left join TMP_TIME_WR2 wr on wr.FTABN_ID=z.FTABN_ID"
				+(iskUchMS?" left join KUCH as k1 on k1.Ftabn_id=z.Ftabn_id":"")
				+(iskUchprMS?" left join KUCHPR as k2 on k2.Ftabn_id=z.Ftabn_id":"")
			+" group by z.FTABN_ID";
		ExecuteSQL(strSQL);
	}

	
	if ((bln_mes_nach!=0 && !differ(base_month, rasch_mes))){	
		ExecuteSQL("drop table TMP_SRED_INIV", false);
		CreateTable("TMP_SRED_INIV", "SRED_INI", "*");
		strSQL = "insert into TMP_SRED_INIV "
				+"(FLD_DATE,FTABN_ID,FLD_STOR8"
				+",FLD_STOR11,FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18)"
			+" select "+ sqlTo(vardate) +" as FLD_DATE, z.FTABN_ID"
				+", "+ sqlRound(sum8, nDec) +" as FLD_STOR8"
				+", "+ sqlRound(sum11, nDec) +" as FLD_STOR11"
				+", "+ sqlRound(sum14, nDec) +" as FLD_STOR14"
				+", "+ sqlRound(sum15, nDec) +" as FLD_STOR15"
				+", "+ sqlRound(sum17, nDec) +" as FLD_STOR17"
				+", "+ sqlRound(sum18, nDec) +" as FLD_STOR18"
			+" from TMP_SVZP_LICV z "
				+" left join TMP_TIME_GO tg on tg.FTABN_ID=z.FTABN_ID"
				+" left join TMP_TIME_WR2 wr on wr.FTABN_ID=z.FTABN_ID"
				+(iskUchMS?" left join KUCH as k1 on k1.Ftabn_id=z.Ftabn_id":"")
				+(iskUchprMS?" left join KUCHPR as k2 on k2.Ftabn_id=z.Ftabn_id":"")
			+" group by z.FTABN_ID";
		ExecuteSQL(strSQL);

		strSQL = "update TMP_SRED_INI set Fld_stor8=(select b.Fld_stor8 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	

		strSQL = "update TMP_SRED_INI set Fld_stor11=(select b.Fld_stor11 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	

		strSQL = "update TMP_SRED_INI set Fld_stor14=(select b.Fld_stor14 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	
	
		strSQL = "update TMP_SRED_INI set Fld_stor15=(select b.Fld_stor15 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	

		strSQL = "update TMP_SRED_INI set Fld_stor17=(select b.Fld_stor17 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	
		
		strSQL = "update TMP_SRED_INI set Fld_stor18=(select b.Fld_stor18 from TMP_SRED_INIV AS b where b.Ftabn_id=TMP_SRED_INI.Ftabn_id and TMP_SRED_INI.Fld_date=b.Fld_date)"
		ExecuteSQL(strSQL);	

	}
		
	ExecuteSQL("drop table TMP_SRED_FORUPDATE", false);
	strSQL = "select * into TMP_SRED_FORUPDATE "
			+" from TMP_SRED_INI "
			+" where FTABN_ID in (select FTABN_ID from ^SRED_INI "
								+" where FLD_DATE="+ sqlTo(vardate) +")";
	ExecuteSQL(strSQL);
	ExecuteSQL("CREATE INDEX FTABN_ID ON TMP_SRED_FORUPDATE (FTABN_ID)", false);
		                        
	var sWhereRscht = "";
	if(fis_rtabn)
		sWhereRscht = " and FTABN_ID in (select r.FTABN_ID from ^CL_RSCHT r "
						+" where r.FDATE="+ sqlTo(rasch_mes)
						+(base_month? " and r.FDATEB="+ sqlTo(base_month) : "");
	if(!getPar("KOMKOLD")){
		strSQL = "insert into ^SRED_INI "
			+"(FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
			+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
			+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13,FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19)"
		+" select FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
			+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
			+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13,FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19"
		+" from TMP_SRED_INI tmp "				
		+" where tmp.FTABN_ID not in (select FTABN_ID from TMP_SRED_FORUPDATE)"
			+ sWhereRscht;
	}else{
		strSQL = "insert into ^SRED_INI "
				+"(FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
				+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
				+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13,FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19,FLD_STOR20)"
			+" select FLD_DATE,FTABN_ID,FLD_STOR,FLD_STOR1,FLD_STOR2"
				+",FLD_STOR3,FLD_STOR4,FLD_STOR5,FLD_STOR6,FLD_STOR8"
				+",FLD_STOR10,FLD_STOR11,FLD_STOR12,FLD_STOR13,FLD_STOR14,FLD_STOR15,FLD_STOR17,FLD_STOR18,FLD_STOR19,FLD_STOR20"
			+" from TMP_SRED_INI tmp "				
			+" where tmp.FTABN_ID not in (select FTABN_ID from TMP_SRED_FORUPDATE)"
				+ sWhereRscht;
	}
	ExecuteSQL(strSQL);
		
	var sFrom = " from TMP_SRED_FORUPDATE as tmp where tmp.FTABN_ID=^SRED_INI.FTABN_ID";
	
	//если базовый месяц, то нужно перезаписывать всегда, или когда параметр bln_mes_nach==0
	if ((bln_mes_nach!=0 && !differ(base_month, rasch_mes)) || bln_mes_nach==0){
		if(!getPar("KOMKOLD")){
			strSQL = "update ^SRED_INI "
				+" set  FLD_STOR = (select FLD_STOR "+ sFrom +")"
	       			+", FLD_STOR1 = (select FLD_STOR1 "+ sFrom +")"
	       			+", FLD_STOR2 = (select FLD_STOR2 "+ sFrom +")" 
	       			+", FLD_STOR3 = (select FLD_STOR3 "+ sFrom +")"
	       			+", FLD_STOR4 = (select FLD_STOR4 "+ sFrom +")"
	       			+", FLD_STOR5 = (select FLD_STOR5 "+ sFrom +")"
	       			+", FLD_STOR6 = (select FLD_STOR6 "+ sFrom +")"
	       			+", FLD_STOR8 = (select FLD_STOR8 "+ sFrom +")"
	       			+", FLD_STOR10 = (select FLD_STOR10 "+ sFrom +")"
	       			+", FLD_STOR11 = (select FLD_STOR11 "+ sFrom +")" 
	       			+", FLD_STOR12 = (select FLD_STOR12 "+ sFrom +")"
	       			+", FLD_STOR13 = (select FLD_STOR13 "+ sFrom +")"
	       			+", FLD_STOR14 = (select FLD_STOR14 "+ sFrom +")"
	       			+", FLD_STOR15 = (select FLD_STOR15 "+ sFrom +")"
	       			+", FLD_STOR17 = (select FLD_STOR17 "+ sFrom +")"
	       			+", FLD_STOR18 = (select FLD_STOR18 "+ sFrom +")"       			       			
	       			+", FLD_STOR19 = (select FLD_STOR19 "+ sFrom +")"
	       		+" where FTABN_ID in (select FTABN_ID from TMP_SRED_FORUPDATE)"
	       			+" and FLD_DATE="+ sqlTo(vardate)
	       			+ sWhereRscht;
		}else{
			strSQL = "update ^SRED_INI "
			+" set  FLD_STOR = (select FLD_STOR "+ sFrom +")"
       			+", FLD_STOR1 = (select FLD_STOR1 "+ sFrom +")"
       			+", FLD_STOR2 = (select FLD_STOR2 "+ sFrom +")" 
       			+", FLD_STOR3 = (select FLD_STOR3 "+ sFrom +")"
       			+", FLD_STOR4 = (select FLD_STOR4 "+ sFrom +")"
       			+", FLD_STOR5 = (select FLD_STOR5 "+ sFrom +")"
       			+", FLD_STOR6 = (select FLD_STOR6 "+ sFrom +")"
       			+", FLD_STOR8 = (select FLD_STOR8 "+ sFrom +")"
       			+", FLD_STOR10 = (select FLD_STOR10 "+ sFrom +")"
       			+", FLD_STOR11 = (select FLD_STOR11 "+ sFrom +")" 
       			+", FLD_STOR12 = (select FLD_STOR12 "+ sFrom +")"
       			+", FLD_STOR13 = (select FLD_STOR13 "+ sFrom +")"
       			+", FLD_STOR14 = (select FLD_STOR14 "+ sFrom +")"
       			+", FLD_STOR15 = (select FLD_STOR15 "+ sFrom +")"
       			+", FLD_STOR17 = (select FLD_STOR17 "+ sFrom +")"
       			+", FLD_STOR18 = (select FLD_STOR18 "+ sFrom +")"       			       			
       			+", FLD_STOR19 = (select FLD_STOR19 "+ sFrom +")"
       			+", FLD_STOR20 = (select FLD_STOR20 "+ sFrom +")"       			
       		+" where FTABN_ID in (select FTABN_ID from TMP_SRED_FORUPDATE)"
       			+" and FLD_DATE="+ sqlTo(vardate)
       			+ sWhereRscht;
		}
		ExecuteSQL(strSQL);		
	}
	//если месяц не базовый, то нужно перезаписывать все, кроме больничных, которые реагируют на параметр
	//если базовый месяц, то нужно перезаписывать всегда, или когда параметр bln_mes_nach==0
	if ((bln_mes_nach!=0 && differ(base_month, rasch_mes)!=0)){
		if(!getPar("KOMKOLD")){
			strSQL = "update ^SRED_INI "
				+" set  FLD_STOR = (select FLD_STOR "+ sFrom +")"
	       			+", FLD_STOR1 = (select FLD_STOR1 "+ sFrom +")"
	       			+", FLD_STOR2 = (select FLD_STOR2 "+ sFrom +")" 
	       			+", FLD_STOR3 = (select FLD_STOR3 "+ sFrom +")"
	       			+", FLD_STOR4 = (select FLD_STOR4 "+ sFrom +")"
	       			+", FLD_STOR5 = (select FLD_STOR5 "+ sFrom +")"
	       			+", FLD_STOR6 = (select FLD_STOR6 "+ sFrom +")"
	       			+", FLD_STOR10 = (select FLD_STOR10 "+ sFrom +")"
	       			+", FLD_STOR12 = (select FLD_STOR12 "+ sFrom +")"
	       			+", FLD_STOR13 = (select FLD_STOR13 "+ sFrom +")"
	       			+", FLD_STOR19 = (select FLD_STOR19 "+ sFrom +")"
	       		+" where FTABN_ID in (select FTABN_ID from TMP_SRED_FORUPDATE)"
	       			+" and FLD_DATE="+ sqlTo(vardate)
	       			+ sWhereRscht;
		}else{
			strSQL = "update ^SRED_INI "
			+" set  FLD_STOR = (select FLD_STOR "+ sFrom +")"
       			+", FLD_STOR1 = (select FLD_STOR1 "+ sFrom +")"
       			+", FLD_STOR2 = (select FLD_STOR2 "+ sFrom +")" 
       			+", FLD_STOR3 = (select FLD_STOR3 "+ sFrom +")"
       			+", FLD_STOR4 = (select FLD_STOR4 "+ sFrom +")"
       			+", FLD_STOR5 = (select FLD_STOR5 "+ sFrom +")"
       			+", FLD_STOR6 = (select FLD_STOR6 "+ sFrom +")"
       			+", FLD_STOR10 = (select FLD_STOR10 "+ sFrom +")"
       			+", FLD_STOR12 = (select FLD_STOR12 "+ sFrom +")"
       			+", FLD_STOR13 = (select FLD_STOR13 "+ sFrom +")"
       			+", FLD_STOR19 = (select FLD_STOR19 "+ sFrom +")"
       			+", FLD_STOR20 = (select FLD_STOR20 "+ sFrom +")"       			
       		+" where FTABN_ID in (select FTABN_ID from TMP_SRED_FORUPDATE)"
       			+" and FLD_DATE="+ sqlTo(vardate)
       			+ sWhereRscht;
		}
    	ExecuteSQL(strSQL);
	}
	return true;	
}