//расчет аналогичный r_sum.js, добавлен перенос дней пропорции из таблицы DLT
//использовался при изменении ставок начислений и удержаний в фонд занятости с 13.01.2009 для коректного применения ставок к каждой части месяца

function name_sump()
{
	return "Розрахунок готових сум з урахуванням пропорції днів|Расчет готовых сумм с учетом пропорции дней";
}

function r_sump(month, vopl, vidprk, lsfid, lsfid2, ftabn_id, svzpName)
{

	// дата начала
	var D1 = new Date(month.getFullYear(), month.getMonth(), 1);
	// дата конца
	var D2 = new Date(month.getFullYear(), month.getMonth() + 1, 1);
	D2.setDate(0);   
	//----------------------------------------------------------------------------------------------------------
	var is_rasch = 0 == differ(base_month, month);
	//----------------------------------------------------------------------------------------------------------
	// достаем цифры к названию файла
	var szTag = (month.getFullYear())+((month.getMonth()< 9)?"0":"") + (month.getMonth()+1);        
	var strTabName = (svzpName?svzpName:"svzp") + szTag;
      
// Проверка на существование таблицы "svzp%LD"
	if(!IsTableEx("zrp_res", "zrp_" + strTabName))
	{ 
//		var strPath = getPath("zrp_res");
		CreateTableEx("zrp_res","zrp_" + strTabName, "svzp");
	}
         			//IIF("fdb_sc=254", "'Итого'", sTxt) +" as Ftxt " +
         			
	/* зачем нам тут штатное расписание
  	var strSQL = "INSERT INTO ^" + strTabName
	 			+ "( ftabn_id,fwid_wp"
	 			+ ", fshpz"
	 			+ ", ffld_num"
	 			+ ", flsfid"
	 			+ ", fbdy"
	 			+ ", fedy"
	 			+ ", fsum"
	 			+ ", fday"
	 			+ ", fchas"
	 			+ ", fis_day"
	 			+ ", fmn"
	 			+ ", fvp"
	 			+ ", fid_prk"
	 			+ ", fvid_prk)"
			+ " SELECT wp.fwid_cl,pa.fwid_wp, pa.fshpz, pd.ffld_num, pd.flsfid, 0 AS fbdy, 0 AS fedy, pa.fsum, pd.fday"
					+ ", pd.fchas, pd.fis_day, " + sqlTo(d00) + " AS fmn, 0 AS fvp"
		 			+ ", pa.fwid as fid_prk"
					+ ", " + sqlTo(vidprk)+ " as fvid_prk"
			+ " FROM ((^prk_all AS pa INNER JOIN ^prk_drct AS pd ON pa.Fwid=pd.Fwid)"
					+ " INNER JOIN ^work_pers as wp ON wp.fwid=pa.fwid_wp)" 
			+ " WHERE (pa.fbdat>=" + sqlTo(D1) + " AND pa.fbdat<=" + sqlTo(D2) + ")" 
      */   			
	var sqlTabn = ftabn_id?" and pa.Ftabn_id in ("+ftabn_id+") ":"";
	var strSQL = "INSERT INTO ^" + strTabName
	 			+ "( ftabn_id, Fwid_wp"
	 			+ ", fshpz"
	 			+ ", ffld_num"
	 			+ ", flsfid"
	 			+ ", fbdy"
	 			+ ", fedy"
	 			+ ", fsum"
	 			+ ", fday"
	 			+ ", fchas"
	 			+ ", fis_day"
	 			+ ", fmn"
	 			+ ", fvp"
	 			+ ", fid_prk"
	 			+ ", fvid_prk"
	 			+ ", fproc)"
			+ " SELECT pa.ftabn_id,"+IIF("l.Fis6='+'","pa.fwid_wp","0")+" as Fwid_wp, pa.fshpz, pd.ffld_num, pd.flsfid, 0 AS fbdy, 0 AS fedy, pa.fsum, pd.fday"
					+ ", pd.fchas, pd.fis_day, " + sqlTo(d00) + " AS fmn, 0 AS fvp"
		 			+ ", pa.fwid as fid_prk"
					+ ", " + sqlTo(vidprk)+ " as fvid_prk, pa.fproc"
			+ " FROM ((^prk_all AS pa INNER JOIN ^prk_drct AS pd ON pa.Fwid=pd.Fwid) "
					+ " INNER JOIN ^lic_fld as l ON l.fid=pd.flsfid )"			
			+ " WHERE (pa.fbdat>=" + sqlTo(D1) + " AND pa.fbdat<=" + sqlTo(D2) + ")" + sqlTabn

	if(!poln_rasch)
		strSQL += " AND pa.fwid_wp IN (SELECT DISTINCT c.fwid_wp FROM ^chngtn AS c)";
	
	ExecuteSQL(strSQL);

    if(getPar("KOMKOLD")){	
    	svnrTableName = "svnr" + szTag;
    	if(!IsTableEx("zrp_res", "zrp_" + svnrTableName))
    	{
    		//var strPath = getPath("zrp_res");
    		CreateTableEx("zrp_res","zrp_" + svnrTableName, "svzp", "*");
    	}
	
    	var strSQL = "INSERT INTO ^"+svnrTableName 
    		+ "( ftabn_id, Fwid_wp"
    		+ ", ffld_num"
    		+ ", flsfid"
    		+ ", fsum"
    		+ ", fmn"
    		+ ", fvp)"
    		+ " SELECT pa.ftabn_id,"+IIF("l.Fis6='+'","pa.fwid_wp","0")+" as Fwid_wp, pd.ffld_num, pd.flsfid, pa.fsum"
    		+ ", " + sqlTo(d00) + " AS fmn, 0 AS fvp"
    		+ " FROM ((^prk_all AS pa INNER JOIN ^prk_drct AS pd ON pa.Fwid=pd.Fwid) "
    		+ " INNER JOIN ^lic_fld as l ON l.fid=pd.flsfid )"			
    		+ " WHERE (pa.fbdat>=" + sqlTo(D1) + " AND pa.fbdat<=" + sqlTo(D2) + ")" + sqlTabn

    		if(!poln_rasch)
    			strSQL += " AND pa.fwid_wp IN (SELECT DISTINCT c.fwid_wp FROM ^chngtn AS c)";

    	ExecuteSQL(strSQL);
    }
	
	if(0 == differ(base_month, month))
	{
		/* нужно обнулять fwid_wp для записей по удержаниям и зачем тут штатное расписание
		strSQL =  "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz"
		 			+ ", ffld_num"
		 			+ ", flsfid"
		 			+ ", fbdy"
		 			+ ", fedy"
		 			+ ", fsum"
		 			+ ", fday"
		 			+ ", fchas"
		 			+ ", fis_day"
		 			+ ", fmn"
		 			+ ", fvp"
		 			+ ", fid_prk"
		 			+ ", fvid_prk)"
		 		+ " SELECT wp.fwid_cl, pa.fwid_wp, pa.fshpz, nu.ffld_num, nu.flsfid, nu.fbdy, nu.fedy, pa.fsum"
		 			+ ", nu.fday, nu.fchas, nu.fis_day, nu.fmn1 AS fmn, 2 AS fvp, pa.fwid AS fid_prk, "
					+ sqlTo(vidprk) + " AS fvid_prk " 
		 		+ " FROM ((^prk_all AS pa INNER JOIN ^nxt_u AS nu ON pa.Fwid=nu.Fwid)"
		 				+ " INNER JOIN ^work_pers as wp ON wp.fwid=pa.fwid_wp)"
		 		+ " WHERE nu.fmn=" + sqlTo(D1);
		*/
		strSQL =  "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz"
		 			+ ", ffld_num"
		 			+ ", flsfid"
		 			+ ", fbdy"
		 			+ ", fedy"
		 			+ ", fsum"
		 			+ ", fday"
		 			+ ", fchas"
		 			+ ", fis_day"
		 			+ ", fmn"
		 			+ ", fvp"
		 			+ ", fid_prk"
		 			+ ", fvid_prk"
		 			+ ", fproc)"
		 		+ " SELECT pa.ftabn_id,"+IIF("l.Fis6='+'","pa.fwid_wp","0")+" as Fwid_wp, pa.fshpz, nu.ffld_num, nu.flsfid, nu.fbdy, nu.fedy, pa.fsum"
		 			+ ", nu.fday, nu.fchas, nu.fis_day, "+toSqlDate(sqlYear("nu.fmn1"),sqlMonth("nu.fmn1"),1)+" AS fmn, 2 AS fvp, pa.fwid AS fid_prk, "
					+ sqlTo(vidprk) + " AS fvid_prk, pa.fproc " 
		 		+ " FROM ((^prk_all AS pa INNER JOIN ^nxt_u AS nu ON pa.Fwid=nu.Fwid)"
					+ " INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid )"		 		
		 		+ " WHERE "+toSqlDate(sqlYear("nu.fmn"),sqlMonth("nu.fmn"),1)+"=" + Convert(sqlTo(D1),"DATE") + sqlTabn;
		if(!poln_rasch)
			strSQL += " AND pa.fwid_wp IN (SELECT DISTINCT c.fwid_wp FROM ^chngtn AS c)";
		
		ExecuteSQL(strSQL);
		if (IsTableEx("zrp_mdb", "zrp_dlt" + szTag))
		{
			/*нужно обнулять fwid_wp для удержаний
			strSQL="INSERT INTO ^" + strTabName + " (ftabn_id,fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy, fsum"
						+ ", fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk)"
				+ " SELECT ftabn_id,fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy, fsum"
						+ ", fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk"
				+ " FROM ^dlt" + szTag
				+ " WHERE ftabn_id<>0";
				//+ " WHERE " + ((null != fwid_wp)?("fwid_wp=" + sqlTo(fwid_wp)):"fwid_wp<>0");
			*/
			strSQL="INSERT INTO ^" + strTabName + " (ftabn_id,fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy, fsum"
						+ ", fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk, Fday_prop, fproc)"
				+ " SELECT d.ftabn_id,"+IIF("l.Fis6='+'","d.fwid_wp","0")+" as Fwid_wp, d.fshpz, d.ffld_num, d.flsfid, d.fbdy, d.fedy, d.fsum"
						+ ", d.fday, d.fchas, d.fis_day, d.fis_slct, d.fmn, d.fvp, d.fid_prk, Fday_prop, d.Fproc"
				+ " FROM (^dlt" + szTag
				+ " as d INNER JOIN ^lic_fld as l ON l.fid=d.flsfid )"				
				+ " WHERE d.ftabn_id<>0" + (ftabn_id?" and d.Ftabn_id in ("+ftabn_id+") ":"");
			ExecuteSQL(strSQL);
		}  

		if (IsTableEx("zrp_mdb", "zrp_dltu" + szTag))
		{
			/* нужно обнулять fwid_wp для записей по удержаниям и зачем тут штатное расписание			
			strSQL="INSERT INTO ^" + strTabName + " (ftabn_id, fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy"
						+ ", fsum, fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk, fvid_prk)"
				+ " SELECT pa.ftabn_id, pa.fwid_wp, pa.fshpz, du.ffld_num, du.flsfid, du.fbdy, du.fedy, pa.fsum"
						+ ", du.fday, du.fchas, du.fis_day, pa.fis_slct, du.fmn, du.fvp, du.fid_prk, pa.fvid_prk"
				+ " FROM ^prk_all AS pa INNER JOIN ^dltu" + szTag + " AS du ON pa.Fwid=du.Fwid"
				+ " WHERE " + ((null != fwid_wp)?("pa.fwid_wp=" + sqlTo(fwid_wp)):"pa.fwid_wp<>0");
			*/
			strSQL="INSERT INTO ^" + strTabName + " (ftabn_id, fwid_wp, fshpz, ffld_num, flsfid, fbdy, fedy"
						+ ", fsum, fday, fchas, fis_day, fis_slct, fmn, fvp, fid_prk, fvid_prk, fproc)"
				+ " SELECT pa.ftabn_id,"+IIF("l.Fis6='+'","pa.fwid_wp","0")+" as Fwid_wp, pa.fshpz, du.ffld_num, du.flsfid, du.fbdy, du.fedy, pa.fsum"
						+ ", du.fday, du.fchas, du.fis_day, pa.fis_slct, du.fmn, du.fvp, pa.fwid, pa.fvid_prk, pa.fproc"
				+ " FROM ((^prk_all AS pa INNER JOIN ^dltu" + szTag + " AS du ON pa.Fwid=du.Fwid)"
				+ " INNER JOIN ^lic_fld as l ON l.fid=du.flsfid )"				
				+ " WHERE pa.Fin_table LIKE ('%"+szTag+"') " + sqlTabn;
			ExecuteSQL(strSQL);
		}  

		/*нужно обнулять fwid_wp для удержаний и зачем тут штатное расписание
		strSQL =  "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz"
		 			+ ", ffld_num"
		 			+ ", flsfid"
		 			+ ", fbdy"
		 			+ ", fedy"
		 			+ ", fsum"
		 			+ ", fday"
		 			+ ", fchas"
		 			+ ", fis_day"
		 			+ ", fmn"
		 			+ ", fvp"
		 			+ ", fid_prk"
		 			+ ", fvid_prk)"
		 		+ " SELECT wp.fwid_cl,nu.fwid_wp, nu.fshpz, nu.ffld_num, nu.flsfid, nu.fbdy, nu.fedy, -nu.fsum"
		 			+ ", nu.fday, nu.fchas, nu.fis_day, nu.fmn, 1 AS fvp, nu.fwid AS fid_prk"
		 			+ ", " + sqlTo(vidprk)+ " as fvid_prk"
		 		+ " FROM ^nxt AS nu INNER JOIN ^work_pers as wp ON wp.fwid=nu.fwid_wp"
		 		+ " WHERE nu.fmn1=" + sqlTo(D1); 
		*/
		//исправила Fid_prk
		strSQL =  "INSERT INTO ^" + strTabName
		 			+ "( ftabn_id,fwid_wp"
		 			+ ", fshpz"
		 			+ ", ffld_num"
		 			+ ", flsfid"
		 			+ ", fbdy"
		 			+ ", fedy"
		 			+ ", fsum"
		 			+ ", fday"
		 			+ ", fchas"
		 			+ ", fis_day"
		 			+ ", fmn"
		 			+ ", fvp"
		 			+ ", fid_prk"
		 			+ ", fvid_prk"
		 			+ ", fproc)"
		 		+ " SELECT nu.ftabn_id, "+IIF("l.Fis6='+'","nu.fwid_wp","0")+" as Fwid_wp, nu.fshpz, nu.ffld_num, nu.flsfid, nu.fbdy, nu.fedy, -nu.fsum"
		 			+ ", nu.fday, nu.fchas, nu.fis_day, nu.fmn, 1 AS fvp, nu.fid_prk AS fid_prk"
		 			+ ", " + sqlTo(vidprk)+ " as fvid_prk, nu.Fproc"
		 		+ " FROM (^nxt AS nu "
				+ " INNER JOIN ^lic_fld as l ON l.fid=nu.flsfid )"		 		
		 		+ " WHERE nu.fmn1=" + sqlTo(D1) + (ftabn_id?" and nu.Ftabn_id in ("+ftabn_id+") ":""); 
			
		if(!poln_rasch)
			strSQL += " AND nu.fwid_wp IN (SELECT DISTINCT c.fwid_wp FROM ^chngtn AS c)";
		ExecuteSQL(strSQL);
		
		//в телекоме появляются записи с нулевыми Ffld_num 
		ExecuteSQL("UPDATE ^"+strTabName+" SET Ffld_num=(SELECT Ffld_num FROM ^lic_fld as l WHERE l.Fid=^"
					+strTabName+".Flsfid) WHERE Ffld_num=0" + (ftabn_id?" and Ftabn_id in ("+ftabn_id+") ":""));
	}
	return true;
}