include("servis/date.js");
include("Objects/DpLicf.js")
include("Objects/DpShtat.js");
include("doc/DpDoc.js");

function r_tlfrom(mdat,vvopl,mvvdpl,mvvcslid,vvprk, base_month, vvlsfid2)
{
	var table, szTag, szName, tblOut;
	var doc = "avto:com.debet.avto";
	var D1 = firstDay(mdat);
	var D2 = lastDay(mdat);
	
	szTag = month_txt(D1);
	
	//проверка на существование модуля 
	var arrModules = getModules();
	var ok = false;
	for(var i in arrModules)
	{
		if(String(arrModules[i]).toLowerCase() == "avto")
		{
			ok = true;
		}
	}
	
	if (!ok)
	{
		return true;
	}
	
	//смотрим на параметры папок и отбираем номера которые участвуют в расчете ЗП
	strSQL = " SELECT FNOP" 
				+" FROM ^CL_LNK"
				+" WHERE 1=1"
					+" AND FDOC = "+sqlTo(doc)
					+" AND FNOP <> "+sqlTo(0)
	var opTbl = OpenTable(strSQL);
	var listFnop = "";
	for(; !opTbl.IsEOF(); opTbl.MoveNext())
	{
		//снимаем параметр папки "_is_load2zp" == true то записуем номер этой папки
		var oDoc = new DpDoc(doc, opTbl.getValue("FNOP"));
		if(oDoc.getPar("_is_load2zp"));
		{
			if(isEmpty(listFnop))
			{
				listFnop += opTbl.getValue("FNOP");
			}
			else
			{
				listFnop += ","+opTbl.getValue("FNOP")
			}
		}
		oDoc = null;
	}
	opTbl.Close();
	opTbl = null;
	
	strSQL = " SELECT"
				+" H.FDRIVER"
				+", R.FSHPZ"
				+", SUM(R.FCDV) AS FCHAS"
				+", SUM(R.FDDV) AS FDAY"
				+", SUM(R.FSUM - R.FSDOPL - R.FKLSUM) AS FSUM"
				+", SUM(R.FKLSUM) AS FKLSUM"
				+", R.FLSFIDKLASSN"
			+" FROM"
				+" ^WAYBILL H"
				+", ^RWAYBILL R"
			+" WHERE 1 = 1"
				+" AND H.FDOC_DAT >= "+sqlTo(D1)
				+" AND H.FDOC_DAT <= "+sqlTo(D2)
				+" AND H.FWID = R.FID_DOC"
				+" AND H.FNOP IN ("+listFnop+")"
			+" GROUP BY "
				+" H.FDRIVER"
				+", R.FSHPZ"
				+", R.FLSFIDKLASSN"
	table = OpenTable("s", strSQL)
	
	if (table.IsEmpty())
	{
		return;
	}

	szName = "SVZP" + szTag;
	tblOut = "ZRP_" + szName;
	if(!IsTableEx("ZRP_RES", tblOut))
	{
		CreateTableEx("ZRP_RES", tblOut, "SVZP", "*");
	}
		
	//объкт нужен для получения id штатного
	var oShtat = new DpShtat("" , D1, D2);
	
	var oLicf = new DpLicf();
	//установим код поля ЛС
	//чтобы получить номер 
	oLicf.setFid(mvvcslid);

	for(; !table.IsEOF(); table.MoveNext())
	{
		mFwid_wp = 0;
		oShtat.setEmployeCod(table.getValue("FDRIVER"));
		oShtat.arrCtrls = new Array();
		oShtat.arrCtrls["fcod"] = new Object(this.value = 0)
		oShtat.arrCtrls["fcod"].value = table.getValue("FDRIVER");
		if(oShtat.validCod())
		{
			mFwid_wp = oShtat.getFwid();
		}
		else
		{
			var msg = "r_tlfrom: ";
			msg += ru("Для таб.№"+table.getValue("FDRIVER")+" нету записи в штатном расписании."
						, "Для таб.№"+table.getValue("FDRIVER")+" нема запису в штатному розкладі.");
			alert(msg);
			continue;
		}
		
		var m = {};
		m.FTABN_ID = getTabnID(table.getValue("FDRIVER"));
		m.FWID_WP = mFwid_wp;
		m.FSHPZ = table.getValue("FSHPZ");
		m.FSUM = table.getValue("FSUM");
		m.FFLD_NUM = oLicf.getFnum();
		m.FLSFID = oLicf.getFid();
		m.FDAY = table.getValue("FDAY");
		m.FCHAS = table.getValue("FCHAS");
		m.FBDY = D1.getDate();
		m.FEDY = D2.getDate();
		m.FMN = d00;
		m.FVP = 0;
		m.FID_PRK = vvprk;
		updateTable("^"+szName, m, true);
		
		//если сума для классности не пустая то запишем ее в svzp
		if(!isEmpty(table.getValue("FKLSUM")) && !isEmpty(table.getValue("FLSFIDKLASSN")))
		{
			oLicf.setFid(table.getValue("FLSFIDKLASSN"));
			m.FLSFID = oLicf.getFid();
			m.FFLD_NUM = oLicf.getFnum();
			m.FSUM = table.getValue("FKLSUM");
			m.FDAY = table.getValue("FDAY");
			m.FCHAS = table.getValue("FCHAS");
			updateTable("^"+szName, m, true);
		}
	}
	table.close();

	//теперь необходимо распределить сумму доплат из строк
	strSQL = "SELECT"
				+" H.FDRIVER"
				+", R.FSHPZ"
				+", SUM(D.FTIME) AS FCHAS"
				+", SUM(D.FSUM) AS FSUM"
				+", D.FLSFID"
			+" FROM"
				+" (^WAYBILL H LEFT JOIN ^RWAYBILL R ON H.FWID = R.FID_DOC)"
					+" LEFT JOIN ^ROWS_DOPL D ON R.FWID = D.FID_DOC"
			+" WHERE 1 = 1"
				+" AND D.FDOC = "+sqlTo(doc)
				+" AND H.FDOC_DAT >= "+sqlTo(D1)
				+" AND H.FDOC_DAT <= "+sqlTo(D2)
				+" AND R.FSDOPL <> 0"
				+" AND H.FNOP IN ("+listFnop+")"
			+" GROUP BY "
				+" H.FDRIVER"
				+", R.FSHPZ"
				+", D.FLSFID"
	table = OpenTable("s", strSQL)
	
	//запись доплат в svzp
	for(; !table.IsEOF(); table.MoveNext())
	{
		mFwid_wp = 0;
		oShtat.setEmployeCod(table.getValue("FDRIVER"));
		oShtat.arrCtrls = new Array();
		oShtat.arrCtrls["fcod"] = new Object(this.value = 0);
		oShtat.arrCtrls["fcod"].value = table.getValue("FDRIVER");
		if(oShtat.validCod())
		{
			mFwid_wp = oShtat.getFwid();
		}
		else
		{
			var msg = "r_tlfrom (доплаты): ";
			msg += ru("Для таб.№"+table.getValue("FDRIVER")+" нету записи в штатном расписании."
						, "Для таб.№"+table.getValue("FDRIVER")+" нема запису в штатному розкладі.");
			alert(msg);
			continue;
		}
		oLicf.setFid(table.getValue("FLSFID"))
		
		var m = {};
		m.FTABN_ID = getTabnID(table.getValue("FDRIVER"));
		m.FWID_WP = mFwid_wp;
		m.FSHPZ = table.getValue("FSHPZ");
		m.FSUM = table.getValue("FSUM");
		m.FFLD_NUM = oLicf.getFnum();
		m.FLSFID = oLicf.getFid();
		m.FCHAS = table.getValue("FCHAS");
		m.FBDY = D1.getDate();
		m.FEDY = D2.getDate();
		m.FMN = d00;
		m.FVP = 0;
		m.FID_PRK = vvprk;
		updateTable("^"+szName, m, true);
	}
	table.Close();
	
	//запись строк с помошниками
	strSQL = "SELECT"
				+" RH.FTABN"
				+", RH.FSHPZ"
				+", SUM(RH.FHOUR) AS FCHAS"
				+", SUM(RH.FDAY) AS FDAY"
				+", SUM(RH.FSUM) AS FSUM"
			+" FROM"
				+" ^WAYBILL H LEFT JOIN ^ROWS_HELP RH ON H.FWID = RH.FID_DOC"
			+" WHERE 1 = 1"
				+" AND RH.FDOC = "+sqlTo(doc)
				+" AND H.FDOC_DAT >= "+sqlTo(D1)
				+" AND H.FDOC_DAT <= "+sqlTo(D2)
				+" AND RH.FSUM <> 0"
				+" AND H.FNOP IN ("+listFnop+")"
			+" GROUP BY"
				+" RH.FTABN"
				+", RH.FSHPZ"
	table = OpenTable("s", strSQL);
	
	//установим код поля ЛС
	//чтобы получить номер 
	oLicf.setFid(mvvcslid);
	
	//запись доплат в svzp
	for(; !table.IsEOF(); table.MoveNext())
	{
		mFwid_wp = 0;
		oShtat.setEmployeCod(table.getValue("FTABN"));
		oShtat.arrCtrls = new Array();
		oShtat.arrCtrls["fcod"] = new Object(this.value = 0);
		oShtat.arrCtrls["fcod"].value = table.getValue("FTABN");
		if(oShtat.validCod())
		{
			mFwid_wp = oShtat.getFwid();
		}
		else
		{
			var msg = "r_tlfrom (помошники): ";
			msg += ru("Для таб.№"+table.getValue("FTABN")+" нету записи в штатном расписании."
						, "Для таб.№"+table.getValue("FTABN")+" нема запису в штатному розкладі.");
			alert(msg);
			continue;
		}
		
		var m = {};
		m.FTABN_ID = getTabnID(table.getValue("FTABN"));
		m.FWID_WP = mFwid_wp;
		m.FSHPZ = table.getValue("FSHPZ");
		m.FSUM = table.getValue("FSUM");
		m.FFLD_NUM = oLicf.getFnum();
		m.FLSFID = oLicf.getFid();
		m.FCHAS = table.getValue("FCHAS");
		m.FDAY = table.getValue("FDAY");
		m.FBDY = D1.getDate();
		m.FEDY = D2.getDate();
		m.FMN = d00;
		m.FVP = 0;
		m.FID_PRK = vvprk;
		updateTable("^"+szName, m, true);
	}
	table.Close();
		
	oShtat = null;
	oLicf = null;
	return;
}

function getTabnID(cod)
{
	var ret = false;
	cod = Number(cod);
	
	var strSQL = "SELECT FWID_CL"
						+" FROM ^CLRELCLCL"
						+" WHERE 1=1"
							+" AND FCL = " + sqlTo(getPar("CODPERS"))			
							+" AND FCOD = " + sqlTo(cod)			
	var sn = getSnap(strSQL);
	if(sn != null && !isEmpty(sn[0]))
	{
		ret = sn[0];
	}
	sn = null;
	
	return ret;
}