include("Objects/DpShifPZ.js");
include("doc/DpDoc.js");
include("add_sotr.js");

var tblName = "^prk1";
var Validation = true;
var mFvid = null;
var Cl_ShifPZ = null
var zat = 0;

function Load()
{
	Caption("Додавання співробітників за видом приказу|Добавление сотрудников по виду приказа");
	if (extPar==null)
		return;

	mFvid = extPar.fvid;
	strSQL = "select fan from ^lic_fld as f inner join ^cl_prik as p"
			+ " on f.fid=p.flsfid where p.fvid=" + sqlTo(mFvid);
	var tlic = getSnap(strSQL);
	if(null != tlic)
		zat = tlic[0];

	if(532 == extPar.fz6)
		tblName = "^prk3";
	else if(522 == extPar.fz6)
		tblName = "^prk2";
	else if(512 == extPar.fz6)
		tblName = "^prk1";

	HNAZV.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	HPRIM.mask = "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&";
	HSUM.mask="######.##";
	HNOM_PRIK.mask=strRepl("&", 15);
	HSHPZ.mask="&&&&&&&&&&&&&&&";
	Disable(HNAZV);

	setValid(HBDAT, Fbdat_Valid);
	setValid(HEDAT, Fedat_Valid);
   
	// Создается объект для ввода шифра производственных затрат   
	Cl_ShifPZ = new DpShifPZ();
	Cl_ShifPZ.setFshpz(0);
	Cl_ShifPZ.linkCtrl(HSHPZ, HSHPZ_TXT);
	
	HNAZV.value = extPar.nazv;
	HBDAT.value = d00;
	HEDAT.value = d00;
	HSUM.value  = 0;
//	var snap = getSnap("SELECT MAX(fnom_prik) FROM "+ tblName);
//	HNOM_PRIK.value  = (null == snap)?1:((null==snap[0])?1:(snap[0]+1));
	HDAT_PRIK.value  = d00;
	HPRIM.value  = "";
}

function onSave()
{
	var sotrList = AddSotrPrk(HBDAT.value, HEDAT.value);
	if("" != sotrList)
	{
//Сохранение приказов в XML
		var strSQL = "SELECT fwid_cl, fwid FROM ^work_pers WHERE fwid IN (" + sotrList + ")";
		var tmpTable = OpenTable("s", strSQL);
		if(!tmpTable.isEmpty())
		{
			for(tmpTable.MoveFirst(); !tmpTable.isEOF(); tmpTable.MoveNext())
			{
				var objDoc = new DpDoc("com.debet.cdr.pf", 0);
				objDoc.loadByID(tmpTable.getValue("fwid_cl"));
				var objPrk = objDoc.createPrk();
				objPrk.setID(HNOM_PRIK.value);
				objPrk.setAttribute("ID", HNOM_PRIK.value);
				objPrk.setAttribute("dat_prk", StrDat(HDAT_PRIK.value, "DMY"));
				objPrk.setAttribute("vid", mFvid);
				objPrk.setAttribute("bdat", StrDat(HBDAT.value, "DMY"));
				objPrk.setAttribute("edat", StrDat(HEDAT.value, "DMY"));
				objPrk.setAttribute("sum", HSUM.value);
				objPrk.setAttribute("prk", tblName);
				objDoc.addPrk(objPrk, tmpTable.getValue("fwid"));
				objDoc.save();
				
			}
		}
		
		var hpz = Cl_ShifPZ.getFshpz();
		strSQL = "INSERT INTO " + tblName + "(fvid_prk, fbdat, fedat, fsum, fdat_prik, fnom_prik, fshpz, fwid_wp)"
			+ " SELECT " + sqlTo(mFvid) + " AS fvid_prk"
				+ ", " + sqlTo(HBDAT.value) + " AS fbdat"
				+ ", " + sqlTo(HEDAT.value) + " AS fedat"
				+ ", " + sqlTo(HSUM.value) + " AS fsum"
				+ ", " + sqlTo(HDAT_PRIK.value) + " AS fdat_prik"
				+ ", " + sqlTo(HNOM_PRIK.value) + " AS fnom_prik"
				+ ", " + IIF( zat + "=0"
							, IIF(sqlTo(hpz) + "=0", "d.fshpz", sqlTo(hpz))
							, SqlConCat("LEFT(" + IIF(sqlTo(hpz) + "=0", "d.fshpz", sqlTo(hpz)) 
										+ ", LENGTH(" + IIF(sqlTo(hpz) + "=0", "d.fshpz", sqlTo(hpz)) + ")-1)"
										, Convert(zat, "STR"))) + " AS fshpz"
				+ ", w.fwid AS fwid_wp"
			+ " FROM ^work_pers AS w RIGHT JOIN ^stru_dol AS d ON w.fwid_dol=d.fwid"
			+ " WHERE w.fwid IN (" + sotrList + ")";
			
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO ^prk_txt (fwid, fvid_prk, fnazv, fbdat, fedat, fdat_prik, fnom_prik)"
				+ " VALUES ("
					+ sqlTo(GetUID())
					+ ", " + sqlTo(mFvid)
					+ ", " + sqlTo(HPRIM.value)
					+ ", " + sqlTo(HBDAT.value)
					+ ", " + sqlTo(HEDAT.value)
					+ ", " + sqlTo(HDAT_PRIK.value)
					+ ", " + sqlTo(HNOM_PRIK.value) 
				+ ")";
		ExecuteSQL(strSQL);
	}
	
}

function Fbdat_Valid()
{
	var result = !isEmpty(HBDAT.value);
	return result;
}

function Fedat_Valid()
{
	var result = !isEmpty(HEDAT.value);
	if(true == result)
	{
		result = 1!= differ(HBDAT.value, HEDAT.value);
	}
	
	return result;
}
include("sys\\DpBaseDlg.js");