function r_amnds(parDat)
{
	//расчет НДС
	DropTable("TAMSR0");
	DropTable("TAMSR01");
	DropTable("TAMSR02");
	DropTable("TAMSR03");
	DropTable("TAMSR1");
	DropTable("TAMSR2");
	DropTable("TAMSR3");
	DropTable("TAMSR4");

	var offset, ostsr;

	new_dat = parDat;

	fis_amexist = true;
	if (!IsTable("AMORTSRN")) 
		fis_amexist = false;
	if (!fis_amexist)
	{
		CreateTable("AMORTSRN", "AMORT");
		strSQL = "CREATE Index AMORTSRN on AMORTSRN (FKEYEXPR)";
		ExecuteSQL(strSQL);
	}
	else
	{
		strSQL = "delete from AMORTSRN";
		ExecuteSQL(strSQL);
	}

	strSQL = "select * from ^OS0NDS where Fbdat<="+sqlTo(new_dat)+" and Fedat>="+sqlTo(new_dat)+" and Fgroup<>6 order by Finv_num";
	os0b = OpenTable("s", strSQL);
	if (os0b.IsEmpty())
	{
		alert(ru("Список ОС за данный период пуст","Список ОЗ за даний період порожній"));
		return false;
	}

	while (!os0b.IsEOF())
	{
		WAIT ("N ="+String(os0b.getValue("Finv_num")));

		mon_sum= 0;
		all_am = 0;

		mFgroup = toScrObj(os0b.getValue("Fgroup"))
		os0b_pric = toScrObj(os0b.getValue("Forig_pric"));
		mFiznos = toScrObj(os0b.getValue("Fiznos"));
		os0b_bd   = new Date(os0b.getValue("Fbdat"));

		// предыдущая дата
		os0b_bd_1 = new Date(os0b.getValue("Fbdat").getYear()+1900, 
							os0b.getValue("Fbdat").getMonth(), 
							os0b.getValue("Fbdat").getDate()-1);
		fis_izgr = false;
		fis_rash = true;

		//если 0 группа, то не участв. в расчете
		if (mFgroup==0)
			fis_rash = false;
		fis_frstr = false; 
		strSQL = "select * from ^OS0NDS where Finv_num="
					+sqlTo(os0b.getValue("Finv_num"))
					+" and Fedat="+sqlTo(os0b_bd_1);
//		tos0n = OpenTable("s", strSQL);
		var oSnap = getSnap(strSQL);
//		if (tos0n.IsEmpty())
		if(oSnap==null)
			fis_frstr = true; //значит это самая первая запись 
		if (fis_frstr && (new Date(new_dat).getFullYear()==new Date(os0b_bd).getFullYear() && new Date(new_dat).getMonth()==new Date(os0b_bd).getMonth()))
			fis_rash = false;

		//если 1-е число, то проверяем на изменение группы. Если его не было, то эта запись не учитывается.
		if (new Date(os0b_bd).getDate()==1)
		{
			pFgroup = Number(izosdatb(os0b_bd_1, Number(os0b.getValue("Finv_num")), "group", "OS0NDS"));
			if (pFgroup!=-100)
			{
				if (pFgroup!=mFgroup)
				{
					fis_izgr = true;
					fis_rash = true;
				}
				else
				{
					os0b_pric = Number(izosdatb(os0b_bd_1, Number(os0b.getValue("Finv_num")), "orig_pric", "OS0NDS"))
					mFiznos   = Number(izosdatb(os0b_bd_1, Number(os0b.getValue("Finv_num")), "iznos", "OS0NDS"))
					os0b_bd   = new Date(izosdatb(os0b_bd_1, Number(os0b.getValue("Finv_num")), "bdat", "OS0NDS"))
				}
			}
			else
				fis_izgr = false;
		}
		if (fis_rash)
		{
			//непосредственный расчет амортизации
			if (!fis_izgr)
				mFbdat = new Date(new Date(os0b_bd).getFullYear(),new Date(os0b_bd).getMonth()+1, 1);
			else
				mFbdat = new Date(os0b_bd);
				
			kol_mes = round((((new_dat-mFbdat)/3600000)/24)/30.4367,0);
			nr_am = norm_am(new_dat, mFgroup, "")/3;
			if (os0b_pric>0)
				mon_sum = round(os0b_pric*nr_am*koef_am(new_dat),2);
			else
				mon_sum = 0;

			if (mon_sum<0)
			{
				mon_sum=0;
				mFiznos = os0b_pric;
			}
			if (kol_mes<0)
				mon_sum = 0
			all_am = 0;
			curbdat = mFbdat;
			for ( var i=1; i<=kol_mes; i++)
			{
				all_am = all_am + mon_sum;
				curbdat = new Date(curbdat.getFullYear(), curbdat.getMonth()+1,1);
			}
			mes_am = 0;			
			if (os0b_pric-(mFiznos+all_am)<=0)
				mes_am = 0;
			if (os0b_pric-(mFiznos+all_am)>0)
			{
				mes_am = (mon_sum-(os0b_pric-(mFiznos+all_am))<0)?mon_sum:os0b_pric-(mFiznos+all_am);
				if (mes_am<0) 
					mes_am = 0;
			}
			var xxiznos = 0;
			if (os0b_pric>0)
			{
				xxiznos = (os0b_pric>=Number(all_am)+Number(mFiznos)+Number(mes_am))?Number(all_am)+Number(mFiznos)+Number(mes_am):os0b_pric;
			}

			var m = new Object();
			m.Fgroup = mFgroup;
			m.Fdatkv = new_dat.getVarDate();
			m.Finv_num = Number(os0b.getValue("FINV_NUM"));
			m.Fsum_pv = mes_am;
			m.Fsum_izn = xxiznos;
			m.Fsum_am = os0b_pric;
			m.Fkol = Number(os0b.getValue("Fkol"));
			m.Forig_pric = os0b_pric-xxiznos;
			UpdateTable("AMORTSRN", m, true);
		}
		os0b.MoveNext();
	}//end while (!os0b.IsEOF())
	os0b.close();
	//подбивка итогов по индивидуальному расчету
	strSQL = "select sum(AMORTSRN.Fsum_pv) as Fsum_pv, sum(AMORTSRN.Fsum_izn) as Fsum_izn, "+
			"sum(AMORTSRN.Forig_pric) as Forig_pric, sum(AMORTSRN.Fsum_am) as Fsum_am, 999 as fdb_sc, 0 as fdb_su, 0 as fdb_st, 0 as ftdst, "+
			"0 as Ftdsu, 2 as Ftdsc, 0 as finv_num  into TAMSR4 from AMORTSRN ";
	ExecuteSQL(strSQL);

	strSQL = "INSERT into AMORTSRN " + getColumn("TAMSR4", true) + 
			" select " + getColumn("TAMSR4", false) + " from TAMSR4";
	ExecuteSQL(strSQL);

	strSQL = "UPDATE ^AMORTSRN set FKEYEXPR = " + SqlConCat(Convert("FTDSC", "STR"),Convert("FINV_NUM", "STR"));
	ExecuteSQL(strSQL);
}