//расчет дневника для почты по пятидневкам

include("Objects/DpGetDat.js");
include("sys/servis.js");

var rsi;
var rs;
var rsr;
var NOMD;
var prnPatt = "DNPTD";

function listLoad()
{
	NOMD = extPar.oDoc.getPar("_nomdn");

	if (extPar.mode=="CALC")
	{
		return r_dnptd();	
	}

	if (!IsTable("DN_HD") || !IsTable("DP130_C") || !IsTable("DP130_R") || !IsTable("DP130_S"))
	{
		alert(ru("Сначала произведите расчет!","Спочатку проведіть розрахунок!"));
		return false;
	}
}

function listTitle()
{	
	var sTitle = UR("Наявність і рух грошових коштів у касі|Наличие и движение денежных средств в кассе");
	var cap_tbl = getSnap("select fbdat,fedat from ^DP_HD");
	if(cap_tbl)
	{	
		dat1 = cap_tbl[0];
		dat2 = cap_tbl[1];
		sTitle += " за "+ StrDat(dat1,"DMY") +" - "+ StrDat(dat2,"DMY");
	}
	return sTitle;
}
	
function listSrc()
{	
	this.qrySet("Cross", "DP130", "Order", "FSTAT");
}

function listDpGrid()
{	
	include("Objects/DpGrid.js");
	
	var ColCaptU;
	var ColCaptR;
	var ColId;
		
	rsi = OpenTable( "c", "DP130");
	rs  = rsi.GetCol();
	rsr = rsi.GetRow();
	
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();
	
	var fstat = "=^FSTAT=="+ cl_sup +"? '"+ ru("Итог","Підсумок") +"'"
				+" : tcl('CL', 'TXT', "+ NOMD +", ^FSTAT)"; 
	gr.FieldEx(fstat, "Найменування статей|Наименование статей", 25);
		
	while (!rs.IsEOF())
	{
		ColCaptU = rs.getValue("Fsect")==3 ? "Прибуток\n"+ NumPtd("u", rs.getValue("Fdate")) 
				: rs.getValue("Fsect")==5 ? "Видаток\n"+ NumPtd("u",rs.getValue("Fdate")) 
				: (rs.getValue("Fsect")==4 || rs.getValue("Fsect")==6)? "Всього\nза місяць" 
				: "";
		ColCaptR = rs.getValue("Fsect")==3 ? "Приход\n"+ NumPtd("r",rs.getValue("Fdate")) 
				: rs.getValue("Fsect")==5 ? "Расход\n"+ NumPtd("r",rs.getValue("Fdate")) 
				: (rs.getValue("Fsect")==4 || rs.getValue("Fsect")==6)? "Итого\nза месяц" 
				: "";
		ColId = rs.getValue( "fColID" );
		gr.FieldEx(ColId, ColCaptU +"|"+ ColCaptR, 14);
       	rs.MoveNext();
	}
	oGrid.build();
}

function r_dnptd()
{
	var gd = new DpGetDat("d");
	if (gd.escape)
	{
		return false;
	}
	dat1 = gd.dat1;
	var dt = new Date(dat1);
	dat2 = new Date(dt.getYear(), dt.getMonth()+1, 0);

	var hdn_tbl = getSnap("select FWID from ^HDN where FWID="+ extPar.fwid);
	if (!hdn_tbl)
	{
		alert(ru("Запись не найдена!", "Запис не знайдено!"));
		return false;
	}
	
	var nPr = 1;
	var sPr = ru("Расчет итогов по пятидневкам", "Розрахунок підсумків по п'ятиденках");
	setProgressRange(0, 20);
	setProgressPos(nPr++, sPr);
	
	DropTable("DP130");
	DropTable("RDP_TM");
	DropTable("D130TMP");
	DropTable("D2130");
	DropTable("DR130TMP");
	DropTable("DR2130");
	DropTable("TTT");
	
	setProgressPos(nPr++, sPr);
	strSQL = "create table RDP_TM "
			+"(Fsum "+ SqlType("CURRENCY") 
			+",Fstat "+ SqlType("INT") 
			+",Fval "+ SqlType("INT") 
			+",Fprix "+ SqlType("BYTE") 
			+",Fdate "+ SqlType("DATE")
			+",Fbdat "+ SqlType("DATE")
			+",Fedat "+ SqlType("DATE") 
			+",Fid_doc "+ SqlType("INT") 
			+",Fwid "+ SqlType("COUNTER")
			+")";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "insert into RDP_TM (Fid_doc,Fsum,Fstat,Fval,Fprix,Fbdat,Fedat)"
			+" SELECT r.Fid_doc,r.Fsum,r.Fstat,r.Fval,r.Fprix"
				+",h.Fdoc_dat as Fbdat, h.Fdoc_date as Fedat "
			+" FROM ^RDN as r "
				+" left join ^HDN as h on h.FWID=r.FID_DOC"
			+" WHERE r.FNOP=0 OR r.FNOP="+ extPar.Nop;
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);	
	var rdptmp_tbl = OpenTable("s","RDP_TM");
	while (!rdptmp_tbl.IsEOF())
	{
		isCh = false;
		tobeg = rdptmp_tbl.getValue("Fbdat");
		bdat = new Date(tobeg);
		edat = new Date(rdptmp_tbl.getValue("Fedat"));
		dayb = bdat.getDate();
		daye = edat.getDate();
		monb = bdat.getMonth();
		yearb = bdat.getYear();
		
		if (dayb>=1 && dayb<=5 && daye>=1 && daye<=5)
		{
			tobeg = new Date(yearb+1900, monb, 1);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (dayb>=6 && dayb<=10 && daye>=6 && daye<=10)
		{
			tobeg = new Date(yearb+1900, monb, 6);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (dayb>=11 && dayb<=15 && daye>=11 && daye<=15)
		{
			tobeg = new Date(yearb+1900, monb, 11);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (dayb>=16 && dayb<=20 && daye>=16 && daye<=20)
		{
			tobeg = new Date(yearb+1900, monb, 16);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (dayb>=21 && dayb<=25 && daye>=21 && daye<=25)
		{
			tobeg = new Date(yearb+1900, monb, 21);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (dayb>=26 && dayb<=31 && daye>=26 && daye<=31)
		{
			tobeg = new Date(yearb+1900, monb, 26);
			//tobeg = tobeg.getVarDate();
			isCh = true;
		}
		if (isCh)
		{
			ExecuteSQL("update RDP_TM set Fdate="+ sqlTo(tobeg) 
					+" where FWID="+ rdptmp_tbl.getValue("Fwid"));			
		}
		rdptmp_tbl.MoveNext();
	}
	setProgressPos(nPr++, sPr);	
	strSQL = "SELECT Sum(RDP_TM.Fsum) AS Fsum,Fstat,Fdate,'3' AS Fsect"
			+" INTO D130TMP "
			+" FROM RDP_TM "
			+" WHERE FPRIX="+ SqlTrue 
				+" AND FDATE BETWEEN "+ sqlTo(dat1) +" AND "+ sqlTo(dat2)
			+" GROUP BY FSTAT,FDATE";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	ExecuteSQL("SELECT * INTO DP130 FROM D130TMP");
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(D130TMP.Fsum) AS Fsum,Fstat"
				+","+sqlTo(d00)+" AS Fdate,'4' AS Fsect"
			+" INTO D2130 FROM D130TMP "
			+" GROUP BY FSTAT";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DP130(Fsum,Fstat,Fdate,Fsect) "
			+" SELECT Fsum,Fstat,Fdate,Fsect FROM D2130";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(RDP_TM.Fsum) AS Fsum,Fstat,Fdate,'5' AS Fsect"
			+" INTO DR130TMP "
			+" FROM RDP_TM "
			+" WHERE FPRIX="+ SqlFalse 
				+" AND FDATE BETWEEN "+ sqlTo(dat1) +" AND "+ sqlTo(dat2)
			+" GROUP BY FSTAT,FDATE";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DP130(Fsum,Fstat,Fdate,Fsect) "
			+" SELECT Fsum,Fstat,Fdate,Fsect FROM DR130TMP";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(DR130TMP.Fsum) AS Fsum,Fstat"
				+","+sqlTo(d00)+" AS Fdate,'6' AS Fsect"
			+" INTO DR2130 FROM DR130TMP "
			+" GROUP BY FSTAT";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DP130(Fsum,Fstat,Fdate,Fsect) "
			+" SELECT Fsum,Fstat,Fdate,Fsect FROM DR2130";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "SELECT SUM(DP130.Fsum) AS Fsum"
				+","+sqlTo(cl_sup)+" AS Fstat,Fdate,Fsect"
			+" INTO TTT FROM DP130 "
			+" GROUP BY FSECT,FDATE";
	ExecuteSQL(strSQL);
	
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DP130(Fsum,Fstat,Fdate,Fsect) "
			+" SELECT Fsum,Fstat,Fdate,Fsect FROM TTT";
	ExecuteSQL(strSQL);
		
	//Создаем шахматные таблицы
	setProgressPos(nPr++, sPr);
	DropTable("DP130_S");
	DropTable("DP130_R");
	DropTable("DP130_C");
		
	// Выражения, идентифицирующие строку и столбец по основной таблице
	setProgressPos(nPr++, sPr);
	var RowIdExpr, ColIdExpr;
    ColIdExpr = SqlConCat(Convert("FSECT", "STR"), "'@'", Convert("FDATE", "STR"));
    RowIdExpr = Convert("FSECT", "STR");
	
	setProgressPos(nPr++, sPr);
	ExecuteSQL("SELECT DISTINCT Fsum as Fvalue, "
	        	+ ColIdExpr + " as FColId, "
	        	+ RowIdExpr + " as fRowId "
			  +" INTO DP130_S "
			  +" FROM DP130");
	setProgressPos(nPr++, sPr);		  
	ExecuteSQL("SELECT DISTINCT "+ RowIdExpr +" as fRowId, Fstat "
	        +" INTO DP130_R "
	        +" FROM DP130 "
	        +" ORDER BY Fstat");
	setProgressPos(nPr++, sPr);
	ExecuteSQL("SELECT DISTINCT "+ ColIdExpr +" as fColID, "
	        	+" Fsect, Fdate "
	        +" INTO DP130_C "
	        +" FROM DP130 "
	        +" ORDER BY Fsect, Fdate");
	setProgressPos(nPr++, sPr);
	if (SUBD==ORACLE || SUBD==DERBY)
		ExecuteSQL("DROP INDEX RowCol", false);
	ExecuteSQL("CREATE INDEX RowCol ON DP130_S (FrowId, FcolId)" );
	//Шахматные таблицы созданы
		
	//Сохраняем даты в таблице
	setProgressPos(nPr++, sPr);
	DropTable("DP_HD");
	ExecuteSQL("CREATE TABLE DP_HD "
        		+"(fbdat "+ SqlType("DATE") 
        		+",fedat "+ SqlType("DATE")
        		+",fnomdn "+ SqlType("INTEGER")
        		+")");
	setProgressPos(nPr++, sPr);
	strSQL = "INSERT INTO DP_HD (Fbdat,Fedat,Fnomdn)"
			 +" VALUES ("+ sqlTo(dat1) +","+ sqlTo(dat2) +","+ sqlTo(NOMD) +")";
	ExecuteSQL(strSQL);
	setProgressPos(0);
	
	return true;
}

function unLoad()
{
  	rsi.close();
}

function listMenuInit(ds)
{
    if (!rsi.IsEmpty())
    	ds.AddMenuItem("PRINT", "Друк списку|Печать списка");
}

function listMenuRun(nID)
{
	if (nID=="PRINT")
	{
	    include("Objects/DpTVars.js");
		var tv = new DpTVars(prnPatt);
		var bm = rsi.bookmark;
		tv.setHTbl(cap_tbl);
		tv.setRTbl(rsi);
		tv.print();
		rsi.bookmark = bm;
	}
}

include("sys/DpList.js");