// JScript source code
include("objects\\DpGetDat.js");
include("r_glavn.js");
include("TrnNBln.js");
include("objects\\DpGrid.js");
include("objects\\DpSc.js");
include("objects\\DpCl.js");
include("objects\\DpClcl.js");
include("objects\\DpObsl.js");

prnPatt="glavsc";
editAcc="";
delFilter=false;

var ds, gr, sta_num, sch_num, sub_num, dtgl, rsr;
var rs,rsi;
var menuMode;

function listLoad()
{
	with( this )
	{
		subAsk = askParam;
		subSrc = infSrc;
		printLabel = "glavsc";
		this.accDel = null;
	}
	
	dsSaveFormat(false);
	menuMode = list.par.menuMode;
	if (this.par.menuMode.substr(0,1) == "R")
		this.par.menuMode = "CALC";
	else
		this.par.menuMode = "VIEW";
}

function askParam()
{
	return new DpGetDat("dcut0");
}

function listMake()
{
	DropTable("tmp_gl");
	DropTable("TMP_GL_C");
	DropTable("TMP_GL_R");
	DropTable("TMP_GL_S");
	
	if (IsTable("tmp_gl") || IsTable("TMP_GL_C") 
		|| IsTable("TMP_GL_R") || IsTable("TMP_GL_S"))
	{
		 alert("Невозможно выполнить расчет." 
			+ "\nПроверьте, возможно окно с данным расчетом уже открыто,"
			+ "\nили перезапустите систему.");
			//+ "\nВозможно окно с данным расчетом уже открыто");
			return;
	}
	 
	sch_num = list.objAsk.sc.getSc();
	sub_num = list.objAsk.sc.getSu();
	sta_num = list.objAsk.sc.getSt();
     dtgl = list.objAsk.dat1;     
	 if ( !r_glavn("BYSCH", dtgl, sch_num, sub_num, sta_num) )
     {
         CloseWindow();
         return false;
     }
}

function listTitle()
{
	if (sch_num)
		return ru("Главная книга в разрезе счетов по счету ","Головна книга в розрізі рахунків по рахунку ") + sch_num + "/" + sub_num + " с " + StrDat(dtgl,"DMY");
	else
		return ru("Главная книга в разрезе счетов","Головна книга в розрізі рахунків");
}

function infSrc()
{
	this.qrySet( "Cross", "TMP_GL" , "Order", "Fmn");
}

function listGrid()
{
	rs = this.tbl.GetCol();
	rsr= this.tbl.GetRow();

	if (!rs.IsEmpty()) rs.MoveFirst();   
     
	var oGrid = new DpGrid("NOCREATE");
	var oPage = oGrid.page();
	oPage.FieldEx("Fmn", "Мес.", 8,"", "%2d");

	var Sc, Su;

	while (!rs.IsEOF())
	{
		Sc = Number(rs.getValue( "fcr_sc1" ));
		Su = Number(rs.getValue( "fcr_su1" ));

		if (Sc < 99996)
		{
			ColCapt = "Сч:" + String(Sc);
			if (Su != 0)
			{
				ColCapt = ColCapt + "/" + String(Su);
			}
		}
		else
		{
			switch (Sc)
			{
			case  99996:
				ColCapt = "Об.по деб.";
				break;
			case  99997: 
				ColCapt = "Об.по кр.";
				break;
			case  99998:
				ColCapt = "Ост.по деб.";
				break;
			case  99999:
				ColCapt = "Ост.по кр."
				break;       
			}
		}
		ColId = String(rs.getValue("fColID"));
		oPage.FieldEx(ColId, ColCapt, 8,"", DP_FORMAT_SUM);
		rs.MoveNext();
	} 
	oGrid.build(); 
}

function Load1()
{
	dsSaveFormat(false);
   ds = DataSource();

   var menuMode = GetMenuMode();
   if (menuMode.substr(0,1)=="R"){
      var gd = new DpGetDat("dcut0");
      if (gd.escape){  
         gdescape = true;
         CloseWindow();
         return;
      }
      DropTable("tmp_gl");DropTable("TMP_GL_C");DropTable("TMP_GL_R");DropTable("TMP_GL_S");
	  if(IsTable("tmp_gl") ||IsTable("TMP_GL_C") || IsTable("TMP_GL_R") || IsTable("TMP_GL_S"))
			{
				 alert("Невозможно выполнить расчет."+"\nПроверьте, возможно окно с данным расчетом уже открыто,"+"\nили перезапустите систему.");
				//+ "\nВозможно окно с данным расчетом уже открыто");
				CloseWindow();
				return;
			}
      
      sch_num = gd.sc.getSc();
      sub_num = gd.sc.getSu();
      sta_num = gd.sc.getSt();
      dtgl = gd.dat1;

      if ( !r_glavn("BYSCH", gd.dat1, sch_num, sub_num, sta_num) ){
         CloseWindow();
         return;
      }
   }
   else
   {
		var sysname=getSysName();
		sysname=sysname.substring(sysname.lastIndexOf('|')+1, sysname.length);
		sch_num = getParWithDef("FSC", sysname, 0);
		sub_num = getParWithDef("FSU", sysname, 0);
		sta_num = getParWithDef("FST", sysname, 0);
		dtgl    = getParWithDef("DAT1", sysname, d00);
      if(isEmpty(dtgl))
      {
			alert(ru("Сначала выполните расчет","Спочатку виконайте розрахунок"));
			CloseWindow();
			return;
      }
   }

	Caption("Главная книга в разрезе счетов по счету " + sch_num + "/" + sub_num + " с " + StrDat(dtgl,"DMY"));
 	if (IsTable("TMP_GL_C") && IsTable("TMP_GL_R") && IsTable("TMP_GL_S")){
    rsi = OpenTable( "c", "TMP_GL"); 
    rs = rsi.GetCol();
    rsr= rsi.GetRow();

    if (!rs.IsEmpty()) rs.MoveFirst();   

    ds.Source(rsi);
    
    FieldEx("Fmn", "Мес.", 10);

    var Sc, Su;

    while (!rs.IsEOF){
       Sc = rs( "fcr_sc1" );
       Su = rs( "fcr_su1" );

       if (Sc<99996){
          ColCapt = "Сч:" + String(Sc);
          if (Su!=0){
             ColCapt = ColCapt + "/" + String(Su);
          }
       }else{
           switch (Sc){
              case  99996:
                 ColCapt = "Об.по деб.";
                 break;
              case  99997: 
                 ColCapt = "Об.по кр.";
                 break;
              case  99998:
                 ColCapt = "Ост.по деб.";
                 break;
              case  99999:
                 ColCapt = "Ост.по кр."
                 break;
              default:
           }
       }
       ColId = rs( "fColID" );
       FieldEx(ColId, ColCapt, 12);
       rs.MoveNext();
    }

    ds.grid = grid;
  }
}

function UnLoad1()
{
 // /*if (IsTable("TMP_GL_C") && IsTable("TMP_GL_R") && IsTable("TMP_GL_S"))*/  ds.Delete();
}
function getTblH()
{
	var ret = new Object();
	ret.FD1 = new Date(dtgl).getVarDate();
	ret.FSC = sch_num;
	ret.FSU = sub_num;
	ret.FST = sta_num;
	return ret;
}

function listMenuInit()
{
	this.dataSrc.AddMenuItem (1,"Раскрыть дебетовые обороты");
	this.dataSrc.AddMenuItem (2,"Раскрыть кредитовые обороты");	
}

function listMenuRun(nID)
{
//	var par = new empty();
	var par = new Object();
	ty = new Date(dtgl).getYear();
	pmn = rsr.getValue("Fmn");
	par.pdat  = new Date(ty, pmn-1, 1);
	par.pdat2 = new Date(ty, pmn, 0);
	par.psc = sch_num;
	par.psu = sub_num;
	par.pst = sta_num;
	par.pst = 0;
	par.pcl1= 0;
	par.val = 0;
	par.val_nzv = "ГРН";
	par.modegrn = true;
	par.isRaskr = true;

	if (nID==1)
	{
		if (pmn!=0)
		{
			showWindow("vp_dc.js",SW_NOMODAL,par);
		}
		else
		{
			alert("Обороты за данный период отсутствуют");
		}
	}
	else if (nID == 2)
	{
		if (pmn != 0)
		{
			showWindow("vp_cd.js",SW_NOMODAL,par);
		}
		else
		{
			alert("Обороты за данный период отсутствуют");
		}
	}
}

include("sys\\DpList.js")
