include("objects\\DpGetDat.js");
//include("objects\\DpPnExt.js");
include("objects\\DpGrid.js");
include("sys\\dbase.js");
include("sub\\mtr.js");
include("mtr_ost.js");

var label = "grost";
var tblOut;
//var viewPM = true;
var isDet;

function listLoad()
{
	dsSaveFormat(false);
	isDet = strIn("DET", list.par.menuMode); 
	tblOut = "tmp_" + label + (isDet? "DET": "");
	with( list )
	{
		subAsk = askParam;
		subMake = tbl_refresh;
		//subSrc = infSrc;
		//subGrid = gridInit;
		subMenuInit = menuInit;
		subMenuRun = menuRun;
		subPageAgrHead = ttlGridRowPrefix;
		printLabel = "grost";
	}

	with (list.objTotal)
	{
		//init("obr")
		init("grost");
	}
}

function listTitle()
{
	with(list)
		return UR("Угоди-доручення за ", "Договора-поручения за ")
			 + StrDat(objAsk.dat1, "DMY") + "-" + StrDat(objAsk.dat2, "DMY");
}

function listSrc()
{
	list.qrySet( "From", tblOut );

	addTtlTbl();
	addPnTbl();

	var sFsum1 = ru("Приход: Сумма поступлений по цен.пост.","Прихід: Сума надходжень за цін.пост.");
	var sFsum2 = ru("Приход: Сумма перемещений по цен.пост.","Прихід: Сума переміщень за цін.пост.");
	var sFsum3 = ru("Расход: Сумма выбытий по цен.пост.","Видаток: Сума вибутків за цін.пост.");
	var sFsum4 = ru("Расход: Сумма перемещений по цен.пост.","Видаток: Сума переміщень за цін.пост.");
/*	list.dataSrc.AddSumField("F1PSUMR", sFsum1, dbFloat)
	list.dataSrc.AddSumField("F1PSUMV", sFsum2, dbFloat)
	list.dataSrc.AddSumField("F1RSUMR", sFsum3, dbFloat)
	list.dataSrc.AddSumField("F1RSUMV", sFsum4, dbFloat)
*/
}

function askParam()
{
	var gd, arrVariants
	arrVariants = list.getVariantsArr()
	if(isDet)
	{
		gd = new DpGetDat(new Array("r","N0","c0","p0","m0","s:c0ut","t0", "v0"),arrVariants);
		gd.fitog = 56; 
	}
	else
		gd = new DpGetDat(new Array("b","r","N0","c0","p0","m0","s:c0ut","t0", "v0"),arrVariants);
	DropTable(tblOut);
	if(IsTable(tblOut))
	{
		 alert(ru("Невозможно выполнить расчет."
    	      	+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
    	      	+"\nили перезапустите систему.",
    	      	  "Неможливо виконати розрахунок."
    	      	+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
    	      	+"\nабо перезапустіть систему."));
			
		gd.escape = true;
	}	
	return gd
}

function tbl_refresh()
{
	var sSQL = " select max(fdate) from ^anltk where fdoc = 'SA' "
	+" and fdate < "+sqlTo(list.objAsk.dat1);
	var datKOst = getSnap(sSQL)[0]; 
	
	var cFbdat = sqlTo(list.objAsk.dat1);
	var cFedat = sqlTo(list.objAsk.dat2);
	var cFKOdat = sqlTo(datKOst);
	
	var sFnpkol = IIF("frtype='5'","a.fkol",0);
	var sFnrkol = IIF("frtype='7'","a.fkol",0);
	var sFnvpkol = IIF("frtype='6'","a.fkol",0);
	var sFnvrkol = IIF("frtype='8'","a.fkol",0);	
         
	var sSQL = "";
	//var sDat = (SUBD==ORACLE || SUBD==DERBY)? sqlTo(new Date()) : "a.fdate";
	sSel = " select a.fcena as fcena, a.fcenapr as fcenapr, s.fdbkr as fdbkr"
				+", 0 as fedi_fas, 0 AS fnop"
				+", a.fnmkl "
				+", 0 AS fid_doc "
				+", SUM("+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol) AS fost "
				+", SUM("+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol) AS fbost "
				+", "+Convert(0,"DBL")+" AS fpkol, "+Convert(0,"DBL")+" AS frkol, "
				+Convert(0,"DBL")+" AS fvpkol, "+Convert(0,"DBL")+" AS fvrkol "
				+",SUM("+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol*a.fcenapr) AS fobsum"
				+", "+Convert(0,"DBL")+" AS fopsum,"+Convert(0,"DBL")+" AS forsum,"
				+Convert(0,"DBL")+" AS fovrsum,"+Convert(0,"DBL")+"  AS fovpsum"         
				+", SUM(("+sFnpkol+"+"+sFnvpkol+"-"+sFnrkol+"-"+sFnvrkol+")*fcenapr) as foesum "
				+", SUM("+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol*a.fcena) AS fubsum"
				+", "+Convert(0,"DBL")+" AS fupsum, "+Convert(0,"DBL")+" AS fursum,"
				+Convert(0,"DBL")+" AS fuvrsum, "+Convert(0,"DBL")+" AS fuvpsum "
				+", SUM(("+sFnpkol+"+"+sFnvpkol+"-"+sFnrkol+"-"+sFnvrkol+")*fcena) as fuesum "
				+", 0 as fwid "
	sSQL = 	" into "+ tblOut
			+" from ^anltk a left join ^sch_zag s on a.fid_doc = s.fwid"
			+" where ((fdate < "+cFbdat+(datKOst!=null?" and fdate >="+cFKOdat:"")+") "
				+" or (fdate = "+cFbdat+" and frtype ='!')) "  
				+ sqlw0And("a.fsc=", this.objAsk.fsc)
				+ sqlw0And("a.fsu=", list.objAsk.fsu)
				+ sqlw0And("a.fst=", list.objAsk.fst)
				+ sqlw0And("a.fmol=", list.objAsk.fmol)
				+ sqlw0And("a.fpodr=", list.objAsk.fpodr)
				+ sqlwNmk("a.Fnmkl", list.objAsk.fnmk)
			+" group by s.fdbkr, a.fnmkl, a.fcena, a.fcenapr "
			+" having SUM("+IIF("frtype>'6'",-1,1)+"*a.fkol)<>0";

	ExecuteSQL(sSel + sSQL);
	//ExecuteSQL("update "+ tblOut +" set fdoc_dat="+ sqlTo(d00));
	
	ExecuteSQL("ALTER TABLE "+ tblOut +" ADD fdoc_dat "+ sqlType("TEXT", 25));
	ExecuteSQL("ALTER TABLE "+ tblOut +" ADD fdoc_num "+ sqlType("TEXT", 25));
	ExecuteSQL("ALTER TABLE "+ tblOut +" ADD fdoc "+ sqlType("TEXT", 50));
	ExecuteSQL("ALTER TABLE "+ tblOut +" ADD ftt "+ sqlType("TEXT", 50));

	sSQL = "insert into "+ tblOut +" (fnmkl,fcena,fcenapr,fdbkr,fedi_fas,"
				+"ftt,fdoc_dat,fdoc_num,fid_doc,fdoc,fnop,fbost,fost,fpkol,frkol,fvpkol,fvrkol,"
				+"fobsum,fopsum,forsum,fovpsum,fovrsum,foesum,"
				+"fubsum,fupsum,fursum,fuvpsum,fuvrsum,fuesum)";
	
	var sDocNum = SUBD==ORACLE? "s.fdoc_num" : IIF("s.fdoc_num is NULL", "''", "s.fdoc_num");
	sSQL +=" select a.fnmkl, a.fcena, a.fcenapr "
				+", s.fdbkr, 0 as fedi_fas"
				+", " + sqlEmpStr + " as ftt, s.fdoc_dat"
				+", "+ sDocNum
				+", a.fid_doc, a.fdoc"
				+", "+ IIF("s.fnop is NULL", "0", "s.fnop")
				+", 0 AS fbost"
        		+","+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol AS fost "
				+","+ sFnpkol+" AS fpkol"
				+","+ sFnrkol+" AS frkol"
				+","+ sFnvpkol+" AS fvpkol"
				+","+ sFnvrkol+" AS fvrkol"
				+",0 as fobsum "
				+","+ sFnpkol+"*fcenapr AS fopsum"
				+","+ sFnrkol+"*fcenapr AS forsum"
				+","+ sFnvpkol+"*fcenapr AS fovpsum"
				+","+ sFnvrkol+"*fcenapr AS fovrsum"
				+","+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol*fcenapr AS foesum"
				+", 0 AS fubsum"
				+","+ sFnpkol+"*fcena AS fupsum"
				+","+ sFnrkol+"*fcena AS fursum"
				+","+ sFnvpkol+"*fcena AS fuvpsum"
				+","+ sFnvrkol+"*fcena AS fuvrsum"
				+","+IIF("frtype='7' or frtype ='8'",-1,1)+"*a.fkol*fcena AS fuesum"
			+" from ^anltk a left join ^sch_zag s on a.fid_doc = s.fwid"
			+" where fdate >="+cFbdat+" and fdate <="+cFedat+" and a.frtype <> '1' "
				+ sqlw0And("a.fsc=", list.objAsk.fsc)
				+ sqlw0And("a.fsu=", list.objAsk.fsu)
				+ sqlw0And("a.fst=", list.objAsk.fst)
				+ sqlw0And("a.fmol=", list.objAsk.fmol)
				+ sqlw0And("a.fpodr=", list.objAsk.fpodr)
				+ sqlwNmk("a.Fnmkl", list.objAsk.fnmk);

		ExecuteSQL(sSQL);	
}

var ls = 13, ps=10, ts = ps+5+5+3+3+5, qs=10, ss=10
function listDpGridEx(oGrid)
{
	var oPrefix = oGrid.prefix();
	var itogGrp = oPrefix.group()
	var nazv_group = itogGrp.cell("=^Fnmkl?^NM.Fcod +': '  + ^NM.Ftxts:''", "Номенклатура", sizeNmk);		
	list.GroupPage(oGrid, itogGrp, 0, false, nazv_group);
	with (oGrid)
	{
		with (page("Кількість|Количество"))
		{
			fieldEx("fdbkr", "Пост", 4)
			cell("ED.FTXTS", "Од.|Ед.", 4)
			cell("fcena","Ціна|Цена",ps,null,DP_FORMAT_PRI);
			cell("fcenapr","Ціна відпускна|Цена отпускная",ps,null,DP_FORMAT_PRI);
			with(group("Кількість|Количество"))
			{
				cell("fbost","На початок|На начало",qs,null,DP_FORMAT_KOL);
				cell("fpkol","Прихід|Приход",qs,null,DP_FORMAT_KOL);
				cell("frkol","Витрати|Расход",qs,null,DP_FORMAT_KOL);
				cell("fvpkol","Прихід по переміщенням| Приход по перемещениям",qs,null,DP_FORMAT_KOL);
				cell("fvrkol","Витрати по переміщенням| Расход по перемещениям",qs,null,DP_FORMAT_KOL);
				cell("=(^fbost+^fpkol-^frkol+^fvpkol-^fvrkol)","На кінець|На конец",qs,null,DP_FORMAT_KOL);
			}
		}
		with (page("Сума|Сумма"))
		{
			with(group("Сума|Сумма"))
			{
				cell("fubsum","На початок|На начало",ss,null,DP_FORMAT_SUM);
				cell("fupsum","Прихід|Приход",ss,null,DP_FORMAT_SUM);
				cell("fursum","Витрати|Расход",ss,null,DP_FORMAT_SUM);
				cell("fuvpsum","Прихід по переміщенням| Приход по перемещениям",ss,null,DP_FORMAT_SUM);
				cell("fuvrsum","Витрати по переміщенням| Расход по перемещениям",ss,null,DP_FORMAT_SUM);
				cell("fuesum","На кінець|На конец",ss,null,DP_FORMAT_SUM);
			}
		}
		with (page("Сума відпускна|Сумма отпускная"))
		{
			with(group("Сума відпускна|Сумма отпускная"))
			{
				cell("fobsum","На початок|На начало",ss,null,DP_FORMAT_SUM);
				cell("fopsum","Прихід|Приход",ss,null,DP_FORMAT_SUM);
				cell("forsum","Витрати|Расход",ss,null,DP_FORMAT_SUM);
				cell("fovpsum","Прихід по переміщенням| Приход по перемещениям",ss,null,DP_FORMAT_SUM);
				cell("fovrsum","Витрати по переміщенням| Расход по перемещениям",ss,null,DP_FORMAT_SUM);
				cell("foesum","На кінець|На конец",ss,null,DP_FORMAT_SUM);
			}
		}	
	}	
	//oGrid.build();
}

function menuInit()
{
   with( list.dataSrc )
   {
		if(list.tbl.isRecord())
			AddMenuItem( "KAR_SKL","Картка складського обліку|Карточка складского учета"  );
      AddMenuItem( "VED_DV", "Відомість руху|Ведомость движения" );
      //AddMenuItem( "PMSWITCH", (viewPM? ru("Не учитывать внутренние перемещения","Не враховувати внутрішні переміщення"): 
      //									ru("Учитывать внутренние перемещения","Враховувати внутрішні переміщення")));
   }
}

function menuRun(ID)
{
	switch(ID)
	{
	case "PMSWITCH":
		list.isRefresh = false;
		list.isRefreshGrid = true;
		//viewPM = !viewPM;
		break;
	
	case "KAR_SKL":
		var par = new Object();
		//par.objAsk = objCopy(list.objAsk);
		par.objAsk = list.objAsk;
		if(list.tbl.getValue("fnmkl"))
			par.objAsk.fnmk = list.tbl.getValue("fnmkl");
		// Если в текущей записи установлены параметры - передадим, если нет (для итоговых записей)- берем параметы списка
		if(list.tbl.getValue("fcena"))
			par.objAsk.fcena = list.tbl.getValue("fcena");
		if(list.tbl.getValue("fmol"))
			par.objAsk.fmol = list.tbl.getValue("fmol");
		if(list.tbl.getValue("fpodr"))
			par.objAsk.fpodr = list.tbl.getValue("fpodr");
		if(list.tbl.getValue("fsc"))
			par.objAsk.fsc = list.tbl.getValue("fsc");
		else
			par.objAsk.fsc = 0;
		if(list.tbl.getValue("fsu"))
			par.objAsk.fsu = list.tbl.getValue("fsu");
		else
			par.objAsk.fsu = 0;
		if(list.tbl.getValue("fpost"))
			par.objAsk.forg = list.tbl.getValue("fpost");
		else
			par.objAsk.forg = 0;
		if(list.tbl.getValue("fsn"))
			par.objAsk.fsn = list.tbl.getValue("fsn");
		else
			par.objAsk.fsn = "";
		par.menuMode = "CALC";
		showWindow("r_ksu.js",SW_NOMODAL,par);
		break;
	
	case "VED_DV":
		var par = new Object();
		par.dat1 = list.objAsk.dat1;
		par.dat2 = list.objAsk.dat2;
		par.menuMode = "CALC";
		if(!list.tbl.IsEOF() && !list.tbl.IsBOF())
		{
			par.fnmkl = list.tbl.getValue("fnmkl");
			
			par.objAsk = list.objAsk;
			par.objAsk.fid_pn = Number(list.tbl.getValue("fid_pn"));
			par.objAsk.fcena_ord = Number(list.tbl.getValue("fcena_ord"));
		}
		showWindow("l_anltk.js",SW_NOMODAL,par);
	}
}

/*
function tbl_refresh()
{
	with(new DpMtrOb())
	{
		fnmkl = list.objAsk.fnmk;
		fcena = list.objAsk.fcena;
		fpodr = list.objAsk.fpodr;
		fmol  = list.objAsk.fmol;
		fsc   = list.objAsk.fsc;
		fsu   = list.objAsk.fsu;
		fst   = list.objAsk.fst;
		fpost = list.objAsk.fpost;
		date1 = list.objAsk.dat1;
		date2 = list.objAsk.dat2;
		grost = true;
		//isFinDate = true;
		pattern = "obr";
		tblName = tblOut;
		isSprKol = true;
		sumCenaPost = true;
		doCalc();
	}
}
*/

function objPn_run(isRefExist)
{
	this.tbl.setValue("FBSUM_PN",  this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FBKOL"));
	this.tbl.setValue("FPSUMR_PN", this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FPKOLR"));
	this.tbl.setValue("FPSUMV_PN", this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FPKOLV"));
	this.tbl.setValue("FRSUMR_PN", this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FRKOLR"));
	this.tbl.setValue("FRSUMV_PN", this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FRKOLV"));
	this.tbl.setValue("FESUM_PN",  this.tbl.getValue("FCENA_PN") * this.tbl.getValue("FEKOL"));
}

function listOnPrnList(tv)
{
    var h = new Object();
    h.FD1  = new Date(list.objAsk.dat1).getVarDate();
    h.FD2  = new Date(list.objAsk.dat2).getVarDate();
    h.FNMKL = list.objAsk.fnmk;
    h.FCENA = list.objAsk.fcena;
    h.FPODR = list.objAsk.fpodr;
    h.FMOL = list.objAsk.fmol;
    h.FSC = list.objAsk.fsc;
    h.FSU = list.objAsk.fsu;
    h.FPOST = list.objAsk.fpost;
    h.FVAL = list.objAsk.fval;
    tv.setHTbl(h);
}
	
include("sys\\DpList.js");