include ("Objects\\DpGetDat.js");
include ("oss_dat.js");
include ("oss_datb.js");
include ("calc_os.js");
include ("izosdat.js");
include ("izosdatb.js");
include ("Objects\\DpGrid.js");
include ("sub\\mtr.js");

var listPrnForm  = "IZM";
var label = "IZM";
var tmpTbl = "TMP_IZM";
var oSnap;
var dat1, dat2, buhuch, d1, d2;

function listLoad()
{
	list.accDel = null;
	list.objTotal.init(label);
	list.par.menuMode = GetMenuMode();
	if(list.par.menuMode=="CALC")
	{
		var form = createForm(UR("Введіть данні для відбору інформації|Введите данные для отбора информации"));
		form.addItog(label);
		var D1=form.addObj("D1","date",UR("Дата початку періоду|Дата начала периода"));
		D1.setValue(new Date(today.getFullYear(), today.getMonth()-1, 1).getVarDate());
		var D2=form.addObj("D2","date",UR("Дата кінця періоду|Дата конца периода"));
		D2.setValue(new Date(today.getFullYear(), today.getMonth()+1, 1).getVarDate());
		var buh = form.addObj("buh", "bool", UR("Ведення бух.обліку|Ведение бух.учета"));
		buh.setValue(getPar("__BUHUCH"));
		form.show();
		if(form.escape == false)
		{
			dat1 = new Date(form.D1);
			dat2 = new Date(form.D2);
			buhuch = toScrObj(form.buh);
			DropTable(tmpTbl);
			//создадим таблицу в которую занесём период расчёта и булевое значение б/у
			//для использования при дальнейших вызовах просмотров
			ExecuteSQL("CREATE TABLE "+tmpTbl+" (Fdat1 "+sqlType("DATE")+", Fdat2 "+sqlType("DATE")+", Fbuh "+sqlType("BIT")+")")
			ExecuteSQL("INSERT INTO "+tmpTbl+" (Fdat1, Fdat2, Fbuh) VALUES("+sqlTo(dat1)+","+sqlTo(dat2)+","+sqlTo(buhuch)+")");
		}
		else
			return false;
	}
	else
	{
		if(!IsTable("IZM"))
		{
			alert(ru("Сперва выполните расчёт!","Спочатку виконайте розрахунок!"));
			return false;
		}
	}
}

/*function listAsk()
{
	var arrVariants = list.getVariantsArr()
	return new DpGetDat(new Array("b0","r"),arrVariants);
}

function listTitle()
{
	return "Реестр змiн вартостi ОЗ за перiод "
			+ StrDat(list.objAsk.dat1, "DMY") + "-" + StrDat(list.objAsk.dat2, "DMY")
			+ "|"
			+ "Реестр изменений стоимости ОС за период "
			+ StrDat(list.objAsk.dat1, "DMY") + "-" + StrDat(list.objAsk.dat2, "DMY")
}*/

function listMake()
{
	DropTable("IZM");
	if(IsTable("IZM"))
		return false;
	r_izm(new Date(dat1), new Date(dat2));
}

function listSrc()
{
	if(IsTable(tmpTbl))
	{
		oSnap = getSnap("SELECT Fdat1, Fdat2, Fbuh FROM "+tmpTbl);
		if( oSnap != null )
		{
			var captBuh = oSnap[2]?ru(" (бух.учет)"," (бух.облік)"):ru(" (налог.учет)"," (податк.облік)");
			list.title = "Реєстр змiн вартостi ОЗ за перiод "+StrDat(oSnap[0], "DMY")+"-"+StrDat(oSnap[1], "DMY")+captBuh
						+"|Реестр изменений стоимости ОС за период "+StrDat(oSnap[0], "DMY")+"-"+StrDat(oSnap[1], "DMY")+captBuh;
			d1 = oSnap[0];
			d2 = oSnap[1];
		}
	}
	list.qrySet("From", "IZM",
		"Order", "Finv_num",
		"Prn", listPrnForm,
		"Ptn", "IZM");
	list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	addTtlTbl();
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var nazv_group;

	with (oGrid)
	{
		onePageMode(false);
		
		with(page())
		{
			cell("Finv_num", "Iнв.N|Инв.N", 6);
			//nazv_group = group();
			//list.GroupPage(oGrid,nazv_group);
			//with(nazv_group)
			cell("=^ftt=='!!'?UR('Разом|Итого'):^x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");

			cell("Fdat_post", "Дата\nнадх.|Дата\nпост.", 8);
			cell("Forig_pric", "Перв.варт.\nна дату надх.|Перв.стоим.\nна дату пост.", 14, "", DP_FORMAT_SUM);
			cell("Fizmen", "Сума змiни\nвартості ОЗ|Сумма измен.\nстоимости ОС", 14, "", DP_FORMAT_SUM);
			cell("Fgroup", "Гр.|Гр.", 4);
		}
//		list.GroupPage(oGrid, oExtPage.group(), 8, false, nazv_group, 0, "w");

		build();
	}
}

function listOnPrnList(tv)
{
	if(dat1==null || dat2==null)
	{
		if(d1!=null && d2!=null)
		{
			dat1 = new Date(d1);
			dat2 = new Date(d2);
		}
		else
			return false;
	}
	var h = new Object();
	h.DAT_B = dat1.getVarDate();
	h.DAT_E = dat2.getVarDate();
	tv.setHTbl(h);	
}

function r_izm(dat1, dat2)
{
   cdat1 = sqlTo(dat1);
   cdat2 = sqlTo(dat2);

   DropTable("IZM");
   DropTable("T1");
   DropTable("TG0");
   DropTable("TG1");
   DropTable("TG2");
   DropTable("TG3");
   DropTable("TG4");
   DropTable("TG5");
   DropTable("TG6");
   DropTable("TG7");

   dat1 = new Date(dat1);
   dat2 = new Date(dat2);
   
   D1 = dat1;
   D2 = dat2;
   

//   var buhuch = getPar("__BUHUCH");

   if (buhuch==false)
   {
      Retvsp=oss_dat(D1,D2);
   }
   else
   {
      Retvsp=oss_datb(D1,D2);
   }

   if (Retvsp!=-100)
   {
      vs = OpenTable("s", "VSP");
      vs.index="VSP";
      if (SQL)
		vs.index="Finv";
   }
   else
   {
      _alert("Не создан.список измен.стоим.Расчет невозможен");
      return;
   }
	
   var  m = new Object();
   var gS;
   os7 = OpenTable("s", "OS7");
   os7.index = "INV_NUM";
   if (SQL)
		os7.index = "FINV_NUM";

   CreateTable("IZM", "IZM", "IZM");
   iz = OpenTable("s", "IZM");
   if (!vs.IsEmpty())
   {
      vs.MoveFirst();
      while (!vs.IsEOF())
      {
         if (Number(vs.getValue("Fizm"))!=0)
         {
            if (buhuch==false)
            {
               mFprice = Number(izosdat( dat1, Number(vs.getValue("Finv")), "orig_pric"));
               if (mFprice == -100)  mFprice = 0;
               mFgroup = Number(izosdat(dat2,  Number(vs.getValue("Finv")), "group"));
               if (mFgroup == -100)  mFgroup = 0;
            }
            else
            {
               mFprice = Number(izosdatb( dat1, Number(vs.getValue("Finv")), "orig_pric"));
               if (mFprice == -100)  mFprice = 0;
               mFgroup = Number(izosdatb(dat2,  Number(vs.getValue("Finv")), "group"));
               if (mFgroup == -100)  mFgroup = 0;
            }
            //iz.AddNew();
            m = new Object();
            m.Finv_num = Number(vs.getValue("Finv"));
            m.Fizmen   = Number(vs.getValue("Fizm"));
            gS = getSnap("select Fdoc_dat,Fdat_vib from ^OS7 where Finv_num=" + sqlTo(vs.getValue("Finv")));
            
            if (gS != null)
            {
               m.Fdat_post = gS[0];
               m.Fdat_vib  = gS[1];
            }
            m.Forig_pric = mFprice;
            m.Fgroup     = mFgroup;
            m.Fdatn      = dat1.getVarDate();
            m.Fdatk      = dat2.getVarDate();
            //iz.Update();
            UpdateTable("IZM",m,true)
         }
         vs.MoveNext();
      }
   }
   else
   {
      _alert("Список ОС за данный период пуст");
      iz.Close();
      return;
   }
   if (SQL)
      iz.Requery();

   if (iz.IsEmpty())
   {
      _alert("Нет изменений стоимости ОС за данный период");
      iz.Close();
      return;
   }
	iz.Close();
}

include ("sys\\DpList.js");