include("Objects/DpGetDat.js");
include("sys/docinfo.js");
include("sys/servis.js");

var par = new Object();
var prnPatt = "jord";
var gd, inout = 0;
var zmbDate = new Date();
var zmeDate = new Date();
var captDat1,captDat2;
var cr_sc,cr_su,cr_st;

function listLoad()
{	
	this.printLabel = prnPatt;
	if(GetMenuMode()=="VIEW")
	{
		cr_sc = Number(ReadParEx("cr_sc"));
		cr_su = Number(ReadParEx("cr_su"));
		cr_st = Number(ReadParEx("cr_st"));
	    captDat1 = ReadParEx("captDat1");
	    captDat2 = ReadParEx("captDat2");
	}
	this.accDel = new Function ("return false");
}

function listAsk()
{
	gd = new DpGetDat("dDcut0");     
  	if (gd.escape)
  		return gd;
  	
  		// получим введенные счет, субсчет, статью
	cr_sc = gd.fsc;
	cr_su = gd.fsu;
	cr_st = gd.fst;
	 	// получим дату начала и дату конца
    zmbDate = gd.dat1;
    zmeDate = gd.dat2;

    captDat1 = StrDat(zmbDate, "DMY");
    captDat2 = StrDat(zmeDate, "DMY");
	WriteParEx("cr_sc",cr_sc);
	WriteParEx("cr_su",cr_su);
	WriteParEx("cr_st",cr_st);
	WriteParEx("captDat1",captDat1);
	WriteParEx("captDat2",captDat2);
  	return gd;
}

function listTitle()
{
	if(!captDat1 && !captDat2)
		return "Журнал-ордер: ";
	return 	"Журнал-ордер: "+ captDat1 +"-"+ captDat2;
}

function listMake()
{
	var strSQL_S, strSQL_R, strSQL_C, strSQL_tmp;
	var sPrgs = ru("Расчет...","Розрахунок...");
	var nPrgs = 1;
	setProgressRange(0, 10);
	setProgressText(sPrgs);
	DropTable("DOL_S_1");	
	DropTable("DOL_S");	
	DropTable("DOL_C");	
	DropTable("DOL_R");

	setProgressPos(nPrgs++, sPrgs);
	if (IsTable("DOL_S_1") || IsTable("DOL_S") || IsTable("DOL_C") || IsTable("DOL_R"))
	{ 
		alert("Невозможно выполнить расчет."+"\nПроверьте, возможно окно с данным расчетом уже открыто,"+"\nили перезапустите систему.");
		setProgressPos(0);
		return false;
  	}
  	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;
	// выбираем из исходной таблицы ID документа, счет, субсчет, статью по дебету, дату,
	// номер документа, формируем поле, в котором будут находиться данные,
	//идентифицирующие одну и ту же проводку, формируем поле, в котором указываем
	// сумму в гривнах (посчитанную с помощью ф-ции sqlRate())
	var tbl_doc;
	var sSql = "SELECT FDOC, FID_DOC, FID_DOC AS FRowId, FDB_SC, FDB_SU, FDB_ST, FDATE, FDOCNUM, "
            	+ SqlConCat(Convert("FDB_SC", "NVARCHAR"), "'@'", Convert("FDB_SU", "NVARCHAR"), "'@'"
            	, Convert("FDB_ST", "NVARCHAR")) +" AS  FColID"
			    + ", ^SCHET.Fsum*"+sqlRate("^SCHET","Fval","Fdate","fvkurs") + " AS fsum"
			+ " INTO DOL_S_1"
			+ " FROM ^SCHET"
			+ " WHERE FCR_SC="+sqlTo(cr_sc)
				+ sqlw0And("FCR_SU=", cr_su)
				+ sqlw0And("FCR_ST=", cr_st)
				+" AND (FDATE>="+sqlTo(zmbDate)	+" AND FDATE<="+sqlTo(zmeDate)+")"
				+" AND (" + sqlStrIsNotEmp("FDOC") + " AND "+ sqlStrIsNotNull("FDOC") +")"
				+ orgCond
	ExecuteSQL(sSql);
	setProgressPos(nPrgs++, sPrgs);
	// Удалим, если существует табличка DOL_S
	DropTable("DOL_S1");
	DropTable("DOL_S");
	setProgressPos(nPrgs++, sPrgs);
	sSql = "SELECT FRowID, FID_DOC, FDB_SC, FDB_SU, FDB_ST, FDATE"
				+", FDOCNUM, FColID, FDOC, SUM(fsum) AS fValue "
			+" INTO DOL_S1 FROM DOL_S_1"
			+" GROUP BY FID_DOC, FRowID, FDB_SC, FDB_SU, FDB_ST, FDATE, FDOCNUM, FColID, FDOC";
	ExecuteSQL(sSql);
	setProgressPos(nPrgs++, sPrgs);
	
	sSql = "SELECT FRowID , FID_DOC, FDB_SC, FDB_SU, FDB_ST, FDATE"
				+", FDOCNUM, FColID, FDOC, fValue "
			+" INTO DOL_S FROM DOL_S1";
	ExecuteSQL(sSql);		
	ExecuteSQL("alter table DOL_S add ftxt " + SqlType("LONGTEXT"));
	setProgressPos(nPrgs++, sPrgs);
   	ExecuteSQL("DROP INDEX DOL_S_RowCol", false);
   	ExecuteSQL("CREATE INDEX DOL_S_RowCol ON DOL_S (FrowId, FcolId)");
    // Выбираем из таблицы DOL_S все разные проводки вместе с суммами.Упорядочим их.
	DropTable("DOL_C");
    sSql = "SELECT DISTINCT FColID, FDB_SC, FDB_SU, FDB_ST"
			+ " INTO DOL_C"
			+ " FROM DOL_S ORDER BY Fdb_sc, Fdb_su, Fdb_st";
	ExecuteSQL(sSql);	
	setProgressPos(nPrgs++, sPrgs);	   

	DropTable("DOL_R");
	sSql = "SELECT FID_DOC AS FRowID, FDATE,  FDOCNUM, SUM(FVALUE) AS FSUM, FDOC, FTXT "
			+" INTO DOL_R "
			+" FROM DOL_S "
			+" GROUP BY FID_DOC, FDATE,  FDOCNUM, FDOC, FTXT ";
	ExecuteSQL(sSql);	
	setProgressPos(nPrgs++, sPrgs);
	// создадим индекс в таблице строк/////////////////////
	ExecuteSQL("DROP INDEX DOL_R_FDATE", false);
	ExecuteSQL("DROP INDEX DOL_R_FROWID", false);
	ExecuteSQL("CREATE INDEX DOL_R_FDATE ON DOL_R (FDATE)");
	ExecuteSQL("CREATE INDEX DOL_R_FROWID ON DOL_R (FROWID)");
    setProgressPos(nPrgs++, sPrgs);
    t_r = OpenTable("s","SELECT * "
					+" FROM DOL_R "
					+" ORDER BY FDOCNUM, FDATE");
	if (t_r.isEmpty())
	{
		setProgressPos(0);
		return 777;
	} 
	setProgressPos(0); 
	setProgressRange(0, t_r.recordCount);   	
	var n = 0;
	BeginTransaction(4);
 	for(t_r.MoveFirst(); !t_r.IsEOF(); t_r.MoveNext())
	{
		var sOrg;
		setProgressPos(++n, sPrgs); 
		//tbl_doc = docinfo("HFILE",t_r.getValue("FDOC"));
		tbl_doc = getDocTblName(t_r.getValue("FDOC"));
		if (!tbl_doc || tbl_doc=="")
			continue;
		
		var fldOrg = docinfo("FLDORG",t_r.getValue("FDOC"));
		//vlad 02.09.2008
		//Есть документы, в которых нет поля организация, например VD-Ведомости
		if(fldOrg=="=0")
		{
			continue;
		}
		var tbl_tmp = getSnap("SELECT "+ fldOrg +" AS ORG "
								+" FROM ^"+ tbl_doc
								+" WHERE FWID="+sqlTo(t_r.getValue("FRowID")));
		if(!tbl_tmp || tbl_tmp[0]<=0)
			continue;
		sOrg = sqlTo(tbl_tmp[0]);
				
		//vlad
		// 1) Нельзя ориентироваться по полю FDOCNUM - может быть несколько документов с одинак. номером
		// 2) Раз уж поле называется FTXT, то запишем туда наименование	
		//ExecuteSQL("Update DOL_R SET FTXT="+ sOrg
		//			+" where FDOCNUM="+ sqlTo(t_r.getValue("FDOCNUM")));
		var strSQL = "UPDATE DOL_R SET FTXT = "
			+SqlConCat(sqlTo(sOrg.trim()+":"),"(SELECT MAX(CL.FTXT) "
				+" FROM ^CL CL INNER JOIN ^CLRELCLCL REL ON CL.FWID=REL.FWID_CL"
				+" WHERE REL.FCL="+sqlTo(0)+" AND REL.FCOD="+sOrg+")")		
		+" where FRowID="+ sqlTo(t_r.getValue("FRowID"))
		ExecuteSQL(strSQL) 
	}
	CommitTrans();
	setProgressPos(0);  
	t_r.close();
	// Таблица с результирующими цифрами
	var ResTable;
	ResTable = "tmp_order_2";
	DropTable(ResTable);
	ExecuteSQL("select SUM(Fsum) as Fsum, "+ Convert("-999999999","INT")+" as Frowid into "+ResTable+" from DOL_R");
	ExecuteSQL("insert into DOL_R (Fsum,Frowid,Fdate) select Fsum, Frowid, "+sqlTo(d00)+" from "+ResTable);
	DropTable(ResTable);
	ExecuteSQL("select Fcolid, SUM(Fvalue) as Fvalue, "+Convert("-999999999","INT")+" as Frowid into "+ResTable+" from DOL_S group by Fcolid");
	ExecuteSQL("insert into DOL_S (Fcolid,Fvalue,Frowid) select Fcolid, Fvalue, Frowid from "+ResTable);
	setProgressPos(0);
	return true;
}

function listSrc()
{
	this.qrySet("Cross", "DOL"
				,"Order", "FDATE"
				);
}		

function listDpGrid()
{
	include("Objects/DpGrid.js");
	//var grid = new DpGrid("NOCREATE");	
   	//gr = grid.page();
	grid.defCond("itog", "=^Frowid ==-999999999");
	grid.color(1, "itog");
	grid.bold("itog");
   	// столбцы "Дата", "№п/п", "Сумма"
   	grid.FieldEx("=^Frowid !=-999999999?^Fdate:UR('Всього|Итого')","Дата |Дата ",10);
   	grid.FieldEx("FDOCNUM","№ док |№ док ",5);
   	grid.FieldEx("FTXT","Орг.|Орг.",5);
   	//если решили код и текствоку выводить в одно поле, тогда эта колонка лишняя
   	//grid.FieldEx("=Number(^Ftxt)>0?tfcl('', 0, Number(^FTXT)):''","Назва | Название",20);
   	
   	grid.FieldEx("FSUM","Сума |Сумма ",5, "", DP_FORMAT_SUM);
   	
   	t_c = OpenTable("s", "SELECT *"
					+ " FROM DOL_C"
					+ " ORDER BY fdb_sc, fdb_su, fdb_st");
	// добавляем столько же столбцов в  gridЕ, сколько и различных счетов по дебету
   	while(!t_c.IsEOF())
   	{
      	var strTmp = sqlTo(t_c.getValue("FDB_SC"));
        if (Number(t_c.getValue("FDB_SU")))
			strTmp += "/"+ sqlTo(t_c.getValue("FDB_SU"));
        if (Number(t_c.getValue("FDB_ST")))
           	strTmp += "/"+ sqlTo(t_c.getValue("FDB_ST"));
        
		grid.FieldEx(String(t_c.getValue("FColID")), " "+ strTmp +" ",10, "", DP_FORMAT_SUM);
		t_c.MoveNext()
	}	
	t_c.close();
	grid.FieldEx("FDOC","Тип",5);
   	grid.build();
}

function listMenuInit()
{
	if(!list.tbl.isEmpty() && Number(list.tbl.getValue("frowid")) != -999999999)
  	{
		this.dataSrc.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");		
   	}   	
}

function listMenuRun(ID)
{
	switch(ID)
	{
   	case "EDIT":
    	  if(list.tbl.isRecord() && Number(list.tbl.getValue("frowid")) != -999999999)
  		  {
  			include("doc\\DpDoc.js");
  			var oDoc = new DpDoc(String(list.tbl.getValue("fdoc")), 0);
  			var ret = oDoc.edit("EDIT",list.tbl.getValue("frowid"));
  			  			
  		 }
  		 return DpList_exit;
  		 break;
  	case "FINDDOC":
		if(list.tbl.isRecord())
		{
				include("doc\\DpDocPtn.js");
				FindDocument(String(list.tbl.getValue("fdoc")), 0, list.tbl.getValue("frowid"));
		}
		return DpList_exit;
	}
	
}

function getTblH()
{
	var h = new Object();
	h.HSC = cr_sc
	h.HSU = cr_su;
	h.HST = cr_st;
    h.HBDAT = captDat1;
    h.HEDAT = captDat2;
	return h;
}
 
include("sys/DpList.js");