include("objects/DpGetDat.js");
include("doc/dpDocPtn.js");
include("doc/RegPar.js");
include("sys/DpSql.js");
include("sys/dbase.js");

var Capt1,Capt2;

function listLoad()
{
   	with( list )
   	{
      	title = ru("Реестр налоговых накладных","Реєстр податкових накладних");
      	printLabel = "nktax";
      	subOnPrnList = onPrnList;
   	}
	DataSource().addAccel(GA_CTRL, "D", "FINDDOC");
}

function listSrc()
{
	var exprFnk_num = SqlLPAD("Hnknom",20);
	with( list )
	{
		qrySet("Fields", "a.*, " + exprFnk_num + " as fnk_num0"
			,"From", "^"+extPar.tblName+" AS a"
        		+" INNER JOIN ^cl_reg b"
					+ " ON a.Hdoc=b.Fdoc and a.Hnop=b.Fnop"	//and a.Hreg=b.Freg
			,"Where"
				, SqlCmpTrue
				+ " and b.Fnom=0"
				+ " and b.Fused=" + SqlTrue
				+ " and (a.Hdat between "+sqlTo(objAsk.dat1)+" AND "+sqlTo(objAsk.dat2)+")"
				+ " and " + sqlStrIsNotEmp("a.HNKNOM")
				+ " and " + (getRegPar(list.par.fvid, "GRJREG")=="+"
					? (" a.Hreg in (SELECT c.FREG FROM ^CL_REG c "
						+" WHERE c.FDOC="+SqlEmpStr+" AND c.FVID=" + sqlTo(list.par.fvid) +")") 
					: (" a.Hreg=" + sqlTo(list.par.freg)))
			,"Order", exprFnk_num + ",HDAT");
		if (SQL)
		{
			subTie("CLRELCLCL", "REL", "CLCOD", "="+sprOrg+",Horg");
			subTie("CL", "ORG", "FWID", "REL.FWID_CL");
		}
		else
		{
			subTie("CLRELCLCL", "REL", "CLCOD", "="+sprOrg+",Horg");
			subTie("CL", "ORG", "FWID", "REL.FWID_CL");
		}
	}
}

function listDpGrid()
{
   	include("objects\\DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	
   	with( oGrid.page() )
   	{      	
      	FieldEx("Hnknom","№ под.нк.|№ нал.нк.",15);
      	FieldEx("Hnkdat","Дата под.нк.|Дата нал.нк.",10);
      	FieldEx("Hnom","№ док.|№ док.",15);
      	FieldEx("Hdat","Дата док.|Дата док.",10);
      	FieldEx("Horg","Код|Код",5);
      	FieldEx("ORG.Ftxt","Контрагент|Контрагент",40);
   	}
   	
   	oGrid.build(); 
}

function listAsk()
{
   	var gd = new DpGetDat(new Array("r"));
   	return gd;
}

function onPrnList(tv)
{
    var zmbDate = list.objAsk.dat1;
    var zmeDate = list.objAsk.dat2;

    var captDat1 = StrDat(zmbDate, "DMY");
    var captDat2 = StrDat(zmeDate, "DMY");
    
    var h = new Object();
 	h.FCAPTDAT1 = captDat1;
 	h.FCAPTDAT2 = captDat2;
 	tv.setHTbl(h);
}

function listMenuInit(ds)
{
	ds.AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
	ds.AddMenuItem("","");
}

function listMenuRun(cID)
{
	switch(cID)
	{
	case "FINDDOC":
		var t = DataSource().getTable();
		if(t.isRecord())
				FindDocument(t.getValue("fdoc")
					, t.getValue("fnop")
					, t.getValue("fid_doc"));
		break;
	}
}

include("sys/DpList.js");