include("sys/servis.js");
include("objects/DpGetDat.js");
include("r_ord10.js");
include("r_ord5.js");
include("r_ord8.js");
include("objects/DpSc.js");
include("objects/DpGrid.js");

var prnPatt;
var ds, typeRash, m_vid; 
var num_ord;
var text = "";
var rs,rsi;
var mDat;

function listLoad()
{
	list.printLabel	= "1ORDSV";
	ds = DataSource();
	if(extPar==null)
	{
		num_ord = 0;
		m_vid   = 0;
		text    = "";
		typeRash= "R";
	}
	else
	{
		num_ord = (extPar.numord && typeof(extPar.numord) != "unknown")? extPar.numord: 0;
		m_vid   = (extPar.type && typeof(extPar.type) != "unknown")? extPar.type: 0;
		text    = (extPar.text && typeof(extPar.text) != "unknown")? extPar.text: "";
		typeRash= extPar.rmode;
	}

	if (typeRash=="R")
	{
		switch (String(m_vid))
		{
		case "1":
			if ( !r_ord10(num_ord) )
			{
				CloseWindow();
				return false;
			}
			break;
		case "2":
			if ( !r_ord5(num_ord) )
			{
				CloseWindow();
				return false;
			}
			break;
		case "3":
			if (!r_ord8(num_ord))
			{
				CloseWindow();
				return false;
			}
			break;
		default:
			//Название процедуры расчета
			var sProcName = "r_uord"+String(m_vid);
			var sFileName = sProcName+".js";
			include("VedNarItog:"+sFileName);
			if(typeof(sProcName)=="function" || typeof(sProcName)=="string")
			{
				list.printLabel	= "VedNarItog:VED";
				var res = eval(sProcName+"(num_ord)");
				if (!res)
				{
					CloseWindow();
					return false;
				}
				mDat = extPar.dat;
				list.subOnPrnList = onPrnList;

				with (list.objTotal)
				{
					label = listGetTotalID();
					init(label, "", 50);
				}
			}
			else
			{
				alert("Не реализовано!");
			}
		}
	}
}

function listSrc()
{
	switch (String(m_vid))
	{
		case "1":	this.qrySet("Cross", "ORD10");	break;
		case "2":	this.qrySet("Cross", "ORD5");	break;
		case "3":	this.qrySet("Cross", "ORD8");	break;
		case "101":	this.qrySet("From", "VED_3", "Order", IIF("FSC=0", sqlTo(1), sqlTo(0))
								+", FSC, "+IIF("FSU=0 AND FST=0", sqlTo(1), sqlTo(0))+", FSU, FTTLEVEL");
		break;
		case "102":	this.qrySet("From", "VED"
								,"Order",
										IIF("FSC=0", sqlTo(1), sqlTo(0))+", FSC, "
										+IIF("FSU=0 AND FST=0", sqlTo(1), sqlTo(0))+", FSU, "
										+IIF("FST=0 AND FCL_COD1=0", sqlTo(1), sqlTo(0))+", FST, "
										+IIF("FCL_COD1=0", sqlTo(1), sqlTo(0))+", FCL_COD1, "
										+IIF("FCL_COD2=0", sqlTo(1), sqlTo(0))+", FCL_COD2, "
										+IIF("FCL_COD3=0", sqlTo(1), sqlTo(0))+", FCL_COD3, "
										+IIF("FSC_CORR=0", sqlTo(1), sqlTo(0))+", FSC_CORR, "
										+IIF("FSU_CORR=0", sqlTo(1), sqlTo(0))+", FSU_CORR, "
										+IIF("FST_CORR=0", sqlTo(1), sqlTo(0))+", FST_CORR, "
										+", FTTLEVEL"
										+", FDATE"
										//+", decode(translate(trim(FDOCNUM), '_0123456789', '_'), null, to_number(trim(FDOCNUM)))"
										+(SUBD == ORACLE ? ", decode(translate(trim(FDOCNUM), '_0123456789', '_'), null, to_number(trim(FDOCNUM)))" : ", FDOCNUM")
								,"WhereArr", Array( "FTT='SC'"
													,"FTT='SU'"
													,"FTT='ST'"
													,"FTT='AN1'"
													,"FTT='AN2'"
													,"FTT='AN3'"
													)
								,"WhereArrName", Array( ru("Свернуть по счету","Згорнути по рахунку")
														,ru("Свернуть по с/счету","Згорнути по с/рахунку")
														,ru("Свернуть по статье","Згорнути по статті")
														,ru("Свернуть по аналитике 1","Згорнути по аналітиці 1")
														,ru("Свернуть по аналитике 2","Згорнути по аналітиці 2")
														,ru("Свернуть по аналитике 3","Згорнути по аналітиці 3")
														)
								);
		break;
		case "125":	
			this.qrySet("Cross", "ORD125");
			break;
		default:
	}
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var page = oGrid.page();
	
	switch (String(m_vid))
	{
	case "1":
		var rs = this.tbl.GetCol();
		if (IsTable("ORD10_C") && IsTable("ORD10_R") && IsTable("ORD10_S"))
		{
			//rsi = OpenTable("c", "ORD10"); 
			//rs = rsi.GetCol();
			if (!rs.IsEmpty())
				rs.MoveFirst();

			t = OpenTable("s", "ORD10_date");
			if (t!=null && !t.IsEmpty())
				text = text + ru(" за период с "," за період з ") 
					+ StrDat(t.getValue("FBDAT"),"DMY") + " по " + StrDat(t.getValue("FEDAT"),"DMY");
						
			t.close()
			page.FieldEx("FTxt", "Сч.", 10);

			var Sc, Su, St, Cod1, Sect;

			while (!rs.IsEOF())
			{
				Sc    = rs.getValue("fcr_sc");
				Su    = rs.getValue("fcr_su");
				St    = rs.getValue("fcr_st");
				Cod1  = rs.getValue("fcr_cod1");
				Sect  = rs.getValue("fsect");

				if(Number(Sc) == 254) 
					ColCapt = "Разом|Итого";
				else if(String(Sect)=="3")
				{
					var flag = false;
					var ColCapt = "";
					if (Cod1!=0) {ColCapt = "/" + String(Cod1); flag = true;}
					if (St!=0 || flag) {ColCapt = "/" + String(St) + ColCapt; flag = true;}
					if (Su!=0 || flag) {ColCapt = "/" + String(Su) + ColCapt;}
					ColCapt = "С кр." + String(Sc) + ColCapt;
				}
				else 
					ColCapt = "Разом по ж./о.|Всего по ж./о." ;

				ColId = rs.getValue("fColID");
				//gr.Field(ColId, 120, ColCapt);
				page.FieldEx(ColId, ColCapt, 10,"", DP_FORMAT_SUM);

				rs.MoveNext();
			}
		}
		prnPatt = "1ordsv";
		break;
	
	case "2":
		var rs = this.tbl.GetCol();
		if (IsTable("ORD5_C") && IsTable("ORD5_R") && IsTable("ORD5_S"))
		{
			//rsi = OpenTable( "c", "ORD5"); 
			//rs  = rsi.GetCol();
			if (!rs.IsEmpty()) 
				rs.MoveFirst();
			
			var t = OpenTable("s","ORD5_date");
			if (t!=null && !t.IsEmpty())
				text = text + ru(" за период с "," за період з ") + StrDat(t.getValue("FBDAT"),"DMY") 
							+ " по " + StrDat(t.getValue("FEDAT"),"DMY");
			t.close();
			page.FieldEx("Ftxt", "Дата", 10);
			//page.FieldEx("+(^FTxt=="+ StrDat(new Date(3000, 1, 1),"DMY")+ "? 'Итого' : ^Ftxt)", "Дата", 10);
			
			var Sc, Su, Sc_cr, Su_cr, Sect;

			while (!rs.IsEOF())
			{
				Sc = rs.getValue("fdb_sc");
				Su = rs.getValue("fdb_su");
				Sc_cr = rs.getValue("fcr_sc");
				Su_cr = rs.getValue("fcr_su");
				Sect  = Number(rs.getValue("fsect"));

				if (Sect/2-Math.floor(Sect/2) == 0)
				{
					ColCapt = ru("Всего c кр.","Разом з кр.")+ String(Sc_cr)+ "/" + String(Su_cr);
				}
				else
				{
					ColCapt = ru("С кр.","З кр.")+ String(Sc_cr)+ "/" + String(Su_cr)+" в деб." + String(Sc);
					if (Su!=0) ColCapt = ColCapt + "/" + String(Su);
				}
				ColId = rs.getValue("fColID");
				page.FieldEx(ColId, ColCapt, 10);
				rs.MoveNext();
			}
		}
		prnPatt="2ordsv";
		break;

	case "3":
		var rs = this.tbl.GetCol();
		if (IsTable("ORD8_C") && IsTable("ORD8_R") && IsTable("ORD8_S"))
		{
			if (!rs.IsEmpty()) rs.MoveFirst();
			
			var t = OpenTable("s","ORD8_date");
			if (t!=null && !t.IsEmpty())
				text = text + ru(" за период с "," за період з ") 
						+ StrDat(t.getValue("FBDAT"),"DMY") + " по " + StrDat(t.getValue("FEDAT"),"DMY");
			t.close();
			page.FieldEx("FTxt", "Дебет рах./субрах.|Дебет сч./субсч.", 15);
			page.FieldEx("Fnazv", "Зміст операції|Содержание операции", 15);
			
			var Sc_cr, Su_cr, Sect;

			while (!rs.IsEOF())
			{
				Sc_cr = Number(rs.getValue("fcr_sc"));
				Su_cr = Number(rs.getValue("fcr_su"));
				Sect  = Number(rs.getValue("fsect"));

				if (Sect == 3)
				{
					ColCapt = ru("Всего c кр.", "Разом з кр.")+ String(Sc_cr)+ "/" + String(Su_cr);
				}
				else if (Sect == 4)
				{
					ColCapt = "Разом|Итого";
				}
				ColId = rs.getValue("fColID");
				page.FieldEx(ColId, ColCapt, 10);
				rs.MoveNext();
			}
		}
		prnPatt="3ordsv";
		break;

	case "101":	// ведомость нарастающих итогов
		if (IsTable("VED_3"))
		{
			width = 4;
			if (JAVA)
			{
				cItogCond = '=^Ftt != ""';
			}
			else
			{
				cItogCond = '=^Ftt <> ""';
			}
			oGrid.defCond(cItogCond,"Itog");
			oGrid.color(1,"Itog");
			oGrid.bold("Itog");

			with (page)
			{
				//cell("FTXTITOG", "Підсумки|Итоги", 5);
				//cell("FNOP", "Папка|Папка", 4);
				with (group("Основний рахунок|Основной счет"))
				{
					cell("FSC", "рах.|сч.", width);
					cell("FSU", "с/р|с/с", width);
					cell("FST", "ст.|ст.", width);
					cell("FCL_COD1", "Ан. 1|Ан. 1", width);
					cell("FCL_COD2", "Ан. 2|Ан. 2", width);
					cell("FCL_COD3", "Ан. 3|Ан. 3", width);
				}
				with (group("Кореспондуючий рахунок|Корреспондирующий счет"))
				{
					cell("FSC_CORR", "рах.|сч.", width);
					cell("FSU_CORR", "с/р|с/с", width);
					//cell("FST_CORR", "ст.|ст.", width);
					//cell("FCL_COD1_CORR", "Ан. 1|Ан. 1", width);
					//cell("FCL_COD2_CORR", "Ан. 2|Ан. 2", width);
					//cell("FCL_COD3_CORR", "Ан. 3|Ан. 3", width);
					cell("=tfsc('', Number(^Fsc_corr), Number(^Fsu_corr))", "Назва|Название", 12, "w");
				}
				with (group("Нарост. на початок місяця|Нараст. на начало месяца"))
				{
					cell("FSUM1", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM2", "Кредит|Кредит", 8,null, DP_FORMAT_SUM);
				}
				with (group("Обіги за поточний місяць|Обороты за тек. месяц"))
				{
					cell("FSUM3", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM4", "Кредит|Кредит", 8, null, DP_FORMAT_SUM);
				}
				with (group("Нарост. на кінець місяця|Нараст. на конец месяца"))
				{
					cell("FSUM5", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM6", "Кредит|Кредит", 8, null, DP_FORMAT_SUM);
				}
			}
		}
		prnPatt = "VED";
		break;

	case "102":	// оборотная ведомость
		if (IsTable("VED"))
		{
			width = 5;
			if (JAVA)
			{
				cItogCond = '=^Ftt != ""';
			}
			else
			{
				cItogCond = '=^Ftt <> ""';
			}
			oGrid.defCond(cItogCond,"Itog");
			oGrid.color(1,"Itog");
			oGrid.bold("Itog");
			
			with (page)
			{
				cell("FDATE", "Дата запису|Дата записи", 10);
				cell("FNOP", "№ папки|№ папки", 4);
				cell("FDOCNUM", "№ документа|№ документа", 4);
				with (group("Основний рахунок|Основной счет"))
				{
					cell("FSC", "рах.|сч.", width);
					cell("FSU", "с/р|с/с", width);
					cell("FST", "ст.|ст.", width);
					cell("FCL_COD1", "Ан. 1|Ан. 1", width);
					cell("FCL_COD2", "Ан. 2|Ан. 2", width);
					cell("FCL_COD3", "Ан. 3|Ан. 3", width);
					cell("=tfsc('', Number(^Fsc), Number(^Fsu), Number(^Fst)"
						+", Number(^Fcl_cod1), Number(^Fcl_cod2), Number(^Fcl_cod3))", "Назва|Название", 20, "w");
				}
				with (group("Кореспондуючий рахунок|Корреспондирующий счет"))
				{
					cell("FSC_CORR", "рах.|сч.", width);
					cell("FSU_CORR", "с/р|с/с", width);
					cell("FST_CORR", "ст.|ст.", width);
					cell("FCL_COD1_CORR", "Ан. 1|Ан. 1", width);
					cell("FCL_COD2_CORR", "Ан. 2|Ан. 2", width);
					cell("FCL_COD3_CORR", "Ан. 3|Ан. 3", width);
				}
				with (group("Залишок на поч. місяця|Остаток на нач. месяца"))
				{
					cell("FSUM1", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM2", "Кредит|Кредит", 8, null, DP_FORMAT_SUM);
				}
				with (group("Обіги за поточний місяць|Обороты за тек. месяц"))
				{
					cell("FSUM5", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM6", "Кредит|Кредит", 8, null, DP_FORMAT_SUM);
				}
				with (group("Залишок на кінець місяця|Остаток на конец месяца"))
				{
					cell("FSUM3", "Дебет|Дебет", 8, null, DP_FORMAT_SUM);
					cell("FSUM4", "Кредит|Кредит", 8, null, DP_FORMAT_SUM);
				}
			}
		}
		prnPatt = "VED";
		break;
	case "125":
		

		var rs = this.tbl.GetCol();
		if (IsTable("ORD125_C") && IsTable("ORD125_R") && IsTable("ORD125_S"))
		{
			
			cItogCond = "=^FROWID == 'TOT_ROW'";
			oGrid.defCond(cItogCond, "Itog");
			oGrid.color(1,"Itog");
			oGrid.bold("Itog");

			if (!rs.IsEmpty())
				rs.MoveFirst();

			var t = OpenTable("s", "ORD125_date");
			if (t!=null && !t.IsEmpty())
				text = text + ru(" за период с "," за період з ") 
					+ StrDat(t.getValue("FBDAT"),"DMY") + " по " + StrDat(t.getValue("FEDAT"),"DMY");
			t.close();			
			with (page)
			{
				with(group("Рахунок|Счет"))
				{
					cell("=(^FROWID=='TOT_ROW' ? '"+ru("Всего:","Всього:")+"' : ^FSC_TXT)", "рах.|счет", 13, "w");
					cell("=tfsc('', ^FDB_SC, ^FDB_SU, ^FDB_ST, ^FDB_COD1)", "Назва|Название", 13, "w");
				}
				
				if (!rs.IsEmpty())
					rs.MoveFirst();
				with (group("Сальдо на початок|Сальдо на начало"))
				{
					var Sc, Su, St, Cod1, Sect;
	
					while (!rs.IsEOF())
					{
						Sc    = rs.getValue("fcr_sc");
						Su    = rs.getValue("fcr_su");
						St    = rs.getValue("fcr_st");
						Cod1  = rs.getValue("fcr_cod1");
		
						ColCapt = Sc+"/"+Su+"/"+St+"/"+Cod1;
						ColId = rs.getValue("FCOLID");
						colTT = rs.getValue("FTT");
		
						if (colTT == "BEG_DT_SL" || colTT == "BEG_KT_SL")
						{
							if (colTT == "BEG_DT_SL")
							{
								cell(ColId, "дебет|дебет", GRID_SUM_WDT, "", DP_FORMAT_SUM)
							}
							if (colTT == "BEG_KT_SL")
							{
								cell(ColId, "кредит|кредит", GRID_SUM_WDT, "", DP_FORMAT_SUM)
							}
						}
						rs.MoveNext();
					}
				}

				if (!rs.IsEmpty())
					rs.MoveFirst();
				with (group("Всього обіги по рахунку|Всего обороты по счету"))
				{
					var Sc, Su, St, Cod1, Sect;
	
					while (!rs.IsEOF())
					{
						Sc    = rs.getValue("fcr_sc");
						Su    = rs.getValue("fcr_su");
						St    = rs.getValue("fcr_st");
						Cod1  = rs.getValue("fcr_cod1");
		
						ColCapt = Sc+"/"+Su+"/"+St+"/"+Cod1;
						ColId = rs.getValue("FCOLID");
						colTT = rs.getValue("FTT");
		
						if (colTT == "TOT_DT_OB")
						{
							cell(ColId, "дебет|дебет", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						if (colTT == "TOT_KT_OB")
						{
							cell(ColId, "кредит|кредит", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						rs.MoveNext();
					}
				}
				
				
				
				if (!rs.IsEmpty())
					rs.MoveFirst();
					
				with (group("Обіги з кредиту рахунків|Обороты с кредита счетов"))
				{
					while (!rs.IsEOF())
					{
						Sc    = rs.getValue("fcr_sc");
						Su    = rs.getValue("fcr_su");
						St    = rs.getValue("fcr_st");
						Cod1  = rs.getValue("fcr_cod1");
		
						ColCapt = Sc+"/"+Su+"/"+St+"/"+Cod1;
						ColId = rs.getValue("FCOLID");
						colTT = rs.getValue("FTT");
		
						if (colTT == "OB")
						{
							cell(ColId, ColCapt, GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						if (colTT == "TOT_COL")
						{
							cell(ColId, "ВСЬОГО|ВСЕГО", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						
						if (colTT == "REST")
						{
							cell(ColId, "ВСЕ ІНШЕ|ВСЕ ОСТАЛЬНОЕ", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						
						rs.MoveNext();
					}
				}

				if (!rs.IsEmpty())
					rs.MoveFirst();
					
				with (group("Сальдо на кінець|Сальдо на конец"))
				{
					while (!rs.IsEOF())
					{
						Sc    = rs.getValue("fcr_sc");
						Su    = rs.getValue("fcr_su");
						St    = rs.getValue("fcr_st");
						Cod1  = rs.getValue("fcr_cod1");
		
						ColCapt = Sc+"/"+Su+"/"+St+"/"+Cod1;
						ColId = rs.getValue("FCOLID");
						colTT = rs.getValue("FTT");
		
						if (colTT == "END_DT_SL")
						{
							cell(ColId, "дебет|дебет", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						if (colTT == "END_KT_SL")
						{
							cell(ColId, "кредит|кредит", GRID_SUM_WDT, "", DP_FORMAT_SUM)
						}
						rs.MoveNext();
					}
				}
/*
				if (!rs.IsEmpty())
					rs.MoveFirst();
					
				while (!rs.IsEOF())
				{
					Sc    = rs.getValue("fcr_sc");
					Su    = rs.getValue("fcr_su");
					St    = rs.getValue("fcr_st");
					Cod1  = rs.getValue("fcr_cod1");
	
					ColCapt = Sc+"/"+Su+"/"+St+"/"+Cod1;
					ColId = rs.getValue("FCOLID");
					colTT = rs.getValue("FTT");
	
					if (colTT == "REST")
					{
						cell(ColId, "Все інше|Все остальное", GRID_SUM_WDT, "", DP_FORMAT_SUM)
					}
					rs.MoveNext();
				}
*/				
			}
		}
		prnPatt = "1ordsv";
		break;
	default:
	}
	oGrid.build();	
}

function listTitle()
{
	return text;
}

function Title1OrdSv(sc,sect,su,st,cod1)
{
	if (sc==254) return ru('Итого','Загалом');
	if (sect!=3) return ru('Всего по ж./о.','Всього по ж./о.');
	if (cod1!=0) return ru('С кр.','З кр.') + sc + '/' + su + '/' + st + '/' + cod1;
	if (  st!=0) return ru('С кр.','З кр.') + sc + '/' + su + '/' + st;
	if (  su!=0) return ru('С кр.','З кр.') + sc + '/' + su;
	return ru('С кр.','З кр.') + sc;
}

function Discharge()
{
	var strOrd, strPartSQL = "";
	switch (m_vid)
	{
	case 1: 
		strOrd = "10";
		strPartSQL = "FCR_ST, FCR_COD1,";
		break;
	case 2: 
		strOrd = "5";
		strPartSQL = "FDATE,";
		break;
	case 3: 
		strOrd = "8";
		strPartSQL = "FDATE,FTXT,FLINE,";
		break;
	default:
	}
	var nameTable = "ORD" + strOrd + "__" + iOrg;
	DropTable(nameTable);
	CreateTable(nameTable,"SVOORD" + strOrd,"*");
	t1 = OpenTable("s","ORD" + strOrd + "_date");
	var t2 = OpenTable("s","SELECT FOBL FROM ^CL_SVBAL WHERE FRN=" + iOrg);
	var iObl = (t2.IsEmpty())? 0 : t2("fobl");
	var strSQL = "INSERT INTO " + nameTable  + 
		  " SELECT FCR_SC,FCR_SU,FDB_SC,FDB_SU,FSECT,FSUM," + strPartSQL +
		  sqlTo(iOrg) + " AS FRN," + iObl + " AS FOBL," +
		  sqlTo(t1("FBDAT")) + " AS FBDAT, " + sqlTo(t1("FEDAT")) + " AS FEDAT" +
		  " FROM ^ORD" + strOrd;
	ExecuteSQL(strSQL);
}

function listMenuInit(ds)
{
	//ds.AddMenuItem("DISCHARGE","Выгрузка");
	//ds.AddMenuItem("PRINT","Печать списка");
}

function listMenuRun(ID)
{
	if(ID=="PRINT")
	{
		include("objects\\DpTVars.js");
		var tv = new DpTVars(prnPatt);
		//var bm = tbl.bookmark;
		tv.setRTbl(list.tbl);
		tv.colMoveFirst();
		tv.print();
		tv.setVar("text",text);
		//tbl.bookmark = bm;
	}
	else if (ID=="DISCHARGE") 
		Discharge();	
}

function onPrnList(tv)
{
	var h = new Object();
	h.DAT = mDat;
	tv.setHTbl(h);
}

function listGetTotalID()
{
	return "r_ordsv" + num_ord;
}

function listDelAcc()
{
	return false;
}

include("sys/DpList.js");