/*Расчет отпусков с учетом предварительных начислений и удержаний
	VVS 03.06.04
	Печать отпускных из прибыли списком
	Переделано из r_otp_pr_eu.js
	SEV 28.10.03
	Печатаем выделенные отпуска (DataSource().sqlSelected)
*/

include("koef_otp.js");
include("objects\\DpCl.js")
include("objects\\DpClcl.js")
include("prik\\calculate\\r_otpall.js");
include("prik\\calculate\\r_premblot.js");
include("objects\\DpDefVed.js")
include("servis\\date.js")
include("objects\\DpCalendar.js");
include("objects\\DpShtat.js")
include("objects\\DpShifPZ.js")
var tbl_PRK_O, tbl_DTPRKB, tbl_PRK_FMPL, tbl_WT_LBL_O, tbl_WT_LBL_B, tbl_SRED_INI, tbl_CL_KALEN, tbl_TIME_KL;
var sPrkTbl = "PRK_ALL";

var sprPers = getPar("CODPERS");

function l_ras_otp_p(strSQL1)
{
	if (!IsTable("OTP_PRT"))
		CreateTable("OTP_PRT", "OTP_PRT", "*");
	else
		ExecuteSQL("DELETE from OTP_PRT");

	var tbl_o = OpenTable(strSQL1);

	for( tbl_o.MoveFirst(); !tbl_o.IsEOF(); tbl_o.MoveNext() )
	{
		var mFtabn = toScrObj(tbl_o.getValue("FTABN_ID"));
		var mFbdat = toScrObj(tbl_o.getValue("FBDAT"));
		var mFedat = toScrObj(tbl_o.getValue("FEDAT"));
		var mFwid = toScrObj(tbl_o.getValue("FWID"));
		var mFcalnum = Number(tbl_o.getValue("FCALNUM"));

		r_otp_p_pr_sel(mFtabn, mFbdat, mFedat, mFwid, mFcalnum);
	}
	tbl_o.close(5652);
	tbl_o = null;
}

function r_otp_p_pr_sel(mFtabn, mFbdat, mFedat, mFwid, mFcalnum)
{
	var eDatWh = d00;

	var DefVed = new DpDefVed();
	var D1,D2;
	var mFvp,mFmn,pdt,db,db1,dt;
	var ssum;
	DefVed.begin("",ru("расчет отпускных","розрахунок відпускних"));

	//установ. даты на начало и конец расчетного месяца
	var data = new Date(mFbdat);
	
	D1 = new Date(firstDay(data));
	D1 = D1.getVarDate();
	D2 = new Date(lastDay(data));
	D2 = D2.getVarDate();

	var bDatOtp = new Date(mFbdat);//начало отпуска
	var eDatOtp = new Date(mFedat);//конец отпуска
	var eDat,bDat;
	var obj_PRK_B = new Object();
	var obj_PRK_P = new Object();

	obj_PRK_B.vid_sred = 1;
	obj_PRK_P.vid_sred = 10;
	
	obj_PRK_B.rmode = "K3";
	obj_PRK_P.rmode = "KL";
	
	obj_PRK_B.plusfmp = false;
	obj_PRK_P.plusfmp = true;
	
	var oCl = new DpCl("");
	codpers  = getPar("CODPERS");

	DropTable("tmp_prk_o");
	strSQL = " SELECT p.*"
		+" INTO tmp_prk_o"
		+" FROM ^"+ sPrkTbl +" AS P"
		+" WHERE P.FWID = "+ sqlTo(mFwid)
		+" order by p.Fbdat, p.Fedat"
	ExecuteSQL(strSQL);

	tbl_PRK_O = OpenTable("s","tmp_prk_o");

	if (tbl_PRK_O.IsEmpty())
	{
		return false;
	}

	while (!tbl_PRK_O.IsEOF())
	{
		mFtabn = toScrObj(tbl_PRK_O.getValue("Ftabn_id"));
		mFbdat = toScrObj(tbl_PRK_O.getValue("Fbdat"));
		mFedat = toScrObj(tbl_PRK_O.getValue("Fedat"));
		mFdatotp = toScrObj(tbl_PRK_O.getValue("Fdat_otp"));

		obj_PRK_B.Ftabn_id = toScrObj(tbl_PRK_O.getValue("Ftabn_id"));
		obj_PRK_P.Ftabn_id = toScrObj(tbl_PRK_O.getValue("Ftabn_id"));

		obj_PRK_B.Fdat_bol = toScrObj(tbl_PRK_O.getValue("Fdat_otp"));
		obj_PRK_P.Fdat_bol = toScrObj(tbl_PRK_O.getValue("Fdat_otp"));

		obj_PRK_B.Fsum = toScrObj(tbl_PRK_O.getValue("Fsum"));
		obj_PRK_P.Fsum = toScrObj(tbl_PRK_O.getValue("Fsum"));

		obj_PRK_B.mFkoef_gp = (toScrObj(tbl_PRK_O.getValue("Fkoef")) == 0 ? 1 : toScrObj(tbl_PRK_O.getValue("Fkoef")))
		obj_PRK_P.mFkoef_gp = (toScrObj(tbl_PRK_O.getValue("Fkoef")) == 0 ? 1 : toScrObj(tbl_PRK_O.getValue("Fkoef")))

		obj_PRK_B.Fwid_wp = toScrObj(tbl_PRK_O.getValue("Fwid_wp"));
		obj_PRK_P.Fwid_wp = toScrObj(tbl_PRK_O.getValue("Fwid_wp"));

		oCl.setClcl(codpers);
		oCl.setFWID(mFtabn);
		if ((tbl_PRK_O.getValue("Fbdat") >= D1) && (tbl_PRK_O.getValue("Fbdat") <= D2) && (tbl_PRK_O.getValue("Fedat") >= D1) && (tbl_PRK_O.getValue("Fedat") <= D2))
		{
			mFvp = 0;
			mFmn = d00;
		}
		else
		{
			mFvp = 2;
			db = new Date(toScrObj(tbl_PRK_O.getValue("Fbdat")));
			db = new Date(db.getFullYear(),db.getMonth(),1);
			db = db.getVarDate();
			mFmn = db;
		}

		// вычислить первое число отпускного месяца
		db = new Date(mFdatotp);
		db = new Date(db.getFullYear(),db.getMonth(),1);
		pdt = db.getVarDate();

		Ok = r_otpall(mFbdat, DefVed, obj_PRK_B, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, tbl_TIME_KL, tbl_CL_KALEN);
		Ok2 = r_otpall(mFbdat, DefVed, obj_PRK_P, tbl_PRK_FMPL, tbl_DTPRKB, tbl_WT_LBL_B, tbl_WT_LBL_O, tbl_SRED_INI, oCl, tbl_TIME_KL, tbl_CL_KALEN);

		if (Ok || Ok2)
		{
			var m = new Object();
			m.FBDAT = toScrObj(tbl_PRK_O.getValue("FBDAT"));
			m.FEDAT = toScrObj(tbl_PRK_O.getValue("FEDAT"));
			ftabn_id = toScrObj(tbl_PRK_O.getValue("Ftabn_id"));
			m.Ftabn_id  = ftabn_id;
			m.FTABN = getClcodByID(sprPers, ftabn_id);
			var objdat_otp = new Date(toScrObj(tbl_PRK_O.getValue("Fbdat")));
			m.FMSOTP = String(objdat_otp.getMonth()+1)+"/"+String(objdat_otp.getFullYear());

			if(Ok)
			{
				m.Fsredn = obj_PRK_B.Fsredn;
				m.FSUMOTP= obj_PRK_B.ssum;
				m.FDNOTP = obj_PRK_B.Fsum;
				for (var i = 1; i <= 12; i++)
				{
					eval("m.FSTMONTH"+i+" = obj_PRK_B.Fstmonth"+i);
					eval("m.FSUMFAKT"+i+" = obj_PRK_B.Fsumfakt"+i);
					eval("m.FKOLDN"+i+" = obj_PRK_B.Fkoldn"+i);
					eval("m.FKOEF"+i+" = obj_PRK_B.Fkoef"+i);
					eval("m.FSUM0_"+i+" = obj_PRK_B.FSUM0_"+i);
				}

				m.FSUMFAKTT = obj_PRK_B.Fsumtot;
				m.FKOLMES = obj_PRK_B.Fmestot;
			}

			if(Ok2)
			{
				m.Fsrednp = obj_PRK_P.Fsrednp;
				m.FSUMOTPP = obj_PRK_P.ssump;
				for (var i = 1; i <= 12; i++)
				{
					eval("m.FSUMFAKP"+i+" = obj_PRK_P.Fsumfakp"+i);
				}
				m.FSUMFAKPT = obj_PRK_P.Fsumfakp;
				m.FKOLMESP = obj_PRK_P.Fmestot;
			}
			m.FTT = '';
			UpdateTable("OTP_PRT", m, true);
		}
		tbl_PRK_O.MoveNext();
	}//while

	//Добавим в tbl_OTP_PRT записи для разбивки по месяцам
	tbl_PRK_O.MoveFirst();

	var bDat = new Date(toScrObj(tbl_PRK_O.getValue("FBDAT")));//дата начала отпуска
	var eDat = new Date(toScrObj(tbl_PRK_O.getValue("FEDAT")));//дата конца отпуска
	var mFcalnum = toScrObj(tbl_PRK_O.getValue("FCALNUM"));

	var bmDat = bDat;//первое число сегмента
	var emDat = bDat;//последнее число сегмента

	//ставим флаг того, что заходим не первый раз
	//для того, что если отпуск не переходящий,
	//то записи добавлять не будем
	var isZav = 0;
	var days;

	var oCalend = new dpCalendar();
	oCalend.setCod(mFcalnum);

	while(eDat > emDat)
	{
		//ставим последнее число месяца сегмента
		emDat = new Date(bmDat.getYear(),bmDat.getMonth()+1,0);
		//если месяц emDat и месяц конца отпуска совпадают,
		//то emDat ставим не последним числом, а концом отпуска
		if(emDat.getMonth() == eDat.getMonth() && isZav != 0)
		{
			emDat = eDat;
			days = oCalend.getCalDays("В|Р", bmDat, emDat);
			var m = new Object();
			m.Ftabn_id  = mFtabn;
			m.FTABN = getClcodByID(sprPers, ftabn_id);
			m.FBDAT = new Date(bmDat).getVarDate();
			m.FEDAT = new Date(emDat).getVarDate();
			m.FTT = 'MN';
			m.FDNOTP = days;
			m.FSUMOTP = obj_PRK_B.Fsredn!=null ? round(days*obj_PRK_B.Fsredn,2) : 0;
			m.FSUMOTPP = obj_PRK_P.Fsrednp!=null ? round(days*obj_PRK_P.Fsrednp,2) : 0;
			UpdateTable("OTP_PRT", m, true);
		}
		else
			if(isZav!=0)
			{
				days = oCalend.getCalDays("В|Р", bmDat, emDat);
				var m = new Object();
				m.Ftabn_id  = mFtabn;
				m.FTABN = getClcodByID(sprPers, ftabn_id);
				m.FBDAT = new Date(bmDat).getVarDate();
				m.FEDAT = new Date(emDat).getVarDate();
				m.FTT = 'MN';
				m.FDNOTP = days;
				m.FSUMOTP = obj_PRK_B.Fsredn!=null ? round(days*obj_PRK_B.Fsredn,2) : 0;
				m.FSUMOTPP = obj_PRK_P.Fsrednp!=null ? round(days*obj_PRK_P.Fsrednp,2): 0;
				UpdateTable("OTP_PRT", m, true);
				bmDat = goDay(emDat, 1);
			}
		isZav++;
	}
	tbl_PRK_O.Close();
	DefVed.end();
	return true;
}