include ("Objects\\DpGetDat.js");
include ("oss_dat.js");
include ("calc_os.js");
include ("izosdat.js");
include ("Objects\\DpGrid.js");
include ("sub\\mtr.js");
include("servis/date.js");
include("servis/format.js");

var listPrnForm  = "PEREM";
var tblName = "PEREM";
var label = "PEREM";
var form, dat1, dat2, isBuh, oItog;

function listLoad()
{
	list.accDel = null;
	list.objTotal.init(label);
	list.par.menuMode = GetMenuMode();
	
	if(GetMenuMode()=="CALC")
	{
		if(!askForm())
			return false;
	}
	else
	{
		dat1 = strToDateFormat(ReadParEx("dat1"),"dd.mm.yyyy");
		dat2 = strToDateFormat(ReadParEx("dat2"),"dd.mm.yyyy");
		isBuh = Number(ReadParEx("isBuh"));
	}
	this.title = "Реєстр переміщень ОЗ за перiод "
			+ ReadParEx("dat1") + "-" + ReadParEx("dat2") + (isBuh?" (б/о)":" (п/о)")
			+ "|"
			+ "Реестр перемещений ОС за период "
			+ ReadParEx("dat1") + "-" + ReadParEx("dat2") + (isBuh?" (б/у)":" (н/у)")
}

//function listAsk()
//{
//	var arrVariants = list.getVariantsArr();
//	return new DpGetDat(new Array("b0","r"),arrVariants);
//}

function listMake()
{
	DropTable(tblName);
	return r_perem(new Date(dat1), new Date(dat2));
}

function listSrc()
{
	list.qrySet("From", tblName,
		"Order", "FINV_NUM,FBDAT",
		"Prn", listPrnForm,
		"Ptn", "PEREM");
		
	if (SQL)
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	else
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	
	addTtlTbl();
	
}

function listGrid()
{
	grid.setStaticRowspan(1);
	var oGrid = new DpGrid("NOCREATE");
	var nazv_group;
	with (oGrid)
	{
		onePageMode(false);
		
		with(page())
		{
			cell("Finv_num", "Iнв.N|Инв.N", 6);
//			nazv_group = group();
//			list.GroupPage(oGrid,nazv_group);
//			with(nazv_group)
				cell("x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");

			cell("Fpodro", "Підр.\nзвiдки|Подр.\nоткуда", 6);
			cell("Fpodr", "Підр.\nкуди|Подр.\nкуда", 6);
			cell("Ftabn", "МВО|МОЛ", 6);
			cell("Fbdat", "Дата\nперем.", 8);
			cell("Forig_pric", "Первісна вартість\nна дату змiни|Первоначальная стоимость\nна дату измен.", 14, "", DP_FORMAT_SUM);
		}		
		build();
	}
}

function listOnPrnList(tv)
{
	var h = new Object();

	h.DAT_B = new Date(dat1).getVarDate();
	h.DAT_E = new Date(dat2).getVarDate();
	h.ISBUH = isBuh;

	tv.setHTbl(h);
}

function r_perem (dat1, dat2)
{
   cdat1 = sqlTo(dat1);
   cdat2 = sqlTo(dat2);

   dat1 = new Date(dat1);
   dat2 = new Date(dat2);
   	
	//ищем ошибочные записи в списке внутренних перемещений, у которых пустое подразделение откуда встречается больше одного раза
	strSQL = " select Finv_num from ^VN_PEREM "
			+" where Fbdat>="+cdat1+" and Fbdat<="+cdat2+" and Fpodro=0 "
			+" group by Finv_num "
			+" having count(finv_num)>1";
	snap = getSnap(strSQL);
	msg = ru("Найдены ошибки в справочнике внутренних перемещений!\nПродолжить расчет?","Знайдено помилки в довіднику внутрішніх переміщень!\nПродовжити розрахунок?");
	if(snap)
	{
		var p = new Object();
		p.title = ru("Ошибочные внутренние перемещения","Помилкові внутрішні переміщення");
		p.finv_num = strSQL;
		showWindow("l_vnpr.js",SW_NOMODAL,p);
		if(!confirm(msg))
			return false;
	}
	
   DropTable("PEREM");
   DropTable("T1");

   strSQL = "select * from ^VN_PEREM where Fbdat>="+cdat1+" and Fbdat<="+cdat2+" and Fpodro<>0";
   vn = OpenTable("s", strSQL);

   os7 = OpenTable("s", "OS7");
   os7.index = "INV_NUM";
   if (SQL)
		os7.index = "FINV_NUM";

	var gS;
	var m = new Object();
   CreateTable("PEREM", "PEREM", "PEREM");

   prm = OpenTable("s", "PEREM");

   if (!vn.IsEmpty())
   {
      vn.MoveFirst();
      while (!vn.IsEOF())
      {
         fis_inv = true;
         gS = getSnap("select Fiznos from ^OS7 where Finv_num=" + sqlTo(vn.getValue("Finv_num")));
         if (gS != null)
         {
           // mFprice = os7("FORIG_PRIC");
            mFiznos = Number(gS[0]);
         }
         else
         {
            _alert("Нет инв.карт.для N "+String(vn.getValue("Finv_num")));
            fis_inv = false;
            mFprice    = 0;
            mFiznos    = 0;
         }
         if(isBuh)
         	mFprice = Number(izosdatb(new Date(vn.getValue("Fbdat")), Number(vn.getValue("Finv_num")), "orig_pric"));
         else
         	mFprice = Number(izosdat(new Date(vn.getValue("Fbdat")), Number(vn.getValue("Finv_num")), "orig_pric"));
         if (mFprice == -100) mFprice = 0;

         if (fis_inv)
         { 
            //prm.AddNew();
            m = new Object();
            m.fdatn   = dat1;
            m.fdatk   = dat2;
            m.finv_num   = Number(vn.getValue("finv_num"));
            m.fpodr      = Number(vn.getValue("Fpodr"));
            m.fpodro     = Number(vn.getValue("Fpodro"));
            m.fbdat      = vn.getValue("Fbdat");
            m.ftabn      = Number(vn.getValue("Ftabn"));
            m.forig_pric = mFprice;
            m.fiznos     = mFiznos;
           // prm.Update();
           UpdateTable("PEREM",m,true);
         }
         vn.MoveNext();
      }
   }
	prm.Requery();
	if (prm.IsEmpty())
	{
		alert(ru("Нет перемещений ОС за данный период!","Немає переміщень ОЗ за даний період!"));
		prm.Close(5652);
		return false;
	}
	prm.Close(5652);
	list.objTotal.variantCur = oItog.getCod();
	return true;
}

function askForm()
{
	form = createForm(UR("Введіть данні для відбору інформації|Введите данные для отбора информации"));
	oItog = form.addItog(label);
	oItog.setCod(Number(ReadParEx("total")));
	var D1=form.addObj("dat1","date",UR("Дата початку|Дата начала"));
	if(differ(strToDateFormat(ReadParEx("dat1"),"dd.mm.yyyy"),d00)==0)
		D1.setValue(new Date().getVarDate());
	else
		D1.setValue(strToDateFormat(ReadParEx("dat1"),"dd.mm.yyyy"));
	var D2=form.addObj("dat2","date",UR("Дата закінчення|Дата окончания"));
	D2.setValue(strToDateFormat(ReadParEx("dat2"),"dd.mm.yyyy"));
	var buh = form.addObj("buh", "bool", UR("Ведення бух.обліку|Ведение бух.учета"));
	buh.setValue(Boolean(Number(ReadParEx("isBuh"))));
	form.show();
	if(form.escape)
		return false;
	dat1=form.dat1;
	dat2=form.dat2;
	isBuh = toScrObj(form.buh);
	WriteParEx("dat1",format("dd.mm.yyyy",dat1));
	WriteParEx("dat2",format("dd.mm.yyyy",dat2));
	WriteParEx("total",oItog.getCod());
	WriteParEx("isBuh",Number(isBuh));
	while(differ(form.dat1,form.dat2)>0)
	{
		alert(ru("Дата начала не может быть больше даты окончания!","Дата початку не може бути більше за дату закінчення!"));
		askForm();
	}
	return true;
}

include ("sys\\DpList.js");