include ("Objects\\DpGetDat.js");
include ("oss_dat.js");
include ("calc_os.js");
include ("izosdat.js");
include ("izos0.js");
include ("Objects\\DpGrid.js");
include ("sub\\mtr.js");

var listPrnForm  = "PMKMPL";
var tblName = "RKM";
var label = "RKM";

function listLoad()
{
	list.accDel = null;
	list.objTotal.init(label);
	list.par.menuMode = GetMenuMode();
}

function listAsk()
{
	var arrVariants = list.getVariantsArr()

	return new DpGetDat(new Array("b0","r"),arrVariants);
}

function listTitle()
{
	return "Реєстр перемiщень ОЗ мiж компл. 1 гр. за перiод "
			+ StrDat(list.objAsk.dat1, "DMY") + "-" + StrDat(list.objAsk.dat2, "DMY")
			+ "|"
			+ "Реестр перемещений ОС между компл. 1 гр. за период "
			+ StrDat(list.objAsk.dat1, "DMY") + "-" + StrDat(list.objAsk.dat2, "DMY")
}

function listMake()
{
	DropTable(tblName);
	
	r_pmkmpl(list.objAsk.dat1, list.objAsk.dat2);
}

function listSrc()
{
	list.qrySet("From", tblName,
		"Order", "FINV_NUM",
		"Prn", listPrnForm,
		"Ptn", "RKM");
		
	if (SQL)
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	else
		list.subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
	
	addTtlTbl();
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var nazv_group;

	with (oGrid)
	{
		onePageMode(false);
		
		with(page())
		{
			cell("Finv_num", "Iнв.N\nновий|Инв.N\nновый", 6);
			nazv_group = group();
			list.GroupPage(oGrid,nazv_group);
			with(nazv_group)
				cell("x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");

			cell("Finv_old", "Iнв.N\nпопер.|Iнв.N\nпред.", 6);
			cell("Fdat_post", "Дата\nперем.|Дата\nперем.", 8);
			cell("Forig_pric", "Первiсна\nвартiсть|Первоначальная\nстоимость", 14, null, DP_FORMAT_SUM);
		}
		
		var oExtPage = page("Итоги");
		with (oExtPage)
		{
			with(group())
			{
				cell("", "", 1);
			}
		}

//		list.GroupPage(oGrid, oExtPage.group(), 8, false, nazv_group, 0, "w");

		build();
	}
}

function listOnPrnList(tv)
{
	var h = new Object();

	h.DAT_B = javaDate2Script(list.objAsk.dat1).getVarDate();
	h.DAT_E = javaDate2Script(list.objAsk.dat2).getVarDate();

	tv.setHTbl(h);
}

function r_pmkmpl (dat1, dat2)
{

   cdat1 = sqlTo(dat1);
   cdat2 = sqlTo(dat2);

   DropTable("RKM");
   DropTable("T1");

   D1 = javaDate2Script(dat1);
   D2 = javaDate2Script(dat2);

   Retvsp=oss_dat(D1,D2);
   if (Retvsp!=-100)
   {
      vs = OpenTable("s", "VSP");
      vs.index="VSP";
      if (SQL)
			vs.index = "Finv";
   }
   else
   {
      _alert("Не создан.список измен.стоим.Расчет невозможен");
      return;
   }

   os1 = OpenTable("s", "OS1");
   os1.index = "INV_NUM";
   if (SQL)
		os1.index = "FINV_NUM";

   CreateTable("RKM", "RKM", "RKM");

   km = OpenTable("s", "RKM");
	var gS;
	var m = new Object();
   if (vs.IsEmpty()) return;

   vs.MoveFirst();
   while (!vs.IsEOF())
   {
      if (Number(vs.getValue("Fprib"))!=0)
      {
         gS = getSnap("select Finv_old,Fdoc_dat,Forig_pric from ^OS1 where Finv_num=" + sqlTo(vs.getValue("Finv")));
         //if (os1.Seek("=", vs("Finv")))
         if (gS != null)
         {
            if (Number(gS[0])!=0)
            {
               gr_do = izos0("L", (gS[0]), "group");
               gr_ps = izosdat(javaDate2Script(gS[1]), vs.getValue("Finv"), "group");
               if (gr_do==1 && gr_ps==1)
               {
                  //km.AddNew();
                  m = new Object();
                  m.Finv_num = vs.getValue("Finv");
                  m.Finv_old = gS[0];
                  m.Fdat_post= gS[1];
                  m.Forig_pric = gS[2];
                  m.Fiznos = 0;
                  //km.Update();
                  UpdateTable("RKM",m,true);
               }
            }
         }
      }
      vs.MoveNext();
   }

   if (km.IsEmpty()){
      _alert("Нет перевода ОС между комплектами за данный период");
      km.Close(5652);
      return;
   }
   
   km.Close(5652);
}

include ("sys\\DpList.js");