include("servis\\date.js");
include("servis\\format.js");

function get_cnst(pokaz, pok_date)
{
//функция возвращает сумму для указаной постоянной величины и даты;
	oSnap = null;
	oSnap = getSnap("SELECT Fsum FROM ^const"
   				+ " WHERE Fbdat<="+ sqlTo(pok_date)
        		+ " AND Fedat>="+ sqlTo(pok_date)
          		+ " AND Fconst_nam= '"+pokaz+"'");
	if (oSnap!= null)
	{
		if (oSnap[0]!= null)
			return oSnap[0];
		else
			return 0;
	}
	else
		return 0;
}

function szTag(date)
{
	return (date.getYear()+1900) + ((date.getMonth()<9)?"0":"") + (date.getMonth()+1);
}

function r_pns150(dt)
{
	var par = new Object();
	par.escape = true;
	showWindow("i_pns150.xml", SW_MODAL, par);
	
	if (par== null)
		return false;
	else
		if (par.escape)
			return false;
	var RasMode = par.Is;
	var date1 = firstDayMonth(par.MDat);
	var date2 = lastDayMonth(date1);
	dt.dat1 = date1;
	
    //RasMode="ESV";
    
   	var sum_ogr = get_cnst("sum_ogr",date1);
   	if(!sum_ogr)
	{
		alert(ru("Не найдена константа суммы ограничения sum_ogr за",
				"Не знайдено константу граничної суми sum_ogr за")+format(" dd.mm.yyyy",date1).toLowerCase());
	}
   	
	if (RasMode.indexOf("ESV")!=-1)
	{
	   //константа, сколько месяцев нужно не учитывать будущие суммы в текущем месяце
	   //по новому закону отпускные будущие за январь, начисленные в декабре, нельзя перерасчитывать.
	   dtbotp = get_cnst ("dtbotp", new Date(date1))
		
	   // достаем цифры к названию файла
	   if (date1.getMonth() < 9)  
	      szTag = String(new Date(date1).getFullYear()) +"0"+String(new Date(date1).getMonth()+1);
	   else
		  szTag = String(new Date(date1).getFullYear())+String(new Date(date1).getMonth()+1);        
	   var siName = "^svzp" + szTag
		
		//создается временная таблица для расчета единого налога  
		DropTable("SVZPEDV");
		CreateTable("SVZPEDV", "VSP");
		ExecuteSQL("ALTER TABLE SVZPEDV ADD Fmes  "+SqlType("DATE"))
		ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis30  "+SqlType("TEXT",1))		
		ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis19  "+SqlType("TEXT",1))
		ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis8  "+SqlType("TEXT",1))
		ExecuteSQL("ALTER TABLE SVZPEDV ADD Fis12  "+SqlType("TEXT",1))		
    
		ExecuteSQL("INSERT INTO SVZPEDV(Flsfid, Fsum, Fwid_wp, Fshpz, Fmn, Fvp, Ftabn_id, Fis30, Fis12, Fis8, Fis19) SELECT a.Flsfid, a.Fsum, a.Fwid_wp, a.Fshpz, a.Fmn, a.Fvp, a.Ftabn_id, b.Fis30, b.Fis12, b.Fis8, b.Fis19  FROM "+siName+" a INNER JOIN ^LIC_FLD b on a.Flsfid=b.Fid");
		ExecuteSQL("update SVZPEDV set Fmes="+sqlTo(date1))
		ExecuteSQL("DELETE FROM SVZPEDV WHERE Fvp=1 AND Fmn>Fmes");
		if (dtbotp!=0){
			ExecuteSQL("update SVZPEDV set Fmn="+sqlTo(d00obj)+", Fvp=0 where Fvp=1 and Fmn<"+sqlTo(date1))			
		}
		
		//налогооблагаемая сумма		
	      DropTable("TMP1");
	      strSQL = "select sum(s.Fsum) as Fsum, sum(s.Fsum) as Fsumbedv, sum(s.Fsum) as Fsumnedv, Ftabn_id, Fmn, Fvp into TMP1 from SVZPEDV s where s.Fis30='+' group by Ftabn_id, Fmn, Fvp"
	      ExecuteSQL(strSQL);
	      ExecuteSQL("update TMP1 set Fsumbedv=0, Fsumnedv=0")   

	      //база для взноса с учетом ограничения		
	      DropTable("TMP2");		
	      strSQL = "select sum(s.Fsum) as Fsumbedv, sum(s.Fsum) as Fsumnedv, sum(s.Fsum) as Fsum, Ftabn_id, Fmn, Fvp into TMP2 from SVZPEDV s where (s.Fis12='5' or s.Fis12='6' or s.Fis12='7') group by s.Ftabn_id, s.Fmn, s.Fvp"
	      ExecuteSQL(strSQL);			
	      ExecuteSQL("update TMP2 set Fsum=0, Fsumnedv=0")   

	      //взнос с учетом ограничения		
	      DropTable("TMP3");
	      strSQL = "select sum(s.Fsum) as Fsumnedv, sum(s.Fsum) as Fsumbedv, sum(s.Fsum) as Fsum, Ftabn_id, Fmn, Fvp into TMP3 from SVZPEDV s where (s.Fis8='5' or s.Fis8='6' or s.Fis8='7') group by s.Ftabn_id, s.Fmn, s.Fvp"
	      ExecuteSQL(strSQL);
	      ExecuteSQL("update TMP3 set Fsumbedv=0, Fsum=0")   

	      strSQL = "insert into TMP1 (Ftabn_id,Fmn,Fvp,Fsum,Fsumbedv,Fsumnedv) select Ftabn_id,Fmn,Fvp,Fsum,Fsumbedv,Fsumnedv from TMP2"
	      ExecuteSQL(strSQL);
	      strSQL = "insert into TMP1 (Ftabn_id,Fmn,Fvp,Fsum,Fsumbedv,Fsumnedv) select Ftabn_id,Fmn,Fvp,Fsum,Fsumbedv,Fsumnedv from TMP3"
	      ExecuteSQL(strSQL);

	      DropTable("TMP4");
	      strSQL = "select sum(s.Fsumbedv) as Fsumbedv, sum(s.Fsumnedv) as Fsumnedv, sum(s.Fsum) as Fsum, Ftabn_id, Fmn, Fvp into TMP4 from TMP1 s group by s.Ftabn_id, s.Fmn, s.Fvp"
	      ExecuteSQL(strSQL);			
		
		
		//текущие суммы и будущие
		DropTable("SUMTMP1");
		//strSQL = "select a.*, 0 as Ftt, cl.Fcod as Ftabn into SUMTMP1 from TMP4 a INNER JOIN ^clrelclcl cl ON a.Ftabn_id= cl.Fwid_cl where a.Fvp=0 or NOT(a.Fvp=2 and a.Fmn<"+sqlTo(date1)+")"
		strSQL = "select a.*, 0 as Ftt, 0 as Fis_prev, cl.Fcod as Ftabn into SUMTMP1 from TMP4 a INNER JOIN ^clrelclcl cl ON a.Ftabn_id= cl.Fwid_cl"		
		ExecuteSQL(strSQL);
		ExecuteSQL("ALTER TABLE SUMTMP1 ADD Fsumogr "+SqlType("CURRENCY"))
		ExecuteSQL("ALTER TABLE SUMTMP1 ADD Fsum_razn "+SqlType("CURRENCY"))				
		
		ExecuteSQL("update SUMTMP1 set Fsum_razn=Fsum-Fsumbedv")		
		ExecuteSQL("update SUMTMP1 set Fis_prev=1 where abs(Fsum_razn)>0")
		//для режима отображения тольк записей с превышением суммы ограничения остальные записи удаляем
		if (RasMode=="ESVOGR")
			ExecuteSQL("delete from SUMTMP1 where Fis_prev=0");
		

		var gs = getSnap("select count(*) as Fkolrec from SUMTMP1")
		if (gs!=null && gs[0]!=0){
			DropTable("SUMTMP3")
			strSQL = "SELECT SUM(s.Fsum) as Fsum, SUM(s.Fsumbedv) as Fsumbedv, SUM(s.Fsumnedv) as Fsumnedv, SUM(s.Fsumogr) as Fsumogr, SUM(s.Fsum_razn) as Fsum_razn,"
  			+ " 0 as Ftabn_id, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp, 0 as Ftabn "
          	+ " INTO SUMTMP3 from SUMTMP1 s";
			ExecuteSQL(strSQL);
 
			strSQL = "INSERT INTO SUMTMP1(Fsum, Fsumbedv, Fsumnedv, Fsumogr, Fsum_razn, Ftabn_id, Ftabn, Ftt, Fmn, Fvp, Fis_prev)"
  			+ " SELECT Fsum, Fsumbedv, Fsumnedv, Fsumogr, Fsum_razn, Ftabn_id, Ftabn, Ftt, Fmn, Fvp, 0"
  			+ " FROM SUMTMP3";
			ExecuteSQL(strSQL);
		}	
		DropTable("SUMTMP");
		strSQL = "CREATE TABLE SUMTMP "
					+ " ( S_dox "+SqlType("CURRENCY")
					+ " , S_ogr "+SqlType("CURRENCY")					
					+ " , S_tax "+SqlType("CURRENCY")
					+ " , S_taxn "+SqlType("CURRENCY")					
					+ " , S_razn "+SqlType("CURRENCY")					
					+ " , FMN "+SqlType("DATE")
					+ " , FVP "+SqlType("BYTE")
					+ " , FTABN "+SqlType("LONG")
					+ " , FTABN_ID "+SqlType("LONG")
					+ " , FTT "+SqlType("BYTE")
					+ " , FKOD_KZO "+SqlType("BYTE")
					+ " , FPROC_N "+SqlType("CURRENCY")
					+ " , FPROC_U "+SqlType("CURRENCY")										
					+ " , FSUM "+SqlType("CURRENCY")																									
					+ " , FWID " + SqlType("COUNTER") + ")";
			ExecuteSQL(strSQL); 			
		
        strSQL = "INSERT INTO SUMTMP(S_dox, S_ogr, S_tax, S_razn, Ftabn_id, Ftabn, Ftt, Fmn, Fvp)"
  			+ " SELECT Fsum, Fsumbedv, Fsumnedv, Fsum_razn, Ftabn_id, Ftabn, Ftt, Fmn, Fvp"
  			+ " FROM SUMTMP1";
        ExecuteSQL(strSQL);
        
        DropTable("RAZBKAT1")        
        ExecuteSQL("CREATE TABLE RAZBKAT1 ("
   				+ " Ftabn_id"+SqlType("LONG")+","
   				+ " Fcod_kzo " +SqlType("LONG")+","
   				+ " Fsumbase " +SqlType("CURRENCY")+","
   				+ " Fsumud  " +SqlType("CURRENCY")+","
   				+ " Fsumnach " +SqlType("CURRENCY")+","   				
   				+ " Fmes "   +SqlType("DATE")+","
   				+ " Fmn "   +SqlType("DATE")+","
   				+ " Fvp "   +SqlType("BYTE")+","   				
				+ " Fproc_n "  +SqlType("CURRENCY")+","
				+ " Fproc_u "  +SqlType("CURRENCY")+")");

      
        DropTable("XX1")
        strSQL = "select a.Ftabn_id,a.Flsfid,a.Fsum as Fsumbase, a.Fday as Fcod_kzo,a.Fproc as Fproc_u, a.Fmn, a.Fvp  into XX1 from "+siName+" a inner join ^lic_fld l on a.Flsfid=l.Fid"+
                 " and (l.Fis12='5' or l.Fis12='6' or l.Fis12='7') and not (a.Fvp=1 and a.Fmn>"+sqlTo(date1)+")"
        ExecuteSQL(strSQL);
        DropTable("XX2")
        strSQL = "select a.Ftabn_id,a.Flsfid,a.Fsum as Fsumud,a.Fday as Fcod_kzo,a.Fproc as Fproc_u, a.Fmn, a.Fvp into XX2 from "+siName+" a inner join ^lic_fld l on a.Flsfid=l.Fid"+
                 " and (l.Fis8='5' or l.Fis8='6' or l.Fis8='7') and not (a.Fvp=1 and a.Fmn>"+sqlTo(date1)+")"
        ExecuteSQL(strSQL);
        DropTable("XX3")
        strSQL = "select a.Ftabn_id,a.Flsfid,a.Fsum as Fsumnach,a.Fday as Fcod_kzo,a.Fproc as Fproc_n, a.Fmn, a.Fvp into XX3 from ^svpf"+szTag+" a inner join ^lic_fld l on a.Flsfid=l.Fid"+
                 " and (l.Fis12='0' or l.Fis12='h' or l.Fis12='k') and not (a.Fvp=1 and a.Fmn>"+sqlTo(date1)+")"
        ExecuteSQL(strSQL, false);

        ExecuteSQL("insert into RAZBKAT1 (Ftabn_id,Fcod_kzo,Fsumbase,Fproc_u,Fmn,Fvp) select Ftabn_id,Fcod_kzo,Fsumbase,Fproc_u,Fmn, Fvp from XX1")
        ExecuteSQL("insert into RAZBKAT1 (Ftabn_id,Fcod_kzo,Fsumud,Fproc_u,Fmn, Fvp) select Ftabn_id,Fcod_kzo,Fsumud,Fproc_u,Fmn, Fvp from XX2")
        ExecuteSQL("insert into RAZBKAT1 (Ftabn_id,Fcod_kzo,Fsumnach,Fproc_n,Fmn, Fvp) select Ftabn_id,Fcod_kzo,Fsumnach,Fproc_n,Fmn, Fvp from XX3", false)
        
        DropTable("RAZBKATU")        
        strSQL = "select a.Fcod_kzo, sum(a.Fsumbase) as Fsumbase, sum(a.Fsumud) as Fsumud, sum(a.Fsumnach) as Fsumnach, MAX(a.Fproc_u) as Fproc_u, MAX(a.Fproc_n) as Fproc_n,a.Fmn, a.Fvp into RAZBKATU from RAZBKAT1 a group by a.Fcod_kzo,a.Fmn, a.Fvp"
        ExecuteSQL(strSQL);


        strSQL = "INSERT INTO SUMTMP(S_dox, S_ogr, S_tax, S_taxn, S_razn, Ftabn_id, Ftabn, Ftt, Fmn, Fvp, Fkod_kzo,Fproc_n,Fproc_u)"
  			+ " SELECT 0, Fsumbase, Fsumud, Fsumnach, 0, 0, 0, 3, Fmn, Fvp, Fcod_kzo,Fproc_n,Fproc_u "
  			+ " FROM RAZBKATU";
        ExecuteSQL(strSQL);

	}
	
 	if (RasMode.indexOf("ESV")==-1)
 	{
 	   	gr_pns  = get_cnst("gr_pns" ,date1); 		
	//отдельная сумма ограничения для пенсионного фонда
	var sum_ogrp = get_cnst("sum_ogrp",date1);
	if(!sum_ogrp)
		sum_ogrp = sum_ogr;
   	
   	gr_soc  = get_cnst("gr_soc" ,date1);

	tbl_svzp = "SVZP" + getDateTag(date1);
	
	DropTable("SVZP_ALL");
   	DropTable("SUMTMP");
   	DropTable("SUMTMP0");
   	DropTable("SUMTMP00");
   	DropTable("SUMTMP50");
   	DropTable("SUMTMP2");
   	DropTable("SUMTMP3");
   	DropTable("SUMTMP4");
   	
   	if (IsTable("SVZP_ALL") || IsTable("SUMTMP")  || IsTable("SUMTMP0") || IsTable("SUMTMP00") ||
    	IsTable("SUMTMP50") || IsTable("SUMTMP2") || IsTable("SUMTMP3"))
        {
           alert(ru("Невозможно выполнить расчет."
           +"\nПроверьте, возможно окно с данным расчетом уже открыто,"
           +"\nили перезапустите систему.",
           			"Неможливо виконати розрахунок."
           +"\nПеревірте, можливо вікно з данними вже відчинено,"
           +"\nабо перезапустіть систему"));
	        return false;
        } 
   
   	CreateTable("SVZP_ALL", "SVZP_ALL", "*");
	ExecuteSQL("CREATE Index SVTN150 ON SVZP_ALL (Ftabn,Flsfid,Fmn,Fvp)", true);

   ExecuteSQL("CREATE TABLE SUMTMP0 ("
   				+ " Ftabn "  +SqlType("LONG")+","
   				+ " Ftabn_id"+SqlType("LONG")+","
   				+ " Ftt "    +SqlType("SHORT")+","
   				+ " Fmes "   +SqlType("DATE")+","
				+ " S_dox "  +SqlType("CURRENCY")+","
				+ " Flsfid " +SqlType("LONG")+","
				+ " Fmn "    +SqlType("DATE")+","
				+ " Fvp "    +SqlType("SHORT")+","
				+ " S_tax "  +SqlType("CURRENCY")+","
				+ " S_razn " +SqlType("CURRENCY")+")");
				
	var tblOut = "ZRP_" + tbl_svzp;
   	if (IsTableEx("ZRP_RES", tblOut))
   	{
		ExecuteSQL("INSERT INTO SVZP_ALL (Ftabn, Ftabn_id, Flsfid, Ffld_num, Fsum,"
					+ " Fbdy, Fedy, Fday, Fis_day, Fmn, Fvp, Fmf, Fmes)"
					+ " SELECT cl.Fcod as Ftabn, sv.Ftabn_id, sv.Flsfid,"
						+ " sv.Ffld_num, sv.Fsum, sv.Fbdy, sv.Fedy,"
						+ " sv.Fday, sv.Fis_day, sv.Fmn, sv.Fvp, "
						+ sqlTo(date1)+" as Fmf, "+sqlTo(date1)+" as Fmes"
					+ " FROM ^"+tbl_svzp+" sv INNER JOIN ^clrelclcl cl ON sv.Ftabn_id= cl.Fwid_cl"
					/*+ " ORDER BY cl.Fcod, sv.Flsfid"*/);
   	}

	ExecuteSQL("DELETE FROM SVZP_ALL WHERE Fvp=1 AND Fmn>Fmf");
	
	ALL_table = OpenTable("s","SELECT * FROM SVZP_ALL ORDER BY Ftabn,Flsfid,Fmn,Fvp");
   	if(ALL_table.IsEOF() && ALL_table.IsBOF())
   	{
		alert(ru("Hет инфоpмации по начисленной з/п для pасчета.",
		"Немае інформації по нарахованій з/п для розрахунку."));
      	return false;
   	} 

   lic_fld = OpenTable("s", "SELECT * FROM ^LIC_FLD WHERE Fis_slct="+sqlTrue+" ORDER BY Fid");

   if (RasMode == "is150pns") // 1-й
   {
      ALL_table.MoveFirst();
      var pFtabn = Number(ALL_table.getValue("Ftabn"));
      var pFtabn_id = ALL_table.getValue("Ftabn_id");
      var pFmes  = ALL_table.getValue("Fmes");

      while(!ALL_table.IsEOF())
      {
      	WAIT(ru("Рассчит.таб.N ","Розрахунок таб.N ")+pFtabn);
        while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))== pFtabn))
         {
            ssum1   = 0;
            ssum3   = 0;
            ssum5   = 0;
            ssum8   = 0;
            mFlsfid = Number(ALL_table.getValue("Flsfid"));
            mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            mFvp    = Number(ALL_table.getValue("Fvp"));

            while ((!ALL_table.IsEOF()) &&
            		 (Number(ALL_table.getValue("Ftabn")) == pFtabn) &&
            		 (Number(ALL_table.getValue("Flsfid"))== mFlsfid) &&
            		 (toScriptDate(ALL_table.getValue("Fmn")).getYear()== mFmn.getYear()) &&
            		 (toScriptDate(ALL_table.getValue("Fmn")).getMonth()== mFmn.getMonth()) &&
            		 (toScriptDate(ALL_table.getValue("Fmn")).getDate()== mFmn.getDate()) &&
            		 (ALL_table.getValue("Fvp")==mFvp))
            {
               var mFsum   = Number(ALL_table.getValue("Fsum"));
               var mFmf    = ALL_table.getValue("Fmf");
               var mFlsfid = ALL_table.getValue("Flsfid");

               // проверка входимости в налогооблагаемую сумму
               if(!lic_fld.FindFirst("FID=" + mFlsfid)){
                  WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     +" Ссылка на неизвестное поле лицевого счета.\n"
                         +" Пригласите разработчиков для устранения");}

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               switch (String(lic_fld.getValue("Fis8")))
               	{
               		case '+': ssum1 += mFsum; break;
               		case '*': ssum3 += mFsum; break;
               		case '&': ssum5 += mFsum; break;
               		case '?': ssum8 += mFsum; break;
               		default: break;
               	}
               ALL_table.MoveNext();
            }

			ssum = ssum1 + ssum3 + ssum5 + ssum8;
            if (ssum!= 0)
            {
            	ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
            		+ " VALUES ("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "
            			+ sqlTo(mFmn)+", "+mFvp+", "+sqlTo(pFmes)+", "+mFlsfid+")");
            }
         } // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))

         if(!ALL_table.IsEOF())
         {
            pFtabn = Number(ALL_table.getValue("Ftabn"));
            pFtabn_id = ALL_table.getValue("Ftabn_id");
            pFmes  = toScriptDate(ALL_table.getValue("Fmes"));
         }
      }  //end of while(!ALL_table.IsEOF())

      strSQL = "SELECT * FROM SUMTMP0 WHERE Fvp=2 AND Fmn<Fmes ORDER BY Ftabn";
      SUMTMPV = OpenTable("s",strSQL);
      if (!SUMTMPV.IsEmpty())
      {
         SUMTMPV.MoveFirst();
         while (!SUMTMPV.IsEOF())
         {
            vFtabn = SUMTMPV.getValue("Ftabn");
            vFtabn_id = SUMTMPV.getValue("Ftabn_id");
            vFmes  = SUMTMPV.getValue("Fmes");
            vFmn   = SUMTMPV.getValue("Fmn");   
            vFvp   = SUMTMPV.getValue("Fvp");
            ctn    = SUMTMPV.getValue("Ftabn")
            dat_pr = firstDayMonth(SUMTMPV.getValue("Fmn"));
            var tbl_svzpDP = "SVZP" + szTag(dat_pr);
            var xxfile = "ZRP_" + tbl_svzpDP;  
            if (IsTableEx("zrp_res", xxfile))
            {
               var ttbl = OpenTable("s","SELECT sv.* FROM ^"+tbl_svzpDP+" sv"
               			+ " INNER JOIN ^clrelclcl cl ON sv.Ftabn_id= cl.Fwid_cl"
               		+ " WHERE cl.Fcod="+ ctn +" AND sv.Fvp=0 ORDER BY sv.Flsfid");
               if (!ttbl.IsEmpty())
               {
                  ttbl.MoveFirst();
                  while (!ttbl.IsEOF())
                  {
                     sum1   = 0;
                     sum3   = 0;
                     sum5   = 0;
                     sum8   = 0;
                     mFsum   = Number(ttbl.getValue("Fsum"));
                     vFlsfid = Number(ttbl.getValue("Flsfid"));
                     while (!ttbl.IsEOF() && Number(ttbl.getValue("Flsfid"))== vFlsfid)
                     {
                        if(!lic_fld.FindFirst("FID=" + vFlsfid))          
                           WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                           		+ " Ссылка на неизвестное поле лицевого счета.\n"
                           		+ " Пригласите разработчиков для устранения")

                        // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
                        // колонке (Fis8) файла LIC_FLD
                        switch (String(lic_fld.getValue("Fis8")))
               			{
               				case '+': sum1 += mFsum; break;
               				case '*': sum3 += mFsum; break;
               				case '&': sum5 += mFsum; break;
               				case '?': sum8 += mFsum; break;
               				default: break;
               			}
                        ttbl.MoveNext();
                     }
                     sum = sum1 + sum3 + sum5 + sum8;
                     if (sum!= 0)
                     {
                     	ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
		            		+ " VALUES ("+vFtabn+", "+vFtabn_id+", "+sqlTo(sum)+", "+sqlTo(vFmn)+", "
		            			+ vFvp+", "+sqlTo(vFmes)+", "+vFlsfid+")");
                     }
                  } 
               }
               ttbl.close();
            }   
            if(!SUMTMPV.IsEOF())
            {  
               SUMTMPV.MoveNext();
            }
         }  
      }
      SUMTMPV.close();
      strSQL =  "SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      			+ " s.Ftabn, s.Ftabn_id, s.Fmn, s.Fvp, s.Ftt, 0 as S_razn"
                + " INTO SUMTMP00 FROM SUMTMP0 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Ftt";
      ExecuteSQL(strSQL);

	ExecuteSQL("SELECT SUM(s.S_dox) as S_dox, sum(s.S_tax) as S_tax,"
    			+ " s.Ftabn, s.Ftabn_id, s.Fmn, s.Fvp, s.Ftt, 0 as S_razn"
                + " INTO SUMTMP50 FROM SUMTMP00 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Ftt");
    
   ExecuteSQL("SELECT * INTO SUMTMP FROM SUMTMP50 WHERE ABS(S_DOX)<="+ gr_pns);

      strSQL = "SELECT * FROM ^LIC_FLD WHERE Fis8='п' AND Fis_slct="+sqlTrue+" ORDER BY Ffld_num";
      tlic_fld = OpenTable("s", strSQL);
      if (!tlic_fld.IsEmpty())
      {
         mFlsfid = tlic_fld.getValue("Fid");
            strSQL = "SELECT Ftabn, Fmn, Fvp, Flsfid, SUM(Fsum) as Fsum2"
            			+ " INTO SUMTMP2"
            			+ " FROM SVZP_ALL"
            			+ " WHERE Flsfid="+mFlsfid
                      	+ " GROUP BY Ftabn, Fmn, Fvp, Flsfid"
                      	+ " ORDER BY Ftabn, Fmn, Fvp";
            ExecuteSQL(strSQL);
            sumtmp2 = OpenTable("s", "SUMTMP2");
            if (!sumtmp2.IsEmpty())
            {
               sumtmp2.MoveFirst();
               while (!sumtmp2.IsEOF())
               {
                  nFtabn = sumtmp2.getValue("Ftabn");
                  nFmn   = sumtmp2.getValue("Fmn");
                  nFvp   = sumtmp2.getValue("Fvp");
                  /*strSQL = "SELECT * FROM SUMTMP"
                  			+ " WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp);
                  sumtmp = OpenTable("s", strSQL);
                  if (!sumtmp.IsEmpty())
                  {*/
                     ExecuteSQL("UPDATE SUMTMP SET S_tax="+sqlTo(sumtmp2.getValue("Fsum2"))+" WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp));
                  /*}
                  else
                  {
                     strSQL = "SELECT * FROM SUMTMP00"
                     			+ " WHERE Ftabn="+ nFtabn
                     				+ " AND Fmn="+sqlTo(nFmn)
                     				+ " AND Fvp="+sqlTo(nFvp);
                     sumtmp00 = OpenTable("s", strSQL);
                     if (!sumtmp00.IsEmpty() && Math.abs(sumtmp00.getValue("S_DOX"))<= gr_pns)
                     {
                        sumtmp.Edit();
                        sumtmp.setValue("S_tax",sumtmp2.getValue("Fsum2"));
                        sumtmp.setValue("Ftabn",sumtmp2.getValue("Ftabn"));
                        sumtmp.setValue("Fmn",sumtmp2.getValue("Fmn"));
                        sumtmp.setValue("Fvp",sumtmp2.getValue("Fvp"));
                        sumtmp.Update();
                     }
                  }*/
                  sumtmp2.MoveNext();
               }
            }
            sumtmp2.close();
      }
	  tlic_fld.close();
      strSQL = "SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      			+ " 0 as Ftabn, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp, 0 as S_razn "
              	+ " INTO SUMTMP3 from SUMTMP s";
      ExecuteSQL(strSQL);
     
      strSQL = "INSERT INTO SUMTMP(S_dox, S_tax, Ftabn, Ftt, Fmn, Fvp, S_razn)"
      			+ " SELECT S_dox, S_tax, Ftabn, Ftt, Fmn, Fvp, S_razn"
      			+ " FROM SUMTMP3";
      ExecuteSQL(strSQL);
   } // /1-й
 	}
 	
   if (RasMode == "is150soc") // 2-й
   {
      ALL_table.MoveFirst();
      var pFtabn = Number(ALL_table.getValue("Ftabn"));
      var pFtabn_id = ALL_table.getValue("Ftabn_id");
      var pFmes  = ALL_table.getValue("Fmes");
      while(!ALL_table.IsEOF())
      {
      	WAIT("Рассчит.таб.N "+pFtabn);
      	
         while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))== pFtabn))
         {
            var ssum1   = 0;
            var ssum3   = 0;
            var ssum5   = 0;
            var mFlsfid = Number(ALL_table.getValue("Flsfid"));
            var mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            var mFvp    = Number(ALL_table.getValue("Fvp"));

            while((!ALL_table.IsEOF()) &&
            	 (Number(ALL_table.getValue("Ftabn"))==pFtabn) &&
            	 (Number(ALL_table.getValue("Flsfid"))==mFlsfid) &&
            	 ((toScriptDate(ALL_table.getValue("Fmn")).getYear()== mFmn.getYear()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getMonth()== mFmn.getMonth()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getDate()== mFmn.getDate())) &&
            	  (Number(ALL_table.getValue("Fvp"))== mFvp))
           	{
               var mFsum   = Number(ALL_table.getValue("Fsum"));
               var mFmf    = ALL_table.getValue("Fmf");
               var mFlsfid = ALL_table.getValue("Flsfid");
               // проверка входимости в налогооблагаемую сумму
              
               if(!lic_fld.FindFirst("FID=" + mFlsfid))
                  WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     +" Ссылка на неизвестное поле лицевого счета.\n"
                         +" Пригласите разработчиков для устранения")

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               if (lic_fld.getValue("Fis17")=='+')
               {
               		ssum1 += mFsum;
               }
               var ssum3      = 0;
               var ssum5      = 0;
               ALL_table.MoveNext();
            }
            ssum = ssum1 + ssum3 + ssum5;
            if (ssum!=0)
            {
               ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               		+ " VALUES("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "+sqlTo(mFmn)+", "+mFvp
               			+", "+sqlTo(pFmes)+", "+mFlsfid+")");
            }
         } // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))

         if(!ALL_table.IsEOF())
         {
            pFtabn = ALL_table.getValue("Ftabn");
            pFtabn_id = ALL_table.getValue("Ftabn_id");
            pFmes  = ALL_table.getValue("Fmes");
         }
      }  //end of while(!ALL_table.IsEOF())

      strSQL = "SELECT * FROM SUMTMP0 WHERE Fvp=2 AND Fmn<Fmes ORDER BY Ftabn"
      SUMTMPV = OpenTable("s",strSQL);
      if (!SUMTMPV.IsEmpty())
      {
         SUMTMPV.MoveFirst();
         while (!SUMTMPV.IsEOF())
         {
            vFtabn = SUMTMPV.getValue("Ftabn");
            vFtabn_id = SUMTMPV.getValue("Ftabn_id");
            vFmes  = SUMTMPV.getValue("Fmes");
            vFmn   = SUMTMPV.getValue("Fmn");   
            vFvp   = SUMTMPV.getValue("Fvp");
            ctn    = SUMTMPV.getValue("Ftabn");
            dat_pr = firstDayMonth(SUMTMPV.getValue("Fmn"));
            var tbl_svzpDP = "SVZP" + szTag(dat_pr);
            var xxfile = "zrp_" + tbl_svzpDP;
            if (IsTableEx("zrp_res", xxfile))
            {
               var ttbl = OpenTable("s","SELECT s.* FROM ^"+tbl_svzpDP+" s"
               			+ " INNER JOIN ^clrelclcl cl ON s.Ftabn_id= cl.Fwid_cl"
               		+ " WHERE cl.Fcod="+ ctn+" AND s.Fvp=0"
               		+ " ORDER BY Flsfid");
               if (!ttbl.IsEmpty())
               {
                  ttbl.MoveFirst();
                  while (!ttbl.IsEOF())
                  {
                     sum1 = 0;
                     sum3 = 0;
                     sum5 = 0;
                     mFsum = Number(ttbl.getValue("Fsum"));
                     vFlsfid = Number(ttbl.getValue("Flsfid"));
                     while (!ttbl.IsEOF() && Number(ttbl.getValue("Flsfid"))==vFlsfid)
                     {
                        if(!lic_fld.FindFirst("FID=" + vFlsfid))
                           WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                           +" Ссылка на неизвестное поле лицевого счета.\n"
                           +" Пригласите разработчиков для устранения")

                        if (lic_fld.getValue("Fis17")=='+')
                        {
                        	sum1 += mFsum;
                        }
                        var sum3      = 0;
                        var sum5      = 0;
                        ttbl.MoveNext();
                     }
                     sum     = sum1 + sum3 + sum5;
                     if (sum!= 0)
                     {
                     	ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               				+ " VALUES("+vFtabn+", "+vFtabn_id+", "+sqlTo(sum)+", "+sqlTo(vFmn)+", "+vFvp
               					+ ", "+sqlTo(vFmes)+", "+vFlsfid+")");
                     }
                  } 
               }
               ttbl.close();
            }   
            if(!SUMTMPV.IsEOF())
            {
               SUMTMPV.MoveNext();
            }
         }  
      }
      SUMTMPV.close();

      strSQL = "SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      		+ " Ftabn, Ftabn_id, Fmn, Fvp, Ftt, 0 as S_razn"
            + " INTO SUMTMP00 FROM SUMTMP0 s"
            + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Ftt";
      ExecuteSQL(strSQL);

         strSQL = "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
         		+ " Ftabn, Ftabn_id, Fmn, Fvp, Ftt, 0 as S_razn" 
                + " INTO SUMTMP50 FROM SUMTMP00 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Ftt";
         ExecuteSQL(strSQL);
         strSQL = "SELECT * INTO SUMTMP FROM SUMTMP50"
         		+ " WHERE ABS(S_DOX)<="+ gr_soc;
         ExecuteSQL(strSQL);

      strSQL = "SELECT * FROM ^LIC_FLD WHERE Fis8='с' AND Fis_slct="+sqlTrue;
      tlic_fld = OpenTable("s", strSQL);
      if (!tlic_fld.IsEmpty())
      {
         mFlsfid = tlic_fld.getValue("Fid");
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, SUM(Fsum) as Fsum2"
            		+ " INTO SUMTMP2 FROM SVZP_ALL"
            		+ " WHERE Flsfid="+ mFlsfid
                    + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid"
                    + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            sumtmp2 = OpenTable("s", "SUMTMP2");
            if (!sumtmp2.IsEmpty())
            {
               sumtmp2.MoveFirst();
               while (!sumtmp2.IsEOF())
               {
                  nFtabn = sumtmp2.getValue("Ftabn");
                  nFtabn_id = sumtmp2.getValue("Ftabn_id");
                  nFmn   = sumtmp2.getValue("Fmn");
                  nFvp   = sumtmp2.getValue("Fvp");
                  /*strSQL = "SELECT * FROM SUMTMP"
                  		+ " WHERE Ftabn="+ nFtabn
                  			+ " AND Fmn="+sqlTo(nFmn)
                  			+ " AND Fvp="+sqlTo(nFvp);
                  sumtmp = OpenTable("s", strSQL);
                  if (!sumtmp.IsEmpty())
                  {*/
                     ExecuteSQL("UPDATE SUMTMP SET S_tax="+sqlTo(sumtmp2.getValue("Fsum2"))+" WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp));
                  /*}
                  else
                  {
                     strSQL = "SELECT * FROM SUMTMP00"
                     		+ " WHERE Ftabn="+ nFtabn
                     			+ " AND Fmn="+sqlTo(nFmn)
                     			+ " AND Fvp="+sqlTo(nFvp);
                     sumtmp00 = OpenTable("s", strSQL);
                     if (!sumtmp00.IsEmpty() && Math.abs(sumtmp00.getValue("S_DOX"))<=gr_soc)
                     {
                        sumtmp.Edit();
                        sumtmp.setValue("S_tax",sumtmp2.getValue("Fsum2"));
                        sumtmp.setValue("Ftabn",sumtmp2.getValue("Ftabn"));
                        sumtmp.setValue("Ftabn_id",sumtmp2.getValue("Ftabn_id"));
                        sumtmp.setValue("Fmn",sumtmp2.getValue("Fmn"));
                        sumtmp.setValue("Fvp",sumtmp2.getValue("Fvp"));
                        sumtmp.Update();
                     }
                  }*/
                  sumtmp2.MoveNext();
               }
            }
            sumtmp2.close();
      }
	  tlic_fld.close();
      strSQL = "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
      		+ " 0 as Ftabn, 0 as Ftabn_id, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp, 0 as S_razn "
            + " INTO SUMTMP3 FROM SUMTMP s";
      ExecuteSQL(strSQL);
     
      strSQL = "INSERT INTO SUMTMP(S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn)"
      		+ " SELECT S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn"
      		+ " FROM SUMTMP3";
      ExecuteSQL(strSQL);
   } // /2-й

   if (RasMode == "is1000pns") // 3-й
   {
      ALL_table.MoveFirst();
      var pFtabn = Number(ALL_table.getValue("Ftabn"));
      var pFtabn_id = ALL_table.getValue("Ftabn_id");
      var pFmes  = ALL_table.getValue("Fmes");
      while(!ALL_table.IsEOF())
      {
      	WAIT("Рассчит.таб.N "+pFtabn);
         while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))==pFtabn))
         {
			var ssum1   = 0;
            var mFlsfid = Number(ALL_table.getValue("Flsfid"));
            var mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            var mFvp    = Number(ALL_table.getValue("Fvp"));
            while((!ALL_table.IsEOF()) &&
            	 (Number(ALL_table.getValue("Ftabn"))== pFtabn) &&
            	 (Number(ALL_table.getValue("Flsfid"))== mFlsfid) &&
            	 ((toScriptDate(ALL_table.getValue("Fmn")).getYear()== mFmn.getYear()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getMonth()== mFmn.getMonth()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getDate()== mFmn.getDate())) &&
            	  (Number(ALL_table.getValue("Fvp"))== mFvp))
            {
               var mFsum   = Number(ALL_table.getValue("Fsum"));
               var mFmf    = ALL_table.getValue("Fmf");
               var mFlsfid = Number(ALL_table.getValue("Flsfid"));
               // проверка входимости в налогооблагаемую сумму
             
               if(!lic_fld.FindFirst("FID=" + mFlsfid))          
                  WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     +" Ссылка на неизвестное поле лицевого счета.\n"
                         +" Пригласите разработчиков для устранения")

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               if (lic_fld.getValue("Fis20")=='+')
               		ssum1 += mFsum;
               
               ALL_table.MoveNext();
            } // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))

			ssum = ssum1;
			if (ssum!= 0)
			{
				ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               		+ " VALUES("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "+sqlTo(mFmn)+", "+mFvp
               			+", "+sqlTo(pFmes)+", "+mFlsfid+")");
			}
		} 

		if(!ALL_table.IsEOF())
		{
			pFtabn = ALL_table.getValue("Ftabn");
			pFtabn_id = ALL_table.getValue("Ftabn_id");
			pFmes  = ALL_table.getValue("Fmes");
		}
       }

	ExecuteSQL("SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
      			+ " SUM(s.S_razn) as S_razn, Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt "
                + " INTO SUMTMP00 FROM SUMTMP0 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp");

	ExecuteSQL("SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
         		+ " SUM(s.S_razn) as S_razn, Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt " 
                + " INTO SUMTMP50 FROM SUMTMP00 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp");

	ExecuteSQL("SELECT * INTO SUMTMP FROM SUMTMP50 WHERE ABS(S_DOX)>"+ sum_ogrp);
	
      strSQL = "SELECT * FROM ^LIC_FLD WHERE Fis8='п' AND Fis_slct="+sqlTrue;
      tlic_fld = OpenTable("s", strSQL);
      if (!tlic_fld.IsEmpty())
      {
         mFlsfid = tlic_fld.getValue("Fid");
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(Fsum) as Fsum2"
            	+ " INTO SUMTMP4 FROM SVZP_ALL"
            	+ " WHERE Flsfid="+ mFlsfid
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            strSQL = "UPDATE SUMTMP4 SET Fmn="+sqlTo(d00obj)+", Fvp=0"
            		+ " WHERE Fvp=2 AND Fmn<Fmes";
            ExecuteSQL(strSQL);
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(s.Fsum2) as Fsum2"
            		+ " into SUMTMP2"
            		+ " FROM SUMTMP4 s"
            		+ " WHERE Flsfid="+ mFlsfid
                    + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                    + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            sumtmp2 = OpenTable("s", "SUMTMP2");
            if (!sumtmp2.IsEmpty())
            {
               sumtmp2.MoveFirst();
               while (!sumtmp2.IsEOF())
               {
                  nFtabn = sumtmp2.getValue("Ftabn");
                  nFmn   = sumtmp2.getValue("Fmn");
                  nFvp   = sumtmp2.getValue("Fvp");
                  /*strSQL = "SELECT * FROM SUMTMP"
                  		+ " WHERE Ftabn="+ nFtabn
                  			+ " AND Fmn="+sqlTo(nFmn)
                  			+ " AND Fvp="+sqlTo(nFvp);
                  sumtmp = OpenTable("s", strSQL);
                  if (!sumtmp.IsEmpty())
                  {*/
                     ExecuteSQL("UPDATE SUMTMP SET S_tax="+sqlTo(sumtmp2.getValue("Fsum2"))+" WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp));
                  /*}else{
                     strSQL = "SELECT * FROM SUMTMP00"
                     		+ " WHERE Ftabn="+ nFtabn
                     			+ " AND Fmn="+sqlTo(nFmn)
                     			+ " AND Fvp="+sqlTo(nFvp);
                     sumtmp00 = OpenTable("s", strSQL);
                     if (!sumtmp00.IsEmpty() && Math.abs(sumtmp00.getValue("S_DOX")) > sum_ogr)
                     {
                        sumtmp.Edit();
                        sumtmp.setValue("S_tax",sumtmp2.getValue("Fsum2"));
                        sumtmp.setValue("Ftabn",sumtmp2.getValue("Ftabn"));
                        sumtmp.setValue("Ftabn_id",sumtmp2.getValue("Ftabn_id"));
                        sumtmp.setValue("Fmn",sumtmp2.getValue("Fmn"));
                        sumtmp.setValue("Fvp",sumtmp2.getValue("Fvp"));
                        sumtmp.Update();
                     }
                  }*/
                  sumtmp2.MoveNext();
               }
            }
            sumtmp2.close();
      }
	  tlic_fld.close();
      strSQL = "UPDATE SUMTMP SET S_razn=S_DOX-"+ sum_ogrp
      		+" WHERE Ftt=0 AND S_DOX>=0";
      ExecuteSQL(strSQL);

      strSQL = "UPDATE SUMTMP SET S_razn=S_DOX+"+ sum_ogrp
      		+ " WHERE Ftt=0 AND S_DOX<0";
      ExecuteSQL(strSQL);

      strSQL = "SELECT SUM(s.S_DOX) as S_DOX, sum(s.S_tax) as S_tax,"
      		+ " 0 as Ftabn, 0 as Ftabn_id, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp, sum(s.S_razn) as S_razn"
            + " INTO SUMTMP3 FROM SUMTMP s";
      ExecuteSQL(strSQL);
     
      strSQL = "INSERT INTO SUMTMP(S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn)"
      		+ " SELECT S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn FROM SUMTMP3";
      ExecuteSQL(strSQL);
	} // /3-й
	
   if (RasMode == "is1000zan") // 4-й
   {
      ALL_table.MoveFirst();
      var pFtabn = Number(ALL_table.getValue("Ftabn"));
      var pFtabn_id = Number(ALL_table.getValue("Ftabn_id"));
      var pFmes  = toScriptDate(ALL_table.getValue("Fmes"));
      while(!ALL_table.IsEOF())
      {
      	WAIT("Рассчит.таб.N "+pFtabn);
         while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))==pFtabn))
         {
            var ssum1   = 0;
            var mFlsfid = Number(ALL_table.getValue("Flsfid"));
            var mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            var mFvp    = Number(ALL_table.getValue("Fvp"));
            while( (!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))==pFtabn) &&
            		 (Number(ALL_table.getValue("Flsfid"))==mFlsfid) &&
            		 ((toScriptDate(ALL_table.getValue("Fmn")).getYear()==new Date(mFmn).getYear()) &&
            		  (toScriptDate(ALL_table.getValue("Fmn")).getMonth()==new Date(mFmn).getMonth()) &&
            		  (toScriptDate(ALL_table.getValue("Fmn")).getDate()==new Date(mFmn).getDate())) &&
            		  (Number(ALL_table.getValue("Fvp"))==mFvp))
           {
               var mFsum   = Number(ALL_table.getValue("Fsum"));
               var mFmf    = ALL_table.getValue("Fmf");
               var mFlsfid = Number(ALL_table.getValue("Flsfid"));
               // проверка входимости в налогооблагаемую сумму
            
               if(!lic_fld.FindFirst("FID=" + mFlsfid))
                  WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     +" Ссылка на неизвестное поле лицевого счета.\n"
                         +" Пригласите разработчиков для устранения")

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               if (lic_fld.getValue("Fis23")=='+')
               {
               		ssum1 += mFsum;
               }
               ALL_table.MoveNext();
            }
            
			ssum = ssum1;

            if (ssum!=0)
            {
            	ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               		+ " VALUES("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "+sqlTo(mFmn)+", "+mFvp
               			+", "+sqlTo(pFmes)+", "+mFlsfid+")");
            }
         } 

         if(!ALL_table.IsEOF())
         {  
            pFtabn = ALL_table.getValue("Ftabn");
            pFtabn_id = ALL_table.getValue("Ftabn_id");
            pFmes  = ALL_table.getValue("Fmes");
         }
      } // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))
      
      strSQL =  "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
      		+ " Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt, SUM(s.S_razn) as S_razn"
            + " INTO SUMTMP00 FROM SUMTMP0 s"
            + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp";
      ExecuteSQL(strSQL);
         strSQL = "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
         		+ " Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt, SUM(s.S_razn) as S_razn"
                + " INTO SUMTMP50 FROM SUMTMP00 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp";
         ExecuteSQL(strSQL);
         strSQL = "SELECT * INTO SUMTMP FROM SUMTMP50"
         		+ " WHERE ABS(S_DOX)>"+ sum_ogr;
         ExecuteSQL(strSQL);

      strSQL = "SELECT * FROM ^LIC_FLD WHERE Fis1='з' AND Fis_slct="+sqlTrue;
      tlic_fld = OpenTable("s", strSQL);
      if (!tlic_fld.IsEmpty())
      {
         mFlsfid = tlic_fld.getValue("Fid");
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(Fsum) as Fsum2"
            	+ " INTO SUMTMP4 FROM SVZP_ALL"
            	+ " WHERE Flsfid="+ mFlsfid
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            strSQL = "UPDATE SUMTMP4 SET Fmn="+sqlTo(d00obj)+", Fvp=0"
            	+ " WHERE Fvp=2 AND Fmn<Fmes";
            ExecuteSQL(strSQL);
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(s.Fsum2) as Fsum2"
            	+ " INTO SUMTMP2 FROM SUMTMP4 s"
            	+ " WHERE Flsfid="+ mFlsfid
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);

            sumtmp2 = OpenTable("s", "SUMTMP2");
            if (!sumtmp2.IsEmpty())
            {
               sumtmp2.MoveFirst();
               while (!sumtmp2.IsEOF())
               {
                  nFtabn = sumtmp2.getValue("Ftabn");
                  nFmn   = sumtmp2.getValue("Fmn");
                  nFvp   = sumtmp2.getValue("Fvp");
                  /*strSQL = "SELECT * FROM SUMTMP"
                  		+ " WHERE Ftabn="+ nFtabn
                  			+ " AND Fmn="+sqlTo(nFmn)
                  			+ " AND Fvp="+sqlTo(nFvp);
                  sumtmp = OpenTable("s", strSQL);
                  if (!sumtmp.IsEmpty())
                  {*/
                     ExecuteSQL("UPDATE SUMTMP SET S_tax="+sqlTo(sumtmp2.getValue("Fsum2"))+" WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp));
                  /*}else{
                     strSQL = "SELECT * FROM SUMTMP00"
                     		+ " WHERE Ftabn="+ nFtabn
                     			+ " AND Fmn="+sqlTo(nFmn)
                     			+ " AND Fvp="+sqlTo(nFvp);
                     sumtmp00 = OpenTable("s", strSQL);
                     if (!sumtmp00.IsEmpty() && Math.abs(sumtmp00.getValue("S_DOX"))>sum_ogr)
                     {
                        sumtmp.Edit();
                        sumtmp.setValue("S_tax",sumtmp2.getValue("Fsum2"));
                        sumtmp.setValue("Ftabn",sumtmp2.getValue("Ftabn"));
                        sumtmp.setValue("Ftabn_id",sumtmp2.getValue("Ftabn_id"));
                        sumtmp.setValue("Fmn",sumtmp2.getValue("Fmn"));
                        sumtmp.setValue("Fvp",sumtmp2.getValue("Fvp"));
                        sumtmp.Update();
                     }
                  }*/
                  sumtmp2.MoveNext();
               }
            }
            sumtmp2.close();
      }
	  tlic_fld.close();
      strSQL = "UPDATE SUMTMP SET S_razn=S_DOX-"+ sum_ogr
      		+ " WHERE Ftt=0 AND S_DOX>=0";
      ExecuteSQL(strSQL);

      strSQL = "UPDATE SUMTMP SET S_razn=S_DOX+"+ sum_ogr
      		+ " WHERE Ftt=0 AND S_DOX<0";
      ExecuteSQL(strSQL);

      strSQL = "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
      		+ " 0 as Ftabn, 0 as Ftabn_id, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp,"
      		+ " SUM(s.S_razn) as S_razn"
            + " INTO SUMTMP3 FROM SUMTMP s";
      ExecuteSQL(strSQL);
     
      strSQL = "INSERT INTO SUMTMP (S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn)"
      		+ " SELECT S_DOX, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp, S_razn"
      		+ " FROM SUMTMP3";
      ExecuteSQL(strSQL);
	} // /4-й
	
   if (RasMode == "is1000soc") //5-й
   {
      ALL_table.MoveFirst();
      var pFtabn = Number(ALL_table.getValue("Ftabn"));
      var pFtabn_id = ALL_table.getValue("Ftabn_id");
      var pFmes  = ALL_table.getValue("Fmes");
      while(!ALL_table.IsEOF())
      {
      	 WAIT("Рассчит.таб.N "+pFtabn);

         while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn")) == pFtabn))
         {
            var ssum1   = 0;
            var mFlsfid = Number(ALL_table.getValue("Flsfid"));
            var mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            var mFvp    = Number(ALL_table.getValue("Fvp"));

            while((!ALL_table.IsEOF()) &&
            	 (Number(ALL_table.getValue("Ftabn"))==pFtabn) &&
            	 (Number(ALL_table.getValue("Flsfid"))==mFlsfid) &&
            	 ((toScriptDate(ALL_table.getValue("Fmn")).getYear()== mFmn.getYear()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getMonth()== mFmn.getMonth()) &&
            	  (toScriptDate(ALL_table.getValue("Fmn")).getDate()== mFmn.getDate())) &&
            	  (Number(ALL_table.getValue("Fvp"))== mFvp))
           {
               var mFsum   = Number(ALL_table.getValue("Fsum"));
               var mFmf    = ALL_table.getValue("Fmf");
               var mFlsfid = ALL_table.getValue("Flsfid");
               // проверка входимости в налогооблагаемую сумму
            
               if(!lic_fld.FindFirst("FID=" +  mFlsfid))
                  WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     +" Ссылка на неизвестное поле лицевого счета.\n"
                         +" Пригласите разработчиков для устранения")

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               if (lic_fld.getValue("Fis17")=='+')
               {
               		ssum1 += mFsum;
               }
               ALL_table.MoveNext();
            }
            
            ssum = ssum1;

            if (ssum!=0)
            {
            	ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               		+ " VALUES("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "+sqlTo(mFmn)+", "+mFvp
               			+", "+sqlTo(pFmes)+", "+mFlsfid+")");
            }
         }

         if(!ALL_table.IsEOF())
         {
            pFtabn = ALL_table.getValue("Ftabn");
            pFtabn_id = ALL_table.getValue("Ftabn_id");
            pFmes  = ALL_table.getValue("Fmes");
         }
	 } // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))

      strSQL =  "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
      		+ " Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt, SUM(s.S_razn) as S_razn"
            + " INTO SUMTMP00 FROM SUMTMP0 s"
            + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp";
      ExecuteSQL(strSQL);
         strSQL = "SELECT SUM(s.S_DOX) as S_DOX, SUM(s.S_tax) as S_tax,"
         		+ " Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt, SUM(s.S_razn) as S_razn"
                + " INTO SUMTMP50 FROM SUMTMP00 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp";
         ExecuteSQL(strSQL);
         strSQL = "SELECT * INTO SUMTMP FROM SUMTMP50"
         		+ " WHERE ABS(S_DOX)>"+ sum_ogr;
         ExecuteSQL(strSQL);

      strSQL = "SELECT * FROM ^LIC_FLD"
      		+ " WHERE Fis8='с' AND Fis_slct="+sqlTrue;
      tlic_fld = OpenTable("s", strSQL);
      if (!tlic_fld.IsEmpty())
      {
         mFlsfid = tlic_fld.getValue("Fid");
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(Fsum) as Fsum2"
            		+ " INTO SUMTMP4 FROM SVZP_ALL"
            		+ " WHERE Flsfid="+ mFlsfid
                    + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                    + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            strSQL = "UPDATE SUMTMP4 SET Fmn="+sqlTo(d00obj)+", Fvp=0"
            		+ " WHERE Fvp=2 and Fmn<Fmes";
            ExecuteSQL(strSQL);
            strSQL = "SELECT Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes, SUM(s.Fsum2) as Fsum2"
            		+ " INTO SUMTMP2 FROM SUMTMP4 s"
            		+ " WHERE Flsfid="+ mFlsfid
                    + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp, Flsfid, Fmes"
                    + " ORDER BY Ftabn, Ftabn_id, Fmn, Fvp";
            ExecuteSQL(strSQL);
            sumtmp2 = OpenTable("s", "SUMTMP2");
            if (!sumtmp2.IsEmpty())
            {
               sumtmp2.MoveFirst();
               while (!sumtmp2.IsEOF())
               {
                  nFtabn = sumtmp2.getValue("Ftabn");
                  nFtabn_id = sumtmp2.getValue("Ftabn_id");
                  nFmn   = sumtmp2.getValue("Fmn");
                  nFvp   = sumtmp2.getValue("Fvp");
                  /*strSQL = "SELECT * FROM SUMTMP"
                  		+ " WHERE Ftabn="+ nFtabn
                  			+ " AND Fmn="+sqlTo(nFmn)
                  			+ " AND Fvp="+sqlTo(nFvp);
                  sumtmp = OpenTable("s", strSQL);
                  if (!sumtmp.IsEmpty())
                  {*/
                     ExecuteSQL("UPDATE SUMTMP SET S_tax="+sqlTo(sumtmp2.getValue("Fsum2"))+" WHERE Ftabn="+ nFtabn
                  				+ " AND Fmn="+sqlTo(nFmn)
                  				+ " AND Fvp="+sqlTo(nFvp));
                  /*}else{
                     strSQL = "SELECT * FROM SUMTMP00"
                     		+ " WHERE Ftabn="+ nFtabn
                     			+ " AND Fmn="+sqlTo(nFmn)
                     			+ " AND Fvp="+sqlTo(nFvp);
                     sumtmp00 = OpenTable("s", strSQL);
                     if (!sumtmp00.IsEmpty() && Math.abs(sumtmp00.getValue("S_DOX"))>sum_ogr)
                     {
                        sumtmp.Edit();
                        sumtmp.setValue("S_tax",sumtmp2.getValue("Fsum2"));
                        sumtmp.setValue("Ftabn",sumtmp2.getValue("Ftabn"));
                        sumtmp.setValue("Ftabn_id",sumtmp2.getValue("Ftabn_id"));
                        sumtmp.setValue("Fmn",sumtmp2.getValue("Fmn"));
                        sumtmp.setValue("Fvp",sumtmp2.getValue("Fvp"));
                        sumtmp.Update();
                     }
                  }*/
                  sumtmp2.MoveNext();
               }
            }
            sumtmp2.close();
      }
	  tlic_fld.close();
      strSQL="UPDATE SUMTMP SET S_razn=S_dox-"+ sum_ogr
      		+ " WHERE Ftt=0 AND S_dox>=0";
      ExecuteSQL(strSQL);

      strSQL="UPDATE SUMTMP SET S_razn=S_dox+"+ sum_ogr
      		+ " WHERE Ftt=0 AND S_dox<0";
      ExecuteSQL(strSQL);

      strSQL = "SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      		+ " 0 as Ftabn, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp,"
      		+ " SUM(s.S_razn) as S_razn"
            + " INTO SUMTMP3 FROM SUMTMP s";
      ExecuteSQL(strSQL);
     
      strSQL = "INSERT INTO SUMTMP(S_dox, S_tax, Ftabn, Ftt, Fmn, Fvp, S_razn)"
      		+ " SELECT S_dox, S_tax, Ftabn, Ftt, Fmn, Fvp, S_razn FROM SUMTMP3";
      ExecuteSQL(strSQL);
	} // /5-й
	
	if (RasMode == "israbpns") // 6-й
   	{
    	ALL_table.MoveFirst();
      	var pFtabn = Number(ALL_table.getValue("Ftabn"));
      	var pFtabn_id = ALL_table.getValue("Ftabn_id");
      	var pFmes  = ALL_table.getValue("Fmes");
      	while(!ALL_table.IsEOF())
      	{
      		WAIT("Рассчит.таб.N "+pFtabn);
         	while((!ALL_table.IsEOF()) && (Number(ALL_table.getValue("Ftabn"))== pFtabn))
         	{
            	var ssum1   = 0;
            	var mFlsfid = Number(ALL_table.getValue("Flsfid"));
            	var mFmn    = toScriptDate(ALL_table.getValue("Fmn"));
            	var mFvp    = Number(ALL_table.getValue("Fvp"));

            	while( (!ALL_table.IsEOF()) &&
            		(Number(ALL_table.getValue("Ftabn"))== pFtabn) &&
            	 	(Number(ALL_table.getValue("Flsfid"))== mFlsfid) &&
            	 	((toScriptDate(ALL_table.getValue("Fmn")).getYear()== mFmn.getYear()) &&
            	  	(toScriptDate(ALL_table.getValue("Fmn")).getMonth()== mFmn.getMonth()) &&
            	  	(toScriptDate(ALL_table.getValue("Fmn")).getDate()== mFmn.getDate())) &&
            	  	(Number(ALL_table.getValue("Fvp"))== mFvp))
          		{
               		var mFsum   = Number(ALL_table.getValue("Fsum"));
               		var mFmf    = ALL_table.getValue("Fmf");
               		var mFlsfid = ALL_table.getValue("Flsfid");
               // проверка входимости в налогооблагаемую сумму
            
               		if(!lic_fld.FindFirst("FID=" + mFlsfid)){
                  		WAIT("Обнаружена серьезная ошибка функционирования системы.\n" 
                     		+" Ссылка на неизвестное поле лицевого счета.\n"
                         	+" Пригласите разработчиков для устранения");}

               // пpизнак входимости в налогооблагаемую сумму опpеделяется по пеpвой
               // колонке (Fis8) файла LIC_FLD
               		if (lic_fld.getValue("Fis23")=='+')
               		{
               			ssum1 += mFsum;
               		}
               		ALL_table.MoveNext();
            	}
            	
            	ssum = ssum1;

            	pr_pensz = getSnap("SELECT * FROM ^PR_PENSZ as p inner join ^work_pers as w on p.Fwid_wp=w.Fwid "
            						+ " WHERE w.Fwid_cl="+ pFtabn_id);
            	/*
            	pr_pensz = OpenTable("s","SELECT * FROM ^PR_PENSZ pp"
            			+ " INNER JOIN svzp_all s ON s.Fwid_wp= pp.Fwid_wp"
            		+ " WHERE s.Ftabn= "+ pFtabn); */

            	if (pr_pensz && ssum!=0)
            	{
            		ExecuteSQL("INSERT INTO SUMTMP0 (Ftabn, Ftabn_id, S_dox, Fmn, Fvp, Fmes, Flsfid)"
               				+ " VALUES("+pFtabn+", "+pFtabn_id+", "+sqlTo(ssum)+", "+sqlTo(mFmn)
               				+ ", "+mFvp+", "+sqlTo(pFmes)+", "+mFlsfid+")");
            	}
         	} // end of while((!ALL_table.IsEOF()) && (ALL_table("Ftabn")==pFtabn))

         	if(!ALL_table.IsEOF())
         	{  
            	pFtabn = ALL_table.getValue("Ftabn");
            	pFtabn_id = ALL_table.getValue("Ftabn_id");
            	pFmes  = ALL_table.getValue("Fmes");
         	}
      	}  //end of while(!ALL_table.IsEOF())
		
      	ExecuteSQL("SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      			+ " Ftabn, Ftabn_id, Fmn, Fvp, 0 as Ftt"
                + " INTO SUMTMP FROM SUMTMP0 s"
                + " GROUP BY Ftabn, Ftabn_id, Fmn, Fvp");

      	ExecuteSQL("SELECT SUM(s.S_dox) as S_dox, SUM(s.S_tax) as S_tax,"
      			+ " 0 as Ftabn, 0 as Ftabn_id, 1 as Ftt, "+sqlTo(d00obj)+" as Fmn, 0 as Fvp "
                + " INTO SUMTMP3 FROM SUMTMP s");
     
      	ExecuteSQL("INSERT INTO SUMTMP(S_dox, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp)"
      			+ " SELECT S_dox, S_tax, Ftabn, Ftabn_id, Ftt, Fmn, Fvp"
      			+ " FROM SUMTMP3");
	} // /6-й
	if (RasMode.indexOf("ESV")==-1) // 6-й
   	{
		ExecuteSQL("ALTER TABLE SUMTMP ADD Fwid "+sqlType("COUNTER"));
		ExecuteSQL("ALTER TABLE SUMTMP ADD Fwid_wp "+sqlType("LONG"));
		ExecuteSQL("UPDATE SUMTMP SET Fwid_wp = (SELECT MAX(Fwid) FROM ^work_pers AS wp WHERE SUMTMP.Ftabn_id=wp.Fwid_cl AND wp.Fbdat<="+sqlTo(par.MDat)+" AND wp.Fedat>="+sqlTo(par.MDat)+")")
		ALL_table.close();
		lic_fld.close();
	}	
	return true;
}