prnPatt="protra";

function listDpGrid()
{
	include("Objects//DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	oGrid.defCond("=(^ftype1 == 1 || ^ftype1 == 3)", "main");
	oGrid.defCond("=(^ftype1 == 2)", "midle");
	oGrid.defCond("=(^ftype1 == 3)", "end");	
	oGrid.color(1, "main");
	oGrid.color(12, "midle");
	with (oGrid.page())
	{
		fieldEx("=(^ftype1 == 1 || ^ftype1 == 3) ? ^fnazv : ''","Стаття балансу|Статья бланса",30);
		fieldEx("=(^ftype1 == 1 || ^ftype1 == 3) ? ^FLINE : ''","Рядок|Строка",20, null, "%10d");
		fieldEx("=(^ftype1 == 2 || ^ftype1 == 3) ? ^fsch : ''","Рахунок|Счет",10, null, "%10d");
		fieldEx("=(^ftype1 == 2 || ^ftype1 == 3) ? ^fsub : ''","Субрахунок|Субсчет",10, null, "%10d");
		fieldEx("fact","Тип",5);
		fieldEx("=(^ftype1 == 2 || ^ftype1 == 3) ? ^fnsch : ''","Сальдо\nна початок|Сальдо\nна начало",10);
		fieldEx("=(^ftype1 == 2 || ^ftype1 == 3) ? ^fksch : ''","Сальдо\nна кiнець|Сальдо\nна конец",10);
	}
	oGrid.build();

	//Становимся на нужную строку
	if(typeof extPar != "undefined" && typeof extPar.nLine == "number")
	{
		//индекс первой строки
		var startInd = DataSource().getRowSelected();
		
		var tGridName = DataSource().getTable().getTableName();
		var ind = getSnap("SELECT COUNT(*) FROM "+tGridName+" WHERE FLINE < "+sqlTo(extPar.nLine))[0];
		
		DataSource().setRowSelected(ind+startInd);
		grid.refresh();
	}
}

function listLoad()
{
	with (this)
	{
		title = "Протокол розрахунку обігового балансу|Протокол расчета оборотного баланса";
		accDel = new Function("false");
	}
	
	if (IsTable("OT_BLN_1") && IsTable("OT_BLN_2"))
	{
		var strSQL;
		if (IsTable("PROTOK_BLN"))
			DropTable("PROTOK_BLN");
	
		strSQL = "SELECT A.FLINE AS FLINE,A.FSCH AS FSCH,A.FSUB AS FSUB,A.FACT AS FACT,2 AS FTYPE1, " +
	          	 "SUM(A.FSUM1*A.Fkoef1+A.FSUM2*A.Fkoef2+A.FSUM2*A.FKOEF3+A.FSUM1*A.FKOEF4) AS FNSCH, " +
	          	 "SUM(A.FSUM3*A.Fkoef1+A.FSUM4*A.Fkoef2+A.FSUM4*A.FKOEF3+A.FSUM3*A.FKOEF4) AS FKSCH " +
	          	 "INTO PROTOK_BLN FROM OT_BLN_1 A " +
	          	 "GROUP BY A.FLINE,A.FSCH,A.FSUB,A.FACT";
		ExecuteSQL(strSQL);
	   
		strSQL = "ALTER TABLE PROTOK_BLN ADD FNAZV " + SqlType("TEXT");
		ExecuteSQL(strSQL);
	
		strSQL = "ALTER TABLE PROTOK_BLN ADD FWID " + SqlType("COUNTER");
		ExecuteSQL(strSQL);
	
		if (SUBD == ORACLE)
			strSQL = "UPDATE PROTOK_BLN " +
					"SET FNAZV = (SELECT FNAZV FROM OT_BLN_2 " +
					"WHERE ROWNUM = 1 AND OT_BLN_2.FLINE = PROTOK_BLN.FLINE) " +
					"WHERE EXISTS (SELECT  " +
					"FNAZV FROM OT_BLN_2 " +
					"WHERE ROWNUM = 1 AND OT_BLN_2.FLINE = PROTOK_BLN.FLINE)";
		else if (SUBD == MSSQL)
			strSQL = "UPDATE PROTOK_BLN " +
					"SET FNAZV = (SELECT TOP 1 " +
					"FNAZV FROM OT_BLN_2 " +
					"WHERE OT_BLN_2.FLINE = PROTOK_BLN.FLINE) " +
					"WHERE EXISTS (SELECT TOP 1 " +
					"FNAZV FROM OT_BLN_2 " +
					"WHERE OT_BLN_2.FLINE = PROTOK_BLN.FLINE)";
		else if (SUBD == DERBY || SUBD == POSTGRE)
			strSQL = "UPDATE PROTOK_BLN " +
					"SET FNAZV = (SELECT MAX(FNAZV) FROM OT_BLN_2 " +
						"WHERE OT_BLN_2.FLINE = PROTOK_BLN.FLINE) " +
					"WHERE EXISTS (SELECT MAX(FNAZV) FROM OT_BLN_2 " +
						"WHERE OT_BLN_2.FLINE = PROTOK_BLN.FLINE)";
		else //ACCESS
			strSQL = "UPDATE OT_BLN_2 " +
					"INNER JOIN PROTOK_BLN " +
					"ON OT_BLN_2.FLINE = PROTOK_BLN.FLINE " +
					"SET PROTOK_BLN.FNAZV = OT_BLN_2.FNAZV";	
		ExecuteSQL(strSQL);
		
		strSQL = "UPDATE PROTOK_BLN " +
	    	      	"SET FTYPE1=1 WHERE FSCH=0";
		ExecuteSQL(strSQL);
	   
		strSQL = "INSERT INTO PROTOK_BLN(FNAZV,FLINE,FNSCH,FKSCH,FTYPE1) "+
	            "SELECT 'Итого по строке' AS FNAZV,A.FLINE AS FLINE,FNSAL AS FNSCH,FKSAL AS FKSCH,3 AS FTYPE1 " +
	          	"FROM OT_BLN_2 A WHERE EXISTS " +
	          	"(SELECT * FROM OT_BLN_1 B WHERE A.FLINE=B.FLINE)";
		ExecuteSQL(strSQL);   
	   
		strSQL = "INSERT INTO PROTOK_BLN(FNAZV,FLINE,FNSCH,FKSCH,FTYPE1) " +
	            "SELECT '' AS FNAZV,A.FLINE AS FLINE,FNSAL AS FNSCH,FKSAL AS FKSCH,4 AS FTYPE1 " +
	          	"FROM OT_BLN_2 A WHERE EXISTS " +
	          	"(SELECT * FROM OT_BLN_1 B WHERE A.FLINE=B.FLINE)";
		ExecuteSQL(strSQL);
	   
		strSQL = "CREATE INDEX fsline ON PROTOK_BLN(Fline,FTYPE1,Fsch,Fsub)";
		ExecuteSQL(strSQL);
	}
	else
	{
		alert(UR("Спочатку виконайте розрахунок звітного балансу." +
					"|Сначала произведите расчет отчётного баланса."), ICON_WARNING);
		return false;
	}
}

function listSrc()
{
	this.qrySet("From", "PROTOK_BLN", "Order", new Array("fline, ftype1"));
	this.subTie("OT_BLN_2","BLN_2","fline","fline", TIE_NOSEARCH);
}

include("sys\\DpList.js");