include ("Objects\\DpGetDat.js");
include ("ras_zkr.js");
include ("firstkv.js");
include ("lastkv.js");
include ("oss_dat.js");
include ("oss_datb.js");
include ("calc_os.js");
include ("izosdat.js");
include ("izosdatb.js");
include ("riznosb.js");
include ("riznosbp.js");
include ("r_balnam.js");
include ("r_am.js");
include ("servis\\date.js");
include ("koef_am.js");

var l_title;
var menuMode, gd;
var calcMode, outFile, clNom, clCod, orderFld, arrForWrap
var rTitle, uTitle
var tblName;
var oSnap;

m__codmol  = getPar("CODMOL");
m__codpod = getPar("CODPODR");
var dat1, buhuch;
//var buhuch = getPar("__BUHUCH");

/*function listAsk()
{
	//gd = new DpGetDat("d");
	//return gd;
	
}*/

function listLoad()
{
	with(this)
	{
		rTitle = "Закрепление"
		uTitle = "Закрiплення"
		calcMode = par.menuMode.substr(4)
		qryWhereArrI = -1;
		switch ( calcMode )
		{
			case "MOLALL"://режим для абсолютно всех ОС (немат. в том числе)
			case "MOL":
				xmlGridFile = "r_zkr.xml";
				printLabel = "m_zkr";
				rTitle  += " ОС за МОЛ"
				uTitle  += " ОЗ за МВО"
				clNom    = m__codmol
				clCod    = "Ftabn"
				outFile  = "MATOTV"
				orderFld = "Ftall,Ftabn,Fttabn,Ftgroup,Finv_num,Fgroup"
				arrForWrap = new Array("NOT (Fttabn<>1 and Ftall<>1)", "Ftgroup=2 and (Fttabn<>0 or Ftall<>0)" )
				tblName = "TMP_"+calcMode;
			break;
			case "MOLP":
				xmlGridFile = "r_zkrp.xml";
				printLabel = "m_zkrp";
				rTitle  += " ОС за МОЛ"
				uTitle  += " ОЗ за МВО"
				clNom    = m__codmol
				clCod    = "Ftabn"
				outFile  = "MATOTVP"
				orderFld = "Ftall,Ftabn,Fttabn,Ftgroup,Finv_num,Fgroup"
				arrForWrap = new Array("NOT (Fttabn<>1 and Ftall<>1)", "Ftgroup=2 and (Fttabn<>0 or Ftall<>0)" )
				tblName = "TMP_"+calcMode;
			break;
			case "MOLN":
				xmlGridFile = "r_zkrn.xml";
				printLabel = "mn_zkr";
				rTitle += " немат.активов за МОЛ"
				uTitle += " немат.активiв за МВО"
				clNom = m__codmol
				clCod = "Ftabn"
				outFile = "MATOTVN"
				orderFld = "Ftall,Ftabn,Fttabn,Finv_num"
				arrForWrap = new Array("NOT (Fttabn<>1 and Ftall<>1)")
				tblName = "TMP_"+calcMode;
			break;
			case "POD":
				xmlGridFile = "r_zkr_pod.xml";
				printLabel = "p_zkr";
				rTitle += " ОС за подразделениями"
				uTitle += " ОЗ за пiдроздiлами"
				clNom = m__codpod
				clCod = "Fcod_podr"
				outFile = "MATPOD"
				orderFld = "Ftall,Fcod_podr,Fttabn,Fdb_sc,Fdb_su,Fdb_st,Ftgroup,Finv_num"
				arrForWrap = new Array("NOT (Fttabn<>1 and Ftall<>1 and Ftgroup<>1)")
				tblName = "TMP_"+calcMode;
			break;
			case "PODN":
				xmlGridFile = "r_zkr_podn.xml";
				printLabel = "pn_zkr";
				rTitle += " немат.активов за подразделениями"
				uTitle += " немат.активiв за пiдроздiлами"
				clNom = m__codpod
				clCod = "Fcod_podr"
				outFile = "MATPODN"
				orderFld = "Ftall,Fcod_podr,Fttabn,Finv_num"
				arrForWrap = new Array("NOT (Fttabn<>1 and Ftall<>1)")
				tblName = "TMP_"+calcMode;
			break;
			case "VID":
				xmlGridFile = "r_zkr_vid.xml";
				printLabel = "v_zkr";
				rTitle += " ОС по видам"
				uTitle += " ОЗ по видах"
				clNom = m__codmol
				clCod = "Ftabn"
				outFile = "OS7VID"
				orderFld = "Ft0,Fcod_vid,Ft1,Finv_num"
				arrForWrap = new Array("NOT (Ft2=0 and Ft1=0 and Ft0=0)")
				tblName = "TMP_"+calcMode;
			break;
			default:
				alert("Неизвестный режим расчета")
		}
		title = uTitle+"|"+rTitle;
	}
	if(this.par.menuMode.substr(0,4)=="CALC")
	{
		var form = createForm(UR("Введіть данні для відбору інформації|Введите данные для отбора информации"));
		var D1=form.addObj("D1","date",UR("Дата початку|Дата начала"));
		D1.setValue(new Date().getVarDate());
		var buh = form.addObj("buh", "bool", UR("Ведення бух.обліку|Ведение бух.учета"));
		buh.setValue(getPar("__BUHUCH"));
		form.show();
		if(form.escape == false)
		{
			dat1 = new Date(form.D1);
			buhuch = toScrObj(form.buh);
			DropTable(tblName);
			//создадим таблицу в которую занесём дату расчёта и булевое значение б/у
			//для использования при дальнейших вызовах просмотров
			ExecuteSQL("CREATE TABLE "+tblName+" (Fdat "+sqlType("DATE")+", Fbuh "+sqlType("BIT")+")")
			ExecuteSQL("INSERT INTO "+tblName+" (Fdat, Fbuh) VALUES("+sqlTo(dat1)+","+sqlTo(buhuch)+")");
		}
		else
			return false;
	}
}

function listSrc()
{
	if(IsTable(tblName))
		oSnap = getSnap("SELECT Fdat, Fbuh FROM "+tblName);
	else
	{
		alert(ru("Сперва выполните расчёт!","Спочатку виконайте розрахунок!"));
		return false;
	}
	if( oSnap != null )
	{
		var captDat = StrDat(oSnap[0], "DMY");
		var captBuh = oSnap[1]?ru(" (бух.учет)"," (бух.облік)"):ru(" (налог.учет)"," (податк.облік)");
		list.title = uTitle+" на "+captDat+captBuh+"|"+rTitle+" на "+captDat+captBuh;
	}
	l_title=list.title;

	with( list )
	{
		qrySet("From", outFile, "Order", orderFld);
		qrySet("WhereArr", arrForWrap)
		subTie("OSNAZV", "x_osnazv", "OSNAZV", "Finv_num");
		subTie("clrelclcl","CLREL","CLCOD","="+clNom+","+clCod);
		subTie("CL","x_clm","FWID","CLREL.FWID_CL");
		if (calcMode=="VID")
			subTie("VIDOS", "x_vidos", "VIDOS", "Fcod_vid");
	}
}

function listMake()
{
	//ras_zkr(calcMode, list.objAsk.dat1);
	if(!ras_zkr(calcMode, dat1, buhuch))
		return false;
}

function getBuh()//возвращает булевое значение б/у для xml грида
{
	if(buhuch!=null)
		return buhuch;
	else
	{
		oSnap = getSnap("SELECT Fbuh FROM "+tblName);
		if(oSnap!=null)
			return oSnap[0];
	}
}
include ("sys\\DpList.js");