// передаются 
// res_mon - місяць отримання результатів

include("get_cnst.js");
include("objects/DpDefVed.js");
include("servis/format.js");
include("servis/date.js")
include("Objects/DpGetDat.js");

var sTitle = ru("Справка в налоговую инспекцию за квартал","Довідка в податкову інспекцію за квартал");
var sFieldID = "FTABN_ID";
var baseOrg;

function listLoad()
{   	
    list.title = sTitle;
    var objAsk = new DpGetDat("d");
	if(objAsk.escape)
		return false;

	var res_moni = new Date(objAsk.dat1.getYear()+1900, objAsk.dat1.getMonth(), 1);
		
   	r_raznb(res_moni);
    
    return false;
}

function r_raznb (res_mon)
{ 
  	var nPos = 1;
  	var maxPos = 25;
  	var sTxt = ru("Расчет...","Розрахунок...");
  	  
  	var DefVed = new DpDefVed();//e05.07.2006: дефектная ведомость (не фурычит)
  	var monthtxt1;
  	var _rez_dt = res_mon;
  	var schrName;
  	var VSP_table, VSP2_table, SCHR_table, VSP5_table, Shtat_table, Lic_table, RAZN_table;
  	
  	var oSnap = getSnap("SELECT Fwid FROM ^stru_org WHERE Fwid_par=0");
   	if(oSnap!=null)
   		baseOrg = oSnap[0];
   	else
   	{
   		alert(ru("Невозможно найти корневое подразделение!",
   				"Неможливо знайти корневий пірозділ!"));
   		return false;
   	}
	  
  	// достаем цифры к названию файла
  	//monthtxt1 = month_txt(res_mon);
  	monthtxt1 = format("yyyymm", res_mon);
  
  	// Проверяем существует ли у нас таблица "svzp" + monthtxt1 по шаблону "svzp"
  	tblOut = "zrp_" + "svzp" + monthtxt1;
  	if(!IsTableEx("zrp_res", tblOut))
  	{
     	alert(ru("Внимание! Перед началом данного рачета проведите\n расчет начислений за выбранный вами месяц"
     			,"Увага! Перед початком даного розрахунку проведіть\n розрахунок нарахувань за вибраний вами місяць"));
     	return false;
  	}
  	
  	//делаем проверку на коректность категорий в ШР
    include("servis/zrp.js");
    if(!isCorectKat())
    	return false;

	setProgressRange(0, maxPos);  
  	setProgressPos(nPos++, sTxt);
  	
  	DefVed.begin("", ru("Проверка различий между таблицами","Перевірка розбіжностей між таблицями"));
	
  	CreateTable("VSPZ", "VSP", "*");
  	
  	setProgressPos(nPos++, sTxt);  
  	CreateTable("VSP2", "VSP_N", "*");           
  	VSP2_table = OpenTable("s","VSP2");
  	
  	setProgressPos(nPos++, sTxt);  
  	CreateTable("VSP5", "VSP_N", "*");                          
  	VSP5_table = OpenTable("s", "VSP5");
  	
  	setProgressPos(nPos++, sTxt);  
  	schrName = "schr"+ monthtxt1;
  	CreateTable(schrName, "SCHR", "*");
  	//SCHR_table = OpenTable("s", schrName);
  
  	var DDD = d00;

  	// дата начала
  	var D1 = new Date(res_mon.getFullYear(), res_mon.getMonth(), 1);

  	// дата конца
  	//var DI2 = lastDayMonth(D1).getDate();
   	var D2 = new Date(lastDayMonth(D1));

    mdt1 = sqlTo(D1);
	mdt2 = sqlTo(D2);
	
	var DD1 = D1.getVarDate();
  	var DD2 = D2.getVarDate();
  	
  	var fis_podr = true;
  	var fis_kat = true;
  	var no_empty = false;
    var stop = false;
    var mFdoc_num = "1";
    var ssum = 0;
           			
  	for (var i=1; i<=3; i++)	// отдельные проходы по текущим, прошлым и будущим записям
  	{   	
     	setProgressPos(nPos++, sTxt);  
     	
     	//************************************************************
     	//26.03.08
     	//здесь должен сформироватьс файл VSPZ с такими же кодами подр, как и в r_razn2b. Олег это делал и проверял, так что
     	//считаем, что здесб все правильно.
     	ExecuteSQL("DELETE from VSPZ");
     	ExecuteSQL("DELETE from VSP2");   	
     	var sWhere = "";
     	if (i==1)
     	{        	
        	sWhere = " WHERE (zp.Fvp=0 OR (zp.Fvp=2 AND zp.Fmn <"+sqlTo(D1)+"))";        	
     	}
     	else if (i==2)
     	{            
            sWhere = " WHERE (zp.Fvp=2 AND zp.Fmn >"+sqlTo(D1)+")";            
       	}
       	else if (i==3)
       	{       		
            sWhere = " WHERE  (zp.Fvp=1 AND zp.Fmn <"+sqlTo(D1)+")";            
		}
		
	   	DropTable("TZWSVOD");	
		strSQL = "SELECT zp.Flsfid, zp.Ftabn_id as Ftabn, zp.Fwid_wp, zp.Fmn, zp.Fvp, zp.Fsum, zp.Fshpz"
				+ " INTO TZWSVOD FROM "
	     		+ " ^SVZP"+ monthtxt1+" zp INNER JOIN ^lic_fld lc ON zp.Flsfid= lc.Fid"
    	 		+ sWhere;
		ExecuteSQL(strSQL);
		
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_kat "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_dol "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fwid_org "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Fkod_kat "+sqlType("INT"));
		ExecuteSQL("ALTER TABLE TZWSVOD ADD Finval "+sqlType("BIT"));
		ExecuteSQL("UPDATE TZWSVOD SET Fwid_kat=0, Fwid_dol=0, "
					+" Fwid_org=0, Fkod_kat=0, Finval="+sqlFalse)

   		//20.07.07  Yana  сначала нужно найти катег.на код ШР.Если не найден, тогда на таб.N
		strSQL = "update TZWSVOD set fwid_wp=(select max(Fwid) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     +  "AND ((wp.FBDAT <= " + mdt1 + " AND wp.FEDAT >= " + mdt2 +") " 
                     + "OR (wp.FBDAT >= " + mdt1 + " AND wp.FBDAT <= " + mdt2 +") " 
                     + "OR (wp.FEDAT >= " + mdt1 + " AND wp.FEDAT <= " + mdt2 +"))  ) where (TZWSVOD.Fwid_wp=0 or TZWSVOD.Fwid_wp is null)"
		ExecuteSQL(strSQL);   				 
   			
		strSQL = "update TZWSVOD set fwid_wp=0 where Fwid_wp is null";
		ExecuteSQL(strSQL);

		strSQL = "update TZWSVOD set fwid_wp=(select max(Fwid) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn)"+
					 " where (TZWSVOD.Fwid_wp=0)"
		ExecuteSQL(strSQL);   				 
   					  	
		strSQL = "update TZWSVOD set fwid_kat=(select Fwid_kat from ^work_pers where Fwid=TZWSVOD.Fwid_wp) where Fwid_wp<>0 and EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)";
		ExecuteSQL(strSQL);   

		strSQL = "update TZWSVOD set fwid_kat=(select max(Fwid_kat) from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     + " AND wp.FBDAT <= " + mdt2 + " AND wp.FEDAT >= " + mdt1 +"  )  where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" 
		ExecuteSQL(strSQL);   				 

		ExecuteSQL("update TZWSVOD set fkod_kat=(SELECT Fcod "
			+ " FROM ^clrelclcl where TZWSVOD.Fwid_kat=Fwid_cl)")
  
		//20.07.07  Yana  сначала нужно найти код должности на код ШР.Если не найден, тогда на таб.N
   		ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT wp.Fwid_dol FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Fwid_wp = wp.Fwid)"
			+"  where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );
   
   		ExecuteSQL("UPDATE TZWSVOD SET Fwid_dol="
   			+ " (SELECT MAX(wp.Fwid_dol) FROM ^work_pers wp"
   			+ " WHERE TZWSVOD.Ftabn = wp.Fwid_cl"
			+ " AND ((wp.Fbdat <= "+mdt1+ " AND wp.Fedat >= "+mdt2+")"
            + " OR (wp.Fbdat >= "+mdt1+" AND wp.Fbdat <= "+mdt2+")"
            + " OR (wp.Fedat >= "+mdt1+" AND wp.Fedat <= "+mdt2+")))"
			+" where NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" );        	           
   
   		//20.07.07  Yana  найти код подразделения
   		strSQL = "update TZWSVOD set fwid_org=(select Fwid_org from ^stru_dol where Fwid=TZWSVOD.Fwid_dol)";
   		ExecuteSQL(strSQL);
   		
  		//14.07.07  Yana  сначала нужно найти инвал.на код ШР.Если не найден, тогда на таб.N
	   	strSQL = "update TZWSVOD set finval=(select "+First(Convert("finval", "INT"))+" from ^work_pers where Fwid=TZWSVOD.Fwid_wp) where EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)";
		ExecuteSQL(strSQL);   

   		strSQL = "update TZWSVOD set finval=(select "+First(Convert("wp.finval", "INT"))+" from ^work_pers as wp where wp.Fwid_cl=TZWSVOD.Ftabn "
                     +  "AND ((wp.FBDAT <= " + sqlTo(D1) + " AND wp.FEDAT >= " + sqlTo(D2) +") " 
                     + "OR (wp.FBDAT >= " + sqlTo(D1) + " AND wp.FBDAT <= " + sqlTo(D2) +") " 
                     + "OR (wp.FEDAT >= " + sqlTo(D1) + " AND wp.FEDAT <= " + sqlTo(D2) +"))  ) where "
                     + "NOT EXISTS( select Fwid from ^work_pers where Fwid=TZWSVOD.Fwid_wp)" 
		ExecuteSQL(strSQL);   				 

        var sSql = "INSERT INTO VSPZ(FLSFID, FMN, FSUM, FVP, FSHPZ"
        			+", FWID_WP, FKOD_KAT, FINVAL, FWID_ORG, Ftabn) "	
        			+" SELECT FLSFID, FMN, FSUM, FVP, FSHPZ, FWID_WP,fkod_kat, FINVAL, "
        			+" FWID_ORG, Ftabn from TZWSVOD";     	
		ExecuteSQL(sSql);

     	VSP_table = OpenTable("s", "select * from VSPZ order by Ftabn");     	
     	//************************************************************
     	if (!VSP_table.IsEmpty())
     	{
        	//RAZN_table = OpenTable("s","SELECT r.*, s.Fleftkey, s.Frightkey FROM ^RAZN AS r INNER JOIN ^stru_org AS s ON r.Fwid_org=s.Fwid WHERE Fdb_sc=91 and fcr_sc=65 and fcr_su=651 and Fis_tabn="+ SqlFalse);
        	RAZN_table = OpenTable("s","SELECT r.*, s.Fleftkey, s.Frightkey FROM ^RAZN AS r INNER JOIN ^stru_org AS s ON r.Fwid_org=s.Fwid WHERE Fis_tabn="+ SqlFalse);
			
			setProgressPos(nPos++, sTxt);  
        	RAZN_table.MoveFirst();
        	while (!RAZN_table.IsEOF())
        	{
           		fis_podr = true;
           		if (Number(RAZN_table.getValue("Fwid_org"))==baseOrg)
              		fis_podr = false;
           		fis_kat = true;
          		if (Number(RAZN_table.getValue("Fkod_kat"))==0)
             		fis_kat = false;
          		
          		if ((!fis_podr) && (!fis_kat)) 
          		{
             		VSP_table.index = "IVSP1";
             		if (SQL)
						VSP_table.index = "FLSFID";
          		}
          		if ((!fis_podr) && (fis_kat)) 
          		{
             		VSP_table.index = "IVSP2";
             		if (SQL)
						VSP_table.index = "FKOD_KAT,FLSFID";
          		}
          		if ((fis_podr) && (!fis_kat)) 
          		{
             		VSP_table.index = "IVSP3";
             		if (SQL)
						VSP_table.index = "FLV1,FLSFID";
          		}
          		if ((fis_podr) && (fis_kat)) 
          		{
             		VSP_table.index = "IVSP4";
             		if (SQL)
						VSP_table.index = "FLV1,FKOD_KAT,FLSFID";
         		}
  				var oVsp;
          		ssum = 0;
          		if ((!fis_podr) && (!fis_kat))
          		{              		
             		oVsp = OpenTable("s", "select * from ^VSPZ where Flsfid="+ RAZN_table.getValue("Flsfid"));
             		if(!oVsp.isEmpty())
             		{
                		while ((!oVsp.IsEOF()) && (Number(RAZN_table.getValue("Flsfid"))==Number(oVsp.getValue("Flsfid"))))
                		{
                   			var date = oVsp.getValue("Fmn"); 
                   			var monthtxt2 = new Date(date.getYear()+1900, date.getMonth()+1, 1);
                   			var monthtxt3 = DD1;
                   			ssum = Number(ssum);
                   			var nFvp = Number(oVsp.getValue("Fvp"));
                   			var nSum = Number(oVsp.getValue("Fsum"));

                   			switch(RAZN_table.getValue("Fprizn"))
                   			{
                      		case "т":
                         		ssum = ssum + (nFvp==0)? nSum : 0;
                      		case "б":
                         		ssum = ssum + ((nFvp==2) && differ(monthtxt2,monthtxt3)>0)? nSum : 0;
                      		case "п":
                         		ssum = ssum + ((nFvp==1) && differ(monthtxt2,monthtxt3)<0)? nSum : 0;
                      		default:
                        		ssum = ssum + nSum;
                   			}
                   			      
                   			oVsp.MoveNext();
                		}
//alert(Number(RAZN_table.getValue("Flsfid")))
//alert(ssum)                		
             		}  
          		}
				
          		if ((!fis_podr) && (fis_kat))
          		{
             		oVsp = OpenTable("s", "select * from ^VSPZ where Fkod_kat="+ RAZN_table.getValue("Fkod_kat") 
             												  	+" and Flsfid="+ RAZN_table.getValue("Flsfid"));
             		//if (VSP_table.FindFirst("Fkod_kat="+ RAZN_table.getValue("Fkod_kat")) 
             		// && VSP_table.FindFirst("Flsfid="+ RAZN_table.getValue("Flsfid")))
             		if(!oVsp.isEmpty())
             		{	
                		while ((!oVsp.IsEOF()) && (Number(RAZN_table.getValue("Flsfid"))==Number(oVsp.getValue("Flsfid"))) 
                				&& (Number(RAZN_table.getValue("Fkod_kat"))==Number(oVsp.getValue("Fkod_kat"))))
                		{
                   			var date = oVsp.getValue("Fmn"); 
                   			var monthtxt2 = new Date(date.getYear()+1900,date.getMonth()+1,1);
                   			var monthtxt3 = DD1;
                   			ssum = Number(ssum);
                   			var nFvp = Number(oVsp.getValue("Fvp"));
                   			var nSum = Number(oVsp.getValue("Fsum"));
                   			switch(RAZN_table.getValue("Fprizn"))
                   			{
                      		case "т":
                         		ssum = ssum + (nFvp==0)? nSum : 0;
                      		case "б":
                         		ssum = ssum + ((nFvp==2) && differ(monthtxt2,monthtxt3)>0)? nSum : 0;
                      		case "п":
                         		ssum = ssum + ((nFvp==1) && differ(monthtxt2,monthtxt3)<0)? nSum : 0;
                      		default:
                         		ssum = ssum + nSum;
                   			}      
                   			oVsp.MoveNext();
                		}
             		}
//alert(Number(RAZN_table.getValue("Fleftkey")))
//alert(Number(RAZN_table.getValue("Frightkey")))
//alert(Number(RAZN_table.getValue("Fkod_kat")))                		
//alert(Number(RAZN_table.getValue("Flsfid")))
//alert(ssum)                		
            		  
          		}
				
          		if ((fis_podr) && (!fis_kat))
          		{ 
             		//отбираем также и дочерние подразделения по отношению к подразделению из настройки
             		oVsp = OpenTable("select v.*, s.Fleftkey, s.Frightkey from ^VSPZ AS v "
             				+" INNER JOIN ^stru_org AS s ON v.Fwid_org=s.Fwid "
             				+" where Fleftkey>="+RAZN_table.getValue("Fleftkey") 
             						+" and Frightkey<="+RAZN_table.getValue("Frightkey")
             						+" and Flsfid="+ RAZN_table.getValue("Flsfid"));
             		if(!oVsp.isEmpty())
             		{
                		while ((!oVsp.IsEOF()) && (Number(RAZN_table.getValue("Flsfid"))==Number(oVsp.getValue("Flsfid")))
                				//&&(Number(RAZN_table.getValue("Fwid_org"))==Number(oVsp.getValue("Fwid_org")))
                				&& (Number(RAZN_table.getValue("Fleftkey"))<=Number(oVsp.getValue("Fleftkey")))
                				&& (Number(RAZN_table.getValue("Frightkey"))>=Number(oVsp.getValue("Frightkey")))
                				)
                		{
                   			var date = oVsp.getValue("Fmn"); 
                   			var monthtxt2 = new Date(date.getYear()+1900,date.getMonth()+1,1) 
                   			var monthtxt3 = DD1;
                   			ssum = Number(ssum);
                   			var nFvp = Number(oVsp.getValue("Fvp"));
                   			var nSum = Number(oVsp.getValue("Fsum"));
                   			switch(RAZN_table.getValue("Fprizn"))
                   			{
                      		case "т":
                         		ssum = ssum + (nFvp==0)? nSum : 0;
                      		case "б":
                       		  	ssum = ssum + ((nFvp==2) && differ(monthtxt2,monthtxt3)>0)? nSum : 0;
                      		case "п":
                         		ssum = ssum + ((nFvp==1) && differ(monthtxt2,monthtxt3)<0)? nSum : 0;
                      		default:
                         		ssum = ssum + nSum;
                   			}      
                   			oVsp.MoveNext();
                		}
//alert(Number(RAZN_table.getValue("Fleftkey")))
//alert(Number(RAZN_table.getValue("Frightkey")))                		
//alert(Number(RAZN_table.getValue("Flsfid")))
//alert(ssum)                		
             		}
          		}
				
          		if ((fis_podr) && (fis_kat))
          		{ 
             		//отбираем также и дочерние подразделения по отношению к подразделению из настройки
             		oVsp = OpenTable("select v.*, s.Fleftkey, s.Frightkey from ^VSPZ AS v "
             				+" INNER JOIN ^stru_org AS s ON v.Fwid_org=s.Fwid "
             				+" where Fleftkey>="+RAZN_table.getValue("Fleftkey") 
             						+" and Frightkey<="+RAZN_table.getValue("Frightkey")
             						+" and Fkod_kat="+ RAZN_table.getValue("Fkod_kat")
             						+" and Flsfid="+ RAZN_table.getValue("Flsfid"));
             		//oVsp = OpenTable("select * from ^VSPZ where Fwid_org="+ RAZN_table.getValue("Fwid_org") 
             		//									   +" and Fkod_kat="+ RAZN_table.getValue("Fkod_kat")
             		//										 +" and Flsfid="+ RAZN_table.getValue("Flsfid"));
             		if(!oVsp.isEmpty())
             		{
                		while ((!oVsp.IsEOF()) 
                				&& (Number(RAZN_table.getValue("Flsfid"))==Number(oVsp.getValue("Flsfid")))
                				//&& (Number(RAZN_table.getValue("Fwid_org"))==Number(oVsp.getValue("Fwid_org")))
                				&& (Number(RAZN_table.getValue("Fleftkey"))<=Number(oVsp.getValue("Fleftkey")))
                				&& (Number(RAZN_table.getValue("Frightkey"))>=Number(oVsp.getValue("Frightkey")))
                				&& (Number(RAZN_table.getValue("Fkod_kat"))==Number(oVsp.getValue("Fkod_kat"))))
                		{
                   			var date = oVsp.getValue("Fmn"); 
                   			var monthtxt2 = new Date(date.getYear()+1900,date.getMonth()+1,1) 
                   			var monthtxt3 = DD1;
                   			ssum = Number(ssum);
                   			var nFvp = Number(oVsp.getValue("Fvp"));
                   			var nSum = Number(oVsp.getValue("Fsum"));
                   			switch(RAZN_table.getValue("Fprizn"))
                   			{
                      		case "т":
                        	 	ssum = ssum + (nFvp==0)? nSum : 0;
                      		case "б":
                        	 	ssum = ssum + ((nFvp==2) && differ(monthtxt2,monthtxt3)>0)? nSum : 0;
                      		case "п":
                        	 	ssum = ssum + ((nFvp==1) && differ(monthtxt2,monthtxt3)<0)? nSum : 0;
                      		default:
                        	 	ssum = ssum + nSum;
                   			}      
                   			oVsp.MoveNext();
                		}
//alert(Number(RAZN_table.getValue("Fleftkey")))
//alert(Number(RAZN_table.getValue("Frightkey")))                		
//alert(Number(RAZN_table.getValue("Fkod_kat")))
//alert(Number(RAZN_table.getValue("Flsfid")))
//alert(ssum)                		
             		}  
          		}        		
         		
          		var nFproc = Number(RAZN_table.getValue("Fproc"));
          		if(nFproc!=0)
          			ssum = Number(ssum) * nFproc/100;
				
//alert(ssum)				
				
				var sFld = "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,Fnazv_op";	
          		var sSql = "INSERT INTO ^VSP2 ("+ sFld +",Fsum) "
          					+" SELECT "+ sFld +","+ ssum +" as Fsum "
          					+" FROM ^RAZN WHERE Fwid="+ RAZN_table.getValue("Fwid");
          		if (ssum!=0)
          		{             		            		
             		ExecuteSQL(sSql);
          		}	
          		RAZN_table.MoveNext();
        	}
        	
			setProgressPos(nPos++, sTxt);  
        	WAIT(ru("шаг 2 - свести все по корреспонденциям","крок 2 - звести усе по кореспонденціях"))

       		VSP2_table.Requery();
        	VSP2_table.index = "VSP_NI";
        	if (SQL)
				VSP2_table.index = "FDB_SC,FDB_SU,FDB_ST,FCR_SC,FCR_SU,FCR_ST";
       	 	VSP2_table.MoveFirst();
  
        	no_empty = false;
  
        	if (!VSP2_table.IsEOF())
        	{ 
           		var prew1 = VSP2_table.getValue("Fdb_sc");
           		var prew2 = VSP2_table.getValue("Fdb_su");
           		var prew6 = VSP2_table.getValue("Fdb_st");
           		var prew8 = VSP2_table.getValue("Fdb_cod1");
	            var prew10 = VSP2_table.getValue("Fdb_cod2");
           		var prew11 = VSP2_table.getValue("Fdb_cod3");
           		var prew3 = VSP2_table.getValue("Fcr_sc");
           		var prew4 = VSP2_table.getValue("Fcr_su");
           		var prew7 = VSP2_table.getValue("Fcr_st");
           		var prew9 = VSP2_table.getValue("Fcr_cod1");
	            var prew12 = VSP2_table.getValue("Fcr_cod2");
           		var prew13 = VSP2_table.getValue("Fcr_cod3");
           		var prew5 = VSP2_table.getValue("Fnazv_op");
           		ssum = Number(VSP2_table.getValue("Fsum"));
	
           		mFdoc_num = "1";
           		stop = false;
           		no_empty = true;
           		VSP2_table.MoveNext();
        	}       		
       		setProgressPos(nPos++, sTxt);  
        	if (!VSP2_table.IsEOF())
        	{           		
           		while (true)
           		{ 
            		if (VSP2_table.IsEOF() 
            			|| (prew1!=VSP2_table.getValue("Fdb_sc"))  || (prew2!=VSP2_table.getValue("Fdb_su"))
            			|| (prew6!=VSP2_table.getValue("Fdb_st"))  || (prew3!=VSP2_table.getValue("Fcr_sc")) 
            			|| (prew4!=VSP2_table.getValue("Fcr_su"))  || (prew7!=VSP2_table.getValue("Fcr_st")) 
            			|| (prew8!=VSP2_table.getValue("Fdb_cod1"))|| (prew9!=VSP2_table.getValue("Fcr_cod1"))
						|| (prew10!=VSP2_table.getValue("Fdb_cod2"))||(prew12!=VSP2_table.getValue("Fcr_cod2"))
						|| (prew11!=VSP2_table.getValue("Fdb_cod3"))||(prew13!=VSP2_table.getValue("Fcr_cod3")))
                	{
                	 	newN = true;
                 		sSql = "INSERT INTO "+ schrName
                 			+" (Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num) "
                 			+" VALUES ("+prew1+","+prew2+","+prew6+","+prew8+","+prew10+","+prew11+","+prew3+","+prew4+","+prew7+","+prew9+","+prew12+","+prew13
                 						+","+ssum+","+sqlTo(prew5)+",5,"+sqlTo(DD2)+","+sqlTo(mFdoc_num)+") ";
                 		bRes = ExecuteSQL(sSql);
                 		//if(!bRes) return false;
                 		ssum = 0;
              		}
              		else
                		newN = false;
        
              		if (stop) 
              			break;
        
              		ssum  = Number(ssum) + Number(VSP2_table.getValue("Fsum"));

              		prew1 = VSP2_table.getValue("Fdb_sc");
              		prew2 = VSP2_table.getValue("Fdb_su");
              		prew6 = VSP2_table.getValue("Fdb_st");
              		prew8 = VSP2_table.getValue("Fdb_cod1");
	            	prew10 = VSP2_table.getValue("Fdb_cod2");
           			prew11 = VSP2_table.getValue("Fdb_cod3");
              		prew3 = VSP2_table.getValue("Fcr_sc");
              		prew4 = VSP2_table.getValue("Fcr_su");
              		prew7 = VSP2_table.getValue("Fcr_st");
              		prew9 = VSP2_table.getValue("Fcr_cod1");
	            	prew12 = VSP2_table.getValue("Fcr_cod2");
           			prew13 = VSP2_table.getValue("Fcr_cod3");
              		prew5 = VSP2_table.getValue("Fnazv_op");
              		VSP2_table.MoveNext();
       
              		if (VSP2_table.IsEOF()) 
              			stop = true;
           		}
        	}
        	else if (no_empty)
        	{           		        		
           		sSql = "INSERT INTO "+ schrName 
                 			+" (Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num) "
                 			+" VALUES ("+prew1+","+prew2+","+prew6+","+prew8+","+prew10+","+prew11+","+prew3+","+prew4+","+prew7+","+prew9+","+prew12+","+prew13
                 						+","+ssum+",'"+prew5+"',5,"+sqlTo(DD2)+","+sqlTo(mFdoc_num)+") ";
        		bRes = ExecuteSQL(sSql);
        		//if(!bRes) return false;                	
        	}        	       	    		
        	RAZN_table.close();
		}		
        VSP_table.close(); 	
	}
	VSP2_table.close();
	
	setProgressPos(nPos++, sTxt);      	
  	//кусок по разноске сумм к выплате по табельным номерам
  	CreateTable("VSPTN", "VSP", "*");     
	
	setProgressPos(nPos++, sTxt);  
  	RAZN_table = OpenTable("s","SELECT * FROM ^RAZN WHERE Fis_tabn=" + SqlTrue + " ORDER BY FLSFID");  	
  	
  	while (!RAZN_table.IsEOF())
  	{
    	mFlsfid = RAZN_table.getValue("Flsfid");
     	//зачем в цикле создавать таблицу, если её можно очищать
     	//CreateTable("VSPTN", "VSP", "*");
     	ExecuteSQL("DELETE FROM VSPTN");
     	sSql = "INSERT INTO VSPTN (FSUM, FTABN, FLSFID, FFLD_NUM, FVP, FMN) "
     				+" SELECT FSUM, "+ sFieldID +", FLSFID, FFLD_NUM, FVP, FMN "
                 	+" FROM ^SVZP"+ monthtxt1 +" where Flsfid="+ sqlTo(mFlsfid); 
        bRes = ExecuteSQL(sSql);
        //if(!bRes) return false;
        	
     	var Fdb_sc = RAZN_table.getValue("Fdb_sc");
     	var Fdb_su = RAZN_table.getValue("Fdb_su");
     	var Fdb_st = RAZN_table.getValue("Fdb_st");
     	var Fcr_sc = RAZN_table.getValue("Fcr_sc");
     	var Fcr_su = RAZN_table.getValue("Fcr_su");
     	var Fcr_st = RAZN_table.getValue("Fcr_st");     	
     	var Fdbcr  = RAZN_table.getValue("Fdbcr");
     	var Fnazv_op = RAZN_table.getValue("Fnazv_op");
     	var Fdb_cod1 = (!Fdbcr? RAZN_table.getValue("Fdb_cod1") : "FTABN"); 
     	var Fcr_cod1 = (!Fdbcr? "FTABN" : RAZN_table.getValue("Fcr_cod1"));
     	
     	sSql = "INSERT INTO VSP5 "
        		+" (Fdb_sc,Fdb_su,Fdb_st,Fcr_sc,Fcr_su,Fcr_st,Fnazv_op,Fsum,Fdb_cod1,Fcr_cod1) "
        		+" SELECT "+Fdb_sc+" as Fdb_sc,"+Fdb_su+" as Fdb_su,"+Fdb_st+" as Fdb_st,"
        				   +Fcr_sc+" as Fcr_sc,"+Fcr_su+" as Fcr_su,"+Fcr_st+" as Fcr_st,"
        				   +"'"+Fnazv_op+"' as Fnazv_op, Fsum,"+ Fdb_cod1 +" as Fdb_cod1,"+Fcr_cod1+" as Fcr_cod1"        			
        		+" FROM ^VSPTN WHERE Fsum<>0";
        bRes = ExecuteSQL(sSql);
        //if(!bRes) return false;

     	RAZN_table.MoveNext();
  	}
  	RAZN_table.close();
	  	  	
  	setProgressPos(nPos++, sTxt);      	
  	VSP5_table.requery();
  	if (!VSP5_table.IsEmpty())
  	{     	
     	sSql = "INSERT INTO ^"+ schrName 
     		+" (Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num) "
     		+" SELECT Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fsum,Fnazv_op,"
     			+"5 as Fwrk,"+sqlTo(DD2)+" as Fdate,"+sqlTo(mFdoc_num)+" as Fdoc_num "
     		+" FROM ^VSP5";
     	bRes = ExecuteSQL(sSql);
        //if(!bRes) return false;        	
     	ssum = 0;
  	}
	VSP5_table.close();
	
	setProgressPos(nPos++, sTxt);      	
  	DropTable("tschr");
  	strSQL = "select Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
  				+","+First("^"+schrName+".Fnazv_op")+" as Fnazv_op, 5 as Fwrk,Fdate,Fdoc_num, sum(^"+schrName+".Fsum) as Fsum "
  			+" into tschr "
  			+" from ^"+schrName
  			+" group by Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3,Fdate,Fdoc_num"
  	bRes = ExecuteSQL(strSQL);
  	//if(!bRes) return false;

  	ExecuteSQL("DELETE from ^"+schrName);
	
	setProgressPos(maxPos, sTxt);      	
	var sFlds = "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2,Fdb_cod3,Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2,Fcr_cod3"
				+",Fsum,Fnazv_op,Fwrk,Fdate,Fdoc_num";
	ExecuteSQL("INSERT INTO ^"+ schrName +" ("+ sFlds +") SELECT "+ sFlds +" FROM ^tschr");
	
	//результат каждой разноски будем записывать в свою таблицу
	var tblName = "raznb"+monthtxt1;
	DropTable(tblName)
	ExecuteSQL("select * into "+tblName+" from schr"+monthtxt1);
  	
  	setProgressPos(0);
  	DefVed.end();  	
  	return true;
}

include("sys/DpList.js");