include("Objects/DpCl.js");

var srcTbl = "SKU_CARD_"+ getTmpTableName();
var dogID = 0;
var nOrg = 0;
var dat1;
var dat2;
var oStreet;
var oHouse;
var oNode;

function listLoad()
{
	this.printLabel = "KU_CARD";
	
	oNode = new DpCl("0");
	oNode.setClcl(getPar("CODNODE"));
	oNode.linkSmartCtrl(FNODE);
	oNode.setContAssist();
	if(extPar && extPar.node)
		oNode.setCod(extPar.node);
	if(!getPar("CODNODE"))
		GRNODE.setVisible(false);
	
	oStreet = new DpCl("0");
	oStreet.setClcl(getPar("CODSTREET"));
	oStreet.linkSmartCtrl(FSTREET);
	oStreet.setContAssist();
	if(extPar && extPar.street)
		oStreet.setFWID(extPar.street);
	
	oHouse = new DpCl("0", getPar("CODHOUSE"), 0, oStreet);
	oHouse.linkSmartCtrl(FHOUSE);
	oHouse.setContAssist();
	oHouse.addFldSearchSmart("FNOM");
	oHouse.isExactSearchSmart = true;
	oHouse.isCodeSearchSmart = false;
	if(extPar && extPar.house)
		oHouse.setFWID(extPar.house);
	
	this.oOrg = new DpCl("0", 0, 0);
	this.oOrg.linkSmartCtrl(FORG);
	this.oOrg.setContAssist();
	if(extPar && extPar.org)
		this.oOrg.setCod(extPar.org);		
	//this.oOrg.AfterLoad = loadOrg;
		
	setButton(btnCALC, recalc);
	setValid(FPERIOD, period_valid);
	changePeriod();
	
	if(extPar && extPar.dat1)
		FBDAT.value = extPar.dat1;
	if(extPar && extPar.dat2)
		FEDAT.value = extPar.dat2;		
	if(extPar && extPar.dogID)
		dogID = extPar.dogID;
}

function listSrc()
{
	this.qrySet("From", srcTbl
				, "Order", "FNUM, FDATE, FTT"
				, "Where", "FDATE<="+ sqlTo(dat2) 
						+ (differ(d00, dat1)>0? " and (FDATE>"+ sqlTo(dat1) +" or FTT='ST')" : "") 
						+" or FTT='SUM' or FTT='END'"
				);
}

function listTitle()
{
	var title = UR("Картка рахунку: |Карточка счета: ");
	if(this.oOrg.getCod())
		title += this.oOrg.getCod() +" - "+ this.oOrg.getTxt();
	else if(oNode.getCod())
		title += oNode.getCod() +" - "+ oNode.getTxt();
	else if(oStreet.getCod())
	{
		title += oStreet.getTxt()
		if(oHouse.getCod())
			title += " "+ oHouse.getTxt();
	}
	dat1 = FBDAT.value;
	dat2 = FEDAT.value;
	if(differ(d00, dat1)>0)
		title += "  за "+ StrDat(dat1, "DMY");
	if(differ(d00, dat2)>0)
		title += " - "+ StrDat(dat2, "DMY");
	return title;
}

function listDpGrid()
{
	grid.DeletePages();
	
	grid.defCond("SUM", "=^FTT=='SUM'");
	grid.color(2, "SUM");
	grid.bold("SUM");
	
	grid.defCond("BAL", "=^FTT=='ST' || ^FTT=='END'");
	grid.color(1, "BAL");
	grid.bold("BAL");
	
	with(grid)
	{
		FieldEx("=^FTT=='SUM'? '"+ UR("Разом за період|Всего за период") +"' "
				+": ^FTT=='ST'? '"+ UR("На початок|На начало") +"'" //+" ("+ format("dd.mm.yyyy", FBDAT.value) +")'"
				+": ^FTT=='END'? '"+ UR("На кінець|На конец") +"'" //+" ("+ format("dd.mm.yyyy", FEDAT.value) +")'"
				+": tmonth(^FMONTH, 1) +' '+ ^FYEAR", "Дата|Дата", 20);
		FieldEx("FSUM_BIL", "Нараховано|Начислено", 10);
		FieldEx("FSUM_SUB", "Субсидія|Субсидия", 10);
		FieldEx("FSUM_REC", "Перерахунок|Перерасчет", 10);
		FieldEx("FSUM_PAY", "Оплачено|Оплачено", 10);
		FieldEx("=balance(^FWID)", "Сальдо|Сальдо", 10);
	}
	grid.build();
}

function loadOrg()
{
	dogID = licscID();
	recalc();
}

function recalc()
{
	//list.init();
	listMake();
	list.tblInit();
}

function listAsk()
{
	var p = new Object();
	if(extPar)
		p = extPar;
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	FBDAT.value = p.idat1;
	    FEDAT.value = p.idat2;
	    oStreet.setFWID(p.istreet.getFWID());
	    oHouse.setFWID(p.ihouse.getFWID());
	    oNode.setCod(p.inode.getCod());
	    this.oOrg.setCod(p.iplat.getCod());
	}    
	return p;
}

function listMake()
{
	node = oNode.getCod();
	street = oStreet.getFWID();
	house = oHouse.getFWID();
	nOrg = list.oOrg.getCod();
	dat1 = FBDAT.value;
	dat2 = FEDAT.value;
	var tblReg = hocRegTblName();
	
	if(!ExecuteSQL("drop table "+ srcTbl, false))
		ExecuteSQL("DELETE FROM "+ srcTbl, false);
	
	var sSQL = "create table "+ srcTbl 
				+" (FORG "+ SqlType("INT")
				+", FNUM "+ SqlType("INT")				
				+", FDATE "+ SqlType("DATE")
				+", FMONTH "+ SqlType("INT")
				+", FYEAR "+ SqlType("INT")
				+", FSUM_BIL "+ SqlType("CURRENCY")
				+", FSUM_PAY "+ SqlType("CURRENCY")
				+", FSUM_SUB "+ SqlType("CURRENCY")
				+", FSUM_REC "+ SqlType("CURRENCY")
				+", FDEBT "+ SqlType("CURRENCY")
				+", FTT "+ SqlType("TEXT", 3) +" default "+ sqlEmpStr
				+", FWID "+ sqlType("COUNTER")
				+")";
	ExecuteSQL(sSQL, false);
	
	var sumBil = IIF("r.FISSKU="+ sqlTrue, "r.FSUM_SKU", 0);
	var sumPay = IIF("r.FISSKU="+ sqlFalse, "r.FSUM", 0);
	/*
	sSQL = "insert into "+ srcTbl 
				+" (FNUM, FORG, FDATE, FMONTH, FYEAR, FSUM_BIL, FSUM_SUB, FSUM_PAY)"
			+" select 1, min(r.FORG), min(r.FDATE), "+ sqlMonth("r.FDATE") +","+ sqlYear("r.FDATE") 
				+", sum("+ sumBil +"), sum(r.FSUB), sum("+ sumPay +")"
			+" from "+ tblReg +" r "
				+" inner join ^LICSC l on l.FID_DOG=r.FID_DOG"
			+" where 1=1 " 
				+(node? " and l.FNODE="+ node : "")
				+(street? " and l.FSTREET="+ street : "")
				+(house? " and l.FHOUSE="+ house : "")
				+(nOrg? " and r.FORG="+ nOrg : "")
				//+(dogID? " and l.FID_DOG="+ dogID : "")
				+(differ(d00, dat1)>0? " and r.FDATE>="+ sqlTo(dat1) : "")
				+(differ(d00, dat2)>0? " and r.FDATE<="+ sqlTo(dat2) : "")
			+" group by "+ sqlMonth("r.FDATE") +", "+ sqlYear("r.FDATE") +", r.FISRECALC"
	ExecuteSQL(sSQL);
	*/
	var sTempTbl = getTmpTableName();
	ExecuteSQL("select * into "+ sTempTbl +" from "+ srcTbl);
	
	sSQL = "insert into "+ sTempTbl 
				+" (FNUM, FORG, FDATE, FMONTH, FYEAR, FSUM_BIL, FSUM_SUB, FSUM_PAY, FSUM_REC)"
			+" select 1, min(r.FORG), min(r.FDATE), "+ sqlMonth("r.FDATE") +","+ sqlYear("r.FDATE") 
				+", sum("+ sumBil +"), sum(r.FSUB), sum("+ sumPay +"), sum(FRECALC)"
			+" from "+ tblReg +" r "
				+" inner join ^LICSC l on l.FID_DOG=r.FID_DOG"
			+" where 1=1 " 
				+(node? " and l.FNODE="+ node : "")
				+(street? " and l.FSTREET="+ street : "")
				+(house? " and l.FHOUSE="+ house : "")
				+(nOrg? " and r.FORG="+ nOrg : "")
				//+(dogID? " and l.FID_DOG="+ dogID : "")
			+" group by "+ sqlMonth("r.FDATE") +", "+ sqlYear("r.FDATE") +", r.FISRECALC"
	ExecuteSQL(sSQL);
	
	sSQL = "insert into "+ srcTbl 
			+" select * from "+ sTempTbl 
			+" where 1=1 "
				+(differ(d00, dat1)>0? " and FDATE>="+ sqlTo(dat1) : "")
				+(differ(d00, dat2)>0? " and FDATE<="+ sqlTo(dat2) : "")
	ExecuteSQL(sSQL);
	
	ExecuteSQL("update "+ srcTbl +" set FSUM_PAY=0 where FSUM_PAY is NULL");
	
	ExecuteSQL("drop table "+ srcTbl +"_ITOG", false);
	sSQL = "select sum(FSUM_BIL) as FSUM_BIL"
				+", sum(FSUM_PAY) as FSUM_PAY"
				+", sum(FSUM_SUB) as FSUM_SUB"
				+", 'SUM' as FTT"
				+", "+ (differ(d00, dat2)>0? sqlTo(dat2) : sqlD00) +" as FDATE"
				+", 2 as FNUM"
			+" into "+ srcTbl +"_ITOG "
			+" from "+ sTempTbl
			+" where 1=1 "
			+(differ(d00, dat1)>0? " and FDATE>="+ sqlTo(dat1) : "")
			+(differ(d00, dat2)>0? " and FDATE<="+ sqlTo(dat2) : "")
	ExecuteSQL(sSQL);
	
	if(differ(d00, dat1)>0)
	{
		sSQL = "insert into "+ srcTbl +"_ITOG (FNUM, FSUM_BIL, FSUM_PAY, FSUM_SUB, FTT, FDATE)"
				+" select 0, sum(FSUM_BIL) as FSUM_BIL"
					+", sum(FSUM_PAY) as FSUM_PAY"
					+", sum(FSUM_SUB) as FSUM_SUB"
					+", 'ST' as FTT"
					+", "+ sqlTo(dat1) +" as FDATE"
				+" from "+ sTempTbl
				+" where FDATE<"+ sqlTo(dat1)
		ExecuteSQL(sSQL);
	}
	
	if(differ(d00, dat2)>0)
	{
		sSQL = "insert into "+ srcTbl +"_ITOG (FNUM, FSUM_BIL, FSUM_PAY, FSUM_SUB, FTT, FDATE)"
				+" select 3, sum(FSUM_BIL) as FSUM_BIL"
					+", sum(FSUM_PAY) as FSUM_PAY"
					+", sum(FSUM_SUB) as FSUM_SUB"
					+", 'END' as FTT"
					+", "+ sqlTo(dat2) +" as FDATE"
				+" from "+ sTempTbl
				+" where FDATE<="+ sqlTo(dat2)
		ExecuteSQL(sSQL);
	}
	
	sSQL = "insert into "+ srcTbl +" (FNUM, FTT, FDATE, FORG, FSUM_BIL, FSUM_PAY, FSUM_SUB)"
			+" select FNUM, FTT, FDATE, "+ nOrg +", FSUM_BIL, FSUM_PAY, FSUM_SUB"
			+" from "+ srcTbl +"_ITOG "
	ExecuteSQL(sSQL);		
}

function sumDebt(date)
{
	if(!date)
		date = new Date();
	var oSnap = getSnap("select sum(FSUM_BIL-FSUM_PAY)"
						+" from "+ srcTbl
						+" where FDATE<="+ sqlTo(date)
							+" and FTT="+ sqlEmpStr
						, false
						);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0]);
	return 0;
}

function balance(fid)
{
	var oSnap = getSnap("select sum(FSUM_BIL-FSUM_PAY)"
						+" from "+ srcTbl
						+" where FWID="+ sqlTo(fid)
						, false
						);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0]);
	return 0;
}

function period_valid()
{
	changePeriod();
	recalc();
}

function changePeriod()
{
	sType = String(FPERIOD.value).trim().toUpperCase();
	switch (sType)
	{
		case "TD":
			FBDAT.value = today.getVarDate();
			FEDAT.value = today.getVarDate();
			break;
		case "YTD":
			FBDAT.value = goDay(today, -1);
			FEDAT.value = goDay(today, -1);
			break;
		case "TW":
			FBDAT.value = goDay(today, -today.getDay());
			FEDAT.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			FBDAT.value = firstDayMonth(today);
			FEDAT.value = lastDayMonth(today);
			break;
		case "LM":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -1));
			FEDAT.value = lastDayMonth(today);
			break;
		case "3M":
			FBDAT.value = firstDayMonth(_dateTrans(today, "M+", -2));
			FEDAT.value = lastDayMonth(today);
			break;		
		case "TY":
			FBDAT.value = jan01(today);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			FBDAT.value = jan01(bdat);
			FEDAT.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			FBDAT.value = d00;
			FEDAT.value = d00;
			break;
		default:
			break;
	}
}

function listOnPrnList(tv)
{
	tv.eval.addVar("TITLE", this.subTitle());
	tv.eval.addVar("ORG", this.oOrg.getCod());	
	tv.eval.addVar("ADDR", getAddr());
	tv.eval.addVar("PERS", persCount());
}

function licscID()
{
	dogID = 0;
	var oSnap = getSnap("select FWID from ^CONTRACT where FORG="+ nOrg);
	if(oSnap)
		dogID = oSnap[0];
	return dogID;
}

function persCount()
{
	if(!dogID)
	{
		dogID = licscID();
		if(!dogID)
			return "";
	}
	
	var oSnap = getSnap("select count(*) "
						+" from ^SC_MEN "
						+" where FID_DOG="+ dogID
							+" and FBDAT<="+ sqlTo(today) 
							+" and FEDAT>="+ sqlTo(today)
						, false
					);
	if(oSnap && Number(oSnap[0]))
		return oSnap[0];
	return "";
}

function getAddr()
{
	var dogID = licscID();
	if(dogID)
		return getAddrByDog(dogID);
	else
		return "";
}

function hocRegTblName()
{		
	var jID = getPar("HOCPAYREG");	
	var sPath = getPath("UJ");
	var sTblName = sPath +".UJ_KU";	
	if(jID!=null && jID!="")
		sTblName = sPath +".UJ_"+ jID;		
	return sTblName;
}

include("sys/DpList.js");