include("Objects\\DpGetDat.js");
include("doc\\DpDocPtn.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\DpSql.js");
include("sub\\mtr.js");
include("GetParam.js");

var ds,t;
var tblOut = "";

function listLoad()
{
	with( list )
	{
        title = "Строки с пустой ссылкой на первый приход";
		subAsk = askParam;
		subMake = tbl_refresh;
		printLabel = "sver6";
	}
}

function listSrc()
{
    with (list)
    {
        title = "Строки с пустой ссылкой на первый приход"+
		    StrDat(objAsk.dat1, "DMY")+"-"+StrDat(objAsk.dat2, "DMY")
   	}

   	with( list )
	{
		qrySet( "From", tblOut, "Ptn", "SVER6" )
	}
}

function listGrid()
{	
	var gr = new DpGrid("NOCREATE");
	with(gr.page())
	{
		fieldEx("fnmkl","Номенклатура",15);
		fieldEx("fdoc","Документ",3);
		fieldEx("fnop","Операция",3);
		fieldEx("fdoc_num","№",6);
		fieldEx("fdoc_dat","Дата",7);
	}
	with(gr.page())
	{
		fieldEx("fnmkl","Номенклатура",15);
		fieldEx("frtype","Тип строки",7);
		fieldEx("fid_pn","Первый приход",7);
		fieldEx("fid_pn0","Первый приход(NK для VR)",7);
		fieldEx("fcena","Цена",7, "", DP_FORMAT_PRI);
		fieldEx("fpodr","Подр.",5);
		fieldEx("fmol","МОЛ",5);
		fieldEx("fsc","Счет",5);
		fieldEx("fsu","Субсчет",6);
		fieldEx("fst","Статья",5);
		fieldEx("fpost","Поставщик",7);
		fieldEx("fis_otl","Отлож. расц.",3);
	}
	gr.build();
}

function askParam()
{
	var gd = new DpGetDat(new Array("r"));
	
	tblOut = "tmp_bad_docs_no_FID_PN"
    DropTable(tblOut);
    if (IsTable(tblOut))
    {
    	alert(ru("Невозможно выполнить расчет."
				+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 		+"\nили перезапустите систему.",
		 		 "Неможливо виконати розрахунок."
		 		+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
		 		+"\nабо перезапустіть систему."));
		gd.escape = true;
	    return gd;
    }
	return gd;
}

function tbl_refresh()
{
	with( list.objAsk )
	{
		tblOut = "tmp_bad_docs_no_FID_PN"
		strSQL = "SELECT b.fdoc_dat, b.fdoc, b.fnop, b.fdoc_num, a.fwid, a.fid_doc " 
			+ " ,a.fnmkl,a.fis_otl,a.fcena,a.fpodr,a.fmol,a.fsc,a.fsu,a.fst,a.fpost,'' as fid_pn "
			+ " ,a.fid_pn0,a.f1cena, a.fcenapr, a.frtype " 
			+ " into " + tblOut + " from (^anltk a left join ^sch_zag b on a.fid_doc=b.fwid) left join ^anltk a1 on a.fid_pn=a1.fwid" 
			+ " WHERE (a.fid_pn is null or a.fid_pn = 0 or a1.fwid is null) and a.fdate>="+sqlTo(dat1)+" and a.fdate <="+sqlTo(dat2)
			+ " order by a.fnmkl, b.fdoc_dat, b.fdoc, b.fnop, b.fdoc_num";			
		ExecuteSQL(strSQL);
	}
}

function listMenuInit()
{
	if(!list.tbl.IsEmpty())
	{
		grid.AddMenuItem("FINDDOC","Найти документ");
		grid.AddMenuItem("VED_DV", "Відомість руху|Ведомость движения" );
		if(list.tbl.getValue("Fdoc")=="VR")
			grid.AddMenuItem("REPAIR_VR","Подобрать первый приход (для Возврата от покупателя)");
		if((list.tbl.getValue("Fdoc")=="SM" || list.tbl.getValue("Fdoc")=="VM") && list.tbl.getValue("frtype")=="8")
			grid.AddMenuItem("REPAIR_SM_VM","Подобрать первый приход (через выбор учетной цены)");
		if(list.tbl.getValue("Fdoc")=="SA" || list.tbl.getValue("Fdoc")=="NK")
			grid.AddMenuItem("REPAIR_NK","Подобрать первый приход (через выбор учетной цены для NK/SA)");
	}
}

function listMenuRun(ID)
{
	var ppar;
	switch(ID)
	{
	case "DIFSUM":
		alert("NOT IMPLEMENTED");
		break;
	case "PROV":
		alert("NOT IMPLEMENTED");
		break;
	case "NAKL":
		alert("NOT IMPLEMENTED");
		break;
	case "DIFDATA":
		alert("NOT IMPLEMENTED");
		break;
	case "FINDDOC":
        var doc = String(list.tbl.getValue("Fdoc"));
        var nop = Number(list.tbl.getValue("Fnop"));
        var fid = Number(list.tbl.getValue("Fid_doc"));
        FindDocument(doc, nop, fid);
		break;
	default:
		break;
	}
} 
include("sys\\DpList.js");