include("Objects\\DpGetDat.js");
include("doc\\DpDocPtn.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\DpSql.js");
include("sub\\mtr.js");
include("GetParam.js");

var ds,t;
var tblOut = "";

function listLoad()
{
	with( list )
	{
        title = "Проверка на правильность парных строк в двустрочечных накладных ПО КОЛ-ВУ";
		subAsk = askParam;
		subMake = tbl_refresh;
		printLabel = "sver6";
	}
}

function listSrc()
{
    with (list)
    {
        title = "Проверка на правильность парных строк в двустрочечных накладных ПО КОЛ-ВУ"+
		    StrDat(objAsk.dat1, "DMY")+"-"+StrDat(objAsk.dat2, "DMY")
   	}

   	with( list )
	{
		qrySet( "From", tblOut, "Ptn", "SVER6" )
	}
}

function listGrid()
{	
	var gr = new DpGrid("NOCREATE");
   	with(gr.page())
   	{
		fieldEx("FRTYPE_PMP","Кол-во по приходу",7, "", DP_FORMAT_KOL);
		fieldEx("FRTYPE_PMR","Кол-во по расходу",7, "", DP_FORMAT_KOL);
		fieldEx("fdoc","Документ",3);
		fieldEx("fdoc","№ операции",3);
		fieldEx("fdoc_dat","Дата",7);
		fieldEx("fwid","FWID док-та",9);
		
	}
	gr.build();
}

function askParam()
{
	var gd = new DpGetDat(new Array("r"));
	
	tblOut = "tmp_bad_docs_dual";
    DropTable(tblOut);
    if (IsTable(tblOut))
    {
    	alert(ru("Невозможно выполнить расчет."
				+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 		+"\nили перезапустите систему.",
		 		 "Неможливо виконати розрахунок."
		 		+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
		 		+"\nабо перезапустіть систему."));
		gd.escape = true;
	    return gd;
    }
	return gd;
}

function tbl_refresh()
{
	with( list.objAsk )
	{
		tblOut = "tmp_bad_docs_dual";
		DropTable(tblOut);
		var strSQL;
		strSQL = "SELECT b.fwid , b.fdoc, b.fnop, b.fdoc_dat, sum("+IIF("frtype="+sqlTo(RTYPE_PMP), "a.fkol", "0") + ") as FRTYPE_PMP, "
				+ " sum("+IIF("frtype="+sqlTo(RTYPE_PMR), "a.fkol", "0") + ") as FRTYPE_PMR "
				+ " into " + tblOut 
					+ " from ^anltk a left join ^sch_zag b on a.fid_doc=b.fwid " 
					+ " WHERE a.fdate>="+sqlTo(dat1)+" and a.fdate <="+sqlTo(dat2)
					+ " group by b.fwid, b.fdoc, b.fnop, b.fdoc_dat "
					+ " HAVING sum("+IIF("frtype="+sqlTo(RTYPE_PMP), "a.fkol", "0") + ") <> "
						+ " sum("+IIF("frtype="+sqlTo(RTYPE_PMR), "a.fkol", "0") + ")"
					;
		ExecuteSQL(strSQL);
			
	}
}

function listMenuInit()
{
	if(!list.tbl.IsEmpty())
	{
		if(list.tbl.getValue("Fdoc")!='' && list.tbl.getValue("Fdoc")!=null)
			list.dataSrc.AddMenuItem("FIND_DOC", "Найти документ");
	}
}

function listMenuRun(ID)
{
	var ppar;
	switch(ID)
	{
	case "FIND_DOC":
        var doc = String(list.tbl.getValue("Fdoc"));
        var nop = Number(list.tbl.getValue("Fnop"));
        var fid = Number(list.tbl.getValue("Fwid"));
        FindDocument(doc, nop, fid);
		break;
	default:
		break;
	}
}


include("sys\\DpList.js");