include("objects\\DpGetDat.js");
include("get_cnst.js");

var tbl_SVLS, dgd;
var szTag;
var dateBegin;
var dateEnd;
var sWhere, sFrom;

function listLoad()
{
	with(this)
	{
		title = ru("Своды по отраб.времени","Зведення по вiдпрац.часу");
		xmlGridFile = "r_svzptm.xml";
		htmlPrnList = "SVZPTM";
		par.menuMode = "CALC";
	}
	if(extPar)
	{
		sWhere = extPar.sWhere;
		sFrom = extPar.sFrom;
	}
	if(extPar)
	{
		dateBegin = extPar.fdat;
		dateEnd = lastDayMonth(dateBegin);
	    szTag = getDateTag(extPar.fdat);
		tbl_SVLS = "SVLS"+szTag;
	}
	else
	{
		dgd = new DpGetDat("d");
		if(dgd.escape == true)
		{
			return false;
		}
		dateBegin = dgd.dat1;
		dateEnd = lastDayMonth(dateBegin);
	    szTag = getDateTag(dgd.dat1);
		tbl_SVLS = "SVLS"+szTag;
	}		
}

/*function listAsk()
{
	dgd = new DpGetDat("d");
	if(dgd.escape == true)
	{
		return false;
	}
	dateBegin = dgd.dat1;
}*/

function listSrc()
{
	with(list)
	{
		qrySet("From","SVTM","Order","Ftt,Ffld_num");
		subTie("LIC_FLD", "lic", "Fid", "Flsfid");	
	}	
}

function listMenuInit(obj)
{
	with(obj)
	{
	    obj.AddMenuItem("LEKV", ru("Просмотр расчета отр.врем.штат.сотр.","Перегляд розр.вiдпр.часу штат.спiвр."));
    	obj.AddMenuItem("LKVS", ru("Просмотр расчета отр.врем.внешн.совм.","Перегляд розр.вiдпр.часу зовн.сумiсн."));
	    obj.AddMenuItem("LEKVO", ru("Просмотр расчета отп.штат.сотр.","Перегляд розр.вiдп.штат.спiвр."));
    	obj.AddMenuItem("LKVSO", ru("Просмотр расчета отп.внешн.совм.","Перегляд розр.вiдп.зовн.сумiсн."));
		//AddMenuItem("DISCHARGE",ru("Выгрузка инф.","Вивантаження інф."));
   		//AddMenuItem("SVODLS", 	ru("Выборка по полям ЛС","Вибірка по полях ОР"));
	    AddMenuItem("", "");
	}	
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "LEKV":
    		showWindow("l_tmro.js", SW_NOMODAL);		
			break;
		case "LKVS":
    		showWindow("l_tmrs.js", SW_NOMODAL);		
			break;
		case "LEKVO":
    		showWindow("l_tmoo.js", SW_NOMODAL);		
			break;
		case "LKVSO":
    		showWindow("l_tmos.js", SW_NOMODAL);		
			break;
		case "DISCHARGE":
			var nameTable = "svzpls__"+iOrg;
  			DropTable(nameTable);
			CreateTable(nameTable,"SVZPLS","*");
			var t2 = OpenTable("s","SELECT Fobl FROM ^CL_SVBAL WHERE Frn=" + iOrg);
			var iObl = (t2.IsEmpty())? 0 : t2("fobl");
			ExecuteSQL("INSERT INTO "+nameTable+"(FDATKV,FFLD_NUM,FLSFID,FMN,FSUM,FVP,FTT," +
			"FRN,FOBL,FBDAT, FEDAT) " +
	          " SELECT FDATKV,FFLD_NUM,FLSFID,FMN,FSUM,FVP,FTT," +
    	      sqlTo(iOrg) + " AS FRN," + iObl + " AS FOBL," +
        	  sqlTo(dateBegin) + " AS FBDAT, " + sqlTo(dateEnd) + " AS FEDAT" +
	          " FROM "+tbl_SVLS);
			break;
		case "SVODLS":
			   with(list)
			   {
		       		if(extPar)
		       			par.fdat   = extPar.fdat;
		       		else
		       			par.fdat   = dgd.dat1;
		       		par.flsfid = this.tbl.getValue("Flsfid");
		       		par.flsnum = this.tbl.getValue("Ffld_num");
		       	}
		       showWindow("r_svodls.js",SW_NOMODAL,list.par);
			break;
	}
}

function listMake()
{
//	if(extPar.fdat == null) 
//		return false;
//	else
	{
		var vrem_otbl = get_cnst("tmblot", dateBegin)
		
	    var fis_dnkl = false;
	    if(get_cnst("rdnotls", dateBegin)!=0 && get_cnst("rdnotls", dateBegin)!=null){   
		   fis_dnkl = true;	   
	    }
		
  
		DropTable("SVZPTMP");
		DropTable("SVTM");
		DropTable("SVTM2");
		lic_fld = OpenTable("s", "LIC_FLD", "LIC_FID");  
		var SVZPFILE = "SVZP" + szTag;
		if (!IsTableEx("ZRP_RES", "ZRP_"+SVZPFILE))
			CreateTableEx("ZRP_RES","ZRP_"+SVZPFILE,"SVZP","*");

		ExecuteSQL("SELECT P.* INTO SVZPTMP FROM ^"+SVZPFILE+" AS P "
   				+ (sFrom!=null?sFrom:"")
   				+ " WHERE NOT (Fvp=1 and Fmn>="+sqlTo(dateBegin)+") "
				+ (sWhere!=null?sWhere:""));
   
		ExecuteSQL("DELETE FROM SVZPTMP WHERE '+'<>"
   				+ " (SELECT l.Fis6 FROM ^LIC_FLD l WHERE l.Fid= SVZPTMP.Flsfid)");              

   		//если сумма отнимается, то и время перебить на отрицательное
	    ExecuteSQL("update SVZPTMP set Fday=-Fday where Fsum<0 and Fday<>0 ") 
   		ExecuteSQL("update SVZPTMP set Fchas=-Fchas where Fsum<0 and Fchas<>0 ")
		if (fis_dnkl == true){
		    ExecuteSQL("update SVZPTMP set Fdnkl=-Fdnkl where Fsum<0 and Fdnkl<>0 ")			
		}   		
   				
		var oSnap;
		// чел.часы отработанные штатными работниками   
   		DropTable("VSHTS1")
   		/*
   		ExecuteSQL("select Ftabn_id,Fsum,Fday,Fchas into VSHTS1 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                        + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
   					+ " )")
   					*/ 
   		ExecuteSQL("select Ftabn_id, Fwid_wp, Fsum,Fday,Fchas into VSHTS1 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=1) "
   					)
   	    ExecuteSQL("ALTER TABLE VSHTS1 ADD COLUMN FWID " + SqlType("COUNTER")); 			
   		//если не проставлены часы, то умножим не продолжительность рабочего дня, иначе в общую
   		//сумму часов эти дни не попадут
   		ExecuteSQL("update VSHTS1 set Fchas=Fday*"+sqlTo(vrem_otbl)+" where Fchas=0 and Fday<>0")
   					
		oSnap = getSnap("SELECT SUM(Fsum),SUM(Fday),SUM(Fchas) FROM VSHTS1");
		if(oSnap!=null)
		{
			ssum = oSnap[0];
			sdn  = oSnap[1];
			sch  = oSnap[2];
		}
		else
		{
			ssum = 0;
			sdn  = 0;
			sch  = 0;
		}						   

		// чел.часы отработанные внешними совм.
   		DropTable("VSHTS2")
   		/*
		ExecuteSQL("SELECT Ftabn_id,Fsum,Fday,Fchas into VSHTS2 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
					+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
					+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
  					+ " AND EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and not Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "+
                       "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+"))) and Ftable=2 and "+
                       "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+"))"
   					+ " )");   							
		*/
		ExecuteSQL("SELECT Ftabn_id,Fsum,Fday,Fchas into VSHTS2 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
					+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
					+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
					+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=2) " 
					+ " AND NOT EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                    + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
   					+ " )"	);
   					    							
   	    ExecuteSQL("ALTER TABLE VSHTS2 ADD COLUMN FWID " + SqlType("COUNTER"));		
		oSnap = getSnap("SELECT SUM(Fsum),SUM(Fday),SUM(Fchas) FROM VSHTS2");   					
		if(oSnap!=null)
		{
			ssums = oSnap[0];
			sdns  = oSnap[1];
			schs  = oSnap[2];
		}
		else
		{
			ssums = 0;
			sdns  = 0;
			schs  = 0;
		}
   		
		// чел.часы для штатными работниками по неявкам
		//29.04.10 нужно вставить оператор Шкредова по отсечению совместителей

		//добавляем предварительный выбор рабочих дней из приказов на отпуск
		ssumn1 = 0;
		sdnn1  = 0;
		schn1  = 0;
		 		
		DropTable("RABOTP")
		/* 
		var strSQL = "select Fsum,Fday,Fchas,Ftabn_id,Fid_prk,Fvid_prk into RABOTP from SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о' "
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                        + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
	                + ")"                       
   					+ " )";
        ExecuteSQL(strSQL);  					 
   					*/ 
		if (fis_dnkl == false){		
			ExecuteSQL("select Fwid_wp,Fsum,Fday,Fchas,Ftabn_id,Fid_prk,Fvid_prk into RABOTP FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о')"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=1)") 
                           						
			ExecuteSQL("ALTER TABLE RABOTP ADD COLUMN FWID " + SqlType("COUNTER"));
			//смотрим, есть ли в лицевых счетах фиды приказов, если есть, то ищем приказ на отпуск по фиду, если нет, то сложнее 
			var os = getSnap("select Fid_prk from RABOTP where Fid_prk<>0")
			if (os==null){
				//если нет фидов приказов ненулевых, значит, старый вариант расчета, когда фиды еще не прописывались. Значит, пробуем найти
				//приказы на отпуск с помощью видов приказов и табельных номеров, что может не дать правильный результат, если на одного
				//человека есть несколько записей в приказе. Поэтому, нужно брать уникальный табельный номер и суммировать на него все дни из приказа
				DropTable("DRABOTP")
				DropTable("DRABOTP2")
				DropTable("DRABOTPS")
				//отбираем людей по виду приказа на отпуск        	        	
				ExecuteSQL("select distinct Ftabn_id, Fvid_prk, 0 as Fday, 0 as Fchas into DRABOTP from RABOTP group by Fvid_prk")
				//находим рабочие дни по виду приказа
				ExecuteSQL("update DRABOTP set Fday=(select sum(Fproc) as Fday from ^PRK_ALL where Ftabn_id=DRABOTP.Ftabn_id and Fvid_prk=DRABOTP.Fvid_prk and Fin_table='PRK_O' and Fbdat<="+sqlTo(dateBegin)+" and Fedat>="+sqlTo(dateBegin)+")" )
				ExecuteSQL("update DRABOTP set Fday=0 where Fday is null")
				//находим рабочие дни по табельному номеру (если один человек в нескольких приказах)	        
				ExecuteSQL("SELECT Ftabn_id, sum(s.Fday) as Fday, sum(s.Fchas) as Fchas into DRABOTP2 FROM DRABOTP s group by s.Ftabn_id")
			
				//находим сумму отпуска и рабочие дни по табельному номеру 				        
				ExecuteSQL("SELECT SUM(s.Fsum) as Fsum, Ftabn_id, sum(s.Fday) as Fday, sum(s.Fchas) as Fchas into DRABOTPS FROM RABOTP s group by s.Ftabn_id")
				ExecuteSQL("update DRABOTPS set Fday=(select Fday from DRABOTP2 where Ftabn_id=DRABOTPS.Ftabn_id)")
				//если делается перерасчет по отпуску в меньшую сторону. то дни нужно проставить с минусом
				ExecuteSQL("update DRABOTPS set Fday=-Fday where Fsum<0")
							        
				oSnap = getSnap("SELECT sum(Fsum),SUM(Fday),SUM(Fchas) FROM DRABOTPS")
				if(oSnap!=null)
				{
					ssumn1 = oSnap[0];
					sdnn1  = oSnap[1];
					schn1  = oSnap[2];
				}
			}else{
				ExecuteSQL("update RABOTP set Fday=0, Fchas=0")        
				ExecuteSQL("update RABOTP set Fday=(select Fproc from ^PRK_ALL where Ftabn_id=RABOTP.Ftabn_id and Fwid=RABOTP.Fid_prk and Fin_table='PRK_O')")
				ExecuteSQL("update RABOTP set Fday=0 where Fday is null")
				//если делается перерасчет по отпуску в меньшую сторону. то дни нужно проставить с минусом
				ExecuteSQL("update RABOTP set Fday=-Fday where Fsum<0")
	                    						
				oSnap = getSnap("SELECT SUM(Fsum),SUM(Fday),SUM(Fchas) FROM RABOTP")
				if(oSnap!=null)
				{
					ssumn1 = oSnap[0];
					sdnn1  = oSnap[1];
					schn1  = oSnap[2];
				}
			}
		}else{
			//когда рабочие дни прописываются в лицевых счетах
			ExecuteSQL("select Fwid_wp,Fsum,Fday,Fchas,Ftabn_id,Fdnkl into RABOTP FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о')"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=s.Ftabn_id and Fwid=s.Fwid_wp and Fkod_uv<>2 and Ftable=1)") 
                           						
			//ExecuteSQL("ALTER TABLE RABOTP ADD COLUMN FWID " + SqlType("COUNTER"));
			ExecuteSQL("update RABOTP set Fday=0 where Fday is null")						
			ExecuteSQL("update RABOTP set Fdnkl=0 where Fday is null")						
			ExecuteSQL("update RABOTP set Fday=-Fday where Fsum<0")
			ExecuteSQL("update RABOTP set Fdnkl=-Fdnkl where Fsum<0")
			
			//находим сумму отпуска и рабочие дни по табельному номеру
			oSnap = getSnap("SELECT SUM(Fsum),SUM(Fdnkl),SUM(Fday),SUM(Fchas) FROM RABOTP")			
			if(oSnap!=null)
			{
				ssumn1 = oSnap[0];
				sdnn1  = oSnap[1];
				schn1  = oSnap[3];
			}
			
		}
		//рабочие дни отпусков для совместителей
		DropTable("RABOTSV")
		/* 
		var strSQL = "select Fsum,Fday,Fchas,Ftabn_id,Fid_prk,Fvid_prk into RABOTSV from SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о' "
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
  						+ " AND EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and not Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "+
                       "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+"))) and Ftable=2 and "+
                       "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+"))"
   					+ " ))";
        ExecuteSQL(strSQL);   					 
   					*/
		if (fis_dnkl == false){		
			ExecuteSQL("SELECT Fsum,Fday,Fchas,Ftabn_id,Fid_prk,Fvid_prk,Fwid_wp into RABOTSV FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о')"
					+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
					+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
					+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=2)"
					+ " AND NOT EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                    + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
   					+ " )"	);   							
         
			//смотрим, есть ли в лицевых счетах фиды приказов, если есть, то ищем приказ на отпуск по фиду, если нет, то сложнее 
			var osS = getSnap("select Fid_prk from RABOTSV where Fid_prk<>0")
			if (osS==null){
				//если нет фидов приказов ненулевых, значит, старый вариант расчета, когда фиды еще не прописывались. Значит, пробуем найти
				//приказы на отпуск с помощью видов приказов и табельных номеров, что может не дать правильный результат, если на одного
				//человека есть несколько записей в приказе. Поэтому, нужно брать уникальный табельный номер и суммировать на него все дни из приказа
				DropTable("DRABOTS")
				DropTable("DRABOT2S")
				DropTable("DRABOTSS")
				//отбираем людей по виду приказа на отпуск        	        	
				ExecuteSQL("select distinct Ftabn_id, Fvid_prk, 0 as Fday, 0 as Fchas into DRABOTS from RABOTSV group by Fvid_prk,Ftabn_id")
				//находим рабочие дни по виду приказа
				ExecuteSQL("update DRABOTS set Fday=(select sum(Fproc) as Fday from ^PRK_ALL where Ftabn_id=DRABOTS.Ftabn_id and Fvid_prk=DRABOTS.Fvid_prk and Fin_table='PRK_O' and Fbdat<="+sqlTo(dateBegin)+" and Fedat>="+sqlTo(dateBegin)+")" )
				ExecuteSQL("update DRABOTS set Fday=0 where Fday is null")
				//находим рабочие дни по табельному номеру (если один человек в нескольких приказах)	        
				ExecuteSQL("SELECT Ftabn_id, sum(s.Fday) as Fday, sum(s.Fchas) as Fchas into DRABOT2S FROM DRABOTS s group by s.Ftabn_id")
			
				//находим сумму отпуска и рабочие дни по табельному номеру 				        
				ExecuteSQL("SELECT SUM(s.Fsum) as Fsum, Ftabn_id, sum(s.Fday) as Fday, sum(s.Fchas) as Fchas into DRABOTSS FROM RABOTSV s group by s.Ftabn_id")
				ExecuteSQL("update DRABOTSS set Fday=(select Fday from DRABOT2S where Ftabn_id=DRABOTSS.Ftabn_id)")
				//если делается перерасчет по отпуску в меньшую сторону. то дни нужно проставить с минусом
				ExecuteSQL("update DRABOTSS set Fday=-Fday where Fsum<0")
				        
				oSnap = getSnap("SELECT sum(Fsum),SUM(Fday),SUM(Fchas) FROM DRABOTSS")
				if(oSnap!=null)
				{
					ssumn1S = oSnap[0];
					sdnn1S  = oSnap[1];
					schn1S  = oSnap[2];
				}
			}else{
				ExecuteSQL("update RABOTSV set Fday=0, Fchas=0")        
				ExecuteSQL("update RABOTSV set Fday=(select Fproc from ^PRK_ALL where Ftabn_id=RABOTSV.Ftabn_id and Fwid=RABOTSV.Fid_prk and Fin_table='PRK_O')")
				ExecuteSQL("update RABOTSV set Fday=0 where Fday is null")
				ExecuteSQL("update RABOTSV set Fday=-Fday where Fsum<0")	                    						
				oSnap = getSnap("SELECT SUM(Fsum),SUM(Fday),SUM(Fchas) FROM RABOTSV")
				if(oSnap!=null)
				{
					ssumn1S = oSnap[0];
					sdnn1S  = oSnap[1];
					schn1S  = oSnap[2];
				}
			}
		}else{
			ExecuteSQL("SELECT Fsum,Fday,Fchas,Ftabn_id,Fwid_wp,Fdnkl into RABOTSV FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='о')"
					+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
					+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
					+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=s.Ftabn_id and Fwid=s.Fwid_wp and Fkod_uv<>2 and Ftable=2)"
					+ " AND NOT EXISTS(SELECT distinct Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=s.Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                    + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
   					+ " )"	);   							
			ExecuteSQL("update RABOTSV set Fday=0 where Fday is null")
			ExecuteSQL("update RABOTSV set Fdnkl=0 where Fday is null")			
			ExecuteSQL("update RABOTSV set Fday=-Fday where Fsum<0")			
			ExecuteSQL("update RABOTSV set Fdnkl=-Fdnkl where Fsum<0")
			oSnap = getSnap("SELECT SUM(Fsum),SUM(Fdnkl),SUM(Fday),SUM(Fchas) FROM RABOTSV")
			if(oSnap!=null)
			{
				ssumn1S = oSnap[0];
				sdnn1S  = oSnap[1];
				schn1S  = oSnap[3];
			}
		}

		//гособязанности и подобное
   		oSnap = getSnap("select Ftabn_id, Fwid_wp, Fsum,Fday,Fchas FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE (l.Ffzp='н')"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=1 )" 
   					);                           						
		if(oSnap!=null)
		{
			ssumn2 = oSnap[2];
			sdnn2  = oSnap[3];
			schn2  = oSnap[4];
		}
		else
		{
			ssumn2 = 0;
			sdnn2  = 0;
			schn2  = 0;
		}
		
		
		// чел.часы для штатными работниками по неявкам = отпускные+гособязанности
		ssumn = ssumn1+ssumn2;
		sdnn  = sdnn1+sdnn2;
		schn  = schn1+schn2;
   
		// чел.часы для штатными работниками по больничным
   		DropTable("VSHTS4")
   		ExecuteSQL("select Ftabn_id, Fwid_wp, Fsum,Fday,Fchas,Fmn,Fvp into VSHTS4 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='b') OR (l.Ffzp='б') OR (l.Ffzp='f'))"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						//+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1)"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=1)"						
   					)
		oSnap = getSnap("SELECT SUM(Fsum) as Fsum, SUM(Fday) as Fday, SUM(Fchas) as Fchas"
   					+ " FROM VSHTS4" );   						

		if(oSnap!=null)
		{
			ssumb = oSnap[0];
			sdnb  = oSnap[1];
			schb  = oSnap[2];
		}
		else
		{ 
			ssumb = 0;
			sdnb  = 0;
			schb  = 0;
		}		    

		oSnap = getSnap("SELECT SUM(Fsum) as Fsum, SUM(Fday) as Fday, SUM(Fchas) as Fchas"
   					+ " FROM VSHTS4 where Fvp=0" );   						

		if(oSnap!=null)
		{
			ssumbtk = oSnap[0];
			sdnbtk  = oSnap[1];
			schbtk  = oSnap[2];
		}
		else
		{ 
			ssumbtk = 0;
			sdnbtk  = 0;
			schbtk  = 0;
		}		    
		//отработано женщинами штатниками
   		DropTable("VSHTS5")
   		ExecuteSQL("select Ftabn_id, Fwid_wp, Fsum,Fday,Fchas into VSHTS5 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=1 )"
   						+ " AND EXISTS (SELECT h.Fsex FROM ^cl_homo h"
	   					+ " WHERE h.Fwid_cl=s.Ftabn_id and h.Fsex= "+sqlFalse+")"   						   					
   					)
   					
		oSnap = getSnap("SELECT SUM(Fsum) as Fsum, SUM(Fday) as Fday, SUM(Fchas) as Fchas"
   					+ " FROM VSHTS5" );   						

		if(oSnap!=null)
   		{ 
			ssumgt = oSnap[0];
			sdngt  = oSnap[1];
			schgt  = oSnap[2];
   		}
   		else
   		{
   			ssumgt = 0;
   			sdngt  = 0;
   			schgt  = 0;   			
		}
		//отработано женщинами совместителями
   		DropTable("VSHTS6")
   		ExecuteSQL("select Ftabn_id, Fwid_wp, Fsum,Fday,Fchas into VSHTS6 FROM SVZPTMP s INNER JOIN ^LIC_FLD l ON l.Fid= s.Flsfid"
   					+ " WHERE ((l.Ffzp='+') OR (l.Ffzp='к'))"
   						+ " AND NOT(s.Fvp=2 AND s.Fmn>"+sqlTo(dateBegin)+")"
   						+ " AND NOT(s.Fvp=1 AND s.Fmn<"+sqlTo(dateBegin)+")"
						+ " AND s.Fwid_wp = (SELECT distinct Fwid from ^work_pers where Fwid_cl=Ftabn_id and Fwid=Fwid_wp and Fkod_uv<>2 and Ftable=2 )"
   						+ " AND EXISTS (SELECT h.Fsex FROM ^cl_homo h"
	   					+ " WHERE h.Fwid_cl=s.Ftabn_id and h.Fsex= "+sqlFalse+")"
					+ " AND NOT EXISTS(SELECT distinct w.Fwid_cl from ^work_pers as w where w.Fwid_cl=s.Ftabn_id and w.Fwid_cl in (select Fwid_cl from ^work_pers where Fwid_cl=Ftabn_id and (Fkod_uv=0 or Fkod_uv is null) and Ftable=1 and "
                    + "((fbdat<="+sqlTo(dateBegin)+" and fedat>="+sqlTo(dateEnd)+") or (fbdat>="+sqlTo(dateBegin)+" and fbdat<="+sqlTo(dateEnd)+") or (fedat>="+sqlTo(dateBegin)+" and fedat<="+sqlTo(dateEnd)+")))"
   					+ " )"                    
   					)

		oSnap = getSnap("SELECT SUM(Fsum) as Fsum, SUM(Fday) as Fday, SUM(Fchas) as Fchas"
   					+ " FROM VSHTS6" );   						
   		if(oSnap!=null)
   		{ 
   			ssumgs = oSnap[0];
   			sdngs  = oSnap[1];
   			schgs  = oSnap[2];   			
   		}
   		else
   		{
   			 ssumgs = 0;
   			 sdngs  = 0;
   			 schgs  = 0;
		 }
                                
		DropTable("SVZPTM2");
		
		ExecuteSQL("SELECT s.*, 0 AS Fdayn, 0 AS Fchasn, 0 AS Fdnkln INTO SVZPTM2 FROM SVZPTMP s");
		if (fis_dnkl == false){
			ExecuteSQL("UPDATE SVZPTM2 set Fdayn=Fday, Fchasn=Fchas");
		
			ExecuteSQL("DELETE FROM SVZPTM2 WHERE '+'<>"
   				+ " (SELECT l.Fis6 FROM ^LIC_FLD l WHERE l.Fid= SVZPTM2.Flsfid)");
   				
			ExecuteSQL("UPDATE SVZPTM2 SET "
   				+ " Fdayn=Fdayn*(-1),"
//	   			+ "(SELECT Fdayn FROM SVZPTM2"
// 				+ " WHERE (Fvp=1 AND Fmn<"+sqlTo(dateBegin)+" AND Fsum<0)),"
   				+ " Fchasn=Fchasn*(-1)"
   				+ " WHERE (Fvp=1 AND Fmn<"+sqlTo(dateBegin)+" AND Fsum<0)");
   				
			ExecuteSQL("SELECT SUM(s2.Fsum) as Fsum,"
			+ " SUM(s2.Fdayn) as Fday,"
			+ " SUM(s2.Fchasn) as Fchas,"
			+ " Flsfid, Ffld_num, Fis_day, 0 as Ftt"
			+ " INTO SVTM FROM SVZPTM2 s2 WHERE Fis_day<>2"
			+ " GROUP BY Flsfid, Ffld_num, Fis_day ORDER BY Ffld_num");
			
			ExecuteSQL("SELECT SUM(s2.Fsum) as Fsum,"
   			+ " SUM(s2.Fdayn) as Fday,"
   			+ " SUM(s2.Fchasn) as Fchas,"
   			+ " 999 AS Flsfid,"
   			+ " 0 AS Ffld_num,"
   			+ " 0 AS Fis_day,"
   			+ " 1 AS Ftt"
   			+ " INTO SVTM2 FROM SVZPTM2 s2 WHERE Fis_day<>2 and Fis_day<>3");
   			
			ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   			+ " SELECT Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt FROM SVTM2");
		}else{
			ExecuteSQL("UPDATE SVZPTM2 set Fdayn=Fday, Fchasn=Fchas, Fdnkln=Fdnkl");
			
			ExecuteSQL("DELETE FROM SVZPTM2 WHERE '+'<>"
   				+ " (SELECT l.Fis6 FROM ^LIC_FLD l WHERE l.Fid= SVZPTM2.Flsfid)");
   				
			ExecuteSQL("UPDATE SVZPTM2 SET "
   				+ " Fdayn=Fdayn*(-1),"
   				+ " Fdnkln=Fdnkln*(-1),"   				
//	   			+ "(SELECT Fdayn FROM SVZPTM2"
// 				+ " WHERE (Fvp=1 AND Fmn<"+sqlTo(dateBegin)+" AND Fsum<0)),"
   				+ " Fchasn=Fchasn*(-1)"
   				+ " WHERE (Fvp=1 AND Fmn<"+sqlTo(dateBegin)+" AND Fsum<0)");
   				
			ExecuteSQL("SELECT SUM(s2.Fsum) as Fsum,"
			+ " SUM(s2.Fdayn) as Fday,"
			+ " SUM(s2.Fdnkln) as Fdnkl,"			
			+ " SUM(s2.Fchasn) as Fchas,"
			+ " Flsfid, Ffld_num, Fis_day, 0 as Ftt"
			+ " INTO SVTM FROM SVZPTM2 s2 WHERE Fis_day<>2"
			+ " GROUP BY Flsfid, Ffld_num, Fis_day ORDER BY Ffld_num");
			
			ExecuteSQL("SELECT SUM(s2.Fsum) as Fsum,"
		   	+ " SUM(s2.Fdayn) as Fday,"					
   			+ " SUM(s2.Fdnkln) as Fdnkl,"
   			+ " SUM(s2.Fchasn) as Fchas,"
   			+ " 999 AS Flsfid,"
   			+ " 0 AS Ffld_num,"
   			+ " 0 AS Fis_day,"
   			+ " 1 AS Ftt"
   			+ " INTO SVTM2 FROM SVZPTM2 s2 WHERE Fis_day<>2 and Fis_day<>3");
   			
			ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Fdnkl, Flsfid, Ffld_num, Fis_day, Ftt)"
   			+ " SELECT Fsum, Fday, Fchas, Fdnkl, Flsfid, Ffld_num, Fis_day, Ftt FROM SVTM2");
		}
		
		if (vrem_otbl!=0)
		{
			schn = round(sdnn*vrem_otbl,2)+schn
			schb = round(sdnb*vrem_otbl,2)+schb
			//schn1S = round(sdnn1S*vrem_otbl,2)+schn1S
			schbtk = round(sdnbtk*vrem_otbl,2)+schbtk
		}

		//сумма отраб.чел.час.(все-совм. - т.к. # в fis1 идет и для совм. и для труд.согл.
		//то берем общую сумму с труд.согл.и отним.суммы по #
		//05.05.10
		//sum1 = ssum - ssums;
		//sdn1 = sdn - sdns; 
		//sch1 = sch - schs;
		// принцип отбора штатных сотрудников привели в соответствие с процедурой r_fot, смотрим по таблице подоходного налога=1 и признак
		// исключения из штатных сотрудников=0   
		sum1 = ssum;		   
		sdn1 = sdn; 
		sch1 = sch;   

		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+(sum1)+", "+(sdn1)+", "+(sch1)+", 999, 0, 0, 3)");   

		//чел.час. за кот начисл.ЗП
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+(sum1+ssumn)+", "+(sdn1+sdnn)+", "+(sch1+schn)
	   				+ ", 999, 0, 0, 4)");   				

		//Фонд раб.времени (всего)
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+(sum1+ssumn+ssumb)+", "+(sdn1+sdnn+sdnb)+", "+(sch1+schn+schb)
	   				+ ", 999, 0, 0, 5)");   

		//чел.час. по отпускным и гособяз.
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssumn+", "+sdnn+", "+schn+", 999, 0, 0, 6)");   				   

		//чел.час. по больничным
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssumb+", "+sdnb+", "+schb+", 999, 0, 0, 7)");

		//чел.час. отраб.по женщинам
		//05.05.10
		//ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   		//		+ " VALUES ("+(ssumgt-ssumgs)+", "+(sdngt-sdngs)+", "+(schgt-schgs)
	   	//			+ ", 999, 0, 0, 8)");
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+(ssumgt)+", "+(sdngt)+", "+(schgt)
	   				+ ", 999, 0, 0, 8)");
   				
		//чел.час. отраб.по женщинам совм.
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssumgs+", "+sdngs+", "+schgs+", 999, 0, 0, 15)");

		//кол-во людей по отпускным
		tbl = OpenTable("SELECT count(*)  FROM RABOTP group by ftabn_id");
		
		var koln = tbl.recordCount;
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+koln+", 0, 0, 999, 0, 0, 16)");
	
		//кол-во людей по больничным
		tbl = OpenTable("SELECT count(*)  FROM VSHTS4 group by ftabn_id")
		var kolb = tbl.recordCount;
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+kolb+", 0, 0, 999, 0, 0, 17)");

   		//количество часов отаботанных совместителей		
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssums+", "+sdns+", "+schs+", 999, 0, 0, 18)");   				   
   				
   		//количество часов отпускных совместителей		
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssumn1S+", "+sdnn1S+", "+schn1S+", 999, 0, 0, 19)");   				   

		//чел.час. по больничным за текущий месяц
		ExecuteSQL("INSERT INTO SVTM (Fsum, Fday, Fchas, Flsfid, Ffld_num, Fis_day, Ftt)"
   				+ " VALUES ("+ssumbtk+", "+sdnbtk+", "+schbtk+", 999, 0, 0, 20)");
   				
   		ExecuteSQL("update SVTM set Fday=0 where Fday is null")
   		ExecuteSQL("update SVTM set Fchas=0 where Fchas is null")
   		ExecuteSQL("update SVTM set Fsum=0 where Fsum is null")   		   				
	}
}

function xmlFieldPost(lctxt)
{
	var str = "";
	switch(Number(list.tbl.getValue("Ftt")))
	{
		case 0: str = lctxt; break;
		case 1: str = ru("Всего по организации","Всього по організації"); break;
		case 3: str = "Отр.ч/часов штатн."; break;
		case 4: str = "Ч/час.нач.ЗП для штат."; break;
		case 5: str = "Фонд раб.вр.штат."; break;
		case 6: str = "отп.(раб.вр.)+гос.об.штат."; break;
		case 7: str = "Ч/ч-больн.штат."; break;
		case 8: str = "Ч/ч-женщ.штат."; break;
		case 15:str = "Ч/ч-женщ совм."; break;
		case 16:str = "Людей в отп.штат."; break;
		case 17:str = "Людей на больн.штат."; break;
		case 18:str = "Отр.ч/часов совм."; break;
		case 19:str = "отп.совм."; break;
		case 20:str = "Ч/ч-больн.штат.за тек.мес."; break;
		default: str = ""; break
	}
	return str; 
}

include("sys\\DpList.js");