﻿include("Objects\\DpGetDat.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\dbase.js");
include("sub\\mtr.js");

var label	= "VBPZ";
var tblOut	= getTmpTableName("", true);
var useExt4OutSc = true;
var mFisavto;

function listLoad()
{
	//debug("listLoad");
	dsSaveFormat(false);
	this.title = UR("Вибірка по списанню|Выборка по списанию");
	with (list)
	{
		//subPageAgrHead = ttlGridRowPrefix;
		printLabel = label;
		//onChangeSQL		= doExTie;
	}
	with (list.objTotal)
   {
    	init(label)
	}

	DataSource().addAccel(GA_CTRL, "D", "CTRL-D");

	return true;
}

function listSrc()
{
   with( list )
   {
		qrySet("From", tblOut, "Ptn", label);
	}
	
/*	//AV
	this.subTie("clrelclcl", "CLREL" + "AV", "CLCOD", "=" + sqlTo(9) + ",FAVTO", null, TIE_NOSEARCH);
	this.subTie("cl", "AV", "FWID", "CLREL" + "AV" + ".FWID_CL", null, TIE_NOSEARCH);
	//AP
	this.subTie("clrelclcl", "CLREL" + "AP", "CLCOD", "=" + sqlTo(sprPodr) + ",FAVTOPARK", null, TIE_NOSEARCH);
	this.subTie("cl", "AP", "FWID", "CLREL" + "AP" + ".FWID_CL", null, TIE_NOSEARCH);
*/

	addTtlTbl();
	addPnTbl();
	
	this.subTie("clrelclcl","CLRELA1","CLCOD","ST.FCL1,FCL_COD1");
	this.subTie("cl","A1","FWID","CLRELA1.FWID_CL");
	
	this.subTie("clrelclcl","CLRELA2","CLCOD","ST.FCL1,FCL_COD2");
	this.subTie("cl","A2","FWID","CLRELA2.FWID_CL");
	
	this.subTie("clrelclcl","CLRELA3","CLCOD","ST.FCL3,FCL_COD3");
	this.subTie("cl","A3","FWID","CLRELA3.FWID_CL");

	this.subTie("clrelclcl","CLRELA11","CLCOD","=Number(^ST1.FCL1),FCL2_COD1");
	this.subTie("cl","A11","FWID","CLRELA11.FWID_CL");
	
	this.subTie("clrelclcl","CLRELA21","CLCOD","=Number(^ST1.FCL2),FCL2_COD2");
	this.subTie("cl","A21","FWID","CLRELA21.FWID_CL");
	
	this.subTie("clrelclcl","CLRELA31","CLCOD","=Number(^ST1.FCL3),FCL2_COD3");
	this.subTie("cl","A31","FWID","CLRELA31.FWID_CL");
	//this.clTie("A11", ",FCL2_COD1");

   grid.setSQLQueryCount(true);
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix();
	//oGrid.setFixColCount(4);
	var itogGrp = oPrefix.group()
	var nazv_group = itogGrp.cell("=^Fnmkl?^NM.Fcod +': '  + ^NM.Ftxts:''", "Номенклатура", sizeNmk);		
	list.GroupPage(oGrid, itogGrp, 0, false, nazv_group);
	with (oGrid)
	{
		with(page())
		{
			//cell(mexpr,"Назва|Наименование",19,"w");
			//
			cell("fcena","Облікова ціна|Учетная цена",10,null,DP_FORMAT_PRI);
			cell("fkol","Кількість|Количество",10,null,DP_FORMAT_KOL);
			cell("fsumrs","Сума|Сумма.",10,null,DP_FORMAT_SUM);
			if (mFisavto)
			{
				with (group("Авто"))
				{
					cell("FAVTO", "Код",6);
					cell("AV.FTXT", "Назва|Название",12)
				}
				with (group("Автопарк"))
				{
					cell("FAVTOPARK", "Код",6);
					cell("AP.FTXT", "Назва|Название",12)
				}
			}
		}

		with(page())
		{
			cell("NM.FCOD","Номенкл.|Номенкл.",10);
			cell("Fdate","Дата\nперед.|Дата\nперед.",6);
			//cell("fcena","Облікова ціна|Учетная цена",10,null,DP_FORMAT_PRI);
			with (group("Звідки|Откуда"))
			{
				cell("Fpodr","Підр|Подр",6);
				cell("Fmol","МВО|МОЛ",6);
				cell("Fsc","Рах|Сч",3);
				cell("Fsu","С/р|С/с",3);
				cell("Fst","Ст|Ст",3);
			}
			with (group("Куди|Куда"))
			{
				cell("Fsc1","Рах|Сч",3);
				cell("Fsu1","С/р|С/с",3);
				cell("Fst1","Ст|Ст",3);
				cell("Fcl2_cod1","Ан.1|Ан.1",6);
				cell("Fcl2_cod2","Ан.2|Ан.2",6);
				cell("Fcl2_cod3","Ан.3|Ан.3",6);
			}
			//cell("fkol","Кіль-ть|Кол-во",9,null,DP_FORMAT_KOL);
			cell("Fdoc_num","№ док.",5);
		}
	}
	//(new DpPnExt()).Load2Grid(oGrid, list.tbl);
	oGrid.build();

	//return true;
}

function listAsk()
{
	var gd, arrVariants
	arrVariants = list.getVariantsArr()
	gd = new DpGetDat(new Array("b","r","N0","p0","m0","su0","SU0","tdnop0"),arrVariants);
   DropTable(tblOut);
	if(IsTable(tblOut))
	{
		alert(ru("Невозможно выполнить расчет."
				+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 		+"\nили перезапустите систему.",
		 		 "Неможливо виконати розрахунок."
		 		+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
		 		+"\nабо перезапустіть систему."));
		gd.escape = true;
	}	
	return gd;
}

function listMake()
{
	var strSql1,mwhere;
	with( list.objAsk )
	{
		// для Перлыны для PZ 70 списание на авто добавим колонку авто
		// пока не нужно
		mFisavto = false;//(fdoc == "PZ" && fnop == 70);

		mwhere = "( A.Fdate between "+sqlTo(dat1)+" and "+sqlTo(dat2)+")"
			+" and (A.Frtype in ("+sqlTo(RTYPE_RS)+")) "
			+ sqlw0And("A.Fpodr=", fpodr)
			+ sqlw0And("A.Fmol=", fmol)
			+ sqlw0And("A.Fsc=", toScrObj(fsc))
			+ sqlw0And("A.Fsu=", toScrObj(fsu))
			+ sqlw0And("S.Fdoc=", String(fdoc))
			+ sqlw0And("S.Fnop=", Number(fnop))
			+ sqlw0And("A.Fnmkl=", fnmk)

		CreateTable(tblOut, label, "fwid");
		
		//Если используем расширение то идем через ж.
//alert("fldGroupKey\n"+fldGroupKey)
//alert("fldDocHR\n"+fldDocHR)
		if (useExt4OutSc)
		{
			strSql1="SELECT "
					+ fldGroupKey
					+ "," + fldDocHR
					+ ",A.Fdate as Fdate"
					//+ ",S.FDOC_DAT as FDOC_DAT"
					+ ",A.Fkol"
					+",A.Fcenapr"
					+",S.Fpodr1"
					+",S.Fmol1"
					//всегда сравниваем со счетом
					+","+IIF("A.FSC1<>0","A.FSC1","S.Fsc")+" as Fsc1"
					+","+IIF("A.FSC1<>0","A.FSU1","S.Fsu")+" as Fsu1"
					+","+IIF("A.FSC1<>0","A.FST1","S.Fst")+" as Fst1"
					+","+IIF("A.FSC1<>0","A.FCOD1","S.FCL_COD1")+" as FCL2_COD1"
					+","+IIF("A.FSC1<>0","A.FCOD2","S.FCL_COD2")+" as FCL2_COD2"
					+","+IIF("A.FSC1<>0","A.FCOD3","S.FCL_COD3")+" as FCL2_COD3"
					+ ", A.Fkol*A.Fcena as Fsumrs"
					+ ", S.Fdoc_num "
					//+", A.FWID  AS FWID_R "
					+(mFisavto ? ", E.FINT AS FAVTO"
						+", TZ.FPODR AS FAVTOPARK": "")
				 + " from "
					+" ^ANLTK AS A "
					+" , ^SCH_ZAG AS S "
					+(mFisavto ? ", ^EXT E"
						+", ^CL_TZ TZ"
						+", ^CLRELCLCL REL": "")
				+ " where "
					+" A.Fid_doc=S.Fwid and "+mwhere
					+(mFisavto ? " AND E.FMAINWID = A.FWID"
						+" AND REL.FWID_CL = TZ.FWID_CL"
						+" AND REL.FCL = 9"
						+" AND REL.FCOD = E.FINT": "")

			strSQL = "INSERT INTO " + tblOut
					+"(fnmkl, fis_otl, fcena, fpodr, fmol, fsc, fsu, fst, fpost, fid_pn, fwid_r, fwid_h, fdoc, fnop, fdate"
					+", fkol, fcenapr, fpodr1, fmol1, fsc1, fsu1, fst1, fcl2_cod1, fcl2_cod2, fcl2_cod3, fsumrs, fdoc_num"
					+(mFisavto ? ", FAVTO"
						+", FAVTOPARK": "")
					+")"
					+strSql1;
			ExecuteSQL(strSQL);
			
			//Удаляем все данные которые нам не подходят
			if (!isEmpty(toScrObj(fscto)) || !isEmpty(toScrObj(fsuto)))
			{
				strSQL = " DELETE FROM "+tblOut
					+" WHERE NOT (1=1"
							+sqlw0And("Fsc1=", toScrObj(fscto))
							+ sqlw0And("Fsu1=", toScrObj(fsuto))
						+")"
				alert(strSQL)
				ExecuteSQL(strSQL)
			}
		}
		else
		{
			//Расширение не используем счет куда берем прямо из заголовка.
			mwhere	+= sqlw0And("S.Fsc=", fscto)
						+ sqlw0And("S.Fsu=", fsuto)
			strSql1="SELECT "
						+ fldGroupKey
						+ "," + fldDocHR
						+ ",A.Fdate as Fdate"
						//+ ",S.FDOC_DAT as FDOC_DAT"
						+ ",A.Fkol,A.Fcenapr,S.Fpodr1,S.Fmol1,S.Fsc as Fsc1,S.Fsu as Fsu1"
				        + ",S.Fst as Fst1, S.FCL_COD1 as FCL2_COD1, S.FCL_COD2 as FCL2_COD2, S.FCL_COD3 as FCL2_COD3"
						+ ",A.Fkol*A.Fcena as Fsumrs"
						+ ",S.Fdoc_num "
				 + " from "
					+" ^ANLTK AS A "
					+" , ^SCH_ZAG AS S "
				+ " where "
					+" A.Fid_doc=S.Fwid and "+mwhere
			ExecuteSQL("INSERT INTO " + tblOut 
						+"(fnmkl, fis_otl, fcena, fpodr, fmol, fsc, fsu, fst, fpost, fid_pn, fwid_r, fwid_h, fdoc, fnop, fdate"
						+", fkol, fcenapr, fpodr1, fmol1, fsc1, fsu1, fst1, fcl2_cod1, fcl2_cod2, fcl2_cod3, fsumrs, fdoc_num"
						+")"
							+ " " + strSql1);

		}
	}
	//	alert(strSql1)
	//ExecuteSQL("ALTER TABLE ["+tblOut+"] ADD COLUMN FDOC_DAT DATETIME")


	//return true;
}

function listMenuInit()
{
	if(list.tbl.getValue("fwid_h") && list.tbl.getValue("Fdoc"))
		DataSource().AddMenuItem("CTRL-D", "Поиск документа");

	//return true;
}

function listMenuRun(cID)
{
	switch(cID)
	{
	case "CTRL-D":					//поиск документа по проводке
		include("doc\\DpDocPtn.js");
		FindDocument(list.tbl.getValue("Fdoc"), list.tbl.getValue("Fnop"), list.tbl.getValue("Fwid_h"));
		break;
	}

	//return true;
}

function listOnPrnList(tv)
{
	var h = new Object();
	h.FD1  = list.objAsk.dat1;
	h.FD2  = list.objAsk.dat2;
	h.FNMKL = list.objAsk.fnmk;
//from
	h.FPODR = list.objAsk.fpodr;
	h.FMOL = list.objAsk.fmol;
	h.FSC = list.objAsk.fsc;
	h.FSU = list.objAsk.fsu;

	h.FSCTO = list.objAsk.fscto;
	h.FSUTO = list.objAsk.fsuto;

	h.FORG = list.objAsk.forg;
	h.FVAL = list.objAsk.fval;
	tv.setHTbl(h);

	return true;
}

include ("sys\\DpList.js");