include("Objects\\DpGetDat.js");
include("Objects\\DpGrid.js");
include("sys\\servis.js");
include("sys\\dbase.js");
include("sub\\mtr.js");

var label="vbrs";
var tblOut="tmp_"+label;

function listLoad()
{
	with( list )
    {
    	title = ru("Анализ продаж","Аналіз продажу");
        subAsk = askParam;
        subMake = tbl_refresh;
        subSrc = infSrc;
        //subGrid = gridInit;
        //subPageAgrHead = ttlGridRowPrefix;
        printLabel = "vbrs";
	}

	with (list.objTotal)
    {
    	init(label)
	}
    DataSource().addAccel(GA_CTRL, "D", "FINDDOC");
}

function infSrc()
{
    with( list )
    {
        qrySet( "From", tblOut, "Ptn", "VBRS" );
    }
    addTtlTbl();
    addPnTbl();
    grid.setSQLQueryCount(true);
//?	list.dataSrc.AddSumField("ffsumV", "Сума довідникова|Сумма справочная", dbFloat)
}

function listDpGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var oPrefix = oGrid.prefix();
	//oGrid.setFixColCount(4);
	var itogGrp = oPrefix.group()
	var nazv_group = itogGrp.cell("=^Fnmkl?^NM.Fcod +': '  + ^NM.Ftxts:''", "Номенклатура", sizeNmk);		
	list.GroupPage(oGrid, itogGrp, 0, false, nazv_group);
	with (oGrid)
	{		
		with(page())
		{
			cell("Fdoc_num","№ док.",5);
			cell("ffkol","Кількість|Количество",8 ,null,DP_FORMAT_KOL);
			
			with(group("Ціна відпуску|Цена отпуска"))
			{
				cell("fcenapr0","Без ПДВ|Без НДС",8 ,null,DP_FORMAT_PRI);
				cell("=^fcenapr0*1.2","+20%|+20%",8 ,null,DP_FORMAT_PRI);
				cell("F1CENA","Ціна до кальк.|Цена до кальк.",10,null,DP_FORMAT_PRI);
			}			
			cell("ffsumO","Сума\n(в відп.)|Сумма\n(в отп.)",8 ,null,DP_FORMAT_SUM);			
			cell("FNDS","ПДВ\n(в відп.)|НДС\n(в отп.)",8 ,null,DP_FORMAT_SUM);			
			cell("ffincomO","Доход",8 ,null,DP_FORMAT_SUM);
		
			
			cell("fcena","Ціна\nобліку|Цена\nучета",8,null,DP_FORMAT_PRI);
			cell("ffsumU","Сума\n(в обл.)|Сумма\n(в уч.)",GRID_SUM_WDT,null,DP_FORMAT_SUM);
			
			cell("ffincomU2","Рентабель\nність,%|Рентабель\nность,%",GRID_SUM_WDT,null,DP_FORMAT_SUM);
			cell("ffincomU","Наценка,%|Наценка,%",GRID_SUM_WDT,null,DP_FORMAT_SUM);
		
			cell("fcena_pn","Ціна у\nвалюті|Цена в\nвалюте",GRID_PRI_WDT,null,DP_FORMAT_PRI);
			cell("Fsumnk_pn","Сума\n(у вал.)|Сумма\n(в вал.)",GRID_SUM_WDT,null,DP_FORMAT_SUM);
			cell("Fsumsf_pn","Виписано|Выписано",GRID_SUM_WDT,null,DP_FORMAT_SUM);
		
			cell("fvcena","Довідникова\n ціна|Справочная\n цена",GRID_PRI_WDT,null,DP_FORMAT_PRI);			
			cell("ffsumV","Сума\n(в дов.)|Сумма\n(в спр.)",GRID_SUM_WDT,null,DP_FORMAT_SUM);
			
		
			cell("NM.Fcod","Номенклатура",15);
			cell("Fdate","Дата",8);
			with(group("Покупатель"))
			{
				cell("Fpok","Код",6,"","",null,"CLS.CL2","FCOD",null);
				cell("=tforg('TXT', ^Fpok, 0, 1)","Назва|Название",6);
			}
			cell("Fpodr","Підр.|Подр.",6);
			cell("Fmol","МВО|МОЛ.",6);
			cell("Fsc","Рах.|Сч.",4);
			cell("Fsu","С/рах.|С/cч.",4);
			cell("Fst","Стат|Стат",4);
			cell("Fio_pol","Хто пер.|Кто пер.",10);
		
			cell("F1CENA_PN","Ціна пост.|Цена пост.",10);
			cell("F1VAL_PN","Вал.|Вал.",4);

			cell("FDOC","Документ|Документ",6);
			cell("FNOP","№ операції|№ операции",6);
		
			//cell("FCODCOUNTRY","Код країни|Код страны",10);
			cell("CC.FTXT","Країна|Страна",10);
			//cell("FCODREGION","Код області|Код области",10);
			cell("CR.FTXT","Область|Область",10);
			//cell("FCODAREA","Код району|Код района",10);
			cell("CA.FTXT","Район|Район",10);
			//cell("FCODLOCATE","Код населеного\nпункту|Код населенного\nпункта",12);
			cell("CL.FTXT","Населений пункт|Населенный пункт",12);
		}
	}
//	(new DpPnExt()).Load2Grid(oGrid, list.tbl);
	oGrid.build();
}

function askParam()
{
	var gd, arrVariants
    arrVariants = list.getVariantsArr()
    gd = new DpGetDat(new Array("b","r","T0","N0","p0","m0","s:c0ut","o0","tdnop0","v0"),arrVariants);
    DropTable(tblOut);
	if(IsTable(tblOut))
	{
		alert(ru("Невозможно выполнить расчет."
				+"\nПроверьте, возможно окно с данным расчетом уже открыто,"
		 		+"\nили перезапустите систему.",
		 		 "Неможливо виконати розрахунок."
		 		+"\nПеревірте, можливо вікно з даним розрахунком вже відкрито,"
		 		+"\nабо перезапустіть систему."));
		gd.escape = true;
	}	
    return gd;
}

function tbl_refresh()
{
// - is 7
// + is 5
	var strSql1,mwhere
	with( list.objAsk )
	{
		// Код покупателя лежит в Fdbkr, кроме TZ
		strFpok = IIF("S.Fdoc='TZ'", "S.Fdbkr1", "S.Fdbkr")

		mwhere = "(A.Fdate between "+sqlTo(dat1)+" and "+sqlTo(dat2)+")"
			+ " and ((S.Fdoc in ('NK','OT','VR','VZ','TC','SF','PZ')) or (S.Fdoc='TZ' and A.Frtype='7')) "
		
		if(fpok)
			mwhere=mwhere+" and " + strFpok + "="+fpok;
		if(fpodr)
			mwhere=mwhere+" and A.Fpodr="+fpodr;
		if(fmol)
			mwhere=mwhere+" and A.Fmol="+fmol;
		if(fsc)
			mwhere=mwhere+" and A.Fsc="+fsc;
		if(fsu)
			mwhere=mwhere+" and A.Fsu="+fsu;
		if(fst)
			mwhere=mwhere+" and A.Fst="+fst;
		if(forg)
			mwhere=mwhere+" and A.Fpost="+forg;
			
		if(fdoc!=null && fdoc!=0 && fdoc!="")
			mwhere=mwhere+" and A.Fdoc='"+fdoc+"'";
		else
			+ " and ((S.Fdoc in ('NK','OT','VR','VZ','TC','SF','PZ')) or (S.Fdoc='TZ' and A.Frtype='7')) ";
		
		if(fnop!=null && fnop!=0 && fnop!="")
			mwhere=mwhere+" and S.Fnop="+fnop;
		
		mwhere = mwhere + sqlwNmk("A.Fnmkl",fnmk)

		var Jul01Var = new Date(1996, 5, 1);
		
		strNDS = ","+IIF("S.Fnds_proc<>0 AND A.fnmkvid<>'O'",
				IIF("S.FDOC_DAT < " + sqlTo(Jul01Var), 
					"20 / (100 + 20)", "20"), "0")+" as FNDS";
					//"ext_nmk.FFLOAT / (100 + ext_nmk.FFLOAT)","ext_nmk.FFLOAT/100"), "0")+" as FNDS";

		DropTable("tmp_nds");
		ExecuteSQL("SELECT fnmkl, A.fwid as fwid " + strNDS
			+ " INTO tmp_nds "
			+ " FROM ^SCH_ZAG S"
			+ " RIGHT JOIN (^ANLTK A"
				+ " LEFT JOIN ^cl_nmk nmk"					
					+ " ON A.fnmkl=nmk.fwid)"
					+ " ON A.Fid_doc=S.Fwid"
				+ " where "+mwhere
				);
		
		strFKolNK = IIF("S.Fdoc in ('NK','TC','TZ','PZ','OT')",	"A.Fkol",IIF("S.Fdoc in ('VR','VZ')","-A.Fkol","0"));
		strFKolSF = IIF("S.Fdoc='SF'","A.Fkol", "0");
		strFcenapr0 = sqlRate("A","Fcenapr_vl","Fdate")+"*A.Fcenapr";

		var top1 = "";		
		/*
		if (SUBD == ORACLE)
			strSql1 = "(" + sel_fldGroupKey + "," + sel_fldDocHR + ",Fpok,FDOC_NUM,Fdate,FIO_POL,Fcenapr0," +
					  "Fvcena,Fkolnk,Fkolsf,ffkol,ffsumO,ffsumU,ffincomO,ffincomU,ffsumV," +
					  "FNDS,FCODAREA,FCODCOUNTRY,FCODLOCATE,FCODREGION,F1CENA_PN,F1VAL_PN) "; 
		else
		{
			strSql1= "";
			top1 = "TOP 1";
		}*/
		var _Fcenapr0 = "(" + sqlRate("A","Fcenapr_vl","Fdate") + ")*A.Fcenapr";
		var _ffkol = "(" + strFKolNK + ")+(" + strFKolSF + ")";
		var _ffsumO = "(" + _ffkol + ")*(" + _Fcenapr0 + ")";
		var _ffsumU = "(" + _ffkol + ")*A.Fcena";
		var _ffincomO = "(" + _ffsumO + ")-(" + _ffsumU + ")";
		strSql1 = "SELECT " + fldGroupKey + "," + fldDocHR 
				+ "," + strFpok + " as Fpok" 
				+ ",S.FDOC_NUM as FDOC_NUM" 
				+ ",A.Fdate as Fdate"
				+ ",S.FIO_POL" 
				+ "," + _Fcenapr0 + " as Fcenapr0"
				//+ "," + strFcenapr0 + " as Fvcena"
				+ ", a.fvcena as Fvcena"
				+ ", a.F1CENA as F1CENA"
				+ ", " + strFKolNK + " as Fkolnk"
				+ ", " + strFKolSF + " as Fkolsf"
				+ ", " + _ffkol + " AS ffkol"
				+ ", " + _ffsumO + " AS ffsumO"
				+ ", " + _ffsumU + " AS ffsumU"
				+ ", " + _ffincomO + " AS ffincomO"
				+ ", " + IIF(_ffsumU + "=0",
							 "0",
							 "(" + _ffincomO + ")/(" + _ffsumU + ")*100*(" + IIF(_ffsumU + "<0", "-1", "1")+")"
							) + " AS ffincomU"
				+ ", " + IIF(_ffsumO + "=0",
							 "0",
							 "(" + _ffincomO + ")/(" + _ffsumO + ")*100*(" + IIF(_ffsumU + "<0", "-1", "1")+")"
							) + " AS ffincomU2"
				/*
				+ ", " + IIF(_ffsumU + "=0",
							 "0",
							 "(" + _ffsumO + ")/(" + _ffsumU + ")*100*(" + IIF(_ffsumU + "<0", "-1", "1")+")"
							) + " AS ffincomU2"
				*/			
				+ ", (" + _ffkol + ")*(" + strFcenapr0 + ") AS ffsumV"
				+ ", "
				+ "n.fnds/100"
//					+IIF("EXISTS(SELECT * FROM tmp_nds where A.fnmkl = tmp_nds.fnmkl and A.fwid = tmp_nds.fwid)",
//						"(SELECT " + top1 + " FNDS FROM tmp_nds where A.fnmkl = tmp_nds.fnmkl and A.fwid = tmp_nds.fwid)", 
//						"20/100")
					+"*("+strFKolNK+"+"+strFKolSF+")*("+strFcenapr0+") as FNDS" 
				+ ",(SELECT max(B.FCODAREA) from ^clrelclcl RELCLCL left join ^cl_post B "
					+ " on RELCLCL.fwid_cl = B.fwid_cl where RELCLCL.fcod = " + strFpok + " and RELCLCL.fcl = " + sprOrg + ") as FCODAREA "
				+ ",(SELECT max(B.FCODCOUNTRY) from ^clrelclcl RELCLCL left join ^cl_post B "
					+ " on RELCLCL.fwid_cl = B.fwid_cl where RELCLCL.fcod = " + strFpok + " and RELCLCL.fcl = " + sprOrg + ") as FCODCOUNTRY "
				+ ",(SELECT max(B.FCODLOCATE) from ^clrelclcl RELCLCL left join ^cl_post B "
					+ " on RELCLCL.fwid_cl = B.fwid_cl where RELCLCL.fcod = " + strFpok + " and RELCLCL.fcl = " + sprOrg + ") as FCODLOCATE "
				+ ",(SELECT max(B.FCODREGION) from ^clrelclcl RELCLCL left join ^cl_post B "
					+ " on RELCLCL.fwid_cl = B.fwid_cl where RELCLCL.fcod = " + strFpok + " and RELCLCL.fcl = " + sprOrg + ") as FCODREGION "
				+ ", A1.F1CENA as F1CENA_PN"
				+ ", A1.F1VAL AS F1VAL_PN"
				+ ", a.fsc1 AS fsc1"
				+ ", a.fsu1 AS fsu1"
				+ ", a.fst1 AS fst1"
			 + " from (^ANLTK A LEFT JOIN ^SCH_ZAG S ON A.fid_doc = S.fwid)"
			 + " LEFT JOIN ^ANLTK A1 on A.fid_pn = A1.fwid"
			 + " LEFT JOIN ^CL_NMK n on A.fnmkl = n.fwid"
			    + " where 1=1 and "+ mwhere
	}
	
	var sFields = "(fnmkl,fis_otl,fcena,fpodr,fmol,fsc,fsu,fst,fpost,fid_pn,FWID_R,FWID_H"
				+",FDOC,FNOP,Fpok,FDOC_NUM,Fdate,FIO_POL,Fcenapr0,Fvcena,F1CENA,Fkolnk,Fkolsf,ffkol"
				+",ffsumO,ffsumU,ffincomO,ffincomU,ffincomU2,ffsumV,FNDS,FCODAREA ,FCODCOUNTRY,FCODLOCATE"
				+",FCODREGION,F1CENA_PN,F1VAL_PN,fsc1,fsu1,fst1)";
				
	CreateTable(tblOut, "VBRS", "fwid");
	ExecuteSQL("alter table " + tblOut +" add F1CENA "+ sqlType("CURRENCY"), false);
	ExecuteSQL("INSERT INTO " + tblOut + sFields + strSql1);
//   var objPn = new pnRef(tblOut, list.objAsk.codv, objPn_run);
}

function objPn_run(isRefExist)
{
	var k = this.tbl.getValue("ffsumU")<0? -1 : 1;
	var fincomu = this.tbl.getValue("ffincomO") / this.tbl.getValue("ffsumU") * 100 * k;       
	var fincomu2 = this.tbl.getValue("ffsumO") / this.tbl.getValue("ffsumU") * 100 * k;       
    this.tbl.setValue("Fsumnk_pn", this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcena_pn"));
    this.tbl.setValue("Fsumsf_pn", this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcena_pn"));
    this.tbl.setValue("Fsumnk",    this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("Fsumsf",    this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("Fsumprnk",  this.tbl.getValue("Fkolnk")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("Fsumprsf",  this.tbl.getValue("Fkolsf")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("ffkol",     this.tbl.getValue("fkolnk")+this.tbl.getValue("fkolsf"));
    this.tbl.setValue("ffsumO",    this.tbl.getValue("ffkol")*this.tbl.getValue("Fcenapr0"));
    this.tbl.setValue("ffsumU",    this.tbl.getValue("ffkol")*this.tbl.getValue("Fcena"));
    this.tbl.setValue("ffincomO",  this.tbl.getValue("ffsumO")-this.tbl.getValue("ffsumU"));
    this.tbl.setValue("ffincomU",  this.tbl.getValue("ffsumU")==0? 0 : fincomu);
    this.tbl.setValue("ffincomU2",  this.tbl.getValue("ffsumU")==0? 0 : fincomu2);
    this.tbl.setValue("ffsumV",    this.tbl.getValue("ffkol")*this.tbl.getValue("Fvcena"));
}
function listOnPrnList(tv)
{
    var h = new Object();
    h.FD1  = list.objAsk.dat1;
    h.FD2  = list.objAsk.dat2;
    h.FNMKL = list.objAsk.fnmk;
    h.FPODR = list.objAsk.fpodr;
    h.FMOL = list.objAsk.fmol;
    h.FSC = list.objAsk.fsc;
    h.FSU = list.objAsk.fsu;
    h.FST = list.objAsk.fst;
    h.FORG = list.objAsk.forg;
    h.FPOK = list.objAsk.fpok;
    h.FVAL = list.objAsk.fval;
    tv.setHTbl(h);
}

function listMenuInit()
{
	if(list.tbl.getValue("FTT")=="" || list.tbl.getValue("FTT")==null)
	{
		DataSource().AddMenuItem("FINDDOC","Пошук документа|Поиск документа");
		DataSource().AddMenuItem("","");
	}
}

function listMenuRun(cID)
{
	switch(cID)
	{
	case "FINDDOC":
		include("doc\\DpDocPtn.js");
		var t = DataSource().getTable();
		if(t.isRecord())
			FindDocument(t.getValue("fdoc"), t.getValue("fnop"), t.getValue("fwid_h"));
		break;
	case "EDIT":
		include("doc\\DpDoc.js");
		var t = DataSource().getTable();
		if(t.isRecord() && (t.getValue("FTT")=="" || t.getValue("FTT")==null))
		{
			var oDoc = new DpDoc(t.getValue("fdoc"), t.getValue("fnop"));
			oDoc.edit("EDIT",t.getValue("fwid_h"))			
		}
		break;
	}
}

include("sys\\DpList.js");