//Сальдовая ведомость по жэку

include("Objects/DpJRegistrator.js");

var jID = getPar("HOCPAYREG");		//журнал реестрации (по умолч. KU)
var tblOut = getTmpTableName();		//таблица с результатами
var tblReg = null;					//таблица журнала регистрации
var label  = "KU_NORM";				//метка для печати
var streetID;						//id улицы
var houseID;						//id дома
var nmk;
var rdat1 = today;					//нач. дата расчета
var rdat2 = today;					//кон. дата расчета

function listLoad()
{
	this.printLabel = label;
	this.accDel = null;  	
}

function listTitle()
{
	var sCapt = ru("Итоги по нормам потребления", "Підсумки по нормах споживання");
	
	var dat1 = list.objAsk.idat1;
	var dat2 = list.objAsk.idat2;
	var oStreet = list.objAsk.istreet;
	var oHouse = list.objAsk.ihouse;
	
	if(dat1)
		sCapt += " за "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");
	if(oStreet!=null && oStreet.getCod()!=0)
		sCapt += ": "+ oStreet.getTxt();
	if(oHouse!=null)
		sCapt += " "+ getHouseNom(oHouse.getFWID());
	
	return sCapt;
}

function listSrc()
{	
	this.qrySet("From", tblOut
				,"WhereArr", new Array("FNMK=FNMK_GRPID")
				,"WhereArrName", Array(ru("Группы","Групи"))
				, "Order", "FNMK_GRPID, "+ IIF("FTT='GR'", 0, 1) +", FNMK"
				);
}

function listAsk()
{
	var p = new Object();
	p.tblName = tblOut;
	p.label = label;	
	p.nmk = true;	
	showWindow("i_vedku.xml", SW_MODAL, p);
	if (!p.escape)
    {
    	rdat1 = p.idat1;
	    rdat2 = p.idat2;
	    houseID = p.ihouse.getFWID();
	    streetID = p.istreet.getFWID();
	    nmk = Number(p.inmk.getFwid());
    }    
	return p;
}

function listMake()
{
	tblReg = hocRegTblName();
	var sSql = "select * from ^"+ tblReg +" where 1<>1";
	if(!lpProxy.getDBManager().testSQL(sSql))
	{
		var sMsg = UR("Не налагоджений журнал реєстрації оплат!"
					+"|Не настроен журнал реестрации оплат!")
		alert(sMsg);
		return false;
	}
	
	var nPr = 1;
	var sPrText = ru("Расчет...","Розрахунок...");
	setProgressRange(0, 10);
	setProgressPos(nPr++, sPrText);
	
	createOutTable();
	setProgressPos(nPr++, sPrText);
		
	var sFldSum = "FSUM";
	var sFldDat = "FDATE";
	var sFldOrg = "FORG";
			
	var sWhere = " where 1=1 ";
	if(rdat1!=null && rdat2!=null)	//отбор за период
		sWhere += " and (sku.FDOC_DAT>="+ sqlTo(rdat1) 
				  +" and sku.FDOC_DAT<="+ sqlTo(rdat2) +")";
	if(streetID!=null)			//отбор по 1 улице
		sWhere += " and lic.FSTREET="+ streetID;	
	if(houseID!=null)			//отбор по 1 дому
		sWhere += " and lic.FHOUSE="+ houseID;
		
	/*
	//--------------------- показания счетчиков ---------------------
	var tblScore = tblOut +"_SCORE";	
	ExecuteSQL("DROP TABLE "+ tblScore, false);
	
	var sSql = "select apt.FCWATER as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" into "+ tblScore
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FCWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FHWATER as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FHWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FWREMOVAL as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FWREMOVAL";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FGAS as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FGAS";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FELECTRIC as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FELECTRIC";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FRENT as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FRENT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FHEAT as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FHEAT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblScore
				+" (FNMK, FHOT, FCOOL, FDRAIN, FHEAT, FGAS, FELECTRIC)"
				+" select apt.FOTHER as FNMK"
					+", max(sku.FHOT) as FHOT"
					+", max(sku.FCOOL) as FCOOL "
					+", max(sku.FDRAIN) as FDRAIN "
					+", max(sku.FHEAT) as FHEAT"
					+", max(sku.FGAS) as FGAS"
					+", max(sku.FELECTRIC) as FELECTRIC"
				+" from ^RAS_SKU as sku "
					+" inner join ^LICSC as lic on lic.FID_DOG=sku.FID_DOG "
					+" left join ^CL_APARTMENT apt on apt.FWID_CL=lic.FAPMT" 
				+(rdat1!=null? " where sku.FDOC_DAT<"+ sqlTo(rdat1) : "")
				+" group by apt.FOTHER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	//--------------------- долги ---------------------	
	var tblDept = tblOut +"_DEBT";
	ExecuteSQL("DROP TABLE "+ tblDept, false);
	sSql = "CREATE TABLE "+ tblDept 
				+"( FNMK "+ SqlType("LONG") 
				+", FSUM"+ SqlType("CURRENCY") 
				+", FPLATSUM"+ SqlType("CURRENCY") +")"
	ExecuteSQL(sSql);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FCWATER"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FWATER", "-reg.FWATER") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FWATER") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FCWATER<>0"
			+" group by apt.FCWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FHWATER"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FHOTWATER", "-reg.FHOTWATER") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FHOTWATER") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FHWATER<>0"
			+" group by apt.FHWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FWREMOVAL"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FDRAIN", "-reg.FDRAIN") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FDRAIN") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FWREMOVAL<>0"
			+" group by apt.FWREMOVAL";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FGAS"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FGAS", "-reg.FGAS") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FGAS") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FGAS<>0"
			+" group by apt.FGAS";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FELECTRIC"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FELECTRIC", "-reg.FELECTRIC") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FELECTRIC") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FELECTRIC<>0"
			+" group by apt.FELECTRIC";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FRENT"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FRENT", "-reg.FRENT") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FRENT") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FRENT<>0"
			+" group by apt.FRENT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FHEAT"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FHEAT", "-reg.FHEAT") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FHEAT") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FHEAT<>0"
			+" group by apt.FHEAT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "insert into "+ tblDept +"(FNMK, FSUM, FPLATSUM)"
			+" select apt.FOTHER"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "reg.FOTHER", "-reg.FOTHER") +")"
				+", sum("+ IIF("reg.FISSKU="+ sqlTrue, "0", "reg.FOTHER") +")"
			+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" left join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where reg.FDATE<="+ sqlTo(rdat1)
				+" and apt.FOTHER<>0"
			+" group by apt.FOTHER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	//--------------------- общая таблица ---------------------
	sSql = "INSERT INTO "+ tblOut
				+"(FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"
				+", apt.FCWATER"
				+", sum(sku.FCOOLSUM) as FSUM"
				+", sum(sku.FCOOLSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FCWATER) as FDEBT"
				+", (select sum(reg.FWATER) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FCWATER=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FCWATER"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FCWATER "
			+ sWhere
				+(nmk? " and apt.FCWATER="+ nmk : "")
				+" and apt.FCWATER<>0"
			+ " group by apt.FCWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FHWATER"
				+", sum(sku.FHOTSUM) as FSUM"
				+", sum(sku.FHOTSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FHWATER) as FDEBT"
				+", (select sum(reg.FHOTWATER) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FHWATER=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FHWATER"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FHWATER "
			+ sWhere
				+" and apt.FHWATER<>0"
				+(nmk? " and apt.FHWATER="+ nmk : "")
			+ " group by apt.FHWATER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FWREMOVAL"
				+", sum(sku.FWREMOVSUM) as FSUM"
				+", sum(sku.FWREMOVSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FWREMOVAL) as FDEBT"
				+", (select sum(reg.FDRAIN) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FWREMOVAL=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FWREMOVAL"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FWREMOVAL "
			+ sWhere
				+" and apt.FWREMOVAL<>0"
				+(nmk? " and apt.FWREMOVAL="+ nmk : "")
			+ " group by apt.FWREMOVAL";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FGAS"
				+", sum(sku.FGASSUM) as FSUM"
				+", sum(sku.FGASSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FGAS) as FDEBT"
				+", (select sum(reg.FGAS) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FGAS=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FGAS"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FGAS "
			+ sWhere
				+" and apt.FGAS<>0"
				+(nmk? " and apt.FGAS="+ nmk : "")
			+ " group by apt.FGAS";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FELECTRIC"
				+", sum(sku.FELECTRICSUM) as FSUM"
				+", sum(sku.FELECTRICSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FELECTRIC) as FDEBT"
				+", (select sum(reg.FELECTRIC) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FELECTRIC=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FELECTRIC"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FELECTRIC "
			+ sWhere
				+" and apt.FELECTRIC<>0"
				+(nmk? " and apt.FELECTRIC="+ nmk : "")
			+ " group by apt.FELECTRIC";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FRENT"
				+", sum(sku.FRENTSUM) as FSUM"
				+", sum(sku.FRENTSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FRENT) as FDEBT"
				+", (select sum(reg.FRENT) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FRENT=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FRENT"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FRENT "
			+ sWhere
				+" and apt.FRENT<>0"
				+(nmk? " and apt.FRENT="+ nmk : "")
			+ " group by apt.FRENT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FHEAT"
				+", sum(sku.FHEATSUM) as FSUM"
				+", sum(sku.FHEATSUB) as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FHEAT) as FDEBT"
				+", (select sum(reg.FHEAT) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FHEAT=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FHEAT"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FHEAT "
			+ sWhere
				+" and apt.FHEAT<>0"
				+(nmk? " and apt.FHEAT="+ nmk : "")
			+ " group by apt.FHEAT";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK"
				+", FSUM, FSUB, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+", FDEBT, FPLATSUM"
				+")" 
			+" SELECT "+ sqlEmpStr +" as FTT"				
				+", apt.FOTHER"
				+", sum(sku.FOTHERSUM) as FSUM"
				+", 0 as FSUB"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"
				+", (max(sku.FHOT)-max(s.FHOT)) as FHOTVOL"
				+", (max(sku.FCOOL)-max(s.FCOOL)) as FCOOLVOL"
				+", (max(sku.FDRAIN)-max(s.FDRAIN)) as FDRAINVOL"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
				+", (select sum(debt.FSUM) from "+ tblDept +" debt where debt.FNMK=apt.FOTHER) as FDEBT"
				+", (select sum(reg.FOTHER) from "+ tblReg +" reg "
					+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
					+" where apt.FOTHER=s.FNMK"
						+" and reg.FISSKU<>"+ sqlTrue
						+" and reg.FDATE>="+ sqlTo(rdat1)
						+" and reg.FDATE<="+ sqlTo(rdat2)
					+" group by apt.FOTHER"	
					+") as FPLATSUM"
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
				+" LEFT JOIN ^"+ tblScore +" as s ON s.FNMK=apt.FOTHER "
			+ sWhere
				+" and apt.FOTHER<>0"
				+(nmk? " and apt.FOTHER="+ nmk : "")
			+ " group by apt.FOTHER";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	
	//количество плательщиков определяем по договорам
	sSql = "update "+ tblOut +" set FPLATKOL=("
			+"select count(*) "
			+" from ^LICSC as lic "
			+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
			+" where apt.FCWATER="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FHWATER="+ tblOut +".FNMK)"
			+" where exists (select apt.FHWATER "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FHWATER="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FWREMOVAL="+ tblOut +".FNMK)"
			+" where exists (select apt.FWREMOVAL "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FWREMOVAL="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FGAS="+ tblOut +".FNMK)"
			+" where exists (select apt.FGAS "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FGAS="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FELECTRIC="+ tblOut +".FNMK)"
			+" where exists (select apt.FELECTRIC "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FELECTRIC="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FRENT="+ tblOut +".FNMK)"
			+" where exists (select apt.FRENT "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FRENT="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FHEAT="+ tblOut +".FNMK)"
			+" where exists (select apt.FHEAT "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FHEAT="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CL_APARTMENT as apt on apt.FWID_CL=lic.FAPMT "
				+" where apt.FOTHER="+ tblOut +".FNMK)"
			+" where exists (select apt.FOTHER "
				+" from ^CL_APARTMENT as apt "
				+" where apt.FOTHER="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	//--------------------- субсидия ---------------------
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK, FNMK_GRPID, FNMK_TXT"
				+", FSUM, FSUB"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+")" 
			+" SELECT 'SUB' as FTT"
				+", 0 as FNMK"
				+", "+ java.lang.Integer.MAX_VALUE +" as FNMK_GRPID"
				+", '"+ UR("Субсидія|Субсидия") +"'"
				+", -sum(sku.FSUB) as FSUM"
				+", sum(sku.FSUB) as FSUB"
				+", 0 as FPLATKOL"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"				
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "				
			+ sWhere
				+" and sku.FSUB>0"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
		
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+" select count(*) as cnt from ^CLRELCLCL "
				+" where FCL=0 and FCOD in ( select FORG "
					+" from ^RAS_SKU sku "
						+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
						+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
						+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
					+ sWhere
						+" and sku.FSUB>0"
					+" group by sku.FORG)"
				+")"
			+" where FTT='SUB'"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	//--------------------- перерасчет ---------------------
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK, FNMK_GRPID, FNMK_TXT"
				+", FSUM, FSUB"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+")" 
			+" SELECT 'REC' as FTT"
				+", 0 as FNMK"
				+", "+ java.lang.Integer.MAX_VALUE +" as FNMK_GRPID"
				+", '"+ UR("Перерахунок|Перерасчет") +"'"
				+", sum(sku.FRECALC) as FSUM"
				+", sum(sku.FSUB) as FSUB"
				+", 0 as FPLATKOL"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"				
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "				
			+ sWhere
				+" and sku.FRECALC>0"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+" select count(*) as cnt from ^CLRELCLCL "
				+" where FCL=0 and FCOD in ( select FORG "
					+" from ^RAS_SKU sku "
						+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
						+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
						+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
					+ sWhere
						+" and sku.FRECALC>0"
					+" group by sku.FORG)"
				+")"
			+" where FTT='REC'"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	//--------------------- пеня ---------------------
	sSql = "INSERT INTO "+ tblOut
				+"( FTT, FNMK, FNMK_GRPID, FNMK_TXT"
				+", FSUM, FSUB"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+")" 
			+" SELECT 'PEN' as FTT"
				+", 0 as FNMK"
				+", "+ java.lang.Integer.MAX_VALUE +" as FNMK_GRPID"
				+", '"+ UR("Пеня|Пеня") +"'"
				+", sum(sku.FPENALTY) as FSUM"
				+", sum(sku.FSUB) as FSUB"
				+", 0 as FPLATKOL"
				+", sum(lic.FPERSKOL) as FPERSKOL"
				+", sum(lic.FEXTKOL) as FEXMPTKOL"				
			+" FROM ^RAS_SKU sku "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
				+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
				+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "				
			+ sWhere
				+" and sku.FPENALTY>0"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" FPLATKOL=("
				+" select count(*) as cnt from ^CLRELCLCL "
				+" where FCL=0 and FCOD in ( select FORG "
					+" from ^RAS_SKU sku "
						+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
						+" left join ^CL_APARTMENT as apt ON apt.FWID_CL=lic.FAPMT "
						+" inner join ^CL_HOUSE as hs ON hs.FWID_CL=lic.FHOUSE "
					+ sWhere
						+" and sku.FPENALTY>0"
					+" group by sku.FORG)"
				+")"
			+" where FTT='PEN'"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
			
	//--------------------- итоги ---------------------
	ExecuteSQL("DROP TABLE "+ tblOut +"_ITOG", false);
	
	//самая итоговая строка (по жэку)
	sSql = "select 'SUM' as FTT"
				+", 0 as FSTREET"
				+", 0 as FHOUSE "
				+", "+ java.lang.Integer.MAX_VALUE +" as FNMK_GRPID"
				+", "+ java.lang.Integer.MAX_VALUE +" as FNMK"
				+", sum(FSUM) as FSUM"
				+", sum(FSUB) as FSUB"
				+", sum(FDEBT) as FDEBT"
				+", sum(FPLATSUM) as FPLATSUM"
				+", sum(FPLATKOL) as FPLATKOL"
				+", sum(FPERSKOL) as FPERSKOL"
				+", sum(FEXMPTKOL) as FEXMPTKOL"
				+", sum(FHOTVOL) as FHOTVOL"
				+", sum(FCOOLVOL) as FCOOLVOL"
				+", sum(FDRAINVOL) as FDRAINVOL"
				+", sum(FRECALC) as FRECALC"
				+", sum(FPENALTY) as FPENALTY"
			+" into "+ tblOut +"_ITOG from "+ tblOut;	
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
			
	//по группам номенклатуры 
	sSql = "insert into "+ tblOut +"_ITOG "
				+"( FTT, FNMK, FNMK_GRPID"
				+", FSUM, FSUB, FDEBT, FPLATSUM"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
				+")"
			+" select 'GR' as FTT, nmk.FGRPID"
				+", nmk.FGRPID "
				+", sum(FSUM) as FSUM"
				+", sum(FSUB) as FSUB"
				+", sum(FDEBT) as FDEBT"
				+", sum(FPLATSUM) as FPLATSUM"
				+", sum(FPLATKOL) as FPLATKOL"
				+", sum(FPERSKOL) as FPERSKOL"
				+", sum(FEXMPTKOL) as FEXMPTKOL"
				+", sum(FHOTVOL) as FHOTVOL"
				+", sum(FCOOLVOL) as FCOOLVOL"
				+", sum(FDRAINVOL) as FDRAINVOL"
				+", sum(FRECALC) as FRECALC"
				+", sum(FPENALTY) as FPENALTY"
			+" from "+ tblOut +" t "
				+" inner join ^CL_NMK nmk on nmk.FWID=t.FNMK"
			+" where FNMK>0"
			+" group by nmk.FGRPID";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "INSERT INTO "+ tblOut 
				+" (FTT, FSTREET, FHOUSE, FNMK, FNMK_GRPID"
				+", FSUM, FSUB, FDEBT, FPLATSUM"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY)" 
			+" SELECT FTT, FSTREET, FHOUSE, FNMK, FNMK_GRPID"
				+", FSUM, FSUB, FDEBT, FPLATSUM"
				+", FPLATKOL, FPERSKOL, FEXMPTKOL"
				+", FHOTVOL, FCOOLVOL, FDRAINVOL"				
				+", FRECALC, FPENALTY"
			+" FROM "+ tblOut +"_ITOG";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	sSql = "update "+ tblOut
			+" set FNMK_TXT=("
				+"select nmk.FTXTS "
				+" from ^CL_NMK nmk "
				+" where nmk.FWID="+ tblOut +".FNMK"
				+")"
			+" where FNMK<>0 "
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut
			+" set FNMK_GRPID=("
				+"select nmk.FGRPID "
				+" from ^CL_NMK nmk "
				+" where nmk.FWID="+ tblOut +".FNMK"
				+")"
			+" where FNMK<>0 "
				+" and (FNMK_GRPID=0 "
				+" or FNMK_GRPID is NULL)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);	
	
	ExecuteSQL("update "+ tblOut +" set FDEBT=0 where FDEBT is NULL");
	ExecuteSQL("update "+ tblOut +" set FPLATSUM=0 where FPLATSUM is NULL");
	ExecuteSQL("delete from "+ tblOut +" where FDEBT=0 and FSUM=0 and FPLATSUM=0");
			
	//сальдо
	sSql = "UPDATE "+ tblOut 
		+" SET FBBALANS=FDEBT"
			+", FEBALANS=(FDEBT + (FSUM-FPLATSUM))";
	ExecuteSQL(sSql);
	*/
	
	
	sSql = "INSERT INTO "+ tblOut
				+"(FNMK, FNMK_TXT, FNMK_GRPID, FSERV"
				+", FPERSKOL, FEXMPTKOL, FKOL, FSUM, FRECALC, FPENALTY"
				+")" 
			+" SELECT s.FNMKL, max(nmk.FTXTS)"
				+", max(nmk.FGRPID), max(s.FSERV)"
				+", sum(sku.FPERSKOL), sum(sku.FEXEMPTKOL)"
				+", sum(s.FKOL), sum(s.FSUM)"
				+", max(sku.FRECALC) as FRECALC"
				+", max(sku.FPENALTY) as FPENALTY"
			+" FROM ^RAS_SKU sku "
				+" inner join ^SKU_SERV as s ON s.FID_DOC=sku.FWID "
				+" inner join ^CL_NMK as nmk ON nmk.FWID=s.FNMKL "
				+" inner join ^LICSC as lic ON lic.FID_DOG=sku.FID_DOG "
			+ sWhere
				+(nmk? " s.FNMKL="+ nmk : "")
			+ " group by s.FNMKL";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	sSql = "update "+ tblOut +" set FPLATKOL=("
				+"select count(*) "
				+" from ^LICSC as lic "
					+" inner join ^CONTRACT c on c.FWID=lic.FID_DOG "
					+" inner join ^SC_SERV as s ON s.FID_DOG=c.FWID "
				+" where s.FNMKL="+ tblOut +".FNMK"
					+" and c.FBDAT<="+ sqlTo(today) +" and c.FEDAT>="+ sqlTo(rdat2)
					+(streetID? " and lic.FSTREET="+ streetID :"")
					+(houseID? " and lic.FHOUSE="+ houseID :"")
				+" group by s.FNMKL)"
			+" where exists (select lic.FID_DOG "
				+" from ^LICSC as lic "
					+" inner join ^RAS_SKU sku on sku.FID_DOG=lic.FID_DOG "
					+" inner join ^SKU_SERV as s ON s.FID_DOC=sku.FWID "
				+" where s.FNMKL="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	var sTmpMen = getTmpTableName();
	sSql = "CREATE TABLE "+ sTmpMen
			+"( FNMKL"+ SqlType("LONG")
			+", FWID"+ SqlType("LONG")
			+", FID_DOG"+ SqlType("LONG")
			+", FID_LG"+ SqlType("LONG")
			+", FPERSKOL"+ SqlType("INT")
			+", FEXMPTKOL"+ SqlType("INT")
			+", FSERV"+ SqlType("TEXT", 25)
			+")";			
	ExecuteSQL(sSql, false);
	
	sSql = "insert into "+ sTmpMen 
				+" (FWID, FID_DOG, FID_LG)"
			+" select m.FWID, m.FID_DOG, 0"
			+" from ^SC_MEN m"
			+" inner join ^CONTRACT c on c.FWID=m.FID_DOG "
			+" inner join ^LICSC lic on c.FWID=lic.FID_DOG "
			+" where c.FBDAT<="+ sqlTo(rdat2) +" and c.FEDAT>="+ sqlTo(rdat1)
				+" and m.FBDAT<="+ sqlTo(rdat2) 
				+" and m.FEDAT>="+ sqlTo(rdat1)
				+(streetID? " and lic.FSTREET="+ streetID :"")
				+(houseID? " and lic.FHOUSE="+ houseID :"")
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FPERSKOL=("
				+"select count(*) "
				+" from "+ sTmpMen +" m "
				+" inner join ^SC_SERV s on s.FID_DOG=m.FID_DOG"
				+" where s.FNMKL="+ tblOut +".FNMK"
				+" group by s.FNMKL)"
			+" where exists (select s.FID_DOG "
				+" from ^SC_SERV s "
				+" where s.FNMKL="+ tblOut +".FNMK)";
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	
	sSql = "update "+ tblOut +" set FPLATSUM=("
				+"select sum("+ IIF(tblOut +".FSERV='RENT'", "reg.FRENT"
							  , IIF(tblOut +".FSERV='CWATER'", "reg.FWATER"
							  , IIF(tblOut +".FSERV='HEAT'", "reg.FHEAT"
							  , IIF(tblOut +".FSERV='HWATER'", "reg.FHOTWATER"
							  , IIF(tblOut +".FSERV='DRAIN'", "reg.FDRAIN"
							  , IIF(tblOut +".FSERV='GAS'", "reg.FGAS"
							  , IIF(tblOut +".FSERV='ELECTRIC'", "reg.FELECTRIC"
							  , IIF(tblOut +".FSERV='OTHER'", "reg.FOTHER"
							  , IIF(tblOut +".FSERV='SUBSERV'", "reg.FSUBSERV"
							  , "0")))))))))
							+")"
				+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" where reg.FDATE>="+ sqlTo(rdat1) 
					+" and reg.FDATE<="+ sqlTo(rdat2)
					+" and reg.FISSKU="+ sqlFalse
					+(streetID? " and lic.FSTREET="+ streetID :"")
					+(houseID? " and lic.FHOUSE="+ houseID :"")
				+")"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	sSql = "update "+ tblOut +" set FDEBT=("
				+"select sum("+ IIF(tblOut +".FSERV='RENT'", IIF("reg.FISSKU="+ sqlTrue, "reg.FRENT", "-reg.FRENT")
							  , IIF(tblOut +".FSERV='CWATER'", IIF("reg.FISSKU="+ sqlTrue, "reg.FWATER", "-reg.FWATER")
							  , IIF(tblOut +".FSERV='HEAT'", IIF("reg.FISSKU="+ sqlTrue, "reg.FHEAT", "-reg.FHEAT")
							  , IIF(tblOut +".FSERV='HWATER'", IIF("reg.FISSKU="+ sqlTrue, "reg.FHOTWATER", "-reg.FHOTWATER")
							  , IIF(tblOut +".FSERV='DRAIN'", IIF("reg.FISSKU="+ sqlTrue, "reg.FDRAIN", "-reg.FDRAIN")
							  , IIF(tblOut +".FSERV='GAS'", IIF("reg.FISSKU="+ sqlTrue, "reg.FGAS", "-reg.FGAS")
							  , IIF(tblOut +".FSERV='ELECTRIC'", IIF("reg.FISSKU="+ sqlTrue, "reg.FELECTRIC", "-reg.FELECTRIC")
							  , IIF(tblOut +".FSERV='OTHER'", IIF("reg.FISSKU="+ sqlTrue, "reg.FOTHER", "-reg.FOTHER")
							  , IIF(tblOut +".FSERV='SUBSERV'", IIF("reg.FISSKU="+ sqlTrue, "reg.FSUBSERV", "-reg.FSUBSERV")
							  , "0")))))))))
							+")"
				+" from ^"+ tblReg +" reg "
				+" inner join ^LICSC as lic on lic.FID_DOG=reg.FID_DOG "
				+" where reg.FDATE<"+ sqlTo(rdat1) 
					+(streetID? " and lic.FSTREET="+ streetID :"")
					+(houseID? " and lic.FHOUSE="+ houseID :"")
				+")"
	ExecuteSQL(sSql);
	setProgressPos(nPr++, sPrText);
	
	ExecuteSQL("update "+ tblOut +" set FDEBT=0 where FDEBT is NULL");
	ExecuteSQL("update "+ tblOut +" set FPLATSUM=0 where FPLATSUM is NULL");
	ExecuteSQL("delete from "+ tblOut +" where FDEBT=0 and FSUM=0 and FPLATSUM=0");
	
	sSql = "UPDATE "+ tblOut 
		+" SET FBBALANS=FDEBT"
			+", FEBALANS=(FDEBT + (FSUM-FPLATSUM))";
	ExecuteSQL(sSql);
	
	setProgressPos(0);
}

function createOutTable(sTblName)
{
	if(!sTblName)
		sTblName = tblOut;
	if(!ExecuteSQL("DROP TABLE "+ sTblName, false))
		ExecuteSQL("DELETE FROM "+ sTblName, false);
	var sSql = "CREATE TABLE "+ sTblName
			+"( FNMK"+ SqlType("LONG")
			+", FNMK_GRPID"+ SqlType("LONG")
			+", FNMK_TXT"+ SqlType("LONGTEXT")
			+", FHOUSE"+ SqlType("LONG")		//дом: FWID_CL табл CL_HOUSE, он же FHOUSE из табл CL_APARTMENT. вытягивается по FAPMT табл LICSC
			+", FSTREET"+ SqlType("LONG")		//улица: FSTREET из табл CL_HOUSE, он же FWID табл CL (справочник 1-го вида). вытягивается по FHOUSE табл CL_APARTMENT
			+", FWCOUNTER"+ SqlType("BIT")		//налич.сч.воды
			+", FGCOUNTER"+ SqlType("BIT")		//налич.сч.газа
			+", FPLATKOL"+ SqlType("INT")
			+", FPERSKOL"+ SqlType("INT")		//колич. жильцов
			+", FEXMPTKOL"+ SqlType("INT")		//колич. льготников
			+", FSERV"+ SqlType("TEXT", 25)
			+", FTT"+ SqlType("TEXT") +" default "+ sqlEmpStr //итог
			+", FSUM"+ SqlType("CURRENCY")		//общая сумма с уч. льгот и субсидий
			+", FSUB"+ SqlType("CURRENCY")		//сумма субсидий			
			+", FBBALANS"+ SqlType("CURRENCY")	//сальдо на начало
			+", FEBALANS"+ SqlType("CURRENCY")	//сальдо на конец
			+", FPLATSUM"+ SqlType("CURRENCY")	//сумма оплаченная: FSUM из журнала регистрации по документу PP.
			+", FDEBT"+ SqlType("CURRENCY")		//долг на начало
			+", FKOL"+ SqlType("DOUBLE")	 	//
			+", FHOTVOL"+ SqlType("DOUBLE")	 	//гор. вода
			+", FCOOLVOL"+ SqlType("DOUBLE") 	//хол. вода
			+", FDRAINVOL"+ SqlType("DOUBLE")	//водоотведение
			+", FRECALC"+ SqlType("CURRENCY") 	//перерасчет
			+", FPENALTY"+ SqlType("CURRENCY") 	//пеня
			+", FWID"+ SqlType("COUNTER")
			+")";			
	ExecuteSQL(sSql, false);
	createIndex(sTblName, "FSERV", "FSERV");
	createIndex(sTblName, "FNMK", "FNMK");
}

function listDpGrid()
{
	include("Objects/DpGrid.js");
	var oGrid = new DpGrid("NOCREATE");
	var gr = oGrid.page();    
    
    oGrid.defCond("=^FTT=='SUM'", "ITOG");         
	oGrid.color(1, "ITOG");	
	oGrid.bold("ITOG");
	
	oGrid.defCond("=^FTT=='SUB'", "SUB"); 
	oGrid.color(2, "SUB");
	oGrid.bold("SUB");
	
	oGrid.defCond("=^FTT=='GR' || ^FTT=='REC' || ^FTT=='PEN'", "GROUP"); 
	oGrid.color(2, "GROUP");
	oGrid.bold("GROUP");
		
	var nmk = "=^FTT=='SUM'? ru('Всего','Разом') "
			+" : ^FTT=='SUB'? ru('Субсидия ','Субсидія ')"
			+" : ^FTT=='HS'? ru('Всего по дому ','Разом по дому ')"
			+" : (^FNMK_TXT)";
	gr.FieldEx(nmk, "Тариф|Тариф", 15);
	//if(!houseID)
	//	gr.FieldEx("hs.FNOM", "Будинок|Дом", 8);
	//gr.FieldEx("FWCOUNTER", "Ліч.води|Сч.воды", 10, "", "%5d");
	
	gr.FieldEx("FPLATKOL", "Платників|Плательщиков", 8, "", "%5d");
	gr.FieldEx("FPERSKOL", "Мешканців|Жильцов", 8, "", "%5d");
	gr.FieldEx("FEXMPTKOL", "Пільговиків|Льготников", 8, "", "%5d");
	gr.FieldEx("FKOL", "Кількість\n(об'єм)|Колич.\n(объем)", 10, "", DP_FORMAT_KOL);
	
	gr.FieldEx("FBBALANS", "Сальдо\nна початок|Сальдо\nна начало", 10, "", DP_FORMAT_SUM);	
	gr.FieldEx("FSUM", "Нараховано|Начислено", 10, "", DP_FORMAT_SUM);
	//gr.FieldEx("FSUB", "Сума\nсубсидій|Сумма\nсубсидий", 10, "", DP_FORMAT_SUM);
	gr.FieldEx("FPLATSUM", "Сума\nоплати|Сумма\nоплаты", 10, "", DP_FORMAT_SUM);
	gr.FieldEx("FEBALANS", "Сальдо\nна кінець|Сальдо\nна конец", 10, "", DP_FORMAT_SUM);
	/*
	if(getSystem()=="VDK")
	{
		gr.FieldEx("=^FCOOLVOL+^FHOTVOL", "Об'єм (вода)|Объем (вода)", 10, "", DP_FORMAT_KOL);
		gr.FieldEx("FDRAINVOL", "Об'єм (водовідведення)|Объем (водоотведение)", 10, "", DP_FORMAT_KOL);
	}
	*/ 
	
	oGrid.build(); 
}

function hocRegTblName()
{		
	if(!jID || jID=="")
		jID = getPar("HOCPAYREG");		
	var sPath = getPath("UJ");
	var sTblName = sPath +".UJ_KU";	
	if(jID!=null && jID!="")
		sTblName = sPath +".UJ_"+ jID;		
	return sTblName;
}

function getHouseNom(fwid_cl)
{
	var sNom = "";
	if(!fwid_cl)
		fwid_cl = houseID;
	var sSql = "select rel.fcod, h.fnom, h.fwid_cl from ^cl_house h "
				+" inner join ^clrelclcl rel on rel.fwid_cl=h.fwid_cl "
				+" where h.fwid_cl="+ fwid_cl;
	var oHs = getSnap(sSql, false);
	if(oHs!=null && oHs[1]!=null)
		sNom = oHs[1];
	return sNom;	
}

function getSDat(date)
{	
	if(!date)
	{
		var oSnap = getSnap("select FDATE from "+ tblOut +" order by FDATE", false);
		if(oSnap!=null)
			date = toScriptDate(oSnap[0]);
	}
	if(!date)
		return "";
	var sMonth = tmonth(date, 3);
	var sYear = date.getYear() + 1900;
	return sMonth +" "+ sYear;
}

function getAddr()
{
	var sAddr = "";
	var oSnap = getSnap("select r.FSTREET,r.FHOUSE,cl.FTXT "
					+" from "+ tblOut +" r inner join ^CL cl on cl.FWID=r.Fstreet "
					+" where r.Fhouse<>0", false);
	if(oSnap!=null && oSnap[0]!=0)
		sAddr = oSnap[2] +" "+ getHouseNom(oSnap[1]);

	return sAddr;
}

function getSum(sFld, sWhere)
{
	if(!sFld)
		sFld = "FSUM";
	if(!sWhere)
		sWhere = "FTT='SUM'"
	var oSnap = getSnap("select sum("+ sFld +") from "+ tblOut +" where "+ sWhere);
	if(oSnap && Number(oSnap[0]))
		return round(oSnap[0], getPar("DECISUM"));
	return 0;
}

function listOnPrnList(tv)
{			
	tv.eval.addVar("DATE", getSDat());
	tv.eval.addVar("ADDR", getAddr());
	
	var tPrn = OpenTable("s", "select * from "+ tblOut 
				+" where FTT='SUM'");
	var arrFld = getColumn(tblOut).split(",");
	for(var n=0; n<arrFld.length; n++)
	{
		var sFld = arrFld[n];
		tv.eval.addVar(sFld, tPrn.getValue(sFld));
	}
}

function listMenuInit(ds)
{
	ds.AddMenuItem("LICSC", "Особові рахунки|Лицевые счета");
}

function listMenuRun(sID)
{
	if(sID=="LICSC")
	{
		var nmk = list.tbl.getValue("FNMK");
		var par = new Object();
		par.doc = "LICSC";
		par.nop = 0;
		par.subWhere = " FID_DOG in (select FID_DOG from ^SC_SERV where FNMKL="+ nmk +")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);		
	}
}

include("sys/DpList.js");