include ("Objects\\DpGetDat.js");
include ("oss_dat.js");
include ("oss_datb.js");
include ("calc_os.js");
include ("izvnprdt.js");
include ("izosdat.js");
include ("izosdatb.js");
include ("firstkv.js");
include ("sub\\mtr.js");
include ("objects\\DpGrid.js");

var label = "VIB";
var tmpTbl = "TMP_VIB";
var oSnap;
var dat1, dat2, buhuch, d1, d2;
var oItog;

function listLoad()
{
	list.accDel = null;
	list.objTotal.init(label);
	this.printLabel  = "VIB";
	list.par.menuMode = GetMenuMode();
	if(list.par.menuMode=="CALC")
	{
		var form = createForm(UR("Введіть данні для відбору інформації|Введите данные для отбора информации"));
		oItog = form.addItog(label,true);
		var D1=form.addObj("D1","date",UR("Дата початку періоду|Дата начала периода"));
		D1.setValue(getPar("GLOBDAT1"));
		var D2=form.addObj("D2","date",UR("Дата кінця періоду|Дата конца периода"));
		D2.setValue(getPar("GLOBDAT2"));
		var buh = form.addObj("buh", "bool", UR("Ведення бух.обліку|Ведение бух.учета"));
		buh.setValue(getPar("__BUHUCH"));
		form.show();
		if(form.escape == false)
		{
			setPar("GLOBDAT1", form.D1);
			setPar("GLOBDAT2", form.D2);
			dat1 = new Date(form.D1);
			dat2 = new Date(form.D2);
			buhuch = toScrObj(form.buh);
			DropTable(tmpTbl);
			
			//создадим таблицу в которую занесём период расчёта и булевое значение б/у
			//для использования при дальнейших вызовах просмотров
			ExecuteSQL("CREATE TABLE "+tmpTbl+" (Fdat1 "+sqlType("DATE")+", Fdat2 "+sqlType("DATE")+", Fbuh "+sqlType("BIT")+")")
			ExecuteSQL("INSERT INTO "+tmpTbl+" (Fdat1, Fdat2, Fbuh) VALUES("+sqlTo(dat1)+","+sqlTo(dat2)+","+sqlTo(buhuch)+")");
		}
		else
			return false;
	}
	else
	{
		if(!IsTable("VIB"))
		{
			alert(ru("Сперва выполните расчёт!","Спочатку виконайте розрахунок!"));
			return false;
		}
	}
}

function listMake()
{
	if(IsTable("VIB"))
		DropTable("VIB");
		
	if(IsTable("VIB"))
		return false;

	r_vib(new Date(dat1), new Date(dat2));
	list.objTotal.variantCur = oItog.getCod();
}

function listSrc()
{
	if(IsTable(tmpTbl))
	{
		oSnap = getSnap("SELECT Fdat1, Fdat2, Fbuh FROM "+tmpTbl);
		if( oSnap != null )
		{
			var captBuh = oSnap[2]?ru(" (бух.учет)"," (бух.облік)"):ru(" (налог.учет)"," (податк.облік)");
			list.title = "Реєстр вибуття ОЗ за перiод "+StrDat(oSnap[0], "DMY")+"-"+StrDat(oSnap[1], "DMY")+captBuh
						+"|Реестр выбытия ОС за период "+StrDat(oSnap[0], "DMY")+"-"+StrDat(oSnap[1], "DMY")+captBuh;
			d1 = oSnap[0];
			d2 = oSnap[1];
		}
	}
	list.qrySet("From", "VIB",
		"Order", "FINV_NUM",
		"Ptn", "REESTOT");
	list.subTie("OSNAZV", "x_osnazv", "Finv_num", "Finv_num");
	list.subTie("OS7", "os7", "INV_NUM", "Finv_num");
	addTtlTbl();
}

function listGrid()
{
	var oGrid = new DpGrid("NOCREATE");
	var nazv_group;

	with (oGrid)
	{
		onePageMode(false);
		
		var p = prefix();
		
		with(p)
		{
//			cell("Finv_num", "Iнв.N|Инв.N", 6);
			//var n = cell("x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");
		}
		//list.GroupPage(oGrid,p,0,false, n);
		with(page())
		{
//			cell("Finv_num", "Iнв.N|Инв.N", 6);
//			cell("x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");
			cell("Finv_num", "Iнв.N|Инв.N", 6);
			cell("x_osnazv.Ftxt", "Назва ОС|Название ОС", 20, "w");
			cell("Fgroup", "Гр.|Гр.", 4);
			cell("Fdat_post", "Дата\nприб.|Дата\nпост.", 8);
			cell("Fdat_vib","Дата\nвибуття|Дата\nвыбытия", 8);
			cell("Forig_all", "Перв. вартiсть\nна дату виб.|Перв. стоимость\nна дату выб.", 12, "", DP_FORMAT_SUM);
			cell("Fiznos","Знос на поч.кв.\nвиб.(перв.знос)|Износ на нач.кв.\nвыб.(перв.изн.)",13, "", DP_FORMAT_SUM);
			cell("Fsum_akt","Сума по актах\nвибуття|Сумма по актам\nвыбытия",13, null, DP_FORMAT_SUM, 2);
			cell("Fnds", "ПДВ|НДС",10, "", DP_FORMAT_SUM);
			cell("Fkol", "Кiл-сть|Кол-во", 7, "", DP_FORMAT_KOL);
			//cell("Fgroup", "Гр.|Гр.", 4);
			cell("=(^Forig_pric-^Fbalst)","Знос\nна дату виб.|Износ\nна дату выб.",13, "", DP_FORMAT_SUM);	
			cell("Fbalst","Балансова\nвартiсть|Балансовая\nстоимость",13, "", DP_FORMAT_SUM);
			cell("os7.Fvidos", "Код\nКОФ", 8);
			cell("Fdat_vib","Дата\nвибуття|Дата\nвыбытия", 8);
			//cell("Fkol", "Кiл-сть|Кол-во", 7);
			cell("Fcod_podr", "Підр.|Подр.", 6);
			cell("Ftabn", "МВО|МОЛ", 6);
		}
		build();
	}
}

function listOnPrnList(tv)
{
	if(dat1==null || dat2==null)
	{
		if(d1!=null && d2!=null)
		{
			dat1 = new Date(d1);
			dat2 = new Date(d2);
		}
		else
			return false;
	}
	var h = new Object();
	h.DAT_B = dat1.getVarDate();
	h.DAT_E = dat2.getVarDate();
	tv.setHTbl(h);	
}

function listMenuInit()
{
	list.dataSrc.AddMenuItem("SVER","Звiрка актiв лiкв.i змiн варт.|Сверка актов ликв. и изм.стоим.-просмотр");
}

function listMenuRun(ID)
{
	switch(ID)
	{
		case "SVER":
			var oPar = new Object();
			showWindow("l_svactl.js", SW_NOMODAL, oPar);
			break;
	}
}

function r_vib(dat1, dat2)
{
	var gS;
	var m = new Object();
	
   DatNewAm = new Date(1997,6,1);

   datind = new Date(getPar("DATIND"));

   cdat1 = sqlTo(dat1);
   cdat2 = sqlTo(dat2);

   DropTable("VIB");
   DropTable("T1");
   DropTable("TG0");
   DropTable("TG1");
   DropTable("TG2");
   DropTable("TG3");
   DropTable("TG4");
   DropTable("TG5");
   DropTable("TG6");
   DropTable("TG7");

//   var buhuch = getPar("__BUHUCH");

   D1 = new Date(dat1);
   D2 = new Date(dat2);

   rami = OpenTable("s", "RAMORTI");
//   rami.index = "RAMORTI";
//   if (SQL)
//		rami.index = "FKOMPL,FINV_NUM,FGROUP,FDATKV";

   rmi = OpenTable("s", "RAMI");
   rmi.index = "RAMI";
   if (SQL)
		rmi.index = "FKOMPL,FINV_NUM,FGROUP,FDATKV";

   os7 = OpenTable("s", "OS7");
   os7.index = "INV_NUM";
   if (SQL)
		os7.index = "FINV_NUM";

   CreateTable("VIB", "REESTR", "REESTR");

   var dat2011  = getPar("UOSDAT2011");
   
   strSQL = "select * from ^OS4 where Fdoc_dat>="+sqlTo(D1)+" and Fdoc_dat<="+sqlTo(D2)+" order by Finv_num, Fdoc_dat";
   os4 = OpenTable("s", strSQL);
   if (!os4.IsEmpty())
   {
      os4.MoveFirst();  
      while (!os4.IsEOF())
      {
         if (!os7.FindFirst("Finv_old ="+String(os4.getValue("Finv_num"))))
         {
       	 
          	m = new Object();
            //  vb.AddNew();
            m.Finv_num = os4.getValue("Finv_num");
            gS = getSnap ("select Fcod_podr,Fdoc_dat,Forig_pric,Fiznos,Fvidos from ^OS7 where Finv_num=" + sqlTo(os4.getValue("Finv_num")));
            if (gS != null)
            //if (os7.Seek("=", vs("Finv")))
            {
               m.Fcod_podr = gS[0];
               m.Fdat_post = gS[1];
               m.Fdat_vib = os4.getValue("Fdoc_dat");
               m.Forig_pric = gS[2];
               m.Fiznos = gS[3];
               m.Fvidos = gS[4];
            }
            else
            {
               m.Fcod_podr = 0;
               m.Fdat_post = null;
               m.Fdat_vib  = null;
               m.Forig_pric= 0;
               m.Fiznos    = 0;
               m.Fvidos    = 0;
            }
            m.Fcod_podr = izvnprdt(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "podr");
            m.Ftabn     = izvnprdt(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "tabn");
   
 
            //если была частичная ликвидация, то перв.стоимость брать на 
            // на пред дату от даты акта ликвидации
            datvib = sqlTo(os4.getValue("Fdoc_dat"));
            if (os4.getValue("Fall_licv")==false)
            {                       
				tdt2 = new Date(os4.getValue("Fdoc_dat"));
				tdt2 = new Date(tdt2-1);
            }
			else
			{ 
			    tdt2 = new Date(os4.getValue("Fdoc_dat"));
			}    
            						
            if (buhuch == false){
               mFgroup = izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "group");
               if(mFgroup==-100) mFgroup=0;
 
               mFprice = izosdat(tdt2, os4.getValue("Finv_num"), "orig_pric");
               if (mFprice==-100)
                  mFprice = izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_pric");
                  mFprice = (mFprice==-100)?0:mFprice;
               if (os4.getValue("Fkol") != 0)
               {
                  var mKol = Number(izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "kol"))*os4.getValue("Fkol");
                  if(mKol>0)
                  	mFprice = round(Number(izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_pric"))/mKol,2)
               }
               mForig_all = izosdat(tdt2, os4.getValue("Finv_num"), "orig_all");
               if (mForig_all==-100)
                  mForig_all = izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_all");
               mForig_all = (mForig_all==-100)?0:mForig_all;
               if (os4.getValue("Fkol")!=0	)
               {
                  var mKol = Number(izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "kol"))*os4.getValue("Fkol");
                  if(mKol>0)
	                  mForig_all = round(Number(izosdat(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_all"))/mKol,2)
               }
               var sum_izn = 0;
               if (differ(new Date(os4.getValue("Fdoc_dat")),dat2011)<0){                   
            	   if ((mFgroup==6 || mFgroup==7 || mFgroup==0) || (new Date(os4.getValue("Fdoc_dat")))<DatNewAm)
            	   {
            		   mFiznos = os4.getValue("Fizn_licv");
            	   }
            	   else
            	   {
            		   //найти дату начала пред.кв.
            		   tdt1 = new Date(firstkv(new Date(os4.getValue("Fdoc_dat"))));
            		   tdt1 = new Date(tdt1-1);
            		   tdt1 = firstkv(tdt1);
            		   if (differ(tdt1,DatNewAm)==0)                         
            			   //if (tdt1.getYear()==DatNewAm.getYear() && tdt1.getMonth()==DatNewAm.getMonth() && tdt1.getDate()==DatNewAm.getDate())
            		   {
            			   //износ = износу на конец пред.кв. по RAMORTI
            			   gS = getSnap("select Fiznos from ^RAMORTI where Fkompl=0 and Finv_num=" + sqlTo(vs.getValue("Finv"))+ " and Fgroup=" + mFgroup + " and Fdatkv=" + sqlTo(tdt1));
            			   if (gS != null)
            				   //if (rami.seek("=", 0, vs("Finv"), mFgroup, tdt1.getVarDate()))
            			   {
            				   mFiznos = Number(gS[0]);
            			   }
            			   else
            			   {
            				   mFiznos = 0;
            			   }
            			   if (os4.getValue("Fkol")!= 0)
            				   mFiznos = round(mFiznos/Number(izosdat(tdt1, os4.getValue("Finv_num"), "kol"))*os4.getValue("Fkol"),2)
            		   }
            		   else
            		   {
            			   mFiznos = 0;
            			   if (firstkv(new Date(os4.getValue("Fdoc_dat")))<datind)
            			   {
            				   gS = getSnap("select Flicv,Finv_num,Fiznos from ^RAMORTI where Fkompl=0 and Finv_num=" 
                                  			+ sqlTo(os4.getValue("Finv_num"))+ " and Fgroup=" + mFgroup 
                                  			+ " and Fdatkv=" + sqlTo(tdt1)+" and Flicv="+sqlTo(false));
            				   if (gS != null)
            					   mFiznos = Number(gS[2]);
            				   // if (rami.seek("=", 0, vs("Finv"), mFgroup, tdt1.getVarDate())){
            				   if (os4.getValue("Fkol")!= 0)
            				   {
            					   mFiznos = round(mFiznos/Number(izosdat(tdt1, os4.getValue("Finv_num"), "kol"))*os4.getValue("Fkol"),2)
            				   }
            				   else
            				   {
            					   //найти первоначальный износ, если нет в таблице расчета амортизации
            					   mFiznos = izosdat(m.Fdat_post, os4.getValue("Finv_num"), "iznos");
            					   if (os4.getValue("Fkol")!= 0)
            					   {
            						   mFiznos = round(mFiznos/Number(izosdat(m.Fdat_post, os4.getValue("Finv_num"), "kol"))*os4.getValue("Fkol"),2)
            					   }
            				   }
            			   }   
            			   else
            			   {
            				   //вставить текст
            				   dtlikv = firstkv(new Date(os4.getValue("Fdoc_dat")));
            				   if (dtlikv.getFullYear()==datind.getFullYear() && dtlikv.getMonth()==datind.getMonth() && dtlikv.getDate()==datind.getDate())
            				   {
            					   datind_1 = new Date(new Date(datind)-1);
            					   gS = getSnap("select Flicv,Finv_num,Fiznos from ^RAMI where Fkompl=0 and Finv_num=" 
                                  			+ sqlTo(os4.getValue("Finv_num"))+ " and Fgroup=" + mFgroup 
                                  			+ " and Fdatkv=" + sqlTo(tdt1)+" and Flicv="+sqlTo(false));
            					   if (gS != null)
            					   {
            						   mFiznos = Number(gS[2]);
            						   if (os4.getValue("Fkol")!=0)
            						   {
            							   if (izosdat(datind_1, os4.getValue("Finv_num"), "kol")!=0)
            								   mFiznos = round(mFiznos/izosdat(datind_1, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
            						   }
            					   }else{
            						   //найти первоначальный износ, если нет в таблице расчета амортизации
            						   mFiznos = izosdat(m.Fdat_post, os4.getValue("Finv_num"), "iznos");
            						   if (os4.getValue("Fkol")!=0)
            							   mFiznos = round(mFiznos/izosdat(m.Fdat_post, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
            					   }
            				   }else{
            					   //if (rmi.seek("=", 0, vs("Finv"), mFgroup, tdt1.getVarDate())){
            					   gS = getSnap("select Flicv,Finv_num,Fiznos from ^RAMI where Fkompl=0 and Finv_num=" 
                                  			+ sqlTo(os4.getValue("Finv_num"))+ " and Fgroup=" + mFgroup 
                                  			+ " and Fdatkv=" + sqlTo(tdt1)+" and Flicv="+sqlTo(false));
            					   if (gS != null)
            					   {
            						   mFiznos = Number(gS[2]);
            						   if (os4.getValue("Fkol")!=0)
            							   mFiznos = round(mFiznos/izosdat(tdt1, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
            					   }else{
            						   //найти первоначальный износ, если нет в таблице расчета амортизации
            						   mFiznos = izosdat(m.Fdat_post, os4.getValue("Finv_num"), "iznos");
            						   if (os4.getValue("Fkol")!=0)
            							   mFiznos = round(mFiznos/izosdat(m.Fdat_post, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
            					   }
            				   }
            			   }
            		   }
            	   }
            
            	   sum_akt = 0;
            	   if (mFgroup==1 || mFgroup==11) sum_akt= os4.getValue("Fsum_bal");
            	   if ((mFgroup>1 && mFgroup<=5) || mFgroup>=9)  sum_akt= os4.getValue("Fsum_real");
            	   if (mFgroup==6 || mFgroup==7 || mFgroup==0 || mFgroup==8)  sum_akt= os4.getValue("Fsum_real");
            	   if ((mFgroup>=2 && mFgroup<=5) || mFgroup>=9){
            		   balst =  os4.getValue("Fbalstrsch");
            	   }else{
            		   if (mFgroup==1 || mFgroup==11)
            			   balst  =  os4.getValue("Fsum_bal");
            		   else
            			   balst  =  os4.getValue("Forig_pric")-os4.getValue("Fizn_licv")
            	   }
                   m.Fizndat= mFprice-balst;            	   
               }else{
            	   //с 2011 года
                   ntdt1 = firstDayMonth(new Date(os4.getValue("Fdoc_dat")));
                   ntdt1 = new Date(ntdt1.getFullYear(),ntdt1.getMonth(), ntdt1.getDate()-1);
                   ntdt1 = firstDayMonth(ntdt1);

                   if (differ(firstDayMonth(new Date(os4.getValue("Fdoc_dat"))),dat2011)==0){ 
                      sum_izn = izosdat(dat2011, os4.getValue("Finv_num"), "iznos");
                   }else{
                      gs = getSnap("select Fiznos from ^RAMORIB where Finv_num="+sqlTo(os4.getValue("Finv_num"))+" and Fdatkv="+sqlTo(ntdt1)+" and Fampred=9")
                      if (gs!=null){
                    	  sum_izn  = Number(gs[0]) 
                      }else{
                    	  sum_izn  = izosdat(ntdt1, os4.getValue("Finv_num"), "iznos");
                      }    
                   }
				   if (os4.getValue("Fkol")!=0)
					   sum_izn  = round(sum_izn /izosdat(m.Fdat_post, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
					   
				   sum_akt = os4.getValue("Fizn_licv");
				   balst = mFprice-sum_akt
               }
               m.Fdatn = dat1.getVarDate();
               m.Fdatk = dat2.getVarDate();
               m.Fdat_vib = os4.getValue("Fdoc_dat");
               m.Forig_pric= mFprice;
               m.Forig_all= (mForig_all!=0)?mForig_all:mFprice;
               m.Fiznos= sum_izn;
               m.Fsum_akt= sum_akt;
               m.Fnds= os4.getValue("Fnds");
               m.Fkol= os4.getValue("Fkol");
               m.Fbalst= balst;
               //m.Fizndat= mFprice-balst;
               m.Fgroup= mFgroup;
               UpdateTable("VIB",m,true);                         

            }
            else
            {
           //реестр выбытия по бух.учету
          
               mFprice = izosdatb(tdt2, os4.getValue("Finv_num"), "orig_pric");
               if (mFprice==-100)
                   mFprice = izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_pric");
               mFprice = (mFprice==-100)?0:mFprice;
               if (Number(os4.getValue("Fkol"))!=0)
                    mFprice = round(izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_pric")/izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
               mForig_all = izosdatb(tdt2, os4.getValue("Finv_num"), "orig_all");
               if (mForig_all==-100)
                   mForig_all = izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_all");
               mForig_all = (mForig_all==-100)?0:mForig_all;
               if (os4.getValue("Fkol")!=0)
                   mForig_all = round(izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "orig_all")/izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
                   
           	   sum_pric = mFprice;
           	   sum_pric1= (mForig_all!=0)?mForig_all:mFprice;
        	   mFgroup = izosdatb(new Date(os4.getValue("Fdoc_dat")), os4.getValue("Finv_num"), "group");           	   
                   
               if (differ(new Date(os4.getValue("Fdoc_dat")),dat2011)<0){
            	   mFiznos = os4.getValue("Fizn_buh");
            	   sum_izn  = mFiznos;
            	   sum_akt  = 0;

            	   if(mFgroup==-100) mFgroup=0;
            	   if (mFgroup==1 || mFgroup==11) sum_akt= os4.getValue("Fsum_bal");
            	   if ((mFgroup>1 && mFgroup<=5) || mFgroup>=9)  sum_akt= os4.getValue("Fsum_real");
            	   if (mFgroup==6 || mFgroup==7 || mFgroup==0 || mFgroup==8)  sum_akt= os4.getValue("Fsum_real");

            	   balst = sum_pric1-sum_izn;
            	   sum_nds= os4.getValue("Fnds");
            	   kol    = os4.getValue("Fkol");
               }else{
            	   //с 2011 года
                   ntdt1 = firstDayMonth(new Date(os4.getValue("Fdoc_dat")));
                   ntdt1 = new Date(ntdt1.getFullYear(),ntdt1.getMonth(), ntdt1.getDate()-1);
                   ntdt1 = firstDayMonth(ntdt1);

                   if (differ(firstDayMonth(new Date(os4.getValue("Fdoc_dat"))),dat2011)==0){ 
                      sum_izn = izosdatb(dat2011, os4.getValue("Finv_num"), "iznos");
                   }else{
                      gs = getSnap("select Fiznos from ^RAMORIB where Finv_num="+sqlTo(os4.getValue("Finv_num"))+" and Fdatkv="+sqlTo(ntdt1)+" and Fampred=8")
                      if (gs!=null){
                    	  sum_izn  = Number(gs[0]) 
                      }else{
                    	  sum_izn  = izosdatb(ntdt1, os4.getValue("Finv_num"), "iznos");
                      }    
                   }
				   if (os4.getValue("Fkol")!=0)
					   sum_izn  = round(sum_izn/izosdatb(m.Fdat_post, os4.getValue("Finv_num"), "kol")*os4.getValue("Fkol"),2)
					   
				   sum_akt = os4.getValue("Fizn_buh");
            	   balst = sum_pric1-sum_akt;
            	   sum_nds= os4.getValue("Fnds");
            	   kol    = os4.getValue("Fkol");
               }   
               m.Fdatn = dat1.getVarDate();
               m.Fdatk = dat2.getVarDate();
               m.Fdat_vib = os4.getValue("Fdoc_dat");
               m.Forig_pric= sum_pric;
               m.Forig_all = sum_pric1;
               m.Fiznos= sum_izn;
               m.Fsum_akt= sum_akt;
               m.Fbalst= balst;
               m.Fkol= os4.getValue("Fkol");
               m.Fgroup= mFgroup;
               UpdateTable("VIB",m,true);                                              
            }
         }  
         os4.MoveNext();
      }
   }   
   vb = OpenTable("s", "VIB");
   if (vb.IsEmpty())
   {
      _alert("За данный период ОС не ликвидировались");
      vb.Close();
      return;
   }

   strSQL ="DELETE FROM VIB where Finv_num in (select b.Finv_num from ^OS4 b where b.Finv_num=VIB.Finv_num and b.Fdoc_dat=VIB.Fdat_vib and b.Fstorno="+sqlTo("+")+")";  
   ExecuteSQL(strSQL);

/*
   vb.MoveFirst();
   while (!vb.IsEOF()){
      strSQL = "select * from ^OS4 where Finv_num="+sqlTo(vb("Finv_num"))+" and Fdoc_dat="+sqlTo(vb("Fdat_vib"))
      tmp_os4 = OpenTable("s", strSQL);
      if (!tmp_os4.IsEmpty()){
         if (tmp_os4.getValue("Fstorno")=="+"){
            vb.Delete();
         }
      }
      vb.MoveNext();
   }

   if (SQL)
      vb.Requery();
*/
      
   vb.Close();


   if (IsTable("OSCMPL"))
   {
     ExecuteSQL("DELETE from OSCMPL", true);
   }
   else
   {
     strSQL = "CREATE TABLE OSCMPL (Fnumcmp "+SqlType("LONG")+", Ftxt "+SqlType("TEXT",100)+", Finv_num "+SqlType("LONG")+", Fdat "+SqlType("DATE")+")"
     ExecuteSQL(strSQL, true);

     strSQL = "CREATE INDEX OSCMPL ON OSCMPL (Fnumcmp, Finv_num)";
     ExecuteSQL(strSQL, true);
   }

  oscmp =  OpenTable("s", "OSCMPL");

  WAIT ("Сверка актов ликвидации с изм.ст.по б/у")

  oscmp = new Object();
  oscmp.Fnumcmp=6;
  oscmp.Finv_num=0;
  oscmp.Fdat=d00obj.getVarDate();
  oscmp.Ftxt="есть в актах ликвидации, отлич. от изм.ст.по б/у";
  UpdateTable("OSCMPL",oscmp,true);                                                

  //сверка актов ликвидации и OS0B
  //сначала находим неправильные записи по полной ликвидации 
  //есть в актах ликв., в изм.ст.по б/у нет или разные даты начала - полная ликвидация
  DropTable("LIKV4"); 
  strSQL = "select Finv_num, Fall_licv,Fdoc_dat into LIKV4 from ^OS4 a where (a.Fdoc_dat>="+sqlTo(D1)+ " and a.Fdoc_dat<="+sqlTo(D2)+") and not Finv_num in "+
           "(select Finv_num from ^OS0B b where a.Finv_num=b.Finv_num and a.Fdoc_dat=b.Fedat and "+
            " (b.Fkol=0 or b.Fkol1=0 or (b.Fkol1<>0 and b.Fkol=b.Fkol1)))" 
  ExecuteSQL(strSQL);

  //проверяем, не подходят ли они под частичную ликвидацию
  //отбор правильных записей по частичной ликвидации
  DropTable("LIKV5"); 
  strSQL = "select Finv_num, Fdoc_dat into LIKV5 from LIKV4 a where a.Fall_licv="+sqlTo("-")+" and Finv_num in "+
           "(select Finv_num from ^OS0B b where a.Finv_num=b.Finv_num and a.Fdoc_dat=b.Fbdat) ";
  ExecuteSQL(strSQL);
  //окончательный отбор неправильных записей
  DropTable("LIKV6"); 
  strSQL = "select 6 as Fnumcmp, ' ' as Ftxt, a.Finv_num, a.Fdoc_dat as Fdat into LIKV6 from LIKV4 a where not a.Finv_num in "+
           "(select b.Finv_num from LIKV5 b where a.Finv_num=b.Finv_num) ";
  ExecuteSQL(strSQL);
  strSQL = "INSERT INTO OSCMPL select * from LIKV6";
  ExecuteSQL(strSQL);

  WAIT ("Сверка актов ликвидации с изм.ст.по н/у")

  oscmp2 = new Object();
  oscmp2.Fnumcmp=7;
  oscmp2.Finv_num=0;
  oscmp2.Fdat=d00obj.getVarDate();
  oscmp2.Ftxt="есть в актах ликвидации, отлич. от изм.ст.по н/у";
  UpdateTable("OSCMPL",oscmp2,true);                                                  

  //сверка актов ликвидации и OS0
  //сначала находим неправильные записи по полной ликвидации 
  //есть в актах ликв., в изм.ст.по б/у нет или разные даты начала - полная ликвидация
  DropTable("LIKV7"); 
  strSQL = "select Finv_num, Fall_licv,Fdoc_dat into LIKV7 from ^OS4 a where (a.Fdoc_dat>="+sqlTo(D1)+ " and a.Fdoc_dat<="+sqlTo(D2)+") and not Finv_num in "+
           "(select Finv_num from ^OS0 b where a.Finv_num=b.Finv_num and a.Fdoc_dat=b.Fedat and "+
            " (b.Fkol=0 or b.Fkol1=0 or (b.Fkol1<>0 and b.Fkol=b.Fkol1)))" 
  ExecuteSQL(strSQL);

  //проверяем, не подходят ли они под частичную ликвидацию
  //отбор правильных записей по частичной ликвидации
  DropTable("LIKV8"); 
  strSQL = "select Finv_num, Fdoc_dat into LIKV8 from LIKV7 a where a.Fall_licv="+sqlTo("-")+" and Finv_num in "+
           "(select Finv_num from ^OS0 b where a.Finv_num=b.Finv_num and a.Fdoc_dat=b.Fbdat) ";
  ExecuteSQL(strSQL);
  //окончательный отбор неправильных записей
  DropTable("LIKV9"); 
  strSQL = "select 7 as Fnumcmp, ' ' as Ftxt, a.Finv_num, a.Fdoc_dat as Fdat into LIKV9 from LIKV7 a where not a.Finv_num in "+
           "(select b.Finv_num from LIKV8 b where a.Finv_num=b.Finv_num) ";
  ExecuteSQL(strSQL);
  strSQL = "INSERT INTO OSCMPL select * from LIKV9";
  ExecuteSQL(strSQL);

  oscmp3 = new Object();
  oscmp3.Fnumcmp=8;
  oscmp3.Finv_num=0;
  oscmp3.Fdat=d00obj.getVarDate();
  oscmp3.Ftxt="в списке изм.стоим.по н/у дата окончания отлич. от списка внутр.перем.";
  UpdateTable("OSCMPL",oscmp3,true);                                                    
}
include ("sys\\DpList.js");