// JScript source code
include("objects\\DpGetDat.js");
include("TrnNBln.js");
include("objects\\DpGrid.js");
include("objects\\DpSc.js");
include("objects\\DpCl.js");
include("objects\\DpObsl.js");
include("doc\\dpdocptn.js");




var ds,t;

var prnPatt = "PRVIP";
var editAcc = "";

var mfsc,mfsu,mfst,mfcl1,mfcl2,tdat1,tdat2;

var cItogCond = '=^Ftxt="NDB" or ^Ftxt="NCR"'
	+ ' or ^Ftxt="OBDB" or ^Ftxt="OBCR"'
	+ ' or ^Ftxt="KDB" or ^Ftxt="KCR"'


function listLoad()
{
	if (JAVA)
	{
		cItogCond = '=^Ftxt == "NDB" || ^Ftxt == "NCR"'
			+ ' || ^Ftxt == "OBDB" || ^Ftxt == "OBCR"'
			+ ' || ^Ftxt == "KDB" || ^Ftxt == "KCR"'
	}
	else
	{
		cItogCond = '=^Ftxt = "NDB" or ^Ftxt = "NCR"'
			+ ' or ^Ftxt="OBDB" or ^Ftxt = "OBCR"'
			+ ' or ^Ftxt = "KDB" or ^Ftxt = "KCR"'	
	}
	with( this )
	{
		subAsk = askParam;
		subSrc = infSrc;
		printLabel = "PRVIP";
		this.accDel = null;
		this.xmlGridFile = "r_vip.xml"
	}
	
	
	
	if (extPar==null)
		menumd = this.par.menuMode;
	else
		menumd = "R";
	
	if (menumd == "V")
		this.par.menuMode = "VIEW";
	else
		this.par.menuMode = "CALC";	
}

function askParam()
{
	var gd = new Object();
	if (extPar==null)
	{
		var gd=new DpGetDat("dDcutxyz0");			
		mfsc = gd.fsc;
		mfsu = gd.fsu;
		mfst = gd.fst;
		mfcl1 = gd.fcl1;
		mfcl2 = gd.fcl2;
		tdat1 = gd.dat1;
		tdat2 = gd.dat2;
	}
	else //extPar!=null
	{
		mfsc = extPar.psc;
		mfsu = extPar.psu;
		mfst = extPar.pst;
		mfcl1 = extPar.pcl1;
		mfcl2 = extPar.pcl2? extPar.pcl2: 0;
		tdat1 = extPar.pdat;
		tdat2 = extPar.pdat2;
		
		gd.escape = false;
	}
	
	return gd;
}

function listMake()
{
	var par,tbl,zm_sch,oop,strSQL,dopStr1,dopStr2;
	var dopzm1,dopzm2,dopzm3,dopzm4,dopzm5,doptab,dopzm1Spr,dopzm2Spr;

	DropTable("VIP");
	if (IsTable("VIP"))
	{
		 alert("Невозможно выполнить расчет."+"\nПроверьте, возможно окно с данным расчетом уже открыто,"+"\nили перезапустите систему.");
		//+ "\nВозможно окно с данным расчетом уже открыто");
		CloseWindow();
		return false;
	}

//	par=new Object();
//	tbl=new Object();
	zm_sch = new DpSc(mfsc,mfsu,mfst,mfcl1,mfcl2);
	oop = new DpObsl(zm_sch,tdat1,tdat2);
	dopStr1 = "";
	dopStr2 = "";
//		doptab=new Object();

	if (IsTable("VIP"))
		DropTable("VIP");
		
	CreateTable("VIP", "VIP", "*");

	if (mfsu != 0)
	{
		dopStr1 += " AND Fdb_su = " + sqlTo(mfsu);
		dopStr2 += " AND Fcr_su = " + sqlTo(mfsu);
	}
		
	if (mfst != 0)
	{
		dopStr1 += " AND Fdb_st = " + sqlTo(mfst);
		dopStr2 += " AND Fcr_st = " + sqlTo(mfst);
	}
		
	if (mfcl1!=0)
	{
		dopStr1 += " AND Fdb_cod1 = " + mfcl1;
		dopStr2 += " AND Fcr_cod1 = " + mfcl1;
	}
	
	if (mfcl2!=0)
	{
		dopStr1 += " AND Fdb_cod2 = " + mfcl2;
		dopStr2 += " AND Fcr_cod2 = " + mfcl2;
	}
	
	//фильтр на организацию
	var orgCond = "";
	if(getPar("BLNBYORG"))
		orgCond = " and Forg0="+CURRENT_ORG;
	
	strSQL =
		"INSERT INTO vip (Fdate,Fdocnum,Ftxt,fid_sch" 
			+ ", Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3"
			+ ", Fcr_sc, Fcr_su, Fcr_st, Fcr_cod1, Fcr_cod2, Fcr_cod3"
			+ ", Fsum, Fsumspr, Fdoc, Fnop, Fid_doc)"
			+ " SELECT Fdate,Fdocnum,Ftxt"
			+ ", fwid AS fid_sch"
			+ ", Fdb_sc, Fdb_su, Fdb_st, Fdb_cod1, Fdb_cod2, Fdb_cod3"
			+ ", Fcr_sc, Fcr_su, Fcr_st, Fcr_cod1, Fcr_cod2, Fcr_cod3"
			+ ", ^SCHET.Fsum*"+IIF("fvkurs<>0", "fvkurs", sqlRate("^SCHET"))+" AS Fsum"
			+ ", ^SCHET.Fsumspr*" + sqlRate("^SCHET","Fvalspr")
			+ " AS Fsumspr"
			+ ", Fdoc, Fnop, Fid_doc"
			+ " FROM ^SCHET "
			+ " WHERE  Fdate>="+sqlTo(tdat1)
			+ " AND Fdate<="+sqlTo(tdat2)
			+ " AND ((Fdb_sc="+sqlTo(mfsc)+dopStr1+") OR (Fcr_sc="+sqlTo(mfsc)+dopStr2+"))"
			+ orgCond;
	ExecuteSQL(strSQL);

	if (op_zakr(tdat1,tdat2))
	{
		strSQL =
				"INSERT INTO VIP (Fdate,Fdocnum,Ftxt,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,"
					+ "Fsum, Fsumspr, Fdoc,Fnop,Fid_doc)"
				+ "SELECT Fdate,Fdocnum,Ftxt,"
					+ " Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,"
					+ " Fcr_sc,Fcr_su,Fcr_st,fcr_cod1,"
					+ "^SCHET_ZR.Fsum*"+IIF("fvkurs<>0", "fvkurs",sqlRate("^SCHET_ZR"))+" AS Fsum,"
					+ "^SCHET_ZR.Fsumspr*"+sqlRate("^SCHET_ZR","Fvalspr")+" AS Fsumspr,"
					+" Fdoc,Fnop,Fid_doc"
				+ " FROM ^SCHET_ZR "
				+ " WHERE  Fdate>="+sqlTo(tdat1)+" AND Fdate<="+sqlTo(tdat2)
					+ " AND ((Fdb_sc="+sqlTo(mfsc)+dopStr1+") OR (Fcr_sc="+sqlTo(mfsc)+dopStr2+"))"
					+ orgCond;
			ExecuteSQL(strSQL);
	}

	//strSQL="ALTER TABLE VIP ADD Fsum2 double";
	//ExecuteSQL(strSQL);

	//strSQL="ALTER TABLE VIP ADD Fsum4 double";
	//ExecuteSQL(strSQL);

	//strSQL="CREATE INDEX fdate ON VIP(Fdate,Fdocnum)";
	//ExecuteSQL(strSQL);

	
	strSQL = "SELECT MAX(Fdate) AS FMAXDAT,MIN(Fdate) AS FMINDAT"+" FROM VIP";
	doptab = OpenTable("s",strSQL);
//-	if (!doptab.IsEmpty())
	if (doptab.getValue("Fmindat") != null)
	{
		dopzm3 = toScriptDate(doptab.getValue("Fmindat"));
		dopzm4 = toScriptDate(doptab.getValue("Fmaxdat"));
		dopzm3.setFullYear(dopzm3.getFullYear()-1);
		dopzm4.setFullYear(dopzm4.getFullYear()+1);
	}
	else
	{
		dopzm3 = d00min;
		dopzm4 = d00min;
	}			
					
	if (zm_sch.getVid() == "+")
	{
		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,Fsumspr,Fsum4,Fdocnum,"
				+"Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1, Fdb_cod2)"
			+ " VALUES ('NDB',"
				+ sqlTo(dopzm3)+","
				+ oop.dbSl1+","+oop.dbSl1+","
				+ oop.dbSl1Spr+","+oop.dbSl1Spr
				+ ",'1',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2) 
			+ ")";

		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1, Fdb_cod2)"
			+ " VALUES ('OBDB',"
				+ sqlTo(dopzm4)+","
				+ oop.dbOb+", 0,"
				+ oop.dbObSpr+", 0"
				+ ",'1',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1, Fcr_cod2)"
			+ " VALUES ('OBCR',"
				+ sqlTo(dopzm4)+","
				+ oop.crOb+","
				+ "0,"
				//+ oop.crOb+","
				+ oop.crObSpr+",0"
				+ ",'2',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+"Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1, Fdb_cod2)"
			+ " VALUES ('KDB',"
				+ sqlTo(dopzm4)+","
				+ oop.dbSl2+","+oop.dbSl2+","
				+ oop.dbSl2Spr+","+oop.dbSl2Spr
				+ ",'3',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);
	}
	else if (zm_sch.getVid() == "-")
	{
		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
			+" VALUES ('NCR',"
				+ sqlTo(dopzm3)+","
				+ oop.crSl1+","+(oop.dbSl1-oop.crSl1)+","
				+ oop.crSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
				+ ",'2',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
			+ " VALUES ('OBDB',"
				+ sqlTo(dopzm4)+","
				+ oop.dbOb+","
				+ "0,"
				//+oop.dbOb+","
				+ oop.dbObSpr+",0"
				+ ",'1',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
			+" VALUES ('OBCR',"
				+ sqlTo(dopzm4)+","
				+ oop.crOb+",0,"
				+ oop.crObSpr+",0"
				+ ",'2',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
			+ " VALUES ('KCR',"
				+ sqlTo(dopzm4)+","
				+ oop.crSl2+","+(-oop.crSl2)+","
				+ oop.crSl2Spr+","+(-oop.crSl2Spr)
				+ ",'4',"
				+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
				+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
			+ ")";
		ExecuteSQL(strSQL);
	}
	else if (zm_sch.getVid()=="*")
	{
		if (oop.dbSl1>0)
		{
			strSQL = "INSERT INTO VIP "
					+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
					+ " VALUES ('NDB',"
					+ sqlTo(dopzm3)+","
					+ oop.dbSl1+","+oop.dbSl1+","
					+ oop.dbSl1Spr+","+oop.dbSl1Spr
					+ ",'1',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+")";
			ExecuteSQL(strSQL);
		}
		else if (oop.crSl1>0)
		{
			strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('NCR',"
					+ sqlTo(dopzm3)+","
					+ oop.crSl1+","+(oop.dbSl1-oop.crSl1)+","
					+ oop.crSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
					+ ",'1',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
			ExecuteSQL(strSQL);
		}
		else
		{
			strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
				+ " VALUES ('NDB',"
					+ sqlTo(dopzm3)+","
					+ oop.dbSl1+","+(oop.dbSl1-oop.crSl1)+","
					+ oop.dbSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
					+ ",'1',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
			ExecuteSQL(strSQL);

			strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('NCR',"
					+ sqlTo(dopzm3)+","
					+ oop.crSl1+","+(oop.dbSl1-oop.crSl1)+","
					+ oop.crSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
					+ ",'2',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
			ExecuteSQL(strSQL);
		}

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
				+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
				+ " VALUES ('OBDB',"
					+ sqlTo(dopzm4)+","
					+ oop.dbOb+",0,"
					+ oop.dbObSpr+",0"
					+ ",'1',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('OBCR',"
					+ sqlTo(dopzm4)+","
					+ oop.crOb+",0,"
					+ oop.crObSpr+",0"
					+ ",'2',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		if (oop.dbSl2>0)
		{
			strSQL = "INSERT INTO VIP "
					+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
						+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
					+ " VALUES ('KDB',"
						+ sqlTo(dopzm4)+","
						+ oop.dbSl2+","+oop.dbSl2+","
						+ oop.dbSl2Spr+","+oop.dbSl2Spr
						+ ",'3',"
						+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
						+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
					+")";
			ExecuteSQL(strSQL);
		}
		else if (oop.crSl2>0)
		{
			strSQL = "INSERT INTO VIP "
					+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
						+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
					+ " VALUES ('KCR',"
						+ sqlTo(dopzm4)+","
						+ oop.crSl2+","+(-oop.crSl2)+","
						+ oop.crSl2Spr+","+(-oop.crSl2Spr)
						+ ",'4',"
						+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
						+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
					+ ")";
			ExecuteSQL(strSQL);
		}
		else
		{
			strSQL="INSERT INTO VIP "
					+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
						+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
					+ " VALUES ('KDB',"
						+ sqlTo(dopzm4)+","
						+ oop.dbSl2+","+oop.dbSl2+","
						+ oop.dbSl2Spr+","+oop.dbSl2Spr
						+ ",'3',"
						+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
						+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
					+ ")";
			ExecuteSQL(strSQL);

			strSQL = "INSERT INTO VIP "
					+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
						+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
					+ " VALUES ('KCR',"
						+ sqlTo(dopzm4)+","
						+ oop.crSl2+","+(-oop.crSl2)+","
						+ oop.crSl2Spr+","+(-oop.crSl2Spr)
						+ ",'4',"
						+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
						+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
					+ ")";
			ExecuteSQL(strSQL);
		}
			
	}
	else if(zm_sch.getVid()=="%")
	{
		strSQL = "INSERT INTO VIP "
			+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
					+ " VALUES ('NDB',"
					+ sqlTo(dopzm3)+","
					+ oop.dbSl1+","+(oop.dbSl1-oop.crSl1)+","
					+ oop.dbSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
					+ ",'1',"
					+ mfsc+","+mfsu+","
					+ mfst+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);
		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('NCR',"
					+ sqlTo(dopzm3)+","
					+ oop.crSl1+","+(oop.dbSl1-oop.crSl1)+","
					+ oop.crSl1Spr+","+(oop.dbSl1Spr-oop.crSl1Spr)
					+ ",'2',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
				+ " VALUES ('OBDB',"
					+ sqlTo(dopzm4)+","
					+ oop.dbOb+",0,"
					+ oop.dbObSpr+",0"
					+ ",'1',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('OBCR',"
					+ sqlTo(dopzm4)+","
					+ oop.crOb+",0,"
					+ oop.crObSpr+",0"
					+ ",'2',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fdb_sc,Fdb_su,Fdb_st,Fdb_cod1,Fdb_cod2)"
				+ " VALUES ('KDB',"
					+ sqlTo(dopzm4)+","
					+ oop.dbSl2+","+oop.dbSl2+","
					+ oop.dbSl2Spr+","+oop.dbSl2Spr
					+ ",'3',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);

		strSQL = "INSERT INTO VIP "
				+ "(Ftxt,Fdate,Fsum,Fsum2,FsumSpr,Fsum4,Fdocnum,"
					+ "Fcr_sc,Fcr_su,Fcr_st,Fcr_cod1,Fcr_cod2)"
				+ " VALUES ('KCR',"
					+ sqlTo(dopzm4)+","
					+ oop.crSl2+","+(-oop.crSl2)+","
					+ oop.crSl2Spr+","+(-oop.crSl2Spr)
					+ ",'4',"
					+ sqlTo(mfsc)+","+sqlTo(mfsu)+","
					+ sqlTo(mfst)+","+sqlTo(mfcl1)+","+sqlTo(mfcl2)
				+ ")";
		ExecuteSQL(strSQL);
	}
		
	
	BeginTransaction(4);
	//ExecuteSQL("UPDATE VIP set fsum2 = 0 where fsum2 is null");
	tbl = OpenTable("s", "select * from vip order by fdate, fdocnum, fid_doc");
		
	__patt(tbl, "SCHET");

	dopzm1 = oop.dbSl1 - oop.crSl1;
	dopzm1Spr = oop.dbSl1Spr - oop.crSl1Spr;
	var sTxt = "";
	while (!tbl.IsEOF())
	{
		sTxt = String(tbl.getValue("FTXT"));		
		
		if (sTxt == "NDB" || sTxt == "NCR" || sTxt == "OBDB"
			|| sTxt == "OBCR" || sTxt == "KDB" || sTxt == "KCR")
		{
			tbl.MoveNext();
			continue;
		}

		dopzm2 = Number(tbl.getValue("Fsum"));
		dopzm2Spr = Number(tbl.getValue("FsumSpr"));
		if(tbl.getValue("Fdb_sc")!=null && tbl.getValue("Fcr_sc")!=null)
		{
			tbl.Edit();
			if(Number(tbl.getValue("Fdb_sc")) == mfsc
					&& (mfsu==0 || Number(tbl.getValue("Fdb_su")) == mfsu)
					&& (mfst==0 || Number(tbl.getValue("Fdb_st")) == mfst)
					&& (mfcl1==0 || Number(tbl.getValue("Fdb_cod1")) == mfcl1)
					)
			{
				dopzm1 += dopzm2;
				dopzm1Spr += dopzm2Spr;
				tbl.setValue("Fsum2",dopzm1);
				tbl.setValue("Fsum4",dopzm1Spr);
				}
				
			if (Number(tbl.getValue("Fcr_sc")) == mfsc
					&& (mfsu==0 || Number(tbl.getValue("Fcr_su")) == mfsu)
					&& (mfst==0 || Number(tbl.getValue("Fcr_st")) == mfst)
					&& (mfcl1==0 || Number(tbl.getValue("Fcr_cod1")) == mfcl1)
					)
			{
				dopzm1 -= dopzm2;
				dopzm1Spr -= dopzm2Spr;
				tbl.setValue("Fsum2", dopzm1);
				tbl.setValue("Fsum4", dopzm1Spr);
			}
				
			tbl.Update();
		}
		
		tbl.MoveNext();
	}
	tbl.close(5652);
	CommitTrans();	
	doptab.close(5652);	
}

function listTitle()
{
	var sCapt = "Аналіз рахунку, субрахунку, статті за " 
					+ StrDat(tdat1,"DMY") + "-" + StrDat(tdat2,"DMY") 
					+ "|Анализ счета, субсчета, статьи за " 
					+ StrDat(tdat1,"DMY") + "-" + StrDat(tdat2,"DMY");
	return sCapt;
}

function infSrc()
{
	if (menumd == "V")
	{ 
		if (IsTable("VIP"))
		{
			tdat1 = getPar("GLOBDAT1");
			tdat2 = getPar("GLOBDAT2");
		}
		else
		{
			alert("Сначала произведите расчет отчётного баланса.");
			
			return false;
		}
	}
	
	
	this.dataSrc.addAccel(GA_CTRL, "D", "FIND_DOC");
	this.dataSrc.addAccel(GA_CTRL, "P", "CTRL-P");

	this.qrySet( 
		"From", "VIP",
		"Order","FDATE,FDOCNUM,FID_DOC",	//05.06.2012: +FID_DOC - если есть документы с одним номером и датой, из-за сортировки не правильно отображается остаток.
		"Ptn", "SCHET");
	grid.setSQLQueryCount(true);	
}

function listGrid1()
{
	var expr = "="+sqlSwitch("^Ftxt"
			, "NDB", "Початкове сальдо <Дб>|Начальное сальдо <Дб>"
			, "NCR", "Початкове сальдо <Кр>|Начальное сальдо <Кр>"
			, "OBDB", "Обiг по дебету|Оборот по дебету"
			, "OBCR", "Обiг по кредиту|Оборот по кредиту"
			, "KDB", "Сальдо на кiнець <Дб>|Сальдо на конец <Дб>"
			, "KCR", "Сальдо на кiнець <Кр>|Сальдо на конец <Кр>","^FTXT");
	
	with(new DpGrid("NOCREATE"))
	{
		defCond(cItogCond,"Itog");
		color(1,"Itog");
		bold("Itog");
		onePageMode(false);
		with(prefix())
		{
			
			with(alternate("Itog"))
			{
				FieldEx("","Дата|Дата",8);
				FieldEx("", "№ | №",6);
			}
			
			FieldEx("Fdate","Дата|Дата",8);
			FieldEx("Fdocnum", "№ | №",6);
		}
		with(page())
		{
			/*
			with(alternate("Itog"))
			{
				FieldEx(expr,"Зміст|Содержание",18,"w");
				with(group("Дебет|Дебет"))
				{
					with(group("Рах.|Сч."))
						cell("=CStr(^fdb_sc)+chr(10)+iif(^fdb_cod1=0, \"\", CStr(^fdb_cod1))", "Ан.1", 4, "w");
					with(group("С/р|С/с"))
						cell("=CStr(^fdb_su)+chr(10)+iif(^fdb_cod2=0, \"\", CStr(^fdb_cod2))", "Ан.2", 4, "w");
					with(group("Ст.|Ст."))
						cell("=CStr(^fdb_st)+chr(10)+iif(^fdb_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

					FieldEx("=sccltxt(CByte(int(^Fdb_sc/10)),^Fdb_sc,^Fdb_su,^Fdb_st, ^Fdb_cod1, ^Fdb_cod2, ^Fdb_cod3)", "Назва|Название", 12, "w");
				}
				with(group("Кредит|Кредит"))
				{
					with(group("Рах.|Сч."))
						cell("=CStr(^fcr_sc)+chr(10)+iif(^fcr_cod1=0, \"\", CStr(^fcr_cod1))", "Ан.1", 4, "w");
					with(group("С/р|С/с"))
						cell("=CStr(^fcr_su)+chr(10)+iif(^fcr_cod2=0, \"\", CStr(^fcr_cod2))", "Ан.2", 4, "w");
					with(group("Ст.|Ст."))
						cell("=CStr(^fcr_st)+chr(10)+iif(^fcr_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

					FieldEx("=sccltxt(CByte(int(^fcr_sc/10)),^fcr_sc,^fcr_su,^fcr_st, ^fcr_cod1, ^fcr_cod2, ^fcr_cod3)", "Назва|Название", 12, "w");
				}
				fieldEx('Fsum',  "Сума|Сумма", 8);
			}
			*/
			FieldEx(expr,"Зміст|Содержание",18,"w");
			with(group("Дебет|Дебет"))
			{
				with(group("Рах.|Сч."))
					cell("=CStr(^fdb_sc)+chr(10)+iif(^fdb_cod1=0, \"\", CStr(^fdb_cod1))", "Ан.1", 4, "w");
				with(group("С/р|С/с"))
					cell("=CStr(^fdb_su)+chr(10)+iif(^fdb_cod2=0, \"\", CStr(^fdb_cod2))", "Ан.2", 4, "w");
				with(group("Ст.|Ст."))
					cell("=CStr(^fdb_st)+chr(10)+iif(^fdb_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

				FieldEx("=sccltxt(CByte(int(^Fdb_sc/10)),^Fdb_sc,^Fdb_su,^Fdb_st, ^Fdb_cod1, ^Fdb_cod2, ^Fdb_cod3)", "Назва|Название", 12, "w");
			}
			with(group("Кредит|Кредит"))
			{
				with(group("Рах.|Сч."))
					cell("=CStr(^fcr_sc)+chr(10)+iif(^fcr_cod1=0, \"\", CStr(^fcr_cod1))", "Ан.1", 4, "w");
				with(group("С/р|С/с"))
					cell("=CStr(^fcr_su)+chr(10)+iif(^fcr_cod2=0, \"\", CStr(^fcr_cod2))", "Ан.2", 4, "w");
				with(group("Ст.|Ст."))
					cell("=CStr(^fcr_st)+chr(10)+iif(^fcr_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

				FieldEx("=sccltxt(CByte(int(^fcr_sc/10)),^fcr_sc,^fcr_su,^fcr_st, ^fcr_cod1, ^fcr_cod2, ^fcr_cod3)", "Назва|Название", 12, "w");
			}
			fieldEx('Fsum',  "Сума|Сумма", 8);
		}
		with(page())
		{
			/*
			with(alternate("Itog"))
			{
				FieldEx(expr,"Зміст|Содержание",18,"w");
			}
			*/
			FieldEx(expr,"Зміст|Содержание",18,"w");
			with(group("Дебет|Дебет"))
			{
				with(group("Рах.|Сч."))
					cell("=CStr(^fdb_sc)+chr(10)+iif(^fdb_cod1=0, \"\", CStr(^fdb_cod1))", "Ан.1", 4, "w");
				with(group("С/р|С/с"))
					cell("=CStr(^fdb_su)+chr(10)+iif(^fdb_cod2=0, \"\", CStr(^fdb_cod2))", "Ан.2", 4, "w");
				with(group("Ст.|Ст."))
					cell("=CStr(^fdb_st)+chr(10)+iif(^fdb_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

				FieldEx("=sccltxt(CByte(int(^Fdb_sc/10)),^Fdb_sc,^Fdb_su,^Fdb_st, ^Fdb_cod1, ^Fdb_cod2, ^Fdb_cod3)", "Назва|Название", 12, "w");
			}
			with(group("Кредит|Кредит"))
			{
				with(group("Рах.|Сч."))
					cell("=CStr(^fcr_sc)+chr(10)+iif(^fcr_cod1=0, \"\", CStr(^fcr_cod1))", "Ан.1", 4, "w");
				with(group("С/р|С/с"))
					cell("=CStr(^fcr_su)+chr(10)+iif(^fcr_cod2=0, \"\", CStr(^fcr_cod2))", "Ан.2", 4, "w");
				with(group("Ст.|Ст."))
					cell("=CStr(^fcr_st)+chr(10)+iif(^fcr_cod3=0, \"\", CStr(^fcr_cod3))", "Ан.3", 4, "w");

				FieldEx("=sccltxt(CByte(int(^fcr_sc/10)),^fcr_sc,^fcr_su,^fcr_st, ^fcr_cod1, ^fcr_cod2, ^fcr_cod3)", "Назва|Название", 12, "w");
			}
			fieldEx('FsumSpr',  "Сума дов.|Сумма спр.", 8);
			fieldEx('Fsum4',  "Зал. дов.|Ост. спр.", 8);
		}
		with(page())
		{
			FieldEx("Fdoc","Док.|Док.",5);
			FieldEx("Fnop","Опер.|Опер.",5);
			FieldEx("Fsum2","Залишок|Остаток",8);
		}
	
		build();		
	}
}


function getTblH()
{
	var ret = new Object();
	var sysname=getSysName();
	sysname=sysname.substring(sysname.lastIndexOf('|')+1, sysname.length);

	ret.FSC = extPar? extPar.psc: list.objAsk.fsc;
	ret.FSU = extPar? extPar.psu: list.objAsk.fsu;
	ret.FST = extPar? extPar.pst: list.objAsk.fst;
	ret.FCL1 = extPar? extPar.pcl1: list.objAsk.fcl1;
	ret.FCL2 = extPar? extPar.pcl2: list.objAsk.fcl2;
	ret.FD1 = new Date(tdat1).getVarDate();
	ret.FD2 = new Date(tdat2).getVarDate();

	return ret;
}

function listMenuInit()
{
	if (this.tbl.getValue("Fid_doc") != null)
		this.dataSrc.AddMenuItem("FIND_DOC","Пошук документа|Поиск документа");
	if (toScrObj(this.tbl.getValue("Fid_sch")))
		this.dataSrc.AddMenuItem("CTRL-P","Пошук проведення в журналі проведень|Поиск проводки в журнале проводок");	
}

function listMenuRun(szID)
{
	if (szID == "FIND_DOC")
	{
		if(this.tbl.getValue("Fid_doc") != null)
			FindDocument(this.tbl.getValue("Fdoc"), Number(this.tbl.getValue("Fnop")), this.tbl.getValue("Fid_doc"));
		return
	}
	else if(szID == "CTRL-P")
	{
		if(toScrObj(this.tbl.getValue("Fid_sch")))
		{
			var oPar = new Object();
			oPar.ret = new Object();
			oPar.ret.fwid = this.tbl.getValue("Fid_sch");
			showWindow("l_prov.js", SW_NOMODAL, oPar);
		}
	}
	else if(szID == "EDIT")
	{
		include("doc/DpDoc.js");
		var t = DataSource().getTable();
		if(t.isRecord() && (t.getValue("FTT")==null || allt(String(t.getValue("FDOC")))=="" ))
		{
			var oDoc = new DpDoc(t.getValue("fdoc"), t.getValue("fnop"));
			oDoc.edit("EDIT",t.getValue("fid_doc"))			
		}
	
	}
}

include("sys\\DpList.js")