include("servis/format.js");
include("servis/date.js");
//include("doc/DpDoc.js");
//расчет долгов на дату
function bill_debt(date, nClient, sTblDebt, viddog)
{	
	var sTblFrom = getRegTblName();
	if(!sTblFrom)
		return false;
	
	if(!viddog)
		viddog = 0;
		
	if(!sTblDebt)
		sTblDebt = "TMP_BILL_DEBT";
				
	if(!date)
		date = new Date();
	var d1 = new Date(date);		
	//d1 = new Date(firstDay(d1));
			
	var ssum = "sum("+ IIF("r.FDOC='BILL'", "r.FSUM", 0) +")";
	var ssumPay = "sum("+ IIF("r.FDOC='BILL'", 0, "r.FSUM") +")";	
	
	createBillTbl(sTblDebt);
	var sSQL = "insert into "+ sTblDebt 
				+" (FCLIENT, FID_DOG, FID_PACK, FNMKL, FSUM, FSUMPAY)"
			+" select r.FCLIENT, r.FID_DOG, r.FWID_CL, r.FNMKL, "+ ssum +", "+ ssumPay
			+" from ^"+ sTblFrom +" r "
				+" inner join ^BILDOG dog on dog.FID_DOG=r.FID_DOG "
			+" where dog.FVID_DOG="+ viddog
				+" and r.FEDATE<="+ sqlTo(d1)
				+ sqlw0And("r.FCLIENT=", nClient)
			+" group by r.FCLIENT, r.FID_DOG, r.FWID_CL, r.FNMKL"
	bRet = ExecuteSQL(sSQL);	 
	
	sSQL = "update "+ sTblDebt +" set FSUMPAY=0 where FSUMPAY is NULL";
	ExecuteSQL(sSQL);
	
	return bRet;
}

function createBillTbl(sTblName)
{
	if(!ExecuteSQL("drop table "+ sTblName, false))
		ExecuteSQL("delete from "+ sTblName, false)
	var sSQL = "create table "+ sTblName 
		+" (FCLIENT "+ SqlType("LONG") 
		+", FNMKL "+ SqlType("LONG")
		+", FID_PACK "+ SqlType("LONG")
		+", FID_DOG "+ SqlType("LONG")
		+", FGROUP "+ SqlType("INT")
		+", FVID_DOG "+ SqlType("INT")
		+", FPHONE "+ SqlType("LONG")
		+", FKOL "+ SqlType("DOUBLE")
		+", FUSEKOL "+ SqlType("DOUBLE")
		+", FCENA "+ SqlType("CURRENCY")
		+", FCENAOVER "+ SqlType("CURRENCY")
		+", FSUM "+ SqlType("CURRENCY")
		+", FSUMOVER "+ SqlType("CURRENCY")
		+", FSUMPAY "+ SqlType("CURRENCY")		
		+", FINCR "+ SqlType("CURRENCY")
		+", FDEBT "+ SqlType("CURRENCY")		
		+", FDATE "+ SqlType("DATE")	//дата начисления
		+", FEDATE "+ SqlType("DATE")	//дата когда начисл. становится долгом
		+", FPAYDAT "+ SqlType("DATE")	//дата оказания услуги
		+", FVID "+ SqlType("INT") +" default 0"	
		+", FSTATUS "+ SqlType("INT")		
		+", FWID "+ SqlType("COUNTER")
		+", FTT "+ SqlType("TEXT")
		+", FID_DOC "+ SqlType("LONG")
		+", FID_BIL "+ SqlType("LONG")
		+", FBILSYS "+ SqlType("INT")
		+", FISDEBT "+ SqlType("BIT") +" default "+ sqlFalse
		+")";
	return ExecuteSQL(sSQL, false);	
}

//имя таблицы с начислениями
function getRegTblName()
{		
	var sTblName = "RBILL";
	/*
	var jID = getPar("BILL_REG");	
	if(jID && jID.trim()!="")
		sTblName = getPath("UJ") +".UJ_"+ jID;	
		
	var sSql = "select * from ^"+ sTblName +" where 1<>1";
	if(!lpProxy.getDBManager().testSQL(sSql))
	{
		var sMsg = UR("Не налагоджений журнал реєстрації "
					+"|Не настроен журнал реестрации ")
					+ jID;
		alert(sMsg);
		return null;
	}
	*/	
	return sTblName;
}

//таблица связки начислений с документами
function getRelTblName()
{
	return getPath("MTR") +".MTR_RELBILL";;
}

//сальдо на дату по клиенту, договору
function getBalance(date, nClient, dogID)
{
	var balance = 0;
	
	var sTblFrom = getRegTblName();
	if(!sTblFrom)
		return balance;
	
	var sGroup = "";
	var sWhere = " where 1=1 ";		
	if(date)
	{
		//date = new Date(firstDay(new Date(date)));
		sWhere += " and FDATE<"+ sqlTo(date);
	}	
	if(nClient)
	{		
		sWhere += " and FCLIENT="+ sqlTo(nClient);
		sGroup = " group by FCLIENT";
	}
	if(dogID && dogID!="" && dogID!=" ")
	{
		sWhere += " and FID_DOG="+ sqlTo(dogID);
		sGroup = " group by FID_DOG";
	}
		
	var sSum = "sum("+ IIF("FDOC='BILL'", "FSUM", "-FSUM") +")";
	var oSnap = getSnap("select "+ sSum +" from ^"+ sTblFrom 
						+ sWhere
						+ sGroup
					, false);	
	if(oSnap)
		balance = Number(oSnap[0]);
	
	return balance;
}

//общий долг по дате, клиенту, договору
function getDebt(date, nClient, dogID)
{
	var nDebt = 0;
	
	var sTblFrom = getRegTblName();
	if(!sTblFrom)
		return nDebt;
	
	var sGroup = "";
	var sWhere = " where 1=1 ";		
	if(date)
	{
		//date = new Date(firstDay(new Date(date)));
		sWhere += " and FEDATE<="+ sqlTo(date);
	}	
	if(nClient)
	{		
		sWhere += " and FCLIENT="+ sqlTo(nClient);
		sGroup = " group by FCLIENT";
	}
	if(dogID && dogID!="" && dogID!=" ")
	{
		sWhere += " and FID_DOG="+ sqlTo(dogID);
		sGroup = " group by FID_DOG";
	}
		
	var sSum = "sum("+ IIF("FDOC='BILL'", "FSUM", "-FSUM") +")";
	var oSnap = getSnap("select "+ sSum +" from ^"+ sTblFrom 
						+ sWhere
						+ sGroup
					, false);	
	if(oSnap)
		nDebt = Number(oSnap[0]);
	
	return nDebt;
}

//сумма начислений/оплат за период
function billSum(dat1, dat2, nOrg, dogID, doc, nop)
{
	var sum = 0;
	
	var sTblFrom = getRegTblName();
	if(!sTblFrom)
		return sum;
	if(!doc)
	{
		doc = "PV";
		nop = getPar("BILL_PV");
	}
	var sGroup = "";
	var sWhere = " where UPPER(FDOC)="+ sqlTo(doc.toUpperCase());
	if(nop)
	{		
		sWhere += " and FNOP="+ sqlTo(nop);
	}	
	if(dat1)
	{		
		//dat1 = firstDay(new Date(dat1));
		if(!dat2)
			dat2 = lastDay(new Date(dat1));
		sWhere += " and FDATE>="+ sqlTo(dat1);
		sWhere += " and FDATE<="+ sqlTo(dat2);
	}	
	if(nOrg)
	{		
		sWhere += " and FCLIENT="+ sqlTo(nOrg);
		sGroup = " group by FCLIENT";
	}
	if(dogID && dogID!="" && dogID!=" ")
	{
		sWhere += " and FID_DOG="+ sqlTo(dogID);
		sGroup = " group by FID_DOG";
	}
		
	var sSum = "sum(FSUM) as FSUM";
	var oSnap = getSnap("select "+ sSum +" from ^"+ sTblFrom 
						+ sWhere
						+ sGroup
					, false);	
	if(oSnap)
		sum = Number(oSnap[0]);
	
	return sum;
}

//формирование NK
function formNK(date, nClient, dogID, vid, nmk, fid_doc, bAuto, bCorrect, bPrint)
{
	include("doc/DpDoc.js");
	
	var sDoc = "NK";
	var sTmpTbl = "TMP_BILL_NK";
	var sTblFrom = getRegTblName();
	var sRelTbl = getRelTblName();
	var doc_dat = new Date();
	if(date)
		doc_dat = new Date(date);
	if(fid_doc && !date)
	{
		var oSnap = getSnap("select FDATE from "+ sTblFrom 
							+" where FID_DOC="+ fid_doc);
		if(oSnap)
			date = new Date(oSnap[0]);
	}
	var d1 = new Date();
	var d2 = new Date();
	if(date)
	{
		d1 = firstDay(date);
		d2 = lastDay(date);
	}
	if((!date || !nClient) && !fid_doc && !bAuto)
	{
		include("Objects/DpGetDat.js");
		gd = new DpGetDat(new Array("r", "o0"));
		if(gd.escape)
			return false;
		if(!date)
			date = new Date();
		d1 = new Date(gd.dat1);
		d2 = new Date(gd.dat2);
		nClient = gd.forg;
		doc_dat = new Date(date);
	}	
		
    nClient = Number(nClient);	
    
    if(fid_doc && !bCorrect)
		bCorrect = isCorNakl(fid_doc, "RBILL");
    
	var nPrPos = 1;
	var sPrText = ru("Выгрузка данных...","Вивантаження даних...");
	//setProgressRange(0, 7);
	//setProgressPos(nPrPos++, sPrText);
	
	createBillTbl(sTmpTbl);			
	//setProgressPos(nPrPos++, sPrText);
	
	var sFvid = IIF("r.FVID=1 or r.FVID=2", 1, "r.FVID");
	var sUseKol = IIF("r.FUSEKOL>r.FKOL", "r.FUSEKOL-r.FKOL", 0);
	var sKol = IIF("r.FLIMIT="+ sqlTrue, sUseKol, "r.FKOL");
	sSQL = "insert into "+ sTmpTbl 
			+" (FID_DOC, FID_BIL, FCLIENT, FID_DOG, FBILSYS, FCENA, FNMKL, FKOL"
				+", FSUM, FINCR, FVID, FDATE, FPAYDAT, FGROUP) "
			+" select r.FID_DOC, r.FWID, r.FCLIENT, r.FID_DOG, d.FBILSYS, r.FCENA, r.FNMKL"
				+", "+ sKol +", r.FSUM, d.FINCR, "+ sFvid +", r.FDATE, r.FPAYDAT, d.FGROUP"
			+" from ^"+ sTblFrom +" r "				
				+" inner join ^BILDOG d on d.FID_DOG=r.FID_DOG"
			+" where r.FWID not in (select FID_RBIL from "+ sRelTbl +" where FDOC='NK')"
				+((bCorrect && fid_doc)? "" : " and r.FPAYDAT>="+ sqlTo(d1) +" and r.FPAYDAT<="+ sqlTo(d2))
				+" and r.FDOC='BILL'"
				//+(bTovar? "" : " and r.FVID<>4")
				+(vid? " and FVID in ("+ vid +")" : "")
				+ sqlw0And("r.FCLIENT=", nClient)
				+ sqlw0And("r.FID_DOC=", fid_doc)
				+ sqlw0And("r.FID_DOG=", dogID)
				+ sqlw0And("r.FNMKL=", nmk)
	ExecuteSQL(sSQL);
	//setProgressPos(nPrPos++, sPrText);

	var nNop = getPar("BILL_NK");
	var nNopCor = getPar("BILL_COR");	
	
	if(!nNop || (bCorrect && !nNopCor))
	{
		var sMsg = UR("Не встановлений параметр |Не установлен параметр ")
				+ (!nNop? UR("'Видаткові накладні'|'Расходные накладные'") : UR("'Коригування'|'Корректировки'"))
				+ ".\n"+ UR("Відкрити вікно для налагодження параметрів?|Открыть окно для настройки параметров?");
		var par = new Object();
		par.sel = "BILDOC";		
		if(confirm(sMsg))	
			showWindow("e_param.xml", SW_MODAL, par);
		
		if(!nNop)
			nNop = getPar("BILL_NK");
		if(!nNopCor)
			nNopCor = getPar("BILL_COR");
		
		if(!nNop || !nNopCor)
			return false;	
	}
	
	//если в договоре стоит нулевая группа, группируем договору, иначе - по группе
	var sGroupDog = IIF("FGROUP=0", "FID_DOG", "FGROUP");			
	var hTbl  = OpenTable("s","SELECT FCLIENT,FID_DOG,FGROUP,FVID,FPAYDAT "
							+" FROM ^"+ sTmpTbl 
							+" group by FCLIENT,"+ sGroupDog +",FVID,FPAYDAT");	
	if(hTbl.isEmpty())
	{
		hTbl.close();
		return false;
	}
	var oPar = new Object();		
	oPar.escape = false;
	var num = 1;	
	var sum = 0;
	
	nPrPos = 1;
	var nCount = hTbl.recordCount;
	sPrText = ru("Формирование накладных","Формування накладних");
	setProgressRange(0, nCount);
		
	for(hTbl.MoveFirst(); !hTbl.IsEOF(); hTbl.MoveNext())	
	{
		setProgressPos(nPrPos++, sPrText +": "+ num +"/"+ nCount);
		
		doc_dat = hTbl.getValue("FPAYDAT");
		oPar.Fid_dog = hTbl.getValue("FID_DOG");
		oPar.Fpost = hTbl.getValue("FCLIENT");
		//oPar.Fcalc = Fcalc;		
		oPar.Fnop  = nNop;
		if(bCorrect)
			oPar.Fnop  = nNopCor;		
		oPar.Fdate = doc_dat;
		oPar.Fdoc  = sDoc;
		oPar.escape = true;
		oPar.submode = "GETORDER";	
		oPar.nk_num = getNextNKNum("S1_DEC", "-");
		var group = Number(hTbl.getValue("FGROUP"));
		var whereDog = " FID_DOG="+ sqlTo(oPar.Fid_dog);
		if(group>0)
			whereDog = " FGROUP="+ sqlTo(group);
		oPar.tblFrom = OpenTable("s","select * from "+ sTmpTbl	
								+" where FCLIENT="+ sqlTo(oPar.Fpost)
									+" and "+ whereDog
									+" and FVID="+ sqlTo(hTbl.getValue("FVID"))
									+" and FPAYDAT="+ sqlTo(doc_dat)
								+" order by FNMKL");
		var oDoc = new DpDoc(sDoc, oPar.Fnop);				
		var sNum = getNextDocNum(oPar.Fid_dog, doc_dat, "NK");
		var bSave = saveDoc(oPar, oDoc, sNum, bCorrect);
       	if(bSave)	
		{				
			if(bPrint)
				printNK(oDoc.getID());				
			sum += Number(oDoc.getVar("HSUM"));
			num++;
		}			
		oPar.tblFrom.close();	
	}
	num--;			
	hTbl.close();					

	sum = round(sum, 2);
	setProgressPos(0);
	
	var sAlt = ru("Сформировано накладных: "+ num +"\n  на общую сумму: "+ sum
				,"Сформовано накладних: "+ num +"\n  на загальну суму: "+ sum);
	if(num!=0)
		alert(sAlt);
}

//формирование SF
function formSF(nNop, date, nClient, dogID, fid_doc, bPrint, bFormSFDebt, bFormKvitDebt, nmkDebtID)
{	
	include("doc/DpDoc.js");
	
	var sDoc = "SF";
	var sTmpTbl = "TMP_BILL_SF";
	var sTblFrom = getRegTblName();
	var sRelTbl = getRelTblName();
	var doc_dat = new Date();
	if(date)
	{
		doc_dat = new Date(date);
	}
	else if(fid_doc)
	{
		var oSnap = getSnap("select FDATE from ^"+ sTblFrom 
							+" where FID_DOC="+ fid_doc);
		if(oSnap)
			date = new Date(oSnap[0]);
	}
	var d1 = new Date();
	var d2 = new Date();
	if(date)
	{
		d1 = firstDay(date);
		d2 = lastDay(date);
	}
	if((!date || !nClient) && !fid_doc)
	{
		include("Objects/DpGetDat.js");
		gd = new DpGetDat(new Array("r","o0"));
		if(gd.escape)
			return false;
		date = new Date();
		d1 = gd.dat1;
		d2 = gd.dat2;
		nClient = gd.forg;
		doc_dat = new Date(date);
	}	
	
	if(!nNop)
	{
		nNop = getPar("BILL_SF");
	}
	
	if(!nNop)	
	{
		var par = new Object();
		par.ret = new Object();
		par.ret.Fdoc = null;
		par.ret.Fnop = null;
		par.ret.Fcalc= null;
	
		par.escape = true;
		par.doc = sDoc;
		par.mode = "DOCONLY";
		showWindow("l_cl_lnk.xml", SW_MODAL, par);
	
    	if (par.escape)
    		return;
    
    	sDoc = par.ret.Fdoc;
    	nNop = par.ret.Fnop;
    	Fcalc = par.ret.Fcalc;
	}  
	  		
	var nPrPos = 1;
	var sPrText = ru("Выгрузка данных...","Вивантаження даних...");
	//setProgressRange(0, 7);
	//setProgressPos(nPrPos++, sPrText);
	
	createBillTbl(sTmpTbl);			
	//setProgressPos(nPrPos++, sPrText);
	
	//превышение, абонплата и доп. услуги	
	var sUseKol = IIF("r.FUSEKOL>r.FKOL", "r.FUSEKOL-r.FKOL", 0);
	//var sKol = "sum("+ IIF("r.FLIMIT="+ sqlTrue, sUseKol, "r.FKOL") +")";
	var sKol = IIF("r.FLIMIT="+ sqlTrue, sUseKol, "r.FKOL");
	sSQL = "insert into "+ sTmpTbl 
				+" (FID_DOC, FID_BIL, FCLIENT, FID_DOG, FBILSYS, FCENA, FNMKL, FKOL, FSUM, FINCR, FGROUP) "
			+" select r.FID_DOC, r.FWID, r.FCLIENT, r.FID_DOG, d.FBILSYS, r.FCENA, r.FNMKL"
				+", "+ sKol +" as FKOL, r.FSUM, d.FINCR, d.FGROUP "
			+" from ^"+ sTblFrom +" r "
				//+" inner join ^HBILL h on h.FWID=r.FID_DOC "
				+" inner join ^BILDOG d on d.FID_DOG=r.FID_DOG "
			+" where r.FDATE>="+ sqlTo(d1) +" and r.FDATE<="+ sqlTo(d2)
				+" and r.FWID not in (select FID_RBIL from "+ sRelTbl +" where FDOC='SF')"
				+" and r.FDOC='BILL'"
				//+" and r.FISSF="+ sqlFalse
				+ sqlw0And("r.FCLIENT=", nClient)
				+ sqlw0And("r.FID_DOG=", dogID)
				+ sqlw0And("r.FID_DOC=", fid_doc)
			//+" group by r.FCLIENT, r.FID_DOG, r.FCENA, r.FNMKL, d.FGROUP";
	var bRet = ExecuteSQL(sSQL);
	//setProgressPos(nPrPos++, sPrText);
	if(!bRet)
	{
		setProgressPos(0);
		return false;
	}
	
	if(bFormSFDebt || bFormKvitDebt)
	{
		//долги
		
		var sTblDebt = "TMP_BILL_DEBT";
		//var debtDat = goMonth(lastDay(date), -1);
		bill_debt(today, nClient, sTblDebt);
		
		if(bFormSFDebt)
		{
			sSQL = "insert into "+ sTmpTbl 
						+" (FID_DOC, FCLIENT, FID_DOG, FCENA, FNMKL, FKOL, FSUM, FISDEBT) "
					+" select "+ fid_doc +" as FID_DOC, d.FCLIENT, d.FID_DOG, sum(d.FSUM-d.FSUMPAY)"
						+", "+ nmkDebtID +", 1, sum(d.FSUM-d.FSUMPAY), "+ sqlTrue
					+" from "+ sTblDebt +" d "
						+" inner join ^BILDOG dog on dog.FID_DOG=d.FID_DOG "
					+" where d.FCLIENT in "
						+" (select r.FCLIENT from ^"+ sTblFrom +" r "
							+" where r.FDATE>="+ sqlTo(d1) +" and r.FDATE<="+ sqlTo(d2)
								+ sqlw0And("r.FCLIENT=", nClient) 
								+ sqlw0And("r.FID_DOC=", fid_doc) +")"
						+" and dog.FPRINT=0 "
					+" group by d.FCLIENT";
			ExecuteSQL(sSQL);
		}
		
		if(bFormKvitDebt)
		{
			sSQL = "insert into "+ sTmpTbl 
						+" (FID_DOC, FCLIENT, FID_DOG, FCENA, FNMKL, FKOL, FSUM, FISDEBT) "
					+" select "+ fid_doc +" as FID_DOC, d.FCLIENT, d.FID_DOG, sum(d.FSUM-d.FSUMPAY)"
						+", "+ nmkDebtID +", 1, sum(d.FSUM-d.FSUMPAY), "+ sqlTrue
					+" from "+ sTblDebt +" d "
						+" inner join ^BILDOG dog on dog.FID_DOG=d.FID_DOG "
					+" where d.FCLIENT in "
						+" (select r.FCLIENT from ^"+ sTblFrom +" r "
							+" where r.FDATE>="+ sqlTo(d1) +" and r.FDATE<="+ sqlTo(d2)
								+ sqlw0And("r.FCLIENT=", nClient) 
								+ sqlw0And("r.FID_DOC=", fid_doc) +")"
						+" and dog.FPRINT=1 "
					+" group by d.FCLIENT";
			ExecuteSQL(sSQL);
		}
		
		sSQL = "delete from "+ sTmpTbl +" where FSUM<0 or FSUM=0";
		ExecuteSQL(sSQL);		
	}
	setProgressPos(nPrPos++, sPrText);
	
	var sGroupDog = IIF("FGROUP=0", "FID_DOG", "FGROUP");		
	var hTbl  = OpenTable("s","SELECT FCLIENT, FID_DOG, FGROUP, FISDEBT"
							+" FROM ^"+ sTmpTbl 
							+" group by FCLIENT, FISDEBT, "+ sGroupDog
						);	
	if(hTbl.isEmpty())
	{
		hTbl.close();
		return false;
	}
	var oPar = new Object();		
	oPar.escape = false;
	
	var debtSF = 0;
	var debtSum = 0;
	var num = 1;	
	var sum = 0;
	
	nPrPos = 1;
	var nCount = hTbl.recordCount;
	sPrText = ru("Формирование счетов","Формування рахунків");
	setProgressRange(0, nCount);
	
	var sNum = "";
	var oDoc = new DpDoc(sDoc, nNop);	
	for(hTbl.MoveFirst(); !hTbl.IsEOF(); hTbl.MoveNext())	
	{
		setProgressPos(nPrPos++, sPrText +": "+ num +"/"+ nCount);				
		
		oPar.Fid_dog = hTbl.getValue("FID_DOG");
		oPar.Fpost = hTbl.getValue("FCLIENT");
		oPar.Fdate = doc_dat;
		oPar.Fdoc  = sDoc;
		oPar.Fnop  = nNop;														
		oPar.escape = true;
		oPar.submode = "GETORDER";
		var isDebt = hTbl.getValue("FISDEBT");
		oPar.isDebt = false;
		if(isDebt=="true" || isDebt=="1" || Number(isDebt)==1)
			oPar.isDebt = true;
		var group = Number(hTbl.getValue("FGROUP"));
		var whereDog = " FID_DOG="+ sqlTo(oPar.Fid_dog);
		if(group>0)
			whereDog = " FGROUP="+ sqlTo(group);
		oPar.tblFrom = OpenTable("s","select * from "+ sTmpTbl	
								+" where FCLIENT="+ sqlTo(oPar.Fpost)
									+" and "+ whereDog
									+" and FISDEBT="+ sqlTo(isDebt)
								+" order by FNMKL");
		sNum = getNextDocNum(oPar.Fid_dog, doc_dat, "SF");
		var bSave = saveDoc(oPar, oDoc, sNum);
       	if(bSave)	
		{				
			if(bPrint)
				printSF(oDoc.getID());	
			sum += Number(oDoc.getVar("HSUM"));
			num++;
			if(oPar.isDebt)
			{
				debtSum += Number(oDoc.getVar("HSUM"));
				debtSF++;				
			}
		}			
		oPar.tblFrom.close();	
	}
	hTbl.close();
	sum = round(sum, 2);
	debtSum = round(debtSum, 2);
	num--;	
		
	setProgressPos(0);
	
	var sMsg = ru("Сформировано счетов: "+ num +"\n   на общую сумму: "+ sum
				,"Сформовано рахунків: "+ num +"\n   на загальну суму: "+ sum);
	if(debtSF>0)
	{
		sMsg += "\n\n"+ ru("Из них за долги: "+ debtSF +"\n   на сумму: "+ debtSum
						,"З них за борги: "+ debtSF +"\n   на суму: "+ debtSum);
	}		
	if(num!=0 && sum!=0)
		alert(sMsg);
}

function getLnk(sDoc)
{
	var par = new Object();
	par.ret = new Object();
	par.ret.Fdoc = null;
	par.ret.Fnop = null;
	par.ret.Fcalc= null;
	
	par.escape = true;
	par.doc = sDoc;
	par.mode = "DOCONLY";
	showWindow("l_cl_lnk.xml", SW_MODAL, par);
	
    if (par.escape)
    	return null;
    
    return par.ret;
}

function saveDoc(par, oDoc, num, bCorrect)
{		
	if(!oDoc)
	{
		include("doc/DpDoc.js");
		oDoc = new DpDoc(par.Fdoc, par.Fnop);
	}
	else
	{
		oDoc.clear();
	}
		
	var Fmol = 0;
	var Fpodr = 0;
	
	var tbl = par.tblFrom;
	var dat = new Date(par.Fdate.getYear()+1900, par.Fdate.getMonth(), par.Fdate.getDate())	
	with(oDoc)
	{
		var month = Number(par.Fdate.getMonth())+1;
		var sNom = month;
		var oSnap = getSnap("select FDOG_NUM from ^CONTRACT where FWID="+ par.Fid_dog, false);

		if(oSnap && oSnap[0])
		{
			var dogNum = oSnap[0];
			dogNum = dogNum.split("/");
			sNom = dogNum[0] +"/"+ month;
			if(num && num!=0)
				sNom += "/"+ num;
			if(dogNum[1])
				sNom += "/"+ dogNum[1];			
		}
			
		setVar("HDOC", par.Fdoc)
		setVar("HOP", Number(par.Fnop))
		setVar("HNOM", sNom);
		setVar("HDAT", dat.getVarDate());
		setVar("HMOL", Fmol);
		setVar("HPODR", Fpodr);
		setVar("HPLCH", par.Fpost);
		setVar("HID_DOG", par.Fid_dog);		
		setVar("HP", oDoc.getPar("_pricetyp"));	
		setVar("HPN",oDoc.getPar("_priceuse"));			
	}
	
	if(par.isDebt)
		oDoc.setExt("ISDEBT", par.isDebt);
	
	num = 0;
	var kol = 0;
	var sum = 0;	
	var oRow;	
	var fnds = getPar("NDSPROC");
	
	for(tbl.moveFirst(); !tbl.isEOF(); tbl.MoveNext())
	{	
		var nKol = Number(tbl.getValue("Fkol"));		
		var nCena = Number(tbl.getValue("Fcena"));
		var nIncr = Number(tbl.getValue("FINCR"));
		if(nIncr)
		{	
			nCena += nCena*nIncr/100;
			nCena = round(nCena, 2);
		}
		var nSum = round(nKol * nCena, 2);	
		if(bCorrect)
		{
			nSum = Number(tbl.getValue("FSUM"));	
			nCena = nSum/nKol;			
		}
		if(nSum==0)
			continue;
		sum += nSum;
		kol += nKol;
		num++;
	
		oRow = oDoc.createRow("ROW");
		oDoc.appendRow("ROW", oRow);
		
		var nmk = tbl.getValue("Fnmkl");
				
		with(oRow)
		{
			setVar("R1ID",	 0);	
			setVar("RNOM",	 num);		
			setVar("RTYPE",	 "7");							
			setVar("RKOL",	 nKol);
			setVar("R1DAT",	 dat);
			setVar("RPCENE", nCena);
			setVar("ROCENA", nCena);		
			setVar("RFOCENA",nCena);
			setVar("RSUM", 	 nSum);		
			setVar("RTNMK",	 nmk);
			setVar("RPODR",	 oDoc.getVar("HPODR"));		
			setVar("RMOL",	 oDoc.getVar("HMOL"));
			setVar("RPOST",	 oDoc.getVar("HPOST"));
			setVar("RSC",	 0);
			setVar("RSU",	 0);
			setVar("RST",	 0);
			setVar("RSC1",	 0);
			setVar("RSU1",	 0);
			setVar("RST1",	 0);			
			setVar("REDI",	 0);
			setVar("RKOLSPR",0);			
		}	
		obj2DB(oRow.getID(), oRow.jDocRow, null, "ANLTK");
		
		saveRel(tbl.getValue("FID_BIL")
			   ,tbl.getValue("FID_DOC")
			   ,oDoc.getID()
			   ,oRow.getID()
			   ,oDoc.getVar("HDOC")
			   );		
	}

	if(sum==0)
	{
		delRel(0, 0, oDoc.getID(), 0);
		return false;
	}	
	//var fsnds = round(sum*fnds/100, getPar("DECISUM"));
	fsnds = 0;
	fnds = 0;
	
	oDoc.setVar("HPNDS", fnds);	
	oDoc.setVar("HSNDS", fsnds);
	oDoc.setVar("HPSUM", sum);
	oDoc.setVar("HSUM", sum);
	oDoc.setVar("HKOL", kol);	
	oDoc.setVar("HNR", num);
	if(par.nk_num)
		oDoc.setRegAttr("S1_DEC", "NK_NUM", String(par.nk_num));	
	var bRet = oDoc.save(true, "ADD");
	if(bRet)
		oDoc.saveExtToDB();
	else
		delRel(0, 0, oDoc.getID(), 0);
	return bRet;
}

//сохранить связь RBILL с документом (построчно)
function saveRel(fid_rbil, fid_bil, fid_doc, fid_row, fdoc)
{
	if(!fid_bil)
		return false;
	if(!fid_row)
		fid_row = 0;
	var sSql = "insert into "+ getRelTblName() +" (FID_RBIL, FID_BIL, FID_DOC, FID_ROW, FDOC) "
			+" values ("+ fid_rbil +", "+ fid_bil +", "+ fid_doc +", "+ fid_row +","+ sqlTo(fdoc) +")";
	return ExecuteSQL(sSql);
}

//сохранить FWID корректировки
function saveCor(fid_cor, fid_bil, fid_rbil, fid_doc)
{
	if(!fid_cor)
		return false;
	var sWhere = "";
	if(fid_doc)
		sWhere = " FID_DOC in ("+ fid_doc +")";
	else if(fid_rbil)
		sWhere = " FID_RBIL in ("+ fid_rbil +")";
	else if(fid_bil)
		sWhere = " FID_BIL="+ fid_bil;
	else
		return false;
	var sSql = "update "+ getRelTblName() 
					+" set FID_COR="+ fid_cor 
				+" where "+ sWhere;					
	return ExecuteSQL(sSql);
}

//удалить связь RBILL с документом
function delRel(fid_rbil, fid_bil, fid_doc, fid_row)
{	
	var sSql = "delete from "+ getRelTblName()
				+" where 1=1 "
				+ sqlw0And("FID_RBIL=", fid_rbil)
				+ sqlw0And("FID_BIL=", fid_bil)
				+ sqlw0And("FID_DOC=", fid_doc)
				+ sqlw0And("FID_ROW=", fid_row);
	return ExecuteSQL(sSql);
}

//формирование начислений на дату
function make_bill(sBillTbl, date, dog, org, nmk, vid, vidDog, bFiltr, inclSingleServ)
{		
	if(!date)
		date = new Date();
	else
		date = new Date(date);
	if(!sBillTbl)
		sBillTbl = "TMP_BILL";
	var sRegTbl = getPath("MTR") +".MTR_"+ getRegTblName();
	
	//если вид услуги не указан отбираем только ежемесячные услуги
	if(!vid)
		vid = "1,2";
	
	trace("\n<<<<<<<<<<<< ФОРМИРОВАНИЕ НАЧИСЛЕНИЙ НА ДАТУ "+ StrDat(date, "DMY") +" >>>>>>>>>>>>>>");					
	if(!ExecuteSQL("drop table "+ sBillTbl, false))
		ExecuteSQL("delete from "+ sBillTbl, false);
	CreateTable(sBillTbl, "RBILL");
	
	var bDatUse = new Date(goMonth(date, -1));
	bDatUse = new Date(firstDay(bDatUse));
	var eDatUse = new Date(lastDay(bDatUse));
	var sUseKol = "(select max(FKOL) from ^RRU r "
			+" where r.FCLIENT=c.FORG "
				+" and r.FID_DOG=d.FID_DOG "
				+" and r.FNMKL=s.FNMKL"
				//+" and r.FPHONE=p.FPHONE" 
				+" and r.FDATE>="+ sqlTo(bDatUse)
				+" and r.FDATE<="+ sqlTo(eDatUse) 
				+")";
	var sSum = 0;		
	
	var sFiltr = "";	
	
	//превышение
	var payDat = billDate(date, 1, true);
	var oBDate = new Date(firstDay(payDat));
	var oEDate = new Date(lastDay(payDat));
	if(bFiltr)
	{
		sFiltr = " and p.FWID_CL "
				+" not in (select FWID_CL from "+ sRegTbl 
					+" where FVID in (1,2) "
						+" and FLIMIT="+ sqlTrue
						+" and FPAYDAT>="+ sqlTo(oBDate) 
						+" and FPAYDAT<="+ sqlTo(oEDate)
						//+ sqlw0And("FID_DOG=", dog)
						//+ sqlw0And("FCLIENT=", org)
						//+ sqlw0And("FNMKL=", nmk) 
						+" and FID_DOG=c.FWID "
						+" and FCLIENT=c.FORG "
						+" and FNMKL=s.FNMKL "
					+")"				
	}
	var sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FBILSYS,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,d.FBILSYS,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR"
				+","+ sqlRound(sUseKol, 0) +","+ sSum +",p.FBDAT,p.FEDAT "
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+" where s.FVID in ("+ vid +")"
				+" and s.FLIMIT="+ sqlTrue
				+" and d.FBILSYS=0"
				+ sqlw0And("c.FWID=", dog)
				+ sqlw0And("c.FORG=", org)
				+ sqlw0And("s.FNMKL=", nmk)
				+ sqlw0And("d.FVID_DOG=", vidDog)
				+" and (p.FBDAT<="+ sqlTo(oEDate) +" and p.FEDAT>="+ sqlTo(oBDate) +")"
				+" and ((c.FBDAT<="+ sqlTo(oBDate) +" and c.FEDAT>="+ sqlTo(oEDate) +")"
			   		+" or (c.FBDAT>="+ sqlTo(oBDate) +" and c.FBDAT<="+ sqlTo(oEDate) +")"
			   		+" or (c.FEDAT<="+ sqlTo(oEDate) +" and c.FEDAT>="+ sqlTo(oBDate) +"))"
			   	+ sFiltr
	//trace("\n>>> "+ sSql)
	ExecuteSQL(sSql);
		
	//абонплата и доп.услуги
	payDat = billDate(date, 1);
	oBDate = new Date(firstDay(payDat));
	oEDate = new Date(lastDay(payDat));
	if(bFiltr)
	{
		sFiltr = " and p.FWID_CL "
				+" not in (select FWID_CL from "+ sRegTbl 
					+" where FVID in ("+ vid +") "
						+" and FLIMIT<>"+ sqlTrue
						+" and FPAYDAT>="+ sqlTo(oBDate) 
						+" and FPAYDAT<="+ sqlTo(oEDate)
						+" and FID_DOG=c.FWID "
						+" and FCLIENT=c.FORG "
						+" and FNMKL=s.FNMKL "	
					 +")"				
	}
	var sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FBILSYS,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,d.FBILSYS,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR"
				+","+ sUseKol +","+ sSum +",p.FBDAT,p.FEDAT "
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+" where s.FVID in ("+ vid +")"
				+" and s.FLIMIT<>"+ sqlTrue
				+" and d.FBILSYS=0"
				+ sqlw0And("c.FWID=", dog)
				+ sqlw0And("c.FORG=", org)
				+ sqlw0And("s.FNMKL=", nmk)
				+ sqlw0And("d.FVID_DOG=", vidDog)
				+" and (p.FBDAT<="+ sqlTo(oEDate) +" and p.FEDAT>="+ sqlTo(oBDate) +")"
			   	+" and ((c.FBDAT<="+ sqlTo(oBDate) +" and c.FEDAT>="+ sqlTo(oEDate) +")"
			   		+" or (c.FBDAT>="+ sqlTo(oBDate) +" and c.FBDAT<="+ sqlTo(oEDate) +")"
			   		+" or (c.FEDAT<="+ sqlTo(oEDate) +" and c.FEDAT>="+ sqlTo(oBDate) +"))"
			   	+ sFiltr
	//trace("\n>>> "+ sSql)
	ExecuteSQL(sSql);
	
	//разовые услуги
	if(inclSingleServ)
	{
		vid = "3,4";
		//payDat = billDate(date, 3);
		payDat = goMonth(date, -1);
		oBDate = new Date(firstDay(payDat));		
		//oEDate = new Date(lastDay(payDat));
		oEDate = goMonth(lastDay(date), 1);
		
		if(bFiltr)
		{
			sFiltr = " and p.FWID_CL "
					+" not in (select FWID_CL from "+ sRegTbl 
						+" where FVID in ("+ vid +") "
							+" and FPAYDAT=p.FBDAT"
							+" and FID_DOG=c.FWID "
							+" and FCLIENT=c.FORG "
							+" and FNMKL=s.FNMKL "	
						 +")"				
		}
		
		var sSql = "insert into "+ sBillTbl 
				+" (FCLIENT,FID_DOG,FBILSYS,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
					+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
				+" select c.FORG,d.FID_DOG,d.FBILSYS,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
					+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR"
					+","+ sUseKol +","+ sSum +",p.FBDAT,p.FEDAT "
				+" from ^CL_SERV s "
					+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
					+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
					+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
				+" where s.FVID in ("+ vid +")"
					+" and s.FLIMIT<>"+ sqlTrue
					+ sqlw0And("c.FWID=", dog)
					+ sqlw0And("c.FORG=", org)
					+ sqlw0And("s.FNMKL=", nmk)
					+ sqlw0And("d.FVID_DOG=", vidDog)
					+" and (p.FBDAT<="+ sqlTo(oEDate) +" and p.FBDAT>="+ sqlTo(oBDate) 
					+" and p.FEDAT>="+ sqlTo(d00) +")"
				   	+" and ((c.FBDAT<="+ sqlTo(oBDate) +" and c.FEDAT>="+ sqlTo(oEDate) +")"
				   		+" or (c.FBDAT>="+ sqlTo(oBDate) +" and c.FBDAT<="+ sqlTo(oEDate) +")"
				   		+" or (c.FEDAT<="+ sqlTo(oEDate) +" and c.FEDAT>="+ sqlTo(oBDate) +"))"
				   	+ sFiltr
		//trace("\n>>> "+ sSql)
		ExecuteSQL(sSql);
	}
	
	//кредитная система
	var payDat = billDate(date, 1, true, true);
	var oBDate = new Date(firstDay(payDat));
	var oEDate = new Date(lastDay(payDat));
	if(bFiltr)
	{
		sFiltr = " and p.FWID_CL "
				+" not in (select FWID_CL from "+ sRegTbl 
					+" where FVID in (1,2) "						
						+" and FPAYDAT>="+ sqlTo(oBDate) 
						+" and FPAYDAT<="+ sqlTo(oEDate)						
						+" and FID_DOG=c.FWID "
						+" and FCLIENT=c.FORG "
						+" and FNMKL=s.FNMKL "
					+")"				
	}
	sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FBILSYS,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,d.FBILSYS,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR"
				+","+ sqlRound(sUseKol, 0) +","+ sSum +",p.FBDAT,p.FEDAT "
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+" where s.FVID in (1,2)"				
				+" and d.FBILSYS=1"
				+ sqlw0And("c.FWID=", dog)
				+ sqlw0And("c.FORG=", org)
				+ sqlw0And("s.FNMKL=", nmk)
				+ sqlw0And("d.FVID_DOG=", vidDog)
				+" and (p.FBDAT<="+ sqlTo(oEDate) +" and p.FEDAT>="+ sqlTo(oBDate) +")"
				+" and ((c.FBDAT<="+ sqlTo(oBDate) +" and c.FEDAT>="+ sqlTo(oEDate) +")"
			   		+" or (c.FBDAT>="+ sqlTo(oBDate) +" and c.FBDAT<="+ sqlTo(oEDate) +")"
			   		+" or (c.FEDAT<="+ sqlTo(oEDate) +" and c.FEDAT>="+ sqlTo(oBDate) +"))"
			   	+ sFiltr	
	ExecuteSQL(sSql);
	
	trace("<<<<<<<<<<<< ФОРМИРОВАНИЕ НАЧИСЛЕНИЙ НА ДАТУ "+ StrDat(date, "DMY") +" >>>>>>>>>>>>>>\n");
	
	return true;
}

function getBillCena(tbl, payDat)
{
	var cena = Number(tbl.getValue("fcena"));
	if(!cena)
		return 0;
	//расчет для неполного месяца по количеству дней
	var flimit = tbl.getValue("flimit");
	var fvid = Number(tbl.getValue("fvid"));	
	var bDatPack = new Date(tbl.getValue("FDATE"));
	var eDatPack = new Date(tbl.getValue("FEDATE"));
	if(dayInPeriod(bDatPack, payDat) || dayInPeriod(eDatPack, payDat))
	{
		var kDay = getDayKoef(fvid, bDatPack, eDatPack, payDat); 
		if(kDay>0 && (flimit!=true && flimit!="true"))
			cena = cena*kDay;
	}
	return cena;	
}

//сумма начислений по номенклатуре
function getBillSum(tbl, payDat)
{				
	var fsum = Number(tbl.getValue("fsum"));
	var fcena = Number(tbl.getValue("fcena"));	
	var fkol = Number(tbl.getValue("fkol"));
	var fekol = Number(tbl.getValue("fekol"));
	var fusekol = Number(tbl.getValue("fusekol"));	
	var fincr = Number(tbl.getValue("fincr"));
	var flimit = tbl.getValue("flimit");
	var fvid = Number(tbl.getValue("fvid"));

	var nSum = fcena*fkol;
	//для расчета превышения берётся цена диапазона
	if(flimit==true || flimit=="true")
	{
		nSum = 0;
		if(fusekol>fkol && (fusekol<fekol || fekol==0))
			nSum = (fusekol-fkol)*fcena;
	}
	
	//надбавка из договора
	if(fincr)	
		nSum += nSum*fincr/100;	
	
	//для нового пакета абонплату на текущий месяц рассчитываем по дням
	var kDay = 0;
	var bDatPack = new Date(tbl.getValue("FDATE"));
	var eDatPack = new Date(tbl.getValue("FEDATE"));
	if(dayInPeriod(bDatPack, payDat) || dayInPeriod(eDatPack, payDat))
	{
		kDay = getDayKoef(fvid, bDatPack, eDatPack, payDat); 
		if(kDay>0 && (flimit!=true && flimit!="true"))
			nSum = nSum*kDay;
	}
	trace(">>>\ngetBillSum: \nnSum - "+ nSum +"\nkDay - "+ kDay +"\nfcena - "+ fcena +"\nfusekol - "+ fusekol +"\nfkol - "+ fkol +"\nfvid - "+ fvid +"\nflimit - "+ (flimit) +"\npayDat - "+ StrDat(payDat, "DMY") +"\nbDatPack - "+ StrDat(bDatPack, "DMY") +"\neDatPack - "+ StrDat(eDatPack, "DMY") +"\n>>>");	
	return round(nSum, 2);
}

//проверяет попадает ли дата date в период [dat1,dat2]
function dayInPeriod(date, dat1, dat2)
{
	if(!date || !dat1)
		return false;
	date = new Date(date);
	dat1 = new Date(dat1);
	dat1 = new Date(firstDay(dat1));
	if(!dat2)
		dat2 = lastDay(dat1);
	dat2 = new Date(dat2);
	//trace("\n"+ StrDat(date, "DMY") +" > "+ StrDat(dat1, "DMY") +" : "+ StrDat(dat2, "DMY") +" = "+ (differ(dat1, date)!=differ(dat2, date)) +"\n")
	if(differ(dat1, date)!=differ(dat2, date))
		return true;
	return false;
}

//коэфициент учитывающий количество дней, которые попадают в расчет
function getDayKoef(fvid, bdat, edat, bilDat)
{
	var koef = 1;
	var nDay = getDayDif(bdat, edat, bilDat); 
	if(nDay>0 && bilDat && (Number(fvid)==1 || Number(fvid)==2))
	{
		var fullDays = Number(getDaysInMonth(new Date(bilDat)));
		koef = nDay/fullDays;
	}
	return koef;
}

//разница в днях между датами
function getDayDif(bdat, edat, bilDat)
{
	var nDay = 0;
	if(!bdat)
		bdat = new Date();
	if(!edat || differ(edat, new Date(d00))==0)
		edat = lastDay(bdat);	
	if(bilDat)
	{
		bilDat = new Date(bilDat);
		var d1 = new Date(firstDay(bilDat));
		var d2 = new Date(lastDay(bilDat));
		//если начальная дата меньше даты расчета берем дату расчета
		if(differ(bdat, d1)<0)
			bdat = d1;
		//если дата расчета меньше конечной даты берем дату расчета
		if(differ(d2, edat)<0)
			edat = d2;
	}	
	if(bdat.getMonth()==edat.getMonth() && bdat.getYear()==edat.getYear())
		nDay = edat.getDate()-bdat.getDate()+1;
	return Number(nDay);
}

//разница между датами в целых месяцах
function getMonthKol(bDate, eDate)
{
	bDate = new Date(bDate);
	eDate = new Date(eDate);
	
	var nTotalDaysInBegMonth = getDaysInMonth(bDate); //кол-во дней в начальном месяце
	var nTotalDaysInEndMonth = getDaysInMonth(eDate); //кол-во дней в конечном месяце
	var nDaysInBegMonth = nTotalDaysInBegMonth - bDate.getDate() + 1; //кол-во дней в начальном месяце для оплаты
	var nDaysInEndMonth = oEDate.getDate(); //кол-во дней в конечном месяце для оплаты
	var nDays = day_difference(bDate, eDate);
		
	var nMonths = 12*eDate.getYear()+eDate.getMonth() 
				- (12*bDate.getYear()+bDate.getMonth());
	/*
	if(nMonths == 0)
	{
		//Разность 0 тот же месяц
		nSum = nTariff / nMonth / nTotalDaysInBegMonth * nDays;
	}
	else if(nMonths == 1)
	{
		//Разность 0 разные месяцы
		nSum = nTariff / nMonth
				* (1 / nTotalDaysInBegMonth * nDaysInBegMonth + 1 / nTotalDaysInEndMonth * nDaysInEndMonth);
	}
	else
	{
		nMonths--;
		//"Разность "+nMonths
		nSum = nTariff / nMonth
				* (1 / nTotalDaysInBegMonth * nDaysInBegMonth + 1 / nTotalDaysInEndMonth * nDaysInEndMonth + nMonths)
	}
	*/ 
	return nMonths;
}

//определяет договор по контрагенту и сумме
function billDog(org, sum)
{
	var dogID = 0;
		
	var oSnap = getSnap("select FID_DOG from ^SCH_ZAG "
						+" where FDOC='SF' "
							+" and FDBKR="+ sqlTo(org)
							+" and FSUM="+ sqlTo(sum)
						, false);
	if(oSnap)
		return Number(oSnap[0]);
	
	oSnap = getSnap("select p.FID_DOG from ^BIL_PACK p "
						+" inner join ^CONTRACT c on c.FWID=p.FID_DOG"
						+" where c.FORG="+ sqlTo(org)
							+" and c.FSUM_DOG="+ sqlTo(sum)
						, false);
	if(oSnap)
		return Number(oSnap[0]);	
	/*	
	oSnap = getSnap("select count(*) from ^BILDOG "
						+" where FCLIENT="+ sqlTo(org)
					, false);
	if(oSnap && Number(oSnap[0])!=1)
		return dogID;
		
	oSnap = getSnap("select FID_DOG from ^BILDOG "
						+" where FCLIENT="+ sqlTo(org)
					, false);
	if(oSnap)
		return Number(oSnap[0]);
	*/
	return dogID;
}

//определяет дату оказания услуги
function billDate(date, vid, limit, bCreditSys)
{	
	var retDate = new Date();
	if(date)
		retDate = new Date(date);
	if(!vid || vid=="" || Number(vid)==1 || Number(vid)==2)	//для ежемесячных и доп.услуг
	{	
		if(bCreditSys)	//кредитная система
			retDate = goMonth(retDate, -1);
		else if(limit==true || limit=="true" || limit=="1")	//превышение
			retDate = goMonth(retDate, -1);
		else	
			retDate = goMonth(retDate, 1);
		retDate = new Date(lastDay(retDate));		
	}	
	return retDate;
}

//дата долга
function getPayDat(date, vid)
{	
	var payDat = new Date();
	if(date)
		payDat = new Date(date);
	if(!vid || vid==1 || vid==2)
	{
		payDat = goMonth(payDat, 1);
		payDat = new Date(firstDay(payDat));
	}
	return payDat;
}

//запуск расчета реестра выданных налоговых накладных
function run_rnalv(par)
{
	if(!par)
		par = new Object();
	par.freg = "S1_DEC";
	par.fvid = "-";
	
	var oSnap = getSnap("select count(*) as cnt "
						+" from ^RAS_SCH "
						+" where FDOC='PV' and FORG=0");
	if(oSnap && Number(oSnap[0])>0)
	{
		var sMsg = UR("Знайдено "+ oSnap[0] +" оплат з невизначеним контрагентом. \nВідкрити список для редагування?"
					+"|Найдено "+ oSnap[0] +" оплат с неопределенным контрагентом. \nОткрыть список для редактирования?");
		if(confirm(sMsg))
		{
			par.doc = "PV";
			par.subWhere = "FORG=0";			
			setPar("GLOBDAT1", new Date(1900, 0, 01).getVarDate());
			setPar("GLOBDAT2", d00);				
			showWindow("bill_servis.js", SW_NOMODAL, par);
			return;
		}	
	}
	
	WAIT(UR("Перевірка реєстрації . . .|Проверка регистрации . . ."));
	var d1 = new Date(firstDay(goMonth(today, -1)));
	var d2 = new Date(lastDay(today));
	var oSnap = getSnap("select count(*) as cnt "
						+" from ^RAS_SCH s "
						+" where s.FWID not in (select m.HID_DOC from dpbase.MDOCREG m) "
							+" and s.FORG in (select rel.FCOD from ^CLRELCLCL rel "
								+" inner join ^CL cl on cl.FWID=rel.FWID_CL "
								+" inner join ^CL_POST p on p.FWID_CL=cl.FWID where p.FCAT=0) "
							+" and s.FNOP=1"
							+" and s.FDOC_DAT>="+ sqlTo(d1)
							+" and s.FDOC_DAT<="+ sqlTo(d2)
						);
	if(oSnap && Number(oSnap[0])>0)
	{
		var sMsg = UR("Знайдено "+ oSnap[0] +" незареєстрованих оплат. \nВідкрити список оплат для реєстрації?"
					+"|Найдено "+ oSnap[0] +" незарегистрированных оплат. \nОткрыть список оплат для регистрации?"
					);
		if(confirm(sMsg))
		{
			par.doc = "PV";			
			setPar("GLOBDAT1", d1.getVarDate());
			setPar("GLOBDAT2", d2.getVarDate());				
			showWindow("bill_servis.js", SW_NOMODAL, par);
			return;
		}	
	}
	CLEARWAIT();
	
	showWindow("r_rnalv.js", SW_NOMODAL, par);			
}

//формирование начислений по договору
function formBill(dogID, bAsk, bFormSF, bFormNK)
{			
	trace("\n<<<<<<<<<<<< ФОРМИРОВАНИЕ НАЧИСЛЕНИЙ ПО ДОГОВОРУ "+ dogID +" >>>>>>>>>>>>>>");
		
	var sRegTbl = getPath("MTR") +".MTR_"+ getRegTblName();
	
	//корректировка начислений по закрытым пакетам
	closeBillDog(dogID, bAsk);	
	/*	
	//начисления для новых пакетов	
	var oSnap = getSnap("select p.FWID_CL from ^BIL_PACK p "
						+" where p.FID_DOG="+ dogID
							+" and p.FEDAT>"+ sqlTo(new Date())
							+" and p.FWID_CL not in "
								+" (select FWID_CL from "+ sRegTbl 
									+" where FID_DOG="+ dogID +")");
	if(!oSnap)
		return;
	*/
	var sBillTbl = "TMP_BILL";
	/*
	if(!ExecuteSQL("drop table "+ sBillTbl, false))
		ExecuteSQL("delete from "+ sBillTbl, false);
	CreateTable(sBillTbl, "RBILL");	
	*/
		
	//начисления на прошлый месяц	
	/*
	var dat1 = firstDay(new Date());
	var dat2 = lastDay(new Date());	
	dat1 = goMonth(dat1, -1);
	dat2 = goMonth(dat2, -1);
	var sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR,0,0,p.FBDAT,p.FEDAT"
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+ " where c.FWID="+ dogID 
				//+" and s.FLIMIT<>"+ sqlTrue
				+" and p.FEDAT>="+ sqlTo(dat1)
			   	//+" and p.FBDAT>="+ sqlTo(dat1) 
			   	+" and p.FBDAT<="+ sqlTo(dat2)
			   	+" and p.FWID_CL not in (select FWID_CL from "+ sRegTbl 
									+" where FID_DOG="+ dogID 
										+" and FPAYDAT>="+ sqlTo(dat1) 
										+" and FPAYDAT<="+ sqlTo(dat2) +")";
	ExecuteSQL(sSql);
	*/
	var bilDate = goMonth(new Date(), -1);
	make_bill(sBillTbl, goMonth(new Date(), -2), dogID, 0, 0, "1,2", 0, true, true);
			
	var sMsg = UR("Сформувати нові нарахування|Сформировать новые начисления");
	if(bFormSF)
		sMsg += UR(" і рахунки| и счета");
	
	rowTbl = OpenTable("select * from "+ sBillTbl);
	if(!rowTbl.isEmpty())
	{		
		//var bilDate = new Date(rowTbl.getValue("FDATE"));
		if(!bAsk || (bAsk && confirm(sMsg +" на "+ tmonth(bilDate, 1) +"?")))
		{
			//bilDate = goMonth(bilDate, -1);
			var oDoc = saveBill(rowTbl, null, new Date(), bilDate, false, false);
			if(bFormSF)
				makeSF(oDoc && oDoc, new Date(), null, 0, true, false);
			if(bFormNK)
				makeNK(oDoc && oDoc, null, null, null, true);
			/*
			var oSnap = getSnap("select FDATE from "+ sBillTbl +" where FVID=3 or FVID=4");
			if(oSnap && oSnap[0])
			{
				var nkDate = new Date(oSnap[0]);
				makeNK(oDoc, nkDate, null, "3,4");
			}
			*/
		}		
	}
	rowTbl.close();	
		
	//начисления на текущий месяц	
	/*
	ExecuteSQL("delete from "+ sBillTbl);
	var dat1 = firstDay(new Date());
	var dat2 = lastDay(new Date());			
	var sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR,0,0,p.FBDAT,p.FEDAT"
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+ " where c.FWID="+ dogID 
				//+" and s.FLIMIT<>"+ sqlTrue
				+" and p.FEDAT>="+ sqlTo(dat1)
				+" and (((s.FVID=3 or s.FVID=4)"				
			   			+" and p.FBDAT>="+ sqlTo(dat1) 
			   			+" and p.FBDAT<="+ sqlTo(dat2) +") "
			   		+" or (s.FVID=1 or s.FVID=2)"
			   			+" and p.FBDAT<= "+ sqlTo(dat2) +")"			   	
			   	+" and p.FWID_CL not in (select FWID_CL from "+ sRegTbl 
									+" where FID_DOG="+ dogID 
										+" and FPAYDAT>="+ sqlTo(dat1) 
										+" and FPAYDAT<="+ sqlTo(dat2) +")";
	ExecuteSQL(sSql);
	*/
	bilDate = new Date();
	make_bill(sBillTbl, goMonth(new Date(), -1), dogID, 0, 0, "1,2", 0, true, true);
			
	rowTbl = OpenTable("select * from "+ sBillTbl);
	if(!rowTbl.isEmpty())
	{
		//var bilDate = new Date(rowTbl.getValue("FDATE"));
		if(!bAsk || (bAsk && confirm(sMsg +" на "+ tmonth(new Date(), 1) +"?")))
		{			
			var oDoc = saveBill(rowTbl, null, new Date(), new Date(), false, false);
			if(oDoc && bFormSF)
				makeSF(oDoc, new Date(), null, 0, true, false);
			if(oDoc && bFormNK)
				makeNK(oDoc, null, null, null, true);
			/*
			var oSnap = getSnap("select FDATE from "+ sBillTbl +" where FVID=3 or FVID=4");
			if(oSnap && oSnap[0])
			{
				var nkDate = new Date(oSnap[0]);
				makeNK(oDoc, nkDate, null, "3,4");
			}
			*/
		}		
	}
	rowTbl.close();		
	
	
	//начисления на след. месяц	
	/*
	make_bill(sBillTbl, new Date(), dogID, 0, 0, "1,2", 0, true);
	//разовые услуги на след. месяц	
	var dat1 = firstDay(new Date());
	dat1 = goMonth(dat1, 1);
	var dat2 = lastDay(new Date());	
	dat2 = goMonth(dat2, 1);	
	var sSql = "insert into "+ sBillTbl 
			+" (FCLIENT,FID_DOG,FNMKL,FKOL,FEKOL,FLIMIT,FVID,FCENA,FCENAOVER"
				+",FPHONE,FWID_CL,FINCR,FUSEKOL,FSUM,FDATE,FEDATE) "
			+" select c.FORG,d.FID_DOG,s.FNMKL,s.FKOL,s.FEKOL,s.FLIMIT,s.FVID"
				+",s.FCENA,s.FCENAOVER,p.FPHONE,s.FWID_CL,d.FINCR,0,0,p.FBDAT,p.FEDAT"
			+" from ^CL_SERV s "
				+" inner join ^BIL_PACK p on p.FWID_CL=s.FWID_CL "
				+" inner join ^BILDOG d on d.FID_DOG=p.FID_DOG "
				+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
			+ " where c.FWID="+ dogID 
				//+" and s.FLIMIT<>"+ sqlTrue				
				+" and (s.FVID=3 or s.FVID=4)"				
			   	//+" and p.FBDAT>="+ sqlTo(dat1) 
			   	+" and p.FBDAT<="+ sqlTo(dat2)
			   	+" and p.FEDAT>="+ sqlTo(dat1)
			   	+" and p.FWID_CL not in (select FWID_CL from "+ sRegTbl 
									+" where FID_DOG="+ dogID 
										+" and FPAYDAT>="+ sqlTo(dat1) 
										+" and FPAYDAT<="+ sqlTo(dat2) +")";
	ExecuteSQL(sSql);	
	*/
	make_bill(sBillTbl, new Date(), dogID, 0, 0, "1,2", 0, true, true);
	
	rowTbl = OpenTable("select * from "+ sBillTbl);
	if(!rowTbl.isEmpty())
	{
		//bilDate = new Date();
		bilDate = goMonth(new Date(), 1);
		//bilDate = new Date(rowTbl.getValue("FDATE"));		
		if(!bAsk || (bAsk && confirm(sMsg +" на "+ tmonth(goMonth(new Date(), 1), 1) +"?")))
		{
			//bilDate = new Date(rowTbl.getValue("FDATE"));
			//var oDoc = saveBill(rowTbl);			
			var oDoc = saveBill(rowTbl, null, new Date(), bilDate, false, false);
			if(oDoc && bFormSF)
				makeSF(oDoc, new Date(), null, 0, true, false);
			if(oDoc && bFormNK)
				makeNK(oDoc, null, null, null, true);
			/*
			var oSnap = getSnap("select FDATE from "+ sBillTbl +" where FVID=3 or FVID=4");
			if(oSnap && oSnap[0])
			{
				var nkDate = new Date(oSnap[0]);
				makeNK(oDoc, nkDate, null, "3,4");
			}
			*/
		}
	}
	rowTbl.close();
	
	trace("<<<<<<<<<<<< ФОРМИРОВАНИЕ НАЧИСЛЕНИЙ ПО ДОГОВОРУ "+ dogID +" >>>>>>>>>>>>>>\n");
}

//корректировка начислений по закрытым пакетам
function closeBillDog(dogID, bAsk)
{	
	//проверяем есть ли закрытые пакеты по которым сформированы начисления	
	var sRegTbl = getPath("MTR") +".MTR_"+ getRegTblName();
	var sPackTbl = getPath("MTR") +".BIL_BIL_PACK";
	var sRelTbl = getRelTblName();
	var bdat = firstDay(new Date());
	var edat = d00;
	var oSnap = getSnap("select FEDAT from ^CONTRACT where FWID="+ dogID);
	if(oSnap)
		edat = new Date(oSnap[0]);
		
	var sCorTbl = "TMP_BILL_COR";
	ExecuteSQL("drop table "+ sCorTbl, false);
	var sSQL = "select r.*, p.FBDAT, p.FEDAT "
				+" into "+ sCorTbl 
				+" from "+ sRegTbl +" r "
					+" inner join "+ sPackTbl +" p on p.FWID_CL=r.FWID_CL"
					+" where r.FDOC='BILL' "
						+" and r.FID_DOG="+ dogID
						+" and p.FID_DOG="+ dogID
						+" and r.FVID in (1,2)"
						+" and (r.FPAYDAT>p.FEDAT "
						  +" or r.FPAYDAT>"+ sqlTo(edat) +")"
	ExecuteSQL(sSQL);
	
	//начисления, по которым сформированы расходные накладные
	var sSQL = "select * from "+ sCorTbl +" c "
				+" inner join "+ sRelTbl +" r on r.FID_RBIL=c.FWID "
				+" where r.FDOC='NK'";	
	var billCorTbl = OpenTable(sSQL);
	var bCor = !billCorTbl.isEmpty()
	
	//начисления без расходных накладных
	var sSQL = "select * from "+ sCorTbl +" c "
						+" where c.FWID not in (select r.FID_RBIL from "+ sRelTbl +" r "
							+" where r.FDOC='NK')"
	var billRowTbl = OpenTable(sSQL);
	if(billRowTbl.isEmpty() && !bCor)
		return true;
	
	var sMsg = UR("По закритих пакетах сформовані нарахування"
					+(bCor? " і видаткові накладні" : "") 
					+".\nКорегувати нарахування?"
				+"|По закрытым пакетам сформированы начисления"
					+(bCor? " и расходные накладные" : "") 
					+".\nКорректировать начисления?");
	if(bAsk && !confirm(sMsg))
		return true;
		
	//удаляем начисления по которым не сформированы расходные накладные	
	deleteBill(billRowTbl);
	billRowTbl.close();
		
	//если по начислениям сформированы расходные накладные нужно их корректировать
	correctBill(billCorTbl);	
	billCorTbl.close();	
}

function deleteBill(rowTbl)
{
	include("doc/DpDoc.js");
	
	if(!rowTbl || rowTbl.isEmpty())
		return true;
	
	var bRet = false;	
	var sRegTbl = getRegTblName();
	var fid_doc = 0;
	var sID = "0";
	var oDoc;
	var bLoad = false;
	var nSum = 0;
	for(rowTbl.MoveFirst(); !rowTbl.isEOF(); rowTbl.MoveNext())
	{		
		if(fid_doc!=Number(rowTbl.getValue("FID_DOC")))
		{	
			if(fid_doc!=0)
			{
				oDoc.setVar("HSUM", nSum);
				bRet = oDoc.save(false, "EDIT");
				if(!bRet)
					return false;				
			}
			fid_doc = Number(rowTbl.getValue("FID_DOC"));
			var sDoc = rowTbl.getValue("FDOC");
			var nNop = rowTbl.getValue("FNOP");
			oDoc = new DpDoc(sDoc, nNop);
			bLoad = oDoc.loadByID(fid_doc);
			if(!bLoad)
				return false;
			nSum = oDoc.getVar("HSUM");
		}
		var rowID = Number(rowTbl.getValue("FWID"));
		oDoc.deleteRow("ROW", rowID);
		sID += ","+ rowID;
		nSum = nSum - Number(rowTbl.getValue("FSUM"));
	}	
	oDoc.setVar("HSUM", nSum);
	bRet = oDoc.save(false, "EDIT");	
	if(bRet)
		ExecuteSQL("delete from ^"+ sRegTbl +" where FWID in ("+ sID +")");
	return bRet;
}

//корректировка начислений
function correctBill(rowTbl, sWhere)
{		
	if(!rowTbl && !sWhere)
		return false;
		
	if(!rowTbl && sWhere)
	{
		var sRegTbl = getRegTblName();
		rowTbl = OpenTable("select * from ^"+ sRegTbl
						+" where "+ sWhere
						);
	}
	if(!rowTbl)
		return true;
	if(!rowTbl || rowTbl.isEmpty())
	{
		rowTbl.close();
		return true;
	}
	include("doc/DpDoc.js");
	
	var sDoc = rowTbl.getValue("FDOC");
	var nNop = rowTbl.getValue("FNOP");
	var oDoc = new DpDoc(sDoc, nNop);
	var hTbl = getSnap("select FDOC_NUM, FDOC_DAT, FPAYDAT from ^HBILL "
					+" where FWID="+ rowTbl.getValue("FID_DOC"));
	if(hTbl)
		oDoc.setVar("HNOM", hTbl[0]);
		
	saveBill(rowTbl, oDoc, null, null, true);
	
	var date = new Date(oDoc.getVar("HDAT"));
	var sMsg = UR("Сформувати видаткові накладні?|Сформировать расходные накладные?");
	if(!isNK(oDoc.getID(), null, null, null, null, null, true))
	{ 
		if(confirm(sMsg))
			formNK(date, null, null, null, null, oDoc.getID(), true, true, true);
	}	
}

function saveBill(rowTbl, oDoc, date, payDat, bCorrect, bFormDocs)
{	
	if(rowTbl.isEmpty())
		return false;
	
	var sDoc = "BILL";
	var nNop = getPar("BILL_BILL");
	if(!oDoc)
	{
		include("doc/DpDoc.js");
		oDoc = new DpDoc(sDoc, nNop);
	}
	include("doc/DpAutoNo.js");
	var docNum = new dpAutoNo(oDoc).get();
	/*
	var oSnap = getSnap("select max(FDOC_NUM) as FNUM from ^HBILL "
						+" where FDOC="+ sqlTo(sDoc) +" and FNOP="+ nNop);
	if(oSnap && oSnap[0])
		docNum = Number(oSnap[0])+1;
	*/
	var docDat = new Date();
	if(date)
		docDat = new Date(date);
	with(oDoc)
	{				
		//setVar("HDOC", sDoc);
		//setVar("HOP", Number(nNop));
		if(!oDoc.getVar("HNOM"))
			setVar("HNOM", docNum);		
		setVar("HDAT", docDat.getVarDate());
		setVar("HPAYDAT", rowTbl.getValue("FPAYDAT"));
		setVar("HEDAT", getPayDat(docDat).getVarDate());
		setVar("HCLIENT", rowTbl.getValue("FCLIENT"));		
	}
	
	var oRow;
	var num = 0;	
	var sum = 0;
	var sRowID = "";
	var sOldID = "";
	var sRowTbl = "RBILL";
	//var sTmpTbl = "TMP_BILL";
	//CreateTable(sTmpTbl, sRowTbl);
		
	for(rowTbl.moveFirst(); !rowTbl.isEOF(); rowTbl.MoveNext())
	{			
		var vid = rowTbl.getValue("FVID");
		var limit = rowTbl.getValue("FLIMIT");
		
		//определяем дату оказания услуги
		var billDat = new Date();
		if(payDat)				//если дата указана берём её	
			billDat = new Date(payDat);
		else					//если нет определяем дату по виду услуги
			billDat = billDate(docDat, vid, limit);			
		if(vid==1 || vid==2)	//для ежемесячных услуг дата оказания - последний день месяца
			billDat = new Date(lastDay(billDat));
		else					//для разовых услуг дата оказания берется из договора
			billDat = new Date(rowTbl.getValue("FDATE"));
		if(bCorrect)			//для корректировок дата оказания=дате документа
			billDat = new Date(docDat);	
		var edat = new Date(rowTbl.getValue("FEDATE"));
		if(differ(edat, billDat)<0)//если дата завершения пакета меньше даты оказания берем дату из договора
			billDat = edat;
				
		var nKol = Number(rowTbl.getValue("FKOL"));		
		var nCena = Number(rowTbl.getValue("FCENA"));
		var nSum = Number(rowTbl.getValue("FSUM"));			
		if(bCorrect)
		{			
			nKol = -nKol;
			nSum = -nSum;
		}
		else
		{
			nSum = getBillSum(rowTbl, billDat);
		}
		
		if(nSum==0)
			continue;
		
		if(payDat && limit!=true && limit!="true")
		{
			nCena = (nSum/nKol);			
		}		
		sum += nSum;
		num++;
	
		oRow = oDoc.createRow("ROW");
		oDoc.appendRow("ROW", oRow);
				
		with(oRow)
		{
			setVar("RNOM", num);
			setVar("RCENA", nCena);				
			setVar("RSUM", nSum);
			setVar("RKOL", rowTbl.getValue("FKOL"));
			setVar("RCLIENT", rowTbl.getValue("FCLIENT"));
			setVar("RDOGID", rowTbl.getValue("FID_DOG"));
			setVar("RPACKID", rowTbl.getValue("FWID_CL"));
			setVar("RNMKL", rowTbl.getValue("FNMKL"));			
			setVar("REDAT", rowTbl.getValue("FEDATE"));
			setVar("RHANDSUM", rowTbl.getValue("FHANDSUM"));
			setVar("RTYPE", rowTbl.getValue("FRTYPE"));		
			setVar("RVID", rowTbl.getValue("FVID"));						
			setVar("RINCR", rowTbl.getValue("FINCR"));
			setVar("RPHONE", rowTbl.getValue("FPHONE"));
			setVar("RPAYDAT", billDat.getVarDate());
			setVar("RLIMIT", rowTbl.getValue("FLIMIT"));
			setVar("RCENAOVER", rowTbl.getValue("FCENAOVER"));
			setVar("RUSEKOL", rowTbl.getValue("FUSEKOL"));
			setVar("REKOL", rowTbl.getValue("FEKOL"));					
		}	
		obj2DB(oRow.getID(), oRow.jDocRow, null, sRowTbl);
		sRowID += (sRowID==""? "" : ",") + oRow.getID();
		sOldID += (sOldID==""? "" : ",") + rowTbl.getValue("FWID");
	}
	if(sum==0)
		return false;
		
	oDoc.setVar("HSUM", sum);		
	oDoc.setVar("HNR", num);	
	
	var bRet = false;
	var par = new Object();	
	
	if(bCorrect)	//корректировки открываем для редактирования
		bRet = oDoc.edit("ADD", null, par);
	else
		bRet = oDoc.save(true, "ADD");
	
	if(bRet)
	{
		oDoc.saveExtToDB();
		if(bCorrect)
			saveCor(oDoc.getID(), null, sOldID);
		//saveCor(fid_cor, fid_bil, fid_rbil, fid_doc)
		if(bFormDocs)
			formDocs(oDoc, sRowTbl);
	}
	else
	{		
		//если документ не сохранился удаляем строки из RBILL
		ExecuteSQL("delete from ^"+ sRowTbl 
					+" where FID_DOC="+ oDoc.getID() 
						//+" and FSUM<0"
					);
	}	
	rowTbl.close();
	
	return oDoc;
}

function saveBillRows(fid_doc, sTmpTbl, sRowTbl)
{
	if(!sRowTbl)
		sRowTbl = getRegTblName();
	ExecuteSQL("DELETE FROM ^"+ sRowTbl +" WHERE fid_doc="+ fid_doc);
	var sFLD = GetPatternIntersection(sRowTbl, sRowTbl);
	//sFLD = sFLD.toUpperCase().replace(",FORDID", "");
	//sFLD = sFLD.toUpperCase().replace("FORDID,", "");
	ExecuteSQL("INSERT INTO ^"+ sRowTbl +"("+ sFLD +")"
			  +" SELECT "+ sFLD +" FROM "+ sTmpTbl 
			  );
}

function formDocs(billDoc, sRowTbl, vid, bPrint)
{		
	makeSF(billDoc, null, sRowTbl, vid, bPrint);
	makeNK(billDoc, null, sRowTbl, vid, bPrint);
}

function makeSF(billDoc, docDate, sRowTbl, vid, bPrint, bAsk, bFormDebtSF)
{
	if(!sRowTbl)
		sRowTbl = getRegTblName();
	var billID = 0;
	var _formSF = true;
	var _formsf_debt = false;
	var _formkvit_debt = false;
	var _debt_nmk = 0;
	var nOpSF = getPar("BILL_SF");
	if(billDoc)
	{
		billID = billDoc.getID();	
		_formSF = billDoc.getPar("_formsf");
		nOpSF = billDoc.getPar("_nopsf");
		if(bFormDebtSF)
		{
			_formsf_debt = billDoc.getPar("_formsf_debt");
			_formkvit_debt = billDoc.getPar("_formkvit_debt");
			_debt_nmk = billDoc.getPar("_debt_nmk");
		}
	}	
		
	var sRelTbl = getRelTblName();		
	if(_formSF)
	{
		var oSnap = getSnap("select FWID from ^"+ sRowTbl 
					+" where FID_DOC="+ billID 
						//+(vid? " and FVID in ("+ vid +")" : "")
						+" and FWID not in "
						+" (select FID_RBIL from "+ sRelTbl 
							+" where FDOC='SF')"
						, false);
		if(!oSnap || !oSnap[0])
			_formSF = false;
	}
	
	var date = new Date();
	if(billDoc)
		date = new Date(billDoc.getVar("HDAT"));		
	if(docDate)
		date = docDate;
	
	if(_formSF && bAsk)
	{
		var sMsg = UR("Сформувати рахунки-фактури на "+ tmonth(date, 1) +"?|Сформировать счета-фактуры на "+ tmonth(date, 1) +"?");
			_formSF = confirm(sMsg);
		sMsg = UR("Сформувати рахунки за борги?|Сформировать счета за долги?");
		if(_formsf_debt)
			_formsf_debt = confirm(sMsg);
		sMsg = UR("Сформувати квитанції за борги?|Сформировать квитанции за долги?");
		if(_formkvit_debt)
			_formkvit_debt = confirm(sMsg);
	}
	if(_formSF)
	{			
		formSF(nOpSF, date, 0, 0, billDoc.getID(), bPrint, _formsf_debt, _formkvit_debt, _debt_nmk);
	}
}

function makeNK(billDoc, docDate, sRowTbl, vid, bPrint)
{	
	var billID = 0;
	var _formNK = true;
	var date = new Date();
	if(billDoc)
	{
		billID = billDoc.getID();
		_formNK = billDoc.getPar("_formnk");
		date = new Date(billDoc.getVar("HDAT"));
	}
		
	if(!_formNK || isNK(billID, vid, null, null, null, sRowTbl))			
		return false;
		
	if(docDate)
		date = docDate;
	
	var sMsg = UR("Сформувати видаткові накладні на "+ tmonth(date, 1) +"?|Сформировать расходные накладные на "+ tmonth(date, 1) +"?");
	if(confirm(sMsg))
	{			
		var bCorrect = isCorNakl(billID, "RBILLTMP");		
		formNK(date, 0, 0, vid, 0, billID, false, bCorrect, bPrint);		
	}
}

//проверяет сформированы ли накладные по всем строкам начисления
function isNK(fid_doc, vid, date, org, dog, sRowTbl, bCorrect)
{
	var isNK = false;
	if(!sRowTbl)
		sRowTbl = getRegTblName();
	var sRelTbl = getRelTblName();
	var oSnap = getSnap("select FWID from ^"+ sRowTbl 
					+" where FDOC='BILL' "
						+ sqlw0And("FID_DOC=", fid_doc)
						+ sqlw0And("FCLIENT=", org)
						+ sqlw0And("FID_DOG=", dog)
						+(!vid? "" : " and FVID in ("+ vid +")")
						+((!date || (bCorrect==true && fid_doc))? "" 
								: "and FPAYDAT>="+ sqlTo(firstDay(date)) 
								+" and FPAYDAT<="+ sqlTo(lastDay(date)))
						+" and FWID not in "						
							+" (select FID_RBIL from "+ sRelTbl 
								+" where FDOC='NK')"						
					, false);
	if(!oSnap || !oSnap[0])
		isNK = true;
	return isNK;
}

//проверяет сформированы ли счета по всем строкам начисления
function isSF(fid_doc, vid, date, org, fid_dog, sRowTbl)
{
	var isSF = false;
	if(!sRowTbl)
		sRowTbl = getRegTblName();
	var sRelTbl = getRelTblName();
	var oSnap = getSnap("select FWID from ^"+ sRowTbl 
					+" where FDOC='BILL' "
						+ sqlw0And("FID_DOC=", fid_doc)
						+ sqlw0And("FCLIENT=", org)
						//+ sqlw0And("FID_DOG=", dog)
						+(!vid? "" : " and FVID in ("+ vid +")")
						+(!date? "" : "and FPAYDAT>="+ sqlTo(firstDay(date)) 
									+" and FPAYDAT<="+ sqlTo(lastDay(date)))
						+" and FWID not in "						
							+" (select FID_RBIL from "+ sRelTbl 
								+" where FDOC='SF')"						
					, false);
	if(!oSnap || !oSnap[0])
		isSF = true;
	return isSF;
}

//категория контрагента: 0 - юр., 1 - физ.; 
function getOrgCat(nOrg)
{
	var cat = 0;
	var oSnap = getSnap("select FCAT from ^CL_POST p "
					+" inner join ^CLRELCLCL c on c.FWID_CL=p.FWID_CL"
					+" where c.FCOD="+ sqlTo(nOrg));
	if(oSnap)
		cat = oSnap[0];
	return Number(cat);
}

//номер счета для контрольной суммы
function getNumSF(num)
{
	return "7" + String(num);
}

//контрольна сумма
function getKS(num)
{
	var ks = 0;
	if(!num)
		return ks;
	num = String(num);
	var k = 21;
	var i = num.length-1;
	for(i; i>=0; i--)
	{		
		ks += (Number(num[i])*k--);		
	}	
	return ks;
}

//адрес установки
function billPoint(dogID, nOrg)
{
	var oSnap = getSnap("select cl.FTXT from ^BIL_PACK p "
						+" inner join ^CL cl on cl.FWID=p.FPOINT "
						+" where p.FID_DOG="+ dogID, false);
	if(oSnap)
		return oSnap[0];
	
	if(nOrg)
		return tforg("ADDR", nOrg);
	
	return "";
}

//номер телефона установки
function billPhone(dogID, nOrg)
{
	var oSnap = getSnap("select cl.FTXT from ^BIL_PACK p "
						+" inner join ^CL cl on cl.FWID=p.FPHONE "
						+" where p.FID_DOG="+ dogID, false);
	if(oSnap)
		return oSnap[0];
	
	if(nOrg)
		return tforg("PHONE", nOrg);
	
	return "";
}

//номер налоговой
function getNextNKNum(sReg, sVid)
{
	return "";
	/*
	//var nk_num = parseInt(getRegPar("-","NGNKNUM"));
	var oSnap = getSnap("select max(HNKNUM) from ^MDOCREG", false);
	if(!oSnap)
		return 0;
	nk_num = Number(oSnap[0]);
	if(nk_num)
		nk_num++;	
	return nk_num;	
	*/
}

//накладная на корректировку?
function isCorNakl(fid_doc, sTblName)
{
	var sum = 0;
	var cena = 0;
	if(!sTblName)
		sTblName = "ANLTK";
	var oSnap = getSnap("select min(FSUM) as FSUM, min(FCENA) as FCENA "
						+" from ^"+ sTblName
						+" where FID_DOC="+ fid_doc
					, false);
	if(oSnap)
	{
		sum = Number(oSnap[0]);
		cena = Number(oSnap[1]);
	}
	return (sum<0 || cena<0);
}

//лицевой счет для договора
function getPersNum(sDogNum, nOrg, dogID)
{
	var sNum = "";
	if(!sDogNum && dogID)
	{
		var oSnap = getSnap("select d.FPERSNUM, c.FDOG_NUM, c.FORG "
						+" from ^BILDOG d "
							+" inner join ^CONTRACT c on c.FWID=d.FID_DOG "
						+" where d.FID_DOG="+ dogID
					, false);
		if(oSnap)
		{
			//sNum = oSnap[0];
			//if(sNum && sNum!="")
			//	return sNum;
			
			sDogNum = oSnap[1];
			nOrg = oSnap[2];
		}
	}
	//trace("\n>>> sDogNum - "+ sDogNum)
	if(!sDogNum)
		return "";
	
	sDogNum = String(sDogNum).toUpperCase();
	sDogNum = sDogNum.replace("KI", "");
	sDogNum = sDogNum.replace("КІ", "");
	sDogNum = sDogNum.replace("КI", "");
	sDogNum = sDogNum.replace("KІ", "");
	sDogNum = sDogNum.replace("-", "");
	sDogNum = sDogNum.replace(" ", "");
	sDogNum = sDogNum.replace("/", "");
	
	//trace(">>> sDogNum - "+ sDogNum)
	sNum = "3";
	if(getOrgCat(nOrg)==0)
		sNum = "4";	
	if(Number(sDogNum))
	{
		sNum += format("000000", Number(sDogNum));
		trace(">>> sNum 1 - "+ sNum)
	}
	else
	{
		var z = 6-sDogNum.length;
		for(var i=0; i<z; i++)
			sNum += "0";
		sNum += sDogNum;
		trace(">>> sNum 2 - "+ sNum)
	}
		
	return sNum;
}

//вид услуги
function getVid(nmk)
{
	var vid = 1;
	var oSnap = getSnap("select FVID, FLIMIT from ^"+ getRegTblName()
						+" where FNMKL="+ sqlTo(nmk)
					, false);
	if(oSnap)
		vid = oSnap[0];
	
	return Number(vid);
}

//проверяет есть ли в документе строки с товаром
function isTovar(fid_doc, sTblName)
{
	if(!sTblName)
		sTblName = "ANLTK";
	var isTovar = false;
	var sBillTbl = getRegTblName();
	var oSnap = getSnap("select p.FVID from ^CL_SERV p "
						+" inner join ^"+ sTblName +" a on a.FNMKL=p.FNMKL "
						+" where a.FID_DOC="+ fid_doc
							+" and p.FVID=4 "
					, false);
	if(oSnap)
		isTovar = (Number(oSnap[0])==4);
	return isTovar;
}

//группа договора
function getDogGroup(fid_dog)
{
	var group = "";
	var oSnap = getSnap("select FGROUP "
						+" from ^BILDOG "
						+" where FID_DOG="+ fid_dog
					, false);
	if(oSnap)
		group = Number(oSnap[0]);
	if(group==0)
		group = "";
	return String(group);
}

//название технологии
function tech(dogID)
{
	var oSnap = getSnap("select cl.FTXT "
					+" from ^CL cl "
					+" inner join ^BIL_PACK p on p.FTECHN=cl.FWID"
					+" where p.FID_DOG="+ dogID
				, false);
	if(!oSnap)
		return "";
	return oSnap[0];
}

//название пакета
function billPackTxtFull(packID, dogID)
{
	var sPack = "";
	var oSnap = getSnap("select cl.FTXT, p.FCENA, s.FSPEED, s.FSIZE, d.FMODEM, d.FSN, s.FVID "
					+" from ^CL_SERV s "
					+" inner join ^CL_PACK p on p.FWID_CL=s.FWID_CL "
					+" inner join ^CL cl on cl.FWID=p.FWID_CL "
					+" inner join ^BIL_PACK d on d.FWID_CL=p.FWID_CL "					
					+" where s.FWID_CL="+ packID
						//+" and s.FVID in (1,2)"
						+ sqlw0And("d.FID_DOG=", dogID)						
				, false);
	if(!oSnap)
		return sPack;
	sPack = "«"+ oSnap[0] +"»";
	if(oSnap[4]!="")
		sPack += ": "+ oSnap[4];
	if(oSnap[5]!="")
		sPack += " s/n: "+ oSnap[5];
	if(oSnap[1])
		sPack += ".\n    "+ UR("Ціна: |Цена: ") + oSnap[1] +" грн.";
	if(oSnap[2]!="")
		sPack += ".\n    "+ UR("Швидкість доступу: |Скорость доступа: ")+ oSnap[2];
	if(oSnap[3]!="" && oSnap[4]=="" && Number(oSnap[6])==1)
		sPack += ".\n    "+ UR("Обсяг передплаченої інформації: |Объем предоплаченой информации: ")+ oSnap[3];	
	return sPack;
}

function billPackTxtAbon(packID, dogID)
{
	var sPack = billPackTxt(packID, dogID);
	if(sPack!="")
		sPack = UR("Абонентська плата: |Абонентская плата: ") + sPack;
	return sPack;
}

//услуги по пакету
function billServTxt(packID, dogID)
{
	var sPack = "";
	var oSnap = getSnap("select cl.FTXT, s.FCENA, s.FSPEED, s.FSIZE, d.FMODEM, d.FSN, nmk.FTXTS, s.FVID "
					+" from ^CL_SERV s "
					+" inner join ^CL_PACK p on p.FWID_CL=s.FWID_CL "
					+" inner join ^CL cl on cl.FWID=p.FWID_CL "
					+" inner join ^BIL_PACK d on d.FWID_CL=p.FWID_CL "					
					+" inner join ^CL_NMK nmk on nmk.FWID=s.FNMKL "
					+" where s.FWID_CL="+ packID
						+" and s.FLIMIT="+ sqlFalse
						+ sqlw0And("d.FID_DOG=", dogID)						
				, false);
	if(!oSnap)
		return sPack;
	if(Number(oSnap[7])==1)	//ежемесячные услуги
	{
		if(oSnap[6]!="")
			sPack = oSnap[6] +": ";
		sPack += " Пакет «"+ oSnap[0] +"»";
		if(oSnap[2]!="")
			sPack += ".\n    "+ UR("Швидкість доступу: |Скорость доступа: ")+ oSnap[2];
		if(oSnap[3]!="" && oSnap[4]=="")
			sPack += ".\n    "+ UR("Обсяг передплаченої інформації: |Объем предоплаченой информации: ")+ oSnap[3];	
	}
	else
	{
		sPack += oSnap[0];
		//if(oSnap[4]!="")
		//	sPack += ": "+ oSnap[4];
		//if(oSnap[5]!="")
		//	sPack += " s/n: "+ oSnap[5];	
	}
	return sPack;
}

function billPackSum(packID, nmkID)
{
	var oSnap = getSnap("select FCENA*FKOL "
					+" from ^CL_SERV "
					+" where FWID_CL="+ packID
						+ sqlw0And("FNMKL=", nmkID)
						+(nmkID? "" : " and FLIMIT="+ sqlFalse)						
				, false);
	if(!oSnap)
		return "";
	return round(Number(oSnap[0]), 2);
}

function tmodem(dogID, nModem)
{	
	var sModem = "";
	if(nModem!=null && Number(nModem)==0)	
		sModem = UR(" свій. | свой. ");
	var oSnap = getSnap("select FMODEM, FSN "
					+" from ^BIL_PACK "					
					+" where FID_DOG="+ dogID
						+" and FEDATE<"+ sqlD00
						+" and ((FMODEM<>"+ sqlEmpStr +" and FMODEM is not NULL) "
							+" or (FSN<>"+ sqlEmpStr +" and FSN is not NULL))"
				, false);
	if(!oSnap)
		return sModem;
	sModem = oSnap[0];
	if(oSnap[1]!="")
		sModem += "  s/n"+ oSnap[1];
	return sModem;
}

function singleServ(packID)
{
	var oSnap = getSnap("select FVID "
						+" from ^CL_SERV "
						+" where FWID_CL="+ packID
							+" and FVID in (3,4)"
				, false);
	if(!oSnap)
		return false;
	return (Number(oSnap[0])==3 || Number(oSnap[0])==4);
}

function appendServ(packID)
{
	var oSnap = getSnap("select FVID "
						+" from ^CL_SERV "
						+" where FWID_CL="+ packID
							+" and FVID=2"
				, false);
	if(!oSnap)
		return false;
	return (Number(oSnap[0])==2);
}

//номенклатура абонплаты
function dogNmkAbon(dogID)
{
	var oSnap = getSnap("select s.FNMKL "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" where d.FID_DOG="+ dogID
						+" and s.FVID=1 "
						+" and s.FLIMIT="+ sqlFalse
				, false);
	if(!oSnap)
		return 0;
	return oSnap[0];
}

function packNmkAbon(packID, dogID)
{
	var oSnap = getSnap("select s.FNMKL "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" where s.FWID_CL="+ packID
						+ sqlw0And("d.FID_DOG=", dogID)
						+" and s.FVID=1 "
						+" and s.FLIMIT="+ sqlFalse
				, false);
	if(!oSnap)
		return 0;
	return oSnap[0];
}

//превышение
function packNmkOver(packID, dogID)
{
	var oSnap = getSnap("select s.FNMKL "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" where s.FWID_CL="+ packID
						+" and s.FLIMIT="+ sqlTrue
						+ sqlw0And("d.FID_DOG=", dogID)						
				, false);
	if(!oSnap)
		return 0;
	return oSnap[0];
}

//превышение
function packNmkOverTxt(packID, dogID)
{
	var oSnap = getSnap("select s.FNMKL, nmk.FTXTS "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" inner join ^CL_NMK nmk on nmk.FWID=s.FNMKL "
					+" where s.FWID_CL="+ packID
						+" and s.FLIMIT="+ sqlTrue
						+ sqlw0And("d.FID_DOG=", dogID)						
				, false);
	if(!oSnap)
		return "";
	return oSnap[1];
}

function packSize(packID, dogID)
{
	var oSnap = getSnap("select s.FSIZE "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" where s.FWID_CL="+ packID
						+ sqlw0And("d.FID_DOG=", dogID)
						+" and s.FVID=1 "
						+" and s.FLIMIT="+ sqlFalse
				, false);
	if(!oSnap)
		return "";
	return oSnap[0];
}

function packSpeed(packID, dogID)
{
	var oSnap = getSnap("select s.FSPEED "
					+" from ^CL_SERV s "
					+" inner join ^BIL_PACK d on d.FWID_CL=s.FWID_CL "
					+" where s.FWID_CL="+ packID
						+ sqlw0And("d.FID_DOG=", dogID)
						+" and s.FVID=1 "
						+" and s.FLIMIT="+ sqlFalse
				, false);
	if(!oSnap)
		return "";
	return oSnap[0];
}

function size(dogID)
{
	var nmk = packNmk(dogID);
	return billSize(nmk, dogID);
}

function speed(dogID)
{
	var nmk = packNmk(dogID);
	return billSpeed(nmk, dogID);
}

function techFIO(codOrg)
{
	var oSnap = getSnap("select FFIO "
					+" from ^CL_ORGCP cp "
					+" inner join ^CLRELCLCL rel "
						+" on cp.FWID_CL=rel.FWID_CL "
						+" and rel.FCL="+ getPar("CODPLAT")
					+" where rel.FCOD="+ sqlTo(codOrg)
						+" and cp.FNOTIFY_TECH="+ sqlTrue
				, false);
	if(oSnap)
		return oSnap[0];
	return "";
}

function techPOST(codOrg)
{
	var oSnap = getSnap("select FPOST "
					+" from ^CL_ORGCP cp "
					+" inner join ^CLRELCLCL rel "
						+" on cp.FWID_CL=rel.FWID_CL "
						+" and rel.FCL="+ getPar("CODPLAT")
					+" where rel.FCOD="+ sqlTo(codOrg)
						+" and cp.FNOTIFY_TECH="+ sqlTrue
				, false);
	if(oSnap)
		return oSnap[0];
	return "";
}

function techMAIL(codOrg)
{
	var oSnap = getSnap("select FEMAIL "
					+" from ^CL_ORGCP cp "
					+" inner join ^CLRELCLCL rel "
						+" on cp.FWID_CL=rel.FWID_CL "
						+" and rel.FCL="+ getPar("CODPLAT")
					+" where rel.FCOD="+ sqlTo(codOrg)
						+" and cp.FNOTIFY_TECH="+ sqlTrue
				, false);
	if(oSnap)
		return oSnap[0];
	return "";
}

function techPHONE(codOrg)
{
	var oSnap = getSnap("select FPHONE "
					+" from ^CL_ORGCP cp "
					+" inner join ^CLRELCLCL rel "
						+" on cp.FWID_CL=rel.FWID_CL "
						+" and rel.FCL="+ getPar("CODPLAT")
					+" where rel.FCOD="+ sqlTo(codOrg)
						+" and cp.FNOTIFY_TECH="+ sqlTrue
				, false);
	if(oSnap)
		return oSnap[0];
	return "";
}

function tconnection(nConnect)
{
	var sConnect = UR("Самостійне підключення|Самостоятельное подкдючение");
	if(Number(nConnect)==1)
		sConnect = UR("Виїзд спеціаліста|Выезд специалиста");
	return sConnect;
}

function billDogTVid(nVid)
{
	var sVid = UR("Інтернет|Интернет");
	if(Number(nVid)==1)
		sVid = UR("Телефон|Телефон");
	if(Number(nVid)==2)
		sVid = UR("Передача даних|Передача данных");
	return sVid;
}

//номер накладной для корректировки
function getCorVal(fid_doc, sVar)
{
	if(!sVar)
		sVar = "HNKNOM";
	var num = "";
	var oSnap = getSnap("select FID_BIL from ^RELBILL where FID_DOC="+ fid_doc, false);
	if(!oSnap)
		return num;
	
	var fid_cor = oSnap[0];
	oSnap = getSnap("select FID_BIL, FID_DOC from ^RELBILL where FID_COR="+ fid_cor +" and FDOC='NK'", false);
	if(!oSnap)
		return num;
	
	fid_doc = oSnap[1];	
	//oSnap = getSnap("select FDOC_NUM from ^SCH_ZAG where FWID="+ fid_cor, false);
	oSnap = getSnap("select "+ sVar +" from ^MDOCREG where HID_DOC="+ fid_doc, false);
	if(oSnap)
		num = oSnap[0];
	
	return num;
}

function getNextDocNum(dogID, date, sDoc)
{
	if(date)
		date = new Date(date);
	else
		date = new Date();
	var d1 = firstDay(date);	
	var d2 = lastDay(date);
	
	var num = "";
	var sTblName = "SCH_ZAG";
	var oSnap = getSnap("select count(*) as cnt "
					+" from ^"+ sTblName 
					+" where FDOC="+ sqlTo(sDoc)
						+" and FID_DOG="+ dogID
						+" and FDOC_DAT>="+ sqlTo(d1)
						+" and FDOC_DAT<="+ sqlTo(d2)
						);
	if(oSnap && Number(oSnap[0])>0)
	{
		num = Number(oSnap[0])+1;
	}
	return num;
}

function printSF(fid_doc)
{
	include("bill_print.js");
	printDoc(fid_doc, null, true);
}

function printNK(fid_doc)
{
	include("bill_print.js");
	printDoc(fid_doc, null, true);
}

function getOrgForPV(sTxt)
{
	sTxt = parseTextForPV(sTxt);
	var org = 0;
	var arrNum = sTxt.split(" ");
	for(var n=0; n<arrNum.length; n++)
	{
		try
		{
			var num = String(arrNum[n]).trim();
			num = Number(num.substring(1));
			if(!num)
				continue;
			org = getOrgBySF(num);
			if(org)
				return org;
		}
		catch(e)
		{
			
		}
	}
	return org;
}

function getDogForPV(sTxt)
{
	sTxt = parseTextForPV(sTxt);
	var dogID = 0;
	var arrNum = sTxt.split(" ");
	for(var n=0; n<arrNum.length; n++)
	{
		try
		{
			var num = String(arrNum[n]).trim();
			num = Number(num.substring(1));
			if(!num)
				continue;
			dogID = getDogBySF(num);
			if(dogID)
				return dogID;
		}
		catch(e)
		{
			
		}
	}
	return dogID;
}

function parseTextForPV(sTxt)
{
	sTxt = String(sTxt).toLowerCase().trim();
	if(sTxt.indexOf(" kb ")!=-1)
		sTxt = sTxt.substring(sTxt.indexOf(" kb ")+3).trim();
	if(sTxt.indexOf(" кв ")!=-1)
		sTxt = sTxt.substring(sTxt.indexOf(" кв ")+3).trim();
	if(sTxt.indexOf(" кв ")!=-1)
		sTxt = sTxt.substring(sTxt.indexOf(" кв ")+3).trim();
	if(sTxt.indexOf("№")!=-1)
		sTxt = sTxt.substring(sTxt.indexOf("№")+1).trim();
	return sTxt;
}

function getDogBySF(ID)
{
	var oSnap = getSnap("select FID_DOG from ^SCH_ZAG where FWID="+ sqlTo(ID), false);
	if(oSnap)
		return oSnap[0];		
	return 0;
}

function getOrgBySF(ID)
{
	var oSnap = getSnap("select FDBKR from ^SCH_ZAG where FWID="+ sqlTo(ID), false);
	if(oSnap)
		return oSnap[0];		
	return 0;
}

function bilSystem(dogID)
{
	var sys = 0;
	var oSnap = getSnap("select FBILSYS from ^BILDOG where FID_DOG="+ dogID, false);
	if(oSnap)
		sys = Number(oSnap[0]);
	return sys;
}

function isCreditSystem(dogID)
{
	return bilSystem(dogID)==1;
}

function cleanDogNum(sNum)
{
	var num = String(sNum).replace("/KI", "");
	num = num.replace("/КI", "");
	num = num.replace("/КІ", "");
	num = num.replace("/KI", "");
	return num;
}

function search_pv_for_close_contract(date1, date2)
{
	if(!date1)
		date1 = new Date(today.getFullYear(), today.getMonth(), 1);
	var oSnap = getSnap("select count(*) as cnt "
						+" from ^LISTDOCSPV pv "
						+" where pv.FDOC_DAT>(select c.FEDAT "
							+" from ^CONTRACT c "
							+" where c.FWID=pv.FID_DOG) "
							+" and pv.FDOC_DAT>="+ sqlTo(date1)
							+(date2? "and FDOC_DAT<="+ sqlTo(date2) : "")
						);
	if(oSnap && Number(oSnap[0]))
		return Number(oSnap[0]);
	return 0;
}