include("sys\\kursval.js")
include("servis\\format.js");
include("objects\\DpEval.js");


//// Общие константы
var sizeNmk = 16

//// Константы для работы с файлом строк накладных

//var chain_fwid  = SqlConCat( Convert('a.fnmkl', 'NVARCHAR'), "' '", Convert('a.fis_otl', 'NVARCHAR'),"' '", Convert('a.fcena', 'NVARCHAR'), "' '", Convert('a.fpodr', 'NVARCHAR'), "' '", Convert('a.fmol', 'NVARCHAR'), "' '", Convert('a.fsc', 'NVARCHAR'), "' '", Convert('a.fsu', 'NVARCHAR'), "' '", Convert('a.fst', 'NVARCHAR'), "' '", Convert('a.fpost', 'NVARCHAR'), "' '", Convert('a.fid_pn', 'NVARCHAR') );
//var chain_fwid_ = SqlConCat( Convert('fnmkl', 'NVARCHAR'), "' '", Convert('fis_otl', 'NVARCHAR'), "' '", Convert('fcena', 'NVARCHAR'), "' '", Convert('fpodr', 'NVARCHAR'), "' '", Convert('fmol', 'NVARCHAR'), "' '", Convert('fsc', 'NVARCHAR'), "' '", Convert('fsu', 'NVARCHAR'), "' '", Convert('fst', 'NVARCHAR'), "' '", Convert('fpost', 'NVARCHAR'), "' '", Convert('fid_pn', 'NVARCHAR') );

// Поля цепочки(нужно обязательно изменить вторую строку при изменении первой)
var fldGroupKey = "a.fnmkl,a.fis_otl,a.fcena,a.fpodr,a.fmol,a.fsc,a.fsu,a.fst,a.fpost,a.fid_pn";
var sel_fldGroupKey = "fnmkl,fis_otl,fcena,fpodr,fmol,fsc,fsu,fst,fpost,fid_pn";

// Поля в выборках строк накладных(нужно обязательно изменить вторую строку при изменении первой)
var fldDocHR = "A.FWID as FWID_R,A.FID_DOC as FWID_H,A.FDOC,S.FNOP";
var sel_fldDocHR = "FWID_R,FWID_H,FDOC,FNOP";

// Поля цепочки для связи в SQL-запросах
var joinKey = "a.fnmkl=b.fnmkl"
   //+ " AND a.fis_otl=b.fis_otl"
   + " AND a.fcena=b.fcena"
   + " AND a.fpodr=b.fpodr"
   + " AND a.fmol=b.fmol"
   + " AND a.fsc=b.fsc"
   + " AND a.fsu=b.fsu"
   + " AND a.fst=b.fst"
   + " AND a.fpost=b.fpost"
   + " AND a.fid_pn=b.fid_pn";

// Записи по приходу ТМЦ извне
var sRecIncR = "a.Frtype='"+RTYPE_PR+"'"

// Записи по приходу ТМЦ по перемещениям
var sRecIncV = "a.Frtype='"+RTYPE_PMP+"'"

// Записи по приходу ТМЦ
var sRecInc = "a.Frtype='"+RTYPE_OST+"' or a.Frtype='"+RTYPE_PR+"' or a.Frtype='"+RTYPE_PMP+"'"

// Записи по расходу ТМЦ вовне
var sRecDecR = "a.Frtype='"+RTYPE_RS+"' and a.Fdoc<>'SF'"

// Записи по расходу ТМЦ по перемещениям
var sRecDecV = "a.Frtype='"+RTYPE_PMR+"'"

// Записи по расходу ТМЦ с учетом перемещений и счетов-фактур
var sRecDec = "a.Frtype='"+RTYPE_RS+"' or a.Frtype='"+RTYPE_PMR+"'"

// Знак записи (1,0,-1) по расходу ТМЦ с учетом перемещений и счетов-фактур
var sRecSignSF = IIF(sRecInc, "1", IIF(sRecDec , "-1", "0"));

// Знак записи (1,0,-1) по расходу ТМЦ с учетом перемещений и без учета счетов-фактур
var sRecSign = IIF("a.Fdoc='SF'", "0", sRecSignSF);

// Условия для процедур с отдельной обработкой начальных остатков (например mtr_ost.js)
var sRecIncRV = "Frtype='"+RTYPE_PR+"' or Frtype='"+RTYPE_PMP+"'"
var sRecSignRVSF = IIF(sRecIncRV, "1", IIF(sRecDec , "-1", "0"));
var sRecSignRV = IIF("Fdoc='SF'", "0",sRecSignRVSF);

//// Вернуть имя прайса по коду и дате
function pName(t, dat, id)
{   
   
    var tPri = null;
	var prId = null;
    if (id != null)
    {
    	prId = id;
    	
    }
    else
    {
    	 if(!dat)
    	    	dat = pDat(t);
    	 prId = _pName(t, dat);
    }
    d = new Date(dat);    
    
    tPri = getSnap("SELECT FCOD,FDAT FROM ^cl_pri"
			+ " WHERE fwid=" + prId);
	t = tPri!=null? tPri[0] : t;
	d = tPri!=null? tPri[1] : dat;
	d = new Date(d.getYear()+1900, d.getMonth(), d.getDate())
	return "^P" + t + format("yyyymmdd", d);

	//return "^P" + t + ((d.getYear()<10)?"0"+d.getYear():d.getYear()) + ((d.getMonth()<9)?"0"+(1+d.getMonth()):(1+d.getMonth())) + ((d.getDate()<10)?"0"+d.getDate():d.getDate())
}

/*
   fwid прайса из существующих,
   максимально подходящее под дату
*/
function _pName(t, dat)
{
   /*
      открыть таблицу и провести поиск
   */
   var tbl = OpenTable("s", "select fwid, fdat from ^cl_pri where fcod="+sqlTo(t)+" order by fdat");
   var ret = null;
   if( tbl.FindFirst("Fdat>="+sqlTo(dat)) )
   {
      /*
         fwid нужен чтобы просто показать прайс
      */
      //if(tbl.getValue("Fdat")>dat)
      if(differ(sqlTo(tbl.getValue("Fdat")),sqlTo(dat)) > 0)
         tbl.MovePrev();

      if(tbl.IsRecord())
         ret = tbl.getValue("fwid");
   }
   tbl.close();
   /*
      прайс не нашли
   */
   return ret;
}

function pDat(cod)
{
	var sWhere = " where (FISGRP="+ sqlFalse +" or FISGRP is NULL)";
	if(cod)
		sWhere += " and FCOD="+ sqlTo(cod);
	var oSnap = getSnap("select FDAT from ^CL_PRI "+ sWhere 
						+" order by FDAT desc");
	if(oSnap)
		return new Date(oSnap[0]);
	return null;
}

//// Функции для привязки и вывода информации по первым приходам при просмотре
function addPnTbl()
{
   list.subTie("anltk","rpn","FWID","FID_PN");
   list.subTie("sch_zag", "hpn", "FWID", "rpn.FID_DOC")
}

function addPnGrid()
{
if( false )
   with( list.grid )
   {
      page();
      row("=(NOT IsNull(^Fid_pn))");
      fieldEx("rpn.fdate","Дата прихода",10);
      fieldEx("rpn.hpn.fdoc_num","Номер документа",15);
   }
}

//// Добавить поля для связи с
function addTtlTbl()
{  
   // Цикл по группам с case внутри (tie)
   var gr_tbl = OpenTable("s",
      "SELECT *"
      + " FROM ^CL_TTFLD"
      + " WHERE UPPER(flist)=" + sqlTo(list.objTotal.callerName.toUpperCase())
      );
   
   while(!gr_tbl.IsEOF())
   {
      	var  sTT = String(gr_tbl.getValue("FTT")).toUpperCase();
      	var sField = String(gr_tbl.getValue("FFIELD")).toUpperCase();
      	switch(sTT)
      	{
    	case "NM":
			list.subTie("CL_NMK",sTT,"FWID",sField);
			list.subTie("CL_EDI", "ED", "cod", sTT + ".Fcedib"/*,'getTie("'+sTT+'")'*/);
         	break;
      case "PD":
      case "PD1":
		 	list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+sqlTo(sprPodr)+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "ML":
      case "ML1":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+sqlTo(sprMol)+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "SC":
		 list.subTie("cl_schet",sTT,"U0","FSC,=0,=0");
         break;
      case "SU":
		 list.subTie("cl_schet",sTT,"U0","FSC,FSU,=0");
         break;
      case "ST":
         // Неправильно - указываются явно имена полей - надо будет переделать
		 list.subTie("cl_schet",sTT,"U0","FSC,FSU,FST");
         break;
      case "SC1":
      case "SU1":
         // Неправильно - указываются явно имена полей - надо будет переделать
		 list.subTie("cl_schet",sTT,"U0","FSC1,FSU1,=0");
         break;
      case "ST1":
		 list.subTie("cl_schet",sTT,"U0","FSC1,FSU1,FST1");
			break;
      case "PS":
      case "PK":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+sqlTo(sprOrg)+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "P1":
		 list.subTie("anltk",sTT,"FWID",sField);
		 list.subTie("sch_zag","H","FWID","FID_DOC",'getTie("'+sTT+'")');
         break;            
      case "DE":            
         list.subTie("sch_zag",sTT,"FWID",sField);
         break;          
      case "OO":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+sqlTo(sprOrg)+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "CA":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+getPar("codArea")+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "CC":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+getPar("codCountry")+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		 
         break;
      case "CL":
		list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+getPar("codLocate")+","+sField);
			list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		
         break;
      case "CR":
		 list.subTie("clrelclcl","CLREL"+sTT,"CLCOD","="+getPar("codRegion")+","+sField);
		list.subTie("cl",sTT,"FWID","CLREL"+sTT+".FWID_CL");
		
         break;
//NI: <Специально для ЧеркассыТрансГаз - для генератора отчетов>         
      case "GZ":
         if(IsTable("gogrps")){
          list.subTie("gogrps",sTT,"FGRP",sField);
         }
         break;
//END NI: </Специально для ЧеркассыТрансГаз - для генератора отчетов>         
		case "IN":
		 list.subTie("osnazv",sTT,"OSNAZV", sField);
		
		break;
		case "VOS":
		 list.subTie("VIDOS",sTT,"VIDOS", sField);		 
		break;
      }
      gr_tbl.MoveNext()  
   }
   gr_tbl.close();
}

// Вывод префикса в итоговых строках
function ttlGridRowPrefix(i, line_i, fldSize, txtSize)
{
   var fldOutExp, fldOutTxt, fldOutSize, txtOutExp, txtOutTxt, txtOutSize
   var fldObjFieldEx, txtObjFieldEx
   /*
   var gr_tbl = OpenTable("s",
      "SELECT *"
      + " FROM ^CL_TTFLD"
      + " WHERE flist=" + sqlTo(list.objTotal.callerName)
         + " AND fno=" + sqlTo(i)
      );
   */
   var tblCl_ttr = OpenTable("s", "cl_ttr", "itog");
   if (SQL)
		tblCl_ttr.Index = "FLIST,FHNO,FNO";
   if(!tblCl_ttr.Seek("="
         , list.objTotal.callerName
         , list.objTotal.variantCur
         , i))
      return;
   var gr_tbl = OpenTable("s", "cl_ttfld", "field");
   if (SQL)
		gr_tbl.Index = "FLIST,FFIELD";
   if(!gr_tbl.Seek("="
         , list.objTotal.callerName
         , tblCl_ttr("ffield")))
      return;
   
   fldOutExp = gr_tbl("Ffield");
   fldOutTxt = gr_tbl("ftxt");
   fldOutSize = fldSize;
   txtOutExp = "";
   txtOutTxt = "Назва|Название";
   txtOutSize = txtSize;
   
   var oExpr = new tt2expr(gr_tbl);
   fldOutExp = oExpr.fldOutExp;
   fldOutTxt = oExpr.fldOutTxt;
   txtOutExp = oExpr.txtOutExp;
   txtOutTxt = oExpr.txtOutTxt;
   
   if( list.gridHeaderHeight>0 && line_i!=0 )
   {
      fldOutExp = "";
      fldOutTxt = "";
      txtOutExp = "";
      txtOutTxt = "";
      fldOutSize = 1;
      txtOutSize = 1;
   }
   fldObjFieldEx = list.grid.fieldEx(fldOutExp,fldOutTxt,fldOutSize, "l");
   txtObjFieldEx = list.grid.fieldEx(txtOutExp, txtOutTxt, txtOutSize, "l");
   if( list.gridHeaderHeight>0 && line_i!=0 )
   {
      fldObjFieldEx.Empty()
      txtObjFieldEx.Empty()
   }
}

function tt2expr(tblCl_ttfld)
{
   fldOutExp = tblCl_ttfld("Ffield");
   fldOutTxt = tblCl_ttfld("ftxt");
   txtOutExp = "";
   txtOutTxt = "Назва|Название";
   
   switch( tblCl_ttfld("FTT") )
   {
   case "!!":
      fldOutExp = "=\"Итого\"";
      break;
   case "NM":
      txtOutExp = tblCl_ttfld("FTT")+".ftxts"
      break;
   case "PD":
   case "ML":
   case "PS":
   case "PK":
   case "PD1":
   case "ML1":
   case "OO":
         txtOutExp = tblCl_ttfld("FTT") + ".ftxt"
         break;
   case "SC":
   case "SC1":
         txtOutExp = tblCl_ttfld("FTT") + ".fnazv"
         break;
   case "SU":
         fldOutExp = '=(CStr(^FSC)+"/"+CStr(^FSU))'
         txtOutExp = "SC.fnazv"
         break;
   case "SU1":
         fldOutExp = '=(CStr(^FSC1)+"/"+CStr(^FSU1))'
         txtOutExp = "SC1" + ".fnazv"
         break;
   case "P1":
         fldOutExp = tblCl_ttfld("FTT")+'.fdate'
         txtOutExp = tblCl_ttfld("FTT")+".H.fdoc_num"
         break;
   case "DC":
         break;
   case "OP":
         fldOutExp = '=^fdoc+"-"+CStr(^fnop)';
         break;
   case "DE":
         fldOutExp = tblCl_ttfld("FTT")+'.fdoc_dat'
         txtOutExp = tblCl_ttfld("FTT")+'.fdoc_num'
         break;
   case "DT"://дата
         break;
   case "PP":
         break;
//NI: <Специально для ЧеркассыТрансГаз - для генератора отчетов>
   case "GZ":
         txtOutExp =tblCl_ttfld("FTT")+'.FGRPTXT';
         break;
//END NI: </Специально для ЧеркассыТрансГаз - для генератора отчетов>         
   case "CN":
   case "CN1": // Новая учетна
   case "OC": // Отпускная цена
         break;
   }
   this.fldOutExp = fldOutExp;
   this.fldOutTxt = fldOutTxt;
   this.txtOutExp = txtOutExp;
   this.txtOutTxt = txtOutTxt;
}

// Вернуть строку запроса с фильтром
function sqlwNmk(field,fnmk)
{
	if (!fnmk || Number(fnmk) == 0)
		return "";
	var ret = sqlNmkCond(field,fnmk);
	if (ret)
		return " and " + ret;
	return "";
		
}

function sqlNmkCond(field,fnmk)
{
	var ret = "";
	if( fnmk!=null && fnmk!="" && fnmk!=0)
	{
		var tNmkl = OpenTable(
			"SELECT * FROM ^cl_nmk "
			 + " WHERE fwid=" + sqlTo(Number(fnmk))
			);
		
		if (tNmkl.IsEOF())
			ret = sqlFalse;
		else if (!toScrObj(tNmkl.getValue("fisgrp")))
			ret = field +"="+ sqlTo(fnmk);
		else
			ret = field + " IN (SELECT FWID FROM ^cl_nmk"
				+ " WHERE fleftkey BETWEEN " + tNmkl.getValue("fleftkey") + " AND " + tNmkl.getValue("frightkey")
				+ ")"
		
		/*
		var oSnap = getSnap("SELECT * FROM ^cl_nmk "
						  + " WHERE fwid=" + sqlTo(Number(fnmk))
						  + " AND (FISGRP<>" + sqlTo(true) +" OR FISGRP IS NULL)");
		if (oSnap != null)
			ret = " and "+ field +"="+ sqlTo(fnmk);
		else
		{
			var tmpTbl = getTmpTableName();
			ExecuteSQL("CREATE TABLE " + tmpTbl + "(FWID " + SqlType("LONG",10) + ")");
			var batch = createBatch();
			fillNmkFwids(fnmk,tmpTbl,batch);
			batch.execute(false);
			ret = " AND " + field + " IN (SELECT FWID FROM " + tmpTbl + ")"
		}
		*/
		tNmkl.close();
	}
	return ret;
}

function fillNmkFwids(fnmkl,tblName,batch)
{
	batch.addBatch("INSERT INTO " + tblName
				 + " SELECT FWID FROM ^cl_nmk"
				 + " WHERE FGRPID=" + sqlTo(Number(fnmkl)) 
				 + " AND FISGRP<>" + sqlTo(true));
	var tbl = OpenTable("s","SELECT FWID FROM ^cl_nmk"
					  + " WHERE FGRPID=" + sqlTo(Number(fnmkl))
					  + " AND FISGRP=" + sqlTo(true));
	for (tbl.MoveFirst();!tbl.isEOF();tbl.MoveNext())
		fillNmkFwids(tbl.getValue("FWID"),tblName,batch);
	tbl.close();
}

function sqlwPri(field,fpri)
{
   var ret = ""
   if( fpri!=null && fpri!=0 )
      ret = " and " + field + "="+sqlTo(fpri)
   return ret
}

//---------------------------------
// Обьект по обработке первого прихода
// В this.tbl должно быть поле FID_PN
/*
function pnRef(tblName, val, subRun)
{
   this.tbl = OpenTable("s", tblName);
   this.tbl_r = OpenTable("s","^ANLTK","FWID");
   if (SQL)
		this.tbl_r.Index = "FWID";
   this.fval = val;
   this.recRun = subRun;
   this.isPn = false;   
   // Описания полей 
   this.arrFldExpr = new Array();
   this.init = pnRef_init;
   this.run = pnRef_run;
   this.done = pnRef_done;
   this.recInit = pnRef_recInit;
   this.recDone = pnRef_recDone;
   this.run();
}

function pnRef_init()
{
   if( true )
      this.arrFldExpr["FID_PNH"] = '(this.isPn?this.tbl_r("FID_DOC"):null)';
   if( true )
      this.arrFldExpr["FCENA_PN"] = '(this.isPn?_nv2nv("", this.tbl_r("FDATE"), 0, this.tbl_r("FCENA"), this.fval):0)';
}

function pnRef_recInit()
{
   this.isPn = false;
   this.tbl.Edit();
   if( this.tbl("FID_PN")!=null && this.tbl_r.seek("=", this.tbl("FID_PN")) )
   {
      this.isPn = true;
      for( var i in this.arrFldExpr )
      {
         this.tbl(i) = eval(this.arrFldExpr[i]);
      }
   }
   return this.isPn
}

function pnRef_recDone()
{
   this.tbl.Update();
}

function pnRef_run()
{
   this.init();
   while (!this.tbl.IsEOF())
   {
      this.recInit();
      if( this.recRun )
         this.recRun(this.isPn);
      this.recDone();
      this.tbl.MoveNext();
   }
   this.done();
}

function pnRef_done()
{
   this.tbl = null;
   this.tbl_r = null;
}
*/
function sayNmkl(cFnmkExpr, cCl_nmkAlias)
{
   return (getPar("SHOWNMK")? cFnmkExpr + "+ \" : \"+" : "")
      + "allt(^" + cCl_nmkAlias + ".ftxts)";
}


// Приходит строка на подобии такой XCL_FPOK_100_LABEL2
// а нам нужно сделать такую ?xcl(fpok,100)
//
function checkXCL(fld)
{
	var fld_tmp = fld;
	fld = fld.toLowerCase();
	if (fld.indexOf("xxcl") == 0)
	{		
		fld = fld.substring(0, fld.indexOf("__")) + '(' + fld.substring(fld.indexOf("__")+2,fld.length);
		fld = fld.substring(0, fld.indexOf("__")) + ',' + fld.substring(fld.indexOf("__")+2,fld.length);
		fld = fld.substring(0, fld.indexOf("__")) + ')' + fld.substring(fld.indexOf("__")+2,fld.length);
		fld = fld.substring(0, fld.lastIndexOf(')')+1);
		fld = "?" + fld.toLowerCase();
		return fld;
	}
	return fld_tmp;
}

// Приходит строка на подобии такой XCL_FPOK_100_LABEL2
// а нам нужно сделать такую 100
function getFCL(fld)
{
	var fld_tmp = fld.toLowerCase();
	fld_tmp = fld_tmp.replace('(',"__");
	fld_tmp = fld_tmp.replace(',',"__");
	fld_tmp = fld_tmp.replace(')',"__");
	if (fld_tmp.indexOf("xxcl") == 0 || fld_tmp.indexOf("?xxcl") == 0)
	{		
		fld_tmp = fld_tmp.substring(fld_tmp.indexOf("__")+2,fld_tmp.length);
		fld_tmp = fld_tmp.substring(fld_tmp.indexOf("__")+2,fld_tmp.length);
		fld_tmp = fld_tmp.substring(0, fld_tmp.indexOf("__"));
		return fld_tmp;
	}
	return fld;
}
// Приходит строка на подобии такой XCL_FPOK_100_LABEL2
// а нам нужно сделать такую 100
function getFCL_value(fld)
{
	var fld_tmp = fld.toLowerCase();
	fld_tmp = fld_tmp.replace('(',"__");
	fld_tmp = fld_tmp.replace(',',"__");
	fld_tmp = fld_tmp.replace(')',"__");
	if (fld_tmp.indexOf("xxcl") == 0 || fld_tmp.indexOf("?xxcl") == 0)
	{		
		fld_tmp = fld_tmp.substring(fld_tmp.indexOf("__")+2,fld_tmp.length);
		fld_tmp = fld_tmp.substring(fld_tmp.indexOf("__")+2,fld_tmp.length);
		fld_tmp = fld_tmp.substring(0, fld_tmp.indexOf("__"));
		if (isNaN (Number(fld_tmp)))
		{
			if (fld_tmp.charAt(0) == 'f') // Поле из таблицы
			{
				return "";
			}
			else if (fld_tmp.charAt(0) == '_')
			{
				return String(getPar(fld_tmp.substring(1)));
			}
			else //выражение, рассчитываем через m_oItogExtMap
			{
				if (extPar && typeof(extPar.listPar) != "undefined"
							&& typeof(extPar.listPar.makeTotal) != "undefined")
				{
					if (extPar.listPar.makeTotal.m_oItogExtMap[fld_tmp] != null)
						return extPar.listPar.makeTotal.m_oItogExtMap[fld_tmp];
				}
				else if (typeof(list)!="undefined" && typeof(list.objTotal)!="undefined"
							&& typeof(list.objTotal.makeTotal)!="undefined")
				{
					if (list.objTotal.makeTotal.m_oItogExtMap[fld_tmp] != null)
						return list.objTotal.makeTotal.m_oItogExtMap[fld_tmp];
				}
				
				return "-1";
			}
		}
		return fld_tmp;
	}
	return fld;
}
function getXCLField(fld)
{
	var fld_tmp = fld.toLowerCase();
	fld_tmp = fld_tmp.replace('(',"__");
	fld_tmp = fld_tmp.replace(',',"__");
	fld_tmp = fld_tmp.replace(')',"__");
	if (fld_tmp.indexOf("xxcl") == 0  || fld_tmp.indexOf("?xxcl") == 0)
	{		
		fld_tmp = fld_tmp.substring(fld_tmp.indexOf("__")+2,fld_tmp.length);
		fld_tmp = fld_tmp.substring(0, fld_tmp.indexOf("__"));
		return fld_tmp;
	}
	return fld;
}

function getLabel(fld)
{
	if (fld.lastIndexOf("___") != -1)
		fld = fld.substring(fld.lastIndexOf("___")+2,fld.length);
	else
		fld = fld.substring(fld.lastIndexOf("__")+2,fld.length);
	return fld;
}

function nmkl_rename()
{	
	t_find=OpenTable("m","CL_NMK");
	t_find.Index="COD";
	if (SQL)
		t_find.Index="FCOD";

	debug();
	t = OpenTable("m","CL_NMK");
	// nmkMap Сюда попадают те коды, которые рекурсивно пересекаются как описано ниже
	var nmkMap = new Array();
	var nmkMap_ind = 999999000;
	for(t.MoveFirst(); !t.IsEOF(); t.MoveNext())
	{
		if (t("FCODNEW") != "")
		{
			if (!t_find.Seek("=",t("FCODNEW"))) // простое изменение номера номенклатуры
				nmkl_rename_cod(t("FCOD"), t("FCODNEW"));
			else if (t_find("FCODNEW") == "") // соединяем 2 номенклатуры
				nmkl_rename_cod(t("FCOD"), t("FCODNEW"));
			else if (!t_find.Seek("=",String(nmkMap_ind)))
			{
			// 1 -> 2 но 2 при этом тоже изменяем в какую-то, поэтому нужно
			// сначала разобраться со 2 - ой, а 2-ая сама может так-же рекурсивно
			// ссылаться
				nmkMap[String(nmkMap_ind)] = t("FCODNEW");
				nmkl_rename_cod(t("FCOD"), String(nmkMap_ind));
				nmkMap_ind ++;
			}
		}
	}
	// Теперь, меняем те номенклатуры, которые были рекурсивными
	for(var i in nmkMap)
		if (!t_find.Seek("=",nmkMap[i]))
			nmkl_rename_cod(i, nmkMap[i]);
}

function nmkl_rename_cod(cod_old, cod_new)
{
	tbl=OpenTable("m","CL_NMK");
	tbl.Index="COD";
	if (SQL)
		tbl.Index="FCOD";
	mode = "CHANGE";
	if (tbl.Seek("=",cod_new))
		mode = "COMBINE";
		
	// Ищем в базе в каких таблицах есть номенклатура
	strSQL = "SELECT DISTINCT(A.ftable) from ^strutables A "
		+ " LEFT JOIN ^strufields B ON "
			+ " (A.fpattern = B.fpattern and B.ffield = " + sqlTo("fnmkl") + " )";
	var stru = OpenTable("s", strSQL);
	strSQL = " SET FNMKL = " + sqlTo(cod_new)
			+ " WHERE FNMKL = " + sqlTo(cod_old);
	setProgressRange(0, stru.RecordCount);
	i = 1;
	for(stru.MoveFirst(); !stru.IsEOF(); stru.MoveNext())
	{
		setProgressPos(i, "Обновляется таблица "+stru("FTABLE")+ " " + (i++) + " из " + stru.RecordCount);
		if (stru("FTABLE").search("%LD") == -1) // все кроме прайсов
			ExecuteSQL("UPDATE ^" + stru("FTABLE") + strSQL);
	}
	stru.Close();
	// теперь прайсы, с ними хитро (как в папке прайс листов)
	t_pri = OpenTable("s","SELECT * from ^cl_pri where fdat<>"+sqlD00);
	setProgressRange(0, t_pri.RecordCount);
	i = 1;
	for(t_pri.MoveFirst(); !t_pri.IsEOF(); t_pri.MoveNext())
	{
		name=pName(t_pri("fcod"),t_pri("fdat"));
		setProgressPos(i, "Обновляется прайс "+name+ " " + (i++) + " из " + t_pri.RecordCount);
		ExecuteSQL("UPDATE " + name + strSQL);
	}
	t_pri.Close();
	// Теперь с TOV_OTCH, в нем номенклатура в поле fnmk а не fnmkl
	// почти то же самое что и до этого
	strSQL = "SELECT DISTINCT(A.ftable) from ^strutables A "
		+ " LEFT JOIN ^strufields B ON "
			+ " (A.fpattern = B.fpattern and B.fpattern = " + sqlTo("TOV_OTCH")
			+ " and B.ffield = " + sqlTo("fnmk") + " )";
	stru = OpenTable("s", strSQL);
	strSQL = " SET FNMK = " + sqlTo(cod_new)
			+ " WHERE FNMK = " + sqlTo(cod_old);
	setProgressRange(0, stru.RecordCount);
	i = 1;
	for(stru.MoveFirst(); !stru.IsEOF(); stru.MoveNext())
	{
		setProgressPos(i, "Обновляется таблица "+stru("FTABLE")+ " " + (i++) + " из " + stru.RecordCount);
		if (stru("FTABLE").search("%LD") == -1) // все кроме прайсов
			ExecuteSQL("UPDATE ^" + stru("FTABLE") + strSQL);
	}
	stru.Close();
	setProgressPos(0);

	// изменим код в самом справочнике номенклатуры
	if (mode == "CHANGE")
	{
		ExecuteSQL("UPDATE ^CL_NMK "
			+ " SET FCOD = " + sqlTo(cod_new)
			+ ", FCODNEW = " + sqlTo("")
			+ " WHERE FCOD = " + sqlTo(cod_old));
	}
	else if (mode == "COMBINE") //сливаем 2 номенклатуры в одну
	{
		tbl.Seek("=",cod_old);
		ExecuteSQL("DELETE FROM ^CL_NMK WHERE FWID = " + sqlTo(tbl("fwid")));
	}
}


function getNmklOstKol(datost, nmkl, sc, su, st, podr, mol)
{
	include ("mtr_ost.js");
	var oOb = new DpMtrOb();
	oOb.tblName = getTmpTableName();		
	__setObjParNmklOst(oOb, datost, nmkl, sc, su, st, podr, mol);
	oOb.doCalc();
	
	//browse("select * from " + oOb.tblName)
	var ret = 0;
	var oSnap = getSnap("select sum(FOST) as FRET from " + oOb.tblName);
	if(oSnap && oSnap[0])
		ret = oSnap[0];
	DropTable(oOb.tblName);
	return ret;	
	
}

function  __setObjParNmklOst(oOb, datost, nmkl, sc, su, st, podr, mol)
{
	if(typeof date == "string")
		oOb.fdate = strToDate(date);
	else if (isDateType(date))
		oOb.fdate = new Date(date).getVarDate();
	else
		oOb.fdate = today;
	oOb.fpost = null;
	
	if(nmkl)
	{
		if(typeof nmkl == "string")
		{
			var oSnap = getSnap("select fwid from ^cl_nmk where fcod = " + sqlTo(nmkl));
			if (!oSnap)
				return 0;
			else
				oOb.fnmkl = oSnap[0];
			
		}
		else		
			oOb.fnmkl = nmkl;
	}
	
	if(podr)
		oOb.fpodr = podr;
	if(mol)
		oOb.fmol = mol;
	if(sc)
		oOb.fsc = sc;
	if(su)
		oOb.fsu = su;
	if(st)
		oOb.fst = st;
}

function getNmklOstXML(datost, nmkl, sc, su, st, podr, mol)
{
	include ("mtr_ost.js");
	var oOb = new DpMtrOb();
	oOb.tblName = getTmpTableName();		
	__setObjParNmklOst(oOb, datost, nmkl, sc, su, st, podr, mol);
	oOb.doCalc();
	
	var tbl = OpenTable("select * from " + oOb.tblName + " order by fnmkl, fsc, fsu, fst, fpodr, fmol");
	var ret = tbl.toXML();
	tbl.close();
	DropTable(oOb.tblName);
	return ret;	
}

function getNmklOstCSV(datost, nmkl, sc, su, st, podr, mol)
{
	include ("mtr_ost.js");
	var oOb = new DpMtrOb();
	oOb.tblName = getTmpTableName();		
	__setObjParNmklOst(oOb, datost, nmkl, sc, su, st, podr, mol);
	oOb.doCalc();
	
	var tbl = OpenTable("select * from " + oOb.tblName + " order by fnmkl, fsc, fsu, fst, fpodr, fmol")
	//browse("select * from " + oOb.tblName + " order by fnmkl, fsc, fsu, fst, fpodr, fmol");
	var ret = tbl.toCSV(true);
	tbl.close();
	DropTable(oOb.tblName);
	return ret;	
}

function getNmklOstXMLString(datost, nmkl, sc, su, st, podr, mol)
{
	var el = getNmklOstXML(datost, nmkl, sc, su, st, podr, mol);
	if(el == null)
	{
		return "";
	}
	
	var t = Packages.javax.xml.transform.TransformerFactory.newInstance().newTransformer();
    var sw = new java.io.StringWriter();
    t.setOutputProperty("encoding","utf8");
    t.transform(new Packages.javax.xml.transform.dom.DOMSource(el), 
    				new Packages.javax.xml.transform.stream.StreamResult(sw));
    return String(sw.getBuffer());  
	
}