
function buildPanel()
{
	loadCASDocsPanel();
	loadCASClPanel();
	loadCASCalcPanel();
}

function loadCASDocsPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Первинні документи|Первичные документы"));
	var imgFile = lpProxy.getAppPlugLoc() + "icons/moneybag.gif";	
	panel.addItem("CP", UR("Пpибутковий касовий ордер (CP)|Пpиходный кассовый ордер (CP)"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/moneybag 2.gif";	
	panel.addItem("CR", UR("Видатковий касовий ордер (CR)|Расходный кассовый ордер (CR)"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/briefcase2_document.gif";	
	panel.addItem("AO", UR("Авансовий звіт (AO)|Авансовый отчет (AO)"), imgFile);
	if(checkExistDocs("VD"))
		panel.addItem("VD", UR("Відомість (VD)|Ведомость (VD)"), true);
	panel.addItem("DOCS", UR("Інші документи|Другие документы"), true);
			
	this.selCASHandler = selCASHandler;
	panel.setSelectHandler(this, "selCASHandler");
}

function checkExistDocs(sLBL)
{
	var oSnap = getSnap("select fnop from ^cl_lnk where fdoc = " + sqlTo(sLBL)
			+ " and fnop <> 0 and fused <> " + sqlFalse);
	return oSnap != null;
}

function loadCASClPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Довідники|Справочники"));
	var imgFile = lpProxy.getAppPlugLoc() + "icons/businessman.gif";		
	panel.addItem("CL2",	 UR("Контрагенти|Контрагенты"), imgFile);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/men.gif";
	panel.addItem("CL3", UR("Фізичні особы|Физические лица"), imgFile);	
	
		
	this.selCASHandler = selCASHandler;
	panel.setSelectHandler(this, "selCASHandler");
}

function loadCASCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Вихiднi документи|Выходные документы"));
		
	panel.addItem("CAS", UR("Сторiнка касової книги|Страница кассовой книги"), true);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/finplan.gif";	
	panel.addItem("OBSCH",	UR("Обiги та залишки по 30 рахунку|Обороты и остатки по 30 счету"), imgFile);
	panel.addItem("VIP", 	UR("Аналiз 30 рахунку|Анализ 30 счета"), true);			
			
	this.selCASHandler = selCASHandler;
	panel.setSelectHandler(this, "selCASHandler");
}

function selCASHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "CP":
		case "CR":
		case "AO":
		case "VD":
		case "DOCS":
			var oPar = new Object();		
			oPar.ret = new Object();
			oPar.isZaval = true;			
			if(sID!="DOCS")
			{
				oPar.onlyDoc = sID;
				oPar.simple = true;
			}
			oPar.ret.fdoc = sID;
			oPar.ret.fnop = 0;			
			oPar.title = UR("Виберіть папку|Выберите папку");
			showWindow("l_cl_lnk.xml", SW_MODAL, oPar);		
			if (oPar.escape)
				return false;				
			par.nop = oPar.ret.fnop;
			par.doc = oPar.ret.fdoc;
			sDlg = "l_docekz.xml";
			break;
		case "CL2":
			par.Fcl = getPar("CODPLAT");
			par.Fvid = 2;
			sDlg = "l_cl.xml";
			break;
		case "CL3":
			par.Fcl = getPar("CODPERS");
			par.Fvid = 3;
			sDlg = "l_cl.xml";
			break;
		
		case "CAS":
			sDlg = "r_stkass.js";
			break;
		
		case "OBSCH":
			WriteParameter("FSC","30","l_obsch")
			sDlg = "l_obsch.js";
			break;
		
		case "VIP":
			WriteParameter("FSC","30","cas_panel")
			include("Objects/DpGetDat.js");
			var gd = new DpGetDat("dDcutx0");
			if(gd.escape)
				return;			
			par.psc = gd.fsc;
			par.psu = gd.fsu;
			par.pst = gd.fst;
			par.pcl1 = gd.fcl1;
			par.pcl2 = 0;
			par.pdat = gd.dat1;
			par.pdat2 = gd.dat2;
			sDlg = "r_vip.js";
			break;
				
						
		default:
			return;
	}
	showWindow(sDlg, sType, par);
}