function buildPanel()
{
	loadCRMCntPanel();
	loadCRMDocPanel();
	loadCRMCalcPanel();
	loadCRMTaskPanel();
	//loadCRMParamPanel();
	
	//PANELBAR.getCtrl().setWeights(new Array(12, 10, 21, 15, 12));
}

function loadCRMCntPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Контрагенти|Контрагенты"));
	
	panel.addItem("ORG", UR("Організації|Организации"), true);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/businessman.gif";
	panel.addItem("CONTR", UR("Контрагенти|Контрагенты"), imgFile);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/man.gif";
	panel.addItem("CNT", UR("Контакні особи|Контактные лица"), imgFile);	
			
	this.selCRMHandler = selCRMHandler;
	panel.setSelectHandler(this, "selCRMHandler");
}

function loadCRMCalcPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Звіти|Отчеты"));
	
	//panel.addItem("FULLDOCLIST", UR("Повний список документів|Полный список документов"), true);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/blue book.gif";
	panel.addItem("JCNT", UR("Журнал CRM|Журнал CRM"), imgFile);	
	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/Calculator.gif";
	panel.addItem("ACT", UR("Акт звіряння|Акт сверки"), imgFile);
	panel.addItem("ORG_BALANCE", UR("Баланс контрагентів|Баланс контрагентов"), true);
	panel.addItem("ORG_ACTIVITY", UR("Активність контрагентів|Активность контрагентов"), true);
	panel.addItem("PRODUCTIVITY", UR("Продустивність персоналу|Продуктивность персонала"), true);
	imgFile = lpProxy.getAppPlugLoc() + "icons/Summary-2.gif";
	panel.addItem("REPORTS", UR("Інші звіти|Другие отчеты"), imgFile);
				
	this.selCRMHandler = selCRMHandler;
	panel.setSelectHandler(this, "selCRMHandler");
}

function loadCRMDocPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Документи|Документы"));
	
	panel.addItem("POST", UR("Кореспонденція|Корреспонденция"), true);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/phone 2.gif";
	panel.addItem("CRM.TR", UR("Телеф. розмова|Телеф. разговор"), imgFile);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/mail.gif";
	panel.addItem("MAIL", UR("Ел. пошта|Эл. почта"), imgFile);	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/Meta_16.gif";
	panel.addItem("CALL", UR("Заявки|Заявки"), imgFile);
	panel.addItem("SOLUTIONS", UR("Рішення|Решения"), imgFile);
	panel.addItem("EVENT", UR("Події|События"), true);
	panel.addItem("ORGANIZER", UR("Органайзер|Органайзер"), true);
	panel.addItem("TOPIC", UR("Теми|Темы"), true);
	panel.addItem("ML", UR("Маркетингові списки|Маркетинговые списки"), true);
	panel.addItem("RESPONSE", UR("Відгуки|Отклики"), true);
					
	this.selCRMHandler = selCRMHandler;
	panel.setSelectHandler(this, "selCRMHandler");
}

function loadCRMTaskPanel()
{
	var panel = PANELBAR.createPanel();
	panel.setCaption(UR("Завдання|Задания"));
	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/stamp.gif";
	panel.addItem("TASK", UR("Усі завдання|Все задания"), imgFile);
	panel.addItem("MY_TASK", UR("Мої завдання|Мои задания"), true);
	panel.addItem("OWN_TASK", UR("Призначені мною|Назначенные мной"), true);
	panel.addItem("MY_OWN_TASK", UR("Призначені собі|Назначенные себе"), true);
				
	this.selCRMHandler = selCRMHandler;
	panel.setSelectHandler(this, "selCRMHandler");
}

function loadCRMParamPanel()
{
	pCl = PANELBAR.createPanel();
	pCl.setCaption(UR("Налагодження|Настройки"));
	
	var imgFile = lpProxy.getAppPlugLoc() + "icons/Jrnl.gif";
	pCl.addItem("JORN", UR("Журнали реєстрації|Журналы регистрации"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/t19.gif";
	pCl.addItem("DOCFDR", UR("Папки документів|Папки документов"), imgFile);
	var imgFile = lpProxy.getAppPlugLoc() + "icons/sys_param.gif";
	pCl.addItem("PARAMS", UR("Параметри|Параметры"), imgFile);
				
	this.selCRMHandler = selCRMHandler;
	pCl.setSelectHandler(this, "selCRMHandler");
}

function selCRMHandler(sID, oPanel)
{
	var sDlg = "";
	var par = new Object();
	var sType = SW_NOMODAL;
	switch(sID)
	{
		case "ORG":
			par.Fvid = 2;
			par.Fcl = getPar("CODMYORG");
			/*
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр 'Справочник своих организаций'"
					 	,"Не встановлений параметр 'Довідник своїх організацій'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selCRMHandler("PARAMS");
				return;				
			}
			*/ 
			sDlg = "l_cl.xml";
			break;		
		
		case "CONTR":
			par.Fvid = 2;
			par.Fcl = getPar("CODPLAT");
			/*
			if(!par.Fcl)
			{
				var sMsg = ru("Не установлен параметр для справочника 'поставщики-покупатели'"
					 	,"Не встановлений параметр довідника 'постачальники-покупці'");
				sMsg += ru("\nОткрыть окно для настройки параметров?"
				  		,"\nВідкрити вікно для налагодження параметрів?");
				if(confirm(sMsg))
					selCRMHandler("PARAMS");
				return;
			}
			*/ 			
			sDlg = "l_cl.xml";
			break;
			
		case "CRM.TR":		
		case "MMSG":
		case "POST":
		case "CALL":
		case "SOLUTIONS":
		case "EVENT":
		case "TOPIC":
		case "ML":
		case "RESPONSE":
			par.doc = sID;
			par.nop = 1;
			sDlg = "l_docekz.xml";
			break;
				
		case "TASK":
			par.menuMode = "ALL";
			sDlg = "l_vsslist.js";
			break;			
		
		case "MY_TASK":
			par.menuMode = "MY";
			sDlg = "l_vsslist.js";
			break;
		
		case "OWN_TASK":
			par.menuMode = "OWN";
			sDlg = "l_vsslist.js";
			break;
			
		case "MY_OWN_TASK":
			par.menuMode = "MY_OWN";
			sDlg = "l_vsslist.js";
			break;
		
		case "MAIL":
			par.doc = "MMSG";
			par.nop = 1;
			sDlg = "l_mail.xml";
			break;
			
		case "CNT":
			sDlg = "l_cnt.js";
			break;	
			
		case "JCNT":
			par.JID = "CRM";
			sDlg = "l_crm.xml";		
			
			include("objects/DpJRegistrator.js");
			var oReg = new DpJRegistrator(null, null, "U");
			var jor = oReg.listJournals()[par.JID];	
			if(!jor)
			{
				var sMsg = ru("Не существует журнал с меткой 'CRM'"
					 	,"Не існує журнал з міткою 'CRM'");
				sMsg += ru("\nОткрыть окно для настройки журналов?"
				  		,"\nВідкрити вікно для налагодження журналів?");
				if(confirm(sMsg))
					selCRMHandler("JORN");
				return;
			}
			break;
		
		case "FULLDOCLIST":
			sDlg = "fulldoclist.xml";
			break;
		
		case "ACT":			
			par.JID = "CRM";
			sDlg = "l_crm.xml";		
			
			include("objects/DpJRegistrator.js");
			var oReg = new DpJRegistrator(null, null, "U");
			var jor = oReg.listJournals()[par.JID];	
			if(!jor)
			{
				var sMsg = ru("Не существует журнал с меткой 'CRM'"
					 	,"Не існує журнал з міткою 'CRM'");
				sMsg += ru("\nОткрыть окно для настройки журналов?"
				  		,"\nВідкрити вікно для налагодження журналів?");
				if(confirm(sMsg))
					selCRMHandler("JORN");
				return;
			}
			
			par.tbl_j = jor.getFullTableName();
			par.org = 0;// Number(list.tbl.getValue("Forg"))
			sDlg = "l_dog_act.js";			
			break;
		
		case "ORG_BALANCE":
			sDlg = "subSys/crm/calc/orgbalance.xml";		
			break;
		
		case "ORG_ACTIVITY":
			sDlg = "subSys/crm/calc/orgactivity.xml";		
			break;
			
		case "PRODUCTIVITY":
			sDlg = "subSys/crm/calc/productivity.xml";		
			break;
			
		case "REPORTS":
			par.ret = new Object();
			par.ret.FID = null;
			showWindow("reports:list.xml", SW_MODAL, par);
			if(par.escape)
				return;
			var oPar = new Object();
			oPar.name = par.ret.FID;
			showWindow("reports:report.xml", SW_NOMODAL, oPar);
			break;

		case "ORGANIZER":
			sDlg = "organizer.xml";		
			break;	

		case "JORN":
			par.jtype = "U";
			sDlg = "l_cl_usrjrnl.xml";		
			break;	
		
		case "DOCFDR":
			sDlg = "l_cl_lnk.xml";
			break;
							
		case "PARAMS":
			sType = SW_MODAL;
			par.sel = "CRM";
			sDlg = "e_param.xml";
			break;			
					
		default:
			return;
	}
	if(sDlg!="")
		showWindow(sDlg, sType, par);
}