function DpTestResult(sClass, sFunc)
{
	this.nRuns = 0;	
	
	this.arrErrors = new Array();
	this.arrFailures = new Array();
	
	this.addResult = DpTestResult_addResult;
	
	this.getRuns = DpTestResult_getRuns;
	this.getErrors = DpTestResult_getErrors;
	this.getFailures = DpTestResult_getFailures;
	
	this.addRun = DpTestResult_addRun;
	this.addError = DpTestResult_addError;
	this.addFailure = DpTestResult_addFailure;
	this.sTestNameClass = sClass;
	this.sFuncName = sFunc;
}

function DpTestResult_addResult(oTestResult)
{		
	this.nRuns += oTestResult.getRuns()
	var arrNewErr = oTestResult.getErrors();	
	for(var i = 0; i < arrNewErr.length; i++)
	{
		this.arrErrors[this.arrErrors.length] = arrNewErr[i];
	}	
	
		
	var arrNewFail = oTestResult.getFailures();
	for(var i = 0; i < arrNewFail.length; i++)
	{
		this.arrFailures[this.arrFailures.length] = arrNewFail[i];
	}
	
	this.nFailures += oTestResult.getFailures()
}

function DpTestResult_getRuns()
{
	return this.nRuns;
}

function DpTestResult_getErrors()
{	
	return this.arrErrors;
}

function DpTestResult_getFailures()
{
	return this.arrFailures;
}
function DpTestResult_addRun()
{
	this.nRuns++;
	
}

function DpTestResult_addError(sMsg)
{
	this.nErrors++;
	this.arrErrors[this.arrErrors.length] 
			= new DpResultError(this.sTestNameClass,  this.sFuncName, sMsg);
	
}

function DpTestResult_addFailure(sException)
{
	this.nFailures++;
	this.arrErrors[this.arrFailures.length] 
			= new DpResultFailure(this.sTestNameClass,  this.sFuncName, sException);
}

function DpResultFailure(sClass, sFunc, sMsg)
{
	this.sTestClass = sClass;
	this.sTestFunc = sFunc;
	this.sExceptMsg = sMsg;
}

function DpResultError(sClass, sFunc, sMsg)
{
	this.sTestClass = sClass;
	this.sTestFunc = sFunc;
	this.sMsg = sMsg;
}