include("objects\\DpGetDat.js");
include("objects\\DpTVars.js");
include("sys/udfs.js");

var gd, d1, d2, d, de;
var h, tbl, tv;

function onLoad()
{
	Caption(UR("Оборотність|Оборачиваемость"));
	setButton(btnOOA, calcOOA);		//К-т оборачиваемости обор.активов
	setButton(btnOZ, calcOZ);		//К-т оборачиваемости запасов
	setButton(btnODZ, calcODZ);		//К-т оборачиваемости деб. задолж.
	setButton(btnOKZ, calcOKZ);		//К-т оборачиваемости кред. задолж.
	setButton(btnPOOA, calcPOOA);	//Продолж.одного оборота обор.активов
	setButton(btnPOZ, calcPOZ);		//Продолж.одного оборота запасов
	setButton(btnPODZ, calcPODZ);	//Продолж.одного оборота деб.задолж.
	setButton(btnPOKZ, calcPOKZ);	//Продолж.одного оборота кред.задолж.
}

function init()
{
	// создать объект для запроса дат и , если нужно, счета
	gd = new DpGetDat("dD");
	if(gd.escape)
		return false;
	d1 = new Date(gd.dat1);
	d2 = new Date(gd.dat2);
	//создадим таблицу которую будем выводить в Excel документ
	DropTable("TMP_OPG");
	ExecuteSQL("CREATE TABLE TMP_OPG(Fyear "+SqlType("TEXT")
					+", Fkoef "+SqlType("DOUBLE")
					+", Fpr "+SqlType("MONEY")
					+", Fob "+SqlType("MONEY")+")");
	return true;
}

function showXlsDoc(prnPat, title, h1, h2, h3, h4)//вывод документа
{
	tv = new DpTVars("LIST",prnPat);
	tbl = OpenTable("s","TMP_OPG");
	tv.setRTbl(tbl);
	h = new Object();
	h.FYEAR = h1;
	h.FKOEF = h2;
	h.FPR = h3;
	h.FOB = h4;
	tv.setHTbl(h);
	tv.setVar("text",title);
	tv.print();
	tbl.close();
}

function calcOOA()//obsch_kav.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,21,0,0,0,0,0)+
				sl_("D",de,0,25,0,0,0,0,0)+sl_("D",de,0,24,0,0,0,0,0)+
				sl_("D",de,0,26,0,0,0,0,0)+sl_("D",de,0,27,0,0,0,0,0)+
				sl_("D",de,0,28,0,0,0,0,0)+sl_("D",de,0,34,0,0,0,0,0)+
				sl_("D",de,0,36,0,0,0,0,0)-sl_("K",de,0,38,0,0,0,0,0)+
				sl_("D",de,0,64,0,0,0,0,0)+sl_("D",de,0,65,0,0,0,0,0)+
				sl_("D",de,0,36,0,0,0,0,0)+sl_("D",de,0,68,0,0,0,0,0)+
				sl_("D",de,0,37,0,0,0,0,0)+sl_("D",de,0,35,0,0,0,0,0)+
				sl_("D",de,0,30,0,0,0,0,0)+sl_("D",de,0,31,0,0,0,0,0)+
				sl_("D",de,0,33,0,0,0,0,0)
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		m.Fyear = String(de.getFullYear());
		if ( akTotal !=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т оборотності обор.активів|К-т оборачиваемости обор.активов",
			"Діапазон|Диапазон", "К-т оборотн.обор.активів|К-т оборач.обор.активов",
			"Чиста виручка від реалізації|Чистая выручка от реализации",
			"Сер.сума обор.активів|Средн.сумма обор.активов");
}

function calcOZ()//obsch_koz.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,25,0,0,0,0,0)+
                          sl_("D",de,0,23,0,0,0,0,0)+sl_("D",de,0,24,0,0,0,0,0)+
                          sl_("D",de,0,26,0,0,0,0,0)+sl_("D",de,0,27,0,0,0,0,0)+
                          sl_("D",de,0,28,0,0,0,0,0)
		//себестоимость об.деб.90 сч. 
		psTotal = ob_("",d,de,0,90,0)
		m.Fyear = String(de.getFullYear());
		if (akTotal!=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т оборотності запасів|К-т оборачиваемости запасов",
			"Діапазон|Диапазон", "К-т оборотн.запасів|К-т оборач.запасов",
			"Собіварт.реал.прод.|Себестоим.реал.прод.",
			"Сер.варт.запасів|Средн.ст-ть запасов");
}

function calcODZ()//obsch_kod.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("D",de,0,36,0,0,0,0,0);
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643);
		m.Fyear = String(de.getFullYear());
		if (akTotal!=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т оборотності деб.заборг.|К-т оборачиваемости деб.задолж.",
			"Діапазон|Диапазон", "К-т оборотн.деб.заборг.|К-т оборач.деб.задолж.",
			"Собіварт.реал.прод.|Себестоим.реал.прод.",
			"Сер.варт.запасів|Средн.ст-ть запасов");
}

function calcOKZ()//obsch_kok.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("K",de,0,63,0,0,0,0,0)
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		m.Fyear = String(de.getFullYear());
		if (akTotal!=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т оборотності кред.заборг.|К-т оборачиваемости кред.задолж.",
			"Діапазон|Диапазон", "К-т оборотн.кред.заборг.|К-т оборач.кред.задолж.",
			"Собіварт.реал.прод.|Себестоим.реал.прод.",
			"Сер.варт.запасів|Средн.ст-ть запасов");
}

function calcPOOA()//obsch_poa.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal2 = sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,21,0,0,0,0,0)+
                          sl_("D",de,0,25,0,0,0,0,0)+sl_("D",de,0,24,0,0,0,0,0)+
                          sl_("D",de,0,26,0,0,0,0,0)+sl_("D",de,0,27,0,0,0,0,0)+
                          sl_("D",de,0,28,0,0,0,0,0)+sl_("D",de,0,34,0,0,0,0,0)+
                          sl_("D",de,0,36,0,0,0,0,0)-sl_("K",de,0,38,0,0,0,0,0)+
                          sl_("D",de,0,64,0,0,0,0,0)+sl_("D",de,0,65,0,0,0,0,0)+
                          sl_("D",de,0,36,0,0,0,0,0)+sl_("D",de,0,68,0,0,0,0,0)+
                          sl_("D",de,0,37,0,0,0,0,0)+sl_("D",de,0,35,0,0,0,0,0)+
                          sl_("D",de,0,30,0,0,0,0,0)+sl_("D",de,0,31,0,0,0,0,0)+
                          sl_("D",de,0,33,0,0,0,0,0)
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal2 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		akTotal = round(psTotal2/akTotal2,2)
		//календ.дни
		psTotal = 360
		m.Fyear = String(de.getFullYear());
		if ( akTotal !=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Продовж.одного обороту обор.активів|Продолж.одного оборота обор.активов",
			"Діапазон|Диапазон", "Продовж.одного обороту обор.активів|Продолж.одного оборота обор.активов",
			"К-ть календ.днів звітн.періоду|К-во календ.дней отч.периода",
			"К-т обор.обор.активів|К-т обор.обор.активов");
}

function calcPOZ()//obsch_poz.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal2 = sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,25,0,0,0,0,0)+
					sl_("D",de,0,23,0,0,0,0,0)+sl_("D",de,0,24,0,0,0,0,0)+
					sl_("D",de,0,26,0,0,0,0,0)+sl_("D",de,0,27,0,0,0,0,0)+
					sl_("D",de,0,28,0,0,0,0,0);
		//себестоимость об.деб.90 сч. 
		psTotal2 = ob_("",d,de,0,90,0)
		akTotal = round(psTotal2/akTotal2,2)
		//календ.дни
		psTotal = 360
		m.Fyear = String(de.getFullYear());
		if (akTotal!=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Продовж.одного обороту запасів|Продолж.одного оборота запасов",
			"Діапазон|Диапазон", "Продовж.одного обороту обор.запасів|Продолж.одного оборота обор.запасов",
			"К-ть календ.днів звітн.періоду|К-во календ.дней отч.периода",
			"К-т обор.обор.активів|К-т обор.обор.активов");
}

function calcPODZ()//obsch_pod.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal2 = sl_("D",de,0,36,0,0,0,0,0);
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal2 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643);
		akTotal = round(psTotal2/akTotal2,2);
		//календ.дни
		psTotal = 360;
		m.Fyear = String(de.getFullYear());
		if ( akTotal !=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Продовж.одного обороту деб.заборг.|Продолж.одного оборота деб.задолж.",
			"Діапазон|Диапазон", "Середній період погаш.деб.заборг.|Средний период погаш.деб.задолж.",
			"К-ть календ.днів звітн.періоду|К-во календ.дней отч.периода",
			"К-т обор.деб.заборг.|К-т обор.деб.задолж.");
}

function calcPOKZ()//obsch_pok.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (de<new Date(lastDay(new Date(d2.getFullYear()+1,11,1)))); i++)
	{
		akTotal = sl_("K",de,0,63,0,0,0,0,0);
		//чистая выручка = об.кр.70 сч. - НДС
		psTotal = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643);
		akTotal = round(psTotal2/akTotal2,2);
		//календ.дни
		psTotal = 360;
		m.Fyear = String(de.getFullYear());
		if (akTotal!=0)
			m.Fkoef = (psTotal/akTotal);
		else
			m.Fkoef = 0;
		m.Fpr = akTotal;
		m.Fob = psTotal;
		de = new Date(lastDay(new Date(de.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Продовж.одного обороту кред.заборг.|Продолж.одного оборота кред.задолж.",
			"Діапазон|Диапазон", "Середній період погаш.кред.заборг.|Средний период погаш.кред.задолж.",
			"К-ть календ.днів звітн.періоду|К-во календ.дней отч.периода",
			"К-т обор.кред.заборг.|К-т обор.кред.задолж.");
}
include("sys\\DpBaseDlg.js");