include("objects\\DpGetDat.js");
include("objects\\DpTVars.js");
include("sys/udfs.js");

var gd, d1, d2, d, de;
var h, tbl, tv;

function onLoad()
{
	Caption(UR("Платоспроможність|Платежноспособность"));
	setButton(btnOSIS, calcOSIS);	//К-т обеспеч.собств.источниками средств
	setButton(btnFN, calcFN);	//К-т финансовой независимости
	setButton(btnFU, calcFU);	//К-т финансовой устойчивости
	setButton(btnFL, calcFL);	//К-т финансового ливериджа
}

function init()
{
	// создать объект для запроса дат и , если нужно, счета
	gd = new DpGetDat("dD");
	if(gd.escape)
		return false;
	d1 = new Date(gd.dat1);
	d2 = new Date(gd.dat2);
	//создадим таблицу которую будем выводить в Excel документ
	DropTable("TMP_OPG");
	ExecuteSQL("CREATE TABLE TMP_OPG(Fyear "+SqlType("TEXT")
					+", Fkoef "+SqlType("DOUBLE")
					+", Fpr "+SqlType("MONEY")
					+", Fob "+SqlType("MONEY")+")");
	return true;
}

function showXlsDoc(prnPat, title, h1, h2, h3, h4)//вывод документа
{
	tv = new DpTVars("LIST",prnPat);
	tbl = OpenTable("s","TMP_OPG");
	tv.setRTbl(tbl);
	h = new Object();
	h.FYEAR = h1;
	h.FKOEF = h2;
	h.FPR = h3;
	h.FOB = h4;
	tv.setHTbl(h);
	tv.setVar("text",title);
	tv.print();
	tbl.close();
}

function calcOSIS()//obsch_klii.js YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(lastday(new Date(d1.getFullYear(),11,1)));
	de = new Date(lastDay(new Date(d2.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<=de) ; i++)
	{
		chTotal1 = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
					sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
					sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
					sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
					sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
					sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
					sl_("K", new Date(lastDay(d)),0,49,0)
		chTotal2 = (sl_("D", new Date(lastDay(d)),0,10,0)+sl_("D", new Date(lastDay(d)),0,11,0)+
					sl_("D", new Date(lastDay(d)),0,12,0)-sl_("K", new Date(lastDay(d)),0,13,0)+
					sl_("D", new Date(lastDay(d)),0,14,0)+sl_("D", new Date(lastDay(d)),0,15,0)+
					sl_("D", new Date(lastDay(d)),0,16,0)+sl_("D", new Date(lastDay(d)),0,17,0)+
					sl_("D", new Date(lastDay(d)),0,18,0)-sl_("K", new Date(lastDay(d)),0,19,0))
		//строка 380 баланса +430 баланса-080 строка баланса
		chTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
					sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
					sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
					sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
					sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
					sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
					sl_("K", new Date(lastDay(d)),0,49,0)-
					(sl_("D", new Date(lastDay(d)),0,10,0)+sl_("D", new Date(lastDay(d)),0,11,0)+
					sl_("D", new Date(lastDay(d)),0,12,0)-sl_("K", new Date(lastDay(d)),0,13,0)+
					sl_("D", new Date(lastDay(d)),0,14,0)+sl_("D", new Date(lastDay(d)),0,15,0)+
					sl_("D", new Date(lastDay(d)),0,16,0)+sl_("D", new Date(lastDay(d)),0,17,0)+
					sl_("D", new Date(lastDay(d)),0,18,0)-sl_("K", new Date(lastDay(d)),0,19,0))
		// строка 100-250 баланса (т.е. 260 баланса)
		znTotal = sl_("D", new Date(lastDay(d)) ,0,20)+sl_("D", new Date(lastDay(d)) ,0,21)+
					sl_("D", new Date(lastDay(d)) ,0,25)+sl_("D", new Date(lastDay(d)) ,0,23)+
					sl_("D", new Date(lastDay(d)) ,0,26)+sl_("D", new Date(lastDay(d)) ,0,27)+
					sl_("D", new Date(lastDay(d)) ,0,28)+
					sl_("D", new Date(lastDay(d)) ,0,30)+sl_("D", new Date(lastDay(d)) ,0,31)+
					sl_("D", new Date(lastDay(d)) ,0,32)+sl_("D", new Date(lastDay(d)) ,0,33)+
					sl_("D", new Date(lastDay(d)) ,0,34)+sl_("D", new Date(lastDay(d)) ,0,35)+
					sl_("D", new Date(lastDay(d)) ,0,64)+sl_("D", new Date(lastDay(d)) ,0,65)+
					sl_("D", new Date(lastDay(d)) ,0,36)-sl_("K", new Date(lastDay(d)) ,0,38)+
					sl_("D", new Date(lastDay(d)) ,0,63)+sl_("D", new Date(lastDay(d)) ,0,68,682)+
					sl_("D", new Date(lastDay(d)) ,0,68,683)+sl_("D", new Date(lastDay(d)) ,0,68,685)+
					sl_("D", new Date(lastDay(d)) ,0,68,684)+sl_("D", new Date(lastDay(d)) ,0,37)-
					sl_("K", new Date(lastDay(d)) ,0,37,371)+sl_("D", new Date(lastDay(d)) ,0,24)

		m.Fyear = String(d.getFullYear());
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(lastday(new Date(d.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т забесп.власн.джерелами засобів|К-т обеспеч.собств.источниками средств",
			"Діапазон|Диапазон", "К-т абсол.ліквідн.|К-т абсол.ликвидн.",
			"Власн.капітал-сть ОЗ та інших необ.активів|Собств.капитал-сть ОС и прочих необ.активов",
			"Оборотні активи|Оборотные активы");
}

function calcFN()//obsch_klin.js YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(lastday(new Date(d1.getFullYear(),11,1)));
	de = new Date(lastDay(new Date(d2.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<=de) ; i++)
	{
		//строка 380 баланса +430 баланса+630 баланса
		chTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
				sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
				sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
				sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
				sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
				sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
				sl_("K", new Date(lastDay(d)), 0,69)
		//строка 640
		//строка 380 баланса +430 баланса+480 баланса+620+630 баланса
		znTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
				sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
				sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
				sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
				sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
				sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
				sl_("K", new Date(lastDay(d)),0,49,0)+sl_("K", new Date(lastDay(d)),0,50,0)+
				sl_("K", new Date(lastDay(d)),0,51,0)+sl_("K", new Date(lastDay(d)),0,52,0)+
				sl_("K", new Date(lastDay(d)),0,54,0)+sl_("K", new Date(lastDay(d)),0,55,0)+
				sl_("K", new Date(lastDay(de)) ,0,60)+sl_("K", new Date(lastDay(de)), 0,61)+
				sl_("K", new Date(lastDay(de)), 0,62)+sl_("K", new Date(lastDay(de)) ,0,63)+
				sl_("K", new Date(lastDay(de)), 0,64)+sl_("K", new Date(lastDay(de)) ,0,65)+
				sl_("K", new Date(lastDay(de)), 0,66)+sl_("K", new Date(lastDay(de)) ,0,67)+
				sl_("K", new Date(lastDay(de)), 0,68,681)-sl_("D", new Date(lastDay(de)), 0,68,681)+
				sl_("K", new Date(lastDay(de)), 0,68,682)+sl_("K", new Date(lastDay(de)), 0,68,683)+
				sl_("K", new Date(lastDay(de)), 0,68,684)+sl_("K", new Date(lastDay(de)), 0,68,685)+
				sl_("K", new Date(lastDay(de)), 0,36)+sl_("K", new Date(lastDay(de)), 0,37,372)+
				sl_("K", new Date(lastDay(de)), 0,37,373)+sl_("K", new Date(lastDay(de)), 0,37,374)+
				sl_("K", new Date(lastDay(de)), 0,37,375)+sl_("K", new Date(lastDay(de)), 0,37,376)+
				sl_("K", new Date(lastDay(de)), 0,37,377)+sl_("K", new Date(lastDay(d)), 0,69)
		m.Fyear = String(d.getFullYear());
		if ( znTotal !=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(lastday(new Date(d.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т фінансової незалежності|К-т финансовой независимости",
			"Діапазон|Диапазон", "К-т фін.незалежн.(автономії)|К-т фин.независ.(автономии)",
			"Власн.капітал|Собств.капитал", "Підсумок балансу|Итог баланса");
}

function calcFU()//obsch_klit.js YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(lastday(new Date(d1.getFullYear(),11,1)));
	de = new Date(lastDay(new Date(d2.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<=de) ; i++)
	{
		//строка 380 баланса +430 баланса+480 баланса+630 баланса
		chTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
                          sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
                          sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
                          sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
                          sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
                          sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
                          sl_("K", new Date(lastDay(d)),0,49,0)+sl_("K", new Date(lastDay(d)),0,50,0)+
                          sl_("K", new Date(lastDay(d)),0,51,0)+sl_("K", new Date(lastDay(d)),0,52,0)+
                          sl_("K", new Date(lastDay(d)),0,54,0)+sl_("K", new Date(lastDay(d)),0,55,0)+
                          sl_("K", new Date(lastDay(d)), 0,69)

		//строка 640
		//строка 380 баланса +430 баланса+480 баланса+620+630 баланса
		znTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
                          sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
                          sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
                          sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
                          sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
                          sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
                          sl_("K", new Date(lastDay(d)),0,49,0)+sl_("K", new Date(lastDay(d)),0,50,0)+
                          sl_("K", new Date(lastDay(d)),0,51,0)+sl_("K", new Date(lastDay(d)),0,52,0)+
                          sl_("K", new Date(lastDay(d)),0,54,0)+sl_("K", new Date(lastDay(d)),0,55,0)+
		          sl_("K", new Date(lastDay(de)) ,0,60)+sl_("K", new Date(lastDay(de)), 0,61)+
                          sl_("K", new Date(lastDay(de)), 0,62)+sl_("K", new Date(lastDay(de)) ,0,63)+
                          sl_("K", new Date(lastDay(de)), 0,64)+sl_("K", new Date(lastDay(de)) ,0,65)+
                          sl_("K", new Date(lastDay(de)), 0,66)+sl_("K", new Date(lastDay(de)) ,0,67)+
                          sl_("K", new Date(lastDay(de)), 0,68,681)-sl_("D", new Date(lastDay(de)), 0,68,681)+
                          sl_("K", new Date(lastDay(de)), 0,68,682)+sl_("K", new Date(lastDay(de)), 0,68,683)+
                          sl_("K", new Date(lastDay(de)), 0,68,684)+sl_("K", new Date(lastDay(de)), 0,68,685)+
                          sl_("K", new Date(lastDay(de)), 0,36)+sl_("K", new Date(lastDay(de)), 0,37,372)+
                          sl_("K", new Date(lastDay(de)), 0,37,373)+sl_("K", new Date(lastDay(de)), 0,37,374)+
                          sl_("K", new Date(lastDay(de)), 0,37,375)+sl_("K", new Date(lastDay(de)), 0,37,376)+
                          sl_("K", new Date(lastDay(de)), 0,37,377)+sl_("K", new Date(lastDay(d)), 0,69)
		m.Fyear = String(d.getFullYear());
		if (znTotal!=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(lastday(new Date(d.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т фінансової стійкості|К-т финансовой устойчивости",
			"Діапазон|Диапазон", "К-т фін.стійкості|К-т фин.устойчивости",
			"Власн.капітал+довгострок.забов-ня|Собств.капитал+долгосрочн.обяз-ва",
			"Підсумок балансу|Итог баланса");
}

function calcFL()//obsch_klil.js YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(lastday(new Date(d1.getFullYear(),11,1)));
	de = new Date(lastDay(new Date(d2.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<=de) ; i++)
	{
		//строка 480 баланса
		chTotal = sl_("K", new Date(lastDay(d)),0,50,0)+sl_("K", new Date(lastDay(d)),0,51,0)+
				sl_("K", new Date(lastDay(d)),0,52,0)+sl_("K", new Date(lastDay(d)),0,53,0)+
				sl_("K", new Date(lastDay(d)),0,54,0)+sl_("K", new Date(lastDay(d)),0,55,0)
		//строка 380 баланса +430 баланса+630 баланса
		znTotal = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
				sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
				sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)+
				sl_("K", new Date(lastDay(d)),0,79,0)-sl_("D", new Date(lastDay(d)),0,79,0)-
				sl_("D", new Date(lastDay(d)),0,46,0)-sl_("D", new Date(lastDay(d)),0,45,0)+          
				sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
				sl_("K", new Date(lastDay(d)), 0,69)
		m.Fyear = String(d.getFullYear());
		if (znTotal!=0)
			m.Fkoef = (chTotal/znTotal);
		else
			m.Fkoef = 0;
		m.Fpr = chTotal;
		m.Fob = znTotal;
		d = new Date(lastday(new Date(d.getFullYear()+1,11,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т фінансового ліверіджа|К-т финансового ливериджа",
			"Діапазон|Диапазон", "К-т фін.ліверіджа|К-т фин.ливериджа",
			"Довгострок.забов-ня|Долгосрочн.обяз-ва", "Власний капітал|Собств.капитал");
}
include("sys\\DpBaseDlg.js");