include("objects\\DpGetDat.js");
include("objects\\DpTVars.js");
include("sys/udfs.js");

var gd, d1, d2, d, de;
var h, tbl, tv;

function onLoad()
{
	Caption(UR("Рентабельність|Рентабельность"));
	setButton(btnRAPG, calcRAPG);	//Рентабельность активов предприятия по годам
	setButton(btnRAPM, calcRAPM);	//Рентабельность активов предприятия по месяцам
	setButton(btnRPG, calcRPG);		//Рентабельность продукции по годам
	setButton(btnRPM, calcRPM);		//Рентабельность продукции по месяцам
	setButton(btnRSKG, calcRSKG);	//Рентабельность собств. капитала по годам
	setButton(btnRSKM, calcRSKM);	//Рентабельность собств. капитала по месяцам
	setButton(btnRRG, calcRRG);		//Рентабельность реализации по годам
	setButton(btnRRM, calcRRM);		//Рентабельность реализации по месяцам
	setButton(btnRCAG, calcRCAG);	//Рентабельность чистых активов по годам
	setButton(btnRCAM, calcRCAM);	//Рентабельность чистых активов по месяцам
	setButton(btnKP, calcKP);		//К-т прибыльности
	setButton(btnKOP, calcKOP);		//К-т общей прибыльности
	setButton(btnAVPZ, calcAVPZ);	//Анализ возможности просроч.задолж.
}

function init()
{
	// создать объект для запроса дат и , если нужно, счета
	gd = new DpGetDat("dD");
	if(gd.escape)
		return false;
	d1 = new Date(gd.dat1);
	d2 = new Date(gd.dat2);
	//создадим таблицу которую будем выводить в Excel документ
	DropTable("TMP_OPG");
	ExecuteSQL("CREATE TABLE TMP_OPG(Fyear "+SqlType("TEXT")
					+", Fkoef "+SqlType("DOUBLE")
					+", Fpr "+SqlType("MONEY")
					+", Fob "+SqlType("MONEY")+")");
	return true;
}

function showXlsDoc(prnPat, title, h1, h2, h3, h4)//вывод документа
{
	tv = new DpTVars("LIST",prnPat);
	tbl = OpenTable("s","TMP_OPG");
	tv.setRTbl(tbl);
	h = new Object();
	h.FYEAR = h1;
	h.FKOEF = h2;
	h.FPR = h3;
	h.FOB = h4;
	tv.setHTbl(h);
	tv.setVar("text",title);
	tv.print();
	tbl.close();
}

function calcRAPG()//вместо obsch_rent.js  YANA_2005_10_27 взят расчет из ob_reng.js CVS (К-т рентабельности по годам)
{
	if(!init())
		return false;
	var d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	var de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))) ; i++)
	{
		obTotal = ob_("D", d, de ,0,23,0)
			  +ob_("D", d, de ,0,90)
			  +ob_("D", d, de ,0,91)
			  +ob_("D", d, de ,0,92)
			  +ob_("D", d, de ,0,93)
			  +ob_("D", d, de ,0,94);
		slTotal = sl_("K", de, 0, 44)
					- sl_("D", de, 0, 44);	//прибыль-убыток
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т рентабельності по роках|К-т рентабельности по годам",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRAPM()//вместо obsch_rentm.js  YANA_2005_10_27 взят расчет obsch_Rent.js CVS (К-т рентабельности помесячно)
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		obTotal = ob_("D", d, new Date(lastDay(d)),0,23,0)
			  +ob_("D", d, new Date(lastDay(d)),0,90)
			  +ob_("D", d, new Date(lastDay(d)),0,91)
			  +ob_("D", d, new Date(lastDay(d)),0,92)
			  +ob_("D", d, new Date(lastDay(d)),0,93)
			  +ob_("D", d, new Date(lastDay(d)),0,94);

		slTotal	= ob_("K", d, new Date(lastDay(d)),0,0,79)
				-ob_("D", d, new Date(lastDay(d)),0,79,0) ;	//прибыль-убыток

		m.Fyear	= tmonth(d, "mt")+", "+d.getFullYear();
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т рентабельності щомісячно|К-т рентабельности помесячно",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRPG()//obsch_reng.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		obTotal = ob_("D", d, de ,0,23,0)
			  +ob_("D", d, de ,0,90)
			  +ob_("D", d, de ,0,91)
			  +ob_("D", d, de ,0,92)
			  +ob_("D", d, de ,0,93)
			  +ob_("D", d, de ,0,94);
		slTotal = sl_("K", de, 0, 44) - sl_("D", de, 0, 44);// прибыль-убыток
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність продукції по роках|Рентабельность продукции по годам",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRPM()//obsch_rengm.js  YANA_2005_10_27 недоделан
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643);
		//строка  40 формы 2
		obTotal1 = ob_("D", d, de ,0,90);
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка 60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643);
		//строка  70+80+90 формы 2
		obTotalpr = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94);
		//строка 100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		slTotal = str100;
		obTotal = obTotal1;
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if(obTotal!=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність продукції по місяцях|Рентабельность продукции по месяцам",
			"Діапазон|Диапазон", "К-т рентабельності|К-т рентабельности",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRSKG()//obsch_renk.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		obTotal = sl_("K",de,0,40,0,0,0,0,0)+sl_("K",de,0,41,0,0,0,0,0)+
				sl_("K",de,0,42,0,0,0,0,0)+sl_("K",de,0,43,0,0,0,0,0)+
				sl_("K",de,0,44,0,0,0,0,0)+sl_("D",de,0,44,0,0,0,0,0)-
				sl_("K",de,0,46,0,0,0,0,0)-sl_("K",de,0,45,0,0,0,0,0);
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643);
		//строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90);
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643);
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94);
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72);
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73);
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643);
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97);
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180)?str170-str180:0;
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210)
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність власн. капіталу по роках|Рентабельность собств. капитала по годам",
			"Діапазон|Диапазон", "Рентаб.власн.капіталу|Рентаб.собств.капитала",
			"Чистий прибуток|Чистая прибыль", "Власн.капітал|Собств.капитал");
}

function calcRSKM()//obsch_renkm.js  YANA_2005_10_27 недоделан
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		obTotal = sl_("K",de,0,40,0,0,0,0,0)+sl_("K",de,0,41,0,0,0,0,0)+
				sl_("K",de,0,42,0,0,0,0,0)+sl_("K",de,0,43,0,0,0,0,0)+
				sl_("K",de,0,44,0,0,0,0,0)+sl_("D",de,0,44,0,0,0,0,0)-
				sl_("K",de,0,46,0,0,0,0,0)-sl_("K",de,0,45,0,0,0,0,0);
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		//строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90)
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643)
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94)
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72)
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73)
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643)
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97)
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180,str170-str180,0)
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210)
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність власн. капіталу по місяцях|Рентабельность собств. капитала по месяцам",
			"Діапазон|Диапазон", "Рентаб.власн.капіталу|Рентаб.собств.капитала",
			"Чистий прибуток|Чистая прибыль", "Власн.капітал|Собств.капитал");
}

function calcRRG()//obsch_renp.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		//строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90)
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643)
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94)
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72)
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73)
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643);
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97);
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180)?str170-str180:0;
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210);
		obTotal = str35;
		m.Fyear	= String(d.getFullYear());
		if(obTotal!=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність реалізації по роках|Рентабельность реализации по годам",
			"Діапазон|Диапазон", "Рентаб.продажів|Рентаб.продаж",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRRM()//obsch_renpm.js  YANA_2005_10_27 недоделан
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		//строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90)
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643)
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94)
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72)
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73)
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643)
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97)
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180)?str170-str180:0;
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210)
		obTotal = str35;
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність реалізації по місяцях|Рентабельность реализации по месяцам",
			"Діапазон|Диапазон", "Рентаб.продажів|Рентаб.продаж",
			"Прибуток|Прибыль", "Собівартість|Себестоимость");
}

function calcRCAG()//obsch_renc.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		obTotal = sl_("D",de,0,10,0,0,0,0,0)+sl_("D",de,0,11,0,0,0,0,0)+
				sl_("D",de,0,12,0,0,0,0,0)-sl_("K",de,0,13,0,0,0,0,0)+
				sl_("D",de,0,14,0,0,0,0,0)+sl_("D",de,0,15,0,0,0,0,0)+
				sl_("D",de,0,16,0,0,0,0,0)+sl_("D",de,0,17,0,0,0,0,0)+
				sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,25,0,0,0,0,0)+
				sl_("D",de,0,21,0,0,0,0,0)+sl_("D",de,0,23,0,0,0,0,0)+
				sl_("D",de,0,24,0,0,0,0,0)+sl_("D",de,0,26,0,0,0,0,0)+
				sl_("D",de,0,27,0,0,0,0,0)+sl_("D",de,0,28,0,0,0,0,0)+
				sl_("D",de,0,34,0,0,0,0,0)+sl_("D",de,0,36,0,0,0,0,0)-
				sl_("K",de,0,38,0,0,0,0,0)+sl_("D",de,0,64,0,0,0,0,0)+
				sl_("D",de,0,65,0,0,0,0,0)+sl_("D",de,0,68,0,0,0,0,0)+
				sl_("D",de,0,37,0,0,0,0,0)-(sl_("K",de,0,50,0,0,0,0,0)+
				sl_("K",de,0,51,0,0,0,0,0)+sl_("K",de,0,52,0,0,0,0,0)+
				sl_("K",de,0,53,0,0,0,0,0)+sl_("K",de,0,54,0,0,0,0,0)+//+ или - ?????
				sl_("K",de,0,55,0,0,0,0,0))-(sl_("K",de,0,60,0,0,0,0,0)+
				sl_("K",de,0,61,0,0,0,0,0)+sl_("K",de,0,62,0,0,0,0,0)+
				sl_("K",de,0,63,0,0,0,0,0)+sl_("K",de,0,36,0,0,0,0,0)+
				sl_("K",de,0,68,0,0,0,0,0)+sl_("K",de,0,37,0,0,0,0,0)+
				sl_("K",de,0,64,0,0,0,0,0)+sl_("K",de,0,65,0,0,0,0,0)+
				sl_("K",de,0,66,0,0,0,0,0)+sl_("K",de,0,67,0,0,0,0,0))
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
        //строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90)
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643)
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94)
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72)
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73)
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643)
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97)
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180)?str170-str180:0;
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210)
		m.Fyear	= String(d.getFullYear());
		if (obTotal!=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність чистих активів по роках|Рентабельность чистых активов по годам",
			"Діапазон|Диапазон", "Рентаб.чистих активів|Рентаб.чистых активов",
			"Чистий прибуток|Чистая прибыль",
			"Різниця між усіма активами і звонішн.забов'яз.|Разность между всеми активами и внешн.обяз.");
}

function calcRCAM()//obsch_rencm.js  YANA_2005_10_27 недоделан
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	de = new Date(lastDay(d2));//какую брать конечную дату????
	var m = new Object();
	for(var i=1; d<=d2; i++)
	{
		obTotal = sl_("D",de,0,10,0,0,0,0,0)+sl_("D",de,0,11,0,0,0,0,0)+
				sl_("D",de,0,12,0,0,0,0,0)-sl_("K",de,0,13,0,0,0,0,0)+
				sl_("D",de,0,14,0,0,0,0,0)+sl_("D",de,0,15,0,0,0,0,0)+
				sl_("D",de,0,16,0,0,0,0,0)+sl_("D",de,0,17,0,0,0,0,0)+
				sl_("D",de,0,20,0,0,0,0,0)+sl_("D",de,0,25,0,0,0,0,0)+
				sl_("D",de,0,21,0,0,0,0,0)+sl_("D",de,0,23,0,0,0,0,0)+
				sl_("D",de,0,24,0,0,0,0,0)+sl_("D",de,0,26,0,0,0,0,0)+
				sl_("D",de,0,27,0,0,0,0,0)+sl_("D",de,0,28,0,0,0,0,0)+
				sl_("D",de,0,34,0,0,0,0,0)+sl_("D",de,0,36,0,0,0,0,0)-
				sl_("K",de,0,38,0,0,0,0,0)+sl_("D",de,0,64,0,0,0,0,0)+
				sl_("D",de,0,65,0,0,0,0,0)+sl_("D",de,0,68,0,0,0,0,0)+
				sl_("D",de,0,37,0,0,0,0,0)-(sl_("K",de,0,50,0,0,0,0,0)+
				sl_("K",de,0,51,0,0,0,0,0)+sl_("K",de,0,52,0,0,0,0,0)+
				sl_("K",de,0,53,0,0,0,0,0)+sl_("K",de,0,54,0,0,0,0,0)+//+ или - ????
				sl_("K",de,0,55,0,0,0,0,0))-(sl_("K",de,0,60,0,0,0,0,0)+
				sl_("K",de,0,61,0,0,0,0,0)+sl_("K",de,0,62,0,0,0,0,0)+
				sl_("K",de,0,63,0,0,0,0,0)+sl_("K",de,0,36,0,0,0,0,0)+
				sl_("K",de,0,68,0,0,0,0,0)+sl_("K",de,0,37,0,0,0,0,0)+
				sl_("K",de,0,64,0,0,0,0,0)+sl_("K",de,0,65,0,0,0,0,0)+
				sl_("K",de,0,66,0,0,0,0,0)+sl_("K",de,0,67,0,0,0,0,0))
		//строка 35 формы 2
		str35 = ob_("",d,de,0,0,70)-ob_("",d,de,0,70,64,0,643)
		//строка  40 формы 2
		obTotal1    = ob_("D", d, de ,0,90)
		//строка  50 формы 2
		str50 = (str35>obTotal1)?str35-obTotal1:0;
		//строка  60 формы 2
		str60 = ob_("",d,de,0,0,71)-ob_("",d,de,0,71,64,0,643)
		//строка  70+80+90 формы 2
		obTotalpr  = ob_("D", d, de ,0,92)+ ob_("D", d, de ,0,93)+ ob_("D", d, de ,0,94)
		//строка  100 формы 2
		str100 =(str50+str60>obTotalpr)?str50+str60-obTotalpr:0;
		//строка  110 формы 2
		str110 = ob_("",d,de,0,0,72);
		//строка  120 формы 2
		str120 = ob_("",d,de,0,0,73);
		//строка  130 формы 2
		str130 = ob_("",d,de,0,0,74)-ob_("",d,de,0,74,64,0,643);
		//строка  140+150+160 формы 2
		obTotalpr2 = ob_("D", d, de ,0,95)+ ob_("D", d, de ,0,96)+ ob_("D", d, de ,0,97)
		//строка  170 формы 2
		str170  = (str100+str110+str120+str130>obTotalpr2)?str100+str110+str120+str130-obTotalpr2:0;
		//строка  180 формы 2
		str180  = ob_("",d,de,0,98,0,981)
		//строка  190 формы 2
		str190  = (str170>str180,str170-str180,0)
		//строка  200 формы 2
		str200  = ob_("",d,de,0,0,75)
		//строка  210 формы 2
		str210  = ob_("",d,de,0,98,0,982)
		//строка  220 формы 2
		slTotal =(str190+str200-str210)
		m.Fyear	= tmonth(d, "mt") + ", " + d.getFullYear();
		if ( obTotal !=0)
			m.Fkoef = (slTotal/obTotal)*100;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(goMonth(d, 1));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Рентабельність чистих активів по місяцях|Рентабельность чистых активов по месяцам",
			"Діапазон|Диапазон", "Рентаб.чистих активів|Рентаб.чистых активов",
			"Чистий прибуток|Чистая прибыль",
			"Різниця між усіма активами і звонішн.забов'яз.|Разность между всеми активами и внешн.обяз.");
}

function calcKP()//obsch_zpr.js  CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		obTotal = ob_("K", d, de ,0,0,70);
		prTotal = sl_("K", de, 0, 44) - sl_("D", de, 0, 44);	//прибыль-убыток 
		m.Fyear	= String(d.getFullYear());
		if (obTotal!=0)
			m.Fkoef = (prTotal/obTotal);
		else
			m.Fkoef = 0;
		m.Fpr = prTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т прибутковості|К-т прибыльности",
			"Діапазон|Диапазон", "К-т прибутковості|К-т прибыльности",
			"Прибуток-збиток|Прибыль-убыток", "Сума реалізації|Сумма реализации");
}

function calcKOP()//obsch_pr.js CVS
{
	if(!init())
		return false;
	d = new Date(firstDay(new Date(d1.getFullYear(),0,1)));
	de = new Date(lastDay(new Date(d1.getFullYear(),11,1)));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))) ; i++)
	{
		obTotal = ob_("K", d, de, 0, 0, 70);
		prTotal = sl_("K", de, 0, 44);// прибыль
		m.Fyear	= String(d.getFullYear());
		if ( obTotal !=0)
			m.Fkoef = (prTotal/obTotal);
		else
			m.Fkoef = 0;
		m.Fpr = prTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "К-т загальної прибутковості|К-т общей прибыльности",
			"Діапазон|Диапазон", "К-т загальної прибутковості|К-т общей прибыльности",
			"Прибуток|Прибыль", "Сума реалізації|Сумма реализации");
}

function calcAVPZ()//obsch_zadol.js  YANA_2005_10_27
{
	if(!init())
		return false;
	d = new Date(firstDay(d1));
	var m = new Object();
	for(var i=1; (d<new Date(firstDay(new Date(d2.getFullYear()+1,0,1)))); i++)
	{
		//к-т быстрой ликвидности
		chTotal = sl_("D", new Date(lastDay(d)) ,0,30)+sl_("D", new Date(lastDay(d)) ,0,31)+
				sl_("D", new Date(lastDay(d)) ,0,32)+sl_("D", new Date(lastDay(d)) ,0,33)+
				sl_("D", new Date(lastDay(d)) ,0,34)+sl_("D", new Date(lastDay(d)) ,0,35)+
				sl_("D", new Date(lastDay(d)) ,0,64)+sl_("D", new Date(lastDay(d)) ,0,65)+
				sl_("D", new Date(lastDay(d)) ,0,36)-sl_("K", new Date(lastDay(d)) ,0,38)+
				sl_("D", new Date(lastDay(d)) ,0,68)+sl_("D", new Date(lastDay(d)) ,0,37)
		znTotal = sl_("K", new Date(lastDay(d)) ,0,60)+sl_("K", new Date(lastDay(d)), 0,61)+
				sl_("K", new Date(lastDay(d)), 0,62)+sl_("K", new Date(lastDay(d)) ,0,63)+
				sl_("K", new Date(lastDay(d)), 0,64)+sl_("K", new Date(lastDay(d)) ,0,65)+
				sl_("K", new Date(lastDay(d)), 0,66)+sl_("K", new Date(lastDay(d)) ,0,67)+
				sl_("K", new Date(lastDay(d)), 0,68)+sl_("K", new Date(lastDay(d)), 0,36)+
				sl_("K", new Date(lastDay(d)), 0,37,371)
		if ( znTotal !=0)
			Z1 = (chTotal/znTotal);
		else
			Z1 = 0;
		//к-т финансовой устойчивости
		chTotal2 = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
				sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
				sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)-
				sl_("K", new Date(lastDay(d)),0,46,0)-sl_("K", new Date(lastDay(d)),0,45,0)+
				sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
				sl_("K", new Date(lastDay(d)),0,69,0)+sl_("K", new Date(lastDay(d)),0,50,0)+
				sl_("K", new Date(lastDay(d)),0,51,0)+sl_("K", new Date(lastDay(d)),0,52,0)+
				sl_("K", new Date(lastDay(d)),0,53,0)+sl_("K", new Date(lastDay(d)),0,54,0)+
				sl_("K", new Date(lastDay(d)),0,55,0)
                                                             
		znTotal2 = sl_("K", new Date(lastDay(d)),0,40,0)+sl_("K", new Date(lastDay(d)),0,41,0)+
				sl_("K", new Date(lastDay(d)),0,42,0)+sl_("K", new Date(lastDay(d)),0,43,0)+
				sl_("K", new Date(lastDay(d)),0,44,0)-sl_("D", new Date(lastDay(d)),0,44,0)-
				sl_("K", new Date(lastDay(d)),0,46,0)-sl_("K", new Date(lastDay(d)),0,45,0)+          
				sl_("K", new Date(lastDay(d)),0,47,0)+sl_("K", new Date(lastDay(d)),0,48,0)+
				sl_("K", new Date(lastDay(d)),0,69,0)+sl_("K", new Date(lastDay(d)),0,50,0)+
				sl_("K", new Date(lastDay(d)),0,51,0)+sl_("K", new Date(lastDay(d)),0,52,0)+
				sl_("K", new Date(lastDay(d)),0,54,0)+sl_("K", new Date(lastDay(d)),0,55,0)+
				sl_("K", new Date(lastDay(d)),0,61,0)+sl_("K", new Date(lastDay(d)),0,36,0)+
				sl_("K", new Date(lastDay(d)) ,0,60)+sl_("K", new Date(lastDay(d)), 0,62)+
				sl_("K", new Date(lastDay(d)) ,0,63)+sl_("K", new Date(lastDay(d)), 0,64)+
				sl_("K", new Date(lastDay(d)) ,0,65)+sl_("K", new Date(lastDay(d)), 0,66)+
				sl_("K", new Date(lastDay(d)) ,0,67)+sl_("K", new Date(lastDay(d)), 0,68)+
				sl_("K", new Date(lastDay(d)) ,0,37,371)
		if(znTotal2!=0)
			Z2 = (chTotal2/znTotal2);
		else
			Z2 = 0;
		m.Fyear	= String(d.getFullYear());
		if(Z1!=0 && Z2!=0)
			m.Fkoef = 2.236*Z1+0.009*Z2;
		else
			m.Fkoef = 0;
		m.Fpr = slTotal;
		m.Fob = obTotal;
		d = new Date(firstDay(new Date(d.getFullYear()+1,0,1)));
		UpdateTable("TMP_OPG", m, true);
	}
	showXlsDoc("UCH_OPG", "Аналіз можливості простроч.заборг.|Анализ возможности просроч.задолж.",
			"Діапазон|Диапазон", "Прогноз виникн.простр.заборг.по кредитах|Прогноз возн.просроч.задолж.по кредитам",
			"К-т швидкої лікв.|К-т быстрой ликв.", "К-т фін.стійк.|К-т фин.устойч.");
}
include("sys\\DpBaseDlg.js");